import Api
from Api import Api
from Api import Function, Typedef, Enum
from Api import Return, Parameter, Input, Output, InputOutput
from Api import Enumerant
from Api import Extension
from Api import StateType, State

gl = Api()

GLenum = Typedef('GLenum','unsigned int')
GLenum.default = '0'

GLboolean = Typedef('GLboolean','unsigned char')
GLboolean.default = 'GL_FALSE'

GLbitfield = Typedef('GLbitfield','unsigned int')
GLbitfield.default = '0'

GLbyte = Typedef('GLbyte','signed char')
GLbyte.default = '0'

GLshort = Typedef('GLshort','short')
GLshort.default = '0'

GLint = Typedef('GLint','int')
GLint.default = '0'

GLsizei = Typedef('GLsizei','int')
GLsizei.default = '0'

GLubyte = Typedef('GLubyte','unsigned char')
GLubyte.default = '0'

GLushort = Typedef('GLushort','unsigned short')
GLushort.default = '0'

GLuint = Typedef('GLuint','unsigned int')
GLuint.default = '0'

GLfloat = Typedef('GLfloat','float')
GLfloat.default = '0'

GLclampf = Typedef('GLclampf','float')
GLclampf.default = '0'

GLdouble = Typedef('GLdouble','double')
GLdouble.default = '0'

GLclampd = Typedef('GLclampd','double')
GLclampd.default = '0'

GLvoid = Typedef('GLvoid','void')

GLintptr = Typedef('GLintptr','ptrdiff_t')
GLintptr.category = 'GL_VERSION_1_5'
GLintptr.default = '0'

GLsizeiptr = Typedef('GLsizeiptr','ptrdiff_t')
GLsizeiptr.category = 'GL_VERSION_1_5'
GLsizeiptr.default = '0'

GLchar = Typedef('GLchar','char')
GLchar.category = 'GL_VERSION_2_0'
GLchar.default = '0'

GLint64 = Typedef('GLint64','int64_t')
GLint64.category = 'GL_ARB_sync'
GLint64.default = '0'

GLuint64 = Typedef('GLuint64','uint64_t')
GLuint64.category = 'GL_ARB_sync'
GLuint64.default = '0'

GLsync = Typedef('GLsync','struct __GLsync *')
GLsync.category = 'GL_ARB_sync'
GLsync.default = 'NULL'

cl_context = Typedef('cl_context','struct _cl_context *')
cl_context.category = 'GL_ARB_cl_event'
cl_context.default = 'NULL'

cl_event = Typedef('cl_event','struct _cl_event *')
cl_event.category = 'GL_ARB_cl_event'
cl_event.default = 'NULL'

GLintptrARB = Typedef('GLintptrARB','ptrdiff_t')
GLintptrARB.category = 'GL_ARB_vertex_buffer_object'
GLintptrARB.default = 'NULL'

GLsizeiptrARB = Typedef('GLsizeiptrARB','ptrdiff_t')
GLsizeiptrARB.category = 'GL_ARB_vertex_buffer_object'
GLsizeiptrARB.default = 'NULL'

GLcharARB = Typedef('GLcharARB','char')
GLcharARB.category = 'GL_ARB_shader_objects'
GLcharARB.default = '0'

GLhandleARB = Typedef('GLhandleARB',{'': 'unsigned int', 'osx': 'unsigned long', 'ios': 'unsigned long'})
GLhandleARB.category = 'GL_ARB_shader_objects'
GLhandleARB.default = '0'

GLhalfARB = Typedef('GLhalfARB','unsigned short')
GLhalfARB.category = 'GL_ARB_half_float_pixel'
GLhalfARB.default = '0'

GLhalfNV = Typedef('GLhalfNV','unsigned short')
GLhalfNV.category = 'GL_NV_half_float'
GLhalfNV.default = '0'

int32_t = Typedef('int32_t','long int')
int32_t.regal = False

int64_t = Typedef('int64_t','long long int')
int64_t.regal = False

uint64_t = Typedef('uint64_t','unsigned long long int')
uint64_t.regal = False

GLint64EXT = Typedef('GLint64EXT','int64_t')
GLint64EXT.category = 'GL_EXT_timer_query'
GLint64EXT.default = '0'

GLuint64EXT = Typedef('GLuint64EXT','uint64_t')
GLuint64EXT.category = 'GL_EXT_timer_query'
GLuint64EXT.default = '0'

GLvdpauSurfaceNV = Typedef('GLvdpauSurfaceNV','GLintptr')
GLvdpauSurfaceNV.category = 'GL_NV_vdpau_interop'
GLvdpauSurfaceNV.default = '0'

GLfixed = Typedef('GLfixed','int')
GLfixed.category = 'GL_VERSION_4_1'
GLfixed.default = '0'

GLclampx = Typedef('GLclampx','int')
GLclampx.default = '0'

eglImageOES = Typedef('eglImageOES','void *')
eglImageOES.category = 'GL_OES_EGL_image_external'
eglImageOES.default = 'NULL'

gl.add(GLenum)
gl.add(GLboolean)
gl.add(GLbitfield)
gl.add(GLbyte)
gl.add(GLshort)
gl.add(GLint)
gl.add(GLsizei)
gl.add(GLubyte)
gl.add(GLushort)
gl.add(GLuint)
gl.add(GLfloat)
gl.add(GLclampf)
gl.add(GLdouble)
gl.add(GLclampd)
gl.add(GLvoid)
gl.add(GLintptr)
gl.add(GLsizeiptr)
gl.add(GLchar)
gl.add(GLint64)
gl.add(GLuint64)
gl.add(GLsync)
gl.add(cl_context)
gl.add(cl_event)
gl.add(GLintptrARB)
gl.add(GLsizeiptrARB)
gl.add(GLcharARB)
gl.add(GLhandleARB)
gl.add(GLhalfARB)
gl.add(GLhalfNV)
gl.add(int32_t)
gl.add(int64_t)
gl.add(uint64_t)
gl.add(GLint64EXT)
gl.add(GLuint64EXT)
gl.add(GLvdpauSurfaceNV)
gl.add(GLfixed)
gl.add(GLclampx)
gl.add(eglImageOES)


defines = Enum('defines')
gl.add(defines)

# GL_VERSION_1_1

GL_2D = Enumerant('GL_2D', 0x0600, 'GL_VERSION_1_1')
GL_2_BYTES = Enumerant('GL_2_BYTES', 0x1407, 'GL_VERSION_1_1')
GL_3D = Enumerant('GL_3D', 0x0601, 'GL_VERSION_1_1')
GL_3D_COLOR = Enumerant('GL_3D_COLOR', 0x0602, 'GL_VERSION_1_1')
GL_3D_COLOR_TEXTURE = Enumerant('GL_3D_COLOR_TEXTURE', 0x0603, 'GL_VERSION_1_1')
GL_3_BYTES = Enumerant('GL_3_BYTES', 0x1408, 'GL_VERSION_1_1')
GL_4D_COLOR_TEXTURE = Enumerant('GL_4D_COLOR_TEXTURE', 0x0604, 'GL_VERSION_1_1')
GL_4_BYTES = Enumerant('GL_4_BYTES', 0x1409, 'GL_VERSION_1_1')
GL_ACCUM = Enumerant('GL_ACCUM', 0x0100, 'GL_VERSION_1_1')
GL_ACCUM_ALPHA_BITS = Enumerant('GL_ACCUM_ALPHA_BITS', 0x0d5b, 'GL_VERSION_1_1')
GL_ACCUM_BLUE_BITS = Enumerant('GL_ACCUM_BLUE_BITS', 0x0d5a, 'GL_VERSION_1_1')
GL_ACCUM_BUFFER_BIT = Enumerant('GL_ACCUM_BUFFER_BIT', 0x0200, 'GL_VERSION_1_1')
GL_ACCUM_CLEAR_VALUE = Enumerant('GL_ACCUM_CLEAR_VALUE', 0x0b80, 'GL_VERSION_1_1')
GL_ACCUM_GREEN_BITS = Enumerant('GL_ACCUM_GREEN_BITS', 0x0d59, 'GL_VERSION_1_1')
GL_ACCUM_RED_BITS = Enumerant('GL_ACCUM_RED_BITS', 0x0d58, 'GL_VERSION_1_1')
GL_ADD = Enumerant('GL_ADD', 0x0104, 'GL_VERSION_1_1')
GL_ALL_ATTRIB_BITS = Enumerant('GL_ALL_ATTRIB_BITS', 0xfffff, 'GL_VERSION_1_1')
GL_ALPHA = Enumerant('GL_ALPHA', 0x1906, 'GL_VERSION_1_1')
GL_ALPHA.esVersions = [2.0]
GL_ALPHA.internalformat = True
GL_ALPHA12 = Enumerant('GL_ALPHA12', 0x803d, 'GL_VERSION_1_1')
GL_ALPHA16 = Enumerant('GL_ALPHA16', 0x803e, 'GL_VERSION_1_1')
GL_ALPHA4 = Enumerant('GL_ALPHA4', 0x803b, 'GL_VERSION_1_1')
GL_ALPHA8 = Enumerant('GL_ALPHA8', 0x803c, 'GL_VERSION_1_1')
GL_ALPHA_BIAS = Enumerant('GL_ALPHA_BIAS', 0x0d1d, 'GL_VERSION_1_1')
GL_ALPHA_BITS = Enumerant('GL_ALPHA_BITS', 0x0d55, 'GL_VERSION_1_1')
GL_ALPHA_BITS.esVersions = [2.0]
GL_ALPHA_SCALE = Enumerant('GL_ALPHA_SCALE', 0x0d1c, 'GL_VERSION_1_1')
GL_ALPHA_TEST = Enumerant('GL_ALPHA_TEST', 0x0bc0, 'GL_VERSION_1_1')
GL_ALPHA_TEST_FUNC = Enumerant('GL_ALPHA_TEST_FUNC', 0x0bc1, 'GL_VERSION_1_1')
GL_ALPHA_TEST_REF = Enumerant('GL_ALPHA_TEST_REF', 0x0bc2, 'GL_VERSION_1_1')
GL_ALWAYS = Enumerant('GL_ALWAYS', 0x0207, 'GL_VERSION_1_1')
GL_ALWAYS.esVersions = [2.0]
GL_AMBIENT = Enumerant('GL_AMBIENT', 0x1200, 'GL_VERSION_1_1')
GL_AMBIENT_AND_DIFFUSE = Enumerant('GL_AMBIENT_AND_DIFFUSE', 0x1602, 'GL_VERSION_1_1')
GL_AND = Enumerant('GL_AND', 0x1501, 'GL_VERSION_1_1')
GL_AND_INVERTED = Enumerant('GL_AND_INVERTED', 0x1504, 'GL_VERSION_1_1')
GL_AND_REVERSE = Enumerant('GL_AND_REVERSE', 0x1502, 'GL_VERSION_1_1')
GL_ATTRIB_STACK_DEPTH = Enumerant('GL_ATTRIB_STACK_DEPTH', 0x0bb0, 'GL_VERSION_1_1')
GL_AUTO_NORMAL = Enumerant('GL_AUTO_NORMAL', 0x0d80, 'GL_VERSION_1_1')
GL_AUX0 = Enumerant('GL_AUX0', 0x0409, 'GL_VERSION_1_1')
GL_AUX1 = Enumerant('GL_AUX1', 0x040a, 'GL_VERSION_1_1')
GL_AUX2 = Enumerant('GL_AUX2', 0x040b, 'GL_VERSION_1_1')
GL_AUX3 = Enumerant('GL_AUX3', 0x040c, 'GL_VERSION_1_1')
GL_AUX_BUFFERS = Enumerant('GL_AUX_BUFFERS', 0x0c00, 'GL_VERSION_1_1')
GL_BACK = Enumerant('GL_BACK', 0x0405, 'GL_VERSION_1_1')
GL_BACK.esVersions = [2.0]
GL_BACK_LEFT = Enumerant('GL_BACK_LEFT', 0x0402, 'GL_VERSION_1_1')
GL_BACK_RIGHT = Enumerant('GL_BACK_RIGHT', 0x0403, 'GL_VERSION_1_1')
GL_BITMAP = Enumerant('GL_BITMAP', 0x1a00, 'GL_VERSION_1_1')
GL_BITMAP_TOKEN = Enumerant('GL_BITMAP_TOKEN', 0x0704, 'GL_VERSION_1_1')
GL_BLEND = Enumerant('GL_BLEND', 0x0be2, 'GL_VERSION_1_1')
GL_BLEND.esVersions = [2.0]
GL_BLEND.enableCap = True
GL_BLEND_DST = Enumerant('GL_BLEND_DST', 0x0be0, 'GL_VERSION_1_1')
GL_BLEND_SRC = Enumerant('GL_BLEND_SRC', 0x0be1, 'GL_VERSION_1_1')
GL_BLUE = Enumerant('GL_BLUE', 0x1905, 'GL_VERSION_1_1')
GL_BLUE_BIAS = Enumerant('GL_BLUE_BIAS', 0x0d1b, 'GL_VERSION_1_1')
GL_BLUE_BITS = Enumerant('GL_BLUE_BITS', 0x0d54, 'GL_VERSION_1_1')
GL_BLUE_BITS.esVersions = [2.0]
GL_BLUE_SCALE = Enumerant('GL_BLUE_SCALE', 0x0d1a, 'GL_VERSION_1_1')
GL_BYTE = Enumerant('GL_BYTE', 0x1400, 'GL_VERSION_1_1')
GL_BYTE.group = ['pathCoord']
GL_BYTE.esVersions = [2.0]
GL_C3F_V3F = Enumerant('GL_C3F_V3F', 0x2a24, 'GL_VERSION_1_1')
GL_C4F_N3F_V3F = Enumerant('GL_C4F_N3F_V3F', 0x2a26, 'GL_VERSION_1_1')
GL_C4UB_V2F = Enumerant('GL_C4UB_V2F', 0x2a22, 'GL_VERSION_1_1')
GL_C4UB_V3F = Enumerant('GL_C4UB_V3F', 0x2a23, 'GL_VERSION_1_1')
GL_CCW = Enumerant('GL_CCW', 0x0901, 'GL_VERSION_1_1')
GL_CCW.esVersions = [2.0]
GL_CLAMP = Enumerant('GL_CLAMP', 0x2900, 'GL_VERSION_1_1')
GL_CLEAR = Enumerant('GL_CLEAR', 0x1500, 'GL_VERSION_1_1')
GL_CLIENT_ALL_ATTRIB_BITS = Enumerant('GL_CLIENT_ALL_ATTRIB_BITS', 0xffffffff, 'GL_VERSION_1_1')
GL_CLIENT_ATTRIB_STACK_DEPTH = Enumerant('GL_CLIENT_ATTRIB_STACK_DEPTH', 0x0bb1, 'GL_VERSION_1_1')
GL_CLIENT_PIXEL_STORE_BIT = Enumerant('GL_CLIENT_PIXEL_STORE_BIT', 0x0001, 'GL_VERSION_1_1')
GL_CLIENT_VERTEX_ARRAY_BIT = Enumerant('GL_CLIENT_VERTEX_ARRAY_BIT', 0x0002, 'GL_VERSION_1_1')
GL_CLIP_PLANE0 = Enumerant('GL_CLIP_PLANE0', 0x3000, 'GL_VERSION_1_1')
GL_CLIP_PLANE1 = Enumerant('GL_CLIP_PLANE1', 0x3001, 'GL_VERSION_1_1')
GL_CLIP_PLANE2 = Enumerant('GL_CLIP_PLANE2', 0x3002, 'GL_VERSION_1_1')
GL_CLIP_PLANE3 = Enumerant('GL_CLIP_PLANE3', 0x3003, 'GL_VERSION_1_1')
GL_CLIP_PLANE4 = Enumerant('GL_CLIP_PLANE4', 0x3004, 'GL_VERSION_1_1')
GL_CLIP_PLANE5 = Enumerant('GL_CLIP_PLANE5', 0x3005, 'GL_VERSION_1_1')
GL_CLIP_PLANE6 = Enumerant('GL_CLIP_PLANE6', 0x3006, 'GL_VERSION_1_1')
GL_CLIP_PLANE7 = Enumerant('GL_CLIP_PLANE7', 0x3007, 'GL_VERSION_1_1')
GL_COEFF = Enumerant('GL_COEFF', 0x0a00, 'GL_VERSION_1_1')
GL_COLOR = Enumerant('GL_COLOR', 0x1800, 'GL_VERSION_1_1')
GL_COLOR_ARRAY = Enumerant('GL_COLOR_ARRAY', 0x8076, 'GL_VERSION_1_1')
GL_COLOR_ARRAY_POINTER = Enumerant('GL_COLOR_ARRAY_POINTER', 0x8090, 'GL_VERSION_1_1')
GL_COLOR_ARRAY_SIZE = Enumerant('GL_COLOR_ARRAY_SIZE', 0x8081, 'GL_VERSION_1_1')
GL_COLOR_ARRAY_STRIDE = Enumerant('GL_COLOR_ARRAY_STRIDE', 0x8083, 'GL_VERSION_1_1')
GL_COLOR_ARRAY_TYPE = Enumerant('GL_COLOR_ARRAY_TYPE', 0x8082, 'GL_VERSION_1_1')
GL_COLOR_BUFFER_BIT = Enumerant('GL_COLOR_BUFFER_BIT', 0x4000, 'GL_VERSION_1_1')
GL_COLOR_BUFFER_BIT.esVersions = [2.0]
GL_COLOR_CLEAR_VALUE = Enumerant('GL_COLOR_CLEAR_VALUE', 0x0c22, 'GL_VERSION_1_1')
GL_COLOR_CLEAR_VALUE.esVersions = [2.0]
GL_COLOR_INDEX = Enumerant('GL_COLOR_INDEX', 0x1900, 'GL_VERSION_1_1')
GL_COLOR_INDEXES = Enumerant('GL_COLOR_INDEXES', 0x1603, 'GL_VERSION_1_1')
GL_COLOR_LOGIC_OP = Enumerant('GL_COLOR_LOGIC_OP', 0x0bf2, 'GL_VERSION_1_1')
GL_COLOR_LOGIC_OP.enableCap = True
GL_COLOR_MATERIAL = Enumerant('GL_COLOR_MATERIAL', 0x0b57, 'GL_VERSION_1_1')
GL_COLOR_MATERIAL_FACE = Enumerant('GL_COLOR_MATERIAL_FACE', 0x0b55, 'GL_VERSION_1_1')
GL_COLOR_MATERIAL_PARAMETER = Enumerant('GL_COLOR_MATERIAL_PARAMETER', 0x0b56, 'GL_VERSION_1_1')
GL_COLOR_WRITEMASK = Enumerant('GL_COLOR_WRITEMASK', 0x0c23, 'GL_VERSION_1_1')
GL_COLOR_WRITEMASK.esVersions = [2.0]
GL_COMPILE = Enumerant('GL_COMPILE', 0x1300, 'GL_VERSION_1_1')
GL_COMPILE_AND_EXECUTE = Enumerant('GL_COMPILE_AND_EXECUTE', 0x1301, 'GL_VERSION_1_1')
GL_CONSTANT_ATTENUATION = Enumerant('GL_CONSTANT_ATTENUATION', 0x1207, 'GL_VERSION_1_1')
GL_COPY = Enumerant('GL_COPY', 0x1503, 'GL_VERSION_1_1')
GL_COPY_INVERTED = Enumerant('GL_COPY_INVERTED', 0x150c, 'GL_VERSION_1_1')
GL_COPY_PIXEL_TOKEN = Enumerant('GL_COPY_PIXEL_TOKEN', 0x0706, 'GL_VERSION_1_1')
GL_CULL_FACE = Enumerant('GL_CULL_FACE', 0x0b44, 'GL_VERSION_1_1')
GL_CULL_FACE.esVersions = [2.0]
GL_CULL_FACE.enableCap = True
GL_CULL_FACE_MODE = Enumerant('GL_CULL_FACE_MODE', 0x0b45, 'GL_VERSION_1_1')
GL_CULL_FACE_MODE.esVersions = [2.0]
GL_CURRENT_BIT = Enumerant('GL_CURRENT_BIT', 0x0001, 'GL_VERSION_1_1')
GL_CURRENT_COLOR = Enumerant('GL_CURRENT_COLOR', 0x0b00, 'GL_VERSION_1_1')
GL_CURRENT_INDEX = Enumerant('GL_CURRENT_INDEX', 0x0b01, 'GL_VERSION_1_1')
GL_CURRENT_NORMAL = Enumerant('GL_CURRENT_NORMAL', 0x0b02, 'GL_VERSION_1_1')
GL_CURRENT_RASTER_COLOR = Enumerant('GL_CURRENT_RASTER_COLOR', 0x0b04, 'GL_VERSION_1_1')
GL_CURRENT_RASTER_DISTANCE = Enumerant('GL_CURRENT_RASTER_DISTANCE', 0x0b09, 'GL_VERSION_1_1')
GL_CURRENT_RASTER_INDEX = Enumerant('GL_CURRENT_RASTER_INDEX', 0x0b05, 'GL_VERSION_1_1')
GL_CURRENT_RASTER_POSITION = Enumerant('GL_CURRENT_RASTER_POSITION', 0x0b07, 'GL_VERSION_1_1')
GL_CURRENT_RASTER_POSITION_VALID = Enumerant('GL_CURRENT_RASTER_POSITION_VALID', 0x0b08, 'GL_VERSION_1_1')
GL_CURRENT_RASTER_TEXTURE_COORDS = Enumerant('GL_CURRENT_RASTER_TEXTURE_COORDS', 0x0b06, 'GL_VERSION_1_1')
GL_CURRENT_TEXTURE_COORDS = Enumerant('GL_CURRENT_TEXTURE_COORDS', 0x0b03, 'GL_VERSION_1_1')
GL_CW = Enumerant('GL_CW', 0x0900, 'GL_VERSION_1_1')
GL_CW.esVersions = [2.0]
GL_DECAL = Enumerant('GL_DECAL', 0x2101, 'GL_VERSION_1_1')
GL_DECR = Enumerant('GL_DECR', 0x1e03, 'GL_VERSION_1_1')
GL_DECR.esVersions = [2.0]
GL_DEPTH = Enumerant('GL_DEPTH', 0x1801, 'GL_VERSION_1_1')
GL_DEPTH_BIAS = Enumerant('GL_DEPTH_BIAS', 0x0d1f, 'GL_VERSION_1_1')
GL_DEPTH_BITS = Enumerant('GL_DEPTH_BITS', 0x0d56, 'GL_VERSION_1_1')
GL_DEPTH_BITS.esVersions = [2.0]
GL_DEPTH_BUFFER_BIT = Enumerant('GL_DEPTH_BUFFER_BIT', 0x0100, 'GL_VERSION_1_1')
GL_DEPTH_BUFFER_BIT.esVersions = [2.0]
GL_DEPTH_CLEAR_VALUE = Enumerant('GL_DEPTH_CLEAR_VALUE', 0x0b73, 'GL_VERSION_1_1')
GL_DEPTH_CLEAR_VALUE.esVersions = [2.0]
GL_DEPTH_COMPONENT = Enumerant('GL_DEPTH_COMPONENT', 0x1902, 'GL_VERSION_1_1')
GL_DEPTH_COMPONENT.esVersions = [2.0]
GL_DEPTH_FUNC = Enumerant('GL_DEPTH_FUNC', 0x0b74, 'GL_VERSION_1_1')
GL_DEPTH_FUNC.esVersions = [2.0]
GL_DEPTH_RANGE = Enumerant('GL_DEPTH_RANGE', 0x0b70, 'GL_VERSION_1_1')
GL_DEPTH_RANGE.esVersions = [2.0]
GL_DEPTH_SCALE = Enumerant('GL_DEPTH_SCALE', 0x0d1e, 'GL_VERSION_1_1')
GL_DEPTH_TEST = Enumerant('GL_DEPTH_TEST', 0x0b71, 'GL_VERSION_1_1')
GL_DEPTH_TEST.esVersions = [2.0]
GL_DEPTH_TEST.enableCap = True
GL_DEPTH_WRITEMASK = Enumerant('GL_DEPTH_WRITEMASK', 0x0b72, 'GL_VERSION_1_1')
GL_DEPTH_WRITEMASK.esVersions = [2.0]
GL_DIFFUSE = Enumerant('GL_DIFFUSE', 0x1201, 'GL_VERSION_1_1')
GL_DITHER = Enumerant('GL_DITHER', 0x0bd0, 'GL_VERSION_1_1')
GL_DITHER.esVersions = [2.0]
GL_DITHER.enableCap = True
GL_DOMAIN = Enumerant('GL_DOMAIN', 0x0a02, 'GL_VERSION_1_1')
GL_DONT_CARE = Enumerant('GL_DONT_CARE', 0x1100, 'GL_VERSION_1_1')
GL_DONT_CARE.esVersions = [2.0]
GL_DOUBLE = Enumerant('GL_DOUBLE', 0x140a, 'GL_VERSION_1_1')
GL_DOUBLEBUFFER = Enumerant('GL_DOUBLEBUFFER', 0x0c32, 'GL_VERSION_1_1')
GL_DRAW_BUFFER = Enumerant('GL_DRAW_BUFFER', 0x0c01, 'GL_VERSION_1_1')
GL_DRAW_PIXEL_TOKEN = Enumerant('GL_DRAW_PIXEL_TOKEN', 0x0705, 'GL_VERSION_1_1')
GL_DST_ALPHA = Enumerant('GL_DST_ALPHA', 0x0304, 'GL_VERSION_1_1')
GL_DST_ALPHA.esVersions = [2.0]
GL_DST_COLOR = Enumerant('GL_DST_COLOR', 0x0306, 'GL_VERSION_1_1')
GL_DST_COLOR.esVersions = [2.0]
GL_EDGE_FLAG = Enumerant('GL_EDGE_FLAG', 0x0b43, 'GL_VERSION_1_1')
GL_EDGE_FLAG_ARRAY = Enumerant('GL_EDGE_FLAG_ARRAY', 0x8079, 'GL_VERSION_1_1')
GL_EDGE_FLAG_ARRAY_POINTER = Enumerant('GL_EDGE_FLAG_ARRAY_POINTER', 0x8093, 'GL_VERSION_1_1')
GL_EDGE_FLAG_ARRAY_STRIDE = Enumerant('GL_EDGE_FLAG_ARRAY_STRIDE', 0x808c, 'GL_VERSION_1_1')
GL_EMISSION = Enumerant('GL_EMISSION', 0x1600, 'GL_VERSION_1_1')
GL_ENABLE_BIT = Enumerant('GL_ENABLE_BIT', 0x2000, 'GL_VERSION_1_1')
GL_EQUAL = Enumerant('GL_EQUAL', 0x0202, 'GL_VERSION_1_1')
GL_EQUAL.esVersions = [2.0]
GL_EQUIV = Enumerant('GL_EQUIV', 0x1509, 'GL_VERSION_1_1')
GL_EVAL_BIT = Enumerant('GL_EVAL_BIT', 0x10000, 'GL_VERSION_1_1')
GL_EXP = Enumerant('GL_EXP', 0x0800, 'GL_VERSION_1_1')
GL_EXP2 = Enumerant('GL_EXP2', 0x0801, 'GL_VERSION_1_1')
GL_EXTENSIONS = Enumerant('GL_EXTENSIONS', 0x1f03, 'GL_VERSION_1_1')
GL_EXTENSIONS.esVersions = [2.0]
GL_EYE_LINEAR = Enumerant('GL_EYE_LINEAR', 0x2400, 'GL_VERSION_1_1')
GL_EYE_PLANE = Enumerant('GL_EYE_PLANE', 0x2502, 'GL_VERSION_1_1')
GL_FALSE = Enumerant('GL_FALSE', 0x0000, 'GL_VERSION_1_1')
GL_FALSE.esVersions = [2.0]
GL_FASTEST = Enumerant('GL_FASTEST', 0x1101, 'GL_VERSION_1_1')
GL_FASTEST.esVersions = [2.0]
GL_FEEDBACK = Enumerant('GL_FEEDBACK', 0x1c01, 'GL_VERSION_1_1')
GL_FEEDBACK_BUFFER_POINTER = Enumerant('GL_FEEDBACK_BUFFER_POINTER', 0x0df0, 'GL_VERSION_1_1')
GL_FEEDBACK_BUFFER_SIZE = Enumerant('GL_FEEDBACK_BUFFER_SIZE', 0x0df1, 'GL_VERSION_1_1')
GL_FEEDBACK_BUFFER_TYPE = Enumerant('GL_FEEDBACK_BUFFER_TYPE', 0x0df2, 'GL_VERSION_1_1')
GL_FILL = Enumerant('GL_FILL', 0x1b02, 'GL_VERSION_1_1')
GL_FLAT = Enumerant('GL_FLAT', 0x1d00, 'GL_VERSION_1_1')
GL_FLOAT = Enumerant('GL_FLOAT', 0x1406, 'GL_VERSION_1_1')
GL_FLOAT.group = ['pathCoord']
GL_FLOAT.esVersions = [2.0]
GL_FOG = Enumerant('GL_FOG', 0x0b60, 'GL_VERSION_1_1')
GL_FOG_BIT = Enumerant('GL_FOG_BIT', 0x0080, 'GL_VERSION_1_1')
GL_FOG_COLOR = Enumerant('GL_FOG_COLOR', 0x0b66, 'GL_VERSION_1_1')
GL_FOG_DENSITY = Enumerant('GL_FOG_DENSITY', 0x0b62, 'GL_VERSION_1_1')
GL_FOG_END = Enumerant('GL_FOG_END', 0x0b64, 'GL_VERSION_1_1')
GL_FOG_HINT = Enumerant('GL_FOG_HINT', 0x0c54, 'GL_VERSION_1_1')
GL_FOG_INDEX = Enumerant('GL_FOG_INDEX', 0x0b61, 'GL_VERSION_1_1')
GL_FOG_MODE = Enumerant('GL_FOG_MODE', 0x0b65, 'GL_VERSION_1_1')
GL_FOG_START = Enumerant('GL_FOG_START', 0x0b63, 'GL_VERSION_1_1')
GL_FRONT = Enumerant('GL_FRONT', 0x0404, 'GL_VERSION_1_1')
GL_FRONT.esVersions = [2.0]
GL_FRONT_AND_BACK = Enumerant('GL_FRONT_AND_BACK', 0x0408, 'GL_VERSION_1_1')
GL_FRONT_AND_BACK.esVersions = [2.0]
GL_FRONT_FACE = Enumerant('GL_FRONT_FACE', 0x0b46, 'GL_VERSION_1_1')
GL_FRONT_FACE.esVersions = [2.0]
GL_FRONT_LEFT = Enumerant('GL_FRONT_LEFT', 0x0400, 'GL_VERSION_1_1')
GL_FRONT_RIGHT = Enumerant('GL_FRONT_RIGHT', 0x0401, 'GL_VERSION_1_1')
GL_GEQUAL = Enumerant('GL_GEQUAL', 0x0206, 'GL_VERSION_1_1')
GL_GEQUAL.esVersions = [2.0]
GL_GREATER = Enumerant('GL_GREATER', 0x0204, 'GL_VERSION_1_1')
GL_GREATER.esVersions = [2.0]
GL_GREEN = Enumerant('GL_GREEN', 0x1904, 'GL_VERSION_1_1')
GL_GREEN_BIAS = Enumerant('GL_GREEN_BIAS', 0x0d19, 'GL_VERSION_1_1')
GL_GREEN_BITS = Enumerant('GL_GREEN_BITS', 0x0d53, 'GL_VERSION_1_1')
GL_GREEN_BITS.esVersions = [2.0]
GL_GREEN_SCALE = Enumerant('GL_GREEN_SCALE', 0x0d18, 'GL_VERSION_1_1')
GL_HINT_BIT = Enumerant('GL_HINT_BIT', 0x8000, 'GL_VERSION_1_1')
GL_INCR = Enumerant('GL_INCR', 0x1e02, 'GL_VERSION_1_1')
GL_INCR.esVersions = [2.0]
GL_INDEX_ARRAY = Enumerant('GL_INDEX_ARRAY', 0x8077, 'GL_VERSION_1_1')
GL_INDEX_ARRAY_POINTER = Enumerant('GL_INDEX_ARRAY_POINTER', 0x8091, 'GL_VERSION_1_1')
GL_INDEX_ARRAY_STRIDE = Enumerant('GL_INDEX_ARRAY_STRIDE', 0x8086, 'GL_VERSION_1_1')
GL_INDEX_ARRAY_TYPE = Enumerant('GL_INDEX_ARRAY_TYPE', 0x8085, 'GL_VERSION_1_1')
GL_INDEX_BITS = Enumerant('GL_INDEX_BITS', 0x0d51, 'GL_VERSION_1_1')
GL_INDEX_CLEAR_VALUE = Enumerant('GL_INDEX_CLEAR_VALUE', 0x0c20, 'GL_VERSION_1_1')
GL_INDEX_LOGIC_OP = Enumerant('GL_INDEX_LOGIC_OP', 0x0bf1, 'GL_VERSION_1_1')
GL_INDEX_MODE = Enumerant('GL_INDEX_MODE', 0x0c30, 'GL_VERSION_1_1')
GL_INDEX_OFFSET = Enumerant('GL_INDEX_OFFSET', 0x0d13, 'GL_VERSION_1_1')
GL_INDEX_SHIFT = Enumerant('GL_INDEX_SHIFT', 0x0d12, 'GL_VERSION_1_1')
GL_INDEX_WRITEMASK = Enumerant('GL_INDEX_WRITEMASK', 0x0c21, 'GL_VERSION_1_1')
GL_INT = Enumerant('GL_INT', 0x1404, 'GL_VERSION_1_1')
GL_INT.esVersions = [2.0]
GL_INTENSITY = Enumerant('GL_INTENSITY', 0x8049, 'GL_VERSION_1_1')
GL_INTENSITY12 = Enumerant('GL_INTENSITY12', 0x804c, 'GL_VERSION_1_1')
GL_INTENSITY16 = Enumerant('GL_INTENSITY16', 0x804d, 'GL_VERSION_1_1')
GL_INTENSITY4 = Enumerant('GL_INTENSITY4', 0x804a, 'GL_VERSION_1_1')
GL_INTENSITY8 = Enumerant('GL_INTENSITY8', 0x804b, 'GL_VERSION_1_1')
GL_INVALID_ENUM = Enumerant('GL_INVALID_ENUM', 0x0500, 'GL_VERSION_1_1')
GL_INVALID_ENUM.esVersions = [2.0]
GL_INVALID_ENUM.gluErrorString = 'invalid enumerant'
GL_INVALID_OPERATION = Enumerant('GL_INVALID_OPERATION', 0x0502, 'GL_VERSION_1_1')
GL_INVALID_OPERATION.esVersions = [2.0]
GL_INVALID_OPERATION.gluErrorString = 'invalid operation'
GL_INVALID_VALUE = Enumerant('GL_INVALID_VALUE', 0x0501, 'GL_VERSION_1_1')
GL_INVALID_VALUE.esVersions = [2.0]
GL_INVALID_VALUE.gluErrorString = 'invalid value'
GL_INVERT = Enumerant('GL_INVERT', 0x150a, 'GL_VERSION_1_1')
GL_INVERT.esVersions = [2.0]
GL_KEEP = Enumerant('GL_KEEP', 0x1e00, 'GL_VERSION_1_1')
GL_KEEP.esVersions = [2.0]
GL_LEFT = Enumerant('GL_LEFT', 0x0406, 'GL_VERSION_1_1')
GL_LEQUAL = Enumerant('GL_LEQUAL', 0x0203, 'GL_VERSION_1_1')
GL_LEQUAL.esVersions = [2.0]
GL_LESS = Enumerant('GL_LESS', 0x0201, 'GL_VERSION_1_1')
GL_LESS.esVersions = [2.0]
GL_LIGHT0 = Enumerant('GL_LIGHT0', 0x4000, 'GL_VERSION_1_1')
GL_LIGHT1 = Enumerant('GL_LIGHT1', 0x4001, 'GL_VERSION_1_1')
GL_LIGHT2 = Enumerant('GL_LIGHT2', 0x4002, 'GL_VERSION_1_1')
GL_LIGHT3 = Enumerant('GL_LIGHT3', 0x4003, 'GL_VERSION_1_1')
GL_LIGHT4 = Enumerant('GL_LIGHT4', 0x4004, 'GL_VERSION_1_1')
GL_LIGHT5 = Enumerant('GL_LIGHT5', 0x4005, 'GL_VERSION_1_1')
GL_LIGHT6 = Enumerant('GL_LIGHT6', 0x4006, 'GL_VERSION_1_1')
GL_LIGHT7 = Enumerant('GL_LIGHT7', 0x4007, 'GL_VERSION_1_1')
GL_LIGHTING = Enumerant('GL_LIGHTING', 0x0b50, 'GL_VERSION_1_1')
GL_LIGHTING_BIT = Enumerant('GL_LIGHTING_BIT', 0x0040, 'GL_VERSION_1_1')
GL_LIGHT_MODEL_AMBIENT = Enumerant('GL_LIGHT_MODEL_AMBIENT', 0x0b53, 'GL_VERSION_1_1')
GL_LIGHT_MODEL_LOCAL_VIEWER = Enumerant('GL_LIGHT_MODEL_LOCAL_VIEWER', 0x0b51, 'GL_VERSION_1_1')
GL_LIGHT_MODEL_TWO_SIDE = Enumerant('GL_LIGHT_MODEL_TWO_SIDE', 0x0b52, 'GL_VERSION_1_1')
GL_LINE = Enumerant('GL_LINE', 0x1b01, 'GL_VERSION_1_1')
GL_LINEAR = Enumerant('GL_LINEAR', 0x2601, 'GL_VERSION_1_1')
GL_LINEAR.esVersions = [2.0]
GL_LINEAR_ATTENUATION = Enumerant('GL_LINEAR_ATTENUATION', 0x1208, 'GL_VERSION_1_1')
GL_LINEAR_MIPMAP_LINEAR = Enumerant('GL_LINEAR_MIPMAP_LINEAR', 0x2703, 'GL_VERSION_1_1')
GL_LINEAR_MIPMAP_LINEAR.esVersions = [2.0]
GL_LINEAR_MIPMAP_NEAREST = Enumerant('GL_LINEAR_MIPMAP_NEAREST', 0x2701, 'GL_VERSION_1_1')
GL_LINEAR_MIPMAP_NEAREST.esVersions = [2.0]
GL_LINES = Enumerant('GL_LINES', 0x0001, 'GL_VERSION_1_1')
GL_LINES.esVersions = [2.0]
GL_LINE_BIT = Enumerant('GL_LINE_BIT', 0x0004, 'GL_VERSION_1_1')
GL_LINE_LOOP = Enumerant('GL_LINE_LOOP', 0x0002, 'GL_VERSION_1_1')
GL_LINE_LOOP.esVersions = [2.0]
GL_LINE_RESET_TOKEN = Enumerant('GL_LINE_RESET_TOKEN', 0x0707, 'GL_VERSION_1_1')
GL_LINE_SMOOTH = Enumerant('GL_LINE_SMOOTH', 0x0b20, 'GL_VERSION_1_1')
GL_LINE_SMOOTH.enableCap = True
GL_LINE_SMOOTH_HINT = Enumerant('GL_LINE_SMOOTH_HINT', 0x0c52, 'GL_VERSION_1_1')
GL_LINE_STIPPLE = Enumerant('GL_LINE_STIPPLE', 0x0b24, 'GL_VERSION_1_1')
GL_LINE_STIPPLE_PATTERN = Enumerant('GL_LINE_STIPPLE_PATTERN', 0x0b25, 'GL_VERSION_1_1')
GL_LINE_STIPPLE_REPEAT = Enumerant('GL_LINE_STIPPLE_REPEAT', 0x0b26, 'GL_VERSION_1_1')
GL_LINE_STRIP = Enumerant('GL_LINE_STRIP', 0x0003, 'GL_VERSION_1_1')
GL_LINE_STRIP.esVersions = [2.0]
GL_LINE_TOKEN = Enumerant('GL_LINE_TOKEN', 0x0702, 'GL_VERSION_1_1')
GL_LINE_WIDTH = Enumerant('GL_LINE_WIDTH', 0x0b21, 'GL_VERSION_1_1')
GL_LINE_WIDTH.esVersions = [2.0]
GL_LINE_WIDTH_GRANULARITY = Enumerant('GL_LINE_WIDTH_GRANULARITY', 0x0b23, 'GL_VERSION_1_1')
GL_LINE_WIDTH_RANGE = Enumerant('GL_LINE_WIDTH_RANGE', 0x0b22, 'GL_VERSION_1_1')
GL_LIST_BASE = Enumerant('GL_LIST_BASE', 0x0b32, 'GL_VERSION_1_1')
GL_LIST_BIT = Enumerant('GL_LIST_BIT', 0x20000, 'GL_VERSION_1_1')
GL_LIST_INDEX = Enumerant('GL_LIST_INDEX', 0x0b33, 'GL_VERSION_1_1')
GL_LIST_MODE = Enumerant('GL_LIST_MODE', 0x0b30, 'GL_VERSION_1_1')
GL_LOAD = Enumerant('GL_LOAD', 0x0101, 'GL_VERSION_1_1')
GL_LOGIC_OP = Enumerant('GL_LOGIC_OP', 'GL_INDEX_LOGIC_OP', 'GL_VERSION_1_1')
GL_LOGIC_OP_MODE = Enumerant('GL_LOGIC_OP_MODE', 0x0bf0, 'GL_VERSION_1_1')
GL_LUMINANCE = Enumerant('GL_LUMINANCE', 0x1909, 'GL_VERSION_1_1')
GL_LUMINANCE.esVersions = [2.0]
GL_LUMINANCE.internalformat = True
GL_LUMINANCE12 = Enumerant('GL_LUMINANCE12', 0x8041, 'GL_VERSION_1_1')
GL_LUMINANCE12_ALPHA12 = Enumerant('GL_LUMINANCE12_ALPHA12', 0x8047, 'GL_VERSION_1_1')
GL_LUMINANCE12_ALPHA4 = Enumerant('GL_LUMINANCE12_ALPHA4', 0x8046, 'GL_VERSION_1_1')
GL_LUMINANCE16 = Enumerant('GL_LUMINANCE16', 0x8042, 'GL_VERSION_1_1')
GL_LUMINANCE16_ALPHA16 = Enumerant('GL_LUMINANCE16_ALPHA16', 0x8048, 'GL_VERSION_1_1')
GL_LUMINANCE4 = Enumerant('GL_LUMINANCE4', 0x803f, 'GL_VERSION_1_1')
GL_LUMINANCE4_ALPHA4 = Enumerant('GL_LUMINANCE4_ALPHA4', 0x8043, 'GL_VERSION_1_1')
GL_LUMINANCE6_ALPHA2 = Enumerant('GL_LUMINANCE6_ALPHA2', 0x8044, 'GL_VERSION_1_1')
GL_LUMINANCE8 = Enumerant('GL_LUMINANCE8', 0x8040, 'GL_VERSION_1_1')
GL_LUMINANCE8_ALPHA8 = Enumerant('GL_LUMINANCE8_ALPHA8', 0x8045, 'GL_VERSION_1_1')
GL_LUMINANCE_ALPHA = Enumerant('GL_LUMINANCE_ALPHA', 0x190a, 'GL_VERSION_1_1')
GL_LUMINANCE_ALPHA.esVersions = [2.0]
GL_LUMINANCE_ALPHA.internalformat = True
GL_MAP1_COLOR_4 = Enumerant('GL_MAP1_COLOR_4', 0x0d90, 'GL_VERSION_1_1')
GL_MAP1_GRID_DOMAIN = Enumerant('GL_MAP1_GRID_DOMAIN', 0x0dd0, 'GL_VERSION_1_1')
GL_MAP1_GRID_SEGMENTS = Enumerant('GL_MAP1_GRID_SEGMENTS', 0x0dd1, 'GL_VERSION_1_1')
GL_MAP1_INDEX = Enumerant('GL_MAP1_INDEX', 0x0d91, 'GL_VERSION_1_1')
GL_MAP1_NORMAL = Enumerant('GL_MAP1_NORMAL', 0x0d92, 'GL_VERSION_1_1')
GL_MAP1_TEXTURE_COORD_1 = Enumerant('GL_MAP1_TEXTURE_COORD_1', 0x0d93, 'GL_VERSION_1_1')
GL_MAP1_TEXTURE_COORD_2 = Enumerant('GL_MAP1_TEXTURE_COORD_2', 0x0d94, 'GL_VERSION_1_1')
GL_MAP1_TEXTURE_COORD_3 = Enumerant('GL_MAP1_TEXTURE_COORD_3', 0x0d95, 'GL_VERSION_1_1')
GL_MAP1_TEXTURE_COORD_4 = Enumerant('GL_MAP1_TEXTURE_COORD_4', 0x0d96, 'GL_VERSION_1_1')
GL_MAP1_VERTEX_3 = Enumerant('GL_MAP1_VERTEX_3', 0x0d97, 'GL_VERSION_1_1')
GL_MAP1_VERTEX_4 = Enumerant('GL_MAP1_VERTEX_4', 0x0d98, 'GL_VERSION_1_1')
GL_MAP2_COLOR_4 = Enumerant('GL_MAP2_COLOR_4', 0x0db0, 'GL_VERSION_1_1')
GL_MAP2_GRID_DOMAIN = Enumerant('GL_MAP2_GRID_DOMAIN', 0x0dd2, 'GL_VERSION_1_1')
GL_MAP2_GRID_SEGMENTS = Enumerant('GL_MAP2_GRID_SEGMENTS', 0x0dd3, 'GL_VERSION_1_1')
GL_MAP2_INDEX = Enumerant('GL_MAP2_INDEX', 0x0db1, 'GL_VERSION_1_1')
GL_MAP2_NORMAL = Enumerant('GL_MAP2_NORMAL', 0x0db2, 'GL_VERSION_1_1')
GL_MAP2_TEXTURE_COORD_1 = Enumerant('GL_MAP2_TEXTURE_COORD_1', 0x0db3, 'GL_VERSION_1_1')
GL_MAP2_TEXTURE_COORD_2 = Enumerant('GL_MAP2_TEXTURE_COORD_2', 0x0db4, 'GL_VERSION_1_1')
GL_MAP2_TEXTURE_COORD_3 = Enumerant('GL_MAP2_TEXTURE_COORD_3', 0x0db5, 'GL_VERSION_1_1')
GL_MAP2_TEXTURE_COORD_4 = Enumerant('GL_MAP2_TEXTURE_COORD_4', 0x0db6, 'GL_VERSION_1_1')
GL_MAP2_VERTEX_3 = Enumerant('GL_MAP2_VERTEX_3', 0x0db7, 'GL_VERSION_1_1')
GL_MAP2_VERTEX_4 = Enumerant('GL_MAP2_VERTEX_4', 0x0db8, 'GL_VERSION_1_1')
GL_MAP_COLOR = Enumerant('GL_MAP_COLOR', 0x0d10, 'GL_VERSION_1_1')
GL_MAP_STENCIL = Enumerant('GL_MAP_STENCIL', 0x0d11, 'GL_VERSION_1_1')
GL_MATRIX_MODE = Enumerant('GL_MATRIX_MODE', 0x0ba0, 'GL_VERSION_1_1')
GL_MAX_ATTRIB_STACK_DEPTH = Enumerant('GL_MAX_ATTRIB_STACK_DEPTH', 0x0d35, 'GL_VERSION_1_1')
GL_MAX_CLIENT_ATTRIB_STACK_DEPTH = Enumerant('GL_MAX_CLIENT_ATTRIB_STACK_DEPTH', 0x0d3b, 'GL_VERSION_1_1')
GL_MAX_CLIP_PLANES = Enumerant('GL_MAX_CLIP_PLANES', 0x0d32, 'GL_VERSION_1_1')
GL_MAX_EVAL_ORDER = Enumerant('GL_MAX_EVAL_ORDER', 0x0d30, 'GL_VERSION_1_1')
GL_MAX_LIGHTS = Enumerant('GL_MAX_LIGHTS', 0x0d31, 'GL_VERSION_1_1')
GL_MAX_LIST_NESTING = Enumerant('GL_MAX_LIST_NESTING', 0x0b31, 'GL_VERSION_1_1')
GL_MAX_MODELVIEW_STACK_DEPTH = Enumerant('GL_MAX_MODELVIEW_STACK_DEPTH', 0x0d36, 'GL_VERSION_1_1')
GL_MAX_NAME_STACK_DEPTH = Enumerant('GL_MAX_NAME_STACK_DEPTH', 0x0d37, 'GL_VERSION_1_1')
GL_MAX_PIXEL_MAP_TABLE = Enumerant('GL_MAX_PIXEL_MAP_TABLE', 0x0d34, 'GL_VERSION_1_1')
GL_MAX_PROJECTION_STACK_DEPTH = Enumerant('GL_MAX_PROJECTION_STACK_DEPTH', 0x0d38, 'GL_VERSION_1_1')
GL_MAX_TEXTURE_SIZE = Enumerant('GL_MAX_TEXTURE_SIZE', 0x0d33, 'GL_VERSION_1_1')
GL_MAX_TEXTURE_SIZE.esVersions = [2.0]
GL_MAX_TEXTURE_STACK_DEPTH = Enumerant('GL_MAX_TEXTURE_STACK_DEPTH', 0x0d39, 'GL_VERSION_1_1')
GL_MAX_VIEWPORT_DIMS = Enumerant('GL_MAX_VIEWPORT_DIMS', 0x0d3a, 'GL_VERSION_1_1')
GL_MAX_VIEWPORT_DIMS.esVersions = [2.0]
GL_MODELVIEW = Enumerant('GL_MODELVIEW', 0x1700, 'GL_VERSION_1_1')
GL_MODELVIEW_MATRIX = Enumerant('GL_MODELVIEW_MATRIX', 0x0ba6, 'GL_VERSION_1_1')
GL_MODELVIEW_STACK_DEPTH = Enumerant('GL_MODELVIEW_STACK_DEPTH', 0x0ba3, 'GL_VERSION_1_1')
GL_MODULATE = Enumerant('GL_MODULATE', 0x2100, 'GL_VERSION_1_1')
GL_MULT = Enumerant('GL_MULT', 0x0103, 'GL_VERSION_1_1')
GL_N3F_V3F = Enumerant('GL_N3F_V3F', 0x2a25, 'GL_VERSION_1_1')
GL_NAME_STACK_DEPTH = Enumerant('GL_NAME_STACK_DEPTH', 0x0d70, 'GL_VERSION_1_1')
GL_NAND = Enumerant('GL_NAND', 0x150e, 'GL_VERSION_1_1')
GL_NEAREST = Enumerant('GL_NEAREST', 0x2600, 'GL_VERSION_1_1')
GL_NEAREST.esVersions = [2.0]
GL_NEAREST_MIPMAP_LINEAR = Enumerant('GL_NEAREST_MIPMAP_LINEAR', 0x2702, 'GL_VERSION_1_1')
GL_NEAREST_MIPMAP_LINEAR.esVersions = [2.0]
GL_NEAREST_MIPMAP_NEAREST = Enumerant('GL_NEAREST_MIPMAP_NEAREST', 0x2700, 'GL_VERSION_1_1')
GL_NEAREST_MIPMAP_NEAREST.esVersions = [2.0]
GL_NEVER = Enumerant('GL_NEVER', 0x0200, 'GL_VERSION_1_1')
GL_NEVER.esVersions = [2.0]
GL_NICEST = Enumerant('GL_NICEST', 0x1102, 'GL_VERSION_1_1')
GL_NICEST.esVersions = [2.0]
GL_NONE = Enumerant('GL_NONE', 0x0000, 'GL_VERSION_1_1')
GL_NONE.esVersions = [2.0]
GL_NOOP = Enumerant('GL_NOOP', 0x1505, 'GL_VERSION_1_1')
GL_NOR = Enumerant('GL_NOR', 0x1508, 'GL_VERSION_1_1')
GL_NORMALIZE = Enumerant('GL_NORMALIZE', 0x0ba1, 'GL_VERSION_1_1')
GL_NORMAL_ARRAY = Enumerant('GL_NORMAL_ARRAY', 0x8075, 'GL_VERSION_1_1')
GL_NORMAL_ARRAY_POINTER = Enumerant('GL_NORMAL_ARRAY_POINTER', 0x808f, 'GL_VERSION_1_1')
GL_NORMAL_ARRAY_STRIDE = Enumerant('GL_NORMAL_ARRAY_STRIDE', 0x807f, 'GL_VERSION_1_1')
GL_NORMAL_ARRAY_TYPE = Enumerant('GL_NORMAL_ARRAY_TYPE', 0x807e, 'GL_VERSION_1_1')
GL_NOTEQUAL = Enumerant('GL_NOTEQUAL', 0x0205, 'GL_VERSION_1_1')
GL_NOTEQUAL.esVersions = [2.0]
GL_NO_ERROR = Enumerant('GL_NO_ERROR', 0x0000, 'GL_VERSION_1_1')
GL_NO_ERROR.esVersions = [2.0]
GL_NO_ERROR.gluErrorString = 'no error'
GL_OBJECT_LINEAR = Enumerant('GL_OBJECT_LINEAR', 0x2401, 'GL_VERSION_1_1')
GL_OBJECT_PLANE = Enumerant('GL_OBJECT_PLANE', 0x2501, 'GL_VERSION_1_1')
GL_ONE = Enumerant('GL_ONE', 0x0001, 'GL_VERSION_1_1')
GL_ONE.esVersions = [2.0]
GL_ONE_MINUS_DST_ALPHA = Enumerant('GL_ONE_MINUS_DST_ALPHA', 0x0305, 'GL_VERSION_1_1')
GL_ONE_MINUS_DST_ALPHA.esVersions = [2.0]
GL_ONE_MINUS_DST_COLOR = Enumerant('GL_ONE_MINUS_DST_COLOR', 0x0307, 'GL_VERSION_1_1')
GL_ONE_MINUS_DST_COLOR.esVersions = [2.0]
GL_ONE_MINUS_SRC_ALPHA = Enumerant('GL_ONE_MINUS_SRC_ALPHA', 0x0303, 'GL_VERSION_1_1')
GL_ONE_MINUS_SRC_ALPHA.esVersions = [2.0]
GL_ONE_MINUS_SRC_COLOR = Enumerant('GL_ONE_MINUS_SRC_COLOR', 0x0301, 'GL_VERSION_1_1')
GL_ONE_MINUS_SRC_COLOR.esVersions = [2.0]
GL_OR = Enumerant('GL_OR', 0x1507, 'GL_VERSION_1_1')
GL_ORDER = Enumerant('GL_ORDER', 0x0a01, 'GL_VERSION_1_1')
GL_OR_INVERTED = Enumerant('GL_OR_INVERTED', 0x150d, 'GL_VERSION_1_1')
GL_OR_REVERSE = Enumerant('GL_OR_REVERSE', 0x150b, 'GL_VERSION_1_1')
GL_OUT_OF_MEMORY = Enumerant('GL_OUT_OF_MEMORY', 0x0505, 'GL_VERSION_1_1')
GL_OUT_OF_MEMORY.esVersions = [2.0]
GL_OUT_OF_MEMORY.gluErrorString = 'out of memory'
GL_PACK_ALIGNMENT = Enumerant('GL_PACK_ALIGNMENT', 0x0d05, 'GL_VERSION_1_1')
GL_PACK_ALIGNMENT.esVersions = [2.0]
GL_PACK_LSB_FIRST = Enumerant('GL_PACK_LSB_FIRST', 0x0d01, 'GL_VERSION_1_1')
GL_PACK_ROW_LENGTH = Enumerant('GL_PACK_ROW_LENGTH', 0x0d02, 'GL_VERSION_1_1')
GL_PACK_SKIP_PIXELS = Enumerant('GL_PACK_SKIP_PIXELS', 0x0d04, 'GL_VERSION_1_1')
GL_PACK_SKIP_ROWS = Enumerant('GL_PACK_SKIP_ROWS', 0x0d03, 'GL_VERSION_1_1')
GL_PACK_SWAP_BYTES = Enumerant('GL_PACK_SWAP_BYTES', 0x0d00, 'GL_VERSION_1_1')
GL_PASS_THROUGH_TOKEN = Enumerant('GL_PASS_THROUGH_TOKEN', 0x0700, 'GL_VERSION_1_1')
GL_PERSPECTIVE_CORRECTION_HINT = Enumerant('GL_PERSPECTIVE_CORRECTION_HINT', 0x0c50, 'GL_VERSION_1_1')
GL_PIXEL_MAP_A_TO_A = Enumerant('GL_PIXEL_MAP_A_TO_A', 0x0c79, 'GL_VERSION_1_1')
GL_PIXEL_MAP_A_TO_A_SIZE = Enumerant('GL_PIXEL_MAP_A_TO_A_SIZE', 0x0cb9, 'GL_VERSION_1_1')
GL_PIXEL_MAP_B_TO_B = Enumerant('GL_PIXEL_MAP_B_TO_B', 0x0c78, 'GL_VERSION_1_1')
GL_PIXEL_MAP_B_TO_B_SIZE = Enumerant('GL_PIXEL_MAP_B_TO_B_SIZE', 0x0cb8, 'GL_VERSION_1_1')
GL_PIXEL_MAP_G_TO_G = Enumerant('GL_PIXEL_MAP_G_TO_G', 0x0c77, 'GL_VERSION_1_1')
GL_PIXEL_MAP_G_TO_G_SIZE = Enumerant('GL_PIXEL_MAP_G_TO_G_SIZE', 0x0cb7, 'GL_VERSION_1_1')
GL_PIXEL_MAP_I_TO_A = Enumerant('GL_PIXEL_MAP_I_TO_A', 0x0c75, 'GL_VERSION_1_1')
GL_PIXEL_MAP_I_TO_A_SIZE = Enumerant('GL_PIXEL_MAP_I_TO_A_SIZE', 0x0cb5, 'GL_VERSION_1_1')
GL_PIXEL_MAP_I_TO_B = Enumerant('GL_PIXEL_MAP_I_TO_B', 0x0c74, 'GL_VERSION_1_1')
GL_PIXEL_MAP_I_TO_B_SIZE = Enumerant('GL_PIXEL_MAP_I_TO_B_SIZE', 0x0cb4, 'GL_VERSION_1_1')
GL_PIXEL_MAP_I_TO_G = Enumerant('GL_PIXEL_MAP_I_TO_G', 0x0c73, 'GL_VERSION_1_1')
GL_PIXEL_MAP_I_TO_G_SIZE = Enumerant('GL_PIXEL_MAP_I_TO_G_SIZE', 0x0cb3, 'GL_VERSION_1_1')
GL_PIXEL_MAP_I_TO_I = Enumerant('GL_PIXEL_MAP_I_TO_I', 0x0c70, 'GL_VERSION_1_1')
GL_PIXEL_MAP_I_TO_I_SIZE = Enumerant('GL_PIXEL_MAP_I_TO_I_SIZE', 0x0cb0, 'GL_VERSION_1_1')
GL_PIXEL_MAP_I_TO_R = Enumerant('GL_PIXEL_MAP_I_TO_R', 0x0c72, 'GL_VERSION_1_1')
GL_PIXEL_MAP_I_TO_R_SIZE = Enumerant('GL_PIXEL_MAP_I_TO_R_SIZE', 0x0cb2, 'GL_VERSION_1_1')
GL_PIXEL_MAP_R_TO_R = Enumerant('GL_PIXEL_MAP_R_TO_R', 0x0c76, 'GL_VERSION_1_1')
GL_PIXEL_MAP_R_TO_R_SIZE = Enumerant('GL_PIXEL_MAP_R_TO_R_SIZE', 0x0cb6, 'GL_VERSION_1_1')
GL_PIXEL_MAP_S_TO_S = Enumerant('GL_PIXEL_MAP_S_TO_S', 0x0c71, 'GL_VERSION_1_1')
GL_PIXEL_MAP_S_TO_S_SIZE = Enumerant('GL_PIXEL_MAP_S_TO_S_SIZE', 0x0cb1, 'GL_VERSION_1_1')
GL_PIXEL_MODE_BIT = Enumerant('GL_PIXEL_MODE_BIT', 0x0020, 'GL_VERSION_1_1')
GL_POINT = Enumerant('GL_POINT', 0x1b00, 'GL_VERSION_1_1')
GL_POINTS = Enumerant('GL_POINTS', 0x0000, 'GL_VERSION_1_1')
GL_POINTS.esVersions = [2.0]
GL_POINT_BIT = Enumerant('GL_POINT_BIT', 0x0002, 'GL_VERSION_1_1')
GL_POINT_SIZE = Enumerant('GL_POINT_SIZE', 0x0b11, 'GL_VERSION_1_1')
GL_POINT_SIZE_GRANULARITY = Enumerant('GL_POINT_SIZE_GRANULARITY', 0x0b13, 'GL_VERSION_1_1')
GL_POINT_SIZE_RANGE = Enumerant('GL_POINT_SIZE_RANGE', 0x0b12, 'GL_VERSION_1_1')
GL_POINT_SMOOTH = Enumerant('GL_POINT_SMOOTH', 0x0b10, 'GL_VERSION_1_1')
GL_POINT_SMOOTH_HINT = Enumerant('GL_POINT_SMOOTH_HINT', 0x0c51, 'GL_VERSION_1_1')
GL_POINT_TOKEN = Enumerant('GL_POINT_TOKEN', 0x0701, 'GL_VERSION_1_1')
GL_POLYGON = Enumerant('GL_POLYGON', 0x0009, 'GL_VERSION_1_1')
GL_POLYGON_BIT = Enumerant('GL_POLYGON_BIT', 0x0008, 'GL_VERSION_1_1')
GL_POLYGON_MODE = Enumerant('GL_POLYGON_MODE', 0x0b40, 'GL_VERSION_1_1')
GL_POLYGON_OFFSET_FACTOR = Enumerant('GL_POLYGON_OFFSET_FACTOR', 0x8038, 'GL_VERSION_1_1')
GL_POLYGON_OFFSET_FACTOR.esVersions = [2.0]
GL_POLYGON_OFFSET_FILL = Enumerant('GL_POLYGON_OFFSET_FILL', 0x8037, 'GL_VERSION_1_1')
GL_POLYGON_OFFSET_FILL.esVersions = [2.0]
GL_POLYGON_OFFSET_FILL.enableCap = True
GL_POLYGON_OFFSET_LINE = Enumerant('GL_POLYGON_OFFSET_LINE', 0x2a02, 'GL_VERSION_1_1')
GL_POLYGON_OFFSET_LINE.enableCap = True
GL_POLYGON_OFFSET_POINT = Enumerant('GL_POLYGON_OFFSET_POINT', 0x2a01, 'GL_VERSION_1_1')
GL_POLYGON_OFFSET_POINT.enableCap = True
GL_POLYGON_OFFSET_UNITS = Enumerant('GL_POLYGON_OFFSET_UNITS', 0x2a00, 'GL_VERSION_1_1')
GL_POLYGON_OFFSET_UNITS.esVersions = [2.0]
GL_POLYGON_SMOOTH = Enumerant('GL_POLYGON_SMOOTH', 0x0b41, 'GL_VERSION_1_1')
GL_POLYGON_SMOOTH.enableCap = True
GL_POLYGON_SMOOTH_HINT = Enumerant('GL_POLYGON_SMOOTH_HINT', 0x0c53, 'GL_VERSION_1_1')
GL_POLYGON_STIPPLE = Enumerant('GL_POLYGON_STIPPLE', 0x0b42, 'GL_VERSION_1_1')
GL_POLYGON_STIPPLE_BIT = Enumerant('GL_POLYGON_STIPPLE_BIT', 0x0010, 'GL_VERSION_1_1')
GL_POLYGON_TOKEN = Enumerant('GL_POLYGON_TOKEN', 0x0703, 'GL_VERSION_1_1')
GL_POSITION = Enumerant('GL_POSITION', 0x1203, 'GL_VERSION_1_1')
GL_PROJECTION = Enumerant('GL_PROJECTION', 0x1701, 'GL_VERSION_1_1')
GL_PROJECTION_MATRIX = Enumerant('GL_PROJECTION_MATRIX', 0x0ba7, 'GL_VERSION_1_1')
GL_PROJECTION_STACK_DEPTH = Enumerant('GL_PROJECTION_STACK_DEPTH', 0x0ba4, 'GL_VERSION_1_1')
GL_PROXY_TEXTURE_1D = Enumerant('GL_PROXY_TEXTURE_1D', 0x8063, 'GL_VERSION_1_1')
GL_PROXY_TEXTURE_2D = Enumerant('GL_PROXY_TEXTURE_2D', 0x8064, 'GL_VERSION_1_1')
GL_Q = Enumerant('GL_Q', 0x2003, 'GL_VERSION_1_1')
GL_QUADRATIC_ATTENUATION = Enumerant('GL_QUADRATIC_ATTENUATION', 0x1209, 'GL_VERSION_1_1')
GL_QUADS = Enumerant('GL_QUADS', 0x0007, 'GL_VERSION_1_1')
GL_QUAD_STRIP = Enumerant('GL_QUAD_STRIP', 0x0008, 'GL_VERSION_1_1')
GL_R = Enumerant('GL_R', 0x2002, 'GL_VERSION_1_1')
GL_R3_G3_B2 = Enumerant('GL_R3_G3_B2', 0x2a10, 'GL_VERSION_1_1')
GL_READ_BUFFER = Enumerant('GL_READ_BUFFER', 0x0c02, 'GL_VERSION_1_1')
GL_RED = Enumerant('GL_RED', 0x1903, 'GL_VERSION_1_1')
GL_RED_BIAS = Enumerant('GL_RED_BIAS', 0x0d15, 'GL_VERSION_1_1')
GL_RED_BITS = Enumerant('GL_RED_BITS', 0x0d52, 'GL_VERSION_1_1')
GL_RED_BITS.esVersions = [2.0]
GL_RED_SCALE = Enumerant('GL_RED_SCALE', 0x0d14, 'GL_VERSION_1_1')
GL_RENDER = Enumerant('GL_RENDER', 0x1c00, 'GL_VERSION_1_1')
GL_RENDERER = Enumerant('GL_RENDERER', 0x1f01, 'GL_VERSION_1_1')
GL_RENDERER.esVersions = [2.0]
GL_RENDER_MODE = Enumerant('GL_RENDER_MODE', 0x0c40, 'GL_VERSION_1_1')
GL_REPEAT = Enumerant('GL_REPEAT', 0x2901, 'GL_VERSION_1_1')
GL_REPEAT.esVersions = [2.0]
GL_REPLACE = Enumerant('GL_REPLACE', 0x1e01, 'GL_VERSION_1_1')
GL_REPLACE.esVersions = [2.0]
GL_RETURN = Enumerant('GL_RETURN', 0x0102, 'GL_VERSION_1_1')
GL_RGB = Enumerant('GL_RGB', 0x1907, 'GL_VERSION_1_1')
GL_RGB.esVersions = [2.0]
GL_RGB.internalformat = True
GL_RGB10 = Enumerant('GL_RGB10', 0x8052, 'GL_VERSION_1_1')
GL_RGB10_A2 = Enumerant('GL_RGB10_A2', 0x8059, 'GL_VERSION_1_1')
GL_RGB12 = Enumerant('GL_RGB12', 0x8053, 'GL_VERSION_1_1')
GL_RGB16 = Enumerant('GL_RGB16', 0x8054, 'GL_VERSION_1_1')
GL_RGB4 = Enumerant('GL_RGB4', 0x804f, 'GL_VERSION_1_1')
GL_RGB5 = Enumerant('GL_RGB5', 0x8050, 'GL_VERSION_1_1')
GL_RGB5_A1 = Enumerant('GL_RGB5_A1', 0x8057, 'GL_VERSION_1_1')
GL_RGB5_A1.esVersions = [2.0]
GL_RGB8 = Enumerant('GL_RGB8', 0x8051, 'GL_VERSION_1_1')
GL_RGBA = Enumerant('GL_RGBA', 0x1908, 'GL_VERSION_1_1')
GL_RGBA.esVersions = [2.0]
GL_RGBA.internalformat = True
GL_RGBA12 = Enumerant('GL_RGBA12', 0x805a, 'GL_VERSION_1_1')
GL_RGBA16 = Enumerant('GL_RGBA16', 0x805b, 'GL_VERSION_1_1')
GL_RGBA2 = Enumerant('GL_RGBA2', 0x8055, 'GL_VERSION_1_1')
GL_RGBA4 = Enumerant('GL_RGBA4', 0x8056, 'GL_VERSION_1_1')
GL_RGBA4.esVersions = [2.0]
GL_RGBA8 = Enumerant('GL_RGBA8', 0x8058, 'GL_VERSION_1_1')
GL_RGBA_MODE = Enumerant('GL_RGBA_MODE', 0x0c31, 'GL_VERSION_1_1')
GL_RIGHT = Enumerant('GL_RIGHT', 0x0407, 'GL_VERSION_1_1')
GL_S = Enumerant('GL_S', 0x2000, 'GL_VERSION_1_1')
GL_SCISSOR_BIT = Enumerant('GL_SCISSOR_BIT', 0x80000, 'GL_VERSION_1_1')
GL_SCISSOR_BOX = Enumerant('GL_SCISSOR_BOX', 0x0c10, 'GL_VERSION_1_1')
GL_SCISSOR_BOX.esVersions = [2.0]
GL_SCISSOR_TEST = Enumerant('GL_SCISSOR_TEST', 0x0c11, 'GL_VERSION_1_1')
GL_SCISSOR_TEST.esVersions = [2.0]
GL_SCISSOR_TEST.enableCap = True
GL_SELECT = Enumerant('GL_SELECT', 0x1c02, 'GL_VERSION_1_1')
GL_SELECTION_BUFFER_POINTER = Enumerant('GL_SELECTION_BUFFER_POINTER', 0x0df3, 'GL_VERSION_1_1')
GL_SELECTION_BUFFER_SIZE = Enumerant('GL_SELECTION_BUFFER_SIZE', 0x0df4, 'GL_VERSION_1_1')
GL_SET = Enumerant('GL_SET', 0x150f, 'GL_VERSION_1_1')
GL_SHADE_MODEL = Enumerant('GL_SHADE_MODEL', 0x0b54, 'GL_VERSION_1_1')
GL_SHININESS = Enumerant('GL_SHININESS', 0x1601, 'GL_VERSION_1_1')
GL_SHORT = Enumerant('GL_SHORT', 0x1402, 'GL_VERSION_1_1')
GL_SHORT.group = ['pathCoord']
GL_SHORT.esVersions = [2.0]
GL_SMOOTH = Enumerant('GL_SMOOTH', 0x1d01, 'GL_VERSION_1_1')
GL_SPECULAR = Enumerant('GL_SPECULAR', 0x1202, 'GL_VERSION_1_1')
GL_SPHERE_MAP = Enumerant('GL_SPHERE_MAP', 0x2402, 'GL_VERSION_1_1')
GL_SPOT_CUTOFF = Enumerant('GL_SPOT_CUTOFF', 0x1206, 'GL_VERSION_1_1')
GL_SPOT_DIRECTION = Enumerant('GL_SPOT_DIRECTION', 0x1204, 'GL_VERSION_1_1')
GL_SPOT_EXPONENT = Enumerant('GL_SPOT_EXPONENT', 0x1205, 'GL_VERSION_1_1')
GL_SRC_ALPHA = Enumerant('GL_SRC_ALPHA', 0x0302, 'GL_VERSION_1_1')
GL_SRC_ALPHA.esVersions = [2.0]
GL_SRC_ALPHA_SATURATE = Enumerant('GL_SRC_ALPHA_SATURATE', 0x0308, 'GL_VERSION_1_1')
GL_SRC_ALPHA_SATURATE.esVersions = [2.0]
GL_SRC_COLOR = Enumerant('GL_SRC_COLOR', 0x0300, 'GL_VERSION_1_1')
GL_SRC_COLOR.esVersions = [2.0]
GL_STACK_OVERFLOW = Enumerant('GL_STACK_OVERFLOW', 0x0503, 'GL_VERSION_1_1')
GL_STACK_OVERFLOW.gluErrorString = 'stack overflow'
GL_STACK_UNDERFLOW = Enumerant('GL_STACK_UNDERFLOW', 0x0504, 'GL_VERSION_1_1')
GL_STACK_UNDERFLOW.gluErrorString = 'stack underflow'
GL_STENCIL = Enumerant('GL_STENCIL', 0x1802, 'GL_VERSION_1_1')
GL_STENCIL_BITS = Enumerant('GL_STENCIL_BITS', 0x0d57, 'GL_VERSION_1_1')
GL_STENCIL_BITS.esVersions = [2.0]
GL_STENCIL_BUFFER_BIT = Enumerant('GL_STENCIL_BUFFER_BIT', 0x0400, 'GL_VERSION_1_1')
GL_STENCIL_BUFFER_BIT.esVersions = [2.0]
GL_STENCIL_CLEAR_VALUE = Enumerant('GL_STENCIL_CLEAR_VALUE', 0x0b91, 'GL_VERSION_1_1')
GL_STENCIL_CLEAR_VALUE.esVersions = [2.0]
GL_STENCIL_FAIL = Enumerant('GL_STENCIL_FAIL', 0x0b94, 'GL_VERSION_1_1')
GL_STENCIL_FAIL.esVersions = [2.0]
GL_STENCIL_FUNC = Enumerant('GL_STENCIL_FUNC', 0x0b92, 'GL_VERSION_1_1')
GL_STENCIL_FUNC.esVersions = [2.0]
GL_STENCIL_INDEX = Enumerant('GL_STENCIL_INDEX', 0x1901, 'GL_VERSION_1_1')
GL_STENCIL_PASS_DEPTH_FAIL = Enumerant('GL_STENCIL_PASS_DEPTH_FAIL', 0x0b95, 'GL_VERSION_1_1')
GL_STENCIL_PASS_DEPTH_FAIL.esVersions = [2.0]
GL_STENCIL_PASS_DEPTH_PASS = Enumerant('GL_STENCIL_PASS_DEPTH_PASS', 0x0b96, 'GL_VERSION_1_1')
GL_STENCIL_PASS_DEPTH_PASS.esVersions = [2.0]
GL_STENCIL_REF = Enumerant('GL_STENCIL_REF', 0x0b97, 'GL_VERSION_1_1')
GL_STENCIL_REF.esVersions = [2.0]
GL_STENCIL_TEST = Enumerant('GL_STENCIL_TEST', 0x0b90, 'GL_VERSION_1_1')
GL_STENCIL_TEST.esVersions = [2.0]
GL_STENCIL_TEST.enableCap = True
GL_STENCIL_VALUE_MASK = Enumerant('GL_STENCIL_VALUE_MASK', 0x0b93, 'GL_VERSION_1_1')
GL_STENCIL_VALUE_MASK.esVersions = [2.0]
GL_STENCIL_WRITEMASK = Enumerant('GL_STENCIL_WRITEMASK', 0x0b98, 'GL_VERSION_1_1')
GL_STENCIL_WRITEMASK.esVersions = [2.0]
GL_STEREO = Enumerant('GL_STEREO', 0x0c33, 'GL_VERSION_1_1')
GL_SUBPIXEL_BITS = Enumerant('GL_SUBPIXEL_BITS', 0x0d50, 'GL_VERSION_1_1')
GL_SUBPIXEL_BITS.esVersions = [2.0]
GL_T = Enumerant('GL_T', 0x2001, 'GL_VERSION_1_1')
GL_T2F_C3F_V3F = Enumerant('GL_T2F_C3F_V3F', 0x2a2a, 'GL_VERSION_1_1')
GL_T2F_C4F_N3F_V3F = Enumerant('GL_T2F_C4F_N3F_V3F', 0x2a2c, 'GL_VERSION_1_1')
GL_T2F_C4UB_V3F = Enumerant('GL_T2F_C4UB_V3F', 0x2a29, 'GL_VERSION_1_1')
GL_T2F_N3F_V3F = Enumerant('GL_T2F_N3F_V3F', 0x2a2b, 'GL_VERSION_1_1')
GL_T2F_V3F = Enumerant('GL_T2F_V3F', 0x2a27, 'GL_VERSION_1_1')
GL_T4F_C4F_N3F_V4F = Enumerant('GL_T4F_C4F_N3F_V4F', 0x2a2d, 'GL_VERSION_1_1')
GL_T4F_V4F = Enumerant('GL_T4F_V4F', 0x2a28, 'GL_VERSION_1_1')
GL_TEXTURE = Enumerant('GL_TEXTURE', 0x1702, 'GL_VERSION_1_1')
GL_TEXTURE.esVersions = [2.0]
GL_TEXTURE_1D = Enumerant('GL_TEXTURE_1D', 0x0de0, 'GL_VERSION_1_1')
GL_TEXTURE_2D = Enumerant('GL_TEXTURE_2D', 0x0de1, 'GL_VERSION_1_1')
GL_TEXTURE_2D.esVersions = [2.0]
GL_TEXTURE_2D.enableCap = True
GL_TEXTURE_2D.bindTexture = True
GL_TEXTURE_2D.texImage = True
GL_TEXTURE_ALPHA_SIZE = Enumerant('GL_TEXTURE_ALPHA_SIZE', 0x805f, 'GL_VERSION_1_1')
GL_TEXTURE_BINDING_1D = Enumerant('GL_TEXTURE_BINDING_1D', 0x8068, 'GL_VERSION_1_1')
GL_TEXTURE_BINDING_2D = Enumerant('GL_TEXTURE_BINDING_2D', 0x8069, 'GL_VERSION_1_1')
GL_TEXTURE_BINDING_2D.esVersions = [2.0]
GL_TEXTURE_BIT = Enumerant('GL_TEXTURE_BIT', 0x40000, 'GL_VERSION_1_1')
GL_TEXTURE_BLUE_SIZE = Enumerant('GL_TEXTURE_BLUE_SIZE', 0x805e, 'GL_VERSION_1_1')
GL_TEXTURE_BORDER = Enumerant('GL_TEXTURE_BORDER', 0x1005, 'GL_VERSION_1_1')
GL_TEXTURE_BORDER_COLOR = Enumerant('GL_TEXTURE_BORDER_COLOR', 0x1004, 'GL_VERSION_1_1')
GL_TEXTURE_COMPONENTS = Enumerant('GL_TEXTURE_COMPONENTS', 'GL_TEXTURE_INTERNAL_FORMAT', 'GL_VERSION_1_1')
GL_TEXTURE_COORD_ARRAY = Enumerant('GL_TEXTURE_COORD_ARRAY', 0x8078, 'GL_VERSION_1_1')
GL_TEXTURE_COORD_ARRAY_POINTER = Enumerant('GL_TEXTURE_COORD_ARRAY_POINTER', 0x8092, 'GL_VERSION_1_1')
GL_TEXTURE_COORD_ARRAY_SIZE = Enumerant('GL_TEXTURE_COORD_ARRAY_SIZE', 0x8088, 'GL_VERSION_1_1')
GL_TEXTURE_COORD_ARRAY_STRIDE = Enumerant('GL_TEXTURE_COORD_ARRAY_STRIDE', 0x808a, 'GL_VERSION_1_1')
GL_TEXTURE_COORD_ARRAY_TYPE = Enumerant('GL_TEXTURE_COORD_ARRAY_TYPE', 0x8089, 'GL_VERSION_1_1')
GL_TEXTURE_ENV = Enumerant('GL_TEXTURE_ENV', 0x2300, 'GL_VERSION_1_1')
GL_TEXTURE_ENV_COLOR = Enumerant('GL_TEXTURE_ENV_COLOR', 0x2201, 'GL_VERSION_1_1')
GL_TEXTURE_ENV_MODE = Enumerant('GL_TEXTURE_ENV_MODE', 0x2200, 'GL_VERSION_1_1')
GL_TEXTURE_GEN_MODE = Enumerant('GL_TEXTURE_GEN_MODE', 0x2500, 'GL_VERSION_1_1')
GL_TEXTURE_GEN_Q = Enumerant('GL_TEXTURE_GEN_Q', 0x0c63, 'GL_VERSION_1_1')
GL_TEXTURE_GEN_R = Enumerant('GL_TEXTURE_GEN_R', 0x0c62, 'GL_VERSION_1_1')
GL_TEXTURE_GEN_S = Enumerant('GL_TEXTURE_GEN_S', 0x0c60, 'GL_VERSION_1_1')
GL_TEXTURE_GEN_T = Enumerant('GL_TEXTURE_GEN_T', 0x0c61, 'GL_VERSION_1_1')
GL_TEXTURE_GREEN_SIZE = Enumerant('GL_TEXTURE_GREEN_SIZE', 0x805d, 'GL_VERSION_1_1')
GL_TEXTURE_HEIGHT = Enumerant('GL_TEXTURE_HEIGHT', 0x1001, 'GL_VERSION_1_1')
GL_TEXTURE_INTENSITY_SIZE = Enumerant('GL_TEXTURE_INTENSITY_SIZE', 0x8061, 'GL_VERSION_1_1')
GL_TEXTURE_INTERNAL_FORMAT = Enumerant('GL_TEXTURE_INTERNAL_FORMAT', 0x1003, 'GL_VERSION_1_1')
GL_TEXTURE_LUMINANCE_SIZE = Enumerant('GL_TEXTURE_LUMINANCE_SIZE', 0x8060, 'GL_VERSION_1_1')
GL_TEXTURE_MAG_FILTER = Enumerant('GL_TEXTURE_MAG_FILTER', 0x2800, 'GL_VERSION_1_1')
GL_TEXTURE_MAG_FILTER.esVersions = [2.0]
GL_TEXTURE_MATRIX = Enumerant('GL_TEXTURE_MATRIX', 0x0ba8, 'GL_VERSION_1_1')
GL_TEXTURE_MIN_FILTER = Enumerant('GL_TEXTURE_MIN_FILTER', 0x2801, 'GL_VERSION_1_1')
GL_TEXTURE_MIN_FILTER.esVersions = [2.0]
GL_TEXTURE_PRIORITY = Enumerant('GL_TEXTURE_PRIORITY', 0x8066, 'GL_VERSION_1_1')
GL_TEXTURE_RED_SIZE = Enumerant('GL_TEXTURE_RED_SIZE', 0x805c, 'GL_VERSION_1_1')
GL_TEXTURE_RESIDENT = Enumerant('GL_TEXTURE_RESIDENT', 0x8067, 'GL_VERSION_1_1')
GL_TEXTURE_STACK_DEPTH = Enumerant('GL_TEXTURE_STACK_DEPTH', 0x0ba5, 'GL_VERSION_1_1')
GL_TEXTURE_WIDTH = Enumerant('GL_TEXTURE_WIDTH', 0x1000, 'GL_VERSION_1_1')
GL_TEXTURE_WRAP_S = Enumerant('GL_TEXTURE_WRAP_S', 0x2802, 'GL_VERSION_1_1')
GL_TEXTURE_WRAP_S.esVersions = [2.0]
GL_TEXTURE_WRAP_T = Enumerant('GL_TEXTURE_WRAP_T', 0x2803, 'GL_VERSION_1_1')
GL_TEXTURE_WRAP_T.esVersions = [2.0]
GL_TRANSFORM_BIT = Enumerant('GL_TRANSFORM_BIT', 0x1000, 'GL_VERSION_1_1')
GL_TRIANGLES = Enumerant('GL_TRIANGLES', 0x0004, 'GL_VERSION_1_1')
GL_TRIANGLES.esVersions = [2.0]
GL_TRIANGLE_FAN = Enumerant('GL_TRIANGLE_FAN', 0x0006, 'GL_VERSION_1_1')
GL_TRIANGLE_FAN.esVersions = [2.0]
GL_TRIANGLE_STRIP = Enumerant('GL_TRIANGLE_STRIP', 0x0005, 'GL_VERSION_1_1')
GL_TRIANGLE_STRIP.esVersions = [2.0]
GL_TRUE = Enumerant('GL_TRUE', 0x0001, 'GL_VERSION_1_1')
GL_TRUE.esVersions = [2.0]
GL_UNPACK_ALIGNMENT = Enumerant('GL_UNPACK_ALIGNMENT', 0x0cf5, 'GL_VERSION_1_1')
GL_UNPACK_ALIGNMENT.esVersions = [2.0]
GL_UNPACK_LSB_FIRST = Enumerant('GL_UNPACK_LSB_FIRST', 0x0cf1, 'GL_VERSION_1_1')
GL_UNPACK_ROW_LENGTH = Enumerant('GL_UNPACK_ROW_LENGTH', 0x0cf2, 'GL_VERSION_1_1')
GL_UNPACK_SKIP_PIXELS = Enumerant('GL_UNPACK_SKIP_PIXELS', 0x0cf4, 'GL_VERSION_1_1')
GL_UNPACK_SKIP_ROWS = Enumerant('GL_UNPACK_SKIP_ROWS', 0x0cf3, 'GL_VERSION_1_1')
GL_UNPACK_SWAP_BYTES = Enumerant('GL_UNPACK_SWAP_BYTES', 0x0cf0, 'GL_VERSION_1_1')
GL_UNSIGNED_BYTE = Enumerant('GL_UNSIGNED_BYTE', 0x1401, 'GL_VERSION_1_1')
GL_UNSIGNED_BYTE.group = ['pathCoord']
GL_UNSIGNED_BYTE.esVersions = [2.0]
GL_UNSIGNED_INT = Enumerant('GL_UNSIGNED_INT', 0x1405, 'GL_VERSION_1_1')
GL_UNSIGNED_INT.esVersions = [2.0]
GL_UNSIGNED_SHORT = Enumerant('GL_UNSIGNED_SHORT', 0x1403, 'GL_VERSION_1_1')
GL_UNSIGNED_SHORT.group = ['pathCoord']
GL_UNSIGNED_SHORT.esVersions = [2.0]
GL_V2F = Enumerant('GL_V2F', 0x2a20, 'GL_VERSION_1_1')
GL_V3F = Enumerant('GL_V3F', 0x2a21, 'GL_VERSION_1_1')
GL_VENDOR = Enumerant('GL_VENDOR', 0x1f00, 'GL_VERSION_1_1')
GL_VENDOR.esVersions = [2.0]
GL_VERSION = Enumerant('GL_VERSION', 0x1f02, 'GL_VERSION_1_1')
GL_VERSION.esVersions = [2.0]
GL_VERTEX_ARRAY = Enumerant('GL_VERTEX_ARRAY', 0x8074, 'GL_VERSION_1_1')
GL_VERTEX_ARRAY_POINTER = Enumerant('GL_VERTEX_ARRAY_POINTER', 0x808e, 'GL_VERSION_1_1')
GL_VERTEX_ARRAY_SIZE = Enumerant('GL_VERTEX_ARRAY_SIZE', 0x807a, 'GL_VERSION_1_1')
GL_VERTEX_ARRAY_STRIDE = Enumerant('GL_VERTEX_ARRAY_STRIDE', 0x807c, 'GL_VERSION_1_1')
GL_VERTEX_ARRAY_TYPE = Enumerant('GL_VERTEX_ARRAY_TYPE', 0x807b, 'GL_VERSION_1_1')
GL_VIEWPORT = Enumerant('GL_VIEWPORT', 0x0ba2, 'GL_VERSION_1_1')
GL_VIEWPORT.esVersions = [2.0]
GL_VIEWPORT_BIT = Enumerant('GL_VIEWPORT_BIT', 0x0800, 'GL_VERSION_1_1')
GL_XOR = Enumerant('GL_XOR', 0x1506, 'GL_VERSION_1_1')
GL_ZERO = Enumerant('GL_ZERO', 0x0000, 'GL_VERSION_1_1')
GL_ZERO.esVersions = [2.0]
GL_ZOOM_X = Enumerant('GL_ZOOM_X', 0x0d16, 'GL_VERSION_1_1')
GL_ZOOM_Y = Enumerant('GL_ZOOM_Y', 0x0d17, 'GL_VERSION_1_1')

defines.add(GL_2D)
defines.add(GL_2_BYTES)
defines.add(GL_3D)
defines.add(GL_3D_COLOR)
defines.add(GL_3D_COLOR_TEXTURE)
defines.add(GL_3_BYTES)
defines.add(GL_4D_COLOR_TEXTURE)
defines.add(GL_4_BYTES)
defines.add(GL_ACCUM)
defines.add(GL_ACCUM_ALPHA_BITS)
defines.add(GL_ACCUM_BLUE_BITS)
defines.add(GL_ACCUM_BUFFER_BIT)
defines.add(GL_ACCUM_CLEAR_VALUE)
defines.add(GL_ACCUM_GREEN_BITS)
defines.add(GL_ACCUM_RED_BITS)
defines.add(GL_ADD)
defines.add(GL_ALL_ATTRIB_BITS)
defines.add(GL_ALPHA)
defines.add(GL_ALPHA12)
defines.add(GL_ALPHA16)
defines.add(GL_ALPHA4)
defines.add(GL_ALPHA8)
defines.add(GL_ALPHA_BIAS)
defines.add(GL_ALPHA_BITS)
defines.add(GL_ALPHA_SCALE)
defines.add(GL_ALPHA_TEST)
defines.add(GL_ALPHA_TEST_FUNC)
defines.add(GL_ALPHA_TEST_REF)
defines.add(GL_ALWAYS)
defines.add(GL_AMBIENT)
defines.add(GL_AMBIENT_AND_DIFFUSE)
defines.add(GL_AND)
defines.add(GL_AND_INVERTED)
defines.add(GL_AND_REVERSE)
defines.add(GL_ATTRIB_STACK_DEPTH)
defines.add(GL_AUTO_NORMAL)
defines.add(GL_AUX0)
defines.add(GL_AUX1)
defines.add(GL_AUX2)
defines.add(GL_AUX3)
defines.add(GL_AUX_BUFFERS)
defines.add(GL_BACK)
defines.add(GL_BACK_LEFT)
defines.add(GL_BACK_RIGHT)
defines.add(GL_BITMAP)
defines.add(GL_BITMAP_TOKEN)
defines.add(GL_BLEND)
defines.add(GL_BLEND_DST)
defines.add(GL_BLEND_SRC)
defines.add(GL_BLUE)
defines.add(GL_BLUE_BIAS)
defines.add(GL_BLUE_BITS)
defines.add(GL_BLUE_SCALE)
defines.add(GL_BYTE)
defines.add(GL_C3F_V3F)
defines.add(GL_C4F_N3F_V3F)
defines.add(GL_C4UB_V2F)
defines.add(GL_C4UB_V3F)
defines.add(GL_CCW)
defines.add(GL_CLAMP)
defines.add(GL_CLEAR)
defines.add(GL_CLIENT_ALL_ATTRIB_BITS)
defines.add(GL_CLIENT_ATTRIB_STACK_DEPTH)
defines.add(GL_CLIENT_PIXEL_STORE_BIT)
defines.add(GL_CLIENT_VERTEX_ARRAY_BIT)
defines.add(GL_CLIP_PLANE0)
defines.add(GL_CLIP_PLANE1)
defines.add(GL_CLIP_PLANE2)
defines.add(GL_CLIP_PLANE3)
defines.add(GL_CLIP_PLANE4)
defines.add(GL_CLIP_PLANE5)
defines.add(GL_CLIP_PLANE6)
defines.add(GL_CLIP_PLANE7)
defines.add(GL_COEFF)
defines.add(GL_COLOR)
defines.add(GL_COLOR_ARRAY)
defines.add(GL_COLOR_ARRAY_POINTER)
defines.add(GL_COLOR_ARRAY_SIZE)
defines.add(GL_COLOR_ARRAY_STRIDE)
defines.add(GL_COLOR_ARRAY_TYPE)
defines.add(GL_COLOR_BUFFER_BIT)
defines.add(GL_COLOR_CLEAR_VALUE)
defines.add(GL_COLOR_INDEX)
defines.add(GL_COLOR_INDEXES)
defines.add(GL_COLOR_LOGIC_OP)
defines.add(GL_COLOR_MATERIAL)
defines.add(GL_COLOR_MATERIAL_FACE)
defines.add(GL_COLOR_MATERIAL_PARAMETER)
defines.add(GL_COLOR_WRITEMASK)
defines.add(GL_COMPILE)
defines.add(GL_COMPILE_AND_EXECUTE)
defines.add(GL_CONSTANT_ATTENUATION)
defines.add(GL_COPY)
defines.add(GL_COPY_INVERTED)
defines.add(GL_COPY_PIXEL_TOKEN)
defines.add(GL_CULL_FACE)
defines.add(GL_CULL_FACE_MODE)
defines.add(GL_CURRENT_BIT)
defines.add(GL_CURRENT_COLOR)
defines.add(GL_CURRENT_INDEX)
defines.add(GL_CURRENT_NORMAL)
defines.add(GL_CURRENT_RASTER_COLOR)
defines.add(GL_CURRENT_RASTER_DISTANCE)
defines.add(GL_CURRENT_RASTER_INDEX)
defines.add(GL_CURRENT_RASTER_POSITION)
defines.add(GL_CURRENT_RASTER_POSITION_VALID)
defines.add(GL_CURRENT_RASTER_TEXTURE_COORDS)
defines.add(GL_CURRENT_TEXTURE_COORDS)
defines.add(GL_CW)
defines.add(GL_DECAL)
defines.add(GL_DECR)
defines.add(GL_DEPTH)
defines.add(GL_DEPTH_BIAS)
defines.add(GL_DEPTH_BITS)
defines.add(GL_DEPTH_BUFFER_BIT)
defines.add(GL_DEPTH_CLEAR_VALUE)
defines.add(GL_DEPTH_COMPONENT)
defines.add(GL_DEPTH_FUNC)
defines.add(GL_DEPTH_RANGE)
defines.add(GL_DEPTH_SCALE)
defines.add(GL_DEPTH_TEST)
defines.add(GL_DEPTH_WRITEMASK)
defines.add(GL_DIFFUSE)
defines.add(GL_DITHER)
defines.add(GL_DOMAIN)
defines.add(GL_DONT_CARE)
defines.add(GL_DOUBLE)
defines.add(GL_DOUBLEBUFFER)
defines.add(GL_DRAW_BUFFER)
defines.add(GL_DRAW_PIXEL_TOKEN)
defines.add(GL_DST_ALPHA)
defines.add(GL_DST_COLOR)
defines.add(GL_EDGE_FLAG)
defines.add(GL_EDGE_FLAG_ARRAY)
defines.add(GL_EDGE_FLAG_ARRAY_POINTER)
defines.add(GL_EDGE_FLAG_ARRAY_STRIDE)
defines.add(GL_EMISSION)
defines.add(GL_ENABLE_BIT)
defines.add(GL_EQUAL)
defines.add(GL_EQUIV)
defines.add(GL_EVAL_BIT)
defines.add(GL_EXP)
defines.add(GL_EXP2)
defines.add(GL_EXTENSIONS)
defines.add(GL_EYE_LINEAR)
defines.add(GL_EYE_PLANE)
defines.add(GL_FALSE)
defines.add(GL_FASTEST)
defines.add(GL_FEEDBACK)
defines.add(GL_FEEDBACK_BUFFER_POINTER)
defines.add(GL_FEEDBACK_BUFFER_SIZE)
defines.add(GL_FEEDBACK_BUFFER_TYPE)
defines.add(GL_FILL)
defines.add(GL_FLAT)
defines.add(GL_FLOAT)
defines.add(GL_FOG)
defines.add(GL_FOG_BIT)
defines.add(GL_FOG_COLOR)
defines.add(GL_FOG_DENSITY)
defines.add(GL_FOG_END)
defines.add(GL_FOG_HINT)
defines.add(GL_FOG_INDEX)
defines.add(GL_FOG_MODE)
defines.add(GL_FOG_START)
defines.add(GL_FRONT)
defines.add(GL_FRONT_AND_BACK)
defines.add(GL_FRONT_FACE)
defines.add(GL_FRONT_LEFT)
defines.add(GL_FRONT_RIGHT)
defines.add(GL_GEQUAL)
defines.add(GL_GREATER)
defines.add(GL_GREEN)
defines.add(GL_GREEN_BIAS)
defines.add(GL_GREEN_BITS)
defines.add(GL_GREEN_SCALE)
defines.add(GL_HINT_BIT)
defines.add(GL_INCR)
defines.add(GL_INDEX_ARRAY)
defines.add(GL_INDEX_ARRAY_POINTER)
defines.add(GL_INDEX_ARRAY_STRIDE)
defines.add(GL_INDEX_ARRAY_TYPE)
defines.add(GL_INDEX_BITS)
defines.add(GL_INDEX_CLEAR_VALUE)
defines.add(GL_INDEX_LOGIC_OP)
defines.add(GL_INDEX_MODE)
defines.add(GL_INDEX_OFFSET)
defines.add(GL_INDEX_SHIFT)
defines.add(GL_INDEX_WRITEMASK)
defines.add(GL_INT)
defines.add(GL_INTENSITY)
defines.add(GL_INTENSITY12)
defines.add(GL_INTENSITY16)
defines.add(GL_INTENSITY4)
defines.add(GL_INTENSITY8)
defines.add(GL_INVALID_ENUM)
defines.add(GL_INVALID_OPERATION)
defines.add(GL_INVALID_VALUE)
defines.add(GL_INVERT)
defines.add(GL_KEEP)
defines.add(GL_LEFT)
defines.add(GL_LEQUAL)
defines.add(GL_LESS)
defines.add(GL_LIGHT0)
defines.add(GL_LIGHT1)
defines.add(GL_LIGHT2)
defines.add(GL_LIGHT3)
defines.add(GL_LIGHT4)
defines.add(GL_LIGHT5)
defines.add(GL_LIGHT6)
defines.add(GL_LIGHT7)
defines.add(GL_LIGHTING)
defines.add(GL_LIGHTING_BIT)
defines.add(GL_LIGHT_MODEL_AMBIENT)
defines.add(GL_LIGHT_MODEL_LOCAL_VIEWER)
defines.add(GL_LIGHT_MODEL_TWO_SIDE)
defines.add(GL_LINE)
defines.add(GL_LINEAR)
defines.add(GL_LINEAR_ATTENUATION)
defines.add(GL_LINEAR_MIPMAP_LINEAR)
defines.add(GL_LINEAR_MIPMAP_NEAREST)
defines.add(GL_LINES)
defines.add(GL_LINE_BIT)
defines.add(GL_LINE_LOOP)
defines.add(GL_LINE_RESET_TOKEN)
defines.add(GL_LINE_SMOOTH)
defines.add(GL_LINE_SMOOTH_HINT)
defines.add(GL_LINE_STIPPLE)
defines.add(GL_LINE_STIPPLE_PATTERN)
defines.add(GL_LINE_STIPPLE_REPEAT)
defines.add(GL_LINE_STRIP)
defines.add(GL_LINE_TOKEN)
defines.add(GL_LINE_WIDTH)
defines.add(GL_LINE_WIDTH_GRANULARITY)
defines.add(GL_LINE_WIDTH_RANGE)
defines.add(GL_LIST_BASE)
defines.add(GL_LIST_BIT)
defines.add(GL_LIST_INDEX)
defines.add(GL_LIST_MODE)
defines.add(GL_LOAD)
defines.add(GL_LOGIC_OP)
defines.add(GL_LOGIC_OP_MODE)
defines.add(GL_LUMINANCE)
defines.add(GL_LUMINANCE12)
defines.add(GL_LUMINANCE12_ALPHA12)
defines.add(GL_LUMINANCE12_ALPHA4)
defines.add(GL_LUMINANCE16)
defines.add(GL_LUMINANCE16_ALPHA16)
defines.add(GL_LUMINANCE4)
defines.add(GL_LUMINANCE4_ALPHA4)
defines.add(GL_LUMINANCE6_ALPHA2)
defines.add(GL_LUMINANCE8)
defines.add(GL_LUMINANCE8_ALPHA8)
defines.add(GL_LUMINANCE_ALPHA)
defines.add(GL_MAP1_COLOR_4)
defines.add(GL_MAP1_GRID_DOMAIN)
defines.add(GL_MAP1_GRID_SEGMENTS)
defines.add(GL_MAP1_INDEX)
defines.add(GL_MAP1_NORMAL)
defines.add(GL_MAP1_TEXTURE_COORD_1)
defines.add(GL_MAP1_TEXTURE_COORD_2)
defines.add(GL_MAP1_TEXTURE_COORD_3)
defines.add(GL_MAP1_TEXTURE_COORD_4)
defines.add(GL_MAP1_VERTEX_3)
defines.add(GL_MAP1_VERTEX_4)
defines.add(GL_MAP2_COLOR_4)
defines.add(GL_MAP2_GRID_DOMAIN)
defines.add(GL_MAP2_GRID_SEGMENTS)
defines.add(GL_MAP2_INDEX)
defines.add(GL_MAP2_NORMAL)
defines.add(GL_MAP2_TEXTURE_COORD_1)
defines.add(GL_MAP2_TEXTURE_COORD_2)
defines.add(GL_MAP2_TEXTURE_COORD_3)
defines.add(GL_MAP2_TEXTURE_COORD_4)
defines.add(GL_MAP2_VERTEX_3)
defines.add(GL_MAP2_VERTEX_4)
defines.add(GL_MAP_COLOR)
defines.add(GL_MAP_STENCIL)
defines.add(GL_MATRIX_MODE)
defines.add(GL_MAX_ATTRIB_STACK_DEPTH)
defines.add(GL_MAX_CLIENT_ATTRIB_STACK_DEPTH)
defines.add(GL_MAX_CLIP_PLANES)
defines.add(GL_MAX_EVAL_ORDER)
defines.add(GL_MAX_LIGHTS)
defines.add(GL_MAX_LIST_NESTING)
defines.add(GL_MAX_MODELVIEW_STACK_DEPTH)
defines.add(GL_MAX_NAME_STACK_DEPTH)
defines.add(GL_MAX_PIXEL_MAP_TABLE)
defines.add(GL_MAX_PROJECTION_STACK_DEPTH)
defines.add(GL_MAX_TEXTURE_SIZE)
defines.add(GL_MAX_TEXTURE_STACK_DEPTH)
defines.add(GL_MAX_VIEWPORT_DIMS)
defines.add(GL_MODELVIEW)
defines.add(GL_MODELVIEW_MATRIX)
defines.add(GL_MODELVIEW_STACK_DEPTH)
defines.add(GL_MODULATE)
defines.add(GL_MULT)
defines.add(GL_N3F_V3F)
defines.add(GL_NAME_STACK_DEPTH)
defines.add(GL_NAND)
defines.add(GL_NEAREST)
defines.add(GL_NEAREST_MIPMAP_LINEAR)
defines.add(GL_NEAREST_MIPMAP_NEAREST)
defines.add(GL_NEVER)
defines.add(GL_NICEST)
defines.add(GL_NONE)
defines.add(GL_NOOP)
defines.add(GL_NOR)
defines.add(GL_NORMALIZE)
defines.add(GL_NORMAL_ARRAY)
defines.add(GL_NORMAL_ARRAY_POINTER)
defines.add(GL_NORMAL_ARRAY_STRIDE)
defines.add(GL_NORMAL_ARRAY_TYPE)
defines.add(GL_NOTEQUAL)
defines.add(GL_NO_ERROR)
defines.add(GL_OBJECT_LINEAR)
defines.add(GL_OBJECT_PLANE)
defines.add(GL_ONE)
defines.add(GL_ONE_MINUS_DST_ALPHA)
defines.add(GL_ONE_MINUS_DST_COLOR)
defines.add(GL_ONE_MINUS_SRC_ALPHA)
defines.add(GL_ONE_MINUS_SRC_COLOR)
defines.add(GL_OR)
defines.add(GL_ORDER)
defines.add(GL_OR_INVERTED)
defines.add(GL_OR_REVERSE)
defines.add(GL_OUT_OF_MEMORY)
defines.add(GL_PACK_ALIGNMENT)
defines.add(GL_PACK_LSB_FIRST)
defines.add(GL_PACK_ROW_LENGTH)
defines.add(GL_PACK_SKIP_PIXELS)
defines.add(GL_PACK_SKIP_ROWS)
defines.add(GL_PACK_SWAP_BYTES)
defines.add(GL_PASS_THROUGH_TOKEN)
defines.add(GL_PERSPECTIVE_CORRECTION_HINT)
defines.add(GL_PIXEL_MAP_A_TO_A)
defines.add(GL_PIXEL_MAP_A_TO_A_SIZE)
defines.add(GL_PIXEL_MAP_B_TO_B)
defines.add(GL_PIXEL_MAP_B_TO_B_SIZE)
defines.add(GL_PIXEL_MAP_G_TO_G)
defines.add(GL_PIXEL_MAP_G_TO_G_SIZE)
defines.add(GL_PIXEL_MAP_I_TO_A)
defines.add(GL_PIXEL_MAP_I_TO_A_SIZE)
defines.add(GL_PIXEL_MAP_I_TO_B)
defines.add(GL_PIXEL_MAP_I_TO_B_SIZE)
defines.add(GL_PIXEL_MAP_I_TO_G)
defines.add(GL_PIXEL_MAP_I_TO_G_SIZE)
defines.add(GL_PIXEL_MAP_I_TO_I)
defines.add(GL_PIXEL_MAP_I_TO_I_SIZE)
defines.add(GL_PIXEL_MAP_I_TO_R)
defines.add(GL_PIXEL_MAP_I_TO_R_SIZE)
defines.add(GL_PIXEL_MAP_R_TO_R)
defines.add(GL_PIXEL_MAP_R_TO_R_SIZE)
defines.add(GL_PIXEL_MAP_S_TO_S)
defines.add(GL_PIXEL_MAP_S_TO_S_SIZE)
defines.add(GL_PIXEL_MODE_BIT)
defines.add(GL_POINT)
defines.add(GL_POINTS)
defines.add(GL_POINT_BIT)
defines.add(GL_POINT_SIZE)
defines.add(GL_POINT_SIZE_GRANULARITY)
defines.add(GL_POINT_SIZE_RANGE)
defines.add(GL_POINT_SMOOTH)
defines.add(GL_POINT_SMOOTH_HINT)
defines.add(GL_POINT_TOKEN)
defines.add(GL_POLYGON)
defines.add(GL_POLYGON_BIT)
defines.add(GL_POLYGON_MODE)
defines.add(GL_POLYGON_OFFSET_FACTOR)
defines.add(GL_POLYGON_OFFSET_FILL)
defines.add(GL_POLYGON_OFFSET_LINE)
defines.add(GL_POLYGON_OFFSET_POINT)
defines.add(GL_POLYGON_OFFSET_UNITS)
defines.add(GL_POLYGON_SMOOTH)
defines.add(GL_POLYGON_SMOOTH_HINT)
defines.add(GL_POLYGON_STIPPLE)
defines.add(GL_POLYGON_STIPPLE_BIT)
defines.add(GL_POLYGON_TOKEN)
defines.add(GL_POSITION)
defines.add(GL_PROJECTION)
defines.add(GL_PROJECTION_MATRIX)
defines.add(GL_PROJECTION_STACK_DEPTH)
defines.add(GL_PROXY_TEXTURE_1D)
defines.add(GL_PROXY_TEXTURE_2D)
defines.add(GL_Q)
defines.add(GL_QUADRATIC_ATTENUATION)
defines.add(GL_QUADS)
defines.add(GL_QUAD_STRIP)
defines.add(GL_R)
defines.add(GL_R3_G3_B2)
defines.add(GL_READ_BUFFER)
defines.add(GL_RED)
defines.add(GL_RED_BIAS)
defines.add(GL_RED_BITS)
defines.add(GL_RED_SCALE)
defines.add(GL_RENDER)
defines.add(GL_RENDERER)
defines.add(GL_RENDER_MODE)
defines.add(GL_REPEAT)
defines.add(GL_REPLACE)
defines.add(GL_RETURN)
defines.add(GL_RGB)
defines.add(GL_RGB10)
defines.add(GL_RGB10_A2)
defines.add(GL_RGB12)
defines.add(GL_RGB16)
defines.add(GL_RGB4)
defines.add(GL_RGB5)
defines.add(GL_RGB5_A1)
defines.add(GL_RGB8)
defines.add(GL_RGBA)
defines.add(GL_RGBA12)
defines.add(GL_RGBA16)
defines.add(GL_RGBA2)
defines.add(GL_RGBA4)
defines.add(GL_RGBA8)
defines.add(GL_RGBA_MODE)
defines.add(GL_RIGHT)
defines.add(GL_S)
defines.add(GL_SCISSOR_BIT)
defines.add(GL_SCISSOR_BOX)
defines.add(GL_SCISSOR_TEST)
defines.add(GL_SELECT)
defines.add(GL_SELECTION_BUFFER_POINTER)
defines.add(GL_SELECTION_BUFFER_SIZE)
defines.add(GL_SET)
defines.add(GL_SHADE_MODEL)
defines.add(GL_SHININESS)
defines.add(GL_SHORT)
defines.add(GL_SMOOTH)
defines.add(GL_SPECULAR)
defines.add(GL_SPHERE_MAP)
defines.add(GL_SPOT_CUTOFF)
defines.add(GL_SPOT_DIRECTION)
defines.add(GL_SPOT_EXPONENT)
defines.add(GL_SRC_ALPHA)
defines.add(GL_SRC_ALPHA_SATURATE)
defines.add(GL_SRC_COLOR)
defines.add(GL_STACK_OVERFLOW)
defines.add(GL_STACK_UNDERFLOW)
defines.add(GL_STENCIL)
defines.add(GL_STENCIL_BITS)
defines.add(GL_STENCIL_BUFFER_BIT)
defines.add(GL_STENCIL_CLEAR_VALUE)
defines.add(GL_STENCIL_FAIL)
defines.add(GL_STENCIL_FUNC)
defines.add(GL_STENCIL_INDEX)
defines.add(GL_STENCIL_PASS_DEPTH_FAIL)
defines.add(GL_STENCIL_PASS_DEPTH_PASS)
defines.add(GL_STENCIL_REF)
defines.add(GL_STENCIL_TEST)
defines.add(GL_STENCIL_VALUE_MASK)
defines.add(GL_STENCIL_WRITEMASK)
defines.add(GL_STEREO)
defines.add(GL_SUBPIXEL_BITS)
defines.add(GL_T)
defines.add(GL_T2F_C3F_V3F)
defines.add(GL_T2F_C4F_N3F_V3F)
defines.add(GL_T2F_C4UB_V3F)
defines.add(GL_T2F_N3F_V3F)
defines.add(GL_T2F_V3F)
defines.add(GL_T4F_C4F_N3F_V4F)
defines.add(GL_T4F_V4F)
defines.add(GL_TEXTURE)
defines.add(GL_TEXTURE_1D)
defines.add(GL_TEXTURE_2D)
defines.add(GL_TEXTURE_ALPHA_SIZE)
defines.add(GL_TEXTURE_BINDING_1D)
defines.add(GL_TEXTURE_BINDING_2D)
defines.add(GL_TEXTURE_BIT)
defines.add(GL_TEXTURE_BLUE_SIZE)
defines.add(GL_TEXTURE_BORDER)
defines.add(GL_TEXTURE_BORDER_COLOR)
defines.add(GL_TEXTURE_COMPONENTS)
defines.add(GL_TEXTURE_COORD_ARRAY)
defines.add(GL_TEXTURE_COORD_ARRAY_POINTER)
defines.add(GL_TEXTURE_COORD_ARRAY_SIZE)
defines.add(GL_TEXTURE_COORD_ARRAY_STRIDE)
defines.add(GL_TEXTURE_COORD_ARRAY_TYPE)
defines.add(GL_TEXTURE_ENV)
defines.add(GL_TEXTURE_ENV_COLOR)
defines.add(GL_TEXTURE_ENV_MODE)
defines.add(GL_TEXTURE_GEN_MODE)
defines.add(GL_TEXTURE_GEN_Q)
defines.add(GL_TEXTURE_GEN_R)
defines.add(GL_TEXTURE_GEN_S)
defines.add(GL_TEXTURE_GEN_T)
defines.add(GL_TEXTURE_GREEN_SIZE)
defines.add(GL_TEXTURE_HEIGHT)
defines.add(GL_TEXTURE_INTENSITY_SIZE)
defines.add(GL_TEXTURE_INTERNAL_FORMAT)
defines.add(GL_TEXTURE_LUMINANCE_SIZE)
defines.add(GL_TEXTURE_MAG_FILTER)
defines.add(GL_TEXTURE_MATRIX)
defines.add(GL_TEXTURE_MIN_FILTER)
defines.add(GL_TEXTURE_PRIORITY)
defines.add(GL_TEXTURE_RED_SIZE)
defines.add(GL_TEXTURE_RESIDENT)
defines.add(GL_TEXTURE_STACK_DEPTH)
defines.add(GL_TEXTURE_WIDTH)
defines.add(GL_TEXTURE_WRAP_S)
defines.add(GL_TEXTURE_WRAP_T)
defines.add(GL_TRANSFORM_BIT)
defines.add(GL_TRIANGLES)
defines.add(GL_TRIANGLE_FAN)
defines.add(GL_TRIANGLE_STRIP)
defines.add(GL_TRUE)
defines.add(GL_UNPACK_ALIGNMENT)
defines.add(GL_UNPACK_LSB_FIRST)
defines.add(GL_UNPACK_ROW_LENGTH)
defines.add(GL_UNPACK_SKIP_PIXELS)
defines.add(GL_UNPACK_SKIP_ROWS)
defines.add(GL_UNPACK_SWAP_BYTES)
defines.add(GL_UNSIGNED_BYTE)
defines.add(GL_UNSIGNED_INT)
defines.add(GL_UNSIGNED_SHORT)
defines.add(GL_V2F)
defines.add(GL_V3F)
defines.add(GL_VENDOR)
defines.add(GL_VERSION)
defines.add(GL_VERTEX_ARRAY)
defines.add(GL_VERTEX_ARRAY_POINTER)
defines.add(GL_VERTEX_ARRAY_SIZE)
defines.add(GL_VERTEX_ARRAY_STRIDE)
defines.add(GL_VERTEX_ARRAY_TYPE)
defines.add(GL_VIEWPORT)
defines.add(GL_VIEWPORT_BIT)
defines.add(GL_XOR)
defines.add(GL_ZERO)
defines.add(GL_ZOOM_X)
defines.add(GL_ZOOM_Y)

# GL_VERSION_1_2

GL_ALIASED_LINE_WIDTH_RANGE = Enumerant('GL_ALIASED_LINE_WIDTH_RANGE', 0x846e, 'GL_VERSION_1_2')
GL_ALIASED_LINE_WIDTH_RANGE.esVersions = [2.0]
GL_ALIASED_POINT_SIZE_RANGE = Enumerant('GL_ALIASED_POINT_SIZE_RANGE', 0x846d, 'GL_VERSION_1_2')
GL_ALIASED_POINT_SIZE_RANGE.esVersions = [2.0]
GL_BGR = Enumerant('GL_BGR', 0x80e0, 'GL_VERSION_1_2')
GL_BGRA = Enumerant('GL_BGRA', 0x80e1, 'GL_VERSION_1_2')
GL_CLAMP_TO_EDGE = Enumerant('GL_CLAMP_TO_EDGE', 0x812f, 'GL_VERSION_1_2')
GL_CLAMP_TO_EDGE.esVersions = [2.0]
GL_LIGHT_MODEL_COLOR_CONTROL = Enumerant('GL_LIGHT_MODEL_COLOR_CONTROL', 0x81f8, 'GL_VERSION_1_2')
GL_MAX_3D_TEXTURE_SIZE = Enumerant('GL_MAX_3D_TEXTURE_SIZE', 0x8073, 'GL_VERSION_1_2')
GL_MAX_ELEMENTS_INDICES = Enumerant('GL_MAX_ELEMENTS_INDICES', 0x80e9, 'GL_VERSION_1_2')
GL_MAX_ELEMENTS_VERTICES = Enumerant('GL_MAX_ELEMENTS_VERTICES', 0x80e8, 'GL_VERSION_1_2')
GL_PACK_IMAGE_HEIGHT = Enumerant('GL_PACK_IMAGE_HEIGHT', 0x806c, 'GL_VERSION_1_2')
GL_PACK_SKIP_IMAGES = Enumerant('GL_PACK_SKIP_IMAGES', 0x806b, 'GL_VERSION_1_2')
GL_PROXY_TEXTURE_3D = Enumerant('GL_PROXY_TEXTURE_3D', 0x8070, 'GL_VERSION_1_2')
GL_RESCALE_NORMAL = Enumerant('GL_RESCALE_NORMAL', 0x803a, 'GL_VERSION_1_2')
GL_RESCALE_NORMAL.enableCap = True
GL_SEPARATE_SPECULAR_COLOR = Enumerant('GL_SEPARATE_SPECULAR_COLOR', 0x81fa, 'GL_VERSION_1_2')
GL_SINGLE_COLOR = Enumerant('GL_SINGLE_COLOR', 0x81f9, 'GL_VERSION_1_2')
GL_SMOOTH_LINE_WIDTH_GRANULARITY = Enumerant('GL_SMOOTH_LINE_WIDTH_GRANULARITY', 0x0b23, 'GL_VERSION_1_2')
GL_SMOOTH_LINE_WIDTH_RANGE = Enumerant('GL_SMOOTH_LINE_WIDTH_RANGE', 0x0b22, 'GL_VERSION_1_2')
GL_SMOOTH_POINT_SIZE_GRANULARITY = Enumerant('GL_SMOOTH_POINT_SIZE_GRANULARITY', 0x0b13, 'GL_VERSION_1_2')
GL_SMOOTH_POINT_SIZE_RANGE = Enumerant('GL_SMOOTH_POINT_SIZE_RANGE', 0x0b12, 'GL_VERSION_1_2')
GL_TEXTURE_3D = Enumerant('GL_TEXTURE_3D', 0x806f, 'GL_VERSION_1_2')
GL_TEXTURE_BASE_LEVEL = Enumerant('GL_TEXTURE_BASE_LEVEL', 0x813c, 'GL_VERSION_1_2')
GL_TEXTURE_BINDING_3D = Enumerant('GL_TEXTURE_BINDING_3D', 0x806a, 'GL_VERSION_1_2')
GL_TEXTURE_DEPTH = Enumerant('GL_TEXTURE_DEPTH', 0x8071, 'GL_VERSION_1_2')
GL_TEXTURE_MAX_LEVEL = Enumerant('GL_TEXTURE_MAX_LEVEL', 0x813d, 'GL_VERSION_1_2')
GL_TEXTURE_MAX_LOD = Enumerant('GL_TEXTURE_MAX_LOD', 0x813b, 'GL_VERSION_1_2')
GL_TEXTURE_MIN_LOD = Enumerant('GL_TEXTURE_MIN_LOD', 0x813a, 'GL_VERSION_1_2')
GL_TEXTURE_WRAP_R = Enumerant('GL_TEXTURE_WRAP_R', 0x8072, 'GL_VERSION_1_2')
GL_UNPACK_IMAGE_HEIGHT = Enumerant('GL_UNPACK_IMAGE_HEIGHT', 0x806e, 'GL_VERSION_1_2')
GL_UNPACK_SKIP_IMAGES = Enumerant('GL_UNPACK_SKIP_IMAGES', 0x806d, 'GL_VERSION_1_2')
GL_UNSIGNED_BYTE_2_3_3_REV = Enumerant('GL_UNSIGNED_BYTE_2_3_3_REV', 0x8362, 'GL_VERSION_1_2')
GL_UNSIGNED_BYTE_3_3_2 = Enumerant('GL_UNSIGNED_BYTE_3_3_2', 0x8032, 'GL_VERSION_1_2')
GL_UNSIGNED_INT_10_10_10_2 = Enumerant('GL_UNSIGNED_INT_10_10_10_2', 0x8036, 'GL_VERSION_1_2')
GL_UNSIGNED_INT_2_10_10_10_REV = Enumerant('GL_UNSIGNED_INT_2_10_10_10_REV', 0x8368, 'GL_VERSION_1_2')
GL_UNSIGNED_INT_8_8_8_8 = Enumerant('GL_UNSIGNED_INT_8_8_8_8', 0x8035, 'GL_VERSION_1_2')
GL_UNSIGNED_INT_8_8_8_8_REV = Enumerant('GL_UNSIGNED_INT_8_8_8_8_REV', 0x8367, 'GL_VERSION_1_2')
GL_UNSIGNED_SHORT_1_5_5_5_REV = Enumerant('GL_UNSIGNED_SHORT_1_5_5_5_REV', 0x8366, 'GL_VERSION_1_2')
GL_UNSIGNED_SHORT_4_4_4_4 = Enumerant('GL_UNSIGNED_SHORT_4_4_4_4', 0x8033, 'GL_VERSION_1_2')
GL_UNSIGNED_SHORT_4_4_4_4.esVersions = [2.0]
GL_UNSIGNED_SHORT_4_4_4_4_REV = Enumerant('GL_UNSIGNED_SHORT_4_4_4_4_REV', 0x8365, 'GL_VERSION_1_2')
GL_UNSIGNED_SHORT_5_5_5_1 = Enumerant('GL_UNSIGNED_SHORT_5_5_5_1', 0x8034, 'GL_VERSION_1_2')
GL_UNSIGNED_SHORT_5_5_5_1.esVersions = [2.0]
GL_UNSIGNED_SHORT_5_6_5 = Enumerant('GL_UNSIGNED_SHORT_5_6_5', 0x8363, 'GL_VERSION_1_2')
GL_UNSIGNED_SHORT_5_6_5.esVersions = [2.0]
GL_UNSIGNED_SHORT_5_6_5_REV = Enumerant('GL_UNSIGNED_SHORT_5_6_5_REV', 0x8364, 'GL_VERSION_1_2')

defines.add(GL_ALIASED_LINE_WIDTH_RANGE)
defines.add(GL_ALIASED_POINT_SIZE_RANGE)
defines.add(GL_BGR)
defines.add(GL_BGRA)
defines.add(GL_CLAMP_TO_EDGE)
defines.add(GL_LIGHT_MODEL_COLOR_CONTROL)
defines.add(GL_MAX_3D_TEXTURE_SIZE)
defines.add(GL_MAX_ELEMENTS_INDICES)
defines.add(GL_MAX_ELEMENTS_VERTICES)
defines.add(GL_PACK_IMAGE_HEIGHT)
defines.add(GL_PACK_SKIP_IMAGES)
defines.add(GL_PROXY_TEXTURE_3D)
defines.add(GL_RESCALE_NORMAL)
defines.add(GL_SEPARATE_SPECULAR_COLOR)
defines.add(GL_SINGLE_COLOR)
defines.add(GL_SMOOTH_LINE_WIDTH_GRANULARITY)
defines.add(GL_SMOOTH_LINE_WIDTH_RANGE)
defines.add(GL_SMOOTH_POINT_SIZE_GRANULARITY)
defines.add(GL_SMOOTH_POINT_SIZE_RANGE)
defines.add(GL_TEXTURE_3D)
defines.add(GL_TEXTURE_BASE_LEVEL)
defines.add(GL_TEXTURE_BINDING_3D)
defines.add(GL_TEXTURE_DEPTH)
defines.add(GL_TEXTURE_MAX_LEVEL)
defines.add(GL_TEXTURE_MAX_LOD)
defines.add(GL_TEXTURE_MIN_LOD)
defines.add(GL_TEXTURE_WRAP_R)
defines.add(GL_UNPACK_IMAGE_HEIGHT)
defines.add(GL_UNPACK_SKIP_IMAGES)
defines.add(GL_UNSIGNED_BYTE_2_3_3_REV)
defines.add(GL_UNSIGNED_BYTE_3_3_2)
defines.add(GL_UNSIGNED_INT_10_10_10_2)
defines.add(GL_UNSIGNED_INT_2_10_10_10_REV)
defines.add(GL_UNSIGNED_INT_8_8_8_8)
defines.add(GL_UNSIGNED_INT_8_8_8_8_REV)
defines.add(GL_UNSIGNED_SHORT_1_5_5_5_REV)
defines.add(GL_UNSIGNED_SHORT_4_4_4_4)
defines.add(GL_UNSIGNED_SHORT_4_4_4_4_REV)
defines.add(GL_UNSIGNED_SHORT_5_5_5_1)
defines.add(GL_UNSIGNED_SHORT_5_6_5)
defines.add(GL_UNSIGNED_SHORT_5_6_5_REV)

# GL_VERSION_1_3

GL_ACTIVE_TEXTURE = Enumerant('GL_ACTIVE_TEXTURE', 0x84e0, 'GL_VERSION_1_3')
GL_ACTIVE_TEXTURE.esVersions = [2.0]
GL_ADD_SIGNED = Enumerant('GL_ADD_SIGNED', 0x8574, 'GL_VERSION_1_3')
GL_CLAMP_TO_BORDER = Enumerant('GL_CLAMP_TO_BORDER', 0x812d, 'GL_VERSION_1_3')
GL_CLIENT_ACTIVE_TEXTURE = Enumerant('GL_CLIENT_ACTIVE_TEXTURE', 0x84e1, 'GL_VERSION_1_3')
GL_COMBINE = Enumerant('GL_COMBINE', 0x8570, 'GL_VERSION_1_3')
GL_COMBINE_ALPHA = Enumerant('GL_COMBINE_ALPHA', 0x8572, 'GL_VERSION_1_3')
GL_COMBINE_RGB = Enumerant('GL_COMBINE_RGB', 0x8571, 'GL_VERSION_1_3')
GL_COMPRESSED_ALPHA = Enumerant('GL_COMPRESSED_ALPHA', 0x84e9, 'GL_VERSION_1_3')
GL_COMPRESSED_INTENSITY = Enumerant('GL_COMPRESSED_INTENSITY', 0x84ec, 'GL_VERSION_1_3')
GL_COMPRESSED_LUMINANCE = Enumerant('GL_COMPRESSED_LUMINANCE', 0x84ea, 'GL_VERSION_1_3')
GL_COMPRESSED_LUMINANCE_ALPHA = Enumerant('GL_COMPRESSED_LUMINANCE_ALPHA', 0x84eb, 'GL_VERSION_1_3')
GL_COMPRESSED_RGB = Enumerant('GL_COMPRESSED_RGB', 0x84ed, 'GL_VERSION_1_3')
GL_COMPRESSED_RGBA = Enumerant('GL_COMPRESSED_RGBA', 0x84ee, 'GL_VERSION_1_3')
GL_COMPRESSED_TEXTURE_FORMATS = Enumerant('GL_COMPRESSED_TEXTURE_FORMATS', 0x86a3, 'GL_VERSION_1_3')
GL_COMPRESSED_TEXTURE_FORMATS.esVersions = [2.0]
GL_CONSTANT = Enumerant('GL_CONSTANT', 0x8576, 'GL_VERSION_1_3')
GL_DOT3_RGB = Enumerant('GL_DOT3_RGB', 0x86ae, 'GL_VERSION_1_3')
GL_DOT3_RGBA = Enumerant('GL_DOT3_RGBA', 0x86af, 'GL_VERSION_1_3')
GL_INTERPOLATE = Enumerant('GL_INTERPOLATE', 0x8575, 'GL_VERSION_1_3')
GL_MAX_CUBE_MAP_TEXTURE_SIZE = Enumerant('GL_MAX_CUBE_MAP_TEXTURE_SIZE', 0x851c, 'GL_VERSION_1_3')
GL_MAX_CUBE_MAP_TEXTURE_SIZE.esVersions = [2.0]
GL_MAX_TEXTURE_UNITS = Enumerant('GL_MAX_TEXTURE_UNITS', 0x84e2, 'GL_VERSION_1_3')
GL_MULTISAMPLE = Enumerant('GL_MULTISAMPLE', 0x809d, 'GL_VERSION_1_3')
GL_MULTISAMPLE.enableCap = True
GL_MULTISAMPLE_BIT = Enumerant('GL_MULTISAMPLE_BIT', 0x20000000, 'GL_VERSION_1_3')
GL_NORMAL_MAP = Enumerant('GL_NORMAL_MAP', 0x8511, 'GL_VERSION_1_3')
GL_NUM_COMPRESSED_TEXTURE_FORMATS = Enumerant('GL_NUM_COMPRESSED_TEXTURE_FORMATS', 0x86a2, 'GL_VERSION_1_3')
GL_NUM_COMPRESSED_TEXTURE_FORMATS.esVersions = [2.0]
GL_OPERAND0_ALPHA = Enumerant('GL_OPERAND0_ALPHA', 0x8598, 'GL_VERSION_1_3')
GL_OPERAND0_RGB = Enumerant('GL_OPERAND0_RGB', 0x8590, 'GL_VERSION_1_3')
GL_OPERAND1_ALPHA = Enumerant('GL_OPERAND1_ALPHA', 0x8599, 'GL_VERSION_1_3')
GL_OPERAND1_RGB = Enumerant('GL_OPERAND1_RGB', 0x8591, 'GL_VERSION_1_3')
GL_OPERAND2_ALPHA = Enumerant('GL_OPERAND2_ALPHA', 0x859a, 'GL_VERSION_1_3')
GL_OPERAND2_RGB = Enumerant('GL_OPERAND2_RGB', 0x8592, 'GL_VERSION_1_3')
GL_PREVIOUS = Enumerant('GL_PREVIOUS', 0x8578, 'GL_VERSION_1_3')
GL_PRIMARY_COLOR = Enumerant('GL_PRIMARY_COLOR', 0x8577, 'GL_VERSION_1_3')
GL_PROXY_TEXTURE_CUBE_MAP = Enumerant('GL_PROXY_TEXTURE_CUBE_MAP', 0x851b, 'GL_VERSION_1_3')
GL_REFLECTION_MAP = Enumerant('GL_REFLECTION_MAP', 0x8512, 'GL_VERSION_1_3')
GL_RGB_SCALE = Enumerant('GL_RGB_SCALE', 0x8573, 'GL_VERSION_1_3')
GL_SAMPLES = Enumerant('GL_SAMPLES', 0x80a9, 'GL_VERSION_1_3')
GL_SAMPLES.esVersions = [2.0]
GL_SAMPLE_ALPHA_TO_COVERAGE = Enumerant('GL_SAMPLE_ALPHA_TO_COVERAGE', 0x809e, 'GL_VERSION_1_3')
GL_SAMPLE_ALPHA_TO_COVERAGE.esVersions = [2.0]
GL_SAMPLE_ALPHA_TO_COVERAGE.enableCap = True
GL_SAMPLE_ALPHA_TO_ONE = Enumerant('GL_SAMPLE_ALPHA_TO_ONE', 0x809f, 'GL_VERSION_1_3')
GL_SAMPLE_ALPHA_TO_ONE.enableCap = True
GL_SAMPLE_BUFFERS = Enumerant('GL_SAMPLE_BUFFERS', 0x80a8, 'GL_VERSION_1_3')
GL_SAMPLE_BUFFERS.esVersions = [2.0]
GL_SAMPLE_COVERAGE = Enumerant('GL_SAMPLE_COVERAGE', 0x80a0, 'GL_VERSION_1_3')
GL_SAMPLE_COVERAGE.esVersions = [2.0]
GL_SAMPLE_COVERAGE.enableCap = True
GL_SAMPLE_COVERAGE_INVERT = Enumerant('GL_SAMPLE_COVERAGE_INVERT', 0x80ab, 'GL_VERSION_1_3')
GL_SAMPLE_COVERAGE_INVERT.esVersions = [2.0]
GL_SAMPLE_COVERAGE_VALUE = Enumerant('GL_SAMPLE_COVERAGE_VALUE', 0x80aa, 'GL_VERSION_1_3')
GL_SAMPLE_COVERAGE_VALUE.esVersions = [2.0]
GL_SOURCE0_ALPHA = Enumerant('GL_SOURCE0_ALPHA', 0x8588, 'GL_VERSION_1_3')
GL_SOURCE0_RGB = Enumerant('GL_SOURCE0_RGB', 0x8580, 'GL_VERSION_1_3')
GL_SOURCE1_ALPHA = Enumerant('GL_SOURCE1_ALPHA', 0x8589, 'GL_VERSION_1_3')
GL_SOURCE1_RGB = Enumerant('GL_SOURCE1_RGB', 0x8581, 'GL_VERSION_1_3')
GL_SOURCE2_ALPHA = Enumerant('GL_SOURCE2_ALPHA', 0x858a, 'GL_VERSION_1_3')
GL_SOURCE2_RGB = Enumerant('GL_SOURCE2_RGB', 0x8582, 'GL_VERSION_1_3')
GL_SUBTRACT = Enumerant('GL_SUBTRACT', 0x84e7, 'GL_VERSION_1_3')
GL_TEXTURE0 = Enumerant('GL_TEXTURE0', 0x84c0, 'GL_VERSION_1_3')
GL_TEXTURE0.esVersions = [2.0]
GL_TEXTURE1 = Enumerant('GL_TEXTURE1', 0x84c1, 'GL_VERSION_1_3')
GL_TEXTURE1.esVersions = [2.0]
GL_TEXTURE10 = Enumerant('GL_TEXTURE10', 0x84ca, 'GL_VERSION_1_3')
GL_TEXTURE10.esVersions = [2.0]
GL_TEXTURE11 = Enumerant('GL_TEXTURE11', 0x84cb, 'GL_VERSION_1_3')
GL_TEXTURE11.esVersions = [2.0]
GL_TEXTURE12 = Enumerant('GL_TEXTURE12', 0x84cc, 'GL_VERSION_1_3')
GL_TEXTURE12.esVersions = [2.0]
GL_TEXTURE13 = Enumerant('GL_TEXTURE13', 0x84cd, 'GL_VERSION_1_3')
GL_TEXTURE13.esVersions = [2.0]
GL_TEXTURE14 = Enumerant('GL_TEXTURE14', 0x84ce, 'GL_VERSION_1_3')
GL_TEXTURE14.esVersions = [2.0]
GL_TEXTURE15 = Enumerant('GL_TEXTURE15', 0x84cf, 'GL_VERSION_1_3')
GL_TEXTURE15.esVersions = [2.0]
GL_TEXTURE16 = Enumerant('GL_TEXTURE16', 0x84d0, 'GL_VERSION_1_3')
GL_TEXTURE16.esVersions = [2.0]
GL_TEXTURE17 = Enumerant('GL_TEXTURE17', 0x84d1, 'GL_VERSION_1_3')
GL_TEXTURE17.esVersions = [2.0]
GL_TEXTURE18 = Enumerant('GL_TEXTURE18', 0x84d2, 'GL_VERSION_1_3')
GL_TEXTURE18.esVersions = [2.0]
GL_TEXTURE19 = Enumerant('GL_TEXTURE19', 0x84d3, 'GL_VERSION_1_3')
GL_TEXTURE19.esVersions = [2.0]
GL_TEXTURE2 = Enumerant('GL_TEXTURE2', 0x84c2, 'GL_VERSION_1_3')
GL_TEXTURE2.esVersions = [2.0]
GL_TEXTURE20 = Enumerant('GL_TEXTURE20', 0x84d4, 'GL_VERSION_1_3')
GL_TEXTURE20.esVersions = [2.0]
GL_TEXTURE21 = Enumerant('GL_TEXTURE21', 0x84d5, 'GL_VERSION_1_3')
GL_TEXTURE21.esVersions = [2.0]
GL_TEXTURE22 = Enumerant('GL_TEXTURE22', 0x84d6, 'GL_VERSION_1_3')
GL_TEXTURE22.esVersions = [2.0]
GL_TEXTURE23 = Enumerant('GL_TEXTURE23', 0x84d7, 'GL_VERSION_1_3')
GL_TEXTURE23.esVersions = [2.0]
GL_TEXTURE24 = Enumerant('GL_TEXTURE24', 0x84d8, 'GL_VERSION_1_3')
GL_TEXTURE24.esVersions = [2.0]
GL_TEXTURE25 = Enumerant('GL_TEXTURE25', 0x84d9, 'GL_VERSION_1_3')
GL_TEXTURE25.esVersions = [2.0]
GL_TEXTURE26 = Enumerant('GL_TEXTURE26', 0x84da, 'GL_VERSION_1_3')
GL_TEXTURE26.esVersions = [2.0]
GL_TEXTURE27 = Enumerant('GL_TEXTURE27', 0x84db, 'GL_VERSION_1_3')
GL_TEXTURE27.esVersions = [2.0]
GL_TEXTURE28 = Enumerant('GL_TEXTURE28', 0x84dc, 'GL_VERSION_1_3')
GL_TEXTURE28.esVersions = [2.0]
GL_TEXTURE29 = Enumerant('GL_TEXTURE29', 0x84dd, 'GL_VERSION_1_3')
GL_TEXTURE29.esVersions = [2.0]
GL_TEXTURE3 = Enumerant('GL_TEXTURE3', 0x84c3, 'GL_VERSION_1_3')
GL_TEXTURE3.esVersions = [2.0]
GL_TEXTURE30 = Enumerant('GL_TEXTURE30', 0x84de, 'GL_VERSION_1_3')
GL_TEXTURE30.esVersions = [2.0]
GL_TEXTURE31 = Enumerant('GL_TEXTURE31', 0x84df, 'GL_VERSION_1_3')
GL_TEXTURE31.esVersions = [2.0]
GL_TEXTURE4 = Enumerant('GL_TEXTURE4', 0x84c4, 'GL_VERSION_1_3')
GL_TEXTURE4.esVersions = [2.0]
GL_TEXTURE5 = Enumerant('GL_TEXTURE5', 0x84c5, 'GL_VERSION_1_3')
GL_TEXTURE5.esVersions = [2.0]
GL_TEXTURE6 = Enumerant('GL_TEXTURE6', 0x84c6, 'GL_VERSION_1_3')
GL_TEXTURE6.esVersions = [2.0]
GL_TEXTURE7 = Enumerant('GL_TEXTURE7', 0x84c7, 'GL_VERSION_1_3')
GL_TEXTURE7.esVersions = [2.0]
GL_TEXTURE8 = Enumerant('GL_TEXTURE8', 0x84c8, 'GL_VERSION_1_3')
GL_TEXTURE8.esVersions = [2.0]
GL_TEXTURE9 = Enumerant('GL_TEXTURE9', 0x84c9, 'GL_VERSION_1_3')
GL_TEXTURE9.esVersions = [2.0]
GL_TEXTURE_BINDING_CUBE_MAP = Enumerant('GL_TEXTURE_BINDING_CUBE_MAP', 0x8514, 'GL_VERSION_1_3')
GL_TEXTURE_BINDING_CUBE_MAP.esVersions = [2.0]
GL_TEXTURE_COMPRESSED = Enumerant('GL_TEXTURE_COMPRESSED', 0x86a1, 'GL_VERSION_1_3')
GL_TEXTURE_COMPRESSED_IMAGE_SIZE = Enumerant('GL_TEXTURE_COMPRESSED_IMAGE_SIZE', 0x86a0, 'GL_VERSION_1_3')
GL_TEXTURE_COMPRESSION_HINT = Enumerant('GL_TEXTURE_COMPRESSION_HINT', 0x84ef, 'GL_VERSION_1_3')
GL_TEXTURE_CUBE_MAP = Enumerant('GL_TEXTURE_CUBE_MAP', 0x8513, 'GL_VERSION_1_3')
GL_TEXTURE_CUBE_MAP.esVersions = [2.0]
GL_TEXTURE_CUBE_MAP.bindTexture = True
GL_TEXTURE_CUBE_MAP_NEGATIVE_X = Enumerant('GL_TEXTURE_CUBE_MAP_NEGATIVE_X', 0x8516, 'GL_VERSION_1_3')
GL_TEXTURE_CUBE_MAP_NEGATIVE_X.esVersions = [2.0]
GL_TEXTURE_CUBE_MAP_NEGATIVE_X.texImage = True
GL_TEXTURE_CUBE_MAP_NEGATIVE_Y = Enumerant('GL_TEXTURE_CUBE_MAP_NEGATIVE_Y', 0x8518, 'GL_VERSION_1_3')
GL_TEXTURE_CUBE_MAP_NEGATIVE_Y.esVersions = [2.0]
GL_TEXTURE_CUBE_MAP_NEGATIVE_Y.texImage = True
GL_TEXTURE_CUBE_MAP_NEGATIVE_Z = Enumerant('GL_TEXTURE_CUBE_MAP_NEGATIVE_Z', 0x851a, 'GL_VERSION_1_3')
GL_TEXTURE_CUBE_MAP_NEGATIVE_Z.esVersions = [2.0]
GL_TEXTURE_CUBE_MAP_NEGATIVE_Z.texImage = True
GL_TEXTURE_CUBE_MAP_POSITIVE_X = Enumerant('GL_TEXTURE_CUBE_MAP_POSITIVE_X', 0x8515, 'GL_VERSION_1_3')
GL_TEXTURE_CUBE_MAP_POSITIVE_X.esVersions = [2.0]
GL_TEXTURE_CUBE_MAP_POSITIVE_X.texImage = True
GL_TEXTURE_CUBE_MAP_POSITIVE_Y = Enumerant('GL_TEXTURE_CUBE_MAP_POSITIVE_Y', 0x8517, 'GL_VERSION_1_3')
GL_TEXTURE_CUBE_MAP_POSITIVE_Y.esVersions = [2.0]
GL_TEXTURE_CUBE_MAP_POSITIVE_Y.texImage = True
GL_TEXTURE_CUBE_MAP_POSITIVE_Z = Enumerant('GL_TEXTURE_CUBE_MAP_POSITIVE_Z', 0x8519, 'GL_VERSION_1_3')
GL_TEXTURE_CUBE_MAP_POSITIVE_Z.esVersions = [2.0]
GL_TEXTURE_CUBE_MAP_POSITIVE_Z.texImage = True
GL_TRANSPOSE_COLOR_MATRIX = Enumerant('GL_TRANSPOSE_COLOR_MATRIX', 0x84e6, 'GL_VERSION_1_3')
GL_TRANSPOSE_MODELVIEW_MATRIX = Enumerant('GL_TRANSPOSE_MODELVIEW_MATRIX', 0x84e3, 'GL_VERSION_1_3')
GL_TRANSPOSE_PROJECTION_MATRIX = Enumerant('GL_TRANSPOSE_PROJECTION_MATRIX', 0x84e4, 'GL_VERSION_1_3')
GL_TRANSPOSE_TEXTURE_MATRIX = Enumerant('GL_TRANSPOSE_TEXTURE_MATRIX', 0x84e5, 'GL_VERSION_1_3')

defines.add(GL_ACTIVE_TEXTURE)
defines.add(GL_ADD_SIGNED)
defines.add(GL_CLAMP_TO_BORDER)
defines.add(GL_CLIENT_ACTIVE_TEXTURE)
defines.add(GL_COMBINE)
defines.add(GL_COMBINE_ALPHA)
defines.add(GL_COMBINE_RGB)
defines.add(GL_COMPRESSED_ALPHA)
defines.add(GL_COMPRESSED_INTENSITY)
defines.add(GL_COMPRESSED_LUMINANCE)
defines.add(GL_COMPRESSED_LUMINANCE_ALPHA)
defines.add(GL_COMPRESSED_RGB)
defines.add(GL_COMPRESSED_RGBA)
defines.add(GL_COMPRESSED_TEXTURE_FORMATS)
defines.add(GL_CONSTANT)
defines.add(GL_DOT3_RGB)
defines.add(GL_DOT3_RGBA)
defines.add(GL_INTERPOLATE)
defines.add(GL_MAX_CUBE_MAP_TEXTURE_SIZE)
defines.add(GL_MAX_TEXTURE_UNITS)
defines.add(GL_MULTISAMPLE)
defines.add(GL_MULTISAMPLE_BIT)
defines.add(GL_NORMAL_MAP)
defines.add(GL_NUM_COMPRESSED_TEXTURE_FORMATS)
defines.add(GL_OPERAND0_ALPHA)
defines.add(GL_OPERAND0_RGB)
defines.add(GL_OPERAND1_ALPHA)
defines.add(GL_OPERAND1_RGB)
defines.add(GL_OPERAND2_ALPHA)
defines.add(GL_OPERAND2_RGB)
defines.add(GL_PREVIOUS)
defines.add(GL_PRIMARY_COLOR)
defines.add(GL_PROXY_TEXTURE_CUBE_MAP)
defines.add(GL_REFLECTION_MAP)
defines.add(GL_RGB_SCALE)
defines.add(GL_SAMPLES)
defines.add(GL_SAMPLE_ALPHA_TO_COVERAGE)
defines.add(GL_SAMPLE_ALPHA_TO_ONE)
defines.add(GL_SAMPLE_BUFFERS)
defines.add(GL_SAMPLE_COVERAGE)
defines.add(GL_SAMPLE_COVERAGE_INVERT)
defines.add(GL_SAMPLE_COVERAGE_VALUE)
defines.add(GL_SOURCE0_ALPHA)
defines.add(GL_SOURCE0_RGB)
defines.add(GL_SOURCE1_ALPHA)
defines.add(GL_SOURCE1_RGB)
defines.add(GL_SOURCE2_ALPHA)
defines.add(GL_SOURCE2_RGB)
defines.add(GL_SUBTRACT)
defines.add(GL_TEXTURE0)
defines.add(GL_TEXTURE1)
defines.add(GL_TEXTURE10)
defines.add(GL_TEXTURE11)
defines.add(GL_TEXTURE12)
defines.add(GL_TEXTURE13)
defines.add(GL_TEXTURE14)
defines.add(GL_TEXTURE15)
defines.add(GL_TEXTURE16)
defines.add(GL_TEXTURE17)
defines.add(GL_TEXTURE18)
defines.add(GL_TEXTURE19)
defines.add(GL_TEXTURE2)
defines.add(GL_TEXTURE20)
defines.add(GL_TEXTURE21)
defines.add(GL_TEXTURE22)
defines.add(GL_TEXTURE23)
defines.add(GL_TEXTURE24)
defines.add(GL_TEXTURE25)
defines.add(GL_TEXTURE26)
defines.add(GL_TEXTURE27)
defines.add(GL_TEXTURE28)
defines.add(GL_TEXTURE29)
defines.add(GL_TEXTURE3)
defines.add(GL_TEXTURE30)
defines.add(GL_TEXTURE31)
defines.add(GL_TEXTURE4)
defines.add(GL_TEXTURE5)
defines.add(GL_TEXTURE6)
defines.add(GL_TEXTURE7)
defines.add(GL_TEXTURE8)
defines.add(GL_TEXTURE9)
defines.add(GL_TEXTURE_BINDING_CUBE_MAP)
defines.add(GL_TEXTURE_COMPRESSED)
defines.add(GL_TEXTURE_COMPRESSED_IMAGE_SIZE)
defines.add(GL_TEXTURE_COMPRESSION_HINT)
defines.add(GL_TEXTURE_CUBE_MAP)
defines.add(GL_TEXTURE_CUBE_MAP_NEGATIVE_X)
defines.add(GL_TEXTURE_CUBE_MAP_NEGATIVE_Y)
defines.add(GL_TEXTURE_CUBE_MAP_NEGATIVE_Z)
defines.add(GL_TEXTURE_CUBE_MAP_POSITIVE_X)
defines.add(GL_TEXTURE_CUBE_MAP_POSITIVE_Y)
defines.add(GL_TEXTURE_CUBE_MAP_POSITIVE_Z)
defines.add(GL_TRANSPOSE_COLOR_MATRIX)
defines.add(GL_TRANSPOSE_MODELVIEW_MATRIX)
defines.add(GL_TRANSPOSE_PROJECTION_MATRIX)
defines.add(GL_TRANSPOSE_TEXTURE_MATRIX)

# GL_VERSION_1_4

GL_BLEND_DST_ALPHA = Enumerant('GL_BLEND_DST_ALPHA', 0x80ca, 'GL_VERSION_1_4')
GL_BLEND_DST_ALPHA.esVersions = [2.0]
GL_BLEND_DST_RGB = Enumerant('GL_BLEND_DST_RGB', 0x80c8, 'GL_VERSION_1_4')
GL_BLEND_DST_RGB.esVersions = [2.0]
GL_BLEND_SRC_ALPHA = Enumerant('GL_BLEND_SRC_ALPHA', 0x80cb, 'GL_VERSION_1_4')
GL_BLEND_SRC_ALPHA.esVersions = [2.0]
GL_BLEND_SRC_RGB = Enumerant('GL_BLEND_SRC_RGB', 0x80c9, 'GL_VERSION_1_4')
GL_BLEND_SRC_RGB.esVersions = [2.0]
GL_COLOR_SUM = Enumerant('GL_COLOR_SUM', 0x8458, 'GL_VERSION_1_4')
GL_COMPARE_R_TO_TEXTURE = Enumerant('GL_COMPARE_R_TO_TEXTURE', 0x884e, 'GL_VERSION_1_4')
GL_CURRENT_FOG_COORDINATE = Enumerant('GL_CURRENT_FOG_COORDINATE', 0x8453, 'GL_VERSION_1_4')
GL_CURRENT_SECONDARY_COLOR = Enumerant('GL_CURRENT_SECONDARY_COLOR', 0x8459, 'GL_VERSION_1_4')
GL_DECR_WRAP = Enumerant('GL_DECR_WRAP', 0x8508, 'GL_VERSION_1_4')
GL_DECR_WRAP.esVersions = [2.0]
GL_DEPTH_COMPONENT16 = Enumerant('GL_DEPTH_COMPONENT16', 0x81a5, 'GL_VERSION_1_4')
GL_DEPTH_COMPONENT16.esVersions = [2.0]
GL_DEPTH_COMPONENT24 = Enumerant('GL_DEPTH_COMPONENT24', 0x81a6, 'GL_VERSION_1_4')
GL_DEPTH_COMPONENT32 = Enumerant('GL_DEPTH_COMPONENT32', 0x81a7, 'GL_VERSION_1_4')
GL_DEPTH_TEXTURE_MODE = Enumerant('GL_DEPTH_TEXTURE_MODE', 0x884b, 'GL_VERSION_1_4')
GL_FOG_COORDINATE = Enumerant('GL_FOG_COORDINATE', 0x8451, 'GL_VERSION_1_4')
GL_FOG_COORDINATE_ARRAY = Enumerant('GL_FOG_COORDINATE_ARRAY', 0x8457, 'GL_VERSION_1_4')
GL_FOG_COORDINATE_ARRAY_POINTER = Enumerant('GL_FOG_COORDINATE_ARRAY_POINTER', 0x8456, 'GL_VERSION_1_4')
GL_FOG_COORDINATE_ARRAY_STRIDE = Enumerant('GL_FOG_COORDINATE_ARRAY_STRIDE', 0x8455, 'GL_VERSION_1_4')
GL_FOG_COORDINATE_ARRAY_TYPE = Enumerant('GL_FOG_COORDINATE_ARRAY_TYPE', 0x8454, 'GL_VERSION_1_4')
GL_FOG_COORDINATE_SOURCE = Enumerant('GL_FOG_COORDINATE_SOURCE', 0x8450, 'GL_VERSION_1_4')
GL_FRAGMENT_DEPTH = Enumerant('GL_FRAGMENT_DEPTH', 0x8452, 'GL_VERSION_1_4')
GL_GENERATE_MIPMAP = Enumerant('GL_GENERATE_MIPMAP', 0x8191, 'GL_VERSION_1_4')
GL_GENERATE_MIPMAP_HINT = Enumerant('GL_GENERATE_MIPMAP_HINT', 0x8192, 'GL_VERSION_1_4')
GL_GENERATE_MIPMAP_HINT.esVersions = [2.0]
GL_INCR_WRAP = Enumerant('GL_INCR_WRAP', 0x8507, 'GL_VERSION_1_4')
GL_INCR_WRAP.esVersions = [2.0]
GL_MAX_TEXTURE_LOD_BIAS = Enumerant('GL_MAX_TEXTURE_LOD_BIAS', 0x84fd, 'GL_VERSION_1_4')
GL_MIRRORED_REPEAT = Enumerant('GL_MIRRORED_REPEAT', 0x8370, 'GL_VERSION_1_4')
GL_MIRRORED_REPEAT.esVersions = [2.0]
GL_POINT_DISTANCE_ATTENUATION = Enumerant('GL_POINT_DISTANCE_ATTENUATION', 0x8129, 'GL_VERSION_1_4')
GL_POINT_FADE_THRESHOLD_SIZE = Enumerant('GL_POINT_FADE_THRESHOLD_SIZE', 0x8128, 'GL_VERSION_1_4')
GL_POINT_SIZE_MAX = Enumerant('GL_POINT_SIZE_MAX', 0x8127, 'GL_VERSION_1_4')
GL_POINT_SIZE_MIN = Enumerant('GL_POINT_SIZE_MIN', 0x8126, 'GL_VERSION_1_4')
GL_SECONDARY_COLOR_ARRAY = Enumerant('GL_SECONDARY_COLOR_ARRAY', 0x845e, 'GL_VERSION_1_4')
GL_SECONDARY_COLOR_ARRAY_POINTER = Enumerant('GL_SECONDARY_COLOR_ARRAY_POINTER', 0x845d, 'GL_VERSION_1_4')
GL_SECONDARY_COLOR_ARRAY_SIZE = Enumerant('GL_SECONDARY_COLOR_ARRAY_SIZE', 0x845a, 'GL_VERSION_1_4')
GL_SECONDARY_COLOR_ARRAY_STRIDE = Enumerant('GL_SECONDARY_COLOR_ARRAY_STRIDE', 0x845c, 'GL_VERSION_1_4')
GL_SECONDARY_COLOR_ARRAY_TYPE = Enumerant('GL_SECONDARY_COLOR_ARRAY_TYPE', 0x845b, 'GL_VERSION_1_4')
GL_TEXTURE_COMPARE_FUNC = Enumerant('GL_TEXTURE_COMPARE_FUNC', 0x884d, 'GL_VERSION_1_4')
GL_TEXTURE_COMPARE_MODE = Enumerant('GL_TEXTURE_COMPARE_MODE', 0x884c, 'GL_VERSION_1_4')
GL_TEXTURE_DEPTH_SIZE = Enumerant('GL_TEXTURE_DEPTH_SIZE', 0x884a, 'GL_VERSION_1_4')
GL_TEXTURE_FILTER_CONTROL = Enumerant('GL_TEXTURE_FILTER_CONTROL', 0x8500, 'GL_VERSION_1_4')
GL_TEXTURE_LOD_BIAS = Enumerant('GL_TEXTURE_LOD_BIAS', 0x8501, 'GL_VERSION_1_4')

defines.add(GL_BLEND_DST_ALPHA)
defines.add(GL_BLEND_DST_RGB)
defines.add(GL_BLEND_SRC_ALPHA)
defines.add(GL_BLEND_SRC_RGB)
defines.add(GL_COLOR_SUM)
defines.add(GL_COMPARE_R_TO_TEXTURE)
defines.add(GL_CURRENT_FOG_COORDINATE)
defines.add(GL_CURRENT_SECONDARY_COLOR)
defines.add(GL_DECR_WRAP)
defines.add(GL_DEPTH_COMPONENT16)
defines.add(GL_DEPTH_COMPONENT24)
defines.add(GL_DEPTH_COMPONENT32)
defines.add(GL_DEPTH_TEXTURE_MODE)
defines.add(GL_FOG_COORDINATE)
defines.add(GL_FOG_COORDINATE_ARRAY)
defines.add(GL_FOG_COORDINATE_ARRAY_POINTER)
defines.add(GL_FOG_COORDINATE_ARRAY_STRIDE)
defines.add(GL_FOG_COORDINATE_ARRAY_TYPE)
defines.add(GL_FOG_COORDINATE_SOURCE)
defines.add(GL_FRAGMENT_DEPTH)
defines.add(GL_GENERATE_MIPMAP)
defines.add(GL_GENERATE_MIPMAP_HINT)
defines.add(GL_INCR_WRAP)
defines.add(GL_MAX_TEXTURE_LOD_BIAS)
defines.add(GL_MIRRORED_REPEAT)
defines.add(GL_POINT_DISTANCE_ATTENUATION)
defines.add(GL_POINT_FADE_THRESHOLD_SIZE)
defines.add(GL_POINT_SIZE_MAX)
defines.add(GL_POINT_SIZE_MIN)
defines.add(GL_SECONDARY_COLOR_ARRAY)
defines.add(GL_SECONDARY_COLOR_ARRAY_POINTER)
defines.add(GL_SECONDARY_COLOR_ARRAY_SIZE)
defines.add(GL_SECONDARY_COLOR_ARRAY_STRIDE)
defines.add(GL_SECONDARY_COLOR_ARRAY_TYPE)
defines.add(GL_TEXTURE_COMPARE_FUNC)
defines.add(GL_TEXTURE_COMPARE_MODE)
defines.add(GL_TEXTURE_DEPTH_SIZE)
defines.add(GL_TEXTURE_FILTER_CONTROL)
defines.add(GL_TEXTURE_LOD_BIAS)

# GL_VERSION_1_5

GL_ARRAY_BUFFER = Enumerant('GL_ARRAY_BUFFER', 0x8892, 'GL_VERSION_1_5')
GL_ARRAY_BUFFER.esVersions = [2.0]
GL_ARRAY_BUFFER_BINDING = Enumerant('GL_ARRAY_BUFFER_BINDING', 0x8894, 'GL_VERSION_1_5')
GL_ARRAY_BUFFER_BINDING.esVersions = [2.0]
GL_BUFFER_ACCESS = Enumerant('GL_BUFFER_ACCESS', 0x88bb, 'GL_VERSION_1_5')
GL_BUFFER_MAPPED = Enumerant('GL_BUFFER_MAPPED', 0x88bc, 'GL_VERSION_1_5')
GL_BUFFER_MAP_POINTER = Enumerant('GL_BUFFER_MAP_POINTER', 0x88bd, 'GL_VERSION_1_5')
GL_BUFFER_SIZE = Enumerant('GL_BUFFER_SIZE', 0x8764, 'GL_VERSION_1_5')
GL_BUFFER_SIZE.esVersions = [2.0]
GL_BUFFER_USAGE = Enumerant('GL_BUFFER_USAGE', 0x8765, 'GL_VERSION_1_5')
GL_BUFFER_USAGE.esVersions = [2.0]
GL_COLOR_ARRAY_BUFFER_BINDING = Enumerant('GL_COLOR_ARRAY_BUFFER_BINDING', 0x8898, 'GL_VERSION_1_5')
GL_CURRENT_FOG_COORD = Enumerant('GL_CURRENT_FOG_COORD', 'GL_CURRENT_FOG_COORDINATE', 'GL_VERSION_1_5')
GL_CURRENT_QUERY = Enumerant('GL_CURRENT_QUERY', 0x8865, 'GL_VERSION_1_5')
GL_DYNAMIC_COPY = Enumerant('GL_DYNAMIC_COPY', 0x88ea, 'GL_VERSION_1_5')
GL_DYNAMIC_DRAW = Enumerant('GL_DYNAMIC_DRAW', 0x88e8, 'GL_VERSION_1_5')
GL_DYNAMIC_DRAW.esVersions = [2.0]
GL_DYNAMIC_READ = Enumerant('GL_DYNAMIC_READ', 0x88e9, 'GL_VERSION_1_5')
GL_EDGE_FLAG_ARRAY_BUFFER_BINDING = Enumerant('GL_EDGE_FLAG_ARRAY_BUFFER_BINDING', 0x889b, 'GL_VERSION_1_5')
GL_ELEMENT_ARRAY_BUFFER = Enumerant('GL_ELEMENT_ARRAY_BUFFER', 0x8893, 'GL_VERSION_1_5')
GL_ELEMENT_ARRAY_BUFFER.esVersions = [2.0]
GL_ELEMENT_ARRAY_BUFFER_BINDING = Enumerant('GL_ELEMENT_ARRAY_BUFFER_BINDING', 0x8895, 'GL_VERSION_1_5')
GL_ELEMENT_ARRAY_BUFFER_BINDING.esVersions = [2.0]
GL_FOG_COORD = Enumerant('GL_FOG_COORD', 'GL_FOG_COORDINATE', 'GL_VERSION_1_5')
GL_FOG_COORDINATE_ARRAY_BUFFER_BINDING = Enumerant('GL_FOG_COORDINATE_ARRAY_BUFFER_BINDING', 0x889d, 'GL_VERSION_1_5')
GL_FOG_COORD_ARRAY = Enumerant('GL_FOG_COORD_ARRAY', 'GL_FOG_COORDINATE_ARRAY', 'GL_VERSION_1_5')
GL_FOG_COORD_ARRAY_BUFFER_BINDING = Enumerant('GL_FOG_COORD_ARRAY_BUFFER_BINDING', 'GL_FOG_COORDINATE_ARRAY_BUFFER_BINDING', 'GL_VERSION_1_5')
GL_FOG_COORD_ARRAY_POINTER = Enumerant('GL_FOG_COORD_ARRAY_POINTER', 'GL_FOG_COORDINATE_ARRAY_POINTER', 'GL_VERSION_1_5')
GL_FOG_COORD_ARRAY_STRIDE = Enumerant('GL_FOG_COORD_ARRAY_STRIDE', 'GL_FOG_COORDINATE_ARRAY_STRIDE', 'GL_VERSION_1_5')
GL_FOG_COORD_ARRAY_TYPE = Enumerant('GL_FOG_COORD_ARRAY_TYPE', 'GL_FOG_COORDINATE_ARRAY_TYPE', 'GL_VERSION_1_5')
GL_FOG_COORD_SRC = Enumerant('GL_FOG_COORD_SRC', 'GL_FOG_COORDINATE_SOURCE', 'GL_VERSION_1_5')
GL_INDEX_ARRAY_BUFFER_BINDING = Enumerant('GL_INDEX_ARRAY_BUFFER_BINDING', 0x8899, 'GL_VERSION_1_5')
GL_NORMAL_ARRAY_BUFFER_BINDING = Enumerant('GL_NORMAL_ARRAY_BUFFER_BINDING', 0x8897, 'GL_VERSION_1_5')
GL_QUERY_COUNTER_BITS = Enumerant('GL_QUERY_COUNTER_BITS', 0x8864, 'GL_VERSION_1_5')
GL_QUERY_RESULT = Enumerant('GL_QUERY_RESULT', 0x8866, 'GL_VERSION_1_5')
GL_QUERY_RESULT_AVAILABLE = Enumerant('GL_QUERY_RESULT_AVAILABLE', 0x8867, 'GL_VERSION_1_5')
GL_READ_ONLY = Enumerant('GL_READ_ONLY', 0x88b8, 'GL_VERSION_1_5')
GL_READ_WRITE = Enumerant('GL_READ_WRITE', 0x88ba, 'GL_VERSION_1_5')
GL_SAMPLES_PASSED = Enumerant('GL_SAMPLES_PASSED', 0x8914, 'GL_VERSION_1_5')
GL_SECONDARY_COLOR_ARRAY_BUFFER_BINDING = Enumerant('GL_SECONDARY_COLOR_ARRAY_BUFFER_BINDING', 0x889c, 'GL_VERSION_1_5')
GL_SRC0_ALPHA = Enumerant('GL_SRC0_ALPHA', 'GL_SOURCE0_ALPHA', 'GL_VERSION_1_5')
GL_SRC0_RGB = Enumerant('GL_SRC0_RGB', 'GL_SOURCE0_RGB', 'GL_VERSION_1_5')
GL_SRC1_ALPHA = Enumerant('GL_SRC1_ALPHA', 'GL_SOURCE1_ALPHA', 'GL_VERSION_1_5')
GL_SRC1_RGB = Enumerant('GL_SRC1_RGB', 'GL_SOURCE1_RGB', 'GL_VERSION_1_5')
GL_SRC2_ALPHA = Enumerant('GL_SRC2_ALPHA', 'GL_SOURCE2_ALPHA', 'GL_VERSION_1_5')
GL_SRC2_RGB = Enumerant('GL_SRC2_RGB', 'GL_SOURCE2_RGB', 'GL_VERSION_1_5')
GL_STATIC_COPY = Enumerant('GL_STATIC_COPY', 0x88e6, 'GL_VERSION_1_5')
GL_STATIC_DRAW = Enumerant('GL_STATIC_DRAW', 0x88e4, 'GL_VERSION_1_5')
GL_STATIC_DRAW.esVersions = [2.0]
GL_STATIC_READ = Enumerant('GL_STATIC_READ', 0x88e5, 'GL_VERSION_1_5')
GL_STREAM_COPY = Enumerant('GL_STREAM_COPY', 0x88e2, 'GL_VERSION_1_5')
GL_STREAM_DRAW = Enumerant('GL_STREAM_DRAW', 0x88e0, 'GL_VERSION_1_5')
GL_STREAM_DRAW.esVersions = [2.0]
GL_STREAM_READ = Enumerant('GL_STREAM_READ', 0x88e1, 'GL_VERSION_1_5')
GL_TEXTURE_COORD_ARRAY_BUFFER_BINDING = Enumerant('GL_TEXTURE_COORD_ARRAY_BUFFER_BINDING', 0x889a, 'GL_VERSION_1_5')
GL_VERTEX_ARRAY_BUFFER_BINDING = Enumerant('GL_VERTEX_ARRAY_BUFFER_BINDING', 0x8896, 'GL_VERSION_1_5')
GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING = Enumerant('GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING', 0x889f, 'GL_VERSION_1_5')
GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING.esVersions = [2.0]
GL_WEIGHT_ARRAY_BUFFER_BINDING = Enumerant('GL_WEIGHT_ARRAY_BUFFER_BINDING', 0x889e, 'GL_VERSION_1_5')
GL_WRITE_ONLY = Enumerant('GL_WRITE_ONLY', 0x88b9, 'GL_VERSION_1_5')

defines.add(GL_ARRAY_BUFFER)
defines.add(GL_ARRAY_BUFFER_BINDING)
defines.add(GL_BUFFER_ACCESS)
defines.add(GL_BUFFER_MAPPED)
defines.add(GL_BUFFER_MAP_POINTER)
defines.add(GL_BUFFER_SIZE)
defines.add(GL_BUFFER_USAGE)
defines.add(GL_COLOR_ARRAY_BUFFER_BINDING)
defines.add(GL_CURRENT_FOG_COORD)
defines.add(GL_CURRENT_QUERY)
defines.add(GL_DYNAMIC_COPY)
defines.add(GL_DYNAMIC_DRAW)
defines.add(GL_DYNAMIC_READ)
defines.add(GL_EDGE_FLAG_ARRAY_BUFFER_BINDING)
defines.add(GL_ELEMENT_ARRAY_BUFFER)
defines.add(GL_ELEMENT_ARRAY_BUFFER_BINDING)
defines.add(GL_FOG_COORD)
defines.add(GL_FOG_COORDINATE_ARRAY_BUFFER_BINDING)
defines.add(GL_FOG_COORD_ARRAY)
defines.add(GL_FOG_COORD_ARRAY_BUFFER_BINDING)
defines.add(GL_FOG_COORD_ARRAY_POINTER)
defines.add(GL_FOG_COORD_ARRAY_STRIDE)
defines.add(GL_FOG_COORD_ARRAY_TYPE)
defines.add(GL_FOG_COORD_SRC)
defines.add(GL_INDEX_ARRAY_BUFFER_BINDING)
defines.add(GL_NORMAL_ARRAY_BUFFER_BINDING)
defines.add(GL_QUERY_COUNTER_BITS)
defines.add(GL_QUERY_RESULT)
defines.add(GL_QUERY_RESULT_AVAILABLE)
defines.add(GL_READ_ONLY)
defines.add(GL_READ_WRITE)
defines.add(GL_SAMPLES_PASSED)
defines.add(GL_SECONDARY_COLOR_ARRAY_BUFFER_BINDING)
defines.add(GL_SRC0_ALPHA)
defines.add(GL_SRC0_RGB)
defines.add(GL_SRC1_ALPHA)
defines.add(GL_SRC1_RGB)
defines.add(GL_SRC2_ALPHA)
defines.add(GL_SRC2_RGB)
defines.add(GL_STATIC_COPY)
defines.add(GL_STATIC_DRAW)
defines.add(GL_STATIC_READ)
defines.add(GL_STREAM_COPY)
defines.add(GL_STREAM_DRAW)
defines.add(GL_STREAM_READ)
defines.add(GL_TEXTURE_COORD_ARRAY_BUFFER_BINDING)
defines.add(GL_VERTEX_ARRAY_BUFFER_BINDING)
defines.add(GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING)
defines.add(GL_WEIGHT_ARRAY_BUFFER_BINDING)
defines.add(GL_WRITE_ONLY)

# GL_VERSION_2_0

GL_ACTIVE_ATTRIBUTES = Enumerant('GL_ACTIVE_ATTRIBUTES', 0x8b89, 'GL_VERSION_2_0')
GL_ACTIVE_ATTRIBUTES.esVersions = [2.0]
GL_ACTIVE_ATTRIBUTE_MAX_LENGTH = Enumerant('GL_ACTIVE_ATTRIBUTE_MAX_LENGTH', 0x8b8a, 'GL_VERSION_2_0')
GL_ACTIVE_ATTRIBUTE_MAX_LENGTH.esVersions = [2.0]
GL_ACTIVE_UNIFORMS = Enumerant('GL_ACTIVE_UNIFORMS', 0x8b86, 'GL_VERSION_2_0')
GL_ACTIVE_UNIFORMS.esVersions = [2.0]
GL_ACTIVE_UNIFORM_MAX_LENGTH = Enumerant('GL_ACTIVE_UNIFORM_MAX_LENGTH', 0x8b87, 'GL_VERSION_2_0')
GL_ACTIVE_UNIFORM_MAX_LENGTH.esVersions = [2.0]
GL_ATTACHED_SHADERS = Enumerant('GL_ATTACHED_SHADERS', 0x8b85, 'GL_VERSION_2_0')
GL_ATTACHED_SHADERS.esVersions = [2.0]
GL_BLEND_EQUATION_ALPHA = Enumerant('GL_BLEND_EQUATION_ALPHA', 0x883d, 'GL_VERSION_2_0')
GL_BLEND_EQUATION_ALPHA.esVersions = [2.0]
GL_BLEND_EQUATION_RGB = Enumerant('GL_BLEND_EQUATION_RGB', 'GL_BLEND_EQUATION', 'GL_VERSION_2_0')
GL_BLEND_EQUATION_RGB.esVersions = [2.0]
GL_BOOL = Enumerant('GL_BOOL', 0x8b56, 'GL_VERSION_2_0')
GL_BOOL.esVersions = [2.0]
GL_BOOL_VEC2 = Enumerant('GL_BOOL_VEC2', 0x8b57, 'GL_VERSION_2_0')
GL_BOOL_VEC2.esVersions = [2.0]
GL_BOOL_VEC3 = Enumerant('GL_BOOL_VEC3', 0x8b58, 'GL_VERSION_2_0')
GL_BOOL_VEC3.esVersions = [2.0]
GL_BOOL_VEC4 = Enumerant('GL_BOOL_VEC4', 0x8b59, 'GL_VERSION_2_0')
GL_BOOL_VEC4.esVersions = [2.0]
GL_COMPILE_STATUS = Enumerant('GL_COMPILE_STATUS', 0x8b81, 'GL_VERSION_2_0')
GL_COMPILE_STATUS.esVersions = [2.0]
GL_COORD_REPLACE = Enumerant('GL_COORD_REPLACE', 0x8862, 'GL_VERSION_2_0')
GL_CURRENT_PROGRAM = Enumerant('GL_CURRENT_PROGRAM', 0x8b8d, 'GL_VERSION_2_0')
GL_CURRENT_PROGRAM.esVersions = [2.0]
GL_CURRENT_VERTEX_ATTRIB = Enumerant('GL_CURRENT_VERTEX_ATTRIB', 0x8626, 'GL_VERSION_2_0')
GL_CURRENT_VERTEX_ATTRIB.esVersions = [2.0]
GL_DELETE_STATUS = Enumerant('GL_DELETE_STATUS', 0x8b80, 'GL_VERSION_2_0')
GL_DELETE_STATUS.esVersions = [2.0]
GL_DRAW_BUFFER0 = Enumerant('GL_DRAW_BUFFER0', 0x8825, 'GL_VERSION_2_0')
GL_DRAW_BUFFER1 = Enumerant('GL_DRAW_BUFFER1', 0x8826, 'GL_VERSION_2_0')
GL_DRAW_BUFFER10 = Enumerant('GL_DRAW_BUFFER10', 0x882f, 'GL_VERSION_2_0')
GL_DRAW_BUFFER11 = Enumerant('GL_DRAW_BUFFER11', 0x8830, 'GL_VERSION_2_0')
GL_DRAW_BUFFER12 = Enumerant('GL_DRAW_BUFFER12', 0x8831, 'GL_VERSION_2_0')
GL_DRAW_BUFFER13 = Enumerant('GL_DRAW_BUFFER13', 0x8832, 'GL_VERSION_2_0')
GL_DRAW_BUFFER14 = Enumerant('GL_DRAW_BUFFER14', 0x8833, 'GL_VERSION_2_0')
GL_DRAW_BUFFER15 = Enumerant('GL_DRAW_BUFFER15', 0x8834, 'GL_VERSION_2_0')
GL_DRAW_BUFFER2 = Enumerant('GL_DRAW_BUFFER2', 0x8827, 'GL_VERSION_2_0')
GL_DRAW_BUFFER3 = Enumerant('GL_DRAW_BUFFER3', 0x8828, 'GL_VERSION_2_0')
GL_DRAW_BUFFER4 = Enumerant('GL_DRAW_BUFFER4', 0x8829, 'GL_VERSION_2_0')
GL_DRAW_BUFFER5 = Enumerant('GL_DRAW_BUFFER5', 0x882a, 'GL_VERSION_2_0')
GL_DRAW_BUFFER6 = Enumerant('GL_DRAW_BUFFER6', 0x882b, 'GL_VERSION_2_0')
GL_DRAW_BUFFER7 = Enumerant('GL_DRAW_BUFFER7', 0x882c, 'GL_VERSION_2_0')
GL_DRAW_BUFFER8 = Enumerant('GL_DRAW_BUFFER8', 0x882d, 'GL_VERSION_2_0')
GL_DRAW_BUFFER9 = Enumerant('GL_DRAW_BUFFER9', 0x882e, 'GL_VERSION_2_0')
GL_FLOAT_MAT2 = Enumerant('GL_FLOAT_MAT2', 0x8b5a, 'GL_VERSION_2_0')
GL_FLOAT_MAT2.esVersions = [2.0]
GL_FLOAT_MAT3 = Enumerant('GL_FLOAT_MAT3', 0x8b5b, 'GL_VERSION_2_0')
GL_FLOAT_MAT3.esVersions = [2.0]
GL_FLOAT_MAT4 = Enumerant('GL_FLOAT_MAT4', 0x8b5c, 'GL_VERSION_2_0')
GL_FLOAT_MAT4.esVersions = [2.0]
GL_FLOAT_VEC2 = Enumerant('GL_FLOAT_VEC2', 0x8b50, 'GL_VERSION_2_0')
GL_FLOAT_VEC2.esVersions = [2.0]
GL_FLOAT_VEC3 = Enumerant('GL_FLOAT_VEC3', 0x8b51, 'GL_VERSION_2_0')
GL_FLOAT_VEC3.esVersions = [2.0]
GL_FLOAT_VEC4 = Enumerant('GL_FLOAT_VEC4', 0x8b52, 'GL_VERSION_2_0')
GL_FLOAT_VEC4.esVersions = [2.0]
GL_FRAGMENT_SHADER = Enumerant('GL_FRAGMENT_SHADER', 0x8b30, 'GL_VERSION_2_0')
GL_FRAGMENT_SHADER.esVersions = [2.0]
GL_FRAGMENT_SHADER_DERIVATIVE_HINT = Enumerant('GL_FRAGMENT_SHADER_DERIVATIVE_HINT', 0x8b8b, 'GL_VERSION_2_0')
GL_INFO_LOG_LENGTH = Enumerant('GL_INFO_LOG_LENGTH', 0x8b84, 'GL_VERSION_2_0')
GL_INFO_LOG_LENGTH.esVersions = [2.0]
GL_INT_VEC2 = Enumerant('GL_INT_VEC2', 0x8b53, 'GL_VERSION_2_0')
GL_INT_VEC2.esVersions = [2.0]
GL_INT_VEC3 = Enumerant('GL_INT_VEC3', 0x8b54, 'GL_VERSION_2_0')
GL_INT_VEC3.esVersions = [2.0]
GL_INT_VEC4 = Enumerant('GL_INT_VEC4', 0x8b55, 'GL_VERSION_2_0')
GL_INT_VEC4.esVersions = [2.0]
GL_LINK_STATUS = Enumerant('GL_LINK_STATUS', 0x8b82, 'GL_VERSION_2_0')
GL_LINK_STATUS.esVersions = [2.0]
GL_LOWER_LEFT = Enumerant('GL_LOWER_LEFT', 0x8ca1, 'GL_VERSION_2_0')
GL_MAX_COMBINED_TEXTURE_IMAGE_UNITS = Enumerant('GL_MAX_COMBINED_TEXTURE_IMAGE_UNITS', 0x8b4d, 'GL_VERSION_2_0')
GL_MAX_COMBINED_TEXTURE_IMAGE_UNITS.esVersions = [2.0]
GL_MAX_DRAW_BUFFERS = Enumerant('GL_MAX_DRAW_BUFFERS', 0x8824, 'GL_VERSION_2_0')
GL_MAX_FRAGMENT_UNIFORM_COMPONENTS = Enumerant('GL_MAX_FRAGMENT_UNIFORM_COMPONENTS', 0x8b49, 'GL_VERSION_2_0')
GL_MAX_TEXTURE_COORDS = Enumerant('GL_MAX_TEXTURE_COORDS', 0x8871, 'GL_VERSION_2_0')
GL_MAX_TEXTURE_IMAGE_UNITS = Enumerant('GL_MAX_TEXTURE_IMAGE_UNITS', 0x8872, 'GL_VERSION_2_0')
GL_MAX_TEXTURE_IMAGE_UNITS.esVersions = [2.0]
GL_MAX_VARYING_FLOATS = Enumerant('GL_MAX_VARYING_FLOATS', 0x8b4b, 'GL_VERSION_2_0')
GL_MAX_VERTEX_ATTRIBS = Enumerant('GL_MAX_VERTEX_ATTRIBS', 0x8869, 'GL_VERSION_2_0')
GL_MAX_VERTEX_ATTRIBS.esVersions = [2.0]
GL_MAX_VERTEX_TEXTURE_IMAGE_UNITS = Enumerant('GL_MAX_VERTEX_TEXTURE_IMAGE_UNITS', 0x8b4c, 'GL_VERSION_2_0')
GL_MAX_VERTEX_TEXTURE_IMAGE_UNITS.esVersions = [2.0]
GL_MAX_VERTEX_UNIFORM_COMPONENTS = Enumerant('GL_MAX_VERTEX_UNIFORM_COMPONENTS', 0x8b4a, 'GL_VERSION_2_0')
GL_POINT_SPRITE = Enumerant('GL_POINT_SPRITE', 0x8861, 'GL_VERSION_2_0')
GL_POINT_SPRITE_COORD_ORIGIN = Enumerant('GL_POINT_SPRITE_COORD_ORIGIN', 0x8ca0, 'GL_VERSION_2_0')
GL_SAMPLER_1D = Enumerant('GL_SAMPLER_1D', 0x8b5d, 'GL_VERSION_2_0')
GL_SAMPLER_1D_SHADOW = Enumerant('GL_SAMPLER_1D_SHADOW', 0x8b61, 'GL_VERSION_2_0')
GL_SAMPLER_2D = Enumerant('GL_SAMPLER_2D', 0x8b5e, 'GL_VERSION_2_0')
GL_SAMPLER_2D.esVersions = [2.0]
GL_SAMPLER_2D_SHADOW = Enumerant('GL_SAMPLER_2D_SHADOW', 0x8b62, 'GL_VERSION_2_0')
GL_SAMPLER_3D = Enumerant('GL_SAMPLER_3D', 0x8b5f, 'GL_VERSION_2_0')
GL_SAMPLER_CUBE = Enumerant('GL_SAMPLER_CUBE', 0x8b60, 'GL_VERSION_2_0')
GL_SAMPLER_CUBE.esVersions = [2.0]
GL_SHADER_SOURCE_LENGTH = Enumerant('GL_SHADER_SOURCE_LENGTH', 0x8b88, 'GL_VERSION_2_0')
GL_SHADER_SOURCE_LENGTH.esVersions = [2.0]
GL_SHADER_TYPE = Enumerant('GL_SHADER_TYPE', 0x8b4f, 'GL_VERSION_2_0')
GL_SHADER_TYPE.esVersions = [2.0]
GL_SHADING_LANGUAGE_VERSION = Enumerant('GL_SHADING_LANGUAGE_VERSION', 0x8b8c, 'GL_VERSION_2_0')
GL_SHADING_LANGUAGE_VERSION.esVersions = [2.0]
GL_STENCIL_BACK_FAIL = Enumerant('GL_STENCIL_BACK_FAIL', 0x8801, 'GL_VERSION_2_0')
GL_STENCIL_BACK_FAIL.esVersions = [2.0]
GL_STENCIL_BACK_FUNC = Enumerant('GL_STENCIL_BACK_FUNC', 0x8800, 'GL_VERSION_2_0')
GL_STENCIL_BACK_FUNC.esVersions = [2.0]
GL_STENCIL_BACK_PASS_DEPTH_FAIL = Enumerant('GL_STENCIL_BACK_PASS_DEPTH_FAIL', 0x8802, 'GL_VERSION_2_0')
GL_STENCIL_BACK_PASS_DEPTH_FAIL.esVersions = [2.0]
GL_STENCIL_BACK_PASS_DEPTH_PASS = Enumerant('GL_STENCIL_BACK_PASS_DEPTH_PASS', 0x8803, 'GL_VERSION_2_0')
GL_STENCIL_BACK_PASS_DEPTH_PASS.esVersions = [2.0]
GL_STENCIL_BACK_REF = Enumerant('GL_STENCIL_BACK_REF', 0x8ca3, 'GL_VERSION_2_0')
GL_STENCIL_BACK_REF.esVersions = [2.0]
GL_STENCIL_BACK_VALUE_MASK = Enumerant('GL_STENCIL_BACK_VALUE_MASK', 0x8ca4, 'GL_VERSION_2_0')
GL_STENCIL_BACK_VALUE_MASK.esVersions = [2.0]
GL_STENCIL_BACK_WRITEMASK = Enumerant('GL_STENCIL_BACK_WRITEMASK', 0x8ca5, 'GL_VERSION_2_0')
GL_STENCIL_BACK_WRITEMASK.esVersions = [2.0]
GL_UPPER_LEFT = Enumerant('GL_UPPER_LEFT', 0x8ca2, 'GL_VERSION_2_0')
GL_VALIDATE_STATUS = Enumerant('GL_VALIDATE_STATUS', 0x8b83, 'GL_VERSION_2_0')
GL_VALIDATE_STATUS.esVersions = [2.0]
GL_VERTEX_ATTRIB_ARRAY_ENABLED = Enumerant('GL_VERTEX_ATTRIB_ARRAY_ENABLED', 0x8622, 'GL_VERSION_2_0')
GL_VERTEX_ATTRIB_ARRAY_ENABLED.esVersions = [2.0]
GL_VERTEX_ATTRIB_ARRAY_NORMALIZED = Enumerant('GL_VERTEX_ATTRIB_ARRAY_NORMALIZED', 0x886a, 'GL_VERSION_2_0')
GL_VERTEX_ATTRIB_ARRAY_NORMALIZED.esVersions = [2.0]
GL_VERTEX_ATTRIB_ARRAY_POINTER = Enumerant('GL_VERTEX_ATTRIB_ARRAY_POINTER', 0x8645, 'GL_VERSION_2_0')
GL_VERTEX_ATTRIB_ARRAY_POINTER.esVersions = [2.0]
GL_VERTEX_ATTRIB_ARRAY_SIZE = Enumerant('GL_VERTEX_ATTRIB_ARRAY_SIZE', 0x8623, 'GL_VERSION_2_0')
GL_VERTEX_ATTRIB_ARRAY_SIZE.esVersions = [2.0]
GL_VERTEX_ATTRIB_ARRAY_STRIDE = Enumerant('GL_VERTEX_ATTRIB_ARRAY_STRIDE', 0x8624, 'GL_VERSION_2_0')
GL_VERTEX_ATTRIB_ARRAY_STRIDE.esVersions = [2.0]
GL_VERTEX_ATTRIB_ARRAY_TYPE = Enumerant('GL_VERTEX_ATTRIB_ARRAY_TYPE', 0x8625, 'GL_VERSION_2_0')
GL_VERTEX_ATTRIB_ARRAY_TYPE.esVersions = [2.0]
GL_VERTEX_PROGRAM_POINT_SIZE = Enumerant('GL_VERTEX_PROGRAM_POINT_SIZE', 0x8642, 'GL_VERSION_2_0')
GL_VERTEX_PROGRAM_TWO_SIDE = Enumerant('GL_VERTEX_PROGRAM_TWO_SIDE', 0x8643, 'GL_VERSION_2_0')
GL_VERTEX_SHADER = Enumerant('GL_VERTEX_SHADER', 0x8b31, 'GL_VERSION_2_0')
GL_VERTEX_SHADER.esVersions = [2.0]

defines.add(GL_ACTIVE_ATTRIBUTES)
defines.add(GL_ACTIVE_ATTRIBUTE_MAX_LENGTH)
defines.add(GL_ACTIVE_UNIFORMS)
defines.add(GL_ACTIVE_UNIFORM_MAX_LENGTH)
defines.add(GL_ATTACHED_SHADERS)
defines.add(GL_BLEND_EQUATION_ALPHA)
defines.add(GL_BLEND_EQUATION_RGB)
defines.add(GL_BOOL)
defines.add(GL_BOOL_VEC2)
defines.add(GL_BOOL_VEC3)
defines.add(GL_BOOL_VEC4)
defines.add(GL_COMPILE_STATUS)
defines.add(GL_COORD_REPLACE)
defines.add(GL_CURRENT_PROGRAM)
defines.add(GL_CURRENT_VERTEX_ATTRIB)
defines.add(GL_DELETE_STATUS)
defines.add(GL_DRAW_BUFFER0)
defines.add(GL_DRAW_BUFFER1)
defines.add(GL_DRAW_BUFFER10)
defines.add(GL_DRAW_BUFFER11)
defines.add(GL_DRAW_BUFFER12)
defines.add(GL_DRAW_BUFFER13)
defines.add(GL_DRAW_BUFFER14)
defines.add(GL_DRAW_BUFFER15)
defines.add(GL_DRAW_BUFFER2)
defines.add(GL_DRAW_BUFFER3)
defines.add(GL_DRAW_BUFFER4)
defines.add(GL_DRAW_BUFFER5)
defines.add(GL_DRAW_BUFFER6)
defines.add(GL_DRAW_BUFFER7)
defines.add(GL_DRAW_BUFFER8)
defines.add(GL_DRAW_BUFFER9)
defines.add(GL_FLOAT_MAT2)
defines.add(GL_FLOAT_MAT3)
defines.add(GL_FLOAT_MAT4)
defines.add(GL_FLOAT_VEC2)
defines.add(GL_FLOAT_VEC3)
defines.add(GL_FLOAT_VEC4)
defines.add(GL_FRAGMENT_SHADER)
defines.add(GL_FRAGMENT_SHADER_DERIVATIVE_HINT)
defines.add(GL_INFO_LOG_LENGTH)
defines.add(GL_INT_VEC2)
defines.add(GL_INT_VEC3)
defines.add(GL_INT_VEC4)
defines.add(GL_LINK_STATUS)
defines.add(GL_LOWER_LEFT)
defines.add(GL_MAX_COMBINED_TEXTURE_IMAGE_UNITS)
defines.add(GL_MAX_DRAW_BUFFERS)
defines.add(GL_MAX_FRAGMENT_UNIFORM_COMPONENTS)
defines.add(GL_MAX_TEXTURE_COORDS)
defines.add(GL_MAX_TEXTURE_IMAGE_UNITS)
defines.add(GL_MAX_VARYING_FLOATS)
defines.add(GL_MAX_VERTEX_ATTRIBS)
defines.add(GL_MAX_VERTEX_TEXTURE_IMAGE_UNITS)
defines.add(GL_MAX_VERTEX_UNIFORM_COMPONENTS)
defines.add(GL_POINT_SPRITE)
defines.add(GL_POINT_SPRITE_COORD_ORIGIN)
defines.add(GL_SAMPLER_1D)
defines.add(GL_SAMPLER_1D_SHADOW)
defines.add(GL_SAMPLER_2D)
defines.add(GL_SAMPLER_2D_SHADOW)
defines.add(GL_SAMPLER_3D)
defines.add(GL_SAMPLER_CUBE)
defines.add(GL_SHADER_SOURCE_LENGTH)
defines.add(GL_SHADER_TYPE)
defines.add(GL_SHADING_LANGUAGE_VERSION)
defines.add(GL_STENCIL_BACK_FAIL)
defines.add(GL_STENCIL_BACK_FUNC)
defines.add(GL_STENCIL_BACK_PASS_DEPTH_FAIL)
defines.add(GL_STENCIL_BACK_PASS_DEPTH_PASS)
defines.add(GL_STENCIL_BACK_REF)
defines.add(GL_STENCIL_BACK_VALUE_MASK)
defines.add(GL_STENCIL_BACK_WRITEMASK)
defines.add(GL_UPPER_LEFT)
defines.add(GL_VALIDATE_STATUS)
defines.add(GL_VERTEX_ATTRIB_ARRAY_ENABLED)
defines.add(GL_VERTEX_ATTRIB_ARRAY_NORMALIZED)
defines.add(GL_VERTEX_ATTRIB_ARRAY_POINTER)
defines.add(GL_VERTEX_ATTRIB_ARRAY_SIZE)
defines.add(GL_VERTEX_ATTRIB_ARRAY_STRIDE)
defines.add(GL_VERTEX_ATTRIB_ARRAY_TYPE)
defines.add(GL_VERTEX_PROGRAM_POINT_SIZE)
defines.add(GL_VERTEX_PROGRAM_TWO_SIDE)
defines.add(GL_VERTEX_SHADER)

# GL_VERSION_2_1

GL_COMPRESSED_SLUMINANCE = Enumerant('GL_COMPRESSED_SLUMINANCE', 0x8c4a, 'GL_VERSION_2_1')
GL_COMPRESSED_SLUMINANCE_ALPHA = Enumerant('GL_COMPRESSED_SLUMINANCE_ALPHA', 0x8c4b, 'GL_VERSION_2_1')
GL_COMPRESSED_SRGB = Enumerant('GL_COMPRESSED_SRGB', 0x8c48, 'GL_VERSION_2_1')
GL_COMPRESSED_SRGB_ALPHA = Enumerant('GL_COMPRESSED_SRGB_ALPHA', 0x8c49, 'GL_VERSION_2_1')
GL_CURRENT_RASTER_SECONDARY_COLOR = Enumerant('GL_CURRENT_RASTER_SECONDARY_COLOR', 0x845f, 'GL_VERSION_2_1')
GL_FLOAT_MAT2x3 = Enumerant('GL_FLOAT_MAT2x3', 0x8b65, 'GL_VERSION_2_1')
GL_FLOAT_MAT2x4 = Enumerant('GL_FLOAT_MAT2x4', 0x8b66, 'GL_VERSION_2_1')
GL_FLOAT_MAT3x2 = Enumerant('GL_FLOAT_MAT3x2', 0x8b67, 'GL_VERSION_2_1')
GL_FLOAT_MAT3x4 = Enumerant('GL_FLOAT_MAT3x4', 0x8b68, 'GL_VERSION_2_1')
GL_FLOAT_MAT4x2 = Enumerant('GL_FLOAT_MAT4x2', 0x8b69, 'GL_VERSION_2_1')
GL_FLOAT_MAT4x3 = Enumerant('GL_FLOAT_MAT4x3', 0x8b6a, 'GL_VERSION_2_1')
GL_PIXEL_PACK_BUFFER = Enumerant('GL_PIXEL_PACK_BUFFER', 0x88eb, 'GL_VERSION_2_1')
GL_PIXEL_PACK_BUFFER_BINDING = Enumerant('GL_PIXEL_PACK_BUFFER_BINDING', 0x88ed, 'GL_VERSION_2_1')
GL_PIXEL_UNPACK_BUFFER = Enumerant('GL_PIXEL_UNPACK_BUFFER', 0x88ec, 'GL_VERSION_2_1')
GL_PIXEL_UNPACK_BUFFER_BINDING = Enumerant('GL_PIXEL_UNPACK_BUFFER_BINDING', 0x88ef, 'GL_VERSION_2_1')
GL_SLUMINANCE = Enumerant('GL_SLUMINANCE', 0x8c46, 'GL_VERSION_2_1')
GL_SLUMINANCE8 = Enumerant('GL_SLUMINANCE8', 0x8c47, 'GL_VERSION_2_1')
GL_SLUMINANCE8_ALPHA8 = Enumerant('GL_SLUMINANCE8_ALPHA8', 0x8c45, 'GL_VERSION_2_1')
GL_SLUMINANCE_ALPHA = Enumerant('GL_SLUMINANCE_ALPHA', 0x8c44, 'GL_VERSION_2_1')
GL_SRGB = Enumerant('GL_SRGB', 0x8c40, 'GL_VERSION_2_1')
GL_SRGB8 = Enumerant('GL_SRGB8', 0x8c41, 'GL_VERSION_2_1')
GL_SRGB8_ALPHA8 = Enumerant('GL_SRGB8_ALPHA8', 0x8c43, 'GL_VERSION_2_1')
GL_SRGB_ALPHA = Enumerant('GL_SRGB_ALPHA', 0x8c42, 'GL_VERSION_2_1')

defines.add(GL_COMPRESSED_SLUMINANCE)
defines.add(GL_COMPRESSED_SLUMINANCE_ALPHA)
defines.add(GL_COMPRESSED_SRGB)
defines.add(GL_COMPRESSED_SRGB_ALPHA)
defines.add(GL_CURRENT_RASTER_SECONDARY_COLOR)
defines.add(GL_FLOAT_MAT2x3)
defines.add(GL_FLOAT_MAT2x4)
defines.add(GL_FLOAT_MAT3x2)
defines.add(GL_FLOAT_MAT3x4)
defines.add(GL_FLOAT_MAT4x2)
defines.add(GL_FLOAT_MAT4x3)
defines.add(GL_PIXEL_PACK_BUFFER)
defines.add(GL_PIXEL_PACK_BUFFER_BINDING)
defines.add(GL_PIXEL_UNPACK_BUFFER)
defines.add(GL_PIXEL_UNPACK_BUFFER_BINDING)
defines.add(GL_SLUMINANCE)
defines.add(GL_SLUMINANCE8)
defines.add(GL_SLUMINANCE8_ALPHA8)
defines.add(GL_SLUMINANCE_ALPHA)
defines.add(GL_SRGB)
defines.add(GL_SRGB8)
defines.add(GL_SRGB8_ALPHA8)
defines.add(GL_SRGB_ALPHA)

# GL_VERSION_3_0

GL_ALPHA_INTEGER = Enumerant('GL_ALPHA_INTEGER', 0x8d97, 'GL_VERSION_3_0')
GL_BGRA_INTEGER = Enumerant('GL_BGRA_INTEGER', 0x8d9b, 'GL_VERSION_3_0')
GL_BGR_INTEGER = Enumerant('GL_BGR_INTEGER', 0x8d9a, 'GL_VERSION_3_0')
GL_BLUE_INTEGER = Enumerant('GL_BLUE_INTEGER', 0x8d96, 'GL_VERSION_3_0')
GL_CLAMP_FRAGMENT_COLOR = Enumerant('GL_CLAMP_FRAGMENT_COLOR', 0x891b, 'GL_VERSION_3_0')
GL_CLAMP_READ_COLOR = Enumerant('GL_CLAMP_READ_COLOR', 0x891c, 'GL_VERSION_3_0')
GL_CLAMP_VERTEX_COLOR = Enumerant('GL_CLAMP_VERTEX_COLOR', 0x891a, 'GL_VERSION_3_0')
GL_CLIP_DISTANCE0 = Enumerant('GL_CLIP_DISTANCE0', 'GL_CLIP_PLANE0', 'GL_VERSION_3_0')
GL_CLIP_DISTANCE0.enableCap = True
GL_CLIP_DISTANCE1 = Enumerant('GL_CLIP_DISTANCE1', 'GL_CLIP_PLANE1', 'GL_VERSION_3_0')
GL_CLIP_DISTANCE1.enableCap = True
GL_CLIP_DISTANCE2 = Enumerant('GL_CLIP_DISTANCE2', 'GL_CLIP_PLANE2', 'GL_VERSION_3_0')
GL_CLIP_DISTANCE2.enableCap = True
GL_CLIP_DISTANCE3 = Enumerant('GL_CLIP_DISTANCE3', 'GL_CLIP_PLANE3', 'GL_VERSION_3_0')
GL_CLIP_DISTANCE3.enableCap = True
GL_CLIP_DISTANCE4 = Enumerant('GL_CLIP_DISTANCE4', 'GL_CLIP_PLANE4', 'GL_VERSION_3_0')
GL_CLIP_DISTANCE4.enableCap = True
GL_CLIP_DISTANCE5 = Enumerant('GL_CLIP_DISTANCE5', 'GL_CLIP_PLANE5', 'GL_VERSION_3_0')
GL_CLIP_DISTANCE5.enableCap = True
GL_CLIP_DISTANCE6 = Enumerant('GL_CLIP_DISTANCE6', 'GL_CLIP_PLANE6', 'GL_VERSION_3_0')
GL_CLIP_DISTANCE6.enableCap = True
GL_CLIP_DISTANCE7 = Enumerant('GL_CLIP_DISTANCE7', 'GL_CLIP_PLANE7', 'GL_VERSION_3_0')
GL_CLIP_DISTANCE7.enableCap = True
GL_COMPARE_REF_TO_TEXTURE = Enumerant('GL_COMPARE_REF_TO_TEXTURE', 'GL_COMPARE_R_TO_TEXTURE_ARB', 'GL_VERSION_3_0')
GL_CONTEXT_FLAGS = Enumerant('GL_CONTEXT_FLAGS', 0x821e, 'GL_VERSION_3_0')
GL_CONTEXT_FLAG_FORWARD_COMPATIBLE_BIT = Enumerant('GL_CONTEXT_FLAG_FORWARD_COMPATIBLE_BIT', 0x0001, 'GL_VERSION_3_0')
GL_DEPTH_BUFFER = Enumerant('GL_DEPTH_BUFFER', 0x8223, 'GL_VERSION_3_0')
GL_FIXED_ONLY = Enumerant('GL_FIXED_ONLY', 0x891d, 'GL_VERSION_3_0')
GL_GREEN_INTEGER = Enumerant('GL_GREEN_INTEGER', 0x8d95, 'GL_VERSION_3_0')
GL_INTERLEAVED_ATTRIBS = Enumerant('GL_INTERLEAVED_ATTRIBS', 0x8c8c, 'GL_VERSION_3_0')
GL_INT_SAMPLER_1D = Enumerant('GL_INT_SAMPLER_1D', 0x8dc9, 'GL_VERSION_3_0')
GL_INT_SAMPLER_1D_ARRAY = Enumerant('GL_INT_SAMPLER_1D_ARRAY', 0x8dce, 'GL_VERSION_3_0')
GL_INT_SAMPLER_2D = Enumerant('GL_INT_SAMPLER_2D', 0x8dca, 'GL_VERSION_3_0')
GL_INT_SAMPLER_2D_ARRAY = Enumerant('GL_INT_SAMPLER_2D_ARRAY', 0x8dcf, 'GL_VERSION_3_0')
GL_INT_SAMPLER_3D = Enumerant('GL_INT_SAMPLER_3D', 0x8dcb, 'GL_VERSION_3_0')
GL_INT_SAMPLER_CUBE = Enumerant('GL_INT_SAMPLER_CUBE', 0x8dcc, 'GL_VERSION_3_0')
GL_MAJOR_VERSION = Enumerant('GL_MAJOR_VERSION', 0x821b, 'GL_VERSION_3_0')
GL_MAX_ARRAY_TEXTURE_LAYERS = Enumerant('GL_MAX_ARRAY_TEXTURE_LAYERS', 0x88ff, 'GL_VERSION_3_0')
GL_MAX_CLIP_DISTANCES = Enumerant('GL_MAX_CLIP_DISTANCES', 'GL_MAX_CLIP_PLANES', 'GL_VERSION_3_0')
GL_MAX_PROGRAM_TEXEL_OFFSET = Enumerant('GL_MAX_PROGRAM_TEXEL_OFFSET', 0x8905, 'GL_VERSION_3_0')
GL_MAX_TRANSFORM_FEEDBACK_INTERLEAVED_COMPONENTS = Enumerant('GL_MAX_TRANSFORM_FEEDBACK_INTERLEAVED_COMPONENTS', 0x8c8a, 'GL_VERSION_3_0')
GL_MAX_TRANSFORM_FEEDBACK_SEPARATE_ATTRIBS = Enumerant('GL_MAX_TRANSFORM_FEEDBACK_SEPARATE_ATTRIBS', 0x8c8b, 'GL_VERSION_3_0')
GL_MAX_TRANSFORM_FEEDBACK_SEPARATE_COMPONENTS = Enumerant('GL_MAX_TRANSFORM_FEEDBACK_SEPARATE_COMPONENTS', 0x8c80, 'GL_VERSION_3_0')
GL_MAX_VARYING_COMPONENTS = Enumerant('GL_MAX_VARYING_COMPONENTS', 'GL_MAX_VARYING_FLOATS', 'GL_VERSION_3_0')
GL_MINOR_VERSION = Enumerant('GL_MINOR_VERSION', 0x821c, 'GL_VERSION_3_0')
GL_MIN_PROGRAM_TEXEL_OFFSET = Enumerant('GL_MIN_PROGRAM_TEXEL_OFFSET', 0x8904, 'GL_VERSION_3_0')
GL_NUM_EXTENSIONS = Enumerant('GL_NUM_EXTENSIONS', 0x821d, 'GL_VERSION_3_0')
GL_PRIMITIVES_GENERATED = Enumerant('GL_PRIMITIVES_GENERATED', 0x8c87, 'GL_VERSION_3_0')
GL_PROXY_TEXTURE_1D_ARRAY = Enumerant('GL_PROXY_TEXTURE_1D_ARRAY', 0x8c19, 'GL_VERSION_3_0')
GL_PROXY_TEXTURE_2D_ARRAY = Enumerant('GL_PROXY_TEXTURE_2D_ARRAY', 0x8c1b, 'GL_VERSION_3_0')
GL_QUERY_BY_REGION_NO_WAIT = Enumerant('GL_QUERY_BY_REGION_NO_WAIT', 0x8e16, 'GL_VERSION_3_0')
GL_QUERY_BY_REGION_WAIT = Enumerant('GL_QUERY_BY_REGION_WAIT', 0x8e15, 'GL_VERSION_3_0')
GL_QUERY_NO_WAIT = Enumerant('GL_QUERY_NO_WAIT', 0x8e14, 'GL_VERSION_3_0')
GL_QUERY_WAIT = Enumerant('GL_QUERY_WAIT', 0x8e13, 'GL_VERSION_3_0')
GL_R11F_G11F_B10F = Enumerant('GL_R11F_G11F_B10F', 0x8c3a, 'GL_VERSION_3_0')
GL_RASTERIZER_DISCARD = Enumerant('GL_RASTERIZER_DISCARD', 0x8c89, 'GL_VERSION_3_0')
GL_RED_INTEGER = Enumerant('GL_RED_INTEGER', 0x8d94, 'GL_VERSION_3_0')
GL_RGB16F = Enumerant('GL_RGB16F', 0x881b, 'GL_VERSION_3_0')
GL_RGB16I = Enumerant('GL_RGB16I', 0x8d89, 'GL_VERSION_3_0')
GL_RGB16UI = Enumerant('GL_RGB16UI', 0x8d77, 'GL_VERSION_3_0')
GL_RGB32F = Enumerant('GL_RGB32F', 0x8815, 'GL_VERSION_3_0')
GL_RGB32I = Enumerant('GL_RGB32I', 0x8d83, 'GL_VERSION_3_0')
GL_RGB32UI = Enumerant('GL_RGB32UI', 0x8d71, 'GL_VERSION_3_0')
GL_RGB8I = Enumerant('GL_RGB8I', 0x8d8f, 'GL_VERSION_3_0')
GL_RGB8UI = Enumerant('GL_RGB8UI', 0x8d7d, 'GL_VERSION_3_0')
GL_RGB9_E5 = Enumerant('GL_RGB9_E5', 0x8c3d, 'GL_VERSION_3_0')
GL_RGBA16F = Enumerant('GL_RGBA16F', 0x881a, 'GL_VERSION_3_0')
GL_RGBA16I = Enumerant('GL_RGBA16I', 0x8d88, 'GL_VERSION_3_0')
GL_RGBA16UI = Enumerant('GL_RGBA16UI', 0x8d76, 'GL_VERSION_3_0')
GL_RGBA32F = Enumerant('GL_RGBA32F', 0x8814, 'GL_VERSION_3_0')
GL_RGBA32I = Enumerant('GL_RGBA32I', 0x8d82, 'GL_VERSION_3_0')
GL_RGBA32UI = Enumerant('GL_RGBA32UI', 0x8d70, 'GL_VERSION_3_0')
GL_RGBA8I = Enumerant('GL_RGBA8I', 0x8d8e, 'GL_VERSION_3_0')
GL_RGBA8UI = Enumerant('GL_RGBA8UI', 0x8d7c, 'GL_VERSION_3_0')
GL_RGBA_INTEGER = Enumerant('GL_RGBA_INTEGER', 0x8d99, 'GL_VERSION_3_0')
GL_RGB_INTEGER = Enumerant('GL_RGB_INTEGER', 0x8d98, 'GL_VERSION_3_0')
GL_SAMPLER_1D_ARRAY = Enumerant('GL_SAMPLER_1D_ARRAY', 0x8dc0, 'GL_VERSION_3_0')
GL_SAMPLER_1D_ARRAY_SHADOW = Enumerant('GL_SAMPLER_1D_ARRAY_SHADOW', 0x8dc3, 'GL_VERSION_3_0')
GL_SAMPLER_2D_ARRAY = Enumerant('GL_SAMPLER_2D_ARRAY', 0x8dc1, 'GL_VERSION_3_0')
GL_SAMPLER_2D_ARRAY_SHADOW = Enumerant('GL_SAMPLER_2D_ARRAY_SHADOW', 0x8dc4, 'GL_VERSION_3_0')
GL_SAMPLER_CUBE_SHADOW = Enumerant('GL_SAMPLER_CUBE_SHADOW', 0x8dc5, 'GL_VERSION_3_0')
GL_SEPARATE_ATTRIBS = Enumerant('GL_SEPARATE_ATTRIBS', 0x8c8d, 'GL_VERSION_3_0')
GL_STENCIL_BUFFER = Enumerant('GL_STENCIL_BUFFER', 0x8224, 'GL_VERSION_3_0')
GL_TEXTURE_1D_ARRAY = Enumerant('GL_TEXTURE_1D_ARRAY', 0x8c18, 'GL_VERSION_3_0')
GL_TEXTURE_2D_ARRAY = Enumerant('GL_TEXTURE_2D_ARRAY', 0x8c1a, 'GL_VERSION_3_0')
GL_TEXTURE_ALPHA_TYPE = Enumerant('GL_TEXTURE_ALPHA_TYPE', 0x8c13, 'GL_VERSION_3_0')
GL_TEXTURE_BINDING_1D_ARRAY = Enumerant('GL_TEXTURE_BINDING_1D_ARRAY', 0x8c1c, 'GL_VERSION_3_0')
GL_TEXTURE_BINDING_2D_ARRAY = Enumerant('GL_TEXTURE_BINDING_2D_ARRAY', 0x8c1d, 'GL_VERSION_3_0')
GL_TEXTURE_BLUE_TYPE = Enumerant('GL_TEXTURE_BLUE_TYPE', 0x8c12, 'GL_VERSION_3_0')
GL_TEXTURE_DEPTH_TYPE = Enumerant('GL_TEXTURE_DEPTH_TYPE', 0x8c16, 'GL_VERSION_3_0')
GL_TEXTURE_GREEN_TYPE = Enumerant('GL_TEXTURE_GREEN_TYPE', 0x8c11, 'GL_VERSION_3_0')
GL_TEXTURE_INTENSITY_TYPE = Enumerant('GL_TEXTURE_INTENSITY_TYPE', 0x8c15, 'GL_VERSION_3_0')
GL_TEXTURE_LUMINANCE_TYPE = Enumerant('GL_TEXTURE_LUMINANCE_TYPE', 0x8c14, 'GL_VERSION_3_0')
GL_TEXTURE_RED_TYPE = Enumerant('GL_TEXTURE_RED_TYPE', 0x8c10, 'GL_VERSION_3_0')
GL_TEXTURE_SHARED_SIZE = Enumerant('GL_TEXTURE_SHARED_SIZE', 0x8c3f, 'GL_VERSION_3_0')
GL_TRANSFORM_FEEDBACK_BUFFER = Enumerant('GL_TRANSFORM_FEEDBACK_BUFFER', 0x8c8e, 'GL_VERSION_3_0')
GL_TRANSFORM_FEEDBACK_BUFFER_BINDING = Enumerant('GL_TRANSFORM_FEEDBACK_BUFFER_BINDING', 0x8c8f, 'GL_VERSION_3_0')
GL_TRANSFORM_FEEDBACK_BUFFER_MODE = Enumerant('GL_TRANSFORM_FEEDBACK_BUFFER_MODE', 0x8c7f, 'GL_VERSION_3_0')
GL_TRANSFORM_FEEDBACK_BUFFER_SIZE = Enumerant('GL_TRANSFORM_FEEDBACK_BUFFER_SIZE', 0x8c85, 'GL_VERSION_3_0')
GL_TRANSFORM_FEEDBACK_BUFFER_START = Enumerant('GL_TRANSFORM_FEEDBACK_BUFFER_START', 0x8c84, 'GL_VERSION_3_0')
GL_TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN = Enumerant('GL_TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN', 0x8c88, 'GL_VERSION_3_0')
GL_TRANSFORM_FEEDBACK_VARYINGS = Enumerant('GL_TRANSFORM_FEEDBACK_VARYINGS', 0x8c83, 'GL_VERSION_3_0')
GL_TRANSFORM_FEEDBACK_VARYING_MAX_LENGTH = Enumerant('GL_TRANSFORM_FEEDBACK_VARYING_MAX_LENGTH', 0x8c76, 'GL_VERSION_3_0')
GL_UNSIGNED_INT_10F_11F_11F_REV = Enumerant('GL_UNSIGNED_INT_10F_11F_11F_REV', 0x8c3b, 'GL_VERSION_3_0')
GL_UNSIGNED_INT_5_9_9_9_REV = Enumerant('GL_UNSIGNED_INT_5_9_9_9_REV', 0x8c3e, 'GL_VERSION_3_0')
GL_UNSIGNED_INT_SAMPLER_1D = Enumerant('GL_UNSIGNED_INT_SAMPLER_1D', 0x8dd1, 'GL_VERSION_3_0')
GL_UNSIGNED_INT_SAMPLER_1D_ARRAY = Enumerant('GL_UNSIGNED_INT_SAMPLER_1D_ARRAY', 0x8dd6, 'GL_VERSION_3_0')
GL_UNSIGNED_INT_SAMPLER_2D = Enumerant('GL_UNSIGNED_INT_SAMPLER_2D', 0x8dd2, 'GL_VERSION_3_0')
GL_UNSIGNED_INT_SAMPLER_2D_ARRAY = Enumerant('GL_UNSIGNED_INT_SAMPLER_2D_ARRAY', 0x8dd7, 'GL_VERSION_3_0')
GL_UNSIGNED_INT_SAMPLER_3D = Enumerant('GL_UNSIGNED_INT_SAMPLER_3D', 0x8dd3, 'GL_VERSION_3_0')
GL_UNSIGNED_INT_SAMPLER_CUBE = Enumerant('GL_UNSIGNED_INT_SAMPLER_CUBE', 0x8dd4, 'GL_VERSION_3_0')
GL_UNSIGNED_INT_VEC2 = Enumerant('GL_UNSIGNED_INT_VEC2', 0x8dc6, 'GL_VERSION_3_0')
GL_UNSIGNED_INT_VEC3 = Enumerant('GL_UNSIGNED_INT_VEC3', 0x8dc7, 'GL_VERSION_3_0')
GL_UNSIGNED_INT_VEC4 = Enumerant('GL_UNSIGNED_INT_VEC4', 0x8dc8, 'GL_VERSION_3_0')
GL_VERTEX_ATTRIB_ARRAY_INTEGER = Enumerant('GL_VERTEX_ATTRIB_ARRAY_INTEGER', 0x88fd, 'GL_VERSION_3_0')

defines.add(GL_ALPHA_INTEGER)
defines.add(GL_BGRA_INTEGER)
defines.add(GL_BGR_INTEGER)
defines.add(GL_BLUE_INTEGER)
defines.add(GL_CLAMP_FRAGMENT_COLOR)
defines.add(GL_CLAMP_READ_COLOR)
defines.add(GL_CLAMP_VERTEX_COLOR)
defines.add(GL_CLIP_DISTANCE0)
defines.add(GL_CLIP_DISTANCE1)
defines.add(GL_CLIP_DISTANCE2)
defines.add(GL_CLIP_DISTANCE3)
defines.add(GL_CLIP_DISTANCE4)
defines.add(GL_CLIP_DISTANCE5)
defines.add(GL_CLIP_DISTANCE6)
defines.add(GL_CLIP_DISTANCE7)
defines.add(GL_COMPARE_REF_TO_TEXTURE)
defines.add(GL_CONTEXT_FLAGS)
defines.add(GL_CONTEXT_FLAG_FORWARD_COMPATIBLE_BIT)
defines.add(GL_DEPTH_BUFFER)
defines.add(GL_FIXED_ONLY)
defines.add(GL_GREEN_INTEGER)
defines.add(GL_INTERLEAVED_ATTRIBS)
defines.add(GL_INT_SAMPLER_1D)
defines.add(GL_INT_SAMPLER_1D_ARRAY)
defines.add(GL_INT_SAMPLER_2D)
defines.add(GL_INT_SAMPLER_2D_ARRAY)
defines.add(GL_INT_SAMPLER_3D)
defines.add(GL_INT_SAMPLER_CUBE)
defines.add(GL_MAJOR_VERSION)
defines.add(GL_MAX_ARRAY_TEXTURE_LAYERS)
defines.add(GL_MAX_CLIP_DISTANCES)
defines.add(GL_MAX_PROGRAM_TEXEL_OFFSET)
defines.add(GL_MAX_TRANSFORM_FEEDBACK_INTERLEAVED_COMPONENTS)
defines.add(GL_MAX_TRANSFORM_FEEDBACK_SEPARATE_ATTRIBS)
defines.add(GL_MAX_TRANSFORM_FEEDBACK_SEPARATE_COMPONENTS)
defines.add(GL_MAX_VARYING_COMPONENTS)
defines.add(GL_MINOR_VERSION)
defines.add(GL_MIN_PROGRAM_TEXEL_OFFSET)
defines.add(GL_NUM_EXTENSIONS)
defines.add(GL_PRIMITIVES_GENERATED)
defines.add(GL_PROXY_TEXTURE_1D_ARRAY)
defines.add(GL_PROXY_TEXTURE_2D_ARRAY)
defines.add(GL_QUERY_BY_REGION_NO_WAIT)
defines.add(GL_QUERY_BY_REGION_WAIT)
defines.add(GL_QUERY_NO_WAIT)
defines.add(GL_QUERY_WAIT)
defines.add(GL_R11F_G11F_B10F)
defines.add(GL_RASTERIZER_DISCARD)
defines.add(GL_RED_INTEGER)
defines.add(GL_RGB16F)
defines.add(GL_RGB16I)
defines.add(GL_RGB16UI)
defines.add(GL_RGB32F)
defines.add(GL_RGB32I)
defines.add(GL_RGB32UI)
defines.add(GL_RGB8I)
defines.add(GL_RGB8UI)
defines.add(GL_RGB9_E5)
defines.add(GL_RGBA16F)
defines.add(GL_RGBA16I)
defines.add(GL_RGBA16UI)
defines.add(GL_RGBA32F)
defines.add(GL_RGBA32I)
defines.add(GL_RGBA32UI)
defines.add(GL_RGBA8I)
defines.add(GL_RGBA8UI)
defines.add(GL_RGBA_INTEGER)
defines.add(GL_RGB_INTEGER)
defines.add(GL_SAMPLER_1D_ARRAY)
defines.add(GL_SAMPLER_1D_ARRAY_SHADOW)
defines.add(GL_SAMPLER_2D_ARRAY)
defines.add(GL_SAMPLER_2D_ARRAY_SHADOW)
defines.add(GL_SAMPLER_CUBE_SHADOW)
defines.add(GL_SEPARATE_ATTRIBS)
defines.add(GL_STENCIL_BUFFER)
defines.add(GL_TEXTURE_1D_ARRAY)
defines.add(GL_TEXTURE_2D_ARRAY)
defines.add(GL_TEXTURE_ALPHA_TYPE)
defines.add(GL_TEXTURE_BINDING_1D_ARRAY)
defines.add(GL_TEXTURE_BINDING_2D_ARRAY)
defines.add(GL_TEXTURE_BLUE_TYPE)
defines.add(GL_TEXTURE_DEPTH_TYPE)
defines.add(GL_TEXTURE_GREEN_TYPE)
defines.add(GL_TEXTURE_INTENSITY_TYPE)
defines.add(GL_TEXTURE_LUMINANCE_TYPE)
defines.add(GL_TEXTURE_RED_TYPE)
defines.add(GL_TEXTURE_SHARED_SIZE)
defines.add(GL_TRANSFORM_FEEDBACK_BUFFER)
defines.add(GL_TRANSFORM_FEEDBACK_BUFFER_BINDING)
defines.add(GL_TRANSFORM_FEEDBACK_BUFFER_MODE)
defines.add(GL_TRANSFORM_FEEDBACK_BUFFER_SIZE)
defines.add(GL_TRANSFORM_FEEDBACK_BUFFER_START)
defines.add(GL_TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN)
defines.add(GL_TRANSFORM_FEEDBACK_VARYINGS)
defines.add(GL_TRANSFORM_FEEDBACK_VARYING_MAX_LENGTH)
defines.add(GL_UNSIGNED_INT_10F_11F_11F_REV)
defines.add(GL_UNSIGNED_INT_5_9_9_9_REV)
defines.add(GL_UNSIGNED_INT_SAMPLER_1D)
defines.add(GL_UNSIGNED_INT_SAMPLER_1D_ARRAY)
defines.add(GL_UNSIGNED_INT_SAMPLER_2D)
defines.add(GL_UNSIGNED_INT_SAMPLER_2D_ARRAY)
defines.add(GL_UNSIGNED_INT_SAMPLER_3D)
defines.add(GL_UNSIGNED_INT_SAMPLER_CUBE)
defines.add(GL_UNSIGNED_INT_VEC2)
defines.add(GL_UNSIGNED_INT_VEC3)
defines.add(GL_UNSIGNED_INT_VEC4)
defines.add(GL_VERTEX_ATTRIB_ARRAY_INTEGER)

# GL_VERSION_3_1

GL_BUFFER_ACCESS_FLAGS = Enumerant('GL_BUFFER_ACCESS_FLAGS', 0x911f, 'GL_VERSION_3_1')
GL_BUFFER_MAP_LENGTH = Enumerant('GL_BUFFER_MAP_LENGTH', 0x9120, 'GL_VERSION_3_1')
GL_BUFFER_MAP_OFFSET = Enumerant('GL_BUFFER_MAP_OFFSET', 0x9121, 'GL_VERSION_3_1')
GL_INT_SAMPLER_2D_RECT = Enumerant('GL_INT_SAMPLER_2D_RECT', 0x8dcd, 'GL_VERSION_3_1')
GL_INT_SAMPLER_BUFFER = Enumerant('GL_INT_SAMPLER_BUFFER', 0x8dd0, 'GL_VERSION_3_1')
GL_MAX_RECTANGLE_TEXTURE_SIZE = Enumerant('GL_MAX_RECTANGLE_TEXTURE_SIZE', 0x84f8, 'GL_VERSION_3_1')
GL_MAX_TEXTURE_BUFFER_SIZE = Enumerant('GL_MAX_TEXTURE_BUFFER_SIZE', 0x8c2b, 'GL_VERSION_3_1')
GL_PRIMITIVE_RESTART = Enumerant('GL_PRIMITIVE_RESTART', 0x8f9d, 'GL_VERSION_3_1')
GL_PRIMITIVE_RESTART.enableCap = True
GL_PRIMITIVE_RESTART_INDEX = Enumerant('GL_PRIMITIVE_RESTART_INDEX', 0x8f9e, 'GL_VERSION_3_1')
GL_PROXY_TEXTURE_RECTANGLE = Enumerant('GL_PROXY_TEXTURE_RECTANGLE', 0x84f7, 'GL_VERSION_3_1')
GL_SAMPLER_2D_RECT = Enumerant('GL_SAMPLER_2D_RECT', 0x8b63, 'GL_VERSION_3_1')
GL_SAMPLER_2D_RECT_SHADOW = Enumerant('GL_SAMPLER_2D_RECT_SHADOW', 0x8b64, 'GL_VERSION_3_1')
GL_SAMPLER_BUFFER = Enumerant('GL_SAMPLER_BUFFER', 0x8dc2, 'GL_VERSION_3_1')
GL_TEXTURE_BINDING_BUFFER = Enumerant('GL_TEXTURE_BINDING_BUFFER', 0x8c2c, 'GL_VERSION_3_1')
GL_TEXTURE_BINDING_RECTANGLE = Enumerant('GL_TEXTURE_BINDING_RECTANGLE', 0x84f6, 'GL_VERSION_3_1')
GL_TEXTURE_BUFFER = Enumerant('GL_TEXTURE_BUFFER', 0x8c2a, 'GL_VERSION_3_1')
GL_TEXTURE_BUFFER_DATA_STORE_BINDING = Enumerant('GL_TEXTURE_BUFFER_DATA_STORE_BINDING', 0x8c2d, 'GL_VERSION_3_1')
GL_TEXTURE_BUFFER_FORMAT = Enumerant('GL_TEXTURE_BUFFER_FORMAT', 0x8c2e, 'GL_VERSION_3_1')
GL_TEXTURE_RECTANGLE = Enumerant('GL_TEXTURE_RECTANGLE', 0x84f5, 'GL_VERSION_3_1')
GL_UNSIGNED_INT_SAMPLER_2D_RECT = Enumerant('GL_UNSIGNED_INT_SAMPLER_2D_RECT', 0x8dd5, 'GL_VERSION_3_1')
GL_UNSIGNED_INT_SAMPLER_BUFFER = Enumerant('GL_UNSIGNED_INT_SAMPLER_BUFFER', 0x8dd8, 'GL_VERSION_3_1')

defines.add(GL_BUFFER_ACCESS_FLAGS)
defines.add(GL_BUFFER_MAP_LENGTH)
defines.add(GL_BUFFER_MAP_OFFSET)
defines.add(GL_INT_SAMPLER_2D_RECT)
defines.add(GL_INT_SAMPLER_BUFFER)
defines.add(GL_MAX_RECTANGLE_TEXTURE_SIZE)
defines.add(GL_MAX_TEXTURE_BUFFER_SIZE)
defines.add(GL_PRIMITIVE_RESTART)
defines.add(GL_PRIMITIVE_RESTART_INDEX)
defines.add(GL_PROXY_TEXTURE_RECTANGLE)
defines.add(GL_SAMPLER_2D_RECT)
defines.add(GL_SAMPLER_2D_RECT_SHADOW)
defines.add(GL_SAMPLER_BUFFER)
defines.add(GL_TEXTURE_BINDING_BUFFER)
defines.add(GL_TEXTURE_BINDING_RECTANGLE)
defines.add(GL_TEXTURE_BUFFER)
defines.add(GL_TEXTURE_BUFFER_DATA_STORE_BINDING)
defines.add(GL_TEXTURE_BUFFER_FORMAT)
defines.add(GL_TEXTURE_RECTANGLE)
defines.add(GL_UNSIGNED_INT_SAMPLER_2D_RECT)
defines.add(GL_UNSIGNED_INT_SAMPLER_BUFFER)

# GL_VERSION_3_2

GL_CONTEXT_COMPATIBILITY_PROFILE_BIT = Enumerant('GL_CONTEXT_COMPATIBILITY_PROFILE_BIT', 0x0002, 'GL_VERSION_3_2')
GL_CONTEXT_CORE_PROFILE_BIT = Enumerant('GL_CONTEXT_CORE_PROFILE_BIT', 0x0001, 'GL_VERSION_3_2')
GL_CONTEXT_PROFILE_MASK = Enumerant('GL_CONTEXT_PROFILE_MASK', 0x9126, 'GL_VERSION_3_2')
GL_FRAMEBUFFER_ATTACHMENT_LAYERED = Enumerant('GL_FRAMEBUFFER_ATTACHMENT_LAYERED', 0x8da7, 'GL_VERSION_3_2')
GL_FRAMEBUFFER_INCOMPLETE_LAYER_TARGETS = Enumerant('GL_FRAMEBUFFER_INCOMPLETE_LAYER_TARGETS', 0x8da8, 'GL_VERSION_3_2')
GL_GEOMETRY_INPUT_TYPE = Enumerant('GL_GEOMETRY_INPUT_TYPE', 0x8917, 'GL_VERSION_3_2')
GL_GEOMETRY_OUTPUT_TYPE = Enumerant('GL_GEOMETRY_OUTPUT_TYPE', 0x8918, 'GL_VERSION_3_2')
GL_GEOMETRY_SHADER = Enumerant('GL_GEOMETRY_SHADER', 0x8dd9, 'GL_VERSION_3_2')
GL_GEOMETRY_VERTICES_OUT = Enumerant('GL_GEOMETRY_VERTICES_OUT', 0x8916, 'GL_VERSION_3_2')
GL_LINES_ADJACENCY = Enumerant('GL_LINES_ADJACENCY', 0x000a, 'GL_VERSION_3_2')
GL_LINE_STRIP_ADJACENCY = Enumerant('GL_LINE_STRIP_ADJACENCY', 0x000b, 'GL_VERSION_3_2')
GL_MAX_FRAGMENT_INPUT_COMPONENTS = Enumerant('GL_MAX_FRAGMENT_INPUT_COMPONENTS', 0x9125, 'GL_VERSION_3_2')
GL_MAX_GEOMETRY_INPUT_COMPONENTS = Enumerant('GL_MAX_GEOMETRY_INPUT_COMPONENTS', 0x9123, 'GL_VERSION_3_2')
GL_MAX_GEOMETRY_OUTPUT_COMPONENTS = Enumerant('GL_MAX_GEOMETRY_OUTPUT_COMPONENTS', 0x9124, 'GL_VERSION_3_2')
GL_MAX_GEOMETRY_OUTPUT_VERTICES = Enumerant('GL_MAX_GEOMETRY_OUTPUT_VERTICES', 0x8de0, 'GL_VERSION_3_2')
GL_MAX_GEOMETRY_TEXTURE_IMAGE_UNITS = Enumerant('GL_MAX_GEOMETRY_TEXTURE_IMAGE_UNITS', 0x8c29, 'GL_VERSION_3_2')
GL_MAX_GEOMETRY_TOTAL_OUTPUT_COMPONENTS = Enumerant('GL_MAX_GEOMETRY_TOTAL_OUTPUT_COMPONENTS', 0x8de1, 'GL_VERSION_3_2')
GL_MAX_GEOMETRY_UNIFORM_COMPONENTS = Enumerant('GL_MAX_GEOMETRY_UNIFORM_COMPONENTS', 0x8ddf, 'GL_VERSION_3_2')
GL_MAX_VERTEX_OUTPUT_COMPONENTS = Enumerant('GL_MAX_VERTEX_OUTPUT_COMPONENTS', 0x9122, 'GL_VERSION_3_2')
GL_PROGRAM_POINT_SIZE = Enumerant('GL_PROGRAM_POINT_SIZE', 0x8642, 'GL_VERSION_3_2')
GL_PROGRAM_POINT_SIZE.enableCap = True
GL_TRIANGLES_ADJACENCY = Enumerant('GL_TRIANGLES_ADJACENCY', 0x000c, 'GL_VERSION_3_2')
GL_TRIANGLE_STRIP_ADJACENCY = Enumerant('GL_TRIANGLE_STRIP_ADJACENCY', 0x000d, 'GL_VERSION_3_2')

defines.add(GL_CONTEXT_COMPATIBILITY_PROFILE_BIT)
defines.add(GL_CONTEXT_CORE_PROFILE_BIT)
defines.add(GL_CONTEXT_PROFILE_MASK)
defines.add(GL_FRAMEBUFFER_ATTACHMENT_LAYERED)
defines.add(GL_FRAMEBUFFER_INCOMPLETE_LAYER_TARGETS)
defines.add(GL_GEOMETRY_INPUT_TYPE)
defines.add(GL_GEOMETRY_OUTPUT_TYPE)
defines.add(GL_GEOMETRY_SHADER)
defines.add(GL_GEOMETRY_VERTICES_OUT)
defines.add(GL_LINES_ADJACENCY)
defines.add(GL_LINE_STRIP_ADJACENCY)
defines.add(GL_MAX_FRAGMENT_INPUT_COMPONENTS)
defines.add(GL_MAX_GEOMETRY_INPUT_COMPONENTS)
defines.add(GL_MAX_GEOMETRY_OUTPUT_COMPONENTS)
defines.add(GL_MAX_GEOMETRY_OUTPUT_VERTICES)
defines.add(GL_MAX_GEOMETRY_TEXTURE_IMAGE_UNITS)
defines.add(GL_MAX_GEOMETRY_TOTAL_OUTPUT_COMPONENTS)
defines.add(GL_MAX_GEOMETRY_UNIFORM_COMPONENTS)
defines.add(GL_MAX_VERTEX_OUTPUT_COMPONENTS)
defines.add(GL_PROGRAM_POINT_SIZE)
defines.add(GL_TRIANGLES_ADJACENCY)
defines.add(GL_TRIANGLE_STRIP_ADJACENCY)

# GL_VERSION_3_3

GL_VERTEX_ATTRIB_ARRAY_DIVISOR = Enumerant('GL_VERTEX_ATTRIB_ARRAY_DIVISOR', 0x88fe, 'GL_VERSION_3_3')

defines.add(GL_VERTEX_ATTRIB_ARRAY_DIVISOR)

# GL_VERSION_4_0

GL_INT_SAMPLER_CUBE_MAP_ARRAY = Enumerant('GL_INT_SAMPLER_CUBE_MAP_ARRAY', 0x900e, 'GL_VERSION_4_0')
GL_MAX_PROGRAM_TEXTURE_GATHER_COMPONENTS = Enumerant('GL_MAX_PROGRAM_TEXTURE_GATHER_COMPONENTS', 0x8f9f, 'GL_VERSION_4_0')
GL_MAX_PROGRAM_TEXTURE_GATHER_OFFSET = Enumerant('GL_MAX_PROGRAM_TEXTURE_GATHER_OFFSET', 0x8e5f, 'GL_VERSION_4_0')
GL_MIN_PROGRAM_TEXTURE_GATHER_OFFSET = Enumerant('GL_MIN_PROGRAM_TEXTURE_GATHER_OFFSET', 0x8e5e, 'GL_VERSION_4_0')
GL_MIN_SAMPLE_SHADING_VALUE = Enumerant('GL_MIN_SAMPLE_SHADING_VALUE', 0x8c37, 'GL_VERSION_4_0')
GL_PROXY_TEXTURE_CUBE_MAP_ARRAY = Enumerant('GL_PROXY_TEXTURE_CUBE_MAP_ARRAY', 0x900b, 'GL_VERSION_4_0')
GL_SAMPLER_CUBE_MAP_ARRAY = Enumerant('GL_SAMPLER_CUBE_MAP_ARRAY', 0x900c, 'GL_VERSION_4_0')
GL_SAMPLER_CUBE_MAP_ARRAY_SHADOW = Enumerant('GL_SAMPLER_CUBE_MAP_ARRAY_SHADOW', 0x900d, 'GL_VERSION_4_0')
GL_SAMPLE_SHADING = Enumerant('GL_SAMPLE_SHADING', 0x8c36, 'GL_VERSION_4_0')
GL_TEXTURE_BINDING_CUBE_MAP_ARRAY = Enumerant('GL_TEXTURE_BINDING_CUBE_MAP_ARRAY', 0x900a, 'GL_VERSION_4_0')
GL_TEXTURE_CUBE_MAP_ARRAY = Enumerant('GL_TEXTURE_CUBE_MAP_ARRAY', 0x9009, 'GL_VERSION_4_0')
GL_UNSIGNED_INT_SAMPLER_CUBE_MAP_ARRAY = Enumerant('GL_UNSIGNED_INT_SAMPLER_CUBE_MAP_ARRAY', 0x900f, 'GL_VERSION_4_0')

defines.add(GL_INT_SAMPLER_CUBE_MAP_ARRAY)
defines.add(GL_MAX_PROGRAM_TEXTURE_GATHER_COMPONENTS)
defines.add(GL_MAX_PROGRAM_TEXTURE_GATHER_OFFSET)
defines.add(GL_MIN_PROGRAM_TEXTURE_GATHER_OFFSET)
defines.add(GL_MIN_SAMPLE_SHADING_VALUE)
defines.add(GL_PROXY_TEXTURE_CUBE_MAP_ARRAY)
defines.add(GL_SAMPLER_CUBE_MAP_ARRAY)
defines.add(GL_SAMPLER_CUBE_MAP_ARRAY_SHADOW)
defines.add(GL_SAMPLE_SHADING)
defines.add(GL_TEXTURE_BINDING_CUBE_MAP_ARRAY)
defines.add(GL_TEXTURE_CUBE_MAP_ARRAY)
defines.add(GL_UNSIGNED_INT_SAMPLER_CUBE_MAP_ARRAY)

# GL_VERSION_4_2

GL_COMPRESSED_RGBA_BPTC_UNORM = Enumerant('GL_COMPRESSED_RGBA_BPTC_UNORM', 0x8e8c, 'GL_VERSION_4_2')
GL_COMPRESSED_RGB_BPTC_SIGNED_FLOAT = Enumerant('GL_COMPRESSED_RGB_BPTC_SIGNED_FLOAT', 0x8e8e, 'GL_VERSION_4_2')
GL_COMPRESSED_RGB_BPTC_UNSIGNED_FLOAT = Enumerant('GL_COMPRESSED_RGB_BPTC_UNSIGNED_FLOAT', 0x8e8f, 'GL_VERSION_4_2')
GL_COMPRESSED_SRGB_ALPHA_BPTC_UNORM = Enumerant('GL_COMPRESSED_SRGB_ALPHA_BPTC_UNORM', 0x8e8d, 'GL_VERSION_4_2')

defines.add(GL_COMPRESSED_RGBA_BPTC_UNORM)
defines.add(GL_COMPRESSED_RGB_BPTC_SIGNED_FLOAT)
defines.add(GL_COMPRESSED_RGB_BPTC_UNSIGNED_FLOAT)
defines.add(GL_COMPRESSED_SRGB_ALPHA_BPTC_UNORM)

# GL_VERSION_4_3

GL_NUM_SHADING_LANGUAGE_VERSIONS = Enumerant('GL_NUM_SHADING_LANGUAGE_VERSIONS', 0x82e9, 'GL_VERSION_4_3')
GL_VERTEX_ATTRIB_ARRAY_LONG = Enumerant('GL_VERTEX_ATTRIB_ARRAY_LONG', 0x874e, 'GL_VERSION_4_3')

defines.add(GL_NUM_SHADING_LANGUAGE_VERSIONS)
defines.add(GL_VERTEX_ATTRIB_ARRAY_LONG)

# GL_VERSION_4_4

GL_MAX_VERTEX_ATTRIB_STRIDE = Enumerant('GL_MAX_VERTEX_ATTRIB_STRIDE', 0x82e5, 'GL_VERSION_4_4')
GL_PRIMITIVE_RESTART_FOR_PATCHES_SUPPORTED = Enumerant('GL_PRIMITIVE_RESTART_FOR_PATCHES_SUPPORTED', 0x8221, 'GL_VERSION_4_4')
GL_TEXTURE_BUFFER_BINDING = Enumerant('GL_TEXTURE_BUFFER_BINDING', 0x8c2a, 'GL_VERSION_4_4')

defines.add(GL_MAX_VERTEX_ATTRIB_STRIDE)
defines.add(GL_PRIMITIVE_RESTART_FOR_PATCHES_SUPPORTED)
defines.add(GL_TEXTURE_BUFFER_BINDING)

# GL_3DFX_multisample

GL_MULTISAMPLE_3DFX = Enumerant('GL_MULTISAMPLE_3DFX', 0x86b2, 'GL_3DFX_multisample')
GL_MULTISAMPLE_BIT_3DFX = Enumerant('GL_MULTISAMPLE_BIT_3DFX', 0x20000000, 'GL_3DFX_multisample')
GL_SAMPLES_3DFX = Enumerant('GL_SAMPLES_3DFX', 0x86b4, 'GL_3DFX_multisample')
GL_SAMPLE_BUFFERS_3DFX = Enumerant('GL_SAMPLE_BUFFERS_3DFX', 0x86b3, 'GL_3DFX_multisample')

defines.add(GL_MULTISAMPLE_3DFX)
defines.add(GL_MULTISAMPLE_BIT_3DFX)
defines.add(GL_SAMPLES_3DFX)
defines.add(GL_SAMPLE_BUFFERS_3DFX)

# GL_3DFX_texture_compression_FXT1

GL_COMPRESSED_RGBA_FXT1_3DFX = Enumerant('GL_COMPRESSED_RGBA_FXT1_3DFX', 0x86b1, 'GL_3DFX_texture_compression_FXT1')
GL_COMPRESSED_RGB_FXT1_3DFX = Enumerant('GL_COMPRESSED_RGB_FXT1_3DFX', 0x86b0, 'GL_3DFX_texture_compression_FXT1')

defines.add(GL_COMPRESSED_RGBA_FXT1_3DFX)
defines.add(GL_COMPRESSED_RGB_FXT1_3DFX)

# GL_AMD_blend_minmax_factor

GL_FACTOR_MAX_AMD = Enumerant('GL_FACTOR_MAX_AMD', 0x901d, 'GL_AMD_blend_minmax_factor')
GL_FACTOR_MIN_AMD = Enumerant('GL_FACTOR_MIN_AMD', 0x901c, 'GL_AMD_blend_minmax_factor')

defines.add(GL_FACTOR_MAX_AMD)
defines.add(GL_FACTOR_MIN_AMD)

# GL_AMD_compressed_3DC_texture

GL_3DC_XY_AMD = Enumerant('GL_3DC_XY_AMD', 0x87fa, 'GL_AMD_compressed_3DC_texture')
GL_3DC_X_AMD = Enumerant('GL_3DC_X_AMD', 0x87f9, 'GL_AMD_compressed_3DC_texture')

defines.add(GL_3DC_XY_AMD)
defines.add(GL_3DC_X_AMD)

# GL_AMD_compressed_ATC_texture

GL_ATC_RGBA_EXPLICIT_ALPHA_AMD = Enumerant('GL_ATC_RGBA_EXPLICIT_ALPHA_AMD', 0x8c93, 'GL_AMD_compressed_ATC_texture')
GL_ATC_RGBA_INTERPOLATED_ALPHA_AMD = Enumerant('GL_ATC_RGBA_INTERPOLATED_ALPHA_AMD', 0x87ee, 'GL_AMD_compressed_ATC_texture')
GL_ATC_RGB_AMD = Enumerant('GL_ATC_RGB_AMD', 0x8c92, 'GL_AMD_compressed_ATC_texture')

defines.add(GL_ATC_RGBA_EXPLICIT_ALPHA_AMD)
defines.add(GL_ATC_RGBA_INTERPOLATED_ALPHA_AMD)
defines.add(GL_ATC_RGB_AMD)

# GL_AMD_debug_output

GL_DEBUG_CATEGORY_API_ERROR_AMD = Enumerant('GL_DEBUG_CATEGORY_API_ERROR_AMD', 0x9149, 'GL_AMD_debug_output')
GL_DEBUG_CATEGORY_APPLICATION_AMD = Enumerant('GL_DEBUG_CATEGORY_APPLICATION_AMD', 0x914f, 'GL_AMD_debug_output')
GL_DEBUG_CATEGORY_DEPRECATION_AMD = Enumerant('GL_DEBUG_CATEGORY_DEPRECATION_AMD', 0x914b, 'GL_AMD_debug_output')
GL_DEBUG_CATEGORY_OTHER_AMD = Enumerant('GL_DEBUG_CATEGORY_OTHER_AMD', 0x9150, 'GL_AMD_debug_output')
GL_DEBUG_CATEGORY_PERFORMANCE_AMD = Enumerant('GL_DEBUG_CATEGORY_PERFORMANCE_AMD', 0x914d, 'GL_AMD_debug_output')
GL_DEBUG_CATEGORY_SHADER_COMPILER_AMD = Enumerant('GL_DEBUG_CATEGORY_SHADER_COMPILER_AMD', 0x914e, 'GL_AMD_debug_output')
GL_DEBUG_CATEGORY_UNDEFINED_BEHAVIOR_AMD = Enumerant('GL_DEBUG_CATEGORY_UNDEFINED_BEHAVIOR_AMD', 0x914c, 'GL_AMD_debug_output')
GL_DEBUG_CATEGORY_WINDOW_SYSTEM_AMD = Enumerant('GL_DEBUG_CATEGORY_WINDOW_SYSTEM_AMD', 0x914a, 'GL_AMD_debug_output')
GL_DEBUG_LOGGED_MESSAGES_AMD = Enumerant('GL_DEBUG_LOGGED_MESSAGES_AMD', 0x9145, 'GL_AMD_debug_output')
GL_DEBUG_SEVERITY_HIGH_AMD = Enumerant('GL_DEBUG_SEVERITY_HIGH_AMD', 0x9146, 'GL_AMD_debug_output')
GL_DEBUG_SEVERITY_LOW_AMD = Enumerant('GL_DEBUG_SEVERITY_LOW_AMD', 0x9148, 'GL_AMD_debug_output')
GL_DEBUG_SEVERITY_MEDIUM_AMD = Enumerant('GL_DEBUG_SEVERITY_MEDIUM_AMD', 0x9147, 'GL_AMD_debug_output')
GL_MAX_DEBUG_LOGGED_MESSAGES_AMD = Enumerant('GL_MAX_DEBUG_LOGGED_MESSAGES_AMD', 0x9144, 'GL_AMD_debug_output')
GL_MAX_DEBUG_MESSAGE_LENGTH_AMD = Enumerant('GL_MAX_DEBUG_MESSAGE_LENGTH_AMD', 0x9143, 'GL_AMD_debug_output')

defines.add(GL_DEBUG_CATEGORY_API_ERROR_AMD)
defines.add(GL_DEBUG_CATEGORY_APPLICATION_AMD)
defines.add(GL_DEBUG_CATEGORY_DEPRECATION_AMD)
defines.add(GL_DEBUG_CATEGORY_OTHER_AMD)
defines.add(GL_DEBUG_CATEGORY_PERFORMANCE_AMD)
defines.add(GL_DEBUG_CATEGORY_SHADER_COMPILER_AMD)
defines.add(GL_DEBUG_CATEGORY_UNDEFINED_BEHAVIOR_AMD)
defines.add(GL_DEBUG_CATEGORY_WINDOW_SYSTEM_AMD)
defines.add(GL_DEBUG_LOGGED_MESSAGES_AMD)
defines.add(GL_DEBUG_SEVERITY_HIGH_AMD)
defines.add(GL_DEBUG_SEVERITY_LOW_AMD)
defines.add(GL_DEBUG_SEVERITY_MEDIUM_AMD)
defines.add(GL_MAX_DEBUG_LOGGED_MESSAGES_AMD)
defines.add(GL_MAX_DEBUG_MESSAGE_LENGTH_AMD)

# GL_AMD_depth_clamp_separate

GL_DEPTH_CLAMP_FAR_AMD = Enumerant('GL_DEPTH_CLAMP_FAR_AMD', 0x901f, 'GL_AMD_depth_clamp_separate')
GL_DEPTH_CLAMP_NEAR_AMD = Enumerant('GL_DEPTH_CLAMP_NEAR_AMD', 0x901e, 'GL_AMD_depth_clamp_separate')

defines.add(GL_DEPTH_CLAMP_FAR_AMD)
defines.add(GL_DEPTH_CLAMP_NEAR_AMD)

# GL_AMD_interleaved_elements

GL_VERTEX_ELEMENT_SWIZZLE_AMD = Enumerant('GL_VERTEX_ELEMENT_SWIZZLE_AMD', 0x91a4, 'GL_AMD_interleaved_elements')
GL_VERTEX_ID_SWIZZLE_AMD = Enumerant('GL_VERTEX_ID_SWIZZLE_AMD', 0x91a5, 'GL_AMD_interleaved_elements')

defines.add(GL_VERTEX_ELEMENT_SWIZZLE_AMD)
defines.add(GL_VERTEX_ID_SWIZZLE_AMD)

# GL_AMD_name_gen_delete

GL_DATA_BUFFER_AMD = Enumerant('GL_DATA_BUFFER_AMD', 0x9151, 'GL_AMD_name_gen_delete')
GL_PERFORMANCE_MONITOR_AMD = Enumerant('GL_PERFORMANCE_MONITOR_AMD', 0x9152, 'GL_AMD_name_gen_delete')
GL_QUERY_OBJECT_AMD = Enumerant('GL_QUERY_OBJECT_AMD', 0x9153, 'GL_AMD_name_gen_delete')
GL_SAMPLER_OBJECT_AMD = Enumerant('GL_SAMPLER_OBJECT_AMD', 0x9155, 'GL_AMD_name_gen_delete')
GL_VERTEX_ARRAY_OBJECT_AMD = Enumerant('GL_VERTEX_ARRAY_OBJECT_AMD', 0x9154, 'GL_AMD_name_gen_delete')

defines.add(GL_DATA_BUFFER_AMD)
defines.add(GL_PERFORMANCE_MONITOR_AMD)
defines.add(GL_QUERY_OBJECT_AMD)
defines.add(GL_SAMPLER_OBJECT_AMD)
defines.add(GL_VERTEX_ARRAY_OBJECT_AMD)

# GL_AMD_performance_monitor

GL_COUNTER_RANGE_AMD = Enumerant('GL_COUNTER_RANGE_AMD', 0x8bc1, 'GL_AMD_performance_monitor')
GL_COUNTER_TYPE_AMD = Enumerant('GL_COUNTER_TYPE_AMD', 0x8bc0, 'GL_AMD_performance_monitor')
GL_PERCENTAGE_AMD = Enumerant('GL_PERCENTAGE_AMD', 0x8bc3, 'GL_AMD_performance_monitor')
GL_PERFMON_RESULT_AMD = Enumerant('GL_PERFMON_RESULT_AMD', 0x8bc6, 'GL_AMD_performance_monitor')
GL_PERFMON_RESULT_AVAILABLE_AMD = Enumerant('GL_PERFMON_RESULT_AVAILABLE_AMD', 0x8bc4, 'GL_AMD_performance_monitor')
GL_PERFMON_RESULT_SIZE_AMD = Enumerant('GL_PERFMON_RESULT_SIZE_AMD', 0x8bc5, 'GL_AMD_performance_monitor')
GL_UNSIGNED_INT64_AMD = Enumerant('GL_UNSIGNED_INT64_AMD', 0x8bc2, 'GL_AMD_performance_monitor')

defines.add(GL_COUNTER_RANGE_AMD)
defines.add(GL_COUNTER_TYPE_AMD)
defines.add(GL_PERCENTAGE_AMD)
defines.add(GL_PERFMON_RESULT_AMD)
defines.add(GL_PERFMON_RESULT_AVAILABLE_AMD)
defines.add(GL_PERFMON_RESULT_SIZE_AMD)
defines.add(GL_UNSIGNED_INT64_AMD)

# GL_AMD_pinned_memory

GL_EXTERNAL_VIRTUAL_MEMORY_BUFFER_AMD = Enumerant('GL_EXTERNAL_VIRTUAL_MEMORY_BUFFER_AMD', 0x9160, 'GL_AMD_pinned_memory')

defines.add(GL_EXTERNAL_VIRTUAL_MEMORY_BUFFER_AMD)

# GL_AMD_program_binary_Z400

GL_Z400_BINARY_AMD = Enumerant('GL_Z400_BINARY_AMD', 0x8740, 'GL_AMD_program_binary_Z400')

defines.add(GL_Z400_BINARY_AMD)

# GL_AMD_query_buffer_object

GL_QUERY_BUFFER_AMD = Enumerant('GL_QUERY_BUFFER_AMD', 0x9192, 'GL_AMD_query_buffer_object')
GL_QUERY_BUFFER_BINDING_AMD = Enumerant('GL_QUERY_BUFFER_BINDING_AMD', 0x9193, 'GL_AMD_query_buffer_object')
GL_QUERY_RESULT_NO_WAIT_AMD = Enumerant('GL_QUERY_RESULT_NO_WAIT_AMD', 0x9194, 'GL_AMD_query_buffer_object')

defines.add(GL_QUERY_BUFFER_AMD)
defines.add(GL_QUERY_BUFFER_BINDING_AMD)
defines.add(GL_QUERY_RESULT_NO_WAIT_AMD)

# GL_AMD_sample_positions

GL_SUBSAMPLE_DISTANCE_AMD = Enumerant('GL_SUBSAMPLE_DISTANCE_AMD', 0x883f, 'GL_AMD_sample_positions')

defines.add(GL_SUBSAMPLE_DISTANCE_AMD)

# GL_AMD_seamless_cubemap_per_texture

GL_TEXTURE_CUBE_MAP_SEAMLESS_ARB = Enumerant('GL_TEXTURE_CUBE_MAP_SEAMLESS_ARB', 0x884f, 'GL_AMD_seamless_cubemap_per_texture')

defines.add(GL_TEXTURE_CUBE_MAP_SEAMLESS_ARB)

# GL_AMD_sparse_texture

GL_MAX_SPARSE_3D_TEXTURE_SIZE_AMD = Enumerant('GL_MAX_SPARSE_3D_TEXTURE_SIZE_AMD', 0x9199, 'GL_AMD_sparse_texture')
GL_MAX_SPARSE_ARRAY_TEXTURE_LAYERS = Enumerant('GL_MAX_SPARSE_ARRAY_TEXTURE_LAYERS', 0x919a, 'GL_AMD_sparse_texture')
GL_MAX_SPARSE_TEXTURE_SIZE_AMD = Enumerant('GL_MAX_SPARSE_TEXTURE_SIZE_AMD', 0x9198, 'GL_AMD_sparse_texture')
GL_MIN_LOD_WARNING_AMD = Enumerant('GL_MIN_LOD_WARNING_AMD', 0x919c, 'GL_AMD_sparse_texture')
GL_MIN_SPARSE_LEVEL_AMD = Enumerant('GL_MIN_SPARSE_LEVEL_AMD', 0x919b, 'GL_AMD_sparse_texture')
GL_TEXTURE_STORAGE_SPARSE_BIT_AMD = Enumerant('GL_TEXTURE_STORAGE_SPARSE_BIT_AMD', 0x0001, 'GL_AMD_sparse_texture')
GL_VIRTUAL_PAGE_SIZE_X_AMD = Enumerant('GL_VIRTUAL_PAGE_SIZE_X_AMD', 0x9195, 'GL_AMD_sparse_texture')
GL_VIRTUAL_PAGE_SIZE_Y_AMD = Enumerant('GL_VIRTUAL_PAGE_SIZE_Y_AMD', 0x9196, 'GL_AMD_sparse_texture')
GL_VIRTUAL_PAGE_SIZE_Z_AMD = Enumerant('GL_VIRTUAL_PAGE_SIZE_Z_AMD', 0x9197, 'GL_AMD_sparse_texture')

defines.add(GL_MAX_SPARSE_3D_TEXTURE_SIZE_AMD)
defines.add(GL_MAX_SPARSE_ARRAY_TEXTURE_LAYERS)
defines.add(GL_MAX_SPARSE_TEXTURE_SIZE_AMD)
defines.add(GL_MIN_LOD_WARNING_AMD)
defines.add(GL_MIN_SPARSE_LEVEL_AMD)
defines.add(GL_TEXTURE_STORAGE_SPARSE_BIT_AMD)
defines.add(GL_VIRTUAL_PAGE_SIZE_X_AMD)
defines.add(GL_VIRTUAL_PAGE_SIZE_Y_AMD)
defines.add(GL_VIRTUAL_PAGE_SIZE_Z_AMD)

# GL_AMD_stencil_operation_extended

GL_REPLACE_VALUE_AMD = Enumerant('GL_REPLACE_VALUE_AMD', 0x874b, 'GL_AMD_stencil_operation_extended')
GL_SET_AMD = Enumerant('GL_SET_AMD', 0x874a, 'GL_AMD_stencil_operation_extended')
GL_STENCIL_BACK_OP_VALUE_AMD = Enumerant('GL_STENCIL_BACK_OP_VALUE_AMD', 0x874d, 'GL_AMD_stencil_operation_extended')
GL_STENCIL_OP_VALUE_AMD = Enumerant('GL_STENCIL_OP_VALUE_AMD', 0x874c, 'GL_AMD_stencil_operation_extended')

defines.add(GL_REPLACE_VALUE_AMD)
defines.add(GL_SET_AMD)
defines.add(GL_STENCIL_BACK_OP_VALUE_AMD)
defines.add(GL_STENCIL_OP_VALUE_AMD)

# GL_AMD_vertex_shader_tessellator

GL_CONTINUOUS_AMD = Enumerant('GL_CONTINUOUS_AMD', 0x9007, 'GL_AMD_vertex_shader_tessellator')
GL_DISCRETE_AMD = Enumerant('GL_DISCRETE_AMD', 0x9006, 'GL_AMD_vertex_shader_tessellator')
GL_INT_SAMPLER_BUFFER_AMD = Enumerant('GL_INT_SAMPLER_BUFFER_AMD', 0x9002, 'GL_AMD_vertex_shader_tessellator')
GL_SAMPLER_BUFFER_AMD = Enumerant('GL_SAMPLER_BUFFER_AMD', 0x9001, 'GL_AMD_vertex_shader_tessellator')
GL_TESSELLATION_FACTOR_AMD = Enumerant('GL_TESSELLATION_FACTOR_AMD', 0x9005, 'GL_AMD_vertex_shader_tessellator')
GL_TESSELLATION_MODE_AMD = Enumerant('GL_TESSELLATION_MODE_AMD', 0x9004, 'GL_AMD_vertex_shader_tessellator')
GL_UNSIGNED_INT_SAMPLER_BUFFER_AMD = Enumerant('GL_UNSIGNED_INT_SAMPLER_BUFFER_AMD', 0x9003, 'GL_AMD_vertex_shader_tessellator')

defines.add(GL_CONTINUOUS_AMD)
defines.add(GL_DISCRETE_AMD)
defines.add(GL_INT_SAMPLER_BUFFER_AMD)
defines.add(GL_SAMPLER_BUFFER_AMD)
defines.add(GL_TESSELLATION_FACTOR_AMD)
defines.add(GL_TESSELLATION_MODE_AMD)
defines.add(GL_UNSIGNED_INT_SAMPLER_BUFFER_AMD)

# GL_ANGLE_framebuffer_blit

GL_DRAW_FRAMEBUFFER_ANGLE = Enumerant('GL_DRAW_FRAMEBUFFER_ANGLE', 0x8ca9, 'GL_ANGLE_framebuffer_blit')
GL_DRAW_FRAMEBUFFER_BINDING_ANGLE = Enumerant('GL_DRAW_FRAMEBUFFER_BINDING_ANGLE', 0x8ca6, 'GL_ANGLE_framebuffer_blit')
GL_READ_FRAMEBUFFER_ANGLE = Enumerant('GL_READ_FRAMEBUFFER_ANGLE', 0x8ca8, 'GL_ANGLE_framebuffer_blit')
GL_READ_FRAMEBUFFER_BINDING_ANGLE = Enumerant('GL_READ_FRAMEBUFFER_BINDING_ANGLE', 0x8caa, 'GL_ANGLE_framebuffer_blit')

defines.add(GL_DRAW_FRAMEBUFFER_ANGLE)
defines.add(GL_DRAW_FRAMEBUFFER_BINDING_ANGLE)
defines.add(GL_READ_FRAMEBUFFER_ANGLE)
defines.add(GL_READ_FRAMEBUFFER_BINDING_ANGLE)

# GL_ANGLE_framebuffer_multisample

GL_FRAMEBUFFER_INCOMPLETE_MULTISAMPLE_ANGLE = Enumerant('GL_FRAMEBUFFER_INCOMPLETE_MULTISAMPLE_ANGLE', 0x8d56, 'GL_ANGLE_framebuffer_multisample')
GL_MAX_SAMPLES_ANGLE = Enumerant('GL_MAX_SAMPLES_ANGLE', 0x8d57, 'GL_ANGLE_framebuffer_multisample')
GL_RENDERBUFFER_SAMPLES_ANGLE = Enumerant('GL_RENDERBUFFER_SAMPLES_ANGLE', 0x8cab, 'GL_ANGLE_framebuffer_multisample')

defines.add(GL_FRAMEBUFFER_INCOMPLETE_MULTISAMPLE_ANGLE)
defines.add(GL_MAX_SAMPLES_ANGLE)
defines.add(GL_RENDERBUFFER_SAMPLES_ANGLE)

# GL_ANGLE_instanced_arrays

GL_VERTEX_ATTRIB_ARRAY_DIVISOR_ANGLE = Enumerant('GL_VERTEX_ATTRIB_ARRAY_DIVISOR_ANGLE', 0x88fe, 'GL_ANGLE_instanced_arrays')

defines.add(GL_VERTEX_ATTRIB_ARRAY_DIVISOR_ANGLE)

# GL_ANGLE_pack_reverse_row_order

GL_PACK_REVERSE_ROW_ORDER_ANGLE = Enumerant('GL_PACK_REVERSE_ROW_ORDER_ANGLE', 0x93a4, 'GL_ANGLE_pack_reverse_row_order')

defines.add(GL_PACK_REVERSE_ROW_ORDER_ANGLE)

# GL_ANGLE_program_binary

GL_PROGRAM_BINARY_ANGLE = Enumerant('GL_PROGRAM_BINARY_ANGLE', 0x93a6, 'GL_ANGLE_program_binary')

defines.add(GL_PROGRAM_BINARY_ANGLE)

# GL_ANGLE_texture_compression_dxt1

GL_COMPRESSED_RGBA_S3TC_DXT1_ANGLE = Enumerant('GL_COMPRESSED_RGBA_S3TC_DXT1_ANGLE', 0x83f1, 'GL_ANGLE_texture_compression_dxt1')
GL_COMPRESSED_RGB_S3TC_DXT1_ANGLE = Enumerant('GL_COMPRESSED_RGB_S3TC_DXT1_ANGLE', 0x83f0, 'GL_ANGLE_texture_compression_dxt1')

defines.add(GL_COMPRESSED_RGBA_S3TC_DXT1_ANGLE)
defines.add(GL_COMPRESSED_RGB_S3TC_DXT1_ANGLE)

# GL_ANGLE_texture_compression_dxt3

GL_COMPRESSED_RGBA_S3TC_DXT3_ANGLE = Enumerant('GL_COMPRESSED_RGBA_S3TC_DXT3_ANGLE', 0x83f2, 'GL_ANGLE_texture_compression_dxt3')

defines.add(GL_COMPRESSED_RGBA_S3TC_DXT3_ANGLE)

# GL_ANGLE_texture_compression_dxt5

GL_COMPRESSED_RGBA_S3TC_DXT5_ANGLE = Enumerant('GL_COMPRESSED_RGBA_S3TC_DXT5_ANGLE', 0x83f3, 'GL_ANGLE_texture_compression_dxt5')

defines.add(GL_COMPRESSED_RGBA_S3TC_DXT5_ANGLE)

# GL_ANGLE_texture_usage

GL_FRAMEBUFFER_ATTACHMENT_ANGLE = Enumerant('GL_FRAMEBUFFER_ATTACHMENT_ANGLE', 0x93a3, 'GL_ANGLE_texture_usage')
GL_TEXTURE_USAGE_ANGLE = Enumerant('GL_TEXTURE_USAGE_ANGLE', 0x93a2, 'GL_ANGLE_texture_usage')

defines.add(GL_FRAMEBUFFER_ATTACHMENT_ANGLE)
defines.add(GL_TEXTURE_USAGE_ANGLE)

# GL_ANGLE_timer_query

GL_CURRENT_QUERY_ANGLE = Enumerant('GL_CURRENT_QUERY_ANGLE', 0x8865, 'GL_ANGLE_timer_query')
GL_QUERY_COUNTER_BITS_ANGLE = Enumerant('GL_QUERY_COUNTER_BITS_ANGLE', 0x8864, 'GL_ANGLE_timer_query')
GL_QUERY_RESULT_ANGLE = Enumerant('GL_QUERY_RESULT_ANGLE', 0x8866, 'GL_ANGLE_timer_query')
GL_QUERY_RESULT_AVAILABLE_ANGLE = Enumerant('GL_QUERY_RESULT_AVAILABLE_ANGLE', 0x8867, 'GL_ANGLE_timer_query')
GL_TIMESTAMP_ANGLE = Enumerant('GL_TIMESTAMP_ANGLE', 0x8e28, 'GL_ANGLE_timer_query')
GL_TIME_ELAPSED_ANGLE = Enumerant('GL_TIME_ELAPSED_ANGLE', 0x88bf, 'GL_ANGLE_timer_query')

defines.add(GL_CURRENT_QUERY_ANGLE)
defines.add(GL_QUERY_COUNTER_BITS_ANGLE)
defines.add(GL_QUERY_RESULT_ANGLE)
defines.add(GL_QUERY_RESULT_AVAILABLE_ANGLE)
defines.add(GL_TIMESTAMP_ANGLE)
defines.add(GL_TIME_ELAPSED_ANGLE)

# GL_ANGLE_translated_shader_source

GL_TRANSLATED_SHADER_SOURCE_LENGTH_ANGLE = Enumerant('GL_TRANSLATED_SHADER_SOURCE_LENGTH_ANGLE', 0x93a0, 'GL_ANGLE_translated_shader_source')

defines.add(GL_TRANSLATED_SHADER_SOURCE_LENGTH_ANGLE)

# GL_APPLE_aux_depth_stencil

GL_AUX_DEPTH_STENCIL_APPLE = Enumerant('GL_AUX_DEPTH_STENCIL_APPLE', 0x8a14, 'GL_APPLE_aux_depth_stencil')

defines.add(GL_AUX_DEPTH_STENCIL_APPLE)

# GL_APPLE_client_storage

GL_UNPACK_CLIENT_STORAGE_APPLE = Enumerant('GL_UNPACK_CLIENT_STORAGE_APPLE', 0x85b2, 'GL_APPLE_client_storage')

defines.add(GL_UNPACK_CLIENT_STORAGE_APPLE)

# GL_APPLE_element_array

GL_ELEMENT_ARRAY_APPLE = Enumerant('GL_ELEMENT_ARRAY_APPLE', 0x8a0c, 'GL_APPLE_element_array')
GL_ELEMENT_ARRAY_POINTER_APPLE = Enumerant('GL_ELEMENT_ARRAY_POINTER_APPLE', 0x8a0e, 'GL_APPLE_element_array')
GL_ELEMENT_ARRAY_TYPE_APPLE = Enumerant('GL_ELEMENT_ARRAY_TYPE_APPLE', 0x8a0d, 'GL_APPLE_element_array')

defines.add(GL_ELEMENT_ARRAY_APPLE)
defines.add(GL_ELEMENT_ARRAY_POINTER_APPLE)
defines.add(GL_ELEMENT_ARRAY_TYPE_APPLE)

# GL_APPLE_fence

GL_DRAW_PIXELS_APPLE = Enumerant('GL_DRAW_PIXELS_APPLE', 0x8a0a, 'GL_APPLE_fence')
GL_FENCE_APPLE = Enumerant('GL_FENCE_APPLE', 0x8a0b, 'GL_APPLE_fence')

defines.add(GL_DRAW_PIXELS_APPLE)
defines.add(GL_FENCE_APPLE)

# GL_APPLE_float_pixels

GL_ALPHA_FLOAT16_APPLE = Enumerant('GL_ALPHA_FLOAT16_APPLE', 0x881c, 'GL_APPLE_float_pixels')
GL_ALPHA_FLOAT32_APPLE = Enumerant('GL_ALPHA_FLOAT32_APPLE', 0x8816, 'GL_APPLE_float_pixels')
GL_COLOR_FLOAT_APPLE = Enumerant('GL_COLOR_FLOAT_APPLE', 0x8a0f, 'GL_APPLE_float_pixels')
GL_HALF_APPLE = Enumerant('GL_HALF_APPLE', 0x140b, 'GL_APPLE_float_pixels')
GL_INTENSITY_FLOAT16_APPLE = Enumerant('GL_INTENSITY_FLOAT16_APPLE', 0x881d, 'GL_APPLE_float_pixels')
GL_INTENSITY_FLOAT32_APPLE = Enumerant('GL_INTENSITY_FLOAT32_APPLE', 0x8817, 'GL_APPLE_float_pixels')
GL_LUMINANCE_ALPHA_FLOAT16_APPLE = Enumerant('GL_LUMINANCE_ALPHA_FLOAT16_APPLE', 0x881f, 'GL_APPLE_float_pixels')
GL_LUMINANCE_ALPHA_FLOAT32_APPLE = Enumerant('GL_LUMINANCE_ALPHA_FLOAT32_APPLE', 0x8819, 'GL_APPLE_float_pixels')
GL_LUMINANCE_FLOAT16_APPLE = Enumerant('GL_LUMINANCE_FLOAT16_APPLE', 0x881e, 'GL_APPLE_float_pixels')
GL_LUMINANCE_FLOAT32_APPLE = Enumerant('GL_LUMINANCE_FLOAT32_APPLE', 0x8818, 'GL_APPLE_float_pixels')
GL_RGBA_FLOAT16_APPLE = Enumerant('GL_RGBA_FLOAT16_APPLE', 0x881a, 'GL_APPLE_float_pixels')
GL_RGBA_FLOAT32_APPLE = Enumerant('GL_RGBA_FLOAT32_APPLE', 0x8814, 'GL_APPLE_float_pixels')
GL_RGB_FLOAT16_APPLE = Enumerant('GL_RGB_FLOAT16_APPLE', 0x881b, 'GL_APPLE_float_pixels')
GL_RGB_FLOAT32_APPLE = Enumerant('GL_RGB_FLOAT32_APPLE', 0x8815, 'GL_APPLE_float_pixels')

defines.add(GL_ALPHA_FLOAT16_APPLE)
defines.add(GL_ALPHA_FLOAT32_APPLE)
defines.add(GL_COLOR_FLOAT_APPLE)
defines.add(GL_HALF_APPLE)
defines.add(GL_INTENSITY_FLOAT16_APPLE)
defines.add(GL_INTENSITY_FLOAT32_APPLE)
defines.add(GL_LUMINANCE_ALPHA_FLOAT16_APPLE)
defines.add(GL_LUMINANCE_ALPHA_FLOAT32_APPLE)
defines.add(GL_LUMINANCE_FLOAT16_APPLE)
defines.add(GL_LUMINANCE_FLOAT32_APPLE)
defines.add(GL_RGBA_FLOAT16_APPLE)
defines.add(GL_RGBA_FLOAT32_APPLE)
defines.add(GL_RGB_FLOAT16_APPLE)
defines.add(GL_RGB_FLOAT32_APPLE)

# GL_APPLE_flush_buffer_range

GL_BUFFER_FLUSHING_UNMAP_APPLE = Enumerant('GL_BUFFER_FLUSHING_UNMAP_APPLE', 0x8a13, 'GL_APPLE_flush_buffer_range')
GL_BUFFER_SERIALIZED_MODIFY_APPLE = Enumerant('GL_BUFFER_SERIALIZED_MODIFY_APPLE', 0x8a12, 'GL_APPLE_flush_buffer_range')

defines.add(GL_BUFFER_FLUSHING_UNMAP_APPLE)
defines.add(GL_BUFFER_SERIALIZED_MODIFY_APPLE)

# GL_APPLE_framebuffer_multisample

GL_DRAW_FRAMEBUFFER_APPLE = Enumerant('GL_DRAW_FRAMEBUFFER_APPLE', 0x8ca9, 'GL_APPLE_framebuffer_multisample')
GL_DRAW_FRAMEBUFFER_BINDING_APPLE = Enumerant('GL_DRAW_FRAMEBUFFER_BINDING_APPLE', 0x8ca6, 'GL_APPLE_framebuffer_multisample')
GL_FRAMEBUFFER_INCOMPLETE_MULTISAMPLE_APPLE = Enumerant('GL_FRAMEBUFFER_INCOMPLETE_MULTISAMPLE_APPLE', 0x8d56, 'GL_APPLE_framebuffer_multisample')
GL_MAX_SAMPLES_APPLE = Enumerant('GL_MAX_SAMPLES_APPLE', 0x8d57, 'GL_APPLE_framebuffer_multisample')
GL_READ_FRAMEBUFFER_APPLE = Enumerant('GL_READ_FRAMEBUFFER_APPLE', 0x8ca8, 'GL_APPLE_framebuffer_multisample')
GL_READ_FRAMEBUFFER_BINDING_APPLE = Enumerant('GL_READ_FRAMEBUFFER_BINDING_APPLE', 0x8caa, 'GL_APPLE_framebuffer_multisample')
GL_RENDERBUFFER_SAMPLES_APPLE = Enumerant('GL_RENDERBUFFER_SAMPLES_APPLE', 0x8cab, 'GL_APPLE_framebuffer_multisample')

defines.add(GL_DRAW_FRAMEBUFFER_APPLE)
defines.add(GL_DRAW_FRAMEBUFFER_BINDING_APPLE)
defines.add(GL_FRAMEBUFFER_INCOMPLETE_MULTISAMPLE_APPLE)
defines.add(GL_MAX_SAMPLES_APPLE)
defines.add(GL_READ_FRAMEBUFFER_APPLE)
defines.add(GL_READ_FRAMEBUFFER_BINDING_APPLE)
defines.add(GL_RENDERBUFFER_SAMPLES_APPLE)

# GL_APPLE_object_purgeable

GL_BUFFER_OBJECT_APPLE = Enumerant('GL_BUFFER_OBJECT_APPLE', 0x85b3, 'GL_APPLE_object_purgeable')
GL_PURGEABLE_APPLE = Enumerant('GL_PURGEABLE_APPLE', 0x8a1d, 'GL_APPLE_object_purgeable')
GL_RELEASED_APPLE = Enumerant('GL_RELEASED_APPLE', 0x8a19, 'GL_APPLE_object_purgeable')
GL_RETAINED_APPLE = Enumerant('GL_RETAINED_APPLE', 0x8a1b, 'GL_APPLE_object_purgeable')
GL_UNDEFINED_APPLE = Enumerant('GL_UNDEFINED_APPLE', 0x8a1c, 'GL_APPLE_object_purgeable')
GL_VOLATILE_APPLE = Enumerant('GL_VOLATILE_APPLE', 0x8a1a, 'GL_APPLE_object_purgeable')

defines.add(GL_BUFFER_OBJECT_APPLE)
defines.add(GL_PURGEABLE_APPLE)
defines.add(GL_RELEASED_APPLE)
defines.add(GL_RETAINED_APPLE)
defines.add(GL_UNDEFINED_APPLE)
defines.add(GL_VOLATILE_APPLE)

# GL_APPLE_pixel_buffer

GL_MIN_PBUFFER_VIEWPORT_DIMS_APPLE = Enumerant('GL_MIN_PBUFFER_VIEWPORT_DIMS_APPLE', 0x8a10, 'GL_APPLE_pixel_buffer')

defines.add(GL_MIN_PBUFFER_VIEWPORT_DIMS_APPLE)

# GL_APPLE_rgb_422

GL_RGB_422_APPLE = Enumerant('GL_RGB_422_APPLE', 0x8a1f, 'GL_APPLE_rgb_422')

defines.add(GL_RGB_422_APPLE)

# GL_APPLE_row_bytes

GL_PACK_ROW_BYTES_APPLE = Enumerant('GL_PACK_ROW_BYTES_APPLE', 0x8a15, 'GL_APPLE_row_bytes')
GL_UNPACK_ROW_BYTES_APPLE = Enumerant('GL_UNPACK_ROW_BYTES_APPLE', 0x8a16, 'GL_APPLE_row_bytes')

defines.add(GL_PACK_ROW_BYTES_APPLE)
defines.add(GL_UNPACK_ROW_BYTES_APPLE)

# GL_APPLE_specular_vector

GL_LIGHT_MODEL_SPECULAR_VECTOR_APPLE = Enumerant('GL_LIGHT_MODEL_SPECULAR_VECTOR_APPLE', 0x85b0, 'GL_APPLE_specular_vector')

defines.add(GL_LIGHT_MODEL_SPECULAR_VECTOR_APPLE)

# GL_APPLE_sync

GL_ALREADY_SIGNALED_APPLE = Enumerant('GL_ALREADY_SIGNALED_APPLE', 0x911a, 'GL_APPLE_sync')
GL_CONDITION_SATISFIED_APPLE = Enumerant('GL_CONDITION_SATISFIED_APPLE', 0x911c, 'GL_APPLE_sync')
GL_MAX_SERVER_WAIT_TIMEOUT_APPLE = Enumerant('GL_MAX_SERVER_WAIT_TIMEOUT_APPLE', 0x9111, 'GL_APPLE_sync')
GL_OBJECT_TYPE_APPLE = Enumerant('GL_OBJECT_TYPE_APPLE', 0x9112, 'GL_APPLE_sync')
GL_SIGNALED_APPLE = Enumerant('GL_SIGNALED_APPLE', 0x9119, 'GL_APPLE_sync')
GL_SYNC_CONDITION_APPLE = Enumerant('GL_SYNC_CONDITION_APPLE', 0x9113, 'GL_APPLE_sync')
GL_SYNC_FENCE_APPLE = Enumerant('GL_SYNC_FENCE_APPLE', 0x9116, 'GL_APPLE_sync')
GL_SYNC_FLAGS_APPLE = Enumerant('GL_SYNC_FLAGS_APPLE', 0x9115, 'GL_APPLE_sync')
GL_SYNC_FLUSH_COMMANDS_BIT_APPLE = Enumerant('GL_SYNC_FLUSH_COMMANDS_BIT_APPLE', 0x0001, 'GL_APPLE_sync')
GL_SYNC_GPU_COMMANDS_COMPLETE_APPLE = Enumerant('GL_SYNC_GPU_COMMANDS_COMPLETE_APPLE', 0x9117, 'GL_APPLE_sync')
GL_SYNC_OBJECT_APPLE = Enumerant('GL_SYNC_OBJECT_APPLE', 0x8a53, 'GL_APPLE_sync')
GL_SYNC_STATUS_APPLE = Enumerant('GL_SYNC_STATUS_APPLE', 0x9114, 'GL_APPLE_sync')
GL_TIMEOUT_EXPIRED_APPLE = Enumerant('GL_TIMEOUT_EXPIRED_APPLE', 0x911b, 'GL_APPLE_sync')
GL_TIMEOUT_IGNORED_APPLE = Enumerant('GL_TIMEOUT_IGNORED_APPLE', 0xffffffffffffffff, 'GL_APPLE_sync')
GL_UNSIGNALED_APPLE = Enumerant('GL_UNSIGNALED_APPLE', 0x9118, 'GL_APPLE_sync')
GL_WAIT_FAILED_APPLE = Enumerant('GL_WAIT_FAILED_APPLE', 0x911d, 'GL_APPLE_sync')

defines.add(GL_ALREADY_SIGNALED_APPLE)
defines.add(GL_CONDITION_SATISFIED_APPLE)
defines.add(GL_MAX_SERVER_WAIT_TIMEOUT_APPLE)
defines.add(GL_OBJECT_TYPE_APPLE)
defines.add(GL_SIGNALED_APPLE)
defines.add(GL_SYNC_CONDITION_APPLE)
defines.add(GL_SYNC_FENCE_APPLE)
defines.add(GL_SYNC_FLAGS_APPLE)
defines.add(GL_SYNC_FLUSH_COMMANDS_BIT_APPLE)
defines.add(GL_SYNC_GPU_COMMANDS_COMPLETE_APPLE)
defines.add(GL_SYNC_OBJECT_APPLE)
defines.add(GL_SYNC_STATUS_APPLE)
defines.add(GL_TIMEOUT_EXPIRED_APPLE)
defines.add(GL_TIMEOUT_IGNORED_APPLE)
defines.add(GL_UNSIGNALED_APPLE)
defines.add(GL_WAIT_FAILED_APPLE)

# GL_APPLE_texture_max_level

GL_TEXTURE_MAX_LEVEL_APPLE = Enumerant('GL_TEXTURE_MAX_LEVEL_APPLE', 0x813d, 'GL_APPLE_texture_max_level')

defines.add(GL_TEXTURE_MAX_LEVEL_APPLE)

# GL_APPLE_texture_range

GL_STORAGE_PRIVATE_APPLE = Enumerant('GL_STORAGE_PRIVATE_APPLE', 0x85bd, 'GL_APPLE_texture_range')
GL_TEXTURE_RANGE_LENGTH_APPLE = Enumerant('GL_TEXTURE_RANGE_LENGTH_APPLE', 0x85b7, 'GL_APPLE_texture_range')
GL_TEXTURE_RANGE_POINTER_APPLE = Enumerant('GL_TEXTURE_RANGE_POINTER_APPLE', 0x85b8, 'GL_APPLE_texture_range')
GL_TEXTURE_STORAGE_HINT_APPLE = Enumerant('GL_TEXTURE_STORAGE_HINT_APPLE', 0x85bc, 'GL_APPLE_texture_range')

defines.add(GL_STORAGE_PRIVATE_APPLE)
defines.add(GL_TEXTURE_RANGE_LENGTH_APPLE)
defines.add(GL_TEXTURE_RANGE_POINTER_APPLE)
defines.add(GL_TEXTURE_STORAGE_HINT_APPLE)

# GL_APPLE_transform_hint

GL_TRANSFORM_HINT_APPLE = Enumerant('GL_TRANSFORM_HINT_APPLE', 0x85b1, 'GL_APPLE_transform_hint')

defines.add(GL_TRANSFORM_HINT_APPLE)

# GL_APPLE_vertex_array_object

GL_VERTEX_ARRAY_BINDING_APPLE = Enumerant('GL_VERTEX_ARRAY_BINDING_APPLE', 0x85b5, 'GL_APPLE_vertex_array_object')

defines.add(GL_VERTEX_ARRAY_BINDING_APPLE)

# GL_APPLE_vertex_array_range

GL_MAX_VERTEX_ARRAY_RANGE_ELEMENT_APPLE = Enumerant('GL_MAX_VERTEX_ARRAY_RANGE_ELEMENT_APPLE', 0x8520, 'GL_APPLE_vertex_array_range')
GL_STORAGE_CACHED_APPLE = Enumerant('GL_STORAGE_CACHED_APPLE', 0x85be, 'GL_APPLE_vertex_array_range')
GL_STORAGE_CLIENT_APPLE = Enumerant('GL_STORAGE_CLIENT_APPLE', 0x85b4, 'GL_APPLE_vertex_array_range')
GL_STORAGE_SHARED_APPLE = Enumerant('GL_STORAGE_SHARED_APPLE', 0x85bf, 'GL_APPLE_vertex_array_range')
GL_VERTEX_ARRAY_RANGE_APPLE = Enumerant('GL_VERTEX_ARRAY_RANGE_APPLE', 0x851d, 'GL_APPLE_vertex_array_range')
GL_VERTEX_ARRAY_RANGE_LENGTH_APPLE = Enumerant('GL_VERTEX_ARRAY_RANGE_LENGTH_APPLE', 0x851e, 'GL_APPLE_vertex_array_range')
GL_VERTEX_ARRAY_RANGE_POINTER_APPLE = Enumerant('GL_VERTEX_ARRAY_RANGE_POINTER_APPLE', 0x8521, 'GL_APPLE_vertex_array_range')
GL_VERTEX_ARRAY_STORAGE_HINT_APPLE = Enumerant('GL_VERTEX_ARRAY_STORAGE_HINT_APPLE', 0x851f, 'GL_APPLE_vertex_array_range')

defines.add(GL_MAX_VERTEX_ARRAY_RANGE_ELEMENT_APPLE)
defines.add(GL_STORAGE_CACHED_APPLE)
defines.add(GL_STORAGE_CLIENT_APPLE)
defines.add(GL_STORAGE_SHARED_APPLE)
defines.add(GL_VERTEX_ARRAY_RANGE_APPLE)
defines.add(GL_VERTEX_ARRAY_RANGE_LENGTH_APPLE)
defines.add(GL_VERTEX_ARRAY_RANGE_POINTER_APPLE)
defines.add(GL_VERTEX_ARRAY_STORAGE_HINT_APPLE)

# GL_APPLE_vertex_program_evaluators

GL_VERTEX_ATTRIB_MAP1_APPLE = Enumerant('GL_VERTEX_ATTRIB_MAP1_APPLE', 0x8a00, 'GL_APPLE_vertex_program_evaluators')
GL_VERTEX_ATTRIB_MAP1_COEFF_APPLE = Enumerant('GL_VERTEX_ATTRIB_MAP1_COEFF_APPLE', 0x8a03, 'GL_APPLE_vertex_program_evaluators')
GL_VERTEX_ATTRIB_MAP1_DOMAIN_APPLE = Enumerant('GL_VERTEX_ATTRIB_MAP1_DOMAIN_APPLE', 0x8a05, 'GL_APPLE_vertex_program_evaluators')
GL_VERTEX_ATTRIB_MAP1_ORDER_APPLE = Enumerant('GL_VERTEX_ATTRIB_MAP1_ORDER_APPLE', 0x8a04, 'GL_APPLE_vertex_program_evaluators')
GL_VERTEX_ATTRIB_MAP1_SIZE_APPLE = Enumerant('GL_VERTEX_ATTRIB_MAP1_SIZE_APPLE', 0x8a02, 'GL_APPLE_vertex_program_evaluators')
GL_VERTEX_ATTRIB_MAP2_APPLE = Enumerant('GL_VERTEX_ATTRIB_MAP2_APPLE', 0x8a01, 'GL_APPLE_vertex_program_evaluators')
GL_VERTEX_ATTRIB_MAP2_COEFF_APPLE = Enumerant('GL_VERTEX_ATTRIB_MAP2_COEFF_APPLE', 0x8a07, 'GL_APPLE_vertex_program_evaluators')
GL_VERTEX_ATTRIB_MAP2_DOMAIN_APPLE = Enumerant('GL_VERTEX_ATTRIB_MAP2_DOMAIN_APPLE', 0x8a09, 'GL_APPLE_vertex_program_evaluators')
GL_VERTEX_ATTRIB_MAP2_ORDER_APPLE = Enumerant('GL_VERTEX_ATTRIB_MAP2_ORDER_APPLE', 0x8a08, 'GL_APPLE_vertex_program_evaluators')
GL_VERTEX_ATTRIB_MAP2_SIZE_APPLE = Enumerant('GL_VERTEX_ATTRIB_MAP2_SIZE_APPLE', 0x8a06, 'GL_APPLE_vertex_program_evaluators')

defines.add(GL_VERTEX_ATTRIB_MAP1_APPLE)
defines.add(GL_VERTEX_ATTRIB_MAP1_COEFF_APPLE)
defines.add(GL_VERTEX_ATTRIB_MAP1_DOMAIN_APPLE)
defines.add(GL_VERTEX_ATTRIB_MAP1_ORDER_APPLE)
defines.add(GL_VERTEX_ATTRIB_MAP1_SIZE_APPLE)
defines.add(GL_VERTEX_ATTRIB_MAP2_APPLE)
defines.add(GL_VERTEX_ATTRIB_MAP2_COEFF_APPLE)
defines.add(GL_VERTEX_ATTRIB_MAP2_DOMAIN_APPLE)
defines.add(GL_VERTEX_ATTRIB_MAP2_ORDER_APPLE)
defines.add(GL_VERTEX_ATTRIB_MAP2_SIZE_APPLE)

# GL_APPLE_ycbcr_422

GL_UNSIGNED_SHORT_8_8_APPLE = Enumerant('GL_UNSIGNED_SHORT_8_8_APPLE', 0x85ba, 'GL_APPLE_ycbcr_422')
GL_UNSIGNED_SHORT_8_8_REV_APPLE = Enumerant('GL_UNSIGNED_SHORT_8_8_REV_APPLE', 0x85bb, 'GL_APPLE_ycbcr_422')
GL_YCBCR_422_APPLE = Enumerant('GL_YCBCR_422_APPLE', 0x85b9, 'GL_APPLE_ycbcr_422')

defines.add(GL_UNSIGNED_SHORT_8_8_APPLE)
defines.add(GL_UNSIGNED_SHORT_8_8_REV_APPLE)
defines.add(GL_YCBCR_422_APPLE)

# GL_ARB_ES2_compatibility

GL_FIXED = Enumerant('GL_FIXED', 0x140c, 'GL_ARB_ES2_compatibility')
GL_FIXED.esVersions = [2.0]
GL_HIGH_FLOAT = Enumerant('GL_HIGH_FLOAT', 0x8df2, 'GL_ARB_ES2_compatibility')
GL_HIGH_FLOAT.esVersions = [2.0]
GL_HIGH_INT = Enumerant('GL_HIGH_INT', 0x8df5, 'GL_ARB_ES2_compatibility')
GL_HIGH_INT.esVersions = [2.0]
GL_IMPLEMENTATION_COLOR_READ_FORMAT = Enumerant('GL_IMPLEMENTATION_COLOR_READ_FORMAT', 0x8b9b, 'GL_ARB_ES2_compatibility')
GL_IMPLEMENTATION_COLOR_READ_FORMAT.esVersions = [2.0]
GL_IMPLEMENTATION_COLOR_READ_TYPE = Enumerant('GL_IMPLEMENTATION_COLOR_READ_TYPE', 0x8b9a, 'GL_ARB_ES2_compatibility')
GL_IMPLEMENTATION_COLOR_READ_TYPE.esVersions = [2.0]
GL_LOW_FLOAT = Enumerant('GL_LOW_FLOAT', 0x8df0, 'GL_ARB_ES2_compatibility')
GL_LOW_FLOAT.esVersions = [2.0]
GL_LOW_INT = Enumerant('GL_LOW_INT', 0x8df3, 'GL_ARB_ES2_compatibility')
GL_LOW_INT.esVersions = [2.0]
GL_MAX_FRAGMENT_UNIFORM_VECTORS = Enumerant('GL_MAX_FRAGMENT_UNIFORM_VECTORS', 0x8dfd, 'GL_ARB_ES2_compatibility')
GL_MAX_FRAGMENT_UNIFORM_VECTORS.esVersions = [2.0]
GL_MAX_VARYING_VECTORS = Enumerant('GL_MAX_VARYING_VECTORS', 0x8dfc, 'GL_ARB_ES2_compatibility')
GL_MAX_VARYING_VECTORS.esVersions = [2.0]
GL_MAX_VERTEX_UNIFORM_VECTORS = Enumerant('GL_MAX_VERTEX_UNIFORM_VECTORS', 0x8dfb, 'GL_ARB_ES2_compatibility')
GL_MAX_VERTEX_UNIFORM_VECTORS.esVersions = [2.0]
GL_MEDIUM_FLOAT = Enumerant('GL_MEDIUM_FLOAT', 0x8df1, 'GL_ARB_ES2_compatibility')
GL_MEDIUM_FLOAT.esVersions = [2.0]
GL_MEDIUM_INT = Enumerant('GL_MEDIUM_INT', 0x8df4, 'GL_ARB_ES2_compatibility')
GL_MEDIUM_INT.esVersions = [2.0]
GL_NUM_SHADER_BINARY_FORMATS = Enumerant('GL_NUM_SHADER_BINARY_FORMATS', 0x8df9, 'GL_ARB_ES2_compatibility')
GL_NUM_SHADER_BINARY_FORMATS.esVersions = [2.0]
GL_RGB565 = Enumerant('GL_RGB565', 0x8d62, 'GL_ARB_ES2_compatibility')
GL_RGB565.esVersions = [2.0]
GL_SHADER_BINARY_FORMATS = Enumerant('GL_SHADER_BINARY_FORMATS', 0x8df8, 'GL_ARB_ES2_compatibility')
GL_SHADER_BINARY_FORMATS.esVersions = [2.0]
GL_SHADER_COMPILER = Enumerant('GL_SHADER_COMPILER', 0x8dfa, 'GL_ARB_ES2_compatibility')
GL_SHADER_COMPILER.esVersions = [2.0]

defines.add(GL_FIXED)
defines.add(GL_HIGH_FLOAT)
defines.add(GL_HIGH_INT)
defines.add(GL_IMPLEMENTATION_COLOR_READ_FORMAT)
defines.add(GL_IMPLEMENTATION_COLOR_READ_TYPE)
defines.add(GL_LOW_FLOAT)
defines.add(GL_LOW_INT)
defines.add(GL_MAX_FRAGMENT_UNIFORM_VECTORS)
defines.add(GL_MAX_VARYING_VECTORS)
defines.add(GL_MAX_VERTEX_UNIFORM_VECTORS)
defines.add(GL_MEDIUM_FLOAT)
defines.add(GL_MEDIUM_INT)
defines.add(GL_NUM_SHADER_BINARY_FORMATS)
defines.add(GL_RGB565)
defines.add(GL_SHADER_BINARY_FORMATS)
defines.add(GL_SHADER_COMPILER)

# GL_ARB_ES3_compatibility

GL_ANY_SAMPLES_PASSED_CONSERVATIVE = Enumerant('GL_ANY_SAMPLES_PASSED_CONSERVATIVE', 0x8d6a, 'GL_ARB_ES3_compatibility')
GL_COMPRESSED_R11_EAC = Enumerant('GL_COMPRESSED_R11_EAC', 0x9270, 'GL_ARB_ES3_compatibility')
GL_COMPRESSED_RG11_EAC = Enumerant('GL_COMPRESSED_RG11_EAC', 0x9272, 'GL_ARB_ES3_compatibility')
GL_COMPRESSED_RGB8_ETC2 = Enumerant('GL_COMPRESSED_RGB8_ETC2', 0x9274, 'GL_ARB_ES3_compatibility')
GL_COMPRESSED_RGB8_PUNCHTHROUGH_ALPHA1_ETC2 = Enumerant('GL_COMPRESSED_RGB8_PUNCHTHROUGH_ALPHA1_ETC2', 0x9276, 'GL_ARB_ES3_compatibility')
GL_COMPRESSED_RGBA8_ETC2_EAC = Enumerant('GL_COMPRESSED_RGBA8_ETC2_EAC', 0x9278, 'GL_ARB_ES3_compatibility')
GL_COMPRESSED_SIGNED_R11_EAC = Enumerant('GL_COMPRESSED_SIGNED_R11_EAC', 0x9271, 'GL_ARB_ES3_compatibility')
GL_COMPRESSED_SIGNED_RG11_EAC = Enumerant('GL_COMPRESSED_SIGNED_RG11_EAC', 0x9273, 'GL_ARB_ES3_compatibility')
GL_COMPRESSED_SRGB8_ALPHA8_ETC2_EAC = Enumerant('GL_COMPRESSED_SRGB8_ALPHA8_ETC2_EAC', 0x9279, 'GL_ARB_ES3_compatibility')
GL_COMPRESSED_SRGB8_ETC2 = Enumerant('GL_COMPRESSED_SRGB8_ETC2', 0x9275, 'GL_ARB_ES3_compatibility')
GL_COMPRESSED_SRGB8_PUNCHTHROUGH_ALPHA1_ETC2 = Enumerant('GL_COMPRESSED_SRGB8_PUNCHTHROUGH_ALPHA1_ETC2', 0x9277, 'GL_ARB_ES3_compatibility')
GL_MAX_ELEMENT_INDEX = Enumerant('GL_MAX_ELEMENT_INDEX', 0x8d6b, 'GL_ARB_ES3_compatibility')
GL_PRIMITIVE_RESTART_FIXED_INDEX = Enumerant('GL_PRIMITIVE_RESTART_FIXED_INDEX', 0x8d69, 'GL_ARB_ES3_compatibility')
GL_PRIMITIVE_RESTART_FIXED_INDEX.enableCap = True

defines.add(GL_ANY_SAMPLES_PASSED_CONSERVATIVE)
defines.add(GL_COMPRESSED_R11_EAC)
defines.add(GL_COMPRESSED_RG11_EAC)
defines.add(GL_COMPRESSED_RGB8_ETC2)
defines.add(GL_COMPRESSED_RGB8_PUNCHTHROUGH_ALPHA1_ETC2)
defines.add(GL_COMPRESSED_RGBA8_ETC2_EAC)
defines.add(GL_COMPRESSED_SIGNED_R11_EAC)
defines.add(GL_COMPRESSED_SIGNED_RG11_EAC)
defines.add(GL_COMPRESSED_SRGB8_ALPHA8_ETC2_EAC)
defines.add(GL_COMPRESSED_SRGB8_ETC2)
defines.add(GL_COMPRESSED_SRGB8_PUNCHTHROUGH_ALPHA1_ETC2)
defines.add(GL_MAX_ELEMENT_INDEX)
defines.add(GL_PRIMITIVE_RESTART_FIXED_INDEX)

# GL_ARB_bindless_texture

GL_UNSIGNED_INT64_ARB = Enumerant('GL_UNSIGNED_INT64_ARB', 0x140f, 'GL_ARB_bindless_texture')

defines.add(GL_UNSIGNED_INT64_ARB)

# GL_ARB_blend_func_extended

GL_MAX_DUAL_SOURCE_DRAW_BUFFERS = Enumerant('GL_MAX_DUAL_SOURCE_DRAW_BUFFERS', 0x88fc, 'GL_ARB_blend_func_extended')
GL_ONE_MINUS_SRC1_ALPHA = Enumerant('GL_ONE_MINUS_SRC1_ALPHA', 0x88fb, 'GL_ARB_blend_func_extended')
GL_ONE_MINUS_SRC1_COLOR = Enumerant('GL_ONE_MINUS_SRC1_COLOR', 0x88fa, 'GL_ARB_blend_func_extended')
GL_SRC1_COLOR = Enumerant('GL_SRC1_COLOR', 0x88f9, 'GL_ARB_blend_func_extended')

defines.add(GL_MAX_DUAL_SOURCE_DRAW_BUFFERS)
defines.add(GL_ONE_MINUS_SRC1_ALPHA)
defines.add(GL_ONE_MINUS_SRC1_COLOR)
defines.add(GL_SRC1_COLOR)

# GL_ARB_buffer_storage

GL_BUFFER_IMMUTABLE_STORAGE = Enumerant('GL_BUFFER_IMMUTABLE_STORAGE', 0x821f, 'GL_ARB_buffer_storage')
GL_BUFFER_STORAGE_FLAGS = Enumerant('GL_BUFFER_STORAGE_FLAGS', 0x8220, 'GL_ARB_buffer_storage')
GL_CLIENT_MAPPED_BUFFER_BARRIER_BIT = Enumerant('GL_CLIENT_MAPPED_BUFFER_BARRIER_BIT', 0x4000, 'GL_ARB_buffer_storage')
GL_CLIENT_STORAGE_BIT = Enumerant('GL_CLIENT_STORAGE_BIT', 0x0200, 'GL_ARB_buffer_storage')
GL_DYNAMIC_STORAGE_BIT = Enumerant('GL_DYNAMIC_STORAGE_BIT', 0x0100, 'GL_ARB_buffer_storage')
GL_MAP_COHERENT_BIT = Enumerant('GL_MAP_COHERENT_BIT', 0x0080, 'GL_ARB_buffer_storage')
GL_MAP_PERSISTENT_BIT = Enumerant('GL_MAP_PERSISTENT_BIT', 0x0040, 'GL_ARB_buffer_storage')

defines.add(GL_BUFFER_IMMUTABLE_STORAGE)
defines.add(GL_BUFFER_STORAGE_FLAGS)
defines.add(GL_CLIENT_MAPPED_BUFFER_BARRIER_BIT)
defines.add(GL_CLIENT_STORAGE_BIT)
defines.add(GL_DYNAMIC_STORAGE_BIT)
defines.add(GL_MAP_COHERENT_BIT)
defines.add(GL_MAP_PERSISTENT_BIT)

# GL_ARB_cl_event

GL_SYNC_CL_EVENT_ARB = Enumerant('GL_SYNC_CL_EVENT_ARB', 0x8240, 'GL_ARB_cl_event')
GL_SYNC_CL_EVENT_COMPLETE_ARB = Enumerant('GL_SYNC_CL_EVENT_COMPLETE_ARB', 0x8241, 'GL_ARB_cl_event')

defines.add(GL_SYNC_CL_EVENT_ARB)
defines.add(GL_SYNC_CL_EVENT_COMPLETE_ARB)

# GL_ARB_clear_texture

GL_CLEAR_TEXTURE = Enumerant('GL_CLEAR_TEXTURE', 0x9365, 'GL_ARB_clear_texture')

defines.add(GL_CLEAR_TEXTURE)

# GL_ARB_color_buffer_float

GL_CLAMP_FRAGMENT_COLOR_ARB = Enumerant('GL_CLAMP_FRAGMENT_COLOR_ARB', 0x891b, 'GL_ARB_color_buffer_float')
GL_CLAMP_READ_COLOR_ARB = Enumerant('GL_CLAMP_READ_COLOR_ARB', 0x891c, 'GL_ARB_color_buffer_float')
GL_CLAMP_VERTEX_COLOR_ARB = Enumerant('GL_CLAMP_VERTEX_COLOR_ARB', 0x891a, 'GL_ARB_color_buffer_float')
GL_FIXED_ONLY_ARB = Enumerant('GL_FIXED_ONLY_ARB', 0x891d, 'GL_ARB_color_buffer_float')
GL_RGBA_FLOAT_MODE_ARB = Enumerant('GL_RGBA_FLOAT_MODE_ARB', 0x8820, 'GL_ARB_color_buffer_float')

defines.add(GL_CLAMP_FRAGMENT_COLOR_ARB)
defines.add(GL_CLAMP_READ_COLOR_ARB)
defines.add(GL_CLAMP_VERTEX_COLOR_ARB)
defines.add(GL_FIXED_ONLY_ARB)
defines.add(GL_RGBA_FLOAT_MODE_ARB)

# GL_ARB_compressed_texture_pixel_storage

GL_PACK_COMPRESSED_BLOCK_DEPTH = Enumerant('GL_PACK_COMPRESSED_BLOCK_DEPTH', 0x912d, 'GL_ARB_compressed_texture_pixel_storage')
GL_PACK_COMPRESSED_BLOCK_HEIGHT = Enumerant('GL_PACK_COMPRESSED_BLOCK_HEIGHT', 0x912c, 'GL_ARB_compressed_texture_pixel_storage')
GL_PACK_COMPRESSED_BLOCK_SIZE = Enumerant('GL_PACK_COMPRESSED_BLOCK_SIZE', 0x912e, 'GL_ARB_compressed_texture_pixel_storage')
GL_PACK_COMPRESSED_BLOCK_WIDTH = Enumerant('GL_PACK_COMPRESSED_BLOCK_WIDTH', 0x912b, 'GL_ARB_compressed_texture_pixel_storage')
GL_UNPACK_COMPRESSED_BLOCK_DEPTH = Enumerant('GL_UNPACK_COMPRESSED_BLOCK_DEPTH', 0x9129, 'GL_ARB_compressed_texture_pixel_storage')
GL_UNPACK_COMPRESSED_BLOCK_HEIGHT = Enumerant('GL_UNPACK_COMPRESSED_BLOCK_HEIGHT', 0x9128, 'GL_ARB_compressed_texture_pixel_storage')
GL_UNPACK_COMPRESSED_BLOCK_SIZE = Enumerant('GL_UNPACK_COMPRESSED_BLOCK_SIZE', 0x912a, 'GL_ARB_compressed_texture_pixel_storage')
GL_UNPACK_COMPRESSED_BLOCK_WIDTH = Enumerant('GL_UNPACK_COMPRESSED_BLOCK_WIDTH', 0x9127, 'GL_ARB_compressed_texture_pixel_storage')

defines.add(GL_PACK_COMPRESSED_BLOCK_DEPTH)
defines.add(GL_PACK_COMPRESSED_BLOCK_HEIGHT)
defines.add(GL_PACK_COMPRESSED_BLOCK_SIZE)
defines.add(GL_PACK_COMPRESSED_BLOCK_WIDTH)
defines.add(GL_UNPACK_COMPRESSED_BLOCK_DEPTH)
defines.add(GL_UNPACK_COMPRESSED_BLOCK_HEIGHT)
defines.add(GL_UNPACK_COMPRESSED_BLOCK_SIZE)
defines.add(GL_UNPACK_COMPRESSED_BLOCK_WIDTH)

# GL_ARB_compute_shader

GL_ATOMIC_COUNTER_BUFFER_REFERENCED_BY_COMPUTE_SHADER = Enumerant('GL_ATOMIC_COUNTER_BUFFER_REFERENCED_BY_COMPUTE_SHADER', 0x90ed, 'GL_ARB_compute_shader')
GL_COMPUTE_SHADER = Enumerant('GL_COMPUTE_SHADER', 0x91b9, 'GL_ARB_compute_shader')
GL_COMPUTE_SHADER_BIT = Enumerant('GL_COMPUTE_SHADER_BIT', 0x0020, 'GL_ARB_compute_shader')
GL_COMPUTE_WORK_GROUP_SIZE = Enumerant('GL_COMPUTE_WORK_GROUP_SIZE', 0x8267, 'GL_ARB_compute_shader')
GL_DISPATCH_INDIRECT_BUFFER = Enumerant('GL_DISPATCH_INDIRECT_BUFFER', 0x90ee, 'GL_ARB_compute_shader')
GL_DISPATCH_INDIRECT_BUFFER_BINDING = Enumerant('GL_DISPATCH_INDIRECT_BUFFER_BINDING', 0x90ef, 'GL_ARB_compute_shader')
GL_MAX_COMBINED_COMPUTE_UNIFORM_COMPONENTS = Enumerant('GL_MAX_COMBINED_COMPUTE_UNIFORM_COMPONENTS', 0x8266, 'GL_ARB_compute_shader')
GL_MAX_COMPUTE_ATOMIC_COUNTERS = Enumerant('GL_MAX_COMPUTE_ATOMIC_COUNTERS', 0x8265, 'GL_ARB_compute_shader')
GL_MAX_COMPUTE_ATOMIC_COUNTER_BUFFERS = Enumerant('GL_MAX_COMPUTE_ATOMIC_COUNTER_BUFFERS', 0x8264, 'GL_ARB_compute_shader')
GL_MAX_COMPUTE_IMAGE_UNIFORMS = Enumerant('GL_MAX_COMPUTE_IMAGE_UNIFORMS', 0x91bd, 'GL_ARB_compute_shader')
GL_MAX_COMPUTE_SHARED_MEMORY_SIZE = Enumerant('GL_MAX_COMPUTE_SHARED_MEMORY_SIZE', 0x8262, 'GL_ARB_compute_shader')
GL_MAX_COMPUTE_TEXTURE_IMAGE_UNITS = Enumerant('GL_MAX_COMPUTE_TEXTURE_IMAGE_UNITS', 0x91bc, 'GL_ARB_compute_shader')
GL_MAX_COMPUTE_UNIFORM_BLOCKS = Enumerant('GL_MAX_COMPUTE_UNIFORM_BLOCKS', 0x91bb, 'GL_ARB_compute_shader')
GL_MAX_COMPUTE_UNIFORM_COMPONENTS = Enumerant('GL_MAX_COMPUTE_UNIFORM_COMPONENTS', 0x8263, 'GL_ARB_compute_shader')
GL_MAX_COMPUTE_WORK_GROUP_COUNT = Enumerant('GL_MAX_COMPUTE_WORK_GROUP_COUNT', 0x91be, 'GL_ARB_compute_shader')
GL_MAX_COMPUTE_WORK_GROUP_INVOCATIONS = Enumerant('GL_MAX_COMPUTE_WORK_GROUP_INVOCATIONS', 0x90eb, 'GL_ARB_compute_shader')
GL_MAX_COMPUTE_WORK_GROUP_SIZE = Enumerant('GL_MAX_COMPUTE_WORK_GROUP_SIZE', 0x91bf, 'GL_ARB_compute_shader')
GL_UNIFORM_BLOCK_REFERENCED_BY_COMPUTE_SHADER = Enumerant('GL_UNIFORM_BLOCK_REFERENCED_BY_COMPUTE_SHADER', 0x90ec, 'GL_ARB_compute_shader')

defines.add(GL_ATOMIC_COUNTER_BUFFER_REFERENCED_BY_COMPUTE_SHADER)
defines.add(GL_COMPUTE_SHADER)
defines.add(GL_COMPUTE_SHADER_BIT)
defines.add(GL_COMPUTE_WORK_GROUP_SIZE)
defines.add(GL_DISPATCH_INDIRECT_BUFFER)
defines.add(GL_DISPATCH_INDIRECT_BUFFER_BINDING)
defines.add(GL_MAX_COMBINED_COMPUTE_UNIFORM_COMPONENTS)
defines.add(GL_MAX_COMPUTE_ATOMIC_COUNTERS)
defines.add(GL_MAX_COMPUTE_ATOMIC_COUNTER_BUFFERS)
defines.add(GL_MAX_COMPUTE_IMAGE_UNIFORMS)
defines.add(GL_MAX_COMPUTE_SHARED_MEMORY_SIZE)
defines.add(GL_MAX_COMPUTE_TEXTURE_IMAGE_UNITS)
defines.add(GL_MAX_COMPUTE_UNIFORM_BLOCKS)
defines.add(GL_MAX_COMPUTE_UNIFORM_COMPONENTS)
defines.add(GL_MAX_COMPUTE_WORK_GROUP_COUNT)
defines.add(GL_MAX_COMPUTE_WORK_GROUP_INVOCATIONS)
defines.add(GL_MAX_COMPUTE_WORK_GROUP_SIZE)
defines.add(GL_UNIFORM_BLOCK_REFERENCED_BY_COMPUTE_SHADER)

# GL_ARB_compute_variable_group_size

GL_MAX_COMPUTE_FIXED_GROUP_INVOCATIONS_ARB = Enumerant('GL_MAX_COMPUTE_FIXED_GROUP_INVOCATIONS_ARB', 0x90eb, 'GL_ARB_compute_variable_group_size')
GL_MAX_COMPUTE_FIXED_GROUP_SIZE_ARB = Enumerant('GL_MAX_COMPUTE_FIXED_GROUP_SIZE_ARB', 0x91bf, 'GL_ARB_compute_variable_group_size')
GL_MAX_COMPUTE_VARIABLE_GROUP_INVOCATIONS_ARB = Enumerant('GL_MAX_COMPUTE_VARIABLE_GROUP_INVOCATIONS_ARB', 0x9344, 'GL_ARB_compute_variable_group_size')
GL_MAX_COMPUTE_VARIABLE_GROUP_SIZE_ARB = Enumerant('GL_MAX_COMPUTE_VARIABLE_GROUP_SIZE_ARB', 0x9345, 'GL_ARB_compute_variable_group_size')

defines.add(GL_MAX_COMPUTE_FIXED_GROUP_INVOCATIONS_ARB)
defines.add(GL_MAX_COMPUTE_FIXED_GROUP_SIZE_ARB)
defines.add(GL_MAX_COMPUTE_VARIABLE_GROUP_INVOCATIONS_ARB)
defines.add(GL_MAX_COMPUTE_VARIABLE_GROUP_SIZE_ARB)

# GL_ARB_copy_buffer

GL_COPY_READ_BUFFER = Enumerant('GL_COPY_READ_BUFFER', 0x8f36, 'GL_ARB_copy_buffer')
GL_COPY_WRITE_BUFFER = Enumerant('GL_COPY_WRITE_BUFFER', 0x8f37, 'GL_ARB_copy_buffer')

defines.add(GL_COPY_READ_BUFFER)
defines.add(GL_COPY_WRITE_BUFFER)

# GL_ARB_debug_output

GL_DEBUG_CALLBACK_FUNCTION_ARB = Enumerant('GL_DEBUG_CALLBACK_FUNCTION_ARB', 0x8244, 'GL_ARB_debug_output')
GL_DEBUG_CALLBACK_USER_PARAM_ARB = Enumerant('GL_DEBUG_CALLBACK_USER_PARAM_ARB', 0x8245, 'GL_ARB_debug_output')
GL_DEBUG_LOGGED_MESSAGES_ARB = Enumerant('GL_DEBUG_LOGGED_MESSAGES_ARB', 0x9145, 'GL_ARB_debug_output')
GL_DEBUG_NEXT_LOGGED_MESSAGE_LENGTH_ARB = Enumerant('GL_DEBUG_NEXT_LOGGED_MESSAGE_LENGTH_ARB', 0x8243, 'GL_ARB_debug_output')
GL_DEBUG_OUTPUT_SYNCHRONOUS_ARB = Enumerant('GL_DEBUG_OUTPUT_SYNCHRONOUS_ARB', 0x8242, 'GL_ARB_debug_output')
GL_DEBUG_SEVERITY_HIGH_ARB = Enumerant('GL_DEBUG_SEVERITY_HIGH_ARB', 0x9146, 'GL_ARB_debug_output')
GL_DEBUG_SEVERITY_LOW_ARB = Enumerant('GL_DEBUG_SEVERITY_LOW_ARB', 0x9148, 'GL_ARB_debug_output')
GL_DEBUG_SEVERITY_MEDIUM_ARB = Enumerant('GL_DEBUG_SEVERITY_MEDIUM_ARB', 0x9147, 'GL_ARB_debug_output')
GL_DEBUG_SOURCE_API_ARB = Enumerant('GL_DEBUG_SOURCE_API_ARB', 0x8246, 'GL_ARB_debug_output')
GL_DEBUG_SOURCE_APPLICATION_ARB = Enumerant('GL_DEBUG_SOURCE_APPLICATION_ARB', 0x824a, 'GL_ARB_debug_output')
GL_DEBUG_SOURCE_OTHER_ARB = Enumerant('GL_DEBUG_SOURCE_OTHER_ARB', 0x824b, 'GL_ARB_debug_output')
GL_DEBUG_SOURCE_SHADER_COMPILER_ARB = Enumerant('GL_DEBUG_SOURCE_SHADER_COMPILER_ARB', 0x8248, 'GL_ARB_debug_output')
GL_DEBUG_SOURCE_THIRD_PARTY_ARB = Enumerant('GL_DEBUG_SOURCE_THIRD_PARTY_ARB', 0x8249, 'GL_ARB_debug_output')
GL_DEBUG_SOURCE_WINDOW_SYSTEM_ARB = Enumerant('GL_DEBUG_SOURCE_WINDOW_SYSTEM_ARB', 0x8247, 'GL_ARB_debug_output')
GL_DEBUG_TYPE_DEPRECATED_BEHAVIOR_ARB = Enumerant('GL_DEBUG_TYPE_DEPRECATED_BEHAVIOR_ARB', 0x824d, 'GL_ARB_debug_output')
GL_DEBUG_TYPE_ERROR_ARB = Enumerant('GL_DEBUG_TYPE_ERROR_ARB', 0x824c, 'GL_ARB_debug_output')
GL_DEBUG_TYPE_OTHER_ARB = Enumerant('GL_DEBUG_TYPE_OTHER_ARB', 0x8251, 'GL_ARB_debug_output')
GL_DEBUG_TYPE_PERFORMANCE_ARB = Enumerant('GL_DEBUG_TYPE_PERFORMANCE_ARB', 0x8250, 'GL_ARB_debug_output')
GL_DEBUG_TYPE_PORTABILITY_ARB = Enumerant('GL_DEBUG_TYPE_PORTABILITY_ARB', 0x824f, 'GL_ARB_debug_output')
GL_DEBUG_TYPE_UNDEFINED_BEHAVIOR_ARB = Enumerant('GL_DEBUG_TYPE_UNDEFINED_BEHAVIOR_ARB', 0x824e, 'GL_ARB_debug_output')
GL_MAX_DEBUG_LOGGED_MESSAGES_ARB = Enumerant('GL_MAX_DEBUG_LOGGED_MESSAGES_ARB', 0x9144, 'GL_ARB_debug_output')
GL_MAX_DEBUG_MESSAGE_LENGTH_ARB = Enumerant('GL_MAX_DEBUG_MESSAGE_LENGTH_ARB', 0x9143, 'GL_ARB_debug_output')

defines.add(GL_DEBUG_CALLBACK_FUNCTION_ARB)
defines.add(GL_DEBUG_CALLBACK_USER_PARAM_ARB)
defines.add(GL_DEBUG_LOGGED_MESSAGES_ARB)
defines.add(GL_DEBUG_NEXT_LOGGED_MESSAGE_LENGTH_ARB)
defines.add(GL_DEBUG_OUTPUT_SYNCHRONOUS_ARB)
defines.add(GL_DEBUG_SEVERITY_HIGH_ARB)
defines.add(GL_DEBUG_SEVERITY_LOW_ARB)
defines.add(GL_DEBUG_SEVERITY_MEDIUM_ARB)
defines.add(GL_DEBUG_SOURCE_API_ARB)
defines.add(GL_DEBUG_SOURCE_APPLICATION_ARB)
defines.add(GL_DEBUG_SOURCE_OTHER_ARB)
defines.add(GL_DEBUG_SOURCE_SHADER_COMPILER_ARB)
defines.add(GL_DEBUG_SOURCE_THIRD_PARTY_ARB)
defines.add(GL_DEBUG_SOURCE_WINDOW_SYSTEM_ARB)
defines.add(GL_DEBUG_TYPE_DEPRECATED_BEHAVIOR_ARB)
defines.add(GL_DEBUG_TYPE_ERROR_ARB)
defines.add(GL_DEBUG_TYPE_OTHER_ARB)
defines.add(GL_DEBUG_TYPE_PERFORMANCE_ARB)
defines.add(GL_DEBUG_TYPE_PORTABILITY_ARB)
defines.add(GL_DEBUG_TYPE_UNDEFINED_BEHAVIOR_ARB)
defines.add(GL_MAX_DEBUG_LOGGED_MESSAGES_ARB)
defines.add(GL_MAX_DEBUG_MESSAGE_LENGTH_ARB)

# GL_ARB_depth_buffer_float

GL_DEPTH32F_STENCIL8 = Enumerant('GL_DEPTH32F_STENCIL8', 0x8cad, 'GL_ARB_depth_buffer_float')
GL_DEPTH_COMPONENT32F = Enumerant('GL_DEPTH_COMPONENT32F', 0x8cac, 'GL_ARB_depth_buffer_float')
GL_FLOAT_32_UNSIGNED_INT_24_8_REV = Enumerant('GL_FLOAT_32_UNSIGNED_INT_24_8_REV', 0x8dad, 'GL_ARB_depth_buffer_float')

defines.add(GL_DEPTH32F_STENCIL8)
defines.add(GL_DEPTH_COMPONENT32F)
defines.add(GL_FLOAT_32_UNSIGNED_INT_24_8_REV)

# GL_ARB_depth_clamp

GL_DEPTH_CLAMP = Enumerant('GL_DEPTH_CLAMP', 0x864f, 'GL_ARB_depth_clamp')
GL_DEPTH_CLAMP.enableCap = True

defines.add(GL_DEPTH_CLAMP)

# GL_ARB_depth_texture

GL_DEPTH_COMPONENT16_ARB = Enumerant('GL_DEPTH_COMPONENT16_ARB', 0x81a5, 'GL_ARB_depth_texture')
GL_DEPTH_COMPONENT24_ARB = Enumerant('GL_DEPTH_COMPONENT24_ARB', 0x81a6, 'GL_ARB_depth_texture')
GL_DEPTH_COMPONENT32_ARB = Enumerant('GL_DEPTH_COMPONENT32_ARB', 0x81a7, 'GL_ARB_depth_texture')
GL_DEPTH_TEXTURE_MODE_ARB = Enumerant('GL_DEPTH_TEXTURE_MODE_ARB', 0x884b, 'GL_ARB_depth_texture')
GL_TEXTURE_DEPTH_SIZE_ARB = Enumerant('GL_TEXTURE_DEPTH_SIZE_ARB', 0x884a, 'GL_ARB_depth_texture')

defines.add(GL_DEPTH_COMPONENT16_ARB)
defines.add(GL_DEPTH_COMPONENT24_ARB)
defines.add(GL_DEPTH_COMPONENT32_ARB)
defines.add(GL_DEPTH_TEXTURE_MODE_ARB)
defines.add(GL_TEXTURE_DEPTH_SIZE_ARB)

# GL_ARB_draw_buffers

GL_DRAW_BUFFER0_ARB = Enumerant('GL_DRAW_BUFFER0_ARB', 0x8825, 'GL_ARB_draw_buffers')
GL_DRAW_BUFFER10_ARB = Enumerant('GL_DRAW_BUFFER10_ARB', 0x882f, 'GL_ARB_draw_buffers')
GL_DRAW_BUFFER11_ARB = Enumerant('GL_DRAW_BUFFER11_ARB', 0x8830, 'GL_ARB_draw_buffers')
GL_DRAW_BUFFER12_ARB = Enumerant('GL_DRAW_BUFFER12_ARB', 0x8831, 'GL_ARB_draw_buffers')
GL_DRAW_BUFFER13_ARB = Enumerant('GL_DRAW_BUFFER13_ARB', 0x8832, 'GL_ARB_draw_buffers')
GL_DRAW_BUFFER14_ARB = Enumerant('GL_DRAW_BUFFER14_ARB', 0x8833, 'GL_ARB_draw_buffers')
GL_DRAW_BUFFER15_ARB = Enumerant('GL_DRAW_BUFFER15_ARB', 0x8834, 'GL_ARB_draw_buffers')
GL_DRAW_BUFFER1_ARB = Enumerant('GL_DRAW_BUFFER1_ARB', 0x8826, 'GL_ARB_draw_buffers')
GL_DRAW_BUFFER2_ARB = Enumerant('GL_DRAW_BUFFER2_ARB', 0x8827, 'GL_ARB_draw_buffers')
GL_DRAW_BUFFER3_ARB = Enumerant('GL_DRAW_BUFFER3_ARB', 0x8828, 'GL_ARB_draw_buffers')
GL_DRAW_BUFFER4_ARB = Enumerant('GL_DRAW_BUFFER4_ARB', 0x8829, 'GL_ARB_draw_buffers')
GL_DRAW_BUFFER5_ARB = Enumerant('GL_DRAW_BUFFER5_ARB', 0x882a, 'GL_ARB_draw_buffers')
GL_DRAW_BUFFER6_ARB = Enumerant('GL_DRAW_BUFFER6_ARB', 0x882b, 'GL_ARB_draw_buffers')
GL_DRAW_BUFFER7_ARB = Enumerant('GL_DRAW_BUFFER7_ARB', 0x882c, 'GL_ARB_draw_buffers')
GL_DRAW_BUFFER8_ARB = Enumerant('GL_DRAW_BUFFER8_ARB', 0x882d, 'GL_ARB_draw_buffers')
GL_DRAW_BUFFER9_ARB = Enumerant('GL_DRAW_BUFFER9_ARB', 0x882e, 'GL_ARB_draw_buffers')
GL_MAX_DRAW_BUFFERS_ARB = Enumerant('GL_MAX_DRAW_BUFFERS_ARB', 0x8824, 'GL_ARB_draw_buffers')

defines.add(GL_DRAW_BUFFER0_ARB)
defines.add(GL_DRAW_BUFFER10_ARB)
defines.add(GL_DRAW_BUFFER11_ARB)
defines.add(GL_DRAW_BUFFER12_ARB)
defines.add(GL_DRAW_BUFFER13_ARB)
defines.add(GL_DRAW_BUFFER14_ARB)
defines.add(GL_DRAW_BUFFER15_ARB)
defines.add(GL_DRAW_BUFFER1_ARB)
defines.add(GL_DRAW_BUFFER2_ARB)
defines.add(GL_DRAW_BUFFER3_ARB)
defines.add(GL_DRAW_BUFFER4_ARB)
defines.add(GL_DRAW_BUFFER5_ARB)
defines.add(GL_DRAW_BUFFER6_ARB)
defines.add(GL_DRAW_BUFFER7_ARB)
defines.add(GL_DRAW_BUFFER8_ARB)
defines.add(GL_DRAW_BUFFER9_ARB)
defines.add(GL_MAX_DRAW_BUFFERS_ARB)

# GL_ARB_draw_indirect

GL_DRAW_INDIRECT_BUFFER = Enumerant('GL_DRAW_INDIRECT_BUFFER', 0x8f3f, 'GL_ARB_draw_indirect')
GL_DRAW_INDIRECT_BUFFER_BINDING = Enumerant('GL_DRAW_INDIRECT_BUFFER_BINDING', 0x8f43, 'GL_ARB_draw_indirect')

defines.add(GL_DRAW_INDIRECT_BUFFER)
defines.add(GL_DRAW_INDIRECT_BUFFER_BINDING)

# GL_ARB_enhanced_layouts

GL_LOCATION_COMPONENT = Enumerant('GL_LOCATION_COMPONENT', 0x934a, 'GL_ARB_enhanced_layouts')
GL_TRANSFORM_FEEDBACK_BUFFER_INDEX = Enumerant('GL_TRANSFORM_FEEDBACK_BUFFER_INDEX', 0x934b, 'GL_ARB_enhanced_layouts')
GL_TRANSFORM_FEEDBACK_BUFFER_STRIDE = Enumerant('GL_TRANSFORM_FEEDBACK_BUFFER_STRIDE', 0x934c, 'GL_ARB_enhanced_layouts')

defines.add(GL_LOCATION_COMPONENT)
defines.add(GL_TRANSFORM_FEEDBACK_BUFFER_INDEX)
defines.add(GL_TRANSFORM_FEEDBACK_BUFFER_STRIDE)

# GL_ARB_explicit_uniform_location

GL_MAX_UNIFORM_LOCATIONS = Enumerant('GL_MAX_UNIFORM_LOCATIONS', 0x826e, 'GL_ARB_explicit_uniform_location')

defines.add(GL_MAX_UNIFORM_LOCATIONS)

# GL_ARB_fragment_program

GL_FRAGMENT_PROGRAM_ARB = Enumerant('GL_FRAGMENT_PROGRAM_ARB', 0x8804, 'GL_ARB_fragment_program')
GL_MAX_PROGRAM_ALU_INSTRUCTIONS_ARB = Enumerant('GL_MAX_PROGRAM_ALU_INSTRUCTIONS_ARB', 0x880b, 'GL_ARB_fragment_program')
GL_MAX_PROGRAM_NATIVE_ALU_INSTRUCTIONS_ARB = Enumerant('GL_MAX_PROGRAM_NATIVE_ALU_INSTRUCTIONS_ARB', 0x880e, 'GL_ARB_fragment_program')
GL_MAX_PROGRAM_NATIVE_TEX_INDIRECTIONS_ARB = Enumerant('GL_MAX_PROGRAM_NATIVE_TEX_INDIRECTIONS_ARB', 0x8810, 'GL_ARB_fragment_program')
GL_MAX_PROGRAM_NATIVE_TEX_INSTRUCTIONS_ARB = Enumerant('GL_MAX_PROGRAM_NATIVE_TEX_INSTRUCTIONS_ARB', 0x880f, 'GL_ARB_fragment_program')
GL_MAX_PROGRAM_TEX_INDIRECTIONS_ARB = Enumerant('GL_MAX_PROGRAM_TEX_INDIRECTIONS_ARB', 0x880d, 'GL_ARB_fragment_program')
GL_MAX_PROGRAM_TEX_INSTRUCTIONS_ARB = Enumerant('GL_MAX_PROGRAM_TEX_INSTRUCTIONS_ARB', 0x880c, 'GL_ARB_fragment_program')
GL_MAX_TEXTURE_COORDS_ARB = Enumerant('GL_MAX_TEXTURE_COORDS_ARB', 0x8871, 'GL_ARB_fragment_program')
GL_MAX_TEXTURE_IMAGE_UNITS_ARB = Enumerant('GL_MAX_TEXTURE_IMAGE_UNITS_ARB', 0x8872, 'GL_ARB_fragment_program')
GL_PROGRAM_ALU_INSTRUCTIONS_ARB = Enumerant('GL_PROGRAM_ALU_INSTRUCTIONS_ARB', 0x8805, 'GL_ARB_fragment_program')
GL_PROGRAM_NATIVE_ALU_INSTRUCTIONS_ARB = Enumerant('GL_PROGRAM_NATIVE_ALU_INSTRUCTIONS_ARB', 0x8808, 'GL_ARB_fragment_program')
GL_PROGRAM_NATIVE_TEX_INDIRECTIONS_ARB = Enumerant('GL_PROGRAM_NATIVE_TEX_INDIRECTIONS_ARB', 0x880a, 'GL_ARB_fragment_program')
GL_PROGRAM_NATIVE_TEX_INSTRUCTIONS_ARB = Enumerant('GL_PROGRAM_NATIVE_TEX_INSTRUCTIONS_ARB', 0x8809, 'GL_ARB_fragment_program')
GL_PROGRAM_TEX_INDIRECTIONS_ARB = Enumerant('GL_PROGRAM_TEX_INDIRECTIONS_ARB', 0x8807, 'GL_ARB_fragment_program')
GL_PROGRAM_TEX_INSTRUCTIONS_ARB = Enumerant('GL_PROGRAM_TEX_INSTRUCTIONS_ARB', 0x8806, 'GL_ARB_fragment_program')

defines.add(GL_FRAGMENT_PROGRAM_ARB)
defines.add(GL_MAX_PROGRAM_ALU_INSTRUCTIONS_ARB)
defines.add(GL_MAX_PROGRAM_NATIVE_ALU_INSTRUCTIONS_ARB)
defines.add(GL_MAX_PROGRAM_NATIVE_TEX_INDIRECTIONS_ARB)
defines.add(GL_MAX_PROGRAM_NATIVE_TEX_INSTRUCTIONS_ARB)
defines.add(GL_MAX_PROGRAM_TEX_INDIRECTIONS_ARB)
defines.add(GL_MAX_PROGRAM_TEX_INSTRUCTIONS_ARB)
defines.add(GL_MAX_TEXTURE_COORDS_ARB)
defines.add(GL_MAX_TEXTURE_IMAGE_UNITS_ARB)
defines.add(GL_PROGRAM_ALU_INSTRUCTIONS_ARB)
defines.add(GL_PROGRAM_NATIVE_ALU_INSTRUCTIONS_ARB)
defines.add(GL_PROGRAM_NATIVE_TEX_INDIRECTIONS_ARB)
defines.add(GL_PROGRAM_NATIVE_TEX_INSTRUCTIONS_ARB)
defines.add(GL_PROGRAM_TEX_INDIRECTIONS_ARB)
defines.add(GL_PROGRAM_TEX_INSTRUCTIONS_ARB)

# GL_ARB_fragment_shader

GL_FRAGMENT_SHADER_ARB = Enumerant('GL_FRAGMENT_SHADER_ARB', 0x8b30, 'GL_ARB_fragment_shader')
GL_FRAGMENT_SHADER_DERIVATIVE_HINT_ARB = Enumerant('GL_FRAGMENT_SHADER_DERIVATIVE_HINT_ARB', 0x8b8b, 'GL_ARB_fragment_shader')
GL_MAX_FRAGMENT_UNIFORM_COMPONENTS_ARB = Enumerant('GL_MAX_FRAGMENT_UNIFORM_COMPONENTS_ARB', 0x8b49, 'GL_ARB_fragment_shader')

defines.add(GL_FRAGMENT_SHADER_ARB)
defines.add(GL_FRAGMENT_SHADER_DERIVATIVE_HINT_ARB)
defines.add(GL_MAX_FRAGMENT_UNIFORM_COMPONENTS_ARB)

# GL_ARB_framebuffer_no_attachments

GL_FRAMEBUFFER_DEFAULT_FIXED_SAMPLE_LOCATIONS = Enumerant('GL_FRAMEBUFFER_DEFAULT_FIXED_SAMPLE_LOCATIONS', 0x9314, 'GL_ARB_framebuffer_no_attachments')
GL_FRAMEBUFFER_DEFAULT_HEIGHT = Enumerant('GL_FRAMEBUFFER_DEFAULT_HEIGHT', 0x9311, 'GL_ARB_framebuffer_no_attachments')
GL_FRAMEBUFFER_DEFAULT_LAYERS = Enumerant('GL_FRAMEBUFFER_DEFAULT_LAYERS', 0x9312, 'GL_ARB_framebuffer_no_attachments')
GL_FRAMEBUFFER_DEFAULT_SAMPLES = Enumerant('GL_FRAMEBUFFER_DEFAULT_SAMPLES', 0x9313, 'GL_ARB_framebuffer_no_attachments')
GL_FRAMEBUFFER_DEFAULT_WIDTH = Enumerant('GL_FRAMEBUFFER_DEFAULT_WIDTH', 0x9310, 'GL_ARB_framebuffer_no_attachments')
GL_MAX_FRAMEBUFFER_HEIGHT = Enumerant('GL_MAX_FRAMEBUFFER_HEIGHT', 0x9316, 'GL_ARB_framebuffer_no_attachments')
GL_MAX_FRAMEBUFFER_LAYERS = Enumerant('GL_MAX_FRAMEBUFFER_LAYERS', 0x9317, 'GL_ARB_framebuffer_no_attachments')
GL_MAX_FRAMEBUFFER_SAMPLES = Enumerant('GL_MAX_FRAMEBUFFER_SAMPLES', 0x9318, 'GL_ARB_framebuffer_no_attachments')
GL_MAX_FRAMEBUFFER_WIDTH = Enumerant('GL_MAX_FRAMEBUFFER_WIDTH', 0x9315, 'GL_ARB_framebuffer_no_attachments')

defines.add(GL_FRAMEBUFFER_DEFAULT_FIXED_SAMPLE_LOCATIONS)
defines.add(GL_FRAMEBUFFER_DEFAULT_HEIGHT)
defines.add(GL_FRAMEBUFFER_DEFAULT_LAYERS)
defines.add(GL_FRAMEBUFFER_DEFAULT_SAMPLES)
defines.add(GL_FRAMEBUFFER_DEFAULT_WIDTH)
defines.add(GL_MAX_FRAMEBUFFER_HEIGHT)
defines.add(GL_MAX_FRAMEBUFFER_LAYERS)
defines.add(GL_MAX_FRAMEBUFFER_SAMPLES)
defines.add(GL_MAX_FRAMEBUFFER_WIDTH)

# GL_ARB_framebuffer_object

GL_COLOR_ATTACHMENT0 = Enumerant('GL_COLOR_ATTACHMENT0', 0x8ce0, 'GL_ARB_framebuffer_object')
GL_COLOR_ATTACHMENT0.esVersions = [2.0]
GL_COLOR_ATTACHMENT1 = Enumerant('GL_COLOR_ATTACHMENT1', 0x8ce1, 'GL_ARB_framebuffer_object')
GL_COLOR_ATTACHMENT10 = Enumerant('GL_COLOR_ATTACHMENT10', 0x8cea, 'GL_ARB_framebuffer_object')
GL_COLOR_ATTACHMENT11 = Enumerant('GL_COLOR_ATTACHMENT11', 0x8ceb, 'GL_ARB_framebuffer_object')
GL_COLOR_ATTACHMENT12 = Enumerant('GL_COLOR_ATTACHMENT12', 0x8cec, 'GL_ARB_framebuffer_object')
GL_COLOR_ATTACHMENT13 = Enumerant('GL_COLOR_ATTACHMENT13', 0x8ced, 'GL_ARB_framebuffer_object')
GL_COLOR_ATTACHMENT14 = Enumerant('GL_COLOR_ATTACHMENT14', 0x8cee, 'GL_ARB_framebuffer_object')
GL_COLOR_ATTACHMENT15 = Enumerant('GL_COLOR_ATTACHMENT15', 0x8cef, 'GL_ARB_framebuffer_object')
GL_COLOR_ATTACHMENT2 = Enumerant('GL_COLOR_ATTACHMENT2', 0x8ce2, 'GL_ARB_framebuffer_object')
GL_COLOR_ATTACHMENT3 = Enumerant('GL_COLOR_ATTACHMENT3', 0x8ce3, 'GL_ARB_framebuffer_object')
GL_COLOR_ATTACHMENT4 = Enumerant('GL_COLOR_ATTACHMENT4', 0x8ce4, 'GL_ARB_framebuffer_object')
GL_COLOR_ATTACHMENT5 = Enumerant('GL_COLOR_ATTACHMENT5', 0x8ce5, 'GL_ARB_framebuffer_object')
GL_COLOR_ATTACHMENT6 = Enumerant('GL_COLOR_ATTACHMENT6', 0x8ce6, 'GL_ARB_framebuffer_object')
GL_COLOR_ATTACHMENT7 = Enumerant('GL_COLOR_ATTACHMENT7', 0x8ce7, 'GL_ARB_framebuffer_object')
GL_COLOR_ATTACHMENT8 = Enumerant('GL_COLOR_ATTACHMENT8', 0x8ce8, 'GL_ARB_framebuffer_object')
GL_COLOR_ATTACHMENT9 = Enumerant('GL_COLOR_ATTACHMENT9', 0x8ce9, 'GL_ARB_framebuffer_object')
GL_DEPTH24_STENCIL8 = Enumerant('GL_DEPTH24_STENCIL8', 0x88f0, 'GL_ARB_framebuffer_object')
GL_DEPTH_ATTACHMENT = Enumerant('GL_DEPTH_ATTACHMENT', 0x8d00, 'GL_ARB_framebuffer_object')
GL_DEPTH_ATTACHMENT.esVersions = [2.0]
GL_DEPTH_STENCIL = Enumerant('GL_DEPTH_STENCIL', 0x84f9, 'GL_ARB_framebuffer_object')
GL_DEPTH_STENCIL_ATTACHMENT = Enumerant('GL_DEPTH_STENCIL_ATTACHMENT', 0x821a, 'GL_ARB_framebuffer_object')
GL_DRAW_FRAMEBUFFER = Enumerant('GL_DRAW_FRAMEBUFFER', 0x8ca9, 'GL_ARB_framebuffer_object')
GL_DRAW_FRAMEBUFFER_BINDING = Enumerant('GL_DRAW_FRAMEBUFFER_BINDING', 0x8ca6, 'GL_ARB_framebuffer_object')
GL_FRAMEBUFFER = Enumerant('GL_FRAMEBUFFER', 0x8d40, 'GL_ARB_framebuffer_object')
GL_FRAMEBUFFER.esVersions = [2.0]
GL_FRAMEBUFFER_ATTACHMENT_ALPHA_SIZE = Enumerant('GL_FRAMEBUFFER_ATTACHMENT_ALPHA_SIZE', 0x8215, 'GL_ARB_framebuffer_object')
GL_FRAMEBUFFER_ATTACHMENT_BLUE_SIZE = Enumerant('GL_FRAMEBUFFER_ATTACHMENT_BLUE_SIZE', 0x8214, 'GL_ARB_framebuffer_object')
GL_FRAMEBUFFER_ATTACHMENT_COLOR_ENCODING = Enumerant('GL_FRAMEBUFFER_ATTACHMENT_COLOR_ENCODING', 0x8210, 'GL_ARB_framebuffer_object')
GL_FRAMEBUFFER_ATTACHMENT_COMPONENT_TYPE = Enumerant('GL_FRAMEBUFFER_ATTACHMENT_COMPONENT_TYPE', 0x8211, 'GL_ARB_framebuffer_object')
GL_FRAMEBUFFER_ATTACHMENT_DEPTH_SIZE = Enumerant('GL_FRAMEBUFFER_ATTACHMENT_DEPTH_SIZE', 0x8216, 'GL_ARB_framebuffer_object')
GL_FRAMEBUFFER_ATTACHMENT_GREEN_SIZE = Enumerant('GL_FRAMEBUFFER_ATTACHMENT_GREEN_SIZE', 0x8213, 'GL_ARB_framebuffer_object')
GL_FRAMEBUFFER_ATTACHMENT_OBJECT_NAME = Enumerant('GL_FRAMEBUFFER_ATTACHMENT_OBJECT_NAME', 0x8cd1, 'GL_ARB_framebuffer_object')
GL_FRAMEBUFFER_ATTACHMENT_OBJECT_NAME.esVersions = [2.0]
GL_FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE = Enumerant('GL_FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE', 0x8cd0, 'GL_ARB_framebuffer_object')
GL_FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE.esVersions = [2.0]
GL_FRAMEBUFFER_ATTACHMENT_RED_SIZE = Enumerant('GL_FRAMEBUFFER_ATTACHMENT_RED_SIZE', 0x8212, 'GL_ARB_framebuffer_object')
GL_FRAMEBUFFER_ATTACHMENT_STENCIL_SIZE = Enumerant('GL_FRAMEBUFFER_ATTACHMENT_STENCIL_SIZE', 0x8217, 'GL_ARB_framebuffer_object')
GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE = Enumerant('GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE', 0x8cd3, 'GL_ARB_framebuffer_object')
GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE.esVersions = [2.0]
GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_LAYER = Enumerant('GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_LAYER', 0x8cd4, 'GL_ARB_framebuffer_object')
GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL = Enumerant('GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL', 0x8cd2, 'GL_ARB_framebuffer_object')
GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL.esVersions = [2.0]
GL_FRAMEBUFFER_BINDING = Enumerant('GL_FRAMEBUFFER_BINDING', 0x8ca6, 'GL_ARB_framebuffer_object')
GL_FRAMEBUFFER_BINDING.esVersions = [2.0]
GL_FRAMEBUFFER_COMPLETE = Enumerant('GL_FRAMEBUFFER_COMPLETE', 0x8cd5, 'GL_ARB_framebuffer_object')
GL_FRAMEBUFFER_COMPLETE.esVersions = [2.0]
GL_FRAMEBUFFER_DEFAULT = Enumerant('GL_FRAMEBUFFER_DEFAULT', 0x8218, 'GL_ARB_framebuffer_object')
GL_FRAMEBUFFER_INCOMPLETE_ATTACHMENT = Enumerant('GL_FRAMEBUFFER_INCOMPLETE_ATTACHMENT', 0x8cd6, 'GL_ARB_framebuffer_object')
GL_FRAMEBUFFER_INCOMPLETE_ATTACHMENT.esVersions = [2.0]
GL_FRAMEBUFFER_INCOMPLETE_DRAW_BUFFER = Enumerant('GL_FRAMEBUFFER_INCOMPLETE_DRAW_BUFFER', 0x8cdb, 'GL_ARB_framebuffer_object')
GL_FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT = Enumerant('GL_FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT', 0x8cd7, 'GL_ARB_framebuffer_object')
GL_FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT.esVersions = [2.0]
GL_FRAMEBUFFER_INCOMPLETE_MULTISAMPLE = Enumerant('GL_FRAMEBUFFER_INCOMPLETE_MULTISAMPLE', 0x8d56, 'GL_ARB_framebuffer_object')
GL_FRAMEBUFFER_INCOMPLETE_READ_BUFFER = Enumerant('GL_FRAMEBUFFER_INCOMPLETE_READ_BUFFER', 0x8cdc, 'GL_ARB_framebuffer_object')
GL_FRAMEBUFFER_UNDEFINED = Enumerant('GL_FRAMEBUFFER_UNDEFINED', 0x8219, 'GL_ARB_framebuffer_object')
GL_FRAMEBUFFER_UNSUPPORTED = Enumerant('GL_FRAMEBUFFER_UNSUPPORTED', 0x8cdd, 'GL_ARB_framebuffer_object')
GL_FRAMEBUFFER_UNSUPPORTED.esVersions = [2.0]
GL_INDEX = Enumerant('GL_INDEX', 0x8222, 'GL_ARB_framebuffer_object')
GL_INVALID_FRAMEBUFFER_OPERATION = Enumerant('GL_INVALID_FRAMEBUFFER_OPERATION', 0x0506, 'GL_ARB_framebuffer_object')
GL_INVALID_FRAMEBUFFER_OPERATION.esVersions = [2.0]
GL_MAX_COLOR_ATTACHMENTS = Enumerant('GL_MAX_COLOR_ATTACHMENTS', 0x8cdf, 'GL_ARB_framebuffer_object')
GL_MAX_RENDERBUFFER_SIZE = Enumerant('GL_MAX_RENDERBUFFER_SIZE', 0x84e8, 'GL_ARB_framebuffer_object')
GL_MAX_RENDERBUFFER_SIZE.esVersions = [2.0]
GL_MAX_SAMPLES = Enumerant('GL_MAX_SAMPLES', 0x8d57, 'GL_ARB_framebuffer_object')
GL_READ_FRAMEBUFFER = Enumerant('GL_READ_FRAMEBUFFER', 0x8ca8, 'GL_ARB_framebuffer_object')
GL_READ_FRAMEBUFFER_BINDING = Enumerant('GL_READ_FRAMEBUFFER_BINDING', 0x8caa, 'GL_ARB_framebuffer_object')
GL_RENDERBUFFER = Enumerant('GL_RENDERBUFFER', 0x8d41, 'GL_ARB_framebuffer_object')
GL_RENDERBUFFER.esVersions = [2.0]
GL_RENDERBUFFER_ALPHA_SIZE = Enumerant('GL_RENDERBUFFER_ALPHA_SIZE', 0x8d53, 'GL_ARB_framebuffer_object')
GL_RENDERBUFFER_ALPHA_SIZE.esVersions = [2.0]
GL_RENDERBUFFER_BINDING = Enumerant('GL_RENDERBUFFER_BINDING', 0x8ca7, 'GL_ARB_framebuffer_object')
GL_RENDERBUFFER_BINDING.esVersions = [2.0]
GL_RENDERBUFFER_BLUE_SIZE = Enumerant('GL_RENDERBUFFER_BLUE_SIZE', 0x8d52, 'GL_ARB_framebuffer_object')
GL_RENDERBUFFER_BLUE_SIZE.esVersions = [2.0]
GL_RENDERBUFFER_DEPTH_SIZE = Enumerant('GL_RENDERBUFFER_DEPTH_SIZE', 0x8d54, 'GL_ARB_framebuffer_object')
GL_RENDERBUFFER_DEPTH_SIZE.esVersions = [2.0]
GL_RENDERBUFFER_GREEN_SIZE = Enumerant('GL_RENDERBUFFER_GREEN_SIZE', 0x8d51, 'GL_ARB_framebuffer_object')
GL_RENDERBUFFER_GREEN_SIZE.esVersions = [2.0]
GL_RENDERBUFFER_HEIGHT = Enumerant('GL_RENDERBUFFER_HEIGHT', 0x8d43, 'GL_ARB_framebuffer_object')
GL_RENDERBUFFER_HEIGHT.esVersions = [2.0]
GL_RENDERBUFFER_INTERNAL_FORMAT = Enumerant('GL_RENDERBUFFER_INTERNAL_FORMAT', 0x8d44, 'GL_ARB_framebuffer_object')
GL_RENDERBUFFER_INTERNAL_FORMAT.esVersions = [2.0]
GL_RENDERBUFFER_RED_SIZE = Enumerant('GL_RENDERBUFFER_RED_SIZE', 0x8d50, 'GL_ARB_framebuffer_object')
GL_RENDERBUFFER_RED_SIZE.esVersions = [2.0]
GL_RENDERBUFFER_SAMPLES = Enumerant('GL_RENDERBUFFER_SAMPLES', 0x8cab, 'GL_ARB_framebuffer_object')
GL_RENDERBUFFER_STENCIL_SIZE = Enumerant('GL_RENDERBUFFER_STENCIL_SIZE', 0x8d55, 'GL_ARB_framebuffer_object')
GL_RENDERBUFFER_STENCIL_SIZE.esVersions = [2.0]
GL_RENDERBUFFER_WIDTH = Enumerant('GL_RENDERBUFFER_WIDTH', 0x8d42, 'GL_ARB_framebuffer_object')
GL_RENDERBUFFER_WIDTH.esVersions = [2.0]
GL_STENCIL_ATTACHMENT = Enumerant('GL_STENCIL_ATTACHMENT', 0x8d20, 'GL_ARB_framebuffer_object')
GL_STENCIL_ATTACHMENT.esVersions = [2.0]
GL_STENCIL_INDEX1 = Enumerant('GL_STENCIL_INDEX1', 0x8d46, 'GL_ARB_framebuffer_object')
GL_STENCIL_INDEX16 = Enumerant('GL_STENCIL_INDEX16', 0x8d49, 'GL_ARB_framebuffer_object')
GL_STENCIL_INDEX4 = Enumerant('GL_STENCIL_INDEX4', 0x8d47, 'GL_ARB_framebuffer_object')
GL_STENCIL_INDEX8 = Enumerant('GL_STENCIL_INDEX8', 0x8d48, 'GL_ARB_framebuffer_object')
GL_STENCIL_INDEX8.esVersions = [2.0]
GL_TEXTURE_STENCIL_SIZE = Enumerant('GL_TEXTURE_STENCIL_SIZE', 0x88f1, 'GL_ARB_framebuffer_object')
GL_UNSIGNED_INT_24_8 = Enumerant('GL_UNSIGNED_INT_24_8', 0x84fa, 'GL_ARB_framebuffer_object')
GL_UNSIGNED_NORMALIZED = Enumerant('GL_UNSIGNED_NORMALIZED', 0x8c17, 'GL_ARB_framebuffer_object')

defines.add(GL_COLOR_ATTACHMENT0)
defines.add(GL_COLOR_ATTACHMENT1)
defines.add(GL_COLOR_ATTACHMENT10)
defines.add(GL_COLOR_ATTACHMENT11)
defines.add(GL_COLOR_ATTACHMENT12)
defines.add(GL_COLOR_ATTACHMENT13)
defines.add(GL_COLOR_ATTACHMENT14)
defines.add(GL_COLOR_ATTACHMENT15)
defines.add(GL_COLOR_ATTACHMENT2)
defines.add(GL_COLOR_ATTACHMENT3)
defines.add(GL_COLOR_ATTACHMENT4)
defines.add(GL_COLOR_ATTACHMENT5)
defines.add(GL_COLOR_ATTACHMENT6)
defines.add(GL_COLOR_ATTACHMENT7)
defines.add(GL_COLOR_ATTACHMENT8)
defines.add(GL_COLOR_ATTACHMENT9)
defines.add(GL_DEPTH24_STENCIL8)
defines.add(GL_DEPTH_ATTACHMENT)
defines.add(GL_DEPTH_STENCIL)
defines.add(GL_DEPTH_STENCIL_ATTACHMENT)
defines.add(GL_DRAW_FRAMEBUFFER)
defines.add(GL_DRAW_FRAMEBUFFER_BINDING)
defines.add(GL_FRAMEBUFFER)
defines.add(GL_FRAMEBUFFER_ATTACHMENT_ALPHA_SIZE)
defines.add(GL_FRAMEBUFFER_ATTACHMENT_BLUE_SIZE)
defines.add(GL_FRAMEBUFFER_ATTACHMENT_COLOR_ENCODING)
defines.add(GL_FRAMEBUFFER_ATTACHMENT_COMPONENT_TYPE)
defines.add(GL_FRAMEBUFFER_ATTACHMENT_DEPTH_SIZE)
defines.add(GL_FRAMEBUFFER_ATTACHMENT_GREEN_SIZE)
defines.add(GL_FRAMEBUFFER_ATTACHMENT_OBJECT_NAME)
defines.add(GL_FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE)
defines.add(GL_FRAMEBUFFER_ATTACHMENT_RED_SIZE)
defines.add(GL_FRAMEBUFFER_ATTACHMENT_STENCIL_SIZE)
defines.add(GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE)
defines.add(GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_LAYER)
defines.add(GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL)
defines.add(GL_FRAMEBUFFER_BINDING)
defines.add(GL_FRAMEBUFFER_COMPLETE)
defines.add(GL_FRAMEBUFFER_DEFAULT)
defines.add(GL_FRAMEBUFFER_INCOMPLETE_ATTACHMENT)
defines.add(GL_FRAMEBUFFER_INCOMPLETE_DRAW_BUFFER)
defines.add(GL_FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT)
defines.add(GL_FRAMEBUFFER_INCOMPLETE_MULTISAMPLE)
defines.add(GL_FRAMEBUFFER_INCOMPLETE_READ_BUFFER)
defines.add(GL_FRAMEBUFFER_UNDEFINED)
defines.add(GL_FRAMEBUFFER_UNSUPPORTED)
defines.add(GL_INDEX)
defines.add(GL_INVALID_FRAMEBUFFER_OPERATION)
defines.add(GL_MAX_COLOR_ATTACHMENTS)
defines.add(GL_MAX_RENDERBUFFER_SIZE)
defines.add(GL_MAX_SAMPLES)
defines.add(GL_READ_FRAMEBUFFER)
defines.add(GL_READ_FRAMEBUFFER_BINDING)
defines.add(GL_RENDERBUFFER)
defines.add(GL_RENDERBUFFER_ALPHA_SIZE)
defines.add(GL_RENDERBUFFER_BINDING)
defines.add(GL_RENDERBUFFER_BLUE_SIZE)
defines.add(GL_RENDERBUFFER_DEPTH_SIZE)
defines.add(GL_RENDERBUFFER_GREEN_SIZE)
defines.add(GL_RENDERBUFFER_HEIGHT)
defines.add(GL_RENDERBUFFER_INTERNAL_FORMAT)
defines.add(GL_RENDERBUFFER_RED_SIZE)
defines.add(GL_RENDERBUFFER_SAMPLES)
defines.add(GL_RENDERBUFFER_STENCIL_SIZE)
defines.add(GL_RENDERBUFFER_WIDTH)
defines.add(GL_STENCIL_ATTACHMENT)
defines.add(GL_STENCIL_INDEX1)
defines.add(GL_STENCIL_INDEX16)
defines.add(GL_STENCIL_INDEX4)
defines.add(GL_STENCIL_INDEX8)
defines.add(GL_TEXTURE_STENCIL_SIZE)
defines.add(GL_UNSIGNED_INT_24_8)
defines.add(GL_UNSIGNED_NORMALIZED)

# GL_ARB_framebuffer_sRGB

GL_FRAMEBUFFER_SRGB = Enumerant('GL_FRAMEBUFFER_SRGB', 0x8db9, 'GL_ARB_framebuffer_sRGB')
GL_FRAMEBUFFER_SRGB.esVersions = [2.0]
GL_FRAMEBUFFER_SRGB.enableCap = True

defines.add(GL_FRAMEBUFFER_SRGB)

# GL_ARB_geometry_shader4

GL_FRAMEBUFFER_ATTACHMENT_LAYERED_ARB = Enumerant('GL_FRAMEBUFFER_ATTACHMENT_LAYERED_ARB', 0x8da7, 'GL_ARB_geometry_shader4')
GL_FRAMEBUFFER_INCOMPLETE_LAYER_COUNT_ARB = Enumerant('GL_FRAMEBUFFER_INCOMPLETE_LAYER_COUNT_ARB', 0x8da9, 'GL_ARB_geometry_shader4')
GL_FRAMEBUFFER_INCOMPLETE_LAYER_TARGETS_ARB = Enumerant('GL_FRAMEBUFFER_INCOMPLETE_LAYER_TARGETS_ARB', 0x8da8, 'GL_ARB_geometry_shader4')
GL_GEOMETRY_INPUT_TYPE_ARB = Enumerant('GL_GEOMETRY_INPUT_TYPE_ARB', 0x8ddb, 'GL_ARB_geometry_shader4')
GL_GEOMETRY_OUTPUT_TYPE_ARB = Enumerant('GL_GEOMETRY_OUTPUT_TYPE_ARB', 0x8ddc, 'GL_ARB_geometry_shader4')
GL_GEOMETRY_SHADER_ARB = Enumerant('GL_GEOMETRY_SHADER_ARB', 0x8dd9, 'GL_ARB_geometry_shader4')
GL_GEOMETRY_VERTICES_OUT_ARB = Enumerant('GL_GEOMETRY_VERTICES_OUT_ARB', 0x8dda, 'GL_ARB_geometry_shader4')
GL_LINES_ADJACENCY_ARB = Enumerant('GL_LINES_ADJACENCY_ARB', 0x000a, 'GL_ARB_geometry_shader4')
GL_LINE_STRIP_ADJACENCY_ARB = Enumerant('GL_LINE_STRIP_ADJACENCY_ARB', 0x000b, 'GL_ARB_geometry_shader4')
GL_MAX_GEOMETRY_OUTPUT_VERTICES_ARB = Enumerant('GL_MAX_GEOMETRY_OUTPUT_VERTICES_ARB', 0x8de0, 'GL_ARB_geometry_shader4')
GL_MAX_GEOMETRY_TEXTURE_IMAGE_UNITS_ARB = Enumerant('GL_MAX_GEOMETRY_TEXTURE_IMAGE_UNITS_ARB', 0x8c29, 'GL_ARB_geometry_shader4')
GL_MAX_GEOMETRY_TOTAL_OUTPUT_COMPONENTS_ARB = Enumerant('GL_MAX_GEOMETRY_TOTAL_OUTPUT_COMPONENTS_ARB', 0x8de1, 'GL_ARB_geometry_shader4')
GL_MAX_GEOMETRY_UNIFORM_COMPONENTS_ARB = Enumerant('GL_MAX_GEOMETRY_UNIFORM_COMPONENTS_ARB', 0x8ddf, 'GL_ARB_geometry_shader4')
GL_MAX_GEOMETRY_VARYING_COMPONENTS_ARB = Enumerant('GL_MAX_GEOMETRY_VARYING_COMPONENTS_ARB', 0x8ddd, 'GL_ARB_geometry_shader4')
GL_MAX_VERTEX_VARYING_COMPONENTS_ARB = Enumerant('GL_MAX_VERTEX_VARYING_COMPONENTS_ARB', 0x8dde, 'GL_ARB_geometry_shader4')
GL_PROGRAM_POINT_SIZE_ARB = Enumerant('GL_PROGRAM_POINT_SIZE_ARB', 0x8642, 'GL_ARB_geometry_shader4')
GL_TRIANGLES_ADJACENCY_ARB = Enumerant('GL_TRIANGLES_ADJACENCY_ARB', 0x000c, 'GL_ARB_geometry_shader4')
GL_TRIANGLE_STRIP_ADJACENCY_ARB = Enumerant('GL_TRIANGLE_STRIP_ADJACENCY_ARB', 0x000d, 'GL_ARB_geometry_shader4')

defines.add(GL_FRAMEBUFFER_ATTACHMENT_LAYERED_ARB)
defines.add(GL_FRAMEBUFFER_INCOMPLETE_LAYER_COUNT_ARB)
defines.add(GL_FRAMEBUFFER_INCOMPLETE_LAYER_TARGETS_ARB)
defines.add(GL_GEOMETRY_INPUT_TYPE_ARB)
defines.add(GL_GEOMETRY_OUTPUT_TYPE_ARB)
defines.add(GL_GEOMETRY_SHADER_ARB)
defines.add(GL_GEOMETRY_VERTICES_OUT_ARB)
defines.add(GL_LINES_ADJACENCY_ARB)
defines.add(GL_LINE_STRIP_ADJACENCY_ARB)
defines.add(GL_MAX_GEOMETRY_OUTPUT_VERTICES_ARB)
defines.add(GL_MAX_GEOMETRY_TEXTURE_IMAGE_UNITS_ARB)
defines.add(GL_MAX_GEOMETRY_TOTAL_OUTPUT_COMPONENTS_ARB)
defines.add(GL_MAX_GEOMETRY_UNIFORM_COMPONENTS_ARB)
defines.add(GL_MAX_GEOMETRY_VARYING_COMPONENTS_ARB)
defines.add(GL_MAX_VERTEX_VARYING_COMPONENTS_ARB)
defines.add(GL_PROGRAM_POINT_SIZE_ARB)
defines.add(GL_TRIANGLES_ADJACENCY_ARB)
defines.add(GL_TRIANGLE_STRIP_ADJACENCY_ARB)

# GL_ARB_get_program_binary

GL_NUM_PROGRAM_BINARY_FORMATS = Enumerant('GL_NUM_PROGRAM_BINARY_FORMATS', 0x87fe, 'GL_ARB_get_program_binary')
GL_PROGRAM_BINARY_FORMATS = Enumerant('GL_PROGRAM_BINARY_FORMATS', 0x87ff, 'GL_ARB_get_program_binary')
GL_PROGRAM_BINARY_LENGTH = Enumerant('GL_PROGRAM_BINARY_LENGTH', 0x8741, 'GL_ARB_get_program_binary')
GL_PROGRAM_BINARY_RETRIEVABLE_HINT = Enumerant('GL_PROGRAM_BINARY_RETRIEVABLE_HINT', 0x8257, 'GL_ARB_get_program_binary')

defines.add(GL_NUM_PROGRAM_BINARY_FORMATS)
defines.add(GL_PROGRAM_BINARY_FORMATS)
defines.add(GL_PROGRAM_BINARY_LENGTH)
defines.add(GL_PROGRAM_BINARY_RETRIEVABLE_HINT)

# GL_ARB_gpu_shader5

GL_FRAGMENT_INTERPOLATION_OFFSET_BITS = Enumerant('GL_FRAGMENT_INTERPOLATION_OFFSET_BITS', 0x8e5d, 'GL_ARB_gpu_shader5')
GL_GEOMETRY_SHADER_INVOCATIONS = Enumerant('GL_GEOMETRY_SHADER_INVOCATIONS', 0x887f, 'GL_ARB_gpu_shader5')
GL_MAX_FRAGMENT_INTERPOLATION_OFFSET = Enumerant('GL_MAX_FRAGMENT_INTERPOLATION_OFFSET', 0x8e5c, 'GL_ARB_gpu_shader5')
GL_MAX_GEOMETRY_SHADER_INVOCATIONS = Enumerant('GL_MAX_GEOMETRY_SHADER_INVOCATIONS', 0x8e5a, 'GL_ARB_gpu_shader5')
GL_MAX_VERTEX_STREAMS = Enumerant('GL_MAX_VERTEX_STREAMS', 0x8e71, 'GL_ARB_gpu_shader5')
GL_MIN_FRAGMENT_INTERPOLATION_OFFSET = Enumerant('GL_MIN_FRAGMENT_INTERPOLATION_OFFSET', 0x8e5b, 'GL_ARB_gpu_shader5')

defines.add(GL_FRAGMENT_INTERPOLATION_OFFSET_BITS)
defines.add(GL_GEOMETRY_SHADER_INVOCATIONS)
defines.add(GL_MAX_FRAGMENT_INTERPOLATION_OFFSET)
defines.add(GL_MAX_GEOMETRY_SHADER_INVOCATIONS)
defines.add(GL_MAX_VERTEX_STREAMS)
defines.add(GL_MIN_FRAGMENT_INTERPOLATION_OFFSET)

# GL_ARB_gpu_shader_fp64

GL_DOUBLE_MAT2 = Enumerant('GL_DOUBLE_MAT2', 0x8f46, 'GL_ARB_gpu_shader_fp64')
GL_DOUBLE_MAT2x3 = Enumerant('GL_DOUBLE_MAT2x3', 0x8f49, 'GL_ARB_gpu_shader_fp64')
GL_DOUBLE_MAT2x4 = Enumerant('GL_DOUBLE_MAT2x4', 0x8f4a, 'GL_ARB_gpu_shader_fp64')
GL_DOUBLE_MAT3 = Enumerant('GL_DOUBLE_MAT3', 0x8f47, 'GL_ARB_gpu_shader_fp64')
GL_DOUBLE_MAT3x2 = Enumerant('GL_DOUBLE_MAT3x2', 0x8f4b, 'GL_ARB_gpu_shader_fp64')
GL_DOUBLE_MAT3x4 = Enumerant('GL_DOUBLE_MAT3x4', 0x8f4c, 'GL_ARB_gpu_shader_fp64')
GL_DOUBLE_MAT4 = Enumerant('GL_DOUBLE_MAT4', 0x8f48, 'GL_ARB_gpu_shader_fp64')
GL_DOUBLE_MAT4x2 = Enumerant('GL_DOUBLE_MAT4x2', 0x8f4d, 'GL_ARB_gpu_shader_fp64')
GL_DOUBLE_MAT4x3 = Enumerant('GL_DOUBLE_MAT4x3', 0x8f4e, 'GL_ARB_gpu_shader_fp64')
GL_DOUBLE_VEC2 = Enumerant('GL_DOUBLE_VEC2', 0x8ffc, 'GL_ARB_gpu_shader_fp64')
GL_DOUBLE_VEC3 = Enumerant('GL_DOUBLE_VEC3', 0x8ffd, 'GL_ARB_gpu_shader_fp64')
GL_DOUBLE_VEC4 = Enumerant('GL_DOUBLE_VEC4', 0x8ffe, 'GL_ARB_gpu_shader_fp64')

defines.add(GL_DOUBLE_MAT2)
defines.add(GL_DOUBLE_MAT2x3)
defines.add(GL_DOUBLE_MAT2x4)
defines.add(GL_DOUBLE_MAT3)
defines.add(GL_DOUBLE_MAT3x2)
defines.add(GL_DOUBLE_MAT3x4)
defines.add(GL_DOUBLE_MAT4)
defines.add(GL_DOUBLE_MAT4x2)
defines.add(GL_DOUBLE_MAT4x3)
defines.add(GL_DOUBLE_VEC2)
defines.add(GL_DOUBLE_VEC3)
defines.add(GL_DOUBLE_VEC4)

# GL_ARB_half_float_pixel

GL_HALF_FLOAT_ARB = Enumerant('GL_HALF_FLOAT_ARB', 0x140b, 'GL_ARB_half_float_pixel')

defines.add(GL_HALF_FLOAT_ARB)

# GL_ARB_half_float_vertex

GL_HALF_FLOAT = Enumerant('GL_HALF_FLOAT', 0x140b, 'GL_ARB_half_float_vertex')

defines.add(GL_HALF_FLOAT)

# GL_ARB_imaging

GL_BLEND_COLOR = Enumerant('GL_BLEND_COLOR', 0x8005, 'GL_ARB_imaging')
GL_BLEND_COLOR.esVersions = [2.0]
GL_BLEND_EQUATION = Enumerant('GL_BLEND_EQUATION', 0x8009, 'GL_ARB_imaging')
GL_BLEND_EQUATION.esVersions = [2.0]
GL_COLOR_MATRIX = Enumerant('GL_COLOR_MATRIX', 0x80b1, 'GL_ARB_imaging')
GL_COLOR_MATRIX_STACK_DEPTH = Enumerant('GL_COLOR_MATRIX_STACK_DEPTH', 0x80b2, 'GL_ARB_imaging')
GL_COLOR_TABLE = Enumerant('GL_COLOR_TABLE', 0x80d0, 'GL_ARB_imaging')
GL_COLOR_TABLE_ALPHA_SIZE = Enumerant('GL_COLOR_TABLE_ALPHA_SIZE', 0x80dd, 'GL_ARB_imaging')
GL_COLOR_TABLE_BIAS = Enumerant('GL_COLOR_TABLE_BIAS', 0x80d7, 'GL_ARB_imaging')
GL_COLOR_TABLE_BLUE_SIZE = Enumerant('GL_COLOR_TABLE_BLUE_SIZE', 0x80dc, 'GL_ARB_imaging')
GL_COLOR_TABLE_FORMAT = Enumerant('GL_COLOR_TABLE_FORMAT', 0x80d8, 'GL_ARB_imaging')
GL_COLOR_TABLE_GREEN_SIZE = Enumerant('GL_COLOR_TABLE_GREEN_SIZE', 0x80db, 'GL_ARB_imaging')
GL_COLOR_TABLE_INTENSITY_SIZE = Enumerant('GL_COLOR_TABLE_INTENSITY_SIZE', 0x80df, 'GL_ARB_imaging')
GL_COLOR_TABLE_LUMINANCE_SIZE = Enumerant('GL_COLOR_TABLE_LUMINANCE_SIZE', 0x80de, 'GL_ARB_imaging')
GL_COLOR_TABLE_RED_SIZE = Enumerant('GL_COLOR_TABLE_RED_SIZE', 0x80da, 'GL_ARB_imaging')
GL_COLOR_TABLE_SCALE = Enumerant('GL_COLOR_TABLE_SCALE', 0x80d6, 'GL_ARB_imaging')
GL_COLOR_TABLE_WIDTH = Enumerant('GL_COLOR_TABLE_WIDTH', 0x80d9, 'GL_ARB_imaging')
GL_CONSTANT_ALPHA = Enumerant('GL_CONSTANT_ALPHA', 0x8003, 'GL_ARB_imaging')
GL_CONSTANT_ALPHA.esVersions = [2.0]
GL_CONSTANT_BORDER = Enumerant('GL_CONSTANT_BORDER', 0x8151, 'GL_ARB_imaging')
GL_CONSTANT_COLOR = Enumerant('GL_CONSTANT_COLOR', 0x8001, 'GL_ARB_imaging')
GL_CONSTANT_COLOR.esVersions = [2.0]
GL_CONVOLUTION_1D = Enumerant('GL_CONVOLUTION_1D', 0x8010, 'GL_ARB_imaging')
GL_CONVOLUTION_2D = Enumerant('GL_CONVOLUTION_2D', 0x8011, 'GL_ARB_imaging')
GL_CONVOLUTION_BORDER_COLOR = Enumerant('GL_CONVOLUTION_BORDER_COLOR', 0x8154, 'GL_ARB_imaging')
GL_CONVOLUTION_BORDER_MODE = Enumerant('GL_CONVOLUTION_BORDER_MODE', 0x8013, 'GL_ARB_imaging')
GL_CONVOLUTION_FILTER_BIAS = Enumerant('GL_CONVOLUTION_FILTER_BIAS', 0x8015, 'GL_ARB_imaging')
GL_CONVOLUTION_FILTER_SCALE = Enumerant('GL_CONVOLUTION_FILTER_SCALE', 0x8014, 'GL_ARB_imaging')
GL_CONVOLUTION_FORMAT = Enumerant('GL_CONVOLUTION_FORMAT', 0x8017, 'GL_ARB_imaging')
GL_CONVOLUTION_HEIGHT = Enumerant('GL_CONVOLUTION_HEIGHT', 0x8019, 'GL_ARB_imaging')
GL_CONVOLUTION_WIDTH = Enumerant('GL_CONVOLUTION_WIDTH', 0x8018, 'GL_ARB_imaging')
GL_FUNC_ADD = Enumerant('GL_FUNC_ADD', 0x8006, 'GL_ARB_imaging')
GL_FUNC_ADD.esVersions = [2.0]
GL_FUNC_REVERSE_SUBTRACT = Enumerant('GL_FUNC_REVERSE_SUBTRACT', 0x800b, 'GL_ARB_imaging')
GL_FUNC_REVERSE_SUBTRACT.esVersions = [2.0]
GL_FUNC_SUBTRACT = Enumerant('GL_FUNC_SUBTRACT', 0x800a, 'GL_ARB_imaging')
GL_FUNC_SUBTRACT.esVersions = [2.0]
GL_HISTOGRAM = Enumerant('GL_HISTOGRAM', 0x8024, 'GL_ARB_imaging')
GL_HISTOGRAM_ALPHA_SIZE = Enumerant('GL_HISTOGRAM_ALPHA_SIZE', 0x802b, 'GL_ARB_imaging')
GL_HISTOGRAM_BLUE_SIZE = Enumerant('GL_HISTOGRAM_BLUE_SIZE', 0x802a, 'GL_ARB_imaging')
GL_HISTOGRAM_FORMAT = Enumerant('GL_HISTOGRAM_FORMAT', 0x8027, 'GL_ARB_imaging')
GL_HISTOGRAM_GREEN_SIZE = Enumerant('GL_HISTOGRAM_GREEN_SIZE', 0x8029, 'GL_ARB_imaging')
GL_HISTOGRAM_LUMINANCE_SIZE = Enumerant('GL_HISTOGRAM_LUMINANCE_SIZE', 0x802c, 'GL_ARB_imaging')
GL_HISTOGRAM_RED_SIZE = Enumerant('GL_HISTOGRAM_RED_SIZE', 0x8028, 'GL_ARB_imaging')
GL_HISTOGRAM_SINK = Enumerant('GL_HISTOGRAM_SINK', 0x802d, 'GL_ARB_imaging')
GL_HISTOGRAM_WIDTH = Enumerant('GL_HISTOGRAM_WIDTH', 0x8026, 'GL_ARB_imaging')
GL_IGNORE_BORDER = Enumerant('GL_IGNORE_BORDER', 0x8150, 'GL_ARB_imaging')
GL_MAX = Enumerant('GL_MAX', 0x8008, 'GL_ARB_imaging')
GL_MAX_COLOR_MATRIX_STACK_DEPTH = Enumerant('GL_MAX_COLOR_MATRIX_STACK_DEPTH', 0x80b3, 'GL_ARB_imaging')
GL_MAX_CONVOLUTION_HEIGHT = Enumerant('GL_MAX_CONVOLUTION_HEIGHT', 0x801b, 'GL_ARB_imaging')
GL_MAX_CONVOLUTION_WIDTH = Enumerant('GL_MAX_CONVOLUTION_WIDTH', 0x801a, 'GL_ARB_imaging')
GL_MIN = Enumerant('GL_MIN', 0x8007, 'GL_ARB_imaging')
GL_MINMAX = Enumerant('GL_MINMAX', 0x802e, 'GL_ARB_imaging')
GL_MINMAX_FORMAT = Enumerant('GL_MINMAX_FORMAT', 0x802f, 'GL_ARB_imaging')
GL_MINMAX_SINK = Enumerant('GL_MINMAX_SINK', 0x8030, 'GL_ARB_imaging')
GL_ONE_MINUS_CONSTANT_ALPHA = Enumerant('GL_ONE_MINUS_CONSTANT_ALPHA', 0x8004, 'GL_ARB_imaging')
GL_ONE_MINUS_CONSTANT_ALPHA.esVersions = [2.0]
GL_ONE_MINUS_CONSTANT_COLOR = Enumerant('GL_ONE_MINUS_CONSTANT_COLOR', 0x8002, 'GL_ARB_imaging')
GL_ONE_MINUS_CONSTANT_COLOR.esVersions = [2.0]
GL_POST_COLOR_MATRIX_ALPHA_BIAS = Enumerant('GL_POST_COLOR_MATRIX_ALPHA_BIAS', 0x80bb, 'GL_ARB_imaging')
GL_POST_COLOR_MATRIX_ALPHA_SCALE = Enumerant('GL_POST_COLOR_MATRIX_ALPHA_SCALE', 0x80b7, 'GL_ARB_imaging')
GL_POST_COLOR_MATRIX_BLUE_BIAS = Enumerant('GL_POST_COLOR_MATRIX_BLUE_BIAS', 0x80ba, 'GL_ARB_imaging')
GL_POST_COLOR_MATRIX_BLUE_SCALE = Enumerant('GL_POST_COLOR_MATRIX_BLUE_SCALE', 0x80b6, 'GL_ARB_imaging')
GL_POST_COLOR_MATRIX_COLOR_TABLE = Enumerant('GL_POST_COLOR_MATRIX_COLOR_TABLE', 0x80d2, 'GL_ARB_imaging')
GL_POST_COLOR_MATRIX_GREEN_BIAS = Enumerant('GL_POST_COLOR_MATRIX_GREEN_BIAS', 0x80b9, 'GL_ARB_imaging')
GL_POST_COLOR_MATRIX_GREEN_SCALE = Enumerant('GL_POST_COLOR_MATRIX_GREEN_SCALE', 0x80b5, 'GL_ARB_imaging')
GL_POST_COLOR_MATRIX_RED_BIAS = Enumerant('GL_POST_COLOR_MATRIX_RED_BIAS', 0x80b8, 'GL_ARB_imaging')
GL_POST_COLOR_MATRIX_RED_SCALE = Enumerant('GL_POST_COLOR_MATRIX_RED_SCALE', 0x80b4, 'GL_ARB_imaging')
GL_POST_CONVOLUTION_ALPHA_BIAS = Enumerant('GL_POST_CONVOLUTION_ALPHA_BIAS', 0x8023, 'GL_ARB_imaging')
GL_POST_CONVOLUTION_ALPHA_SCALE = Enumerant('GL_POST_CONVOLUTION_ALPHA_SCALE', 0x801f, 'GL_ARB_imaging')
GL_POST_CONVOLUTION_BLUE_BIAS = Enumerant('GL_POST_CONVOLUTION_BLUE_BIAS', 0x8022, 'GL_ARB_imaging')
GL_POST_CONVOLUTION_BLUE_SCALE = Enumerant('GL_POST_CONVOLUTION_BLUE_SCALE', 0x801e, 'GL_ARB_imaging')
GL_POST_CONVOLUTION_COLOR_TABLE = Enumerant('GL_POST_CONVOLUTION_COLOR_TABLE', 0x80d1, 'GL_ARB_imaging')
GL_POST_CONVOLUTION_GREEN_BIAS = Enumerant('GL_POST_CONVOLUTION_GREEN_BIAS', 0x8021, 'GL_ARB_imaging')
GL_POST_CONVOLUTION_GREEN_SCALE = Enumerant('GL_POST_CONVOLUTION_GREEN_SCALE', 0x801d, 'GL_ARB_imaging')
GL_POST_CONVOLUTION_RED_BIAS = Enumerant('GL_POST_CONVOLUTION_RED_BIAS', 0x8020, 'GL_ARB_imaging')
GL_POST_CONVOLUTION_RED_SCALE = Enumerant('GL_POST_CONVOLUTION_RED_SCALE', 0x801c, 'GL_ARB_imaging')
GL_PROXY_COLOR_TABLE = Enumerant('GL_PROXY_COLOR_TABLE', 0x80d3, 'GL_ARB_imaging')
GL_PROXY_HISTOGRAM = Enumerant('GL_PROXY_HISTOGRAM', 0x8025, 'GL_ARB_imaging')
GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE = Enumerant('GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE', 0x80d5, 'GL_ARB_imaging')
GL_PROXY_POST_CONVOLUTION_COLOR_TABLE = Enumerant('GL_PROXY_POST_CONVOLUTION_COLOR_TABLE', 0x80d4, 'GL_ARB_imaging')
GL_REDUCE = Enumerant('GL_REDUCE', 0x8016, 'GL_ARB_imaging')
GL_REPLICATE_BORDER = Enumerant('GL_REPLICATE_BORDER', 0x8153, 'GL_ARB_imaging')
GL_SEPARABLE_2D = Enumerant('GL_SEPARABLE_2D', 0x8012, 'GL_ARB_imaging')
GL_TABLE_TOO_LARGE = Enumerant('GL_TABLE_TOO_LARGE', 0x8031, 'GL_ARB_imaging')
GL_TABLE_TOO_LARGE.gluErrorString = 'table too large'
GL_WRAP_BORDER = Enumerant('GL_WRAP_BORDER', 0x8152, 'GL_ARB_imaging')

defines.add(GL_BLEND_COLOR)
defines.add(GL_BLEND_EQUATION)
defines.add(GL_COLOR_MATRIX)
defines.add(GL_COLOR_MATRIX_STACK_DEPTH)
defines.add(GL_COLOR_TABLE)
defines.add(GL_COLOR_TABLE_ALPHA_SIZE)
defines.add(GL_COLOR_TABLE_BIAS)
defines.add(GL_COLOR_TABLE_BLUE_SIZE)
defines.add(GL_COLOR_TABLE_FORMAT)
defines.add(GL_COLOR_TABLE_GREEN_SIZE)
defines.add(GL_COLOR_TABLE_INTENSITY_SIZE)
defines.add(GL_COLOR_TABLE_LUMINANCE_SIZE)
defines.add(GL_COLOR_TABLE_RED_SIZE)
defines.add(GL_COLOR_TABLE_SCALE)
defines.add(GL_COLOR_TABLE_WIDTH)
defines.add(GL_CONSTANT_ALPHA)
defines.add(GL_CONSTANT_BORDER)
defines.add(GL_CONSTANT_COLOR)
defines.add(GL_CONVOLUTION_1D)
defines.add(GL_CONVOLUTION_2D)
defines.add(GL_CONVOLUTION_BORDER_COLOR)
defines.add(GL_CONVOLUTION_BORDER_MODE)
defines.add(GL_CONVOLUTION_FILTER_BIAS)
defines.add(GL_CONVOLUTION_FILTER_SCALE)
defines.add(GL_CONVOLUTION_FORMAT)
defines.add(GL_CONVOLUTION_HEIGHT)
defines.add(GL_CONVOLUTION_WIDTH)
defines.add(GL_FUNC_ADD)
defines.add(GL_FUNC_REVERSE_SUBTRACT)
defines.add(GL_FUNC_SUBTRACT)
defines.add(GL_HISTOGRAM)
defines.add(GL_HISTOGRAM_ALPHA_SIZE)
defines.add(GL_HISTOGRAM_BLUE_SIZE)
defines.add(GL_HISTOGRAM_FORMAT)
defines.add(GL_HISTOGRAM_GREEN_SIZE)
defines.add(GL_HISTOGRAM_LUMINANCE_SIZE)
defines.add(GL_HISTOGRAM_RED_SIZE)
defines.add(GL_HISTOGRAM_SINK)
defines.add(GL_HISTOGRAM_WIDTH)
defines.add(GL_IGNORE_BORDER)
defines.add(GL_MAX)
defines.add(GL_MAX_COLOR_MATRIX_STACK_DEPTH)
defines.add(GL_MAX_CONVOLUTION_HEIGHT)
defines.add(GL_MAX_CONVOLUTION_WIDTH)
defines.add(GL_MIN)
defines.add(GL_MINMAX)
defines.add(GL_MINMAX_FORMAT)
defines.add(GL_MINMAX_SINK)
defines.add(GL_ONE_MINUS_CONSTANT_ALPHA)
defines.add(GL_ONE_MINUS_CONSTANT_COLOR)
defines.add(GL_POST_COLOR_MATRIX_ALPHA_BIAS)
defines.add(GL_POST_COLOR_MATRIX_ALPHA_SCALE)
defines.add(GL_POST_COLOR_MATRIX_BLUE_BIAS)
defines.add(GL_POST_COLOR_MATRIX_BLUE_SCALE)
defines.add(GL_POST_COLOR_MATRIX_COLOR_TABLE)
defines.add(GL_POST_COLOR_MATRIX_GREEN_BIAS)
defines.add(GL_POST_COLOR_MATRIX_GREEN_SCALE)
defines.add(GL_POST_COLOR_MATRIX_RED_BIAS)
defines.add(GL_POST_COLOR_MATRIX_RED_SCALE)
defines.add(GL_POST_CONVOLUTION_ALPHA_BIAS)
defines.add(GL_POST_CONVOLUTION_ALPHA_SCALE)
defines.add(GL_POST_CONVOLUTION_BLUE_BIAS)
defines.add(GL_POST_CONVOLUTION_BLUE_SCALE)
defines.add(GL_POST_CONVOLUTION_COLOR_TABLE)
defines.add(GL_POST_CONVOLUTION_GREEN_BIAS)
defines.add(GL_POST_CONVOLUTION_GREEN_SCALE)
defines.add(GL_POST_CONVOLUTION_RED_BIAS)
defines.add(GL_POST_CONVOLUTION_RED_SCALE)
defines.add(GL_PROXY_COLOR_TABLE)
defines.add(GL_PROXY_HISTOGRAM)
defines.add(GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE)
defines.add(GL_PROXY_POST_CONVOLUTION_COLOR_TABLE)
defines.add(GL_REDUCE)
defines.add(GL_REPLICATE_BORDER)
defines.add(GL_SEPARABLE_2D)
defines.add(GL_TABLE_TOO_LARGE)
defines.add(GL_WRAP_BORDER)

# GL_ARB_indirect_parameters

GL_PARAMETER_BUFFER_ARB = Enumerant('GL_PARAMETER_BUFFER_ARB', 0x80ee, 'GL_ARB_indirect_parameters')
GL_PARAMETER_BUFFER_BINDING_ARB = Enumerant('GL_PARAMETER_BUFFER_BINDING_ARB', 0x80ef, 'GL_ARB_indirect_parameters')

defines.add(GL_PARAMETER_BUFFER_ARB)
defines.add(GL_PARAMETER_BUFFER_BINDING_ARB)

# GL_ARB_instanced_arrays

GL_VERTEX_ATTRIB_ARRAY_DIVISOR_ARB = Enumerant('GL_VERTEX_ATTRIB_ARRAY_DIVISOR_ARB', 0x88fe, 'GL_ARB_instanced_arrays')

defines.add(GL_VERTEX_ATTRIB_ARRAY_DIVISOR_ARB)

# GL_ARB_internalformat_query

GL_NUM_SAMPLE_COUNTS = Enumerant('GL_NUM_SAMPLE_COUNTS', 0x9380, 'GL_ARB_internalformat_query')

defines.add(GL_NUM_SAMPLE_COUNTS)

# GL_ARB_internalformat_query2

GL_AUTO_GENERATE_MIPMAP = Enumerant('GL_AUTO_GENERATE_MIPMAP', 0x8295, 'GL_ARB_internalformat_query2')
GL_CAVEAT_SUPPORT = Enumerant('GL_CAVEAT_SUPPORT', 0x82b8, 'GL_ARB_internalformat_query2')
GL_CLEAR_BUFFER = Enumerant('GL_CLEAR_BUFFER', 0x82b4, 'GL_ARB_internalformat_query2')
GL_COLOR_COMPONENTS = Enumerant('GL_COLOR_COMPONENTS', 0x8283, 'GL_ARB_internalformat_query2')
GL_COLOR_ENCODING = Enumerant('GL_COLOR_ENCODING', 0x8296, 'GL_ARB_internalformat_query2')
GL_COLOR_RENDERABLE = Enumerant('GL_COLOR_RENDERABLE', 0x8286, 'GL_ARB_internalformat_query2')
GL_COMPUTE_TEXTURE = Enumerant('GL_COMPUTE_TEXTURE', 0x82a0, 'GL_ARB_internalformat_query2')
GL_DEPTH_COMPONENTS = Enumerant('GL_DEPTH_COMPONENTS', 0x8284, 'GL_ARB_internalformat_query2')
GL_DEPTH_RENDERABLE = Enumerant('GL_DEPTH_RENDERABLE', 0x8287, 'GL_ARB_internalformat_query2')
GL_FILTER = Enumerant('GL_FILTER', 0x829a, 'GL_ARB_internalformat_query2')
GL_FRAGMENT_TEXTURE = Enumerant('GL_FRAGMENT_TEXTURE', 0x829f, 'GL_ARB_internalformat_query2')
GL_FRAMEBUFFER_BLEND = Enumerant('GL_FRAMEBUFFER_BLEND', 0x828b, 'GL_ARB_internalformat_query2')
GL_FRAMEBUFFER_RENDERABLE = Enumerant('GL_FRAMEBUFFER_RENDERABLE', 0x8289, 'GL_ARB_internalformat_query2')
GL_FRAMEBUFFER_RENDERABLE_LAYERED = Enumerant('GL_FRAMEBUFFER_RENDERABLE_LAYERED', 0x828a, 'GL_ARB_internalformat_query2')
GL_FULL_SUPPORT = Enumerant('GL_FULL_SUPPORT', 0x82b7, 'GL_ARB_internalformat_query2')
GL_GEOMETRY_TEXTURE = Enumerant('GL_GEOMETRY_TEXTURE', 0x829e, 'GL_ARB_internalformat_query2')
GL_GET_TEXTURE_IMAGE_FORMAT = Enumerant('GL_GET_TEXTURE_IMAGE_FORMAT', 0x8291, 'GL_ARB_internalformat_query2')
GL_GET_TEXTURE_IMAGE_TYPE = Enumerant('GL_GET_TEXTURE_IMAGE_TYPE', 0x8292, 'GL_ARB_internalformat_query2')
GL_IMAGE_CLASS_10_10_10_2 = Enumerant('GL_IMAGE_CLASS_10_10_10_2', 0x82c3, 'GL_ARB_internalformat_query2')
GL_IMAGE_CLASS_11_11_10 = Enumerant('GL_IMAGE_CLASS_11_11_10', 0x82c2, 'GL_ARB_internalformat_query2')
GL_IMAGE_CLASS_1_X_16 = Enumerant('GL_IMAGE_CLASS_1_X_16', 0x82be, 'GL_ARB_internalformat_query2')
GL_IMAGE_CLASS_1_X_32 = Enumerant('GL_IMAGE_CLASS_1_X_32', 0x82bb, 'GL_ARB_internalformat_query2')
GL_IMAGE_CLASS_1_X_8 = Enumerant('GL_IMAGE_CLASS_1_X_8', 0x82c1, 'GL_ARB_internalformat_query2')
GL_IMAGE_CLASS_2_X_16 = Enumerant('GL_IMAGE_CLASS_2_X_16', 0x82bd, 'GL_ARB_internalformat_query2')
GL_IMAGE_CLASS_2_X_32 = Enumerant('GL_IMAGE_CLASS_2_X_32', 0x82ba, 'GL_ARB_internalformat_query2')
GL_IMAGE_CLASS_2_X_8 = Enumerant('GL_IMAGE_CLASS_2_X_8', 0x82c0, 'GL_ARB_internalformat_query2')
GL_IMAGE_CLASS_4_X_16 = Enumerant('GL_IMAGE_CLASS_4_X_16', 0x82bc, 'GL_ARB_internalformat_query2')
GL_IMAGE_CLASS_4_X_32 = Enumerant('GL_IMAGE_CLASS_4_X_32', 0x82b9, 'GL_ARB_internalformat_query2')
GL_IMAGE_CLASS_4_X_8 = Enumerant('GL_IMAGE_CLASS_4_X_8', 0x82bf, 'GL_ARB_internalformat_query2')
GL_IMAGE_COMPATIBILITY_CLASS = Enumerant('GL_IMAGE_COMPATIBILITY_CLASS', 0x82a8, 'GL_ARB_internalformat_query2')
GL_IMAGE_PIXEL_FORMAT = Enumerant('GL_IMAGE_PIXEL_FORMAT', 0x82a9, 'GL_ARB_internalformat_query2')
GL_IMAGE_PIXEL_TYPE = Enumerant('GL_IMAGE_PIXEL_TYPE', 0x82aa, 'GL_ARB_internalformat_query2')
GL_IMAGE_TEXEL_SIZE = Enumerant('GL_IMAGE_TEXEL_SIZE', 0x82a7, 'GL_ARB_internalformat_query2')
GL_INTERNALFORMAT_ALPHA_SIZE = Enumerant('GL_INTERNALFORMAT_ALPHA_SIZE', 0x8274, 'GL_ARB_internalformat_query2')
GL_INTERNALFORMAT_ALPHA_TYPE = Enumerant('GL_INTERNALFORMAT_ALPHA_TYPE', 0x827b, 'GL_ARB_internalformat_query2')
GL_INTERNALFORMAT_BLUE_SIZE = Enumerant('GL_INTERNALFORMAT_BLUE_SIZE', 0x8273, 'GL_ARB_internalformat_query2')
GL_INTERNALFORMAT_BLUE_TYPE = Enumerant('GL_INTERNALFORMAT_BLUE_TYPE', 0x827a, 'GL_ARB_internalformat_query2')
GL_INTERNALFORMAT_DEPTH_SIZE = Enumerant('GL_INTERNALFORMAT_DEPTH_SIZE', 0x8275, 'GL_ARB_internalformat_query2')
GL_INTERNALFORMAT_DEPTH_TYPE = Enumerant('GL_INTERNALFORMAT_DEPTH_TYPE', 0x827c, 'GL_ARB_internalformat_query2')
GL_INTERNALFORMAT_GREEN_SIZE = Enumerant('GL_INTERNALFORMAT_GREEN_SIZE', 0x8272, 'GL_ARB_internalformat_query2')
GL_INTERNALFORMAT_GREEN_TYPE = Enumerant('GL_INTERNALFORMAT_GREEN_TYPE', 0x8279, 'GL_ARB_internalformat_query2')
GL_INTERNALFORMAT_PREFERRED = Enumerant('GL_INTERNALFORMAT_PREFERRED', 0x8270, 'GL_ARB_internalformat_query2')
GL_INTERNALFORMAT_RED_SIZE = Enumerant('GL_INTERNALFORMAT_RED_SIZE', 0x8271, 'GL_ARB_internalformat_query2')
GL_INTERNALFORMAT_RED_TYPE = Enumerant('GL_INTERNALFORMAT_RED_TYPE', 0x8278, 'GL_ARB_internalformat_query2')
GL_INTERNALFORMAT_SHARED_SIZE = Enumerant('GL_INTERNALFORMAT_SHARED_SIZE', 0x8277, 'GL_ARB_internalformat_query2')
GL_INTERNALFORMAT_STENCIL_SIZE = Enumerant('GL_INTERNALFORMAT_STENCIL_SIZE', 0x8276, 'GL_ARB_internalformat_query2')
GL_INTERNALFORMAT_STENCIL_TYPE = Enumerant('GL_INTERNALFORMAT_STENCIL_TYPE', 0x827d, 'GL_ARB_internalformat_query2')
GL_INTERNALFORMAT_SUPPORTED = Enumerant('GL_INTERNALFORMAT_SUPPORTED', 0x826f, 'GL_ARB_internalformat_query2')
GL_MANUAL_GENERATE_MIPMAP = Enumerant('GL_MANUAL_GENERATE_MIPMAP', 0x8294, 'GL_ARB_internalformat_query2')
GL_MAX_COMBINED_DIMENSIONS = Enumerant('GL_MAX_COMBINED_DIMENSIONS', 0x8282, 'GL_ARB_internalformat_query2')
GL_MAX_DEPTH = Enumerant('GL_MAX_DEPTH', 0x8280, 'GL_ARB_internalformat_query2')
GL_MAX_HEIGHT = Enumerant('GL_MAX_HEIGHT', 0x827f, 'GL_ARB_internalformat_query2')
GL_MAX_LAYERS = Enumerant('GL_MAX_LAYERS', 0x8281, 'GL_ARB_internalformat_query2')
GL_MAX_WIDTH = Enumerant('GL_MAX_WIDTH', 0x827e, 'GL_ARB_internalformat_query2')
GL_MIPMAP = Enumerant('GL_MIPMAP', 0x8293, 'GL_ARB_internalformat_query2')
GL_READ_PIXELS = Enumerant('GL_READ_PIXELS', 0x828c, 'GL_ARB_internalformat_query2')
GL_READ_PIXELS_FORMAT = Enumerant('GL_READ_PIXELS_FORMAT', 0x828d, 'GL_ARB_internalformat_query2')
GL_READ_PIXELS_TYPE = Enumerant('GL_READ_PIXELS_TYPE', 0x828e, 'GL_ARB_internalformat_query2')
GL_SHADER_IMAGE_ATOMIC = Enumerant('GL_SHADER_IMAGE_ATOMIC', 0x82a6, 'GL_ARB_internalformat_query2')
GL_SHADER_IMAGE_LOAD = Enumerant('GL_SHADER_IMAGE_LOAD', 0x82a4, 'GL_ARB_internalformat_query2')
GL_SHADER_IMAGE_STORE = Enumerant('GL_SHADER_IMAGE_STORE', 0x82a5, 'GL_ARB_internalformat_query2')
GL_SIMULTANEOUS_TEXTURE_AND_DEPTH_TEST = Enumerant('GL_SIMULTANEOUS_TEXTURE_AND_DEPTH_TEST', 0x82ac, 'GL_ARB_internalformat_query2')
GL_SIMULTANEOUS_TEXTURE_AND_DEPTH_WRITE = Enumerant('GL_SIMULTANEOUS_TEXTURE_AND_DEPTH_WRITE', 0x82ae, 'GL_ARB_internalformat_query2')
GL_SIMULTANEOUS_TEXTURE_AND_STENCIL_TEST = Enumerant('GL_SIMULTANEOUS_TEXTURE_AND_STENCIL_TEST', 0x82ad, 'GL_ARB_internalformat_query2')
GL_SIMULTANEOUS_TEXTURE_AND_STENCIL_WRITE = Enumerant('GL_SIMULTANEOUS_TEXTURE_AND_STENCIL_WRITE', 0x82af, 'GL_ARB_internalformat_query2')
GL_SRGB_DECODE_ARB = Enumerant('GL_SRGB_DECODE_ARB', 0x8299, 'GL_ARB_internalformat_query2')
GL_SRGB_READ = Enumerant('GL_SRGB_READ', 0x8297, 'GL_ARB_internalformat_query2')
GL_SRGB_WRITE = Enumerant('GL_SRGB_WRITE', 0x8298, 'GL_ARB_internalformat_query2')
GL_STENCIL_COMPONENTS = Enumerant('GL_STENCIL_COMPONENTS', 0x8285, 'GL_ARB_internalformat_query2')
GL_STENCIL_RENDERABLE = Enumerant('GL_STENCIL_RENDERABLE', 0x8288, 'GL_ARB_internalformat_query2')
GL_TESS_CONTROL_TEXTURE = Enumerant('GL_TESS_CONTROL_TEXTURE', 0x829c, 'GL_ARB_internalformat_query2')
GL_TESS_EVALUATION_TEXTURE = Enumerant('GL_TESS_EVALUATION_TEXTURE', 0x829d, 'GL_ARB_internalformat_query2')
GL_TEXTURE_COMPRESSED_BLOCK_HEIGHT = Enumerant('GL_TEXTURE_COMPRESSED_BLOCK_HEIGHT', 0x82b2, 'GL_ARB_internalformat_query2')
GL_TEXTURE_COMPRESSED_BLOCK_SIZE = Enumerant('GL_TEXTURE_COMPRESSED_BLOCK_SIZE', 0x82b3, 'GL_ARB_internalformat_query2')
GL_TEXTURE_COMPRESSED_BLOCK_WIDTH = Enumerant('GL_TEXTURE_COMPRESSED_BLOCK_WIDTH', 0x82b1, 'GL_ARB_internalformat_query2')
GL_TEXTURE_GATHER = Enumerant('GL_TEXTURE_GATHER', 0x82a2, 'GL_ARB_internalformat_query2')
GL_TEXTURE_GATHER_SHADOW = Enumerant('GL_TEXTURE_GATHER_SHADOW', 0x82a3, 'GL_ARB_internalformat_query2')
GL_TEXTURE_IMAGE_FORMAT = Enumerant('GL_TEXTURE_IMAGE_FORMAT', 0x828f, 'GL_ARB_internalformat_query2')
GL_TEXTURE_IMAGE_TYPE = Enumerant('GL_TEXTURE_IMAGE_TYPE', 0x8290, 'GL_ARB_internalformat_query2')
GL_TEXTURE_SHADOW = Enumerant('GL_TEXTURE_SHADOW', 0x82a1, 'GL_ARB_internalformat_query2')
GL_TEXTURE_VIEW = Enumerant('GL_TEXTURE_VIEW', 0x82b5, 'GL_ARB_internalformat_query2')
GL_VERTEX_TEXTURE = Enumerant('GL_VERTEX_TEXTURE', 0x829b, 'GL_ARB_internalformat_query2')
GL_VIEW_CLASS_128_BITS = Enumerant('GL_VIEW_CLASS_128_BITS', 0x82c4, 'GL_ARB_internalformat_query2')
GL_VIEW_CLASS_16_BITS = Enumerant('GL_VIEW_CLASS_16_BITS', 0x82ca, 'GL_ARB_internalformat_query2')
GL_VIEW_CLASS_24_BITS = Enumerant('GL_VIEW_CLASS_24_BITS', 0x82c9, 'GL_ARB_internalformat_query2')
GL_VIEW_CLASS_32_BITS = Enumerant('GL_VIEW_CLASS_32_BITS', 0x82c8, 'GL_ARB_internalformat_query2')
GL_VIEW_CLASS_48_BITS = Enumerant('GL_VIEW_CLASS_48_BITS', 0x82c7, 'GL_ARB_internalformat_query2')
GL_VIEW_CLASS_64_BITS = Enumerant('GL_VIEW_CLASS_64_BITS', 0x82c6, 'GL_ARB_internalformat_query2')
GL_VIEW_CLASS_8_BITS = Enumerant('GL_VIEW_CLASS_8_BITS', 0x82cb, 'GL_ARB_internalformat_query2')
GL_VIEW_CLASS_96_BITS = Enumerant('GL_VIEW_CLASS_96_BITS', 0x82c5, 'GL_ARB_internalformat_query2')
GL_VIEW_CLASS_BPTC_FLOAT = Enumerant('GL_VIEW_CLASS_BPTC_FLOAT', 0x82d3, 'GL_ARB_internalformat_query2')
GL_VIEW_CLASS_BPTC_UNORM = Enumerant('GL_VIEW_CLASS_BPTC_UNORM', 0x82d2, 'GL_ARB_internalformat_query2')
GL_VIEW_CLASS_RGTC1_RED = Enumerant('GL_VIEW_CLASS_RGTC1_RED', 0x82d0, 'GL_ARB_internalformat_query2')
GL_VIEW_CLASS_RGTC2_RG = Enumerant('GL_VIEW_CLASS_RGTC2_RG', 0x82d1, 'GL_ARB_internalformat_query2')
GL_VIEW_CLASS_S3TC_DXT1_RGB = Enumerant('GL_VIEW_CLASS_S3TC_DXT1_RGB', 0x82cc, 'GL_ARB_internalformat_query2')
GL_VIEW_CLASS_S3TC_DXT1_RGBA = Enumerant('GL_VIEW_CLASS_S3TC_DXT1_RGBA', 0x82cd, 'GL_ARB_internalformat_query2')
GL_VIEW_CLASS_S3TC_DXT3_RGBA = Enumerant('GL_VIEW_CLASS_S3TC_DXT3_RGBA', 0x82ce, 'GL_ARB_internalformat_query2')
GL_VIEW_CLASS_S3TC_DXT5_RGBA = Enumerant('GL_VIEW_CLASS_S3TC_DXT5_RGBA', 0x82cf, 'GL_ARB_internalformat_query2')
GL_VIEW_COMPATIBILITY_CLASS = Enumerant('GL_VIEW_COMPATIBILITY_CLASS', 0x82b6, 'GL_ARB_internalformat_query2')

defines.add(GL_AUTO_GENERATE_MIPMAP)
defines.add(GL_CAVEAT_SUPPORT)
defines.add(GL_CLEAR_BUFFER)
defines.add(GL_COLOR_COMPONENTS)
defines.add(GL_COLOR_ENCODING)
defines.add(GL_COLOR_RENDERABLE)
defines.add(GL_COMPUTE_TEXTURE)
defines.add(GL_DEPTH_COMPONENTS)
defines.add(GL_DEPTH_RENDERABLE)
defines.add(GL_FILTER)
defines.add(GL_FRAGMENT_TEXTURE)
defines.add(GL_FRAMEBUFFER_BLEND)
defines.add(GL_FRAMEBUFFER_RENDERABLE)
defines.add(GL_FRAMEBUFFER_RENDERABLE_LAYERED)
defines.add(GL_FULL_SUPPORT)
defines.add(GL_GEOMETRY_TEXTURE)
defines.add(GL_GET_TEXTURE_IMAGE_FORMAT)
defines.add(GL_GET_TEXTURE_IMAGE_TYPE)
defines.add(GL_IMAGE_CLASS_10_10_10_2)
defines.add(GL_IMAGE_CLASS_11_11_10)
defines.add(GL_IMAGE_CLASS_1_X_16)
defines.add(GL_IMAGE_CLASS_1_X_32)
defines.add(GL_IMAGE_CLASS_1_X_8)
defines.add(GL_IMAGE_CLASS_2_X_16)
defines.add(GL_IMAGE_CLASS_2_X_32)
defines.add(GL_IMAGE_CLASS_2_X_8)
defines.add(GL_IMAGE_CLASS_4_X_16)
defines.add(GL_IMAGE_CLASS_4_X_32)
defines.add(GL_IMAGE_CLASS_4_X_8)
defines.add(GL_IMAGE_COMPATIBILITY_CLASS)
defines.add(GL_IMAGE_PIXEL_FORMAT)
defines.add(GL_IMAGE_PIXEL_TYPE)
defines.add(GL_IMAGE_TEXEL_SIZE)
defines.add(GL_INTERNALFORMAT_ALPHA_SIZE)
defines.add(GL_INTERNALFORMAT_ALPHA_TYPE)
defines.add(GL_INTERNALFORMAT_BLUE_SIZE)
defines.add(GL_INTERNALFORMAT_BLUE_TYPE)
defines.add(GL_INTERNALFORMAT_DEPTH_SIZE)
defines.add(GL_INTERNALFORMAT_DEPTH_TYPE)
defines.add(GL_INTERNALFORMAT_GREEN_SIZE)
defines.add(GL_INTERNALFORMAT_GREEN_TYPE)
defines.add(GL_INTERNALFORMAT_PREFERRED)
defines.add(GL_INTERNALFORMAT_RED_SIZE)
defines.add(GL_INTERNALFORMAT_RED_TYPE)
defines.add(GL_INTERNALFORMAT_SHARED_SIZE)
defines.add(GL_INTERNALFORMAT_STENCIL_SIZE)
defines.add(GL_INTERNALFORMAT_STENCIL_TYPE)
defines.add(GL_INTERNALFORMAT_SUPPORTED)
defines.add(GL_MANUAL_GENERATE_MIPMAP)
defines.add(GL_MAX_COMBINED_DIMENSIONS)
defines.add(GL_MAX_DEPTH)
defines.add(GL_MAX_HEIGHT)
defines.add(GL_MAX_LAYERS)
defines.add(GL_MAX_WIDTH)
defines.add(GL_MIPMAP)
defines.add(GL_READ_PIXELS)
defines.add(GL_READ_PIXELS_FORMAT)
defines.add(GL_READ_PIXELS_TYPE)
defines.add(GL_SHADER_IMAGE_ATOMIC)
defines.add(GL_SHADER_IMAGE_LOAD)
defines.add(GL_SHADER_IMAGE_STORE)
defines.add(GL_SIMULTANEOUS_TEXTURE_AND_DEPTH_TEST)
defines.add(GL_SIMULTANEOUS_TEXTURE_AND_DEPTH_WRITE)
defines.add(GL_SIMULTANEOUS_TEXTURE_AND_STENCIL_TEST)
defines.add(GL_SIMULTANEOUS_TEXTURE_AND_STENCIL_WRITE)
defines.add(GL_SRGB_DECODE_ARB)
defines.add(GL_SRGB_READ)
defines.add(GL_SRGB_WRITE)
defines.add(GL_STENCIL_COMPONENTS)
defines.add(GL_STENCIL_RENDERABLE)
defines.add(GL_TESS_CONTROL_TEXTURE)
defines.add(GL_TESS_EVALUATION_TEXTURE)
defines.add(GL_TEXTURE_COMPRESSED_BLOCK_HEIGHT)
defines.add(GL_TEXTURE_COMPRESSED_BLOCK_SIZE)
defines.add(GL_TEXTURE_COMPRESSED_BLOCK_WIDTH)
defines.add(GL_TEXTURE_GATHER)
defines.add(GL_TEXTURE_GATHER_SHADOW)
defines.add(GL_TEXTURE_IMAGE_FORMAT)
defines.add(GL_TEXTURE_IMAGE_TYPE)
defines.add(GL_TEXTURE_SHADOW)
defines.add(GL_TEXTURE_VIEW)
defines.add(GL_VERTEX_TEXTURE)
defines.add(GL_VIEW_CLASS_128_BITS)
defines.add(GL_VIEW_CLASS_16_BITS)
defines.add(GL_VIEW_CLASS_24_BITS)
defines.add(GL_VIEW_CLASS_32_BITS)
defines.add(GL_VIEW_CLASS_48_BITS)
defines.add(GL_VIEW_CLASS_64_BITS)
defines.add(GL_VIEW_CLASS_8_BITS)
defines.add(GL_VIEW_CLASS_96_BITS)
defines.add(GL_VIEW_CLASS_BPTC_FLOAT)
defines.add(GL_VIEW_CLASS_BPTC_UNORM)
defines.add(GL_VIEW_CLASS_RGTC1_RED)
defines.add(GL_VIEW_CLASS_RGTC2_RG)
defines.add(GL_VIEW_CLASS_S3TC_DXT1_RGB)
defines.add(GL_VIEW_CLASS_S3TC_DXT1_RGBA)
defines.add(GL_VIEW_CLASS_S3TC_DXT3_RGBA)
defines.add(GL_VIEW_CLASS_S3TC_DXT5_RGBA)
defines.add(GL_VIEW_COMPATIBILITY_CLASS)

# GL_ARB_map_buffer_alignment

GL_MIN_MAP_BUFFER_ALIGNMENT = Enumerant('GL_MIN_MAP_BUFFER_ALIGNMENT', 0x90bc, 'GL_ARB_map_buffer_alignment')

defines.add(GL_MIN_MAP_BUFFER_ALIGNMENT)

# GL_ARB_map_buffer_range

GL_MAP_FLUSH_EXPLICIT_BIT = Enumerant('GL_MAP_FLUSH_EXPLICIT_BIT', 0x0010, 'GL_ARB_map_buffer_range')
GL_MAP_INVALIDATE_BUFFER_BIT = Enumerant('GL_MAP_INVALIDATE_BUFFER_BIT', 0x0008, 'GL_ARB_map_buffer_range')
GL_MAP_INVALIDATE_RANGE_BIT = Enumerant('GL_MAP_INVALIDATE_RANGE_BIT', 0x0004, 'GL_ARB_map_buffer_range')
GL_MAP_READ_BIT = Enumerant('GL_MAP_READ_BIT', 0x0001, 'GL_ARB_map_buffer_range')
GL_MAP_UNSYNCHRONIZED_BIT = Enumerant('GL_MAP_UNSYNCHRONIZED_BIT', 0x0020, 'GL_ARB_map_buffer_range')
GL_MAP_WRITE_BIT = Enumerant('GL_MAP_WRITE_BIT', 0x0002, 'GL_ARB_map_buffer_range')

defines.add(GL_MAP_FLUSH_EXPLICIT_BIT)
defines.add(GL_MAP_INVALIDATE_BUFFER_BIT)
defines.add(GL_MAP_INVALIDATE_RANGE_BIT)
defines.add(GL_MAP_READ_BIT)
defines.add(GL_MAP_UNSYNCHRONIZED_BIT)
defines.add(GL_MAP_WRITE_BIT)

# GL_ARB_matrix_palette

GL_CURRENT_MATRIX_INDEX_ARB = Enumerant('GL_CURRENT_MATRIX_INDEX_ARB', 0x8845, 'GL_ARB_matrix_palette')
GL_CURRENT_PALETTE_MATRIX_ARB = Enumerant('GL_CURRENT_PALETTE_MATRIX_ARB', 0x8843, 'GL_ARB_matrix_palette')
GL_MATRIX_INDEX_ARRAY_ARB = Enumerant('GL_MATRIX_INDEX_ARRAY_ARB', 0x8844, 'GL_ARB_matrix_palette')
GL_MATRIX_INDEX_ARRAY_POINTER_ARB = Enumerant('GL_MATRIX_INDEX_ARRAY_POINTER_ARB', 0x8849, 'GL_ARB_matrix_palette')
GL_MATRIX_INDEX_ARRAY_SIZE_ARB = Enumerant('GL_MATRIX_INDEX_ARRAY_SIZE_ARB', 0x8846, 'GL_ARB_matrix_palette')
GL_MATRIX_INDEX_ARRAY_STRIDE_ARB = Enumerant('GL_MATRIX_INDEX_ARRAY_STRIDE_ARB', 0x8848, 'GL_ARB_matrix_palette')
GL_MATRIX_INDEX_ARRAY_TYPE_ARB = Enumerant('GL_MATRIX_INDEX_ARRAY_TYPE_ARB', 0x8847, 'GL_ARB_matrix_palette')
GL_MATRIX_PALETTE_ARB = Enumerant('GL_MATRIX_PALETTE_ARB', 0x8840, 'GL_ARB_matrix_palette')
GL_MAX_MATRIX_PALETTE_STACK_DEPTH_ARB = Enumerant('GL_MAX_MATRIX_PALETTE_STACK_DEPTH_ARB', 0x8841, 'GL_ARB_matrix_palette')
GL_MAX_PALETTE_MATRICES_ARB = Enumerant('GL_MAX_PALETTE_MATRICES_ARB', 0x8842, 'GL_ARB_matrix_palette')

defines.add(GL_CURRENT_MATRIX_INDEX_ARB)
defines.add(GL_CURRENT_PALETTE_MATRIX_ARB)
defines.add(GL_MATRIX_INDEX_ARRAY_ARB)
defines.add(GL_MATRIX_INDEX_ARRAY_POINTER_ARB)
defines.add(GL_MATRIX_INDEX_ARRAY_SIZE_ARB)
defines.add(GL_MATRIX_INDEX_ARRAY_STRIDE_ARB)
defines.add(GL_MATRIX_INDEX_ARRAY_TYPE_ARB)
defines.add(GL_MATRIX_PALETTE_ARB)
defines.add(GL_MAX_MATRIX_PALETTE_STACK_DEPTH_ARB)
defines.add(GL_MAX_PALETTE_MATRICES_ARB)

# GL_ARB_multisample

GL_MULTISAMPLE_ARB = Enumerant('GL_MULTISAMPLE_ARB', 0x809d, 'GL_ARB_multisample')
GL_MULTISAMPLE_BIT_ARB = Enumerant('GL_MULTISAMPLE_BIT_ARB', 0x20000000, 'GL_ARB_multisample')
GL_SAMPLES_ARB = Enumerant('GL_SAMPLES_ARB', 0x80a9, 'GL_ARB_multisample')
GL_SAMPLE_ALPHA_TO_COVERAGE_ARB = Enumerant('GL_SAMPLE_ALPHA_TO_COVERAGE_ARB', 0x809e, 'GL_ARB_multisample')
GL_SAMPLE_ALPHA_TO_ONE_ARB = Enumerant('GL_SAMPLE_ALPHA_TO_ONE_ARB', 0x809f, 'GL_ARB_multisample')
GL_SAMPLE_BUFFERS_ARB = Enumerant('GL_SAMPLE_BUFFERS_ARB', 0x80a8, 'GL_ARB_multisample')
GL_SAMPLE_COVERAGE_ARB = Enumerant('GL_SAMPLE_COVERAGE_ARB', 0x80a0, 'GL_ARB_multisample')
GL_SAMPLE_COVERAGE_INVERT_ARB = Enumerant('GL_SAMPLE_COVERAGE_INVERT_ARB', 0x80ab, 'GL_ARB_multisample')
GL_SAMPLE_COVERAGE_VALUE_ARB = Enumerant('GL_SAMPLE_COVERAGE_VALUE_ARB', 0x80aa, 'GL_ARB_multisample')

defines.add(GL_MULTISAMPLE_ARB)
defines.add(GL_MULTISAMPLE_BIT_ARB)
defines.add(GL_SAMPLES_ARB)
defines.add(GL_SAMPLE_ALPHA_TO_COVERAGE_ARB)
defines.add(GL_SAMPLE_ALPHA_TO_ONE_ARB)
defines.add(GL_SAMPLE_BUFFERS_ARB)
defines.add(GL_SAMPLE_COVERAGE_ARB)
defines.add(GL_SAMPLE_COVERAGE_INVERT_ARB)
defines.add(GL_SAMPLE_COVERAGE_VALUE_ARB)

# GL_ARB_multitexture

GL_ACTIVE_TEXTURE_ARB = Enumerant('GL_ACTIVE_TEXTURE_ARB', 0x84e0, 'GL_ARB_multitexture')
GL_CLIENT_ACTIVE_TEXTURE_ARB = Enumerant('GL_CLIENT_ACTIVE_TEXTURE_ARB', 0x84e1, 'GL_ARB_multitexture')
GL_MAX_TEXTURE_UNITS_ARB = Enumerant('GL_MAX_TEXTURE_UNITS_ARB', 0x84e2, 'GL_ARB_multitexture')
GL_TEXTURE0_ARB = Enumerant('GL_TEXTURE0_ARB', 0x84c0, 'GL_ARB_multitexture')
GL_TEXTURE10_ARB = Enumerant('GL_TEXTURE10_ARB', 0x84ca, 'GL_ARB_multitexture')
GL_TEXTURE11_ARB = Enumerant('GL_TEXTURE11_ARB', 0x84cb, 'GL_ARB_multitexture')
GL_TEXTURE12_ARB = Enumerant('GL_TEXTURE12_ARB', 0x84cc, 'GL_ARB_multitexture')
GL_TEXTURE13_ARB = Enumerant('GL_TEXTURE13_ARB', 0x84cd, 'GL_ARB_multitexture')
GL_TEXTURE14_ARB = Enumerant('GL_TEXTURE14_ARB', 0x84ce, 'GL_ARB_multitexture')
GL_TEXTURE15_ARB = Enumerant('GL_TEXTURE15_ARB', 0x84cf, 'GL_ARB_multitexture')
GL_TEXTURE16_ARB = Enumerant('GL_TEXTURE16_ARB', 0x84d0, 'GL_ARB_multitexture')
GL_TEXTURE17_ARB = Enumerant('GL_TEXTURE17_ARB', 0x84d1, 'GL_ARB_multitexture')
GL_TEXTURE18_ARB = Enumerant('GL_TEXTURE18_ARB', 0x84d2, 'GL_ARB_multitexture')
GL_TEXTURE19_ARB = Enumerant('GL_TEXTURE19_ARB', 0x84d3, 'GL_ARB_multitexture')
GL_TEXTURE1_ARB = Enumerant('GL_TEXTURE1_ARB', 0x84c1, 'GL_ARB_multitexture')
GL_TEXTURE20_ARB = Enumerant('GL_TEXTURE20_ARB', 0x84d4, 'GL_ARB_multitexture')
GL_TEXTURE21_ARB = Enumerant('GL_TEXTURE21_ARB', 0x84d5, 'GL_ARB_multitexture')
GL_TEXTURE22_ARB = Enumerant('GL_TEXTURE22_ARB', 0x84d6, 'GL_ARB_multitexture')
GL_TEXTURE23_ARB = Enumerant('GL_TEXTURE23_ARB', 0x84d7, 'GL_ARB_multitexture')
GL_TEXTURE24_ARB = Enumerant('GL_TEXTURE24_ARB', 0x84d8, 'GL_ARB_multitexture')
GL_TEXTURE25_ARB = Enumerant('GL_TEXTURE25_ARB', 0x84d9, 'GL_ARB_multitexture')
GL_TEXTURE26_ARB = Enumerant('GL_TEXTURE26_ARB', 0x84da, 'GL_ARB_multitexture')
GL_TEXTURE27_ARB = Enumerant('GL_TEXTURE27_ARB', 0x84db, 'GL_ARB_multitexture')
GL_TEXTURE28_ARB = Enumerant('GL_TEXTURE28_ARB', 0x84dc, 'GL_ARB_multitexture')
GL_TEXTURE29_ARB = Enumerant('GL_TEXTURE29_ARB', 0x84dd, 'GL_ARB_multitexture')
GL_TEXTURE2_ARB = Enumerant('GL_TEXTURE2_ARB', 0x84c2, 'GL_ARB_multitexture')
GL_TEXTURE30_ARB = Enumerant('GL_TEXTURE30_ARB', 0x84de, 'GL_ARB_multitexture')
GL_TEXTURE31_ARB = Enumerant('GL_TEXTURE31_ARB', 0x84df, 'GL_ARB_multitexture')
GL_TEXTURE3_ARB = Enumerant('GL_TEXTURE3_ARB', 0x84c3, 'GL_ARB_multitexture')
GL_TEXTURE4_ARB = Enumerant('GL_TEXTURE4_ARB', 0x84c4, 'GL_ARB_multitexture')
GL_TEXTURE5_ARB = Enumerant('GL_TEXTURE5_ARB', 0x84c5, 'GL_ARB_multitexture')
GL_TEXTURE6_ARB = Enumerant('GL_TEXTURE6_ARB', 0x84c6, 'GL_ARB_multitexture')
GL_TEXTURE7_ARB = Enumerant('GL_TEXTURE7_ARB', 0x84c7, 'GL_ARB_multitexture')
GL_TEXTURE8_ARB = Enumerant('GL_TEXTURE8_ARB', 0x84c8, 'GL_ARB_multitexture')
GL_TEXTURE9_ARB = Enumerant('GL_TEXTURE9_ARB', 0x84c9, 'GL_ARB_multitexture')

defines.add(GL_ACTIVE_TEXTURE_ARB)
defines.add(GL_CLIENT_ACTIVE_TEXTURE_ARB)
defines.add(GL_MAX_TEXTURE_UNITS_ARB)
defines.add(GL_TEXTURE0_ARB)
defines.add(GL_TEXTURE10_ARB)
defines.add(GL_TEXTURE11_ARB)
defines.add(GL_TEXTURE12_ARB)
defines.add(GL_TEXTURE13_ARB)
defines.add(GL_TEXTURE14_ARB)
defines.add(GL_TEXTURE15_ARB)
defines.add(GL_TEXTURE16_ARB)
defines.add(GL_TEXTURE17_ARB)
defines.add(GL_TEXTURE18_ARB)
defines.add(GL_TEXTURE19_ARB)
defines.add(GL_TEXTURE1_ARB)
defines.add(GL_TEXTURE20_ARB)
defines.add(GL_TEXTURE21_ARB)
defines.add(GL_TEXTURE22_ARB)
defines.add(GL_TEXTURE23_ARB)
defines.add(GL_TEXTURE24_ARB)
defines.add(GL_TEXTURE25_ARB)
defines.add(GL_TEXTURE26_ARB)
defines.add(GL_TEXTURE27_ARB)
defines.add(GL_TEXTURE28_ARB)
defines.add(GL_TEXTURE29_ARB)
defines.add(GL_TEXTURE2_ARB)
defines.add(GL_TEXTURE30_ARB)
defines.add(GL_TEXTURE31_ARB)
defines.add(GL_TEXTURE3_ARB)
defines.add(GL_TEXTURE4_ARB)
defines.add(GL_TEXTURE5_ARB)
defines.add(GL_TEXTURE6_ARB)
defines.add(GL_TEXTURE7_ARB)
defines.add(GL_TEXTURE8_ARB)
defines.add(GL_TEXTURE9_ARB)

# GL_ARB_occlusion_query

GL_CURRENT_QUERY_ARB = Enumerant('GL_CURRENT_QUERY_ARB', 0x8865, 'GL_ARB_occlusion_query')
GL_QUERY_COUNTER_BITS_ARB = Enumerant('GL_QUERY_COUNTER_BITS_ARB', 0x8864, 'GL_ARB_occlusion_query')
GL_QUERY_RESULT_ARB = Enumerant('GL_QUERY_RESULT_ARB', 0x8866, 'GL_ARB_occlusion_query')
GL_QUERY_RESULT_AVAILABLE_ARB = Enumerant('GL_QUERY_RESULT_AVAILABLE_ARB', 0x8867, 'GL_ARB_occlusion_query')
GL_SAMPLES_PASSED_ARB = Enumerant('GL_SAMPLES_PASSED_ARB', 0x8914, 'GL_ARB_occlusion_query')

defines.add(GL_CURRENT_QUERY_ARB)
defines.add(GL_QUERY_COUNTER_BITS_ARB)
defines.add(GL_QUERY_RESULT_ARB)
defines.add(GL_QUERY_RESULT_AVAILABLE_ARB)
defines.add(GL_SAMPLES_PASSED_ARB)

# GL_ARB_occlusion_query2

GL_ANY_SAMPLES_PASSED = Enumerant('GL_ANY_SAMPLES_PASSED', 0x8c2f, 'GL_ARB_occlusion_query2')

defines.add(GL_ANY_SAMPLES_PASSED)

# GL_ARB_pixel_buffer_object

GL_PIXEL_PACK_BUFFER_ARB = Enumerant('GL_PIXEL_PACK_BUFFER_ARB', 0x88eb, 'GL_ARB_pixel_buffer_object')
GL_PIXEL_PACK_BUFFER_BINDING_ARB = Enumerant('GL_PIXEL_PACK_BUFFER_BINDING_ARB', 0x88ed, 'GL_ARB_pixel_buffer_object')
GL_PIXEL_UNPACK_BUFFER_ARB = Enumerant('GL_PIXEL_UNPACK_BUFFER_ARB', 0x88ec, 'GL_ARB_pixel_buffer_object')
GL_PIXEL_UNPACK_BUFFER_BINDING_ARB = Enumerant('GL_PIXEL_UNPACK_BUFFER_BINDING_ARB', 0x88ef, 'GL_ARB_pixel_buffer_object')

defines.add(GL_PIXEL_PACK_BUFFER_ARB)
defines.add(GL_PIXEL_PACK_BUFFER_BINDING_ARB)
defines.add(GL_PIXEL_UNPACK_BUFFER_ARB)
defines.add(GL_PIXEL_UNPACK_BUFFER_BINDING_ARB)

# GL_ARB_point_parameters

GL_POINT_DISTANCE_ATTENUATION_ARB = Enumerant('GL_POINT_DISTANCE_ATTENUATION_ARB', 0x8129, 'GL_ARB_point_parameters')
GL_POINT_FADE_THRESHOLD_SIZE_ARB = Enumerant('GL_POINT_FADE_THRESHOLD_SIZE_ARB', 0x8128, 'GL_ARB_point_parameters')
GL_POINT_SIZE_MAX_ARB = Enumerant('GL_POINT_SIZE_MAX_ARB', 0x8127, 'GL_ARB_point_parameters')
GL_POINT_SIZE_MIN_ARB = Enumerant('GL_POINT_SIZE_MIN_ARB', 0x8126, 'GL_ARB_point_parameters')

defines.add(GL_POINT_DISTANCE_ATTENUATION_ARB)
defines.add(GL_POINT_FADE_THRESHOLD_SIZE_ARB)
defines.add(GL_POINT_SIZE_MAX_ARB)
defines.add(GL_POINT_SIZE_MIN_ARB)

# GL_ARB_point_sprite

GL_COORD_REPLACE_ARB = Enumerant('GL_COORD_REPLACE_ARB', 0x8862, 'GL_ARB_point_sprite')
GL_POINT_SPRITE_ARB = Enumerant('GL_POINT_SPRITE_ARB', 0x8861, 'GL_ARB_point_sprite')

defines.add(GL_COORD_REPLACE_ARB)
defines.add(GL_POINT_SPRITE_ARB)

# GL_ARB_program_interface_query

GL_ACTIVE_RESOURCES = Enumerant('GL_ACTIVE_RESOURCES', 0x92f5, 'GL_ARB_program_interface_query')
GL_ACTIVE_VARIABLES = Enumerant('GL_ACTIVE_VARIABLES', 0x9305, 'GL_ARB_program_interface_query')
GL_ARRAY_SIZE = Enumerant('GL_ARRAY_SIZE', 0x92fb, 'GL_ARB_program_interface_query')
GL_ARRAY_STRIDE = Enumerant('GL_ARRAY_STRIDE', 0x92fe, 'GL_ARB_program_interface_query')
GL_ATOMIC_COUNTER_BUFFER_INDEX = Enumerant('GL_ATOMIC_COUNTER_BUFFER_INDEX', 0x9301, 'GL_ARB_program_interface_query')
GL_BLOCK_INDEX = Enumerant('GL_BLOCK_INDEX', 0x92fd, 'GL_ARB_program_interface_query')
GL_BUFFER_BINDING = Enumerant('GL_BUFFER_BINDING', 0x9302, 'GL_ARB_program_interface_query')
GL_BUFFER_DATA_SIZE = Enumerant('GL_BUFFER_DATA_SIZE', 0x9303, 'GL_ARB_program_interface_query')
GL_BUFFER_VARIABLE = Enumerant('GL_BUFFER_VARIABLE', 0x92e5, 'GL_ARB_program_interface_query')
GL_COMPUTE_SUBROUTINE = Enumerant('GL_COMPUTE_SUBROUTINE', 0x92ed, 'GL_ARB_program_interface_query')
GL_COMPUTE_SUBROUTINE_UNIFORM = Enumerant('GL_COMPUTE_SUBROUTINE_UNIFORM', 0x92f3, 'GL_ARB_program_interface_query')
GL_FRAGMENT_SUBROUTINE = Enumerant('GL_FRAGMENT_SUBROUTINE', 0x92ec, 'GL_ARB_program_interface_query')
GL_FRAGMENT_SUBROUTINE_UNIFORM = Enumerant('GL_FRAGMENT_SUBROUTINE_UNIFORM', 0x92f2, 'GL_ARB_program_interface_query')
GL_GEOMETRY_SUBROUTINE = Enumerant('GL_GEOMETRY_SUBROUTINE', 0x92eb, 'GL_ARB_program_interface_query')
GL_GEOMETRY_SUBROUTINE_UNIFORM = Enumerant('GL_GEOMETRY_SUBROUTINE_UNIFORM', 0x92f1, 'GL_ARB_program_interface_query')
GL_IS_PER_PATCH = Enumerant('GL_IS_PER_PATCH', 0x92e7, 'GL_ARB_program_interface_query')
GL_IS_ROW_MAJOR = Enumerant('GL_IS_ROW_MAJOR', 0x9300, 'GL_ARB_program_interface_query')
GL_LOCATION = Enumerant('GL_LOCATION', 0x930e, 'GL_ARB_program_interface_query')
GL_LOCATION_INDEX = Enumerant('GL_LOCATION_INDEX', 0x930f, 'GL_ARB_program_interface_query')
GL_MATRIX_STRIDE = Enumerant('GL_MATRIX_STRIDE', 0x92ff, 'GL_ARB_program_interface_query')
GL_MAX_NAME_LENGTH = Enumerant('GL_MAX_NAME_LENGTH', 0x92f6, 'GL_ARB_program_interface_query')
GL_MAX_NUM_ACTIVE_VARIABLES = Enumerant('GL_MAX_NUM_ACTIVE_VARIABLES', 0x92f7, 'GL_ARB_program_interface_query')
GL_MAX_NUM_COMPATIBLE_SUBROUTINES = Enumerant('GL_MAX_NUM_COMPATIBLE_SUBROUTINES', 0x92f8, 'GL_ARB_program_interface_query')
GL_NAME_LENGTH = Enumerant('GL_NAME_LENGTH', 0x92f9, 'GL_ARB_program_interface_query')
GL_NUM_ACTIVE_VARIABLES = Enumerant('GL_NUM_ACTIVE_VARIABLES', 0x9304, 'GL_ARB_program_interface_query')
GL_OFFSET = Enumerant('GL_OFFSET', 0x92fc, 'GL_ARB_program_interface_query')
GL_PROGRAM_INPUT = Enumerant('GL_PROGRAM_INPUT', 0x92e3, 'GL_ARB_program_interface_query')
GL_PROGRAM_OUTPUT = Enumerant('GL_PROGRAM_OUTPUT', 0x92e4, 'GL_ARB_program_interface_query')
GL_REFERENCED_BY_COMPUTE_SHADER = Enumerant('GL_REFERENCED_BY_COMPUTE_SHADER', 0x930b, 'GL_ARB_program_interface_query')
GL_REFERENCED_BY_FRAGMENT_SHADER = Enumerant('GL_REFERENCED_BY_FRAGMENT_SHADER', 0x930a, 'GL_ARB_program_interface_query')
GL_REFERENCED_BY_GEOMETRY_SHADER = Enumerant('GL_REFERENCED_BY_GEOMETRY_SHADER', 0x9309, 'GL_ARB_program_interface_query')
GL_REFERENCED_BY_TESS_CONTROL_SHADER = Enumerant('GL_REFERENCED_BY_TESS_CONTROL_SHADER', 0x9307, 'GL_ARB_program_interface_query')
GL_REFERENCED_BY_TESS_EVALUATION_SHADER = Enumerant('GL_REFERENCED_BY_TESS_EVALUATION_SHADER', 0x9308, 'GL_ARB_program_interface_query')
GL_REFERENCED_BY_VERTEX_SHADER = Enumerant('GL_REFERENCED_BY_VERTEX_SHADER', 0x9306, 'GL_ARB_program_interface_query')
GL_SHADER_STORAGE_BLOCK = Enumerant('GL_SHADER_STORAGE_BLOCK', 0x92e6, 'GL_ARB_program_interface_query')
GL_TESS_CONTROL_SUBROUTINE = Enumerant('GL_TESS_CONTROL_SUBROUTINE', 0x92e9, 'GL_ARB_program_interface_query')
GL_TESS_CONTROL_SUBROUTINE_UNIFORM = Enumerant('GL_TESS_CONTROL_SUBROUTINE_UNIFORM', 0x92ef, 'GL_ARB_program_interface_query')
GL_TESS_EVALUATION_SUBROUTINE = Enumerant('GL_TESS_EVALUATION_SUBROUTINE', 0x92ea, 'GL_ARB_program_interface_query')
GL_TESS_EVALUATION_SUBROUTINE_UNIFORM = Enumerant('GL_TESS_EVALUATION_SUBROUTINE_UNIFORM', 0x92f0, 'GL_ARB_program_interface_query')
GL_TOP_LEVEL_ARRAY_SIZE = Enumerant('GL_TOP_LEVEL_ARRAY_SIZE', 0x930c, 'GL_ARB_program_interface_query')
GL_TOP_LEVEL_ARRAY_STRIDE = Enumerant('GL_TOP_LEVEL_ARRAY_STRIDE', 0x930d, 'GL_ARB_program_interface_query')
GL_TRANSFORM_FEEDBACK_VARYING = Enumerant('GL_TRANSFORM_FEEDBACK_VARYING', 0x92f4, 'GL_ARB_program_interface_query')
GL_TYPE = Enumerant('GL_TYPE', 0x92fa, 'GL_ARB_program_interface_query')
GL_UNIFORM = Enumerant('GL_UNIFORM', 0x92e1, 'GL_ARB_program_interface_query')
GL_UNIFORM_BLOCK = Enumerant('GL_UNIFORM_BLOCK', 0x92e2, 'GL_ARB_program_interface_query')
GL_VERTEX_SUBROUTINE = Enumerant('GL_VERTEX_SUBROUTINE', 0x92e8, 'GL_ARB_program_interface_query')
GL_VERTEX_SUBROUTINE_UNIFORM = Enumerant('GL_VERTEX_SUBROUTINE_UNIFORM', 0x92ee, 'GL_ARB_program_interface_query')

defines.add(GL_ACTIVE_RESOURCES)
defines.add(GL_ACTIVE_VARIABLES)
defines.add(GL_ARRAY_SIZE)
defines.add(GL_ARRAY_STRIDE)
defines.add(GL_ATOMIC_COUNTER_BUFFER_INDEX)
defines.add(GL_BLOCK_INDEX)
defines.add(GL_BUFFER_BINDING)
defines.add(GL_BUFFER_DATA_SIZE)
defines.add(GL_BUFFER_VARIABLE)
defines.add(GL_COMPUTE_SUBROUTINE)
defines.add(GL_COMPUTE_SUBROUTINE_UNIFORM)
defines.add(GL_FRAGMENT_SUBROUTINE)
defines.add(GL_FRAGMENT_SUBROUTINE_UNIFORM)
defines.add(GL_GEOMETRY_SUBROUTINE)
defines.add(GL_GEOMETRY_SUBROUTINE_UNIFORM)
defines.add(GL_IS_PER_PATCH)
defines.add(GL_IS_ROW_MAJOR)
defines.add(GL_LOCATION)
defines.add(GL_LOCATION_INDEX)
defines.add(GL_MATRIX_STRIDE)
defines.add(GL_MAX_NAME_LENGTH)
defines.add(GL_MAX_NUM_ACTIVE_VARIABLES)
defines.add(GL_MAX_NUM_COMPATIBLE_SUBROUTINES)
defines.add(GL_NAME_LENGTH)
defines.add(GL_NUM_ACTIVE_VARIABLES)
defines.add(GL_OFFSET)
defines.add(GL_PROGRAM_INPUT)
defines.add(GL_PROGRAM_OUTPUT)
defines.add(GL_REFERENCED_BY_COMPUTE_SHADER)
defines.add(GL_REFERENCED_BY_FRAGMENT_SHADER)
defines.add(GL_REFERENCED_BY_GEOMETRY_SHADER)
defines.add(GL_REFERENCED_BY_TESS_CONTROL_SHADER)
defines.add(GL_REFERENCED_BY_TESS_EVALUATION_SHADER)
defines.add(GL_REFERENCED_BY_VERTEX_SHADER)
defines.add(GL_SHADER_STORAGE_BLOCK)
defines.add(GL_TESS_CONTROL_SUBROUTINE)
defines.add(GL_TESS_CONTROL_SUBROUTINE_UNIFORM)
defines.add(GL_TESS_EVALUATION_SUBROUTINE)
defines.add(GL_TESS_EVALUATION_SUBROUTINE_UNIFORM)
defines.add(GL_TOP_LEVEL_ARRAY_SIZE)
defines.add(GL_TOP_LEVEL_ARRAY_STRIDE)
defines.add(GL_TRANSFORM_FEEDBACK_VARYING)
defines.add(GL_TYPE)
defines.add(GL_UNIFORM)
defines.add(GL_UNIFORM_BLOCK)
defines.add(GL_VERTEX_SUBROUTINE)
defines.add(GL_VERTEX_SUBROUTINE_UNIFORM)

# GL_ARB_provoking_vertex

GL_FIRST_VERTEX_CONVENTION = Enumerant('GL_FIRST_VERTEX_CONVENTION', 0x8e4d, 'GL_ARB_provoking_vertex')
GL_LAST_VERTEX_CONVENTION = Enumerant('GL_LAST_VERTEX_CONVENTION', 0x8e4e, 'GL_ARB_provoking_vertex')
GL_PROVOKING_VERTEX = Enumerant('GL_PROVOKING_VERTEX', 0x8e4f, 'GL_ARB_provoking_vertex')
GL_QUADS_FOLLOW_PROVOKING_VERTEX_CONVENTION = Enumerant('GL_QUADS_FOLLOW_PROVOKING_VERTEX_CONVENTION', 0x8e4c, 'GL_ARB_provoking_vertex')

defines.add(GL_FIRST_VERTEX_CONVENTION)
defines.add(GL_LAST_VERTEX_CONVENTION)
defines.add(GL_PROVOKING_VERTEX)
defines.add(GL_QUADS_FOLLOW_PROVOKING_VERTEX_CONVENTION)

# GL_ARB_query_buffer_object

GL_QUERY_BUFFER = Enumerant('GL_QUERY_BUFFER', 0x9192, 'GL_ARB_query_buffer_object')
GL_QUERY_BUFFER_BARRIER_BIT = Enumerant('GL_QUERY_BUFFER_BARRIER_BIT', 0x8000, 'GL_ARB_query_buffer_object')
GL_QUERY_BUFFER_BINDING = Enumerant('GL_QUERY_BUFFER_BINDING', 0x9193, 'GL_ARB_query_buffer_object')
GL_QUERY_RESULT_NO_WAIT = Enumerant('GL_QUERY_RESULT_NO_WAIT', 0x9194, 'GL_ARB_query_buffer_object')

defines.add(GL_QUERY_BUFFER)
defines.add(GL_QUERY_BUFFER_BARRIER_BIT)
defines.add(GL_QUERY_BUFFER_BINDING)
defines.add(GL_QUERY_RESULT_NO_WAIT)

# GL_ARB_robustness

GL_CONTEXT_FLAG_ROBUST_ACCESS_BIT_ARB = Enumerant('GL_CONTEXT_FLAG_ROBUST_ACCESS_BIT_ARB', 0x0004, 'GL_ARB_robustness')
GL_GUILTY_CONTEXT_RESET_ARB = Enumerant('GL_GUILTY_CONTEXT_RESET_ARB', 0x8253, 'GL_ARB_robustness')
GL_INNOCENT_CONTEXT_RESET_ARB = Enumerant('GL_INNOCENT_CONTEXT_RESET_ARB', 0x8254, 'GL_ARB_robustness')
GL_LOSE_CONTEXT_ON_RESET_ARB = Enumerant('GL_LOSE_CONTEXT_ON_RESET_ARB', 0x8252, 'GL_ARB_robustness')
GL_NO_RESET_NOTIFICATION_ARB = Enumerant('GL_NO_RESET_NOTIFICATION_ARB', 0x8261, 'GL_ARB_robustness')
GL_RESET_NOTIFICATION_STRATEGY_ARB = Enumerant('GL_RESET_NOTIFICATION_STRATEGY_ARB', 0x8256, 'GL_ARB_robustness')
GL_UNKNOWN_CONTEXT_RESET_ARB = Enumerant('GL_UNKNOWN_CONTEXT_RESET_ARB', 0x8255, 'GL_ARB_robustness')

defines.add(GL_CONTEXT_FLAG_ROBUST_ACCESS_BIT_ARB)
defines.add(GL_GUILTY_CONTEXT_RESET_ARB)
defines.add(GL_INNOCENT_CONTEXT_RESET_ARB)
defines.add(GL_LOSE_CONTEXT_ON_RESET_ARB)
defines.add(GL_NO_RESET_NOTIFICATION_ARB)
defines.add(GL_RESET_NOTIFICATION_STRATEGY_ARB)
defines.add(GL_UNKNOWN_CONTEXT_RESET_ARB)

# GL_ARB_sample_shading

GL_MIN_SAMPLE_SHADING_VALUE_ARB = Enumerant('GL_MIN_SAMPLE_SHADING_VALUE_ARB', 0x8c37, 'GL_ARB_sample_shading')
GL_SAMPLE_SHADING_ARB = Enumerant('GL_SAMPLE_SHADING_ARB', 0x8c36, 'GL_ARB_sample_shading')

defines.add(GL_MIN_SAMPLE_SHADING_VALUE_ARB)
defines.add(GL_SAMPLE_SHADING_ARB)

# GL_ARB_sampler_objects

GL_SAMPLER_BINDING = Enumerant('GL_SAMPLER_BINDING', 0x8919, 'GL_ARB_sampler_objects')

defines.add(GL_SAMPLER_BINDING)

# GL_ARB_seamless_cube_map

GL_TEXTURE_CUBE_MAP_SEAMLESS = Enumerant('GL_TEXTURE_CUBE_MAP_SEAMLESS', 0x884f, 'GL_ARB_seamless_cube_map')
GL_TEXTURE_CUBE_MAP_SEAMLESS.enableCap = True

defines.add(GL_TEXTURE_CUBE_MAP_SEAMLESS)

# GL_ARB_separate_shader_objects

GL_ACTIVE_PROGRAM = Enumerant('GL_ACTIVE_PROGRAM', 0x8259, 'GL_ARB_separate_shader_objects')
GL_ALL_SHADER_BITS = Enumerant('GL_ALL_SHADER_BITS', 0xffffffff, 'GL_ARB_separate_shader_objects')
GL_FRAGMENT_SHADER_BIT = Enumerant('GL_FRAGMENT_SHADER_BIT', 0x0002, 'GL_ARB_separate_shader_objects')
GL_GEOMETRY_SHADER_BIT = Enumerant('GL_GEOMETRY_SHADER_BIT', 0x0004, 'GL_ARB_separate_shader_objects')
GL_PROGRAM_PIPELINE_BINDING = Enumerant('GL_PROGRAM_PIPELINE_BINDING', 0x825a, 'GL_ARB_separate_shader_objects')
GL_PROGRAM_SEPARABLE = Enumerant('GL_PROGRAM_SEPARABLE', 0x8258, 'GL_ARB_separate_shader_objects')
GL_TESS_CONTROL_SHADER_BIT = Enumerant('GL_TESS_CONTROL_SHADER_BIT', 0x0008, 'GL_ARB_separate_shader_objects')
GL_TESS_EVALUATION_SHADER_BIT = Enumerant('GL_TESS_EVALUATION_SHADER_BIT', 0x0010, 'GL_ARB_separate_shader_objects')
GL_VERTEX_SHADER_BIT = Enumerant('GL_VERTEX_SHADER_BIT', 0x0001, 'GL_ARB_separate_shader_objects')

defines.add(GL_ACTIVE_PROGRAM)
defines.add(GL_ALL_SHADER_BITS)
defines.add(GL_FRAGMENT_SHADER_BIT)
defines.add(GL_GEOMETRY_SHADER_BIT)
defines.add(GL_PROGRAM_PIPELINE_BINDING)
defines.add(GL_PROGRAM_SEPARABLE)
defines.add(GL_TESS_CONTROL_SHADER_BIT)
defines.add(GL_TESS_EVALUATION_SHADER_BIT)
defines.add(GL_VERTEX_SHADER_BIT)

# GL_ARB_shader_atomic_counters

GL_ACTIVE_ATOMIC_COUNTER_BUFFERS = Enumerant('GL_ACTIVE_ATOMIC_COUNTER_BUFFERS', 0x92d9, 'GL_ARB_shader_atomic_counters')
GL_ATOMIC_COUNTER_BUFFER = Enumerant('GL_ATOMIC_COUNTER_BUFFER', 0x92c0, 'GL_ARB_shader_atomic_counters')
GL_ATOMIC_COUNTER_BUFFER_ACTIVE_ATOMIC_COUNTERS = Enumerant('GL_ATOMIC_COUNTER_BUFFER_ACTIVE_ATOMIC_COUNTERS', 0x92c5, 'GL_ARB_shader_atomic_counters')
GL_ATOMIC_COUNTER_BUFFER_ACTIVE_ATOMIC_COUNTER_INDICES = Enumerant('GL_ATOMIC_COUNTER_BUFFER_ACTIVE_ATOMIC_COUNTER_INDICES', 0x92c6, 'GL_ARB_shader_atomic_counters')
GL_ATOMIC_COUNTER_BUFFER_BINDING = Enumerant('GL_ATOMIC_COUNTER_BUFFER_BINDING', 0x92c1, 'GL_ARB_shader_atomic_counters')
GL_ATOMIC_COUNTER_BUFFER_DATA_SIZE = Enumerant('GL_ATOMIC_COUNTER_BUFFER_DATA_SIZE', 0x92c4, 'GL_ARB_shader_atomic_counters')
GL_ATOMIC_COUNTER_BUFFER_REFERENCED_BY_FRAGMENT_SHADER = Enumerant('GL_ATOMIC_COUNTER_BUFFER_REFERENCED_BY_FRAGMENT_SHADER', 0x92cb, 'GL_ARB_shader_atomic_counters')
GL_ATOMIC_COUNTER_BUFFER_REFERENCED_BY_GEOMETRY_SHADER = Enumerant('GL_ATOMIC_COUNTER_BUFFER_REFERENCED_BY_GEOMETRY_SHADER', 0x92ca, 'GL_ARB_shader_atomic_counters')
GL_ATOMIC_COUNTER_BUFFER_REFERENCED_BY_TESS_CONTROL_SHADER = Enumerant('GL_ATOMIC_COUNTER_BUFFER_REFERENCED_BY_TESS_CONTROL_SHADER', 0x92c8, 'GL_ARB_shader_atomic_counters')
GL_ATOMIC_COUNTER_BUFFER_REFERENCED_BY_TESS_EVALUATION_SHADER = Enumerant('GL_ATOMIC_COUNTER_BUFFER_REFERENCED_BY_TESS_EVALUATION_SHADER', 0x92c9, 'GL_ARB_shader_atomic_counters')
GL_ATOMIC_COUNTER_BUFFER_REFERENCED_BY_VERTEX_SHADER = Enumerant('GL_ATOMIC_COUNTER_BUFFER_REFERENCED_BY_VERTEX_SHADER', 0x92c7, 'GL_ARB_shader_atomic_counters')
GL_ATOMIC_COUNTER_BUFFER_SIZE = Enumerant('GL_ATOMIC_COUNTER_BUFFER_SIZE', 0x92c3, 'GL_ARB_shader_atomic_counters')
GL_ATOMIC_COUNTER_BUFFER_START = Enumerant('GL_ATOMIC_COUNTER_BUFFER_START', 0x92c2, 'GL_ARB_shader_atomic_counters')
GL_MAX_ATOMIC_COUNTER_BUFFER_BINDINGS = Enumerant('GL_MAX_ATOMIC_COUNTER_BUFFER_BINDINGS', 0x92dc, 'GL_ARB_shader_atomic_counters')
GL_MAX_ATOMIC_COUNTER_BUFFER_SIZE = Enumerant('GL_MAX_ATOMIC_COUNTER_BUFFER_SIZE', 0x92d8, 'GL_ARB_shader_atomic_counters')
GL_MAX_COMBINED_ATOMIC_COUNTERS = Enumerant('GL_MAX_COMBINED_ATOMIC_COUNTERS', 0x92d7, 'GL_ARB_shader_atomic_counters')
GL_MAX_COMBINED_ATOMIC_COUNTER_BUFFERS = Enumerant('GL_MAX_COMBINED_ATOMIC_COUNTER_BUFFERS', 0x92d1, 'GL_ARB_shader_atomic_counters')
GL_MAX_FRAGMENT_ATOMIC_COUNTERS = Enumerant('GL_MAX_FRAGMENT_ATOMIC_COUNTERS', 0x92d6, 'GL_ARB_shader_atomic_counters')
GL_MAX_FRAGMENT_ATOMIC_COUNTER_BUFFERS = Enumerant('GL_MAX_FRAGMENT_ATOMIC_COUNTER_BUFFERS', 0x92d0, 'GL_ARB_shader_atomic_counters')
GL_MAX_GEOMETRY_ATOMIC_COUNTERS = Enumerant('GL_MAX_GEOMETRY_ATOMIC_COUNTERS', 0x92d5, 'GL_ARB_shader_atomic_counters')
GL_MAX_GEOMETRY_ATOMIC_COUNTER_BUFFERS = Enumerant('GL_MAX_GEOMETRY_ATOMIC_COUNTER_BUFFERS', 0x92cf, 'GL_ARB_shader_atomic_counters')
GL_MAX_TESS_CONTROL_ATOMIC_COUNTERS = Enumerant('GL_MAX_TESS_CONTROL_ATOMIC_COUNTERS', 0x92d3, 'GL_ARB_shader_atomic_counters')
GL_MAX_TESS_CONTROL_ATOMIC_COUNTER_BUFFERS = Enumerant('GL_MAX_TESS_CONTROL_ATOMIC_COUNTER_BUFFERS', 0x92cd, 'GL_ARB_shader_atomic_counters')
GL_MAX_TESS_EVALUATION_ATOMIC_COUNTERS = Enumerant('GL_MAX_TESS_EVALUATION_ATOMIC_COUNTERS', 0x92d4, 'GL_ARB_shader_atomic_counters')
GL_MAX_TESS_EVALUATION_ATOMIC_COUNTER_BUFFERS = Enumerant('GL_MAX_TESS_EVALUATION_ATOMIC_COUNTER_BUFFERS', 0x92ce, 'GL_ARB_shader_atomic_counters')
GL_MAX_VERTEX_ATOMIC_COUNTERS = Enumerant('GL_MAX_VERTEX_ATOMIC_COUNTERS', 0x92d2, 'GL_ARB_shader_atomic_counters')
GL_MAX_VERTEX_ATOMIC_COUNTER_BUFFERS = Enumerant('GL_MAX_VERTEX_ATOMIC_COUNTER_BUFFERS', 0x92cc, 'GL_ARB_shader_atomic_counters')
GL_UNIFORM_ATOMIC_COUNTER_BUFFER_INDEX = Enumerant('GL_UNIFORM_ATOMIC_COUNTER_BUFFER_INDEX', 0x92da, 'GL_ARB_shader_atomic_counters')
GL_UNSIGNED_INT_ATOMIC_COUNTER = Enumerant('GL_UNSIGNED_INT_ATOMIC_COUNTER', 0x92db, 'GL_ARB_shader_atomic_counters')

defines.add(GL_ACTIVE_ATOMIC_COUNTER_BUFFERS)
defines.add(GL_ATOMIC_COUNTER_BUFFER)
defines.add(GL_ATOMIC_COUNTER_BUFFER_ACTIVE_ATOMIC_COUNTERS)
defines.add(GL_ATOMIC_COUNTER_BUFFER_ACTIVE_ATOMIC_COUNTER_INDICES)
defines.add(GL_ATOMIC_COUNTER_BUFFER_BINDING)
defines.add(GL_ATOMIC_COUNTER_BUFFER_DATA_SIZE)
defines.add(GL_ATOMIC_COUNTER_BUFFER_REFERENCED_BY_FRAGMENT_SHADER)
defines.add(GL_ATOMIC_COUNTER_BUFFER_REFERENCED_BY_GEOMETRY_SHADER)
defines.add(GL_ATOMIC_COUNTER_BUFFER_REFERENCED_BY_TESS_CONTROL_SHADER)
defines.add(GL_ATOMIC_COUNTER_BUFFER_REFERENCED_BY_TESS_EVALUATION_SHADER)
defines.add(GL_ATOMIC_COUNTER_BUFFER_REFERENCED_BY_VERTEX_SHADER)
defines.add(GL_ATOMIC_COUNTER_BUFFER_SIZE)
defines.add(GL_ATOMIC_COUNTER_BUFFER_START)
defines.add(GL_MAX_ATOMIC_COUNTER_BUFFER_BINDINGS)
defines.add(GL_MAX_ATOMIC_COUNTER_BUFFER_SIZE)
defines.add(GL_MAX_COMBINED_ATOMIC_COUNTERS)
defines.add(GL_MAX_COMBINED_ATOMIC_COUNTER_BUFFERS)
defines.add(GL_MAX_FRAGMENT_ATOMIC_COUNTERS)
defines.add(GL_MAX_FRAGMENT_ATOMIC_COUNTER_BUFFERS)
defines.add(GL_MAX_GEOMETRY_ATOMIC_COUNTERS)
defines.add(GL_MAX_GEOMETRY_ATOMIC_COUNTER_BUFFERS)
defines.add(GL_MAX_TESS_CONTROL_ATOMIC_COUNTERS)
defines.add(GL_MAX_TESS_CONTROL_ATOMIC_COUNTER_BUFFERS)
defines.add(GL_MAX_TESS_EVALUATION_ATOMIC_COUNTERS)
defines.add(GL_MAX_TESS_EVALUATION_ATOMIC_COUNTER_BUFFERS)
defines.add(GL_MAX_VERTEX_ATOMIC_COUNTERS)
defines.add(GL_MAX_VERTEX_ATOMIC_COUNTER_BUFFERS)
defines.add(GL_UNIFORM_ATOMIC_COUNTER_BUFFER_INDEX)
defines.add(GL_UNSIGNED_INT_ATOMIC_COUNTER)

# GL_ARB_shader_image_load_store

GL_ALL_BARRIER_BITS = Enumerant('GL_ALL_BARRIER_BITS', 0xffffffff, 'GL_ARB_shader_image_load_store')
GL_ATOMIC_COUNTER_BARRIER_BIT = Enumerant('GL_ATOMIC_COUNTER_BARRIER_BIT', 0x1000, 'GL_ARB_shader_image_load_store')
GL_BUFFER_UPDATE_BARRIER_BIT = Enumerant('GL_BUFFER_UPDATE_BARRIER_BIT', 0x0200, 'GL_ARB_shader_image_load_store')
GL_COMMAND_BARRIER_BIT = Enumerant('GL_COMMAND_BARRIER_BIT', 0x0040, 'GL_ARB_shader_image_load_store')
GL_ELEMENT_ARRAY_BARRIER_BIT = Enumerant('GL_ELEMENT_ARRAY_BARRIER_BIT', 0x0002, 'GL_ARB_shader_image_load_store')
GL_FRAMEBUFFER_BARRIER_BIT = Enumerant('GL_FRAMEBUFFER_BARRIER_BIT', 0x0400, 'GL_ARB_shader_image_load_store')
GL_IMAGE_1D = Enumerant('GL_IMAGE_1D', 0x904c, 'GL_ARB_shader_image_load_store')
GL_IMAGE_1D_ARRAY = Enumerant('GL_IMAGE_1D_ARRAY', 0x9052, 'GL_ARB_shader_image_load_store')
GL_IMAGE_2D = Enumerant('GL_IMAGE_2D', 0x904d, 'GL_ARB_shader_image_load_store')
GL_IMAGE_2D_ARRAY = Enumerant('GL_IMAGE_2D_ARRAY', 0x9053, 'GL_ARB_shader_image_load_store')
GL_IMAGE_2D_MULTISAMPLE = Enumerant('GL_IMAGE_2D_MULTISAMPLE', 0x9055, 'GL_ARB_shader_image_load_store')
GL_IMAGE_2D_MULTISAMPLE_ARRAY = Enumerant('GL_IMAGE_2D_MULTISAMPLE_ARRAY', 0x9056, 'GL_ARB_shader_image_load_store')
GL_IMAGE_2D_RECT = Enumerant('GL_IMAGE_2D_RECT', 0x904f, 'GL_ARB_shader_image_load_store')
GL_IMAGE_3D = Enumerant('GL_IMAGE_3D', 0x904e, 'GL_ARB_shader_image_load_store')
GL_IMAGE_BINDING_ACCESS = Enumerant('GL_IMAGE_BINDING_ACCESS', 0x8f3e, 'GL_ARB_shader_image_load_store')
GL_IMAGE_BINDING_FORMAT = Enumerant('GL_IMAGE_BINDING_FORMAT', 0x906e, 'GL_ARB_shader_image_load_store')
GL_IMAGE_BINDING_LAYER = Enumerant('GL_IMAGE_BINDING_LAYER', 0x8f3d, 'GL_ARB_shader_image_load_store')
GL_IMAGE_BINDING_LAYERED = Enumerant('GL_IMAGE_BINDING_LAYERED', 0x8f3c, 'GL_ARB_shader_image_load_store')
GL_IMAGE_BINDING_LEVEL = Enumerant('GL_IMAGE_BINDING_LEVEL', 0x8f3b, 'GL_ARB_shader_image_load_store')
GL_IMAGE_BINDING_NAME = Enumerant('GL_IMAGE_BINDING_NAME', 0x8f3a, 'GL_ARB_shader_image_load_store')
GL_IMAGE_BUFFER = Enumerant('GL_IMAGE_BUFFER', 0x9051, 'GL_ARB_shader_image_load_store')
GL_IMAGE_CUBE = Enumerant('GL_IMAGE_CUBE', 0x9050, 'GL_ARB_shader_image_load_store')
GL_IMAGE_CUBE_MAP_ARRAY = Enumerant('GL_IMAGE_CUBE_MAP_ARRAY', 0x9054, 'GL_ARB_shader_image_load_store')
GL_IMAGE_FORMAT_COMPATIBILITY_BY_CLASS = Enumerant('GL_IMAGE_FORMAT_COMPATIBILITY_BY_CLASS', 0x90c9, 'GL_ARB_shader_image_load_store')
GL_IMAGE_FORMAT_COMPATIBILITY_BY_SIZE = Enumerant('GL_IMAGE_FORMAT_COMPATIBILITY_BY_SIZE', 0x90c8, 'GL_ARB_shader_image_load_store')
GL_IMAGE_FORMAT_COMPATIBILITY_TYPE = Enumerant('GL_IMAGE_FORMAT_COMPATIBILITY_TYPE', 0x90c7, 'GL_ARB_shader_image_load_store')
GL_INT_IMAGE_1D = Enumerant('GL_INT_IMAGE_1D', 0x9057, 'GL_ARB_shader_image_load_store')
GL_INT_IMAGE_1D_ARRAY = Enumerant('GL_INT_IMAGE_1D_ARRAY', 0x905d, 'GL_ARB_shader_image_load_store')
GL_INT_IMAGE_2D = Enumerant('GL_INT_IMAGE_2D', 0x9058, 'GL_ARB_shader_image_load_store')
GL_INT_IMAGE_2D_ARRAY = Enumerant('GL_INT_IMAGE_2D_ARRAY', 0x905e, 'GL_ARB_shader_image_load_store')
GL_INT_IMAGE_2D_MULTISAMPLE = Enumerant('GL_INT_IMAGE_2D_MULTISAMPLE', 0x9060, 'GL_ARB_shader_image_load_store')
GL_INT_IMAGE_2D_MULTISAMPLE_ARRAY = Enumerant('GL_INT_IMAGE_2D_MULTISAMPLE_ARRAY', 0x9061, 'GL_ARB_shader_image_load_store')
GL_INT_IMAGE_2D_RECT = Enumerant('GL_INT_IMAGE_2D_RECT', 0x905a, 'GL_ARB_shader_image_load_store')
GL_INT_IMAGE_3D = Enumerant('GL_INT_IMAGE_3D', 0x9059, 'GL_ARB_shader_image_load_store')
GL_INT_IMAGE_BUFFER = Enumerant('GL_INT_IMAGE_BUFFER', 0x905c, 'GL_ARB_shader_image_load_store')
GL_INT_IMAGE_CUBE = Enumerant('GL_INT_IMAGE_CUBE', 0x905b, 'GL_ARB_shader_image_load_store')
GL_INT_IMAGE_CUBE_MAP_ARRAY = Enumerant('GL_INT_IMAGE_CUBE_MAP_ARRAY', 0x905f, 'GL_ARB_shader_image_load_store')
GL_MAX_COMBINED_IMAGE_UNIFORMS = Enumerant('GL_MAX_COMBINED_IMAGE_UNIFORMS', 0x90cf, 'GL_ARB_shader_image_load_store')
GL_MAX_COMBINED_IMAGE_UNITS_AND_FRAGMENT_OUTPUTS = Enumerant('GL_MAX_COMBINED_IMAGE_UNITS_AND_FRAGMENT_OUTPUTS', 0x8f39, 'GL_ARB_shader_image_load_store')
GL_MAX_FRAGMENT_IMAGE_UNIFORMS = Enumerant('GL_MAX_FRAGMENT_IMAGE_UNIFORMS', 0x90ce, 'GL_ARB_shader_image_load_store')
GL_MAX_GEOMETRY_IMAGE_UNIFORMS = Enumerant('GL_MAX_GEOMETRY_IMAGE_UNIFORMS', 0x90cd, 'GL_ARB_shader_image_load_store')
GL_MAX_IMAGE_SAMPLES = Enumerant('GL_MAX_IMAGE_SAMPLES', 0x906d, 'GL_ARB_shader_image_load_store')
GL_MAX_IMAGE_UNITS = Enumerant('GL_MAX_IMAGE_UNITS', 0x8f38, 'GL_ARB_shader_image_load_store')
GL_MAX_TESS_CONTROL_IMAGE_UNIFORMS = Enumerant('GL_MAX_TESS_CONTROL_IMAGE_UNIFORMS', 0x90cb, 'GL_ARB_shader_image_load_store')
GL_MAX_TESS_EVALUATION_IMAGE_UNIFORMS = Enumerant('GL_MAX_TESS_EVALUATION_IMAGE_UNIFORMS', 0x90cc, 'GL_ARB_shader_image_load_store')
GL_MAX_VERTEX_IMAGE_UNIFORMS = Enumerant('GL_MAX_VERTEX_IMAGE_UNIFORMS', 0x90ca, 'GL_ARB_shader_image_load_store')
GL_PIXEL_BUFFER_BARRIER_BIT = Enumerant('GL_PIXEL_BUFFER_BARRIER_BIT', 0x0080, 'GL_ARB_shader_image_load_store')
GL_SHADER_IMAGE_ACCESS_BARRIER_BIT = Enumerant('GL_SHADER_IMAGE_ACCESS_BARRIER_BIT', 0x0020, 'GL_ARB_shader_image_load_store')
GL_TEXTURE_FETCH_BARRIER_BIT = Enumerant('GL_TEXTURE_FETCH_BARRIER_BIT', 0x0008, 'GL_ARB_shader_image_load_store')
GL_TEXTURE_UPDATE_BARRIER_BIT = Enumerant('GL_TEXTURE_UPDATE_BARRIER_BIT', 0x0100, 'GL_ARB_shader_image_load_store')
GL_TRANSFORM_FEEDBACK_BARRIER_BIT = Enumerant('GL_TRANSFORM_FEEDBACK_BARRIER_BIT', 0x0800, 'GL_ARB_shader_image_load_store')
GL_UNIFORM_BARRIER_BIT = Enumerant('GL_UNIFORM_BARRIER_BIT', 0x0004, 'GL_ARB_shader_image_load_store')
GL_UNSIGNED_INT_IMAGE_1D = Enumerant('GL_UNSIGNED_INT_IMAGE_1D', 0x9062, 'GL_ARB_shader_image_load_store')
GL_UNSIGNED_INT_IMAGE_1D_ARRAY = Enumerant('GL_UNSIGNED_INT_IMAGE_1D_ARRAY', 0x9068, 'GL_ARB_shader_image_load_store')
GL_UNSIGNED_INT_IMAGE_2D = Enumerant('GL_UNSIGNED_INT_IMAGE_2D', 0x9063, 'GL_ARB_shader_image_load_store')
GL_UNSIGNED_INT_IMAGE_2D_ARRAY = Enumerant('GL_UNSIGNED_INT_IMAGE_2D_ARRAY', 0x9069, 'GL_ARB_shader_image_load_store')
GL_UNSIGNED_INT_IMAGE_2D_MULTISAMPLE = Enumerant('GL_UNSIGNED_INT_IMAGE_2D_MULTISAMPLE', 0x906b, 'GL_ARB_shader_image_load_store')
GL_UNSIGNED_INT_IMAGE_2D_MULTISAMPLE_ARRAY = Enumerant('GL_UNSIGNED_INT_IMAGE_2D_MULTISAMPLE_ARRAY', 0x906c, 'GL_ARB_shader_image_load_store')
GL_UNSIGNED_INT_IMAGE_2D_RECT = Enumerant('GL_UNSIGNED_INT_IMAGE_2D_RECT', 0x9065, 'GL_ARB_shader_image_load_store')
GL_UNSIGNED_INT_IMAGE_3D = Enumerant('GL_UNSIGNED_INT_IMAGE_3D', 0x9064, 'GL_ARB_shader_image_load_store')
GL_UNSIGNED_INT_IMAGE_BUFFER = Enumerant('GL_UNSIGNED_INT_IMAGE_BUFFER', 0x9067, 'GL_ARB_shader_image_load_store')
GL_UNSIGNED_INT_IMAGE_CUBE = Enumerant('GL_UNSIGNED_INT_IMAGE_CUBE', 0x9066, 'GL_ARB_shader_image_load_store')
GL_UNSIGNED_INT_IMAGE_CUBE_MAP_ARRAY = Enumerant('GL_UNSIGNED_INT_IMAGE_CUBE_MAP_ARRAY', 0x906a, 'GL_ARB_shader_image_load_store')
GL_VERTEX_ATTRIB_ARRAY_BARRIER_BIT = Enumerant('GL_VERTEX_ATTRIB_ARRAY_BARRIER_BIT', 0x0001, 'GL_ARB_shader_image_load_store')

defines.add(GL_ALL_BARRIER_BITS)
defines.add(GL_ATOMIC_COUNTER_BARRIER_BIT)
defines.add(GL_BUFFER_UPDATE_BARRIER_BIT)
defines.add(GL_COMMAND_BARRIER_BIT)
defines.add(GL_ELEMENT_ARRAY_BARRIER_BIT)
defines.add(GL_FRAMEBUFFER_BARRIER_BIT)
defines.add(GL_IMAGE_1D)
defines.add(GL_IMAGE_1D_ARRAY)
defines.add(GL_IMAGE_2D)
defines.add(GL_IMAGE_2D_ARRAY)
defines.add(GL_IMAGE_2D_MULTISAMPLE)
defines.add(GL_IMAGE_2D_MULTISAMPLE_ARRAY)
defines.add(GL_IMAGE_2D_RECT)
defines.add(GL_IMAGE_3D)
defines.add(GL_IMAGE_BINDING_ACCESS)
defines.add(GL_IMAGE_BINDING_FORMAT)
defines.add(GL_IMAGE_BINDING_LAYER)
defines.add(GL_IMAGE_BINDING_LAYERED)
defines.add(GL_IMAGE_BINDING_LEVEL)
defines.add(GL_IMAGE_BINDING_NAME)
defines.add(GL_IMAGE_BUFFER)
defines.add(GL_IMAGE_CUBE)
defines.add(GL_IMAGE_CUBE_MAP_ARRAY)
defines.add(GL_IMAGE_FORMAT_COMPATIBILITY_BY_CLASS)
defines.add(GL_IMAGE_FORMAT_COMPATIBILITY_BY_SIZE)
defines.add(GL_IMAGE_FORMAT_COMPATIBILITY_TYPE)
defines.add(GL_INT_IMAGE_1D)
defines.add(GL_INT_IMAGE_1D_ARRAY)
defines.add(GL_INT_IMAGE_2D)
defines.add(GL_INT_IMAGE_2D_ARRAY)
defines.add(GL_INT_IMAGE_2D_MULTISAMPLE)
defines.add(GL_INT_IMAGE_2D_MULTISAMPLE_ARRAY)
defines.add(GL_INT_IMAGE_2D_RECT)
defines.add(GL_INT_IMAGE_3D)
defines.add(GL_INT_IMAGE_BUFFER)
defines.add(GL_INT_IMAGE_CUBE)
defines.add(GL_INT_IMAGE_CUBE_MAP_ARRAY)
defines.add(GL_MAX_COMBINED_IMAGE_UNIFORMS)
defines.add(GL_MAX_COMBINED_IMAGE_UNITS_AND_FRAGMENT_OUTPUTS)
defines.add(GL_MAX_FRAGMENT_IMAGE_UNIFORMS)
defines.add(GL_MAX_GEOMETRY_IMAGE_UNIFORMS)
defines.add(GL_MAX_IMAGE_SAMPLES)
defines.add(GL_MAX_IMAGE_UNITS)
defines.add(GL_MAX_TESS_CONTROL_IMAGE_UNIFORMS)
defines.add(GL_MAX_TESS_EVALUATION_IMAGE_UNIFORMS)
defines.add(GL_MAX_VERTEX_IMAGE_UNIFORMS)
defines.add(GL_PIXEL_BUFFER_BARRIER_BIT)
defines.add(GL_SHADER_IMAGE_ACCESS_BARRIER_BIT)
defines.add(GL_TEXTURE_FETCH_BARRIER_BIT)
defines.add(GL_TEXTURE_UPDATE_BARRIER_BIT)
defines.add(GL_TRANSFORM_FEEDBACK_BARRIER_BIT)
defines.add(GL_UNIFORM_BARRIER_BIT)
defines.add(GL_UNSIGNED_INT_IMAGE_1D)
defines.add(GL_UNSIGNED_INT_IMAGE_1D_ARRAY)
defines.add(GL_UNSIGNED_INT_IMAGE_2D)
defines.add(GL_UNSIGNED_INT_IMAGE_2D_ARRAY)
defines.add(GL_UNSIGNED_INT_IMAGE_2D_MULTISAMPLE)
defines.add(GL_UNSIGNED_INT_IMAGE_2D_MULTISAMPLE_ARRAY)
defines.add(GL_UNSIGNED_INT_IMAGE_2D_RECT)
defines.add(GL_UNSIGNED_INT_IMAGE_3D)
defines.add(GL_UNSIGNED_INT_IMAGE_BUFFER)
defines.add(GL_UNSIGNED_INT_IMAGE_CUBE)
defines.add(GL_UNSIGNED_INT_IMAGE_CUBE_MAP_ARRAY)
defines.add(GL_VERTEX_ATTRIB_ARRAY_BARRIER_BIT)

# GL_ARB_shader_objects

GL_BOOL_ARB = Enumerant('GL_BOOL_ARB', 0x8b56, 'GL_ARB_shader_objects')
GL_BOOL_VEC2_ARB = Enumerant('GL_BOOL_VEC2_ARB', 0x8b57, 'GL_ARB_shader_objects')
GL_BOOL_VEC3_ARB = Enumerant('GL_BOOL_VEC3_ARB', 0x8b58, 'GL_ARB_shader_objects')
GL_BOOL_VEC4_ARB = Enumerant('GL_BOOL_VEC4_ARB', 0x8b59, 'GL_ARB_shader_objects')
GL_FLOAT_MAT2_ARB = Enumerant('GL_FLOAT_MAT2_ARB', 0x8b5a, 'GL_ARB_shader_objects')
GL_FLOAT_MAT3_ARB = Enumerant('GL_FLOAT_MAT3_ARB', 0x8b5b, 'GL_ARB_shader_objects')
GL_FLOAT_MAT4_ARB = Enumerant('GL_FLOAT_MAT4_ARB', 0x8b5c, 'GL_ARB_shader_objects')
GL_FLOAT_VEC2_ARB = Enumerant('GL_FLOAT_VEC2_ARB', 0x8b50, 'GL_ARB_shader_objects')
GL_FLOAT_VEC3_ARB = Enumerant('GL_FLOAT_VEC3_ARB', 0x8b51, 'GL_ARB_shader_objects')
GL_FLOAT_VEC4_ARB = Enumerant('GL_FLOAT_VEC4_ARB', 0x8b52, 'GL_ARB_shader_objects')
GL_INT_VEC2_ARB = Enumerant('GL_INT_VEC2_ARB', 0x8b53, 'GL_ARB_shader_objects')
GL_INT_VEC3_ARB = Enumerant('GL_INT_VEC3_ARB', 0x8b54, 'GL_ARB_shader_objects')
GL_INT_VEC4_ARB = Enumerant('GL_INT_VEC4_ARB', 0x8b55, 'GL_ARB_shader_objects')
GL_OBJECT_ACTIVE_UNIFORMS_ARB = Enumerant('GL_OBJECT_ACTIVE_UNIFORMS_ARB', 0x8b86, 'GL_ARB_shader_objects')
GL_OBJECT_ACTIVE_UNIFORM_MAX_LENGTH_ARB = Enumerant('GL_OBJECT_ACTIVE_UNIFORM_MAX_LENGTH_ARB', 0x8b87, 'GL_ARB_shader_objects')
GL_OBJECT_ATTACHED_OBJECTS_ARB = Enumerant('GL_OBJECT_ATTACHED_OBJECTS_ARB', 0x8b85, 'GL_ARB_shader_objects')
GL_OBJECT_COMPILE_STATUS_ARB = Enumerant('GL_OBJECT_COMPILE_STATUS_ARB', 0x8b81, 'GL_ARB_shader_objects')
GL_OBJECT_DELETE_STATUS_ARB = Enumerant('GL_OBJECT_DELETE_STATUS_ARB', 0x8b80, 'GL_ARB_shader_objects')
GL_OBJECT_INFO_LOG_LENGTH_ARB = Enumerant('GL_OBJECT_INFO_LOG_LENGTH_ARB', 0x8b84, 'GL_ARB_shader_objects')
GL_OBJECT_LINK_STATUS_ARB = Enumerant('GL_OBJECT_LINK_STATUS_ARB', 0x8b82, 'GL_ARB_shader_objects')
GL_OBJECT_SHADER_SOURCE_LENGTH_ARB = Enumerant('GL_OBJECT_SHADER_SOURCE_LENGTH_ARB', 0x8b88, 'GL_ARB_shader_objects')
GL_OBJECT_SUBTYPE_ARB = Enumerant('GL_OBJECT_SUBTYPE_ARB', 0x8b4f, 'GL_ARB_shader_objects')
GL_OBJECT_TYPE_ARB = Enumerant('GL_OBJECT_TYPE_ARB', 0x8b4e, 'GL_ARB_shader_objects')
GL_OBJECT_VALIDATE_STATUS_ARB = Enumerant('GL_OBJECT_VALIDATE_STATUS_ARB', 0x8b83, 'GL_ARB_shader_objects')
GL_PROGRAM_OBJECT_ARB = Enumerant('GL_PROGRAM_OBJECT_ARB', 0x8b40, 'GL_ARB_shader_objects')
GL_SAMPLER_1D_ARB = Enumerant('GL_SAMPLER_1D_ARB', 0x8b5d, 'GL_ARB_shader_objects')
GL_SAMPLER_1D_SHADOW_ARB = Enumerant('GL_SAMPLER_1D_SHADOW_ARB', 0x8b61, 'GL_ARB_shader_objects')
GL_SAMPLER_2D_ARB = Enumerant('GL_SAMPLER_2D_ARB', 0x8b5e, 'GL_ARB_shader_objects')
GL_SAMPLER_2D_RECT_ARB = Enumerant('GL_SAMPLER_2D_RECT_ARB', 0x8b63, 'GL_ARB_shader_objects')
GL_SAMPLER_2D_RECT_SHADOW_ARB = Enumerant('GL_SAMPLER_2D_RECT_SHADOW_ARB', 0x8b64, 'GL_ARB_shader_objects')
GL_SAMPLER_2D_SHADOW_ARB = Enumerant('GL_SAMPLER_2D_SHADOW_ARB', 0x8b62, 'GL_ARB_shader_objects')
GL_SAMPLER_3D_ARB = Enumerant('GL_SAMPLER_3D_ARB', 0x8b5f, 'GL_ARB_shader_objects')
GL_SAMPLER_CUBE_ARB = Enumerant('GL_SAMPLER_CUBE_ARB', 0x8b60, 'GL_ARB_shader_objects')
GL_SHADER_OBJECT_ARB = Enumerant('GL_SHADER_OBJECT_ARB', 0x8b48, 'GL_ARB_shader_objects')

defines.add(GL_BOOL_ARB)
defines.add(GL_BOOL_VEC2_ARB)
defines.add(GL_BOOL_VEC3_ARB)
defines.add(GL_BOOL_VEC4_ARB)
defines.add(GL_FLOAT_MAT2_ARB)
defines.add(GL_FLOAT_MAT3_ARB)
defines.add(GL_FLOAT_MAT4_ARB)
defines.add(GL_FLOAT_VEC2_ARB)
defines.add(GL_FLOAT_VEC3_ARB)
defines.add(GL_FLOAT_VEC4_ARB)
defines.add(GL_INT_VEC2_ARB)
defines.add(GL_INT_VEC3_ARB)
defines.add(GL_INT_VEC4_ARB)
defines.add(GL_OBJECT_ACTIVE_UNIFORMS_ARB)
defines.add(GL_OBJECT_ACTIVE_UNIFORM_MAX_LENGTH_ARB)
defines.add(GL_OBJECT_ATTACHED_OBJECTS_ARB)
defines.add(GL_OBJECT_COMPILE_STATUS_ARB)
defines.add(GL_OBJECT_DELETE_STATUS_ARB)
defines.add(GL_OBJECT_INFO_LOG_LENGTH_ARB)
defines.add(GL_OBJECT_LINK_STATUS_ARB)
defines.add(GL_OBJECT_SHADER_SOURCE_LENGTH_ARB)
defines.add(GL_OBJECT_SUBTYPE_ARB)
defines.add(GL_OBJECT_TYPE_ARB)
defines.add(GL_OBJECT_VALIDATE_STATUS_ARB)
defines.add(GL_PROGRAM_OBJECT_ARB)
defines.add(GL_SAMPLER_1D_ARB)
defines.add(GL_SAMPLER_1D_SHADOW_ARB)
defines.add(GL_SAMPLER_2D_ARB)
defines.add(GL_SAMPLER_2D_RECT_ARB)
defines.add(GL_SAMPLER_2D_RECT_SHADOW_ARB)
defines.add(GL_SAMPLER_2D_SHADOW_ARB)
defines.add(GL_SAMPLER_3D_ARB)
defines.add(GL_SAMPLER_CUBE_ARB)
defines.add(GL_SHADER_OBJECT_ARB)

# GL_ARB_shader_storage_buffer_object

GL_MAX_COMBINED_SHADER_OUTPUT_RESOURCES = Enumerant('GL_MAX_COMBINED_SHADER_OUTPUT_RESOURCES', 0x8f39, 'GL_ARB_shader_storage_buffer_object')
GL_MAX_COMBINED_SHADER_STORAGE_BLOCKS = Enumerant('GL_MAX_COMBINED_SHADER_STORAGE_BLOCKS', 0x90dc, 'GL_ARB_shader_storage_buffer_object')
GL_MAX_COMPUTE_SHADER_STORAGE_BLOCKS = Enumerant('GL_MAX_COMPUTE_SHADER_STORAGE_BLOCKS', 0x90db, 'GL_ARB_shader_storage_buffer_object')
GL_MAX_FRAGMENT_SHADER_STORAGE_BLOCKS = Enumerant('GL_MAX_FRAGMENT_SHADER_STORAGE_BLOCKS', 0x90da, 'GL_ARB_shader_storage_buffer_object')
GL_MAX_GEOMETRY_SHADER_STORAGE_BLOCKS = Enumerant('GL_MAX_GEOMETRY_SHADER_STORAGE_BLOCKS', 0x90d7, 'GL_ARB_shader_storage_buffer_object')
GL_MAX_SHADER_STORAGE_BLOCK_SIZE = Enumerant('GL_MAX_SHADER_STORAGE_BLOCK_SIZE', 0x90de, 'GL_ARB_shader_storage_buffer_object')
GL_MAX_SHADER_STORAGE_BUFFER_BINDINGS = Enumerant('GL_MAX_SHADER_STORAGE_BUFFER_BINDINGS', 0x90dd, 'GL_ARB_shader_storage_buffer_object')
GL_MAX_TESS_CONTROL_SHADER_STORAGE_BLOCKS = Enumerant('GL_MAX_TESS_CONTROL_SHADER_STORAGE_BLOCKS', 0x90d8, 'GL_ARB_shader_storage_buffer_object')
GL_MAX_TESS_EVALUATION_SHADER_STORAGE_BLOCKS = Enumerant('GL_MAX_TESS_EVALUATION_SHADER_STORAGE_BLOCKS', 0x90d9, 'GL_ARB_shader_storage_buffer_object')
GL_MAX_VERTEX_SHADER_STORAGE_BLOCKS = Enumerant('GL_MAX_VERTEX_SHADER_STORAGE_BLOCKS', 0x90d6, 'GL_ARB_shader_storage_buffer_object')
GL_SHADER_STORAGE_BARRIER_BIT = Enumerant('GL_SHADER_STORAGE_BARRIER_BIT', 0x2000, 'GL_ARB_shader_storage_buffer_object')
GL_SHADER_STORAGE_BUFFER = Enumerant('GL_SHADER_STORAGE_BUFFER', 0x90d2, 'GL_ARB_shader_storage_buffer_object')
GL_SHADER_STORAGE_BUFFER_BINDING = Enumerant('GL_SHADER_STORAGE_BUFFER_BINDING', 0x90d3, 'GL_ARB_shader_storage_buffer_object')
GL_SHADER_STORAGE_BUFFER_OFFSET_ALIGNMENT = Enumerant('GL_SHADER_STORAGE_BUFFER_OFFSET_ALIGNMENT', 0x90df, 'GL_ARB_shader_storage_buffer_object')
GL_SHADER_STORAGE_BUFFER_SIZE = Enumerant('GL_SHADER_STORAGE_BUFFER_SIZE', 0x90d5, 'GL_ARB_shader_storage_buffer_object')
GL_SHADER_STORAGE_BUFFER_START = Enumerant('GL_SHADER_STORAGE_BUFFER_START', 0x90d4, 'GL_ARB_shader_storage_buffer_object')

defines.add(GL_MAX_COMBINED_SHADER_OUTPUT_RESOURCES)
defines.add(GL_MAX_COMBINED_SHADER_STORAGE_BLOCKS)
defines.add(GL_MAX_COMPUTE_SHADER_STORAGE_BLOCKS)
defines.add(GL_MAX_FRAGMENT_SHADER_STORAGE_BLOCKS)
defines.add(GL_MAX_GEOMETRY_SHADER_STORAGE_BLOCKS)
defines.add(GL_MAX_SHADER_STORAGE_BLOCK_SIZE)
defines.add(GL_MAX_SHADER_STORAGE_BUFFER_BINDINGS)
defines.add(GL_MAX_TESS_CONTROL_SHADER_STORAGE_BLOCKS)
defines.add(GL_MAX_TESS_EVALUATION_SHADER_STORAGE_BLOCKS)
defines.add(GL_MAX_VERTEX_SHADER_STORAGE_BLOCKS)
defines.add(GL_SHADER_STORAGE_BARRIER_BIT)
defines.add(GL_SHADER_STORAGE_BUFFER)
defines.add(GL_SHADER_STORAGE_BUFFER_BINDING)
defines.add(GL_SHADER_STORAGE_BUFFER_OFFSET_ALIGNMENT)
defines.add(GL_SHADER_STORAGE_BUFFER_SIZE)
defines.add(GL_SHADER_STORAGE_BUFFER_START)

# GL_ARB_shader_subroutine

GL_ACTIVE_SUBROUTINES = Enumerant('GL_ACTIVE_SUBROUTINES', 0x8de5, 'GL_ARB_shader_subroutine')
GL_ACTIVE_SUBROUTINE_MAX_LENGTH = Enumerant('GL_ACTIVE_SUBROUTINE_MAX_LENGTH', 0x8e48, 'GL_ARB_shader_subroutine')
GL_ACTIVE_SUBROUTINE_UNIFORMS = Enumerant('GL_ACTIVE_SUBROUTINE_UNIFORMS', 0x8de6, 'GL_ARB_shader_subroutine')
GL_ACTIVE_SUBROUTINE_UNIFORM_LOCATIONS = Enumerant('GL_ACTIVE_SUBROUTINE_UNIFORM_LOCATIONS', 0x8e47, 'GL_ARB_shader_subroutine')
GL_ACTIVE_SUBROUTINE_UNIFORM_MAX_LENGTH = Enumerant('GL_ACTIVE_SUBROUTINE_UNIFORM_MAX_LENGTH', 0x8e49, 'GL_ARB_shader_subroutine')
GL_COMPATIBLE_SUBROUTINES = Enumerant('GL_COMPATIBLE_SUBROUTINES', 0x8e4b, 'GL_ARB_shader_subroutine')
GL_MAX_SUBROUTINES = Enumerant('GL_MAX_SUBROUTINES', 0x8de7, 'GL_ARB_shader_subroutine')
GL_MAX_SUBROUTINE_UNIFORM_LOCATIONS = Enumerant('GL_MAX_SUBROUTINE_UNIFORM_LOCATIONS', 0x8de8, 'GL_ARB_shader_subroutine')
GL_NUM_COMPATIBLE_SUBROUTINES = Enumerant('GL_NUM_COMPATIBLE_SUBROUTINES', 0x8e4a, 'GL_ARB_shader_subroutine')

defines.add(GL_ACTIVE_SUBROUTINES)
defines.add(GL_ACTIVE_SUBROUTINE_MAX_LENGTH)
defines.add(GL_ACTIVE_SUBROUTINE_UNIFORMS)
defines.add(GL_ACTIVE_SUBROUTINE_UNIFORM_LOCATIONS)
defines.add(GL_ACTIVE_SUBROUTINE_UNIFORM_MAX_LENGTH)
defines.add(GL_COMPATIBLE_SUBROUTINES)
defines.add(GL_MAX_SUBROUTINES)
defines.add(GL_MAX_SUBROUTINE_UNIFORM_LOCATIONS)
defines.add(GL_NUM_COMPATIBLE_SUBROUTINES)

# GL_ARB_shading_language_100

GL_SHADING_LANGUAGE_VERSION_ARB = Enumerant('GL_SHADING_LANGUAGE_VERSION_ARB', 0x8b8c, 'GL_ARB_shading_language_100')

defines.add(GL_SHADING_LANGUAGE_VERSION_ARB)

# GL_ARB_shading_language_include

GL_NAMED_STRING_LENGTH_ARB = Enumerant('GL_NAMED_STRING_LENGTH_ARB', 0x8de9, 'GL_ARB_shading_language_include')
GL_NAMED_STRING_TYPE_ARB = Enumerant('GL_NAMED_STRING_TYPE_ARB', 0x8dea, 'GL_ARB_shading_language_include')
GL_SHADER_INCLUDE_ARB = Enumerant('GL_SHADER_INCLUDE_ARB', 0x8dae, 'GL_ARB_shading_language_include')

defines.add(GL_NAMED_STRING_LENGTH_ARB)
defines.add(GL_NAMED_STRING_TYPE_ARB)
defines.add(GL_SHADER_INCLUDE_ARB)

# GL_ARB_shadow

GL_COMPARE_R_TO_TEXTURE_ARB = Enumerant('GL_COMPARE_R_TO_TEXTURE_ARB', 0x884e, 'GL_ARB_shadow')
GL_TEXTURE_COMPARE_FUNC_ARB = Enumerant('GL_TEXTURE_COMPARE_FUNC_ARB', 0x884d, 'GL_ARB_shadow')
GL_TEXTURE_COMPARE_MODE_ARB = Enumerant('GL_TEXTURE_COMPARE_MODE_ARB', 0x884c, 'GL_ARB_shadow')

defines.add(GL_COMPARE_R_TO_TEXTURE_ARB)
defines.add(GL_TEXTURE_COMPARE_FUNC_ARB)
defines.add(GL_TEXTURE_COMPARE_MODE_ARB)

# GL_ARB_shadow_ambient

GL_TEXTURE_COMPARE_FAIL_VALUE_ARB = Enumerant('GL_TEXTURE_COMPARE_FAIL_VALUE_ARB', 0x80bf, 'GL_ARB_shadow_ambient')

defines.add(GL_TEXTURE_COMPARE_FAIL_VALUE_ARB)

# GL_ARB_sparse_texture

GL_MAX_SPARSE_3D_TEXTURE_SIZE_ARB = Enumerant('GL_MAX_SPARSE_3D_TEXTURE_SIZE_ARB', 0x9199, 'GL_ARB_sparse_texture')
GL_MAX_SPARSE_ARRAY_TEXTURE_LAYERS_ARB = Enumerant('GL_MAX_SPARSE_ARRAY_TEXTURE_LAYERS_ARB', 0x919a, 'GL_ARB_sparse_texture')
GL_MAX_SPARSE_TEXTURE_SIZE_ARB = Enumerant('GL_MAX_SPARSE_TEXTURE_SIZE_ARB', 0x9198, 'GL_ARB_sparse_texture')
GL_NUM_SPARSE_LEVELS_ARB = Enumerant('GL_NUM_SPARSE_LEVELS_ARB', 0x91aa, 'GL_ARB_sparse_texture')
GL_NUM_VIRTUAL_PAGE_SIZES_ARB = Enumerant('GL_NUM_VIRTUAL_PAGE_SIZES_ARB', 0x91a8, 'GL_ARB_sparse_texture')
GL_SPARSE_TEXTURE_FULL_ARRAY_CUBE_MIPMAPS_ARB = Enumerant('GL_SPARSE_TEXTURE_FULL_ARRAY_CUBE_MIPMAPS_ARB', 0x91a9, 'GL_ARB_sparse_texture')
GL_TEXTURE_SPARSE_ARB = Enumerant('GL_TEXTURE_SPARSE_ARB', 0x91a6, 'GL_ARB_sparse_texture')
GL_VIRTUAL_PAGE_SIZE_INDEX_ARB = Enumerant('GL_VIRTUAL_PAGE_SIZE_INDEX_ARB', 0x91a7, 'GL_ARB_sparse_texture')
GL_VIRTUAL_PAGE_SIZE_X_ARB = Enumerant('GL_VIRTUAL_PAGE_SIZE_X_ARB', 0x9195, 'GL_ARB_sparse_texture')
GL_VIRTUAL_PAGE_SIZE_Y_ARB = Enumerant('GL_VIRTUAL_PAGE_SIZE_Y_ARB', 0x9196, 'GL_ARB_sparse_texture')
GL_VIRTUAL_PAGE_SIZE_Z_ARB = Enumerant('GL_VIRTUAL_PAGE_SIZE_Z_ARB', 0x9197, 'GL_ARB_sparse_texture')

defines.add(GL_MAX_SPARSE_3D_TEXTURE_SIZE_ARB)
defines.add(GL_MAX_SPARSE_ARRAY_TEXTURE_LAYERS_ARB)
defines.add(GL_MAX_SPARSE_TEXTURE_SIZE_ARB)
defines.add(GL_NUM_SPARSE_LEVELS_ARB)
defines.add(GL_NUM_VIRTUAL_PAGE_SIZES_ARB)
defines.add(GL_SPARSE_TEXTURE_FULL_ARRAY_CUBE_MIPMAPS_ARB)
defines.add(GL_TEXTURE_SPARSE_ARB)
defines.add(GL_VIRTUAL_PAGE_SIZE_INDEX_ARB)
defines.add(GL_VIRTUAL_PAGE_SIZE_X_ARB)
defines.add(GL_VIRTUAL_PAGE_SIZE_Y_ARB)
defines.add(GL_VIRTUAL_PAGE_SIZE_Z_ARB)

# GL_ARB_stencil_texturing

GL_DEPTH_STENCIL_TEXTURE_MODE = Enumerant('GL_DEPTH_STENCIL_TEXTURE_MODE', 0x90ea, 'GL_ARB_stencil_texturing')

defines.add(GL_DEPTH_STENCIL_TEXTURE_MODE)

# GL_ARB_sync

GL_ALREADY_SIGNALED = Enumerant('GL_ALREADY_SIGNALED', 0x911a, 'GL_ARB_sync')
GL_CONDITION_SATISFIED = Enumerant('GL_CONDITION_SATISFIED', 0x911c, 'GL_ARB_sync')
GL_MAX_SERVER_WAIT_TIMEOUT = Enumerant('GL_MAX_SERVER_WAIT_TIMEOUT', 0x9111, 'GL_ARB_sync')
GL_OBJECT_TYPE = Enumerant('GL_OBJECT_TYPE', 0x9112, 'GL_ARB_sync')
GL_SIGNALED = Enumerant('GL_SIGNALED', 0x9119, 'GL_ARB_sync')
GL_SYNC_CONDITION = Enumerant('GL_SYNC_CONDITION', 0x9113, 'GL_ARB_sync')
GL_SYNC_FENCE = Enumerant('GL_SYNC_FENCE', 0x9116, 'GL_ARB_sync')
GL_SYNC_FLAGS = Enumerant('GL_SYNC_FLAGS', 0x9115, 'GL_ARB_sync')
GL_SYNC_FLUSH_COMMANDS_BIT = Enumerant('GL_SYNC_FLUSH_COMMANDS_BIT', 0x0001, 'GL_ARB_sync')
GL_SYNC_GPU_COMMANDS_COMPLETE = Enumerant('GL_SYNC_GPU_COMMANDS_COMPLETE', 0x9117, 'GL_ARB_sync')
GL_SYNC_STATUS = Enumerant('GL_SYNC_STATUS', 0x9114, 'GL_ARB_sync')
GL_TIMEOUT_EXPIRED = Enumerant('GL_TIMEOUT_EXPIRED', 0x911b, 'GL_ARB_sync')
GL_TIMEOUT_IGNORED = Enumerant('GL_TIMEOUT_IGNORED', 0xffffffffffffffff, 'GL_ARB_sync')
GL_UNSIGNALED = Enumerant('GL_UNSIGNALED', 0x9118, 'GL_ARB_sync')
GL_WAIT_FAILED = Enumerant('GL_WAIT_FAILED', 0x911d, 'GL_ARB_sync')

defines.add(GL_ALREADY_SIGNALED)
defines.add(GL_CONDITION_SATISFIED)
defines.add(GL_MAX_SERVER_WAIT_TIMEOUT)
defines.add(GL_OBJECT_TYPE)
defines.add(GL_SIGNALED)
defines.add(GL_SYNC_CONDITION)
defines.add(GL_SYNC_FENCE)
defines.add(GL_SYNC_FLAGS)
defines.add(GL_SYNC_FLUSH_COMMANDS_BIT)
defines.add(GL_SYNC_GPU_COMMANDS_COMPLETE)
defines.add(GL_SYNC_STATUS)
defines.add(GL_TIMEOUT_EXPIRED)
defines.add(GL_TIMEOUT_IGNORED)
defines.add(GL_UNSIGNALED)
defines.add(GL_WAIT_FAILED)

# GL_ARB_tessellation_shader

GL_FRACTIONAL_EVEN = Enumerant('GL_FRACTIONAL_EVEN', 0x8e7c, 'GL_ARB_tessellation_shader')
GL_FRACTIONAL_ODD = Enumerant('GL_FRACTIONAL_ODD', 0x8e7b, 'GL_ARB_tessellation_shader')
GL_ISOLINES = Enumerant('GL_ISOLINES', 0x8e7a, 'GL_ARB_tessellation_shader')
GL_MAX_COMBINED_TESS_CONTROL_UNIFORM_COMPONENTS = Enumerant('GL_MAX_COMBINED_TESS_CONTROL_UNIFORM_COMPONENTS', 0x8e1e, 'GL_ARB_tessellation_shader')
GL_MAX_COMBINED_TESS_EVALUATION_UNIFORM_COMPONENTS = Enumerant('GL_MAX_COMBINED_TESS_EVALUATION_UNIFORM_COMPONENTS', 0x8e1f, 'GL_ARB_tessellation_shader')
GL_MAX_PATCH_VERTICES = Enumerant('GL_MAX_PATCH_VERTICES', 0x8e7d, 'GL_ARB_tessellation_shader')
GL_MAX_TESS_CONTROL_INPUT_COMPONENTS = Enumerant('GL_MAX_TESS_CONTROL_INPUT_COMPONENTS', 0x886c, 'GL_ARB_tessellation_shader')
GL_MAX_TESS_CONTROL_OUTPUT_COMPONENTS = Enumerant('GL_MAX_TESS_CONTROL_OUTPUT_COMPONENTS', 0x8e83, 'GL_ARB_tessellation_shader')
GL_MAX_TESS_CONTROL_TEXTURE_IMAGE_UNITS = Enumerant('GL_MAX_TESS_CONTROL_TEXTURE_IMAGE_UNITS', 0x8e81, 'GL_ARB_tessellation_shader')
GL_MAX_TESS_CONTROL_TOTAL_OUTPUT_COMPONENTS = Enumerant('GL_MAX_TESS_CONTROL_TOTAL_OUTPUT_COMPONENTS', 0x8e85, 'GL_ARB_tessellation_shader')
GL_MAX_TESS_CONTROL_UNIFORM_BLOCKS = Enumerant('GL_MAX_TESS_CONTROL_UNIFORM_BLOCKS', 0x8e89, 'GL_ARB_tessellation_shader')
GL_MAX_TESS_CONTROL_UNIFORM_COMPONENTS = Enumerant('GL_MAX_TESS_CONTROL_UNIFORM_COMPONENTS', 0x8e7f, 'GL_ARB_tessellation_shader')
GL_MAX_TESS_EVALUATION_INPUT_COMPONENTS = Enumerant('GL_MAX_TESS_EVALUATION_INPUT_COMPONENTS', 0x886d, 'GL_ARB_tessellation_shader')
GL_MAX_TESS_EVALUATION_OUTPUT_COMPONENTS = Enumerant('GL_MAX_TESS_EVALUATION_OUTPUT_COMPONENTS', 0x8e86, 'GL_ARB_tessellation_shader')
GL_MAX_TESS_EVALUATION_TEXTURE_IMAGE_UNITS = Enumerant('GL_MAX_TESS_EVALUATION_TEXTURE_IMAGE_UNITS', 0x8e82, 'GL_ARB_tessellation_shader')
GL_MAX_TESS_EVALUATION_UNIFORM_BLOCKS = Enumerant('GL_MAX_TESS_EVALUATION_UNIFORM_BLOCKS', 0x8e8a, 'GL_ARB_tessellation_shader')
GL_MAX_TESS_EVALUATION_UNIFORM_COMPONENTS = Enumerant('GL_MAX_TESS_EVALUATION_UNIFORM_COMPONENTS', 0x8e80, 'GL_ARB_tessellation_shader')
GL_MAX_TESS_GEN_LEVEL = Enumerant('GL_MAX_TESS_GEN_LEVEL', 0x8e7e, 'GL_ARB_tessellation_shader')
GL_MAX_TESS_PATCH_COMPONENTS = Enumerant('GL_MAX_TESS_PATCH_COMPONENTS', 0x8e84, 'GL_ARB_tessellation_shader')
GL_PATCHES = Enumerant('GL_PATCHES', 0x000e, 'GL_ARB_tessellation_shader')
GL_PATCH_DEFAULT_INNER_LEVEL = Enumerant('GL_PATCH_DEFAULT_INNER_LEVEL', 0x8e73, 'GL_ARB_tessellation_shader')
GL_PATCH_DEFAULT_OUTER_LEVEL = Enumerant('GL_PATCH_DEFAULT_OUTER_LEVEL', 0x8e74, 'GL_ARB_tessellation_shader')
GL_PATCH_VERTICES = Enumerant('GL_PATCH_VERTICES', 0x8e72, 'GL_ARB_tessellation_shader')
GL_TESS_CONTROL_OUTPUT_VERTICES = Enumerant('GL_TESS_CONTROL_OUTPUT_VERTICES', 0x8e75, 'GL_ARB_tessellation_shader')
GL_TESS_CONTROL_SHADER = Enumerant('GL_TESS_CONTROL_SHADER', 0x8e88, 'GL_ARB_tessellation_shader')
GL_TESS_EVALUATION_SHADER = Enumerant('GL_TESS_EVALUATION_SHADER', 0x8e87, 'GL_ARB_tessellation_shader')
GL_TESS_GEN_MODE = Enumerant('GL_TESS_GEN_MODE', 0x8e76, 'GL_ARB_tessellation_shader')
GL_TESS_GEN_POINT_MODE = Enumerant('GL_TESS_GEN_POINT_MODE', 0x8e79, 'GL_ARB_tessellation_shader')
GL_TESS_GEN_SPACING = Enumerant('GL_TESS_GEN_SPACING', 0x8e77, 'GL_ARB_tessellation_shader')
GL_TESS_GEN_VERTEX_ORDER = Enumerant('GL_TESS_GEN_VERTEX_ORDER', 0x8e78, 'GL_ARB_tessellation_shader')
GL_UNIFORM_BLOCK_REFERENCED_BY_TESS_CONTROL_SHADER = Enumerant('GL_UNIFORM_BLOCK_REFERENCED_BY_TESS_CONTROL_SHADER', 0x84f0, 'GL_ARB_tessellation_shader')
GL_UNIFORM_BLOCK_REFERENCED_BY_TESS_EVALUATION_SHADER = Enumerant('GL_UNIFORM_BLOCK_REFERENCED_BY_TESS_EVALUATION_SHADER', 0x84f1, 'GL_ARB_tessellation_shader')

defines.add(GL_FRACTIONAL_EVEN)
defines.add(GL_FRACTIONAL_ODD)
defines.add(GL_ISOLINES)
defines.add(GL_MAX_COMBINED_TESS_CONTROL_UNIFORM_COMPONENTS)
defines.add(GL_MAX_COMBINED_TESS_EVALUATION_UNIFORM_COMPONENTS)
defines.add(GL_MAX_PATCH_VERTICES)
defines.add(GL_MAX_TESS_CONTROL_INPUT_COMPONENTS)
defines.add(GL_MAX_TESS_CONTROL_OUTPUT_COMPONENTS)
defines.add(GL_MAX_TESS_CONTROL_TEXTURE_IMAGE_UNITS)
defines.add(GL_MAX_TESS_CONTROL_TOTAL_OUTPUT_COMPONENTS)
defines.add(GL_MAX_TESS_CONTROL_UNIFORM_BLOCKS)
defines.add(GL_MAX_TESS_CONTROL_UNIFORM_COMPONENTS)
defines.add(GL_MAX_TESS_EVALUATION_INPUT_COMPONENTS)
defines.add(GL_MAX_TESS_EVALUATION_OUTPUT_COMPONENTS)
defines.add(GL_MAX_TESS_EVALUATION_TEXTURE_IMAGE_UNITS)
defines.add(GL_MAX_TESS_EVALUATION_UNIFORM_BLOCKS)
defines.add(GL_MAX_TESS_EVALUATION_UNIFORM_COMPONENTS)
defines.add(GL_MAX_TESS_GEN_LEVEL)
defines.add(GL_MAX_TESS_PATCH_COMPONENTS)
defines.add(GL_PATCHES)
defines.add(GL_PATCH_DEFAULT_INNER_LEVEL)
defines.add(GL_PATCH_DEFAULT_OUTER_LEVEL)
defines.add(GL_PATCH_VERTICES)
defines.add(GL_TESS_CONTROL_OUTPUT_VERTICES)
defines.add(GL_TESS_CONTROL_SHADER)
defines.add(GL_TESS_EVALUATION_SHADER)
defines.add(GL_TESS_GEN_MODE)
defines.add(GL_TESS_GEN_POINT_MODE)
defines.add(GL_TESS_GEN_SPACING)
defines.add(GL_TESS_GEN_VERTEX_ORDER)
defines.add(GL_UNIFORM_BLOCK_REFERENCED_BY_TESS_CONTROL_SHADER)
defines.add(GL_UNIFORM_BLOCK_REFERENCED_BY_TESS_EVALUATION_SHADER)

# GL_ARB_texture_border_clamp

GL_CLAMP_TO_BORDER_ARB = Enumerant('GL_CLAMP_TO_BORDER_ARB', 0x812d, 'GL_ARB_texture_border_clamp')

defines.add(GL_CLAMP_TO_BORDER_ARB)

# GL_ARB_texture_buffer_object

GL_MAX_TEXTURE_BUFFER_SIZE_ARB = Enumerant('GL_MAX_TEXTURE_BUFFER_SIZE_ARB', 0x8c2b, 'GL_ARB_texture_buffer_object')
GL_TEXTURE_BINDING_BUFFER_ARB = Enumerant('GL_TEXTURE_BINDING_BUFFER_ARB', 0x8c2c, 'GL_ARB_texture_buffer_object')
GL_TEXTURE_BUFFER_ARB = Enumerant('GL_TEXTURE_BUFFER_ARB', 0x8c2a, 'GL_ARB_texture_buffer_object')
GL_TEXTURE_BUFFER_DATA_STORE_BINDING_ARB = Enumerant('GL_TEXTURE_BUFFER_DATA_STORE_BINDING_ARB', 0x8c2d, 'GL_ARB_texture_buffer_object')
GL_TEXTURE_BUFFER_FORMAT_ARB = Enumerant('GL_TEXTURE_BUFFER_FORMAT_ARB', 0x8c2e, 'GL_ARB_texture_buffer_object')

defines.add(GL_MAX_TEXTURE_BUFFER_SIZE_ARB)
defines.add(GL_TEXTURE_BINDING_BUFFER_ARB)
defines.add(GL_TEXTURE_BUFFER_ARB)
defines.add(GL_TEXTURE_BUFFER_DATA_STORE_BINDING_ARB)
defines.add(GL_TEXTURE_BUFFER_FORMAT_ARB)

# GL_ARB_texture_buffer_range

GL_TEXTURE_BUFFER_OFFSET = Enumerant('GL_TEXTURE_BUFFER_OFFSET', 0x919d, 'GL_ARB_texture_buffer_range')
GL_TEXTURE_BUFFER_OFFSET_ALIGNMENT = Enumerant('GL_TEXTURE_BUFFER_OFFSET_ALIGNMENT', 0x919f, 'GL_ARB_texture_buffer_range')
GL_TEXTURE_BUFFER_SIZE = Enumerant('GL_TEXTURE_BUFFER_SIZE', 0x919e, 'GL_ARB_texture_buffer_range')

defines.add(GL_TEXTURE_BUFFER_OFFSET)
defines.add(GL_TEXTURE_BUFFER_OFFSET_ALIGNMENT)
defines.add(GL_TEXTURE_BUFFER_SIZE)

# GL_ARB_texture_compression

GL_COMPRESSED_ALPHA_ARB = Enumerant('GL_COMPRESSED_ALPHA_ARB', 0x84e9, 'GL_ARB_texture_compression')
GL_COMPRESSED_INTENSITY_ARB = Enumerant('GL_COMPRESSED_INTENSITY_ARB', 0x84ec, 'GL_ARB_texture_compression')
GL_COMPRESSED_LUMINANCE_ALPHA_ARB = Enumerant('GL_COMPRESSED_LUMINANCE_ALPHA_ARB', 0x84eb, 'GL_ARB_texture_compression')
GL_COMPRESSED_LUMINANCE_ARB = Enumerant('GL_COMPRESSED_LUMINANCE_ARB', 0x84ea, 'GL_ARB_texture_compression')
GL_COMPRESSED_RGBA_ARB = Enumerant('GL_COMPRESSED_RGBA_ARB', 0x84ee, 'GL_ARB_texture_compression')
GL_COMPRESSED_RGB_ARB = Enumerant('GL_COMPRESSED_RGB_ARB', 0x84ed, 'GL_ARB_texture_compression')
GL_COMPRESSED_TEXTURE_FORMATS_ARB = Enumerant('GL_COMPRESSED_TEXTURE_FORMATS_ARB', 0x86a3, 'GL_ARB_texture_compression')
GL_NUM_COMPRESSED_TEXTURE_FORMATS_ARB = Enumerant('GL_NUM_COMPRESSED_TEXTURE_FORMATS_ARB', 0x86a2, 'GL_ARB_texture_compression')
GL_TEXTURE_COMPRESSED_ARB = Enumerant('GL_TEXTURE_COMPRESSED_ARB', 0x86a1, 'GL_ARB_texture_compression')
GL_TEXTURE_COMPRESSED_IMAGE_SIZE_ARB = Enumerant('GL_TEXTURE_COMPRESSED_IMAGE_SIZE_ARB', 0x86a0, 'GL_ARB_texture_compression')
GL_TEXTURE_COMPRESSION_HINT_ARB = Enumerant('GL_TEXTURE_COMPRESSION_HINT_ARB', 0x84ef, 'GL_ARB_texture_compression')

defines.add(GL_COMPRESSED_ALPHA_ARB)
defines.add(GL_COMPRESSED_INTENSITY_ARB)
defines.add(GL_COMPRESSED_LUMINANCE_ALPHA_ARB)
defines.add(GL_COMPRESSED_LUMINANCE_ARB)
defines.add(GL_COMPRESSED_RGBA_ARB)
defines.add(GL_COMPRESSED_RGB_ARB)
defines.add(GL_COMPRESSED_TEXTURE_FORMATS_ARB)
defines.add(GL_NUM_COMPRESSED_TEXTURE_FORMATS_ARB)
defines.add(GL_TEXTURE_COMPRESSED_ARB)
defines.add(GL_TEXTURE_COMPRESSED_IMAGE_SIZE_ARB)
defines.add(GL_TEXTURE_COMPRESSION_HINT_ARB)

# GL_ARB_texture_compression_bptc

GL_COMPRESSED_RGBA_BPTC_UNORM_ARB = Enumerant('GL_COMPRESSED_RGBA_BPTC_UNORM_ARB', 0x8e8c, 'GL_ARB_texture_compression_bptc')
GL_COMPRESSED_RGB_BPTC_SIGNED_FLOAT_ARB = Enumerant('GL_COMPRESSED_RGB_BPTC_SIGNED_FLOAT_ARB', 0x8e8e, 'GL_ARB_texture_compression_bptc')
GL_COMPRESSED_RGB_BPTC_UNSIGNED_FLOAT_ARB = Enumerant('GL_COMPRESSED_RGB_BPTC_UNSIGNED_FLOAT_ARB', 0x8e8f, 'GL_ARB_texture_compression_bptc')
GL_COMPRESSED_SRGB_ALPHA_BPTC_UNORM_ARB = Enumerant('GL_COMPRESSED_SRGB_ALPHA_BPTC_UNORM_ARB', 0x8e8d, 'GL_ARB_texture_compression_bptc')

defines.add(GL_COMPRESSED_RGBA_BPTC_UNORM_ARB)
defines.add(GL_COMPRESSED_RGB_BPTC_SIGNED_FLOAT_ARB)
defines.add(GL_COMPRESSED_RGB_BPTC_UNSIGNED_FLOAT_ARB)
defines.add(GL_COMPRESSED_SRGB_ALPHA_BPTC_UNORM_ARB)

# GL_ARB_texture_compression_rgtc

GL_COMPRESSED_RED_RGTC1 = Enumerant('GL_COMPRESSED_RED_RGTC1', 0x8dbb, 'GL_ARB_texture_compression_rgtc')
GL_COMPRESSED_RG_RGTC2 = Enumerant('GL_COMPRESSED_RG_RGTC2', 0x8dbd, 'GL_ARB_texture_compression_rgtc')
GL_COMPRESSED_SIGNED_RED_RGTC1 = Enumerant('GL_COMPRESSED_SIGNED_RED_RGTC1', 0x8dbc, 'GL_ARB_texture_compression_rgtc')
GL_COMPRESSED_SIGNED_RG_RGTC2 = Enumerant('GL_COMPRESSED_SIGNED_RG_RGTC2', 0x8dbe, 'GL_ARB_texture_compression_rgtc')

defines.add(GL_COMPRESSED_RED_RGTC1)
defines.add(GL_COMPRESSED_RG_RGTC2)
defines.add(GL_COMPRESSED_SIGNED_RED_RGTC1)
defines.add(GL_COMPRESSED_SIGNED_RG_RGTC2)

# GL_ARB_texture_cube_map

GL_MAX_CUBE_MAP_TEXTURE_SIZE_ARB = Enumerant('GL_MAX_CUBE_MAP_TEXTURE_SIZE_ARB', 0x851c, 'GL_ARB_texture_cube_map')
GL_NORMAL_MAP_ARB = Enumerant('GL_NORMAL_MAP_ARB', 0x8511, 'GL_ARB_texture_cube_map')
GL_PROXY_TEXTURE_CUBE_MAP_ARB = Enumerant('GL_PROXY_TEXTURE_CUBE_MAP_ARB', 0x851b, 'GL_ARB_texture_cube_map')
GL_REFLECTION_MAP_ARB = Enumerant('GL_REFLECTION_MAP_ARB', 0x8512, 'GL_ARB_texture_cube_map')
GL_TEXTURE_BINDING_CUBE_MAP_ARB = Enumerant('GL_TEXTURE_BINDING_CUBE_MAP_ARB', 0x8514, 'GL_ARB_texture_cube_map')
GL_TEXTURE_CUBE_MAP_ARB = Enumerant('GL_TEXTURE_CUBE_MAP_ARB', 0x8513, 'GL_ARB_texture_cube_map')
GL_TEXTURE_CUBE_MAP_NEGATIVE_X_ARB = Enumerant('GL_TEXTURE_CUBE_MAP_NEGATIVE_X_ARB', 0x8516, 'GL_ARB_texture_cube_map')
GL_TEXTURE_CUBE_MAP_NEGATIVE_Y_ARB = Enumerant('GL_TEXTURE_CUBE_MAP_NEGATIVE_Y_ARB', 0x8518, 'GL_ARB_texture_cube_map')
GL_TEXTURE_CUBE_MAP_NEGATIVE_Z_ARB = Enumerant('GL_TEXTURE_CUBE_MAP_NEGATIVE_Z_ARB', 0x851a, 'GL_ARB_texture_cube_map')
GL_TEXTURE_CUBE_MAP_POSITIVE_X_ARB = Enumerant('GL_TEXTURE_CUBE_MAP_POSITIVE_X_ARB', 0x8515, 'GL_ARB_texture_cube_map')
GL_TEXTURE_CUBE_MAP_POSITIVE_Y_ARB = Enumerant('GL_TEXTURE_CUBE_MAP_POSITIVE_Y_ARB', 0x8517, 'GL_ARB_texture_cube_map')
GL_TEXTURE_CUBE_MAP_POSITIVE_Z_ARB = Enumerant('GL_TEXTURE_CUBE_MAP_POSITIVE_Z_ARB', 0x8519, 'GL_ARB_texture_cube_map')

defines.add(GL_MAX_CUBE_MAP_TEXTURE_SIZE_ARB)
defines.add(GL_NORMAL_MAP_ARB)
defines.add(GL_PROXY_TEXTURE_CUBE_MAP_ARB)
defines.add(GL_REFLECTION_MAP_ARB)
defines.add(GL_TEXTURE_BINDING_CUBE_MAP_ARB)
defines.add(GL_TEXTURE_CUBE_MAP_ARB)
defines.add(GL_TEXTURE_CUBE_MAP_NEGATIVE_X_ARB)
defines.add(GL_TEXTURE_CUBE_MAP_NEGATIVE_Y_ARB)
defines.add(GL_TEXTURE_CUBE_MAP_NEGATIVE_Z_ARB)
defines.add(GL_TEXTURE_CUBE_MAP_POSITIVE_X_ARB)
defines.add(GL_TEXTURE_CUBE_MAP_POSITIVE_Y_ARB)
defines.add(GL_TEXTURE_CUBE_MAP_POSITIVE_Z_ARB)

# GL_ARB_texture_cube_map_array

GL_INT_SAMPLER_CUBE_MAP_ARRAY_ARB = Enumerant('GL_INT_SAMPLER_CUBE_MAP_ARRAY_ARB', 0x900e, 'GL_ARB_texture_cube_map_array')
GL_PROXY_TEXTURE_CUBE_MAP_ARRAY_ARB = Enumerant('GL_PROXY_TEXTURE_CUBE_MAP_ARRAY_ARB', 0x900b, 'GL_ARB_texture_cube_map_array')
GL_SAMPLER_CUBE_MAP_ARRAY_ARB = Enumerant('GL_SAMPLER_CUBE_MAP_ARRAY_ARB', 0x900c, 'GL_ARB_texture_cube_map_array')
GL_SAMPLER_CUBE_MAP_ARRAY_SHADOW_ARB = Enumerant('GL_SAMPLER_CUBE_MAP_ARRAY_SHADOW_ARB', 0x900d, 'GL_ARB_texture_cube_map_array')
GL_TEXTURE_BINDING_CUBE_MAP_ARRAY_ARB = Enumerant('GL_TEXTURE_BINDING_CUBE_MAP_ARRAY_ARB', 0x900a, 'GL_ARB_texture_cube_map_array')
GL_TEXTURE_CUBE_MAP_ARRAY_ARB = Enumerant('GL_TEXTURE_CUBE_MAP_ARRAY_ARB', 0x9009, 'GL_ARB_texture_cube_map_array')
GL_UNSIGNED_INT_SAMPLER_CUBE_MAP_ARRAY_ARB = Enumerant('GL_UNSIGNED_INT_SAMPLER_CUBE_MAP_ARRAY_ARB', 0x900f, 'GL_ARB_texture_cube_map_array')

defines.add(GL_INT_SAMPLER_CUBE_MAP_ARRAY_ARB)
defines.add(GL_PROXY_TEXTURE_CUBE_MAP_ARRAY_ARB)
defines.add(GL_SAMPLER_CUBE_MAP_ARRAY_ARB)
defines.add(GL_SAMPLER_CUBE_MAP_ARRAY_SHADOW_ARB)
defines.add(GL_TEXTURE_BINDING_CUBE_MAP_ARRAY_ARB)
defines.add(GL_TEXTURE_CUBE_MAP_ARRAY_ARB)
defines.add(GL_UNSIGNED_INT_SAMPLER_CUBE_MAP_ARRAY_ARB)

# GL_ARB_texture_env_combine

GL_ADD_SIGNED_ARB = Enumerant('GL_ADD_SIGNED_ARB', 0x8574, 'GL_ARB_texture_env_combine')
GL_COMBINE_ALPHA_ARB = Enumerant('GL_COMBINE_ALPHA_ARB', 0x8572, 'GL_ARB_texture_env_combine')
GL_COMBINE_ARB = Enumerant('GL_COMBINE_ARB', 0x8570, 'GL_ARB_texture_env_combine')
GL_COMBINE_RGB_ARB = Enumerant('GL_COMBINE_RGB_ARB', 0x8571, 'GL_ARB_texture_env_combine')
GL_CONSTANT_ARB = Enumerant('GL_CONSTANT_ARB', 0x8576, 'GL_ARB_texture_env_combine')
GL_INTERPOLATE_ARB = Enumerant('GL_INTERPOLATE_ARB', 0x8575, 'GL_ARB_texture_env_combine')
GL_OPERAND0_ALPHA_ARB = Enumerant('GL_OPERAND0_ALPHA_ARB', 0x8598, 'GL_ARB_texture_env_combine')
GL_OPERAND0_RGB_ARB = Enumerant('GL_OPERAND0_RGB_ARB', 0x8590, 'GL_ARB_texture_env_combine')
GL_OPERAND1_ALPHA_ARB = Enumerant('GL_OPERAND1_ALPHA_ARB', 0x8599, 'GL_ARB_texture_env_combine')
GL_OPERAND1_RGB_ARB = Enumerant('GL_OPERAND1_RGB_ARB', 0x8591, 'GL_ARB_texture_env_combine')
GL_OPERAND2_ALPHA_ARB = Enumerant('GL_OPERAND2_ALPHA_ARB', 0x859a, 'GL_ARB_texture_env_combine')
GL_OPERAND2_RGB_ARB = Enumerant('GL_OPERAND2_RGB_ARB', 0x8592, 'GL_ARB_texture_env_combine')
GL_PREVIOUS_ARB = Enumerant('GL_PREVIOUS_ARB', 0x8578, 'GL_ARB_texture_env_combine')
GL_PRIMARY_COLOR_ARB = Enumerant('GL_PRIMARY_COLOR_ARB', 0x8577, 'GL_ARB_texture_env_combine')
GL_RGB_SCALE_ARB = Enumerant('GL_RGB_SCALE_ARB', 0x8573, 'GL_ARB_texture_env_combine')
GL_SOURCE0_ALPHA_ARB = Enumerant('GL_SOURCE0_ALPHA_ARB', 0x8588, 'GL_ARB_texture_env_combine')
GL_SOURCE0_RGB_ARB = Enumerant('GL_SOURCE0_RGB_ARB', 0x8580, 'GL_ARB_texture_env_combine')
GL_SOURCE1_ALPHA_ARB = Enumerant('GL_SOURCE1_ALPHA_ARB', 0x8589, 'GL_ARB_texture_env_combine')
GL_SOURCE1_RGB_ARB = Enumerant('GL_SOURCE1_RGB_ARB', 0x8581, 'GL_ARB_texture_env_combine')
GL_SOURCE2_ALPHA_ARB = Enumerant('GL_SOURCE2_ALPHA_ARB', 0x858a, 'GL_ARB_texture_env_combine')
GL_SOURCE2_RGB_ARB = Enumerant('GL_SOURCE2_RGB_ARB', 0x8582, 'GL_ARB_texture_env_combine')
GL_SUBTRACT_ARB = Enumerant('GL_SUBTRACT_ARB', 0x84e7, 'GL_ARB_texture_env_combine')

defines.add(GL_ADD_SIGNED_ARB)
defines.add(GL_COMBINE_ALPHA_ARB)
defines.add(GL_COMBINE_ARB)
defines.add(GL_COMBINE_RGB_ARB)
defines.add(GL_CONSTANT_ARB)
defines.add(GL_INTERPOLATE_ARB)
defines.add(GL_OPERAND0_ALPHA_ARB)
defines.add(GL_OPERAND0_RGB_ARB)
defines.add(GL_OPERAND1_ALPHA_ARB)
defines.add(GL_OPERAND1_RGB_ARB)
defines.add(GL_OPERAND2_ALPHA_ARB)
defines.add(GL_OPERAND2_RGB_ARB)
defines.add(GL_PREVIOUS_ARB)
defines.add(GL_PRIMARY_COLOR_ARB)
defines.add(GL_RGB_SCALE_ARB)
defines.add(GL_SOURCE0_ALPHA_ARB)
defines.add(GL_SOURCE0_RGB_ARB)
defines.add(GL_SOURCE1_ALPHA_ARB)
defines.add(GL_SOURCE1_RGB_ARB)
defines.add(GL_SOURCE2_ALPHA_ARB)
defines.add(GL_SOURCE2_RGB_ARB)
defines.add(GL_SUBTRACT_ARB)

# GL_ARB_texture_env_dot3

GL_DOT3_RGBA_ARB = Enumerant('GL_DOT3_RGBA_ARB', 0x86af, 'GL_ARB_texture_env_dot3')
GL_DOT3_RGB_ARB = Enumerant('GL_DOT3_RGB_ARB', 0x86ae, 'GL_ARB_texture_env_dot3')

defines.add(GL_DOT3_RGBA_ARB)
defines.add(GL_DOT3_RGB_ARB)

# GL_ARB_texture_float

GL_ALPHA16F_ARB = Enumerant('GL_ALPHA16F_ARB', 0x881c, 'GL_ARB_texture_float')
GL_ALPHA32F_ARB = Enumerant('GL_ALPHA32F_ARB', 0x8816, 'GL_ARB_texture_float')
GL_INTENSITY16F_ARB = Enumerant('GL_INTENSITY16F_ARB', 0x881d, 'GL_ARB_texture_float')
GL_INTENSITY32F_ARB = Enumerant('GL_INTENSITY32F_ARB', 0x8817, 'GL_ARB_texture_float')
GL_LUMINANCE16F_ARB = Enumerant('GL_LUMINANCE16F_ARB', 0x881e, 'GL_ARB_texture_float')
GL_LUMINANCE32F_ARB = Enumerant('GL_LUMINANCE32F_ARB', 0x8818, 'GL_ARB_texture_float')
GL_LUMINANCE_ALPHA16F_ARB = Enumerant('GL_LUMINANCE_ALPHA16F_ARB', 0x881f, 'GL_ARB_texture_float')
GL_LUMINANCE_ALPHA32F_ARB = Enumerant('GL_LUMINANCE_ALPHA32F_ARB', 0x8819, 'GL_ARB_texture_float')
GL_RGB16F_ARB = Enumerant('GL_RGB16F_ARB', 0x881b, 'GL_ARB_texture_float')
GL_RGB32F_ARB = Enumerant('GL_RGB32F_ARB', 0x8815, 'GL_ARB_texture_float')
GL_RGBA16F_ARB = Enumerant('GL_RGBA16F_ARB', 0x881a, 'GL_ARB_texture_float')
GL_RGBA32F_ARB = Enumerant('GL_RGBA32F_ARB', 0x8814, 'GL_ARB_texture_float')
GL_TEXTURE_ALPHA_TYPE_ARB = Enumerant('GL_TEXTURE_ALPHA_TYPE_ARB', 0x8c13, 'GL_ARB_texture_float')
GL_TEXTURE_BLUE_TYPE_ARB = Enumerant('GL_TEXTURE_BLUE_TYPE_ARB', 0x8c12, 'GL_ARB_texture_float')
GL_TEXTURE_DEPTH_TYPE_ARB = Enumerant('GL_TEXTURE_DEPTH_TYPE_ARB', 0x8c16, 'GL_ARB_texture_float')
GL_TEXTURE_GREEN_TYPE_ARB = Enumerant('GL_TEXTURE_GREEN_TYPE_ARB', 0x8c11, 'GL_ARB_texture_float')
GL_TEXTURE_INTENSITY_TYPE_ARB = Enumerant('GL_TEXTURE_INTENSITY_TYPE_ARB', 0x8c15, 'GL_ARB_texture_float')
GL_TEXTURE_LUMINANCE_TYPE_ARB = Enumerant('GL_TEXTURE_LUMINANCE_TYPE_ARB', 0x8c14, 'GL_ARB_texture_float')
GL_TEXTURE_RED_TYPE_ARB = Enumerant('GL_TEXTURE_RED_TYPE_ARB', 0x8c10, 'GL_ARB_texture_float')
GL_UNSIGNED_NORMALIZED_ARB = Enumerant('GL_UNSIGNED_NORMALIZED_ARB', 0x8c17, 'GL_ARB_texture_float')

defines.add(GL_ALPHA16F_ARB)
defines.add(GL_ALPHA32F_ARB)
defines.add(GL_INTENSITY16F_ARB)
defines.add(GL_INTENSITY32F_ARB)
defines.add(GL_LUMINANCE16F_ARB)
defines.add(GL_LUMINANCE32F_ARB)
defines.add(GL_LUMINANCE_ALPHA16F_ARB)
defines.add(GL_LUMINANCE_ALPHA32F_ARB)
defines.add(GL_RGB16F_ARB)
defines.add(GL_RGB32F_ARB)
defines.add(GL_RGBA16F_ARB)
defines.add(GL_RGBA32F_ARB)
defines.add(GL_TEXTURE_ALPHA_TYPE_ARB)
defines.add(GL_TEXTURE_BLUE_TYPE_ARB)
defines.add(GL_TEXTURE_DEPTH_TYPE_ARB)
defines.add(GL_TEXTURE_GREEN_TYPE_ARB)
defines.add(GL_TEXTURE_INTENSITY_TYPE_ARB)
defines.add(GL_TEXTURE_LUMINANCE_TYPE_ARB)
defines.add(GL_TEXTURE_RED_TYPE_ARB)
defines.add(GL_UNSIGNED_NORMALIZED_ARB)

# GL_ARB_texture_gather

GL_MAX_PROGRAM_TEXTURE_GATHER_COMPONENTS_ARB = Enumerant('GL_MAX_PROGRAM_TEXTURE_GATHER_COMPONENTS_ARB', 0x8f9f, 'GL_ARB_texture_gather')
GL_MAX_PROGRAM_TEXTURE_GATHER_OFFSET_ARB = Enumerant('GL_MAX_PROGRAM_TEXTURE_GATHER_OFFSET_ARB', 0x8e5f, 'GL_ARB_texture_gather')
GL_MIN_PROGRAM_TEXTURE_GATHER_OFFSET_ARB = Enumerant('GL_MIN_PROGRAM_TEXTURE_GATHER_OFFSET_ARB', 0x8e5e, 'GL_ARB_texture_gather')

defines.add(GL_MAX_PROGRAM_TEXTURE_GATHER_COMPONENTS_ARB)
defines.add(GL_MAX_PROGRAM_TEXTURE_GATHER_OFFSET_ARB)
defines.add(GL_MIN_PROGRAM_TEXTURE_GATHER_OFFSET_ARB)

# GL_ARB_texture_mirror_clamp_to_edge

GL_MIRROR_CLAMP_TO_EDGE = Enumerant('GL_MIRROR_CLAMP_TO_EDGE', 0x8743, 'GL_ARB_texture_mirror_clamp_to_edge')

defines.add(GL_MIRROR_CLAMP_TO_EDGE)

# GL_ARB_texture_mirrored_repeat

GL_MIRRORED_REPEAT_ARB = Enumerant('GL_MIRRORED_REPEAT_ARB', 0x8370, 'GL_ARB_texture_mirrored_repeat')

defines.add(GL_MIRRORED_REPEAT_ARB)

# GL_ARB_texture_multisample

GL_INT_SAMPLER_2D_MULTISAMPLE = Enumerant('GL_INT_SAMPLER_2D_MULTISAMPLE', 0x9109, 'GL_ARB_texture_multisample')
GL_INT_SAMPLER_2D_MULTISAMPLE_ARRAY = Enumerant('GL_INT_SAMPLER_2D_MULTISAMPLE_ARRAY', 0x910c, 'GL_ARB_texture_multisample')
GL_MAX_COLOR_TEXTURE_SAMPLES = Enumerant('GL_MAX_COLOR_TEXTURE_SAMPLES', 0x910e, 'GL_ARB_texture_multisample')
GL_MAX_DEPTH_TEXTURE_SAMPLES = Enumerant('GL_MAX_DEPTH_TEXTURE_SAMPLES', 0x910f, 'GL_ARB_texture_multisample')
GL_MAX_INTEGER_SAMPLES = Enumerant('GL_MAX_INTEGER_SAMPLES', 0x9110, 'GL_ARB_texture_multisample')
GL_MAX_SAMPLE_MASK_WORDS = Enumerant('GL_MAX_SAMPLE_MASK_WORDS', 0x8e59, 'GL_ARB_texture_multisample')
GL_PROXY_TEXTURE_2D_MULTISAMPLE = Enumerant('GL_PROXY_TEXTURE_2D_MULTISAMPLE', 0x9101, 'GL_ARB_texture_multisample')
GL_PROXY_TEXTURE_2D_MULTISAMPLE_ARRAY = Enumerant('GL_PROXY_TEXTURE_2D_MULTISAMPLE_ARRAY', 0x9103, 'GL_ARB_texture_multisample')
GL_SAMPLER_2D_MULTISAMPLE = Enumerant('GL_SAMPLER_2D_MULTISAMPLE', 0x9108, 'GL_ARB_texture_multisample')
GL_SAMPLER_2D_MULTISAMPLE_ARRAY = Enumerant('GL_SAMPLER_2D_MULTISAMPLE_ARRAY', 0x910b, 'GL_ARB_texture_multisample')
GL_SAMPLE_MASK = Enumerant('GL_SAMPLE_MASK', 0x8e51, 'GL_ARB_texture_multisample')
GL_SAMPLE_MASK.enableCap = True
GL_SAMPLE_MASK_VALUE = Enumerant('GL_SAMPLE_MASK_VALUE', 0x8e52, 'GL_ARB_texture_multisample')
GL_SAMPLE_POSITION = Enumerant('GL_SAMPLE_POSITION', 0x8e50, 'GL_ARB_texture_multisample')
GL_TEXTURE_2D_MULTISAMPLE = Enumerant('GL_TEXTURE_2D_MULTISAMPLE', 0x9100, 'GL_ARB_texture_multisample')
GL_TEXTURE_2D_MULTISAMPLE_ARRAY = Enumerant('GL_TEXTURE_2D_MULTISAMPLE_ARRAY', 0x9102, 'GL_ARB_texture_multisample')
GL_TEXTURE_BINDING_2D_MULTISAMPLE = Enumerant('GL_TEXTURE_BINDING_2D_MULTISAMPLE', 0x9104, 'GL_ARB_texture_multisample')
GL_TEXTURE_BINDING_2D_MULTISAMPLE_ARRAY = Enumerant('GL_TEXTURE_BINDING_2D_MULTISAMPLE_ARRAY', 0x9105, 'GL_ARB_texture_multisample')
GL_TEXTURE_FIXED_SAMPLE_LOCATIONS = Enumerant('GL_TEXTURE_FIXED_SAMPLE_LOCATIONS', 0x9107, 'GL_ARB_texture_multisample')
GL_TEXTURE_SAMPLES = Enumerant('GL_TEXTURE_SAMPLES', 0x9106, 'GL_ARB_texture_multisample')
GL_UNSIGNED_INT_SAMPLER_2D_MULTISAMPLE = Enumerant('GL_UNSIGNED_INT_SAMPLER_2D_MULTISAMPLE', 0x910a, 'GL_ARB_texture_multisample')
GL_UNSIGNED_INT_SAMPLER_2D_MULTISAMPLE_ARRAY = Enumerant('GL_UNSIGNED_INT_SAMPLER_2D_MULTISAMPLE_ARRAY', 0x910d, 'GL_ARB_texture_multisample')

defines.add(GL_INT_SAMPLER_2D_MULTISAMPLE)
defines.add(GL_INT_SAMPLER_2D_MULTISAMPLE_ARRAY)
defines.add(GL_MAX_COLOR_TEXTURE_SAMPLES)
defines.add(GL_MAX_DEPTH_TEXTURE_SAMPLES)
defines.add(GL_MAX_INTEGER_SAMPLES)
defines.add(GL_MAX_SAMPLE_MASK_WORDS)
defines.add(GL_PROXY_TEXTURE_2D_MULTISAMPLE)
defines.add(GL_PROXY_TEXTURE_2D_MULTISAMPLE_ARRAY)
defines.add(GL_SAMPLER_2D_MULTISAMPLE)
defines.add(GL_SAMPLER_2D_MULTISAMPLE_ARRAY)
defines.add(GL_SAMPLE_MASK)
defines.add(GL_SAMPLE_MASK_VALUE)
defines.add(GL_SAMPLE_POSITION)
defines.add(GL_TEXTURE_2D_MULTISAMPLE)
defines.add(GL_TEXTURE_2D_MULTISAMPLE_ARRAY)
defines.add(GL_TEXTURE_BINDING_2D_MULTISAMPLE)
defines.add(GL_TEXTURE_BINDING_2D_MULTISAMPLE_ARRAY)
defines.add(GL_TEXTURE_FIXED_SAMPLE_LOCATIONS)
defines.add(GL_TEXTURE_SAMPLES)
defines.add(GL_UNSIGNED_INT_SAMPLER_2D_MULTISAMPLE)
defines.add(GL_UNSIGNED_INT_SAMPLER_2D_MULTISAMPLE_ARRAY)

# GL_ARB_texture_rectangle

GL_MAX_RECTANGLE_TEXTURE_SIZE_ARB = Enumerant('GL_MAX_RECTANGLE_TEXTURE_SIZE_ARB', 0x84f8, 'GL_ARB_texture_rectangle')
GL_PROXY_TEXTURE_RECTANGLE_ARB = Enumerant('GL_PROXY_TEXTURE_RECTANGLE_ARB', 0x84f7, 'GL_ARB_texture_rectangle')
GL_TEXTURE_BINDING_RECTANGLE_ARB = Enumerant('GL_TEXTURE_BINDING_RECTANGLE_ARB', 0x84f6, 'GL_ARB_texture_rectangle')
GL_TEXTURE_RECTANGLE_ARB = Enumerant('GL_TEXTURE_RECTANGLE_ARB', 0x84f5, 'GL_ARB_texture_rectangle')

defines.add(GL_MAX_RECTANGLE_TEXTURE_SIZE_ARB)
defines.add(GL_PROXY_TEXTURE_RECTANGLE_ARB)
defines.add(GL_TEXTURE_BINDING_RECTANGLE_ARB)
defines.add(GL_TEXTURE_RECTANGLE_ARB)

# GL_ARB_texture_rg

GL_COMPRESSED_RED = Enumerant('GL_COMPRESSED_RED', 0x8225, 'GL_ARB_texture_rg')
GL_COMPRESSED_RG = Enumerant('GL_COMPRESSED_RG', 0x8226, 'GL_ARB_texture_rg')
GL_R16 = Enumerant('GL_R16', 0x822a, 'GL_ARB_texture_rg')
GL_R16F = Enumerant('GL_R16F', 0x822d, 'GL_ARB_texture_rg')
GL_R16I = Enumerant('GL_R16I', 0x8233, 'GL_ARB_texture_rg')
GL_R16UI = Enumerant('GL_R16UI', 0x8234, 'GL_ARB_texture_rg')
GL_R32F = Enumerant('GL_R32F', 0x822e, 'GL_ARB_texture_rg')
GL_R32I = Enumerant('GL_R32I', 0x8235, 'GL_ARB_texture_rg')
GL_R32UI = Enumerant('GL_R32UI', 0x8236, 'GL_ARB_texture_rg')
GL_R8 = Enumerant('GL_R8', 0x8229, 'GL_ARB_texture_rg')
GL_R8I = Enumerant('GL_R8I', 0x8231, 'GL_ARB_texture_rg')
GL_R8UI = Enumerant('GL_R8UI', 0x8232, 'GL_ARB_texture_rg')
GL_RG = Enumerant('GL_RG', 0x8227, 'GL_ARB_texture_rg')
GL_RG16 = Enumerant('GL_RG16', 0x822c, 'GL_ARB_texture_rg')
GL_RG16F = Enumerant('GL_RG16F', 0x822f, 'GL_ARB_texture_rg')
GL_RG16I = Enumerant('GL_RG16I', 0x8239, 'GL_ARB_texture_rg')
GL_RG16UI = Enumerant('GL_RG16UI', 0x823a, 'GL_ARB_texture_rg')
GL_RG32F = Enumerant('GL_RG32F', 0x8230, 'GL_ARB_texture_rg')
GL_RG32I = Enumerant('GL_RG32I', 0x823b, 'GL_ARB_texture_rg')
GL_RG32UI = Enumerant('GL_RG32UI', 0x823c, 'GL_ARB_texture_rg')
GL_RG8 = Enumerant('GL_RG8', 0x822b, 'GL_ARB_texture_rg')
GL_RG8I = Enumerant('GL_RG8I', 0x8237, 'GL_ARB_texture_rg')
GL_RG8UI = Enumerant('GL_RG8UI', 0x8238, 'GL_ARB_texture_rg')
GL_RG_INTEGER = Enumerant('GL_RG_INTEGER', 0x8228, 'GL_ARB_texture_rg')

defines.add(GL_COMPRESSED_RED)
defines.add(GL_COMPRESSED_RG)
defines.add(GL_R16)
defines.add(GL_R16F)
defines.add(GL_R16I)
defines.add(GL_R16UI)
defines.add(GL_R32F)
defines.add(GL_R32I)
defines.add(GL_R32UI)
defines.add(GL_R8)
defines.add(GL_R8I)
defines.add(GL_R8UI)
defines.add(GL_RG)
defines.add(GL_RG16)
defines.add(GL_RG16F)
defines.add(GL_RG16I)
defines.add(GL_RG16UI)
defines.add(GL_RG32F)
defines.add(GL_RG32I)
defines.add(GL_RG32UI)
defines.add(GL_RG8)
defines.add(GL_RG8I)
defines.add(GL_RG8UI)
defines.add(GL_RG_INTEGER)

# GL_ARB_texture_rgb10_a2ui

GL_RGB10_A2UI = Enumerant('GL_RGB10_A2UI', 0x906f, 'GL_ARB_texture_rgb10_a2ui')

defines.add(GL_RGB10_A2UI)

# GL_ARB_texture_storage

GL_TEXTURE_IMMUTABLE_FORMAT = Enumerant('GL_TEXTURE_IMMUTABLE_FORMAT', 0x912f, 'GL_ARB_texture_storage')

defines.add(GL_TEXTURE_IMMUTABLE_FORMAT)

# GL_ARB_texture_swizzle

GL_TEXTURE_SWIZZLE_A = Enumerant('GL_TEXTURE_SWIZZLE_A', 0x8e45, 'GL_ARB_texture_swizzle')
GL_TEXTURE_SWIZZLE_B = Enumerant('GL_TEXTURE_SWIZZLE_B', 0x8e44, 'GL_ARB_texture_swizzle')
GL_TEXTURE_SWIZZLE_G = Enumerant('GL_TEXTURE_SWIZZLE_G', 0x8e43, 'GL_ARB_texture_swizzle')
GL_TEXTURE_SWIZZLE_R = Enumerant('GL_TEXTURE_SWIZZLE_R', 0x8e42, 'GL_ARB_texture_swizzle')
GL_TEXTURE_SWIZZLE_RGBA = Enumerant('GL_TEXTURE_SWIZZLE_RGBA', 0x8e46, 'GL_ARB_texture_swizzle')

defines.add(GL_TEXTURE_SWIZZLE_A)
defines.add(GL_TEXTURE_SWIZZLE_B)
defines.add(GL_TEXTURE_SWIZZLE_G)
defines.add(GL_TEXTURE_SWIZZLE_R)
defines.add(GL_TEXTURE_SWIZZLE_RGBA)

# GL_ARB_texture_view

GL_TEXTURE_IMMUTABLE_LEVELS = Enumerant('GL_TEXTURE_IMMUTABLE_LEVELS', 0x82df, 'GL_ARB_texture_view')
GL_TEXTURE_VIEW_MIN_LAYER = Enumerant('GL_TEXTURE_VIEW_MIN_LAYER', 0x82dd, 'GL_ARB_texture_view')
GL_TEXTURE_VIEW_MIN_LEVEL = Enumerant('GL_TEXTURE_VIEW_MIN_LEVEL', 0x82db, 'GL_ARB_texture_view')
GL_TEXTURE_VIEW_NUM_LAYERS = Enumerant('GL_TEXTURE_VIEW_NUM_LAYERS', 0x82de, 'GL_ARB_texture_view')
GL_TEXTURE_VIEW_NUM_LEVELS = Enumerant('GL_TEXTURE_VIEW_NUM_LEVELS', 0x82dc, 'GL_ARB_texture_view')

defines.add(GL_TEXTURE_IMMUTABLE_LEVELS)
defines.add(GL_TEXTURE_VIEW_MIN_LAYER)
defines.add(GL_TEXTURE_VIEW_MIN_LEVEL)
defines.add(GL_TEXTURE_VIEW_NUM_LAYERS)
defines.add(GL_TEXTURE_VIEW_NUM_LEVELS)

# GL_ARB_timer_query

GL_TIMESTAMP = Enumerant('GL_TIMESTAMP', 0x8e28, 'GL_ARB_timer_query')
GL_TIME_ELAPSED = Enumerant('GL_TIME_ELAPSED', 0x88bf, 'GL_ARB_timer_query')

defines.add(GL_TIMESTAMP)
defines.add(GL_TIME_ELAPSED)

# GL_ARB_transform_feedback2

GL_TRANSFORM_FEEDBACK = Enumerant('GL_TRANSFORM_FEEDBACK', 0x8e22, 'GL_ARB_transform_feedback2')
GL_TRANSFORM_FEEDBACK_BINDING = Enumerant('GL_TRANSFORM_FEEDBACK_BINDING', 0x8e25, 'GL_ARB_transform_feedback2')
GL_TRANSFORM_FEEDBACK_BUFFER_ACTIVE = Enumerant('GL_TRANSFORM_FEEDBACK_BUFFER_ACTIVE', 0x8e24, 'GL_ARB_transform_feedback2')
GL_TRANSFORM_FEEDBACK_BUFFER_PAUSED = Enumerant('GL_TRANSFORM_FEEDBACK_BUFFER_PAUSED', 0x8e23, 'GL_ARB_transform_feedback2')

defines.add(GL_TRANSFORM_FEEDBACK)
defines.add(GL_TRANSFORM_FEEDBACK_BINDING)
defines.add(GL_TRANSFORM_FEEDBACK_BUFFER_ACTIVE)
defines.add(GL_TRANSFORM_FEEDBACK_BUFFER_PAUSED)

# GL_ARB_transform_feedback3

GL_MAX_TRANSFORM_FEEDBACK_BUFFERS = Enumerant('GL_MAX_TRANSFORM_FEEDBACK_BUFFERS', 0x8e70, 'GL_ARB_transform_feedback3')

defines.add(GL_MAX_TRANSFORM_FEEDBACK_BUFFERS)

# GL_ARB_transpose_matrix

GL_TRANSPOSE_COLOR_MATRIX_ARB = Enumerant('GL_TRANSPOSE_COLOR_MATRIX_ARB', 0x84e6, 'GL_ARB_transpose_matrix')
GL_TRANSPOSE_MODELVIEW_MATRIX_ARB = Enumerant('GL_TRANSPOSE_MODELVIEW_MATRIX_ARB', 0x84e3, 'GL_ARB_transpose_matrix')
GL_TRANSPOSE_PROJECTION_MATRIX_ARB = Enumerant('GL_TRANSPOSE_PROJECTION_MATRIX_ARB', 0x84e4, 'GL_ARB_transpose_matrix')
GL_TRANSPOSE_TEXTURE_MATRIX_ARB = Enumerant('GL_TRANSPOSE_TEXTURE_MATRIX_ARB', 0x84e5, 'GL_ARB_transpose_matrix')

defines.add(GL_TRANSPOSE_COLOR_MATRIX_ARB)
defines.add(GL_TRANSPOSE_MODELVIEW_MATRIX_ARB)
defines.add(GL_TRANSPOSE_PROJECTION_MATRIX_ARB)
defines.add(GL_TRANSPOSE_TEXTURE_MATRIX_ARB)

# GL_ARB_uniform_buffer_object

GL_ACTIVE_UNIFORM_BLOCKS = Enumerant('GL_ACTIVE_UNIFORM_BLOCKS', 0x8a36, 'GL_ARB_uniform_buffer_object')
GL_ACTIVE_UNIFORM_BLOCK_MAX_NAME_LENGTH = Enumerant('GL_ACTIVE_UNIFORM_BLOCK_MAX_NAME_LENGTH', 0x8a35, 'GL_ARB_uniform_buffer_object')
GL_INVALID_INDEX = Enumerant('GL_INVALID_INDEX', 0xffffffff, 'GL_ARB_uniform_buffer_object')
GL_MAX_COMBINED_FRAGMENT_UNIFORM_COMPONENTS = Enumerant('GL_MAX_COMBINED_FRAGMENT_UNIFORM_COMPONENTS', 0x8a33, 'GL_ARB_uniform_buffer_object')
GL_MAX_COMBINED_GEOMETRY_UNIFORM_COMPONENTS = Enumerant('GL_MAX_COMBINED_GEOMETRY_UNIFORM_COMPONENTS', 0x8a32, 'GL_ARB_uniform_buffer_object')
GL_MAX_COMBINED_UNIFORM_BLOCKS = Enumerant('GL_MAX_COMBINED_UNIFORM_BLOCKS', 0x8a2e, 'GL_ARB_uniform_buffer_object')
GL_MAX_COMBINED_VERTEX_UNIFORM_COMPONENTS = Enumerant('GL_MAX_COMBINED_VERTEX_UNIFORM_COMPONENTS', 0x8a31, 'GL_ARB_uniform_buffer_object')
GL_MAX_FRAGMENT_UNIFORM_BLOCKS = Enumerant('GL_MAX_FRAGMENT_UNIFORM_BLOCKS', 0x8a2d, 'GL_ARB_uniform_buffer_object')
GL_MAX_GEOMETRY_UNIFORM_BLOCKS = Enumerant('GL_MAX_GEOMETRY_UNIFORM_BLOCKS', 0x8a2c, 'GL_ARB_uniform_buffer_object')
GL_MAX_UNIFORM_BLOCK_SIZE = Enumerant('GL_MAX_UNIFORM_BLOCK_SIZE', 0x8a30, 'GL_ARB_uniform_buffer_object')
GL_MAX_UNIFORM_BUFFER_BINDINGS = Enumerant('GL_MAX_UNIFORM_BUFFER_BINDINGS', 0x8a2f, 'GL_ARB_uniform_buffer_object')
GL_MAX_VERTEX_UNIFORM_BLOCKS = Enumerant('GL_MAX_VERTEX_UNIFORM_BLOCKS', 0x8a2b, 'GL_ARB_uniform_buffer_object')
GL_UNIFORM_ARRAY_STRIDE = Enumerant('GL_UNIFORM_ARRAY_STRIDE', 0x8a3c, 'GL_ARB_uniform_buffer_object')
GL_UNIFORM_BLOCK_ACTIVE_UNIFORMS = Enumerant('GL_UNIFORM_BLOCK_ACTIVE_UNIFORMS', 0x8a42, 'GL_ARB_uniform_buffer_object')
GL_UNIFORM_BLOCK_ACTIVE_UNIFORM_INDICES = Enumerant('GL_UNIFORM_BLOCK_ACTIVE_UNIFORM_INDICES', 0x8a43, 'GL_ARB_uniform_buffer_object')
GL_UNIFORM_BLOCK_BINDING = Enumerant('GL_UNIFORM_BLOCK_BINDING', 0x8a3f, 'GL_ARB_uniform_buffer_object')
GL_UNIFORM_BLOCK_DATA_SIZE = Enumerant('GL_UNIFORM_BLOCK_DATA_SIZE', 0x8a40, 'GL_ARB_uniform_buffer_object')
GL_UNIFORM_BLOCK_INDEX = Enumerant('GL_UNIFORM_BLOCK_INDEX', 0x8a3a, 'GL_ARB_uniform_buffer_object')
GL_UNIFORM_BLOCK_NAME_LENGTH = Enumerant('GL_UNIFORM_BLOCK_NAME_LENGTH', 0x8a41, 'GL_ARB_uniform_buffer_object')
GL_UNIFORM_BLOCK_REFERENCED_BY_FRAGMENT_SHADER = Enumerant('GL_UNIFORM_BLOCK_REFERENCED_BY_FRAGMENT_SHADER', 0x8a46, 'GL_ARB_uniform_buffer_object')
GL_UNIFORM_BLOCK_REFERENCED_BY_GEOMETRY_SHADER = Enumerant('GL_UNIFORM_BLOCK_REFERENCED_BY_GEOMETRY_SHADER', 0x8a45, 'GL_ARB_uniform_buffer_object')
GL_UNIFORM_BLOCK_REFERENCED_BY_VERTEX_SHADER = Enumerant('GL_UNIFORM_BLOCK_REFERENCED_BY_VERTEX_SHADER', 0x8a44, 'GL_ARB_uniform_buffer_object')
GL_UNIFORM_BUFFER = Enumerant('GL_UNIFORM_BUFFER', 0x8a11, 'GL_ARB_uniform_buffer_object')
GL_UNIFORM_BUFFER_BINDING = Enumerant('GL_UNIFORM_BUFFER_BINDING', 0x8a28, 'GL_ARB_uniform_buffer_object')
GL_UNIFORM_BUFFER_OFFSET_ALIGNMENT = Enumerant('GL_UNIFORM_BUFFER_OFFSET_ALIGNMENT', 0x8a34, 'GL_ARB_uniform_buffer_object')
GL_UNIFORM_BUFFER_SIZE = Enumerant('GL_UNIFORM_BUFFER_SIZE', 0x8a2a, 'GL_ARB_uniform_buffer_object')
GL_UNIFORM_BUFFER_START = Enumerant('GL_UNIFORM_BUFFER_START', 0x8a29, 'GL_ARB_uniform_buffer_object')
GL_UNIFORM_IS_ROW_MAJOR = Enumerant('GL_UNIFORM_IS_ROW_MAJOR', 0x8a3e, 'GL_ARB_uniform_buffer_object')
GL_UNIFORM_MATRIX_STRIDE = Enumerant('GL_UNIFORM_MATRIX_STRIDE', 0x8a3d, 'GL_ARB_uniform_buffer_object')
GL_UNIFORM_NAME_LENGTH = Enumerant('GL_UNIFORM_NAME_LENGTH', 0x8a39, 'GL_ARB_uniform_buffer_object')
GL_UNIFORM_OFFSET = Enumerant('GL_UNIFORM_OFFSET', 0x8a3b, 'GL_ARB_uniform_buffer_object')
GL_UNIFORM_SIZE = Enumerant('GL_UNIFORM_SIZE', 0x8a38, 'GL_ARB_uniform_buffer_object')
GL_UNIFORM_TYPE = Enumerant('GL_UNIFORM_TYPE', 0x8a37, 'GL_ARB_uniform_buffer_object')

defines.add(GL_ACTIVE_UNIFORM_BLOCKS)
defines.add(GL_ACTIVE_UNIFORM_BLOCK_MAX_NAME_LENGTH)
defines.add(GL_INVALID_INDEX)
defines.add(GL_MAX_COMBINED_FRAGMENT_UNIFORM_COMPONENTS)
defines.add(GL_MAX_COMBINED_GEOMETRY_UNIFORM_COMPONENTS)
defines.add(GL_MAX_COMBINED_UNIFORM_BLOCKS)
defines.add(GL_MAX_COMBINED_VERTEX_UNIFORM_COMPONENTS)
defines.add(GL_MAX_FRAGMENT_UNIFORM_BLOCKS)
defines.add(GL_MAX_GEOMETRY_UNIFORM_BLOCKS)
defines.add(GL_MAX_UNIFORM_BLOCK_SIZE)
defines.add(GL_MAX_UNIFORM_BUFFER_BINDINGS)
defines.add(GL_MAX_VERTEX_UNIFORM_BLOCKS)
defines.add(GL_UNIFORM_ARRAY_STRIDE)
defines.add(GL_UNIFORM_BLOCK_ACTIVE_UNIFORMS)
defines.add(GL_UNIFORM_BLOCK_ACTIVE_UNIFORM_INDICES)
defines.add(GL_UNIFORM_BLOCK_BINDING)
defines.add(GL_UNIFORM_BLOCK_DATA_SIZE)
defines.add(GL_UNIFORM_BLOCK_INDEX)
defines.add(GL_UNIFORM_BLOCK_NAME_LENGTH)
defines.add(GL_UNIFORM_BLOCK_REFERENCED_BY_FRAGMENT_SHADER)
defines.add(GL_UNIFORM_BLOCK_REFERENCED_BY_GEOMETRY_SHADER)
defines.add(GL_UNIFORM_BLOCK_REFERENCED_BY_VERTEX_SHADER)
defines.add(GL_UNIFORM_BUFFER)
defines.add(GL_UNIFORM_BUFFER_BINDING)
defines.add(GL_UNIFORM_BUFFER_OFFSET_ALIGNMENT)
defines.add(GL_UNIFORM_BUFFER_SIZE)
defines.add(GL_UNIFORM_BUFFER_START)
defines.add(GL_UNIFORM_IS_ROW_MAJOR)
defines.add(GL_UNIFORM_MATRIX_STRIDE)
defines.add(GL_UNIFORM_NAME_LENGTH)
defines.add(GL_UNIFORM_OFFSET)
defines.add(GL_UNIFORM_SIZE)
defines.add(GL_UNIFORM_TYPE)

# GL_ARB_vertex_array_object

GL_VERTEX_ARRAY_BINDING = Enumerant('GL_VERTEX_ARRAY_BINDING', 0x85b5, 'GL_ARB_vertex_array_object')

defines.add(GL_VERTEX_ARRAY_BINDING)

# GL_ARB_vertex_attrib_binding

GL_MAX_VERTEX_ATTRIB_BINDINGS = Enumerant('GL_MAX_VERTEX_ATTRIB_BINDINGS', 0x82da, 'GL_ARB_vertex_attrib_binding')
GL_MAX_VERTEX_ATTRIB_RELATIVE_OFFSET = Enumerant('GL_MAX_VERTEX_ATTRIB_RELATIVE_OFFSET', 0x82d9, 'GL_ARB_vertex_attrib_binding')
GL_VERTEX_ATTRIB_BINDING = Enumerant('GL_VERTEX_ATTRIB_BINDING', 0x82d4, 'GL_ARB_vertex_attrib_binding')
GL_VERTEX_ATTRIB_RELATIVE_OFFSET = Enumerant('GL_VERTEX_ATTRIB_RELATIVE_OFFSET', 0x82d5, 'GL_ARB_vertex_attrib_binding')
GL_VERTEX_BINDING_DIVISOR = Enumerant('GL_VERTEX_BINDING_DIVISOR', 0x82d6, 'GL_ARB_vertex_attrib_binding')
GL_VERTEX_BINDING_OFFSET = Enumerant('GL_VERTEX_BINDING_OFFSET', 0x82d7, 'GL_ARB_vertex_attrib_binding')
GL_VERTEX_BINDING_STRIDE = Enumerant('GL_VERTEX_BINDING_STRIDE', 0x82d8, 'GL_ARB_vertex_attrib_binding')

defines.add(GL_MAX_VERTEX_ATTRIB_BINDINGS)
defines.add(GL_MAX_VERTEX_ATTRIB_RELATIVE_OFFSET)
defines.add(GL_VERTEX_ATTRIB_BINDING)
defines.add(GL_VERTEX_ATTRIB_RELATIVE_OFFSET)
defines.add(GL_VERTEX_BINDING_DIVISOR)
defines.add(GL_VERTEX_BINDING_OFFSET)
defines.add(GL_VERTEX_BINDING_STRIDE)

# GL_ARB_vertex_blend

GL_ACTIVE_VERTEX_UNITS_ARB = Enumerant('GL_ACTIVE_VERTEX_UNITS_ARB', 0x86a5, 'GL_ARB_vertex_blend')
GL_CURRENT_WEIGHT_ARB = Enumerant('GL_CURRENT_WEIGHT_ARB', 0x86a8, 'GL_ARB_vertex_blend')
GL_MAX_VERTEX_UNITS_ARB = Enumerant('GL_MAX_VERTEX_UNITS_ARB', 0x86a4, 'GL_ARB_vertex_blend')
GL_MODELVIEW0_ARB = Enumerant('GL_MODELVIEW0_ARB', 0x1700, 'GL_ARB_vertex_blend')
GL_MODELVIEW10_ARB = Enumerant('GL_MODELVIEW10_ARB', 0x872a, 'GL_ARB_vertex_blend')
GL_MODELVIEW11_ARB = Enumerant('GL_MODELVIEW11_ARB', 0x872b, 'GL_ARB_vertex_blend')
GL_MODELVIEW12_ARB = Enumerant('GL_MODELVIEW12_ARB', 0x872c, 'GL_ARB_vertex_blend')
GL_MODELVIEW13_ARB = Enumerant('GL_MODELVIEW13_ARB', 0x872d, 'GL_ARB_vertex_blend')
GL_MODELVIEW14_ARB = Enumerant('GL_MODELVIEW14_ARB', 0x872e, 'GL_ARB_vertex_blend')
GL_MODELVIEW15_ARB = Enumerant('GL_MODELVIEW15_ARB', 0x872f, 'GL_ARB_vertex_blend')
GL_MODELVIEW16_ARB = Enumerant('GL_MODELVIEW16_ARB', 0x8730, 'GL_ARB_vertex_blend')
GL_MODELVIEW17_ARB = Enumerant('GL_MODELVIEW17_ARB', 0x8731, 'GL_ARB_vertex_blend')
GL_MODELVIEW18_ARB = Enumerant('GL_MODELVIEW18_ARB', 0x8732, 'GL_ARB_vertex_blend')
GL_MODELVIEW19_ARB = Enumerant('GL_MODELVIEW19_ARB', 0x8733, 'GL_ARB_vertex_blend')
GL_MODELVIEW1_ARB = Enumerant('GL_MODELVIEW1_ARB', 0x850a, 'GL_ARB_vertex_blend')
GL_MODELVIEW20_ARB = Enumerant('GL_MODELVIEW20_ARB', 0x8734, 'GL_ARB_vertex_blend')
GL_MODELVIEW21_ARB = Enumerant('GL_MODELVIEW21_ARB', 0x8735, 'GL_ARB_vertex_blend')
GL_MODELVIEW22_ARB = Enumerant('GL_MODELVIEW22_ARB', 0x8736, 'GL_ARB_vertex_blend')
GL_MODELVIEW23_ARB = Enumerant('GL_MODELVIEW23_ARB', 0x8737, 'GL_ARB_vertex_blend')
GL_MODELVIEW24_ARB = Enumerant('GL_MODELVIEW24_ARB', 0x8738, 'GL_ARB_vertex_blend')
GL_MODELVIEW25_ARB = Enumerant('GL_MODELVIEW25_ARB', 0x8739, 'GL_ARB_vertex_blend')
GL_MODELVIEW26_ARB = Enumerant('GL_MODELVIEW26_ARB', 0x873a, 'GL_ARB_vertex_blend')
GL_MODELVIEW27_ARB = Enumerant('GL_MODELVIEW27_ARB', 0x873b, 'GL_ARB_vertex_blend')
GL_MODELVIEW28_ARB = Enumerant('GL_MODELVIEW28_ARB', 0x873c, 'GL_ARB_vertex_blend')
GL_MODELVIEW29_ARB = Enumerant('GL_MODELVIEW29_ARB', 0x873d, 'GL_ARB_vertex_blend')
GL_MODELVIEW2_ARB = Enumerant('GL_MODELVIEW2_ARB', 0x8722, 'GL_ARB_vertex_blend')
GL_MODELVIEW30_ARB = Enumerant('GL_MODELVIEW30_ARB', 0x873e, 'GL_ARB_vertex_blend')
GL_MODELVIEW31_ARB = Enumerant('GL_MODELVIEW31_ARB', 0x873f, 'GL_ARB_vertex_blend')
GL_MODELVIEW3_ARB = Enumerant('GL_MODELVIEW3_ARB', 0x8723, 'GL_ARB_vertex_blend')
GL_MODELVIEW4_ARB = Enumerant('GL_MODELVIEW4_ARB', 0x8724, 'GL_ARB_vertex_blend')
GL_MODELVIEW5_ARB = Enumerant('GL_MODELVIEW5_ARB', 0x8725, 'GL_ARB_vertex_blend')
GL_MODELVIEW6_ARB = Enumerant('GL_MODELVIEW6_ARB', 0x8726, 'GL_ARB_vertex_blend')
GL_MODELVIEW7_ARB = Enumerant('GL_MODELVIEW7_ARB', 0x8727, 'GL_ARB_vertex_blend')
GL_MODELVIEW8_ARB = Enumerant('GL_MODELVIEW8_ARB', 0x8728, 'GL_ARB_vertex_blend')
GL_MODELVIEW9_ARB = Enumerant('GL_MODELVIEW9_ARB', 0x8729, 'GL_ARB_vertex_blend')
GL_VERTEX_BLEND_ARB = Enumerant('GL_VERTEX_BLEND_ARB', 0x86a7, 'GL_ARB_vertex_blend')
GL_WEIGHT_ARRAY_ARB = Enumerant('GL_WEIGHT_ARRAY_ARB', 0x86ad, 'GL_ARB_vertex_blend')
GL_WEIGHT_ARRAY_POINTER_ARB = Enumerant('GL_WEIGHT_ARRAY_POINTER_ARB', 0x86ac, 'GL_ARB_vertex_blend')
GL_WEIGHT_ARRAY_SIZE_ARB = Enumerant('GL_WEIGHT_ARRAY_SIZE_ARB', 0x86ab, 'GL_ARB_vertex_blend')
GL_WEIGHT_ARRAY_STRIDE_ARB = Enumerant('GL_WEIGHT_ARRAY_STRIDE_ARB', 0x86aa, 'GL_ARB_vertex_blend')
GL_WEIGHT_ARRAY_TYPE_ARB = Enumerant('GL_WEIGHT_ARRAY_TYPE_ARB', 0x86a9, 'GL_ARB_vertex_blend')
GL_WEIGHT_SUM_UNITY_ARB = Enumerant('GL_WEIGHT_SUM_UNITY_ARB', 0x86a6, 'GL_ARB_vertex_blend')

defines.add(GL_ACTIVE_VERTEX_UNITS_ARB)
defines.add(GL_CURRENT_WEIGHT_ARB)
defines.add(GL_MAX_VERTEX_UNITS_ARB)
defines.add(GL_MODELVIEW0_ARB)
defines.add(GL_MODELVIEW10_ARB)
defines.add(GL_MODELVIEW11_ARB)
defines.add(GL_MODELVIEW12_ARB)
defines.add(GL_MODELVIEW13_ARB)
defines.add(GL_MODELVIEW14_ARB)
defines.add(GL_MODELVIEW15_ARB)
defines.add(GL_MODELVIEW16_ARB)
defines.add(GL_MODELVIEW17_ARB)
defines.add(GL_MODELVIEW18_ARB)
defines.add(GL_MODELVIEW19_ARB)
defines.add(GL_MODELVIEW1_ARB)
defines.add(GL_MODELVIEW20_ARB)
defines.add(GL_MODELVIEW21_ARB)
defines.add(GL_MODELVIEW22_ARB)
defines.add(GL_MODELVIEW23_ARB)
defines.add(GL_MODELVIEW24_ARB)
defines.add(GL_MODELVIEW25_ARB)
defines.add(GL_MODELVIEW26_ARB)
defines.add(GL_MODELVIEW27_ARB)
defines.add(GL_MODELVIEW28_ARB)
defines.add(GL_MODELVIEW29_ARB)
defines.add(GL_MODELVIEW2_ARB)
defines.add(GL_MODELVIEW30_ARB)
defines.add(GL_MODELVIEW31_ARB)
defines.add(GL_MODELVIEW3_ARB)
defines.add(GL_MODELVIEW4_ARB)
defines.add(GL_MODELVIEW5_ARB)
defines.add(GL_MODELVIEW6_ARB)
defines.add(GL_MODELVIEW7_ARB)
defines.add(GL_MODELVIEW8_ARB)
defines.add(GL_MODELVIEW9_ARB)
defines.add(GL_VERTEX_BLEND_ARB)
defines.add(GL_WEIGHT_ARRAY_ARB)
defines.add(GL_WEIGHT_ARRAY_POINTER_ARB)
defines.add(GL_WEIGHT_ARRAY_SIZE_ARB)
defines.add(GL_WEIGHT_ARRAY_STRIDE_ARB)
defines.add(GL_WEIGHT_ARRAY_TYPE_ARB)
defines.add(GL_WEIGHT_SUM_UNITY_ARB)

# GL_ARB_vertex_buffer_object

GL_ARRAY_BUFFER_ARB = Enumerant('GL_ARRAY_BUFFER_ARB', 0x8892, 'GL_ARB_vertex_buffer_object')
GL_ARRAY_BUFFER_BINDING_ARB = Enumerant('GL_ARRAY_BUFFER_BINDING_ARB', 0x8894, 'GL_ARB_vertex_buffer_object')
GL_BUFFER_ACCESS_ARB = Enumerant('GL_BUFFER_ACCESS_ARB', 0x88bb, 'GL_ARB_vertex_buffer_object')
GL_BUFFER_MAPPED_ARB = Enumerant('GL_BUFFER_MAPPED_ARB', 0x88bc, 'GL_ARB_vertex_buffer_object')
GL_BUFFER_MAP_POINTER_ARB = Enumerant('GL_BUFFER_MAP_POINTER_ARB', 0x88bd, 'GL_ARB_vertex_buffer_object')
GL_BUFFER_SIZE_ARB = Enumerant('GL_BUFFER_SIZE_ARB', 0x8764, 'GL_ARB_vertex_buffer_object')
GL_BUFFER_USAGE_ARB = Enumerant('GL_BUFFER_USAGE_ARB', 0x8765, 'GL_ARB_vertex_buffer_object')
GL_COLOR_ARRAY_BUFFER_BINDING_ARB = Enumerant('GL_COLOR_ARRAY_BUFFER_BINDING_ARB', 0x8898, 'GL_ARB_vertex_buffer_object')
GL_DYNAMIC_COPY_ARB = Enumerant('GL_DYNAMIC_COPY_ARB', 0x88ea, 'GL_ARB_vertex_buffer_object')
GL_DYNAMIC_DRAW_ARB = Enumerant('GL_DYNAMIC_DRAW_ARB', 0x88e8, 'GL_ARB_vertex_buffer_object')
GL_DYNAMIC_READ_ARB = Enumerant('GL_DYNAMIC_READ_ARB', 0x88e9, 'GL_ARB_vertex_buffer_object')
GL_EDGE_FLAG_ARRAY_BUFFER_BINDING_ARB = Enumerant('GL_EDGE_FLAG_ARRAY_BUFFER_BINDING_ARB', 0x889b, 'GL_ARB_vertex_buffer_object')
GL_ELEMENT_ARRAY_BUFFER_ARB = Enumerant('GL_ELEMENT_ARRAY_BUFFER_ARB', 0x8893, 'GL_ARB_vertex_buffer_object')
GL_ELEMENT_ARRAY_BUFFER_BINDING_ARB = Enumerant('GL_ELEMENT_ARRAY_BUFFER_BINDING_ARB', 0x8895, 'GL_ARB_vertex_buffer_object')
GL_FOG_COORDINATE_ARRAY_BUFFER_BINDING_ARB = Enumerant('GL_FOG_COORDINATE_ARRAY_BUFFER_BINDING_ARB', 0x889d, 'GL_ARB_vertex_buffer_object')
GL_INDEX_ARRAY_BUFFER_BINDING_ARB = Enumerant('GL_INDEX_ARRAY_BUFFER_BINDING_ARB', 0x8899, 'GL_ARB_vertex_buffer_object')
GL_NORMAL_ARRAY_BUFFER_BINDING_ARB = Enumerant('GL_NORMAL_ARRAY_BUFFER_BINDING_ARB', 0x8897, 'GL_ARB_vertex_buffer_object')
GL_READ_ONLY_ARB = Enumerant('GL_READ_ONLY_ARB', 0x88b8, 'GL_ARB_vertex_buffer_object')
GL_READ_WRITE_ARB = Enumerant('GL_READ_WRITE_ARB', 0x88ba, 'GL_ARB_vertex_buffer_object')
GL_SECONDARY_COLOR_ARRAY_BUFFER_BINDING_ARB = Enumerant('GL_SECONDARY_COLOR_ARRAY_BUFFER_BINDING_ARB', 0x889c, 'GL_ARB_vertex_buffer_object')
GL_STATIC_COPY_ARB = Enumerant('GL_STATIC_COPY_ARB', 0x88e6, 'GL_ARB_vertex_buffer_object')
GL_STATIC_DRAW_ARB = Enumerant('GL_STATIC_DRAW_ARB', 0x88e4, 'GL_ARB_vertex_buffer_object')
GL_STATIC_READ_ARB = Enumerant('GL_STATIC_READ_ARB', 0x88e5, 'GL_ARB_vertex_buffer_object')
GL_STREAM_COPY_ARB = Enumerant('GL_STREAM_COPY_ARB', 0x88e2, 'GL_ARB_vertex_buffer_object')
GL_STREAM_DRAW_ARB = Enumerant('GL_STREAM_DRAW_ARB', 0x88e0, 'GL_ARB_vertex_buffer_object')
GL_STREAM_READ_ARB = Enumerant('GL_STREAM_READ_ARB', 0x88e1, 'GL_ARB_vertex_buffer_object')
GL_TEXTURE_COORD_ARRAY_BUFFER_BINDING_ARB = Enumerant('GL_TEXTURE_COORD_ARRAY_BUFFER_BINDING_ARB', 0x889a, 'GL_ARB_vertex_buffer_object')
GL_VERTEX_ARRAY_BUFFER_BINDING_ARB = Enumerant('GL_VERTEX_ARRAY_BUFFER_BINDING_ARB', 0x8896, 'GL_ARB_vertex_buffer_object')
GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING_ARB = Enumerant('GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING_ARB', 0x889f, 'GL_ARB_vertex_buffer_object')
GL_WEIGHT_ARRAY_BUFFER_BINDING_ARB = Enumerant('GL_WEIGHT_ARRAY_BUFFER_BINDING_ARB', 0x889e, 'GL_ARB_vertex_buffer_object')
GL_WRITE_ONLY_ARB = Enumerant('GL_WRITE_ONLY_ARB', 0x88b9, 'GL_ARB_vertex_buffer_object')

defines.add(GL_ARRAY_BUFFER_ARB)
defines.add(GL_ARRAY_BUFFER_BINDING_ARB)
defines.add(GL_BUFFER_ACCESS_ARB)
defines.add(GL_BUFFER_MAPPED_ARB)
defines.add(GL_BUFFER_MAP_POINTER_ARB)
defines.add(GL_BUFFER_SIZE_ARB)
defines.add(GL_BUFFER_USAGE_ARB)
defines.add(GL_COLOR_ARRAY_BUFFER_BINDING_ARB)
defines.add(GL_DYNAMIC_COPY_ARB)
defines.add(GL_DYNAMIC_DRAW_ARB)
defines.add(GL_DYNAMIC_READ_ARB)
defines.add(GL_EDGE_FLAG_ARRAY_BUFFER_BINDING_ARB)
defines.add(GL_ELEMENT_ARRAY_BUFFER_ARB)
defines.add(GL_ELEMENT_ARRAY_BUFFER_BINDING_ARB)
defines.add(GL_FOG_COORDINATE_ARRAY_BUFFER_BINDING_ARB)
defines.add(GL_INDEX_ARRAY_BUFFER_BINDING_ARB)
defines.add(GL_NORMAL_ARRAY_BUFFER_BINDING_ARB)
defines.add(GL_READ_ONLY_ARB)
defines.add(GL_READ_WRITE_ARB)
defines.add(GL_SECONDARY_COLOR_ARRAY_BUFFER_BINDING_ARB)
defines.add(GL_STATIC_COPY_ARB)
defines.add(GL_STATIC_DRAW_ARB)
defines.add(GL_STATIC_READ_ARB)
defines.add(GL_STREAM_COPY_ARB)
defines.add(GL_STREAM_DRAW_ARB)
defines.add(GL_STREAM_READ_ARB)
defines.add(GL_TEXTURE_COORD_ARRAY_BUFFER_BINDING_ARB)
defines.add(GL_VERTEX_ARRAY_BUFFER_BINDING_ARB)
defines.add(GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING_ARB)
defines.add(GL_WEIGHT_ARRAY_BUFFER_BINDING_ARB)
defines.add(GL_WRITE_ONLY_ARB)

# GL_ARB_vertex_program

GL_COLOR_SUM_ARB = Enumerant('GL_COLOR_SUM_ARB', 0x8458, 'GL_ARB_vertex_program')
GL_CURRENT_MATRIX_ARB = Enumerant('GL_CURRENT_MATRIX_ARB', 0x8641, 'GL_ARB_vertex_program')
GL_CURRENT_MATRIX_STACK_DEPTH_ARB = Enumerant('GL_CURRENT_MATRIX_STACK_DEPTH_ARB', 0x8640, 'GL_ARB_vertex_program')
GL_CURRENT_VERTEX_ATTRIB_ARB = Enumerant('GL_CURRENT_VERTEX_ATTRIB_ARB', 0x8626, 'GL_ARB_vertex_program')
GL_MATRIX0_ARB = Enumerant('GL_MATRIX0_ARB', 0x88c0, 'GL_ARB_vertex_program')
GL_MATRIX10_ARB = Enumerant('GL_MATRIX10_ARB', 0x88ca, 'GL_ARB_vertex_program')
GL_MATRIX11_ARB = Enumerant('GL_MATRIX11_ARB', 0x88cb, 'GL_ARB_vertex_program')
GL_MATRIX12_ARB = Enumerant('GL_MATRIX12_ARB', 0x88cc, 'GL_ARB_vertex_program')
GL_MATRIX13_ARB = Enumerant('GL_MATRIX13_ARB', 0x88cd, 'GL_ARB_vertex_program')
GL_MATRIX14_ARB = Enumerant('GL_MATRIX14_ARB', 0x88ce, 'GL_ARB_vertex_program')
GL_MATRIX15_ARB = Enumerant('GL_MATRIX15_ARB', 0x88cf, 'GL_ARB_vertex_program')
GL_MATRIX16_ARB = Enumerant('GL_MATRIX16_ARB', 0x88d0, 'GL_ARB_vertex_program')
GL_MATRIX17_ARB = Enumerant('GL_MATRIX17_ARB', 0x88d1, 'GL_ARB_vertex_program')
GL_MATRIX18_ARB = Enumerant('GL_MATRIX18_ARB', 0x88d2, 'GL_ARB_vertex_program')
GL_MATRIX19_ARB = Enumerant('GL_MATRIX19_ARB', 0x88d3, 'GL_ARB_vertex_program')
GL_MATRIX1_ARB = Enumerant('GL_MATRIX1_ARB', 0x88c1, 'GL_ARB_vertex_program')
GL_MATRIX20_ARB = Enumerant('GL_MATRIX20_ARB', 0x88d4, 'GL_ARB_vertex_program')
GL_MATRIX21_ARB = Enumerant('GL_MATRIX21_ARB', 0x88d5, 'GL_ARB_vertex_program')
GL_MATRIX22_ARB = Enumerant('GL_MATRIX22_ARB', 0x88d6, 'GL_ARB_vertex_program')
GL_MATRIX23_ARB = Enumerant('GL_MATRIX23_ARB', 0x88d7, 'GL_ARB_vertex_program')
GL_MATRIX24_ARB = Enumerant('GL_MATRIX24_ARB', 0x88d8, 'GL_ARB_vertex_program')
GL_MATRIX25_ARB = Enumerant('GL_MATRIX25_ARB', 0x88d9, 'GL_ARB_vertex_program')
GL_MATRIX26_ARB = Enumerant('GL_MATRIX26_ARB', 0x88da, 'GL_ARB_vertex_program')
GL_MATRIX27_ARB = Enumerant('GL_MATRIX27_ARB', 0x88db, 'GL_ARB_vertex_program')
GL_MATRIX28_ARB = Enumerant('GL_MATRIX28_ARB', 0x88dc, 'GL_ARB_vertex_program')
GL_MATRIX29_ARB = Enumerant('GL_MATRIX29_ARB', 0x88dd, 'GL_ARB_vertex_program')
GL_MATRIX2_ARB = Enumerant('GL_MATRIX2_ARB', 0x88c2, 'GL_ARB_vertex_program')
GL_MATRIX30_ARB = Enumerant('GL_MATRIX30_ARB', 0x88de, 'GL_ARB_vertex_program')
GL_MATRIX31_ARB = Enumerant('GL_MATRIX31_ARB', 0x88df, 'GL_ARB_vertex_program')
GL_MATRIX3_ARB = Enumerant('GL_MATRIX3_ARB', 0x88c3, 'GL_ARB_vertex_program')
GL_MATRIX4_ARB = Enumerant('GL_MATRIX4_ARB', 0x88c4, 'GL_ARB_vertex_program')
GL_MATRIX5_ARB = Enumerant('GL_MATRIX5_ARB', 0x88c5, 'GL_ARB_vertex_program')
GL_MATRIX6_ARB = Enumerant('GL_MATRIX6_ARB', 0x88c6, 'GL_ARB_vertex_program')
GL_MATRIX7_ARB = Enumerant('GL_MATRIX7_ARB', 0x88c7, 'GL_ARB_vertex_program')
GL_MATRIX8_ARB = Enumerant('GL_MATRIX8_ARB', 0x88c8, 'GL_ARB_vertex_program')
GL_MATRIX9_ARB = Enumerant('GL_MATRIX9_ARB', 0x88c9, 'GL_ARB_vertex_program')
GL_MAX_PROGRAM_ADDRESS_REGISTERS_ARB = Enumerant('GL_MAX_PROGRAM_ADDRESS_REGISTERS_ARB', 0x88b1, 'GL_ARB_vertex_program')
GL_MAX_PROGRAM_ATTRIBS_ARB = Enumerant('GL_MAX_PROGRAM_ATTRIBS_ARB', 0x88ad, 'GL_ARB_vertex_program')
GL_MAX_PROGRAM_ENV_PARAMETERS_ARB = Enumerant('GL_MAX_PROGRAM_ENV_PARAMETERS_ARB', 0x88b5, 'GL_ARB_vertex_program')
GL_MAX_PROGRAM_INSTRUCTIONS_ARB = Enumerant('GL_MAX_PROGRAM_INSTRUCTIONS_ARB', 0x88a1, 'GL_ARB_vertex_program')
GL_MAX_PROGRAM_LOCAL_PARAMETERS_ARB = Enumerant('GL_MAX_PROGRAM_LOCAL_PARAMETERS_ARB', 0x88b4, 'GL_ARB_vertex_program')
GL_MAX_PROGRAM_MATRICES_ARB = Enumerant('GL_MAX_PROGRAM_MATRICES_ARB', 0x862f, 'GL_ARB_vertex_program')
GL_MAX_PROGRAM_MATRIX_STACK_DEPTH_ARB = Enumerant('GL_MAX_PROGRAM_MATRIX_STACK_DEPTH_ARB', 0x862e, 'GL_ARB_vertex_program')
GL_MAX_PROGRAM_NATIVE_ADDRESS_REGISTERS_ARB = Enumerant('GL_MAX_PROGRAM_NATIVE_ADDRESS_REGISTERS_ARB', 0x88b3, 'GL_ARB_vertex_program')
GL_MAX_PROGRAM_NATIVE_ATTRIBS_ARB = Enumerant('GL_MAX_PROGRAM_NATIVE_ATTRIBS_ARB', 0x88af, 'GL_ARB_vertex_program')
GL_MAX_PROGRAM_NATIVE_INSTRUCTIONS_ARB = Enumerant('GL_MAX_PROGRAM_NATIVE_INSTRUCTIONS_ARB', 0x88a3, 'GL_ARB_vertex_program')
GL_MAX_PROGRAM_NATIVE_PARAMETERS_ARB = Enumerant('GL_MAX_PROGRAM_NATIVE_PARAMETERS_ARB', 0x88ab, 'GL_ARB_vertex_program')
GL_MAX_PROGRAM_NATIVE_TEMPORARIES_ARB = Enumerant('GL_MAX_PROGRAM_NATIVE_TEMPORARIES_ARB', 0x88a7, 'GL_ARB_vertex_program')
GL_MAX_PROGRAM_PARAMETERS_ARB = Enumerant('GL_MAX_PROGRAM_PARAMETERS_ARB', 0x88a9, 'GL_ARB_vertex_program')
GL_MAX_PROGRAM_TEMPORARIES_ARB = Enumerant('GL_MAX_PROGRAM_TEMPORARIES_ARB', 0x88a5, 'GL_ARB_vertex_program')
GL_MAX_VERTEX_ATTRIBS_ARB = Enumerant('GL_MAX_VERTEX_ATTRIBS_ARB', 0x8869, 'GL_ARB_vertex_program')
GL_PROGRAM_ADDRESS_REGISTERS_ARB = Enumerant('GL_PROGRAM_ADDRESS_REGISTERS_ARB', 0x88b0, 'GL_ARB_vertex_program')
GL_PROGRAM_ATTRIBS_ARB = Enumerant('GL_PROGRAM_ATTRIBS_ARB', 0x88ac, 'GL_ARB_vertex_program')
GL_PROGRAM_BINDING_ARB = Enumerant('GL_PROGRAM_BINDING_ARB', 0x8677, 'GL_ARB_vertex_program')
GL_PROGRAM_ERROR_POSITION_ARB = Enumerant('GL_PROGRAM_ERROR_POSITION_ARB', 0x864b, 'GL_ARB_vertex_program')
GL_PROGRAM_ERROR_STRING_ARB = Enumerant('GL_PROGRAM_ERROR_STRING_ARB', 0x8874, 'GL_ARB_vertex_program')
GL_PROGRAM_FORMAT_ARB = Enumerant('GL_PROGRAM_FORMAT_ARB', 0x8876, 'GL_ARB_vertex_program')
GL_PROGRAM_FORMAT_ASCII_ARB = Enumerant('GL_PROGRAM_FORMAT_ASCII_ARB', 0x8875, 'GL_ARB_vertex_program')
GL_PROGRAM_INSTRUCTIONS_ARB = Enumerant('GL_PROGRAM_INSTRUCTIONS_ARB', 0x88a0, 'GL_ARB_vertex_program')
GL_PROGRAM_LENGTH_ARB = Enumerant('GL_PROGRAM_LENGTH_ARB', 0x8627, 'GL_ARB_vertex_program')
GL_PROGRAM_NATIVE_ADDRESS_REGISTERS_ARB = Enumerant('GL_PROGRAM_NATIVE_ADDRESS_REGISTERS_ARB', 0x88b2, 'GL_ARB_vertex_program')
GL_PROGRAM_NATIVE_ATTRIBS_ARB = Enumerant('GL_PROGRAM_NATIVE_ATTRIBS_ARB', 0x88ae, 'GL_ARB_vertex_program')
GL_PROGRAM_NATIVE_INSTRUCTIONS_ARB = Enumerant('GL_PROGRAM_NATIVE_INSTRUCTIONS_ARB', 0x88a2, 'GL_ARB_vertex_program')
GL_PROGRAM_NATIVE_PARAMETERS_ARB = Enumerant('GL_PROGRAM_NATIVE_PARAMETERS_ARB', 0x88aa, 'GL_ARB_vertex_program')
GL_PROGRAM_NATIVE_TEMPORARIES_ARB = Enumerant('GL_PROGRAM_NATIVE_TEMPORARIES_ARB', 0x88a6, 'GL_ARB_vertex_program')
GL_PROGRAM_PARAMETERS_ARB = Enumerant('GL_PROGRAM_PARAMETERS_ARB', 0x88a8, 'GL_ARB_vertex_program')
GL_PROGRAM_STRING_ARB = Enumerant('GL_PROGRAM_STRING_ARB', 0x8628, 'GL_ARB_vertex_program')
GL_PROGRAM_TEMPORARIES_ARB = Enumerant('GL_PROGRAM_TEMPORARIES_ARB', 0x88a4, 'GL_ARB_vertex_program')
GL_PROGRAM_UNDER_NATIVE_LIMITS_ARB = Enumerant('GL_PROGRAM_UNDER_NATIVE_LIMITS_ARB', 0x88b6, 'GL_ARB_vertex_program')
GL_TRANSPOSE_CURRENT_MATRIX_ARB = Enumerant('GL_TRANSPOSE_CURRENT_MATRIX_ARB', 0x88b7, 'GL_ARB_vertex_program')
GL_VERTEX_ATTRIB_ARRAY_ENABLED_ARB = Enumerant('GL_VERTEX_ATTRIB_ARRAY_ENABLED_ARB', 0x8622, 'GL_ARB_vertex_program')
GL_VERTEX_ATTRIB_ARRAY_NORMALIZED_ARB = Enumerant('GL_VERTEX_ATTRIB_ARRAY_NORMALIZED_ARB', 0x886a, 'GL_ARB_vertex_program')
GL_VERTEX_ATTRIB_ARRAY_POINTER_ARB = Enumerant('GL_VERTEX_ATTRIB_ARRAY_POINTER_ARB', 0x8645, 'GL_ARB_vertex_program')
GL_VERTEX_ATTRIB_ARRAY_SIZE_ARB = Enumerant('GL_VERTEX_ATTRIB_ARRAY_SIZE_ARB', 0x8623, 'GL_ARB_vertex_program')
GL_VERTEX_ATTRIB_ARRAY_STRIDE_ARB = Enumerant('GL_VERTEX_ATTRIB_ARRAY_STRIDE_ARB', 0x8624, 'GL_ARB_vertex_program')
GL_VERTEX_ATTRIB_ARRAY_TYPE_ARB = Enumerant('GL_VERTEX_ATTRIB_ARRAY_TYPE_ARB', 0x8625, 'GL_ARB_vertex_program')
GL_VERTEX_PROGRAM_ARB = Enumerant('GL_VERTEX_PROGRAM_ARB', 0x8620, 'GL_ARB_vertex_program')
GL_VERTEX_PROGRAM_POINT_SIZE_ARB = Enumerant('GL_VERTEX_PROGRAM_POINT_SIZE_ARB', 0x8642, 'GL_ARB_vertex_program')
GL_VERTEX_PROGRAM_TWO_SIDE_ARB = Enumerant('GL_VERTEX_PROGRAM_TWO_SIDE_ARB', 0x8643, 'GL_ARB_vertex_program')

defines.add(GL_COLOR_SUM_ARB)
defines.add(GL_CURRENT_MATRIX_ARB)
defines.add(GL_CURRENT_MATRIX_STACK_DEPTH_ARB)
defines.add(GL_CURRENT_VERTEX_ATTRIB_ARB)
defines.add(GL_MATRIX0_ARB)
defines.add(GL_MATRIX10_ARB)
defines.add(GL_MATRIX11_ARB)
defines.add(GL_MATRIX12_ARB)
defines.add(GL_MATRIX13_ARB)
defines.add(GL_MATRIX14_ARB)
defines.add(GL_MATRIX15_ARB)
defines.add(GL_MATRIX16_ARB)
defines.add(GL_MATRIX17_ARB)
defines.add(GL_MATRIX18_ARB)
defines.add(GL_MATRIX19_ARB)
defines.add(GL_MATRIX1_ARB)
defines.add(GL_MATRIX20_ARB)
defines.add(GL_MATRIX21_ARB)
defines.add(GL_MATRIX22_ARB)
defines.add(GL_MATRIX23_ARB)
defines.add(GL_MATRIX24_ARB)
defines.add(GL_MATRIX25_ARB)
defines.add(GL_MATRIX26_ARB)
defines.add(GL_MATRIX27_ARB)
defines.add(GL_MATRIX28_ARB)
defines.add(GL_MATRIX29_ARB)
defines.add(GL_MATRIX2_ARB)
defines.add(GL_MATRIX30_ARB)
defines.add(GL_MATRIX31_ARB)
defines.add(GL_MATRIX3_ARB)
defines.add(GL_MATRIX4_ARB)
defines.add(GL_MATRIX5_ARB)
defines.add(GL_MATRIX6_ARB)
defines.add(GL_MATRIX7_ARB)
defines.add(GL_MATRIX8_ARB)
defines.add(GL_MATRIX9_ARB)
defines.add(GL_MAX_PROGRAM_ADDRESS_REGISTERS_ARB)
defines.add(GL_MAX_PROGRAM_ATTRIBS_ARB)
defines.add(GL_MAX_PROGRAM_ENV_PARAMETERS_ARB)
defines.add(GL_MAX_PROGRAM_INSTRUCTIONS_ARB)
defines.add(GL_MAX_PROGRAM_LOCAL_PARAMETERS_ARB)
defines.add(GL_MAX_PROGRAM_MATRICES_ARB)
defines.add(GL_MAX_PROGRAM_MATRIX_STACK_DEPTH_ARB)
defines.add(GL_MAX_PROGRAM_NATIVE_ADDRESS_REGISTERS_ARB)
defines.add(GL_MAX_PROGRAM_NATIVE_ATTRIBS_ARB)
defines.add(GL_MAX_PROGRAM_NATIVE_INSTRUCTIONS_ARB)
defines.add(GL_MAX_PROGRAM_NATIVE_PARAMETERS_ARB)
defines.add(GL_MAX_PROGRAM_NATIVE_TEMPORARIES_ARB)
defines.add(GL_MAX_PROGRAM_PARAMETERS_ARB)
defines.add(GL_MAX_PROGRAM_TEMPORARIES_ARB)
defines.add(GL_MAX_VERTEX_ATTRIBS_ARB)
defines.add(GL_PROGRAM_ADDRESS_REGISTERS_ARB)
defines.add(GL_PROGRAM_ATTRIBS_ARB)
defines.add(GL_PROGRAM_BINDING_ARB)
defines.add(GL_PROGRAM_ERROR_POSITION_ARB)
defines.add(GL_PROGRAM_ERROR_STRING_ARB)
defines.add(GL_PROGRAM_FORMAT_ARB)
defines.add(GL_PROGRAM_FORMAT_ASCII_ARB)
defines.add(GL_PROGRAM_INSTRUCTIONS_ARB)
defines.add(GL_PROGRAM_LENGTH_ARB)
defines.add(GL_PROGRAM_NATIVE_ADDRESS_REGISTERS_ARB)
defines.add(GL_PROGRAM_NATIVE_ATTRIBS_ARB)
defines.add(GL_PROGRAM_NATIVE_INSTRUCTIONS_ARB)
defines.add(GL_PROGRAM_NATIVE_PARAMETERS_ARB)
defines.add(GL_PROGRAM_NATIVE_TEMPORARIES_ARB)
defines.add(GL_PROGRAM_PARAMETERS_ARB)
defines.add(GL_PROGRAM_STRING_ARB)
defines.add(GL_PROGRAM_TEMPORARIES_ARB)
defines.add(GL_PROGRAM_UNDER_NATIVE_LIMITS_ARB)
defines.add(GL_TRANSPOSE_CURRENT_MATRIX_ARB)
defines.add(GL_VERTEX_ATTRIB_ARRAY_ENABLED_ARB)
defines.add(GL_VERTEX_ATTRIB_ARRAY_NORMALIZED_ARB)
defines.add(GL_VERTEX_ATTRIB_ARRAY_POINTER_ARB)
defines.add(GL_VERTEX_ATTRIB_ARRAY_SIZE_ARB)
defines.add(GL_VERTEX_ATTRIB_ARRAY_STRIDE_ARB)
defines.add(GL_VERTEX_ATTRIB_ARRAY_TYPE_ARB)
defines.add(GL_VERTEX_PROGRAM_ARB)
defines.add(GL_VERTEX_PROGRAM_POINT_SIZE_ARB)
defines.add(GL_VERTEX_PROGRAM_TWO_SIDE_ARB)

# GL_ARB_vertex_shader

GL_MAX_COMBINED_TEXTURE_IMAGE_UNITS_ARB = Enumerant('GL_MAX_COMBINED_TEXTURE_IMAGE_UNITS_ARB', 0x8b4d, 'GL_ARB_vertex_shader')
GL_MAX_VARYING_FLOATS_ARB = Enumerant('GL_MAX_VARYING_FLOATS_ARB', 0x8b4b, 'GL_ARB_vertex_shader')
GL_MAX_VERTEX_TEXTURE_IMAGE_UNITS_ARB = Enumerant('GL_MAX_VERTEX_TEXTURE_IMAGE_UNITS_ARB', 0x8b4c, 'GL_ARB_vertex_shader')
GL_MAX_VERTEX_UNIFORM_COMPONENTS_ARB = Enumerant('GL_MAX_VERTEX_UNIFORM_COMPONENTS_ARB', 0x8b4a, 'GL_ARB_vertex_shader')
GL_OBJECT_ACTIVE_ATTRIBUTES_ARB = Enumerant('GL_OBJECT_ACTIVE_ATTRIBUTES_ARB', 0x8b89, 'GL_ARB_vertex_shader')
GL_OBJECT_ACTIVE_ATTRIBUTE_MAX_LENGTH_ARB = Enumerant('GL_OBJECT_ACTIVE_ATTRIBUTE_MAX_LENGTH_ARB', 0x8b8a, 'GL_ARB_vertex_shader')
GL_VERTEX_SHADER_ARB = Enumerant('GL_VERTEX_SHADER_ARB', 0x8b31, 'GL_ARB_vertex_shader')

defines.add(GL_MAX_COMBINED_TEXTURE_IMAGE_UNITS_ARB)
defines.add(GL_MAX_VARYING_FLOATS_ARB)
defines.add(GL_MAX_VERTEX_TEXTURE_IMAGE_UNITS_ARB)
defines.add(GL_MAX_VERTEX_UNIFORM_COMPONENTS_ARB)
defines.add(GL_OBJECT_ACTIVE_ATTRIBUTES_ARB)
defines.add(GL_OBJECT_ACTIVE_ATTRIBUTE_MAX_LENGTH_ARB)
defines.add(GL_VERTEX_SHADER_ARB)

# GL_ARB_vertex_type_2_10_10_10_rev

GL_INT_2_10_10_10_REV = Enumerant('GL_INT_2_10_10_10_REV', 0x8d9f, 'GL_ARB_vertex_type_2_10_10_10_rev')

defines.add(GL_INT_2_10_10_10_REV)

# GL_ARB_viewport_array

GL_LAYER_PROVOKING_VERTEX = Enumerant('GL_LAYER_PROVOKING_VERTEX', 0x825e, 'GL_ARB_viewport_array')
GL_MAX_VIEWPORTS = Enumerant('GL_MAX_VIEWPORTS', 0x825b, 'GL_ARB_viewport_array')
GL_UNDEFINED_VERTEX = Enumerant('GL_UNDEFINED_VERTEX', 0x8260, 'GL_ARB_viewport_array')
GL_VIEWPORT_BOUNDS_RANGE = Enumerant('GL_VIEWPORT_BOUNDS_RANGE', 0x825d, 'GL_ARB_viewport_array')
GL_VIEWPORT_INDEX_PROVOKING_VERTEX = Enumerant('GL_VIEWPORT_INDEX_PROVOKING_VERTEX', 0x825f, 'GL_ARB_viewport_array')
GL_VIEWPORT_SUBPIXEL_BITS = Enumerant('GL_VIEWPORT_SUBPIXEL_BITS', 0x825c, 'GL_ARB_viewport_array')

defines.add(GL_LAYER_PROVOKING_VERTEX)
defines.add(GL_MAX_VIEWPORTS)
defines.add(GL_UNDEFINED_VERTEX)
defines.add(GL_VIEWPORT_BOUNDS_RANGE)
defines.add(GL_VIEWPORT_INDEX_PROVOKING_VERTEX)
defines.add(GL_VIEWPORT_SUBPIXEL_BITS)

# GL_ARM_mali_program_binary

GL_MALI_PROGRAM_BINARY_ARM = Enumerant('GL_MALI_PROGRAM_BINARY_ARM', 0x8f61, 'GL_ARM_mali_program_binary')

defines.add(GL_MALI_PROGRAM_BINARY_ARM)

# GL_ARM_mali_shader_binary

GL_MALI_SHADER_BINARY_ARM = Enumerant('GL_MALI_SHADER_BINARY_ARM', 0x8f60, 'GL_ARM_mali_shader_binary')

defines.add(GL_MALI_SHADER_BINARY_ARM)

# GL_ATI_draw_buffers

GL_DRAW_BUFFER0_ATI = Enumerant('GL_DRAW_BUFFER0_ATI', 0x8825, 'GL_ATI_draw_buffers')
GL_DRAW_BUFFER10_ATI = Enumerant('GL_DRAW_BUFFER10_ATI', 0x882f, 'GL_ATI_draw_buffers')
GL_DRAW_BUFFER11_ATI = Enumerant('GL_DRAW_BUFFER11_ATI', 0x8830, 'GL_ATI_draw_buffers')
GL_DRAW_BUFFER12_ATI = Enumerant('GL_DRAW_BUFFER12_ATI', 0x8831, 'GL_ATI_draw_buffers')
GL_DRAW_BUFFER13_ATI = Enumerant('GL_DRAW_BUFFER13_ATI', 0x8832, 'GL_ATI_draw_buffers')
GL_DRAW_BUFFER14_ATI = Enumerant('GL_DRAW_BUFFER14_ATI', 0x8833, 'GL_ATI_draw_buffers')
GL_DRAW_BUFFER15_ATI = Enumerant('GL_DRAW_BUFFER15_ATI', 0x8834, 'GL_ATI_draw_buffers')
GL_DRAW_BUFFER1_ATI = Enumerant('GL_DRAW_BUFFER1_ATI', 0x8826, 'GL_ATI_draw_buffers')
GL_DRAW_BUFFER2_ATI = Enumerant('GL_DRAW_BUFFER2_ATI', 0x8827, 'GL_ATI_draw_buffers')
GL_DRAW_BUFFER3_ATI = Enumerant('GL_DRAW_BUFFER3_ATI', 0x8828, 'GL_ATI_draw_buffers')
GL_DRAW_BUFFER4_ATI = Enumerant('GL_DRAW_BUFFER4_ATI', 0x8829, 'GL_ATI_draw_buffers')
GL_DRAW_BUFFER5_ATI = Enumerant('GL_DRAW_BUFFER5_ATI', 0x882a, 'GL_ATI_draw_buffers')
GL_DRAW_BUFFER6_ATI = Enumerant('GL_DRAW_BUFFER6_ATI', 0x882b, 'GL_ATI_draw_buffers')
GL_DRAW_BUFFER7_ATI = Enumerant('GL_DRAW_BUFFER7_ATI', 0x882c, 'GL_ATI_draw_buffers')
GL_DRAW_BUFFER8_ATI = Enumerant('GL_DRAW_BUFFER8_ATI', 0x882d, 'GL_ATI_draw_buffers')
GL_DRAW_BUFFER9_ATI = Enumerant('GL_DRAW_BUFFER9_ATI', 0x882e, 'GL_ATI_draw_buffers')
GL_MAX_DRAW_BUFFERS_ATI = Enumerant('GL_MAX_DRAW_BUFFERS_ATI', 0x8824, 'GL_ATI_draw_buffers')

defines.add(GL_DRAW_BUFFER0_ATI)
defines.add(GL_DRAW_BUFFER10_ATI)
defines.add(GL_DRAW_BUFFER11_ATI)
defines.add(GL_DRAW_BUFFER12_ATI)
defines.add(GL_DRAW_BUFFER13_ATI)
defines.add(GL_DRAW_BUFFER14_ATI)
defines.add(GL_DRAW_BUFFER15_ATI)
defines.add(GL_DRAW_BUFFER1_ATI)
defines.add(GL_DRAW_BUFFER2_ATI)
defines.add(GL_DRAW_BUFFER3_ATI)
defines.add(GL_DRAW_BUFFER4_ATI)
defines.add(GL_DRAW_BUFFER5_ATI)
defines.add(GL_DRAW_BUFFER6_ATI)
defines.add(GL_DRAW_BUFFER7_ATI)
defines.add(GL_DRAW_BUFFER8_ATI)
defines.add(GL_DRAW_BUFFER9_ATI)
defines.add(GL_MAX_DRAW_BUFFERS_ATI)

# GL_ATI_element_array

GL_ELEMENT_ARRAY_ATI = Enumerant('GL_ELEMENT_ARRAY_ATI', 0x8768, 'GL_ATI_element_array')
GL_ELEMENT_ARRAY_POINTER_ATI = Enumerant('GL_ELEMENT_ARRAY_POINTER_ATI', 0x876a, 'GL_ATI_element_array')
GL_ELEMENT_ARRAY_TYPE_ATI = Enumerant('GL_ELEMENT_ARRAY_TYPE_ATI', 0x8769, 'GL_ATI_element_array')

defines.add(GL_ELEMENT_ARRAY_ATI)
defines.add(GL_ELEMENT_ARRAY_POINTER_ATI)
defines.add(GL_ELEMENT_ARRAY_TYPE_ATI)

# GL_ATI_envmap_bumpmap

GL_BUMP_ENVMAP_ATI = Enumerant('GL_BUMP_ENVMAP_ATI', 0x877b, 'GL_ATI_envmap_bumpmap')
GL_BUMP_NUM_TEX_UNITS_ATI = Enumerant('GL_BUMP_NUM_TEX_UNITS_ATI', 0x8777, 'GL_ATI_envmap_bumpmap')
GL_BUMP_ROT_MATRIX_ATI = Enumerant('GL_BUMP_ROT_MATRIX_ATI', 0x8775, 'GL_ATI_envmap_bumpmap')
GL_BUMP_ROT_MATRIX_SIZE_ATI = Enumerant('GL_BUMP_ROT_MATRIX_SIZE_ATI', 0x8776, 'GL_ATI_envmap_bumpmap')
GL_BUMP_TARGET_ATI = Enumerant('GL_BUMP_TARGET_ATI', 0x877c, 'GL_ATI_envmap_bumpmap')
GL_BUMP_TEX_UNITS_ATI = Enumerant('GL_BUMP_TEX_UNITS_ATI', 0x8778, 'GL_ATI_envmap_bumpmap')
GL_DU8DV8_ATI = Enumerant('GL_DU8DV8_ATI', 0x877a, 'GL_ATI_envmap_bumpmap')
GL_DUDV_ATI = Enumerant('GL_DUDV_ATI', 0x8779, 'GL_ATI_envmap_bumpmap')

defines.add(GL_BUMP_ENVMAP_ATI)
defines.add(GL_BUMP_NUM_TEX_UNITS_ATI)
defines.add(GL_BUMP_ROT_MATRIX_ATI)
defines.add(GL_BUMP_ROT_MATRIX_SIZE_ATI)
defines.add(GL_BUMP_TARGET_ATI)
defines.add(GL_BUMP_TEX_UNITS_ATI)
defines.add(GL_DU8DV8_ATI)
defines.add(GL_DUDV_ATI)

# GL_ATI_fragment_shader

GL_2X_BIT_ATI = Enumerant('GL_2X_BIT_ATI', 0x0001, 'GL_ATI_fragment_shader')
GL_4X_BIT_ATI = Enumerant('GL_4X_BIT_ATI', 0x0002, 'GL_ATI_fragment_shader')
GL_8X_BIT_ATI = Enumerant('GL_8X_BIT_ATI', 0x0004, 'GL_ATI_fragment_shader')
GL_ADD_ATI = Enumerant('GL_ADD_ATI', 0x8963, 'GL_ATI_fragment_shader')
GL_BIAS_BIT_ATI = Enumerant('GL_BIAS_BIT_ATI', 0x0008, 'GL_ATI_fragment_shader')
GL_BLUE_BIT_ATI = Enumerant('GL_BLUE_BIT_ATI', 0x0004, 'GL_ATI_fragment_shader')
GL_CND0_ATI = Enumerant('GL_CND0_ATI', 0x896b, 'GL_ATI_fragment_shader')
GL_CND_ATI = Enumerant('GL_CND_ATI', 0x896a, 'GL_ATI_fragment_shader')
GL_COLOR_ALPHA_PAIRING_ATI = Enumerant('GL_COLOR_ALPHA_PAIRING_ATI', 0x8975, 'GL_ATI_fragment_shader')
GL_COMP_BIT_ATI = Enumerant('GL_COMP_BIT_ATI', 0x0002, 'GL_ATI_fragment_shader')
GL_CON_0_ATI = Enumerant('GL_CON_0_ATI', 0x8941, 'GL_ATI_fragment_shader')
GL_CON_1_ATI = Enumerant('GL_CON_1_ATI', 0x8942, 'GL_ATI_fragment_shader')
GL_CON_2_ATI = Enumerant('GL_CON_2_ATI', 0x8943, 'GL_ATI_fragment_shader')
GL_CON_3_ATI = Enumerant('GL_CON_3_ATI', 0x8944, 'GL_ATI_fragment_shader')
GL_CON_4_ATI = Enumerant('GL_CON_4_ATI', 0x8945, 'GL_ATI_fragment_shader')
GL_CON_5_ATI = Enumerant('GL_CON_5_ATI', 0x8946, 'GL_ATI_fragment_shader')
GL_CON_6_ATI = Enumerant('GL_CON_6_ATI', 0x8947, 'GL_ATI_fragment_shader')
GL_CON_7_ATI = Enumerant('GL_CON_7_ATI', 0x8948, 'GL_ATI_fragment_shader')
GL_DOT2_ADD_ATI = Enumerant('GL_DOT2_ADD_ATI', 0x896c, 'GL_ATI_fragment_shader')
GL_DOT3_ATI = Enumerant('GL_DOT3_ATI', 0x8966, 'GL_ATI_fragment_shader')
GL_DOT4_ATI = Enumerant('GL_DOT4_ATI', 0x8967, 'GL_ATI_fragment_shader')
GL_EIGHTH_BIT_ATI = Enumerant('GL_EIGHTH_BIT_ATI', 0x0020, 'GL_ATI_fragment_shader')
GL_FRAGMENT_SHADER_ATI = Enumerant('GL_FRAGMENT_SHADER_ATI', 0x8920, 'GL_ATI_fragment_shader')
GL_GREEN_BIT_ATI = Enumerant('GL_GREEN_BIT_ATI', 0x0002, 'GL_ATI_fragment_shader')
GL_HALF_BIT_ATI = Enumerant('GL_HALF_BIT_ATI', 0x0008, 'GL_ATI_fragment_shader')
GL_LERP_ATI = Enumerant('GL_LERP_ATI', 0x8969, 'GL_ATI_fragment_shader')
GL_MAD_ATI = Enumerant('GL_MAD_ATI', 0x8968, 'GL_ATI_fragment_shader')
GL_MOV_ATI = Enumerant('GL_MOV_ATI', 0x8961, 'GL_ATI_fragment_shader')
GL_MUL_ATI = Enumerant('GL_MUL_ATI', 0x8964, 'GL_ATI_fragment_shader')
GL_NEGATE_BIT_ATI = Enumerant('GL_NEGATE_BIT_ATI', 0x0004, 'GL_ATI_fragment_shader')
GL_NUM_FRAGMENT_CONSTANTS_ATI = Enumerant('GL_NUM_FRAGMENT_CONSTANTS_ATI', 0x896f, 'GL_ATI_fragment_shader')
GL_NUM_FRAGMENT_REGISTERS_ATI = Enumerant('GL_NUM_FRAGMENT_REGISTERS_ATI', 0x896e, 'GL_ATI_fragment_shader')
GL_NUM_INPUT_INTERPOLATOR_COMPONENTS_ATI = Enumerant('GL_NUM_INPUT_INTERPOLATOR_COMPONENTS_ATI', 0x8973, 'GL_ATI_fragment_shader')
GL_NUM_INSTRUCTIONS_PER_PASS_ATI = Enumerant('GL_NUM_INSTRUCTIONS_PER_PASS_ATI', 0x8971, 'GL_ATI_fragment_shader')
GL_NUM_INSTRUCTIONS_TOTAL_ATI = Enumerant('GL_NUM_INSTRUCTIONS_TOTAL_ATI', 0x8972, 'GL_ATI_fragment_shader')
GL_NUM_LOOPBACK_COMPONENTS_ATI = Enumerant('GL_NUM_LOOPBACK_COMPONENTS_ATI', 0x8974, 'GL_ATI_fragment_shader')
GL_NUM_PASSES_ATI = Enumerant('GL_NUM_PASSES_ATI', 0x8970, 'GL_ATI_fragment_shader')
GL_QUARTER_BIT_ATI = Enumerant('GL_QUARTER_BIT_ATI', 0x0010, 'GL_ATI_fragment_shader')
GL_RED_BIT_ATI = Enumerant('GL_RED_BIT_ATI', 0x0001, 'GL_ATI_fragment_shader')
GL_REG_0_ATI = Enumerant('GL_REG_0_ATI', 0x8921, 'GL_ATI_fragment_shader')
GL_REG_1_ATI = Enumerant('GL_REG_1_ATI', 0x8922, 'GL_ATI_fragment_shader')
GL_REG_2_ATI = Enumerant('GL_REG_2_ATI', 0x8923, 'GL_ATI_fragment_shader')
GL_REG_3_ATI = Enumerant('GL_REG_3_ATI', 0x8924, 'GL_ATI_fragment_shader')
GL_REG_4_ATI = Enumerant('GL_REG_4_ATI', 0x8925, 'GL_ATI_fragment_shader')
GL_REG_5_ATI = Enumerant('GL_REG_5_ATI', 0x8926, 'GL_ATI_fragment_shader')
GL_SATURATE_BIT_ATI = Enumerant('GL_SATURATE_BIT_ATI', 0x0040, 'GL_ATI_fragment_shader')
GL_SECONDARY_INTERPOLATOR_ATI = Enumerant('GL_SECONDARY_INTERPOLATOR_ATI', 0x896d, 'GL_ATI_fragment_shader')
GL_SUB_ATI = Enumerant('GL_SUB_ATI', 0x8965, 'GL_ATI_fragment_shader')
GL_SWIZZLE_STQ_ATI = Enumerant('GL_SWIZZLE_STQ_ATI', 0x8977, 'GL_ATI_fragment_shader')
GL_SWIZZLE_STQ_DQ_ATI = Enumerant('GL_SWIZZLE_STQ_DQ_ATI', 0x8979, 'GL_ATI_fragment_shader')
GL_SWIZZLE_STRQ_ATI = Enumerant('GL_SWIZZLE_STRQ_ATI', 0x897a, 'GL_ATI_fragment_shader')
GL_SWIZZLE_STRQ_DQ_ATI = Enumerant('GL_SWIZZLE_STRQ_DQ_ATI', 0x897b, 'GL_ATI_fragment_shader')
GL_SWIZZLE_STR_ATI = Enumerant('GL_SWIZZLE_STR_ATI', 0x8976, 'GL_ATI_fragment_shader')
GL_SWIZZLE_STR_DR_ATI = Enumerant('GL_SWIZZLE_STR_DR_ATI', 0x8978, 'GL_ATI_fragment_shader')

defines.add(GL_2X_BIT_ATI)
defines.add(GL_4X_BIT_ATI)
defines.add(GL_8X_BIT_ATI)
defines.add(GL_ADD_ATI)
defines.add(GL_BIAS_BIT_ATI)
defines.add(GL_BLUE_BIT_ATI)
defines.add(GL_CND0_ATI)
defines.add(GL_CND_ATI)
defines.add(GL_COLOR_ALPHA_PAIRING_ATI)
defines.add(GL_COMP_BIT_ATI)
defines.add(GL_CON_0_ATI)
defines.add(GL_CON_1_ATI)
defines.add(GL_CON_2_ATI)
defines.add(GL_CON_3_ATI)
defines.add(GL_CON_4_ATI)
defines.add(GL_CON_5_ATI)
defines.add(GL_CON_6_ATI)
defines.add(GL_CON_7_ATI)
defines.add(GL_DOT2_ADD_ATI)
defines.add(GL_DOT3_ATI)
defines.add(GL_DOT4_ATI)
defines.add(GL_EIGHTH_BIT_ATI)
defines.add(GL_FRAGMENT_SHADER_ATI)
defines.add(GL_GREEN_BIT_ATI)
defines.add(GL_HALF_BIT_ATI)
defines.add(GL_LERP_ATI)
defines.add(GL_MAD_ATI)
defines.add(GL_MOV_ATI)
defines.add(GL_MUL_ATI)
defines.add(GL_NEGATE_BIT_ATI)
defines.add(GL_NUM_FRAGMENT_CONSTANTS_ATI)
defines.add(GL_NUM_FRAGMENT_REGISTERS_ATI)
defines.add(GL_NUM_INPUT_INTERPOLATOR_COMPONENTS_ATI)
defines.add(GL_NUM_INSTRUCTIONS_PER_PASS_ATI)
defines.add(GL_NUM_INSTRUCTIONS_TOTAL_ATI)
defines.add(GL_NUM_LOOPBACK_COMPONENTS_ATI)
defines.add(GL_NUM_PASSES_ATI)
defines.add(GL_QUARTER_BIT_ATI)
defines.add(GL_RED_BIT_ATI)
defines.add(GL_REG_0_ATI)
defines.add(GL_REG_1_ATI)
defines.add(GL_REG_2_ATI)
defines.add(GL_REG_3_ATI)
defines.add(GL_REG_4_ATI)
defines.add(GL_REG_5_ATI)
defines.add(GL_SATURATE_BIT_ATI)
defines.add(GL_SECONDARY_INTERPOLATOR_ATI)
defines.add(GL_SUB_ATI)
defines.add(GL_SWIZZLE_STQ_ATI)
defines.add(GL_SWIZZLE_STQ_DQ_ATI)
defines.add(GL_SWIZZLE_STRQ_ATI)
defines.add(GL_SWIZZLE_STRQ_DQ_ATI)
defines.add(GL_SWIZZLE_STR_ATI)
defines.add(GL_SWIZZLE_STR_DR_ATI)

# GL_ATI_meminfo

GL_RENDERBUFFER_FREE_MEMORY_ATI = Enumerant('GL_RENDERBUFFER_FREE_MEMORY_ATI', 0x87fd, 'GL_ATI_meminfo')
GL_TEXTURE_FREE_MEMORY_ATI = Enumerant('GL_TEXTURE_FREE_MEMORY_ATI', 0x87fc, 'GL_ATI_meminfo')
GL_VBO_FREE_MEMORY_ATI = Enumerant('GL_VBO_FREE_MEMORY_ATI', 0x87fb, 'GL_ATI_meminfo')

defines.add(GL_RENDERBUFFER_FREE_MEMORY_ATI)
defines.add(GL_TEXTURE_FREE_MEMORY_ATI)
defines.add(GL_VBO_FREE_MEMORY_ATI)

# GL_ATI_pn_triangles

GL_MAX_PN_TRIANGLES_TESSELATION_LEVEL_ATI = Enumerant('GL_MAX_PN_TRIANGLES_TESSELATION_LEVEL_ATI', 0x87f1, 'GL_ATI_pn_triangles')
GL_PN_TRIANGLES_ATI = Enumerant('GL_PN_TRIANGLES_ATI', 0x87f0, 'GL_ATI_pn_triangles')
GL_PN_TRIANGLES_NORMAL_MODE_ATI = Enumerant('GL_PN_TRIANGLES_NORMAL_MODE_ATI', 0x87f3, 'GL_ATI_pn_triangles')
GL_PN_TRIANGLES_NORMAL_MODE_LINEAR_ATI = Enumerant('GL_PN_TRIANGLES_NORMAL_MODE_LINEAR_ATI', 0x87f7, 'GL_ATI_pn_triangles')
GL_PN_TRIANGLES_NORMAL_MODE_QUADRATIC_ATI = Enumerant('GL_PN_TRIANGLES_NORMAL_MODE_QUADRATIC_ATI', 0x87f8, 'GL_ATI_pn_triangles')
GL_PN_TRIANGLES_POINT_MODE_ATI = Enumerant('GL_PN_TRIANGLES_POINT_MODE_ATI', 0x87f2, 'GL_ATI_pn_triangles')
GL_PN_TRIANGLES_POINT_MODE_CUBIC_ATI = Enumerant('GL_PN_TRIANGLES_POINT_MODE_CUBIC_ATI', 0x87f6, 'GL_ATI_pn_triangles')
GL_PN_TRIANGLES_POINT_MODE_LINEAR_ATI = Enumerant('GL_PN_TRIANGLES_POINT_MODE_LINEAR_ATI', 0x87f5, 'GL_ATI_pn_triangles')
GL_PN_TRIANGLES_TESSELATION_LEVEL_ATI = Enumerant('GL_PN_TRIANGLES_TESSELATION_LEVEL_ATI', 0x87f4, 'GL_ATI_pn_triangles')

defines.add(GL_MAX_PN_TRIANGLES_TESSELATION_LEVEL_ATI)
defines.add(GL_PN_TRIANGLES_ATI)
defines.add(GL_PN_TRIANGLES_NORMAL_MODE_ATI)
defines.add(GL_PN_TRIANGLES_NORMAL_MODE_LINEAR_ATI)
defines.add(GL_PN_TRIANGLES_NORMAL_MODE_QUADRATIC_ATI)
defines.add(GL_PN_TRIANGLES_POINT_MODE_ATI)
defines.add(GL_PN_TRIANGLES_POINT_MODE_CUBIC_ATI)
defines.add(GL_PN_TRIANGLES_POINT_MODE_LINEAR_ATI)
defines.add(GL_PN_TRIANGLES_TESSELATION_LEVEL_ATI)

# GL_ATI_separate_stencil

GL_STENCIL_BACK_FAIL_ATI = Enumerant('GL_STENCIL_BACK_FAIL_ATI', 0x8801, 'GL_ATI_separate_stencil')
GL_STENCIL_BACK_FUNC_ATI = Enumerant('GL_STENCIL_BACK_FUNC_ATI', 0x8800, 'GL_ATI_separate_stencil')
GL_STENCIL_BACK_PASS_DEPTH_FAIL_ATI = Enumerant('GL_STENCIL_BACK_PASS_DEPTH_FAIL_ATI', 0x8802, 'GL_ATI_separate_stencil')
GL_STENCIL_BACK_PASS_DEPTH_PASS_ATI = Enumerant('GL_STENCIL_BACK_PASS_DEPTH_PASS_ATI', 0x8803, 'GL_ATI_separate_stencil')

defines.add(GL_STENCIL_BACK_FAIL_ATI)
defines.add(GL_STENCIL_BACK_FUNC_ATI)
defines.add(GL_STENCIL_BACK_PASS_DEPTH_FAIL_ATI)
defines.add(GL_STENCIL_BACK_PASS_DEPTH_PASS_ATI)

# GL_ATI_text_fragment_shader

GL_TEXT_FRAGMENT_SHADER_ATI = Enumerant('GL_TEXT_FRAGMENT_SHADER_ATI', 0x8200, 'GL_ATI_text_fragment_shader')

defines.add(GL_TEXT_FRAGMENT_SHADER_ATI)

# GL_ATI_texture_compression_3dc

GL_COMPRESSED_LUMINANCE_ALPHA_3DC_ATI = Enumerant('GL_COMPRESSED_LUMINANCE_ALPHA_3DC_ATI', 0x8837, 'GL_ATI_texture_compression_3dc')

defines.add(GL_COMPRESSED_LUMINANCE_ALPHA_3DC_ATI)

# GL_ATI_texture_env_combine3

GL_MODULATE_ADD_ATI = Enumerant('GL_MODULATE_ADD_ATI', 0x8744, 'GL_ATI_texture_env_combine3')
GL_MODULATE_SIGNED_ADD_ATI = Enumerant('GL_MODULATE_SIGNED_ADD_ATI', 0x8745, 'GL_ATI_texture_env_combine3')
GL_MODULATE_SUBTRACT_ATI = Enumerant('GL_MODULATE_SUBTRACT_ATI', 0x8746, 'GL_ATI_texture_env_combine3')

defines.add(GL_MODULATE_ADD_ATI)
defines.add(GL_MODULATE_SIGNED_ADD_ATI)
defines.add(GL_MODULATE_SUBTRACT_ATI)

# GL_ATI_texture_float

GL_ALPHA_FLOAT16_ATI = Enumerant('GL_ALPHA_FLOAT16_ATI', 0x881c, 'GL_ATI_texture_float')
GL_ALPHA_FLOAT32_ATI = Enumerant('GL_ALPHA_FLOAT32_ATI', 0x8816, 'GL_ATI_texture_float')
GL_INTENSITY_FLOAT16_ATI = Enumerant('GL_INTENSITY_FLOAT16_ATI', 0x881d, 'GL_ATI_texture_float')
GL_INTENSITY_FLOAT32_ATI = Enumerant('GL_INTENSITY_FLOAT32_ATI', 0x8817, 'GL_ATI_texture_float')
GL_LUMINANCE_ALPHA_FLOAT16_ATI = Enumerant('GL_LUMINANCE_ALPHA_FLOAT16_ATI', 0x881f, 'GL_ATI_texture_float')
GL_LUMINANCE_ALPHA_FLOAT32_ATI = Enumerant('GL_LUMINANCE_ALPHA_FLOAT32_ATI', 0x8819, 'GL_ATI_texture_float')
GL_LUMINANCE_FLOAT16_ATI = Enumerant('GL_LUMINANCE_FLOAT16_ATI', 0x881e, 'GL_ATI_texture_float')
GL_LUMINANCE_FLOAT32_ATI = Enumerant('GL_LUMINANCE_FLOAT32_ATI', 0x8818, 'GL_ATI_texture_float')
GL_RGBA_FLOAT16_ATI = Enumerant('GL_RGBA_FLOAT16_ATI', 0x881a, 'GL_ATI_texture_float')
GL_RGBA_FLOAT32_ATI = Enumerant('GL_RGBA_FLOAT32_ATI', 0x8814, 'GL_ATI_texture_float')
GL_RGB_FLOAT16_ATI = Enumerant('GL_RGB_FLOAT16_ATI', 0x881b, 'GL_ATI_texture_float')
GL_RGB_FLOAT32_ATI = Enumerant('GL_RGB_FLOAT32_ATI', 0x8815, 'GL_ATI_texture_float')

defines.add(GL_ALPHA_FLOAT16_ATI)
defines.add(GL_ALPHA_FLOAT32_ATI)
defines.add(GL_INTENSITY_FLOAT16_ATI)
defines.add(GL_INTENSITY_FLOAT32_ATI)
defines.add(GL_LUMINANCE_ALPHA_FLOAT16_ATI)
defines.add(GL_LUMINANCE_ALPHA_FLOAT32_ATI)
defines.add(GL_LUMINANCE_FLOAT16_ATI)
defines.add(GL_LUMINANCE_FLOAT32_ATI)
defines.add(GL_RGBA_FLOAT16_ATI)
defines.add(GL_RGBA_FLOAT32_ATI)
defines.add(GL_RGB_FLOAT16_ATI)
defines.add(GL_RGB_FLOAT32_ATI)

# GL_ATI_texture_mirror_once

GL_MIRROR_CLAMP_ATI = Enumerant('GL_MIRROR_CLAMP_ATI', 0x8742, 'GL_ATI_texture_mirror_once')
GL_MIRROR_CLAMP_TO_EDGE_ATI = Enumerant('GL_MIRROR_CLAMP_TO_EDGE_ATI', 0x8743, 'GL_ATI_texture_mirror_once')

defines.add(GL_MIRROR_CLAMP_ATI)
defines.add(GL_MIRROR_CLAMP_TO_EDGE_ATI)

# GL_ATI_vertex_array_object

GL_ARRAY_OBJECT_BUFFER_ATI = Enumerant('GL_ARRAY_OBJECT_BUFFER_ATI', 0x8766, 'GL_ATI_vertex_array_object')
GL_ARRAY_OBJECT_OFFSET_ATI = Enumerant('GL_ARRAY_OBJECT_OFFSET_ATI', 0x8767, 'GL_ATI_vertex_array_object')
GL_DISCARD_ATI = Enumerant('GL_DISCARD_ATI', 0x8763, 'GL_ATI_vertex_array_object')
GL_DYNAMIC_ATI = Enumerant('GL_DYNAMIC_ATI', 0x8761, 'GL_ATI_vertex_array_object')
GL_OBJECT_BUFFER_SIZE_ATI = Enumerant('GL_OBJECT_BUFFER_SIZE_ATI', 0x8764, 'GL_ATI_vertex_array_object')
GL_OBJECT_BUFFER_USAGE_ATI = Enumerant('GL_OBJECT_BUFFER_USAGE_ATI', 0x8765, 'GL_ATI_vertex_array_object')
GL_PRESERVE_ATI = Enumerant('GL_PRESERVE_ATI', 0x8762, 'GL_ATI_vertex_array_object')
GL_STATIC_ATI = Enumerant('GL_STATIC_ATI', 0x8760, 'GL_ATI_vertex_array_object')

defines.add(GL_ARRAY_OBJECT_BUFFER_ATI)
defines.add(GL_ARRAY_OBJECT_OFFSET_ATI)
defines.add(GL_DISCARD_ATI)
defines.add(GL_DYNAMIC_ATI)
defines.add(GL_OBJECT_BUFFER_SIZE_ATI)
defines.add(GL_OBJECT_BUFFER_USAGE_ATI)
defines.add(GL_PRESERVE_ATI)
defines.add(GL_STATIC_ATI)

# GL_ATI_vertex_streams

GL_MAX_VERTEX_STREAMS_ATI = Enumerant('GL_MAX_VERTEX_STREAMS_ATI', 0x876b, 'GL_ATI_vertex_streams')
GL_VERTEX_SOURCE_ATI = Enumerant('GL_VERTEX_SOURCE_ATI', 0x876c, 'GL_ATI_vertex_streams')
GL_VERTEX_STREAM0_ATI = Enumerant('GL_VERTEX_STREAM0_ATI', 0x876d, 'GL_ATI_vertex_streams')
GL_VERTEX_STREAM1_ATI = Enumerant('GL_VERTEX_STREAM1_ATI', 0x876e, 'GL_ATI_vertex_streams')
GL_VERTEX_STREAM2_ATI = Enumerant('GL_VERTEX_STREAM2_ATI', 0x876f, 'GL_ATI_vertex_streams')
GL_VERTEX_STREAM3_ATI = Enumerant('GL_VERTEX_STREAM3_ATI', 0x8770, 'GL_ATI_vertex_streams')
GL_VERTEX_STREAM4_ATI = Enumerant('GL_VERTEX_STREAM4_ATI', 0x8771, 'GL_ATI_vertex_streams')
GL_VERTEX_STREAM5_ATI = Enumerant('GL_VERTEX_STREAM5_ATI', 0x8772, 'GL_ATI_vertex_streams')
GL_VERTEX_STREAM6_ATI = Enumerant('GL_VERTEX_STREAM6_ATI', 0x8773, 'GL_ATI_vertex_streams')
GL_VERTEX_STREAM7_ATI = Enumerant('GL_VERTEX_STREAM7_ATI', 0x8774, 'GL_ATI_vertex_streams')

defines.add(GL_MAX_VERTEX_STREAMS_ATI)
defines.add(GL_VERTEX_SOURCE_ATI)
defines.add(GL_VERTEX_STREAM0_ATI)
defines.add(GL_VERTEX_STREAM1_ATI)
defines.add(GL_VERTEX_STREAM2_ATI)
defines.add(GL_VERTEX_STREAM3_ATI)
defines.add(GL_VERTEX_STREAM4_ATI)
defines.add(GL_VERTEX_STREAM5_ATI)
defines.add(GL_VERTEX_STREAM6_ATI)
defines.add(GL_VERTEX_STREAM7_ATI)

# GL_DMP_shader_binary

GL_SHADER_BINARY_DMP = Enumerant('GL_SHADER_BINARY_DMP', 0x9250, 'GL_DMP_shader_binary')

defines.add(GL_SHADER_BINARY_DMP)

# GL_EXT_422_pixels

GL_422_AVERAGE_EXT = Enumerant('GL_422_AVERAGE_EXT', 0x80ce, 'GL_EXT_422_pixels')
GL_422_EXT = Enumerant('GL_422_EXT', 0x80cc, 'GL_EXT_422_pixels')
GL_422_REV_AVERAGE_EXT = Enumerant('GL_422_REV_AVERAGE_EXT', 0x80cf, 'GL_EXT_422_pixels')
GL_422_REV_EXT = Enumerant('GL_422_REV_EXT', 0x80cd, 'GL_EXT_422_pixels')

defines.add(GL_422_AVERAGE_EXT)
defines.add(GL_422_EXT)
defines.add(GL_422_REV_AVERAGE_EXT)
defines.add(GL_422_REV_EXT)

# GL_EXT_Cg_shader

GL_CG_FRAGMENT_SHADER_EXT = Enumerant('GL_CG_FRAGMENT_SHADER_EXT', 0x890f, 'GL_EXT_Cg_shader')
GL_CG_VERTEX_SHADER_EXT = Enumerant('GL_CG_VERTEX_SHADER_EXT', 0x890e, 'GL_EXT_Cg_shader')

defines.add(GL_CG_FRAGMENT_SHADER_EXT)
defines.add(GL_CG_VERTEX_SHADER_EXT)

# GL_EXT_abgr

GL_ABGR_EXT = Enumerant('GL_ABGR_EXT', 0x8000, 'GL_EXT_abgr')

defines.add(GL_ABGR_EXT)

# GL_EXT_bgra

GL_BGRA_EXT = Enumerant('GL_BGRA_EXT', 0x80e1, 'GL_EXT_bgra')
GL_BGR_EXT = Enumerant('GL_BGR_EXT', 0x80e0, 'GL_EXT_bgra')

defines.add(GL_BGRA_EXT)
defines.add(GL_BGR_EXT)

# GL_EXT_bindable_uniform

GL_MAX_BINDABLE_UNIFORM_SIZE_EXT = Enumerant('GL_MAX_BINDABLE_UNIFORM_SIZE_EXT', 0x8ded, 'GL_EXT_bindable_uniform')
GL_MAX_FRAGMENT_BINDABLE_UNIFORMS_EXT = Enumerant('GL_MAX_FRAGMENT_BINDABLE_UNIFORMS_EXT', 0x8de3, 'GL_EXT_bindable_uniform')
GL_MAX_GEOMETRY_BINDABLE_UNIFORMS_EXT = Enumerant('GL_MAX_GEOMETRY_BINDABLE_UNIFORMS_EXT', 0x8de4, 'GL_EXT_bindable_uniform')
GL_MAX_VERTEX_BINDABLE_UNIFORMS_EXT = Enumerant('GL_MAX_VERTEX_BINDABLE_UNIFORMS_EXT', 0x8de2, 'GL_EXT_bindable_uniform')
GL_UNIFORM_BUFFER_BINDING_EXT = Enumerant('GL_UNIFORM_BUFFER_BINDING_EXT', 0x8def, 'GL_EXT_bindable_uniform')
GL_UNIFORM_BUFFER_EXT = Enumerant('GL_UNIFORM_BUFFER_EXT', 0x8dee, 'GL_EXT_bindable_uniform')

defines.add(GL_MAX_BINDABLE_UNIFORM_SIZE_EXT)
defines.add(GL_MAX_FRAGMENT_BINDABLE_UNIFORMS_EXT)
defines.add(GL_MAX_GEOMETRY_BINDABLE_UNIFORMS_EXT)
defines.add(GL_MAX_VERTEX_BINDABLE_UNIFORMS_EXT)
defines.add(GL_UNIFORM_BUFFER_BINDING_EXT)
defines.add(GL_UNIFORM_BUFFER_EXT)

# GL_EXT_blend_color

GL_BLEND_COLOR_EXT = Enumerant('GL_BLEND_COLOR_EXT', 0x8005, 'GL_EXT_blend_color')
GL_CONSTANT_ALPHA_EXT = Enumerant('GL_CONSTANT_ALPHA_EXT', 0x8003, 'GL_EXT_blend_color')
GL_CONSTANT_COLOR_EXT = Enumerant('GL_CONSTANT_COLOR_EXT', 0x8001, 'GL_EXT_blend_color')
GL_ONE_MINUS_CONSTANT_ALPHA_EXT = Enumerant('GL_ONE_MINUS_CONSTANT_ALPHA_EXT', 0x8004, 'GL_EXT_blend_color')
GL_ONE_MINUS_CONSTANT_COLOR_EXT = Enumerant('GL_ONE_MINUS_CONSTANT_COLOR_EXT', 0x8002, 'GL_EXT_blend_color')

defines.add(GL_BLEND_COLOR_EXT)
defines.add(GL_CONSTANT_ALPHA_EXT)
defines.add(GL_CONSTANT_COLOR_EXT)
defines.add(GL_ONE_MINUS_CONSTANT_ALPHA_EXT)
defines.add(GL_ONE_MINUS_CONSTANT_COLOR_EXT)

# GL_EXT_blend_equation_separate

GL_BLEND_EQUATION_ALPHA_EXT = Enumerant('GL_BLEND_EQUATION_ALPHA_EXT', 0x883d, 'GL_EXT_blend_equation_separate')
GL_BLEND_EQUATION_RGB_EXT = Enumerant('GL_BLEND_EQUATION_RGB_EXT', 0x8009, 'GL_EXT_blend_equation_separate')

defines.add(GL_BLEND_EQUATION_ALPHA_EXT)
defines.add(GL_BLEND_EQUATION_RGB_EXT)

# GL_EXT_blend_func_separate

GL_BLEND_DST_ALPHA_EXT = Enumerant('GL_BLEND_DST_ALPHA_EXT', 0x80ca, 'GL_EXT_blend_func_separate')
GL_BLEND_DST_RGB_EXT = Enumerant('GL_BLEND_DST_RGB_EXT', 0x80c8, 'GL_EXT_blend_func_separate')
GL_BLEND_SRC_ALPHA_EXT = Enumerant('GL_BLEND_SRC_ALPHA_EXT', 0x80cb, 'GL_EXT_blend_func_separate')
GL_BLEND_SRC_RGB_EXT = Enumerant('GL_BLEND_SRC_RGB_EXT', 0x80c9, 'GL_EXT_blend_func_separate')

defines.add(GL_BLEND_DST_ALPHA_EXT)
defines.add(GL_BLEND_DST_RGB_EXT)
defines.add(GL_BLEND_SRC_ALPHA_EXT)
defines.add(GL_BLEND_SRC_RGB_EXT)

# GL_EXT_blend_minmax

GL_BLEND_EQUATION_EXT = Enumerant('GL_BLEND_EQUATION_EXT', 0x8009, 'GL_EXT_blend_minmax')
GL_FUNC_ADD_EXT = Enumerant('GL_FUNC_ADD_EXT', 0x8006, 'GL_EXT_blend_minmax')
GL_MAX_EXT = Enumerant('GL_MAX_EXT', 0x8008, 'GL_EXT_blend_minmax')
GL_MIN_EXT = Enumerant('GL_MIN_EXT', 0x8007, 'GL_EXT_blend_minmax')

defines.add(GL_BLEND_EQUATION_EXT)
defines.add(GL_FUNC_ADD_EXT)
defines.add(GL_MAX_EXT)
defines.add(GL_MIN_EXT)

# GL_EXT_blend_subtract

GL_FUNC_REVERSE_SUBTRACT_EXT = Enumerant('GL_FUNC_REVERSE_SUBTRACT_EXT', 0x800b, 'GL_EXT_blend_subtract')
GL_FUNC_SUBTRACT_EXT = Enumerant('GL_FUNC_SUBTRACT_EXT', 0x800a, 'GL_EXT_blend_subtract')

defines.add(GL_FUNC_REVERSE_SUBTRACT_EXT)
defines.add(GL_FUNC_SUBTRACT_EXT)

# GL_EXT_clip_volume_hint

GL_CLIP_VOLUME_CLIPPING_HINT_EXT = Enumerant('GL_CLIP_VOLUME_CLIPPING_HINT_EXT', 0x80f0, 'GL_EXT_clip_volume_hint')

defines.add(GL_CLIP_VOLUME_CLIPPING_HINT_EXT)

# GL_EXT_cmyka

GL_CMYKA_EXT = Enumerant('GL_CMYKA_EXT', 0x800d, 'GL_EXT_cmyka')
GL_CMYK_EXT = Enumerant('GL_CMYK_EXT', 0x800c, 'GL_EXT_cmyka')
GL_PACK_CMYK_HINT_EXT = Enumerant('GL_PACK_CMYK_HINT_EXT', 0x800e, 'GL_EXT_cmyka')
GL_UNPACK_CMYK_HINT_EXT = Enumerant('GL_UNPACK_CMYK_HINT_EXT', 0x800f, 'GL_EXT_cmyka')

defines.add(GL_CMYKA_EXT)
defines.add(GL_CMYK_EXT)
defines.add(GL_PACK_CMYK_HINT_EXT)
defines.add(GL_UNPACK_CMYK_HINT_EXT)

# GL_EXT_color_buffer_half_float

GL_FRAMEBUFFER_ATTACHMENT_COMPONENT_TYPE_EXT = Enumerant('GL_FRAMEBUFFER_ATTACHMENT_COMPONENT_TYPE_EXT', 0x8211, 'GL_EXT_color_buffer_half_float')
GL_UNSIGNED_NORMALIZED_EXT = Enumerant('GL_UNSIGNED_NORMALIZED_EXT', 0x8c17, 'GL_EXT_color_buffer_half_float')

defines.add(GL_FRAMEBUFFER_ATTACHMENT_COMPONENT_TYPE_EXT)
defines.add(GL_UNSIGNED_NORMALIZED_EXT)

# GL_EXT_compiled_vertex_array

GL_ARRAY_ELEMENT_LOCK_COUNT_EXT = Enumerant('GL_ARRAY_ELEMENT_LOCK_COUNT_EXT', 0x81a9, 'GL_EXT_compiled_vertex_array')
GL_ARRAY_ELEMENT_LOCK_FIRST_EXT = Enumerant('GL_ARRAY_ELEMENT_LOCK_FIRST_EXT', 0x81a8, 'GL_EXT_compiled_vertex_array')

defines.add(GL_ARRAY_ELEMENT_LOCK_COUNT_EXT)
defines.add(GL_ARRAY_ELEMENT_LOCK_FIRST_EXT)

# GL_EXT_convolution

GL_CONVOLUTION_1D_EXT = Enumerant('GL_CONVOLUTION_1D_EXT', 0x8010, 'GL_EXT_convolution')
GL_CONVOLUTION_2D_EXT = Enumerant('GL_CONVOLUTION_2D_EXT', 0x8011, 'GL_EXT_convolution')
GL_CONVOLUTION_BORDER_MODE_EXT = Enumerant('GL_CONVOLUTION_BORDER_MODE_EXT', 0x8013, 'GL_EXT_convolution')
GL_CONVOLUTION_FILTER_BIAS_EXT = Enumerant('GL_CONVOLUTION_FILTER_BIAS_EXT', 0x8015, 'GL_EXT_convolution')
GL_CONVOLUTION_FILTER_SCALE_EXT = Enumerant('GL_CONVOLUTION_FILTER_SCALE_EXT', 0x8014, 'GL_EXT_convolution')
GL_CONVOLUTION_FORMAT_EXT = Enumerant('GL_CONVOLUTION_FORMAT_EXT', 0x8017, 'GL_EXT_convolution')
GL_CONVOLUTION_HEIGHT_EXT = Enumerant('GL_CONVOLUTION_HEIGHT_EXT', 0x8019, 'GL_EXT_convolution')
GL_CONVOLUTION_WIDTH_EXT = Enumerant('GL_CONVOLUTION_WIDTH_EXT', 0x8018, 'GL_EXT_convolution')
GL_MAX_CONVOLUTION_HEIGHT_EXT = Enumerant('GL_MAX_CONVOLUTION_HEIGHT_EXT', 0x801b, 'GL_EXT_convolution')
GL_MAX_CONVOLUTION_WIDTH_EXT = Enumerant('GL_MAX_CONVOLUTION_WIDTH_EXT', 0x801a, 'GL_EXT_convolution')
GL_POST_CONVOLUTION_ALPHA_BIAS_EXT = Enumerant('GL_POST_CONVOLUTION_ALPHA_BIAS_EXT', 0x8023, 'GL_EXT_convolution')
GL_POST_CONVOLUTION_ALPHA_SCALE_EXT = Enumerant('GL_POST_CONVOLUTION_ALPHA_SCALE_EXT', 0x801f, 'GL_EXT_convolution')
GL_POST_CONVOLUTION_BLUE_BIAS_EXT = Enumerant('GL_POST_CONVOLUTION_BLUE_BIAS_EXT', 0x8022, 'GL_EXT_convolution')
GL_POST_CONVOLUTION_BLUE_SCALE_EXT = Enumerant('GL_POST_CONVOLUTION_BLUE_SCALE_EXT', 0x801e, 'GL_EXT_convolution')
GL_POST_CONVOLUTION_GREEN_BIAS_EXT = Enumerant('GL_POST_CONVOLUTION_GREEN_BIAS_EXT', 0x8021, 'GL_EXT_convolution')
GL_POST_CONVOLUTION_GREEN_SCALE_EXT = Enumerant('GL_POST_CONVOLUTION_GREEN_SCALE_EXT', 0x801d, 'GL_EXT_convolution')
GL_POST_CONVOLUTION_RED_BIAS_EXT = Enumerant('GL_POST_CONVOLUTION_RED_BIAS_EXT', 0x8020, 'GL_EXT_convolution')
GL_POST_CONVOLUTION_RED_SCALE_EXT = Enumerant('GL_POST_CONVOLUTION_RED_SCALE_EXT', 0x801c, 'GL_EXT_convolution')
GL_REDUCE_EXT = Enumerant('GL_REDUCE_EXT', 0x8016, 'GL_EXT_convolution')
GL_SEPARABLE_2D_EXT = Enumerant('GL_SEPARABLE_2D_EXT', 0x8012, 'GL_EXT_convolution')

defines.add(GL_CONVOLUTION_1D_EXT)
defines.add(GL_CONVOLUTION_2D_EXT)
defines.add(GL_CONVOLUTION_BORDER_MODE_EXT)
defines.add(GL_CONVOLUTION_FILTER_BIAS_EXT)
defines.add(GL_CONVOLUTION_FILTER_SCALE_EXT)
defines.add(GL_CONVOLUTION_FORMAT_EXT)
defines.add(GL_CONVOLUTION_HEIGHT_EXT)
defines.add(GL_CONVOLUTION_WIDTH_EXT)
defines.add(GL_MAX_CONVOLUTION_HEIGHT_EXT)
defines.add(GL_MAX_CONVOLUTION_WIDTH_EXT)
defines.add(GL_POST_CONVOLUTION_ALPHA_BIAS_EXT)
defines.add(GL_POST_CONVOLUTION_ALPHA_SCALE_EXT)
defines.add(GL_POST_CONVOLUTION_BLUE_BIAS_EXT)
defines.add(GL_POST_CONVOLUTION_BLUE_SCALE_EXT)
defines.add(GL_POST_CONVOLUTION_GREEN_BIAS_EXT)
defines.add(GL_POST_CONVOLUTION_GREEN_SCALE_EXT)
defines.add(GL_POST_CONVOLUTION_RED_BIAS_EXT)
defines.add(GL_POST_CONVOLUTION_RED_SCALE_EXT)
defines.add(GL_REDUCE_EXT)
defines.add(GL_SEPARABLE_2D_EXT)

# GL_EXT_coordinate_frame

GL_BINORMAL_ARRAY_EXT = Enumerant('GL_BINORMAL_ARRAY_EXT', 0x843a, 'GL_EXT_coordinate_frame')
GL_BINORMAL_ARRAY_POINTER_EXT = Enumerant('GL_BINORMAL_ARRAY_POINTER_EXT', 0x8443, 'GL_EXT_coordinate_frame')
GL_BINORMAL_ARRAY_STRIDE_EXT = Enumerant('GL_BINORMAL_ARRAY_STRIDE_EXT', 0x8441, 'GL_EXT_coordinate_frame')
GL_BINORMAL_ARRAY_TYPE_EXT = Enumerant('GL_BINORMAL_ARRAY_TYPE_EXT', 0x8440, 'GL_EXT_coordinate_frame')
GL_CURRENT_BINORMAL_EXT = Enumerant('GL_CURRENT_BINORMAL_EXT', 0x843c, 'GL_EXT_coordinate_frame')
GL_CURRENT_TANGENT_EXT = Enumerant('GL_CURRENT_TANGENT_EXT', 0x843b, 'GL_EXT_coordinate_frame')
GL_MAP1_BINORMAL_EXT = Enumerant('GL_MAP1_BINORMAL_EXT', 0x8446, 'GL_EXT_coordinate_frame')
GL_MAP1_TANGENT_EXT = Enumerant('GL_MAP1_TANGENT_EXT', 0x8444, 'GL_EXT_coordinate_frame')
GL_MAP2_BINORMAL_EXT = Enumerant('GL_MAP2_BINORMAL_EXT', 0x8447, 'GL_EXT_coordinate_frame')
GL_MAP2_TANGENT_EXT = Enumerant('GL_MAP2_TANGENT_EXT', 0x8445, 'GL_EXT_coordinate_frame')
GL_TANGENT_ARRAY_EXT = Enumerant('GL_TANGENT_ARRAY_EXT', 0x8439, 'GL_EXT_coordinate_frame')
GL_TANGENT_ARRAY_POINTER_EXT = Enumerant('GL_TANGENT_ARRAY_POINTER_EXT', 0x8442, 'GL_EXT_coordinate_frame')
GL_TANGENT_ARRAY_STRIDE_EXT = Enumerant('GL_TANGENT_ARRAY_STRIDE_EXT', 0x843f, 'GL_EXT_coordinate_frame')
GL_TANGENT_ARRAY_TYPE_EXT = Enumerant('GL_TANGENT_ARRAY_TYPE_EXT', 0x843e, 'GL_EXT_coordinate_frame')

defines.add(GL_BINORMAL_ARRAY_EXT)
defines.add(GL_BINORMAL_ARRAY_POINTER_EXT)
defines.add(GL_BINORMAL_ARRAY_STRIDE_EXT)
defines.add(GL_BINORMAL_ARRAY_TYPE_EXT)
defines.add(GL_CURRENT_BINORMAL_EXT)
defines.add(GL_CURRENT_TANGENT_EXT)
defines.add(GL_MAP1_BINORMAL_EXT)
defines.add(GL_MAP1_TANGENT_EXT)
defines.add(GL_MAP2_BINORMAL_EXT)
defines.add(GL_MAP2_TANGENT_EXT)
defines.add(GL_TANGENT_ARRAY_EXT)
defines.add(GL_TANGENT_ARRAY_POINTER_EXT)
defines.add(GL_TANGENT_ARRAY_STRIDE_EXT)
defines.add(GL_TANGENT_ARRAY_TYPE_EXT)

# GL_EXT_cull_vertex

GL_CULL_VERTEX_EXT = Enumerant('GL_CULL_VERTEX_EXT', 0x81aa, 'GL_EXT_cull_vertex')
GL_CULL_VERTEX_EYE_POSITION_EXT = Enumerant('GL_CULL_VERTEX_EYE_POSITION_EXT', 0x81ab, 'GL_EXT_cull_vertex')
GL_CULL_VERTEX_OBJECT_POSITION_EXT = Enumerant('GL_CULL_VERTEX_OBJECT_POSITION_EXT', 0x81ac, 'GL_EXT_cull_vertex')

defines.add(GL_CULL_VERTEX_EXT)
defines.add(GL_CULL_VERTEX_EYE_POSITION_EXT)
defines.add(GL_CULL_VERTEX_OBJECT_POSITION_EXT)

# GL_EXT_debug_label

GL_BUFFER_OBJECT_EXT = Enumerant('GL_BUFFER_OBJECT_EXT', 0x9151, 'GL_EXT_debug_label')
GL_PROGRAM_OBJECT_EXT = Enumerant('GL_PROGRAM_OBJECT_EXT', 0x8b40, 'GL_EXT_debug_label')
GL_PROGRAM_PIPELINE_OBJECT_EXT = Enumerant('GL_PROGRAM_PIPELINE_OBJECT_EXT', 0x8a4f, 'GL_EXT_debug_label')
GL_QUERY_OBJECT_EXT = Enumerant('GL_QUERY_OBJECT_EXT', 0x9153, 'GL_EXT_debug_label')
GL_SHADER_OBJECT_EXT = Enumerant('GL_SHADER_OBJECT_EXT', 0x8b48, 'GL_EXT_debug_label')
GL_VERTEX_ARRAY_OBJECT_EXT = Enumerant('GL_VERTEX_ARRAY_OBJECT_EXT', 0x9154, 'GL_EXT_debug_label')

defines.add(GL_BUFFER_OBJECT_EXT)
defines.add(GL_PROGRAM_OBJECT_EXT)
defines.add(GL_PROGRAM_PIPELINE_OBJECT_EXT)
defines.add(GL_QUERY_OBJECT_EXT)
defines.add(GL_SHADER_OBJECT_EXT)
defines.add(GL_VERTEX_ARRAY_OBJECT_EXT)

# GL_EXT_depth_bounds_test

GL_DEPTH_BOUNDS_EXT = Enumerant('GL_DEPTH_BOUNDS_EXT', 0x8891, 'GL_EXT_depth_bounds_test')
GL_DEPTH_BOUNDS_TEST_EXT = Enumerant('GL_DEPTH_BOUNDS_TEST_EXT', 0x8890, 'GL_EXT_depth_bounds_test')

defines.add(GL_DEPTH_BOUNDS_EXT)
defines.add(GL_DEPTH_BOUNDS_TEST_EXT)

# GL_EXT_direct_state_access

GL_PROGRAM_MATRIX_EXT = Enumerant('GL_PROGRAM_MATRIX_EXT', 0x8e2d, 'GL_EXT_direct_state_access')
GL_PROGRAM_MATRIX_STACK_DEPTH_EXT = Enumerant('GL_PROGRAM_MATRIX_STACK_DEPTH_EXT', 0x8e2f, 'GL_EXT_direct_state_access')
GL_TRANSPOSE_PROGRAM_MATRIX_EXT = Enumerant('GL_TRANSPOSE_PROGRAM_MATRIX_EXT', 0x8e2e, 'GL_EXT_direct_state_access')

defines.add(GL_PROGRAM_MATRIX_EXT)
defines.add(GL_PROGRAM_MATRIX_STACK_DEPTH_EXT)
defines.add(GL_TRANSPOSE_PROGRAM_MATRIX_EXT)

# GL_EXT_discard_framebuffer

GL_COLOR_EXT = Enumerant('GL_COLOR_EXT', 0x1800, 'GL_EXT_discard_framebuffer')
GL_DEPTH_EXT = Enumerant('GL_DEPTH_EXT', 0x1801, 'GL_EXT_discard_framebuffer')
GL_STENCIL_EXT = Enumerant('GL_STENCIL_EXT', 0x1802, 'GL_EXT_discard_framebuffer')

defines.add(GL_COLOR_EXT)
defines.add(GL_DEPTH_EXT)
defines.add(GL_STENCIL_EXT)

# GL_EXT_disjoint_timer_query

GL_GPU_DISJOINT_EXT = Enumerant('GL_GPU_DISJOINT_EXT', 0x8fbb, 'GL_EXT_disjoint_timer_query')
GL_QUERY_COUNTER_BITS_EXT = Enumerant('GL_QUERY_COUNTER_BITS_EXT', 0x8864, 'GL_EXT_disjoint_timer_query')
GL_TIMESTAMP_EXT = Enumerant('GL_TIMESTAMP_EXT', 0x8e28, 'GL_EXT_disjoint_timer_query')

defines.add(GL_GPU_DISJOINT_EXT)
defines.add(GL_QUERY_COUNTER_BITS_EXT)
defines.add(GL_TIMESTAMP_EXT)

# GL_EXT_draw_range_elements

GL_MAX_ELEMENTS_INDICES_EXT = Enumerant('GL_MAX_ELEMENTS_INDICES_EXT', 0x80e9, 'GL_EXT_draw_range_elements')
GL_MAX_ELEMENTS_VERTICES_EXT = Enumerant('GL_MAX_ELEMENTS_VERTICES_EXT', 0x80e8, 'GL_EXT_draw_range_elements')

defines.add(GL_MAX_ELEMENTS_INDICES_EXT)
defines.add(GL_MAX_ELEMENTS_VERTICES_EXT)

# GL_EXT_fog_coord

GL_CURRENT_FOG_COORDINATE_EXT = Enumerant('GL_CURRENT_FOG_COORDINATE_EXT', 0x8453, 'GL_EXT_fog_coord')
GL_FOG_COORDINATE_ARRAY_EXT = Enumerant('GL_FOG_COORDINATE_ARRAY_EXT', 0x8457, 'GL_EXT_fog_coord')
GL_FOG_COORDINATE_ARRAY_POINTER_EXT = Enumerant('GL_FOG_COORDINATE_ARRAY_POINTER_EXT', 0x8456, 'GL_EXT_fog_coord')
GL_FOG_COORDINATE_ARRAY_STRIDE_EXT = Enumerant('GL_FOG_COORDINATE_ARRAY_STRIDE_EXT', 0x8455, 'GL_EXT_fog_coord')
GL_FOG_COORDINATE_ARRAY_TYPE_EXT = Enumerant('GL_FOG_COORDINATE_ARRAY_TYPE_EXT', 0x8454, 'GL_EXT_fog_coord')
GL_FOG_COORDINATE_EXT = Enumerant('GL_FOG_COORDINATE_EXT', 0x8451, 'GL_EXT_fog_coord')
GL_FOG_COORDINATE_SOURCE_EXT = Enumerant('GL_FOG_COORDINATE_SOURCE_EXT', 0x8450, 'GL_EXT_fog_coord')
GL_FRAGMENT_DEPTH_EXT = Enumerant('GL_FRAGMENT_DEPTH_EXT', 0x8452, 'GL_EXT_fog_coord')

defines.add(GL_CURRENT_FOG_COORDINATE_EXT)
defines.add(GL_FOG_COORDINATE_ARRAY_EXT)
defines.add(GL_FOG_COORDINATE_ARRAY_POINTER_EXT)
defines.add(GL_FOG_COORDINATE_ARRAY_STRIDE_EXT)
defines.add(GL_FOG_COORDINATE_ARRAY_TYPE_EXT)
defines.add(GL_FOG_COORDINATE_EXT)
defines.add(GL_FOG_COORDINATE_SOURCE_EXT)
defines.add(GL_FRAGMENT_DEPTH_EXT)

# GL_EXT_fragment_lighting

GL_CURRENT_RASTER_NORMAL_EXT = Enumerant('GL_CURRENT_RASTER_NORMAL_EXT', 0x8406, 'GL_EXT_fragment_lighting')
GL_FRAGMENT_COLOR_MATERIAL_EXT = Enumerant('GL_FRAGMENT_COLOR_MATERIAL_EXT', 0x8401, 'GL_EXT_fragment_lighting')
GL_FRAGMENT_COLOR_MATERIAL_FACE_EXT = Enumerant('GL_FRAGMENT_COLOR_MATERIAL_FACE_EXT', 0x8402, 'GL_EXT_fragment_lighting')
GL_FRAGMENT_COLOR_MATERIAL_PARAMETER_EXT = Enumerant('GL_FRAGMENT_COLOR_MATERIAL_PARAMETER_EXT', 0x8403, 'GL_EXT_fragment_lighting')
GL_FRAGMENT_LIGHT0_EXT = Enumerant('GL_FRAGMENT_LIGHT0_EXT', 0x840c, 'GL_EXT_fragment_lighting')
GL_FRAGMENT_LIGHT1_EXT = Enumerant('GL_FRAGMENT_LIGHT1_EXT', 0x840d, 'GL_EXT_fragment_lighting')
GL_FRAGMENT_LIGHT2_EXT = Enumerant('GL_FRAGMENT_LIGHT2_EXT', 0x840e, 'GL_EXT_fragment_lighting')
GL_FRAGMENT_LIGHT3_EXT = Enumerant('GL_FRAGMENT_LIGHT3_EXT', 0x840f, 'GL_EXT_fragment_lighting')
GL_FRAGMENT_LIGHT4_EXT = Enumerant('GL_FRAGMENT_LIGHT4_EXT', 0x8410, 'GL_EXT_fragment_lighting')
GL_FRAGMENT_LIGHT5_EXT = Enumerant('GL_FRAGMENT_LIGHT5_EXT', 0x8411, 'GL_EXT_fragment_lighting')
GL_FRAGMENT_LIGHT6_EXT = Enumerant('GL_FRAGMENT_LIGHT6_EXT', 0x8412, 'GL_EXT_fragment_lighting')
GL_FRAGMENT_LIGHT7_EXT = Enumerant('GL_FRAGMENT_LIGHT7_EXT', 0x8413, 'GL_EXT_fragment_lighting')
GL_FRAGMENT_LIGHTING_EXT = Enumerant('GL_FRAGMENT_LIGHTING_EXT', 0x8400, 'GL_EXT_fragment_lighting')
GL_FRAGMENT_LIGHT_MODEL_AMBIENT_EXT = Enumerant('GL_FRAGMENT_LIGHT_MODEL_AMBIENT_EXT', 0x840a, 'GL_EXT_fragment_lighting')
GL_FRAGMENT_LIGHT_MODEL_LOCAL_VIEWER_EXT = Enumerant('GL_FRAGMENT_LIGHT_MODEL_LOCAL_VIEWER_EXT', 0x8408, 'GL_EXT_fragment_lighting')
GL_FRAGMENT_LIGHT_MODEL_NORMAL_INTERPOLATION_EXT = Enumerant('GL_FRAGMENT_LIGHT_MODEL_NORMAL_INTERPOLATION_EXT', 0x840b, 'GL_EXT_fragment_lighting')
GL_FRAGMENT_LIGHT_MODEL_TWO_SIDE_EXT = Enumerant('GL_FRAGMENT_LIGHT_MODEL_TWO_SIDE_EXT', 0x8409, 'GL_EXT_fragment_lighting')
GL_LIGHT_ENV_MODE_EXT = Enumerant('GL_LIGHT_ENV_MODE_EXT', 0x8407, 'GL_EXT_fragment_lighting')
GL_MAX_ACTIVE_LIGHTS_EXT = Enumerant('GL_MAX_ACTIVE_LIGHTS_EXT', 0x8405, 'GL_EXT_fragment_lighting')
GL_MAX_FRAGMENT_LIGHTS_EXT = Enumerant('GL_MAX_FRAGMENT_LIGHTS_EXT', 0x8404, 'GL_EXT_fragment_lighting')

defines.add(GL_CURRENT_RASTER_NORMAL_EXT)
defines.add(GL_FRAGMENT_COLOR_MATERIAL_EXT)
defines.add(GL_FRAGMENT_COLOR_MATERIAL_FACE_EXT)
defines.add(GL_FRAGMENT_COLOR_MATERIAL_PARAMETER_EXT)
defines.add(GL_FRAGMENT_LIGHT0_EXT)
defines.add(GL_FRAGMENT_LIGHT1_EXT)
defines.add(GL_FRAGMENT_LIGHT2_EXT)
defines.add(GL_FRAGMENT_LIGHT3_EXT)
defines.add(GL_FRAGMENT_LIGHT4_EXT)
defines.add(GL_FRAGMENT_LIGHT5_EXT)
defines.add(GL_FRAGMENT_LIGHT6_EXT)
defines.add(GL_FRAGMENT_LIGHT7_EXT)
defines.add(GL_FRAGMENT_LIGHTING_EXT)
defines.add(GL_FRAGMENT_LIGHT_MODEL_AMBIENT_EXT)
defines.add(GL_FRAGMENT_LIGHT_MODEL_LOCAL_VIEWER_EXT)
defines.add(GL_FRAGMENT_LIGHT_MODEL_NORMAL_INTERPOLATION_EXT)
defines.add(GL_FRAGMENT_LIGHT_MODEL_TWO_SIDE_EXT)
defines.add(GL_LIGHT_ENV_MODE_EXT)
defines.add(GL_MAX_ACTIVE_LIGHTS_EXT)
defines.add(GL_MAX_FRAGMENT_LIGHTS_EXT)

# GL_EXT_framebuffer_blit

GL_DRAW_FRAMEBUFFER_BINDING_EXT = Enumerant('GL_DRAW_FRAMEBUFFER_BINDING_EXT', 0x8ca6, 'GL_EXT_framebuffer_blit')
GL_DRAW_FRAMEBUFFER_EXT = Enumerant('GL_DRAW_FRAMEBUFFER_EXT', 0x8ca9, 'GL_EXT_framebuffer_blit')
GL_READ_FRAMEBUFFER_BINDING_EXT = Enumerant('GL_READ_FRAMEBUFFER_BINDING_EXT', 0x8caa, 'GL_EXT_framebuffer_blit')
GL_READ_FRAMEBUFFER_EXT = Enumerant('GL_READ_FRAMEBUFFER_EXT', 0x8ca8, 'GL_EXT_framebuffer_blit')

defines.add(GL_DRAW_FRAMEBUFFER_BINDING_EXT)
defines.add(GL_DRAW_FRAMEBUFFER_EXT)
defines.add(GL_READ_FRAMEBUFFER_BINDING_EXT)
defines.add(GL_READ_FRAMEBUFFER_EXT)

# GL_EXT_framebuffer_multisample

GL_FRAMEBUFFER_INCOMPLETE_MULTISAMPLE_EXT = Enumerant('GL_FRAMEBUFFER_INCOMPLETE_MULTISAMPLE_EXT', 0x8d56, 'GL_EXT_framebuffer_multisample')
GL_MAX_SAMPLES_EXT = Enumerant('GL_MAX_SAMPLES_EXT', 0x8d57, 'GL_EXT_framebuffer_multisample')
GL_RENDERBUFFER_SAMPLES_EXT = Enumerant('GL_RENDERBUFFER_SAMPLES_EXT', 0x8cab, 'GL_EXT_framebuffer_multisample')

defines.add(GL_FRAMEBUFFER_INCOMPLETE_MULTISAMPLE_EXT)
defines.add(GL_MAX_SAMPLES_EXT)
defines.add(GL_RENDERBUFFER_SAMPLES_EXT)

# GL_EXT_framebuffer_multisample_blit_scaled

GL_SCALED_RESOLVE_FASTEST_EXT = Enumerant('GL_SCALED_RESOLVE_FASTEST_EXT', 0x90ba, 'GL_EXT_framebuffer_multisample_blit_scaled')
GL_SCALED_RESOLVE_NICEST_EXT = Enumerant('GL_SCALED_RESOLVE_NICEST_EXT', 0x90bb, 'GL_EXT_framebuffer_multisample_blit_scaled')

defines.add(GL_SCALED_RESOLVE_FASTEST_EXT)
defines.add(GL_SCALED_RESOLVE_NICEST_EXT)

# GL_EXT_framebuffer_object

GL_COLOR_ATTACHMENT0_EXT = Enumerant('GL_COLOR_ATTACHMENT0_EXT', 0x8ce0, 'GL_EXT_framebuffer_object')
GL_COLOR_ATTACHMENT10_EXT = Enumerant('GL_COLOR_ATTACHMENT10_EXT', 0x8cea, 'GL_EXT_framebuffer_object')
GL_COLOR_ATTACHMENT11_EXT = Enumerant('GL_COLOR_ATTACHMENT11_EXT', 0x8ceb, 'GL_EXT_framebuffer_object')
GL_COLOR_ATTACHMENT12_EXT = Enumerant('GL_COLOR_ATTACHMENT12_EXT', 0x8cec, 'GL_EXT_framebuffer_object')
GL_COLOR_ATTACHMENT13_EXT = Enumerant('GL_COLOR_ATTACHMENT13_EXT', 0x8ced, 'GL_EXT_framebuffer_object')
GL_COLOR_ATTACHMENT14_EXT = Enumerant('GL_COLOR_ATTACHMENT14_EXT', 0x8cee, 'GL_EXT_framebuffer_object')
GL_COLOR_ATTACHMENT15_EXT = Enumerant('GL_COLOR_ATTACHMENT15_EXT', 0x8cef, 'GL_EXT_framebuffer_object')
GL_COLOR_ATTACHMENT1_EXT = Enumerant('GL_COLOR_ATTACHMENT1_EXT', 0x8ce1, 'GL_EXT_framebuffer_object')
GL_COLOR_ATTACHMENT2_EXT = Enumerant('GL_COLOR_ATTACHMENT2_EXT', 0x8ce2, 'GL_EXT_framebuffer_object')
GL_COLOR_ATTACHMENT3_EXT = Enumerant('GL_COLOR_ATTACHMENT3_EXT', 0x8ce3, 'GL_EXT_framebuffer_object')
GL_COLOR_ATTACHMENT4_EXT = Enumerant('GL_COLOR_ATTACHMENT4_EXT', 0x8ce4, 'GL_EXT_framebuffer_object')
GL_COLOR_ATTACHMENT5_EXT = Enumerant('GL_COLOR_ATTACHMENT5_EXT', 0x8ce5, 'GL_EXT_framebuffer_object')
GL_COLOR_ATTACHMENT6_EXT = Enumerant('GL_COLOR_ATTACHMENT6_EXT', 0x8ce6, 'GL_EXT_framebuffer_object')
GL_COLOR_ATTACHMENT7_EXT = Enumerant('GL_COLOR_ATTACHMENT7_EXT', 0x8ce7, 'GL_EXT_framebuffer_object')
GL_COLOR_ATTACHMENT8_EXT = Enumerant('GL_COLOR_ATTACHMENT8_EXT', 0x8ce8, 'GL_EXT_framebuffer_object')
GL_COLOR_ATTACHMENT9_EXT = Enumerant('GL_COLOR_ATTACHMENT9_EXT', 0x8ce9, 'GL_EXT_framebuffer_object')
GL_DEPTH_ATTACHMENT_EXT = Enumerant('GL_DEPTH_ATTACHMENT_EXT', 0x8d00, 'GL_EXT_framebuffer_object')
GL_FRAMEBUFFER_ATTACHMENT_OBJECT_NAME_EXT = Enumerant('GL_FRAMEBUFFER_ATTACHMENT_OBJECT_NAME_EXT', 0x8cd1, 'GL_EXT_framebuffer_object')
GL_FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE_EXT = Enumerant('GL_FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE_EXT', 0x8cd0, 'GL_EXT_framebuffer_object')
GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_3D_ZOFFSET_EXT = Enumerant('GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_3D_ZOFFSET_EXT', 0x8cd4, 'GL_EXT_framebuffer_object')
GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE_EXT = Enumerant('GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE_EXT', 0x8cd3, 'GL_EXT_framebuffer_object')
GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL_EXT = Enumerant('GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL_EXT', 0x8cd2, 'GL_EXT_framebuffer_object')
GL_FRAMEBUFFER_BINDING_EXT = Enumerant('GL_FRAMEBUFFER_BINDING_EXT', 0x8ca6, 'GL_EXT_framebuffer_object')
GL_FRAMEBUFFER_COMPLETE_EXT = Enumerant('GL_FRAMEBUFFER_COMPLETE_EXT', 0x8cd5, 'GL_EXT_framebuffer_object')
GL_FRAMEBUFFER_EXT = Enumerant('GL_FRAMEBUFFER_EXT', 0x8d40, 'GL_EXT_framebuffer_object')
GL_FRAMEBUFFER_INCOMPLETE_ATTACHMENT_EXT = Enumerant('GL_FRAMEBUFFER_INCOMPLETE_ATTACHMENT_EXT', 0x8cd6, 'GL_EXT_framebuffer_object')
GL_FRAMEBUFFER_INCOMPLETE_DIMENSIONS_EXT = Enumerant('GL_FRAMEBUFFER_INCOMPLETE_DIMENSIONS_EXT', 0x8cd9, 'GL_EXT_framebuffer_object')
GL_FRAMEBUFFER_INCOMPLETE_DRAW_BUFFER_EXT = Enumerant('GL_FRAMEBUFFER_INCOMPLETE_DRAW_BUFFER_EXT', 0x8cdb, 'GL_EXT_framebuffer_object')
GL_FRAMEBUFFER_INCOMPLETE_FORMATS_EXT = Enumerant('GL_FRAMEBUFFER_INCOMPLETE_FORMATS_EXT', 0x8cda, 'GL_EXT_framebuffer_object')
GL_FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT_EXT = Enumerant('GL_FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT_EXT', 0x8cd7, 'GL_EXT_framebuffer_object')
GL_FRAMEBUFFER_INCOMPLETE_READ_BUFFER_EXT = Enumerant('GL_FRAMEBUFFER_INCOMPLETE_READ_BUFFER_EXT', 0x8cdc, 'GL_EXT_framebuffer_object')
GL_FRAMEBUFFER_UNSUPPORTED_EXT = Enumerant('GL_FRAMEBUFFER_UNSUPPORTED_EXT', 0x8cdd, 'GL_EXT_framebuffer_object')
GL_INVALID_FRAMEBUFFER_OPERATION_EXT = Enumerant('GL_INVALID_FRAMEBUFFER_OPERATION_EXT', 0x0506, 'GL_EXT_framebuffer_object')
GL_INVALID_FRAMEBUFFER_OPERATION_EXT.gluErrorString = 'invalid framebuffer operation'
GL_MAX_COLOR_ATTACHMENTS_EXT = Enumerant('GL_MAX_COLOR_ATTACHMENTS_EXT', 0x8cdf, 'GL_EXT_framebuffer_object')
GL_MAX_RENDERBUFFER_SIZE_EXT = Enumerant('GL_MAX_RENDERBUFFER_SIZE_EXT', 0x84e8, 'GL_EXT_framebuffer_object')
GL_RENDERBUFFER_ALPHA_SIZE_EXT = Enumerant('GL_RENDERBUFFER_ALPHA_SIZE_EXT', 0x8d53, 'GL_EXT_framebuffer_object')
GL_RENDERBUFFER_BINDING_EXT = Enumerant('GL_RENDERBUFFER_BINDING_EXT', 0x8ca7, 'GL_EXT_framebuffer_object')
GL_RENDERBUFFER_BLUE_SIZE_EXT = Enumerant('GL_RENDERBUFFER_BLUE_SIZE_EXT', 0x8d52, 'GL_EXT_framebuffer_object')
GL_RENDERBUFFER_DEPTH_SIZE_EXT = Enumerant('GL_RENDERBUFFER_DEPTH_SIZE_EXT', 0x8d54, 'GL_EXT_framebuffer_object')
GL_RENDERBUFFER_EXT = Enumerant('GL_RENDERBUFFER_EXT', 0x8d41, 'GL_EXT_framebuffer_object')
GL_RENDERBUFFER_GREEN_SIZE_EXT = Enumerant('GL_RENDERBUFFER_GREEN_SIZE_EXT', 0x8d51, 'GL_EXT_framebuffer_object')
GL_RENDERBUFFER_HEIGHT_EXT = Enumerant('GL_RENDERBUFFER_HEIGHT_EXT', 0x8d43, 'GL_EXT_framebuffer_object')
GL_RENDERBUFFER_INTERNAL_FORMAT_EXT = Enumerant('GL_RENDERBUFFER_INTERNAL_FORMAT_EXT', 0x8d44, 'GL_EXT_framebuffer_object')
GL_RENDERBUFFER_RED_SIZE_EXT = Enumerant('GL_RENDERBUFFER_RED_SIZE_EXT', 0x8d50, 'GL_EXT_framebuffer_object')
GL_RENDERBUFFER_STENCIL_SIZE_EXT = Enumerant('GL_RENDERBUFFER_STENCIL_SIZE_EXT', 0x8d55, 'GL_EXT_framebuffer_object')
GL_RENDERBUFFER_WIDTH_EXT = Enumerant('GL_RENDERBUFFER_WIDTH_EXT', 0x8d42, 'GL_EXT_framebuffer_object')
GL_STENCIL_ATTACHMENT_EXT = Enumerant('GL_STENCIL_ATTACHMENT_EXT', 0x8d20, 'GL_EXT_framebuffer_object')
GL_STENCIL_INDEX16_EXT = Enumerant('GL_STENCIL_INDEX16_EXT', 0x8d49, 'GL_EXT_framebuffer_object')
GL_STENCIL_INDEX1_EXT = Enumerant('GL_STENCIL_INDEX1_EXT', 0x8d46, 'GL_EXT_framebuffer_object')
GL_STENCIL_INDEX4_EXT = Enumerant('GL_STENCIL_INDEX4_EXT', 0x8d47, 'GL_EXT_framebuffer_object')
GL_STENCIL_INDEX8_EXT = Enumerant('GL_STENCIL_INDEX8_EXT', 0x8d48, 'GL_EXT_framebuffer_object')

defines.add(GL_COLOR_ATTACHMENT0_EXT)
defines.add(GL_COLOR_ATTACHMENT10_EXT)
defines.add(GL_COLOR_ATTACHMENT11_EXT)
defines.add(GL_COLOR_ATTACHMENT12_EXT)
defines.add(GL_COLOR_ATTACHMENT13_EXT)
defines.add(GL_COLOR_ATTACHMENT14_EXT)
defines.add(GL_COLOR_ATTACHMENT15_EXT)
defines.add(GL_COLOR_ATTACHMENT1_EXT)
defines.add(GL_COLOR_ATTACHMENT2_EXT)
defines.add(GL_COLOR_ATTACHMENT3_EXT)
defines.add(GL_COLOR_ATTACHMENT4_EXT)
defines.add(GL_COLOR_ATTACHMENT5_EXT)
defines.add(GL_COLOR_ATTACHMENT6_EXT)
defines.add(GL_COLOR_ATTACHMENT7_EXT)
defines.add(GL_COLOR_ATTACHMENT8_EXT)
defines.add(GL_COLOR_ATTACHMENT9_EXT)
defines.add(GL_DEPTH_ATTACHMENT_EXT)
defines.add(GL_FRAMEBUFFER_ATTACHMENT_OBJECT_NAME_EXT)
defines.add(GL_FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE_EXT)
defines.add(GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_3D_ZOFFSET_EXT)
defines.add(GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE_EXT)
defines.add(GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL_EXT)
defines.add(GL_FRAMEBUFFER_BINDING_EXT)
defines.add(GL_FRAMEBUFFER_COMPLETE_EXT)
defines.add(GL_FRAMEBUFFER_EXT)
defines.add(GL_FRAMEBUFFER_INCOMPLETE_ATTACHMENT_EXT)
defines.add(GL_FRAMEBUFFER_INCOMPLETE_DIMENSIONS_EXT)
defines.add(GL_FRAMEBUFFER_INCOMPLETE_DRAW_BUFFER_EXT)
defines.add(GL_FRAMEBUFFER_INCOMPLETE_FORMATS_EXT)
defines.add(GL_FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT_EXT)
defines.add(GL_FRAMEBUFFER_INCOMPLETE_READ_BUFFER_EXT)
defines.add(GL_FRAMEBUFFER_UNSUPPORTED_EXT)
defines.add(GL_INVALID_FRAMEBUFFER_OPERATION_EXT)
defines.add(GL_MAX_COLOR_ATTACHMENTS_EXT)
defines.add(GL_MAX_RENDERBUFFER_SIZE_EXT)
defines.add(GL_RENDERBUFFER_ALPHA_SIZE_EXT)
defines.add(GL_RENDERBUFFER_BINDING_EXT)
defines.add(GL_RENDERBUFFER_BLUE_SIZE_EXT)
defines.add(GL_RENDERBUFFER_DEPTH_SIZE_EXT)
defines.add(GL_RENDERBUFFER_EXT)
defines.add(GL_RENDERBUFFER_GREEN_SIZE_EXT)
defines.add(GL_RENDERBUFFER_HEIGHT_EXT)
defines.add(GL_RENDERBUFFER_INTERNAL_FORMAT_EXT)
defines.add(GL_RENDERBUFFER_RED_SIZE_EXT)
defines.add(GL_RENDERBUFFER_STENCIL_SIZE_EXT)
defines.add(GL_RENDERBUFFER_WIDTH_EXT)
defines.add(GL_STENCIL_ATTACHMENT_EXT)
defines.add(GL_STENCIL_INDEX16_EXT)
defines.add(GL_STENCIL_INDEX1_EXT)
defines.add(GL_STENCIL_INDEX4_EXT)
defines.add(GL_STENCIL_INDEX8_EXT)

# GL_EXT_framebuffer_sRGB

GL_FRAMEBUFFER_SRGB_CAPABLE_EXT = Enumerant('GL_FRAMEBUFFER_SRGB_CAPABLE_EXT', 0x8dba, 'GL_EXT_framebuffer_sRGB')
GL_FRAMEBUFFER_SRGB_EXT = Enumerant('GL_FRAMEBUFFER_SRGB_EXT', 0x8db9, 'GL_EXT_framebuffer_sRGB')

defines.add(GL_FRAMEBUFFER_SRGB_CAPABLE_EXT)
defines.add(GL_FRAMEBUFFER_SRGB_EXT)

# GL_EXT_geometry_shader4

GL_FRAMEBUFFER_ATTACHMENT_LAYERED_EXT = Enumerant('GL_FRAMEBUFFER_ATTACHMENT_LAYERED_EXT', 0x8da7, 'GL_EXT_geometry_shader4')
GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_LAYER_EXT = Enumerant('GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_LAYER_EXT', 0x8cd4, 'GL_EXT_geometry_shader4')
GL_FRAMEBUFFER_INCOMPLETE_LAYER_COUNT_EXT = Enumerant('GL_FRAMEBUFFER_INCOMPLETE_LAYER_COUNT_EXT', 0x8da9, 'GL_EXT_geometry_shader4')
GL_FRAMEBUFFER_INCOMPLETE_LAYER_TARGETS_EXT = Enumerant('GL_FRAMEBUFFER_INCOMPLETE_LAYER_TARGETS_EXT', 0x8da8, 'GL_EXT_geometry_shader4')
GL_GEOMETRY_INPUT_TYPE_EXT = Enumerant('GL_GEOMETRY_INPUT_TYPE_EXT', 0x8ddb, 'GL_EXT_geometry_shader4')
GL_GEOMETRY_OUTPUT_TYPE_EXT = Enumerant('GL_GEOMETRY_OUTPUT_TYPE_EXT', 0x8ddc, 'GL_EXT_geometry_shader4')
GL_GEOMETRY_SHADER_EXT = Enumerant('GL_GEOMETRY_SHADER_EXT', 0x8dd9, 'GL_EXT_geometry_shader4')
GL_GEOMETRY_VERTICES_OUT_EXT = Enumerant('GL_GEOMETRY_VERTICES_OUT_EXT', 0x8dda, 'GL_EXT_geometry_shader4')
GL_LINES_ADJACENCY_EXT = Enumerant('GL_LINES_ADJACENCY_EXT', 0x000a, 'GL_EXT_geometry_shader4')
GL_LINE_STRIP_ADJACENCY_EXT = Enumerant('GL_LINE_STRIP_ADJACENCY_EXT', 0x000b, 'GL_EXT_geometry_shader4')
GL_MAX_GEOMETRY_OUTPUT_VERTICES_EXT = Enumerant('GL_MAX_GEOMETRY_OUTPUT_VERTICES_EXT', 0x8de0, 'GL_EXT_geometry_shader4')
GL_MAX_GEOMETRY_TEXTURE_IMAGE_UNITS_EXT = Enumerant('GL_MAX_GEOMETRY_TEXTURE_IMAGE_UNITS_EXT', 0x8c29, 'GL_EXT_geometry_shader4')
GL_MAX_GEOMETRY_TOTAL_OUTPUT_COMPONENTS_EXT = Enumerant('GL_MAX_GEOMETRY_TOTAL_OUTPUT_COMPONENTS_EXT', 0x8de1, 'GL_EXT_geometry_shader4')
GL_MAX_GEOMETRY_UNIFORM_COMPONENTS_EXT = Enumerant('GL_MAX_GEOMETRY_UNIFORM_COMPONENTS_EXT', 0x8ddf, 'GL_EXT_geometry_shader4')
GL_MAX_GEOMETRY_VARYING_COMPONENTS_EXT = Enumerant('GL_MAX_GEOMETRY_VARYING_COMPONENTS_EXT', 0x8ddd, 'GL_EXT_geometry_shader4')
GL_MAX_VARYING_COMPONENTS_EXT = Enumerant('GL_MAX_VARYING_COMPONENTS_EXT', 0x8b4b, 'GL_EXT_geometry_shader4')
GL_MAX_VERTEX_VARYING_COMPONENTS_EXT = Enumerant('GL_MAX_VERTEX_VARYING_COMPONENTS_EXT', 0x8dde, 'GL_EXT_geometry_shader4')
GL_PROGRAM_POINT_SIZE_EXT = Enumerant('GL_PROGRAM_POINT_SIZE_EXT', 0x8642, 'GL_EXT_geometry_shader4')
GL_TRIANGLES_ADJACENCY_EXT = Enumerant('GL_TRIANGLES_ADJACENCY_EXT', 0x000c, 'GL_EXT_geometry_shader4')
GL_TRIANGLE_STRIP_ADJACENCY_EXT = Enumerant('GL_TRIANGLE_STRIP_ADJACENCY_EXT', 0x000d, 'GL_EXT_geometry_shader4')

defines.add(GL_FRAMEBUFFER_ATTACHMENT_LAYERED_EXT)
defines.add(GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_LAYER_EXT)
defines.add(GL_FRAMEBUFFER_INCOMPLETE_LAYER_COUNT_EXT)
defines.add(GL_FRAMEBUFFER_INCOMPLETE_LAYER_TARGETS_EXT)
defines.add(GL_GEOMETRY_INPUT_TYPE_EXT)
defines.add(GL_GEOMETRY_OUTPUT_TYPE_EXT)
defines.add(GL_GEOMETRY_SHADER_EXT)
defines.add(GL_GEOMETRY_VERTICES_OUT_EXT)
defines.add(GL_LINES_ADJACENCY_EXT)
defines.add(GL_LINE_STRIP_ADJACENCY_EXT)
defines.add(GL_MAX_GEOMETRY_OUTPUT_VERTICES_EXT)
defines.add(GL_MAX_GEOMETRY_TEXTURE_IMAGE_UNITS_EXT)
defines.add(GL_MAX_GEOMETRY_TOTAL_OUTPUT_COMPONENTS_EXT)
defines.add(GL_MAX_GEOMETRY_UNIFORM_COMPONENTS_EXT)
defines.add(GL_MAX_GEOMETRY_VARYING_COMPONENTS_EXT)
defines.add(GL_MAX_VARYING_COMPONENTS_EXT)
defines.add(GL_MAX_VERTEX_VARYING_COMPONENTS_EXT)
defines.add(GL_PROGRAM_POINT_SIZE_EXT)
defines.add(GL_TRIANGLES_ADJACENCY_EXT)
defines.add(GL_TRIANGLE_STRIP_ADJACENCY_EXT)

# GL_EXT_gpu_shader4

GL_INT_SAMPLER_1D_ARRAY_EXT = Enumerant('GL_INT_SAMPLER_1D_ARRAY_EXT', 0x8dce, 'GL_EXT_gpu_shader4')
GL_INT_SAMPLER_1D_EXT = Enumerant('GL_INT_SAMPLER_1D_EXT', 0x8dc9, 'GL_EXT_gpu_shader4')
GL_INT_SAMPLER_2D_ARRAY_EXT = Enumerant('GL_INT_SAMPLER_2D_ARRAY_EXT', 0x8dcf, 'GL_EXT_gpu_shader4')
GL_INT_SAMPLER_2D_EXT = Enumerant('GL_INT_SAMPLER_2D_EXT', 0x8dca, 'GL_EXT_gpu_shader4')
GL_INT_SAMPLER_2D_RECT_EXT = Enumerant('GL_INT_SAMPLER_2D_RECT_EXT', 0x8dcd, 'GL_EXT_gpu_shader4')
GL_INT_SAMPLER_3D_EXT = Enumerant('GL_INT_SAMPLER_3D_EXT', 0x8dcb, 'GL_EXT_gpu_shader4')
GL_INT_SAMPLER_BUFFER_EXT = Enumerant('GL_INT_SAMPLER_BUFFER_EXT', 0x8dd0, 'GL_EXT_gpu_shader4')
GL_INT_SAMPLER_CUBE_EXT = Enumerant('GL_INT_SAMPLER_CUBE_EXT', 0x8dcc, 'GL_EXT_gpu_shader4')
GL_SAMPLER_1D_ARRAY_EXT = Enumerant('GL_SAMPLER_1D_ARRAY_EXT', 0x8dc0, 'GL_EXT_gpu_shader4')
GL_SAMPLER_1D_ARRAY_SHADOW_EXT = Enumerant('GL_SAMPLER_1D_ARRAY_SHADOW_EXT', 0x8dc3, 'GL_EXT_gpu_shader4')
GL_SAMPLER_2D_ARRAY_EXT = Enumerant('GL_SAMPLER_2D_ARRAY_EXT', 0x8dc1, 'GL_EXT_gpu_shader4')
GL_SAMPLER_2D_ARRAY_SHADOW_EXT = Enumerant('GL_SAMPLER_2D_ARRAY_SHADOW_EXT', 0x8dc4, 'GL_EXT_gpu_shader4')
GL_SAMPLER_BUFFER_EXT = Enumerant('GL_SAMPLER_BUFFER_EXT', 0x8dc2, 'GL_EXT_gpu_shader4')
GL_SAMPLER_CUBE_SHADOW_EXT = Enumerant('GL_SAMPLER_CUBE_SHADOW_EXT', 0x8dc5, 'GL_EXT_gpu_shader4')
GL_UNSIGNED_INT_SAMPLER_1D_ARRAY_EXT = Enumerant('GL_UNSIGNED_INT_SAMPLER_1D_ARRAY_EXT', 0x8dd6, 'GL_EXT_gpu_shader4')
GL_UNSIGNED_INT_SAMPLER_1D_EXT = Enumerant('GL_UNSIGNED_INT_SAMPLER_1D_EXT', 0x8dd1, 'GL_EXT_gpu_shader4')
GL_UNSIGNED_INT_SAMPLER_2D_ARRAY_EXT = Enumerant('GL_UNSIGNED_INT_SAMPLER_2D_ARRAY_EXT', 0x8dd7, 'GL_EXT_gpu_shader4')
GL_UNSIGNED_INT_SAMPLER_2D_EXT = Enumerant('GL_UNSIGNED_INT_SAMPLER_2D_EXT', 0x8dd2, 'GL_EXT_gpu_shader4')
GL_UNSIGNED_INT_SAMPLER_2D_RECT_EXT = Enumerant('GL_UNSIGNED_INT_SAMPLER_2D_RECT_EXT', 0x8dd5, 'GL_EXT_gpu_shader4')
GL_UNSIGNED_INT_SAMPLER_3D_EXT = Enumerant('GL_UNSIGNED_INT_SAMPLER_3D_EXT', 0x8dd3, 'GL_EXT_gpu_shader4')
GL_UNSIGNED_INT_SAMPLER_BUFFER_EXT = Enumerant('GL_UNSIGNED_INT_SAMPLER_BUFFER_EXT', 0x8dd8, 'GL_EXT_gpu_shader4')
GL_UNSIGNED_INT_SAMPLER_CUBE_EXT = Enumerant('GL_UNSIGNED_INT_SAMPLER_CUBE_EXT', 0x8dd4, 'GL_EXT_gpu_shader4')
GL_UNSIGNED_INT_VEC2_EXT = Enumerant('GL_UNSIGNED_INT_VEC2_EXT', 0x8dc6, 'GL_EXT_gpu_shader4')
GL_UNSIGNED_INT_VEC3_EXT = Enumerant('GL_UNSIGNED_INT_VEC3_EXT', 0x8dc7, 'GL_EXT_gpu_shader4')
GL_UNSIGNED_INT_VEC4_EXT = Enumerant('GL_UNSIGNED_INT_VEC4_EXT', 0x8dc8, 'GL_EXT_gpu_shader4')
GL_VERTEX_ATTRIB_ARRAY_INTEGER_EXT = Enumerant('GL_VERTEX_ATTRIB_ARRAY_INTEGER_EXT', 0x88fd, 'GL_EXT_gpu_shader4')

defines.add(GL_INT_SAMPLER_1D_ARRAY_EXT)
defines.add(GL_INT_SAMPLER_1D_EXT)
defines.add(GL_INT_SAMPLER_2D_ARRAY_EXT)
defines.add(GL_INT_SAMPLER_2D_EXT)
defines.add(GL_INT_SAMPLER_2D_RECT_EXT)
defines.add(GL_INT_SAMPLER_3D_EXT)
defines.add(GL_INT_SAMPLER_BUFFER_EXT)
defines.add(GL_INT_SAMPLER_CUBE_EXT)
defines.add(GL_SAMPLER_1D_ARRAY_EXT)
defines.add(GL_SAMPLER_1D_ARRAY_SHADOW_EXT)
defines.add(GL_SAMPLER_2D_ARRAY_EXT)
defines.add(GL_SAMPLER_2D_ARRAY_SHADOW_EXT)
defines.add(GL_SAMPLER_BUFFER_EXT)
defines.add(GL_SAMPLER_CUBE_SHADOW_EXT)
defines.add(GL_UNSIGNED_INT_SAMPLER_1D_ARRAY_EXT)
defines.add(GL_UNSIGNED_INT_SAMPLER_1D_EXT)
defines.add(GL_UNSIGNED_INT_SAMPLER_2D_ARRAY_EXT)
defines.add(GL_UNSIGNED_INT_SAMPLER_2D_EXT)
defines.add(GL_UNSIGNED_INT_SAMPLER_2D_RECT_EXT)
defines.add(GL_UNSIGNED_INT_SAMPLER_3D_EXT)
defines.add(GL_UNSIGNED_INT_SAMPLER_BUFFER_EXT)
defines.add(GL_UNSIGNED_INT_SAMPLER_CUBE_EXT)
defines.add(GL_UNSIGNED_INT_VEC2_EXT)
defines.add(GL_UNSIGNED_INT_VEC3_EXT)
defines.add(GL_UNSIGNED_INT_VEC4_EXT)
defines.add(GL_VERTEX_ATTRIB_ARRAY_INTEGER_EXT)

# GL_EXT_histogram

GL_HISTOGRAM_ALPHA_SIZE_EXT = Enumerant('GL_HISTOGRAM_ALPHA_SIZE_EXT', 0x802b, 'GL_EXT_histogram')
GL_HISTOGRAM_BLUE_SIZE_EXT = Enumerant('GL_HISTOGRAM_BLUE_SIZE_EXT', 0x802a, 'GL_EXT_histogram')
GL_HISTOGRAM_EXT = Enumerant('GL_HISTOGRAM_EXT', 0x8024, 'GL_EXT_histogram')
GL_HISTOGRAM_FORMAT_EXT = Enumerant('GL_HISTOGRAM_FORMAT_EXT', 0x8027, 'GL_EXT_histogram')
GL_HISTOGRAM_GREEN_SIZE_EXT = Enumerant('GL_HISTOGRAM_GREEN_SIZE_EXT', 0x8029, 'GL_EXT_histogram')
GL_HISTOGRAM_LUMINANCE_SIZE_EXT = Enumerant('GL_HISTOGRAM_LUMINANCE_SIZE_EXT', 0x802c, 'GL_EXT_histogram')
GL_HISTOGRAM_RED_SIZE_EXT = Enumerant('GL_HISTOGRAM_RED_SIZE_EXT', 0x8028, 'GL_EXT_histogram')
GL_HISTOGRAM_SINK_EXT = Enumerant('GL_HISTOGRAM_SINK_EXT', 0x802d, 'GL_EXT_histogram')
GL_HISTOGRAM_WIDTH_EXT = Enumerant('GL_HISTOGRAM_WIDTH_EXT', 0x8026, 'GL_EXT_histogram')
GL_MINMAX_EXT = Enumerant('GL_MINMAX_EXT', 0x802e, 'GL_EXT_histogram')
GL_MINMAX_FORMAT_EXT = Enumerant('GL_MINMAX_FORMAT_EXT', 0x802f, 'GL_EXT_histogram')
GL_MINMAX_SINK_EXT = Enumerant('GL_MINMAX_SINK_EXT', 0x8030, 'GL_EXT_histogram')
GL_PROXY_HISTOGRAM_EXT = Enumerant('GL_PROXY_HISTOGRAM_EXT', 0x8025, 'GL_EXT_histogram')

defines.add(GL_HISTOGRAM_ALPHA_SIZE_EXT)
defines.add(GL_HISTOGRAM_BLUE_SIZE_EXT)
defines.add(GL_HISTOGRAM_EXT)
defines.add(GL_HISTOGRAM_FORMAT_EXT)
defines.add(GL_HISTOGRAM_GREEN_SIZE_EXT)
defines.add(GL_HISTOGRAM_LUMINANCE_SIZE_EXT)
defines.add(GL_HISTOGRAM_RED_SIZE_EXT)
defines.add(GL_HISTOGRAM_SINK_EXT)
defines.add(GL_HISTOGRAM_WIDTH_EXT)
defines.add(GL_MINMAX_EXT)
defines.add(GL_MINMAX_FORMAT_EXT)
defines.add(GL_MINMAX_SINK_EXT)
defines.add(GL_PROXY_HISTOGRAM_EXT)

# GL_EXT_light_texture

GL_ATTENUATION_EXT = Enumerant('GL_ATTENUATION_EXT', 0x834d, 'GL_EXT_light_texture')
GL_FRAGMENT_COLOR_EXT = Enumerant('GL_FRAGMENT_COLOR_EXT', 0x834c, 'GL_EXT_light_texture')
GL_FRAGMENT_MATERIAL_EXT = Enumerant('GL_FRAGMENT_MATERIAL_EXT', 0x8349, 'GL_EXT_light_texture')
GL_FRAGMENT_NORMAL_EXT = Enumerant('GL_FRAGMENT_NORMAL_EXT', 0x834a, 'GL_EXT_light_texture')
GL_SHADOW_ATTENUATION_EXT = Enumerant('GL_SHADOW_ATTENUATION_EXT', 0x834e, 'GL_EXT_light_texture')
GL_TEXTURE_APPLICATION_MODE_EXT = Enumerant('GL_TEXTURE_APPLICATION_MODE_EXT', 0x834f, 'GL_EXT_light_texture')
GL_TEXTURE_LIGHT_EXT = Enumerant('GL_TEXTURE_LIGHT_EXT', 0x8350, 'GL_EXT_light_texture')
GL_TEXTURE_MATERIAL_FACE_EXT = Enumerant('GL_TEXTURE_MATERIAL_FACE_EXT', 0x8351, 'GL_EXT_light_texture')
GL_TEXTURE_MATERIAL_PARAMETER_EXT = Enumerant('GL_TEXTURE_MATERIAL_PARAMETER_EXT', 0x8352, 'GL_EXT_light_texture')

defines.add(GL_ATTENUATION_EXT)
defines.add(GL_FRAGMENT_COLOR_EXT)
defines.add(GL_FRAGMENT_MATERIAL_EXT)
defines.add(GL_FRAGMENT_NORMAL_EXT)
defines.add(GL_SHADOW_ATTENUATION_EXT)
defines.add(GL_TEXTURE_APPLICATION_MODE_EXT)
defines.add(GL_TEXTURE_LIGHT_EXT)
defines.add(GL_TEXTURE_MATERIAL_FACE_EXT)
defines.add(GL_TEXTURE_MATERIAL_PARAMETER_EXT)

# GL_EXT_map_buffer_range

GL_MAP_FLUSH_EXPLICIT_BIT_EXT = Enumerant('GL_MAP_FLUSH_EXPLICIT_BIT_EXT', 0x0010, 'GL_EXT_map_buffer_range')
GL_MAP_INVALIDATE_BUFFER_BIT_EXT = Enumerant('GL_MAP_INVALIDATE_BUFFER_BIT_EXT', 0x0008, 'GL_EXT_map_buffer_range')
GL_MAP_INVALIDATE_RANGE_BIT_EXT = Enumerant('GL_MAP_INVALIDATE_RANGE_BIT_EXT', 0x0004, 'GL_EXT_map_buffer_range')
GL_MAP_READ_BIT_EXT = Enumerant('GL_MAP_READ_BIT_EXT', 0x0001, 'GL_EXT_map_buffer_range')
GL_MAP_UNSYNCHRONIZED_BIT_EXT = Enumerant('GL_MAP_UNSYNCHRONIZED_BIT_EXT', 0x0020, 'GL_EXT_map_buffer_range')
GL_MAP_WRITE_BIT_EXT = Enumerant('GL_MAP_WRITE_BIT_EXT', 0x0002, 'GL_EXT_map_buffer_range')

defines.add(GL_MAP_FLUSH_EXPLICIT_BIT_EXT)
defines.add(GL_MAP_INVALIDATE_BUFFER_BIT_EXT)
defines.add(GL_MAP_INVALIDATE_RANGE_BIT_EXT)
defines.add(GL_MAP_READ_BIT_EXT)
defines.add(GL_MAP_UNSYNCHRONIZED_BIT_EXT)
defines.add(GL_MAP_WRITE_BIT_EXT)

# GL_EXT_multisample

GL_1PASS_EXT = Enumerant('GL_1PASS_EXT', 0x80a1, 'GL_EXT_multisample')
GL_2PASS_0_EXT = Enumerant('GL_2PASS_0_EXT', 0x80a2, 'GL_EXT_multisample')
GL_2PASS_1_EXT = Enumerant('GL_2PASS_1_EXT', 0x80a3, 'GL_EXT_multisample')
GL_4PASS_0_EXT = Enumerant('GL_4PASS_0_EXT', 0x80a4, 'GL_EXT_multisample')
GL_4PASS_1_EXT = Enumerant('GL_4PASS_1_EXT', 0x80a5, 'GL_EXT_multisample')
GL_4PASS_2_EXT = Enumerant('GL_4PASS_2_EXT', 0x80a6, 'GL_EXT_multisample')
GL_4PASS_3_EXT = Enumerant('GL_4PASS_3_EXT', 0x80a7, 'GL_EXT_multisample')
GL_MULTISAMPLE_BIT_EXT = Enumerant('GL_MULTISAMPLE_BIT_EXT', 0x20000000, 'GL_EXT_multisample')
GL_MULTISAMPLE_EXT = Enumerant('GL_MULTISAMPLE_EXT', 0x809d, 'GL_EXT_multisample')
GL_SAMPLES_EXT = Enumerant('GL_SAMPLES_EXT', 0x80a9, 'GL_EXT_multisample')
GL_SAMPLE_ALPHA_TO_MASK_EXT = Enumerant('GL_SAMPLE_ALPHA_TO_MASK_EXT', 0x809e, 'GL_EXT_multisample')
GL_SAMPLE_ALPHA_TO_ONE_EXT = Enumerant('GL_SAMPLE_ALPHA_TO_ONE_EXT', 0x809f, 'GL_EXT_multisample')
GL_SAMPLE_BUFFERS_EXT = Enumerant('GL_SAMPLE_BUFFERS_EXT', 0x80a8, 'GL_EXT_multisample')
GL_SAMPLE_MASK_EXT = Enumerant('GL_SAMPLE_MASK_EXT', 0x80a0, 'GL_EXT_multisample')
GL_SAMPLE_MASK_INVERT_EXT = Enumerant('GL_SAMPLE_MASK_INVERT_EXT', 0x80ab, 'GL_EXT_multisample')
GL_SAMPLE_MASK_VALUE_EXT = Enumerant('GL_SAMPLE_MASK_VALUE_EXT', 0x80aa, 'GL_EXT_multisample')
GL_SAMPLE_PATTERN_EXT = Enumerant('GL_SAMPLE_PATTERN_EXT', 0x80ac, 'GL_EXT_multisample')

defines.add(GL_1PASS_EXT)
defines.add(GL_2PASS_0_EXT)
defines.add(GL_2PASS_1_EXT)
defines.add(GL_4PASS_0_EXT)
defines.add(GL_4PASS_1_EXT)
defines.add(GL_4PASS_2_EXT)
defines.add(GL_4PASS_3_EXT)
defines.add(GL_MULTISAMPLE_BIT_EXT)
defines.add(GL_MULTISAMPLE_EXT)
defines.add(GL_SAMPLES_EXT)
defines.add(GL_SAMPLE_ALPHA_TO_MASK_EXT)
defines.add(GL_SAMPLE_ALPHA_TO_ONE_EXT)
defines.add(GL_SAMPLE_BUFFERS_EXT)
defines.add(GL_SAMPLE_MASK_EXT)
defines.add(GL_SAMPLE_MASK_INVERT_EXT)
defines.add(GL_SAMPLE_MASK_VALUE_EXT)
defines.add(GL_SAMPLE_PATTERN_EXT)

# GL_EXT_multisampled_render_to_texture

GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_SAMPLES_EXT = Enumerant('GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_SAMPLES_EXT', 0x8d6c, 'GL_EXT_multisampled_render_to_texture')

defines.add(GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_SAMPLES_EXT)

# GL_EXT_multiview_draw_buffers

GL_COLOR_ATTACHMENT_EXT = Enumerant('GL_COLOR_ATTACHMENT_EXT', 0x90f0, 'GL_EXT_multiview_draw_buffers')
GL_DRAW_BUFFER_EXT = Enumerant('GL_DRAW_BUFFER_EXT', 0x0c01, 'GL_EXT_multiview_draw_buffers')
GL_MAX_MULTIVIEW_BUFFERS_EXT = Enumerant('GL_MAX_MULTIVIEW_BUFFERS_EXT', 0x90f2, 'GL_EXT_multiview_draw_buffers')
GL_MULTIVIEW_EXT = Enumerant('GL_MULTIVIEW_EXT', 0x90f1, 'GL_EXT_multiview_draw_buffers')
GL_READ_BUFFER_EXT = Enumerant('GL_READ_BUFFER_EXT', 0x0c02, 'GL_EXT_multiview_draw_buffers')

defines.add(GL_COLOR_ATTACHMENT_EXT)
defines.add(GL_DRAW_BUFFER_EXT)
defines.add(GL_MAX_MULTIVIEW_BUFFERS_EXT)
defines.add(GL_MULTIVIEW_EXT)
defines.add(GL_READ_BUFFER_EXT)

# GL_EXT_occlusion_query_boolean

GL_ANY_SAMPLES_PASSED_CONSERVATIVE_EXT = Enumerant('GL_ANY_SAMPLES_PASSED_CONSERVATIVE_EXT', 0x8d6a, 'GL_EXT_occlusion_query_boolean')
GL_ANY_SAMPLES_PASSED_EXT = Enumerant('GL_ANY_SAMPLES_PASSED_EXT', 0x8c2f, 'GL_EXT_occlusion_query_boolean')
GL_CURRENT_QUERY_EXT = Enumerant('GL_CURRENT_QUERY_EXT', 0x8865, 'GL_EXT_occlusion_query_boolean')
GL_QUERY_RESULT_AVAILABLE_EXT = Enumerant('GL_QUERY_RESULT_AVAILABLE_EXT', 0x8867, 'GL_EXT_occlusion_query_boolean')
GL_QUERY_RESULT_EXT = Enumerant('GL_QUERY_RESULT_EXT', 0x8866, 'GL_EXT_occlusion_query_boolean')

defines.add(GL_ANY_SAMPLES_PASSED_CONSERVATIVE_EXT)
defines.add(GL_ANY_SAMPLES_PASSED_EXT)
defines.add(GL_CURRENT_QUERY_EXT)
defines.add(GL_QUERY_RESULT_AVAILABLE_EXT)
defines.add(GL_QUERY_RESULT_EXT)

# GL_EXT_packed_depth_stencil

GL_DEPTH24_STENCIL8_EXT = Enumerant('GL_DEPTH24_STENCIL8_EXT', 0x88f0, 'GL_EXT_packed_depth_stencil')
GL_DEPTH_STENCIL_EXT = Enumerant('GL_DEPTH_STENCIL_EXT', 0x84f9, 'GL_EXT_packed_depth_stencil')
GL_TEXTURE_STENCIL_SIZE_EXT = Enumerant('GL_TEXTURE_STENCIL_SIZE_EXT', 0x88f1, 'GL_EXT_packed_depth_stencil')
GL_UNSIGNED_INT_24_8_EXT = Enumerant('GL_UNSIGNED_INT_24_8_EXT', 0x84fa, 'GL_EXT_packed_depth_stencil')

defines.add(GL_DEPTH24_STENCIL8_EXT)
defines.add(GL_DEPTH_STENCIL_EXT)
defines.add(GL_TEXTURE_STENCIL_SIZE_EXT)
defines.add(GL_UNSIGNED_INT_24_8_EXT)

# GL_EXT_packed_float

GL_R11F_G11F_B10F_EXT = Enumerant('GL_R11F_G11F_B10F_EXT', 0x8c3a, 'GL_EXT_packed_float')
GL_RGBA_SIGNED_COMPONENTS_EXT = Enumerant('GL_RGBA_SIGNED_COMPONENTS_EXT', 0x8c3c, 'GL_EXT_packed_float')
GL_UNSIGNED_INT_10F_11F_11F_REV_EXT = Enumerant('GL_UNSIGNED_INT_10F_11F_11F_REV_EXT', 0x8c3b, 'GL_EXT_packed_float')

defines.add(GL_R11F_G11F_B10F_EXT)
defines.add(GL_RGBA_SIGNED_COMPONENTS_EXT)
defines.add(GL_UNSIGNED_INT_10F_11F_11F_REV_EXT)

# GL_EXT_packed_pixels

GL_UNSIGNED_BYTE_3_3_2_EXT = Enumerant('GL_UNSIGNED_BYTE_3_3_2_EXT', 0x8032, 'GL_EXT_packed_pixels')
GL_UNSIGNED_INT_10_10_10_2_EXT = Enumerant('GL_UNSIGNED_INT_10_10_10_2_EXT', 0x8036, 'GL_EXT_packed_pixels')
GL_UNSIGNED_INT_8_8_8_8_EXT = Enumerant('GL_UNSIGNED_INT_8_8_8_8_EXT', 0x8035, 'GL_EXT_packed_pixels')
GL_UNSIGNED_SHORT_4_4_4_4_EXT = Enumerant('GL_UNSIGNED_SHORT_4_4_4_4_EXT', 0x8033, 'GL_EXT_packed_pixels')
GL_UNSIGNED_SHORT_5_5_5_1_EXT = Enumerant('GL_UNSIGNED_SHORT_5_5_5_1_EXT', 0x8034, 'GL_EXT_packed_pixels')

defines.add(GL_UNSIGNED_BYTE_3_3_2_EXT)
defines.add(GL_UNSIGNED_INT_10_10_10_2_EXT)
defines.add(GL_UNSIGNED_INT_8_8_8_8_EXT)
defines.add(GL_UNSIGNED_SHORT_4_4_4_4_EXT)
defines.add(GL_UNSIGNED_SHORT_5_5_5_1_EXT)

# GL_EXT_paletted_texture

GL_COLOR_INDEX12_EXT = Enumerant('GL_COLOR_INDEX12_EXT', 0x80e6, 'GL_EXT_paletted_texture')
GL_COLOR_INDEX16_EXT = Enumerant('GL_COLOR_INDEX16_EXT', 0x80e7, 'GL_EXT_paletted_texture')
GL_COLOR_INDEX1_EXT = Enumerant('GL_COLOR_INDEX1_EXT', 0x80e2, 'GL_EXT_paletted_texture')
GL_COLOR_INDEX2_EXT = Enumerant('GL_COLOR_INDEX2_EXT', 0x80e3, 'GL_EXT_paletted_texture')
GL_COLOR_INDEX4_EXT = Enumerant('GL_COLOR_INDEX4_EXT', 0x80e4, 'GL_EXT_paletted_texture')
GL_COLOR_INDEX8_EXT = Enumerant('GL_COLOR_INDEX8_EXT', 0x80e5, 'GL_EXT_paletted_texture')
GL_COLOR_TABLE_ALPHA_SIZE_EXT = Enumerant('GL_COLOR_TABLE_ALPHA_SIZE_EXT', 0x80dd, 'GL_EXT_paletted_texture')
GL_COLOR_TABLE_BLUE_SIZE_EXT = Enumerant('GL_COLOR_TABLE_BLUE_SIZE_EXT', 0x80dc, 'GL_EXT_paletted_texture')
GL_COLOR_TABLE_FORMAT_EXT = Enumerant('GL_COLOR_TABLE_FORMAT_EXT', 0x80d8, 'GL_EXT_paletted_texture')
GL_COLOR_TABLE_GREEN_SIZE_EXT = Enumerant('GL_COLOR_TABLE_GREEN_SIZE_EXT', 0x80db, 'GL_EXT_paletted_texture')
GL_COLOR_TABLE_INTENSITY_SIZE_EXT = Enumerant('GL_COLOR_TABLE_INTENSITY_SIZE_EXT', 0x80df, 'GL_EXT_paletted_texture')
GL_COLOR_TABLE_LUMINANCE_SIZE_EXT = Enumerant('GL_COLOR_TABLE_LUMINANCE_SIZE_EXT', 0x80de, 'GL_EXT_paletted_texture')
GL_COLOR_TABLE_RED_SIZE_EXT = Enumerant('GL_COLOR_TABLE_RED_SIZE_EXT', 0x80da, 'GL_EXT_paletted_texture')
GL_COLOR_TABLE_WIDTH_EXT = Enumerant('GL_COLOR_TABLE_WIDTH_EXT', 0x80d9, 'GL_EXT_paletted_texture')
GL_TEXTURE_INDEX_SIZE_EXT = Enumerant('GL_TEXTURE_INDEX_SIZE_EXT', 0x80ed, 'GL_EXT_paletted_texture')

defines.add(GL_COLOR_INDEX12_EXT)
defines.add(GL_COLOR_INDEX16_EXT)
defines.add(GL_COLOR_INDEX1_EXT)
defines.add(GL_COLOR_INDEX2_EXT)
defines.add(GL_COLOR_INDEX4_EXT)
defines.add(GL_COLOR_INDEX8_EXT)
defines.add(GL_COLOR_TABLE_ALPHA_SIZE_EXT)
defines.add(GL_COLOR_TABLE_BLUE_SIZE_EXT)
defines.add(GL_COLOR_TABLE_FORMAT_EXT)
defines.add(GL_COLOR_TABLE_GREEN_SIZE_EXT)
defines.add(GL_COLOR_TABLE_INTENSITY_SIZE_EXT)
defines.add(GL_COLOR_TABLE_LUMINANCE_SIZE_EXT)
defines.add(GL_COLOR_TABLE_RED_SIZE_EXT)
defines.add(GL_COLOR_TABLE_WIDTH_EXT)
defines.add(GL_TEXTURE_INDEX_SIZE_EXT)

# GL_EXT_pixel_buffer_object

GL_PIXEL_PACK_BUFFER_BINDING_EXT = Enumerant('GL_PIXEL_PACK_BUFFER_BINDING_EXT', 0x88ed, 'GL_EXT_pixel_buffer_object')
GL_PIXEL_PACK_BUFFER_EXT = Enumerant('GL_PIXEL_PACK_BUFFER_EXT', 0x88eb, 'GL_EXT_pixel_buffer_object')
GL_PIXEL_UNPACK_BUFFER_BINDING_EXT = Enumerant('GL_PIXEL_UNPACK_BUFFER_BINDING_EXT', 0x88ef, 'GL_EXT_pixel_buffer_object')
GL_PIXEL_UNPACK_BUFFER_EXT = Enumerant('GL_PIXEL_UNPACK_BUFFER_EXT', 0x88ec, 'GL_EXT_pixel_buffer_object')

defines.add(GL_PIXEL_PACK_BUFFER_BINDING_EXT)
defines.add(GL_PIXEL_PACK_BUFFER_EXT)
defines.add(GL_PIXEL_UNPACK_BUFFER_BINDING_EXT)
defines.add(GL_PIXEL_UNPACK_BUFFER_EXT)

# GL_EXT_pixel_transform

GL_AVERAGE_EXT = Enumerant('GL_AVERAGE_EXT', 0x8335, 'GL_EXT_pixel_transform')
GL_CUBIC_EXT = Enumerant('GL_CUBIC_EXT', 0x8334, 'GL_EXT_pixel_transform')
GL_MAX_PIXEL_TRANSFORM_2D_STACK_DEPTH_EXT = Enumerant('GL_MAX_PIXEL_TRANSFORM_2D_STACK_DEPTH_EXT', 0x8337, 'GL_EXT_pixel_transform')
GL_PIXEL_CUBIC_WEIGHT_EXT = Enumerant('GL_PIXEL_CUBIC_WEIGHT_EXT', 0x8333, 'GL_EXT_pixel_transform')
GL_PIXEL_MAG_FILTER_EXT = Enumerant('GL_PIXEL_MAG_FILTER_EXT', 0x8331, 'GL_EXT_pixel_transform')
GL_PIXEL_MIN_FILTER_EXT = Enumerant('GL_PIXEL_MIN_FILTER_EXT', 0x8332, 'GL_EXT_pixel_transform')
GL_PIXEL_TRANSFORM_2D_EXT = Enumerant('GL_PIXEL_TRANSFORM_2D_EXT', 0x8330, 'GL_EXT_pixel_transform')
GL_PIXEL_TRANSFORM_2D_MATRIX_EXT = Enumerant('GL_PIXEL_TRANSFORM_2D_MATRIX_EXT', 0x8338, 'GL_EXT_pixel_transform')
GL_PIXEL_TRANSFORM_2D_STACK_DEPTH_EXT = Enumerant('GL_PIXEL_TRANSFORM_2D_STACK_DEPTH_EXT', 0x8336, 'GL_EXT_pixel_transform')

defines.add(GL_AVERAGE_EXT)
defines.add(GL_CUBIC_EXT)
defines.add(GL_MAX_PIXEL_TRANSFORM_2D_STACK_DEPTH_EXT)
defines.add(GL_PIXEL_CUBIC_WEIGHT_EXT)
defines.add(GL_PIXEL_MAG_FILTER_EXT)
defines.add(GL_PIXEL_MIN_FILTER_EXT)
defines.add(GL_PIXEL_TRANSFORM_2D_EXT)
defines.add(GL_PIXEL_TRANSFORM_2D_MATRIX_EXT)
defines.add(GL_PIXEL_TRANSFORM_2D_STACK_DEPTH_EXT)

# GL_EXT_point_parameters

GL_DISTANCE_ATTENUATION_EXT = Enumerant('GL_DISTANCE_ATTENUATION_EXT', 0x8129, 'GL_EXT_point_parameters')
GL_POINT_FADE_THRESHOLD_SIZE_EXT = Enumerant('GL_POINT_FADE_THRESHOLD_SIZE_EXT', 0x8128, 'GL_EXT_point_parameters')
GL_POINT_SIZE_MAX_EXT = Enumerant('GL_POINT_SIZE_MAX_EXT', 0x8127, 'GL_EXT_point_parameters')
GL_POINT_SIZE_MIN_EXT = Enumerant('GL_POINT_SIZE_MIN_EXT', 0x8126, 'GL_EXT_point_parameters')

defines.add(GL_DISTANCE_ATTENUATION_EXT)
defines.add(GL_POINT_FADE_THRESHOLD_SIZE_EXT)
defines.add(GL_POINT_SIZE_MAX_EXT)
defines.add(GL_POINT_SIZE_MIN_EXT)

# GL_EXT_polygon_offset

GL_POLYGON_OFFSET_BIAS_EXT = Enumerant('GL_POLYGON_OFFSET_BIAS_EXT', 0x8039, 'GL_EXT_polygon_offset')
GL_POLYGON_OFFSET_EXT = Enumerant('GL_POLYGON_OFFSET_EXT', 0x8037, 'GL_EXT_polygon_offset')
GL_POLYGON_OFFSET_FACTOR_EXT = Enumerant('GL_POLYGON_OFFSET_FACTOR_EXT', 0x8038, 'GL_EXT_polygon_offset')

defines.add(GL_POLYGON_OFFSET_BIAS_EXT)
defines.add(GL_POLYGON_OFFSET_EXT)
defines.add(GL_POLYGON_OFFSET_FACTOR_EXT)

# GL_EXT_provoking_vertex

GL_FIRST_VERTEX_CONVENTION_EXT = Enumerant('GL_FIRST_VERTEX_CONVENTION_EXT', 0x8e4d, 'GL_EXT_provoking_vertex')
GL_LAST_VERTEX_CONVENTION_EXT = Enumerant('GL_LAST_VERTEX_CONVENTION_EXT', 0x8e4e, 'GL_EXT_provoking_vertex')
GL_PROVOKING_VERTEX_EXT = Enumerant('GL_PROVOKING_VERTEX_EXT', 0x8e4f, 'GL_EXT_provoking_vertex')
GL_QUADS_FOLLOW_PROVOKING_VERTEX_CONVENTION_EXT = Enumerant('GL_QUADS_FOLLOW_PROVOKING_VERTEX_CONVENTION_EXT', 0x8e4c, 'GL_EXT_provoking_vertex')

defines.add(GL_FIRST_VERTEX_CONVENTION_EXT)
defines.add(GL_LAST_VERTEX_CONVENTION_EXT)
defines.add(GL_PROVOKING_VERTEX_EXT)
defines.add(GL_QUADS_FOLLOW_PROVOKING_VERTEX_CONVENTION_EXT)

# GL_EXT_read_format_bgra

GL_UNSIGNED_SHORT_1_5_5_5_REV_EXT = Enumerant('GL_UNSIGNED_SHORT_1_5_5_5_REV_EXT', 0x8366, 'GL_EXT_read_format_bgra')
GL_UNSIGNED_SHORT_4_4_4_4_REV_EXT = Enumerant('GL_UNSIGNED_SHORT_4_4_4_4_REV_EXT', 0x8365, 'GL_EXT_read_format_bgra')

defines.add(GL_UNSIGNED_SHORT_1_5_5_5_REV_EXT)
defines.add(GL_UNSIGNED_SHORT_4_4_4_4_REV_EXT)

# GL_EXT_rescale_normal

GL_RESCALE_NORMAL_EXT = Enumerant('GL_RESCALE_NORMAL_EXT', 0x803a, 'GL_EXT_rescale_normal')

defines.add(GL_RESCALE_NORMAL_EXT)

# GL_EXT_robustness

GL_CONTEXT_ROBUST_ACCESS_EXT = Enumerant('GL_CONTEXT_ROBUST_ACCESS_EXT', 0x90f3, 'GL_EXT_robustness')
GL_GUILTY_CONTEXT_RESET_EXT = Enumerant('GL_GUILTY_CONTEXT_RESET_EXT', 0x8253, 'GL_EXT_robustness')
GL_INNOCENT_CONTEXT_RESET_EXT = Enumerant('GL_INNOCENT_CONTEXT_RESET_EXT', 0x8254, 'GL_EXT_robustness')
GL_LOSE_CONTEXT_ON_RESET_EXT = Enumerant('GL_LOSE_CONTEXT_ON_RESET_EXT', 0x8252, 'GL_EXT_robustness')
GL_NO_RESET_NOTIFICATION_EXT = Enumerant('GL_NO_RESET_NOTIFICATION_EXT', 0x8261, 'GL_EXT_robustness')
GL_RESET_NOTIFICATION_STRATEGY_EXT = Enumerant('GL_RESET_NOTIFICATION_STRATEGY_EXT', 0x8256, 'GL_EXT_robustness')
GL_UNKNOWN_CONTEXT_RESET_EXT = Enumerant('GL_UNKNOWN_CONTEXT_RESET_EXT', 0x8255, 'GL_EXT_robustness')

defines.add(GL_CONTEXT_ROBUST_ACCESS_EXT)
defines.add(GL_GUILTY_CONTEXT_RESET_EXT)
defines.add(GL_INNOCENT_CONTEXT_RESET_EXT)
defines.add(GL_LOSE_CONTEXT_ON_RESET_EXT)
defines.add(GL_NO_RESET_NOTIFICATION_EXT)
defines.add(GL_RESET_NOTIFICATION_STRATEGY_EXT)
defines.add(GL_UNKNOWN_CONTEXT_RESET_EXT)

# GL_EXT_sRGB

GL_FRAMEBUFFER_ATTACHMENT_COLOR_ENCODING_EXT = Enumerant('GL_FRAMEBUFFER_ATTACHMENT_COLOR_ENCODING_EXT', 0x8210, 'GL_EXT_sRGB')

defines.add(GL_FRAMEBUFFER_ATTACHMENT_COLOR_ENCODING_EXT)

# GL_EXT_secondary_color

GL_COLOR_SUM_EXT = Enumerant('GL_COLOR_SUM_EXT', 0x8458, 'GL_EXT_secondary_color')
GL_CURRENT_SECONDARY_COLOR_EXT = Enumerant('GL_CURRENT_SECONDARY_COLOR_EXT', 0x8459, 'GL_EXT_secondary_color')
GL_SECONDARY_COLOR_ARRAY_EXT = Enumerant('GL_SECONDARY_COLOR_ARRAY_EXT', 0x845e, 'GL_EXT_secondary_color')
GL_SECONDARY_COLOR_ARRAY_POINTER_EXT = Enumerant('GL_SECONDARY_COLOR_ARRAY_POINTER_EXT', 0x845d, 'GL_EXT_secondary_color')
GL_SECONDARY_COLOR_ARRAY_SIZE_EXT = Enumerant('GL_SECONDARY_COLOR_ARRAY_SIZE_EXT', 0x845a, 'GL_EXT_secondary_color')
GL_SECONDARY_COLOR_ARRAY_STRIDE_EXT = Enumerant('GL_SECONDARY_COLOR_ARRAY_STRIDE_EXT', 0x845c, 'GL_EXT_secondary_color')
GL_SECONDARY_COLOR_ARRAY_TYPE_EXT = Enumerant('GL_SECONDARY_COLOR_ARRAY_TYPE_EXT', 0x845b, 'GL_EXT_secondary_color')

defines.add(GL_COLOR_SUM_EXT)
defines.add(GL_CURRENT_SECONDARY_COLOR_EXT)
defines.add(GL_SECONDARY_COLOR_ARRAY_EXT)
defines.add(GL_SECONDARY_COLOR_ARRAY_POINTER_EXT)
defines.add(GL_SECONDARY_COLOR_ARRAY_SIZE_EXT)
defines.add(GL_SECONDARY_COLOR_ARRAY_STRIDE_EXT)
defines.add(GL_SECONDARY_COLOR_ARRAY_TYPE_EXT)

# GL_EXT_separate_shader_objects

GL_ACTIVE_PROGRAM_EXT = Enumerant('GL_ACTIVE_PROGRAM_EXT', 0x8b8d, 'GL_EXT_separate_shader_objects')

defines.add(GL_ACTIVE_PROGRAM_EXT)

# GL_EXT_separate_specular_color

GL_LIGHT_MODEL_COLOR_CONTROL_EXT = Enumerant('GL_LIGHT_MODEL_COLOR_CONTROL_EXT', 0x81f8, 'GL_EXT_separate_specular_color')
GL_SEPARATE_SPECULAR_COLOR_EXT = Enumerant('GL_SEPARATE_SPECULAR_COLOR_EXT', 0x81fa, 'GL_EXT_separate_specular_color')
GL_SINGLE_COLOR_EXT = Enumerant('GL_SINGLE_COLOR_EXT', 0x81f9, 'GL_EXT_separate_specular_color')

defines.add(GL_LIGHT_MODEL_COLOR_CONTROL_EXT)
defines.add(GL_SEPARATE_SPECULAR_COLOR_EXT)
defines.add(GL_SINGLE_COLOR_EXT)

# GL_EXT_shader_framebuffer_fetch

GL_FRAGMENT_SHADER_DISCARDS_SAMPLES_EXT = Enumerant('GL_FRAGMENT_SHADER_DISCARDS_SAMPLES_EXT', 0x8a52, 'GL_EXT_shader_framebuffer_fetch')

defines.add(GL_FRAGMENT_SHADER_DISCARDS_SAMPLES_EXT)

# GL_EXT_shader_image_load_store

GL_ALL_BARRIER_BITS_EXT = Enumerant('GL_ALL_BARRIER_BITS_EXT', 0xffffffff, 'GL_EXT_shader_image_load_store')
GL_ATOMIC_COUNTER_BARRIER_BIT_EXT = Enumerant('GL_ATOMIC_COUNTER_BARRIER_BIT_EXT', 0x1000, 'GL_EXT_shader_image_load_store')
GL_BUFFER_UPDATE_BARRIER_BIT_EXT = Enumerant('GL_BUFFER_UPDATE_BARRIER_BIT_EXT', 0x0200, 'GL_EXT_shader_image_load_store')
GL_COMMAND_BARRIER_BIT_EXT = Enumerant('GL_COMMAND_BARRIER_BIT_EXT', 0x0040, 'GL_EXT_shader_image_load_store')
GL_ELEMENT_ARRAY_BARRIER_BIT_EXT = Enumerant('GL_ELEMENT_ARRAY_BARRIER_BIT_EXT', 0x0002, 'GL_EXT_shader_image_load_store')
GL_FRAMEBUFFER_BARRIER_BIT_EXT = Enumerant('GL_FRAMEBUFFER_BARRIER_BIT_EXT', 0x0400, 'GL_EXT_shader_image_load_store')
GL_IMAGE_1D_ARRAY_EXT = Enumerant('GL_IMAGE_1D_ARRAY_EXT', 0x9052, 'GL_EXT_shader_image_load_store')
GL_IMAGE_1D_EXT = Enumerant('GL_IMAGE_1D_EXT', 0x904c, 'GL_EXT_shader_image_load_store')
GL_IMAGE_2D_ARRAY_EXT = Enumerant('GL_IMAGE_2D_ARRAY_EXT', 0x9053, 'GL_EXT_shader_image_load_store')
GL_IMAGE_2D_EXT = Enumerant('GL_IMAGE_2D_EXT', 0x904d, 'GL_EXT_shader_image_load_store')
GL_IMAGE_2D_MULTISAMPLE_ARRAY_EXT = Enumerant('GL_IMAGE_2D_MULTISAMPLE_ARRAY_EXT', 0x9056, 'GL_EXT_shader_image_load_store')
GL_IMAGE_2D_MULTISAMPLE_EXT = Enumerant('GL_IMAGE_2D_MULTISAMPLE_EXT', 0x9055, 'GL_EXT_shader_image_load_store')
GL_IMAGE_2D_RECT_EXT = Enumerant('GL_IMAGE_2D_RECT_EXT', 0x904f, 'GL_EXT_shader_image_load_store')
GL_IMAGE_3D_EXT = Enumerant('GL_IMAGE_3D_EXT', 0x904e, 'GL_EXT_shader_image_load_store')
GL_IMAGE_BINDING_ACCESS_EXT = Enumerant('GL_IMAGE_BINDING_ACCESS_EXT', 0x8f3e, 'GL_EXT_shader_image_load_store')
GL_IMAGE_BINDING_FORMAT_EXT = Enumerant('GL_IMAGE_BINDING_FORMAT_EXT', 0x906e, 'GL_EXT_shader_image_load_store')
GL_IMAGE_BINDING_LAYERED_EXT = Enumerant('GL_IMAGE_BINDING_LAYERED_EXT', 0x8f3c, 'GL_EXT_shader_image_load_store')
GL_IMAGE_BINDING_LAYER_EXT = Enumerant('GL_IMAGE_BINDING_LAYER_EXT', 0x8f3d, 'GL_EXT_shader_image_load_store')
GL_IMAGE_BINDING_LEVEL_EXT = Enumerant('GL_IMAGE_BINDING_LEVEL_EXT', 0x8f3b, 'GL_EXT_shader_image_load_store')
GL_IMAGE_BINDING_NAME_EXT = Enumerant('GL_IMAGE_BINDING_NAME_EXT', 0x8f3a, 'GL_EXT_shader_image_load_store')
GL_IMAGE_BUFFER_EXT = Enumerant('GL_IMAGE_BUFFER_EXT', 0x9051, 'GL_EXT_shader_image_load_store')
GL_IMAGE_CUBE_EXT = Enumerant('GL_IMAGE_CUBE_EXT', 0x9050, 'GL_EXT_shader_image_load_store')
GL_IMAGE_CUBE_MAP_ARRAY_EXT = Enumerant('GL_IMAGE_CUBE_MAP_ARRAY_EXT', 0x9054, 'GL_EXT_shader_image_load_store')
GL_INT_IMAGE_1D_ARRAY_EXT = Enumerant('GL_INT_IMAGE_1D_ARRAY_EXT', 0x905d, 'GL_EXT_shader_image_load_store')
GL_INT_IMAGE_1D_EXT = Enumerant('GL_INT_IMAGE_1D_EXT', 0x9057, 'GL_EXT_shader_image_load_store')
GL_INT_IMAGE_2D_ARRAY_EXT = Enumerant('GL_INT_IMAGE_2D_ARRAY_EXT', 0x905e, 'GL_EXT_shader_image_load_store')
GL_INT_IMAGE_2D_EXT = Enumerant('GL_INT_IMAGE_2D_EXT', 0x9058, 'GL_EXT_shader_image_load_store')
GL_INT_IMAGE_2D_MULTISAMPLE_ARRAY_EXT = Enumerant('GL_INT_IMAGE_2D_MULTISAMPLE_ARRAY_EXT', 0x9061, 'GL_EXT_shader_image_load_store')
GL_INT_IMAGE_2D_MULTISAMPLE_EXT = Enumerant('GL_INT_IMAGE_2D_MULTISAMPLE_EXT', 0x9060, 'GL_EXT_shader_image_load_store')
GL_INT_IMAGE_2D_RECT_EXT = Enumerant('GL_INT_IMAGE_2D_RECT_EXT', 0x905a, 'GL_EXT_shader_image_load_store')
GL_INT_IMAGE_3D_EXT = Enumerant('GL_INT_IMAGE_3D_EXT', 0x9059, 'GL_EXT_shader_image_load_store')
GL_INT_IMAGE_BUFFER_EXT = Enumerant('GL_INT_IMAGE_BUFFER_EXT', 0x905c, 'GL_EXT_shader_image_load_store')
GL_INT_IMAGE_CUBE_EXT = Enumerant('GL_INT_IMAGE_CUBE_EXT', 0x905b, 'GL_EXT_shader_image_load_store')
GL_INT_IMAGE_CUBE_MAP_ARRAY_EXT = Enumerant('GL_INT_IMAGE_CUBE_MAP_ARRAY_EXT', 0x905f, 'GL_EXT_shader_image_load_store')
GL_MAX_COMBINED_IMAGE_UNITS_AND_FRAGMENT_OUTPUTS_EXT = Enumerant('GL_MAX_COMBINED_IMAGE_UNITS_AND_FRAGMENT_OUTPUTS_EXT', 0x8f39, 'GL_EXT_shader_image_load_store')
GL_MAX_IMAGE_SAMPLES_EXT = Enumerant('GL_MAX_IMAGE_SAMPLES_EXT', 0x906d, 'GL_EXT_shader_image_load_store')
GL_MAX_IMAGE_UNITS_EXT = Enumerant('GL_MAX_IMAGE_UNITS_EXT', 0x8f38, 'GL_EXT_shader_image_load_store')
GL_PIXEL_BUFFER_BARRIER_BIT_EXT = Enumerant('GL_PIXEL_BUFFER_BARRIER_BIT_EXT', 0x0080, 'GL_EXT_shader_image_load_store')
GL_SHADER_IMAGE_ACCESS_BARRIER_BIT_EXT = Enumerant('GL_SHADER_IMAGE_ACCESS_BARRIER_BIT_EXT', 0x0020, 'GL_EXT_shader_image_load_store')
GL_TEXTURE_FETCH_BARRIER_BIT_EXT = Enumerant('GL_TEXTURE_FETCH_BARRIER_BIT_EXT', 0x0008, 'GL_EXT_shader_image_load_store')
GL_TEXTURE_UPDATE_BARRIER_BIT_EXT = Enumerant('GL_TEXTURE_UPDATE_BARRIER_BIT_EXT', 0x0100, 'GL_EXT_shader_image_load_store')
GL_TRANSFORM_FEEDBACK_BARRIER_BIT_EXT = Enumerant('GL_TRANSFORM_FEEDBACK_BARRIER_BIT_EXT', 0x0800, 'GL_EXT_shader_image_load_store')
GL_UNIFORM_BARRIER_BIT_EXT = Enumerant('GL_UNIFORM_BARRIER_BIT_EXT', 0x0004, 'GL_EXT_shader_image_load_store')
GL_UNSIGNED_INT_IMAGE_1D_ARRAY_EXT = Enumerant('GL_UNSIGNED_INT_IMAGE_1D_ARRAY_EXT', 0x9068, 'GL_EXT_shader_image_load_store')
GL_UNSIGNED_INT_IMAGE_1D_EXT = Enumerant('GL_UNSIGNED_INT_IMAGE_1D_EXT', 0x9062, 'GL_EXT_shader_image_load_store')
GL_UNSIGNED_INT_IMAGE_2D_ARRAY_EXT = Enumerant('GL_UNSIGNED_INT_IMAGE_2D_ARRAY_EXT', 0x9069, 'GL_EXT_shader_image_load_store')
GL_UNSIGNED_INT_IMAGE_2D_EXT = Enumerant('GL_UNSIGNED_INT_IMAGE_2D_EXT', 0x9063, 'GL_EXT_shader_image_load_store')
GL_UNSIGNED_INT_IMAGE_2D_MULTISAMPLE_ARRAY_EXT = Enumerant('GL_UNSIGNED_INT_IMAGE_2D_MULTISAMPLE_ARRAY_EXT', 0x906c, 'GL_EXT_shader_image_load_store')
GL_UNSIGNED_INT_IMAGE_2D_MULTISAMPLE_EXT = Enumerant('GL_UNSIGNED_INT_IMAGE_2D_MULTISAMPLE_EXT', 0x906b, 'GL_EXT_shader_image_load_store')
GL_UNSIGNED_INT_IMAGE_2D_RECT_EXT = Enumerant('GL_UNSIGNED_INT_IMAGE_2D_RECT_EXT', 0x9065, 'GL_EXT_shader_image_load_store')
GL_UNSIGNED_INT_IMAGE_3D_EXT = Enumerant('GL_UNSIGNED_INT_IMAGE_3D_EXT', 0x9064, 'GL_EXT_shader_image_load_store')
GL_UNSIGNED_INT_IMAGE_BUFFER_EXT = Enumerant('GL_UNSIGNED_INT_IMAGE_BUFFER_EXT', 0x9067, 'GL_EXT_shader_image_load_store')
GL_UNSIGNED_INT_IMAGE_CUBE_EXT = Enumerant('GL_UNSIGNED_INT_IMAGE_CUBE_EXT', 0x9066, 'GL_EXT_shader_image_load_store')
GL_UNSIGNED_INT_IMAGE_CUBE_MAP_ARRAY_EXT = Enumerant('GL_UNSIGNED_INT_IMAGE_CUBE_MAP_ARRAY_EXT', 0x906a, 'GL_EXT_shader_image_load_store')
GL_VERTEX_ATTRIB_ARRAY_BARRIER_BIT_EXT = Enumerant('GL_VERTEX_ATTRIB_ARRAY_BARRIER_BIT_EXT', 0x0001, 'GL_EXT_shader_image_load_store')

defines.add(GL_ALL_BARRIER_BITS_EXT)
defines.add(GL_ATOMIC_COUNTER_BARRIER_BIT_EXT)
defines.add(GL_BUFFER_UPDATE_BARRIER_BIT_EXT)
defines.add(GL_COMMAND_BARRIER_BIT_EXT)
defines.add(GL_ELEMENT_ARRAY_BARRIER_BIT_EXT)
defines.add(GL_FRAMEBUFFER_BARRIER_BIT_EXT)
defines.add(GL_IMAGE_1D_ARRAY_EXT)
defines.add(GL_IMAGE_1D_EXT)
defines.add(GL_IMAGE_2D_ARRAY_EXT)
defines.add(GL_IMAGE_2D_EXT)
defines.add(GL_IMAGE_2D_MULTISAMPLE_ARRAY_EXT)
defines.add(GL_IMAGE_2D_MULTISAMPLE_EXT)
defines.add(GL_IMAGE_2D_RECT_EXT)
defines.add(GL_IMAGE_3D_EXT)
defines.add(GL_IMAGE_BINDING_ACCESS_EXT)
defines.add(GL_IMAGE_BINDING_FORMAT_EXT)
defines.add(GL_IMAGE_BINDING_LAYERED_EXT)
defines.add(GL_IMAGE_BINDING_LAYER_EXT)
defines.add(GL_IMAGE_BINDING_LEVEL_EXT)
defines.add(GL_IMAGE_BINDING_NAME_EXT)
defines.add(GL_IMAGE_BUFFER_EXT)
defines.add(GL_IMAGE_CUBE_EXT)
defines.add(GL_IMAGE_CUBE_MAP_ARRAY_EXT)
defines.add(GL_INT_IMAGE_1D_ARRAY_EXT)
defines.add(GL_INT_IMAGE_1D_EXT)
defines.add(GL_INT_IMAGE_2D_ARRAY_EXT)
defines.add(GL_INT_IMAGE_2D_EXT)
defines.add(GL_INT_IMAGE_2D_MULTISAMPLE_ARRAY_EXT)
defines.add(GL_INT_IMAGE_2D_MULTISAMPLE_EXT)
defines.add(GL_INT_IMAGE_2D_RECT_EXT)
defines.add(GL_INT_IMAGE_3D_EXT)
defines.add(GL_INT_IMAGE_BUFFER_EXT)
defines.add(GL_INT_IMAGE_CUBE_EXT)
defines.add(GL_INT_IMAGE_CUBE_MAP_ARRAY_EXT)
defines.add(GL_MAX_COMBINED_IMAGE_UNITS_AND_FRAGMENT_OUTPUTS_EXT)
defines.add(GL_MAX_IMAGE_SAMPLES_EXT)
defines.add(GL_MAX_IMAGE_UNITS_EXT)
defines.add(GL_PIXEL_BUFFER_BARRIER_BIT_EXT)
defines.add(GL_SHADER_IMAGE_ACCESS_BARRIER_BIT_EXT)
defines.add(GL_TEXTURE_FETCH_BARRIER_BIT_EXT)
defines.add(GL_TEXTURE_UPDATE_BARRIER_BIT_EXT)
defines.add(GL_TRANSFORM_FEEDBACK_BARRIER_BIT_EXT)
defines.add(GL_UNIFORM_BARRIER_BIT_EXT)
defines.add(GL_UNSIGNED_INT_IMAGE_1D_ARRAY_EXT)
defines.add(GL_UNSIGNED_INT_IMAGE_1D_EXT)
defines.add(GL_UNSIGNED_INT_IMAGE_2D_ARRAY_EXT)
defines.add(GL_UNSIGNED_INT_IMAGE_2D_EXT)
defines.add(GL_UNSIGNED_INT_IMAGE_2D_MULTISAMPLE_ARRAY_EXT)
defines.add(GL_UNSIGNED_INT_IMAGE_2D_MULTISAMPLE_EXT)
defines.add(GL_UNSIGNED_INT_IMAGE_2D_RECT_EXT)
defines.add(GL_UNSIGNED_INT_IMAGE_3D_EXT)
defines.add(GL_UNSIGNED_INT_IMAGE_BUFFER_EXT)
defines.add(GL_UNSIGNED_INT_IMAGE_CUBE_EXT)
defines.add(GL_UNSIGNED_INT_IMAGE_CUBE_MAP_ARRAY_EXT)
defines.add(GL_VERTEX_ATTRIB_ARRAY_BARRIER_BIT_EXT)

# GL_EXT_shadow_samplers

GL_COMPARE_REF_TO_TEXTURE_EXT = Enumerant('GL_COMPARE_REF_TO_TEXTURE_EXT', 0x884e, 'GL_EXT_shadow_samplers')
GL_SAMPLER_2D_SHADOW_EXT = Enumerant('GL_SAMPLER_2D_SHADOW_EXT', 0x8b62, 'GL_EXT_shadow_samplers')
GL_TEXTURE_COMPARE_FUNC_EXT = Enumerant('GL_TEXTURE_COMPARE_FUNC_EXT', 0x884d, 'GL_EXT_shadow_samplers')
GL_TEXTURE_COMPARE_MODE_EXT = Enumerant('GL_TEXTURE_COMPARE_MODE_EXT', 0x884c, 'GL_EXT_shadow_samplers')

defines.add(GL_COMPARE_REF_TO_TEXTURE_EXT)
defines.add(GL_SAMPLER_2D_SHADOW_EXT)
defines.add(GL_TEXTURE_COMPARE_FUNC_EXT)
defines.add(GL_TEXTURE_COMPARE_MODE_EXT)

# GL_EXT_shared_texture_palette

GL_SHARED_TEXTURE_PALETTE_EXT = Enumerant('GL_SHARED_TEXTURE_PALETTE_EXT', 0x81fb, 'GL_EXT_shared_texture_palette')

defines.add(GL_SHARED_TEXTURE_PALETTE_EXT)

# GL_EXT_stencil_clear_tag

GL_STENCIL_CLEAR_TAG_VALUE_EXT = Enumerant('GL_STENCIL_CLEAR_TAG_VALUE_EXT', 0x88f3, 'GL_EXT_stencil_clear_tag')
GL_STENCIL_TAG_BITS_EXT = Enumerant('GL_STENCIL_TAG_BITS_EXT', 0x88f2, 'GL_EXT_stencil_clear_tag')

defines.add(GL_STENCIL_CLEAR_TAG_VALUE_EXT)
defines.add(GL_STENCIL_TAG_BITS_EXT)

# GL_EXT_stencil_two_side

GL_ACTIVE_STENCIL_FACE_EXT = Enumerant('GL_ACTIVE_STENCIL_FACE_EXT', 0x8911, 'GL_EXT_stencil_two_side')
GL_STENCIL_TEST_TWO_SIDE_EXT = Enumerant('GL_STENCIL_TEST_TWO_SIDE_EXT', 0x8910, 'GL_EXT_stencil_two_side')

defines.add(GL_ACTIVE_STENCIL_FACE_EXT)
defines.add(GL_STENCIL_TEST_TWO_SIDE_EXT)

# GL_EXT_stencil_wrap

GL_DECR_WRAP_EXT = Enumerant('GL_DECR_WRAP_EXT', 0x8508, 'GL_EXT_stencil_wrap')
GL_INCR_WRAP_EXT = Enumerant('GL_INCR_WRAP_EXT', 0x8507, 'GL_EXT_stencil_wrap')

defines.add(GL_DECR_WRAP_EXT)
defines.add(GL_INCR_WRAP_EXT)

# GL_EXT_texture

GL_ALPHA12_EXT = Enumerant('GL_ALPHA12_EXT', 0x803d, 'GL_EXT_texture')
GL_ALPHA16_EXT = Enumerant('GL_ALPHA16_EXT', 0x803e, 'GL_EXT_texture')
GL_ALPHA4_EXT = Enumerant('GL_ALPHA4_EXT', 0x803b, 'GL_EXT_texture')
GL_ALPHA8_EXT = Enumerant('GL_ALPHA8_EXT', 0x803c, 'GL_EXT_texture')
GL_INTENSITY12_EXT = Enumerant('GL_INTENSITY12_EXT', 0x804c, 'GL_EXT_texture')
GL_INTENSITY16_EXT = Enumerant('GL_INTENSITY16_EXT', 0x804d, 'GL_EXT_texture')
GL_INTENSITY4_EXT = Enumerant('GL_INTENSITY4_EXT', 0x804a, 'GL_EXT_texture')
GL_INTENSITY8_EXT = Enumerant('GL_INTENSITY8_EXT', 0x804b, 'GL_EXT_texture')
GL_INTENSITY_EXT = Enumerant('GL_INTENSITY_EXT', 0x8049, 'GL_EXT_texture')
GL_LUMINANCE12_ALPHA12_EXT = Enumerant('GL_LUMINANCE12_ALPHA12_EXT', 0x8047, 'GL_EXT_texture')
GL_LUMINANCE12_ALPHA4_EXT = Enumerant('GL_LUMINANCE12_ALPHA4_EXT', 0x8046, 'GL_EXT_texture')
GL_LUMINANCE12_EXT = Enumerant('GL_LUMINANCE12_EXT', 0x8041, 'GL_EXT_texture')
GL_LUMINANCE16_ALPHA16_EXT = Enumerant('GL_LUMINANCE16_ALPHA16_EXT', 0x8048, 'GL_EXT_texture')
GL_LUMINANCE16_EXT = Enumerant('GL_LUMINANCE16_EXT', 0x8042, 'GL_EXT_texture')
GL_LUMINANCE4_ALPHA4_EXT = Enumerant('GL_LUMINANCE4_ALPHA4_EXT', 0x8043, 'GL_EXT_texture')
GL_LUMINANCE4_EXT = Enumerant('GL_LUMINANCE4_EXT', 0x803f, 'GL_EXT_texture')
GL_LUMINANCE6_ALPHA2_EXT = Enumerant('GL_LUMINANCE6_ALPHA2_EXT', 0x8044, 'GL_EXT_texture')
GL_LUMINANCE8_ALPHA8_EXT = Enumerant('GL_LUMINANCE8_ALPHA8_EXT', 0x8045, 'GL_EXT_texture')
GL_LUMINANCE8_EXT = Enumerant('GL_LUMINANCE8_EXT', 0x8040, 'GL_EXT_texture')
GL_PROXY_TEXTURE_1D_EXT = Enumerant('GL_PROXY_TEXTURE_1D_EXT', 0x8063, 'GL_EXT_texture')
GL_PROXY_TEXTURE_2D_EXT = Enumerant('GL_PROXY_TEXTURE_2D_EXT', 0x8064, 'GL_EXT_texture')
GL_REPLACE_EXT = Enumerant('GL_REPLACE_EXT', 0x8062, 'GL_EXT_texture')
GL_RGB10_A2_EXT = Enumerant('GL_RGB10_A2_EXT', 0x8059, 'GL_EXT_texture')
GL_RGB10_EXT = Enumerant('GL_RGB10_EXT', 0x8052, 'GL_EXT_texture')
GL_RGB12_EXT = Enumerant('GL_RGB12_EXT', 0x8053, 'GL_EXT_texture')
GL_RGB16_EXT = Enumerant('GL_RGB16_EXT', 0x8054, 'GL_EXT_texture')
GL_RGB2_EXT = Enumerant('GL_RGB2_EXT', 0x804e, 'GL_EXT_texture')
GL_RGB4_EXT = Enumerant('GL_RGB4_EXT', 0x804f, 'GL_EXT_texture')
GL_RGB5_A1_EXT = Enumerant('GL_RGB5_A1_EXT', 0x8057, 'GL_EXT_texture')
GL_RGB5_EXT = Enumerant('GL_RGB5_EXT', 0x8050, 'GL_EXT_texture')
GL_RGB8_EXT = Enumerant('GL_RGB8_EXT', 0x8051, 'GL_EXT_texture')
GL_RGBA12_EXT = Enumerant('GL_RGBA12_EXT', 0x805a, 'GL_EXT_texture')
GL_RGBA16_EXT = Enumerant('GL_RGBA16_EXT', 0x805b, 'GL_EXT_texture')
GL_RGBA2_EXT = Enumerant('GL_RGBA2_EXT', 0x8055, 'GL_EXT_texture')
GL_RGBA4_EXT = Enumerant('GL_RGBA4_EXT', 0x8056, 'GL_EXT_texture')
GL_RGBA8_EXT = Enumerant('GL_RGBA8_EXT', 0x8058, 'GL_EXT_texture')
GL_TEXTURE_ALPHA_SIZE_EXT = Enumerant('GL_TEXTURE_ALPHA_SIZE_EXT', 0x805f, 'GL_EXT_texture')
GL_TEXTURE_BLUE_SIZE_EXT = Enumerant('GL_TEXTURE_BLUE_SIZE_EXT', 0x805e, 'GL_EXT_texture')
GL_TEXTURE_GREEN_SIZE_EXT = Enumerant('GL_TEXTURE_GREEN_SIZE_EXT', 0x805d, 'GL_EXT_texture')
GL_TEXTURE_INTENSITY_SIZE_EXT = Enumerant('GL_TEXTURE_INTENSITY_SIZE_EXT', 0x8061, 'GL_EXT_texture')
GL_TEXTURE_LUMINANCE_SIZE_EXT = Enumerant('GL_TEXTURE_LUMINANCE_SIZE_EXT', 0x8060, 'GL_EXT_texture')
GL_TEXTURE_RED_SIZE_EXT = Enumerant('GL_TEXTURE_RED_SIZE_EXT', 0x805c, 'GL_EXT_texture')

defines.add(GL_ALPHA12_EXT)
defines.add(GL_ALPHA16_EXT)
defines.add(GL_ALPHA4_EXT)
defines.add(GL_ALPHA8_EXT)
defines.add(GL_INTENSITY12_EXT)
defines.add(GL_INTENSITY16_EXT)
defines.add(GL_INTENSITY4_EXT)
defines.add(GL_INTENSITY8_EXT)
defines.add(GL_INTENSITY_EXT)
defines.add(GL_LUMINANCE12_ALPHA12_EXT)
defines.add(GL_LUMINANCE12_ALPHA4_EXT)
defines.add(GL_LUMINANCE12_EXT)
defines.add(GL_LUMINANCE16_ALPHA16_EXT)
defines.add(GL_LUMINANCE16_EXT)
defines.add(GL_LUMINANCE4_ALPHA4_EXT)
defines.add(GL_LUMINANCE4_EXT)
defines.add(GL_LUMINANCE6_ALPHA2_EXT)
defines.add(GL_LUMINANCE8_ALPHA8_EXT)
defines.add(GL_LUMINANCE8_EXT)
defines.add(GL_PROXY_TEXTURE_1D_EXT)
defines.add(GL_PROXY_TEXTURE_2D_EXT)
defines.add(GL_REPLACE_EXT)
defines.add(GL_RGB10_A2_EXT)
defines.add(GL_RGB10_EXT)
defines.add(GL_RGB12_EXT)
defines.add(GL_RGB16_EXT)
defines.add(GL_RGB2_EXT)
defines.add(GL_RGB4_EXT)
defines.add(GL_RGB5_A1_EXT)
defines.add(GL_RGB5_EXT)
defines.add(GL_RGB8_EXT)
defines.add(GL_RGBA12_EXT)
defines.add(GL_RGBA16_EXT)
defines.add(GL_RGBA2_EXT)
defines.add(GL_RGBA4_EXT)
defines.add(GL_RGBA8_EXT)
defines.add(GL_TEXTURE_ALPHA_SIZE_EXT)
defines.add(GL_TEXTURE_BLUE_SIZE_EXT)
defines.add(GL_TEXTURE_GREEN_SIZE_EXT)
defines.add(GL_TEXTURE_INTENSITY_SIZE_EXT)
defines.add(GL_TEXTURE_LUMINANCE_SIZE_EXT)
defines.add(GL_TEXTURE_RED_SIZE_EXT)

# GL_EXT_texture3D

GL_MAX_3D_TEXTURE_SIZE_EXT = Enumerant('GL_MAX_3D_TEXTURE_SIZE_EXT', 0x8073, 'GL_EXT_texture3D')
GL_PACK_IMAGE_HEIGHT_EXT = Enumerant('GL_PACK_IMAGE_HEIGHT_EXT', 0x806c, 'GL_EXT_texture3D')
GL_PACK_SKIP_IMAGES_EXT = Enumerant('GL_PACK_SKIP_IMAGES_EXT', 0x806b, 'GL_EXT_texture3D')
GL_PROXY_TEXTURE_3D_EXT = Enumerant('GL_PROXY_TEXTURE_3D_EXT', 0x8070, 'GL_EXT_texture3D')
GL_TEXTURE_3D_EXT = Enumerant('GL_TEXTURE_3D_EXT', 0x806f, 'GL_EXT_texture3D')
GL_TEXTURE_DEPTH_EXT = Enumerant('GL_TEXTURE_DEPTH_EXT', 0x8071, 'GL_EXT_texture3D')
GL_TEXTURE_WRAP_R_EXT = Enumerant('GL_TEXTURE_WRAP_R_EXT', 0x8072, 'GL_EXT_texture3D')
GL_UNPACK_IMAGE_HEIGHT_EXT = Enumerant('GL_UNPACK_IMAGE_HEIGHT_EXT', 0x806e, 'GL_EXT_texture3D')
GL_UNPACK_SKIP_IMAGES_EXT = Enumerant('GL_UNPACK_SKIP_IMAGES_EXT', 0x806d, 'GL_EXT_texture3D')

defines.add(GL_MAX_3D_TEXTURE_SIZE_EXT)
defines.add(GL_PACK_IMAGE_HEIGHT_EXT)
defines.add(GL_PACK_SKIP_IMAGES_EXT)
defines.add(GL_PROXY_TEXTURE_3D_EXT)
defines.add(GL_TEXTURE_3D_EXT)
defines.add(GL_TEXTURE_DEPTH_EXT)
defines.add(GL_TEXTURE_WRAP_R_EXT)
defines.add(GL_UNPACK_IMAGE_HEIGHT_EXT)
defines.add(GL_UNPACK_SKIP_IMAGES_EXT)

# GL_EXT_texture_array

GL_COMPARE_REF_DEPTH_TO_TEXTURE_EXT = Enumerant('GL_COMPARE_REF_DEPTH_TO_TEXTURE_EXT', 0x884e, 'GL_EXT_texture_array')
GL_MAX_ARRAY_TEXTURE_LAYERS_EXT = Enumerant('GL_MAX_ARRAY_TEXTURE_LAYERS_EXT', 0x88ff, 'GL_EXT_texture_array')
GL_PROXY_TEXTURE_1D_ARRAY_EXT = Enumerant('GL_PROXY_TEXTURE_1D_ARRAY_EXT', 0x8c19, 'GL_EXT_texture_array')
GL_PROXY_TEXTURE_2D_ARRAY_EXT = Enumerant('GL_PROXY_TEXTURE_2D_ARRAY_EXT', 0x8c1b, 'GL_EXT_texture_array')
GL_TEXTURE_1D_ARRAY_EXT = Enumerant('GL_TEXTURE_1D_ARRAY_EXT', 0x8c18, 'GL_EXT_texture_array')
GL_TEXTURE_2D_ARRAY_EXT = Enumerant('GL_TEXTURE_2D_ARRAY_EXT', 0x8c1a, 'GL_EXT_texture_array')
GL_TEXTURE_BINDING_1D_ARRAY_EXT = Enumerant('GL_TEXTURE_BINDING_1D_ARRAY_EXT', 0x8c1c, 'GL_EXT_texture_array')
GL_TEXTURE_BINDING_2D_ARRAY_EXT = Enumerant('GL_TEXTURE_BINDING_2D_ARRAY_EXT', 0x8c1d, 'GL_EXT_texture_array')

defines.add(GL_COMPARE_REF_DEPTH_TO_TEXTURE_EXT)
defines.add(GL_MAX_ARRAY_TEXTURE_LAYERS_EXT)
defines.add(GL_PROXY_TEXTURE_1D_ARRAY_EXT)
defines.add(GL_PROXY_TEXTURE_2D_ARRAY_EXT)
defines.add(GL_TEXTURE_1D_ARRAY_EXT)
defines.add(GL_TEXTURE_2D_ARRAY_EXT)
defines.add(GL_TEXTURE_BINDING_1D_ARRAY_EXT)
defines.add(GL_TEXTURE_BINDING_2D_ARRAY_EXT)

# GL_EXT_texture_buffer_object

GL_MAX_TEXTURE_BUFFER_SIZE_EXT = Enumerant('GL_MAX_TEXTURE_BUFFER_SIZE_EXT', 0x8c2b, 'GL_EXT_texture_buffer_object')
GL_TEXTURE_BINDING_BUFFER_EXT = Enumerant('GL_TEXTURE_BINDING_BUFFER_EXT', 0x8c2c, 'GL_EXT_texture_buffer_object')
GL_TEXTURE_BUFFER_DATA_STORE_BINDING_EXT = Enumerant('GL_TEXTURE_BUFFER_DATA_STORE_BINDING_EXT', 0x8c2d, 'GL_EXT_texture_buffer_object')
GL_TEXTURE_BUFFER_EXT = Enumerant('GL_TEXTURE_BUFFER_EXT', 0x8c2a, 'GL_EXT_texture_buffer_object')
GL_TEXTURE_BUFFER_FORMAT_EXT = Enumerant('GL_TEXTURE_BUFFER_FORMAT_EXT', 0x8c2e, 'GL_EXT_texture_buffer_object')

defines.add(GL_MAX_TEXTURE_BUFFER_SIZE_EXT)
defines.add(GL_TEXTURE_BINDING_BUFFER_EXT)
defines.add(GL_TEXTURE_BUFFER_DATA_STORE_BINDING_EXT)
defines.add(GL_TEXTURE_BUFFER_EXT)
defines.add(GL_TEXTURE_BUFFER_FORMAT_EXT)

# GL_EXT_texture_compression_latc

GL_COMPRESSED_LUMINANCE_ALPHA_LATC2_EXT = Enumerant('GL_COMPRESSED_LUMINANCE_ALPHA_LATC2_EXT', 0x8c72, 'GL_EXT_texture_compression_latc')
GL_COMPRESSED_LUMINANCE_LATC1_EXT = Enumerant('GL_COMPRESSED_LUMINANCE_LATC1_EXT', 0x8c70, 'GL_EXT_texture_compression_latc')
GL_COMPRESSED_SIGNED_LUMINANCE_ALPHA_LATC2_EXT = Enumerant('GL_COMPRESSED_SIGNED_LUMINANCE_ALPHA_LATC2_EXT', 0x8c73, 'GL_EXT_texture_compression_latc')
GL_COMPRESSED_SIGNED_LUMINANCE_LATC1_EXT = Enumerant('GL_COMPRESSED_SIGNED_LUMINANCE_LATC1_EXT', 0x8c71, 'GL_EXT_texture_compression_latc')

defines.add(GL_COMPRESSED_LUMINANCE_ALPHA_LATC2_EXT)
defines.add(GL_COMPRESSED_LUMINANCE_LATC1_EXT)
defines.add(GL_COMPRESSED_SIGNED_LUMINANCE_ALPHA_LATC2_EXT)
defines.add(GL_COMPRESSED_SIGNED_LUMINANCE_LATC1_EXT)

# GL_EXT_texture_compression_rgtc

GL_COMPRESSED_RED_GREEN_RGTC2_EXT = Enumerant('GL_COMPRESSED_RED_GREEN_RGTC2_EXT', 0x8dbd, 'GL_EXT_texture_compression_rgtc')
GL_COMPRESSED_RED_RGTC1_EXT = Enumerant('GL_COMPRESSED_RED_RGTC1_EXT', 0x8dbb, 'GL_EXT_texture_compression_rgtc')
GL_COMPRESSED_SIGNED_RED_GREEN_RGTC2_EXT = Enumerant('GL_COMPRESSED_SIGNED_RED_GREEN_RGTC2_EXT', 0x8dbe, 'GL_EXT_texture_compression_rgtc')
GL_COMPRESSED_SIGNED_RED_RGTC1_EXT = Enumerant('GL_COMPRESSED_SIGNED_RED_RGTC1_EXT', 0x8dbc, 'GL_EXT_texture_compression_rgtc')

defines.add(GL_COMPRESSED_RED_GREEN_RGTC2_EXT)
defines.add(GL_COMPRESSED_RED_RGTC1_EXT)
defines.add(GL_COMPRESSED_SIGNED_RED_GREEN_RGTC2_EXT)
defines.add(GL_COMPRESSED_SIGNED_RED_RGTC1_EXT)

# GL_EXT_texture_compression_s3tc

GL_COMPRESSED_RGBA_S3TC_DXT1_EXT = Enumerant('GL_COMPRESSED_RGBA_S3TC_DXT1_EXT', 0x83f1, 'GL_EXT_texture_compression_s3tc')
GL_COMPRESSED_RGBA_S3TC_DXT3_EXT = Enumerant('GL_COMPRESSED_RGBA_S3TC_DXT3_EXT', 0x83f2, 'GL_EXT_texture_compression_s3tc')
GL_COMPRESSED_RGBA_S3TC_DXT5_EXT = Enumerant('GL_COMPRESSED_RGBA_S3TC_DXT5_EXT', 0x83f3, 'GL_EXT_texture_compression_s3tc')
GL_COMPRESSED_RGB_S3TC_DXT1_EXT = Enumerant('GL_COMPRESSED_RGB_S3TC_DXT1_EXT', 0x83f0, 'GL_EXT_texture_compression_s3tc')

defines.add(GL_COMPRESSED_RGBA_S3TC_DXT1_EXT)
defines.add(GL_COMPRESSED_RGBA_S3TC_DXT3_EXT)
defines.add(GL_COMPRESSED_RGBA_S3TC_DXT5_EXT)
defines.add(GL_COMPRESSED_RGB_S3TC_DXT1_EXT)

# GL_EXT_texture_cube_map

GL_MAX_CUBE_MAP_TEXTURE_SIZE_EXT = Enumerant('GL_MAX_CUBE_MAP_TEXTURE_SIZE_EXT', 0x851c, 'GL_EXT_texture_cube_map')
GL_NORMAL_MAP_EXT = Enumerant('GL_NORMAL_MAP_EXT', 0x8511, 'GL_EXT_texture_cube_map')
GL_PROXY_TEXTURE_CUBE_MAP_EXT = Enumerant('GL_PROXY_TEXTURE_CUBE_MAP_EXT', 0x851b, 'GL_EXT_texture_cube_map')
GL_REFLECTION_MAP_EXT = Enumerant('GL_REFLECTION_MAP_EXT', 0x8512, 'GL_EXT_texture_cube_map')
GL_TEXTURE_BINDING_CUBE_MAP_EXT = Enumerant('GL_TEXTURE_BINDING_CUBE_MAP_EXT', 0x8514, 'GL_EXT_texture_cube_map')
GL_TEXTURE_CUBE_MAP_EXT = Enumerant('GL_TEXTURE_CUBE_MAP_EXT', 0x8513, 'GL_EXT_texture_cube_map')
GL_TEXTURE_CUBE_MAP_NEGATIVE_X_EXT = Enumerant('GL_TEXTURE_CUBE_MAP_NEGATIVE_X_EXT', 0x8516, 'GL_EXT_texture_cube_map')
GL_TEXTURE_CUBE_MAP_NEGATIVE_Y_EXT = Enumerant('GL_TEXTURE_CUBE_MAP_NEGATIVE_Y_EXT', 0x8518, 'GL_EXT_texture_cube_map')
GL_TEXTURE_CUBE_MAP_NEGATIVE_Z_EXT = Enumerant('GL_TEXTURE_CUBE_MAP_NEGATIVE_Z_EXT', 0x851a, 'GL_EXT_texture_cube_map')
GL_TEXTURE_CUBE_MAP_POSITIVE_X_EXT = Enumerant('GL_TEXTURE_CUBE_MAP_POSITIVE_X_EXT', 0x8515, 'GL_EXT_texture_cube_map')
GL_TEXTURE_CUBE_MAP_POSITIVE_Y_EXT = Enumerant('GL_TEXTURE_CUBE_MAP_POSITIVE_Y_EXT', 0x8517, 'GL_EXT_texture_cube_map')
GL_TEXTURE_CUBE_MAP_POSITIVE_Z_EXT = Enumerant('GL_TEXTURE_CUBE_MAP_POSITIVE_Z_EXT', 0x8519, 'GL_EXT_texture_cube_map')

defines.add(GL_MAX_CUBE_MAP_TEXTURE_SIZE_EXT)
defines.add(GL_NORMAL_MAP_EXT)
defines.add(GL_PROXY_TEXTURE_CUBE_MAP_EXT)
defines.add(GL_REFLECTION_MAP_EXT)
defines.add(GL_TEXTURE_BINDING_CUBE_MAP_EXT)
defines.add(GL_TEXTURE_CUBE_MAP_EXT)
defines.add(GL_TEXTURE_CUBE_MAP_NEGATIVE_X_EXT)
defines.add(GL_TEXTURE_CUBE_MAP_NEGATIVE_Y_EXT)
defines.add(GL_TEXTURE_CUBE_MAP_NEGATIVE_Z_EXT)
defines.add(GL_TEXTURE_CUBE_MAP_POSITIVE_X_EXT)
defines.add(GL_TEXTURE_CUBE_MAP_POSITIVE_Y_EXT)
defines.add(GL_TEXTURE_CUBE_MAP_POSITIVE_Z_EXT)

# GL_EXT_texture_edge_clamp

GL_CLAMP_TO_EDGE_EXT = Enumerant('GL_CLAMP_TO_EDGE_EXT', 0x812f, 'GL_EXT_texture_edge_clamp')

defines.add(GL_CLAMP_TO_EDGE_EXT)

# GL_EXT_texture_env_combine

GL_ADD_SIGNED_EXT = Enumerant('GL_ADD_SIGNED_EXT', 0x8574, 'GL_EXT_texture_env_combine')
GL_COMBINE_ALPHA_EXT = Enumerant('GL_COMBINE_ALPHA_EXT', 0x8572, 'GL_EXT_texture_env_combine')
GL_COMBINE_EXT = Enumerant('GL_COMBINE_EXT', 0x8570, 'GL_EXT_texture_env_combine')
GL_COMBINE_RGB_EXT = Enumerant('GL_COMBINE_RGB_EXT', 0x8571, 'GL_EXT_texture_env_combine')
GL_CONSTANT_EXT = Enumerant('GL_CONSTANT_EXT', 0x8576, 'GL_EXT_texture_env_combine')
GL_INTERPOLATE_EXT = Enumerant('GL_INTERPOLATE_EXT', 0x8575, 'GL_EXT_texture_env_combine')
GL_OPERAND0_ALPHA_EXT = Enumerant('GL_OPERAND0_ALPHA_EXT', 0x8598, 'GL_EXT_texture_env_combine')
GL_OPERAND0_RGB_EXT = Enumerant('GL_OPERAND0_RGB_EXT', 0x8590, 'GL_EXT_texture_env_combine')
GL_OPERAND1_ALPHA_EXT = Enumerant('GL_OPERAND1_ALPHA_EXT', 0x8599, 'GL_EXT_texture_env_combine')
GL_OPERAND1_RGB_EXT = Enumerant('GL_OPERAND1_RGB_EXT', 0x8591, 'GL_EXT_texture_env_combine')
GL_OPERAND2_ALPHA_EXT = Enumerant('GL_OPERAND2_ALPHA_EXT', 0x859a, 'GL_EXT_texture_env_combine')
GL_OPERAND2_RGB_EXT = Enumerant('GL_OPERAND2_RGB_EXT', 0x8592, 'GL_EXT_texture_env_combine')
GL_PREVIOUS_EXT = Enumerant('GL_PREVIOUS_EXT', 0x8578, 'GL_EXT_texture_env_combine')
GL_PRIMARY_COLOR_EXT = Enumerant('GL_PRIMARY_COLOR_EXT', 0x8577, 'GL_EXT_texture_env_combine')
GL_RGB_SCALE_EXT = Enumerant('GL_RGB_SCALE_EXT', 0x8573, 'GL_EXT_texture_env_combine')
GL_SOURCE0_ALPHA_EXT = Enumerant('GL_SOURCE0_ALPHA_EXT', 0x8588, 'GL_EXT_texture_env_combine')
GL_SOURCE0_RGB_EXT = Enumerant('GL_SOURCE0_RGB_EXT', 0x8580, 'GL_EXT_texture_env_combine')
GL_SOURCE1_ALPHA_EXT = Enumerant('GL_SOURCE1_ALPHA_EXT', 0x8589, 'GL_EXT_texture_env_combine')
GL_SOURCE1_RGB_EXT = Enumerant('GL_SOURCE1_RGB_EXT', 0x8581, 'GL_EXT_texture_env_combine')
GL_SOURCE2_ALPHA_EXT = Enumerant('GL_SOURCE2_ALPHA_EXT', 0x858a, 'GL_EXT_texture_env_combine')
GL_SOURCE2_RGB_EXT = Enumerant('GL_SOURCE2_RGB_EXT', 0x8582, 'GL_EXT_texture_env_combine')

defines.add(GL_ADD_SIGNED_EXT)
defines.add(GL_COMBINE_ALPHA_EXT)
defines.add(GL_COMBINE_EXT)
defines.add(GL_COMBINE_RGB_EXT)
defines.add(GL_CONSTANT_EXT)
defines.add(GL_INTERPOLATE_EXT)
defines.add(GL_OPERAND0_ALPHA_EXT)
defines.add(GL_OPERAND0_RGB_EXT)
defines.add(GL_OPERAND1_ALPHA_EXT)
defines.add(GL_OPERAND1_RGB_EXT)
defines.add(GL_OPERAND2_ALPHA_EXT)
defines.add(GL_OPERAND2_RGB_EXT)
defines.add(GL_PREVIOUS_EXT)
defines.add(GL_PRIMARY_COLOR_EXT)
defines.add(GL_RGB_SCALE_EXT)
defines.add(GL_SOURCE0_ALPHA_EXT)
defines.add(GL_SOURCE0_RGB_EXT)
defines.add(GL_SOURCE1_ALPHA_EXT)
defines.add(GL_SOURCE1_RGB_EXT)
defines.add(GL_SOURCE2_ALPHA_EXT)
defines.add(GL_SOURCE2_RGB_EXT)

# GL_EXT_texture_env_dot3

GL_DOT3_RGBA_EXT = Enumerant('GL_DOT3_RGBA_EXT', 0x8741, 'GL_EXT_texture_env_dot3')
GL_DOT3_RGB_EXT = Enumerant('GL_DOT3_RGB_EXT', 0x8740, 'GL_EXT_texture_env_dot3')

defines.add(GL_DOT3_RGBA_EXT)
defines.add(GL_DOT3_RGB_EXT)

# GL_EXT_texture_filter_anisotropic

GL_MAX_TEXTURE_MAX_ANISOTROPY_EXT = Enumerant('GL_MAX_TEXTURE_MAX_ANISOTROPY_EXT', 0x84ff, 'GL_EXT_texture_filter_anisotropic')
GL_TEXTURE_MAX_ANISOTROPY_EXT = Enumerant('GL_TEXTURE_MAX_ANISOTROPY_EXT', 0x84fe, 'GL_EXT_texture_filter_anisotropic')

defines.add(GL_MAX_TEXTURE_MAX_ANISOTROPY_EXT)
defines.add(GL_TEXTURE_MAX_ANISOTROPY_EXT)

# GL_EXT_texture_integer

GL_ALPHA16I_EXT = Enumerant('GL_ALPHA16I_EXT', 0x8d8a, 'GL_EXT_texture_integer')
GL_ALPHA16UI_EXT = Enumerant('GL_ALPHA16UI_EXT', 0x8d78, 'GL_EXT_texture_integer')
GL_ALPHA32I_EXT = Enumerant('GL_ALPHA32I_EXT', 0x8d84, 'GL_EXT_texture_integer')
GL_ALPHA32UI_EXT = Enumerant('GL_ALPHA32UI_EXT', 0x8d72, 'GL_EXT_texture_integer')
GL_ALPHA8I_EXT = Enumerant('GL_ALPHA8I_EXT', 0x8d90, 'GL_EXT_texture_integer')
GL_ALPHA8UI_EXT = Enumerant('GL_ALPHA8UI_EXT', 0x8d7e, 'GL_EXT_texture_integer')
GL_ALPHA_INTEGER_EXT = Enumerant('GL_ALPHA_INTEGER_EXT', 0x8d97, 'GL_EXT_texture_integer')
GL_BGRA_INTEGER_EXT = Enumerant('GL_BGRA_INTEGER_EXT', 0x8d9b, 'GL_EXT_texture_integer')
GL_BGR_INTEGER_EXT = Enumerant('GL_BGR_INTEGER_EXT', 0x8d9a, 'GL_EXT_texture_integer')
GL_BLUE_INTEGER_EXT = Enumerant('GL_BLUE_INTEGER_EXT', 0x8d96, 'GL_EXT_texture_integer')
GL_GREEN_INTEGER_EXT = Enumerant('GL_GREEN_INTEGER_EXT', 0x8d95, 'GL_EXT_texture_integer')
GL_INTENSITY16I_EXT = Enumerant('GL_INTENSITY16I_EXT', 0x8d8b, 'GL_EXT_texture_integer')
GL_INTENSITY16UI_EXT = Enumerant('GL_INTENSITY16UI_EXT', 0x8d79, 'GL_EXT_texture_integer')
GL_INTENSITY32I_EXT = Enumerant('GL_INTENSITY32I_EXT', 0x8d85, 'GL_EXT_texture_integer')
GL_INTENSITY32UI_EXT = Enumerant('GL_INTENSITY32UI_EXT', 0x8d73, 'GL_EXT_texture_integer')
GL_INTENSITY8I_EXT = Enumerant('GL_INTENSITY8I_EXT', 0x8d91, 'GL_EXT_texture_integer')
GL_INTENSITY8UI_EXT = Enumerant('GL_INTENSITY8UI_EXT', 0x8d7f, 'GL_EXT_texture_integer')
GL_LUMINANCE16I_EXT = Enumerant('GL_LUMINANCE16I_EXT', 0x8d8c, 'GL_EXT_texture_integer')
GL_LUMINANCE16UI_EXT = Enumerant('GL_LUMINANCE16UI_EXT', 0x8d7a, 'GL_EXT_texture_integer')
GL_LUMINANCE32I_EXT = Enumerant('GL_LUMINANCE32I_EXT', 0x8d86, 'GL_EXT_texture_integer')
GL_LUMINANCE32UI_EXT = Enumerant('GL_LUMINANCE32UI_EXT', 0x8d74, 'GL_EXT_texture_integer')
GL_LUMINANCE8I_EXT = Enumerant('GL_LUMINANCE8I_EXT', 0x8d92, 'GL_EXT_texture_integer')
GL_LUMINANCE8UI_EXT = Enumerant('GL_LUMINANCE8UI_EXT', 0x8d80, 'GL_EXT_texture_integer')
GL_LUMINANCE_ALPHA16I_EXT = Enumerant('GL_LUMINANCE_ALPHA16I_EXT', 0x8d8d, 'GL_EXT_texture_integer')
GL_LUMINANCE_ALPHA16UI_EXT = Enumerant('GL_LUMINANCE_ALPHA16UI_EXT', 0x8d7b, 'GL_EXT_texture_integer')
GL_LUMINANCE_ALPHA32I_EXT = Enumerant('GL_LUMINANCE_ALPHA32I_EXT', 0x8d87, 'GL_EXT_texture_integer')
GL_LUMINANCE_ALPHA32UI_EXT = Enumerant('GL_LUMINANCE_ALPHA32UI_EXT', 0x8d75, 'GL_EXT_texture_integer')
GL_LUMINANCE_ALPHA8I_EXT = Enumerant('GL_LUMINANCE_ALPHA8I_EXT', 0x8d93, 'GL_EXT_texture_integer')
GL_LUMINANCE_ALPHA8UI_EXT = Enumerant('GL_LUMINANCE_ALPHA8UI_EXT', 0x8d81, 'GL_EXT_texture_integer')
GL_LUMINANCE_ALPHA_INTEGER_EXT = Enumerant('GL_LUMINANCE_ALPHA_INTEGER_EXT', 0x8d9d, 'GL_EXT_texture_integer')
GL_LUMINANCE_INTEGER_EXT = Enumerant('GL_LUMINANCE_INTEGER_EXT', 0x8d9c, 'GL_EXT_texture_integer')
GL_RED_INTEGER_EXT = Enumerant('GL_RED_INTEGER_EXT', 0x8d94, 'GL_EXT_texture_integer')
GL_RGB16I_EXT = Enumerant('GL_RGB16I_EXT', 0x8d89, 'GL_EXT_texture_integer')
GL_RGB16UI_EXT = Enumerant('GL_RGB16UI_EXT', 0x8d77, 'GL_EXT_texture_integer')
GL_RGB32I_EXT = Enumerant('GL_RGB32I_EXT', 0x8d83, 'GL_EXT_texture_integer')
GL_RGB32UI_EXT = Enumerant('GL_RGB32UI_EXT', 0x8d71, 'GL_EXT_texture_integer')
GL_RGB8I_EXT = Enumerant('GL_RGB8I_EXT', 0x8d8f, 'GL_EXT_texture_integer')
GL_RGB8UI_EXT = Enumerant('GL_RGB8UI_EXT', 0x8d7d, 'GL_EXT_texture_integer')
GL_RGBA16I_EXT = Enumerant('GL_RGBA16I_EXT', 0x8d88, 'GL_EXT_texture_integer')
GL_RGBA16UI_EXT = Enumerant('GL_RGBA16UI_EXT', 0x8d76, 'GL_EXT_texture_integer')
GL_RGBA32I_EXT = Enumerant('GL_RGBA32I_EXT', 0x8d82, 'GL_EXT_texture_integer')
GL_RGBA32UI_EXT = Enumerant('GL_RGBA32UI_EXT', 0x8d70, 'GL_EXT_texture_integer')
GL_RGBA8I_EXT = Enumerant('GL_RGBA8I_EXT', 0x8d8e, 'GL_EXT_texture_integer')
GL_RGBA8UI_EXT = Enumerant('GL_RGBA8UI_EXT', 0x8d7c, 'GL_EXT_texture_integer')
GL_RGBA_INTEGER_EXT = Enumerant('GL_RGBA_INTEGER_EXT', 0x8d99, 'GL_EXT_texture_integer')
GL_RGBA_INTEGER_MODE_EXT = Enumerant('GL_RGBA_INTEGER_MODE_EXT', 0x8d9e, 'GL_EXT_texture_integer')
GL_RGB_INTEGER_EXT = Enumerant('GL_RGB_INTEGER_EXT', 0x8d98, 'GL_EXT_texture_integer')

defines.add(GL_ALPHA16I_EXT)
defines.add(GL_ALPHA16UI_EXT)
defines.add(GL_ALPHA32I_EXT)
defines.add(GL_ALPHA32UI_EXT)
defines.add(GL_ALPHA8I_EXT)
defines.add(GL_ALPHA8UI_EXT)
defines.add(GL_ALPHA_INTEGER_EXT)
defines.add(GL_BGRA_INTEGER_EXT)
defines.add(GL_BGR_INTEGER_EXT)
defines.add(GL_BLUE_INTEGER_EXT)
defines.add(GL_GREEN_INTEGER_EXT)
defines.add(GL_INTENSITY16I_EXT)
defines.add(GL_INTENSITY16UI_EXT)
defines.add(GL_INTENSITY32I_EXT)
defines.add(GL_INTENSITY32UI_EXT)
defines.add(GL_INTENSITY8I_EXT)
defines.add(GL_INTENSITY8UI_EXT)
defines.add(GL_LUMINANCE16I_EXT)
defines.add(GL_LUMINANCE16UI_EXT)
defines.add(GL_LUMINANCE32I_EXT)
defines.add(GL_LUMINANCE32UI_EXT)
defines.add(GL_LUMINANCE8I_EXT)
defines.add(GL_LUMINANCE8UI_EXT)
defines.add(GL_LUMINANCE_ALPHA16I_EXT)
defines.add(GL_LUMINANCE_ALPHA16UI_EXT)
defines.add(GL_LUMINANCE_ALPHA32I_EXT)
defines.add(GL_LUMINANCE_ALPHA32UI_EXT)
defines.add(GL_LUMINANCE_ALPHA8I_EXT)
defines.add(GL_LUMINANCE_ALPHA8UI_EXT)
defines.add(GL_LUMINANCE_ALPHA_INTEGER_EXT)
defines.add(GL_LUMINANCE_INTEGER_EXT)
defines.add(GL_RED_INTEGER_EXT)
defines.add(GL_RGB16I_EXT)
defines.add(GL_RGB16UI_EXT)
defines.add(GL_RGB32I_EXT)
defines.add(GL_RGB32UI_EXT)
defines.add(GL_RGB8I_EXT)
defines.add(GL_RGB8UI_EXT)
defines.add(GL_RGBA16I_EXT)
defines.add(GL_RGBA16UI_EXT)
defines.add(GL_RGBA32I_EXT)
defines.add(GL_RGBA32UI_EXT)
defines.add(GL_RGBA8I_EXT)
defines.add(GL_RGBA8UI_EXT)
defines.add(GL_RGBA_INTEGER_EXT)
defines.add(GL_RGBA_INTEGER_MODE_EXT)
defines.add(GL_RGB_INTEGER_EXT)

# GL_EXT_texture_lod_bias

GL_MAX_TEXTURE_LOD_BIAS_EXT = Enumerant('GL_MAX_TEXTURE_LOD_BIAS_EXT', 0x84fd, 'GL_EXT_texture_lod_bias')
GL_TEXTURE_FILTER_CONTROL_EXT = Enumerant('GL_TEXTURE_FILTER_CONTROL_EXT', 0x8500, 'GL_EXT_texture_lod_bias')
GL_TEXTURE_LOD_BIAS_EXT = Enumerant('GL_TEXTURE_LOD_BIAS_EXT', 0x8501, 'GL_EXT_texture_lod_bias')

defines.add(GL_MAX_TEXTURE_LOD_BIAS_EXT)
defines.add(GL_TEXTURE_FILTER_CONTROL_EXT)
defines.add(GL_TEXTURE_LOD_BIAS_EXT)

# GL_EXT_texture_mirror_clamp

GL_MIRROR_CLAMP_EXT = Enumerant('GL_MIRROR_CLAMP_EXT', 0x8742, 'GL_EXT_texture_mirror_clamp')
GL_MIRROR_CLAMP_TO_BORDER_EXT = Enumerant('GL_MIRROR_CLAMP_TO_BORDER_EXT', 0x8912, 'GL_EXT_texture_mirror_clamp')
GL_MIRROR_CLAMP_TO_EDGE_EXT = Enumerant('GL_MIRROR_CLAMP_TO_EDGE_EXT', 0x8743, 'GL_EXT_texture_mirror_clamp')

defines.add(GL_MIRROR_CLAMP_EXT)
defines.add(GL_MIRROR_CLAMP_TO_BORDER_EXT)
defines.add(GL_MIRROR_CLAMP_TO_EDGE_EXT)

# GL_EXT_texture_object

GL_TEXTURE_1D_BINDING_EXT = Enumerant('GL_TEXTURE_1D_BINDING_EXT', 0x8068, 'GL_EXT_texture_object')
GL_TEXTURE_2D_BINDING_EXT = Enumerant('GL_TEXTURE_2D_BINDING_EXT', 0x8069, 'GL_EXT_texture_object')
GL_TEXTURE_3D_BINDING_EXT = Enumerant('GL_TEXTURE_3D_BINDING_EXT', 0x806a, 'GL_EXT_texture_object')
GL_TEXTURE_PRIORITY_EXT = Enumerant('GL_TEXTURE_PRIORITY_EXT', 0x8066, 'GL_EXT_texture_object')
GL_TEXTURE_RESIDENT_EXT = Enumerant('GL_TEXTURE_RESIDENT_EXT', 0x8067, 'GL_EXT_texture_object')

defines.add(GL_TEXTURE_1D_BINDING_EXT)
defines.add(GL_TEXTURE_2D_BINDING_EXT)
defines.add(GL_TEXTURE_3D_BINDING_EXT)
defines.add(GL_TEXTURE_PRIORITY_EXT)
defines.add(GL_TEXTURE_RESIDENT_EXT)

# GL_EXT_texture_perturb_normal

GL_PERTURB_EXT = Enumerant('GL_PERTURB_EXT', 0x85ae, 'GL_EXT_texture_perturb_normal')
GL_TEXTURE_NORMAL_EXT = Enumerant('GL_TEXTURE_NORMAL_EXT', 0x85af, 'GL_EXT_texture_perturb_normal')

defines.add(GL_PERTURB_EXT)
defines.add(GL_TEXTURE_NORMAL_EXT)

# GL_EXT_texture_rectangle

GL_MAX_RECTANGLE_TEXTURE_SIZE_EXT = Enumerant('GL_MAX_RECTANGLE_TEXTURE_SIZE_EXT', 0x84f8, 'GL_EXT_texture_rectangle')
GL_PROXY_TEXTURE_RECTANGLE_EXT = Enumerant('GL_PROXY_TEXTURE_RECTANGLE_EXT', 0x84f7, 'GL_EXT_texture_rectangle')
GL_TEXTURE_BINDING_RECTANGLE_EXT = Enumerant('GL_TEXTURE_BINDING_RECTANGLE_EXT', 0x84f6, 'GL_EXT_texture_rectangle')
GL_TEXTURE_RECTANGLE_EXT = Enumerant('GL_TEXTURE_RECTANGLE_EXT', 0x84f5, 'GL_EXT_texture_rectangle')

defines.add(GL_MAX_RECTANGLE_TEXTURE_SIZE_EXT)
defines.add(GL_PROXY_TEXTURE_RECTANGLE_EXT)
defines.add(GL_TEXTURE_BINDING_RECTANGLE_EXT)
defines.add(GL_TEXTURE_RECTANGLE_EXT)

# GL_EXT_texture_rg

GL_RED_EXT = Enumerant('GL_RED_EXT', 0x1903, 'GL_EXT_texture_rg')
GL_RG_EXT = Enumerant('GL_RG_EXT', 0x8227, 'GL_EXT_texture_rg')

defines.add(GL_RED_EXT)
defines.add(GL_RG_EXT)

# GL_EXT_texture_sRGB

GL_COMPRESSED_SLUMINANCE_ALPHA_EXT = Enumerant('GL_COMPRESSED_SLUMINANCE_ALPHA_EXT', 0x8c4b, 'GL_EXT_texture_sRGB')
GL_COMPRESSED_SLUMINANCE_EXT = Enumerant('GL_COMPRESSED_SLUMINANCE_EXT', 0x8c4a, 'GL_EXT_texture_sRGB')
GL_COMPRESSED_SRGB_ALPHA_EXT = Enumerant('GL_COMPRESSED_SRGB_ALPHA_EXT', 0x8c49, 'GL_EXT_texture_sRGB')
GL_COMPRESSED_SRGB_ALPHA_S3TC_DXT1_EXT = Enumerant('GL_COMPRESSED_SRGB_ALPHA_S3TC_DXT1_EXT', 0x8c4d, 'GL_EXT_texture_sRGB')
GL_COMPRESSED_SRGB_ALPHA_S3TC_DXT3_EXT = Enumerant('GL_COMPRESSED_SRGB_ALPHA_S3TC_DXT3_EXT', 0x8c4e, 'GL_EXT_texture_sRGB')
GL_COMPRESSED_SRGB_ALPHA_S3TC_DXT5_EXT = Enumerant('GL_COMPRESSED_SRGB_ALPHA_S3TC_DXT5_EXT', 0x8c4f, 'GL_EXT_texture_sRGB')
GL_COMPRESSED_SRGB_EXT = Enumerant('GL_COMPRESSED_SRGB_EXT', 0x8c48, 'GL_EXT_texture_sRGB')
GL_COMPRESSED_SRGB_S3TC_DXT1_EXT = Enumerant('GL_COMPRESSED_SRGB_S3TC_DXT1_EXT', 0x8c4c, 'GL_EXT_texture_sRGB')
GL_SLUMINANCE8_ALPHA8_EXT = Enumerant('GL_SLUMINANCE8_ALPHA8_EXT', 0x8c45, 'GL_EXT_texture_sRGB')
GL_SLUMINANCE8_EXT = Enumerant('GL_SLUMINANCE8_EXT', 0x8c47, 'GL_EXT_texture_sRGB')
GL_SLUMINANCE_ALPHA_EXT = Enumerant('GL_SLUMINANCE_ALPHA_EXT', 0x8c44, 'GL_EXT_texture_sRGB')
GL_SLUMINANCE_EXT = Enumerant('GL_SLUMINANCE_EXT', 0x8c46, 'GL_EXT_texture_sRGB')
GL_SRGB8_ALPHA8_EXT = Enumerant('GL_SRGB8_ALPHA8_EXT', 0x8c43, 'GL_EXT_texture_sRGB')
GL_SRGB8_EXT = Enumerant('GL_SRGB8_EXT', 0x8c41, 'GL_EXT_texture_sRGB')
GL_SRGB_ALPHA_EXT = Enumerant('GL_SRGB_ALPHA_EXT', 0x8c42, 'GL_EXT_texture_sRGB')
GL_SRGB_EXT = Enumerant('GL_SRGB_EXT', 0x8c40, 'GL_EXT_texture_sRGB')

defines.add(GL_COMPRESSED_SLUMINANCE_ALPHA_EXT)
defines.add(GL_COMPRESSED_SLUMINANCE_EXT)
defines.add(GL_COMPRESSED_SRGB_ALPHA_EXT)
defines.add(GL_COMPRESSED_SRGB_ALPHA_S3TC_DXT1_EXT)
defines.add(GL_COMPRESSED_SRGB_ALPHA_S3TC_DXT3_EXT)
defines.add(GL_COMPRESSED_SRGB_ALPHA_S3TC_DXT5_EXT)
defines.add(GL_COMPRESSED_SRGB_EXT)
defines.add(GL_COMPRESSED_SRGB_S3TC_DXT1_EXT)
defines.add(GL_SLUMINANCE8_ALPHA8_EXT)
defines.add(GL_SLUMINANCE8_EXT)
defines.add(GL_SLUMINANCE_ALPHA_EXT)
defines.add(GL_SLUMINANCE_EXT)
defines.add(GL_SRGB8_ALPHA8_EXT)
defines.add(GL_SRGB8_EXT)
defines.add(GL_SRGB_ALPHA_EXT)
defines.add(GL_SRGB_EXT)

# GL_EXT_texture_sRGB_decode

GL_DECODE_EXT = Enumerant('GL_DECODE_EXT', 0x8a49, 'GL_EXT_texture_sRGB_decode')
GL_SKIP_DECODE_EXT = Enumerant('GL_SKIP_DECODE_EXT', 0x8a4a, 'GL_EXT_texture_sRGB_decode')
GL_TEXTURE_SRGB_DECODE_EXT = Enumerant('GL_TEXTURE_SRGB_DECODE_EXT', 0x8a48, 'GL_EXT_texture_sRGB_decode')

defines.add(GL_DECODE_EXT)
defines.add(GL_SKIP_DECODE_EXT)
defines.add(GL_TEXTURE_SRGB_DECODE_EXT)

# GL_EXT_texture_shared_exponent

GL_RGB9_E5_EXT = Enumerant('GL_RGB9_E5_EXT', 0x8c3d, 'GL_EXT_texture_shared_exponent')
GL_TEXTURE_SHARED_SIZE_EXT = Enumerant('GL_TEXTURE_SHARED_SIZE_EXT', 0x8c3f, 'GL_EXT_texture_shared_exponent')
GL_UNSIGNED_INT_5_9_9_9_REV_EXT = Enumerant('GL_UNSIGNED_INT_5_9_9_9_REV_EXT', 0x8c3e, 'GL_EXT_texture_shared_exponent')

defines.add(GL_RGB9_E5_EXT)
defines.add(GL_TEXTURE_SHARED_SIZE_EXT)
defines.add(GL_UNSIGNED_INT_5_9_9_9_REV_EXT)

# GL_EXT_texture_snorm

GL_ALPHA16_SNORM = Enumerant('GL_ALPHA16_SNORM', 0x9018, 'GL_EXT_texture_snorm')
GL_ALPHA8_SNORM = Enumerant('GL_ALPHA8_SNORM', 0x9014, 'GL_EXT_texture_snorm')
GL_ALPHA_SNORM = Enumerant('GL_ALPHA_SNORM', 0x9010, 'GL_EXT_texture_snorm')
GL_INTENSITY16_SNORM = Enumerant('GL_INTENSITY16_SNORM', 0x901b, 'GL_EXT_texture_snorm')
GL_INTENSITY8_SNORM = Enumerant('GL_INTENSITY8_SNORM', 0x9017, 'GL_EXT_texture_snorm')
GL_INTENSITY_SNORM = Enumerant('GL_INTENSITY_SNORM', 0x9013, 'GL_EXT_texture_snorm')
GL_LUMINANCE16_ALPHA16_SNORM = Enumerant('GL_LUMINANCE16_ALPHA16_SNORM', 0x901a, 'GL_EXT_texture_snorm')
GL_LUMINANCE16_SNORM = Enumerant('GL_LUMINANCE16_SNORM', 0x9019, 'GL_EXT_texture_snorm')
GL_LUMINANCE8_ALPHA8_SNORM = Enumerant('GL_LUMINANCE8_ALPHA8_SNORM', 0x9016, 'GL_EXT_texture_snorm')
GL_LUMINANCE8_SNORM = Enumerant('GL_LUMINANCE8_SNORM', 0x9015, 'GL_EXT_texture_snorm')
GL_LUMINANCE_ALPHA_SNORM = Enumerant('GL_LUMINANCE_ALPHA_SNORM', 0x9012, 'GL_EXT_texture_snorm')
GL_LUMINANCE_SNORM = Enumerant('GL_LUMINANCE_SNORM', 0x9011, 'GL_EXT_texture_snorm')
GL_R16_SNORM = Enumerant('GL_R16_SNORM', 0x8f98, 'GL_EXT_texture_snorm')
GL_R8_SNORM = Enumerant('GL_R8_SNORM', 0x8f94, 'GL_EXT_texture_snorm')
GL_RED_SNORM = Enumerant('GL_RED_SNORM', 0x8f90, 'GL_EXT_texture_snorm')
GL_RG16_SNORM = Enumerant('GL_RG16_SNORM', 0x8f99, 'GL_EXT_texture_snorm')
GL_RG8_SNORM = Enumerant('GL_RG8_SNORM', 0x8f95, 'GL_EXT_texture_snorm')
GL_RGB16_SNORM = Enumerant('GL_RGB16_SNORM', 0x8f9a, 'GL_EXT_texture_snorm')
GL_RGB8_SNORM = Enumerant('GL_RGB8_SNORM', 0x8f96, 'GL_EXT_texture_snorm')
GL_RGBA16_SNORM = Enumerant('GL_RGBA16_SNORM', 0x8f9b, 'GL_EXT_texture_snorm')
GL_RGBA8_SNORM = Enumerant('GL_RGBA8_SNORM', 0x8f97, 'GL_EXT_texture_snorm')
GL_RGBA_SNORM = Enumerant('GL_RGBA_SNORM', 0x8f93, 'GL_EXT_texture_snorm')
GL_RGB_SNORM = Enumerant('GL_RGB_SNORM', 0x8f92, 'GL_EXT_texture_snorm')
GL_RG_SNORM = Enumerant('GL_RG_SNORM', 0x8f91, 'GL_EXT_texture_snorm')
GL_SIGNED_NORMALIZED = Enumerant('GL_SIGNED_NORMALIZED', 0x8f9c, 'GL_EXT_texture_snorm')

defines.add(GL_ALPHA16_SNORM)
defines.add(GL_ALPHA8_SNORM)
defines.add(GL_ALPHA_SNORM)
defines.add(GL_INTENSITY16_SNORM)
defines.add(GL_INTENSITY8_SNORM)
defines.add(GL_INTENSITY_SNORM)
defines.add(GL_LUMINANCE16_ALPHA16_SNORM)
defines.add(GL_LUMINANCE16_SNORM)
defines.add(GL_LUMINANCE8_ALPHA8_SNORM)
defines.add(GL_LUMINANCE8_SNORM)
defines.add(GL_LUMINANCE_ALPHA_SNORM)
defines.add(GL_LUMINANCE_SNORM)
defines.add(GL_R16_SNORM)
defines.add(GL_R8_SNORM)
defines.add(GL_RED_SNORM)
defines.add(GL_RG16_SNORM)
defines.add(GL_RG8_SNORM)
defines.add(GL_RGB16_SNORM)
defines.add(GL_RGB8_SNORM)
defines.add(GL_RGBA16_SNORM)
defines.add(GL_RGBA8_SNORM)
defines.add(GL_RGBA_SNORM)
defines.add(GL_RGB_SNORM)
defines.add(GL_RG_SNORM)
defines.add(GL_SIGNED_NORMALIZED)

# GL_EXT_texture_storage

GL_ALPHA16F_EXT = Enumerant('GL_ALPHA16F_EXT', 0x881c, 'GL_EXT_texture_storage')
GL_ALPHA32F_EXT = Enumerant('GL_ALPHA32F_EXT', 0x8816, 'GL_EXT_texture_storage')
GL_BGRA8_EXT = Enumerant('GL_BGRA8_EXT', 0x93a1, 'GL_EXT_texture_storage')
GL_LUMINANCE16F_EXT = Enumerant('GL_LUMINANCE16F_EXT', 0x881e, 'GL_EXT_texture_storage')
GL_LUMINANCE32F_EXT = Enumerant('GL_LUMINANCE32F_EXT', 0x8818, 'GL_EXT_texture_storage')
GL_LUMINANCE_ALPHA16F_EXT = Enumerant('GL_LUMINANCE_ALPHA16F_EXT', 0x881f, 'GL_EXT_texture_storage')
GL_LUMINANCE_ALPHA32F_EXT = Enumerant('GL_LUMINANCE_ALPHA32F_EXT', 0x8819, 'GL_EXT_texture_storage')
GL_R16F_EXT = Enumerant('GL_R16F_EXT', 0x822d, 'GL_EXT_texture_storage')
GL_R32F_EXT = Enumerant('GL_R32F_EXT', 0x822e, 'GL_EXT_texture_storage')
GL_R8_EXT = Enumerant('GL_R8_EXT', 0x8229, 'GL_EXT_texture_storage')
GL_RG16F_EXT = Enumerant('GL_RG16F_EXT', 0x822f, 'GL_EXT_texture_storage')
GL_RG32F_EXT = Enumerant('GL_RG32F_EXT', 0x8230, 'GL_EXT_texture_storage')
GL_RG8_EXT = Enumerant('GL_RG8_EXT', 0x822b, 'GL_EXT_texture_storage')
GL_RGB16F_EXT = Enumerant('GL_RGB16F_EXT', 0x881b, 'GL_EXT_texture_storage')
GL_RGB32F_EXT = Enumerant('GL_RGB32F_EXT', 0x8815, 'GL_EXT_texture_storage')
GL_RGBA16F_EXT = Enumerant('GL_RGBA16F_EXT', 0x881a, 'GL_EXT_texture_storage')
GL_RGBA32F_EXT = Enumerant('GL_RGBA32F_EXT', 0x8814, 'GL_EXT_texture_storage')
GL_TEXTURE_IMMUTABLE_FORMAT_EXT = Enumerant('GL_TEXTURE_IMMUTABLE_FORMAT_EXT', 0x912f, 'GL_EXT_texture_storage')

defines.add(GL_ALPHA16F_EXT)
defines.add(GL_ALPHA32F_EXT)
defines.add(GL_BGRA8_EXT)
defines.add(GL_LUMINANCE16F_EXT)
defines.add(GL_LUMINANCE32F_EXT)
defines.add(GL_LUMINANCE_ALPHA16F_EXT)
defines.add(GL_LUMINANCE_ALPHA32F_EXT)
defines.add(GL_R16F_EXT)
defines.add(GL_R32F_EXT)
defines.add(GL_R8_EXT)
defines.add(GL_RG16F_EXT)
defines.add(GL_RG32F_EXT)
defines.add(GL_RG8_EXT)
defines.add(GL_RGB16F_EXT)
defines.add(GL_RGB32F_EXT)
defines.add(GL_RGBA16F_EXT)
defines.add(GL_RGBA32F_EXT)
defines.add(GL_TEXTURE_IMMUTABLE_FORMAT_EXT)

# GL_EXT_texture_swizzle

GL_TEXTURE_SWIZZLE_A_EXT = Enumerant('GL_TEXTURE_SWIZZLE_A_EXT', 0x8e45, 'GL_EXT_texture_swizzle')
GL_TEXTURE_SWIZZLE_B_EXT = Enumerant('GL_TEXTURE_SWIZZLE_B_EXT', 0x8e44, 'GL_EXT_texture_swizzle')
GL_TEXTURE_SWIZZLE_G_EXT = Enumerant('GL_TEXTURE_SWIZZLE_G_EXT', 0x8e43, 'GL_EXT_texture_swizzle')
GL_TEXTURE_SWIZZLE_RGBA_EXT = Enumerant('GL_TEXTURE_SWIZZLE_RGBA_EXT', 0x8e46, 'GL_EXT_texture_swizzle')
GL_TEXTURE_SWIZZLE_R_EXT = Enumerant('GL_TEXTURE_SWIZZLE_R_EXT', 0x8e42, 'GL_EXT_texture_swizzle')

defines.add(GL_TEXTURE_SWIZZLE_A_EXT)
defines.add(GL_TEXTURE_SWIZZLE_B_EXT)
defines.add(GL_TEXTURE_SWIZZLE_G_EXT)
defines.add(GL_TEXTURE_SWIZZLE_RGBA_EXT)
defines.add(GL_TEXTURE_SWIZZLE_R_EXT)

# GL_EXT_texture_type_2_10_10_10_REV

GL_UNSIGNED_INT_2_10_10_10_REV_EXT = Enumerant('GL_UNSIGNED_INT_2_10_10_10_REV_EXT', 0x8368, 'GL_EXT_texture_type_2_10_10_10_REV')

defines.add(GL_UNSIGNED_INT_2_10_10_10_REV_EXT)

# GL_EXT_timer_query

GL_TIME_ELAPSED_EXT = Enumerant('GL_TIME_ELAPSED_EXT', 0x88bf, 'GL_EXT_timer_query')

defines.add(GL_TIME_ELAPSED_EXT)

# GL_EXT_transform_feedback

GL_INTERLEAVED_ATTRIBS_EXT = Enumerant('GL_INTERLEAVED_ATTRIBS_EXT', 0x8c8c, 'GL_EXT_transform_feedback')
GL_MAX_TRANSFORM_FEEDBACK_INTERLEAVED_COMPONENTS_EXT = Enumerant('GL_MAX_TRANSFORM_FEEDBACK_INTERLEAVED_COMPONENTS_EXT', 0x8c8a, 'GL_EXT_transform_feedback')
GL_MAX_TRANSFORM_FEEDBACK_SEPARATE_ATTRIBS_EXT = Enumerant('GL_MAX_TRANSFORM_FEEDBACK_SEPARATE_ATTRIBS_EXT', 0x8c8b, 'GL_EXT_transform_feedback')
GL_MAX_TRANSFORM_FEEDBACK_SEPARATE_COMPONENTS_EXT = Enumerant('GL_MAX_TRANSFORM_FEEDBACK_SEPARATE_COMPONENTS_EXT', 0x8c80, 'GL_EXT_transform_feedback')
GL_PRIMITIVES_GENERATED_EXT = Enumerant('GL_PRIMITIVES_GENERATED_EXT', 0x8c87, 'GL_EXT_transform_feedback')
GL_RASTERIZER_DISCARD_EXT = Enumerant('GL_RASTERIZER_DISCARD_EXT', 0x8c89, 'GL_EXT_transform_feedback')
GL_SEPARATE_ATTRIBS_EXT = Enumerant('GL_SEPARATE_ATTRIBS_EXT', 0x8c8d, 'GL_EXT_transform_feedback')
GL_TRANSFORM_FEEDBACK_BUFFER_BINDING_EXT = Enumerant('GL_TRANSFORM_FEEDBACK_BUFFER_BINDING_EXT', 0x8c8f, 'GL_EXT_transform_feedback')
GL_TRANSFORM_FEEDBACK_BUFFER_EXT = Enumerant('GL_TRANSFORM_FEEDBACK_BUFFER_EXT', 0x8c8e, 'GL_EXT_transform_feedback')
GL_TRANSFORM_FEEDBACK_BUFFER_MODE_EXT = Enumerant('GL_TRANSFORM_FEEDBACK_BUFFER_MODE_EXT', 0x8c7f, 'GL_EXT_transform_feedback')
GL_TRANSFORM_FEEDBACK_BUFFER_SIZE_EXT = Enumerant('GL_TRANSFORM_FEEDBACK_BUFFER_SIZE_EXT', 0x8c85, 'GL_EXT_transform_feedback')
GL_TRANSFORM_FEEDBACK_BUFFER_START_EXT = Enumerant('GL_TRANSFORM_FEEDBACK_BUFFER_START_EXT', 0x8c84, 'GL_EXT_transform_feedback')
GL_TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN_EXT = Enumerant('GL_TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN_EXT', 0x8c88, 'GL_EXT_transform_feedback')
GL_TRANSFORM_FEEDBACK_VARYINGS_EXT = Enumerant('GL_TRANSFORM_FEEDBACK_VARYINGS_EXT', 0x8c83, 'GL_EXT_transform_feedback')
GL_TRANSFORM_FEEDBACK_VARYING_MAX_LENGTH_EXT = Enumerant('GL_TRANSFORM_FEEDBACK_VARYING_MAX_LENGTH_EXT', 0x8c76, 'GL_EXT_transform_feedback')

defines.add(GL_INTERLEAVED_ATTRIBS_EXT)
defines.add(GL_MAX_TRANSFORM_FEEDBACK_INTERLEAVED_COMPONENTS_EXT)
defines.add(GL_MAX_TRANSFORM_FEEDBACK_SEPARATE_ATTRIBS_EXT)
defines.add(GL_MAX_TRANSFORM_FEEDBACK_SEPARATE_COMPONENTS_EXT)
defines.add(GL_PRIMITIVES_GENERATED_EXT)
defines.add(GL_RASTERIZER_DISCARD_EXT)
defines.add(GL_SEPARATE_ATTRIBS_EXT)
defines.add(GL_TRANSFORM_FEEDBACK_BUFFER_BINDING_EXT)
defines.add(GL_TRANSFORM_FEEDBACK_BUFFER_EXT)
defines.add(GL_TRANSFORM_FEEDBACK_BUFFER_MODE_EXT)
defines.add(GL_TRANSFORM_FEEDBACK_BUFFER_SIZE_EXT)
defines.add(GL_TRANSFORM_FEEDBACK_BUFFER_START_EXT)
defines.add(GL_TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN_EXT)
defines.add(GL_TRANSFORM_FEEDBACK_VARYINGS_EXT)
defines.add(GL_TRANSFORM_FEEDBACK_VARYING_MAX_LENGTH_EXT)

# GL_EXT_unpack_subimage

GL_UNPACK_ROW_LENGTH_EXT = Enumerant('GL_UNPACK_ROW_LENGTH_EXT', 0x0cf2, 'GL_EXT_unpack_subimage')
GL_UNPACK_SKIP_PIXELS_EXT = Enumerant('GL_UNPACK_SKIP_PIXELS_EXT', 0x0cf4, 'GL_EXT_unpack_subimage')
GL_UNPACK_SKIP_ROWS_EXT = Enumerant('GL_UNPACK_SKIP_ROWS_EXT', 0x0cf3, 'GL_EXT_unpack_subimage')

defines.add(GL_UNPACK_ROW_LENGTH_EXT)
defines.add(GL_UNPACK_SKIP_PIXELS_EXT)
defines.add(GL_UNPACK_SKIP_ROWS_EXT)

# GL_EXT_vertex_array

GL_COLOR_ARRAY_COUNT_EXT = Enumerant('GL_COLOR_ARRAY_COUNT_EXT', 0x8084, 'GL_EXT_vertex_array')
GL_COLOR_ARRAY_EXT = Enumerant('GL_COLOR_ARRAY_EXT', 0x8076, 'GL_EXT_vertex_array')
GL_COLOR_ARRAY_POINTER_EXT = Enumerant('GL_COLOR_ARRAY_POINTER_EXT', 0x8090, 'GL_EXT_vertex_array')
GL_COLOR_ARRAY_SIZE_EXT = Enumerant('GL_COLOR_ARRAY_SIZE_EXT', 0x8081, 'GL_EXT_vertex_array')
GL_COLOR_ARRAY_STRIDE_EXT = Enumerant('GL_COLOR_ARRAY_STRIDE_EXT', 0x8083, 'GL_EXT_vertex_array')
GL_COLOR_ARRAY_TYPE_EXT = Enumerant('GL_COLOR_ARRAY_TYPE_EXT', 0x8082, 'GL_EXT_vertex_array')
GL_DOUBLE_EXT = Enumerant('GL_DOUBLE_EXT', 0x140a, 'GL_EXT_vertex_array')
GL_EDGE_FLAG_ARRAY_COUNT_EXT = Enumerant('GL_EDGE_FLAG_ARRAY_COUNT_EXT', 0x808d, 'GL_EXT_vertex_array')
GL_EDGE_FLAG_ARRAY_EXT = Enumerant('GL_EDGE_FLAG_ARRAY_EXT', 0x8079, 'GL_EXT_vertex_array')
GL_EDGE_FLAG_ARRAY_POINTER_EXT = Enumerant('GL_EDGE_FLAG_ARRAY_POINTER_EXT', 0x8093, 'GL_EXT_vertex_array')
GL_EDGE_FLAG_ARRAY_STRIDE_EXT = Enumerant('GL_EDGE_FLAG_ARRAY_STRIDE_EXT', 0x808c, 'GL_EXT_vertex_array')
GL_INDEX_ARRAY_COUNT_EXT = Enumerant('GL_INDEX_ARRAY_COUNT_EXT', 0x8087, 'GL_EXT_vertex_array')
GL_INDEX_ARRAY_EXT = Enumerant('GL_INDEX_ARRAY_EXT', 0x8077, 'GL_EXT_vertex_array')
GL_INDEX_ARRAY_POINTER_EXT = Enumerant('GL_INDEX_ARRAY_POINTER_EXT', 0x8091, 'GL_EXT_vertex_array')
GL_INDEX_ARRAY_STRIDE_EXT = Enumerant('GL_INDEX_ARRAY_STRIDE_EXT', 0x8086, 'GL_EXT_vertex_array')
GL_INDEX_ARRAY_TYPE_EXT = Enumerant('GL_INDEX_ARRAY_TYPE_EXT', 0x8085, 'GL_EXT_vertex_array')
GL_NORMAL_ARRAY_COUNT_EXT = Enumerant('GL_NORMAL_ARRAY_COUNT_EXT', 0x8080, 'GL_EXT_vertex_array')
GL_NORMAL_ARRAY_EXT = Enumerant('GL_NORMAL_ARRAY_EXT', 0x8075, 'GL_EXT_vertex_array')
GL_NORMAL_ARRAY_POINTER_EXT = Enumerant('GL_NORMAL_ARRAY_POINTER_EXT', 0x808f, 'GL_EXT_vertex_array')
GL_NORMAL_ARRAY_STRIDE_EXT = Enumerant('GL_NORMAL_ARRAY_STRIDE_EXT', 0x807f, 'GL_EXT_vertex_array')
GL_NORMAL_ARRAY_TYPE_EXT = Enumerant('GL_NORMAL_ARRAY_TYPE_EXT', 0x807e, 'GL_EXT_vertex_array')
GL_TEXTURE_COORD_ARRAY_COUNT_EXT = Enumerant('GL_TEXTURE_COORD_ARRAY_COUNT_EXT', 0x808b, 'GL_EXT_vertex_array')
GL_TEXTURE_COORD_ARRAY_EXT = Enumerant('GL_TEXTURE_COORD_ARRAY_EXT', 0x8078, 'GL_EXT_vertex_array')
GL_TEXTURE_COORD_ARRAY_POINTER_EXT = Enumerant('GL_TEXTURE_COORD_ARRAY_POINTER_EXT', 0x8092, 'GL_EXT_vertex_array')
GL_TEXTURE_COORD_ARRAY_SIZE_EXT = Enumerant('GL_TEXTURE_COORD_ARRAY_SIZE_EXT', 0x8088, 'GL_EXT_vertex_array')
GL_TEXTURE_COORD_ARRAY_STRIDE_EXT = Enumerant('GL_TEXTURE_COORD_ARRAY_STRIDE_EXT', 0x808a, 'GL_EXT_vertex_array')
GL_TEXTURE_COORD_ARRAY_TYPE_EXT = Enumerant('GL_TEXTURE_COORD_ARRAY_TYPE_EXT', 0x8089, 'GL_EXT_vertex_array')
GL_VERTEX_ARRAY_COUNT_EXT = Enumerant('GL_VERTEX_ARRAY_COUNT_EXT', 0x807d, 'GL_EXT_vertex_array')
GL_VERTEX_ARRAY_EXT = Enumerant('GL_VERTEX_ARRAY_EXT', 0x8074, 'GL_EXT_vertex_array')
GL_VERTEX_ARRAY_POINTER_EXT = Enumerant('GL_VERTEX_ARRAY_POINTER_EXT', 0x808e, 'GL_EXT_vertex_array')
GL_VERTEX_ARRAY_SIZE_EXT = Enumerant('GL_VERTEX_ARRAY_SIZE_EXT', 0x807a, 'GL_EXT_vertex_array')
GL_VERTEX_ARRAY_STRIDE_EXT = Enumerant('GL_VERTEX_ARRAY_STRIDE_EXT', 0x807c, 'GL_EXT_vertex_array')
GL_VERTEX_ARRAY_TYPE_EXT = Enumerant('GL_VERTEX_ARRAY_TYPE_EXT', 0x807b, 'GL_EXT_vertex_array')

defines.add(GL_COLOR_ARRAY_COUNT_EXT)
defines.add(GL_COLOR_ARRAY_EXT)
defines.add(GL_COLOR_ARRAY_POINTER_EXT)
defines.add(GL_COLOR_ARRAY_SIZE_EXT)
defines.add(GL_COLOR_ARRAY_STRIDE_EXT)
defines.add(GL_COLOR_ARRAY_TYPE_EXT)
defines.add(GL_DOUBLE_EXT)
defines.add(GL_EDGE_FLAG_ARRAY_COUNT_EXT)
defines.add(GL_EDGE_FLAG_ARRAY_EXT)
defines.add(GL_EDGE_FLAG_ARRAY_POINTER_EXT)
defines.add(GL_EDGE_FLAG_ARRAY_STRIDE_EXT)
defines.add(GL_INDEX_ARRAY_COUNT_EXT)
defines.add(GL_INDEX_ARRAY_EXT)
defines.add(GL_INDEX_ARRAY_POINTER_EXT)
defines.add(GL_INDEX_ARRAY_STRIDE_EXT)
defines.add(GL_INDEX_ARRAY_TYPE_EXT)
defines.add(GL_NORMAL_ARRAY_COUNT_EXT)
defines.add(GL_NORMAL_ARRAY_EXT)
defines.add(GL_NORMAL_ARRAY_POINTER_EXT)
defines.add(GL_NORMAL_ARRAY_STRIDE_EXT)
defines.add(GL_NORMAL_ARRAY_TYPE_EXT)
defines.add(GL_TEXTURE_COORD_ARRAY_COUNT_EXT)
defines.add(GL_TEXTURE_COORD_ARRAY_EXT)
defines.add(GL_TEXTURE_COORD_ARRAY_POINTER_EXT)
defines.add(GL_TEXTURE_COORD_ARRAY_SIZE_EXT)
defines.add(GL_TEXTURE_COORD_ARRAY_STRIDE_EXT)
defines.add(GL_TEXTURE_COORD_ARRAY_TYPE_EXT)
defines.add(GL_VERTEX_ARRAY_COUNT_EXT)
defines.add(GL_VERTEX_ARRAY_EXT)
defines.add(GL_VERTEX_ARRAY_POINTER_EXT)
defines.add(GL_VERTEX_ARRAY_SIZE_EXT)
defines.add(GL_VERTEX_ARRAY_STRIDE_EXT)
defines.add(GL_VERTEX_ARRAY_TYPE_EXT)

# GL_EXT_vertex_attrib_64bit

GL_DOUBLE_MAT2_EXT = Enumerant('GL_DOUBLE_MAT2_EXT', 0x8f46, 'GL_EXT_vertex_attrib_64bit')
GL_DOUBLE_MAT2x3_EXT = Enumerant('GL_DOUBLE_MAT2x3_EXT', 0x8f49, 'GL_EXT_vertex_attrib_64bit')
GL_DOUBLE_MAT2x4_EXT = Enumerant('GL_DOUBLE_MAT2x4_EXT', 0x8f4a, 'GL_EXT_vertex_attrib_64bit')
GL_DOUBLE_MAT3_EXT = Enumerant('GL_DOUBLE_MAT3_EXT', 0x8f47, 'GL_EXT_vertex_attrib_64bit')
GL_DOUBLE_MAT3x2_EXT = Enumerant('GL_DOUBLE_MAT3x2_EXT', 0x8f4b, 'GL_EXT_vertex_attrib_64bit')
GL_DOUBLE_MAT3x4_EXT = Enumerant('GL_DOUBLE_MAT3x4_EXT', 0x8f4c, 'GL_EXT_vertex_attrib_64bit')
GL_DOUBLE_MAT4_EXT = Enumerant('GL_DOUBLE_MAT4_EXT', 0x8f48, 'GL_EXT_vertex_attrib_64bit')
GL_DOUBLE_MAT4x2_EXT = Enumerant('GL_DOUBLE_MAT4x2_EXT', 0x8f4d, 'GL_EXT_vertex_attrib_64bit')
GL_DOUBLE_MAT4x3_EXT = Enumerant('GL_DOUBLE_MAT4x3_EXT', 0x8f4e, 'GL_EXT_vertex_attrib_64bit')
GL_DOUBLE_VEC2_EXT = Enumerant('GL_DOUBLE_VEC2_EXT', 0x8ffc, 'GL_EXT_vertex_attrib_64bit')
GL_DOUBLE_VEC3_EXT = Enumerant('GL_DOUBLE_VEC3_EXT', 0x8ffd, 'GL_EXT_vertex_attrib_64bit')
GL_DOUBLE_VEC4_EXT = Enumerant('GL_DOUBLE_VEC4_EXT', 0x8ffe, 'GL_EXT_vertex_attrib_64bit')

defines.add(GL_DOUBLE_MAT2_EXT)
defines.add(GL_DOUBLE_MAT2x3_EXT)
defines.add(GL_DOUBLE_MAT2x4_EXT)
defines.add(GL_DOUBLE_MAT3_EXT)
defines.add(GL_DOUBLE_MAT3x2_EXT)
defines.add(GL_DOUBLE_MAT3x4_EXT)
defines.add(GL_DOUBLE_MAT4_EXT)
defines.add(GL_DOUBLE_MAT4x2_EXT)
defines.add(GL_DOUBLE_MAT4x3_EXT)
defines.add(GL_DOUBLE_VEC2_EXT)
defines.add(GL_DOUBLE_VEC3_EXT)
defines.add(GL_DOUBLE_VEC4_EXT)

# GL_EXT_vertex_shader

GL_CURRENT_VERTEX_EXT = Enumerant('GL_CURRENT_VERTEX_EXT', 0x87e2, 'GL_EXT_vertex_shader')
GL_FULL_RANGE_EXT = Enumerant('GL_FULL_RANGE_EXT', 0x87e1, 'GL_EXT_vertex_shader')
GL_INVARIANT_DATATYPE_EXT = Enumerant('GL_INVARIANT_DATATYPE_EXT', 0x87eb, 'GL_EXT_vertex_shader')
GL_INVARIANT_EXT = Enumerant('GL_INVARIANT_EXT', 0x87c2, 'GL_EXT_vertex_shader')
GL_INVARIANT_VALUE_EXT = Enumerant('GL_INVARIANT_VALUE_EXT', 0x87ea, 'GL_EXT_vertex_shader')
GL_LOCAL_CONSTANT_DATATYPE_EXT = Enumerant('GL_LOCAL_CONSTANT_DATATYPE_EXT', 0x87ed, 'GL_EXT_vertex_shader')
GL_LOCAL_CONSTANT_EXT = Enumerant('GL_LOCAL_CONSTANT_EXT', 0x87c3, 'GL_EXT_vertex_shader')
GL_LOCAL_CONSTANT_VALUE_EXT = Enumerant('GL_LOCAL_CONSTANT_VALUE_EXT', 0x87ec, 'GL_EXT_vertex_shader')
GL_LOCAL_EXT = Enumerant('GL_LOCAL_EXT', 0x87c4, 'GL_EXT_vertex_shader')
GL_MATRIX_EXT = Enumerant('GL_MATRIX_EXT', 0x87c0, 'GL_EXT_vertex_shader')
GL_MAX_OPTIMIZED_VERTEX_SHADER_INSTRUCTIONS_EXT = Enumerant('GL_MAX_OPTIMIZED_VERTEX_SHADER_INSTRUCTIONS_EXT', 0x87ca, 'GL_EXT_vertex_shader')
GL_MAX_OPTIMIZED_VERTEX_SHADER_INVARIANTS_EXT = Enumerant('GL_MAX_OPTIMIZED_VERTEX_SHADER_INVARIANTS_EXT', 0x87cc, 'GL_EXT_vertex_shader')
GL_MAX_OPTIMIZED_VERTEX_SHADER_LOCALS_EXT = Enumerant('GL_MAX_OPTIMIZED_VERTEX_SHADER_LOCALS_EXT', 0x87ce, 'GL_EXT_vertex_shader')
GL_MAX_OPTIMIZED_VERTEX_SHADER_LOCAL_CONSTANTS_EXT = Enumerant('GL_MAX_OPTIMIZED_VERTEX_SHADER_LOCAL_CONSTANTS_EXT', 0x87cd, 'GL_EXT_vertex_shader')
GL_MAX_OPTIMIZED_VERTEX_SHADER_VARIANTS_EXT = Enumerant('GL_MAX_OPTIMIZED_VERTEX_SHADER_VARIANTS_EXT', 0x87cb, 'GL_EXT_vertex_shader')
GL_MAX_VERTEX_SHADER_INSTRUCTIONS_EXT = Enumerant('GL_MAX_VERTEX_SHADER_INSTRUCTIONS_EXT', 0x87c5, 'GL_EXT_vertex_shader')
GL_MAX_VERTEX_SHADER_INVARIANTS_EXT = Enumerant('GL_MAX_VERTEX_SHADER_INVARIANTS_EXT', 0x87c7, 'GL_EXT_vertex_shader')
GL_MAX_VERTEX_SHADER_LOCALS_EXT = Enumerant('GL_MAX_VERTEX_SHADER_LOCALS_EXT', 0x87c9, 'GL_EXT_vertex_shader')
GL_MAX_VERTEX_SHADER_LOCAL_CONSTANTS_EXT = Enumerant('GL_MAX_VERTEX_SHADER_LOCAL_CONSTANTS_EXT', 0x87c8, 'GL_EXT_vertex_shader')
GL_MAX_VERTEX_SHADER_VARIANTS_EXT = Enumerant('GL_MAX_VERTEX_SHADER_VARIANTS_EXT', 0x87c6, 'GL_EXT_vertex_shader')
GL_MVP_MATRIX_EXT = Enumerant('GL_MVP_MATRIX_EXT', 0x87e3, 'GL_EXT_vertex_shader')
GL_NEGATIVE_ONE_EXT = Enumerant('GL_NEGATIVE_ONE_EXT', 0x87df, 'GL_EXT_vertex_shader')
GL_NEGATIVE_W_EXT = Enumerant('GL_NEGATIVE_W_EXT', 0x87dc, 'GL_EXT_vertex_shader')
GL_NEGATIVE_X_EXT = Enumerant('GL_NEGATIVE_X_EXT', 0x87d9, 'GL_EXT_vertex_shader')
GL_NEGATIVE_Y_EXT = Enumerant('GL_NEGATIVE_Y_EXT', 0x87da, 'GL_EXT_vertex_shader')
GL_NEGATIVE_Z_EXT = Enumerant('GL_NEGATIVE_Z_EXT', 0x87db, 'GL_EXT_vertex_shader')
GL_NORMALIZED_RANGE_EXT = Enumerant('GL_NORMALIZED_RANGE_EXT', 0x87e0, 'GL_EXT_vertex_shader')
GL_ONE_EXT = Enumerant('GL_ONE_EXT', 0x87de, 'GL_EXT_vertex_shader')
GL_OP_ADD_EXT = Enumerant('GL_OP_ADD_EXT', 0x8787, 'GL_EXT_vertex_shader')
GL_OP_CLAMP_EXT = Enumerant('GL_OP_CLAMP_EXT', 0x878e, 'GL_EXT_vertex_shader')
GL_OP_CROSS_PRODUCT_EXT = Enumerant('GL_OP_CROSS_PRODUCT_EXT', 0x8797, 'GL_EXT_vertex_shader')
GL_OP_DOT3_EXT = Enumerant('GL_OP_DOT3_EXT', 0x8784, 'GL_EXT_vertex_shader')
GL_OP_DOT4_EXT = Enumerant('GL_OP_DOT4_EXT', 0x8785, 'GL_EXT_vertex_shader')
GL_OP_EXP_BASE_2_EXT = Enumerant('GL_OP_EXP_BASE_2_EXT', 0x8791, 'GL_EXT_vertex_shader')
GL_OP_FLOOR_EXT = Enumerant('GL_OP_FLOOR_EXT', 0x878f, 'GL_EXT_vertex_shader')
GL_OP_FRAC_EXT = Enumerant('GL_OP_FRAC_EXT', 0x8789, 'GL_EXT_vertex_shader')
GL_OP_INDEX_EXT = Enumerant('GL_OP_INDEX_EXT', 0x8782, 'GL_EXT_vertex_shader')
GL_OP_LOG_BASE_2_EXT = Enumerant('GL_OP_LOG_BASE_2_EXT', 0x8792, 'GL_EXT_vertex_shader')
GL_OP_MADD_EXT = Enumerant('GL_OP_MADD_EXT', 0x8788, 'GL_EXT_vertex_shader')
GL_OP_MAX_EXT = Enumerant('GL_OP_MAX_EXT', 0x878a, 'GL_EXT_vertex_shader')
GL_OP_MIN_EXT = Enumerant('GL_OP_MIN_EXT', 0x878b, 'GL_EXT_vertex_shader')
GL_OP_MOV_EXT = Enumerant('GL_OP_MOV_EXT', 0x8799, 'GL_EXT_vertex_shader')
GL_OP_MULTIPLY_MATRIX_EXT = Enumerant('GL_OP_MULTIPLY_MATRIX_EXT', 0x8798, 'GL_EXT_vertex_shader')
GL_OP_MUL_EXT = Enumerant('GL_OP_MUL_EXT', 0x8786, 'GL_EXT_vertex_shader')
GL_OP_NEGATE_EXT = Enumerant('GL_OP_NEGATE_EXT', 0x8783, 'GL_EXT_vertex_shader')
GL_OP_POWER_EXT = Enumerant('GL_OP_POWER_EXT', 0x8793, 'GL_EXT_vertex_shader')
GL_OP_RECIP_EXT = Enumerant('GL_OP_RECIP_EXT', 0x8794, 'GL_EXT_vertex_shader')
GL_OP_RECIP_SQRT_EXT = Enumerant('GL_OP_RECIP_SQRT_EXT', 0x8795, 'GL_EXT_vertex_shader')
GL_OP_ROUND_EXT = Enumerant('GL_OP_ROUND_EXT', 0x8790, 'GL_EXT_vertex_shader')
GL_OP_SET_GE_EXT = Enumerant('GL_OP_SET_GE_EXT', 0x878c, 'GL_EXT_vertex_shader')
GL_OP_SET_LT_EXT = Enumerant('GL_OP_SET_LT_EXT', 0x878d, 'GL_EXT_vertex_shader')
GL_OP_SUB_EXT = Enumerant('GL_OP_SUB_EXT', 0x8796, 'GL_EXT_vertex_shader')
GL_OUTPUT_COLOR0_EXT = Enumerant('GL_OUTPUT_COLOR0_EXT', 0x879b, 'GL_EXT_vertex_shader')
GL_OUTPUT_COLOR1_EXT = Enumerant('GL_OUTPUT_COLOR1_EXT', 0x879c, 'GL_EXT_vertex_shader')
GL_OUTPUT_FOG_EXT = Enumerant('GL_OUTPUT_FOG_EXT', 0x87bd, 'GL_EXT_vertex_shader')
GL_OUTPUT_TEXTURE_COORD0_EXT = Enumerant('GL_OUTPUT_TEXTURE_COORD0_EXT', 0x879d, 'GL_EXT_vertex_shader')
GL_OUTPUT_TEXTURE_COORD10_EXT = Enumerant('GL_OUTPUT_TEXTURE_COORD10_EXT', 0x87a7, 'GL_EXT_vertex_shader')
GL_OUTPUT_TEXTURE_COORD11_EXT = Enumerant('GL_OUTPUT_TEXTURE_COORD11_EXT', 0x87a8, 'GL_EXT_vertex_shader')
GL_OUTPUT_TEXTURE_COORD12_EXT = Enumerant('GL_OUTPUT_TEXTURE_COORD12_EXT', 0x87a9, 'GL_EXT_vertex_shader')
GL_OUTPUT_TEXTURE_COORD13_EXT = Enumerant('GL_OUTPUT_TEXTURE_COORD13_EXT', 0x87aa, 'GL_EXT_vertex_shader')
GL_OUTPUT_TEXTURE_COORD14_EXT = Enumerant('GL_OUTPUT_TEXTURE_COORD14_EXT', 0x87ab, 'GL_EXT_vertex_shader')
GL_OUTPUT_TEXTURE_COORD15_EXT = Enumerant('GL_OUTPUT_TEXTURE_COORD15_EXT', 0x87ac, 'GL_EXT_vertex_shader')
GL_OUTPUT_TEXTURE_COORD16_EXT = Enumerant('GL_OUTPUT_TEXTURE_COORD16_EXT', 0x87ad, 'GL_EXT_vertex_shader')
GL_OUTPUT_TEXTURE_COORD17_EXT = Enumerant('GL_OUTPUT_TEXTURE_COORD17_EXT', 0x87ae, 'GL_EXT_vertex_shader')
GL_OUTPUT_TEXTURE_COORD18_EXT = Enumerant('GL_OUTPUT_TEXTURE_COORD18_EXT', 0x87af, 'GL_EXT_vertex_shader')
GL_OUTPUT_TEXTURE_COORD19_EXT = Enumerant('GL_OUTPUT_TEXTURE_COORD19_EXT', 0x87b0, 'GL_EXT_vertex_shader')
GL_OUTPUT_TEXTURE_COORD1_EXT = Enumerant('GL_OUTPUT_TEXTURE_COORD1_EXT', 0x879e, 'GL_EXT_vertex_shader')
GL_OUTPUT_TEXTURE_COORD20_EXT = Enumerant('GL_OUTPUT_TEXTURE_COORD20_EXT', 0x87b1, 'GL_EXT_vertex_shader')
GL_OUTPUT_TEXTURE_COORD21_EXT = Enumerant('GL_OUTPUT_TEXTURE_COORD21_EXT', 0x87b2, 'GL_EXT_vertex_shader')
GL_OUTPUT_TEXTURE_COORD22_EXT = Enumerant('GL_OUTPUT_TEXTURE_COORD22_EXT', 0x87b3, 'GL_EXT_vertex_shader')
GL_OUTPUT_TEXTURE_COORD23_EXT = Enumerant('GL_OUTPUT_TEXTURE_COORD23_EXT', 0x87b4, 'GL_EXT_vertex_shader')
GL_OUTPUT_TEXTURE_COORD24_EXT = Enumerant('GL_OUTPUT_TEXTURE_COORD24_EXT', 0x87b5, 'GL_EXT_vertex_shader')
GL_OUTPUT_TEXTURE_COORD25_EXT = Enumerant('GL_OUTPUT_TEXTURE_COORD25_EXT', 0x87b6, 'GL_EXT_vertex_shader')
GL_OUTPUT_TEXTURE_COORD26_EXT = Enumerant('GL_OUTPUT_TEXTURE_COORD26_EXT', 0x87b7, 'GL_EXT_vertex_shader')
GL_OUTPUT_TEXTURE_COORD27_EXT = Enumerant('GL_OUTPUT_TEXTURE_COORD27_EXT', 0x87b8, 'GL_EXT_vertex_shader')
GL_OUTPUT_TEXTURE_COORD28_EXT = Enumerant('GL_OUTPUT_TEXTURE_COORD28_EXT', 0x87b9, 'GL_EXT_vertex_shader')
GL_OUTPUT_TEXTURE_COORD29_EXT = Enumerant('GL_OUTPUT_TEXTURE_COORD29_EXT', 0x87ba, 'GL_EXT_vertex_shader')
GL_OUTPUT_TEXTURE_COORD2_EXT = Enumerant('GL_OUTPUT_TEXTURE_COORD2_EXT', 0x879f, 'GL_EXT_vertex_shader')
GL_OUTPUT_TEXTURE_COORD30_EXT = Enumerant('GL_OUTPUT_TEXTURE_COORD30_EXT', 0x87bb, 'GL_EXT_vertex_shader')
GL_OUTPUT_TEXTURE_COORD31_EXT = Enumerant('GL_OUTPUT_TEXTURE_COORD31_EXT', 0x87bc, 'GL_EXT_vertex_shader')
GL_OUTPUT_TEXTURE_COORD3_EXT = Enumerant('GL_OUTPUT_TEXTURE_COORD3_EXT', 0x87a0, 'GL_EXT_vertex_shader')
GL_OUTPUT_TEXTURE_COORD4_EXT = Enumerant('GL_OUTPUT_TEXTURE_COORD4_EXT', 0x87a1, 'GL_EXT_vertex_shader')
GL_OUTPUT_TEXTURE_COORD5_EXT = Enumerant('GL_OUTPUT_TEXTURE_COORD5_EXT', 0x87a2, 'GL_EXT_vertex_shader')
GL_OUTPUT_TEXTURE_COORD6_EXT = Enumerant('GL_OUTPUT_TEXTURE_COORD6_EXT', 0x87a3, 'GL_EXT_vertex_shader')
GL_OUTPUT_TEXTURE_COORD7_EXT = Enumerant('GL_OUTPUT_TEXTURE_COORD7_EXT', 0x87a4, 'GL_EXT_vertex_shader')
GL_OUTPUT_TEXTURE_COORD8_EXT = Enumerant('GL_OUTPUT_TEXTURE_COORD8_EXT', 0x87a5, 'GL_EXT_vertex_shader')
GL_OUTPUT_TEXTURE_COORD9_EXT = Enumerant('GL_OUTPUT_TEXTURE_COORD9_EXT', 0x87a6, 'GL_EXT_vertex_shader')
GL_OUTPUT_VERTEX_EXT = Enumerant('GL_OUTPUT_VERTEX_EXT', 0x879a, 'GL_EXT_vertex_shader')
GL_SCALAR_EXT = Enumerant('GL_SCALAR_EXT', 0x87be, 'GL_EXT_vertex_shader')
GL_VARIANT_ARRAY_EXT = Enumerant('GL_VARIANT_ARRAY_EXT', 0x87e8, 'GL_EXT_vertex_shader')
GL_VARIANT_ARRAY_POINTER_EXT = Enumerant('GL_VARIANT_ARRAY_POINTER_EXT', 0x87e9, 'GL_EXT_vertex_shader')
GL_VARIANT_ARRAY_STRIDE_EXT = Enumerant('GL_VARIANT_ARRAY_STRIDE_EXT', 0x87e6, 'GL_EXT_vertex_shader')
GL_VARIANT_ARRAY_TYPE_EXT = Enumerant('GL_VARIANT_ARRAY_TYPE_EXT', 0x87e7, 'GL_EXT_vertex_shader')
GL_VARIANT_DATATYPE_EXT = Enumerant('GL_VARIANT_DATATYPE_EXT', 0x87e5, 'GL_EXT_vertex_shader')
GL_VARIANT_EXT = Enumerant('GL_VARIANT_EXT', 0x87c1, 'GL_EXT_vertex_shader')
GL_VARIANT_VALUE_EXT = Enumerant('GL_VARIANT_VALUE_EXT', 0x87e4, 'GL_EXT_vertex_shader')
GL_VECTOR_EXT = Enumerant('GL_VECTOR_EXT', 0x87bf, 'GL_EXT_vertex_shader')
GL_VERTEX_SHADER_BINDING_EXT = Enumerant('GL_VERTEX_SHADER_BINDING_EXT', 0x8781, 'GL_EXT_vertex_shader')
GL_VERTEX_SHADER_EXT = Enumerant('GL_VERTEX_SHADER_EXT', 0x8780, 'GL_EXT_vertex_shader')
GL_VERTEX_SHADER_INSTRUCTIONS_EXT = Enumerant('GL_VERTEX_SHADER_INSTRUCTIONS_EXT', 0x87cf, 'GL_EXT_vertex_shader')
GL_VERTEX_SHADER_INVARIANTS_EXT = Enumerant('GL_VERTEX_SHADER_INVARIANTS_EXT', 0x87d1, 'GL_EXT_vertex_shader')
GL_VERTEX_SHADER_LOCALS_EXT = Enumerant('GL_VERTEX_SHADER_LOCALS_EXT', 0x87d3, 'GL_EXT_vertex_shader')
GL_VERTEX_SHADER_LOCAL_CONSTANTS_EXT = Enumerant('GL_VERTEX_SHADER_LOCAL_CONSTANTS_EXT', 0x87d2, 'GL_EXT_vertex_shader')
GL_VERTEX_SHADER_OPTIMIZED_EXT = Enumerant('GL_VERTEX_SHADER_OPTIMIZED_EXT', 0x87d4, 'GL_EXT_vertex_shader')
GL_VERTEX_SHADER_VARIANTS_EXT = Enumerant('GL_VERTEX_SHADER_VARIANTS_EXT', 0x87d0, 'GL_EXT_vertex_shader')
GL_W_EXT = Enumerant('GL_W_EXT', 0x87d8, 'GL_EXT_vertex_shader')
GL_X_EXT = Enumerant('GL_X_EXT', 0x87d5, 'GL_EXT_vertex_shader')
GL_Y_EXT = Enumerant('GL_Y_EXT', 0x87d6, 'GL_EXT_vertex_shader')
GL_ZERO_EXT = Enumerant('GL_ZERO_EXT', 0x87dd, 'GL_EXT_vertex_shader')
GL_Z_EXT = Enumerant('GL_Z_EXT', 0x87d7, 'GL_EXT_vertex_shader')

defines.add(GL_CURRENT_VERTEX_EXT)
defines.add(GL_FULL_RANGE_EXT)
defines.add(GL_INVARIANT_DATATYPE_EXT)
defines.add(GL_INVARIANT_EXT)
defines.add(GL_INVARIANT_VALUE_EXT)
defines.add(GL_LOCAL_CONSTANT_DATATYPE_EXT)
defines.add(GL_LOCAL_CONSTANT_EXT)
defines.add(GL_LOCAL_CONSTANT_VALUE_EXT)
defines.add(GL_LOCAL_EXT)
defines.add(GL_MATRIX_EXT)
defines.add(GL_MAX_OPTIMIZED_VERTEX_SHADER_INSTRUCTIONS_EXT)
defines.add(GL_MAX_OPTIMIZED_VERTEX_SHADER_INVARIANTS_EXT)
defines.add(GL_MAX_OPTIMIZED_VERTEX_SHADER_LOCALS_EXT)
defines.add(GL_MAX_OPTIMIZED_VERTEX_SHADER_LOCAL_CONSTANTS_EXT)
defines.add(GL_MAX_OPTIMIZED_VERTEX_SHADER_VARIANTS_EXT)
defines.add(GL_MAX_VERTEX_SHADER_INSTRUCTIONS_EXT)
defines.add(GL_MAX_VERTEX_SHADER_INVARIANTS_EXT)
defines.add(GL_MAX_VERTEX_SHADER_LOCALS_EXT)
defines.add(GL_MAX_VERTEX_SHADER_LOCAL_CONSTANTS_EXT)
defines.add(GL_MAX_VERTEX_SHADER_VARIANTS_EXT)
defines.add(GL_MVP_MATRIX_EXT)
defines.add(GL_NEGATIVE_ONE_EXT)
defines.add(GL_NEGATIVE_W_EXT)
defines.add(GL_NEGATIVE_X_EXT)
defines.add(GL_NEGATIVE_Y_EXT)
defines.add(GL_NEGATIVE_Z_EXT)
defines.add(GL_NORMALIZED_RANGE_EXT)
defines.add(GL_ONE_EXT)
defines.add(GL_OP_ADD_EXT)
defines.add(GL_OP_CLAMP_EXT)
defines.add(GL_OP_CROSS_PRODUCT_EXT)
defines.add(GL_OP_DOT3_EXT)
defines.add(GL_OP_DOT4_EXT)
defines.add(GL_OP_EXP_BASE_2_EXT)
defines.add(GL_OP_FLOOR_EXT)
defines.add(GL_OP_FRAC_EXT)
defines.add(GL_OP_INDEX_EXT)
defines.add(GL_OP_LOG_BASE_2_EXT)
defines.add(GL_OP_MADD_EXT)
defines.add(GL_OP_MAX_EXT)
defines.add(GL_OP_MIN_EXT)
defines.add(GL_OP_MOV_EXT)
defines.add(GL_OP_MULTIPLY_MATRIX_EXT)
defines.add(GL_OP_MUL_EXT)
defines.add(GL_OP_NEGATE_EXT)
defines.add(GL_OP_POWER_EXT)
defines.add(GL_OP_RECIP_EXT)
defines.add(GL_OP_RECIP_SQRT_EXT)
defines.add(GL_OP_ROUND_EXT)
defines.add(GL_OP_SET_GE_EXT)
defines.add(GL_OP_SET_LT_EXT)
defines.add(GL_OP_SUB_EXT)
defines.add(GL_OUTPUT_COLOR0_EXT)
defines.add(GL_OUTPUT_COLOR1_EXT)
defines.add(GL_OUTPUT_FOG_EXT)
defines.add(GL_OUTPUT_TEXTURE_COORD0_EXT)
defines.add(GL_OUTPUT_TEXTURE_COORD10_EXT)
defines.add(GL_OUTPUT_TEXTURE_COORD11_EXT)
defines.add(GL_OUTPUT_TEXTURE_COORD12_EXT)
defines.add(GL_OUTPUT_TEXTURE_COORD13_EXT)
defines.add(GL_OUTPUT_TEXTURE_COORD14_EXT)
defines.add(GL_OUTPUT_TEXTURE_COORD15_EXT)
defines.add(GL_OUTPUT_TEXTURE_COORD16_EXT)
defines.add(GL_OUTPUT_TEXTURE_COORD17_EXT)
defines.add(GL_OUTPUT_TEXTURE_COORD18_EXT)
defines.add(GL_OUTPUT_TEXTURE_COORD19_EXT)
defines.add(GL_OUTPUT_TEXTURE_COORD1_EXT)
defines.add(GL_OUTPUT_TEXTURE_COORD20_EXT)
defines.add(GL_OUTPUT_TEXTURE_COORD21_EXT)
defines.add(GL_OUTPUT_TEXTURE_COORD22_EXT)
defines.add(GL_OUTPUT_TEXTURE_COORD23_EXT)
defines.add(GL_OUTPUT_TEXTURE_COORD24_EXT)
defines.add(GL_OUTPUT_TEXTURE_COORD25_EXT)
defines.add(GL_OUTPUT_TEXTURE_COORD26_EXT)
defines.add(GL_OUTPUT_TEXTURE_COORD27_EXT)
defines.add(GL_OUTPUT_TEXTURE_COORD28_EXT)
defines.add(GL_OUTPUT_TEXTURE_COORD29_EXT)
defines.add(GL_OUTPUT_TEXTURE_COORD2_EXT)
defines.add(GL_OUTPUT_TEXTURE_COORD30_EXT)
defines.add(GL_OUTPUT_TEXTURE_COORD31_EXT)
defines.add(GL_OUTPUT_TEXTURE_COORD3_EXT)
defines.add(GL_OUTPUT_TEXTURE_COORD4_EXT)
defines.add(GL_OUTPUT_TEXTURE_COORD5_EXT)
defines.add(GL_OUTPUT_TEXTURE_COORD6_EXT)
defines.add(GL_OUTPUT_TEXTURE_COORD7_EXT)
defines.add(GL_OUTPUT_TEXTURE_COORD8_EXT)
defines.add(GL_OUTPUT_TEXTURE_COORD9_EXT)
defines.add(GL_OUTPUT_VERTEX_EXT)
defines.add(GL_SCALAR_EXT)
defines.add(GL_VARIANT_ARRAY_EXT)
defines.add(GL_VARIANT_ARRAY_POINTER_EXT)
defines.add(GL_VARIANT_ARRAY_STRIDE_EXT)
defines.add(GL_VARIANT_ARRAY_TYPE_EXT)
defines.add(GL_VARIANT_DATATYPE_EXT)
defines.add(GL_VARIANT_EXT)
defines.add(GL_VARIANT_VALUE_EXT)
defines.add(GL_VECTOR_EXT)
defines.add(GL_VERTEX_SHADER_BINDING_EXT)
defines.add(GL_VERTEX_SHADER_EXT)
defines.add(GL_VERTEX_SHADER_INSTRUCTIONS_EXT)
defines.add(GL_VERTEX_SHADER_INVARIANTS_EXT)
defines.add(GL_VERTEX_SHADER_LOCALS_EXT)
defines.add(GL_VERTEX_SHADER_LOCAL_CONSTANTS_EXT)
defines.add(GL_VERTEX_SHADER_OPTIMIZED_EXT)
defines.add(GL_VERTEX_SHADER_VARIANTS_EXT)
defines.add(GL_W_EXT)
defines.add(GL_X_EXT)
defines.add(GL_Y_EXT)
defines.add(GL_ZERO_EXT)
defines.add(GL_Z_EXT)

# GL_EXT_vertex_weighting

GL_CURRENT_VERTEX_WEIGHT_EXT = Enumerant('GL_CURRENT_VERTEX_WEIGHT_EXT', 0x850b, 'GL_EXT_vertex_weighting')
GL_MODELVIEW0_EXT = Enumerant('GL_MODELVIEW0_EXT', 0x1700, 'GL_EXT_vertex_weighting')
GL_MODELVIEW0_MATRIX_EXT = Enumerant('GL_MODELVIEW0_MATRIX_EXT', 0x0ba6, 'GL_EXT_vertex_weighting')
GL_MODELVIEW0_STACK_DEPTH_EXT = Enumerant('GL_MODELVIEW0_STACK_DEPTH_EXT', 0x0ba3, 'GL_EXT_vertex_weighting')
GL_MODELVIEW1_EXT = Enumerant('GL_MODELVIEW1_EXT', 0x850a, 'GL_EXT_vertex_weighting')
GL_MODELVIEW1_MATRIX_EXT = Enumerant('GL_MODELVIEW1_MATRIX_EXT', 0x8506, 'GL_EXT_vertex_weighting')
GL_MODELVIEW1_STACK_DEPTH_EXT = Enumerant('GL_MODELVIEW1_STACK_DEPTH_EXT', 0x8502, 'GL_EXT_vertex_weighting')
GL_VERTEX_WEIGHTING_EXT = Enumerant('GL_VERTEX_WEIGHTING_EXT', 0x8509, 'GL_EXT_vertex_weighting')
GL_VERTEX_WEIGHT_ARRAY_EXT = Enumerant('GL_VERTEX_WEIGHT_ARRAY_EXT', 0x850c, 'GL_EXT_vertex_weighting')
GL_VERTEX_WEIGHT_ARRAY_POINTER_EXT = Enumerant('GL_VERTEX_WEIGHT_ARRAY_POINTER_EXT', 0x8510, 'GL_EXT_vertex_weighting')
GL_VERTEX_WEIGHT_ARRAY_SIZE_EXT = Enumerant('GL_VERTEX_WEIGHT_ARRAY_SIZE_EXT', 0x850d, 'GL_EXT_vertex_weighting')
GL_VERTEX_WEIGHT_ARRAY_STRIDE_EXT = Enumerant('GL_VERTEX_WEIGHT_ARRAY_STRIDE_EXT', 0x850f, 'GL_EXT_vertex_weighting')
GL_VERTEX_WEIGHT_ARRAY_TYPE_EXT = Enumerant('GL_VERTEX_WEIGHT_ARRAY_TYPE_EXT', 0x850e, 'GL_EXT_vertex_weighting')

defines.add(GL_CURRENT_VERTEX_WEIGHT_EXT)
defines.add(GL_MODELVIEW0_EXT)
defines.add(GL_MODELVIEW0_MATRIX_EXT)
defines.add(GL_MODELVIEW0_STACK_DEPTH_EXT)
defines.add(GL_MODELVIEW1_EXT)
defines.add(GL_MODELVIEW1_MATRIX_EXT)
defines.add(GL_MODELVIEW1_STACK_DEPTH_EXT)
defines.add(GL_VERTEX_WEIGHTING_EXT)
defines.add(GL_VERTEX_WEIGHT_ARRAY_EXT)
defines.add(GL_VERTEX_WEIGHT_ARRAY_POINTER_EXT)
defines.add(GL_VERTEX_WEIGHT_ARRAY_SIZE_EXT)
defines.add(GL_VERTEX_WEIGHT_ARRAY_STRIDE_EXT)
defines.add(GL_VERTEX_WEIGHT_ARRAY_TYPE_EXT)

# GL_EXT_x11_sync_object

GL_SYNC_X11_FENCE_EXT = Enumerant('GL_SYNC_X11_FENCE_EXT', 0x90e1, 'GL_EXT_x11_sync_object')

defines.add(GL_SYNC_X11_FENCE_EXT)

# GL_FJ_shader_binary_GCCSO

GL_GCCSO_SHADER_BINARY_FJ = Enumerant('GL_GCCSO_SHADER_BINARY_FJ', 0x9260, 'GL_FJ_shader_binary_GCCSO')

defines.add(GL_GCCSO_SHADER_BINARY_FJ)

# GL_HP_image_transform

GL_AVERAGE_HP = Enumerant('GL_AVERAGE_HP', 0x8160, 'GL_HP_image_transform')
GL_CUBIC_HP = Enumerant('GL_CUBIC_HP', 0x815f, 'GL_HP_image_transform')
GL_IMAGE_CUBIC_WEIGHT_HP = Enumerant('GL_IMAGE_CUBIC_WEIGHT_HP', 0x815e, 'GL_HP_image_transform')
GL_IMAGE_MAG_FILTER_HP = Enumerant('GL_IMAGE_MAG_FILTER_HP', 0x815c, 'GL_HP_image_transform')
GL_IMAGE_MIN_FILTER_HP = Enumerant('GL_IMAGE_MIN_FILTER_HP', 0x815d, 'GL_HP_image_transform')
GL_IMAGE_ROTATE_ANGLE_HP = Enumerant('GL_IMAGE_ROTATE_ANGLE_HP', 0x8159, 'GL_HP_image_transform')
GL_IMAGE_ROTATE_ORIGIN_X_HP = Enumerant('GL_IMAGE_ROTATE_ORIGIN_X_HP', 0x815a, 'GL_HP_image_transform')
GL_IMAGE_ROTATE_ORIGIN_Y_HP = Enumerant('GL_IMAGE_ROTATE_ORIGIN_Y_HP', 0x815b, 'GL_HP_image_transform')
GL_IMAGE_SCALE_X_HP = Enumerant('GL_IMAGE_SCALE_X_HP', 0x8155, 'GL_HP_image_transform')
GL_IMAGE_SCALE_Y_HP = Enumerant('GL_IMAGE_SCALE_Y_HP', 0x8156, 'GL_HP_image_transform')
GL_IMAGE_TRANSFORM_2D_HP = Enumerant('GL_IMAGE_TRANSFORM_2D_HP', 0x8161, 'GL_HP_image_transform')
GL_IMAGE_TRANSLATE_X_HP = Enumerant('GL_IMAGE_TRANSLATE_X_HP', 0x8157, 'GL_HP_image_transform')
GL_IMAGE_TRANSLATE_Y_HP = Enumerant('GL_IMAGE_TRANSLATE_Y_HP', 0x8158, 'GL_HP_image_transform')
GL_POST_IMAGE_TRANSFORM_COLOR_TABLE_HP = Enumerant('GL_POST_IMAGE_TRANSFORM_COLOR_TABLE_HP', 0x8162, 'GL_HP_image_transform')
GL_PROXY_POST_IMAGE_TRANSFORM_COLOR_TABLE_HP = Enumerant('GL_PROXY_POST_IMAGE_TRANSFORM_COLOR_TABLE_HP', 0x8163, 'GL_HP_image_transform')

defines.add(GL_AVERAGE_HP)
defines.add(GL_CUBIC_HP)
defines.add(GL_IMAGE_CUBIC_WEIGHT_HP)
defines.add(GL_IMAGE_MAG_FILTER_HP)
defines.add(GL_IMAGE_MIN_FILTER_HP)
defines.add(GL_IMAGE_ROTATE_ANGLE_HP)
defines.add(GL_IMAGE_ROTATE_ORIGIN_X_HP)
defines.add(GL_IMAGE_ROTATE_ORIGIN_Y_HP)
defines.add(GL_IMAGE_SCALE_X_HP)
defines.add(GL_IMAGE_SCALE_Y_HP)
defines.add(GL_IMAGE_TRANSFORM_2D_HP)
defines.add(GL_IMAGE_TRANSLATE_X_HP)
defines.add(GL_IMAGE_TRANSLATE_Y_HP)
defines.add(GL_POST_IMAGE_TRANSFORM_COLOR_TABLE_HP)
defines.add(GL_PROXY_POST_IMAGE_TRANSFORM_COLOR_TABLE_HP)

# GL_HP_occlusion_test

GL_OCCLUSION_TEST_HP = Enumerant('GL_OCCLUSION_TEST_HP', 0x8165, 'GL_HP_occlusion_test')
GL_OCCLUSION_TEST_RESULT_HP = Enumerant('GL_OCCLUSION_TEST_RESULT_HP', 0x8166, 'GL_HP_occlusion_test')

defines.add(GL_OCCLUSION_TEST_HP)
defines.add(GL_OCCLUSION_TEST_RESULT_HP)

# GL_IBM_cull_vertex

GL_CULL_VERTEX_IBM = Enumerant('GL_CULL_VERTEX_IBM', 0x1928a, 'GL_IBM_cull_vertex')

defines.add(GL_CULL_VERTEX_IBM)

# GL_IBM_rasterpos_clip

GL_RASTER_POSITION_UNCLIPPED_IBM = Enumerant('GL_RASTER_POSITION_UNCLIPPED_IBM', 0x19262, 'GL_IBM_rasterpos_clip')

defines.add(GL_RASTER_POSITION_UNCLIPPED_IBM)

# GL_IBM_static_data

GL_ALL_STATIC_DATA_IBM = Enumerant('GL_ALL_STATIC_DATA_IBM', 0x19294, 'GL_IBM_static_data')
GL_STATIC_VERTEX_ARRAY_IBM = Enumerant('GL_STATIC_VERTEX_ARRAY_IBM', 0x19295, 'GL_IBM_static_data')

defines.add(GL_ALL_STATIC_DATA_IBM)
defines.add(GL_STATIC_VERTEX_ARRAY_IBM)

# GL_IBM_texture_mirrored_repeat

GL_MIRRORED_REPEAT_IBM = Enumerant('GL_MIRRORED_REPEAT_IBM', 0x8370, 'GL_IBM_texture_mirrored_repeat')

defines.add(GL_MIRRORED_REPEAT_IBM)

# GL_IBM_vertex_array_lists

GL_COLOR_ARRAY_LIST_IBM = Enumerant('GL_COLOR_ARRAY_LIST_IBM', 0x192a0, 'GL_IBM_vertex_array_lists')
GL_COLOR_ARRAY_LIST_STRIDE_IBM = Enumerant('GL_COLOR_ARRAY_LIST_STRIDE_IBM', 0x192aa, 'GL_IBM_vertex_array_lists')
GL_EDGE_FLAG_ARRAY_LIST_IBM = Enumerant('GL_EDGE_FLAG_ARRAY_LIST_IBM', 0x192a3, 'GL_IBM_vertex_array_lists')
GL_EDGE_FLAG_ARRAY_LIST_STRIDE_IBM = Enumerant('GL_EDGE_FLAG_ARRAY_LIST_STRIDE_IBM', 0x192ad, 'GL_IBM_vertex_array_lists')
GL_FOG_COORDINATE_ARRAY_LIST_IBM = Enumerant('GL_FOG_COORDINATE_ARRAY_LIST_IBM', 0x192a4, 'GL_IBM_vertex_array_lists')
GL_FOG_COORDINATE_ARRAY_LIST_STRIDE_IBM = Enumerant('GL_FOG_COORDINATE_ARRAY_LIST_STRIDE_IBM', 0x192ae, 'GL_IBM_vertex_array_lists')
GL_INDEX_ARRAY_LIST_IBM = Enumerant('GL_INDEX_ARRAY_LIST_IBM', 0x192a1, 'GL_IBM_vertex_array_lists')
GL_INDEX_ARRAY_LIST_STRIDE_IBM = Enumerant('GL_INDEX_ARRAY_LIST_STRIDE_IBM', 0x192ab, 'GL_IBM_vertex_array_lists')
GL_NORMAL_ARRAY_LIST_IBM = Enumerant('GL_NORMAL_ARRAY_LIST_IBM', 0x1929f, 'GL_IBM_vertex_array_lists')
GL_NORMAL_ARRAY_LIST_STRIDE_IBM = Enumerant('GL_NORMAL_ARRAY_LIST_STRIDE_IBM', 0x192a9, 'GL_IBM_vertex_array_lists')
GL_SECONDARY_COLOR_ARRAY_LIST_IBM = Enumerant('GL_SECONDARY_COLOR_ARRAY_LIST_IBM', 0x192a5, 'GL_IBM_vertex_array_lists')
GL_SECONDARY_COLOR_ARRAY_LIST_STRIDE_IBM = Enumerant('GL_SECONDARY_COLOR_ARRAY_LIST_STRIDE_IBM', 0x192af, 'GL_IBM_vertex_array_lists')
GL_TEXTURE_COORD_ARRAY_LIST_IBM = Enumerant('GL_TEXTURE_COORD_ARRAY_LIST_IBM', 0x192a2, 'GL_IBM_vertex_array_lists')
GL_TEXTURE_COORD_ARRAY_LIST_STRIDE_IBM = Enumerant('GL_TEXTURE_COORD_ARRAY_LIST_STRIDE_IBM', 0x192ac, 'GL_IBM_vertex_array_lists')
GL_VERTEX_ARRAY_LIST_IBM = Enumerant('GL_VERTEX_ARRAY_LIST_IBM', 0x1929e, 'GL_IBM_vertex_array_lists')
GL_VERTEX_ARRAY_LIST_STRIDE_IBM = Enumerant('GL_VERTEX_ARRAY_LIST_STRIDE_IBM', 0x192a8, 'GL_IBM_vertex_array_lists')

defines.add(GL_COLOR_ARRAY_LIST_IBM)
defines.add(GL_COLOR_ARRAY_LIST_STRIDE_IBM)
defines.add(GL_EDGE_FLAG_ARRAY_LIST_IBM)
defines.add(GL_EDGE_FLAG_ARRAY_LIST_STRIDE_IBM)
defines.add(GL_FOG_COORDINATE_ARRAY_LIST_IBM)
defines.add(GL_FOG_COORDINATE_ARRAY_LIST_STRIDE_IBM)
defines.add(GL_INDEX_ARRAY_LIST_IBM)
defines.add(GL_INDEX_ARRAY_LIST_STRIDE_IBM)
defines.add(GL_NORMAL_ARRAY_LIST_IBM)
defines.add(GL_NORMAL_ARRAY_LIST_STRIDE_IBM)
defines.add(GL_SECONDARY_COLOR_ARRAY_LIST_IBM)
defines.add(GL_SECONDARY_COLOR_ARRAY_LIST_STRIDE_IBM)
defines.add(GL_TEXTURE_COORD_ARRAY_LIST_IBM)
defines.add(GL_TEXTURE_COORD_ARRAY_LIST_STRIDE_IBM)
defines.add(GL_VERTEX_ARRAY_LIST_IBM)
defines.add(GL_VERTEX_ARRAY_LIST_STRIDE_IBM)

# GL_IMG_multisampled_render_to_texture

GL_FRAMEBUFFER_INCOMPLETE_MULTISAMPLE_IMG = Enumerant('GL_FRAMEBUFFER_INCOMPLETE_MULTISAMPLE_IMG', 0x9134, 'GL_IMG_multisampled_render_to_texture')
GL_MAX_SAMPLES_IMG = Enumerant('GL_MAX_SAMPLES_IMG', 0x9135, 'GL_IMG_multisampled_render_to_texture')
GL_RENDERBUFFER_SAMPLES_IMG = Enumerant('GL_RENDERBUFFER_SAMPLES_IMG', 0x9133, 'GL_IMG_multisampled_render_to_texture')
GL_TEXTURE_SAMPLES_IMG = Enumerant('GL_TEXTURE_SAMPLES_IMG', 0x9136, 'GL_IMG_multisampled_render_to_texture')

defines.add(GL_FRAMEBUFFER_INCOMPLETE_MULTISAMPLE_IMG)
defines.add(GL_MAX_SAMPLES_IMG)
defines.add(GL_RENDERBUFFER_SAMPLES_IMG)
defines.add(GL_TEXTURE_SAMPLES_IMG)

# GL_IMG_program_binary

GL_SGX_PROGRAM_BINARY_IMG = Enumerant('GL_SGX_PROGRAM_BINARY_IMG', 0x9130, 'GL_IMG_program_binary')

defines.add(GL_SGX_PROGRAM_BINARY_IMG)

# GL_IMG_read_format

GL_BGRA_IMG = Enumerant('GL_BGRA_IMG', 0x80e1, 'GL_IMG_read_format')
GL_UNSIGNED_SHORT_4_4_4_4_REV_IMG = Enumerant('GL_UNSIGNED_SHORT_4_4_4_4_REV_IMG', 0x8365, 'GL_IMG_read_format')

defines.add(GL_BGRA_IMG)
defines.add(GL_UNSIGNED_SHORT_4_4_4_4_REV_IMG)

# GL_IMG_shader_binary

GL_SGX_BINARY_IMG = Enumerant('GL_SGX_BINARY_IMG', 0x8c0a, 'GL_IMG_shader_binary')

defines.add(GL_SGX_BINARY_IMG)

# GL_IMG_texture_compression_pvrtc

GL_COMPRESSED_RGBA_PVRTC_2BPPV1_IMG = Enumerant('GL_COMPRESSED_RGBA_PVRTC_2BPPV1_IMG', 0x8c03, 'GL_IMG_texture_compression_pvrtc')
GL_COMPRESSED_RGBA_PVRTC_4BPPV1_IMG = Enumerant('GL_COMPRESSED_RGBA_PVRTC_4BPPV1_IMG', 0x8c02, 'GL_IMG_texture_compression_pvrtc')
GL_COMPRESSED_RGB_PVRTC_2BPPV1_IMG = Enumerant('GL_COMPRESSED_RGB_PVRTC_2BPPV1_IMG', 0x8c01, 'GL_IMG_texture_compression_pvrtc')
GL_COMPRESSED_RGB_PVRTC_4BPPV1_IMG = Enumerant('GL_COMPRESSED_RGB_PVRTC_4BPPV1_IMG', 0x8c00, 'GL_IMG_texture_compression_pvrtc')

defines.add(GL_COMPRESSED_RGBA_PVRTC_2BPPV1_IMG)
defines.add(GL_COMPRESSED_RGBA_PVRTC_4BPPV1_IMG)
defines.add(GL_COMPRESSED_RGB_PVRTC_2BPPV1_IMG)
defines.add(GL_COMPRESSED_RGB_PVRTC_4BPPV1_IMG)

# GL_IMG_texture_compression_pvrtc2

GL_COMPRESSED_RGBA_PVRTC_2BPPV2_IMG = Enumerant('GL_COMPRESSED_RGBA_PVRTC_2BPPV2_IMG', 0x9137, 'GL_IMG_texture_compression_pvrtc2')
GL_COMPRESSED_RGBA_PVRTC_4BPPV2_IMG = Enumerant('GL_COMPRESSED_RGBA_PVRTC_4BPPV2_IMG', 0x9138, 'GL_IMG_texture_compression_pvrtc2')

defines.add(GL_COMPRESSED_RGBA_PVRTC_2BPPV2_IMG)
defines.add(GL_COMPRESSED_RGBA_PVRTC_4BPPV2_IMG)

# GL_IMG_texture_env_enhanced_fixed_function

GL_ADD_BLEND_IMG = Enumerant('GL_ADD_BLEND_IMG', 0x8c09, 'GL_IMG_texture_env_enhanced_fixed_function')
GL_DOT3_RGBA_IMG = Enumerant('GL_DOT3_RGBA_IMG', 0x86af, 'GL_IMG_texture_env_enhanced_fixed_function')
GL_FACTOR_ALPHA_MODULATE_IMG = Enumerant('GL_FACTOR_ALPHA_MODULATE_IMG', 0x8c07, 'GL_IMG_texture_env_enhanced_fixed_function')
GL_FRAGMENT_ALPHA_MODULATE_IMG = Enumerant('GL_FRAGMENT_ALPHA_MODULATE_IMG', 0x8c08, 'GL_IMG_texture_env_enhanced_fixed_function')
GL_MODULATE_COLOR_IMG = Enumerant('GL_MODULATE_COLOR_IMG', 0x8c04, 'GL_IMG_texture_env_enhanced_fixed_function')
GL_RECIP_ADD_SIGNED_ALPHA_IMG = Enumerant('GL_RECIP_ADD_SIGNED_ALPHA_IMG', 0x8c05, 'GL_IMG_texture_env_enhanced_fixed_function')
GL_TEXTURE_ALPHA_MODULATE_IMG = Enumerant('GL_TEXTURE_ALPHA_MODULATE_IMG', 0x8c06, 'GL_IMG_texture_env_enhanced_fixed_function')

defines.add(GL_ADD_BLEND_IMG)
defines.add(GL_DOT3_RGBA_IMG)
defines.add(GL_FACTOR_ALPHA_MODULATE_IMG)
defines.add(GL_FRAGMENT_ALPHA_MODULATE_IMG)
defines.add(GL_MODULATE_COLOR_IMG)
defines.add(GL_RECIP_ADD_SIGNED_ALPHA_IMG)
defines.add(GL_TEXTURE_ALPHA_MODULATE_IMG)

# GL_IMG_user_clip_plane

GL_CLIP_PLANE0_IMG = Enumerant('GL_CLIP_PLANE0_IMG', 0x3000, 'GL_IMG_user_clip_plane')
GL_CLIP_PLANE1_IMG = Enumerant('GL_CLIP_PLANE1_IMG', 0x3001, 'GL_IMG_user_clip_plane')
GL_CLIP_PLANE2_IMG = Enumerant('GL_CLIP_PLANE2_IMG', 0x3002, 'GL_IMG_user_clip_plane')
GL_CLIP_PLANE3_IMG = Enumerant('GL_CLIP_PLANE3_IMG', 0x3003, 'GL_IMG_user_clip_plane')
GL_CLIP_PLANE4_IMG = Enumerant('GL_CLIP_PLANE4_IMG', 0x3004, 'GL_IMG_user_clip_plane')
GL_CLIP_PLANE5_IMG = Enumerant('GL_CLIP_PLANE5_IMG', 0x3005, 'GL_IMG_user_clip_plane')
GL_MAX_CLIP_PLANES_IMG = Enumerant('GL_MAX_CLIP_PLANES_IMG', 0x0d32, 'GL_IMG_user_clip_plane')

defines.add(GL_CLIP_PLANE0_IMG)
defines.add(GL_CLIP_PLANE1_IMG)
defines.add(GL_CLIP_PLANE2_IMG)
defines.add(GL_CLIP_PLANE3_IMG)
defines.add(GL_CLIP_PLANE4_IMG)
defines.add(GL_CLIP_PLANE5_IMG)
defines.add(GL_MAX_CLIP_PLANES_IMG)

# GL_INGR_color_clamp

GL_ALPHA_MAX_CLAMP_INGR = Enumerant('GL_ALPHA_MAX_CLAMP_INGR', 0x8567, 'GL_INGR_color_clamp')
GL_ALPHA_MIN_CLAMP_INGR = Enumerant('GL_ALPHA_MIN_CLAMP_INGR', 0x8563, 'GL_INGR_color_clamp')
GL_BLUE_MAX_CLAMP_INGR = Enumerant('GL_BLUE_MAX_CLAMP_INGR', 0x8566, 'GL_INGR_color_clamp')
GL_BLUE_MIN_CLAMP_INGR = Enumerant('GL_BLUE_MIN_CLAMP_INGR', 0x8562, 'GL_INGR_color_clamp')
GL_GREEN_MAX_CLAMP_INGR = Enumerant('GL_GREEN_MAX_CLAMP_INGR', 0x8565, 'GL_INGR_color_clamp')
GL_GREEN_MIN_CLAMP_INGR = Enumerant('GL_GREEN_MIN_CLAMP_INGR', 0x8561, 'GL_INGR_color_clamp')
GL_RED_MAX_CLAMP_INGR = Enumerant('GL_RED_MAX_CLAMP_INGR', 0x8564, 'GL_INGR_color_clamp')
GL_RED_MIN_CLAMP_INGR = Enumerant('GL_RED_MIN_CLAMP_INGR', 0x8560, 'GL_INGR_color_clamp')

defines.add(GL_ALPHA_MAX_CLAMP_INGR)
defines.add(GL_ALPHA_MIN_CLAMP_INGR)
defines.add(GL_BLUE_MAX_CLAMP_INGR)
defines.add(GL_BLUE_MIN_CLAMP_INGR)
defines.add(GL_GREEN_MAX_CLAMP_INGR)
defines.add(GL_GREEN_MIN_CLAMP_INGR)
defines.add(GL_RED_MAX_CLAMP_INGR)
defines.add(GL_RED_MIN_CLAMP_INGR)

# GL_INGR_interlace_read

GL_INTERLACE_READ_INGR = Enumerant('GL_INTERLACE_READ_INGR', 0x8568, 'GL_INGR_interlace_read')

defines.add(GL_INTERLACE_READ_INGR)

# GL_INTEL_map_texture

GL_LAYOUT_DEFAULT_INTEL = Enumerant('GL_LAYOUT_DEFAULT_INTEL', 0x0000, 'GL_INTEL_map_texture')
GL_LAYOUT_LINEAR_CPU_CACHED_INTEL = Enumerant('GL_LAYOUT_LINEAR_CPU_CACHED_INTEL', 0x0002, 'GL_INTEL_map_texture')
GL_LAYOUT_LINEAR_INTEL = Enumerant('GL_LAYOUT_LINEAR_INTEL', 0x0001, 'GL_INTEL_map_texture')
GL_TEXTURE_MEMORY_LAYOUT_INTEL = Enumerant('GL_TEXTURE_MEMORY_LAYOUT_INTEL', 0x83ff, 'GL_INTEL_map_texture')

defines.add(GL_LAYOUT_DEFAULT_INTEL)
defines.add(GL_LAYOUT_LINEAR_CPU_CACHED_INTEL)
defines.add(GL_LAYOUT_LINEAR_INTEL)
defines.add(GL_TEXTURE_MEMORY_LAYOUT_INTEL)

# GL_INTEL_parallel_arrays

GL_COLOR_ARRAY_PARALLEL_POINTERS_INTEL = Enumerant('GL_COLOR_ARRAY_PARALLEL_POINTERS_INTEL', 0x83f7, 'GL_INTEL_parallel_arrays')
GL_NORMAL_ARRAY_PARALLEL_POINTERS_INTEL = Enumerant('GL_NORMAL_ARRAY_PARALLEL_POINTERS_INTEL', 0x83f6, 'GL_INTEL_parallel_arrays')
GL_PARALLEL_ARRAYS_INTEL = Enumerant('GL_PARALLEL_ARRAYS_INTEL', 0x83f4, 'GL_INTEL_parallel_arrays')
GL_TEXTURE_COORD_ARRAY_PARALLEL_POINTERS_INTEL = Enumerant('GL_TEXTURE_COORD_ARRAY_PARALLEL_POINTERS_INTEL', 0x83f8, 'GL_INTEL_parallel_arrays')
GL_VERTEX_ARRAY_PARALLEL_POINTERS_INTEL = Enumerant('GL_VERTEX_ARRAY_PARALLEL_POINTERS_INTEL', 0x83f5, 'GL_INTEL_parallel_arrays')

defines.add(GL_COLOR_ARRAY_PARALLEL_POINTERS_INTEL)
defines.add(GL_NORMAL_ARRAY_PARALLEL_POINTERS_INTEL)
defines.add(GL_PARALLEL_ARRAYS_INTEL)
defines.add(GL_TEXTURE_COORD_ARRAY_PARALLEL_POINTERS_INTEL)
defines.add(GL_VERTEX_ARRAY_PARALLEL_POINTERS_INTEL)

# GL_KHR_debug

GL_BUFFER = Enumerant('GL_BUFFER', 0x82e0, 'GL_KHR_debug')
GL_CONTEXT_FLAG_DEBUG_BIT = Enumerant('GL_CONTEXT_FLAG_DEBUG_BIT', 0x0002, 'GL_KHR_debug')
GL_DEBUG_CALLBACK_FUNCTION = Enumerant('GL_DEBUG_CALLBACK_FUNCTION', 0x8244, 'GL_KHR_debug')
GL_DEBUG_CALLBACK_USER_PARAM = Enumerant('GL_DEBUG_CALLBACK_USER_PARAM', 0x8245, 'GL_KHR_debug')
GL_DEBUG_GROUP_STACK_DEPTH = Enumerant('GL_DEBUG_GROUP_STACK_DEPTH', 0x826d, 'GL_KHR_debug')
GL_DEBUG_LOGGED_MESSAGES = Enumerant('GL_DEBUG_LOGGED_MESSAGES', 0x9145, 'GL_KHR_debug')
GL_DEBUG_NEXT_LOGGED_MESSAGE_LENGTH = Enumerant('GL_DEBUG_NEXT_LOGGED_MESSAGE_LENGTH', 0x8243, 'GL_KHR_debug')
GL_DEBUG_OUTPUT = Enumerant('GL_DEBUG_OUTPUT', 0x92e0, 'GL_KHR_debug')
GL_DEBUG_OUTPUT.enableCap = True
GL_DEBUG_OUTPUT_SYNCHRONOUS = Enumerant('GL_DEBUG_OUTPUT_SYNCHRONOUS', 0x8242, 'GL_KHR_debug')
GL_DEBUG_OUTPUT_SYNCHRONOUS.enableCap = True
GL_DEBUG_SEVERITY_HIGH = Enumerant('GL_DEBUG_SEVERITY_HIGH', 0x9146, 'GL_KHR_debug')
GL_DEBUG_SEVERITY_LOW = Enumerant('GL_DEBUG_SEVERITY_LOW', 0x9148, 'GL_KHR_debug')
GL_DEBUG_SEVERITY_MEDIUM = Enumerant('GL_DEBUG_SEVERITY_MEDIUM', 0x9147, 'GL_KHR_debug')
GL_DEBUG_SEVERITY_NOTIFICATION = Enumerant('GL_DEBUG_SEVERITY_NOTIFICATION', 0x826b, 'GL_KHR_debug')
GL_DEBUG_SOURCE_API = Enumerant('GL_DEBUG_SOURCE_API', 0x8246, 'GL_KHR_debug')
GL_DEBUG_SOURCE_APPLICATION = Enumerant('GL_DEBUG_SOURCE_APPLICATION', 0x824a, 'GL_KHR_debug')
GL_DEBUG_SOURCE_OTHER = Enumerant('GL_DEBUG_SOURCE_OTHER', 0x824b, 'GL_KHR_debug')
GL_DEBUG_SOURCE_SHADER_COMPILER = Enumerant('GL_DEBUG_SOURCE_SHADER_COMPILER', 0x8248, 'GL_KHR_debug')
GL_DEBUG_SOURCE_THIRD_PARTY = Enumerant('GL_DEBUG_SOURCE_THIRD_PARTY', 0x8249, 'GL_KHR_debug')
GL_DEBUG_SOURCE_WINDOW_SYSTEM = Enumerant('GL_DEBUG_SOURCE_WINDOW_SYSTEM', 0x8247, 'GL_KHR_debug')
GL_DEBUG_TYPE_DEPRECATED_BEHAVIOR = Enumerant('GL_DEBUG_TYPE_DEPRECATED_BEHAVIOR', 0x824d, 'GL_KHR_debug')
GL_DEBUG_TYPE_ERROR = Enumerant('GL_DEBUG_TYPE_ERROR', 0x824c, 'GL_KHR_debug')
GL_DEBUG_TYPE_MARKER = Enumerant('GL_DEBUG_TYPE_MARKER', 0x8268, 'GL_KHR_debug')
GL_DEBUG_TYPE_OTHER = Enumerant('GL_DEBUG_TYPE_OTHER', 0x8251, 'GL_KHR_debug')
GL_DEBUG_TYPE_PERFORMANCE = Enumerant('GL_DEBUG_TYPE_PERFORMANCE', 0x8250, 'GL_KHR_debug')
GL_DEBUG_TYPE_POP_GROUP = Enumerant('GL_DEBUG_TYPE_POP_GROUP', 0x826a, 'GL_KHR_debug')
GL_DEBUG_TYPE_PORTABILITY = Enumerant('GL_DEBUG_TYPE_PORTABILITY', 0x824f, 'GL_KHR_debug')
GL_DEBUG_TYPE_PUSH_GROUP = Enumerant('GL_DEBUG_TYPE_PUSH_GROUP', 0x8269, 'GL_KHR_debug')
GL_DEBUG_TYPE_UNDEFINED_BEHAVIOR = Enumerant('GL_DEBUG_TYPE_UNDEFINED_BEHAVIOR', 0x824e, 'GL_KHR_debug')
GL_DISPLAY_LIST = Enumerant('GL_DISPLAY_LIST', 0x82e7, 'GL_KHR_debug')
GL_MAX_DEBUG_GROUP_STACK_DEPTH = Enumerant('GL_MAX_DEBUG_GROUP_STACK_DEPTH', 0x826c, 'GL_KHR_debug')
GL_MAX_DEBUG_LOGGED_MESSAGES = Enumerant('GL_MAX_DEBUG_LOGGED_MESSAGES', 0x9144, 'GL_KHR_debug')
GL_MAX_DEBUG_MESSAGE_LENGTH = Enumerant('GL_MAX_DEBUG_MESSAGE_LENGTH', 0x9143, 'GL_KHR_debug')
GL_MAX_LABEL_LENGTH = Enumerant('GL_MAX_LABEL_LENGTH', 0x82e8, 'GL_KHR_debug')
GL_PROGRAM = Enumerant('GL_PROGRAM', 0x82e2, 'GL_KHR_debug')
GL_PROGRAM_PIPELINE = Enumerant('GL_PROGRAM_PIPELINE', 0x82e4, 'GL_KHR_debug')
GL_QUERY = Enumerant('GL_QUERY', 0x82e3, 'GL_KHR_debug')
GL_SAMPLER = Enumerant('GL_SAMPLER', 0x82e6, 'GL_KHR_debug')
GL_SHADER = Enumerant('GL_SHADER', 0x82e1, 'GL_KHR_debug')

defines.add(GL_BUFFER)
defines.add(GL_CONTEXT_FLAG_DEBUG_BIT)
defines.add(GL_DEBUG_CALLBACK_FUNCTION)
defines.add(GL_DEBUG_CALLBACK_USER_PARAM)
defines.add(GL_DEBUG_GROUP_STACK_DEPTH)
defines.add(GL_DEBUG_LOGGED_MESSAGES)
defines.add(GL_DEBUG_NEXT_LOGGED_MESSAGE_LENGTH)
defines.add(GL_DEBUG_OUTPUT)
defines.add(GL_DEBUG_OUTPUT_SYNCHRONOUS)
defines.add(GL_DEBUG_SEVERITY_HIGH)
defines.add(GL_DEBUG_SEVERITY_LOW)
defines.add(GL_DEBUG_SEVERITY_MEDIUM)
defines.add(GL_DEBUG_SEVERITY_NOTIFICATION)
defines.add(GL_DEBUG_SOURCE_API)
defines.add(GL_DEBUG_SOURCE_APPLICATION)
defines.add(GL_DEBUG_SOURCE_OTHER)
defines.add(GL_DEBUG_SOURCE_SHADER_COMPILER)
defines.add(GL_DEBUG_SOURCE_THIRD_PARTY)
defines.add(GL_DEBUG_SOURCE_WINDOW_SYSTEM)
defines.add(GL_DEBUG_TYPE_DEPRECATED_BEHAVIOR)
defines.add(GL_DEBUG_TYPE_ERROR)
defines.add(GL_DEBUG_TYPE_MARKER)
defines.add(GL_DEBUG_TYPE_OTHER)
defines.add(GL_DEBUG_TYPE_PERFORMANCE)
defines.add(GL_DEBUG_TYPE_POP_GROUP)
defines.add(GL_DEBUG_TYPE_PORTABILITY)
defines.add(GL_DEBUG_TYPE_PUSH_GROUP)
defines.add(GL_DEBUG_TYPE_UNDEFINED_BEHAVIOR)
defines.add(GL_DISPLAY_LIST)
defines.add(GL_MAX_DEBUG_GROUP_STACK_DEPTH)
defines.add(GL_MAX_DEBUG_LOGGED_MESSAGES)
defines.add(GL_MAX_DEBUG_MESSAGE_LENGTH)
defines.add(GL_MAX_LABEL_LENGTH)
defines.add(GL_PROGRAM)
defines.add(GL_PROGRAM_PIPELINE)
defines.add(GL_QUERY)
defines.add(GL_SAMPLER)
defines.add(GL_SHADER)

# GL_KHR_texture_compression_astc_ldr

GL_COMPRESSED_RGBA_ASTC_10x10_KHR = Enumerant('GL_COMPRESSED_RGBA_ASTC_10x10_KHR', 0x93bb, 'GL_KHR_texture_compression_astc_ldr')
GL_COMPRESSED_RGBA_ASTC_10x5_KHR = Enumerant('GL_COMPRESSED_RGBA_ASTC_10x5_KHR', 0x93b8, 'GL_KHR_texture_compression_astc_ldr')
GL_COMPRESSED_RGBA_ASTC_10x6_KHR = Enumerant('GL_COMPRESSED_RGBA_ASTC_10x6_KHR', 0x93b9, 'GL_KHR_texture_compression_astc_ldr')
GL_COMPRESSED_RGBA_ASTC_10x8_KHR = Enumerant('GL_COMPRESSED_RGBA_ASTC_10x8_KHR', 0x93ba, 'GL_KHR_texture_compression_astc_ldr')
GL_COMPRESSED_RGBA_ASTC_12x10_KHR = Enumerant('GL_COMPRESSED_RGBA_ASTC_12x10_KHR', 0x93bc, 'GL_KHR_texture_compression_astc_ldr')
GL_COMPRESSED_RGBA_ASTC_12x12_KHR = Enumerant('GL_COMPRESSED_RGBA_ASTC_12x12_KHR', 0x93bd, 'GL_KHR_texture_compression_astc_ldr')
GL_COMPRESSED_RGBA_ASTC_4x4_KHR = Enumerant('GL_COMPRESSED_RGBA_ASTC_4x4_KHR', 0x93b0, 'GL_KHR_texture_compression_astc_ldr')
GL_COMPRESSED_RGBA_ASTC_5x4_KHR = Enumerant('GL_COMPRESSED_RGBA_ASTC_5x4_KHR', 0x93b1, 'GL_KHR_texture_compression_astc_ldr')
GL_COMPRESSED_RGBA_ASTC_5x5_KHR = Enumerant('GL_COMPRESSED_RGBA_ASTC_5x5_KHR', 0x93b2, 'GL_KHR_texture_compression_astc_ldr')
GL_COMPRESSED_RGBA_ASTC_6x5_KHR = Enumerant('GL_COMPRESSED_RGBA_ASTC_6x5_KHR', 0x93b3, 'GL_KHR_texture_compression_astc_ldr')
GL_COMPRESSED_RGBA_ASTC_6x6_KHR = Enumerant('GL_COMPRESSED_RGBA_ASTC_6x6_KHR', 0x93b4, 'GL_KHR_texture_compression_astc_ldr')
GL_COMPRESSED_RGBA_ASTC_8x5_KHR = Enumerant('GL_COMPRESSED_RGBA_ASTC_8x5_KHR', 0x93b5, 'GL_KHR_texture_compression_astc_ldr')
GL_COMPRESSED_RGBA_ASTC_8x6_KHR = Enumerant('GL_COMPRESSED_RGBA_ASTC_8x6_KHR', 0x93b6, 'GL_KHR_texture_compression_astc_ldr')
GL_COMPRESSED_RGBA_ASTC_8x8_KHR = Enumerant('GL_COMPRESSED_RGBA_ASTC_8x8_KHR', 0x93b7, 'GL_KHR_texture_compression_astc_ldr')
GL_COMPRESSED_SRGB8_ALPHA8_ASTC_10x10_KHR = Enumerant('GL_COMPRESSED_SRGB8_ALPHA8_ASTC_10x10_KHR', 0x93db, 'GL_KHR_texture_compression_astc_ldr')
GL_COMPRESSED_SRGB8_ALPHA8_ASTC_10x5_KHR = Enumerant('GL_COMPRESSED_SRGB8_ALPHA8_ASTC_10x5_KHR', 0x93d8, 'GL_KHR_texture_compression_astc_ldr')
GL_COMPRESSED_SRGB8_ALPHA8_ASTC_10x6_KHR = Enumerant('GL_COMPRESSED_SRGB8_ALPHA8_ASTC_10x6_KHR', 0x93d9, 'GL_KHR_texture_compression_astc_ldr')
GL_COMPRESSED_SRGB8_ALPHA8_ASTC_10x8_KHR = Enumerant('GL_COMPRESSED_SRGB8_ALPHA8_ASTC_10x8_KHR', 0x93da, 'GL_KHR_texture_compression_astc_ldr')
GL_COMPRESSED_SRGB8_ALPHA8_ASTC_12x10_KHR = Enumerant('GL_COMPRESSED_SRGB8_ALPHA8_ASTC_12x10_KHR', 0x93dc, 'GL_KHR_texture_compression_astc_ldr')
GL_COMPRESSED_SRGB8_ALPHA8_ASTC_12x12_KHR = Enumerant('GL_COMPRESSED_SRGB8_ALPHA8_ASTC_12x12_KHR', 0x93dd, 'GL_KHR_texture_compression_astc_ldr')
GL_COMPRESSED_SRGB8_ALPHA8_ASTC_4x4_KHR = Enumerant('GL_COMPRESSED_SRGB8_ALPHA8_ASTC_4x4_KHR', 0x93d0, 'GL_KHR_texture_compression_astc_ldr')
GL_COMPRESSED_SRGB8_ALPHA8_ASTC_5x4_KHR = Enumerant('GL_COMPRESSED_SRGB8_ALPHA8_ASTC_5x4_KHR', 0x93d1, 'GL_KHR_texture_compression_astc_ldr')
GL_COMPRESSED_SRGB8_ALPHA8_ASTC_5x5_KHR = Enumerant('GL_COMPRESSED_SRGB8_ALPHA8_ASTC_5x5_KHR', 0x93d2, 'GL_KHR_texture_compression_astc_ldr')
GL_COMPRESSED_SRGB8_ALPHA8_ASTC_6x5_KHR = Enumerant('GL_COMPRESSED_SRGB8_ALPHA8_ASTC_6x5_KHR', 0x93d3, 'GL_KHR_texture_compression_astc_ldr')
GL_COMPRESSED_SRGB8_ALPHA8_ASTC_6x6_KHR = Enumerant('GL_COMPRESSED_SRGB8_ALPHA8_ASTC_6x6_KHR', 0x93d4, 'GL_KHR_texture_compression_astc_ldr')
GL_COMPRESSED_SRGB8_ALPHA8_ASTC_8x5_KHR = Enumerant('GL_COMPRESSED_SRGB8_ALPHA8_ASTC_8x5_KHR', 0x93d5, 'GL_KHR_texture_compression_astc_ldr')
GL_COMPRESSED_SRGB8_ALPHA8_ASTC_8x6_KHR = Enumerant('GL_COMPRESSED_SRGB8_ALPHA8_ASTC_8x6_KHR', 0x93d6, 'GL_KHR_texture_compression_astc_ldr')
GL_COMPRESSED_SRGB8_ALPHA8_ASTC_8x8_KHR = Enumerant('GL_COMPRESSED_SRGB8_ALPHA8_ASTC_8x8_KHR', 0x93d7, 'GL_KHR_texture_compression_astc_ldr')

defines.add(GL_COMPRESSED_RGBA_ASTC_10x10_KHR)
defines.add(GL_COMPRESSED_RGBA_ASTC_10x5_KHR)
defines.add(GL_COMPRESSED_RGBA_ASTC_10x6_KHR)
defines.add(GL_COMPRESSED_RGBA_ASTC_10x8_KHR)
defines.add(GL_COMPRESSED_RGBA_ASTC_12x10_KHR)
defines.add(GL_COMPRESSED_RGBA_ASTC_12x12_KHR)
defines.add(GL_COMPRESSED_RGBA_ASTC_4x4_KHR)
defines.add(GL_COMPRESSED_RGBA_ASTC_5x4_KHR)
defines.add(GL_COMPRESSED_RGBA_ASTC_5x5_KHR)
defines.add(GL_COMPRESSED_RGBA_ASTC_6x5_KHR)
defines.add(GL_COMPRESSED_RGBA_ASTC_6x6_KHR)
defines.add(GL_COMPRESSED_RGBA_ASTC_8x5_KHR)
defines.add(GL_COMPRESSED_RGBA_ASTC_8x6_KHR)
defines.add(GL_COMPRESSED_RGBA_ASTC_8x8_KHR)
defines.add(GL_COMPRESSED_SRGB8_ALPHA8_ASTC_10x10_KHR)
defines.add(GL_COMPRESSED_SRGB8_ALPHA8_ASTC_10x5_KHR)
defines.add(GL_COMPRESSED_SRGB8_ALPHA8_ASTC_10x6_KHR)
defines.add(GL_COMPRESSED_SRGB8_ALPHA8_ASTC_10x8_KHR)
defines.add(GL_COMPRESSED_SRGB8_ALPHA8_ASTC_12x10_KHR)
defines.add(GL_COMPRESSED_SRGB8_ALPHA8_ASTC_12x12_KHR)
defines.add(GL_COMPRESSED_SRGB8_ALPHA8_ASTC_4x4_KHR)
defines.add(GL_COMPRESSED_SRGB8_ALPHA8_ASTC_5x4_KHR)
defines.add(GL_COMPRESSED_SRGB8_ALPHA8_ASTC_5x5_KHR)
defines.add(GL_COMPRESSED_SRGB8_ALPHA8_ASTC_6x5_KHR)
defines.add(GL_COMPRESSED_SRGB8_ALPHA8_ASTC_6x6_KHR)
defines.add(GL_COMPRESSED_SRGB8_ALPHA8_ASTC_8x5_KHR)
defines.add(GL_COMPRESSED_SRGB8_ALPHA8_ASTC_8x6_KHR)
defines.add(GL_COMPRESSED_SRGB8_ALPHA8_ASTC_8x8_KHR)

# GL_KTX_buffer_region

GL_KTX_BACK_REGION = Enumerant('GL_KTX_BACK_REGION', 0x0001, 'GL_KTX_buffer_region')
GL_KTX_FRONT_REGION = Enumerant('GL_KTX_FRONT_REGION', 0x0000, 'GL_KTX_buffer_region')
GL_KTX_STENCIL_REGION = Enumerant('GL_KTX_STENCIL_REGION', 0x0003, 'GL_KTX_buffer_region')
GL_KTX_Z_REGION = Enumerant('GL_KTX_Z_REGION', 0x0002, 'GL_KTX_buffer_region')

defines.add(GL_KTX_BACK_REGION)
defines.add(GL_KTX_FRONT_REGION)
defines.add(GL_KTX_STENCIL_REGION)
defines.add(GL_KTX_Z_REGION)

# GL_MESAX_texture_stack

GL_PROXY_TEXTURE_1D_STACK_MESAX = Enumerant('GL_PROXY_TEXTURE_1D_STACK_MESAX', 0x875b, 'GL_MESAX_texture_stack')
GL_PROXY_TEXTURE_2D_STACK_MESAX = Enumerant('GL_PROXY_TEXTURE_2D_STACK_MESAX', 0x875c, 'GL_MESAX_texture_stack')
GL_TEXTURE_1D_STACK_BINDING_MESAX = Enumerant('GL_TEXTURE_1D_STACK_BINDING_MESAX', 0x875d, 'GL_MESAX_texture_stack')
GL_TEXTURE_1D_STACK_MESAX = Enumerant('GL_TEXTURE_1D_STACK_MESAX', 0x8759, 'GL_MESAX_texture_stack')
GL_TEXTURE_2D_STACK_BINDING_MESAX = Enumerant('GL_TEXTURE_2D_STACK_BINDING_MESAX', 0x875e, 'GL_MESAX_texture_stack')
GL_TEXTURE_2D_STACK_MESAX = Enumerant('GL_TEXTURE_2D_STACK_MESAX', 0x875a, 'GL_MESAX_texture_stack')

defines.add(GL_PROXY_TEXTURE_1D_STACK_MESAX)
defines.add(GL_PROXY_TEXTURE_2D_STACK_MESAX)
defines.add(GL_TEXTURE_1D_STACK_BINDING_MESAX)
defines.add(GL_TEXTURE_1D_STACK_MESAX)
defines.add(GL_TEXTURE_2D_STACK_BINDING_MESAX)
defines.add(GL_TEXTURE_2D_STACK_MESAX)

# GL_MESA_pack_invert

GL_PACK_INVERT_MESA = Enumerant('GL_PACK_INVERT_MESA', 0x8758, 'GL_MESA_pack_invert')

defines.add(GL_PACK_INVERT_MESA)

# GL_MESA_ycbcr_texture

GL_UNSIGNED_SHORT_8_8_MESA = Enumerant('GL_UNSIGNED_SHORT_8_8_MESA', 0x85ba, 'GL_MESA_ycbcr_texture')
GL_UNSIGNED_SHORT_8_8_REV_MESA = Enumerant('GL_UNSIGNED_SHORT_8_8_REV_MESA', 0x85bb, 'GL_MESA_ycbcr_texture')
GL_YCBCR_MESA = Enumerant('GL_YCBCR_MESA', 0x8757, 'GL_MESA_ycbcr_texture')

defines.add(GL_UNSIGNED_SHORT_8_8_MESA)
defines.add(GL_UNSIGNED_SHORT_8_8_REV_MESA)
defines.add(GL_YCBCR_MESA)

# GL_NVX_gpu_memory_info

GL_GPU_MEMORY_INFO_CURRENT_AVAILABLE_VIDMEM_NVX = Enumerant('GL_GPU_MEMORY_INFO_CURRENT_AVAILABLE_VIDMEM_NVX', 0x9049, 'GL_NVX_gpu_memory_info')
GL_GPU_MEMORY_INFO_DEDICATED_VIDMEM_NVX = Enumerant('GL_GPU_MEMORY_INFO_DEDICATED_VIDMEM_NVX', 0x9047, 'GL_NVX_gpu_memory_info')
GL_GPU_MEMORY_INFO_EVICTED_MEMORY_NVX = Enumerant('GL_GPU_MEMORY_INFO_EVICTED_MEMORY_NVX', 0x904b, 'GL_NVX_gpu_memory_info')
GL_GPU_MEMORY_INFO_EVICTION_COUNT_NVX = Enumerant('GL_GPU_MEMORY_INFO_EVICTION_COUNT_NVX', 0x904a, 'GL_NVX_gpu_memory_info')
GL_GPU_MEMORY_INFO_TOTAL_AVAILABLE_MEMORY_NVX = Enumerant('GL_GPU_MEMORY_INFO_TOTAL_AVAILABLE_MEMORY_NVX', 0x9048, 'GL_NVX_gpu_memory_info')

defines.add(GL_GPU_MEMORY_INFO_CURRENT_AVAILABLE_VIDMEM_NVX)
defines.add(GL_GPU_MEMORY_INFO_DEDICATED_VIDMEM_NVX)
defines.add(GL_GPU_MEMORY_INFO_EVICTED_MEMORY_NVX)
defines.add(GL_GPU_MEMORY_INFO_EVICTION_COUNT_NVX)
defines.add(GL_GPU_MEMORY_INFO_TOTAL_AVAILABLE_MEMORY_NVX)

# GL_NV_3dvision_settings

GL_3DVISION_STEREO_NV = Enumerant('GL_3DVISION_STEREO_NV', 0x90f4, 'GL_NV_3dvision_settings')
GL_STEREO_CONVERGENCE_NV = Enumerant('GL_STEREO_CONVERGENCE_NV', 0x90f6, 'GL_NV_3dvision_settings')
GL_STEREO_CUTOFF_NV = Enumerant('GL_STEREO_CUTOFF_NV', 0x90f7, 'GL_NV_3dvision_settings')
GL_STEREO_PROJECTION_NV = Enumerant('GL_STEREO_PROJECTION_NV', 0x90f8, 'GL_NV_3dvision_settings')
GL_STEREO_PROJECTION_ORTHO_NV = Enumerant('GL_STEREO_PROJECTION_ORTHO_NV', 0x90fa, 'GL_NV_3dvision_settings')
GL_STEREO_PROJECTION_PERSPECTIVE_NV = Enumerant('GL_STEREO_PROJECTION_PERSPECTIVE_NV', 0x90f9, 'GL_NV_3dvision_settings')
GL_STEREO_SEPARATION_NV = Enumerant('GL_STEREO_SEPARATION_NV', 0x90f5, 'GL_NV_3dvision_settings')

defines.add(GL_3DVISION_STEREO_NV)
defines.add(GL_STEREO_CONVERGENCE_NV)
defines.add(GL_STEREO_CUTOFF_NV)
defines.add(GL_STEREO_PROJECTION_NV)
defines.add(GL_STEREO_PROJECTION_ORTHO_NV)
defines.add(GL_STEREO_PROJECTION_PERSPECTIVE_NV)
defines.add(GL_STEREO_SEPARATION_NV)

# GL_NV_bgr

GL_BGR_NV = Enumerant('GL_BGR_NV', 0x80e0, 'GL_NV_bgr')

defines.add(GL_BGR_NV)

# GL_NV_blend_equation_advanced

GL_BLEND_ADVANCED_COHERENT_NV = Enumerant('GL_BLEND_ADVANCED_COHERENT_NV', 0x9285, 'GL_NV_blend_equation_advanced')
GL_BLEND_OVERLAP_NV = Enumerant('GL_BLEND_OVERLAP_NV', 0x9281, 'GL_NV_blend_equation_advanced')
GL_BLEND_PREMULTIPLIED_SRC_NV = Enumerant('GL_BLEND_PREMULTIPLIED_SRC_NV', 0x9280, 'GL_NV_blend_equation_advanced')
GL_COLORBURN_NV = Enumerant('GL_COLORBURN_NV', 0x929a, 'GL_NV_blend_equation_advanced')
GL_COLORDODGE_NV = Enumerant('GL_COLORDODGE_NV', 0x9299, 'GL_NV_blend_equation_advanced')
GL_CONJOINT_NV = Enumerant('GL_CONJOINT_NV', 0x9284, 'GL_NV_blend_equation_advanced')
GL_CONTRAST_NV = Enumerant('GL_CONTRAST_NV', 0x92a1, 'GL_NV_blend_equation_advanced')
GL_DARKEN_NV = Enumerant('GL_DARKEN_NV', 0x9297, 'GL_NV_blend_equation_advanced')
GL_DIFFERENCE_NV = Enumerant('GL_DIFFERENCE_NV', 0x929e, 'GL_NV_blend_equation_advanced')
GL_DISJOINT_NV = Enumerant('GL_DISJOINT_NV', 0x9283, 'GL_NV_blend_equation_advanced')
GL_DST_ATOP_NV = Enumerant('GL_DST_ATOP_NV', 0x928f, 'GL_NV_blend_equation_advanced')
GL_DST_IN_NV = Enumerant('GL_DST_IN_NV', 0x928b, 'GL_NV_blend_equation_advanced')
GL_DST_NV = Enumerant('GL_DST_NV', 0x9287, 'GL_NV_blend_equation_advanced')
GL_DST_OUT_NV = Enumerant('GL_DST_OUT_NV', 0x928d, 'GL_NV_blend_equation_advanced')
GL_DST_OVER_NV = Enumerant('GL_DST_OVER_NV', 0x9289, 'GL_NV_blend_equation_advanced')
GL_EXCLUSION_NV = Enumerant('GL_EXCLUSION_NV', 0x92a0, 'GL_NV_blend_equation_advanced')
GL_HARDLIGHT_NV = Enumerant('GL_HARDLIGHT_NV', 0x929b, 'GL_NV_blend_equation_advanced')
GL_HARDMIX_NV = Enumerant('GL_HARDMIX_NV', 0x92a9, 'GL_NV_blend_equation_advanced')
GL_HSL_COLOR_NV = Enumerant('GL_HSL_COLOR_NV', 0x92af, 'GL_NV_blend_equation_advanced')
GL_HSL_HUE_NV = Enumerant('GL_HSL_HUE_NV', 0x92ad, 'GL_NV_blend_equation_advanced')
GL_HSL_LUMINOSITY_NV = Enumerant('GL_HSL_LUMINOSITY_NV', 0x92b0, 'GL_NV_blend_equation_advanced')
GL_HSL_SATURATION_NV = Enumerant('GL_HSL_SATURATION_NV', 0x92ae, 'GL_NV_blend_equation_advanced')
GL_INVERT_OVG_NV = Enumerant('GL_INVERT_OVG_NV', 0x92b4, 'GL_NV_blend_equation_advanced')
GL_INVERT_RGB_NV = Enumerant('GL_INVERT_RGB_NV', 0x92a3, 'GL_NV_blend_equation_advanced')
GL_LIGHTEN_NV = Enumerant('GL_LIGHTEN_NV', 0x9298, 'GL_NV_blend_equation_advanced')
GL_LINEARBURN_NV = Enumerant('GL_LINEARBURN_NV', 0x92a5, 'GL_NV_blend_equation_advanced')
GL_LINEARDODGE_NV = Enumerant('GL_LINEARDODGE_NV', 0x92a4, 'GL_NV_blend_equation_advanced')
GL_LINEARLIGHT_NV = Enumerant('GL_LINEARLIGHT_NV', 0x92a7, 'GL_NV_blend_equation_advanced')
GL_MINUS_CLAMPED_NV = Enumerant('GL_MINUS_CLAMPED_NV', 0x92b3, 'GL_NV_blend_equation_advanced')
GL_MINUS_NV = Enumerant('GL_MINUS_NV', 0x929f, 'GL_NV_blend_equation_advanced')
GL_MULTIPLY_NV = Enumerant('GL_MULTIPLY_NV', 0x9294, 'GL_NV_blend_equation_advanced')
GL_OVERLAY_NV = Enumerant('GL_OVERLAY_NV', 0x9296, 'GL_NV_blend_equation_advanced')
GL_PINLIGHT_NV = Enumerant('GL_PINLIGHT_NV', 0x92a8, 'GL_NV_blend_equation_advanced')
GL_PLUS_CLAMPED_ALPHA_NV = Enumerant('GL_PLUS_CLAMPED_ALPHA_NV', 0x92b2, 'GL_NV_blend_equation_advanced')
GL_PLUS_CLAMPED_NV = Enumerant('GL_PLUS_CLAMPED_NV', 0x92b1, 'GL_NV_blend_equation_advanced')
GL_PLUS_DARKER_NV = Enumerant('GL_PLUS_DARKER_NV', 0x9292, 'GL_NV_blend_equation_advanced')
GL_PLUS_NV = Enumerant('GL_PLUS_NV', 0x9291, 'GL_NV_blend_equation_advanced')
GL_SCREEN_NV = Enumerant('GL_SCREEN_NV', 0x9295, 'GL_NV_blend_equation_advanced')
GL_SOFTLIGHT_NV = Enumerant('GL_SOFTLIGHT_NV', 0x929c, 'GL_NV_blend_equation_advanced')
GL_SRC_ATOP_NV = Enumerant('GL_SRC_ATOP_NV', 0x928e, 'GL_NV_blend_equation_advanced')
GL_SRC_IN_NV = Enumerant('GL_SRC_IN_NV', 0x928a, 'GL_NV_blend_equation_advanced')
GL_SRC_NV = Enumerant('GL_SRC_NV', 0x9286, 'GL_NV_blend_equation_advanced')
GL_SRC_OUT_NV = Enumerant('GL_SRC_OUT_NV', 0x928c, 'GL_NV_blend_equation_advanced')
GL_SRC_OVER_NV = Enumerant('GL_SRC_OVER_NV', 0x9288, 'GL_NV_blend_equation_advanced')
GL_UNCORRELATED_NV = Enumerant('GL_UNCORRELATED_NV', 0x9282, 'GL_NV_blend_equation_advanced')
GL_VIVIDLIGHT_NV = Enumerant('GL_VIVIDLIGHT_NV', 0x92a6, 'GL_NV_blend_equation_advanced')

defines.add(GL_BLEND_ADVANCED_COHERENT_NV)
defines.add(GL_BLEND_OVERLAP_NV)
defines.add(GL_BLEND_PREMULTIPLIED_SRC_NV)
defines.add(GL_COLORBURN_NV)
defines.add(GL_COLORDODGE_NV)
defines.add(GL_CONJOINT_NV)
defines.add(GL_CONTRAST_NV)
defines.add(GL_DARKEN_NV)
defines.add(GL_DIFFERENCE_NV)
defines.add(GL_DISJOINT_NV)
defines.add(GL_DST_ATOP_NV)
defines.add(GL_DST_IN_NV)
defines.add(GL_DST_NV)
defines.add(GL_DST_OUT_NV)
defines.add(GL_DST_OVER_NV)
defines.add(GL_EXCLUSION_NV)
defines.add(GL_HARDLIGHT_NV)
defines.add(GL_HARDMIX_NV)
defines.add(GL_HSL_COLOR_NV)
defines.add(GL_HSL_HUE_NV)
defines.add(GL_HSL_LUMINOSITY_NV)
defines.add(GL_HSL_SATURATION_NV)
defines.add(GL_INVERT_OVG_NV)
defines.add(GL_INVERT_RGB_NV)
defines.add(GL_LIGHTEN_NV)
defines.add(GL_LINEARBURN_NV)
defines.add(GL_LINEARDODGE_NV)
defines.add(GL_LINEARLIGHT_NV)
defines.add(GL_MINUS_CLAMPED_NV)
defines.add(GL_MINUS_NV)
defines.add(GL_MULTIPLY_NV)
defines.add(GL_OVERLAY_NV)
defines.add(GL_PINLIGHT_NV)
defines.add(GL_PLUS_CLAMPED_ALPHA_NV)
defines.add(GL_PLUS_CLAMPED_NV)
defines.add(GL_PLUS_DARKER_NV)
defines.add(GL_PLUS_NV)
defines.add(GL_SCREEN_NV)
defines.add(GL_SOFTLIGHT_NV)
defines.add(GL_SRC_ATOP_NV)
defines.add(GL_SRC_IN_NV)
defines.add(GL_SRC_NV)
defines.add(GL_SRC_OUT_NV)
defines.add(GL_SRC_OVER_NV)
defines.add(GL_UNCORRELATED_NV)
defines.add(GL_VIVIDLIGHT_NV)

# GL_NV_compute_program5

GL_COMPUTE_PROGRAM_NV = Enumerant('GL_COMPUTE_PROGRAM_NV', 0x90fb, 'GL_NV_compute_program5')
GL_COMPUTE_PROGRAM_PARAMETER_BUFFER_NV = Enumerant('GL_COMPUTE_PROGRAM_PARAMETER_BUFFER_NV', 0x90fc, 'GL_NV_compute_program5')

defines.add(GL_COMPUTE_PROGRAM_NV)
defines.add(GL_COMPUTE_PROGRAM_PARAMETER_BUFFER_NV)

# GL_NV_conditional_render

GL_QUERY_BY_REGION_NO_WAIT_NV = Enumerant('GL_QUERY_BY_REGION_NO_WAIT_NV', 0x8e16, 'GL_NV_conditional_render')
GL_QUERY_BY_REGION_WAIT_NV = Enumerant('GL_QUERY_BY_REGION_WAIT_NV', 0x8e15, 'GL_NV_conditional_render')
GL_QUERY_NO_WAIT_NV = Enumerant('GL_QUERY_NO_WAIT_NV', 0x8e14, 'GL_NV_conditional_render')
GL_QUERY_WAIT_NV = Enumerant('GL_QUERY_WAIT_NV', 0x8e13, 'GL_NV_conditional_render')

defines.add(GL_QUERY_BY_REGION_NO_WAIT_NV)
defines.add(GL_QUERY_BY_REGION_WAIT_NV)
defines.add(GL_QUERY_NO_WAIT_NV)
defines.add(GL_QUERY_WAIT_NV)

# GL_NV_copy_buffer

GL_COPY_READ_BUFFER_NV = Enumerant('GL_COPY_READ_BUFFER_NV', 0x8f36, 'GL_NV_copy_buffer')
GL_COPY_WRITE_BUFFER_NV = Enumerant('GL_COPY_WRITE_BUFFER_NV', 0x8f37, 'GL_NV_copy_buffer')

defines.add(GL_COPY_READ_BUFFER_NV)
defines.add(GL_COPY_WRITE_BUFFER_NV)

# GL_NV_copy_depth_to_color

GL_DEPTH_STENCIL_TO_BGRA_NV = Enumerant('GL_DEPTH_STENCIL_TO_BGRA_NV', 0x886f, 'GL_NV_copy_depth_to_color')
GL_DEPTH_STENCIL_TO_RGBA_NV = Enumerant('GL_DEPTH_STENCIL_TO_RGBA_NV', 0x886e, 'GL_NV_copy_depth_to_color')

defines.add(GL_DEPTH_STENCIL_TO_BGRA_NV)
defines.add(GL_DEPTH_STENCIL_TO_RGBA_NV)

# GL_NV_coverage_sample

GL_COVERAGE_ALL_FRAGMENTS_NV = Enumerant('GL_COVERAGE_ALL_FRAGMENTS_NV', 0x8ed5, 'GL_NV_coverage_sample')
GL_COVERAGE_ATTACHMENT_NV = Enumerant('GL_COVERAGE_ATTACHMENT_NV', 0x8ed2, 'GL_NV_coverage_sample')
GL_COVERAGE_AUTOMATIC_NV = Enumerant('GL_COVERAGE_AUTOMATIC_NV', 0x8ed7, 'GL_NV_coverage_sample')
GL_COVERAGE_BUFFERS_NV = Enumerant('GL_COVERAGE_BUFFERS_NV', 0x8ed3, 'GL_NV_coverage_sample')
GL_COVERAGE_BUFFER_BIT_NV = Enumerant('GL_COVERAGE_BUFFER_BIT_NV', 0x8000, 'GL_NV_coverage_sample')
GL_COVERAGE_COMPONENT4_NV = Enumerant('GL_COVERAGE_COMPONENT4_NV', 0x8ed1, 'GL_NV_coverage_sample')
GL_COVERAGE_COMPONENT_NV = Enumerant('GL_COVERAGE_COMPONENT_NV', 0x8ed0, 'GL_NV_coverage_sample')
GL_COVERAGE_EDGE_FRAGMENTS_NV = Enumerant('GL_COVERAGE_EDGE_FRAGMENTS_NV', 0x8ed6, 'GL_NV_coverage_sample')
GL_EGL_COVERAGE_BUFFERS_NV = Enumerant('GL_EGL_COVERAGE_BUFFERS_NV', 0x30e0, 'GL_NV_coverage_sample')
GL_EGL_COVERAGE_SAMPLES_NV = Enumerant('GL_EGL_COVERAGE_SAMPLES_NV', 0x30e1, 'GL_NV_coverage_sample')

defines.add(GL_COVERAGE_ALL_FRAGMENTS_NV)
defines.add(GL_COVERAGE_ATTACHMENT_NV)
defines.add(GL_COVERAGE_AUTOMATIC_NV)
defines.add(GL_COVERAGE_BUFFERS_NV)
defines.add(GL_COVERAGE_BUFFER_BIT_NV)
defines.add(GL_COVERAGE_COMPONENT4_NV)
defines.add(GL_COVERAGE_COMPONENT_NV)
defines.add(GL_COVERAGE_EDGE_FRAGMENTS_NV)
defines.add(GL_EGL_COVERAGE_BUFFERS_NV)
defines.add(GL_EGL_COVERAGE_SAMPLES_NV)

# GL_NV_deep_texture3D

GL_MAX_DEEP_3D_TEXTURE_DEPTH_NV = Enumerant('GL_MAX_DEEP_3D_TEXTURE_DEPTH_NV', 0x90d1, 'GL_NV_deep_texture3D')
GL_MAX_DEEP_3D_TEXTURE_WIDTH_HEIGHT_NV = Enumerant('GL_MAX_DEEP_3D_TEXTURE_WIDTH_HEIGHT_NV', 0x90d0, 'GL_NV_deep_texture3D')

defines.add(GL_MAX_DEEP_3D_TEXTURE_DEPTH_NV)
defines.add(GL_MAX_DEEP_3D_TEXTURE_WIDTH_HEIGHT_NV)

# GL_NV_depth_buffer_float

GL_DEPTH32F_STENCIL8_NV = Enumerant('GL_DEPTH32F_STENCIL8_NV', 0x8dac, 'GL_NV_depth_buffer_float')
GL_DEPTH_BUFFER_FLOAT_MODE_NV = Enumerant('GL_DEPTH_BUFFER_FLOAT_MODE_NV', 0x8daf, 'GL_NV_depth_buffer_float')
GL_DEPTH_COMPONENT32F_NV = Enumerant('GL_DEPTH_COMPONENT32F_NV', 0x8dab, 'GL_NV_depth_buffer_float')
GL_FLOAT_32_UNSIGNED_INT_24_8_REV_NV = Enumerant('GL_FLOAT_32_UNSIGNED_INT_24_8_REV_NV', 0x8dad, 'GL_NV_depth_buffer_float')

defines.add(GL_DEPTH32F_STENCIL8_NV)
defines.add(GL_DEPTH_BUFFER_FLOAT_MODE_NV)
defines.add(GL_DEPTH_COMPONENT32F_NV)
defines.add(GL_FLOAT_32_UNSIGNED_INT_24_8_REV_NV)

# GL_NV_depth_clamp

GL_DEPTH_CLAMP_NV = Enumerant('GL_DEPTH_CLAMP_NV', 0x864f, 'GL_NV_depth_clamp')

defines.add(GL_DEPTH_CLAMP_NV)

# GL_NV_depth_nonlinear

GL_DEPTH_COMPONENT16_NONLINEAR_NV = Enumerant('GL_DEPTH_COMPONENT16_NONLINEAR_NV', 0x8e2c, 'GL_NV_depth_nonlinear')
GL_EGL_DEPTH_ENCODING_NONE_NV = Enumerant('GL_EGL_DEPTH_ENCODING_NONE_NV', 0x0000, 'GL_NV_depth_nonlinear')
GL_EGL_DEPTH_ENCODING_NONLINEAR_NV = Enumerant('GL_EGL_DEPTH_ENCODING_NONLINEAR_NV', 0x30e3, 'GL_NV_depth_nonlinear')
GL_EGL_DEPTH_ENCODING_NV = Enumerant('GL_EGL_DEPTH_ENCODING_NV', 0x30e2, 'GL_NV_depth_nonlinear')

defines.add(GL_DEPTH_COMPONENT16_NONLINEAR_NV)
defines.add(GL_EGL_DEPTH_ENCODING_NONE_NV)
defines.add(GL_EGL_DEPTH_ENCODING_NONLINEAR_NV)
defines.add(GL_EGL_DEPTH_ENCODING_NV)

# GL_NV_depth_range_unclamped

GL_CURRENT_SAMPLE_COUNT_QUERY_NV = Enumerant('GL_CURRENT_SAMPLE_COUNT_QUERY_NV', 0x8865, 'GL_NV_depth_range_unclamped')
GL_QUERY_RESULT_AVAILABLE_NV = Enumerant('GL_QUERY_RESULT_AVAILABLE_NV', 0x8867, 'GL_NV_depth_range_unclamped')
GL_QUERY_RESULT_NV = Enumerant('GL_QUERY_RESULT_NV', 0x8866, 'GL_NV_depth_range_unclamped')
GL_SAMPLE_COUNT_BITS_NV = Enumerant('GL_SAMPLE_COUNT_BITS_NV', 0x8864, 'GL_NV_depth_range_unclamped')
GL_SAMPLE_COUNT_NV = Enumerant('GL_SAMPLE_COUNT_NV', 0x8914, 'GL_NV_depth_range_unclamped')

defines.add(GL_CURRENT_SAMPLE_COUNT_QUERY_NV)
defines.add(GL_QUERY_RESULT_AVAILABLE_NV)
defines.add(GL_QUERY_RESULT_NV)
defines.add(GL_SAMPLE_COUNT_BITS_NV)
defines.add(GL_SAMPLE_COUNT_NV)

# GL_NV_draw_buffers

GL_DRAW_BUFFER0_NV = Enumerant('GL_DRAW_BUFFER0_NV', 0x8825, 'GL_NV_draw_buffers')
GL_DRAW_BUFFER10_NV = Enumerant('GL_DRAW_BUFFER10_NV', 0x882f, 'GL_NV_draw_buffers')
GL_DRAW_BUFFER11_NV = Enumerant('GL_DRAW_BUFFER11_NV', 0x8830, 'GL_NV_draw_buffers')
GL_DRAW_BUFFER12_NV = Enumerant('GL_DRAW_BUFFER12_NV', 0x8831, 'GL_NV_draw_buffers')
GL_DRAW_BUFFER13_NV = Enumerant('GL_DRAW_BUFFER13_NV', 0x8832, 'GL_NV_draw_buffers')
GL_DRAW_BUFFER14_NV = Enumerant('GL_DRAW_BUFFER14_NV', 0x8833, 'GL_NV_draw_buffers')
GL_DRAW_BUFFER15_NV = Enumerant('GL_DRAW_BUFFER15_NV', 0x8834, 'GL_NV_draw_buffers')
GL_DRAW_BUFFER1_NV = Enumerant('GL_DRAW_BUFFER1_NV', 0x8826, 'GL_NV_draw_buffers')
GL_DRAW_BUFFER2_NV = Enumerant('GL_DRAW_BUFFER2_NV', 0x8827, 'GL_NV_draw_buffers')
GL_DRAW_BUFFER3_NV = Enumerant('GL_DRAW_BUFFER3_NV', 0x8828, 'GL_NV_draw_buffers')
GL_DRAW_BUFFER4_NV = Enumerant('GL_DRAW_BUFFER4_NV', 0x8829, 'GL_NV_draw_buffers')
GL_DRAW_BUFFER5_NV = Enumerant('GL_DRAW_BUFFER5_NV', 0x882a, 'GL_NV_draw_buffers')
GL_DRAW_BUFFER6_NV = Enumerant('GL_DRAW_BUFFER6_NV', 0x882b, 'GL_NV_draw_buffers')
GL_DRAW_BUFFER7_NV = Enumerant('GL_DRAW_BUFFER7_NV', 0x882c, 'GL_NV_draw_buffers')
GL_DRAW_BUFFER8_NV = Enumerant('GL_DRAW_BUFFER8_NV', 0x882d, 'GL_NV_draw_buffers')
GL_DRAW_BUFFER9_NV = Enumerant('GL_DRAW_BUFFER9_NV', 0x882e, 'GL_NV_draw_buffers')
GL_MAX_DRAW_BUFFERS_NV = Enumerant('GL_MAX_DRAW_BUFFERS_NV', 0x8824, 'GL_NV_draw_buffers')

defines.add(GL_DRAW_BUFFER0_NV)
defines.add(GL_DRAW_BUFFER10_NV)
defines.add(GL_DRAW_BUFFER11_NV)
defines.add(GL_DRAW_BUFFER12_NV)
defines.add(GL_DRAW_BUFFER13_NV)
defines.add(GL_DRAW_BUFFER14_NV)
defines.add(GL_DRAW_BUFFER15_NV)
defines.add(GL_DRAW_BUFFER1_NV)
defines.add(GL_DRAW_BUFFER2_NV)
defines.add(GL_DRAW_BUFFER3_NV)
defines.add(GL_DRAW_BUFFER4_NV)
defines.add(GL_DRAW_BUFFER5_NV)
defines.add(GL_DRAW_BUFFER6_NV)
defines.add(GL_DRAW_BUFFER7_NV)
defines.add(GL_DRAW_BUFFER8_NV)
defines.add(GL_DRAW_BUFFER9_NV)
defines.add(GL_MAX_DRAW_BUFFERS_NV)

# GL_NV_evaluators

GL_EVAL_2D_NV = Enumerant('GL_EVAL_2D_NV', 0x86c0, 'GL_NV_evaluators')
GL_EVAL_FRACTIONAL_TESSELLATION_NV = Enumerant('GL_EVAL_FRACTIONAL_TESSELLATION_NV', 0x86c5, 'GL_NV_evaluators')
GL_EVAL_TRIANGULAR_2D_NV = Enumerant('GL_EVAL_TRIANGULAR_2D_NV', 0x86c1, 'GL_NV_evaluators')
GL_EVAL_VERTEX_ATTRIB0_NV = Enumerant('GL_EVAL_VERTEX_ATTRIB0_NV', 0x86c6, 'GL_NV_evaluators')
GL_EVAL_VERTEX_ATTRIB10_NV = Enumerant('GL_EVAL_VERTEX_ATTRIB10_NV', 0x86d0, 'GL_NV_evaluators')
GL_EVAL_VERTEX_ATTRIB11_NV = Enumerant('GL_EVAL_VERTEX_ATTRIB11_NV', 0x86d1, 'GL_NV_evaluators')
GL_EVAL_VERTEX_ATTRIB12_NV = Enumerant('GL_EVAL_VERTEX_ATTRIB12_NV', 0x86d2, 'GL_NV_evaluators')
GL_EVAL_VERTEX_ATTRIB13_NV = Enumerant('GL_EVAL_VERTEX_ATTRIB13_NV', 0x86d3, 'GL_NV_evaluators')
GL_EVAL_VERTEX_ATTRIB14_NV = Enumerant('GL_EVAL_VERTEX_ATTRIB14_NV', 0x86d4, 'GL_NV_evaluators')
GL_EVAL_VERTEX_ATTRIB15_NV = Enumerant('GL_EVAL_VERTEX_ATTRIB15_NV', 0x86d5, 'GL_NV_evaluators')
GL_EVAL_VERTEX_ATTRIB1_NV = Enumerant('GL_EVAL_VERTEX_ATTRIB1_NV', 0x86c7, 'GL_NV_evaluators')
GL_EVAL_VERTEX_ATTRIB2_NV = Enumerant('GL_EVAL_VERTEX_ATTRIB2_NV', 0x86c8, 'GL_NV_evaluators')
GL_EVAL_VERTEX_ATTRIB3_NV = Enumerant('GL_EVAL_VERTEX_ATTRIB3_NV', 0x86c9, 'GL_NV_evaluators')
GL_EVAL_VERTEX_ATTRIB4_NV = Enumerant('GL_EVAL_VERTEX_ATTRIB4_NV', 0x86ca, 'GL_NV_evaluators')
GL_EVAL_VERTEX_ATTRIB5_NV = Enumerant('GL_EVAL_VERTEX_ATTRIB5_NV', 0x86cb, 'GL_NV_evaluators')
GL_EVAL_VERTEX_ATTRIB6_NV = Enumerant('GL_EVAL_VERTEX_ATTRIB6_NV', 0x86cc, 'GL_NV_evaluators')
GL_EVAL_VERTEX_ATTRIB7_NV = Enumerant('GL_EVAL_VERTEX_ATTRIB7_NV', 0x86cd, 'GL_NV_evaluators')
GL_EVAL_VERTEX_ATTRIB8_NV = Enumerant('GL_EVAL_VERTEX_ATTRIB8_NV', 0x86ce, 'GL_NV_evaluators')
GL_EVAL_VERTEX_ATTRIB9_NV = Enumerant('GL_EVAL_VERTEX_ATTRIB9_NV', 0x86cf, 'GL_NV_evaluators')
GL_MAP_ATTRIB_U_ORDER_NV = Enumerant('GL_MAP_ATTRIB_U_ORDER_NV', 0x86c3, 'GL_NV_evaluators')
GL_MAP_ATTRIB_V_ORDER_NV = Enumerant('GL_MAP_ATTRIB_V_ORDER_NV', 0x86c4, 'GL_NV_evaluators')
GL_MAP_TESSELLATION_NV = Enumerant('GL_MAP_TESSELLATION_NV', 0x86c2, 'GL_NV_evaluators')
GL_MAX_MAP_TESSELLATION_NV = Enumerant('GL_MAX_MAP_TESSELLATION_NV', 0x86d6, 'GL_NV_evaluators')
GL_MAX_RATIONAL_EVAL_ORDER_NV = Enumerant('GL_MAX_RATIONAL_EVAL_ORDER_NV', 0x86d7, 'GL_NV_evaluators')

defines.add(GL_EVAL_2D_NV)
defines.add(GL_EVAL_FRACTIONAL_TESSELLATION_NV)
defines.add(GL_EVAL_TRIANGULAR_2D_NV)
defines.add(GL_EVAL_VERTEX_ATTRIB0_NV)
defines.add(GL_EVAL_VERTEX_ATTRIB10_NV)
defines.add(GL_EVAL_VERTEX_ATTRIB11_NV)
defines.add(GL_EVAL_VERTEX_ATTRIB12_NV)
defines.add(GL_EVAL_VERTEX_ATTRIB13_NV)
defines.add(GL_EVAL_VERTEX_ATTRIB14_NV)
defines.add(GL_EVAL_VERTEX_ATTRIB15_NV)
defines.add(GL_EVAL_VERTEX_ATTRIB1_NV)
defines.add(GL_EVAL_VERTEX_ATTRIB2_NV)
defines.add(GL_EVAL_VERTEX_ATTRIB3_NV)
defines.add(GL_EVAL_VERTEX_ATTRIB4_NV)
defines.add(GL_EVAL_VERTEX_ATTRIB5_NV)
defines.add(GL_EVAL_VERTEX_ATTRIB6_NV)
defines.add(GL_EVAL_VERTEX_ATTRIB7_NV)
defines.add(GL_EVAL_VERTEX_ATTRIB8_NV)
defines.add(GL_EVAL_VERTEX_ATTRIB9_NV)
defines.add(GL_MAP_ATTRIB_U_ORDER_NV)
defines.add(GL_MAP_ATTRIB_V_ORDER_NV)
defines.add(GL_MAP_TESSELLATION_NV)
defines.add(GL_MAX_MAP_TESSELLATION_NV)
defines.add(GL_MAX_RATIONAL_EVAL_ORDER_NV)

# GL_NV_explicit_multisample

GL_INT_SAMPLER_RENDERBUFFER_NV = Enumerant('GL_INT_SAMPLER_RENDERBUFFER_NV', 0x8e57, 'GL_NV_explicit_multisample')
GL_MAX_SAMPLE_MASK_WORDS_NV = Enumerant('GL_MAX_SAMPLE_MASK_WORDS_NV', 0x8e59, 'GL_NV_explicit_multisample')
GL_SAMPLER_RENDERBUFFER_NV = Enumerant('GL_SAMPLER_RENDERBUFFER_NV', 0x8e56, 'GL_NV_explicit_multisample')
GL_SAMPLE_MASK_NV = Enumerant('GL_SAMPLE_MASK_NV', 0x8e51, 'GL_NV_explicit_multisample')
GL_SAMPLE_MASK_VALUE_NV = Enumerant('GL_SAMPLE_MASK_VALUE_NV', 0x8e52, 'GL_NV_explicit_multisample')
GL_SAMPLE_POSITION_NV = Enumerant('GL_SAMPLE_POSITION_NV', 0x8e50, 'GL_NV_explicit_multisample')
GL_TEXTURE_BINDING_RENDERBUFFER_NV = Enumerant('GL_TEXTURE_BINDING_RENDERBUFFER_NV', 0x8e53, 'GL_NV_explicit_multisample')
GL_TEXTURE_RENDERBUFFER_DATA_STORE_BINDING_NV = Enumerant('GL_TEXTURE_RENDERBUFFER_DATA_STORE_BINDING_NV', 0x8e54, 'GL_NV_explicit_multisample')
GL_TEXTURE_RENDERBUFFER_NV = Enumerant('GL_TEXTURE_RENDERBUFFER_NV', 0x8e55, 'GL_NV_explicit_multisample')
GL_UNSIGNED_INT_SAMPLER_RENDERBUFFER_NV = Enumerant('GL_UNSIGNED_INT_SAMPLER_RENDERBUFFER_NV', 0x8e58, 'GL_NV_explicit_multisample')

defines.add(GL_INT_SAMPLER_RENDERBUFFER_NV)
defines.add(GL_MAX_SAMPLE_MASK_WORDS_NV)
defines.add(GL_SAMPLER_RENDERBUFFER_NV)
defines.add(GL_SAMPLE_MASK_NV)
defines.add(GL_SAMPLE_MASK_VALUE_NV)
defines.add(GL_SAMPLE_POSITION_NV)
defines.add(GL_TEXTURE_BINDING_RENDERBUFFER_NV)
defines.add(GL_TEXTURE_RENDERBUFFER_DATA_STORE_BINDING_NV)
defines.add(GL_TEXTURE_RENDERBUFFER_NV)
defines.add(GL_UNSIGNED_INT_SAMPLER_RENDERBUFFER_NV)

# GL_NV_fbo_color_attachments

GL_COLOR_ATTACHMENT0_NV = Enumerant('GL_COLOR_ATTACHMENT0_NV', 0x8ce0, 'GL_NV_fbo_color_attachments')
GL_COLOR_ATTACHMENT10_NV = Enumerant('GL_COLOR_ATTACHMENT10_NV', 0x8cea, 'GL_NV_fbo_color_attachments')
GL_COLOR_ATTACHMENT11_NV = Enumerant('GL_COLOR_ATTACHMENT11_NV', 0x8ceb, 'GL_NV_fbo_color_attachments')
GL_COLOR_ATTACHMENT12_NV = Enumerant('GL_COLOR_ATTACHMENT12_NV', 0x8cec, 'GL_NV_fbo_color_attachments')
GL_COLOR_ATTACHMENT13_NV = Enumerant('GL_COLOR_ATTACHMENT13_NV', 0x8ced, 'GL_NV_fbo_color_attachments')
GL_COLOR_ATTACHMENT14_NV = Enumerant('GL_COLOR_ATTACHMENT14_NV', 0x8cee, 'GL_NV_fbo_color_attachments')
GL_COLOR_ATTACHMENT15_NV = Enumerant('GL_COLOR_ATTACHMENT15_NV', 0x8cef, 'GL_NV_fbo_color_attachments')
GL_COLOR_ATTACHMENT1_NV = Enumerant('GL_COLOR_ATTACHMENT1_NV', 0x8ce1, 'GL_NV_fbo_color_attachments')
GL_COLOR_ATTACHMENT2_NV = Enumerant('GL_COLOR_ATTACHMENT2_NV', 0x8ce2, 'GL_NV_fbo_color_attachments')
GL_COLOR_ATTACHMENT3_NV = Enumerant('GL_COLOR_ATTACHMENT3_NV', 0x8ce3, 'GL_NV_fbo_color_attachments')
GL_COLOR_ATTACHMENT4_NV = Enumerant('GL_COLOR_ATTACHMENT4_NV', 0x8ce4, 'GL_NV_fbo_color_attachments')
GL_COLOR_ATTACHMENT5_NV = Enumerant('GL_COLOR_ATTACHMENT5_NV', 0x8ce5, 'GL_NV_fbo_color_attachments')
GL_COLOR_ATTACHMENT6_NV = Enumerant('GL_COLOR_ATTACHMENT6_NV', 0x8ce6, 'GL_NV_fbo_color_attachments')
GL_COLOR_ATTACHMENT7_NV = Enumerant('GL_COLOR_ATTACHMENT7_NV', 0x8ce7, 'GL_NV_fbo_color_attachments')
GL_COLOR_ATTACHMENT8_NV = Enumerant('GL_COLOR_ATTACHMENT8_NV', 0x8ce8, 'GL_NV_fbo_color_attachments')
GL_COLOR_ATTACHMENT9_NV = Enumerant('GL_COLOR_ATTACHMENT9_NV', 0x8ce9, 'GL_NV_fbo_color_attachments')
GL_MAX_COLOR_ATTACHMENTS_NV = Enumerant('GL_MAX_COLOR_ATTACHMENTS_NV', 0x8cdf, 'GL_NV_fbo_color_attachments')

defines.add(GL_COLOR_ATTACHMENT0_NV)
defines.add(GL_COLOR_ATTACHMENT10_NV)
defines.add(GL_COLOR_ATTACHMENT11_NV)
defines.add(GL_COLOR_ATTACHMENT12_NV)
defines.add(GL_COLOR_ATTACHMENT13_NV)
defines.add(GL_COLOR_ATTACHMENT14_NV)
defines.add(GL_COLOR_ATTACHMENT15_NV)
defines.add(GL_COLOR_ATTACHMENT1_NV)
defines.add(GL_COLOR_ATTACHMENT2_NV)
defines.add(GL_COLOR_ATTACHMENT3_NV)
defines.add(GL_COLOR_ATTACHMENT4_NV)
defines.add(GL_COLOR_ATTACHMENT5_NV)
defines.add(GL_COLOR_ATTACHMENT6_NV)
defines.add(GL_COLOR_ATTACHMENT7_NV)
defines.add(GL_COLOR_ATTACHMENT8_NV)
defines.add(GL_COLOR_ATTACHMENT9_NV)
defines.add(GL_MAX_COLOR_ATTACHMENTS_NV)

# GL_NV_fence

GL_ALL_COMPLETED_NV = Enumerant('GL_ALL_COMPLETED_NV', 0x84f2, 'GL_NV_fence')
GL_FENCE_CONDITION_NV = Enumerant('GL_FENCE_CONDITION_NV', 0x84f4, 'GL_NV_fence')
GL_FENCE_STATUS_NV = Enumerant('GL_FENCE_STATUS_NV', 0x84f3, 'GL_NV_fence')

defines.add(GL_ALL_COMPLETED_NV)
defines.add(GL_FENCE_CONDITION_NV)
defines.add(GL_FENCE_STATUS_NV)

# GL_NV_float_buffer

GL_FLOAT_CLEAR_COLOR_VALUE_NV = Enumerant('GL_FLOAT_CLEAR_COLOR_VALUE_NV', 0x888d, 'GL_NV_float_buffer')
GL_FLOAT_R16_NV = Enumerant('GL_FLOAT_R16_NV', 0x8884, 'GL_NV_float_buffer')
GL_FLOAT_R32_NV = Enumerant('GL_FLOAT_R32_NV', 0x8885, 'GL_NV_float_buffer')
GL_FLOAT_RG16_NV = Enumerant('GL_FLOAT_RG16_NV', 0x8886, 'GL_NV_float_buffer')
GL_FLOAT_RG32_NV = Enumerant('GL_FLOAT_RG32_NV', 0x8887, 'GL_NV_float_buffer')
GL_FLOAT_RGB16_NV = Enumerant('GL_FLOAT_RGB16_NV', 0x8888, 'GL_NV_float_buffer')
GL_FLOAT_RGB32_NV = Enumerant('GL_FLOAT_RGB32_NV', 0x8889, 'GL_NV_float_buffer')
GL_FLOAT_RGBA16_NV = Enumerant('GL_FLOAT_RGBA16_NV', 0x888a, 'GL_NV_float_buffer')
GL_FLOAT_RGBA32_NV = Enumerant('GL_FLOAT_RGBA32_NV', 0x888b, 'GL_NV_float_buffer')
GL_FLOAT_RGBA_MODE_NV = Enumerant('GL_FLOAT_RGBA_MODE_NV', 0x888e, 'GL_NV_float_buffer')
GL_FLOAT_RGBA_NV = Enumerant('GL_FLOAT_RGBA_NV', 0x8883, 'GL_NV_float_buffer')
GL_FLOAT_RGB_NV = Enumerant('GL_FLOAT_RGB_NV', 0x8882, 'GL_NV_float_buffer')
GL_FLOAT_RG_NV = Enumerant('GL_FLOAT_RG_NV', 0x8881, 'GL_NV_float_buffer')
GL_FLOAT_R_NV = Enumerant('GL_FLOAT_R_NV', 0x8880, 'GL_NV_float_buffer')
GL_TEXTURE_FLOAT_COMPONENTS_NV = Enumerant('GL_TEXTURE_FLOAT_COMPONENTS_NV', 0x888c, 'GL_NV_float_buffer')

defines.add(GL_FLOAT_CLEAR_COLOR_VALUE_NV)
defines.add(GL_FLOAT_R16_NV)
defines.add(GL_FLOAT_R32_NV)
defines.add(GL_FLOAT_RG16_NV)
defines.add(GL_FLOAT_RG32_NV)
defines.add(GL_FLOAT_RGB16_NV)
defines.add(GL_FLOAT_RGB32_NV)
defines.add(GL_FLOAT_RGBA16_NV)
defines.add(GL_FLOAT_RGBA32_NV)
defines.add(GL_FLOAT_RGBA_MODE_NV)
defines.add(GL_FLOAT_RGBA_NV)
defines.add(GL_FLOAT_RGB_NV)
defines.add(GL_FLOAT_RG_NV)
defines.add(GL_FLOAT_R_NV)
defines.add(GL_TEXTURE_FLOAT_COMPONENTS_NV)

# GL_NV_fog_distance

GL_EYE_PLANE_ABSOLUTE_NV = Enumerant('GL_EYE_PLANE_ABSOLUTE_NV', 0x855c, 'GL_NV_fog_distance')
GL_EYE_RADIAL_NV = Enumerant('GL_EYE_RADIAL_NV', 0x855b, 'GL_NV_fog_distance')
GL_FOG_DISTANCE_MODE_NV = Enumerant('GL_FOG_DISTANCE_MODE_NV', 0x855a, 'GL_NV_fog_distance')

defines.add(GL_EYE_PLANE_ABSOLUTE_NV)
defines.add(GL_EYE_RADIAL_NV)
defines.add(GL_FOG_DISTANCE_MODE_NV)

# GL_NV_fragment_program

GL_FRAGMENT_PROGRAM_BINDING_NV = Enumerant('GL_FRAGMENT_PROGRAM_BINDING_NV', 0x8873, 'GL_NV_fragment_program')
GL_FRAGMENT_PROGRAM_NV = Enumerant('GL_FRAGMENT_PROGRAM_NV', 0x8870, 'GL_NV_fragment_program')
GL_MAX_FRAGMENT_PROGRAM_LOCAL_PARAMETERS_NV = Enumerant('GL_MAX_FRAGMENT_PROGRAM_LOCAL_PARAMETERS_NV', 0x8868, 'GL_NV_fragment_program')
GL_MAX_TEXTURE_COORDS_NV = Enumerant('GL_MAX_TEXTURE_COORDS_NV', 0x8871, 'GL_NV_fragment_program')
GL_MAX_TEXTURE_IMAGE_UNITS_NV = Enumerant('GL_MAX_TEXTURE_IMAGE_UNITS_NV', 0x8872, 'GL_NV_fragment_program')
GL_PROGRAM_ERROR_STRING_NV = Enumerant('GL_PROGRAM_ERROR_STRING_NV', 0x8874, 'GL_NV_fragment_program')

defines.add(GL_FRAGMENT_PROGRAM_BINDING_NV)
defines.add(GL_FRAGMENT_PROGRAM_NV)
defines.add(GL_MAX_FRAGMENT_PROGRAM_LOCAL_PARAMETERS_NV)
defines.add(GL_MAX_TEXTURE_COORDS_NV)
defines.add(GL_MAX_TEXTURE_IMAGE_UNITS_NV)
defines.add(GL_PROGRAM_ERROR_STRING_NV)

# GL_NV_fragment_program2

GL_MAX_PROGRAM_IF_DEPTH_NV = Enumerant('GL_MAX_PROGRAM_IF_DEPTH_NV', 0x88f6, 'GL_NV_fragment_program2')
GL_MAX_PROGRAM_LOOP_COUNT_NV = Enumerant('GL_MAX_PROGRAM_LOOP_COUNT_NV', 0x88f8, 'GL_NV_fragment_program2')
GL_MAX_PROGRAM_LOOP_DEPTH_NV = Enumerant('GL_MAX_PROGRAM_LOOP_DEPTH_NV', 0x88f7, 'GL_NV_fragment_program2')

defines.add(GL_MAX_PROGRAM_IF_DEPTH_NV)
defines.add(GL_MAX_PROGRAM_LOOP_COUNT_NV)
defines.add(GL_MAX_PROGRAM_LOOP_DEPTH_NV)

# GL_NV_framebuffer_blit

GL_DRAW_FRAMEBUFFER_BINDING_NV = Enumerant('GL_DRAW_FRAMEBUFFER_BINDING_NV', 0x8ca6, 'GL_NV_framebuffer_blit')
GL_DRAW_FRAMEBUFFER_NV = Enumerant('GL_DRAW_FRAMEBUFFER_NV', 0x8ca9, 'GL_NV_framebuffer_blit')
GL_READ_FRAMEBUFFER_BINDING_NV = Enumerant('GL_READ_FRAMEBUFFER_BINDING_NV', 0x8caa, 'GL_NV_framebuffer_blit')
GL_READ_FRAMEBUFFER_NV = Enumerant('GL_READ_FRAMEBUFFER_NV', 0x8ca8, 'GL_NV_framebuffer_blit')

defines.add(GL_DRAW_FRAMEBUFFER_BINDING_NV)
defines.add(GL_DRAW_FRAMEBUFFER_NV)
defines.add(GL_READ_FRAMEBUFFER_BINDING_NV)
defines.add(GL_READ_FRAMEBUFFER_NV)

# GL_NV_framebuffer_multisample

GL_FRAMEBUFFER_INCOMPLETE_MULTISAMPLE_NV = Enumerant('GL_FRAMEBUFFER_INCOMPLETE_MULTISAMPLE_NV', 0x8d56, 'GL_NV_framebuffer_multisample')
GL_MAX_SAMPLES_NV = Enumerant('GL_MAX_SAMPLES_NV', 0x8d57, 'GL_NV_framebuffer_multisample')
GL_RENDERBUFFER_SAMPLES_NV = Enumerant('GL_RENDERBUFFER_SAMPLES_NV', 0x8cab, 'GL_NV_framebuffer_multisample')

defines.add(GL_FRAMEBUFFER_INCOMPLETE_MULTISAMPLE_NV)
defines.add(GL_MAX_SAMPLES_NV)
defines.add(GL_RENDERBUFFER_SAMPLES_NV)

# GL_NV_framebuffer_multisample_coverage

GL_MAX_MULTISAMPLE_COVERAGE_MODES_NV = Enumerant('GL_MAX_MULTISAMPLE_COVERAGE_MODES_NV', 0x8e11, 'GL_NV_framebuffer_multisample_coverage')
GL_MULTISAMPLE_COVERAGE_MODES_NV = Enumerant('GL_MULTISAMPLE_COVERAGE_MODES_NV', 0x8e12, 'GL_NV_framebuffer_multisample_coverage')
GL_RENDERBUFFER_COLOR_SAMPLES_NV = Enumerant('GL_RENDERBUFFER_COLOR_SAMPLES_NV', 0x8e10, 'GL_NV_framebuffer_multisample_coverage')
GL_RENDERBUFFER_COVERAGE_SAMPLES_NV = Enumerant('GL_RENDERBUFFER_COVERAGE_SAMPLES_NV', 0x8cab, 'GL_NV_framebuffer_multisample_coverage')

defines.add(GL_MAX_MULTISAMPLE_COVERAGE_MODES_NV)
defines.add(GL_MULTISAMPLE_COVERAGE_MODES_NV)
defines.add(GL_RENDERBUFFER_COLOR_SAMPLES_NV)
defines.add(GL_RENDERBUFFER_COVERAGE_SAMPLES_NV)

# GL_NV_geometry_program4

GL_GEOMETRY_PROGRAM_NV = Enumerant('GL_GEOMETRY_PROGRAM_NV', 0x8c26, 'GL_NV_geometry_program4')
GL_MAX_PROGRAM_OUTPUT_VERTICES_NV = Enumerant('GL_MAX_PROGRAM_OUTPUT_VERTICES_NV', 0x8c27, 'GL_NV_geometry_program4')
GL_MAX_PROGRAM_TOTAL_OUTPUT_COMPONENTS_NV = Enumerant('GL_MAX_PROGRAM_TOTAL_OUTPUT_COMPONENTS_NV', 0x8c28, 'GL_NV_geometry_program4')

defines.add(GL_GEOMETRY_PROGRAM_NV)
defines.add(GL_MAX_PROGRAM_OUTPUT_VERTICES_NV)
defines.add(GL_MAX_PROGRAM_TOTAL_OUTPUT_COMPONENTS_NV)

# GL_NV_gpu_program4

GL_MAX_PROGRAM_ATTRIB_COMPONENTS_NV = Enumerant('GL_MAX_PROGRAM_ATTRIB_COMPONENTS_NV', 0x8908, 'GL_NV_gpu_program4')
GL_MAX_PROGRAM_GENERIC_ATTRIBS_NV = Enumerant('GL_MAX_PROGRAM_GENERIC_ATTRIBS_NV', 0x8da5, 'GL_NV_gpu_program4')
GL_MAX_PROGRAM_GENERIC_RESULTS_NV = Enumerant('GL_MAX_PROGRAM_GENERIC_RESULTS_NV', 0x8da6, 'GL_NV_gpu_program4')
GL_MAX_PROGRAM_RESULT_COMPONENTS_NV = Enumerant('GL_MAX_PROGRAM_RESULT_COMPONENTS_NV', 0x8909, 'GL_NV_gpu_program4')
GL_MAX_PROGRAM_TEXEL_OFFSET_NV = Enumerant('GL_MAX_PROGRAM_TEXEL_OFFSET_NV', 0x8905, 'GL_NV_gpu_program4')
GL_MIN_PROGRAM_TEXEL_OFFSET_NV = Enumerant('GL_MIN_PROGRAM_TEXEL_OFFSET_NV', 0x8904, 'GL_NV_gpu_program4')
GL_PROGRAM_ATTRIB_COMPONENTS_NV = Enumerant('GL_PROGRAM_ATTRIB_COMPONENTS_NV', 0x8906, 'GL_NV_gpu_program4')
GL_PROGRAM_RESULT_COMPONENTS_NV = Enumerant('GL_PROGRAM_RESULT_COMPONENTS_NV', 0x8907, 'GL_NV_gpu_program4')

defines.add(GL_MAX_PROGRAM_ATTRIB_COMPONENTS_NV)
defines.add(GL_MAX_PROGRAM_GENERIC_ATTRIBS_NV)
defines.add(GL_MAX_PROGRAM_GENERIC_RESULTS_NV)
defines.add(GL_MAX_PROGRAM_RESULT_COMPONENTS_NV)
defines.add(GL_MAX_PROGRAM_TEXEL_OFFSET_NV)
defines.add(GL_MIN_PROGRAM_TEXEL_OFFSET_NV)
defines.add(GL_PROGRAM_ATTRIB_COMPONENTS_NV)
defines.add(GL_PROGRAM_RESULT_COMPONENTS_NV)

# GL_NV_gpu_program5

GL_FRAGMENT_PROGRAM_INTERPOLATION_OFFSET_BITS_NV = Enumerant('GL_FRAGMENT_PROGRAM_INTERPOLATION_OFFSET_BITS_NV', 0x8e5d, 'GL_NV_gpu_program5')
GL_MAX_FRAGMENT_INTERPOLATION_OFFSET_NV = Enumerant('GL_MAX_FRAGMENT_INTERPOLATION_OFFSET_NV', 0x8e5c, 'GL_NV_gpu_program5')
GL_MAX_GEOMETRY_PROGRAM_INVOCATIONS_NV = Enumerant('GL_MAX_GEOMETRY_PROGRAM_INVOCATIONS_NV', 0x8e5a, 'GL_NV_gpu_program5')
GL_MIN_FRAGMENT_INTERPOLATION_OFFSET_NV = Enumerant('GL_MIN_FRAGMENT_INTERPOLATION_OFFSET_NV', 0x8e5b, 'GL_NV_gpu_program5')

defines.add(GL_FRAGMENT_PROGRAM_INTERPOLATION_OFFSET_BITS_NV)
defines.add(GL_MAX_FRAGMENT_INTERPOLATION_OFFSET_NV)
defines.add(GL_MAX_GEOMETRY_PROGRAM_INVOCATIONS_NV)
defines.add(GL_MIN_FRAGMENT_INTERPOLATION_OFFSET_NV)

# GL_NV_gpu_shader5

GL_FLOAT16_NV = Enumerant('GL_FLOAT16_NV', 0x8ff8, 'GL_NV_gpu_shader5')
GL_FLOAT16_VEC2_NV = Enumerant('GL_FLOAT16_VEC2_NV', 0x8ff9, 'GL_NV_gpu_shader5')
GL_FLOAT16_VEC3_NV = Enumerant('GL_FLOAT16_VEC3_NV', 0x8ffa, 'GL_NV_gpu_shader5')
GL_FLOAT16_VEC4_NV = Enumerant('GL_FLOAT16_VEC4_NV', 0x8ffb, 'GL_NV_gpu_shader5')
GL_INT16_NV = Enumerant('GL_INT16_NV', 0x8fe4, 'GL_NV_gpu_shader5')
GL_INT16_VEC2_NV = Enumerant('GL_INT16_VEC2_NV', 0x8fe5, 'GL_NV_gpu_shader5')
GL_INT16_VEC3_NV = Enumerant('GL_INT16_VEC3_NV', 0x8fe6, 'GL_NV_gpu_shader5')
GL_INT16_VEC4_NV = Enumerant('GL_INT16_VEC4_NV', 0x8fe7, 'GL_NV_gpu_shader5')
GL_INT64_VEC2_NV = Enumerant('GL_INT64_VEC2_NV', 0x8fe9, 'GL_NV_gpu_shader5')
GL_INT64_VEC3_NV = Enumerant('GL_INT64_VEC3_NV', 0x8fea, 'GL_NV_gpu_shader5')
GL_INT64_VEC4_NV = Enumerant('GL_INT64_VEC4_NV', 0x8feb, 'GL_NV_gpu_shader5')
GL_INT8_NV = Enumerant('GL_INT8_NV', 0x8fe0, 'GL_NV_gpu_shader5')
GL_INT8_VEC2_NV = Enumerant('GL_INT8_VEC2_NV', 0x8fe1, 'GL_NV_gpu_shader5')
GL_INT8_VEC3_NV = Enumerant('GL_INT8_VEC3_NV', 0x8fe2, 'GL_NV_gpu_shader5')
GL_INT8_VEC4_NV = Enumerant('GL_INT8_VEC4_NV', 0x8fe3, 'GL_NV_gpu_shader5')
GL_UNSIGNED_INT16_NV = Enumerant('GL_UNSIGNED_INT16_NV', 0x8ff0, 'GL_NV_gpu_shader5')
GL_UNSIGNED_INT16_VEC2_NV = Enumerant('GL_UNSIGNED_INT16_VEC2_NV', 0x8ff1, 'GL_NV_gpu_shader5')
GL_UNSIGNED_INT16_VEC3_NV = Enumerant('GL_UNSIGNED_INT16_VEC3_NV', 0x8ff2, 'GL_NV_gpu_shader5')
GL_UNSIGNED_INT16_VEC4_NV = Enumerant('GL_UNSIGNED_INT16_VEC4_NV', 0x8ff3, 'GL_NV_gpu_shader5')
GL_UNSIGNED_INT64_VEC2_NV = Enumerant('GL_UNSIGNED_INT64_VEC2_NV', 0x8ff5, 'GL_NV_gpu_shader5')
GL_UNSIGNED_INT64_VEC3_NV = Enumerant('GL_UNSIGNED_INT64_VEC3_NV', 0x8ff6, 'GL_NV_gpu_shader5')
GL_UNSIGNED_INT64_VEC4_NV = Enumerant('GL_UNSIGNED_INT64_VEC4_NV', 0x8ff7, 'GL_NV_gpu_shader5')
GL_UNSIGNED_INT8_NV = Enumerant('GL_UNSIGNED_INT8_NV', 0x8fec, 'GL_NV_gpu_shader5')
GL_UNSIGNED_INT8_VEC2_NV = Enumerant('GL_UNSIGNED_INT8_VEC2_NV', 0x8fed, 'GL_NV_gpu_shader5')
GL_UNSIGNED_INT8_VEC3_NV = Enumerant('GL_UNSIGNED_INT8_VEC3_NV', 0x8fee, 'GL_NV_gpu_shader5')
GL_UNSIGNED_INT8_VEC4_NV = Enumerant('GL_UNSIGNED_INT8_VEC4_NV', 0x8fef, 'GL_NV_gpu_shader5')

defines.add(GL_FLOAT16_NV)
defines.add(GL_FLOAT16_VEC2_NV)
defines.add(GL_FLOAT16_VEC3_NV)
defines.add(GL_FLOAT16_VEC4_NV)
defines.add(GL_INT16_NV)
defines.add(GL_INT16_VEC2_NV)
defines.add(GL_INT16_VEC3_NV)
defines.add(GL_INT16_VEC4_NV)
defines.add(GL_INT64_VEC2_NV)
defines.add(GL_INT64_VEC3_NV)
defines.add(GL_INT64_VEC4_NV)
defines.add(GL_INT8_NV)
defines.add(GL_INT8_VEC2_NV)
defines.add(GL_INT8_VEC3_NV)
defines.add(GL_INT8_VEC4_NV)
defines.add(GL_UNSIGNED_INT16_NV)
defines.add(GL_UNSIGNED_INT16_VEC2_NV)
defines.add(GL_UNSIGNED_INT16_VEC3_NV)
defines.add(GL_UNSIGNED_INT16_VEC4_NV)
defines.add(GL_UNSIGNED_INT64_VEC2_NV)
defines.add(GL_UNSIGNED_INT64_VEC3_NV)
defines.add(GL_UNSIGNED_INT64_VEC4_NV)
defines.add(GL_UNSIGNED_INT8_NV)
defines.add(GL_UNSIGNED_INT8_VEC2_NV)
defines.add(GL_UNSIGNED_INT8_VEC3_NV)
defines.add(GL_UNSIGNED_INT8_VEC4_NV)

# GL_NV_half_float

GL_HALF_FLOAT_NV = Enumerant('GL_HALF_FLOAT_NV', 0x140b, 'GL_NV_half_float')

defines.add(GL_HALF_FLOAT_NV)

# GL_NV_instanced_arrays

GL_VERTEX_ATTRIB_ARRAY_DIVISOR_NV = Enumerant('GL_VERTEX_ATTRIB_ARRAY_DIVISOR_NV', 0x88fe, 'GL_NV_instanced_arrays')

defines.add(GL_VERTEX_ATTRIB_ARRAY_DIVISOR_NV)

# GL_NV_light_max_exponent

GL_MAX_SHININESS_NV = Enumerant('GL_MAX_SHININESS_NV', 0x8504, 'GL_NV_light_max_exponent')
GL_MAX_SPOT_EXPONENT_NV = Enumerant('GL_MAX_SPOT_EXPONENT_NV', 0x8505, 'GL_NV_light_max_exponent')

defines.add(GL_MAX_SHININESS_NV)
defines.add(GL_MAX_SPOT_EXPONENT_NV)

# GL_NV_multisample_coverage

GL_COLOR_SAMPLES_NV = Enumerant('GL_COLOR_SAMPLES_NV', 0x8e20, 'GL_NV_multisample_coverage')
GL_COVERAGE_SAMPLES_NV = Enumerant('GL_COVERAGE_SAMPLES_NV', 0x80a9, 'GL_NV_multisample_coverage')

defines.add(GL_COLOR_SAMPLES_NV)
defines.add(GL_COVERAGE_SAMPLES_NV)

# GL_NV_multisample_filter_hint

GL_MULTISAMPLE_FILTER_HINT_NV = Enumerant('GL_MULTISAMPLE_FILTER_HINT_NV', 0x8534, 'GL_NV_multisample_filter_hint')

defines.add(GL_MULTISAMPLE_FILTER_HINT_NV)

# GL_NV_non_square_matrices

GL_FLOAT_MAT2x3_NV = Enumerant('GL_FLOAT_MAT2x3_NV', 0x8b65, 'GL_NV_non_square_matrices')
GL_FLOAT_MAT2x4_NV = Enumerant('GL_FLOAT_MAT2x4_NV', 0x8b66, 'GL_NV_non_square_matrices')
GL_FLOAT_MAT3x2_NV = Enumerant('GL_FLOAT_MAT3x2_NV', 0x8b67, 'GL_NV_non_square_matrices')
GL_FLOAT_MAT3x4_NV = Enumerant('GL_FLOAT_MAT3x4_NV', 0x8b68, 'GL_NV_non_square_matrices')
GL_FLOAT_MAT4x2_NV = Enumerant('GL_FLOAT_MAT4x2_NV', 0x8b69, 'GL_NV_non_square_matrices')
GL_FLOAT_MAT4x3_NV = Enumerant('GL_FLOAT_MAT4x3_NV', 0x8b6a, 'GL_NV_non_square_matrices')

defines.add(GL_FLOAT_MAT2x3_NV)
defines.add(GL_FLOAT_MAT2x4_NV)
defines.add(GL_FLOAT_MAT3x2_NV)
defines.add(GL_FLOAT_MAT3x4_NV)
defines.add(GL_FLOAT_MAT4x2_NV)
defines.add(GL_FLOAT_MAT4x3_NV)

# GL_NV_occlusion_query

GL_CURRENT_OCCLUSION_QUERY_ID_NV = Enumerant('GL_CURRENT_OCCLUSION_QUERY_ID_NV', 0x8865, 'GL_NV_occlusion_query')
GL_PIXEL_COUNTER_BITS_NV = Enumerant('GL_PIXEL_COUNTER_BITS_NV', 0x8864, 'GL_NV_occlusion_query')
GL_PIXEL_COUNT_AVAILABLE_NV = Enumerant('GL_PIXEL_COUNT_AVAILABLE_NV', 0x8867, 'GL_NV_occlusion_query')
GL_PIXEL_COUNT_NV = Enumerant('GL_PIXEL_COUNT_NV', 0x8866, 'GL_NV_occlusion_query')

defines.add(GL_CURRENT_OCCLUSION_QUERY_ID_NV)
defines.add(GL_PIXEL_COUNTER_BITS_NV)
defines.add(GL_PIXEL_COUNT_AVAILABLE_NV)
defines.add(GL_PIXEL_COUNT_NV)

# GL_NV_pack_subimage

GL_PACK_ROW_LENGTH_NV = Enumerant('GL_PACK_ROW_LENGTH_NV', 0x0d02, 'GL_NV_pack_subimage')
GL_PACK_SKIP_PIXELS_NV = Enumerant('GL_PACK_SKIP_PIXELS_NV', 0x0d04, 'GL_NV_pack_subimage')
GL_PACK_SKIP_ROWS_NV = Enumerant('GL_PACK_SKIP_ROWS_NV', 0x0d03, 'GL_NV_pack_subimage')

defines.add(GL_PACK_ROW_LENGTH_NV)
defines.add(GL_PACK_SKIP_PIXELS_NV)
defines.add(GL_PACK_SKIP_ROWS_NV)

# GL_NV_packed_depth_stencil

GL_DEPTH_STENCIL_NV = Enumerant('GL_DEPTH_STENCIL_NV', 0x84f9, 'GL_NV_packed_depth_stencil')
GL_UNSIGNED_INT_24_8_NV = Enumerant('GL_UNSIGNED_INT_24_8_NV', 0x84fa, 'GL_NV_packed_depth_stencil')

defines.add(GL_DEPTH_STENCIL_NV)
defines.add(GL_UNSIGNED_INT_24_8_NV)

# GL_NV_packed_float_linear

GL_R11F_G11F_B10F_NV = Enumerant('GL_R11F_G11F_B10F_NV', 0x8c3a, 'GL_NV_packed_float_linear')
GL_UNSIGNED_INT_10F_11F_11F_REV_NV = Enumerant('GL_UNSIGNED_INT_10F_11F_11F_REV_NV', 0x8c3b, 'GL_NV_packed_float_linear')

defines.add(GL_R11F_G11F_B10F_NV)
defines.add(GL_UNSIGNED_INT_10F_11F_11F_REV_NV)

# GL_NV_parameter_buffer_object

GL_FRAGMENT_PROGRAM_PARAMETER_BUFFER_NV = Enumerant('GL_FRAGMENT_PROGRAM_PARAMETER_BUFFER_NV', 0x8da4, 'GL_NV_parameter_buffer_object')
GL_GEOMETRY_PROGRAM_PARAMETER_BUFFER_NV = Enumerant('GL_GEOMETRY_PROGRAM_PARAMETER_BUFFER_NV', 0x8da3, 'GL_NV_parameter_buffer_object')
GL_MAX_PROGRAM_PARAMETER_BUFFER_BINDINGS_NV = Enumerant('GL_MAX_PROGRAM_PARAMETER_BUFFER_BINDINGS_NV', 0x8da0, 'GL_NV_parameter_buffer_object')
GL_MAX_PROGRAM_PARAMETER_BUFFER_SIZE_NV = Enumerant('GL_MAX_PROGRAM_PARAMETER_BUFFER_SIZE_NV', 0x8da1, 'GL_NV_parameter_buffer_object')
GL_VERTEX_PROGRAM_PARAMETER_BUFFER_NV = Enumerant('GL_VERTEX_PROGRAM_PARAMETER_BUFFER_NV', 0x8da2, 'GL_NV_parameter_buffer_object')

defines.add(GL_FRAGMENT_PROGRAM_PARAMETER_BUFFER_NV)
defines.add(GL_GEOMETRY_PROGRAM_PARAMETER_BUFFER_NV)
defines.add(GL_MAX_PROGRAM_PARAMETER_BUFFER_BINDINGS_NV)
defines.add(GL_MAX_PROGRAM_PARAMETER_BUFFER_SIZE_NV)
defines.add(GL_VERTEX_PROGRAM_PARAMETER_BUFFER_NV)

# GL_NV_path_rendering

GL_ACCUM_ADJACENT_PAIRS_NV = Enumerant('GL_ACCUM_ADJACENT_PAIRS_NV', 0x90ad, 'GL_NV_path_rendering')
GL_ADJACENT_PAIRS_NV = Enumerant('GL_ADJACENT_PAIRS_NV', 0x90ae, 'GL_NV_path_rendering')
GL_AFFINE_2D_NV = Enumerant('GL_AFFINE_2D_NV', 0x9092, 'GL_NV_path_rendering')
GL_AFFINE_3D_NV = Enumerant('GL_AFFINE_3D_NV', 0x9094, 'GL_NV_path_rendering')
GL_ARC_TO_NV = Enumerant('GL_ARC_TO_NV', 0x00fe, 'GL_NV_path_rendering')
GL_ARC_TO_NV.group = ['pathCommand']
GL_ARC_TO_NV.alias = ['A']
GL_BEVEL_NV = Enumerant('GL_BEVEL_NV', 0x90a6, 'GL_NV_path_rendering')
GL_BOLD_BIT_NV = Enumerant('GL_BOLD_BIT_NV', 0x0001, 'GL_NV_path_rendering')
GL_BOUNDING_BOX_NV = Enumerant('GL_BOUNDING_BOX_NV', 0x908d, 'GL_NV_path_rendering')
GL_BOUNDING_BOX_OF_BOUNDING_BOXES_NV = Enumerant('GL_BOUNDING_BOX_OF_BOUNDING_BOXES_NV', 0x909c, 'GL_NV_path_rendering')
GL_CIRCULAR_CCW_ARC_TO_NV = Enumerant('GL_CIRCULAR_CCW_ARC_TO_NV', 0x00f8, 'GL_NV_path_rendering')
GL_CIRCULAR_CCW_ARC_TO_NV.group = ['pathCommand']
GL_CIRCULAR_CW_ARC_TO_NV = Enumerant('GL_CIRCULAR_CW_ARC_TO_NV', 0x00fa, 'GL_NV_path_rendering')
GL_CIRCULAR_CW_ARC_TO_NV.group = ['pathCommand']
GL_CIRCULAR_TANGENT_ARC_TO_NV = Enumerant('GL_CIRCULAR_TANGENT_ARC_TO_NV', 0x00fc, 'GL_NV_path_rendering')
GL_CIRCULAR_TANGENT_ARC_TO_NV.group = ['pathCommand']
GL_CLOSE_PATH_NV = Enumerant('GL_CLOSE_PATH_NV', 0x0000, 'GL_NV_path_rendering')
GL_CLOSE_PATH_NV.group = ['pathCommand']
GL_CLOSE_PATH_NV.alias = ['z','Z']
GL_CONVEX_HULL_NV = Enumerant('GL_CONVEX_HULL_NV', 0x908b, 'GL_NV_path_rendering')
GL_COUNT_DOWN_NV = Enumerant('GL_COUNT_DOWN_NV', 0x9089, 'GL_NV_path_rendering')
GL_COUNT_UP_NV = Enumerant('GL_COUNT_UP_NV', 0x9088, 'GL_NV_path_rendering')
GL_CUBIC_CURVE_TO_NV = Enumerant('GL_CUBIC_CURVE_TO_NV', 0x000c, 'GL_NV_path_rendering')
GL_CUBIC_CURVE_TO_NV.group = ['pathCommand']
GL_CUBIC_CURVE_TO_NV.alias = ['C']
GL_DUP_FIRST_CUBIC_CURVE_TO_NV = Enumerant('GL_DUP_FIRST_CUBIC_CURVE_TO_NV', 0x00f2, 'GL_NV_path_rendering')
GL_DUP_FIRST_CUBIC_CURVE_TO_NV.group = ['pathCommand']
GL_DUP_LAST_CUBIC_CURVE_TO_NV = Enumerant('GL_DUP_LAST_CUBIC_CURVE_TO_NV', 0x00f4, 'GL_NV_path_rendering')
GL_DUP_LAST_CUBIC_CURVE_TO_NV.group = ['pathCommand']
GL_FILE_NAME_NV = Enumerant('GL_FILE_NAME_NV', 0x9074, 'GL_NV_path_rendering')
GL_FIRST_TO_REST_NV = Enumerant('GL_FIRST_TO_REST_NV', 0x90af, 'GL_NV_path_rendering')
GL_FONT_ASCENDER_BIT_NV = Enumerant('GL_FONT_ASCENDER_BIT_NV', 0x200000, 'GL_NV_path_rendering')
GL_FONT_DESCENDER_BIT_NV = Enumerant('GL_FONT_DESCENDER_BIT_NV', 0x400000, 'GL_NV_path_rendering')
GL_FONT_HAS_KERNING_BIT_NV = Enumerant('GL_FONT_HAS_KERNING_BIT_NV', 0x10000000, 'GL_NV_path_rendering')
GL_FONT_HEIGHT_BIT_NV = Enumerant('GL_FONT_HEIGHT_BIT_NV', 0x800000, 'GL_NV_path_rendering')
GL_FONT_MAX_ADVANCE_HEIGHT_BIT_NV = Enumerant('GL_FONT_MAX_ADVANCE_HEIGHT_BIT_NV', 0x2000000, 'GL_NV_path_rendering')
GL_FONT_MAX_ADVANCE_WIDTH_BIT_NV = Enumerant('GL_FONT_MAX_ADVANCE_WIDTH_BIT_NV', 0x1000000, 'GL_NV_path_rendering')
GL_FONT_UNDERLINE_POSITION_BIT_NV = Enumerant('GL_FONT_UNDERLINE_POSITION_BIT_NV', 0x4000000, 'GL_NV_path_rendering')
GL_FONT_UNDERLINE_THICKNESS_BIT_NV = Enumerant('GL_FONT_UNDERLINE_THICKNESS_BIT_NV', 0x8000000, 'GL_NV_path_rendering')
GL_FONT_UNITS_PER_EM_BIT_NV = Enumerant('GL_FONT_UNITS_PER_EM_BIT_NV', 0x100000, 'GL_NV_path_rendering')
GL_FONT_X_MAX_BOUNDS_BIT_NV = Enumerant('GL_FONT_X_MAX_BOUNDS_BIT_NV', 0x40000, 'GL_NV_path_rendering')
GL_FONT_X_MIN_BOUNDS_BIT_NV = Enumerant('GL_FONT_X_MIN_BOUNDS_BIT_NV', 0x10000, 'GL_NV_path_rendering')
GL_FONT_Y_MAX_BOUNDS_BIT_NV = Enumerant('GL_FONT_Y_MAX_BOUNDS_BIT_NV', 0x80000, 'GL_NV_path_rendering')
GL_FONT_Y_MIN_BOUNDS_BIT_NV = Enumerant('GL_FONT_Y_MIN_BOUNDS_BIT_NV', 0x20000, 'GL_NV_path_rendering')
GL_GLYPH_HAS_KERNING_BIT_NV = Enumerant('GL_GLYPH_HAS_KERNING_BIT_NV', 0x0100, 'GL_NV_path_rendering')
GL_GLYPH_HEIGHT_BIT_NV = Enumerant('GL_GLYPH_HEIGHT_BIT_NV', 0x0002, 'GL_NV_path_rendering')
GL_GLYPH_HORIZONTAL_BEARING_ADVANCE_BIT_NV = Enumerant('GL_GLYPH_HORIZONTAL_BEARING_ADVANCE_BIT_NV', 0x0010, 'GL_NV_path_rendering')
GL_GLYPH_HORIZONTAL_BEARING_X_BIT_NV = Enumerant('GL_GLYPH_HORIZONTAL_BEARING_X_BIT_NV', 0x0004, 'GL_NV_path_rendering')
GL_GLYPH_HORIZONTAL_BEARING_Y_BIT_NV = Enumerant('GL_GLYPH_HORIZONTAL_BEARING_Y_BIT_NV', 0x0008, 'GL_NV_path_rendering')
GL_GLYPH_VERTICAL_BEARING_ADVANCE_BIT_NV = Enumerant('GL_GLYPH_VERTICAL_BEARING_ADVANCE_BIT_NV', 0x0080, 'GL_NV_path_rendering')
GL_GLYPH_VERTICAL_BEARING_X_BIT_NV = Enumerant('GL_GLYPH_VERTICAL_BEARING_X_BIT_NV', 0x0020, 'GL_NV_path_rendering')
GL_GLYPH_VERTICAL_BEARING_Y_BIT_NV = Enumerant('GL_GLYPH_VERTICAL_BEARING_Y_BIT_NV', 0x0040, 'GL_NV_path_rendering')
GL_GLYPH_WIDTH_BIT_NV = Enumerant('GL_GLYPH_WIDTH_BIT_NV', 0x0001, 'GL_NV_path_rendering')
GL_HORIZONTAL_LINE_TO_NV = Enumerant('GL_HORIZONTAL_LINE_TO_NV', 0x0006, 'GL_NV_path_rendering')
GL_HORIZONTAL_LINE_TO_NV.group = ['pathCommand']
GL_HORIZONTAL_LINE_TO_NV.alias = ['H']
GL_ITALIC_BIT_NV = Enumerant('GL_ITALIC_BIT_NV', 0x0002, 'GL_NV_path_rendering')
GL_LARGE_CCW_ARC_TO_NV = Enumerant('GL_LARGE_CCW_ARC_TO_NV', 0x0016, 'GL_NV_path_rendering')
GL_LARGE_CCW_ARC_TO_NV.group = ['pathCommand']
GL_LARGE_CW_ARC_TO_NV = Enumerant('GL_LARGE_CW_ARC_TO_NV', 0x0018, 'GL_NV_path_rendering')
GL_LARGE_CW_ARC_TO_NV.group = ['pathCommand']
GL_LINE_TO_NV = Enumerant('GL_LINE_TO_NV', 0x0004, 'GL_NV_path_rendering')
GL_LINE_TO_NV.group = ['pathCommand']
GL_LINE_TO_NV.alias = ['L']
GL_MITER_REVERT_NV = Enumerant('GL_MITER_REVERT_NV', 0x90a7, 'GL_NV_path_rendering')
GL_MITER_TRUNCATE_NV = Enumerant('GL_MITER_TRUNCATE_NV', 0x90a8, 'GL_NV_path_rendering')
GL_MOVE_TO_CONTINUES_NV = Enumerant('GL_MOVE_TO_CONTINUES_NV', 0x90b6, 'GL_NV_path_rendering')
GL_MOVE_TO_NV = Enumerant('GL_MOVE_TO_NV', 0x0002, 'GL_NV_path_rendering')
GL_MOVE_TO_NV.group = ['pathCommand']
GL_MOVE_TO_NV.alias = ['M']
GL_MOVE_TO_RESETS_NV = Enumerant('GL_MOVE_TO_RESETS_NV', 0x90b5, 'GL_NV_path_rendering')
GL_PATH_CLIENT_LENGTH_NV = Enumerant('GL_PATH_CLIENT_LENGTH_NV', 0x907f, 'GL_NV_path_rendering')
GL_PATH_COMMAND_COUNT_NV = Enumerant('GL_PATH_COMMAND_COUNT_NV', 0x909d, 'GL_NV_path_rendering')
GL_PATH_COMPUTED_LENGTH_NV = Enumerant('GL_PATH_COMPUTED_LENGTH_NV', 0x90a0, 'GL_NV_path_rendering')
GL_PATH_COORD_COUNT_NV = Enumerant('GL_PATH_COORD_COUNT_NV', 0x909e, 'GL_NV_path_rendering')
GL_PATH_COVER_DEPTH_FUNC_NV = Enumerant('GL_PATH_COVER_DEPTH_FUNC_NV', 0x90bf, 'GL_NV_path_rendering')
GL_PATH_DASH_ARRAY_COUNT_NV = Enumerant('GL_PATH_DASH_ARRAY_COUNT_NV', 0x909f, 'GL_NV_path_rendering')
GL_PATH_DASH_CAPS_NV = Enumerant('GL_PATH_DASH_CAPS_NV', 0x907b, 'GL_NV_path_rendering')
GL_PATH_DASH_OFFSET_NV = Enumerant('GL_PATH_DASH_OFFSET_NV', 0x907e, 'GL_NV_path_rendering')
GL_PATH_DASH_OFFSET_RESET_NV = Enumerant('GL_PATH_DASH_OFFSET_RESET_NV', 0x90b4, 'GL_NV_path_rendering')
GL_PATH_END_CAPS_NV = Enumerant('GL_PATH_END_CAPS_NV', 0x9076, 'GL_NV_path_rendering')
GL_PATH_ERROR_POSITION_NV = Enumerant('GL_PATH_ERROR_POSITION_NV', 0x90ab, 'GL_NV_path_rendering')
GL_PATH_FILL_BOUNDING_BOX_NV = Enumerant('GL_PATH_FILL_BOUNDING_BOX_NV', 0x90a1, 'GL_NV_path_rendering')
GL_PATH_FILL_COVER_MODE_NV = Enumerant('GL_PATH_FILL_COVER_MODE_NV', 0x9082, 'GL_NV_path_rendering')
GL_PATH_FILL_MASK_NV = Enumerant('GL_PATH_FILL_MASK_NV', 0x9081, 'GL_NV_path_rendering')
GL_PATH_FILL_MODE_NV = Enumerant('GL_PATH_FILL_MODE_NV', 0x9080, 'GL_NV_path_rendering')
GL_PATH_FOG_GEN_MODE_NV = Enumerant('GL_PATH_FOG_GEN_MODE_NV', 0x90ac, 'GL_NV_path_rendering')
GL_PATH_FORMAT_PS_NV = Enumerant('GL_PATH_FORMAT_PS_NV', 0x9071, 'GL_NV_path_rendering')
GL_PATH_FORMAT_SVG_NV = Enumerant('GL_PATH_FORMAT_SVG_NV', 0x9070, 'GL_NV_path_rendering')
GL_PATH_GEN_COEFF_NV = Enumerant('GL_PATH_GEN_COEFF_NV', 0x90b1, 'GL_NV_path_rendering')
GL_PATH_GEN_COLOR_FORMAT_NV = Enumerant('GL_PATH_GEN_COLOR_FORMAT_NV', 0x90b2, 'GL_NV_path_rendering')
GL_PATH_GEN_COMPONENTS_NV = Enumerant('GL_PATH_GEN_COMPONENTS_NV', 0x90b3, 'GL_NV_path_rendering')
GL_PATH_GEN_MODE_NV = Enumerant('GL_PATH_GEN_MODE_NV', 0x90b0, 'GL_NV_path_rendering')
GL_PATH_INITIAL_DASH_CAP_NV = Enumerant('GL_PATH_INITIAL_DASH_CAP_NV', 0x907c, 'GL_NV_path_rendering')
GL_PATH_INITIAL_END_CAP_NV = Enumerant('GL_PATH_INITIAL_END_CAP_NV', 0x9077, 'GL_NV_path_rendering')
GL_PATH_JOIN_STYLE_NV = Enumerant('GL_PATH_JOIN_STYLE_NV', 0x9079, 'GL_NV_path_rendering')
GL_PATH_MITER_LIMIT_NV = Enumerant('GL_PATH_MITER_LIMIT_NV', 0x907a, 'GL_NV_path_rendering')
GL_PATH_OBJECT_BOUNDING_BOX_NV = Enumerant('GL_PATH_OBJECT_BOUNDING_BOX_NV', 0x908a, 'GL_NV_path_rendering')
GL_PATH_STENCIL_DEPTH_OFFSET_FACTOR_NV = Enumerant('GL_PATH_STENCIL_DEPTH_OFFSET_FACTOR_NV', 0x90bd, 'GL_NV_path_rendering')
GL_PATH_STENCIL_DEPTH_OFFSET_UNITS_NV = Enumerant('GL_PATH_STENCIL_DEPTH_OFFSET_UNITS_NV', 0x90be, 'GL_NV_path_rendering')
GL_PATH_STENCIL_FUNC_NV = Enumerant('GL_PATH_STENCIL_FUNC_NV', 0x90b7, 'GL_NV_path_rendering')
GL_PATH_STENCIL_REF_NV = Enumerant('GL_PATH_STENCIL_REF_NV', 0x90b8, 'GL_NV_path_rendering')
GL_PATH_STENCIL_VALUE_MASK_NV = Enumerant('GL_PATH_STENCIL_VALUE_MASK_NV', 0x90b9, 'GL_NV_path_rendering')
GL_PATH_STROKE_BOUNDING_BOX_NV = Enumerant('GL_PATH_STROKE_BOUNDING_BOX_NV', 0x90a2, 'GL_NV_path_rendering')
GL_PATH_STROKE_COVER_MODE_NV = Enumerant('GL_PATH_STROKE_COVER_MODE_NV', 0x9083, 'GL_NV_path_rendering')
GL_PATH_STROKE_MASK_NV = Enumerant('GL_PATH_STROKE_MASK_NV', 0x9084, 'GL_NV_path_rendering')
GL_PATH_STROKE_WIDTH_NV = Enumerant('GL_PATH_STROKE_WIDTH_NV', 0x9075, 'GL_NV_path_rendering')
GL_PATH_TERMINAL_DASH_CAP_NV = Enumerant('GL_PATH_TERMINAL_DASH_CAP_NV', 0x907d, 'GL_NV_path_rendering')
GL_PATH_TERMINAL_END_CAP_NV = Enumerant('GL_PATH_TERMINAL_END_CAP_NV', 0x9078, 'GL_NV_path_rendering')
GL_QUADRATIC_CURVE_TO_NV = Enumerant('GL_QUADRATIC_CURVE_TO_NV', 0x000a, 'GL_NV_path_rendering')
GL_QUADRATIC_CURVE_TO_NV.group = ['pathCommand']
GL_QUADRATIC_CURVE_TO_NV.alias = ['Q']
GL_RECT_NV = Enumerant('GL_RECT_NV', 0x00f6, 'GL_NV_path_rendering')
GL_RECT_NV.group = ['pathCommand']
GL_RELATIVE_ARC_TO_NV = Enumerant('GL_RELATIVE_ARC_TO_NV', 0x00ff, 'GL_NV_path_rendering')
GL_RELATIVE_ARC_TO_NV.group = ['pathCommand']
GL_RELATIVE_ARC_TO_NV.alias = ['a']
GL_RELATIVE_CUBIC_CURVE_TO_NV = Enumerant('GL_RELATIVE_CUBIC_CURVE_TO_NV', 0x000d, 'GL_NV_path_rendering')
GL_RELATIVE_CUBIC_CURVE_TO_NV.group = ['pathCommand']
GL_RELATIVE_CUBIC_CURVE_TO_NV.alias = ['c']
GL_RELATIVE_HORIZONTAL_LINE_TO_NV = Enumerant('GL_RELATIVE_HORIZONTAL_LINE_TO_NV', 0x0007, 'GL_NV_path_rendering')
GL_RELATIVE_HORIZONTAL_LINE_TO_NV.group = ['pathCommand']
GL_RELATIVE_HORIZONTAL_LINE_TO_NV.alias = ['h']
GL_RELATIVE_LARGE_CCW_ARC_TO_NV = Enumerant('GL_RELATIVE_LARGE_CCW_ARC_TO_NV', 0x0017, 'GL_NV_path_rendering')
GL_RELATIVE_LARGE_CCW_ARC_TO_NV.group = ['pathCommand']
GL_RELATIVE_LARGE_CW_ARC_TO_NV = Enumerant('GL_RELATIVE_LARGE_CW_ARC_TO_NV', 0x0019, 'GL_NV_path_rendering')
GL_RELATIVE_LARGE_CW_ARC_TO_NV.group = ['pathCommand']
GL_RELATIVE_LINE_TO_NV = Enumerant('GL_RELATIVE_LINE_TO_NV', 0x0005, 'GL_NV_path_rendering')
GL_RELATIVE_LINE_TO_NV.group = ['pathCommand']
GL_RELATIVE_LINE_TO_NV.alias = ['l']
GL_RELATIVE_MOVE_TO_NV = Enumerant('GL_RELATIVE_MOVE_TO_NV', 0x0003, 'GL_NV_path_rendering')
GL_RELATIVE_MOVE_TO_NV.group = ['pathCommand']
GL_RELATIVE_MOVE_TO_NV.alias = ['m']
GL_RELATIVE_QUADRATIC_CURVE_TO_NV = Enumerant('GL_RELATIVE_QUADRATIC_CURVE_TO_NV', 0x000b, 'GL_NV_path_rendering')
GL_RELATIVE_QUADRATIC_CURVE_TO_NV.group = ['pathCommand']
GL_RELATIVE_QUADRATIC_CURVE_TO_NV.alias = ['q']
GL_RELATIVE_SMALL_CCW_ARC_TO_NV = Enumerant('GL_RELATIVE_SMALL_CCW_ARC_TO_NV', 0x0013, 'GL_NV_path_rendering')
GL_RELATIVE_SMALL_CCW_ARC_TO_NV.group = ['pathCommand']
GL_RELATIVE_SMALL_CW_ARC_TO_NV = Enumerant('GL_RELATIVE_SMALL_CW_ARC_TO_NV', 0x0015, 'GL_NV_path_rendering')
GL_RELATIVE_SMALL_CW_ARC_TO_NV.group = ['pathCommand']
GL_RELATIVE_SMOOTH_CUBIC_CURVE_TO_NV = Enumerant('GL_RELATIVE_SMOOTH_CUBIC_CURVE_TO_NV', 0x0011, 'GL_NV_path_rendering')
GL_RELATIVE_SMOOTH_CUBIC_CURVE_TO_NV.group = ['pathCommand']
GL_RELATIVE_SMOOTH_CUBIC_CURVE_TO_NV.alias = ['s']
GL_RELATIVE_SMOOTH_QUADRATIC_CURVE_TO_NV = Enumerant('GL_RELATIVE_SMOOTH_QUADRATIC_CURVE_TO_NV', 0x000f, 'GL_NV_path_rendering')
GL_RELATIVE_SMOOTH_QUADRATIC_CURVE_TO_NV.group = ['pathCommand']
GL_RELATIVE_SMOOTH_QUADRATIC_CURVE_TO_NV.alias = ['t']
GL_RELATIVE_VERTICAL_LINE_TO_NV = Enumerant('GL_RELATIVE_VERTICAL_LINE_TO_NV', 0x0009, 'GL_NV_path_rendering')
GL_RELATIVE_VERTICAL_LINE_TO_NV.group = ['pathCommand']
GL_RELATIVE_VERTICAL_LINE_TO_NV.alias = ['v']
GL_RESTART_PATH_NV = Enumerant('GL_RESTART_PATH_NV', 0x00f0, 'GL_NV_path_rendering')
GL_RESTART_PATH_NV.group = ['pathCommand']
GL_ROUND_NV = Enumerant('GL_ROUND_NV', 0x90a4, 'GL_NV_path_rendering')
GL_SKIP_MISSING_GLYPH_NV = Enumerant('GL_SKIP_MISSING_GLYPH_NV', 0x90a9, 'GL_NV_path_rendering')
GL_SMALL_CCW_ARC_TO_NV = Enumerant('GL_SMALL_CCW_ARC_TO_NV', 0x0012, 'GL_NV_path_rendering')
GL_SMALL_CCW_ARC_TO_NV.group = ['pathCommand']
GL_SMALL_CW_ARC_TO_NV = Enumerant('GL_SMALL_CW_ARC_TO_NV', 0x0014, 'GL_NV_path_rendering')
GL_SMALL_CW_ARC_TO_NV.group = ['pathCommand']
GL_SMOOTH_CUBIC_CURVE_TO_NV = Enumerant('GL_SMOOTH_CUBIC_CURVE_TO_NV', 0x0010, 'GL_NV_path_rendering')
GL_SMOOTH_CUBIC_CURVE_TO_NV.group = ['pathCommand']
GL_SMOOTH_CUBIC_CURVE_TO_NV.alias = ['S']
GL_SMOOTH_QUADRATIC_CURVE_TO_NV = Enumerant('GL_SMOOTH_QUADRATIC_CURVE_TO_NV', 0x000e, 'GL_NV_path_rendering')
GL_SMOOTH_QUADRATIC_CURVE_TO_NV.group = ['pathCommand']
GL_SMOOTH_QUADRATIC_CURVE_TO_NV.alias = ['T']
GL_SQUARE_NV = Enumerant('GL_SQUARE_NV', 0x90a3, 'GL_NV_path_rendering')
GL_STANDARD_FONT_NAME_NV = Enumerant('GL_STANDARD_FONT_NAME_NV', 0x9072, 'GL_NV_path_rendering')
GL_SYSTEM_FONT_NAME_NV = Enumerant('GL_SYSTEM_FONT_NAME_NV', 0x9073, 'GL_NV_path_rendering')
GL_TRANSLATE_2D_NV = Enumerant('GL_TRANSLATE_2D_NV', 0x9090, 'GL_NV_path_rendering')
GL_TRANSLATE_3D_NV = Enumerant('GL_TRANSLATE_3D_NV', 0x9091, 'GL_NV_path_rendering')
GL_TRANSLATE_X_NV = Enumerant('GL_TRANSLATE_X_NV', 0x908e, 'GL_NV_path_rendering')
GL_TRANSLATE_Y_NV = Enumerant('GL_TRANSLATE_Y_NV', 0x908f, 'GL_NV_path_rendering')
GL_TRANSPOSE_AFFINE_2D_NV = Enumerant('GL_TRANSPOSE_AFFINE_2D_NV', 0x9096, 'GL_NV_path_rendering')
GL_TRANSPOSE_AFFINE_3D_NV = Enumerant('GL_TRANSPOSE_AFFINE_3D_NV', 0x9098, 'GL_NV_path_rendering')
GL_TRIANGULAR_NV = Enumerant('GL_TRIANGULAR_NV', 0x90a5, 'GL_NV_path_rendering')
GL_USE_MISSING_GLYPH_NV = Enumerant('GL_USE_MISSING_GLYPH_NV', 0x90aa, 'GL_NV_path_rendering')
GL_UTF16_NV = Enumerant('GL_UTF16_NV', 0x909b, 'GL_NV_path_rendering')
GL_UTF8_NV = Enumerant('GL_UTF8_NV', 0x909a, 'GL_NV_path_rendering')
GL_VERTICAL_LINE_TO_NV = Enumerant('GL_VERTICAL_LINE_TO_NV', 0x0008, 'GL_NV_path_rendering')
GL_VERTICAL_LINE_TO_NV.group = ['pathCommand']
GL_VERTICAL_LINE_TO_NV.alias = ['V']

defines.add(GL_ACCUM_ADJACENT_PAIRS_NV)
defines.add(GL_ADJACENT_PAIRS_NV)
defines.add(GL_AFFINE_2D_NV)
defines.add(GL_AFFINE_3D_NV)
defines.add(GL_ARC_TO_NV)
defines.add(GL_BEVEL_NV)
defines.add(GL_BOLD_BIT_NV)
defines.add(GL_BOUNDING_BOX_NV)
defines.add(GL_BOUNDING_BOX_OF_BOUNDING_BOXES_NV)
defines.add(GL_CIRCULAR_CCW_ARC_TO_NV)
defines.add(GL_CIRCULAR_CW_ARC_TO_NV)
defines.add(GL_CIRCULAR_TANGENT_ARC_TO_NV)
defines.add(GL_CLOSE_PATH_NV)
defines.add(GL_CONVEX_HULL_NV)
defines.add(GL_COUNT_DOWN_NV)
defines.add(GL_COUNT_UP_NV)
defines.add(GL_CUBIC_CURVE_TO_NV)
defines.add(GL_DUP_FIRST_CUBIC_CURVE_TO_NV)
defines.add(GL_DUP_LAST_CUBIC_CURVE_TO_NV)
defines.add(GL_FILE_NAME_NV)
defines.add(GL_FIRST_TO_REST_NV)
defines.add(GL_FONT_ASCENDER_BIT_NV)
defines.add(GL_FONT_DESCENDER_BIT_NV)
defines.add(GL_FONT_HAS_KERNING_BIT_NV)
defines.add(GL_FONT_HEIGHT_BIT_NV)
defines.add(GL_FONT_MAX_ADVANCE_HEIGHT_BIT_NV)
defines.add(GL_FONT_MAX_ADVANCE_WIDTH_BIT_NV)
defines.add(GL_FONT_UNDERLINE_POSITION_BIT_NV)
defines.add(GL_FONT_UNDERLINE_THICKNESS_BIT_NV)
defines.add(GL_FONT_UNITS_PER_EM_BIT_NV)
defines.add(GL_FONT_X_MAX_BOUNDS_BIT_NV)
defines.add(GL_FONT_X_MIN_BOUNDS_BIT_NV)
defines.add(GL_FONT_Y_MAX_BOUNDS_BIT_NV)
defines.add(GL_FONT_Y_MIN_BOUNDS_BIT_NV)
defines.add(GL_GLYPH_HAS_KERNING_BIT_NV)
defines.add(GL_GLYPH_HEIGHT_BIT_NV)
defines.add(GL_GLYPH_HORIZONTAL_BEARING_ADVANCE_BIT_NV)
defines.add(GL_GLYPH_HORIZONTAL_BEARING_X_BIT_NV)
defines.add(GL_GLYPH_HORIZONTAL_BEARING_Y_BIT_NV)
defines.add(GL_GLYPH_VERTICAL_BEARING_ADVANCE_BIT_NV)
defines.add(GL_GLYPH_VERTICAL_BEARING_X_BIT_NV)
defines.add(GL_GLYPH_VERTICAL_BEARING_Y_BIT_NV)
defines.add(GL_GLYPH_WIDTH_BIT_NV)
defines.add(GL_HORIZONTAL_LINE_TO_NV)
defines.add(GL_ITALIC_BIT_NV)
defines.add(GL_LARGE_CCW_ARC_TO_NV)
defines.add(GL_LARGE_CW_ARC_TO_NV)
defines.add(GL_LINE_TO_NV)
defines.add(GL_MITER_REVERT_NV)
defines.add(GL_MITER_TRUNCATE_NV)
defines.add(GL_MOVE_TO_CONTINUES_NV)
defines.add(GL_MOVE_TO_NV)
defines.add(GL_MOVE_TO_RESETS_NV)
defines.add(GL_PATH_CLIENT_LENGTH_NV)
defines.add(GL_PATH_COMMAND_COUNT_NV)
defines.add(GL_PATH_COMPUTED_LENGTH_NV)
defines.add(GL_PATH_COORD_COUNT_NV)
defines.add(GL_PATH_COVER_DEPTH_FUNC_NV)
defines.add(GL_PATH_DASH_ARRAY_COUNT_NV)
defines.add(GL_PATH_DASH_CAPS_NV)
defines.add(GL_PATH_DASH_OFFSET_NV)
defines.add(GL_PATH_DASH_OFFSET_RESET_NV)
defines.add(GL_PATH_END_CAPS_NV)
defines.add(GL_PATH_ERROR_POSITION_NV)
defines.add(GL_PATH_FILL_BOUNDING_BOX_NV)
defines.add(GL_PATH_FILL_COVER_MODE_NV)
defines.add(GL_PATH_FILL_MASK_NV)
defines.add(GL_PATH_FILL_MODE_NV)
defines.add(GL_PATH_FOG_GEN_MODE_NV)
defines.add(GL_PATH_FORMAT_PS_NV)
defines.add(GL_PATH_FORMAT_SVG_NV)
defines.add(GL_PATH_GEN_COEFF_NV)
defines.add(GL_PATH_GEN_COLOR_FORMAT_NV)
defines.add(GL_PATH_GEN_COMPONENTS_NV)
defines.add(GL_PATH_GEN_MODE_NV)
defines.add(GL_PATH_INITIAL_DASH_CAP_NV)
defines.add(GL_PATH_INITIAL_END_CAP_NV)
defines.add(GL_PATH_JOIN_STYLE_NV)
defines.add(GL_PATH_MITER_LIMIT_NV)
defines.add(GL_PATH_OBJECT_BOUNDING_BOX_NV)
defines.add(GL_PATH_STENCIL_DEPTH_OFFSET_FACTOR_NV)
defines.add(GL_PATH_STENCIL_DEPTH_OFFSET_UNITS_NV)
defines.add(GL_PATH_STENCIL_FUNC_NV)
defines.add(GL_PATH_STENCIL_REF_NV)
defines.add(GL_PATH_STENCIL_VALUE_MASK_NV)
defines.add(GL_PATH_STROKE_BOUNDING_BOX_NV)
defines.add(GL_PATH_STROKE_COVER_MODE_NV)
defines.add(GL_PATH_STROKE_MASK_NV)
defines.add(GL_PATH_STROKE_WIDTH_NV)
defines.add(GL_PATH_TERMINAL_DASH_CAP_NV)
defines.add(GL_PATH_TERMINAL_END_CAP_NV)
defines.add(GL_QUADRATIC_CURVE_TO_NV)
defines.add(GL_RECT_NV)
defines.add(GL_RELATIVE_ARC_TO_NV)
defines.add(GL_RELATIVE_CUBIC_CURVE_TO_NV)
defines.add(GL_RELATIVE_HORIZONTAL_LINE_TO_NV)
defines.add(GL_RELATIVE_LARGE_CCW_ARC_TO_NV)
defines.add(GL_RELATIVE_LARGE_CW_ARC_TO_NV)
defines.add(GL_RELATIVE_LINE_TO_NV)
defines.add(GL_RELATIVE_MOVE_TO_NV)
defines.add(GL_RELATIVE_QUADRATIC_CURVE_TO_NV)
defines.add(GL_RELATIVE_SMALL_CCW_ARC_TO_NV)
defines.add(GL_RELATIVE_SMALL_CW_ARC_TO_NV)
defines.add(GL_RELATIVE_SMOOTH_CUBIC_CURVE_TO_NV)
defines.add(GL_RELATIVE_SMOOTH_QUADRATIC_CURVE_TO_NV)
defines.add(GL_RELATIVE_VERTICAL_LINE_TO_NV)
defines.add(GL_RESTART_PATH_NV)
defines.add(GL_ROUND_NV)
defines.add(GL_SKIP_MISSING_GLYPH_NV)
defines.add(GL_SMALL_CCW_ARC_TO_NV)
defines.add(GL_SMALL_CW_ARC_TO_NV)
defines.add(GL_SMOOTH_CUBIC_CURVE_TO_NV)
defines.add(GL_SMOOTH_QUADRATIC_CURVE_TO_NV)
defines.add(GL_SQUARE_NV)
defines.add(GL_STANDARD_FONT_NAME_NV)
defines.add(GL_SYSTEM_FONT_NAME_NV)
defines.add(GL_TRANSLATE_2D_NV)
defines.add(GL_TRANSLATE_3D_NV)
defines.add(GL_TRANSLATE_X_NV)
defines.add(GL_TRANSLATE_Y_NV)
defines.add(GL_TRANSPOSE_AFFINE_2D_NV)
defines.add(GL_TRANSPOSE_AFFINE_3D_NV)
defines.add(GL_TRIANGULAR_NV)
defines.add(GL_USE_MISSING_GLYPH_NV)
defines.add(GL_UTF16_NV)
defines.add(GL_UTF8_NV)
defines.add(GL_VERTICAL_LINE_TO_NV)

# GL_NV_pixel_buffer_object

GL_PIXEL_PACK_BUFFER_BINDING_NV = Enumerant('GL_PIXEL_PACK_BUFFER_BINDING_NV', 0x88ed, 'GL_NV_pixel_buffer_object')
GL_PIXEL_PACK_BUFFER_NV = Enumerant('GL_PIXEL_PACK_BUFFER_NV', 0x88eb, 'GL_NV_pixel_buffer_object')
GL_PIXEL_UNPACK_BUFFER_BINDING_NV = Enumerant('GL_PIXEL_UNPACK_BUFFER_BINDING_NV', 0x88ef, 'GL_NV_pixel_buffer_object')
GL_PIXEL_UNPACK_BUFFER_NV = Enumerant('GL_PIXEL_UNPACK_BUFFER_NV', 0x88ec, 'GL_NV_pixel_buffer_object')

defines.add(GL_PIXEL_PACK_BUFFER_BINDING_NV)
defines.add(GL_PIXEL_PACK_BUFFER_NV)
defines.add(GL_PIXEL_UNPACK_BUFFER_BINDING_NV)
defines.add(GL_PIXEL_UNPACK_BUFFER_NV)

# GL_NV_pixel_data_range

GL_READ_PIXEL_DATA_RANGE_LENGTH_NV = Enumerant('GL_READ_PIXEL_DATA_RANGE_LENGTH_NV', 0x887b, 'GL_NV_pixel_data_range')
GL_READ_PIXEL_DATA_RANGE_NV = Enumerant('GL_READ_PIXEL_DATA_RANGE_NV', 0x8879, 'GL_NV_pixel_data_range')
GL_READ_PIXEL_DATA_RANGE_POINTER_NV = Enumerant('GL_READ_PIXEL_DATA_RANGE_POINTER_NV', 0x887d, 'GL_NV_pixel_data_range')
GL_WRITE_PIXEL_DATA_RANGE_LENGTH_NV = Enumerant('GL_WRITE_PIXEL_DATA_RANGE_LENGTH_NV', 0x887a, 'GL_NV_pixel_data_range')
GL_WRITE_PIXEL_DATA_RANGE_NV = Enumerant('GL_WRITE_PIXEL_DATA_RANGE_NV', 0x8878, 'GL_NV_pixel_data_range')
GL_WRITE_PIXEL_DATA_RANGE_POINTER_NV = Enumerant('GL_WRITE_PIXEL_DATA_RANGE_POINTER_NV', 0x887c, 'GL_NV_pixel_data_range')

defines.add(GL_READ_PIXEL_DATA_RANGE_LENGTH_NV)
defines.add(GL_READ_PIXEL_DATA_RANGE_NV)
defines.add(GL_READ_PIXEL_DATA_RANGE_POINTER_NV)
defines.add(GL_WRITE_PIXEL_DATA_RANGE_LENGTH_NV)
defines.add(GL_WRITE_PIXEL_DATA_RANGE_NV)
defines.add(GL_WRITE_PIXEL_DATA_RANGE_POINTER_NV)

# GL_NV_platform_binary

GL_NVIDIA_PLATFORM_BINARY_NV = Enumerant('GL_NVIDIA_PLATFORM_BINARY_NV', 0x890b, 'GL_NV_platform_binary')

defines.add(GL_NVIDIA_PLATFORM_BINARY_NV)

# GL_NV_point_sprite

GL_COORD_REPLACE_NV = Enumerant('GL_COORD_REPLACE_NV', 0x8862, 'GL_NV_point_sprite')
GL_POINT_SPRITE_NV = Enumerant('GL_POINT_SPRITE_NV', 0x8861, 'GL_NV_point_sprite')
GL_POINT_SPRITE_R_MODE_NV = Enumerant('GL_POINT_SPRITE_R_MODE_NV', 0x8863, 'GL_NV_point_sprite')

defines.add(GL_COORD_REPLACE_NV)
defines.add(GL_POINT_SPRITE_NV)
defines.add(GL_POINT_SPRITE_R_MODE_NV)

# GL_NV_present_video

GL_CURRENT_TIME_NV = Enumerant('GL_CURRENT_TIME_NV', 0x8e28, 'GL_NV_present_video')
GL_FIELDS_NV = Enumerant('GL_FIELDS_NV', 0x8e27, 'GL_NV_present_video')
GL_FRAME_NV = Enumerant('GL_FRAME_NV', 0x8e26, 'GL_NV_present_video')
GL_NUM_FILL_STREAMS_NV = Enumerant('GL_NUM_FILL_STREAMS_NV', 0x8e29, 'GL_NV_present_video')
GL_PRESENT_DURATION_NV = Enumerant('GL_PRESENT_DURATION_NV', 0x8e2b, 'GL_NV_present_video')
GL_PRESENT_TIME_NV = Enumerant('GL_PRESENT_TIME_NV', 0x8e2a, 'GL_NV_present_video')

defines.add(GL_CURRENT_TIME_NV)
defines.add(GL_FIELDS_NV)
defines.add(GL_FRAME_NV)
defines.add(GL_NUM_FILL_STREAMS_NV)
defines.add(GL_PRESENT_DURATION_NV)
defines.add(GL_PRESENT_TIME_NV)

# GL_NV_primitive_restart

GL_PRIMITIVE_RESTART_INDEX_NV = Enumerant('GL_PRIMITIVE_RESTART_INDEX_NV', 0x8559, 'GL_NV_primitive_restart')
GL_PRIMITIVE_RESTART_NV = Enumerant('GL_PRIMITIVE_RESTART_NV', 0x8558, 'GL_NV_primitive_restart')

defines.add(GL_PRIMITIVE_RESTART_INDEX_NV)
defines.add(GL_PRIMITIVE_RESTART_NV)

# GL_NV_read_buffer_front

GL_READ_BUFFER_NV = Enumerant('GL_READ_BUFFER_NV', 0x0c02, 'GL_NV_read_buffer_front')

defines.add(GL_READ_BUFFER_NV)

# GL_NV_register_combiners

GL_BIAS_BY_NEGATIVE_ONE_HALF_NV = Enumerant('GL_BIAS_BY_NEGATIVE_ONE_HALF_NV', 0x8541, 'GL_NV_register_combiners')
GL_COLOR_SUM_CLAMP_NV = Enumerant('GL_COLOR_SUM_CLAMP_NV', 0x854f, 'GL_NV_register_combiners')
GL_COMBINER0_NV = Enumerant('GL_COMBINER0_NV', 0x8550, 'GL_NV_register_combiners')
GL_COMBINER1_NV = Enumerant('GL_COMBINER1_NV', 0x8551, 'GL_NV_register_combiners')
GL_COMBINER2_NV = Enumerant('GL_COMBINER2_NV', 0x8552, 'GL_NV_register_combiners')
GL_COMBINER3_NV = Enumerant('GL_COMBINER3_NV', 0x8553, 'GL_NV_register_combiners')
GL_COMBINER4_NV = Enumerant('GL_COMBINER4_NV', 0x8554, 'GL_NV_register_combiners')
GL_COMBINER5_NV = Enumerant('GL_COMBINER5_NV', 0x8555, 'GL_NV_register_combiners')
GL_COMBINER6_NV = Enumerant('GL_COMBINER6_NV', 0x8556, 'GL_NV_register_combiners')
GL_COMBINER7_NV = Enumerant('GL_COMBINER7_NV', 0x8557, 'GL_NV_register_combiners')
GL_COMBINER_AB_DOT_PRODUCT_NV = Enumerant('GL_COMBINER_AB_DOT_PRODUCT_NV', 0x8545, 'GL_NV_register_combiners')
GL_COMBINER_AB_OUTPUT_NV = Enumerant('GL_COMBINER_AB_OUTPUT_NV', 0x854a, 'GL_NV_register_combiners')
GL_COMBINER_BIAS_NV = Enumerant('GL_COMBINER_BIAS_NV', 0x8549, 'GL_NV_register_combiners')
GL_COMBINER_CD_DOT_PRODUCT_NV = Enumerant('GL_COMBINER_CD_DOT_PRODUCT_NV', 0x8546, 'GL_NV_register_combiners')
GL_COMBINER_CD_OUTPUT_NV = Enumerant('GL_COMBINER_CD_OUTPUT_NV', 0x854b, 'GL_NV_register_combiners')
GL_COMBINER_COMPONENT_USAGE_NV = Enumerant('GL_COMBINER_COMPONENT_USAGE_NV', 0x8544, 'GL_NV_register_combiners')
GL_COMBINER_INPUT_NV = Enumerant('GL_COMBINER_INPUT_NV', 0x8542, 'GL_NV_register_combiners')
GL_COMBINER_MAPPING_NV = Enumerant('GL_COMBINER_MAPPING_NV', 0x8543, 'GL_NV_register_combiners')
GL_COMBINER_MUX_SUM_NV = Enumerant('GL_COMBINER_MUX_SUM_NV', 0x8547, 'GL_NV_register_combiners')
GL_COMBINER_SCALE_NV = Enumerant('GL_COMBINER_SCALE_NV', 0x8548, 'GL_NV_register_combiners')
GL_COMBINER_SUM_OUTPUT_NV = Enumerant('GL_COMBINER_SUM_OUTPUT_NV', 0x854c, 'GL_NV_register_combiners')
GL_CONSTANT_COLOR0_NV = Enumerant('GL_CONSTANT_COLOR0_NV', 0x852a, 'GL_NV_register_combiners')
GL_CONSTANT_COLOR1_NV = Enumerant('GL_CONSTANT_COLOR1_NV', 0x852b, 'GL_NV_register_combiners')
GL_DISCARD_NV = Enumerant('GL_DISCARD_NV', 0x8530, 'GL_NV_register_combiners')
GL_EXPAND_NEGATE_NV = Enumerant('GL_EXPAND_NEGATE_NV', 0x8539, 'GL_NV_register_combiners')
GL_EXPAND_NORMAL_NV = Enumerant('GL_EXPAND_NORMAL_NV', 0x8538, 'GL_NV_register_combiners')
GL_E_TIMES_F_NV = Enumerant('GL_E_TIMES_F_NV', 0x8531, 'GL_NV_register_combiners')
GL_HALF_BIAS_NEGATE_NV = Enumerant('GL_HALF_BIAS_NEGATE_NV', 0x853b, 'GL_NV_register_combiners')
GL_HALF_BIAS_NORMAL_NV = Enumerant('GL_HALF_BIAS_NORMAL_NV', 0x853a, 'GL_NV_register_combiners')
GL_MAX_GENERAL_COMBINERS_NV = Enumerant('GL_MAX_GENERAL_COMBINERS_NV', 0x854d, 'GL_NV_register_combiners')
GL_NUM_GENERAL_COMBINERS_NV = Enumerant('GL_NUM_GENERAL_COMBINERS_NV', 0x854e, 'GL_NV_register_combiners')
GL_PRIMARY_COLOR_NV = Enumerant('GL_PRIMARY_COLOR_NV', 0x852c, 'GL_NV_register_combiners')
GL_REGISTER_COMBINERS_NV = Enumerant('GL_REGISTER_COMBINERS_NV', 0x8522, 'GL_NV_register_combiners')
GL_SCALE_BY_FOUR_NV = Enumerant('GL_SCALE_BY_FOUR_NV', 0x853f, 'GL_NV_register_combiners')
GL_SCALE_BY_ONE_HALF_NV = Enumerant('GL_SCALE_BY_ONE_HALF_NV', 0x8540, 'GL_NV_register_combiners')
GL_SCALE_BY_TWO_NV = Enumerant('GL_SCALE_BY_TWO_NV', 0x853e, 'GL_NV_register_combiners')
GL_SECONDARY_COLOR_NV = Enumerant('GL_SECONDARY_COLOR_NV', 0x852d, 'GL_NV_register_combiners')
GL_SIGNED_IDENTITY_NV = Enumerant('GL_SIGNED_IDENTITY_NV', 0x853c, 'GL_NV_register_combiners')
GL_SIGNED_NEGATE_NV = Enumerant('GL_SIGNED_NEGATE_NV', 0x853d, 'GL_NV_register_combiners')
GL_SPARE0_NV = Enumerant('GL_SPARE0_NV', 0x852e, 'GL_NV_register_combiners')
GL_SPARE0_PLUS_SECONDARY_COLOR_NV = Enumerant('GL_SPARE0_PLUS_SECONDARY_COLOR_NV', 0x8532, 'GL_NV_register_combiners')
GL_SPARE1_NV = Enumerant('GL_SPARE1_NV', 0x852f, 'GL_NV_register_combiners')
GL_UNSIGNED_IDENTITY_NV = Enumerant('GL_UNSIGNED_IDENTITY_NV', 0x8536, 'GL_NV_register_combiners')
GL_UNSIGNED_INVERT_NV = Enumerant('GL_UNSIGNED_INVERT_NV', 0x8537, 'GL_NV_register_combiners')
GL_VARIABLE_A_NV = Enumerant('GL_VARIABLE_A_NV', 0x8523, 'GL_NV_register_combiners')
GL_VARIABLE_B_NV = Enumerant('GL_VARIABLE_B_NV', 0x8524, 'GL_NV_register_combiners')
GL_VARIABLE_C_NV = Enumerant('GL_VARIABLE_C_NV', 0x8525, 'GL_NV_register_combiners')
GL_VARIABLE_D_NV = Enumerant('GL_VARIABLE_D_NV', 0x8526, 'GL_NV_register_combiners')
GL_VARIABLE_E_NV = Enumerant('GL_VARIABLE_E_NV', 0x8527, 'GL_NV_register_combiners')
GL_VARIABLE_F_NV = Enumerant('GL_VARIABLE_F_NV', 0x8528, 'GL_NV_register_combiners')
GL_VARIABLE_G_NV = Enumerant('GL_VARIABLE_G_NV', 0x8529, 'GL_NV_register_combiners')

defines.add(GL_BIAS_BY_NEGATIVE_ONE_HALF_NV)
defines.add(GL_COLOR_SUM_CLAMP_NV)
defines.add(GL_COMBINER0_NV)
defines.add(GL_COMBINER1_NV)
defines.add(GL_COMBINER2_NV)
defines.add(GL_COMBINER3_NV)
defines.add(GL_COMBINER4_NV)
defines.add(GL_COMBINER5_NV)
defines.add(GL_COMBINER6_NV)
defines.add(GL_COMBINER7_NV)
defines.add(GL_COMBINER_AB_DOT_PRODUCT_NV)
defines.add(GL_COMBINER_AB_OUTPUT_NV)
defines.add(GL_COMBINER_BIAS_NV)
defines.add(GL_COMBINER_CD_DOT_PRODUCT_NV)
defines.add(GL_COMBINER_CD_OUTPUT_NV)
defines.add(GL_COMBINER_COMPONENT_USAGE_NV)
defines.add(GL_COMBINER_INPUT_NV)
defines.add(GL_COMBINER_MAPPING_NV)
defines.add(GL_COMBINER_MUX_SUM_NV)
defines.add(GL_COMBINER_SCALE_NV)
defines.add(GL_COMBINER_SUM_OUTPUT_NV)
defines.add(GL_CONSTANT_COLOR0_NV)
defines.add(GL_CONSTANT_COLOR1_NV)
defines.add(GL_DISCARD_NV)
defines.add(GL_EXPAND_NEGATE_NV)
defines.add(GL_EXPAND_NORMAL_NV)
defines.add(GL_E_TIMES_F_NV)
defines.add(GL_HALF_BIAS_NEGATE_NV)
defines.add(GL_HALF_BIAS_NORMAL_NV)
defines.add(GL_MAX_GENERAL_COMBINERS_NV)
defines.add(GL_NUM_GENERAL_COMBINERS_NV)
defines.add(GL_PRIMARY_COLOR_NV)
defines.add(GL_REGISTER_COMBINERS_NV)
defines.add(GL_SCALE_BY_FOUR_NV)
defines.add(GL_SCALE_BY_ONE_HALF_NV)
defines.add(GL_SCALE_BY_TWO_NV)
defines.add(GL_SECONDARY_COLOR_NV)
defines.add(GL_SIGNED_IDENTITY_NV)
defines.add(GL_SIGNED_NEGATE_NV)
defines.add(GL_SPARE0_NV)
defines.add(GL_SPARE0_PLUS_SECONDARY_COLOR_NV)
defines.add(GL_SPARE1_NV)
defines.add(GL_UNSIGNED_IDENTITY_NV)
defines.add(GL_UNSIGNED_INVERT_NV)
defines.add(GL_VARIABLE_A_NV)
defines.add(GL_VARIABLE_B_NV)
defines.add(GL_VARIABLE_C_NV)
defines.add(GL_VARIABLE_D_NV)
defines.add(GL_VARIABLE_E_NV)
defines.add(GL_VARIABLE_F_NV)
defines.add(GL_VARIABLE_G_NV)

# GL_NV_register_combiners2

GL_PER_STAGE_CONSTANTS_NV = Enumerant('GL_PER_STAGE_CONSTANTS_NV', 0x8535, 'GL_NV_register_combiners2')

defines.add(GL_PER_STAGE_CONSTANTS_NV)

# GL_NV_sRGB_formats

GL_COMPRESSED_SRGB_ALPHA_S3TC_DXT1_NV = Enumerant('GL_COMPRESSED_SRGB_ALPHA_S3TC_DXT1_NV', 0x8c4d, 'GL_NV_sRGB_formats')
GL_COMPRESSED_SRGB_ALPHA_S3TC_DXT3_NV = Enumerant('GL_COMPRESSED_SRGB_ALPHA_S3TC_DXT3_NV', 0x8c4e, 'GL_NV_sRGB_formats')
GL_COMPRESSED_SRGB_ALPHA_S3TC_DXT5_NV = Enumerant('GL_COMPRESSED_SRGB_ALPHA_S3TC_DXT5_NV', 0x8c4f, 'GL_NV_sRGB_formats')
GL_COMPRESSED_SRGB_S3TC_DXT1_NV = Enumerant('GL_COMPRESSED_SRGB_S3TC_DXT1_NV', 0x8c4c, 'GL_NV_sRGB_formats')
GL_ETC1_SRGB8_NV = Enumerant('GL_ETC1_SRGB8_NV', 0x88ee, 'GL_NV_sRGB_formats')
GL_SLUMINANCE8_ALPHA8_NV = Enumerant('GL_SLUMINANCE8_ALPHA8_NV', 0x8c45, 'GL_NV_sRGB_formats')
GL_SLUMINANCE8_NV = Enumerant('GL_SLUMINANCE8_NV', 0x8c47, 'GL_NV_sRGB_formats')
GL_SLUMINANCE_ALPHA_NV = Enumerant('GL_SLUMINANCE_ALPHA_NV', 0x8c44, 'GL_NV_sRGB_formats')
GL_SLUMINANCE_NV = Enumerant('GL_SLUMINANCE_NV', 0x8c46, 'GL_NV_sRGB_formats')
GL_SRGB8_NV = Enumerant('GL_SRGB8_NV', 0x8c41, 'GL_NV_sRGB_formats')

defines.add(GL_COMPRESSED_SRGB_ALPHA_S3TC_DXT1_NV)
defines.add(GL_COMPRESSED_SRGB_ALPHA_S3TC_DXT3_NV)
defines.add(GL_COMPRESSED_SRGB_ALPHA_S3TC_DXT5_NV)
defines.add(GL_COMPRESSED_SRGB_S3TC_DXT1_NV)
defines.add(GL_ETC1_SRGB8_NV)
defines.add(GL_SLUMINANCE8_ALPHA8_NV)
defines.add(GL_SLUMINANCE8_NV)
defines.add(GL_SLUMINANCE_ALPHA_NV)
defines.add(GL_SLUMINANCE_NV)
defines.add(GL_SRGB8_NV)

# GL_NV_shader_buffer_load

GL_BUFFER_GPU_ADDRESS_NV = Enumerant('GL_BUFFER_GPU_ADDRESS_NV', 0x8f1d, 'GL_NV_shader_buffer_load')
GL_GPU_ADDRESS_NV = Enumerant('GL_GPU_ADDRESS_NV', 0x8f34, 'GL_NV_shader_buffer_load')
GL_MAX_SHADER_BUFFER_ADDRESS_NV = Enumerant('GL_MAX_SHADER_BUFFER_ADDRESS_NV', 0x8f35, 'GL_NV_shader_buffer_load')

defines.add(GL_BUFFER_GPU_ADDRESS_NV)
defines.add(GL_GPU_ADDRESS_NV)
defines.add(GL_MAX_SHADER_BUFFER_ADDRESS_NV)

# GL_NV_shadow_samplers_array

GL_SAMPLER_2D_ARRAY_SHADOW_NV = Enumerant('GL_SAMPLER_2D_ARRAY_SHADOW_NV', 0x8dc4, 'GL_NV_shadow_samplers_array')

defines.add(GL_SAMPLER_2D_ARRAY_SHADOW_NV)

# GL_NV_shadow_samplers_cube

GL_SAMPLER_CUBE_SHADOW_NV = Enumerant('GL_SAMPLER_CUBE_SHADOW_NV', 0x8dc5, 'GL_NV_shadow_samplers_cube')

defines.add(GL_SAMPLER_CUBE_SHADOW_NV)

# GL_NV_tessellation_program5

GL_MAX_PROGRAM_PATCH_ATTRIBS_NV = Enumerant('GL_MAX_PROGRAM_PATCH_ATTRIBS_NV', 0x86d8, 'GL_NV_tessellation_program5')
GL_TESS_CONTROL_PROGRAM_NV = Enumerant('GL_TESS_CONTROL_PROGRAM_NV', 0x891e, 'GL_NV_tessellation_program5')
GL_TESS_CONTROL_PROGRAM_PARAMETER_BUFFER_NV = Enumerant('GL_TESS_CONTROL_PROGRAM_PARAMETER_BUFFER_NV', 0x8c74, 'GL_NV_tessellation_program5')
GL_TESS_EVALUATION_PROGRAM_NV = Enumerant('GL_TESS_EVALUATION_PROGRAM_NV', 0x891f, 'GL_NV_tessellation_program5')
GL_TESS_EVALUATION_PROGRAM_PARAMETER_BUFFER_NV = Enumerant('GL_TESS_EVALUATION_PROGRAM_PARAMETER_BUFFER_NV', 0x8c75, 'GL_NV_tessellation_program5')

defines.add(GL_MAX_PROGRAM_PATCH_ATTRIBS_NV)
defines.add(GL_TESS_CONTROL_PROGRAM_NV)
defines.add(GL_TESS_CONTROL_PROGRAM_PARAMETER_BUFFER_NV)
defines.add(GL_TESS_EVALUATION_PROGRAM_NV)
defines.add(GL_TESS_EVALUATION_PROGRAM_PARAMETER_BUFFER_NV)

# GL_NV_texgen_emboss

GL_EMBOSS_CONSTANT_NV = Enumerant('GL_EMBOSS_CONSTANT_NV', 0x855e, 'GL_NV_texgen_emboss')
GL_EMBOSS_LIGHT_NV = Enumerant('GL_EMBOSS_LIGHT_NV', 0x855d, 'GL_NV_texgen_emboss')
GL_EMBOSS_MAP_NV = Enumerant('GL_EMBOSS_MAP_NV', 0x855f, 'GL_NV_texgen_emboss')

defines.add(GL_EMBOSS_CONSTANT_NV)
defines.add(GL_EMBOSS_LIGHT_NV)
defines.add(GL_EMBOSS_MAP_NV)

# GL_NV_texgen_reflection

GL_NORMAL_MAP_NV = Enumerant('GL_NORMAL_MAP_NV', 0x8511, 'GL_NV_texgen_reflection')
GL_REFLECTION_MAP_NV = Enumerant('GL_REFLECTION_MAP_NV', 0x8512, 'GL_NV_texgen_reflection')

defines.add(GL_NORMAL_MAP_NV)
defines.add(GL_REFLECTION_MAP_NV)

# GL_NV_texture_array

GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_LAYER_NV = Enumerant('GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_LAYER_NV', 0x8cd4, 'GL_NV_texture_array')
GL_MAX_ARRAY_TEXTURE_LAYERS_NV = Enumerant('GL_MAX_ARRAY_TEXTURE_LAYERS_NV', 0x88ff, 'GL_NV_texture_array')
GL_SAMPLER_2D_ARRAY_NV = Enumerant('GL_SAMPLER_2D_ARRAY_NV', 0x8dc1, 'GL_NV_texture_array')
GL_TEXTURE_2D_ARRAY_NV = Enumerant('GL_TEXTURE_2D_ARRAY_NV', 0x8c1a, 'GL_NV_texture_array')
GL_TEXTURE_BINDING_2D_ARRAY_NV = Enumerant('GL_TEXTURE_BINDING_2D_ARRAY_NV', 0x8c1d, 'GL_NV_texture_array')
GL_UNPACK_IMAGE_HEIGHT_NV = Enumerant('GL_UNPACK_IMAGE_HEIGHT_NV', 0x806e, 'GL_NV_texture_array')
GL_UNPACK_SKIP_IMAGES_NV = Enumerant('GL_UNPACK_SKIP_IMAGES_NV', 0x806d, 'GL_NV_texture_array')

defines.add(GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_LAYER_NV)
defines.add(GL_MAX_ARRAY_TEXTURE_LAYERS_NV)
defines.add(GL_SAMPLER_2D_ARRAY_NV)
defines.add(GL_TEXTURE_2D_ARRAY_NV)
defines.add(GL_TEXTURE_BINDING_2D_ARRAY_NV)
defines.add(GL_UNPACK_IMAGE_HEIGHT_NV)
defines.add(GL_UNPACK_SKIP_IMAGES_NV)

# GL_NV_texture_border_clamp

GL_CLAMP_TO_BORDER_NV = Enumerant('GL_CLAMP_TO_BORDER_NV', 0x812d, 'GL_NV_texture_border_clamp')
GL_TEXTURE_BORDER_COLOR_NV = Enumerant('GL_TEXTURE_BORDER_COLOR_NV', 0x1004, 'GL_NV_texture_border_clamp')

defines.add(GL_CLAMP_TO_BORDER_NV)
defines.add(GL_TEXTURE_BORDER_COLOR_NV)

# GL_NV_texture_compression_latc

GL_COMPRESSED_LUMINANCE_ALPHA_LATC2_NV = Enumerant('GL_COMPRESSED_LUMINANCE_ALPHA_LATC2_NV', 0x8c72, 'GL_NV_texture_compression_latc')
GL_COMPRESSED_LUMINANCE_LATC1_NV = Enumerant('GL_COMPRESSED_LUMINANCE_LATC1_NV', 0x8c70, 'GL_NV_texture_compression_latc')
GL_COMPRESSED_SIGNED_LUMINANCE_ALPHA_LATC2_NV = Enumerant('GL_COMPRESSED_SIGNED_LUMINANCE_ALPHA_LATC2_NV', 0x8c73, 'GL_NV_texture_compression_latc')
GL_COMPRESSED_SIGNED_LUMINANCE_LATC1_NV = Enumerant('GL_COMPRESSED_SIGNED_LUMINANCE_LATC1_NV', 0x8c71, 'GL_NV_texture_compression_latc')

defines.add(GL_COMPRESSED_LUMINANCE_ALPHA_LATC2_NV)
defines.add(GL_COMPRESSED_LUMINANCE_LATC1_NV)
defines.add(GL_COMPRESSED_SIGNED_LUMINANCE_ALPHA_LATC2_NV)
defines.add(GL_COMPRESSED_SIGNED_LUMINANCE_LATC1_NV)

# GL_NV_texture_compression_s3tc

GL_COMPRESSED_RGBA_S3TC_DXT1_NV = Enumerant('GL_COMPRESSED_RGBA_S3TC_DXT1_NV', 0x83f1, 'GL_NV_texture_compression_s3tc')
GL_COMPRESSED_RGBA_S3TC_DXT3_NV = Enumerant('GL_COMPRESSED_RGBA_S3TC_DXT3_NV', 0x83f2, 'GL_NV_texture_compression_s3tc')
GL_COMPRESSED_RGBA_S3TC_DXT5_NV = Enumerant('GL_COMPRESSED_RGBA_S3TC_DXT5_NV', 0x83f3, 'GL_NV_texture_compression_s3tc')
GL_COMPRESSED_RGB_S3TC_DXT1_NV = Enumerant('GL_COMPRESSED_RGB_S3TC_DXT1_NV', 0x83f0, 'GL_NV_texture_compression_s3tc')

defines.add(GL_COMPRESSED_RGBA_S3TC_DXT1_NV)
defines.add(GL_COMPRESSED_RGBA_S3TC_DXT3_NV)
defines.add(GL_COMPRESSED_RGBA_S3TC_DXT5_NV)
defines.add(GL_COMPRESSED_RGB_S3TC_DXT1_NV)

# GL_NV_texture_env_combine4

GL_COMBINE4_NV = Enumerant('GL_COMBINE4_NV', 0x8503, 'GL_NV_texture_env_combine4')
GL_OPERAND3_ALPHA_NV = Enumerant('GL_OPERAND3_ALPHA_NV', 0x859b, 'GL_NV_texture_env_combine4')
GL_OPERAND3_RGB_NV = Enumerant('GL_OPERAND3_RGB_NV', 0x8593, 'GL_NV_texture_env_combine4')
GL_SOURCE3_ALPHA_NV = Enumerant('GL_SOURCE3_ALPHA_NV', 0x858b, 'GL_NV_texture_env_combine4')
GL_SOURCE3_RGB_NV = Enumerant('GL_SOURCE3_RGB_NV', 0x8583, 'GL_NV_texture_env_combine4')

defines.add(GL_COMBINE4_NV)
defines.add(GL_OPERAND3_ALPHA_NV)
defines.add(GL_OPERAND3_RGB_NV)
defines.add(GL_SOURCE3_ALPHA_NV)
defines.add(GL_SOURCE3_RGB_NV)

# GL_NV_texture_expand_normal

GL_TEXTURE_UNSIGNED_REMAP_MODE_NV = Enumerant('GL_TEXTURE_UNSIGNED_REMAP_MODE_NV', 0x888f, 'GL_NV_texture_expand_normal')

defines.add(GL_TEXTURE_UNSIGNED_REMAP_MODE_NV)

# GL_NV_texture_multisample

GL_TEXTURE_COLOR_SAMPLES_NV = Enumerant('GL_TEXTURE_COLOR_SAMPLES_NV', 0x9046, 'GL_NV_texture_multisample')
GL_TEXTURE_COVERAGE_SAMPLES_NV = Enumerant('GL_TEXTURE_COVERAGE_SAMPLES_NV', 0x9045, 'GL_NV_texture_multisample')

defines.add(GL_TEXTURE_COLOR_SAMPLES_NV)
defines.add(GL_TEXTURE_COVERAGE_SAMPLES_NV)

# GL_NV_texture_rectangle

GL_MAX_RECTANGLE_TEXTURE_SIZE_NV = Enumerant('GL_MAX_RECTANGLE_TEXTURE_SIZE_NV', 0x84f8, 'GL_NV_texture_rectangle')
GL_PROXY_TEXTURE_RECTANGLE_NV = Enumerant('GL_PROXY_TEXTURE_RECTANGLE_NV', 0x84f7, 'GL_NV_texture_rectangle')
GL_TEXTURE_BINDING_RECTANGLE_NV = Enumerant('GL_TEXTURE_BINDING_RECTANGLE_NV', 0x84f6, 'GL_NV_texture_rectangle')
GL_TEXTURE_RECTANGLE_NV = Enumerant('GL_TEXTURE_RECTANGLE_NV', 0x84f5, 'GL_NV_texture_rectangle')

defines.add(GL_MAX_RECTANGLE_TEXTURE_SIZE_NV)
defines.add(GL_PROXY_TEXTURE_RECTANGLE_NV)
defines.add(GL_TEXTURE_BINDING_RECTANGLE_NV)
defines.add(GL_TEXTURE_RECTANGLE_NV)

# GL_NV_texture_shader

GL_CONST_EYE_NV = Enumerant('GL_CONST_EYE_NV', 0x86e5, 'GL_NV_texture_shader')
GL_CULL_FRAGMENT_NV = Enumerant('GL_CULL_FRAGMENT_NV', 0x86e7, 'GL_NV_texture_shader')
GL_CULL_MODES_NV = Enumerant('GL_CULL_MODES_NV', 0x86e0, 'GL_NV_texture_shader')
GL_DEPENDENT_AR_TEXTURE_2D_NV = Enumerant('GL_DEPENDENT_AR_TEXTURE_2D_NV', 0x86e9, 'GL_NV_texture_shader')
GL_DEPENDENT_GB_TEXTURE_2D_NV = Enumerant('GL_DEPENDENT_GB_TEXTURE_2D_NV', 0x86ea, 'GL_NV_texture_shader')
GL_DOT_PRODUCT_CONST_EYE_REFLECT_CUBE_MAP_NV = Enumerant('GL_DOT_PRODUCT_CONST_EYE_REFLECT_CUBE_MAP_NV', 0x86f3, 'GL_NV_texture_shader')
GL_DOT_PRODUCT_DEPTH_REPLACE_NV = Enumerant('GL_DOT_PRODUCT_DEPTH_REPLACE_NV', 0x86ed, 'GL_NV_texture_shader')
GL_DOT_PRODUCT_DIFFUSE_CUBE_MAP_NV = Enumerant('GL_DOT_PRODUCT_DIFFUSE_CUBE_MAP_NV', 0x86f1, 'GL_NV_texture_shader')
GL_DOT_PRODUCT_NV = Enumerant('GL_DOT_PRODUCT_NV', 0x86ec, 'GL_NV_texture_shader')
GL_DOT_PRODUCT_REFLECT_CUBE_MAP_NV = Enumerant('GL_DOT_PRODUCT_REFLECT_CUBE_MAP_NV', 0x86f2, 'GL_NV_texture_shader')
GL_DOT_PRODUCT_TEXTURE_2D_NV = Enumerant('GL_DOT_PRODUCT_TEXTURE_2D_NV', 0x86ee, 'GL_NV_texture_shader')
GL_DOT_PRODUCT_TEXTURE_CUBE_MAP_NV = Enumerant('GL_DOT_PRODUCT_TEXTURE_CUBE_MAP_NV', 0x86f0, 'GL_NV_texture_shader')
GL_DOT_PRODUCT_TEXTURE_RECTANGLE_NV = Enumerant('GL_DOT_PRODUCT_TEXTURE_RECTANGLE_NV', 0x864e, 'GL_NV_texture_shader')
GL_DS_BIAS_NV = Enumerant('GL_DS_BIAS_NV', 0x8716, 'GL_NV_texture_shader')
GL_DS_SCALE_NV = Enumerant('GL_DS_SCALE_NV', 0x8710, 'GL_NV_texture_shader')
GL_DT_BIAS_NV = Enumerant('GL_DT_BIAS_NV', 0x8717, 'GL_NV_texture_shader')
GL_DT_SCALE_NV = Enumerant('GL_DT_SCALE_NV', 0x8711, 'GL_NV_texture_shader')
GL_HI_BIAS_NV = Enumerant('GL_HI_BIAS_NV', 0x8714, 'GL_NV_texture_shader')
GL_HI_SCALE_NV = Enumerant('GL_HI_SCALE_NV', 0x870e, 'GL_NV_texture_shader')
GL_LO_BIAS_NV = Enumerant('GL_LO_BIAS_NV', 0x8715, 'GL_NV_texture_shader')
GL_LO_SCALE_NV = Enumerant('GL_LO_SCALE_NV', 0x870f, 'GL_NV_texture_shader')
GL_MAGNITUDE_BIAS_NV = Enumerant('GL_MAGNITUDE_BIAS_NV', 0x8718, 'GL_NV_texture_shader')
GL_MAGNITUDE_SCALE_NV = Enumerant('GL_MAGNITUDE_SCALE_NV', 0x8712, 'GL_NV_texture_shader')
GL_OFFSET_TEXTURE_2D_BIAS_NV = Enumerant('GL_OFFSET_TEXTURE_2D_BIAS_NV', 0x86e3, 'GL_NV_texture_shader')
GL_OFFSET_TEXTURE_2D_MATRIX_NV = Enumerant('GL_OFFSET_TEXTURE_2D_MATRIX_NV', 0x86e1, 'GL_NV_texture_shader')
GL_OFFSET_TEXTURE_2D_NV = Enumerant('GL_OFFSET_TEXTURE_2D_NV', 0x86e8, 'GL_NV_texture_shader')
GL_OFFSET_TEXTURE_2D_SCALE_NV = Enumerant('GL_OFFSET_TEXTURE_2D_SCALE_NV', 0x86e2, 'GL_NV_texture_shader')
GL_OFFSET_TEXTURE_BIAS_NV = Enumerant('GL_OFFSET_TEXTURE_BIAS_NV', 0x86e3, 'GL_NV_texture_shader')
GL_OFFSET_TEXTURE_MATRIX_NV = Enumerant('GL_OFFSET_TEXTURE_MATRIX_NV', 0x86e1, 'GL_NV_texture_shader')
GL_OFFSET_TEXTURE_RECTANGLE_NV = Enumerant('GL_OFFSET_TEXTURE_RECTANGLE_NV', 0x864c, 'GL_NV_texture_shader')
GL_OFFSET_TEXTURE_RECTANGLE_SCALE_NV = Enumerant('GL_OFFSET_TEXTURE_RECTANGLE_SCALE_NV', 0x864d, 'GL_NV_texture_shader')
GL_OFFSET_TEXTURE_SCALE_NV = Enumerant('GL_OFFSET_TEXTURE_SCALE_NV', 0x86e2, 'GL_NV_texture_shader')
GL_PASS_THROUGH_NV = Enumerant('GL_PASS_THROUGH_NV', 0x86e6, 'GL_NV_texture_shader')
GL_PREVIOUS_TEXTURE_INPUT_NV = Enumerant('GL_PREVIOUS_TEXTURE_INPUT_NV', 0x86e4, 'GL_NV_texture_shader')
GL_RGBA_UNSIGNED_DOT_PRODUCT_MAPPING_NV = Enumerant('GL_RGBA_UNSIGNED_DOT_PRODUCT_MAPPING_NV', 0x86d9, 'GL_NV_texture_shader')
GL_SHADER_CONSISTENT_NV = Enumerant('GL_SHADER_CONSISTENT_NV', 0x86dd, 'GL_NV_texture_shader')
GL_SHADER_OPERATION_NV = Enumerant('GL_SHADER_OPERATION_NV', 0x86df, 'GL_NV_texture_shader')
GL_TEXTURE_BORDER_VALUES_NV = Enumerant('GL_TEXTURE_BORDER_VALUES_NV', 0x871a, 'GL_NV_texture_shader')
GL_TEXTURE_DS_SIZE_NV = Enumerant('GL_TEXTURE_DS_SIZE_NV', 0x871d, 'GL_NV_texture_shader')
GL_TEXTURE_DT_SIZE_NV = Enumerant('GL_TEXTURE_DT_SIZE_NV', 0x871e, 'GL_NV_texture_shader')
GL_TEXTURE_HI_SIZE_NV = Enumerant('GL_TEXTURE_HI_SIZE_NV', 0x871b, 'GL_NV_texture_shader')
GL_TEXTURE_LO_SIZE_NV = Enumerant('GL_TEXTURE_LO_SIZE_NV', 0x871c, 'GL_NV_texture_shader')
GL_TEXTURE_MAG_SIZE_NV = Enumerant('GL_TEXTURE_MAG_SIZE_NV', 0x871f, 'GL_NV_texture_shader')
GL_TEXTURE_SHADER_NV = Enumerant('GL_TEXTURE_SHADER_NV', 0x86de, 'GL_NV_texture_shader')
GL_VIBRANCE_BIAS_NV = Enumerant('GL_VIBRANCE_BIAS_NV', 0x8719, 'GL_NV_texture_shader')
GL_VIBRANCE_SCALE_NV = Enumerant('GL_VIBRANCE_SCALE_NV', 0x8713, 'GL_NV_texture_shader')

defines.add(GL_CONST_EYE_NV)
defines.add(GL_CULL_FRAGMENT_NV)
defines.add(GL_CULL_MODES_NV)
defines.add(GL_DEPENDENT_AR_TEXTURE_2D_NV)
defines.add(GL_DEPENDENT_GB_TEXTURE_2D_NV)
defines.add(GL_DOT_PRODUCT_CONST_EYE_REFLECT_CUBE_MAP_NV)
defines.add(GL_DOT_PRODUCT_DEPTH_REPLACE_NV)
defines.add(GL_DOT_PRODUCT_DIFFUSE_CUBE_MAP_NV)
defines.add(GL_DOT_PRODUCT_NV)
defines.add(GL_DOT_PRODUCT_REFLECT_CUBE_MAP_NV)
defines.add(GL_DOT_PRODUCT_TEXTURE_2D_NV)
defines.add(GL_DOT_PRODUCT_TEXTURE_CUBE_MAP_NV)
defines.add(GL_DOT_PRODUCT_TEXTURE_RECTANGLE_NV)
defines.add(GL_DS_BIAS_NV)
defines.add(GL_DS_SCALE_NV)
defines.add(GL_DT_BIAS_NV)
defines.add(GL_DT_SCALE_NV)
defines.add(GL_HI_BIAS_NV)
defines.add(GL_HI_SCALE_NV)
defines.add(GL_LO_BIAS_NV)
defines.add(GL_LO_SCALE_NV)
defines.add(GL_MAGNITUDE_BIAS_NV)
defines.add(GL_MAGNITUDE_SCALE_NV)
defines.add(GL_OFFSET_TEXTURE_2D_BIAS_NV)
defines.add(GL_OFFSET_TEXTURE_2D_MATRIX_NV)
defines.add(GL_OFFSET_TEXTURE_2D_NV)
defines.add(GL_OFFSET_TEXTURE_2D_SCALE_NV)
defines.add(GL_OFFSET_TEXTURE_BIAS_NV)
defines.add(GL_OFFSET_TEXTURE_MATRIX_NV)
defines.add(GL_OFFSET_TEXTURE_RECTANGLE_NV)
defines.add(GL_OFFSET_TEXTURE_RECTANGLE_SCALE_NV)
defines.add(GL_OFFSET_TEXTURE_SCALE_NV)
defines.add(GL_PASS_THROUGH_NV)
defines.add(GL_PREVIOUS_TEXTURE_INPUT_NV)
defines.add(GL_RGBA_UNSIGNED_DOT_PRODUCT_MAPPING_NV)
defines.add(GL_SHADER_CONSISTENT_NV)
defines.add(GL_SHADER_OPERATION_NV)
defines.add(GL_TEXTURE_BORDER_VALUES_NV)
defines.add(GL_TEXTURE_DS_SIZE_NV)
defines.add(GL_TEXTURE_DT_SIZE_NV)
defines.add(GL_TEXTURE_HI_SIZE_NV)
defines.add(GL_TEXTURE_LO_SIZE_NV)
defines.add(GL_TEXTURE_MAG_SIZE_NV)
defines.add(GL_TEXTURE_SHADER_NV)
defines.add(GL_VIBRANCE_BIAS_NV)
defines.add(GL_VIBRANCE_SCALE_NV)

# GL_NV_texture_shader2

GL_DOT_PRODUCT_TEXTURE_3D_NV = Enumerant('GL_DOT_PRODUCT_TEXTURE_3D_NV', 0x86ef, 'GL_NV_texture_shader2')
GL_DSDT8_MAG8_INTENSITY8_NV = Enumerant('GL_DSDT8_MAG8_INTENSITY8_NV', 0x870b, 'GL_NV_texture_shader2')
GL_DSDT8_MAG8_NV = Enumerant('GL_DSDT8_MAG8_NV', 0x870a, 'GL_NV_texture_shader2')
GL_DSDT8_NV = Enumerant('GL_DSDT8_NV', 0x8709, 'GL_NV_texture_shader2')
GL_DSDT_MAG_INTENSITY_NV = Enumerant('GL_DSDT_MAG_INTENSITY_NV', 0x86dc, 'GL_NV_texture_shader2')
GL_DSDT_MAG_NV = Enumerant('GL_DSDT_MAG_NV', 0x86f6, 'GL_NV_texture_shader2')
GL_DSDT_MAG_VIB_NV = Enumerant('GL_DSDT_MAG_VIB_NV', 0x86f7, 'GL_NV_texture_shader2')
GL_DSDT_NV = Enumerant('GL_DSDT_NV', 0x86f5, 'GL_NV_texture_shader2')
GL_HILO16_NV = Enumerant('GL_HILO16_NV', 0x86f8, 'GL_NV_texture_shader2')
GL_HILO_NV = Enumerant('GL_HILO_NV', 0x86f4, 'GL_NV_texture_shader2')
GL_SIGNED_ALPHA8_NV = Enumerant('GL_SIGNED_ALPHA8_NV', 0x8706, 'GL_NV_texture_shader2')
GL_SIGNED_ALPHA_NV = Enumerant('GL_SIGNED_ALPHA_NV', 0x8705, 'GL_NV_texture_shader2')
GL_SIGNED_HILO16_NV = Enumerant('GL_SIGNED_HILO16_NV', 0x86fa, 'GL_NV_texture_shader2')
GL_SIGNED_HILO_NV = Enumerant('GL_SIGNED_HILO_NV', 0x86f9, 'GL_NV_texture_shader2')
GL_SIGNED_INTENSITY8_NV = Enumerant('GL_SIGNED_INTENSITY8_NV', 0x8708, 'GL_NV_texture_shader2')
GL_SIGNED_INTENSITY_NV = Enumerant('GL_SIGNED_INTENSITY_NV', 0x8707, 'GL_NV_texture_shader2')
GL_SIGNED_LUMINANCE8_ALPHA8_NV = Enumerant('GL_SIGNED_LUMINANCE8_ALPHA8_NV', 0x8704, 'GL_NV_texture_shader2')
GL_SIGNED_LUMINANCE8_NV = Enumerant('GL_SIGNED_LUMINANCE8_NV', 0x8702, 'GL_NV_texture_shader2')
GL_SIGNED_LUMINANCE_ALPHA_NV = Enumerant('GL_SIGNED_LUMINANCE_ALPHA_NV', 0x8703, 'GL_NV_texture_shader2')
GL_SIGNED_LUMINANCE_NV = Enumerant('GL_SIGNED_LUMINANCE_NV', 0x8701, 'GL_NV_texture_shader2')
GL_SIGNED_RGB8_NV = Enumerant('GL_SIGNED_RGB8_NV', 0x86ff, 'GL_NV_texture_shader2')
GL_SIGNED_RGB8_UNSIGNED_ALPHA8_NV = Enumerant('GL_SIGNED_RGB8_UNSIGNED_ALPHA8_NV', 0x870d, 'GL_NV_texture_shader2')
GL_SIGNED_RGBA8_NV = Enumerant('GL_SIGNED_RGBA8_NV', 0x86fc, 'GL_NV_texture_shader2')
GL_SIGNED_RGBA_NV = Enumerant('GL_SIGNED_RGBA_NV', 0x86fb, 'GL_NV_texture_shader2')
GL_SIGNED_RGB_NV = Enumerant('GL_SIGNED_RGB_NV', 0x86fe, 'GL_NV_texture_shader2')
GL_SIGNED_RGB_UNSIGNED_ALPHA_NV = Enumerant('GL_SIGNED_RGB_UNSIGNED_ALPHA_NV', 0x870c, 'GL_NV_texture_shader2')
GL_UNSIGNED_INT_8_8_S8_S8_REV_NV = Enumerant('GL_UNSIGNED_INT_8_8_S8_S8_REV_NV', 0x86db, 'GL_NV_texture_shader2')
GL_UNSIGNED_INT_S8_S8_8_8_NV = Enumerant('GL_UNSIGNED_INT_S8_S8_8_8_NV', 0x86da, 'GL_NV_texture_shader2')

defines.add(GL_DOT_PRODUCT_TEXTURE_3D_NV)
defines.add(GL_DSDT8_MAG8_INTENSITY8_NV)
defines.add(GL_DSDT8_MAG8_NV)
defines.add(GL_DSDT8_NV)
defines.add(GL_DSDT_MAG_INTENSITY_NV)
defines.add(GL_DSDT_MAG_NV)
defines.add(GL_DSDT_MAG_VIB_NV)
defines.add(GL_DSDT_NV)
defines.add(GL_HILO16_NV)
defines.add(GL_HILO_NV)
defines.add(GL_SIGNED_ALPHA8_NV)
defines.add(GL_SIGNED_ALPHA_NV)
defines.add(GL_SIGNED_HILO16_NV)
defines.add(GL_SIGNED_HILO_NV)
defines.add(GL_SIGNED_INTENSITY8_NV)
defines.add(GL_SIGNED_INTENSITY_NV)
defines.add(GL_SIGNED_LUMINANCE8_ALPHA8_NV)
defines.add(GL_SIGNED_LUMINANCE8_NV)
defines.add(GL_SIGNED_LUMINANCE_ALPHA_NV)
defines.add(GL_SIGNED_LUMINANCE_NV)
defines.add(GL_SIGNED_RGB8_NV)
defines.add(GL_SIGNED_RGB8_UNSIGNED_ALPHA8_NV)
defines.add(GL_SIGNED_RGBA8_NV)
defines.add(GL_SIGNED_RGBA_NV)
defines.add(GL_SIGNED_RGB_NV)
defines.add(GL_SIGNED_RGB_UNSIGNED_ALPHA_NV)
defines.add(GL_UNSIGNED_INT_8_8_S8_S8_REV_NV)
defines.add(GL_UNSIGNED_INT_S8_S8_8_8_NV)

# GL_NV_texture_shader3

GL_DEPENDENT_HILO_TEXTURE_2D_NV = Enumerant('GL_DEPENDENT_HILO_TEXTURE_2D_NV', 0x8858, 'GL_NV_texture_shader3')
GL_DEPENDENT_RGB_TEXTURE_3D_NV = Enumerant('GL_DEPENDENT_RGB_TEXTURE_3D_NV', 0x8859, 'GL_NV_texture_shader3')
GL_DEPENDENT_RGB_TEXTURE_CUBE_MAP_NV = Enumerant('GL_DEPENDENT_RGB_TEXTURE_CUBE_MAP_NV', 0x885a, 'GL_NV_texture_shader3')
GL_DOT_PRODUCT_AFFINE_DEPTH_REPLACE_NV = Enumerant('GL_DOT_PRODUCT_AFFINE_DEPTH_REPLACE_NV', 0x885d, 'GL_NV_texture_shader3')
GL_DOT_PRODUCT_PASS_THROUGH_NV = Enumerant('GL_DOT_PRODUCT_PASS_THROUGH_NV', 0x885b, 'GL_NV_texture_shader3')
GL_DOT_PRODUCT_TEXTURE_1D_NV = Enumerant('GL_DOT_PRODUCT_TEXTURE_1D_NV', 0x885c, 'GL_NV_texture_shader3')
GL_FORCE_BLUE_TO_ONE_NV = Enumerant('GL_FORCE_BLUE_TO_ONE_NV', 0x8860, 'GL_NV_texture_shader3')
GL_HILO8_NV = Enumerant('GL_HILO8_NV', 0x885e, 'GL_NV_texture_shader3')
GL_OFFSET_HILO_PROJECTIVE_TEXTURE_2D_NV = Enumerant('GL_OFFSET_HILO_PROJECTIVE_TEXTURE_2D_NV', 0x8856, 'GL_NV_texture_shader3')
GL_OFFSET_HILO_PROJECTIVE_TEXTURE_RECTANGLE_NV = Enumerant('GL_OFFSET_HILO_PROJECTIVE_TEXTURE_RECTANGLE_NV', 0x8857, 'GL_NV_texture_shader3')
GL_OFFSET_HILO_TEXTURE_2D_NV = Enumerant('GL_OFFSET_HILO_TEXTURE_2D_NV', 0x8854, 'GL_NV_texture_shader3')
GL_OFFSET_HILO_TEXTURE_RECTANGLE_NV = Enumerant('GL_OFFSET_HILO_TEXTURE_RECTANGLE_NV', 0x8855, 'GL_NV_texture_shader3')
GL_OFFSET_PROJECTIVE_TEXTURE_2D_NV = Enumerant('GL_OFFSET_PROJECTIVE_TEXTURE_2D_NV', 0x8850, 'GL_NV_texture_shader3')
GL_OFFSET_PROJECTIVE_TEXTURE_2D_SCALE_NV = Enumerant('GL_OFFSET_PROJECTIVE_TEXTURE_2D_SCALE_NV', 0x8851, 'GL_NV_texture_shader3')
GL_OFFSET_PROJECTIVE_TEXTURE_RECTANGLE_NV = Enumerant('GL_OFFSET_PROJECTIVE_TEXTURE_RECTANGLE_NV', 0x8852, 'GL_NV_texture_shader3')
GL_OFFSET_PROJECTIVE_TEXTURE_RECTANGLE_SCALE_NV = Enumerant('GL_OFFSET_PROJECTIVE_TEXTURE_RECTANGLE_SCALE_NV', 0x8853, 'GL_NV_texture_shader3')
GL_SIGNED_HILO8_NV = Enumerant('GL_SIGNED_HILO8_NV', 0x885f, 'GL_NV_texture_shader3')

defines.add(GL_DEPENDENT_HILO_TEXTURE_2D_NV)
defines.add(GL_DEPENDENT_RGB_TEXTURE_3D_NV)
defines.add(GL_DEPENDENT_RGB_TEXTURE_CUBE_MAP_NV)
defines.add(GL_DOT_PRODUCT_AFFINE_DEPTH_REPLACE_NV)
defines.add(GL_DOT_PRODUCT_PASS_THROUGH_NV)
defines.add(GL_DOT_PRODUCT_TEXTURE_1D_NV)
defines.add(GL_FORCE_BLUE_TO_ONE_NV)
defines.add(GL_HILO8_NV)
defines.add(GL_OFFSET_HILO_PROJECTIVE_TEXTURE_2D_NV)
defines.add(GL_OFFSET_HILO_PROJECTIVE_TEXTURE_RECTANGLE_NV)
defines.add(GL_OFFSET_HILO_TEXTURE_2D_NV)
defines.add(GL_OFFSET_HILO_TEXTURE_RECTANGLE_NV)
defines.add(GL_OFFSET_PROJECTIVE_TEXTURE_2D_NV)
defines.add(GL_OFFSET_PROJECTIVE_TEXTURE_2D_SCALE_NV)
defines.add(GL_OFFSET_PROJECTIVE_TEXTURE_RECTANGLE_NV)
defines.add(GL_OFFSET_PROJECTIVE_TEXTURE_RECTANGLE_SCALE_NV)
defines.add(GL_SIGNED_HILO8_NV)

# GL_NV_transform_feedback

GL_ACTIVE_VARYINGS_NV = Enumerant('GL_ACTIVE_VARYINGS_NV', 0x8c81, 'GL_NV_transform_feedback')
GL_ACTIVE_VARYING_MAX_LENGTH_NV = Enumerant('GL_ACTIVE_VARYING_MAX_LENGTH_NV', 0x8c82, 'GL_NV_transform_feedback')
GL_BACK_PRIMARY_COLOR_NV = Enumerant('GL_BACK_PRIMARY_COLOR_NV', 0x8c77, 'GL_NV_transform_feedback')
GL_BACK_SECONDARY_COLOR_NV = Enumerant('GL_BACK_SECONDARY_COLOR_NV', 0x8c78, 'GL_NV_transform_feedback')
GL_CLIP_DISTANCE_NV = Enumerant('GL_CLIP_DISTANCE_NV', 0x8c7a, 'GL_NV_transform_feedback')
GL_GENERIC_ATTRIB_NV = Enumerant('GL_GENERIC_ATTRIB_NV', 0x8c7d, 'GL_NV_transform_feedback')
GL_INTERLEAVED_ATTRIBS_NV = Enumerant('GL_INTERLEAVED_ATTRIBS_NV', 0x8c8c, 'GL_NV_transform_feedback')
GL_MAX_TRANSFORM_FEEDBACK_INTERLEAVED_COMPONENTS_NV = Enumerant('GL_MAX_TRANSFORM_FEEDBACK_INTERLEAVED_COMPONENTS_NV', 0x8c8a, 'GL_NV_transform_feedback')
GL_MAX_TRANSFORM_FEEDBACK_SEPARATE_ATTRIBS_NV = Enumerant('GL_MAX_TRANSFORM_FEEDBACK_SEPARATE_ATTRIBS_NV', 0x8c8b, 'GL_NV_transform_feedback')
GL_MAX_TRANSFORM_FEEDBACK_SEPARATE_COMPONENTS_NV = Enumerant('GL_MAX_TRANSFORM_FEEDBACK_SEPARATE_COMPONENTS_NV', 0x8c80, 'GL_NV_transform_feedback')
GL_PRIMITIVES_GENERATED_NV = Enumerant('GL_PRIMITIVES_GENERATED_NV', 0x8c87, 'GL_NV_transform_feedback')
GL_PRIMITIVE_ID_NV = Enumerant('GL_PRIMITIVE_ID_NV', 0x8c7c, 'GL_NV_transform_feedback')
GL_RASTERIZER_DISCARD_NV = Enumerant('GL_RASTERIZER_DISCARD_NV', 0x8c89, 'GL_NV_transform_feedback')
GL_SEPARATE_ATTRIBS_NV = Enumerant('GL_SEPARATE_ATTRIBS_NV', 0x8c8d, 'GL_NV_transform_feedback')
GL_TEXTURE_COORD_NV = Enumerant('GL_TEXTURE_COORD_NV', 0x8c79, 'GL_NV_transform_feedback')
GL_TRANSFORM_FEEDBACK_ATTRIBS_NV = Enumerant('GL_TRANSFORM_FEEDBACK_ATTRIBS_NV', 0x8c7e, 'GL_NV_transform_feedback')
GL_TRANSFORM_FEEDBACK_BUFFER_BINDING_NV = Enumerant('GL_TRANSFORM_FEEDBACK_BUFFER_BINDING_NV', 0x8c8f, 'GL_NV_transform_feedback')
GL_TRANSFORM_FEEDBACK_BUFFER_MODE_NV = Enumerant('GL_TRANSFORM_FEEDBACK_BUFFER_MODE_NV', 0x8c7f, 'GL_NV_transform_feedback')
GL_TRANSFORM_FEEDBACK_BUFFER_NV = Enumerant('GL_TRANSFORM_FEEDBACK_BUFFER_NV', 0x8c8e, 'GL_NV_transform_feedback')
GL_TRANSFORM_FEEDBACK_BUFFER_SIZE_NV = Enumerant('GL_TRANSFORM_FEEDBACK_BUFFER_SIZE_NV', 0x8c85, 'GL_NV_transform_feedback')
GL_TRANSFORM_FEEDBACK_BUFFER_START_NV = Enumerant('GL_TRANSFORM_FEEDBACK_BUFFER_START_NV', 0x8c84, 'GL_NV_transform_feedback')
GL_TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN_NV = Enumerant('GL_TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN_NV', 0x8c88, 'GL_NV_transform_feedback')
GL_TRANSFORM_FEEDBACK_RECORD_NV = Enumerant('GL_TRANSFORM_FEEDBACK_RECORD_NV', 0x8c86, 'GL_NV_transform_feedback')
GL_TRANSFORM_FEEDBACK_VARYINGS_NV = Enumerant('GL_TRANSFORM_FEEDBACK_VARYINGS_NV', 0x8c83, 'GL_NV_transform_feedback')
GL_VERTEX_ID_NV = Enumerant('GL_VERTEX_ID_NV', 0x8c7b, 'GL_NV_transform_feedback')

defines.add(GL_ACTIVE_VARYINGS_NV)
defines.add(GL_ACTIVE_VARYING_MAX_LENGTH_NV)
defines.add(GL_BACK_PRIMARY_COLOR_NV)
defines.add(GL_BACK_SECONDARY_COLOR_NV)
defines.add(GL_CLIP_DISTANCE_NV)
defines.add(GL_GENERIC_ATTRIB_NV)
defines.add(GL_INTERLEAVED_ATTRIBS_NV)
defines.add(GL_MAX_TRANSFORM_FEEDBACK_INTERLEAVED_COMPONENTS_NV)
defines.add(GL_MAX_TRANSFORM_FEEDBACK_SEPARATE_ATTRIBS_NV)
defines.add(GL_MAX_TRANSFORM_FEEDBACK_SEPARATE_COMPONENTS_NV)
defines.add(GL_PRIMITIVES_GENERATED_NV)
defines.add(GL_PRIMITIVE_ID_NV)
defines.add(GL_RASTERIZER_DISCARD_NV)
defines.add(GL_SEPARATE_ATTRIBS_NV)
defines.add(GL_TEXTURE_COORD_NV)
defines.add(GL_TRANSFORM_FEEDBACK_ATTRIBS_NV)
defines.add(GL_TRANSFORM_FEEDBACK_BUFFER_BINDING_NV)
defines.add(GL_TRANSFORM_FEEDBACK_BUFFER_MODE_NV)
defines.add(GL_TRANSFORM_FEEDBACK_BUFFER_NV)
defines.add(GL_TRANSFORM_FEEDBACK_BUFFER_SIZE_NV)
defines.add(GL_TRANSFORM_FEEDBACK_BUFFER_START_NV)
defines.add(GL_TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN_NV)
defines.add(GL_TRANSFORM_FEEDBACK_RECORD_NV)
defines.add(GL_TRANSFORM_FEEDBACK_VARYINGS_NV)
defines.add(GL_VERTEX_ID_NV)

# GL_NV_transform_feedback2

GL_TRANSFORM_FEEDBACK_BINDING_NV = Enumerant('GL_TRANSFORM_FEEDBACK_BINDING_NV', 0x8e25, 'GL_NV_transform_feedback2')
GL_TRANSFORM_FEEDBACK_BUFFER_ACTIVE_NV = Enumerant('GL_TRANSFORM_FEEDBACK_BUFFER_ACTIVE_NV', 0x8e24, 'GL_NV_transform_feedback2')
GL_TRANSFORM_FEEDBACK_BUFFER_PAUSED_NV = Enumerant('GL_TRANSFORM_FEEDBACK_BUFFER_PAUSED_NV', 0x8e23, 'GL_NV_transform_feedback2')
GL_TRANSFORM_FEEDBACK_NV = Enumerant('GL_TRANSFORM_FEEDBACK_NV', 0x8e22, 'GL_NV_transform_feedback2')

defines.add(GL_TRANSFORM_FEEDBACK_BINDING_NV)
defines.add(GL_TRANSFORM_FEEDBACK_BUFFER_ACTIVE_NV)
defines.add(GL_TRANSFORM_FEEDBACK_BUFFER_PAUSED_NV)
defines.add(GL_TRANSFORM_FEEDBACK_NV)

# GL_NV_vdpau_interop

GL_SURFACE_MAPPED_NV = Enumerant('GL_SURFACE_MAPPED_NV', 0x8700, 'GL_NV_vdpau_interop')
GL_SURFACE_REGISTERED_NV = Enumerant('GL_SURFACE_REGISTERED_NV', 0x86fd, 'GL_NV_vdpau_interop')
GL_SURFACE_STATE_NV = Enumerant('GL_SURFACE_STATE_NV', 0x86eb, 'GL_NV_vdpau_interop')
GL_WRITE_DISCARD_NV = Enumerant('GL_WRITE_DISCARD_NV', 0x88be, 'GL_NV_vdpau_interop')

defines.add(GL_SURFACE_MAPPED_NV)
defines.add(GL_SURFACE_REGISTERED_NV)
defines.add(GL_SURFACE_STATE_NV)
defines.add(GL_WRITE_DISCARD_NV)

# GL_NV_vertex_array_range

GL_MAX_VERTEX_ARRAY_RANGE_ELEMENT_NV = Enumerant('GL_MAX_VERTEX_ARRAY_RANGE_ELEMENT_NV', 0x8520, 'GL_NV_vertex_array_range')
GL_VERTEX_ARRAY_RANGE_LENGTH_NV = Enumerant('GL_VERTEX_ARRAY_RANGE_LENGTH_NV', 0x851e, 'GL_NV_vertex_array_range')
GL_VERTEX_ARRAY_RANGE_NV = Enumerant('GL_VERTEX_ARRAY_RANGE_NV', 0x851d, 'GL_NV_vertex_array_range')
GL_VERTEX_ARRAY_RANGE_POINTER_NV = Enumerant('GL_VERTEX_ARRAY_RANGE_POINTER_NV', 0x8521, 'GL_NV_vertex_array_range')
GL_VERTEX_ARRAY_RANGE_VALID_NV = Enumerant('GL_VERTEX_ARRAY_RANGE_VALID_NV', 0x851f, 'GL_NV_vertex_array_range')

defines.add(GL_MAX_VERTEX_ARRAY_RANGE_ELEMENT_NV)
defines.add(GL_VERTEX_ARRAY_RANGE_LENGTH_NV)
defines.add(GL_VERTEX_ARRAY_RANGE_NV)
defines.add(GL_VERTEX_ARRAY_RANGE_POINTER_NV)
defines.add(GL_VERTEX_ARRAY_RANGE_VALID_NV)

# GL_NV_vertex_array_range2

GL_VERTEX_ARRAY_RANGE_WITHOUT_FLUSH_NV = Enumerant('GL_VERTEX_ARRAY_RANGE_WITHOUT_FLUSH_NV', 0x8533, 'GL_NV_vertex_array_range2')

defines.add(GL_VERTEX_ARRAY_RANGE_WITHOUT_FLUSH_NV)

# GL_NV_vertex_attrib_integer_64bit

GL_INT64_NV = Enumerant('GL_INT64_NV', 0x140e, 'GL_NV_vertex_attrib_integer_64bit')
GL_UNSIGNED_INT64_NV = Enumerant('GL_UNSIGNED_INT64_NV', 0x140f, 'GL_NV_vertex_attrib_integer_64bit')

defines.add(GL_INT64_NV)
defines.add(GL_UNSIGNED_INT64_NV)

# GL_NV_vertex_buffer_unified_memory

GL_COLOR_ARRAY_ADDRESS_NV = Enumerant('GL_COLOR_ARRAY_ADDRESS_NV', 0x8f23, 'GL_NV_vertex_buffer_unified_memory')
GL_COLOR_ARRAY_LENGTH_NV = Enumerant('GL_COLOR_ARRAY_LENGTH_NV', 0x8f2d, 'GL_NV_vertex_buffer_unified_memory')
GL_DRAW_INDIRECT_ADDRESS_NV = Enumerant('GL_DRAW_INDIRECT_ADDRESS_NV', 0x8f41, 'GL_NV_vertex_buffer_unified_memory')
GL_DRAW_INDIRECT_LENGTH_NV = Enumerant('GL_DRAW_INDIRECT_LENGTH_NV', 0x8f42, 'GL_NV_vertex_buffer_unified_memory')
GL_DRAW_INDIRECT_UNIFIED_NV = Enumerant('GL_DRAW_INDIRECT_UNIFIED_NV', 0x8f40, 'GL_NV_vertex_buffer_unified_memory')
GL_EDGE_FLAG_ARRAY_ADDRESS_NV = Enumerant('GL_EDGE_FLAG_ARRAY_ADDRESS_NV', 0x8f26, 'GL_NV_vertex_buffer_unified_memory')
GL_EDGE_FLAG_ARRAY_LENGTH_NV = Enumerant('GL_EDGE_FLAG_ARRAY_LENGTH_NV', 0x8f30, 'GL_NV_vertex_buffer_unified_memory')
GL_ELEMENT_ARRAY_ADDRESS_NV = Enumerant('GL_ELEMENT_ARRAY_ADDRESS_NV', 0x8f29, 'GL_NV_vertex_buffer_unified_memory')
GL_ELEMENT_ARRAY_LENGTH_NV = Enumerant('GL_ELEMENT_ARRAY_LENGTH_NV', 0x8f33, 'GL_NV_vertex_buffer_unified_memory')
GL_ELEMENT_ARRAY_UNIFIED_NV = Enumerant('GL_ELEMENT_ARRAY_UNIFIED_NV', 0x8f1f, 'GL_NV_vertex_buffer_unified_memory')
GL_FOG_COORD_ARRAY_ADDRESS_NV = Enumerant('GL_FOG_COORD_ARRAY_ADDRESS_NV', 0x8f28, 'GL_NV_vertex_buffer_unified_memory')
GL_FOG_COORD_ARRAY_LENGTH_NV = Enumerant('GL_FOG_COORD_ARRAY_LENGTH_NV', 0x8f32, 'GL_NV_vertex_buffer_unified_memory')
GL_INDEX_ARRAY_ADDRESS_NV = Enumerant('GL_INDEX_ARRAY_ADDRESS_NV', 0x8f24, 'GL_NV_vertex_buffer_unified_memory')
GL_INDEX_ARRAY_LENGTH_NV = Enumerant('GL_INDEX_ARRAY_LENGTH_NV', 0x8f2e, 'GL_NV_vertex_buffer_unified_memory')
GL_NORMAL_ARRAY_ADDRESS_NV = Enumerant('GL_NORMAL_ARRAY_ADDRESS_NV', 0x8f22, 'GL_NV_vertex_buffer_unified_memory')
GL_NORMAL_ARRAY_LENGTH_NV = Enumerant('GL_NORMAL_ARRAY_LENGTH_NV', 0x8f2c, 'GL_NV_vertex_buffer_unified_memory')
GL_SECONDARY_COLOR_ARRAY_ADDRESS_NV = Enumerant('GL_SECONDARY_COLOR_ARRAY_ADDRESS_NV', 0x8f27, 'GL_NV_vertex_buffer_unified_memory')
GL_SECONDARY_COLOR_ARRAY_LENGTH_NV = Enumerant('GL_SECONDARY_COLOR_ARRAY_LENGTH_NV', 0x8f31, 'GL_NV_vertex_buffer_unified_memory')
GL_TEXTURE_COORD_ARRAY_ADDRESS_NV = Enumerant('GL_TEXTURE_COORD_ARRAY_ADDRESS_NV', 0x8f25, 'GL_NV_vertex_buffer_unified_memory')
GL_TEXTURE_COORD_ARRAY_LENGTH_NV = Enumerant('GL_TEXTURE_COORD_ARRAY_LENGTH_NV', 0x8f2f, 'GL_NV_vertex_buffer_unified_memory')
GL_VERTEX_ARRAY_ADDRESS_NV = Enumerant('GL_VERTEX_ARRAY_ADDRESS_NV', 0x8f21, 'GL_NV_vertex_buffer_unified_memory')
GL_VERTEX_ARRAY_LENGTH_NV = Enumerant('GL_VERTEX_ARRAY_LENGTH_NV', 0x8f2b, 'GL_NV_vertex_buffer_unified_memory')
GL_VERTEX_ATTRIB_ARRAY_ADDRESS_NV = Enumerant('GL_VERTEX_ATTRIB_ARRAY_ADDRESS_NV', 0x8f20, 'GL_NV_vertex_buffer_unified_memory')
GL_VERTEX_ATTRIB_ARRAY_LENGTH_NV = Enumerant('GL_VERTEX_ATTRIB_ARRAY_LENGTH_NV', 0x8f2a, 'GL_NV_vertex_buffer_unified_memory')
GL_VERTEX_ATTRIB_ARRAY_UNIFIED_NV = Enumerant('GL_VERTEX_ATTRIB_ARRAY_UNIFIED_NV', 0x8f1e, 'GL_NV_vertex_buffer_unified_memory')

defines.add(GL_COLOR_ARRAY_ADDRESS_NV)
defines.add(GL_COLOR_ARRAY_LENGTH_NV)
defines.add(GL_DRAW_INDIRECT_ADDRESS_NV)
defines.add(GL_DRAW_INDIRECT_LENGTH_NV)
defines.add(GL_DRAW_INDIRECT_UNIFIED_NV)
defines.add(GL_EDGE_FLAG_ARRAY_ADDRESS_NV)
defines.add(GL_EDGE_FLAG_ARRAY_LENGTH_NV)
defines.add(GL_ELEMENT_ARRAY_ADDRESS_NV)
defines.add(GL_ELEMENT_ARRAY_LENGTH_NV)
defines.add(GL_ELEMENT_ARRAY_UNIFIED_NV)
defines.add(GL_FOG_COORD_ARRAY_ADDRESS_NV)
defines.add(GL_FOG_COORD_ARRAY_LENGTH_NV)
defines.add(GL_INDEX_ARRAY_ADDRESS_NV)
defines.add(GL_INDEX_ARRAY_LENGTH_NV)
defines.add(GL_NORMAL_ARRAY_ADDRESS_NV)
defines.add(GL_NORMAL_ARRAY_LENGTH_NV)
defines.add(GL_SECONDARY_COLOR_ARRAY_ADDRESS_NV)
defines.add(GL_SECONDARY_COLOR_ARRAY_LENGTH_NV)
defines.add(GL_TEXTURE_COORD_ARRAY_ADDRESS_NV)
defines.add(GL_TEXTURE_COORD_ARRAY_LENGTH_NV)
defines.add(GL_VERTEX_ARRAY_ADDRESS_NV)
defines.add(GL_VERTEX_ARRAY_LENGTH_NV)
defines.add(GL_VERTEX_ATTRIB_ARRAY_ADDRESS_NV)
defines.add(GL_VERTEX_ATTRIB_ARRAY_LENGTH_NV)
defines.add(GL_VERTEX_ATTRIB_ARRAY_UNIFIED_NV)

# GL_NV_vertex_program

GL_ATTRIB_ARRAY_POINTER_NV = Enumerant('GL_ATTRIB_ARRAY_POINTER_NV', 0x8645, 'GL_NV_vertex_program')
GL_ATTRIB_ARRAY_SIZE_NV = Enumerant('GL_ATTRIB_ARRAY_SIZE_NV', 0x8623, 'GL_NV_vertex_program')
GL_ATTRIB_ARRAY_STRIDE_NV = Enumerant('GL_ATTRIB_ARRAY_STRIDE_NV', 0x8624, 'GL_NV_vertex_program')
GL_ATTRIB_ARRAY_TYPE_NV = Enumerant('GL_ATTRIB_ARRAY_TYPE_NV', 0x8625, 'GL_NV_vertex_program')
GL_CURRENT_ATTRIB_NV = Enumerant('GL_CURRENT_ATTRIB_NV', 0x8626, 'GL_NV_vertex_program')
GL_CURRENT_MATRIX_NV = Enumerant('GL_CURRENT_MATRIX_NV', 0x8641, 'GL_NV_vertex_program')
GL_CURRENT_MATRIX_STACK_DEPTH_NV = Enumerant('GL_CURRENT_MATRIX_STACK_DEPTH_NV', 0x8640, 'GL_NV_vertex_program')
GL_IDENTITY_NV = Enumerant('GL_IDENTITY_NV', 0x862a, 'GL_NV_vertex_program')
GL_INVERSE_NV = Enumerant('GL_INVERSE_NV', 0x862b, 'GL_NV_vertex_program')
GL_INVERSE_TRANSPOSE_NV = Enumerant('GL_INVERSE_TRANSPOSE_NV', 0x862d, 'GL_NV_vertex_program')
GL_MAP1_VERTEX_ATTRIB0_4_NV = Enumerant('GL_MAP1_VERTEX_ATTRIB0_4_NV', 0x8660, 'GL_NV_vertex_program')
GL_MAP1_VERTEX_ATTRIB10_4_NV = Enumerant('GL_MAP1_VERTEX_ATTRIB10_4_NV', 0x866a, 'GL_NV_vertex_program')
GL_MAP1_VERTEX_ATTRIB11_4_NV = Enumerant('GL_MAP1_VERTEX_ATTRIB11_4_NV', 0x866b, 'GL_NV_vertex_program')
GL_MAP1_VERTEX_ATTRIB12_4_NV = Enumerant('GL_MAP1_VERTEX_ATTRIB12_4_NV', 0x866c, 'GL_NV_vertex_program')
GL_MAP1_VERTEX_ATTRIB13_4_NV = Enumerant('GL_MAP1_VERTEX_ATTRIB13_4_NV', 0x866d, 'GL_NV_vertex_program')
GL_MAP1_VERTEX_ATTRIB14_4_NV = Enumerant('GL_MAP1_VERTEX_ATTRIB14_4_NV', 0x866e, 'GL_NV_vertex_program')
GL_MAP1_VERTEX_ATTRIB15_4_NV = Enumerant('GL_MAP1_VERTEX_ATTRIB15_4_NV', 0x866f, 'GL_NV_vertex_program')
GL_MAP1_VERTEX_ATTRIB1_4_NV = Enumerant('GL_MAP1_VERTEX_ATTRIB1_4_NV', 0x8661, 'GL_NV_vertex_program')
GL_MAP1_VERTEX_ATTRIB2_4_NV = Enumerant('GL_MAP1_VERTEX_ATTRIB2_4_NV', 0x8662, 'GL_NV_vertex_program')
GL_MAP1_VERTEX_ATTRIB3_4_NV = Enumerant('GL_MAP1_VERTEX_ATTRIB3_4_NV', 0x8663, 'GL_NV_vertex_program')
GL_MAP1_VERTEX_ATTRIB4_4_NV = Enumerant('GL_MAP1_VERTEX_ATTRIB4_4_NV', 0x8664, 'GL_NV_vertex_program')
GL_MAP1_VERTEX_ATTRIB5_4_NV = Enumerant('GL_MAP1_VERTEX_ATTRIB5_4_NV', 0x8665, 'GL_NV_vertex_program')
GL_MAP1_VERTEX_ATTRIB6_4_NV = Enumerant('GL_MAP1_VERTEX_ATTRIB6_4_NV', 0x8666, 'GL_NV_vertex_program')
GL_MAP1_VERTEX_ATTRIB7_4_NV = Enumerant('GL_MAP1_VERTEX_ATTRIB7_4_NV', 0x8667, 'GL_NV_vertex_program')
GL_MAP1_VERTEX_ATTRIB8_4_NV = Enumerant('GL_MAP1_VERTEX_ATTRIB8_4_NV', 0x8668, 'GL_NV_vertex_program')
GL_MAP1_VERTEX_ATTRIB9_4_NV = Enumerant('GL_MAP1_VERTEX_ATTRIB9_4_NV', 0x8669, 'GL_NV_vertex_program')
GL_MAP2_VERTEX_ATTRIB0_4_NV = Enumerant('GL_MAP2_VERTEX_ATTRIB0_4_NV', 0x8670, 'GL_NV_vertex_program')
GL_MAP2_VERTEX_ATTRIB10_4_NV = Enumerant('GL_MAP2_VERTEX_ATTRIB10_4_NV', 0x867a, 'GL_NV_vertex_program')
GL_MAP2_VERTEX_ATTRIB11_4_NV = Enumerant('GL_MAP2_VERTEX_ATTRIB11_4_NV', 0x867b, 'GL_NV_vertex_program')
GL_MAP2_VERTEX_ATTRIB12_4_NV = Enumerant('GL_MAP2_VERTEX_ATTRIB12_4_NV', 0x867c, 'GL_NV_vertex_program')
GL_MAP2_VERTEX_ATTRIB13_4_NV = Enumerant('GL_MAP2_VERTEX_ATTRIB13_4_NV', 0x867d, 'GL_NV_vertex_program')
GL_MAP2_VERTEX_ATTRIB14_4_NV = Enumerant('GL_MAP2_VERTEX_ATTRIB14_4_NV', 0x867e, 'GL_NV_vertex_program')
GL_MAP2_VERTEX_ATTRIB15_4_NV = Enumerant('GL_MAP2_VERTEX_ATTRIB15_4_NV', 0x867f, 'GL_NV_vertex_program')
GL_MAP2_VERTEX_ATTRIB1_4_NV = Enumerant('GL_MAP2_VERTEX_ATTRIB1_4_NV', 0x8671, 'GL_NV_vertex_program')
GL_MAP2_VERTEX_ATTRIB2_4_NV = Enumerant('GL_MAP2_VERTEX_ATTRIB2_4_NV', 0x8672, 'GL_NV_vertex_program')
GL_MAP2_VERTEX_ATTRIB3_4_NV = Enumerant('GL_MAP2_VERTEX_ATTRIB3_4_NV', 0x8673, 'GL_NV_vertex_program')
GL_MAP2_VERTEX_ATTRIB4_4_NV = Enumerant('GL_MAP2_VERTEX_ATTRIB4_4_NV', 0x8674, 'GL_NV_vertex_program')
GL_MAP2_VERTEX_ATTRIB5_4_NV = Enumerant('GL_MAP2_VERTEX_ATTRIB5_4_NV', 0x8675, 'GL_NV_vertex_program')
GL_MAP2_VERTEX_ATTRIB6_4_NV = Enumerant('GL_MAP2_VERTEX_ATTRIB6_4_NV', 0x8676, 'GL_NV_vertex_program')
GL_MAP2_VERTEX_ATTRIB7_4_NV = Enumerant('GL_MAP2_VERTEX_ATTRIB7_4_NV', 0x8677, 'GL_NV_vertex_program')
GL_MAP2_VERTEX_ATTRIB8_4_NV = Enumerant('GL_MAP2_VERTEX_ATTRIB8_4_NV', 0x8678, 'GL_NV_vertex_program')
GL_MAP2_VERTEX_ATTRIB9_4_NV = Enumerant('GL_MAP2_VERTEX_ATTRIB9_4_NV', 0x8679, 'GL_NV_vertex_program')
GL_MATRIX0_NV = Enumerant('GL_MATRIX0_NV', 0x8630, 'GL_NV_vertex_program')
GL_MATRIX1_NV = Enumerant('GL_MATRIX1_NV', 0x8631, 'GL_NV_vertex_program')
GL_MATRIX2_NV = Enumerant('GL_MATRIX2_NV', 0x8632, 'GL_NV_vertex_program')
GL_MATRIX3_NV = Enumerant('GL_MATRIX3_NV', 0x8633, 'GL_NV_vertex_program')
GL_MATRIX4_NV = Enumerant('GL_MATRIX4_NV', 0x8634, 'GL_NV_vertex_program')
GL_MATRIX5_NV = Enumerant('GL_MATRIX5_NV', 0x8635, 'GL_NV_vertex_program')
GL_MATRIX6_NV = Enumerant('GL_MATRIX6_NV', 0x8636, 'GL_NV_vertex_program')
GL_MATRIX7_NV = Enumerant('GL_MATRIX7_NV', 0x8637, 'GL_NV_vertex_program')
GL_MAX_TRACK_MATRICES_NV = Enumerant('GL_MAX_TRACK_MATRICES_NV', 0x862f, 'GL_NV_vertex_program')
GL_MAX_TRACK_MATRIX_STACK_DEPTH_NV = Enumerant('GL_MAX_TRACK_MATRIX_STACK_DEPTH_NV', 0x862e, 'GL_NV_vertex_program')
GL_MODELVIEW_PROJECTION_NV = Enumerant('GL_MODELVIEW_PROJECTION_NV', 0x8629, 'GL_NV_vertex_program')
GL_PROGRAM_ERROR_POSITION_NV = Enumerant('GL_PROGRAM_ERROR_POSITION_NV', 0x864b, 'GL_NV_vertex_program')
GL_PROGRAM_LENGTH_NV = Enumerant('GL_PROGRAM_LENGTH_NV', 0x8627, 'GL_NV_vertex_program')
GL_PROGRAM_PARAMETER_NV = Enumerant('GL_PROGRAM_PARAMETER_NV', 0x8644, 'GL_NV_vertex_program')
GL_PROGRAM_RESIDENT_NV = Enumerant('GL_PROGRAM_RESIDENT_NV', 0x8647, 'GL_NV_vertex_program')
GL_PROGRAM_STRING_NV = Enumerant('GL_PROGRAM_STRING_NV', 0x8628, 'GL_NV_vertex_program')
GL_PROGRAM_TARGET_NV = Enumerant('GL_PROGRAM_TARGET_NV', 0x8646, 'GL_NV_vertex_program')
GL_TRACK_MATRIX_NV = Enumerant('GL_TRACK_MATRIX_NV', 0x8648, 'GL_NV_vertex_program')
GL_TRACK_MATRIX_TRANSFORM_NV = Enumerant('GL_TRACK_MATRIX_TRANSFORM_NV', 0x8649, 'GL_NV_vertex_program')
GL_TRANSPOSE_NV = Enumerant('GL_TRANSPOSE_NV', 0x862c, 'GL_NV_vertex_program')
GL_VERTEX_ATTRIB_ARRAY0_NV = Enumerant('GL_VERTEX_ATTRIB_ARRAY0_NV', 0x8650, 'GL_NV_vertex_program')
GL_VERTEX_ATTRIB_ARRAY10_NV = Enumerant('GL_VERTEX_ATTRIB_ARRAY10_NV', 0x865a, 'GL_NV_vertex_program')
GL_VERTEX_ATTRIB_ARRAY11_NV = Enumerant('GL_VERTEX_ATTRIB_ARRAY11_NV', 0x865b, 'GL_NV_vertex_program')
GL_VERTEX_ATTRIB_ARRAY12_NV = Enumerant('GL_VERTEX_ATTRIB_ARRAY12_NV', 0x865c, 'GL_NV_vertex_program')
GL_VERTEX_ATTRIB_ARRAY13_NV = Enumerant('GL_VERTEX_ATTRIB_ARRAY13_NV', 0x865d, 'GL_NV_vertex_program')
GL_VERTEX_ATTRIB_ARRAY14_NV = Enumerant('GL_VERTEX_ATTRIB_ARRAY14_NV', 0x865e, 'GL_NV_vertex_program')
GL_VERTEX_ATTRIB_ARRAY15_NV = Enumerant('GL_VERTEX_ATTRIB_ARRAY15_NV', 0x865f, 'GL_NV_vertex_program')
GL_VERTEX_ATTRIB_ARRAY1_NV = Enumerant('GL_VERTEX_ATTRIB_ARRAY1_NV', 0x8651, 'GL_NV_vertex_program')
GL_VERTEX_ATTRIB_ARRAY2_NV = Enumerant('GL_VERTEX_ATTRIB_ARRAY2_NV', 0x8652, 'GL_NV_vertex_program')
GL_VERTEX_ATTRIB_ARRAY3_NV = Enumerant('GL_VERTEX_ATTRIB_ARRAY3_NV', 0x8653, 'GL_NV_vertex_program')
GL_VERTEX_ATTRIB_ARRAY4_NV = Enumerant('GL_VERTEX_ATTRIB_ARRAY4_NV', 0x8654, 'GL_NV_vertex_program')
GL_VERTEX_ATTRIB_ARRAY5_NV = Enumerant('GL_VERTEX_ATTRIB_ARRAY5_NV', 0x8655, 'GL_NV_vertex_program')
GL_VERTEX_ATTRIB_ARRAY6_NV = Enumerant('GL_VERTEX_ATTRIB_ARRAY6_NV', 0x8656, 'GL_NV_vertex_program')
GL_VERTEX_ATTRIB_ARRAY7_NV = Enumerant('GL_VERTEX_ATTRIB_ARRAY7_NV', 0x8657, 'GL_NV_vertex_program')
GL_VERTEX_ATTRIB_ARRAY8_NV = Enumerant('GL_VERTEX_ATTRIB_ARRAY8_NV', 0x8658, 'GL_NV_vertex_program')
GL_VERTEX_ATTRIB_ARRAY9_NV = Enumerant('GL_VERTEX_ATTRIB_ARRAY9_NV', 0x8659, 'GL_NV_vertex_program')
GL_VERTEX_PROGRAM_BINDING_NV = Enumerant('GL_VERTEX_PROGRAM_BINDING_NV', 0x864a, 'GL_NV_vertex_program')
GL_VERTEX_PROGRAM_NV = Enumerant('GL_VERTEX_PROGRAM_NV', 0x8620, 'GL_NV_vertex_program')
GL_VERTEX_PROGRAM_POINT_SIZE_NV = Enumerant('GL_VERTEX_PROGRAM_POINT_SIZE_NV', 0x8642, 'GL_NV_vertex_program')
GL_VERTEX_PROGRAM_TWO_SIDE_NV = Enumerant('GL_VERTEX_PROGRAM_TWO_SIDE_NV', 0x8643, 'GL_NV_vertex_program')
GL_VERTEX_STATE_PROGRAM_NV = Enumerant('GL_VERTEX_STATE_PROGRAM_NV', 0x8621, 'GL_NV_vertex_program')

defines.add(GL_ATTRIB_ARRAY_POINTER_NV)
defines.add(GL_ATTRIB_ARRAY_SIZE_NV)
defines.add(GL_ATTRIB_ARRAY_STRIDE_NV)
defines.add(GL_ATTRIB_ARRAY_TYPE_NV)
defines.add(GL_CURRENT_ATTRIB_NV)
defines.add(GL_CURRENT_MATRIX_NV)
defines.add(GL_CURRENT_MATRIX_STACK_DEPTH_NV)
defines.add(GL_IDENTITY_NV)
defines.add(GL_INVERSE_NV)
defines.add(GL_INVERSE_TRANSPOSE_NV)
defines.add(GL_MAP1_VERTEX_ATTRIB0_4_NV)
defines.add(GL_MAP1_VERTEX_ATTRIB10_4_NV)
defines.add(GL_MAP1_VERTEX_ATTRIB11_4_NV)
defines.add(GL_MAP1_VERTEX_ATTRIB12_4_NV)
defines.add(GL_MAP1_VERTEX_ATTRIB13_4_NV)
defines.add(GL_MAP1_VERTEX_ATTRIB14_4_NV)
defines.add(GL_MAP1_VERTEX_ATTRIB15_4_NV)
defines.add(GL_MAP1_VERTEX_ATTRIB1_4_NV)
defines.add(GL_MAP1_VERTEX_ATTRIB2_4_NV)
defines.add(GL_MAP1_VERTEX_ATTRIB3_4_NV)
defines.add(GL_MAP1_VERTEX_ATTRIB4_4_NV)
defines.add(GL_MAP1_VERTEX_ATTRIB5_4_NV)
defines.add(GL_MAP1_VERTEX_ATTRIB6_4_NV)
defines.add(GL_MAP1_VERTEX_ATTRIB7_4_NV)
defines.add(GL_MAP1_VERTEX_ATTRIB8_4_NV)
defines.add(GL_MAP1_VERTEX_ATTRIB9_4_NV)
defines.add(GL_MAP2_VERTEX_ATTRIB0_4_NV)
defines.add(GL_MAP2_VERTEX_ATTRIB10_4_NV)
defines.add(GL_MAP2_VERTEX_ATTRIB11_4_NV)
defines.add(GL_MAP2_VERTEX_ATTRIB12_4_NV)
defines.add(GL_MAP2_VERTEX_ATTRIB13_4_NV)
defines.add(GL_MAP2_VERTEX_ATTRIB14_4_NV)
defines.add(GL_MAP2_VERTEX_ATTRIB15_4_NV)
defines.add(GL_MAP2_VERTEX_ATTRIB1_4_NV)
defines.add(GL_MAP2_VERTEX_ATTRIB2_4_NV)
defines.add(GL_MAP2_VERTEX_ATTRIB3_4_NV)
defines.add(GL_MAP2_VERTEX_ATTRIB4_4_NV)
defines.add(GL_MAP2_VERTEX_ATTRIB5_4_NV)
defines.add(GL_MAP2_VERTEX_ATTRIB6_4_NV)
defines.add(GL_MAP2_VERTEX_ATTRIB7_4_NV)
defines.add(GL_MAP2_VERTEX_ATTRIB8_4_NV)
defines.add(GL_MAP2_VERTEX_ATTRIB9_4_NV)
defines.add(GL_MATRIX0_NV)
defines.add(GL_MATRIX1_NV)
defines.add(GL_MATRIX2_NV)
defines.add(GL_MATRIX3_NV)
defines.add(GL_MATRIX4_NV)
defines.add(GL_MATRIX5_NV)
defines.add(GL_MATRIX6_NV)
defines.add(GL_MATRIX7_NV)
defines.add(GL_MAX_TRACK_MATRICES_NV)
defines.add(GL_MAX_TRACK_MATRIX_STACK_DEPTH_NV)
defines.add(GL_MODELVIEW_PROJECTION_NV)
defines.add(GL_PROGRAM_ERROR_POSITION_NV)
defines.add(GL_PROGRAM_LENGTH_NV)
defines.add(GL_PROGRAM_PARAMETER_NV)
defines.add(GL_PROGRAM_RESIDENT_NV)
defines.add(GL_PROGRAM_STRING_NV)
defines.add(GL_PROGRAM_TARGET_NV)
defines.add(GL_TRACK_MATRIX_NV)
defines.add(GL_TRACK_MATRIX_TRANSFORM_NV)
defines.add(GL_TRANSPOSE_NV)
defines.add(GL_VERTEX_ATTRIB_ARRAY0_NV)
defines.add(GL_VERTEX_ATTRIB_ARRAY10_NV)
defines.add(GL_VERTEX_ATTRIB_ARRAY11_NV)
defines.add(GL_VERTEX_ATTRIB_ARRAY12_NV)
defines.add(GL_VERTEX_ATTRIB_ARRAY13_NV)
defines.add(GL_VERTEX_ATTRIB_ARRAY14_NV)
defines.add(GL_VERTEX_ATTRIB_ARRAY15_NV)
defines.add(GL_VERTEX_ATTRIB_ARRAY1_NV)
defines.add(GL_VERTEX_ATTRIB_ARRAY2_NV)
defines.add(GL_VERTEX_ATTRIB_ARRAY3_NV)
defines.add(GL_VERTEX_ATTRIB_ARRAY4_NV)
defines.add(GL_VERTEX_ATTRIB_ARRAY5_NV)
defines.add(GL_VERTEX_ATTRIB_ARRAY6_NV)
defines.add(GL_VERTEX_ATTRIB_ARRAY7_NV)
defines.add(GL_VERTEX_ATTRIB_ARRAY8_NV)
defines.add(GL_VERTEX_ATTRIB_ARRAY9_NV)
defines.add(GL_VERTEX_PROGRAM_BINDING_NV)
defines.add(GL_VERTEX_PROGRAM_NV)
defines.add(GL_VERTEX_PROGRAM_POINT_SIZE_NV)
defines.add(GL_VERTEX_PROGRAM_TWO_SIDE_NV)
defines.add(GL_VERTEX_STATE_PROGRAM_NV)

# GL_NV_vertex_program2_option

GL_MAX_PROGRAM_CALL_DEPTH_NV = Enumerant('GL_MAX_PROGRAM_CALL_DEPTH_NV', 0x88f5, 'GL_NV_vertex_program2_option')
GL_MAX_PROGRAM_EXEC_INSTRUCTIONS_NV = Enumerant('GL_MAX_PROGRAM_EXEC_INSTRUCTIONS_NV', 0x88f4, 'GL_NV_vertex_program2_option')

defines.add(GL_MAX_PROGRAM_CALL_DEPTH_NV)
defines.add(GL_MAX_PROGRAM_EXEC_INSTRUCTIONS_NV)

# GL_NV_vertex_program3

MAX_VERTEX_TEXTURE_IMAGE_UNITS_ARB = Enumerant('MAX_VERTEX_TEXTURE_IMAGE_UNITS_ARB', 0x8b4c, 'GL_NV_vertex_program3')

defines.add(MAX_VERTEX_TEXTURE_IMAGE_UNITS_ARB)

# GL_NV_vertex_program4

GL_VERTEX_ATTRIB_ARRAY_INTEGER_NV = Enumerant('GL_VERTEX_ATTRIB_ARRAY_INTEGER_NV', 0x88fd, 'GL_NV_vertex_program4')

defines.add(GL_VERTEX_ATTRIB_ARRAY_INTEGER_NV)

# GL_NV_video_capture

GL_FAILURE_NV = Enumerant('GL_FAILURE_NV', 0x9030, 'GL_NV_video_capture')
GL_FIELD_LOWER_NV = Enumerant('GL_FIELD_LOWER_NV', 0x9023, 'GL_NV_video_capture')
GL_FIELD_UPPER_NV = Enumerant('GL_FIELD_UPPER_NV', 0x9022, 'GL_NV_video_capture')
GL_LAST_VIDEO_CAPTURE_STATUS_NV = Enumerant('GL_LAST_VIDEO_CAPTURE_STATUS_NV', 0x9027, 'GL_NV_video_capture')
GL_NEXT_VIDEO_CAPTURE_BUFFER_STATUS_NV = Enumerant('GL_NEXT_VIDEO_CAPTURE_BUFFER_STATUS_NV', 0x9025, 'GL_NV_video_capture')
GL_NUM_VIDEO_CAPTURE_STREAMS_NV = Enumerant('GL_NUM_VIDEO_CAPTURE_STREAMS_NV', 0x9024, 'GL_NV_video_capture')
GL_PARTIAL_SUCCESS_NV = Enumerant('GL_PARTIAL_SUCCESS_NV', 0x902e, 'GL_NV_video_capture')
GL_SUCCESS_NV = Enumerant('GL_SUCCESS_NV', 0x902f, 'GL_NV_video_capture')
GL_VIDEO_BUFFER_BINDING_NV = Enumerant('GL_VIDEO_BUFFER_BINDING_NV', 0x9021, 'GL_NV_video_capture')
GL_VIDEO_BUFFER_INTERNAL_FORMAT_NV = Enumerant('GL_VIDEO_BUFFER_INTERNAL_FORMAT_NV', 0x902d, 'GL_NV_video_capture')
GL_VIDEO_BUFFER_NV = Enumerant('GL_VIDEO_BUFFER_NV', 0x9020, 'GL_NV_video_capture')
GL_VIDEO_BUFFER_PITCH_NV = Enumerant('GL_VIDEO_BUFFER_PITCH_NV', 0x9028, 'GL_NV_video_capture')
GL_VIDEO_CAPTURE_FIELD_LOWER_HEIGHT_NV = Enumerant('GL_VIDEO_CAPTURE_FIELD_LOWER_HEIGHT_NV', 0x903b, 'GL_NV_video_capture')
GL_VIDEO_CAPTURE_FIELD_UPPER_HEIGHT_NV = Enumerant('GL_VIDEO_CAPTURE_FIELD_UPPER_HEIGHT_NV', 0x903a, 'GL_NV_video_capture')
GL_VIDEO_CAPTURE_FRAME_HEIGHT_NV = Enumerant('GL_VIDEO_CAPTURE_FRAME_HEIGHT_NV', 0x9039, 'GL_NV_video_capture')
GL_VIDEO_CAPTURE_FRAME_WIDTH_NV = Enumerant('GL_VIDEO_CAPTURE_FRAME_WIDTH_NV', 0x9038, 'GL_NV_video_capture')
GL_VIDEO_CAPTURE_SURFACE_ORIGIN_NV = Enumerant('GL_VIDEO_CAPTURE_SURFACE_ORIGIN_NV', 0x903c, 'GL_NV_video_capture')
GL_VIDEO_CAPTURE_TO_422_SUPPORTED_NV = Enumerant('GL_VIDEO_CAPTURE_TO_422_SUPPORTED_NV', 0x9026, 'GL_NV_video_capture')
GL_VIDEO_COLOR_CONVERSION_MATRIX_NV = Enumerant('GL_VIDEO_COLOR_CONVERSION_MATRIX_NV', 0x9029, 'GL_NV_video_capture')
GL_VIDEO_COLOR_CONVERSION_MAX_NV = Enumerant('GL_VIDEO_COLOR_CONVERSION_MAX_NV', 0x902a, 'GL_NV_video_capture')
GL_VIDEO_COLOR_CONVERSION_MIN_NV = Enumerant('GL_VIDEO_COLOR_CONVERSION_MIN_NV', 0x902b, 'GL_NV_video_capture')
GL_VIDEO_COLOR_CONVERSION_OFFSET_NV = Enumerant('GL_VIDEO_COLOR_CONVERSION_OFFSET_NV', 0x902c, 'GL_NV_video_capture')
GL_YCBAYCR8A_4224_NV = Enumerant('GL_YCBAYCR8A_4224_NV', 0x9032, 'GL_NV_video_capture')
GL_YCBYCR8_422_NV = Enumerant('GL_YCBYCR8_422_NV', 0x9031, 'GL_NV_video_capture')
GL_Z4Y12Z4CB12Z4A12Z4Y12Z4CR12Z4A12_4224_NV = Enumerant('GL_Z4Y12Z4CB12Z4A12Z4Y12Z4CR12Z4A12_4224_NV', 0x9036, 'GL_NV_video_capture')
GL_Z4Y12Z4CB12Z4CR12_444_NV = Enumerant('GL_Z4Y12Z4CB12Z4CR12_444_NV', 0x9037, 'GL_NV_video_capture')
GL_Z4Y12Z4CB12Z4Y12Z4CR12_422_NV = Enumerant('GL_Z4Y12Z4CB12Z4Y12Z4CR12_422_NV', 0x9035, 'GL_NV_video_capture')
GL_Z6Y10Z6CB10Z6A10Z6Y10Z6CR10Z6A10_4224_NV = Enumerant('GL_Z6Y10Z6CB10Z6A10Z6Y10Z6CR10Z6A10_4224_NV', 0x9034, 'GL_NV_video_capture')
GL_Z6Y10Z6CB10Z6Y10Z6CR10_422_NV = Enumerant('GL_Z6Y10Z6CB10Z6Y10Z6CR10_422_NV', 0x9033, 'GL_NV_video_capture')

defines.add(GL_FAILURE_NV)
defines.add(GL_FIELD_LOWER_NV)
defines.add(GL_FIELD_UPPER_NV)
defines.add(GL_LAST_VIDEO_CAPTURE_STATUS_NV)
defines.add(GL_NEXT_VIDEO_CAPTURE_BUFFER_STATUS_NV)
defines.add(GL_NUM_VIDEO_CAPTURE_STREAMS_NV)
defines.add(GL_PARTIAL_SUCCESS_NV)
defines.add(GL_SUCCESS_NV)
defines.add(GL_VIDEO_BUFFER_BINDING_NV)
defines.add(GL_VIDEO_BUFFER_INTERNAL_FORMAT_NV)
defines.add(GL_VIDEO_BUFFER_NV)
defines.add(GL_VIDEO_BUFFER_PITCH_NV)
defines.add(GL_VIDEO_CAPTURE_FIELD_LOWER_HEIGHT_NV)
defines.add(GL_VIDEO_CAPTURE_FIELD_UPPER_HEIGHT_NV)
defines.add(GL_VIDEO_CAPTURE_FRAME_HEIGHT_NV)
defines.add(GL_VIDEO_CAPTURE_FRAME_WIDTH_NV)
defines.add(GL_VIDEO_CAPTURE_SURFACE_ORIGIN_NV)
defines.add(GL_VIDEO_CAPTURE_TO_422_SUPPORTED_NV)
defines.add(GL_VIDEO_COLOR_CONVERSION_MATRIX_NV)
defines.add(GL_VIDEO_COLOR_CONVERSION_MAX_NV)
defines.add(GL_VIDEO_COLOR_CONVERSION_MIN_NV)
defines.add(GL_VIDEO_COLOR_CONVERSION_OFFSET_NV)
defines.add(GL_YCBAYCR8A_4224_NV)
defines.add(GL_YCBYCR8_422_NV)
defines.add(GL_Z4Y12Z4CB12Z4A12Z4Y12Z4CR12Z4A12_4224_NV)
defines.add(GL_Z4Y12Z4CB12Z4CR12_444_NV)
defines.add(GL_Z4Y12Z4CB12Z4Y12Z4CR12_422_NV)
defines.add(GL_Z6Y10Z6CB10Z6A10Z6Y10Z6CR10Z6A10_4224_NV)
defines.add(GL_Z6Y10Z6CB10Z6Y10Z6CR10_422_NV)

# GL_OES_EGL_image_external

GL_REQUIRED_TEXTURE_IMAGE_UNITS_OES = Enumerant('GL_REQUIRED_TEXTURE_IMAGE_UNITS_OES', 0x8d68, 'GL_OES_EGL_image_external')
GL_SAMPLER_EXTERNAL_OES = Enumerant('GL_SAMPLER_EXTERNAL_OES', 0x8d66, 'GL_OES_EGL_image_external')
GL_TEXTURE_BINDING_EXTERNAL_OES = Enumerant('GL_TEXTURE_BINDING_EXTERNAL_OES', 0x8d67, 'GL_OES_EGL_image_external')
GL_TEXTURE_EXTERNAL_OES = Enumerant('GL_TEXTURE_EXTERNAL_OES', 0x8d65, 'GL_OES_EGL_image_external')

defines.add(GL_REQUIRED_TEXTURE_IMAGE_UNITS_OES)
defines.add(GL_SAMPLER_EXTERNAL_OES)
defines.add(GL_TEXTURE_BINDING_EXTERNAL_OES)
defines.add(GL_TEXTURE_EXTERNAL_OES)

# GL_OES_blend_equation_separate

GL_BLEND_EQUATION_ALPHA_OES = Enumerant('GL_BLEND_EQUATION_ALPHA_OES', 0x883d, 'GL_OES_blend_equation_separate')
GL_BLEND_EQUATION_RGB_OES = Enumerant('GL_BLEND_EQUATION_RGB_OES', 0x8009, 'GL_OES_blend_equation_separate')

defines.add(GL_BLEND_EQUATION_ALPHA_OES)
defines.add(GL_BLEND_EQUATION_RGB_OES)

# GL_OES_blend_func_separate

GL_BLEND_DST_ALPHA_OES = Enumerant('GL_BLEND_DST_ALPHA_OES', 0x80ca, 'GL_OES_blend_func_separate')
GL_BLEND_DST_RGB_OES = Enumerant('GL_BLEND_DST_RGB_OES', 0x80c8, 'GL_OES_blend_func_separate')
GL_BLEND_SRC_ALPHA_OES = Enumerant('GL_BLEND_SRC_ALPHA_OES', 0x80cb, 'GL_OES_blend_func_separate')
GL_BLEND_SRC_RGB_OES = Enumerant('GL_BLEND_SRC_RGB_OES', 0x80c9, 'GL_OES_blend_func_separate')

defines.add(GL_BLEND_DST_ALPHA_OES)
defines.add(GL_BLEND_DST_RGB_OES)
defines.add(GL_BLEND_SRC_ALPHA_OES)
defines.add(GL_BLEND_SRC_RGB_OES)

# GL_OES_blend_subtract

GL_BLEND_EQUATION_OES = Enumerant('GL_BLEND_EQUATION_OES', 0x8009, 'GL_OES_blend_subtract')
GL_FUNC_ADD_OES = Enumerant('GL_FUNC_ADD_OES', 0x8006, 'GL_OES_blend_subtract')
GL_FUNC_REVERSE_SUBTRACT_OES = Enumerant('GL_FUNC_REVERSE_SUBTRACT_OES', 0x800b, 'GL_OES_blend_subtract')
GL_FUNC_SUBTRACT_OES = Enumerant('GL_FUNC_SUBTRACT_OES', 0x800a, 'GL_OES_blend_subtract')

defines.add(GL_BLEND_EQUATION_OES)
defines.add(GL_FUNC_ADD_OES)
defines.add(GL_FUNC_REVERSE_SUBTRACT_OES)
defines.add(GL_FUNC_SUBTRACT_OES)

# GL_OES_compressed_ETC1_RGB8_texture

GL_ETC1_RGB8_OES = Enumerant('GL_ETC1_RGB8_OES', 0x8d64, 'GL_OES_compressed_ETC1_RGB8_texture')

defines.add(GL_ETC1_RGB8_OES)

# GL_OES_compressed_paletted_texture

GL_PALETTE4_R5_G6_B5_OES = Enumerant('GL_PALETTE4_R5_G6_B5_OES', 0x8b92, 'GL_OES_compressed_paletted_texture')
GL_PALETTE4_RGB5_A1_OES = Enumerant('GL_PALETTE4_RGB5_A1_OES', 0x8b94, 'GL_OES_compressed_paletted_texture')
GL_PALETTE4_RGB8_OES = Enumerant('GL_PALETTE4_RGB8_OES', 0x8b90, 'GL_OES_compressed_paletted_texture')
GL_PALETTE4_RGBA4_OES = Enumerant('GL_PALETTE4_RGBA4_OES', 0x8b93, 'GL_OES_compressed_paletted_texture')
GL_PALETTE4_RGBA8_OES = Enumerant('GL_PALETTE4_RGBA8_OES', 0x8b91, 'GL_OES_compressed_paletted_texture')
GL_PALETTE8_R5_G6_B5_OES = Enumerant('GL_PALETTE8_R5_G6_B5_OES', 0x8b97, 'GL_OES_compressed_paletted_texture')
GL_PALETTE8_RGB5_A1_OES = Enumerant('GL_PALETTE8_RGB5_A1_OES', 0x8b99, 'GL_OES_compressed_paletted_texture')
GL_PALETTE8_RGB8_OES = Enumerant('GL_PALETTE8_RGB8_OES', 0x8b95, 'GL_OES_compressed_paletted_texture')
GL_PALETTE8_RGBA4_OES = Enumerant('GL_PALETTE8_RGBA4_OES', 0x8b98, 'GL_OES_compressed_paletted_texture')
GL_PALETTE8_RGBA8_OES = Enumerant('GL_PALETTE8_RGBA8_OES', 0x8b96, 'GL_OES_compressed_paletted_texture')

defines.add(GL_PALETTE4_R5_G6_B5_OES)
defines.add(GL_PALETTE4_RGB5_A1_OES)
defines.add(GL_PALETTE4_RGB8_OES)
defines.add(GL_PALETTE4_RGBA4_OES)
defines.add(GL_PALETTE4_RGBA8_OES)
defines.add(GL_PALETTE8_R5_G6_B5_OES)
defines.add(GL_PALETTE8_RGB5_A1_OES)
defines.add(GL_PALETTE8_RGB8_OES)
defines.add(GL_PALETTE8_RGBA4_OES)
defines.add(GL_PALETTE8_RGBA8_OES)

# GL_OES_draw_texture

GL_TEXTURE_CROP_RECT_OES = Enumerant('GL_TEXTURE_CROP_RECT_OES', 0x8b9d, 'GL_OES_draw_texture')

defines.add(GL_TEXTURE_CROP_RECT_OES)

# GL_OES_framebuffer_object

GL_COLOR_ATTACHMENT0_OES = Enumerant('GL_COLOR_ATTACHMENT0_OES', 0x8ce0, 'GL_OES_framebuffer_object')
GL_DEPTH_ATTACHMENT_OES = Enumerant('GL_DEPTH_ATTACHMENT_OES', 0x8d00, 'GL_OES_framebuffer_object')
GL_FRAMEBUFFER_ATTACHMENT_OBJECT_NAME_OES = Enumerant('GL_FRAMEBUFFER_ATTACHMENT_OBJECT_NAME_OES', 0x8cd1, 'GL_OES_framebuffer_object')
GL_FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE_OES = Enumerant('GL_FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE_OES', 0x8cd0, 'GL_OES_framebuffer_object')
GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_3D_ZOFFSET_OES = Enumerant('GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_3D_ZOFFSET_OES', 0x8cd4, 'GL_OES_framebuffer_object')
GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE_OES = Enumerant('GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE_OES', 0x8cd3, 'GL_OES_framebuffer_object')
GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL_OES = Enumerant('GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL_OES', 0x8cd2, 'GL_OES_framebuffer_object')
GL_FRAMEBUFFER_BINDING_OES = Enumerant('GL_FRAMEBUFFER_BINDING_OES', 0x8ca6, 'GL_OES_framebuffer_object')
GL_FRAMEBUFFER_COMPLETE_OES = Enumerant('GL_FRAMEBUFFER_COMPLETE_OES', 0x8cd5, 'GL_OES_framebuffer_object')
GL_FRAMEBUFFER_INCOMPLETE_ATTACHMENT_OES = Enumerant('GL_FRAMEBUFFER_INCOMPLETE_ATTACHMENT_OES', 0x8cd6, 'GL_OES_framebuffer_object')
GL_FRAMEBUFFER_INCOMPLETE_DIMENSIONS_OES = Enumerant('GL_FRAMEBUFFER_INCOMPLETE_DIMENSIONS_OES', 0x8cd9, 'GL_OES_framebuffer_object')
GL_FRAMEBUFFER_INCOMPLETE_DRAW_BUFFER_OES = Enumerant('GL_FRAMEBUFFER_INCOMPLETE_DRAW_BUFFER_OES', 0x8cdb, 'GL_OES_framebuffer_object')
GL_FRAMEBUFFER_INCOMPLETE_FORMATS_OES = Enumerant('GL_FRAMEBUFFER_INCOMPLETE_FORMATS_OES', 0x8cda, 'GL_OES_framebuffer_object')
GL_FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT_OES = Enumerant('GL_FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT_OES', 0x8cd7, 'GL_OES_framebuffer_object')
GL_FRAMEBUFFER_INCOMPLETE_READ_BUFFER_OES = Enumerant('GL_FRAMEBUFFER_INCOMPLETE_READ_BUFFER_OES', 0x8cdc, 'GL_OES_framebuffer_object')
GL_FRAMEBUFFER_OES = Enumerant('GL_FRAMEBUFFER_OES', 0x8d40, 'GL_OES_framebuffer_object')
GL_FRAMEBUFFER_UNSUPPORTED_OES = Enumerant('GL_FRAMEBUFFER_UNSUPPORTED_OES', 0x8cdd, 'GL_OES_framebuffer_object')
GL_INVALID_FRAMEBUFFER_OPERATION_OES = Enumerant('GL_INVALID_FRAMEBUFFER_OPERATION_OES', 0x0506, 'GL_OES_framebuffer_object')
GL_MAX_RENDERBUFFER_SIZE_OES = Enumerant('GL_MAX_RENDERBUFFER_SIZE_OES', 0x84e8, 'GL_OES_framebuffer_object')
GL_NONE_OES = Enumerant('GL_NONE_OES', 0x0000, 'GL_OES_framebuffer_object')
GL_RENDERBUFFER_ALPHA_SIZE_OES = Enumerant('GL_RENDERBUFFER_ALPHA_SIZE_OES', 0x8d53, 'GL_OES_framebuffer_object')
GL_RENDERBUFFER_BINDING_OES = Enumerant('GL_RENDERBUFFER_BINDING_OES', 0x8ca7, 'GL_OES_framebuffer_object')
GL_RENDERBUFFER_BLUE_SIZE_OES = Enumerant('GL_RENDERBUFFER_BLUE_SIZE_OES', 0x8d52, 'GL_OES_framebuffer_object')
GL_RENDERBUFFER_DEPTH_SIZE_OES = Enumerant('GL_RENDERBUFFER_DEPTH_SIZE_OES', 0x8d54, 'GL_OES_framebuffer_object')
GL_RENDERBUFFER_GREEN_SIZE_OES = Enumerant('GL_RENDERBUFFER_GREEN_SIZE_OES', 0x8d51, 'GL_OES_framebuffer_object')
GL_RENDERBUFFER_HEIGHT_OES = Enumerant('GL_RENDERBUFFER_HEIGHT_OES', 0x8d43, 'GL_OES_framebuffer_object')
GL_RENDERBUFFER_INTERNAL_FORMAT_OES = Enumerant('GL_RENDERBUFFER_INTERNAL_FORMAT_OES', 0x8d44, 'GL_OES_framebuffer_object')
GL_RENDERBUFFER_OES = Enumerant('GL_RENDERBUFFER_OES', 0x8d41, 'GL_OES_framebuffer_object')
GL_RENDERBUFFER_RED_SIZE_OES = Enumerant('GL_RENDERBUFFER_RED_SIZE_OES', 0x8d50, 'GL_OES_framebuffer_object')
GL_RENDERBUFFER_STENCIL_SIZE_OES = Enumerant('GL_RENDERBUFFER_STENCIL_SIZE_OES', 0x8d55, 'GL_OES_framebuffer_object')
GL_RENDERBUFFER_WIDTH_OES = Enumerant('GL_RENDERBUFFER_WIDTH_OES', 0x8d42, 'GL_OES_framebuffer_object')
GL_STENCIL_ATTACHMENT_OES = Enumerant('GL_STENCIL_ATTACHMENT_OES', 0x8d20, 'GL_OES_framebuffer_object')

defines.add(GL_COLOR_ATTACHMENT0_OES)
defines.add(GL_DEPTH_ATTACHMENT_OES)
defines.add(GL_FRAMEBUFFER_ATTACHMENT_OBJECT_NAME_OES)
defines.add(GL_FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE_OES)
defines.add(GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_3D_ZOFFSET_OES)
defines.add(GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE_OES)
defines.add(GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL_OES)
defines.add(GL_FRAMEBUFFER_BINDING_OES)
defines.add(GL_FRAMEBUFFER_COMPLETE_OES)
defines.add(GL_FRAMEBUFFER_INCOMPLETE_ATTACHMENT_OES)
defines.add(GL_FRAMEBUFFER_INCOMPLETE_DIMENSIONS_OES)
defines.add(GL_FRAMEBUFFER_INCOMPLETE_DRAW_BUFFER_OES)
defines.add(GL_FRAMEBUFFER_INCOMPLETE_FORMATS_OES)
defines.add(GL_FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT_OES)
defines.add(GL_FRAMEBUFFER_INCOMPLETE_READ_BUFFER_OES)
defines.add(GL_FRAMEBUFFER_OES)
defines.add(GL_FRAMEBUFFER_UNSUPPORTED_OES)
defines.add(GL_INVALID_FRAMEBUFFER_OPERATION_OES)
defines.add(GL_MAX_RENDERBUFFER_SIZE_OES)
defines.add(GL_NONE_OES)
defines.add(GL_RENDERBUFFER_ALPHA_SIZE_OES)
defines.add(GL_RENDERBUFFER_BINDING_OES)
defines.add(GL_RENDERBUFFER_BLUE_SIZE_OES)
defines.add(GL_RENDERBUFFER_DEPTH_SIZE_OES)
defines.add(GL_RENDERBUFFER_GREEN_SIZE_OES)
defines.add(GL_RENDERBUFFER_HEIGHT_OES)
defines.add(GL_RENDERBUFFER_INTERNAL_FORMAT_OES)
defines.add(GL_RENDERBUFFER_OES)
defines.add(GL_RENDERBUFFER_RED_SIZE_OES)
defines.add(GL_RENDERBUFFER_STENCIL_SIZE_OES)
defines.add(GL_RENDERBUFFER_WIDTH_OES)
defines.add(GL_STENCIL_ATTACHMENT_OES)

# GL_OES_get_program_binary

GL_NUM_PROGRAM_BINARY_FORMATS_OES = Enumerant('GL_NUM_PROGRAM_BINARY_FORMATS_OES', 0x87fe, 'GL_OES_get_program_binary')
GL_PROGRAM_BINARY_FORMATS_OES = Enumerant('GL_PROGRAM_BINARY_FORMATS_OES', 0x87ff, 'GL_OES_get_program_binary')
GL_PROGRAM_BINARY_LENGTH_OES = Enumerant('GL_PROGRAM_BINARY_LENGTH_OES', 0x8741, 'GL_OES_get_program_binary')

defines.add(GL_NUM_PROGRAM_BINARY_FORMATS_OES)
defines.add(GL_PROGRAM_BINARY_FORMATS_OES)
defines.add(GL_PROGRAM_BINARY_LENGTH_OES)

# GL_OES_mapbuffer

GL_BUFFER_ACCESS_OES = Enumerant('GL_BUFFER_ACCESS_OES', 0x88bb, 'GL_OES_mapbuffer')
GL_BUFFER_MAPPED_OES = Enumerant('GL_BUFFER_MAPPED_OES', 0x88bc, 'GL_OES_mapbuffer')
GL_BUFFER_MAP_POINTER_OES = Enumerant('GL_BUFFER_MAP_POINTER_OES', 0x88bd, 'GL_OES_mapbuffer')
GL_WRITE_ONLY_OES = Enumerant('GL_WRITE_ONLY_OES', 0x88b9, 'GL_OES_mapbuffer')

defines.add(GL_BUFFER_ACCESS_OES)
defines.add(GL_BUFFER_MAPPED_OES)
defines.add(GL_BUFFER_MAP_POINTER_OES)
defines.add(GL_WRITE_ONLY_OES)

# GL_OES_matrix_get

GL_MODELVIEW_MATRIX_FLOAT_AS_INT_BITS_OES = Enumerant('GL_MODELVIEW_MATRIX_FLOAT_AS_INT_BITS_OES', 0x0898, 'GL_OES_matrix_get')
GL_PROJECTION_MATRIX_FLOAT_AS_INT_BITS_OES = Enumerant('GL_PROJECTION_MATRIX_FLOAT_AS_INT_BITS_OES', 0x0898, 'GL_OES_matrix_get')
GL_TEXTURE_MATRIX_FLOAT_AS_INT_BITS_OES = Enumerant('GL_TEXTURE_MATRIX_FLOAT_AS_INT_BITS_OES', 0x0898, 'GL_OES_matrix_get')

defines.add(GL_MODELVIEW_MATRIX_FLOAT_AS_INT_BITS_OES)
defines.add(GL_PROJECTION_MATRIX_FLOAT_AS_INT_BITS_OES)
defines.add(GL_TEXTURE_MATRIX_FLOAT_AS_INT_BITS_OES)

# GL_OES_matrix_palette

GL_CURRENT_PALETTE_MATRIX_OES = Enumerant('GL_CURRENT_PALETTE_MATRIX_OES', 0x8843, 'GL_OES_matrix_palette')
GL_MATRIX_INDEX_ARRAY_BUFFER_BINDING_OES = Enumerant('GL_MATRIX_INDEX_ARRAY_BUFFER_BINDING_OES', 0x8b9e, 'GL_OES_matrix_palette')
GL_MATRIX_INDEX_ARRAY_OES = Enumerant('GL_MATRIX_INDEX_ARRAY_OES', 0x8844, 'GL_OES_matrix_palette')
GL_MATRIX_INDEX_ARRAY_POINTER_OES = Enumerant('GL_MATRIX_INDEX_ARRAY_POINTER_OES', 0x8849, 'GL_OES_matrix_palette')
GL_MATRIX_INDEX_ARRAY_SIZE_OES = Enumerant('GL_MATRIX_INDEX_ARRAY_SIZE_OES', 0x8846, 'GL_OES_matrix_palette')
GL_MATRIX_INDEX_ARRAY_STRIDE_OES = Enumerant('GL_MATRIX_INDEX_ARRAY_STRIDE_OES', 0x8848, 'GL_OES_matrix_palette')
GL_MATRIX_INDEX_ARRAY_TYPE_OES = Enumerant('GL_MATRIX_INDEX_ARRAY_TYPE_OES', 0x8847, 'GL_OES_matrix_palette')
GL_MATRIX_PALETTE_OES = Enumerant('GL_MATRIX_PALETTE_OES', 0x8840, 'GL_OES_matrix_palette')
GL_MAX_PALETTE_MATRICES_OES = Enumerant('GL_MAX_PALETTE_MATRICES_OES', 0x8842, 'GL_OES_matrix_palette')
GL_MAX_VERTEX_UNITS_OES = Enumerant('GL_MAX_VERTEX_UNITS_OES', 0x86a4, 'GL_OES_matrix_palette')
GL_WEIGHT_ARRAY_BUFFER_BINDING_OES = Enumerant('GL_WEIGHT_ARRAY_BUFFER_BINDING_OES', 0x889e, 'GL_OES_matrix_palette')
GL_WEIGHT_ARRAY_OES = Enumerant('GL_WEIGHT_ARRAY_OES', 0x86ad, 'GL_OES_matrix_palette')
GL_WEIGHT_ARRAY_POINTER_OES = Enumerant('GL_WEIGHT_ARRAY_POINTER_OES', 0x86ac, 'GL_OES_matrix_palette')
GL_WEIGHT_ARRAY_SIZE_OES = Enumerant('GL_WEIGHT_ARRAY_SIZE_OES', 0x86ab, 'GL_OES_matrix_palette')
GL_WEIGHT_ARRAY_STRIDE_OES = Enumerant('GL_WEIGHT_ARRAY_STRIDE_OES', 0x86aa, 'GL_OES_matrix_palette')
GL_WEIGHT_ARRAY_TYPE_OES = Enumerant('GL_WEIGHT_ARRAY_TYPE_OES', 0x86a9, 'GL_OES_matrix_palette')

defines.add(GL_CURRENT_PALETTE_MATRIX_OES)
defines.add(GL_MATRIX_INDEX_ARRAY_BUFFER_BINDING_OES)
defines.add(GL_MATRIX_INDEX_ARRAY_OES)
defines.add(GL_MATRIX_INDEX_ARRAY_POINTER_OES)
defines.add(GL_MATRIX_INDEX_ARRAY_SIZE_OES)
defines.add(GL_MATRIX_INDEX_ARRAY_STRIDE_OES)
defines.add(GL_MATRIX_INDEX_ARRAY_TYPE_OES)
defines.add(GL_MATRIX_PALETTE_OES)
defines.add(GL_MAX_PALETTE_MATRICES_OES)
defines.add(GL_MAX_VERTEX_UNITS_OES)
defines.add(GL_WEIGHT_ARRAY_BUFFER_BINDING_OES)
defines.add(GL_WEIGHT_ARRAY_OES)
defines.add(GL_WEIGHT_ARRAY_POINTER_OES)
defines.add(GL_WEIGHT_ARRAY_SIZE_OES)
defines.add(GL_WEIGHT_ARRAY_STRIDE_OES)
defines.add(GL_WEIGHT_ARRAY_TYPE_OES)

# GL_OES_packed_depth_stencil

GL_DEPTH_STENCIL_OES = Enumerant('GL_DEPTH_STENCIL_OES', 0x84f9, 'GL_OES_packed_depth_stencil')
GL_UNSIGNED_INT_24_8_OES = Enumerant('GL_UNSIGNED_INT_24_8_OES', 0x84fa, 'GL_OES_packed_depth_stencil')

defines.add(GL_DEPTH_STENCIL_OES)
defines.add(GL_UNSIGNED_INT_24_8_OES)

# GL_OES_point_size_array

GL_POINT_SIZE_ARRAY_BUFFER_BINDING_OES = Enumerant('GL_POINT_SIZE_ARRAY_BUFFER_BINDING_OES', 0x8b9f, 'GL_OES_point_size_array')
GL_POINT_SIZE_ARRAY_OES = Enumerant('GL_POINT_SIZE_ARRAY_OES', 0x8b9c, 'GL_OES_point_size_array')
GL_POINT_SIZE_ARRAY_POINTER_OES = Enumerant('GL_POINT_SIZE_ARRAY_POINTER_OES', 0x898c, 'GL_OES_point_size_array')
GL_POINT_SIZE_ARRAY_STRIDE_OES = Enumerant('GL_POINT_SIZE_ARRAY_STRIDE_OES', 0x898b, 'GL_OES_point_size_array')
GL_POINT_SIZE_ARRAY_TYPE_OES = Enumerant('GL_POINT_SIZE_ARRAY_TYPE_OES', 0x898a, 'GL_OES_point_size_array')

defines.add(GL_POINT_SIZE_ARRAY_BUFFER_BINDING_OES)
defines.add(GL_POINT_SIZE_ARRAY_OES)
defines.add(GL_POINT_SIZE_ARRAY_POINTER_OES)
defines.add(GL_POINT_SIZE_ARRAY_STRIDE_OES)
defines.add(GL_POINT_SIZE_ARRAY_TYPE_OES)

# GL_OES_point_sprite

GL_COORD_REPLACE_OES = Enumerant('GL_COORD_REPLACE_OES', 0x8862, 'GL_OES_point_sprite')
GL_POINT_SPRITE_OES = Enumerant('GL_POINT_SPRITE_OES', 0x8861, 'GL_OES_point_sprite')

defines.add(GL_COORD_REPLACE_OES)
defines.add(GL_POINT_SPRITE_OES)

# GL_OES_read_format

GL_IMPLEMENTATION_COLOR_READ_FORMAT_OES = Enumerant('GL_IMPLEMENTATION_COLOR_READ_FORMAT_OES', 0x8b9b, 'GL_OES_read_format')
GL_IMPLEMENTATION_COLOR_READ_TYPE_OES = Enumerant('GL_IMPLEMENTATION_COLOR_READ_TYPE_OES', 0x8b9a, 'GL_OES_read_format')

defines.add(GL_IMPLEMENTATION_COLOR_READ_FORMAT_OES)
defines.add(GL_IMPLEMENTATION_COLOR_READ_TYPE_OES)

# GL_OES_required_internalformat

GL_ALPHA8_OES = Enumerant('GL_ALPHA8_OES', 0x803c, 'GL_OES_required_internalformat')
GL_DEPTH24_STENCIL8_OES = Enumerant('GL_DEPTH24_STENCIL8_OES', 0x88f0, 'GL_OES_required_internalformat')
GL_DEPTH_COMPONENT16_OES = Enumerant('GL_DEPTH_COMPONENT16_OES', 0x81a5, 'GL_OES_required_internalformat')
GL_DEPTH_COMPONENT24_OES = Enumerant('GL_DEPTH_COMPONENT24_OES', 0x81a6, 'GL_OES_required_internalformat')
GL_DEPTH_COMPONENT32_OES = Enumerant('GL_DEPTH_COMPONENT32_OES', 0x81a7, 'GL_OES_required_internalformat')
GL_LUMINANCE4_ALPHA4_OES = Enumerant('GL_LUMINANCE4_ALPHA4_OES', 0x8043, 'GL_OES_required_internalformat')
GL_LUMINANCE8_ALPHA8_OES = Enumerant('GL_LUMINANCE8_ALPHA8_OES', 0x8045, 'GL_OES_required_internalformat')
GL_LUMINANCE8_OES = Enumerant('GL_LUMINANCE8_OES', 0x8040, 'GL_OES_required_internalformat')
GL_RGB565_OES = Enumerant('GL_RGB565_OES', 0x8d62, 'GL_OES_required_internalformat')
GL_RGB5_A1_OES = Enumerant('GL_RGB5_A1_OES', 0x8057, 'GL_OES_required_internalformat')
GL_RGBA4_OES = Enumerant('GL_RGBA4_OES', 0x8056, 'GL_OES_required_internalformat')

defines.add(GL_ALPHA8_OES)
defines.add(GL_DEPTH24_STENCIL8_OES)
defines.add(GL_DEPTH_COMPONENT16_OES)
defines.add(GL_DEPTH_COMPONENT24_OES)
defines.add(GL_DEPTH_COMPONENT32_OES)
defines.add(GL_LUMINANCE4_ALPHA4_OES)
defines.add(GL_LUMINANCE8_ALPHA8_OES)
defines.add(GL_LUMINANCE8_OES)
defines.add(GL_RGB565_OES)
defines.add(GL_RGB5_A1_OES)
defines.add(GL_RGBA4_OES)

# GL_OES_rgb8_rgba8

GL_RGB8_OES = Enumerant('GL_RGB8_OES', 0x8051, 'GL_OES_rgb8_rgba8')
GL_RGBA8_OES = Enumerant('GL_RGBA8_OES', 0x8058, 'GL_OES_rgb8_rgba8')

defines.add(GL_RGB8_OES)
defines.add(GL_RGBA8_OES)

# GL_OES_standard_derivatives

GL_FRAGMENT_SHADER_DERIVATIVE_HINT_OES = Enumerant('GL_FRAGMENT_SHADER_DERIVATIVE_HINT_OES', 0x8b8b, 'GL_OES_standard_derivatives')

defines.add(GL_FRAGMENT_SHADER_DERIVATIVE_HINT_OES)

# GL_OES_stencil1

GL_STENCIL_INDEX1_OES = Enumerant('GL_STENCIL_INDEX1_OES', 0x8d46, 'GL_OES_stencil1')

defines.add(GL_STENCIL_INDEX1_OES)

# GL_OES_stencil4

GL_STENCIL_INDEX4_OES = Enumerant('GL_STENCIL_INDEX4_OES', 0x8d47, 'GL_OES_stencil4')

defines.add(GL_STENCIL_INDEX4_OES)

# GL_OES_stencil8

GL_STENCIL_INDEX8_OES = Enumerant('GL_STENCIL_INDEX8_OES', 0x8d48, 'GL_OES_stencil8')

defines.add(GL_STENCIL_INDEX8_OES)

# GL_OES_surfaceless_context

GL_FRAMEBUFFER_UNDEFINED_OES = Enumerant('GL_FRAMEBUFFER_UNDEFINED_OES', 0x8219, 'GL_OES_surfaceless_context')

defines.add(GL_FRAMEBUFFER_UNDEFINED_OES)

# GL_OES_texture_3D

GL_MAX_3D_TEXTURE_SIZE_OES = Enumerant('GL_MAX_3D_TEXTURE_SIZE_OES', 0x8073, 'GL_OES_texture_3D')
GL_TEXTURE_3D_OES = Enumerant('GL_TEXTURE_3D_OES', 0x806f, 'GL_OES_texture_3D')
GL_TEXTURE_BINDING_3D_OES = Enumerant('GL_TEXTURE_BINDING_3D_OES', 0x806a, 'GL_OES_texture_3D')
GL_TEXTURE_WRAP_R_OES = Enumerant('GL_TEXTURE_WRAP_R_OES', 0x8072, 'GL_OES_texture_3D')

defines.add(GL_MAX_3D_TEXTURE_SIZE_OES)
defines.add(GL_TEXTURE_3D_OES)
defines.add(GL_TEXTURE_BINDING_3D_OES)
defines.add(GL_TEXTURE_WRAP_R_OES)

# GL_OES_texture_cube_map

GL_MAX_CUBE_MAP_TEXTURE_SIZE_OES = Enumerant('GL_MAX_CUBE_MAP_TEXTURE_SIZE_OES', 0x851c, 'GL_OES_texture_cube_map')
GL_NORMAL_MAP_OES = Enumerant('GL_NORMAL_MAP_OES', 0x8511, 'GL_OES_texture_cube_map')
GL_REFLECTION_MAP_OES = Enumerant('GL_REFLECTION_MAP_OES', 0x8512, 'GL_OES_texture_cube_map')
GL_TEXTURE_BINDING_CUBE_MAP_OES = Enumerant('GL_TEXTURE_BINDING_CUBE_MAP_OES', 0x8514, 'GL_OES_texture_cube_map')
GL_TEXTURE_CUBE_MAP_NEGATIVE_X_OES = Enumerant('GL_TEXTURE_CUBE_MAP_NEGATIVE_X_OES', 0x8516, 'GL_OES_texture_cube_map')
GL_TEXTURE_CUBE_MAP_NEGATIVE_Y_OES = Enumerant('GL_TEXTURE_CUBE_MAP_NEGATIVE_Y_OES', 0x8518, 'GL_OES_texture_cube_map')
GL_TEXTURE_CUBE_MAP_NEGATIVE_Z_OES = Enumerant('GL_TEXTURE_CUBE_MAP_NEGATIVE_Z_OES', 0x851a, 'GL_OES_texture_cube_map')
GL_TEXTURE_CUBE_MAP_OES = Enumerant('GL_TEXTURE_CUBE_MAP_OES', 0x8513, 'GL_OES_texture_cube_map')
GL_TEXTURE_CUBE_MAP_POSITIVE_X_OES = Enumerant('GL_TEXTURE_CUBE_MAP_POSITIVE_X_OES', 0x8515, 'GL_OES_texture_cube_map')
GL_TEXTURE_CUBE_MAP_POSITIVE_Y_OES = Enumerant('GL_TEXTURE_CUBE_MAP_POSITIVE_Y_OES', 0x8517, 'GL_OES_texture_cube_map')
GL_TEXTURE_CUBE_MAP_POSITIVE_Z_OES = Enumerant('GL_TEXTURE_CUBE_MAP_POSITIVE_Z_OES', 0x8519, 'GL_OES_texture_cube_map')
GL_TEXTURE_GEN_MODE_OES = Enumerant('GL_TEXTURE_GEN_MODE_OES', 0x2500, 'GL_OES_texture_cube_map')
GL_TEXTURE_GEN_STR_OES = Enumerant('GL_TEXTURE_GEN_STR_OES', 0x8d60, 'GL_OES_texture_cube_map')

defines.add(GL_MAX_CUBE_MAP_TEXTURE_SIZE_OES)
defines.add(GL_NORMAL_MAP_OES)
defines.add(GL_REFLECTION_MAP_OES)
defines.add(GL_TEXTURE_BINDING_CUBE_MAP_OES)
defines.add(GL_TEXTURE_CUBE_MAP_NEGATIVE_X_OES)
defines.add(GL_TEXTURE_CUBE_MAP_NEGATIVE_Y_OES)
defines.add(GL_TEXTURE_CUBE_MAP_NEGATIVE_Z_OES)
defines.add(GL_TEXTURE_CUBE_MAP_OES)
defines.add(GL_TEXTURE_CUBE_MAP_POSITIVE_X_OES)
defines.add(GL_TEXTURE_CUBE_MAP_POSITIVE_Y_OES)
defines.add(GL_TEXTURE_CUBE_MAP_POSITIVE_Z_OES)
defines.add(GL_TEXTURE_GEN_MODE_OES)
defines.add(GL_TEXTURE_GEN_STR_OES)

# GL_OES_vertex_array_object

GL_VERTEX_ARRAY_BINDING_OES = Enumerant('GL_VERTEX_ARRAY_BINDING_OES', 0x85b5, 'GL_OES_vertex_array_object')

defines.add(GL_VERTEX_ARRAY_BINDING_OES)

# GL_OES_vertex_half_float

GL_HALF_FLOAT_OES = Enumerant('GL_HALF_FLOAT_OES', 0x8d61, 'GL_OES_vertex_half_float')

defines.add(GL_HALF_FLOAT_OES)

# GL_OES_vertex_type_10_10_10_2

GL_INT_10_10_10_2_OES = Enumerant('GL_INT_10_10_10_2_OES', 0x8df7, 'GL_OES_vertex_type_10_10_10_2')
GL_UNSIGNED_INT_10_10_10_2_OES = Enumerant('GL_UNSIGNED_INT_10_10_10_2_OES', 0x8df6, 'GL_OES_vertex_type_10_10_10_2')

defines.add(GL_INT_10_10_10_2_OES)
defines.add(GL_UNSIGNED_INT_10_10_10_2_OES)

# GL_OML_interlace

GL_INTERLACE_OML = Enumerant('GL_INTERLACE_OML', 0x8980, 'GL_OML_interlace')
GL_INTERLACE_READ_OML = Enumerant('GL_INTERLACE_READ_OML', 0x8981, 'GL_OML_interlace')

defines.add(GL_INTERLACE_OML)
defines.add(GL_INTERLACE_READ_OML)

# GL_OML_resample

GL_PACK_RESAMPLE_OML = Enumerant('GL_PACK_RESAMPLE_OML', 0x8984, 'GL_OML_resample')
GL_RESAMPLE_AVERAGE_OML = Enumerant('GL_RESAMPLE_AVERAGE_OML', 0x8988, 'GL_OML_resample')
GL_RESAMPLE_DECIMATE_OML = Enumerant('GL_RESAMPLE_DECIMATE_OML', 0x8989, 'GL_OML_resample')
GL_RESAMPLE_REPLICATE_OML = Enumerant('GL_RESAMPLE_REPLICATE_OML', 0x8986, 'GL_OML_resample')
GL_RESAMPLE_ZERO_FILL_OML = Enumerant('GL_RESAMPLE_ZERO_FILL_OML', 0x8987, 'GL_OML_resample')
GL_UNPACK_RESAMPLE_OML = Enumerant('GL_UNPACK_RESAMPLE_OML', 0x8985, 'GL_OML_resample')

defines.add(GL_PACK_RESAMPLE_OML)
defines.add(GL_RESAMPLE_AVERAGE_OML)
defines.add(GL_RESAMPLE_DECIMATE_OML)
defines.add(GL_RESAMPLE_REPLICATE_OML)
defines.add(GL_RESAMPLE_ZERO_FILL_OML)
defines.add(GL_UNPACK_RESAMPLE_OML)

# GL_OML_subsample

GL_FORMAT_SUBSAMPLE_244_244_OML = Enumerant('GL_FORMAT_SUBSAMPLE_244_244_OML', 0x8983, 'GL_OML_subsample')
GL_FORMAT_SUBSAMPLE_24_24_OML = Enumerant('GL_FORMAT_SUBSAMPLE_24_24_OML', 0x8982, 'GL_OML_subsample')

defines.add(GL_FORMAT_SUBSAMPLE_244_244_OML)
defines.add(GL_FORMAT_SUBSAMPLE_24_24_OML)

# GL_PGI_misc_hints

GL_ALLOW_DRAW_FRG_HINT_PGI = Enumerant('GL_ALLOW_DRAW_FRG_HINT_PGI', 0x1a210, 'GL_PGI_misc_hints')
GL_ALLOW_DRAW_MEM_HINT_PGI = Enumerant('GL_ALLOW_DRAW_MEM_HINT_PGI', 0x1a211, 'GL_PGI_misc_hints')
GL_ALLOW_DRAW_OBJ_HINT_PGI = Enumerant('GL_ALLOW_DRAW_OBJ_HINT_PGI', 0x1a20e, 'GL_PGI_misc_hints')
GL_ALLOW_DRAW_WIN_HINT_PGI = Enumerant('GL_ALLOW_DRAW_WIN_HINT_PGI', 0x1a20f, 'GL_PGI_misc_hints')
GL_ALWAYS_FAST_HINT_PGI = Enumerant('GL_ALWAYS_FAST_HINT_PGI', 0x1a20c, 'GL_PGI_misc_hints')
GL_ALWAYS_SOFT_HINT_PGI = Enumerant('GL_ALWAYS_SOFT_HINT_PGI', 0x1a20d, 'GL_PGI_misc_hints')
GL_BACK_NORMALS_HINT_PGI = Enumerant('GL_BACK_NORMALS_HINT_PGI', 0x1a223, 'GL_PGI_misc_hints')
GL_CLIP_FAR_HINT_PGI = Enumerant('GL_CLIP_FAR_HINT_PGI', 0x1a221, 'GL_PGI_misc_hints')
GL_CLIP_NEAR_HINT_PGI = Enumerant('GL_CLIP_NEAR_HINT_PGI', 0x1a220, 'GL_PGI_misc_hints')
GL_CONSERVE_MEMORY_HINT_PGI = Enumerant('GL_CONSERVE_MEMORY_HINT_PGI', 0x1a1fd, 'GL_PGI_misc_hints')
GL_FULL_STIPPLE_HINT_PGI = Enumerant('GL_FULL_STIPPLE_HINT_PGI', 0x1a219, 'GL_PGI_misc_hints')
GL_NATIVE_GRAPHICS_BEGIN_HINT_PGI = Enumerant('GL_NATIVE_GRAPHICS_BEGIN_HINT_PGI', 0x1a203, 'GL_PGI_misc_hints')
GL_NATIVE_GRAPHICS_END_HINT_PGI = Enumerant('GL_NATIVE_GRAPHICS_END_HINT_PGI', 0x1a204, 'GL_PGI_misc_hints')
GL_NATIVE_GRAPHICS_HANDLE_PGI = Enumerant('GL_NATIVE_GRAPHICS_HANDLE_PGI', 0x1a202, 'GL_PGI_misc_hints')
GL_PREFER_DOUBLEBUFFER_HINT_PGI = Enumerant('GL_PREFER_DOUBLEBUFFER_HINT_PGI', 0x1a1f8, 'GL_PGI_misc_hints')
GL_RECLAIM_MEMORY_HINT_PGI = Enumerant('GL_RECLAIM_MEMORY_HINT_PGI', 0x1a1fe, 'GL_PGI_misc_hints')
GL_STRICT_DEPTHFUNC_HINT_PGI = Enumerant('GL_STRICT_DEPTHFUNC_HINT_PGI', 0x1a216, 'GL_PGI_misc_hints')
GL_STRICT_LIGHTING_HINT_PGI = Enumerant('GL_STRICT_LIGHTING_HINT_PGI', 0x1a217, 'GL_PGI_misc_hints')
GL_STRICT_SCISSOR_HINT_PGI = Enumerant('GL_STRICT_SCISSOR_HINT_PGI', 0x1a218, 'GL_PGI_misc_hints')
GL_WIDE_LINE_HINT_PGI = Enumerant('GL_WIDE_LINE_HINT_PGI', 0x1a222, 'GL_PGI_misc_hints')

defines.add(GL_ALLOW_DRAW_FRG_HINT_PGI)
defines.add(GL_ALLOW_DRAW_MEM_HINT_PGI)
defines.add(GL_ALLOW_DRAW_OBJ_HINT_PGI)
defines.add(GL_ALLOW_DRAW_WIN_HINT_PGI)
defines.add(GL_ALWAYS_FAST_HINT_PGI)
defines.add(GL_ALWAYS_SOFT_HINT_PGI)
defines.add(GL_BACK_NORMALS_HINT_PGI)
defines.add(GL_CLIP_FAR_HINT_PGI)
defines.add(GL_CLIP_NEAR_HINT_PGI)
defines.add(GL_CONSERVE_MEMORY_HINT_PGI)
defines.add(GL_FULL_STIPPLE_HINT_PGI)
defines.add(GL_NATIVE_GRAPHICS_BEGIN_HINT_PGI)
defines.add(GL_NATIVE_GRAPHICS_END_HINT_PGI)
defines.add(GL_NATIVE_GRAPHICS_HANDLE_PGI)
defines.add(GL_PREFER_DOUBLEBUFFER_HINT_PGI)
defines.add(GL_RECLAIM_MEMORY_HINT_PGI)
defines.add(GL_STRICT_DEPTHFUNC_HINT_PGI)
defines.add(GL_STRICT_LIGHTING_HINT_PGI)
defines.add(GL_STRICT_SCISSOR_HINT_PGI)
defines.add(GL_WIDE_LINE_HINT_PGI)

# GL_PGI_vertex_hints

GL_COLOR3_BIT_PGI = Enumerant('GL_COLOR3_BIT_PGI', 0x10000, 'GL_PGI_vertex_hints')
GL_COLOR4_BIT_PGI = Enumerant('GL_COLOR4_BIT_PGI', 0x20000, 'GL_PGI_vertex_hints')
GL_EDGEFLAG_BIT_PGI = Enumerant('GL_EDGEFLAG_BIT_PGI', 0x40000, 'GL_PGI_vertex_hints')
GL_INDEX_BIT_PGI = Enumerant('GL_INDEX_BIT_PGI', 0x80000, 'GL_PGI_vertex_hints')
GL_MATERIAL_SIDE_HINT_PGI = Enumerant('GL_MATERIAL_SIDE_HINT_PGI', 0x1a22c, 'GL_PGI_vertex_hints')
GL_MAT_AMBIENT_AND_DIFFUSE_BIT_PGI = Enumerant('GL_MAT_AMBIENT_AND_DIFFUSE_BIT_PGI', 0x200000, 'GL_PGI_vertex_hints')
GL_MAT_AMBIENT_BIT_PGI = Enumerant('GL_MAT_AMBIENT_BIT_PGI', 0x100000, 'GL_PGI_vertex_hints')
GL_MAT_COLOR_INDEXES_BIT_PGI = Enumerant('GL_MAT_COLOR_INDEXES_BIT_PGI', 0x1000000, 'GL_PGI_vertex_hints')
GL_MAT_DIFFUSE_BIT_PGI = Enumerant('GL_MAT_DIFFUSE_BIT_PGI', 0x400000, 'GL_PGI_vertex_hints')
GL_MAT_EMISSION_BIT_PGI = Enumerant('GL_MAT_EMISSION_BIT_PGI', 0x800000, 'GL_PGI_vertex_hints')
GL_MAT_SHININESS_BIT_PGI = Enumerant('GL_MAT_SHININESS_BIT_PGI', 0x2000000, 'GL_PGI_vertex_hints')
GL_MAT_SPECULAR_BIT_PGI = Enumerant('GL_MAT_SPECULAR_BIT_PGI', 0x4000000, 'GL_PGI_vertex_hints')
GL_MAX_VERTEX_HINT_PGI = Enumerant('GL_MAX_VERTEX_HINT_PGI', 0x1a22d, 'GL_PGI_vertex_hints')
GL_NORMAL_BIT_PGI = Enumerant('GL_NORMAL_BIT_PGI', 0x8000000, 'GL_PGI_vertex_hints')
GL_TEXCOORD1_BIT_PGI = Enumerant('GL_TEXCOORD1_BIT_PGI', 0x10000000, 'GL_PGI_vertex_hints')
GL_TEXCOORD2_BIT_PGI = Enumerant('GL_TEXCOORD2_BIT_PGI', 0x20000000, 'GL_PGI_vertex_hints')
GL_TEXCOORD3_BIT_PGI = Enumerant('GL_TEXCOORD3_BIT_PGI', 0x40000000, 'GL_PGI_vertex_hints')
GL_TEXCOORD4_BIT_PGI = Enumerant('GL_TEXCOORD4_BIT_PGI', 0x80000000, 'GL_PGI_vertex_hints')
GL_VERTEX23_BIT_PGI = Enumerant('GL_VERTEX23_BIT_PGI', 0x0004, 'GL_PGI_vertex_hints')
GL_VERTEX4_BIT_PGI = Enumerant('GL_VERTEX4_BIT_PGI', 0x0008, 'GL_PGI_vertex_hints')
GL_VERTEX_CONSISTENT_HINT_PGI = Enumerant('GL_VERTEX_CONSISTENT_HINT_PGI', 0x1a22b, 'GL_PGI_vertex_hints')
GL_VERTEX_DATA_HINT_PGI = Enumerant('GL_VERTEX_DATA_HINT_PGI', 0x1a22a, 'GL_PGI_vertex_hints')

defines.add(GL_COLOR3_BIT_PGI)
defines.add(GL_COLOR4_BIT_PGI)
defines.add(GL_EDGEFLAG_BIT_PGI)
defines.add(GL_INDEX_BIT_PGI)
defines.add(GL_MATERIAL_SIDE_HINT_PGI)
defines.add(GL_MAT_AMBIENT_AND_DIFFUSE_BIT_PGI)
defines.add(GL_MAT_AMBIENT_BIT_PGI)
defines.add(GL_MAT_COLOR_INDEXES_BIT_PGI)
defines.add(GL_MAT_DIFFUSE_BIT_PGI)
defines.add(GL_MAT_EMISSION_BIT_PGI)
defines.add(GL_MAT_SHININESS_BIT_PGI)
defines.add(GL_MAT_SPECULAR_BIT_PGI)
defines.add(GL_MAX_VERTEX_HINT_PGI)
defines.add(GL_NORMAL_BIT_PGI)
defines.add(GL_TEXCOORD1_BIT_PGI)
defines.add(GL_TEXCOORD2_BIT_PGI)
defines.add(GL_TEXCOORD3_BIT_PGI)
defines.add(GL_TEXCOORD4_BIT_PGI)
defines.add(GL_VERTEX23_BIT_PGI)
defines.add(GL_VERTEX4_BIT_PGI)
defines.add(GL_VERTEX_CONSISTENT_HINT_PGI)
defines.add(GL_VERTEX_DATA_HINT_PGI)

# GL_QCOM_alpha_test

GL_ALPHA_TEST_FUNC_QCOM = Enumerant('GL_ALPHA_TEST_FUNC_QCOM', 0x0bc1, 'GL_QCOM_alpha_test')
GL_ALPHA_TEST_QCOM = Enumerant('GL_ALPHA_TEST_QCOM', 0x0bc0, 'GL_QCOM_alpha_test')
GL_ALPHA_TEST_REF_QCOM = Enumerant('GL_ALPHA_TEST_REF_QCOM', 0x0bc2, 'GL_QCOM_alpha_test')

defines.add(GL_ALPHA_TEST_FUNC_QCOM)
defines.add(GL_ALPHA_TEST_QCOM)
defines.add(GL_ALPHA_TEST_REF_QCOM)

# GL_QCOM_binning_control

GL_BINNING_CONTROL_HINT_QCOM = Enumerant('GL_BINNING_CONTROL_HINT_QCOM', 0x8fb0, 'GL_QCOM_binning_control')
GL_CPU_OPTIMIZED_QCOM = Enumerant('GL_CPU_OPTIMIZED_QCOM', 0x8fb1, 'GL_QCOM_binning_control')
GL_GPU_OPTIMIZED_QCOM = Enumerant('GL_GPU_OPTIMIZED_QCOM', 0x8fb2, 'GL_QCOM_binning_control')
GL_RENDER_DIRECT_TO_FRAMEBUFFER_QCOM = Enumerant('GL_RENDER_DIRECT_TO_FRAMEBUFFER_QCOM', 0x8fb3, 'GL_QCOM_binning_control')

defines.add(GL_BINNING_CONTROL_HINT_QCOM)
defines.add(GL_CPU_OPTIMIZED_QCOM)
defines.add(GL_GPU_OPTIMIZED_QCOM)
defines.add(GL_RENDER_DIRECT_TO_FRAMEBUFFER_QCOM)

# GL_QCOM_extended_get

GL_STATE_RESTORE = Enumerant('GL_STATE_RESTORE', 0x8bdc, 'GL_QCOM_extended_get')
GL_TEXTURE_DEPTH_QCOM = Enumerant('GL_TEXTURE_DEPTH_QCOM', 0x8bd4, 'GL_QCOM_extended_get')
GL_TEXTURE_FORMAT_QCOM = Enumerant('GL_TEXTURE_FORMAT_QCOM', 0x8bd6, 'GL_QCOM_extended_get')
GL_TEXTURE_HEIGHT_QCOM = Enumerant('GL_TEXTURE_HEIGHT_QCOM', 0x8bd3, 'GL_QCOM_extended_get')
GL_TEXTURE_IMAGE_VALID_QCOM = Enumerant('GL_TEXTURE_IMAGE_VALID_QCOM', 0x8bd8, 'GL_QCOM_extended_get')
GL_TEXTURE_INTERNAL_FORMAT_QCOM = Enumerant('GL_TEXTURE_INTERNAL_FORMAT_QCOM', 0x8bd5, 'GL_QCOM_extended_get')
GL_TEXTURE_NUM_LEVELS_QCOM = Enumerant('GL_TEXTURE_NUM_LEVELS_QCOM', 0x8bd9, 'GL_QCOM_extended_get')
GL_TEXTURE_OBJECT_VALID_QCOM = Enumerant('GL_TEXTURE_OBJECT_VALID_QCOM', 0x8bdb, 'GL_QCOM_extended_get')
GL_TEXTURE_TARGET_QCOM = Enumerant('GL_TEXTURE_TARGET_QCOM', 0x8bda, 'GL_QCOM_extended_get')
GL_TEXTURE_TYPE_QCOM = Enumerant('GL_TEXTURE_TYPE_QCOM', 0x8bd7, 'GL_QCOM_extended_get')
GL_TEXTURE_WIDTH_QCOM = Enumerant('GL_TEXTURE_WIDTH_QCOM', 0x8bd2, 'GL_QCOM_extended_get')

defines.add(GL_STATE_RESTORE)
defines.add(GL_TEXTURE_DEPTH_QCOM)
defines.add(GL_TEXTURE_FORMAT_QCOM)
defines.add(GL_TEXTURE_HEIGHT_QCOM)
defines.add(GL_TEXTURE_IMAGE_VALID_QCOM)
defines.add(GL_TEXTURE_INTERNAL_FORMAT_QCOM)
defines.add(GL_TEXTURE_NUM_LEVELS_QCOM)
defines.add(GL_TEXTURE_OBJECT_VALID_QCOM)
defines.add(GL_TEXTURE_TARGET_QCOM)
defines.add(GL_TEXTURE_TYPE_QCOM)
defines.add(GL_TEXTURE_WIDTH_QCOM)

# GL_QCOM_perfmon_global_mode

GL_PERFMON_GLOBAL_MODE_QCOM = Enumerant('GL_PERFMON_GLOBAL_MODE_QCOM', 0x8fa0, 'GL_QCOM_perfmon_global_mode')

defines.add(GL_PERFMON_GLOBAL_MODE_QCOM)

# GL_QCOM_tiled_rendering

GL_COLOR_BUFFER_BIT0_QCOM = Enumerant('GL_COLOR_BUFFER_BIT0_QCOM', 0x0001, 'GL_QCOM_tiled_rendering')
GL_COLOR_BUFFER_BIT1_QCOM = Enumerant('GL_COLOR_BUFFER_BIT1_QCOM', 0x0002, 'GL_QCOM_tiled_rendering')
GL_COLOR_BUFFER_BIT2_QCOM = Enumerant('GL_COLOR_BUFFER_BIT2_QCOM', 0x0004, 'GL_QCOM_tiled_rendering')
GL_COLOR_BUFFER_BIT3_QCOM = Enumerant('GL_COLOR_BUFFER_BIT3_QCOM', 0x0008, 'GL_QCOM_tiled_rendering')
GL_COLOR_BUFFER_BIT4_QCOM = Enumerant('GL_COLOR_BUFFER_BIT4_QCOM', 0x0010, 'GL_QCOM_tiled_rendering')
GL_COLOR_BUFFER_BIT5_QCOM = Enumerant('GL_COLOR_BUFFER_BIT5_QCOM', 0x0020, 'GL_QCOM_tiled_rendering')
GL_COLOR_BUFFER_BIT6_QCOM = Enumerant('GL_COLOR_BUFFER_BIT6_QCOM', 0x0040, 'GL_QCOM_tiled_rendering')
GL_COLOR_BUFFER_BIT7_QCOM = Enumerant('GL_COLOR_BUFFER_BIT7_QCOM', 0x0080, 'GL_QCOM_tiled_rendering')
GL_DEPTH_BUFFER_BIT0_QCOM = Enumerant('GL_DEPTH_BUFFER_BIT0_QCOM', 0x0100, 'GL_QCOM_tiled_rendering')
GL_DEPTH_BUFFER_BIT1_QCOM = Enumerant('GL_DEPTH_BUFFER_BIT1_QCOM', 0x0200, 'GL_QCOM_tiled_rendering')
GL_DEPTH_BUFFER_BIT2_QCOM = Enumerant('GL_DEPTH_BUFFER_BIT2_QCOM', 0x0400, 'GL_QCOM_tiled_rendering')
GL_DEPTH_BUFFER_BIT3_QCOM = Enumerant('GL_DEPTH_BUFFER_BIT3_QCOM', 0x0800, 'GL_QCOM_tiled_rendering')
GL_DEPTH_BUFFER_BIT4_QCOM = Enumerant('GL_DEPTH_BUFFER_BIT4_QCOM', 0x1000, 'GL_QCOM_tiled_rendering')
GL_DEPTH_BUFFER_BIT5_QCOM = Enumerant('GL_DEPTH_BUFFER_BIT5_QCOM', 0x2000, 'GL_QCOM_tiled_rendering')
GL_DEPTH_BUFFER_BIT6_QCOM = Enumerant('GL_DEPTH_BUFFER_BIT6_QCOM', 0x4000, 'GL_QCOM_tiled_rendering')
GL_DEPTH_BUFFER_BIT7_QCOM = Enumerant('GL_DEPTH_BUFFER_BIT7_QCOM', 0x8000, 'GL_QCOM_tiled_rendering')
GL_MULTISAMPLE_BUFFER_BIT0_QCOM = Enumerant('GL_MULTISAMPLE_BUFFER_BIT0_QCOM', 0x1000000, 'GL_QCOM_tiled_rendering')
GL_MULTISAMPLE_BUFFER_BIT1_QCOM = Enumerant('GL_MULTISAMPLE_BUFFER_BIT1_QCOM', 0x2000000, 'GL_QCOM_tiled_rendering')
GL_MULTISAMPLE_BUFFER_BIT2_QCOM = Enumerant('GL_MULTISAMPLE_BUFFER_BIT2_QCOM', 0x4000000, 'GL_QCOM_tiled_rendering')
GL_MULTISAMPLE_BUFFER_BIT3_QCOM = Enumerant('GL_MULTISAMPLE_BUFFER_BIT3_QCOM', 0x8000000, 'GL_QCOM_tiled_rendering')
GL_MULTISAMPLE_BUFFER_BIT4_QCOM = Enumerant('GL_MULTISAMPLE_BUFFER_BIT4_QCOM', 0x10000000, 'GL_QCOM_tiled_rendering')
GL_MULTISAMPLE_BUFFER_BIT5_QCOM = Enumerant('GL_MULTISAMPLE_BUFFER_BIT5_QCOM', 0x20000000, 'GL_QCOM_tiled_rendering')
GL_MULTISAMPLE_BUFFER_BIT6_QCOM = Enumerant('GL_MULTISAMPLE_BUFFER_BIT6_QCOM', 0x40000000, 'GL_QCOM_tiled_rendering')
GL_MULTISAMPLE_BUFFER_BIT7_QCOM = Enumerant('GL_MULTISAMPLE_BUFFER_BIT7_QCOM', 0x80000000, 'GL_QCOM_tiled_rendering')
GL_STENCIL_BUFFER_BIT0_QCOM = Enumerant('GL_STENCIL_BUFFER_BIT0_QCOM', 0x10000, 'GL_QCOM_tiled_rendering')
GL_STENCIL_BUFFER_BIT1_QCOM = Enumerant('GL_STENCIL_BUFFER_BIT1_QCOM', 0x20000, 'GL_QCOM_tiled_rendering')
GL_STENCIL_BUFFER_BIT2_QCOM = Enumerant('GL_STENCIL_BUFFER_BIT2_QCOM', 0x40000, 'GL_QCOM_tiled_rendering')
GL_STENCIL_BUFFER_BIT3_QCOM = Enumerant('GL_STENCIL_BUFFER_BIT3_QCOM', 0x80000, 'GL_QCOM_tiled_rendering')
GL_STENCIL_BUFFER_BIT4_QCOM = Enumerant('GL_STENCIL_BUFFER_BIT4_QCOM', 0x100000, 'GL_QCOM_tiled_rendering')
GL_STENCIL_BUFFER_BIT5_QCOM = Enumerant('GL_STENCIL_BUFFER_BIT5_QCOM', 0x200000, 'GL_QCOM_tiled_rendering')
GL_STENCIL_BUFFER_BIT6_QCOM = Enumerant('GL_STENCIL_BUFFER_BIT6_QCOM', 0x400000, 'GL_QCOM_tiled_rendering')
GL_STENCIL_BUFFER_BIT7_QCOM = Enumerant('GL_STENCIL_BUFFER_BIT7_QCOM', 0x800000, 'GL_QCOM_tiled_rendering')

defines.add(GL_COLOR_BUFFER_BIT0_QCOM)
defines.add(GL_COLOR_BUFFER_BIT1_QCOM)
defines.add(GL_COLOR_BUFFER_BIT2_QCOM)
defines.add(GL_COLOR_BUFFER_BIT3_QCOM)
defines.add(GL_COLOR_BUFFER_BIT4_QCOM)
defines.add(GL_COLOR_BUFFER_BIT5_QCOM)
defines.add(GL_COLOR_BUFFER_BIT6_QCOM)
defines.add(GL_COLOR_BUFFER_BIT7_QCOM)
defines.add(GL_DEPTH_BUFFER_BIT0_QCOM)
defines.add(GL_DEPTH_BUFFER_BIT1_QCOM)
defines.add(GL_DEPTH_BUFFER_BIT2_QCOM)
defines.add(GL_DEPTH_BUFFER_BIT3_QCOM)
defines.add(GL_DEPTH_BUFFER_BIT4_QCOM)
defines.add(GL_DEPTH_BUFFER_BIT5_QCOM)
defines.add(GL_DEPTH_BUFFER_BIT6_QCOM)
defines.add(GL_DEPTH_BUFFER_BIT7_QCOM)
defines.add(GL_MULTISAMPLE_BUFFER_BIT0_QCOM)
defines.add(GL_MULTISAMPLE_BUFFER_BIT1_QCOM)
defines.add(GL_MULTISAMPLE_BUFFER_BIT2_QCOM)
defines.add(GL_MULTISAMPLE_BUFFER_BIT3_QCOM)
defines.add(GL_MULTISAMPLE_BUFFER_BIT4_QCOM)
defines.add(GL_MULTISAMPLE_BUFFER_BIT5_QCOM)
defines.add(GL_MULTISAMPLE_BUFFER_BIT6_QCOM)
defines.add(GL_MULTISAMPLE_BUFFER_BIT7_QCOM)
defines.add(GL_STENCIL_BUFFER_BIT0_QCOM)
defines.add(GL_STENCIL_BUFFER_BIT1_QCOM)
defines.add(GL_STENCIL_BUFFER_BIT2_QCOM)
defines.add(GL_STENCIL_BUFFER_BIT3_QCOM)
defines.add(GL_STENCIL_BUFFER_BIT4_QCOM)
defines.add(GL_STENCIL_BUFFER_BIT5_QCOM)
defines.add(GL_STENCIL_BUFFER_BIT6_QCOM)
defines.add(GL_STENCIL_BUFFER_BIT7_QCOM)

# GL_QCOM_writeonly_rendering

GL_WRITEONLY_RENDERING_QCOM = Enumerant('GL_WRITEONLY_RENDERING_QCOM', 0x8823, 'GL_QCOM_writeonly_rendering')

defines.add(GL_WRITEONLY_RENDERING_QCOM)

# GL_REGAL_enable

GL_CACHE_REGAL = Enumerant('GL_CACHE_REGAL', 0x9362, 'GL_REGAL_enable')
GL_CODE_REGAL = Enumerant('GL_CODE_REGAL', 0x9363, 'GL_REGAL_enable')
GL_DEBUG_REGAL = Enumerant('GL_DEBUG_REGAL', 0x9323, 'GL_REGAL_enable')
GL_DRIVER_REGAL = Enumerant('GL_DRIVER_REGAL', 0x9326, 'GL_REGAL_enable')
GL_EMULATION_REGAL = Enumerant('GL_EMULATION_REGAL', 0x9325, 'GL_REGAL_enable')
GL_ERROR_REGAL = Enumerant('GL_ERROR_REGAL', 0x9322, 'GL_REGAL_enable')
GL_LOG_REGAL = Enumerant('GL_LOG_REGAL', 0x9324, 'GL_REGAL_enable')
GL_MISSING_REGAL = Enumerant('GL_MISSING_REGAL', 0x9360, 'GL_REGAL_enable')
GL_STATISTICS_REGAL = Enumerant('GL_STATISTICS_REGAL', 0x9364, 'GL_REGAL_enable')
GL_TRACE_REGAL = Enumerant('GL_TRACE_REGAL', 0x9361, 'GL_REGAL_enable')

defines.add(GL_CACHE_REGAL)
defines.add(GL_CODE_REGAL)
defines.add(GL_DEBUG_REGAL)
defines.add(GL_DRIVER_REGAL)
defines.add(GL_EMULATION_REGAL)
defines.add(GL_ERROR_REGAL)
defines.add(GL_LOG_REGAL)
defines.add(GL_MISSING_REGAL)
defines.add(GL_STATISTICS_REGAL)
defines.add(GL_TRACE_REGAL)

# GL_REGAL_log

GL_LOG_APP_REGAL = Enumerant('GL_LOG_APP_REGAL', 0x931c, 'GL_REGAL_log')
GL_LOG_DEBUG_REGAL = Enumerant('GL_LOG_DEBUG_REGAL', 0x931f, 'GL_REGAL_log')
GL_LOG_DRIVER_REGAL = Enumerant('GL_LOG_DRIVER_REGAL', 0x931d, 'GL_REGAL_log')
GL_LOG_ERROR_REGAL = Enumerant('GL_LOG_ERROR_REGAL', 0x9319, 'GL_REGAL_log')
GL_LOG_HTTP_REGAL = Enumerant('GL_LOG_HTTP_REGAL', 0x9321, 'GL_REGAL_log')
GL_LOG_INFO_REGAL = Enumerant('GL_LOG_INFO_REGAL', 0x931b, 'GL_REGAL_log')
GL_LOG_INTERNAL_REGAL = Enumerant('GL_LOG_INTERNAL_REGAL', 0x931e, 'GL_REGAL_log')
GL_LOG_STATUS_REGAL = Enumerant('GL_LOG_STATUS_REGAL', 0x9320, 'GL_REGAL_log')
GL_LOG_WARNING_REGAL = Enumerant('GL_LOG_WARNING_REGAL', 0x931a, 'GL_REGAL_log')

defines.add(GL_LOG_APP_REGAL)
defines.add(GL_LOG_DEBUG_REGAL)
defines.add(GL_LOG_DRIVER_REGAL)
defines.add(GL_LOG_ERROR_REGAL)
defines.add(GL_LOG_HTTP_REGAL)
defines.add(GL_LOG_INFO_REGAL)
defines.add(GL_LOG_INTERNAL_REGAL)
defines.add(GL_LOG_STATUS_REGAL)
defines.add(GL_LOG_WARNING_REGAL)

# GL_REND_screen_coordinates

GL_INVERTED_SCREEN_W_REND = Enumerant('GL_INVERTED_SCREEN_W_REND', 0x8491, 'GL_REND_screen_coordinates')
GL_SCREEN_COORDINATES_REND = Enumerant('GL_SCREEN_COORDINATES_REND', 0x8490, 'GL_REND_screen_coordinates')

defines.add(GL_INVERTED_SCREEN_W_REND)
defines.add(GL_SCREEN_COORDINATES_REND)

# GL_S3_s3tc

GL_RGB4_S3TC = Enumerant('GL_RGB4_S3TC', 0x83a1, 'GL_S3_s3tc')
GL_RGBA4_DXT5_S3TC = Enumerant('GL_RGBA4_DXT5_S3TC', 0x83a5, 'GL_S3_s3tc')
GL_RGBA4_S3TC = Enumerant('GL_RGBA4_S3TC', 0x83a3, 'GL_S3_s3tc')
GL_RGBA_DXT5_S3TC = Enumerant('GL_RGBA_DXT5_S3TC', 0x83a4, 'GL_S3_s3tc')
GL_RGBA_S3TC = Enumerant('GL_RGBA_S3TC', 0x83a2, 'GL_S3_s3tc')
GL_RGB_S3TC = Enumerant('GL_RGB_S3TC', 0x83a0, 'GL_S3_s3tc')

defines.add(GL_RGB4_S3TC)
defines.add(GL_RGBA4_DXT5_S3TC)
defines.add(GL_RGBA4_S3TC)
defines.add(GL_RGBA_DXT5_S3TC)
defines.add(GL_RGBA_S3TC)
defines.add(GL_RGB_S3TC)

# GL_SGIS_color_range

GL_EXTENDED_RANGE_SGIS = Enumerant('GL_EXTENDED_RANGE_SGIS', 0x85a5, 'GL_SGIS_color_range')
GL_MAX_ALPHA_SGIS = Enumerant('GL_MAX_ALPHA_SGIS', 0x85ad, 'GL_SGIS_color_range')
GL_MAX_BLUE_SGIS = Enumerant('GL_MAX_BLUE_SGIS', 0x85ab, 'GL_SGIS_color_range')
GL_MAX_GREEN_SGIS = Enumerant('GL_MAX_GREEN_SGIS', 0x85a9, 'GL_SGIS_color_range')
GL_MAX_RED_SGIS = Enumerant('GL_MAX_RED_SGIS', 0x85a7, 'GL_SGIS_color_range')
GL_MIN_ALPHA_SGIS = Enumerant('GL_MIN_ALPHA_SGIS', 0x85ac, 'GL_SGIS_color_range')
GL_MIN_BLUE_SGIS = Enumerant('GL_MIN_BLUE_SGIS', 0x85aa, 'GL_SGIS_color_range')
GL_MIN_GREEN_SGIS = Enumerant('GL_MIN_GREEN_SGIS', 0x85a8, 'GL_SGIS_color_range')
GL_MIN_RED_SGIS = Enumerant('GL_MIN_RED_SGIS', 0x85a6, 'GL_SGIS_color_range')

defines.add(GL_EXTENDED_RANGE_SGIS)
defines.add(GL_MAX_ALPHA_SGIS)
defines.add(GL_MAX_BLUE_SGIS)
defines.add(GL_MAX_GREEN_SGIS)
defines.add(GL_MAX_RED_SGIS)
defines.add(GL_MIN_ALPHA_SGIS)
defines.add(GL_MIN_BLUE_SGIS)
defines.add(GL_MIN_GREEN_SGIS)
defines.add(GL_MIN_RED_SGIS)

# GL_SGIS_detail_texture

GL_DETAIL_TEXTURE_2D_BINDING_SGIS = Enumerant('GL_DETAIL_TEXTURE_2D_BINDING_SGIS', 0x8096, 'GL_SGIS_detail_texture')
GL_DETAIL_TEXTURE_2D_SGIS = Enumerant('GL_DETAIL_TEXTURE_2D_SGIS', 0x8095, 'GL_SGIS_detail_texture')
GL_DETAIL_TEXTURE_FUNC_POINTS_SGIS = Enumerant('GL_DETAIL_TEXTURE_FUNC_POINTS_SGIS', 0x809c, 'GL_SGIS_detail_texture')
GL_DETAIL_TEXTURE_LEVEL_SGIS = Enumerant('GL_DETAIL_TEXTURE_LEVEL_SGIS', 0x809a, 'GL_SGIS_detail_texture')
GL_DETAIL_TEXTURE_MODE_SGIS = Enumerant('GL_DETAIL_TEXTURE_MODE_SGIS', 0x809b, 'GL_SGIS_detail_texture')
GL_LINEAR_DETAIL_ALPHA_SGIS = Enumerant('GL_LINEAR_DETAIL_ALPHA_SGIS', 0x8098, 'GL_SGIS_detail_texture')
GL_LINEAR_DETAIL_COLOR_SGIS = Enumerant('GL_LINEAR_DETAIL_COLOR_SGIS', 0x8099, 'GL_SGIS_detail_texture')
GL_LINEAR_DETAIL_SGIS = Enumerant('GL_LINEAR_DETAIL_SGIS', 0x8097, 'GL_SGIS_detail_texture')

defines.add(GL_DETAIL_TEXTURE_2D_BINDING_SGIS)
defines.add(GL_DETAIL_TEXTURE_2D_SGIS)
defines.add(GL_DETAIL_TEXTURE_FUNC_POINTS_SGIS)
defines.add(GL_DETAIL_TEXTURE_LEVEL_SGIS)
defines.add(GL_DETAIL_TEXTURE_MODE_SGIS)
defines.add(GL_LINEAR_DETAIL_ALPHA_SGIS)
defines.add(GL_LINEAR_DETAIL_COLOR_SGIS)
defines.add(GL_LINEAR_DETAIL_SGIS)

# GL_SGIS_generate_mipmap

GL_GENERATE_MIPMAP_HINT_SGIS = Enumerant('GL_GENERATE_MIPMAP_HINT_SGIS', 0x8192, 'GL_SGIS_generate_mipmap')
GL_GENERATE_MIPMAP_SGIS = Enumerant('GL_GENERATE_MIPMAP_SGIS', 0x8191, 'GL_SGIS_generate_mipmap')

defines.add(GL_GENERATE_MIPMAP_HINT_SGIS)
defines.add(GL_GENERATE_MIPMAP_SGIS)

# GL_SGIS_multisample

GL_1PASS_SGIS = Enumerant('GL_1PASS_SGIS', 0x80a1, 'GL_SGIS_multisample')
GL_2PASS_0_SGIS = Enumerant('GL_2PASS_0_SGIS', 0x80a2, 'GL_SGIS_multisample')
GL_2PASS_1_SGIS = Enumerant('GL_2PASS_1_SGIS', 0x80a3, 'GL_SGIS_multisample')
GL_4PASS_0_SGIS = Enumerant('GL_4PASS_0_SGIS', 0x80a4, 'GL_SGIS_multisample')
GL_4PASS_1_SGIS = Enumerant('GL_4PASS_1_SGIS', 0x80a5, 'GL_SGIS_multisample')
GL_4PASS_2_SGIS = Enumerant('GL_4PASS_2_SGIS', 0x80a6, 'GL_SGIS_multisample')
GL_4PASS_3_SGIS = Enumerant('GL_4PASS_3_SGIS', 0x80a7, 'GL_SGIS_multisample')
GL_MULTISAMPLE_SGIS = Enumerant('GL_MULTISAMPLE_SGIS', 0x809d, 'GL_SGIS_multisample')
GL_SAMPLES_SGIS = Enumerant('GL_SAMPLES_SGIS', 0x80a9, 'GL_SGIS_multisample')
GL_SAMPLE_ALPHA_TO_MASK_SGIS = Enumerant('GL_SAMPLE_ALPHA_TO_MASK_SGIS', 0x809e, 'GL_SGIS_multisample')
GL_SAMPLE_ALPHA_TO_ONE_SGIS = Enumerant('GL_SAMPLE_ALPHA_TO_ONE_SGIS', 0x809f, 'GL_SGIS_multisample')
GL_SAMPLE_BUFFERS_SGIS = Enumerant('GL_SAMPLE_BUFFERS_SGIS', 0x80a8, 'GL_SGIS_multisample')
GL_SAMPLE_MASK_INVERT_SGIS = Enumerant('GL_SAMPLE_MASK_INVERT_SGIS', 0x80ab, 'GL_SGIS_multisample')
GL_SAMPLE_MASK_SGIS = Enumerant('GL_SAMPLE_MASK_SGIS', 0x80a0, 'GL_SGIS_multisample')
GL_SAMPLE_MASK_VALUE_SGIS = Enumerant('GL_SAMPLE_MASK_VALUE_SGIS', 0x80aa, 'GL_SGIS_multisample')
GL_SAMPLE_PATTERN_SGIS = Enumerant('GL_SAMPLE_PATTERN_SGIS', 0x80ac, 'GL_SGIS_multisample')

defines.add(GL_1PASS_SGIS)
defines.add(GL_2PASS_0_SGIS)
defines.add(GL_2PASS_1_SGIS)
defines.add(GL_4PASS_0_SGIS)
defines.add(GL_4PASS_1_SGIS)
defines.add(GL_4PASS_2_SGIS)
defines.add(GL_4PASS_3_SGIS)
defines.add(GL_MULTISAMPLE_SGIS)
defines.add(GL_SAMPLES_SGIS)
defines.add(GL_SAMPLE_ALPHA_TO_MASK_SGIS)
defines.add(GL_SAMPLE_ALPHA_TO_ONE_SGIS)
defines.add(GL_SAMPLE_BUFFERS_SGIS)
defines.add(GL_SAMPLE_MASK_INVERT_SGIS)
defines.add(GL_SAMPLE_MASK_SGIS)
defines.add(GL_SAMPLE_MASK_VALUE_SGIS)
defines.add(GL_SAMPLE_PATTERN_SGIS)

# GL_SGIS_point_line_texgen

GL_EYE_DISTANCE_TO_LINE_SGIS = Enumerant('GL_EYE_DISTANCE_TO_LINE_SGIS', 0x81f2, 'GL_SGIS_point_line_texgen')
GL_EYE_DISTANCE_TO_POINT_SGIS = Enumerant('GL_EYE_DISTANCE_TO_POINT_SGIS', 0x81f0, 'GL_SGIS_point_line_texgen')
GL_EYE_LINE_SGIS = Enumerant('GL_EYE_LINE_SGIS', 0x81f6, 'GL_SGIS_point_line_texgen')
GL_EYE_POINT_SGIS = Enumerant('GL_EYE_POINT_SGIS', 0x81f4, 'GL_SGIS_point_line_texgen')
GL_OBJECT_DISTANCE_TO_LINE_SGIS = Enumerant('GL_OBJECT_DISTANCE_TO_LINE_SGIS', 0x81f3, 'GL_SGIS_point_line_texgen')
GL_OBJECT_DISTANCE_TO_POINT_SGIS = Enumerant('GL_OBJECT_DISTANCE_TO_POINT_SGIS', 0x81f1, 'GL_SGIS_point_line_texgen')
GL_OBJECT_LINE_SGIS = Enumerant('GL_OBJECT_LINE_SGIS', 0x81f7, 'GL_SGIS_point_line_texgen')
GL_OBJECT_POINT_SGIS = Enumerant('GL_OBJECT_POINT_SGIS', 0x81f5, 'GL_SGIS_point_line_texgen')

defines.add(GL_EYE_DISTANCE_TO_LINE_SGIS)
defines.add(GL_EYE_DISTANCE_TO_POINT_SGIS)
defines.add(GL_EYE_LINE_SGIS)
defines.add(GL_EYE_POINT_SGIS)
defines.add(GL_OBJECT_DISTANCE_TO_LINE_SGIS)
defines.add(GL_OBJECT_DISTANCE_TO_POINT_SGIS)
defines.add(GL_OBJECT_LINE_SGIS)
defines.add(GL_OBJECT_POINT_SGIS)

# GL_SGIS_texture_border_clamp

GL_CLAMP_TO_BORDER_SGIS = Enumerant('GL_CLAMP_TO_BORDER_SGIS', 0x812d, 'GL_SGIS_texture_border_clamp')

defines.add(GL_CLAMP_TO_BORDER_SGIS)

# GL_SGIS_texture_edge_clamp

GL_CLAMP_TO_EDGE_SGIS = Enumerant('GL_CLAMP_TO_EDGE_SGIS', 0x812f, 'GL_SGIS_texture_edge_clamp')

defines.add(GL_CLAMP_TO_EDGE_SGIS)

# GL_SGIS_texture_lod

GL_TEXTURE_BASE_LEVEL_SGIS = Enumerant('GL_TEXTURE_BASE_LEVEL_SGIS', 0x813c, 'GL_SGIS_texture_lod')
GL_TEXTURE_MAX_LEVEL_SGIS = Enumerant('GL_TEXTURE_MAX_LEVEL_SGIS', 0x813d, 'GL_SGIS_texture_lod')
GL_TEXTURE_MAX_LOD_SGIS = Enumerant('GL_TEXTURE_MAX_LOD_SGIS', 0x813b, 'GL_SGIS_texture_lod')
GL_TEXTURE_MIN_LOD_SGIS = Enumerant('GL_TEXTURE_MIN_LOD_SGIS', 0x813a, 'GL_SGIS_texture_lod')

defines.add(GL_TEXTURE_BASE_LEVEL_SGIS)
defines.add(GL_TEXTURE_MAX_LEVEL_SGIS)
defines.add(GL_TEXTURE_MAX_LOD_SGIS)
defines.add(GL_TEXTURE_MIN_LOD_SGIS)

# GL_SGIX_async

GL_ASYNC_MARKER_SGIX = Enumerant('GL_ASYNC_MARKER_SGIX', 0x8329, 'GL_SGIX_async')

defines.add(GL_ASYNC_MARKER_SGIX)

# GL_SGIX_async_histogram

GL_ASYNC_HISTOGRAM_SGIX = Enumerant('GL_ASYNC_HISTOGRAM_SGIX', 0x832c, 'GL_SGIX_async_histogram')
GL_MAX_ASYNC_HISTOGRAM_SGIX = Enumerant('GL_MAX_ASYNC_HISTOGRAM_SGIX', 0x832d, 'GL_SGIX_async_histogram')

defines.add(GL_ASYNC_HISTOGRAM_SGIX)
defines.add(GL_MAX_ASYNC_HISTOGRAM_SGIX)

# GL_SGIX_async_pixel

GL_ASYNC_DRAW_PIXELS_SGIX = Enumerant('GL_ASYNC_DRAW_PIXELS_SGIX', 0x835d, 'GL_SGIX_async_pixel')
GL_ASYNC_READ_PIXELS_SGIX = Enumerant('GL_ASYNC_READ_PIXELS_SGIX', 0x835e, 'GL_SGIX_async_pixel')
GL_ASYNC_TEX_IMAGE_SGIX = Enumerant('GL_ASYNC_TEX_IMAGE_SGIX', 0x835c, 'GL_SGIX_async_pixel')
GL_MAX_ASYNC_DRAW_PIXELS_SGIX = Enumerant('GL_MAX_ASYNC_DRAW_PIXELS_SGIX', 0x8360, 'GL_SGIX_async_pixel')
GL_MAX_ASYNC_READ_PIXELS_SGIX = Enumerant('GL_MAX_ASYNC_READ_PIXELS_SGIX', 0x8361, 'GL_SGIX_async_pixel')
GL_MAX_ASYNC_TEX_IMAGE_SGIX = Enumerant('GL_MAX_ASYNC_TEX_IMAGE_SGIX', 0x835f, 'GL_SGIX_async_pixel')

defines.add(GL_ASYNC_DRAW_PIXELS_SGIX)
defines.add(GL_ASYNC_READ_PIXELS_SGIX)
defines.add(GL_ASYNC_TEX_IMAGE_SGIX)
defines.add(GL_MAX_ASYNC_DRAW_PIXELS_SGIX)
defines.add(GL_MAX_ASYNC_READ_PIXELS_SGIX)
defines.add(GL_MAX_ASYNC_TEX_IMAGE_SGIX)

# GL_SGIX_blend_alpha_minmax

GL_ALPHA_MAX_SGIX = Enumerant('GL_ALPHA_MAX_SGIX', 0x8321, 'GL_SGIX_blend_alpha_minmax')
GL_ALPHA_MIN_SGIX = Enumerant('GL_ALPHA_MIN_SGIX', 0x8320, 'GL_SGIX_blend_alpha_minmax')

defines.add(GL_ALPHA_MAX_SGIX)
defines.add(GL_ALPHA_MIN_SGIX)

# GL_SGIX_convolution_accuracy

GL_CONVOLUTION_HINT_SGIX = Enumerant('GL_CONVOLUTION_HINT_SGIX', 0x8316, 'GL_SGIX_convolution_accuracy')

defines.add(GL_CONVOLUTION_HINT_SGIX)

# GL_SGIX_depth_texture

GL_DEPTH_COMPONENT16_SGIX = Enumerant('GL_DEPTH_COMPONENT16_SGIX', 0x81a5, 'GL_SGIX_depth_texture')
GL_DEPTH_COMPONENT24_SGIX = Enumerant('GL_DEPTH_COMPONENT24_SGIX', 0x81a6, 'GL_SGIX_depth_texture')
GL_DEPTH_COMPONENT32_SGIX = Enumerant('GL_DEPTH_COMPONENT32_SGIX', 0x81a7, 'GL_SGIX_depth_texture')

defines.add(GL_DEPTH_COMPONENT16_SGIX)
defines.add(GL_DEPTH_COMPONENT24_SGIX)
defines.add(GL_DEPTH_COMPONENT32_SGIX)

# GL_SGIX_fog_offset

GL_FOG_OFFSET_SGIX = Enumerant('GL_FOG_OFFSET_SGIX', 0x8198, 'GL_SGIX_fog_offset')
GL_FOG_OFFSET_VALUE_SGIX = Enumerant('GL_FOG_OFFSET_VALUE_SGIX', 0x8199, 'GL_SGIX_fog_offset')

defines.add(GL_FOG_OFFSET_SGIX)
defines.add(GL_FOG_OFFSET_VALUE_SGIX)

# GL_SGIX_fog_texture

GL_FOG_PATCHY_FACTOR_SGIX = Enumerant('GL_FOG_PATCHY_FACTOR_SGIX', 0x0000, 'GL_SGIX_fog_texture')
GL_FRAGMENT_FOG_SGIX = Enumerant('GL_FRAGMENT_FOG_SGIX', 0x0000, 'GL_SGIX_fog_texture')
GL_TEXTURE_FOG_SGIX = Enumerant('GL_TEXTURE_FOG_SGIX', 0x0000, 'GL_SGIX_fog_texture')

defines.add(GL_FOG_PATCHY_FACTOR_SGIX)
defines.add(GL_FRAGMENT_FOG_SGIX)
defines.add(GL_TEXTURE_FOG_SGIX)

# GL_SGIX_fragment_specular_lighting

GL_CURRENT_RASTER_NORMAL_SGIX = Enumerant('GL_CURRENT_RASTER_NORMAL_SGIX', 0x8406, 'GL_SGIX_fragment_specular_lighting')
GL_FRAGMENT_COLOR_MATERIAL_FACE_SGIX = Enumerant('GL_FRAGMENT_COLOR_MATERIAL_FACE_SGIX', 0x8402, 'GL_SGIX_fragment_specular_lighting')
GL_FRAGMENT_COLOR_MATERIAL_PARAMETER_SGIX = Enumerant('GL_FRAGMENT_COLOR_MATERIAL_PARAMETER_SGIX', 0x8403, 'GL_SGIX_fragment_specular_lighting')
GL_FRAGMENT_COLOR_MATERIAL_SGIX = Enumerant('GL_FRAGMENT_COLOR_MATERIAL_SGIX', 0x8401, 'GL_SGIX_fragment_specular_lighting')
GL_FRAGMENT_LIGHT0_SGIX = Enumerant('GL_FRAGMENT_LIGHT0_SGIX', 0x840c, 'GL_SGIX_fragment_specular_lighting')
GL_FRAGMENT_LIGHT1_SGIX = Enumerant('GL_FRAGMENT_LIGHT1_SGIX', 0x840d, 'GL_SGIX_fragment_specular_lighting')
GL_FRAGMENT_LIGHT2_SGIX = Enumerant('GL_FRAGMENT_LIGHT2_SGIX', 0x840e, 'GL_SGIX_fragment_specular_lighting')
GL_FRAGMENT_LIGHT3_SGIX = Enumerant('GL_FRAGMENT_LIGHT3_SGIX', 0x840f, 'GL_SGIX_fragment_specular_lighting')
GL_FRAGMENT_LIGHT4_SGIX = Enumerant('GL_FRAGMENT_LIGHT4_SGIX', 0x8410, 'GL_SGIX_fragment_specular_lighting')
GL_FRAGMENT_LIGHT5_SGIX = Enumerant('GL_FRAGMENT_LIGHT5_SGIX', 0x8411, 'GL_SGIX_fragment_specular_lighting')
GL_FRAGMENT_LIGHT6_SGIX = Enumerant('GL_FRAGMENT_LIGHT6_SGIX', 0x8412, 'GL_SGIX_fragment_specular_lighting')
GL_FRAGMENT_LIGHT7_SGIX = Enumerant('GL_FRAGMENT_LIGHT7_SGIX', 0x8413, 'GL_SGIX_fragment_specular_lighting')
GL_FRAGMENT_LIGHTING_SGIX = Enumerant('GL_FRAGMENT_LIGHTING_SGIX', 0x8400, 'GL_SGIX_fragment_specular_lighting')
GL_FRAGMENT_LIGHT_MODEL_AMBIENT_SGIX = Enumerant('GL_FRAGMENT_LIGHT_MODEL_AMBIENT_SGIX', 0x840a, 'GL_SGIX_fragment_specular_lighting')
GL_FRAGMENT_LIGHT_MODEL_LOCAL_VIEWER_SGIX = Enumerant('GL_FRAGMENT_LIGHT_MODEL_LOCAL_VIEWER_SGIX', 0x8408, 'GL_SGIX_fragment_specular_lighting')
GL_FRAGMENT_LIGHT_MODEL_NORMAL_INTERPOLATION_SGIX = Enumerant('GL_FRAGMENT_LIGHT_MODEL_NORMAL_INTERPOLATION_SGIX', 0x840b, 'GL_SGIX_fragment_specular_lighting')
GL_FRAGMENT_LIGHT_MODEL_TWO_SIDE_SGIX = Enumerant('GL_FRAGMENT_LIGHT_MODEL_TWO_SIDE_SGIX', 0x8409, 'GL_SGIX_fragment_specular_lighting')
GL_LIGHT_ENV_MODE_SGIX = Enumerant('GL_LIGHT_ENV_MODE_SGIX', 0x8407, 'GL_SGIX_fragment_specular_lighting')
GL_MAX_ACTIVE_LIGHTS_SGIX = Enumerant('GL_MAX_ACTIVE_LIGHTS_SGIX', 0x8405, 'GL_SGIX_fragment_specular_lighting')
GL_MAX_FRAGMENT_LIGHTS_SGIX = Enumerant('GL_MAX_FRAGMENT_LIGHTS_SGIX', 0x8404, 'GL_SGIX_fragment_specular_lighting')

defines.add(GL_CURRENT_RASTER_NORMAL_SGIX)
defines.add(GL_FRAGMENT_COLOR_MATERIAL_FACE_SGIX)
defines.add(GL_FRAGMENT_COLOR_MATERIAL_PARAMETER_SGIX)
defines.add(GL_FRAGMENT_COLOR_MATERIAL_SGIX)
defines.add(GL_FRAGMENT_LIGHT0_SGIX)
defines.add(GL_FRAGMENT_LIGHT1_SGIX)
defines.add(GL_FRAGMENT_LIGHT2_SGIX)
defines.add(GL_FRAGMENT_LIGHT3_SGIX)
defines.add(GL_FRAGMENT_LIGHT4_SGIX)
defines.add(GL_FRAGMENT_LIGHT5_SGIX)
defines.add(GL_FRAGMENT_LIGHT6_SGIX)
defines.add(GL_FRAGMENT_LIGHT7_SGIX)
defines.add(GL_FRAGMENT_LIGHTING_SGIX)
defines.add(GL_FRAGMENT_LIGHT_MODEL_AMBIENT_SGIX)
defines.add(GL_FRAGMENT_LIGHT_MODEL_LOCAL_VIEWER_SGIX)
defines.add(GL_FRAGMENT_LIGHT_MODEL_NORMAL_INTERPOLATION_SGIX)
defines.add(GL_FRAGMENT_LIGHT_MODEL_TWO_SIDE_SGIX)
defines.add(GL_LIGHT_ENV_MODE_SGIX)
defines.add(GL_MAX_ACTIVE_LIGHTS_SGIX)
defines.add(GL_MAX_FRAGMENT_LIGHTS_SGIX)

# GL_SGIX_interlace

GL_INTERLACE_SGIX = Enumerant('GL_INTERLACE_SGIX', 0x8094, 'GL_SGIX_interlace')

defines.add(GL_INTERLACE_SGIX)

# GL_SGIX_resample

GL_PACK_RESAMPLE_SGIX = Enumerant('GL_PACK_RESAMPLE_SGIX', 0x842e, 'GL_SGIX_resample')
GL_RESAMPLE_DECIMATE_SGIX = Enumerant('GL_RESAMPLE_DECIMATE_SGIX', 0x8430, 'GL_SGIX_resample')
GL_RESAMPLE_REPLICATE_SGIX = Enumerant('GL_RESAMPLE_REPLICATE_SGIX', 0x8433, 'GL_SGIX_resample')
GL_RESAMPLE_ZERO_FILL_SGIX = Enumerant('GL_RESAMPLE_ZERO_FILL_SGIX', 0x8434, 'GL_SGIX_resample')
GL_UNPACK_RESAMPLE_SGIX = Enumerant('GL_UNPACK_RESAMPLE_SGIX', 0x842f, 'GL_SGIX_resample')

defines.add(GL_PACK_RESAMPLE_SGIX)
defines.add(GL_RESAMPLE_DECIMATE_SGIX)
defines.add(GL_RESAMPLE_REPLICATE_SGIX)
defines.add(GL_RESAMPLE_ZERO_FILL_SGIX)
defines.add(GL_UNPACK_RESAMPLE_SGIX)

# GL_SGIX_shadow

GL_TEXTURE_COMPARE_OPERATOR_SGIX = Enumerant('GL_TEXTURE_COMPARE_OPERATOR_SGIX', 0x819b, 'GL_SGIX_shadow')
GL_TEXTURE_COMPARE_SGIX = Enumerant('GL_TEXTURE_COMPARE_SGIX', 0x819a, 'GL_SGIX_shadow')
GL_TEXTURE_GEQUAL_R_SGIX = Enumerant('GL_TEXTURE_GEQUAL_R_SGIX', 0x819d, 'GL_SGIX_shadow')
GL_TEXTURE_LEQUAL_R_SGIX = Enumerant('GL_TEXTURE_LEQUAL_R_SGIX', 0x819c, 'GL_SGIX_shadow')

defines.add(GL_TEXTURE_COMPARE_OPERATOR_SGIX)
defines.add(GL_TEXTURE_COMPARE_SGIX)
defines.add(GL_TEXTURE_GEQUAL_R_SGIX)
defines.add(GL_TEXTURE_LEQUAL_R_SGIX)

# GL_SGIX_shadow_ambient

GL_SHADOW_AMBIENT_SGIX = Enumerant('GL_SHADOW_AMBIENT_SGIX', 0x80bf, 'GL_SGIX_shadow_ambient')

defines.add(GL_SHADOW_AMBIENT_SGIX)

# GL_SGIX_texture_coordinate_clamp

GL_TEXTURE_MAX_CLAMP_R_SGIX = Enumerant('GL_TEXTURE_MAX_CLAMP_R_SGIX', 0x836b, 'GL_SGIX_texture_coordinate_clamp')
GL_TEXTURE_MAX_CLAMP_S_SGIX = Enumerant('GL_TEXTURE_MAX_CLAMP_S_SGIX', 0x8369, 'GL_SGIX_texture_coordinate_clamp')
GL_TEXTURE_MAX_CLAMP_T_SGIX = Enumerant('GL_TEXTURE_MAX_CLAMP_T_SGIX', 0x836a, 'GL_SGIX_texture_coordinate_clamp')

defines.add(GL_TEXTURE_MAX_CLAMP_R_SGIX)
defines.add(GL_TEXTURE_MAX_CLAMP_S_SGIX)
defines.add(GL_TEXTURE_MAX_CLAMP_T_SGIX)

# GL_SGIX_texture_multi_buffer

GL_TEXTURE_MULTI_BUFFER_HINT_SGIX = Enumerant('GL_TEXTURE_MULTI_BUFFER_HINT_SGIX', 0x812e, 'GL_SGIX_texture_multi_buffer')

defines.add(GL_TEXTURE_MULTI_BUFFER_HINT_SGIX)

# GL_SGIX_texture_range

GL_ALPHA16_EXTENDED_RANGE_SGIX = Enumerant('GL_ALPHA16_EXTENDED_RANGE_SGIX', 0x85f4, 'GL_SGIX_texture_range')
GL_ALPHA16_SIGNED_SGIX = Enumerant('GL_ALPHA16_SIGNED_SGIX', 0x85e8, 'GL_SGIX_texture_range')
GL_ALPHA_EXTENDED_RANGE_SGIX = Enumerant('GL_ALPHA_EXTENDED_RANGE_SGIX', 0x85ee, 'GL_SGIX_texture_range')
GL_ALPHA_SIGNED_SGIX = Enumerant('GL_ALPHA_SIGNED_SGIX', 0x85e2, 'GL_SGIX_texture_range')
GL_INTENSITY16_EXTENDED_RANGE_SGIX = Enumerant('GL_INTENSITY16_EXTENDED_RANGE_SGIX', 0x85f6, 'GL_SGIX_texture_range')
GL_INTENSITY16_SIGNED_SGIX = Enumerant('GL_INTENSITY16_SIGNED_SGIX', 0x85ea, 'GL_SGIX_texture_range')
GL_INTENSITY_EXTENDED_RANGE_SGIX = Enumerant('GL_INTENSITY_EXTENDED_RANGE_SGIX', 0x85f0, 'GL_SGIX_texture_range')
GL_INTENSITY_SIGNED_SGIX = Enumerant('GL_INTENSITY_SIGNED_SGIX', 0x85e4, 'GL_SGIX_texture_range')
GL_LUMINANCE16_ALPHA16_EXTENDED_RANGE_SGIX = Enumerant('GL_LUMINANCE16_ALPHA16_EXTENDED_RANGE_SGIX', 0x85f7, 'GL_SGIX_texture_range')
GL_LUMINANCE16_ALPHA16_SIGNED_SGIX = Enumerant('GL_LUMINANCE16_ALPHA16_SIGNED_SGIX', 0x85eb, 'GL_SGIX_texture_range')
GL_LUMINANCE16_EXTENDED_RANGE_SGIX = Enumerant('GL_LUMINANCE16_EXTENDED_RANGE_SGIX', 0x85f5, 'GL_SGIX_texture_range')
GL_LUMINANCE16_SIGNED_SGIX = Enumerant('GL_LUMINANCE16_SIGNED_SGIX', 0x85e9, 'GL_SGIX_texture_range')
GL_LUMINANCE_ALPHA_EXTENDED_RANGE_SGIX = Enumerant('GL_LUMINANCE_ALPHA_EXTENDED_RANGE_SGIX', 0x85f1, 'GL_SGIX_texture_range')
GL_LUMINANCE_ALPHA_SIGNED_SGIX = Enumerant('GL_LUMINANCE_ALPHA_SIGNED_SGIX', 0x85e5, 'GL_SGIX_texture_range')
GL_LUMINANCE_EXTENDED_RANGE_SGIX = Enumerant('GL_LUMINANCE_EXTENDED_RANGE_SGIX', 0x85ef, 'GL_SGIX_texture_range')
GL_LUMINANCE_SIGNED_SGIX = Enumerant('GL_LUMINANCE_SIGNED_SGIX', 0x85e3, 'GL_SGIX_texture_range')
GL_MAX_INTENSITY_SGIS = Enumerant('GL_MAX_INTENSITY_SGIS', 0x85fb, 'GL_SGIX_texture_range')
GL_MAX_LUMINANCE_SGIS = Enumerant('GL_MAX_LUMINANCE_SGIS', 0x85f9, 'GL_SGIX_texture_range')
GL_MIN_INTENSITY_SGIS = Enumerant('GL_MIN_INTENSITY_SGIS', 0x85fa, 'GL_SGIX_texture_range')
GL_MIN_LUMINANCE_SGIS = Enumerant('GL_MIN_LUMINANCE_SGIS', 0x85f8, 'GL_SGIX_texture_range')
GL_RGB16_EXTENDED_RANGE_SGIX = Enumerant('GL_RGB16_EXTENDED_RANGE_SGIX', 0x85f2, 'GL_SGIX_texture_range')
GL_RGB16_SIGNED_SGIX = Enumerant('GL_RGB16_SIGNED_SGIX', 0x85e6, 'GL_SGIX_texture_range')
GL_RGBA16_EXTENDED_RANGE_SGIX = Enumerant('GL_RGBA16_EXTENDED_RANGE_SGIX', 0x85f3, 'GL_SGIX_texture_range')
GL_RGBA16_SIGNED_SGIX = Enumerant('GL_RGBA16_SIGNED_SGIX', 0x85e7, 'GL_SGIX_texture_range')
GL_RGBA_EXTENDED_RANGE_SGIX = Enumerant('GL_RGBA_EXTENDED_RANGE_SGIX', 0x85ed, 'GL_SGIX_texture_range')
GL_RGBA_SIGNED_SGIX = Enumerant('GL_RGBA_SIGNED_SGIX', 0x85e1, 'GL_SGIX_texture_range')
GL_RGB_EXTENDED_RANGE_SGIX = Enumerant('GL_RGB_EXTENDED_RANGE_SGIX', 0x85ec, 'GL_SGIX_texture_range')
GL_RGB_SIGNED_SGIX = Enumerant('GL_RGB_SIGNED_SGIX', 0x85e0, 'GL_SGIX_texture_range')

defines.add(GL_ALPHA16_EXTENDED_RANGE_SGIX)
defines.add(GL_ALPHA16_SIGNED_SGIX)
defines.add(GL_ALPHA_EXTENDED_RANGE_SGIX)
defines.add(GL_ALPHA_SIGNED_SGIX)
defines.add(GL_INTENSITY16_EXTENDED_RANGE_SGIX)
defines.add(GL_INTENSITY16_SIGNED_SGIX)
defines.add(GL_INTENSITY_EXTENDED_RANGE_SGIX)
defines.add(GL_INTENSITY_SIGNED_SGIX)
defines.add(GL_LUMINANCE16_ALPHA16_EXTENDED_RANGE_SGIX)
defines.add(GL_LUMINANCE16_ALPHA16_SIGNED_SGIX)
defines.add(GL_LUMINANCE16_EXTENDED_RANGE_SGIX)
defines.add(GL_LUMINANCE16_SIGNED_SGIX)
defines.add(GL_LUMINANCE_ALPHA_EXTENDED_RANGE_SGIX)
defines.add(GL_LUMINANCE_ALPHA_SIGNED_SGIX)
defines.add(GL_LUMINANCE_EXTENDED_RANGE_SGIX)
defines.add(GL_LUMINANCE_SIGNED_SGIX)
defines.add(GL_MAX_INTENSITY_SGIS)
defines.add(GL_MAX_LUMINANCE_SGIS)
defines.add(GL_MIN_INTENSITY_SGIS)
defines.add(GL_MIN_LUMINANCE_SGIS)
defines.add(GL_RGB16_EXTENDED_RANGE_SGIX)
defines.add(GL_RGB16_SIGNED_SGIX)
defines.add(GL_RGBA16_EXTENDED_RANGE_SGIX)
defines.add(GL_RGBA16_SIGNED_SGIX)
defines.add(GL_RGBA_EXTENDED_RANGE_SGIX)
defines.add(GL_RGBA_SIGNED_SGIX)
defines.add(GL_RGB_EXTENDED_RANGE_SGIX)
defines.add(GL_RGB_SIGNED_SGIX)

# GL_SGIX_texture_scale_bias

GL_POST_TEXTURE_FILTER_BIAS_RANGE_SGIX = Enumerant('GL_POST_TEXTURE_FILTER_BIAS_RANGE_SGIX', 0x817b, 'GL_SGIX_texture_scale_bias')
GL_POST_TEXTURE_FILTER_BIAS_SGIX = Enumerant('GL_POST_TEXTURE_FILTER_BIAS_SGIX', 0x8179, 'GL_SGIX_texture_scale_bias')
GL_POST_TEXTURE_FILTER_SCALE_RANGE_SGIX = Enumerant('GL_POST_TEXTURE_FILTER_SCALE_RANGE_SGIX', 0x817c, 'GL_SGIX_texture_scale_bias')
GL_POST_TEXTURE_FILTER_SCALE_SGIX = Enumerant('GL_POST_TEXTURE_FILTER_SCALE_SGIX', 0x817a, 'GL_SGIX_texture_scale_bias')

defines.add(GL_POST_TEXTURE_FILTER_BIAS_RANGE_SGIX)
defines.add(GL_POST_TEXTURE_FILTER_BIAS_SGIX)
defines.add(GL_POST_TEXTURE_FILTER_SCALE_RANGE_SGIX)
defines.add(GL_POST_TEXTURE_FILTER_SCALE_SGIX)

# GL_SGIX_vertex_preclip_hint

GL_VERTEX_PRECLIP_HINT_SGIX = Enumerant('GL_VERTEX_PRECLIP_HINT_SGIX', 0x83ef, 'GL_SGIX_vertex_preclip_hint')
GL_VERTEX_PRECLIP_SGIX = Enumerant('GL_VERTEX_PRECLIP_SGIX', 0x83ee, 'GL_SGIX_vertex_preclip_hint')

defines.add(GL_VERTEX_PRECLIP_HINT_SGIX)
defines.add(GL_VERTEX_PRECLIP_SGIX)

# GL_SGIX_ycrcb

GL_YCRCB_422_SGIX = Enumerant('GL_YCRCB_422_SGIX', 0x81bb, 'GL_SGIX_ycrcb')
GL_YCRCB_444_SGIX = Enumerant('GL_YCRCB_444_SGIX', 0x81bc, 'GL_SGIX_ycrcb')

defines.add(GL_YCRCB_422_SGIX)
defines.add(GL_YCRCB_444_SGIX)

# GL_SGI_color_matrix

GL_COLOR_MATRIX_SGI = Enumerant('GL_COLOR_MATRIX_SGI', 0x80b1, 'GL_SGI_color_matrix')
GL_COLOR_MATRIX_STACK_DEPTH_SGI = Enumerant('GL_COLOR_MATRIX_STACK_DEPTH_SGI', 0x80b2, 'GL_SGI_color_matrix')
GL_MAX_COLOR_MATRIX_STACK_DEPTH_SGI = Enumerant('GL_MAX_COLOR_MATRIX_STACK_DEPTH_SGI', 0x80b3, 'GL_SGI_color_matrix')
GL_POST_COLOR_MATRIX_ALPHA_BIAS_SGI = Enumerant('GL_POST_COLOR_MATRIX_ALPHA_BIAS_SGI', 0x80bb, 'GL_SGI_color_matrix')
GL_POST_COLOR_MATRIX_ALPHA_SCALE_SGI = Enumerant('GL_POST_COLOR_MATRIX_ALPHA_SCALE_SGI', 0x80b7, 'GL_SGI_color_matrix')
GL_POST_COLOR_MATRIX_BLUE_BIAS_SGI = Enumerant('GL_POST_COLOR_MATRIX_BLUE_BIAS_SGI', 0x80ba, 'GL_SGI_color_matrix')
GL_POST_COLOR_MATRIX_BLUE_SCALE_SGI = Enumerant('GL_POST_COLOR_MATRIX_BLUE_SCALE_SGI', 0x80b6, 'GL_SGI_color_matrix')
GL_POST_COLOR_MATRIX_GREEN_BIAS_SGI = Enumerant('GL_POST_COLOR_MATRIX_GREEN_BIAS_SGI', 0x80b9, 'GL_SGI_color_matrix')
GL_POST_COLOR_MATRIX_GREEN_SCALE_SGI = Enumerant('GL_POST_COLOR_MATRIX_GREEN_SCALE_SGI', 0x80b5, 'GL_SGI_color_matrix')
GL_POST_COLOR_MATRIX_RED_BIAS_SGI = Enumerant('GL_POST_COLOR_MATRIX_RED_BIAS_SGI', 0x80b8, 'GL_SGI_color_matrix')
GL_POST_COLOR_MATRIX_RED_SCALE_SGI = Enumerant('GL_POST_COLOR_MATRIX_RED_SCALE_SGI', 0x80b4, 'GL_SGI_color_matrix')

defines.add(GL_COLOR_MATRIX_SGI)
defines.add(GL_COLOR_MATRIX_STACK_DEPTH_SGI)
defines.add(GL_MAX_COLOR_MATRIX_STACK_DEPTH_SGI)
defines.add(GL_POST_COLOR_MATRIX_ALPHA_BIAS_SGI)
defines.add(GL_POST_COLOR_MATRIX_ALPHA_SCALE_SGI)
defines.add(GL_POST_COLOR_MATRIX_BLUE_BIAS_SGI)
defines.add(GL_POST_COLOR_MATRIX_BLUE_SCALE_SGI)
defines.add(GL_POST_COLOR_MATRIX_GREEN_BIAS_SGI)
defines.add(GL_POST_COLOR_MATRIX_GREEN_SCALE_SGI)
defines.add(GL_POST_COLOR_MATRIX_RED_BIAS_SGI)
defines.add(GL_POST_COLOR_MATRIX_RED_SCALE_SGI)

# GL_SGI_color_table

GL_COLOR_TABLE_ALPHA_SIZE_SGI = Enumerant('GL_COLOR_TABLE_ALPHA_SIZE_SGI', 0x80dd, 'GL_SGI_color_table')
GL_COLOR_TABLE_BIAS_SGI = Enumerant('GL_COLOR_TABLE_BIAS_SGI', 0x80d7, 'GL_SGI_color_table')
GL_COLOR_TABLE_BLUE_SIZE_SGI = Enumerant('GL_COLOR_TABLE_BLUE_SIZE_SGI', 0x80dc, 'GL_SGI_color_table')
GL_COLOR_TABLE_FORMAT_SGI = Enumerant('GL_COLOR_TABLE_FORMAT_SGI', 0x80d8, 'GL_SGI_color_table')
GL_COLOR_TABLE_GREEN_SIZE_SGI = Enumerant('GL_COLOR_TABLE_GREEN_SIZE_SGI', 0x80db, 'GL_SGI_color_table')
GL_COLOR_TABLE_INTENSITY_SIZE_SGI = Enumerant('GL_COLOR_TABLE_INTENSITY_SIZE_SGI', 0x80df, 'GL_SGI_color_table')
GL_COLOR_TABLE_LUMINANCE_SIZE_SGI = Enumerant('GL_COLOR_TABLE_LUMINANCE_SIZE_SGI', 0x80de, 'GL_SGI_color_table')
GL_COLOR_TABLE_RED_SIZE_SGI = Enumerant('GL_COLOR_TABLE_RED_SIZE_SGI', 0x80da, 'GL_SGI_color_table')
GL_COLOR_TABLE_SCALE_SGI = Enumerant('GL_COLOR_TABLE_SCALE_SGI', 0x80d6, 'GL_SGI_color_table')
GL_COLOR_TABLE_SGI = Enumerant('GL_COLOR_TABLE_SGI', 0x80d0, 'GL_SGI_color_table')
GL_COLOR_TABLE_WIDTH_SGI = Enumerant('GL_COLOR_TABLE_WIDTH_SGI', 0x80d9, 'GL_SGI_color_table')
GL_POST_COLOR_MATRIX_COLOR_TABLE_SGI = Enumerant('GL_POST_COLOR_MATRIX_COLOR_TABLE_SGI', 0x80d2, 'GL_SGI_color_table')
GL_POST_CONVOLUTION_COLOR_TABLE_SGI = Enumerant('GL_POST_CONVOLUTION_COLOR_TABLE_SGI', 0x80d1, 'GL_SGI_color_table')
GL_PROXY_COLOR_TABLE_SGI = Enumerant('GL_PROXY_COLOR_TABLE_SGI', 0x80d3, 'GL_SGI_color_table')
GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE_SGI = Enumerant('GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE_SGI', 0x80d5, 'GL_SGI_color_table')
GL_PROXY_POST_CONVOLUTION_COLOR_TABLE_SGI = Enumerant('GL_PROXY_POST_CONVOLUTION_COLOR_TABLE_SGI', 0x80d4, 'GL_SGI_color_table')

defines.add(GL_COLOR_TABLE_ALPHA_SIZE_SGI)
defines.add(GL_COLOR_TABLE_BIAS_SGI)
defines.add(GL_COLOR_TABLE_BLUE_SIZE_SGI)
defines.add(GL_COLOR_TABLE_FORMAT_SGI)
defines.add(GL_COLOR_TABLE_GREEN_SIZE_SGI)
defines.add(GL_COLOR_TABLE_INTENSITY_SIZE_SGI)
defines.add(GL_COLOR_TABLE_LUMINANCE_SIZE_SGI)
defines.add(GL_COLOR_TABLE_RED_SIZE_SGI)
defines.add(GL_COLOR_TABLE_SCALE_SGI)
defines.add(GL_COLOR_TABLE_SGI)
defines.add(GL_COLOR_TABLE_WIDTH_SGI)
defines.add(GL_POST_COLOR_MATRIX_COLOR_TABLE_SGI)
defines.add(GL_POST_CONVOLUTION_COLOR_TABLE_SGI)
defines.add(GL_PROXY_COLOR_TABLE_SGI)
defines.add(GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE_SGI)
defines.add(GL_PROXY_POST_CONVOLUTION_COLOR_TABLE_SGI)

# GL_SGI_texture_color_table

GL_PROXY_TEXTURE_COLOR_TABLE_SGI = Enumerant('GL_PROXY_TEXTURE_COLOR_TABLE_SGI', 0x80bd, 'GL_SGI_texture_color_table')
GL_TEXTURE_COLOR_TABLE_SGI = Enumerant('GL_TEXTURE_COLOR_TABLE_SGI', 0x80bc, 'GL_SGI_texture_color_table')

defines.add(GL_PROXY_TEXTURE_COLOR_TABLE_SGI)
defines.add(GL_TEXTURE_COLOR_TABLE_SGI)

# GL_SUNX_constant_data

GL_TEXTURE_CONSTANT_DATA_SUNX = Enumerant('GL_TEXTURE_CONSTANT_DATA_SUNX', 0x81d6, 'GL_SUNX_constant_data')
GL_UNPACK_CONSTANT_DATA_SUNX = Enumerant('GL_UNPACK_CONSTANT_DATA_SUNX', 0x81d5, 'GL_SUNX_constant_data')

defines.add(GL_TEXTURE_CONSTANT_DATA_SUNX)
defines.add(GL_UNPACK_CONSTANT_DATA_SUNX)

# GL_SUN_convolution_border_modes

GL_WRAP_BORDER_SUN = Enumerant('GL_WRAP_BORDER_SUN', 0x81d4, 'GL_SUN_convolution_border_modes')

defines.add(GL_WRAP_BORDER_SUN)

# GL_SUN_global_alpha

GL_GLOBAL_ALPHA_FACTOR_SUN = Enumerant('GL_GLOBAL_ALPHA_FACTOR_SUN', 0x81da, 'GL_SUN_global_alpha')
GL_GLOBAL_ALPHA_SUN = Enumerant('GL_GLOBAL_ALPHA_SUN', 0x81d9, 'GL_SUN_global_alpha')

defines.add(GL_GLOBAL_ALPHA_FACTOR_SUN)
defines.add(GL_GLOBAL_ALPHA_SUN)

# GL_SUN_mesh_array

GL_QUAD_MESH_SUN = Enumerant('GL_QUAD_MESH_SUN', 0x8614, 'GL_SUN_mesh_array')
GL_TRIANGLE_MESH_SUN = Enumerant('GL_TRIANGLE_MESH_SUN', 0x8615, 'GL_SUN_mesh_array')

defines.add(GL_QUAD_MESH_SUN)
defines.add(GL_TRIANGLE_MESH_SUN)

# GL_SUN_slice_accum

GL_SLICE_ACCUM_SUN = Enumerant('GL_SLICE_ACCUM_SUN', 0x85cc, 'GL_SUN_slice_accum')

defines.add(GL_SLICE_ACCUM_SUN)

# GL_SUN_triangle_list

GL_R1UI_C3F_V3F_SUN = Enumerant('GL_R1UI_C3F_V3F_SUN', 0x85c6, 'GL_SUN_triangle_list')
GL_R1UI_C4F_N3F_V3F_SUN = Enumerant('GL_R1UI_C4F_N3F_V3F_SUN', 0x85c8, 'GL_SUN_triangle_list')
GL_R1UI_C4UB_V3F_SUN = Enumerant('GL_R1UI_C4UB_V3F_SUN', 0x85c5, 'GL_SUN_triangle_list')
GL_R1UI_N3F_V3F_SUN = Enumerant('GL_R1UI_N3F_V3F_SUN', 0x85c7, 'GL_SUN_triangle_list')
GL_R1UI_T2F_C4F_N3F_V3F_SUN = Enumerant('GL_R1UI_T2F_C4F_N3F_V3F_SUN', 0x85cb, 'GL_SUN_triangle_list')
GL_R1UI_T2F_N3F_V3F_SUN = Enumerant('GL_R1UI_T2F_N3F_V3F_SUN', 0x85ca, 'GL_SUN_triangle_list')
GL_R1UI_T2F_V3F_SUN = Enumerant('GL_R1UI_T2F_V3F_SUN', 0x85c9, 'GL_SUN_triangle_list')
GL_R1UI_V3F_SUN = Enumerant('GL_R1UI_V3F_SUN', 0x85c4, 'GL_SUN_triangle_list')
GL_REPLACEMENT_CODE_ARRAY_POINTER_SUN = Enumerant('GL_REPLACEMENT_CODE_ARRAY_POINTER_SUN', 0x85c3, 'GL_SUN_triangle_list')
GL_REPLACEMENT_CODE_ARRAY_STRIDE_SUN = Enumerant('GL_REPLACEMENT_CODE_ARRAY_STRIDE_SUN', 0x85c2, 'GL_SUN_triangle_list')
GL_REPLACEMENT_CODE_ARRAY_SUN = Enumerant('GL_REPLACEMENT_CODE_ARRAY_SUN', 0x85c0, 'GL_SUN_triangle_list')
GL_REPLACEMENT_CODE_ARRAY_TYPE_SUN = Enumerant('GL_REPLACEMENT_CODE_ARRAY_TYPE_SUN', 0x85c1, 'GL_SUN_triangle_list')
GL_REPLACEMENT_CODE_SUN = Enumerant('GL_REPLACEMENT_CODE_SUN', 0x81d8, 'GL_SUN_triangle_list')
GL_REPLACE_MIDDLE_SUN = Enumerant('GL_REPLACE_MIDDLE_SUN', 0x0002, 'GL_SUN_triangle_list')
GL_REPLACE_OLDEST_SUN = Enumerant('GL_REPLACE_OLDEST_SUN', 0x0003, 'GL_SUN_triangle_list')
GL_RESTART_SUN = Enumerant('GL_RESTART_SUN', 0x0001, 'GL_SUN_triangle_list')
GL_TRIANGLE_LIST_SUN = Enumerant('GL_TRIANGLE_LIST_SUN', 0x81d7, 'GL_SUN_triangle_list')

defines.add(GL_R1UI_C3F_V3F_SUN)
defines.add(GL_R1UI_C4F_N3F_V3F_SUN)
defines.add(GL_R1UI_C4UB_V3F_SUN)
defines.add(GL_R1UI_N3F_V3F_SUN)
defines.add(GL_R1UI_T2F_C4F_N3F_V3F_SUN)
defines.add(GL_R1UI_T2F_N3F_V3F_SUN)
defines.add(GL_R1UI_T2F_V3F_SUN)
defines.add(GL_R1UI_V3F_SUN)
defines.add(GL_REPLACEMENT_CODE_ARRAY_POINTER_SUN)
defines.add(GL_REPLACEMENT_CODE_ARRAY_STRIDE_SUN)
defines.add(GL_REPLACEMENT_CODE_ARRAY_SUN)
defines.add(GL_REPLACEMENT_CODE_ARRAY_TYPE_SUN)
defines.add(GL_REPLACEMENT_CODE_SUN)
defines.add(GL_REPLACE_MIDDLE_SUN)
defines.add(GL_REPLACE_OLDEST_SUN)
defines.add(GL_RESTART_SUN)
defines.add(GL_TRIANGLE_LIST_SUN)

# GL_VIV_shader_binary

GL_SHADER_BINARY_VIV = Enumerant('GL_SHADER_BINARY_VIV', 0x8fc4, 'GL_VIV_shader_binary')

defines.add(GL_SHADER_BINARY_VIV)

# GL_WIN_phong_shading

GL_PHONG_HINT_WIN = Enumerant('GL_PHONG_HINT_WIN', 0x80eb, 'GL_WIN_phong_shading')
GL_PHONG_WIN = Enumerant('GL_PHONG_WIN', 0x80ea, 'GL_WIN_phong_shading')

defines.add(GL_PHONG_HINT_WIN)
defines.add(GL_PHONG_WIN)

# GL_WIN_specular_fog

GL_FOG_SPECULAR_TEXTURE_WIN = Enumerant('GL_FOG_SPECULAR_TEXTURE_WIN', 0x80ec, 'GL_WIN_specular_fog')

defines.add(GL_FOG_SPECULAR_TEXTURE_WIN)

# GL_VERSION_1_0

glAccum = Function('glAccum')
glAccum.ret = Return('void')
glAccum.add( Input( 'op','GLenum' ))
glAccum.add( Input( 'value','GLfloat' ))
glAccum.version = '1.0'
glAccum.category = 'GL_VERSION_1_0'
glAccum.trace = True
glAccum.play = True
gl.add(glAccum)

glAlphaFunc = Function('glAlphaFunc')
glAlphaFunc.ret = Return('void')
glAlphaFunc.add( Input( 'func','GLenum' ))
glAlphaFunc.add( Input( 'ref','GLclampf' ))
glAlphaFunc.version = '1.0'
glAlphaFunc.category = 'GL_VERSION_1_0'
glAlphaFunc.esVersions = [1.0, 1.1]
glAlphaFunc.trace = True
glAlphaFunc.play = True
gl.add(glAlphaFunc)

glBegin = Function('glBegin')
glBegin.ret = Return('void')
glBegin.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glBegin.version = '1.0'
glBegin.category = 'GL_VERSION_1_0'
glBegin.trace = True
glBegin.play = True
gl.add(glBegin)

glBitmap = Function('glBitmap')
glBitmap.ret = Return('void')
glBitmap.add( Input( 'width','GLsizei' ))
glBitmap.add( Input( 'height','GLsizei' ))
glBitmap.add( Input( 'xorig','GLfloat' ))
glBitmap.add( Input( 'yorig','GLfloat' ))
glBitmap.add( Input( 'xmove','GLfloat' ))
glBitmap.add( Input( 'ymove','GLfloat' ))
glBitmap.add( Input( 'bitmap','const GLubyte *' ,size = 'helperGLPixelImageSize(width, height, 0, GL_COLOR_INDEX, GL_BITMAP, 0, GL_BITMAP)' ))
glBitmap.version = '1.0'
glBitmap.category = 'GL_VERSION_1_0'
glBitmap.trace = True
glBitmap.play = True
gl.add(glBitmap)

glBlendFunc = Function('glBlendFunc')
glBlendFunc.ret = Return('void')
glBlendFunc.add( Input( 'sfactor','GLenum' ))
glBlendFunc.add( Input( 'dfactor','GLenum' ))
glBlendFunc.version = '1.0'
glBlendFunc.category = 'GL_VERSION_1_0'
glBlendFunc.esVersions = [1.0, 1.1, 2.0]
glBlendFunc.trace = True
glBlendFunc.play = True
gl.add(glBlendFunc)

glCallList = Function('glCallList')
glCallList.ret = Return('void')
glCallList.add( Input( 'list','GLuint' ))
glCallList.version = '1.0'
glCallList.category = 'GL_VERSION_1_0'
glCallList.trace = True
glCallList.play = True
gl.add(glCallList)

glCallLists = Function('glCallLists')
glCallLists.ret = Return('void')
glCallLists.add( Input( 'n','GLsizei' ))
glCallLists.add( Input( 'type','GLenum' ))
glCallLists.add( Input( 'lists','const GLvoid *' ,size = 'helperGLCallListsSize(n, type)' ,cast = 'const GLubyte *' ))
glCallLists.version = '1.0'
glCallLists.category = 'GL_VERSION_1_0'
glCallLists.trace = True
glCallLists.play = True
gl.add(glCallLists)

glClear = Function('glClear')
glClear.ret = Return('void')
glClear.add( Input( 'mask','GLbitfield' ,regalLog = 'GLclearToString(mask)' ))
glClear.version = '1.0'
glClear.category = 'GL_VERSION_1_0'
glClear.esVersions = [1.0, 1.1, 2.0]
glClear.trace = True
glClear.play = True
gl.add(glClear)

glClearAccum = Function('glClearAccum')
glClearAccum.ret = Return('void')
glClearAccum.add( Input( 'red','GLfloat' ))
glClearAccum.add( Input( 'green','GLfloat' ))
glClearAccum.add( Input( 'blue','GLfloat' ))
glClearAccum.add( Input( 'alpha','GLfloat' ))
glClearAccum.version = '1.0'
glClearAccum.category = 'GL_VERSION_1_0'
glClearAccum.trace = True
glClearAccum.play = True
gl.add(glClearAccum)

glClearColor = Function('glClearColor')
glClearColor.ret = Return('void')
glClearColor.add( Input( 'red','GLclampf' ))
glClearColor.add( Input( 'green','GLclampf' ))
glClearColor.add( Input( 'blue','GLclampf' ))
glClearColor.add( Input( 'alpha','GLclampf' ))
glClearColor.version = '1.0'
glClearColor.category = 'GL_VERSION_1_0'
glClearColor.esVersions = [1.0, 1.1, 2.0]
glClearColor.trace = True
glClearColor.play = True
gl.add(glClearColor)

glClearDepth = Function('glClearDepth')
glClearDepth.ret = Return('void')
glClearDepth.add( Input( 'depth','GLclampd' ))
glClearDepth.version = '1.0'
glClearDepth.category = 'GL_VERSION_1_0'
glClearDepth.regalRemap = {'ES2.0': 'glClearDepthf((GLclampf)depth)'}
glClearDepth.trace = True
glClearDepth.play = True
gl.add(glClearDepth)

glClearIndex = Function('glClearIndex')
glClearIndex.ret = Return('void')
glClearIndex.add( Input( 'c','GLfloat' ))
glClearIndex.version = '1.0'
glClearIndex.category = 'GL_VERSION_1_0'
glClearIndex.trace = True
glClearIndex.play = True
gl.add(glClearIndex)

glClearStencil = Function('glClearStencil')
glClearStencil.ret = Return('void')
glClearStencil.add( Input( 's','GLint' ))
glClearStencil.version = '1.0'
glClearStencil.category = 'GL_VERSION_1_0'
glClearStencil.esVersions = [1.0, 1.1, 2.0]
glClearStencil.trace = True
glClearStencil.play = True
gl.add(glClearStencil)

glClipPlane = Function('glClipPlane')
glClipPlane.ret = Return('void')
glClipPlane.add( Input( 'plane','GLenum' ))
glClipPlane.add( Input( 'equation','const GLdouble *' ,size = 4 ))
glClipPlane.version = '1.0'
glClipPlane.category = 'GL_VERSION_1_0'
glClipPlane.trace = True
glClipPlane.play = True
gl.add(glClipPlane)

glColor3b = Function('glColor3b')
glColor3b.ret = Return('void')
glColor3b.add( Input( 'red','GLbyte' ))
glColor3b.add( Input( 'green','GLbyte' ))
glColor3b.add( Input( 'blue','GLbyte' ))
glColor3b.version = '1.0'
glColor3b.category = 'GL_VERSION_1_0'
glColor3b.trace = True
glColor3b.play = True
gl.add(glColor3b)

glColor3bv = Function('glColor3bv')
glColor3bv.ret = Return('void')
glColor3bv.add( Input( 'v','const GLbyte *' ,size = 3 ))
glColor3bv.version = '1.0'
glColor3bv.category = 'GL_VERSION_1_0'
glColor3bv.trace = True
glColor3bv.play = True
gl.add(glColor3bv)

glColor3d = Function('glColor3d')
glColor3d.ret = Return('void')
glColor3d.add( Input( 'red','GLdouble' ))
glColor3d.add( Input( 'green','GLdouble' ))
glColor3d.add( Input( 'blue','GLdouble' ))
glColor3d.version = '1.0'
glColor3d.category = 'GL_VERSION_1_0'
glColor3d.trace = True
glColor3d.play = True
gl.add(glColor3d)

glColor3dv = Function('glColor3dv')
glColor3dv.ret = Return('void')
glColor3dv.add( Input( 'v','const GLdouble *' ,size = 3 ))
glColor3dv.version = '1.0'
glColor3dv.category = 'GL_VERSION_1_0'
glColor3dv.trace = True
glColor3dv.play = True
gl.add(glColor3dv)

glColor3f = Function('glColor3f')
glColor3f.ret = Return('void')
glColor3f.add( Input( 'red','GLfloat' ))
glColor3f.add( Input( 'green','GLfloat' ))
glColor3f.add( Input( 'blue','GLfloat' ))
glColor3f.version = '1.0'
glColor3f.category = 'GL_VERSION_1_0'
glColor3f.trace = True
glColor3f.play = True
gl.add(glColor3f)

glColor3fv = Function('glColor3fv')
glColor3fv.ret = Return('void')
glColor3fv.add( Input( 'v','const GLfloat *' ,size = 3 ))
glColor3fv.version = '1.0'
glColor3fv.category = 'GL_VERSION_1_0'
glColor3fv.trace = True
glColor3fv.play = True
gl.add(glColor3fv)

glColor3i = Function('glColor3i')
glColor3i.ret = Return('void')
glColor3i.add( Input( 'red','GLint' ))
glColor3i.add( Input( 'green','GLint' ))
glColor3i.add( Input( 'blue','GLint' ))
glColor3i.version = '1.0'
glColor3i.category = 'GL_VERSION_1_0'
glColor3i.trace = True
glColor3i.play = True
gl.add(glColor3i)

glColor3iv = Function('glColor3iv')
glColor3iv.ret = Return('void')
glColor3iv.add( Input( 'v','const GLint *' ,size = 3 ))
glColor3iv.version = '1.0'
glColor3iv.category = 'GL_VERSION_1_0'
glColor3iv.trace = True
glColor3iv.play = True
gl.add(glColor3iv)

glColor3s = Function('glColor3s')
glColor3s.ret = Return('void')
glColor3s.add( Input( 'red','GLshort' ))
glColor3s.add( Input( 'green','GLshort' ))
glColor3s.add( Input( 'blue','GLshort' ))
glColor3s.version = '1.0'
glColor3s.category = 'GL_VERSION_1_0'
glColor3s.trace = True
glColor3s.play = True
gl.add(glColor3s)

glColor3sv = Function('glColor3sv')
glColor3sv.ret = Return('void')
glColor3sv.add( Input( 'v','const GLshort *' ,size = 3 ))
glColor3sv.version = '1.0'
glColor3sv.category = 'GL_VERSION_1_0'
glColor3sv.trace = True
glColor3sv.play = True
gl.add(glColor3sv)

glColor3ub = Function('glColor3ub')
glColor3ub.ret = Return('void')
glColor3ub.add( Input( 'red','GLubyte' ))
glColor3ub.add( Input( 'green','GLubyte' ))
glColor3ub.add( Input( 'blue','GLubyte' ))
glColor3ub.version = '1.0'
glColor3ub.category = 'GL_VERSION_1_0'
glColor3ub.trace = True
glColor3ub.play = True
gl.add(glColor3ub)

glColor3ubv = Function('glColor3ubv')
glColor3ubv.ret = Return('void')
glColor3ubv.add( Input( 'v','const GLubyte *' ,size = 3 ))
glColor3ubv.version = '1.0'
glColor3ubv.category = 'GL_VERSION_1_0'
glColor3ubv.trace = True
glColor3ubv.play = True
gl.add(glColor3ubv)

glColor3ui = Function('glColor3ui')
glColor3ui.ret = Return('void')
glColor3ui.add( Input( 'red','GLuint' ))
glColor3ui.add( Input( 'green','GLuint' ))
glColor3ui.add( Input( 'blue','GLuint' ))
glColor3ui.version = '1.0'
glColor3ui.category = 'GL_VERSION_1_0'
glColor3ui.trace = True
glColor3ui.play = True
gl.add(glColor3ui)

glColor3uiv = Function('glColor3uiv')
glColor3uiv.ret = Return('void')
glColor3uiv.add( Input( 'v','const GLuint *' ,size = 3 ))
glColor3uiv.version = '1.0'
glColor3uiv.category = 'GL_VERSION_1_0'
glColor3uiv.trace = True
glColor3uiv.play = True
gl.add(glColor3uiv)

glColor3us = Function('glColor3us')
glColor3us.ret = Return('void')
glColor3us.add( Input( 'red','GLushort' ))
glColor3us.add( Input( 'green','GLushort' ))
glColor3us.add( Input( 'blue','GLushort' ))
glColor3us.version = '1.0'
glColor3us.category = 'GL_VERSION_1_0'
glColor3us.trace = True
glColor3us.play = True
gl.add(glColor3us)

glColor3usv = Function('glColor3usv')
glColor3usv.ret = Return('void')
glColor3usv.add( Input( 'v','const GLushort *' ,size = 3 ))
glColor3usv.version = '1.0'
glColor3usv.category = 'GL_VERSION_1_0'
glColor3usv.trace = True
glColor3usv.play = True
gl.add(glColor3usv)

glColor4b = Function('glColor4b')
glColor4b.ret = Return('void')
glColor4b.add( Input( 'red','GLbyte' ))
glColor4b.add( Input( 'green','GLbyte' ))
glColor4b.add( Input( 'blue','GLbyte' ))
glColor4b.add( Input( 'alpha','GLbyte' ))
glColor4b.version = '1.0'
glColor4b.category = 'GL_VERSION_1_0'
glColor4b.trace = True
glColor4b.play = True
gl.add(glColor4b)

glColor4bv = Function('glColor4bv')
glColor4bv.ret = Return('void')
glColor4bv.add( Input( 'v','const GLbyte *' ,size = 4 ))
glColor4bv.version = '1.0'
glColor4bv.category = 'GL_VERSION_1_0'
glColor4bv.trace = True
glColor4bv.play = True
gl.add(glColor4bv)

glColor4d = Function('glColor4d')
glColor4d.ret = Return('void')
glColor4d.add( Input( 'red','GLdouble' ))
glColor4d.add( Input( 'green','GLdouble' ))
glColor4d.add( Input( 'blue','GLdouble' ))
glColor4d.add( Input( 'alpha','GLdouble' ))
glColor4d.version = '1.0'
glColor4d.category = 'GL_VERSION_1_0'
glColor4d.trace = True
glColor4d.play = True
gl.add(glColor4d)

glColor4dv = Function('glColor4dv')
glColor4dv.ret = Return('void')
glColor4dv.add( Input( 'v','const GLdouble *' ,size = 4 ))
glColor4dv.version = '1.0'
glColor4dv.category = 'GL_VERSION_1_0'
glColor4dv.trace = True
glColor4dv.play = True
gl.add(glColor4dv)

glColor4f = Function('glColor4f')
glColor4f.ret = Return('void')
glColor4f.add( Input( 'red','GLfloat' ))
glColor4f.add( Input( 'green','GLfloat' ))
glColor4f.add( Input( 'blue','GLfloat' ))
glColor4f.add( Input( 'alpha','GLfloat' ))
glColor4f.version = '1.0'
glColor4f.category = 'GL_VERSION_1_0'
glColor4f.esVersions = [1.0, 1.1]
glColor4f.trace = True
glColor4f.play = True
gl.add(glColor4f)

glColor4fv = Function('glColor4fv')
glColor4fv.ret = Return('void')
glColor4fv.add( Input( 'v','const GLfloat *' ,size = 4 ))
glColor4fv.version = '1.0'
glColor4fv.category = 'GL_VERSION_1_0'
glColor4fv.trace = True
glColor4fv.play = True
gl.add(glColor4fv)

glColor4i = Function('glColor4i')
glColor4i.ret = Return('void')
glColor4i.add( Input( 'red','GLint' ))
glColor4i.add( Input( 'green','GLint' ))
glColor4i.add( Input( 'blue','GLint' ))
glColor4i.add( Input( 'alpha','GLint' ))
glColor4i.version = '1.0'
glColor4i.category = 'GL_VERSION_1_0'
glColor4i.trace = True
glColor4i.play = True
gl.add(glColor4i)

glColor4iv = Function('glColor4iv')
glColor4iv.ret = Return('void')
glColor4iv.add( Input( 'v','const GLint *' ,size = 4 ))
glColor4iv.version = '1.0'
glColor4iv.category = 'GL_VERSION_1_0'
glColor4iv.trace = True
glColor4iv.play = True
gl.add(glColor4iv)

glColor4s = Function('glColor4s')
glColor4s.ret = Return('void')
glColor4s.add( Input( 'red','GLshort' ))
glColor4s.add( Input( 'green','GLshort' ))
glColor4s.add( Input( 'blue','GLshort' ))
glColor4s.add( Input( 'alpha','GLshort' ))
glColor4s.version = '1.0'
glColor4s.category = 'GL_VERSION_1_0'
glColor4s.trace = True
glColor4s.play = True
gl.add(glColor4s)

glColor4sv = Function('glColor4sv')
glColor4sv.ret = Return('void')
glColor4sv.add( Input( 'v','const GLshort *' ,size = 4 ))
glColor4sv.version = '1.0'
glColor4sv.category = 'GL_VERSION_1_0'
glColor4sv.trace = True
glColor4sv.play = True
gl.add(glColor4sv)

glColor4ub = Function('glColor4ub')
glColor4ub.ret = Return('void')
glColor4ub.add( Input( 'red','GLubyte' ))
glColor4ub.add( Input( 'green','GLubyte' ))
glColor4ub.add( Input( 'blue','GLubyte' ))
glColor4ub.add( Input( 'alpha','GLubyte' ))
glColor4ub.version = '1.0'
glColor4ub.category = 'GL_VERSION_1_0'
glColor4ub.esVersions = [1.1]
glColor4ub.trace = True
glColor4ub.play = True
gl.add(glColor4ub)

glColor4ubv = Function('glColor4ubv')
glColor4ubv.ret = Return('void')
glColor4ubv.add( Input( 'v','const GLubyte *' ,size = 4 ))
glColor4ubv.version = '1.0'
glColor4ubv.category = 'GL_VERSION_1_0'
glColor4ubv.trace = True
glColor4ubv.play = True
gl.add(glColor4ubv)

glColor4ui = Function('glColor4ui')
glColor4ui.ret = Return('void')
glColor4ui.add( Input( 'red','GLuint' ))
glColor4ui.add( Input( 'green','GLuint' ))
glColor4ui.add( Input( 'blue','GLuint' ))
glColor4ui.add( Input( 'alpha','GLuint' ))
glColor4ui.version = '1.0'
glColor4ui.category = 'GL_VERSION_1_0'
glColor4ui.trace = True
glColor4ui.play = True
gl.add(glColor4ui)

glColor4uiv = Function('glColor4uiv')
glColor4uiv.ret = Return('void')
glColor4uiv.add( Input( 'v','const GLuint *' ,size = 4 ))
glColor4uiv.version = '1.0'
glColor4uiv.category = 'GL_VERSION_1_0'
glColor4uiv.trace = True
glColor4uiv.play = True
gl.add(glColor4uiv)

glColor4us = Function('glColor4us')
glColor4us.ret = Return('void')
glColor4us.add( Input( 'red','GLushort' ))
glColor4us.add( Input( 'green','GLushort' ))
glColor4us.add( Input( 'blue','GLushort' ))
glColor4us.add( Input( 'alpha','GLushort' ))
glColor4us.version = '1.0'
glColor4us.category = 'GL_VERSION_1_0'
glColor4us.trace = True
glColor4us.play = True
gl.add(glColor4us)

glColor4usv = Function('glColor4usv')
glColor4usv.ret = Return('void')
glColor4usv.add( Input( 'v','const GLushort *' ,size = 4 ))
glColor4usv.version = '1.0'
glColor4usv.category = 'GL_VERSION_1_0'
glColor4usv.trace = True
glColor4usv.play = True
gl.add(glColor4usv)

glColorMask = Function('glColorMask')
glColorMask.ret = Return('void')
glColorMask.add( Input( 'red','GLboolean' ))
glColorMask.add( Input( 'green','GLboolean' ))
glColorMask.add( Input( 'blue','GLboolean' ))
glColorMask.add( Input( 'alpha','GLboolean' ))
glColorMask.version = '1.0'
glColorMask.category = 'GL_VERSION_1_0'
glColorMask.esVersions = [1.0, 1.1, 2.0]
glColorMask.trace = True
glColorMask.play = True
gl.add(glColorMask)

glColorMaterial = Function('glColorMaterial')
glColorMaterial.ret = Return('void')
glColorMaterial.add( Input( 'face','GLenum' ))
glColorMaterial.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glColorMaterial.version = '1.0'
glColorMaterial.category = 'GL_VERSION_1_0'
glColorMaterial.trace = True
glColorMaterial.play = True
gl.add(glColorMaterial)

glCopyPixels = Function('glCopyPixels')
glCopyPixels.ret = Return('void')
glCopyPixels.add( Input( 'x','GLint' ))
glCopyPixels.add( Input( 'y','GLint' ))
glCopyPixels.add( Input( 'width','GLsizei' ))
glCopyPixels.add( Input( 'height','GLsizei' ))
glCopyPixels.add( Input( 'type','GLenum' ))
glCopyPixels.version = '1.0'
glCopyPixels.category = 'GL_VERSION_1_0'
glCopyPixels.trace = True
glCopyPixels.play = True
gl.add(glCopyPixels)

glCullFace = Function('glCullFace')
glCullFace.ret = Return('void')
glCullFace.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glCullFace.version = '1.0'
glCullFace.category = 'GL_VERSION_1_0'
glCullFace.esVersions = [1.0, 1.1, 2.0]
glCullFace.trace = True
glCullFace.play = True
gl.add(glCullFace)

glDeleteLists = Function('glDeleteLists')
glDeleteLists.ret = Return('void')
glDeleteLists.add( Input( 'list','GLuint' ))
glDeleteLists.add( Input( 'range','GLsizei' ))
glDeleteLists.version = '1.0'
glDeleteLists.category = 'GL_VERSION_1_0'
glDeleteLists.trace = True
glDeleteLists.play = True
gl.add(glDeleteLists)

glDepthFunc = Function('glDepthFunc')
glDepthFunc.ret = Return('void')
glDepthFunc.add( Input( 'func','GLenum' ))
glDepthFunc.version = '1.0'
glDepthFunc.category = 'GL_VERSION_1_0'
glDepthFunc.esVersions = [1.0, 1.1, 2.0]
glDepthFunc.trace = True
glDepthFunc.play = True
gl.add(glDepthFunc)

glDepthMask = Function('glDepthMask')
glDepthMask.ret = Return('void')
glDepthMask.add( Input( 'flag','GLboolean' ))
glDepthMask.version = '1.0'
glDepthMask.category = 'GL_VERSION_1_0'
glDepthMask.esVersions = [1.0, 1.1, 2.0]
glDepthMask.trace = True
glDepthMask.play = True
gl.add(glDepthMask)

glDepthRange = Function('glDepthRange')
glDepthRange.ret = Return('void')
glDepthRange.add( Input( 'zNear','GLclampd' ))
glDepthRange.add( Input( 'zFar','GLclampd' ))
glDepthRange.version = '1.0'
glDepthRange.category = 'GL_VERSION_1_0'
glDepthRange.regalRemap = {'ES2.0': 'glDepthRangef((GLclampf)zNear,(GLclampf)zFar)'}
glDepthRange.trace = True
glDepthRange.play = True
gl.add(glDepthRange)

glDisable = Function('glDisable')
glDisable.ret = Return('void')
glDisable.add( Input( 'cap','GLenum' ))
glDisable.version = '1.0'
glDisable.category = 'GL_VERSION_1_0'
glDisable.esVersions = [1.0, 1.1, 2.0]
glDisable.trace = True
glDisable.play = True
gl.add(glDisable)

glDrawBuffer = Function('glDrawBuffer')
glDrawBuffer.ret = Return('void')
glDrawBuffer.add( Input( 'mode','GLenum' ))
glDrawBuffer.version = '1.0'
glDrawBuffer.category = 'GL_VERSION_1_0'
glDrawBuffer.trace = True
glDrawBuffer.play = True
gl.add(glDrawBuffer)

glDrawPixels = Function('glDrawPixels')
glDrawPixels.ret = Return('void')
glDrawPixels.add( Input( 'width','GLsizei' ))
glDrawPixels.add( Input( 'height','GLsizei' ))
glDrawPixels.add( Input( 'format','GLenum' ))
glDrawPixels.add( Input( 'type','GLenum' ))
glDrawPixels.add( Input( 'pixels','const GLvoid *' ,size = 'helperGLPixelImageSize(width, height, 0, format, type, 0, 0)' ,cast = 'const GLubyte *' ))
glDrawPixels.version = '1.0'
glDrawPixels.category = 'GL_VERSION_1_0'
glDrawPixels.trace = True
glDrawPixels.play = True
gl.add(glDrawPixels)

glEdgeFlag = Function('glEdgeFlag')
glEdgeFlag.ret = Return('void')
glEdgeFlag.add( Input( 'flag','GLboolean' ))
glEdgeFlag.version = '1.0'
glEdgeFlag.category = 'GL_VERSION_1_0'
glEdgeFlag.trace = True
glEdgeFlag.play = True
gl.add(glEdgeFlag)

glEdgeFlagv = Function('glEdgeFlagv')
glEdgeFlagv.ret = Return('void')
glEdgeFlagv.add( Input( 'flag','const GLboolean *' ,size = 1 ))
glEdgeFlagv.version = '1.0'
glEdgeFlagv.category = 'GL_VERSION_1_0'
glEdgeFlagv.trace = True
glEdgeFlagv.play = True
gl.add(glEdgeFlagv)

glEnable = Function('glEnable')
glEnable.ret = Return('void')
glEnable.add( Input( 'cap','GLenum' ))
glEnable.version = '1.0'
glEnable.category = 'GL_VERSION_1_0'
glEnable.esVersions = [1.0, 1.1, 2.0]
glEnable.trace = True
glEnable.play = True
gl.add(glEnable)

glEnd = Function('glEnd')
glEnd.ret = Return('void')
glEnd.version = '1.0'
glEnd.category = 'GL_VERSION_1_0'
glEnd.trace = True
glEnd.play = True
gl.add(glEnd)

glEndList = Function('glEndList')
glEndList.ret = Return('void')
glEndList.version = '1.0'
glEndList.category = 'GL_VERSION_1_0'
glEndList.trace = True
glEndList.play = True
gl.add(glEndList)

glEvalCoord1d = Function('glEvalCoord1d')
glEvalCoord1d.ret = Return('void')
glEvalCoord1d.add( Input( 'u','GLdouble' ))
glEvalCoord1d.version = '1.0'
glEvalCoord1d.category = 'GL_VERSION_1_0'
glEvalCoord1d.trace = True
glEvalCoord1d.play = True
gl.add(glEvalCoord1d)

glEvalCoord1dv = Function('glEvalCoord1dv')
glEvalCoord1dv.ret = Return('void')
glEvalCoord1dv.add( Input( 'u','const GLdouble *' ,size = 1 ))
glEvalCoord1dv.version = '1.0'
glEvalCoord1dv.category = 'GL_VERSION_1_0'
glEvalCoord1dv.trace = True
glEvalCoord1dv.play = True
gl.add(glEvalCoord1dv)

glEvalCoord1f = Function('glEvalCoord1f')
glEvalCoord1f.ret = Return('void')
glEvalCoord1f.add( Input( 'u','GLfloat' ))
glEvalCoord1f.version = '1.0'
glEvalCoord1f.category = 'GL_VERSION_1_0'
glEvalCoord1f.trace = True
glEvalCoord1f.play = True
gl.add(glEvalCoord1f)

glEvalCoord1fv = Function('glEvalCoord1fv')
glEvalCoord1fv.ret = Return('void')
glEvalCoord1fv.add( Input( 'u','const GLfloat *' ,size = 1 ))
glEvalCoord1fv.version = '1.0'
glEvalCoord1fv.category = 'GL_VERSION_1_0'
glEvalCoord1fv.trace = True
glEvalCoord1fv.play = True
gl.add(glEvalCoord1fv)

glEvalCoord2d = Function('glEvalCoord2d')
glEvalCoord2d.ret = Return('void')
glEvalCoord2d.add( Input( 'u','GLdouble' ))
glEvalCoord2d.add( Input( 'v','GLdouble' ))
glEvalCoord2d.version = '1.0'
glEvalCoord2d.category = 'GL_VERSION_1_0'
glEvalCoord2d.trace = True
glEvalCoord2d.play = True
gl.add(glEvalCoord2d)

glEvalCoord2dv = Function('glEvalCoord2dv')
glEvalCoord2dv.ret = Return('void')
glEvalCoord2dv.add( Input( 'u','const GLdouble *' ,size = 2 ))
glEvalCoord2dv.version = '1.0'
glEvalCoord2dv.category = 'GL_VERSION_1_0'
glEvalCoord2dv.trace = True
glEvalCoord2dv.play = True
gl.add(glEvalCoord2dv)

glEvalCoord2f = Function('glEvalCoord2f')
glEvalCoord2f.ret = Return('void')
glEvalCoord2f.add( Input( 'u','GLfloat' ))
glEvalCoord2f.add( Input( 'v','GLfloat' ))
glEvalCoord2f.version = '1.0'
glEvalCoord2f.category = 'GL_VERSION_1_0'
glEvalCoord2f.trace = True
glEvalCoord2f.play = True
gl.add(glEvalCoord2f)

glEvalCoord2fv = Function('glEvalCoord2fv')
glEvalCoord2fv.ret = Return('void')
glEvalCoord2fv.add( Input( 'u','const GLfloat *' ,size = 2 ))
glEvalCoord2fv.version = '1.0'
glEvalCoord2fv.category = 'GL_VERSION_1_0'
glEvalCoord2fv.trace = True
glEvalCoord2fv.play = True
gl.add(glEvalCoord2fv)

glEvalMesh1 = Function('glEvalMesh1')
glEvalMesh1.ret = Return('void')
glEvalMesh1.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glEvalMesh1.add( Input( 'i1','GLint' ))
glEvalMesh1.add( Input( 'i2','GLint' ))
glEvalMesh1.version = '1.0'
glEvalMesh1.category = 'GL_VERSION_1_0'
glEvalMesh1.trace = True
glEvalMesh1.play = True
gl.add(glEvalMesh1)

glEvalMesh2 = Function('glEvalMesh2')
glEvalMesh2.ret = Return('void')
glEvalMesh2.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glEvalMesh2.add( Input( 'i1','GLint' ))
glEvalMesh2.add( Input( 'i2','GLint' ))
glEvalMesh2.add( Input( 'j1','GLint' ))
glEvalMesh2.add( Input( 'j2','GLint' ))
glEvalMesh2.version = '1.0'
glEvalMesh2.category = 'GL_VERSION_1_0'
glEvalMesh2.trace = True
glEvalMesh2.play = True
gl.add(glEvalMesh2)

glEvalPoint1 = Function('glEvalPoint1')
glEvalPoint1.ret = Return('void')
glEvalPoint1.add( Input( 'i','GLint' ))
glEvalPoint1.version = '1.0'
glEvalPoint1.category = 'GL_VERSION_1_0'
glEvalPoint1.trace = True
glEvalPoint1.play = True
gl.add(glEvalPoint1)

glEvalPoint2 = Function('glEvalPoint2')
glEvalPoint2.ret = Return('void')
glEvalPoint2.add( Input( 'i','GLint' ))
glEvalPoint2.add( Input( 'j','GLint' ))
glEvalPoint2.version = '1.0'
glEvalPoint2.category = 'GL_VERSION_1_0'
glEvalPoint2.trace = True
glEvalPoint2.play = True
gl.add(glEvalPoint2)

glFeedbackBuffer = Function('glFeedbackBuffer')
glFeedbackBuffer.ret = Return('void')
glFeedbackBuffer.add( Input( 'size','GLsizei' ))
glFeedbackBuffer.add( Input( 'type','GLenum' ))
glFeedbackBuffer.add( Output( 'buffer','GLfloat *' ))
glFeedbackBuffer.version = '1.0'
glFeedbackBuffer.category = 'GL_VERSION_1_0'
glFeedbackBuffer.trace = True
glFeedbackBuffer.play = True
gl.add(glFeedbackBuffer)

glFinish = Function('glFinish')
glFinish.ret = Return('void')
glFinish.version = '1.0'
glFinish.category = 'GL_VERSION_1_0'
glFinish.esVersions = [1.0, 1.1, 2.0]
glFinish.trace = True
glFinish.play = True
gl.add(glFinish)

glFlush = Function('glFlush')
glFlush.ret = Return('void')
glFlush.version = '1.0'
glFlush.category = 'GL_VERSION_1_0'
glFlush.esVersions = [1.0, 1.1, 2.0]
glFlush.trace = True
glFlush.play = True
gl.add(glFlush)

glFogf = Function('glFogf')
glFogf.ret = Return('void')
glFogf.add( Input( 'pname','GLenum' ))
glFogf.add( Input( 'param','GLfloat' ))
glFogf.version = '1.0'
glFogf.category = 'GL_VERSION_1_0'
glFogf.esVersions = [1.0, 1.1]
glFogf.trace = True
glFogf.play = True
gl.add(glFogf)

glFogfv = Function('glFogfv')
glFogfv.ret = Return('void')
glFogfv.add( Input( 'pname','GLenum' ))
glFogfv.add( Input( 'params','const GLfloat *' ,size = 'helperGLFogvSize(pname)' ))
glFogfv.version = '1.0'
glFogfv.category = 'GL_VERSION_1_0'
glFogfv.esVersions = [1.0, 1.1]
glFogfv.trace = True
glFogfv.play = True
gl.add(glFogfv)

glFogi = Function('glFogi')
glFogi.ret = Return('void')
glFogi.add( Input( 'pname','GLenum' ))
glFogi.add( Input( 'param','GLint' ))
glFogi.version = '1.0'
glFogi.category = 'GL_VERSION_1_0'
glFogi.trace = True
glFogi.play = True
gl.add(glFogi)

glFogiv = Function('glFogiv')
glFogiv.ret = Return('void')
glFogiv.add( Input( 'pname','GLenum' ))
glFogiv.add( Input( 'params','const GLint *' ,size = 'helperGLFogvSize(pname)' ))
glFogiv.version = '1.0'
glFogiv.category = 'GL_VERSION_1_0'
glFogiv.trace = True
glFogiv.play = True
gl.add(glFogiv)

glFrontFace = Function('glFrontFace')
glFrontFace.ret = Return('void')
glFrontFace.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glFrontFace.version = '1.0'
glFrontFace.category = 'GL_VERSION_1_0'
glFrontFace.esVersions = [1.0, 1.1, 2.0]
glFrontFace.trace = True
glFrontFace.play = True
gl.add(glFrontFace)

glFrustum = Function('glFrustum')
glFrustum.ret = Return('void')
glFrustum.add( Input( 'left','GLdouble' ))
glFrustum.add( Input( 'right','GLdouble' ))
glFrustum.add( Input( 'bottom','GLdouble' ))
glFrustum.add( Input( 'top','GLdouble' ))
glFrustum.add( Input( 'zNear','GLdouble' ))
glFrustum.add( Input( 'zFar','GLdouble' ))
glFrustum.version = '1.0'
glFrustum.category = 'GL_VERSION_1_0'
glFrustum.trace = True
glFrustum.play = True
gl.add(glFrustum)

glGenLists = Function('glGenLists')
glGenLists.ret = Return('GLuint')
glGenLists.add( Input( 'range','GLsizei' ))
glGenLists.version = '1.0'
glGenLists.category = 'GL_VERSION_1_0'
glGenLists.trace = True
glGenLists.play = True
gl.add(glGenLists)

glGetBooleanv = Function('glGetBooleanv')
glGetBooleanv.ret = Return('void')
glGetBooleanv.add( Input( 'pname','GLenum' ))
glGetBooleanv.add( Output( 'params','GLboolean *' ))
glGetBooleanv.version = '1.0'
glGetBooleanv.category = 'GL_VERSION_1_0'
glGetBooleanv.esVersions = [1.1, 2.0]
glGetBooleanv.trace = True
glGetBooleanv.play = False
gl.add(glGetBooleanv)

glGetClipPlane = Function('glGetClipPlane')
glGetClipPlane.ret = Return('void')
glGetClipPlane.add( Input( 'plane','GLenum' ))
glGetClipPlane.add( Output( 'equation','GLdouble *' ,size = 4 ))
glGetClipPlane.version = '1.0'
glGetClipPlane.category = 'GL_VERSION_1_0'
glGetClipPlane.trace = True
glGetClipPlane.play = True
gl.add(glGetClipPlane)

glGetDoublev = Function('glGetDoublev')
glGetDoublev.ret = Return('void')
glGetDoublev.add( Input( 'pname','GLenum' ))
glGetDoublev.add( Output( 'params','GLdouble *' ))
glGetDoublev.version = '1.0'
glGetDoublev.category = 'GL_VERSION_1_0'
glGetDoublev.trace = True
glGetDoublev.play = False
gl.add(glGetDoublev)

glGetError = Function('glGetError')
glGetError.ret = Return('GLenum')
glGetError.version = '1.0'
glGetError.category = 'GL_VERSION_1_0'
glGetError.esVersions = [1.0, 1.1, 2.0]
glGetError.trace = True
glGetError.play = True
gl.add(glGetError)

glGetFloatv = Function('glGetFloatv')
glGetFloatv.ret = Return('void')
glGetFloatv.add( Input( 'pname','GLenum' ))
glGetFloatv.add( Output( 'params','GLfloat *' ,size = 'helperGLGetSize(pname)' ))
glGetFloatv.version = '1.0'
glGetFloatv.category = 'GL_VERSION_1_0'
glGetFloatv.esVersions = [1.1, 2.0]
glGetFloatv.trace = True
glGetFloatv.play = False
gl.add(glGetFloatv)

glGetIntegerv = Function('glGetIntegerv')
glGetIntegerv.ret = Return('void')
glGetIntegerv.add( Input( 'pname','GLenum' ))
glGetIntegerv.add( Output( 'params','GLint *' ,size = 'helperGLGetSize(pname)' ))
glGetIntegerv.version = '1.0'
glGetIntegerv.category = 'GL_VERSION_1_0'
glGetIntegerv.esVersions = [1.0, 1.1, 2.0]
glGetIntegerv.trace = True
glGetIntegerv.play = False
gl.add(glGetIntegerv)

glGetLightfv = Function('glGetLightfv')
glGetLightfv.ret = Return('void')
glGetLightfv.add( Input( 'light','GLenum' ))
glGetLightfv.add( Input( 'pname','GLenum' ))
glGetLightfv.add( Output( 'params','GLfloat *' ))
glGetLightfv.version = '1.0'
glGetLightfv.category = 'GL_VERSION_1_0'
glGetLightfv.esVersions = [1.1]
glGetLightfv.trace = True
glGetLightfv.play = False
gl.add(glGetLightfv)

glGetLightiv = Function('glGetLightiv')
glGetLightiv.ret = Return('void')
glGetLightiv.add( Input( 'light','GLenum' ))
glGetLightiv.add( Input( 'pname','GLenum' ))
glGetLightiv.add( Output( 'params','GLint *' ))
glGetLightiv.version = '1.0'
glGetLightiv.category = 'GL_VERSION_1_0'
glGetLightiv.trace = True
glGetLightiv.play = False
gl.add(glGetLightiv)

glGetMapdv = Function('glGetMapdv')
glGetMapdv.ret = Return('void')
glGetMapdv.add( Input( 'target','GLenum' ))
glGetMapdv.add( Input( 'query','GLenum' ))
glGetMapdv.add( Output( 'v','GLdouble *' ))
glGetMapdv.version = '1.0'
glGetMapdv.category = 'GL_VERSION_1_0'
glGetMapdv.trace = True
glGetMapdv.play = False
gl.add(glGetMapdv)

glGetMapfv = Function('glGetMapfv')
glGetMapfv.ret = Return('void')
glGetMapfv.add( Input( 'target','GLenum' ))
glGetMapfv.add( Input( 'query','GLenum' ))
glGetMapfv.add( Output( 'v','GLfloat *' ))
glGetMapfv.version = '1.0'
glGetMapfv.category = 'GL_VERSION_1_0'
glGetMapfv.trace = True
glGetMapfv.play = False
gl.add(glGetMapfv)

glGetMapiv = Function('glGetMapiv')
glGetMapiv.ret = Return('void')
glGetMapiv.add( Input( 'target','GLenum' ))
glGetMapiv.add( Input( 'query','GLenum' ))
glGetMapiv.add( Output( 'v','GLint *' ))
glGetMapiv.version = '1.0'
glGetMapiv.category = 'GL_VERSION_1_0'
glGetMapiv.trace = True
glGetMapiv.play = False
gl.add(glGetMapiv)

glGetMaterialfv = Function('glGetMaterialfv')
glGetMaterialfv.ret = Return('void')
glGetMaterialfv.add( Input( 'face','GLenum' ))
glGetMaterialfv.add( Input( 'pname','GLenum' ))
glGetMaterialfv.add( Output( 'params','GLfloat *' ))
glGetMaterialfv.version = '1.0'
glGetMaterialfv.category = 'GL_VERSION_1_0'
glGetMaterialfv.esVersions = [1.1]
glGetMaterialfv.trace = True
glGetMaterialfv.play = False
gl.add(glGetMaterialfv)

glGetMaterialiv = Function('glGetMaterialiv')
glGetMaterialiv.ret = Return('void')
glGetMaterialiv.add( Input( 'face','GLenum' ))
glGetMaterialiv.add( Input( 'pname','GLenum' ))
glGetMaterialiv.add( Output( 'params','GLint *' ))
glGetMaterialiv.version = '1.0'
glGetMaterialiv.category = 'GL_VERSION_1_0'
glGetMaterialiv.trace = True
glGetMaterialiv.play = False
gl.add(glGetMaterialiv)

glGetPixelMapfv = Function('glGetPixelMapfv')
glGetPixelMapfv.ret = Return('void')
glGetPixelMapfv.add( Input( 'map','GLenum' ))
glGetPixelMapfv.add( Output( 'values','GLfloat *' ))
glGetPixelMapfv.version = '1.0'
glGetPixelMapfv.category = 'GL_VERSION_1_0'
glGetPixelMapfv.trace = True
glGetPixelMapfv.play = False
gl.add(glGetPixelMapfv)

glGetPixelMapuiv = Function('glGetPixelMapuiv')
glGetPixelMapuiv.ret = Return('void')
glGetPixelMapuiv.add( Input( 'map','GLenum' ))
glGetPixelMapuiv.add( Output( 'values','GLuint *' ))
glGetPixelMapuiv.version = '1.0'
glGetPixelMapuiv.category = 'GL_VERSION_1_0'
glGetPixelMapuiv.trace = True
glGetPixelMapuiv.play = False
gl.add(glGetPixelMapuiv)

glGetPixelMapusv = Function('glGetPixelMapusv')
glGetPixelMapusv.ret = Return('void')
glGetPixelMapusv.add( Input( 'map','GLenum' ))
glGetPixelMapusv.add( Output( 'values','GLushort *' ))
glGetPixelMapusv.version = '1.0'
glGetPixelMapusv.category = 'GL_VERSION_1_0'
glGetPixelMapusv.trace = True
glGetPixelMapusv.play = False
gl.add(glGetPixelMapusv)

glGetPolygonStipple = Function('glGetPolygonStipple')
glGetPolygonStipple.ret = Return('void')
glGetPolygonStipple.add( Output( 'mask','GLubyte *' ))
glGetPolygonStipple.version = '1.0'
glGetPolygonStipple.category = 'GL_VERSION_1_0'
glGetPolygonStipple.trace = True
glGetPolygonStipple.play = False
gl.add(glGetPolygonStipple)

glGetString = Function('glGetString')
glGetString.ret = Return('const GLubyte *')
glGetString.ret.cast = 'const GLchar *'
glGetString.add( Input( 'name','GLenum' ))
glGetString.version = '1.0'
glGetString.category = 'GL_VERSION_1_0'
glGetString.esVersions = [1.0, 1.1, 2.0]
glGetString.trace = True
glGetString.play = True
gl.add(glGetString)

glGetTexEnvfv = Function('glGetTexEnvfv')
glGetTexEnvfv.ret = Return('void')
glGetTexEnvfv.add( Input( 'target','GLenum' ))
glGetTexEnvfv.add( Input( 'pname','GLenum' ))
glGetTexEnvfv.add( Output( 'params','GLfloat *' ))
glGetTexEnvfv.version = '1.0'
glGetTexEnvfv.category = 'GL_VERSION_1_0'
glGetTexEnvfv.esVersions = [1.1]
glGetTexEnvfv.trace = True
glGetTexEnvfv.play = False
gl.add(glGetTexEnvfv)

glGetTexEnviv = Function('glGetTexEnviv')
glGetTexEnviv.ret = Return('void')
glGetTexEnviv.add( Input( 'target','GLenum' ))
glGetTexEnviv.add( Input( 'pname','GLenum' ))
glGetTexEnviv.add( Output( 'params','GLint *' ))
glGetTexEnviv.version = '1.0'
glGetTexEnviv.category = 'GL_VERSION_1_0'
glGetTexEnviv.esVersions = [1.1]
glGetTexEnviv.trace = True
glGetTexEnviv.play = False
gl.add(glGetTexEnviv)

glGetTexGendv = Function('glGetTexGendv')
glGetTexGendv.ret = Return('void')
glGetTexGendv.add( Input( 'coord','GLenum' ))
glGetTexGendv.add( Input( 'pname','GLenum' ))
glGetTexGendv.add( Output( 'params','GLdouble *' ))
glGetTexGendv.version = '1.0'
glGetTexGendv.category = 'GL_VERSION_1_0'
glGetTexGendv.trace = True
glGetTexGendv.play = False
gl.add(glGetTexGendv)

glGetTexGenfv = Function('glGetTexGenfv')
glGetTexGenfv.ret = Return('void')
glGetTexGenfv.add( Input( 'coord','GLenum' ))
glGetTexGenfv.add( Input( 'pname','GLenum' ))
glGetTexGenfv.add( Output( 'params','GLfloat *' ))
glGetTexGenfv.version = '1.0'
glGetTexGenfv.category = 'GL_VERSION_1_0'
glGetTexGenfv.trace = True
glGetTexGenfv.play = False
gl.add(glGetTexGenfv)

glGetTexGeniv = Function('glGetTexGeniv')
glGetTexGeniv.ret = Return('void')
glGetTexGeniv.add( Input( 'coord','GLenum' ))
glGetTexGeniv.add( Input( 'pname','GLenum' ))
glGetTexGeniv.add( Output( 'params','GLint *' ))
glGetTexGeniv.version = '1.0'
glGetTexGeniv.category = 'GL_VERSION_1_0'
glGetTexGeniv.trace = True
glGetTexGeniv.play = False
gl.add(glGetTexGeniv)

glGetTexImage = Function('glGetTexImage')
glGetTexImage.ret = Return('void')
glGetTexImage.add( Input( 'target','GLenum' ))
glGetTexImage.add( Input( 'level','GLint' ))
glGetTexImage.add( Input( 'format','GLenum' ))
glGetTexImage.add( Input( 'type','GLenum' ))
glGetTexImage.add( Output( 'pixels','GLvoid *' ))
glGetTexImage.version = '1.0'
glGetTexImage.category = 'GL_VERSION_1_0'
glGetTexImage.trace = True
glGetTexImage.play = False
gl.add(glGetTexImage)

glGetTexLevelParameterfv = Function('glGetTexLevelParameterfv')
glGetTexLevelParameterfv.ret = Return('void')
glGetTexLevelParameterfv.add( Input( 'target','GLenum' ))
glGetTexLevelParameterfv.add( Input( 'level','GLint' ))
glGetTexLevelParameterfv.add( Input( 'pname','GLenum' ))
glGetTexLevelParameterfv.add( Output( 'params','GLfloat *' ))
glGetTexLevelParameterfv.version = '1.0'
glGetTexLevelParameterfv.category = 'GL_VERSION_1_0'
glGetTexLevelParameterfv.trace = True
glGetTexLevelParameterfv.play = False
gl.add(glGetTexLevelParameterfv)

glGetTexLevelParameteriv = Function('glGetTexLevelParameteriv')
glGetTexLevelParameteriv.ret = Return('void')
glGetTexLevelParameteriv.add( Input( 'target','GLenum' ))
glGetTexLevelParameteriv.add( Input( 'level','GLint' ))
glGetTexLevelParameteriv.add( Input( 'pname','GLenum' ))
glGetTexLevelParameteriv.add( Output( 'params','GLint *' ))
glGetTexLevelParameteriv.version = '1.0'
glGetTexLevelParameteriv.category = 'GL_VERSION_1_0'
glGetTexLevelParameteriv.trace = True
glGetTexLevelParameteriv.play = False
gl.add(glGetTexLevelParameteriv)

glGetTexParameterfv = Function('glGetTexParameterfv')
glGetTexParameterfv.ret = Return('void')
glGetTexParameterfv.add( Input( 'target','GLenum' ))
glGetTexParameterfv.add( Input( 'pname','GLenum' ))
glGetTexParameterfv.add( Output( 'params','GLfloat *' ))
glGetTexParameterfv.version = '1.0'
glGetTexParameterfv.category = 'GL_VERSION_1_0'
glGetTexParameterfv.esVersions = [1.1, 2.0]
glGetTexParameterfv.trace = True
glGetTexParameterfv.play = False
gl.add(glGetTexParameterfv)

glGetTexParameteriv = Function('glGetTexParameteriv')
glGetTexParameteriv.ret = Return('void')
glGetTexParameteriv.add( Input( 'target','GLenum' ))
glGetTexParameteriv.add( Input( 'pname','GLenum' ))
glGetTexParameteriv.add( Output( 'params','GLint *' ))
glGetTexParameteriv.version = '1.0'
glGetTexParameteriv.category = 'GL_VERSION_1_0'
glGetTexParameteriv.esVersions = [1.1, 2.0]
glGetTexParameteriv.trace = True
glGetTexParameteriv.play = False
gl.add(glGetTexParameteriv)

glHint = Function('glHint')
glHint.ret = Return('void')
glHint.add( Input( 'target','GLenum' ))
glHint.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glHint.version = '1.0'
glHint.category = 'GL_VERSION_1_0'
glHint.esVersions = [1.0, 1.1, 2.0]
glHint.trace = True
glHint.play = True
gl.add(glHint)

glIndexMask = Function('glIndexMask')
glIndexMask.ret = Return('void')
glIndexMask.add( Input( 'mask','GLuint' ))
glIndexMask.version = '1.0'
glIndexMask.category = 'GL_VERSION_1_0'
glIndexMask.trace = True
glIndexMask.play = True
gl.add(glIndexMask)

glIndexd = Function('glIndexd')
glIndexd.ret = Return('void')
glIndexd.add( Input( 'c','GLdouble' ))
glIndexd.version = '1.0'
glIndexd.category = 'GL_VERSION_1_0'
glIndexd.trace = True
glIndexd.play = True
gl.add(glIndexd)

glIndexdv = Function('glIndexdv')
glIndexdv.ret = Return('void')
glIndexdv.add( Input( 'c','const GLdouble *' ,size = 1 ))
glIndexdv.version = '1.0'
glIndexdv.category = 'GL_VERSION_1_0'
glIndexdv.trace = True
glIndexdv.play = True
gl.add(glIndexdv)

glIndexf = Function('glIndexf')
glIndexf.ret = Return('void')
glIndexf.add( Input( 'c','GLfloat' ))
glIndexf.version = '1.0'
glIndexf.category = 'GL_VERSION_1_0'
glIndexf.trace = True
glIndexf.play = True
gl.add(glIndexf)

glIndexfv = Function('glIndexfv')
glIndexfv.ret = Return('void')
glIndexfv.add( Input( 'c','const GLfloat *' ,size = 1 ))
glIndexfv.version = '1.0'
glIndexfv.category = 'GL_VERSION_1_0'
glIndexfv.trace = True
glIndexfv.play = True
gl.add(glIndexfv)

glIndexi = Function('glIndexi')
glIndexi.ret = Return('void')
glIndexi.add( Input( 'c','GLint' ))
glIndexi.version = '1.0'
glIndexi.category = 'GL_VERSION_1_0'
glIndexi.trace = True
glIndexi.play = True
gl.add(glIndexi)

glIndexiv = Function('glIndexiv')
glIndexiv.ret = Return('void')
glIndexiv.add( Input( 'c','const GLint *' ,size = 1 ))
glIndexiv.version = '1.0'
glIndexiv.category = 'GL_VERSION_1_0'
glIndexiv.trace = True
glIndexiv.play = True
gl.add(glIndexiv)

glIndexs = Function('glIndexs')
glIndexs.ret = Return('void')
glIndexs.add( Input( 'c','GLshort' ))
glIndexs.version = '1.0'
glIndexs.category = 'GL_VERSION_1_0'
glIndexs.trace = True
glIndexs.play = True
gl.add(glIndexs)

glIndexsv = Function('glIndexsv')
glIndexsv.ret = Return('void')
glIndexsv.add( Input( 'c','const GLshort *' ,size = 1 ))
glIndexsv.version = '1.0'
glIndexsv.category = 'GL_VERSION_1_0'
glIndexsv.trace = True
glIndexsv.play = True
gl.add(glIndexsv)

glInitNames = Function('glInitNames')
glInitNames.ret = Return('void')
glInitNames.version = '1.0'
glInitNames.category = 'GL_VERSION_1_0'
glInitNames.trace = True
glInitNames.play = True
gl.add(glInitNames)

glIsEnabled = Function('glIsEnabled')
glIsEnabled.ret = Return('GLboolean')
glIsEnabled.add( Input( 'cap','GLenum' ))
glIsEnabled.version = '1.0'
glIsEnabled.category = 'GL_VERSION_1_0'
glIsEnabled.esVersions = [1.1, 2.0]
glIsEnabled.trace = True
glIsEnabled.play = True
gl.add(glIsEnabled)

glIsList = Function('glIsList')
glIsList.ret = Return('GLboolean')
glIsList.add( Input( 'list','GLuint' ))
glIsList.version = '1.0'
glIsList.category = 'GL_VERSION_1_0'
glIsList.trace = True
glIsList.play = True
gl.add(glIsList)

glLightModelf = Function('glLightModelf')
glLightModelf.ret = Return('void')
glLightModelf.add( Input( 'pname','GLenum' ))
glLightModelf.add( Input( 'param','GLfloat' ))
glLightModelf.version = '1.0'
glLightModelf.category = 'GL_VERSION_1_0'
glLightModelf.esVersions = [1.0, 1.1]
glLightModelf.trace = True
glLightModelf.play = True
gl.add(glLightModelf)

glLightModelfv = Function('glLightModelfv')
glLightModelfv.ret = Return('void')
glLightModelfv.add( Input( 'pname','GLenum' ))
glLightModelfv.add( Input( 'params','const GLfloat *' ,size = 'helperGLLightModelvSize(pname)' ))
glLightModelfv.version = '1.0'
glLightModelfv.category = 'GL_VERSION_1_0'
glLightModelfv.esVersions = [1.0, 1.1]
glLightModelfv.trace = True
glLightModelfv.play = True
gl.add(glLightModelfv)

glLightModeli = Function('glLightModeli')
glLightModeli.ret = Return('void')
glLightModeli.add( Input( 'pname','GLenum' ))
glLightModeli.add( Input( 'param','GLint' ))
glLightModeli.version = '1.0'
glLightModeli.category = 'GL_VERSION_1_0'
glLightModeli.trace = True
glLightModeli.play = True
gl.add(glLightModeli)

glLightModeliv = Function('glLightModeliv')
glLightModeliv.ret = Return('void')
glLightModeliv.add( Input( 'pname','GLenum' ))
glLightModeliv.add( Input( 'params','const GLint *' ,size = 'helperGLLightModelvSize(pname)' ))
glLightModeliv.version = '1.0'
glLightModeliv.category = 'GL_VERSION_1_0'
glLightModeliv.trace = True
glLightModeliv.play = True
gl.add(glLightModeliv)

glLightf = Function('glLightf')
glLightf.ret = Return('void')
glLightf.add( Input( 'light','GLenum' ))
glLightf.add( Input( 'pname','GLenum' ))
glLightf.add( Input( 'param','GLfloat' ))
glLightf.version = '1.0'
glLightf.category = 'GL_VERSION_1_0'
glLightf.esVersions = [1.0, 1.1]
glLightf.trace = True
glLightf.play = True
gl.add(glLightf)

glLightfv = Function('glLightfv')
glLightfv.ret = Return('void')
glLightfv.add( Input( 'light','GLenum' ))
glLightfv.add( Input( 'pname','GLenum' ))
glLightfv.add( Input( 'params','const GLfloat *' ,size = 'helperGLLightvSize(pname)' ))
glLightfv.version = '1.0'
glLightfv.category = 'GL_VERSION_1_0'
glLightfv.esVersions = [1.0, 1.1]
glLightfv.trace = True
glLightfv.play = True
gl.add(glLightfv)

glLighti = Function('glLighti')
glLighti.ret = Return('void')
glLighti.add( Input( 'light','GLenum' ))
glLighti.add( Input( 'pname','GLenum' ))
glLighti.add( Input( 'param','GLint' ))
glLighti.version = '1.0'
glLighti.category = 'GL_VERSION_1_0'
glLighti.trace = True
glLighti.play = True
gl.add(glLighti)

glLightiv = Function('glLightiv')
glLightiv.ret = Return('void')
glLightiv.add( Input( 'light','GLenum' ))
glLightiv.add( Input( 'pname','GLenum' ))
glLightiv.add( Input( 'params','const GLint *' ,size = 'helperGLLightvSize(pname)' ))
glLightiv.version = '1.0'
glLightiv.category = 'GL_VERSION_1_0'
glLightiv.trace = True
glLightiv.play = True
gl.add(glLightiv)

glLineStipple = Function('glLineStipple')
glLineStipple.ret = Return('void')
glLineStipple.add( Input( 'factor','GLint' ))
glLineStipple.add( Input( 'pattern','GLushort' ))
glLineStipple.version = '1.0'
glLineStipple.category = 'GL_VERSION_1_0'
glLineStipple.trace = True
glLineStipple.play = True
gl.add(glLineStipple)

glLineWidth = Function('glLineWidth')
glLineWidth.ret = Return('void')
glLineWidth.add( Input( 'width','GLfloat' ))
glLineWidth.version = '1.0'
glLineWidth.category = 'GL_VERSION_1_0'
glLineWidth.esVersions = [1.0, 1.1, 2.0]
glLineWidth.trace = True
glLineWidth.play = True
gl.add(glLineWidth)

glListBase = Function('glListBase')
glListBase.ret = Return('void')
glListBase.add( Input( 'base','GLuint' ))
glListBase.version = '1.0'
glListBase.category = 'GL_VERSION_1_0'
glListBase.trace = True
glListBase.play = True
gl.add(glListBase)

glLoadIdentity = Function('glLoadIdentity')
glLoadIdentity.ret = Return('void')
glLoadIdentity.version = '1.0'
glLoadIdentity.category = 'GL_VERSION_1_0'
glLoadIdentity.esVersions = [1.0, 1.1]
glLoadIdentity.trace = True
glLoadIdentity.play = True
gl.add(glLoadIdentity)

glLoadMatrixd = Function('glLoadMatrixd')
glLoadMatrixd.ret = Return('void')
glLoadMatrixd.add( Input( 'm','const GLdouble *' ,size = 16 ))
glLoadMatrixd.version = '1.0'
glLoadMatrixd.category = 'GL_VERSION_1_0'
glLoadMatrixd.trace = True
glLoadMatrixd.play = True
gl.add(glLoadMatrixd)

glLoadMatrixf = Function('glLoadMatrixf')
glLoadMatrixf.ret = Return('void')
glLoadMatrixf.add( Input( 'm','const GLfloat *' ,size = 16 ))
glLoadMatrixf.version = '1.0'
glLoadMatrixf.category = 'GL_VERSION_1_0'
glLoadMatrixf.esVersions = [1.0, 1.1]
glLoadMatrixf.trace = True
glLoadMatrixf.play = True
gl.add(glLoadMatrixf)

glLoadName = Function('glLoadName')
glLoadName.ret = Return('void')
glLoadName.add( Input( 'name','GLuint' ))
glLoadName.version = '1.0'
glLoadName.category = 'GL_VERSION_1_0'
glLoadName.trace = True
glLoadName.play = True
gl.add(glLoadName)

glLogicOp = Function('glLogicOp')
glLogicOp.ret = Return('void')
glLogicOp.add( Input( 'opcode','GLenum' ))
glLogicOp.version = '1.0'
glLogicOp.category = 'GL_VERSION_1_0'
glLogicOp.esVersions = [1.0, 1.1]
glLogicOp.trace = True
glLogicOp.play = True
gl.add(glLogicOp)

glMap1d = Function('glMap1d')
glMap1d.ret = Return('void')
glMap1d.add( Input( 'target','GLenum' ))
glMap1d.add( Input( 'u1','GLdouble' ))
glMap1d.add( Input( 'u2','GLdouble' ))
glMap1d.add( Input( 'stride','GLint' ))
glMap1d.add( Input( 'order','GLint' ))
glMap1d.add( Input( 'points','const GLdouble *' ))
glMap1d.version = '1.0'
glMap1d.category = 'GL_VERSION_1_0'
glMap1d.trace = True
glMap1d.play = True
gl.add(glMap1d)

glMap1f = Function('glMap1f')
glMap1f.ret = Return('void')
glMap1f.add( Input( 'target','GLenum' ))
glMap1f.add( Input( 'u1','GLfloat' ))
glMap1f.add( Input( 'u2','GLfloat' ))
glMap1f.add( Input( 'stride','GLint' ))
glMap1f.add( Input( 'order','GLint' ))
glMap1f.add( Input( 'points','const GLfloat *' ))
glMap1f.version = '1.0'
glMap1f.category = 'GL_VERSION_1_0'
glMap1f.trace = True
glMap1f.play = True
gl.add(glMap1f)

glMap2d = Function('glMap2d')
glMap2d.ret = Return('void')
glMap2d.add( Input( 'target','GLenum' ))
glMap2d.add( Input( 'u1','GLdouble' ))
glMap2d.add( Input( 'u2','GLdouble' ))
glMap2d.add( Input( 'ustride','GLint' ))
glMap2d.add( Input( 'uorder','GLint' ))
glMap2d.add( Input( 'v1','GLdouble' ))
glMap2d.add( Input( 'v2','GLdouble' ))
glMap2d.add( Input( 'vstride','GLint' ))
glMap2d.add( Input( 'vorder','GLint' ))
glMap2d.add( Input( 'points','const GLdouble *' ))
glMap2d.version = '1.0'
glMap2d.category = 'GL_VERSION_1_0'
glMap2d.trace = True
glMap2d.play = True
gl.add(glMap2d)

glMap2f = Function('glMap2f')
glMap2f.ret = Return('void')
glMap2f.add( Input( 'target','GLenum' ))
glMap2f.add( Input( 'u1','GLfloat' ))
glMap2f.add( Input( 'u2','GLfloat' ))
glMap2f.add( Input( 'ustride','GLint' ))
glMap2f.add( Input( 'uorder','GLint' ))
glMap2f.add( Input( 'v1','GLfloat' ))
glMap2f.add( Input( 'v2','GLfloat' ))
glMap2f.add( Input( 'vstride','GLint' ))
glMap2f.add( Input( 'vorder','GLint' ))
glMap2f.add( Input( 'points','const GLfloat *' ))
glMap2f.version = '1.0'
glMap2f.category = 'GL_VERSION_1_0'
glMap2f.trace = True
glMap2f.play = True
gl.add(glMap2f)

glMapGrid1d = Function('glMapGrid1d')
glMapGrid1d.ret = Return('void')
glMapGrid1d.add( Input( 'un','GLint' ))
glMapGrid1d.add( Input( 'u1','GLdouble' ))
glMapGrid1d.add( Input( 'u2','GLdouble' ))
glMapGrid1d.version = '1.0'
glMapGrid1d.category = 'GL_VERSION_1_0'
glMapGrid1d.trace = True
glMapGrid1d.play = True
gl.add(glMapGrid1d)

glMapGrid1f = Function('glMapGrid1f')
glMapGrid1f.ret = Return('void')
glMapGrid1f.add( Input( 'un','GLint' ))
glMapGrid1f.add( Input( 'u1','GLfloat' ))
glMapGrid1f.add( Input( 'u2','GLfloat' ))
glMapGrid1f.version = '1.0'
glMapGrid1f.category = 'GL_VERSION_1_0'
glMapGrid1f.trace = True
glMapGrid1f.play = True
gl.add(glMapGrid1f)

glMapGrid2d = Function('glMapGrid2d')
glMapGrid2d.ret = Return('void')
glMapGrid2d.add( Input( 'un','GLint' ))
glMapGrid2d.add( Input( 'u1','GLdouble' ))
glMapGrid2d.add( Input( 'u2','GLdouble' ))
glMapGrid2d.add( Input( 'vn','GLint' ))
glMapGrid2d.add( Input( 'v1','GLdouble' ))
glMapGrid2d.add( Input( 'v2','GLdouble' ))
glMapGrid2d.version = '1.0'
glMapGrid2d.category = 'GL_VERSION_1_0'
glMapGrid2d.trace = True
glMapGrid2d.play = True
gl.add(glMapGrid2d)

glMapGrid2f = Function('glMapGrid2f')
glMapGrid2f.ret = Return('void')
glMapGrid2f.add( Input( 'un','GLint' ))
glMapGrid2f.add( Input( 'u1','GLfloat' ))
glMapGrid2f.add( Input( 'u2','GLfloat' ))
glMapGrid2f.add( Input( 'vn','GLint' ))
glMapGrid2f.add( Input( 'v1','GLfloat' ))
glMapGrid2f.add( Input( 'v2','GLfloat' ))
glMapGrid2f.version = '1.0'
glMapGrid2f.category = 'GL_VERSION_1_0'
glMapGrid2f.trace = True
glMapGrid2f.play = True
gl.add(glMapGrid2f)

glMaterialf = Function('glMaterialf')
glMaterialf.ret = Return('void')
glMaterialf.add( Input( 'face','GLenum' ))
glMaterialf.add( Input( 'pname','GLenum' ))
glMaterialf.add( Input( 'param','GLfloat' ))
glMaterialf.version = '1.0'
glMaterialf.category = 'GL_VERSION_1_0'
glMaterialf.esVersions = [1.0, 1.1]
glMaterialf.trace = True
glMaterialf.play = True
gl.add(glMaterialf)

glMaterialfv = Function('glMaterialfv')
glMaterialfv.ret = Return('void')
glMaterialfv.add( Input( 'face','GLenum' ))
glMaterialfv.add( Input( 'pname','GLenum' ))
glMaterialfv.add( Input( 'params','const GLfloat *' ,size = 'helperGLMaterialvSize(pname)' ))
glMaterialfv.version = '1.0'
glMaterialfv.category = 'GL_VERSION_1_0'
glMaterialfv.esVersions = [1.0, 1.1]
glMaterialfv.trace = True
glMaterialfv.play = True
gl.add(glMaterialfv)

glMateriali = Function('glMateriali')
glMateriali.ret = Return('void')
glMateriali.add( Input( 'face','GLenum' ))
glMateriali.add( Input( 'pname','GLenum' ))
glMateriali.add( Input( 'param','GLint' ))
glMateriali.version = '1.0'
glMateriali.category = 'GL_VERSION_1_0'
glMateriali.trace = True
glMateriali.play = True
gl.add(glMateriali)

glMaterialiv = Function('glMaterialiv')
glMaterialiv.ret = Return('void')
glMaterialiv.add( Input( 'face','GLenum' ))
glMaterialiv.add( Input( 'pname','GLenum' ))
glMaterialiv.add( Input( 'params','const GLint *' ,size = 'helperGLMaterialvSize(pname)' ))
glMaterialiv.version = '1.0'
glMaterialiv.category = 'GL_VERSION_1_0'
glMaterialiv.trace = True
glMaterialiv.play = True
gl.add(glMaterialiv)

glMatrixMode = Function('glMatrixMode')
glMatrixMode.ret = Return('void')
glMatrixMode.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glMatrixMode.version = '1.0'
glMatrixMode.category = 'GL_VERSION_1_0'
glMatrixMode.esVersions = [1.0, 1.1]
glMatrixMode.trace = True
glMatrixMode.play = True
gl.add(glMatrixMode)

glMultMatrixd = Function('glMultMatrixd')
glMultMatrixd.ret = Return('void')
glMultMatrixd.add( Input( 'm','const GLdouble *' ,size = 16 ))
glMultMatrixd.version = '1.0'
glMultMatrixd.category = 'GL_VERSION_1_0'
glMultMatrixd.trace = True
glMultMatrixd.play = True
gl.add(glMultMatrixd)

glMultMatrixf = Function('glMultMatrixf')
glMultMatrixf.ret = Return('void')
glMultMatrixf.add( Input( 'm','const GLfloat *' ,size = 16 ))
glMultMatrixf.version = '1.0'
glMultMatrixf.category = 'GL_VERSION_1_0'
glMultMatrixf.esVersions = [1.0, 1.1]
glMultMatrixf.trace = True
glMultMatrixf.play = True
gl.add(glMultMatrixf)

glNewList = Function('glNewList')
glNewList.ret = Return('void')
glNewList.add( Input( 'list','GLuint' ))
glNewList.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glNewList.version = '1.0'
glNewList.category = 'GL_VERSION_1_0'
glNewList.trace = True
glNewList.play = True
gl.add(glNewList)

glNormal3b = Function('glNormal3b')
glNormal3b.ret = Return('void')
glNormal3b.add( Input( 'nx','GLbyte' ))
glNormal3b.add( Input( 'ny','GLbyte' ))
glNormal3b.add( Input( 'nz','GLbyte' ))
glNormal3b.version = '1.0'
glNormal3b.category = 'GL_VERSION_1_0'
glNormal3b.trace = True
glNormal3b.play = True
gl.add(glNormal3b)

glNormal3bv = Function('glNormal3bv')
glNormal3bv.ret = Return('void')
glNormal3bv.add( Input( 'v','const GLbyte *' ,size = 3 ))
glNormal3bv.version = '1.0'
glNormal3bv.category = 'GL_VERSION_1_0'
glNormal3bv.trace = True
glNormal3bv.play = True
gl.add(glNormal3bv)

glNormal3d = Function('glNormal3d')
glNormal3d.ret = Return('void')
glNormal3d.add( Input( 'nx','GLdouble' ))
glNormal3d.add( Input( 'ny','GLdouble' ))
glNormal3d.add( Input( 'nz','GLdouble' ))
glNormal3d.version = '1.0'
glNormal3d.category = 'GL_VERSION_1_0'
glNormal3d.trace = True
glNormal3d.play = True
gl.add(glNormal3d)

glNormal3dv = Function('glNormal3dv')
glNormal3dv.ret = Return('void')
glNormal3dv.add( Input( 'v','const GLdouble *' ,size = 3 ))
glNormal3dv.version = '1.0'
glNormal3dv.category = 'GL_VERSION_1_0'
glNormal3dv.trace = True
glNormal3dv.play = True
gl.add(glNormal3dv)

glNormal3f = Function('glNormal3f')
glNormal3f.ret = Return('void')
glNormal3f.add( Input( 'nx','GLfloat' ))
glNormal3f.add( Input( 'ny','GLfloat' ))
glNormal3f.add( Input( 'nz','GLfloat' ))
glNormal3f.version = '1.0'
glNormal3f.category = 'GL_VERSION_1_0'
glNormal3f.esVersions = [1.0, 1.1]
glNormal3f.trace = True
glNormal3f.play = True
gl.add(glNormal3f)

glNormal3fv = Function('glNormal3fv')
glNormal3fv.ret = Return('void')
glNormal3fv.add( Input( 'v','const GLfloat *' ,size = 3 ))
glNormal3fv.version = '1.0'
glNormal3fv.category = 'GL_VERSION_1_0'
glNormal3fv.trace = True
glNormal3fv.play = True
gl.add(glNormal3fv)

glNormal3i = Function('glNormal3i')
glNormal3i.ret = Return('void')
glNormal3i.add( Input( 'nx','GLint' ))
glNormal3i.add( Input( 'ny','GLint' ))
glNormal3i.add( Input( 'nz','GLint' ))
glNormal3i.version = '1.0'
glNormal3i.category = 'GL_VERSION_1_0'
glNormal3i.trace = True
glNormal3i.play = True
gl.add(glNormal3i)

glNormal3iv = Function('glNormal3iv')
glNormal3iv.ret = Return('void')
glNormal3iv.add( Input( 'v','const GLint *' ,size = 3 ))
glNormal3iv.version = '1.0'
glNormal3iv.category = 'GL_VERSION_1_0'
glNormal3iv.trace = True
glNormal3iv.play = True
gl.add(glNormal3iv)

glNormal3s = Function('glNormal3s')
glNormal3s.ret = Return('void')
glNormal3s.add( Input( 'nx','GLshort' ))
glNormal3s.add( Input( 'ny','GLshort' ))
glNormal3s.add( Input( 'nz','GLshort' ))
glNormal3s.version = '1.0'
glNormal3s.category = 'GL_VERSION_1_0'
glNormal3s.trace = True
glNormal3s.play = True
gl.add(glNormal3s)

glNormal3sv = Function('glNormal3sv')
glNormal3sv.ret = Return('void')
glNormal3sv.add( Input( 'v','const GLshort *' ,size = 3 ))
glNormal3sv.version = '1.0'
glNormal3sv.category = 'GL_VERSION_1_0'
glNormal3sv.trace = True
glNormal3sv.play = True
gl.add(glNormal3sv)

glOrtho = Function('glOrtho')
glOrtho.ret = Return('void')
glOrtho.add( Input( 'left','GLdouble' ))
glOrtho.add( Input( 'right','GLdouble' ))
glOrtho.add( Input( 'bottom','GLdouble' ))
glOrtho.add( Input( 'top','GLdouble' ))
glOrtho.add( Input( 'zNear','GLdouble' ))
glOrtho.add( Input( 'zFar','GLdouble' ))
glOrtho.version = '1.0'
glOrtho.category = 'GL_VERSION_1_0'
glOrtho.trace = True
glOrtho.play = True
gl.add(glOrtho)

glPassThrough = Function('glPassThrough')
glPassThrough.ret = Return('void')
glPassThrough.add( Input( 'token','GLfloat' ))
glPassThrough.version = '1.0'
glPassThrough.category = 'GL_VERSION_1_0'
glPassThrough.trace = True
glPassThrough.play = True
gl.add(glPassThrough)

glPixelMapfv = Function('glPixelMapfv')
glPixelMapfv.ret = Return('void')
glPixelMapfv.add( Input( 'map','GLenum' ))
glPixelMapfv.add( Input( 'mapsize','GLsizei' ))
glPixelMapfv.add( Input( 'values','const GLfloat *' ,size = 'mapsize' ))
glPixelMapfv.version = '1.0'
glPixelMapfv.category = 'GL_VERSION_1_0'
glPixelMapfv.trace = True
glPixelMapfv.play = True
gl.add(glPixelMapfv)

glPixelMapuiv = Function('glPixelMapuiv')
glPixelMapuiv.ret = Return('void')
glPixelMapuiv.add( Input( 'map','GLenum' ))
glPixelMapuiv.add( Input( 'mapsize','GLsizei' ))
glPixelMapuiv.add( Input( 'values','const GLuint *' ,size = 'mapsize' ))
glPixelMapuiv.version = '1.0'
glPixelMapuiv.category = 'GL_VERSION_1_0'
glPixelMapuiv.trace = True
glPixelMapuiv.play = True
gl.add(glPixelMapuiv)

glPixelMapusv = Function('glPixelMapusv')
glPixelMapusv.ret = Return('void')
glPixelMapusv.add( Input( 'map','GLenum' ))
glPixelMapusv.add( Input( 'mapsize','GLsizei' ))
glPixelMapusv.add( Input( 'values','const GLushort *' ,size = 'mapsize' ))
glPixelMapusv.version = '1.0'
glPixelMapusv.category = 'GL_VERSION_1_0'
glPixelMapusv.trace = True
glPixelMapusv.play = True
gl.add(glPixelMapusv)

glPixelStoref = Function('glPixelStoref')
glPixelStoref.ret = Return('void')
glPixelStoref.add( Input( 'pname','GLenum' ))
glPixelStoref.add( Input( 'param','GLfloat' ))
glPixelStoref.version = '1.0'
glPixelStoref.category = 'GL_VERSION_1_0'
glPixelStoref.trace = True
glPixelStoref.play = True
gl.add(glPixelStoref)

glPixelStorei = Function('glPixelStorei')
glPixelStorei.ret = Return('void')
glPixelStorei.add( Input( 'pname','GLenum' ))
glPixelStorei.add( Input( 'param','GLint' ))
glPixelStorei.version = '1.0'
glPixelStorei.category = 'GL_VERSION_1_0'
glPixelStorei.esVersions = [1.0, 1.1, 2.0]
glPixelStorei.trace = True
glPixelStorei.play = True
gl.add(glPixelStorei)

glPixelTransferf = Function('glPixelTransferf')
glPixelTransferf.ret = Return('void')
glPixelTransferf.add( Input( 'pname','GLenum' ))
glPixelTransferf.add( Input( 'param','GLfloat' ))
glPixelTransferf.version = '1.0'
glPixelTransferf.category = 'GL_VERSION_1_0'
glPixelTransferf.trace = True
glPixelTransferf.play = True
gl.add(glPixelTransferf)

glPixelTransferi = Function('glPixelTransferi')
glPixelTransferi.ret = Return('void')
glPixelTransferi.add( Input( 'pname','GLenum' ))
glPixelTransferi.add( Input( 'param','GLint' ))
glPixelTransferi.version = '1.0'
glPixelTransferi.category = 'GL_VERSION_1_0'
glPixelTransferi.trace = True
glPixelTransferi.play = True
gl.add(glPixelTransferi)

glPixelZoom = Function('glPixelZoom')
glPixelZoom.ret = Return('void')
glPixelZoom.add( Input( 'xfactor','GLfloat' ))
glPixelZoom.add( Input( 'yfactor','GLfloat' ))
glPixelZoom.version = '1.0'
glPixelZoom.category = 'GL_VERSION_1_0'
glPixelZoom.trace = True
glPixelZoom.play = True
gl.add(glPixelZoom)

glPointSize = Function('glPointSize')
glPointSize.ret = Return('void')
glPointSize.add( Input( 'size','GLfloat' ))
glPointSize.version = '1.0'
glPointSize.category = 'GL_VERSION_1_0'
glPointSize.esVersions = [1.0, 1.1]
glPointSize.trace = True
glPointSize.play = True
gl.add(glPointSize)

glPolygonMode = Function('glPolygonMode')
glPolygonMode.ret = Return('void')
glPolygonMode.add( Input( 'face','GLenum' ))
glPolygonMode.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glPolygonMode.version = '1.0'
glPolygonMode.category = 'GL_VERSION_1_0'
glPolygonMode.trace = True
glPolygonMode.play = True
gl.add(glPolygonMode)

glPolygonStipple = Function('glPolygonStipple')
glPolygonStipple.ret = Return('void')
glPolygonStipple.add( Input( 'mask','const GLubyte *' ,size = 'helperGLPixelImageSize(32, 32, 0, GL_COLOR_INDEX, GL_BITMAP, 0, GL_BITMAP)' ))
glPolygonStipple.version = '1.0'
glPolygonStipple.category = 'GL_VERSION_1_0'
glPolygonStipple.trace = True
glPolygonStipple.play = True
gl.add(glPolygonStipple)

glPopAttrib = Function('glPopAttrib')
glPopAttrib.ret = Return('void')
glPopAttrib.version = '1.0'
glPopAttrib.category = 'GL_VERSION_1_0'
glPopAttrib.trace = True
glPopAttrib.play = True
gl.add(glPopAttrib)

glPopMatrix = Function('glPopMatrix')
glPopMatrix.ret = Return('void')
glPopMatrix.version = '1.0'
glPopMatrix.category = 'GL_VERSION_1_0'
glPopMatrix.esVersions = [1.0, 1.1]
glPopMatrix.trace = True
glPopMatrix.play = True
gl.add(glPopMatrix)

glPopName = Function('glPopName')
glPopName.ret = Return('void')
glPopName.version = '1.0'
glPopName.category = 'GL_VERSION_1_0'
glPopName.trace = True
glPopName.play = True
gl.add(glPopName)

glPushAttrib = Function('glPushAttrib')
glPushAttrib.ret = Return('void')
glPushAttrib.add( Input( 'mask','GLbitfield' ,regalLog = 'GLpushAttribToString(mask)' ))
glPushAttrib.version = '1.0'
glPushAttrib.category = 'GL_VERSION_1_0'
glPushAttrib.trace = True
glPushAttrib.play = True
gl.add(glPushAttrib)

glPushMatrix = Function('glPushMatrix')
glPushMatrix.ret = Return('void')
glPushMatrix.version = '1.0'
glPushMatrix.category = 'GL_VERSION_1_0'
glPushMatrix.esVersions = [1.0, 1.1]
glPushMatrix.trace = True
glPushMatrix.play = True
gl.add(glPushMatrix)

glPushName = Function('glPushName')
glPushName.ret = Return('void')
glPushName.add( Input( 'name','GLuint' ))
glPushName.version = '1.0'
glPushName.category = 'GL_VERSION_1_0'
glPushName.trace = True
glPushName.play = True
gl.add(glPushName)

glRasterPos2d = Function('glRasterPos2d')
glRasterPos2d.ret = Return('void')
glRasterPos2d.add( Input( 'x','GLdouble' ))
glRasterPos2d.add( Input( 'y','GLdouble' ))
glRasterPos2d.version = '1.0'
glRasterPos2d.category = 'GL_VERSION_1_0'
glRasterPos2d.trace = True
glRasterPos2d.play = True
gl.add(glRasterPos2d)

glRasterPos2dv = Function('glRasterPos2dv')
glRasterPos2dv.ret = Return('void')
glRasterPos2dv.add( Input( 'v','const GLdouble *' ,size = 2 ))
glRasterPos2dv.version = '1.0'
glRasterPos2dv.category = 'GL_VERSION_1_0'
glRasterPos2dv.trace = True
glRasterPos2dv.play = True
gl.add(glRasterPos2dv)

glRasterPos2f = Function('glRasterPos2f')
glRasterPos2f.ret = Return('void')
glRasterPos2f.add( Input( 'x','GLfloat' ))
glRasterPos2f.add( Input( 'y','GLfloat' ))
glRasterPos2f.version = '1.0'
glRasterPos2f.category = 'GL_VERSION_1_0'
glRasterPos2f.trace = True
glRasterPos2f.play = True
gl.add(glRasterPos2f)

glRasterPos2fv = Function('glRasterPos2fv')
glRasterPos2fv.ret = Return('void')
glRasterPos2fv.add( Input( 'v','const GLfloat *' ,size = 2 ))
glRasterPos2fv.version = '1.0'
glRasterPos2fv.category = 'GL_VERSION_1_0'
glRasterPos2fv.trace = True
glRasterPos2fv.play = True
gl.add(glRasterPos2fv)

glRasterPos2i = Function('glRasterPos2i')
glRasterPos2i.ret = Return('void')
glRasterPos2i.add( Input( 'x','GLint' ))
glRasterPos2i.add( Input( 'y','GLint' ))
glRasterPos2i.version = '1.0'
glRasterPos2i.category = 'GL_VERSION_1_0'
glRasterPos2i.trace = True
glRasterPos2i.play = True
gl.add(glRasterPos2i)

glRasterPos2iv = Function('glRasterPos2iv')
glRasterPos2iv.ret = Return('void')
glRasterPos2iv.add( Input( 'v','const GLint *' ,size = 2 ))
glRasterPos2iv.version = '1.0'
glRasterPos2iv.category = 'GL_VERSION_1_0'
glRasterPos2iv.trace = True
glRasterPos2iv.play = True
gl.add(glRasterPos2iv)

glRasterPos2s = Function('glRasterPos2s')
glRasterPos2s.ret = Return('void')
glRasterPos2s.add( Input( 'x','GLshort' ))
glRasterPos2s.add( Input( 'y','GLshort' ))
glRasterPos2s.version = '1.0'
glRasterPos2s.category = 'GL_VERSION_1_0'
glRasterPos2s.trace = True
glRasterPos2s.play = True
gl.add(glRasterPos2s)

glRasterPos2sv = Function('glRasterPos2sv')
glRasterPos2sv.ret = Return('void')
glRasterPos2sv.add( Input( 'v','const GLshort *' ,size = 2 ))
glRasterPos2sv.version = '1.0'
glRasterPos2sv.category = 'GL_VERSION_1_0'
glRasterPos2sv.trace = True
glRasterPos2sv.play = True
gl.add(glRasterPos2sv)

glRasterPos3d = Function('glRasterPos3d')
glRasterPos3d.ret = Return('void')
glRasterPos3d.add( Input( 'x','GLdouble' ))
glRasterPos3d.add( Input( 'y','GLdouble' ))
glRasterPos3d.add( Input( 'z','GLdouble' ))
glRasterPos3d.version = '1.0'
glRasterPos3d.category = 'GL_VERSION_1_0'
glRasterPos3d.trace = True
glRasterPos3d.play = True
gl.add(glRasterPos3d)

glRasterPos3dv = Function('glRasterPos3dv')
glRasterPos3dv.ret = Return('void')
glRasterPos3dv.add( Input( 'v','const GLdouble *' ,size = 3 ))
glRasterPos3dv.version = '1.0'
glRasterPos3dv.category = 'GL_VERSION_1_0'
glRasterPos3dv.trace = True
glRasterPos3dv.play = True
gl.add(glRasterPos3dv)

glRasterPos3f = Function('glRasterPos3f')
glRasterPos3f.ret = Return('void')
glRasterPos3f.add( Input( 'x','GLfloat' ))
glRasterPos3f.add( Input( 'y','GLfloat' ))
glRasterPos3f.add( Input( 'z','GLfloat' ))
glRasterPos3f.version = '1.0'
glRasterPos3f.category = 'GL_VERSION_1_0'
glRasterPos3f.trace = True
glRasterPos3f.play = True
gl.add(glRasterPos3f)

glRasterPos3fv = Function('glRasterPos3fv')
glRasterPos3fv.ret = Return('void')
glRasterPos3fv.add( Input( 'v','const GLfloat *' ,size = 3 ))
glRasterPos3fv.version = '1.0'
glRasterPos3fv.category = 'GL_VERSION_1_0'
glRasterPos3fv.trace = True
glRasterPos3fv.play = True
gl.add(glRasterPos3fv)

glRasterPos3i = Function('glRasterPos3i')
glRasterPos3i.ret = Return('void')
glRasterPos3i.add( Input( 'x','GLint' ))
glRasterPos3i.add( Input( 'y','GLint' ))
glRasterPos3i.add( Input( 'z','GLint' ))
glRasterPos3i.version = '1.0'
glRasterPos3i.category = 'GL_VERSION_1_0'
glRasterPos3i.trace = True
glRasterPos3i.play = True
gl.add(glRasterPos3i)

glRasterPos3iv = Function('glRasterPos3iv')
glRasterPos3iv.ret = Return('void')
glRasterPos3iv.add( Input( 'v','const GLint *' ,size = 3 ))
glRasterPos3iv.version = '1.0'
glRasterPos3iv.category = 'GL_VERSION_1_0'
glRasterPos3iv.trace = True
glRasterPos3iv.play = True
gl.add(glRasterPos3iv)

glRasterPos3s = Function('glRasterPos3s')
glRasterPos3s.ret = Return('void')
glRasterPos3s.add( Input( 'x','GLshort' ))
glRasterPos3s.add( Input( 'y','GLshort' ))
glRasterPos3s.add( Input( 'z','GLshort' ))
glRasterPos3s.version = '1.0'
glRasterPos3s.category = 'GL_VERSION_1_0'
glRasterPos3s.trace = True
glRasterPos3s.play = True
gl.add(glRasterPos3s)

glRasterPos3sv = Function('glRasterPos3sv')
glRasterPos3sv.ret = Return('void')
glRasterPos3sv.add( Input( 'v','const GLshort *' ,size = 3 ))
glRasterPos3sv.version = '1.0'
glRasterPos3sv.category = 'GL_VERSION_1_0'
glRasterPos3sv.trace = True
glRasterPos3sv.play = True
gl.add(glRasterPos3sv)

glRasterPos4d = Function('glRasterPos4d')
glRasterPos4d.ret = Return('void')
glRasterPos4d.add( Input( 'x','GLdouble' ))
glRasterPos4d.add( Input( 'y','GLdouble' ))
glRasterPos4d.add( Input( 'z','GLdouble' ))
glRasterPos4d.add( Input( 'w','GLdouble' ))
glRasterPos4d.version = '1.0'
glRasterPos4d.category = 'GL_VERSION_1_0'
glRasterPos4d.trace = True
glRasterPos4d.play = True
gl.add(glRasterPos4d)

glRasterPos4dv = Function('glRasterPos4dv')
glRasterPos4dv.ret = Return('void')
glRasterPos4dv.add( Input( 'v','const GLdouble *' ,size = 4 ))
glRasterPos4dv.version = '1.0'
glRasterPos4dv.category = 'GL_VERSION_1_0'
glRasterPos4dv.trace = True
glRasterPos4dv.play = True
gl.add(glRasterPos4dv)

glRasterPos4f = Function('glRasterPos4f')
glRasterPos4f.ret = Return('void')
glRasterPos4f.add( Input( 'x','GLfloat' ))
glRasterPos4f.add( Input( 'y','GLfloat' ))
glRasterPos4f.add( Input( 'z','GLfloat' ))
glRasterPos4f.add( Input( 'w','GLfloat' ))
glRasterPos4f.version = '1.0'
glRasterPos4f.category = 'GL_VERSION_1_0'
glRasterPos4f.trace = True
glRasterPos4f.play = True
gl.add(glRasterPos4f)

glRasterPos4fv = Function('glRasterPos4fv')
glRasterPos4fv.ret = Return('void')
glRasterPos4fv.add( Input( 'v','const GLfloat *' ,size = 4 ))
glRasterPos4fv.version = '1.0'
glRasterPos4fv.category = 'GL_VERSION_1_0'
glRasterPos4fv.trace = True
glRasterPos4fv.play = True
gl.add(glRasterPos4fv)

glRasterPos4i = Function('glRasterPos4i')
glRasterPos4i.ret = Return('void')
glRasterPos4i.add( Input( 'x','GLint' ))
glRasterPos4i.add( Input( 'y','GLint' ))
glRasterPos4i.add( Input( 'z','GLint' ))
glRasterPos4i.add( Input( 'w','GLint' ))
glRasterPos4i.version = '1.0'
glRasterPos4i.category = 'GL_VERSION_1_0'
glRasterPos4i.trace = True
glRasterPos4i.play = True
gl.add(glRasterPos4i)

glRasterPos4iv = Function('glRasterPos4iv')
glRasterPos4iv.ret = Return('void')
glRasterPos4iv.add( Input( 'v','const GLint *' ,size = 4 ))
glRasterPos4iv.version = '1.0'
glRasterPos4iv.category = 'GL_VERSION_1_0'
glRasterPos4iv.trace = True
glRasterPos4iv.play = True
gl.add(glRasterPos4iv)

glRasterPos4s = Function('glRasterPos4s')
glRasterPos4s.ret = Return('void')
glRasterPos4s.add( Input( 'x','GLshort' ))
glRasterPos4s.add( Input( 'y','GLshort' ))
glRasterPos4s.add( Input( 'z','GLshort' ))
glRasterPos4s.add( Input( 'w','GLshort' ))
glRasterPos4s.version = '1.0'
glRasterPos4s.category = 'GL_VERSION_1_0'
glRasterPos4s.trace = True
glRasterPos4s.play = True
gl.add(glRasterPos4s)

glRasterPos4sv = Function('glRasterPos4sv')
glRasterPos4sv.ret = Return('void')
glRasterPos4sv.add( Input( 'v','const GLshort *' ,size = 4 ))
glRasterPos4sv.version = '1.0'
glRasterPos4sv.category = 'GL_VERSION_1_0'
glRasterPos4sv.trace = True
glRasterPos4sv.play = True
gl.add(glRasterPos4sv)

glReadBuffer = Function('glReadBuffer')
glReadBuffer.ret = Return('void')
glReadBuffer.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glReadBuffer.version = '1.0'
glReadBuffer.category = 'GL_VERSION_1_0'
glReadBuffer.trace = True
glReadBuffer.play = True
gl.add(glReadBuffer)

glReadPixels = Function('glReadPixels')
glReadPixels.ret = Return('void')
glReadPixels.add( Input( 'x','GLint' ))
glReadPixels.add( Input( 'y','GLint' ))
glReadPixels.add( Input( 'width','GLsizei' ))
glReadPixels.add( Input( 'height','GLsizei' ))
glReadPixels.add( Input( 'format','GLenum' ))
glReadPixels.add( Input( 'type','GLenum' ))
glReadPixels.add( Output( 'pixels','GLvoid *' ,size = 'helperGLPixelImageSize(width, height, 0, format, type, 1, 0)' ,cast = 'GLubyte *' ))
glReadPixels.version = '1.0'
glReadPixels.category = 'GL_VERSION_1_0'
glReadPixels.esVersions = [1.0, 1.1, 2.0]
glReadPixels.trace = True
glReadPixels.play = True
gl.add(glReadPixels)

glRectd = Function('glRectd')
glRectd.ret = Return('void')
glRectd.add( Input( 'x1','GLdouble' ))
glRectd.add( Input( 'y1','GLdouble' ))
glRectd.add( Input( 'x2','GLdouble' ))
glRectd.add( Input( 'y2','GLdouble' ))
glRectd.version = '1.0'
glRectd.category = 'GL_VERSION_1_0'
glRectd.trace = True
glRectd.play = True
gl.add(glRectd)

glRectdv = Function('glRectdv')
glRectdv.ret = Return('void')
glRectdv.add( Input( 'v1','const GLdouble *' ,size = 2 ))
glRectdv.add( Input( 'v2','const GLdouble *' ,size = 2 ))
glRectdv.version = '1.0'
glRectdv.category = 'GL_VERSION_1_0'
glRectdv.trace = True
glRectdv.play = True
gl.add(glRectdv)

glRectf = Function('glRectf')
glRectf.ret = Return('void')
glRectf.add( Input( 'x1','GLfloat' ))
glRectf.add( Input( 'y1','GLfloat' ))
glRectf.add( Input( 'x2','GLfloat' ))
glRectf.add( Input( 'y2','GLfloat' ))
glRectf.version = '1.0'
glRectf.category = 'GL_VERSION_1_0'
glRectf.trace = True
glRectf.play = True
gl.add(glRectf)

glRectfv = Function('glRectfv')
glRectfv.ret = Return('void')
glRectfv.add( Input( 'v1','const GLfloat *' ,size = 2 ))
glRectfv.add( Input( 'v2','const GLfloat *' ,size = 2 ))
glRectfv.version = '1.0'
glRectfv.category = 'GL_VERSION_1_0'
glRectfv.trace = True
glRectfv.play = True
gl.add(glRectfv)

glRecti = Function('glRecti')
glRecti.ret = Return('void')
glRecti.add( Input( 'x1','GLint' ))
glRecti.add( Input( 'y1','GLint' ))
glRecti.add( Input( 'x2','GLint' ))
glRecti.add( Input( 'y2','GLint' ))
glRecti.version = '1.0'
glRecti.category = 'GL_VERSION_1_0'
glRecti.trace = True
glRecti.play = True
gl.add(glRecti)

glRectiv = Function('glRectiv')
glRectiv.ret = Return('void')
glRectiv.add( Input( 'v1','const GLint *' ,size = 2 ))
glRectiv.add( Input( 'v2','const GLint *' ,size = 2 ))
glRectiv.version = '1.0'
glRectiv.category = 'GL_VERSION_1_0'
glRectiv.trace = True
glRectiv.play = True
gl.add(glRectiv)

glRects = Function('glRects')
glRects.ret = Return('void')
glRects.add( Input( 'x1','GLshort' ))
glRects.add( Input( 'y1','GLshort' ))
glRects.add( Input( 'x2','GLshort' ))
glRects.add( Input( 'y2','GLshort' ))
glRects.version = '1.0'
glRects.category = 'GL_VERSION_1_0'
glRects.trace = True
glRects.play = True
gl.add(glRects)

glRectsv = Function('glRectsv')
glRectsv.ret = Return('void')
glRectsv.add( Input( 'v1','const GLshort *' ,size = 2 ))
glRectsv.add( Input( 'v2','const GLshort *' ,size = 2 ))
glRectsv.version = '1.0'
glRectsv.category = 'GL_VERSION_1_0'
glRectsv.trace = True
glRectsv.play = True
gl.add(glRectsv)

glRenderMode = Function('glRenderMode')
glRenderMode.ret = Return('GLint')
glRenderMode.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glRenderMode.version = '1.0'
glRenderMode.category = 'GL_VERSION_1_0'
glRenderMode.trace = True
glRenderMode.play = True
gl.add(glRenderMode)

glRotated = Function('glRotated')
glRotated.ret = Return('void')
glRotated.add( Input( 'angle','GLdouble' ))
glRotated.add( Input( 'x','GLdouble' ))
glRotated.add( Input( 'y','GLdouble' ))
glRotated.add( Input( 'z','GLdouble' ))
glRotated.version = '1.0'
glRotated.category = 'GL_VERSION_1_0'
glRotated.trace = True
glRotated.play = True
gl.add(glRotated)

glRotatef = Function('glRotatef')
glRotatef.ret = Return('void')
glRotatef.add( Input( 'angle','GLfloat' ))
glRotatef.add( Input( 'x','GLfloat' ))
glRotatef.add( Input( 'y','GLfloat' ))
glRotatef.add( Input( 'z','GLfloat' ))
glRotatef.version = '1.0'
glRotatef.category = 'GL_VERSION_1_0'
glRotatef.esVersions = [1.0, 1.1]
glRotatef.trace = True
glRotatef.play = True
gl.add(glRotatef)

glScaled = Function('glScaled')
glScaled.ret = Return('void')
glScaled.add( Input( 'x','GLdouble' ))
glScaled.add( Input( 'y','GLdouble' ))
glScaled.add( Input( 'z','GLdouble' ))
glScaled.version = '1.0'
glScaled.category = 'GL_VERSION_1_0'
glScaled.trace = True
glScaled.play = True
gl.add(glScaled)

glScalef = Function('glScalef')
glScalef.ret = Return('void')
glScalef.add( Input( 'x','GLfloat' ))
glScalef.add( Input( 'y','GLfloat' ))
glScalef.add( Input( 'z','GLfloat' ))
glScalef.version = '1.0'
glScalef.category = 'GL_VERSION_1_0'
glScalef.esVersions = [1.0, 1.1]
glScalef.trace = True
glScalef.play = True
gl.add(glScalef)

glScissor = Function('glScissor')
glScissor.ret = Return('void')
glScissor.add( Input( 'x','GLint' ))
glScissor.add( Input( 'y','GLint' ))
glScissor.add( Input( 'width','GLsizei' ))
glScissor.add( Input( 'height','GLsizei' ))
glScissor.version = '1.0'
glScissor.category = 'GL_VERSION_1_0'
glScissor.esVersions = [1.0, 1.1, 2.0]
glScissor.trace = True
glScissor.play = True
gl.add(glScissor)

glSelectBuffer = Function('glSelectBuffer')
glSelectBuffer.ret = Return('void')
glSelectBuffer.add( Input( 'size','GLsizei' ))
glSelectBuffer.add( Output( 'buffer','GLuint *' ,size = 'size' ))
glSelectBuffer.version = '1.0'
glSelectBuffer.category = 'GL_VERSION_1_0'
glSelectBuffer.trace = True
glSelectBuffer.play = True
gl.add(glSelectBuffer)

glShadeModel = Function('glShadeModel')
glShadeModel.ret = Return('void')
glShadeModel.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glShadeModel.version = '1.0'
glShadeModel.category = 'GL_VERSION_1_0'
glShadeModel.esVersions = [1.0, 1.1]
glShadeModel.trace = True
glShadeModel.play = True
gl.add(glShadeModel)

glStencilFunc = Function('glStencilFunc')
glStencilFunc.ret = Return('void')
glStencilFunc.add( Input( 'func','GLenum' ))
glStencilFunc.add( Input( 'ref','GLint' ,regalLog = 'boost::print::hex(ref)' ))
glStencilFunc.add( Input( 'mask','GLuint' ,regalLog = 'boost::print::hex(mask)' ))
glStencilFunc.version = '1.0'
glStencilFunc.category = 'GL_VERSION_1_0'
glStencilFunc.esVersions = [1.0, 1.1, 2.0]
glStencilFunc.trace = True
glStencilFunc.play = True
gl.add(glStencilFunc)

glStencilMask = Function('glStencilMask')
glStencilMask.ret = Return('void')
glStencilMask.add( Input( 'mask','GLuint' ,regalLog = 'boost::print::hex(mask)' ))
glStencilMask.version = '1.0'
glStencilMask.category = 'GL_VERSION_1_0'
glStencilMask.esVersions = [1.0, 1.1, 2.0]
glStencilMask.trace = True
glStencilMask.play = True
gl.add(glStencilMask)

glStencilOp = Function('glStencilOp')
glStencilOp.ret = Return('void')
glStencilOp.add( Input( 'fail','GLenum' ))
glStencilOp.add( Input( 'zfail','GLenum' ))
glStencilOp.add( Input( 'zpass','GLenum' ))
glStencilOp.version = '1.0'
glStencilOp.category = 'GL_VERSION_1_0'
glStencilOp.esVersions = [1.0, 1.1, 2.0]
glStencilOp.trace = True
glStencilOp.play = True
gl.add(glStencilOp)

glTexCoord1d = Function('glTexCoord1d')
glTexCoord1d.ret = Return('void')
glTexCoord1d.add( Input( 's','GLdouble' ))
glTexCoord1d.version = '1.0'
glTexCoord1d.category = 'GL_VERSION_1_0'
glTexCoord1d.trace = True
glTexCoord1d.play = True
gl.add(glTexCoord1d)

glTexCoord1dv = Function('glTexCoord1dv')
glTexCoord1dv.ret = Return('void')
glTexCoord1dv.add( Input( 'v','const GLdouble *' ,size = 1 ))
glTexCoord1dv.version = '1.0'
glTexCoord1dv.category = 'GL_VERSION_1_0'
glTexCoord1dv.trace = True
glTexCoord1dv.play = True
gl.add(glTexCoord1dv)

glTexCoord1f = Function('glTexCoord1f')
glTexCoord1f.ret = Return('void')
glTexCoord1f.add( Input( 's','GLfloat' ))
glTexCoord1f.version = '1.0'
glTexCoord1f.category = 'GL_VERSION_1_0'
glTexCoord1f.trace = True
glTexCoord1f.play = True
gl.add(glTexCoord1f)

glTexCoord1fv = Function('glTexCoord1fv')
glTexCoord1fv.ret = Return('void')
glTexCoord1fv.add( Input( 'v','const GLfloat *' ,size = 1 ))
glTexCoord1fv.version = '1.0'
glTexCoord1fv.category = 'GL_VERSION_1_0'
glTexCoord1fv.trace = True
glTexCoord1fv.play = True
gl.add(glTexCoord1fv)

glTexCoord1i = Function('glTexCoord1i')
glTexCoord1i.ret = Return('void')
glTexCoord1i.add( Input( 's','GLint' ))
glTexCoord1i.version = '1.0'
glTexCoord1i.category = 'GL_VERSION_1_0'
glTexCoord1i.trace = True
glTexCoord1i.play = True
gl.add(glTexCoord1i)

glTexCoord1iv = Function('glTexCoord1iv')
glTexCoord1iv.ret = Return('void')
glTexCoord1iv.add( Input( 'v','const GLint *' ,size = 1 ))
glTexCoord1iv.version = '1.0'
glTexCoord1iv.category = 'GL_VERSION_1_0'
glTexCoord1iv.trace = True
glTexCoord1iv.play = True
gl.add(glTexCoord1iv)

glTexCoord1s = Function('glTexCoord1s')
glTexCoord1s.ret = Return('void')
glTexCoord1s.add( Input( 's','GLshort' ))
glTexCoord1s.version = '1.0'
glTexCoord1s.category = 'GL_VERSION_1_0'
glTexCoord1s.trace = True
glTexCoord1s.play = True
gl.add(glTexCoord1s)

glTexCoord1sv = Function('glTexCoord1sv')
glTexCoord1sv.ret = Return('void')
glTexCoord1sv.add( Input( 'v','const GLshort *' ,size = 1 ))
glTexCoord1sv.version = '1.0'
glTexCoord1sv.category = 'GL_VERSION_1_0'
glTexCoord1sv.trace = True
glTexCoord1sv.play = True
gl.add(glTexCoord1sv)

glTexCoord2d = Function('glTexCoord2d')
glTexCoord2d.ret = Return('void')
glTexCoord2d.add( Input( 's','GLdouble' ))
glTexCoord2d.add( Input( 't','GLdouble' ))
glTexCoord2d.version = '1.0'
glTexCoord2d.category = 'GL_VERSION_1_0'
glTexCoord2d.trace = True
glTexCoord2d.play = True
gl.add(glTexCoord2d)

glTexCoord2dv = Function('glTexCoord2dv')
glTexCoord2dv.ret = Return('void')
glTexCoord2dv.add( Input( 'v','const GLdouble *' ,size = 2 ))
glTexCoord2dv.version = '1.0'
glTexCoord2dv.category = 'GL_VERSION_1_0'
glTexCoord2dv.trace = True
glTexCoord2dv.play = True
gl.add(glTexCoord2dv)

glTexCoord2f = Function('glTexCoord2f')
glTexCoord2f.ret = Return('void')
glTexCoord2f.add( Input( 's','GLfloat' ))
glTexCoord2f.add( Input( 't','GLfloat' ))
glTexCoord2f.version = '1.0'
glTexCoord2f.category = 'GL_VERSION_1_0'
glTexCoord2f.trace = True
glTexCoord2f.play = True
gl.add(glTexCoord2f)

glTexCoord2fv = Function('glTexCoord2fv')
glTexCoord2fv.ret = Return('void')
glTexCoord2fv.add( Input( 'v','const GLfloat *' ,size = 2 ))
glTexCoord2fv.version = '1.0'
glTexCoord2fv.category = 'GL_VERSION_1_0'
glTexCoord2fv.trace = True
glTexCoord2fv.play = True
gl.add(glTexCoord2fv)

glTexCoord2i = Function('glTexCoord2i')
glTexCoord2i.ret = Return('void')
glTexCoord2i.add( Input( 's','GLint' ))
glTexCoord2i.add( Input( 't','GLint' ))
glTexCoord2i.version = '1.0'
glTexCoord2i.category = 'GL_VERSION_1_0'
glTexCoord2i.trace = True
glTexCoord2i.play = True
gl.add(glTexCoord2i)

glTexCoord2iv = Function('glTexCoord2iv')
glTexCoord2iv.ret = Return('void')
glTexCoord2iv.add( Input( 'v','const GLint *' ,size = 2 ))
glTexCoord2iv.version = '1.0'
glTexCoord2iv.category = 'GL_VERSION_1_0'
glTexCoord2iv.trace = True
glTexCoord2iv.play = True
gl.add(glTexCoord2iv)

glTexCoord2s = Function('glTexCoord2s')
glTexCoord2s.ret = Return('void')
glTexCoord2s.add( Input( 's','GLshort' ))
glTexCoord2s.add( Input( 't','GLshort' ))
glTexCoord2s.version = '1.0'
glTexCoord2s.category = 'GL_VERSION_1_0'
glTexCoord2s.trace = True
glTexCoord2s.play = True
gl.add(glTexCoord2s)

glTexCoord2sv = Function('glTexCoord2sv')
glTexCoord2sv.ret = Return('void')
glTexCoord2sv.add( Input( 'v','const GLshort *' ,size = 2 ))
glTexCoord2sv.version = '1.0'
glTexCoord2sv.category = 'GL_VERSION_1_0'
glTexCoord2sv.trace = True
glTexCoord2sv.play = True
gl.add(glTexCoord2sv)

glTexCoord3d = Function('glTexCoord3d')
glTexCoord3d.ret = Return('void')
glTexCoord3d.add( Input( 's','GLdouble' ))
glTexCoord3d.add( Input( 't','GLdouble' ))
glTexCoord3d.add( Input( 'r','GLdouble' ))
glTexCoord3d.version = '1.0'
glTexCoord3d.category = 'GL_VERSION_1_0'
glTexCoord3d.trace = True
glTexCoord3d.play = True
gl.add(glTexCoord3d)

glTexCoord3dv = Function('glTexCoord3dv')
glTexCoord3dv.ret = Return('void')
glTexCoord3dv.add( Input( 'v','const GLdouble *' ,size = 3 ))
glTexCoord3dv.version = '1.0'
glTexCoord3dv.category = 'GL_VERSION_1_0'
glTexCoord3dv.trace = True
glTexCoord3dv.play = True
gl.add(glTexCoord3dv)

glTexCoord3f = Function('glTexCoord3f')
glTexCoord3f.ret = Return('void')
glTexCoord3f.add( Input( 's','GLfloat' ))
glTexCoord3f.add( Input( 't','GLfloat' ))
glTexCoord3f.add( Input( 'r','GLfloat' ))
glTexCoord3f.version = '1.0'
glTexCoord3f.category = 'GL_VERSION_1_0'
glTexCoord3f.trace = True
glTexCoord3f.play = True
gl.add(glTexCoord3f)

glTexCoord3fv = Function('glTexCoord3fv')
glTexCoord3fv.ret = Return('void')
glTexCoord3fv.add( Input( 'v','const GLfloat *' ,size = 3 ))
glTexCoord3fv.version = '1.0'
glTexCoord3fv.category = 'GL_VERSION_1_0'
glTexCoord3fv.trace = True
glTexCoord3fv.play = True
gl.add(glTexCoord3fv)

glTexCoord3i = Function('glTexCoord3i')
glTexCoord3i.ret = Return('void')
glTexCoord3i.add( Input( 's','GLint' ))
glTexCoord3i.add( Input( 't','GLint' ))
glTexCoord3i.add( Input( 'r','GLint' ))
glTexCoord3i.version = '1.0'
glTexCoord3i.category = 'GL_VERSION_1_0'
glTexCoord3i.trace = True
glTexCoord3i.play = True
gl.add(glTexCoord3i)

glTexCoord3iv = Function('glTexCoord3iv')
glTexCoord3iv.ret = Return('void')
glTexCoord3iv.add( Input( 'v','const GLint *' ,size = 3 ))
glTexCoord3iv.version = '1.0'
glTexCoord3iv.category = 'GL_VERSION_1_0'
glTexCoord3iv.trace = True
glTexCoord3iv.play = True
gl.add(glTexCoord3iv)

glTexCoord3s = Function('glTexCoord3s')
glTexCoord3s.ret = Return('void')
glTexCoord3s.add( Input( 's','GLshort' ))
glTexCoord3s.add( Input( 't','GLshort' ))
glTexCoord3s.add( Input( 'r','GLshort' ))
glTexCoord3s.version = '1.0'
glTexCoord3s.category = 'GL_VERSION_1_0'
glTexCoord3s.trace = True
glTexCoord3s.play = True
gl.add(glTexCoord3s)

glTexCoord3sv = Function('glTexCoord3sv')
glTexCoord3sv.ret = Return('void')
glTexCoord3sv.add( Input( 'v','const GLshort *' ,size = 3 ))
glTexCoord3sv.version = '1.0'
glTexCoord3sv.category = 'GL_VERSION_1_0'
glTexCoord3sv.trace = True
glTexCoord3sv.play = True
gl.add(glTexCoord3sv)

glTexCoord4d = Function('glTexCoord4d')
glTexCoord4d.ret = Return('void')
glTexCoord4d.add( Input( 's','GLdouble' ))
glTexCoord4d.add( Input( 't','GLdouble' ))
glTexCoord4d.add( Input( 'r','GLdouble' ))
glTexCoord4d.add( Input( 'q','GLdouble' ))
glTexCoord4d.version = '1.0'
glTexCoord4d.category = 'GL_VERSION_1_0'
glTexCoord4d.trace = True
glTexCoord4d.play = True
gl.add(glTexCoord4d)

glTexCoord4dv = Function('glTexCoord4dv')
glTexCoord4dv.ret = Return('void')
glTexCoord4dv.add( Input( 'v','const GLdouble *' ,size = 4 ))
glTexCoord4dv.version = '1.0'
glTexCoord4dv.category = 'GL_VERSION_1_0'
glTexCoord4dv.trace = True
glTexCoord4dv.play = True
gl.add(glTexCoord4dv)

glTexCoord4f = Function('glTexCoord4f')
glTexCoord4f.ret = Return('void')
glTexCoord4f.add( Input( 's','GLfloat' ))
glTexCoord4f.add( Input( 't','GLfloat' ))
glTexCoord4f.add( Input( 'r','GLfloat' ))
glTexCoord4f.add( Input( 'q','GLfloat' ))
glTexCoord4f.version = '1.0'
glTexCoord4f.category = 'GL_VERSION_1_0'
glTexCoord4f.trace = True
glTexCoord4f.play = True
gl.add(glTexCoord4f)

glTexCoord4fv = Function('glTexCoord4fv')
glTexCoord4fv.ret = Return('void')
glTexCoord4fv.add( Input( 'v','const GLfloat *' ,size = 4 ))
glTexCoord4fv.version = '1.0'
glTexCoord4fv.category = 'GL_VERSION_1_0'
glTexCoord4fv.trace = True
glTexCoord4fv.play = True
gl.add(glTexCoord4fv)

glTexCoord4i = Function('glTexCoord4i')
glTexCoord4i.ret = Return('void')
glTexCoord4i.add( Input( 's','GLint' ))
glTexCoord4i.add( Input( 't','GLint' ))
glTexCoord4i.add( Input( 'r','GLint' ))
glTexCoord4i.add( Input( 'q','GLint' ))
glTexCoord4i.version = '1.0'
glTexCoord4i.category = 'GL_VERSION_1_0'
glTexCoord4i.trace = True
glTexCoord4i.play = True
gl.add(glTexCoord4i)

glTexCoord4iv = Function('glTexCoord4iv')
glTexCoord4iv.ret = Return('void')
glTexCoord4iv.add( Input( 'v','const GLint *' ,size = 4 ))
glTexCoord4iv.version = '1.0'
glTexCoord4iv.category = 'GL_VERSION_1_0'
glTexCoord4iv.trace = True
glTexCoord4iv.play = True
gl.add(glTexCoord4iv)

glTexCoord4s = Function('glTexCoord4s')
glTexCoord4s.ret = Return('void')
glTexCoord4s.add( Input( 's','GLshort' ))
glTexCoord4s.add( Input( 't','GLshort' ))
glTexCoord4s.add( Input( 'r','GLshort' ))
glTexCoord4s.add( Input( 'q','GLshort' ))
glTexCoord4s.version = '1.0'
glTexCoord4s.category = 'GL_VERSION_1_0'
glTexCoord4s.trace = True
glTexCoord4s.play = True
gl.add(glTexCoord4s)

glTexCoord4sv = Function('glTexCoord4sv')
glTexCoord4sv.ret = Return('void')
glTexCoord4sv.add( Input( 'v','const GLshort *' ,size = 4 ))
glTexCoord4sv.version = '1.0'
glTexCoord4sv.category = 'GL_VERSION_1_0'
glTexCoord4sv.trace = True
glTexCoord4sv.play = True
gl.add(glTexCoord4sv)

glTexEnvf = Function('glTexEnvf')
glTexEnvf.ret = Return('void')
glTexEnvf.add( Input( 'target','GLenum' ))
glTexEnvf.add( Input( 'pname','GLenum' ))
glTexEnvf.add( Input( 'param','GLfloat' ))
glTexEnvf.version = '1.0'
glTexEnvf.category = 'GL_VERSION_1_0'
glTexEnvf.esVersions = [1.0, 1.1]
glTexEnvf.trace = True
glTexEnvf.play = True
gl.add(glTexEnvf)

glTexEnvfv = Function('glTexEnvfv')
glTexEnvfv.ret = Return('void')
glTexEnvfv.add( Input( 'target','GLenum' ))
glTexEnvfv.add( Input( 'pname','GLenum' ))
glTexEnvfv.add( Input( 'params','const GLfloat *' ,size = 'helperGLTexEnvvSize(target, pname)' ))
glTexEnvfv.version = '1.0'
glTexEnvfv.category = 'GL_VERSION_1_0'
glTexEnvfv.esVersions = [1.0, 1.1]
glTexEnvfv.trace = True
glTexEnvfv.play = True
gl.add(glTexEnvfv)

glTexEnvi = Function('glTexEnvi')
glTexEnvi.ret = Return('void')
glTexEnvi.add( Input( 'target','GLenum' ))
glTexEnvi.add( Input( 'pname','GLenum' ))
glTexEnvi.add( Input( 'param','GLint' ))
glTexEnvi.version = '1.0'
glTexEnvi.category = 'GL_VERSION_1_0'
glTexEnvi.esVersions = [1.1]
glTexEnvi.trace = True
glTexEnvi.play = True
gl.add(glTexEnvi)

glTexEnviv = Function('glTexEnviv')
glTexEnviv.ret = Return('void')
glTexEnviv.add( Input( 'target','GLenum' ))
glTexEnviv.add( Input( 'pname','GLenum' ))
glTexEnviv.add( Input( 'params','const GLint *' ,size = 'helperGLTexEnvvSize(target, pname)' ))
glTexEnviv.version = '1.0'
glTexEnviv.category = 'GL_VERSION_1_0'
glTexEnviv.esVersions = [1.1]
glTexEnviv.trace = True
glTexEnviv.play = True
gl.add(glTexEnviv)

glTexGend = Function('glTexGend')
glTexGend.ret = Return('void')
glTexGend.add( Input( 'coord','GLenum' ))
glTexGend.add( Input( 'pname','GLenum' ))
glTexGend.add( Input( 'param','GLdouble' ))
glTexGend.version = '1.0'
glTexGend.category = 'GL_VERSION_1_0'
glTexGend.trace = True
glTexGend.play = True
gl.add(glTexGend)

glTexGendv = Function('glTexGendv')
glTexGendv.ret = Return('void')
glTexGendv.add( Input( 'coord','GLenum' ))
glTexGendv.add( Input( 'pname','GLenum' ))
glTexGendv.add( Input( 'params','const GLdouble *' ,size = 'helperGLTexGenvSize(pname)' ))
glTexGendv.version = '1.0'
glTexGendv.category = 'GL_VERSION_1_0'
glTexGendv.trace = True
glTexGendv.play = True
gl.add(glTexGendv)

glTexGenf = Function('glTexGenf')
glTexGenf.ret = Return('void')
glTexGenf.add( Input( 'coord','GLenum' ))
glTexGenf.add( Input( 'pname','GLenum' ))
glTexGenf.add( Input( 'param','GLfloat' ))
glTexGenf.version = '1.0'
glTexGenf.category = 'GL_VERSION_1_0'
glTexGenf.trace = True
glTexGenf.play = True
gl.add(glTexGenf)

glTexGenfv = Function('glTexGenfv')
glTexGenfv.ret = Return('void')
glTexGenfv.add( Input( 'coord','GLenum' ))
glTexGenfv.add( Input( 'pname','GLenum' ))
glTexGenfv.add( Input( 'params','const GLfloat *' ,size = 'helperGLTexGenvSize(pname)' ))
glTexGenfv.version = '1.0'
glTexGenfv.category = 'GL_VERSION_1_0'
glTexGenfv.trace = True
glTexGenfv.play = True
gl.add(glTexGenfv)

glTexGeni = Function('glTexGeni')
glTexGeni.ret = Return('void')
glTexGeni.add( Input( 'coord','GLenum' ))
glTexGeni.add( Input( 'pname','GLenum' ))
glTexGeni.add( Input( 'param','GLint' ,regalLog = 'GLenumToString(static_cast<GLenum>(param))' ))
glTexGeni.version = '1.0'
glTexGeni.category = 'GL_VERSION_1_0'
glTexGeni.trace = True
glTexGeni.play = True
gl.add(glTexGeni)

glTexGeniv = Function('glTexGeniv')
glTexGeniv.ret = Return('void')
glTexGeniv.add( Input( 'coord','GLenum' ))
glTexGeniv.add( Input( 'pname','GLenum' ))
glTexGeniv.add( Input( 'params','const GLint *' ,size = 'helperGLTexGenvSize(pname)' ))
glTexGeniv.version = '1.0'
glTexGeniv.category = 'GL_VERSION_1_0'
glTexGeniv.trace = True
glTexGeniv.play = True
gl.add(glTexGeniv)

glTexImage1D = Function('glTexImage1D')
glTexImage1D.ret = Return('void')
glTexImage1D.add( Input( 'target','GLenum' ))
glTexImage1D.add( Input( 'level','GLint' ))
glTexImage1D.add( Input( 'internalformat','GLint' ,regalLog = 'internalFormatToString(internalformat)' ))
glTexImage1D.add( Input( 'width','GLsizei' ))
glTexImage1D.add( Input( 'border','GLint' ))
glTexImage1D.add( Input( 'format','GLenum' ))
glTexImage1D.add( Input( 'type','GLenum' ))
glTexImage1D.add( Input( 'pixels','const GLvoid *' ,size = 'helperGLPixelImageSize(width, 0, 0, format, type, 0, target)' ,cast = 'const GLubyte *' ))
glTexImage1D.version = '1.0'
glTexImage1D.category = 'GL_VERSION_1_0'
glTexImage1D.trace = True
glTexImage1D.play = True
gl.add(glTexImage1D)

glTexImage2D = Function('glTexImage2D')
glTexImage2D.ret = Return('void')
glTexImage2D.add( Input( 'target','GLenum' ))
glTexImage2D.add( Input( 'level','GLint' ))
glTexImage2D.add( Input( 'internalformat','GLint' ,regalLog = 'internalFormatToString(internalformat)' ))
glTexImage2D.add( Input( 'width','GLsizei' ))
glTexImage2D.add( Input( 'height','GLsizei' ))
glTexImage2D.add( Input( 'border','GLint' ))
glTexImage2D.add( Input( 'format','GLenum' ))
glTexImage2D.add( Input( 'type','GLenum' ))
glTexImage2D.add( Input( 'pixels','const GLvoid *' ,size = 'helperGLPixelImageSize(width, height, 0, format, type, 0, target)' ,cast = 'const GLubyte *' ))
glTexImage2D.version = '1.0'
glTexImage2D.category = 'GL_VERSION_1_0'
glTexImage2D.esVersions = [1.0, 1.1, 2.0]
glTexImage2D.trace = True
glTexImage2D.play = True
gl.add(glTexImage2D)

glTexParameterf = Function('glTexParameterf')
glTexParameterf.ret = Return('void')
glTexParameterf.add( Input( 'target','GLenum' ))
glTexParameterf.add( Input( 'pname','GLenum' ))
glTexParameterf.add( Input( 'param','GLfloat' ,regalLog = 'GLTexParameterToString(pname,param)' ))
glTexParameterf.version = '1.0'
glTexParameterf.category = 'GL_VERSION_1_0'
glTexParameterf.esVersions = [1.0, 1.1, 2.0]
glTexParameterf.trace = True
glTexParameterf.play = True
gl.add(glTexParameterf)

glTexParameterfv = Function('glTexParameterfv')
glTexParameterfv.ret = Return('void')
glTexParameterfv.add( Input( 'target','GLenum' ))
glTexParameterfv.add( Input( 'pname','GLenum' ))
glTexParameterfv.add( Input( 'params','const GLfloat *' ,size = 'helperGLTexParametervSize(pname)' ,regalLog = 'GLTexParameterToString(pname,params)' ))
glTexParameterfv.version = '1.0'
glTexParameterfv.category = 'GL_VERSION_1_0'
glTexParameterfv.esVersions = [1.1, 2.0]
glTexParameterfv.trace = True
glTexParameterfv.play = True
gl.add(glTexParameterfv)

glTexParameteri = Function('glTexParameteri')
glTexParameteri.ret = Return('void')
glTexParameteri.add( Input( 'target','GLenum' ))
glTexParameteri.add( Input( 'pname','GLenum' ))
glTexParameteri.add( Input( 'param','GLint' ,regalLog = 'GLTexParameterToString(pname,param)' ))
glTexParameteri.version = '1.0'
glTexParameteri.category = 'GL_VERSION_1_0'
glTexParameteri.esVersions = [1.1, 2.0]
glTexParameteri.trace = True
glTexParameteri.play = True
gl.add(glTexParameteri)

glTexParameteriv = Function('glTexParameteriv')
glTexParameteriv.ret = Return('void')
glTexParameteriv.add( Input( 'target','GLenum' ))
glTexParameteriv.add( Input( 'pname','GLenum' ))
glTexParameteriv.add( Input( 'params','const GLint *' ,size = 'helperGLTexParametervSize(pname)' ,regalLog = 'GLTexParameterToString(pname,params)' ))
glTexParameteriv.version = '1.0'
glTexParameteriv.category = 'GL_VERSION_1_0'
glTexParameteriv.esVersions = [1.1, 2.0]
glTexParameteriv.trace = True
glTexParameteriv.play = True
gl.add(glTexParameteriv)

glTranslated = Function('glTranslated')
glTranslated.ret = Return('void')
glTranslated.add( Input( 'x','GLdouble' ))
glTranslated.add( Input( 'y','GLdouble' ))
glTranslated.add( Input( 'z','GLdouble' ))
glTranslated.version = '1.0'
glTranslated.category = 'GL_VERSION_1_0'
glTranslated.trace = True
glTranslated.play = True
gl.add(glTranslated)

glTranslatef = Function('glTranslatef')
glTranslatef.ret = Return('void')
glTranslatef.add( Input( 'x','GLfloat' ))
glTranslatef.add( Input( 'y','GLfloat' ))
glTranslatef.add( Input( 'z','GLfloat' ))
glTranslatef.version = '1.0'
glTranslatef.category = 'GL_VERSION_1_0'
glTranslatef.esVersions = [1.0, 1.1]
glTranslatef.trace = True
glTranslatef.play = True
gl.add(glTranslatef)

glVertex2d = Function('glVertex2d')
glVertex2d.ret = Return('void')
glVertex2d.add( Input( 'x','GLdouble' ))
glVertex2d.add( Input( 'y','GLdouble' ))
glVertex2d.version = '1.0'
glVertex2d.category = 'GL_VERSION_1_0'
glVertex2d.trace = True
glVertex2d.play = True
gl.add(glVertex2d)

glVertex2dv = Function('glVertex2dv')
glVertex2dv.ret = Return('void')
glVertex2dv.add( Input( 'v','const GLdouble *' ,size = 2 ))
glVertex2dv.version = '1.0'
glVertex2dv.category = 'GL_VERSION_1_0'
glVertex2dv.trace = True
glVertex2dv.play = True
gl.add(glVertex2dv)

glVertex2f = Function('glVertex2f')
glVertex2f.ret = Return('void')
glVertex2f.add( Input( 'x','GLfloat' ))
glVertex2f.add( Input( 'y','GLfloat' ))
glVertex2f.version = '1.0'
glVertex2f.category = 'GL_VERSION_1_0'
glVertex2f.trace = True
glVertex2f.play = True
gl.add(glVertex2f)

glVertex2fv = Function('glVertex2fv')
glVertex2fv.ret = Return('void')
glVertex2fv.add( Input( 'v','const GLfloat *' ,size = 2 ))
glVertex2fv.version = '1.0'
glVertex2fv.category = 'GL_VERSION_1_0'
glVertex2fv.trace = True
glVertex2fv.play = True
gl.add(glVertex2fv)

glVertex2i = Function('glVertex2i')
glVertex2i.ret = Return('void')
glVertex2i.add( Input( 'x','GLint' ))
glVertex2i.add( Input( 'y','GLint' ))
glVertex2i.version = '1.0'
glVertex2i.category = 'GL_VERSION_1_0'
glVertex2i.trace = True
glVertex2i.play = True
gl.add(glVertex2i)

glVertex2iv = Function('glVertex2iv')
glVertex2iv.ret = Return('void')
glVertex2iv.add( Input( 'v','const GLint *' ,size = 2 ))
glVertex2iv.version = '1.0'
glVertex2iv.category = 'GL_VERSION_1_0'
glVertex2iv.trace = True
glVertex2iv.play = True
gl.add(glVertex2iv)

glVertex2s = Function('glVertex2s')
glVertex2s.ret = Return('void')
glVertex2s.add( Input( 'x','GLshort' ))
glVertex2s.add( Input( 'y','GLshort' ))
glVertex2s.version = '1.0'
glVertex2s.category = 'GL_VERSION_1_0'
glVertex2s.trace = True
glVertex2s.play = True
gl.add(glVertex2s)

glVertex2sv = Function('glVertex2sv')
glVertex2sv.ret = Return('void')
glVertex2sv.add( Input( 'v','const GLshort *' ,size = 2 ))
glVertex2sv.version = '1.0'
glVertex2sv.category = 'GL_VERSION_1_0'
glVertex2sv.trace = True
glVertex2sv.play = True
gl.add(glVertex2sv)

glVertex3d = Function('glVertex3d')
glVertex3d.ret = Return('void')
glVertex3d.add( Input( 'x','GLdouble' ))
glVertex3d.add( Input( 'y','GLdouble' ))
glVertex3d.add( Input( 'z','GLdouble' ))
glVertex3d.version = '1.0'
glVertex3d.category = 'GL_VERSION_1_0'
glVertex3d.trace = True
glVertex3d.play = True
gl.add(glVertex3d)

glVertex3dv = Function('glVertex3dv')
glVertex3dv.ret = Return('void')
glVertex3dv.add( Input( 'v','const GLdouble *' ,size = 3 ))
glVertex3dv.version = '1.0'
glVertex3dv.category = 'GL_VERSION_1_0'
glVertex3dv.trace = True
glVertex3dv.play = True
gl.add(glVertex3dv)

glVertex3f = Function('glVertex3f')
glVertex3f.ret = Return('void')
glVertex3f.add( Input( 'x','GLfloat' ))
glVertex3f.add( Input( 'y','GLfloat' ))
glVertex3f.add( Input( 'z','GLfloat' ))
glVertex3f.version = '1.0'
glVertex3f.category = 'GL_VERSION_1_0'
glVertex3f.trace = True
glVertex3f.play = True
gl.add(glVertex3f)

glVertex3fv = Function('glVertex3fv')
glVertex3fv.ret = Return('void')
glVertex3fv.add( Input( 'v','const GLfloat *' ,size = 3 ))
glVertex3fv.version = '1.0'
glVertex3fv.category = 'GL_VERSION_1_0'
glVertex3fv.trace = True
glVertex3fv.play = True
gl.add(glVertex3fv)

glVertex3i = Function('glVertex3i')
glVertex3i.ret = Return('void')
glVertex3i.add( Input( 'x','GLint' ))
glVertex3i.add( Input( 'y','GLint' ))
glVertex3i.add( Input( 'z','GLint' ))
glVertex3i.version = '1.0'
glVertex3i.category = 'GL_VERSION_1_0'
glVertex3i.trace = True
glVertex3i.play = True
gl.add(glVertex3i)

glVertex3iv = Function('glVertex3iv')
glVertex3iv.ret = Return('void')
glVertex3iv.add( Input( 'v','const GLint *' ,size = 3 ))
glVertex3iv.version = '1.0'
glVertex3iv.category = 'GL_VERSION_1_0'
glVertex3iv.trace = True
glVertex3iv.play = True
gl.add(glVertex3iv)

glVertex3s = Function('glVertex3s')
glVertex3s.ret = Return('void')
glVertex3s.add( Input( 'x','GLshort' ))
glVertex3s.add( Input( 'y','GLshort' ))
glVertex3s.add( Input( 'z','GLshort' ))
glVertex3s.version = '1.0'
glVertex3s.category = 'GL_VERSION_1_0'
glVertex3s.trace = True
glVertex3s.play = True
gl.add(glVertex3s)

glVertex3sv = Function('glVertex3sv')
glVertex3sv.ret = Return('void')
glVertex3sv.add( Input( 'v','const GLshort *' ,size = 3 ))
glVertex3sv.version = '1.0'
glVertex3sv.category = 'GL_VERSION_1_0'
glVertex3sv.trace = True
glVertex3sv.play = True
gl.add(glVertex3sv)

glVertex4d = Function('glVertex4d')
glVertex4d.ret = Return('void')
glVertex4d.add( Input( 'x','GLdouble' ))
glVertex4d.add( Input( 'y','GLdouble' ))
glVertex4d.add( Input( 'z','GLdouble' ))
glVertex4d.add( Input( 'w','GLdouble' ))
glVertex4d.version = '1.0'
glVertex4d.category = 'GL_VERSION_1_0'
glVertex4d.trace = True
glVertex4d.play = True
gl.add(glVertex4d)

glVertex4dv = Function('glVertex4dv')
glVertex4dv.ret = Return('void')
glVertex4dv.add( Input( 'v','const GLdouble *' ,size = 4 ))
glVertex4dv.version = '1.0'
glVertex4dv.category = 'GL_VERSION_1_0'
glVertex4dv.trace = True
glVertex4dv.play = True
gl.add(glVertex4dv)

glVertex4f = Function('glVertex4f')
glVertex4f.ret = Return('void')
glVertex4f.add( Input( 'x','GLfloat' ))
glVertex4f.add( Input( 'y','GLfloat' ))
glVertex4f.add( Input( 'z','GLfloat' ))
glVertex4f.add( Input( 'w','GLfloat' ))
glVertex4f.version = '1.0'
glVertex4f.category = 'GL_VERSION_1_0'
glVertex4f.trace = True
glVertex4f.play = True
gl.add(glVertex4f)

glVertex4fv = Function('glVertex4fv')
glVertex4fv.ret = Return('void')
glVertex4fv.add( Input( 'v','const GLfloat *' ,size = 4 ))
glVertex4fv.version = '1.0'
glVertex4fv.category = 'GL_VERSION_1_0'
glVertex4fv.trace = True
glVertex4fv.play = True
gl.add(glVertex4fv)

glVertex4i = Function('glVertex4i')
glVertex4i.ret = Return('void')
glVertex4i.add( Input( 'x','GLint' ))
glVertex4i.add( Input( 'y','GLint' ))
glVertex4i.add( Input( 'z','GLint' ))
glVertex4i.add( Input( 'w','GLint' ))
glVertex4i.version = '1.0'
glVertex4i.category = 'GL_VERSION_1_0'
glVertex4i.trace = True
glVertex4i.play = True
gl.add(glVertex4i)

glVertex4iv = Function('glVertex4iv')
glVertex4iv.ret = Return('void')
glVertex4iv.add( Input( 'v','const GLint *' ,size = 4 ))
glVertex4iv.version = '1.0'
glVertex4iv.category = 'GL_VERSION_1_0'
glVertex4iv.trace = True
glVertex4iv.play = True
gl.add(glVertex4iv)

glVertex4s = Function('glVertex4s')
glVertex4s.ret = Return('void')
glVertex4s.add( Input( 'x','GLshort' ))
glVertex4s.add( Input( 'y','GLshort' ))
glVertex4s.add( Input( 'z','GLshort' ))
glVertex4s.add( Input( 'w','GLshort' ))
glVertex4s.version = '1.0'
glVertex4s.category = 'GL_VERSION_1_0'
glVertex4s.trace = True
glVertex4s.play = True
gl.add(glVertex4s)

glVertex4sv = Function('glVertex4sv')
glVertex4sv.ret = Return('void')
glVertex4sv.add( Input( 'v','const GLshort *' ,size = 4 ))
glVertex4sv.version = '1.0'
glVertex4sv.category = 'GL_VERSION_1_0'
glVertex4sv.trace = True
glVertex4sv.play = True
gl.add(glVertex4sv)

glViewport = Function('glViewport')
glViewport.ret = Return('void')
glViewport.add( Input( 'x','GLint' ))
glViewport.add( Input( 'y','GLint' ))
glViewport.add( Input( 'width','GLsizei' ))
glViewport.add( Input( 'height','GLsizei' ))
glViewport.version = '1.0'
glViewport.category = 'GL_VERSION_1_0'
glViewport.esVersions = [1.0, 1.1, 2.0]
glViewport.trace = True
glViewport.play = True
gl.add(glViewport)

# GL_VERSION_1_1

glAreTexturesResident = Function('glAreTexturesResident')
glAreTexturesResident.ret = Return('GLboolean')
glAreTexturesResident.add( Input( 'n','GLsizei' ))
glAreTexturesResident.add( Input( 'textures','const GLuint *' ,size = 'n' ))
glAreTexturesResident.add( Output( 'residences','GLboolean *' ,size = 'n' ))
glAreTexturesResident.version = '1.1'
glAreTexturesResident.category = 'GL_VERSION_1_1'
glAreTexturesResident.trace = True
glAreTexturesResident.play = True
gl.add(glAreTexturesResident)

glArrayElement = Function('glArrayElement')
glArrayElement.ret = Return('void')
glArrayElement.add( Input( 'index','GLint' ))
glArrayElement.version = '1.1'
glArrayElement.category = 'GL_VERSION_1_1'
glArrayElement.trace = True
glArrayElement.play = True
gl.add(glArrayElement)

glBindTexture = Function('glBindTexture')
glBindTexture.ret = Return('void')
glBindTexture.add( Input( 'target','GLenum' ))
glBindTexture.add( Input( 'texture','GLuint' ))
glBindTexture.version = '1.1'
glBindTexture.category = 'GL_VERSION_1_1'
glBindTexture.esVersions = [1.0, 1.1, 2.0]
glBindTexture.trace = True
glBindTexture.play = True
gl.add(glBindTexture)

glColorPointer = Function('glColorPointer')
glColorPointer.ret = Return('void')
glColorPointer.add( Input( 'size','GLint' ))
glColorPointer.add( Input( 'type','GLenum' ))
glColorPointer.add( Input( 'stride','GLsizei' ))
glColorPointer.add( Input( 'pointer','const GLvoid *' ))
glColorPointer.version = '1.1'
glColorPointer.category = 'GL_VERSION_1_1'
glColorPointer.esVersions = [1.0, 1.1]
glColorPointer.trace = True
glColorPointer.play = True
gl.add(glColorPointer)

glCopyTexImage1D = Function('glCopyTexImage1D')
glCopyTexImage1D.ret = Return('void')
glCopyTexImage1D.add( Input( 'target','GLenum' ))
glCopyTexImage1D.add( Input( 'level','GLint' ))
glCopyTexImage1D.add( Input( 'internalformat','GLenum' ))
glCopyTexImage1D.add( Input( 'x','GLint' ))
glCopyTexImage1D.add( Input( 'y','GLint' ))
glCopyTexImage1D.add( Input( 'width','GLsizei' ))
glCopyTexImage1D.add( Input( 'border','GLint' ))
glCopyTexImage1D.version = '1.1'
glCopyTexImage1D.category = 'GL_VERSION_1_1'
glCopyTexImage1D.trace = True
glCopyTexImage1D.play = True
gl.add(glCopyTexImage1D)

glCopyTexImage2D = Function('glCopyTexImage2D')
glCopyTexImage2D.ret = Return('void')
glCopyTexImage2D.add( Input( 'target','GLenum' ))
glCopyTexImage2D.add( Input( 'level','GLint' ))
glCopyTexImage2D.add( Input( 'internalformat','GLenum' ))
glCopyTexImage2D.add( Input( 'x','GLint' ))
glCopyTexImage2D.add( Input( 'y','GLint' ))
glCopyTexImage2D.add( Input( 'width','GLsizei' ))
glCopyTexImage2D.add( Input( 'height','GLsizei' ))
glCopyTexImage2D.add( Input( 'border','GLint' ))
glCopyTexImage2D.version = '1.1'
glCopyTexImage2D.category = 'GL_VERSION_1_1'
glCopyTexImage2D.esVersions = [1.0, 1.1, 2.0]
glCopyTexImage2D.trace = True
glCopyTexImage2D.play = True
gl.add(glCopyTexImage2D)

glCopyTexSubImage1D = Function('glCopyTexSubImage1D')
glCopyTexSubImage1D.ret = Return('void')
glCopyTexSubImage1D.add( Input( 'target','GLenum' ))
glCopyTexSubImage1D.add( Input( 'level','GLint' ))
glCopyTexSubImage1D.add( Input( 'xoffset','GLint' ))
glCopyTexSubImage1D.add( Input( 'x','GLint' ))
glCopyTexSubImage1D.add( Input( 'y','GLint' ))
glCopyTexSubImage1D.add( Input( 'width','GLsizei' ))
glCopyTexSubImage1D.version = '1.1'
glCopyTexSubImage1D.category = 'GL_VERSION_1_1'
glCopyTexSubImage1D.trace = True
glCopyTexSubImage1D.play = True
gl.add(glCopyTexSubImage1D)

glCopyTexSubImage2D = Function('glCopyTexSubImage2D')
glCopyTexSubImage2D.ret = Return('void')
glCopyTexSubImage2D.add( Input( 'target','GLenum' ))
glCopyTexSubImage2D.add( Input( 'level','GLint' ))
glCopyTexSubImage2D.add( Input( 'xoffset','GLint' ))
glCopyTexSubImage2D.add( Input( 'yoffset','GLint' ))
glCopyTexSubImage2D.add( Input( 'x','GLint' ))
glCopyTexSubImage2D.add( Input( 'y','GLint' ))
glCopyTexSubImage2D.add( Input( 'width','GLsizei' ))
glCopyTexSubImage2D.add( Input( 'height','GLsizei' ))
glCopyTexSubImage2D.version = '1.1'
glCopyTexSubImage2D.category = 'GL_VERSION_1_1'
glCopyTexSubImage2D.esVersions = [1.0, 1.1, 2.0]
glCopyTexSubImage2D.trace = True
glCopyTexSubImage2D.play = True
gl.add(glCopyTexSubImage2D)

glDeleteTextures = Function('glDeleteTextures')
glDeleteTextures.ret = Return('void')
glDeleteTextures.add( Input( 'n','GLsizei' ))
glDeleteTextures.add( Input( 'textures','const GLuint *' ,size = 'n' ))
glDeleteTextures.version = '1.1'
glDeleteTextures.category = 'GL_VERSION_1_1'
glDeleteTextures.esVersions = [1.0, 1.1, 2.0]
glDeleteTextures.trace = True
glDeleteTextures.play = True
gl.add(glDeleteTextures)

glDisableClientState = Function('glDisableClientState')
glDisableClientState.ret = Return('void')
glDisableClientState.add( Input( 'cap','GLenum' ))
glDisableClientState.version = '1.1'
glDisableClientState.category = 'GL_VERSION_1_1'
glDisableClientState.esVersions = [1.0, 1.1]
glDisableClientState.trace = True
glDisableClientState.play = True
gl.add(glDisableClientState)

glDrawArrays = Function('glDrawArrays')
glDrawArrays.ret = Return('void')
glDrawArrays.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glDrawArrays.add( Input( 'first','GLint' ))
glDrawArrays.add( Input( 'count','GLsizei' ))
glDrawArrays.version = '1.1'
glDrawArrays.category = 'GL_VERSION_1_1'
glDrawArrays.esVersions = [1.0, 1.1, 2.0]
glDrawArrays.trace = True
glDrawArrays.play = True
gl.add(glDrawArrays)

glDrawElements = Function('glDrawElements')
glDrawElements.ret = Return('void')
glDrawElements.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glDrawElements.add( Input( 'count','GLsizei' ))
glDrawElements.add( Input( 'type','GLenum' ))
glDrawElements.add( Input( 'indices','const GLvoid *' ,size = 'helperGLDrawElementsSize(mode, count, type)' ,cast = 'const GLubyte *' ))
glDrawElements.version = '1.1'
glDrawElements.category = 'GL_VERSION_1_1'
glDrawElements.esVersions = [1.0, 1.1, 2.0]
glDrawElements.trace = True
glDrawElements.play = True
gl.add(glDrawElements)

glEdgeFlagPointer = Function('glEdgeFlagPointer')
glEdgeFlagPointer.ret = Return('void')
glEdgeFlagPointer.add( Input( 'stride','GLsizei' ))
glEdgeFlagPointer.add( Input( 'pointer','const GLvoid *' ))
glEdgeFlagPointer.version = '1.1'
glEdgeFlagPointer.category = 'GL_VERSION_1_1'
glEdgeFlagPointer.trace = True
glEdgeFlagPointer.play = True
gl.add(glEdgeFlagPointer)

glEnableClientState = Function('glEnableClientState')
glEnableClientState.ret = Return('void')
glEnableClientState.add( Input( 'cap','GLenum' ))
glEnableClientState.version = '1.1'
glEnableClientState.category = 'GL_VERSION_1_1'
glEnableClientState.esVersions = [1.0, 1.1]
glEnableClientState.trace = True
glEnableClientState.play = True
gl.add(glEnableClientState)

glGenTextures = Function('glGenTextures')
glGenTextures.ret = Return('void')
glGenTextures.add( Input( 'n','GLsizei' ))
glGenTextures.add( Output( 'textures','GLuint *' ,size = 'n' ))
glGenTextures.version = '1.1'
glGenTextures.category = 'GL_VERSION_1_1'
glGenTextures.esVersions = [1.0, 1.1, 2.0]
glGenTextures.trace = True
glGenTextures.play = True
gl.add(glGenTextures)

glGetPointerv = Function('glGetPointerv')
glGetPointerv.ret = Return('void')
glGetPointerv.add( Input( 'pname','GLenum' ))
glGetPointerv.add( Output( 'params','GLvoid **' ,size = 1 ))
glGetPointerv.version = '1.1'
glGetPointerv.category = 'GL_VERSION_1_1'
glGetPointerv.esVersions = [1.1]
glGetPointerv.trace = True
glGetPointerv.play = False
gl.add(glGetPointerv)

glIndexPointer = Function('glIndexPointer')
glIndexPointer.ret = Return('void')
glIndexPointer.add( Input( 'type','GLenum' ))
glIndexPointer.add( Input( 'stride','GLsizei' ))
glIndexPointer.add( Input( 'pointer','const GLvoid *' ))
glIndexPointer.version = '1.1'
glIndexPointer.category = 'GL_VERSION_1_1'
glIndexPointer.trace = True
glIndexPointer.play = True
gl.add(glIndexPointer)

glIndexub = Function('glIndexub')
glIndexub.ret = Return('void')
glIndexub.add( Input( 'c','GLubyte' ))
glIndexub.version = '1.1'
glIndexub.category = 'GL_VERSION_1_1'
glIndexub.trace = True
glIndexub.play = True
gl.add(glIndexub)

glIndexubv = Function('glIndexubv')
glIndexubv.ret = Return('void')
glIndexubv.add( Input( 'c','const GLubyte *' ,size = 1 ))
glIndexubv.version = '1.1'
glIndexubv.category = 'GL_VERSION_1_1'
glIndexubv.trace = True
glIndexubv.play = True
gl.add(glIndexubv)

glInterleavedArrays = Function('glInterleavedArrays')
glInterleavedArrays.ret = Return('void')
glInterleavedArrays.add( Input( 'format','GLenum' ))
glInterleavedArrays.add( Input( 'stride','GLsizei' ))
glInterleavedArrays.add( Input( 'pointer','const GLvoid *' ))
glInterleavedArrays.version = '1.1'
glInterleavedArrays.category = 'GL_VERSION_1_1'
glInterleavedArrays.trace = True
glInterleavedArrays.play = True
gl.add(glInterleavedArrays)

glIsTexture = Function('glIsTexture')
glIsTexture.ret = Return('GLboolean')
glIsTexture.add( Input( 'texture','GLuint' ))
glIsTexture.version = '1.1'
glIsTexture.category = 'GL_VERSION_1_1'
glIsTexture.esVersions = [1.1, 2.0]
glIsTexture.trace = True
glIsTexture.play = True
gl.add(glIsTexture)

glNormalPointer = Function('glNormalPointer')
glNormalPointer.ret = Return('void')
glNormalPointer.add( Input( 'type','GLenum' ))
glNormalPointer.add( Input( 'stride','GLsizei' ))
glNormalPointer.add( Input( 'pointer','const GLvoid *' ))
glNormalPointer.version = '1.1'
glNormalPointer.category = 'GL_VERSION_1_1'
glNormalPointer.esVersions = [1.0, 1.1]
glNormalPointer.trace = True
glNormalPointer.play = True
gl.add(glNormalPointer)

glPolygonOffset = Function('glPolygonOffset')
glPolygonOffset.ret = Return('void')
glPolygonOffset.add( Input( 'factor','GLfloat' ))
glPolygonOffset.add( Input( 'units','GLfloat' ))
glPolygonOffset.version = '1.1'
glPolygonOffset.category = 'GL_VERSION_1_1'
glPolygonOffset.esVersions = [1.0, 1.1, 2.0]
glPolygonOffset.trace = True
glPolygonOffset.play = True
gl.add(glPolygonOffset)

glPopClientAttrib = Function('glPopClientAttrib')
glPopClientAttrib.ret = Return('void')
glPopClientAttrib.version = '1.1'
glPopClientAttrib.category = 'GL_VERSION_1_1'
glPopClientAttrib.trace = True
glPopClientAttrib.play = True
gl.add(glPopClientAttrib)

glPrioritizeTextures = Function('glPrioritizeTextures')
glPrioritizeTextures.ret = Return('void')
glPrioritizeTextures.add( Input( 'n','GLsizei' ))
glPrioritizeTextures.add( Input( 'textures','const GLuint *' ,size = 'n' ))
glPrioritizeTextures.add( Input( 'priorities','const GLclampf *' ,size = 'n' ))
glPrioritizeTextures.version = '1.1'
glPrioritizeTextures.category = 'GL_VERSION_1_1'
glPrioritizeTextures.trace = True
glPrioritizeTextures.play = True
gl.add(glPrioritizeTextures)

glPushClientAttrib = Function('glPushClientAttrib')
glPushClientAttrib.ret = Return('void')
glPushClientAttrib.add( Input( 'mask','GLbitfield' ,regalLog = 'GLpushClientAttribToString(mask)' ))
glPushClientAttrib.version = '1.1'
glPushClientAttrib.category = 'GL_VERSION_1_1'
glPushClientAttrib.trace = True
glPushClientAttrib.play = True
gl.add(glPushClientAttrib)

glTexCoordPointer = Function('glTexCoordPointer')
glTexCoordPointer.ret = Return('void')
glTexCoordPointer.add( Input( 'size','GLint' ))
glTexCoordPointer.add( Input( 'type','GLenum' ))
glTexCoordPointer.add( Input( 'stride','GLsizei' ))
glTexCoordPointer.add( Input( 'pointer','const GLvoid *' ))
glTexCoordPointer.version = '1.1'
glTexCoordPointer.category = 'GL_VERSION_1_1'
glTexCoordPointer.esVersions = [1.0, 1.1]
glTexCoordPointer.trace = True
glTexCoordPointer.play = True
gl.add(glTexCoordPointer)

glTexSubImage1D = Function('glTexSubImage1D')
glTexSubImage1D.ret = Return('void')
glTexSubImage1D.add( Input( 'target','GLenum' ))
glTexSubImage1D.add( Input( 'level','GLint' ))
glTexSubImage1D.add( Input( 'xoffset','GLint' ))
glTexSubImage1D.add( Input( 'width','GLsizei' ))
glTexSubImage1D.add( Input( 'format','GLenum' ))
glTexSubImage1D.add( Input( 'type','GLenum' ))
glTexSubImage1D.add( Input( 'pixels','const GLvoid *' ,size = 'helperGLPixelImageSize(width, 0, 0, format, type, 0, target)' ,cast = 'const GLubyte *' ))
glTexSubImage1D.version = '1.1'
glTexSubImage1D.category = 'GL_VERSION_1_1'
glTexSubImage1D.trace = True
glTexSubImage1D.play = True
gl.add(glTexSubImage1D)

glTexSubImage2D = Function('glTexSubImage2D')
glTexSubImage2D.ret = Return('void')
glTexSubImage2D.add( Input( 'target','GLenum' ))
glTexSubImage2D.add( Input( 'level','GLint' ))
glTexSubImage2D.add( Input( 'xoffset','GLint' ))
glTexSubImage2D.add( Input( 'yoffset','GLint' ))
glTexSubImage2D.add( Input( 'width','GLsizei' ))
glTexSubImage2D.add( Input( 'height','GLsizei' ))
glTexSubImage2D.add( Input( 'format','GLenum' ))
glTexSubImage2D.add( Input( 'type','GLenum' ))
glTexSubImage2D.add( Input( 'pixels','const GLvoid *' ,size = 'helperGLPixelImageSize(width, height, 0, format, type, 0, target)' ,cast = 'const GLubyte *' ))
glTexSubImage2D.version = '1.1'
glTexSubImage2D.category = 'GL_VERSION_1_1'
glTexSubImage2D.esVersions = [1.0, 1.1, 2.0]
glTexSubImage2D.trace = True
glTexSubImage2D.play = True
gl.add(glTexSubImage2D)

glVertexPointer = Function('glVertexPointer')
glVertexPointer.ret = Return('void')
glVertexPointer.add( Input( 'size','GLint' ))
glVertexPointer.add( Input( 'type','GLenum' ))
glVertexPointer.add( Input( 'stride','GLsizei' ))
glVertexPointer.add( Input( 'pointer','const GLvoid *' ))
glVertexPointer.version = '1.1'
glVertexPointer.category = 'GL_VERSION_1_1'
glVertexPointer.esVersions = [1.0, 1.1]
glVertexPointer.trace = True
glVertexPointer.play = False
gl.add(glVertexPointer)

# GL_VERSION_1_2

glBlendColor = Function('glBlendColor')
glBlendColor.ret = Return('void')
glBlendColor.add( Input( 'red','GLclampf' ))
glBlendColor.add( Input( 'green','GLclampf' ))
glBlendColor.add( Input( 'blue','GLclampf' ))
glBlendColor.add( Input( 'alpha','GLclampf' ))
glBlendColor.version = '1.2'
glBlendColor.category = 'GL_VERSION_1_2'
glBlendColor.esVersions = [2.0]
glBlendColor.trace = True
glBlendColor.play = True
gl.add(glBlendColor)

glBlendEquation = Function('glBlendEquation')
glBlendEquation.ret = Return('void')
glBlendEquation.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glBlendEquation.version = '1.2'
glBlendEquation.category = 'GL_VERSION_1_2'
glBlendEquation.esVersions = [2.0]
glBlendEquation.trace = True
glBlendEquation.play = True
gl.add(glBlendEquation)

glCopyTexSubImage3D = Function('glCopyTexSubImage3D')
glCopyTexSubImage3D.ret = Return('void')
glCopyTexSubImage3D.add( Input( 'target','GLenum' ))
glCopyTexSubImage3D.add( Input( 'level','GLint' ))
glCopyTexSubImage3D.add( Input( 'xoffset','GLint' ))
glCopyTexSubImage3D.add( Input( 'yoffset','GLint' ))
glCopyTexSubImage3D.add( Input( 'zoffset','GLint' ))
glCopyTexSubImage3D.add( Input( 'x','GLint' ))
glCopyTexSubImage3D.add( Input( 'y','GLint' ))
glCopyTexSubImage3D.add( Input( 'width','GLsizei' ))
glCopyTexSubImage3D.add( Input( 'height','GLsizei' ))
glCopyTexSubImage3D.version = '1.2'
glCopyTexSubImage3D.category = 'GL_VERSION_1_2'
glCopyTexSubImage3D.trace = True
glCopyTexSubImage3D.play = True
gl.add(glCopyTexSubImage3D)

glDrawRangeElements = Function('glDrawRangeElements')
glDrawRangeElements.ret = Return('void')
glDrawRangeElements.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glDrawRangeElements.add( Input( 'start','GLuint' ))
glDrawRangeElements.add( Input( 'end','GLuint' ))
glDrawRangeElements.add( Input( 'count','GLsizei' ))
glDrawRangeElements.add( Input( 'type','GLenum' ))
glDrawRangeElements.add( Input( 'indices','const GLvoid *' ))
glDrawRangeElements.version = '1.2'
glDrawRangeElements.category = 'GL_VERSION_1_2'
glDrawRangeElements.trace = True
glDrawRangeElements.play = True
gl.add(glDrawRangeElements)

glTexImage3D = Function('glTexImage3D')
glTexImage3D.ret = Return('void')
glTexImage3D.add( Input( 'target','GLenum' ))
glTexImage3D.add( Input( 'level','GLint' ))
glTexImage3D.add( Input( 'internalformat','GLint' ,regalLog = 'internalFormatToString(internalformat)' ))
glTexImage3D.add( Input( 'width','GLsizei' ))
glTexImage3D.add( Input( 'height','GLsizei' ))
glTexImage3D.add( Input( 'depth','GLsizei' ))
glTexImage3D.add( Input( 'border','GLint' ))
glTexImage3D.add( Input( 'format','GLenum' ))
glTexImage3D.add( Input( 'type','GLenum' ))
glTexImage3D.add( Input( 'pixels','const GLvoid *' ,size = 'helperGLPixelImageSize(width, height, depth, format, type, 0, target)' ,cast = 'const GLubyte *' ))
glTexImage3D.version = '1.2'
glTexImage3D.category = 'GL_VERSION_1_2'
glTexImage3D.trace = True
glTexImage3D.play = True
gl.add(glTexImage3D)

glTexSubImage3D = Function('glTexSubImage3D')
glTexSubImage3D.ret = Return('void')
glTexSubImage3D.add( Input( 'target','GLenum' ))
glTexSubImage3D.add( Input( 'level','GLint' ))
glTexSubImage3D.add( Input( 'xoffset','GLint' ))
glTexSubImage3D.add( Input( 'yoffset','GLint' ))
glTexSubImage3D.add( Input( 'zoffset','GLint' ))
glTexSubImage3D.add( Input( 'width','GLsizei' ))
glTexSubImage3D.add( Input( 'height','GLsizei' ))
glTexSubImage3D.add( Input( 'depth','GLsizei' ))
glTexSubImage3D.add( Input( 'format','GLenum' ))
glTexSubImage3D.add( Input( 'type','GLenum' ))
glTexSubImage3D.add( Input( 'pixels','const GLvoid *' ,size = 'helperGLPixelImageSize(width, height, depth, format, type, 0, target)' ,cast = 'const GLubyte *' ))
glTexSubImage3D.version = '1.2'
glTexSubImage3D.category = 'GL_VERSION_1_2'
glTexSubImage3D.trace = True
glTexSubImage3D.play = True
gl.add(glTexSubImage3D)

# GL_VERSION_1_3

glActiveTexture = Function('glActiveTexture')
glActiveTexture.ret = Return('void')
glActiveTexture.add( Input( 'texture','GLenum' ))
glActiveTexture.version = '1.3'
glActiveTexture.category = 'GL_VERSION_1_3'
glActiveTexture.esVersions = [1.0, 1.1, 2.0]
glActiveTexture.trace = True
glActiveTexture.play = True
gl.add(glActiveTexture)

glClientActiveTexture = Function('glClientActiveTexture')
glClientActiveTexture.ret = Return('void')
glClientActiveTexture.add( Input( 'texture','GLenum' ))
glClientActiveTexture.version = '1.3'
glClientActiveTexture.category = 'GL_VERSION_1_3'
glClientActiveTexture.esVersions = [1.0, 1.1]
glClientActiveTexture.trace = True
glClientActiveTexture.play = True
gl.add(glClientActiveTexture)

glCompressedTexImage1D = Function('glCompressedTexImage1D')
glCompressedTexImage1D.ret = Return('void')
glCompressedTexImage1D.add( Input( 'target','GLenum' ))
glCompressedTexImage1D.add( Input( 'level','GLint' ))
glCompressedTexImage1D.add( Input( 'internalformat','GLenum' ))
glCompressedTexImage1D.add( Input( 'width','GLsizei' ))
glCompressedTexImage1D.add( Input( 'border','GLint' ))
glCompressedTexImage1D.add( Input( 'imageSize','GLsizei' ))
glCompressedTexImage1D.add( Input( 'data','const GLvoid *' ,size = 'imageSize' ))
glCompressedTexImage1D.version = '1.3'
glCompressedTexImage1D.category = 'GL_VERSION_1_3'
glCompressedTexImage1D.trace = True
glCompressedTexImage1D.play = True
gl.add(glCompressedTexImage1D)

glCompressedTexImage2D = Function('glCompressedTexImage2D')
glCompressedTexImage2D.ret = Return('void')
glCompressedTexImage2D.add( Input( 'target','GLenum' ))
glCompressedTexImage2D.add( Input( 'level','GLint' ))
glCompressedTexImage2D.add( Input( 'internalformat','GLenum' ))
glCompressedTexImage2D.add( Input( 'width','GLsizei' ))
glCompressedTexImage2D.add( Input( 'height','GLsizei' ))
glCompressedTexImage2D.add( Input( 'border','GLint' ))
glCompressedTexImage2D.add( Input( 'imageSize','GLsizei' ))
glCompressedTexImage2D.add( Input( 'data','const GLvoid *' ,size = 'imageSize' ))
glCompressedTexImage2D.version = '1.3'
glCompressedTexImage2D.category = 'GL_VERSION_1_3'
glCompressedTexImage2D.esVersions = [1.0, 1.1, 2.0]
glCompressedTexImage2D.trace = True
glCompressedTexImage2D.play = True
gl.add(glCompressedTexImage2D)

glCompressedTexImage3D = Function('glCompressedTexImage3D')
glCompressedTexImage3D.ret = Return('void')
glCompressedTexImage3D.add( Input( 'target','GLenum' ))
glCompressedTexImage3D.add( Input( 'level','GLint' ))
glCompressedTexImage3D.add( Input( 'internalformat','GLenum' ))
glCompressedTexImage3D.add( Input( 'width','GLsizei' ))
glCompressedTexImage3D.add( Input( 'height','GLsizei' ))
glCompressedTexImage3D.add( Input( 'depth','GLsizei' ))
glCompressedTexImage3D.add( Input( 'border','GLint' ))
glCompressedTexImage3D.add( Input( 'imageSize','GLsizei' ))
glCompressedTexImage3D.add( Input( 'data','const GLvoid *' ,size = 'imageSize' ))
glCompressedTexImage3D.version = '1.3'
glCompressedTexImage3D.category = 'GL_VERSION_1_3'
glCompressedTexImage3D.trace = True
glCompressedTexImage3D.play = True
gl.add(glCompressedTexImage3D)

glCompressedTexSubImage1D = Function('glCompressedTexSubImage1D')
glCompressedTexSubImage1D.ret = Return('void')
glCompressedTexSubImage1D.add( Input( 'target','GLenum' ))
glCompressedTexSubImage1D.add( Input( 'level','GLint' ))
glCompressedTexSubImage1D.add( Input( 'xoffset','GLint' ))
glCompressedTexSubImage1D.add( Input( 'width','GLsizei' ))
glCompressedTexSubImage1D.add( Input( 'format','GLenum' ))
glCompressedTexSubImage1D.add( Input( 'imageSize','GLsizei' ))
glCompressedTexSubImage1D.add( Input( 'data','const GLvoid *' ,size = 'imageSize' ))
glCompressedTexSubImage1D.version = '1.3'
glCompressedTexSubImage1D.category = 'GL_VERSION_1_3'
glCompressedTexSubImage1D.trace = True
glCompressedTexSubImage1D.play = True
gl.add(glCompressedTexSubImage1D)

glCompressedTexSubImage2D = Function('glCompressedTexSubImage2D')
glCompressedTexSubImage2D.ret = Return('void')
glCompressedTexSubImage2D.add( Input( 'target','GLenum' ))
glCompressedTexSubImage2D.add( Input( 'level','GLint' ))
glCompressedTexSubImage2D.add( Input( 'xoffset','GLint' ))
glCompressedTexSubImage2D.add( Input( 'yoffset','GLint' ))
glCompressedTexSubImage2D.add( Input( 'width','GLsizei' ))
glCompressedTexSubImage2D.add( Input( 'height','GLsizei' ))
glCompressedTexSubImage2D.add( Input( 'format','GLenum' ))
glCompressedTexSubImage2D.add( Input( 'imageSize','GLsizei' ))
glCompressedTexSubImage2D.add( Input( 'data','const GLvoid *' ,size = 'imageSize' ))
glCompressedTexSubImage2D.version = '1.3'
glCompressedTexSubImage2D.category = 'GL_VERSION_1_3'
glCompressedTexSubImage2D.esVersions = [1.0, 1.1, 2.0]
glCompressedTexSubImage2D.trace = True
glCompressedTexSubImage2D.play = True
gl.add(glCompressedTexSubImage2D)

glCompressedTexSubImage3D = Function('glCompressedTexSubImage3D')
glCompressedTexSubImage3D.ret = Return('void')
glCompressedTexSubImage3D.add( Input( 'target','GLenum' ))
glCompressedTexSubImage3D.add( Input( 'level','GLint' ))
glCompressedTexSubImage3D.add( Input( 'xoffset','GLint' ))
glCompressedTexSubImage3D.add( Input( 'yoffset','GLint' ))
glCompressedTexSubImage3D.add( Input( 'zoffset','GLint' ))
glCompressedTexSubImage3D.add( Input( 'width','GLsizei' ))
glCompressedTexSubImage3D.add( Input( 'height','GLsizei' ))
glCompressedTexSubImage3D.add( Input( 'depth','GLsizei' ))
glCompressedTexSubImage3D.add( Input( 'format','GLenum' ))
glCompressedTexSubImage3D.add( Input( 'imageSize','GLsizei' ))
glCompressedTexSubImage3D.add( Input( 'data','const GLvoid *' ,size = 'imageSize' ))
glCompressedTexSubImage3D.version = '1.3'
glCompressedTexSubImage3D.category = 'GL_VERSION_1_3'
glCompressedTexSubImage3D.trace = True
glCompressedTexSubImage3D.play = True
gl.add(glCompressedTexSubImage3D)

glGetCompressedTexImage = Function('glGetCompressedTexImage')
glGetCompressedTexImage.ret = Return('void')
glGetCompressedTexImage.add( Input( 'target','GLenum' ))
glGetCompressedTexImage.add( Input( 'lod','GLint' ))
glGetCompressedTexImage.add( Output( 'img','GLvoid *' ))
glGetCompressedTexImage.version = '1.3'
glGetCompressedTexImage.category = 'GL_VERSION_1_3'
glGetCompressedTexImage.trace = True
glGetCompressedTexImage.play = True
gl.add(glGetCompressedTexImage)

glLoadTransposeMatrixd = Function('glLoadTransposeMatrixd')
glLoadTransposeMatrixd.ret = Return('void')
glLoadTransposeMatrixd.add( Input( 'm','const GLdouble *' ,size = 16 ))
glLoadTransposeMatrixd.version = '1.3'
glLoadTransposeMatrixd.category = 'GL_VERSION_1_3'
glLoadTransposeMatrixd.trace = True
glLoadTransposeMatrixd.play = True
gl.add(glLoadTransposeMatrixd)

glLoadTransposeMatrixf = Function('glLoadTransposeMatrixf')
glLoadTransposeMatrixf.ret = Return('void')
glLoadTransposeMatrixf.add( Input( 'm','const GLfloat *' ,size = 16 ))
glLoadTransposeMatrixf.version = '1.3'
glLoadTransposeMatrixf.category = 'GL_VERSION_1_3'
glLoadTransposeMatrixf.trace = True
glLoadTransposeMatrixf.play = True
gl.add(glLoadTransposeMatrixf)

glMultTransposeMatrixd = Function('glMultTransposeMatrixd')
glMultTransposeMatrixd.ret = Return('void')
glMultTransposeMatrixd.add( Input( 'm','const GLdouble *' ,size = 16 ))
glMultTransposeMatrixd.version = '1.3'
glMultTransposeMatrixd.category = 'GL_VERSION_1_3'
glMultTransposeMatrixd.trace = True
glMultTransposeMatrixd.play = True
gl.add(glMultTransposeMatrixd)

glMultTransposeMatrixf = Function('glMultTransposeMatrixf')
glMultTransposeMatrixf.ret = Return('void')
glMultTransposeMatrixf.add( Input( 'm','const GLfloat *' ,size = 16 ))
glMultTransposeMatrixf.version = '1.3'
glMultTransposeMatrixf.category = 'GL_VERSION_1_3'
glMultTransposeMatrixf.trace = True
glMultTransposeMatrixf.play = True
gl.add(glMultTransposeMatrixf)

glMultiTexCoord1d = Function('glMultiTexCoord1d')
glMultiTexCoord1d.ret = Return('void')
glMultiTexCoord1d.add( Input( 'target','GLenum' ))
glMultiTexCoord1d.add( Input( 's','GLdouble' ))
glMultiTexCoord1d.version = '1.3'
glMultiTexCoord1d.category = 'GL_VERSION_1_3'
glMultiTexCoord1d.trace = True
glMultiTexCoord1d.play = True
gl.add(glMultiTexCoord1d)

glMultiTexCoord1dv = Function('glMultiTexCoord1dv')
glMultiTexCoord1dv.ret = Return('void')
glMultiTexCoord1dv.add( Input( 'target','GLenum' ))
glMultiTexCoord1dv.add( Input( 'v','const GLdouble *' ,size = 1 ))
glMultiTexCoord1dv.version = '1.3'
glMultiTexCoord1dv.category = 'GL_VERSION_1_3'
glMultiTexCoord1dv.trace = True
glMultiTexCoord1dv.play = True
gl.add(glMultiTexCoord1dv)

glMultiTexCoord1f = Function('glMultiTexCoord1f')
glMultiTexCoord1f.ret = Return('void')
glMultiTexCoord1f.add( Input( 'target','GLenum' ))
glMultiTexCoord1f.add( Input( 's','GLfloat' ))
glMultiTexCoord1f.version = '1.3'
glMultiTexCoord1f.category = 'GL_VERSION_1_3'
glMultiTexCoord1f.trace = True
glMultiTexCoord1f.play = True
gl.add(glMultiTexCoord1f)

glMultiTexCoord1fv = Function('glMultiTexCoord1fv')
glMultiTexCoord1fv.ret = Return('void')
glMultiTexCoord1fv.add( Input( 'target','GLenum' ))
glMultiTexCoord1fv.add( Input( 'v','const GLfloat *' ,size = 1 ))
glMultiTexCoord1fv.version = '1.3'
glMultiTexCoord1fv.category = 'GL_VERSION_1_3'
glMultiTexCoord1fv.trace = True
glMultiTexCoord1fv.play = True
gl.add(glMultiTexCoord1fv)

glMultiTexCoord1i = Function('glMultiTexCoord1i')
glMultiTexCoord1i.ret = Return('void')
glMultiTexCoord1i.add( Input( 'target','GLenum' ))
glMultiTexCoord1i.add( Input( 's','GLint' ))
glMultiTexCoord1i.version = '1.3'
glMultiTexCoord1i.category = 'GL_VERSION_1_3'
glMultiTexCoord1i.trace = True
glMultiTexCoord1i.play = True
gl.add(glMultiTexCoord1i)

glMultiTexCoord1iv = Function('glMultiTexCoord1iv')
glMultiTexCoord1iv.ret = Return('void')
glMultiTexCoord1iv.add( Input( 'target','GLenum' ))
glMultiTexCoord1iv.add( Input( 'v','const GLint *' ,size = 1 ))
glMultiTexCoord1iv.version = '1.3'
glMultiTexCoord1iv.category = 'GL_VERSION_1_3'
glMultiTexCoord1iv.trace = True
glMultiTexCoord1iv.play = True
gl.add(glMultiTexCoord1iv)

glMultiTexCoord1s = Function('glMultiTexCoord1s')
glMultiTexCoord1s.ret = Return('void')
glMultiTexCoord1s.add( Input( 'target','GLenum' ))
glMultiTexCoord1s.add( Input( 's','GLshort' ))
glMultiTexCoord1s.version = '1.3'
glMultiTexCoord1s.category = 'GL_VERSION_1_3'
glMultiTexCoord1s.trace = True
glMultiTexCoord1s.play = True
gl.add(glMultiTexCoord1s)

glMultiTexCoord1sv = Function('glMultiTexCoord1sv')
glMultiTexCoord1sv.ret = Return('void')
glMultiTexCoord1sv.add( Input( 'target','GLenum' ))
glMultiTexCoord1sv.add( Input( 'v','const GLshort *' ,size = 1 ))
glMultiTexCoord1sv.version = '1.3'
glMultiTexCoord1sv.category = 'GL_VERSION_1_3'
glMultiTexCoord1sv.trace = True
glMultiTexCoord1sv.play = True
gl.add(glMultiTexCoord1sv)

glMultiTexCoord2d = Function('glMultiTexCoord2d')
glMultiTexCoord2d.ret = Return('void')
glMultiTexCoord2d.add( Input( 'target','GLenum' ))
glMultiTexCoord2d.add( Input( 's','GLdouble' ))
glMultiTexCoord2d.add( Input( 't','GLdouble' ))
glMultiTexCoord2d.version = '1.3'
glMultiTexCoord2d.category = 'GL_VERSION_1_3'
glMultiTexCoord2d.trace = True
glMultiTexCoord2d.play = True
gl.add(glMultiTexCoord2d)

glMultiTexCoord2dv = Function('glMultiTexCoord2dv')
glMultiTexCoord2dv.ret = Return('void')
glMultiTexCoord2dv.add( Input( 'target','GLenum' ))
glMultiTexCoord2dv.add( Input( 'v','const GLdouble *' ,size = 2 ))
glMultiTexCoord2dv.version = '1.3'
glMultiTexCoord2dv.category = 'GL_VERSION_1_3'
glMultiTexCoord2dv.trace = True
glMultiTexCoord2dv.play = True
gl.add(glMultiTexCoord2dv)

glMultiTexCoord2f = Function('glMultiTexCoord2f')
glMultiTexCoord2f.ret = Return('void')
glMultiTexCoord2f.add( Input( 'target','GLenum' ))
glMultiTexCoord2f.add( Input( 's','GLfloat' ))
glMultiTexCoord2f.add( Input( 't','GLfloat' ))
glMultiTexCoord2f.version = '1.3'
glMultiTexCoord2f.category = 'GL_VERSION_1_3'
glMultiTexCoord2f.trace = True
glMultiTexCoord2f.play = True
gl.add(glMultiTexCoord2f)

glMultiTexCoord2fv = Function('glMultiTexCoord2fv')
glMultiTexCoord2fv.ret = Return('void')
glMultiTexCoord2fv.add( Input( 'target','GLenum' ))
glMultiTexCoord2fv.add( Input( 'v','const GLfloat *' ,size = 2 ))
glMultiTexCoord2fv.version = '1.3'
glMultiTexCoord2fv.category = 'GL_VERSION_1_3'
glMultiTexCoord2fv.trace = True
glMultiTexCoord2fv.play = True
gl.add(glMultiTexCoord2fv)

glMultiTexCoord2i = Function('glMultiTexCoord2i')
glMultiTexCoord2i.ret = Return('void')
glMultiTexCoord2i.add( Input( 'target','GLenum' ))
glMultiTexCoord2i.add( Input( 's','GLint' ))
glMultiTexCoord2i.add( Input( 't','GLint' ))
glMultiTexCoord2i.version = '1.3'
glMultiTexCoord2i.category = 'GL_VERSION_1_3'
glMultiTexCoord2i.trace = True
glMultiTexCoord2i.play = True
gl.add(glMultiTexCoord2i)

glMultiTexCoord2iv = Function('glMultiTexCoord2iv')
glMultiTexCoord2iv.ret = Return('void')
glMultiTexCoord2iv.add( Input( 'target','GLenum' ))
glMultiTexCoord2iv.add( Input( 'v','const GLint *' ,size = 2 ))
glMultiTexCoord2iv.version = '1.3'
glMultiTexCoord2iv.category = 'GL_VERSION_1_3'
glMultiTexCoord2iv.trace = True
glMultiTexCoord2iv.play = True
gl.add(glMultiTexCoord2iv)

glMultiTexCoord2s = Function('glMultiTexCoord2s')
glMultiTexCoord2s.ret = Return('void')
glMultiTexCoord2s.add( Input( 'target','GLenum' ))
glMultiTexCoord2s.add( Input( 's','GLshort' ))
glMultiTexCoord2s.add( Input( 't','GLshort' ))
glMultiTexCoord2s.version = '1.3'
glMultiTexCoord2s.category = 'GL_VERSION_1_3'
glMultiTexCoord2s.trace = True
glMultiTexCoord2s.play = True
gl.add(glMultiTexCoord2s)

glMultiTexCoord2sv = Function('glMultiTexCoord2sv')
glMultiTexCoord2sv.ret = Return('void')
glMultiTexCoord2sv.add( Input( 'target','GLenum' ))
glMultiTexCoord2sv.add( Input( 'v','const GLshort *' ,size = 2 ))
glMultiTexCoord2sv.version = '1.3'
glMultiTexCoord2sv.category = 'GL_VERSION_1_3'
glMultiTexCoord2sv.trace = True
glMultiTexCoord2sv.play = True
gl.add(glMultiTexCoord2sv)

glMultiTexCoord3d = Function('glMultiTexCoord3d')
glMultiTexCoord3d.ret = Return('void')
glMultiTexCoord3d.add( Input( 'target','GLenum' ))
glMultiTexCoord3d.add( Input( 's','GLdouble' ))
glMultiTexCoord3d.add( Input( 't','GLdouble' ))
glMultiTexCoord3d.add( Input( 'r','GLdouble' ))
glMultiTexCoord3d.version = '1.3'
glMultiTexCoord3d.category = 'GL_VERSION_1_3'
glMultiTexCoord3d.trace = True
glMultiTexCoord3d.play = True
gl.add(glMultiTexCoord3d)

glMultiTexCoord3dv = Function('glMultiTexCoord3dv')
glMultiTexCoord3dv.ret = Return('void')
glMultiTexCoord3dv.add( Input( 'target','GLenum' ))
glMultiTexCoord3dv.add( Input( 'v','const GLdouble *' ,size = 3 ))
glMultiTexCoord3dv.version = '1.3'
glMultiTexCoord3dv.category = 'GL_VERSION_1_3'
glMultiTexCoord3dv.trace = True
glMultiTexCoord3dv.play = True
gl.add(glMultiTexCoord3dv)

glMultiTexCoord3f = Function('glMultiTexCoord3f')
glMultiTexCoord3f.ret = Return('void')
glMultiTexCoord3f.add( Input( 'target','GLenum' ))
glMultiTexCoord3f.add( Input( 's','GLfloat' ))
glMultiTexCoord3f.add( Input( 't','GLfloat' ))
glMultiTexCoord3f.add( Input( 'r','GLfloat' ))
glMultiTexCoord3f.version = '1.3'
glMultiTexCoord3f.category = 'GL_VERSION_1_3'
glMultiTexCoord3f.trace = True
glMultiTexCoord3f.play = True
gl.add(glMultiTexCoord3f)

glMultiTexCoord3fv = Function('glMultiTexCoord3fv')
glMultiTexCoord3fv.ret = Return('void')
glMultiTexCoord3fv.add( Input( 'target','GLenum' ))
glMultiTexCoord3fv.add( Input( 'v','const GLfloat *' ,size = 3 ))
glMultiTexCoord3fv.version = '1.3'
glMultiTexCoord3fv.category = 'GL_VERSION_1_3'
glMultiTexCoord3fv.trace = True
glMultiTexCoord3fv.play = True
gl.add(glMultiTexCoord3fv)

glMultiTexCoord3i = Function('glMultiTexCoord3i')
glMultiTexCoord3i.ret = Return('void')
glMultiTexCoord3i.add( Input( 'target','GLenum' ))
glMultiTexCoord3i.add( Input( 's','GLint' ))
glMultiTexCoord3i.add( Input( 't','GLint' ))
glMultiTexCoord3i.add( Input( 'r','GLint' ))
glMultiTexCoord3i.version = '1.3'
glMultiTexCoord3i.category = 'GL_VERSION_1_3'
glMultiTexCoord3i.trace = True
glMultiTexCoord3i.play = True
gl.add(glMultiTexCoord3i)

glMultiTexCoord3iv = Function('glMultiTexCoord3iv')
glMultiTexCoord3iv.ret = Return('void')
glMultiTexCoord3iv.add( Input( 'target','GLenum' ))
glMultiTexCoord3iv.add( Input( 'v','const GLint *' ,size = 3 ))
glMultiTexCoord3iv.version = '1.3'
glMultiTexCoord3iv.category = 'GL_VERSION_1_3'
glMultiTexCoord3iv.trace = True
glMultiTexCoord3iv.play = True
gl.add(glMultiTexCoord3iv)

glMultiTexCoord3s = Function('glMultiTexCoord3s')
glMultiTexCoord3s.ret = Return('void')
glMultiTexCoord3s.add( Input( 'target','GLenum' ))
glMultiTexCoord3s.add( Input( 's','GLshort' ))
glMultiTexCoord3s.add( Input( 't','GLshort' ))
glMultiTexCoord3s.add( Input( 'r','GLshort' ))
glMultiTexCoord3s.version = '1.3'
glMultiTexCoord3s.category = 'GL_VERSION_1_3'
glMultiTexCoord3s.trace = True
glMultiTexCoord3s.play = True
gl.add(glMultiTexCoord3s)

glMultiTexCoord3sv = Function('glMultiTexCoord3sv')
glMultiTexCoord3sv.ret = Return('void')
glMultiTexCoord3sv.add( Input( 'target','GLenum' ))
glMultiTexCoord3sv.add( Input( 'v','const GLshort *' ,size = 3 ))
glMultiTexCoord3sv.version = '1.3'
glMultiTexCoord3sv.category = 'GL_VERSION_1_3'
glMultiTexCoord3sv.trace = True
glMultiTexCoord3sv.play = True
gl.add(glMultiTexCoord3sv)

glMultiTexCoord4d = Function('glMultiTexCoord4d')
glMultiTexCoord4d.ret = Return('void')
glMultiTexCoord4d.add( Input( 'target','GLenum' ))
glMultiTexCoord4d.add( Input( 's','GLdouble' ))
glMultiTexCoord4d.add( Input( 't','GLdouble' ))
glMultiTexCoord4d.add( Input( 'r','GLdouble' ))
glMultiTexCoord4d.add( Input( 'q','GLdouble' ))
glMultiTexCoord4d.version = '1.3'
glMultiTexCoord4d.category = 'GL_VERSION_1_3'
glMultiTexCoord4d.trace = True
glMultiTexCoord4d.play = True
gl.add(glMultiTexCoord4d)

glMultiTexCoord4dv = Function('glMultiTexCoord4dv')
glMultiTexCoord4dv.ret = Return('void')
glMultiTexCoord4dv.add( Input( 'target','GLenum' ))
glMultiTexCoord4dv.add( Input( 'v','const GLdouble *' ,size = 4 ))
glMultiTexCoord4dv.version = '1.3'
glMultiTexCoord4dv.category = 'GL_VERSION_1_3'
glMultiTexCoord4dv.trace = True
glMultiTexCoord4dv.play = True
gl.add(glMultiTexCoord4dv)

glMultiTexCoord4f = Function('glMultiTexCoord4f')
glMultiTexCoord4f.ret = Return('void')
glMultiTexCoord4f.add( Input( 'target','GLenum' ))
glMultiTexCoord4f.add( Input( 's','GLfloat' ))
glMultiTexCoord4f.add( Input( 't','GLfloat' ))
glMultiTexCoord4f.add( Input( 'r','GLfloat' ))
glMultiTexCoord4f.add( Input( 'q','GLfloat' ))
glMultiTexCoord4f.version = '1.3'
glMultiTexCoord4f.category = 'GL_VERSION_1_3'
glMultiTexCoord4f.esVersions = [1.0, 1.1]
glMultiTexCoord4f.trace = True
glMultiTexCoord4f.play = True
gl.add(glMultiTexCoord4f)

glMultiTexCoord4fv = Function('glMultiTexCoord4fv')
glMultiTexCoord4fv.ret = Return('void')
glMultiTexCoord4fv.add( Input( 'target','GLenum' ))
glMultiTexCoord4fv.add( Input( 'v','const GLfloat *' ,size = 4 ))
glMultiTexCoord4fv.version = '1.3'
glMultiTexCoord4fv.category = 'GL_VERSION_1_3'
glMultiTexCoord4fv.trace = True
glMultiTexCoord4fv.play = True
gl.add(glMultiTexCoord4fv)

glMultiTexCoord4i = Function('glMultiTexCoord4i')
glMultiTexCoord4i.ret = Return('void')
glMultiTexCoord4i.add( Input( 'target','GLenum' ))
glMultiTexCoord4i.add( Input( 's','GLint' ))
glMultiTexCoord4i.add( Input( 't','GLint' ))
glMultiTexCoord4i.add( Input( 'r','GLint' ))
glMultiTexCoord4i.add( Input( 'q','GLint' ))
glMultiTexCoord4i.version = '1.3'
glMultiTexCoord4i.category = 'GL_VERSION_1_3'
glMultiTexCoord4i.trace = True
glMultiTexCoord4i.play = True
gl.add(glMultiTexCoord4i)

glMultiTexCoord4iv = Function('glMultiTexCoord4iv')
glMultiTexCoord4iv.ret = Return('void')
glMultiTexCoord4iv.add( Input( 'target','GLenum' ))
glMultiTexCoord4iv.add( Input( 'v','const GLint *' ,size = 4 ))
glMultiTexCoord4iv.version = '1.3'
glMultiTexCoord4iv.category = 'GL_VERSION_1_3'
glMultiTexCoord4iv.trace = True
glMultiTexCoord4iv.play = True
gl.add(glMultiTexCoord4iv)

glMultiTexCoord4s = Function('glMultiTexCoord4s')
glMultiTexCoord4s.ret = Return('void')
glMultiTexCoord4s.add( Input( 'target','GLenum' ))
glMultiTexCoord4s.add( Input( 's','GLshort' ))
glMultiTexCoord4s.add( Input( 't','GLshort' ))
glMultiTexCoord4s.add( Input( 'r','GLshort' ))
glMultiTexCoord4s.add( Input( 'q','GLshort' ))
glMultiTexCoord4s.version = '1.3'
glMultiTexCoord4s.category = 'GL_VERSION_1_3'
glMultiTexCoord4s.trace = True
glMultiTexCoord4s.play = True
gl.add(glMultiTexCoord4s)

glMultiTexCoord4sv = Function('glMultiTexCoord4sv')
glMultiTexCoord4sv.ret = Return('void')
glMultiTexCoord4sv.add( Input( 'target','GLenum' ))
glMultiTexCoord4sv.add( Input( 'v','const GLshort *' ,size = 4 ))
glMultiTexCoord4sv.version = '1.3'
glMultiTexCoord4sv.category = 'GL_VERSION_1_3'
glMultiTexCoord4sv.trace = True
glMultiTexCoord4sv.play = True
gl.add(glMultiTexCoord4sv)

# GL_VERSION_1_4

glBlendFuncSeparate = Function('glBlendFuncSeparate')
glBlendFuncSeparate.ret = Return('void')
glBlendFuncSeparate.add( Input( 'sfactorRGB','GLenum' ))
glBlendFuncSeparate.add( Input( 'dfactorRGB','GLenum' ))
glBlendFuncSeparate.add( Input( 'sfactorAlpha','GLenum' ))
glBlendFuncSeparate.add( Input( 'dfactorAlpha','GLenum' ))
glBlendFuncSeparate.version = '1.4'
glBlendFuncSeparate.category = 'GL_VERSION_1_4'
glBlendFuncSeparate.esVersions = [2.0]
glBlendFuncSeparate.trace = True
glBlendFuncSeparate.play = True
gl.add(glBlendFuncSeparate)

glFogCoordPointer = Function('glFogCoordPointer')
glFogCoordPointer.ret = Return('void')
glFogCoordPointer.add( Input( 'type','GLenum' ))
glFogCoordPointer.add( Input( 'stride','GLsizei' ))
glFogCoordPointer.add( Input( 'pointer','const GLvoid *' ))
glFogCoordPointer.version = '1.4'
glFogCoordPointer.category = 'GL_VERSION_1_4'
glFogCoordPointer.trace = True
glFogCoordPointer.play = True
gl.add(glFogCoordPointer)

glFogCoordd = Function('glFogCoordd')
glFogCoordd.ret = Return('void')
glFogCoordd.add( Input( 'coord','GLdouble' ))
glFogCoordd.version = '1.4'
glFogCoordd.category = 'GL_VERSION_1_4'
glFogCoordd.trace = True
glFogCoordd.play = True
gl.add(glFogCoordd)

glFogCoorddv = Function('glFogCoorddv')
glFogCoorddv.ret = Return('void')
glFogCoorddv.add( Input( 'coord','const GLdouble *' ,size = 1 ))
glFogCoorddv.version = '1.4'
glFogCoorddv.category = 'GL_VERSION_1_4'
glFogCoorddv.trace = True
glFogCoorddv.play = True
gl.add(glFogCoorddv)

glFogCoordf = Function('glFogCoordf')
glFogCoordf.ret = Return('void')
glFogCoordf.add( Input( 'coord','GLfloat' ))
glFogCoordf.version = '1.4'
glFogCoordf.category = 'GL_VERSION_1_4'
glFogCoordf.trace = True
glFogCoordf.play = True
gl.add(glFogCoordf)

glFogCoordfv = Function('glFogCoordfv')
glFogCoordfv.ret = Return('void')
glFogCoordfv.add( Input( 'coord','const GLfloat *' ,size = 1 ))
glFogCoordfv.version = '1.4'
glFogCoordfv.category = 'GL_VERSION_1_4'
glFogCoordfv.trace = True
glFogCoordfv.play = True
gl.add(glFogCoordfv)

glMultiDrawArrays = Function('glMultiDrawArrays')
glMultiDrawArrays.ret = Return('void')
glMultiDrawArrays.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glMultiDrawArrays.add( Input( 'first','const GLint *' ,size = 'primcount' ))
glMultiDrawArrays.add( Input( 'count','const GLsizei *' ,size = 'primcount' ))
glMultiDrawArrays.add( Input( 'primcount','GLsizei' ))
glMultiDrawArrays.version = '1.4'
glMultiDrawArrays.category = 'GL_VERSION_1_4'
glMultiDrawArrays.trace = True
glMultiDrawArrays.play = True
gl.add(glMultiDrawArrays)

glMultiDrawElements = Function('glMultiDrawElements')
glMultiDrawElements.ret = Return('void')
glMultiDrawElements.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glMultiDrawElements.add( Input( 'count','const GLsizei *' ,size = 'primcount' ))
glMultiDrawElements.add( Input( 'type','GLenum' ))
glMultiDrawElements.add( Input( 'indices','const GLvoid * const *' ,size = 'primcount' ))
glMultiDrawElements.add( Input( 'primcount','GLsizei' ))
glMultiDrawElements.version = '1.4'
glMultiDrawElements.category = 'GL_VERSION_1_4'
glMultiDrawElements.trace = True
glMultiDrawElements.play = True
gl.add(glMultiDrawElements)

glPointParameterf = Function('glPointParameterf')
glPointParameterf.ret = Return('void')
glPointParameterf.add( Input( 'pname','GLenum' ))
glPointParameterf.add( Input( 'param','GLfloat' ))
glPointParameterf.version = '1.4'
glPointParameterf.category = 'GL_VERSION_1_4'
glPointParameterf.esVersions = [1.1]
glPointParameterf.trace = True
glPointParameterf.play = True
gl.add(glPointParameterf)

glPointParameterfv = Function('glPointParameterfv')
glPointParameterfv.ret = Return('void')
glPointParameterfv.add( Input( 'pname','GLenum' ))
glPointParameterfv.add( Input( 'params','const GLfloat *' ))
glPointParameterfv.version = '1.4'
glPointParameterfv.category = 'GL_VERSION_1_4'
glPointParameterfv.esVersions = [1.1]
glPointParameterfv.trace = True
glPointParameterfv.play = True
gl.add(glPointParameterfv)

glPointParameteri = Function('glPointParameteri')
glPointParameteri.ret = Return('void')
glPointParameteri.add( Input( 'pname','GLenum' ))
glPointParameteri.add( Input( 'param','GLint' ))
glPointParameteri.version = '1.4'
glPointParameteri.category = 'GL_VERSION_1_4'
glPointParameteri.trace = True
glPointParameteri.play = True
gl.add(glPointParameteri)

glPointParameteriv = Function('glPointParameteriv')
glPointParameteriv.ret = Return('void')
glPointParameteriv.add( Input( 'pname','GLenum' ))
glPointParameteriv.add( Input( 'params','const GLint *' ))
glPointParameteriv.version = '1.4'
glPointParameteriv.category = 'GL_VERSION_1_4'
glPointParameteriv.trace = True
glPointParameteriv.play = True
gl.add(glPointParameteriv)

glSecondaryColor3b = Function('glSecondaryColor3b')
glSecondaryColor3b.ret = Return('void')
glSecondaryColor3b.add( Input( 'red','GLbyte' ))
glSecondaryColor3b.add( Input( 'green','GLbyte' ))
glSecondaryColor3b.add( Input( 'blue','GLbyte' ))
glSecondaryColor3b.version = '1.4'
glSecondaryColor3b.category = 'GL_VERSION_1_4'
glSecondaryColor3b.trace = True
glSecondaryColor3b.play = True
gl.add(glSecondaryColor3b)

glSecondaryColor3bv = Function('glSecondaryColor3bv')
glSecondaryColor3bv.ret = Return('void')
glSecondaryColor3bv.add( Input( 'v','const GLbyte *' ,size = 3 ))
glSecondaryColor3bv.version = '1.4'
glSecondaryColor3bv.category = 'GL_VERSION_1_4'
glSecondaryColor3bv.trace = True
glSecondaryColor3bv.play = True
gl.add(glSecondaryColor3bv)

glSecondaryColor3d = Function('glSecondaryColor3d')
glSecondaryColor3d.ret = Return('void')
glSecondaryColor3d.add( Input( 'red','GLdouble' ))
glSecondaryColor3d.add( Input( 'green','GLdouble' ))
glSecondaryColor3d.add( Input( 'blue','GLdouble' ))
glSecondaryColor3d.version = '1.4'
glSecondaryColor3d.category = 'GL_VERSION_1_4'
glSecondaryColor3d.trace = True
glSecondaryColor3d.play = True
gl.add(glSecondaryColor3d)

glSecondaryColor3dv = Function('glSecondaryColor3dv')
glSecondaryColor3dv.ret = Return('void')
glSecondaryColor3dv.add( Input( 'v','const GLdouble *' ,size = 3 ))
glSecondaryColor3dv.version = '1.4'
glSecondaryColor3dv.category = 'GL_VERSION_1_4'
glSecondaryColor3dv.trace = True
glSecondaryColor3dv.play = True
gl.add(glSecondaryColor3dv)

glSecondaryColor3f = Function('glSecondaryColor3f')
glSecondaryColor3f.ret = Return('void')
glSecondaryColor3f.add( Input( 'red','GLfloat' ))
glSecondaryColor3f.add( Input( 'green','GLfloat' ))
glSecondaryColor3f.add( Input( 'blue','GLfloat' ))
glSecondaryColor3f.version = '1.4'
glSecondaryColor3f.category = 'GL_VERSION_1_4'
glSecondaryColor3f.trace = True
glSecondaryColor3f.play = True
gl.add(glSecondaryColor3f)

glSecondaryColor3fv = Function('glSecondaryColor3fv')
glSecondaryColor3fv.ret = Return('void')
glSecondaryColor3fv.add( Input( 'v','const GLfloat *' ,size = 3 ))
glSecondaryColor3fv.version = '1.4'
glSecondaryColor3fv.category = 'GL_VERSION_1_4'
glSecondaryColor3fv.trace = True
glSecondaryColor3fv.play = True
gl.add(glSecondaryColor3fv)

glSecondaryColor3i = Function('glSecondaryColor3i')
glSecondaryColor3i.ret = Return('void')
glSecondaryColor3i.add( Input( 'red','GLint' ))
glSecondaryColor3i.add( Input( 'green','GLint' ))
glSecondaryColor3i.add( Input( 'blue','GLint' ))
glSecondaryColor3i.version = '1.4'
glSecondaryColor3i.category = 'GL_VERSION_1_4'
glSecondaryColor3i.trace = True
glSecondaryColor3i.play = True
gl.add(glSecondaryColor3i)

glSecondaryColor3iv = Function('glSecondaryColor3iv')
glSecondaryColor3iv.ret = Return('void')
glSecondaryColor3iv.add( Input( 'v','const GLint *' ,size = 3 ))
glSecondaryColor3iv.version = '1.4'
glSecondaryColor3iv.category = 'GL_VERSION_1_4'
glSecondaryColor3iv.trace = True
glSecondaryColor3iv.play = True
gl.add(glSecondaryColor3iv)

glSecondaryColor3s = Function('glSecondaryColor3s')
glSecondaryColor3s.ret = Return('void')
glSecondaryColor3s.add( Input( 'red','GLshort' ))
glSecondaryColor3s.add( Input( 'green','GLshort' ))
glSecondaryColor3s.add( Input( 'blue','GLshort' ))
glSecondaryColor3s.version = '1.4'
glSecondaryColor3s.category = 'GL_VERSION_1_4'
glSecondaryColor3s.trace = True
glSecondaryColor3s.play = True
gl.add(glSecondaryColor3s)

glSecondaryColor3sv = Function('glSecondaryColor3sv')
glSecondaryColor3sv.ret = Return('void')
glSecondaryColor3sv.add( Input( 'v','const GLshort *' ,size = 3 ))
glSecondaryColor3sv.version = '1.4'
glSecondaryColor3sv.category = 'GL_VERSION_1_4'
glSecondaryColor3sv.trace = True
glSecondaryColor3sv.play = True
gl.add(glSecondaryColor3sv)

glSecondaryColor3ub = Function('glSecondaryColor3ub')
glSecondaryColor3ub.ret = Return('void')
glSecondaryColor3ub.add( Input( 'red','GLubyte' ))
glSecondaryColor3ub.add( Input( 'green','GLubyte' ))
glSecondaryColor3ub.add( Input( 'blue','GLubyte' ))
glSecondaryColor3ub.version = '1.4'
glSecondaryColor3ub.category = 'GL_VERSION_1_4'
glSecondaryColor3ub.trace = True
glSecondaryColor3ub.play = True
gl.add(glSecondaryColor3ub)

glSecondaryColor3ubv = Function('glSecondaryColor3ubv')
glSecondaryColor3ubv.ret = Return('void')
glSecondaryColor3ubv.add( Input( 'v','const GLubyte *' ,size = 3 ))
glSecondaryColor3ubv.version = '1.4'
glSecondaryColor3ubv.category = 'GL_VERSION_1_4'
glSecondaryColor3ubv.trace = True
glSecondaryColor3ubv.play = True
gl.add(glSecondaryColor3ubv)

glSecondaryColor3ui = Function('glSecondaryColor3ui')
glSecondaryColor3ui.ret = Return('void')
glSecondaryColor3ui.add( Input( 'red','GLuint' ))
glSecondaryColor3ui.add( Input( 'green','GLuint' ))
glSecondaryColor3ui.add( Input( 'blue','GLuint' ))
glSecondaryColor3ui.version = '1.4'
glSecondaryColor3ui.category = 'GL_VERSION_1_4'
glSecondaryColor3ui.trace = True
glSecondaryColor3ui.play = True
gl.add(glSecondaryColor3ui)

glSecondaryColor3uiv = Function('glSecondaryColor3uiv')
glSecondaryColor3uiv.ret = Return('void')
glSecondaryColor3uiv.add( Input( 'v','const GLuint *' ,size = 3 ))
glSecondaryColor3uiv.version = '1.4'
glSecondaryColor3uiv.category = 'GL_VERSION_1_4'
glSecondaryColor3uiv.trace = True
glSecondaryColor3uiv.play = True
gl.add(glSecondaryColor3uiv)

glSecondaryColor3us = Function('glSecondaryColor3us')
glSecondaryColor3us.ret = Return('void')
glSecondaryColor3us.add( Input( 'red','GLushort' ))
glSecondaryColor3us.add( Input( 'green','GLushort' ))
glSecondaryColor3us.add( Input( 'blue','GLushort' ))
glSecondaryColor3us.version = '1.4'
glSecondaryColor3us.category = 'GL_VERSION_1_4'
glSecondaryColor3us.trace = True
glSecondaryColor3us.play = True
gl.add(glSecondaryColor3us)

glSecondaryColor3usv = Function('glSecondaryColor3usv')
glSecondaryColor3usv.ret = Return('void')
glSecondaryColor3usv.add( Input( 'v','const GLushort *' ,size = 3 ))
glSecondaryColor3usv.version = '1.4'
glSecondaryColor3usv.category = 'GL_VERSION_1_4'
glSecondaryColor3usv.trace = True
glSecondaryColor3usv.play = True
gl.add(glSecondaryColor3usv)

glSecondaryColorPointer = Function('glSecondaryColorPointer')
glSecondaryColorPointer.ret = Return('void')
glSecondaryColorPointer.add( Input( 'size','GLint' ))
glSecondaryColorPointer.add( Input( 'type','GLenum' ))
glSecondaryColorPointer.add( Input( 'stride','GLsizei' ))
glSecondaryColorPointer.add( Input( 'pointer','const GLvoid *' ))
glSecondaryColorPointer.version = '1.4'
glSecondaryColorPointer.category = 'GL_VERSION_1_4'
glSecondaryColorPointer.trace = True
glSecondaryColorPointer.play = True
gl.add(glSecondaryColorPointer)

glWindowPos2d = Function('glWindowPos2d')
glWindowPos2d.ret = Return('void')
glWindowPos2d.add( Input( 'x','GLdouble' ))
glWindowPos2d.add( Input( 'y','GLdouble' ))
glWindowPos2d.version = '1.4'
glWindowPos2d.category = 'GL_VERSION_1_4'
glWindowPos2d.trace = True
glWindowPos2d.play = True
gl.add(glWindowPos2d)

glWindowPos2dv = Function('glWindowPos2dv')
glWindowPos2dv.ret = Return('void')
glWindowPos2dv.add( Input( 'p','const GLdouble *' ,size = 2 ))
glWindowPos2dv.version = '1.4'
glWindowPos2dv.category = 'GL_VERSION_1_4'
glWindowPos2dv.trace = True
glWindowPos2dv.play = True
gl.add(glWindowPos2dv)

glWindowPos2f = Function('glWindowPos2f')
glWindowPos2f.ret = Return('void')
glWindowPos2f.add( Input( 'x','GLfloat' ))
glWindowPos2f.add( Input( 'y','GLfloat' ))
glWindowPos2f.version = '1.4'
glWindowPos2f.category = 'GL_VERSION_1_4'
glWindowPos2f.trace = True
glWindowPos2f.play = True
gl.add(glWindowPos2f)

glWindowPos2fv = Function('glWindowPos2fv')
glWindowPos2fv.ret = Return('void')
glWindowPos2fv.add( Input( 'p','const GLfloat *' ,size = 2 ))
glWindowPos2fv.version = '1.4'
glWindowPos2fv.category = 'GL_VERSION_1_4'
glWindowPos2fv.trace = True
glWindowPos2fv.play = True
gl.add(glWindowPos2fv)

glWindowPos2i = Function('glWindowPos2i')
glWindowPos2i.ret = Return('void')
glWindowPos2i.add( Input( 'x','GLint' ))
glWindowPos2i.add( Input( 'y','GLint' ))
glWindowPos2i.version = '1.4'
glWindowPos2i.category = 'GL_VERSION_1_4'
glWindowPos2i.trace = True
glWindowPos2i.play = True
gl.add(glWindowPos2i)

glWindowPos2iv = Function('glWindowPos2iv')
glWindowPos2iv.ret = Return('void')
glWindowPos2iv.add( Input( 'p','const GLint *' ,size = 2 ))
glWindowPos2iv.version = '1.4'
glWindowPos2iv.category = 'GL_VERSION_1_4'
glWindowPos2iv.trace = True
glWindowPos2iv.play = True
gl.add(glWindowPos2iv)

glWindowPos2s = Function('glWindowPos2s')
glWindowPos2s.ret = Return('void')
glWindowPos2s.add( Input( 'x','GLshort' ))
glWindowPos2s.add( Input( 'y','GLshort' ))
glWindowPos2s.version = '1.4'
glWindowPos2s.category = 'GL_VERSION_1_4'
glWindowPos2s.trace = True
glWindowPos2s.play = True
gl.add(glWindowPos2s)

glWindowPos2sv = Function('glWindowPos2sv')
glWindowPos2sv.ret = Return('void')
glWindowPos2sv.add( Input( 'p','const GLshort *' ,size = 2 ))
glWindowPos2sv.version = '1.4'
glWindowPos2sv.category = 'GL_VERSION_1_4'
glWindowPos2sv.trace = True
glWindowPos2sv.play = True
gl.add(glWindowPos2sv)

glWindowPos3d = Function('glWindowPos3d')
glWindowPos3d.ret = Return('void')
glWindowPos3d.add( Input( 'x','GLdouble' ))
glWindowPos3d.add( Input( 'y','GLdouble' ))
glWindowPos3d.add( Input( 'z','GLdouble' ))
glWindowPos3d.version = '1.4'
glWindowPos3d.category = 'GL_VERSION_1_4'
glWindowPos3d.trace = True
glWindowPos3d.play = True
gl.add(glWindowPos3d)

glWindowPos3dv = Function('glWindowPos3dv')
glWindowPos3dv.ret = Return('void')
glWindowPos3dv.add( Input( 'p','const GLdouble *' ,size = 3 ))
glWindowPos3dv.version = '1.4'
glWindowPos3dv.category = 'GL_VERSION_1_4'
glWindowPos3dv.trace = True
glWindowPos3dv.play = True
gl.add(glWindowPos3dv)

glWindowPos3f = Function('glWindowPos3f')
glWindowPos3f.ret = Return('void')
glWindowPos3f.add( Input( 'x','GLfloat' ))
glWindowPos3f.add( Input( 'y','GLfloat' ))
glWindowPos3f.add( Input( 'z','GLfloat' ))
glWindowPos3f.version = '1.4'
glWindowPos3f.category = 'GL_VERSION_1_4'
glWindowPos3f.trace = True
glWindowPos3f.play = True
gl.add(glWindowPos3f)

glWindowPos3fv = Function('glWindowPos3fv')
glWindowPos3fv.ret = Return('void')
glWindowPos3fv.add( Input( 'p','const GLfloat *' ,size = 3 ))
glWindowPos3fv.version = '1.4'
glWindowPos3fv.category = 'GL_VERSION_1_4'
glWindowPos3fv.trace = True
glWindowPos3fv.play = True
gl.add(glWindowPos3fv)

glWindowPos3i = Function('glWindowPos3i')
glWindowPos3i.ret = Return('void')
glWindowPos3i.add( Input( 'x','GLint' ))
glWindowPos3i.add( Input( 'y','GLint' ))
glWindowPos3i.add( Input( 'z','GLint' ))
glWindowPos3i.version = '1.4'
glWindowPos3i.category = 'GL_VERSION_1_4'
glWindowPos3i.trace = True
glWindowPos3i.play = True
gl.add(glWindowPos3i)

glWindowPos3iv = Function('glWindowPos3iv')
glWindowPos3iv.ret = Return('void')
glWindowPos3iv.add( Input( 'p','const GLint *' ,size = 3 ))
glWindowPos3iv.version = '1.4'
glWindowPos3iv.category = 'GL_VERSION_1_4'
glWindowPos3iv.trace = True
glWindowPos3iv.play = True
gl.add(glWindowPos3iv)

glWindowPos3s = Function('glWindowPos3s')
glWindowPos3s.ret = Return('void')
glWindowPos3s.add( Input( 'x','GLshort' ))
glWindowPos3s.add( Input( 'y','GLshort' ))
glWindowPos3s.add( Input( 'z','GLshort' ))
glWindowPos3s.version = '1.4'
glWindowPos3s.category = 'GL_VERSION_1_4'
glWindowPos3s.trace = True
glWindowPos3s.play = True
gl.add(glWindowPos3s)

glWindowPos3sv = Function('glWindowPos3sv')
glWindowPos3sv.ret = Return('void')
glWindowPos3sv.add( Input( 'p','const GLshort *' ,size = 3 ))
glWindowPos3sv.version = '1.4'
glWindowPos3sv.category = 'GL_VERSION_1_4'
glWindowPos3sv.trace = True
glWindowPos3sv.play = True
gl.add(glWindowPos3sv)

# GL_VERSION_1_5

glBeginQuery = Function('glBeginQuery')
glBeginQuery.ret = Return('void')
glBeginQuery.add( Input( 'target','GLenum' ))
glBeginQuery.add( Input( 'id','GLuint' ))
glBeginQuery.version = '1.5'
glBeginQuery.category = 'GL_VERSION_1_5'
glBeginQuery.trace = True
glBeginQuery.play = True
gl.add(glBeginQuery)

glBindBuffer = Function('glBindBuffer')
glBindBuffer.ret = Return('void')
glBindBuffer.add( Input( 'target','GLenum' ))
glBindBuffer.add( Input( 'buffer','GLuint' ))
glBindBuffer.version = '1.5'
glBindBuffer.category = 'GL_VERSION_1_5'
glBindBuffer.esVersions = [1.1, 2.0]
glBindBuffer.trace = True
glBindBuffer.play = True
gl.add(glBindBuffer)

glBufferData = Function('glBufferData')
glBufferData.ret = Return('void')
glBufferData.add( Input( 'target','GLenum' ))
glBufferData.add( Input( 'size','GLsizeiptr' ))
glBufferData.add( Input( 'data','const GLvoid *' ))
glBufferData.add( Input( 'usage','GLenum' ))
glBufferData.version = '1.5'
glBufferData.category = 'GL_VERSION_1_5'
glBufferData.esVersions = [1.1, 2.0]
glBufferData.trace = True
glBufferData.play = True
gl.add(glBufferData)

glBufferSubData = Function('glBufferSubData')
glBufferSubData.ret = Return('void')
glBufferSubData.add( Input( 'target','GLenum' ))
glBufferSubData.add( Input( 'offset','GLintptr' ))
glBufferSubData.add( Input( 'size','GLsizeiptr' ))
glBufferSubData.add( Input( 'data','const GLvoid *' ))
glBufferSubData.version = '1.5'
glBufferSubData.category = 'GL_VERSION_1_5'
glBufferSubData.esVersions = [1.1, 2.0]
glBufferSubData.trace = True
glBufferSubData.play = True
gl.add(glBufferSubData)

glDeleteBuffers = Function('glDeleteBuffers')
glDeleteBuffers.ret = Return('void')
glDeleteBuffers.add( Input( 'n','GLsizei' ))
glDeleteBuffers.add( Input( 'buffers','const GLuint *' ,size = 'n' ))
glDeleteBuffers.version = '1.5'
glDeleteBuffers.category = 'GL_VERSION_1_5'
glDeleteBuffers.esVersions = [1.1, 2.0]
glDeleteBuffers.trace = True
glDeleteBuffers.play = True
gl.add(glDeleteBuffers)

glDeleteQueries = Function('glDeleteQueries')
glDeleteQueries.ret = Return('void')
glDeleteQueries.add( Input( 'n','GLsizei' ))
glDeleteQueries.add( Input( 'ids','const GLuint *' ,size = 'n' ))
glDeleteQueries.version = '1.5'
glDeleteQueries.category = 'GL_VERSION_1_5'
glDeleteQueries.trace = True
glDeleteQueries.play = True
gl.add(glDeleteQueries)

glEndQuery = Function('glEndQuery')
glEndQuery.ret = Return('void')
glEndQuery.add( Input( 'target','GLenum' ))
glEndQuery.version = '1.5'
glEndQuery.category = 'GL_VERSION_1_5'
glEndQuery.trace = True
glEndQuery.play = True
gl.add(glEndQuery)

glGenBuffers = Function('glGenBuffers')
glGenBuffers.ret = Return('void')
glGenBuffers.add( Input( 'n','GLsizei' ))
glGenBuffers.add( Output( 'buffers','GLuint *' ,size = 'n' ))
glGenBuffers.version = '1.5'
glGenBuffers.category = 'GL_VERSION_1_5'
glGenBuffers.esVersions = [1.1, 2.0]
glGenBuffers.trace = True
glGenBuffers.play = True
gl.add(glGenBuffers)

glGenQueries = Function('glGenQueries')
glGenQueries.ret = Return('void')
glGenQueries.add( Input( 'n','GLsizei' ))
glGenQueries.add( Output( 'ids','GLuint *' ,size = 'n' ))
glGenQueries.version = '1.5'
glGenQueries.category = 'GL_VERSION_1_5'
glGenQueries.trace = True
glGenQueries.play = True
gl.add(glGenQueries)

glGetBufferParameteriv = Function('glGetBufferParameteriv')
glGetBufferParameteriv.ret = Return('void')
glGetBufferParameteriv.add( Input( 'target','GLenum' ))
glGetBufferParameteriv.add( Input( 'pname','GLenum' ))
glGetBufferParameteriv.add( Output( 'params','GLint *' ))
glGetBufferParameteriv.version = '1.5'
glGetBufferParameteriv.category = 'GL_VERSION_1_5'
glGetBufferParameteriv.esVersions = [1.1, 2.0]
glGetBufferParameteriv.trace = True
glGetBufferParameteriv.play = True
gl.add(glGetBufferParameteriv)

glGetBufferPointerv = Function('glGetBufferPointerv')
glGetBufferPointerv.ret = Return('void')
glGetBufferPointerv.add( Input( 'target','GLenum' ))
glGetBufferPointerv.add( Input( 'pname','GLenum' ))
glGetBufferPointerv.add( Output( 'params','GLvoid **' ,size = 1 ))
glGetBufferPointerv.version = '1.5'
glGetBufferPointerv.category = 'GL_VERSION_1_5'
glGetBufferPointerv.trace = True
glGetBufferPointerv.play = True
gl.add(glGetBufferPointerv)

glGetBufferSubData = Function('glGetBufferSubData')
glGetBufferSubData.ret = Return('void')
glGetBufferSubData.add( Input( 'target','GLenum' ))
glGetBufferSubData.add( Input( 'offset','GLintptr' ))
glGetBufferSubData.add( Input( 'size','GLsizeiptr' ))
glGetBufferSubData.add( Output( 'data','GLvoid *' ))
glGetBufferSubData.version = '1.5'
glGetBufferSubData.category = 'GL_VERSION_1_5'
glGetBufferSubData.trace = True
glGetBufferSubData.play = True
gl.add(glGetBufferSubData)

glGetQueryObjectiv = Function('glGetQueryObjectiv')
glGetQueryObjectiv.ret = Return('void')
glGetQueryObjectiv.add( Input( 'id','GLuint' ))
glGetQueryObjectiv.add( Input( 'pname','GLenum' ))
glGetQueryObjectiv.add( Output( 'params','GLint *' ))
glGetQueryObjectiv.version = '1.5'
glGetQueryObjectiv.category = 'GL_VERSION_1_5'
glGetQueryObjectiv.trace = True
glGetQueryObjectiv.play = False
gl.add(glGetQueryObjectiv)

glGetQueryObjectuiv = Function('glGetQueryObjectuiv')
glGetQueryObjectuiv.ret = Return('void')
glGetQueryObjectuiv.add( Input( 'id','GLuint' ))
glGetQueryObjectuiv.add( Input( 'pname','GLenum' ))
glGetQueryObjectuiv.add( Output( 'params','GLuint *' ))
glGetQueryObjectuiv.version = '1.5'
glGetQueryObjectuiv.category = 'GL_VERSION_1_5'
glGetQueryObjectuiv.trace = True
glGetQueryObjectuiv.play = False
gl.add(glGetQueryObjectuiv)

glGetQueryiv = Function('glGetQueryiv')
glGetQueryiv.ret = Return('void')
glGetQueryiv.add( Input( 'target','GLenum' ))
glGetQueryiv.add( Input( 'pname','GLenum' ))
glGetQueryiv.add( Output( 'params','GLint *' ))
glGetQueryiv.version = '1.5'
glGetQueryiv.category = 'GL_VERSION_1_5'
glGetQueryiv.trace = True
glGetQueryiv.play = False
gl.add(glGetQueryiv)

glIsBuffer = Function('glIsBuffer')
glIsBuffer.ret = Return('GLboolean')
glIsBuffer.add( Input( 'buffer','GLuint' ))
glIsBuffer.version = '1.5'
glIsBuffer.category = 'GL_VERSION_1_5'
glIsBuffer.esVersions = [1.1, 2.0]
glIsBuffer.trace = True
glIsBuffer.play = True
gl.add(glIsBuffer)

glIsQuery = Function('glIsQuery')
glIsQuery.ret = Return('GLboolean')
glIsQuery.add( Input( 'id','GLuint' ))
glIsQuery.version = '1.5'
glIsQuery.category = 'GL_VERSION_1_5'
glIsQuery.trace = True
glIsQuery.play = True
gl.add(glIsQuery)

glMapBuffer = Function('glMapBuffer')
glMapBuffer.ret = Return('GLvoid *')
glMapBuffer.add( Input( 'target','GLenum' ))
glMapBuffer.add( Input( 'access','GLenum' ))
glMapBuffer.version = '1.5'
glMapBuffer.category = 'GL_VERSION_1_5'
glMapBuffer.trace = True
glMapBuffer.play = True
gl.add(glMapBuffer)

glUnmapBuffer = Function('glUnmapBuffer')
glUnmapBuffer.ret = Return('GLboolean')
glUnmapBuffer.add( Input( 'target','GLenum' ))
glUnmapBuffer.version = '1.5'
glUnmapBuffer.category = 'GL_VERSION_1_5'
glUnmapBuffer.trace = True
glUnmapBuffer.play = True
gl.add(glUnmapBuffer)

# GL_VERSION_2_0

glAttachShader = Function('glAttachShader')
glAttachShader.ret = Return('void')
glAttachShader.add( Input( 'program','GLuint' ))
glAttachShader.add( Input( 'shader','GLuint' ))
glAttachShader.version = '2.0'
glAttachShader.category = 'GL_VERSION_2_0'
glAttachShader.esVersions = [2.0]
glAttachShader.trace = True
glAttachShader.play = True
gl.add(glAttachShader)

glBindAttribLocation = Function('glBindAttribLocation')
glBindAttribLocation.ret = Return('void')
glBindAttribLocation.add( Input( 'program','GLuint' ))
glBindAttribLocation.add( Input( 'index','GLuint' ))
glBindAttribLocation.add( Input( 'name','const GLchar *' ))
glBindAttribLocation.version = '2.0'
glBindAttribLocation.category = 'GL_VERSION_2_0'
glBindAttribLocation.esVersions = [2.0]
glBindAttribLocation.trace = True
glBindAttribLocation.play = True
gl.add(glBindAttribLocation)

glBlendEquationSeparate = Function('glBlendEquationSeparate')
glBlendEquationSeparate.ret = Return('void')
glBlendEquationSeparate.add( Input( 'modeRGB','GLenum' ,regalLog = 'GLmodeToString(modeRGB)' ))
glBlendEquationSeparate.add( Input( 'modeAlpha','GLenum' ,regalLog = 'GLmodeToString(modeAlpha)' ))
glBlendEquationSeparate.version = '2.0'
glBlendEquationSeparate.category = 'GL_VERSION_2_0'
glBlendEquationSeparate.esVersions = [2.0]
glBlendEquationSeparate.trace = True
glBlendEquationSeparate.play = True
gl.add(glBlendEquationSeparate)

glCompileShader = Function('glCompileShader')
glCompileShader.ret = Return('void')
glCompileShader.add( Input( 'shader','GLuint' ))
glCompileShader.version = '2.0'
glCompileShader.category = 'GL_VERSION_2_0'
glCompileShader.esVersions = [2.0]
glCompileShader.trace = True
glCompileShader.play = True
gl.add(glCompileShader)

glCreateProgram = Function('glCreateProgram')
glCreateProgram.ret = Return('GLuint')
glCreateProgram.version = '2.0'
glCreateProgram.category = 'GL_VERSION_2_0'
glCreateProgram.esVersions = [2.0]
glCreateProgram.trace = True
glCreateProgram.play = True
gl.add(glCreateProgram)

glCreateShader = Function('glCreateShader')
glCreateShader.ret = Return('GLuint')
glCreateShader.add( Input( 'type','GLenum' ))
glCreateShader.version = '2.0'
glCreateShader.category = 'GL_VERSION_2_0'
glCreateShader.esVersions = [2.0]
glCreateShader.trace = True
glCreateShader.play = True
gl.add(glCreateShader)

glDeleteProgram = Function('glDeleteProgram')
glDeleteProgram.ret = Return('void')
glDeleteProgram.add( Input( 'program','GLuint' ))
glDeleteProgram.version = '2.0'
glDeleteProgram.category = 'GL_VERSION_2_0'
glDeleteProgram.esVersions = [2.0]
glDeleteProgram.trace = True
glDeleteProgram.play = True
gl.add(glDeleteProgram)

glDeleteShader = Function('glDeleteShader')
glDeleteShader.ret = Return('void')
glDeleteShader.add( Input( 'shader','GLuint' ))
glDeleteShader.version = '2.0'
glDeleteShader.category = 'GL_VERSION_2_0'
glDeleteShader.esVersions = [2.0]
glDeleteShader.trace = True
glDeleteShader.play = True
gl.add(glDeleteShader)

glDetachShader = Function('glDetachShader')
glDetachShader.ret = Return('void')
glDetachShader.add( Input( 'program','GLuint' ))
glDetachShader.add( Input( 'shader','GLuint' ))
glDetachShader.version = '2.0'
glDetachShader.category = 'GL_VERSION_2_0'
glDetachShader.esVersions = [2.0]
glDetachShader.trace = True
glDetachShader.play = True
gl.add(glDetachShader)

glDisableVertexAttribArray = Function('glDisableVertexAttribArray')
glDisableVertexAttribArray.ret = Return('void')
glDisableVertexAttribArray.add( Input( 'index','GLuint' ))
glDisableVertexAttribArray.version = '2.0'
glDisableVertexAttribArray.category = 'GL_VERSION_2_0'
glDisableVertexAttribArray.esVersions = [2.0]
glDisableVertexAttribArray.trace = True
glDisableVertexAttribArray.play = True
gl.add(glDisableVertexAttribArray)

glDrawBuffers = Function('glDrawBuffers')
glDrawBuffers.ret = Return('void')
glDrawBuffers.add( Input( 'n','GLsizei' ))
glDrawBuffers.add( Input( 'bufs','const GLenum *' ,size = 'n' ))
glDrawBuffers.version = '2.0'
glDrawBuffers.category = 'GL_VERSION_2_0'
glDrawBuffers.trace = True
glDrawBuffers.play = True
gl.add(glDrawBuffers)

glEnableVertexAttribArray = Function('glEnableVertexAttribArray')
glEnableVertexAttribArray.ret = Return('void')
glEnableVertexAttribArray.add( Input( 'index','GLuint' ))
glEnableVertexAttribArray.version = '2.0'
glEnableVertexAttribArray.category = 'GL_VERSION_2_0'
glEnableVertexAttribArray.esVersions = [2.0]
glEnableVertexAttribArray.trace = True
glEnableVertexAttribArray.play = True
gl.add(glEnableVertexAttribArray)

glGetActiveAttrib = Function('glGetActiveAttrib')
glGetActiveAttrib.ret = Return('void')
glGetActiveAttrib.add( Input( 'program','GLuint' ))
glGetActiveAttrib.add( Input( 'index','GLuint' ))
glGetActiveAttrib.add( Input( 'bufSize','GLsizei' ))
glGetActiveAttrib.add( Output( 'length','GLsizei *' ,size = 1 ))
glGetActiveAttrib.add( Output( 'size','GLint *' ,size = 1 ))
glGetActiveAttrib.add( Output( 'type','GLenum *' ,size = 1 ))
glGetActiveAttrib.add( Output( 'name','GLchar *' ,maxSize = 'bufSize' ))
glGetActiveAttrib.version = '2.0'
glGetActiveAttrib.category = 'GL_VERSION_2_0'
glGetActiveAttrib.esVersions = [2.0]
glGetActiveAttrib.trace = True
glGetActiveAttrib.play = False
gl.add(glGetActiveAttrib)

glGetActiveUniform = Function('glGetActiveUniform')
glGetActiveUniform.ret = Return('void')
glGetActiveUniform.add( Input( 'program','GLuint' ))
glGetActiveUniform.add( Input( 'index','GLuint' ))
glGetActiveUniform.add( Input( 'bufSize','GLsizei' ))
glGetActiveUniform.add( Output( 'length','GLsizei *' ,size = 1 ))
glGetActiveUniform.add( Output( 'size','GLint *' ,size = 1 ))
glGetActiveUniform.add( Output( 'type','GLenum *' ,size = 1 ))
glGetActiveUniform.add( Output( 'name','GLchar *' ,maxSize = 'bufSize' ))
glGetActiveUniform.version = '2.0'
glGetActiveUniform.category = 'GL_VERSION_2_0'
glGetActiveUniform.esVersions = [2.0]
glGetActiveUniform.trace = True
glGetActiveUniform.play = False
gl.add(glGetActiveUniform)

glGetAttachedShaders = Function('glGetAttachedShaders')
glGetAttachedShaders.ret = Return('void')
glGetAttachedShaders.add( Input( 'program','GLuint' ))
glGetAttachedShaders.add( Input( 'maxCount','GLsizei' ))
glGetAttachedShaders.add( Output( 'count','GLsizei *' ,size = 1 ))
glGetAttachedShaders.add( Output( 'shaders','GLuint *' ,size = 'count ? *count : 0' ))
glGetAttachedShaders.version = '2.0'
glGetAttachedShaders.category = 'GL_VERSION_2_0'
glGetAttachedShaders.esVersions = [2.0]
glGetAttachedShaders.trace = True
glGetAttachedShaders.play = False
gl.add(glGetAttachedShaders)

glGetAttribLocation = Function('glGetAttribLocation')
glGetAttribLocation.ret = Return('GLint')
glGetAttribLocation.add( Input( 'program','GLuint' ))
glGetAttribLocation.add( Input( 'name','const GLchar *' ))
glGetAttribLocation.version = '2.0'
glGetAttribLocation.category = 'GL_VERSION_2_0'
glGetAttribLocation.esVersions = [2.0]
glGetAttribLocation.trace = True
glGetAttribLocation.play = False
gl.add(glGetAttribLocation)

glGetProgramInfoLog = Function('glGetProgramInfoLog')
glGetProgramInfoLog.ret = Return('void')
glGetProgramInfoLog.add( Input( 'program','GLuint' ))
glGetProgramInfoLog.add( Input( 'bufSize','GLsizei' ))
glGetProgramInfoLog.add( Output( 'length','GLsizei *' ,size = 'length ? 1 : 0' ))
glGetProgramInfoLog.add( Output( 'infoLog','GLchar *' ,maxSize = 'bufSize' ))
glGetProgramInfoLog.version = '2.0'
glGetProgramInfoLog.category = 'GL_VERSION_2_0'
glGetProgramInfoLog.esVersions = [2.0]
glGetProgramInfoLog.trace = True
glGetProgramInfoLog.play = False
gl.add(glGetProgramInfoLog)

glGetProgramiv = Function('glGetProgramiv')
glGetProgramiv.ret = Return('void')
glGetProgramiv.add( Input( 'program','GLuint' ))
glGetProgramiv.add( Input( 'pname','GLenum' ))
glGetProgramiv.add( Output( 'params','GLint *' ,size = 1 ))
glGetProgramiv.version = '2.0'
glGetProgramiv.category = 'GL_VERSION_2_0'
glGetProgramiv.esVersions = [2.0]
glGetProgramiv.trace = True
glGetProgramiv.play = False
gl.add(glGetProgramiv)

glGetShaderInfoLog = Function('glGetShaderInfoLog')
glGetShaderInfoLog.ret = Return('void')
glGetShaderInfoLog.add( Input( 'shader','GLuint' ))
glGetShaderInfoLog.add( Input( 'bufSize','GLsizei' ))
glGetShaderInfoLog.add( Output( 'length','GLsizei *' ,size = 'length ? 1 : 0' ))
glGetShaderInfoLog.add( Output( 'infoLog','GLchar *' ,maxSize = 'bufSize' ))
glGetShaderInfoLog.version = '2.0'
glGetShaderInfoLog.category = 'GL_VERSION_2_0'
glGetShaderInfoLog.esVersions = [2.0]
glGetShaderInfoLog.trace = True
glGetShaderInfoLog.play = False
gl.add(glGetShaderInfoLog)

glGetShaderSource = Function('glGetShaderSource')
glGetShaderSource.ret = Return('void')
glGetShaderSource.add( Input( 'shader','GLuint' ))
glGetShaderSource.add( Input( 'bufSize','GLsizei' ))
glGetShaderSource.add( Output( 'length','GLsizei *' ,size = 'length ? 1 : 0' ))
glGetShaderSource.add( Output( 'source','GLchar *' ,maxSize = 'bufSize' ))
glGetShaderSource.version = '2.0'
glGetShaderSource.category = 'GL_VERSION_2_0'
glGetShaderSource.esVersions = [2.0]
glGetShaderSource.trace = True
glGetShaderSource.play = False
gl.add(glGetShaderSource)

glGetShaderiv = Function('glGetShaderiv')
glGetShaderiv.ret = Return('void')
glGetShaderiv.add( Input( 'shader','GLuint' ))
glGetShaderiv.add( Input( 'pname','GLenum' ))
glGetShaderiv.add( Output( 'params','GLint *' ,size = 1 ))
glGetShaderiv.version = '2.0'
glGetShaderiv.category = 'GL_VERSION_2_0'
glGetShaderiv.esVersions = [2.0]
glGetShaderiv.trace = True
glGetShaderiv.play = False
gl.add(glGetShaderiv)

glGetUniformLocation = Function('glGetUniformLocation')
glGetUniformLocation.ret = Return('GLint')
glGetUniformLocation.add( Input( 'program','GLuint' ))
glGetUniformLocation.add( Input( 'name','const GLchar *' ,cast = 'const char *' ))
glGetUniformLocation.version = '2.0'
glGetUniformLocation.category = 'GL_VERSION_2_0'
glGetUniformLocation.esVersions = [2.0]
glGetUniformLocation.trace = True
glGetUniformLocation.play = False
gl.add(glGetUniformLocation)

glGetUniformfv = Function('glGetUniformfv')
glGetUniformfv.ret = Return('void')
glGetUniformfv.add( Input( 'program','GLuint' ))
glGetUniformfv.add( Input( 'location','GLint' ))
glGetUniformfv.add( Output( 'params','GLfloat *' ))
glGetUniformfv.version = '2.0'
glGetUniformfv.category = 'GL_VERSION_2_0'
glGetUniformfv.esVersions = [2.0]
glGetUniformfv.trace = True
glGetUniformfv.play = False
gl.add(glGetUniformfv)

glGetUniformiv = Function('glGetUniformiv')
glGetUniformiv.ret = Return('void')
glGetUniformiv.add( Input( 'program','GLuint' ))
glGetUniformiv.add( Input( 'location','GLint' ))
glGetUniformiv.add( Output( 'params','GLint *' ))
glGetUniformiv.version = '2.0'
glGetUniformiv.category = 'GL_VERSION_2_0'
glGetUniformiv.esVersions = [2.0]
glGetUniformiv.trace = True
glGetUniformiv.play = False
gl.add(glGetUniformiv)

glGetVertexAttribPointerv = Function('glGetVertexAttribPointerv')
glGetVertexAttribPointerv.ret = Return('void')
glGetVertexAttribPointerv.add( Input( 'index','GLuint' ))
glGetVertexAttribPointerv.add( Input( 'pname','GLenum' ))
glGetVertexAttribPointerv.add( Output( 'pointer','GLvoid **' ,size = 1 ))
glGetVertexAttribPointerv.version = '2.0'
glGetVertexAttribPointerv.category = 'GL_VERSION_2_0'
glGetVertexAttribPointerv.esVersions = [2.0]
glGetVertexAttribPointerv.trace = True
glGetVertexAttribPointerv.play = False
gl.add(glGetVertexAttribPointerv)

glGetVertexAttribdv = Function('glGetVertexAttribdv')
glGetVertexAttribdv.ret = Return('void')
glGetVertexAttribdv.add( Input( 'index','GLuint' ))
glGetVertexAttribdv.add( Input( 'pname','GLenum' ))
glGetVertexAttribdv.add( Output( 'params','GLdouble *' ,size = 4 ))
glGetVertexAttribdv.version = '2.0'
glGetVertexAttribdv.category = 'GL_VERSION_2_0'
glGetVertexAttribdv.trace = True
glGetVertexAttribdv.play = False
gl.add(glGetVertexAttribdv)

glGetVertexAttribfv = Function('glGetVertexAttribfv')
glGetVertexAttribfv.ret = Return('void')
glGetVertexAttribfv.add( Input( 'index','GLuint' ))
glGetVertexAttribfv.add( Input( 'pname','GLenum' ))
glGetVertexAttribfv.add( Output( 'params','GLfloat *' ,size = 4 ))
glGetVertexAttribfv.version = '2.0'
glGetVertexAttribfv.category = 'GL_VERSION_2_0'
glGetVertexAttribfv.esVersions = [2.0]
glGetVertexAttribfv.trace = True
glGetVertexAttribfv.play = False
gl.add(glGetVertexAttribfv)

glGetVertexAttribiv = Function('glGetVertexAttribiv')
glGetVertexAttribiv.ret = Return('void')
glGetVertexAttribiv.add( Input( 'index','GLuint' ))
glGetVertexAttribiv.add( Input( 'pname','GLenum' ))
glGetVertexAttribiv.add( Output( 'params','GLint *' ,size = 4 ))
glGetVertexAttribiv.version = '2.0'
glGetVertexAttribiv.category = 'GL_VERSION_2_0'
glGetVertexAttribiv.esVersions = [2.0]
glGetVertexAttribiv.trace = True
glGetVertexAttribiv.play = False
gl.add(glGetVertexAttribiv)

glIsProgram = Function('glIsProgram')
glIsProgram.ret = Return('GLboolean')
glIsProgram.add( Input( 'program','GLuint' ))
glIsProgram.version = '2.0'
glIsProgram.category = 'GL_VERSION_2_0'
glIsProgram.esVersions = [2.0]
glIsProgram.trace = True
glIsProgram.play = True
gl.add(glIsProgram)

glIsShader = Function('glIsShader')
glIsShader.ret = Return('GLboolean')
glIsShader.add( Input( 'shader','GLuint' ))
glIsShader.version = '2.0'
glIsShader.category = 'GL_VERSION_2_0'
glIsShader.esVersions = [2.0]
glIsShader.trace = True
glIsShader.play = True
gl.add(glIsShader)

glLinkProgram = Function('glLinkProgram')
glLinkProgram.ret = Return('void')
glLinkProgram.add( Input( 'program','GLuint' ))
glLinkProgram.version = '2.0'
glLinkProgram.category = 'GL_VERSION_2_0'
glLinkProgram.esVersions = [2.0]
glLinkProgram.trace = True
glLinkProgram.play = True
gl.add(glLinkProgram)

glShaderSource = Function('glShaderSource')
glShaderSource.ret = Return('void')
glShaderSource.add( Input( 'shader','GLuint' ))
glShaderSource.add( Input( 'count','GLsizei' ))
glShaderSource.add( Input( 'string','const GLchar * const *' ,size = 'string ? count : 0' ,cast = 'const char * const *' ))
glShaderSource.add( Input( 'length','const GLint *' ,size = 'length ? count : 0' ))
glShaderSource.version = '2.0'
glShaderSource.category = 'GL_VERSION_2_0'
glShaderSource.esVersions = [2.0]
glShaderSource.trace = True
glShaderSource.play = False
gl.add(glShaderSource)

glStencilFuncSeparate = Function('glStencilFuncSeparate')
glStencilFuncSeparate.ret = Return('void')
glStencilFuncSeparate.add( Input( 'face','GLenum' ))
glStencilFuncSeparate.add( Input( 'func','GLenum' ))
glStencilFuncSeparate.add( Input( 'ref','GLint' ,regalLog = 'boost::print::hex(ref)' ))
glStencilFuncSeparate.add( Input( 'mask','GLuint' ,regalLog = 'boost::print::hex(mask)' ))
glStencilFuncSeparate.version = '2.0'
glStencilFuncSeparate.category = 'GL_VERSION_2_0'
glStencilFuncSeparate.esVersions = [2.0]
glStencilFuncSeparate.trace = True
glStencilFuncSeparate.play = True
gl.add(glStencilFuncSeparate)

glStencilMaskSeparate = Function('glStencilMaskSeparate')
glStencilMaskSeparate.ret = Return('void')
glStencilMaskSeparate.add( Input( 'face','GLenum' ))
glStencilMaskSeparate.add( Input( 'mask','GLuint' ,regalLog = 'boost::print::hex(mask)' ))
glStencilMaskSeparate.version = '2.0'
glStencilMaskSeparate.category = 'GL_VERSION_2_0'
glStencilMaskSeparate.esVersions = [2.0]
glStencilMaskSeparate.trace = True
glStencilMaskSeparate.play = True
gl.add(glStencilMaskSeparate)

glStencilOpSeparate = Function('glStencilOpSeparate')
glStencilOpSeparate.ret = Return('void')
glStencilOpSeparate.add( Input( 'face','GLenum' ))
glStencilOpSeparate.add( Input( 'fail','GLenum' ))
glStencilOpSeparate.add( Input( 'zfail','GLenum' ))
glStencilOpSeparate.add( Input( 'zpass','GLenum' ))
glStencilOpSeparate.version = '2.0'
glStencilOpSeparate.category = 'GL_VERSION_2_0'
glStencilOpSeparate.esVersions = [2.0]
glStencilOpSeparate.trace = True
glStencilOpSeparate.play = True
gl.add(glStencilOpSeparate)

glUniform1f = Function('glUniform1f')
glUniform1f.ret = Return('void')
glUniform1f.add( Input( 'location','GLint' ))
glUniform1f.add( Input( 'v0','GLfloat' ))
glUniform1f.version = '2.0'
glUniform1f.category = 'GL_VERSION_2_0'
glUniform1f.esVersions = [2.0]
glUniform1f.trace = True
glUniform1f.play = True
gl.add(glUniform1f)

glUniform1fv = Function('glUniform1fv')
glUniform1fv.ret = Return('void')
glUniform1fv.add( Input( 'location','GLint' ))
glUniform1fv.add( Input( 'count','GLsizei' ))
glUniform1fv.add( Input( 'value','const GLfloat *' ,size = '1 * count' ))
glUniform1fv.version = '2.0'
glUniform1fv.category = 'GL_VERSION_2_0'
glUniform1fv.esVersions = [2.0]
glUniform1fv.trace = True
glUniform1fv.play = True
gl.add(glUniform1fv)

glUniform1i = Function('glUniform1i')
glUniform1i.ret = Return('void')
glUniform1i.add( Input( 'location','GLint' ))
glUniform1i.add( Input( 'v0','GLint' ))
glUniform1i.version = '2.0'
glUniform1i.category = 'GL_VERSION_2_0'
glUniform1i.esVersions = [2.0]
glUniform1i.trace = True
glUniform1i.play = True
gl.add(glUniform1i)

glUniform1iv = Function('glUniform1iv')
glUniform1iv.ret = Return('void')
glUniform1iv.add( Input( 'location','GLint' ))
glUniform1iv.add( Input( 'count','GLsizei' ))
glUniform1iv.add( Input( 'value','const GLint *' ,size = 'count' ))
glUniform1iv.version = '2.0'
glUniform1iv.category = 'GL_VERSION_2_0'
glUniform1iv.esVersions = [2.0]
glUniform1iv.trace = True
glUniform1iv.play = True
gl.add(glUniform1iv)

glUniform2f = Function('glUniform2f')
glUniform2f.ret = Return('void')
glUniform2f.add( Input( 'location','GLint' ))
glUniform2f.add( Input( 'v0','GLfloat' ))
glUniform2f.add( Input( 'v1','GLfloat' ))
glUniform2f.version = '2.0'
glUniform2f.category = 'GL_VERSION_2_0'
glUniform2f.esVersions = [2.0]
glUniform2f.trace = True
glUniform2f.play = True
gl.add(glUniform2f)

glUniform2fv = Function('glUniform2fv')
glUniform2fv.ret = Return('void')
glUniform2fv.add( Input( 'location','GLint' ))
glUniform2fv.add( Input( 'count','GLsizei' ))
glUniform2fv.add( Input( 'value','const GLfloat *' ,size = 'count' ))
glUniform2fv.version = '2.0'
glUniform2fv.category = 'GL_VERSION_2_0'
glUniform2fv.esVersions = [2.0]
glUniform2fv.trace = True
glUniform2fv.play = True
gl.add(glUniform2fv)

glUniform2i = Function('glUniform2i')
glUniform2i.ret = Return('void')
glUniform2i.add( Input( 'location','GLint' ))
glUniform2i.add( Input( 'v0','GLint' ))
glUniform2i.add( Input( 'v1','GLint' ))
glUniform2i.version = '2.0'
glUniform2i.category = 'GL_VERSION_2_0'
glUniform2i.esVersions = [2.0]
glUniform2i.trace = True
glUniform2i.play = True
gl.add(glUniform2i)

glUniform2iv = Function('glUniform2iv')
glUniform2iv.ret = Return('void')
glUniform2iv.add( Input( 'location','GLint' ))
glUniform2iv.add( Input( 'count','GLsizei' ))
glUniform2iv.add( Input( 'value','const GLint *' ,size = '2 * count' ))
glUniform2iv.version = '2.0'
glUniform2iv.category = 'GL_VERSION_2_0'
glUniform2iv.esVersions = [2.0]
glUniform2iv.trace = True
glUniform2iv.play = True
gl.add(glUniform2iv)

glUniform3f = Function('glUniform3f')
glUniform3f.ret = Return('void')
glUniform3f.add( Input( 'location','GLint' ))
glUniform3f.add( Input( 'v0','GLfloat' ))
glUniform3f.add( Input( 'v1','GLfloat' ))
glUniform3f.add( Input( 'v2','GLfloat' ))
glUniform3f.version = '2.0'
glUniform3f.category = 'GL_VERSION_2_0'
glUniform3f.esVersions = [2.0]
glUniform3f.trace = True
glUniform3f.play = True
gl.add(glUniform3f)

glUniform3fv = Function('glUniform3fv')
glUniform3fv.ret = Return('void')
glUniform3fv.add( Input( 'location','GLint' ))
glUniform3fv.add( Input( 'count','GLsizei' ))
glUniform3fv.add( Input( 'value','const GLfloat *' ,size = '3 * count' ))
glUniform3fv.version = '2.0'
glUniform3fv.category = 'GL_VERSION_2_0'
glUniform3fv.esVersions = [2.0]
glUniform3fv.trace = True
glUniform3fv.play = True
gl.add(glUniform3fv)

glUniform3i = Function('glUniform3i')
glUniform3i.ret = Return('void')
glUniform3i.add( Input( 'location','GLint' ))
glUniform3i.add( Input( 'v0','GLint' ))
glUniform3i.add( Input( 'v1','GLint' ))
glUniform3i.add( Input( 'v2','GLint' ))
glUniform3i.version = '2.0'
glUniform3i.category = 'GL_VERSION_2_0'
glUniform3i.esVersions = [2.0]
glUniform3i.trace = True
glUniform3i.play = True
gl.add(glUniform3i)

glUniform3iv = Function('glUniform3iv')
glUniform3iv.ret = Return('void')
glUniform3iv.add( Input( 'location','GLint' ))
glUniform3iv.add( Input( 'count','GLsizei' ))
glUniform3iv.add( Input( 'value','const GLint *' ,size = '3 * count' ))
glUniform3iv.version = '2.0'
glUniform3iv.category = 'GL_VERSION_2_0'
glUniform3iv.esVersions = [2.0]
glUniform3iv.trace = True
glUniform3iv.play = True
gl.add(glUniform3iv)

glUniform4f = Function('glUniform4f')
glUniform4f.ret = Return('void')
glUniform4f.add( Input( 'location','GLint' ))
glUniform4f.add( Input( 'v0','GLfloat' ))
glUniform4f.add( Input( 'v1','GLfloat' ))
glUniform4f.add( Input( 'v2','GLfloat' ))
glUniform4f.add( Input( 'v3','GLfloat' ))
glUniform4f.version = '2.0'
glUniform4f.category = 'GL_VERSION_2_0'
glUniform4f.esVersions = [2.0]
glUniform4f.trace = True
glUniform4f.play = True
gl.add(glUniform4f)

glUniform4fv = Function('glUniform4fv')
glUniform4fv.ret = Return('void')
glUniform4fv.add( Input( 'location','GLint' ))
glUniform4fv.add( Input( 'count','GLsizei' ))
glUniform4fv.add( Input( 'value','const GLfloat *' ,size = '4 * count' ))
glUniform4fv.version = '2.0'
glUniform4fv.category = 'GL_VERSION_2_0'
glUniform4fv.esVersions = [2.0]
glUniform4fv.trace = True
glUniform4fv.play = True
gl.add(glUniform4fv)

glUniform4i = Function('glUniform4i')
glUniform4i.ret = Return('void')
glUniform4i.add( Input( 'location','GLint' ))
glUniform4i.add( Input( 'v0','GLint' ))
glUniform4i.add( Input( 'v1','GLint' ))
glUniform4i.add( Input( 'v2','GLint' ))
glUniform4i.add( Input( 'v3','GLint' ))
glUniform4i.version = '2.0'
glUniform4i.category = 'GL_VERSION_2_0'
glUniform4i.esVersions = [2.0]
glUniform4i.trace = True
glUniform4i.play = True
gl.add(glUniform4i)

glUniform4iv = Function('glUniform4iv')
glUniform4iv.ret = Return('void')
glUniform4iv.add( Input( 'location','GLint' ))
glUniform4iv.add( Input( 'count','GLsizei' ))
glUniform4iv.add( Input( 'value','const GLint *' ,size = '4 * count' ))
glUniform4iv.version = '2.0'
glUniform4iv.category = 'GL_VERSION_2_0'
glUniform4iv.esVersions = [2.0]
glUniform4iv.trace = True
glUniform4iv.play = True
gl.add(glUniform4iv)

glUniformMatrix2fv = Function('glUniformMatrix2fv')
glUniformMatrix2fv.ret = Return('void')
glUniformMatrix2fv.add( Input( 'location','GLint' ))
glUniformMatrix2fv.add( Input( 'count','GLsizei' ))
glUniformMatrix2fv.add( Input( 'transpose','GLboolean' ))
glUniformMatrix2fv.add( Input( 'value','const GLfloat *' ,size = '2 * 2 * count' ))
glUniformMatrix2fv.version = '2.0'
glUniformMatrix2fv.category = 'GL_VERSION_2_0'
glUniformMatrix2fv.esVersions = [2.0]
glUniformMatrix2fv.trace = True
glUniformMatrix2fv.play = True
gl.add(glUniformMatrix2fv)

glUniformMatrix3fv = Function('glUniformMatrix3fv')
glUniformMatrix3fv.ret = Return('void')
glUniformMatrix3fv.add( Input( 'location','GLint' ))
glUniformMatrix3fv.add( Input( 'count','GLsizei' ))
glUniformMatrix3fv.add( Input( 'transpose','GLboolean' ))
glUniformMatrix3fv.add( Input( 'value','const GLfloat *' ,size = '3 * 3 * count' ))
glUniformMatrix3fv.version = '2.0'
glUniformMatrix3fv.category = 'GL_VERSION_2_0'
glUniformMatrix3fv.esVersions = [2.0]
glUniformMatrix3fv.trace = True
glUniformMatrix3fv.play = True
gl.add(glUniformMatrix3fv)

glUniformMatrix4fv = Function('glUniformMatrix4fv')
glUniformMatrix4fv.ret = Return('void')
glUniformMatrix4fv.add( Input( 'location','GLint' ))
glUniformMatrix4fv.add( Input( 'count','GLsizei' ))
glUniformMatrix4fv.add( Input( 'transpose','GLboolean' ))
glUniformMatrix4fv.add( Input( 'value','const GLfloat *' ,size = '4 * 4 * count' ))
glUniformMatrix4fv.version = '2.0'
glUniformMatrix4fv.category = 'GL_VERSION_2_0'
glUniformMatrix4fv.esVersions = [2.0]
glUniformMatrix4fv.trace = True
glUniformMatrix4fv.play = True
gl.add(glUniformMatrix4fv)

glUseProgram = Function('glUseProgram')
glUseProgram.ret = Return('void')
glUseProgram.add( Input( 'program','GLuint' ))
glUseProgram.version = '2.0'
glUseProgram.category = 'GL_VERSION_2_0'
glUseProgram.esVersions = [2.0]
glUseProgram.trace = True
glUseProgram.play = True
gl.add(glUseProgram)

glValidateProgram = Function('glValidateProgram')
glValidateProgram.ret = Return('void')
glValidateProgram.add( Input( 'program','GLuint' ))
glValidateProgram.version = '2.0'
glValidateProgram.category = 'GL_VERSION_2_0'
glValidateProgram.esVersions = [2.0]
glValidateProgram.trace = True
glValidateProgram.play = True
gl.add(glValidateProgram)

glVertexAttrib1d = Function('glVertexAttrib1d')
glVertexAttrib1d.ret = Return('void')
glVertexAttrib1d.add( Input( 'index','GLuint' ))
glVertexAttrib1d.add( Input( 'x','GLdouble' ))
glVertexAttrib1d.version = '2.0'
glVertexAttrib1d.category = 'GL_VERSION_2_0'
glVertexAttrib1d.trace = True
glVertexAttrib1d.play = True
gl.add(glVertexAttrib1d)

glVertexAttrib1dv = Function('glVertexAttrib1dv')
glVertexAttrib1dv.ret = Return('void')
glVertexAttrib1dv.add( Input( 'index','GLuint' ))
glVertexAttrib1dv.add( Input( 'v','const GLdouble *' ,size = 1 ))
glVertexAttrib1dv.version = '2.0'
glVertexAttrib1dv.category = 'GL_VERSION_2_0'
glVertexAttrib1dv.trace = True
glVertexAttrib1dv.play = True
gl.add(glVertexAttrib1dv)

glVertexAttrib1f = Function('glVertexAttrib1f')
glVertexAttrib1f.ret = Return('void')
glVertexAttrib1f.add( Input( 'index','GLuint' ))
glVertexAttrib1f.add( Input( 'x','GLfloat' ))
glVertexAttrib1f.version = '2.0'
glVertexAttrib1f.category = 'GL_VERSION_2_0'
glVertexAttrib1f.esVersions = [2.0]
glVertexAttrib1f.trace = True
glVertexAttrib1f.play = True
gl.add(glVertexAttrib1f)

glVertexAttrib1fv = Function('glVertexAttrib1fv')
glVertexAttrib1fv.ret = Return('void')
glVertexAttrib1fv.add( Input( 'index','GLuint' ))
glVertexAttrib1fv.add( Input( 'v','const GLfloat *' ,size = 1 ))
glVertexAttrib1fv.version = '2.0'
glVertexAttrib1fv.category = 'GL_VERSION_2_0'
glVertexAttrib1fv.esVersions = [2.0]
glVertexAttrib1fv.trace = True
glVertexAttrib1fv.play = True
gl.add(glVertexAttrib1fv)

glVertexAttrib1s = Function('glVertexAttrib1s')
glVertexAttrib1s.ret = Return('void')
glVertexAttrib1s.add( Input( 'index','GLuint' ))
glVertexAttrib1s.add( Input( 'x','GLshort' ))
glVertexAttrib1s.version = '2.0'
glVertexAttrib1s.category = 'GL_VERSION_2_0'
glVertexAttrib1s.trace = True
glVertexAttrib1s.play = True
gl.add(glVertexAttrib1s)

glVertexAttrib1sv = Function('glVertexAttrib1sv')
glVertexAttrib1sv.ret = Return('void')
glVertexAttrib1sv.add( Input( 'index','GLuint' ))
glVertexAttrib1sv.add( Input( 'v','const GLshort *' ,size = 1 ))
glVertexAttrib1sv.version = '2.0'
glVertexAttrib1sv.category = 'GL_VERSION_2_0'
glVertexAttrib1sv.trace = True
glVertexAttrib1sv.play = True
gl.add(glVertexAttrib1sv)

glVertexAttrib2d = Function('glVertexAttrib2d')
glVertexAttrib2d.ret = Return('void')
glVertexAttrib2d.add( Input( 'index','GLuint' ))
glVertexAttrib2d.add( Input( 'x','GLdouble' ))
glVertexAttrib2d.add( Input( 'y','GLdouble' ))
glVertexAttrib2d.version = '2.0'
glVertexAttrib2d.category = 'GL_VERSION_2_0'
glVertexAttrib2d.trace = True
glVertexAttrib2d.play = True
gl.add(glVertexAttrib2d)

glVertexAttrib2dv = Function('glVertexAttrib2dv')
glVertexAttrib2dv.ret = Return('void')
glVertexAttrib2dv.add( Input( 'index','GLuint' ))
glVertexAttrib2dv.add( Input( 'v','const GLdouble *' ,size = 2 ))
glVertexAttrib2dv.version = '2.0'
glVertexAttrib2dv.category = 'GL_VERSION_2_0'
glVertexAttrib2dv.trace = True
glVertexAttrib2dv.play = True
gl.add(glVertexAttrib2dv)

glVertexAttrib2f = Function('glVertexAttrib2f')
glVertexAttrib2f.ret = Return('void')
glVertexAttrib2f.add( Input( 'index','GLuint' ))
glVertexAttrib2f.add( Input( 'x','GLfloat' ))
glVertexAttrib2f.add( Input( 'y','GLfloat' ))
glVertexAttrib2f.version = '2.0'
glVertexAttrib2f.category = 'GL_VERSION_2_0'
glVertexAttrib2f.esVersions = [2.0]
glVertexAttrib2f.trace = True
glVertexAttrib2f.play = True
gl.add(glVertexAttrib2f)

glVertexAttrib2fv = Function('glVertexAttrib2fv')
glVertexAttrib2fv.ret = Return('void')
glVertexAttrib2fv.add( Input( 'index','GLuint' ))
glVertexAttrib2fv.add( Input( 'v','const GLfloat *' ,size = 2 ))
glVertexAttrib2fv.version = '2.0'
glVertexAttrib2fv.category = 'GL_VERSION_2_0'
glVertexAttrib2fv.esVersions = [2.0]
glVertexAttrib2fv.trace = True
glVertexAttrib2fv.play = True
gl.add(glVertexAttrib2fv)

glVertexAttrib2s = Function('glVertexAttrib2s')
glVertexAttrib2s.ret = Return('void')
glVertexAttrib2s.add( Input( 'index','GLuint' ))
glVertexAttrib2s.add( Input( 'x','GLshort' ))
glVertexAttrib2s.add( Input( 'y','GLshort' ))
glVertexAttrib2s.version = '2.0'
glVertexAttrib2s.category = 'GL_VERSION_2_0'
glVertexAttrib2s.trace = True
glVertexAttrib2s.play = True
gl.add(glVertexAttrib2s)

glVertexAttrib2sv = Function('glVertexAttrib2sv')
glVertexAttrib2sv.ret = Return('void')
glVertexAttrib2sv.add( Input( 'index','GLuint' ))
glVertexAttrib2sv.add( Input( 'v','const GLshort *' ,size = 2 ))
glVertexAttrib2sv.version = '2.0'
glVertexAttrib2sv.category = 'GL_VERSION_2_0'
glVertexAttrib2sv.trace = True
glVertexAttrib2sv.play = True
gl.add(glVertexAttrib2sv)

glVertexAttrib3d = Function('glVertexAttrib3d')
glVertexAttrib3d.ret = Return('void')
glVertexAttrib3d.add( Input( 'index','GLuint' ))
glVertexAttrib3d.add( Input( 'x','GLdouble' ))
glVertexAttrib3d.add( Input( 'y','GLdouble' ))
glVertexAttrib3d.add( Input( 'z','GLdouble' ))
glVertexAttrib3d.version = '2.0'
glVertexAttrib3d.category = 'GL_VERSION_2_0'
glVertexAttrib3d.trace = True
glVertexAttrib3d.play = True
gl.add(glVertexAttrib3d)

glVertexAttrib3dv = Function('glVertexAttrib3dv')
glVertexAttrib3dv.ret = Return('void')
glVertexAttrib3dv.add( Input( 'index','GLuint' ))
glVertexAttrib3dv.add( Input( 'v','const GLdouble *' ,size = 3 ))
glVertexAttrib3dv.version = '2.0'
glVertexAttrib3dv.category = 'GL_VERSION_2_0'
glVertexAttrib3dv.trace = True
glVertexAttrib3dv.play = True
gl.add(glVertexAttrib3dv)

glVertexAttrib3f = Function('glVertexAttrib3f')
glVertexAttrib3f.ret = Return('void')
glVertexAttrib3f.add( Input( 'index','GLuint' ))
glVertexAttrib3f.add( Input( 'x','GLfloat' ))
glVertexAttrib3f.add( Input( 'y','GLfloat' ))
glVertexAttrib3f.add( Input( 'z','GLfloat' ))
glVertexAttrib3f.version = '2.0'
glVertexAttrib3f.category = 'GL_VERSION_2_0'
glVertexAttrib3f.esVersions = [2.0]
glVertexAttrib3f.trace = True
glVertexAttrib3f.play = True
gl.add(glVertexAttrib3f)

glVertexAttrib3fv = Function('glVertexAttrib3fv')
glVertexAttrib3fv.ret = Return('void')
glVertexAttrib3fv.add( Input( 'index','GLuint' ))
glVertexAttrib3fv.add( Input( 'v','const GLfloat *' ,size = 3 ))
glVertexAttrib3fv.version = '2.0'
glVertexAttrib3fv.category = 'GL_VERSION_2_0'
glVertexAttrib3fv.esVersions = [2.0]
glVertexAttrib3fv.trace = True
glVertexAttrib3fv.play = True
gl.add(glVertexAttrib3fv)

glVertexAttrib3s = Function('glVertexAttrib3s')
glVertexAttrib3s.ret = Return('void')
glVertexAttrib3s.add( Input( 'index','GLuint' ))
glVertexAttrib3s.add( Input( 'x','GLshort' ))
glVertexAttrib3s.add( Input( 'y','GLshort' ))
glVertexAttrib3s.add( Input( 'z','GLshort' ))
glVertexAttrib3s.version = '2.0'
glVertexAttrib3s.category = 'GL_VERSION_2_0'
glVertexAttrib3s.trace = True
glVertexAttrib3s.play = True
gl.add(glVertexAttrib3s)

glVertexAttrib3sv = Function('glVertexAttrib3sv')
glVertexAttrib3sv.ret = Return('void')
glVertexAttrib3sv.add( Input( 'index','GLuint' ))
glVertexAttrib3sv.add( Input( 'v','const GLshort *' ,size = 3 ))
glVertexAttrib3sv.version = '2.0'
glVertexAttrib3sv.category = 'GL_VERSION_2_0'
glVertexAttrib3sv.trace = True
glVertexAttrib3sv.play = True
gl.add(glVertexAttrib3sv)

glVertexAttrib4Nbv = Function('glVertexAttrib4Nbv')
glVertexAttrib4Nbv.ret = Return('void')
glVertexAttrib4Nbv.add( Input( 'index','GLuint' ))
glVertexAttrib4Nbv.add( Input( 'v','const GLbyte *' ,size = 4 ))
glVertexAttrib4Nbv.version = '2.0'
glVertexAttrib4Nbv.category = 'GL_VERSION_2_0'
glVertexAttrib4Nbv.trace = True
glVertexAttrib4Nbv.play = True
gl.add(glVertexAttrib4Nbv)

glVertexAttrib4Niv = Function('glVertexAttrib4Niv')
glVertexAttrib4Niv.ret = Return('void')
glVertexAttrib4Niv.add( Input( 'index','GLuint' ))
glVertexAttrib4Niv.add( Input( 'v','const GLint *' ,size = 4 ))
glVertexAttrib4Niv.version = '2.0'
glVertexAttrib4Niv.category = 'GL_VERSION_2_0'
glVertexAttrib4Niv.trace = True
glVertexAttrib4Niv.play = True
gl.add(glVertexAttrib4Niv)

glVertexAttrib4Nsv = Function('glVertexAttrib4Nsv')
glVertexAttrib4Nsv.ret = Return('void')
glVertexAttrib4Nsv.add( Input( 'index','GLuint' ))
glVertexAttrib4Nsv.add( Input( 'v','const GLshort *' ,size = 4 ))
glVertexAttrib4Nsv.version = '2.0'
glVertexAttrib4Nsv.category = 'GL_VERSION_2_0'
glVertexAttrib4Nsv.trace = True
glVertexAttrib4Nsv.play = True
gl.add(glVertexAttrib4Nsv)

glVertexAttrib4Nub = Function('glVertexAttrib4Nub')
glVertexAttrib4Nub.ret = Return('void')
glVertexAttrib4Nub.add( Input( 'index','GLuint' ))
glVertexAttrib4Nub.add( Input( 'x','GLubyte' ))
glVertexAttrib4Nub.add( Input( 'y','GLubyte' ))
glVertexAttrib4Nub.add( Input( 'z','GLubyte' ))
glVertexAttrib4Nub.add( Input( 'w','GLubyte' ))
glVertexAttrib4Nub.version = '2.0'
glVertexAttrib4Nub.category = 'GL_VERSION_2_0'
glVertexAttrib4Nub.trace = True
glVertexAttrib4Nub.play = True
gl.add(glVertexAttrib4Nub)

glVertexAttrib4Nubv = Function('glVertexAttrib4Nubv')
glVertexAttrib4Nubv.ret = Return('void')
glVertexAttrib4Nubv.add( Input( 'index','GLuint' ))
glVertexAttrib4Nubv.add( Input( 'v','const GLubyte *' ,size = 4 ))
glVertexAttrib4Nubv.version = '2.0'
glVertexAttrib4Nubv.category = 'GL_VERSION_2_0'
glVertexAttrib4Nubv.trace = True
glVertexAttrib4Nubv.play = True
gl.add(glVertexAttrib4Nubv)

glVertexAttrib4Nuiv = Function('glVertexAttrib4Nuiv')
glVertexAttrib4Nuiv.ret = Return('void')
glVertexAttrib4Nuiv.add( Input( 'index','GLuint' ))
glVertexAttrib4Nuiv.add( Input( 'v','const GLuint *' ,size = 4 ))
glVertexAttrib4Nuiv.version = '2.0'
glVertexAttrib4Nuiv.category = 'GL_VERSION_2_0'
glVertexAttrib4Nuiv.trace = True
glVertexAttrib4Nuiv.play = True
gl.add(glVertexAttrib4Nuiv)

glVertexAttrib4Nusv = Function('glVertexAttrib4Nusv')
glVertexAttrib4Nusv.ret = Return('void')
glVertexAttrib4Nusv.add( Input( 'index','GLuint' ))
glVertexAttrib4Nusv.add( Input( 'v','const GLushort *' ,size = 4 ))
glVertexAttrib4Nusv.version = '2.0'
glVertexAttrib4Nusv.category = 'GL_VERSION_2_0'
glVertexAttrib4Nusv.trace = True
glVertexAttrib4Nusv.play = True
gl.add(glVertexAttrib4Nusv)

glVertexAttrib4bv = Function('glVertexAttrib4bv')
glVertexAttrib4bv.ret = Return('void')
glVertexAttrib4bv.add( Input( 'index','GLuint' ))
glVertexAttrib4bv.add( Input( 'v','const GLbyte *' ,size = 4 ))
glVertexAttrib4bv.version = '2.0'
glVertexAttrib4bv.category = 'GL_VERSION_2_0'
glVertexAttrib4bv.trace = True
glVertexAttrib4bv.play = True
gl.add(glVertexAttrib4bv)

glVertexAttrib4d = Function('glVertexAttrib4d')
glVertexAttrib4d.ret = Return('void')
glVertexAttrib4d.add( Input( 'index','GLuint' ))
glVertexAttrib4d.add( Input( 'x','GLdouble' ))
glVertexAttrib4d.add( Input( 'y','GLdouble' ))
glVertexAttrib4d.add( Input( 'z','GLdouble' ))
glVertexAttrib4d.add( Input( 'w','GLdouble' ))
glVertexAttrib4d.version = '2.0'
glVertexAttrib4d.category = 'GL_VERSION_2_0'
glVertexAttrib4d.trace = True
glVertexAttrib4d.play = True
gl.add(glVertexAttrib4d)

glVertexAttrib4dv = Function('glVertexAttrib4dv')
glVertexAttrib4dv.ret = Return('void')
glVertexAttrib4dv.add( Input( 'index','GLuint' ))
glVertexAttrib4dv.add( Input( 'v','const GLdouble *' ,size = 4 ))
glVertexAttrib4dv.version = '2.0'
glVertexAttrib4dv.category = 'GL_VERSION_2_0'
glVertexAttrib4dv.trace = True
glVertexAttrib4dv.play = True
gl.add(glVertexAttrib4dv)

glVertexAttrib4f = Function('glVertexAttrib4f')
glVertexAttrib4f.ret = Return('void')
glVertexAttrib4f.add( Input( 'index','GLuint' ))
glVertexAttrib4f.add( Input( 'x','GLfloat' ))
glVertexAttrib4f.add( Input( 'y','GLfloat' ))
glVertexAttrib4f.add( Input( 'z','GLfloat' ))
glVertexAttrib4f.add( Input( 'w','GLfloat' ))
glVertexAttrib4f.version = '2.0'
glVertexAttrib4f.category = 'GL_VERSION_2_0'
glVertexAttrib4f.esVersions = [2.0]
glVertexAttrib4f.trace = True
glVertexAttrib4f.play = True
gl.add(glVertexAttrib4f)

glVertexAttrib4fv = Function('glVertexAttrib4fv')
glVertexAttrib4fv.ret = Return('void')
glVertexAttrib4fv.add( Input( 'index','GLuint' ))
glVertexAttrib4fv.add( Input( 'v','const GLfloat *' ,size = 4 ))
glVertexAttrib4fv.version = '2.0'
glVertexAttrib4fv.category = 'GL_VERSION_2_0'
glVertexAttrib4fv.esVersions = [2.0]
glVertexAttrib4fv.trace = True
glVertexAttrib4fv.play = True
gl.add(glVertexAttrib4fv)

glVertexAttrib4iv = Function('glVertexAttrib4iv')
glVertexAttrib4iv.ret = Return('void')
glVertexAttrib4iv.add( Input( 'index','GLuint' ))
glVertexAttrib4iv.add( Input( 'v','const GLint *' ,size = 4 ))
glVertexAttrib4iv.version = '2.0'
glVertexAttrib4iv.category = 'GL_VERSION_2_0'
glVertexAttrib4iv.trace = True
glVertexAttrib4iv.play = True
gl.add(glVertexAttrib4iv)

glVertexAttrib4s = Function('glVertexAttrib4s')
glVertexAttrib4s.ret = Return('void')
glVertexAttrib4s.add( Input( 'index','GLuint' ))
glVertexAttrib4s.add( Input( 'x','GLshort' ))
glVertexAttrib4s.add( Input( 'y','GLshort' ))
glVertexAttrib4s.add( Input( 'z','GLshort' ))
glVertexAttrib4s.add( Input( 'w','GLshort' ))
glVertexAttrib4s.version = '2.0'
glVertexAttrib4s.category = 'GL_VERSION_2_0'
glVertexAttrib4s.trace = True
glVertexAttrib4s.play = True
gl.add(glVertexAttrib4s)

glVertexAttrib4sv = Function('glVertexAttrib4sv')
glVertexAttrib4sv.ret = Return('void')
glVertexAttrib4sv.add( Input( 'index','GLuint' ))
glVertexAttrib4sv.add( Input( 'v','const GLshort *' ,size = 4 ))
glVertexAttrib4sv.version = '2.0'
glVertexAttrib4sv.category = 'GL_VERSION_2_0'
glVertexAttrib4sv.trace = True
glVertexAttrib4sv.play = True
gl.add(glVertexAttrib4sv)

glVertexAttrib4ubv = Function('glVertexAttrib4ubv')
glVertexAttrib4ubv.ret = Return('void')
glVertexAttrib4ubv.add( Input( 'index','GLuint' ))
glVertexAttrib4ubv.add( Input( 'v','const GLubyte *' ,size = 4 ))
glVertexAttrib4ubv.version = '2.0'
glVertexAttrib4ubv.category = 'GL_VERSION_2_0'
glVertexAttrib4ubv.trace = True
glVertexAttrib4ubv.play = True
gl.add(glVertexAttrib4ubv)

glVertexAttrib4uiv = Function('glVertexAttrib4uiv')
glVertexAttrib4uiv.ret = Return('void')
glVertexAttrib4uiv.add( Input( 'index','GLuint' ))
glVertexAttrib4uiv.add( Input( 'v','const GLuint *' ,size = 4 ))
glVertexAttrib4uiv.version = '2.0'
glVertexAttrib4uiv.category = 'GL_VERSION_2_0'
glVertexAttrib4uiv.trace = True
glVertexAttrib4uiv.play = True
gl.add(glVertexAttrib4uiv)

glVertexAttrib4usv = Function('glVertexAttrib4usv')
glVertexAttrib4usv.ret = Return('void')
glVertexAttrib4usv.add( Input( 'index','GLuint' ))
glVertexAttrib4usv.add( Input( 'v','const GLushort *' ,size = 4 ))
glVertexAttrib4usv.version = '2.0'
glVertexAttrib4usv.category = 'GL_VERSION_2_0'
glVertexAttrib4usv.trace = True
glVertexAttrib4usv.play = True
gl.add(glVertexAttrib4usv)

glVertexAttribPointer = Function('glVertexAttribPointer')
glVertexAttribPointer.ret = Return('void')
glVertexAttribPointer.add( Input( 'index','GLuint' ))
glVertexAttribPointer.add( Input( 'size','GLint' ))
glVertexAttribPointer.add( Input( 'type','GLenum' ))
glVertexAttribPointer.add( Input( 'normalized','GLboolean' ))
glVertexAttribPointer.add( Input( 'stride','GLsizei' ))
glVertexAttribPointer.add( Input( 'pointer','const GLvoid *' ))
glVertexAttribPointer.version = '2.0'
glVertexAttribPointer.category = 'GL_VERSION_2_0'
glVertexAttribPointer.esVersions = [2.0]
glVertexAttribPointer.trace = True
glVertexAttribPointer.play = True
gl.add(glVertexAttribPointer)

# GL_VERSION_2_1

glUniformMatrix2x3fv = Function('glUniformMatrix2x3fv')
glUniformMatrix2x3fv.ret = Return('void')
glUniformMatrix2x3fv.add( Input( 'location','GLint' ))
glUniformMatrix2x3fv.add( Input( 'count','GLsizei' ))
glUniformMatrix2x3fv.add( Input( 'transpose','GLboolean' ))
glUniformMatrix2x3fv.add( Input( 'value','const GLfloat *' ,size = '2 * 3 * count' ))
glUniformMatrix2x3fv.version = '2.1'
glUniformMatrix2x3fv.category = 'GL_VERSION_2_1'
glUniformMatrix2x3fv.trace = True
glUniformMatrix2x3fv.play = True
gl.add(glUniformMatrix2x3fv)

glUniformMatrix2x4fv = Function('glUniformMatrix2x4fv')
glUniformMatrix2x4fv.ret = Return('void')
glUniformMatrix2x4fv.add( Input( 'location','GLint' ))
glUniformMatrix2x4fv.add( Input( 'count','GLsizei' ))
glUniformMatrix2x4fv.add( Input( 'transpose','GLboolean' ))
glUniformMatrix2x4fv.add( Input( 'value','const GLfloat *' ,size = '2 * 4 * count' ))
glUniformMatrix2x4fv.version = '2.1'
glUniformMatrix2x4fv.category = 'GL_VERSION_2_1'
glUniformMatrix2x4fv.trace = True
glUniformMatrix2x4fv.play = True
gl.add(glUniformMatrix2x4fv)

glUniformMatrix3x2fv = Function('glUniformMatrix3x2fv')
glUniformMatrix3x2fv.ret = Return('void')
glUniformMatrix3x2fv.add( Input( 'location','GLint' ))
glUniformMatrix3x2fv.add( Input( 'count','GLsizei' ))
glUniformMatrix3x2fv.add( Input( 'transpose','GLboolean' ))
glUniformMatrix3x2fv.add( Input( 'value','const GLfloat *' ,size = '3 * 2 * count' ))
glUniformMatrix3x2fv.version = '2.1'
glUniformMatrix3x2fv.category = 'GL_VERSION_2_1'
glUniformMatrix3x2fv.trace = True
glUniformMatrix3x2fv.play = True
gl.add(glUniformMatrix3x2fv)

glUniformMatrix3x4fv = Function('glUniformMatrix3x4fv')
glUniformMatrix3x4fv.ret = Return('void')
glUniformMatrix3x4fv.add( Input( 'location','GLint' ))
glUniformMatrix3x4fv.add( Input( 'count','GLsizei' ))
glUniformMatrix3x4fv.add( Input( 'transpose','GLboolean' ))
glUniformMatrix3x4fv.add( Input( 'value','const GLfloat *' ,size = '3 * 4 * count' ))
glUniformMatrix3x4fv.version = '2.1'
glUniformMatrix3x4fv.category = 'GL_VERSION_2_1'
glUniformMatrix3x4fv.trace = True
glUniformMatrix3x4fv.play = True
gl.add(glUniformMatrix3x4fv)

glUniformMatrix4x2fv = Function('glUniformMatrix4x2fv')
glUniformMatrix4x2fv.ret = Return('void')
glUniformMatrix4x2fv.add( Input( 'location','GLint' ))
glUniformMatrix4x2fv.add( Input( 'count','GLsizei' ))
glUniformMatrix4x2fv.add( Input( 'transpose','GLboolean' ))
glUniformMatrix4x2fv.add( Input( 'value','const GLfloat *' ,size = '4 * 2 * count' ))
glUniformMatrix4x2fv.version = '2.1'
glUniformMatrix4x2fv.category = 'GL_VERSION_2_1'
glUniformMatrix4x2fv.trace = True
glUniformMatrix4x2fv.play = True
gl.add(glUniformMatrix4x2fv)

glUniformMatrix4x3fv = Function('glUniformMatrix4x3fv')
glUniformMatrix4x3fv.ret = Return('void')
glUniformMatrix4x3fv.add( Input( 'location','GLint' ))
glUniformMatrix4x3fv.add( Input( 'count','GLsizei' ))
glUniformMatrix4x3fv.add( Input( 'transpose','GLboolean' ))
glUniformMatrix4x3fv.add( Input( 'value','const GLfloat *' ,size = '4 * 3 * count' ))
glUniformMatrix4x3fv.version = '2.1'
glUniformMatrix4x3fv.category = 'GL_VERSION_2_1'
glUniformMatrix4x3fv.trace = True
glUniformMatrix4x3fv.play = True
gl.add(glUniformMatrix4x3fv)

# GL_VERSION_3_0

glBeginConditionalRender = Function('glBeginConditionalRender')
glBeginConditionalRender.ret = Return('void')
glBeginConditionalRender.add( Input( 'id','GLuint' ))
glBeginConditionalRender.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glBeginConditionalRender.version = '3.0'
glBeginConditionalRender.category = 'GL_VERSION_3_0'
glBeginConditionalRender.trace = True
glBeginConditionalRender.play = True
gl.add(glBeginConditionalRender)

glBeginTransformFeedback = Function('glBeginTransformFeedback')
glBeginTransformFeedback.ret = Return('void')
glBeginTransformFeedback.add( Input( 'primitiveMode','GLenum' ))
glBeginTransformFeedback.version = '3.0'
glBeginTransformFeedback.category = 'GL_VERSION_3_0'
glBeginTransformFeedback.trace = True
glBeginTransformFeedback.play = True
gl.add(glBeginTransformFeedback)

glBindFragDataLocation = Function('glBindFragDataLocation')
glBindFragDataLocation.ret = Return('void')
glBindFragDataLocation.add( Input( 'program','GLuint' ))
glBindFragDataLocation.add( Input( 'color','GLuint' ))
glBindFragDataLocation.add( Input( 'name','const GLchar *' ))
glBindFragDataLocation.version = '3.0'
glBindFragDataLocation.category = 'GL_VERSION_3_0'
glBindFragDataLocation.trace = True
glBindFragDataLocation.play = True
gl.add(glBindFragDataLocation)

glClampColor = Function('glClampColor')
glClampColor.ret = Return('void')
glClampColor.add( Input( 'target','GLenum' ))
glClampColor.add( Input( 'clamp','GLenum' ))
glClampColor.version = '3.0'
glClampColor.category = 'GL_VERSION_3_0'
glClampColor.trace = True
glClampColor.play = True
gl.add(glClampColor)

glClearBufferfi = Function('glClearBufferfi')
glClearBufferfi.ret = Return('void')
glClearBufferfi.add( Input( 'buffer','GLenum' ))
glClearBufferfi.add( Input( 'drawbuffer','GLint' ))
glClearBufferfi.add( Input( 'depth','GLfloat' ))
glClearBufferfi.add( Input( 'stencil','GLint' ))
glClearBufferfi.version = '3.0'
glClearBufferfi.category = 'GL_VERSION_3_0'
glClearBufferfi.trace = True
glClearBufferfi.play = True
gl.add(glClearBufferfi)

glClearBufferfv = Function('glClearBufferfv')
glClearBufferfv.ret = Return('void')
glClearBufferfv.add( Input( 'buffer','GLenum' ))
glClearBufferfv.add( Input( 'drawbuffer','GLint' ))
glClearBufferfv.add( Input( 'value','const GLfloat *' ))
glClearBufferfv.version = '3.0'
glClearBufferfv.category = 'GL_VERSION_3_0'
glClearBufferfv.trace = True
glClearBufferfv.play = True
gl.add(glClearBufferfv)

glClearBufferiv = Function('glClearBufferiv')
glClearBufferiv.ret = Return('void')
glClearBufferiv.add( Input( 'buffer','GLenum' ))
glClearBufferiv.add( Input( 'drawbuffer','GLint' ))
glClearBufferiv.add( Input( 'value','const GLint *' ))
glClearBufferiv.version = '3.0'
glClearBufferiv.category = 'GL_VERSION_3_0'
glClearBufferiv.trace = True
glClearBufferiv.play = True
gl.add(glClearBufferiv)

glClearBufferuiv = Function('glClearBufferuiv')
glClearBufferuiv.ret = Return('void')
glClearBufferuiv.add( Input( 'buffer','GLenum' ))
glClearBufferuiv.add( Input( 'drawbuffer','GLint' ))
glClearBufferuiv.add( Input( 'value','const GLuint *' ))
glClearBufferuiv.version = '3.0'
glClearBufferuiv.category = 'GL_VERSION_3_0'
glClearBufferuiv.trace = True
glClearBufferuiv.play = True
gl.add(glClearBufferuiv)

glColorMaski = Function('glColorMaski')
glColorMaski.ret = Return('void')
glColorMaski.add( Input( 'index','GLuint' ))
glColorMaski.add( Input( 'r','GLboolean' ))
glColorMaski.add( Input( 'g','GLboolean' ))
glColorMaski.add( Input( 'b','GLboolean' ))
glColorMaski.add( Input( 'a','GLboolean' ))
glColorMaski.version = '3.0'
glColorMaski.category = 'GL_VERSION_3_0'
glColorMaski.trace = True
glColorMaski.play = True
gl.add(glColorMaski)

glDisablei = Function('glDisablei')
glDisablei.ret = Return('void')
glDisablei.add( Input( 'cap','GLenum' ))
glDisablei.add( Input( 'index','GLuint' ))
glDisablei.version = '3.0'
glDisablei.category = 'GL_VERSION_3_0'
glDisablei.trace = True
glDisablei.play = True
gl.add(glDisablei)

glEnablei = Function('glEnablei')
glEnablei.ret = Return('void')
glEnablei.add( Input( 'cap','GLenum' ))
glEnablei.add( Input( 'index','GLuint' ))
glEnablei.version = '3.0'
glEnablei.category = 'GL_VERSION_3_0'
glEnablei.trace = True
glEnablei.play = True
gl.add(glEnablei)

glEndConditionalRender = Function('glEndConditionalRender')
glEndConditionalRender.ret = Return('void')
glEndConditionalRender.version = '3.0'
glEndConditionalRender.category = 'GL_VERSION_3_0'
glEndConditionalRender.trace = True
glEndConditionalRender.play = True
gl.add(glEndConditionalRender)

glEndTransformFeedback = Function('glEndTransformFeedback')
glEndTransformFeedback.ret = Return('void')
glEndTransformFeedback.version = '3.0'
glEndTransformFeedback.category = 'GL_VERSION_3_0'
glEndTransformFeedback.trace = True
glEndTransformFeedback.play = True
gl.add(glEndTransformFeedback)

glGetBooleani_v = Function('glGetBooleani_v')
glGetBooleani_v.ret = Return('void')
glGetBooleani_v.add( Input( 'target','GLenum' ))
glGetBooleani_v.add( Input( 'index','GLuint' ))
glGetBooleani_v.add( Output( 'data','GLboolean *' ))
glGetBooleani_v.version = '3.0'
glGetBooleani_v.category = 'GL_VERSION_3_0'
glGetBooleani_v.trace = True
glGetBooleani_v.play = False
gl.add(glGetBooleani_v)

glGetFragDataLocation = Function('glGetFragDataLocation')
glGetFragDataLocation.ret = Return('GLint')
glGetFragDataLocation.add( Input( 'program','GLuint' ))
glGetFragDataLocation.add( Input( 'name','const GLchar *' ))
glGetFragDataLocation.version = '3.0'
glGetFragDataLocation.category = 'GL_VERSION_3_0'
glGetFragDataLocation.trace = True
glGetFragDataLocation.play = True
gl.add(glGetFragDataLocation)

glGetStringi = Function('glGetStringi')
glGetStringi.ret = Return('const GLubyte *')
glGetStringi.ret.cast = 'const GLchar *'
glGetStringi.add( Input( 'name','GLenum' ))
glGetStringi.add( Input( 'index','GLuint' ))
glGetStringi.version = '3.0'
glGetStringi.category = 'GL_VERSION_3_0'
glGetStringi.trace = True
glGetStringi.play = True
gl.add(glGetStringi)

glGetTexParameterIiv = Function('glGetTexParameterIiv')
glGetTexParameterIiv.ret = Return('void')
glGetTexParameterIiv.add( Input( 'target','GLenum' ))
glGetTexParameterIiv.add( Input( 'pname','GLenum' ))
glGetTexParameterIiv.add( Output( 'params','GLint *' ))
glGetTexParameterIiv.version = '3.0'
glGetTexParameterIiv.category = 'GL_VERSION_3_0'
glGetTexParameterIiv.trace = True
glGetTexParameterIiv.play = True
gl.add(glGetTexParameterIiv)

glGetTexParameterIuiv = Function('glGetTexParameterIuiv')
glGetTexParameterIuiv.ret = Return('void')
glGetTexParameterIuiv.add( Input( 'target','GLenum' ))
glGetTexParameterIuiv.add( Input( 'pname','GLenum' ))
glGetTexParameterIuiv.add( Output( 'params','GLuint *' ))
glGetTexParameterIuiv.version = '3.0'
glGetTexParameterIuiv.category = 'GL_VERSION_3_0'
glGetTexParameterIuiv.trace = True
glGetTexParameterIuiv.play = True
gl.add(glGetTexParameterIuiv)

glGetTransformFeedbackVarying = Function('glGetTransformFeedbackVarying')
glGetTransformFeedbackVarying.ret = Return('void')
glGetTransformFeedbackVarying.add( Input( 'program','GLuint' ))
glGetTransformFeedbackVarying.add( Input( 'index','GLuint' ))
glGetTransformFeedbackVarying.add( Input( 'bufSize','GLsizei' ))
glGetTransformFeedbackVarying.add( Output( 'length','GLsizei *' ,size = 1 ))
glGetTransformFeedbackVarying.add( Output( 'size','GLsizei *' ,size = 1 ))
glGetTransformFeedbackVarying.add( Output( 'type','GLenum *' ,size = 1 ))
glGetTransformFeedbackVarying.add( Output( 'name','GLchar *' ,size = 'bufSize' ))
glGetTransformFeedbackVarying.version = '3.0'
glGetTransformFeedbackVarying.category = 'GL_VERSION_3_0'
glGetTransformFeedbackVarying.trace = True
glGetTransformFeedbackVarying.play = True
gl.add(glGetTransformFeedbackVarying)

glGetUniformuiv = Function('glGetUniformuiv')
glGetUniformuiv.ret = Return('void')
glGetUniformuiv.add( Input( 'program','GLuint' ))
glGetUniformuiv.add( Input( 'location','GLint' ))
glGetUniformuiv.add( Output( 'params','GLuint *' ))
glGetUniformuiv.version = '3.0'
glGetUniformuiv.category = 'GL_VERSION_3_0'
glGetUniformuiv.trace = True
glGetUniformuiv.play = True
gl.add(glGetUniformuiv)

glGetVertexAttribIiv = Function('glGetVertexAttribIiv')
glGetVertexAttribIiv.ret = Return('void')
glGetVertexAttribIiv.add( Input( 'index','GLuint' ))
glGetVertexAttribIiv.add( Input( 'pname','GLenum' ))
glGetVertexAttribIiv.add( Output( 'params','GLint *' ,size = 1 ))
glGetVertexAttribIiv.version = '3.0'
glGetVertexAttribIiv.category = 'GL_VERSION_3_0'
glGetVertexAttribIiv.trace = True
glGetVertexAttribIiv.play = True
gl.add(glGetVertexAttribIiv)

glGetVertexAttribIuiv = Function('glGetVertexAttribIuiv')
glGetVertexAttribIuiv.ret = Return('void')
glGetVertexAttribIuiv.add( Input( 'index','GLuint' ))
glGetVertexAttribIuiv.add( Input( 'pname','GLenum' ))
glGetVertexAttribIuiv.add( Output( 'params','GLuint *' ,size = 1 ))
glGetVertexAttribIuiv.version = '3.0'
glGetVertexAttribIuiv.category = 'GL_VERSION_3_0'
glGetVertexAttribIuiv.trace = True
glGetVertexAttribIuiv.play = True
gl.add(glGetVertexAttribIuiv)

glIsEnabledi = Function('glIsEnabledi')
glIsEnabledi.ret = Return('GLboolean')
glIsEnabledi.add( Input( 'target','GLenum' ))
glIsEnabledi.add( Input( 'index','GLuint' ))
glIsEnabledi.version = '3.0'
glIsEnabledi.category = 'GL_VERSION_3_0'
glIsEnabledi.trace = True
glIsEnabledi.play = True
gl.add(glIsEnabledi)

glTexParameterIiv = Function('glTexParameterIiv')
glTexParameterIiv.ret = Return('void')
glTexParameterIiv.add( Input( 'target','GLenum' ))
glTexParameterIiv.add( Input( 'pname','GLenum' ))
glTexParameterIiv.add( Input( 'params','const GLint *' ,regalLog = 'GLTexParameterToString(pname,params)' ))
glTexParameterIiv.version = '3.0'
glTexParameterIiv.category = 'GL_VERSION_3_0'
glTexParameterIiv.trace = True
glTexParameterIiv.play = True
gl.add(glTexParameterIiv)

glTexParameterIuiv = Function('glTexParameterIuiv')
glTexParameterIuiv.ret = Return('void')
glTexParameterIuiv.add( Input( 'target','GLenum' ))
glTexParameterIuiv.add( Input( 'pname','GLenum' ))
glTexParameterIuiv.add( Input( 'params','const GLuint *' ,regalLog = 'GLTexParameterToString(pname,params)' ))
glTexParameterIuiv.version = '3.0'
glTexParameterIuiv.category = 'GL_VERSION_3_0'
glTexParameterIuiv.trace = True
glTexParameterIuiv.play = True
gl.add(glTexParameterIuiv)

glTransformFeedbackVaryings = Function('glTransformFeedbackVaryings')
glTransformFeedbackVaryings.ret = Return('void')
glTransformFeedbackVaryings.add( Input( 'program','GLuint' ))
glTransformFeedbackVaryings.add( Input( 'count','GLsizei' ))
glTransformFeedbackVaryings.add( Input( 'varyings','const GLchar * const *' ,size = 'count' ))
glTransformFeedbackVaryings.add( Input( 'bufferMode','GLenum' ))
glTransformFeedbackVaryings.version = '3.0'
glTransformFeedbackVaryings.category = 'GL_VERSION_3_0'
glTransformFeedbackVaryings.trace = True
glTransformFeedbackVaryings.play = True
gl.add(glTransformFeedbackVaryings)

glUniform1ui = Function('glUniform1ui')
glUniform1ui.ret = Return('void')
glUniform1ui.add( Input( 'location','GLint' ))
glUniform1ui.add( Input( 'v0','GLuint' ))
glUniform1ui.version = '3.0'
glUniform1ui.category = 'GL_VERSION_3_0'
glUniform1ui.trace = True
glUniform1ui.play = True
gl.add(glUniform1ui)

glUniform1uiv = Function('glUniform1uiv')
glUniform1uiv.ret = Return('void')
glUniform1uiv.add( Input( 'location','GLint' ))
glUniform1uiv.add( Input( 'count','GLsizei' ))
glUniform1uiv.add( Input( 'value','const GLuint *' ,size = 'count' ))
glUniform1uiv.version = '3.0'
glUniform1uiv.category = 'GL_VERSION_3_0'
glUniform1uiv.trace = True
glUniform1uiv.play = True
gl.add(glUniform1uiv)

glUniform2ui = Function('glUniform2ui')
glUniform2ui.ret = Return('void')
glUniform2ui.add( Input( 'location','GLint' ))
glUniform2ui.add( Input( 'v0','GLuint' ))
glUniform2ui.add( Input( 'v1','GLuint' ))
glUniform2ui.version = '3.0'
glUniform2ui.category = 'GL_VERSION_3_0'
glUniform2ui.trace = True
glUniform2ui.play = True
gl.add(glUniform2ui)

glUniform2uiv = Function('glUniform2uiv')
glUniform2uiv.ret = Return('void')
glUniform2uiv.add( Input( 'location','GLint' ))
glUniform2uiv.add( Input( 'count','GLsizei' ))
glUniform2uiv.add( Input( 'value','const GLuint *' ,size = 'count * 2' ))
glUniform2uiv.version = '3.0'
glUniform2uiv.category = 'GL_VERSION_3_0'
glUniform2uiv.trace = True
glUniform2uiv.play = True
gl.add(glUniform2uiv)

glUniform3ui = Function('glUniform3ui')
glUniform3ui.ret = Return('void')
glUniform3ui.add( Input( 'location','GLint' ))
glUniform3ui.add( Input( 'v0','GLuint' ))
glUniform3ui.add( Input( 'v1','GLuint' ))
glUniform3ui.add( Input( 'v2','GLuint' ))
glUniform3ui.version = '3.0'
glUniform3ui.category = 'GL_VERSION_3_0'
glUniform3ui.trace = True
glUniform3ui.play = True
gl.add(glUniform3ui)

glUniform3uiv = Function('glUniform3uiv')
glUniform3uiv.ret = Return('void')
glUniform3uiv.add( Input( 'location','GLint' ))
glUniform3uiv.add( Input( 'count','GLsizei' ))
glUniform3uiv.add( Input( 'value','const GLuint *' ,size = 'count * 3' ))
glUniform3uiv.version = '3.0'
glUniform3uiv.category = 'GL_VERSION_3_0'
glUniform3uiv.trace = True
glUniform3uiv.play = True
gl.add(glUniform3uiv)

glUniform4ui = Function('glUniform4ui')
glUniform4ui.ret = Return('void')
glUniform4ui.add( Input( 'location','GLint' ))
glUniform4ui.add( Input( 'v0','GLuint' ))
glUniform4ui.add( Input( 'v1','GLuint' ))
glUniform4ui.add( Input( 'v2','GLuint' ))
glUniform4ui.add( Input( 'v3','GLuint' ))
glUniform4ui.version = '3.0'
glUniform4ui.category = 'GL_VERSION_3_0'
glUniform4ui.trace = True
glUniform4ui.play = True
gl.add(glUniform4ui)

glUniform4uiv = Function('glUniform4uiv')
glUniform4uiv.ret = Return('void')
glUniform4uiv.add( Input( 'location','GLint' ))
glUniform4uiv.add( Input( 'count','GLsizei' ))
glUniform4uiv.add( Input( 'value','const GLuint *' ,size = 'count * 4' ))
glUniform4uiv.version = '3.0'
glUniform4uiv.category = 'GL_VERSION_3_0'
glUniform4uiv.trace = True
glUniform4uiv.play = True
gl.add(glUniform4uiv)

glVertexAttribI1i = Function('glVertexAttribI1i')
glVertexAttribI1i.ret = Return('void')
glVertexAttribI1i.add( Input( 'index','GLuint' ))
glVertexAttribI1i.add( Input( 'x','GLint' ))
glVertexAttribI1i.version = '3.0'
glVertexAttribI1i.category = 'GL_VERSION_3_0'
glVertexAttribI1i.trace = True
glVertexAttribI1i.play = True
gl.add(glVertexAttribI1i)

glVertexAttribI1iv = Function('glVertexAttribI1iv')
glVertexAttribI1iv.ret = Return('void')
glVertexAttribI1iv.add( Input( 'index','GLuint' ))
glVertexAttribI1iv.add( Input( 'v','const GLint *' ,size = 1 ))
glVertexAttribI1iv.version = '3.0'
glVertexAttribI1iv.category = 'GL_VERSION_3_0'
glVertexAttribI1iv.trace = True
glVertexAttribI1iv.play = True
gl.add(glVertexAttribI1iv)

glVertexAttribI1ui = Function('glVertexAttribI1ui')
glVertexAttribI1ui.ret = Return('void')
glVertexAttribI1ui.add( Input( 'index','GLuint' ))
glVertexAttribI1ui.add( Input( 'x','GLuint' ))
glVertexAttribI1ui.version = '3.0'
glVertexAttribI1ui.category = 'GL_VERSION_3_0'
glVertexAttribI1ui.trace = True
glVertexAttribI1ui.play = True
gl.add(glVertexAttribI1ui)

glVertexAttribI1uiv = Function('glVertexAttribI1uiv')
glVertexAttribI1uiv.ret = Return('void')
glVertexAttribI1uiv.add( Input( 'index','GLuint' ))
glVertexAttribI1uiv.add( Input( 'v','const GLuint *' ,size = 1 ))
glVertexAttribI1uiv.version = '3.0'
glVertexAttribI1uiv.category = 'GL_VERSION_3_0'
glVertexAttribI1uiv.trace = True
glVertexAttribI1uiv.play = True
gl.add(glVertexAttribI1uiv)

glVertexAttribI2i = Function('glVertexAttribI2i')
glVertexAttribI2i.ret = Return('void')
glVertexAttribI2i.add( Input( 'index','GLuint' ))
glVertexAttribI2i.add( Input( 'x','GLint' ))
glVertexAttribI2i.add( Input( 'y','GLint' ))
glVertexAttribI2i.version = '3.0'
glVertexAttribI2i.category = 'GL_VERSION_3_0'
glVertexAttribI2i.trace = True
glVertexAttribI2i.play = True
gl.add(glVertexAttribI2i)

glVertexAttribI2iv = Function('glVertexAttribI2iv')
glVertexAttribI2iv.ret = Return('void')
glVertexAttribI2iv.add( Input( 'index','GLuint' ))
glVertexAttribI2iv.add( Input( 'v','const GLint *' ,size = 2 ))
glVertexAttribI2iv.version = '3.0'
glVertexAttribI2iv.category = 'GL_VERSION_3_0'
glVertexAttribI2iv.trace = True
glVertexAttribI2iv.play = True
gl.add(glVertexAttribI2iv)

glVertexAttribI2ui = Function('glVertexAttribI2ui')
glVertexAttribI2ui.ret = Return('void')
glVertexAttribI2ui.add( Input( 'index','GLuint' ))
glVertexAttribI2ui.add( Input( 'x','GLuint' ))
glVertexAttribI2ui.add( Input( 'y','GLuint' ))
glVertexAttribI2ui.version = '3.0'
glVertexAttribI2ui.category = 'GL_VERSION_3_0'
glVertexAttribI2ui.trace = True
glVertexAttribI2ui.play = True
gl.add(glVertexAttribI2ui)

glVertexAttribI2uiv = Function('glVertexAttribI2uiv')
glVertexAttribI2uiv.ret = Return('void')
glVertexAttribI2uiv.add( Input( 'index','GLuint' ))
glVertexAttribI2uiv.add( Input( 'v','const GLuint *' ,size = 2 ))
glVertexAttribI2uiv.version = '3.0'
glVertexAttribI2uiv.category = 'GL_VERSION_3_0'
glVertexAttribI2uiv.trace = True
glVertexAttribI2uiv.play = True
gl.add(glVertexAttribI2uiv)

glVertexAttribI3i = Function('glVertexAttribI3i')
glVertexAttribI3i.ret = Return('void')
glVertexAttribI3i.add( Input( 'index','GLuint' ))
glVertexAttribI3i.add( Input( 'x','GLint' ))
glVertexAttribI3i.add( Input( 'y','GLint' ))
glVertexAttribI3i.add( Input( 'z','GLint' ))
glVertexAttribI3i.version = '3.0'
glVertexAttribI3i.category = 'GL_VERSION_3_0'
glVertexAttribI3i.trace = True
glVertexAttribI3i.play = True
gl.add(glVertexAttribI3i)

glVertexAttribI3iv = Function('glVertexAttribI3iv')
glVertexAttribI3iv.ret = Return('void')
glVertexAttribI3iv.add( Input( 'index','GLuint' ))
glVertexAttribI3iv.add( Input( 'v','const GLint *' ,size = 3 ))
glVertexAttribI3iv.version = '3.0'
glVertexAttribI3iv.category = 'GL_VERSION_3_0'
glVertexAttribI3iv.trace = True
glVertexAttribI3iv.play = True
gl.add(glVertexAttribI3iv)

glVertexAttribI3ui = Function('glVertexAttribI3ui')
glVertexAttribI3ui.ret = Return('void')
glVertexAttribI3ui.add( Input( 'index','GLuint' ))
glVertexAttribI3ui.add( Input( 'x','GLuint' ))
glVertexAttribI3ui.add( Input( 'y','GLuint' ))
glVertexAttribI3ui.add( Input( 'z','GLuint' ))
glVertexAttribI3ui.version = '3.0'
glVertexAttribI3ui.category = 'GL_VERSION_3_0'
glVertexAttribI3ui.trace = True
glVertexAttribI3ui.play = True
gl.add(glVertexAttribI3ui)

glVertexAttribI3uiv = Function('glVertexAttribI3uiv')
glVertexAttribI3uiv.ret = Return('void')
glVertexAttribI3uiv.add( Input( 'index','GLuint' ))
glVertexAttribI3uiv.add( Input( 'v','const GLuint *' ,size = 3 ))
glVertexAttribI3uiv.version = '3.0'
glVertexAttribI3uiv.category = 'GL_VERSION_3_0'
glVertexAttribI3uiv.trace = True
glVertexAttribI3uiv.play = True
gl.add(glVertexAttribI3uiv)

glVertexAttribI4bv = Function('glVertexAttribI4bv')
glVertexAttribI4bv.ret = Return('void')
glVertexAttribI4bv.add( Input( 'index','GLuint' ))
glVertexAttribI4bv.add( Input( 'v','const GLbyte *' ,size = 4 ))
glVertexAttribI4bv.version = '3.0'
glVertexAttribI4bv.category = 'GL_VERSION_3_0'
glVertexAttribI4bv.trace = True
glVertexAttribI4bv.play = True
gl.add(glVertexAttribI4bv)

glVertexAttribI4i = Function('glVertexAttribI4i')
glVertexAttribI4i.ret = Return('void')
glVertexAttribI4i.add( Input( 'index','GLuint' ))
glVertexAttribI4i.add( Input( 'x','GLint' ))
glVertexAttribI4i.add( Input( 'y','GLint' ))
glVertexAttribI4i.add( Input( 'z','GLint' ))
glVertexAttribI4i.add( Input( 'w','GLint' ))
glVertexAttribI4i.version = '3.0'
glVertexAttribI4i.category = 'GL_VERSION_3_0'
glVertexAttribI4i.trace = True
glVertexAttribI4i.play = True
gl.add(glVertexAttribI4i)

glVertexAttribI4iv = Function('glVertexAttribI4iv')
glVertexAttribI4iv.ret = Return('void')
glVertexAttribI4iv.add( Input( 'index','GLuint' ))
glVertexAttribI4iv.add( Input( 'v','const GLint *' ,size = 4 ))
glVertexAttribI4iv.version = '3.0'
glVertexAttribI4iv.category = 'GL_VERSION_3_0'
glVertexAttribI4iv.trace = True
glVertexAttribI4iv.play = True
gl.add(glVertexAttribI4iv)

glVertexAttribI4sv = Function('glVertexAttribI4sv')
glVertexAttribI4sv.ret = Return('void')
glVertexAttribI4sv.add( Input( 'index','GLuint' ))
glVertexAttribI4sv.add( Input( 'v','const GLshort *' ,size = 4 ))
glVertexAttribI4sv.version = '3.0'
glVertexAttribI4sv.category = 'GL_VERSION_3_0'
glVertexAttribI4sv.trace = True
glVertexAttribI4sv.play = True
gl.add(glVertexAttribI4sv)

glVertexAttribI4ubv = Function('glVertexAttribI4ubv')
glVertexAttribI4ubv.ret = Return('void')
glVertexAttribI4ubv.add( Input( 'index','GLuint' ))
glVertexAttribI4ubv.add( Input( 'v','const GLubyte *' ,size = 4 ))
glVertexAttribI4ubv.version = '3.0'
glVertexAttribI4ubv.category = 'GL_VERSION_3_0'
glVertexAttribI4ubv.trace = True
glVertexAttribI4ubv.play = True
gl.add(glVertexAttribI4ubv)

glVertexAttribI4ui = Function('glVertexAttribI4ui')
glVertexAttribI4ui.ret = Return('void')
glVertexAttribI4ui.add( Input( 'index','GLuint' ))
glVertexAttribI4ui.add( Input( 'x','GLuint' ))
glVertexAttribI4ui.add( Input( 'y','GLuint' ))
glVertexAttribI4ui.add( Input( 'z','GLuint' ))
glVertexAttribI4ui.add( Input( 'w','GLuint' ))
glVertexAttribI4ui.version = '3.0'
glVertexAttribI4ui.category = 'GL_VERSION_3_0'
glVertexAttribI4ui.trace = True
glVertexAttribI4ui.play = True
gl.add(glVertexAttribI4ui)

glVertexAttribI4uiv = Function('glVertexAttribI4uiv')
glVertexAttribI4uiv.ret = Return('void')
glVertexAttribI4uiv.add( Input( 'index','GLuint' ))
glVertexAttribI4uiv.add( Input( 'v','const GLuint *' ,size = 4 ))
glVertexAttribI4uiv.version = '3.0'
glVertexAttribI4uiv.category = 'GL_VERSION_3_0'
glVertexAttribI4uiv.trace = True
glVertexAttribI4uiv.play = True
gl.add(glVertexAttribI4uiv)

glVertexAttribI4usv = Function('glVertexAttribI4usv')
glVertexAttribI4usv.ret = Return('void')
glVertexAttribI4usv.add( Input( 'index','GLuint' ))
glVertexAttribI4usv.add( Input( 'v','const GLushort *' ,size = 4 ))
glVertexAttribI4usv.version = '3.0'
glVertexAttribI4usv.category = 'GL_VERSION_3_0'
glVertexAttribI4usv.trace = True
glVertexAttribI4usv.play = True
gl.add(glVertexAttribI4usv)

glVertexAttribIPointer = Function('glVertexAttribIPointer')
glVertexAttribIPointer.ret = Return('void')
glVertexAttribIPointer.add( Input( 'index','GLuint' ))
glVertexAttribIPointer.add( Input( 'size','GLint' ))
glVertexAttribIPointer.add( Input( 'type','GLenum' ))
glVertexAttribIPointer.add( Input( 'stride','GLsizei' ))
glVertexAttribIPointer.add( Input( 'pointer','const GLvoid *' ))
glVertexAttribIPointer.version = '3.0'
glVertexAttribIPointer.category = 'GL_VERSION_3_0'
glVertexAttribIPointer.trace = True
glVertexAttribIPointer.play = True
gl.add(glVertexAttribIPointer)

# GL_VERSION_3_1

glDrawArraysInstanced = Function('glDrawArraysInstanced')
glDrawArraysInstanced.ret = Return('void')
glDrawArraysInstanced.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glDrawArraysInstanced.add( Input( 'start','GLint' ))
glDrawArraysInstanced.add( Input( 'count','GLsizei' ))
glDrawArraysInstanced.add( Input( 'primcount','GLsizei' ))
glDrawArraysInstanced.version = '3.1'
glDrawArraysInstanced.category = 'GL_VERSION_3_1'
glDrawArraysInstanced.trace = True
glDrawArraysInstanced.play = True
gl.add(glDrawArraysInstanced)

glDrawElementsInstanced = Function('glDrawElementsInstanced')
glDrawElementsInstanced.ret = Return('void')
glDrawElementsInstanced.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glDrawElementsInstanced.add( Input( 'count','GLsizei' ))
glDrawElementsInstanced.add( Input( 'type','GLenum' ))
glDrawElementsInstanced.add( Input( 'indices','const GLvoid *' ))
glDrawElementsInstanced.add( Input( 'primcount','GLsizei' ))
glDrawElementsInstanced.version = '3.1'
glDrawElementsInstanced.category = 'GL_VERSION_3_1'
glDrawElementsInstanced.trace = True
glDrawElementsInstanced.play = True
gl.add(glDrawElementsInstanced)

glPrimitiveRestartIndex = Function('glPrimitiveRestartIndex')
glPrimitiveRestartIndex.ret = Return('void')
glPrimitiveRestartIndex.add( Input( 'index','GLuint' ))
glPrimitiveRestartIndex.version = '3.1'
glPrimitiveRestartIndex.category = 'GL_VERSION_3_1'
glPrimitiveRestartIndex.trace = True
glPrimitiveRestartIndex.play = True
gl.add(glPrimitiveRestartIndex)

glTexBuffer = Function('glTexBuffer')
glTexBuffer.ret = Return('void')
glTexBuffer.add( Input( 'target','GLenum' ))
glTexBuffer.add( Input( 'internalformat','GLenum' ))
glTexBuffer.add( Input( 'buffer','GLuint' ))
glTexBuffer.version = '3.1'
glTexBuffer.category = 'GL_VERSION_3_1'
glTexBuffer.trace = True
glTexBuffer.play = True
gl.add(glTexBuffer)

# GL_VERSION_3_2

glFramebufferTexture = Function('glFramebufferTexture')
glFramebufferTexture.ret = Return('void')
glFramebufferTexture.add( Input( 'target','GLenum' ))
glFramebufferTexture.add( Input( 'attachment','GLenum' ))
glFramebufferTexture.add( Input( 'texture','GLuint' ))
glFramebufferTexture.add( Input( 'level','GLint' ))
glFramebufferTexture.version = '3.2'
glFramebufferTexture.category = 'GL_VERSION_3_2'
glFramebufferTexture.trace = True
glFramebufferTexture.play = True
gl.add(glFramebufferTexture)

glGetBufferParameteri64v = Function('glGetBufferParameteri64v')
glGetBufferParameteri64v.ret = Return('void')
glGetBufferParameteri64v.add( Input( 'target','GLenum' ))
glGetBufferParameteri64v.add( Input( 'pname','GLenum' ))
glGetBufferParameteri64v.add( Output( 'params','GLint64 *' ))
glGetBufferParameteri64v.version = '3.2'
glGetBufferParameteri64v.category = 'GL_VERSION_3_2'
glGetBufferParameteri64v.trace = True
glGetBufferParameteri64v.play = False
gl.add(glGetBufferParameteri64v)

glGetInteger64i_v = Function('glGetInteger64i_v')
glGetInteger64i_v.ret = Return('void')
glGetInteger64i_v.add( Input( 'target','GLenum' ))
glGetInteger64i_v.add( Input( 'index','GLuint' ))
glGetInteger64i_v.add( Output( 'data','GLint64 *' ))
glGetInteger64i_v.version = '3.2'
glGetInteger64i_v.category = 'GL_VERSION_3_2'
glGetInteger64i_v.trace = True
glGetInteger64i_v.play = False
gl.add(glGetInteger64i_v)

# GL_VERSION_3_3

glVertexAttribDivisor = Function('glVertexAttribDivisor')
glVertexAttribDivisor.ret = Return('void')
glVertexAttribDivisor.add( Input( 'index','GLuint' ))
glVertexAttribDivisor.add( Input( 'divisor','GLuint' ))
glVertexAttribDivisor.version = '3.3'
glVertexAttribDivisor.category = 'GL_VERSION_3_3'
glVertexAttribDivisor.trace = True
glVertexAttribDivisor.play = True
gl.add(glVertexAttribDivisor)

# GL_VERSION_4_0

glBlendEquationSeparatei = Function('glBlendEquationSeparatei')
glBlendEquationSeparatei.ret = Return('void')
glBlendEquationSeparatei.add( Input( 'buf','GLuint' ))
glBlendEquationSeparatei.add( Input( 'modeRGB','GLenum' ,regalLog = 'GLmodeToString(modeRGB)' ))
glBlendEquationSeparatei.add( Input( 'modeAlpha','GLenum' ,regalLog = 'GLmodeToString(modeAlpha)' ))
glBlendEquationSeparatei.version = '4.0'
glBlendEquationSeparatei.category = 'GL_VERSION_4_0'
glBlendEquationSeparatei.trace = True
glBlendEquationSeparatei.play = True
gl.add(glBlendEquationSeparatei)

glBlendEquationi = Function('glBlendEquationi')
glBlendEquationi.ret = Return('void')
glBlendEquationi.add( Input( 'buf','GLuint' ))
glBlendEquationi.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glBlendEquationi.version = '4.0'
glBlendEquationi.category = 'GL_VERSION_4_0'
glBlendEquationi.trace = True
glBlendEquationi.play = True
gl.add(glBlendEquationi)

glBlendFuncSeparatei = Function('glBlendFuncSeparatei')
glBlendFuncSeparatei.ret = Return('void')
glBlendFuncSeparatei.add( Input( 'buf','GLuint' ))
glBlendFuncSeparatei.add( Input( 'srcRGB','GLenum' ))
glBlendFuncSeparatei.add( Input( 'dstRGB','GLenum' ))
glBlendFuncSeparatei.add( Input( 'srcAlpha','GLenum' ))
glBlendFuncSeparatei.add( Input( 'dstAlpha','GLenum' ))
glBlendFuncSeparatei.version = '4.0'
glBlendFuncSeparatei.category = 'GL_VERSION_4_0'
glBlendFuncSeparatei.trace = True
glBlendFuncSeparatei.play = True
gl.add(glBlendFuncSeparatei)

glBlendFunci = Function('glBlendFunci')
glBlendFunci.ret = Return('void')
glBlendFunci.add( Input( 'buf','GLuint' ))
glBlendFunci.add( Input( 'src','GLenum' ))
glBlendFunci.add( Input( 'dst','GLenum' ))
glBlendFunci.version = '4.0'
glBlendFunci.category = 'GL_VERSION_4_0'
glBlendFunci.trace = True
glBlendFunci.play = True
gl.add(glBlendFunci)

#

glSampleCoverage = Function('glSampleCoverage')
glSampleCoverage.ret = Return('void')
glSampleCoverage.add( Input( 'value','GLclampf' ))
glSampleCoverage.add( Input( 'invert','GLboolean' ))
glSampleCoverage.version = '1.3'
glSampleCoverage.category = ''
glSampleCoverage.esVersions = [1.0, 1.1, 2.0]
glSampleCoverage.trace = True
glSampleCoverage.play = True
gl.add(glSampleCoverage)

# GL_3DFX_tbuffer

glTbufferMask3DFX = Function('glTbufferMask3DFX')
glTbufferMask3DFX.ret = Return('void')
glTbufferMask3DFX.add( Input( 'mask','GLuint' ))
glTbufferMask3DFX.version = '1.2'
glTbufferMask3DFX.category = 'GL_3DFX_tbuffer'
glTbufferMask3DFX.trace = True
glTbufferMask3DFX.play = True
gl.add(glTbufferMask3DFX)

# GL_AMD_debug_output

glDebugMessageCallbackAMD = Function('glDebugMessageCallbackAMD')
glDebugMessageCallbackAMD.ret = Return('void')
glDebugMessageCallbackAMD.add( Input( 'callback','GLDEBUGPROCAMD' ))
glDebugMessageCallbackAMD.add( Input( 'userParam','void *' ))
glDebugMessageCallbackAMD.version = ''
glDebugMessageCallbackAMD.category = 'GL_AMD_debug_output'
glDebugMessageCallbackAMD.trace = True
glDebugMessageCallbackAMD.play = True
gl.add(glDebugMessageCallbackAMD)

glDebugMessageEnableAMD = Function('glDebugMessageEnableAMD')
glDebugMessageEnableAMD.ret = Return('void')
glDebugMessageEnableAMD.add( Input( 'category','GLenum' ))
glDebugMessageEnableAMD.add( Input( 'severity','GLenum' ))
glDebugMessageEnableAMD.add( Input( 'count','GLsizei' ))
glDebugMessageEnableAMD.add( Input( 'ids','const GLuint *' ))
glDebugMessageEnableAMD.add( Input( 'enabled','GLboolean' ))
glDebugMessageEnableAMD.version = ''
glDebugMessageEnableAMD.category = 'GL_AMD_debug_output'
glDebugMessageEnableAMD.trace = True
glDebugMessageEnableAMD.play = True
gl.add(glDebugMessageEnableAMD)

glDebugMessageInsertAMD = Function('glDebugMessageInsertAMD')
glDebugMessageInsertAMD.ret = Return('void')
glDebugMessageInsertAMD.add( Input( 'category','GLenum' ))
glDebugMessageInsertAMD.add( Input( 'severity','GLenum' ))
glDebugMessageInsertAMD.add( Input( 'id','GLuint' ))
glDebugMessageInsertAMD.add( Input( 'length','GLsizei' ))
glDebugMessageInsertAMD.add( Input( 'buf','const GLchar *' ))
glDebugMessageInsertAMD.version = ''
glDebugMessageInsertAMD.category = 'GL_AMD_debug_output'
glDebugMessageInsertAMD.trace = True
glDebugMessageInsertAMD.play = True
gl.add(glDebugMessageInsertAMD)

glGetDebugMessageLogAMD = Function('glGetDebugMessageLogAMD')
glGetDebugMessageLogAMD.ret = Return('GLuint')
glGetDebugMessageLogAMD.add( Input( 'count','GLuint' ))
glGetDebugMessageLogAMD.add( Input( 'bufsize','GLsizei' ))
glGetDebugMessageLogAMD.add( Input( 'categories','GLenum *' ))
glGetDebugMessageLogAMD.add( Input( 'severities','GLuint *' ))
glGetDebugMessageLogAMD.add( Input( 'ids','GLuint *' ))
glGetDebugMessageLogAMD.add( Input( 'lengths','GLsizei *' ))
glGetDebugMessageLogAMD.add( Input( 'message','GLchar *' ))
glGetDebugMessageLogAMD.version = ''
glGetDebugMessageLogAMD.category = 'GL_AMD_debug_output'
glGetDebugMessageLogAMD.trace = True
glGetDebugMessageLogAMD.play = False
gl.add(glGetDebugMessageLogAMD)

# GL_AMD_draw_buffers_blend

glBlendEquationIndexedAMD = Function('glBlendEquationIndexedAMD')
glBlendEquationIndexedAMD.ret = Return('void')
glBlendEquationIndexedAMD.add( Input( 'buf','GLuint' ))
glBlendEquationIndexedAMD.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glBlendEquationIndexedAMD.version = '2.0'
glBlendEquationIndexedAMD.category = 'GL_AMD_draw_buffers_blend'
glBlendEquationIndexedAMD.trace = True
glBlendEquationIndexedAMD.play = True
gl.add(glBlendEquationIndexedAMD)

glBlendEquationSeparateIndexedAMD = Function('glBlendEquationSeparateIndexedAMD')
glBlendEquationSeparateIndexedAMD.ret = Return('void')
glBlendEquationSeparateIndexedAMD.add( Input( 'buf','GLuint' ))
glBlendEquationSeparateIndexedAMD.add( Input( 'modeRGB','GLenum' ,regalLog = 'GLmodeToString(modeRGB)' ))
glBlendEquationSeparateIndexedAMD.add( Input( 'modeAlpha','GLenum' ,regalLog = 'GLmodeToString(modeAlpha)' ))
glBlendEquationSeparateIndexedAMD.version = '2.0'
glBlendEquationSeparateIndexedAMD.category = 'GL_AMD_draw_buffers_blend'
glBlendEquationSeparateIndexedAMD.trace = True
glBlendEquationSeparateIndexedAMD.play = True
gl.add(glBlendEquationSeparateIndexedAMD)

glBlendFuncIndexedAMD = Function('glBlendFuncIndexedAMD')
glBlendFuncIndexedAMD.ret = Return('void')
glBlendFuncIndexedAMD.add( Input( 'buf','GLuint' ))
glBlendFuncIndexedAMD.add( Input( 'src','GLenum' ))
glBlendFuncIndexedAMD.add( Input( 'dst','GLenum' ))
glBlendFuncIndexedAMD.version = '2.0'
glBlendFuncIndexedAMD.category = 'GL_AMD_draw_buffers_blend'
glBlendFuncIndexedAMD.trace = True
glBlendFuncIndexedAMD.play = True
gl.add(glBlendFuncIndexedAMD)

glBlendFuncSeparateIndexedAMD = Function('glBlendFuncSeparateIndexedAMD')
glBlendFuncSeparateIndexedAMD.ret = Return('void')
glBlendFuncSeparateIndexedAMD.add( Input( 'buf','GLuint' ))
glBlendFuncSeparateIndexedAMD.add( Input( 'srcRGB','GLenum' ))
glBlendFuncSeparateIndexedAMD.add( Input( 'dstRGB','GLenum' ))
glBlendFuncSeparateIndexedAMD.add( Input( 'srcAlpha','GLenum' ))
glBlendFuncSeparateIndexedAMD.add( Input( 'dstAlpha','GLenum' ))
glBlendFuncSeparateIndexedAMD.version = '2.0'
glBlendFuncSeparateIndexedAMD.category = 'GL_AMD_draw_buffers_blend'
glBlendFuncSeparateIndexedAMD.trace = True
glBlendFuncSeparateIndexedAMD.play = True
gl.add(glBlendFuncSeparateIndexedAMD)

# GL_AMD_interleaved_elements

glVertexAttribParameteriAMD = Function('glVertexAttribParameteriAMD')
glVertexAttribParameteriAMD.ret = Return('void')
glVertexAttribParameteriAMD.add( Input( 'index','GLuint' ))
glVertexAttribParameteriAMD.add( Input( 'pname','GLenum' ))
glVertexAttribParameteriAMD.add( Input( 'param','GLint' ))
glVertexAttribParameteriAMD.version = ''
glVertexAttribParameteriAMD.category = 'GL_AMD_interleaved_elements'
glVertexAttribParameteriAMD.trace = True
glVertexAttribParameteriAMD.play = True
gl.add(glVertexAttribParameteriAMD)

# GL_AMD_multi_draw_indirect

glMultiDrawArraysIndirectAMD = Function('glMultiDrawArraysIndirectAMD')
glMultiDrawArraysIndirectAMD.ret = Return('void')
glMultiDrawArraysIndirectAMD.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glMultiDrawArraysIndirectAMD.add( Input( 'indirect','const GLvoid *' ))
glMultiDrawArraysIndirectAMD.add( Input( 'primcount','GLsizei' ))
glMultiDrawArraysIndirectAMD.add( Input( 'stride','GLsizei' ))
glMultiDrawArraysIndirectAMD.version = ''
glMultiDrawArraysIndirectAMD.category = 'GL_AMD_multi_draw_indirect'
glMultiDrawArraysIndirectAMD.trace = True
glMultiDrawArraysIndirectAMD.play = True
gl.add(glMultiDrawArraysIndirectAMD)

glMultiDrawElementsIndirectAMD = Function('glMultiDrawElementsIndirectAMD')
glMultiDrawElementsIndirectAMD.ret = Return('void')
glMultiDrawElementsIndirectAMD.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glMultiDrawElementsIndirectAMD.add( Input( 'type','GLenum' ))
glMultiDrawElementsIndirectAMD.add( Input( 'indirect','const GLvoid *' ))
glMultiDrawElementsIndirectAMD.add( Input( 'primcount','GLsizei' ))
glMultiDrawElementsIndirectAMD.add( Input( 'stride','GLsizei' ))
glMultiDrawElementsIndirectAMD.version = ''
glMultiDrawElementsIndirectAMD.category = 'GL_AMD_multi_draw_indirect'
glMultiDrawElementsIndirectAMD.trace = True
glMultiDrawElementsIndirectAMD.play = True
gl.add(glMultiDrawElementsIndirectAMD)

# GL_AMD_name_gen_delete

glDeleteNamesAMD = Function('glDeleteNamesAMD')
glDeleteNamesAMD.ret = Return('void')
glDeleteNamesAMD.add( Input( 'identifier','GLenum' ))
glDeleteNamesAMD.add( Input( 'num','GLuint' ))
glDeleteNamesAMD.add( Input( 'names','const GLuint *' ))
glDeleteNamesAMD.version = ''
glDeleteNamesAMD.category = 'GL_AMD_name_gen_delete'
glDeleteNamesAMD.trace = True
glDeleteNamesAMD.play = True
gl.add(glDeleteNamesAMD)

glGenNamesAMD = Function('glGenNamesAMD')
glGenNamesAMD.ret = Return('void')
glGenNamesAMD.add( Input( 'identifier','GLenum' ))
glGenNamesAMD.add( Input( 'num','GLuint' ))
glGenNamesAMD.add( Input( 'names','GLuint *' ))
glGenNamesAMD.version = ''
glGenNamesAMD.category = 'GL_AMD_name_gen_delete'
glGenNamesAMD.trace = True
glGenNamesAMD.play = True
gl.add(glGenNamesAMD)

glIsNameAMD = Function('glIsNameAMD')
glIsNameAMD.ret = Return('GLboolean')
glIsNameAMD.add( Input( 'identifier','GLenum' ))
glIsNameAMD.add( Input( 'name','GLuint' ))
glIsNameAMD.version = ''
glIsNameAMD.category = 'GL_AMD_name_gen_delete'
glIsNameAMD.trace = True
glIsNameAMD.play = True
gl.add(glIsNameAMD)

# GL_AMD_performance_monitor

glBeginPerfMonitorAMD = Function('glBeginPerfMonitorAMD')
glBeginPerfMonitorAMD.ret = Return('void')
glBeginPerfMonitorAMD.add( Input( 'monitor','GLuint' ))
glBeginPerfMonitorAMD.version = '1.2'
glBeginPerfMonitorAMD.category = 'GL_AMD_performance_monitor'
glBeginPerfMonitorAMD.trace = True
glBeginPerfMonitorAMD.play = True
gl.add(glBeginPerfMonitorAMD)

glDeletePerfMonitorsAMD = Function('glDeletePerfMonitorsAMD')
glDeletePerfMonitorsAMD.ret = Return('void')
glDeletePerfMonitorsAMD.add( Input( 'n','GLsizei' ))
glDeletePerfMonitorsAMD.add( Output( 'monitors','GLuint *' ))
glDeletePerfMonitorsAMD.version = '1.2'
glDeletePerfMonitorsAMD.category = 'GL_AMD_performance_monitor'
glDeletePerfMonitorsAMD.trace = True
glDeletePerfMonitorsAMD.play = True
gl.add(glDeletePerfMonitorsAMD)

glEndPerfMonitorAMD = Function('glEndPerfMonitorAMD')
glEndPerfMonitorAMD.ret = Return('void')
glEndPerfMonitorAMD.add( Input( 'monitor','GLuint' ))
glEndPerfMonitorAMD.version = '1.2'
glEndPerfMonitorAMD.category = 'GL_AMD_performance_monitor'
glEndPerfMonitorAMD.trace = True
glEndPerfMonitorAMD.play = True
gl.add(glEndPerfMonitorAMD)

glGenPerfMonitorsAMD = Function('glGenPerfMonitorsAMD')
glGenPerfMonitorsAMD.ret = Return('void')
glGenPerfMonitorsAMD.add( Input( 'n','GLsizei' ))
glGenPerfMonitorsAMD.add( Output( 'monitors','GLuint *' ))
glGenPerfMonitorsAMD.version = '1.2'
glGenPerfMonitorsAMD.category = 'GL_AMD_performance_monitor'
glGenPerfMonitorsAMD.trace = True
glGenPerfMonitorsAMD.play = True
gl.add(glGenPerfMonitorsAMD)

glGetPerfMonitorCounterDataAMD = Function('glGetPerfMonitorCounterDataAMD')
glGetPerfMonitorCounterDataAMD.ret = Return('void')
glGetPerfMonitorCounterDataAMD.add( Input( 'monitor','GLuint' ))
glGetPerfMonitorCounterDataAMD.add( Input( 'pname','GLenum' ))
glGetPerfMonitorCounterDataAMD.add( Input( 'dataSize','GLsizei' ))
glGetPerfMonitorCounterDataAMD.add( Output( 'data','GLuint *' ))
glGetPerfMonitorCounterDataAMD.add( Output( 'bytesWritten','GLint *' ,size = 1 ))
glGetPerfMonitorCounterDataAMD.version = '1.2'
glGetPerfMonitorCounterDataAMD.category = 'GL_AMD_performance_monitor'
glGetPerfMonitorCounterDataAMD.trace = True
glGetPerfMonitorCounterDataAMD.play = True
gl.add(glGetPerfMonitorCounterDataAMD)

glGetPerfMonitorCounterInfoAMD = Function('glGetPerfMonitorCounterInfoAMD')
glGetPerfMonitorCounterInfoAMD.ret = Return('void')
glGetPerfMonitorCounterInfoAMD.add( Input( 'group','GLuint' ))
glGetPerfMonitorCounterInfoAMD.add( Input( 'counter','GLuint' ))
glGetPerfMonitorCounterInfoAMD.add( Input( 'pname','GLenum' ))
glGetPerfMonitorCounterInfoAMD.add( Output( 'data','GLvoid *' ))
glGetPerfMonitorCounterInfoAMD.version = '1.2'
glGetPerfMonitorCounterInfoAMD.category = 'GL_AMD_performance_monitor'
glGetPerfMonitorCounterInfoAMD.trace = True
glGetPerfMonitorCounterInfoAMD.play = True
gl.add(glGetPerfMonitorCounterInfoAMD)

glGetPerfMonitorCounterStringAMD = Function('glGetPerfMonitorCounterStringAMD')
glGetPerfMonitorCounterStringAMD.ret = Return('void')
glGetPerfMonitorCounterStringAMD.add( Input( 'group','GLuint' ))
glGetPerfMonitorCounterStringAMD.add( Input( 'counter','GLuint' ))
glGetPerfMonitorCounterStringAMD.add( Input( 'bufSize','GLsizei' ))
glGetPerfMonitorCounterStringAMD.add( Output( 'length','GLsizei *' ,size = 1 ))
glGetPerfMonitorCounterStringAMD.add( Output( 'counterString','GLchar *' ,maxSize = 'bufSize' ))
glGetPerfMonitorCounterStringAMD.version = '1.2'
glGetPerfMonitorCounterStringAMD.category = 'GL_AMD_performance_monitor'
glGetPerfMonitorCounterStringAMD.trace = True
glGetPerfMonitorCounterStringAMD.play = False
gl.add(glGetPerfMonitorCounterStringAMD)

glGetPerfMonitorCountersAMD = Function('glGetPerfMonitorCountersAMD')
glGetPerfMonitorCountersAMD.ret = Return('void')
glGetPerfMonitorCountersAMD.add( Input( 'group','GLuint' ))
glGetPerfMonitorCountersAMD.add( Output( 'numCounters','GLint *' ,size = 1 ))
glGetPerfMonitorCountersAMD.add( Output( 'maxActiveCounters','GLint *' ,size = 1 ))
glGetPerfMonitorCountersAMD.add( Input( 'countersSize','GLsizei' ))
glGetPerfMonitorCountersAMD.add( Output( 'counters','GLuint *' ))
glGetPerfMonitorCountersAMD.version = '1.2'
glGetPerfMonitorCountersAMD.category = 'GL_AMD_performance_monitor'
glGetPerfMonitorCountersAMD.trace = True
glGetPerfMonitorCountersAMD.play = True
gl.add(glGetPerfMonitorCountersAMD)

glGetPerfMonitorGroupStringAMD = Function('glGetPerfMonitorGroupStringAMD')
glGetPerfMonitorGroupStringAMD.ret = Return('void')
glGetPerfMonitorGroupStringAMD.add( Input( 'group','GLuint' ))
glGetPerfMonitorGroupStringAMD.add( Input( 'bufSize','GLsizei' ))
glGetPerfMonitorGroupStringAMD.add( Output( 'length','GLsizei *' ,size = 1 ))
glGetPerfMonitorGroupStringAMD.add( Output( 'groupString','GLchar *' ,maxSize = 'bufSize' ))
glGetPerfMonitorGroupStringAMD.version = '1.2'
glGetPerfMonitorGroupStringAMD.category = 'GL_AMD_performance_monitor'
glGetPerfMonitorGroupStringAMD.trace = True
glGetPerfMonitorGroupStringAMD.play = False
gl.add(glGetPerfMonitorGroupStringAMD)

glGetPerfMonitorGroupsAMD = Function('glGetPerfMonitorGroupsAMD')
glGetPerfMonitorGroupsAMD.ret = Return('void')
glGetPerfMonitorGroupsAMD.add( Output( 'numGroups','GLint *' ,size = 1 ))
glGetPerfMonitorGroupsAMD.add( Input( 'groupsSize','GLsizei' ))
glGetPerfMonitorGroupsAMD.add( Output( 'groups','GLuint *' ))
glGetPerfMonitorGroupsAMD.version = '1.2'
glGetPerfMonitorGroupsAMD.category = 'GL_AMD_performance_monitor'
glGetPerfMonitorGroupsAMD.trace = True
glGetPerfMonitorGroupsAMD.play = True
gl.add(glGetPerfMonitorGroupsAMD)

glSelectPerfMonitorCountersAMD = Function('glSelectPerfMonitorCountersAMD')
glSelectPerfMonitorCountersAMD.ret = Return('void')
glSelectPerfMonitorCountersAMD.add( Input( 'monitor','GLuint' ))
glSelectPerfMonitorCountersAMD.add( Input( 'enable','GLboolean' ))
glSelectPerfMonitorCountersAMD.add( Input( 'group','GLuint' ))
glSelectPerfMonitorCountersAMD.add( Input( 'numCounters','GLint' ))
glSelectPerfMonitorCountersAMD.add( Output( 'counterList','GLuint *' ))
glSelectPerfMonitorCountersAMD.version = '1.2'
glSelectPerfMonitorCountersAMD.category = 'GL_AMD_performance_monitor'
glSelectPerfMonitorCountersAMD.trace = True
glSelectPerfMonitorCountersAMD.play = True
gl.add(glSelectPerfMonitorCountersAMD)

# GL_AMD_sample_positions

glSetMultisamplefvAMD = Function('glSetMultisamplefvAMD')
glSetMultisamplefvAMD.ret = Return('void')
glSetMultisamplefvAMD.add( Input( 'pname','GLenum' ))
glSetMultisamplefvAMD.add( Input( 'index','GLuint' ))
glSetMultisamplefvAMD.add( Input( 'val','const GLfloat *' ))
glSetMultisamplefvAMD.version = ''
glSetMultisamplefvAMD.category = 'GL_AMD_sample_positions'
glSetMultisamplefvAMD.trace = True
glSetMultisamplefvAMD.play = True
gl.add(glSetMultisamplefvAMD)

# GL_AMD_sparse_texture

glTexStorageSparseAMD = Function('glTexStorageSparseAMD')
glTexStorageSparseAMD.ret = Return('void')
glTexStorageSparseAMD.add( Input( 'target','GLenum' ))
glTexStorageSparseAMD.add( Input( 'internalFormat','GLenum' ))
glTexStorageSparseAMD.add( Input( 'width','GLsizei' ))
glTexStorageSparseAMD.add( Input( 'height','GLsizei' ))
glTexStorageSparseAMD.add( Input( 'depth','GLsizei' ))
glTexStorageSparseAMD.add( Input( 'layers','GLsizei' ))
glTexStorageSparseAMD.add( Input( 'flags','GLbitfield' ,regalLog = 'GLtexStorageSparseAMDToString(flags)' ))
glTexStorageSparseAMD.version = ''
glTexStorageSparseAMD.category = 'GL_AMD_sparse_texture'
glTexStorageSparseAMD.trace = True
glTexStorageSparseAMD.play = True
gl.add(glTexStorageSparseAMD)

glTextureStorageSparseAMD = Function('glTextureStorageSparseAMD')
glTextureStorageSparseAMD.ret = Return('void')
glTextureStorageSparseAMD.add( Input( 'texture','GLuint' ))
glTextureStorageSparseAMD.add( Input( 'target','GLenum' ))
glTextureStorageSparseAMD.add( Input( 'internalFormat','GLenum' ))
glTextureStorageSparseAMD.add( Input( 'width','GLsizei' ))
glTextureStorageSparseAMD.add( Input( 'height','GLsizei' ))
glTextureStorageSparseAMD.add( Input( 'depth','GLsizei' ))
glTextureStorageSparseAMD.add( Input( 'layers','GLsizei' ))
glTextureStorageSparseAMD.add( Input( 'flags','GLbitfield' ,regalLog = 'GLtexStorageSparseAMDToString(flags)' ))
glTextureStorageSparseAMD.version = ''
glTextureStorageSparseAMD.category = 'GL_AMD_sparse_texture'
glTextureStorageSparseAMD.trace = True
glTextureStorageSparseAMD.play = True
gl.add(glTextureStorageSparseAMD)

# GL_AMD_stencil_operation_extended

glStencilOpValueAMD = Function('glStencilOpValueAMD')
glStencilOpValueAMD.ret = Return('void')
glStencilOpValueAMD.add( Input( 'face','GLenum' ))
glStencilOpValueAMD.add( Input( 'value','GLuint' ))
glStencilOpValueAMD.version = ''
glStencilOpValueAMD.category = 'GL_AMD_stencil_operation_extended'
glStencilOpValueAMD.trace = True
glStencilOpValueAMD.play = True
gl.add(glStencilOpValueAMD)

# GL_AMD_vertex_shader_tessellator

glTessellationFactorAMD = Function('glTessellationFactorAMD')
glTessellationFactorAMD.ret = Return('void')
glTessellationFactorAMD.add( Input( 'factor','GLfloat' ))
glTessellationFactorAMD.version = '2.0'
glTessellationFactorAMD.category = 'GL_AMD_vertex_shader_tessellator'
glTessellationFactorAMD.trace = True
glTessellationFactorAMD.play = True
gl.add(glTessellationFactorAMD)

glTessellationModeAMD = Function('glTessellationModeAMD')
glTessellationModeAMD.ret = Return('void')
glTessellationModeAMD.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glTessellationModeAMD.version = '2.0'
glTessellationModeAMD.category = 'GL_AMD_vertex_shader_tessellator'
glTessellationModeAMD.trace = True
glTessellationModeAMD.play = True
gl.add(glTessellationModeAMD)

# GL_ANGLE_framebuffer_blit

glBlitFramebufferANGLE = Function('glBlitFramebufferANGLE')
glBlitFramebufferANGLE.ret = Return('void')
glBlitFramebufferANGLE.add( Input( 'srcX0','GLint' ))
glBlitFramebufferANGLE.add( Input( 'srcY0','GLint' ))
glBlitFramebufferANGLE.add( Input( 'srcX1','GLint' ))
glBlitFramebufferANGLE.add( Input( 'srcY1','GLint' ))
glBlitFramebufferANGLE.add( Input( 'dstX0','GLint' ))
glBlitFramebufferANGLE.add( Input( 'dstY0','GLint' ))
glBlitFramebufferANGLE.add( Input( 'dstX1','GLint' ))
glBlitFramebufferANGLE.add( Input( 'dstY1','GLint' ))
glBlitFramebufferANGLE.add( Input( 'mask','GLbitfield' ,regalLog = 'GLblitFramebufferToString(mask)' ))
glBlitFramebufferANGLE.add( Input( 'filter','GLenum' ))
glBlitFramebufferANGLE.version = ''
glBlitFramebufferANGLE.category = 'GL_ANGLE_framebuffer_blit'
glBlitFramebufferANGLE.trace = True
glBlitFramebufferANGLE.play = True
gl.add(glBlitFramebufferANGLE)

# GL_ANGLE_framebuffer_multisample

glRenderbufferStorageMultisampleANGLE = Function('glRenderbufferStorageMultisampleANGLE')
glRenderbufferStorageMultisampleANGLE.ret = Return('void')
glRenderbufferStorageMultisampleANGLE.add( Input( 'target','GLenum' ))
glRenderbufferStorageMultisampleANGLE.add( Input( 'samples','GLsizei' ))
glRenderbufferStorageMultisampleANGLE.add( Input( 'internalformat','GLenum' ))
glRenderbufferStorageMultisampleANGLE.add( Input( 'width','GLsizei' ))
glRenderbufferStorageMultisampleANGLE.add( Input( 'height','GLsizei' ))
glRenderbufferStorageMultisampleANGLE.version = ''
glRenderbufferStorageMultisampleANGLE.category = 'GL_ANGLE_framebuffer_multisample'
glRenderbufferStorageMultisampleANGLE.trace = True
glRenderbufferStorageMultisampleANGLE.play = True
gl.add(glRenderbufferStorageMultisampleANGLE)

# GL_ANGLE_instanced_arrays

glDrawArraysInstancedANGLE = Function('glDrawArraysInstancedANGLE')
glDrawArraysInstancedANGLE.ret = Return('void')
glDrawArraysInstancedANGLE.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glDrawArraysInstancedANGLE.add( Input( 'first','GLint' ))
glDrawArraysInstancedANGLE.add( Input( 'count','GLsizei' ))
glDrawArraysInstancedANGLE.add( Input( 'primcount','GLsizei' ))
glDrawArraysInstancedANGLE.version = ''
glDrawArraysInstancedANGLE.category = 'GL_ANGLE_instanced_arrays'
glDrawArraysInstancedANGLE.trace = True
glDrawArraysInstancedANGLE.play = True
gl.add(glDrawArraysInstancedANGLE)

glDrawElementsInstancedANGLE = Function('glDrawElementsInstancedANGLE')
glDrawElementsInstancedANGLE.ret = Return('void')
glDrawElementsInstancedANGLE.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glDrawElementsInstancedANGLE.add( Input( 'count','GLsizei' ))
glDrawElementsInstancedANGLE.add( Input( 'type','GLenum' ))
glDrawElementsInstancedANGLE.add( Input( 'indices','const GLvoid *' ))
glDrawElementsInstancedANGLE.add( Input( 'primcount','GLsizei' ))
glDrawElementsInstancedANGLE.version = ''
glDrawElementsInstancedANGLE.category = 'GL_ANGLE_instanced_arrays'
glDrawElementsInstancedANGLE.trace = True
glDrawElementsInstancedANGLE.play = True
gl.add(glDrawElementsInstancedANGLE)

glVertexAttribDivisorANGLE = Function('glVertexAttribDivisorANGLE')
glVertexAttribDivisorANGLE.ret = Return('void')
glVertexAttribDivisorANGLE.add( Input( 'index','GLuint' ))
glVertexAttribDivisorANGLE.add( Input( 'divisor','GLuint' ))
glVertexAttribDivisorANGLE.version = ''
glVertexAttribDivisorANGLE.category = 'GL_ANGLE_instanced_arrays'
glVertexAttribDivisorANGLE.trace = True
glVertexAttribDivisorANGLE.play = True
gl.add(glVertexAttribDivisorANGLE)

# GL_ANGLE_timer_query

glBeginQueryANGLE = Function('glBeginQueryANGLE')
glBeginQueryANGLE.ret = Return('void')
glBeginQueryANGLE.add( Input( 'target','GLenum' ))
glBeginQueryANGLE.add( Input( 'id','GLuint' ))
glBeginQueryANGLE.version = ''
glBeginQueryANGLE.category = 'GL_ANGLE_timer_query'
glBeginQueryANGLE.trace = True
glBeginQueryANGLE.play = True
gl.add(glBeginQueryANGLE)

glDeleteQueriesANGLE = Function('glDeleteQueriesANGLE')
glDeleteQueriesANGLE.ret = Return('void')
glDeleteQueriesANGLE.add( Input( 'n','GLsizei' ))
glDeleteQueriesANGLE.add( Input( 'ids','const GLuint *' ))
glDeleteQueriesANGLE.version = ''
glDeleteQueriesANGLE.category = 'GL_ANGLE_timer_query'
glDeleteQueriesANGLE.trace = True
glDeleteQueriesANGLE.play = True
gl.add(glDeleteQueriesANGLE)

glEndQueryANGLE = Function('glEndQueryANGLE')
glEndQueryANGLE.ret = Return('void')
glEndQueryANGLE.add( Input( 'target','GLenum' ))
glEndQueryANGLE.version = ''
glEndQueryANGLE.category = 'GL_ANGLE_timer_query'
glEndQueryANGLE.trace = True
glEndQueryANGLE.play = True
gl.add(glEndQueryANGLE)

glGenQueriesANGLE = Function('glGenQueriesANGLE')
glGenQueriesANGLE.ret = Return('void')
glGenQueriesANGLE.add( Input( 'n','GLsizei' ))
glGenQueriesANGLE.add( Output( 'ids','GLuint *' ))
glGenQueriesANGLE.version = ''
glGenQueriesANGLE.category = 'GL_ANGLE_timer_query'
glGenQueriesANGLE.trace = True
glGenQueriesANGLE.play = True
gl.add(glGenQueriesANGLE)

glGetQueryObjecti64vANGLE = Function('glGetQueryObjecti64vANGLE')
glGetQueryObjecti64vANGLE.ret = Return('void')
glGetQueryObjecti64vANGLE.add( Input( 'id','GLuint' ))
glGetQueryObjecti64vANGLE.add( Input( 'pname','GLenum' ))
glGetQueryObjecti64vANGLE.add( Output( 'params','GLint64 *' ))
glGetQueryObjecti64vANGLE.version = ''
glGetQueryObjecti64vANGLE.category = 'GL_ANGLE_timer_query'
glGetQueryObjecti64vANGLE.trace = True
glGetQueryObjecti64vANGLE.play = True
gl.add(glGetQueryObjecti64vANGLE)

glGetQueryObjectivANGLE = Function('glGetQueryObjectivANGLE')
glGetQueryObjectivANGLE.ret = Return('void')
glGetQueryObjectivANGLE.add( Input( 'id','GLuint' ))
glGetQueryObjectivANGLE.add( Input( 'pname','GLenum' ))
glGetQueryObjectivANGLE.add( Output( 'params','GLint *' ))
glGetQueryObjectivANGLE.version = ''
glGetQueryObjectivANGLE.category = 'GL_ANGLE_timer_query'
glGetQueryObjectivANGLE.trace = True
glGetQueryObjectivANGLE.play = True
gl.add(glGetQueryObjectivANGLE)

glGetQueryObjectui64vANGLE = Function('glGetQueryObjectui64vANGLE')
glGetQueryObjectui64vANGLE.ret = Return('void')
glGetQueryObjectui64vANGLE.add( Input( 'id','GLuint' ))
glGetQueryObjectui64vANGLE.add( Input( 'pname','GLenum' ))
glGetQueryObjectui64vANGLE.add( Output( 'params','GLuint64 *' ))
glGetQueryObjectui64vANGLE.version = ''
glGetQueryObjectui64vANGLE.category = 'GL_ANGLE_timer_query'
glGetQueryObjectui64vANGLE.trace = True
glGetQueryObjectui64vANGLE.play = True
gl.add(glGetQueryObjectui64vANGLE)

glGetQueryObjectuivANGLE = Function('glGetQueryObjectuivANGLE')
glGetQueryObjectuivANGLE.ret = Return('void')
glGetQueryObjectuivANGLE.add( Input( 'id','GLuint' ))
glGetQueryObjectuivANGLE.add( Input( 'pname','GLenum' ))
glGetQueryObjectuivANGLE.add( Output( 'params','GLuint *' ))
glGetQueryObjectuivANGLE.version = ''
glGetQueryObjectuivANGLE.category = 'GL_ANGLE_timer_query'
glGetQueryObjectuivANGLE.trace = True
glGetQueryObjectuivANGLE.play = True
gl.add(glGetQueryObjectuivANGLE)

glGetQueryivANGLE = Function('glGetQueryivANGLE')
glGetQueryivANGLE.ret = Return('void')
glGetQueryivANGLE.add( Input( 'target','GLenum' ))
glGetQueryivANGLE.add( Input( 'pname','GLenum' ))
glGetQueryivANGLE.add( Output( 'params','GLint *' ))
glGetQueryivANGLE.version = ''
glGetQueryivANGLE.category = 'GL_ANGLE_timer_query'
glGetQueryivANGLE.trace = True
glGetQueryivANGLE.play = True
gl.add(glGetQueryivANGLE)

glIsQueryANGLE = Function('glIsQueryANGLE')
glIsQueryANGLE.ret = Return('GLboolean')
glIsQueryANGLE.add( Input( 'id','GLuint' ))
glIsQueryANGLE.version = ''
glIsQueryANGLE.category = 'GL_ANGLE_timer_query'
glIsQueryANGLE.trace = True
glIsQueryANGLE.play = True
gl.add(glIsQueryANGLE)

glQueryCounterANGLE = Function('glQueryCounterANGLE')
glQueryCounterANGLE.ret = Return('void')
glQueryCounterANGLE.add( Input( 'id','GLuint' ))
glQueryCounterANGLE.add( Input( 'target','GLenum' ))
glQueryCounterANGLE.version = ''
glQueryCounterANGLE.category = 'GL_ANGLE_timer_query'
glQueryCounterANGLE.trace = True
glQueryCounterANGLE.play = True
gl.add(glQueryCounterANGLE)

# GL_ANGLE_translated_shader_source

glGetTranslatedShaderSourceANGLE = Function('glGetTranslatedShaderSourceANGLE')
glGetTranslatedShaderSourceANGLE.ret = Return('void')
glGetTranslatedShaderSourceANGLE.add( Input( 'shader','GLuint' ))
glGetTranslatedShaderSourceANGLE.add( Input( 'bufsize','GLsizei' ))
glGetTranslatedShaderSourceANGLE.add( Input( 'length','GLsizei *' ))
glGetTranslatedShaderSourceANGLE.add( Input( 'source','GLchar *' ))
glGetTranslatedShaderSourceANGLE.version = ''
glGetTranslatedShaderSourceANGLE.category = 'GL_ANGLE_translated_shader_source'
glGetTranslatedShaderSourceANGLE.trace = True
glGetTranslatedShaderSourceANGLE.play = True
gl.add(glGetTranslatedShaderSourceANGLE)

# GL_APPLE_copy_texture_levels

glCopyTextureLevelsAPPLE = Function('glCopyTextureLevelsAPPLE')
glCopyTextureLevelsAPPLE.ret = Return('void')
glCopyTextureLevelsAPPLE.add( Input( 'destinationTexture','GLuint' ))
glCopyTextureLevelsAPPLE.add( Input( 'sourceTexture','GLuint' ))
glCopyTextureLevelsAPPLE.add( Input( 'sourceBaseLevel','GLint' ))
glCopyTextureLevelsAPPLE.add( Input( 'sourceLevelCount','GLsizei' ))
glCopyTextureLevelsAPPLE.version = ''
glCopyTextureLevelsAPPLE.category = 'GL_APPLE_copy_texture_levels'
glCopyTextureLevelsAPPLE.trace = True
glCopyTextureLevelsAPPLE.play = True
gl.add(glCopyTextureLevelsAPPLE)

# GL_APPLE_element_array

glDrawElementArrayAPPLE = Function('glDrawElementArrayAPPLE')
glDrawElementArrayAPPLE.ret = Return('void')
glDrawElementArrayAPPLE.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glDrawElementArrayAPPLE.add( Input( 'first','GLint' ))
glDrawElementArrayAPPLE.add( Input( 'count','GLsizei' ))
glDrawElementArrayAPPLE.version = '1.2'
glDrawElementArrayAPPLE.category = 'GL_APPLE_element_array'
glDrawElementArrayAPPLE.trace = True
glDrawElementArrayAPPLE.play = True
gl.add(glDrawElementArrayAPPLE)

glDrawRangeElementArrayAPPLE = Function('glDrawRangeElementArrayAPPLE')
glDrawRangeElementArrayAPPLE.ret = Return('void')
glDrawRangeElementArrayAPPLE.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glDrawRangeElementArrayAPPLE.add( Input( 'start','GLuint' ))
glDrawRangeElementArrayAPPLE.add( Input( 'end','GLuint' ))
glDrawRangeElementArrayAPPLE.add( Input( 'first','GLint' ))
glDrawRangeElementArrayAPPLE.add( Input( 'count','GLsizei' ))
glDrawRangeElementArrayAPPLE.version = '1.2'
glDrawRangeElementArrayAPPLE.category = 'GL_APPLE_element_array'
glDrawRangeElementArrayAPPLE.trace = True
glDrawRangeElementArrayAPPLE.play = True
gl.add(glDrawRangeElementArrayAPPLE)

glElementPointerAPPLE = Function('glElementPointerAPPLE')
glElementPointerAPPLE.ret = Return('void')
glElementPointerAPPLE.add( Input( 'type','GLenum' ))
glElementPointerAPPLE.add( Input( 'pointer','const GLvoid *' ))
glElementPointerAPPLE.version = '1.2'
glElementPointerAPPLE.category = 'GL_APPLE_element_array'
glElementPointerAPPLE.trace = True
glElementPointerAPPLE.play = True
gl.add(glElementPointerAPPLE)

glMultiDrawElementArrayAPPLE = Function('glMultiDrawElementArrayAPPLE')
glMultiDrawElementArrayAPPLE.ret = Return('void')
glMultiDrawElementArrayAPPLE.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glMultiDrawElementArrayAPPLE.add( Input( 'first','const GLint *' ))
glMultiDrawElementArrayAPPLE.add( Input( 'count','const GLsizei *' ))
glMultiDrawElementArrayAPPLE.add( Input( 'primcount','GLsizei' ))
glMultiDrawElementArrayAPPLE.version = '1.2'
glMultiDrawElementArrayAPPLE.category = 'GL_APPLE_element_array'
glMultiDrawElementArrayAPPLE.trace = True
glMultiDrawElementArrayAPPLE.play = True
gl.add(glMultiDrawElementArrayAPPLE)

glMultiDrawRangeElementArrayAPPLE = Function('glMultiDrawRangeElementArrayAPPLE')
glMultiDrawRangeElementArrayAPPLE.ret = Return('void')
glMultiDrawRangeElementArrayAPPLE.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glMultiDrawRangeElementArrayAPPLE.add( Input( 'start','GLuint' ))
glMultiDrawRangeElementArrayAPPLE.add( Input( 'end','GLuint' ))
glMultiDrawRangeElementArrayAPPLE.add( Input( 'first','const GLint *' ))
glMultiDrawRangeElementArrayAPPLE.add( Input( 'count','const GLsizei *' ))
glMultiDrawRangeElementArrayAPPLE.add( Input( 'primcount','GLsizei' ))
glMultiDrawRangeElementArrayAPPLE.version = '1.2'
glMultiDrawRangeElementArrayAPPLE.category = 'GL_APPLE_element_array'
glMultiDrawRangeElementArrayAPPLE.trace = True
glMultiDrawRangeElementArrayAPPLE.play = True
gl.add(glMultiDrawRangeElementArrayAPPLE)

# GL_APPLE_fence

glDeleteFencesAPPLE = Function('glDeleteFencesAPPLE')
glDeleteFencesAPPLE.ret = Return('void')
glDeleteFencesAPPLE.add( Input( 'n','GLsizei' ))
glDeleteFencesAPPLE.add( Input( 'fences','const GLuint *' ))
glDeleteFencesAPPLE.version = '1.2'
glDeleteFencesAPPLE.category = 'GL_APPLE_fence'
glDeleteFencesAPPLE.trace = True
glDeleteFencesAPPLE.play = True
gl.add(glDeleteFencesAPPLE)

glFinishFenceAPPLE = Function('glFinishFenceAPPLE')
glFinishFenceAPPLE.ret = Return('void')
glFinishFenceAPPLE.add( Input( 'fence','GLuint' ))
glFinishFenceAPPLE.version = '1.2'
glFinishFenceAPPLE.category = 'GL_APPLE_fence'
glFinishFenceAPPLE.trace = True
glFinishFenceAPPLE.play = True
gl.add(glFinishFenceAPPLE)

glFinishObjectAPPLE = Function('glFinishObjectAPPLE')
glFinishObjectAPPLE.ret = Return('void')
glFinishObjectAPPLE.add( Input( 'object','GLenum' ))
glFinishObjectAPPLE.add( Input( 'name','GLint' ))
glFinishObjectAPPLE.version = '1.2'
glFinishObjectAPPLE.category = 'GL_APPLE_fence'
glFinishObjectAPPLE.trace = True
glFinishObjectAPPLE.play = True
gl.add(glFinishObjectAPPLE)

glGenFencesAPPLE = Function('glGenFencesAPPLE')
glGenFencesAPPLE.ret = Return('void')
glGenFencesAPPLE.add( Input( 'n','GLsizei' ))
glGenFencesAPPLE.add( Output( 'fences','GLuint *' ))
glGenFencesAPPLE.version = '1.2'
glGenFencesAPPLE.category = 'GL_APPLE_fence'
glGenFencesAPPLE.trace = True
glGenFencesAPPLE.play = True
gl.add(glGenFencesAPPLE)

glIsFenceAPPLE = Function('glIsFenceAPPLE')
glIsFenceAPPLE.ret = Return('GLboolean')
glIsFenceAPPLE.add( Input( 'fence','GLuint' ))
glIsFenceAPPLE.version = '1.2'
glIsFenceAPPLE.category = 'GL_APPLE_fence'
glIsFenceAPPLE.trace = True
glIsFenceAPPLE.play = True
gl.add(glIsFenceAPPLE)

glSetFenceAPPLE = Function('glSetFenceAPPLE')
glSetFenceAPPLE.ret = Return('void')
glSetFenceAPPLE.add( Input( 'fence','GLuint' ))
glSetFenceAPPLE.version = '1.2'
glSetFenceAPPLE.category = 'GL_APPLE_fence'
glSetFenceAPPLE.trace = True
glSetFenceAPPLE.play = True
gl.add(glSetFenceAPPLE)

glTestFenceAPPLE = Function('glTestFenceAPPLE')
glTestFenceAPPLE.ret = Return('GLboolean')
glTestFenceAPPLE.add( Input( 'fence','GLuint' ))
glTestFenceAPPLE.version = '1.2'
glTestFenceAPPLE.category = 'GL_APPLE_fence'
glTestFenceAPPLE.trace = True
glTestFenceAPPLE.play = True
gl.add(glTestFenceAPPLE)

glTestObjectAPPLE = Function('glTestObjectAPPLE')
glTestObjectAPPLE.ret = Return('GLboolean')
glTestObjectAPPLE.add( Input( 'object','GLenum' ))
glTestObjectAPPLE.add( Input( 'name','GLuint' ))
glTestObjectAPPLE.version = '1.2'
glTestObjectAPPLE.category = 'GL_APPLE_fence'
glTestObjectAPPLE.trace = True
glTestObjectAPPLE.play = True
gl.add(glTestObjectAPPLE)

# GL_APPLE_flush_buffer_range

glBufferParameteriAPPLE = Function('glBufferParameteriAPPLE')
glBufferParameteriAPPLE.ret = Return('void')
glBufferParameteriAPPLE.add( Input( 'target','GLenum' ))
glBufferParameteriAPPLE.add( Input( 'pname','GLenum' ))
glBufferParameteriAPPLE.add( Input( 'param','GLint' ))
glBufferParameteriAPPLE.version = '1.5'
glBufferParameteriAPPLE.category = 'GL_APPLE_flush_buffer_range'
glBufferParameteriAPPLE.trace = True
glBufferParameteriAPPLE.play = True
gl.add(glBufferParameteriAPPLE)

glFlushMappedBufferRangeAPPLE = Function('glFlushMappedBufferRangeAPPLE')
glFlushMappedBufferRangeAPPLE.ret = Return('void')
glFlushMappedBufferRangeAPPLE.add( Input( 'target','GLenum' ))
glFlushMappedBufferRangeAPPLE.add( Input( 'offset','GLintptr' ))
glFlushMappedBufferRangeAPPLE.add( Input( 'size','GLsizeiptr' ))
glFlushMappedBufferRangeAPPLE.version = '1.5'
glFlushMappedBufferRangeAPPLE.category = 'GL_APPLE_flush_buffer_range'
glFlushMappedBufferRangeAPPLE.trace = True
glFlushMappedBufferRangeAPPLE.play = True
gl.add(glFlushMappedBufferRangeAPPLE)

# GL_APPLE_flush_render

glFinishRenderAPPLE = Function('glFinishRenderAPPLE')
glFinishRenderAPPLE.ret = Return('void')
glFinishRenderAPPLE.version = ''
glFinishRenderAPPLE.category = 'GL_APPLE_flush_render'
glFinishRenderAPPLE.trace = True
glFinishRenderAPPLE.play = True
gl.add(glFinishRenderAPPLE)

glFlushRenderAPPLE = Function('glFlushRenderAPPLE')
glFlushRenderAPPLE.ret = Return('void')
glFlushRenderAPPLE.version = ''
glFlushRenderAPPLE.category = 'GL_APPLE_flush_render'
glFlushRenderAPPLE.trace = True
glFlushRenderAPPLE.play = True
gl.add(glFlushRenderAPPLE)

glSwapAPPLE = Function('glSwapAPPLE')
glSwapAPPLE.ret = Return('void')
glSwapAPPLE.version = ''
glSwapAPPLE.category = 'GL_APPLE_flush_render'
glSwapAPPLE.trace = True
glSwapAPPLE.play = True
gl.add(glSwapAPPLE)

# GL_APPLE_framebuffer_multisample

glRenderbufferStorageMultisampleAPPLE = Function('glRenderbufferStorageMultisampleAPPLE')
glRenderbufferStorageMultisampleAPPLE.ret = Return('void')
glRenderbufferStorageMultisampleAPPLE.add( Input( 'target','GLenum' ))
glRenderbufferStorageMultisampleAPPLE.add( Input( 'samples','GLsizei' ))
glRenderbufferStorageMultisampleAPPLE.add( Input( 'internalformat','GLenum' ))
glRenderbufferStorageMultisampleAPPLE.add( Input( 'width','GLsizei' ))
glRenderbufferStorageMultisampleAPPLE.add( Input( 'height','GLsizei' ))
glRenderbufferStorageMultisampleAPPLE.version = ''
glRenderbufferStorageMultisampleAPPLE.category = 'GL_APPLE_framebuffer_multisample'
glRenderbufferStorageMultisampleAPPLE.trace = True
glRenderbufferStorageMultisampleAPPLE.play = True
gl.add(glRenderbufferStorageMultisampleAPPLE)

glResolveMultisampleFramebufferAPPLE = Function('glResolveMultisampleFramebufferAPPLE')
glResolveMultisampleFramebufferAPPLE.ret = Return('void')
glResolveMultisampleFramebufferAPPLE.version = ''
glResolveMultisampleFramebufferAPPLE.category = 'GL_APPLE_framebuffer_multisample'
glResolveMultisampleFramebufferAPPLE.trace = True
glResolveMultisampleFramebufferAPPLE.play = True
gl.add(glResolveMultisampleFramebufferAPPLE)

# GL_APPLE_object_purgeable

glGetObjectParameterivAPPLE = Function('glGetObjectParameterivAPPLE')
glGetObjectParameterivAPPLE.ret = Return('void')
glGetObjectParameterivAPPLE.add( Input( 'objectType','GLenum' ))
glGetObjectParameterivAPPLE.add( Input( 'name','GLuint' ))
glGetObjectParameterivAPPLE.add( Input( 'pname','GLenum' ))
glGetObjectParameterivAPPLE.add( Output( 'params','GLint *' ))
glGetObjectParameterivAPPLE.version = '1.5'
glGetObjectParameterivAPPLE.category = 'GL_APPLE_object_purgeable'
glGetObjectParameterivAPPLE.trace = True
glGetObjectParameterivAPPLE.play = True
gl.add(glGetObjectParameterivAPPLE)

glObjectPurgeableAPPLE = Function('glObjectPurgeableAPPLE')
glObjectPurgeableAPPLE.ret = Return('GLenum')
glObjectPurgeableAPPLE.add( Input( 'objectType','GLenum' ))
glObjectPurgeableAPPLE.add( Input( 'name','GLuint' ))
glObjectPurgeableAPPLE.add( Input( 'option','GLenum' ))
glObjectPurgeableAPPLE.version = '1.5'
glObjectPurgeableAPPLE.category = 'GL_APPLE_object_purgeable'
glObjectPurgeableAPPLE.trace = True
glObjectPurgeableAPPLE.play = True
gl.add(glObjectPurgeableAPPLE)

glObjectUnpurgeableAPPLE = Function('glObjectUnpurgeableAPPLE')
glObjectUnpurgeableAPPLE.ret = Return('GLenum')
glObjectUnpurgeableAPPLE.add( Input( 'objectType','GLenum' ))
glObjectUnpurgeableAPPLE.add( Input( 'name','GLuint' ))
glObjectUnpurgeableAPPLE.add( Input( 'option','GLenum' ))
glObjectUnpurgeableAPPLE.version = '1.5'
glObjectUnpurgeableAPPLE.category = 'GL_APPLE_object_purgeable'
glObjectUnpurgeableAPPLE.trace = True
glObjectUnpurgeableAPPLE.play = True
gl.add(glObjectUnpurgeableAPPLE)

# GL_APPLE_sync

glClientWaitSyncAPPLE = Function('glClientWaitSyncAPPLE')
glClientWaitSyncAPPLE.ret = Return('GLenum')
glClientWaitSyncAPPLE.add( Input( 'sync','GLsync' ))
glClientWaitSyncAPPLE.add( Input( 'flags','GLbitfield' ,regalLog = 'GLclientWaitSyncToString(flags)' ))
glClientWaitSyncAPPLE.add( Input( 'timeout','GLuint64' ))
glClientWaitSyncAPPLE.version = ''
glClientWaitSyncAPPLE.category = 'GL_APPLE_sync'
glClientWaitSyncAPPLE.trace = True
glClientWaitSyncAPPLE.play = True
gl.add(glClientWaitSyncAPPLE)

glDeleteSyncAPPLE = Function('glDeleteSyncAPPLE')
glDeleteSyncAPPLE.ret = Return('void')
glDeleteSyncAPPLE.add( Input( 'sync','GLsync' ))
glDeleteSyncAPPLE.version = ''
glDeleteSyncAPPLE.category = 'GL_APPLE_sync'
glDeleteSyncAPPLE.trace = True
glDeleteSyncAPPLE.play = True
gl.add(glDeleteSyncAPPLE)

glFenceSyncAPPLE = Function('glFenceSyncAPPLE')
glFenceSyncAPPLE.ret = Return('GLsync')
glFenceSyncAPPLE.add( Input( 'condition','GLenum' ))
glFenceSyncAPPLE.add( Input( 'flags','GLbitfield' ,regalLog = 'GLfenceSyncToString(flags)' ))
glFenceSyncAPPLE.version = ''
glFenceSyncAPPLE.category = 'GL_APPLE_sync'
glFenceSyncAPPLE.trace = True
glFenceSyncAPPLE.play = True
gl.add(glFenceSyncAPPLE)

glGetInteger64vAPPLE = Function('glGetInteger64vAPPLE')
glGetInteger64vAPPLE.ret = Return('void')
glGetInteger64vAPPLE.add( Input( 'pname','GLenum' ))
glGetInteger64vAPPLE.add( Input( 'params','GLint64 *' ))
glGetInteger64vAPPLE.version = ''
glGetInteger64vAPPLE.category = 'GL_APPLE_sync'
glGetInteger64vAPPLE.trace = True
glGetInteger64vAPPLE.play = True
gl.add(glGetInteger64vAPPLE)

glGetSyncivAPPLE = Function('glGetSyncivAPPLE')
glGetSyncivAPPLE.ret = Return('void')
glGetSyncivAPPLE.add( Input( 'sync','GLsync' ))
glGetSyncivAPPLE.add( Input( 'pname','GLenum' ))
glGetSyncivAPPLE.add( Input( 'bufSize','GLsizei' ))
glGetSyncivAPPLE.add( Input( 'length','GLsizei *' ))
glGetSyncivAPPLE.add( Input( 'values','GLint *' ))
glGetSyncivAPPLE.version = ''
glGetSyncivAPPLE.category = 'GL_APPLE_sync'
glGetSyncivAPPLE.trace = True
glGetSyncivAPPLE.play = True
gl.add(glGetSyncivAPPLE)

glIsSyncAPPLE = Function('glIsSyncAPPLE')
glIsSyncAPPLE.ret = Return('GLboolean')
glIsSyncAPPLE.add( Input( 'sync','GLsync' ))
glIsSyncAPPLE.version = ''
glIsSyncAPPLE.category = 'GL_APPLE_sync'
glIsSyncAPPLE.trace = True
glIsSyncAPPLE.play = True
gl.add(glIsSyncAPPLE)

glWaitSyncAPPLE = Function('glWaitSyncAPPLE')
glWaitSyncAPPLE.ret = Return('void')
glWaitSyncAPPLE.add( Input( 'sync','GLsync' ))
glWaitSyncAPPLE.add( Input( 'flags','GLbitfield' ,regalLog = 'GLwaitSyncToString(flags)' ))
glWaitSyncAPPLE.add( Input( 'timeout','GLuint64' ))
glWaitSyncAPPLE.version = ''
glWaitSyncAPPLE.category = 'GL_APPLE_sync'
glWaitSyncAPPLE.trace = True
glWaitSyncAPPLE.play = True
gl.add(glWaitSyncAPPLE)

# GL_APPLE_texture_range

glGetTexParameterPointervAPPLE = Function('glGetTexParameterPointervAPPLE')
glGetTexParameterPointervAPPLE.ret = Return('void')
glGetTexParameterPointervAPPLE.add( Input( 'target','GLenum' ))
glGetTexParameterPointervAPPLE.add( Input( 'pname','GLenum' ))
glGetTexParameterPointervAPPLE.add( Output( 'params','GLvoid **' ,size = 1 ))
glGetTexParameterPointervAPPLE.version = '1.2'
glGetTexParameterPointervAPPLE.category = 'GL_APPLE_texture_range'
glGetTexParameterPointervAPPLE.trace = True
glGetTexParameterPointervAPPLE.play = True
gl.add(glGetTexParameterPointervAPPLE)

glTextureRangeAPPLE = Function('glTextureRangeAPPLE')
glTextureRangeAPPLE.ret = Return('void')
glTextureRangeAPPLE.add( Input( 'target','GLenum' ))
glTextureRangeAPPLE.add( Input( 'length','GLsizei' ))
glTextureRangeAPPLE.add( Input( 'pointer','const GLvoid *' ))
glTextureRangeAPPLE.version = '1.2'
glTextureRangeAPPLE.category = 'GL_APPLE_texture_range'
glTextureRangeAPPLE.trace = True
glTextureRangeAPPLE.play = True
gl.add(glTextureRangeAPPLE)

# GL_APPLE_vertex_array_object

glBindVertexArrayAPPLE = Function('glBindVertexArrayAPPLE')
glBindVertexArrayAPPLE.ret = Return('void')
glBindVertexArrayAPPLE.add( Input( 'array','GLuint' ))
glBindVertexArrayAPPLE.version = '1.2'
glBindVertexArrayAPPLE.category = 'GL_APPLE_vertex_array_object'
glBindVertexArrayAPPLE.trace = True
glBindVertexArrayAPPLE.play = True
gl.add(glBindVertexArrayAPPLE)

glDeleteVertexArraysAPPLE = Function('glDeleteVertexArraysAPPLE')
glDeleteVertexArraysAPPLE.ret = Return('void')
glDeleteVertexArraysAPPLE.add( Input( 'n','GLsizei' ))
glDeleteVertexArraysAPPLE.add( Input( 'arrays','const GLuint *' ))
glDeleteVertexArraysAPPLE.version = '1.2'
glDeleteVertexArraysAPPLE.category = 'GL_APPLE_vertex_array_object'
glDeleteVertexArraysAPPLE.trace = True
glDeleteVertexArraysAPPLE.play = True
gl.add(glDeleteVertexArraysAPPLE)

glGenVertexArraysAPPLE = Function('glGenVertexArraysAPPLE')
glGenVertexArraysAPPLE.ret = Return('void')
glGenVertexArraysAPPLE.add( Input( 'n','GLsizei' ))
glGenVertexArraysAPPLE.add( Output( 'arrays','GLuint *' ))
glGenVertexArraysAPPLE.version = '1.2'
glGenVertexArraysAPPLE.category = 'GL_APPLE_vertex_array_object'
glGenVertexArraysAPPLE.trace = True
glGenVertexArraysAPPLE.play = True
gl.add(glGenVertexArraysAPPLE)

glIsVertexArrayAPPLE = Function('glIsVertexArrayAPPLE')
glIsVertexArrayAPPLE.ret = Return('GLboolean')
glIsVertexArrayAPPLE.add( Input( 'array','GLuint' ))
glIsVertexArrayAPPLE.version = '1.2'
glIsVertexArrayAPPLE.category = 'GL_APPLE_vertex_array_object'
glIsVertexArrayAPPLE.trace = True
glIsVertexArrayAPPLE.play = True
gl.add(glIsVertexArrayAPPLE)

# GL_APPLE_vertex_array_range

glFlushVertexArrayRangeAPPLE = Function('glFlushVertexArrayRangeAPPLE')
glFlushVertexArrayRangeAPPLE.ret = Return('void')
glFlushVertexArrayRangeAPPLE.add( Input( 'length','GLsizei' ))
glFlushVertexArrayRangeAPPLE.add( Output( 'pointer','GLvoid *' ))
glFlushVertexArrayRangeAPPLE.version = '1.2'
glFlushVertexArrayRangeAPPLE.category = 'GL_APPLE_vertex_array_range'
glFlushVertexArrayRangeAPPLE.trace = True
glFlushVertexArrayRangeAPPLE.play = True
gl.add(glFlushVertexArrayRangeAPPLE)

glVertexArrayParameteriAPPLE = Function('glVertexArrayParameteriAPPLE')
glVertexArrayParameteriAPPLE.ret = Return('void')
glVertexArrayParameteriAPPLE.add( Input( 'pname','GLenum' ))
glVertexArrayParameteriAPPLE.add( Input( 'param','GLint' ))
glVertexArrayParameteriAPPLE.version = '1.2'
glVertexArrayParameteriAPPLE.category = 'GL_APPLE_vertex_array_range'
glVertexArrayParameteriAPPLE.trace = True
glVertexArrayParameteriAPPLE.play = True
gl.add(glVertexArrayParameteriAPPLE)

glVertexArrayRangeAPPLE = Function('glVertexArrayRangeAPPLE')
glVertexArrayRangeAPPLE.ret = Return('void')
glVertexArrayRangeAPPLE.add( Input( 'length','GLsizei' ))
glVertexArrayRangeAPPLE.add( Output( 'pointer','GLvoid *' ))
glVertexArrayRangeAPPLE.version = '1.2'
glVertexArrayRangeAPPLE.category = 'GL_APPLE_vertex_array_range'
glVertexArrayRangeAPPLE.trace = True
glVertexArrayRangeAPPLE.play = True
gl.add(glVertexArrayRangeAPPLE)

# GL_APPLE_vertex_program_evaluators

glDisableVertexAttribAPPLE = Function('glDisableVertexAttribAPPLE')
glDisableVertexAttribAPPLE.ret = Return('void')
glDisableVertexAttribAPPLE.add( Input( 'index','GLuint' ))
glDisableVertexAttribAPPLE.add( Input( 'pname','GLenum' ))
glDisableVertexAttribAPPLE.version = '1.5'
glDisableVertexAttribAPPLE.category = 'GL_APPLE_vertex_program_evaluators'
glDisableVertexAttribAPPLE.trace = True
glDisableVertexAttribAPPLE.play = True
gl.add(glDisableVertexAttribAPPLE)

glEnableVertexAttribAPPLE = Function('glEnableVertexAttribAPPLE')
glEnableVertexAttribAPPLE.ret = Return('void')
glEnableVertexAttribAPPLE.add( Input( 'index','GLuint' ))
glEnableVertexAttribAPPLE.add( Input( 'pname','GLenum' ))
glEnableVertexAttribAPPLE.version = '1.5'
glEnableVertexAttribAPPLE.category = 'GL_APPLE_vertex_program_evaluators'
glEnableVertexAttribAPPLE.trace = True
glEnableVertexAttribAPPLE.play = True
gl.add(glEnableVertexAttribAPPLE)

glIsVertexAttribEnabledAPPLE = Function('glIsVertexAttribEnabledAPPLE')
glIsVertexAttribEnabledAPPLE.ret = Return('GLboolean')
glIsVertexAttribEnabledAPPLE.add( Input( 'index','GLuint' ))
glIsVertexAttribEnabledAPPLE.add( Input( 'pname','GLenum' ))
glIsVertexAttribEnabledAPPLE.version = '1.5'
glIsVertexAttribEnabledAPPLE.category = 'GL_APPLE_vertex_program_evaluators'
glIsVertexAttribEnabledAPPLE.trace = True
glIsVertexAttribEnabledAPPLE.play = True
gl.add(glIsVertexAttribEnabledAPPLE)

glMapVertexAttrib1dAPPLE = Function('glMapVertexAttrib1dAPPLE')
glMapVertexAttrib1dAPPLE.ret = Return('void')
glMapVertexAttrib1dAPPLE.add( Input( 'index','GLuint' ))
glMapVertexAttrib1dAPPLE.add( Input( 'size','GLuint' ))
glMapVertexAttrib1dAPPLE.add( Input( 'u1','GLdouble' ))
glMapVertexAttrib1dAPPLE.add( Input( 'u2','GLdouble' ))
glMapVertexAttrib1dAPPLE.add( Input( 'stride','GLint' ))
glMapVertexAttrib1dAPPLE.add( Input( 'order','GLint' ))
glMapVertexAttrib1dAPPLE.add( Input( 'points','const GLdouble *' ))
glMapVertexAttrib1dAPPLE.version = '1.5'
glMapVertexAttrib1dAPPLE.category = 'GL_APPLE_vertex_program_evaluators'
glMapVertexAttrib1dAPPLE.trace = True
glMapVertexAttrib1dAPPLE.play = True
gl.add(glMapVertexAttrib1dAPPLE)

glMapVertexAttrib1fAPPLE = Function('glMapVertexAttrib1fAPPLE')
glMapVertexAttrib1fAPPLE.ret = Return('void')
glMapVertexAttrib1fAPPLE.add( Input( 'index','GLuint' ))
glMapVertexAttrib1fAPPLE.add( Input( 'size','GLuint' ))
glMapVertexAttrib1fAPPLE.add( Input( 'u1','GLfloat' ))
glMapVertexAttrib1fAPPLE.add( Input( 'u2','GLfloat' ))
glMapVertexAttrib1fAPPLE.add( Input( 'stride','GLint' ))
glMapVertexAttrib1fAPPLE.add( Input( 'order','GLint' ))
glMapVertexAttrib1fAPPLE.add( Input( 'points','const GLfloat *' ))
glMapVertexAttrib1fAPPLE.version = '1.5'
glMapVertexAttrib1fAPPLE.category = 'GL_APPLE_vertex_program_evaluators'
glMapVertexAttrib1fAPPLE.trace = True
glMapVertexAttrib1fAPPLE.play = True
gl.add(glMapVertexAttrib1fAPPLE)

glMapVertexAttrib2dAPPLE = Function('glMapVertexAttrib2dAPPLE')
glMapVertexAttrib2dAPPLE.ret = Return('void')
glMapVertexAttrib2dAPPLE.add( Input( 'index','GLuint' ))
glMapVertexAttrib2dAPPLE.add( Input( 'size','GLuint' ))
glMapVertexAttrib2dAPPLE.add( Input( 'u1','GLdouble' ))
glMapVertexAttrib2dAPPLE.add( Input( 'u2','GLdouble' ))
glMapVertexAttrib2dAPPLE.add( Input( 'ustride','GLint' ))
glMapVertexAttrib2dAPPLE.add( Input( 'uorder','GLint' ))
glMapVertexAttrib2dAPPLE.add( Input( 'v1','GLdouble' ))
glMapVertexAttrib2dAPPLE.add( Input( 'v2','GLdouble' ))
glMapVertexAttrib2dAPPLE.add( Input( 'vstride','GLint' ))
glMapVertexAttrib2dAPPLE.add( Input( 'vorder','GLint' ))
glMapVertexAttrib2dAPPLE.add( Input( 'points','const GLdouble *' ))
glMapVertexAttrib2dAPPLE.version = '1.5'
glMapVertexAttrib2dAPPLE.category = 'GL_APPLE_vertex_program_evaluators'
glMapVertexAttrib2dAPPLE.trace = True
glMapVertexAttrib2dAPPLE.play = True
gl.add(glMapVertexAttrib2dAPPLE)

glMapVertexAttrib2fAPPLE = Function('glMapVertexAttrib2fAPPLE')
glMapVertexAttrib2fAPPLE.ret = Return('void')
glMapVertexAttrib2fAPPLE.add( Input( 'index','GLuint' ))
glMapVertexAttrib2fAPPLE.add( Input( 'size','GLuint' ))
glMapVertexAttrib2fAPPLE.add( Input( 'u1','GLfloat' ))
glMapVertexAttrib2fAPPLE.add( Input( 'u2','GLfloat' ))
glMapVertexAttrib2fAPPLE.add( Input( 'ustride','GLint' ))
glMapVertexAttrib2fAPPLE.add( Input( 'uorder','GLint' ))
glMapVertexAttrib2fAPPLE.add( Input( 'v1','GLfloat' ))
glMapVertexAttrib2fAPPLE.add( Input( 'v2','GLfloat' ))
glMapVertexAttrib2fAPPLE.add( Input( 'vstride','GLint' ))
glMapVertexAttrib2fAPPLE.add( Input( 'vorder','GLint' ))
glMapVertexAttrib2fAPPLE.add( Input( 'points','const GLfloat *' ))
glMapVertexAttrib2fAPPLE.version = '1.5'
glMapVertexAttrib2fAPPLE.category = 'GL_APPLE_vertex_program_evaluators'
glMapVertexAttrib2fAPPLE.trace = True
glMapVertexAttrib2fAPPLE.play = True
gl.add(glMapVertexAttrib2fAPPLE)

# GL_ARB_ES2_compatibility

glClearDepthf = Function('glClearDepthf')
glClearDepthf.ret = Return('void')
glClearDepthf.add( Input( 'd','GLclampf' ))
glClearDepthf.version = '4.1'
glClearDepthf.category = 'GL_ARB_ES2_compatibility'
glClearDepthf.esVersions = [1.0, 1.1, 2.0]
glClearDepthf.trace = True
glClearDepthf.play = True
gl.add(glClearDepthf)

glDepthRangef = Function('glDepthRangef')
glDepthRangef.ret = Return('void')
glDepthRangef.add( Input( 'n','GLclampf' ))
glDepthRangef.add( Input( 'f','GLclampf' ))
glDepthRangef.version = '4.1'
glDepthRangef.category = 'GL_ARB_ES2_compatibility'
glDepthRangef.esVersions = [1.0, 1.1, 2.0]
glDepthRangef.trace = True
glDepthRangef.play = True
gl.add(glDepthRangef)

glGetShaderPrecisionFormat = Function('glGetShaderPrecisionFormat')
glGetShaderPrecisionFormat.ret = Return('void')
glGetShaderPrecisionFormat.add( Input( 'shadertype','GLenum' ))
glGetShaderPrecisionFormat.add( Input( 'precisiontype','GLenum' ))
glGetShaderPrecisionFormat.add( Output( 'range','GLint *' ,size = 2 ))
glGetShaderPrecisionFormat.add( Output( 'precision','GLint *' ,size = 1 ))
glGetShaderPrecisionFormat.version = '4.1'
glGetShaderPrecisionFormat.category = 'GL_ARB_ES2_compatibility'
glGetShaderPrecisionFormat.esVersions = [2.0]
glGetShaderPrecisionFormat.trace = True
glGetShaderPrecisionFormat.play = True
gl.add(glGetShaderPrecisionFormat)

glReleaseShaderCompiler = Function('glReleaseShaderCompiler')
glReleaseShaderCompiler.ret = Return('void')
glReleaseShaderCompiler.version = '4.1'
glReleaseShaderCompiler.category = 'GL_ARB_ES2_compatibility'
glReleaseShaderCompiler.esVersions = [2.0]
glReleaseShaderCompiler.trace = True
glReleaseShaderCompiler.play = True
gl.add(glReleaseShaderCompiler)

glShaderBinary = Function('glShaderBinary')
glShaderBinary.ret = Return('void')
glShaderBinary.add( Input( 'count','GLsizei' ))
glShaderBinary.add( Input( 'shaders','const GLuint *' ,size = 'count' ))
glShaderBinary.add( Input( 'binaryformat','GLenum' ))
glShaderBinary.add( Input( 'binary','const GLvoid *' ,size = 'length' ))
glShaderBinary.add( Input( 'length','GLsizei' ))
glShaderBinary.version = '4.1'
glShaderBinary.category = 'GL_ARB_ES2_compatibility'
glShaderBinary.esVersions = [2.0]
glShaderBinary.trace = True
glShaderBinary.play = True
gl.add(glShaderBinary)

# GL_ARB_base_instance

glDrawArraysInstancedBaseInstance = Function('glDrawArraysInstancedBaseInstance')
glDrawArraysInstancedBaseInstance.ret = Return('void')
glDrawArraysInstancedBaseInstance.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glDrawArraysInstancedBaseInstance.add( Input( 'first','GLint' ))
glDrawArraysInstancedBaseInstance.add( Input( 'count','GLsizei' ))
glDrawArraysInstancedBaseInstance.add( Input( 'primcount','GLsizei' ))
glDrawArraysInstancedBaseInstance.add( Input( 'baseinstance','GLuint' ))
glDrawArraysInstancedBaseInstance.version = ''
glDrawArraysInstancedBaseInstance.category = 'GL_ARB_base_instance'
glDrawArraysInstancedBaseInstance.trace = True
glDrawArraysInstancedBaseInstance.play = True
gl.add(glDrawArraysInstancedBaseInstance)

glDrawElementsInstancedBaseInstance = Function('glDrawElementsInstancedBaseInstance')
glDrawElementsInstancedBaseInstance.ret = Return('void')
glDrawElementsInstancedBaseInstance.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glDrawElementsInstancedBaseInstance.add( Input( 'count','GLsizei' ))
glDrawElementsInstancedBaseInstance.add( Input( 'type','GLenum' ))
glDrawElementsInstancedBaseInstance.add( Input( 'indices','const GLvoid *' ))
glDrawElementsInstancedBaseInstance.add( Input( 'primcount','GLsizei' ))
glDrawElementsInstancedBaseInstance.add( Input( 'baseinstance','GLuint' ))
glDrawElementsInstancedBaseInstance.version = ''
glDrawElementsInstancedBaseInstance.category = 'GL_ARB_base_instance'
glDrawElementsInstancedBaseInstance.trace = True
glDrawElementsInstancedBaseInstance.play = True
gl.add(glDrawElementsInstancedBaseInstance)

glDrawElementsInstancedBaseVertexBaseInstance = Function('glDrawElementsInstancedBaseVertexBaseInstance')
glDrawElementsInstancedBaseVertexBaseInstance.ret = Return('void')
glDrawElementsInstancedBaseVertexBaseInstance.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glDrawElementsInstancedBaseVertexBaseInstance.add( Input( 'count','GLsizei' ))
glDrawElementsInstancedBaseVertexBaseInstance.add( Input( 'type','GLenum' ))
glDrawElementsInstancedBaseVertexBaseInstance.add( Input( 'indices','const GLvoid *' ))
glDrawElementsInstancedBaseVertexBaseInstance.add( Input( 'primcount','GLsizei' ))
glDrawElementsInstancedBaseVertexBaseInstance.add( Input( 'basevertex','GLint' ))
glDrawElementsInstancedBaseVertexBaseInstance.add( Input( 'baseinstance','GLuint' ))
glDrawElementsInstancedBaseVertexBaseInstance.version = ''
glDrawElementsInstancedBaseVertexBaseInstance.category = 'GL_ARB_base_instance'
glDrawElementsInstancedBaseVertexBaseInstance.trace = True
glDrawElementsInstancedBaseVertexBaseInstance.play = True
gl.add(glDrawElementsInstancedBaseVertexBaseInstance)

# GL_ARB_bindless_texture

glGetImageHandleARB = Function('glGetImageHandleARB')
glGetImageHandleARB.ret = Return('GLuint64')
glGetImageHandleARB.add( Input( 'texture','GLuint' ))
glGetImageHandleARB.add( Input( 'level','GLint' ))
glGetImageHandleARB.add( Input( 'layered','GLboolean' ))
glGetImageHandleARB.add( Input( 'layer','GLint' ))
glGetImageHandleARB.add( Input( 'format','GLenum' ))
glGetImageHandleARB.version = ''
glGetImageHandleARB.category = 'GL_ARB_bindless_texture'
glGetImageHandleARB.trace = True
glGetImageHandleARB.play = True
gl.add(glGetImageHandleARB)

glGetTextureHandleARB = Function('glGetTextureHandleARB')
glGetTextureHandleARB.ret = Return('GLuint64')
glGetTextureHandleARB.add( Input( 'texture','GLuint' ))
glGetTextureHandleARB.version = ''
glGetTextureHandleARB.category = 'GL_ARB_bindless_texture'
glGetTextureHandleARB.trace = True
glGetTextureHandleARB.play = True
gl.add(glGetTextureHandleARB)

glGetTextureSamplerHandleARB = Function('glGetTextureSamplerHandleARB')
glGetTextureSamplerHandleARB.ret = Return('GLuint64')
glGetTextureSamplerHandleARB.add( Input( 'texture','GLuint' ))
glGetTextureSamplerHandleARB.add( Input( 'sampler','GLuint' ))
glGetTextureSamplerHandleARB.version = ''
glGetTextureSamplerHandleARB.category = 'GL_ARB_bindless_texture'
glGetTextureSamplerHandleARB.trace = True
glGetTextureSamplerHandleARB.play = True
gl.add(glGetTextureSamplerHandleARB)

glGetVertexAttribLui64vARB = Function('glGetVertexAttribLui64vARB')
glGetVertexAttribLui64vARB.ret = Return('void')
glGetVertexAttribLui64vARB.add( Input( 'index','GLuint' ))
glGetVertexAttribLui64vARB.add( Input( 'pname','GLenum' ))
glGetVertexAttribLui64vARB.add( Output( 'params','GLuint64EXT *' ))
glGetVertexAttribLui64vARB.version = ''
glGetVertexAttribLui64vARB.category = 'GL_ARB_bindless_texture'
glGetVertexAttribLui64vARB.trace = True
glGetVertexAttribLui64vARB.play = True
gl.add(glGetVertexAttribLui64vARB)

glIsImageHandleResidentARB = Function('glIsImageHandleResidentARB')
glIsImageHandleResidentARB.ret = Return('GLboolean')
glIsImageHandleResidentARB.add( Input( 'handle','GLuint64' ))
glIsImageHandleResidentARB.version = ''
glIsImageHandleResidentARB.category = 'GL_ARB_bindless_texture'
glIsImageHandleResidentARB.trace = True
glIsImageHandleResidentARB.play = True
gl.add(glIsImageHandleResidentARB)

glIsTextureHandleResidentARB = Function('glIsTextureHandleResidentARB')
glIsTextureHandleResidentARB.ret = Return('GLboolean')
glIsTextureHandleResidentARB.add( Input( 'handle','GLuint64' ))
glIsTextureHandleResidentARB.version = ''
glIsTextureHandleResidentARB.category = 'GL_ARB_bindless_texture'
glIsTextureHandleResidentARB.trace = True
glIsTextureHandleResidentARB.play = True
gl.add(glIsTextureHandleResidentARB)

glMakeImageHandleNonResidentARB = Function('glMakeImageHandleNonResidentARB')
glMakeImageHandleNonResidentARB.ret = Return('void')
glMakeImageHandleNonResidentARB.add( Input( 'handle','GLuint64' ))
glMakeImageHandleNonResidentARB.version = ''
glMakeImageHandleNonResidentARB.category = 'GL_ARB_bindless_texture'
glMakeImageHandleNonResidentARB.trace = True
glMakeImageHandleNonResidentARB.play = True
gl.add(glMakeImageHandleNonResidentARB)

glMakeImageHandleResidentARB = Function('glMakeImageHandleResidentARB')
glMakeImageHandleResidentARB.ret = Return('void')
glMakeImageHandleResidentARB.add( Input( 'handle','GLuint64' ))
glMakeImageHandleResidentARB.add( Input( 'access','GLenum' ))
glMakeImageHandleResidentARB.version = ''
glMakeImageHandleResidentARB.category = 'GL_ARB_bindless_texture'
glMakeImageHandleResidentARB.trace = True
glMakeImageHandleResidentARB.play = True
gl.add(glMakeImageHandleResidentARB)

glMakeTextureHandleNonResidentARB = Function('glMakeTextureHandleNonResidentARB')
glMakeTextureHandleNonResidentARB.ret = Return('void')
glMakeTextureHandleNonResidentARB.add( Input( 'handle','GLuint64' ))
glMakeTextureHandleNonResidentARB.version = ''
glMakeTextureHandleNonResidentARB.category = 'GL_ARB_bindless_texture'
glMakeTextureHandleNonResidentARB.trace = True
glMakeTextureHandleNonResidentARB.play = True
gl.add(glMakeTextureHandleNonResidentARB)

glMakeTextureHandleResidentARB = Function('glMakeTextureHandleResidentARB')
glMakeTextureHandleResidentARB.ret = Return('void')
glMakeTextureHandleResidentARB.add( Input( 'handle','GLuint64' ))
glMakeTextureHandleResidentARB.version = ''
glMakeTextureHandleResidentARB.category = 'GL_ARB_bindless_texture'
glMakeTextureHandleResidentARB.trace = True
glMakeTextureHandleResidentARB.play = True
gl.add(glMakeTextureHandleResidentARB)

glProgramUniformHandleui64ARB = Function('glProgramUniformHandleui64ARB')
glProgramUniformHandleui64ARB.ret = Return('void')
glProgramUniformHandleui64ARB.add( Input( 'program','GLuint' ))
glProgramUniformHandleui64ARB.add( Input( 'location','GLint' ))
glProgramUniformHandleui64ARB.add( Input( 'value','GLuint64' ))
glProgramUniformHandleui64ARB.version = ''
glProgramUniformHandleui64ARB.category = 'GL_ARB_bindless_texture'
glProgramUniformHandleui64ARB.trace = True
glProgramUniformHandleui64ARB.play = True
gl.add(glProgramUniformHandleui64ARB)

glProgramUniformHandleui64vARB = Function('glProgramUniformHandleui64vARB')
glProgramUniformHandleui64vARB.ret = Return('void')
glProgramUniformHandleui64vARB.add( Input( 'program','GLuint' ))
glProgramUniformHandleui64vARB.add( Input( 'location','GLint' ))
glProgramUniformHandleui64vARB.add( Input( 'count','GLsizei' ))
glProgramUniformHandleui64vARB.add( Input( 'values','const GLuint64 *' ))
glProgramUniformHandleui64vARB.version = ''
glProgramUniformHandleui64vARB.category = 'GL_ARB_bindless_texture'
glProgramUniformHandleui64vARB.trace = True
glProgramUniformHandleui64vARB.play = True
gl.add(glProgramUniformHandleui64vARB)

glUniformHandleui64ARB = Function('glUniformHandleui64ARB')
glUniformHandleui64ARB.ret = Return('void')
glUniformHandleui64ARB.add( Input( 'location','GLint' ))
glUniformHandleui64ARB.add( Input( 'value','GLuint64' ))
glUniformHandleui64ARB.version = ''
glUniformHandleui64ARB.category = 'GL_ARB_bindless_texture'
glUniformHandleui64ARB.trace = True
glUniformHandleui64ARB.play = True
gl.add(glUniformHandleui64ARB)

glUniformHandleui64vARB = Function('glUniformHandleui64vARB')
glUniformHandleui64vARB.ret = Return('void')
glUniformHandleui64vARB.add( Input( 'location','GLint' ))
glUniformHandleui64vARB.add( Input( 'count','GLsizei' ))
glUniformHandleui64vARB.add( Input( 'value','const GLuint64 *' ))
glUniformHandleui64vARB.version = ''
glUniformHandleui64vARB.category = 'GL_ARB_bindless_texture'
glUniformHandleui64vARB.trace = True
glUniformHandleui64vARB.play = True
gl.add(glUniformHandleui64vARB)

glVertexAttribL1ui64ARB = Function('glVertexAttribL1ui64ARB')
glVertexAttribL1ui64ARB.ret = Return('void')
glVertexAttribL1ui64ARB.add( Input( 'index','GLuint' ))
glVertexAttribL1ui64ARB.add( Input( 'x','GLuint64EXT' ))
glVertexAttribL1ui64ARB.version = ''
glVertexAttribL1ui64ARB.category = 'GL_ARB_bindless_texture'
glVertexAttribL1ui64ARB.trace = True
glVertexAttribL1ui64ARB.play = True
gl.add(glVertexAttribL1ui64ARB)

glVertexAttribL1ui64vARB = Function('glVertexAttribL1ui64vARB')
glVertexAttribL1ui64vARB.ret = Return('void')
glVertexAttribL1ui64vARB.add( Input( 'index','GLuint' ))
glVertexAttribL1ui64vARB.add( Input( 'v','const GLuint64EXT *' ))
glVertexAttribL1ui64vARB.version = ''
glVertexAttribL1ui64vARB.category = 'GL_ARB_bindless_texture'
glVertexAttribL1ui64vARB.trace = True
glVertexAttribL1ui64vARB.play = True
gl.add(glVertexAttribL1ui64vARB)

# GL_ARB_blend_func_extended

glBindFragDataLocationIndexed = Function('glBindFragDataLocationIndexed')
glBindFragDataLocationIndexed.ret = Return('void')
glBindFragDataLocationIndexed.add( Input( 'program','GLuint' ))
glBindFragDataLocationIndexed.add( Input( 'colorNumber','GLuint' ))
glBindFragDataLocationIndexed.add( Input( 'index','GLuint' ))
glBindFragDataLocationIndexed.add( Input( 'name','const GLchar *' ))
glBindFragDataLocationIndexed.version = '3.3'
glBindFragDataLocationIndexed.category = 'GL_ARB_blend_func_extended'
glBindFragDataLocationIndexed.trace = True
glBindFragDataLocationIndexed.play = True
gl.add(glBindFragDataLocationIndexed)

glGetFragDataIndex = Function('glGetFragDataIndex')
glGetFragDataIndex.ret = Return('GLint')
glGetFragDataIndex.add( Input( 'program','GLuint' ))
glGetFragDataIndex.add( Input( 'name','const GLchar *' ))
glGetFragDataIndex.version = '3.3'
glGetFragDataIndex.category = 'GL_ARB_blend_func_extended'
glGetFragDataIndex.trace = True
glGetFragDataIndex.play = True
gl.add(glGetFragDataIndex)

# GL_ARB_buffer_storage

glBufferStorage = Function('glBufferStorage')
glBufferStorage.ret = Return('void')
glBufferStorage.add( Input( 'target','GLenum' ))
glBufferStorage.add( Input( 'size','GLsizeiptr' ))
glBufferStorage.add( Input( 'data','const GLvoid *' ))
glBufferStorage.add( Input( 'flags','GLbitfield' ,regalLog = 'GLbufferStorageToString(flags)' ))
glBufferStorage.version = '4.4'
glBufferStorage.category = 'GL_ARB_buffer_storage'
glBufferStorage.trace = True
glBufferStorage.play = True
gl.add(glBufferStorage)

glNamedBufferStorageEXT = Function('glNamedBufferStorageEXT')
glNamedBufferStorageEXT.ret = Return('void')
glNamedBufferStorageEXT.add( Input( 'buffer','GLuint' ))
glNamedBufferStorageEXT.add( Input( 'size','GLsizeiptr' ))
glNamedBufferStorageEXT.add( Input( 'data','const GLvoid *' ))
glNamedBufferStorageEXT.add( Input( 'flags','GLbitfield' ,regalLog = 'GLbufferStorageToString(flags)' ))
glNamedBufferStorageEXT.version = ''
glNamedBufferStorageEXT.category = 'GL_ARB_buffer_storage'
glNamedBufferStorageEXT.trace = True
glNamedBufferStorageEXT.play = True
gl.add(glNamedBufferStorageEXT)

# GL_ARB_cl_event

glCreateSyncFromCLeventARB = Function('glCreateSyncFromCLeventARB')
glCreateSyncFromCLeventARB.ret = Return('GLsync')
glCreateSyncFromCLeventARB.add( Input( 'context','cl_context' ))
glCreateSyncFromCLeventARB.add( Input( 'event','cl_event' ))
glCreateSyncFromCLeventARB.add( Input( 'flags','GLbitfield' ,regalLog = 'GLcreateSyncFromCLeventARBToString(flags)' ))
glCreateSyncFromCLeventARB.version = ''
glCreateSyncFromCLeventARB.category = 'GL_ARB_cl_event'
glCreateSyncFromCLeventARB.trace = True
glCreateSyncFromCLeventARB.play = True
gl.add(glCreateSyncFromCLeventARB)

# GL_ARB_clear_buffer_object

glClearBufferData = Function('glClearBufferData')
glClearBufferData.ret = Return('void')
glClearBufferData.add( Input( 'target','GLenum' ))
glClearBufferData.add( Input( 'internalformat','GLenum' ))
glClearBufferData.add( Input( 'format','GLenum' ))
glClearBufferData.add( Input( 'type','GLenum' ))
glClearBufferData.add( Input( 'data','const GLvoid *' ))
glClearBufferData.version = ''
glClearBufferData.category = 'GL_ARB_clear_buffer_object'
glClearBufferData.trace = True
glClearBufferData.play = True
gl.add(glClearBufferData)

glClearBufferSubData = Function('glClearBufferSubData')
glClearBufferSubData.ret = Return('void')
glClearBufferSubData.add( Input( 'target','GLenum' ))
glClearBufferSubData.add( Input( 'internalformat','GLenum' ))
glClearBufferSubData.add( Input( 'offset','GLintptr' ))
glClearBufferSubData.add( Input( 'size','GLsizeiptr' ))
glClearBufferSubData.add( Input( 'format','GLenum' ))
glClearBufferSubData.add( Input( 'type','GLenum' ))
glClearBufferSubData.add( Input( 'data','const GLvoid *' ))
glClearBufferSubData.version = ''
glClearBufferSubData.category = 'GL_ARB_clear_buffer_object'
glClearBufferSubData.trace = True
glClearBufferSubData.play = True
gl.add(glClearBufferSubData)

glClearNamedBufferDataEXT = Function('glClearNamedBufferDataEXT')
glClearNamedBufferDataEXT.ret = Return('void')
glClearNamedBufferDataEXT.add( Input( 'buffer','GLuint' ))
glClearNamedBufferDataEXT.add( Input( 'internalformat','GLenum' ))
glClearNamedBufferDataEXT.add( Input( 'format','GLenum' ))
glClearNamedBufferDataEXT.add( Input( 'type','GLenum' ))
glClearNamedBufferDataEXT.add( Input( 'data','const GLvoid *' ))
glClearNamedBufferDataEXT.version = ''
glClearNamedBufferDataEXT.category = 'GL_ARB_clear_buffer_object'
glClearNamedBufferDataEXT.trace = True
glClearNamedBufferDataEXT.play = True
gl.add(glClearNamedBufferDataEXT)

glClearNamedBufferSubDataEXT = Function('glClearNamedBufferSubDataEXT')
glClearNamedBufferSubDataEXT.ret = Return('void')
glClearNamedBufferSubDataEXT.add( Input( 'buffer','GLuint' ))
glClearNamedBufferSubDataEXT.add( Input( 'internalformat','GLenum' ))
glClearNamedBufferSubDataEXT.add( Input( 'offset','GLintptr' ))
glClearNamedBufferSubDataEXT.add( Input( 'size','GLsizeiptr' ))
glClearNamedBufferSubDataEXT.add( Input( 'format','GLenum' ))
glClearNamedBufferSubDataEXT.add( Input( 'type','GLenum' ))
glClearNamedBufferSubDataEXT.add( Input( 'data','const GLvoid *' ))
glClearNamedBufferSubDataEXT.version = ''
glClearNamedBufferSubDataEXT.category = 'GL_ARB_clear_buffer_object'
glClearNamedBufferSubDataEXT.trace = True
glClearNamedBufferSubDataEXT.play = True
gl.add(glClearNamedBufferSubDataEXT)

# GL_ARB_clear_texture

glClearTexImage = Function('glClearTexImage')
glClearTexImage.ret = Return('void')
glClearTexImage.add( Input( 'texture','GLuint' ))
glClearTexImage.add( Input( 'level','GLint' ))
glClearTexImage.add( Input( 'format','GLenum' ))
glClearTexImage.add( Input( 'type','GLenum' ))
glClearTexImage.add( Input( 'data','const GLvoid *' ))
glClearTexImage.version = '4.4'
glClearTexImage.category = 'GL_ARB_clear_texture'
glClearTexImage.trace = True
glClearTexImage.play = True
gl.add(glClearTexImage)

glClearTexSubImage = Function('glClearTexSubImage')
glClearTexSubImage.ret = Return('void')
glClearTexSubImage.add( Input( 'texture','GLuint' ))
glClearTexSubImage.add( Input( 'level','GLint' ))
glClearTexSubImage.add( Input( 'xoffset','GLint' ))
glClearTexSubImage.add( Input( 'yoffset','GLint' ))
glClearTexSubImage.add( Input( 'zoffset','GLint' ))
glClearTexSubImage.add( Input( 'width','GLsizei' ))
glClearTexSubImage.add( Input( 'height','GLsizei' ))
glClearTexSubImage.add( Input( 'depth','GLsizei' ))
glClearTexSubImage.add( Input( 'format','GLenum' ))
glClearTexSubImage.add( Input( 'type','GLenum' ))
glClearTexSubImage.add( Input( 'data','const GLvoid *' ))
glClearTexSubImage.version = '4.4'
glClearTexSubImage.category = 'GL_ARB_clear_texture'
glClearTexSubImage.trace = True
glClearTexSubImage.play = True
gl.add(glClearTexSubImage)

# GL_ARB_color_buffer_float

glClampColorARB = Function('glClampColorARB')
glClampColorARB.ret = Return('void')
glClampColorARB.add( Input( 'target','GLenum' ))
glClampColorARB.add( Input( 'clamp','GLenum' ))
glClampColorARB.version = '2.0'
glClampColorARB.category = 'GL_ARB_color_buffer_float'
glClampColorARB.trace = True
glClampColorARB.play = True
gl.add(glClampColorARB)

# GL_ARB_compute_shader

glDispatchCompute = Function('glDispatchCompute')
glDispatchCompute.ret = Return('void')
glDispatchCompute.add( Input( 'num_groups_x','GLuint' ))
glDispatchCompute.add( Input( 'num_groups_y','GLuint' ))
glDispatchCompute.add( Input( 'num_groups_z','GLuint' ))
glDispatchCompute.version = ''
glDispatchCompute.category = 'GL_ARB_compute_shader'
glDispatchCompute.trace = True
glDispatchCompute.play = True
gl.add(glDispatchCompute)

glDispatchComputeIndirect = Function('glDispatchComputeIndirect')
glDispatchComputeIndirect.ret = Return('void')
glDispatchComputeIndirect.add( Input( 'indirect','GLintptr' ))
glDispatchComputeIndirect.version = ''
glDispatchComputeIndirect.category = 'GL_ARB_compute_shader'
glDispatchComputeIndirect.trace = True
glDispatchComputeIndirect.play = True
gl.add(glDispatchComputeIndirect)

# GL_ARB_compute_variable_group_size

glDispatchComputeGroupSizeARB = Function('glDispatchComputeGroupSizeARB')
glDispatchComputeGroupSizeARB.ret = Return('void')
glDispatchComputeGroupSizeARB.add( Input( 'num_groups_x','GLuint' ))
glDispatchComputeGroupSizeARB.add( Input( 'num_groups_y','GLuint' ))
glDispatchComputeGroupSizeARB.add( Input( 'num_groups_z','GLuint' ))
glDispatchComputeGroupSizeARB.add( Input( 'group_size_x','GLuint' ))
glDispatchComputeGroupSizeARB.add( Input( 'group_size_y','GLuint' ))
glDispatchComputeGroupSizeARB.add( Input( 'group_size_z','GLuint' ))
glDispatchComputeGroupSizeARB.version = ''
glDispatchComputeGroupSizeARB.category = 'GL_ARB_compute_variable_group_size'
glDispatchComputeGroupSizeARB.trace = True
glDispatchComputeGroupSizeARB.play = True
gl.add(glDispatchComputeGroupSizeARB)

# GL_ARB_copy_buffer

glCopyBufferSubData = Function('glCopyBufferSubData')
glCopyBufferSubData.ret = Return('void')
glCopyBufferSubData.add( Input( 'readtarget','GLenum' ))
glCopyBufferSubData.add( Input( 'writetarget','GLenum' ))
glCopyBufferSubData.add( Input( 'readoffset','GLintptr' ))
glCopyBufferSubData.add( Input( 'writeoffset','GLintptr' ))
glCopyBufferSubData.add( Input( 'size','GLsizeiptr' ))
glCopyBufferSubData.version = '3.1'
glCopyBufferSubData.category = 'GL_ARB_copy_buffer'
glCopyBufferSubData.trace = True
glCopyBufferSubData.play = True
gl.add(glCopyBufferSubData)

# GL_ARB_copy_image

glCopyImageSubData = Function('glCopyImageSubData')
glCopyImageSubData.ret = Return('void')
glCopyImageSubData.add( Input( 'srcName','GLuint' ))
glCopyImageSubData.add( Input( 'srcTarget','GLenum' ))
glCopyImageSubData.add( Input( 'srcLevel','GLint' ))
glCopyImageSubData.add( Input( 'srcX','GLint' ))
glCopyImageSubData.add( Input( 'srcY','GLint' ))
glCopyImageSubData.add( Input( 'srcZ','GLint' ))
glCopyImageSubData.add( Input( 'dstName','GLuint' ))
glCopyImageSubData.add( Input( 'dstTarget','GLenum' ))
glCopyImageSubData.add( Input( 'dstLevel','GLint' ))
glCopyImageSubData.add( Input( 'dstX','GLint' ))
glCopyImageSubData.add( Input( 'dstY','GLint' ))
glCopyImageSubData.add( Input( 'dstZ','GLint' ))
glCopyImageSubData.add( Input( 'srcWidth','GLsizei' ))
glCopyImageSubData.add( Input( 'srcHeight','GLsizei' ))
glCopyImageSubData.add( Input( 'srcDepth','GLsizei' ))
glCopyImageSubData.version = ''
glCopyImageSubData.category = 'GL_ARB_copy_image'
glCopyImageSubData.trace = True
glCopyImageSubData.play = True
gl.add(glCopyImageSubData)

# GL_ARB_debug_output

glDebugMessageCallbackARB = Function('glDebugMessageCallbackARB')
glDebugMessageCallbackARB.ret = Return('void')
glDebugMessageCallbackARB.add( Input( 'callback','GLDEBUGPROCARB' ))
glDebugMessageCallbackARB.add( Input( 'userParam','const void *' ))
glDebugMessageCallbackARB.version = '4.1'
glDebugMessageCallbackARB.category = 'GL_ARB_debug_output'
glDebugMessageCallbackARB.trace = True
glDebugMessageCallbackARB.play = True
gl.add(glDebugMessageCallbackARB)

glDebugMessageControlARB = Function('glDebugMessageControlARB')
glDebugMessageControlARB.ret = Return('void')
glDebugMessageControlARB.add( Input( 'source','GLenum' ))
glDebugMessageControlARB.add( Input( 'type','GLenum' ))
glDebugMessageControlARB.add( Input( 'severity','GLenum' ))
glDebugMessageControlARB.add( Input( 'count','GLsizei' ))
glDebugMessageControlARB.add( Input( 'ids','const GLuint *' ,size = 'count>0 && ids ? count : 0' ))
glDebugMessageControlARB.add( Input( 'enabled','GLboolean' ))
glDebugMessageControlARB.version = '4.1'
glDebugMessageControlARB.category = 'GL_ARB_debug_output'
glDebugMessageControlARB.trace = True
glDebugMessageControlARB.play = True
gl.add(glDebugMessageControlARB)

glDebugMessageInsertARB = Function('glDebugMessageInsertARB')
glDebugMessageInsertARB.ret = Return('void')
glDebugMessageInsertARB.add( Input( 'source','GLenum' ))
glDebugMessageInsertARB.add( Input( 'type','GLenum' ))
glDebugMessageInsertARB.add( Input( 'id','GLuint' ))
glDebugMessageInsertARB.add( Input( 'severity','GLenum' ))
glDebugMessageInsertARB.add( Input( 'length','GLsizei' ))
glDebugMessageInsertARB.add( Input( 'buf','const GLchar *' ))
glDebugMessageInsertARB.version = '4.1'
glDebugMessageInsertARB.category = 'GL_ARB_debug_output'
glDebugMessageInsertARB.trace = True
glDebugMessageInsertARB.play = True
gl.add(glDebugMessageInsertARB)

glGetDebugMessageLogARB = Function('glGetDebugMessageLogARB')
glGetDebugMessageLogARB.ret = Return('GLuint')
glGetDebugMessageLogARB.add( Input( 'count','GLuint' ))
glGetDebugMessageLogARB.add( Input( 'bufsize','GLsizei' ))
glGetDebugMessageLogARB.add( Output( 'sources','GLenum *' ,size = 'ret' ,maxSize = 'count' ))
glGetDebugMessageLogARB.add( Output( 'types','GLenum *' ,size = 'ret' ,maxSize = 'count' ))
glGetDebugMessageLogARB.add( Output( 'ids','GLuint *' ,size = 'ret' ,maxSize = 'count' ))
glGetDebugMessageLogARB.add( Output( 'severities','GLenum *' ,size = 'ret' ,maxSize = 'count' ))
glGetDebugMessageLogARB.add( Output( 'lengths','GLsizei *' ,size = 'ret' ,maxSize = 'count' ))
glGetDebugMessageLogARB.add( Output( 'messageLog','GLchar *' ,maxSize = 'logsize' ))
glGetDebugMessageLogARB.version = '4.1'
glGetDebugMessageLogARB.category = 'GL_ARB_debug_output'
glGetDebugMessageLogARB.trace = True
glGetDebugMessageLogARB.play = False
gl.add(glGetDebugMessageLogARB)

# GL_ARB_draw_buffers

glDrawBuffersARB = Function('glDrawBuffersARB')
glDrawBuffersARB.ret = Return('void')
glDrawBuffersARB.add( Input( 'n','GLsizei' ))
glDrawBuffersARB.add( Input( 'bufs','const GLenum *' ,size = 'n' ))
glDrawBuffersARB.version = '1.2'
glDrawBuffersARB.category = 'GL_ARB_draw_buffers'
glDrawBuffersARB.trace = True
glDrawBuffersARB.play = True
gl.add(glDrawBuffersARB)

# GL_ARB_draw_buffers_blend

glBlendEquationSeparateiARB = Function('glBlendEquationSeparateiARB')
glBlendEquationSeparateiARB.ret = Return('void')
glBlendEquationSeparateiARB.add( Input( 'buf','GLuint' ))
glBlendEquationSeparateiARB.add( Input( 'modeRGB','GLenum' ,regalLog = 'GLmodeToString(modeRGB)' ))
glBlendEquationSeparateiARB.add( Input( 'modeAlpha','GLenum' ,regalLog = 'GLmodeToString(modeAlpha)' ))
glBlendEquationSeparateiARB.version = '2.0'
glBlendEquationSeparateiARB.category = 'GL_ARB_draw_buffers_blend'
glBlendEquationSeparateiARB.trace = True
glBlendEquationSeparateiARB.play = True
gl.add(glBlendEquationSeparateiARB)

glBlendEquationiARB = Function('glBlendEquationiARB')
glBlendEquationiARB.ret = Return('void')
glBlendEquationiARB.add( Input( 'buf','GLuint' ))
glBlendEquationiARB.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glBlendEquationiARB.version = '2.0'
glBlendEquationiARB.category = 'GL_ARB_draw_buffers_blend'
glBlendEquationiARB.trace = True
glBlendEquationiARB.play = True
gl.add(glBlendEquationiARB)

glBlendFuncSeparateiARB = Function('glBlendFuncSeparateiARB')
glBlendFuncSeparateiARB.ret = Return('void')
glBlendFuncSeparateiARB.add( Input( 'buf','GLuint' ))
glBlendFuncSeparateiARB.add( Input( 'srcRGB','GLenum' ))
glBlendFuncSeparateiARB.add( Input( 'dstRGB','GLenum' ))
glBlendFuncSeparateiARB.add( Input( 'srcAlpha','GLenum' ))
glBlendFuncSeparateiARB.add( Input( 'dstAlpha','GLenum' ))
glBlendFuncSeparateiARB.version = '2.0'
glBlendFuncSeparateiARB.category = 'GL_ARB_draw_buffers_blend'
glBlendFuncSeparateiARB.trace = True
glBlendFuncSeparateiARB.play = True
gl.add(glBlendFuncSeparateiARB)

glBlendFunciARB = Function('glBlendFunciARB')
glBlendFunciARB.ret = Return('void')
glBlendFunciARB.add( Input( 'buf','GLuint' ))
glBlendFunciARB.add( Input( 'src','GLenum' ))
glBlendFunciARB.add( Input( 'dst','GLenum' ))
glBlendFunciARB.version = '2.0'
glBlendFunciARB.category = 'GL_ARB_draw_buffers_blend'
glBlendFunciARB.trace = True
glBlendFunciARB.play = True
gl.add(glBlendFunciARB)

# GL_ARB_draw_elements_base_vertex

glDrawElementsBaseVertex = Function('glDrawElementsBaseVertex')
glDrawElementsBaseVertex.ret = Return('void')
glDrawElementsBaseVertex.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glDrawElementsBaseVertex.add( Input( 'count','GLsizei' ))
glDrawElementsBaseVertex.add( Input( 'type','GLenum' ))
glDrawElementsBaseVertex.add( Input( 'indices','const GLvoid *' ))
glDrawElementsBaseVertex.add( Input( 'basevertex','GLint' ))
glDrawElementsBaseVertex.version = '3.2'
glDrawElementsBaseVertex.category = 'GL_ARB_draw_elements_base_vertex'
glDrawElementsBaseVertex.trace = True
glDrawElementsBaseVertex.play = True
gl.add(glDrawElementsBaseVertex)

glDrawElementsInstancedBaseVertex = Function('glDrawElementsInstancedBaseVertex')
glDrawElementsInstancedBaseVertex.ret = Return('void')
glDrawElementsInstancedBaseVertex.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glDrawElementsInstancedBaseVertex.add( Input( 'count','GLsizei' ))
glDrawElementsInstancedBaseVertex.add( Input( 'type','GLenum' ))
glDrawElementsInstancedBaseVertex.add( Input( 'indices','const GLvoid *' ))
glDrawElementsInstancedBaseVertex.add( Input( 'primcount','GLsizei' ))
glDrawElementsInstancedBaseVertex.add( Input( 'basevertex','GLint' ))
glDrawElementsInstancedBaseVertex.version = '3.2'
glDrawElementsInstancedBaseVertex.category = 'GL_ARB_draw_elements_base_vertex'
glDrawElementsInstancedBaseVertex.trace = True
glDrawElementsInstancedBaseVertex.play = True
gl.add(glDrawElementsInstancedBaseVertex)

glDrawRangeElementsBaseVertex = Function('glDrawRangeElementsBaseVertex')
glDrawRangeElementsBaseVertex.ret = Return('void')
glDrawRangeElementsBaseVertex.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glDrawRangeElementsBaseVertex.add( Input( 'start','GLuint' ))
glDrawRangeElementsBaseVertex.add( Input( 'end','GLuint' ))
glDrawRangeElementsBaseVertex.add( Input( 'count','GLsizei' ))
glDrawRangeElementsBaseVertex.add( Input( 'type','GLenum' ))
glDrawRangeElementsBaseVertex.add( Input( 'indices','const GLvoid *' ))
glDrawRangeElementsBaseVertex.add( Input( 'basevertex','GLint' ))
glDrawRangeElementsBaseVertex.version = '3.2'
glDrawRangeElementsBaseVertex.category = 'GL_ARB_draw_elements_base_vertex'
glDrawRangeElementsBaseVertex.trace = True
glDrawRangeElementsBaseVertex.play = True
gl.add(glDrawRangeElementsBaseVertex)

glMultiDrawElementsBaseVertex = Function('glMultiDrawElementsBaseVertex')
glMultiDrawElementsBaseVertex.ret = Return('void')
glMultiDrawElementsBaseVertex.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glMultiDrawElementsBaseVertex.add( Input( 'count','const GLsizei *' ,size = 'primcount' ))
glMultiDrawElementsBaseVertex.add( Input( 'type','GLenum' ))
glMultiDrawElementsBaseVertex.add( Input( 'indices','const GLvoid * const *' ,size = 'primcount' ))
glMultiDrawElementsBaseVertex.add( Input( 'primcount','GLsizei' ))
glMultiDrawElementsBaseVertex.add( Input( 'basevertex','const GLint *' ,size = 'primcount' ))
glMultiDrawElementsBaseVertex.version = '3.2'
glMultiDrawElementsBaseVertex.category = 'GL_ARB_draw_elements_base_vertex'
glMultiDrawElementsBaseVertex.trace = True
glMultiDrawElementsBaseVertex.play = False
gl.add(glMultiDrawElementsBaseVertex)

# GL_ARB_draw_indirect

glDrawArraysIndirect = Function('glDrawArraysIndirect')
glDrawArraysIndirect.ret = Return('void')
glDrawArraysIndirect.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glDrawArraysIndirect.add( Input( 'indirect','const GLvoid *' ))
glDrawArraysIndirect.version = '4.0'
glDrawArraysIndirect.category = 'GL_ARB_draw_indirect'
glDrawArraysIndirect.trace = True
glDrawArraysIndirect.play = True
gl.add(glDrawArraysIndirect)

glDrawElementsIndirect = Function('glDrawElementsIndirect')
glDrawElementsIndirect.ret = Return('void')
glDrawElementsIndirect.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glDrawElementsIndirect.add( Input( 'type','GLenum' ))
glDrawElementsIndirect.add( Input( 'indirect','const GLvoid *' ))
glDrawElementsIndirect.version = '4.0'
glDrawElementsIndirect.category = 'GL_ARB_draw_indirect'
glDrawElementsIndirect.trace = True
glDrawElementsIndirect.play = True
gl.add(glDrawElementsIndirect)

# GL_ARB_draw_instanced

glDrawArraysInstancedARB = Function('glDrawArraysInstancedARB')
glDrawArraysInstancedARB.ret = Return('void')
glDrawArraysInstancedARB.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glDrawArraysInstancedARB.add( Input( 'start','GLint' ))
glDrawArraysInstancedARB.add( Input( 'count','GLsizei' ))
glDrawArraysInstancedARB.add( Input( 'primcount','GLsizei' ))
glDrawArraysInstancedARB.version = '2.0'
glDrawArraysInstancedARB.category = 'GL_ARB_draw_instanced'
glDrawArraysInstancedARB.trace = True
glDrawArraysInstancedARB.play = True
gl.add(glDrawArraysInstancedARB)

glDrawElementsInstancedARB = Function('glDrawElementsInstancedARB')
glDrawElementsInstancedARB.ret = Return('void')
glDrawElementsInstancedARB.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glDrawElementsInstancedARB.add( Input( 'count','GLsizei' ))
glDrawElementsInstancedARB.add( Input( 'type','GLenum' ))
glDrawElementsInstancedARB.add( Input( 'indices','const GLvoid *' ))
glDrawElementsInstancedARB.add( Input( 'primcount','GLsizei' ))
glDrawElementsInstancedARB.version = '2.0'
glDrawElementsInstancedARB.category = 'GL_ARB_draw_instanced'
glDrawElementsInstancedARB.trace = True
glDrawElementsInstancedARB.play = True
gl.add(glDrawElementsInstancedARB)

# GL_ARB_framebuffer_no_attachments

glFramebufferParameteri = Function('glFramebufferParameteri')
glFramebufferParameteri.ret = Return('void')
glFramebufferParameteri.add( Input( 'target','GLenum' ))
glFramebufferParameteri.add( Input( 'pname','GLenum' ))
glFramebufferParameteri.add( Input( 'param','GLint' ))
glFramebufferParameteri.version = ''
glFramebufferParameteri.category = 'GL_ARB_framebuffer_no_attachments'
glFramebufferParameteri.trace = True
glFramebufferParameteri.play = True
gl.add(glFramebufferParameteri)

glGetFramebufferParameteriv = Function('glGetFramebufferParameteriv')
glGetFramebufferParameteriv.ret = Return('void')
glGetFramebufferParameteriv.add( Input( 'target','GLenum' ))
glGetFramebufferParameteriv.add( Input( 'pname','GLenum' ))
glGetFramebufferParameteriv.add( Input( 'params','GLint *' ))
glGetFramebufferParameteriv.version = ''
glGetFramebufferParameteriv.category = 'GL_ARB_framebuffer_no_attachments'
glGetFramebufferParameteriv.trace = True
glGetFramebufferParameteriv.play = True
gl.add(glGetFramebufferParameteriv)

glGetNamedFramebufferParameterivEXT = Function('glGetNamedFramebufferParameterivEXT')
glGetNamedFramebufferParameterivEXT.ret = Return('void')
glGetNamedFramebufferParameterivEXT.add( Input( 'framebuffer','GLuint' ))
glGetNamedFramebufferParameterivEXT.add( Input( 'pname','GLenum' ))
glGetNamedFramebufferParameterivEXT.add( Input( 'params','GLint *' ))
glGetNamedFramebufferParameterivEXT.version = ''
glGetNamedFramebufferParameterivEXT.category = 'GL_ARB_framebuffer_no_attachments'
glGetNamedFramebufferParameterivEXT.trace = True
glGetNamedFramebufferParameterivEXT.play = True
gl.add(glGetNamedFramebufferParameterivEXT)

glNamedFramebufferParameteriEXT = Function('glNamedFramebufferParameteriEXT')
glNamedFramebufferParameteriEXT.ret = Return('void')
glNamedFramebufferParameteriEXT.add( Input( 'framebuffer','GLuint' ))
glNamedFramebufferParameteriEXT.add( Input( 'pname','GLenum' ))
glNamedFramebufferParameteriEXT.add( Input( 'param','GLint' ))
glNamedFramebufferParameteriEXT.version = ''
glNamedFramebufferParameteriEXT.category = 'GL_ARB_framebuffer_no_attachments'
glNamedFramebufferParameteriEXT.trace = True
glNamedFramebufferParameteriEXT.play = True
gl.add(glNamedFramebufferParameteriEXT)

# GL_ARB_framebuffer_object

glBindFramebuffer = Function('glBindFramebuffer')
glBindFramebuffer.ret = Return('void')
glBindFramebuffer.add( Input( 'target','GLenum' ))
glBindFramebuffer.add( Input( 'framebuffer','GLuint' ))
glBindFramebuffer.version = '3.0'
glBindFramebuffer.category = 'GL_ARB_framebuffer_object'
glBindFramebuffer.esVersions = [2.0]
glBindFramebuffer.trace = True
glBindFramebuffer.play = True
gl.add(glBindFramebuffer)

glBindRenderbuffer = Function('glBindRenderbuffer')
glBindRenderbuffer.ret = Return('void')
glBindRenderbuffer.add( Input( 'target','GLenum' ))
glBindRenderbuffer.add( Input( 'renderbuffer','GLuint' ))
glBindRenderbuffer.version = '3.0'
glBindRenderbuffer.category = 'GL_ARB_framebuffer_object'
glBindRenderbuffer.esVersions = [2.0]
glBindRenderbuffer.trace = True
glBindRenderbuffer.play = True
gl.add(glBindRenderbuffer)

glBlitFramebuffer = Function('glBlitFramebuffer')
glBlitFramebuffer.ret = Return('void')
glBlitFramebuffer.add( Input( 'srcX0','GLint' ))
glBlitFramebuffer.add( Input( 'srcY0','GLint' ))
glBlitFramebuffer.add( Input( 'srcX1','GLint' ))
glBlitFramebuffer.add( Input( 'srcY1','GLint' ))
glBlitFramebuffer.add( Input( 'dstX0','GLint' ))
glBlitFramebuffer.add( Input( 'dstY0','GLint' ))
glBlitFramebuffer.add( Input( 'dstX1','GLint' ))
glBlitFramebuffer.add( Input( 'dstY1','GLint' ))
glBlitFramebuffer.add( Input( 'mask','GLbitfield' ,regalLog = 'GLblitFramebufferToString(mask)' ))
glBlitFramebuffer.add( Input( 'filter','GLenum' ))
glBlitFramebuffer.version = '3.0'
glBlitFramebuffer.category = 'GL_ARB_framebuffer_object'
glBlitFramebuffer.trace = True
glBlitFramebuffer.play = True
gl.add(glBlitFramebuffer)

glCheckFramebufferStatus = Function('glCheckFramebufferStatus')
glCheckFramebufferStatus.ret = Return('GLenum')
glCheckFramebufferStatus.add( Input( 'target','GLenum' ))
glCheckFramebufferStatus.version = '3.0'
glCheckFramebufferStatus.category = 'GL_ARB_framebuffer_object'
glCheckFramebufferStatus.esVersions = [2.0]
glCheckFramebufferStatus.trace = True
glCheckFramebufferStatus.play = True
gl.add(glCheckFramebufferStatus)

glDeleteFramebuffers = Function('glDeleteFramebuffers')
glDeleteFramebuffers.ret = Return('void')
glDeleteFramebuffers.add( Input( 'n','GLsizei' ))
glDeleteFramebuffers.add( Input( 'framebuffers','const GLuint *' ,size = 'n' ))
glDeleteFramebuffers.version = '3.0'
glDeleteFramebuffers.category = 'GL_ARB_framebuffer_object'
glDeleteFramebuffers.esVersions = [2.0]
glDeleteFramebuffers.trace = True
glDeleteFramebuffers.play = True
gl.add(glDeleteFramebuffers)

glDeleteRenderbuffers = Function('glDeleteRenderbuffers')
glDeleteRenderbuffers.ret = Return('void')
glDeleteRenderbuffers.add( Input( 'n','GLsizei' ))
glDeleteRenderbuffers.add( Input( 'renderbuffers','const GLuint *' ,size = 'n' ))
glDeleteRenderbuffers.version = '3.0'
glDeleteRenderbuffers.category = 'GL_ARB_framebuffer_object'
glDeleteRenderbuffers.esVersions = [2.0]
glDeleteRenderbuffers.trace = True
glDeleteRenderbuffers.play = True
gl.add(glDeleteRenderbuffers)

glFramebufferRenderbuffer = Function('glFramebufferRenderbuffer')
glFramebufferRenderbuffer.ret = Return('void')
glFramebufferRenderbuffer.add( Input( 'target','GLenum' ))
glFramebufferRenderbuffer.add( Input( 'attachment','GLenum' ))
glFramebufferRenderbuffer.add( Input( 'renderbuffertarget','GLenum' ))
glFramebufferRenderbuffer.add( Input( 'renderbuffer','GLuint' ))
glFramebufferRenderbuffer.version = '3.0'
glFramebufferRenderbuffer.category = 'GL_ARB_framebuffer_object'
glFramebufferRenderbuffer.esVersions = [2.0]
glFramebufferRenderbuffer.trace = True
glFramebufferRenderbuffer.play = True
gl.add(glFramebufferRenderbuffer)

glFramebufferTexture1D = Function('glFramebufferTexture1D')
glFramebufferTexture1D.ret = Return('void')
glFramebufferTexture1D.add( Input( 'target','GLenum' ))
glFramebufferTexture1D.add( Input( 'attachment','GLenum' ))
glFramebufferTexture1D.add( Input( 'textarget','GLenum' ))
glFramebufferTexture1D.add( Input( 'texture','GLuint' ))
glFramebufferTexture1D.add( Input( 'level','GLint' ))
glFramebufferTexture1D.version = '3.0'
glFramebufferTexture1D.category = 'GL_ARB_framebuffer_object'
glFramebufferTexture1D.trace = True
glFramebufferTexture1D.play = True
gl.add(glFramebufferTexture1D)

glFramebufferTexture2D = Function('glFramebufferTexture2D')
glFramebufferTexture2D.ret = Return('void')
glFramebufferTexture2D.add( Input( 'target','GLenum' ))
glFramebufferTexture2D.add( Input( 'attachment','GLenum' ))
glFramebufferTexture2D.add( Input( 'textarget','GLenum' ))
glFramebufferTexture2D.add( Input( 'texture','GLuint' ))
glFramebufferTexture2D.add( Input( 'level','GLint' ))
glFramebufferTexture2D.version = '3.0'
glFramebufferTexture2D.category = 'GL_ARB_framebuffer_object'
glFramebufferTexture2D.esVersions = [2.0]
glFramebufferTexture2D.trace = True
glFramebufferTexture2D.play = True
gl.add(glFramebufferTexture2D)

glFramebufferTexture3D = Function('glFramebufferTexture3D')
glFramebufferTexture3D.ret = Return('void')
glFramebufferTexture3D.add( Input( 'target','GLenum' ))
glFramebufferTexture3D.add( Input( 'attachment','GLenum' ))
glFramebufferTexture3D.add( Input( 'textarget','GLenum' ))
glFramebufferTexture3D.add( Input( 'texture','GLuint' ))
glFramebufferTexture3D.add( Input( 'level','GLint' ))
glFramebufferTexture3D.add( Input( 'layer','GLint' ))
glFramebufferTexture3D.version = '3.0'
glFramebufferTexture3D.category = 'GL_ARB_framebuffer_object'
glFramebufferTexture3D.trace = True
glFramebufferTexture3D.play = True
gl.add(glFramebufferTexture3D)

glFramebufferTextureLayer = Function('glFramebufferTextureLayer')
glFramebufferTextureLayer.ret = Return('void')
glFramebufferTextureLayer.add( Input( 'target','GLenum' ))
glFramebufferTextureLayer.add( Input( 'attachment','GLenum' ))
glFramebufferTextureLayer.add( Input( 'texture','GLuint' ))
glFramebufferTextureLayer.add( Input( 'level','GLint' ))
glFramebufferTextureLayer.add( Input( 'layer','GLint' ))
glFramebufferTextureLayer.version = '3.0'
glFramebufferTextureLayer.category = 'GL_ARB_framebuffer_object'
glFramebufferTextureLayer.trace = True
glFramebufferTextureLayer.play = True
gl.add(glFramebufferTextureLayer)

glGenFramebuffers = Function('glGenFramebuffers')
glGenFramebuffers.ret = Return('void')
glGenFramebuffers.add( Input( 'n','GLsizei' ))
glGenFramebuffers.add( Output( 'framebuffers','GLuint *' ,size = 'n' ))
glGenFramebuffers.version = '3.0'
glGenFramebuffers.category = 'GL_ARB_framebuffer_object'
glGenFramebuffers.esVersions = [2.0]
glGenFramebuffers.trace = True
glGenFramebuffers.play = True
gl.add(glGenFramebuffers)

glGenRenderbuffers = Function('glGenRenderbuffers')
glGenRenderbuffers.ret = Return('void')
glGenRenderbuffers.add( Input( 'n','GLsizei' ))
glGenRenderbuffers.add( Output( 'renderbuffers','GLuint *' ,size = 'n' ))
glGenRenderbuffers.version = '3.0'
glGenRenderbuffers.category = 'GL_ARB_framebuffer_object'
glGenRenderbuffers.esVersions = [2.0]
glGenRenderbuffers.trace = True
glGenRenderbuffers.play = True
gl.add(glGenRenderbuffers)

glGenerateMipmap = Function('glGenerateMipmap')
glGenerateMipmap.ret = Return('void')
glGenerateMipmap.add( Input( 'target','GLenum' ))
glGenerateMipmap.version = '3.0'
glGenerateMipmap.category = 'GL_ARB_framebuffer_object'
glGenerateMipmap.esVersions = [2.0]
glGenerateMipmap.trace = True
glGenerateMipmap.play = True
gl.add(glGenerateMipmap)

glGetFramebufferAttachmentParameteriv = Function('glGetFramebufferAttachmentParameteriv')
glGetFramebufferAttachmentParameteriv.ret = Return('void')
glGetFramebufferAttachmentParameteriv.add( Input( 'target','GLenum' ))
glGetFramebufferAttachmentParameteriv.add( Input( 'attachment','GLenum' ))
glGetFramebufferAttachmentParameteriv.add( Input( 'pname','GLenum' ))
glGetFramebufferAttachmentParameteriv.add( Output( 'params','GLint *' ))
glGetFramebufferAttachmentParameteriv.version = '3.0'
glGetFramebufferAttachmentParameteriv.category = 'GL_ARB_framebuffer_object'
glGetFramebufferAttachmentParameteriv.esVersions = [2.0]
glGetFramebufferAttachmentParameteriv.trace = True
glGetFramebufferAttachmentParameteriv.play = True
gl.add(glGetFramebufferAttachmentParameteriv)

glGetRenderbufferParameteriv = Function('glGetRenderbufferParameteriv')
glGetRenderbufferParameteriv.ret = Return('void')
glGetRenderbufferParameteriv.add( Input( 'target','GLenum' ))
glGetRenderbufferParameteriv.add( Input( 'pname','GLenum' ))
glGetRenderbufferParameteriv.add( Output( 'params','GLint *' ))
glGetRenderbufferParameteriv.version = '3.0'
glGetRenderbufferParameteriv.category = 'GL_ARB_framebuffer_object'
glGetRenderbufferParameteriv.esVersions = [2.0]
glGetRenderbufferParameteriv.trace = True
glGetRenderbufferParameteriv.play = True
gl.add(glGetRenderbufferParameteriv)

glIsFramebuffer = Function('glIsFramebuffer')
glIsFramebuffer.ret = Return('GLboolean')
glIsFramebuffer.add( Input( 'framebuffer','GLuint' ))
glIsFramebuffer.version = '3.0'
glIsFramebuffer.category = 'GL_ARB_framebuffer_object'
glIsFramebuffer.esVersions = [2.0]
glIsFramebuffer.trace = True
glIsFramebuffer.play = True
gl.add(glIsFramebuffer)

glIsRenderbuffer = Function('glIsRenderbuffer')
glIsRenderbuffer.ret = Return('GLboolean')
glIsRenderbuffer.add( Input( 'renderbuffer','GLuint' ))
glIsRenderbuffer.version = '3.0'
glIsRenderbuffer.category = 'GL_ARB_framebuffer_object'
glIsRenderbuffer.esVersions = [2.0]
glIsRenderbuffer.trace = True
glIsRenderbuffer.play = True
gl.add(glIsRenderbuffer)

glRenderbufferStorage = Function('glRenderbufferStorage')
glRenderbufferStorage.ret = Return('void')
glRenderbufferStorage.add( Input( 'target','GLenum' ))
glRenderbufferStorage.add( Input( 'internalformat','GLenum' ))
glRenderbufferStorage.add( Input( 'width','GLsizei' ))
glRenderbufferStorage.add( Input( 'height','GLsizei' ))
glRenderbufferStorage.version = '3.0'
glRenderbufferStorage.category = 'GL_ARB_framebuffer_object'
glRenderbufferStorage.esVersions = [2.0]
glRenderbufferStorage.trace = True
glRenderbufferStorage.play = True
gl.add(glRenderbufferStorage)

glRenderbufferStorageMultisample = Function('glRenderbufferStorageMultisample')
glRenderbufferStorageMultisample.ret = Return('void')
glRenderbufferStorageMultisample.add( Input( 'target','GLenum' ))
glRenderbufferStorageMultisample.add( Input( 'samples','GLsizei' ))
glRenderbufferStorageMultisample.add( Input( 'internalformat','GLenum' ))
glRenderbufferStorageMultisample.add( Input( 'width','GLsizei' ))
glRenderbufferStorageMultisample.add( Input( 'height','GLsizei' ))
glRenderbufferStorageMultisample.version = '3.0'
glRenderbufferStorageMultisample.category = 'GL_ARB_framebuffer_object'
glRenderbufferStorageMultisample.trace = True
glRenderbufferStorageMultisample.play = True
gl.add(glRenderbufferStorageMultisample)

# GL_ARB_geometry_shader4

glFramebufferTextureARB = Function('glFramebufferTextureARB')
glFramebufferTextureARB.ret = Return('void')
glFramebufferTextureARB.add( Input( 'target','GLenum' ))
glFramebufferTextureARB.add( Input( 'attachment','GLenum' ))
glFramebufferTextureARB.add( Input( 'texture','GLuint' ))
glFramebufferTextureARB.add( Input( 'level','GLint' ))
glFramebufferTextureARB.version = '3.0'
glFramebufferTextureARB.category = 'GL_ARB_geometry_shader4'
glFramebufferTextureARB.trace = True
glFramebufferTextureARB.play = True
gl.add(glFramebufferTextureARB)

glFramebufferTextureFaceARB = Function('glFramebufferTextureFaceARB')
glFramebufferTextureFaceARB.ret = Return('void')
glFramebufferTextureFaceARB.add( Input( 'target','GLenum' ))
glFramebufferTextureFaceARB.add( Input( 'attachment','GLenum' ))
glFramebufferTextureFaceARB.add( Input( 'texture','GLuint' ))
glFramebufferTextureFaceARB.add( Input( 'level','GLint' ))
glFramebufferTextureFaceARB.add( Input( 'face','GLenum' ))
glFramebufferTextureFaceARB.version = '3.0'
glFramebufferTextureFaceARB.category = 'GL_ARB_geometry_shader4'
glFramebufferTextureFaceARB.trace = True
glFramebufferTextureFaceARB.play = True
gl.add(glFramebufferTextureFaceARB)

glFramebufferTextureLayerARB = Function('glFramebufferTextureLayerARB')
glFramebufferTextureLayerARB.ret = Return('void')
glFramebufferTextureLayerARB.add( Input( 'target','GLenum' ))
glFramebufferTextureLayerARB.add( Input( 'attachment','GLenum' ))
glFramebufferTextureLayerARB.add( Input( 'texture','GLuint' ))
glFramebufferTextureLayerARB.add( Input( 'level','GLint' ))
glFramebufferTextureLayerARB.add( Input( 'layer','GLint' ))
glFramebufferTextureLayerARB.version = '3.0'
glFramebufferTextureLayerARB.category = 'GL_ARB_geometry_shader4'
glFramebufferTextureLayerARB.trace = True
glFramebufferTextureLayerARB.play = True
gl.add(glFramebufferTextureLayerARB)

glProgramParameteriARB = Function('glProgramParameteriARB')
glProgramParameteriARB.ret = Return('void')
glProgramParameteriARB.add( Input( 'program','GLuint' ))
glProgramParameteriARB.add( Input( 'pname','GLenum' ))
glProgramParameteriARB.add( Input( 'value','GLint' ))
glProgramParameteriARB.version = '3.0'
glProgramParameteriARB.category = 'GL_ARB_geometry_shader4'
glProgramParameteriARB.trace = True
glProgramParameteriARB.play = True
gl.add(glProgramParameteriARB)

# GL_ARB_get_program_binary

glGetProgramBinary = Function('glGetProgramBinary')
glGetProgramBinary.ret = Return('void')
glGetProgramBinary.add( Input( 'program','GLuint' ))
glGetProgramBinary.add( Input( 'bufSize','GLsizei' ))
glGetProgramBinary.add( Output( 'length','GLsizei *' ,size = 1 ))
glGetProgramBinary.add( Output( 'binaryFormat','GLenum *' ,size = 1 ))
glGetProgramBinary.add( Output( 'binary','GLvoid *' ,maxSize = 'bufSize' ))
glGetProgramBinary.version = '4.1'
glGetProgramBinary.category = 'GL_ARB_get_program_binary'
glGetProgramBinary.trace = True
glGetProgramBinary.play = True
gl.add(glGetProgramBinary)

glProgramBinary = Function('glProgramBinary')
glProgramBinary.ret = Return('void')
glProgramBinary.add( Input( 'program','GLuint' ))
glProgramBinary.add( Input( 'binaryFormat','GLenum' ))
glProgramBinary.add( Input( 'binary','const GLvoid *' ,size = 'length' ))
glProgramBinary.add( Input( 'length','GLsizei' ))
glProgramBinary.version = '4.1'
glProgramBinary.category = 'GL_ARB_get_program_binary'
glProgramBinary.trace = True
glProgramBinary.play = True
gl.add(glProgramBinary)

glProgramParameteri = Function('glProgramParameteri')
glProgramParameteri.ret = Return('void')
glProgramParameteri.add( Input( 'program','GLuint' ))
glProgramParameteri.add( Input( 'pname','GLenum' ))
glProgramParameteri.add( Input( 'value','GLint' ))
glProgramParameteri.version = '4.1'
glProgramParameteri.category = 'GL_ARB_get_program_binary'
glProgramParameteri.trace = True
glProgramParameteri.play = True
gl.add(glProgramParameteri)

# GL_ARB_gpu_shader_fp64

glGetUniformdv = Function('glGetUniformdv')
glGetUniformdv.ret = Return('void')
glGetUniformdv.add( Input( 'program','GLuint' ))
glGetUniformdv.add( Input( 'location','GLint' ))
glGetUniformdv.add( Output( 'params','GLdouble *' ))
glGetUniformdv.version = '4.0'
glGetUniformdv.category = 'GL_ARB_gpu_shader_fp64'
glGetUniformdv.trace = True
glGetUniformdv.play = True
gl.add(glGetUniformdv)

glUniform1d = Function('glUniform1d')
glUniform1d.ret = Return('void')
glUniform1d.add( Input( 'location','GLint' ))
glUniform1d.add( Input( 'x','GLdouble' ))
glUniform1d.version = '4.0'
glUniform1d.category = 'GL_ARB_gpu_shader_fp64'
glUniform1d.trace = True
glUniform1d.play = True
gl.add(glUniform1d)

glUniform1dv = Function('glUniform1dv')
glUniform1dv.ret = Return('void')
glUniform1dv.add( Input( 'location','GLint' ))
glUniform1dv.add( Input( 'count','GLsizei' ))
glUniform1dv.add( Input( 'value','const GLdouble *' ,size = 'count' ))
glUniform1dv.version = '4.0'
glUniform1dv.category = 'GL_ARB_gpu_shader_fp64'
glUniform1dv.trace = True
glUniform1dv.play = True
gl.add(glUniform1dv)

glUniform2d = Function('glUniform2d')
glUniform2d.ret = Return('void')
glUniform2d.add( Input( 'location','GLint' ))
glUniform2d.add( Input( 'x','GLdouble' ))
glUniform2d.add( Input( 'y','GLdouble' ))
glUniform2d.version = '4.0'
glUniform2d.category = 'GL_ARB_gpu_shader_fp64'
glUniform2d.trace = True
glUniform2d.play = True
gl.add(glUniform2d)

glUniform2dv = Function('glUniform2dv')
glUniform2dv.ret = Return('void')
glUniform2dv.add( Input( 'location','GLint' ))
glUniform2dv.add( Input( 'count','GLsizei' ))
glUniform2dv.add( Input( 'value','const GLdouble *' ,size = 'count * 2' ))
glUniform2dv.version = '4.0'
glUniform2dv.category = 'GL_ARB_gpu_shader_fp64'
glUniform2dv.trace = True
glUniform2dv.play = True
gl.add(glUniform2dv)

glUniform3d = Function('glUniform3d')
glUniform3d.ret = Return('void')
glUniform3d.add( Input( 'location','GLint' ))
glUniform3d.add( Input( 'x','GLdouble' ))
glUniform3d.add( Input( 'y','GLdouble' ))
glUniform3d.add( Input( 'z','GLdouble' ))
glUniform3d.version = '4.0'
glUniform3d.category = 'GL_ARB_gpu_shader_fp64'
glUniform3d.trace = True
glUniform3d.play = True
gl.add(glUniform3d)

glUniform3dv = Function('glUniform3dv')
glUniform3dv.ret = Return('void')
glUniform3dv.add( Input( 'location','GLint' ))
glUniform3dv.add( Input( 'count','GLsizei' ))
glUniform3dv.add( Input( 'value','const GLdouble *' ,size = 'count * 3' ))
glUniform3dv.version = '4.0'
glUniform3dv.category = 'GL_ARB_gpu_shader_fp64'
glUniform3dv.trace = True
glUniform3dv.play = True
gl.add(glUniform3dv)

glUniform4d = Function('glUniform4d')
glUniform4d.ret = Return('void')
glUniform4d.add( Input( 'location','GLint' ))
glUniform4d.add( Input( 'x','GLdouble' ))
glUniform4d.add( Input( 'y','GLdouble' ))
glUniform4d.add( Input( 'z','GLdouble' ))
glUniform4d.add( Input( 'w','GLdouble' ))
glUniform4d.version = '4.0'
glUniform4d.category = 'GL_ARB_gpu_shader_fp64'
glUniform4d.trace = True
glUniform4d.play = True
gl.add(glUniform4d)

glUniform4dv = Function('glUniform4dv')
glUniform4dv.ret = Return('void')
glUniform4dv.add( Input( 'location','GLint' ))
glUniform4dv.add( Input( 'count','GLsizei' ))
glUniform4dv.add( Input( 'value','const GLdouble *' ,size = 'count * 4' ))
glUniform4dv.version = '4.0'
glUniform4dv.category = 'GL_ARB_gpu_shader_fp64'
glUniform4dv.trace = True
glUniform4dv.play = True
gl.add(glUniform4dv)

glUniformMatrix2dv = Function('glUniformMatrix2dv')
glUniformMatrix2dv.ret = Return('void')
glUniformMatrix2dv.add( Input( 'location','GLint' ))
glUniformMatrix2dv.add( Input( 'count','GLsizei' ))
glUniformMatrix2dv.add( Input( 'transpose','GLboolean' ))
glUniformMatrix2dv.add( Input( 'value','const GLdouble *' ,size = '2 * 2 * count' ))
glUniformMatrix2dv.version = '4.0'
glUniformMatrix2dv.category = 'GL_ARB_gpu_shader_fp64'
glUniformMatrix2dv.trace = True
glUniformMatrix2dv.play = True
gl.add(glUniformMatrix2dv)

glUniformMatrix2x3dv = Function('glUniformMatrix2x3dv')
glUniformMatrix2x3dv.ret = Return('void')
glUniformMatrix2x3dv.add( Input( 'location','GLint' ))
glUniformMatrix2x3dv.add( Input( 'count','GLsizei' ))
glUniformMatrix2x3dv.add( Input( 'transpose','GLboolean' ))
glUniformMatrix2x3dv.add( Input( 'value','const GLdouble *' ,size = '2 * 3 * count' ))
glUniformMatrix2x3dv.version = '4.0'
glUniformMatrix2x3dv.category = 'GL_ARB_gpu_shader_fp64'
glUniformMatrix2x3dv.trace = True
glUniformMatrix2x3dv.play = True
gl.add(glUniformMatrix2x3dv)

glUniformMatrix2x4dv = Function('glUniformMatrix2x4dv')
glUniformMatrix2x4dv.ret = Return('void')
glUniformMatrix2x4dv.add( Input( 'location','GLint' ))
glUniformMatrix2x4dv.add( Input( 'count','GLsizei' ))
glUniformMatrix2x4dv.add( Input( 'transpose','GLboolean' ))
glUniformMatrix2x4dv.add( Input( 'value','const GLdouble *' ,size = '2 * 4 * count' ))
glUniformMatrix2x4dv.version = '4.0'
glUniformMatrix2x4dv.category = 'GL_ARB_gpu_shader_fp64'
glUniformMatrix2x4dv.trace = True
glUniformMatrix2x4dv.play = True
gl.add(glUniformMatrix2x4dv)

glUniformMatrix3dv = Function('glUniformMatrix3dv')
glUniformMatrix3dv.ret = Return('void')
glUniformMatrix3dv.add( Input( 'location','GLint' ))
glUniformMatrix3dv.add( Input( 'count','GLsizei' ))
glUniformMatrix3dv.add( Input( 'transpose','GLboolean' ))
glUniformMatrix3dv.add( Input( 'value','const GLdouble *' ,size = '3 * 3 * count' ))
glUniformMatrix3dv.version = '4.0'
glUniformMatrix3dv.category = 'GL_ARB_gpu_shader_fp64'
glUniformMatrix3dv.trace = True
glUniformMatrix3dv.play = True
gl.add(glUniformMatrix3dv)

glUniformMatrix3x2dv = Function('glUniformMatrix3x2dv')
glUniformMatrix3x2dv.ret = Return('void')
glUniformMatrix3x2dv.add( Input( 'location','GLint' ))
glUniformMatrix3x2dv.add( Input( 'count','GLsizei' ))
glUniformMatrix3x2dv.add( Input( 'transpose','GLboolean' ))
glUniformMatrix3x2dv.add( Input( 'value','const GLdouble *' ,size = '3 * 2 * count' ))
glUniformMatrix3x2dv.version = '4.0'
glUniformMatrix3x2dv.category = 'GL_ARB_gpu_shader_fp64'
glUniformMatrix3x2dv.trace = True
glUniformMatrix3x2dv.play = True
gl.add(glUniformMatrix3x2dv)

glUniformMatrix3x4dv = Function('glUniformMatrix3x4dv')
glUniformMatrix3x4dv.ret = Return('void')
glUniformMatrix3x4dv.add( Input( 'location','GLint' ))
glUniformMatrix3x4dv.add( Input( 'count','GLsizei' ))
glUniformMatrix3x4dv.add( Input( 'transpose','GLboolean' ))
glUniformMatrix3x4dv.add( Input( 'value','const GLdouble *' ,size = '3 * 4 * count' ))
glUniformMatrix3x4dv.version = '4.0'
glUniformMatrix3x4dv.category = 'GL_ARB_gpu_shader_fp64'
glUniformMatrix3x4dv.trace = True
glUniformMatrix3x4dv.play = True
gl.add(glUniformMatrix3x4dv)

glUniformMatrix4dv = Function('glUniformMatrix4dv')
glUniformMatrix4dv.ret = Return('void')
glUniformMatrix4dv.add( Input( 'location','GLint' ))
glUniformMatrix4dv.add( Input( 'count','GLsizei' ))
glUniformMatrix4dv.add( Input( 'transpose','GLboolean' ))
glUniformMatrix4dv.add( Input( 'value','const GLdouble *' ,size = '4 * 4 * count' ))
glUniformMatrix4dv.version = '4.0'
glUniformMatrix4dv.category = 'GL_ARB_gpu_shader_fp64'
glUniformMatrix4dv.trace = True
glUniformMatrix4dv.play = True
gl.add(glUniformMatrix4dv)

glUniformMatrix4x2dv = Function('glUniformMatrix4x2dv')
glUniformMatrix4x2dv.ret = Return('void')
glUniformMatrix4x2dv.add( Input( 'location','GLint' ))
glUniformMatrix4x2dv.add( Input( 'count','GLsizei' ))
glUniformMatrix4x2dv.add( Input( 'transpose','GLboolean' ))
glUniformMatrix4x2dv.add( Input( 'value','const GLdouble *' ,size = '4 * 2 * count' ))
glUniformMatrix4x2dv.version = '4.0'
glUniformMatrix4x2dv.category = 'GL_ARB_gpu_shader_fp64'
glUniformMatrix4x2dv.trace = True
glUniformMatrix4x2dv.play = True
gl.add(glUniformMatrix4x2dv)

glUniformMatrix4x3dv = Function('glUniformMatrix4x3dv')
glUniformMatrix4x3dv.ret = Return('void')
glUniformMatrix4x3dv.add( Input( 'location','GLint' ))
glUniformMatrix4x3dv.add( Input( 'count','GLsizei' ))
glUniformMatrix4x3dv.add( Input( 'transpose','GLboolean' ))
glUniformMatrix4x3dv.add( Input( 'value','const GLdouble *' ,size = '4 * 3 * count' ))
glUniformMatrix4x3dv.version = '4.0'
glUniformMatrix4x3dv.category = 'GL_ARB_gpu_shader_fp64'
glUniformMatrix4x3dv.trace = True
glUniformMatrix4x3dv.play = True
gl.add(glUniformMatrix4x3dv)

# GL_ARB_imaging

glColorSubTable = Function('glColorSubTable')
glColorSubTable.ret = Return('void')
glColorSubTable.add( Input( 'target','GLenum' ))
glColorSubTable.add( Input( 'start','GLsizei' ))
glColorSubTable.add( Input( 'count','GLsizei' ))
glColorSubTable.add( Input( 'format','GLenum' ))
glColorSubTable.add( Input( 'type','GLenum' ))
glColorSubTable.add( Input( 'data','const GLvoid *' ))
glColorSubTable.version = '1.2'
glColorSubTable.category = 'GL_ARB_imaging'
glColorSubTable.trace = True
glColorSubTable.play = True
gl.add(glColorSubTable)

glColorTable = Function('glColorTable')
glColorTable.ret = Return('void')
glColorTable.add( Input( 'target','GLenum' ))
glColorTable.add( Input( 'internalformat','GLenum' ))
glColorTable.add( Input( 'width','GLsizei' ))
glColorTable.add( Input( 'format','GLenum' ))
glColorTable.add( Input( 'type','GLenum' ))
glColorTable.add( Input( 'table','const GLvoid *' ))
glColorTable.version = '1.2'
glColorTable.category = 'GL_ARB_imaging'
glColorTable.trace = True
glColorTable.play = True
gl.add(glColorTable)

glColorTableParameterfv = Function('glColorTableParameterfv')
glColorTableParameterfv.ret = Return('void')
glColorTableParameterfv.add( Input( 'target','GLenum' ))
glColorTableParameterfv.add( Input( 'pname','GLenum' ))
glColorTableParameterfv.add( Input( 'params','const GLfloat *' ))
glColorTableParameterfv.version = '1.2'
glColorTableParameterfv.category = 'GL_ARB_imaging'
glColorTableParameterfv.trace = True
glColorTableParameterfv.play = True
gl.add(glColorTableParameterfv)

glColorTableParameteriv = Function('glColorTableParameteriv')
glColorTableParameteriv.ret = Return('void')
glColorTableParameteriv.add( Input( 'target','GLenum' ))
glColorTableParameteriv.add( Input( 'pname','GLenum' ))
glColorTableParameteriv.add( Input( 'params','const GLint *' ))
glColorTableParameteriv.version = '1.2'
glColorTableParameteriv.category = 'GL_ARB_imaging'
glColorTableParameteriv.trace = True
glColorTableParameteriv.play = True
gl.add(glColorTableParameteriv)

glConvolutionFilter1D = Function('glConvolutionFilter1D')
glConvolutionFilter1D.ret = Return('void')
glConvolutionFilter1D.add( Input( 'target','GLenum' ))
glConvolutionFilter1D.add( Input( 'internalformat','GLenum' ))
glConvolutionFilter1D.add( Input( 'width','GLsizei' ))
glConvolutionFilter1D.add( Input( 'format','GLenum' ))
glConvolutionFilter1D.add( Input( 'type','GLenum' ))
glConvolutionFilter1D.add( Input( 'image','const GLvoid *' ))
glConvolutionFilter1D.version = '1.2'
glConvolutionFilter1D.category = 'GL_ARB_imaging'
glConvolutionFilter1D.trace = True
glConvolutionFilter1D.play = True
gl.add(glConvolutionFilter1D)

glConvolutionFilter2D = Function('glConvolutionFilter2D')
glConvolutionFilter2D.ret = Return('void')
glConvolutionFilter2D.add( Input( 'target','GLenum' ))
glConvolutionFilter2D.add( Input( 'internalformat','GLenum' ))
glConvolutionFilter2D.add( Input( 'width','GLsizei' ))
glConvolutionFilter2D.add( Input( 'height','GLsizei' ))
glConvolutionFilter2D.add( Input( 'format','GLenum' ))
glConvolutionFilter2D.add( Input( 'type','GLenum' ))
glConvolutionFilter2D.add( Input( 'image','const GLvoid *' ))
glConvolutionFilter2D.version = '1.2'
glConvolutionFilter2D.category = 'GL_ARB_imaging'
glConvolutionFilter2D.trace = True
glConvolutionFilter2D.play = True
gl.add(glConvolutionFilter2D)

glConvolutionParameterf = Function('glConvolutionParameterf')
glConvolutionParameterf.ret = Return('void')
glConvolutionParameterf.add( Input( 'target','GLenum' ))
glConvolutionParameterf.add( Input( 'pname','GLenum' ))
glConvolutionParameterf.add( Input( 'params','GLfloat' ))
glConvolutionParameterf.version = '1.2'
glConvolutionParameterf.category = 'GL_ARB_imaging'
glConvolutionParameterf.trace = True
glConvolutionParameterf.play = True
gl.add(glConvolutionParameterf)

glConvolutionParameterfv = Function('glConvolutionParameterfv')
glConvolutionParameterfv.ret = Return('void')
glConvolutionParameterfv.add( Input( 'target','GLenum' ))
glConvolutionParameterfv.add( Input( 'pname','GLenum' ))
glConvolutionParameterfv.add( Input( 'params','const GLfloat *' ))
glConvolutionParameterfv.version = '1.2'
glConvolutionParameterfv.category = 'GL_ARB_imaging'
glConvolutionParameterfv.trace = True
glConvolutionParameterfv.play = True
gl.add(glConvolutionParameterfv)

glConvolutionParameteri = Function('glConvolutionParameteri')
glConvolutionParameteri.ret = Return('void')
glConvolutionParameteri.add( Input( 'target','GLenum' ))
glConvolutionParameteri.add( Input( 'pname','GLenum' ))
glConvolutionParameteri.add( Input( 'params','GLint' ))
glConvolutionParameteri.version = '1.2'
glConvolutionParameteri.category = 'GL_ARB_imaging'
glConvolutionParameteri.trace = True
glConvolutionParameteri.play = True
gl.add(glConvolutionParameteri)

glConvolutionParameteriv = Function('glConvolutionParameteriv')
glConvolutionParameteriv.ret = Return('void')
glConvolutionParameteriv.add( Input( 'target','GLenum' ))
glConvolutionParameteriv.add( Input( 'pname','GLenum' ))
glConvolutionParameteriv.add( Input( 'params','const GLint *' ))
glConvolutionParameteriv.version = '1.2'
glConvolutionParameteriv.category = 'GL_ARB_imaging'
glConvolutionParameteriv.trace = True
glConvolutionParameteriv.play = True
gl.add(glConvolutionParameteriv)

glCopyColorSubTable = Function('glCopyColorSubTable')
glCopyColorSubTable.ret = Return('void')
glCopyColorSubTable.add( Input( 'target','GLenum' ))
glCopyColorSubTable.add( Input( 'start','GLsizei' ))
glCopyColorSubTable.add( Input( 'x','GLint' ))
glCopyColorSubTable.add( Input( 'y','GLint' ))
glCopyColorSubTable.add( Input( 'width','GLsizei' ))
glCopyColorSubTable.version = '1.2'
glCopyColorSubTable.category = 'GL_ARB_imaging'
glCopyColorSubTable.trace = True
glCopyColorSubTable.play = True
gl.add(glCopyColorSubTable)

glCopyColorTable = Function('glCopyColorTable')
glCopyColorTable.ret = Return('void')
glCopyColorTable.add( Input( 'target','GLenum' ))
glCopyColorTable.add( Input( 'internalformat','GLenum' ))
glCopyColorTable.add( Input( 'x','GLint' ))
glCopyColorTable.add( Input( 'y','GLint' ))
glCopyColorTable.add( Input( 'width','GLsizei' ))
glCopyColorTable.version = '1.2'
glCopyColorTable.category = 'GL_ARB_imaging'
glCopyColorTable.trace = True
glCopyColorTable.play = True
gl.add(glCopyColorTable)

glCopyConvolutionFilter1D = Function('glCopyConvolutionFilter1D')
glCopyConvolutionFilter1D.ret = Return('void')
glCopyConvolutionFilter1D.add( Input( 'target','GLenum' ))
glCopyConvolutionFilter1D.add( Input( 'internalformat','GLenum' ))
glCopyConvolutionFilter1D.add( Input( 'x','GLint' ))
glCopyConvolutionFilter1D.add( Input( 'y','GLint' ))
glCopyConvolutionFilter1D.add( Input( 'width','GLsizei' ))
glCopyConvolutionFilter1D.version = '1.2'
glCopyConvolutionFilter1D.category = 'GL_ARB_imaging'
glCopyConvolutionFilter1D.trace = True
glCopyConvolutionFilter1D.play = True
gl.add(glCopyConvolutionFilter1D)

glCopyConvolutionFilter2D = Function('glCopyConvolutionFilter2D')
glCopyConvolutionFilter2D.ret = Return('void')
glCopyConvolutionFilter2D.add( Input( 'target','GLenum' ))
glCopyConvolutionFilter2D.add( Input( 'internalformat','GLenum' ))
glCopyConvolutionFilter2D.add( Input( 'x','GLint' ))
glCopyConvolutionFilter2D.add( Input( 'y','GLint' ))
glCopyConvolutionFilter2D.add( Input( 'width','GLsizei' ))
glCopyConvolutionFilter2D.add( Input( 'height','GLsizei' ))
glCopyConvolutionFilter2D.version = '1.2'
glCopyConvolutionFilter2D.category = 'GL_ARB_imaging'
glCopyConvolutionFilter2D.trace = True
glCopyConvolutionFilter2D.play = True
gl.add(glCopyConvolutionFilter2D)

glGetColorTable = Function('glGetColorTable')
glGetColorTable.ret = Return('void')
glGetColorTable.add( Input( 'target','GLenum' ))
glGetColorTable.add( Input( 'format','GLenum' ))
glGetColorTable.add( Input( 'type','GLenum' ))
glGetColorTable.add( Output( 'table','GLvoid *' ))
glGetColorTable.version = '1.2'
glGetColorTable.category = 'GL_ARB_imaging'
glGetColorTable.trace = True
glGetColorTable.play = True
gl.add(glGetColorTable)

glGetColorTableParameterfv = Function('glGetColorTableParameterfv')
glGetColorTableParameterfv.ret = Return('void')
glGetColorTableParameterfv.add( Input( 'target','GLenum' ))
glGetColorTableParameterfv.add( Input( 'pname','GLenum' ))
glGetColorTableParameterfv.add( Output( 'params','GLfloat *' ))
glGetColorTableParameterfv.version = '1.2'
glGetColorTableParameterfv.category = 'GL_ARB_imaging'
glGetColorTableParameterfv.trace = True
glGetColorTableParameterfv.play = True
gl.add(glGetColorTableParameterfv)

glGetColorTableParameteriv = Function('glGetColorTableParameteriv')
glGetColorTableParameteriv.ret = Return('void')
glGetColorTableParameteriv.add( Input( 'target','GLenum' ))
glGetColorTableParameteriv.add( Input( 'pname','GLenum' ))
glGetColorTableParameteriv.add( Output( 'params','GLint *' ))
glGetColorTableParameteriv.version = '1.2'
glGetColorTableParameteriv.category = 'GL_ARB_imaging'
glGetColorTableParameteriv.trace = True
glGetColorTableParameteriv.play = True
gl.add(glGetColorTableParameteriv)

glGetConvolutionFilter = Function('glGetConvolutionFilter')
glGetConvolutionFilter.ret = Return('void')
glGetConvolutionFilter.add( Input( 'target','GLenum' ))
glGetConvolutionFilter.add( Input( 'format','GLenum' ))
glGetConvolutionFilter.add( Input( 'type','GLenum' ))
glGetConvolutionFilter.add( Output( 'image','GLvoid *' ))
glGetConvolutionFilter.version = '1.2'
glGetConvolutionFilter.category = 'GL_ARB_imaging'
glGetConvolutionFilter.trace = True
glGetConvolutionFilter.play = False
gl.add(glGetConvolutionFilter)

glGetConvolutionParameterfv = Function('glGetConvolutionParameterfv')
glGetConvolutionParameterfv.ret = Return('void')
glGetConvolutionParameterfv.add( Input( 'target','GLenum' ))
glGetConvolutionParameterfv.add( Input( 'pname','GLenum' ))
glGetConvolutionParameterfv.add( Output( 'params','GLfloat *' ))
glGetConvolutionParameterfv.version = '1.2'
glGetConvolutionParameterfv.category = 'GL_ARB_imaging'
glGetConvolutionParameterfv.trace = True
glGetConvolutionParameterfv.play = False
gl.add(glGetConvolutionParameterfv)

glGetConvolutionParameteriv = Function('glGetConvolutionParameteriv')
glGetConvolutionParameteriv.ret = Return('void')
glGetConvolutionParameteriv.add( Input( 'target','GLenum' ))
glGetConvolutionParameteriv.add( Input( 'pname','GLenum' ))
glGetConvolutionParameteriv.add( Output( 'params','GLint *' ))
glGetConvolutionParameteriv.version = '1.2'
glGetConvolutionParameteriv.category = 'GL_ARB_imaging'
glGetConvolutionParameteriv.trace = True
glGetConvolutionParameteriv.play = False
gl.add(glGetConvolutionParameteriv)

glGetHistogram = Function('glGetHistogram')
glGetHistogram.ret = Return('void')
glGetHistogram.add( Input( 'target','GLenum' ))
glGetHistogram.add( Input( 'reset','GLboolean' ))
glGetHistogram.add( Input( 'format','GLenum' ))
glGetHistogram.add( Input( 'type','GLenum' ))
glGetHistogram.add( Output( 'values','GLvoid *' ))
glGetHistogram.version = '1.2'
glGetHistogram.category = 'GL_ARB_imaging'
glGetHistogram.trace = True
glGetHistogram.play = False
gl.add(glGetHistogram)

glGetHistogramParameterfv = Function('glGetHistogramParameterfv')
glGetHistogramParameterfv.ret = Return('void')
glGetHistogramParameterfv.add( Input( 'target','GLenum' ))
glGetHistogramParameterfv.add( Input( 'pname','GLenum' ))
glGetHistogramParameterfv.add( Output( 'params','GLfloat *' ))
glGetHistogramParameterfv.version = '1.2'
glGetHistogramParameterfv.category = 'GL_ARB_imaging'
glGetHistogramParameterfv.trace = True
glGetHistogramParameterfv.play = False
gl.add(glGetHistogramParameterfv)

glGetHistogramParameteriv = Function('glGetHistogramParameteriv')
glGetHistogramParameteriv.ret = Return('void')
glGetHistogramParameteriv.add( Input( 'target','GLenum' ))
glGetHistogramParameteriv.add( Input( 'pname','GLenum' ))
glGetHistogramParameteriv.add( Output( 'params','GLint *' ))
glGetHistogramParameteriv.version = '1.2'
glGetHistogramParameteriv.category = 'GL_ARB_imaging'
glGetHistogramParameteriv.trace = True
glGetHistogramParameteriv.play = False
gl.add(glGetHistogramParameteriv)

glGetMinmax = Function('glGetMinmax')
glGetMinmax.ret = Return('void')
glGetMinmax.add( Input( 'target','GLenum' ))
glGetMinmax.add( Input( 'reset','GLboolean' ))
glGetMinmax.add( Input( 'format','GLenum' ))
glGetMinmax.add( Input( 'types','GLenum' ))
glGetMinmax.add( Output( 'values','GLvoid *' ))
glGetMinmax.version = '1.2'
glGetMinmax.category = 'GL_ARB_imaging'
glGetMinmax.trace = True
glGetMinmax.play = False
gl.add(glGetMinmax)

glGetMinmaxParameterfv = Function('glGetMinmaxParameterfv')
glGetMinmaxParameterfv.ret = Return('void')
glGetMinmaxParameterfv.add( Input( 'target','GLenum' ))
glGetMinmaxParameterfv.add( Input( 'pname','GLenum' ))
glGetMinmaxParameterfv.add( Output( 'params','GLfloat *' ))
glGetMinmaxParameterfv.version = '1.2'
glGetMinmaxParameterfv.category = 'GL_ARB_imaging'
glGetMinmaxParameterfv.trace = True
glGetMinmaxParameterfv.play = False
gl.add(glGetMinmaxParameterfv)

glGetMinmaxParameteriv = Function('glGetMinmaxParameteriv')
glGetMinmaxParameteriv.ret = Return('void')
glGetMinmaxParameteriv.add( Input( 'target','GLenum' ))
glGetMinmaxParameteriv.add( Input( 'pname','GLenum' ))
glGetMinmaxParameteriv.add( Output( 'params','GLint *' ))
glGetMinmaxParameteriv.version = '1.2'
glGetMinmaxParameteriv.category = 'GL_ARB_imaging'
glGetMinmaxParameteriv.trace = True
glGetMinmaxParameteriv.play = False
gl.add(glGetMinmaxParameteriv)

glGetSeparableFilter = Function('glGetSeparableFilter')
glGetSeparableFilter.ret = Return('void')
glGetSeparableFilter.add( Input( 'target','GLenum' ))
glGetSeparableFilter.add( Input( 'format','GLenum' ))
glGetSeparableFilter.add( Input( 'type','GLenum' ))
glGetSeparableFilter.add( Output( 'row','GLvoid *' ))
glGetSeparableFilter.add( Output( 'column','GLvoid *' ))
glGetSeparableFilter.add( Output( 'span','GLvoid *' ))
glGetSeparableFilter.version = '1.2'
glGetSeparableFilter.category = 'GL_ARB_imaging'
glGetSeparableFilter.trace = True
glGetSeparableFilter.play = False
gl.add(glGetSeparableFilter)

glHistogram = Function('glHistogram')
glHistogram.ret = Return('void')
glHistogram.add( Input( 'target','GLenum' ))
glHistogram.add( Input( 'width','GLsizei' ))
glHistogram.add( Input( 'internalformat','GLenum' ))
glHistogram.add( Input( 'sink','GLboolean' ))
glHistogram.version = '1.2'
glHistogram.category = 'GL_ARB_imaging'
glHistogram.trace = True
glHistogram.play = True
gl.add(glHistogram)

glMinmax = Function('glMinmax')
glMinmax.ret = Return('void')
glMinmax.add( Input( 'target','GLenum' ))
glMinmax.add( Input( 'internalformat','GLenum' ))
glMinmax.add( Input( 'sink','GLboolean' ))
glMinmax.version = '1.2'
glMinmax.category = 'GL_ARB_imaging'
glMinmax.trace = True
glMinmax.play = True
gl.add(glMinmax)

glResetHistogram = Function('glResetHistogram')
glResetHistogram.ret = Return('void')
glResetHistogram.add( Input( 'target','GLenum' ))
glResetHistogram.version = '1.2'
glResetHistogram.category = 'GL_ARB_imaging'
glResetHistogram.trace = True
glResetHistogram.play = True
gl.add(glResetHistogram)

glResetMinmax = Function('glResetMinmax')
glResetMinmax.ret = Return('void')
glResetMinmax.add( Input( 'target','GLenum' ))
glResetMinmax.version = '1.2'
glResetMinmax.category = 'GL_ARB_imaging'
glResetMinmax.trace = True
glResetMinmax.play = True
gl.add(glResetMinmax)

glSeparableFilter2D = Function('glSeparableFilter2D')
glSeparableFilter2D.ret = Return('void')
glSeparableFilter2D.add( Input( 'target','GLenum' ))
glSeparableFilter2D.add( Input( 'internalformat','GLenum' ))
glSeparableFilter2D.add( Input( 'width','GLsizei' ))
glSeparableFilter2D.add( Input( 'height','GLsizei' ))
glSeparableFilter2D.add( Input( 'format','GLenum' ))
glSeparableFilter2D.add( Input( 'type','GLenum' ))
glSeparableFilter2D.add( Input( 'row','const GLvoid *' ))
glSeparableFilter2D.add( Input( 'column','const GLvoid *' ))
glSeparableFilter2D.version = '1.2'
glSeparableFilter2D.category = 'GL_ARB_imaging'
glSeparableFilter2D.trace = True
glSeparableFilter2D.play = True
gl.add(glSeparableFilter2D)

# GL_ARB_indirect_parameters

glMultiDrawArraysIndirectCountARB = Function('glMultiDrawArraysIndirectCountARB')
glMultiDrawArraysIndirectCountARB.ret = Return('void')
glMultiDrawArraysIndirectCountARB.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glMultiDrawArraysIndirectCountARB.add( Input( 'indirect','const GLvoid *' ))
glMultiDrawArraysIndirectCountARB.add( Input( 'drawcount','GLintptr' ))
glMultiDrawArraysIndirectCountARB.add( Input( 'maxdrawcount','GLsizei' ))
glMultiDrawArraysIndirectCountARB.add( Input( 'stride','GLsizei' ))
glMultiDrawArraysIndirectCountARB.version = ''
glMultiDrawArraysIndirectCountARB.category = 'GL_ARB_indirect_parameters'
glMultiDrawArraysIndirectCountARB.trace = True
glMultiDrawArraysIndirectCountARB.play = True
gl.add(glMultiDrawArraysIndirectCountARB)

glMultiDrawElementsIndirectCountARB = Function('glMultiDrawElementsIndirectCountARB')
glMultiDrawElementsIndirectCountARB.ret = Return('void')
glMultiDrawElementsIndirectCountARB.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glMultiDrawElementsIndirectCountARB.add( Input( 'type','GLenum' ))
glMultiDrawElementsIndirectCountARB.add( Input( 'indirect','const GLvoid *' ))
glMultiDrawElementsIndirectCountARB.add( Input( 'drawcount','GLintptr' ))
glMultiDrawElementsIndirectCountARB.add( Input( 'maxdrawcount','GLsizei' ))
glMultiDrawElementsIndirectCountARB.add( Input( 'stride','GLsizei' ))
glMultiDrawElementsIndirectCountARB.version = ''
glMultiDrawElementsIndirectCountARB.category = 'GL_ARB_indirect_parameters'
glMultiDrawElementsIndirectCountARB.trace = True
glMultiDrawElementsIndirectCountARB.play = True
gl.add(glMultiDrawElementsIndirectCountARB)

# GL_ARB_instanced_arrays

glVertexAttribDivisorARB = Function('glVertexAttribDivisorARB')
glVertexAttribDivisorARB.ret = Return('void')
glVertexAttribDivisorARB.add( Input( 'index','GLuint' ))
glVertexAttribDivisorARB.add( Input( 'divisor','GLuint' ))
glVertexAttribDivisorARB.version = '3.3'
glVertexAttribDivisorARB.category = 'GL_ARB_instanced_arrays'
glVertexAttribDivisorARB.trace = True
glVertexAttribDivisorARB.play = True
gl.add(glVertexAttribDivisorARB)

# GL_ARB_internalformat_query

glGetInternalformativ = Function('glGetInternalformativ')
glGetInternalformativ.ret = Return('void')
glGetInternalformativ.add( Input( 'target','GLenum' ))
glGetInternalformativ.add( Input( 'internalformat','GLenum' ))
glGetInternalformativ.add( Input( 'pname','GLenum' ))
glGetInternalformativ.add( Input( 'bufSize','GLsizei' ))
glGetInternalformativ.add( Input( 'params','GLint *' ))
glGetInternalformativ.version = ''
glGetInternalformativ.category = 'GL_ARB_internalformat_query'
glGetInternalformativ.trace = True
glGetInternalformativ.play = True
gl.add(glGetInternalformativ)

# GL_ARB_internalformat_query2

glGetInternalformati64v = Function('glGetInternalformati64v')
glGetInternalformati64v.ret = Return('void')
glGetInternalformati64v.add( Input( 'target','GLenum' ))
glGetInternalformati64v.add( Input( 'internalformat','GLenum' ))
glGetInternalformati64v.add( Input( 'pname','GLenum' ))
glGetInternalformati64v.add( Input( 'bufSize','GLsizei' ))
glGetInternalformati64v.add( Input( 'params','GLint64 *' ))
glGetInternalformati64v.version = ''
glGetInternalformati64v.category = 'GL_ARB_internalformat_query2'
glGetInternalformati64v.trace = True
glGetInternalformati64v.play = True
gl.add(glGetInternalformati64v)

# GL_ARB_invalidate_subdata

glInvalidateBufferData = Function('glInvalidateBufferData')
glInvalidateBufferData.ret = Return('void')
glInvalidateBufferData.add( Input( 'buffer','GLuint' ))
glInvalidateBufferData.version = ''
glInvalidateBufferData.category = 'GL_ARB_invalidate_subdata'
glInvalidateBufferData.trace = True
glInvalidateBufferData.play = True
gl.add(glInvalidateBufferData)

glInvalidateBufferSubData = Function('glInvalidateBufferSubData')
glInvalidateBufferSubData.ret = Return('void')
glInvalidateBufferSubData.add( Input( 'buffer','GLuint' ))
glInvalidateBufferSubData.add( Input( 'offset','GLintptr' ))
glInvalidateBufferSubData.add( Input( 'length','GLsizeiptr' ))
glInvalidateBufferSubData.version = ''
glInvalidateBufferSubData.category = 'GL_ARB_invalidate_subdata'
glInvalidateBufferSubData.trace = True
glInvalidateBufferSubData.play = True
gl.add(glInvalidateBufferSubData)

glInvalidateFramebuffer = Function('glInvalidateFramebuffer')
glInvalidateFramebuffer.ret = Return('void')
glInvalidateFramebuffer.add( Input( 'target','GLenum' ))
glInvalidateFramebuffer.add( Input( 'numAttachments','GLsizei' ))
glInvalidateFramebuffer.add( Input( 'attachments','const GLenum *' ))
glInvalidateFramebuffer.version = ''
glInvalidateFramebuffer.category = 'GL_ARB_invalidate_subdata'
glInvalidateFramebuffer.trace = True
glInvalidateFramebuffer.play = True
gl.add(glInvalidateFramebuffer)

glInvalidateSubFramebuffer = Function('glInvalidateSubFramebuffer')
glInvalidateSubFramebuffer.ret = Return('void')
glInvalidateSubFramebuffer.add( Input( 'target','GLenum' ))
glInvalidateSubFramebuffer.add( Input( 'numAttachments','GLsizei' ))
glInvalidateSubFramebuffer.add( Input( 'attachments','const GLenum *' ))
glInvalidateSubFramebuffer.add( Input( 'x','GLint' ))
glInvalidateSubFramebuffer.add( Input( 'y','GLint' ))
glInvalidateSubFramebuffer.add( Input( 'width','GLsizei' ))
glInvalidateSubFramebuffer.add( Input( 'height','GLsizei' ))
glInvalidateSubFramebuffer.version = ''
glInvalidateSubFramebuffer.category = 'GL_ARB_invalidate_subdata'
glInvalidateSubFramebuffer.trace = True
glInvalidateSubFramebuffer.play = True
gl.add(glInvalidateSubFramebuffer)

glInvalidateTexImage = Function('glInvalidateTexImage')
glInvalidateTexImage.ret = Return('void')
glInvalidateTexImage.add( Input( 'texture','GLuint' ))
glInvalidateTexImage.add( Input( 'level','GLint' ))
glInvalidateTexImage.version = ''
glInvalidateTexImage.category = 'GL_ARB_invalidate_subdata'
glInvalidateTexImage.trace = True
glInvalidateTexImage.play = True
gl.add(glInvalidateTexImage)

glInvalidateTexSubImage = Function('glInvalidateTexSubImage')
glInvalidateTexSubImage.ret = Return('void')
glInvalidateTexSubImage.add( Input( 'texture','GLuint' ))
glInvalidateTexSubImage.add( Input( 'level','GLint' ))
glInvalidateTexSubImage.add( Input( 'xoffset','GLint' ))
glInvalidateTexSubImage.add( Input( 'yoffset','GLint' ))
glInvalidateTexSubImage.add( Input( 'zoffset','GLint' ))
glInvalidateTexSubImage.add( Input( 'width','GLsizei' ))
glInvalidateTexSubImage.add( Input( 'height','GLsizei' ))
glInvalidateTexSubImage.add( Input( 'depth','GLsizei' ))
glInvalidateTexSubImage.version = ''
glInvalidateTexSubImage.category = 'GL_ARB_invalidate_subdata'
glInvalidateTexSubImage.trace = True
glInvalidateTexSubImage.play = True
gl.add(glInvalidateTexSubImage)

# GL_ARB_map_buffer_range

glFlushMappedBufferRange = Function('glFlushMappedBufferRange')
glFlushMappedBufferRange.ret = Return('void')
glFlushMappedBufferRange.add( Input( 'target','GLenum' ))
glFlushMappedBufferRange.add( Input( 'offset','GLintptr' ))
glFlushMappedBufferRange.add( Input( 'length','GLsizeiptr' ))
glFlushMappedBufferRange.version = '3.0'
glFlushMappedBufferRange.category = 'GL_ARB_map_buffer_range'
glFlushMappedBufferRange.trace = True
glFlushMappedBufferRange.play = True
gl.add(glFlushMappedBufferRange)

glMapBufferRange = Function('glMapBufferRange')
glMapBufferRange.ret = Return('GLvoid *')
glMapBufferRange.add( Input( 'target','GLenum' ))
glMapBufferRange.add( Input( 'offset','GLintptr' ))
glMapBufferRange.add( Input( 'length','GLsizeiptr' ))
glMapBufferRange.add( Input( 'access','GLbitfield' ,regalLog = 'GLmapBufferRangeToString(access)' ))
glMapBufferRange.version = '3.0'
glMapBufferRange.category = 'GL_ARB_map_buffer_range'
glMapBufferRange.trace = True
glMapBufferRange.play = True
gl.add(glMapBufferRange)

# GL_ARB_matrix_palette

glCurrentPaletteMatrixARB = Function('glCurrentPaletteMatrixARB')
glCurrentPaletteMatrixARB.ret = Return('void')
glCurrentPaletteMatrixARB.add( Input( 'index','GLint' ))
glCurrentPaletteMatrixARB.version = '1.1'
glCurrentPaletteMatrixARB.category = 'GL_ARB_matrix_palette'
glCurrentPaletteMatrixARB.trace = True
glCurrentPaletteMatrixARB.play = True
gl.add(glCurrentPaletteMatrixARB)

glMatrixIndexPointerARB = Function('glMatrixIndexPointerARB')
glMatrixIndexPointerARB.ret = Return('void')
glMatrixIndexPointerARB.add( Input( 'size','GLint' ))
glMatrixIndexPointerARB.add( Input( 'type','GLenum' ))
glMatrixIndexPointerARB.add( Input( 'stride','GLsizei' ))
glMatrixIndexPointerARB.add( Input( 'pointer','const GLvoid *' ))
glMatrixIndexPointerARB.version = '1.1'
glMatrixIndexPointerARB.category = 'GL_ARB_matrix_palette'
glMatrixIndexPointerARB.trace = True
glMatrixIndexPointerARB.play = True
gl.add(glMatrixIndexPointerARB)

glMatrixIndexubvARB = Function('glMatrixIndexubvARB')
glMatrixIndexubvARB.ret = Return('void')
glMatrixIndexubvARB.add( Input( 'size','GLint' ))
glMatrixIndexubvARB.add( Input( 'indices','const GLubyte *' ))
glMatrixIndexubvARB.version = '1.1'
glMatrixIndexubvARB.category = 'GL_ARB_matrix_palette'
glMatrixIndexubvARB.trace = True
glMatrixIndexubvARB.play = False
gl.add(glMatrixIndexubvARB)

glMatrixIndexuivARB = Function('glMatrixIndexuivARB')
glMatrixIndexuivARB.ret = Return('void')
glMatrixIndexuivARB.add( Input( 'size','GLint' ))
glMatrixIndexuivARB.add( Input( 'indices','const GLuint *' ))
glMatrixIndexuivARB.version = '1.1'
glMatrixIndexuivARB.category = 'GL_ARB_matrix_palette'
glMatrixIndexuivARB.trace = True
glMatrixIndexuivARB.play = True
gl.add(glMatrixIndexuivARB)

glMatrixIndexusvARB = Function('glMatrixIndexusvARB')
glMatrixIndexusvARB.ret = Return('void')
glMatrixIndexusvARB.add( Input( 'size','GLint' ))
glMatrixIndexusvARB.add( Input( 'indices','const GLushort *' ))
glMatrixIndexusvARB.version = '1.1'
glMatrixIndexusvARB.category = 'GL_ARB_matrix_palette'
glMatrixIndexusvARB.trace = True
glMatrixIndexusvARB.play = True
gl.add(glMatrixIndexusvARB)

# GL_ARB_multi_bind

glBindBuffersBase = Function('glBindBuffersBase')
glBindBuffersBase.ret = Return('void')
glBindBuffersBase.add( Input( 'target','GLenum' ))
glBindBuffersBase.add( Input( 'first','GLuint' ))
glBindBuffersBase.add( Input( 'count','GLsizei' ))
glBindBuffersBase.add( Input( 'buffers','const GLuint *' ))
glBindBuffersBase.version = '4.4'
glBindBuffersBase.category = 'GL_ARB_multi_bind'
glBindBuffersBase.trace = True
glBindBuffersBase.play = True
gl.add(glBindBuffersBase)

glBindBuffersRange = Function('glBindBuffersRange')
glBindBuffersRange.ret = Return('void')
glBindBuffersRange.add( Input( 'target','GLenum' ))
glBindBuffersRange.add( Input( 'first','GLuint' ))
glBindBuffersRange.add( Input( 'count','GLsizei' ))
glBindBuffersRange.add( Input( 'buffers','const GLuint *' ))
glBindBuffersRange.add( Input( 'offsets','const GLintptr *' ))
glBindBuffersRange.add( Input( 'sizes','const GLsizeiptr *' ))
glBindBuffersRange.version = '4.4'
glBindBuffersRange.category = 'GL_ARB_multi_bind'
glBindBuffersRange.trace = True
glBindBuffersRange.play = True
gl.add(glBindBuffersRange)

glBindImageTextures = Function('glBindImageTextures')
glBindImageTextures.ret = Return('void')
glBindImageTextures.add( Input( 'first','GLuint' ))
glBindImageTextures.add( Input( 'count','GLsizei' ))
glBindImageTextures.add( Input( 'textures','const GLuint *' ))
glBindImageTextures.version = '4.4'
glBindImageTextures.category = 'GL_ARB_multi_bind'
glBindImageTextures.trace = True
glBindImageTextures.play = True
gl.add(glBindImageTextures)

glBindSamplers = Function('glBindSamplers')
glBindSamplers.ret = Return('void')
glBindSamplers.add( Input( 'first','GLuint' ))
glBindSamplers.add( Input( 'count','GLsizei' ))
glBindSamplers.add( Input( 'samplers','const GLuint *' ))
glBindSamplers.version = '4.4'
glBindSamplers.category = 'GL_ARB_multi_bind'
glBindSamplers.trace = True
glBindSamplers.play = True
gl.add(glBindSamplers)

glBindTextures = Function('glBindTextures')
glBindTextures.ret = Return('void')
glBindTextures.add( Input( 'first','GLuint' ))
glBindTextures.add( Input( 'count','GLsizei' ))
glBindTextures.add( Input( 'textures','const GLuint *' ))
glBindTextures.version = '4.4'
glBindTextures.category = 'GL_ARB_multi_bind'
glBindTextures.trace = True
glBindTextures.play = True
gl.add(glBindTextures)

glBindVertexBuffers = Function('glBindVertexBuffers')
glBindVertexBuffers.ret = Return('void')
glBindVertexBuffers.add( Input( 'first','GLuint' ))
glBindVertexBuffers.add( Input( 'count','GLsizei' ))
glBindVertexBuffers.add( Input( 'buffers','const GLuint *' ))
glBindVertexBuffers.add( Input( 'offsets','const GLintptr *' ))
glBindVertexBuffers.add( Input( 'strides','const GLsizei *' ))
glBindVertexBuffers.version = '4.4'
glBindVertexBuffers.category = 'GL_ARB_multi_bind'
glBindVertexBuffers.trace = True
glBindVertexBuffers.play = True
gl.add(glBindVertexBuffers)

# GL_ARB_multi_draw_indirect

glMultiDrawArraysIndirect = Function('glMultiDrawArraysIndirect')
glMultiDrawArraysIndirect.ret = Return('void')
glMultiDrawArraysIndirect.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glMultiDrawArraysIndirect.add( Input( 'indirect','const GLvoid *' ))
glMultiDrawArraysIndirect.add( Input( 'primcount','GLsizei' ))
glMultiDrawArraysIndirect.add( Input( 'stride','GLsizei' ))
glMultiDrawArraysIndirect.version = ''
glMultiDrawArraysIndirect.category = 'GL_ARB_multi_draw_indirect'
glMultiDrawArraysIndirect.trace = True
glMultiDrawArraysIndirect.play = True
gl.add(glMultiDrawArraysIndirect)

glMultiDrawElementsIndirect = Function('glMultiDrawElementsIndirect')
glMultiDrawElementsIndirect.ret = Return('void')
glMultiDrawElementsIndirect.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glMultiDrawElementsIndirect.add( Input( 'type','GLenum' ))
glMultiDrawElementsIndirect.add( Input( 'indirect','const GLvoid *' ))
glMultiDrawElementsIndirect.add( Input( 'primcount','GLsizei' ))
glMultiDrawElementsIndirect.add( Input( 'stride','GLsizei' ))
glMultiDrawElementsIndirect.version = ''
glMultiDrawElementsIndirect.category = 'GL_ARB_multi_draw_indirect'
glMultiDrawElementsIndirect.trace = True
glMultiDrawElementsIndirect.play = True
gl.add(glMultiDrawElementsIndirect)

# GL_ARB_multisample

glSampleCoverageARB = Function('glSampleCoverageARB')
glSampleCoverageARB.ret = Return('void')
glSampleCoverageARB.add( Input( 'value','GLclampf' ))
glSampleCoverageARB.add( Input( 'invert','GLboolean' ))
glSampleCoverageARB.version = '1.2'
glSampleCoverageARB.category = 'GL_ARB_multisample'
glSampleCoverageARB.trace = True
glSampleCoverageARB.play = True
gl.add(glSampleCoverageARB)

# GL_ARB_multitexture

glActiveTextureARB = Function('glActiveTextureARB')
glActiveTextureARB.ret = Return('void')
glActiveTextureARB.add( Input( 'texture','GLenum' ))
glActiveTextureARB.version = '1.2'
glActiveTextureARB.category = 'GL_ARB_multitexture'
glActiveTextureARB.trace = True
glActiveTextureARB.play = True
gl.add(glActiveTextureARB)

glClientActiveTextureARB = Function('glClientActiveTextureARB')
glClientActiveTextureARB.ret = Return('void')
glClientActiveTextureARB.add( Input( 'texture','GLenum' ))
glClientActiveTextureARB.version = '1.2'
glClientActiveTextureARB.category = 'GL_ARB_multitexture'
glClientActiveTextureARB.trace = True
glClientActiveTextureARB.play = True
gl.add(glClientActiveTextureARB)

glMultiTexCoord1dARB = Function('glMultiTexCoord1dARB')
glMultiTexCoord1dARB.ret = Return('void')
glMultiTexCoord1dARB.add( Input( 'target','GLenum' ))
glMultiTexCoord1dARB.add( Input( 's','GLdouble' ))
glMultiTexCoord1dARB.version = '1.2'
glMultiTexCoord1dARB.category = 'GL_ARB_multitexture'
glMultiTexCoord1dARB.trace = True
glMultiTexCoord1dARB.play = True
gl.add(glMultiTexCoord1dARB)

glMultiTexCoord1dvARB = Function('glMultiTexCoord1dvARB')
glMultiTexCoord1dvARB.ret = Return('void')
glMultiTexCoord1dvARB.add( Input( 'target','GLenum' ))
glMultiTexCoord1dvARB.add( Input( 'v','const GLdouble *' ,size = 1 ))
glMultiTexCoord1dvARB.version = '1.2'
glMultiTexCoord1dvARB.category = 'GL_ARB_multitexture'
glMultiTexCoord1dvARB.trace = True
glMultiTexCoord1dvARB.play = True
gl.add(glMultiTexCoord1dvARB)

glMultiTexCoord1fARB = Function('glMultiTexCoord1fARB')
glMultiTexCoord1fARB.ret = Return('void')
glMultiTexCoord1fARB.add( Input( 'target','GLenum' ))
glMultiTexCoord1fARB.add( Input( 's','GLfloat' ))
glMultiTexCoord1fARB.version = '1.2'
glMultiTexCoord1fARB.category = 'GL_ARB_multitexture'
glMultiTexCoord1fARB.trace = True
glMultiTexCoord1fARB.play = True
gl.add(glMultiTexCoord1fARB)

glMultiTexCoord1fvARB = Function('glMultiTexCoord1fvARB')
glMultiTexCoord1fvARB.ret = Return('void')
glMultiTexCoord1fvARB.add( Input( 'target','GLenum' ))
glMultiTexCoord1fvARB.add( Input( 'v','const GLfloat *' ,size = 1 ))
glMultiTexCoord1fvARB.version = '1.2'
glMultiTexCoord1fvARB.category = 'GL_ARB_multitexture'
glMultiTexCoord1fvARB.trace = True
glMultiTexCoord1fvARB.play = True
gl.add(glMultiTexCoord1fvARB)

glMultiTexCoord1iARB = Function('glMultiTexCoord1iARB')
glMultiTexCoord1iARB.ret = Return('void')
glMultiTexCoord1iARB.add( Input( 'target','GLenum' ))
glMultiTexCoord1iARB.add( Input( 's','GLint' ))
glMultiTexCoord1iARB.version = '1.2'
glMultiTexCoord1iARB.category = 'GL_ARB_multitexture'
glMultiTexCoord1iARB.trace = True
glMultiTexCoord1iARB.play = True
gl.add(glMultiTexCoord1iARB)

glMultiTexCoord1ivARB = Function('glMultiTexCoord1ivARB')
glMultiTexCoord1ivARB.ret = Return('void')
glMultiTexCoord1ivARB.add( Input( 'target','GLenum' ))
glMultiTexCoord1ivARB.add( Input( 'v','const GLint *' ,size = 1 ))
glMultiTexCoord1ivARB.version = '1.2'
glMultiTexCoord1ivARB.category = 'GL_ARB_multitexture'
glMultiTexCoord1ivARB.trace = True
glMultiTexCoord1ivARB.play = True
gl.add(glMultiTexCoord1ivARB)

glMultiTexCoord1sARB = Function('glMultiTexCoord1sARB')
glMultiTexCoord1sARB.ret = Return('void')
glMultiTexCoord1sARB.add( Input( 'target','GLenum' ))
glMultiTexCoord1sARB.add( Input( 's','GLshort' ))
glMultiTexCoord1sARB.version = '1.2'
glMultiTexCoord1sARB.category = 'GL_ARB_multitexture'
glMultiTexCoord1sARB.trace = True
glMultiTexCoord1sARB.play = True
gl.add(glMultiTexCoord1sARB)

glMultiTexCoord1svARB = Function('glMultiTexCoord1svARB')
glMultiTexCoord1svARB.ret = Return('void')
glMultiTexCoord1svARB.add( Input( 'target','GLenum' ))
glMultiTexCoord1svARB.add( Input( 'v','const GLshort *' ,size = 1 ))
glMultiTexCoord1svARB.version = '1.2'
glMultiTexCoord1svARB.category = 'GL_ARB_multitexture'
glMultiTexCoord1svARB.trace = True
glMultiTexCoord1svARB.play = True
gl.add(glMultiTexCoord1svARB)

glMultiTexCoord2dARB = Function('glMultiTexCoord2dARB')
glMultiTexCoord2dARB.ret = Return('void')
glMultiTexCoord2dARB.add( Input( 'target','GLenum' ))
glMultiTexCoord2dARB.add( Input( 's','GLdouble' ))
glMultiTexCoord2dARB.add( Input( 't','GLdouble' ))
glMultiTexCoord2dARB.version = '1.2'
glMultiTexCoord2dARB.category = 'GL_ARB_multitexture'
glMultiTexCoord2dARB.trace = True
glMultiTexCoord2dARB.play = True
gl.add(glMultiTexCoord2dARB)

glMultiTexCoord2dvARB = Function('glMultiTexCoord2dvARB')
glMultiTexCoord2dvARB.ret = Return('void')
glMultiTexCoord2dvARB.add( Input( 'target','GLenum' ))
glMultiTexCoord2dvARB.add( Input( 'v','const GLdouble *' ,size = 2 ))
glMultiTexCoord2dvARB.version = '1.2'
glMultiTexCoord2dvARB.category = 'GL_ARB_multitexture'
glMultiTexCoord2dvARB.trace = True
glMultiTexCoord2dvARB.play = True
gl.add(glMultiTexCoord2dvARB)

glMultiTexCoord2fARB = Function('glMultiTexCoord2fARB')
glMultiTexCoord2fARB.ret = Return('void')
glMultiTexCoord2fARB.add( Input( 'target','GLenum' ))
glMultiTexCoord2fARB.add( Input( 's','GLfloat' ))
glMultiTexCoord2fARB.add( Input( 't','GLfloat' ))
glMultiTexCoord2fARB.version = '1.2'
glMultiTexCoord2fARB.category = 'GL_ARB_multitexture'
glMultiTexCoord2fARB.trace = True
glMultiTexCoord2fARB.play = True
gl.add(glMultiTexCoord2fARB)

glMultiTexCoord2fvARB = Function('glMultiTexCoord2fvARB')
glMultiTexCoord2fvARB.ret = Return('void')
glMultiTexCoord2fvARB.add( Input( 'target','GLenum' ))
glMultiTexCoord2fvARB.add( Input( 'v','const GLfloat *' ,size = 2 ))
glMultiTexCoord2fvARB.version = '1.2'
glMultiTexCoord2fvARB.category = 'GL_ARB_multitexture'
glMultiTexCoord2fvARB.trace = True
glMultiTexCoord2fvARB.play = True
gl.add(glMultiTexCoord2fvARB)

glMultiTexCoord2iARB = Function('glMultiTexCoord2iARB')
glMultiTexCoord2iARB.ret = Return('void')
glMultiTexCoord2iARB.add( Input( 'target','GLenum' ))
glMultiTexCoord2iARB.add( Input( 's','GLint' ))
glMultiTexCoord2iARB.add( Input( 't','GLint' ))
glMultiTexCoord2iARB.version = '1.2'
glMultiTexCoord2iARB.category = 'GL_ARB_multitexture'
glMultiTexCoord2iARB.trace = True
glMultiTexCoord2iARB.play = True
gl.add(glMultiTexCoord2iARB)

glMultiTexCoord2ivARB = Function('glMultiTexCoord2ivARB')
glMultiTexCoord2ivARB.ret = Return('void')
glMultiTexCoord2ivARB.add( Input( 'target','GLenum' ))
glMultiTexCoord2ivARB.add( Input( 'v','const GLint *' ,size = 2 ))
glMultiTexCoord2ivARB.version = '1.2'
glMultiTexCoord2ivARB.category = 'GL_ARB_multitexture'
glMultiTexCoord2ivARB.trace = True
glMultiTexCoord2ivARB.play = True
gl.add(glMultiTexCoord2ivARB)

glMultiTexCoord2sARB = Function('glMultiTexCoord2sARB')
glMultiTexCoord2sARB.ret = Return('void')
glMultiTexCoord2sARB.add( Input( 'target','GLenum' ))
glMultiTexCoord2sARB.add( Input( 's','GLshort' ))
glMultiTexCoord2sARB.add( Input( 't','GLshort' ))
glMultiTexCoord2sARB.version = '1.2'
glMultiTexCoord2sARB.category = 'GL_ARB_multitexture'
glMultiTexCoord2sARB.trace = True
glMultiTexCoord2sARB.play = True
gl.add(glMultiTexCoord2sARB)

glMultiTexCoord2svARB = Function('glMultiTexCoord2svARB')
glMultiTexCoord2svARB.ret = Return('void')
glMultiTexCoord2svARB.add( Input( 'target','GLenum' ))
glMultiTexCoord2svARB.add( Input( 'v','const GLshort *' ,size = 2 ))
glMultiTexCoord2svARB.version = '1.2'
glMultiTexCoord2svARB.category = 'GL_ARB_multitexture'
glMultiTexCoord2svARB.trace = True
glMultiTexCoord2svARB.play = True
gl.add(glMultiTexCoord2svARB)

glMultiTexCoord3dARB = Function('glMultiTexCoord3dARB')
glMultiTexCoord3dARB.ret = Return('void')
glMultiTexCoord3dARB.add( Input( 'target','GLenum' ))
glMultiTexCoord3dARB.add( Input( 's','GLdouble' ))
glMultiTexCoord3dARB.add( Input( 't','GLdouble' ))
glMultiTexCoord3dARB.add( Input( 'r','GLdouble' ))
glMultiTexCoord3dARB.version = '1.2'
glMultiTexCoord3dARB.category = 'GL_ARB_multitexture'
glMultiTexCoord3dARB.trace = True
glMultiTexCoord3dARB.play = True
gl.add(glMultiTexCoord3dARB)

glMultiTexCoord3dvARB = Function('glMultiTexCoord3dvARB')
glMultiTexCoord3dvARB.ret = Return('void')
glMultiTexCoord3dvARB.add( Input( 'target','GLenum' ))
glMultiTexCoord3dvARB.add( Input( 'v','const GLdouble *' ,size = 3 ))
glMultiTexCoord3dvARB.version = '1.2'
glMultiTexCoord3dvARB.category = 'GL_ARB_multitexture'
glMultiTexCoord3dvARB.trace = True
glMultiTexCoord3dvARB.play = True
gl.add(glMultiTexCoord3dvARB)

glMultiTexCoord3fARB = Function('glMultiTexCoord3fARB')
glMultiTexCoord3fARB.ret = Return('void')
glMultiTexCoord3fARB.add( Input( 'target','GLenum' ))
glMultiTexCoord3fARB.add( Input( 's','GLfloat' ))
glMultiTexCoord3fARB.add( Input( 't','GLfloat' ))
glMultiTexCoord3fARB.add( Input( 'r','GLfloat' ))
glMultiTexCoord3fARB.version = '1.2'
glMultiTexCoord3fARB.category = 'GL_ARB_multitexture'
glMultiTexCoord3fARB.trace = True
glMultiTexCoord3fARB.play = True
gl.add(glMultiTexCoord3fARB)

glMultiTexCoord3fvARB = Function('glMultiTexCoord3fvARB')
glMultiTexCoord3fvARB.ret = Return('void')
glMultiTexCoord3fvARB.add( Input( 'target','GLenum' ))
glMultiTexCoord3fvARB.add( Input( 'v','const GLfloat *' ,size = 3 ))
glMultiTexCoord3fvARB.version = '1.2'
glMultiTexCoord3fvARB.category = 'GL_ARB_multitexture'
glMultiTexCoord3fvARB.trace = True
glMultiTexCoord3fvARB.play = True
gl.add(glMultiTexCoord3fvARB)

glMultiTexCoord3iARB = Function('glMultiTexCoord3iARB')
glMultiTexCoord3iARB.ret = Return('void')
glMultiTexCoord3iARB.add( Input( 'target','GLenum' ))
glMultiTexCoord3iARB.add( Input( 's','GLint' ))
glMultiTexCoord3iARB.add( Input( 't','GLint' ))
glMultiTexCoord3iARB.add( Input( 'r','GLint' ))
glMultiTexCoord3iARB.version = '1.2'
glMultiTexCoord3iARB.category = 'GL_ARB_multitexture'
glMultiTexCoord3iARB.trace = True
glMultiTexCoord3iARB.play = True
gl.add(glMultiTexCoord3iARB)

glMultiTexCoord3ivARB = Function('glMultiTexCoord3ivARB')
glMultiTexCoord3ivARB.ret = Return('void')
glMultiTexCoord3ivARB.add( Input( 'target','GLenum' ))
glMultiTexCoord3ivARB.add( Input( 'v','const GLint *' ,size = 3 ))
glMultiTexCoord3ivARB.version = '1.2'
glMultiTexCoord3ivARB.category = 'GL_ARB_multitexture'
glMultiTexCoord3ivARB.trace = True
glMultiTexCoord3ivARB.play = True
gl.add(glMultiTexCoord3ivARB)

glMultiTexCoord3sARB = Function('glMultiTexCoord3sARB')
glMultiTexCoord3sARB.ret = Return('void')
glMultiTexCoord3sARB.add( Input( 'target','GLenum' ))
glMultiTexCoord3sARB.add( Input( 's','GLshort' ))
glMultiTexCoord3sARB.add( Input( 't','GLshort' ))
glMultiTexCoord3sARB.add( Input( 'r','GLshort' ))
glMultiTexCoord3sARB.version = '1.2'
glMultiTexCoord3sARB.category = 'GL_ARB_multitexture'
glMultiTexCoord3sARB.trace = True
glMultiTexCoord3sARB.play = True
gl.add(glMultiTexCoord3sARB)

glMultiTexCoord3svARB = Function('glMultiTexCoord3svARB')
glMultiTexCoord3svARB.ret = Return('void')
glMultiTexCoord3svARB.add( Input( 'target','GLenum' ))
glMultiTexCoord3svARB.add( Input( 'v','const GLshort *' ,size = 3 ))
glMultiTexCoord3svARB.version = '1.2'
glMultiTexCoord3svARB.category = 'GL_ARB_multitexture'
glMultiTexCoord3svARB.trace = True
glMultiTexCoord3svARB.play = True
gl.add(glMultiTexCoord3svARB)

glMultiTexCoord4dARB = Function('glMultiTexCoord4dARB')
glMultiTexCoord4dARB.ret = Return('void')
glMultiTexCoord4dARB.add( Input( 'target','GLenum' ))
glMultiTexCoord4dARB.add( Input( 's','GLdouble' ))
glMultiTexCoord4dARB.add( Input( 't','GLdouble' ))
glMultiTexCoord4dARB.add( Input( 'r','GLdouble' ))
glMultiTexCoord4dARB.add( Input( 'q','GLdouble' ))
glMultiTexCoord4dARB.version = '1.2'
glMultiTexCoord4dARB.category = 'GL_ARB_multitexture'
glMultiTexCoord4dARB.trace = True
glMultiTexCoord4dARB.play = True
gl.add(glMultiTexCoord4dARB)

glMultiTexCoord4dvARB = Function('glMultiTexCoord4dvARB')
glMultiTexCoord4dvARB.ret = Return('void')
glMultiTexCoord4dvARB.add( Input( 'target','GLenum' ))
glMultiTexCoord4dvARB.add( Input( 'v','const GLdouble *' ,size = 4 ))
glMultiTexCoord4dvARB.version = '1.2'
glMultiTexCoord4dvARB.category = 'GL_ARB_multitexture'
glMultiTexCoord4dvARB.trace = True
glMultiTexCoord4dvARB.play = True
gl.add(glMultiTexCoord4dvARB)

glMultiTexCoord4fARB = Function('glMultiTexCoord4fARB')
glMultiTexCoord4fARB.ret = Return('void')
glMultiTexCoord4fARB.add( Input( 'target','GLenum' ))
glMultiTexCoord4fARB.add( Input( 's','GLfloat' ))
glMultiTexCoord4fARB.add( Input( 't','GLfloat' ))
glMultiTexCoord4fARB.add( Input( 'r','GLfloat' ))
glMultiTexCoord4fARB.add( Input( 'q','GLfloat' ))
glMultiTexCoord4fARB.version = '1.2'
glMultiTexCoord4fARB.category = 'GL_ARB_multitexture'
glMultiTexCoord4fARB.trace = True
glMultiTexCoord4fARB.play = True
gl.add(glMultiTexCoord4fARB)

glMultiTexCoord4fvARB = Function('glMultiTexCoord4fvARB')
glMultiTexCoord4fvARB.ret = Return('void')
glMultiTexCoord4fvARB.add( Input( 'target','GLenum' ))
glMultiTexCoord4fvARB.add( Input( 'v','const GLfloat *' ,size = 4 ))
glMultiTexCoord4fvARB.version = '1.2'
glMultiTexCoord4fvARB.category = 'GL_ARB_multitexture'
glMultiTexCoord4fvARB.trace = True
glMultiTexCoord4fvARB.play = True
gl.add(glMultiTexCoord4fvARB)

glMultiTexCoord4iARB = Function('glMultiTexCoord4iARB')
glMultiTexCoord4iARB.ret = Return('void')
glMultiTexCoord4iARB.add( Input( 'target','GLenum' ))
glMultiTexCoord4iARB.add( Input( 's','GLint' ))
glMultiTexCoord4iARB.add( Input( 't','GLint' ))
glMultiTexCoord4iARB.add( Input( 'r','GLint' ))
glMultiTexCoord4iARB.add( Input( 'q','GLint' ))
glMultiTexCoord4iARB.version = '1.2'
glMultiTexCoord4iARB.category = 'GL_ARB_multitexture'
glMultiTexCoord4iARB.trace = True
glMultiTexCoord4iARB.play = True
gl.add(glMultiTexCoord4iARB)

glMultiTexCoord4ivARB = Function('glMultiTexCoord4ivARB')
glMultiTexCoord4ivARB.ret = Return('void')
glMultiTexCoord4ivARB.add( Input( 'target','GLenum' ))
glMultiTexCoord4ivARB.add( Input( 'v','const GLint *' ,size = 4 ))
glMultiTexCoord4ivARB.version = '1.2'
glMultiTexCoord4ivARB.category = 'GL_ARB_multitexture'
glMultiTexCoord4ivARB.trace = True
glMultiTexCoord4ivARB.play = True
gl.add(glMultiTexCoord4ivARB)

glMultiTexCoord4sARB = Function('glMultiTexCoord4sARB')
glMultiTexCoord4sARB.ret = Return('void')
glMultiTexCoord4sARB.add( Input( 'target','GLenum' ))
glMultiTexCoord4sARB.add( Input( 's','GLshort' ))
glMultiTexCoord4sARB.add( Input( 't','GLshort' ))
glMultiTexCoord4sARB.add( Input( 'r','GLshort' ))
glMultiTexCoord4sARB.add( Input( 'q','GLshort' ))
glMultiTexCoord4sARB.version = '1.2'
glMultiTexCoord4sARB.category = 'GL_ARB_multitexture'
glMultiTexCoord4sARB.trace = True
glMultiTexCoord4sARB.play = True
gl.add(glMultiTexCoord4sARB)

glMultiTexCoord4svARB = Function('glMultiTexCoord4svARB')
glMultiTexCoord4svARB.ret = Return('void')
glMultiTexCoord4svARB.add( Input( 'target','GLenum' ))
glMultiTexCoord4svARB.add( Input( 'v','const GLshort *' ,size = 4 ))
glMultiTexCoord4svARB.version = '1.2'
glMultiTexCoord4svARB.category = 'GL_ARB_multitexture'
glMultiTexCoord4svARB.trace = True
glMultiTexCoord4svARB.play = True
gl.add(glMultiTexCoord4svARB)

# GL_ARB_occlusion_query

glBeginQueryARB = Function('glBeginQueryARB')
glBeginQueryARB.ret = Return('void')
glBeginQueryARB.add( Input( 'target','GLenum' ))
glBeginQueryARB.add( Input( 'id','GLuint' ))
glBeginQueryARB.version = '1.2'
glBeginQueryARB.category = 'GL_ARB_occlusion_query'
glBeginQueryARB.trace = True
glBeginQueryARB.play = True
gl.add(glBeginQueryARB)

glDeleteQueriesARB = Function('glDeleteQueriesARB')
glDeleteQueriesARB.ret = Return('void')
glDeleteQueriesARB.add( Input( 'n','GLsizei' ))
glDeleteQueriesARB.add( Input( 'ids','const GLuint *' ,size = 'n' ))
glDeleteQueriesARB.version = '1.2'
glDeleteQueriesARB.category = 'GL_ARB_occlusion_query'
glDeleteQueriesARB.trace = True
glDeleteQueriesARB.play = True
gl.add(glDeleteQueriesARB)

glEndQueryARB = Function('glEndQueryARB')
glEndQueryARB.ret = Return('void')
glEndQueryARB.add( Input( 'target','GLenum' ))
glEndQueryARB.version = '1.2'
glEndQueryARB.category = 'GL_ARB_occlusion_query'
glEndQueryARB.trace = True
glEndQueryARB.play = True
gl.add(glEndQueryARB)

glGenQueriesARB = Function('glGenQueriesARB')
glGenQueriesARB.ret = Return('void')
glGenQueriesARB.add( Input( 'n','GLsizei' ))
glGenQueriesARB.add( Output( 'ids','GLuint *' ,size = 'n' ))
glGenQueriesARB.version = '1.2'
glGenQueriesARB.category = 'GL_ARB_occlusion_query'
glGenQueriesARB.trace = True
glGenQueriesARB.play = True
gl.add(glGenQueriesARB)

glGetQueryObjectivARB = Function('glGetQueryObjectivARB')
glGetQueryObjectivARB.ret = Return('void')
glGetQueryObjectivARB.add( Input( 'id','GLuint' ))
glGetQueryObjectivARB.add( Input( 'pname','GLenum' ))
glGetQueryObjectivARB.add( Output( 'params','GLint *' ))
glGetQueryObjectivARB.version = '1.2'
glGetQueryObjectivARB.category = 'GL_ARB_occlusion_query'
glGetQueryObjectivARB.trace = True
glGetQueryObjectivARB.play = False
gl.add(glGetQueryObjectivARB)

glGetQueryObjectuivARB = Function('glGetQueryObjectuivARB')
glGetQueryObjectuivARB.ret = Return('void')
glGetQueryObjectuivARB.add( Input( 'id','GLuint' ))
glGetQueryObjectuivARB.add( Input( 'pname','GLenum' ))
glGetQueryObjectuivARB.add( Output( 'params','GLuint *' ))
glGetQueryObjectuivARB.version = '1.2'
glGetQueryObjectuivARB.category = 'GL_ARB_occlusion_query'
glGetQueryObjectuivARB.trace = True
glGetQueryObjectuivARB.play = False
gl.add(glGetQueryObjectuivARB)

glGetQueryivARB = Function('glGetQueryivARB')
glGetQueryivARB.ret = Return('void')
glGetQueryivARB.add( Input( 'target','GLenum' ))
glGetQueryivARB.add( Input( 'pname','GLenum' ))
glGetQueryivARB.add( Output( 'params','GLint *' ))
glGetQueryivARB.version = '1.2'
glGetQueryivARB.category = 'GL_ARB_occlusion_query'
glGetQueryivARB.trace = True
glGetQueryivARB.play = False
gl.add(glGetQueryivARB)

glIsQueryARB = Function('glIsQueryARB')
glIsQueryARB.ret = Return('GLboolean')
glIsQueryARB.add( Input( 'id','GLuint' ))
glIsQueryARB.version = '1.2'
glIsQueryARB.category = 'GL_ARB_occlusion_query'
glIsQueryARB.trace = True
glIsQueryARB.play = True
gl.add(glIsQueryARB)

# GL_ARB_point_parameters

glPointParameterfARB = Function('glPointParameterfARB')
glPointParameterfARB.ret = Return('void')
glPointParameterfARB.add( Input( 'pname','GLenum' ))
glPointParameterfARB.add( Input( 'param','GLfloat' ))
glPointParameterfARB.version = '1.1'
glPointParameterfARB.category = 'GL_ARB_point_parameters'
glPointParameterfARB.trace = True
glPointParameterfARB.play = True
gl.add(glPointParameterfARB)

glPointParameterfvARB = Function('glPointParameterfvARB')
glPointParameterfvARB.ret = Return('void')
glPointParameterfvARB.add( Input( 'pname','GLenum' ))
glPointParameterfvARB.add( Input( 'params','const GLfloat *' ))
glPointParameterfvARB.version = '1.1'
glPointParameterfvARB.category = 'GL_ARB_point_parameters'
glPointParameterfvARB.trace = True
glPointParameterfvARB.play = True
gl.add(glPointParameterfvARB)

# GL_ARB_program_interface_query

glGetProgramInterfaceiv = Function('glGetProgramInterfaceiv')
glGetProgramInterfaceiv.ret = Return('void')
glGetProgramInterfaceiv.add( Input( 'program','GLuint' ))
glGetProgramInterfaceiv.add( Input( 'programInterface','GLenum' ))
glGetProgramInterfaceiv.add( Input( 'pname','GLenum' ))
glGetProgramInterfaceiv.add( Input( 'params','GLint *' ))
glGetProgramInterfaceiv.version = ''
glGetProgramInterfaceiv.category = 'GL_ARB_program_interface_query'
glGetProgramInterfaceiv.trace = True
glGetProgramInterfaceiv.play = True
gl.add(glGetProgramInterfaceiv)

glGetProgramResourceIndex = Function('glGetProgramResourceIndex')
glGetProgramResourceIndex.ret = Return('GLuint')
glGetProgramResourceIndex.add( Input( 'program','GLuint' ))
glGetProgramResourceIndex.add( Input( 'programInterface','GLenum' ))
glGetProgramResourceIndex.add( Input( 'name','const GLchar *' ))
glGetProgramResourceIndex.version = ''
glGetProgramResourceIndex.category = 'GL_ARB_program_interface_query'
glGetProgramResourceIndex.trace = True
glGetProgramResourceIndex.play = True
gl.add(glGetProgramResourceIndex)

glGetProgramResourceLocation = Function('glGetProgramResourceLocation')
glGetProgramResourceLocation.ret = Return('GLint')
glGetProgramResourceLocation.add( Input( 'program','GLuint' ))
glGetProgramResourceLocation.add( Input( 'programInterface','GLenum' ))
glGetProgramResourceLocation.add( Input( 'name','const GLchar *' ))
glGetProgramResourceLocation.version = ''
glGetProgramResourceLocation.category = 'GL_ARB_program_interface_query'
glGetProgramResourceLocation.trace = True
glGetProgramResourceLocation.play = True
gl.add(glGetProgramResourceLocation)

glGetProgramResourceLocationIndex = Function('glGetProgramResourceLocationIndex')
glGetProgramResourceLocationIndex.ret = Return('GLint')
glGetProgramResourceLocationIndex.add( Input( 'program','GLuint' ))
glGetProgramResourceLocationIndex.add( Input( 'programInterface','GLenum' ))
glGetProgramResourceLocationIndex.add( Input( 'name','const GLchar *' ))
glGetProgramResourceLocationIndex.version = ''
glGetProgramResourceLocationIndex.category = 'GL_ARB_program_interface_query'
glGetProgramResourceLocationIndex.trace = True
glGetProgramResourceLocationIndex.play = True
gl.add(glGetProgramResourceLocationIndex)

glGetProgramResourceName = Function('glGetProgramResourceName')
glGetProgramResourceName.ret = Return('void')
glGetProgramResourceName.add( Input( 'program','GLuint' ))
glGetProgramResourceName.add( Input( 'programInterface','GLenum' ))
glGetProgramResourceName.add( Input( 'index','GLuint' ))
glGetProgramResourceName.add( Input( 'bufSize','GLsizei' ))
glGetProgramResourceName.add( Input( 'length','GLsizei *' ))
glGetProgramResourceName.add( Input( 'name','GLchar *' ))
glGetProgramResourceName.version = ''
glGetProgramResourceName.category = 'GL_ARB_program_interface_query'
glGetProgramResourceName.trace = True
glGetProgramResourceName.play = True
gl.add(glGetProgramResourceName)

glGetProgramResourceiv = Function('glGetProgramResourceiv')
glGetProgramResourceiv.ret = Return('void')
glGetProgramResourceiv.add( Input( 'program','GLuint' ))
glGetProgramResourceiv.add( Input( 'programInterface','GLenum' ))
glGetProgramResourceiv.add( Input( 'index','GLuint' ))
glGetProgramResourceiv.add( Input( 'propCount','GLsizei' ))
glGetProgramResourceiv.add( Input( 'props','const GLenum *' ))
glGetProgramResourceiv.add( Input( 'bufSize','GLsizei' ))
glGetProgramResourceiv.add( Input( 'length','GLsizei *' ))
glGetProgramResourceiv.add( Input( 'params','GLint *' ))
glGetProgramResourceiv.version = ''
glGetProgramResourceiv.category = 'GL_ARB_program_interface_query'
glGetProgramResourceiv.trace = True
glGetProgramResourceiv.play = True
gl.add(glGetProgramResourceiv)

# GL_ARB_provoking_vertex

glProvokingVertex = Function('glProvokingVertex')
glProvokingVertex.ret = Return('void')
glProvokingVertex.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glProvokingVertex.version = '3.2'
glProvokingVertex.category = 'GL_ARB_provoking_vertex'
glProvokingVertex.trace = True
glProvokingVertex.play = True
gl.add(glProvokingVertex)

# GL_ARB_robustness

glGetGraphicsResetStatusARB = Function('glGetGraphicsResetStatusARB')
glGetGraphicsResetStatusARB.ret = Return('GLenum')
glGetGraphicsResetStatusARB.version = '4.1'
glGetGraphicsResetStatusARB.category = 'GL_ARB_robustness'
glGetGraphicsResetStatusARB.trace = True
glGetGraphicsResetStatusARB.play = True
gl.add(glGetGraphicsResetStatusARB)

glGetnColorTableARB = Function('glGetnColorTableARB')
glGetnColorTableARB.ret = Return('void')
glGetnColorTableARB.add( Input( 'target','GLenum' ))
glGetnColorTableARB.add( Input( 'format','GLenum' ))
glGetnColorTableARB.add( Input( 'type','GLenum' ))
glGetnColorTableARB.add( Input( 'bufSize','GLsizei' ))
glGetnColorTableARB.add( Output( 'table','GLvoid *' ))
glGetnColorTableARB.version = '4.1'
glGetnColorTableARB.category = 'GL_ARB_robustness'
glGetnColorTableARB.trace = True
glGetnColorTableARB.play = True
gl.add(glGetnColorTableARB)

glGetnCompressedTexImageARB = Function('glGetnCompressedTexImageARB')
glGetnCompressedTexImageARB.ret = Return('void')
glGetnCompressedTexImageARB.add( Input( 'target','GLenum' ))
glGetnCompressedTexImageARB.add( Input( 'lod','GLint' ))
glGetnCompressedTexImageARB.add( Input( 'bufSize','GLsizei' ))
glGetnCompressedTexImageARB.add( Output( 'img','GLvoid *' ))
glGetnCompressedTexImageARB.version = '4.1'
glGetnCompressedTexImageARB.category = 'GL_ARB_robustness'
glGetnCompressedTexImageARB.trace = True
glGetnCompressedTexImageARB.play = True
gl.add(glGetnCompressedTexImageARB)

glGetnConvolutionFilterARB = Function('glGetnConvolutionFilterARB')
glGetnConvolutionFilterARB.ret = Return('void')
glGetnConvolutionFilterARB.add( Input( 'target','GLenum' ))
glGetnConvolutionFilterARB.add( Input( 'format','GLenum' ))
glGetnConvolutionFilterARB.add( Input( 'type','GLenum' ))
glGetnConvolutionFilterARB.add( Input( 'bufSize','GLsizei' ))
glGetnConvolutionFilterARB.add( Output( 'image','GLvoid *' ))
glGetnConvolutionFilterARB.version = '4.1'
glGetnConvolutionFilterARB.category = 'GL_ARB_robustness'
glGetnConvolutionFilterARB.trace = True
glGetnConvolutionFilterARB.play = True
gl.add(glGetnConvolutionFilterARB)

glGetnHistogramARB = Function('glGetnHistogramARB')
glGetnHistogramARB.ret = Return('void')
glGetnHistogramARB.add( Input( 'target','GLenum' ))
glGetnHistogramARB.add( Input( 'reset','GLboolean' ))
glGetnHistogramARB.add( Input( 'format','GLenum' ))
glGetnHistogramARB.add( Input( 'type','GLenum' ))
glGetnHistogramARB.add( Input( 'bufSize','GLsizei' ))
glGetnHistogramARB.add( Output( 'values','GLvoid *' ))
glGetnHistogramARB.version = '4.1'
glGetnHistogramARB.category = 'GL_ARB_robustness'
glGetnHistogramARB.trace = True
glGetnHistogramARB.play = True
gl.add(glGetnHistogramARB)

glGetnMapdvARB = Function('glGetnMapdvARB')
glGetnMapdvARB.ret = Return('void')
glGetnMapdvARB.add( Input( 'target','GLenum' ))
glGetnMapdvARB.add( Input( 'query','GLenum' ))
glGetnMapdvARB.add( Input( 'bufSize','GLsizei' ))
glGetnMapdvARB.add( Output( 'v','GLdouble *' ))
glGetnMapdvARB.version = '4.1'
glGetnMapdvARB.category = 'GL_ARB_robustness'
glGetnMapdvARB.trace = True
glGetnMapdvARB.play = True
gl.add(glGetnMapdvARB)

glGetnMapfvARB = Function('glGetnMapfvARB')
glGetnMapfvARB.ret = Return('void')
glGetnMapfvARB.add( Input( 'target','GLenum' ))
glGetnMapfvARB.add( Input( 'query','GLenum' ))
glGetnMapfvARB.add( Input( 'bufSize','GLsizei' ))
glGetnMapfvARB.add( Output( 'v','GLfloat *' ))
glGetnMapfvARB.version = '4.1'
glGetnMapfvARB.category = 'GL_ARB_robustness'
glGetnMapfvARB.trace = True
glGetnMapfvARB.play = True
gl.add(glGetnMapfvARB)

glGetnMapivARB = Function('glGetnMapivARB')
glGetnMapivARB.ret = Return('void')
glGetnMapivARB.add( Input( 'target','GLenum' ))
glGetnMapivARB.add( Input( 'query','GLenum' ))
glGetnMapivARB.add( Input( 'bufSize','GLsizei' ))
glGetnMapivARB.add( Output( 'v','GLint *' ))
glGetnMapivARB.version = '4.1'
glGetnMapivARB.category = 'GL_ARB_robustness'
glGetnMapivARB.trace = True
glGetnMapivARB.play = True
gl.add(glGetnMapivARB)

glGetnMinmaxARB = Function('glGetnMinmaxARB')
glGetnMinmaxARB.ret = Return('void')
glGetnMinmaxARB.add( Input( 'target','GLenum' ))
glGetnMinmaxARB.add( Input( 'reset','GLboolean' ))
glGetnMinmaxARB.add( Input( 'format','GLenum' ))
glGetnMinmaxARB.add( Input( 'type','GLenum' ))
glGetnMinmaxARB.add( Input( 'bufSize','GLsizei' ))
glGetnMinmaxARB.add( Output( 'values','GLvoid *' ))
glGetnMinmaxARB.version = '4.1'
glGetnMinmaxARB.category = 'GL_ARB_robustness'
glGetnMinmaxARB.trace = True
glGetnMinmaxARB.play = True
gl.add(glGetnMinmaxARB)

glGetnPixelMapfvARB = Function('glGetnPixelMapfvARB')
glGetnPixelMapfvARB.ret = Return('void')
glGetnPixelMapfvARB.add( Input( 'map','GLenum' ))
glGetnPixelMapfvARB.add( Input( 'bufSize','GLsizei' ))
glGetnPixelMapfvARB.add( Output( 'values','GLfloat *' ))
glGetnPixelMapfvARB.version = '4.1'
glGetnPixelMapfvARB.category = 'GL_ARB_robustness'
glGetnPixelMapfvARB.trace = True
glGetnPixelMapfvARB.play = True
gl.add(glGetnPixelMapfvARB)

glGetnPixelMapuivARB = Function('glGetnPixelMapuivARB')
glGetnPixelMapuivARB.ret = Return('void')
glGetnPixelMapuivARB.add( Input( 'map','GLenum' ))
glGetnPixelMapuivARB.add( Input( 'bufSize','GLsizei' ))
glGetnPixelMapuivARB.add( Output( 'values','GLuint *' ))
glGetnPixelMapuivARB.version = '4.1'
glGetnPixelMapuivARB.category = 'GL_ARB_robustness'
glGetnPixelMapuivARB.trace = True
glGetnPixelMapuivARB.play = True
gl.add(glGetnPixelMapuivARB)

glGetnPixelMapusvARB = Function('glGetnPixelMapusvARB')
glGetnPixelMapusvARB.ret = Return('void')
glGetnPixelMapusvARB.add( Input( 'map','GLenum' ))
glGetnPixelMapusvARB.add( Input( 'bufSize','GLsizei' ))
glGetnPixelMapusvARB.add( Output( 'values','GLushort *' ))
glGetnPixelMapusvARB.version = '4.1'
glGetnPixelMapusvARB.category = 'GL_ARB_robustness'
glGetnPixelMapusvARB.trace = True
glGetnPixelMapusvARB.play = True
gl.add(glGetnPixelMapusvARB)

glGetnPolygonStippleARB = Function('glGetnPolygonStippleARB')
glGetnPolygonStippleARB.ret = Return('void')
glGetnPolygonStippleARB.add( Input( 'bufSize','GLsizei' ))
glGetnPolygonStippleARB.add( Output( 'pattern','GLubyte *' ))
glGetnPolygonStippleARB.version = '4.1'
glGetnPolygonStippleARB.category = 'GL_ARB_robustness'
glGetnPolygonStippleARB.trace = True
glGetnPolygonStippleARB.play = False
gl.add(glGetnPolygonStippleARB)

glGetnSeparableFilterARB = Function('glGetnSeparableFilterARB')
glGetnSeparableFilterARB.ret = Return('void')
glGetnSeparableFilterARB.add( Input( 'target','GLenum' ))
glGetnSeparableFilterARB.add( Input( 'format','GLenum' ))
glGetnSeparableFilterARB.add( Input( 'type','GLenum' ))
glGetnSeparableFilterARB.add( Input( 'rowBufSize','GLsizei' ))
glGetnSeparableFilterARB.add( Output( 'row','GLvoid *' ))
glGetnSeparableFilterARB.add( Input( 'columnBufSize','GLsizei' ))
glGetnSeparableFilterARB.add( Output( 'column','GLvoid *' ))
glGetnSeparableFilterARB.add( Input( 'span','GLvoid *' ))
glGetnSeparableFilterARB.version = '4.1'
glGetnSeparableFilterARB.category = 'GL_ARB_robustness'
glGetnSeparableFilterARB.trace = True
glGetnSeparableFilterARB.play = True
gl.add(glGetnSeparableFilterARB)

glGetnTexImageARB = Function('glGetnTexImageARB')
glGetnTexImageARB.ret = Return('void')
glGetnTexImageARB.add( Input( 'target','GLenum' ))
glGetnTexImageARB.add( Input( 'level','GLint' ))
glGetnTexImageARB.add( Input( 'format','GLenum' ))
glGetnTexImageARB.add( Input( 'type','GLenum' ))
glGetnTexImageARB.add( Input( 'bufSize','GLsizei' ))
glGetnTexImageARB.add( Output( 'img','GLvoid *' ))
glGetnTexImageARB.version = '4.1'
glGetnTexImageARB.category = 'GL_ARB_robustness'
glGetnTexImageARB.trace = True
glGetnTexImageARB.play = True
gl.add(glGetnTexImageARB)

glGetnUniformdvARB = Function('glGetnUniformdvARB')
glGetnUniformdvARB.ret = Return('void')
glGetnUniformdvARB.add( Input( 'program','GLuint' ))
glGetnUniformdvARB.add( Input( 'location','GLint' ))
glGetnUniformdvARB.add( Input( 'bufSize','GLsizei' ))
glGetnUniformdvARB.add( Output( 'params','GLdouble *' ))
glGetnUniformdvARB.version = '4.1'
glGetnUniformdvARB.category = 'GL_ARB_robustness'
glGetnUniformdvARB.trace = True
glGetnUniformdvARB.play = True
gl.add(glGetnUniformdvARB)

glGetnUniformfvARB = Function('glGetnUniformfvARB')
glGetnUniformfvARB.ret = Return('void')
glGetnUniformfvARB.add( Input( 'program','GLuint' ))
glGetnUniformfvARB.add( Input( 'location','GLint' ))
glGetnUniformfvARB.add( Input( 'bufSize','GLsizei' ))
glGetnUniformfvARB.add( Output( 'params','GLfloat *' ))
glGetnUniformfvARB.version = '4.1'
glGetnUniformfvARB.category = 'GL_ARB_robustness'
glGetnUniformfvARB.trace = True
glGetnUniformfvARB.play = True
gl.add(glGetnUniformfvARB)

glGetnUniformivARB = Function('glGetnUniformivARB')
glGetnUniformivARB.ret = Return('void')
glGetnUniformivARB.add( Input( 'program','GLuint' ))
glGetnUniformivARB.add( Input( 'location','GLint' ))
glGetnUniformivARB.add( Input( 'bufSize','GLsizei' ))
glGetnUniformivARB.add( Output( 'params','GLint *' ))
glGetnUniformivARB.version = '4.1'
glGetnUniformivARB.category = 'GL_ARB_robustness'
glGetnUniformivARB.trace = True
glGetnUniformivARB.play = True
gl.add(glGetnUniformivARB)

glGetnUniformuivARB = Function('glGetnUniformuivARB')
glGetnUniformuivARB.ret = Return('void')
glGetnUniformuivARB.add( Input( 'program','GLuint' ))
glGetnUniformuivARB.add( Input( 'location','GLint' ))
glGetnUniformuivARB.add( Input( 'bufSize','GLsizei' ))
glGetnUniformuivARB.add( Output( 'params','GLuint *' ))
glGetnUniformuivARB.version = '4.1'
glGetnUniformuivARB.category = 'GL_ARB_robustness'
glGetnUniformuivARB.trace = True
glGetnUniformuivARB.play = True
gl.add(glGetnUniformuivARB)

glReadnPixelsARB = Function('glReadnPixelsARB')
glReadnPixelsARB.ret = Return('void')
glReadnPixelsARB.add( Input( 'x','GLint' ))
glReadnPixelsARB.add( Input( 'y','GLint' ))
glReadnPixelsARB.add( Input( 'width','GLsizei' ))
glReadnPixelsARB.add( Input( 'height','GLsizei' ))
glReadnPixelsARB.add( Input( 'format','GLenum' ))
glReadnPixelsARB.add( Input( 'type','GLenum' ))
glReadnPixelsARB.add( Input( 'bufSize','GLsizei' ))
glReadnPixelsARB.add( Output( 'data','GLvoid *' ))
glReadnPixelsARB.version = '4.1'
glReadnPixelsARB.category = 'GL_ARB_robustness'
glReadnPixelsARB.trace = True
glReadnPixelsARB.play = True
gl.add(glReadnPixelsARB)

# GL_ARB_sample_shading

glMinSampleShading = Function('glMinSampleShading')
glMinSampleShading.ret = Return('void')
glMinSampleShading.add( Input( 'value','GLclampf' ))
glMinSampleShading.version = '4.0'
glMinSampleShading.category = 'GL_ARB_sample_shading'
glMinSampleShading.trace = True
glMinSampleShading.play = True
gl.add(glMinSampleShading)

glMinSampleShadingARB = Function('glMinSampleShadingARB')
glMinSampleShadingARB.ret = Return('void')
glMinSampleShadingARB.add( Input( 'value','GLclampf' ))
glMinSampleShadingARB.version = '2.0'
glMinSampleShadingARB.category = 'GL_ARB_sample_shading'
glMinSampleShadingARB.trace = True
glMinSampleShadingARB.play = True
gl.add(glMinSampleShadingARB)

# GL_ARB_sampler_objects

glBindSampler = Function('glBindSampler')
glBindSampler.ret = Return('void')
glBindSampler.add( Input( 'unit','GLuint' ))
glBindSampler.add( Input( 'sampler','GLuint' ))
glBindSampler.version = '3.3'
glBindSampler.category = 'GL_ARB_sampler_objects'
glBindSampler.trace = True
glBindSampler.play = True
gl.add(glBindSampler)

glDeleteSamplers = Function('glDeleteSamplers')
glDeleteSamplers.ret = Return('void')
glDeleteSamplers.add( Input( 'count','GLsizei' ))
glDeleteSamplers.add( Input( 'samplers','const GLuint *' ,size = 'count' ))
glDeleteSamplers.version = '3.3'
glDeleteSamplers.category = 'GL_ARB_sampler_objects'
glDeleteSamplers.trace = True
glDeleteSamplers.play = True
gl.add(glDeleteSamplers)

glGenSamplers = Function('glGenSamplers')
glGenSamplers.ret = Return('void')
glGenSamplers.add( Input( 'count','GLsizei' ))
glGenSamplers.add( Output( 'samplers','GLuint *' ,size = 'count' ))
glGenSamplers.version = '3.3'
glGenSamplers.category = 'GL_ARB_sampler_objects'
glGenSamplers.trace = True
glGenSamplers.play = True
gl.add(glGenSamplers)

glGetSamplerParameterIiv = Function('glGetSamplerParameterIiv')
glGetSamplerParameterIiv.ret = Return('void')
glGetSamplerParameterIiv.add( Input( 'sampler','GLuint' ))
glGetSamplerParameterIiv.add( Input( 'pname','GLenum' ))
glGetSamplerParameterIiv.add( Output( 'params','GLint *' ,size = 'helperGLSamplerParametervSize(pname)' ))
glGetSamplerParameterIiv.version = '3.3'
glGetSamplerParameterIiv.category = 'GL_ARB_sampler_objects'
glGetSamplerParameterIiv.trace = True
glGetSamplerParameterIiv.play = True
gl.add(glGetSamplerParameterIiv)

glGetSamplerParameterIuiv = Function('glGetSamplerParameterIuiv')
glGetSamplerParameterIuiv.ret = Return('void')
glGetSamplerParameterIuiv.add( Input( 'sampler','GLuint' ))
glGetSamplerParameterIuiv.add( Input( 'pname','GLenum' ))
glGetSamplerParameterIuiv.add( Output( 'params','GLuint *' ,size = 'helperGLSamplerParametervSize(pname)' ))
glGetSamplerParameterIuiv.version = '3.3'
glGetSamplerParameterIuiv.category = 'GL_ARB_sampler_objects'
glGetSamplerParameterIuiv.trace = True
glGetSamplerParameterIuiv.play = True
gl.add(glGetSamplerParameterIuiv)

glGetSamplerParameterfv = Function('glGetSamplerParameterfv')
glGetSamplerParameterfv.ret = Return('void')
glGetSamplerParameterfv.add( Input( 'sampler','GLuint' ))
glGetSamplerParameterfv.add( Input( 'pname','GLenum' ))
glGetSamplerParameterfv.add( Output( 'params','GLfloat *' ,size = 'helperGLSamplerParametervSize(pname)' ))
glGetSamplerParameterfv.version = '3.3'
glGetSamplerParameterfv.category = 'GL_ARB_sampler_objects'
glGetSamplerParameterfv.trace = True
glGetSamplerParameterfv.play = True
gl.add(glGetSamplerParameterfv)

glGetSamplerParameteriv = Function('glGetSamplerParameteriv')
glGetSamplerParameteriv.ret = Return('void')
glGetSamplerParameteriv.add( Input( 'sampler','GLuint' ))
glGetSamplerParameteriv.add( Input( 'pname','GLenum' ))
glGetSamplerParameteriv.add( Output( 'params','GLint *' ,size = 'helperGLSamplerParametervSize(pname)' ))
glGetSamplerParameteriv.version = '3.3'
glGetSamplerParameteriv.category = 'GL_ARB_sampler_objects'
glGetSamplerParameteriv.trace = True
glGetSamplerParameteriv.play = True
gl.add(glGetSamplerParameteriv)

glIsSampler = Function('glIsSampler')
glIsSampler.ret = Return('GLboolean')
glIsSampler.add( Input( 'sampler','GLuint' ))
glIsSampler.version = '3.3'
glIsSampler.category = 'GL_ARB_sampler_objects'
glIsSampler.trace = True
glIsSampler.play = True
gl.add(glIsSampler)

glSamplerParameterIiv = Function('glSamplerParameterIiv')
glSamplerParameterIiv.ret = Return('void')
glSamplerParameterIiv.add( Input( 'sampler','GLuint' ))
glSamplerParameterIiv.add( Input( 'pname','GLenum' ))
glSamplerParameterIiv.add( Input( 'params','const GLint *' ,size = 'helperGLSamplerParametervSize(pname)' ,regalLog = 'GLTexParameterToString(pname,params)' ))
glSamplerParameterIiv.version = '3.3'
glSamplerParameterIiv.category = 'GL_ARB_sampler_objects'
glSamplerParameterIiv.trace = True
glSamplerParameterIiv.play = True
gl.add(glSamplerParameterIiv)

glSamplerParameterIuiv = Function('glSamplerParameterIuiv')
glSamplerParameterIuiv.ret = Return('void')
glSamplerParameterIuiv.add( Input( 'sampler','GLuint' ))
glSamplerParameterIuiv.add( Input( 'pname','GLenum' ))
glSamplerParameterIuiv.add( Input( 'params','const GLuint *' ,size = 'helperGLSamplerParametervSize(pname)' ,regalLog = 'GLTexParameterToString(pname,params)' ))
glSamplerParameterIuiv.version = '3.3'
glSamplerParameterIuiv.category = 'GL_ARB_sampler_objects'
glSamplerParameterIuiv.trace = True
glSamplerParameterIuiv.play = True
gl.add(glSamplerParameterIuiv)

glSamplerParameterf = Function('glSamplerParameterf')
glSamplerParameterf.ret = Return('void')
glSamplerParameterf.add( Input( 'sampler','GLuint' ))
glSamplerParameterf.add( Input( 'pname','GLenum' ))
glSamplerParameterf.add( Input( 'param','GLfloat' ,regalLog = 'GLTexParameterToString(pname,param)' ))
glSamplerParameterf.version = '3.3'
glSamplerParameterf.category = 'GL_ARB_sampler_objects'
glSamplerParameterf.trace = True
glSamplerParameterf.play = True
gl.add(glSamplerParameterf)

glSamplerParameterfv = Function('glSamplerParameterfv')
glSamplerParameterfv.ret = Return('void')
glSamplerParameterfv.add( Input( 'sampler','GLuint' ))
glSamplerParameterfv.add( Input( 'pname','GLenum' ))
glSamplerParameterfv.add( Input( 'params','const GLfloat *' ,size = 'helperGLSamplerParametervSize(pname)' ,regalLog = 'GLTexParameterToString(pname,params)' ))
glSamplerParameterfv.version = '3.3'
glSamplerParameterfv.category = 'GL_ARB_sampler_objects'
glSamplerParameterfv.trace = True
glSamplerParameterfv.play = True
gl.add(glSamplerParameterfv)

glSamplerParameteri = Function('glSamplerParameteri')
glSamplerParameteri.ret = Return('void')
glSamplerParameteri.add( Input( 'sampler','GLuint' ))
glSamplerParameteri.add( Input( 'pname','GLenum' ))
glSamplerParameteri.add( Input( 'param','GLint' ,regalLog = 'GLTexParameterToString(pname,param)' ))
glSamplerParameteri.version = '3.3'
glSamplerParameteri.category = 'GL_ARB_sampler_objects'
glSamplerParameteri.trace = True
glSamplerParameteri.play = True
gl.add(glSamplerParameteri)

glSamplerParameteriv = Function('glSamplerParameteriv')
glSamplerParameteriv.ret = Return('void')
glSamplerParameteriv.add( Input( 'sampler','GLuint' ))
glSamplerParameteriv.add( Input( 'pname','GLenum' ))
glSamplerParameteriv.add( Input( 'params','const GLint *' ,size = 'helperGLSamplerParametervSize(pname)' ,regalLog = 'GLTexParameterToString(pname,params)' ))
glSamplerParameteriv.version = '3.3'
glSamplerParameteriv.category = 'GL_ARB_sampler_objects'
glSamplerParameteriv.trace = True
glSamplerParameteriv.play = True
gl.add(glSamplerParameteriv)

# GL_ARB_separate_shader_objects

glActiveShaderProgram = Function('glActiveShaderProgram')
glActiveShaderProgram.ret = Return('void')
glActiveShaderProgram.add( Input( 'pipeline','GLuint' ))
glActiveShaderProgram.add( Input( 'program','GLuint' ))
glActiveShaderProgram.version = '4.1'
glActiveShaderProgram.category = 'GL_ARB_separate_shader_objects'
glActiveShaderProgram.trace = True
glActiveShaderProgram.play = True
gl.add(glActiveShaderProgram)

glBindProgramPipeline = Function('glBindProgramPipeline')
glBindProgramPipeline.ret = Return('void')
glBindProgramPipeline.add( Input( 'pipeline','GLuint' ))
glBindProgramPipeline.version = '4.1'
glBindProgramPipeline.category = 'GL_ARB_separate_shader_objects'
glBindProgramPipeline.trace = True
glBindProgramPipeline.play = True
gl.add(glBindProgramPipeline)

glCreateShaderProgramv = Function('glCreateShaderProgramv')
glCreateShaderProgramv.ret = Return('GLuint')
glCreateShaderProgramv.add( Input( 'type','GLenum' ))
glCreateShaderProgramv.add( Input( 'count','GLsizei' ))
glCreateShaderProgramv.add( Input( 'strings','const GLchar * const *' ,size = 'count' ))
glCreateShaderProgramv.version = '4.1'
glCreateShaderProgramv.category = 'GL_ARB_separate_shader_objects'
glCreateShaderProgramv.trace = True
glCreateShaderProgramv.play = True
gl.add(glCreateShaderProgramv)

glDeleteProgramPipelines = Function('glDeleteProgramPipelines')
glDeleteProgramPipelines.ret = Return('void')
glDeleteProgramPipelines.add( Input( 'n','GLsizei' ))
glDeleteProgramPipelines.add( Input( 'pipelines','const GLuint *' ,size = 'n' ))
glDeleteProgramPipelines.version = '4.1'
glDeleteProgramPipelines.category = 'GL_ARB_separate_shader_objects'
glDeleteProgramPipelines.trace = True
glDeleteProgramPipelines.play = True
gl.add(glDeleteProgramPipelines)

glGenProgramPipelines = Function('glGenProgramPipelines')
glGenProgramPipelines.ret = Return('void')
glGenProgramPipelines.add( Input( 'n','GLsizei' ))
glGenProgramPipelines.add( Output( 'pipelines','GLuint *' ,size = 'n' ))
glGenProgramPipelines.version = '4.1'
glGenProgramPipelines.category = 'GL_ARB_separate_shader_objects'
glGenProgramPipelines.trace = True
glGenProgramPipelines.play = True
gl.add(glGenProgramPipelines)

glGetProgramPipelineInfoLog = Function('glGetProgramPipelineInfoLog')
glGetProgramPipelineInfoLog.ret = Return('void')
glGetProgramPipelineInfoLog.add( Input( 'pipeline','GLuint' ))
glGetProgramPipelineInfoLog.add( Input( 'bufSize','GLsizei' ))
glGetProgramPipelineInfoLog.add( Output( 'length','GLsizei *' ,size = 1 ))
glGetProgramPipelineInfoLog.add( Output( 'infoLog','GLchar *' ,maxSize = 'bufSize' ))
glGetProgramPipelineInfoLog.version = '4.1'
glGetProgramPipelineInfoLog.category = 'GL_ARB_separate_shader_objects'
glGetProgramPipelineInfoLog.trace = True
glGetProgramPipelineInfoLog.play = True
gl.add(glGetProgramPipelineInfoLog)

glGetProgramPipelineiv = Function('glGetProgramPipelineiv')
glGetProgramPipelineiv.ret = Return('void')
glGetProgramPipelineiv.add( Input( 'pipeline','GLuint' ))
glGetProgramPipelineiv.add( Input( 'pname','GLenum' ))
glGetProgramPipelineiv.add( Output( 'params','GLint *' ))
glGetProgramPipelineiv.version = '4.1'
glGetProgramPipelineiv.category = 'GL_ARB_separate_shader_objects'
glGetProgramPipelineiv.trace = True
glGetProgramPipelineiv.play = True
gl.add(glGetProgramPipelineiv)

glIsProgramPipeline = Function('glIsProgramPipeline')
glIsProgramPipeline.ret = Return('GLboolean')
glIsProgramPipeline.add( Input( 'pipeline','GLuint' ))
glIsProgramPipeline.version = '4.1'
glIsProgramPipeline.category = 'GL_ARB_separate_shader_objects'
glIsProgramPipeline.trace = True
glIsProgramPipeline.play = True
gl.add(glIsProgramPipeline)

glProgramUniform1d = Function('glProgramUniform1d')
glProgramUniform1d.ret = Return('void')
glProgramUniform1d.add( Input( 'program','GLuint' ))
glProgramUniform1d.add( Input( 'location','GLint' ))
glProgramUniform1d.add( Input( 'x','GLdouble' ))
glProgramUniform1d.version = '4.1'
glProgramUniform1d.category = 'GL_ARB_separate_shader_objects'
glProgramUniform1d.trace = True
glProgramUniform1d.play = True
gl.add(glProgramUniform1d)

glProgramUniform1dv = Function('glProgramUniform1dv')
glProgramUniform1dv.ret = Return('void')
glProgramUniform1dv.add( Input( 'program','GLuint' ))
glProgramUniform1dv.add( Input( 'location','GLint' ))
glProgramUniform1dv.add( Input( 'count','GLsizei' ))
glProgramUniform1dv.add( Input( 'value','const GLdouble *' ,size = 'count' ))
glProgramUniform1dv.version = '4.1'
glProgramUniform1dv.category = 'GL_ARB_separate_shader_objects'
glProgramUniform1dv.trace = True
glProgramUniform1dv.play = True
gl.add(glProgramUniform1dv)

glProgramUniform1f = Function('glProgramUniform1f')
glProgramUniform1f.ret = Return('void')
glProgramUniform1f.add( Input( 'program','GLuint' ))
glProgramUniform1f.add( Input( 'location','GLint' ))
glProgramUniform1f.add( Input( 'x','GLfloat' ))
glProgramUniform1f.version = '4.1'
glProgramUniform1f.category = 'GL_ARB_separate_shader_objects'
glProgramUniform1f.trace = True
glProgramUniform1f.play = True
gl.add(glProgramUniform1f)

glProgramUniform1fv = Function('glProgramUniform1fv')
glProgramUniform1fv.ret = Return('void')
glProgramUniform1fv.add( Input( 'program','GLuint' ))
glProgramUniform1fv.add( Input( 'location','GLint' ))
glProgramUniform1fv.add( Input( 'count','GLsizei' ))
glProgramUniform1fv.add( Input( 'value','const GLfloat *' ,size = 'count' ))
glProgramUniform1fv.version = '4.1'
glProgramUniform1fv.category = 'GL_ARB_separate_shader_objects'
glProgramUniform1fv.trace = True
glProgramUniform1fv.play = True
gl.add(glProgramUniform1fv)

glProgramUniform1i = Function('glProgramUniform1i')
glProgramUniform1i.ret = Return('void')
glProgramUniform1i.add( Input( 'program','GLuint' ))
glProgramUniform1i.add( Input( 'location','GLint' ))
glProgramUniform1i.add( Input( 'x','GLint' ))
glProgramUniform1i.version = '4.1'
glProgramUniform1i.category = 'GL_ARB_separate_shader_objects'
glProgramUniform1i.trace = True
glProgramUniform1i.play = True
gl.add(glProgramUniform1i)

glProgramUniform1iv = Function('glProgramUniform1iv')
glProgramUniform1iv.ret = Return('void')
glProgramUniform1iv.add( Input( 'program','GLuint' ))
glProgramUniform1iv.add( Input( 'location','GLint' ))
glProgramUniform1iv.add( Input( 'count','GLsizei' ))
glProgramUniform1iv.add( Input( 'value','const GLint *' ,size = 'count' ))
glProgramUniform1iv.version = '4.1'
glProgramUniform1iv.category = 'GL_ARB_separate_shader_objects'
glProgramUniform1iv.trace = True
glProgramUniform1iv.play = True
gl.add(glProgramUniform1iv)

glProgramUniform1ui = Function('glProgramUniform1ui')
glProgramUniform1ui.ret = Return('void')
glProgramUniform1ui.add( Input( 'program','GLuint' ))
glProgramUniform1ui.add( Input( 'location','GLint' ))
glProgramUniform1ui.add( Input( 'v0','GLuint' ))
glProgramUniform1ui.version = '4.1'
glProgramUniform1ui.category = 'GL_ARB_separate_shader_objects'
glProgramUniform1ui.trace = True
glProgramUniform1ui.play = True
gl.add(glProgramUniform1ui)

glProgramUniform1uiv = Function('glProgramUniform1uiv')
glProgramUniform1uiv.ret = Return('void')
glProgramUniform1uiv.add( Input( 'program','GLuint' ))
glProgramUniform1uiv.add( Input( 'location','GLint' ))
glProgramUniform1uiv.add( Input( 'count','GLsizei' ))
glProgramUniform1uiv.add( Input( 'value','const GLuint *' ,size = 'count' ))
glProgramUniform1uiv.version = '4.1'
glProgramUniform1uiv.category = 'GL_ARB_separate_shader_objects'
glProgramUniform1uiv.trace = True
glProgramUniform1uiv.play = True
gl.add(glProgramUniform1uiv)

glProgramUniform2d = Function('glProgramUniform2d')
glProgramUniform2d.ret = Return('void')
glProgramUniform2d.add( Input( 'program','GLuint' ))
glProgramUniform2d.add( Input( 'location','GLint' ))
glProgramUniform2d.add( Input( 'x','GLdouble' ))
glProgramUniform2d.add( Input( 'y','GLdouble' ))
glProgramUniform2d.version = '4.1'
glProgramUniform2d.category = 'GL_ARB_separate_shader_objects'
glProgramUniform2d.trace = True
glProgramUniform2d.play = True
gl.add(glProgramUniform2d)

glProgramUniform2dv = Function('glProgramUniform2dv')
glProgramUniform2dv.ret = Return('void')
glProgramUniform2dv.add( Input( 'program','GLuint' ))
glProgramUniform2dv.add( Input( 'location','GLint' ))
glProgramUniform2dv.add( Input( 'count','GLsizei' ))
glProgramUniform2dv.add( Input( 'value','const GLdouble *' ,size = 'count * 2' ))
glProgramUniform2dv.version = '4.1'
glProgramUniform2dv.category = 'GL_ARB_separate_shader_objects'
glProgramUniform2dv.trace = True
glProgramUniform2dv.play = True
gl.add(glProgramUniform2dv)

glProgramUniform2f = Function('glProgramUniform2f')
glProgramUniform2f.ret = Return('void')
glProgramUniform2f.add( Input( 'program','GLuint' ))
glProgramUniform2f.add( Input( 'location','GLint' ))
glProgramUniform2f.add( Input( 'x','GLfloat' ))
glProgramUniform2f.add( Input( 'y','GLfloat' ))
glProgramUniform2f.version = '4.1'
glProgramUniform2f.category = 'GL_ARB_separate_shader_objects'
glProgramUniform2f.trace = True
glProgramUniform2f.play = True
gl.add(glProgramUniform2f)

glProgramUniform2fv = Function('glProgramUniform2fv')
glProgramUniform2fv.ret = Return('void')
glProgramUniform2fv.add( Input( 'program','GLuint' ))
glProgramUniform2fv.add( Input( 'location','GLint' ))
glProgramUniform2fv.add( Input( 'count','GLsizei' ))
glProgramUniform2fv.add( Input( 'value','const GLfloat *' ,size = 'count * 2' ))
glProgramUniform2fv.version = '4.1'
glProgramUniform2fv.category = 'GL_ARB_separate_shader_objects'
glProgramUniform2fv.trace = True
glProgramUniform2fv.play = True
gl.add(glProgramUniform2fv)

glProgramUniform2i = Function('glProgramUniform2i')
glProgramUniform2i.ret = Return('void')
glProgramUniform2i.add( Input( 'program','GLuint' ))
glProgramUniform2i.add( Input( 'location','GLint' ))
glProgramUniform2i.add( Input( 'x','GLint' ))
glProgramUniform2i.add( Input( 'y','GLint' ))
glProgramUniform2i.version = '4.1'
glProgramUniform2i.category = 'GL_ARB_separate_shader_objects'
glProgramUniform2i.trace = True
glProgramUniform2i.play = True
gl.add(glProgramUniform2i)

glProgramUniform2iv = Function('glProgramUniform2iv')
glProgramUniform2iv.ret = Return('void')
glProgramUniform2iv.add( Input( 'program','GLuint' ))
glProgramUniform2iv.add( Input( 'location','GLint' ))
glProgramUniform2iv.add( Input( 'count','GLsizei' ))
glProgramUniform2iv.add( Input( 'value','const GLint *' ,size = 'count * 2' ))
glProgramUniform2iv.version = '4.1'
glProgramUniform2iv.category = 'GL_ARB_separate_shader_objects'
glProgramUniform2iv.trace = True
glProgramUniform2iv.play = True
gl.add(glProgramUniform2iv)

glProgramUniform2ui = Function('glProgramUniform2ui')
glProgramUniform2ui.ret = Return('void')
glProgramUniform2ui.add( Input( 'program','GLuint' ))
glProgramUniform2ui.add( Input( 'location','GLint' ))
glProgramUniform2ui.add( Input( 'x','GLuint' ))
glProgramUniform2ui.add( Input( 'y','GLuint' ))
glProgramUniform2ui.version = '4.1'
glProgramUniform2ui.category = 'GL_ARB_separate_shader_objects'
glProgramUniform2ui.trace = True
glProgramUniform2ui.play = True
gl.add(glProgramUniform2ui)

glProgramUniform2uiv = Function('glProgramUniform2uiv')
glProgramUniform2uiv.ret = Return('void')
glProgramUniform2uiv.add( Input( 'program','GLuint' ))
glProgramUniform2uiv.add( Input( 'location','GLint' ))
glProgramUniform2uiv.add( Input( 'count','GLsizei' ))
glProgramUniform2uiv.add( Input( 'value','const GLuint *' ,size = 'count * 2' ))
glProgramUniform2uiv.version = '4.1'
glProgramUniform2uiv.category = 'GL_ARB_separate_shader_objects'
glProgramUniform2uiv.trace = True
glProgramUniform2uiv.play = True
gl.add(glProgramUniform2uiv)

glProgramUniform3d = Function('glProgramUniform3d')
glProgramUniform3d.ret = Return('void')
glProgramUniform3d.add( Input( 'program','GLuint' ))
glProgramUniform3d.add( Input( 'location','GLint' ))
glProgramUniform3d.add( Input( 'x','GLdouble' ))
glProgramUniform3d.add( Input( 'y','GLdouble' ))
glProgramUniform3d.add( Input( 'z','GLdouble' ))
glProgramUniform3d.version = '4.1'
glProgramUniform3d.category = 'GL_ARB_separate_shader_objects'
glProgramUniform3d.trace = True
glProgramUniform3d.play = True
gl.add(glProgramUniform3d)

glProgramUniform3dv = Function('glProgramUniform3dv')
glProgramUniform3dv.ret = Return('void')
glProgramUniform3dv.add( Input( 'program','GLuint' ))
glProgramUniform3dv.add( Input( 'location','GLint' ))
glProgramUniform3dv.add( Input( 'count','GLsizei' ))
glProgramUniform3dv.add( Input( 'value','const GLdouble *' ,size = 'count * 3' ))
glProgramUniform3dv.version = '4.1'
glProgramUniform3dv.category = 'GL_ARB_separate_shader_objects'
glProgramUniform3dv.trace = True
glProgramUniform3dv.play = True
gl.add(glProgramUniform3dv)

glProgramUniform3f = Function('glProgramUniform3f')
glProgramUniform3f.ret = Return('void')
glProgramUniform3f.add( Input( 'program','GLuint' ))
glProgramUniform3f.add( Input( 'location','GLint' ))
glProgramUniform3f.add( Input( 'x','GLfloat' ))
glProgramUniform3f.add( Input( 'y','GLfloat' ))
glProgramUniform3f.add( Input( 'z','GLfloat' ))
glProgramUniform3f.version = '4.1'
glProgramUniform3f.category = 'GL_ARB_separate_shader_objects'
glProgramUniform3f.trace = True
glProgramUniform3f.play = True
gl.add(glProgramUniform3f)

glProgramUniform3fv = Function('glProgramUniform3fv')
glProgramUniform3fv.ret = Return('void')
glProgramUniform3fv.add( Input( 'program','GLuint' ))
glProgramUniform3fv.add( Input( 'location','GLint' ))
glProgramUniform3fv.add( Input( 'count','GLsizei' ))
glProgramUniform3fv.add( Input( 'value','const GLfloat *' ,size = 'count * 3' ))
glProgramUniform3fv.version = '4.1'
glProgramUniform3fv.category = 'GL_ARB_separate_shader_objects'
glProgramUniform3fv.trace = True
glProgramUniform3fv.play = True
gl.add(glProgramUniform3fv)

glProgramUniform3i = Function('glProgramUniform3i')
glProgramUniform3i.ret = Return('void')
glProgramUniform3i.add( Input( 'program','GLuint' ))
glProgramUniform3i.add( Input( 'location','GLint' ))
glProgramUniform3i.add( Input( 'x','GLint' ))
glProgramUniform3i.add( Input( 'y','GLint' ))
glProgramUniform3i.add( Input( 'z','GLint' ))
glProgramUniform3i.version = '4.1'
glProgramUniform3i.category = 'GL_ARB_separate_shader_objects'
glProgramUniform3i.trace = True
glProgramUniform3i.play = True
gl.add(glProgramUniform3i)

glProgramUniform3iv = Function('glProgramUniform3iv')
glProgramUniform3iv.ret = Return('void')
glProgramUniform3iv.add( Input( 'program','GLuint' ))
glProgramUniform3iv.add( Input( 'location','GLint' ))
glProgramUniform3iv.add( Input( 'count','GLsizei' ))
glProgramUniform3iv.add( Input( 'value','const GLint *' ,size = 'count * 3' ))
glProgramUniform3iv.version = '4.1'
glProgramUniform3iv.category = 'GL_ARB_separate_shader_objects'
glProgramUniform3iv.trace = True
glProgramUniform3iv.play = True
gl.add(glProgramUniform3iv)

glProgramUniform3ui = Function('glProgramUniform3ui')
glProgramUniform3ui.ret = Return('void')
glProgramUniform3ui.add( Input( 'program','GLuint' ))
glProgramUniform3ui.add( Input( 'location','GLint' ))
glProgramUniform3ui.add( Input( 'x','GLuint' ))
glProgramUniform3ui.add( Input( 'y','GLuint' ))
glProgramUniform3ui.add( Input( 'z','GLuint' ))
glProgramUniform3ui.version = '4.1'
glProgramUniform3ui.category = 'GL_ARB_separate_shader_objects'
glProgramUniform3ui.trace = True
glProgramUniform3ui.play = True
gl.add(glProgramUniform3ui)

glProgramUniform3uiv = Function('glProgramUniform3uiv')
glProgramUniform3uiv.ret = Return('void')
glProgramUniform3uiv.add( Input( 'program','GLuint' ))
glProgramUniform3uiv.add( Input( 'location','GLint' ))
glProgramUniform3uiv.add( Input( 'count','GLsizei' ))
glProgramUniform3uiv.add( Input( 'value','const GLuint *' ,size = 'count * 3' ))
glProgramUniform3uiv.version = '4.1'
glProgramUniform3uiv.category = 'GL_ARB_separate_shader_objects'
glProgramUniform3uiv.trace = True
glProgramUniform3uiv.play = True
gl.add(glProgramUniform3uiv)

glProgramUniform4d = Function('glProgramUniform4d')
glProgramUniform4d.ret = Return('void')
glProgramUniform4d.add( Input( 'program','GLuint' ))
glProgramUniform4d.add( Input( 'location','GLint' ))
glProgramUniform4d.add( Input( 'x','GLdouble' ))
glProgramUniform4d.add( Input( 'y','GLdouble' ))
glProgramUniform4d.add( Input( 'z','GLdouble' ))
glProgramUniform4d.add( Input( 'w','GLdouble' ))
glProgramUniform4d.version = '4.1'
glProgramUniform4d.category = 'GL_ARB_separate_shader_objects'
glProgramUniform4d.trace = True
glProgramUniform4d.play = True
gl.add(glProgramUniform4d)

glProgramUniform4dv = Function('glProgramUniform4dv')
glProgramUniform4dv.ret = Return('void')
glProgramUniform4dv.add( Input( 'program','GLuint' ))
glProgramUniform4dv.add( Input( 'location','GLint' ))
glProgramUniform4dv.add( Input( 'count','GLsizei' ))
glProgramUniform4dv.add( Input( 'value','const GLdouble *' ,size = 'count * 4' ))
glProgramUniform4dv.version = '4.1'
glProgramUniform4dv.category = 'GL_ARB_separate_shader_objects'
glProgramUniform4dv.trace = True
glProgramUniform4dv.play = True
gl.add(glProgramUniform4dv)

glProgramUniform4f = Function('glProgramUniform4f')
glProgramUniform4f.ret = Return('void')
glProgramUniform4f.add( Input( 'program','GLuint' ))
glProgramUniform4f.add( Input( 'location','GLint' ))
glProgramUniform4f.add( Input( 'x','GLfloat' ))
glProgramUniform4f.add( Input( 'y','GLfloat' ))
glProgramUniform4f.add( Input( 'z','GLfloat' ))
glProgramUniform4f.add( Input( 'w','GLfloat' ))
glProgramUniform4f.version = '4.1'
glProgramUniform4f.category = 'GL_ARB_separate_shader_objects'
glProgramUniform4f.trace = True
glProgramUniform4f.play = True
gl.add(glProgramUniform4f)

glProgramUniform4fv = Function('glProgramUniform4fv')
glProgramUniform4fv.ret = Return('void')
glProgramUniform4fv.add( Input( 'program','GLuint' ))
glProgramUniform4fv.add( Input( 'location','GLint' ))
glProgramUniform4fv.add( Input( 'count','GLsizei' ))
glProgramUniform4fv.add( Input( 'value','const GLfloat *' ,size = 'count * 4' ))
glProgramUniform4fv.version = '4.1'
glProgramUniform4fv.category = 'GL_ARB_separate_shader_objects'
glProgramUniform4fv.trace = True
glProgramUniform4fv.play = True
gl.add(glProgramUniform4fv)

glProgramUniform4i = Function('glProgramUniform4i')
glProgramUniform4i.ret = Return('void')
glProgramUniform4i.add( Input( 'program','GLuint' ))
glProgramUniform4i.add( Input( 'location','GLint' ))
glProgramUniform4i.add( Input( 'x','GLint' ))
glProgramUniform4i.add( Input( 'y','GLint' ))
glProgramUniform4i.add( Input( 'z','GLint' ))
glProgramUniform4i.add( Input( 'w','GLint' ))
glProgramUniform4i.version = '4.1'
glProgramUniform4i.category = 'GL_ARB_separate_shader_objects'
glProgramUniform4i.trace = True
glProgramUniform4i.play = True
gl.add(glProgramUniform4i)

glProgramUniform4iv = Function('glProgramUniform4iv')
glProgramUniform4iv.ret = Return('void')
glProgramUniform4iv.add( Input( 'program','GLuint' ))
glProgramUniform4iv.add( Input( 'location','GLint' ))
glProgramUniform4iv.add( Input( 'count','GLsizei' ))
glProgramUniform4iv.add( Input( 'value','const GLint *' ,size = 'count * 4' ))
glProgramUniform4iv.version = '4.1'
glProgramUniform4iv.category = 'GL_ARB_separate_shader_objects'
glProgramUniform4iv.trace = True
glProgramUniform4iv.play = True
gl.add(glProgramUniform4iv)

glProgramUniform4ui = Function('glProgramUniform4ui')
glProgramUniform4ui.ret = Return('void')
glProgramUniform4ui.add( Input( 'program','GLuint' ))
glProgramUniform4ui.add( Input( 'location','GLint' ))
glProgramUniform4ui.add( Input( 'x','GLuint' ))
glProgramUniform4ui.add( Input( 'y','GLuint' ))
glProgramUniform4ui.add( Input( 'z','GLuint' ))
glProgramUniform4ui.add( Input( 'w','GLuint' ))
glProgramUniform4ui.version = '4.1'
glProgramUniform4ui.category = 'GL_ARB_separate_shader_objects'
glProgramUniform4ui.trace = True
glProgramUniform4ui.play = True
gl.add(glProgramUniform4ui)

glProgramUniform4uiv = Function('glProgramUniform4uiv')
glProgramUniform4uiv.ret = Return('void')
glProgramUniform4uiv.add( Input( 'program','GLuint' ))
glProgramUniform4uiv.add( Input( 'location','GLint' ))
glProgramUniform4uiv.add( Input( 'count','GLsizei' ))
glProgramUniform4uiv.add( Input( 'value','const GLuint *' ,size = 'count * 4' ))
glProgramUniform4uiv.version = '4.1'
glProgramUniform4uiv.category = 'GL_ARB_separate_shader_objects'
glProgramUniform4uiv.trace = True
glProgramUniform4uiv.play = True
gl.add(glProgramUniform4uiv)

glProgramUniformMatrix2dv = Function('glProgramUniformMatrix2dv')
glProgramUniformMatrix2dv.ret = Return('void')
glProgramUniformMatrix2dv.add( Input( 'program','GLuint' ))
glProgramUniformMatrix2dv.add( Input( 'location','GLint' ))
glProgramUniformMatrix2dv.add( Input( 'count','GLsizei' ))
glProgramUniformMatrix2dv.add( Input( 'transpose','GLboolean' ))
glProgramUniformMatrix2dv.add( Input( 'value','const GLdouble *' ,size = 'count * 4' ))
glProgramUniformMatrix2dv.version = '4.1'
glProgramUniformMatrix2dv.category = 'GL_ARB_separate_shader_objects'
glProgramUniformMatrix2dv.trace = True
glProgramUniformMatrix2dv.play = True
gl.add(glProgramUniformMatrix2dv)

glProgramUniformMatrix2fv = Function('glProgramUniformMatrix2fv')
glProgramUniformMatrix2fv.ret = Return('void')
glProgramUniformMatrix2fv.add( Input( 'program','GLuint' ))
glProgramUniformMatrix2fv.add( Input( 'location','GLint' ))
glProgramUniformMatrix2fv.add( Input( 'count','GLsizei' ))
glProgramUniformMatrix2fv.add( Input( 'transpose','GLboolean' ))
glProgramUniformMatrix2fv.add( Input( 'value','const GLfloat *' ,size = 'count * 4' ))
glProgramUniformMatrix2fv.version = '4.1'
glProgramUniformMatrix2fv.category = 'GL_ARB_separate_shader_objects'
glProgramUniformMatrix2fv.trace = True
glProgramUniformMatrix2fv.play = True
gl.add(glProgramUniformMatrix2fv)

glProgramUniformMatrix2x3dv = Function('glProgramUniformMatrix2x3dv')
glProgramUniformMatrix2x3dv.ret = Return('void')
glProgramUniformMatrix2x3dv.add( Input( 'program','GLuint' ))
glProgramUniformMatrix2x3dv.add( Input( 'location','GLint' ))
glProgramUniformMatrix2x3dv.add( Input( 'count','GLsizei' ))
glProgramUniformMatrix2x3dv.add( Input( 'transpose','GLboolean' ))
glProgramUniformMatrix2x3dv.add( Input( 'value','const GLdouble *' ,size = 'count * 6' ))
glProgramUniformMatrix2x3dv.version = '4.1'
glProgramUniformMatrix2x3dv.category = 'GL_ARB_separate_shader_objects'
glProgramUniformMatrix2x3dv.trace = True
glProgramUniformMatrix2x3dv.play = True
gl.add(glProgramUniformMatrix2x3dv)

glProgramUniformMatrix2x3fv = Function('glProgramUniformMatrix2x3fv')
glProgramUniformMatrix2x3fv.ret = Return('void')
glProgramUniformMatrix2x3fv.add( Input( 'program','GLuint' ))
glProgramUniformMatrix2x3fv.add( Input( 'location','GLint' ))
glProgramUniformMatrix2x3fv.add( Input( 'count','GLsizei' ))
glProgramUniformMatrix2x3fv.add( Input( 'transpose','GLboolean' ))
glProgramUniformMatrix2x3fv.add( Input( 'value','const GLfloat *' ,size = 'count * 6' ))
glProgramUniformMatrix2x3fv.version = '4.1'
glProgramUniformMatrix2x3fv.category = 'GL_ARB_separate_shader_objects'
glProgramUniformMatrix2x3fv.trace = True
glProgramUniformMatrix2x3fv.play = True
gl.add(glProgramUniformMatrix2x3fv)

glProgramUniformMatrix2x4dv = Function('glProgramUniformMatrix2x4dv')
glProgramUniformMatrix2x4dv.ret = Return('void')
glProgramUniformMatrix2x4dv.add( Input( 'program','GLuint' ))
glProgramUniformMatrix2x4dv.add( Input( 'location','GLint' ))
glProgramUniformMatrix2x4dv.add( Input( 'count','GLsizei' ))
glProgramUniformMatrix2x4dv.add( Input( 'transpose','GLboolean' ))
glProgramUniformMatrix2x4dv.add( Input( 'value','const GLdouble *' ,size = 'count * 8' ))
glProgramUniformMatrix2x4dv.version = '4.1'
glProgramUniformMatrix2x4dv.category = 'GL_ARB_separate_shader_objects'
glProgramUniformMatrix2x4dv.trace = True
glProgramUniformMatrix2x4dv.play = True
gl.add(glProgramUniformMatrix2x4dv)

glProgramUniformMatrix2x4fv = Function('glProgramUniformMatrix2x4fv')
glProgramUniformMatrix2x4fv.ret = Return('void')
glProgramUniformMatrix2x4fv.add( Input( 'program','GLuint' ))
glProgramUniformMatrix2x4fv.add( Input( 'location','GLint' ))
glProgramUniformMatrix2x4fv.add( Input( 'count','GLsizei' ))
glProgramUniformMatrix2x4fv.add( Input( 'transpose','GLboolean' ))
glProgramUniformMatrix2x4fv.add( Input( 'value','const GLfloat *' ,size = 'count * 8' ))
glProgramUniformMatrix2x4fv.version = '4.1'
glProgramUniformMatrix2x4fv.category = 'GL_ARB_separate_shader_objects'
glProgramUniformMatrix2x4fv.trace = True
glProgramUniformMatrix2x4fv.play = True
gl.add(glProgramUniformMatrix2x4fv)

glProgramUniformMatrix3dv = Function('glProgramUniformMatrix3dv')
glProgramUniformMatrix3dv.ret = Return('void')
glProgramUniformMatrix3dv.add( Input( 'program','GLuint' ))
glProgramUniformMatrix3dv.add( Input( 'location','GLint' ))
glProgramUniformMatrix3dv.add( Input( 'count','GLsizei' ))
glProgramUniformMatrix3dv.add( Input( 'transpose','GLboolean' ))
glProgramUniformMatrix3dv.add( Input( 'value','const GLdouble *' ,size = 'count * 9' ))
glProgramUniformMatrix3dv.version = '4.1'
glProgramUniformMatrix3dv.category = 'GL_ARB_separate_shader_objects'
glProgramUniformMatrix3dv.trace = True
glProgramUniformMatrix3dv.play = True
gl.add(glProgramUniformMatrix3dv)

glProgramUniformMatrix3fv = Function('glProgramUniformMatrix3fv')
glProgramUniformMatrix3fv.ret = Return('void')
glProgramUniformMatrix3fv.add( Input( 'program','GLuint' ))
glProgramUniformMatrix3fv.add( Input( 'location','GLint' ))
glProgramUniformMatrix3fv.add( Input( 'count','GLsizei' ))
glProgramUniformMatrix3fv.add( Input( 'transpose','GLboolean' ))
glProgramUniformMatrix3fv.add( Input( 'value','const GLfloat *' ,size = 'count * 9' ))
glProgramUniformMatrix3fv.version = '4.1'
glProgramUniformMatrix3fv.category = 'GL_ARB_separate_shader_objects'
glProgramUniformMatrix3fv.trace = True
glProgramUniformMatrix3fv.play = True
gl.add(glProgramUniformMatrix3fv)

glProgramUniformMatrix3x2dv = Function('glProgramUniformMatrix3x2dv')
glProgramUniformMatrix3x2dv.ret = Return('void')
glProgramUniformMatrix3x2dv.add( Input( 'program','GLuint' ))
glProgramUniformMatrix3x2dv.add( Input( 'location','GLint' ))
glProgramUniformMatrix3x2dv.add( Input( 'count','GLsizei' ))
glProgramUniformMatrix3x2dv.add( Input( 'transpose','GLboolean' ))
glProgramUniformMatrix3x2dv.add( Input( 'value','const GLdouble *' ,size = 'count * 6' ))
glProgramUniformMatrix3x2dv.version = '4.1'
glProgramUniformMatrix3x2dv.category = 'GL_ARB_separate_shader_objects'
glProgramUniformMatrix3x2dv.trace = True
glProgramUniformMatrix3x2dv.play = True
gl.add(glProgramUniformMatrix3x2dv)

glProgramUniformMatrix3x2fv = Function('glProgramUniformMatrix3x2fv')
glProgramUniformMatrix3x2fv.ret = Return('void')
glProgramUniformMatrix3x2fv.add( Input( 'program','GLuint' ))
glProgramUniformMatrix3x2fv.add( Input( 'location','GLint' ))
glProgramUniformMatrix3x2fv.add( Input( 'count','GLsizei' ))
glProgramUniformMatrix3x2fv.add( Input( 'transpose','GLboolean' ))
glProgramUniformMatrix3x2fv.add( Input( 'value','const GLfloat *' ,size = 'count * 6' ))
glProgramUniformMatrix3x2fv.version = '4.1'
glProgramUniformMatrix3x2fv.category = 'GL_ARB_separate_shader_objects'
glProgramUniformMatrix3x2fv.trace = True
glProgramUniformMatrix3x2fv.play = True
gl.add(glProgramUniformMatrix3x2fv)

glProgramUniformMatrix3x4dv = Function('glProgramUniformMatrix3x4dv')
glProgramUniformMatrix3x4dv.ret = Return('void')
glProgramUniformMatrix3x4dv.add( Input( 'program','GLuint' ))
glProgramUniformMatrix3x4dv.add( Input( 'location','GLint' ))
glProgramUniformMatrix3x4dv.add( Input( 'count','GLsizei' ))
glProgramUniformMatrix3x4dv.add( Input( 'transpose','GLboolean' ))
glProgramUniformMatrix3x4dv.add( Input( 'value','const GLdouble *' ,size = 'count * 12' ))
glProgramUniformMatrix3x4dv.version = '4.1'
glProgramUniformMatrix3x4dv.category = 'GL_ARB_separate_shader_objects'
glProgramUniformMatrix3x4dv.trace = True
glProgramUniformMatrix3x4dv.play = True
gl.add(glProgramUniformMatrix3x4dv)

glProgramUniformMatrix3x4fv = Function('glProgramUniformMatrix3x4fv')
glProgramUniformMatrix3x4fv.ret = Return('void')
glProgramUniformMatrix3x4fv.add( Input( 'program','GLuint' ))
glProgramUniformMatrix3x4fv.add( Input( 'location','GLint' ))
glProgramUniformMatrix3x4fv.add( Input( 'count','GLsizei' ))
glProgramUniformMatrix3x4fv.add( Input( 'transpose','GLboolean' ))
glProgramUniformMatrix3x4fv.add( Input( 'value','const GLfloat *' ,size = 'count * 12' ))
glProgramUniformMatrix3x4fv.version = '4.1'
glProgramUniformMatrix3x4fv.category = 'GL_ARB_separate_shader_objects'
glProgramUniformMatrix3x4fv.trace = True
glProgramUniformMatrix3x4fv.play = True
gl.add(glProgramUniformMatrix3x4fv)

glProgramUniformMatrix4dv = Function('glProgramUniformMatrix4dv')
glProgramUniformMatrix4dv.ret = Return('void')
glProgramUniformMatrix4dv.add( Input( 'program','GLuint' ))
glProgramUniformMatrix4dv.add( Input( 'location','GLint' ))
glProgramUniformMatrix4dv.add( Input( 'count','GLsizei' ))
glProgramUniformMatrix4dv.add( Input( 'transpose','GLboolean' ))
glProgramUniformMatrix4dv.add( Input( 'value','const GLdouble *' ,size = 'count * 16' ))
glProgramUniformMatrix4dv.version = '4.1'
glProgramUniformMatrix4dv.category = 'GL_ARB_separate_shader_objects'
glProgramUniformMatrix4dv.trace = True
glProgramUniformMatrix4dv.play = True
gl.add(glProgramUniformMatrix4dv)

glProgramUniformMatrix4fv = Function('glProgramUniformMatrix4fv')
glProgramUniformMatrix4fv.ret = Return('void')
glProgramUniformMatrix4fv.add( Input( 'program','GLuint' ))
glProgramUniformMatrix4fv.add( Input( 'location','GLint' ))
glProgramUniformMatrix4fv.add( Input( 'count','GLsizei' ))
glProgramUniformMatrix4fv.add( Input( 'transpose','GLboolean' ))
glProgramUniformMatrix4fv.add( Input( 'value','const GLfloat *' ,size = 'count * 16' ))
glProgramUniformMatrix4fv.version = '4.1'
glProgramUniformMatrix4fv.category = 'GL_ARB_separate_shader_objects'
glProgramUniformMatrix4fv.trace = True
glProgramUniformMatrix4fv.play = True
gl.add(glProgramUniformMatrix4fv)

glProgramUniformMatrix4x2dv = Function('glProgramUniformMatrix4x2dv')
glProgramUniformMatrix4x2dv.ret = Return('void')
glProgramUniformMatrix4x2dv.add( Input( 'program','GLuint' ))
glProgramUniformMatrix4x2dv.add( Input( 'location','GLint' ))
glProgramUniformMatrix4x2dv.add( Input( 'count','GLsizei' ))
glProgramUniformMatrix4x2dv.add( Input( 'transpose','GLboolean' ))
glProgramUniformMatrix4x2dv.add( Input( 'value','const GLdouble *' ,size = 'count * 8' ))
glProgramUniformMatrix4x2dv.version = '4.1'
glProgramUniformMatrix4x2dv.category = 'GL_ARB_separate_shader_objects'
glProgramUniformMatrix4x2dv.trace = True
glProgramUniformMatrix4x2dv.play = True
gl.add(glProgramUniformMatrix4x2dv)

glProgramUniformMatrix4x2fv = Function('glProgramUniformMatrix4x2fv')
glProgramUniformMatrix4x2fv.ret = Return('void')
glProgramUniformMatrix4x2fv.add( Input( 'program','GLuint' ))
glProgramUniformMatrix4x2fv.add( Input( 'location','GLint' ))
glProgramUniformMatrix4x2fv.add( Input( 'count','GLsizei' ))
glProgramUniformMatrix4x2fv.add( Input( 'transpose','GLboolean' ))
glProgramUniformMatrix4x2fv.add( Input( 'value','const GLfloat *' ,size = 'count * 8' ))
glProgramUniformMatrix4x2fv.version = '4.1'
glProgramUniformMatrix4x2fv.category = 'GL_ARB_separate_shader_objects'
glProgramUniformMatrix4x2fv.trace = True
glProgramUniformMatrix4x2fv.play = True
gl.add(glProgramUniformMatrix4x2fv)

glProgramUniformMatrix4x3dv = Function('glProgramUniformMatrix4x3dv')
glProgramUniformMatrix4x3dv.ret = Return('void')
glProgramUniformMatrix4x3dv.add( Input( 'program','GLuint' ))
glProgramUniformMatrix4x3dv.add( Input( 'location','GLint' ))
glProgramUniformMatrix4x3dv.add( Input( 'count','GLsizei' ))
glProgramUniformMatrix4x3dv.add( Input( 'transpose','GLboolean' ))
glProgramUniformMatrix4x3dv.add( Input( 'value','const GLdouble *' ,size = 'count * 12' ))
glProgramUniformMatrix4x3dv.version = '4.1'
glProgramUniformMatrix4x3dv.category = 'GL_ARB_separate_shader_objects'
glProgramUniformMatrix4x3dv.trace = True
glProgramUniformMatrix4x3dv.play = True
gl.add(glProgramUniformMatrix4x3dv)

glProgramUniformMatrix4x3fv = Function('glProgramUniformMatrix4x3fv')
glProgramUniformMatrix4x3fv.ret = Return('void')
glProgramUniformMatrix4x3fv.add( Input( 'program','GLuint' ))
glProgramUniformMatrix4x3fv.add( Input( 'location','GLint' ))
glProgramUniformMatrix4x3fv.add( Input( 'count','GLsizei' ))
glProgramUniformMatrix4x3fv.add( Input( 'transpose','GLboolean' ))
glProgramUniformMatrix4x3fv.add( Input( 'value','const GLfloat *' ,size = 'count * 12' ))
glProgramUniformMatrix4x3fv.version = '4.1'
glProgramUniformMatrix4x3fv.category = 'GL_ARB_separate_shader_objects'
glProgramUniformMatrix4x3fv.trace = True
glProgramUniformMatrix4x3fv.play = True
gl.add(glProgramUniformMatrix4x3fv)

glUseProgramStages = Function('glUseProgramStages')
glUseProgramStages.ret = Return('void')
glUseProgramStages.add( Input( 'pipeline','GLuint' ))
glUseProgramStages.add( Input( 'stages','GLbitfield' ,regalLog = 'GLuseProgramStagesToString(stages)' ))
glUseProgramStages.add( Input( 'program','GLuint' ))
glUseProgramStages.version = '4.1'
glUseProgramStages.category = 'GL_ARB_separate_shader_objects'
glUseProgramStages.trace = True
glUseProgramStages.play = True
gl.add(glUseProgramStages)

glValidateProgramPipeline = Function('glValidateProgramPipeline')
glValidateProgramPipeline.ret = Return('void')
glValidateProgramPipeline.add( Input( 'pipeline','GLuint' ))
glValidateProgramPipeline.version = '4.1'
glValidateProgramPipeline.category = 'GL_ARB_separate_shader_objects'
glValidateProgramPipeline.trace = True
glValidateProgramPipeline.play = True
gl.add(glValidateProgramPipeline)

# GL_ARB_shader_atomic_counters

glGetActiveAtomicCounterBufferiv = Function('glGetActiveAtomicCounterBufferiv')
glGetActiveAtomicCounterBufferiv.ret = Return('void')
glGetActiveAtomicCounterBufferiv.add( Input( 'program','GLuint' ))
glGetActiveAtomicCounterBufferiv.add( Input( 'bufferIndex','GLuint' ))
glGetActiveAtomicCounterBufferiv.add( Input( 'pname','GLenum' ))
glGetActiveAtomicCounterBufferiv.add( Input( 'params','GLint *' ))
glGetActiveAtomicCounterBufferiv.version = ''
glGetActiveAtomicCounterBufferiv.category = 'GL_ARB_shader_atomic_counters'
glGetActiveAtomicCounterBufferiv.trace = True
glGetActiveAtomicCounterBufferiv.play = True
gl.add(glGetActiveAtomicCounterBufferiv)

# GL_ARB_shader_image_load_store

glBindImageTexture = Function('glBindImageTexture')
glBindImageTexture.ret = Return('void')
glBindImageTexture.add( Input( 'unit','GLuint' ))
glBindImageTexture.add( Input( 'texture','GLuint' ))
glBindImageTexture.add( Input( 'level','GLint' ))
glBindImageTexture.add( Input( 'layered','GLboolean' ))
glBindImageTexture.add( Input( 'layer','GLint' ))
glBindImageTexture.add( Input( 'access','GLenum' ))
glBindImageTexture.add( Input( 'format','GLenum' ))
glBindImageTexture.version = ''
glBindImageTexture.category = 'GL_ARB_shader_image_load_store'
glBindImageTexture.trace = True
glBindImageTexture.play = True
gl.add(glBindImageTexture)

glMemoryBarrier = Function('glMemoryBarrier')
glMemoryBarrier.ret = Return('void')
glMemoryBarrier.add( Input( 'barriers','GLbitfield' ,regalLog = 'GLmemoryBarrierToString(barriers)' ))
glMemoryBarrier.version = ''
glMemoryBarrier.category = 'GL_ARB_shader_image_load_store'
glMemoryBarrier.trace = True
glMemoryBarrier.play = True
gl.add(glMemoryBarrier)

# GL_ARB_shader_objects

glAttachObjectARB = Function('glAttachObjectARB')
glAttachObjectARB.ret = Return('void')
glAttachObjectARB.add( Input( 'containerObj','GLhandleARB' ))
glAttachObjectARB.add( Input( 'obj','GLhandleARB' ))
glAttachObjectARB.version = '1.1'
glAttachObjectARB.category = 'GL_ARB_shader_objects'
glAttachObjectARB.trace = True
glAttachObjectARB.play = True
gl.add(glAttachObjectARB)

glCompileShaderARB = Function('glCompileShaderARB')
glCompileShaderARB.ret = Return('void')
glCompileShaderARB.add( Input( 'shaderObj','GLhandleARB' ))
glCompileShaderARB.version = '1.1'
glCompileShaderARB.category = 'GL_ARB_shader_objects'
glCompileShaderARB.trace = True
glCompileShaderARB.play = True
gl.add(glCompileShaderARB)

glCreateProgramObjectARB = Function('glCreateProgramObjectARB')
glCreateProgramObjectARB.ret = Return('GLhandleARB')
glCreateProgramObjectARB.version = '1.1'
glCreateProgramObjectARB.category = 'GL_ARB_shader_objects'
glCreateProgramObjectARB.trace = True
glCreateProgramObjectARB.play = True
gl.add(glCreateProgramObjectARB)

glCreateShaderObjectARB = Function('glCreateShaderObjectARB')
glCreateShaderObjectARB.ret = Return('GLhandleARB')
glCreateShaderObjectARB.add( Input( 'shaderType','GLenum' ))
glCreateShaderObjectARB.version = '1.1'
glCreateShaderObjectARB.category = 'GL_ARB_shader_objects'
glCreateShaderObjectARB.trace = True
glCreateShaderObjectARB.play = True
gl.add(glCreateShaderObjectARB)

glDeleteObjectARB = Function('glDeleteObjectARB')
glDeleteObjectARB.ret = Return('void')
glDeleteObjectARB.add( Input( 'obj','GLhandleARB' ))
glDeleteObjectARB.version = '1.1'
glDeleteObjectARB.category = 'GL_ARB_shader_objects'
glDeleteObjectARB.trace = True
glDeleteObjectARB.play = True
gl.add(glDeleteObjectARB)

glDetachObjectARB = Function('glDetachObjectARB')
glDetachObjectARB.ret = Return('void')
glDetachObjectARB.add( Input( 'containerObj','GLhandleARB' ))
glDetachObjectARB.add( Input( 'attachedObj','GLhandleARB' ))
glDetachObjectARB.version = '1.1'
glDetachObjectARB.category = 'GL_ARB_shader_objects'
glDetachObjectARB.trace = True
glDetachObjectARB.play = True
gl.add(glDetachObjectARB)

glGetActiveUniformARB = Function('glGetActiveUniformARB')
glGetActiveUniformARB.ret = Return('void')
glGetActiveUniformARB.add( Input( 'programObj','GLhandleARB' ))
glGetActiveUniformARB.add( Input( 'index','GLuint' ))
glGetActiveUniformARB.add( Input( 'maxLength','GLsizei' ))
glGetActiveUniformARB.add( Output( 'length','GLsizei *' ,size = 1 ))
glGetActiveUniformARB.add( Output( 'size','GLint *' ,size = 1 ))
glGetActiveUniformARB.add( Output( 'type','GLenum *' ,size = 1 ))
glGetActiveUniformARB.add( Output( 'name','GLcharARB *' ,maxSize = 'maxLength' ))
glGetActiveUniformARB.version = '1.1'
glGetActiveUniformARB.category = 'GL_ARB_shader_objects'
glGetActiveUniformARB.trace = True
glGetActiveUniformARB.play = False
gl.add(glGetActiveUniformARB)

glGetAttachedObjectsARB = Function('glGetAttachedObjectsARB')
glGetAttachedObjectsARB.ret = Return('void')
glGetAttachedObjectsARB.add( Input( 'containerObj','GLhandleARB' ))
glGetAttachedObjectsARB.add( Input( 'maxCount','GLsizei' ))
glGetAttachedObjectsARB.add( Output( 'count','GLsizei *' ,size = 1 ))
glGetAttachedObjectsARB.add( Output( 'obj','GLhandleARB *' ))
glGetAttachedObjectsARB.version = '1.1'
glGetAttachedObjectsARB.category = 'GL_ARB_shader_objects'
glGetAttachedObjectsARB.trace = True
glGetAttachedObjectsARB.play = False
gl.add(glGetAttachedObjectsARB)

glGetHandleARB = Function('glGetHandleARB')
glGetHandleARB.ret = Return('GLhandleARB')
glGetHandleARB.add( Input( 'pname','GLenum' ))
glGetHandleARB.version = '1.1'
glGetHandleARB.category = 'GL_ARB_shader_objects'
glGetHandleARB.trace = True
glGetHandleARB.play = True
gl.add(glGetHandleARB)

glGetInfoLogARB = Function('glGetInfoLogARB')
glGetInfoLogARB.ret = Return('void')
glGetInfoLogARB.add( Input( 'obj','GLhandleARB' ))
glGetInfoLogARB.add( Input( 'maxLength','GLsizei' ))
glGetInfoLogARB.add( Output( 'length','GLsizei *' ,size = 'length ? 1 : 0' ))
glGetInfoLogARB.add( Output( 'infoLog','GLcharARB *' ,maxSize = 'maxLength' ))
glGetInfoLogARB.version = '1.1'
glGetInfoLogARB.category = 'GL_ARB_shader_objects'
glGetInfoLogARB.trace = True
glGetInfoLogARB.play = False
gl.add(glGetInfoLogARB)

glGetObjectParameterfvARB = Function('glGetObjectParameterfvARB')
glGetObjectParameterfvARB.ret = Return('void')
glGetObjectParameterfvARB.add( Input( 'obj','GLhandleARB' ))
glGetObjectParameterfvARB.add( Input( 'pname','GLenum' ))
glGetObjectParameterfvARB.add( Output( 'params','GLfloat *' ))
glGetObjectParameterfvARB.version = '1.1'
glGetObjectParameterfvARB.category = 'GL_ARB_shader_objects'
glGetObjectParameterfvARB.trace = True
glGetObjectParameterfvARB.play = True
gl.add(glGetObjectParameterfvARB)

glGetObjectParameterivARB = Function('glGetObjectParameterivARB')
glGetObjectParameterivARB.ret = Return('void')
glGetObjectParameterivARB.add( Input( 'obj','GLhandleARB' ))
glGetObjectParameterivARB.add( Input( 'pname','GLenum' ))
glGetObjectParameterivARB.add( Output( 'params','GLint *' ))
glGetObjectParameterivARB.version = '1.1'
glGetObjectParameterivARB.category = 'GL_ARB_shader_objects'
glGetObjectParameterivARB.trace = True
glGetObjectParameterivARB.play = True
gl.add(glGetObjectParameterivARB)

glGetShaderSourceARB = Function('glGetShaderSourceARB')
glGetShaderSourceARB.ret = Return('void')
glGetShaderSourceARB.add( Input( 'obj','GLhandleARB' ))
glGetShaderSourceARB.add( Input( 'maxLength','GLsizei' ))
glGetShaderSourceARB.add( Output( 'length','GLsizei *' ,size = 1 ))
glGetShaderSourceARB.add( Output( 'source','GLcharARB *' ,maxSize = 'maxLength' ))
glGetShaderSourceARB.version = '1.1'
glGetShaderSourceARB.category = 'GL_ARB_shader_objects'
glGetShaderSourceARB.trace = True
glGetShaderSourceARB.play = False
gl.add(glGetShaderSourceARB)

glGetUniformLocationARB = Function('glGetUniformLocationARB')
glGetUniformLocationARB.ret = Return('GLint')
glGetUniformLocationARB.add( Input( 'programObj','GLhandleARB' ))
glGetUniformLocationARB.add( Input( 'name','const GLcharARB *' ))
glGetUniformLocationARB.version = '1.1'
glGetUniformLocationARB.category = 'GL_ARB_shader_objects'
glGetUniformLocationARB.trace = True
glGetUniformLocationARB.play = False
gl.add(glGetUniformLocationARB)

glGetUniformfvARB = Function('glGetUniformfvARB')
glGetUniformfvARB.ret = Return('void')
glGetUniformfvARB.add( Input( 'programObj','GLhandleARB' ))
glGetUniformfvARB.add( Input( 'location','GLint' ))
glGetUniformfvARB.add( Output( 'params','GLfloat *' ))
glGetUniformfvARB.version = '1.1'
glGetUniformfvARB.category = 'GL_ARB_shader_objects'
glGetUniformfvARB.trace = True
glGetUniformfvARB.play = False
gl.add(glGetUniformfvARB)

glGetUniformivARB = Function('glGetUniformivARB')
glGetUniformivARB.ret = Return('void')
glGetUniformivARB.add( Input( 'programObj','GLhandleARB' ))
glGetUniformivARB.add( Input( 'location','GLint' ))
glGetUniformivARB.add( Output( 'params','GLint *' ))
glGetUniformivARB.version = '1.1'
glGetUniformivARB.category = 'GL_ARB_shader_objects'
glGetUniformivARB.trace = True
glGetUniformivARB.play = False
gl.add(glGetUniformivARB)

glLinkProgramARB = Function('glLinkProgramARB')
glLinkProgramARB.ret = Return('void')
glLinkProgramARB.add( Input( 'programObj','GLhandleARB' ))
glLinkProgramARB.version = '1.1'
glLinkProgramARB.category = 'GL_ARB_shader_objects'
glLinkProgramARB.trace = True
glLinkProgramARB.play = True
gl.add(glLinkProgramARB)

glShaderSourceARB = Function('glShaderSourceARB')
glShaderSourceARB.ret = Return('void')
glShaderSourceARB.add( Input( 'shaderObj','GLhandleARB' ))
glShaderSourceARB.add( Input( 'count','GLsizei' ))
glShaderSourceARB.add( Input( 'string','const GLcharARB ** const' ,size = 'string ? count : 0' ,cast = 'const char ** const' ))
glShaderSourceARB.add( Input( 'length','const GLint *' ,size = 'length ? count : 0' ))
glShaderSourceARB.version = '1.1'
glShaderSourceARB.category = 'GL_ARB_shader_objects'
glShaderSourceARB.trace = True
glShaderSourceARB.play = False
gl.add(glShaderSourceARB)

glUniform1fARB = Function('glUniform1fARB')
glUniform1fARB.ret = Return('void')
glUniform1fARB.add( Input( 'location','GLint' ))
glUniform1fARB.add( Input( 'v0','GLfloat' ))
glUniform1fARB.version = '1.1'
glUniform1fARB.category = 'GL_ARB_shader_objects'
glUniform1fARB.trace = True
glUniform1fARB.play = True
gl.add(glUniform1fARB)

glUniform1fvARB = Function('glUniform1fvARB')
glUniform1fvARB.ret = Return('void')
glUniform1fvARB.add( Input( 'location','GLint' ))
glUniform1fvARB.add( Input( 'count','GLsizei' ))
glUniform1fvARB.add( Input( 'value','const GLfloat *' ))
glUniform1fvARB.version = '1.1'
glUniform1fvARB.category = 'GL_ARB_shader_objects'
glUniform1fvARB.trace = True
glUniform1fvARB.play = True
gl.add(glUniform1fvARB)

glUniform1iARB = Function('glUniform1iARB')
glUniform1iARB.ret = Return('void')
glUniform1iARB.add( Input( 'location','GLint' ))
glUniform1iARB.add( Input( 'v0','GLint' ))
glUniform1iARB.version = '1.1'
glUniform1iARB.category = 'GL_ARB_shader_objects'
glUniform1iARB.trace = True
glUniform1iARB.play = True
gl.add(glUniform1iARB)

glUniform1ivARB = Function('glUniform1ivARB')
glUniform1ivARB.ret = Return('void')
glUniform1ivARB.add( Input( 'location','GLint' ))
glUniform1ivARB.add( Input( 'count','GLsizei' ))
glUniform1ivARB.add( Input( 'value','const GLint *' ))
glUniform1ivARB.version = '1.1'
glUniform1ivARB.category = 'GL_ARB_shader_objects'
glUniform1ivARB.trace = True
glUniform1ivARB.play = True
gl.add(glUniform1ivARB)

glUniform2fARB = Function('glUniform2fARB')
glUniform2fARB.ret = Return('void')
glUniform2fARB.add( Input( 'location','GLint' ))
glUniform2fARB.add( Input( 'v0','GLfloat' ))
glUniform2fARB.add( Input( 'v1','GLfloat' ))
glUniform2fARB.version = '1.1'
glUniform2fARB.category = 'GL_ARB_shader_objects'
glUniform2fARB.trace = True
glUniform2fARB.play = True
gl.add(glUniform2fARB)

glUniform2fvARB = Function('glUniform2fvARB')
glUniform2fvARB.ret = Return('void')
glUniform2fvARB.add( Input( 'location','GLint' ))
glUniform2fvARB.add( Input( 'count','GLsizei' ))
glUniform2fvARB.add( Input( 'value','const GLfloat *' ))
glUniform2fvARB.version = '1.1'
glUniform2fvARB.category = 'GL_ARB_shader_objects'
glUniform2fvARB.trace = True
glUniform2fvARB.play = True
gl.add(glUniform2fvARB)

glUniform2iARB = Function('glUniform2iARB')
glUniform2iARB.ret = Return('void')
glUniform2iARB.add( Input( 'location','GLint' ))
glUniform2iARB.add( Input( 'v0','GLint' ))
glUniform2iARB.add( Input( 'v1','GLint' ))
glUniform2iARB.version = '1.1'
glUniform2iARB.category = 'GL_ARB_shader_objects'
glUniform2iARB.trace = True
glUniform2iARB.play = True
gl.add(glUniform2iARB)

glUniform2ivARB = Function('glUniform2ivARB')
glUniform2ivARB.ret = Return('void')
glUniform2ivARB.add( Input( 'location','GLint' ))
glUniform2ivARB.add( Input( 'count','GLsizei' ))
glUniform2ivARB.add( Input( 'value','const GLint *' ))
glUniform2ivARB.version = '1.1'
glUniform2ivARB.category = 'GL_ARB_shader_objects'
glUniform2ivARB.trace = True
glUniform2ivARB.play = True
gl.add(glUniform2ivARB)

glUniform3fARB = Function('glUniform3fARB')
glUniform3fARB.ret = Return('void')
glUniform3fARB.add( Input( 'location','GLint' ))
glUniform3fARB.add( Input( 'v0','GLfloat' ))
glUniform3fARB.add( Input( 'v1','GLfloat' ))
glUniform3fARB.add( Input( 'v2','GLfloat' ))
glUniform3fARB.version = '1.1'
glUniform3fARB.category = 'GL_ARB_shader_objects'
glUniform3fARB.trace = True
glUniform3fARB.play = True
gl.add(glUniform3fARB)

glUniform3fvARB = Function('glUniform3fvARB')
glUniform3fvARB.ret = Return('void')
glUniform3fvARB.add( Input( 'location','GLint' ))
glUniform3fvARB.add( Input( 'count','GLsizei' ))
glUniform3fvARB.add( Input( 'value','const GLfloat *' ))
glUniform3fvARB.version = '1.1'
glUniform3fvARB.category = 'GL_ARB_shader_objects'
glUniform3fvARB.trace = True
glUniform3fvARB.play = True
gl.add(glUniform3fvARB)

glUniform3iARB = Function('glUniform3iARB')
glUniform3iARB.ret = Return('void')
glUniform3iARB.add( Input( 'location','GLint' ))
glUniform3iARB.add( Input( 'v0','GLint' ))
glUniform3iARB.add( Input( 'v1','GLint' ))
glUniform3iARB.add( Input( 'v2','GLint' ))
glUniform3iARB.version = '1.1'
glUniform3iARB.category = 'GL_ARB_shader_objects'
glUniform3iARB.trace = True
glUniform3iARB.play = True
gl.add(glUniform3iARB)

glUniform3ivARB = Function('glUniform3ivARB')
glUniform3ivARB.ret = Return('void')
glUniform3ivARB.add( Input( 'location','GLint' ))
glUniform3ivARB.add( Input( 'count','GLsizei' ))
glUniform3ivARB.add( Input( 'value','const GLint *' ))
glUniform3ivARB.version = '1.1'
glUniform3ivARB.category = 'GL_ARB_shader_objects'
glUniform3ivARB.trace = True
glUniform3ivARB.play = True
gl.add(glUniform3ivARB)

glUniform4fARB = Function('glUniform4fARB')
glUniform4fARB.ret = Return('void')
glUniform4fARB.add( Input( 'location','GLint' ))
glUniform4fARB.add( Input( 'v0','GLfloat' ))
glUniform4fARB.add( Input( 'v1','GLfloat' ))
glUniform4fARB.add( Input( 'v2','GLfloat' ))
glUniform4fARB.add( Input( 'v3','GLfloat' ))
glUniform4fARB.version = '1.1'
glUniform4fARB.category = 'GL_ARB_shader_objects'
glUniform4fARB.trace = True
glUniform4fARB.play = True
gl.add(glUniform4fARB)

glUniform4fvARB = Function('glUniform4fvARB')
glUniform4fvARB.ret = Return('void')
glUniform4fvARB.add( Input( 'location','GLint' ))
glUniform4fvARB.add( Input( 'count','GLsizei' ))
glUniform4fvARB.add( Input( 'value','const GLfloat *' ))
glUniform4fvARB.version = '1.1'
glUniform4fvARB.category = 'GL_ARB_shader_objects'
glUniform4fvARB.trace = True
glUniform4fvARB.play = True
gl.add(glUniform4fvARB)

glUniform4iARB = Function('glUniform4iARB')
glUniform4iARB.ret = Return('void')
glUniform4iARB.add( Input( 'location','GLint' ))
glUniform4iARB.add( Input( 'v0','GLint' ))
glUniform4iARB.add( Input( 'v1','GLint' ))
glUniform4iARB.add( Input( 'v2','GLint' ))
glUniform4iARB.add( Input( 'v3','GLint' ))
glUniform4iARB.version = '1.1'
glUniform4iARB.category = 'GL_ARB_shader_objects'
glUniform4iARB.trace = True
glUniform4iARB.play = True
gl.add(glUniform4iARB)

glUniform4ivARB = Function('glUniform4ivARB')
glUniform4ivARB.ret = Return('void')
glUniform4ivARB.add( Input( 'location','GLint' ))
glUniform4ivARB.add( Input( 'count','GLsizei' ))
glUniform4ivARB.add( Input( 'value','const GLint *' ))
glUniform4ivARB.version = '1.1'
glUniform4ivARB.category = 'GL_ARB_shader_objects'
glUniform4ivARB.trace = True
glUniform4ivARB.play = True
gl.add(glUniform4ivARB)

glUniformMatrix2fvARB = Function('glUniformMatrix2fvARB')
glUniformMatrix2fvARB.ret = Return('void')
glUniformMatrix2fvARB.add( Input( 'location','GLint' ))
glUniformMatrix2fvARB.add( Input( 'count','GLsizei' ))
glUniformMatrix2fvARB.add( Input( 'transpose','GLboolean' ))
glUniformMatrix2fvARB.add( Input( 'value','const GLfloat *' ,size = '2 * 2 * count' ))
glUniformMatrix2fvARB.version = '1.1'
glUniformMatrix2fvARB.category = 'GL_ARB_shader_objects'
glUniformMatrix2fvARB.trace = True
glUniformMatrix2fvARB.play = True
gl.add(glUniformMatrix2fvARB)

glUniformMatrix3fvARB = Function('glUniformMatrix3fvARB')
glUniformMatrix3fvARB.ret = Return('void')
glUniformMatrix3fvARB.add( Input( 'location','GLint' ))
glUniformMatrix3fvARB.add( Input( 'count','GLsizei' ))
glUniformMatrix3fvARB.add( Input( 'transpose','GLboolean' ))
glUniformMatrix3fvARB.add( Input( 'value','const GLfloat *' ,size = '3 * 3 * count' ))
glUniformMatrix3fvARB.version = '1.1'
glUniformMatrix3fvARB.category = 'GL_ARB_shader_objects'
glUniformMatrix3fvARB.trace = True
glUniformMatrix3fvARB.play = True
gl.add(glUniformMatrix3fvARB)

glUniformMatrix4fvARB = Function('glUniformMatrix4fvARB')
glUniformMatrix4fvARB.ret = Return('void')
glUniformMatrix4fvARB.add( Input( 'location','GLint' ))
glUniformMatrix4fvARB.add( Input( 'count','GLsizei' ))
glUniformMatrix4fvARB.add( Input( 'transpose','GLboolean' ))
glUniformMatrix4fvARB.add( Input( 'value','const GLfloat *' ,size = '4 * 4 * count' ))
glUniformMatrix4fvARB.version = '1.1'
glUniformMatrix4fvARB.category = 'GL_ARB_shader_objects'
glUniformMatrix4fvARB.trace = True
glUniformMatrix4fvARB.play = True
gl.add(glUniformMatrix4fvARB)

glUseProgramObjectARB = Function('glUseProgramObjectARB')
glUseProgramObjectARB.ret = Return('void')
glUseProgramObjectARB.add( Input( 'programObj','GLhandleARB' ))
glUseProgramObjectARB.version = '1.1'
glUseProgramObjectARB.category = 'GL_ARB_shader_objects'
glUseProgramObjectARB.trace = True
glUseProgramObjectARB.play = True
gl.add(glUseProgramObjectARB)

glValidateProgramARB = Function('glValidateProgramARB')
glValidateProgramARB.ret = Return('void')
glValidateProgramARB.add( Input( 'programObj','GLhandleARB' ))
glValidateProgramARB.version = '1.1'
glValidateProgramARB.category = 'GL_ARB_shader_objects'
glValidateProgramARB.trace = True
glValidateProgramARB.play = True
gl.add(glValidateProgramARB)

# GL_ARB_shader_storage_buffer_object

glShaderStorageBlockBinding = Function('glShaderStorageBlockBinding')
glShaderStorageBlockBinding.ret = Return('void')
glShaderStorageBlockBinding.add( Input( 'program','GLuint' ))
glShaderStorageBlockBinding.add( Input( 'storageBlockIndex','GLuint' ))
glShaderStorageBlockBinding.add( Input( 'storageBlockBinding','GLuint' ))
glShaderStorageBlockBinding.version = ''
glShaderStorageBlockBinding.category = 'GL_ARB_shader_storage_buffer_object'
glShaderStorageBlockBinding.trace = True
glShaderStorageBlockBinding.play = True
gl.add(glShaderStorageBlockBinding)

# GL_ARB_shader_subroutine

glGetActiveSubroutineName = Function('glGetActiveSubroutineName')
glGetActiveSubroutineName.ret = Return('void')
glGetActiveSubroutineName.add( Input( 'program','GLuint' ))
glGetActiveSubroutineName.add( Input( 'shaderType','GLenum' ))
glGetActiveSubroutineName.add( Input( 'index','GLuint' ))
glGetActiveSubroutineName.add( Input( 'bufSize','GLsizei' ))
glGetActiveSubroutineName.add( Output( 'length','GLsizei *' ,size = 1 ))
glGetActiveSubroutineName.add( Output( 'name','GLchar *' ,maxSize = 'bufSize' ))
glGetActiveSubroutineName.version = '4.0'
glGetActiveSubroutineName.category = 'GL_ARB_shader_subroutine'
glGetActiveSubroutineName.trace = True
glGetActiveSubroutineName.play = True
gl.add(glGetActiveSubroutineName)

glGetActiveSubroutineUniformName = Function('glGetActiveSubroutineUniformName')
glGetActiveSubroutineUniformName.ret = Return('void')
glGetActiveSubroutineUniformName.add( Input( 'program','GLuint' ))
glGetActiveSubroutineUniformName.add( Input( 'shaderType','GLenum' ))
glGetActiveSubroutineUniformName.add( Input( 'index','GLuint' ))
glGetActiveSubroutineUniformName.add( Input( 'bufSize','GLsizei' ))
glGetActiveSubroutineUniformName.add( Output( 'length','GLsizei *' ,size = 1 ))
glGetActiveSubroutineUniformName.add( Output( 'name','GLchar *' ,maxSize = 'bufSize' ))
glGetActiveSubroutineUniformName.version = '4.0'
glGetActiveSubroutineUniformName.category = 'GL_ARB_shader_subroutine'
glGetActiveSubroutineUniformName.trace = True
glGetActiveSubroutineUniformName.play = True
gl.add(glGetActiveSubroutineUniformName)

glGetActiveSubroutineUniformiv = Function('glGetActiveSubroutineUniformiv')
glGetActiveSubroutineUniformiv.ret = Return('void')
glGetActiveSubroutineUniformiv.add( Input( 'program','GLuint' ))
glGetActiveSubroutineUniformiv.add( Input( 'shaderType','GLenum' ))
glGetActiveSubroutineUniformiv.add( Input( 'index','GLuint' ))
glGetActiveSubroutineUniformiv.add( Input( 'pname','GLenum' ))
glGetActiveSubroutineUniformiv.add( Output( 'values','GLint *' ))
glGetActiveSubroutineUniformiv.version = '4.0'
glGetActiveSubroutineUniformiv.category = 'GL_ARB_shader_subroutine'
glGetActiveSubroutineUniformiv.trace = True
glGetActiveSubroutineUniformiv.play = True
gl.add(glGetActiveSubroutineUniformiv)

glGetProgramStageiv = Function('glGetProgramStageiv')
glGetProgramStageiv.ret = Return('void')
glGetProgramStageiv.add( Input( 'program','GLuint' ))
glGetProgramStageiv.add( Input( 'shaderType','GLenum' ))
glGetProgramStageiv.add( Input( 'pname','GLenum' ))
glGetProgramStageiv.add( Output( 'values','GLint *' ,size = 1 ))
glGetProgramStageiv.version = '4.0'
glGetProgramStageiv.category = 'GL_ARB_shader_subroutine'
glGetProgramStageiv.trace = True
glGetProgramStageiv.play = True
gl.add(glGetProgramStageiv)

glGetProgramSubroutineParameteruivNV = Function('glGetProgramSubroutineParameteruivNV')
glGetProgramSubroutineParameteruivNV.ret = Return('void')
glGetProgramSubroutineParameteruivNV.add( Input( 'target','GLenum' ))
glGetProgramSubroutineParameteruivNV.add( Input( 'index','GLuint' ))
glGetProgramSubroutineParameteruivNV.add( Output( 'params','GLuint *' ,size = 1 ))
glGetProgramSubroutineParameteruivNV.version = '4.0'
glGetProgramSubroutineParameteruivNV.category = 'GL_ARB_shader_subroutine'
glGetProgramSubroutineParameteruivNV.trace = True
glGetProgramSubroutineParameteruivNV.play = True
gl.add(glGetProgramSubroutineParameteruivNV)

glGetSubroutineIndex = Function('glGetSubroutineIndex')
glGetSubroutineIndex.ret = Return('GLuint')
glGetSubroutineIndex.add( Input( 'program','GLuint' ))
glGetSubroutineIndex.add( Input( 'shaderType','GLenum' ))
glGetSubroutineIndex.add( Input( 'name','const GLchar *' ))
glGetSubroutineIndex.version = '4.0'
glGetSubroutineIndex.category = 'GL_ARB_shader_subroutine'
glGetSubroutineIndex.trace = True
glGetSubroutineIndex.play = True
gl.add(glGetSubroutineIndex)

glGetSubroutineUniformLocation = Function('glGetSubroutineUniformLocation')
glGetSubroutineUniformLocation.ret = Return('GLint')
glGetSubroutineUniformLocation.add( Input( 'program','GLuint' ))
glGetSubroutineUniformLocation.add( Input( 'shaderType','GLenum' ))
glGetSubroutineUniformLocation.add( Input( 'name','const GLchar *' ))
glGetSubroutineUniformLocation.version = '4.0'
glGetSubroutineUniformLocation.category = 'GL_ARB_shader_subroutine'
glGetSubroutineUniformLocation.trace = True
glGetSubroutineUniformLocation.play = True
gl.add(glGetSubroutineUniformLocation)

glGetUniformSubroutineuiv = Function('glGetUniformSubroutineuiv')
glGetUniformSubroutineuiv.ret = Return('void')
glGetUniformSubroutineuiv.add( Input( 'shaderType','GLenum' ))
glGetUniformSubroutineuiv.add( Input( 'location','GLint' ))
glGetUniformSubroutineuiv.add( Output( 'params','GLuint *' ,size = 1 ))
glGetUniformSubroutineuiv.version = '4.0'
glGetUniformSubroutineuiv.category = 'GL_ARB_shader_subroutine'
glGetUniformSubroutineuiv.trace = True
glGetUniformSubroutineuiv.play = True
gl.add(glGetUniformSubroutineuiv)

glProgramSubroutineParametersuivNV = Function('glProgramSubroutineParametersuivNV')
glProgramSubroutineParametersuivNV.ret = Return('void')
glProgramSubroutineParametersuivNV.add( Input( 'target','GLenum' ))
glProgramSubroutineParametersuivNV.add( Input( 'count','GLsizei' ))
glProgramSubroutineParametersuivNV.add( Input( 'params','const GLuint *' ,size = 'count' ))
glProgramSubroutineParametersuivNV.version = '4.0'
glProgramSubroutineParametersuivNV.category = 'GL_ARB_shader_subroutine'
glProgramSubroutineParametersuivNV.trace = True
glProgramSubroutineParametersuivNV.play = True
gl.add(glProgramSubroutineParametersuivNV)

glUniformSubroutinesuiv = Function('glUniformSubroutinesuiv')
glUniformSubroutinesuiv.ret = Return('void')
glUniformSubroutinesuiv.add( Input( 'shaderType','GLenum' ))
glUniformSubroutinesuiv.add( Input( 'count','GLsizei' ))
glUniformSubroutinesuiv.add( Input( 'indices','const GLuint *' ,size = 'count' ))
glUniformSubroutinesuiv.version = '4.0'
glUniformSubroutinesuiv.category = 'GL_ARB_shader_subroutine'
glUniformSubroutinesuiv.trace = True
glUniformSubroutinesuiv.play = True
gl.add(glUniformSubroutinesuiv)

# GL_ARB_shading_language_include

glCompileShaderIncludeARB = Function('glCompileShaderIncludeARB')
glCompileShaderIncludeARB.ret = Return('void')
glCompileShaderIncludeARB.add( Input( 'shader','GLuint' ))
glCompileShaderIncludeARB.add( Input( 'count','GLsizei' ))
glCompileShaderIncludeARB.add( Input( 'path','const GLchar * const *' ,size = 'count' ))
glCompileShaderIncludeARB.add( Input( 'length','const GLint *' ,size = 'count' ))
glCompileShaderIncludeARB.version = '4.0'
glCompileShaderIncludeARB.category = 'GL_ARB_shading_language_include'
glCompileShaderIncludeARB.trace = True
glCompileShaderIncludeARB.play = True
gl.add(glCompileShaderIncludeARB)

glDeleteNamedStringARB = Function('glDeleteNamedStringARB')
glDeleteNamedStringARB.ret = Return('void')
glDeleteNamedStringARB.add( Input( 'namelen','GLint' ))
glDeleteNamedStringARB.add( Input( 'name','const GLchar *' ,size = 'helperGLNamedStringSize(namelen, name)' ))
glDeleteNamedStringARB.version = '4.0'
glDeleteNamedStringARB.category = 'GL_ARB_shading_language_include'
glDeleteNamedStringARB.trace = True
glDeleteNamedStringARB.play = True
gl.add(glDeleteNamedStringARB)

glGetNamedStringARB = Function('glGetNamedStringARB')
glGetNamedStringARB.ret = Return('void')
glGetNamedStringARB.add( Input( 'namelen','GLint' ))
glGetNamedStringARB.add( Input( 'name','const GLchar *' ,size = 'helperGLNamedStringSize(namelen, name)' ))
glGetNamedStringARB.add( Input( 'bufSize','GLsizei' ))
glGetNamedStringARB.add( Output( 'stringlen','GLint *' ,size = 1 ))
glGetNamedStringARB.add( Output( 'string','GLchar *' ,maxSize = 'bufSize' ))
glGetNamedStringARB.version = '4.0'
glGetNamedStringARB.category = 'GL_ARB_shading_language_include'
glGetNamedStringARB.trace = True
glGetNamedStringARB.play = True
gl.add(glGetNamedStringARB)

glGetNamedStringivARB = Function('glGetNamedStringivARB')
glGetNamedStringivARB.ret = Return('void')
glGetNamedStringivARB.add( Input( 'namelen','GLint' ))
glGetNamedStringivARB.add( Input( 'name','const GLchar *' ,size = 'helperGLNamedStringSize(namelen, name)' ))
glGetNamedStringivARB.add( Input( 'pname','GLenum' ))
glGetNamedStringivARB.add( Output( 'params','GLint *' ,size = 'helperGLNamedStringParamsSize(pname)' ))
glGetNamedStringivARB.version = '4.0'
glGetNamedStringivARB.category = 'GL_ARB_shading_language_include'
glGetNamedStringivARB.trace = True
glGetNamedStringivARB.play = True
gl.add(glGetNamedStringivARB)

glIsNamedStringARB = Function('glIsNamedStringARB')
glIsNamedStringARB.ret = Return('GLboolean')
glIsNamedStringARB.add( Input( 'namelen','GLint' ))
glIsNamedStringARB.add( Input( 'name','const GLchar *' ,size = 'helperGLNamedStringSize(namelen, name)' ))
glIsNamedStringARB.version = '4.0'
glIsNamedStringARB.category = 'GL_ARB_shading_language_include'
glIsNamedStringARB.trace = True
glIsNamedStringARB.play = True
gl.add(glIsNamedStringARB)

glNamedStringARB = Function('glNamedStringARB')
glNamedStringARB.ret = Return('void')
glNamedStringARB.add( Input( 'type','GLenum' ))
glNamedStringARB.add( Input( 'namelen','GLint' ))
glNamedStringARB.add( Input( 'name','const GLchar *' ,size = 'helperGLNamedStringSize(namelen, name)' ))
glNamedStringARB.add( Input( 'stringlen','GLint' ))
glNamedStringARB.add( Input( 'string','const GLchar *' ,size = 'helperGLNamedStringSize(stringlen, string)' ))
glNamedStringARB.version = '4.0'
glNamedStringARB.category = 'GL_ARB_shading_language_include'
glNamedStringARB.trace = True
glNamedStringARB.play = True
gl.add(glNamedStringARB)

# GL_ARB_sparse_texture

glTexPageCommitmentARB = Function('glTexPageCommitmentARB')
glTexPageCommitmentARB.ret = Return('void')
glTexPageCommitmentARB.add( Input( 'target','GLenum' ))
glTexPageCommitmentARB.add( Input( 'level','GLint' ))
glTexPageCommitmentARB.add( Input( 'xoffset','GLint' ))
glTexPageCommitmentARB.add( Input( 'yoffset','GLint' ))
glTexPageCommitmentARB.add( Input( 'zoffset','GLint' ))
glTexPageCommitmentARB.add( Input( 'width','GLsizei' ))
glTexPageCommitmentARB.add( Input( 'height','GLsizei' ))
glTexPageCommitmentARB.add( Input( 'depth','GLsizei' ))
glTexPageCommitmentARB.add( Input( 'commit','GLboolean' ))
glTexPageCommitmentARB.version = ''
glTexPageCommitmentARB.category = 'GL_ARB_sparse_texture'
glTexPageCommitmentARB.trace = True
glTexPageCommitmentARB.play = True
gl.add(glTexPageCommitmentARB)

glTexturePageCommitmentEXT = Function('glTexturePageCommitmentEXT')
glTexturePageCommitmentEXT.ret = Return('void')
glTexturePageCommitmentEXT.add( Input( 'texture','GLuint' ))
glTexturePageCommitmentEXT.add( Input( 'target','GLenum' ))
glTexturePageCommitmentEXT.add( Input( 'level','GLint' ))
glTexturePageCommitmentEXT.add( Input( 'xoffset','GLint' ))
glTexturePageCommitmentEXT.add( Input( 'yoffset','GLint' ))
glTexturePageCommitmentEXT.add( Input( 'zoffset','GLint' ))
glTexturePageCommitmentEXT.add( Input( 'width','GLsizei' ))
glTexturePageCommitmentEXT.add( Input( 'height','GLsizei' ))
glTexturePageCommitmentEXT.add( Input( 'depth','GLsizei' ))
glTexturePageCommitmentEXT.add( Input( 'commit','GLboolean' ))
glTexturePageCommitmentEXT.version = ''
glTexturePageCommitmentEXT.category = 'GL_ARB_sparse_texture'
glTexturePageCommitmentEXT.trace = True
glTexturePageCommitmentEXT.play = True
gl.add(glTexturePageCommitmentEXT)

# GL_ARB_sync

glClientWaitSync = Function('glClientWaitSync')
glClientWaitSync.ret = Return('GLenum')
glClientWaitSync.add( Input( 'sync','GLsync' ,cast = 'void *' ))
glClientWaitSync.add( Input( 'flags','GLbitfield' ,regalLog = 'GLclientWaitSyncToString(flags)' ))
glClientWaitSync.add( Input( 'timeout','GLuint64' ))
glClientWaitSync.version = '3.2'
glClientWaitSync.category = 'GL_ARB_sync'
glClientWaitSync.trace = True
glClientWaitSync.play = True
gl.add(glClientWaitSync)

glDeleteSync = Function('glDeleteSync')
glDeleteSync.ret = Return('void')
glDeleteSync.add( Input( 'sync','GLsync' ,cast = 'void *' ))
glDeleteSync.version = '3.2'
glDeleteSync.category = 'GL_ARB_sync'
glDeleteSync.trace = True
glDeleteSync.play = True
gl.add(glDeleteSync)

glFenceSync = Function('glFenceSync')
glFenceSync.ret = Return('GLsync')
glFenceSync.ret.cast = 'void *'
glFenceSync.add( Input( 'condition','GLenum' ))
glFenceSync.add( Input( 'flags','GLbitfield' ,regalLog = 'GLfenceSyncToString(flags)' ))
glFenceSync.version = '3.2'
glFenceSync.category = 'GL_ARB_sync'
glFenceSync.trace = True
glFenceSync.play = True
gl.add(glFenceSync)

glGetInteger64v = Function('glGetInteger64v')
glGetInteger64v.ret = Return('void')
glGetInteger64v.add( Input( 'pname','GLenum' ))
glGetInteger64v.add( Output( 'params','GLint64 *' ))
glGetInteger64v.version = '3.2'
glGetInteger64v.category = 'GL_ARB_sync'
glGetInteger64v.trace = True
glGetInteger64v.play = False
gl.add(glGetInteger64v)

glGetSynciv = Function('glGetSynciv')
glGetSynciv.ret = Return('void')
glGetSynciv.add( Input( 'sync','GLsync' ,cast = 'void *' ))
glGetSynciv.add( Input( 'pname','GLenum' ))
glGetSynciv.add( Input( 'bufSize','GLsizei' ))
glGetSynciv.add( Output( 'length','GLsizei *' ,size = 1 ))
glGetSynciv.add( Output( 'values','GLint *' ,size = 'bufSize' ))
glGetSynciv.version = '3.2'
glGetSynciv.category = 'GL_ARB_sync'
glGetSynciv.trace = True
glGetSynciv.play = True
gl.add(glGetSynciv)

glIsSync = Function('glIsSync')
glIsSync.ret = Return('GLboolean')
glIsSync.add( Input( 'sync','GLsync' ,cast = 'void *' ))
glIsSync.version = '3.2'
glIsSync.category = 'GL_ARB_sync'
glIsSync.trace = True
glIsSync.play = True
gl.add(glIsSync)

glWaitSync = Function('glWaitSync')
glWaitSync.ret = Return('void')
glWaitSync.add( Input( 'sync','GLsync' ,cast = 'void *' ))
glWaitSync.add( Input( 'flags','GLbitfield' ,regalLog = 'GLwaitSyncToString(flags)' ))
glWaitSync.add( Input( 'timeout','GLuint64' ))
glWaitSync.version = '3.2'
glWaitSync.category = 'GL_ARB_sync'
glWaitSync.trace = True
glWaitSync.play = True
gl.add(glWaitSync)

# GL_ARB_tessellation_shader

glPatchParameterfv = Function('glPatchParameterfv')
glPatchParameterfv.ret = Return('void')
glPatchParameterfv.add( Input( 'pname','GLenum' ))
glPatchParameterfv.add( Input( 'values','const GLfloat *' ,size = '1' ))
glPatchParameterfv.version = '4.0'
glPatchParameterfv.category = 'GL_ARB_tessellation_shader'
glPatchParameterfv.trace = True
glPatchParameterfv.play = True
gl.add(glPatchParameterfv)

glPatchParameteri = Function('glPatchParameteri')
glPatchParameteri.ret = Return('void')
glPatchParameteri.add( Input( 'pname','GLenum' ))
glPatchParameteri.add( Input( 'value','GLint' ))
glPatchParameteri.version = '4.0'
glPatchParameteri.category = 'GL_ARB_tessellation_shader'
glPatchParameteri.trace = True
glPatchParameteri.play = True
gl.add(glPatchParameteri)

# GL_ARB_texture_buffer_object

glTexBufferARB = Function('glTexBufferARB')
glTexBufferARB.ret = Return('void')
glTexBufferARB.add( Input( 'target','GLenum' ))
glTexBufferARB.add( Input( 'internalformat','GLenum' ))
glTexBufferARB.add( Input( 'buffer','GLuint' ))
glTexBufferARB.version = '3.0'
glTexBufferARB.category = 'GL_ARB_texture_buffer_object'
glTexBufferARB.trace = True
glTexBufferARB.play = True
gl.add(glTexBufferARB)

# GL_ARB_texture_buffer_range

glTexBufferRange = Function('glTexBufferRange')
glTexBufferRange.ret = Return('void')
glTexBufferRange.add( Input( 'target','GLenum' ))
glTexBufferRange.add( Input( 'internalformat','GLenum' ))
glTexBufferRange.add( Input( 'buffer','GLuint' ))
glTexBufferRange.add( Input( 'offset','GLintptr' ))
glTexBufferRange.add( Input( 'size','GLsizeiptr' ))
glTexBufferRange.version = ''
glTexBufferRange.category = 'GL_ARB_texture_buffer_range'
glTexBufferRange.trace = True
glTexBufferRange.play = True
gl.add(glTexBufferRange)

glTextureBufferRangeEXT = Function('glTextureBufferRangeEXT')
glTextureBufferRangeEXT.ret = Return('void')
glTextureBufferRangeEXT.add( Input( 'texture','GLuint' ))
glTextureBufferRangeEXT.add( Input( 'target','GLenum' ))
glTextureBufferRangeEXT.add( Input( 'internalformat','GLenum' ))
glTextureBufferRangeEXT.add( Input( 'buffer','GLuint' ))
glTextureBufferRangeEXT.add( Input( 'offset','GLintptr' ))
glTextureBufferRangeEXT.add( Input( 'size','GLsizeiptr' ))
glTextureBufferRangeEXT.version = ''
glTextureBufferRangeEXT.category = 'GL_ARB_texture_buffer_range'
glTextureBufferRangeEXT.trace = True
glTextureBufferRangeEXT.play = True
gl.add(glTextureBufferRangeEXT)

# GL_ARB_texture_compression

glCompressedTexImage1DARB = Function('glCompressedTexImage1DARB')
glCompressedTexImage1DARB.ret = Return('void')
glCompressedTexImage1DARB.add( Input( 'target','GLenum' ))
glCompressedTexImage1DARB.add( Input( 'level','GLint' ))
glCompressedTexImage1DARB.add( Input( 'internalformat','GLenum' ))
glCompressedTexImage1DARB.add( Input( 'width','GLsizei' ))
glCompressedTexImage1DARB.add( Input( 'border','GLint' ))
glCompressedTexImage1DARB.add( Input( 'imageSize','GLsizei' ))
glCompressedTexImage1DARB.add( Input( 'data','const GLvoid *' ,size = 'imageSize' ))
glCompressedTexImage1DARB.version = '1.1'
glCompressedTexImage1DARB.category = 'GL_ARB_texture_compression'
glCompressedTexImage1DARB.trace = True
glCompressedTexImage1DARB.play = True
gl.add(glCompressedTexImage1DARB)

glCompressedTexImage2DARB = Function('glCompressedTexImage2DARB')
glCompressedTexImage2DARB.ret = Return('void')
glCompressedTexImage2DARB.add( Input( 'target','GLenum' ))
glCompressedTexImage2DARB.add( Input( 'level','GLint' ))
glCompressedTexImage2DARB.add( Input( 'internalformat','GLenum' ))
glCompressedTexImage2DARB.add( Input( 'width','GLsizei' ))
glCompressedTexImage2DARB.add( Input( 'height','GLsizei' ))
glCompressedTexImage2DARB.add( Input( 'border','GLint' ))
glCompressedTexImage2DARB.add( Input( 'imageSize','GLsizei' ))
glCompressedTexImage2DARB.add( Input( 'data','const GLvoid *' ,size = 'imageSize' ))
glCompressedTexImage2DARB.version = '1.1'
glCompressedTexImage2DARB.category = 'GL_ARB_texture_compression'
glCompressedTexImage2DARB.trace = True
glCompressedTexImage2DARB.play = True
gl.add(glCompressedTexImage2DARB)

glCompressedTexImage3DARB = Function('glCompressedTexImage3DARB')
glCompressedTexImage3DARB.ret = Return('void')
glCompressedTexImage3DARB.add( Input( 'target','GLenum' ))
glCompressedTexImage3DARB.add( Input( 'level','GLint' ))
glCompressedTexImage3DARB.add( Input( 'internalformat','GLenum' ))
glCompressedTexImage3DARB.add( Input( 'width','GLsizei' ))
glCompressedTexImage3DARB.add( Input( 'height','GLsizei' ))
glCompressedTexImage3DARB.add( Input( 'depth','GLsizei' ))
glCompressedTexImage3DARB.add( Input( 'border','GLint' ))
glCompressedTexImage3DARB.add( Input( 'imageSize','GLsizei' ))
glCompressedTexImage3DARB.add( Input( 'data','const GLvoid *' ,size = 'imageSize' ))
glCompressedTexImage3DARB.version = '1.1'
glCompressedTexImage3DARB.category = 'GL_ARB_texture_compression'
glCompressedTexImage3DARB.trace = True
glCompressedTexImage3DARB.play = True
gl.add(glCompressedTexImage3DARB)

glCompressedTexSubImage1DARB = Function('glCompressedTexSubImage1DARB')
glCompressedTexSubImage1DARB.ret = Return('void')
glCompressedTexSubImage1DARB.add( Input( 'target','GLenum' ))
glCompressedTexSubImage1DARB.add( Input( 'level','GLint' ))
glCompressedTexSubImage1DARB.add( Input( 'xoffset','GLint' ))
glCompressedTexSubImage1DARB.add( Input( 'width','GLsizei' ))
glCompressedTexSubImage1DARB.add( Input( 'format','GLenum' ))
glCompressedTexSubImage1DARB.add( Input( 'imageSize','GLsizei' ))
glCompressedTexSubImage1DARB.add( Input( 'data','const GLvoid *' ,size = 'imageSize' ))
glCompressedTexSubImage1DARB.version = '1.1'
glCompressedTexSubImage1DARB.category = 'GL_ARB_texture_compression'
glCompressedTexSubImage1DARB.trace = True
glCompressedTexSubImage1DARB.play = True
gl.add(glCompressedTexSubImage1DARB)

glCompressedTexSubImage2DARB = Function('glCompressedTexSubImage2DARB')
glCompressedTexSubImage2DARB.ret = Return('void')
glCompressedTexSubImage2DARB.add( Input( 'target','GLenum' ))
glCompressedTexSubImage2DARB.add( Input( 'level','GLint' ))
glCompressedTexSubImage2DARB.add( Input( 'xoffset','GLint' ))
glCompressedTexSubImage2DARB.add( Input( 'yoffset','GLint' ))
glCompressedTexSubImage2DARB.add( Input( 'width','GLsizei' ))
glCompressedTexSubImage2DARB.add( Input( 'height','GLsizei' ))
glCompressedTexSubImage2DARB.add( Input( 'format','GLenum' ))
glCompressedTexSubImage2DARB.add( Input( 'imageSize','GLsizei' ))
glCompressedTexSubImage2DARB.add( Input( 'data','const GLvoid *' ,size = 'imageSize' ))
glCompressedTexSubImage2DARB.version = '1.1'
glCompressedTexSubImage2DARB.category = 'GL_ARB_texture_compression'
glCompressedTexSubImage2DARB.trace = True
glCompressedTexSubImage2DARB.play = True
gl.add(glCompressedTexSubImage2DARB)

glCompressedTexSubImage3DARB = Function('glCompressedTexSubImage3DARB')
glCompressedTexSubImage3DARB.ret = Return('void')
glCompressedTexSubImage3DARB.add( Input( 'target','GLenum' ))
glCompressedTexSubImage3DARB.add( Input( 'level','GLint' ))
glCompressedTexSubImage3DARB.add( Input( 'xoffset','GLint' ))
glCompressedTexSubImage3DARB.add( Input( 'yoffset','GLint' ))
glCompressedTexSubImage3DARB.add( Input( 'zoffset','GLint' ))
glCompressedTexSubImage3DARB.add( Input( 'width','GLsizei' ))
glCompressedTexSubImage3DARB.add( Input( 'height','GLsizei' ))
glCompressedTexSubImage3DARB.add( Input( 'depth','GLsizei' ))
glCompressedTexSubImage3DARB.add( Input( 'format','GLenum' ))
glCompressedTexSubImage3DARB.add( Input( 'imageSize','GLsizei' ))
glCompressedTexSubImage3DARB.add( Input( 'data','const GLvoid *' ,size = 'imageSize' ))
glCompressedTexSubImage3DARB.version = '1.1'
glCompressedTexSubImage3DARB.category = 'GL_ARB_texture_compression'
glCompressedTexSubImage3DARB.trace = True
glCompressedTexSubImage3DARB.play = True
gl.add(glCompressedTexSubImage3DARB)

glGetCompressedTexImageARB = Function('glGetCompressedTexImageARB')
glGetCompressedTexImageARB.ret = Return('void')
glGetCompressedTexImageARB.add( Input( 'target','GLenum' ))
glGetCompressedTexImageARB.add( Input( 'lod','GLint' ))
glGetCompressedTexImageARB.add( Output( 'img','GLvoid *' ))
glGetCompressedTexImageARB.version = '1.1'
glGetCompressedTexImageARB.category = 'GL_ARB_texture_compression'
glGetCompressedTexImageARB.trace = True
glGetCompressedTexImageARB.play = True
gl.add(glGetCompressedTexImageARB)

# GL_ARB_texture_multisample

glGetMultisamplefv = Function('glGetMultisamplefv')
glGetMultisamplefv.ret = Return('void')
glGetMultisamplefv.add( Input( 'pname','GLenum' ))
glGetMultisamplefv.add( Input( 'index','GLuint' ))
glGetMultisamplefv.add( Output( 'val','GLfloat *' ))
glGetMultisamplefv.version = '3.2'
glGetMultisamplefv.category = 'GL_ARB_texture_multisample'
glGetMultisamplefv.trace = True
glGetMultisamplefv.play = True
gl.add(glGetMultisamplefv)

glSampleMaski = Function('glSampleMaski')
glSampleMaski.ret = Return('void')
glSampleMaski.add( Input( 'index','GLuint' ))
glSampleMaski.add( Input( 'mask','GLbitfield' ))
glSampleMaski.version = '3.2'
glSampleMaski.category = 'GL_ARB_texture_multisample'
glSampleMaski.trace = True
glSampleMaski.play = True
gl.add(glSampleMaski)

glTexImage2DMultisample = Function('glTexImage2DMultisample')
glTexImage2DMultisample.ret = Return('void')
glTexImage2DMultisample.add( Input( 'target','GLenum' ))
glTexImage2DMultisample.add( Input( 'samples','GLsizei' ))
glTexImage2DMultisample.add( Input( 'internalformat','GLenum' ))
glTexImage2DMultisample.add( Input( 'width','GLsizei' ))
glTexImage2DMultisample.add( Input( 'height','GLsizei' ))
glTexImage2DMultisample.add( Input( 'fixedsamplelocations','GLboolean' ))
glTexImage2DMultisample.version = '3.2'
glTexImage2DMultisample.category = 'GL_ARB_texture_multisample'
glTexImage2DMultisample.trace = True
glTexImage2DMultisample.play = True
gl.add(glTexImage2DMultisample)

glTexImage3DMultisample = Function('glTexImage3DMultisample')
glTexImage3DMultisample.ret = Return('void')
glTexImage3DMultisample.add( Input( 'target','GLenum' ))
glTexImage3DMultisample.add( Input( 'samples','GLsizei' ))
glTexImage3DMultisample.add( Input( 'internalformat','GLenum' ))
glTexImage3DMultisample.add( Input( 'width','GLsizei' ))
glTexImage3DMultisample.add( Input( 'height','GLsizei' ))
glTexImage3DMultisample.add( Input( 'depth','GLsizei' ))
glTexImage3DMultisample.add( Input( 'fixedsamplelocations','GLboolean' ))
glTexImage3DMultisample.version = '3.2'
glTexImage3DMultisample.category = 'GL_ARB_texture_multisample'
glTexImage3DMultisample.trace = True
glTexImage3DMultisample.play = True
gl.add(glTexImage3DMultisample)

# GL_ARB_texture_storage

glTexStorage1D = Function('glTexStorage1D')
glTexStorage1D.ret = Return('void')
glTexStorage1D.add( Input( 'target','GLenum' ))
glTexStorage1D.add( Input( 'levels','GLsizei' ))
glTexStorage1D.add( Input( 'internalformat','GLenum' ))
glTexStorage1D.add( Input( 'width','GLsizei' ))
glTexStorage1D.version = ''
glTexStorage1D.category = 'GL_ARB_texture_storage'
glTexStorage1D.trace = True
glTexStorage1D.play = True
gl.add(glTexStorage1D)

glTexStorage2D = Function('glTexStorage2D')
glTexStorage2D.ret = Return('void')
glTexStorage2D.add( Input( 'target','GLenum' ))
glTexStorage2D.add( Input( 'levels','GLsizei' ))
glTexStorage2D.add( Input( 'internalformat','GLenum' ))
glTexStorage2D.add( Input( 'width','GLsizei' ))
glTexStorage2D.add( Input( 'height','GLsizei' ))
glTexStorage2D.version = ''
glTexStorage2D.category = 'GL_ARB_texture_storage'
glTexStorage2D.trace = True
glTexStorage2D.play = True
gl.add(glTexStorage2D)

glTexStorage3D = Function('glTexStorage3D')
glTexStorage3D.ret = Return('void')
glTexStorage3D.add( Input( 'target','GLenum' ))
glTexStorage3D.add( Input( 'levels','GLsizei' ))
glTexStorage3D.add( Input( 'internalformat','GLenum' ))
glTexStorage3D.add( Input( 'width','GLsizei' ))
glTexStorage3D.add( Input( 'height','GLsizei' ))
glTexStorage3D.add( Input( 'depth','GLsizei' ))
glTexStorage3D.version = ''
glTexStorage3D.category = 'GL_ARB_texture_storage'
glTexStorage3D.trace = True
glTexStorage3D.play = True
gl.add(glTexStorage3D)

glTextureStorage1DEXT = Function('glTextureStorage1DEXT')
glTextureStorage1DEXT.ret = Return('void')
glTextureStorage1DEXT.add( Input( 'texture','GLuint' ))
glTextureStorage1DEXT.add( Input( 'target','GLenum' ))
glTextureStorage1DEXT.add( Input( 'levels','GLsizei' ))
glTextureStorage1DEXT.add( Input( 'internalformat','GLenum' ))
glTextureStorage1DEXT.add( Input( 'width','GLsizei' ))
glTextureStorage1DEXT.version = ''
glTextureStorage1DEXT.category = 'GL_ARB_texture_storage'
glTextureStorage1DEXT.trace = True
glTextureStorage1DEXT.play = True
gl.add(glTextureStorage1DEXT)

glTextureStorage2DEXT = Function('glTextureStorage2DEXT')
glTextureStorage2DEXT.ret = Return('void')
glTextureStorage2DEXT.add( Input( 'texture','GLuint' ))
glTextureStorage2DEXT.add( Input( 'target','GLenum' ))
glTextureStorage2DEXT.add( Input( 'levels','GLsizei' ))
glTextureStorage2DEXT.add( Input( 'internalformat','GLenum' ))
glTextureStorage2DEXT.add( Input( 'width','GLsizei' ))
glTextureStorage2DEXT.add( Input( 'height','GLsizei' ))
glTextureStorage2DEXT.version = ''
glTextureStorage2DEXT.category = 'GL_ARB_texture_storage'
glTextureStorage2DEXT.trace = True
glTextureStorage2DEXT.play = True
gl.add(glTextureStorage2DEXT)

glTextureStorage3DEXT = Function('glTextureStorage3DEXT')
glTextureStorage3DEXT.ret = Return('void')
glTextureStorage3DEXT.add( Input( 'texture','GLuint' ))
glTextureStorage3DEXT.add( Input( 'target','GLenum' ))
glTextureStorage3DEXT.add( Input( 'levels','GLsizei' ))
glTextureStorage3DEXT.add( Input( 'internalformat','GLenum' ))
glTextureStorage3DEXT.add( Input( 'width','GLsizei' ))
glTextureStorage3DEXT.add( Input( 'height','GLsizei' ))
glTextureStorage3DEXT.add( Input( 'depth','GLsizei' ))
glTextureStorage3DEXT.version = ''
glTextureStorage3DEXT.category = 'GL_ARB_texture_storage'
glTextureStorage3DEXT.trace = True
glTextureStorage3DEXT.play = True
gl.add(glTextureStorage3DEXT)

# GL_ARB_texture_storage_multisample

glTexStorage2DMultisample = Function('glTexStorage2DMultisample')
glTexStorage2DMultisample.ret = Return('void')
glTexStorage2DMultisample.add( Input( 'target','GLenum' ))
glTexStorage2DMultisample.add( Input( 'samples','GLsizei' ))
glTexStorage2DMultisample.add( Input( 'internalformat','GLenum' ))
glTexStorage2DMultisample.add( Input( 'width','GLsizei' ))
glTexStorage2DMultisample.add( Input( 'height','GLsizei' ))
glTexStorage2DMultisample.add( Input( 'fixedsamplelocations','GLboolean' ))
glTexStorage2DMultisample.version = ''
glTexStorage2DMultisample.category = 'GL_ARB_texture_storage_multisample'
glTexStorage2DMultisample.trace = True
glTexStorage2DMultisample.play = True
gl.add(glTexStorage2DMultisample)

glTexStorage3DMultisample = Function('glTexStorage3DMultisample')
glTexStorage3DMultisample.ret = Return('void')
glTexStorage3DMultisample.add( Input( 'target','GLenum' ))
glTexStorage3DMultisample.add( Input( 'samples','GLsizei' ))
glTexStorage3DMultisample.add( Input( 'internalformat','GLenum' ))
glTexStorage3DMultisample.add( Input( 'width','GLsizei' ))
glTexStorage3DMultisample.add( Input( 'height','GLsizei' ))
glTexStorage3DMultisample.add( Input( 'depth','GLsizei' ))
glTexStorage3DMultisample.add( Input( 'fixedsamplelocations','GLboolean' ))
glTexStorage3DMultisample.version = ''
glTexStorage3DMultisample.category = 'GL_ARB_texture_storage_multisample'
glTexStorage3DMultisample.trace = True
glTexStorage3DMultisample.play = True
gl.add(glTexStorage3DMultisample)

glTextureStorage2DMultisampleEXT = Function('glTextureStorage2DMultisampleEXT')
glTextureStorage2DMultisampleEXT.ret = Return('void')
glTextureStorage2DMultisampleEXT.add( Input( 'texture','GLuint' ))
glTextureStorage2DMultisampleEXT.add( Input( 'target','GLenum' ))
glTextureStorage2DMultisampleEXT.add( Input( 'samples','GLsizei' ))
glTextureStorage2DMultisampleEXT.add( Input( 'internalformat','GLenum' ))
glTextureStorage2DMultisampleEXT.add( Input( 'width','GLsizei' ))
glTextureStorage2DMultisampleEXT.add( Input( 'height','GLsizei' ))
glTextureStorage2DMultisampleEXT.add( Input( 'fixedsamplelocations','GLboolean' ))
glTextureStorage2DMultisampleEXT.version = ''
glTextureStorage2DMultisampleEXT.category = 'GL_ARB_texture_storage_multisample'
glTextureStorage2DMultisampleEXT.trace = True
glTextureStorage2DMultisampleEXT.play = True
gl.add(glTextureStorage2DMultisampleEXT)

glTextureStorage3DMultisampleEXT = Function('glTextureStorage3DMultisampleEXT')
glTextureStorage3DMultisampleEXT.ret = Return('void')
glTextureStorage3DMultisampleEXT.add( Input( 'texture','GLuint' ))
glTextureStorage3DMultisampleEXT.add( Input( 'target','GLenum' ))
glTextureStorage3DMultisampleEXT.add( Input( 'samples','GLsizei' ))
glTextureStorage3DMultisampleEXT.add( Input( 'internalformat','GLenum' ))
glTextureStorage3DMultisampleEXT.add( Input( 'width','GLsizei' ))
glTextureStorage3DMultisampleEXT.add( Input( 'height','GLsizei' ))
glTextureStorage3DMultisampleEXT.add( Input( 'depth','GLsizei' ))
glTextureStorage3DMultisampleEXT.add( Input( 'fixedsamplelocations','GLboolean' ))
glTextureStorage3DMultisampleEXT.version = ''
glTextureStorage3DMultisampleEXT.category = 'GL_ARB_texture_storage_multisample'
glTextureStorage3DMultisampleEXT.trace = True
glTextureStorage3DMultisampleEXT.play = True
gl.add(glTextureStorage3DMultisampleEXT)

# GL_ARB_texture_view

glTextureView = Function('glTextureView')
glTextureView.ret = Return('void')
glTextureView.add( Input( 'texture','GLuint' ))
glTextureView.add( Input( 'target','GLenum' ))
glTextureView.add( Input( 'origtexture','GLuint' ))
glTextureView.add( Input( 'internalformat','GLenum' ))
glTextureView.add( Input( 'minlevel','GLuint' ))
glTextureView.add( Input( 'numlevels','GLuint' ))
glTextureView.add( Input( 'minlayer','GLuint' ))
glTextureView.add( Input( 'numlayers','GLuint' ))
glTextureView.version = ''
glTextureView.category = 'GL_ARB_texture_view'
glTextureView.trace = True
glTextureView.play = True
gl.add(glTextureView)

# GL_ARB_timer_query

glGetQueryObjecti64v = Function('glGetQueryObjecti64v')
glGetQueryObjecti64v.ret = Return('void')
glGetQueryObjecti64v.add( Input( 'id','GLuint' ))
glGetQueryObjecti64v.add( Input( 'pname','GLenum' ))
glGetQueryObjecti64v.add( Output( 'params','GLint64 *' ))
glGetQueryObjecti64v.version = '3.3'
glGetQueryObjecti64v.category = 'GL_ARB_timer_query'
glGetQueryObjecti64v.trace = True
glGetQueryObjecti64v.play = False
gl.add(glGetQueryObjecti64v)

glGetQueryObjectui64v = Function('glGetQueryObjectui64v')
glGetQueryObjectui64v.ret = Return('void')
glGetQueryObjectui64v.add( Input( 'id','GLuint' ))
glGetQueryObjectui64v.add( Input( 'pname','GLenum' ))
glGetQueryObjectui64v.add( Output( 'params','GLuint64 *' ))
glGetQueryObjectui64v.version = '3.3'
glGetQueryObjectui64v.category = 'GL_ARB_timer_query'
glGetQueryObjectui64v.trace = True
glGetQueryObjectui64v.play = False
gl.add(glGetQueryObjectui64v)

glQueryCounter = Function('glQueryCounter')
glQueryCounter.ret = Return('void')
glQueryCounter.add( Input( 'id','GLuint' ))
glQueryCounter.add( Input( 'target','GLenum' ))
glQueryCounter.version = '3.3'
glQueryCounter.category = 'GL_ARB_timer_query'
glQueryCounter.trace = True
glQueryCounter.play = True
gl.add(glQueryCounter)

# GL_ARB_transform_feedback2

glBindTransformFeedback = Function('glBindTransformFeedback')
glBindTransformFeedback.ret = Return('void')
glBindTransformFeedback.add( Input( 'target','GLenum' ))
glBindTransformFeedback.add( Input( 'id','GLuint' ))
glBindTransformFeedback.version = '4.0'
glBindTransformFeedback.category = 'GL_ARB_transform_feedback2'
glBindTransformFeedback.trace = True
glBindTransformFeedback.play = True
gl.add(glBindTransformFeedback)

glDeleteTransformFeedbacks = Function('glDeleteTransformFeedbacks')
glDeleteTransformFeedbacks.ret = Return('void')
glDeleteTransformFeedbacks.add( Input( 'n','GLsizei' ))
glDeleteTransformFeedbacks.add( Input( 'ids','const GLuint *' ,size = 'n' ))
glDeleteTransformFeedbacks.version = '4.0'
glDeleteTransformFeedbacks.category = 'GL_ARB_transform_feedback2'
glDeleteTransformFeedbacks.trace = True
glDeleteTransformFeedbacks.play = True
gl.add(glDeleteTransformFeedbacks)

glDrawTransformFeedback = Function('glDrawTransformFeedback')
glDrawTransformFeedback.ret = Return('void')
glDrawTransformFeedback.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glDrawTransformFeedback.add( Input( 'name','GLuint' ))
glDrawTransformFeedback.version = '4.0'
glDrawTransformFeedback.category = 'GL_ARB_transform_feedback2'
glDrawTransformFeedback.trace = True
glDrawTransformFeedback.play = True
gl.add(glDrawTransformFeedback)

glGenTransformFeedbacks = Function('glGenTransformFeedbacks')
glGenTransformFeedbacks.ret = Return('void')
glGenTransformFeedbacks.add( Input( 'n','GLsizei' ))
glGenTransformFeedbacks.add( Output( 'ids','GLuint *' ,size = 'n' ))
glGenTransformFeedbacks.version = '4.0'
glGenTransformFeedbacks.category = 'GL_ARB_transform_feedback2'
glGenTransformFeedbacks.trace = True
glGenTransformFeedbacks.play = True
gl.add(glGenTransformFeedbacks)

glIsTransformFeedback = Function('glIsTransformFeedback')
glIsTransformFeedback.ret = Return('GLboolean')
glIsTransformFeedback.add( Input( 'id','GLuint' ))
glIsTransformFeedback.version = '4.0'
glIsTransformFeedback.category = 'GL_ARB_transform_feedback2'
glIsTransformFeedback.trace = True
glIsTransformFeedback.play = True
gl.add(glIsTransformFeedback)

glPauseTransformFeedback = Function('glPauseTransformFeedback')
glPauseTransformFeedback.ret = Return('void')
glPauseTransformFeedback.version = '4.0'
glPauseTransformFeedback.category = 'GL_ARB_transform_feedback2'
glPauseTransformFeedback.trace = True
glPauseTransformFeedback.play = True
gl.add(glPauseTransformFeedback)

glResumeTransformFeedback = Function('glResumeTransformFeedback')
glResumeTransformFeedback.ret = Return('void')
glResumeTransformFeedback.version = '4.0'
glResumeTransformFeedback.category = 'GL_ARB_transform_feedback2'
glResumeTransformFeedback.trace = True
glResumeTransformFeedback.play = True
gl.add(glResumeTransformFeedback)

# GL_ARB_transform_feedback3

glBeginQueryIndexed = Function('glBeginQueryIndexed')
glBeginQueryIndexed.ret = Return('void')
glBeginQueryIndexed.add( Input( 'target','GLenum' ))
glBeginQueryIndexed.add( Input( 'index','GLuint' ))
glBeginQueryIndexed.add( Input( 'id','GLuint' ))
glBeginQueryIndexed.version = '4.0'
glBeginQueryIndexed.category = 'GL_ARB_transform_feedback3'
glBeginQueryIndexed.trace = True
glBeginQueryIndexed.play = True
gl.add(glBeginQueryIndexed)

glDrawTransformFeedbackStream = Function('glDrawTransformFeedbackStream')
glDrawTransformFeedbackStream.ret = Return('void')
glDrawTransformFeedbackStream.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glDrawTransformFeedbackStream.add( Input( 'id','GLuint' ))
glDrawTransformFeedbackStream.add( Input( 'stream','GLuint' ))
glDrawTransformFeedbackStream.version = '4.0'
glDrawTransformFeedbackStream.category = 'GL_ARB_transform_feedback3'
glDrawTransformFeedbackStream.trace = True
glDrawTransformFeedbackStream.play = True
gl.add(glDrawTransformFeedbackStream)

glEndQueryIndexed = Function('glEndQueryIndexed')
glEndQueryIndexed.ret = Return('void')
glEndQueryIndexed.add( Input( 'target','GLenum' ))
glEndQueryIndexed.add( Input( 'index','GLuint' ))
glEndQueryIndexed.version = '4.0'
glEndQueryIndexed.category = 'GL_ARB_transform_feedback3'
glEndQueryIndexed.trace = True
glEndQueryIndexed.play = True
gl.add(glEndQueryIndexed)

glGetQueryIndexediv = Function('glGetQueryIndexediv')
glGetQueryIndexediv.ret = Return('void')
glGetQueryIndexediv.add( Input( 'target','GLenum' ))
glGetQueryIndexediv.add( Input( 'index','GLuint' ))
glGetQueryIndexediv.add( Input( 'pname','GLenum' ))
glGetQueryIndexediv.add( Output( 'params','GLint *' ))
glGetQueryIndexediv.version = '4.0'
glGetQueryIndexediv.category = 'GL_ARB_transform_feedback3'
glGetQueryIndexediv.trace = True
glGetQueryIndexediv.play = False
gl.add(glGetQueryIndexediv)

# GL_ARB_transform_feedback_instanced

glDrawTransformFeedbackInstanced = Function('glDrawTransformFeedbackInstanced')
glDrawTransformFeedbackInstanced.ret = Return('void')
glDrawTransformFeedbackInstanced.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glDrawTransformFeedbackInstanced.add( Input( 'id','GLuint' ))
glDrawTransformFeedbackInstanced.add( Input( 'primcount','GLsizei' ))
glDrawTransformFeedbackInstanced.version = ''
glDrawTransformFeedbackInstanced.category = 'GL_ARB_transform_feedback_instanced'
glDrawTransformFeedbackInstanced.trace = True
glDrawTransformFeedbackInstanced.play = True
gl.add(glDrawTransformFeedbackInstanced)

glDrawTransformFeedbackStreamInstanced = Function('glDrawTransformFeedbackStreamInstanced')
glDrawTransformFeedbackStreamInstanced.ret = Return('void')
glDrawTransformFeedbackStreamInstanced.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glDrawTransformFeedbackStreamInstanced.add( Input( 'id','GLuint' ))
glDrawTransformFeedbackStreamInstanced.add( Input( 'stream','GLuint' ))
glDrawTransformFeedbackStreamInstanced.add( Input( 'primcount','GLsizei' ))
glDrawTransformFeedbackStreamInstanced.version = ''
glDrawTransformFeedbackStreamInstanced.category = 'GL_ARB_transform_feedback_instanced'
glDrawTransformFeedbackStreamInstanced.trace = True
glDrawTransformFeedbackStreamInstanced.play = True
gl.add(glDrawTransformFeedbackStreamInstanced)

# GL_ARB_transpose_matrix

glLoadTransposeMatrixdARB = Function('glLoadTransposeMatrixdARB')
glLoadTransposeMatrixdARB.ret = Return('void')
glLoadTransposeMatrixdARB.add( Input( 'm','const GLdouble *' ,size = 16 ))
glLoadTransposeMatrixdARB.version = '1.1'
glLoadTransposeMatrixdARB.category = 'GL_ARB_transpose_matrix'
glLoadTransposeMatrixdARB.trace = True
glLoadTransposeMatrixdARB.play = True
gl.add(glLoadTransposeMatrixdARB)

glLoadTransposeMatrixfARB = Function('glLoadTransposeMatrixfARB')
glLoadTransposeMatrixfARB.ret = Return('void')
glLoadTransposeMatrixfARB.add( Input( 'm','const GLfloat *' ,size = 16 ))
glLoadTransposeMatrixfARB.version = '1.1'
glLoadTransposeMatrixfARB.category = 'GL_ARB_transpose_matrix'
glLoadTransposeMatrixfARB.trace = True
glLoadTransposeMatrixfARB.play = True
gl.add(glLoadTransposeMatrixfARB)

glMultTransposeMatrixdARB = Function('glMultTransposeMatrixdARB')
glMultTransposeMatrixdARB.ret = Return('void')
glMultTransposeMatrixdARB.add( Input( 'm','const GLdouble *' ,size = 16 ))
glMultTransposeMatrixdARB.version = '1.1'
glMultTransposeMatrixdARB.category = 'GL_ARB_transpose_matrix'
glMultTransposeMatrixdARB.trace = True
glMultTransposeMatrixdARB.play = True
gl.add(glMultTransposeMatrixdARB)

glMultTransposeMatrixfARB = Function('glMultTransposeMatrixfARB')
glMultTransposeMatrixfARB.ret = Return('void')
glMultTransposeMatrixfARB.add( Input( 'm','const GLfloat *' ,size = 16 ))
glMultTransposeMatrixfARB.version = '1.1'
glMultTransposeMatrixfARB.category = 'GL_ARB_transpose_matrix'
glMultTransposeMatrixfARB.trace = True
glMultTransposeMatrixfARB.play = True
gl.add(glMultTransposeMatrixfARB)

# GL_ARB_uniform_buffer_object

glBindBufferBase = Function('glBindBufferBase')
glBindBufferBase.ret = Return('void')
glBindBufferBase.add( Input( 'target','GLenum' ))
glBindBufferBase.add( Input( 'index','GLuint' ))
glBindBufferBase.add( Input( 'buffer','GLuint' ))
glBindBufferBase.version = '3.0'
glBindBufferBase.category = 'GL_ARB_uniform_buffer_object'
glBindBufferBase.trace = True
glBindBufferBase.play = True
gl.add(glBindBufferBase)

glBindBufferRange = Function('glBindBufferRange')
glBindBufferRange.ret = Return('void')
glBindBufferRange.add( Input( 'target','GLenum' ))
glBindBufferRange.add( Input( 'index','GLuint' ))
glBindBufferRange.add( Input( 'buffer','GLuint' ))
glBindBufferRange.add( Input( 'offset','GLintptr' ))
glBindBufferRange.add( Input( 'size','GLsizeiptr' ))
glBindBufferRange.version = '3.0'
glBindBufferRange.category = 'GL_ARB_uniform_buffer_object'
glBindBufferRange.trace = True
glBindBufferRange.play = True
gl.add(glBindBufferRange)

glGetActiveUniformBlockName = Function('glGetActiveUniformBlockName')
glGetActiveUniformBlockName.ret = Return('void')
glGetActiveUniformBlockName.add( Input( 'program','GLuint' ))
glGetActiveUniformBlockName.add( Input( 'uniformBlockIndex','GLuint' ))
glGetActiveUniformBlockName.add( Input( 'bufSize','GLsizei' ))
glGetActiveUniformBlockName.add( Output( 'length','GLsizei *' ,size = 1 ))
glGetActiveUniformBlockName.add( Output( 'uniformBlockName','GLchar *' ,maxSize = 'bufSize' ))
glGetActiveUniformBlockName.version = '3.1'
glGetActiveUniformBlockName.category = 'GL_ARB_uniform_buffer_object'
glGetActiveUniformBlockName.trace = True
glGetActiveUniformBlockName.play = False
gl.add(glGetActiveUniformBlockName)

glGetActiveUniformBlockiv = Function('glGetActiveUniformBlockiv')
glGetActiveUniformBlockiv.ret = Return('void')
glGetActiveUniformBlockiv.add( Input( 'program','GLuint' ))
glGetActiveUniformBlockiv.add( Input( 'uniformBlockIndex','GLuint' ))
glGetActiveUniformBlockiv.add( Input( 'pname','GLenum' ))
glGetActiveUniformBlockiv.add( Output( 'params','GLint *' ))
glGetActiveUniformBlockiv.version = '3.1'
glGetActiveUniformBlockiv.category = 'GL_ARB_uniform_buffer_object'
glGetActiveUniformBlockiv.trace = True
glGetActiveUniformBlockiv.play = False
gl.add(glGetActiveUniformBlockiv)

glGetActiveUniformName = Function('glGetActiveUniformName')
glGetActiveUniformName.ret = Return('void')
glGetActiveUniformName.add( Input( 'program','GLuint' ))
glGetActiveUniformName.add( Input( 'uniformIndex','GLuint' ))
glGetActiveUniformName.add( Input( 'bufSize','GLsizei' ))
glGetActiveUniformName.add( Output( 'length','GLsizei *' ,size = 1 ))
glGetActiveUniformName.add( Output( 'uniformName','GLchar *' ,maxSize = 'bufSize' ))
glGetActiveUniformName.version = '3.1'
glGetActiveUniformName.category = 'GL_ARB_uniform_buffer_object'
glGetActiveUniformName.trace = True
glGetActiveUniformName.play = False
gl.add(glGetActiveUniformName)

glGetActiveUniformsiv = Function('glGetActiveUniformsiv')
glGetActiveUniformsiv.ret = Return('void')
glGetActiveUniformsiv.add( Input( 'program','GLuint' ))
glGetActiveUniformsiv.add( Input( 'uniformCount','GLsizei' ))
glGetActiveUniformsiv.add( Input( 'uniformIndices','const GLuint *' ))
glGetActiveUniformsiv.add( Input( 'pname','GLenum' ))
glGetActiveUniformsiv.add( Output( 'params','GLint *' ))
glGetActiveUniformsiv.version = '3.1'
glGetActiveUniformsiv.category = 'GL_ARB_uniform_buffer_object'
glGetActiveUniformsiv.trace = True
glGetActiveUniformsiv.play = True
gl.add(glGetActiveUniformsiv)

glGetIntegeri_v = Function('glGetIntegeri_v')
glGetIntegeri_v.ret = Return('void')
glGetIntegeri_v.add( Input( 'target','GLenum' ))
glGetIntegeri_v.add( Input( 'index','GLuint' ))
glGetIntegeri_v.add( Output( 'data','GLint *' ))
glGetIntegeri_v.version = '3.0'
glGetIntegeri_v.category = 'GL_ARB_uniform_buffer_object'
glGetIntegeri_v.trace = True
glGetIntegeri_v.play = False
gl.add(glGetIntegeri_v)

glGetUniformBlockIndex = Function('glGetUniformBlockIndex')
glGetUniformBlockIndex.ret = Return('GLuint')
glGetUniformBlockIndex.add( Input( 'program','GLuint' ))
glGetUniformBlockIndex.add( Input( 'uniformBlockName','const GLchar *' ))
glGetUniformBlockIndex.version = '3.1'
glGetUniformBlockIndex.category = 'GL_ARB_uniform_buffer_object'
glGetUniformBlockIndex.trace = True
glGetUniformBlockIndex.play = False
gl.add(glGetUniformBlockIndex)

glGetUniformIndices = Function('glGetUniformIndices')
glGetUniformIndices.ret = Return('void')
glGetUniformIndices.add( Input( 'program','GLuint' ))
glGetUniformIndices.add( Input( 'uniformCount','GLsizei' ))
glGetUniformIndices.add( Input( 'uniformNames','const GLchar * const *' ))
glGetUniformIndices.add( Output( 'uniformIndices','GLuint *' ))
glGetUniformIndices.version = '3.1'
glGetUniformIndices.category = 'GL_ARB_uniform_buffer_object'
glGetUniformIndices.trace = True
glGetUniformIndices.play = True
gl.add(glGetUniformIndices)

glUniformBlockBinding = Function('glUniformBlockBinding')
glUniformBlockBinding.ret = Return('void')
glUniformBlockBinding.add( Input( 'program','GLuint' ))
glUniformBlockBinding.add( Input( 'uniformBlockIndex','GLuint' ))
glUniformBlockBinding.add( Input( 'uniformBlockBinding','GLuint' ))
glUniformBlockBinding.version = '3.1'
glUniformBlockBinding.category = 'GL_ARB_uniform_buffer_object'
glUniformBlockBinding.trace = True
glUniformBlockBinding.play = True
gl.add(glUniformBlockBinding)

# GL_ARB_vertex_array_object

glBindVertexArray = Function('glBindVertexArray')
glBindVertexArray.ret = Return('void')
glBindVertexArray.add( Input( 'array','GLuint' ))
glBindVertexArray.version = '3.0'
glBindVertexArray.category = 'GL_ARB_vertex_array_object'
glBindVertexArray.trace = True
glBindVertexArray.play = True
gl.add(glBindVertexArray)

glDeleteVertexArrays = Function('glDeleteVertexArrays')
glDeleteVertexArrays.ret = Return('void')
glDeleteVertexArrays.add( Input( 'n','GLsizei' ))
glDeleteVertexArrays.add( Input( 'arrays','const GLuint *' ,size = 'n' ))
glDeleteVertexArrays.version = '3.0'
glDeleteVertexArrays.category = 'GL_ARB_vertex_array_object'
glDeleteVertexArrays.trace = True
glDeleteVertexArrays.play = True
gl.add(glDeleteVertexArrays)

glGenVertexArrays = Function('glGenVertexArrays')
glGenVertexArrays.ret = Return('void')
glGenVertexArrays.add( Input( 'n','GLsizei' ))
glGenVertexArrays.add( Output( 'arrays','GLuint *' ,size = 'n' ))
glGenVertexArrays.version = '3.0'
glGenVertexArrays.category = 'GL_ARB_vertex_array_object'
glGenVertexArrays.trace = True
glGenVertexArrays.play = True
gl.add(glGenVertexArrays)

glIsVertexArray = Function('glIsVertexArray')
glIsVertexArray.ret = Return('GLboolean')
glIsVertexArray.add( Input( 'array','GLuint' ))
glIsVertexArray.version = '3.0'
glIsVertexArray.category = 'GL_ARB_vertex_array_object'
glIsVertexArray.trace = True
glIsVertexArray.play = True
gl.add(glIsVertexArray)

# GL_ARB_vertex_attrib_64bit

glGetVertexAttribLdv = Function('glGetVertexAttribLdv')
glGetVertexAttribLdv.ret = Return('void')
glGetVertexAttribLdv.add( Input( 'index','GLuint' ))
glGetVertexAttribLdv.add( Input( 'pname','GLenum' ))
glGetVertexAttribLdv.add( Output( 'params','GLdouble *' ,size = 1 ))
glGetVertexAttribLdv.version = '4.1'
glGetVertexAttribLdv.category = 'GL_ARB_vertex_attrib_64bit'
glGetVertexAttribLdv.trace = True
glGetVertexAttribLdv.play = True
gl.add(glGetVertexAttribLdv)

glVertexAttribL1d = Function('glVertexAttribL1d')
glVertexAttribL1d.ret = Return('void')
glVertexAttribL1d.add( Input( 'index','GLuint' ))
glVertexAttribL1d.add( Input( 'x','GLdouble' ))
glVertexAttribL1d.version = '4.1'
glVertexAttribL1d.category = 'GL_ARB_vertex_attrib_64bit'
glVertexAttribL1d.trace = True
glVertexAttribL1d.play = True
gl.add(glVertexAttribL1d)

glVertexAttribL1dv = Function('glVertexAttribL1dv')
glVertexAttribL1dv.ret = Return('void')
glVertexAttribL1dv.add( Input( 'index','GLuint' ))
glVertexAttribL1dv.add( Input( 'v','const GLdouble *' ,size = 1 ))
glVertexAttribL1dv.version = '4.1'
glVertexAttribL1dv.category = 'GL_ARB_vertex_attrib_64bit'
glVertexAttribL1dv.trace = True
glVertexAttribL1dv.play = True
gl.add(glVertexAttribL1dv)

glVertexAttribL2d = Function('glVertexAttribL2d')
glVertexAttribL2d.ret = Return('void')
glVertexAttribL2d.add( Input( 'index','GLuint' ))
glVertexAttribL2d.add( Input( 'x','GLdouble' ))
glVertexAttribL2d.add( Input( 'y','GLdouble' ))
glVertexAttribL2d.version = '4.1'
glVertexAttribL2d.category = 'GL_ARB_vertex_attrib_64bit'
glVertexAttribL2d.trace = True
glVertexAttribL2d.play = True
gl.add(glVertexAttribL2d)

glVertexAttribL2dv = Function('glVertexAttribL2dv')
glVertexAttribL2dv.ret = Return('void')
glVertexAttribL2dv.add( Input( 'index','GLuint' ))
glVertexAttribL2dv.add( Input( 'v','const GLdouble *' ,size = 2 ))
glVertexAttribL2dv.version = '4.1'
glVertexAttribL2dv.category = 'GL_ARB_vertex_attrib_64bit'
glVertexAttribL2dv.trace = True
glVertexAttribL2dv.play = True
gl.add(glVertexAttribL2dv)

glVertexAttribL3d = Function('glVertexAttribL3d')
glVertexAttribL3d.ret = Return('void')
glVertexAttribL3d.add( Input( 'index','GLuint' ))
glVertexAttribL3d.add( Input( 'x','GLdouble' ))
glVertexAttribL3d.add( Input( 'y','GLdouble' ))
glVertexAttribL3d.add( Input( 'z','GLdouble' ))
glVertexAttribL3d.version = '4.1'
glVertexAttribL3d.category = 'GL_ARB_vertex_attrib_64bit'
glVertexAttribL3d.trace = True
glVertexAttribL3d.play = True
gl.add(glVertexAttribL3d)

glVertexAttribL3dv = Function('glVertexAttribL3dv')
glVertexAttribL3dv.ret = Return('void')
glVertexAttribL3dv.add( Input( 'index','GLuint' ))
glVertexAttribL3dv.add( Input( 'v','const GLdouble *' ,size = 3 ))
glVertexAttribL3dv.version = '4.1'
glVertexAttribL3dv.category = 'GL_ARB_vertex_attrib_64bit'
glVertexAttribL3dv.trace = True
glVertexAttribL3dv.play = True
gl.add(glVertexAttribL3dv)

glVertexAttribL4d = Function('glVertexAttribL4d')
glVertexAttribL4d.ret = Return('void')
glVertexAttribL4d.add( Input( 'index','GLuint' ))
glVertexAttribL4d.add( Input( 'x','GLdouble' ))
glVertexAttribL4d.add( Input( 'y','GLdouble' ))
glVertexAttribL4d.add( Input( 'z','GLdouble' ))
glVertexAttribL4d.add( Input( 'w','GLdouble' ))
glVertexAttribL4d.version = '4.1'
glVertexAttribL4d.category = 'GL_ARB_vertex_attrib_64bit'
glVertexAttribL4d.trace = True
glVertexAttribL4d.play = True
gl.add(glVertexAttribL4d)

glVertexAttribL4dv = Function('glVertexAttribL4dv')
glVertexAttribL4dv.ret = Return('void')
glVertexAttribL4dv.add( Input( 'index','GLuint' ))
glVertexAttribL4dv.add( Input( 'v','const GLdouble *' ,size = 4 ))
glVertexAttribL4dv.version = '4.1'
glVertexAttribL4dv.category = 'GL_ARB_vertex_attrib_64bit'
glVertexAttribL4dv.trace = True
glVertexAttribL4dv.play = True
gl.add(glVertexAttribL4dv)

glVertexAttribLPointer = Function('glVertexAttribLPointer')
glVertexAttribLPointer.ret = Return('void')
glVertexAttribLPointer.add( Input( 'index','GLuint' ))
glVertexAttribLPointer.add( Input( 'size','GLint' ))
glVertexAttribLPointer.add( Input( 'type','GLenum' ))
glVertexAttribLPointer.add( Input( 'stride','GLsizei' ))
glVertexAttribLPointer.add( Input( 'pointer','const GLvoid *' ))
glVertexAttribLPointer.version = '4.1'
glVertexAttribLPointer.category = 'GL_ARB_vertex_attrib_64bit'
glVertexAttribLPointer.trace = True
glVertexAttribLPointer.play = True
gl.add(glVertexAttribLPointer)

# GL_ARB_vertex_attrib_binding

glBindVertexBuffer = Function('glBindVertexBuffer')
glBindVertexBuffer.ret = Return('void')
glBindVertexBuffer.add( Input( 'bindingindex','GLuint' ))
glBindVertexBuffer.add( Input( 'buffer','GLuint' ))
glBindVertexBuffer.add( Input( 'offset','GLintptr' ))
glBindVertexBuffer.add( Input( 'stride','GLsizei' ))
glBindVertexBuffer.version = ''
glBindVertexBuffer.category = 'GL_ARB_vertex_attrib_binding'
glBindVertexBuffer.trace = True
glBindVertexBuffer.play = True
gl.add(glBindVertexBuffer)

glVertexArrayBindVertexBufferEXT = Function('glVertexArrayBindVertexBufferEXT')
glVertexArrayBindVertexBufferEXT.ret = Return('void')
glVertexArrayBindVertexBufferEXT.add( Input( 'vaobj','GLuint' ))
glVertexArrayBindVertexBufferEXT.add( Input( 'bindingindex','GLuint' ))
glVertexArrayBindVertexBufferEXT.add( Input( 'buffer','GLuint' ))
glVertexArrayBindVertexBufferEXT.add( Input( 'offset','GLintptr' ))
glVertexArrayBindVertexBufferEXT.add( Input( 'stride','GLsizei' ))
glVertexArrayBindVertexBufferEXT.version = ''
glVertexArrayBindVertexBufferEXT.category = 'GL_ARB_vertex_attrib_binding'
glVertexArrayBindVertexBufferEXT.trace = True
glVertexArrayBindVertexBufferEXT.play = True
gl.add(glVertexArrayBindVertexBufferEXT)

glVertexArrayVertexAttribBindingEXT = Function('glVertexArrayVertexAttribBindingEXT')
glVertexArrayVertexAttribBindingEXT.ret = Return('void')
glVertexArrayVertexAttribBindingEXT.add( Input( 'vaobj','GLuint' ))
glVertexArrayVertexAttribBindingEXT.add( Input( 'attribindex','GLuint' ))
glVertexArrayVertexAttribBindingEXT.add( Input( 'bindingindex','GLuint' ))
glVertexArrayVertexAttribBindingEXT.version = ''
glVertexArrayVertexAttribBindingEXT.category = 'GL_ARB_vertex_attrib_binding'
glVertexArrayVertexAttribBindingEXT.trace = True
glVertexArrayVertexAttribBindingEXT.play = True
gl.add(glVertexArrayVertexAttribBindingEXT)

glVertexArrayVertexAttribFormatEXT = Function('glVertexArrayVertexAttribFormatEXT')
glVertexArrayVertexAttribFormatEXT.ret = Return('void')
glVertexArrayVertexAttribFormatEXT.add( Input( 'vaobj','GLuint' ))
glVertexArrayVertexAttribFormatEXT.add( Input( 'attribindex','GLuint' ))
glVertexArrayVertexAttribFormatEXT.add( Input( 'size','GLint' ))
glVertexArrayVertexAttribFormatEXT.add( Input( 'type','GLenum' ))
glVertexArrayVertexAttribFormatEXT.add( Input( 'normalized','GLboolean' ))
glVertexArrayVertexAttribFormatEXT.add( Input( 'relativeoffset','GLuint' ))
glVertexArrayVertexAttribFormatEXT.version = ''
glVertexArrayVertexAttribFormatEXT.category = 'GL_ARB_vertex_attrib_binding'
glVertexArrayVertexAttribFormatEXT.trace = True
glVertexArrayVertexAttribFormatEXT.play = True
gl.add(glVertexArrayVertexAttribFormatEXT)

glVertexArrayVertexAttribIFormatEXT = Function('glVertexArrayVertexAttribIFormatEXT')
glVertexArrayVertexAttribIFormatEXT.ret = Return('void')
glVertexArrayVertexAttribIFormatEXT.add( Input( 'vaobj','GLuint' ))
glVertexArrayVertexAttribIFormatEXT.add( Input( 'attribindex','GLuint' ))
glVertexArrayVertexAttribIFormatEXT.add( Input( 'size','GLint' ))
glVertexArrayVertexAttribIFormatEXT.add( Input( 'type','GLenum' ))
glVertexArrayVertexAttribIFormatEXT.add( Input( 'relativeoffset','GLuint' ))
glVertexArrayVertexAttribIFormatEXT.version = ''
glVertexArrayVertexAttribIFormatEXT.category = 'GL_ARB_vertex_attrib_binding'
glVertexArrayVertexAttribIFormatEXT.trace = True
glVertexArrayVertexAttribIFormatEXT.play = True
gl.add(glVertexArrayVertexAttribIFormatEXT)

glVertexArrayVertexAttribLFormatEXT = Function('glVertexArrayVertexAttribLFormatEXT')
glVertexArrayVertexAttribLFormatEXT.ret = Return('void')
glVertexArrayVertexAttribLFormatEXT.add( Input( 'vaobj','GLuint' ))
glVertexArrayVertexAttribLFormatEXT.add( Input( 'attribindex','GLuint' ))
glVertexArrayVertexAttribLFormatEXT.add( Input( 'size','GLint' ))
glVertexArrayVertexAttribLFormatEXT.add( Input( 'type','GLenum' ))
glVertexArrayVertexAttribLFormatEXT.add( Input( 'relativeoffset','GLuint' ))
glVertexArrayVertexAttribLFormatEXT.version = ''
glVertexArrayVertexAttribLFormatEXT.category = 'GL_ARB_vertex_attrib_binding'
glVertexArrayVertexAttribLFormatEXT.trace = True
glVertexArrayVertexAttribLFormatEXT.play = True
gl.add(glVertexArrayVertexAttribLFormatEXT)

glVertexArrayVertexBindingDivisorEXT = Function('glVertexArrayVertexBindingDivisorEXT')
glVertexArrayVertexBindingDivisorEXT.ret = Return('void')
glVertexArrayVertexBindingDivisorEXT.add( Input( 'vaobj','GLuint' ))
glVertexArrayVertexBindingDivisorEXT.add( Input( 'bindingindex','GLuint' ))
glVertexArrayVertexBindingDivisorEXT.add( Input( 'divisor','GLuint' ))
glVertexArrayVertexBindingDivisorEXT.version = ''
glVertexArrayVertexBindingDivisorEXT.category = 'GL_ARB_vertex_attrib_binding'
glVertexArrayVertexBindingDivisorEXT.trace = True
glVertexArrayVertexBindingDivisorEXT.play = True
gl.add(glVertexArrayVertexBindingDivisorEXT)

glVertexAttribBinding = Function('glVertexAttribBinding')
glVertexAttribBinding.ret = Return('void')
glVertexAttribBinding.add( Input( 'attribindex','GLuint' ))
glVertexAttribBinding.add( Input( 'bindingindex','GLuint' ))
glVertexAttribBinding.version = ''
glVertexAttribBinding.category = 'GL_ARB_vertex_attrib_binding'
glVertexAttribBinding.trace = True
glVertexAttribBinding.play = True
gl.add(glVertexAttribBinding)

glVertexAttribFormat = Function('glVertexAttribFormat')
glVertexAttribFormat.ret = Return('void')
glVertexAttribFormat.add( Input( 'attribindex','GLuint' ))
glVertexAttribFormat.add( Input( 'size','GLint' ))
glVertexAttribFormat.add( Input( 'type','GLenum' ))
glVertexAttribFormat.add( Input( 'normalized','GLboolean' ))
glVertexAttribFormat.add( Input( 'relativeoffset','GLuint' ))
glVertexAttribFormat.version = ''
glVertexAttribFormat.category = 'GL_ARB_vertex_attrib_binding'
glVertexAttribFormat.trace = True
glVertexAttribFormat.play = True
gl.add(glVertexAttribFormat)

glVertexAttribIFormat = Function('glVertexAttribIFormat')
glVertexAttribIFormat.ret = Return('void')
glVertexAttribIFormat.add( Input( 'attribindex','GLuint' ))
glVertexAttribIFormat.add( Input( 'size','GLint' ))
glVertexAttribIFormat.add( Input( 'type','GLenum' ))
glVertexAttribIFormat.add( Input( 'relativeoffset','GLuint' ))
glVertexAttribIFormat.version = ''
glVertexAttribIFormat.category = 'GL_ARB_vertex_attrib_binding'
glVertexAttribIFormat.trace = True
glVertexAttribIFormat.play = True
gl.add(glVertexAttribIFormat)

glVertexAttribLFormat = Function('glVertexAttribLFormat')
glVertexAttribLFormat.ret = Return('void')
glVertexAttribLFormat.add( Input( 'attribindex','GLuint' ))
glVertexAttribLFormat.add( Input( 'size','GLint' ))
glVertexAttribLFormat.add( Input( 'type','GLenum' ))
glVertexAttribLFormat.add( Input( 'relativeoffset','GLuint' ))
glVertexAttribLFormat.version = ''
glVertexAttribLFormat.category = 'GL_ARB_vertex_attrib_binding'
glVertexAttribLFormat.trace = True
glVertexAttribLFormat.play = True
gl.add(glVertexAttribLFormat)

glVertexBindingDivisor = Function('glVertexBindingDivisor')
glVertexBindingDivisor.ret = Return('void')
glVertexBindingDivisor.add( Input( 'bindingindex','GLuint' ))
glVertexBindingDivisor.add( Input( 'divisor','GLuint' ))
glVertexBindingDivisor.version = ''
glVertexBindingDivisor.category = 'GL_ARB_vertex_attrib_binding'
glVertexBindingDivisor.trace = True
glVertexBindingDivisor.play = True
gl.add(glVertexBindingDivisor)

# GL_ARB_vertex_blend

glVertexBlendARB = Function('glVertexBlendARB')
glVertexBlendARB.ret = Return('void')
glVertexBlendARB.add( Input( 'count','GLint' ))
glVertexBlendARB.version = '1.1'
glVertexBlendARB.category = 'GL_ARB_vertex_blend'
glVertexBlendARB.trace = True
glVertexBlendARB.play = True
gl.add(glVertexBlendARB)

glWeightPointerARB = Function('glWeightPointerARB')
glWeightPointerARB.ret = Return('void')
glWeightPointerARB.add( Input( 'size','GLint' ))
glWeightPointerARB.add( Input( 'type','GLenum' ))
glWeightPointerARB.add( Input( 'stride','GLsizei' ))
glWeightPointerARB.add( Input( 'pointer','const GLvoid *' ))
glWeightPointerARB.version = '1.1'
glWeightPointerARB.category = 'GL_ARB_vertex_blend'
glWeightPointerARB.trace = True
glWeightPointerARB.play = True
gl.add(glWeightPointerARB)

glWeightbvARB = Function('glWeightbvARB')
glWeightbvARB.ret = Return('void')
glWeightbvARB.add( Input( 'size','GLint' ))
glWeightbvARB.add( Input( 'weights','const GLbyte *' ))
glWeightbvARB.version = '1.1'
glWeightbvARB.category = 'GL_ARB_vertex_blend'
glWeightbvARB.trace = True
glWeightbvARB.play = False
gl.add(glWeightbvARB)

glWeightdvARB = Function('glWeightdvARB')
glWeightdvARB.ret = Return('void')
glWeightdvARB.add( Input( 'size','GLint' ))
glWeightdvARB.add( Input( 'weights','const GLdouble *' ))
glWeightdvARB.version = '1.1'
glWeightdvARB.category = 'GL_ARB_vertex_blend'
glWeightdvARB.trace = True
glWeightdvARB.play = True
gl.add(glWeightdvARB)

glWeightfvARB = Function('glWeightfvARB')
glWeightfvARB.ret = Return('void')
glWeightfvARB.add( Input( 'size','GLint' ))
glWeightfvARB.add( Input( 'weights','const GLfloat *' ))
glWeightfvARB.version = '1.1'
glWeightfvARB.category = 'GL_ARB_vertex_blend'
glWeightfvARB.trace = True
glWeightfvARB.play = True
gl.add(glWeightfvARB)

glWeightivARB = Function('glWeightivARB')
glWeightivARB.ret = Return('void')
glWeightivARB.add( Input( 'size','GLint' ))
glWeightivARB.add( Input( 'weights','const GLint *' ))
glWeightivARB.version = '1.1'
glWeightivARB.category = 'GL_ARB_vertex_blend'
glWeightivARB.trace = True
glWeightivARB.play = True
gl.add(glWeightivARB)

glWeightsvARB = Function('glWeightsvARB')
glWeightsvARB.ret = Return('void')
glWeightsvARB.add( Input( 'size','GLint' ))
glWeightsvARB.add( Input( 'weights','const GLshort *' ))
glWeightsvARB.version = '1.1'
glWeightsvARB.category = 'GL_ARB_vertex_blend'
glWeightsvARB.trace = True
glWeightsvARB.play = True
gl.add(glWeightsvARB)

glWeightubvARB = Function('glWeightubvARB')
glWeightubvARB.ret = Return('void')
glWeightubvARB.add( Input( 'size','GLint' ))
glWeightubvARB.add( Input( 'weights','const GLubyte *' ))
glWeightubvARB.version = '1.1'
glWeightubvARB.category = 'GL_ARB_vertex_blend'
glWeightubvARB.trace = True
glWeightubvARB.play = False
gl.add(glWeightubvARB)

glWeightuivARB = Function('glWeightuivARB')
glWeightuivARB.ret = Return('void')
glWeightuivARB.add( Input( 'size','GLint' ))
glWeightuivARB.add( Input( 'weights','const GLuint *' ))
glWeightuivARB.version = '1.1'
glWeightuivARB.category = 'GL_ARB_vertex_blend'
glWeightuivARB.trace = True
glWeightuivARB.play = True
gl.add(glWeightuivARB)

glWeightusvARB = Function('glWeightusvARB')
glWeightusvARB.ret = Return('void')
glWeightusvARB.add( Input( 'size','GLint' ))
glWeightusvARB.add( Input( 'weights','const GLushort *' ))
glWeightusvARB.version = '1.1'
glWeightusvARB.category = 'GL_ARB_vertex_blend'
glWeightusvARB.trace = True
glWeightusvARB.play = True
gl.add(glWeightusvARB)

# GL_ARB_vertex_buffer_object

glBindBufferARB = Function('glBindBufferARB')
glBindBufferARB.ret = Return('void')
glBindBufferARB.add( Input( 'target','GLenum' ))
glBindBufferARB.add( Input( 'buffer','GLuint' ))
glBindBufferARB.version = '1.1'
glBindBufferARB.category = 'GL_ARB_vertex_buffer_object'
glBindBufferARB.trace = True
glBindBufferARB.play = True
gl.add(glBindBufferARB)

glBufferDataARB = Function('glBufferDataARB')
glBufferDataARB.ret = Return('void')
glBufferDataARB.add( Input( 'target','GLenum' ))
glBufferDataARB.add( Input( 'size','GLsizeiptrARB' ))
glBufferDataARB.add( Input( 'data','const GLvoid *' ))
glBufferDataARB.add( Input( 'usage','GLenum' ))
glBufferDataARB.version = '1.1'
glBufferDataARB.category = 'GL_ARB_vertex_buffer_object'
glBufferDataARB.trace = True
glBufferDataARB.play = True
gl.add(glBufferDataARB)

glBufferSubDataARB = Function('glBufferSubDataARB')
glBufferSubDataARB.ret = Return('void')
glBufferSubDataARB.add( Input( 'target','GLenum' ))
glBufferSubDataARB.add( Input( 'offset','GLintptrARB' ))
glBufferSubDataARB.add( Input( 'size','GLsizeiptrARB' ))
glBufferSubDataARB.add( Input( 'data','const GLvoid *' ))
glBufferSubDataARB.version = '1.1'
glBufferSubDataARB.category = 'GL_ARB_vertex_buffer_object'
glBufferSubDataARB.trace = True
glBufferSubDataARB.play = True
gl.add(glBufferSubDataARB)

glDeleteBuffersARB = Function('glDeleteBuffersARB')
glDeleteBuffersARB.ret = Return('void')
glDeleteBuffersARB.add( Input( 'n','GLsizei' ))
glDeleteBuffersARB.add( Input( 'buffers','const GLuint *' ,size = 'n' ))
glDeleteBuffersARB.version = '1.1'
glDeleteBuffersARB.category = 'GL_ARB_vertex_buffer_object'
glDeleteBuffersARB.trace = True
glDeleteBuffersARB.play = True
gl.add(glDeleteBuffersARB)

glGenBuffersARB = Function('glGenBuffersARB')
glGenBuffersARB.ret = Return('void')
glGenBuffersARB.add( Input( 'n','GLsizei' ))
glGenBuffersARB.add( Output( 'buffers','GLuint *' ,size = 'n' ))
glGenBuffersARB.version = '1.1'
glGenBuffersARB.category = 'GL_ARB_vertex_buffer_object'
glGenBuffersARB.trace = True
glGenBuffersARB.play = True
gl.add(glGenBuffersARB)

glGetBufferParameterivARB = Function('glGetBufferParameterivARB')
glGetBufferParameterivARB.ret = Return('void')
glGetBufferParameterivARB.add( Input( 'target','GLenum' ))
glGetBufferParameterivARB.add( Input( 'pname','GLenum' ))
glGetBufferParameterivARB.add( Output( 'params','GLint *' ))
glGetBufferParameterivARB.version = '1.1'
glGetBufferParameterivARB.category = 'GL_ARB_vertex_buffer_object'
glGetBufferParameterivARB.trace = True
glGetBufferParameterivARB.play = True
gl.add(glGetBufferParameterivARB)

glGetBufferPointervARB = Function('glGetBufferPointervARB')
glGetBufferPointervARB.ret = Return('void')
glGetBufferPointervARB.add( Input( 'target','GLenum' ))
glGetBufferPointervARB.add( Input( 'pname','GLenum' ))
glGetBufferPointervARB.add( Output( 'params','GLvoid **' ,size = 1 ))
glGetBufferPointervARB.version = '1.1'
glGetBufferPointervARB.category = 'GL_ARB_vertex_buffer_object'
glGetBufferPointervARB.trace = True
glGetBufferPointervARB.play = True
gl.add(glGetBufferPointervARB)

glGetBufferSubDataARB = Function('glGetBufferSubDataARB')
glGetBufferSubDataARB.ret = Return('void')
glGetBufferSubDataARB.add( Input( 'target','GLenum' ))
glGetBufferSubDataARB.add( Input( 'offset','GLintptrARB' ))
glGetBufferSubDataARB.add( Input( 'size','GLsizeiptrARB' ))
glGetBufferSubDataARB.add( Output( 'data','GLvoid *' ))
glGetBufferSubDataARB.version = '1.1'
glGetBufferSubDataARB.category = 'GL_ARB_vertex_buffer_object'
glGetBufferSubDataARB.trace = True
glGetBufferSubDataARB.play = True
gl.add(glGetBufferSubDataARB)

glIsBufferARB = Function('glIsBufferARB')
glIsBufferARB.ret = Return('GLboolean')
glIsBufferARB.add( Input( 'buffer','GLuint' ))
glIsBufferARB.version = '1.1'
glIsBufferARB.category = 'GL_ARB_vertex_buffer_object'
glIsBufferARB.trace = True
glIsBufferARB.play = True
gl.add(glIsBufferARB)

glMapBufferARB = Function('glMapBufferARB')
glMapBufferARB.ret = Return('GLvoid *')
glMapBufferARB.add( Input( 'target','GLenum' ))
glMapBufferARB.add( Input( 'access','GLenum' ))
glMapBufferARB.version = '1.1'
glMapBufferARB.category = 'GL_ARB_vertex_buffer_object'
glMapBufferARB.trace = True
glMapBufferARB.play = True
gl.add(glMapBufferARB)

glUnmapBufferARB = Function('glUnmapBufferARB')
glUnmapBufferARB.ret = Return('GLboolean')
glUnmapBufferARB.add( Input( 'target','GLenum' ))
glUnmapBufferARB.version = '1.1'
glUnmapBufferARB.category = 'GL_ARB_vertex_buffer_object'
glUnmapBufferARB.trace = True
glUnmapBufferARB.play = True
gl.add(glUnmapBufferARB)

# GL_ARB_vertex_program

glBindProgramARB = Function('glBindProgramARB')
glBindProgramARB.ret = Return('void')
glBindProgramARB.add( Input( 'target','GLenum' ))
glBindProgramARB.add( Input( 'program','GLuint' ))
glBindProgramARB.version = '1.3'
glBindProgramARB.category = 'GL_ARB_vertex_program'
glBindProgramARB.trace = True
glBindProgramARB.play = True
gl.add(glBindProgramARB)

glDeleteProgramsARB = Function('glDeleteProgramsARB')
glDeleteProgramsARB.ret = Return('void')
glDeleteProgramsARB.add( Input( 'n','GLsizei' ))
glDeleteProgramsARB.add( Input( 'programs','const GLuint *' ,size = 'n' ))
glDeleteProgramsARB.version = '1.3'
glDeleteProgramsARB.category = 'GL_ARB_vertex_program'
glDeleteProgramsARB.trace = True
glDeleteProgramsARB.play = True
gl.add(glDeleteProgramsARB)

glDisableVertexAttribArrayARB = Function('glDisableVertexAttribArrayARB')
glDisableVertexAttribArrayARB.ret = Return('void')
glDisableVertexAttribArrayARB.add( Input( 'index','GLuint' ))
glDisableVertexAttribArrayARB.version = '1.3'
glDisableVertexAttribArrayARB.category = 'GL_ARB_vertex_program'
glDisableVertexAttribArrayARB.trace = True
glDisableVertexAttribArrayARB.play = True
gl.add(glDisableVertexAttribArrayARB)

glEnableVertexAttribArrayARB = Function('glEnableVertexAttribArrayARB')
glEnableVertexAttribArrayARB.ret = Return('void')
glEnableVertexAttribArrayARB.add( Input( 'index','GLuint' ))
glEnableVertexAttribArrayARB.version = '1.3'
glEnableVertexAttribArrayARB.category = 'GL_ARB_vertex_program'
glEnableVertexAttribArrayARB.trace = True
glEnableVertexAttribArrayARB.play = True
gl.add(glEnableVertexAttribArrayARB)

glGenProgramsARB = Function('glGenProgramsARB')
glGenProgramsARB.ret = Return('void')
glGenProgramsARB.add( Input( 'n','GLsizei' ))
glGenProgramsARB.add( Output( 'programs','GLuint *' ,size = 'n' ))
glGenProgramsARB.version = '1.3'
glGenProgramsARB.category = 'GL_ARB_vertex_program'
glGenProgramsARB.trace = True
glGenProgramsARB.play = True
gl.add(glGenProgramsARB)

glGetProgramEnvParameterdvARB = Function('glGetProgramEnvParameterdvARB')
glGetProgramEnvParameterdvARB.ret = Return('void')
glGetProgramEnvParameterdvARB.add( Input( 'target','GLenum' ))
glGetProgramEnvParameterdvARB.add( Input( 'index','GLuint' ))
glGetProgramEnvParameterdvARB.add( Output( 'params','GLdouble *' ,size = 4 ))
glGetProgramEnvParameterdvARB.version = '1.3'
glGetProgramEnvParameterdvARB.category = 'GL_ARB_vertex_program'
glGetProgramEnvParameterdvARB.trace = True
glGetProgramEnvParameterdvARB.play = True
gl.add(glGetProgramEnvParameterdvARB)

glGetProgramEnvParameterfvARB = Function('glGetProgramEnvParameterfvARB')
glGetProgramEnvParameterfvARB.ret = Return('void')
glGetProgramEnvParameterfvARB.add( Input( 'target','GLenum' ))
glGetProgramEnvParameterfvARB.add( Input( 'index','GLuint' ))
glGetProgramEnvParameterfvARB.add( Output( 'params','GLfloat *' ,size = 4 ))
glGetProgramEnvParameterfvARB.version = '1.3'
glGetProgramEnvParameterfvARB.category = 'GL_ARB_vertex_program'
glGetProgramEnvParameterfvARB.trace = True
glGetProgramEnvParameterfvARB.play = True
gl.add(glGetProgramEnvParameterfvARB)

glGetProgramLocalParameterdvARB = Function('glGetProgramLocalParameterdvARB')
glGetProgramLocalParameterdvARB.ret = Return('void')
glGetProgramLocalParameterdvARB.add( Input( 'target','GLenum' ))
glGetProgramLocalParameterdvARB.add( Input( 'index','GLuint' ))
glGetProgramLocalParameterdvARB.add( Output( 'params','GLdouble *' ,size = 4 ))
glGetProgramLocalParameterdvARB.version = '1.3'
glGetProgramLocalParameterdvARB.category = 'GL_ARB_vertex_program'
glGetProgramLocalParameterdvARB.trace = True
glGetProgramLocalParameterdvARB.play = True
gl.add(glGetProgramLocalParameterdvARB)

glGetProgramLocalParameterfvARB = Function('glGetProgramLocalParameterfvARB')
glGetProgramLocalParameterfvARB.ret = Return('void')
glGetProgramLocalParameterfvARB.add( Input( 'target','GLenum' ))
glGetProgramLocalParameterfvARB.add( Input( 'index','GLuint' ))
glGetProgramLocalParameterfvARB.add( Output( 'params','GLfloat *' ,size = 4 ))
glGetProgramLocalParameterfvARB.version = '1.3'
glGetProgramLocalParameterfvARB.category = 'GL_ARB_vertex_program'
glGetProgramLocalParameterfvARB.trace = True
glGetProgramLocalParameterfvARB.play = True
gl.add(glGetProgramLocalParameterfvARB)

glGetProgramStringARB = Function('glGetProgramStringARB')
glGetProgramStringARB.ret = Return('void')
glGetProgramStringARB.add( Input( 'target','GLenum' ))
glGetProgramStringARB.add( Input( 'pname','GLenum' ))
glGetProgramStringARB.add( Output( 'string','GLvoid *' ))
glGetProgramStringARB.version = '1.3'
glGetProgramStringARB.category = 'GL_ARB_vertex_program'
glGetProgramStringARB.trace = True
glGetProgramStringARB.play = True
gl.add(glGetProgramStringARB)

glGetProgramivARB = Function('glGetProgramivARB')
glGetProgramivARB.ret = Return('void')
glGetProgramivARB.add( Input( 'target','GLenum' ))
glGetProgramivARB.add( Input( 'pname','GLenum' ))
glGetProgramivARB.add( Output( 'params','GLint *' ,size = 1 ))
glGetProgramivARB.version = '1.3'
glGetProgramivARB.category = 'GL_ARB_vertex_program'
glGetProgramivARB.trace = True
glGetProgramivARB.play = True
gl.add(glGetProgramivARB)

glGetVertexAttribPointervARB = Function('glGetVertexAttribPointervARB')
glGetVertexAttribPointervARB.ret = Return('void')
glGetVertexAttribPointervARB.add( Input( 'index','GLuint' ))
glGetVertexAttribPointervARB.add( Input( 'pname','GLenum' ))
glGetVertexAttribPointervARB.add( Output( 'pointer','GLvoid **' ,size = 1 ))
glGetVertexAttribPointervARB.version = '1.3'
glGetVertexAttribPointervARB.category = 'GL_ARB_vertex_program'
glGetVertexAttribPointervARB.trace = True
glGetVertexAttribPointervARB.play = False
gl.add(glGetVertexAttribPointervARB)

glGetVertexAttribdvARB = Function('glGetVertexAttribdvARB')
glGetVertexAttribdvARB.ret = Return('void')
glGetVertexAttribdvARB.add( Input( 'index','GLuint' ))
glGetVertexAttribdvARB.add( Input( 'pname','GLenum' ))
glGetVertexAttribdvARB.add( Output( 'params','GLdouble *' ,size = 4 ))
glGetVertexAttribdvARB.version = '1.3'
glGetVertexAttribdvARB.category = 'GL_ARB_vertex_program'
glGetVertexAttribdvARB.trace = True
glGetVertexAttribdvARB.play = True
gl.add(glGetVertexAttribdvARB)

glGetVertexAttribfvARB = Function('glGetVertexAttribfvARB')
glGetVertexAttribfvARB.ret = Return('void')
glGetVertexAttribfvARB.add( Input( 'index','GLuint' ))
glGetVertexAttribfvARB.add( Input( 'pname','GLenum' ))
glGetVertexAttribfvARB.add( Output( 'params','GLfloat *' ,size = 4 ))
glGetVertexAttribfvARB.version = '1.3'
glGetVertexAttribfvARB.category = 'GL_ARB_vertex_program'
glGetVertexAttribfvARB.trace = True
glGetVertexAttribfvARB.play = True
gl.add(glGetVertexAttribfvARB)

glGetVertexAttribivARB = Function('glGetVertexAttribivARB')
glGetVertexAttribivARB.ret = Return('void')
glGetVertexAttribivARB.add( Input( 'index','GLuint' ))
glGetVertexAttribivARB.add( Input( 'pname','GLenum' ))
glGetVertexAttribivARB.add( Output( 'params','GLint *' ,size = 4 ))
glGetVertexAttribivARB.version = '1.3'
glGetVertexAttribivARB.category = 'GL_ARB_vertex_program'
glGetVertexAttribivARB.trace = True
glGetVertexAttribivARB.play = True
gl.add(glGetVertexAttribivARB)

glIsProgramARB = Function('glIsProgramARB')
glIsProgramARB.ret = Return('GLboolean')
glIsProgramARB.add( Input( 'program','GLuint' ))
glIsProgramARB.version = '1.3'
glIsProgramARB.category = 'GL_ARB_vertex_program'
glIsProgramARB.trace = True
glIsProgramARB.play = True
gl.add(glIsProgramARB)

glProgramEnvParameter4dARB = Function('glProgramEnvParameter4dARB')
glProgramEnvParameter4dARB.ret = Return('void')
glProgramEnvParameter4dARB.add( Input( 'target','GLenum' ))
glProgramEnvParameter4dARB.add( Input( 'index','GLuint' ))
glProgramEnvParameter4dARB.add( Input( 'x','GLdouble' ))
glProgramEnvParameter4dARB.add( Input( 'y','GLdouble' ))
glProgramEnvParameter4dARB.add( Input( 'z','GLdouble' ))
glProgramEnvParameter4dARB.add( Input( 'w','GLdouble' ))
glProgramEnvParameter4dARB.version = '1.3'
glProgramEnvParameter4dARB.category = 'GL_ARB_vertex_program'
glProgramEnvParameter4dARB.trace = True
glProgramEnvParameter4dARB.play = True
gl.add(glProgramEnvParameter4dARB)

glProgramEnvParameter4dvARB = Function('glProgramEnvParameter4dvARB')
glProgramEnvParameter4dvARB.ret = Return('void')
glProgramEnvParameter4dvARB.add( Input( 'target','GLenum' ))
glProgramEnvParameter4dvARB.add( Input( 'index','GLuint' ))
glProgramEnvParameter4dvARB.add( Input( 'params','const GLdouble *' ,size = 4 ))
glProgramEnvParameter4dvARB.version = '1.3'
glProgramEnvParameter4dvARB.category = 'GL_ARB_vertex_program'
glProgramEnvParameter4dvARB.trace = True
glProgramEnvParameter4dvARB.play = True
gl.add(glProgramEnvParameter4dvARB)

glProgramEnvParameter4fARB = Function('glProgramEnvParameter4fARB')
glProgramEnvParameter4fARB.ret = Return('void')
glProgramEnvParameter4fARB.add( Input( 'target','GLenum' ))
glProgramEnvParameter4fARB.add( Input( 'index','GLuint' ))
glProgramEnvParameter4fARB.add( Input( 'x','GLfloat' ))
glProgramEnvParameter4fARB.add( Input( 'y','GLfloat' ))
glProgramEnvParameter4fARB.add( Input( 'z','GLfloat' ))
glProgramEnvParameter4fARB.add( Input( 'w','GLfloat' ))
glProgramEnvParameter4fARB.version = '1.3'
glProgramEnvParameter4fARB.category = 'GL_ARB_vertex_program'
glProgramEnvParameter4fARB.trace = True
glProgramEnvParameter4fARB.play = True
gl.add(glProgramEnvParameter4fARB)

glProgramEnvParameter4fvARB = Function('glProgramEnvParameter4fvARB')
glProgramEnvParameter4fvARB.ret = Return('void')
glProgramEnvParameter4fvARB.add( Input( 'target','GLenum' ))
glProgramEnvParameter4fvARB.add( Input( 'index','GLuint' ))
glProgramEnvParameter4fvARB.add( Input( 'params','const GLfloat *' ,size = 4 ))
glProgramEnvParameter4fvARB.version = '1.3'
glProgramEnvParameter4fvARB.category = 'GL_ARB_vertex_program'
glProgramEnvParameter4fvARB.trace = True
glProgramEnvParameter4fvARB.play = True
gl.add(glProgramEnvParameter4fvARB)

glProgramLocalParameter4dARB = Function('glProgramLocalParameter4dARB')
glProgramLocalParameter4dARB.ret = Return('void')
glProgramLocalParameter4dARB.add( Input( 'target','GLenum' ))
glProgramLocalParameter4dARB.add( Input( 'index','GLuint' ))
glProgramLocalParameter4dARB.add( Input( 'x','GLdouble' ))
glProgramLocalParameter4dARB.add( Input( 'y','GLdouble' ))
glProgramLocalParameter4dARB.add( Input( 'z','GLdouble' ))
glProgramLocalParameter4dARB.add( Input( 'w','GLdouble' ))
glProgramLocalParameter4dARB.version = '1.3'
glProgramLocalParameter4dARB.category = 'GL_ARB_vertex_program'
glProgramLocalParameter4dARB.trace = True
glProgramLocalParameter4dARB.play = True
gl.add(glProgramLocalParameter4dARB)

glProgramLocalParameter4dvARB = Function('glProgramLocalParameter4dvARB')
glProgramLocalParameter4dvARB.ret = Return('void')
glProgramLocalParameter4dvARB.add( Input( 'target','GLenum' ))
glProgramLocalParameter4dvARB.add( Input( 'index','GLuint' ))
glProgramLocalParameter4dvARB.add( Input( 'params','const GLdouble *' ,size = 4 ))
glProgramLocalParameter4dvARB.version = '1.3'
glProgramLocalParameter4dvARB.category = 'GL_ARB_vertex_program'
glProgramLocalParameter4dvARB.trace = True
glProgramLocalParameter4dvARB.play = True
gl.add(glProgramLocalParameter4dvARB)

glProgramLocalParameter4fARB = Function('glProgramLocalParameter4fARB')
glProgramLocalParameter4fARB.ret = Return('void')
glProgramLocalParameter4fARB.add( Input( 'target','GLenum' ))
glProgramLocalParameter4fARB.add( Input( 'index','GLuint' ))
glProgramLocalParameter4fARB.add( Input( 'x','GLfloat' ))
glProgramLocalParameter4fARB.add( Input( 'y','GLfloat' ))
glProgramLocalParameter4fARB.add( Input( 'z','GLfloat' ))
glProgramLocalParameter4fARB.add( Input( 'w','GLfloat' ))
glProgramLocalParameter4fARB.version = '1.3'
glProgramLocalParameter4fARB.category = 'GL_ARB_vertex_program'
glProgramLocalParameter4fARB.trace = True
glProgramLocalParameter4fARB.play = True
gl.add(glProgramLocalParameter4fARB)

glProgramLocalParameter4fvARB = Function('glProgramLocalParameter4fvARB')
glProgramLocalParameter4fvARB.ret = Return('void')
glProgramLocalParameter4fvARB.add( Input( 'target','GLenum' ))
glProgramLocalParameter4fvARB.add( Input( 'index','GLuint' ))
glProgramLocalParameter4fvARB.add( Input( 'params','const GLfloat *' ,size = 4 ))
glProgramLocalParameter4fvARB.version = '1.3'
glProgramLocalParameter4fvARB.category = 'GL_ARB_vertex_program'
glProgramLocalParameter4fvARB.trace = True
glProgramLocalParameter4fvARB.play = True
gl.add(glProgramLocalParameter4fvARB)

glProgramStringARB = Function('glProgramStringARB')
glProgramStringARB.ret = Return('void')
glProgramStringARB.add( Input( 'target','GLenum' ))
glProgramStringARB.add( Input( 'format','GLenum' ))
glProgramStringARB.add( Input( 'len','GLsizei' ))
glProgramStringARB.add( Input( 'string','const GLvoid *' ,size = 'len' ,cast = 'const char *' ))
glProgramStringARB.version = '1.3'
glProgramStringARB.category = 'GL_ARB_vertex_program'
glProgramStringARB.trace = True
glProgramStringARB.play = True
gl.add(glProgramStringARB)

glVertexAttrib1dARB = Function('glVertexAttrib1dARB')
glVertexAttrib1dARB.ret = Return('void')
glVertexAttrib1dARB.add( Input( 'index','GLuint' ))
glVertexAttrib1dARB.add( Input( 'x','GLdouble' ))
glVertexAttrib1dARB.version = '1.3'
glVertexAttrib1dARB.category = 'GL_ARB_vertex_program'
glVertexAttrib1dARB.trace = True
glVertexAttrib1dARB.play = True
gl.add(glVertexAttrib1dARB)

glVertexAttrib1dvARB = Function('glVertexAttrib1dvARB')
glVertexAttrib1dvARB.ret = Return('void')
glVertexAttrib1dvARB.add( Input( 'index','GLuint' ))
glVertexAttrib1dvARB.add( Input( 'v','const GLdouble *' ,size = 1 ))
glVertexAttrib1dvARB.version = '1.3'
glVertexAttrib1dvARB.category = 'GL_ARB_vertex_program'
glVertexAttrib1dvARB.trace = True
glVertexAttrib1dvARB.play = True
gl.add(glVertexAttrib1dvARB)

glVertexAttrib1fARB = Function('glVertexAttrib1fARB')
glVertexAttrib1fARB.ret = Return('void')
glVertexAttrib1fARB.add( Input( 'index','GLuint' ))
glVertexAttrib1fARB.add( Input( 'x','GLfloat' ))
glVertexAttrib1fARB.version = '1.3'
glVertexAttrib1fARB.category = 'GL_ARB_vertex_program'
glVertexAttrib1fARB.trace = True
glVertexAttrib1fARB.play = True
gl.add(glVertexAttrib1fARB)

glVertexAttrib1fvARB = Function('glVertexAttrib1fvARB')
glVertexAttrib1fvARB.ret = Return('void')
glVertexAttrib1fvARB.add( Input( 'index','GLuint' ))
glVertexAttrib1fvARB.add( Input( 'v','const GLfloat *' ,size = 1 ))
glVertexAttrib1fvARB.version = '1.3'
glVertexAttrib1fvARB.category = 'GL_ARB_vertex_program'
glVertexAttrib1fvARB.trace = True
glVertexAttrib1fvARB.play = True
gl.add(glVertexAttrib1fvARB)

glVertexAttrib1sARB = Function('glVertexAttrib1sARB')
glVertexAttrib1sARB.ret = Return('void')
glVertexAttrib1sARB.add( Input( 'index','GLuint' ))
glVertexAttrib1sARB.add( Input( 'x','GLshort' ))
glVertexAttrib1sARB.version = '1.3'
glVertexAttrib1sARB.category = 'GL_ARB_vertex_program'
glVertexAttrib1sARB.trace = True
glVertexAttrib1sARB.play = True
gl.add(glVertexAttrib1sARB)

glVertexAttrib1svARB = Function('glVertexAttrib1svARB')
glVertexAttrib1svARB.ret = Return('void')
glVertexAttrib1svARB.add( Input( 'index','GLuint' ))
glVertexAttrib1svARB.add( Input( 'v','const GLshort *' ,size = 1 ))
glVertexAttrib1svARB.version = '1.3'
glVertexAttrib1svARB.category = 'GL_ARB_vertex_program'
glVertexAttrib1svARB.trace = True
glVertexAttrib1svARB.play = True
gl.add(glVertexAttrib1svARB)

glVertexAttrib2dARB = Function('glVertexAttrib2dARB')
glVertexAttrib2dARB.ret = Return('void')
glVertexAttrib2dARB.add( Input( 'index','GLuint' ))
glVertexAttrib2dARB.add( Input( 'x','GLdouble' ))
glVertexAttrib2dARB.add( Input( 'y','GLdouble' ))
glVertexAttrib2dARB.version = '1.3'
glVertexAttrib2dARB.category = 'GL_ARB_vertex_program'
glVertexAttrib2dARB.trace = True
glVertexAttrib2dARB.play = True
gl.add(glVertexAttrib2dARB)

glVertexAttrib2dvARB = Function('glVertexAttrib2dvARB')
glVertexAttrib2dvARB.ret = Return('void')
glVertexAttrib2dvARB.add( Input( 'index','GLuint' ))
glVertexAttrib2dvARB.add( Input( 'v','const GLdouble *' ,size = 2 ))
glVertexAttrib2dvARB.version = '1.3'
glVertexAttrib2dvARB.category = 'GL_ARB_vertex_program'
glVertexAttrib2dvARB.trace = True
glVertexAttrib2dvARB.play = True
gl.add(glVertexAttrib2dvARB)

glVertexAttrib2fARB = Function('glVertexAttrib2fARB')
glVertexAttrib2fARB.ret = Return('void')
glVertexAttrib2fARB.add( Input( 'index','GLuint' ))
glVertexAttrib2fARB.add( Input( 'x','GLfloat' ))
glVertexAttrib2fARB.add( Input( 'y','GLfloat' ))
glVertexAttrib2fARB.version = '1.3'
glVertexAttrib2fARB.category = 'GL_ARB_vertex_program'
glVertexAttrib2fARB.trace = True
glVertexAttrib2fARB.play = True
gl.add(glVertexAttrib2fARB)

glVertexAttrib2fvARB = Function('glVertexAttrib2fvARB')
glVertexAttrib2fvARB.ret = Return('void')
glVertexAttrib2fvARB.add( Input( 'index','GLuint' ))
glVertexAttrib2fvARB.add( Input( 'v','const GLfloat *' ,size = 2 ))
glVertexAttrib2fvARB.version = '1.3'
glVertexAttrib2fvARB.category = 'GL_ARB_vertex_program'
glVertexAttrib2fvARB.trace = True
glVertexAttrib2fvARB.play = True
gl.add(glVertexAttrib2fvARB)

glVertexAttrib2sARB = Function('glVertexAttrib2sARB')
glVertexAttrib2sARB.ret = Return('void')
glVertexAttrib2sARB.add( Input( 'index','GLuint' ))
glVertexAttrib2sARB.add( Input( 'x','GLshort' ))
glVertexAttrib2sARB.add( Input( 'y','GLshort' ))
glVertexAttrib2sARB.version = '1.3'
glVertexAttrib2sARB.category = 'GL_ARB_vertex_program'
glVertexAttrib2sARB.trace = True
glVertexAttrib2sARB.play = True
gl.add(glVertexAttrib2sARB)

glVertexAttrib2svARB = Function('glVertexAttrib2svARB')
glVertexAttrib2svARB.ret = Return('void')
glVertexAttrib2svARB.add( Input( 'index','GLuint' ))
glVertexAttrib2svARB.add( Input( 'v','const GLshort *' ,size = 2 ))
glVertexAttrib2svARB.version = '1.3'
glVertexAttrib2svARB.category = 'GL_ARB_vertex_program'
glVertexAttrib2svARB.trace = True
glVertexAttrib2svARB.play = True
gl.add(glVertexAttrib2svARB)

glVertexAttrib3dARB = Function('glVertexAttrib3dARB')
glVertexAttrib3dARB.ret = Return('void')
glVertexAttrib3dARB.add( Input( 'index','GLuint' ))
glVertexAttrib3dARB.add( Input( 'x','GLdouble' ))
glVertexAttrib3dARB.add( Input( 'y','GLdouble' ))
glVertexAttrib3dARB.add( Input( 'z','GLdouble' ))
glVertexAttrib3dARB.version = '1.3'
glVertexAttrib3dARB.category = 'GL_ARB_vertex_program'
glVertexAttrib3dARB.trace = True
glVertexAttrib3dARB.play = True
gl.add(glVertexAttrib3dARB)

glVertexAttrib3dvARB = Function('glVertexAttrib3dvARB')
glVertexAttrib3dvARB.ret = Return('void')
glVertexAttrib3dvARB.add( Input( 'index','GLuint' ))
glVertexAttrib3dvARB.add( Input( 'v','const GLdouble *' ,size = 3 ))
glVertexAttrib3dvARB.version = '1.3'
glVertexAttrib3dvARB.category = 'GL_ARB_vertex_program'
glVertexAttrib3dvARB.trace = True
glVertexAttrib3dvARB.play = True
gl.add(glVertexAttrib3dvARB)

glVertexAttrib3fARB = Function('glVertexAttrib3fARB')
glVertexAttrib3fARB.ret = Return('void')
glVertexAttrib3fARB.add( Input( 'index','GLuint' ))
glVertexAttrib3fARB.add( Input( 'x','GLfloat' ))
glVertexAttrib3fARB.add( Input( 'y','GLfloat' ))
glVertexAttrib3fARB.add( Input( 'z','GLfloat' ))
glVertexAttrib3fARB.version = '1.3'
glVertexAttrib3fARB.category = 'GL_ARB_vertex_program'
glVertexAttrib3fARB.trace = True
glVertexAttrib3fARB.play = True
gl.add(glVertexAttrib3fARB)

glVertexAttrib3fvARB = Function('glVertexAttrib3fvARB')
glVertexAttrib3fvARB.ret = Return('void')
glVertexAttrib3fvARB.add( Input( 'index','GLuint' ))
glVertexAttrib3fvARB.add( Input( 'v','const GLfloat *' ,size = 3 ))
glVertexAttrib3fvARB.version = '1.3'
glVertexAttrib3fvARB.category = 'GL_ARB_vertex_program'
glVertexAttrib3fvARB.trace = True
glVertexAttrib3fvARB.play = True
gl.add(glVertexAttrib3fvARB)

glVertexAttrib3sARB = Function('glVertexAttrib3sARB')
glVertexAttrib3sARB.ret = Return('void')
glVertexAttrib3sARB.add( Input( 'index','GLuint' ))
glVertexAttrib3sARB.add( Input( 'x','GLshort' ))
glVertexAttrib3sARB.add( Input( 'y','GLshort' ))
glVertexAttrib3sARB.add( Input( 'z','GLshort' ))
glVertexAttrib3sARB.version = '1.3'
glVertexAttrib3sARB.category = 'GL_ARB_vertex_program'
glVertexAttrib3sARB.trace = True
glVertexAttrib3sARB.play = True
gl.add(glVertexAttrib3sARB)

glVertexAttrib3svARB = Function('glVertexAttrib3svARB')
glVertexAttrib3svARB.ret = Return('void')
glVertexAttrib3svARB.add( Input( 'index','GLuint' ))
glVertexAttrib3svARB.add( Input( 'v','const GLshort *' ,size = 3 ))
glVertexAttrib3svARB.version = '1.3'
glVertexAttrib3svARB.category = 'GL_ARB_vertex_program'
glVertexAttrib3svARB.trace = True
glVertexAttrib3svARB.play = True
gl.add(glVertexAttrib3svARB)

glVertexAttrib4NbvARB = Function('glVertexAttrib4NbvARB')
glVertexAttrib4NbvARB.ret = Return('void')
glVertexAttrib4NbvARB.add( Input( 'index','GLuint' ))
glVertexAttrib4NbvARB.add( Input( 'v','const GLbyte *' ,size = 4 ))
glVertexAttrib4NbvARB.version = '1.3'
glVertexAttrib4NbvARB.category = 'GL_ARB_vertex_program'
glVertexAttrib4NbvARB.trace = True
glVertexAttrib4NbvARB.play = True
gl.add(glVertexAttrib4NbvARB)

glVertexAttrib4NivARB = Function('glVertexAttrib4NivARB')
glVertexAttrib4NivARB.ret = Return('void')
glVertexAttrib4NivARB.add( Input( 'index','GLuint' ))
glVertexAttrib4NivARB.add( Input( 'v','const GLint *' ,size = 4 ))
glVertexAttrib4NivARB.version = '1.3'
glVertexAttrib4NivARB.category = 'GL_ARB_vertex_program'
glVertexAttrib4NivARB.trace = True
glVertexAttrib4NivARB.play = True
gl.add(glVertexAttrib4NivARB)

glVertexAttrib4NsvARB = Function('glVertexAttrib4NsvARB')
glVertexAttrib4NsvARB.ret = Return('void')
glVertexAttrib4NsvARB.add( Input( 'index','GLuint' ))
glVertexAttrib4NsvARB.add( Input( 'v','const GLshort *' ,size = 4 ))
glVertexAttrib4NsvARB.version = '1.3'
glVertexAttrib4NsvARB.category = 'GL_ARB_vertex_program'
glVertexAttrib4NsvARB.trace = True
glVertexAttrib4NsvARB.play = True
gl.add(glVertexAttrib4NsvARB)

glVertexAttrib4NubARB = Function('glVertexAttrib4NubARB')
glVertexAttrib4NubARB.ret = Return('void')
glVertexAttrib4NubARB.add( Input( 'index','GLuint' ))
glVertexAttrib4NubARB.add( Input( 'x','GLubyte' ))
glVertexAttrib4NubARB.add( Input( 'y','GLubyte' ))
glVertexAttrib4NubARB.add( Input( 'z','GLubyte' ))
glVertexAttrib4NubARB.add( Input( 'w','GLubyte' ))
glVertexAttrib4NubARB.version = '1.3'
glVertexAttrib4NubARB.category = 'GL_ARB_vertex_program'
glVertexAttrib4NubARB.trace = True
glVertexAttrib4NubARB.play = True
gl.add(glVertexAttrib4NubARB)

glVertexAttrib4NubvARB = Function('glVertexAttrib4NubvARB')
glVertexAttrib4NubvARB.ret = Return('void')
glVertexAttrib4NubvARB.add( Input( 'index','GLuint' ))
glVertexAttrib4NubvARB.add( Input( 'v','const GLubyte *' ,size = 4 ))
glVertexAttrib4NubvARB.version = '1.3'
glVertexAttrib4NubvARB.category = 'GL_ARB_vertex_program'
glVertexAttrib4NubvARB.trace = True
glVertexAttrib4NubvARB.play = True
gl.add(glVertexAttrib4NubvARB)

glVertexAttrib4NuivARB = Function('glVertexAttrib4NuivARB')
glVertexAttrib4NuivARB.ret = Return('void')
glVertexAttrib4NuivARB.add( Input( 'index','GLuint' ))
glVertexAttrib4NuivARB.add( Input( 'v','const GLuint *' ,size = 4 ))
glVertexAttrib4NuivARB.version = '1.3'
glVertexAttrib4NuivARB.category = 'GL_ARB_vertex_program'
glVertexAttrib4NuivARB.trace = True
glVertexAttrib4NuivARB.play = True
gl.add(glVertexAttrib4NuivARB)

glVertexAttrib4NusvARB = Function('glVertexAttrib4NusvARB')
glVertexAttrib4NusvARB.ret = Return('void')
glVertexAttrib4NusvARB.add( Input( 'index','GLuint' ))
glVertexAttrib4NusvARB.add( Input( 'v','const GLushort *' ,size = 4 ))
glVertexAttrib4NusvARB.version = '1.3'
glVertexAttrib4NusvARB.category = 'GL_ARB_vertex_program'
glVertexAttrib4NusvARB.trace = True
glVertexAttrib4NusvARB.play = True
gl.add(glVertexAttrib4NusvARB)

glVertexAttrib4bvARB = Function('glVertexAttrib4bvARB')
glVertexAttrib4bvARB.ret = Return('void')
glVertexAttrib4bvARB.add( Input( 'index','GLuint' ))
glVertexAttrib4bvARB.add( Input( 'v','const GLbyte *' ,size = 4 ))
glVertexAttrib4bvARB.version = '1.3'
glVertexAttrib4bvARB.category = 'GL_ARB_vertex_program'
glVertexAttrib4bvARB.trace = True
glVertexAttrib4bvARB.play = True
gl.add(glVertexAttrib4bvARB)

glVertexAttrib4dARB = Function('glVertexAttrib4dARB')
glVertexAttrib4dARB.ret = Return('void')
glVertexAttrib4dARB.add( Input( 'index','GLuint' ))
glVertexAttrib4dARB.add( Input( 'x','GLdouble' ))
glVertexAttrib4dARB.add( Input( 'y','GLdouble' ))
glVertexAttrib4dARB.add( Input( 'z','GLdouble' ))
glVertexAttrib4dARB.add( Input( 'w','GLdouble' ))
glVertexAttrib4dARB.version = '1.3'
glVertexAttrib4dARB.category = 'GL_ARB_vertex_program'
glVertexAttrib4dARB.trace = True
glVertexAttrib4dARB.play = True
gl.add(glVertexAttrib4dARB)

glVertexAttrib4dvARB = Function('glVertexAttrib4dvARB')
glVertexAttrib4dvARB.ret = Return('void')
glVertexAttrib4dvARB.add( Input( 'index','GLuint' ))
glVertexAttrib4dvARB.add( Input( 'v','const GLdouble *' ,size = 4 ))
glVertexAttrib4dvARB.version = '1.3'
glVertexAttrib4dvARB.category = 'GL_ARB_vertex_program'
glVertexAttrib4dvARB.trace = True
glVertexAttrib4dvARB.play = True
gl.add(glVertexAttrib4dvARB)

glVertexAttrib4fARB = Function('glVertexAttrib4fARB')
glVertexAttrib4fARB.ret = Return('void')
glVertexAttrib4fARB.add( Input( 'index','GLuint' ))
glVertexAttrib4fARB.add( Input( 'x','GLfloat' ))
glVertexAttrib4fARB.add( Input( 'y','GLfloat' ))
glVertexAttrib4fARB.add( Input( 'z','GLfloat' ))
glVertexAttrib4fARB.add( Input( 'w','GLfloat' ))
glVertexAttrib4fARB.version = '1.3'
glVertexAttrib4fARB.category = 'GL_ARB_vertex_program'
glVertexAttrib4fARB.trace = True
glVertexAttrib4fARB.play = True
gl.add(glVertexAttrib4fARB)

glVertexAttrib4fvARB = Function('glVertexAttrib4fvARB')
glVertexAttrib4fvARB.ret = Return('void')
glVertexAttrib4fvARB.add( Input( 'index','GLuint' ))
glVertexAttrib4fvARB.add( Input( 'v','const GLfloat *' ,size = 4 ))
glVertexAttrib4fvARB.version = '1.3'
glVertexAttrib4fvARB.category = 'GL_ARB_vertex_program'
glVertexAttrib4fvARB.trace = True
glVertexAttrib4fvARB.play = True
gl.add(glVertexAttrib4fvARB)

glVertexAttrib4ivARB = Function('glVertexAttrib4ivARB')
glVertexAttrib4ivARB.ret = Return('void')
glVertexAttrib4ivARB.add( Input( 'index','GLuint' ))
glVertexAttrib4ivARB.add( Input( 'v','const GLint *' ,size = 4 ))
glVertexAttrib4ivARB.version = '1.3'
glVertexAttrib4ivARB.category = 'GL_ARB_vertex_program'
glVertexAttrib4ivARB.trace = True
glVertexAttrib4ivARB.play = True
gl.add(glVertexAttrib4ivARB)

glVertexAttrib4sARB = Function('glVertexAttrib4sARB')
glVertexAttrib4sARB.ret = Return('void')
glVertexAttrib4sARB.add( Input( 'index','GLuint' ))
glVertexAttrib4sARB.add( Input( 'x','GLshort' ))
glVertexAttrib4sARB.add( Input( 'y','GLshort' ))
glVertexAttrib4sARB.add( Input( 'z','GLshort' ))
glVertexAttrib4sARB.add( Input( 'w','GLshort' ))
glVertexAttrib4sARB.version = '1.3'
glVertexAttrib4sARB.category = 'GL_ARB_vertex_program'
glVertexAttrib4sARB.trace = True
glVertexAttrib4sARB.play = True
gl.add(glVertexAttrib4sARB)

glVertexAttrib4svARB = Function('glVertexAttrib4svARB')
glVertexAttrib4svARB.ret = Return('void')
glVertexAttrib4svARB.add( Input( 'index','GLuint' ))
glVertexAttrib4svARB.add( Input( 'v','const GLshort *' ,size = 4 ))
glVertexAttrib4svARB.version = '1.3'
glVertexAttrib4svARB.category = 'GL_ARB_vertex_program'
glVertexAttrib4svARB.trace = True
glVertexAttrib4svARB.play = True
gl.add(glVertexAttrib4svARB)

glVertexAttrib4ubvARB = Function('glVertexAttrib4ubvARB')
glVertexAttrib4ubvARB.ret = Return('void')
glVertexAttrib4ubvARB.add( Input( 'index','GLuint' ))
glVertexAttrib4ubvARB.add( Input( 'v','const GLubyte *' ,size = 4 ))
glVertexAttrib4ubvARB.version = '1.3'
glVertexAttrib4ubvARB.category = 'GL_ARB_vertex_program'
glVertexAttrib4ubvARB.trace = True
glVertexAttrib4ubvARB.play = True
gl.add(glVertexAttrib4ubvARB)

glVertexAttrib4uivARB = Function('glVertexAttrib4uivARB')
glVertexAttrib4uivARB.ret = Return('void')
glVertexAttrib4uivARB.add( Input( 'index','GLuint' ))
glVertexAttrib4uivARB.add( Input( 'v','const GLuint *' ,size = 4 ))
glVertexAttrib4uivARB.version = '1.3'
glVertexAttrib4uivARB.category = 'GL_ARB_vertex_program'
glVertexAttrib4uivARB.trace = True
glVertexAttrib4uivARB.play = True
gl.add(glVertexAttrib4uivARB)

glVertexAttrib4usvARB = Function('glVertexAttrib4usvARB')
glVertexAttrib4usvARB.ret = Return('void')
glVertexAttrib4usvARB.add( Input( 'index','GLuint' ))
glVertexAttrib4usvARB.add( Input( 'v','const GLushort *' ,size = 4 ))
glVertexAttrib4usvARB.version = '1.3'
glVertexAttrib4usvARB.category = 'GL_ARB_vertex_program'
glVertexAttrib4usvARB.trace = True
glVertexAttrib4usvARB.play = True
gl.add(glVertexAttrib4usvARB)

glVertexAttribPointerARB = Function('glVertexAttribPointerARB')
glVertexAttribPointerARB.ret = Return('void')
glVertexAttribPointerARB.add( Input( 'index','GLuint' ))
glVertexAttribPointerARB.add( Input( 'size','GLint' ))
glVertexAttribPointerARB.add( Input( 'type','GLenum' ))
glVertexAttribPointerARB.add( Input( 'normalized','GLboolean' ))
glVertexAttribPointerARB.add( Input( 'stride','GLsizei' ))
glVertexAttribPointerARB.add( Input( 'pointer','const GLvoid *' ))
glVertexAttribPointerARB.version = '1.3'
glVertexAttribPointerARB.category = 'GL_ARB_vertex_program'
glVertexAttribPointerARB.trace = True
glVertexAttribPointerARB.play = True
gl.add(glVertexAttribPointerARB)

# GL_ARB_vertex_shader

glBindAttribLocationARB = Function('glBindAttribLocationARB')
glBindAttribLocationARB.ret = Return('void')
glBindAttribLocationARB.add( Input( 'programObj','GLhandleARB' ))
glBindAttribLocationARB.add( Input( 'index','GLuint' ))
glBindAttribLocationARB.add( Input( 'name','const GLcharARB *' ))
glBindAttribLocationARB.version = '1.1'
glBindAttribLocationARB.category = 'GL_ARB_vertex_shader'
glBindAttribLocationARB.trace = True
glBindAttribLocationARB.play = True
gl.add(glBindAttribLocationARB)

glGetActiveAttribARB = Function('glGetActiveAttribARB')
glGetActiveAttribARB.ret = Return('void')
glGetActiveAttribARB.add( Input( 'programObj','GLhandleARB' ))
glGetActiveAttribARB.add( Input( 'index','GLuint' ))
glGetActiveAttribARB.add( Input( 'maxLength','GLsizei' ))
glGetActiveAttribARB.add( Output( 'length','GLsizei *' ,size = 1 ))
glGetActiveAttribARB.add( Output( 'size','GLint *' ,size = 1 ))
glGetActiveAttribARB.add( Output( 'type','GLenum *' ,size = 1 ))
glGetActiveAttribARB.add( Output( 'name','GLcharARB *' ,maxSize = 'maxLength' ))
glGetActiveAttribARB.version = '1.1'
glGetActiveAttribARB.category = 'GL_ARB_vertex_shader'
glGetActiveAttribARB.trace = True
glGetActiveAttribARB.play = False
gl.add(glGetActiveAttribARB)

glGetAttribLocationARB = Function('glGetAttribLocationARB')
glGetAttribLocationARB.ret = Return('GLint')
glGetAttribLocationARB.add( Input( 'programObj','GLhandleARB' ))
glGetAttribLocationARB.add( Input( 'name','const GLcharARB *' ))
glGetAttribLocationARB.version = '1.1'
glGetAttribLocationARB.category = 'GL_ARB_vertex_shader'
glGetAttribLocationARB.trace = True
glGetAttribLocationARB.play = False
gl.add(glGetAttribLocationARB)

# GL_ARB_vertex_type_2_10_10_10_rev

glColorP3ui = Function('glColorP3ui')
glColorP3ui.ret = Return('void')
glColorP3ui.add( Input( 'type','GLenum' ))
glColorP3ui.add( Input( 'color','GLuint' ))
glColorP3ui.version = '3.3'
glColorP3ui.category = 'GL_ARB_vertex_type_2_10_10_10_rev'
glColorP3ui.trace = True
glColorP3ui.play = True
gl.add(glColorP3ui)

glColorP3uiv = Function('glColorP3uiv')
glColorP3uiv.ret = Return('void')
glColorP3uiv.add( Input( 'type','GLenum' ))
glColorP3uiv.add( Input( 'color','const GLuint *' ,size = 1 ))
glColorP3uiv.version = '3.3'
glColorP3uiv.category = 'GL_ARB_vertex_type_2_10_10_10_rev'
glColorP3uiv.trace = True
glColorP3uiv.play = True
gl.add(glColorP3uiv)

glColorP4ui = Function('glColorP4ui')
glColorP4ui.ret = Return('void')
glColorP4ui.add( Input( 'type','GLenum' ))
glColorP4ui.add( Input( 'color','GLuint' ))
glColorP4ui.version = '3.3'
glColorP4ui.category = 'GL_ARB_vertex_type_2_10_10_10_rev'
glColorP4ui.trace = True
glColorP4ui.play = True
gl.add(glColorP4ui)

glColorP4uiv = Function('glColorP4uiv')
glColorP4uiv.ret = Return('void')
glColorP4uiv.add( Input( 'type','GLenum' ))
glColorP4uiv.add( Input( 'color','const GLuint *' ,size = 1 ))
glColorP4uiv.version = '3.3'
glColorP4uiv.category = 'GL_ARB_vertex_type_2_10_10_10_rev'
glColorP4uiv.trace = True
glColorP4uiv.play = True
gl.add(glColorP4uiv)

glMultiTexCoordP1ui = Function('glMultiTexCoordP1ui')
glMultiTexCoordP1ui.ret = Return('void')
glMultiTexCoordP1ui.add( Input( 'texture','GLenum' ))
glMultiTexCoordP1ui.add( Input( 'type','GLenum' ))
glMultiTexCoordP1ui.add( Input( 'coords','GLuint' ))
glMultiTexCoordP1ui.version = '3.3'
glMultiTexCoordP1ui.category = 'GL_ARB_vertex_type_2_10_10_10_rev'
glMultiTexCoordP1ui.trace = True
glMultiTexCoordP1ui.play = True
gl.add(glMultiTexCoordP1ui)

glMultiTexCoordP1uiv = Function('glMultiTexCoordP1uiv')
glMultiTexCoordP1uiv.ret = Return('void')
glMultiTexCoordP1uiv.add( Input( 'texture','GLenum' ))
glMultiTexCoordP1uiv.add( Input( 'type','GLenum' ))
glMultiTexCoordP1uiv.add( Input( 'coords','const GLuint *' ,size = 1 ))
glMultiTexCoordP1uiv.version = '3.3'
glMultiTexCoordP1uiv.category = 'GL_ARB_vertex_type_2_10_10_10_rev'
glMultiTexCoordP1uiv.trace = True
glMultiTexCoordP1uiv.play = True
gl.add(glMultiTexCoordP1uiv)

glMultiTexCoordP2ui = Function('glMultiTexCoordP2ui')
glMultiTexCoordP2ui.ret = Return('void')
glMultiTexCoordP2ui.add( Input( 'texture','GLenum' ))
glMultiTexCoordP2ui.add( Input( 'type','GLenum' ))
glMultiTexCoordP2ui.add( Input( 'coords','GLuint' ))
glMultiTexCoordP2ui.version = '3.3'
glMultiTexCoordP2ui.category = 'GL_ARB_vertex_type_2_10_10_10_rev'
glMultiTexCoordP2ui.trace = True
glMultiTexCoordP2ui.play = True
gl.add(glMultiTexCoordP2ui)

glMultiTexCoordP2uiv = Function('glMultiTexCoordP2uiv')
glMultiTexCoordP2uiv.ret = Return('void')
glMultiTexCoordP2uiv.add( Input( 'texture','GLenum' ))
glMultiTexCoordP2uiv.add( Input( 'type','GLenum' ))
glMultiTexCoordP2uiv.add( Input( 'coords','const GLuint *' ,size = 1 ))
glMultiTexCoordP2uiv.version = '3.3'
glMultiTexCoordP2uiv.category = 'GL_ARB_vertex_type_2_10_10_10_rev'
glMultiTexCoordP2uiv.trace = True
glMultiTexCoordP2uiv.play = True
gl.add(glMultiTexCoordP2uiv)

glMultiTexCoordP3ui = Function('glMultiTexCoordP3ui')
glMultiTexCoordP3ui.ret = Return('void')
glMultiTexCoordP3ui.add( Input( 'texture','GLenum' ))
glMultiTexCoordP3ui.add( Input( 'type','GLenum' ))
glMultiTexCoordP3ui.add( Input( 'coords','GLuint' ))
glMultiTexCoordP3ui.version = '3.3'
glMultiTexCoordP3ui.category = 'GL_ARB_vertex_type_2_10_10_10_rev'
glMultiTexCoordP3ui.trace = True
glMultiTexCoordP3ui.play = True
gl.add(glMultiTexCoordP3ui)

glMultiTexCoordP3uiv = Function('glMultiTexCoordP3uiv')
glMultiTexCoordP3uiv.ret = Return('void')
glMultiTexCoordP3uiv.add( Input( 'texture','GLenum' ))
glMultiTexCoordP3uiv.add( Input( 'type','GLenum' ))
glMultiTexCoordP3uiv.add( Input( 'coords','const GLuint *' ,size = 1 ))
glMultiTexCoordP3uiv.version = '3.3'
glMultiTexCoordP3uiv.category = 'GL_ARB_vertex_type_2_10_10_10_rev'
glMultiTexCoordP3uiv.trace = True
glMultiTexCoordP3uiv.play = True
gl.add(glMultiTexCoordP3uiv)

glMultiTexCoordP4ui = Function('glMultiTexCoordP4ui')
glMultiTexCoordP4ui.ret = Return('void')
glMultiTexCoordP4ui.add( Input( 'texture','GLenum' ))
glMultiTexCoordP4ui.add( Input( 'type','GLenum' ))
glMultiTexCoordP4ui.add( Input( 'coords','GLuint' ))
glMultiTexCoordP4ui.version = '3.3'
glMultiTexCoordP4ui.category = 'GL_ARB_vertex_type_2_10_10_10_rev'
glMultiTexCoordP4ui.trace = True
glMultiTexCoordP4ui.play = True
gl.add(glMultiTexCoordP4ui)

glMultiTexCoordP4uiv = Function('glMultiTexCoordP4uiv')
glMultiTexCoordP4uiv.ret = Return('void')
glMultiTexCoordP4uiv.add( Input( 'texture','GLenum' ))
glMultiTexCoordP4uiv.add( Input( 'type','GLenum' ))
glMultiTexCoordP4uiv.add( Input( 'coords','const GLuint *' ,size = 1 ))
glMultiTexCoordP4uiv.version = '3.3'
glMultiTexCoordP4uiv.category = 'GL_ARB_vertex_type_2_10_10_10_rev'
glMultiTexCoordP4uiv.trace = True
glMultiTexCoordP4uiv.play = True
gl.add(glMultiTexCoordP4uiv)

glNormalP3ui = Function('glNormalP3ui')
glNormalP3ui.ret = Return('void')
glNormalP3ui.add( Input( 'type','GLenum' ))
glNormalP3ui.add( Input( 'coords','GLuint' ))
glNormalP3ui.version = '3.3'
glNormalP3ui.category = 'GL_ARB_vertex_type_2_10_10_10_rev'
glNormalP3ui.trace = True
glNormalP3ui.play = True
gl.add(glNormalP3ui)

glNormalP3uiv = Function('glNormalP3uiv')
glNormalP3uiv.ret = Return('void')
glNormalP3uiv.add( Input( 'type','GLenum' ))
glNormalP3uiv.add( Input( 'coords','const GLuint *' ,size = 1 ))
glNormalP3uiv.version = '3.3'
glNormalP3uiv.category = 'GL_ARB_vertex_type_2_10_10_10_rev'
glNormalP3uiv.trace = True
glNormalP3uiv.play = True
gl.add(glNormalP3uiv)

glSecondaryColorP3ui = Function('glSecondaryColorP3ui')
glSecondaryColorP3ui.ret = Return('void')
glSecondaryColorP3ui.add( Input( 'type','GLenum' ))
glSecondaryColorP3ui.add( Input( 'color','GLuint' ))
glSecondaryColorP3ui.version = '3.3'
glSecondaryColorP3ui.category = 'GL_ARB_vertex_type_2_10_10_10_rev'
glSecondaryColorP3ui.trace = True
glSecondaryColorP3ui.play = True
gl.add(glSecondaryColorP3ui)

glSecondaryColorP3uiv = Function('glSecondaryColorP3uiv')
glSecondaryColorP3uiv.ret = Return('void')
glSecondaryColorP3uiv.add( Input( 'type','GLenum' ))
glSecondaryColorP3uiv.add( Input( 'color','const GLuint *' ,size = 1 ))
glSecondaryColorP3uiv.version = '3.3'
glSecondaryColorP3uiv.category = 'GL_ARB_vertex_type_2_10_10_10_rev'
glSecondaryColorP3uiv.trace = True
glSecondaryColorP3uiv.play = True
gl.add(glSecondaryColorP3uiv)

glTexCoordP1ui = Function('glTexCoordP1ui')
glTexCoordP1ui.ret = Return('void')
glTexCoordP1ui.add( Input( 'type','GLenum' ))
glTexCoordP1ui.add( Input( 'coords','GLuint' ))
glTexCoordP1ui.version = '3.3'
glTexCoordP1ui.category = 'GL_ARB_vertex_type_2_10_10_10_rev'
glTexCoordP1ui.trace = True
glTexCoordP1ui.play = True
gl.add(glTexCoordP1ui)

glTexCoordP1uiv = Function('glTexCoordP1uiv')
glTexCoordP1uiv.ret = Return('void')
glTexCoordP1uiv.add( Input( 'type','GLenum' ))
glTexCoordP1uiv.add( Input( 'coords','const GLuint *' ,size = 1 ))
glTexCoordP1uiv.version = '3.3'
glTexCoordP1uiv.category = 'GL_ARB_vertex_type_2_10_10_10_rev'
glTexCoordP1uiv.trace = True
glTexCoordP1uiv.play = True
gl.add(glTexCoordP1uiv)

glTexCoordP2ui = Function('glTexCoordP2ui')
glTexCoordP2ui.ret = Return('void')
glTexCoordP2ui.add( Input( 'type','GLenum' ))
glTexCoordP2ui.add( Input( 'coords','GLuint' ))
glTexCoordP2ui.version = '3.3'
glTexCoordP2ui.category = 'GL_ARB_vertex_type_2_10_10_10_rev'
glTexCoordP2ui.trace = True
glTexCoordP2ui.play = True
gl.add(glTexCoordP2ui)

glTexCoordP2uiv = Function('glTexCoordP2uiv')
glTexCoordP2uiv.ret = Return('void')
glTexCoordP2uiv.add( Input( 'type','GLenum' ))
glTexCoordP2uiv.add( Input( 'coords','const GLuint *' ,size = 1 ))
glTexCoordP2uiv.version = '3.3'
glTexCoordP2uiv.category = 'GL_ARB_vertex_type_2_10_10_10_rev'
glTexCoordP2uiv.trace = True
glTexCoordP2uiv.play = True
gl.add(glTexCoordP2uiv)

glTexCoordP3ui = Function('glTexCoordP3ui')
glTexCoordP3ui.ret = Return('void')
glTexCoordP3ui.add( Input( 'type','GLenum' ))
glTexCoordP3ui.add( Input( 'coords','GLuint' ))
glTexCoordP3ui.version = '3.3'
glTexCoordP3ui.category = 'GL_ARB_vertex_type_2_10_10_10_rev'
glTexCoordP3ui.trace = True
glTexCoordP3ui.play = True
gl.add(glTexCoordP3ui)

glTexCoordP3uiv = Function('glTexCoordP3uiv')
glTexCoordP3uiv.ret = Return('void')
glTexCoordP3uiv.add( Input( 'type','GLenum' ))
glTexCoordP3uiv.add( Input( 'coords','const GLuint *' ,size = 1 ))
glTexCoordP3uiv.version = '3.3'
glTexCoordP3uiv.category = 'GL_ARB_vertex_type_2_10_10_10_rev'
glTexCoordP3uiv.trace = True
glTexCoordP3uiv.play = True
gl.add(glTexCoordP3uiv)

glTexCoordP4ui = Function('glTexCoordP4ui')
glTexCoordP4ui.ret = Return('void')
glTexCoordP4ui.add( Input( 'type','GLenum' ))
glTexCoordP4ui.add( Input( 'coords','GLuint' ))
glTexCoordP4ui.version = '3.3'
glTexCoordP4ui.category = 'GL_ARB_vertex_type_2_10_10_10_rev'
glTexCoordP4ui.trace = True
glTexCoordP4ui.play = True
gl.add(glTexCoordP4ui)

glTexCoordP4uiv = Function('glTexCoordP4uiv')
glTexCoordP4uiv.ret = Return('void')
glTexCoordP4uiv.add( Input( 'type','GLenum' ))
glTexCoordP4uiv.add( Input( 'coords','const GLuint *' ,size = 1 ))
glTexCoordP4uiv.version = '3.3'
glTexCoordP4uiv.category = 'GL_ARB_vertex_type_2_10_10_10_rev'
glTexCoordP4uiv.trace = True
glTexCoordP4uiv.play = True
gl.add(glTexCoordP4uiv)

glVertexAttribP1ui = Function('glVertexAttribP1ui')
glVertexAttribP1ui.ret = Return('void')
glVertexAttribP1ui.add( Input( 'index','GLuint' ))
glVertexAttribP1ui.add( Input( 'type','GLenum' ))
glVertexAttribP1ui.add( Input( 'normalized','GLboolean' ))
glVertexAttribP1ui.add( Input( 'value','GLuint' ))
glVertexAttribP1ui.version = '3.3'
glVertexAttribP1ui.category = 'GL_ARB_vertex_type_2_10_10_10_rev'
glVertexAttribP1ui.trace = True
glVertexAttribP1ui.play = True
gl.add(glVertexAttribP1ui)

glVertexAttribP1uiv = Function('glVertexAttribP1uiv')
glVertexAttribP1uiv.ret = Return('void')
glVertexAttribP1uiv.add( Input( 'index','GLuint' ))
glVertexAttribP1uiv.add( Input( 'type','GLenum' ))
glVertexAttribP1uiv.add( Input( 'normalized','GLboolean' ))
glVertexAttribP1uiv.add( Input( 'value','const GLuint *' ,size = 1 ))
glVertexAttribP1uiv.version = '3.3'
glVertexAttribP1uiv.category = 'GL_ARB_vertex_type_2_10_10_10_rev'
glVertexAttribP1uiv.trace = True
glVertexAttribP1uiv.play = True
gl.add(glVertexAttribP1uiv)

glVertexAttribP2ui = Function('glVertexAttribP2ui')
glVertexAttribP2ui.ret = Return('void')
glVertexAttribP2ui.add( Input( 'index','GLuint' ))
glVertexAttribP2ui.add( Input( 'type','GLenum' ))
glVertexAttribP2ui.add( Input( 'normalized','GLboolean' ))
glVertexAttribP2ui.add( Input( 'value','GLuint' ))
glVertexAttribP2ui.version = '3.3'
glVertexAttribP2ui.category = 'GL_ARB_vertex_type_2_10_10_10_rev'
glVertexAttribP2ui.trace = True
glVertexAttribP2ui.play = True
gl.add(glVertexAttribP2ui)

glVertexAttribP2uiv = Function('glVertexAttribP2uiv')
glVertexAttribP2uiv.ret = Return('void')
glVertexAttribP2uiv.add( Input( 'index','GLuint' ))
glVertexAttribP2uiv.add( Input( 'type','GLenum' ))
glVertexAttribP2uiv.add( Input( 'normalized','GLboolean' ))
glVertexAttribP2uiv.add( Input( 'value','const GLuint *' ,size = 1 ))
glVertexAttribP2uiv.version = '3.3'
glVertexAttribP2uiv.category = 'GL_ARB_vertex_type_2_10_10_10_rev'
glVertexAttribP2uiv.trace = True
glVertexAttribP2uiv.play = True
gl.add(glVertexAttribP2uiv)

glVertexAttribP3ui = Function('glVertexAttribP3ui')
glVertexAttribP3ui.ret = Return('void')
glVertexAttribP3ui.add( Input( 'index','GLuint' ))
glVertexAttribP3ui.add( Input( 'type','GLenum' ))
glVertexAttribP3ui.add( Input( 'normalized','GLboolean' ))
glVertexAttribP3ui.add( Input( 'value','GLuint' ))
glVertexAttribP3ui.version = '3.3'
glVertexAttribP3ui.category = 'GL_ARB_vertex_type_2_10_10_10_rev'
glVertexAttribP3ui.trace = True
glVertexAttribP3ui.play = True
gl.add(glVertexAttribP3ui)

glVertexAttribP3uiv = Function('glVertexAttribP3uiv')
glVertexAttribP3uiv.ret = Return('void')
glVertexAttribP3uiv.add( Input( 'index','GLuint' ))
glVertexAttribP3uiv.add( Input( 'type','GLenum' ))
glVertexAttribP3uiv.add( Input( 'normalized','GLboolean' ))
glVertexAttribP3uiv.add( Input( 'value','const GLuint *' ,size = 1 ))
glVertexAttribP3uiv.version = '3.3'
glVertexAttribP3uiv.category = 'GL_ARB_vertex_type_2_10_10_10_rev'
glVertexAttribP3uiv.trace = True
glVertexAttribP3uiv.play = True
gl.add(glVertexAttribP3uiv)

glVertexAttribP4ui = Function('glVertexAttribP4ui')
glVertexAttribP4ui.ret = Return('void')
glVertexAttribP4ui.add( Input( 'index','GLuint' ))
glVertexAttribP4ui.add( Input( 'type','GLenum' ))
glVertexAttribP4ui.add( Input( 'normalized','GLboolean' ))
glVertexAttribP4ui.add( Input( 'value','GLuint' ))
glVertexAttribP4ui.version = '3.3'
glVertexAttribP4ui.category = 'GL_ARB_vertex_type_2_10_10_10_rev'
glVertexAttribP4ui.trace = True
glVertexAttribP4ui.play = True
gl.add(glVertexAttribP4ui)

glVertexAttribP4uiv = Function('glVertexAttribP4uiv')
glVertexAttribP4uiv.ret = Return('void')
glVertexAttribP4uiv.add( Input( 'index','GLuint' ))
glVertexAttribP4uiv.add( Input( 'type','GLenum' ))
glVertexAttribP4uiv.add( Input( 'normalized','GLboolean' ))
glVertexAttribP4uiv.add( Input( 'value','const GLuint *' ,size = 1 ))
glVertexAttribP4uiv.version = '3.3'
glVertexAttribP4uiv.category = 'GL_ARB_vertex_type_2_10_10_10_rev'
glVertexAttribP4uiv.trace = True
glVertexAttribP4uiv.play = True
gl.add(glVertexAttribP4uiv)

glVertexP2ui = Function('glVertexP2ui')
glVertexP2ui.ret = Return('void')
glVertexP2ui.add( Input( 'type','GLenum' ))
glVertexP2ui.add( Input( 'coords','GLuint' ))
glVertexP2ui.version = '3.3'
glVertexP2ui.category = 'GL_ARB_vertex_type_2_10_10_10_rev'
glVertexP2ui.trace = True
glVertexP2ui.play = True
gl.add(glVertexP2ui)

glVertexP2uiv = Function('glVertexP2uiv')
glVertexP2uiv.ret = Return('void')
glVertexP2uiv.add( Input( 'type','GLenum' ))
glVertexP2uiv.add( Input( 'coords','const GLuint *' ,size = 1 ))
glVertexP2uiv.version = '3.3'
glVertexP2uiv.category = 'GL_ARB_vertex_type_2_10_10_10_rev'
glVertexP2uiv.trace = True
glVertexP2uiv.play = True
gl.add(glVertexP2uiv)

glVertexP3ui = Function('glVertexP3ui')
glVertexP3ui.ret = Return('void')
glVertexP3ui.add( Input( 'type','GLenum' ))
glVertexP3ui.add( Input( 'coords','GLuint' ))
glVertexP3ui.version = '3.3'
glVertexP3ui.category = 'GL_ARB_vertex_type_2_10_10_10_rev'
glVertexP3ui.trace = True
glVertexP3ui.play = True
gl.add(glVertexP3ui)

glVertexP3uiv = Function('glVertexP3uiv')
glVertexP3uiv.ret = Return('void')
glVertexP3uiv.add( Input( 'type','GLenum' ))
glVertexP3uiv.add( Input( 'coords','const GLuint *' ,size = 1 ))
glVertexP3uiv.version = '3.3'
glVertexP3uiv.category = 'GL_ARB_vertex_type_2_10_10_10_rev'
glVertexP3uiv.trace = True
glVertexP3uiv.play = True
gl.add(glVertexP3uiv)

glVertexP4ui = Function('glVertexP4ui')
glVertexP4ui.ret = Return('void')
glVertexP4ui.add( Input( 'type','GLenum' ))
glVertexP4ui.add( Input( 'coords','GLuint' ))
glVertexP4ui.version = '3.3'
glVertexP4ui.category = 'GL_ARB_vertex_type_2_10_10_10_rev'
glVertexP4ui.trace = True
glVertexP4ui.play = True
gl.add(glVertexP4ui)

glVertexP4uiv = Function('glVertexP4uiv')
glVertexP4uiv.ret = Return('void')
glVertexP4uiv.add( Input( 'type','GLenum' ))
glVertexP4uiv.add( Input( 'coords','const GLuint *' ,size = 1 ))
glVertexP4uiv.version = '3.3'
glVertexP4uiv.category = 'GL_ARB_vertex_type_2_10_10_10_rev'
glVertexP4uiv.trace = True
glVertexP4uiv.play = True
gl.add(glVertexP4uiv)

# GL_ARB_viewport_array

glDepthRangeArrayv = Function('glDepthRangeArrayv')
glDepthRangeArrayv.ret = Return('void')
glDepthRangeArrayv.add( Input( 'first','GLuint' ))
glDepthRangeArrayv.add( Input( 'count','GLsizei' ))
glDepthRangeArrayv.add( Input( 'v','const GLclampd *' ,size = 'count * 2' ))
glDepthRangeArrayv.version = '4.1'
glDepthRangeArrayv.category = 'GL_ARB_viewport_array'
glDepthRangeArrayv.trace = True
glDepthRangeArrayv.play = True
gl.add(glDepthRangeArrayv)

glDepthRangeIndexed = Function('glDepthRangeIndexed')
glDepthRangeIndexed.ret = Return('void')
glDepthRangeIndexed.add( Input( 'index','GLuint' ))
glDepthRangeIndexed.add( Input( 'n','GLclampd' ))
glDepthRangeIndexed.add( Input( 'f','GLclampd' ))
glDepthRangeIndexed.version = '4.1'
glDepthRangeIndexed.category = 'GL_ARB_viewport_array'
glDepthRangeIndexed.trace = True
glDepthRangeIndexed.play = True
gl.add(glDepthRangeIndexed)

glGetDoublei_v = Function('glGetDoublei_v')
glGetDoublei_v.ret = Return('void')
glGetDoublei_v.add( Input( 'target','GLenum' ))
glGetDoublei_v.add( Input( 'index','GLuint' ))
glGetDoublei_v.add( Output( 'v','GLdouble *' ))
glGetDoublei_v.version = '4.1'
glGetDoublei_v.category = 'GL_ARB_viewport_array'
glGetDoublei_v.trace = True
glGetDoublei_v.play = False
gl.add(glGetDoublei_v)

glGetFloati_v = Function('glGetFloati_v')
glGetFloati_v.ret = Return('void')
glGetFloati_v.add( Input( 'target','GLenum' ))
glGetFloati_v.add( Input( 'index','GLuint' ))
glGetFloati_v.add( Output( 'v','GLfloat *' ))
glGetFloati_v.version = '4.1'
glGetFloati_v.category = 'GL_ARB_viewport_array'
glGetFloati_v.trace = True
glGetFloati_v.play = False
gl.add(glGetFloati_v)

glScissorArrayv = Function('glScissorArrayv')
glScissorArrayv.ret = Return('void')
glScissorArrayv.add( Input( 'first','GLuint' ))
glScissorArrayv.add( Input( 'count','GLsizei' ))
glScissorArrayv.add( Input( 'v','const GLint *' ,size = 'count * 4' ))
glScissorArrayv.version = '4.1'
glScissorArrayv.category = 'GL_ARB_viewport_array'
glScissorArrayv.trace = True
glScissorArrayv.play = True
gl.add(glScissorArrayv)

glScissorIndexed = Function('glScissorIndexed')
glScissorIndexed.ret = Return('void')
glScissorIndexed.add( Input( 'index','GLuint' ))
glScissorIndexed.add( Input( 'left','GLint' ))
glScissorIndexed.add( Input( 'bottom','GLint' ))
glScissorIndexed.add( Input( 'width','GLint' ))
glScissorIndexed.add( Input( 'height','GLint' ))
glScissorIndexed.version = '4.1'
glScissorIndexed.category = 'GL_ARB_viewport_array'
glScissorIndexed.trace = True
glScissorIndexed.play = True
gl.add(glScissorIndexed)

glScissorIndexedv = Function('glScissorIndexedv')
glScissorIndexedv.ret = Return('void')
glScissorIndexedv.add( Input( 'index','GLuint' ))
glScissorIndexedv.add( Input( 'v','const GLint *' ,size = 4 ))
glScissorIndexedv.version = '4.1'
glScissorIndexedv.category = 'GL_ARB_viewport_array'
glScissorIndexedv.trace = True
glScissorIndexedv.play = True
gl.add(glScissorIndexedv)

glViewportArrayv = Function('glViewportArrayv')
glViewportArrayv.ret = Return('void')
glViewportArrayv.add( Input( 'first','GLuint' ))
glViewportArrayv.add( Input( 'count','GLsizei' ))
glViewportArrayv.add( Input( 'v','const GLfloat *' ,size = 'count * 4' ))
glViewportArrayv.version = '4.1'
glViewportArrayv.category = 'GL_ARB_viewport_array'
glViewportArrayv.trace = True
glViewportArrayv.play = True
gl.add(glViewportArrayv)

glViewportIndexedf = Function('glViewportIndexedf')
glViewportIndexedf.ret = Return('void')
glViewportIndexedf.add( Input( 'index','GLuint' ))
glViewportIndexedf.add( Input( 'x','GLfloat' ))
glViewportIndexedf.add( Input( 'y','GLfloat' ))
glViewportIndexedf.add( Input( 'w','GLfloat' ))
glViewportIndexedf.add( Input( 'h','GLfloat' ))
glViewportIndexedf.version = '4.1'
glViewportIndexedf.category = 'GL_ARB_viewport_array'
glViewportIndexedf.trace = True
glViewportIndexedf.play = True
gl.add(glViewportIndexedf)

glViewportIndexedfv = Function('glViewportIndexedfv')
glViewportIndexedfv.ret = Return('void')
glViewportIndexedfv.add( Input( 'index','GLuint' ))
glViewportIndexedfv.add( Input( 'v','const GLfloat *' ,size = 4 ))
glViewportIndexedfv.version = '4.1'
glViewportIndexedfv.category = 'GL_ARB_viewport_array'
glViewportIndexedfv.trace = True
glViewportIndexedfv.play = True
gl.add(glViewportIndexedfv)

# GL_ARB_window_pos

glWindowPos2dARB = Function('glWindowPos2dARB')
glWindowPos2dARB.ret = Return('void')
glWindowPos2dARB.add( Input( 'x','GLdouble' ))
glWindowPos2dARB.add( Input( 'y','GLdouble' ))
glWindowPos2dARB.version = '1.2'
glWindowPos2dARB.category = 'GL_ARB_window_pos'
glWindowPos2dARB.trace = True
glWindowPos2dARB.play = True
gl.add(glWindowPos2dARB)

glWindowPos2dvARB = Function('glWindowPos2dvARB')
glWindowPos2dvARB.ret = Return('void')
glWindowPos2dvARB.add( Input( 'p','const GLdouble *' ,size = 2 ))
glWindowPos2dvARB.version = '1.2'
glWindowPos2dvARB.category = 'GL_ARB_window_pos'
glWindowPos2dvARB.trace = True
glWindowPos2dvARB.play = True
gl.add(glWindowPos2dvARB)

glWindowPos2fARB = Function('glWindowPos2fARB')
glWindowPos2fARB.ret = Return('void')
glWindowPos2fARB.add( Input( 'x','GLfloat' ))
glWindowPos2fARB.add( Input( 'y','GLfloat' ))
glWindowPos2fARB.version = '1.2'
glWindowPos2fARB.category = 'GL_ARB_window_pos'
glWindowPos2fARB.trace = True
glWindowPos2fARB.play = True
gl.add(glWindowPos2fARB)

glWindowPos2fvARB = Function('glWindowPos2fvARB')
glWindowPos2fvARB.ret = Return('void')
glWindowPos2fvARB.add( Input( 'p','const GLfloat *' ,size = 2 ))
glWindowPos2fvARB.version = '1.2'
glWindowPos2fvARB.category = 'GL_ARB_window_pos'
glWindowPos2fvARB.trace = True
glWindowPos2fvARB.play = True
gl.add(glWindowPos2fvARB)

glWindowPos2iARB = Function('glWindowPos2iARB')
glWindowPos2iARB.ret = Return('void')
glWindowPos2iARB.add( Input( 'x','GLint' ))
glWindowPos2iARB.add( Input( 'y','GLint' ))
glWindowPos2iARB.version = '1.2'
glWindowPos2iARB.category = 'GL_ARB_window_pos'
glWindowPos2iARB.trace = True
glWindowPos2iARB.play = True
gl.add(glWindowPos2iARB)

glWindowPos2ivARB = Function('glWindowPos2ivARB')
glWindowPos2ivARB.ret = Return('void')
glWindowPos2ivARB.add( Input( 'p','const GLint *' ,size = 2 ))
glWindowPos2ivARB.version = '1.2'
glWindowPos2ivARB.category = 'GL_ARB_window_pos'
glWindowPos2ivARB.trace = True
glWindowPos2ivARB.play = True
gl.add(glWindowPos2ivARB)

glWindowPos2sARB = Function('glWindowPos2sARB')
glWindowPos2sARB.ret = Return('void')
glWindowPos2sARB.add( Input( 'x','GLshort' ))
glWindowPos2sARB.add( Input( 'y','GLshort' ))
glWindowPos2sARB.version = '1.2'
glWindowPos2sARB.category = 'GL_ARB_window_pos'
glWindowPos2sARB.trace = True
glWindowPos2sARB.play = True
gl.add(glWindowPos2sARB)

glWindowPos2svARB = Function('glWindowPos2svARB')
glWindowPos2svARB.ret = Return('void')
glWindowPos2svARB.add( Input( 'p','const GLshort *' ,size = 2 ))
glWindowPos2svARB.version = '1.2'
glWindowPos2svARB.category = 'GL_ARB_window_pos'
glWindowPos2svARB.trace = True
glWindowPos2svARB.play = True
gl.add(glWindowPos2svARB)

glWindowPos3dARB = Function('glWindowPos3dARB')
glWindowPos3dARB.ret = Return('void')
glWindowPos3dARB.add( Input( 'x','GLdouble' ))
glWindowPos3dARB.add( Input( 'y','GLdouble' ))
glWindowPos3dARB.add( Input( 'z','GLdouble' ))
glWindowPos3dARB.version = '1.2'
glWindowPos3dARB.category = 'GL_ARB_window_pos'
glWindowPos3dARB.trace = True
glWindowPos3dARB.play = True
gl.add(glWindowPos3dARB)

glWindowPos3dvARB = Function('glWindowPos3dvARB')
glWindowPos3dvARB.ret = Return('void')
glWindowPos3dvARB.add( Input( 'p','const GLdouble *' ,size = 3 ))
glWindowPos3dvARB.version = '1.2'
glWindowPos3dvARB.category = 'GL_ARB_window_pos'
glWindowPos3dvARB.trace = True
glWindowPos3dvARB.play = True
gl.add(glWindowPos3dvARB)

glWindowPos3fARB = Function('glWindowPos3fARB')
glWindowPos3fARB.ret = Return('void')
glWindowPos3fARB.add( Input( 'x','GLfloat' ))
glWindowPos3fARB.add( Input( 'y','GLfloat' ))
glWindowPos3fARB.add( Input( 'z','GLfloat' ))
glWindowPos3fARB.version = '1.2'
glWindowPos3fARB.category = 'GL_ARB_window_pos'
glWindowPos3fARB.trace = True
glWindowPos3fARB.play = True
gl.add(glWindowPos3fARB)

glWindowPos3fvARB = Function('glWindowPos3fvARB')
glWindowPos3fvARB.ret = Return('void')
glWindowPos3fvARB.add( Input( 'p','const GLfloat *' ,size = 3 ))
glWindowPos3fvARB.version = '1.2'
glWindowPos3fvARB.category = 'GL_ARB_window_pos'
glWindowPos3fvARB.trace = True
glWindowPos3fvARB.play = True
gl.add(glWindowPos3fvARB)

glWindowPos3iARB = Function('glWindowPos3iARB')
glWindowPos3iARB.ret = Return('void')
glWindowPos3iARB.add( Input( 'x','GLint' ))
glWindowPos3iARB.add( Input( 'y','GLint' ))
glWindowPos3iARB.add( Input( 'z','GLint' ))
glWindowPos3iARB.version = '1.2'
glWindowPos3iARB.category = 'GL_ARB_window_pos'
glWindowPos3iARB.trace = True
glWindowPos3iARB.play = True
gl.add(glWindowPos3iARB)

glWindowPos3ivARB = Function('glWindowPos3ivARB')
glWindowPos3ivARB.ret = Return('void')
glWindowPos3ivARB.add( Input( 'p','const GLint *' ,size = 3 ))
glWindowPos3ivARB.version = '1.2'
glWindowPos3ivARB.category = 'GL_ARB_window_pos'
glWindowPos3ivARB.trace = True
glWindowPos3ivARB.play = True
gl.add(glWindowPos3ivARB)

glWindowPos3sARB = Function('glWindowPos3sARB')
glWindowPos3sARB.ret = Return('void')
glWindowPos3sARB.add( Input( 'x','GLshort' ))
glWindowPos3sARB.add( Input( 'y','GLshort' ))
glWindowPos3sARB.add( Input( 'z','GLshort' ))
glWindowPos3sARB.version = '1.2'
glWindowPos3sARB.category = 'GL_ARB_window_pos'
glWindowPos3sARB.trace = True
glWindowPos3sARB.play = True
gl.add(glWindowPos3sARB)

glWindowPos3svARB = Function('glWindowPos3svARB')
glWindowPos3svARB.ret = Return('void')
glWindowPos3svARB.add( Input( 'p','const GLshort *' ,size = 3 ))
glWindowPos3svARB.version = '1.2'
glWindowPos3svARB.category = 'GL_ARB_window_pos'
glWindowPos3svARB.trace = True
glWindowPos3svARB.play = True
gl.add(glWindowPos3svARB)

# GL_ATI_draw_buffers

glDrawBuffersATI = Function('glDrawBuffersATI')
glDrawBuffersATI.ret = Return('void')
glDrawBuffersATI.add( Input( 'n','GLsizei' ))
glDrawBuffersATI.add( Input( 'bufs','const GLenum *' ,size = 'n' ))
glDrawBuffersATI.version = '1.2'
glDrawBuffersATI.category = 'GL_ATI_draw_buffers'
glDrawBuffersATI.trace = True
glDrawBuffersATI.play = True
gl.add(glDrawBuffersATI)

# GL_ATI_element_array

glDrawElementArrayATI = Function('glDrawElementArrayATI')
glDrawElementArrayATI.ret = Return('void')
glDrawElementArrayATI.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glDrawElementArrayATI.add( Input( 'count','GLsizei' ))
glDrawElementArrayATI.version = '1.2'
glDrawElementArrayATI.category = 'GL_ATI_element_array'
glDrawElementArrayATI.trace = True
glDrawElementArrayATI.play = True
gl.add(glDrawElementArrayATI)

glDrawRangeElementArrayATI = Function('glDrawRangeElementArrayATI')
glDrawRangeElementArrayATI.ret = Return('void')
glDrawRangeElementArrayATI.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glDrawRangeElementArrayATI.add( Input( 'start','GLuint' ))
glDrawRangeElementArrayATI.add( Input( 'end','GLuint' ))
glDrawRangeElementArrayATI.add( Input( 'count','GLsizei' ))
glDrawRangeElementArrayATI.version = '1.2'
glDrawRangeElementArrayATI.category = 'GL_ATI_element_array'
glDrawRangeElementArrayATI.trace = True
glDrawRangeElementArrayATI.play = True
gl.add(glDrawRangeElementArrayATI)

glElementPointerATI = Function('glElementPointerATI')
glElementPointerATI.ret = Return('void')
glElementPointerATI.add( Input( 'type','GLenum' ))
glElementPointerATI.add( Input( 'pointer','const GLvoid *' ))
glElementPointerATI.version = '1.2'
glElementPointerATI.category = 'GL_ATI_element_array'
glElementPointerATI.trace = True
glElementPointerATI.play = True
gl.add(glElementPointerATI)

# GL_ATI_envmap_bumpmap

glGetTexBumpParameterfvATI = Function('glGetTexBumpParameterfvATI')
glGetTexBumpParameterfvATI.ret = Return('void')
glGetTexBumpParameterfvATI.add( Input( 'pname','GLenum' ))
glGetTexBumpParameterfvATI.add( Output( 'param','GLfloat *' ))
glGetTexBumpParameterfvATI.version = '1.2'
glGetTexBumpParameterfvATI.category = 'GL_ATI_envmap_bumpmap'
glGetTexBumpParameterfvATI.trace = True
glGetTexBumpParameterfvATI.play = True
gl.add(glGetTexBumpParameterfvATI)

glGetTexBumpParameterivATI = Function('glGetTexBumpParameterivATI')
glGetTexBumpParameterivATI.ret = Return('void')
glGetTexBumpParameterivATI.add( Input( 'pname','GLenum' ))
glGetTexBumpParameterivATI.add( Output( 'param','GLint *' ))
glGetTexBumpParameterivATI.version = '1.2'
glGetTexBumpParameterivATI.category = 'GL_ATI_envmap_bumpmap'
glGetTexBumpParameterivATI.trace = True
glGetTexBumpParameterivATI.play = True
gl.add(glGetTexBumpParameterivATI)

glTexBumpParameterfvATI = Function('glTexBumpParameterfvATI')
glTexBumpParameterfvATI.ret = Return('void')
glTexBumpParameterfvATI.add( Input( 'pname','GLenum' ))
glTexBumpParameterfvATI.add( Input( 'param','const GLfloat *' ))
glTexBumpParameterfvATI.version = '1.2'
glTexBumpParameterfvATI.category = 'GL_ATI_envmap_bumpmap'
glTexBumpParameterfvATI.trace = True
glTexBumpParameterfvATI.play = True
gl.add(glTexBumpParameterfvATI)

glTexBumpParameterivATI = Function('glTexBumpParameterivATI')
glTexBumpParameterivATI.ret = Return('void')
glTexBumpParameterivATI.add( Input( 'pname','GLenum' ))
glTexBumpParameterivATI.add( Input( 'param','const GLint *' ))
glTexBumpParameterivATI.version = '1.2'
glTexBumpParameterivATI.category = 'GL_ATI_envmap_bumpmap'
glTexBumpParameterivATI.trace = True
glTexBumpParameterivATI.play = True
gl.add(glTexBumpParameterivATI)

# GL_ATI_fragment_shader

glAlphaFragmentOp1ATI = Function('glAlphaFragmentOp1ATI')
glAlphaFragmentOp1ATI.ret = Return('void')
glAlphaFragmentOp1ATI.add( Input( 'op','GLenum' ))
glAlphaFragmentOp1ATI.add( Input( 'dst','GLuint' ))
glAlphaFragmentOp1ATI.add( Input( 'dstMod','GLuint' ))
glAlphaFragmentOp1ATI.add( Input( 'arg1','GLuint' ))
glAlphaFragmentOp1ATI.add( Input( 'arg1Rep','GLuint' ))
glAlphaFragmentOp1ATI.add( Input( 'arg1Mod','GLuint' ))
glAlphaFragmentOp1ATI.version = '1.2'
glAlphaFragmentOp1ATI.category = 'GL_ATI_fragment_shader'
glAlphaFragmentOp1ATI.trace = True
glAlphaFragmentOp1ATI.play = True
gl.add(glAlphaFragmentOp1ATI)

glAlphaFragmentOp2ATI = Function('glAlphaFragmentOp2ATI')
glAlphaFragmentOp2ATI.ret = Return('void')
glAlphaFragmentOp2ATI.add( Input( 'op','GLenum' ))
glAlphaFragmentOp2ATI.add( Input( 'dst','GLuint' ))
glAlphaFragmentOp2ATI.add( Input( 'dstMod','GLuint' ))
glAlphaFragmentOp2ATI.add( Input( 'arg1','GLuint' ))
glAlphaFragmentOp2ATI.add( Input( 'arg1Rep','GLuint' ))
glAlphaFragmentOp2ATI.add( Input( 'arg1Mod','GLuint' ))
glAlphaFragmentOp2ATI.add( Input( 'arg2','GLuint' ))
glAlphaFragmentOp2ATI.add( Input( 'arg2Rep','GLuint' ))
glAlphaFragmentOp2ATI.add( Input( 'arg2Mod','GLuint' ))
glAlphaFragmentOp2ATI.version = '1.2'
glAlphaFragmentOp2ATI.category = 'GL_ATI_fragment_shader'
glAlphaFragmentOp2ATI.trace = True
glAlphaFragmentOp2ATI.play = True
gl.add(glAlphaFragmentOp2ATI)

glAlphaFragmentOp3ATI = Function('glAlphaFragmentOp3ATI')
glAlphaFragmentOp3ATI.ret = Return('void')
glAlphaFragmentOp3ATI.add( Input( 'op','GLenum' ))
glAlphaFragmentOp3ATI.add( Input( 'dst','GLuint' ))
glAlphaFragmentOp3ATI.add( Input( 'dstMod','GLuint' ))
glAlphaFragmentOp3ATI.add( Input( 'arg1','GLuint' ))
glAlphaFragmentOp3ATI.add( Input( 'arg1Rep','GLuint' ))
glAlphaFragmentOp3ATI.add( Input( 'arg1Mod','GLuint' ))
glAlphaFragmentOp3ATI.add( Input( 'arg2','GLuint' ))
glAlphaFragmentOp3ATI.add( Input( 'arg2Rep','GLuint' ))
glAlphaFragmentOp3ATI.add( Input( 'arg2Mod','GLuint' ))
glAlphaFragmentOp3ATI.add( Input( 'arg3','GLuint' ))
glAlphaFragmentOp3ATI.add( Input( 'arg3Rep','GLuint' ))
glAlphaFragmentOp3ATI.add( Input( 'arg3Mod','GLuint' ))
glAlphaFragmentOp3ATI.version = '1.2'
glAlphaFragmentOp3ATI.category = 'GL_ATI_fragment_shader'
glAlphaFragmentOp3ATI.trace = True
glAlphaFragmentOp3ATI.play = True
gl.add(glAlphaFragmentOp3ATI)

glBeginFragmentShaderATI = Function('glBeginFragmentShaderATI')
glBeginFragmentShaderATI.ret = Return('void')
glBeginFragmentShaderATI.version = '1.2'
glBeginFragmentShaderATI.category = 'GL_ATI_fragment_shader'
glBeginFragmentShaderATI.trace = True
glBeginFragmentShaderATI.play = True
gl.add(glBeginFragmentShaderATI)

glBindFragmentShaderATI = Function('glBindFragmentShaderATI')
glBindFragmentShaderATI.ret = Return('void')
glBindFragmentShaderATI.add( Input( 'id','GLuint' ))
glBindFragmentShaderATI.version = '1.2'
glBindFragmentShaderATI.category = 'GL_ATI_fragment_shader'
glBindFragmentShaderATI.trace = True
glBindFragmentShaderATI.play = True
gl.add(glBindFragmentShaderATI)

glColorFragmentOp1ATI = Function('glColorFragmentOp1ATI')
glColorFragmentOp1ATI.ret = Return('void')
glColorFragmentOp1ATI.add( Input( 'op','GLenum' ))
glColorFragmentOp1ATI.add( Input( 'dst','GLuint' ))
glColorFragmentOp1ATI.add( Input( 'dstMask','GLuint' ))
glColorFragmentOp1ATI.add( Input( 'dstMod','GLuint' ))
glColorFragmentOp1ATI.add( Input( 'arg1','GLuint' ))
glColorFragmentOp1ATI.add( Input( 'arg1Rep','GLuint' ))
glColorFragmentOp1ATI.add( Input( 'arg1Mod','GLuint' ))
glColorFragmentOp1ATI.version = '1.2'
glColorFragmentOp1ATI.category = 'GL_ATI_fragment_shader'
glColorFragmentOp1ATI.trace = True
glColorFragmentOp1ATI.play = True
gl.add(glColorFragmentOp1ATI)

glColorFragmentOp2ATI = Function('glColorFragmentOp2ATI')
glColorFragmentOp2ATI.ret = Return('void')
glColorFragmentOp2ATI.add( Input( 'op','GLenum' ))
glColorFragmentOp2ATI.add( Input( 'dst','GLuint' ))
glColorFragmentOp2ATI.add( Input( 'dstMask','GLuint' ))
glColorFragmentOp2ATI.add( Input( 'dstMod','GLuint' ))
glColorFragmentOp2ATI.add( Input( 'arg1','GLuint' ))
glColorFragmentOp2ATI.add( Input( 'arg1Rep','GLuint' ))
glColorFragmentOp2ATI.add( Input( 'arg1Mod','GLuint' ))
glColorFragmentOp2ATI.add( Input( 'arg2','GLuint' ))
glColorFragmentOp2ATI.add( Input( 'arg2Rep','GLuint' ))
glColorFragmentOp2ATI.add( Input( 'arg2Mod','GLuint' ))
glColorFragmentOp2ATI.version = '1.2'
glColorFragmentOp2ATI.category = 'GL_ATI_fragment_shader'
glColorFragmentOp2ATI.trace = True
glColorFragmentOp2ATI.play = True
gl.add(glColorFragmentOp2ATI)

glColorFragmentOp3ATI = Function('glColorFragmentOp3ATI')
glColorFragmentOp3ATI.ret = Return('void')
glColorFragmentOp3ATI.add( Input( 'op','GLenum' ))
glColorFragmentOp3ATI.add( Input( 'dst','GLuint' ))
glColorFragmentOp3ATI.add( Input( 'dstMask','GLuint' ))
glColorFragmentOp3ATI.add( Input( 'dstMod','GLuint' ))
glColorFragmentOp3ATI.add( Input( 'arg1','GLuint' ))
glColorFragmentOp3ATI.add( Input( 'arg1Rep','GLuint' ))
glColorFragmentOp3ATI.add( Input( 'arg1Mod','GLuint' ))
glColorFragmentOp3ATI.add( Input( 'arg2','GLuint' ))
glColorFragmentOp3ATI.add( Input( 'arg2Rep','GLuint' ))
glColorFragmentOp3ATI.add( Input( 'arg2Mod','GLuint' ))
glColorFragmentOp3ATI.add( Input( 'arg3','GLuint' ))
glColorFragmentOp3ATI.add( Input( 'arg3Rep','GLuint' ))
glColorFragmentOp3ATI.add( Input( 'arg3Mod','GLuint' ))
glColorFragmentOp3ATI.version = '1.2'
glColorFragmentOp3ATI.category = 'GL_ATI_fragment_shader'
glColorFragmentOp3ATI.trace = True
glColorFragmentOp3ATI.play = True
gl.add(glColorFragmentOp3ATI)

glDeleteFragmentShaderATI = Function('glDeleteFragmentShaderATI')
glDeleteFragmentShaderATI.ret = Return('void')
glDeleteFragmentShaderATI.add( Input( 'id','GLuint' ))
glDeleteFragmentShaderATI.version = '1.2'
glDeleteFragmentShaderATI.category = 'GL_ATI_fragment_shader'
glDeleteFragmentShaderATI.trace = True
glDeleteFragmentShaderATI.play = True
gl.add(glDeleteFragmentShaderATI)

glEndFragmentShaderATI = Function('glEndFragmentShaderATI')
glEndFragmentShaderATI.ret = Return('void')
glEndFragmentShaderATI.version = '1.2'
glEndFragmentShaderATI.category = 'GL_ATI_fragment_shader'
glEndFragmentShaderATI.trace = True
glEndFragmentShaderATI.play = True
gl.add(glEndFragmentShaderATI)

glGenFragmentShadersATI = Function('glGenFragmentShadersATI')
glGenFragmentShadersATI.ret = Return('GLuint')
glGenFragmentShadersATI.add( Input( 'range','GLuint' ))
glGenFragmentShadersATI.version = '1.2'
glGenFragmentShadersATI.category = 'GL_ATI_fragment_shader'
glGenFragmentShadersATI.trace = True
glGenFragmentShadersATI.play = True
gl.add(glGenFragmentShadersATI)

glPassTexCoordATI = Function('glPassTexCoordATI')
glPassTexCoordATI.ret = Return('void')
glPassTexCoordATI.add( Input( 'dst','GLuint' ))
glPassTexCoordATI.add( Input( 'coord','GLuint' ))
glPassTexCoordATI.add( Input( 'swizzle','GLenum' ))
glPassTexCoordATI.version = '1.2'
glPassTexCoordATI.category = 'GL_ATI_fragment_shader'
glPassTexCoordATI.trace = True
glPassTexCoordATI.play = True
gl.add(glPassTexCoordATI)

glSampleMapATI = Function('glSampleMapATI')
glSampleMapATI.ret = Return('void')
glSampleMapATI.add( Input( 'dst','GLuint' ))
glSampleMapATI.add( Input( 'interp','GLuint' ))
glSampleMapATI.add( Input( 'swizzle','GLenum' ))
glSampleMapATI.version = '1.2'
glSampleMapATI.category = 'GL_ATI_fragment_shader'
glSampleMapATI.trace = True
glSampleMapATI.play = True
gl.add(glSampleMapATI)

glSetFragmentShaderConstantATI = Function('glSetFragmentShaderConstantATI')
glSetFragmentShaderConstantATI.ret = Return('void')
glSetFragmentShaderConstantATI.add( Input( 'dst','GLuint' ))
glSetFragmentShaderConstantATI.add( Input( 'value','const GLfloat *' ,size = 4 ))
glSetFragmentShaderConstantATI.version = '1.2'
glSetFragmentShaderConstantATI.category = 'GL_ATI_fragment_shader'
glSetFragmentShaderConstantATI.trace = True
glSetFragmentShaderConstantATI.play = True
gl.add(glSetFragmentShaderConstantATI)

# GL_ATI_map_object_buffer

glMapObjectBufferATI = Function('glMapObjectBufferATI')
glMapObjectBufferATI.ret = Return('GLvoid *')
glMapObjectBufferATI.add( Input( 'buffer','GLuint' ))
glMapObjectBufferATI.version = '1.2'
glMapObjectBufferATI.category = 'GL_ATI_map_object_buffer'
glMapObjectBufferATI.trace = True
glMapObjectBufferATI.play = True
gl.add(glMapObjectBufferATI)

glUnmapObjectBufferATI = Function('glUnmapObjectBufferATI')
glUnmapObjectBufferATI.ret = Return('void')
glUnmapObjectBufferATI.add( Input( 'buffer','GLuint' ))
glUnmapObjectBufferATI.version = '1.2'
glUnmapObjectBufferATI.category = 'GL_ATI_map_object_buffer'
glUnmapObjectBufferATI.trace = True
glUnmapObjectBufferATI.play = True
gl.add(glUnmapObjectBufferATI)

# GL_ATI_pn_triangles

glPNTrianglesfATI = Function('glPNTrianglesfATI')
glPNTrianglesfATI.ret = Return('void')
glPNTrianglesfATI.add( Input( 'pname','GLenum' ))
glPNTrianglesfATI.add( Input( 'param','GLfloat' ))
glPNTrianglesfATI.version = '1.2'
glPNTrianglesfATI.category = 'GL_ATI_pn_triangles'
glPNTrianglesfATI.trace = True
glPNTrianglesfATI.play = True
gl.add(glPNTrianglesfATI)

glPNTrianglesiATI = Function('glPNTrianglesiATI')
glPNTrianglesiATI.ret = Return('void')
glPNTrianglesiATI.add( Input( 'pname','GLenum' ))
glPNTrianglesiATI.add( Input( 'param','GLint' ))
glPNTrianglesiATI.version = '1.2'
glPNTrianglesiATI.category = 'GL_ATI_pn_triangles'
glPNTrianglesiATI.trace = True
glPNTrianglesiATI.play = True
gl.add(glPNTrianglesiATI)

# GL_ATI_separate_stencil

glStencilFuncSeparateATI = Function('glStencilFuncSeparateATI')
glStencilFuncSeparateATI.ret = Return('void')
glStencilFuncSeparateATI.add( Input( 'frontfunc','GLenum' ))
glStencilFuncSeparateATI.add( Input( 'backfunc','GLenum' ))
glStencilFuncSeparateATI.add( Input( 'ref','GLint' ,regalLog = 'boost::print::hex(ref)' ))
glStencilFuncSeparateATI.add( Input( 'mask','GLuint' ,regalLog = 'boost::print::hex(mask)' ))
glStencilFuncSeparateATI.version = '1.2'
glStencilFuncSeparateATI.category = 'GL_ATI_separate_stencil'
glStencilFuncSeparateATI.trace = True
glStencilFuncSeparateATI.play = True
gl.add(glStencilFuncSeparateATI)

glStencilOpSeparateATI = Function('glStencilOpSeparateATI')
glStencilOpSeparateATI.ret = Return('void')
glStencilOpSeparateATI.add( Input( 'face','GLenum' ))
glStencilOpSeparateATI.add( Input( 'sfail','GLenum' ))
glStencilOpSeparateATI.add( Input( 'dpfail','GLenum' ))
glStencilOpSeparateATI.add( Input( 'dppass','GLenum' ))
glStencilOpSeparateATI.version = '1.2'
glStencilOpSeparateATI.category = 'GL_ATI_separate_stencil'
glStencilOpSeparateATI.trace = True
glStencilOpSeparateATI.play = True
gl.add(glStencilOpSeparateATI)

# GL_ATI_vertex_array_object

glArrayObjectATI = Function('glArrayObjectATI')
glArrayObjectATI.ret = Return('void')
glArrayObjectATI.add( Input( 'array','GLenum' ))
glArrayObjectATI.add( Input( 'size','GLint' ))
glArrayObjectATI.add( Input( 'type','GLenum' ))
glArrayObjectATI.add( Input( 'stride','GLsizei' ))
glArrayObjectATI.add( Input( 'buffer','GLuint' ))
glArrayObjectATI.add( Input( 'offset','GLuint' ))
glArrayObjectATI.version = '1.2'
glArrayObjectATI.category = 'GL_ATI_vertex_array_object'
glArrayObjectATI.trace = True
glArrayObjectATI.play = True
gl.add(glArrayObjectATI)

glFreeObjectBufferATI = Function('glFreeObjectBufferATI')
glFreeObjectBufferATI.ret = Return('void')
glFreeObjectBufferATI.add( Input( 'buffer','GLuint' ))
glFreeObjectBufferATI.version = '1.2'
glFreeObjectBufferATI.category = 'GL_ATI_vertex_array_object'
glFreeObjectBufferATI.trace = True
glFreeObjectBufferATI.play = True
gl.add(glFreeObjectBufferATI)

glGetArrayObjectfvATI = Function('glGetArrayObjectfvATI')
glGetArrayObjectfvATI.ret = Return('void')
glGetArrayObjectfvATI.add( Input( 'array','GLenum' ))
glGetArrayObjectfvATI.add( Input( 'pname','GLenum' ))
glGetArrayObjectfvATI.add( Output( 'params','GLfloat *' ,size = 1 ))
glGetArrayObjectfvATI.version = '1.2'
glGetArrayObjectfvATI.category = 'GL_ATI_vertex_array_object'
glGetArrayObjectfvATI.trace = True
glGetArrayObjectfvATI.play = True
gl.add(glGetArrayObjectfvATI)

glGetArrayObjectivATI = Function('glGetArrayObjectivATI')
glGetArrayObjectivATI.ret = Return('void')
glGetArrayObjectivATI.add( Input( 'array','GLenum' ))
glGetArrayObjectivATI.add( Input( 'pname','GLenum' ))
glGetArrayObjectivATI.add( Output( 'params','GLint *' ,size = 1 ))
glGetArrayObjectivATI.version = '1.2'
glGetArrayObjectivATI.category = 'GL_ATI_vertex_array_object'
glGetArrayObjectivATI.trace = True
glGetArrayObjectivATI.play = True
gl.add(glGetArrayObjectivATI)

glGetObjectBufferfvATI = Function('glGetObjectBufferfvATI')
glGetObjectBufferfvATI.ret = Return('void')
glGetObjectBufferfvATI.add( Input( 'buffer','GLuint' ))
glGetObjectBufferfvATI.add( Input( 'pname','GLenum' ))
glGetObjectBufferfvATI.add( Output( 'params','GLfloat *' ,size = 1 ))
glGetObjectBufferfvATI.version = '1.2'
glGetObjectBufferfvATI.category = 'GL_ATI_vertex_array_object'
glGetObjectBufferfvATI.trace = True
glGetObjectBufferfvATI.play = True
gl.add(glGetObjectBufferfvATI)

glGetObjectBufferivATI = Function('glGetObjectBufferivATI')
glGetObjectBufferivATI.ret = Return('void')
glGetObjectBufferivATI.add( Input( 'buffer','GLuint' ))
glGetObjectBufferivATI.add( Input( 'pname','GLenum' ))
glGetObjectBufferivATI.add( Output( 'params','GLint *' ,size = 1 ))
glGetObjectBufferivATI.version = '1.2'
glGetObjectBufferivATI.category = 'GL_ATI_vertex_array_object'
glGetObjectBufferivATI.trace = True
glGetObjectBufferivATI.play = True
gl.add(glGetObjectBufferivATI)

glGetVariantArrayObjectfvATI = Function('glGetVariantArrayObjectfvATI')
glGetVariantArrayObjectfvATI.ret = Return('void')
glGetVariantArrayObjectfvATI.add( Input( 'id','GLuint' ))
glGetVariantArrayObjectfvATI.add( Input( 'pname','GLenum' ))
glGetVariantArrayObjectfvATI.add( Output( 'params','GLfloat *' ,size = 1 ))
glGetVariantArrayObjectfvATI.version = '1.2'
glGetVariantArrayObjectfvATI.category = 'GL_ATI_vertex_array_object'
glGetVariantArrayObjectfvATI.trace = True
glGetVariantArrayObjectfvATI.play = True
gl.add(glGetVariantArrayObjectfvATI)

glGetVariantArrayObjectivATI = Function('glGetVariantArrayObjectivATI')
glGetVariantArrayObjectivATI.ret = Return('void')
glGetVariantArrayObjectivATI.add( Input( 'id','GLuint' ))
glGetVariantArrayObjectivATI.add( Input( 'pname','GLenum' ))
glGetVariantArrayObjectivATI.add( Output( 'params','GLint *' ,size = 1 ))
glGetVariantArrayObjectivATI.version = '1.2'
glGetVariantArrayObjectivATI.category = 'GL_ATI_vertex_array_object'
glGetVariantArrayObjectivATI.trace = True
glGetVariantArrayObjectivATI.play = True
gl.add(glGetVariantArrayObjectivATI)

glIsObjectBufferATI = Function('glIsObjectBufferATI')
glIsObjectBufferATI.ret = Return('GLboolean')
glIsObjectBufferATI.add( Input( 'buffer','GLuint' ))
glIsObjectBufferATI.version = '1.2'
glIsObjectBufferATI.category = 'GL_ATI_vertex_array_object'
glIsObjectBufferATI.trace = True
glIsObjectBufferATI.play = True
gl.add(glIsObjectBufferATI)

glNewObjectBufferATI = Function('glNewObjectBufferATI')
glNewObjectBufferATI.ret = Return('GLuint')
glNewObjectBufferATI.add( Input( 'size','GLsizei' ))
glNewObjectBufferATI.add( Input( 'pointer','const GLvoid *' ))
glNewObjectBufferATI.add( Input( 'usage','GLenum' ))
glNewObjectBufferATI.version = '1.2'
glNewObjectBufferATI.category = 'GL_ATI_vertex_array_object'
glNewObjectBufferATI.trace = True
glNewObjectBufferATI.play = True
gl.add(glNewObjectBufferATI)

glUpdateObjectBufferATI = Function('glUpdateObjectBufferATI')
glUpdateObjectBufferATI.ret = Return('void')
glUpdateObjectBufferATI.add( Input( 'buffer','GLuint' ))
glUpdateObjectBufferATI.add( Input( 'offset','GLuint' ))
glUpdateObjectBufferATI.add( Input( 'size','GLsizei' ))
glUpdateObjectBufferATI.add( Input( 'pointer','const GLvoid *' ))
glUpdateObjectBufferATI.add( Input( 'preserve','GLenum' ))
glUpdateObjectBufferATI.version = '1.2'
glUpdateObjectBufferATI.category = 'GL_ATI_vertex_array_object'
glUpdateObjectBufferATI.trace = True
glUpdateObjectBufferATI.play = True
gl.add(glUpdateObjectBufferATI)

glVariantArrayObjectATI = Function('glVariantArrayObjectATI')
glVariantArrayObjectATI.ret = Return('void')
glVariantArrayObjectATI.add( Input( 'id','GLuint' ))
glVariantArrayObjectATI.add( Input( 'type','GLenum' ))
glVariantArrayObjectATI.add( Input( 'stride','GLsizei' ))
glVariantArrayObjectATI.add( Input( 'buffer','GLuint' ))
glVariantArrayObjectATI.add( Input( 'offset','GLuint' ))
glVariantArrayObjectATI.version = '1.2'
glVariantArrayObjectATI.category = 'GL_ATI_vertex_array_object'
glVariantArrayObjectATI.trace = True
glVariantArrayObjectATI.play = True
gl.add(glVariantArrayObjectATI)

# GL_ATI_vertex_attrib_array_object

glGetVertexAttribArrayObjectfvATI = Function('glGetVertexAttribArrayObjectfvATI')
glGetVertexAttribArrayObjectfvATI.ret = Return('void')
glGetVertexAttribArrayObjectfvATI.add( Input( 'index','GLuint' ))
glGetVertexAttribArrayObjectfvATI.add( Input( 'pname','GLenum' ))
glGetVertexAttribArrayObjectfvATI.add( Output( 'params','GLfloat *' ))
glGetVertexAttribArrayObjectfvATI.version = '1.2'
glGetVertexAttribArrayObjectfvATI.category = 'GL_ATI_vertex_attrib_array_object'
glGetVertexAttribArrayObjectfvATI.trace = True
glGetVertexAttribArrayObjectfvATI.play = True
gl.add(glGetVertexAttribArrayObjectfvATI)

glGetVertexAttribArrayObjectivATI = Function('glGetVertexAttribArrayObjectivATI')
glGetVertexAttribArrayObjectivATI.ret = Return('void')
glGetVertexAttribArrayObjectivATI.add( Input( 'index','GLuint' ))
glGetVertexAttribArrayObjectivATI.add( Input( 'pname','GLenum' ))
glGetVertexAttribArrayObjectivATI.add( Output( 'params','GLint *' ))
glGetVertexAttribArrayObjectivATI.version = '1.2'
glGetVertexAttribArrayObjectivATI.category = 'GL_ATI_vertex_attrib_array_object'
glGetVertexAttribArrayObjectivATI.trace = True
glGetVertexAttribArrayObjectivATI.play = True
gl.add(glGetVertexAttribArrayObjectivATI)

glVertexAttribArrayObjectATI = Function('glVertexAttribArrayObjectATI')
glVertexAttribArrayObjectATI.ret = Return('void')
glVertexAttribArrayObjectATI.add( Input( 'index','GLuint' ))
glVertexAttribArrayObjectATI.add( Input( 'size','GLint' ))
glVertexAttribArrayObjectATI.add( Input( 'type','GLenum' ))
glVertexAttribArrayObjectATI.add( Input( 'normalized','GLboolean' ))
glVertexAttribArrayObjectATI.add( Input( 'stride','GLsizei' ))
glVertexAttribArrayObjectATI.add( Input( 'buffer','GLuint' ))
glVertexAttribArrayObjectATI.add( Input( 'offset','GLuint' ))
glVertexAttribArrayObjectATI.version = '1.2'
glVertexAttribArrayObjectATI.category = 'GL_ATI_vertex_attrib_array_object'
glVertexAttribArrayObjectATI.trace = True
glVertexAttribArrayObjectATI.play = True
gl.add(glVertexAttribArrayObjectATI)

# GL_ATI_vertex_streams

glClientActiveVertexStreamATI = Function('glClientActiveVertexStreamATI')
glClientActiveVertexStreamATI.ret = Return('void')
glClientActiveVertexStreamATI.add( Input( 'stream','GLenum' ))
glClientActiveVertexStreamATI.version = '1.2'
glClientActiveVertexStreamATI.category = 'GL_ATI_vertex_streams'
glClientActiveVertexStreamATI.trace = True
glClientActiveVertexStreamATI.play = True
gl.add(glClientActiveVertexStreamATI)

glNormalStream3bATI = Function('glNormalStream3bATI')
glNormalStream3bATI.ret = Return('void')
glNormalStream3bATI.add( Input( 'stream','GLenum' ))
glNormalStream3bATI.add( Input( 'x','GLbyte' ))
glNormalStream3bATI.add( Input( 'y','GLbyte' ))
glNormalStream3bATI.add( Input( 'z','GLbyte' ))
glNormalStream3bATI.version = '1.2'
glNormalStream3bATI.category = 'GL_ATI_vertex_streams'
glNormalStream3bATI.trace = True
glNormalStream3bATI.play = True
gl.add(glNormalStream3bATI)

glNormalStream3bvATI = Function('glNormalStream3bvATI')
glNormalStream3bvATI.ret = Return('void')
glNormalStream3bvATI.add( Input( 'stream','GLenum' ))
glNormalStream3bvATI.add( Input( 'coords','const GLbyte *' ,size = 3 ))
glNormalStream3bvATI.version = '1.2'
glNormalStream3bvATI.category = 'GL_ATI_vertex_streams'
glNormalStream3bvATI.trace = True
glNormalStream3bvATI.play = True
gl.add(glNormalStream3bvATI)

glNormalStream3dATI = Function('glNormalStream3dATI')
glNormalStream3dATI.ret = Return('void')
glNormalStream3dATI.add( Input( 'stream','GLenum' ))
glNormalStream3dATI.add( Input( 'x','GLdouble' ))
glNormalStream3dATI.add( Input( 'y','GLdouble' ))
glNormalStream3dATI.add( Input( 'z','GLdouble' ))
glNormalStream3dATI.version = '1.2'
glNormalStream3dATI.category = 'GL_ATI_vertex_streams'
glNormalStream3dATI.trace = True
glNormalStream3dATI.play = True
gl.add(glNormalStream3dATI)

glNormalStream3dvATI = Function('glNormalStream3dvATI')
glNormalStream3dvATI.ret = Return('void')
glNormalStream3dvATI.add( Input( 'stream','GLenum' ))
glNormalStream3dvATI.add( Input( 'coords','const GLdouble *' ,size = 3 ))
glNormalStream3dvATI.version = '1.2'
glNormalStream3dvATI.category = 'GL_ATI_vertex_streams'
glNormalStream3dvATI.trace = True
glNormalStream3dvATI.play = True
gl.add(glNormalStream3dvATI)

glNormalStream3fATI = Function('glNormalStream3fATI')
glNormalStream3fATI.ret = Return('void')
glNormalStream3fATI.add( Input( 'stream','GLenum' ))
glNormalStream3fATI.add( Input( 'x','GLfloat' ))
glNormalStream3fATI.add( Input( 'y','GLfloat' ))
glNormalStream3fATI.add( Input( 'z','GLfloat' ))
glNormalStream3fATI.version = '1.2'
glNormalStream3fATI.category = 'GL_ATI_vertex_streams'
glNormalStream3fATI.trace = True
glNormalStream3fATI.play = True
gl.add(glNormalStream3fATI)

glNormalStream3fvATI = Function('glNormalStream3fvATI')
glNormalStream3fvATI.ret = Return('void')
glNormalStream3fvATI.add( Input( 'stream','GLenum' ))
glNormalStream3fvATI.add( Input( 'coords','const GLfloat *' ,size = 3 ))
glNormalStream3fvATI.version = '1.2'
glNormalStream3fvATI.category = 'GL_ATI_vertex_streams'
glNormalStream3fvATI.trace = True
glNormalStream3fvATI.play = True
gl.add(glNormalStream3fvATI)

glNormalStream3iATI = Function('glNormalStream3iATI')
glNormalStream3iATI.ret = Return('void')
glNormalStream3iATI.add( Input( 'stream','GLenum' ))
glNormalStream3iATI.add( Input( 'x','GLint' ))
glNormalStream3iATI.add( Input( 'y','GLint' ))
glNormalStream3iATI.add( Input( 'z','GLint' ))
glNormalStream3iATI.version = '1.2'
glNormalStream3iATI.category = 'GL_ATI_vertex_streams'
glNormalStream3iATI.trace = True
glNormalStream3iATI.play = True
gl.add(glNormalStream3iATI)

glNormalStream3ivATI = Function('glNormalStream3ivATI')
glNormalStream3ivATI.ret = Return('void')
glNormalStream3ivATI.add( Input( 'stream','GLenum' ))
glNormalStream3ivATI.add( Input( 'coords','const GLint *' ,size = 3 ))
glNormalStream3ivATI.version = '1.2'
glNormalStream3ivATI.category = 'GL_ATI_vertex_streams'
glNormalStream3ivATI.trace = True
glNormalStream3ivATI.play = True
gl.add(glNormalStream3ivATI)

glNormalStream3sATI = Function('glNormalStream3sATI')
glNormalStream3sATI.ret = Return('void')
glNormalStream3sATI.add( Input( 'stream','GLenum' ))
glNormalStream3sATI.add( Input( 'x','GLshort' ))
glNormalStream3sATI.add( Input( 'y','GLshort' ))
glNormalStream3sATI.add( Input( 'z','GLshort' ))
glNormalStream3sATI.version = '1.2'
glNormalStream3sATI.category = 'GL_ATI_vertex_streams'
glNormalStream3sATI.trace = True
glNormalStream3sATI.play = True
gl.add(glNormalStream3sATI)

glNormalStream3svATI = Function('glNormalStream3svATI')
glNormalStream3svATI.ret = Return('void')
glNormalStream3svATI.add( Input( 'stream','GLenum' ))
glNormalStream3svATI.add( Input( 'coords','const GLshort *' ,size = 3 ))
glNormalStream3svATI.version = '1.2'
glNormalStream3svATI.category = 'GL_ATI_vertex_streams'
glNormalStream3svATI.trace = True
glNormalStream3svATI.play = True
gl.add(glNormalStream3svATI)

glVertexBlendEnvfATI = Function('glVertexBlendEnvfATI')
glVertexBlendEnvfATI.ret = Return('void')
glVertexBlendEnvfATI.add( Input( 'pname','GLenum' ))
glVertexBlendEnvfATI.add( Input( 'param','GLfloat' ))
glVertexBlendEnvfATI.version = '1.2'
glVertexBlendEnvfATI.category = 'GL_ATI_vertex_streams'
glVertexBlendEnvfATI.trace = True
glVertexBlendEnvfATI.play = True
gl.add(glVertexBlendEnvfATI)

glVertexBlendEnviATI = Function('glVertexBlendEnviATI')
glVertexBlendEnviATI.ret = Return('void')
glVertexBlendEnviATI.add( Input( 'pname','GLenum' ))
glVertexBlendEnviATI.add( Input( 'param','GLint' ))
glVertexBlendEnviATI.version = '1.2'
glVertexBlendEnviATI.category = 'GL_ATI_vertex_streams'
glVertexBlendEnviATI.trace = True
glVertexBlendEnviATI.play = True
gl.add(glVertexBlendEnviATI)

glVertexStream1dATI = Function('glVertexStream1dATI')
glVertexStream1dATI.ret = Return('void')
glVertexStream1dATI.add( Input( 'stream','GLenum' ))
glVertexStream1dATI.add( Input( 'x','GLdouble' ))
glVertexStream1dATI.version = '1.2'
glVertexStream1dATI.category = 'GL_ATI_vertex_streams'
glVertexStream1dATI.trace = True
glVertexStream1dATI.play = True
gl.add(glVertexStream1dATI)

glVertexStream1dvATI = Function('glVertexStream1dvATI')
glVertexStream1dvATI.ret = Return('void')
glVertexStream1dvATI.add( Input( 'stream','GLenum' ))
glVertexStream1dvATI.add( Input( 'coords','const GLdouble *' ,size = 1 ))
glVertexStream1dvATI.version = '1.2'
glVertexStream1dvATI.category = 'GL_ATI_vertex_streams'
glVertexStream1dvATI.trace = True
glVertexStream1dvATI.play = True
gl.add(glVertexStream1dvATI)

glVertexStream1fATI = Function('glVertexStream1fATI')
glVertexStream1fATI.ret = Return('void')
glVertexStream1fATI.add( Input( 'stream','GLenum' ))
glVertexStream1fATI.add( Input( 'x','GLfloat' ))
glVertexStream1fATI.version = '1.2'
glVertexStream1fATI.category = 'GL_ATI_vertex_streams'
glVertexStream1fATI.trace = True
glVertexStream1fATI.play = True
gl.add(glVertexStream1fATI)

glVertexStream1fvATI = Function('glVertexStream1fvATI')
glVertexStream1fvATI.ret = Return('void')
glVertexStream1fvATI.add( Input( 'stream','GLenum' ))
glVertexStream1fvATI.add( Input( 'coords','const GLfloat *' ,size = 1 ))
glVertexStream1fvATI.version = '1.2'
glVertexStream1fvATI.category = 'GL_ATI_vertex_streams'
glVertexStream1fvATI.trace = True
glVertexStream1fvATI.play = True
gl.add(glVertexStream1fvATI)

glVertexStream1iATI = Function('glVertexStream1iATI')
glVertexStream1iATI.ret = Return('void')
glVertexStream1iATI.add( Input( 'stream','GLenum' ))
glVertexStream1iATI.add( Input( 'x','GLint' ))
glVertexStream1iATI.version = '1.2'
glVertexStream1iATI.category = 'GL_ATI_vertex_streams'
glVertexStream1iATI.trace = True
glVertexStream1iATI.play = True
gl.add(glVertexStream1iATI)

glVertexStream1ivATI = Function('glVertexStream1ivATI')
glVertexStream1ivATI.ret = Return('void')
glVertexStream1ivATI.add( Input( 'stream','GLenum' ))
glVertexStream1ivATI.add( Input( 'coords','const GLint *' ,size = 1 ))
glVertexStream1ivATI.version = '1.2'
glVertexStream1ivATI.category = 'GL_ATI_vertex_streams'
glVertexStream1ivATI.trace = True
glVertexStream1ivATI.play = True
gl.add(glVertexStream1ivATI)

glVertexStream1sATI = Function('glVertexStream1sATI')
glVertexStream1sATI.ret = Return('void')
glVertexStream1sATI.add( Input( 'stream','GLenum' ))
glVertexStream1sATI.add( Input( 'x','GLshort' ))
glVertexStream1sATI.version = '1.2'
glVertexStream1sATI.category = 'GL_ATI_vertex_streams'
glVertexStream1sATI.trace = True
glVertexStream1sATI.play = True
gl.add(glVertexStream1sATI)

glVertexStream1svATI = Function('glVertexStream1svATI')
glVertexStream1svATI.ret = Return('void')
glVertexStream1svATI.add( Input( 'stream','GLenum' ))
glVertexStream1svATI.add( Input( 'coords','const GLshort *' ,size = 1 ))
glVertexStream1svATI.version = '1.2'
glVertexStream1svATI.category = 'GL_ATI_vertex_streams'
glVertexStream1svATI.trace = True
glVertexStream1svATI.play = True
gl.add(glVertexStream1svATI)

glVertexStream2dATI = Function('glVertexStream2dATI')
glVertexStream2dATI.ret = Return('void')
glVertexStream2dATI.add( Input( 'stream','GLenum' ))
glVertexStream2dATI.add( Input( 'x','GLdouble' ))
glVertexStream2dATI.add( Input( 'y','GLdouble' ))
glVertexStream2dATI.version = '1.2'
glVertexStream2dATI.category = 'GL_ATI_vertex_streams'
glVertexStream2dATI.trace = True
glVertexStream2dATI.play = True
gl.add(glVertexStream2dATI)

glVertexStream2dvATI = Function('glVertexStream2dvATI')
glVertexStream2dvATI.ret = Return('void')
glVertexStream2dvATI.add( Input( 'stream','GLenum' ))
glVertexStream2dvATI.add( Input( 'coords','const GLdouble *' ,size = 2 ))
glVertexStream2dvATI.version = '1.2'
glVertexStream2dvATI.category = 'GL_ATI_vertex_streams'
glVertexStream2dvATI.trace = True
glVertexStream2dvATI.play = True
gl.add(glVertexStream2dvATI)

glVertexStream2fATI = Function('glVertexStream2fATI')
glVertexStream2fATI.ret = Return('void')
glVertexStream2fATI.add( Input( 'stream','GLenum' ))
glVertexStream2fATI.add( Input( 'x','GLfloat' ))
glVertexStream2fATI.add( Input( 'y','GLfloat' ))
glVertexStream2fATI.version = '1.2'
glVertexStream2fATI.category = 'GL_ATI_vertex_streams'
glVertexStream2fATI.trace = True
glVertexStream2fATI.play = True
gl.add(glVertexStream2fATI)

glVertexStream2fvATI = Function('glVertexStream2fvATI')
glVertexStream2fvATI.ret = Return('void')
glVertexStream2fvATI.add( Input( 'stream','GLenum' ))
glVertexStream2fvATI.add( Input( 'coords','const GLfloat *' ,size = 2 ))
glVertexStream2fvATI.version = '1.2'
glVertexStream2fvATI.category = 'GL_ATI_vertex_streams'
glVertexStream2fvATI.trace = True
glVertexStream2fvATI.play = True
gl.add(glVertexStream2fvATI)

glVertexStream2iATI = Function('glVertexStream2iATI')
glVertexStream2iATI.ret = Return('void')
glVertexStream2iATI.add( Input( 'stream','GLenum' ))
glVertexStream2iATI.add( Input( 'x','GLint' ))
glVertexStream2iATI.add( Input( 'y','GLint' ))
glVertexStream2iATI.version = '1.2'
glVertexStream2iATI.category = 'GL_ATI_vertex_streams'
glVertexStream2iATI.trace = True
glVertexStream2iATI.play = True
gl.add(glVertexStream2iATI)

glVertexStream2ivATI = Function('glVertexStream2ivATI')
glVertexStream2ivATI.ret = Return('void')
glVertexStream2ivATI.add( Input( 'stream','GLenum' ))
glVertexStream2ivATI.add( Input( 'coords','const GLint *' ,size = 2 ))
glVertexStream2ivATI.version = '1.2'
glVertexStream2ivATI.category = 'GL_ATI_vertex_streams'
glVertexStream2ivATI.trace = True
glVertexStream2ivATI.play = True
gl.add(glVertexStream2ivATI)

glVertexStream2sATI = Function('glVertexStream2sATI')
glVertexStream2sATI.ret = Return('void')
glVertexStream2sATI.add( Input( 'stream','GLenum' ))
glVertexStream2sATI.add( Input( 'x','GLshort' ))
glVertexStream2sATI.add( Input( 'y','GLshort' ))
glVertexStream2sATI.version = '1.2'
glVertexStream2sATI.category = 'GL_ATI_vertex_streams'
glVertexStream2sATI.trace = True
glVertexStream2sATI.play = True
gl.add(glVertexStream2sATI)

glVertexStream2svATI = Function('glVertexStream2svATI')
glVertexStream2svATI.ret = Return('void')
glVertexStream2svATI.add( Input( 'stream','GLenum' ))
glVertexStream2svATI.add( Input( 'coords','const GLshort *' ,size = 2 ))
glVertexStream2svATI.version = '1.2'
glVertexStream2svATI.category = 'GL_ATI_vertex_streams'
glVertexStream2svATI.trace = True
glVertexStream2svATI.play = True
gl.add(glVertexStream2svATI)

glVertexStream3dATI = Function('glVertexStream3dATI')
glVertexStream3dATI.ret = Return('void')
glVertexStream3dATI.add( Input( 'stream','GLenum' ))
glVertexStream3dATI.add( Input( 'x','GLdouble' ))
glVertexStream3dATI.add( Input( 'y','GLdouble' ))
glVertexStream3dATI.add( Input( 'z','GLdouble' ))
glVertexStream3dATI.version = '1.2'
glVertexStream3dATI.category = 'GL_ATI_vertex_streams'
glVertexStream3dATI.trace = True
glVertexStream3dATI.play = True
gl.add(glVertexStream3dATI)

glVertexStream3dvATI = Function('glVertexStream3dvATI')
glVertexStream3dvATI.ret = Return('void')
glVertexStream3dvATI.add( Input( 'stream','GLenum' ))
glVertexStream3dvATI.add( Input( 'coords','const GLdouble *' ,size = 3 ))
glVertexStream3dvATI.version = '1.2'
glVertexStream3dvATI.category = 'GL_ATI_vertex_streams'
glVertexStream3dvATI.trace = True
glVertexStream3dvATI.play = True
gl.add(glVertexStream3dvATI)

glVertexStream3fATI = Function('glVertexStream3fATI')
glVertexStream3fATI.ret = Return('void')
glVertexStream3fATI.add( Input( 'stream','GLenum' ))
glVertexStream3fATI.add( Input( 'x','GLfloat' ))
glVertexStream3fATI.add( Input( 'y','GLfloat' ))
glVertexStream3fATI.add( Input( 'z','GLfloat' ))
glVertexStream3fATI.version = '1.2'
glVertexStream3fATI.category = 'GL_ATI_vertex_streams'
glVertexStream3fATI.trace = True
glVertexStream3fATI.play = True
gl.add(glVertexStream3fATI)

glVertexStream3fvATI = Function('glVertexStream3fvATI')
glVertexStream3fvATI.ret = Return('void')
glVertexStream3fvATI.add( Input( 'stream','GLenum' ))
glVertexStream3fvATI.add( Input( 'coords','const GLfloat *' ,size = 3 ))
glVertexStream3fvATI.version = '1.2'
glVertexStream3fvATI.category = 'GL_ATI_vertex_streams'
glVertexStream3fvATI.trace = True
glVertexStream3fvATI.play = True
gl.add(glVertexStream3fvATI)

glVertexStream3iATI = Function('glVertexStream3iATI')
glVertexStream3iATI.ret = Return('void')
glVertexStream3iATI.add( Input( 'stream','GLenum' ))
glVertexStream3iATI.add( Input( 'x','GLint' ))
glVertexStream3iATI.add( Input( 'y','GLint' ))
glVertexStream3iATI.add( Input( 'z','GLint' ))
glVertexStream3iATI.version = '1.2'
glVertexStream3iATI.category = 'GL_ATI_vertex_streams'
glVertexStream3iATI.trace = True
glVertexStream3iATI.play = True
gl.add(glVertexStream3iATI)

glVertexStream3ivATI = Function('glVertexStream3ivATI')
glVertexStream3ivATI.ret = Return('void')
glVertexStream3ivATI.add( Input( 'stream','GLenum' ))
glVertexStream3ivATI.add( Input( 'coords','const GLint *' ,size = 3 ))
glVertexStream3ivATI.version = '1.2'
glVertexStream3ivATI.category = 'GL_ATI_vertex_streams'
glVertexStream3ivATI.trace = True
glVertexStream3ivATI.play = True
gl.add(glVertexStream3ivATI)

glVertexStream3sATI = Function('glVertexStream3sATI')
glVertexStream3sATI.ret = Return('void')
glVertexStream3sATI.add( Input( 'stream','GLenum' ))
glVertexStream3sATI.add( Input( 'x','GLshort' ))
glVertexStream3sATI.add( Input( 'y','GLshort' ))
glVertexStream3sATI.add( Input( 'z','GLshort' ))
glVertexStream3sATI.version = '1.2'
glVertexStream3sATI.category = 'GL_ATI_vertex_streams'
glVertexStream3sATI.trace = True
glVertexStream3sATI.play = True
gl.add(glVertexStream3sATI)

glVertexStream3svATI = Function('glVertexStream3svATI')
glVertexStream3svATI.ret = Return('void')
glVertexStream3svATI.add( Input( 'stream','GLenum' ))
glVertexStream3svATI.add( Input( 'coords','const GLshort *' ,size = 3 ))
glVertexStream3svATI.version = '1.2'
glVertexStream3svATI.category = 'GL_ATI_vertex_streams'
glVertexStream3svATI.trace = True
glVertexStream3svATI.play = True
gl.add(glVertexStream3svATI)

glVertexStream4dATI = Function('glVertexStream4dATI')
glVertexStream4dATI.ret = Return('void')
glVertexStream4dATI.add( Input( 'stream','GLenum' ))
glVertexStream4dATI.add( Input( 'x','GLdouble' ))
glVertexStream4dATI.add( Input( 'y','GLdouble' ))
glVertexStream4dATI.add( Input( 'z','GLdouble' ))
glVertexStream4dATI.add( Input( 'w','GLdouble' ))
glVertexStream4dATI.version = '1.2'
glVertexStream4dATI.category = 'GL_ATI_vertex_streams'
glVertexStream4dATI.trace = True
glVertexStream4dATI.play = True
gl.add(glVertexStream4dATI)

glVertexStream4dvATI = Function('glVertexStream4dvATI')
glVertexStream4dvATI.ret = Return('void')
glVertexStream4dvATI.add( Input( 'stream','GLenum' ))
glVertexStream4dvATI.add( Input( 'coords','const GLdouble *' ,size = 4 ))
glVertexStream4dvATI.version = '1.2'
glVertexStream4dvATI.category = 'GL_ATI_vertex_streams'
glVertexStream4dvATI.trace = True
glVertexStream4dvATI.play = True
gl.add(glVertexStream4dvATI)

glVertexStream4fATI = Function('glVertexStream4fATI')
glVertexStream4fATI.ret = Return('void')
glVertexStream4fATI.add( Input( 'stream','GLenum' ))
glVertexStream4fATI.add( Input( 'x','GLfloat' ))
glVertexStream4fATI.add( Input( 'y','GLfloat' ))
glVertexStream4fATI.add( Input( 'z','GLfloat' ))
glVertexStream4fATI.add( Input( 'w','GLfloat' ))
glVertexStream4fATI.version = '1.2'
glVertexStream4fATI.category = 'GL_ATI_vertex_streams'
glVertexStream4fATI.trace = True
glVertexStream4fATI.play = True
gl.add(glVertexStream4fATI)

glVertexStream4fvATI = Function('glVertexStream4fvATI')
glVertexStream4fvATI.ret = Return('void')
glVertexStream4fvATI.add( Input( 'stream','GLenum' ))
glVertexStream4fvATI.add( Input( 'coords','const GLfloat *' ,size = 4 ))
glVertexStream4fvATI.version = '1.2'
glVertexStream4fvATI.category = 'GL_ATI_vertex_streams'
glVertexStream4fvATI.trace = True
glVertexStream4fvATI.play = True
gl.add(glVertexStream4fvATI)

glVertexStream4iATI = Function('glVertexStream4iATI')
glVertexStream4iATI.ret = Return('void')
glVertexStream4iATI.add( Input( 'stream','GLenum' ))
glVertexStream4iATI.add( Input( 'x','GLint' ))
glVertexStream4iATI.add( Input( 'y','GLint' ))
glVertexStream4iATI.add( Input( 'z','GLint' ))
glVertexStream4iATI.add( Input( 'w','GLint' ))
glVertexStream4iATI.version = '1.2'
glVertexStream4iATI.category = 'GL_ATI_vertex_streams'
glVertexStream4iATI.trace = True
glVertexStream4iATI.play = True
gl.add(glVertexStream4iATI)

glVertexStream4ivATI = Function('glVertexStream4ivATI')
glVertexStream4ivATI.ret = Return('void')
glVertexStream4ivATI.add( Input( 'stream','GLenum' ))
glVertexStream4ivATI.add( Input( 'coords','const GLint *' ,size = 4 ))
glVertexStream4ivATI.version = '1.2'
glVertexStream4ivATI.category = 'GL_ATI_vertex_streams'
glVertexStream4ivATI.trace = True
glVertexStream4ivATI.play = True
gl.add(glVertexStream4ivATI)

glVertexStream4sATI = Function('glVertexStream4sATI')
glVertexStream4sATI.ret = Return('void')
glVertexStream4sATI.add( Input( 'stream','GLenum' ))
glVertexStream4sATI.add( Input( 'x','GLshort' ))
glVertexStream4sATI.add( Input( 'y','GLshort' ))
glVertexStream4sATI.add( Input( 'z','GLshort' ))
glVertexStream4sATI.add( Input( 'w','GLshort' ))
glVertexStream4sATI.version = '1.2'
glVertexStream4sATI.category = 'GL_ATI_vertex_streams'
glVertexStream4sATI.trace = True
glVertexStream4sATI.play = True
gl.add(glVertexStream4sATI)

glVertexStream4svATI = Function('glVertexStream4svATI')
glVertexStream4svATI.ret = Return('void')
glVertexStream4svATI.add( Input( 'stream','GLenum' ))
glVertexStream4svATI.add( Input( 'coords','const GLshort *' ,size = 4 ))
glVertexStream4svATI.version = '1.2'
glVertexStream4svATI.category = 'GL_ATI_vertex_streams'
glVertexStream4svATI.trace = True
glVertexStream4svATI.play = True
gl.add(glVertexStream4svATI)

# GL_EXT_bindable_uniform

glGetUniformBufferSizeEXT = Function('glGetUniformBufferSizeEXT')
glGetUniformBufferSizeEXT.ret = Return('GLint')
glGetUniformBufferSizeEXT.add( Input( 'program','GLuint' ))
glGetUniformBufferSizeEXT.add( Input( 'location','GLint' ))
glGetUniformBufferSizeEXT.version = '2.0'
glGetUniformBufferSizeEXT.category = 'GL_EXT_bindable_uniform'
glGetUniformBufferSizeEXT.trace = True
glGetUniformBufferSizeEXT.play = True
gl.add(glGetUniformBufferSizeEXT)

glGetUniformOffsetEXT = Function('glGetUniformOffsetEXT')
glGetUniformOffsetEXT.ret = Return('GLintptr')
glGetUniformOffsetEXT.add( Input( 'program','GLuint' ))
glGetUniformOffsetEXT.add( Input( 'location','GLint' ))
glGetUniformOffsetEXT.version = '2.0'
glGetUniformOffsetEXT.category = 'GL_EXT_bindable_uniform'
glGetUniformOffsetEXT.trace = True
glGetUniformOffsetEXT.play = True
gl.add(glGetUniformOffsetEXT)

glUniformBufferEXT = Function('glUniformBufferEXT')
glUniformBufferEXT.ret = Return('void')
glUniformBufferEXT.add( Input( 'program','GLuint' ))
glUniformBufferEXT.add( Input( 'location','GLint' ))
glUniformBufferEXT.add( Input( 'buffer','GLuint' ))
glUniformBufferEXT.version = '2.0'
glUniformBufferEXT.category = 'GL_EXT_bindable_uniform'
glUniformBufferEXT.trace = True
glUniformBufferEXT.play = True
gl.add(glUniformBufferEXT)

# GL_EXT_blend_color

glBlendColorEXT = Function('glBlendColorEXT')
glBlendColorEXT.ret = Return('void')
glBlendColorEXT.add( Input( 'red','GLclampf' ))
glBlendColorEXT.add( Input( 'green','GLclampf' ))
glBlendColorEXT.add( Input( 'blue','GLclampf' ))
glBlendColorEXT.add( Input( 'alpha','GLclampf' ))
glBlendColorEXT.version = '1.1'
glBlendColorEXT.category = 'GL_EXT_blend_color'
glBlendColorEXT.trace = True
glBlendColorEXT.play = True
gl.add(glBlendColorEXT)

# GL_EXT_blend_equation_separate

glBlendEquationSeparateEXT = Function('glBlendEquationSeparateEXT')
glBlendEquationSeparateEXT.ret = Return('void')
glBlendEquationSeparateEXT.add( Input( 'modeRGB','GLenum' ,regalLog = 'GLmodeToString(modeRGB)' ))
glBlendEquationSeparateEXT.add( Input( 'modeAlpha','GLenum' ,regalLog = 'GLmodeToString(modeAlpha)' ))
glBlendEquationSeparateEXT.version = '1.1'
glBlendEquationSeparateEXT.category = 'GL_EXT_blend_equation_separate'
glBlendEquationSeparateEXT.trace = True
glBlendEquationSeparateEXT.play = True
gl.add(glBlendEquationSeparateEXT)

# GL_EXT_blend_func_separate

glBlendFuncSeparateEXT = Function('glBlendFuncSeparateEXT')
glBlendFuncSeparateEXT.ret = Return('void')
glBlendFuncSeparateEXT.add( Input( 'sfactorRGB','GLenum' ))
glBlendFuncSeparateEXT.add( Input( 'dfactorRGB','GLenum' ))
glBlendFuncSeparateEXT.add( Input( 'sfactorAlpha','GLenum' ))
glBlendFuncSeparateEXT.add( Input( 'dfactorAlpha','GLenum' ))
glBlendFuncSeparateEXT.version = '1.1'
glBlendFuncSeparateEXT.category = 'GL_EXT_blend_func_separate'
glBlendFuncSeparateEXT.trace = True
glBlendFuncSeparateEXT.play = True
gl.add(glBlendFuncSeparateEXT)

# GL_EXT_blend_minmax

glBlendEquationEXT = Function('glBlendEquationEXT')
glBlendEquationEXT.ret = Return('void')
glBlendEquationEXT.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glBlendEquationEXT.version = '1.1'
glBlendEquationEXT.category = 'GL_EXT_blend_minmax'
glBlendEquationEXT.trace = True
glBlendEquationEXT.play = True
gl.add(glBlendEquationEXT)

# GL_EXT_color_subtable

glColorSubTableEXT = Function('glColorSubTableEXT')
glColorSubTableEXT.ret = Return('void')
glColorSubTableEXT.add( Input( 'target','GLenum' ))
glColorSubTableEXT.add( Input( 'start','GLsizei' ))
glColorSubTableEXT.add( Input( 'count','GLsizei' ))
glColorSubTableEXT.add( Input( 'format','GLenum' ))
glColorSubTableEXT.add( Input( 'type','GLenum' ))
glColorSubTableEXT.add( Input( 'table','const GLvoid *' ))
glColorSubTableEXT.version = '1.0'
glColorSubTableEXT.category = 'GL_EXT_color_subtable'
glColorSubTableEXT.trace = True
glColorSubTableEXT.play = True
gl.add(glColorSubTableEXT)

glCopyColorSubTableEXT = Function('glCopyColorSubTableEXT')
glCopyColorSubTableEXT.ret = Return('void')
glCopyColorSubTableEXT.add( Input( 'target','GLenum' ))
glCopyColorSubTableEXT.add( Input( 'start','GLsizei' ))
glCopyColorSubTableEXT.add( Input( 'x','GLint' ))
glCopyColorSubTableEXT.add( Input( 'y','GLint' ))
glCopyColorSubTableEXT.add( Input( 'width','GLsizei' ))
glCopyColorSubTableEXT.version = '1.0'
glCopyColorSubTableEXT.category = 'GL_EXT_color_subtable'
glCopyColorSubTableEXT.trace = True
glCopyColorSubTableEXT.play = True
gl.add(glCopyColorSubTableEXT)

# GL_EXT_compiled_vertex_array

glLockArraysEXT = Function('glLockArraysEXT')
glLockArraysEXT.ret = Return('void')
glLockArraysEXT.add( Input( 'first','GLint' ))
glLockArraysEXT.add( Input( 'count','GLsizei' ))
glLockArraysEXT.version = '1.1'
glLockArraysEXT.category = 'GL_EXT_compiled_vertex_array'
glLockArraysEXT.trace = True
glLockArraysEXT.play = True
gl.add(glLockArraysEXT)

glUnlockArraysEXT = Function('glUnlockArraysEXT')
glUnlockArraysEXT.ret = Return('void')
glUnlockArraysEXT.version = '1.1'
glUnlockArraysEXT.category = 'GL_EXT_compiled_vertex_array'
glUnlockArraysEXT.trace = True
glUnlockArraysEXT.play = True
gl.add(glUnlockArraysEXT)

# GL_EXT_convolution

glConvolutionFilter1DEXT = Function('glConvolutionFilter1DEXT')
glConvolutionFilter1DEXT.ret = Return('void')
glConvolutionFilter1DEXT.add( Input( 'target','GLenum' ))
glConvolutionFilter1DEXT.add( Input( 'internalformat','GLenum' ))
glConvolutionFilter1DEXT.add( Input( 'width','GLsizei' ))
glConvolutionFilter1DEXT.add( Input( 'format','GLenum' ))
glConvolutionFilter1DEXT.add( Input( 'type','GLenum' ))
glConvolutionFilter1DEXT.add( Input( 'image','const GLvoid *' ))
glConvolutionFilter1DEXT.version = '1.0'
glConvolutionFilter1DEXT.category = 'GL_EXT_convolution'
glConvolutionFilter1DEXT.trace = True
glConvolutionFilter1DEXT.play = True
gl.add(glConvolutionFilter1DEXT)

glConvolutionFilter2DEXT = Function('glConvolutionFilter2DEXT')
glConvolutionFilter2DEXT.ret = Return('void')
glConvolutionFilter2DEXT.add( Input( 'target','GLenum' ))
glConvolutionFilter2DEXT.add( Input( 'internalformat','GLenum' ))
glConvolutionFilter2DEXT.add( Input( 'width','GLsizei' ))
glConvolutionFilter2DEXT.add( Input( 'height','GLsizei' ))
glConvolutionFilter2DEXT.add( Input( 'format','GLenum' ))
glConvolutionFilter2DEXT.add( Input( 'type','GLenum' ))
glConvolutionFilter2DEXT.add( Input( 'image','const GLvoid *' ))
glConvolutionFilter2DEXT.version = '1.0'
glConvolutionFilter2DEXT.category = 'GL_EXT_convolution'
glConvolutionFilter2DEXT.trace = True
glConvolutionFilter2DEXT.play = True
gl.add(glConvolutionFilter2DEXT)

glConvolutionParameterfEXT = Function('glConvolutionParameterfEXT')
glConvolutionParameterfEXT.ret = Return('void')
glConvolutionParameterfEXT.add( Input( 'target','GLenum' ))
glConvolutionParameterfEXT.add( Input( 'pname','GLenum' ))
glConvolutionParameterfEXT.add( Input( 'param','GLfloat' ))
glConvolutionParameterfEXT.version = '1.0'
glConvolutionParameterfEXT.category = 'GL_EXT_convolution'
glConvolutionParameterfEXT.trace = True
glConvolutionParameterfEXT.play = True
gl.add(glConvolutionParameterfEXT)

glConvolutionParameterfvEXT = Function('glConvolutionParameterfvEXT')
glConvolutionParameterfvEXT.ret = Return('void')
glConvolutionParameterfvEXT.add( Input( 'target','GLenum' ))
glConvolutionParameterfvEXT.add( Input( 'pname','GLenum' ))
glConvolutionParameterfvEXT.add( Input( 'params','const GLfloat *' ))
glConvolutionParameterfvEXT.version = '1.0'
glConvolutionParameterfvEXT.category = 'GL_EXT_convolution'
glConvolutionParameterfvEXT.trace = True
glConvolutionParameterfvEXT.play = True
gl.add(glConvolutionParameterfvEXT)

glConvolutionParameteriEXT = Function('glConvolutionParameteriEXT')
glConvolutionParameteriEXT.ret = Return('void')
glConvolutionParameteriEXT.add( Input( 'target','GLenum' ))
glConvolutionParameteriEXT.add( Input( 'pname','GLenum' ))
glConvolutionParameteriEXT.add( Input( 'param','GLint' ))
glConvolutionParameteriEXT.version = '1.0'
glConvolutionParameteriEXT.category = 'GL_EXT_convolution'
glConvolutionParameteriEXT.trace = True
glConvolutionParameteriEXT.play = True
gl.add(glConvolutionParameteriEXT)

glConvolutionParameterivEXT = Function('glConvolutionParameterivEXT')
glConvolutionParameterivEXT.ret = Return('void')
glConvolutionParameterivEXT.add( Input( 'target','GLenum' ))
glConvolutionParameterivEXT.add( Input( 'pname','GLenum' ))
glConvolutionParameterivEXT.add( Input( 'params','const GLint *' ))
glConvolutionParameterivEXT.version = '1.0'
glConvolutionParameterivEXT.category = 'GL_EXT_convolution'
glConvolutionParameterivEXT.trace = True
glConvolutionParameterivEXT.play = True
gl.add(glConvolutionParameterivEXT)

glCopyConvolutionFilter1DEXT = Function('glCopyConvolutionFilter1DEXT')
glCopyConvolutionFilter1DEXT.ret = Return('void')
glCopyConvolutionFilter1DEXT.add( Input( 'target','GLenum' ))
glCopyConvolutionFilter1DEXT.add( Input( 'internalformat','GLenum' ))
glCopyConvolutionFilter1DEXT.add( Input( 'x','GLint' ))
glCopyConvolutionFilter1DEXT.add( Input( 'y','GLint' ))
glCopyConvolutionFilter1DEXT.add( Input( 'width','GLsizei' ))
glCopyConvolutionFilter1DEXT.version = '1.0'
glCopyConvolutionFilter1DEXT.category = 'GL_EXT_convolution'
glCopyConvolutionFilter1DEXT.trace = True
glCopyConvolutionFilter1DEXT.play = True
gl.add(glCopyConvolutionFilter1DEXT)

glCopyConvolutionFilter2DEXT = Function('glCopyConvolutionFilter2DEXT')
glCopyConvolutionFilter2DEXT.ret = Return('void')
glCopyConvolutionFilter2DEXT.add( Input( 'target','GLenum' ))
glCopyConvolutionFilter2DEXT.add( Input( 'internalformat','GLenum' ))
glCopyConvolutionFilter2DEXT.add( Input( 'x','GLint' ))
glCopyConvolutionFilter2DEXT.add( Input( 'y','GLint' ))
glCopyConvolutionFilter2DEXT.add( Input( 'width','GLsizei' ))
glCopyConvolutionFilter2DEXT.add( Input( 'height','GLsizei' ))
glCopyConvolutionFilter2DEXT.version = '1.0'
glCopyConvolutionFilter2DEXT.category = 'GL_EXT_convolution'
glCopyConvolutionFilter2DEXT.trace = True
glCopyConvolutionFilter2DEXT.play = True
gl.add(glCopyConvolutionFilter2DEXT)

glGetConvolutionFilterEXT = Function('glGetConvolutionFilterEXT')
glGetConvolutionFilterEXT.ret = Return('void')
glGetConvolutionFilterEXT.add( Input( 'target','GLenum' ))
glGetConvolutionFilterEXT.add( Input( 'format','GLenum' ))
glGetConvolutionFilterEXT.add( Input( 'type','GLenum' ))
glGetConvolutionFilterEXT.add( Output( 'image','GLvoid *' ))
glGetConvolutionFilterEXT.version = '1.0'
glGetConvolutionFilterEXT.category = 'GL_EXT_convolution'
glGetConvolutionFilterEXT.trace = True
glGetConvolutionFilterEXT.play = True
gl.add(glGetConvolutionFilterEXT)

glGetConvolutionParameterfvEXT = Function('glGetConvolutionParameterfvEXT')
glGetConvolutionParameterfvEXT.ret = Return('void')
glGetConvolutionParameterfvEXT.add( Input( 'target','GLenum' ))
glGetConvolutionParameterfvEXT.add( Input( 'pname','GLenum' ))
glGetConvolutionParameterfvEXT.add( Output( 'params','GLfloat *' ))
glGetConvolutionParameterfvEXT.version = '1.0'
glGetConvolutionParameterfvEXT.category = 'GL_EXT_convolution'
glGetConvolutionParameterfvEXT.trace = True
glGetConvolutionParameterfvEXT.play = True
gl.add(glGetConvolutionParameterfvEXT)

glGetConvolutionParameterivEXT = Function('glGetConvolutionParameterivEXT')
glGetConvolutionParameterivEXT.ret = Return('void')
glGetConvolutionParameterivEXT.add( Input( 'target','GLenum' ))
glGetConvolutionParameterivEXT.add( Input( 'pname','GLenum' ))
glGetConvolutionParameterivEXT.add( Output( 'params','GLint *' ))
glGetConvolutionParameterivEXT.version = '1.0'
glGetConvolutionParameterivEXT.category = 'GL_EXT_convolution'
glGetConvolutionParameterivEXT.trace = True
glGetConvolutionParameterivEXT.play = True
gl.add(glGetConvolutionParameterivEXT)

glGetSeparableFilterEXT = Function('glGetSeparableFilterEXT')
glGetSeparableFilterEXT.ret = Return('void')
glGetSeparableFilterEXT.add( Input( 'target','GLenum' ))
glGetSeparableFilterEXT.add( Input( 'format','GLenum' ))
glGetSeparableFilterEXT.add( Input( 'type','GLenum' ))
glGetSeparableFilterEXT.add( Output( 'row','GLvoid *' ))
glGetSeparableFilterEXT.add( Output( 'column','GLvoid *' ))
glGetSeparableFilterEXT.add( Output( 'span','GLvoid *' ))
glGetSeparableFilterEXT.version = '1.0'
glGetSeparableFilterEXT.category = 'GL_EXT_convolution'
glGetSeparableFilterEXT.trace = True
glGetSeparableFilterEXT.play = True
gl.add(glGetSeparableFilterEXT)

glSeparableFilter2DEXT = Function('glSeparableFilter2DEXT')
glSeparableFilter2DEXT.ret = Return('void')
glSeparableFilter2DEXT.add( Input( 'target','GLenum' ))
glSeparableFilter2DEXT.add( Input( 'internalformat','GLenum' ))
glSeparableFilter2DEXT.add( Input( 'width','GLsizei' ))
glSeparableFilter2DEXT.add( Input( 'height','GLsizei' ))
glSeparableFilter2DEXT.add( Input( 'format','GLenum' ))
glSeparableFilter2DEXT.add( Input( 'type','GLenum' ))
glSeparableFilter2DEXT.add( Input( 'row','const GLvoid *' ))
glSeparableFilter2DEXT.add( Input( 'column','const GLvoid *' ))
glSeparableFilter2DEXT.version = '1.0'
glSeparableFilter2DEXT.category = 'GL_EXT_convolution'
glSeparableFilter2DEXT.trace = True
glSeparableFilter2DEXT.play = True
gl.add(glSeparableFilter2DEXT)

# GL_EXT_coordinate_frame

glBinormal3bEXT = Function('glBinormal3bEXT')
glBinormal3bEXT.ret = Return('void')
glBinormal3bEXT.add( Input( 'bx','GLbyte' ))
glBinormal3bEXT.add( Input( 'by','GLbyte' ))
glBinormal3bEXT.add( Input( 'bz','GLbyte' ))
glBinormal3bEXT.version = '1.1'
glBinormal3bEXT.category = 'GL_EXT_coordinate_frame'
glBinormal3bEXT.trace = True
glBinormal3bEXT.play = True
gl.add(glBinormal3bEXT)

glBinormal3bvEXT = Function('glBinormal3bvEXT')
glBinormal3bvEXT.ret = Return('void')
glBinormal3bvEXT.add( Input( 'v','const GLbyte *' ,size = 3 ))
glBinormal3bvEXT.version = '1.1'
glBinormal3bvEXT.category = 'GL_EXT_coordinate_frame'
glBinormal3bvEXT.trace = True
glBinormal3bvEXT.play = True
gl.add(glBinormal3bvEXT)

glBinormal3dEXT = Function('glBinormal3dEXT')
glBinormal3dEXT.ret = Return('void')
glBinormal3dEXT.add( Input( 'bx','GLdouble' ))
glBinormal3dEXT.add( Input( 'by','GLdouble' ))
glBinormal3dEXT.add( Input( 'bz','GLdouble' ))
glBinormal3dEXT.version = '1.1'
glBinormal3dEXT.category = 'GL_EXT_coordinate_frame'
glBinormal3dEXT.trace = True
glBinormal3dEXT.play = True
gl.add(glBinormal3dEXT)

glBinormal3dvEXT = Function('glBinormal3dvEXT')
glBinormal3dvEXT.ret = Return('void')
glBinormal3dvEXT.add( Input( 'v','const GLdouble *' ,size = 3 ))
glBinormal3dvEXT.version = '1.1'
glBinormal3dvEXT.category = 'GL_EXT_coordinate_frame'
glBinormal3dvEXT.trace = True
glBinormal3dvEXT.play = True
gl.add(glBinormal3dvEXT)

glBinormal3fEXT = Function('glBinormal3fEXT')
glBinormal3fEXT.ret = Return('void')
glBinormal3fEXT.add( Input( 'bx','GLfloat' ))
glBinormal3fEXT.add( Input( 'by','GLfloat' ))
glBinormal3fEXT.add( Input( 'bz','GLfloat' ))
glBinormal3fEXT.version = '1.1'
glBinormal3fEXT.category = 'GL_EXT_coordinate_frame'
glBinormal3fEXT.trace = True
glBinormal3fEXT.play = True
gl.add(glBinormal3fEXT)

glBinormal3fvEXT = Function('glBinormal3fvEXT')
glBinormal3fvEXT.ret = Return('void')
glBinormal3fvEXT.add( Input( 'v','const GLfloat *' ,size = 3 ))
glBinormal3fvEXT.version = '1.1'
glBinormal3fvEXT.category = 'GL_EXT_coordinate_frame'
glBinormal3fvEXT.trace = True
glBinormal3fvEXT.play = True
gl.add(glBinormal3fvEXT)

glBinormal3iEXT = Function('glBinormal3iEXT')
glBinormal3iEXT.ret = Return('void')
glBinormal3iEXT.add( Input( 'bx','GLint' ))
glBinormal3iEXT.add( Input( 'by','GLint' ))
glBinormal3iEXT.add( Input( 'bz','GLint' ))
glBinormal3iEXT.version = '1.1'
glBinormal3iEXT.category = 'GL_EXT_coordinate_frame'
glBinormal3iEXT.trace = True
glBinormal3iEXT.play = True
gl.add(glBinormal3iEXT)

glBinormal3ivEXT = Function('glBinormal3ivEXT')
glBinormal3ivEXT.ret = Return('void')
glBinormal3ivEXT.add( Input( 'v','const GLint *' ,size = 3 ))
glBinormal3ivEXT.version = '1.1'
glBinormal3ivEXT.category = 'GL_EXT_coordinate_frame'
glBinormal3ivEXT.trace = True
glBinormal3ivEXT.play = True
gl.add(glBinormal3ivEXT)

glBinormal3sEXT = Function('glBinormal3sEXT')
glBinormal3sEXT.ret = Return('void')
glBinormal3sEXT.add( Input( 'bx','GLshort' ))
glBinormal3sEXT.add( Input( 'by','GLshort' ))
glBinormal3sEXT.add( Input( 'bz','GLshort' ))
glBinormal3sEXT.version = '1.1'
glBinormal3sEXT.category = 'GL_EXT_coordinate_frame'
glBinormal3sEXT.trace = True
glBinormal3sEXT.play = True
gl.add(glBinormal3sEXT)

glBinormal3svEXT = Function('glBinormal3svEXT')
glBinormal3svEXT.ret = Return('void')
glBinormal3svEXT.add( Input( 'v','const GLshort *' ,size = 3 ))
glBinormal3svEXT.version = '1.1'
glBinormal3svEXT.category = 'GL_EXT_coordinate_frame'
glBinormal3svEXT.trace = True
glBinormal3svEXT.play = True
gl.add(glBinormal3svEXT)

glBinormalPointerEXT = Function('glBinormalPointerEXT')
glBinormalPointerEXT.ret = Return('void')
glBinormalPointerEXT.add( Input( 'type','GLenum' ))
glBinormalPointerEXT.add( Input( 'stride','GLsizei' ))
glBinormalPointerEXT.add( Input( 'pointer','const GLvoid *' ))
glBinormalPointerEXT.version = '1.1'
glBinormalPointerEXT.category = 'GL_EXT_coordinate_frame'
glBinormalPointerEXT.trace = True
glBinormalPointerEXT.play = True
gl.add(glBinormalPointerEXT)

glTangent3bEXT = Function('glTangent3bEXT')
glTangent3bEXT.ret = Return('void')
glTangent3bEXT.add( Input( 'tx','GLbyte' ))
glTangent3bEXT.add( Input( 'ty','GLbyte' ))
glTangent3bEXT.add( Input( 'tz','GLbyte' ))
glTangent3bEXT.version = '1.1'
glTangent3bEXT.category = 'GL_EXT_coordinate_frame'
glTangent3bEXT.trace = True
glTangent3bEXT.play = True
gl.add(glTangent3bEXT)

glTangent3bvEXT = Function('glTangent3bvEXT')
glTangent3bvEXT.ret = Return('void')
glTangent3bvEXT.add( Input( 'v','const GLbyte *' ,size = 3 ))
glTangent3bvEXT.version = '1.1'
glTangent3bvEXT.category = 'GL_EXT_coordinate_frame'
glTangent3bvEXT.trace = True
glTangent3bvEXT.play = True
gl.add(glTangent3bvEXT)

glTangent3dEXT = Function('glTangent3dEXT')
glTangent3dEXT.ret = Return('void')
glTangent3dEXT.add( Input( 'tx','GLdouble' ))
glTangent3dEXT.add( Input( 'ty','GLdouble' ))
glTangent3dEXT.add( Input( 'tz','GLdouble' ))
glTangent3dEXT.version = '1.1'
glTangent3dEXT.category = 'GL_EXT_coordinate_frame'
glTangent3dEXT.trace = True
glTangent3dEXT.play = True
gl.add(glTangent3dEXT)

glTangent3dvEXT = Function('glTangent3dvEXT')
glTangent3dvEXT.ret = Return('void')
glTangent3dvEXT.add( Input( 'v','const GLdouble *' ,size = 3 ))
glTangent3dvEXT.version = '1.1'
glTangent3dvEXT.category = 'GL_EXT_coordinate_frame'
glTangent3dvEXT.trace = True
glTangent3dvEXT.play = True
gl.add(glTangent3dvEXT)

glTangent3fEXT = Function('glTangent3fEXT')
glTangent3fEXT.ret = Return('void')
glTangent3fEXT.add( Input( 'tx','GLfloat' ))
glTangent3fEXT.add( Input( 'ty','GLfloat' ))
glTangent3fEXT.add( Input( 'tz','GLfloat' ))
glTangent3fEXT.version = '1.1'
glTangent3fEXT.category = 'GL_EXT_coordinate_frame'
glTangent3fEXT.trace = True
glTangent3fEXT.play = True
gl.add(glTangent3fEXT)

glTangent3fvEXT = Function('glTangent3fvEXT')
glTangent3fvEXT.ret = Return('void')
glTangent3fvEXT.add( Input( 'v','const GLfloat *' ,size = 3 ))
glTangent3fvEXT.version = '1.1'
glTangent3fvEXT.category = 'GL_EXT_coordinate_frame'
glTangent3fvEXT.trace = True
glTangent3fvEXT.play = True
gl.add(glTangent3fvEXT)

glTangent3iEXT = Function('glTangent3iEXT')
glTangent3iEXT.ret = Return('void')
glTangent3iEXT.add( Input( 'tx','GLint' ))
glTangent3iEXT.add( Input( 'ty','GLint' ))
glTangent3iEXT.add( Input( 'tz','GLint' ))
glTangent3iEXT.version = '1.1'
glTangent3iEXT.category = 'GL_EXT_coordinate_frame'
glTangent3iEXT.trace = True
glTangent3iEXT.play = True
gl.add(glTangent3iEXT)

glTangent3ivEXT = Function('glTangent3ivEXT')
glTangent3ivEXT.ret = Return('void')
glTangent3ivEXT.add( Input( 'v','const GLint *' ,size = 3 ))
glTangent3ivEXT.version = '1.1'
glTangent3ivEXT.category = 'GL_EXT_coordinate_frame'
glTangent3ivEXT.trace = True
glTangent3ivEXT.play = True
gl.add(glTangent3ivEXT)

glTangent3sEXT = Function('glTangent3sEXT')
glTangent3sEXT.ret = Return('void')
glTangent3sEXT.add( Input( 'tx','GLshort' ))
glTangent3sEXT.add( Input( 'ty','GLshort' ))
glTangent3sEXT.add( Input( 'tz','GLshort' ))
glTangent3sEXT.version = '1.1'
glTangent3sEXT.category = 'GL_EXT_coordinate_frame'
glTangent3sEXT.trace = True
glTangent3sEXT.play = True
gl.add(glTangent3sEXT)

glTangent3svEXT = Function('glTangent3svEXT')
glTangent3svEXT.ret = Return('void')
glTangent3svEXT.add( Input( 'v','const GLshort *' ,size = 3 ))
glTangent3svEXT.version = '1.1'
glTangent3svEXT.category = 'GL_EXT_coordinate_frame'
glTangent3svEXT.trace = True
glTangent3svEXT.play = True
gl.add(glTangent3svEXT)

glTangentPointerEXT = Function('glTangentPointerEXT')
glTangentPointerEXT.ret = Return('void')
glTangentPointerEXT.add( Input( 'type','GLenum' ))
glTangentPointerEXT.add( Input( 'stride','GLsizei' ))
glTangentPointerEXT.add( Input( 'pointer','const GLvoid *' ))
glTangentPointerEXT.version = '1.1'
glTangentPointerEXT.category = 'GL_EXT_coordinate_frame'
glTangentPointerEXT.trace = True
glTangentPointerEXT.play = True
gl.add(glTangentPointerEXT)

# GL_EXT_copy_texture

glCopyTexImage1DEXT = Function('glCopyTexImage1DEXT')
glCopyTexImage1DEXT.ret = Return('void')
glCopyTexImage1DEXT.add( Input( 'target','GLenum' ))
glCopyTexImage1DEXT.add( Input( 'level','GLint' ))
glCopyTexImage1DEXT.add( Input( 'internalformat','GLenum' ))
glCopyTexImage1DEXT.add( Input( 'x','GLint' ))
glCopyTexImage1DEXT.add( Input( 'y','GLint' ))
glCopyTexImage1DEXT.add( Input( 'width','GLsizei' ))
glCopyTexImage1DEXT.add( Input( 'border','GLint' ))
glCopyTexImage1DEXT.version = '1.0'
glCopyTexImage1DEXT.category = 'GL_EXT_copy_texture'
glCopyTexImage1DEXT.trace = True
glCopyTexImage1DEXT.play = True
gl.add(glCopyTexImage1DEXT)

glCopyTexImage2DEXT = Function('glCopyTexImage2DEXT')
glCopyTexImage2DEXT.ret = Return('void')
glCopyTexImage2DEXT.add( Input( 'target','GLenum' ))
glCopyTexImage2DEXT.add( Input( 'level','GLint' ))
glCopyTexImage2DEXT.add( Input( 'internalformat','GLenum' ))
glCopyTexImage2DEXT.add( Input( 'x','GLint' ))
glCopyTexImage2DEXT.add( Input( 'y','GLint' ))
glCopyTexImage2DEXT.add( Input( 'width','GLsizei' ))
glCopyTexImage2DEXT.add( Input( 'height','GLsizei' ))
glCopyTexImage2DEXT.add( Input( 'border','GLint' ))
glCopyTexImage2DEXT.version = '1.0'
glCopyTexImage2DEXT.category = 'GL_EXT_copy_texture'
glCopyTexImage2DEXT.trace = True
glCopyTexImage2DEXT.play = True
gl.add(glCopyTexImage2DEXT)

glCopyTexSubImage1DEXT = Function('glCopyTexSubImage1DEXT')
glCopyTexSubImage1DEXT.ret = Return('void')
glCopyTexSubImage1DEXT.add( Input( 'target','GLenum' ))
glCopyTexSubImage1DEXT.add( Input( 'level','GLint' ))
glCopyTexSubImage1DEXT.add( Input( 'xoffset','GLint' ))
glCopyTexSubImage1DEXT.add( Input( 'x','GLint' ))
glCopyTexSubImage1DEXT.add( Input( 'y','GLint' ))
glCopyTexSubImage1DEXT.add( Input( 'width','GLsizei' ))
glCopyTexSubImage1DEXT.version = '1.0'
glCopyTexSubImage1DEXT.category = 'GL_EXT_copy_texture'
glCopyTexSubImage1DEXT.trace = True
glCopyTexSubImage1DEXT.play = True
gl.add(glCopyTexSubImage1DEXT)

glCopyTexSubImage2DEXT = Function('glCopyTexSubImage2DEXT')
glCopyTexSubImage2DEXT.ret = Return('void')
glCopyTexSubImage2DEXT.add( Input( 'target','GLenum' ))
glCopyTexSubImage2DEXT.add( Input( 'level','GLint' ))
glCopyTexSubImage2DEXT.add( Input( 'xoffset','GLint' ))
glCopyTexSubImage2DEXT.add( Input( 'yoffset','GLint' ))
glCopyTexSubImage2DEXT.add( Input( 'x','GLint' ))
glCopyTexSubImage2DEXT.add( Input( 'y','GLint' ))
glCopyTexSubImage2DEXT.add( Input( 'width','GLsizei' ))
glCopyTexSubImage2DEXT.add( Input( 'height','GLsizei' ))
glCopyTexSubImage2DEXT.version = '1.0'
glCopyTexSubImage2DEXT.category = 'GL_EXT_copy_texture'
glCopyTexSubImage2DEXT.trace = True
glCopyTexSubImage2DEXT.play = True
gl.add(glCopyTexSubImage2DEXT)

glCopyTexSubImage3DEXT = Function('glCopyTexSubImage3DEXT')
glCopyTexSubImage3DEXT.ret = Return('void')
glCopyTexSubImage3DEXT.add( Input( 'target','GLenum' ))
glCopyTexSubImage3DEXT.add( Input( 'level','GLint' ))
glCopyTexSubImage3DEXT.add( Input( 'xoffset','GLint' ))
glCopyTexSubImage3DEXT.add( Input( 'yoffset','GLint' ))
glCopyTexSubImage3DEXT.add( Input( 'zoffset','GLint' ))
glCopyTexSubImage3DEXT.add( Input( 'x','GLint' ))
glCopyTexSubImage3DEXT.add( Input( 'y','GLint' ))
glCopyTexSubImage3DEXT.add( Input( 'width','GLsizei' ))
glCopyTexSubImage3DEXT.add( Input( 'height','GLsizei' ))
glCopyTexSubImage3DEXT.version = '1.0'
glCopyTexSubImage3DEXT.category = 'GL_EXT_copy_texture'
glCopyTexSubImage3DEXT.trace = True
glCopyTexSubImage3DEXT.play = True
gl.add(glCopyTexSubImage3DEXT)

# GL_EXT_cull_vertex

glCullParameterdvEXT = Function('glCullParameterdvEXT')
glCullParameterdvEXT.ret = Return('void')
glCullParameterdvEXT.add( Input( 'pname','GLenum' ))
glCullParameterdvEXT.add( Output( 'params','GLdouble *' ,size = 4 ))
glCullParameterdvEXT.version = '1.1'
glCullParameterdvEXT.category = 'GL_EXT_cull_vertex'
glCullParameterdvEXT.trace = True
glCullParameterdvEXT.play = True
gl.add(glCullParameterdvEXT)

glCullParameterfvEXT = Function('glCullParameterfvEXT')
glCullParameterfvEXT.ret = Return('void')
glCullParameterfvEXT.add( Input( 'pname','GLenum' ))
glCullParameterfvEXT.add( Output( 'params','GLfloat *' ,size = 4 ))
glCullParameterfvEXT.version = '1.1'
glCullParameterfvEXT.category = 'GL_EXT_cull_vertex'
glCullParameterfvEXT.trace = True
glCullParameterfvEXT.play = True
gl.add(glCullParameterfvEXT)

# GL_EXT_debug_label

glGetObjectLabelEXT = Function('glGetObjectLabelEXT')
glGetObjectLabelEXT.ret = Return('void')
glGetObjectLabelEXT.add( Input( 'type','GLenum' ))
glGetObjectLabelEXT.add( Input( 'object','GLuint' ))
glGetObjectLabelEXT.add( Input( 'bufSize','GLsizei' ))
glGetObjectLabelEXT.add( Input( 'length','GLsizei *' ))
glGetObjectLabelEXT.add( Input( 'label','GLchar *' ))
glGetObjectLabelEXT.version = ''
glGetObjectLabelEXT.category = 'GL_EXT_debug_label'
glGetObjectLabelEXT.trace = True
glGetObjectLabelEXT.play = True
gl.add(glGetObjectLabelEXT)

glLabelObjectEXT = Function('glLabelObjectEXT')
glLabelObjectEXT.ret = Return('void')
glLabelObjectEXT.add( Input( 'type','GLenum' ))
glLabelObjectEXT.add( Input( 'object','GLuint' ))
glLabelObjectEXT.add( Input( 'length','GLsizei' ))
glLabelObjectEXT.add( Input( 'label','const GLchar *' ))
glLabelObjectEXT.version = ''
glLabelObjectEXT.category = 'GL_EXT_debug_label'
glLabelObjectEXT.trace = True
glLabelObjectEXT.play = True
gl.add(glLabelObjectEXT)

# GL_EXT_debug_marker

glInsertEventMarkerEXT = Function('glInsertEventMarkerEXT')
glInsertEventMarkerEXT.ret = Return('void')
glInsertEventMarkerEXT.add( Input( 'length','GLsizei' ))
glInsertEventMarkerEXT.add( Input( 'marker','const GLchar *' ))
glInsertEventMarkerEXT.version = 'ES 2.0'
glInsertEventMarkerEXT.category = 'GL_EXT_debug_marker'
glInsertEventMarkerEXT.trace = True
glInsertEventMarkerEXT.play = True
gl.add(glInsertEventMarkerEXT)

glPopGroupMarkerEXT = Function('glPopGroupMarkerEXT')
glPopGroupMarkerEXT.ret = Return('void')
glPopGroupMarkerEXT.version = 'ES 2.0'
glPopGroupMarkerEXT.category = 'GL_EXT_debug_marker'
glPopGroupMarkerEXT.trace = True
glPopGroupMarkerEXT.play = True
gl.add(glPopGroupMarkerEXT)

glPushGroupMarkerEXT = Function('glPushGroupMarkerEXT')
glPushGroupMarkerEXT.ret = Return('void')
glPushGroupMarkerEXT.add( Input( 'length','GLsizei' ))
glPushGroupMarkerEXT.add( Input( 'marker','const GLchar *' ))
glPushGroupMarkerEXT.version = 'ES 2.0'
glPushGroupMarkerEXT.category = 'GL_EXT_debug_marker'
glPushGroupMarkerEXT.trace = True
glPushGroupMarkerEXT.play = True
gl.add(glPushGroupMarkerEXT)

# GL_EXT_depth_bounds_test

glDepthBoundsEXT = Function('glDepthBoundsEXT')
glDepthBoundsEXT.ret = Return('void')
glDepthBoundsEXT.add( Input( 'zmin','GLclampd' ))
glDepthBoundsEXT.add( Input( 'zmax','GLclampd' ))
glDepthBoundsEXT.version = '1.1'
glDepthBoundsEXT.category = 'GL_EXT_depth_bounds_test'
glDepthBoundsEXT.trace = True
glDepthBoundsEXT.play = True
gl.add(glDepthBoundsEXT)

# GL_EXT_direct_state_access

glBindMultiTextureEXT = Function('glBindMultiTextureEXT')
glBindMultiTextureEXT.ret = Return('void')
glBindMultiTextureEXT.add( Input( 'texunit','GLenum' ))
glBindMultiTextureEXT.add( Input( 'target','GLenum' ))
glBindMultiTextureEXT.add( Input( 'texture','GLuint' ))
glBindMultiTextureEXT.version = '1.1'
glBindMultiTextureEXT.category = 'GL_EXT_direct_state_access'
glBindMultiTextureEXT.trace = True
glBindMultiTextureEXT.play = True
gl.add(glBindMultiTextureEXT)

glCheckNamedFramebufferStatusEXT = Function('glCheckNamedFramebufferStatusEXT')
glCheckNamedFramebufferStatusEXT.ret = Return('GLenum')
glCheckNamedFramebufferStatusEXT.add( Input( 'framebuffer','GLuint' ))
glCheckNamedFramebufferStatusEXT.add( Input( 'target','GLenum' ))
glCheckNamedFramebufferStatusEXT.version = '1.5'
glCheckNamedFramebufferStatusEXT.category = 'GL_EXT_direct_state_access'
glCheckNamedFramebufferStatusEXT.trace = True
glCheckNamedFramebufferStatusEXT.play = True
gl.add(glCheckNamedFramebufferStatusEXT)

glClientAttribDefaultEXT = Function('glClientAttribDefaultEXT')
glClientAttribDefaultEXT.ret = Return('void')
glClientAttribDefaultEXT.add( Input( 'mask','GLbitfield' ,regalLog = 'GLpushClientAttribToString(mask)' ))
glClientAttribDefaultEXT.version = '1.1'
glClientAttribDefaultEXT.category = 'GL_EXT_direct_state_access'
glClientAttribDefaultEXT.trace = True
glClientAttribDefaultEXT.play = True
gl.add(glClientAttribDefaultEXT)

glCompressedMultiTexImage1DEXT = Function('glCompressedMultiTexImage1DEXT')
glCompressedMultiTexImage1DEXT.ret = Return('void')
glCompressedMultiTexImage1DEXT.add( Input( 'texunit','GLenum' ))
glCompressedMultiTexImage1DEXT.add( Input( 'target','GLenum' ))
glCompressedMultiTexImage1DEXT.add( Input( 'level','GLint' ))
glCompressedMultiTexImage1DEXT.add( Input( 'internalformat','GLenum' ))
glCompressedMultiTexImage1DEXT.add( Input( 'width','GLsizei' ))
glCompressedMultiTexImage1DEXT.add( Input( 'border','GLint' ))
glCompressedMultiTexImage1DEXT.add( Input( 'imageSize','GLsizei' ))
glCompressedMultiTexImage1DEXT.add( Input( 'data','const GLvoid *' ,size = 'imageSize' ))
glCompressedMultiTexImage1DEXT.version = '1.3'
glCompressedMultiTexImage1DEXT.category = 'GL_EXT_direct_state_access'
glCompressedMultiTexImage1DEXT.trace = True
glCompressedMultiTexImage1DEXT.play = True
gl.add(glCompressedMultiTexImage1DEXT)

glCompressedMultiTexImage2DEXT = Function('glCompressedMultiTexImage2DEXT')
glCompressedMultiTexImage2DEXT.ret = Return('void')
glCompressedMultiTexImage2DEXT.add( Input( 'texunit','GLenum' ))
glCompressedMultiTexImage2DEXT.add( Input( 'target','GLenum' ))
glCompressedMultiTexImage2DEXT.add( Input( 'level','GLint' ))
glCompressedMultiTexImage2DEXT.add( Input( 'internalformat','GLenum' ))
glCompressedMultiTexImage2DEXT.add( Input( 'width','GLsizei' ))
glCompressedMultiTexImage2DEXT.add( Input( 'height','GLsizei' ))
glCompressedMultiTexImage2DEXT.add( Input( 'border','GLint' ))
glCompressedMultiTexImage2DEXT.add( Input( 'imageSize','GLsizei' ))
glCompressedMultiTexImage2DEXT.add( Input( 'bits','const GLvoid *' ,size = 'imageSize' ))
glCompressedMultiTexImage2DEXT.version = '1.3'
glCompressedMultiTexImage2DEXT.category = 'GL_EXT_direct_state_access'
glCompressedMultiTexImage2DEXT.trace = True
glCompressedMultiTexImage2DEXT.play = True
gl.add(glCompressedMultiTexImage2DEXT)

glCompressedMultiTexImage3DEXT = Function('glCompressedMultiTexImage3DEXT')
glCompressedMultiTexImage3DEXT.ret = Return('void')
glCompressedMultiTexImage3DEXT.add( Input( 'texunit','GLenum' ))
glCompressedMultiTexImage3DEXT.add( Input( 'target','GLenum' ))
glCompressedMultiTexImage3DEXT.add( Input( 'level','GLint' ))
glCompressedMultiTexImage3DEXT.add( Input( 'internalformat','GLenum' ))
glCompressedMultiTexImage3DEXT.add( Input( 'width','GLsizei' ))
glCompressedMultiTexImage3DEXT.add( Input( 'height','GLsizei' ))
glCompressedMultiTexImage3DEXT.add( Input( 'depth','GLsizei' ))
glCompressedMultiTexImage3DEXT.add( Input( 'border','GLint' ))
glCompressedMultiTexImage3DEXT.add( Input( 'imageSize','GLsizei' ))
glCompressedMultiTexImage3DEXT.add( Input( 'bits','const GLvoid *' ,size = 'imageSize' ))
glCompressedMultiTexImage3DEXT.version = '1.3'
glCompressedMultiTexImage3DEXT.category = 'GL_EXT_direct_state_access'
glCompressedMultiTexImage3DEXT.trace = True
glCompressedMultiTexImage3DEXT.play = True
gl.add(glCompressedMultiTexImage3DEXT)

glCompressedMultiTexSubImage1DEXT = Function('glCompressedMultiTexSubImage1DEXT')
glCompressedMultiTexSubImage1DEXT.ret = Return('void')
glCompressedMultiTexSubImage1DEXT.add( Input( 'texunit','GLenum' ))
glCompressedMultiTexSubImage1DEXT.add( Input( 'target','GLenum' ))
glCompressedMultiTexSubImage1DEXT.add( Input( 'level','GLint' ))
glCompressedMultiTexSubImage1DEXT.add( Input( 'xoffset','GLint' ))
glCompressedMultiTexSubImage1DEXT.add( Input( 'width','GLsizei' ))
glCompressedMultiTexSubImage1DEXT.add( Input( 'format','GLenum' ))
glCompressedMultiTexSubImage1DEXT.add( Input( 'imageSize','GLsizei' ))
glCompressedMultiTexSubImage1DEXT.add( Input( 'data','const GLvoid *' ,size = 'imageSize' ))
glCompressedMultiTexSubImage1DEXT.version = '1.3'
glCompressedMultiTexSubImage1DEXT.category = 'GL_EXT_direct_state_access'
glCompressedMultiTexSubImage1DEXT.trace = True
glCompressedMultiTexSubImage1DEXT.play = True
gl.add(glCompressedMultiTexSubImage1DEXT)

glCompressedMultiTexSubImage2DEXT = Function('glCompressedMultiTexSubImage2DEXT')
glCompressedMultiTexSubImage2DEXT.ret = Return('void')
glCompressedMultiTexSubImage2DEXT.add( Input( 'texunit','GLenum' ))
glCompressedMultiTexSubImage2DEXT.add( Input( 'target','GLenum' ))
glCompressedMultiTexSubImage2DEXT.add( Input( 'level','GLint' ))
glCompressedMultiTexSubImage2DEXT.add( Input( 'xoffset','GLint' ))
glCompressedMultiTexSubImage2DEXT.add( Input( 'yoffset','GLint' ))
glCompressedMultiTexSubImage2DEXT.add( Input( 'width','GLsizei' ))
glCompressedMultiTexSubImage2DEXT.add( Input( 'height','GLsizei' ))
glCompressedMultiTexSubImage2DEXT.add( Input( 'format','GLenum' ))
glCompressedMultiTexSubImage2DEXT.add( Input( 'imageSize','GLsizei' ))
glCompressedMultiTexSubImage2DEXT.add( Input( 'data','const GLvoid *' ,size = 'imageSize' ))
glCompressedMultiTexSubImage2DEXT.version = '1.3'
glCompressedMultiTexSubImage2DEXT.category = 'GL_EXT_direct_state_access'
glCompressedMultiTexSubImage2DEXT.trace = True
glCompressedMultiTexSubImage2DEXT.play = True
gl.add(glCompressedMultiTexSubImage2DEXT)

glCompressedMultiTexSubImage3DEXT = Function('glCompressedMultiTexSubImage3DEXT')
glCompressedMultiTexSubImage3DEXT.ret = Return('void')
glCompressedMultiTexSubImage3DEXT.add( Input( 'texunit','GLenum' ))
glCompressedMultiTexSubImage3DEXT.add( Input( 'target','GLenum' ))
glCompressedMultiTexSubImage3DEXT.add( Input( 'level','GLint' ))
glCompressedMultiTexSubImage3DEXT.add( Input( 'xoffset','GLint' ))
glCompressedMultiTexSubImage3DEXT.add( Input( 'yoffset','GLint' ))
glCompressedMultiTexSubImage3DEXT.add( Input( 'zoffset','GLint' ))
glCompressedMultiTexSubImage3DEXT.add( Input( 'width','GLsizei' ))
glCompressedMultiTexSubImage3DEXT.add( Input( 'height','GLsizei' ))
glCompressedMultiTexSubImage3DEXT.add( Input( 'depth','GLsizei' ))
glCompressedMultiTexSubImage3DEXT.add( Input( 'format','GLenum' ))
glCompressedMultiTexSubImage3DEXT.add( Input( 'imageSize','GLsizei' ))
glCompressedMultiTexSubImage3DEXT.add( Input( 'data','const GLvoid *' ,size = 'imageSize' ))
glCompressedMultiTexSubImage3DEXT.version = '1.3'
glCompressedMultiTexSubImage3DEXT.category = 'GL_EXT_direct_state_access'
glCompressedMultiTexSubImage3DEXT.trace = True
glCompressedMultiTexSubImage3DEXT.play = True
gl.add(glCompressedMultiTexSubImage3DEXT)

glCompressedTextureImage1DEXT = Function('glCompressedTextureImage1DEXT')
glCompressedTextureImage1DEXT.ret = Return('void')
glCompressedTextureImage1DEXT.add( Input( 'texture','GLuint' ))
glCompressedTextureImage1DEXT.add( Input( 'target','GLenum' ))
glCompressedTextureImage1DEXT.add( Input( 'level','GLint' ))
glCompressedTextureImage1DEXT.add( Input( 'internalformat','GLenum' ))
glCompressedTextureImage1DEXT.add( Input( 'width','GLsizei' ))
glCompressedTextureImage1DEXT.add( Input( 'border','GLint' ))
glCompressedTextureImage1DEXT.add( Input( 'imageSize','GLsizei' ))
glCompressedTextureImage1DEXT.add( Input( 'bits','const GLvoid *' ,size = 'imageSize' ))
glCompressedTextureImage1DEXT.version = '1.3'
glCompressedTextureImage1DEXT.category = 'GL_EXT_direct_state_access'
glCompressedTextureImage1DEXT.trace = True
glCompressedTextureImage1DEXT.play = True
gl.add(glCompressedTextureImage1DEXT)

glCompressedTextureImage2DEXT = Function('glCompressedTextureImage2DEXT')
glCompressedTextureImage2DEXT.ret = Return('void')
glCompressedTextureImage2DEXT.add( Input( 'texture','GLuint' ))
glCompressedTextureImage2DEXT.add( Input( 'target','GLenum' ))
glCompressedTextureImage2DEXT.add( Input( 'level','GLint' ))
glCompressedTextureImage2DEXT.add( Input( 'internalformat','GLenum' ))
glCompressedTextureImage2DEXT.add( Input( 'width','GLsizei' ))
glCompressedTextureImage2DEXT.add( Input( 'height','GLsizei' ))
glCompressedTextureImage2DEXT.add( Input( 'border','GLint' ))
glCompressedTextureImage2DEXT.add( Input( 'imageSize','GLsizei' ))
glCompressedTextureImage2DEXT.add( Input( 'bits','const GLvoid *' ,size = 'imageSize' ))
glCompressedTextureImage2DEXT.version = '1.3'
glCompressedTextureImage2DEXT.category = 'GL_EXT_direct_state_access'
glCompressedTextureImage2DEXT.trace = True
glCompressedTextureImage2DEXT.play = True
gl.add(glCompressedTextureImage2DEXT)

glCompressedTextureImage3DEXT = Function('glCompressedTextureImage3DEXT')
glCompressedTextureImage3DEXT.ret = Return('void')
glCompressedTextureImage3DEXT.add( Input( 'texture','GLuint' ))
glCompressedTextureImage3DEXT.add( Input( 'target','GLenum' ))
glCompressedTextureImage3DEXT.add( Input( 'level','GLint' ))
glCompressedTextureImage3DEXT.add( Input( 'internalformat','GLenum' ))
glCompressedTextureImage3DEXT.add( Input( 'width','GLsizei' ))
glCompressedTextureImage3DEXT.add( Input( 'height','GLsizei' ))
glCompressedTextureImage3DEXT.add( Input( 'depth','GLsizei' ))
glCompressedTextureImage3DEXT.add( Input( 'border','GLint' ))
glCompressedTextureImage3DEXT.add( Input( 'imageSize','GLsizei' ))
glCompressedTextureImage3DEXT.add( Input( 'bits','const GLvoid *' ,size = 'imageSize' ))
glCompressedTextureImage3DEXT.version = '1.3'
glCompressedTextureImage3DEXT.category = 'GL_EXT_direct_state_access'
glCompressedTextureImage3DEXT.trace = True
glCompressedTextureImage3DEXT.play = True
gl.add(glCompressedTextureImage3DEXT)

glCompressedTextureSubImage1DEXT = Function('glCompressedTextureSubImage1DEXT')
glCompressedTextureSubImage1DEXT.ret = Return('void')
glCompressedTextureSubImage1DEXT.add( Input( 'texture','GLuint' ))
glCompressedTextureSubImage1DEXT.add( Input( 'target','GLenum' ))
glCompressedTextureSubImage1DEXT.add( Input( 'level','GLint' ))
glCompressedTextureSubImage1DEXT.add( Input( 'xoffset','GLint' ))
glCompressedTextureSubImage1DEXT.add( Input( 'width','GLsizei' ))
glCompressedTextureSubImage1DEXT.add( Input( 'format','GLenum' ))
glCompressedTextureSubImage1DEXT.add( Input( 'imageSize','GLsizei' ))
glCompressedTextureSubImage1DEXT.add( Input( 'bits','const GLvoid *' ,size = 'imageSize' ))
glCompressedTextureSubImage1DEXT.version = '1.3'
glCompressedTextureSubImage1DEXT.category = 'GL_EXT_direct_state_access'
glCompressedTextureSubImage1DEXT.trace = True
glCompressedTextureSubImage1DEXT.play = True
gl.add(glCompressedTextureSubImage1DEXT)

glCompressedTextureSubImage2DEXT = Function('glCompressedTextureSubImage2DEXT')
glCompressedTextureSubImage2DEXT.ret = Return('void')
glCompressedTextureSubImage2DEXT.add( Input( 'texture','GLuint' ))
glCompressedTextureSubImage2DEXT.add( Input( 'target','GLenum' ))
glCompressedTextureSubImage2DEXT.add( Input( 'level','GLint' ))
glCompressedTextureSubImage2DEXT.add( Input( 'xoffset','GLint' ))
glCompressedTextureSubImage2DEXT.add( Input( 'yoffset','GLint' ))
glCompressedTextureSubImage2DEXT.add( Input( 'width','GLsizei' ))
glCompressedTextureSubImage2DEXT.add( Input( 'height','GLsizei' ))
glCompressedTextureSubImage2DEXT.add( Input( 'format','GLenum' ))
glCompressedTextureSubImage2DEXT.add( Input( 'imageSize','GLsizei' ))
glCompressedTextureSubImage2DEXT.add( Input( 'bits','const GLvoid *' ,size = 'imageSize' ))
glCompressedTextureSubImage2DEXT.version = '1.3'
glCompressedTextureSubImage2DEXT.category = 'GL_EXT_direct_state_access'
glCompressedTextureSubImage2DEXT.trace = True
glCompressedTextureSubImage2DEXT.play = True
gl.add(glCompressedTextureSubImage2DEXT)

glCompressedTextureSubImage3DEXT = Function('glCompressedTextureSubImage3DEXT')
glCompressedTextureSubImage3DEXT.ret = Return('void')
glCompressedTextureSubImage3DEXT.add( Input( 'texture','GLuint' ))
glCompressedTextureSubImage3DEXT.add( Input( 'target','GLenum' ))
glCompressedTextureSubImage3DEXT.add( Input( 'level','GLint' ))
glCompressedTextureSubImage3DEXT.add( Input( 'xoffset','GLint' ))
glCompressedTextureSubImage3DEXT.add( Input( 'yoffset','GLint' ))
glCompressedTextureSubImage3DEXT.add( Input( 'zoffset','GLint' ))
glCompressedTextureSubImage3DEXT.add( Input( 'width','GLsizei' ))
glCompressedTextureSubImage3DEXT.add( Input( 'height','GLsizei' ))
glCompressedTextureSubImage3DEXT.add( Input( 'depth','GLsizei' ))
glCompressedTextureSubImage3DEXT.add( Input( 'format','GLenum' ))
glCompressedTextureSubImage3DEXT.add( Input( 'imageSize','GLsizei' ))
glCompressedTextureSubImage3DEXT.add( Input( 'bits','const GLvoid *' ,size = 'imageSize' ))
glCompressedTextureSubImage3DEXT.version = '1.3'
glCompressedTextureSubImage3DEXT.category = 'GL_EXT_direct_state_access'
glCompressedTextureSubImage3DEXT.trace = True
glCompressedTextureSubImage3DEXT.play = True
gl.add(glCompressedTextureSubImage3DEXT)

glCopyMultiTexImage1DEXT = Function('glCopyMultiTexImage1DEXT')
glCopyMultiTexImage1DEXT.ret = Return('void')
glCopyMultiTexImage1DEXT.add( Input( 'texunit','GLenum' ))
glCopyMultiTexImage1DEXT.add( Input( 'target','GLenum' ))
glCopyMultiTexImage1DEXT.add( Input( 'level','GLint' ))
glCopyMultiTexImage1DEXT.add( Input( 'internalformat','GLenum' ))
glCopyMultiTexImage1DEXT.add( Input( 'x','GLint' ))
glCopyMultiTexImage1DEXT.add( Input( 'y','GLint' ))
glCopyMultiTexImage1DEXT.add( Input( 'width','GLsizei' ))
glCopyMultiTexImage1DEXT.add( Input( 'border','GLint' ))
glCopyMultiTexImage1DEXT.version = '1.1'
glCopyMultiTexImage1DEXT.category = 'GL_EXT_direct_state_access'
glCopyMultiTexImage1DEXT.trace = True
glCopyMultiTexImage1DEXT.play = True
gl.add(glCopyMultiTexImage1DEXT)

glCopyMultiTexImage2DEXT = Function('glCopyMultiTexImage2DEXT')
glCopyMultiTexImage2DEXT.ret = Return('void')
glCopyMultiTexImage2DEXT.add( Input( 'texunit','GLenum' ))
glCopyMultiTexImage2DEXT.add( Input( 'target','GLenum' ))
glCopyMultiTexImage2DEXT.add( Input( 'level','GLint' ))
glCopyMultiTexImage2DEXT.add( Input( 'internalformat','GLenum' ))
glCopyMultiTexImage2DEXT.add( Input( 'x','GLint' ))
glCopyMultiTexImage2DEXT.add( Input( 'y','GLint' ))
glCopyMultiTexImage2DEXT.add( Input( 'width','GLsizei' ))
glCopyMultiTexImage2DEXT.add( Input( 'height','GLsizei' ))
glCopyMultiTexImage2DEXT.add( Input( 'border','GLint' ))
glCopyMultiTexImage2DEXT.version = '1.1'
glCopyMultiTexImage2DEXT.category = 'GL_EXT_direct_state_access'
glCopyMultiTexImage2DEXT.trace = True
glCopyMultiTexImage2DEXT.play = True
gl.add(glCopyMultiTexImage2DEXT)

glCopyMultiTexSubImage1DEXT = Function('glCopyMultiTexSubImage1DEXT')
glCopyMultiTexSubImage1DEXT.ret = Return('void')
glCopyMultiTexSubImage1DEXT.add( Input( 'texunit','GLenum' ))
glCopyMultiTexSubImage1DEXT.add( Input( 'target','GLenum' ))
glCopyMultiTexSubImage1DEXT.add( Input( 'level','GLint' ))
glCopyMultiTexSubImage1DEXT.add( Input( 'xoffset','GLint' ))
glCopyMultiTexSubImage1DEXT.add( Input( 'x','GLint' ))
glCopyMultiTexSubImage1DEXT.add( Input( 'y','GLint' ))
glCopyMultiTexSubImage1DEXT.add( Input( 'width','GLsizei' ))
glCopyMultiTexSubImage1DEXT.version = '1.1'
glCopyMultiTexSubImage1DEXT.category = 'GL_EXT_direct_state_access'
glCopyMultiTexSubImage1DEXT.trace = True
glCopyMultiTexSubImage1DEXT.play = True
gl.add(glCopyMultiTexSubImage1DEXT)

glCopyMultiTexSubImage2DEXT = Function('glCopyMultiTexSubImage2DEXT')
glCopyMultiTexSubImage2DEXT.ret = Return('void')
glCopyMultiTexSubImage2DEXT.add( Input( 'texunit','GLenum' ))
glCopyMultiTexSubImage2DEXT.add( Input( 'target','GLenum' ))
glCopyMultiTexSubImage2DEXT.add( Input( 'level','GLint' ))
glCopyMultiTexSubImage2DEXT.add( Input( 'xoffset','GLint' ))
glCopyMultiTexSubImage2DEXT.add( Input( 'yoffset','GLint' ))
glCopyMultiTexSubImage2DEXT.add( Input( 'x','GLint' ))
glCopyMultiTexSubImage2DEXT.add( Input( 'y','GLint' ))
glCopyMultiTexSubImage2DEXT.add( Input( 'width','GLsizei' ))
glCopyMultiTexSubImage2DEXT.add( Input( 'height','GLsizei' ))
glCopyMultiTexSubImage2DEXT.version = '1.1'
glCopyMultiTexSubImage2DEXT.category = 'GL_EXT_direct_state_access'
glCopyMultiTexSubImage2DEXT.trace = True
glCopyMultiTexSubImage2DEXT.play = True
gl.add(glCopyMultiTexSubImage2DEXT)

glCopyMultiTexSubImage3DEXT = Function('glCopyMultiTexSubImage3DEXT')
glCopyMultiTexSubImage3DEXT.ret = Return('void')
glCopyMultiTexSubImage3DEXT.add( Input( 'texunit','GLenum' ))
glCopyMultiTexSubImage3DEXT.add( Input( 'target','GLenum' ))
glCopyMultiTexSubImage3DEXT.add( Input( 'level','GLint' ))
glCopyMultiTexSubImage3DEXT.add( Input( 'xoffset','GLint' ))
glCopyMultiTexSubImage3DEXT.add( Input( 'yoffset','GLint' ))
glCopyMultiTexSubImage3DEXT.add( Input( 'zoffset','GLint' ))
glCopyMultiTexSubImage3DEXT.add( Input( 'x','GLint' ))
glCopyMultiTexSubImage3DEXT.add( Input( 'y','GLint' ))
glCopyMultiTexSubImage3DEXT.add( Input( 'width','GLsizei' ))
glCopyMultiTexSubImage3DEXT.add( Input( 'height','GLsizei' ))
glCopyMultiTexSubImage3DEXT.version = '1.2'
glCopyMultiTexSubImage3DEXT.category = 'GL_EXT_direct_state_access'
glCopyMultiTexSubImage3DEXT.trace = True
glCopyMultiTexSubImage3DEXT.play = True
gl.add(glCopyMultiTexSubImage3DEXT)

glCopyTextureImage1DEXT = Function('glCopyTextureImage1DEXT')
glCopyTextureImage1DEXT.ret = Return('void')
glCopyTextureImage1DEXT.add( Input( 'texture','GLuint' ))
glCopyTextureImage1DEXT.add( Input( 'target','GLenum' ))
glCopyTextureImage1DEXT.add( Input( 'level','GLint' ))
glCopyTextureImage1DEXT.add( Input( 'internalformat','GLenum' ))
glCopyTextureImage1DEXT.add( Input( 'x','GLint' ))
glCopyTextureImage1DEXT.add( Input( 'y','GLint' ))
glCopyTextureImage1DEXT.add( Input( 'width','GLsizei' ))
glCopyTextureImage1DEXT.add( Input( 'border','GLint' ))
glCopyTextureImage1DEXT.version = '1.1'
glCopyTextureImage1DEXT.category = 'GL_EXT_direct_state_access'
glCopyTextureImage1DEXT.trace = True
glCopyTextureImage1DEXT.play = True
gl.add(glCopyTextureImage1DEXT)

glCopyTextureImage2DEXT = Function('glCopyTextureImage2DEXT')
glCopyTextureImage2DEXT.ret = Return('void')
glCopyTextureImage2DEXT.add( Input( 'texture','GLuint' ))
glCopyTextureImage2DEXT.add( Input( 'target','GLenum' ))
glCopyTextureImage2DEXT.add( Input( 'level','GLint' ))
glCopyTextureImage2DEXT.add( Input( 'internalformat','GLenum' ))
glCopyTextureImage2DEXT.add( Input( 'x','GLint' ))
glCopyTextureImage2DEXT.add( Input( 'y','GLint' ))
glCopyTextureImage2DEXT.add( Input( 'width','GLsizei' ))
glCopyTextureImage2DEXT.add( Input( 'height','GLsizei' ))
glCopyTextureImage2DEXT.add( Input( 'border','GLint' ))
glCopyTextureImage2DEXT.version = '1.1'
glCopyTextureImage2DEXT.category = 'GL_EXT_direct_state_access'
glCopyTextureImage2DEXT.trace = True
glCopyTextureImage2DEXT.play = True
gl.add(glCopyTextureImage2DEXT)

glCopyTextureSubImage1DEXT = Function('glCopyTextureSubImage1DEXT')
glCopyTextureSubImage1DEXT.ret = Return('void')
glCopyTextureSubImage1DEXT.add( Input( 'texture','GLuint' ))
glCopyTextureSubImage1DEXT.add( Input( 'target','GLenum' ))
glCopyTextureSubImage1DEXT.add( Input( 'level','GLint' ))
glCopyTextureSubImage1DEXT.add( Input( 'xoffset','GLint' ))
glCopyTextureSubImage1DEXT.add( Input( 'x','GLint' ))
glCopyTextureSubImage1DEXT.add( Input( 'y','GLint' ))
glCopyTextureSubImage1DEXT.add( Input( 'width','GLsizei' ))
glCopyTextureSubImage1DEXT.version = '1.1'
glCopyTextureSubImage1DEXT.category = 'GL_EXT_direct_state_access'
glCopyTextureSubImage1DEXT.trace = True
glCopyTextureSubImage1DEXT.play = True
gl.add(glCopyTextureSubImage1DEXT)

glCopyTextureSubImage2DEXT = Function('glCopyTextureSubImage2DEXT')
glCopyTextureSubImage2DEXT.ret = Return('void')
glCopyTextureSubImage2DEXT.add( Input( 'texture','GLuint' ))
glCopyTextureSubImage2DEXT.add( Input( 'target','GLenum' ))
glCopyTextureSubImage2DEXT.add( Input( 'level','GLint' ))
glCopyTextureSubImage2DEXT.add( Input( 'xoffset','GLint' ))
glCopyTextureSubImage2DEXT.add( Input( 'yoffset','GLint' ))
glCopyTextureSubImage2DEXT.add( Input( 'x','GLint' ))
glCopyTextureSubImage2DEXT.add( Input( 'y','GLint' ))
glCopyTextureSubImage2DEXT.add( Input( 'width','GLsizei' ))
glCopyTextureSubImage2DEXT.add( Input( 'height','GLsizei' ))
glCopyTextureSubImage2DEXT.version = '1.1'
glCopyTextureSubImage2DEXT.category = 'GL_EXT_direct_state_access'
glCopyTextureSubImage2DEXT.trace = True
glCopyTextureSubImage2DEXT.play = True
gl.add(glCopyTextureSubImage2DEXT)

glCopyTextureSubImage3DEXT = Function('glCopyTextureSubImage3DEXT')
glCopyTextureSubImage3DEXT.ret = Return('void')
glCopyTextureSubImage3DEXT.add( Input( 'texture','GLuint' ))
glCopyTextureSubImage3DEXT.add( Input( 'target','GLenum' ))
glCopyTextureSubImage3DEXT.add( Input( 'level','GLint' ))
glCopyTextureSubImage3DEXT.add( Input( 'xoffset','GLint' ))
glCopyTextureSubImage3DEXT.add( Input( 'yoffset','GLint' ))
glCopyTextureSubImage3DEXT.add( Input( 'zoffset','GLint' ))
glCopyTextureSubImage3DEXT.add( Input( 'x','GLint' ))
glCopyTextureSubImage3DEXT.add( Input( 'y','GLint' ))
glCopyTextureSubImage3DEXT.add( Input( 'width','GLsizei' ))
glCopyTextureSubImage3DEXT.add( Input( 'height','GLsizei' ))
glCopyTextureSubImage3DEXT.version = '1.2'
glCopyTextureSubImage3DEXT.category = 'GL_EXT_direct_state_access'
glCopyTextureSubImage3DEXT.trace = True
glCopyTextureSubImage3DEXT.play = True
gl.add(glCopyTextureSubImage3DEXT)

glDisableClientStateIndexedEXT = Function('glDisableClientStateIndexedEXT')
glDisableClientStateIndexedEXT.ret = Return('void')
glDisableClientStateIndexedEXT.add( Input( 'array','GLenum' ))
glDisableClientStateIndexedEXT.add( Input( 'index','GLuint' ))
glDisableClientStateIndexedEXT.version = '1.1'
glDisableClientStateIndexedEXT.category = 'GL_EXT_direct_state_access'
glDisableClientStateIndexedEXT.trace = True
glDisableClientStateIndexedEXT.play = True
gl.add(glDisableClientStateIndexedEXT)

glDisableClientStateiEXT = Function('glDisableClientStateiEXT')
glDisableClientStateiEXT.ret = Return('void')
glDisableClientStateiEXT.add( Input( 'array','GLenum' ))
glDisableClientStateiEXT.add( Input( 'index','GLuint' ))
glDisableClientStateiEXT.version = '1.1'
glDisableClientStateiEXT.category = 'GL_EXT_direct_state_access'
glDisableClientStateiEXT.trace = True
glDisableClientStateiEXT.play = True
gl.add(glDisableClientStateiEXT)

glDisableVertexArrayAttribEXT = Function('glDisableVertexArrayAttribEXT')
glDisableVertexArrayAttribEXT.ret = Return('void')
glDisableVertexArrayAttribEXT.add( Input( 'vaobj','GLuint' ))
glDisableVertexArrayAttribEXT.add( Input( 'array','GLenum' ))
glDisableVertexArrayAttribEXT.version = '3.0'
glDisableVertexArrayAttribEXT.category = 'GL_EXT_direct_state_access'
glDisableVertexArrayAttribEXT.trace = True
glDisableVertexArrayAttribEXT.play = True
gl.add(glDisableVertexArrayAttribEXT)

glDisableVertexArrayEXT = Function('glDisableVertexArrayEXT')
glDisableVertexArrayEXT.ret = Return('void')
glDisableVertexArrayEXT.add( Input( 'vaobj','GLuint' ))
glDisableVertexArrayEXT.add( Input( 'array','GLenum' ))
glDisableVertexArrayEXT.version = '3.0'
glDisableVertexArrayEXT.category = 'GL_EXT_direct_state_access'
glDisableVertexArrayEXT.trace = True
glDisableVertexArrayEXT.play = True
gl.add(glDisableVertexArrayEXT)

glEnableClientStateIndexedEXT = Function('glEnableClientStateIndexedEXT')
glEnableClientStateIndexedEXT.ret = Return('void')
glEnableClientStateIndexedEXT.add( Input( 'array','GLenum' ))
glEnableClientStateIndexedEXT.add( Input( 'index','GLuint' ))
glEnableClientStateIndexedEXT.version = '1.1'
glEnableClientStateIndexedEXT.category = 'GL_EXT_direct_state_access'
glEnableClientStateIndexedEXT.trace = True
glEnableClientStateIndexedEXT.play = True
gl.add(glEnableClientStateIndexedEXT)

glEnableClientStateiEXT = Function('glEnableClientStateiEXT')
glEnableClientStateiEXT.ret = Return('void')
glEnableClientStateiEXT.add( Input( 'array','GLenum' ))
glEnableClientStateiEXT.add( Input( 'index','GLuint' ))
glEnableClientStateiEXT.version = '1.1'
glEnableClientStateiEXT.category = 'GL_EXT_direct_state_access'
glEnableClientStateiEXT.trace = True
glEnableClientStateiEXT.play = True
gl.add(glEnableClientStateiEXT)

glEnableVertexArrayAttribEXT = Function('glEnableVertexArrayAttribEXT')
glEnableVertexArrayAttribEXT.ret = Return('void')
glEnableVertexArrayAttribEXT.add( Input( 'vaobj','GLuint' ))
glEnableVertexArrayAttribEXT.add( Input( 'array','GLenum' ))
glEnableVertexArrayAttribEXT.version = '3.0'
glEnableVertexArrayAttribEXT.category = 'GL_EXT_direct_state_access'
glEnableVertexArrayAttribEXT.trace = True
glEnableVertexArrayAttribEXT.play = True
gl.add(glEnableVertexArrayAttribEXT)

glEnableVertexArrayEXT = Function('glEnableVertexArrayEXT')
glEnableVertexArrayEXT.ret = Return('void')
glEnableVertexArrayEXT.add( Input( 'vaobj','GLuint' ))
glEnableVertexArrayEXT.add( Input( 'array','GLenum' ))
glEnableVertexArrayEXT.version = '3.0'
glEnableVertexArrayEXT.category = 'GL_EXT_direct_state_access'
glEnableVertexArrayEXT.trace = True
glEnableVertexArrayEXT.play = True
gl.add(glEnableVertexArrayEXT)

glFlushMappedNamedBufferRangeEXT = Function('glFlushMappedNamedBufferRangeEXT')
glFlushMappedNamedBufferRangeEXT.ret = Return('void')
glFlushMappedNamedBufferRangeEXT.add( Input( 'buffer','GLuint' ))
glFlushMappedNamedBufferRangeEXT.add( Input( 'offset','GLintptr' ))
glFlushMappedNamedBufferRangeEXT.add( Input( 'length','GLsizeiptr' ))
glFlushMappedNamedBufferRangeEXT.version = '3.0'
glFlushMappedNamedBufferRangeEXT.category = 'GL_EXT_direct_state_access'
glFlushMappedNamedBufferRangeEXT.trace = True
glFlushMappedNamedBufferRangeEXT.play = True
gl.add(glFlushMappedNamedBufferRangeEXT)

glFramebufferDrawBufferEXT = Function('glFramebufferDrawBufferEXT')
glFramebufferDrawBufferEXT.ret = Return('void')
glFramebufferDrawBufferEXT.add( Input( 'framebuffer','GLuint' ))
glFramebufferDrawBufferEXT.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glFramebufferDrawBufferEXT.version = '1.5'
glFramebufferDrawBufferEXT.category = 'GL_EXT_direct_state_access'
glFramebufferDrawBufferEXT.trace = True
glFramebufferDrawBufferEXT.play = True
gl.add(glFramebufferDrawBufferEXT)

glFramebufferDrawBuffersEXT = Function('glFramebufferDrawBuffersEXT')
glFramebufferDrawBuffersEXT.ret = Return('void')
glFramebufferDrawBuffersEXT.add( Input( 'framebuffer','GLuint' ))
glFramebufferDrawBuffersEXT.add( Input( 'n','GLsizei' ))
glFramebufferDrawBuffersEXT.add( Input( 'bufs','const GLenum *' ,size = 'n' ))
glFramebufferDrawBuffersEXT.version = '1.5'
glFramebufferDrawBuffersEXT.category = 'GL_EXT_direct_state_access'
glFramebufferDrawBuffersEXT.trace = True
glFramebufferDrawBuffersEXT.play = True
gl.add(glFramebufferDrawBuffersEXT)

glFramebufferReadBufferEXT = Function('glFramebufferReadBufferEXT')
glFramebufferReadBufferEXT.ret = Return('void')
glFramebufferReadBufferEXT.add( Input( 'framebuffer','GLuint' ))
glFramebufferReadBufferEXT.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glFramebufferReadBufferEXT.version = '1.5'
glFramebufferReadBufferEXT.category = 'GL_EXT_direct_state_access'
glFramebufferReadBufferEXT.trace = True
glFramebufferReadBufferEXT.play = True
gl.add(glFramebufferReadBufferEXT)

glGenerateMultiTexMipmapEXT = Function('glGenerateMultiTexMipmapEXT')
glGenerateMultiTexMipmapEXT.ret = Return('void')
glGenerateMultiTexMipmapEXT.add( Input( 'texunit','GLenum' ))
glGenerateMultiTexMipmapEXT.add( Input( 'target','GLenum' ))
glGenerateMultiTexMipmapEXT.version = '1.5'
glGenerateMultiTexMipmapEXT.category = 'GL_EXT_direct_state_access'
glGenerateMultiTexMipmapEXT.trace = True
glGenerateMultiTexMipmapEXT.play = True
gl.add(glGenerateMultiTexMipmapEXT)

glGenerateTextureMipmapEXT = Function('glGenerateTextureMipmapEXT')
glGenerateTextureMipmapEXT.ret = Return('void')
glGenerateTextureMipmapEXT.add( Input( 'texture','GLuint' ))
glGenerateTextureMipmapEXT.add( Input( 'target','GLenum' ))
glGenerateTextureMipmapEXT.version = '1.5'
glGenerateTextureMipmapEXT.category = 'GL_EXT_direct_state_access'
glGenerateTextureMipmapEXT.trace = True
glGenerateTextureMipmapEXT.play = True
gl.add(glGenerateTextureMipmapEXT)

glGetCompressedMultiTexImageEXT = Function('glGetCompressedMultiTexImageEXT')
glGetCompressedMultiTexImageEXT.ret = Return('void')
glGetCompressedMultiTexImageEXT.add( Input( 'texunit','GLenum' ))
glGetCompressedMultiTexImageEXT.add( Input( 'target','GLenum' ))
glGetCompressedMultiTexImageEXT.add( Input( 'lod','GLint' ))
glGetCompressedMultiTexImageEXT.add( Output( 'img','GLvoid *' ))
glGetCompressedMultiTexImageEXT.version = '1.3'
glGetCompressedMultiTexImageEXT.category = 'GL_EXT_direct_state_access'
glGetCompressedMultiTexImageEXT.trace = True
glGetCompressedMultiTexImageEXT.play = True
gl.add(glGetCompressedMultiTexImageEXT)

glGetCompressedTextureImageEXT = Function('glGetCompressedTextureImageEXT')
glGetCompressedTextureImageEXT.ret = Return('void')
glGetCompressedTextureImageEXT.add( Input( 'texture','GLuint' ))
glGetCompressedTextureImageEXT.add( Input( 'target','GLenum' ))
glGetCompressedTextureImageEXT.add( Input( 'lod','GLint' ))
glGetCompressedTextureImageEXT.add( Output( 'img','GLvoid *' ))
glGetCompressedTextureImageEXT.version = '1.3'
glGetCompressedTextureImageEXT.category = 'GL_EXT_direct_state_access'
glGetCompressedTextureImageEXT.trace = True
glGetCompressedTextureImageEXT.play = True
gl.add(glGetCompressedTextureImageEXT)

glGetDoubleIndexedvEXT = Function('glGetDoubleIndexedvEXT')
glGetDoubleIndexedvEXT.ret = Return('void')
glGetDoubleIndexedvEXT.add( Input( 'target','GLenum' ))
glGetDoubleIndexedvEXT.add( Input( 'index','GLuint' ))
glGetDoubleIndexedvEXT.add( Output( 'data','GLdouble *' ))
glGetDoubleIndexedvEXT.version = '2.0'
glGetDoubleIndexedvEXT.category = 'GL_EXT_direct_state_access'
glGetDoubleIndexedvEXT.trace = True
glGetDoubleIndexedvEXT.play = True
gl.add(glGetDoubleIndexedvEXT)

glGetDoublei_vEXT = Function('glGetDoublei_vEXT')
glGetDoublei_vEXT.ret = Return('void')
glGetDoublei_vEXT.add( Input( 'target','GLenum' ))
glGetDoublei_vEXT.add( Input( 'index','GLuint' ))
glGetDoublei_vEXT.add( Output( 'data','GLdouble *' ))
glGetDoublei_vEXT.version = '2.0'
glGetDoublei_vEXT.category = 'GL_EXT_direct_state_access'
glGetDoublei_vEXT.trace = True
glGetDoublei_vEXT.play = True
gl.add(glGetDoublei_vEXT)

glGetFloatIndexedvEXT = Function('glGetFloatIndexedvEXT')
glGetFloatIndexedvEXT.ret = Return('void')
glGetFloatIndexedvEXT.add( Input( 'target','GLenum' ))
glGetFloatIndexedvEXT.add( Input( 'index','GLuint' ))
glGetFloatIndexedvEXT.add( Output( 'data','GLfloat *' ))
glGetFloatIndexedvEXT.version = '2.0'
glGetFloatIndexedvEXT.category = 'GL_EXT_direct_state_access'
glGetFloatIndexedvEXT.trace = True
glGetFloatIndexedvEXT.play = True
gl.add(glGetFloatIndexedvEXT)

glGetFloati_vEXT = Function('glGetFloati_vEXT')
glGetFloati_vEXT.ret = Return('void')
glGetFloati_vEXT.add( Input( 'target','GLenum' ))
glGetFloati_vEXT.add( Input( 'index','GLuint' ))
glGetFloati_vEXT.add( Output( 'data','GLfloat *' ))
glGetFloati_vEXT.version = '2.0'
glGetFloati_vEXT.category = 'GL_EXT_direct_state_access'
glGetFloati_vEXT.trace = True
glGetFloati_vEXT.play = True
gl.add(glGetFloati_vEXT)

glGetFramebufferParameterivEXT = Function('glGetFramebufferParameterivEXT')
glGetFramebufferParameterivEXT.ret = Return('void')
glGetFramebufferParameterivEXT.add( Input( 'framebuffer','GLuint' ))
glGetFramebufferParameterivEXT.add( Input( 'pname','GLenum' ))
glGetFramebufferParameterivEXT.add( Output( 'params','GLint *' ))
glGetFramebufferParameterivEXT.version = '1.5'
glGetFramebufferParameterivEXT.category = 'GL_EXT_direct_state_access'
glGetFramebufferParameterivEXT.trace = True
glGetFramebufferParameterivEXT.play = True
gl.add(glGetFramebufferParameterivEXT)

glGetMultiTexEnvfvEXT = Function('glGetMultiTexEnvfvEXT')
glGetMultiTexEnvfvEXT.ret = Return('void')
glGetMultiTexEnvfvEXT.add( Input( 'texunit','GLenum' ))
glGetMultiTexEnvfvEXT.add( Input( 'target','GLenum' ))
glGetMultiTexEnvfvEXT.add( Input( 'pname','GLenum' ))
glGetMultiTexEnvfvEXT.add( Output( 'params','GLfloat *' ))
glGetMultiTexEnvfvEXT.version = '1.3'
glGetMultiTexEnvfvEXT.category = 'GL_EXT_direct_state_access'
glGetMultiTexEnvfvEXT.trace = True
glGetMultiTexEnvfvEXT.play = True
gl.add(glGetMultiTexEnvfvEXT)

glGetMultiTexEnvivEXT = Function('glGetMultiTexEnvivEXT')
glGetMultiTexEnvivEXT.ret = Return('void')
glGetMultiTexEnvivEXT.add( Input( 'texunit','GLenum' ))
glGetMultiTexEnvivEXT.add( Input( 'target','GLenum' ))
glGetMultiTexEnvivEXT.add( Input( 'pname','GLenum' ))
glGetMultiTexEnvivEXT.add( Output( 'params','GLint *' ))
glGetMultiTexEnvivEXT.version = '1.3'
glGetMultiTexEnvivEXT.category = 'GL_EXT_direct_state_access'
glGetMultiTexEnvivEXT.trace = True
glGetMultiTexEnvivEXT.play = True
gl.add(glGetMultiTexEnvivEXT)

glGetMultiTexGendvEXT = Function('glGetMultiTexGendvEXT')
glGetMultiTexGendvEXT.ret = Return('void')
glGetMultiTexGendvEXT.add( Input( 'texunit','GLenum' ))
glGetMultiTexGendvEXT.add( Input( 'coord','GLenum' ))
glGetMultiTexGendvEXT.add( Input( 'pname','GLenum' ))
glGetMultiTexGendvEXT.add( Output( 'params','GLdouble *' ))
glGetMultiTexGendvEXT.version = '1.3'
glGetMultiTexGendvEXT.category = 'GL_EXT_direct_state_access'
glGetMultiTexGendvEXT.trace = True
glGetMultiTexGendvEXT.play = True
gl.add(glGetMultiTexGendvEXT)

glGetMultiTexGenfvEXT = Function('glGetMultiTexGenfvEXT')
glGetMultiTexGenfvEXT.ret = Return('void')
glGetMultiTexGenfvEXT.add( Input( 'texunit','GLenum' ))
glGetMultiTexGenfvEXT.add( Input( 'coord','GLenum' ))
glGetMultiTexGenfvEXT.add( Input( 'pname','GLenum' ))
glGetMultiTexGenfvEXT.add( Output( 'params','GLfloat *' ))
glGetMultiTexGenfvEXT.version = '1.3'
glGetMultiTexGenfvEXT.category = 'GL_EXT_direct_state_access'
glGetMultiTexGenfvEXT.trace = True
glGetMultiTexGenfvEXT.play = True
gl.add(glGetMultiTexGenfvEXT)

glGetMultiTexGenivEXT = Function('glGetMultiTexGenivEXT')
glGetMultiTexGenivEXT.ret = Return('void')
glGetMultiTexGenivEXT.add( Input( 'texunit','GLenum' ))
glGetMultiTexGenivEXT.add( Input( 'coord','GLenum' ))
glGetMultiTexGenivEXT.add( Input( 'pname','GLenum' ))
glGetMultiTexGenivEXT.add( Output( 'params','GLint *' ))
glGetMultiTexGenivEXT.version = '1.3'
glGetMultiTexGenivEXT.category = 'GL_EXT_direct_state_access'
glGetMultiTexGenivEXT.trace = True
glGetMultiTexGenivEXT.play = True
gl.add(glGetMultiTexGenivEXT)

glGetMultiTexImageEXT = Function('glGetMultiTexImageEXT')
glGetMultiTexImageEXT.ret = Return('void')
glGetMultiTexImageEXT.add( Input( 'texunit','GLenum' ))
glGetMultiTexImageEXT.add( Input( 'target','GLenum' ))
glGetMultiTexImageEXT.add( Input( 'level','GLint' ))
glGetMultiTexImageEXT.add( Input( 'format','GLenum' ))
glGetMultiTexImageEXT.add( Input( 'type','GLenum' ))
glGetMultiTexImageEXT.add( Output( 'pixels','GLvoid *' ))
glGetMultiTexImageEXT.version = '1.1'
glGetMultiTexImageEXT.category = 'GL_EXT_direct_state_access'
glGetMultiTexImageEXT.trace = True
glGetMultiTexImageEXT.play = True
gl.add(glGetMultiTexImageEXT)

glGetMultiTexLevelParameterfvEXT = Function('glGetMultiTexLevelParameterfvEXT')
glGetMultiTexLevelParameterfvEXT.ret = Return('void')
glGetMultiTexLevelParameterfvEXT.add( Input( 'texunit','GLenum' ))
glGetMultiTexLevelParameterfvEXT.add( Input( 'target','GLenum' ))
glGetMultiTexLevelParameterfvEXT.add( Input( 'level','GLint' ))
glGetMultiTexLevelParameterfvEXT.add( Input( 'pname','GLenum' ))
glGetMultiTexLevelParameterfvEXT.add( Output( 'params','GLfloat *' ))
glGetMultiTexLevelParameterfvEXT.version = '1.1'
glGetMultiTexLevelParameterfvEXT.category = 'GL_EXT_direct_state_access'
glGetMultiTexLevelParameterfvEXT.trace = True
glGetMultiTexLevelParameterfvEXT.play = True
gl.add(glGetMultiTexLevelParameterfvEXT)

glGetMultiTexLevelParameterivEXT = Function('glGetMultiTexLevelParameterivEXT')
glGetMultiTexLevelParameterivEXT.ret = Return('void')
glGetMultiTexLevelParameterivEXT.add( Input( 'texunit','GLenum' ))
glGetMultiTexLevelParameterivEXT.add( Input( 'target','GLenum' ))
glGetMultiTexLevelParameterivEXT.add( Input( 'level','GLint' ))
glGetMultiTexLevelParameterivEXT.add( Input( 'pname','GLenum' ))
glGetMultiTexLevelParameterivEXT.add( Output( 'params','GLint *' ))
glGetMultiTexLevelParameterivEXT.version = '1.1'
glGetMultiTexLevelParameterivEXT.category = 'GL_EXT_direct_state_access'
glGetMultiTexLevelParameterivEXT.trace = True
glGetMultiTexLevelParameterivEXT.play = True
gl.add(glGetMultiTexLevelParameterivEXT)

glGetMultiTexParameterIivEXT = Function('glGetMultiTexParameterIivEXT')
glGetMultiTexParameterIivEXT.ret = Return('void')
glGetMultiTexParameterIivEXT.add( Input( 'texunit','GLenum' ))
glGetMultiTexParameterIivEXT.add( Input( 'target','GLenum' ))
glGetMultiTexParameterIivEXT.add( Input( 'pname','GLenum' ))
glGetMultiTexParameterIivEXT.add( Output( 'params','GLint *' ))
glGetMultiTexParameterIivEXT.version = '1.1'
glGetMultiTexParameterIivEXT.category = 'GL_EXT_direct_state_access'
glGetMultiTexParameterIivEXT.trace = True
glGetMultiTexParameterIivEXT.play = True
gl.add(glGetMultiTexParameterIivEXT)

glGetMultiTexParameterIuivEXT = Function('glGetMultiTexParameterIuivEXT')
glGetMultiTexParameterIuivEXT.ret = Return('void')
glGetMultiTexParameterIuivEXT.add( Input( 'texunit','GLenum' ))
glGetMultiTexParameterIuivEXT.add( Input( 'target','GLenum' ))
glGetMultiTexParameterIuivEXT.add( Input( 'pname','GLenum' ))
glGetMultiTexParameterIuivEXT.add( Output( 'params','GLuint *' ))
glGetMultiTexParameterIuivEXT.version = '1.1'
glGetMultiTexParameterIuivEXT.category = 'GL_EXT_direct_state_access'
glGetMultiTexParameterIuivEXT.trace = True
glGetMultiTexParameterIuivEXT.play = True
gl.add(glGetMultiTexParameterIuivEXT)

glGetMultiTexParameterfvEXT = Function('glGetMultiTexParameterfvEXT')
glGetMultiTexParameterfvEXT.ret = Return('void')
glGetMultiTexParameterfvEXT.add( Input( 'texunit','GLenum' ))
glGetMultiTexParameterfvEXT.add( Input( 'target','GLenum' ))
glGetMultiTexParameterfvEXT.add( Input( 'pname','GLenum' ))
glGetMultiTexParameterfvEXT.add( Output( 'params','GLfloat *' ))
glGetMultiTexParameterfvEXT.version = '1.1'
glGetMultiTexParameterfvEXT.category = 'GL_EXT_direct_state_access'
glGetMultiTexParameterfvEXT.trace = True
glGetMultiTexParameterfvEXT.play = True
gl.add(glGetMultiTexParameterfvEXT)

glGetMultiTexParameterivEXT = Function('glGetMultiTexParameterivEXT')
glGetMultiTexParameterivEXT.ret = Return('void')
glGetMultiTexParameterivEXT.add( Input( 'texunit','GLenum' ))
glGetMultiTexParameterivEXT.add( Input( 'target','GLenum' ))
glGetMultiTexParameterivEXT.add( Input( 'pname','GLenum' ))
glGetMultiTexParameterivEXT.add( Output( 'params','GLint *' ))
glGetMultiTexParameterivEXT.version = '1.1'
glGetMultiTexParameterivEXT.category = 'GL_EXT_direct_state_access'
glGetMultiTexParameterivEXT.trace = True
glGetMultiTexParameterivEXT.play = True
gl.add(glGetMultiTexParameterivEXT)

glGetNamedBufferParameterivEXT = Function('glGetNamedBufferParameterivEXT')
glGetNamedBufferParameterivEXT.ret = Return('void')
glGetNamedBufferParameterivEXT.add( Input( 'buffer','GLuint' ))
glGetNamedBufferParameterivEXT.add( Input( 'pname','GLenum' ))
glGetNamedBufferParameterivEXT.add( Output( 'params','GLint *' ))
glGetNamedBufferParameterivEXT.version = '1.5'
glGetNamedBufferParameterivEXT.category = 'GL_EXT_direct_state_access'
glGetNamedBufferParameterivEXT.trace = True
glGetNamedBufferParameterivEXT.play = True
gl.add(glGetNamedBufferParameterivEXT)

glGetNamedBufferPointervEXT = Function('glGetNamedBufferPointervEXT')
glGetNamedBufferPointervEXT.ret = Return('void')
glGetNamedBufferPointervEXT.add( Input( 'buffer','GLuint' ))
glGetNamedBufferPointervEXT.add( Input( 'pname','GLenum' ))
glGetNamedBufferPointervEXT.add( Output( 'params','GLvoid **' ))
glGetNamedBufferPointervEXT.version = '1.5'
glGetNamedBufferPointervEXT.category = 'GL_EXT_direct_state_access'
glGetNamedBufferPointervEXT.trace = True
glGetNamedBufferPointervEXT.play = True
gl.add(glGetNamedBufferPointervEXT)

glGetNamedBufferSubDataEXT = Function('glGetNamedBufferSubDataEXT')
glGetNamedBufferSubDataEXT.ret = Return('void')
glGetNamedBufferSubDataEXT.add( Input( 'buffer','GLuint' ))
glGetNamedBufferSubDataEXT.add( Input( 'offset','GLintptr' ))
glGetNamedBufferSubDataEXT.add( Input( 'size','GLsizeiptr' ))
glGetNamedBufferSubDataEXT.add( Output( 'data','GLvoid *' ))
glGetNamedBufferSubDataEXT.version = '1.5'
glGetNamedBufferSubDataEXT.category = 'GL_EXT_direct_state_access'
glGetNamedBufferSubDataEXT.trace = True
glGetNamedBufferSubDataEXT.play = True
gl.add(glGetNamedBufferSubDataEXT)

glGetNamedFramebufferAttachmentParameterivEXT = Function('glGetNamedFramebufferAttachmentParameterivEXT')
glGetNamedFramebufferAttachmentParameterivEXT.ret = Return('void')
glGetNamedFramebufferAttachmentParameterivEXT.add( Input( 'framebuffer','GLuint' ))
glGetNamedFramebufferAttachmentParameterivEXT.add( Input( 'attachment','GLenum' ))
glGetNamedFramebufferAttachmentParameterivEXT.add( Input( 'pname','GLenum' ))
glGetNamedFramebufferAttachmentParameterivEXT.add( Output( 'params','GLint *' ))
glGetNamedFramebufferAttachmentParameterivEXT.version = '1.5'
glGetNamedFramebufferAttachmentParameterivEXT.category = 'GL_EXT_direct_state_access'
glGetNamedFramebufferAttachmentParameterivEXT.trace = True
glGetNamedFramebufferAttachmentParameterivEXT.play = True
gl.add(glGetNamedFramebufferAttachmentParameterivEXT)

glGetNamedProgramLocalParameterIivEXT = Function('glGetNamedProgramLocalParameterIivEXT')
glGetNamedProgramLocalParameterIivEXT.ret = Return('void')
glGetNamedProgramLocalParameterIivEXT.add( Input( 'program','GLuint' ))
glGetNamedProgramLocalParameterIivEXT.add( Input( 'target','GLenum' ))
glGetNamedProgramLocalParameterIivEXT.add( Input( 'index','GLuint' ))
glGetNamedProgramLocalParameterIivEXT.add( Output( 'params','GLint *' ,size = 4 ))
glGetNamedProgramLocalParameterIivEXT.version = '1.3'
glGetNamedProgramLocalParameterIivEXT.category = 'GL_EXT_direct_state_access'
glGetNamedProgramLocalParameterIivEXT.trace = True
glGetNamedProgramLocalParameterIivEXT.play = True
gl.add(glGetNamedProgramLocalParameterIivEXT)

glGetNamedProgramLocalParameterIuivEXT = Function('glGetNamedProgramLocalParameterIuivEXT')
glGetNamedProgramLocalParameterIuivEXT.ret = Return('void')
glGetNamedProgramLocalParameterIuivEXT.add( Input( 'program','GLuint' ))
glGetNamedProgramLocalParameterIuivEXT.add( Input( 'target','GLenum' ))
glGetNamedProgramLocalParameterIuivEXT.add( Input( 'index','GLuint' ))
glGetNamedProgramLocalParameterIuivEXT.add( Output( 'params','GLuint *' ,size = 4 ))
glGetNamedProgramLocalParameterIuivEXT.version = '1.3'
glGetNamedProgramLocalParameterIuivEXT.category = 'GL_EXT_direct_state_access'
glGetNamedProgramLocalParameterIuivEXT.trace = True
glGetNamedProgramLocalParameterIuivEXT.play = True
gl.add(glGetNamedProgramLocalParameterIuivEXT)

glGetNamedProgramLocalParameterdvEXT = Function('glGetNamedProgramLocalParameterdvEXT')
glGetNamedProgramLocalParameterdvEXT.ret = Return('void')
glGetNamedProgramLocalParameterdvEXT.add( Input( 'program','GLuint' ))
glGetNamedProgramLocalParameterdvEXT.add( Input( 'target','GLenum' ))
glGetNamedProgramLocalParameterdvEXT.add( Input( 'index','GLuint' ))
glGetNamedProgramLocalParameterdvEXT.add( Output( 'params','GLdouble *' ,size = 4 ))
glGetNamedProgramLocalParameterdvEXT.version = '1.3'
glGetNamedProgramLocalParameterdvEXT.category = 'GL_EXT_direct_state_access'
glGetNamedProgramLocalParameterdvEXT.trace = True
glGetNamedProgramLocalParameterdvEXT.play = True
gl.add(glGetNamedProgramLocalParameterdvEXT)

glGetNamedProgramLocalParameterfvEXT = Function('glGetNamedProgramLocalParameterfvEXT')
glGetNamedProgramLocalParameterfvEXT.ret = Return('void')
glGetNamedProgramLocalParameterfvEXT.add( Input( 'program','GLuint' ))
glGetNamedProgramLocalParameterfvEXT.add( Input( 'target','GLenum' ))
glGetNamedProgramLocalParameterfvEXT.add( Input( 'index','GLuint' ))
glGetNamedProgramLocalParameterfvEXT.add( Output( 'params','GLfloat *' ,size = 4 ))
glGetNamedProgramLocalParameterfvEXT.version = '1.3'
glGetNamedProgramLocalParameterfvEXT.category = 'GL_EXT_direct_state_access'
glGetNamedProgramLocalParameterfvEXT.trace = True
glGetNamedProgramLocalParameterfvEXT.play = True
gl.add(glGetNamedProgramLocalParameterfvEXT)

glGetNamedProgramStringEXT = Function('glGetNamedProgramStringEXT')
glGetNamedProgramStringEXT.ret = Return('void')
glGetNamedProgramStringEXT.add( Input( 'program','GLuint' ))
glGetNamedProgramStringEXT.add( Input( 'target','GLenum' ))
glGetNamedProgramStringEXT.add( Input( 'pname','GLenum' ))
glGetNamedProgramStringEXT.add( Output( 'string','GLvoid *' ))
glGetNamedProgramStringEXT.version = '1.3'
glGetNamedProgramStringEXT.category = 'GL_EXT_direct_state_access'
glGetNamedProgramStringEXT.trace = True
glGetNamedProgramStringEXT.play = True
gl.add(glGetNamedProgramStringEXT)

glGetNamedProgramivEXT = Function('glGetNamedProgramivEXT')
glGetNamedProgramivEXT.ret = Return('void')
glGetNamedProgramivEXT.add( Input( 'program','GLuint' ))
glGetNamedProgramivEXT.add( Input( 'target','GLenum' ))
glGetNamedProgramivEXT.add( Input( 'pname','GLenum' ))
glGetNamedProgramivEXT.add( Output( 'params','GLint *' ,size = 1 ))
glGetNamedProgramivEXT.version = '1.3'
glGetNamedProgramivEXT.category = 'GL_EXT_direct_state_access'
glGetNamedProgramivEXT.trace = True
glGetNamedProgramivEXT.play = True
gl.add(glGetNamedProgramivEXT)

glGetNamedRenderbufferParameterivEXT = Function('glGetNamedRenderbufferParameterivEXT')
glGetNamedRenderbufferParameterivEXT.ret = Return('void')
glGetNamedRenderbufferParameterivEXT.add( Input( 'renderbuffer','GLuint' ))
glGetNamedRenderbufferParameterivEXT.add( Input( 'pname','GLenum' ))
glGetNamedRenderbufferParameterivEXT.add( Output( 'params','GLint *' ))
glGetNamedRenderbufferParameterivEXT.version = '1.5'
glGetNamedRenderbufferParameterivEXT.category = 'GL_EXT_direct_state_access'
glGetNamedRenderbufferParameterivEXT.trace = True
glGetNamedRenderbufferParameterivEXT.play = True
gl.add(glGetNamedRenderbufferParameterivEXT)

glGetPointerIndexedvEXT = Function('glGetPointerIndexedvEXT')
glGetPointerIndexedvEXT.ret = Return('void')
glGetPointerIndexedvEXT.add( Input( 'target','GLenum' ))
glGetPointerIndexedvEXT.add( Input( 'index','GLuint' ))
glGetPointerIndexedvEXT.add( Output( 'data','GLvoid **' ))
glGetPointerIndexedvEXT.version = '2.0'
glGetPointerIndexedvEXT.category = 'GL_EXT_direct_state_access'
glGetPointerIndexedvEXT.trace = True
glGetPointerIndexedvEXT.play = True
gl.add(glGetPointerIndexedvEXT)

glGetPointeri_vEXT = Function('glGetPointeri_vEXT')
glGetPointeri_vEXT.ret = Return('void')
glGetPointeri_vEXT.add( Input( 'pname','GLenum' ))
glGetPointeri_vEXT.add( Input( 'index','GLuint' ))
glGetPointeri_vEXT.add( Output( 'params','GLvoid **' ))
glGetPointeri_vEXT.version = '2.0'
glGetPointeri_vEXT.category = 'GL_EXT_direct_state_access'
glGetPointeri_vEXT.trace = True
glGetPointeri_vEXT.play = True
gl.add(glGetPointeri_vEXT)

glGetTextureImageEXT = Function('glGetTextureImageEXT')
glGetTextureImageEXT.ret = Return('void')
glGetTextureImageEXT.add( Input( 'texture','GLuint' ))
glGetTextureImageEXT.add( Input( 'target','GLenum' ))
glGetTextureImageEXT.add( Input( 'level','GLint' ))
glGetTextureImageEXT.add( Input( 'format','GLenum' ))
glGetTextureImageEXT.add( Input( 'type','GLenum' ))
glGetTextureImageEXT.add( Output( 'pixels','GLvoid *' ))
glGetTextureImageEXT.version = '1.1'
glGetTextureImageEXT.category = 'GL_EXT_direct_state_access'
glGetTextureImageEXT.trace = True
glGetTextureImageEXT.play = True
gl.add(glGetTextureImageEXT)

glGetTextureLevelParameterfvEXT = Function('glGetTextureLevelParameterfvEXT')
glGetTextureLevelParameterfvEXT.ret = Return('void')
glGetTextureLevelParameterfvEXT.add( Input( 'texture','GLuint' ))
glGetTextureLevelParameterfvEXT.add( Input( 'target','GLenum' ))
glGetTextureLevelParameterfvEXT.add( Input( 'level','GLint' ))
glGetTextureLevelParameterfvEXT.add( Input( 'pname','GLenum' ))
glGetTextureLevelParameterfvEXT.add( Output( 'params','GLfloat *' ))
glGetTextureLevelParameterfvEXT.version = '1.1'
glGetTextureLevelParameterfvEXT.category = 'GL_EXT_direct_state_access'
glGetTextureLevelParameterfvEXT.trace = True
glGetTextureLevelParameterfvEXT.play = True
gl.add(glGetTextureLevelParameterfvEXT)

glGetTextureLevelParameterivEXT = Function('glGetTextureLevelParameterivEXT')
glGetTextureLevelParameterivEXT.ret = Return('void')
glGetTextureLevelParameterivEXT.add( Input( 'texture','GLuint' ))
glGetTextureLevelParameterivEXT.add( Input( 'target','GLenum' ))
glGetTextureLevelParameterivEXT.add( Input( 'level','GLint' ))
glGetTextureLevelParameterivEXT.add( Input( 'pname','GLenum' ))
glGetTextureLevelParameterivEXT.add( Output( 'params','GLint *' ))
glGetTextureLevelParameterivEXT.version = '1.1'
glGetTextureLevelParameterivEXT.category = 'GL_EXT_direct_state_access'
glGetTextureLevelParameterivEXT.trace = True
glGetTextureLevelParameterivEXT.play = True
gl.add(glGetTextureLevelParameterivEXT)

glGetTextureParameterIivEXT = Function('glGetTextureParameterIivEXT')
glGetTextureParameterIivEXT.ret = Return('void')
glGetTextureParameterIivEXT.add( Input( 'texture','GLuint' ))
glGetTextureParameterIivEXT.add( Input( 'target','GLenum' ))
glGetTextureParameterIivEXT.add( Input( 'pname','GLenum' ))
glGetTextureParameterIivEXT.add( Output( 'params','GLint *' ))
glGetTextureParameterIivEXT.version = '1.1'
glGetTextureParameterIivEXT.category = 'GL_EXT_direct_state_access'
glGetTextureParameterIivEXT.trace = True
glGetTextureParameterIivEXT.play = True
gl.add(glGetTextureParameterIivEXT)

glGetTextureParameterIuivEXT = Function('glGetTextureParameterIuivEXT')
glGetTextureParameterIuivEXT.ret = Return('void')
glGetTextureParameterIuivEXT.add( Input( 'texture','GLuint' ))
glGetTextureParameterIuivEXT.add( Input( 'target','GLenum' ))
glGetTextureParameterIuivEXT.add( Input( 'pname','GLenum' ))
glGetTextureParameterIuivEXT.add( Output( 'params','GLuint *' ))
glGetTextureParameterIuivEXT.version = '1.1'
glGetTextureParameterIuivEXT.category = 'GL_EXT_direct_state_access'
glGetTextureParameterIuivEXT.trace = True
glGetTextureParameterIuivEXT.play = True
gl.add(glGetTextureParameterIuivEXT)

glGetTextureParameterfvEXT = Function('glGetTextureParameterfvEXT')
glGetTextureParameterfvEXT.ret = Return('void')
glGetTextureParameterfvEXT.add( Input( 'texture','GLuint' ))
glGetTextureParameterfvEXT.add( Input( 'target','GLenum' ))
glGetTextureParameterfvEXT.add( Input( 'pname','GLenum' ))
glGetTextureParameterfvEXT.add( Output( 'params','GLfloat *' ))
glGetTextureParameterfvEXT.version = '1.1'
glGetTextureParameterfvEXT.category = 'GL_EXT_direct_state_access'
glGetTextureParameterfvEXT.trace = True
glGetTextureParameterfvEXT.play = True
gl.add(glGetTextureParameterfvEXT)

glGetTextureParameterivEXT = Function('glGetTextureParameterivEXT')
glGetTextureParameterivEXT.ret = Return('void')
glGetTextureParameterivEXT.add( Input( 'texture','GLuint' ))
glGetTextureParameterivEXT.add( Input( 'target','GLenum' ))
glGetTextureParameterivEXT.add( Input( 'pname','GLenum' ))
glGetTextureParameterivEXT.add( Output( 'params','GLint *' ))
glGetTextureParameterivEXT.version = '1.1'
glGetTextureParameterivEXT.category = 'GL_EXT_direct_state_access'
glGetTextureParameterivEXT.trace = True
glGetTextureParameterivEXT.play = True
gl.add(glGetTextureParameterivEXT)

glGetVertexArrayIntegeri_vEXT = Function('glGetVertexArrayIntegeri_vEXT')
glGetVertexArrayIntegeri_vEXT.ret = Return('void')
glGetVertexArrayIntegeri_vEXT.add( Input( 'vaobj','GLuint' ))
glGetVertexArrayIntegeri_vEXT.add( Input( 'index','GLuint' ))
glGetVertexArrayIntegeri_vEXT.add( Input( 'pname','GLenum' ))
glGetVertexArrayIntegeri_vEXT.add( Output( 'param','GLint *' ))
glGetVertexArrayIntegeri_vEXT.version = '3.0'
glGetVertexArrayIntegeri_vEXT.category = 'GL_EXT_direct_state_access'
glGetVertexArrayIntegeri_vEXT.trace = True
glGetVertexArrayIntegeri_vEXT.play = True
gl.add(glGetVertexArrayIntegeri_vEXT)

glGetVertexArrayIntegervEXT = Function('glGetVertexArrayIntegervEXT')
glGetVertexArrayIntegervEXT.ret = Return('void')
glGetVertexArrayIntegervEXT.add( Input( 'vaobj','GLuint' ))
glGetVertexArrayIntegervEXT.add( Input( 'pname','GLenum' ))
glGetVertexArrayIntegervEXT.add( Output( 'param','GLint *' ))
glGetVertexArrayIntegervEXT.version = '3.0'
glGetVertexArrayIntegervEXT.category = 'GL_EXT_direct_state_access'
glGetVertexArrayIntegervEXT.trace = True
glGetVertexArrayIntegervEXT.play = True
gl.add(glGetVertexArrayIntegervEXT)

glGetVertexArrayPointeri_vEXT = Function('glGetVertexArrayPointeri_vEXT')
glGetVertexArrayPointeri_vEXT.ret = Return('void')
glGetVertexArrayPointeri_vEXT.add( Input( 'vaobj','GLuint' ))
glGetVertexArrayPointeri_vEXT.add( Input( 'index','GLuint' ))
glGetVertexArrayPointeri_vEXT.add( Input( 'pname','GLenum' ))
glGetVertexArrayPointeri_vEXT.add( Output( 'param','GLvoid **' ,size = 1 ))
glGetVertexArrayPointeri_vEXT.version = '3.0'
glGetVertexArrayPointeri_vEXT.category = 'GL_EXT_direct_state_access'
glGetVertexArrayPointeri_vEXT.trace = True
glGetVertexArrayPointeri_vEXT.play = True
gl.add(glGetVertexArrayPointeri_vEXT)

glGetVertexArrayPointervEXT = Function('glGetVertexArrayPointervEXT')
glGetVertexArrayPointervEXT.ret = Return('void')
glGetVertexArrayPointervEXT.add( Input( 'vaobj','GLuint' ))
glGetVertexArrayPointervEXT.add( Input( 'pname','GLenum' ))
glGetVertexArrayPointervEXT.add( Output( 'param','GLvoid **' ,size = 1 ))
glGetVertexArrayPointervEXT.version = '3.0'
glGetVertexArrayPointervEXT.category = 'GL_EXT_direct_state_access'
glGetVertexArrayPointervEXT.trace = True
glGetVertexArrayPointervEXT.play = True
gl.add(glGetVertexArrayPointervEXT)

glMapNamedBufferEXT = Function('glMapNamedBufferEXT')
glMapNamedBufferEXT.ret = Return('GLvoid *')
glMapNamedBufferEXT.add( Input( 'buffer','GLuint' ))
glMapNamedBufferEXT.add( Input( 'access','GLenum' ))
glMapNamedBufferEXT.version = '1.5'
glMapNamedBufferEXT.category = 'GL_EXT_direct_state_access'
glMapNamedBufferEXT.trace = True
glMapNamedBufferEXT.play = True
gl.add(glMapNamedBufferEXT)

glMapNamedBufferRangeEXT = Function('glMapNamedBufferRangeEXT')
glMapNamedBufferRangeEXT.ret = Return('GLvoid *')
glMapNamedBufferRangeEXT.add( Input( 'buffer','GLuint' ))
glMapNamedBufferRangeEXT.add( Input( 'offset','GLintptr' ))
glMapNamedBufferRangeEXT.add( Input( 'length','GLsizeiptr' ))
glMapNamedBufferRangeEXT.add( Input( 'access','GLbitfield' ,regalLog = 'GLmapBufferRangeToString(access)' ))
glMapNamedBufferRangeEXT.version = '3.0'
glMapNamedBufferRangeEXT.category = 'GL_EXT_direct_state_access'
glMapNamedBufferRangeEXT.trace = True
glMapNamedBufferRangeEXT.play = True
gl.add(glMapNamedBufferRangeEXT)

glMatrixFrustumEXT = Function('glMatrixFrustumEXT')
glMatrixFrustumEXT.ret = Return('void')
glMatrixFrustumEXT.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glMatrixFrustumEXT.add( Input( 'left','GLdouble' ))
glMatrixFrustumEXT.add( Input( 'right','GLdouble' ))
glMatrixFrustumEXT.add( Input( 'bottom','GLdouble' ))
glMatrixFrustumEXT.add( Input( 'top','GLdouble' ))
glMatrixFrustumEXT.add( Input( 'zNear','GLdouble' ))
glMatrixFrustumEXT.add( Input( 'zFar','GLdouble' ))
glMatrixFrustumEXT.version = '1.0'
glMatrixFrustumEXT.category = 'GL_EXT_direct_state_access'
glMatrixFrustumEXT.trace = True
glMatrixFrustumEXT.play = True
gl.add(glMatrixFrustumEXT)

glMatrixLoadIdentityEXT = Function('glMatrixLoadIdentityEXT')
glMatrixLoadIdentityEXT.ret = Return('void')
glMatrixLoadIdentityEXT.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glMatrixLoadIdentityEXT.version = '1.0'
glMatrixLoadIdentityEXT.category = 'GL_EXT_direct_state_access'
glMatrixLoadIdentityEXT.trace = True
glMatrixLoadIdentityEXT.play = True
gl.add(glMatrixLoadIdentityEXT)

glMatrixLoadTransposedEXT = Function('glMatrixLoadTransposedEXT')
glMatrixLoadTransposedEXT.ret = Return('void')
glMatrixLoadTransposedEXT.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glMatrixLoadTransposedEXT.add( Input( 'm','const GLdouble *' ,size = 16 ))
glMatrixLoadTransposedEXT.version = '1.3'
glMatrixLoadTransposedEXT.category = 'GL_EXT_direct_state_access'
glMatrixLoadTransposedEXT.trace = True
glMatrixLoadTransposedEXT.play = True
gl.add(glMatrixLoadTransposedEXT)

glMatrixLoadTransposefEXT = Function('glMatrixLoadTransposefEXT')
glMatrixLoadTransposefEXT.ret = Return('void')
glMatrixLoadTransposefEXT.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glMatrixLoadTransposefEXT.add( Input( 'm','const GLfloat *' ,size = 16 ))
glMatrixLoadTransposefEXT.version = '1.3'
glMatrixLoadTransposefEXT.category = 'GL_EXT_direct_state_access'
glMatrixLoadTransposefEXT.trace = True
glMatrixLoadTransposefEXT.play = True
gl.add(glMatrixLoadTransposefEXT)

glMatrixLoaddEXT = Function('glMatrixLoaddEXT')
glMatrixLoaddEXT.ret = Return('void')
glMatrixLoaddEXT.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glMatrixLoaddEXT.add( Input( 'm','const GLdouble *' ,size = 16 ))
glMatrixLoaddEXT.version = '1.0'
glMatrixLoaddEXT.category = 'GL_EXT_direct_state_access'
glMatrixLoaddEXT.trace = True
glMatrixLoaddEXT.play = True
gl.add(glMatrixLoaddEXT)

glMatrixLoadfEXT = Function('glMatrixLoadfEXT')
glMatrixLoadfEXT.ret = Return('void')
glMatrixLoadfEXT.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glMatrixLoadfEXT.add( Input( 'm','const GLfloat *' ,size = 16 ))
glMatrixLoadfEXT.version = '1.0'
glMatrixLoadfEXT.category = 'GL_EXT_direct_state_access'
glMatrixLoadfEXT.trace = True
glMatrixLoadfEXT.play = True
gl.add(glMatrixLoadfEXT)

glMatrixMultTransposedEXT = Function('glMatrixMultTransposedEXT')
glMatrixMultTransposedEXT.ret = Return('void')
glMatrixMultTransposedEXT.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glMatrixMultTransposedEXT.add( Input( 'm','const GLdouble *' ,size = 16 ))
glMatrixMultTransposedEXT.version = '1.3'
glMatrixMultTransposedEXT.category = 'GL_EXT_direct_state_access'
glMatrixMultTransposedEXT.trace = True
glMatrixMultTransposedEXT.play = True
gl.add(glMatrixMultTransposedEXT)

glMatrixMultTransposefEXT = Function('glMatrixMultTransposefEXT')
glMatrixMultTransposefEXT.ret = Return('void')
glMatrixMultTransposefEXT.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glMatrixMultTransposefEXT.add( Input( 'm','const GLfloat *' ,size = 16 ))
glMatrixMultTransposefEXT.version = '1.3'
glMatrixMultTransposefEXT.category = 'GL_EXT_direct_state_access'
glMatrixMultTransposefEXT.trace = True
glMatrixMultTransposefEXT.play = True
gl.add(glMatrixMultTransposefEXT)

glMatrixMultdEXT = Function('glMatrixMultdEXT')
glMatrixMultdEXT.ret = Return('void')
glMatrixMultdEXT.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glMatrixMultdEXT.add( Input( 'm','const GLdouble *' ,size = 16 ))
glMatrixMultdEXT.version = '1.0'
glMatrixMultdEXT.category = 'GL_EXT_direct_state_access'
glMatrixMultdEXT.trace = True
glMatrixMultdEXT.play = True
gl.add(glMatrixMultdEXT)

glMatrixMultfEXT = Function('glMatrixMultfEXT')
glMatrixMultfEXT.ret = Return('void')
glMatrixMultfEXT.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glMatrixMultfEXT.add( Input( 'm','const GLfloat *' ,size = 16 ))
glMatrixMultfEXT.version = '1.0'
glMatrixMultfEXT.category = 'GL_EXT_direct_state_access'
glMatrixMultfEXT.trace = True
glMatrixMultfEXT.play = True
gl.add(glMatrixMultfEXT)

glMatrixOrthoEXT = Function('glMatrixOrthoEXT')
glMatrixOrthoEXT.ret = Return('void')
glMatrixOrthoEXT.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glMatrixOrthoEXT.add( Input( 'left','GLdouble' ))
glMatrixOrthoEXT.add( Input( 'right','GLdouble' ))
glMatrixOrthoEXT.add( Input( 'bottom','GLdouble' ))
glMatrixOrthoEXT.add( Input( 'top','GLdouble' ))
glMatrixOrthoEXT.add( Input( 'zNear','GLdouble' ))
glMatrixOrthoEXT.add( Input( 'zFar','GLdouble' ))
glMatrixOrthoEXT.version = '1.0'
glMatrixOrthoEXT.category = 'GL_EXT_direct_state_access'
glMatrixOrthoEXT.trace = True
glMatrixOrthoEXT.play = True
gl.add(glMatrixOrthoEXT)

glMatrixPopEXT = Function('glMatrixPopEXT')
glMatrixPopEXT.ret = Return('void')
glMatrixPopEXT.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glMatrixPopEXT.version = '1.0'
glMatrixPopEXT.category = 'GL_EXT_direct_state_access'
glMatrixPopEXT.trace = True
glMatrixPopEXT.play = True
gl.add(glMatrixPopEXT)

glMatrixPushEXT = Function('glMatrixPushEXT')
glMatrixPushEXT.ret = Return('void')
glMatrixPushEXT.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glMatrixPushEXT.version = '1.0'
glMatrixPushEXT.category = 'GL_EXT_direct_state_access'
glMatrixPushEXT.trace = True
glMatrixPushEXT.play = True
gl.add(glMatrixPushEXT)

glMatrixRotatedEXT = Function('glMatrixRotatedEXT')
glMatrixRotatedEXT.ret = Return('void')
glMatrixRotatedEXT.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glMatrixRotatedEXT.add( Input( 'angle','GLdouble' ))
glMatrixRotatedEXT.add( Input( 'x','GLdouble' ))
glMatrixRotatedEXT.add( Input( 'y','GLdouble' ))
glMatrixRotatedEXT.add( Input( 'z','GLdouble' ))
glMatrixRotatedEXT.version = '1.0'
glMatrixRotatedEXT.category = 'GL_EXT_direct_state_access'
glMatrixRotatedEXT.trace = True
glMatrixRotatedEXT.play = True
gl.add(glMatrixRotatedEXT)

glMatrixRotatefEXT = Function('glMatrixRotatefEXT')
glMatrixRotatefEXT.ret = Return('void')
glMatrixRotatefEXT.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glMatrixRotatefEXT.add( Input( 'angle','GLfloat' ))
glMatrixRotatefEXT.add( Input( 'x','GLfloat' ))
glMatrixRotatefEXT.add( Input( 'y','GLfloat' ))
glMatrixRotatefEXT.add( Input( 'z','GLfloat' ))
glMatrixRotatefEXT.version = '1.0'
glMatrixRotatefEXT.category = 'GL_EXT_direct_state_access'
glMatrixRotatefEXT.trace = True
glMatrixRotatefEXT.play = True
gl.add(glMatrixRotatefEXT)

glMatrixScaledEXT = Function('glMatrixScaledEXT')
glMatrixScaledEXT.ret = Return('void')
glMatrixScaledEXT.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glMatrixScaledEXT.add( Input( 'x','GLdouble' ))
glMatrixScaledEXT.add( Input( 'y','GLdouble' ))
glMatrixScaledEXT.add( Input( 'z','GLdouble' ))
glMatrixScaledEXT.version = '1.0'
glMatrixScaledEXT.category = 'GL_EXT_direct_state_access'
glMatrixScaledEXT.trace = True
glMatrixScaledEXT.play = True
gl.add(glMatrixScaledEXT)

glMatrixScalefEXT = Function('glMatrixScalefEXT')
glMatrixScalefEXT.ret = Return('void')
glMatrixScalefEXT.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glMatrixScalefEXT.add( Input( 'x','GLfloat' ))
glMatrixScalefEXT.add( Input( 'y','GLfloat' ))
glMatrixScalefEXT.add( Input( 'z','GLfloat' ))
glMatrixScalefEXT.version = '1.0'
glMatrixScalefEXT.category = 'GL_EXT_direct_state_access'
glMatrixScalefEXT.trace = True
glMatrixScalefEXT.play = True
gl.add(glMatrixScalefEXT)

glMatrixTranslatedEXT = Function('glMatrixTranslatedEXT')
glMatrixTranslatedEXT.ret = Return('void')
glMatrixTranslatedEXT.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glMatrixTranslatedEXT.add( Input( 'x','GLdouble' ))
glMatrixTranslatedEXT.add( Input( 'y','GLdouble' ))
glMatrixTranslatedEXT.add( Input( 'z','GLdouble' ))
glMatrixTranslatedEXT.version = '1.0'
glMatrixTranslatedEXT.category = 'GL_EXT_direct_state_access'
glMatrixTranslatedEXT.trace = True
glMatrixTranslatedEXT.play = True
gl.add(glMatrixTranslatedEXT)

glMatrixTranslatefEXT = Function('glMatrixTranslatefEXT')
glMatrixTranslatefEXT.ret = Return('void')
glMatrixTranslatefEXT.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glMatrixTranslatefEXT.add( Input( 'x','GLfloat' ))
glMatrixTranslatefEXT.add( Input( 'y','GLfloat' ))
glMatrixTranslatefEXT.add( Input( 'z','GLfloat' ))
glMatrixTranslatefEXT.version = '1.0'
glMatrixTranslatefEXT.category = 'GL_EXT_direct_state_access'
glMatrixTranslatefEXT.trace = True
glMatrixTranslatefEXT.play = True
gl.add(glMatrixTranslatefEXT)

glMultiTexBufferEXT = Function('glMultiTexBufferEXT')
glMultiTexBufferEXT.ret = Return('void')
glMultiTexBufferEXT.add( Input( 'texunit','GLenum' ))
glMultiTexBufferEXT.add( Input( 'target','GLenum' ))
glMultiTexBufferEXT.add( Input( 'internalformat','GLenum' ))
glMultiTexBufferEXT.add( Input( 'buffer','GLuint' ))
glMultiTexBufferEXT.version = '2.0'
glMultiTexBufferEXT.category = 'GL_EXT_direct_state_access'
glMultiTexBufferEXT.trace = True
glMultiTexBufferEXT.play = True
gl.add(glMultiTexBufferEXT)

glMultiTexCoordPointerEXT = Function('glMultiTexCoordPointerEXT')
glMultiTexCoordPointerEXT.ret = Return('void')
glMultiTexCoordPointerEXT.add( Input( 'texunit','GLenum' ))
glMultiTexCoordPointerEXT.add( Input( 'size','GLint' ))
glMultiTexCoordPointerEXT.add( Input( 'type','GLenum' ))
glMultiTexCoordPointerEXT.add( Input( 'stride','GLsizei' ))
glMultiTexCoordPointerEXT.add( Input( 'pointer','const GLvoid *' ))
glMultiTexCoordPointerEXT.version = '1.1'
glMultiTexCoordPointerEXT.category = 'GL_EXT_direct_state_access'
glMultiTexCoordPointerEXT.trace = True
glMultiTexCoordPointerEXT.play = True
gl.add(glMultiTexCoordPointerEXT)

glMultiTexEnvfEXT = Function('glMultiTexEnvfEXT')
glMultiTexEnvfEXT.ret = Return('void')
glMultiTexEnvfEXT.add( Input( 'texunit','GLenum' ))
glMultiTexEnvfEXT.add( Input( 'target','GLenum' ))
glMultiTexEnvfEXT.add( Input( 'pname','GLenum' ))
glMultiTexEnvfEXT.add( Input( 'param','GLfloat' ))
glMultiTexEnvfEXT.version = '1.3'
glMultiTexEnvfEXT.category = 'GL_EXT_direct_state_access'
glMultiTexEnvfEXT.trace = True
glMultiTexEnvfEXT.play = True
gl.add(glMultiTexEnvfEXT)

glMultiTexEnvfvEXT = Function('glMultiTexEnvfvEXT')
glMultiTexEnvfvEXT.ret = Return('void')
glMultiTexEnvfvEXT.add( Input( 'texunit','GLenum' ))
glMultiTexEnvfvEXT.add( Input( 'target','GLenum' ))
glMultiTexEnvfvEXT.add( Input( 'pname','GLenum' ))
glMultiTexEnvfvEXT.add( Input( 'params','const GLfloat *' ))
glMultiTexEnvfvEXT.version = '1.3'
glMultiTexEnvfvEXT.category = 'GL_EXT_direct_state_access'
glMultiTexEnvfvEXT.trace = True
glMultiTexEnvfvEXT.play = True
gl.add(glMultiTexEnvfvEXT)

glMultiTexEnviEXT = Function('glMultiTexEnviEXT')
glMultiTexEnviEXT.ret = Return('void')
glMultiTexEnviEXT.add( Input( 'texunit','GLenum' ))
glMultiTexEnviEXT.add( Input( 'target','GLenum' ))
glMultiTexEnviEXT.add( Input( 'pname','GLenum' ))
glMultiTexEnviEXT.add( Input( 'param','GLint' ))
glMultiTexEnviEXT.version = '1.3'
glMultiTexEnviEXT.category = 'GL_EXT_direct_state_access'
glMultiTexEnviEXT.trace = True
glMultiTexEnviEXT.play = True
gl.add(glMultiTexEnviEXT)

glMultiTexEnvivEXT = Function('glMultiTexEnvivEXT')
glMultiTexEnvivEXT.ret = Return('void')
glMultiTexEnvivEXT.add( Input( 'texunit','GLenum' ))
glMultiTexEnvivEXT.add( Input( 'target','GLenum' ))
glMultiTexEnvivEXT.add( Input( 'pname','GLenum' ))
glMultiTexEnvivEXT.add( Input( 'params','const GLint *' ))
glMultiTexEnvivEXT.version = '1.3'
glMultiTexEnvivEXT.category = 'GL_EXT_direct_state_access'
glMultiTexEnvivEXT.trace = True
glMultiTexEnvivEXT.play = True
gl.add(glMultiTexEnvivEXT)

glMultiTexGendEXT = Function('glMultiTexGendEXT')
glMultiTexGendEXT.ret = Return('void')
glMultiTexGendEXT.add( Input( 'texunit','GLenum' ))
glMultiTexGendEXT.add( Input( 'coord','GLenum' ))
glMultiTexGendEXT.add( Input( 'pname','GLenum' ))
glMultiTexGendEXT.add( Input( 'param','GLdouble' ))
glMultiTexGendEXT.version = '1.3'
glMultiTexGendEXT.category = 'GL_EXT_direct_state_access'
glMultiTexGendEXT.trace = True
glMultiTexGendEXT.play = True
gl.add(glMultiTexGendEXT)

glMultiTexGendvEXT = Function('glMultiTexGendvEXT')
glMultiTexGendvEXT.ret = Return('void')
glMultiTexGendvEXT.add( Input( 'texunit','GLenum' ))
glMultiTexGendvEXT.add( Input( 'coord','GLenum' ))
glMultiTexGendvEXT.add( Input( 'pname','GLenum' ))
glMultiTexGendvEXT.add( Input( 'params','const GLdouble *' ))
glMultiTexGendvEXT.version = '1.3'
glMultiTexGendvEXT.category = 'GL_EXT_direct_state_access'
glMultiTexGendvEXT.trace = True
glMultiTexGendvEXT.play = True
gl.add(glMultiTexGendvEXT)

glMultiTexGenfEXT = Function('glMultiTexGenfEXT')
glMultiTexGenfEXT.ret = Return('void')
glMultiTexGenfEXT.add( Input( 'texunit','GLenum' ))
glMultiTexGenfEXT.add( Input( 'coord','GLenum' ))
glMultiTexGenfEXT.add( Input( 'pname','GLenum' ))
glMultiTexGenfEXT.add( Input( 'param','GLfloat' ))
glMultiTexGenfEXT.version = '1.3'
glMultiTexGenfEXT.category = 'GL_EXT_direct_state_access'
glMultiTexGenfEXT.trace = True
glMultiTexGenfEXT.play = True
gl.add(glMultiTexGenfEXT)

glMultiTexGenfvEXT = Function('glMultiTexGenfvEXT')
glMultiTexGenfvEXT.ret = Return('void')
glMultiTexGenfvEXT.add( Input( 'texunit','GLenum' ))
glMultiTexGenfvEXT.add( Input( 'coord','GLenum' ))
glMultiTexGenfvEXT.add( Input( 'pname','GLenum' ))
glMultiTexGenfvEXT.add( Input( 'params','const GLfloat *' ))
glMultiTexGenfvEXT.version = '1.3'
glMultiTexGenfvEXT.category = 'GL_EXT_direct_state_access'
glMultiTexGenfvEXT.trace = True
glMultiTexGenfvEXT.play = True
gl.add(glMultiTexGenfvEXT)

glMultiTexGeniEXT = Function('glMultiTexGeniEXT')
glMultiTexGeniEXT.ret = Return('void')
glMultiTexGeniEXT.add( Input( 'texunit','GLenum' ))
glMultiTexGeniEXT.add( Input( 'coord','GLenum' ))
glMultiTexGeniEXT.add( Input( 'pname','GLenum' ))
glMultiTexGeniEXT.add( Input( 'param','GLint' ))
glMultiTexGeniEXT.version = '1.3'
glMultiTexGeniEXT.category = 'GL_EXT_direct_state_access'
glMultiTexGeniEXT.trace = True
glMultiTexGeniEXT.play = True
gl.add(glMultiTexGeniEXT)

glMultiTexGenivEXT = Function('glMultiTexGenivEXT')
glMultiTexGenivEXT.ret = Return('void')
glMultiTexGenivEXT.add( Input( 'texunit','GLenum' ))
glMultiTexGenivEXT.add( Input( 'coord','GLenum' ))
glMultiTexGenivEXT.add( Input( 'pname','GLenum' ))
glMultiTexGenivEXT.add( Input( 'params','const GLint *' ))
glMultiTexGenivEXT.version = '1.3'
glMultiTexGenivEXT.category = 'GL_EXT_direct_state_access'
glMultiTexGenivEXT.trace = True
glMultiTexGenivEXT.play = True
gl.add(glMultiTexGenivEXT)

glMultiTexImage1DEXT = Function('glMultiTexImage1DEXT')
glMultiTexImage1DEXT.ret = Return('void')
glMultiTexImage1DEXT.add( Input( 'texunit','GLenum' ))
glMultiTexImage1DEXT.add( Input( 'target','GLenum' ))
glMultiTexImage1DEXT.add( Input( 'level','GLint' ))
glMultiTexImage1DEXT.add( Input( 'internalformat','GLint' ))
glMultiTexImage1DEXT.add( Input( 'width','GLsizei' ))
glMultiTexImage1DEXT.add( Input( 'border','GLint' ))
glMultiTexImage1DEXT.add( Input( 'format','GLenum' ))
glMultiTexImage1DEXT.add( Input( 'type','GLenum' ))
glMultiTexImage1DEXT.add( Input( 'pixels','const GLvoid *' ))
glMultiTexImage1DEXT.version = '1.1'
glMultiTexImage1DEXT.category = 'GL_EXT_direct_state_access'
glMultiTexImage1DEXT.trace = True
glMultiTexImage1DEXT.play = True
gl.add(glMultiTexImage1DEXT)

glMultiTexImage2DEXT = Function('glMultiTexImage2DEXT')
glMultiTexImage2DEXT.ret = Return('void')
glMultiTexImage2DEXT.add( Input( 'texunit','GLenum' ))
glMultiTexImage2DEXT.add( Input( 'target','GLenum' ))
glMultiTexImage2DEXT.add( Input( 'level','GLint' ))
glMultiTexImage2DEXT.add( Input( 'internalformat','GLint' ))
glMultiTexImage2DEXT.add( Input( 'width','GLsizei' ))
glMultiTexImage2DEXT.add( Input( 'height','GLsizei' ))
glMultiTexImage2DEXT.add( Input( 'border','GLint' ))
glMultiTexImage2DEXT.add( Input( 'format','GLenum' ))
glMultiTexImage2DEXT.add( Input( 'type','GLenum' ))
glMultiTexImage2DEXT.add( Input( 'pixels','const GLvoid *' ))
glMultiTexImage2DEXT.version = '1.1'
glMultiTexImage2DEXT.category = 'GL_EXT_direct_state_access'
glMultiTexImage2DEXT.trace = True
glMultiTexImage2DEXT.play = True
gl.add(glMultiTexImage2DEXT)

glMultiTexImage3DEXT = Function('glMultiTexImage3DEXT')
glMultiTexImage3DEXT.ret = Return('void')
glMultiTexImage3DEXT.add( Input( 'texunit','GLenum' ))
glMultiTexImage3DEXT.add( Input( 'target','GLenum' ))
glMultiTexImage3DEXT.add( Input( 'level','GLint' ))
glMultiTexImage3DEXT.add( Input( 'internalformat','GLint' ))
glMultiTexImage3DEXT.add( Input( 'width','GLsizei' ))
glMultiTexImage3DEXT.add( Input( 'height','GLsizei' ))
glMultiTexImage3DEXT.add( Input( 'depth','GLsizei' ))
glMultiTexImage3DEXT.add( Input( 'border','GLint' ))
glMultiTexImage3DEXT.add( Input( 'format','GLenum' ))
glMultiTexImage3DEXT.add( Input( 'type','GLenum' ))
glMultiTexImage3DEXT.add( Input( 'pixels','const GLvoid *' ))
glMultiTexImage3DEXT.version = '1.2'
glMultiTexImage3DEXT.category = 'GL_EXT_direct_state_access'
glMultiTexImage3DEXT.trace = True
glMultiTexImage3DEXT.play = True
gl.add(glMultiTexImage3DEXT)

glMultiTexParameterIivEXT = Function('glMultiTexParameterIivEXT')
glMultiTexParameterIivEXT.ret = Return('void')
glMultiTexParameterIivEXT.add( Input( 'texunit','GLenum' ))
glMultiTexParameterIivEXT.add( Input( 'target','GLenum' ))
glMultiTexParameterIivEXT.add( Input( 'pname','GLenum' ))
glMultiTexParameterIivEXT.add( Input( 'params','const GLint *' ))
glMultiTexParameterIivEXT.version = '1.1'
glMultiTexParameterIivEXT.category = 'GL_EXT_direct_state_access'
glMultiTexParameterIivEXT.trace = True
glMultiTexParameterIivEXT.play = True
gl.add(glMultiTexParameterIivEXT)

glMultiTexParameterIuivEXT = Function('glMultiTexParameterIuivEXT')
glMultiTexParameterIuivEXT.ret = Return('void')
glMultiTexParameterIuivEXT.add( Input( 'texunit','GLenum' ))
glMultiTexParameterIuivEXT.add( Input( 'target','GLenum' ))
glMultiTexParameterIuivEXT.add( Input( 'pname','GLenum' ))
glMultiTexParameterIuivEXT.add( Input( 'params','const GLuint *' ))
glMultiTexParameterIuivEXT.version = '1.1'
glMultiTexParameterIuivEXT.category = 'GL_EXT_direct_state_access'
glMultiTexParameterIuivEXT.trace = True
glMultiTexParameterIuivEXT.play = True
gl.add(glMultiTexParameterIuivEXT)

glMultiTexParameterfEXT = Function('glMultiTexParameterfEXT')
glMultiTexParameterfEXT.ret = Return('void')
glMultiTexParameterfEXT.add( Input( 'texunit','GLenum' ))
glMultiTexParameterfEXT.add( Input( 'target','GLenum' ))
glMultiTexParameterfEXT.add( Input( 'pname','GLenum' ))
glMultiTexParameterfEXT.add( Input( 'param','GLfloat' ))
glMultiTexParameterfEXT.version = '1.1'
glMultiTexParameterfEXT.category = 'GL_EXT_direct_state_access'
glMultiTexParameterfEXT.trace = True
glMultiTexParameterfEXT.play = True
gl.add(glMultiTexParameterfEXT)

glMultiTexParameterfvEXT = Function('glMultiTexParameterfvEXT')
glMultiTexParameterfvEXT.ret = Return('void')
glMultiTexParameterfvEXT.add( Input( 'texunit','GLenum' ))
glMultiTexParameterfvEXT.add( Input( 'target','GLenum' ))
glMultiTexParameterfvEXT.add( Input( 'pname','GLenum' ))
glMultiTexParameterfvEXT.add( Input( 'param','const GLfloat *' ,size = 'helperGLTexParametervSize(pname)' ))
glMultiTexParameterfvEXT.version = '1.1'
glMultiTexParameterfvEXT.category = 'GL_EXT_direct_state_access'
glMultiTexParameterfvEXT.trace = True
glMultiTexParameterfvEXT.play = True
gl.add(glMultiTexParameterfvEXT)

glMultiTexParameteriEXT = Function('glMultiTexParameteriEXT')
glMultiTexParameteriEXT.ret = Return('void')
glMultiTexParameteriEXT.add( Input( 'texunit','GLenum' ))
glMultiTexParameteriEXT.add( Input( 'target','GLenum' ))
glMultiTexParameteriEXT.add( Input( 'pname','GLenum' ))
glMultiTexParameteriEXT.add( Input( 'param','GLint' ))
glMultiTexParameteriEXT.version = '1.1'
glMultiTexParameteriEXT.category = 'GL_EXT_direct_state_access'
glMultiTexParameteriEXT.trace = True
glMultiTexParameteriEXT.play = True
gl.add(glMultiTexParameteriEXT)

glMultiTexParameterivEXT = Function('glMultiTexParameterivEXT')
glMultiTexParameterivEXT.ret = Return('void')
glMultiTexParameterivEXT.add( Input( 'texunit','GLenum' ))
glMultiTexParameterivEXT.add( Input( 'target','GLenum' ))
glMultiTexParameterivEXT.add( Input( 'pname','GLenum' ))
glMultiTexParameterivEXT.add( Input( 'param','const GLint *' ,size = 'helperGLTexParametervSize(pname)' ))
glMultiTexParameterivEXT.version = '1.1'
glMultiTexParameterivEXT.category = 'GL_EXT_direct_state_access'
glMultiTexParameterivEXT.trace = True
glMultiTexParameterivEXT.play = True
gl.add(glMultiTexParameterivEXT)

glMultiTexRenderbufferEXT = Function('glMultiTexRenderbufferEXT')
glMultiTexRenderbufferEXT.ret = Return('void')
glMultiTexRenderbufferEXT.add( Input( 'texunit','GLenum' ))
glMultiTexRenderbufferEXT.add( Input( 'target','GLenum' ))
glMultiTexRenderbufferEXT.add( Input( 'renderbuffer','GLuint' ))
glMultiTexRenderbufferEXT.version = '2.0'
glMultiTexRenderbufferEXT.category = 'GL_EXT_direct_state_access'
glMultiTexRenderbufferEXT.trace = True
glMultiTexRenderbufferEXT.play = True
gl.add(glMultiTexRenderbufferEXT)

glMultiTexSubImage1DEXT = Function('glMultiTexSubImage1DEXT')
glMultiTexSubImage1DEXT.ret = Return('void')
glMultiTexSubImage1DEXT.add( Input( 'texunit','GLenum' ))
glMultiTexSubImage1DEXT.add( Input( 'target','GLenum' ))
glMultiTexSubImage1DEXT.add( Input( 'level','GLint' ))
glMultiTexSubImage1DEXT.add( Input( 'xoffset','GLint' ))
glMultiTexSubImage1DEXT.add( Input( 'width','GLsizei' ))
glMultiTexSubImage1DEXT.add( Input( 'format','GLenum' ))
glMultiTexSubImage1DEXT.add( Input( 'type','GLenum' ))
glMultiTexSubImage1DEXT.add( Input( 'pixels','const GLvoid *' ))
glMultiTexSubImage1DEXT.version = '1.1'
glMultiTexSubImage1DEXT.category = 'GL_EXT_direct_state_access'
glMultiTexSubImage1DEXT.trace = True
glMultiTexSubImage1DEXT.play = True
gl.add(glMultiTexSubImage1DEXT)

glMultiTexSubImage2DEXT = Function('glMultiTexSubImage2DEXT')
glMultiTexSubImage2DEXT.ret = Return('void')
glMultiTexSubImage2DEXT.add( Input( 'texunit','GLenum' ))
glMultiTexSubImage2DEXT.add( Input( 'target','GLenum' ))
glMultiTexSubImage2DEXT.add( Input( 'level','GLint' ))
glMultiTexSubImage2DEXT.add( Input( 'xoffset','GLint' ))
glMultiTexSubImage2DEXT.add( Input( 'yoffset','GLint' ))
glMultiTexSubImage2DEXT.add( Input( 'width','GLsizei' ))
glMultiTexSubImage2DEXT.add( Input( 'height','GLsizei' ))
glMultiTexSubImage2DEXT.add( Input( 'format','GLenum' ))
glMultiTexSubImage2DEXT.add( Input( 'type','GLenum' ))
glMultiTexSubImage2DEXT.add( Input( 'pixels','const GLvoid *' ))
glMultiTexSubImage2DEXT.version = '1.1'
glMultiTexSubImage2DEXT.category = 'GL_EXT_direct_state_access'
glMultiTexSubImage2DEXT.trace = True
glMultiTexSubImage2DEXT.play = True
gl.add(glMultiTexSubImage2DEXT)

glMultiTexSubImage3DEXT = Function('glMultiTexSubImage3DEXT')
glMultiTexSubImage3DEXT.ret = Return('void')
glMultiTexSubImage3DEXT.add( Input( 'texunit','GLenum' ))
glMultiTexSubImage3DEXT.add( Input( 'target','GLenum' ))
glMultiTexSubImage3DEXT.add( Input( 'level','GLint' ))
glMultiTexSubImage3DEXT.add( Input( 'xoffset','GLint' ))
glMultiTexSubImage3DEXT.add( Input( 'yoffset','GLint' ))
glMultiTexSubImage3DEXT.add( Input( 'zoffset','GLint' ))
glMultiTexSubImage3DEXT.add( Input( 'width','GLsizei' ))
glMultiTexSubImage3DEXT.add( Input( 'height','GLsizei' ))
glMultiTexSubImage3DEXT.add( Input( 'depth','GLsizei' ))
glMultiTexSubImage3DEXT.add( Input( 'format','GLenum' ))
glMultiTexSubImage3DEXT.add( Input( 'type','GLenum' ))
glMultiTexSubImage3DEXT.add( Input( 'pixels','const GLvoid *' ))
glMultiTexSubImage3DEXT.version = '1.2'
glMultiTexSubImage3DEXT.category = 'GL_EXT_direct_state_access'
glMultiTexSubImage3DEXT.trace = True
glMultiTexSubImage3DEXT.play = True
gl.add(glMultiTexSubImage3DEXT)

glNamedBufferDataEXT = Function('glNamedBufferDataEXT')
glNamedBufferDataEXT.ret = Return('void')
glNamedBufferDataEXT.add( Input( 'buffer','GLuint' ))
glNamedBufferDataEXT.add( Input( 'size','GLsizeiptr' ))
glNamedBufferDataEXT.add( Input( 'data','const GLvoid *' ))
glNamedBufferDataEXT.add( Input( 'usage','GLenum' ))
glNamedBufferDataEXT.version = '1.5'
glNamedBufferDataEXT.category = 'GL_EXT_direct_state_access'
glNamedBufferDataEXT.trace = True
glNamedBufferDataEXT.play = True
gl.add(glNamedBufferDataEXT)

glNamedBufferSubDataEXT = Function('glNamedBufferSubDataEXT')
glNamedBufferSubDataEXT.ret = Return('void')
glNamedBufferSubDataEXT.add( Input( 'buffer','GLuint' ))
glNamedBufferSubDataEXT.add( Input( 'offset','GLintptr' ))
glNamedBufferSubDataEXT.add( Input( 'size','GLsizeiptr' ))
glNamedBufferSubDataEXT.add( Input( 'data','const GLvoid *' ))
glNamedBufferSubDataEXT.version = '1.5'
glNamedBufferSubDataEXT.category = 'GL_EXT_direct_state_access'
glNamedBufferSubDataEXT.trace = True
glNamedBufferSubDataEXT.play = True
gl.add(glNamedBufferSubDataEXT)

glNamedCopyBufferSubDataEXT = Function('glNamedCopyBufferSubDataEXT')
glNamedCopyBufferSubDataEXT.ret = Return('void')
glNamedCopyBufferSubDataEXT.add( Input( 'readBuffer','GLuint' ))
glNamedCopyBufferSubDataEXT.add( Input( 'writeBuffer','GLuint' ))
glNamedCopyBufferSubDataEXT.add( Input( 'readOffset','GLintptr' ))
glNamedCopyBufferSubDataEXT.add( Input( 'writeOffset','GLintptr' ))
glNamedCopyBufferSubDataEXT.add( Input( 'size','GLsizeiptr' ))
glNamedCopyBufferSubDataEXT.version = '3.1'
glNamedCopyBufferSubDataEXT.category = 'GL_EXT_direct_state_access'
glNamedCopyBufferSubDataEXT.trace = True
glNamedCopyBufferSubDataEXT.play = True
gl.add(glNamedCopyBufferSubDataEXT)

glNamedFramebufferRenderbufferEXT = Function('glNamedFramebufferRenderbufferEXT')
glNamedFramebufferRenderbufferEXT.ret = Return('void')
glNamedFramebufferRenderbufferEXT.add( Input( 'framebuffer','GLuint' ))
glNamedFramebufferRenderbufferEXT.add( Input( 'attachment','GLenum' ))
glNamedFramebufferRenderbufferEXT.add( Input( 'renderbuffertarget','GLenum' ))
glNamedFramebufferRenderbufferEXT.add( Input( 'renderbuffer','GLuint' ))
glNamedFramebufferRenderbufferEXT.version = '1.5'
glNamedFramebufferRenderbufferEXT.category = 'GL_EXT_direct_state_access'
glNamedFramebufferRenderbufferEXT.trace = True
glNamedFramebufferRenderbufferEXT.play = True
gl.add(glNamedFramebufferRenderbufferEXT)

glNamedFramebufferTexture1DEXT = Function('glNamedFramebufferTexture1DEXT')
glNamedFramebufferTexture1DEXT.ret = Return('void')
glNamedFramebufferTexture1DEXT.add( Input( 'framebuffer','GLuint' ))
glNamedFramebufferTexture1DEXT.add( Input( 'attachment','GLenum' ))
glNamedFramebufferTexture1DEXT.add( Input( 'textarget','GLenum' ))
glNamedFramebufferTexture1DEXT.add( Input( 'texture','GLuint' ))
glNamedFramebufferTexture1DEXT.add( Input( 'level','GLint' ))
glNamedFramebufferTexture1DEXT.version = '1.5'
glNamedFramebufferTexture1DEXT.category = 'GL_EXT_direct_state_access'
glNamedFramebufferTexture1DEXT.trace = True
glNamedFramebufferTexture1DEXT.play = True
gl.add(glNamedFramebufferTexture1DEXT)

glNamedFramebufferTexture2DEXT = Function('glNamedFramebufferTexture2DEXT')
glNamedFramebufferTexture2DEXT.ret = Return('void')
glNamedFramebufferTexture2DEXT.add( Input( 'framebuffer','GLuint' ))
glNamedFramebufferTexture2DEXT.add( Input( 'attachment','GLenum' ))
glNamedFramebufferTexture2DEXT.add( Input( 'textarget','GLenum' ))
glNamedFramebufferTexture2DEXT.add( Input( 'texture','GLuint' ))
glNamedFramebufferTexture2DEXT.add( Input( 'level','GLint' ))
glNamedFramebufferTexture2DEXT.version = '1.5'
glNamedFramebufferTexture2DEXT.category = 'GL_EXT_direct_state_access'
glNamedFramebufferTexture2DEXT.trace = True
glNamedFramebufferTexture2DEXT.play = True
gl.add(glNamedFramebufferTexture2DEXT)

glNamedFramebufferTexture3DEXT = Function('glNamedFramebufferTexture3DEXT')
glNamedFramebufferTexture3DEXT.ret = Return('void')
glNamedFramebufferTexture3DEXT.add( Input( 'framebuffer','GLuint' ))
glNamedFramebufferTexture3DEXT.add( Input( 'attachment','GLenum' ))
glNamedFramebufferTexture3DEXT.add( Input( 'textarget','GLenum' ))
glNamedFramebufferTexture3DEXT.add( Input( 'texture','GLuint' ))
glNamedFramebufferTexture3DEXT.add( Input( 'level','GLint' ))
glNamedFramebufferTexture3DEXT.add( Input( 'zoffset','GLint' ))
glNamedFramebufferTexture3DEXT.version = '1.5'
glNamedFramebufferTexture3DEXT.category = 'GL_EXT_direct_state_access'
glNamedFramebufferTexture3DEXT.trace = True
glNamedFramebufferTexture3DEXT.play = True
gl.add(glNamedFramebufferTexture3DEXT)

glNamedFramebufferTextureEXT = Function('glNamedFramebufferTextureEXT')
glNamedFramebufferTextureEXT.ret = Return('void')
glNamedFramebufferTextureEXT.add( Input( 'framebuffer','GLuint' ))
glNamedFramebufferTextureEXT.add( Input( 'attachment','GLenum' ))
glNamedFramebufferTextureEXT.add( Input( 'texture','GLuint' ))
glNamedFramebufferTextureEXT.add( Input( 'level','GLint' ))
glNamedFramebufferTextureEXT.version = '2.0'
glNamedFramebufferTextureEXT.category = 'GL_EXT_direct_state_access'
glNamedFramebufferTextureEXT.trace = True
glNamedFramebufferTextureEXT.play = True
gl.add(glNamedFramebufferTextureEXT)

glNamedFramebufferTextureFaceEXT = Function('glNamedFramebufferTextureFaceEXT')
glNamedFramebufferTextureFaceEXT.ret = Return('void')
glNamedFramebufferTextureFaceEXT.add( Input( 'framebuffer','GLuint' ))
glNamedFramebufferTextureFaceEXT.add( Input( 'attachment','GLenum' ))
glNamedFramebufferTextureFaceEXT.add( Input( 'texture','GLuint' ))
glNamedFramebufferTextureFaceEXT.add( Input( 'level','GLint' ))
glNamedFramebufferTextureFaceEXT.add( Input( 'face','GLenum' ))
glNamedFramebufferTextureFaceEXT.version = '2.0'
glNamedFramebufferTextureFaceEXT.category = 'GL_EXT_direct_state_access'
glNamedFramebufferTextureFaceEXT.trace = True
glNamedFramebufferTextureFaceEXT.play = True
gl.add(glNamedFramebufferTextureFaceEXT)

glNamedFramebufferTextureLayerEXT = Function('glNamedFramebufferTextureLayerEXT')
glNamedFramebufferTextureLayerEXT.ret = Return('void')
glNamedFramebufferTextureLayerEXT.add( Input( 'framebuffer','GLuint' ))
glNamedFramebufferTextureLayerEXT.add( Input( 'attachment','GLenum' ))
glNamedFramebufferTextureLayerEXT.add( Input( 'texture','GLuint' ))
glNamedFramebufferTextureLayerEXT.add( Input( 'level','GLint' ))
glNamedFramebufferTextureLayerEXT.add( Input( 'layer','GLint' ))
glNamedFramebufferTextureLayerEXT.version = '2.0'
glNamedFramebufferTextureLayerEXT.category = 'GL_EXT_direct_state_access'
glNamedFramebufferTextureLayerEXT.trace = True
glNamedFramebufferTextureLayerEXT.play = True
gl.add(glNamedFramebufferTextureLayerEXT)

glNamedProgramLocalParameter4dEXT = Function('glNamedProgramLocalParameter4dEXT')
glNamedProgramLocalParameter4dEXT.ret = Return('void')
glNamedProgramLocalParameter4dEXT.add( Input( 'program','GLuint' ))
glNamedProgramLocalParameter4dEXT.add( Input( 'target','GLenum' ))
glNamedProgramLocalParameter4dEXT.add( Input( 'index','GLuint' ))
glNamedProgramLocalParameter4dEXT.add( Input( 'x','GLdouble' ))
glNamedProgramLocalParameter4dEXT.add( Input( 'y','GLdouble' ))
glNamedProgramLocalParameter4dEXT.add( Input( 'z','GLdouble' ))
glNamedProgramLocalParameter4dEXT.add( Input( 'w','GLdouble' ))
glNamedProgramLocalParameter4dEXT.version = '1.3'
glNamedProgramLocalParameter4dEXT.category = 'GL_EXT_direct_state_access'
glNamedProgramLocalParameter4dEXT.trace = True
glNamedProgramLocalParameter4dEXT.play = True
gl.add(glNamedProgramLocalParameter4dEXT)

glNamedProgramLocalParameter4dvEXT = Function('glNamedProgramLocalParameter4dvEXT')
glNamedProgramLocalParameter4dvEXT.ret = Return('void')
glNamedProgramLocalParameter4dvEXT.add( Input( 'program','GLuint' ))
glNamedProgramLocalParameter4dvEXT.add( Input( 'target','GLenum' ))
glNamedProgramLocalParameter4dvEXT.add( Input( 'index','GLuint' ))
glNamedProgramLocalParameter4dvEXT.add( Input( 'params','const GLdouble *' ,size = 4 ))
glNamedProgramLocalParameter4dvEXT.version = '1.3'
glNamedProgramLocalParameter4dvEXT.category = 'GL_EXT_direct_state_access'
glNamedProgramLocalParameter4dvEXT.trace = True
glNamedProgramLocalParameter4dvEXT.play = True
gl.add(glNamedProgramLocalParameter4dvEXT)

glNamedProgramLocalParameter4fEXT = Function('glNamedProgramLocalParameter4fEXT')
glNamedProgramLocalParameter4fEXT.ret = Return('void')
glNamedProgramLocalParameter4fEXT.add( Input( 'program','GLuint' ))
glNamedProgramLocalParameter4fEXT.add( Input( 'target','GLenum' ))
glNamedProgramLocalParameter4fEXT.add( Input( 'index','GLuint' ))
glNamedProgramLocalParameter4fEXT.add( Input( 'x','GLfloat' ))
glNamedProgramLocalParameter4fEXT.add( Input( 'y','GLfloat' ))
glNamedProgramLocalParameter4fEXT.add( Input( 'z','GLfloat' ))
glNamedProgramLocalParameter4fEXT.add( Input( 'w','GLfloat' ))
glNamedProgramLocalParameter4fEXT.version = '1.3'
glNamedProgramLocalParameter4fEXT.category = 'GL_EXT_direct_state_access'
glNamedProgramLocalParameter4fEXT.trace = True
glNamedProgramLocalParameter4fEXT.play = True
gl.add(glNamedProgramLocalParameter4fEXT)

glNamedProgramLocalParameter4fvEXT = Function('glNamedProgramLocalParameter4fvEXT')
glNamedProgramLocalParameter4fvEXT.ret = Return('void')
glNamedProgramLocalParameter4fvEXT.add( Input( 'program','GLuint' ))
glNamedProgramLocalParameter4fvEXT.add( Input( 'target','GLenum' ))
glNamedProgramLocalParameter4fvEXT.add( Input( 'index','GLuint' ))
glNamedProgramLocalParameter4fvEXT.add( Input( 'params','const GLfloat *' ,size = 4 ))
glNamedProgramLocalParameter4fvEXT.version = '1.3'
glNamedProgramLocalParameter4fvEXT.category = 'GL_EXT_direct_state_access'
glNamedProgramLocalParameter4fvEXT.trace = True
glNamedProgramLocalParameter4fvEXT.play = True
gl.add(glNamedProgramLocalParameter4fvEXT)

glNamedProgramLocalParameterI4iEXT = Function('glNamedProgramLocalParameterI4iEXT')
glNamedProgramLocalParameterI4iEXT.ret = Return('void')
glNamedProgramLocalParameterI4iEXT.add( Input( 'program','GLuint' ))
glNamedProgramLocalParameterI4iEXT.add( Input( 'target','GLenum' ))
glNamedProgramLocalParameterI4iEXT.add( Input( 'index','GLuint' ))
glNamedProgramLocalParameterI4iEXT.add( Input( 'x','GLint' ))
glNamedProgramLocalParameterI4iEXT.add( Input( 'y','GLint' ))
glNamedProgramLocalParameterI4iEXT.add( Input( 'z','GLint' ))
glNamedProgramLocalParameterI4iEXT.add( Input( 'w','GLint' ))
glNamedProgramLocalParameterI4iEXT.version = '1.3'
glNamedProgramLocalParameterI4iEXT.category = 'GL_EXT_direct_state_access'
glNamedProgramLocalParameterI4iEXT.trace = True
glNamedProgramLocalParameterI4iEXT.play = True
gl.add(glNamedProgramLocalParameterI4iEXT)

glNamedProgramLocalParameterI4ivEXT = Function('glNamedProgramLocalParameterI4ivEXT')
glNamedProgramLocalParameterI4ivEXT.ret = Return('void')
glNamedProgramLocalParameterI4ivEXT.add( Input( 'program','GLuint' ))
glNamedProgramLocalParameterI4ivEXT.add( Input( 'target','GLenum' ))
glNamedProgramLocalParameterI4ivEXT.add( Input( 'index','GLuint' ))
glNamedProgramLocalParameterI4ivEXT.add( Input( 'params','const GLint *' ,size = 4 ))
glNamedProgramLocalParameterI4ivEXT.version = '1.3'
glNamedProgramLocalParameterI4ivEXT.category = 'GL_EXT_direct_state_access'
glNamedProgramLocalParameterI4ivEXT.trace = True
glNamedProgramLocalParameterI4ivEXT.play = True
gl.add(glNamedProgramLocalParameterI4ivEXT)

glNamedProgramLocalParameterI4uiEXT = Function('glNamedProgramLocalParameterI4uiEXT')
glNamedProgramLocalParameterI4uiEXT.ret = Return('void')
glNamedProgramLocalParameterI4uiEXT.add( Input( 'program','GLuint' ))
glNamedProgramLocalParameterI4uiEXT.add( Input( 'target','GLenum' ))
glNamedProgramLocalParameterI4uiEXT.add( Input( 'index','GLuint' ))
glNamedProgramLocalParameterI4uiEXT.add( Input( 'x','GLuint' ))
glNamedProgramLocalParameterI4uiEXT.add( Input( 'y','GLuint' ))
glNamedProgramLocalParameterI4uiEXT.add( Input( 'z','GLuint' ))
glNamedProgramLocalParameterI4uiEXT.add( Input( 'w','GLuint' ))
glNamedProgramLocalParameterI4uiEXT.version = '1.3'
glNamedProgramLocalParameterI4uiEXT.category = 'GL_EXT_direct_state_access'
glNamedProgramLocalParameterI4uiEXT.trace = True
glNamedProgramLocalParameterI4uiEXT.play = True
gl.add(glNamedProgramLocalParameterI4uiEXT)

glNamedProgramLocalParameterI4uivEXT = Function('glNamedProgramLocalParameterI4uivEXT')
glNamedProgramLocalParameterI4uivEXT.ret = Return('void')
glNamedProgramLocalParameterI4uivEXT.add( Input( 'program','GLuint' ))
glNamedProgramLocalParameterI4uivEXT.add( Input( 'target','GLenum' ))
glNamedProgramLocalParameterI4uivEXT.add( Input( 'index','GLuint' ))
glNamedProgramLocalParameterI4uivEXT.add( Input( 'params','const GLuint *' ,size = 4 ))
glNamedProgramLocalParameterI4uivEXT.version = '1.3'
glNamedProgramLocalParameterI4uivEXT.category = 'GL_EXT_direct_state_access'
glNamedProgramLocalParameterI4uivEXT.trace = True
glNamedProgramLocalParameterI4uivEXT.play = True
gl.add(glNamedProgramLocalParameterI4uivEXT)

glNamedProgramLocalParameters4fvEXT = Function('glNamedProgramLocalParameters4fvEXT')
glNamedProgramLocalParameters4fvEXT.ret = Return('void')
glNamedProgramLocalParameters4fvEXT.add( Input( 'program','GLuint' ))
glNamedProgramLocalParameters4fvEXT.add( Input( 'target','GLenum' ))
glNamedProgramLocalParameters4fvEXT.add( Input( 'index','GLuint' ))
glNamedProgramLocalParameters4fvEXT.add( Input( 'count','GLsizei' ))
glNamedProgramLocalParameters4fvEXT.add( Input( 'params','const GLfloat *' ,size = 'count * 4' ))
glNamedProgramLocalParameters4fvEXT.version = '1.3'
glNamedProgramLocalParameters4fvEXT.category = 'GL_EXT_direct_state_access'
glNamedProgramLocalParameters4fvEXT.trace = True
glNamedProgramLocalParameters4fvEXT.play = True
gl.add(glNamedProgramLocalParameters4fvEXT)

glNamedProgramLocalParametersI4ivEXT = Function('glNamedProgramLocalParametersI4ivEXT')
glNamedProgramLocalParametersI4ivEXT.ret = Return('void')
glNamedProgramLocalParametersI4ivEXT.add( Input( 'program','GLuint' ))
glNamedProgramLocalParametersI4ivEXT.add( Input( 'target','GLenum' ))
glNamedProgramLocalParametersI4ivEXT.add( Input( 'index','GLuint' ))
glNamedProgramLocalParametersI4ivEXT.add( Input( 'count','GLsizei' ))
glNamedProgramLocalParametersI4ivEXT.add( Input( 'params','const GLint *' ,size = 'count * 4' ))
glNamedProgramLocalParametersI4ivEXT.version = '1.3'
glNamedProgramLocalParametersI4ivEXT.category = 'GL_EXT_direct_state_access'
glNamedProgramLocalParametersI4ivEXT.trace = True
glNamedProgramLocalParametersI4ivEXT.play = True
gl.add(glNamedProgramLocalParametersI4ivEXT)

glNamedProgramLocalParametersI4uivEXT = Function('glNamedProgramLocalParametersI4uivEXT')
glNamedProgramLocalParametersI4uivEXT.ret = Return('void')
glNamedProgramLocalParametersI4uivEXT.add( Input( 'program','GLuint' ))
glNamedProgramLocalParametersI4uivEXT.add( Input( 'target','GLenum' ))
glNamedProgramLocalParametersI4uivEXT.add( Input( 'index','GLuint' ))
glNamedProgramLocalParametersI4uivEXT.add( Input( 'count','GLsizei' ))
glNamedProgramLocalParametersI4uivEXT.add( Input( 'params','const GLuint *' ,size = 'count * 4' ))
glNamedProgramLocalParametersI4uivEXT.version = '1.3'
glNamedProgramLocalParametersI4uivEXT.category = 'GL_EXT_direct_state_access'
glNamedProgramLocalParametersI4uivEXT.trace = True
glNamedProgramLocalParametersI4uivEXT.play = True
gl.add(glNamedProgramLocalParametersI4uivEXT)

glNamedProgramStringEXT = Function('glNamedProgramStringEXT')
glNamedProgramStringEXT.ret = Return('void')
glNamedProgramStringEXT.add( Input( 'program','GLuint' ))
glNamedProgramStringEXT.add( Input( 'target','GLenum' ))
glNamedProgramStringEXT.add( Input( 'format','GLenum' ))
glNamedProgramStringEXT.add( Input( 'len','GLsizei' ))
glNamedProgramStringEXT.add( Input( 'string','const GLvoid *' ,size = 'len' ,cast = 'const char *' ))
glNamedProgramStringEXT.version = '1.3'
glNamedProgramStringEXT.category = 'GL_EXT_direct_state_access'
glNamedProgramStringEXT.trace = True
glNamedProgramStringEXT.play = True
gl.add(glNamedProgramStringEXT)

glNamedRenderbufferStorageEXT = Function('glNamedRenderbufferStorageEXT')
glNamedRenderbufferStorageEXT.ret = Return('void')
glNamedRenderbufferStorageEXT.add( Input( 'renderbuffer','GLuint' ))
glNamedRenderbufferStorageEXT.add( Input( 'internalformat','GLenum' ))
glNamedRenderbufferStorageEXT.add( Input( 'width','GLsizei' ))
glNamedRenderbufferStorageEXT.add( Input( 'height','GLsizei' ))
glNamedRenderbufferStorageEXT.version = '1.5'
glNamedRenderbufferStorageEXT.category = 'GL_EXT_direct_state_access'
glNamedRenderbufferStorageEXT.trace = True
glNamedRenderbufferStorageEXT.play = True
gl.add(glNamedRenderbufferStorageEXT)

glNamedRenderbufferStorageMultisampleCoverageEXT = Function('glNamedRenderbufferStorageMultisampleCoverageEXT')
glNamedRenderbufferStorageMultisampleCoverageEXT.ret = Return('void')
glNamedRenderbufferStorageMultisampleCoverageEXT.add( Input( 'renderbuffer','GLuint' ))
glNamedRenderbufferStorageMultisampleCoverageEXT.add( Input( 'coverageSamples','GLsizei' ))
glNamedRenderbufferStorageMultisampleCoverageEXT.add( Input( 'colorSamples','GLsizei' ))
glNamedRenderbufferStorageMultisampleCoverageEXT.add( Input( 'internalformat','GLenum' ))
glNamedRenderbufferStorageMultisampleCoverageEXT.add( Input( 'width','GLsizei' ))
glNamedRenderbufferStorageMultisampleCoverageEXT.add( Input( 'height','GLsizei' ))
glNamedRenderbufferStorageMultisampleCoverageEXT.version = '1.5'
glNamedRenderbufferStorageMultisampleCoverageEXT.category = 'GL_EXT_direct_state_access'
glNamedRenderbufferStorageMultisampleCoverageEXT.trace = True
glNamedRenderbufferStorageMultisampleCoverageEXT.play = True
gl.add(glNamedRenderbufferStorageMultisampleCoverageEXT)

glNamedRenderbufferStorageMultisampleEXT = Function('glNamedRenderbufferStorageMultisampleEXT')
glNamedRenderbufferStorageMultisampleEXT.ret = Return('void')
glNamedRenderbufferStorageMultisampleEXT.add( Input( 'renderbuffer','GLuint' ))
glNamedRenderbufferStorageMultisampleEXT.add( Input( 'samples','GLsizei' ))
glNamedRenderbufferStorageMultisampleEXT.add( Input( 'internalformat','GLenum' ))
glNamedRenderbufferStorageMultisampleEXT.add( Input( 'width','GLsizei' ))
glNamedRenderbufferStorageMultisampleEXT.add( Input( 'height','GLsizei' ))
glNamedRenderbufferStorageMultisampleEXT.version = '1.5'
glNamedRenderbufferStorageMultisampleEXT.category = 'GL_EXT_direct_state_access'
glNamedRenderbufferStorageMultisampleEXT.trace = True
glNamedRenderbufferStorageMultisampleEXT.play = True
gl.add(glNamedRenderbufferStorageMultisampleEXT)

glProgramUniform1dEXT = Function('glProgramUniform1dEXT')
glProgramUniform1dEXT.ret = Return('void')
glProgramUniform1dEXT.add( Input( 'program','GLuint' ))
glProgramUniform1dEXT.add( Input( 'location','GLint' ))
glProgramUniform1dEXT.add( Input( 'x','GLdouble' ))
glProgramUniform1dEXT.version = '4.0'
glProgramUniform1dEXT.category = 'GL_EXT_direct_state_access'
glProgramUniform1dEXT.trace = True
glProgramUniform1dEXT.play = True
gl.add(glProgramUniform1dEXT)

glProgramUniform1dvEXT = Function('glProgramUniform1dvEXT')
glProgramUniform1dvEXT.ret = Return('void')
glProgramUniform1dvEXT.add( Input( 'program','GLuint' ))
glProgramUniform1dvEXT.add( Input( 'location','GLint' ))
glProgramUniform1dvEXT.add( Input( 'count','GLsizei' ))
glProgramUniform1dvEXT.add( Input( 'value','const GLdouble *' ,size = 'count' ))
glProgramUniform1dvEXT.version = '4.0'
glProgramUniform1dvEXT.category = 'GL_EXT_direct_state_access'
glProgramUniform1dvEXT.trace = True
glProgramUniform1dvEXT.play = True
gl.add(glProgramUniform1dvEXT)

glProgramUniform1fEXT = Function('glProgramUniform1fEXT')
glProgramUniform1fEXT.ret = Return('void')
glProgramUniform1fEXT.add( Input( 'program','GLuint' ))
glProgramUniform1fEXT.add( Input( 'location','GLint' ))
glProgramUniform1fEXT.add( Input( 'v0','GLfloat' ))
glProgramUniform1fEXT.version = '2.0'
glProgramUniform1fEXT.category = 'GL_EXT_direct_state_access'
glProgramUniform1fEXT.trace = True
glProgramUniform1fEXT.play = True
gl.add(glProgramUniform1fEXT)

glProgramUniform1fvEXT = Function('glProgramUniform1fvEXT')
glProgramUniform1fvEXT.ret = Return('void')
glProgramUniform1fvEXT.add( Input( 'program','GLuint' ))
glProgramUniform1fvEXT.add( Input( 'location','GLint' ))
glProgramUniform1fvEXT.add( Input( 'count','GLsizei' ))
glProgramUniform1fvEXT.add( Input( 'value','const GLfloat *' ,size = 'count' ))
glProgramUniform1fvEXT.version = '2.0'
glProgramUniform1fvEXT.category = 'GL_EXT_direct_state_access'
glProgramUniform1fvEXT.trace = True
glProgramUniform1fvEXT.play = True
gl.add(glProgramUniform1fvEXT)

glProgramUniform1iEXT = Function('glProgramUniform1iEXT')
glProgramUniform1iEXT.ret = Return('void')
glProgramUniform1iEXT.add( Input( 'program','GLuint' ))
glProgramUniform1iEXT.add( Input( 'location','GLint' ))
glProgramUniform1iEXT.add( Input( 'v0','GLint' ))
glProgramUniform1iEXT.version = '2.0'
glProgramUniform1iEXT.category = 'GL_EXT_direct_state_access'
glProgramUniform1iEXT.trace = True
glProgramUniform1iEXT.play = True
gl.add(glProgramUniform1iEXT)

glProgramUniform1ivEXT = Function('glProgramUniform1ivEXT')
glProgramUniform1ivEXT.ret = Return('void')
glProgramUniform1ivEXT.add( Input( 'program','GLuint' ))
glProgramUniform1ivEXT.add( Input( 'location','GLint' ))
glProgramUniform1ivEXT.add( Input( 'count','GLsizei' ))
glProgramUniform1ivEXT.add( Input( 'value','const GLint *' ,size = 'count' ))
glProgramUniform1ivEXT.version = '2.0'
glProgramUniform1ivEXT.category = 'GL_EXT_direct_state_access'
glProgramUniform1ivEXT.trace = True
glProgramUniform1ivEXT.play = True
gl.add(glProgramUniform1ivEXT)

glProgramUniform1uiEXT = Function('glProgramUniform1uiEXT')
glProgramUniform1uiEXT.ret = Return('void')
glProgramUniform1uiEXT.add( Input( 'program','GLuint' ))
glProgramUniform1uiEXT.add( Input( 'location','GLint' ))
glProgramUniform1uiEXT.add( Input( 'v0','GLuint' ))
glProgramUniform1uiEXT.version = '2.0'
glProgramUniform1uiEXT.category = 'GL_EXT_direct_state_access'
glProgramUniform1uiEXT.trace = True
glProgramUniform1uiEXT.play = True
gl.add(glProgramUniform1uiEXT)

glProgramUniform1uivEXT = Function('glProgramUniform1uivEXT')
glProgramUniform1uivEXT.ret = Return('void')
glProgramUniform1uivEXT.add( Input( 'program','GLuint' ))
glProgramUniform1uivEXT.add( Input( 'location','GLint' ))
glProgramUniform1uivEXT.add( Input( 'count','GLsizei' ))
glProgramUniform1uivEXT.add( Input( 'value','const GLuint *' ,size = 'count' ))
glProgramUniform1uivEXT.version = '2.0'
glProgramUniform1uivEXT.category = 'GL_EXT_direct_state_access'
glProgramUniform1uivEXT.trace = True
glProgramUniform1uivEXT.play = True
gl.add(glProgramUniform1uivEXT)

glProgramUniform2dEXT = Function('glProgramUniform2dEXT')
glProgramUniform2dEXT.ret = Return('void')
glProgramUniform2dEXT.add( Input( 'program','GLuint' ))
glProgramUniform2dEXT.add( Input( 'location','GLint' ))
glProgramUniform2dEXT.add( Input( 'x','GLdouble' ))
glProgramUniform2dEXT.add( Input( 'y','GLdouble' ))
glProgramUniform2dEXT.version = '4.0'
glProgramUniform2dEXT.category = 'GL_EXT_direct_state_access'
glProgramUniform2dEXT.trace = True
glProgramUniform2dEXT.play = True
gl.add(glProgramUniform2dEXT)

glProgramUniform2dvEXT = Function('glProgramUniform2dvEXT')
glProgramUniform2dvEXT.ret = Return('void')
glProgramUniform2dvEXT.add( Input( 'program','GLuint' ))
glProgramUniform2dvEXT.add( Input( 'location','GLint' ))
glProgramUniform2dvEXT.add( Input( 'count','GLsizei' ))
glProgramUniform2dvEXT.add( Input( 'value','const GLdouble *' ,size = 'count * 2' ))
glProgramUniform2dvEXT.version = '4.0'
glProgramUniform2dvEXT.category = 'GL_EXT_direct_state_access'
glProgramUniform2dvEXT.trace = True
glProgramUniform2dvEXT.play = True
gl.add(glProgramUniform2dvEXT)

glProgramUniform2fEXT = Function('glProgramUniform2fEXT')
glProgramUniform2fEXT.ret = Return('void')
glProgramUniform2fEXT.add( Input( 'program','GLuint' ))
glProgramUniform2fEXT.add( Input( 'location','GLint' ))
glProgramUniform2fEXT.add( Input( 'v0','GLfloat' ))
glProgramUniform2fEXT.add( Input( 'v1','GLfloat' ))
glProgramUniform2fEXT.version = '2.0'
glProgramUniform2fEXT.category = 'GL_EXT_direct_state_access'
glProgramUniform2fEXT.trace = True
glProgramUniform2fEXT.play = True
gl.add(glProgramUniform2fEXT)

glProgramUniform2fvEXT = Function('glProgramUniform2fvEXT')
glProgramUniform2fvEXT.ret = Return('void')
glProgramUniform2fvEXT.add( Input( 'program','GLuint' ))
glProgramUniform2fvEXT.add( Input( 'location','GLint' ))
glProgramUniform2fvEXT.add( Input( 'count','GLsizei' ))
glProgramUniform2fvEXT.add( Input( 'value','const GLfloat *' ,size = 'count * 2' ))
glProgramUniform2fvEXT.version = '2.0'
glProgramUniform2fvEXT.category = 'GL_EXT_direct_state_access'
glProgramUniform2fvEXT.trace = True
glProgramUniform2fvEXT.play = True
gl.add(glProgramUniform2fvEXT)

glProgramUniform2iEXT = Function('glProgramUniform2iEXT')
glProgramUniform2iEXT.ret = Return('void')
glProgramUniform2iEXT.add( Input( 'program','GLuint' ))
glProgramUniform2iEXT.add( Input( 'location','GLint' ))
glProgramUniform2iEXT.add( Input( 'v0','GLint' ))
glProgramUniform2iEXT.add( Input( 'v1','GLint' ))
glProgramUniform2iEXT.version = '2.0'
glProgramUniform2iEXT.category = 'GL_EXT_direct_state_access'
glProgramUniform2iEXT.trace = True
glProgramUniform2iEXT.play = True
gl.add(glProgramUniform2iEXT)

glProgramUniform2ivEXT = Function('glProgramUniform2ivEXT')
glProgramUniform2ivEXT.ret = Return('void')
glProgramUniform2ivEXT.add( Input( 'program','GLuint' ))
glProgramUniform2ivEXT.add( Input( 'location','GLint' ))
glProgramUniform2ivEXT.add( Input( 'count','GLsizei' ))
glProgramUniform2ivEXT.add( Input( 'value','const GLint *' ,size = 'count * 2' ))
glProgramUniform2ivEXT.version = '2.0'
glProgramUniform2ivEXT.category = 'GL_EXT_direct_state_access'
glProgramUniform2ivEXT.trace = True
glProgramUniform2ivEXT.play = True
gl.add(glProgramUniform2ivEXT)

glProgramUniform2uiEXT = Function('glProgramUniform2uiEXT')
glProgramUniform2uiEXT.ret = Return('void')
glProgramUniform2uiEXT.add( Input( 'program','GLuint' ))
glProgramUniform2uiEXT.add( Input( 'location','GLint' ))
glProgramUniform2uiEXT.add( Input( 'v0','GLuint' ))
glProgramUniform2uiEXT.add( Input( 'v1','GLuint' ))
glProgramUniform2uiEXT.version = '2.0'
glProgramUniform2uiEXT.category = 'GL_EXT_direct_state_access'
glProgramUniform2uiEXT.trace = True
glProgramUniform2uiEXT.play = True
gl.add(glProgramUniform2uiEXT)

glProgramUniform2uivEXT = Function('glProgramUniform2uivEXT')
glProgramUniform2uivEXT.ret = Return('void')
glProgramUniform2uivEXT.add( Input( 'program','GLuint' ))
glProgramUniform2uivEXT.add( Input( 'location','GLint' ))
glProgramUniform2uivEXT.add( Input( 'count','GLsizei' ))
glProgramUniform2uivEXT.add( Input( 'value','const GLuint *' ,size = 'count * 2' ))
glProgramUniform2uivEXT.version = '2.0'
glProgramUniform2uivEXT.category = 'GL_EXT_direct_state_access'
glProgramUniform2uivEXT.trace = True
glProgramUniform2uivEXT.play = True
gl.add(glProgramUniform2uivEXT)

glProgramUniform3dEXT = Function('glProgramUniform3dEXT')
glProgramUniform3dEXT.ret = Return('void')
glProgramUniform3dEXT.add( Input( 'program','GLuint' ))
glProgramUniform3dEXT.add( Input( 'location','GLint' ))
glProgramUniform3dEXT.add( Input( 'x','GLdouble' ))
glProgramUniform3dEXT.add( Input( 'y','GLdouble' ))
glProgramUniform3dEXT.add( Input( 'z','GLdouble' ))
glProgramUniform3dEXT.version = '4.0'
glProgramUniform3dEXT.category = 'GL_EXT_direct_state_access'
glProgramUniform3dEXT.trace = True
glProgramUniform3dEXT.play = True
gl.add(glProgramUniform3dEXT)

glProgramUniform3dvEXT = Function('glProgramUniform3dvEXT')
glProgramUniform3dvEXT.ret = Return('void')
glProgramUniform3dvEXT.add( Input( 'program','GLuint' ))
glProgramUniform3dvEXT.add( Input( 'location','GLint' ))
glProgramUniform3dvEXT.add( Input( 'count','GLsizei' ))
glProgramUniform3dvEXT.add( Input( 'value','const GLdouble *' ,size = 'count * 3' ))
glProgramUniform3dvEXT.version = '4.0'
glProgramUniform3dvEXT.category = 'GL_EXT_direct_state_access'
glProgramUniform3dvEXT.trace = True
glProgramUniform3dvEXT.play = True
gl.add(glProgramUniform3dvEXT)

glProgramUniform3fEXT = Function('glProgramUniform3fEXT')
glProgramUniform3fEXT.ret = Return('void')
glProgramUniform3fEXT.add( Input( 'program','GLuint' ))
glProgramUniform3fEXT.add( Input( 'location','GLint' ))
glProgramUniform3fEXT.add( Input( 'v0','GLfloat' ))
glProgramUniform3fEXT.add( Input( 'v1','GLfloat' ))
glProgramUniform3fEXT.add( Input( 'v2','GLfloat' ))
glProgramUniform3fEXT.version = '2.0'
glProgramUniform3fEXT.category = 'GL_EXT_direct_state_access'
glProgramUniform3fEXT.trace = True
glProgramUniform3fEXT.play = True
gl.add(glProgramUniform3fEXT)

glProgramUniform3fvEXT = Function('glProgramUniform3fvEXT')
glProgramUniform3fvEXT.ret = Return('void')
glProgramUniform3fvEXT.add( Input( 'program','GLuint' ))
glProgramUniform3fvEXT.add( Input( 'location','GLint' ))
glProgramUniform3fvEXT.add( Input( 'count','GLsizei' ))
glProgramUniform3fvEXT.add( Input( 'value','const GLfloat *' ,size = 'count * 3' ))
glProgramUniform3fvEXT.version = '2.0'
glProgramUniform3fvEXT.category = 'GL_EXT_direct_state_access'
glProgramUniform3fvEXT.trace = True
glProgramUniform3fvEXT.play = True
gl.add(glProgramUniform3fvEXT)

glProgramUniform3iEXT = Function('glProgramUniform3iEXT')
glProgramUniform3iEXT.ret = Return('void')
glProgramUniform3iEXT.add( Input( 'program','GLuint' ))
glProgramUniform3iEXT.add( Input( 'location','GLint' ))
glProgramUniform3iEXT.add( Input( 'v0','GLint' ))
glProgramUniform3iEXT.add( Input( 'v1','GLint' ))
glProgramUniform3iEXT.add( Input( 'v2','GLint' ))
glProgramUniform3iEXT.version = '2.0'
glProgramUniform3iEXT.category = 'GL_EXT_direct_state_access'
glProgramUniform3iEXT.trace = True
glProgramUniform3iEXT.play = True
gl.add(glProgramUniform3iEXT)

glProgramUniform3ivEXT = Function('glProgramUniform3ivEXT')
glProgramUniform3ivEXT.ret = Return('void')
glProgramUniform3ivEXT.add( Input( 'program','GLuint' ))
glProgramUniform3ivEXT.add( Input( 'location','GLint' ))
glProgramUniform3ivEXT.add( Input( 'count','GLsizei' ))
glProgramUniform3ivEXT.add( Input( 'value','const GLint *' ,size = 'count * 3' ))
glProgramUniform3ivEXT.version = '2.0'
glProgramUniform3ivEXT.category = 'GL_EXT_direct_state_access'
glProgramUniform3ivEXT.trace = True
glProgramUniform3ivEXT.play = True
gl.add(glProgramUniform3ivEXT)

glProgramUniform3uiEXT = Function('glProgramUniform3uiEXT')
glProgramUniform3uiEXT.ret = Return('void')
glProgramUniform3uiEXT.add( Input( 'program','GLuint' ))
glProgramUniform3uiEXT.add( Input( 'location','GLint' ))
glProgramUniform3uiEXT.add( Input( 'v0','GLuint' ))
glProgramUniform3uiEXT.add( Input( 'v1','GLuint' ))
glProgramUniform3uiEXT.add( Input( 'v2','GLuint' ))
glProgramUniform3uiEXT.version = '2.0'
glProgramUniform3uiEXT.category = 'GL_EXT_direct_state_access'
glProgramUniform3uiEXT.trace = True
glProgramUniform3uiEXT.play = True
gl.add(glProgramUniform3uiEXT)

glProgramUniform3uivEXT = Function('glProgramUniform3uivEXT')
glProgramUniform3uivEXT.ret = Return('void')
glProgramUniform3uivEXT.add( Input( 'program','GLuint' ))
glProgramUniform3uivEXT.add( Input( 'location','GLint' ))
glProgramUniform3uivEXT.add( Input( 'count','GLsizei' ))
glProgramUniform3uivEXT.add( Input( 'value','const GLuint *' ,size = 'count * 3' ))
glProgramUniform3uivEXT.version = '2.0'
glProgramUniform3uivEXT.category = 'GL_EXT_direct_state_access'
glProgramUniform3uivEXT.trace = True
glProgramUniform3uivEXT.play = True
gl.add(glProgramUniform3uivEXT)

glProgramUniform4dEXT = Function('glProgramUniform4dEXT')
glProgramUniform4dEXT.ret = Return('void')
glProgramUniform4dEXT.add( Input( 'program','GLuint' ))
glProgramUniform4dEXT.add( Input( 'location','GLint' ))
glProgramUniform4dEXT.add( Input( 'x','GLdouble' ))
glProgramUniform4dEXT.add( Input( 'y','GLdouble' ))
glProgramUniform4dEXT.add( Input( 'z','GLdouble' ))
glProgramUniform4dEXT.add( Input( 'w','GLdouble' ))
glProgramUniform4dEXT.version = '4.0'
glProgramUniform4dEXT.category = 'GL_EXT_direct_state_access'
glProgramUniform4dEXT.trace = True
glProgramUniform4dEXT.play = True
gl.add(glProgramUniform4dEXT)

glProgramUniform4dvEXT = Function('glProgramUniform4dvEXT')
glProgramUniform4dvEXT.ret = Return('void')
glProgramUniform4dvEXT.add( Input( 'program','GLuint' ))
glProgramUniform4dvEXT.add( Input( 'location','GLint' ))
glProgramUniform4dvEXT.add( Input( 'count','GLsizei' ))
glProgramUniform4dvEXT.add( Input( 'value','const GLdouble *' ,size = 'count * 4' ))
glProgramUniform4dvEXT.version = '4.0'
glProgramUniform4dvEXT.category = 'GL_EXT_direct_state_access'
glProgramUniform4dvEXT.trace = True
glProgramUniform4dvEXT.play = True
gl.add(glProgramUniform4dvEXT)

glProgramUniform4fEXT = Function('glProgramUniform4fEXT')
glProgramUniform4fEXT.ret = Return('void')
glProgramUniform4fEXT.add( Input( 'program','GLuint' ))
glProgramUniform4fEXT.add( Input( 'location','GLint' ))
glProgramUniform4fEXT.add( Input( 'v0','GLfloat' ))
glProgramUniform4fEXT.add( Input( 'v1','GLfloat' ))
glProgramUniform4fEXT.add( Input( 'v2','GLfloat' ))
glProgramUniform4fEXT.add( Input( 'v3','GLfloat' ))
glProgramUniform4fEXT.version = '2.0'
glProgramUniform4fEXT.category = 'GL_EXT_direct_state_access'
glProgramUniform4fEXT.trace = True
glProgramUniform4fEXT.play = True
gl.add(glProgramUniform4fEXT)

glProgramUniform4fvEXT = Function('glProgramUniform4fvEXT')
glProgramUniform4fvEXT.ret = Return('void')
glProgramUniform4fvEXT.add( Input( 'program','GLuint' ))
glProgramUniform4fvEXT.add( Input( 'location','GLint' ))
glProgramUniform4fvEXT.add( Input( 'count','GLsizei' ))
glProgramUniform4fvEXT.add( Input( 'value','const GLfloat *' ,size = 'count * 4' ))
glProgramUniform4fvEXT.version = '2.0'
glProgramUniform4fvEXT.category = 'GL_EXT_direct_state_access'
glProgramUniform4fvEXT.trace = True
glProgramUniform4fvEXT.play = True
gl.add(glProgramUniform4fvEXT)

glProgramUniform4iEXT = Function('glProgramUniform4iEXT')
glProgramUniform4iEXT.ret = Return('void')
glProgramUniform4iEXT.add( Input( 'program','GLuint' ))
glProgramUniform4iEXT.add( Input( 'location','GLint' ))
glProgramUniform4iEXT.add( Input( 'v0','GLint' ))
glProgramUniform4iEXT.add( Input( 'v1','GLint' ))
glProgramUniform4iEXT.add( Input( 'v2','GLint' ))
glProgramUniform4iEXT.add( Input( 'v3','GLint' ))
glProgramUniform4iEXT.version = '2.0'
glProgramUniform4iEXT.category = 'GL_EXT_direct_state_access'
glProgramUniform4iEXT.trace = True
glProgramUniform4iEXT.play = True
gl.add(glProgramUniform4iEXT)

glProgramUniform4ivEXT = Function('glProgramUniform4ivEXT')
glProgramUniform4ivEXT.ret = Return('void')
glProgramUniform4ivEXT.add( Input( 'program','GLuint' ))
glProgramUniform4ivEXT.add( Input( 'location','GLint' ))
glProgramUniform4ivEXT.add( Input( 'count','GLsizei' ))
glProgramUniform4ivEXT.add( Input( 'value','const GLint *' ,size = 'count * 4' ))
glProgramUniform4ivEXT.version = '2.0'
glProgramUniform4ivEXT.category = 'GL_EXT_direct_state_access'
glProgramUniform4ivEXT.trace = True
glProgramUniform4ivEXT.play = True
gl.add(glProgramUniform4ivEXT)

glProgramUniform4uiEXT = Function('glProgramUniform4uiEXT')
glProgramUniform4uiEXT.ret = Return('void')
glProgramUniform4uiEXT.add( Input( 'program','GLuint' ))
glProgramUniform4uiEXT.add( Input( 'location','GLint' ))
glProgramUniform4uiEXT.add( Input( 'v0','GLuint' ))
glProgramUniform4uiEXT.add( Input( 'v1','GLuint' ))
glProgramUniform4uiEXT.add( Input( 'v2','GLuint' ))
glProgramUniform4uiEXT.add( Input( 'v3','GLuint' ))
glProgramUniform4uiEXT.version = '2.0'
glProgramUniform4uiEXT.category = 'GL_EXT_direct_state_access'
glProgramUniform4uiEXT.trace = True
glProgramUniform4uiEXT.play = True
gl.add(glProgramUniform4uiEXT)

glProgramUniform4uivEXT = Function('glProgramUniform4uivEXT')
glProgramUniform4uivEXT.ret = Return('void')
glProgramUniform4uivEXT.add( Input( 'program','GLuint' ))
glProgramUniform4uivEXT.add( Input( 'location','GLint' ))
glProgramUniform4uivEXT.add( Input( 'count','GLsizei' ))
glProgramUniform4uivEXT.add( Input( 'value','const GLuint *' ,size = 'count * 4' ))
glProgramUniform4uivEXT.version = '2.0'
glProgramUniform4uivEXT.category = 'GL_EXT_direct_state_access'
glProgramUniform4uivEXT.trace = True
glProgramUniform4uivEXT.play = True
gl.add(glProgramUniform4uivEXT)

glProgramUniformMatrix2dvEXT = Function('glProgramUniformMatrix2dvEXT')
glProgramUniformMatrix2dvEXT.ret = Return('void')
glProgramUniformMatrix2dvEXT.add( Input( 'program','GLuint' ))
glProgramUniformMatrix2dvEXT.add( Input( 'location','GLint' ))
glProgramUniformMatrix2dvEXT.add( Input( 'count','GLsizei' ))
glProgramUniformMatrix2dvEXT.add( Input( 'transpose','GLboolean' ))
glProgramUniformMatrix2dvEXT.add( Input( 'value','const GLdouble *' ,size = 'count * 4' ))
glProgramUniformMatrix2dvEXT.version = '4.0'
glProgramUniformMatrix2dvEXT.category = 'GL_EXT_direct_state_access'
glProgramUniformMatrix2dvEXT.trace = True
glProgramUniformMatrix2dvEXT.play = True
gl.add(glProgramUniformMatrix2dvEXT)

glProgramUniformMatrix2fvEXT = Function('glProgramUniformMatrix2fvEXT')
glProgramUniformMatrix2fvEXT.ret = Return('void')
glProgramUniformMatrix2fvEXT.add( Input( 'program','GLuint' ))
glProgramUniformMatrix2fvEXT.add( Input( 'location','GLint' ))
glProgramUniformMatrix2fvEXT.add( Input( 'count','GLsizei' ))
glProgramUniformMatrix2fvEXT.add( Input( 'transpose','GLboolean' ))
glProgramUniformMatrix2fvEXT.add( Input( 'value','const GLfloat *' ,size = 'count * 4' ))
glProgramUniformMatrix2fvEXT.version = '2.0'
glProgramUniformMatrix2fvEXT.category = 'GL_EXT_direct_state_access'
glProgramUniformMatrix2fvEXT.trace = True
glProgramUniformMatrix2fvEXT.play = True
gl.add(glProgramUniformMatrix2fvEXT)

glProgramUniformMatrix2x3dvEXT = Function('glProgramUniformMatrix2x3dvEXT')
glProgramUniformMatrix2x3dvEXT.ret = Return('void')
glProgramUniformMatrix2x3dvEXT.add( Input( 'program','GLuint' ))
glProgramUniformMatrix2x3dvEXT.add( Input( 'location','GLint' ))
glProgramUniformMatrix2x3dvEXT.add( Input( 'count','GLsizei' ))
glProgramUniformMatrix2x3dvEXT.add( Input( 'transpose','GLboolean' ))
glProgramUniformMatrix2x3dvEXT.add( Input( 'value','const GLdouble *' ,size = 'count * 6' ))
glProgramUniformMatrix2x3dvEXT.version = '4.0'
glProgramUniformMatrix2x3dvEXT.category = 'GL_EXT_direct_state_access'
glProgramUniformMatrix2x3dvEXT.trace = True
glProgramUniformMatrix2x3dvEXT.play = True
gl.add(glProgramUniformMatrix2x3dvEXT)

glProgramUniformMatrix2x3fvEXT = Function('glProgramUniformMatrix2x3fvEXT')
glProgramUniformMatrix2x3fvEXT.ret = Return('void')
glProgramUniformMatrix2x3fvEXT.add( Input( 'program','GLuint' ))
glProgramUniformMatrix2x3fvEXT.add( Input( 'location','GLint' ))
glProgramUniformMatrix2x3fvEXT.add( Input( 'count','GLsizei' ))
glProgramUniformMatrix2x3fvEXT.add( Input( 'transpose','GLboolean' ))
glProgramUniformMatrix2x3fvEXT.add( Input( 'value','const GLfloat *' ,size = 'count * 6' ))
glProgramUniformMatrix2x3fvEXT.version = '2.1'
glProgramUniformMatrix2x3fvEXT.category = 'GL_EXT_direct_state_access'
glProgramUniformMatrix2x3fvEXT.trace = True
glProgramUniformMatrix2x3fvEXT.play = True
gl.add(glProgramUniformMatrix2x3fvEXT)

glProgramUniformMatrix2x4dvEXT = Function('glProgramUniformMatrix2x4dvEXT')
glProgramUniformMatrix2x4dvEXT.ret = Return('void')
glProgramUniformMatrix2x4dvEXT.add( Input( 'program','GLuint' ))
glProgramUniformMatrix2x4dvEXT.add( Input( 'location','GLint' ))
glProgramUniformMatrix2x4dvEXT.add( Input( 'count','GLsizei' ))
glProgramUniformMatrix2x4dvEXT.add( Input( 'transpose','GLboolean' ))
glProgramUniformMatrix2x4dvEXT.add( Input( 'value','const GLdouble *' ,size = 'count * 8' ))
glProgramUniformMatrix2x4dvEXT.version = '4.0'
glProgramUniformMatrix2x4dvEXT.category = 'GL_EXT_direct_state_access'
glProgramUniformMatrix2x4dvEXT.trace = True
glProgramUniformMatrix2x4dvEXT.play = True
gl.add(glProgramUniformMatrix2x4dvEXT)

glProgramUniformMatrix2x4fvEXT = Function('glProgramUniformMatrix2x4fvEXT')
glProgramUniformMatrix2x4fvEXT.ret = Return('void')
glProgramUniformMatrix2x4fvEXT.add( Input( 'program','GLuint' ))
glProgramUniformMatrix2x4fvEXT.add( Input( 'location','GLint' ))
glProgramUniformMatrix2x4fvEXT.add( Input( 'count','GLsizei' ))
glProgramUniformMatrix2x4fvEXT.add( Input( 'transpose','GLboolean' ))
glProgramUniformMatrix2x4fvEXT.add( Input( 'value','const GLfloat *' ,size = 'count * 8' ))
glProgramUniformMatrix2x4fvEXT.version = '2.1'
glProgramUniformMatrix2x4fvEXT.category = 'GL_EXT_direct_state_access'
glProgramUniformMatrix2x4fvEXT.trace = True
glProgramUniformMatrix2x4fvEXT.play = True
gl.add(glProgramUniformMatrix2x4fvEXT)

glProgramUniformMatrix3dvEXT = Function('glProgramUniformMatrix3dvEXT')
glProgramUniformMatrix3dvEXT.ret = Return('void')
glProgramUniformMatrix3dvEXT.add( Input( 'program','GLuint' ))
glProgramUniformMatrix3dvEXT.add( Input( 'location','GLint' ))
glProgramUniformMatrix3dvEXT.add( Input( 'count','GLsizei' ))
glProgramUniformMatrix3dvEXT.add( Input( 'transpose','GLboolean' ))
glProgramUniformMatrix3dvEXT.add( Input( 'value','const GLdouble *' ,size = 'count * 9' ))
glProgramUniformMatrix3dvEXT.version = '4.0'
glProgramUniformMatrix3dvEXT.category = 'GL_EXT_direct_state_access'
glProgramUniformMatrix3dvEXT.trace = True
glProgramUniformMatrix3dvEXT.play = True
gl.add(glProgramUniformMatrix3dvEXT)

glProgramUniformMatrix3fvEXT = Function('glProgramUniformMatrix3fvEXT')
glProgramUniformMatrix3fvEXT.ret = Return('void')
glProgramUniformMatrix3fvEXT.add( Input( 'program','GLuint' ))
glProgramUniformMatrix3fvEXT.add( Input( 'location','GLint' ))
glProgramUniformMatrix3fvEXT.add( Input( 'count','GLsizei' ))
glProgramUniformMatrix3fvEXT.add( Input( 'transpose','GLboolean' ))
glProgramUniformMatrix3fvEXT.add( Input( 'value','const GLfloat *' ,size = 'count * 9' ))
glProgramUniformMatrix3fvEXT.version = '2.0'
glProgramUniformMatrix3fvEXT.category = 'GL_EXT_direct_state_access'
glProgramUniformMatrix3fvEXT.trace = True
glProgramUniformMatrix3fvEXT.play = True
gl.add(glProgramUniformMatrix3fvEXT)

glProgramUniformMatrix3x2dvEXT = Function('glProgramUniformMatrix3x2dvEXT')
glProgramUniformMatrix3x2dvEXT.ret = Return('void')
glProgramUniformMatrix3x2dvEXT.add( Input( 'program','GLuint' ))
glProgramUniformMatrix3x2dvEXT.add( Input( 'location','GLint' ))
glProgramUniformMatrix3x2dvEXT.add( Input( 'count','GLsizei' ))
glProgramUniformMatrix3x2dvEXT.add( Input( 'transpose','GLboolean' ))
glProgramUniformMatrix3x2dvEXT.add( Input( 'value','const GLdouble *' ,size = 'count * 6' ))
glProgramUniformMatrix3x2dvEXT.version = '4.0'
glProgramUniformMatrix3x2dvEXT.category = 'GL_EXT_direct_state_access'
glProgramUniformMatrix3x2dvEXT.trace = True
glProgramUniformMatrix3x2dvEXT.play = True
gl.add(glProgramUniformMatrix3x2dvEXT)

glProgramUniformMatrix3x2fvEXT = Function('glProgramUniformMatrix3x2fvEXT')
glProgramUniformMatrix3x2fvEXT.ret = Return('void')
glProgramUniformMatrix3x2fvEXT.add( Input( 'program','GLuint' ))
glProgramUniformMatrix3x2fvEXT.add( Input( 'location','GLint' ))
glProgramUniformMatrix3x2fvEXT.add( Input( 'count','GLsizei' ))
glProgramUniformMatrix3x2fvEXT.add( Input( 'transpose','GLboolean' ))
glProgramUniformMatrix3x2fvEXT.add( Input( 'value','const GLfloat *' ,size = 'count * 6' ))
glProgramUniformMatrix3x2fvEXT.version = '2.1'
glProgramUniformMatrix3x2fvEXT.category = 'GL_EXT_direct_state_access'
glProgramUniformMatrix3x2fvEXT.trace = True
glProgramUniformMatrix3x2fvEXT.play = True
gl.add(glProgramUniformMatrix3x2fvEXT)

glProgramUniformMatrix3x4dvEXT = Function('glProgramUniformMatrix3x4dvEXT')
glProgramUniformMatrix3x4dvEXT.ret = Return('void')
glProgramUniformMatrix3x4dvEXT.add( Input( 'program','GLuint' ))
glProgramUniformMatrix3x4dvEXT.add( Input( 'location','GLint' ))
glProgramUniformMatrix3x4dvEXT.add( Input( 'count','GLsizei' ))
glProgramUniformMatrix3x4dvEXT.add( Input( 'transpose','GLboolean' ))
glProgramUniformMatrix3x4dvEXT.add( Input( 'value','const GLdouble *' ,size = 'count * 12' ))
glProgramUniformMatrix3x4dvEXT.version = '4.0'
glProgramUniformMatrix3x4dvEXT.category = 'GL_EXT_direct_state_access'
glProgramUniformMatrix3x4dvEXT.trace = True
glProgramUniformMatrix3x4dvEXT.play = True
gl.add(glProgramUniformMatrix3x4dvEXT)

glProgramUniformMatrix3x4fvEXT = Function('glProgramUniformMatrix3x4fvEXT')
glProgramUniformMatrix3x4fvEXT.ret = Return('void')
glProgramUniformMatrix3x4fvEXT.add( Input( 'program','GLuint' ))
glProgramUniformMatrix3x4fvEXT.add( Input( 'location','GLint' ))
glProgramUniformMatrix3x4fvEXT.add( Input( 'count','GLsizei' ))
glProgramUniformMatrix3x4fvEXT.add( Input( 'transpose','GLboolean' ))
glProgramUniformMatrix3x4fvEXT.add( Input( 'value','const GLfloat *' ,size = 'count * 12' ))
glProgramUniformMatrix3x4fvEXT.version = '2.1'
glProgramUniformMatrix3x4fvEXT.category = 'GL_EXT_direct_state_access'
glProgramUniformMatrix3x4fvEXT.trace = True
glProgramUniformMatrix3x4fvEXT.play = True
gl.add(glProgramUniformMatrix3x4fvEXT)

glProgramUniformMatrix4dvEXT = Function('glProgramUniformMatrix4dvEXT')
glProgramUniformMatrix4dvEXT.ret = Return('void')
glProgramUniformMatrix4dvEXT.add( Input( 'program','GLuint' ))
glProgramUniformMatrix4dvEXT.add( Input( 'location','GLint' ))
glProgramUniformMatrix4dvEXT.add( Input( 'count','GLsizei' ))
glProgramUniformMatrix4dvEXT.add( Input( 'transpose','GLboolean' ))
glProgramUniformMatrix4dvEXT.add( Input( 'value','const GLdouble *' ,size = 'count * 16' ))
glProgramUniformMatrix4dvEXT.version = '4.0'
glProgramUniformMatrix4dvEXT.category = 'GL_EXT_direct_state_access'
glProgramUniformMatrix4dvEXT.trace = True
glProgramUniformMatrix4dvEXT.play = True
gl.add(glProgramUniformMatrix4dvEXT)

glProgramUniformMatrix4fvEXT = Function('glProgramUniformMatrix4fvEXT')
glProgramUniformMatrix4fvEXT.ret = Return('void')
glProgramUniformMatrix4fvEXT.add( Input( 'program','GLuint' ))
glProgramUniformMatrix4fvEXT.add( Input( 'location','GLint' ))
glProgramUniformMatrix4fvEXT.add( Input( 'count','GLsizei' ))
glProgramUniformMatrix4fvEXT.add( Input( 'transpose','GLboolean' ))
glProgramUniformMatrix4fvEXT.add( Input( 'value','const GLfloat *' ,size = 'count * 16' ))
glProgramUniformMatrix4fvEXT.version = '2.0'
glProgramUniformMatrix4fvEXT.category = 'GL_EXT_direct_state_access'
glProgramUniformMatrix4fvEXT.trace = True
glProgramUniformMatrix4fvEXT.play = True
gl.add(glProgramUniformMatrix4fvEXT)

glProgramUniformMatrix4x2dvEXT = Function('glProgramUniformMatrix4x2dvEXT')
glProgramUniformMatrix4x2dvEXT.ret = Return('void')
glProgramUniformMatrix4x2dvEXT.add( Input( 'program','GLuint' ))
glProgramUniformMatrix4x2dvEXT.add( Input( 'location','GLint' ))
glProgramUniformMatrix4x2dvEXT.add( Input( 'count','GLsizei' ))
glProgramUniformMatrix4x2dvEXT.add( Input( 'transpose','GLboolean' ))
glProgramUniformMatrix4x2dvEXT.add( Input( 'value','const GLdouble *' ,size = 'count * 8' ))
glProgramUniformMatrix4x2dvEXT.version = '4.0'
glProgramUniformMatrix4x2dvEXT.category = 'GL_EXT_direct_state_access'
glProgramUniformMatrix4x2dvEXT.trace = True
glProgramUniformMatrix4x2dvEXT.play = True
gl.add(glProgramUniformMatrix4x2dvEXT)

glProgramUniformMatrix4x2fvEXT = Function('glProgramUniformMatrix4x2fvEXT')
glProgramUniformMatrix4x2fvEXT.ret = Return('void')
glProgramUniformMatrix4x2fvEXT.add( Input( 'program','GLuint' ))
glProgramUniformMatrix4x2fvEXT.add( Input( 'location','GLint' ))
glProgramUniformMatrix4x2fvEXT.add( Input( 'count','GLsizei' ))
glProgramUniformMatrix4x2fvEXT.add( Input( 'transpose','GLboolean' ))
glProgramUniformMatrix4x2fvEXT.add( Input( 'value','const GLfloat *' ,size = 'count * 8' ))
glProgramUniformMatrix4x2fvEXT.version = '2.1'
glProgramUniformMatrix4x2fvEXT.category = 'GL_EXT_direct_state_access'
glProgramUniformMatrix4x2fvEXT.trace = True
glProgramUniformMatrix4x2fvEXT.play = True
gl.add(glProgramUniformMatrix4x2fvEXT)

glProgramUniformMatrix4x3dvEXT = Function('glProgramUniformMatrix4x3dvEXT')
glProgramUniformMatrix4x3dvEXT.ret = Return('void')
glProgramUniformMatrix4x3dvEXT.add( Input( 'program','GLuint' ))
glProgramUniformMatrix4x3dvEXT.add( Input( 'location','GLint' ))
glProgramUniformMatrix4x3dvEXT.add( Input( 'count','GLsizei' ))
glProgramUniformMatrix4x3dvEXT.add( Input( 'transpose','GLboolean' ))
glProgramUniformMatrix4x3dvEXT.add( Input( 'value','const GLdouble *' ,size = 'count * 12' ))
glProgramUniformMatrix4x3dvEXT.version = '4.0'
glProgramUniformMatrix4x3dvEXT.category = 'GL_EXT_direct_state_access'
glProgramUniformMatrix4x3dvEXT.trace = True
glProgramUniformMatrix4x3dvEXT.play = True
gl.add(glProgramUniformMatrix4x3dvEXT)

glProgramUniformMatrix4x3fvEXT = Function('glProgramUniformMatrix4x3fvEXT')
glProgramUniformMatrix4x3fvEXT.ret = Return('void')
glProgramUniformMatrix4x3fvEXT.add( Input( 'program','GLuint' ))
glProgramUniformMatrix4x3fvEXT.add( Input( 'location','GLint' ))
glProgramUniformMatrix4x3fvEXT.add( Input( 'count','GLsizei' ))
glProgramUniformMatrix4x3fvEXT.add( Input( 'transpose','GLboolean' ))
glProgramUniformMatrix4x3fvEXT.add( Input( 'value','const GLfloat *' ,size = 'count * 12' ))
glProgramUniformMatrix4x3fvEXT.version = '2.1'
glProgramUniformMatrix4x3fvEXT.category = 'GL_EXT_direct_state_access'
glProgramUniformMatrix4x3fvEXT.trace = True
glProgramUniformMatrix4x3fvEXT.play = True
gl.add(glProgramUniformMatrix4x3fvEXT)

glPushClientAttribDefaultEXT = Function('glPushClientAttribDefaultEXT')
glPushClientAttribDefaultEXT.ret = Return('void')
glPushClientAttribDefaultEXT.add( Input( 'mask','GLbitfield' ,regalLog = 'GLpushClientAttribToString(mask)' ))
glPushClientAttribDefaultEXT.version = '1.1'
glPushClientAttribDefaultEXT.category = 'GL_EXT_direct_state_access'
glPushClientAttribDefaultEXT.trace = True
glPushClientAttribDefaultEXT.play = True
gl.add(glPushClientAttribDefaultEXT)

glTextureBufferEXT = Function('glTextureBufferEXT')
glTextureBufferEXT.ret = Return('void')
glTextureBufferEXT.add( Input( 'texture','GLuint' ))
glTextureBufferEXT.add( Input( 'target','GLenum' ))
glTextureBufferEXT.add( Input( 'internalformat','GLenum' ))
glTextureBufferEXT.add( Input( 'buffer','GLuint' ))
glTextureBufferEXT.version = '2.0'
glTextureBufferEXT.category = 'GL_EXT_direct_state_access'
glTextureBufferEXT.trace = True
glTextureBufferEXT.play = True
gl.add(glTextureBufferEXT)

glTextureImage1DEXT = Function('glTextureImage1DEXT')
glTextureImage1DEXT.ret = Return('void')
glTextureImage1DEXT.add( Input( 'texture','GLuint' ))
glTextureImage1DEXT.add( Input( 'target','GLenum' ))
glTextureImage1DEXT.add( Input( 'level','GLint' ))
glTextureImage1DEXT.add( Input( 'internalformat','GLint' ,regalLog = 'internalFormatToString(internalformat)' ))
glTextureImage1DEXT.add( Input( 'width','GLsizei' ))
glTextureImage1DEXT.add( Input( 'border','GLint' ))
glTextureImage1DEXT.add( Input( 'format','GLenum' ))
glTextureImage1DEXT.add( Input( 'type','GLenum' ))
glTextureImage1DEXT.add( Input( 'pixels','const GLvoid *' ))
glTextureImage1DEXT.version = '1.1'
glTextureImage1DEXT.category = 'GL_EXT_direct_state_access'
glTextureImage1DEXT.trace = True
glTextureImage1DEXT.play = True
gl.add(glTextureImage1DEXT)

glTextureImage2DEXT = Function('glTextureImage2DEXT')
glTextureImage2DEXT.ret = Return('void')
glTextureImage2DEXT.add( Input( 'texture','GLuint' ))
glTextureImage2DEXT.add( Input( 'target','GLenum' ))
glTextureImage2DEXT.add( Input( 'level','GLint' ))
glTextureImage2DEXT.add( Input( 'internalformat','GLint' ,regalLog = 'internalFormatToString(internalformat)' ))
glTextureImage2DEXT.add( Input( 'width','GLsizei' ))
glTextureImage2DEXT.add( Input( 'height','GLsizei' ))
glTextureImage2DEXT.add( Input( 'border','GLint' ))
glTextureImage2DEXT.add( Input( 'format','GLenum' ))
glTextureImage2DEXT.add( Input( 'type','GLenum' ))
glTextureImage2DEXT.add( Input( 'pixels','const GLvoid *' ))
glTextureImage2DEXT.version = '1.1'
glTextureImage2DEXT.category = 'GL_EXT_direct_state_access'
glTextureImage2DEXT.trace = True
glTextureImage2DEXT.play = True
gl.add(glTextureImage2DEXT)

glTextureImage3DEXT = Function('glTextureImage3DEXT')
glTextureImage3DEXT.ret = Return('void')
glTextureImage3DEXT.add( Input( 'texture','GLuint' ))
glTextureImage3DEXT.add( Input( 'target','GLenum' ))
glTextureImage3DEXT.add( Input( 'level','GLint' ))
glTextureImage3DEXT.add( Input( 'internalformat','GLint' ,regalLog = 'internalFormatToString(internalformat)' ))
glTextureImage3DEXT.add( Input( 'width','GLsizei' ))
glTextureImage3DEXT.add( Input( 'height','GLsizei' ))
glTextureImage3DEXT.add( Input( 'depth','GLsizei' ))
glTextureImage3DEXT.add( Input( 'border','GLint' ))
glTextureImage3DEXT.add( Input( 'format','GLenum' ))
glTextureImage3DEXT.add( Input( 'type','GLenum' ))
glTextureImage3DEXT.add( Input( 'pixels','const GLvoid *' ))
glTextureImage3DEXT.version = '1.2'
glTextureImage3DEXT.category = 'GL_EXT_direct_state_access'
glTextureImage3DEXT.trace = True
glTextureImage3DEXT.play = True
gl.add(glTextureImage3DEXT)

glTextureParameterIivEXT = Function('glTextureParameterIivEXT')
glTextureParameterIivEXT.ret = Return('void')
glTextureParameterIivEXT.add( Input( 'texture','GLuint' ))
glTextureParameterIivEXT.add( Input( 'target','GLenum' ))
glTextureParameterIivEXT.add( Input( 'pname','GLenum' ))
glTextureParameterIivEXT.add( Input( 'params','const GLint *' ))
glTextureParameterIivEXT.version = '1.1'
glTextureParameterIivEXT.category = 'GL_EXT_direct_state_access'
glTextureParameterIivEXT.trace = True
glTextureParameterIivEXT.play = True
gl.add(glTextureParameterIivEXT)

glTextureParameterIuivEXT = Function('glTextureParameterIuivEXT')
glTextureParameterIuivEXT.ret = Return('void')
glTextureParameterIuivEXT.add( Input( 'texture','GLuint' ))
glTextureParameterIuivEXT.add( Input( 'target','GLenum' ))
glTextureParameterIuivEXT.add( Input( 'pname','GLenum' ))
glTextureParameterIuivEXT.add( Input( 'params','const GLuint *' ))
glTextureParameterIuivEXT.version = '1.1'
glTextureParameterIuivEXT.category = 'GL_EXT_direct_state_access'
glTextureParameterIuivEXT.trace = True
glTextureParameterIuivEXT.play = True
gl.add(glTextureParameterIuivEXT)

glTextureParameterfEXT = Function('glTextureParameterfEXT')
glTextureParameterfEXT.ret = Return('void')
glTextureParameterfEXT.add( Input( 'texture','GLuint' ))
glTextureParameterfEXT.add( Input( 'target','GLenum' ))
glTextureParameterfEXT.add( Input( 'pname','GLenum' ))
glTextureParameterfEXT.add( Input( 'param','GLfloat' ))
glTextureParameterfEXT.version = '1.1'
glTextureParameterfEXT.category = 'GL_EXT_direct_state_access'
glTextureParameterfEXT.trace = True
glTextureParameterfEXT.play = True
gl.add(glTextureParameterfEXT)

glTextureParameterfvEXT = Function('glTextureParameterfvEXT')
glTextureParameterfvEXT.ret = Return('void')
glTextureParameterfvEXT.add( Input( 'texture','GLuint' ))
glTextureParameterfvEXT.add( Input( 'target','GLenum' ))
glTextureParameterfvEXT.add( Input( 'pname','GLenum' ))
glTextureParameterfvEXT.add( Input( 'param','const GLfloat *' ,size = 'helperGLTexParametervSize(pname)' ))
glTextureParameterfvEXT.version = '1.1'
glTextureParameterfvEXT.category = 'GL_EXT_direct_state_access'
glTextureParameterfvEXT.trace = True
glTextureParameterfvEXT.play = True
gl.add(glTextureParameterfvEXT)

glTextureParameteriEXT = Function('glTextureParameteriEXT')
glTextureParameteriEXT.ret = Return('void')
glTextureParameteriEXT.add( Input( 'texture','GLuint' ))
glTextureParameteriEXT.add( Input( 'target','GLenum' ))
glTextureParameteriEXT.add( Input( 'pname','GLenum' ))
glTextureParameteriEXT.add( Input( 'param','GLint' ))
glTextureParameteriEXT.version = '1.1'
glTextureParameteriEXT.category = 'GL_EXT_direct_state_access'
glTextureParameteriEXT.trace = True
glTextureParameteriEXT.play = True
gl.add(glTextureParameteriEXT)

glTextureParameterivEXT = Function('glTextureParameterivEXT')
glTextureParameterivEXT.ret = Return('void')
glTextureParameterivEXT.add( Input( 'texture','GLuint' ))
glTextureParameterivEXT.add( Input( 'target','GLenum' ))
glTextureParameterivEXT.add( Input( 'pname','GLenum' ))
glTextureParameterivEXT.add( Input( 'param','const GLint *' ,size = 'helperGLTexParametervSize(pname)' ))
glTextureParameterivEXT.version = '1.1'
glTextureParameterivEXT.category = 'GL_EXT_direct_state_access'
glTextureParameterivEXT.trace = True
glTextureParameterivEXT.play = True
gl.add(glTextureParameterivEXT)

glTextureRenderbufferEXT = Function('glTextureRenderbufferEXT')
glTextureRenderbufferEXT.ret = Return('void')
glTextureRenderbufferEXT.add( Input( 'texture','GLuint' ))
glTextureRenderbufferEXT.add( Input( 'target','GLenum' ))
glTextureRenderbufferEXT.add( Input( 'renderbuffer','GLuint' ))
glTextureRenderbufferEXT.version = '2.0'
glTextureRenderbufferEXT.category = 'GL_EXT_direct_state_access'
glTextureRenderbufferEXT.trace = True
glTextureRenderbufferEXT.play = True
gl.add(glTextureRenderbufferEXT)

glTextureSubImage1DEXT = Function('glTextureSubImage1DEXT')
glTextureSubImage1DEXT.ret = Return('void')
glTextureSubImage1DEXT.add( Input( 'texture','GLuint' ))
glTextureSubImage1DEXT.add( Input( 'target','GLenum' ))
glTextureSubImage1DEXT.add( Input( 'level','GLint' ))
glTextureSubImage1DEXT.add( Input( 'xoffset','GLint' ))
glTextureSubImage1DEXT.add( Input( 'width','GLsizei' ))
glTextureSubImage1DEXT.add( Input( 'format','GLenum' ))
glTextureSubImage1DEXT.add( Input( 'type','GLenum' ))
glTextureSubImage1DEXT.add( Input( 'pixels','const GLvoid *' ))
glTextureSubImage1DEXT.version = '1.1'
glTextureSubImage1DEXT.category = 'GL_EXT_direct_state_access'
glTextureSubImage1DEXT.trace = True
glTextureSubImage1DEXT.play = True
gl.add(glTextureSubImage1DEXT)

glTextureSubImage2DEXT = Function('glTextureSubImage2DEXT')
glTextureSubImage2DEXT.ret = Return('void')
glTextureSubImage2DEXT.add( Input( 'texture','GLuint' ))
glTextureSubImage2DEXT.add( Input( 'target','GLenum' ))
glTextureSubImage2DEXT.add( Input( 'level','GLint' ))
glTextureSubImage2DEXT.add( Input( 'xoffset','GLint' ))
glTextureSubImage2DEXT.add( Input( 'yoffset','GLint' ))
glTextureSubImage2DEXT.add( Input( 'width','GLsizei' ))
glTextureSubImage2DEXT.add( Input( 'height','GLsizei' ))
glTextureSubImage2DEXT.add( Input( 'format','GLenum' ))
glTextureSubImage2DEXT.add( Input( 'type','GLenum' ))
glTextureSubImage2DEXT.add( Input( 'pixels','const GLvoid *' ))
glTextureSubImage2DEXT.version = '1.1'
glTextureSubImage2DEXT.category = 'GL_EXT_direct_state_access'
glTextureSubImage2DEXT.trace = True
glTextureSubImage2DEXT.play = True
gl.add(glTextureSubImage2DEXT)

glTextureSubImage3DEXT = Function('glTextureSubImage3DEXT')
glTextureSubImage3DEXT.ret = Return('void')
glTextureSubImage3DEXT.add( Input( 'texture','GLuint' ))
glTextureSubImage3DEXT.add( Input( 'target','GLenum' ))
glTextureSubImage3DEXT.add( Input( 'level','GLint' ))
glTextureSubImage3DEXT.add( Input( 'xoffset','GLint' ))
glTextureSubImage3DEXT.add( Input( 'yoffset','GLint' ))
glTextureSubImage3DEXT.add( Input( 'zoffset','GLint' ))
glTextureSubImage3DEXT.add( Input( 'width','GLsizei' ))
glTextureSubImage3DEXT.add( Input( 'height','GLsizei' ))
glTextureSubImage3DEXT.add( Input( 'depth','GLsizei' ))
glTextureSubImage3DEXT.add( Input( 'format','GLenum' ))
glTextureSubImage3DEXT.add( Input( 'type','GLenum' ))
glTextureSubImage3DEXT.add( Input( 'pixels','const GLvoid *' ))
glTextureSubImage3DEXT.version = '1.2'
glTextureSubImage3DEXT.category = 'GL_EXT_direct_state_access'
glTextureSubImage3DEXT.trace = True
glTextureSubImage3DEXT.play = True
gl.add(glTextureSubImage3DEXT)

glUnmapNamedBufferEXT = Function('glUnmapNamedBufferEXT')
glUnmapNamedBufferEXT.ret = Return('GLboolean')
glUnmapNamedBufferEXT.add( Input( 'buffer','GLuint' ))
glUnmapNamedBufferEXT.version = '1.5'
glUnmapNamedBufferEXT.category = 'GL_EXT_direct_state_access'
glUnmapNamedBufferEXT.trace = True
glUnmapNamedBufferEXT.play = True
gl.add(glUnmapNamedBufferEXT)

glVertexArrayColorOffsetEXT = Function('glVertexArrayColorOffsetEXT')
glVertexArrayColorOffsetEXT.ret = Return('void')
glVertexArrayColorOffsetEXT.add( Input( 'vaobj','GLuint' ))
glVertexArrayColorOffsetEXT.add( Input( 'buffer','GLuint' ))
glVertexArrayColorOffsetEXT.add( Input( 'size','GLint' ))
glVertexArrayColorOffsetEXT.add( Input( 'type','GLenum' ))
glVertexArrayColorOffsetEXT.add( Input( 'stride','GLsizei' ))
glVertexArrayColorOffsetEXT.add( Input( 'offset','const GLintptr' ))
glVertexArrayColorOffsetEXT.version = '3.0'
glVertexArrayColorOffsetEXT.category = 'GL_EXT_direct_state_access'
glVertexArrayColorOffsetEXT.trace = True
glVertexArrayColorOffsetEXT.play = True
gl.add(glVertexArrayColorOffsetEXT)

glVertexArrayEdgeFlagOffsetEXT = Function('glVertexArrayEdgeFlagOffsetEXT')
glVertexArrayEdgeFlagOffsetEXT.ret = Return('void')
glVertexArrayEdgeFlagOffsetEXT.add( Input( 'vaobj','GLuint' ))
glVertexArrayEdgeFlagOffsetEXT.add( Input( 'buffer','GLuint' ))
glVertexArrayEdgeFlagOffsetEXT.add( Input( 'stride','GLsizei' ))
glVertexArrayEdgeFlagOffsetEXT.add( Input( 'offset','const GLintptr' ))
glVertexArrayEdgeFlagOffsetEXT.version = '3.0'
glVertexArrayEdgeFlagOffsetEXT.category = 'GL_EXT_direct_state_access'
glVertexArrayEdgeFlagOffsetEXT.trace = True
glVertexArrayEdgeFlagOffsetEXT.play = True
gl.add(glVertexArrayEdgeFlagOffsetEXT)

glVertexArrayFogCoordOffsetEXT = Function('glVertexArrayFogCoordOffsetEXT')
glVertexArrayFogCoordOffsetEXT.ret = Return('void')
glVertexArrayFogCoordOffsetEXT.add( Input( 'vaobj','GLuint' ))
glVertexArrayFogCoordOffsetEXT.add( Input( 'buffer','GLuint' ))
glVertexArrayFogCoordOffsetEXT.add( Input( 'type','GLenum' ))
glVertexArrayFogCoordOffsetEXT.add( Input( 'stride','GLsizei' ))
glVertexArrayFogCoordOffsetEXT.add( Input( 'offset','const GLintptr' ))
glVertexArrayFogCoordOffsetEXT.version = '3.0'
glVertexArrayFogCoordOffsetEXT.category = 'GL_EXT_direct_state_access'
glVertexArrayFogCoordOffsetEXT.trace = True
glVertexArrayFogCoordOffsetEXT.play = True
gl.add(glVertexArrayFogCoordOffsetEXT)

glVertexArrayIndexOffsetEXT = Function('glVertexArrayIndexOffsetEXT')
glVertexArrayIndexOffsetEXT.ret = Return('void')
glVertexArrayIndexOffsetEXT.add( Input( 'vaobj','GLuint' ))
glVertexArrayIndexOffsetEXT.add( Input( 'buffer','GLuint' ))
glVertexArrayIndexOffsetEXT.add( Input( 'type','GLenum' ))
glVertexArrayIndexOffsetEXT.add( Input( 'stride','GLsizei' ))
glVertexArrayIndexOffsetEXT.add( Input( 'offset','const GLintptr' ))
glVertexArrayIndexOffsetEXT.version = '3.0'
glVertexArrayIndexOffsetEXT.category = 'GL_EXT_direct_state_access'
glVertexArrayIndexOffsetEXT.trace = True
glVertexArrayIndexOffsetEXT.play = True
gl.add(glVertexArrayIndexOffsetEXT)

glVertexArrayMultiTexCoordOffsetEXT = Function('glVertexArrayMultiTexCoordOffsetEXT')
glVertexArrayMultiTexCoordOffsetEXT.ret = Return('void')
glVertexArrayMultiTexCoordOffsetEXT.add( Input( 'vaobj','GLuint' ))
glVertexArrayMultiTexCoordOffsetEXT.add( Input( 'buffer','GLuint' ))
glVertexArrayMultiTexCoordOffsetEXT.add( Input( 'texunit','GLenum' ))
glVertexArrayMultiTexCoordOffsetEXT.add( Input( 'size','GLint' ))
glVertexArrayMultiTexCoordOffsetEXT.add( Input( 'type','GLenum' ))
glVertexArrayMultiTexCoordOffsetEXT.add( Input( 'stride','GLsizei' ))
glVertexArrayMultiTexCoordOffsetEXT.add( Input( 'offset','const GLintptr' ))
glVertexArrayMultiTexCoordOffsetEXT.version = '3.0'
glVertexArrayMultiTexCoordOffsetEXT.category = 'GL_EXT_direct_state_access'
glVertexArrayMultiTexCoordOffsetEXT.trace = True
glVertexArrayMultiTexCoordOffsetEXT.play = True
gl.add(glVertexArrayMultiTexCoordOffsetEXT)

glVertexArrayNormalOffsetEXT = Function('glVertexArrayNormalOffsetEXT')
glVertexArrayNormalOffsetEXT.ret = Return('void')
glVertexArrayNormalOffsetEXT.add( Input( 'vaobj','GLuint' ))
glVertexArrayNormalOffsetEXT.add( Input( 'buffer','GLuint' ))
glVertexArrayNormalOffsetEXT.add( Input( 'type','GLenum' ))
glVertexArrayNormalOffsetEXT.add( Input( 'stride','GLsizei' ))
glVertexArrayNormalOffsetEXT.add( Input( 'offset','const GLintptr' ))
glVertexArrayNormalOffsetEXT.version = '3.0'
glVertexArrayNormalOffsetEXT.category = 'GL_EXT_direct_state_access'
glVertexArrayNormalOffsetEXT.trace = True
glVertexArrayNormalOffsetEXT.play = True
gl.add(glVertexArrayNormalOffsetEXT)

glVertexArraySecondaryColorOffsetEXT = Function('glVertexArraySecondaryColorOffsetEXT')
glVertexArraySecondaryColorOffsetEXT.ret = Return('void')
glVertexArraySecondaryColorOffsetEXT.add( Input( 'vaobj','GLuint' ))
glVertexArraySecondaryColorOffsetEXT.add( Input( 'buffer','GLuint' ))
glVertexArraySecondaryColorOffsetEXT.add( Input( 'size','GLint' ))
glVertexArraySecondaryColorOffsetEXT.add( Input( 'type','GLenum' ))
glVertexArraySecondaryColorOffsetEXT.add( Input( 'stride','GLsizei' ))
glVertexArraySecondaryColorOffsetEXT.add( Input( 'offset','const GLintptr' ))
glVertexArraySecondaryColorOffsetEXT.version = '3.0'
glVertexArraySecondaryColorOffsetEXT.category = 'GL_EXT_direct_state_access'
glVertexArraySecondaryColorOffsetEXT.trace = True
glVertexArraySecondaryColorOffsetEXT.play = True
gl.add(glVertexArraySecondaryColorOffsetEXT)

glVertexArrayTexCoordOffsetEXT = Function('glVertexArrayTexCoordOffsetEXT')
glVertexArrayTexCoordOffsetEXT.ret = Return('void')
glVertexArrayTexCoordOffsetEXT.add( Input( 'vaobj','GLuint' ))
glVertexArrayTexCoordOffsetEXT.add( Input( 'buffer','GLuint' ))
glVertexArrayTexCoordOffsetEXT.add( Input( 'size','GLint' ))
glVertexArrayTexCoordOffsetEXT.add( Input( 'type','GLenum' ))
glVertexArrayTexCoordOffsetEXT.add( Input( 'stride','GLsizei' ))
glVertexArrayTexCoordOffsetEXT.add( Input( 'offset','const GLintptr' ))
glVertexArrayTexCoordOffsetEXT.version = '3.0'
glVertexArrayTexCoordOffsetEXT.category = 'GL_EXT_direct_state_access'
glVertexArrayTexCoordOffsetEXT.trace = True
glVertexArrayTexCoordOffsetEXT.play = True
gl.add(glVertexArrayTexCoordOffsetEXT)

glVertexArrayVertexAttribIOffsetEXT = Function('glVertexArrayVertexAttribIOffsetEXT')
glVertexArrayVertexAttribIOffsetEXT.ret = Return('void')
glVertexArrayVertexAttribIOffsetEXT.add( Input( 'vaobj','GLuint' ))
glVertexArrayVertexAttribIOffsetEXT.add( Input( 'buffer','GLuint' ))
glVertexArrayVertexAttribIOffsetEXT.add( Input( 'index','GLuint' ))
glVertexArrayVertexAttribIOffsetEXT.add( Input( 'size','GLint' ))
glVertexArrayVertexAttribIOffsetEXT.add( Input( 'type','GLenum' ))
glVertexArrayVertexAttribIOffsetEXT.add( Input( 'stride','GLsizei' ))
glVertexArrayVertexAttribIOffsetEXT.add( Input( 'offset','const GLintptr' ))
glVertexArrayVertexAttribIOffsetEXT.version = '3.0'
glVertexArrayVertexAttribIOffsetEXT.category = 'GL_EXT_direct_state_access'
glVertexArrayVertexAttribIOffsetEXT.trace = True
glVertexArrayVertexAttribIOffsetEXT.play = True
gl.add(glVertexArrayVertexAttribIOffsetEXT)

glVertexArrayVertexAttribOffsetEXT = Function('glVertexArrayVertexAttribOffsetEXT')
glVertexArrayVertexAttribOffsetEXT.ret = Return('void')
glVertexArrayVertexAttribOffsetEXT.add( Input( 'vaobj','GLuint' ))
glVertexArrayVertexAttribOffsetEXT.add( Input( 'buffer','GLuint' ))
glVertexArrayVertexAttribOffsetEXT.add( Input( 'index','GLuint' ))
glVertexArrayVertexAttribOffsetEXT.add( Input( 'size','GLint' ))
glVertexArrayVertexAttribOffsetEXT.add( Input( 'type','GLenum' ))
glVertexArrayVertexAttribOffsetEXT.add( Input( 'normalized','GLboolean' ))
glVertexArrayVertexAttribOffsetEXT.add( Input( 'stride','GLsizei' ))
glVertexArrayVertexAttribOffsetEXT.add( Input( 'offset','const GLintptr' ))
glVertexArrayVertexAttribOffsetEXT.version = '3.0'
glVertexArrayVertexAttribOffsetEXT.category = 'GL_EXT_direct_state_access'
glVertexArrayVertexAttribOffsetEXT.trace = True
glVertexArrayVertexAttribOffsetEXT.play = True
gl.add(glVertexArrayVertexAttribOffsetEXT)

glVertexArrayVertexOffsetEXT = Function('glVertexArrayVertexOffsetEXT')
glVertexArrayVertexOffsetEXT.ret = Return('void')
glVertexArrayVertexOffsetEXT.add( Input( 'vaobj','GLuint' ))
glVertexArrayVertexOffsetEXT.add( Input( 'buffer','GLuint' ))
glVertexArrayVertexOffsetEXT.add( Input( 'size','GLint' ))
glVertexArrayVertexOffsetEXT.add( Input( 'type','GLenum' ))
glVertexArrayVertexOffsetEXT.add( Input( 'stride','GLsizei' ))
glVertexArrayVertexOffsetEXT.add( Input( 'offset','const GLintptr' ))
glVertexArrayVertexOffsetEXT.version = '3.0'
glVertexArrayVertexOffsetEXT.category = 'GL_EXT_direct_state_access'
glVertexArrayVertexOffsetEXT.trace = True
glVertexArrayVertexOffsetEXT.play = True
gl.add(glVertexArrayVertexOffsetEXT)

# GL_EXT_discard_framebuffer

glDiscardFramebufferEXT = Function('glDiscardFramebufferEXT')
glDiscardFramebufferEXT.ret = Return('void')
glDiscardFramebufferEXT.add( Input( 'target','GLenum' ))
glDiscardFramebufferEXT.add( Input( 'numAttachments','GLsizei' ))
glDiscardFramebufferEXT.add( Input( 'attachments','const GLenum *' ))
glDiscardFramebufferEXT.version = ''
glDiscardFramebufferEXT.category = 'GL_EXT_discard_framebuffer'
glDiscardFramebufferEXT.trace = True
glDiscardFramebufferEXT.play = True
gl.add(glDiscardFramebufferEXT)

# GL_EXT_disjoint_timer_query

glGetQueryObjectivEXT = Function('glGetQueryObjectivEXT')
glGetQueryObjectivEXT.ret = Return('void')
glGetQueryObjectivEXT.add( Input( 'id','GLuint' ))
glGetQueryObjectivEXT.add( Input( 'pname','GLenum' ))
glGetQueryObjectivEXT.add( Input( 'params','GLint *' ))
glGetQueryObjectivEXT.version = ''
glGetQueryObjectivEXT.category = 'GL_EXT_disjoint_timer_query'
glGetQueryObjectivEXT.trace = True
glGetQueryObjectivEXT.play = True
gl.add(glGetQueryObjectivEXT)

glQueryCounterEXT = Function('glQueryCounterEXT')
glQueryCounterEXT.ret = Return('void')
glQueryCounterEXT.add( Input( 'id','GLuint' ))
glQueryCounterEXT.add( Input( 'target','GLenum' ))
glQueryCounterEXT.version = ''
glQueryCounterEXT.category = 'GL_EXT_disjoint_timer_query'
glQueryCounterEXT.trace = True
glQueryCounterEXT.play = True
gl.add(glQueryCounterEXT)

# GL_EXT_draw_buffers2

glColorMaskIndexedEXT = Function('glColorMaskIndexedEXT')
glColorMaskIndexedEXT.ret = Return('void')
glColorMaskIndexedEXT.add( Input( 'buf','GLuint' ))
glColorMaskIndexedEXT.add( Input( 'r','GLboolean' ))
glColorMaskIndexedEXT.add( Input( 'g','GLboolean' ))
glColorMaskIndexedEXT.add( Input( 'b','GLboolean' ))
glColorMaskIndexedEXT.add( Input( 'a','GLboolean' ))
glColorMaskIndexedEXT.version = '2.0'
glColorMaskIndexedEXT.category = 'GL_EXT_draw_buffers2'
glColorMaskIndexedEXT.trace = True
glColorMaskIndexedEXT.play = True
gl.add(glColorMaskIndexedEXT)

glDisableIndexedEXT = Function('glDisableIndexedEXT')
glDisableIndexedEXT.ret = Return('void')
glDisableIndexedEXT.add( Input( 'target','GLenum' ))
glDisableIndexedEXT.add( Input( 'index','GLuint' ))
glDisableIndexedEXT.version = '2.0'
glDisableIndexedEXT.category = 'GL_EXT_draw_buffers2'
glDisableIndexedEXT.trace = True
glDisableIndexedEXT.play = True
gl.add(glDisableIndexedEXT)

glEnableIndexedEXT = Function('glEnableIndexedEXT')
glEnableIndexedEXT.ret = Return('void')
glEnableIndexedEXT.add( Input( 'target','GLenum' ))
glEnableIndexedEXT.add( Input( 'index','GLuint' ))
glEnableIndexedEXT.version = '2.0'
glEnableIndexedEXT.category = 'GL_EXT_draw_buffers2'
glEnableIndexedEXT.trace = True
glEnableIndexedEXT.play = True
gl.add(glEnableIndexedEXT)

glGetBooleanIndexedvEXT = Function('glGetBooleanIndexedvEXT')
glGetBooleanIndexedvEXT.ret = Return('void')
glGetBooleanIndexedvEXT.add( Input( 'value','GLenum' ))
glGetBooleanIndexedvEXT.add( Input( 'index','GLuint' ))
glGetBooleanIndexedvEXT.add( Output( 'data','GLboolean *' ))
glGetBooleanIndexedvEXT.version = '2.0'
glGetBooleanIndexedvEXT.category = 'GL_EXT_draw_buffers2'
glGetBooleanIndexedvEXT.trace = True
glGetBooleanIndexedvEXT.play = False
gl.add(glGetBooleanIndexedvEXT)

glGetIntegerIndexedvEXT = Function('glGetIntegerIndexedvEXT')
glGetIntegerIndexedvEXT.ret = Return('void')
glGetIntegerIndexedvEXT.add( Input( 'value','GLenum' ))
glGetIntegerIndexedvEXT.add( Input( 'index','GLuint' ))
glGetIntegerIndexedvEXT.add( Output( 'data','GLint *' ))
glGetIntegerIndexedvEXT.version = '2.0'
glGetIntegerIndexedvEXT.category = 'GL_EXT_draw_buffers2'
glGetIntegerIndexedvEXT.trace = True
glGetIntegerIndexedvEXT.play = False
gl.add(glGetIntegerIndexedvEXT)

glIsEnabledIndexedEXT = Function('glIsEnabledIndexedEXT')
glIsEnabledIndexedEXT.ret = Return('GLboolean')
glIsEnabledIndexedEXT.add( Input( 'target','GLenum' ))
glIsEnabledIndexedEXT.add( Input( 'index','GLuint' ))
glIsEnabledIndexedEXT.version = '2.0'
glIsEnabledIndexedEXT.category = 'GL_EXT_draw_buffers2'
glIsEnabledIndexedEXT.trace = True
glIsEnabledIndexedEXT.play = True
gl.add(glIsEnabledIndexedEXT)

# GL_EXT_draw_instanced

glDrawArraysInstancedEXT = Function('glDrawArraysInstancedEXT')
glDrawArraysInstancedEXT.ret = Return('void')
glDrawArraysInstancedEXT.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glDrawArraysInstancedEXT.add( Input( 'start','GLint' ))
glDrawArraysInstancedEXT.add( Input( 'count','GLsizei' ))
glDrawArraysInstancedEXT.add( Input( 'primcount','GLsizei' ))
glDrawArraysInstancedEXT.version = '2.0'
glDrawArraysInstancedEXT.category = 'GL_EXT_draw_instanced'
glDrawArraysInstancedEXT.trace = True
glDrawArraysInstancedEXT.play = True
gl.add(glDrawArraysInstancedEXT)

glDrawElementsInstancedEXT = Function('glDrawElementsInstancedEXT')
glDrawElementsInstancedEXT.ret = Return('void')
glDrawElementsInstancedEXT.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glDrawElementsInstancedEXT.add( Input( 'count','GLsizei' ))
glDrawElementsInstancedEXT.add( Input( 'type','GLenum' ))
glDrawElementsInstancedEXT.add( Input( 'indices','const GLvoid *' ))
glDrawElementsInstancedEXT.add( Input( 'primcount','GLsizei' ))
glDrawElementsInstancedEXT.version = '2.0'
glDrawElementsInstancedEXT.category = 'GL_EXT_draw_instanced'
glDrawElementsInstancedEXT.trace = True
glDrawElementsInstancedEXT.play = True
gl.add(glDrawElementsInstancedEXT)

# GL_EXT_draw_range_elements

glDrawRangeElementsEXT = Function('glDrawRangeElementsEXT')
glDrawRangeElementsEXT.ret = Return('void')
glDrawRangeElementsEXT.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glDrawRangeElementsEXT.add( Input( 'start','GLuint' ))
glDrawRangeElementsEXT.add( Input( 'end','GLuint' ))
glDrawRangeElementsEXT.add( Input( 'count','GLsizei' ))
glDrawRangeElementsEXT.add( Input( 'type','GLenum' ))
glDrawRangeElementsEXT.add( Input( 'indices','const GLvoid *' ))
glDrawRangeElementsEXT.version = '1.2'
glDrawRangeElementsEXT.category = 'GL_EXT_draw_range_elements'
glDrawRangeElementsEXT.trace = True
glDrawRangeElementsEXT.play = True
gl.add(glDrawRangeElementsEXT)

# GL_EXT_fog_coord

glFogCoordPointerEXT = Function('glFogCoordPointerEXT')
glFogCoordPointerEXT.ret = Return('void')
glFogCoordPointerEXT.add( Input( 'type','GLenum' ))
glFogCoordPointerEXT.add( Input( 'stride','GLsizei' ))
glFogCoordPointerEXT.add( Input( 'pointer','const GLvoid *' ))
glFogCoordPointerEXT.version = '1.1'
glFogCoordPointerEXT.category = 'GL_EXT_fog_coord'
glFogCoordPointerEXT.trace = True
glFogCoordPointerEXT.play = True
gl.add(glFogCoordPointerEXT)

glFogCoorddEXT = Function('glFogCoorddEXT')
glFogCoorddEXT.ret = Return('void')
glFogCoorddEXT.add( Input( 'coord','GLdouble' ))
glFogCoorddEXT.version = '1.1'
glFogCoorddEXT.category = 'GL_EXT_fog_coord'
glFogCoorddEXT.trace = True
glFogCoorddEXT.play = True
gl.add(glFogCoorddEXT)

glFogCoorddvEXT = Function('glFogCoorddvEXT')
glFogCoorddvEXT.ret = Return('void')
glFogCoorddvEXT.add( Input( 'coord','const GLdouble *' ,size = 1 ))
glFogCoorddvEXT.version = '1.1'
glFogCoorddvEXT.category = 'GL_EXT_fog_coord'
glFogCoorddvEXT.trace = True
glFogCoorddvEXT.play = True
gl.add(glFogCoorddvEXT)

glFogCoordfEXT = Function('glFogCoordfEXT')
glFogCoordfEXT.ret = Return('void')
glFogCoordfEXT.add( Input( 'coord','GLfloat' ))
glFogCoordfEXT.version = '1.1'
glFogCoordfEXT.category = 'GL_EXT_fog_coord'
glFogCoordfEXT.trace = True
glFogCoordfEXT.play = True
gl.add(glFogCoordfEXT)

glFogCoordfvEXT = Function('glFogCoordfvEXT')
glFogCoordfvEXT.ret = Return('void')
glFogCoordfvEXT.add( Input( 'coord','const GLfloat *' ,size = 1 ))
glFogCoordfvEXT.version = '1.1'
glFogCoordfvEXT.category = 'GL_EXT_fog_coord'
glFogCoordfvEXT.trace = True
glFogCoordfvEXT.play = True
gl.add(glFogCoordfvEXT)

# GL_EXT_fragment_lighting

glFragmentColorMaterialEXT = Function('glFragmentColorMaterialEXT')
glFragmentColorMaterialEXT.ret = Return('void')
glFragmentColorMaterialEXT.add( Input( 'face','GLenum' ))
glFragmentColorMaterialEXT.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glFragmentColorMaterialEXT.version = ''
glFragmentColorMaterialEXT.category = 'GL_EXT_fragment_lighting'
glFragmentColorMaterialEXT.trace = True
glFragmentColorMaterialEXT.play = True
gl.add(glFragmentColorMaterialEXT)

glFragmentLightModelfEXT = Function('glFragmentLightModelfEXT')
glFragmentLightModelfEXT.ret = Return('void')
glFragmentLightModelfEXT.add( Input( 'pname','GLenum' ))
glFragmentLightModelfEXT.add( Input( 'param','GLfloat' ))
glFragmentLightModelfEXT.version = ''
glFragmentLightModelfEXT.category = 'GL_EXT_fragment_lighting'
glFragmentLightModelfEXT.trace = True
glFragmentLightModelfEXT.play = True
gl.add(glFragmentLightModelfEXT)

glFragmentLightModelfvEXT = Function('glFragmentLightModelfvEXT')
glFragmentLightModelfvEXT.ret = Return('void')
glFragmentLightModelfvEXT.add( Input( 'pname','GLenum' ))
glFragmentLightModelfvEXT.add( Input( 'params','GLfloat *' ))
glFragmentLightModelfvEXT.version = ''
glFragmentLightModelfvEXT.category = 'GL_EXT_fragment_lighting'
glFragmentLightModelfvEXT.trace = True
glFragmentLightModelfvEXT.play = True
gl.add(glFragmentLightModelfvEXT)

glFragmentLightModeliEXT = Function('glFragmentLightModeliEXT')
glFragmentLightModeliEXT.ret = Return('void')
glFragmentLightModeliEXT.add( Input( 'pname','GLenum' ))
glFragmentLightModeliEXT.add( Input( 'param','GLint' ))
glFragmentLightModeliEXT.version = ''
glFragmentLightModeliEXT.category = 'GL_EXT_fragment_lighting'
glFragmentLightModeliEXT.trace = True
glFragmentLightModeliEXT.play = True
gl.add(glFragmentLightModeliEXT)

glFragmentLightModelivEXT = Function('glFragmentLightModelivEXT')
glFragmentLightModelivEXT.ret = Return('void')
glFragmentLightModelivEXT.add( Input( 'pname','GLenum' ))
glFragmentLightModelivEXT.add( Input( 'params','GLint *' ))
glFragmentLightModelivEXT.version = ''
glFragmentLightModelivEXT.category = 'GL_EXT_fragment_lighting'
glFragmentLightModelivEXT.trace = True
glFragmentLightModelivEXT.play = True
gl.add(glFragmentLightModelivEXT)

glFragmentLightfEXT = Function('glFragmentLightfEXT')
glFragmentLightfEXT.ret = Return('void')
glFragmentLightfEXT.add( Input( 'light','GLenum' ))
glFragmentLightfEXT.add( Input( 'pname','GLenum' ))
glFragmentLightfEXT.add( Input( 'param','GLfloat' ))
glFragmentLightfEXT.version = ''
glFragmentLightfEXT.category = 'GL_EXT_fragment_lighting'
glFragmentLightfEXT.trace = True
glFragmentLightfEXT.play = True
gl.add(glFragmentLightfEXT)

glFragmentLightfvEXT = Function('glFragmentLightfvEXT')
glFragmentLightfvEXT.ret = Return('void')
glFragmentLightfvEXT.add( Input( 'light','GLenum' ))
glFragmentLightfvEXT.add( Input( 'pname','GLenum' ))
glFragmentLightfvEXT.add( Input( 'params','GLfloat *' ))
glFragmentLightfvEXT.version = ''
glFragmentLightfvEXT.category = 'GL_EXT_fragment_lighting'
glFragmentLightfvEXT.trace = True
glFragmentLightfvEXT.play = True
gl.add(glFragmentLightfvEXT)

glFragmentLightiEXT = Function('glFragmentLightiEXT')
glFragmentLightiEXT.ret = Return('void')
glFragmentLightiEXT.add( Input( 'light','GLenum' ))
glFragmentLightiEXT.add( Input( 'pname','GLenum' ))
glFragmentLightiEXT.add( Input( 'param','GLint' ))
glFragmentLightiEXT.version = ''
glFragmentLightiEXT.category = 'GL_EXT_fragment_lighting'
glFragmentLightiEXT.trace = True
glFragmentLightiEXT.play = True
gl.add(glFragmentLightiEXT)

glFragmentLightivEXT = Function('glFragmentLightivEXT')
glFragmentLightivEXT.ret = Return('void')
glFragmentLightivEXT.add( Input( 'light','GLenum' ))
glFragmentLightivEXT.add( Input( 'pname','GLenum' ))
glFragmentLightivEXT.add( Input( 'params','GLint *' ))
glFragmentLightivEXT.version = ''
glFragmentLightivEXT.category = 'GL_EXT_fragment_lighting'
glFragmentLightivEXT.trace = True
glFragmentLightivEXT.play = True
gl.add(glFragmentLightivEXT)

glFragmentMaterialfEXT = Function('glFragmentMaterialfEXT')
glFragmentMaterialfEXT.ret = Return('void')
glFragmentMaterialfEXT.add( Input( 'face','GLenum' ))
glFragmentMaterialfEXT.add( Input( 'pname','GLenum' ))
glFragmentMaterialfEXT.add( Input( 'param','const GLfloat' ))
glFragmentMaterialfEXT.version = ''
glFragmentMaterialfEXT.category = 'GL_EXT_fragment_lighting'
glFragmentMaterialfEXT.trace = True
glFragmentMaterialfEXT.play = True
gl.add(glFragmentMaterialfEXT)

glFragmentMaterialfvEXT = Function('glFragmentMaterialfvEXT')
glFragmentMaterialfvEXT.ret = Return('void')
glFragmentMaterialfvEXT.add( Input( 'face','GLenum' ))
glFragmentMaterialfvEXT.add( Input( 'pname','GLenum' ))
glFragmentMaterialfvEXT.add( Input( 'params','const GLfloat *' ))
glFragmentMaterialfvEXT.version = ''
glFragmentMaterialfvEXT.category = 'GL_EXT_fragment_lighting'
glFragmentMaterialfvEXT.trace = True
glFragmentMaterialfvEXT.play = True
gl.add(glFragmentMaterialfvEXT)

glFragmentMaterialiEXT = Function('glFragmentMaterialiEXT')
glFragmentMaterialiEXT.ret = Return('void')
glFragmentMaterialiEXT.add( Input( 'face','GLenum' ))
glFragmentMaterialiEXT.add( Input( 'pname','GLenum' ))
glFragmentMaterialiEXT.add( Input( 'param','const GLint' ))
glFragmentMaterialiEXT.version = ''
glFragmentMaterialiEXT.category = 'GL_EXT_fragment_lighting'
glFragmentMaterialiEXT.trace = True
glFragmentMaterialiEXT.play = True
gl.add(glFragmentMaterialiEXT)

glFragmentMaterialivEXT = Function('glFragmentMaterialivEXT')
glFragmentMaterialivEXT.ret = Return('void')
glFragmentMaterialivEXT.add( Input( 'face','GLenum' ))
glFragmentMaterialivEXT.add( Input( 'pname','GLenum' ))
glFragmentMaterialivEXT.add( Input( 'params','const GLint *' ))
glFragmentMaterialivEXT.version = ''
glFragmentMaterialivEXT.category = 'GL_EXT_fragment_lighting'
glFragmentMaterialivEXT.trace = True
glFragmentMaterialivEXT.play = True
gl.add(glFragmentMaterialivEXT)

glGetFragmentLightfvEXT = Function('glGetFragmentLightfvEXT')
glGetFragmentLightfvEXT.ret = Return('void')
glGetFragmentLightfvEXT.add( Input( 'light','GLenum' ))
glGetFragmentLightfvEXT.add( Input( 'pname','GLenum' ))
glGetFragmentLightfvEXT.add( Input( 'params','GLfloat *' ))
glGetFragmentLightfvEXT.version = ''
glGetFragmentLightfvEXT.category = 'GL_EXT_fragment_lighting'
glGetFragmentLightfvEXT.trace = True
glGetFragmentLightfvEXT.play = True
gl.add(glGetFragmentLightfvEXT)

glGetFragmentLightivEXT = Function('glGetFragmentLightivEXT')
glGetFragmentLightivEXT.ret = Return('void')
glGetFragmentLightivEXT.add( Input( 'light','GLenum' ))
glGetFragmentLightivEXT.add( Input( 'pname','GLenum' ))
glGetFragmentLightivEXT.add( Input( 'params','GLint *' ))
glGetFragmentLightivEXT.version = ''
glGetFragmentLightivEXT.category = 'GL_EXT_fragment_lighting'
glGetFragmentLightivEXT.trace = True
glGetFragmentLightivEXT.play = True
gl.add(glGetFragmentLightivEXT)

glGetFragmentMaterialfvEXT = Function('glGetFragmentMaterialfvEXT')
glGetFragmentMaterialfvEXT.ret = Return('void')
glGetFragmentMaterialfvEXT.add( Input( 'face','GLenum' ))
glGetFragmentMaterialfvEXT.add( Input( 'pname','GLenum' ))
glGetFragmentMaterialfvEXT.add( Input( 'params','const GLfloat *' ))
glGetFragmentMaterialfvEXT.version = ''
glGetFragmentMaterialfvEXT.category = 'GL_EXT_fragment_lighting'
glGetFragmentMaterialfvEXT.trace = True
glGetFragmentMaterialfvEXT.play = True
gl.add(glGetFragmentMaterialfvEXT)

glGetFragmentMaterialivEXT = Function('glGetFragmentMaterialivEXT')
glGetFragmentMaterialivEXT.ret = Return('void')
glGetFragmentMaterialivEXT.add( Input( 'face','GLenum' ))
glGetFragmentMaterialivEXT.add( Input( 'pname','GLenum' ))
glGetFragmentMaterialivEXT.add( Input( 'params','const GLint *' ))
glGetFragmentMaterialivEXT.version = ''
glGetFragmentMaterialivEXT.category = 'GL_EXT_fragment_lighting'
glGetFragmentMaterialivEXT.trace = True
glGetFragmentMaterialivEXT.play = True
gl.add(glGetFragmentMaterialivEXT)

glLightEnviEXT = Function('glLightEnviEXT')
glLightEnviEXT.ret = Return('void')
glLightEnviEXT.add( Input( 'pname','GLenum' ))
glLightEnviEXT.add( Input( 'param','GLint' ))
glLightEnviEXT.version = ''
glLightEnviEXT.category = 'GL_EXT_fragment_lighting'
glLightEnviEXT.trace = True
glLightEnviEXT.play = True
gl.add(glLightEnviEXT)

# GL_EXT_framebuffer_blit

glBlitFramebufferEXT = Function('glBlitFramebufferEXT')
glBlitFramebufferEXT.ret = Return('void')
glBlitFramebufferEXT.add( Input( 'srcX0','GLint' ))
glBlitFramebufferEXT.add( Input( 'srcY0','GLint' ))
glBlitFramebufferEXT.add( Input( 'srcX1','GLint' ))
glBlitFramebufferEXT.add( Input( 'srcY1','GLint' ))
glBlitFramebufferEXT.add( Input( 'dstX0','GLint' ))
glBlitFramebufferEXT.add( Input( 'dstY0','GLint' ))
glBlitFramebufferEXT.add( Input( 'dstX1','GLint' ))
glBlitFramebufferEXT.add( Input( 'dstY1','GLint' ))
glBlitFramebufferEXT.add( Input( 'mask','GLbitfield' ,regalLog = 'GLblitFramebufferToString(mask)' ))
glBlitFramebufferEXT.add( Input( 'filter','GLenum' ))
glBlitFramebufferEXT.version = '1.5'
glBlitFramebufferEXT.category = 'GL_EXT_framebuffer_blit'
glBlitFramebufferEXT.trace = True
glBlitFramebufferEXT.play = True
gl.add(glBlitFramebufferEXT)

# GL_EXT_framebuffer_multisample

glRenderbufferStorageMultisampleEXT = Function('glRenderbufferStorageMultisampleEXT')
glRenderbufferStorageMultisampleEXT.ret = Return('void')
glRenderbufferStorageMultisampleEXT.add( Input( 'target','GLenum' ))
glRenderbufferStorageMultisampleEXT.add( Input( 'samples','GLsizei' ))
glRenderbufferStorageMultisampleEXT.add( Input( 'internalformat','GLenum' ))
glRenderbufferStorageMultisampleEXT.add( Input( 'width','GLsizei' ))
glRenderbufferStorageMultisampleEXT.add( Input( 'height','GLsizei' ))
glRenderbufferStorageMultisampleEXT.version = '1.5'
glRenderbufferStorageMultisampleEXT.category = 'GL_EXT_framebuffer_multisample'
glRenderbufferStorageMultisampleEXT.trace = True
glRenderbufferStorageMultisampleEXT.play = True
gl.add(glRenderbufferStorageMultisampleEXT)

# GL_EXT_framebuffer_object

glBindFramebufferEXT = Function('glBindFramebufferEXT')
glBindFramebufferEXT.ret = Return('void')
glBindFramebufferEXT.add( Input( 'target','GLenum' ))
glBindFramebufferEXT.add( Input( 'framebuffer','GLuint' ))
glBindFramebufferEXT.version = '1.5'
glBindFramebufferEXT.category = 'GL_EXT_framebuffer_object'
glBindFramebufferEXT.trace = True
glBindFramebufferEXT.play = True
gl.add(glBindFramebufferEXT)

glBindRenderbufferEXT = Function('glBindRenderbufferEXT')
glBindRenderbufferEXT.ret = Return('void')
glBindRenderbufferEXT.add( Input( 'target','GLenum' ))
glBindRenderbufferEXT.add( Input( 'renderbuffer','GLuint' ))
glBindRenderbufferEXT.version = '1.5'
glBindRenderbufferEXT.category = 'GL_EXT_framebuffer_object'
glBindRenderbufferEXT.trace = True
glBindRenderbufferEXT.play = True
gl.add(glBindRenderbufferEXT)

glCheckFramebufferStatusEXT = Function('glCheckFramebufferStatusEXT')
glCheckFramebufferStatusEXT.ret = Return('GLenum')
glCheckFramebufferStatusEXT.add( Input( 'target','GLenum' ))
glCheckFramebufferStatusEXT.version = '1.5'
glCheckFramebufferStatusEXT.category = 'GL_EXT_framebuffer_object'
glCheckFramebufferStatusEXT.trace = True
glCheckFramebufferStatusEXT.play = True
gl.add(glCheckFramebufferStatusEXT)

glDeleteFramebuffersEXT = Function('glDeleteFramebuffersEXT')
glDeleteFramebuffersEXT.ret = Return('void')
glDeleteFramebuffersEXT.add( Input( 'n','GLsizei' ))
glDeleteFramebuffersEXT.add( Input( 'framebuffers','const GLuint *' ,size = 'n' ))
glDeleteFramebuffersEXT.version = '1.5'
glDeleteFramebuffersEXT.category = 'GL_EXT_framebuffer_object'
glDeleteFramebuffersEXT.trace = True
glDeleteFramebuffersEXT.play = True
gl.add(glDeleteFramebuffersEXT)

glDeleteRenderbuffersEXT = Function('glDeleteRenderbuffersEXT')
glDeleteRenderbuffersEXT.ret = Return('void')
glDeleteRenderbuffersEXT.add( Input( 'n','GLsizei' ))
glDeleteRenderbuffersEXT.add( Input( 'renderbuffers','const GLuint *' ,size = 'n' ))
glDeleteRenderbuffersEXT.version = '1.5'
glDeleteRenderbuffersEXT.category = 'GL_EXT_framebuffer_object'
glDeleteRenderbuffersEXT.trace = True
glDeleteRenderbuffersEXT.play = True
gl.add(glDeleteRenderbuffersEXT)

glFramebufferRenderbufferEXT = Function('glFramebufferRenderbufferEXT')
glFramebufferRenderbufferEXT.ret = Return('void')
glFramebufferRenderbufferEXT.add( Input( 'target','GLenum' ))
glFramebufferRenderbufferEXT.add( Input( 'attachment','GLenum' ))
glFramebufferRenderbufferEXT.add( Input( 'renderbuffertarget','GLenum' ))
glFramebufferRenderbufferEXT.add( Input( 'renderbuffer','GLuint' ))
glFramebufferRenderbufferEXT.version = '1.5'
glFramebufferRenderbufferEXT.category = 'GL_EXT_framebuffer_object'
glFramebufferRenderbufferEXT.trace = True
glFramebufferRenderbufferEXT.play = True
gl.add(glFramebufferRenderbufferEXT)

glFramebufferTexture1DEXT = Function('glFramebufferTexture1DEXT')
glFramebufferTexture1DEXT.ret = Return('void')
glFramebufferTexture1DEXT.add( Input( 'target','GLenum' ))
glFramebufferTexture1DEXT.add( Input( 'attachment','GLenum' ))
glFramebufferTexture1DEXT.add( Input( 'textarget','GLenum' ))
glFramebufferTexture1DEXT.add( Input( 'texture','GLuint' ))
glFramebufferTexture1DEXT.add( Input( 'level','GLint' ))
glFramebufferTexture1DEXT.version = '1.5'
glFramebufferTexture1DEXT.category = 'GL_EXT_framebuffer_object'
glFramebufferTexture1DEXT.trace = True
glFramebufferTexture1DEXT.play = True
gl.add(glFramebufferTexture1DEXT)

glFramebufferTexture2DEXT = Function('glFramebufferTexture2DEXT')
glFramebufferTexture2DEXT.ret = Return('void')
glFramebufferTexture2DEXT.add( Input( 'target','GLenum' ))
glFramebufferTexture2DEXT.add( Input( 'attachment','GLenum' ))
glFramebufferTexture2DEXT.add( Input( 'textarget','GLenum' ))
glFramebufferTexture2DEXT.add( Input( 'texture','GLuint' ))
glFramebufferTexture2DEXT.add( Input( 'level','GLint' ))
glFramebufferTexture2DEXT.version = '1.5'
glFramebufferTexture2DEXT.category = 'GL_EXT_framebuffer_object'
glFramebufferTexture2DEXT.trace = True
glFramebufferTexture2DEXT.play = True
gl.add(glFramebufferTexture2DEXT)

glFramebufferTexture3DEXT = Function('glFramebufferTexture3DEXT')
glFramebufferTexture3DEXT.ret = Return('void')
glFramebufferTexture3DEXT.add( Input( 'target','GLenum' ))
glFramebufferTexture3DEXT.add( Input( 'attachment','GLenum' ))
glFramebufferTexture3DEXT.add( Input( 'textarget','GLenum' ))
glFramebufferTexture3DEXT.add( Input( 'texture','GLuint' ))
glFramebufferTexture3DEXT.add( Input( 'level','GLint' ))
glFramebufferTexture3DEXT.add( Input( 'zoffset','GLint' ))
glFramebufferTexture3DEXT.version = '1.5'
glFramebufferTexture3DEXT.category = 'GL_EXT_framebuffer_object'
glFramebufferTexture3DEXT.trace = True
glFramebufferTexture3DEXT.play = True
gl.add(glFramebufferTexture3DEXT)

glGenFramebuffersEXT = Function('glGenFramebuffersEXT')
glGenFramebuffersEXT.ret = Return('void')
glGenFramebuffersEXT.add( Input( 'n','GLsizei' ))
glGenFramebuffersEXT.add( Output( 'framebuffers','GLuint *' ,size = 'n' ))
glGenFramebuffersEXT.version = '1.5'
glGenFramebuffersEXT.category = 'GL_EXT_framebuffer_object'
glGenFramebuffersEXT.trace = True
glGenFramebuffersEXT.play = True
gl.add(glGenFramebuffersEXT)

glGenRenderbuffersEXT = Function('glGenRenderbuffersEXT')
glGenRenderbuffersEXT.ret = Return('void')
glGenRenderbuffersEXT.add( Input( 'n','GLsizei' ))
glGenRenderbuffersEXT.add( Output( 'renderbuffers','GLuint *' ,size = 'n' ))
glGenRenderbuffersEXT.version = '1.5'
glGenRenderbuffersEXT.category = 'GL_EXT_framebuffer_object'
glGenRenderbuffersEXT.trace = True
glGenRenderbuffersEXT.play = True
gl.add(glGenRenderbuffersEXT)

glGenerateMipmapEXT = Function('glGenerateMipmapEXT')
glGenerateMipmapEXT.ret = Return('void')
glGenerateMipmapEXT.add( Input( 'target','GLenum' ))
glGenerateMipmapEXT.version = '1.5'
glGenerateMipmapEXT.category = 'GL_EXT_framebuffer_object'
glGenerateMipmapEXT.trace = True
glGenerateMipmapEXT.play = True
gl.add(glGenerateMipmapEXT)

glGetFramebufferAttachmentParameterivEXT = Function('glGetFramebufferAttachmentParameterivEXT')
glGetFramebufferAttachmentParameterivEXT.ret = Return('void')
glGetFramebufferAttachmentParameterivEXT.add( Input( 'target','GLenum' ))
glGetFramebufferAttachmentParameterivEXT.add( Input( 'attachment','GLenum' ))
glGetFramebufferAttachmentParameterivEXT.add( Input( 'pname','GLenum' ))
glGetFramebufferAttachmentParameterivEXT.add( Output( 'params','GLint *' ))
glGetFramebufferAttachmentParameterivEXT.version = '1.5'
glGetFramebufferAttachmentParameterivEXT.category = 'GL_EXT_framebuffer_object'
glGetFramebufferAttachmentParameterivEXT.trace = True
glGetFramebufferAttachmentParameterivEXT.play = True
gl.add(glGetFramebufferAttachmentParameterivEXT)

glGetRenderbufferParameterivEXT = Function('glGetRenderbufferParameterivEXT')
glGetRenderbufferParameterivEXT.ret = Return('void')
glGetRenderbufferParameterivEXT.add( Input( 'target','GLenum' ))
glGetRenderbufferParameterivEXT.add( Input( 'pname','GLenum' ))
glGetRenderbufferParameterivEXT.add( Output( 'params','GLint *' ))
glGetRenderbufferParameterivEXT.version = '1.5'
glGetRenderbufferParameterivEXT.category = 'GL_EXT_framebuffer_object'
glGetRenderbufferParameterivEXT.trace = True
glGetRenderbufferParameterivEXT.play = True
gl.add(glGetRenderbufferParameterivEXT)

glIsFramebufferEXT = Function('glIsFramebufferEXT')
glIsFramebufferEXT.ret = Return('GLboolean')
glIsFramebufferEXT.add( Input( 'framebuffer','GLuint' ))
glIsFramebufferEXT.version = '1.5'
glIsFramebufferEXT.category = 'GL_EXT_framebuffer_object'
glIsFramebufferEXT.trace = True
glIsFramebufferEXT.play = True
gl.add(glIsFramebufferEXT)

glIsRenderbufferEXT = Function('glIsRenderbufferEXT')
glIsRenderbufferEXT.ret = Return('GLboolean')
glIsRenderbufferEXT.add( Input( 'renderbuffer','GLuint' ))
glIsRenderbufferEXT.version = '1.5'
glIsRenderbufferEXT.category = 'GL_EXT_framebuffer_object'
glIsRenderbufferEXT.trace = True
glIsRenderbufferEXT.play = True
gl.add(glIsRenderbufferEXT)

glRenderbufferStorageEXT = Function('glRenderbufferStorageEXT')
glRenderbufferStorageEXT.ret = Return('void')
glRenderbufferStorageEXT.add( Input( 'target','GLenum' ))
glRenderbufferStorageEXT.add( Input( 'internalformat','GLenum' ))
glRenderbufferStorageEXT.add( Input( 'width','GLsizei' ))
glRenderbufferStorageEXT.add( Input( 'height','GLsizei' ))
glRenderbufferStorageEXT.version = '1.5'
glRenderbufferStorageEXT.category = 'GL_EXT_framebuffer_object'
glRenderbufferStorageEXT.trace = True
glRenderbufferStorageEXT.play = True
gl.add(glRenderbufferStorageEXT)

# GL_EXT_geometry_shader4

glFramebufferTextureEXT = Function('glFramebufferTextureEXT')
glFramebufferTextureEXT.ret = Return('void')
glFramebufferTextureEXT.add( Input( 'target','GLenum' ))
glFramebufferTextureEXT.add( Input( 'attachment','GLenum' ))
glFramebufferTextureEXT.add( Input( 'texture','GLuint' ))
glFramebufferTextureEXT.add( Input( 'level','GLint' ))
glFramebufferTextureEXT.version = '2.0'
glFramebufferTextureEXT.category = 'GL_EXT_geometry_shader4'
glFramebufferTextureEXT.trace = True
glFramebufferTextureEXT.play = True
gl.add(glFramebufferTextureEXT)

glFramebufferTextureFaceEXT = Function('glFramebufferTextureFaceEXT')
glFramebufferTextureFaceEXT.ret = Return('void')
glFramebufferTextureFaceEXT.add( Input( 'target','GLenum' ))
glFramebufferTextureFaceEXT.add( Input( 'attachment','GLenum' ))
glFramebufferTextureFaceEXT.add( Input( 'texture','GLuint' ))
glFramebufferTextureFaceEXT.add( Input( 'level','GLint' ))
glFramebufferTextureFaceEXT.add( Input( 'face','GLenum' ))
glFramebufferTextureFaceEXT.version = '2.0'
glFramebufferTextureFaceEXT.category = 'GL_EXT_geometry_shader4'
glFramebufferTextureFaceEXT.trace = True
glFramebufferTextureFaceEXT.play = True
gl.add(glFramebufferTextureFaceEXT)

glProgramParameteriEXT = Function('glProgramParameteriEXT')
glProgramParameteriEXT.ret = Return('void')
glProgramParameteriEXT.add( Input( 'program','GLuint' ))
glProgramParameteriEXT.add( Input( 'pname','GLenum' ))
glProgramParameteriEXT.add( Input( 'value','GLint' ))
glProgramParameteriEXT.version = '2.0'
glProgramParameteriEXT.category = 'GL_EXT_geometry_shader4'
glProgramParameteriEXT.trace = True
glProgramParameteriEXT.play = True
gl.add(glProgramParameteriEXT)

# GL_EXT_gpu_program_parameters

glProgramEnvParameters4fvEXT = Function('glProgramEnvParameters4fvEXT')
glProgramEnvParameters4fvEXT.ret = Return('void')
glProgramEnvParameters4fvEXT.add( Input( 'target','GLenum' ))
glProgramEnvParameters4fvEXT.add( Input( 'index','GLuint' ))
glProgramEnvParameters4fvEXT.add( Input( 'count','GLsizei' ))
glProgramEnvParameters4fvEXT.add( Input( 'params','const GLfloat *' ,size = 'count * 4' ))
glProgramEnvParameters4fvEXT.version = '1.3'
glProgramEnvParameters4fvEXT.category = 'GL_EXT_gpu_program_parameters'
glProgramEnvParameters4fvEXT.trace = True
glProgramEnvParameters4fvEXT.play = True
gl.add(glProgramEnvParameters4fvEXT)

glProgramLocalParameters4fvEXT = Function('glProgramLocalParameters4fvEXT')
glProgramLocalParameters4fvEXT.ret = Return('void')
glProgramLocalParameters4fvEXT.add( Input( 'target','GLenum' ))
glProgramLocalParameters4fvEXT.add( Input( 'index','GLuint' ))
glProgramLocalParameters4fvEXT.add( Input( 'count','GLsizei' ))
glProgramLocalParameters4fvEXT.add( Input( 'params','const GLfloat *' ,size = 'count * 4' ))
glProgramLocalParameters4fvEXT.version = '1.3'
glProgramLocalParameters4fvEXT.category = 'GL_EXT_gpu_program_parameters'
glProgramLocalParameters4fvEXT.trace = True
glProgramLocalParameters4fvEXT.play = True
gl.add(glProgramLocalParameters4fvEXT)

# GL_EXT_gpu_shader4

glBindFragDataLocationEXT = Function('glBindFragDataLocationEXT')
glBindFragDataLocationEXT.ret = Return('void')
glBindFragDataLocationEXT.add( Input( 'program','GLuint' ))
glBindFragDataLocationEXT.add( Input( 'color','GLuint' ))
glBindFragDataLocationEXT.add( Input( 'name','const GLchar *' ))
glBindFragDataLocationEXT.version = '2.0'
glBindFragDataLocationEXT.category = 'GL_EXT_gpu_shader4'
glBindFragDataLocationEXT.trace = True
glBindFragDataLocationEXT.play = True
gl.add(glBindFragDataLocationEXT)

glGetFragDataLocationEXT = Function('glGetFragDataLocationEXT')
glGetFragDataLocationEXT.ret = Return('GLint')
glGetFragDataLocationEXT.add( Input( 'program','GLuint' ))
glGetFragDataLocationEXT.add( Input( 'name','const GLchar *' ))
glGetFragDataLocationEXT.version = '2.0'
glGetFragDataLocationEXT.category = 'GL_EXT_gpu_shader4'
glGetFragDataLocationEXT.trace = True
glGetFragDataLocationEXT.play = True
gl.add(glGetFragDataLocationEXT)

glGetUniformuivEXT = Function('glGetUniformuivEXT')
glGetUniformuivEXT.ret = Return('void')
glGetUniformuivEXT.add( Input( 'program','GLuint' ))
glGetUniformuivEXT.add( Input( 'location','GLint' ))
glGetUniformuivEXT.add( Output( 'params','GLuint *' ))
glGetUniformuivEXT.version = '2.0'
glGetUniformuivEXT.category = 'GL_EXT_gpu_shader4'
glGetUniformuivEXT.trace = True
glGetUniformuivEXT.play = True
gl.add(glGetUniformuivEXT)

glGetVertexAttribIivEXT = Function('glGetVertexAttribIivEXT')
glGetVertexAttribIivEXT.ret = Return('void')
glGetVertexAttribIivEXT.add( Input( 'index','GLuint' ))
glGetVertexAttribIivEXT.add( Input( 'pname','GLenum' ))
glGetVertexAttribIivEXT.add( Output( 'params','GLint *' ,size = 1 ))
glGetVertexAttribIivEXT.version = '1.1'
glGetVertexAttribIivEXT.category = 'GL_EXT_gpu_shader4'
glGetVertexAttribIivEXT.trace = True
glGetVertexAttribIivEXT.play = True
gl.add(glGetVertexAttribIivEXT)

glGetVertexAttribIuivEXT = Function('glGetVertexAttribIuivEXT')
glGetVertexAttribIuivEXT.ret = Return('void')
glGetVertexAttribIuivEXT.add( Input( 'index','GLuint' ))
glGetVertexAttribIuivEXT.add( Input( 'pname','GLenum' ))
glGetVertexAttribIuivEXT.add( Output( 'params','GLuint *' ,size = 1 ))
glGetVertexAttribIuivEXT.version = '1.1'
glGetVertexAttribIuivEXT.category = 'GL_EXT_gpu_shader4'
glGetVertexAttribIuivEXT.trace = True
glGetVertexAttribIuivEXT.play = True
gl.add(glGetVertexAttribIuivEXT)

glUniform1uiEXT = Function('glUniform1uiEXT')
glUniform1uiEXT.ret = Return('void')
glUniform1uiEXT.add( Input( 'location','GLint' ))
glUniform1uiEXT.add( Input( 'v0','GLuint' ))
glUniform1uiEXT.version = '2.0'
glUniform1uiEXT.category = 'GL_EXT_gpu_shader4'
glUniform1uiEXT.trace = True
glUniform1uiEXT.play = True
gl.add(glUniform1uiEXT)

glUniform1uivEXT = Function('glUniform1uivEXT')
glUniform1uivEXT.ret = Return('void')
glUniform1uivEXT.add( Input( 'location','GLint' ))
glUniform1uivEXT.add( Input( 'count','GLsizei' ))
glUniform1uivEXT.add( Input( 'value','const GLuint *' ,size = 'count' ))
glUniform1uivEXT.version = '2.0'
glUniform1uivEXT.category = 'GL_EXT_gpu_shader4'
glUniform1uivEXT.trace = True
glUniform1uivEXT.play = True
gl.add(glUniform1uivEXT)

glUniform2uiEXT = Function('glUniform2uiEXT')
glUniform2uiEXT.ret = Return('void')
glUniform2uiEXT.add( Input( 'location','GLint' ))
glUniform2uiEXT.add( Input( 'v0','GLuint' ))
glUniform2uiEXT.add( Input( 'v1','GLuint' ))
glUniform2uiEXT.version = '2.0'
glUniform2uiEXT.category = 'GL_EXT_gpu_shader4'
glUniform2uiEXT.trace = True
glUniform2uiEXT.play = True
gl.add(glUniform2uiEXT)

glUniform2uivEXT = Function('glUniform2uivEXT')
glUniform2uivEXT.ret = Return('void')
glUniform2uivEXT.add( Input( 'location','GLint' ))
glUniform2uivEXT.add( Input( 'count','GLsizei' ))
glUniform2uivEXT.add( Input( 'value','const GLuint *' ,size = 'count * 2' ))
glUniform2uivEXT.version = '2.0'
glUniform2uivEXT.category = 'GL_EXT_gpu_shader4'
glUniform2uivEXT.trace = True
glUniform2uivEXT.play = True
gl.add(glUniform2uivEXT)

glUniform3uiEXT = Function('glUniform3uiEXT')
glUniform3uiEXT.ret = Return('void')
glUniform3uiEXT.add( Input( 'location','GLint' ))
glUniform3uiEXT.add( Input( 'v0','GLuint' ))
glUniform3uiEXT.add( Input( 'v1','GLuint' ))
glUniform3uiEXT.add( Input( 'v2','GLuint' ))
glUniform3uiEXT.version = '2.0'
glUniform3uiEXT.category = 'GL_EXT_gpu_shader4'
glUniform3uiEXT.trace = True
glUniform3uiEXT.play = True
gl.add(glUniform3uiEXT)

glUniform3uivEXT = Function('glUniform3uivEXT')
glUniform3uivEXT.ret = Return('void')
glUniform3uivEXT.add( Input( 'location','GLint' ))
glUniform3uivEXT.add( Input( 'count','GLsizei' ))
glUniform3uivEXT.add( Input( 'value','const GLuint *' ,size = 'count * 3' ))
glUniform3uivEXT.version = '2.0'
glUniform3uivEXT.category = 'GL_EXT_gpu_shader4'
glUniform3uivEXT.trace = True
glUniform3uivEXT.play = True
gl.add(glUniform3uivEXT)

glUniform4uiEXT = Function('glUniform4uiEXT')
glUniform4uiEXT.ret = Return('void')
glUniform4uiEXT.add( Input( 'location','GLint' ))
glUniform4uiEXT.add( Input( 'v0','GLuint' ))
glUniform4uiEXT.add( Input( 'v1','GLuint' ))
glUniform4uiEXT.add( Input( 'v2','GLuint' ))
glUniform4uiEXT.add( Input( 'v3','GLuint' ))
glUniform4uiEXT.version = '2.0'
glUniform4uiEXT.category = 'GL_EXT_gpu_shader4'
glUniform4uiEXT.trace = True
glUniform4uiEXT.play = True
gl.add(glUniform4uiEXT)

glUniform4uivEXT = Function('glUniform4uivEXT')
glUniform4uivEXT.ret = Return('void')
glUniform4uivEXT.add( Input( 'location','GLint' ))
glUniform4uivEXT.add( Input( 'count','GLsizei' ))
glUniform4uivEXT.add( Input( 'value','const GLuint *' ,size = 'count * 4' ))
glUniform4uivEXT.version = '2.0'
glUniform4uivEXT.category = 'GL_EXT_gpu_shader4'
glUniform4uivEXT.trace = True
glUniform4uivEXT.play = True
gl.add(glUniform4uivEXT)

glVertexAttribI1iEXT = Function('glVertexAttribI1iEXT')
glVertexAttribI1iEXT.ret = Return('void')
glVertexAttribI1iEXT.add( Input( 'index','GLuint' ))
glVertexAttribI1iEXT.add( Input( 'x','GLint' ))
glVertexAttribI1iEXT.version = '1.1'
glVertexAttribI1iEXT.category = 'GL_EXT_gpu_shader4'
glVertexAttribI1iEXT.trace = True
glVertexAttribI1iEXT.play = True
gl.add(glVertexAttribI1iEXT)

glVertexAttribI1ivEXT = Function('glVertexAttribI1ivEXT')
glVertexAttribI1ivEXT.ret = Return('void')
glVertexAttribI1ivEXT.add( Input( 'index','GLuint' ))
glVertexAttribI1ivEXT.add( Input( 'v','const GLint *' ,size = 1 ))
glVertexAttribI1ivEXT.version = '1.1'
glVertexAttribI1ivEXT.category = 'GL_EXT_gpu_shader4'
glVertexAttribI1ivEXT.trace = True
glVertexAttribI1ivEXT.play = True
gl.add(glVertexAttribI1ivEXT)

glVertexAttribI1uiEXT = Function('glVertexAttribI1uiEXT')
glVertexAttribI1uiEXT.ret = Return('void')
glVertexAttribI1uiEXT.add( Input( 'index','GLuint' ))
glVertexAttribI1uiEXT.add( Input( 'x','GLuint' ))
glVertexAttribI1uiEXT.version = '1.1'
glVertexAttribI1uiEXT.category = 'GL_EXT_gpu_shader4'
glVertexAttribI1uiEXT.trace = True
glVertexAttribI1uiEXT.play = True
gl.add(glVertexAttribI1uiEXT)

glVertexAttribI1uivEXT = Function('glVertexAttribI1uivEXT')
glVertexAttribI1uivEXT.ret = Return('void')
glVertexAttribI1uivEXT.add( Input( 'index','GLuint' ))
glVertexAttribI1uivEXT.add( Input( 'v','const GLuint *' ,size = 1 ))
glVertexAttribI1uivEXT.version = '1.1'
glVertexAttribI1uivEXT.category = 'GL_EXT_gpu_shader4'
glVertexAttribI1uivEXT.trace = True
glVertexAttribI1uivEXT.play = True
gl.add(glVertexAttribI1uivEXT)

glVertexAttribI2iEXT = Function('glVertexAttribI2iEXT')
glVertexAttribI2iEXT.ret = Return('void')
glVertexAttribI2iEXT.add( Input( 'index','GLuint' ))
glVertexAttribI2iEXT.add( Input( 'x','GLint' ))
glVertexAttribI2iEXT.add( Input( 'y','GLint' ))
glVertexAttribI2iEXT.version = '1.1'
glVertexAttribI2iEXT.category = 'GL_EXT_gpu_shader4'
glVertexAttribI2iEXT.trace = True
glVertexAttribI2iEXT.play = True
gl.add(glVertexAttribI2iEXT)

glVertexAttribI2ivEXT = Function('glVertexAttribI2ivEXT')
glVertexAttribI2ivEXT.ret = Return('void')
glVertexAttribI2ivEXT.add( Input( 'index','GLuint' ))
glVertexAttribI2ivEXT.add( Input( 'v','const GLint *' ,size = 2 ))
glVertexAttribI2ivEXT.version = '1.1'
glVertexAttribI2ivEXT.category = 'GL_EXT_gpu_shader4'
glVertexAttribI2ivEXT.trace = True
glVertexAttribI2ivEXT.play = True
gl.add(glVertexAttribI2ivEXT)

glVertexAttribI2uiEXT = Function('glVertexAttribI2uiEXT')
glVertexAttribI2uiEXT.ret = Return('void')
glVertexAttribI2uiEXT.add( Input( 'index','GLuint' ))
glVertexAttribI2uiEXT.add( Input( 'x','GLuint' ))
glVertexAttribI2uiEXT.add( Input( 'y','GLuint' ))
glVertexAttribI2uiEXT.version = '1.1'
glVertexAttribI2uiEXT.category = 'GL_EXT_gpu_shader4'
glVertexAttribI2uiEXT.trace = True
glVertexAttribI2uiEXT.play = True
gl.add(glVertexAttribI2uiEXT)

glVertexAttribI2uivEXT = Function('glVertexAttribI2uivEXT')
glVertexAttribI2uivEXT.ret = Return('void')
glVertexAttribI2uivEXT.add( Input( 'index','GLuint' ))
glVertexAttribI2uivEXT.add( Input( 'v','const GLuint *' ,size = 2 ))
glVertexAttribI2uivEXT.version = '1.1'
glVertexAttribI2uivEXT.category = 'GL_EXT_gpu_shader4'
glVertexAttribI2uivEXT.trace = True
glVertexAttribI2uivEXT.play = True
gl.add(glVertexAttribI2uivEXT)

glVertexAttribI3iEXT = Function('glVertexAttribI3iEXT')
glVertexAttribI3iEXT.ret = Return('void')
glVertexAttribI3iEXT.add( Input( 'index','GLuint' ))
glVertexAttribI3iEXT.add( Input( 'x','GLint' ))
glVertexAttribI3iEXT.add( Input( 'y','GLint' ))
glVertexAttribI3iEXT.add( Input( 'z','GLint' ))
glVertexAttribI3iEXT.version = '1.1'
glVertexAttribI3iEXT.category = 'GL_EXT_gpu_shader4'
glVertexAttribI3iEXT.trace = True
glVertexAttribI3iEXT.play = True
gl.add(glVertexAttribI3iEXT)

glVertexAttribI3ivEXT = Function('glVertexAttribI3ivEXT')
glVertexAttribI3ivEXT.ret = Return('void')
glVertexAttribI3ivEXT.add( Input( 'index','GLuint' ))
glVertexAttribI3ivEXT.add( Input( 'v','const GLint *' ,size = 3 ))
glVertexAttribI3ivEXT.version = '1.1'
glVertexAttribI3ivEXT.category = 'GL_EXT_gpu_shader4'
glVertexAttribI3ivEXT.trace = True
glVertexAttribI3ivEXT.play = True
gl.add(glVertexAttribI3ivEXT)

glVertexAttribI3uiEXT = Function('glVertexAttribI3uiEXT')
glVertexAttribI3uiEXT.ret = Return('void')
glVertexAttribI3uiEXT.add( Input( 'index','GLuint' ))
glVertexAttribI3uiEXT.add( Input( 'x','GLuint' ))
glVertexAttribI3uiEXT.add( Input( 'y','GLuint' ))
glVertexAttribI3uiEXT.add( Input( 'z','GLuint' ))
glVertexAttribI3uiEXT.version = '1.1'
glVertexAttribI3uiEXT.category = 'GL_EXT_gpu_shader4'
glVertexAttribI3uiEXT.trace = True
glVertexAttribI3uiEXT.play = True
gl.add(glVertexAttribI3uiEXT)

glVertexAttribI3uivEXT = Function('glVertexAttribI3uivEXT')
glVertexAttribI3uivEXT.ret = Return('void')
glVertexAttribI3uivEXT.add( Input( 'index','GLuint' ))
glVertexAttribI3uivEXT.add( Input( 'v','const GLuint *' ,size = 3 ))
glVertexAttribI3uivEXT.version = '1.1'
glVertexAttribI3uivEXT.category = 'GL_EXT_gpu_shader4'
glVertexAttribI3uivEXT.trace = True
glVertexAttribI3uivEXT.play = True
gl.add(glVertexAttribI3uivEXT)

glVertexAttribI4bvEXT = Function('glVertexAttribI4bvEXT')
glVertexAttribI4bvEXT.ret = Return('void')
glVertexAttribI4bvEXT.add( Input( 'index','GLuint' ))
glVertexAttribI4bvEXT.add( Input( 'v','const GLbyte *' ,size = 4 ))
glVertexAttribI4bvEXT.version = '1.1'
glVertexAttribI4bvEXT.category = 'GL_EXT_gpu_shader4'
glVertexAttribI4bvEXT.trace = True
glVertexAttribI4bvEXT.play = True
gl.add(glVertexAttribI4bvEXT)

glVertexAttribI4iEXT = Function('glVertexAttribI4iEXT')
glVertexAttribI4iEXT.ret = Return('void')
glVertexAttribI4iEXT.add( Input( 'index','GLuint' ))
glVertexAttribI4iEXT.add( Input( 'x','GLint' ))
glVertexAttribI4iEXT.add( Input( 'y','GLint' ))
glVertexAttribI4iEXT.add( Input( 'z','GLint' ))
glVertexAttribI4iEXT.add( Input( 'w','GLint' ))
glVertexAttribI4iEXT.version = '1.1'
glVertexAttribI4iEXT.category = 'GL_EXT_gpu_shader4'
glVertexAttribI4iEXT.trace = True
glVertexAttribI4iEXT.play = True
gl.add(glVertexAttribI4iEXT)

glVertexAttribI4ivEXT = Function('glVertexAttribI4ivEXT')
glVertexAttribI4ivEXT.ret = Return('void')
glVertexAttribI4ivEXT.add( Input( 'index','GLuint' ))
glVertexAttribI4ivEXT.add( Input( 'v','const GLint *' ,size = 4 ))
glVertexAttribI4ivEXT.version = '1.1'
glVertexAttribI4ivEXT.category = 'GL_EXT_gpu_shader4'
glVertexAttribI4ivEXT.trace = True
glVertexAttribI4ivEXT.play = True
gl.add(glVertexAttribI4ivEXT)

glVertexAttribI4svEXT = Function('glVertexAttribI4svEXT')
glVertexAttribI4svEXT.ret = Return('void')
glVertexAttribI4svEXT.add( Input( 'index','GLuint' ))
glVertexAttribI4svEXT.add( Input( 'v','const GLshort *' ,size = 4 ))
glVertexAttribI4svEXT.version = '1.1'
glVertexAttribI4svEXT.category = 'GL_EXT_gpu_shader4'
glVertexAttribI4svEXT.trace = True
glVertexAttribI4svEXT.play = True
gl.add(glVertexAttribI4svEXT)

glVertexAttribI4ubvEXT = Function('glVertexAttribI4ubvEXT')
glVertexAttribI4ubvEXT.ret = Return('void')
glVertexAttribI4ubvEXT.add( Input( 'index','GLuint' ))
glVertexAttribI4ubvEXT.add( Input( 'v','const GLubyte *' ,size = 4 ))
glVertexAttribI4ubvEXT.version = '1.1'
glVertexAttribI4ubvEXT.category = 'GL_EXT_gpu_shader4'
glVertexAttribI4ubvEXT.trace = True
glVertexAttribI4ubvEXT.play = True
gl.add(glVertexAttribI4ubvEXT)

glVertexAttribI4uiEXT = Function('glVertexAttribI4uiEXT')
glVertexAttribI4uiEXT.ret = Return('void')
glVertexAttribI4uiEXT.add( Input( 'index','GLuint' ))
glVertexAttribI4uiEXT.add( Input( 'x','GLuint' ))
glVertexAttribI4uiEXT.add( Input( 'y','GLuint' ))
glVertexAttribI4uiEXT.add( Input( 'z','GLuint' ))
glVertexAttribI4uiEXT.add( Input( 'w','GLuint' ))
glVertexAttribI4uiEXT.version = '1.1'
glVertexAttribI4uiEXT.category = 'GL_EXT_gpu_shader4'
glVertexAttribI4uiEXT.trace = True
glVertexAttribI4uiEXT.play = True
gl.add(glVertexAttribI4uiEXT)

glVertexAttribI4uivEXT = Function('glVertexAttribI4uivEXT')
glVertexAttribI4uivEXT.ret = Return('void')
glVertexAttribI4uivEXT.add( Input( 'index','GLuint' ))
glVertexAttribI4uivEXT.add( Input( 'v','const GLuint *' ,size = 4 ))
glVertexAttribI4uivEXT.version = '1.1'
glVertexAttribI4uivEXT.category = 'GL_EXT_gpu_shader4'
glVertexAttribI4uivEXT.trace = True
glVertexAttribI4uivEXT.play = True
gl.add(glVertexAttribI4uivEXT)

glVertexAttribI4usvEXT = Function('glVertexAttribI4usvEXT')
glVertexAttribI4usvEXT.ret = Return('void')
glVertexAttribI4usvEXT.add( Input( 'index','GLuint' ))
glVertexAttribI4usvEXT.add( Input( 'v','const GLushort *' ,size = 4 ))
glVertexAttribI4usvEXT.version = '1.1'
glVertexAttribI4usvEXT.category = 'GL_EXT_gpu_shader4'
glVertexAttribI4usvEXT.trace = True
glVertexAttribI4usvEXT.play = True
gl.add(glVertexAttribI4usvEXT)

glVertexAttribIPointerEXT = Function('glVertexAttribIPointerEXT')
glVertexAttribIPointerEXT.ret = Return('void')
glVertexAttribIPointerEXT.add( Input( 'index','GLuint' ))
glVertexAttribIPointerEXT.add( Input( 'size','GLint' ))
glVertexAttribIPointerEXT.add( Input( 'type','GLenum' ))
glVertexAttribIPointerEXT.add( Input( 'stride','GLsizei' ))
glVertexAttribIPointerEXT.add( Input( 'pointer','const GLvoid *' ))
glVertexAttribIPointerEXT.version = '1.1'
glVertexAttribIPointerEXT.category = 'GL_EXT_gpu_shader4'
glVertexAttribIPointerEXT.trace = True
glVertexAttribIPointerEXT.play = True
gl.add(glVertexAttribIPointerEXT)

# GL_EXT_histogram

glGetHistogramEXT = Function('glGetHistogramEXT')
glGetHistogramEXT.ret = Return('void')
glGetHistogramEXT.add( Input( 'target','GLenum' ))
glGetHistogramEXT.add( Input( 'reset','GLboolean' ))
glGetHistogramEXT.add( Input( 'format','GLenum' ))
glGetHistogramEXT.add( Input( 'type','GLenum' ))
glGetHistogramEXT.add( Output( 'values','GLvoid *' ))
glGetHistogramEXT.version = '1.0'
glGetHistogramEXT.category = 'GL_EXT_histogram'
glGetHistogramEXT.trace = True
glGetHistogramEXT.play = True
gl.add(glGetHistogramEXT)

glGetHistogramParameterfvEXT = Function('glGetHistogramParameterfvEXT')
glGetHistogramParameterfvEXT.ret = Return('void')
glGetHistogramParameterfvEXT.add( Input( 'target','GLenum' ))
glGetHistogramParameterfvEXT.add( Input( 'pname','GLenum' ))
glGetHistogramParameterfvEXT.add( Output( 'params','GLfloat *' ))
glGetHistogramParameterfvEXT.version = '1.0'
glGetHistogramParameterfvEXT.category = 'GL_EXT_histogram'
glGetHistogramParameterfvEXT.trace = True
glGetHistogramParameterfvEXT.play = True
gl.add(glGetHistogramParameterfvEXT)

glGetHistogramParameterivEXT = Function('glGetHistogramParameterivEXT')
glGetHistogramParameterivEXT.ret = Return('void')
glGetHistogramParameterivEXT.add( Input( 'target','GLenum' ))
glGetHistogramParameterivEXT.add( Input( 'pname','GLenum' ))
glGetHistogramParameterivEXT.add( Output( 'params','GLint *' ))
glGetHistogramParameterivEXT.version = '1.0'
glGetHistogramParameterivEXT.category = 'GL_EXT_histogram'
glGetHistogramParameterivEXT.trace = True
glGetHistogramParameterivEXT.play = True
gl.add(glGetHistogramParameterivEXT)

glGetMinmaxEXT = Function('glGetMinmaxEXT')
glGetMinmaxEXT.ret = Return('void')
glGetMinmaxEXT.add( Input( 'target','GLenum' ))
glGetMinmaxEXT.add( Input( 'reset','GLboolean' ))
glGetMinmaxEXT.add( Input( 'format','GLenum' ))
glGetMinmaxEXT.add( Input( 'type','GLenum' ))
glGetMinmaxEXT.add( Output( 'values','GLvoid *' ))
glGetMinmaxEXT.version = '1.0'
glGetMinmaxEXT.category = 'GL_EXT_histogram'
glGetMinmaxEXT.trace = True
glGetMinmaxEXT.play = True
gl.add(glGetMinmaxEXT)

glGetMinmaxParameterfvEXT = Function('glGetMinmaxParameterfvEXT')
glGetMinmaxParameterfvEXT.ret = Return('void')
glGetMinmaxParameterfvEXT.add( Input( 'target','GLenum' ))
glGetMinmaxParameterfvEXT.add( Input( 'pname','GLenum' ))
glGetMinmaxParameterfvEXT.add( Output( 'params','GLfloat *' ))
glGetMinmaxParameterfvEXT.version = '1.0'
glGetMinmaxParameterfvEXT.category = 'GL_EXT_histogram'
glGetMinmaxParameterfvEXT.trace = True
glGetMinmaxParameterfvEXT.play = True
gl.add(glGetMinmaxParameterfvEXT)

glGetMinmaxParameterivEXT = Function('glGetMinmaxParameterivEXT')
glGetMinmaxParameterivEXT.ret = Return('void')
glGetMinmaxParameterivEXT.add( Input( 'target','GLenum' ))
glGetMinmaxParameterivEXT.add( Input( 'pname','GLenum' ))
glGetMinmaxParameterivEXT.add( Output( 'params','GLint *' ))
glGetMinmaxParameterivEXT.version = '1.0'
glGetMinmaxParameterivEXT.category = 'GL_EXT_histogram'
glGetMinmaxParameterivEXT.trace = True
glGetMinmaxParameterivEXT.play = True
gl.add(glGetMinmaxParameterivEXT)

glHistogramEXT = Function('glHistogramEXT')
glHistogramEXT.ret = Return('void')
glHistogramEXT.add( Input( 'target','GLenum' ))
glHistogramEXT.add( Input( 'width','GLsizei' ))
glHistogramEXT.add( Input( 'internalformat','GLenum' ))
glHistogramEXT.add( Input( 'sink','GLboolean' ))
glHistogramEXT.version = '1.0'
glHistogramEXT.category = 'GL_EXT_histogram'
glHistogramEXT.trace = True
glHistogramEXT.play = True
gl.add(glHistogramEXT)

glMinmaxEXT = Function('glMinmaxEXT')
glMinmaxEXT.ret = Return('void')
glMinmaxEXT.add( Input( 'target','GLenum' ))
glMinmaxEXT.add( Input( 'internalformat','GLenum' ))
glMinmaxEXT.add( Input( 'sink','GLboolean' ))
glMinmaxEXT.version = '1.0'
glMinmaxEXT.category = 'GL_EXT_histogram'
glMinmaxEXT.trace = True
glMinmaxEXT.play = True
gl.add(glMinmaxEXT)

glResetHistogramEXT = Function('glResetHistogramEXT')
glResetHistogramEXT.ret = Return('void')
glResetHistogramEXT.add( Input( 'target','GLenum' ))
glResetHistogramEXT.version = '1.0'
glResetHistogramEXT.category = 'GL_EXT_histogram'
glResetHistogramEXT.trace = True
glResetHistogramEXT.play = True
gl.add(glResetHistogramEXT)

glResetMinmaxEXT = Function('glResetMinmaxEXT')
glResetMinmaxEXT.ret = Return('void')
glResetMinmaxEXT.add( Input( 'target','GLenum' ))
glResetMinmaxEXT.version = '1.0'
glResetMinmaxEXT.category = 'GL_EXT_histogram'
glResetMinmaxEXT.trace = True
glResetMinmaxEXT.play = True
gl.add(glResetMinmaxEXT)

# GL_EXT_index_func

glIndexFuncEXT = Function('glIndexFuncEXT')
glIndexFuncEXT.ret = Return('void')
glIndexFuncEXT.add( Input( 'func','GLenum' ))
glIndexFuncEXT.add( Input( 'ref','GLfloat' ))
glIndexFuncEXT.version = '1.1'
glIndexFuncEXT.category = 'GL_EXT_index_func'
glIndexFuncEXT.trace = True
glIndexFuncEXT.play = True
gl.add(glIndexFuncEXT)

# GL_EXT_index_material

glIndexMaterialEXT = Function('glIndexMaterialEXT')
glIndexMaterialEXT.ret = Return('void')
glIndexMaterialEXT.add( Input( 'face','GLenum' ))
glIndexMaterialEXT.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glIndexMaterialEXT.version = '1.1'
glIndexMaterialEXT.category = 'GL_EXT_index_material'
glIndexMaterialEXT.trace = True
glIndexMaterialEXT.play = True
gl.add(glIndexMaterialEXT)

# GL_EXT_light_texture

glApplyTextureEXT = Function('glApplyTextureEXT')
glApplyTextureEXT.ret = Return('void')
glApplyTextureEXT.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glApplyTextureEXT.version = '1.1'
glApplyTextureEXT.category = 'GL_EXT_light_texture'
glApplyTextureEXT.trace = True
glApplyTextureEXT.play = True
gl.add(glApplyTextureEXT)

glTextureLightEXT = Function('glTextureLightEXT')
glTextureLightEXT.ret = Return('void')
glTextureLightEXT.add( Input( 'pname','GLenum' ))
glTextureLightEXT.version = '1.1'
glTextureLightEXT.category = 'GL_EXT_light_texture'
glTextureLightEXT.trace = True
glTextureLightEXT.play = True
gl.add(glTextureLightEXT)

glTextureMaterialEXT = Function('glTextureMaterialEXT')
glTextureMaterialEXT.ret = Return('void')
glTextureMaterialEXT.add( Input( 'face','GLenum' ))
glTextureMaterialEXT.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glTextureMaterialEXT.version = '1.1'
glTextureMaterialEXT.category = 'GL_EXT_light_texture'
glTextureMaterialEXT.trace = True
glTextureMaterialEXT.play = True
gl.add(glTextureMaterialEXT)

# GL_EXT_map_buffer_range

glFlushMappedBufferRangeEXT = Function('glFlushMappedBufferRangeEXT')
glFlushMappedBufferRangeEXT.ret = Return('void')
glFlushMappedBufferRangeEXT.add( Input( 'target','GLenum' ))
glFlushMappedBufferRangeEXT.add( Input( 'offset','GLintptr' ))
glFlushMappedBufferRangeEXT.add( Input( 'length','GLsizeiptr' ))
glFlushMappedBufferRangeEXT.version = ''
glFlushMappedBufferRangeEXT.category = 'GL_EXT_map_buffer_range'
glFlushMappedBufferRangeEXT.trace = True
glFlushMappedBufferRangeEXT.play = True
gl.add(glFlushMappedBufferRangeEXT)

glMapBufferRangeEXT = Function('glMapBufferRangeEXT')
glMapBufferRangeEXT.ret = Return('GLvoid *')
glMapBufferRangeEXT.add( Input( 'target','GLenum' ))
glMapBufferRangeEXT.add( Input( 'offset','GLintptr' ))
glMapBufferRangeEXT.add( Input( 'length','GLsizeiptr' ))
glMapBufferRangeEXT.add( Input( 'access','GLbitfield' ,regalLog = 'GLmapBufferRangeToString(access)' ))
glMapBufferRangeEXT.version = ''
glMapBufferRangeEXT.category = 'GL_EXT_map_buffer_range'
glMapBufferRangeEXT.trace = True
glMapBufferRangeEXT.play = True
gl.add(glMapBufferRangeEXT)

# GL_EXT_multi_draw_arrays

glMultiDrawArraysEXT = Function('glMultiDrawArraysEXT')
glMultiDrawArraysEXT.ret = Return('void')
glMultiDrawArraysEXT.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glMultiDrawArraysEXT.add( Input( 'first','const GLint *' ,size = 'primcount' ))
glMultiDrawArraysEXT.add( Input( 'count','const GLsizei *' ,size = 'primcount' ))
glMultiDrawArraysEXT.add( Input( 'primcount','GLsizei' ))
glMultiDrawArraysEXT.version = '1.1'
glMultiDrawArraysEXT.category = 'GL_EXT_multi_draw_arrays'
glMultiDrawArraysEXT.trace = True
glMultiDrawArraysEXT.play = True
gl.add(glMultiDrawArraysEXT)

glMultiDrawElementsEXT = Function('glMultiDrawElementsEXT')
glMultiDrawElementsEXT.ret = Return('void')
glMultiDrawElementsEXT.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glMultiDrawElementsEXT.add( Input( 'count','const GLsizei *' ,size = 'primcount' ))
glMultiDrawElementsEXT.add( Input( 'type','GLenum' ))
glMultiDrawElementsEXT.add( Input( 'indices','const GLvoid * const *' ,size = 'primcount' ))
glMultiDrawElementsEXT.add( Input( 'primcount','GLsizei' ))
glMultiDrawElementsEXT.version = '1.1'
glMultiDrawElementsEXT.category = 'GL_EXT_multi_draw_arrays'
glMultiDrawElementsEXT.trace = True
glMultiDrawElementsEXT.play = False
gl.add(glMultiDrawElementsEXT)

# GL_EXT_multisample

glSampleMaskEXT = Function('glSampleMaskEXT')
glSampleMaskEXT.ret = Return('void')
glSampleMaskEXT.add( Input( 'value','GLclampf' ))
glSampleMaskEXT.add( Input( 'invert','GLboolean' ))
glSampleMaskEXT.version = '1.0'
glSampleMaskEXT.category = 'GL_EXT_multisample'
glSampleMaskEXT.trace = True
glSampleMaskEXT.play = True
gl.add(glSampleMaskEXT)

glSamplePatternEXT = Function('glSamplePatternEXT')
glSamplePatternEXT.ret = Return('void')
glSamplePatternEXT.add( Input( 'pattern','GLenum' ))
glSamplePatternEXT.version = '1.0'
glSamplePatternEXT.category = 'GL_EXT_multisample'
glSamplePatternEXT.trace = True
glSamplePatternEXT.play = True
gl.add(glSamplePatternEXT)

# GL_EXT_multisampled_render_to_texture

glFramebufferTexture2DMultisampleEXT = Function('glFramebufferTexture2DMultisampleEXT')
glFramebufferTexture2DMultisampleEXT.ret = Return('void')
glFramebufferTexture2DMultisampleEXT.add( Input( 'target','GLenum' ))
glFramebufferTexture2DMultisampleEXT.add( Input( 'attachment','GLenum' ))
glFramebufferTexture2DMultisampleEXT.add( Input( 'textarget','GLenum' ))
glFramebufferTexture2DMultisampleEXT.add( Input( 'texture','GLuint' ))
glFramebufferTexture2DMultisampleEXT.add( Input( 'level','GLint' ))
glFramebufferTexture2DMultisampleEXT.add( Input( 'samples','GLsizei' ))
glFramebufferTexture2DMultisampleEXT.version = ''
glFramebufferTexture2DMultisampleEXT.category = 'GL_EXT_multisampled_render_to_texture'
glFramebufferTexture2DMultisampleEXT.trace = True
glFramebufferTexture2DMultisampleEXT.play = True
gl.add(glFramebufferTexture2DMultisampleEXT)

# GL_EXT_multiview_draw_buffers

glDrawBuffersIndexedEXT = Function('glDrawBuffersIndexedEXT')
glDrawBuffersIndexedEXT.ret = Return('void')
glDrawBuffersIndexedEXT.add( Input( 'n','GLint' ))
glDrawBuffersIndexedEXT.add( Input( 'location','const GLenum *' ))
glDrawBuffersIndexedEXT.add( Input( 'indices','const GLint *' ))
glDrawBuffersIndexedEXT.version = ''
glDrawBuffersIndexedEXT.category = 'GL_EXT_multiview_draw_buffers'
glDrawBuffersIndexedEXT.trace = True
glDrawBuffersIndexedEXT.play = True
gl.add(glDrawBuffersIndexedEXT)

glGetIntegeri_vEXT = Function('glGetIntegeri_vEXT')
glGetIntegeri_vEXT.ret = Return('void')
glGetIntegeri_vEXT.add( Input( 'target','GLenum' ))
glGetIntegeri_vEXT.add( Input( 'index','GLuint' ))
glGetIntegeri_vEXT.add( Input( 'data','GLint *' ))
glGetIntegeri_vEXT.version = ''
glGetIntegeri_vEXT.category = 'GL_EXT_multiview_draw_buffers'
glGetIntegeri_vEXT.trace = True
glGetIntegeri_vEXT.play = True
gl.add(glGetIntegeri_vEXT)

glReadBufferIndexedEXT = Function('glReadBufferIndexedEXT')
glReadBufferIndexedEXT.ret = Return('void')
glReadBufferIndexedEXT.add( Input( 'src','GLenum' ))
glReadBufferIndexedEXT.add( Input( 'index','GLint' ))
glReadBufferIndexedEXT.version = ''
glReadBufferIndexedEXT.category = 'GL_EXT_multiview_draw_buffers'
glReadBufferIndexedEXT.trace = True
glReadBufferIndexedEXT.play = True
gl.add(glReadBufferIndexedEXT)

# GL_EXT_occlusion_query_boolean

glBeginQueryEXT = Function('glBeginQueryEXT')
glBeginQueryEXT.ret = Return('void')
glBeginQueryEXT.add( Input( 'target','GLenum' ))
glBeginQueryEXT.add( Input( 'id','GLuint' ))
glBeginQueryEXT.version = ''
glBeginQueryEXT.category = 'GL_EXT_occlusion_query_boolean'
glBeginQueryEXT.trace = True
glBeginQueryEXT.play = True
gl.add(glBeginQueryEXT)

glDeleteQueriesEXT = Function('glDeleteQueriesEXT')
glDeleteQueriesEXT.ret = Return('void')
glDeleteQueriesEXT.add( Input( 'n','GLsizei' ))
glDeleteQueriesEXT.add( Input( 'ids','const GLuint *' ))
glDeleteQueriesEXT.version = ''
glDeleteQueriesEXT.category = 'GL_EXT_occlusion_query_boolean'
glDeleteQueriesEXT.trace = True
glDeleteQueriesEXT.play = True
gl.add(glDeleteQueriesEXT)

glEndQueryEXT = Function('glEndQueryEXT')
glEndQueryEXT.ret = Return('void')
glEndQueryEXT.add( Input( 'target','GLenum' ))
glEndQueryEXT.version = ''
glEndQueryEXT.category = 'GL_EXT_occlusion_query_boolean'
glEndQueryEXT.trace = True
glEndQueryEXT.play = True
gl.add(glEndQueryEXT)

glGenQueriesEXT = Function('glGenQueriesEXT')
glGenQueriesEXT.ret = Return('void')
glGenQueriesEXT.add( Input( 'n','GLsizei' ))
glGenQueriesEXT.add( Input( 'ids','GLuint *' ))
glGenQueriesEXT.version = ''
glGenQueriesEXT.category = 'GL_EXT_occlusion_query_boolean'
glGenQueriesEXT.trace = True
glGenQueriesEXT.play = True
gl.add(glGenQueriesEXT)

glGetQueryObjectuivEXT = Function('glGetQueryObjectuivEXT')
glGetQueryObjectuivEXT.ret = Return('void')
glGetQueryObjectuivEXT.add( Input( 'id','GLuint' ))
glGetQueryObjectuivEXT.add( Input( 'pname','GLenum' ))
glGetQueryObjectuivEXT.add( Input( 'params','GLuint *' ))
glGetQueryObjectuivEXT.version = ''
glGetQueryObjectuivEXT.category = 'GL_EXT_occlusion_query_boolean'
glGetQueryObjectuivEXT.trace = True
glGetQueryObjectuivEXT.play = True
gl.add(glGetQueryObjectuivEXT)

glGetQueryivEXT = Function('glGetQueryivEXT')
glGetQueryivEXT.ret = Return('void')
glGetQueryivEXT.add( Input( 'target','GLenum' ))
glGetQueryivEXT.add( Input( 'pname','GLenum' ))
glGetQueryivEXT.add( Input( 'params','GLint *' ))
glGetQueryivEXT.version = ''
glGetQueryivEXT.category = 'GL_EXT_occlusion_query_boolean'
glGetQueryivEXT.trace = True
glGetQueryivEXT.play = True
gl.add(glGetQueryivEXT)

glIsQueryEXT = Function('glIsQueryEXT')
glIsQueryEXT.ret = Return('GLboolean')
glIsQueryEXT.add( Input( 'id','GLuint' ))
glIsQueryEXT.version = ''
glIsQueryEXT.category = 'GL_EXT_occlusion_query_boolean'
glIsQueryEXT.trace = True
glIsQueryEXT.play = True
gl.add(glIsQueryEXT)

# GL_EXT_paletted_texture

glColorTableEXT = Function('glColorTableEXT')
glColorTableEXT.ret = Return('void')
glColorTableEXT.add( Input( 'target','GLenum' ))
glColorTableEXT.add( Input( 'internalFormat','GLenum' ))
glColorTableEXT.add( Input( 'width','GLsizei' ))
glColorTableEXT.add( Input( 'format','GLenum' ))
glColorTableEXT.add( Input( 'type','GLenum' ))
glColorTableEXT.add( Input( 'table','const GLvoid *' ))
glColorTableEXT.version = '1.0'
glColorTableEXT.category = 'GL_EXT_paletted_texture'
glColorTableEXT.trace = True
glColorTableEXT.play = True
gl.add(glColorTableEXT)

glGetColorTableEXT = Function('glGetColorTableEXT')
glGetColorTableEXT.ret = Return('void')
glGetColorTableEXT.add( Input( 'target','GLenum' ))
glGetColorTableEXT.add( Input( 'format','GLenum' ))
glGetColorTableEXT.add( Input( 'type','GLenum' ))
glGetColorTableEXT.add( Output( 'data','GLvoid *' ))
glGetColorTableEXT.version = '1.0'
glGetColorTableEXT.category = 'GL_EXT_paletted_texture'
glGetColorTableEXT.trace = True
glGetColorTableEXT.play = True
gl.add(glGetColorTableEXT)

glGetColorTableParameterfvEXT = Function('glGetColorTableParameterfvEXT')
glGetColorTableParameterfvEXT.ret = Return('void')
glGetColorTableParameterfvEXT.add( Input( 'target','GLenum' ))
glGetColorTableParameterfvEXT.add( Input( 'pname','GLenum' ))
glGetColorTableParameterfvEXT.add( Output( 'params','GLfloat *' ))
glGetColorTableParameterfvEXT.version = '1.0'
glGetColorTableParameterfvEXT.category = 'GL_EXT_paletted_texture'
glGetColorTableParameterfvEXT.trace = True
glGetColorTableParameterfvEXT.play = True
gl.add(glGetColorTableParameterfvEXT)

glGetColorTableParameterivEXT = Function('glGetColorTableParameterivEXT')
glGetColorTableParameterivEXT.ret = Return('void')
glGetColorTableParameterivEXT.add( Input( 'target','GLenum' ))
glGetColorTableParameterivEXT.add( Input( 'pname','GLenum' ))
glGetColorTableParameterivEXT.add( Output( 'params','GLint *' ))
glGetColorTableParameterivEXT.version = '1.0'
glGetColorTableParameterivEXT.category = 'GL_EXT_paletted_texture'
glGetColorTableParameterivEXT.trace = True
glGetColorTableParameterivEXT.play = True
gl.add(glGetColorTableParameterivEXT)

# GL_EXT_pixel_transform

glGetPixelTransformParameterfvEXT = Function('glGetPixelTransformParameterfvEXT')
glGetPixelTransformParameterfvEXT.ret = Return('void')
glGetPixelTransformParameterfvEXT.add( Input( 'target','GLenum' ))
glGetPixelTransformParameterfvEXT.add( Input( 'pname','GLenum' ))
glGetPixelTransformParameterfvEXT.add( Output( 'params','GLfloat *' ))
glGetPixelTransformParameterfvEXT.version = ''
glGetPixelTransformParameterfvEXT.category = 'GL_EXT_pixel_transform'
glGetPixelTransformParameterfvEXT.trace = True
glGetPixelTransformParameterfvEXT.play = True
gl.add(glGetPixelTransformParameterfvEXT)

glGetPixelTransformParameterivEXT = Function('glGetPixelTransformParameterivEXT')
glGetPixelTransformParameterivEXT.ret = Return('void')
glGetPixelTransformParameterivEXT.add( Input( 'target','GLenum' ))
glGetPixelTransformParameterivEXT.add( Input( 'pname','GLenum' ))
glGetPixelTransformParameterivEXT.add( Output( 'params','GLint *' ))
glGetPixelTransformParameterivEXT.version = ''
glGetPixelTransformParameterivEXT.category = 'GL_EXT_pixel_transform'
glGetPixelTransformParameterivEXT.trace = True
glGetPixelTransformParameterivEXT.play = True
gl.add(glGetPixelTransformParameterivEXT)

glPixelTransformParameterfEXT = Function('glPixelTransformParameterfEXT')
glPixelTransformParameterfEXT.ret = Return('void')
glPixelTransformParameterfEXT.add( Input( 'target','GLenum' ))
glPixelTransformParameterfEXT.add( Input( 'pname','GLenum' ))
glPixelTransformParameterfEXT.add( Input( 'param','const GLfloat' ))
glPixelTransformParameterfEXT.version = '1.1'
glPixelTransformParameterfEXT.category = 'GL_EXT_pixel_transform'
glPixelTransformParameterfEXT.trace = True
glPixelTransformParameterfEXT.play = True
gl.add(glPixelTransformParameterfEXT)

glPixelTransformParameterfvEXT = Function('glPixelTransformParameterfvEXT')
glPixelTransformParameterfvEXT.ret = Return('void')
glPixelTransformParameterfvEXT.add( Input( 'target','GLenum' ))
glPixelTransformParameterfvEXT.add( Input( 'pname','GLenum' ))
glPixelTransformParameterfvEXT.add( Input( 'params','const GLfloat *' ,size = 1 ))
glPixelTransformParameterfvEXT.version = '1.1'
glPixelTransformParameterfvEXT.category = 'GL_EXT_pixel_transform'
glPixelTransformParameterfvEXT.trace = True
glPixelTransformParameterfvEXT.play = True
gl.add(glPixelTransformParameterfvEXT)

glPixelTransformParameteriEXT = Function('glPixelTransformParameteriEXT')
glPixelTransformParameteriEXT.ret = Return('void')
glPixelTransformParameteriEXT.add( Input( 'target','GLenum' ))
glPixelTransformParameteriEXT.add( Input( 'pname','GLenum' ))
glPixelTransformParameteriEXT.add( Input( 'param','const GLint' ))
glPixelTransformParameteriEXT.version = '1.1'
glPixelTransformParameteriEXT.category = 'GL_EXT_pixel_transform'
glPixelTransformParameteriEXT.trace = True
glPixelTransformParameteriEXT.play = True
gl.add(glPixelTransformParameteriEXT)

glPixelTransformParameterivEXT = Function('glPixelTransformParameterivEXT')
glPixelTransformParameterivEXT.ret = Return('void')
glPixelTransformParameterivEXT.add( Input( 'target','GLenum' ))
glPixelTransformParameterivEXT.add( Input( 'pname','GLenum' ))
glPixelTransformParameterivEXT.add( Input( 'params','const GLint *' ,size = 1 ))
glPixelTransformParameterivEXT.version = '1.1'
glPixelTransformParameterivEXT.category = 'GL_EXT_pixel_transform'
glPixelTransformParameterivEXT.trace = True
glPixelTransformParameterivEXT.play = True
gl.add(glPixelTransformParameterivEXT)

# GL_EXT_point_parameters

glPointParameterfEXT = Function('glPointParameterfEXT')
glPointParameterfEXT.ret = Return('void')
glPointParameterfEXT.add( Input( 'pname','GLenum' ))
glPointParameterfEXT.add( Input( 'param','GLfloat' ))
glPointParameterfEXT.version = '1.1'
glPointParameterfEXT.category = 'GL_EXT_point_parameters'
glPointParameterfEXT.trace = True
glPointParameterfEXT.play = True
gl.add(glPointParameterfEXT)

glPointParameterfvEXT = Function('glPointParameterfvEXT')
glPointParameterfvEXT.ret = Return('void')
glPointParameterfvEXT.add( Input( 'pname','GLenum' ))
glPointParameterfvEXT.add( Input( 'params','const GLfloat *' ))
glPointParameterfvEXT.version = '1.1'
glPointParameterfvEXT.category = 'GL_EXT_point_parameters'
glPointParameterfvEXT.trace = True
glPointParameterfvEXT.play = True
gl.add(glPointParameterfvEXT)

# GL_EXT_polygon_offset

glPolygonOffsetEXT = Function('glPolygonOffsetEXT')
glPolygonOffsetEXT.ret = Return('void')
glPolygonOffsetEXT.add( Input( 'factor','GLfloat' ))
glPolygonOffsetEXT.add( Input( 'bias','GLfloat' ))
glPolygonOffsetEXT.version = '1.0'
glPolygonOffsetEXT.category = 'GL_EXT_polygon_offset'
glPolygonOffsetEXT.trace = True
glPolygonOffsetEXT.play = True
gl.add(glPolygonOffsetEXT)

# GL_EXT_provoking_vertex

glProvokingVertexEXT = Function('glProvokingVertexEXT')
glProvokingVertexEXT.ret = Return('void')
glProvokingVertexEXT.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glProvokingVertexEXT.version = '1.0'
glProvokingVertexEXT.category = 'GL_EXT_provoking_vertex'
glProvokingVertexEXT.trace = True
glProvokingVertexEXT.play = True
gl.add(glProvokingVertexEXT)

# GL_EXT_robustness

glGetnUniformfvEXT = Function('glGetnUniformfvEXT')
glGetnUniformfvEXT.ret = Return('void')
glGetnUniformfvEXT.add( Input( 'program','GLuint' ))
glGetnUniformfvEXT.add( Input( 'location','GLint' ))
glGetnUniformfvEXT.add( Input( 'bufSize','GLsizei' ))
glGetnUniformfvEXT.add( Input( 'params','GLfloat *' ))
glGetnUniformfvEXT.version = ''
glGetnUniformfvEXT.category = 'GL_EXT_robustness'
glGetnUniformfvEXT.trace = True
glGetnUniformfvEXT.play = True
gl.add(glGetnUniformfvEXT)

glGetnUniformivEXT = Function('glGetnUniformivEXT')
glGetnUniformivEXT.ret = Return('void')
glGetnUniformivEXT.add( Input( 'program','GLuint' ))
glGetnUniformivEXT.add( Input( 'location','GLint' ))
glGetnUniformivEXT.add( Input( 'bufSize','GLsizei' ))
glGetnUniformivEXT.add( Input( 'params','GLint *' ))
glGetnUniformivEXT.version = ''
glGetnUniformivEXT.category = 'GL_EXT_robustness'
glGetnUniformivEXT.trace = True
glGetnUniformivEXT.play = True
gl.add(glGetnUniformivEXT)

glReadnPixelsEXT = Function('glReadnPixelsEXT')
glReadnPixelsEXT.ret = Return('void')
glReadnPixelsEXT.add( Input( 'x','GLint' ))
glReadnPixelsEXT.add( Input( 'y','GLint' ))
glReadnPixelsEXT.add( Input( 'width','GLsizei' ))
glReadnPixelsEXT.add( Input( 'height','GLsizei' ))
glReadnPixelsEXT.add( Input( 'format','GLenum' ))
glReadnPixelsEXT.add( Input( 'type','GLenum' ))
glReadnPixelsEXT.add( Input( 'bufSize','GLsizei' ))
glReadnPixelsEXT.add( Input( 'data','GLvoid *' ))
glReadnPixelsEXT.version = ''
glReadnPixelsEXT.category = 'GL_EXT_robustness'
glReadnPixelsEXT.trace = True
glReadnPixelsEXT.play = True
gl.add(glReadnPixelsEXT)

# GL_EXT_scene_marker

glBeginSceneEXT = Function('glBeginSceneEXT')
glBeginSceneEXT.ret = Return('void')
glBeginSceneEXT.version = ''
glBeginSceneEXT.category = 'GL_EXT_scene_marker'
glBeginSceneEXT.trace = True
glBeginSceneEXT.play = True
gl.add(glBeginSceneEXT)

glEndSceneEXT = Function('glEndSceneEXT')
glEndSceneEXT.ret = Return('void')
glEndSceneEXT.version = ''
glEndSceneEXT.category = 'GL_EXT_scene_marker'
glEndSceneEXT.trace = True
glEndSceneEXT.play = True
gl.add(glEndSceneEXT)

# GL_EXT_secondary_color

glSecondaryColor3bEXT = Function('glSecondaryColor3bEXT')
glSecondaryColor3bEXT.ret = Return('void')
glSecondaryColor3bEXT.add( Input( 'red','GLbyte' ))
glSecondaryColor3bEXT.add( Input( 'green','GLbyte' ))
glSecondaryColor3bEXT.add( Input( 'blue','GLbyte' ))
glSecondaryColor3bEXT.version = '1.1'
glSecondaryColor3bEXT.category = 'GL_EXT_secondary_color'
glSecondaryColor3bEXT.trace = True
glSecondaryColor3bEXT.play = True
gl.add(glSecondaryColor3bEXT)

glSecondaryColor3bvEXT = Function('glSecondaryColor3bvEXT')
glSecondaryColor3bvEXT.ret = Return('void')
glSecondaryColor3bvEXT.add( Input( 'v','const GLbyte *' ,size = 3 ))
glSecondaryColor3bvEXT.version = '1.1'
glSecondaryColor3bvEXT.category = 'GL_EXT_secondary_color'
glSecondaryColor3bvEXT.trace = True
glSecondaryColor3bvEXT.play = True
gl.add(glSecondaryColor3bvEXT)

glSecondaryColor3dEXT = Function('glSecondaryColor3dEXT')
glSecondaryColor3dEXT.ret = Return('void')
glSecondaryColor3dEXT.add( Input( 'red','GLdouble' ))
glSecondaryColor3dEXT.add( Input( 'green','GLdouble' ))
glSecondaryColor3dEXT.add( Input( 'blue','GLdouble' ))
glSecondaryColor3dEXT.version = '1.1'
glSecondaryColor3dEXT.category = 'GL_EXT_secondary_color'
glSecondaryColor3dEXT.trace = True
glSecondaryColor3dEXT.play = True
gl.add(glSecondaryColor3dEXT)

glSecondaryColor3dvEXT = Function('glSecondaryColor3dvEXT')
glSecondaryColor3dvEXT.ret = Return('void')
glSecondaryColor3dvEXT.add( Input( 'v','const GLdouble *' ,size = 3 ))
glSecondaryColor3dvEXT.version = '1.1'
glSecondaryColor3dvEXT.category = 'GL_EXT_secondary_color'
glSecondaryColor3dvEXT.trace = True
glSecondaryColor3dvEXT.play = True
gl.add(glSecondaryColor3dvEXT)

glSecondaryColor3fEXT = Function('glSecondaryColor3fEXT')
glSecondaryColor3fEXT.ret = Return('void')
glSecondaryColor3fEXT.add( Input( 'red','GLfloat' ))
glSecondaryColor3fEXT.add( Input( 'green','GLfloat' ))
glSecondaryColor3fEXT.add( Input( 'blue','GLfloat' ))
glSecondaryColor3fEXT.version = '1.1'
glSecondaryColor3fEXT.category = 'GL_EXT_secondary_color'
glSecondaryColor3fEXT.trace = True
glSecondaryColor3fEXT.play = True
gl.add(glSecondaryColor3fEXT)

glSecondaryColor3fvEXT = Function('glSecondaryColor3fvEXT')
glSecondaryColor3fvEXT.ret = Return('void')
glSecondaryColor3fvEXT.add( Input( 'v','const GLfloat *' ,size = 3 ))
glSecondaryColor3fvEXT.version = '1.1'
glSecondaryColor3fvEXT.category = 'GL_EXT_secondary_color'
glSecondaryColor3fvEXT.trace = True
glSecondaryColor3fvEXT.play = True
gl.add(glSecondaryColor3fvEXT)

glSecondaryColor3iEXT = Function('glSecondaryColor3iEXT')
glSecondaryColor3iEXT.ret = Return('void')
glSecondaryColor3iEXT.add( Input( 'red','GLint' ))
glSecondaryColor3iEXT.add( Input( 'green','GLint' ))
glSecondaryColor3iEXT.add( Input( 'blue','GLint' ))
glSecondaryColor3iEXT.version = '1.1'
glSecondaryColor3iEXT.category = 'GL_EXT_secondary_color'
glSecondaryColor3iEXT.trace = True
glSecondaryColor3iEXT.play = True
gl.add(glSecondaryColor3iEXT)

glSecondaryColor3ivEXT = Function('glSecondaryColor3ivEXT')
glSecondaryColor3ivEXT.ret = Return('void')
glSecondaryColor3ivEXT.add( Input( 'v','const GLint *' ,size = 3 ))
glSecondaryColor3ivEXT.version = '1.1'
glSecondaryColor3ivEXT.category = 'GL_EXT_secondary_color'
glSecondaryColor3ivEXT.trace = True
glSecondaryColor3ivEXT.play = True
gl.add(glSecondaryColor3ivEXT)

glSecondaryColor3sEXT = Function('glSecondaryColor3sEXT')
glSecondaryColor3sEXT.ret = Return('void')
glSecondaryColor3sEXT.add( Input( 'red','GLshort' ))
glSecondaryColor3sEXT.add( Input( 'green','GLshort' ))
glSecondaryColor3sEXT.add( Input( 'blue','GLshort' ))
glSecondaryColor3sEXT.version = '1.1'
glSecondaryColor3sEXT.category = 'GL_EXT_secondary_color'
glSecondaryColor3sEXT.trace = True
glSecondaryColor3sEXT.play = True
gl.add(glSecondaryColor3sEXT)

glSecondaryColor3svEXT = Function('glSecondaryColor3svEXT')
glSecondaryColor3svEXT.ret = Return('void')
glSecondaryColor3svEXT.add( Input( 'v','const GLshort *' ,size = 3 ))
glSecondaryColor3svEXT.version = '1.1'
glSecondaryColor3svEXT.category = 'GL_EXT_secondary_color'
glSecondaryColor3svEXT.trace = True
glSecondaryColor3svEXT.play = True
gl.add(glSecondaryColor3svEXT)

glSecondaryColor3ubEXT = Function('glSecondaryColor3ubEXT')
glSecondaryColor3ubEXT.ret = Return('void')
glSecondaryColor3ubEXT.add( Input( 'red','GLubyte' ))
glSecondaryColor3ubEXT.add( Input( 'green','GLubyte' ))
glSecondaryColor3ubEXT.add( Input( 'blue','GLubyte' ))
glSecondaryColor3ubEXT.version = '1.1'
glSecondaryColor3ubEXT.category = 'GL_EXT_secondary_color'
glSecondaryColor3ubEXT.trace = True
glSecondaryColor3ubEXT.play = True
gl.add(glSecondaryColor3ubEXT)

glSecondaryColor3ubvEXT = Function('glSecondaryColor3ubvEXT')
glSecondaryColor3ubvEXT.ret = Return('void')
glSecondaryColor3ubvEXT.add( Input( 'v','const GLubyte *' ,size = 3 ))
glSecondaryColor3ubvEXT.version = '1.1'
glSecondaryColor3ubvEXT.category = 'GL_EXT_secondary_color'
glSecondaryColor3ubvEXT.trace = True
glSecondaryColor3ubvEXT.play = True
gl.add(glSecondaryColor3ubvEXT)

glSecondaryColor3uiEXT = Function('glSecondaryColor3uiEXT')
glSecondaryColor3uiEXT.ret = Return('void')
glSecondaryColor3uiEXT.add( Input( 'red','GLuint' ))
glSecondaryColor3uiEXT.add( Input( 'green','GLuint' ))
glSecondaryColor3uiEXT.add( Input( 'blue','GLuint' ))
glSecondaryColor3uiEXT.version = '1.1'
glSecondaryColor3uiEXT.category = 'GL_EXT_secondary_color'
glSecondaryColor3uiEXT.trace = True
glSecondaryColor3uiEXT.play = True
gl.add(glSecondaryColor3uiEXT)

glSecondaryColor3uivEXT = Function('glSecondaryColor3uivEXT')
glSecondaryColor3uivEXT.ret = Return('void')
glSecondaryColor3uivEXT.add( Input( 'v','const GLuint *' ,size = 3 ))
glSecondaryColor3uivEXT.version = '1.1'
glSecondaryColor3uivEXT.category = 'GL_EXT_secondary_color'
glSecondaryColor3uivEXT.trace = True
glSecondaryColor3uivEXT.play = True
gl.add(glSecondaryColor3uivEXT)

glSecondaryColor3usEXT = Function('glSecondaryColor3usEXT')
glSecondaryColor3usEXT.ret = Return('void')
glSecondaryColor3usEXT.add( Input( 'red','GLushort' ))
glSecondaryColor3usEXT.add( Input( 'green','GLushort' ))
glSecondaryColor3usEXT.add( Input( 'blue','GLushort' ))
glSecondaryColor3usEXT.version = '1.1'
glSecondaryColor3usEXT.category = 'GL_EXT_secondary_color'
glSecondaryColor3usEXT.trace = True
glSecondaryColor3usEXT.play = True
gl.add(glSecondaryColor3usEXT)

glSecondaryColor3usvEXT = Function('glSecondaryColor3usvEXT')
glSecondaryColor3usvEXT.ret = Return('void')
glSecondaryColor3usvEXT.add( Input( 'v','const GLushort *' ,size = 3 ))
glSecondaryColor3usvEXT.version = '1.1'
glSecondaryColor3usvEXT.category = 'GL_EXT_secondary_color'
glSecondaryColor3usvEXT.trace = True
glSecondaryColor3usvEXT.play = True
gl.add(glSecondaryColor3usvEXT)

glSecondaryColorPointerEXT = Function('glSecondaryColorPointerEXT')
glSecondaryColorPointerEXT.ret = Return('void')
glSecondaryColorPointerEXT.add( Input( 'size','GLint' ))
glSecondaryColorPointerEXT.add( Input( 'type','GLenum' ))
glSecondaryColorPointerEXT.add( Input( 'stride','GLsizei' ))
glSecondaryColorPointerEXT.add( Input( 'pointer','const GLvoid *' ))
glSecondaryColorPointerEXT.version = '1.1'
glSecondaryColorPointerEXT.category = 'GL_EXT_secondary_color'
glSecondaryColorPointerEXT.trace = True
glSecondaryColorPointerEXT.play = True
gl.add(glSecondaryColorPointerEXT)

# GL_EXT_separate_shader_objects

glActiveProgramEXT = Function('glActiveProgramEXT')
glActiveProgramEXT.ret = Return('void')
glActiveProgramEXT.add( Input( 'program','GLuint' ))
glActiveProgramEXT.version = '2.0'
glActiveProgramEXT.category = 'GL_EXT_separate_shader_objects'
glActiveProgramEXT.trace = True
glActiveProgramEXT.play = True
gl.add(glActiveProgramEXT)

glCreateShaderProgramEXT = Function('glCreateShaderProgramEXT')
glCreateShaderProgramEXT.ret = Return('GLuint')
glCreateShaderProgramEXT.add( Input( 'type','GLenum' ))
glCreateShaderProgramEXT.add( Input( 'string','const GLchar *' ))
glCreateShaderProgramEXT.version = '2.0'
glCreateShaderProgramEXT.category = 'GL_EXT_separate_shader_objects'
glCreateShaderProgramEXT.trace = True
glCreateShaderProgramEXT.play = True
gl.add(glCreateShaderProgramEXT)

glUseShaderProgramEXT = Function('glUseShaderProgramEXT')
glUseShaderProgramEXT.ret = Return('void')
glUseShaderProgramEXT.add( Input( 'type','GLenum' ))
glUseShaderProgramEXT.add( Input( 'program','GLuint' ))
glUseShaderProgramEXT.version = '2.0'
glUseShaderProgramEXT.category = 'GL_EXT_separate_shader_objects'
glUseShaderProgramEXT.trace = True
glUseShaderProgramEXT.play = True
gl.add(glUseShaderProgramEXT)

# GL_EXT_shader_image_load_store

glBindImageTextureEXT = Function('glBindImageTextureEXT')
glBindImageTextureEXT.ret = Return('void')
glBindImageTextureEXT.add( Input( 'index','GLuint' ))
glBindImageTextureEXT.add( Input( 'texture','GLuint' ))
glBindImageTextureEXT.add( Input( 'level','GLint' ))
glBindImageTextureEXT.add( Input( 'layered','GLboolean' ))
glBindImageTextureEXT.add( Input( 'layer','GLint' ))
glBindImageTextureEXT.add( Input( 'access','GLenum' ))
glBindImageTextureEXT.add( Input( 'format','GLint' ))
glBindImageTextureEXT.version = '2.0'
glBindImageTextureEXT.category = 'GL_EXT_shader_image_load_store'
glBindImageTextureEXT.trace = True
glBindImageTextureEXT.play = True
gl.add(glBindImageTextureEXT)

glMemoryBarrierEXT = Function('glMemoryBarrierEXT')
glMemoryBarrierEXT.ret = Return('void')
glMemoryBarrierEXT.add( Input( 'barriers','GLbitfield' ,regalLog = 'GLmemoryBarrierToString(barriers)' ))
glMemoryBarrierEXT.version = '2.0'
glMemoryBarrierEXT.category = 'GL_EXT_shader_image_load_store'
glMemoryBarrierEXT.trace = True
glMemoryBarrierEXT.play = True
gl.add(glMemoryBarrierEXT)

# GL_EXT_stencil_clear_tag

glStencilClearTagEXT = Function('glStencilClearTagEXT')
glStencilClearTagEXT.ret = Return('void')
glStencilClearTagEXT.add( Input( 'stencilTagBits','GLsizei' ))
glStencilClearTagEXT.add( Input( 'stencilClearTag','GLuint' ))
glStencilClearTagEXT.version = '1.5'
glStencilClearTagEXT.category = 'GL_EXT_stencil_clear_tag'
glStencilClearTagEXT.trace = True
glStencilClearTagEXT.play = True
gl.add(glStencilClearTagEXT)

# GL_EXT_stencil_two_side

glActiveStencilFaceEXT = Function('glActiveStencilFaceEXT')
glActiveStencilFaceEXT.ret = Return('void')
glActiveStencilFaceEXT.add( Input( 'face','GLenum' ))
glActiveStencilFaceEXT.version = '1.1'
glActiveStencilFaceEXT.category = 'GL_EXT_stencil_two_side'
glActiveStencilFaceEXT.trace = True
glActiveStencilFaceEXT.play = True
gl.add(glActiveStencilFaceEXT)

# GL_EXT_subtexture

glTexSubImage1DEXT = Function('glTexSubImage1DEXT')
glTexSubImage1DEXT.ret = Return('void')
glTexSubImage1DEXT.add( Input( 'target','GLenum' ))
glTexSubImage1DEXT.add( Input( 'level','GLint' ))
glTexSubImage1DEXT.add( Input( 'xoffset','GLint' ))
glTexSubImage1DEXT.add( Input( 'width','GLsizei' ))
glTexSubImage1DEXT.add( Input( 'format','GLenum' ))
glTexSubImage1DEXT.add( Input( 'type','GLenum' ))
glTexSubImage1DEXT.add( Input( 'pixels','const GLvoid *' ,size = 'helperGLPixelImageSize(width, 0, 0, format, type, 0, target)' ,cast = 'const GLubyte *' ))
glTexSubImage1DEXT.version = '1.0'
glTexSubImage1DEXT.category = 'GL_EXT_subtexture'
glTexSubImage1DEXT.trace = True
glTexSubImage1DEXT.play = True
gl.add(glTexSubImage1DEXT)

glTexSubImage2DEXT = Function('glTexSubImage2DEXT')
glTexSubImage2DEXT.ret = Return('void')
glTexSubImage2DEXT.add( Input( 'target','GLenum' ))
glTexSubImage2DEXT.add( Input( 'level','GLint' ))
glTexSubImage2DEXT.add( Input( 'xoffset','GLint' ))
glTexSubImage2DEXT.add( Input( 'yoffset','GLint' ))
glTexSubImage2DEXT.add( Input( 'width','GLsizei' ))
glTexSubImage2DEXT.add( Input( 'height','GLsizei' ))
glTexSubImage2DEXT.add( Input( 'format','GLenum' ))
glTexSubImage2DEXT.add( Input( 'type','GLenum' ))
glTexSubImage2DEXT.add( Input( 'pixels','const GLvoid *' ,size = 'helperGLPixelImageSize(width, height, 0, format, type, 0, target)' ,cast = 'const GLubyte *' ))
glTexSubImage2DEXT.version = '1.0'
glTexSubImage2DEXT.category = 'GL_EXT_subtexture'
glTexSubImage2DEXT.trace = True
glTexSubImage2DEXT.play = True
gl.add(glTexSubImage2DEXT)

glTexSubImage3DEXT = Function('glTexSubImage3DEXT')
glTexSubImage3DEXT.ret = Return('void')
glTexSubImage3DEXT.add( Input( 'target','GLenum' ))
glTexSubImage3DEXT.add( Input( 'level','GLint' ))
glTexSubImage3DEXT.add( Input( 'xoffset','GLint' ))
glTexSubImage3DEXT.add( Input( 'yoffset','GLint' ))
glTexSubImage3DEXT.add( Input( 'zoffset','GLint' ))
glTexSubImage3DEXT.add( Input( 'width','GLsizei' ))
glTexSubImage3DEXT.add( Input( 'height','GLsizei' ))
glTexSubImage3DEXT.add( Input( 'depth','GLsizei' ))
glTexSubImage3DEXT.add( Input( 'format','GLenum' ))
glTexSubImage3DEXT.add( Input( 'type','GLenum' ))
glTexSubImage3DEXT.add( Input( 'pixels','const GLvoid *' ,size = 'helperGLPixelImageSize(width, height, depth, format, type, 0, target)' ,cast = 'const GLubyte *' ))
glTexSubImage3DEXT.version = '1.2'
glTexSubImage3DEXT.category = 'GL_EXT_subtexture'
glTexSubImage3DEXT.trace = True
glTexSubImage3DEXT.play = True
gl.add(glTexSubImage3DEXT)

# GL_EXT_texture3D

glTexImage3DEXT = Function('glTexImage3DEXT')
glTexImage3DEXT.ret = Return('void')
glTexImage3DEXT.add( Input( 'target','GLenum' ))
glTexImage3DEXT.add( Input( 'level','GLint' ))
glTexImage3DEXT.add( Input( 'internalformat','GLenum' ,regalLog = 'internalFormatToString(internalformat)' ))
glTexImage3DEXT.add( Input( 'width','GLsizei' ))
glTexImage3DEXT.add( Input( 'height','GLsizei' ))
glTexImage3DEXT.add( Input( 'depth','GLsizei' ))
glTexImage3DEXT.add( Input( 'border','GLint' ))
glTexImage3DEXT.add( Input( 'format','GLenum' ))
glTexImage3DEXT.add( Input( 'type','GLenum' ))
glTexImage3DEXT.add( Input( 'pixels','const GLvoid *' ,size = 'helperGLPixelImageSize(width, height, depth, format, type, 0, target)' ,cast = 'const GLubyte *' ))
glTexImage3DEXT.version = '1.2'
glTexImage3DEXT.category = 'GL_EXT_texture3D'
glTexImage3DEXT.trace = True
glTexImage3DEXT.play = True
gl.add(glTexImage3DEXT)

# GL_EXT_texture_array

glFramebufferTextureLayerEXT = Function('glFramebufferTextureLayerEXT')
glFramebufferTextureLayerEXT.ret = Return('void')
glFramebufferTextureLayerEXT.add( Input( 'target','GLenum' ))
glFramebufferTextureLayerEXT.add( Input( 'attachment','GLenum' ))
glFramebufferTextureLayerEXT.add( Input( 'texture','GLuint' ))
glFramebufferTextureLayerEXT.add( Input( 'level','GLint' ))
glFramebufferTextureLayerEXT.add( Input( 'layer','GLint' ))
glFramebufferTextureLayerEXT.version = '2.0'
glFramebufferTextureLayerEXT.category = 'GL_EXT_texture_array'
glFramebufferTextureLayerEXT.trace = True
glFramebufferTextureLayerEXT.play = True
gl.add(glFramebufferTextureLayerEXT)

# GL_EXT_texture_buffer_object

glTexBufferEXT = Function('glTexBufferEXT')
glTexBufferEXT.ret = Return('void')
glTexBufferEXT.add( Input( 'target','GLenum' ))
glTexBufferEXT.add( Input( 'internalformat','GLenum' ))
glTexBufferEXT.add( Input( 'buffer','GLuint' ))
glTexBufferEXT.version = '2.0'
glTexBufferEXT.category = 'GL_EXT_texture_buffer_object'
glTexBufferEXT.trace = True
glTexBufferEXT.play = True
gl.add(glTexBufferEXT)

# GL_EXT_texture_integer

glClearColorIiEXT = Function('glClearColorIiEXT')
glClearColorIiEXT.ret = Return('void')
glClearColorIiEXT.add( Input( 'red','GLint' ))
glClearColorIiEXT.add( Input( 'green','GLint' ))
glClearColorIiEXT.add( Input( 'blue','GLint' ))
glClearColorIiEXT.add( Input( 'alpha','GLint' ))
glClearColorIiEXT.version = '2.0'
glClearColorIiEXT.category = 'GL_EXT_texture_integer'
glClearColorIiEXT.trace = True
glClearColorIiEXT.play = True
gl.add(glClearColorIiEXT)

glClearColorIuiEXT = Function('glClearColorIuiEXT')
glClearColorIuiEXT.ret = Return('void')
glClearColorIuiEXT.add( Input( 'red','GLuint' ))
glClearColorIuiEXT.add( Input( 'green','GLuint' ))
glClearColorIuiEXT.add( Input( 'blue','GLuint' ))
glClearColorIuiEXT.add( Input( 'alpha','GLuint' ))
glClearColorIuiEXT.version = '2.0'
glClearColorIuiEXT.category = 'GL_EXT_texture_integer'
glClearColorIuiEXT.trace = True
glClearColorIuiEXT.play = True
gl.add(glClearColorIuiEXT)

glGetTexParameterIivEXT = Function('glGetTexParameterIivEXT')
glGetTexParameterIivEXT.ret = Return('void')
glGetTexParameterIivEXT.add( Input( 'target','GLenum' ))
glGetTexParameterIivEXT.add( Input( 'pname','GLenum' ))
glGetTexParameterIivEXT.add( Output( 'params','GLint *' ))
glGetTexParameterIivEXT.version = '2.0'
glGetTexParameterIivEXT.category = 'GL_EXT_texture_integer'
glGetTexParameterIivEXT.trace = True
glGetTexParameterIivEXT.play = True
gl.add(glGetTexParameterIivEXT)

glGetTexParameterIuivEXT = Function('glGetTexParameterIuivEXT')
glGetTexParameterIuivEXT.ret = Return('void')
glGetTexParameterIuivEXT.add( Input( 'target','GLenum' ))
glGetTexParameterIuivEXT.add( Input( 'pname','GLenum' ))
glGetTexParameterIuivEXT.add( Output( 'params','GLuint *' ))
glGetTexParameterIuivEXT.version = '2.0'
glGetTexParameterIuivEXT.category = 'GL_EXT_texture_integer'
glGetTexParameterIuivEXT.trace = True
glGetTexParameterIuivEXT.play = True
gl.add(glGetTexParameterIuivEXT)

glTexParameterIivEXT = Function('glTexParameterIivEXT')
glTexParameterIivEXT.ret = Return('void')
glTexParameterIivEXT.add( Input( 'target','GLenum' ))
glTexParameterIivEXT.add( Input( 'pname','GLenum' ))
glTexParameterIivEXT.add( Input( 'params','const GLint *' ,regalLog = 'GLTexParameterToString(pname,params)' ))
glTexParameterIivEXT.version = '2.0'
glTexParameterIivEXT.category = 'GL_EXT_texture_integer'
glTexParameterIivEXT.trace = True
glTexParameterIivEXT.play = True
gl.add(glTexParameterIivEXT)

glTexParameterIuivEXT = Function('glTexParameterIuivEXT')
glTexParameterIuivEXT.ret = Return('void')
glTexParameterIuivEXT.add( Input( 'target','GLenum' ))
glTexParameterIuivEXT.add( Input( 'pname','GLenum' ))
glTexParameterIuivEXT.add( Input( 'params','const GLuint *' ,regalLog = 'GLTexParameterToString(pname,params)' ))
glTexParameterIuivEXT.version = '2.0'
glTexParameterIuivEXT.category = 'GL_EXT_texture_integer'
glTexParameterIuivEXT.trace = True
glTexParameterIuivEXT.play = True
gl.add(glTexParameterIuivEXT)

# GL_EXT_texture_object

glAreTexturesResidentEXT = Function('glAreTexturesResidentEXT')
glAreTexturesResidentEXT.ret = Return('GLboolean')
glAreTexturesResidentEXT.add( Input( 'n','GLsizei' ))
glAreTexturesResidentEXT.add( Input( 'textures','const GLuint *' ,size = 'n' ))
glAreTexturesResidentEXT.add( Output( 'residences','GLboolean *' ,size = 'n' ))
glAreTexturesResidentEXT.version = '1.1'
glAreTexturesResidentEXT.category = 'GL_EXT_texture_object'
glAreTexturesResidentEXT.trace = True
glAreTexturesResidentEXT.play = True
gl.add(glAreTexturesResidentEXT)

glBindTextureEXT = Function('glBindTextureEXT')
glBindTextureEXT.ret = Return('void')
glBindTextureEXT.add( Input( 'target','GLenum' ))
glBindTextureEXT.add( Input( 'texture','GLuint' ))
glBindTextureEXT.version = '1.1'
glBindTextureEXT.category = 'GL_EXT_texture_object'
glBindTextureEXT.trace = True
glBindTextureEXT.play = True
gl.add(glBindTextureEXT)

glDeleteTexturesEXT = Function('glDeleteTexturesEXT')
glDeleteTexturesEXT.ret = Return('void')
glDeleteTexturesEXT.add( Input( 'n','GLsizei' ))
glDeleteTexturesEXT.add( Input( 'textures','const GLuint *' ,size = 'n' ))
glDeleteTexturesEXT.version = '1.1'
glDeleteTexturesEXT.category = 'GL_EXT_texture_object'
glDeleteTexturesEXT.trace = True
glDeleteTexturesEXT.play = True
gl.add(glDeleteTexturesEXT)

glGenTexturesEXT = Function('glGenTexturesEXT')
glGenTexturesEXT.ret = Return('void')
glGenTexturesEXT.add( Input( 'n','GLsizei' ))
glGenTexturesEXT.add( Output( 'textures','GLuint *' ,size = 'n' ))
glGenTexturesEXT.version = '1.1'
glGenTexturesEXT.category = 'GL_EXT_texture_object'
glGenTexturesEXT.trace = True
glGenTexturesEXT.play = True
gl.add(glGenTexturesEXT)

glIsTextureEXT = Function('glIsTextureEXT')
glIsTextureEXT.ret = Return('GLboolean')
glIsTextureEXT.add( Input( 'texture','GLuint' ))
glIsTextureEXT.version = '1.1'
glIsTextureEXT.category = 'GL_EXT_texture_object'
glIsTextureEXT.trace = True
glIsTextureEXT.play = True
gl.add(glIsTextureEXT)

glPrioritizeTexturesEXT = Function('glPrioritizeTexturesEXT')
glPrioritizeTexturesEXT.ret = Return('void')
glPrioritizeTexturesEXT.add( Input( 'n','GLsizei' ))
glPrioritizeTexturesEXT.add( Input( 'textures','const GLuint *' ,size = 'n' ))
glPrioritizeTexturesEXT.add( Input( 'priorities','const GLclampf *' ,size = 'n' ))
glPrioritizeTexturesEXT.version = '1.1'
glPrioritizeTexturesEXT.category = 'GL_EXT_texture_object'
glPrioritizeTexturesEXT.trace = True
glPrioritizeTexturesEXT.play = True
gl.add(glPrioritizeTexturesEXT)

# GL_EXT_texture_perturb_normal

glTextureNormalEXT = Function('glTextureNormalEXT')
glTextureNormalEXT.ret = Return('void')
glTextureNormalEXT.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glTextureNormalEXT.version = '1.1'
glTextureNormalEXT.category = 'GL_EXT_texture_perturb_normal'
glTextureNormalEXT.trace = True
glTextureNormalEXT.play = True
gl.add(glTextureNormalEXT)

# GL_EXT_texture_storage

glTexStorage1DEXT = Function('glTexStorage1DEXT')
glTexStorage1DEXT.ret = Return('void')
glTexStorage1DEXT.add( Input( 'target','GLenum' ))
glTexStorage1DEXT.add( Input( 'levels','GLsizei' ))
glTexStorage1DEXT.add( Input( 'internalformat','GLenum' ))
glTexStorage1DEXT.add( Input( 'width','GLsizei' ))
glTexStorage1DEXT.version = ''
glTexStorage1DEXT.category = 'GL_EXT_texture_storage'
glTexStorage1DEXT.trace = True
glTexStorage1DEXT.play = True
gl.add(glTexStorage1DEXT)

glTexStorage2DEXT = Function('glTexStorage2DEXT')
glTexStorage2DEXT.ret = Return('void')
glTexStorage2DEXT.add( Input( 'target','GLenum' ))
glTexStorage2DEXT.add( Input( 'levels','GLsizei' ))
glTexStorage2DEXT.add( Input( 'internalformat','GLenum' ))
glTexStorage2DEXT.add( Input( 'width','GLsizei' ))
glTexStorage2DEXT.add( Input( 'height','GLsizei' ))
glTexStorage2DEXT.version = ''
glTexStorage2DEXT.category = 'GL_EXT_texture_storage'
glTexStorage2DEXT.trace = True
glTexStorage2DEXT.play = True
gl.add(glTexStorage2DEXT)

glTexStorage3DEXT = Function('glTexStorage3DEXT')
glTexStorage3DEXT.ret = Return('void')
glTexStorage3DEXT.add( Input( 'target','GLenum' ))
glTexStorage3DEXT.add( Input( 'levels','GLsizei' ))
glTexStorage3DEXT.add( Input( 'internalformat','GLenum' ))
glTexStorage3DEXT.add( Input( 'width','GLsizei' ))
glTexStorage3DEXT.add( Input( 'height','GLsizei' ))
glTexStorage3DEXT.add( Input( 'depth','GLsizei' ))
glTexStorage3DEXT.version = ''
glTexStorage3DEXT.category = 'GL_EXT_texture_storage'
glTexStorage3DEXT.trace = True
glTexStorage3DEXT.play = True
gl.add(glTexStorage3DEXT)

# GL_EXT_timer_query

glGetQueryObjecti64vEXT = Function('glGetQueryObjecti64vEXT')
glGetQueryObjecti64vEXT.ret = Return('void')
glGetQueryObjecti64vEXT.add( Input( 'id','GLuint' ))
glGetQueryObjecti64vEXT.add( Input( 'pname','GLenum' ))
glGetQueryObjecti64vEXT.add( Output( 'params','GLint64EXT *' ))
glGetQueryObjecti64vEXT.version = '1.5'
glGetQueryObjecti64vEXT.category = 'GL_EXT_timer_query'
glGetQueryObjecti64vEXT.trace = True
glGetQueryObjecti64vEXT.play = False
gl.add(glGetQueryObjecti64vEXT)

glGetQueryObjectui64vEXT = Function('glGetQueryObjectui64vEXT')
glGetQueryObjectui64vEXT.ret = Return('void')
glGetQueryObjectui64vEXT.add( Input( 'id','GLuint' ))
glGetQueryObjectui64vEXT.add( Input( 'pname','GLenum' ))
glGetQueryObjectui64vEXT.add( Output( 'params','GLuint64EXT *' ))
glGetQueryObjectui64vEXT.version = '1.5'
glGetQueryObjectui64vEXT.category = 'GL_EXT_timer_query'
glGetQueryObjectui64vEXT.trace = True
glGetQueryObjectui64vEXT.play = False
gl.add(glGetQueryObjectui64vEXT)

# GL_EXT_transform_feedback

glBeginTransformFeedbackEXT = Function('glBeginTransformFeedbackEXT')
glBeginTransformFeedbackEXT.ret = Return('void')
glBeginTransformFeedbackEXT.add( Input( 'primitiveMode','GLenum' ))
glBeginTransformFeedbackEXT.version = '2.0'
glBeginTransformFeedbackEXT.category = 'GL_EXT_transform_feedback'
glBeginTransformFeedbackEXT.trace = True
glBeginTransformFeedbackEXT.play = True
gl.add(glBeginTransformFeedbackEXT)

glBindBufferBaseEXT = Function('glBindBufferBaseEXT')
glBindBufferBaseEXT.ret = Return('void')
glBindBufferBaseEXT.add( Input( 'target','GLenum' ))
glBindBufferBaseEXT.add( Input( 'index','GLuint' ))
glBindBufferBaseEXT.add( Input( 'buffer','GLuint' ))
glBindBufferBaseEXT.version = '2.0'
glBindBufferBaseEXT.category = 'GL_EXT_transform_feedback'
glBindBufferBaseEXT.trace = True
glBindBufferBaseEXT.play = True
gl.add(glBindBufferBaseEXT)

glBindBufferOffsetEXT = Function('glBindBufferOffsetEXT')
glBindBufferOffsetEXT.ret = Return('void')
glBindBufferOffsetEXT.add( Input( 'target','GLenum' ))
glBindBufferOffsetEXT.add( Input( 'index','GLuint' ))
glBindBufferOffsetEXT.add( Input( 'buffer','GLuint' ))
glBindBufferOffsetEXT.add( Input( 'offset','GLintptr' ))
glBindBufferOffsetEXT.version = '2.0'
glBindBufferOffsetEXT.category = 'GL_EXT_transform_feedback'
glBindBufferOffsetEXT.trace = True
glBindBufferOffsetEXT.play = True
gl.add(glBindBufferOffsetEXT)

glBindBufferRangeEXT = Function('glBindBufferRangeEXT')
glBindBufferRangeEXT.ret = Return('void')
glBindBufferRangeEXT.add( Input( 'target','GLenum' ))
glBindBufferRangeEXT.add( Input( 'index','GLuint' ))
glBindBufferRangeEXT.add( Input( 'buffer','GLuint' ))
glBindBufferRangeEXT.add( Input( 'offset','GLintptr' ))
glBindBufferRangeEXT.add( Input( 'size','GLsizeiptr' ))
glBindBufferRangeEXT.version = '2.0'
glBindBufferRangeEXT.category = 'GL_EXT_transform_feedback'
glBindBufferRangeEXT.trace = True
glBindBufferRangeEXT.play = True
gl.add(glBindBufferRangeEXT)

glEndTransformFeedbackEXT = Function('glEndTransformFeedbackEXT')
glEndTransformFeedbackEXT.ret = Return('void')
glEndTransformFeedbackEXT.version = '2.0'
glEndTransformFeedbackEXT.category = 'GL_EXT_transform_feedback'
glEndTransformFeedbackEXT.trace = True
glEndTransformFeedbackEXT.play = True
gl.add(glEndTransformFeedbackEXT)

glGetTransformFeedbackVaryingEXT = Function('glGetTransformFeedbackVaryingEXT')
glGetTransformFeedbackVaryingEXT.ret = Return('void')
glGetTransformFeedbackVaryingEXT.add( Input( 'program','GLuint' ))
glGetTransformFeedbackVaryingEXT.add( Input( 'index','GLuint' ))
glGetTransformFeedbackVaryingEXT.add( Input( 'bufSize','GLsizei' ))
glGetTransformFeedbackVaryingEXT.add( Output( 'length','GLsizei *' ,size = 1 ))
glGetTransformFeedbackVaryingEXT.add( Output( 'size','GLsizei *' ,size = 1 ))
glGetTransformFeedbackVaryingEXT.add( Output( 'type','GLenum *' ,size = 1 ))
glGetTransformFeedbackVaryingEXT.add( Output( 'name','GLchar *' ,maxSize = 'bufSize' ))
glGetTransformFeedbackVaryingEXT.version = '2.0'
glGetTransformFeedbackVaryingEXT.category = 'GL_EXT_transform_feedback'
glGetTransformFeedbackVaryingEXT.trace = True
glGetTransformFeedbackVaryingEXT.play = False
gl.add(glGetTransformFeedbackVaryingEXT)

glTransformFeedbackVaryingsEXT = Function('glTransformFeedbackVaryingsEXT')
glTransformFeedbackVaryingsEXT.ret = Return('void')
glTransformFeedbackVaryingsEXT.add( Input( 'program','GLuint' ))
glTransformFeedbackVaryingsEXT.add( Input( 'count','GLsizei' ))
glTransformFeedbackVaryingsEXT.add( Input( 'varyings','const GLchar * const *' ,size = 'count' ))
glTransformFeedbackVaryingsEXT.add( Input( 'bufferMode','GLenum' ))
glTransformFeedbackVaryingsEXT.version = '2.0'
glTransformFeedbackVaryingsEXT.category = 'GL_EXT_transform_feedback'
glTransformFeedbackVaryingsEXT.trace = True
glTransformFeedbackVaryingsEXT.play = True
gl.add(glTransformFeedbackVaryingsEXT)

# GL_EXT_vertex_array

glArrayElementEXT = Function('glArrayElementEXT')
glArrayElementEXT.ret = Return('void')
glArrayElementEXT.add( Input( 'i','GLint' ))
glArrayElementEXT.version = '1.1'
glArrayElementEXT.category = 'GL_EXT_vertex_array'
glArrayElementEXT.trace = True
glArrayElementEXT.play = True
gl.add(glArrayElementEXT)

glColorPointerEXT = Function('glColorPointerEXT')
glColorPointerEXT.ret = Return('void')
glColorPointerEXT.add( Input( 'size','GLint' ))
glColorPointerEXT.add( Input( 'type','GLenum' ))
glColorPointerEXT.add( Input( 'stride','GLsizei' ))
glColorPointerEXT.add( Input( 'count','GLsizei' ))
glColorPointerEXT.add( Input( 'pointer','const GLvoid *' ))
glColorPointerEXT.version = '1.1'
glColorPointerEXT.category = 'GL_EXT_vertex_array'
glColorPointerEXT.trace = True
glColorPointerEXT.play = True
gl.add(glColorPointerEXT)

glDrawArraysEXT = Function('glDrawArraysEXT')
glDrawArraysEXT.ret = Return('void')
glDrawArraysEXT.add( Input( 'mode','GLenum' ))
glDrawArraysEXT.add( Input( 'first','GLint' ,regalLog = 'GLmodeToString(mode)' ))
glDrawArraysEXT.add( Input( 'count','GLsizei' ))
glDrawArraysEXT.version = '1.1'
glDrawArraysEXT.category = 'GL_EXT_vertex_array'
glDrawArraysEXT.trace = True
glDrawArraysEXT.play = True
gl.add(glDrawArraysEXT)

glEdgeFlagPointerEXT = Function('glEdgeFlagPointerEXT')
glEdgeFlagPointerEXT.ret = Return('void')
glEdgeFlagPointerEXT.add( Input( 'stride','GLsizei' ))
glEdgeFlagPointerEXT.add( Input( 'count','GLsizei' ))
glEdgeFlagPointerEXT.add( Input( 'pointer','const GLboolean *' ))
glEdgeFlagPointerEXT.version = '1.1'
glEdgeFlagPointerEXT.category = 'GL_EXT_vertex_array'
glEdgeFlagPointerEXT.trace = True
glEdgeFlagPointerEXT.play = True
gl.add(glEdgeFlagPointerEXT)

glGetPointervEXT = Function('glGetPointervEXT')
glGetPointervEXT.ret = Return('void')
glGetPointervEXT.add( Input( 'pname','GLenum' ))
glGetPointervEXT.add( Output( 'params','GLvoid **' ,size = 1 ))
glGetPointervEXT.version = '1.1'
glGetPointervEXT.category = 'GL_EXT_vertex_array'
glGetPointervEXT.trace = True
glGetPointervEXT.play = False
gl.add(glGetPointervEXT)

glIndexPointerEXT = Function('glIndexPointerEXT')
glIndexPointerEXT.ret = Return('void')
glIndexPointerEXT.add( Input( 'type','GLenum' ))
glIndexPointerEXT.add( Input( 'stride','GLsizei' ))
glIndexPointerEXT.add( Input( 'count','GLsizei' ))
glIndexPointerEXT.add( Input( 'pointer','const GLvoid *' ))
glIndexPointerEXT.version = '1.1'
glIndexPointerEXT.category = 'GL_EXT_vertex_array'
glIndexPointerEXT.trace = True
glIndexPointerEXT.play = True
gl.add(glIndexPointerEXT)

glNormalPointerEXT = Function('glNormalPointerEXT')
glNormalPointerEXT.ret = Return('void')
glNormalPointerEXT.add( Input( 'type','GLenum' ))
glNormalPointerEXT.add( Input( 'stride','GLsizei' ))
glNormalPointerEXT.add( Input( 'count','GLsizei' ))
glNormalPointerEXT.add( Input( 'pointer','const GLvoid *' ))
glNormalPointerEXT.version = '1.1'
glNormalPointerEXT.category = 'GL_EXT_vertex_array'
glNormalPointerEXT.trace = True
glNormalPointerEXT.play = True
gl.add(glNormalPointerEXT)

glTexCoordPointerEXT = Function('glTexCoordPointerEXT')
glTexCoordPointerEXT.ret = Return('void')
glTexCoordPointerEXT.add( Input( 'size','GLint' ))
glTexCoordPointerEXT.add( Input( 'type','GLenum' ))
glTexCoordPointerEXT.add( Input( 'stride','GLsizei' ))
glTexCoordPointerEXT.add( Input( 'count','GLsizei' ))
glTexCoordPointerEXT.add( Input( 'pointer','const GLvoid *' ))
glTexCoordPointerEXT.version = '1.1'
glTexCoordPointerEXT.category = 'GL_EXT_vertex_array'
glTexCoordPointerEXT.trace = True
glTexCoordPointerEXT.play = True
gl.add(glTexCoordPointerEXT)

glVertexPointerEXT = Function('glVertexPointerEXT')
glVertexPointerEXT.ret = Return('void')
glVertexPointerEXT.add( Input( 'size','GLint' ))
glVertexPointerEXT.add( Input( 'type','GLenum' ))
glVertexPointerEXT.add( Input( 'stride','GLsizei' ))
glVertexPointerEXT.add( Input( 'count','GLsizei' ))
glVertexPointerEXT.add( Input( 'pointer','const GLvoid *' ))
glVertexPointerEXT.version = '1.1'
glVertexPointerEXT.category = 'GL_EXT_vertex_array'
glVertexPointerEXT.trace = True
glVertexPointerEXT.play = False
gl.add(glVertexPointerEXT)

# GL_EXT_vertex_attrib_64bit

glGetVertexAttribLdvEXT = Function('glGetVertexAttribLdvEXT')
glGetVertexAttribLdvEXT.ret = Return('void')
glGetVertexAttribLdvEXT.add( Input( 'index','GLuint' ))
glGetVertexAttribLdvEXT.add( Input( 'pname','GLenum' ))
glGetVertexAttribLdvEXT.add( Output( 'params','GLdouble *' ,size = 1 ))
glGetVertexAttribLdvEXT.version = ''
glGetVertexAttribLdvEXT.category = 'GL_EXT_vertex_attrib_64bit'
glGetVertexAttribLdvEXT.trace = True
glGetVertexAttribLdvEXT.play = True
gl.add(glGetVertexAttribLdvEXT)

glVertexArrayVertexAttribLOffsetEXT = Function('glVertexArrayVertexAttribLOffsetEXT')
glVertexArrayVertexAttribLOffsetEXT.ret = Return('void')
glVertexArrayVertexAttribLOffsetEXT.add( Input( 'vaobj','GLuint' ))
glVertexArrayVertexAttribLOffsetEXT.add( Input( 'buffer','GLuint' ))
glVertexArrayVertexAttribLOffsetEXT.add( Input( 'index','GLuint' ))
glVertexArrayVertexAttribLOffsetEXT.add( Input( 'size','GLint' ))
glVertexArrayVertexAttribLOffsetEXT.add( Input( 'type','GLenum' ))
glVertexArrayVertexAttribLOffsetEXT.add( Input( 'stride','GLsizei' ))
glVertexArrayVertexAttribLOffsetEXT.add( Input( 'offset','GLintptr' ))
glVertexArrayVertexAttribLOffsetEXT.version = '3.0'
glVertexArrayVertexAttribLOffsetEXT.category = 'GL_EXT_vertex_attrib_64bit'
glVertexArrayVertexAttribLOffsetEXT.trace = True
glVertexArrayVertexAttribLOffsetEXT.play = True
gl.add(glVertexArrayVertexAttribLOffsetEXT)

glVertexAttribL1dEXT = Function('glVertexAttribL1dEXT')
glVertexAttribL1dEXT.ret = Return('void')
glVertexAttribL1dEXT.add( Input( 'index','GLuint' ))
glVertexAttribL1dEXT.add( Input( 'x','GLdouble' ))
glVertexAttribL1dEXT.version = ''
glVertexAttribL1dEXT.category = 'GL_EXT_vertex_attrib_64bit'
glVertexAttribL1dEXT.trace = True
glVertexAttribL1dEXT.play = True
gl.add(glVertexAttribL1dEXT)

glVertexAttribL1dvEXT = Function('glVertexAttribL1dvEXT')
glVertexAttribL1dvEXT.ret = Return('void')
glVertexAttribL1dvEXT.add( Input( 'index','GLuint' ))
glVertexAttribL1dvEXT.add( Input( 'v','const GLdouble *' ,size = 1 ))
glVertexAttribL1dvEXT.version = ''
glVertexAttribL1dvEXT.category = 'GL_EXT_vertex_attrib_64bit'
glVertexAttribL1dvEXT.trace = True
glVertexAttribL1dvEXT.play = True
gl.add(glVertexAttribL1dvEXT)

glVertexAttribL2dEXT = Function('glVertexAttribL2dEXT')
glVertexAttribL2dEXT.ret = Return('void')
glVertexAttribL2dEXT.add( Input( 'index','GLuint' ))
glVertexAttribL2dEXT.add( Input( 'x','GLdouble' ))
glVertexAttribL2dEXT.add( Input( 'y','GLdouble' ))
glVertexAttribL2dEXT.version = ''
glVertexAttribL2dEXT.category = 'GL_EXT_vertex_attrib_64bit'
glVertexAttribL2dEXT.trace = True
glVertexAttribL2dEXT.play = True
gl.add(glVertexAttribL2dEXT)

glVertexAttribL2dvEXT = Function('glVertexAttribL2dvEXT')
glVertexAttribL2dvEXT.ret = Return('void')
glVertexAttribL2dvEXT.add( Input( 'index','GLuint' ))
glVertexAttribL2dvEXT.add( Input( 'v','const GLdouble *' ,size = 2 ))
glVertexAttribL2dvEXT.version = ''
glVertexAttribL2dvEXT.category = 'GL_EXT_vertex_attrib_64bit'
glVertexAttribL2dvEXT.trace = True
glVertexAttribL2dvEXT.play = True
gl.add(glVertexAttribL2dvEXT)

glVertexAttribL3dEXT = Function('glVertexAttribL3dEXT')
glVertexAttribL3dEXT.ret = Return('void')
glVertexAttribL3dEXT.add( Input( 'index','GLuint' ))
glVertexAttribL3dEXT.add( Input( 'x','GLdouble' ))
glVertexAttribL3dEXT.add( Input( 'y','GLdouble' ))
glVertexAttribL3dEXT.add( Input( 'z','GLdouble' ))
glVertexAttribL3dEXT.version = ''
glVertexAttribL3dEXT.category = 'GL_EXT_vertex_attrib_64bit'
glVertexAttribL3dEXT.trace = True
glVertexAttribL3dEXT.play = True
gl.add(glVertexAttribL3dEXT)

glVertexAttribL3dvEXT = Function('glVertexAttribL3dvEXT')
glVertexAttribL3dvEXT.ret = Return('void')
glVertexAttribL3dvEXT.add( Input( 'index','GLuint' ))
glVertexAttribL3dvEXT.add( Input( 'v','const GLdouble *' ,size = 3 ))
glVertexAttribL3dvEXT.version = ''
glVertexAttribL3dvEXT.category = 'GL_EXT_vertex_attrib_64bit'
glVertexAttribL3dvEXT.trace = True
glVertexAttribL3dvEXT.play = True
gl.add(glVertexAttribL3dvEXT)

glVertexAttribL4dEXT = Function('glVertexAttribL4dEXT')
glVertexAttribL4dEXT.ret = Return('void')
glVertexAttribL4dEXT.add( Input( 'index','GLuint' ))
glVertexAttribL4dEXT.add( Input( 'x','GLdouble' ))
glVertexAttribL4dEXT.add( Input( 'y','GLdouble' ))
glVertexAttribL4dEXT.add( Input( 'z','GLdouble' ))
glVertexAttribL4dEXT.add( Input( 'w','GLdouble' ))
glVertexAttribL4dEXT.version = ''
glVertexAttribL4dEXT.category = 'GL_EXT_vertex_attrib_64bit'
glVertexAttribL4dEXT.trace = True
glVertexAttribL4dEXT.play = True
gl.add(glVertexAttribL4dEXT)

glVertexAttribL4dvEXT = Function('glVertexAttribL4dvEXT')
glVertexAttribL4dvEXT.ret = Return('void')
glVertexAttribL4dvEXT.add( Input( 'index','GLuint' ))
glVertexAttribL4dvEXT.add( Input( 'v','const GLdouble *' ,size = 4 ))
glVertexAttribL4dvEXT.version = ''
glVertexAttribL4dvEXT.category = 'GL_EXT_vertex_attrib_64bit'
glVertexAttribL4dvEXT.trace = True
glVertexAttribL4dvEXT.play = True
gl.add(glVertexAttribL4dvEXT)

glVertexAttribLPointerEXT = Function('glVertexAttribLPointerEXT')
glVertexAttribLPointerEXT.ret = Return('void')
glVertexAttribLPointerEXT.add( Input( 'index','GLuint' ))
glVertexAttribLPointerEXT.add( Input( 'size','GLint' ))
glVertexAttribLPointerEXT.add( Input( 'type','GLenum' ))
glVertexAttribLPointerEXT.add( Input( 'stride','GLsizei' ))
glVertexAttribLPointerEXT.add( Input( 'pointer','const GLvoid *' ))
glVertexAttribLPointerEXT.version = ''
glVertexAttribLPointerEXT.category = 'GL_EXT_vertex_attrib_64bit'
glVertexAttribLPointerEXT.trace = True
glVertexAttribLPointerEXT.play = True
gl.add(glVertexAttribLPointerEXT)

# GL_EXT_vertex_shader

glBeginVertexShaderEXT = Function('glBeginVertexShaderEXT')
glBeginVertexShaderEXT.ret = Return('void')
glBeginVertexShaderEXT.version = '1.2'
glBeginVertexShaderEXT.category = 'GL_EXT_vertex_shader'
glBeginVertexShaderEXT.trace = True
glBeginVertexShaderEXT.play = True
gl.add(glBeginVertexShaderEXT)

glBindLightParameterEXT = Function('glBindLightParameterEXT')
glBindLightParameterEXT.ret = Return('GLuint')
glBindLightParameterEXT.add( Input( 'light','GLenum' ))
glBindLightParameterEXT.add( Input( 'value','GLenum' ))
glBindLightParameterEXT.version = '1.2'
glBindLightParameterEXT.category = 'GL_EXT_vertex_shader'
glBindLightParameterEXT.trace = True
glBindLightParameterEXT.play = True
gl.add(glBindLightParameterEXT)

glBindMaterialParameterEXT = Function('glBindMaterialParameterEXT')
glBindMaterialParameterEXT.ret = Return('GLuint')
glBindMaterialParameterEXT.add( Input( 'face','GLenum' ))
glBindMaterialParameterEXT.add( Input( 'value','GLenum' ))
glBindMaterialParameterEXT.version = '1.2'
glBindMaterialParameterEXT.category = 'GL_EXT_vertex_shader'
glBindMaterialParameterEXT.trace = True
glBindMaterialParameterEXT.play = True
gl.add(glBindMaterialParameterEXT)

glBindParameterEXT = Function('glBindParameterEXT')
glBindParameterEXT.ret = Return('GLuint')
glBindParameterEXT.add( Input( 'value','GLenum' ))
glBindParameterEXT.version = '1.2'
glBindParameterEXT.category = 'GL_EXT_vertex_shader'
glBindParameterEXT.trace = True
glBindParameterEXT.play = True
gl.add(glBindParameterEXT)

glBindTexGenParameterEXT = Function('glBindTexGenParameterEXT')
glBindTexGenParameterEXT.ret = Return('GLuint')
glBindTexGenParameterEXT.add( Input( 'unit','GLenum' ))
glBindTexGenParameterEXT.add( Input( 'coord','GLenum' ))
glBindTexGenParameterEXT.add( Input( 'value','GLenum' ))
glBindTexGenParameterEXT.version = '1.2'
glBindTexGenParameterEXT.category = 'GL_EXT_vertex_shader'
glBindTexGenParameterEXT.trace = True
glBindTexGenParameterEXT.play = True
gl.add(glBindTexGenParameterEXT)

glBindTextureUnitParameterEXT = Function('glBindTextureUnitParameterEXT')
glBindTextureUnitParameterEXT.ret = Return('GLuint')
glBindTextureUnitParameterEXT.add( Input( 'unit','GLenum' ))
glBindTextureUnitParameterEXT.add( Input( 'value','GLenum' ))
glBindTextureUnitParameterEXT.version = '1.2'
glBindTextureUnitParameterEXT.category = 'GL_EXT_vertex_shader'
glBindTextureUnitParameterEXT.trace = True
glBindTextureUnitParameterEXT.play = True
gl.add(glBindTextureUnitParameterEXT)

glBindVertexShaderEXT = Function('glBindVertexShaderEXT')
glBindVertexShaderEXT.ret = Return('void')
glBindVertexShaderEXT.add( Input( 'id','GLuint' ))
glBindVertexShaderEXT.version = '1.2'
glBindVertexShaderEXT.category = 'GL_EXT_vertex_shader'
glBindVertexShaderEXT.trace = True
glBindVertexShaderEXT.play = True
gl.add(glBindVertexShaderEXT)

glDeleteVertexShaderEXT = Function('glDeleteVertexShaderEXT')
glDeleteVertexShaderEXT.ret = Return('void')
glDeleteVertexShaderEXT.add( Input( 'id','GLuint' ))
glDeleteVertexShaderEXT.version = '1.2'
glDeleteVertexShaderEXT.category = 'GL_EXT_vertex_shader'
glDeleteVertexShaderEXT.trace = True
glDeleteVertexShaderEXT.play = True
gl.add(glDeleteVertexShaderEXT)

glDisableVariantClientStateEXT = Function('glDisableVariantClientStateEXT')
glDisableVariantClientStateEXT.ret = Return('void')
glDisableVariantClientStateEXT.add( Input( 'id','GLuint' ))
glDisableVariantClientStateEXT.version = '1.2'
glDisableVariantClientStateEXT.category = 'GL_EXT_vertex_shader'
glDisableVariantClientStateEXT.trace = True
glDisableVariantClientStateEXT.play = True
gl.add(glDisableVariantClientStateEXT)

glEnableVariantClientStateEXT = Function('glEnableVariantClientStateEXT')
glEnableVariantClientStateEXT.ret = Return('void')
glEnableVariantClientStateEXT.add( Input( 'id','GLuint' ))
glEnableVariantClientStateEXT.version = '1.2'
glEnableVariantClientStateEXT.category = 'GL_EXT_vertex_shader'
glEnableVariantClientStateEXT.trace = True
glEnableVariantClientStateEXT.play = True
gl.add(glEnableVariantClientStateEXT)

glEndVertexShaderEXT = Function('glEndVertexShaderEXT')
glEndVertexShaderEXT.ret = Return('void')
glEndVertexShaderEXT.version = '1.2'
glEndVertexShaderEXT.category = 'GL_EXT_vertex_shader'
glEndVertexShaderEXT.trace = True
glEndVertexShaderEXT.play = True
gl.add(glEndVertexShaderEXT)

glExtractComponentEXT = Function('glExtractComponentEXT')
glExtractComponentEXT.ret = Return('void')
glExtractComponentEXT.add( Input( 'res','GLuint' ))
glExtractComponentEXT.add( Input( 'src','GLuint' ))
glExtractComponentEXT.add( Input( 'num','GLuint' ))
glExtractComponentEXT.version = '1.2'
glExtractComponentEXT.category = 'GL_EXT_vertex_shader'
glExtractComponentEXT.trace = True
glExtractComponentEXT.play = True
gl.add(glExtractComponentEXT)

glGenSymbolsEXT = Function('glGenSymbolsEXT')
glGenSymbolsEXT.ret = Return('GLuint')
glGenSymbolsEXT.add( Input( 'datatype','GLenum' ))
glGenSymbolsEXT.add( Input( 'storagetype','GLenum' ))
glGenSymbolsEXT.add( Input( 'range','GLenum' ))
glGenSymbolsEXT.add( Input( 'components','GLuint' ))
glGenSymbolsEXT.version = '1.2'
glGenSymbolsEXT.category = 'GL_EXT_vertex_shader'
glGenSymbolsEXT.trace = True
glGenSymbolsEXT.play = True
gl.add(glGenSymbolsEXT)

glGenVertexShadersEXT = Function('glGenVertexShadersEXT')
glGenVertexShadersEXT.ret = Return('GLuint')
glGenVertexShadersEXT.add( Input( 'range','GLuint' ))
glGenVertexShadersEXT.version = '1.2'
glGenVertexShadersEXT.category = 'GL_EXT_vertex_shader'
glGenVertexShadersEXT.trace = True
glGenVertexShadersEXT.play = True
gl.add(glGenVertexShadersEXT)

glGetInvariantBooleanvEXT = Function('glGetInvariantBooleanvEXT')
glGetInvariantBooleanvEXT.ret = Return('void')
glGetInvariantBooleanvEXT.add( Input( 'id','GLuint' ))
glGetInvariantBooleanvEXT.add( Input( 'value','GLenum' ))
glGetInvariantBooleanvEXT.add( Output( 'data','GLboolean *' ))
glGetInvariantBooleanvEXT.version = '1.2'
glGetInvariantBooleanvEXT.category = 'GL_EXT_vertex_shader'
glGetInvariantBooleanvEXT.trace = True
glGetInvariantBooleanvEXT.play = False
gl.add(glGetInvariantBooleanvEXT)

glGetInvariantFloatvEXT = Function('glGetInvariantFloatvEXT')
glGetInvariantFloatvEXT.ret = Return('void')
glGetInvariantFloatvEXT.add( Input( 'id','GLuint' ))
glGetInvariantFloatvEXT.add( Input( 'value','GLenum' ))
glGetInvariantFloatvEXT.add( Output( 'data','GLfloat *' ))
glGetInvariantFloatvEXT.version = '1.2'
glGetInvariantFloatvEXT.category = 'GL_EXT_vertex_shader'
glGetInvariantFloatvEXT.trace = True
glGetInvariantFloatvEXT.play = False
gl.add(glGetInvariantFloatvEXT)

glGetInvariantIntegervEXT = Function('glGetInvariantIntegervEXT')
glGetInvariantIntegervEXT.ret = Return('void')
glGetInvariantIntegervEXT.add( Input( 'id','GLuint' ))
glGetInvariantIntegervEXT.add( Input( 'value','GLenum' ))
glGetInvariantIntegervEXT.add( Output( 'data','GLint *' ))
glGetInvariantIntegervEXT.version = '1.2'
glGetInvariantIntegervEXT.category = 'GL_EXT_vertex_shader'
glGetInvariantIntegervEXT.trace = True
glGetInvariantIntegervEXT.play = False
gl.add(glGetInvariantIntegervEXT)

glGetLocalConstantBooleanvEXT = Function('glGetLocalConstantBooleanvEXT')
glGetLocalConstantBooleanvEXT.ret = Return('void')
glGetLocalConstantBooleanvEXT.add( Input( 'id','GLuint' ))
glGetLocalConstantBooleanvEXT.add( Input( 'value','GLenum' ))
glGetLocalConstantBooleanvEXT.add( Output( 'data','GLboolean *' ))
glGetLocalConstantBooleanvEXT.version = '1.2'
glGetLocalConstantBooleanvEXT.category = 'GL_EXT_vertex_shader'
glGetLocalConstantBooleanvEXT.trace = True
glGetLocalConstantBooleanvEXT.play = False
gl.add(glGetLocalConstantBooleanvEXT)

glGetLocalConstantFloatvEXT = Function('glGetLocalConstantFloatvEXT')
glGetLocalConstantFloatvEXT.ret = Return('void')
glGetLocalConstantFloatvEXT.add( Input( 'id','GLuint' ))
glGetLocalConstantFloatvEXT.add( Input( 'value','GLenum' ))
glGetLocalConstantFloatvEXT.add( Output( 'data','GLfloat *' ))
glGetLocalConstantFloatvEXT.version = '1.2'
glGetLocalConstantFloatvEXT.category = 'GL_EXT_vertex_shader'
glGetLocalConstantFloatvEXT.trace = True
glGetLocalConstantFloatvEXT.play = False
gl.add(glGetLocalConstantFloatvEXT)

glGetLocalConstantIntegervEXT = Function('glGetLocalConstantIntegervEXT')
glGetLocalConstantIntegervEXT.ret = Return('void')
glGetLocalConstantIntegervEXT.add( Input( 'id','GLuint' ))
glGetLocalConstantIntegervEXT.add( Input( 'value','GLenum' ))
glGetLocalConstantIntegervEXT.add( Output( 'data','GLint *' ))
glGetLocalConstantIntegervEXT.version = '1.2'
glGetLocalConstantIntegervEXT.category = 'GL_EXT_vertex_shader'
glGetLocalConstantIntegervEXT.trace = True
glGetLocalConstantIntegervEXT.play = False
gl.add(glGetLocalConstantIntegervEXT)

glGetVariantBooleanvEXT = Function('glGetVariantBooleanvEXT')
glGetVariantBooleanvEXT.ret = Return('void')
glGetVariantBooleanvEXT.add( Input( 'id','GLuint' ))
glGetVariantBooleanvEXT.add( Input( 'value','GLenum' ))
glGetVariantBooleanvEXT.add( Output( 'data','GLboolean *' ))
glGetVariantBooleanvEXT.version = '1.2'
glGetVariantBooleanvEXT.category = 'GL_EXT_vertex_shader'
glGetVariantBooleanvEXT.trace = True
glGetVariantBooleanvEXT.play = False
gl.add(glGetVariantBooleanvEXT)

glGetVariantFloatvEXT = Function('glGetVariantFloatvEXT')
glGetVariantFloatvEXT.ret = Return('void')
glGetVariantFloatvEXT.add( Input( 'id','GLuint' ))
glGetVariantFloatvEXT.add( Input( 'value','GLenum' ))
glGetVariantFloatvEXT.add( Output( 'data','GLfloat *' ))
glGetVariantFloatvEXT.version = '1.2'
glGetVariantFloatvEXT.category = 'GL_EXT_vertex_shader'
glGetVariantFloatvEXT.trace = True
glGetVariantFloatvEXT.play = False
gl.add(glGetVariantFloatvEXT)

glGetVariantIntegervEXT = Function('glGetVariantIntegervEXT')
glGetVariantIntegervEXT.ret = Return('void')
glGetVariantIntegervEXT.add( Input( 'id','GLuint' ))
glGetVariantIntegervEXT.add( Input( 'value','GLenum' ))
glGetVariantIntegervEXT.add( Output( 'data','GLint *' ))
glGetVariantIntegervEXT.version = '1.2'
glGetVariantIntegervEXT.category = 'GL_EXT_vertex_shader'
glGetVariantIntegervEXT.trace = True
glGetVariantIntegervEXT.play = False
gl.add(glGetVariantIntegervEXT)

glGetVariantPointervEXT = Function('glGetVariantPointervEXT')
glGetVariantPointervEXT.ret = Return('void')
glGetVariantPointervEXT.add( Input( 'id','GLuint' ))
glGetVariantPointervEXT.add( Input( 'value','GLenum' ))
glGetVariantPointervEXT.add( Output( 'data','GLvoid **' ))
glGetVariantPointervEXT.version = '1.2'
glGetVariantPointervEXT.category = 'GL_EXT_vertex_shader'
glGetVariantPointervEXT.trace = True
glGetVariantPointervEXT.play = False
gl.add(glGetVariantPointervEXT)

glInsertComponentEXT = Function('glInsertComponentEXT')
glInsertComponentEXT.ret = Return('void')
glInsertComponentEXT.add( Input( 'res','GLuint' ))
glInsertComponentEXT.add( Input( 'src','GLuint' ))
glInsertComponentEXT.add( Input( 'num','GLuint' ))
glInsertComponentEXT.version = '1.2'
glInsertComponentEXT.category = 'GL_EXT_vertex_shader'
glInsertComponentEXT.trace = True
glInsertComponentEXT.play = True
gl.add(glInsertComponentEXT)

glIsVariantEnabledEXT = Function('glIsVariantEnabledEXT')
glIsVariantEnabledEXT.ret = Return('GLboolean')
glIsVariantEnabledEXT.add( Input( 'id','GLuint' ))
glIsVariantEnabledEXT.add( Input( 'cap','GLenum' ))
glIsVariantEnabledEXT.version = '1.2'
glIsVariantEnabledEXT.category = 'GL_EXT_vertex_shader'
glIsVariantEnabledEXT.trace = True
glIsVariantEnabledEXT.play = True
gl.add(glIsVariantEnabledEXT)

glSetInvariantEXT = Function('glSetInvariantEXT')
glSetInvariantEXT.ret = Return('void')
glSetInvariantEXT.add( Input( 'id','GLuint' ))
glSetInvariantEXT.add( Input( 'type','GLenum' ))
glSetInvariantEXT.add( Input( 'addr','const GLvoid *' ))
glSetInvariantEXT.version = '1.2'
glSetInvariantEXT.category = 'GL_EXT_vertex_shader'
glSetInvariantEXT.trace = True
glSetInvariantEXT.play = True
gl.add(glSetInvariantEXT)

glSetLocalConstantEXT = Function('glSetLocalConstantEXT')
glSetLocalConstantEXT.ret = Return('void')
glSetLocalConstantEXT.add( Input( 'id','GLuint' ))
glSetLocalConstantEXT.add( Input( 'type','GLenum' ))
glSetLocalConstantEXT.add( Input( 'addr','const GLvoid *' ))
glSetLocalConstantEXT.version = '1.2'
glSetLocalConstantEXT.category = 'GL_EXT_vertex_shader'
glSetLocalConstantEXT.trace = True
glSetLocalConstantEXT.play = True
gl.add(glSetLocalConstantEXT)

glShaderOp1EXT = Function('glShaderOp1EXT')
glShaderOp1EXT.ret = Return('void')
glShaderOp1EXT.add( Input( 'op','GLenum' ))
glShaderOp1EXT.add( Input( 'res','GLuint' ))
glShaderOp1EXT.add( Input( 'arg1','GLuint' ))
glShaderOp1EXT.version = '1.2'
glShaderOp1EXT.category = 'GL_EXT_vertex_shader'
glShaderOp1EXT.trace = True
glShaderOp1EXT.play = True
gl.add(glShaderOp1EXT)

glShaderOp2EXT = Function('glShaderOp2EXT')
glShaderOp2EXT.ret = Return('void')
glShaderOp2EXT.add( Input( 'op','GLenum' ))
glShaderOp2EXT.add( Input( 'res','GLuint' ))
glShaderOp2EXT.add( Input( 'arg1','GLuint' ))
glShaderOp2EXT.add( Input( 'arg2','GLuint' ))
glShaderOp2EXT.version = '1.2'
glShaderOp2EXT.category = 'GL_EXT_vertex_shader'
glShaderOp2EXT.trace = True
glShaderOp2EXT.play = True
gl.add(glShaderOp2EXT)

glShaderOp3EXT = Function('glShaderOp3EXT')
glShaderOp3EXT.ret = Return('void')
glShaderOp3EXT.add( Input( 'op','GLenum' ))
glShaderOp3EXT.add( Input( 'res','GLuint' ))
glShaderOp3EXT.add( Input( 'arg1','GLuint' ))
glShaderOp3EXT.add( Input( 'arg2','GLuint' ))
glShaderOp3EXT.add( Input( 'arg3','GLuint' ))
glShaderOp3EXT.version = '1.2'
glShaderOp3EXT.category = 'GL_EXT_vertex_shader'
glShaderOp3EXT.trace = True
glShaderOp3EXT.play = True
gl.add(glShaderOp3EXT)

glSwizzleEXT = Function('glSwizzleEXT')
glSwizzleEXT.ret = Return('void')
glSwizzleEXT.add( Input( 'res','GLuint' ))
glSwizzleEXT.add( Input( 'in','GLuint' ))
glSwizzleEXT.add( Input( 'outX','GLenum' ))
glSwizzleEXT.add( Input( 'outY','GLenum' ))
glSwizzleEXT.add( Input( 'outZ','GLenum' ))
glSwizzleEXT.add( Input( 'outW','GLenum' ))
glSwizzleEXT.version = '1.2'
glSwizzleEXT.category = 'GL_EXT_vertex_shader'
glSwizzleEXT.trace = True
glSwizzleEXT.play = True
gl.add(glSwizzleEXT)

glVariantPointerEXT = Function('glVariantPointerEXT')
glVariantPointerEXT.ret = Return('void')
glVariantPointerEXT.add( Input( 'id','GLuint' ))
glVariantPointerEXT.add( Input( 'type','GLenum' ))
glVariantPointerEXT.add( Input( 'stride','GLuint' ))
glVariantPointerEXT.add( Input( 'addr','const GLvoid *' ))
glVariantPointerEXT.version = '1.2'
glVariantPointerEXT.category = 'GL_EXT_vertex_shader'
glVariantPointerEXT.trace = True
glVariantPointerEXT.play = True
gl.add(glVariantPointerEXT)

glVariantbvEXT = Function('glVariantbvEXT')
glVariantbvEXT.ret = Return('void')
glVariantbvEXT.add( Input( 'id','GLuint' ))
glVariantbvEXT.add( Input( 'addr','const GLbyte *' ))
glVariantbvEXT.version = '1.2'
glVariantbvEXT.category = 'GL_EXT_vertex_shader'
glVariantbvEXT.trace = True
glVariantbvEXT.play = True
gl.add(glVariantbvEXT)

glVariantdvEXT = Function('glVariantdvEXT')
glVariantdvEXT.ret = Return('void')
glVariantdvEXT.add( Input( 'id','GLuint' ))
glVariantdvEXT.add( Input( 'addr','const GLdouble *' ))
glVariantdvEXT.version = '1.2'
glVariantdvEXT.category = 'GL_EXT_vertex_shader'
glVariantdvEXT.trace = True
glVariantdvEXT.play = True
gl.add(glVariantdvEXT)

glVariantfvEXT = Function('glVariantfvEXT')
glVariantfvEXT.ret = Return('void')
glVariantfvEXT.add( Input( 'id','GLuint' ))
glVariantfvEXT.add( Input( 'addr','const GLfloat *' ))
glVariantfvEXT.version = '1.2'
glVariantfvEXT.category = 'GL_EXT_vertex_shader'
glVariantfvEXT.trace = True
glVariantfvEXT.play = True
gl.add(glVariantfvEXT)

glVariantivEXT = Function('glVariantivEXT')
glVariantivEXT.ret = Return('void')
glVariantivEXT.add( Input( 'id','GLuint' ))
glVariantivEXT.add( Input( 'addr','const GLint *' ))
glVariantivEXT.version = '1.2'
glVariantivEXT.category = 'GL_EXT_vertex_shader'
glVariantivEXT.trace = True
glVariantivEXT.play = True
gl.add(glVariantivEXT)

glVariantsvEXT = Function('glVariantsvEXT')
glVariantsvEXT.ret = Return('void')
glVariantsvEXT.add( Input( 'id','GLuint' ))
glVariantsvEXT.add( Input( 'addr','const GLshort *' ))
glVariantsvEXT.version = '1.2'
glVariantsvEXT.category = 'GL_EXT_vertex_shader'
glVariantsvEXT.trace = True
glVariantsvEXT.play = True
gl.add(glVariantsvEXT)

glVariantubvEXT = Function('glVariantubvEXT')
glVariantubvEXT.ret = Return('void')
glVariantubvEXT.add( Input( 'id','GLuint' ))
glVariantubvEXT.add( Input( 'addr','const GLubyte *' ))
glVariantubvEXT.version = '1.2'
glVariantubvEXT.category = 'GL_EXT_vertex_shader'
glVariantubvEXT.trace = True
glVariantubvEXT.play = True
gl.add(glVariantubvEXT)

glVariantuivEXT = Function('glVariantuivEXT')
glVariantuivEXT.ret = Return('void')
glVariantuivEXT.add( Input( 'id','GLuint' ))
glVariantuivEXT.add( Input( 'addr','const GLuint *' ))
glVariantuivEXT.version = '1.2'
glVariantuivEXT.category = 'GL_EXT_vertex_shader'
glVariantuivEXT.trace = True
glVariantuivEXT.play = True
gl.add(glVariantuivEXT)

glVariantusvEXT = Function('glVariantusvEXT')
glVariantusvEXT.ret = Return('void')
glVariantusvEXT.add( Input( 'id','GLuint' ))
glVariantusvEXT.add( Input( 'addr','const GLushort *' ))
glVariantusvEXT.version = '1.2'
glVariantusvEXT.category = 'GL_EXT_vertex_shader'
glVariantusvEXT.trace = True
glVariantusvEXT.play = True
gl.add(glVariantusvEXT)

glWriteMaskEXT = Function('glWriteMaskEXT')
glWriteMaskEXT.ret = Return('void')
glWriteMaskEXT.add( Input( 'res','GLuint' ))
glWriteMaskEXT.add( Input( 'in','GLuint' ))
glWriteMaskEXT.add( Input( 'outX','GLenum' ))
glWriteMaskEXT.add( Input( 'outY','GLenum' ))
glWriteMaskEXT.add( Input( 'outZ','GLenum' ))
glWriteMaskEXT.add( Input( 'outW','GLenum' ))
glWriteMaskEXT.version = '1.2'
glWriteMaskEXT.category = 'GL_EXT_vertex_shader'
glWriteMaskEXT.trace = True
glWriteMaskEXT.play = True
gl.add(glWriteMaskEXT)

# GL_EXT_vertex_weighting

glVertexWeightPointerEXT = Function('glVertexWeightPointerEXT')
glVertexWeightPointerEXT.ret = Return('void')
glVertexWeightPointerEXT.add( Input( 'size','GLsizei' ))
glVertexWeightPointerEXT.add( Input( 'type','GLenum' ))
glVertexWeightPointerEXT.add( Input( 'stride','GLsizei' ))
glVertexWeightPointerEXT.add( Input( 'pointer','const GLvoid *' ))
glVertexWeightPointerEXT.version = '1.1'
glVertexWeightPointerEXT.category = 'GL_EXT_vertex_weighting'
glVertexWeightPointerEXT.trace = True
glVertexWeightPointerEXT.play = True
gl.add(glVertexWeightPointerEXT)

glVertexWeightfEXT = Function('glVertexWeightfEXT')
glVertexWeightfEXT.ret = Return('void')
glVertexWeightfEXT.add( Input( 'weight','GLfloat' ))
glVertexWeightfEXT.version = '1.1'
glVertexWeightfEXT.category = 'GL_EXT_vertex_weighting'
glVertexWeightfEXT.trace = True
glVertexWeightfEXT.play = True
gl.add(glVertexWeightfEXT)

glVertexWeightfvEXT = Function('glVertexWeightfvEXT')
glVertexWeightfvEXT.ret = Return('void')
glVertexWeightfvEXT.add( Input( 'weight','const GLfloat *' ,size = 1 ))
glVertexWeightfvEXT.version = '1.1'
glVertexWeightfvEXT.category = 'GL_EXT_vertex_weighting'
glVertexWeightfvEXT.trace = True
glVertexWeightfvEXT.play = True
gl.add(glVertexWeightfvEXT)

# GL_EXT_x11_sync_object

glImportSyncEXT = Function('glImportSyncEXT')
glImportSyncEXT.ret = Return('GLsync')
glImportSyncEXT.add( Input( 'external_sync_type','GLenum' ))
glImportSyncEXT.add( Input( 'external_sync','GLintptr' ))
glImportSyncEXT.add( Input( 'flags','GLbitfield' ,regalLog = 'GLimportSyncEXTToString(flags)' ))
glImportSyncEXT.version = ''
glImportSyncEXT.category = 'GL_EXT_x11_sync_object'
glImportSyncEXT.trace = True
glImportSyncEXT.play = True
gl.add(glImportSyncEXT)

# GL_GREMEDY_frame_terminator

glFrameTerminatorGREMEDY = Function('glFrameTerminatorGREMEDY')
glFrameTerminatorGREMEDY.ret = Return('void')
glFrameTerminatorGREMEDY.version = '1.0'
glFrameTerminatorGREMEDY.category = 'GL_GREMEDY_frame_terminator'
glFrameTerminatorGREMEDY.trace = True
glFrameTerminatorGREMEDY.play = True
gl.add(glFrameTerminatorGREMEDY)

# GL_GREMEDY_string_marker

glStringMarkerGREMEDY = Function('glStringMarkerGREMEDY')
glStringMarkerGREMEDY.ret = Return('void')
glStringMarkerGREMEDY.add( Input( 'len','GLsizei' ))
glStringMarkerGREMEDY.add( Input( 'string','const GLvoid *' ))
glStringMarkerGREMEDY.version = '1.0'
glStringMarkerGREMEDY.category = 'GL_GREMEDY_string_marker'
glStringMarkerGREMEDY.trace = True
glStringMarkerGREMEDY.play = True
gl.add(glStringMarkerGREMEDY)

# GL_HP_image_transform

glGetImageTransformParameterfvHP = Function('glGetImageTransformParameterfvHP')
glGetImageTransformParameterfvHP.ret = Return('void')
glGetImageTransformParameterfvHP.add( Input( 'target','GLenum' ))
glGetImageTransformParameterfvHP.add( Input( 'pname','GLenum' ))
glGetImageTransformParameterfvHP.add( Output( 'params','GLfloat *' ))
glGetImageTransformParameterfvHP.version = '1.1'
glGetImageTransformParameterfvHP.category = 'GL_HP_image_transform'
glGetImageTransformParameterfvHP.trace = True
glGetImageTransformParameterfvHP.play = True
gl.add(glGetImageTransformParameterfvHP)

glGetImageTransformParameterivHP = Function('glGetImageTransformParameterivHP')
glGetImageTransformParameterivHP.ret = Return('void')
glGetImageTransformParameterivHP.add( Input( 'target','GLenum' ))
glGetImageTransformParameterivHP.add( Input( 'pname','GLenum' ))
glGetImageTransformParameterivHP.add( Output( 'params','GLint *' ))
glGetImageTransformParameterivHP.version = '1.1'
glGetImageTransformParameterivHP.category = 'GL_HP_image_transform'
glGetImageTransformParameterivHP.trace = True
glGetImageTransformParameterivHP.play = True
gl.add(glGetImageTransformParameterivHP)

glImageTransformParameterfHP = Function('glImageTransformParameterfHP')
glImageTransformParameterfHP.ret = Return('void')
glImageTransformParameterfHP.add( Input( 'target','GLenum' ))
glImageTransformParameterfHP.add( Input( 'pname','GLenum' ))
glImageTransformParameterfHP.add( Input( 'param','GLfloat' ))
glImageTransformParameterfHP.version = '1.1'
glImageTransformParameterfHP.category = 'GL_HP_image_transform'
glImageTransformParameterfHP.trace = True
glImageTransformParameterfHP.play = True
gl.add(glImageTransformParameterfHP)

glImageTransformParameterfvHP = Function('glImageTransformParameterfvHP')
glImageTransformParameterfvHP.ret = Return('void')
glImageTransformParameterfvHP.add( Input( 'target','GLenum' ))
glImageTransformParameterfvHP.add( Input( 'pname','GLenum' ))
glImageTransformParameterfvHP.add( Input( 'params','const GLfloat *' ))
glImageTransformParameterfvHP.version = '1.1'
glImageTransformParameterfvHP.category = 'GL_HP_image_transform'
glImageTransformParameterfvHP.trace = True
glImageTransformParameterfvHP.play = True
gl.add(glImageTransformParameterfvHP)

glImageTransformParameteriHP = Function('glImageTransformParameteriHP')
glImageTransformParameteriHP.ret = Return('void')
glImageTransformParameteriHP.add( Input( 'target','GLenum' ))
glImageTransformParameteriHP.add( Input( 'pname','GLenum' ))
glImageTransformParameteriHP.add( Input( 'param','GLint' ))
glImageTransformParameteriHP.version = '1.1'
glImageTransformParameteriHP.category = 'GL_HP_image_transform'
glImageTransformParameteriHP.trace = True
glImageTransformParameteriHP.play = True
gl.add(glImageTransformParameteriHP)

glImageTransformParameterivHP = Function('glImageTransformParameterivHP')
glImageTransformParameterivHP.ret = Return('void')
glImageTransformParameterivHP.add( Input( 'target','GLenum' ))
glImageTransformParameterivHP.add( Input( 'pname','GLenum' ))
glImageTransformParameterivHP.add( Input( 'params','const GLint *' ))
glImageTransformParameterivHP.version = '1.1'
glImageTransformParameterivHP.category = 'GL_HP_image_transform'
glImageTransformParameterivHP.trace = True
glImageTransformParameterivHP.play = True
gl.add(glImageTransformParameterivHP)

# GL_IBM_multimode_draw_arrays

glMultiModeDrawArraysIBM = Function('glMultiModeDrawArraysIBM')
glMultiModeDrawArraysIBM.ret = Return('void')
glMultiModeDrawArraysIBM.add( Input( 'mode','const GLenum *' ))
glMultiModeDrawArraysIBM.add( Input( 'first','const GLint *' ))
glMultiModeDrawArraysIBM.add( Input( 'count','const GLsizei *' ))
glMultiModeDrawArraysIBM.add( Input( 'primcount','GLsizei' ))
glMultiModeDrawArraysIBM.add( Input( 'modestride','GLint' ))
glMultiModeDrawArraysIBM.version = '1.1'
glMultiModeDrawArraysIBM.category = 'GL_IBM_multimode_draw_arrays'
glMultiModeDrawArraysIBM.trace = True
glMultiModeDrawArraysIBM.play = True
gl.add(glMultiModeDrawArraysIBM)

glMultiModeDrawElementsIBM = Function('glMultiModeDrawElementsIBM')
glMultiModeDrawElementsIBM.ret = Return('void')
glMultiModeDrawElementsIBM.add( Input( 'mode','const GLenum *' ))
glMultiModeDrawElementsIBM.add( Input( 'count','const GLsizei *' ))
glMultiModeDrawElementsIBM.add( Input( 'type','GLenum' ))
glMultiModeDrawElementsIBM.add( Input( 'indices','const GLvoid * const *' ))
glMultiModeDrawElementsIBM.add( Input( 'primcount','GLsizei' ))
glMultiModeDrawElementsIBM.add( Input( 'modestride','GLint' ))
glMultiModeDrawElementsIBM.version = '1.1'
glMultiModeDrawElementsIBM.category = 'GL_IBM_multimode_draw_arrays'
glMultiModeDrawElementsIBM.trace = True
glMultiModeDrawElementsIBM.play = True
gl.add(glMultiModeDrawElementsIBM)

# GL_IBM_vertex_array_lists

glColorPointerListIBM = Function('glColorPointerListIBM')
glColorPointerListIBM.ret = Return('void')
glColorPointerListIBM.add( Input( 'size','GLint' ))
glColorPointerListIBM.add( Input( 'type','GLenum' ))
glColorPointerListIBM.add( Input( 'stride','GLint' ))
glColorPointerListIBM.add( Input( 'pointer','const GLvoid **' ))
glColorPointerListIBM.add( Input( 'ptrstride','GLint' ))
glColorPointerListIBM.version = '1.1'
glColorPointerListIBM.category = 'GL_IBM_vertex_array_lists'
glColorPointerListIBM.trace = True
glColorPointerListIBM.play = True
gl.add(glColorPointerListIBM)

glEdgeFlagPointerListIBM = Function('glEdgeFlagPointerListIBM')
glEdgeFlagPointerListIBM.ret = Return('void')
glEdgeFlagPointerListIBM.add( Input( 'stride','GLint' ))
glEdgeFlagPointerListIBM.add( Input( 'pointer','const GLboolean **' ))
glEdgeFlagPointerListIBM.add( Input( 'ptrstride','GLint' ))
glEdgeFlagPointerListIBM.version = '1.1'
glEdgeFlagPointerListIBM.category = 'GL_IBM_vertex_array_lists'
glEdgeFlagPointerListIBM.trace = True
glEdgeFlagPointerListIBM.play = True
gl.add(glEdgeFlagPointerListIBM)

glFogCoordPointerListIBM = Function('glFogCoordPointerListIBM')
glFogCoordPointerListIBM.ret = Return('void')
glFogCoordPointerListIBM.add( Input( 'type','GLenum' ))
glFogCoordPointerListIBM.add( Input( 'stride','GLint' ))
glFogCoordPointerListIBM.add( Input( 'pointer','const GLvoid **' ))
glFogCoordPointerListIBM.add( Input( 'ptrstride','GLint' ))
glFogCoordPointerListIBM.version = '1.1'
glFogCoordPointerListIBM.category = 'GL_IBM_vertex_array_lists'
glFogCoordPointerListIBM.trace = True
glFogCoordPointerListIBM.play = True
gl.add(glFogCoordPointerListIBM)

glIndexPointerListIBM = Function('glIndexPointerListIBM')
glIndexPointerListIBM.ret = Return('void')
glIndexPointerListIBM.add( Input( 'type','GLenum' ))
glIndexPointerListIBM.add( Input( 'stride','GLint' ))
glIndexPointerListIBM.add( Input( 'pointer','const GLvoid **' ))
glIndexPointerListIBM.add( Input( 'ptrstride','GLint' ))
glIndexPointerListIBM.version = '1.1'
glIndexPointerListIBM.category = 'GL_IBM_vertex_array_lists'
glIndexPointerListIBM.trace = True
glIndexPointerListIBM.play = True
gl.add(glIndexPointerListIBM)

glNormalPointerListIBM = Function('glNormalPointerListIBM')
glNormalPointerListIBM.ret = Return('void')
glNormalPointerListIBM.add( Input( 'type','GLenum' ))
glNormalPointerListIBM.add( Input( 'stride','GLint' ))
glNormalPointerListIBM.add( Input( 'pointer','const GLvoid **' ))
glNormalPointerListIBM.add( Input( 'ptrstride','GLint' ))
glNormalPointerListIBM.version = '1.1'
glNormalPointerListIBM.category = 'GL_IBM_vertex_array_lists'
glNormalPointerListIBM.trace = True
glNormalPointerListIBM.play = True
gl.add(glNormalPointerListIBM)

glSecondaryColorPointerListIBM = Function('glSecondaryColorPointerListIBM')
glSecondaryColorPointerListIBM.ret = Return('void')
glSecondaryColorPointerListIBM.add( Input( 'size','GLint' ))
glSecondaryColorPointerListIBM.add( Input( 'type','GLenum' ))
glSecondaryColorPointerListIBM.add( Input( 'stride','GLint' ))
glSecondaryColorPointerListIBM.add( Input( 'pointer','const GLvoid **' ))
glSecondaryColorPointerListIBM.add( Input( 'ptrstride','GLint' ))
glSecondaryColorPointerListIBM.version = '1.1'
glSecondaryColorPointerListIBM.category = 'GL_IBM_vertex_array_lists'
glSecondaryColorPointerListIBM.trace = True
glSecondaryColorPointerListIBM.play = True
gl.add(glSecondaryColorPointerListIBM)

glTexCoordPointerListIBM = Function('glTexCoordPointerListIBM')
glTexCoordPointerListIBM.ret = Return('void')
glTexCoordPointerListIBM.add( Input( 'size','GLint' ))
glTexCoordPointerListIBM.add( Input( 'type','GLenum' ))
glTexCoordPointerListIBM.add( Input( 'stride','GLint' ))
glTexCoordPointerListIBM.add( Input( 'pointer','const GLvoid **' ))
glTexCoordPointerListIBM.add( Input( 'ptrstride','GLint' ))
glTexCoordPointerListIBM.version = '1.1'
glTexCoordPointerListIBM.category = 'GL_IBM_vertex_array_lists'
glTexCoordPointerListIBM.trace = True
glTexCoordPointerListIBM.play = True
gl.add(glTexCoordPointerListIBM)

glVertexPointerListIBM = Function('glVertexPointerListIBM')
glVertexPointerListIBM.ret = Return('void')
glVertexPointerListIBM.add( Input( 'size','GLint' ))
glVertexPointerListIBM.add( Input( 'type','GLenum' ))
glVertexPointerListIBM.add( Input( 'stride','GLint' ))
glVertexPointerListIBM.add( Input( 'pointer','const GLvoid **' ))
glVertexPointerListIBM.add( Input( 'ptrstride','GLint' ))
glVertexPointerListIBM.version = '1.1'
glVertexPointerListIBM.category = 'GL_IBM_vertex_array_lists'
glVertexPointerListIBM.trace = True
glVertexPointerListIBM.play = True
gl.add(glVertexPointerListIBM)

# GL_IMG_multisampled_render_to_texture

glFramebufferTexture2DMultisampleIMG = Function('glFramebufferTexture2DMultisampleIMG')
glFramebufferTexture2DMultisampleIMG.ret = Return('void')
glFramebufferTexture2DMultisampleIMG.add( Input( 'target','GLenum' ))
glFramebufferTexture2DMultisampleIMG.add( Input( 'attachment','GLenum' ))
glFramebufferTexture2DMultisampleIMG.add( Input( 'textarget','GLenum' ))
glFramebufferTexture2DMultisampleIMG.add( Input( 'texture','GLuint' ))
glFramebufferTexture2DMultisampleIMG.add( Input( 'level','GLint' ))
glFramebufferTexture2DMultisampleIMG.add( Input( 'samples','GLsizei' ))
glFramebufferTexture2DMultisampleIMG.version = ''
glFramebufferTexture2DMultisampleIMG.category = 'GL_IMG_multisampled_render_to_texture'
glFramebufferTexture2DMultisampleIMG.trace = True
glFramebufferTexture2DMultisampleIMG.play = True
gl.add(glFramebufferTexture2DMultisampleIMG)

glRenderbufferStorageMultisampleIMG = Function('glRenderbufferStorageMultisampleIMG')
glRenderbufferStorageMultisampleIMG.ret = Return('void')
glRenderbufferStorageMultisampleIMG.add( Input( 'target','GLenum' ))
glRenderbufferStorageMultisampleIMG.add( Input( 'samples','GLsizei' ))
glRenderbufferStorageMultisampleIMG.add( Input( 'internalformat','GLenum' ))
glRenderbufferStorageMultisampleIMG.add( Input( 'width','GLsizei' ))
glRenderbufferStorageMultisampleIMG.add( Input( 'height','GLsizei' ))
glRenderbufferStorageMultisampleIMG.version = ''
glRenderbufferStorageMultisampleIMG.category = 'GL_IMG_multisampled_render_to_texture'
glRenderbufferStorageMultisampleIMG.trace = True
glRenderbufferStorageMultisampleIMG.play = True
gl.add(glRenderbufferStorageMultisampleIMG)

# GL_INGR_blend_func_separate

glBlendFuncSeparateINGR = Function('glBlendFuncSeparateINGR')
glBlendFuncSeparateINGR.ret = Return('void')
glBlendFuncSeparateINGR.add( Input( 'sfactorRGB','GLenum' ))
glBlendFuncSeparateINGR.add( Input( 'dfactorRGB','GLenum' ))
glBlendFuncSeparateINGR.add( Input( 'sfactorAlpha','GLenum' ))
glBlendFuncSeparateINGR.add( Input( 'dfactorAlpha','GLenum' ))
glBlendFuncSeparateINGR.version = '1.1'
glBlendFuncSeparateINGR.category = 'GL_INGR_blend_func_separate'
glBlendFuncSeparateINGR.trace = True
glBlendFuncSeparateINGR.play = True
gl.add(glBlendFuncSeparateINGR)

# GL_INTEL_map_texture

glMapTexture2DINTEL = Function('glMapTexture2DINTEL')
glMapTexture2DINTEL.ret = Return('GLvoid *')
glMapTexture2DINTEL.add( Input( 'texture','GLuint' ))
glMapTexture2DINTEL.add( Input( 'level','GLint' ))
glMapTexture2DINTEL.add( Input( 'access','GLbitfield' ,regalLog = 'GLmapTexture2DINTELToString(access)' ))
glMapTexture2DINTEL.add( Input( 'stride','GLint *' ))
glMapTexture2DINTEL.add( Input( 'layout','GLenum *' ))
glMapTexture2DINTEL.version = ''
glMapTexture2DINTEL.category = 'GL_INTEL_map_texture'
glMapTexture2DINTEL.trace = True
glMapTexture2DINTEL.play = True
gl.add(glMapTexture2DINTEL)

glSyncTextureINTEL = Function('glSyncTextureINTEL')
glSyncTextureINTEL.ret = Return('void')
glSyncTextureINTEL.add( Input( 'texture','GLuint' ))
glSyncTextureINTEL.version = ''
glSyncTextureINTEL.category = 'GL_INTEL_map_texture'
glSyncTextureINTEL.trace = True
glSyncTextureINTEL.play = True
gl.add(glSyncTextureINTEL)

glUnmapTexture2DINTEL = Function('glUnmapTexture2DINTEL')
glUnmapTexture2DINTEL.ret = Return('void')
glUnmapTexture2DINTEL.add( Input( 'texture','GLuint' ))
glUnmapTexture2DINTEL.add( Input( 'level','GLint' ))
glUnmapTexture2DINTEL.version = ''
glUnmapTexture2DINTEL.category = 'GL_INTEL_map_texture'
glUnmapTexture2DINTEL.trace = True
glUnmapTexture2DINTEL.play = True
gl.add(glUnmapTexture2DINTEL)

# GL_INTEL_parallel_arrays

glColorPointervINTEL = Function('glColorPointervINTEL')
glColorPointervINTEL.ret = Return('void')
glColorPointervINTEL.add( Input( 'size','GLint' ))
glColorPointervINTEL.add( Input( 'type','GLenum' ))
glColorPointervINTEL.add( Input( 'pointer','const GLvoid **' ,size = 4 ))
glColorPointervINTEL.version = '1.1'
glColorPointervINTEL.category = 'GL_INTEL_parallel_arrays'
glColorPointervINTEL.trace = True
glColorPointervINTEL.play = True
gl.add(glColorPointervINTEL)

glNormalPointervINTEL = Function('glNormalPointervINTEL')
glNormalPointervINTEL.ret = Return('void')
glNormalPointervINTEL.add( Input( 'type','GLenum' ))
glNormalPointervINTEL.add( Input( 'pointer','const GLvoid **' ,size = 4 ))
glNormalPointervINTEL.version = '1.1'
glNormalPointervINTEL.category = 'GL_INTEL_parallel_arrays'
glNormalPointervINTEL.trace = True
glNormalPointervINTEL.play = True
gl.add(glNormalPointervINTEL)

glTexCoordPointervINTEL = Function('glTexCoordPointervINTEL')
glTexCoordPointervINTEL.ret = Return('void')
glTexCoordPointervINTEL.add( Input( 'size','GLint' ))
glTexCoordPointervINTEL.add( Input( 'type','GLenum' ))
glTexCoordPointervINTEL.add( Input( 'pointer','const GLvoid **' ,size = 4 ))
glTexCoordPointervINTEL.version = '1.1'
glTexCoordPointervINTEL.category = 'GL_INTEL_parallel_arrays'
glTexCoordPointervINTEL.trace = True
glTexCoordPointervINTEL.play = True
gl.add(glTexCoordPointervINTEL)

glVertexPointervINTEL = Function('glVertexPointervINTEL')
glVertexPointervINTEL.ret = Return('void')
glVertexPointervINTEL.add( Input( 'size','GLint' ))
glVertexPointervINTEL.add( Input( 'type','GLenum' ))
glVertexPointervINTEL.add( Input( 'pointer','const GLvoid **' ,size = 4 ))
glVertexPointervINTEL.version = '1.1'
glVertexPointervINTEL.category = 'GL_INTEL_parallel_arrays'
glVertexPointervINTEL.trace = True
glVertexPointervINTEL.play = True
gl.add(glVertexPointervINTEL)

# GL_INTEL_texture_scissor

glTexScissorFuncINTEL = Function('glTexScissorFuncINTEL')
glTexScissorFuncINTEL.ret = Return('void')
glTexScissorFuncINTEL.add( Input( 'target','GLenum' ))
glTexScissorFuncINTEL.add( Input( 'lfunc','GLenum' ))
glTexScissorFuncINTEL.add( Input( 'hfunc','GLenum' ))
glTexScissorFuncINTEL.version = ''
glTexScissorFuncINTEL.category = 'GL_INTEL_texture_scissor'
glTexScissorFuncINTEL.trace = True
glTexScissorFuncINTEL.play = True
gl.add(glTexScissorFuncINTEL)

glTexScissorINTEL = Function('glTexScissorINTEL')
glTexScissorINTEL.ret = Return('void')
glTexScissorINTEL.add( Input( 'target','GLenum' ))
glTexScissorINTEL.add( Input( 'tlow','GLclampf' ))
glTexScissorINTEL.add( Input( 'thigh','GLclampf' ))
glTexScissorINTEL.version = ''
glTexScissorINTEL.category = 'GL_INTEL_texture_scissor'
glTexScissorINTEL.trace = True
glTexScissorINTEL.play = True
gl.add(glTexScissorINTEL)

# GL_KHR_debug

glDebugMessageCallback = Function('glDebugMessageCallback')
glDebugMessageCallback.ret = Return('void')
glDebugMessageCallback.add( Input( 'callback','GLDEBUGPROC' ))
glDebugMessageCallback.add( Input( 'userParam','const void *' ))
glDebugMessageCallback.version = ''
glDebugMessageCallback.category = 'GL_KHR_debug'
glDebugMessageCallback.trace = True
glDebugMessageCallback.play = True
gl.add(glDebugMessageCallback)

glDebugMessageControl = Function('glDebugMessageControl')
glDebugMessageControl.ret = Return('void')
glDebugMessageControl.add( Input( 'source','GLenum' ))
glDebugMessageControl.add( Input( 'type','GLenum' ))
glDebugMessageControl.add( Input( 'severity','GLenum' ))
glDebugMessageControl.add( Input( 'count','GLsizei' ))
glDebugMessageControl.add( Input( 'ids','const GLuint *' ))
glDebugMessageControl.add( Input( 'enabled','GLboolean' ))
glDebugMessageControl.version = ''
glDebugMessageControl.category = 'GL_KHR_debug'
glDebugMessageControl.trace = True
glDebugMessageControl.play = True
gl.add(glDebugMessageControl)

glDebugMessageInsert = Function('glDebugMessageInsert')
glDebugMessageInsert.ret = Return('void')
glDebugMessageInsert.add( Input( 'source','GLenum' ))
glDebugMessageInsert.add( Input( 'type','GLenum' ))
glDebugMessageInsert.add( Input( 'id','GLuint' ))
glDebugMessageInsert.add( Input( 'severity','GLenum' ))
glDebugMessageInsert.add( Input( 'length','GLsizei' ))
glDebugMessageInsert.add( Input( 'buf','const GLchar *' ))
glDebugMessageInsert.version = ''
glDebugMessageInsert.category = 'GL_KHR_debug'
glDebugMessageInsert.trace = True
glDebugMessageInsert.play = True
gl.add(glDebugMessageInsert)

glGetDebugMessageLog = Function('glGetDebugMessageLog')
glGetDebugMessageLog.ret = Return('GLuint')
glGetDebugMessageLog.add( Input( 'count','GLuint' ))
glGetDebugMessageLog.add( Input( 'bufsize','GLsizei' ))
glGetDebugMessageLog.add( Input( 'sources','GLenum *' ))
glGetDebugMessageLog.add( Input( 'types','GLenum *' ))
glGetDebugMessageLog.add( Input( 'ids','GLuint *' ))
glGetDebugMessageLog.add( Input( 'severities','GLenum *' ))
glGetDebugMessageLog.add( Input( 'lengths','GLsizei *' ))
glGetDebugMessageLog.add( Input( 'messageLog','GLchar *' ))
glGetDebugMessageLog.version = ''
glGetDebugMessageLog.category = 'GL_KHR_debug'
glGetDebugMessageLog.trace = True
glGetDebugMessageLog.play = True
gl.add(glGetDebugMessageLog)

glGetObjectLabel = Function('glGetObjectLabel')
glGetObjectLabel.ret = Return('void')
glGetObjectLabel.add( Input( 'identifier','GLenum' ))
glGetObjectLabel.add( Input( 'name','GLuint' ))
glGetObjectLabel.add( Input( 'bufSize','GLsizei' ))
glGetObjectLabel.add( Input( 'length','GLsizei *' ))
glGetObjectLabel.add( Input( 'label','GLchar *' ))
glGetObjectLabel.version = ''
glGetObjectLabel.category = 'GL_KHR_debug'
glGetObjectLabel.trace = True
glGetObjectLabel.play = True
gl.add(glGetObjectLabel)

glGetObjectPtrLabel = Function('glGetObjectPtrLabel')
glGetObjectPtrLabel.ret = Return('void')
glGetObjectPtrLabel.add( Input( 'ptr','const GLvoid *' ))
glGetObjectPtrLabel.add( Input( 'bufSize','GLsizei' ))
glGetObjectPtrLabel.add( Input( 'length','GLsizei *' ))
glGetObjectPtrLabel.add( Input( 'label','GLchar *' ))
glGetObjectPtrLabel.version = ''
glGetObjectPtrLabel.category = 'GL_KHR_debug'
glGetObjectPtrLabel.trace = True
glGetObjectPtrLabel.play = True
gl.add(glGetObjectPtrLabel)

glObjectLabel = Function('glObjectLabel')
glObjectLabel.ret = Return('void')
glObjectLabel.add( Input( 'identifier','GLenum' ))
glObjectLabel.add( Input( 'name','GLuint' ))
glObjectLabel.add( Input( 'length','GLsizei' ))
glObjectLabel.add( Input( 'label','const GLchar *' ))
glObjectLabel.version = ''
glObjectLabel.category = 'GL_KHR_debug'
glObjectLabel.trace = True
glObjectLabel.play = True
gl.add(glObjectLabel)

glObjectPtrLabel = Function('glObjectPtrLabel')
glObjectPtrLabel.ret = Return('void')
glObjectPtrLabel.add( Input( 'ptr','const GLvoid *' ))
glObjectPtrLabel.add( Input( 'length','GLsizei' ))
glObjectPtrLabel.add( Input( 'label','const GLchar *' ))
glObjectPtrLabel.version = ''
glObjectPtrLabel.category = 'GL_KHR_debug'
glObjectPtrLabel.trace = True
glObjectPtrLabel.play = True
gl.add(glObjectPtrLabel)

glPopDebugGroup = Function('glPopDebugGroup')
glPopDebugGroup.ret = Return('void')
glPopDebugGroup.version = ''
glPopDebugGroup.category = 'GL_KHR_debug'
glPopDebugGroup.trace = True
glPopDebugGroup.play = True
gl.add(glPopDebugGroup)

glPushDebugGroup = Function('glPushDebugGroup')
glPushDebugGroup.ret = Return('void')
glPushDebugGroup.add( Input( 'source','GLenum' ))
glPushDebugGroup.add( Input( 'id','GLuint' ))
glPushDebugGroup.add( Input( 'length','GLsizei' ))
glPushDebugGroup.add( Input( 'message','const GLchar *' ))
glPushDebugGroup.version = ''
glPushDebugGroup.category = 'GL_KHR_debug'
glPushDebugGroup.trace = True
glPushDebugGroup.play = True
gl.add(glPushDebugGroup)

# GL_KTX_buffer_region

glBufferRegionEnabled = Function('glBufferRegionEnabled')
glBufferRegionEnabled.ret = Return('GLuint')
glBufferRegionEnabled.version = ''
glBufferRegionEnabled.category = 'GL_KTX_buffer_region'
glBufferRegionEnabled.trace = True
glBufferRegionEnabled.play = True
gl.add(glBufferRegionEnabled)

glDeleteBufferRegion = Function('glDeleteBufferRegion')
glDeleteBufferRegion.ret = Return('void')
glDeleteBufferRegion.add( Input( 'region','GLenum' ))
glDeleteBufferRegion.version = ''
glDeleteBufferRegion.category = 'GL_KTX_buffer_region'
glDeleteBufferRegion.trace = True
glDeleteBufferRegion.play = True
gl.add(glDeleteBufferRegion)

glDrawBufferRegion = Function('glDrawBufferRegion')
glDrawBufferRegion.ret = Return('void')
glDrawBufferRegion.add( Input( 'region','GLuint' ))
glDrawBufferRegion.add( Input( 'x','GLint' ))
glDrawBufferRegion.add( Input( 'y','GLint' ))
glDrawBufferRegion.add( Input( 'width','GLsizei' ))
glDrawBufferRegion.add( Input( 'height','GLsizei' ))
glDrawBufferRegion.add( Input( 'xDest','GLint' ))
glDrawBufferRegion.add( Input( 'yDest','GLint' ))
glDrawBufferRegion.version = ''
glDrawBufferRegion.category = 'GL_KTX_buffer_region'
glDrawBufferRegion.trace = True
glDrawBufferRegion.play = True
gl.add(glDrawBufferRegion)

glNewBufferRegion = Function('glNewBufferRegion')
glNewBufferRegion.ret = Return('GLuint')
glNewBufferRegion.add( Input( 'region','GLenum' ))
glNewBufferRegion.version = ''
glNewBufferRegion.category = 'GL_KTX_buffer_region'
glNewBufferRegion.trace = True
glNewBufferRegion.play = True
gl.add(glNewBufferRegion)

glReadBufferRegion = Function('glReadBufferRegion')
glReadBufferRegion.ret = Return('void')
glReadBufferRegion.add( Input( 'region','GLuint' ))
glReadBufferRegion.add( Input( 'x','GLint' ))
glReadBufferRegion.add( Input( 'y','GLint' ))
glReadBufferRegion.add( Input( 'width','GLsizei' ))
glReadBufferRegion.add( Input( 'height','GLsizei' ))
glReadBufferRegion.version = ''
glReadBufferRegion.category = 'GL_KTX_buffer_region'
glReadBufferRegion.trace = True
glReadBufferRegion.play = True
gl.add(glReadBufferRegion)

# GL_MESA_resize_buffers

glResizeBuffersMESA = Function('glResizeBuffersMESA')
glResizeBuffersMESA.ret = Return('void')
glResizeBuffersMESA.version = '1.0'
glResizeBuffersMESA.category = 'GL_MESA_resize_buffers'
glResizeBuffersMESA.trace = True
glResizeBuffersMESA.play = True
gl.add(glResizeBuffersMESA)

# GL_MESA_window_pos

glWindowPos2dMESA = Function('glWindowPos2dMESA')
glWindowPos2dMESA.ret = Return('void')
glWindowPos2dMESA.add( Input( 'x','GLdouble' ))
glWindowPos2dMESA.add( Input( 'y','GLdouble' ))
glWindowPos2dMESA.version = '1.0'
glWindowPos2dMESA.category = 'GL_MESA_window_pos'
glWindowPos2dMESA.trace = True
glWindowPos2dMESA.play = True
gl.add(glWindowPos2dMESA)

glWindowPos2dvMESA = Function('glWindowPos2dvMESA')
glWindowPos2dvMESA.ret = Return('void')
glWindowPos2dvMESA.add( Input( 'v','const GLdouble *' ,size = 2 ))
glWindowPos2dvMESA.version = '1.0'
glWindowPos2dvMESA.category = 'GL_MESA_window_pos'
glWindowPos2dvMESA.trace = True
glWindowPos2dvMESA.play = True
gl.add(glWindowPos2dvMESA)

glWindowPos2fMESA = Function('glWindowPos2fMESA')
glWindowPos2fMESA.ret = Return('void')
glWindowPos2fMESA.add( Input( 'x','GLfloat' ))
glWindowPos2fMESA.add( Input( 'y','GLfloat' ))
glWindowPos2fMESA.version = '1.0'
glWindowPos2fMESA.category = 'GL_MESA_window_pos'
glWindowPos2fMESA.trace = True
glWindowPos2fMESA.play = True
gl.add(glWindowPos2fMESA)

glWindowPos2fvMESA = Function('glWindowPos2fvMESA')
glWindowPos2fvMESA.ret = Return('void')
glWindowPos2fvMESA.add( Input( 'v','const GLfloat *' ,size = 2 ))
glWindowPos2fvMESA.version = '1.0'
glWindowPos2fvMESA.category = 'GL_MESA_window_pos'
glWindowPos2fvMESA.trace = True
glWindowPos2fvMESA.play = True
gl.add(glWindowPos2fvMESA)

glWindowPos2iMESA = Function('glWindowPos2iMESA')
glWindowPos2iMESA.ret = Return('void')
glWindowPos2iMESA.add( Input( 'x','GLint' ))
glWindowPos2iMESA.add( Input( 'y','GLint' ))
glWindowPos2iMESA.version = '1.0'
glWindowPos2iMESA.category = 'GL_MESA_window_pos'
glWindowPos2iMESA.trace = True
glWindowPos2iMESA.play = True
gl.add(glWindowPos2iMESA)

glWindowPos2ivMESA = Function('glWindowPos2ivMESA')
glWindowPos2ivMESA.ret = Return('void')
glWindowPos2ivMESA.add( Input( 'v','const GLint *' ,size = 2 ))
glWindowPos2ivMESA.version = '1.0'
glWindowPos2ivMESA.category = 'GL_MESA_window_pos'
glWindowPos2ivMESA.trace = True
glWindowPos2ivMESA.play = True
gl.add(glWindowPos2ivMESA)

glWindowPos2sMESA = Function('glWindowPos2sMESA')
glWindowPos2sMESA.ret = Return('void')
glWindowPos2sMESA.add( Input( 'x','GLshort' ))
glWindowPos2sMESA.add( Input( 'y','GLshort' ))
glWindowPos2sMESA.version = '1.0'
glWindowPos2sMESA.category = 'GL_MESA_window_pos'
glWindowPos2sMESA.trace = True
glWindowPos2sMESA.play = True
gl.add(glWindowPos2sMESA)

glWindowPos2svMESA = Function('glWindowPos2svMESA')
glWindowPos2svMESA.ret = Return('void')
glWindowPos2svMESA.add( Input( 'v','const GLshort *' ,size = 2 ))
glWindowPos2svMESA.version = '1.0'
glWindowPos2svMESA.category = 'GL_MESA_window_pos'
glWindowPos2svMESA.trace = True
glWindowPos2svMESA.play = True
gl.add(glWindowPos2svMESA)

glWindowPos3dMESA = Function('glWindowPos3dMESA')
glWindowPos3dMESA.ret = Return('void')
glWindowPos3dMESA.add( Input( 'x','GLdouble' ))
glWindowPos3dMESA.add( Input( 'y','GLdouble' ))
glWindowPos3dMESA.add( Input( 'z','GLdouble' ))
glWindowPos3dMESA.version = '1.0'
glWindowPos3dMESA.category = 'GL_MESA_window_pos'
glWindowPos3dMESA.trace = True
glWindowPos3dMESA.play = True
gl.add(glWindowPos3dMESA)

glWindowPos3dvMESA = Function('glWindowPos3dvMESA')
glWindowPos3dvMESA.ret = Return('void')
glWindowPos3dvMESA.add( Input( 'v','const GLdouble *' ,size = 3 ))
glWindowPos3dvMESA.version = '1.0'
glWindowPos3dvMESA.category = 'GL_MESA_window_pos'
glWindowPos3dvMESA.trace = True
glWindowPos3dvMESA.play = True
gl.add(glWindowPos3dvMESA)

glWindowPos3fMESA = Function('glWindowPos3fMESA')
glWindowPos3fMESA.ret = Return('void')
glWindowPos3fMESA.add( Input( 'x','GLfloat' ))
glWindowPos3fMESA.add( Input( 'y','GLfloat' ))
glWindowPos3fMESA.add( Input( 'z','GLfloat' ))
glWindowPos3fMESA.version = '1.0'
glWindowPos3fMESA.category = 'GL_MESA_window_pos'
glWindowPos3fMESA.trace = True
glWindowPos3fMESA.play = True
gl.add(glWindowPos3fMESA)

glWindowPos3fvMESA = Function('glWindowPos3fvMESA')
glWindowPos3fvMESA.ret = Return('void')
glWindowPos3fvMESA.add( Input( 'v','const GLfloat *' ,size = 3 ))
glWindowPos3fvMESA.version = '1.0'
glWindowPos3fvMESA.category = 'GL_MESA_window_pos'
glWindowPos3fvMESA.trace = True
glWindowPos3fvMESA.play = True
gl.add(glWindowPos3fvMESA)

glWindowPos3iMESA = Function('glWindowPos3iMESA')
glWindowPos3iMESA.ret = Return('void')
glWindowPos3iMESA.add( Input( 'x','GLint' ))
glWindowPos3iMESA.add( Input( 'y','GLint' ))
glWindowPos3iMESA.add( Input( 'z','GLint' ))
glWindowPos3iMESA.version = '1.0'
glWindowPos3iMESA.category = 'GL_MESA_window_pos'
glWindowPos3iMESA.trace = True
glWindowPos3iMESA.play = True
gl.add(glWindowPos3iMESA)

glWindowPos3ivMESA = Function('glWindowPos3ivMESA')
glWindowPos3ivMESA.ret = Return('void')
glWindowPos3ivMESA.add( Input( 'v','const GLint *' ,size = 3 ))
glWindowPos3ivMESA.version = '1.0'
glWindowPos3ivMESA.category = 'GL_MESA_window_pos'
glWindowPos3ivMESA.trace = True
glWindowPos3ivMESA.play = True
gl.add(glWindowPos3ivMESA)

glWindowPos3sMESA = Function('glWindowPos3sMESA')
glWindowPos3sMESA.ret = Return('void')
glWindowPos3sMESA.add( Input( 'x','GLshort' ))
glWindowPos3sMESA.add( Input( 'y','GLshort' ))
glWindowPos3sMESA.add( Input( 'z','GLshort' ))
glWindowPos3sMESA.version = '1.0'
glWindowPos3sMESA.category = 'GL_MESA_window_pos'
glWindowPos3sMESA.trace = True
glWindowPos3sMESA.play = True
gl.add(glWindowPos3sMESA)

glWindowPos3svMESA = Function('glWindowPos3svMESA')
glWindowPos3svMESA.ret = Return('void')
glWindowPos3svMESA.add( Input( 'v','const GLshort *' ,size = 3 ))
glWindowPos3svMESA.version = '1.0'
glWindowPos3svMESA.category = 'GL_MESA_window_pos'
glWindowPos3svMESA.trace = True
glWindowPos3svMESA.play = True
gl.add(glWindowPos3svMESA)

glWindowPos4dMESA = Function('glWindowPos4dMESA')
glWindowPos4dMESA.ret = Return('void')
glWindowPos4dMESA.add( Input( 'x','GLdouble' ))
glWindowPos4dMESA.add( Input( 'y','GLdouble' ))
glWindowPos4dMESA.add( Input( 'z','GLdouble' ))
glWindowPos4dMESA.add( Input( 'w','GLdouble' ))
glWindowPos4dMESA.version = '1.0'
glWindowPos4dMESA.category = 'GL_MESA_window_pos'
glWindowPos4dMESA.trace = True
glWindowPos4dMESA.play = True
gl.add(glWindowPos4dMESA)

glWindowPos4dvMESA = Function('glWindowPos4dvMESA')
glWindowPos4dvMESA.ret = Return('void')
glWindowPos4dvMESA.add( Input( 'v','const GLdouble *' ,size = 4 ))
glWindowPos4dvMESA.version = '1.0'
glWindowPos4dvMESA.category = 'GL_MESA_window_pos'
glWindowPos4dvMESA.trace = True
glWindowPos4dvMESA.play = True
gl.add(glWindowPos4dvMESA)

glWindowPos4fMESA = Function('glWindowPos4fMESA')
glWindowPos4fMESA.ret = Return('void')
glWindowPos4fMESA.add( Input( 'x','GLfloat' ))
glWindowPos4fMESA.add( Input( 'y','GLfloat' ))
glWindowPos4fMESA.add( Input( 'z','GLfloat' ))
glWindowPos4fMESA.add( Input( 'w','GLfloat' ))
glWindowPos4fMESA.version = '1.0'
glWindowPos4fMESA.category = 'GL_MESA_window_pos'
glWindowPos4fMESA.trace = True
glWindowPos4fMESA.play = True
gl.add(glWindowPos4fMESA)

glWindowPos4fvMESA = Function('glWindowPos4fvMESA')
glWindowPos4fvMESA.ret = Return('void')
glWindowPos4fvMESA.add( Input( 'v','const GLfloat *' ,size = 4 ))
glWindowPos4fvMESA.version = '1.0'
glWindowPos4fvMESA.category = 'GL_MESA_window_pos'
glWindowPos4fvMESA.trace = True
glWindowPos4fvMESA.play = True
gl.add(glWindowPos4fvMESA)

glWindowPos4iMESA = Function('glWindowPos4iMESA')
glWindowPos4iMESA.ret = Return('void')
glWindowPos4iMESA.add( Input( 'x','GLint' ))
glWindowPos4iMESA.add( Input( 'y','GLint' ))
glWindowPos4iMESA.add( Input( 'z','GLint' ))
glWindowPos4iMESA.add( Input( 'w','GLint' ))
glWindowPos4iMESA.version = '1.0'
glWindowPos4iMESA.category = 'GL_MESA_window_pos'
glWindowPos4iMESA.trace = True
glWindowPos4iMESA.play = True
gl.add(glWindowPos4iMESA)

glWindowPos4ivMESA = Function('glWindowPos4ivMESA')
glWindowPos4ivMESA.ret = Return('void')
glWindowPos4ivMESA.add( Input( 'v','const GLint *' ,size = 4 ))
glWindowPos4ivMESA.version = '1.0'
glWindowPos4ivMESA.category = 'GL_MESA_window_pos'
glWindowPos4ivMESA.trace = True
glWindowPos4ivMESA.play = True
gl.add(glWindowPos4ivMESA)

glWindowPos4sMESA = Function('glWindowPos4sMESA')
glWindowPos4sMESA.ret = Return('void')
glWindowPos4sMESA.add( Input( 'x','GLshort' ))
glWindowPos4sMESA.add( Input( 'y','GLshort' ))
glWindowPos4sMESA.add( Input( 'z','GLshort' ))
glWindowPos4sMESA.add( Input( 'w','GLshort' ))
glWindowPos4sMESA.version = '1.0'
glWindowPos4sMESA.category = 'GL_MESA_window_pos'
glWindowPos4sMESA.trace = True
glWindowPos4sMESA.play = True
gl.add(glWindowPos4sMESA)

glWindowPos4svMESA = Function('glWindowPos4svMESA')
glWindowPos4svMESA.ret = Return('void')
glWindowPos4svMESA.add( Input( 'v','const GLshort *' ,size = 4 ))
glWindowPos4svMESA.version = '1.0'
glWindowPos4svMESA.category = 'GL_MESA_window_pos'
glWindowPos4svMESA.trace = True
glWindowPos4svMESA.play = True
gl.add(glWindowPos4svMESA)

# GL_NVX_conditional_render

glBeginConditionalRenderNVX = Function('glBeginConditionalRenderNVX')
glBeginConditionalRenderNVX.ret = Return('void')
glBeginConditionalRenderNVX.add( Input( 'id','GLuint' ))
glBeginConditionalRenderNVX.version = '1.5'
glBeginConditionalRenderNVX.category = 'GL_NVX_conditional_render'
glBeginConditionalRenderNVX.trace = True
glBeginConditionalRenderNVX.play = True
gl.add(glBeginConditionalRenderNVX)

glEndConditionalRenderNVX = Function('glEndConditionalRenderNVX')
glEndConditionalRenderNVX.ret = Return('void')
glEndConditionalRenderNVX.version = '1.5'
glEndConditionalRenderNVX.category = 'GL_NVX_conditional_render'
glEndConditionalRenderNVX.trace = True
glEndConditionalRenderNVX.play = True
gl.add(glEndConditionalRenderNVX)

# GL_NV_bindless_texture

glGetImageHandleNV = Function('glGetImageHandleNV')
glGetImageHandleNV.ret = Return('GLuint64')
glGetImageHandleNV.add( Input( 'texture','GLuint' ))
glGetImageHandleNV.add( Input( 'level','GLint' ))
glGetImageHandleNV.add( Input( 'layered','GLboolean' ))
glGetImageHandleNV.add( Input( 'layer','GLint' ))
glGetImageHandleNV.add( Input( 'format','GLenum' ))
glGetImageHandleNV.version = ''
glGetImageHandleNV.category = 'GL_NV_bindless_texture'
glGetImageHandleNV.trace = True
glGetImageHandleNV.play = True
gl.add(glGetImageHandleNV)

glGetTextureHandleNV = Function('glGetTextureHandleNV')
glGetTextureHandleNV.ret = Return('GLuint64')
glGetTextureHandleNV.add( Input( 'texture','GLuint' ))
glGetTextureHandleNV.version = ''
glGetTextureHandleNV.category = 'GL_NV_bindless_texture'
glGetTextureHandleNV.trace = True
glGetTextureHandleNV.play = True
gl.add(glGetTextureHandleNV)

glGetTextureSamplerHandleNV = Function('glGetTextureSamplerHandleNV')
glGetTextureSamplerHandleNV.ret = Return('GLuint64')
glGetTextureSamplerHandleNV.add( Input( 'texture','GLuint' ))
glGetTextureSamplerHandleNV.add( Input( 'sampler','GLuint' ))
glGetTextureSamplerHandleNV.version = ''
glGetTextureSamplerHandleNV.category = 'GL_NV_bindless_texture'
glGetTextureSamplerHandleNV.trace = True
glGetTextureSamplerHandleNV.play = True
gl.add(glGetTextureSamplerHandleNV)

glIsImageHandleResidentNV = Function('glIsImageHandleResidentNV')
glIsImageHandleResidentNV.ret = Return('GLboolean')
glIsImageHandleResidentNV.add( Input( 'handle','GLuint64' ))
glIsImageHandleResidentNV.version = ''
glIsImageHandleResidentNV.category = 'GL_NV_bindless_texture'
glIsImageHandleResidentNV.trace = True
glIsImageHandleResidentNV.play = True
gl.add(glIsImageHandleResidentNV)

glIsTextureHandleResidentNV = Function('glIsTextureHandleResidentNV')
glIsTextureHandleResidentNV.ret = Return('GLboolean')
glIsTextureHandleResidentNV.add( Input( 'handle','GLuint64' ))
glIsTextureHandleResidentNV.version = ''
glIsTextureHandleResidentNV.category = 'GL_NV_bindless_texture'
glIsTextureHandleResidentNV.trace = True
glIsTextureHandleResidentNV.play = True
gl.add(glIsTextureHandleResidentNV)

glMakeImageHandleNonResidentNV = Function('glMakeImageHandleNonResidentNV')
glMakeImageHandleNonResidentNV.ret = Return('void')
glMakeImageHandleNonResidentNV.add( Input( 'handle','GLuint64' ))
glMakeImageHandleNonResidentNV.version = ''
glMakeImageHandleNonResidentNV.category = 'GL_NV_bindless_texture'
glMakeImageHandleNonResidentNV.trace = True
glMakeImageHandleNonResidentNV.play = True
gl.add(glMakeImageHandleNonResidentNV)

glMakeImageHandleResidentNV = Function('glMakeImageHandleResidentNV')
glMakeImageHandleResidentNV.ret = Return('void')
glMakeImageHandleResidentNV.add( Input( 'handle','GLuint64' ))
glMakeImageHandleResidentNV.add( Input( 'access','GLenum' ))
glMakeImageHandleResidentNV.version = ''
glMakeImageHandleResidentNV.category = 'GL_NV_bindless_texture'
glMakeImageHandleResidentNV.trace = True
glMakeImageHandleResidentNV.play = True
gl.add(glMakeImageHandleResidentNV)

glMakeTextureHandleNonResidentNV = Function('glMakeTextureHandleNonResidentNV')
glMakeTextureHandleNonResidentNV.ret = Return('void')
glMakeTextureHandleNonResidentNV.add( Input( 'handle','GLuint64' ))
glMakeTextureHandleNonResidentNV.version = ''
glMakeTextureHandleNonResidentNV.category = 'GL_NV_bindless_texture'
glMakeTextureHandleNonResidentNV.trace = True
glMakeTextureHandleNonResidentNV.play = True
gl.add(glMakeTextureHandleNonResidentNV)

glMakeTextureHandleResidentNV = Function('glMakeTextureHandleResidentNV')
glMakeTextureHandleResidentNV.ret = Return('void')
glMakeTextureHandleResidentNV.add( Input( 'handle','GLuint64' ))
glMakeTextureHandleResidentNV.version = ''
glMakeTextureHandleResidentNV.category = 'GL_NV_bindless_texture'
glMakeTextureHandleResidentNV.trace = True
glMakeTextureHandleResidentNV.play = True
gl.add(glMakeTextureHandleResidentNV)

glProgramUniformHandleui64NV = Function('glProgramUniformHandleui64NV')
glProgramUniformHandleui64NV.ret = Return('void')
glProgramUniformHandleui64NV.add( Input( 'program','GLuint' ))
glProgramUniformHandleui64NV.add( Input( 'location','GLint' ))
glProgramUniformHandleui64NV.add( Input( 'value','GLuint64' ))
glProgramUniformHandleui64NV.version = ''
glProgramUniformHandleui64NV.category = 'GL_NV_bindless_texture'
glProgramUniformHandleui64NV.trace = True
glProgramUniformHandleui64NV.play = True
gl.add(glProgramUniformHandleui64NV)

glProgramUniformHandleui64vNV = Function('glProgramUniformHandleui64vNV')
glProgramUniformHandleui64vNV.ret = Return('void')
glProgramUniformHandleui64vNV.add( Input( 'program','GLuint' ))
glProgramUniformHandleui64vNV.add( Input( 'location','GLint' ))
glProgramUniformHandleui64vNV.add( Input( 'count','GLsizei' ))
glProgramUniformHandleui64vNV.add( Input( 'values','const GLuint64 *' ))
glProgramUniformHandleui64vNV.version = ''
glProgramUniformHandleui64vNV.category = 'GL_NV_bindless_texture'
glProgramUniformHandleui64vNV.trace = True
glProgramUniformHandleui64vNV.play = True
gl.add(glProgramUniformHandleui64vNV)

glUniformHandleui64NV = Function('glUniformHandleui64NV')
glUniformHandleui64NV.ret = Return('void')
glUniformHandleui64NV.add( Input( 'location','GLint' ))
glUniformHandleui64NV.add( Input( 'value','GLuint64' ))
glUniformHandleui64NV.version = ''
glUniformHandleui64NV.category = 'GL_NV_bindless_texture'
glUniformHandleui64NV.trace = True
glUniformHandleui64NV.play = True
gl.add(glUniformHandleui64NV)

glUniformHandleui64vNV = Function('glUniformHandleui64vNV')
glUniformHandleui64vNV.ret = Return('void')
glUniformHandleui64vNV.add( Input( 'location','GLint' ))
glUniformHandleui64vNV.add( Input( 'count','GLsizei' ))
glUniformHandleui64vNV.add( Input( 'value','const GLuint64 *' ))
glUniformHandleui64vNV.version = ''
glUniformHandleui64vNV.category = 'GL_NV_bindless_texture'
glUniformHandleui64vNV.trace = True
glUniformHandleui64vNV.play = True
gl.add(glUniformHandleui64vNV)

# GL_NV_blend_equation_advanced

glBlendBarrierNV = Function('glBlendBarrierNV')
glBlendBarrierNV.ret = Return('void')
glBlendBarrierNV.version = ''
glBlendBarrierNV.category = 'GL_NV_blend_equation_advanced'
glBlendBarrierNV.trace = True
glBlendBarrierNV.play = True
gl.add(glBlendBarrierNV)

glBlendParameteriNV = Function('glBlendParameteriNV')
glBlendParameteriNV.ret = Return('void')
glBlendParameteriNV.add( Input( 'pname','GLenum' ))
glBlendParameteriNV.add( Input( 'value','GLint' ))
glBlendParameteriNV.version = ''
glBlendParameteriNV.category = 'GL_NV_blend_equation_advanced'
glBlendParameteriNV.trace = True
glBlendParameteriNV.play = True
gl.add(glBlendParameteriNV)

# GL_NV_conditional_render

glBeginConditionalRenderNV = Function('glBeginConditionalRenderNV')
glBeginConditionalRenderNV.ret = Return('void')
glBeginConditionalRenderNV.add( Input( 'id','GLuint' ))
glBeginConditionalRenderNV.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glBeginConditionalRenderNV.version = '1.5'
glBeginConditionalRenderNV.category = 'GL_NV_conditional_render'
glBeginConditionalRenderNV.trace = True
glBeginConditionalRenderNV.play = True
gl.add(glBeginConditionalRenderNV)

glEndConditionalRenderNV = Function('glEndConditionalRenderNV')
glEndConditionalRenderNV.ret = Return('void')
glEndConditionalRenderNV.version = '1.5'
glEndConditionalRenderNV.category = 'GL_NV_conditional_render'
glEndConditionalRenderNV.trace = True
glEndConditionalRenderNV.play = True
gl.add(glEndConditionalRenderNV)

# GL_NV_copy_buffer

glCopyBufferSubDataNV = Function('glCopyBufferSubDataNV')
glCopyBufferSubDataNV.ret = Return('void')
glCopyBufferSubDataNV.add( Input( 'readtarget','GLenum' ))
glCopyBufferSubDataNV.add( Input( 'writetarget','GLenum' ))
glCopyBufferSubDataNV.add( Input( 'readoffset','GLintptr' ))
glCopyBufferSubDataNV.add( Input( 'writeoffset','GLintptr' ))
glCopyBufferSubDataNV.add( Input( 'size','GLsizeiptr' ))
glCopyBufferSubDataNV.version = ''
glCopyBufferSubDataNV.category = 'GL_NV_copy_buffer'
glCopyBufferSubDataNV.trace = True
glCopyBufferSubDataNV.play = True
gl.add(glCopyBufferSubDataNV)

# GL_NV_copy_image

glCopyImageSubDataNV = Function('glCopyImageSubDataNV')
glCopyImageSubDataNV.ret = Return('void')
glCopyImageSubDataNV.add( Input( 'srcName','GLuint' ))
glCopyImageSubDataNV.add( Input( 'srcTarget','GLenum' ))
glCopyImageSubDataNV.add( Input( 'srcLevel','GLint' ))
glCopyImageSubDataNV.add( Input( 'srcX','GLint' ))
glCopyImageSubDataNV.add( Input( 'srcY','GLint' ))
glCopyImageSubDataNV.add( Input( 'srcZ','GLint' ))
glCopyImageSubDataNV.add( Input( 'dstName','GLuint' ))
glCopyImageSubDataNV.add( Input( 'dstTarget','GLenum' ))
glCopyImageSubDataNV.add( Input( 'dstLevel','GLint' ))
glCopyImageSubDataNV.add( Input( 'dstX','GLint' ))
glCopyImageSubDataNV.add( Input( 'dstY','GLint' ))
glCopyImageSubDataNV.add( Input( 'dstZ','GLint' ))
glCopyImageSubDataNV.add( Input( 'width','GLsizei' ))
glCopyImageSubDataNV.add( Input( 'height','GLsizei' ))
glCopyImageSubDataNV.add( Input( 'depth','GLsizei' ))
glCopyImageSubDataNV.version = '1.5'
glCopyImageSubDataNV.category = 'GL_NV_copy_image'
glCopyImageSubDataNV.trace = True
glCopyImageSubDataNV.play = True
gl.add(glCopyImageSubDataNV)

# GL_NV_coverage_sample

glCoverageMaskNV = Function('glCoverageMaskNV')
glCoverageMaskNV.ret = Return('void')
glCoverageMaskNV.add( Input( 'mask','GLboolean' ))
glCoverageMaskNV.version = ''
glCoverageMaskNV.category = 'GL_NV_coverage_sample'
glCoverageMaskNV.trace = True
glCoverageMaskNV.play = True
gl.add(glCoverageMaskNV)

glCoverageOperationNV = Function('glCoverageOperationNV')
glCoverageOperationNV.ret = Return('void')
glCoverageOperationNV.add( Input( 'operation','GLenum' ))
glCoverageOperationNV.version = ''
glCoverageOperationNV.category = 'GL_NV_coverage_sample'
glCoverageOperationNV.trace = True
glCoverageOperationNV.play = True
gl.add(glCoverageOperationNV)

# GL_NV_depth_buffer_float

glClearDepthdNV = Function('glClearDepthdNV')
glClearDepthdNV.ret = Return('void')
glClearDepthdNV.add( Input( 'depth','GLdouble' ))
glClearDepthdNV.version = '2.0'
glClearDepthdNV.category = 'GL_NV_depth_buffer_float'
glClearDepthdNV.trace = True
glClearDepthdNV.play = True
gl.add(glClearDepthdNV)

glDepthBoundsdNV = Function('glDepthBoundsdNV')
glDepthBoundsdNV.ret = Return('void')
glDepthBoundsdNV.add( Input( 'zmin','GLdouble' ))
glDepthBoundsdNV.add( Input( 'zmax','GLdouble' ))
glDepthBoundsdNV.version = '2.0'
glDepthBoundsdNV.category = 'GL_NV_depth_buffer_float'
glDepthBoundsdNV.trace = True
glDepthBoundsdNV.play = True
gl.add(glDepthBoundsdNV)

glDepthRangedNV = Function('glDepthRangedNV')
glDepthRangedNV.ret = Return('void')
glDepthRangedNV.add( Input( 'zNear','GLdouble' ))
glDepthRangedNV.add( Input( 'zFar','GLdouble' ))
glDepthRangedNV.version = '2.0'
glDepthRangedNV.category = 'GL_NV_depth_buffer_float'
glDepthRangedNV.trace = True
glDepthRangedNV.play = True
gl.add(glDepthRangedNV)

# GL_NV_draw_buffers

glDrawBuffersNV = Function('glDrawBuffersNV')
glDrawBuffersNV.ret = Return('void')
glDrawBuffersNV.add( Input( 'n','GLsizei' ))
glDrawBuffersNV.add( Input( 'bufs','const GLenum *' ))
glDrawBuffersNV.version = ''
glDrawBuffersNV.category = 'GL_NV_draw_buffers'
glDrawBuffersNV.trace = True
glDrawBuffersNV.play = True
gl.add(glDrawBuffersNV)

# GL_NV_draw_texture

glDrawTextureNV = Function('glDrawTextureNV')
glDrawTextureNV.ret = Return('void')
glDrawTextureNV.add( Input( 'texture','GLuint' ))
glDrawTextureNV.add( Input( 'sampler','GLuint' ))
glDrawTextureNV.add( Input( 'x0','GLfloat' ))
glDrawTextureNV.add( Input( 'y0','GLfloat' ))
glDrawTextureNV.add( Input( 'x1','GLfloat' ))
glDrawTextureNV.add( Input( 'y1','GLfloat' ))
glDrawTextureNV.add( Input( 'z','GLfloat' ))
glDrawTextureNV.add( Input( 's0','GLfloat' ))
glDrawTextureNV.add( Input( 't0','GLfloat' ))
glDrawTextureNV.add( Input( 's1','GLfloat' ))
glDrawTextureNV.add( Input( 't1','GLfloat' ))
glDrawTextureNV.version = ''
glDrawTextureNV.category = 'GL_NV_draw_texture'
glDrawTextureNV.trace = True
glDrawTextureNV.play = True
gl.add(glDrawTextureNV)

# GL_NV_evaluators

glEvalMapsNV = Function('glEvalMapsNV')
glEvalMapsNV.ret = Return('void')
glEvalMapsNV.add( Input( 'target','GLenum' ))
glEvalMapsNV.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glEvalMapsNV.version = '1.1'
glEvalMapsNV.category = 'GL_NV_evaluators'
glEvalMapsNV.trace = True
glEvalMapsNV.play = True
gl.add(glEvalMapsNV)

glGetMapAttribParameterfvNV = Function('glGetMapAttribParameterfvNV')
glGetMapAttribParameterfvNV.ret = Return('void')
glGetMapAttribParameterfvNV.add( Input( 'target','GLenum' ))
glGetMapAttribParameterfvNV.add( Input( 'index','GLuint' ))
glGetMapAttribParameterfvNV.add( Input( 'pname','GLenum' ))
glGetMapAttribParameterfvNV.add( Output( 'params','GLfloat *' ))
glGetMapAttribParameterfvNV.version = '1.1'
glGetMapAttribParameterfvNV.category = 'GL_NV_evaluators'
glGetMapAttribParameterfvNV.trace = True
glGetMapAttribParameterfvNV.play = True
gl.add(glGetMapAttribParameterfvNV)

glGetMapAttribParameterivNV = Function('glGetMapAttribParameterivNV')
glGetMapAttribParameterivNV.ret = Return('void')
glGetMapAttribParameterivNV.add( Input( 'target','GLenum' ))
glGetMapAttribParameterivNV.add( Input( 'index','GLuint' ))
glGetMapAttribParameterivNV.add( Input( 'pname','GLenum' ))
glGetMapAttribParameterivNV.add( Output( 'params','GLint *' ))
glGetMapAttribParameterivNV.version = '1.1'
glGetMapAttribParameterivNV.category = 'GL_NV_evaluators'
glGetMapAttribParameterivNV.trace = True
glGetMapAttribParameterivNV.play = True
gl.add(glGetMapAttribParameterivNV)

glGetMapControlPointsNV = Function('glGetMapControlPointsNV')
glGetMapControlPointsNV.ret = Return('void')
glGetMapControlPointsNV.add( Input( 'target','GLenum' ))
glGetMapControlPointsNV.add( Input( 'index','GLuint' ))
glGetMapControlPointsNV.add( Input( 'type','GLenum' ))
glGetMapControlPointsNV.add( Input( 'ustride','GLsizei' ))
glGetMapControlPointsNV.add( Input( 'vstride','GLsizei' ))
glGetMapControlPointsNV.add( Input( 'packed','GLboolean' ))
glGetMapControlPointsNV.add( Output( 'points','GLvoid *' ))
glGetMapControlPointsNV.version = '1.1'
glGetMapControlPointsNV.category = 'GL_NV_evaluators'
glGetMapControlPointsNV.trace = True
glGetMapControlPointsNV.play = True
gl.add(glGetMapControlPointsNV)

glGetMapParameterfvNV = Function('glGetMapParameterfvNV')
glGetMapParameterfvNV.ret = Return('void')
glGetMapParameterfvNV.add( Input( 'target','GLenum' ))
glGetMapParameterfvNV.add( Input( 'pname','GLenum' ))
glGetMapParameterfvNV.add( Output( 'params','GLfloat *' ))
glGetMapParameterfvNV.version = '1.1'
glGetMapParameterfvNV.category = 'GL_NV_evaluators'
glGetMapParameterfvNV.trace = True
glGetMapParameterfvNV.play = True
gl.add(glGetMapParameterfvNV)

glGetMapParameterivNV = Function('glGetMapParameterivNV')
glGetMapParameterivNV.ret = Return('void')
glGetMapParameterivNV.add( Input( 'target','GLenum' ))
glGetMapParameterivNV.add( Input( 'pname','GLenum' ))
glGetMapParameterivNV.add( Output( 'params','GLint *' ))
glGetMapParameterivNV.version = '1.1'
glGetMapParameterivNV.category = 'GL_NV_evaluators'
glGetMapParameterivNV.trace = True
glGetMapParameterivNV.play = True
gl.add(glGetMapParameterivNV)

glMapControlPointsNV = Function('glMapControlPointsNV')
glMapControlPointsNV.ret = Return('void')
glMapControlPointsNV.add( Input( 'target','GLenum' ))
glMapControlPointsNV.add( Input( 'index','GLuint' ))
glMapControlPointsNV.add( Input( 'type','GLenum' ))
glMapControlPointsNV.add( Input( 'ustride','GLsizei' ))
glMapControlPointsNV.add( Input( 'vstride','GLsizei' ))
glMapControlPointsNV.add( Input( 'uorder','GLint' ))
glMapControlPointsNV.add( Input( 'vorder','GLint' ))
glMapControlPointsNV.add( Input( 'packed','GLboolean' ))
glMapControlPointsNV.add( Input( 'points','const GLvoid *' ))
glMapControlPointsNV.version = '1.1'
glMapControlPointsNV.category = 'GL_NV_evaluators'
glMapControlPointsNV.trace = True
glMapControlPointsNV.play = True
gl.add(glMapControlPointsNV)

glMapParameterfvNV = Function('glMapParameterfvNV')
glMapParameterfvNV.ret = Return('void')
glMapParameterfvNV.add( Input( 'target','GLenum' ))
glMapParameterfvNV.add( Input( 'pname','GLenum' ))
glMapParameterfvNV.add( Input( 'params','const GLfloat *' ))
glMapParameterfvNV.version = '1.1'
glMapParameterfvNV.category = 'GL_NV_evaluators'
glMapParameterfvNV.trace = True
glMapParameterfvNV.play = True
gl.add(glMapParameterfvNV)

glMapParameterivNV = Function('glMapParameterivNV')
glMapParameterivNV.ret = Return('void')
glMapParameterivNV.add( Input( 'target','GLenum' ))
glMapParameterivNV.add( Input( 'pname','GLenum' ))
glMapParameterivNV.add( Input( 'params','const GLint *' ))
glMapParameterivNV.version = '1.1'
glMapParameterivNV.category = 'GL_NV_evaluators'
glMapParameterivNV.trace = True
glMapParameterivNV.play = True
gl.add(glMapParameterivNV)

# GL_NV_explicit_multisample

glGetMultisamplefvNV = Function('glGetMultisamplefvNV')
glGetMultisamplefvNV.ret = Return('void')
glGetMultisamplefvNV.add( Input( 'pname','GLenum' ))
glGetMultisamplefvNV.add( Input( 'index','GLuint' ))
glGetMultisamplefvNV.add( Output( 'val','GLfloat *' ,size = 2 ))
glGetMultisamplefvNV.version = '2.0'
glGetMultisamplefvNV.category = 'GL_NV_explicit_multisample'
glGetMultisamplefvNV.trace = True
glGetMultisamplefvNV.play = True
gl.add(glGetMultisamplefvNV)

glSampleMaskIndexedNV = Function('glSampleMaskIndexedNV')
glSampleMaskIndexedNV.ret = Return('void')
glSampleMaskIndexedNV.add( Input( 'index','GLuint' ))
glSampleMaskIndexedNV.add( Input( 'mask','GLbitfield' ))
glSampleMaskIndexedNV.version = '2.0'
glSampleMaskIndexedNV.category = 'GL_NV_explicit_multisample'
glSampleMaskIndexedNV.trace = True
glSampleMaskIndexedNV.play = True
gl.add(glSampleMaskIndexedNV)

glTexRenderbufferNV = Function('glTexRenderbufferNV')
glTexRenderbufferNV.ret = Return('void')
glTexRenderbufferNV.add( Input( 'target','GLenum' ))
glTexRenderbufferNV.add( Input( 'renderbuffer','GLuint' ))
glTexRenderbufferNV.version = '2.0'
glTexRenderbufferNV.category = 'GL_NV_explicit_multisample'
glTexRenderbufferNV.trace = True
glTexRenderbufferNV.play = True
gl.add(glTexRenderbufferNV)

# GL_NV_fence

glDeleteFencesNV = Function('glDeleteFencesNV')
glDeleteFencesNV.ret = Return('void')
glDeleteFencesNV.add( Input( 'n','GLsizei' ))
glDeleteFencesNV.add( Input( 'fences','const GLuint *' ,size = 'n' ))
glDeleteFencesNV.version = '1.2'
glDeleteFencesNV.category = 'GL_NV_fence'
glDeleteFencesNV.trace = True
glDeleteFencesNV.play = True
gl.add(glDeleteFencesNV)

glFinishFenceNV = Function('glFinishFenceNV')
glFinishFenceNV.ret = Return('void')
glFinishFenceNV.add( Input( 'fence','GLuint' ))
glFinishFenceNV.version = '1.2'
glFinishFenceNV.category = 'GL_NV_fence'
glFinishFenceNV.trace = True
glFinishFenceNV.play = True
gl.add(glFinishFenceNV)

glGenFencesNV = Function('glGenFencesNV')
glGenFencesNV.ret = Return('void')
glGenFencesNV.add( Input( 'n','GLsizei' ))
glGenFencesNV.add( Output( 'fences','GLuint *' ,size = 'n' ))
glGenFencesNV.version = '1.2'
glGenFencesNV.category = 'GL_NV_fence'
glGenFencesNV.trace = True
glGenFencesNV.play = True
gl.add(glGenFencesNV)

glGetFenceivNV = Function('glGetFenceivNV')
glGetFenceivNV.ret = Return('void')
glGetFenceivNV.add( Input( 'fence','GLuint' ))
glGetFenceivNV.add( Input( 'pname','GLenum' ))
glGetFenceivNV.add( Output( 'params','GLint *' ))
glGetFenceivNV.version = '1.2'
glGetFenceivNV.category = 'GL_NV_fence'
glGetFenceivNV.trace = True
glGetFenceivNV.play = True
gl.add(glGetFenceivNV)

glIsFenceNV = Function('glIsFenceNV')
glIsFenceNV.ret = Return('GLboolean')
glIsFenceNV.add( Input( 'fence','GLuint' ))
glIsFenceNV.version = '1.2'
glIsFenceNV.category = 'GL_NV_fence'
glIsFenceNV.trace = True
glIsFenceNV.play = True
gl.add(glIsFenceNV)

glSetFenceNV = Function('glSetFenceNV')
glSetFenceNV.ret = Return('void')
glSetFenceNV.add( Input( 'fence','GLuint' ))
glSetFenceNV.add( Input( 'condition','GLenum' ))
glSetFenceNV.version = '1.2'
glSetFenceNV.category = 'GL_NV_fence'
glSetFenceNV.trace = True
glSetFenceNV.play = True
gl.add(glSetFenceNV)

glTestFenceNV = Function('glTestFenceNV')
glTestFenceNV.ret = Return('GLboolean')
glTestFenceNV.add( Input( 'fence','GLuint' ))
glTestFenceNV.version = '1.2'
glTestFenceNV.category = 'GL_NV_fence'
glTestFenceNV.trace = True
glTestFenceNV.play = True
gl.add(glTestFenceNV)

# GL_NV_fragment_program

glGetProgramNamedParameterdvNV = Function('glGetProgramNamedParameterdvNV')
glGetProgramNamedParameterdvNV.ret = Return('void')
glGetProgramNamedParameterdvNV.add( Input( 'id','GLuint' ))
glGetProgramNamedParameterdvNV.add( Input( 'len','GLsizei' ))
glGetProgramNamedParameterdvNV.add( Input( 'name','const GLubyte *' ,size = 1 ))
glGetProgramNamedParameterdvNV.add( Output( 'params','GLdouble *' ,size = 4 ))
glGetProgramNamedParameterdvNV.version = '1.2'
glGetProgramNamedParameterdvNV.category = 'GL_NV_fragment_program'
glGetProgramNamedParameterdvNV.trace = True
glGetProgramNamedParameterdvNV.play = True
gl.add(glGetProgramNamedParameterdvNV)

glGetProgramNamedParameterfvNV = Function('glGetProgramNamedParameterfvNV')
glGetProgramNamedParameterfvNV.ret = Return('void')
glGetProgramNamedParameterfvNV.add( Input( 'id','GLuint' ))
glGetProgramNamedParameterfvNV.add( Input( 'len','GLsizei' ))
glGetProgramNamedParameterfvNV.add( Input( 'name','const GLubyte *' ,size = 1 ))
glGetProgramNamedParameterfvNV.add( Output( 'params','GLfloat *' ,size = 4 ))
glGetProgramNamedParameterfvNV.version = '1.2'
glGetProgramNamedParameterfvNV.category = 'GL_NV_fragment_program'
glGetProgramNamedParameterfvNV.trace = True
glGetProgramNamedParameterfvNV.play = True
gl.add(glGetProgramNamedParameterfvNV)

glProgramNamedParameter4dNV = Function('glProgramNamedParameter4dNV')
glProgramNamedParameter4dNV.ret = Return('void')
glProgramNamedParameter4dNV.add( Input( 'id','GLuint' ))
glProgramNamedParameter4dNV.add( Input( 'len','GLsizei' ))
glProgramNamedParameter4dNV.add( Input( 'name','const GLubyte *' ,size = 1 ))
glProgramNamedParameter4dNV.add( Input( 'x','GLdouble' ))
glProgramNamedParameter4dNV.add( Input( 'y','GLdouble' ))
glProgramNamedParameter4dNV.add( Input( 'z','GLdouble' ))
glProgramNamedParameter4dNV.add( Input( 'w','GLdouble' ))
glProgramNamedParameter4dNV.version = '1.2'
glProgramNamedParameter4dNV.category = 'GL_NV_fragment_program'
glProgramNamedParameter4dNV.trace = True
glProgramNamedParameter4dNV.play = True
gl.add(glProgramNamedParameter4dNV)

glProgramNamedParameter4dvNV = Function('glProgramNamedParameter4dvNV')
glProgramNamedParameter4dvNV.ret = Return('void')
glProgramNamedParameter4dvNV.add( Input( 'id','GLuint' ))
glProgramNamedParameter4dvNV.add( Input( 'len','GLsizei' ))
glProgramNamedParameter4dvNV.add( Input( 'name','const GLubyte *' ,size = 1 ))
glProgramNamedParameter4dvNV.add( Input( 'v','const GLdouble *' ,size = 4 ))
glProgramNamedParameter4dvNV.version = '1.2'
glProgramNamedParameter4dvNV.category = 'GL_NV_fragment_program'
glProgramNamedParameter4dvNV.trace = True
glProgramNamedParameter4dvNV.play = True
gl.add(glProgramNamedParameter4dvNV)

glProgramNamedParameter4fNV = Function('glProgramNamedParameter4fNV')
glProgramNamedParameter4fNV.ret = Return('void')
glProgramNamedParameter4fNV.add( Input( 'id','GLuint' ))
glProgramNamedParameter4fNV.add( Input( 'len','GLsizei' ))
glProgramNamedParameter4fNV.add( Input( 'name','const GLubyte *' ,size = 1 ))
glProgramNamedParameter4fNV.add( Input( 'x','GLfloat' ))
glProgramNamedParameter4fNV.add( Input( 'y','GLfloat' ))
glProgramNamedParameter4fNV.add( Input( 'z','GLfloat' ))
glProgramNamedParameter4fNV.add( Input( 'w','GLfloat' ))
glProgramNamedParameter4fNV.version = '1.2'
glProgramNamedParameter4fNV.category = 'GL_NV_fragment_program'
glProgramNamedParameter4fNV.trace = True
glProgramNamedParameter4fNV.play = True
gl.add(glProgramNamedParameter4fNV)

glProgramNamedParameter4fvNV = Function('glProgramNamedParameter4fvNV')
glProgramNamedParameter4fvNV.ret = Return('void')
glProgramNamedParameter4fvNV.add( Input( 'id','GLuint' ))
glProgramNamedParameter4fvNV.add( Input( 'len','GLsizei' ))
glProgramNamedParameter4fvNV.add( Input( 'name','const GLubyte *' ,size = 1 ))
glProgramNamedParameter4fvNV.add( Input( 'v','const GLfloat *' ,size = 4 ))
glProgramNamedParameter4fvNV.version = '1.2'
glProgramNamedParameter4fvNV.category = 'GL_NV_fragment_program'
glProgramNamedParameter4fvNV.trace = True
glProgramNamedParameter4fvNV.play = True
gl.add(glProgramNamedParameter4fvNV)

# GL_NV_framebuffer_blit

glBlitFramebufferNV = Function('glBlitFramebufferNV')
glBlitFramebufferNV.ret = Return('void')
glBlitFramebufferNV.add( Input( 'srcX0','GLint' ))
glBlitFramebufferNV.add( Input( 'srcY0','GLint' ))
glBlitFramebufferNV.add( Input( 'srcX1','GLint' ))
glBlitFramebufferNV.add( Input( 'srcY1','GLint' ))
glBlitFramebufferNV.add( Input( 'dstX0','GLint' ))
glBlitFramebufferNV.add( Input( 'dstY0','GLint' ))
glBlitFramebufferNV.add( Input( 'dstX1','GLint' ))
glBlitFramebufferNV.add( Input( 'dstY1','GLint' ))
glBlitFramebufferNV.add( Input( 'mask','GLbitfield' ,regalLog = 'GLblitFramebufferToString(mask)' ))
glBlitFramebufferNV.add( Input( 'filter','GLenum' ))
glBlitFramebufferNV.version = ''
glBlitFramebufferNV.category = 'GL_NV_framebuffer_blit'
glBlitFramebufferNV.trace = True
glBlitFramebufferNV.play = True
gl.add(glBlitFramebufferNV)

# GL_NV_framebuffer_multisample_coverage

glRenderbufferStorageMultisampleCoverageNV = Function('glRenderbufferStorageMultisampleCoverageNV')
glRenderbufferStorageMultisampleCoverageNV.ret = Return('void')
glRenderbufferStorageMultisampleCoverageNV.add( Input( 'target','GLenum' ))
glRenderbufferStorageMultisampleCoverageNV.add( Input( 'coverageSamples','GLsizei' ))
glRenderbufferStorageMultisampleCoverageNV.add( Input( 'colorSamples','GLsizei' ))
glRenderbufferStorageMultisampleCoverageNV.add( Input( 'internalformat','GLenum' ))
glRenderbufferStorageMultisampleCoverageNV.add( Input( 'width','GLsizei' ))
glRenderbufferStorageMultisampleCoverageNV.add( Input( 'height','GLsizei' ))
glRenderbufferStorageMultisampleCoverageNV.version = '1.5'
glRenderbufferStorageMultisampleCoverageNV.category = 'GL_NV_framebuffer_multisample_coverage'
glRenderbufferStorageMultisampleCoverageNV.trace = True
glRenderbufferStorageMultisampleCoverageNV.play = True
gl.add(glRenderbufferStorageMultisampleCoverageNV)

# GL_NV_geometry_program4

glProgramVertexLimitNV = Function('glProgramVertexLimitNV')
glProgramVertexLimitNV.ret = Return('void')
glProgramVertexLimitNV.add( Input( 'target','GLenum' ))
glProgramVertexLimitNV.add( Input( 'limit','GLint' ))
glProgramVertexLimitNV.version = '2.0'
glProgramVertexLimitNV.category = 'GL_NV_geometry_program4'
glProgramVertexLimitNV.trace = True
glProgramVertexLimitNV.play = True
gl.add(glProgramVertexLimitNV)

# GL_NV_gpu_program4

glGetProgramEnvParameterIivNV = Function('glGetProgramEnvParameterIivNV')
glGetProgramEnvParameterIivNV.ret = Return('void')
glGetProgramEnvParameterIivNV.add( Input( 'target','GLenum' ))
glGetProgramEnvParameterIivNV.add( Input( 'index','GLuint' ))
glGetProgramEnvParameterIivNV.add( Output( 'params','GLint *' ,size = 4 ))
glGetProgramEnvParameterIivNV.version = '1.3'
glGetProgramEnvParameterIivNV.category = 'GL_NV_gpu_program4'
glGetProgramEnvParameterIivNV.trace = True
glGetProgramEnvParameterIivNV.play = True
gl.add(glGetProgramEnvParameterIivNV)

glGetProgramEnvParameterIuivNV = Function('glGetProgramEnvParameterIuivNV')
glGetProgramEnvParameterIuivNV.ret = Return('void')
glGetProgramEnvParameterIuivNV.add( Input( 'target','GLenum' ))
glGetProgramEnvParameterIuivNV.add( Input( 'index','GLuint' ))
glGetProgramEnvParameterIuivNV.add( Output( 'params','GLuint *' ,size = 4 ))
glGetProgramEnvParameterIuivNV.version = '1.3'
glGetProgramEnvParameterIuivNV.category = 'GL_NV_gpu_program4'
glGetProgramEnvParameterIuivNV.trace = True
glGetProgramEnvParameterIuivNV.play = True
gl.add(glGetProgramEnvParameterIuivNV)

glGetProgramLocalParameterIivNV = Function('glGetProgramLocalParameterIivNV')
glGetProgramLocalParameterIivNV.ret = Return('void')
glGetProgramLocalParameterIivNV.add( Input( 'target','GLenum' ))
glGetProgramLocalParameterIivNV.add( Input( 'index','GLuint' ))
glGetProgramLocalParameterIivNV.add( Output( 'params','GLint *' ,size = 4 ))
glGetProgramLocalParameterIivNV.version = '1.3'
glGetProgramLocalParameterIivNV.category = 'GL_NV_gpu_program4'
glGetProgramLocalParameterIivNV.trace = True
glGetProgramLocalParameterIivNV.play = True
gl.add(glGetProgramLocalParameterIivNV)

glGetProgramLocalParameterIuivNV = Function('glGetProgramLocalParameterIuivNV')
glGetProgramLocalParameterIuivNV.ret = Return('void')
glGetProgramLocalParameterIuivNV.add( Input( 'target','GLenum' ))
glGetProgramLocalParameterIuivNV.add( Input( 'index','GLuint' ))
glGetProgramLocalParameterIuivNV.add( Output( 'params','GLuint *' ,size = 4 ))
glGetProgramLocalParameterIuivNV.version = '1.3'
glGetProgramLocalParameterIuivNV.category = 'GL_NV_gpu_program4'
glGetProgramLocalParameterIuivNV.trace = True
glGetProgramLocalParameterIuivNV.play = True
gl.add(glGetProgramLocalParameterIuivNV)

glProgramEnvParameterI4iNV = Function('glProgramEnvParameterI4iNV')
glProgramEnvParameterI4iNV.ret = Return('void')
glProgramEnvParameterI4iNV.add( Input( 'target','GLenum' ))
glProgramEnvParameterI4iNV.add( Input( 'index','GLuint' ))
glProgramEnvParameterI4iNV.add( Input( 'x','GLint' ))
glProgramEnvParameterI4iNV.add( Input( 'y','GLint' ))
glProgramEnvParameterI4iNV.add( Input( 'z','GLint' ))
glProgramEnvParameterI4iNV.add( Input( 'w','GLint' ))
glProgramEnvParameterI4iNV.version = '1.3'
glProgramEnvParameterI4iNV.category = 'GL_NV_gpu_program4'
glProgramEnvParameterI4iNV.trace = True
glProgramEnvParameterI4iNV.play = True
gl.add(glProgramEnvParameterI4iNV)

glProgramEnvParameterI4ivNV = Function('glProgramEnvParameterI4ivNV')
glProgramEnvParameterI4ivNV.ret = Return('void')
glProgramEnvParameterI4ivNV.add( Input( 'target','GLenum' ))
glProgramEnvParameterI4ivNV.add( Input( 'index','GLuint' ))
glProgramEnvParameterI4ivNV.add( Input( 'params','const GLint *' ,size = 4 ))
glProgramEnvParameterI4ivNV.version = '1.3'
glProgramEnvParameterI4ivNV.category = 'GL_NV_gpu_program4'
glProgramEnvParameterI4ivNV.trace = True
glProgramEnvParameterI4ivNV.play = True
gl.add(glProgramEnvParameterI4ivNV)

glProgramEnvParameterI4uiNV = Function('glProgramEnvParameterI4uiNV')
glProgramEnvParameterI4uiNV.ret = Return('void')
glProgramEnvParameterI4uiNV.add( Input( 'target','GLenum' ))
glProgramEnvParameterI4uiNV.add( Input( 'index','GLuint' ))
glProgramEnvParameterI4uiNV.add( Input( 'x','GLuint' ))
glProgramEnvParameterI4uiNV.add( Input( 'y','GLuint' ))
glProgramEnvParameterI4uiNV.add( Input( 'z','GLuint' ))
glProgramEnvParameterI4uiNV.add( Input( 'w','GLuint' ))
glProgramEnvParameterI4uiNV.version = '1.3'
glProgramEnvParameterI4uiNV.category = 'GL_NV_gpu_program4'
glProgramEnvParameterI4uiNV.trace = True
glProgramEnvParameterI4uiNV.play = True
gl.add(glProgramEnvParameterI4uiNV)

glProgramEnvParameterI4uivNV = Function('glProgramEnvParameterI4uivNV')
glProgramEnvParameterI4uivNV.ret = Return('void')
glProgramEnvParameterI4uivNV.add( Input( 'target','GLenum' ))
glProgramEnvParameterI4uivNV.add( Input( 'index','GLuint' ))
glProgramEnvParameterI4uivNV.add( Input( 'params','const GLuint *' ,size = 4 ))
glProgramEnvParameterI4uivNV.version = '1.3'
glProgramEnvParameterI4uivNV.category = 'GL_NV_gpu_program4'
glProgramEnvParameterI4uivNV.trace = True
glProgramEnvParameterI4uivNV.play = True
gl.add(glProgramEnvParameterI4uivNV)

glProgramEnvParametersI4ivNV = Function('glProgramEnvParametersI4ivNV')
glProgramEnvParametersI4ivNV.ret = Return('void')
glProgramEnvParametersI4ivNV.add( Input( 'target','GLenum' ))
glProgramEnvParametersI4ivNV.add( Input( 'index','GLuint' ))
glProgramEnvParametersI4ivNV.add( Input( 'count','GLsizei' ))
glProgramEnvParametersI4ivNV.add( Input( 'params','const GLint *' ,size = 'count * 4' ))
glProgramEnvParametersI4ivNV.version = '1.3'
glProgramEnvParametersI4ivNV.category = 'GL_NV_gpu_program4'
glProgramEnvParametersI4ivNV.trace = True
glProgramEnvParametersI4ivNV.play = True
gl.add(glProgramEnvParametersI4ivNV)

glProgramEnvParametersI4uivNV = Function('glProgramEnvParametersI4uivNV')
glProgramEnvParametersI4uivNV.ret = Return('void')
glProgramEnvParametersI4uivNV.add( Input( 'target','GLenum' ))
glProgramEnvParametersI4uivNV.add( Input( 'index','GLuint' ))
glProgramEnvParametersI4uivNV.add( Input( 'count','GLsizei' ))
glProgramEnvParametersI4uivNV.add( Input( 'params','const GLuint *' ,size = 'count * 4' ))
glProgramEnvParametersI4uivNV.version = '1.3'
glProgramEnvParametersI4uivNV.category = 'GL_NV_gpu_program4'
glProgramEnvParametersI4uivNV.trace = True
glProgramEnvParametersI4uivNV.play = True
gl.add(glProgramEnvParametersI4uivNV)

glProgramLocalParameterI4iNV = Function('glProgramLocalParameterI4iNV')
glProgramLocalParameterI4iNV.ret = Return('void')
glProgramLocalParameterI4iNV.add( Input( 'target','GLenum' ))
glProgramLocalParameterI4iNV.add( Input( 'index','GLuint' ))
glProgramLocalParameterI4iNV.add( Input( 'x','GLint' ))
glProgramLocalParameterI4iNV.add( Input( 'y','GLint' ))
glProgramLocalParameterI4iNV.add( Input( 'z','GLint' ))
glProgramLocalParameterI4iNV.add( Input( 'w','GLint' ))
glProgramLocalParameterI4iNV.version = '1.3'
glProgramLocalParameterI4iNV.category = 'GL_NV_gpu_program4'
glProgramLocalParameterI4iNV.trace = True
glProgramLocalParameterI4iNV.play = True
gl.add(glProgramLocalParameterI4iNV)

glProgramLocalParameterI4ivNV = Function('glProgramLocalParameterI4ivNV')
glProgramLocalParameterI4ivNV.ret = Return('void')
glProgramLocalParameterI4ivNV.add( Input( 'target','GLenum' ))
glProgramLocalParameterI4ivNV.add( Input( 'index','GLuint' ))
glProgramLocalParameterI4ivNV.add( Input( 'params','const GLint *' ,size = 4 ))
glProgramLocalParameterI4ivNV.version = '1.3'
glProgramLocalParameterI4ivNV.category = 'GL_NV_gpu_program4'
glProgramLocalParameterI4ivNV.trace = True
glProgramLocalParameterI4ivNV.play = True
gl.add(glProgramLocalParameterI4ivNV)

glProgramLocalParameterI4uiNV = Function('glProgramLocalParameterI4uiNV')
glProgramLocalParameterI4uiNV.ret = Return('void')
glProgramLocalParameterI4uiNV.add( Input( 'target','GLenum' ))
glProgramLocalParameterI4uiNV.add( Input( 'index','GLuint' ))
glProgramLocalParameterI4uiNV.add( Input( 'x','GLuint' ))
glProgramLocalParameterI4uiNV.add( Input( 'y','GLuint' ))
glProgramLocalParameterI4uiNV.add( Input( 'z','GLuint' ))
glProgramLocalParameterI4uiNV.add( Input( 'w','GLuint' ))
glProgramLocalParameterI4uiNV.version = '1.3'
glProgramLocalParameterI4uiNV.category = 'GL_NV_gpu_program4'
glProgramLocalParameterI4uiNV.trace = True
glProgramLocalParameterI4uiNV.play = True
gl.add(glProgramLocalParameterI4uiNV)

glProgramLocalParameterI4uivNV = Function('glProgramLocalParameterI4uivNV')
glProgramLocalParameterI4uivNV.ret = Return('void')
glProgramLocalParameterI4uivNV.add( Input( 'target','GLenum' ))
glProgramLocalParameterI4uivNV.add( Input( 'index','GLuint' ))
glProgramLocalParameterI4uivNV.add( Input( 'params','const GLuint *' ,size = 4 ))
glProgramLocalParameterI4uivNV.version = '1.3'
glProgramLocalParameterI4uivNV.category = 'GL_NV_gpu_program4'
glProgramLocalParameterI4uivNV.trace = True
glProgramLocalParameterI4uivNV.play = True
gl.add(glProgramLocalParameterI4uivNV)

glProgramLocalParametersI4ivNV = Function('glProgramLocalParametersI4ivNV')
glProgramLocalParametersI4ivNV.ret = Return('void')
glProgramLocalParametersI4ivNV.add( Input( 'target','GLenum' ))
glProgramLocalParametersI4ivNV.add( Input( 'index','GLuint' ))
glProgramLocalParametersI4ivNV.add( Input( 'count','GLsizei' ))
glProgramLocalParametersI4ivNV.add( Input( 'params','const GLint *' ,size = 'count * 4' ))
glProgramLocalParametersI4ivNV.version = '1.3'
glProgramLocalParametersI4ivNV.category = 'GL_NV_gpu_program4'
glProgramLocalParametersI4ivNV.trace = True
glProgramLocalParametersI4ivNV.play = True
gl.add(glProgramLocalParametersI4ivNV)

glProgramLocalParametersI4uivNV = Function('glProgramLocalParametersI4uivNV')
glProgramLocalParametersI4uivNV.ret = Return('void')
glProgramLocalParametersI4uivNV.add( Input( 'target','GLenum' ))
glProgramLocalParametersI4uivNV.add( Input( 'index','GLuint' ))
glProgramLocalParametersI4uivNV.add( Input( 'count','GLsizei' ))
glProgramLocalParametersI4uivNV.add( Input( 'params','const GLuint *' ,size = 'count * 4' ))
glProgramLocalParametersI4uivNV.version = '1.3'
glProgramLocalParametersI4uivNV.category = 'GL_NV_gpu_program4'
glProgramLocalParametersI4uivNV.trace = True
glProgramLocalParametersI4uivNV.play = True
gl.add(glProgramLocalParametersI4uivNV)

# GL_NV_gpu_shader5

glGetUniformi64vNV = Function('glGetUniformi64vNV')
glGetUniformi64vNV.ret = Return('void')
glGetUniformi64vNV.add( Input( 'program','GLuint' ))
glGetUniformi64vNV.add( Input( 'location','GLint' ))
glGetUniformi64vNV.add( Output( 'params','GLint64EXT *' ))
glGetUniformi64vNV.version = '2.0'
glGetUniformi64vNV.category = 'GL_NV_gpu_shader5'
glGetUniformi64vNV.trace = True
glGetUniformi64vNV.play = True
gl.add(glGetUniformi64vNV)

glProgramUniform1i64NV = Function('glProgramUniform1i64NV')
glProgramUniform1i64NV.ret = Return('void')
glProgramUniform1i64NV.add( Input( 'program','GLuint' ))
glProgramUniform1i64NV.add( Input( 'location','GLint' ))
glProgramUniform1i64NV.add( Input( 'x','GLint64EXT' ))
glProgramUniform1i64NV.version = '2.0'
glProgramUniform1i64NV.category = 'GL_NV_gpu_shader5'
glProgramUniform1i64NV.trace = True
glProgramUniform1i64NV.play = True
gl.add(glProgramUniform1i64NV)

glProgramUniform1i64vNV = Function('glProgramUniform1i64vNV')
glProgramUniform1i64vNV.ret = Return('void')
glProgramUniform1i64vNV.add( Input( 'program','GLuint' ))
glProgramUniform1i64vNV.add( Input( 'location','GLint' ))
glProgramUniform1i64vNV.add( Input( 'count','GLsizei' ))
glProgramUniform1i64vNV.add( Input( 'value','const GLint64EXT *' ,size = 'count' ))
glProgramUniform1i64vNV.version = '2.0'
glProgramUniform1i64vNV.category = 'GL_NV_gpu_shader5'
glProgramUniform1i64vNV.trace = True
glProgramUniform1i64vNV.play = True
gl.add(glProgramUniform1i64vNV)

glProgramUniform1ui64NV = Function('glProgramUniform1ui64NV')
glProgramUniform1ui64NV.ret = Return('void')
glProgramUniform1ui64NV.add( Input( 'program','GLuint' ))
glProgramUniform1ui64NV.add( Input( 'location','GLint' ))
glProgramUniform1ui64NV.add( Input( 'x','GLuint64EXT' ))
glProgramUniform1ui64NV.version = '2.0'
glProgramUniform1ui64NV.category = 'GL_NV_gpu_shader5'
glProgramUniform1ui64NV.trace = True
glProgramUniform1ui64NV.play = True
gl.add(glProgramUniform1ui64NV)

glProgramUniform1ui64vNV = Function('glProgramUniform1ui64vNV')
glProgramUniform1ui64vNV.ret = Return('void')
glProgramUniform1ui64vNV.add( Input( 'program','GLuint' ))
glProgramUniform1ui64vNV.add( Input( 'location','GLint' ))
glProgramUniform1ui64vNV.add( Input( 'count','GLsizei' ))
glProgramUniform1ui64vNV.add( Input( 'value','const GLuint64EXT *' ,size = 'count' ))
glProgramUniform1ui64vNV.version = '2.0'
glProgramUniform1ui64vNV.category = 'GL_NV_gpu_shader5'
glProgramUniform1ui64vNV.trace = True
glProgramUniform1ui64vNV.play = True
gl.add(glProgramUniform1ui64vNV)

glProgramUniform2i64NV = Function('glProgramUniform2i64NV')
glProgramUniform2i64NV.ret = Return('void')
glProgramUniform2i64NV.add( Input( 'program','GLuint' ))
glProgramUniform2i64NV.add( Input( 'location','GLint' ))
glProgramUniform2i64NV.add( Input( 'x','GLint64EXT' ))
glProgramUniform2i64NV.add( Input( 'y','GLint64EXT' ))
glProgramUniform2i64NV.version = '2.0'
glProgramUniform2i64NV.category = 'GL_NV_gpu_shader5'
glProgramUniform2i64NV.trace = True
glProgramUniform2i64NV.play = True
gl.add(glProgramUniform2i64NV)

glProgramUniform2i64vNV = Function('glProgramUniform2i64vNV')
glProgramUniform2i64vNV.ret = Return('void')
glProgramUniform2i64vNV.add( Input( 'program','GLuint' ))
glProgramUniform2i64vNV.add( Input( 'location','GLint' ))
glProgramUniform2i64vNV.add( Input( 'count','GLsizei' ))
glProgramUniform2i64vNV.add( Input( 'value','const GLint64EXT *' ,size = 'count * 2' ))
glProgramUniform2i64vNV.version = '2.0'
glProgramUniform2i64vNV.category = 'GL_NV_gpu_shader5'
glProgramUniform2i64vNV.trace = True
glProgramUniform2i64vNV.play = True
gl.add(glProgramUniform2i64vNV)

glProgramUniform2ui64NV = Function('glProgramUniform2ui64NV')
glProgramUniform2ui64NV.ret = Return('void')
glProgramUniform2ui64NV.add( Input( 'program','GLuint' ))
glProgramUniform2ui64NV.add( Input( 'location','GLint' ))
glProgramUniform2ui64NV.add( Input( 'x','GLuint64EXT' ))
glProgramUniform2ui64NV.add( Input( 'y','GLuint64EXT' ))
glProgramUniform2ui64NV.version = '2.0'
glProgramUniform2ui64NV.category = 'GL_NV_gpu_shader5'
glProgramUniform2ui64NV.trace = True
glProgramUniform2ui64NV.play = True
gl.add(glProgramUniform2ui64NV)

glProgramUniform2ui64vNV = Function('glProgramUniform2ui64vNV')
glProgramUniform2ui64vNV.ret = Return('void')
glProgramUniform2ui64vNV.add( Input( 'program','GLuint' ))
glProgramUniform2ui64vNV.add( Input( 'location','GLint' ))
glProgramUniform2ui64vNV.add( Input( 'count','GLsizei' ))
glProgramUniform2ui64vNV.add( Input( 'value','const GLuint64EXT *' ,size = 'count * 2' ))
glProgramUniform2ui64vNV.version = '2.0'
glProgramUniform2ui64vNV.category = 'GL_NV_gpu_shader5'
glProgramUniform2ui64vNV.trace = True
glProgramUniform2ui64vNV.play = True
gl.add(glProgramUniform2ui64vNV)

glProgramUniform3i64NV = Function('glProgramUniform3i64NV')
glProgramUniform3i64NV.ret = Return('void')
glProgramUniform3i64NV.add( Input( 'program','GLuint' ))
glProgramUniform3i64NV.add( Input( 'location','GLint' ))
glProgramUniform3i64NV.add( Input( 'x','GLint64EXT' ))
glProgramUniform3i64NV.add( Input( 'y','GLint64EXT' ))
glProgramUniform3i64NV.add( Input( 'z','GLint64EXT' ))
glProgramUniform3i64NV.version = '2.0'
glProgramUniform3i64NV.category = 'GL_NV_gpu_shader5'
glProgramUniform3i64NV.trace = True
glProgramUniform3i64NV.play = True
gl.add(glProgramUniform3i64NV)

glProgramUniform3i64vNV = Function('glProgramUniform3i64vNV')
glProgramUniform3i64vNV.ret = Return('void')
glProgramUniform3i64vNV.add( Input( 'program','GLuint' ))
glProgramUniform3i64vNV.add( Input( 'location','GLint' ))
glProgramUniform3i64vNV.add( Input( 'count','GLsizei' ))
glProgramUniform3i64vNV.add( Input( 'value','const GLint64EXT *' ,size = 'count * 3' ))
glProgramUniform3i64vNV.version = '2.0'
glProgramUniform3i64vNV.category = 'GL_NV_gpu_shader5'
glProgramUniform3i64vNV.trace = True
glProgramUniform3i64vNV.play = True
gl.add(glProgramUniform3i64vNV)

glProgramUniform3ui64NV = Function('glProgramUniform3ui64NV')
glProgramUniform3ui64NV.ret = Return('void')
glProgramUniform3ui64NV.add( Input( 'program','GLuint' ))
glProgramUniform3ui64NV.add( Input( 'location','GLint' ))
glProgramUniform3ui64NV.add( Input( 'x','GLuint64EXT' ))
glProgramUniform3ui64NV.add( Input( 'y','GLuint64EXT' ))
glProgramUniform3ui64NV.add( Input( 'z','GLuint64EXT' ))
glProgramUniform3ui64NV.version = '2.0'
glProgramUniform3ui64NV.category = 'GL_NV_gpu_shader5'
glProgramUniform3ui64NV.trace = True
glProgramUniform3ui64NV.play = True
gl.add(glProgramUniform3ui64NV)

glProgramUniform3ui64vNV = Function('glProgramUniform3ui64vNV')
glProgramUniform3ui64vNV.ret = Return('void')
glProgramUniform3ui64vNV.add( Input( 'program','GLuint' ))
glProgramUniform3ui64vNV.add( Input( 'location','GLint' ))
glProgramUniform3ui64vNV.add( Input( 'count','GLsizei' ))
glProgramUniform3ui64vNV.add( Input( 'value','const GLuint64EXT *' ,size = 'count * 3' ))
glProgramUniform3ui64vNV.version = '2.0'
glProgramUniform3ui64vNV.category = 'GL_NV_gpu_shader5'
glProgramUniform3ui64vNV.trace = True
glProgramUniform3ui64vNV.play = True
gl.add(glProgramUniform3ui64vNV)

glProgramUniform4i64NV = Function('glProgramUniform4i64NV')
glProgramUniform4i64NV.ret = Return('void')
glProgramUniform4i64NV.add( Input( 'program','GLuint' ))
glProgramUniform4i64NV.add( Input( 'location','GLint' ))
glProgramUniform4i64NV.add( Input( 'x','GLint64EXT' ))
glProgramUniform4i64NV.add( Input( 'y','GLint64EXT' ))
glProgramUniform4i64NV.add( Input( 'z','GLint64EXT' ))
glProgramUniform4i64NV.add( Input( 'w','GLint64EXT' ))
glProgramUniform4i64NV.version = '2.0'
glProgramUniform4i64NV.category = 'GL_NV_gpu_shader5'
glProgramUniform4i64NV.trace = True
glProgramUniform4i64NV.play = True
gl.add(glProgramUniform4i64NV)

glProgramUniform4i64vNV = Function('glProgramUniform4i64vNV')
glProgramUniform4i64vNV.ret = Return('void')
glProgramUniform4i64vNV.add( Input( 'program','GLuint' ))
glProgramUniform4i64vNV.add( Input( 'location','GLint' ))
glProgramUniform4i64vNV.add( Input( 'count','GLsizei' ))
glProgramUniform4i64vNV.add( Input( 'value','const GLint64EXT *' ,size = 'count * 4' ))
glProgramUniform4i64vNV.version = '2.0'
glProgramUniform4i64vNV.category = 'GL_NV_gpu_shader5'
glProgramUniform4i64vNV.trace = True
glProgramUniform4i64vNV.play = True
gl.add(glProgramUniform4i64vNV)

glProgramUniform4ui64NV = Function('glProgramUniform4ui64NV')
glProgramUniform4ui64NV.ret = Return('void')
glProgramUniform4ui64NV.add( Input( 'program','GLuint' ))
glProgramUniform4ui64NV.add( Input( 'location','GLint' ))
glProgramUniform4ui64NV.add( Input( 'x','GLuint64EXT' ))
glProgramUniform4ui64NV.add( Input( 'y','GLuint64EXT' ))
glProgramUniform4ui64NV.add( Input( 'z','GLuint64EXT' ))
glProgramUniform4ui64NV.add( Input( 'w','GLuint64EXT' ))
glProgramUniform4ui64NV.version = '2.0'
glProgramUniform4ui64NV.category = 'GL_NV_gpu_shader5'
glProgramUniform4ui64NV.trace = True
glProgramUniform4ui64NV.play = True
gl.add(glProgramUniform4ui64NV)

glProgramUniform4ui64vNV = Function('glProgramUniform4ui64vNV')
glProgramUniform4ui64vNV.ret = Return('void')
glProgramUniform4ui64vNV.add( Input( 'program','GLuint' ))
glProgramUniform4ui64vNV.add( Input( 'location','GLint' ))
glProgramUniform4ui64vNV.add( Input( 'count','GLsizei' ))
glProgramUniform4ui64vNV.add( Input( 'value','const GLuint64EXT *' ,size = 'count * 4' ))
glProgramUniform4ui64vNV.version = '2.0'
glProgramUniform4ui64vNV.category = 'GL_NV_gpu_shader5'
glProgramUniform4ui64vNV.trace = True
glProgramUniform4ui64vNV.play = True
gl.add(glProgramUniform4ui64vNV)

glUniform1i64NV = Function('glUniform1i64NV')
glUniform1i64NV.ret = Return('void')
glUniform1i64NV.add( Input( 'location','GLint' ))
glUniform1i64NV.add( Input( 'x','GLint64EXT' ))
glUniform1i64NV.version = '2.0'
glUniform1i64NV.category = 'GL_NV_gpu_shader5'
glUniform1i64NV.trace = True
glUniform1i64NV.play = True
gl.add(glUniform1i64NV)

glUniform1i64vNV = Function('glUniform1i64vNV')
glUniform1i64vNV.ret = Return('void')
glUniform1i64vNV.add( Input( 'location','GLint' ))
glUniform1i64vNV.add( Input( 'count','GLsizei' ))
glUniform1i64vNV.add( Input( 'value','const GLint64EXT *' ,size = 'count' ))
glUniform1i64vNV.version = '2.0'
glUniform1i64vNV.category = 'GL_NV_gpu_shader5'
glUniform1i64vNV.trace = True
glUniform1i64vNV.play = True
gl.add(glUniform1i64vNV)

glUniform1ui64NV = Function('glUniform1ui64NV')
glUniform1ui64NV.ret = Return('void')
glUniform1ui64NV.add( Input( 'location','GLint' ))
glUniform1ui64NV.add( Input( 'x','GLuint64EXT' ))
glUniform1ui64NV.version = '2.0'
glUniform1ui64NV.category = 'GL_NV_gpu_shader5'
glUniform1ui64NV.trace = True
glUniform1ui64NV.play = True
gl.add(glUniform1ui64NV)

glUniform1ui64vNV = Function('glUniform1ui64vNV')
glUniform1ui64vNV.ret = Return('void')
glUniform1ui64vNV.add( Input( 'location','GLint' ))
glUniform1ui64vNV.add( Input( 'count','GLsizei' ))
glUniform1ui64vNV.add( Input( 'value','const GLuint64EXT *' ,size = 'count' ))
glUniform1ui64vNV.version = '2.0'
glUniform1ui64vNV.category = 'GL_NV_gpu_shader5'
glUniform1ui64vNV.trace = True
glUniform1ui64vNV.play = True
gl.add(glUniform1ui64vNV)

glUniform2i64NV = Function('glUniform2i64NV')
glUniform2i64NV.ret = Return('void')
glUniform2i64NV.add( Input( 'location','GLint' ))
glUniform2i64NV.add( Input( 'x','GLint64EXT' ))
glUniform2i64NV.add( Input( 'y','GLint64EXT' ))
glUniform2i64NV.version = '2.0'
glUniform2i64NV.category = 'GL_NV_gpu_shader5'
glUniform2i64NV.trace = True
glUniform2i64NV.play = True
gl.add(glUniform2i64NV)

glUniform2i64vNV = Function('glUniform2i64vNV')
glUniform2i64vNV.ret = Return('void')
glUniform2i64vNV.add( Input( 'location','GLint' ))
glUniform2i64vNV.add( Input( 'count','GLsizei' ))
glUniform2i64vNV.add( Input( 'value','const GLint64EXT *' ,size = 'count * 2' ))
glUniform2i64vNV.version = '2.0'
glUniform2i64vNV.category = 'GL_NV_gpu_shader5'
glUniform2i64vNV.trace = True
glUniform2i64vNV.play = True
gl.add(glUniform2i64vNV)

glUniform2ui64NV = Function('glUniform2ui64NV')
glUniform2ui64NV.ret = Return('void')
glUniform2ui64NV.add( Input( 'location','GLint' ))
glUniform2ui64NV.add( Input( 'x','GLuint64EXT' ))
glUniform2ui64NV.add( Input( 'y','GLuint64EXT' ))
glUniform2ui64NV.version = '2.0'
glUniform2ui64NV.category = 'GL_NV_gpu_shader5'
glUniform2ui64NV.trace = True
glUniform2ui64NV.play = True
gl.add(glUniform2ui64NV)

glUniform2ui64vNV = Function('glUniform2ui64vNV')
glUniform2ui64vNV.ret = Return('void')
glUniform2ui64vNV.add( Input( 'location','GLint' ))
glUniform2ui64vNV.add( Input( 'count','GLsizei' ))
glUniform2ui64vNV.add( Input( 'value','const GLuint64EXT *' ,size = 'count * 2' ))
glUniform2ui64vNV.version = '2.0'
glUniform2ui64vNV.category = 'GL_NV_gpu_shader5'
glUniform2ui64vNV.trace = True
glUniform2ui64vNV.play = True
gl.add(glUniform2ui64vNV)

glUniform3i64NV = Function('glUniform3i64NV')
glUniform3i64NV.ret = Return('void')
glUniform3i64NV.add( Input( 'location','GLint' ))
glUniform3i64NV.add( Input( 'x','GLint64EXT' ))
glUniform3i64NV.add( Input( 'y','GLint64EXT' ))
glUniform3i64NV.add( Input( 'z','GLint64EXT' ))
glUniform3i64NV.version = '2.0'
glUniform3i64NV.category = 'GL_NV_gpu_shader5'
glUniform3i64NV.trace = True
glUniform3i64NV.play = True
gl.add(glUniform3i64NV)

glUniform3i64vNV = Function('glUniform3i64vNV')
glUniform3i64vNV.ret = Return('void')
glUniform3i64vNV.add( Input( 'location','GLint' ))
glUniform3i64vNV.add( Input( 'count','GLsizei' ))
glUniform3i64vNV.add( Input( 'value','const GLint64EXT *' ,size = 'count * 3' ))
glUniform3i64vNV.version = '2.0'
glUniform3i64vNV.category = 'GL_NV_gpu_shader5'
glUniform3i64vNV.trace = True
glUniform3i64vNV.play = True
gl.add(glUniform3i64vNV)

glUniform3ui64NV = Function('glUniform3ui64NV')
glUniform3ui64NV.ret = Return('void')
glUniform3ui64NV.add( Input( 'location','GLint' ))
glUniform3ui64NV.add( Input( 'x','GLuint64EXT' ))
glUniform3ui64NV.add( Input( 'y','GLuint64EXT' ))
glUniform3ui64NV.add( Input( 'z','GLuint64EXT' ))
glUniform3ui64NV.version = '2.0'
glUniform3ui64NV.category = 'GL_NV_gpu_shader5'
glUniform3ui64NV.trace = True
glUniform3ui64NV.play = True
gl.add(glUniform3ui64NV)

glUniform3ui64vNV = Function('glUniform3ui64vNV')
glUniform3ui64vNV.ret = Return('void')
glUniform3ui64vNV.add( Input( 'location','GLint' ))
glUniform3ui64vNV.add( Input( 'count','GLsizei' ))
glUniform3ui64vNV.add( Input( 'value','const GLuint64EXT *' ,size = 'count * 3' ))
glUniform3ui64vNV.version = '2.0'
glUniform3ui64vNV.category = 'GL_NV_gpu_shader5'
glUniform3ui64vNV.trace = True
glUniform3ui64vNV.play = True
gl.add(glUniform3ui64vNV)

glUniform4i64NV = Function('glUniform4i64NV')
glUniform4i64NV.ret = Return('void')
glUniform4i64NV.add( Input( 'location','GLint' ))
glUniform4i64NV.add( Input( 'x','GLint64EXT' ))
glUniform4i64NV.add( Input( 'y','GLint64EXT' ))
glUniform4i64NV.add( Input( 'z','GLint64EXT' ))
glUniform4i64NV.add( Input( 'w','GLint64EXT' ))
glUniform4i64NV.version = '2.0'
glUniform4i64NV.category = 'GL_NV_gpu_shader5'
glUniform4i64NV.trace = True
glUniform4i64NV.play = True
gl.add(glUniform4i64NV)

glUniform4i64vNV = Function('glUniform4i64vNV')
glUniform4i64vNV.ret = Return('void')
glUniform4i64vNV.add( Input( 'location','GLint' ))
glUniform4i64vNV.add( Input( 'count','GLsizei' ))
glUniform4i64vNV.add( Input( 'value','const GLint64EXT *' ,size = 'count * 4' ))
glUniform4i64vNV.version = '2.0'
glUniform4i64vNV.category = 'GL_NV_gpu_shader5'
glUniform4i64vNV.trace = True
glUniform4i64vNV.play = True
gl.add(glUniform4i64vNV)

glUniform4ui64NV = Function('glUniform4ui64NV')
glUniform4ui64NV.ret = Return('void')
glUniform4ui64NV.add( Input( 'location','GLint' ))
glUniform4ui64NV.add( Input( 'x','GLuint64EXT' ))
glUniform4ui64NV.add( Input( 'y','GLuint64EXT' ))
glUniform4ui64NV.add( Input( 'z','GLuint64EXT' ))
glUniform4ui64NV.add( Input( 'w','GLuint64EXT' ))
glUniform4ui64NV.version = '2.0'
glUniform4ui64NV.category = 'GL_NV_gpu_shader5'
glUniform4ui64NV.trace = True
glUniform4ui64NV.play = True
gl.add(glUniform4ui64NV)

glUniform4ui64vNV = Function('glUniform4ui64vNV')
glUniform4ui64vNV.ret = Return('void')
glUniform4ui64vNV.add( Input( 'location','GLint' ))
glUniform4ui64vNV.add( Input( 'count','GLsizei' ))
glUniform4ui64vNV.add( Input( 'value','const GLuint64EXT *' ,size = 'count * 4' ))
glUniform4ui64vNV.version = '2.0'
glUniform4ui64vNV.category = 'GL_NV_gpu_shader5'
glUniform4ui64vNV.trace = True
glUniform4ui64vNV.play = True
gl.add(glUniform4ui64vNV)

# GL_NV_half_float

glColor3hNV = Function('glColor3hNV')
glColor3hNV.ret = Return('void')
glColor3hNV.add( Input( 'red','GLhalfNV' ))
glColor3hNV.add( Input( 'green','GLhalfNV' ))
glColor3hNV.add( Input( 'blue','GLhalfNV' ))
glColor3hNV.version = '1.3'
glColor3hNV.category = 'GL_NV_half_float'
glColor3hNV.trace = True
glColor3hNV.play = True
gl.add(glColor3hNV)

glColor3hvNV = Function('glColor3hvNV')
glColor3hvNV.ret = Return('void')
glColor3hvNV.add( Input( 'v','const GLhalfNV *' ,size = 3 ))
glColor3hvNV.version = '1.3'
glColor3hvNV.category = 'GL_NV_half_float'
glColor3hvNV.trace = True
glColor3hvNV.play = True
gl.add(glColor3hvNV)

glColor4hNV = Function('glColor4hNV')
glColor4hNV.ret = Return('void')
glColor4hNV.add( Input( 'red','GLhalfNV' ))
glColor4hNV.add( Input( 'green','GLhalfNV' ))
glColor4hNV.add( Input( 'blue','GLhalfNV' ))
glColor4hNV.add( Input( 'alpha','GLhalfNV' ))
glColor4hNV.version = '1.3'
glColor4hNV.category = 'GL_NV_half_float'
glColor4hNV.trace = True
glColor4hNV.play = True
gl.add(glColor4hNV)

glColor4hvNV = Function('glColor4hvNV')
glColor4hvNV.ret = Return('void')
glColor4hvNV.add( Input( 'v','const GLhalfNV *' ,size = 4 ))
glColor4hvNV.version = '1.3'
glColor4hvNV.category = 'GL_NV_half_float'
glColor4hvNV.trace = True
glColor4hvNV.play = True
gl.add(glColor4hvNV)

glFogCoordhNV = Function('glFogCoordhNV')
glFogCoordhNV.ret = Return('void')
glFogCoordhNV.add( Input( 'coord','GLhalfNV' ))
glFogCoordhNV.version = '1.3'
glFogCoordhNV.category = 'GL_NV_half_float'
glFogCoordhNV.trace = True
glFogCoordhNV.play = True
gl.add(glFogCoordhNV)

glFogCoordhvNV = Function('glFogCoordhvNV')
glFogCoordhvNV.ret = Return('void')
glFogCoordhvNV.add( Input( 'coord','const GLhalfNV *' ,size = 1 ))
glFogCoordhvNV.version = '1.3'
glFogCoordhvNV.category = 'GL_NV_half_float'
glFogCoordhvNV.trace = True
glFogCoordhvNV.play = True
gl.add(glFogCoordhvNV)

glMultiTexCoord1hNV = Function('glMultiTexCoord1hNV')
glMultiTexCoord1hNV.ret = Return('void')
glMultiTexCoord1hNV.add( Input( 'target','GLenum' ))
glMultiTexCoord1hNV.add( Input( 's','GLhalfNV' ))
glMultiTexCoord1hNV.version = '1.3'
glMultiTexCoord1hNV.category = 'GL_NV_half_float'
glMultiTexCoord1hNV.trace = True
glMultiTexCoord1hNV.play = True
gl.add(glMultiTexCoord1hNV)

glMultiTexCoord1hvNV = Function('glMultiTexCoord1hvNV')
glMultiTexCoord1hvNV.ret = Return('void')
glMultiTexCoord1hvNV.add( Input( 'target','GLenum' ))
glMultiTexCoord1hvNV.add( Input( 'v','const GLhalfNV *' ,size = 1 ))
glMultiTexCoord1hvNV.version = '1.3'
glMultiTexCoord1hvNV.category = 'GL_NV_half_float'
glMultiTexCoord1hvNV.trace = True
glMultiTexCoord1hvNV.play = True
gl.add(glMultiTexCoord1hvNV)

glMultiTexCoord2hNV = Function('glMultiTexCoord2hNV')
glMultiTexCoord2hNV.ret = Return('void')
glMultiTexCoord2hNV.add( Input( 'target','GLenum' ))
glMultiTexCoord2hNV.add( Input( 's','GLhalfNV' ))
glMultiTexCoord2hNV.add( Input( 't','GLhalfNV' ))
glMultiTexCoord2hNV.version = '1.3'
glMultiTexCoord2hNV.category = 'GL_NV_half_float'
glMultiTexCoord2hNV.trace = True
glMultiTexCoord2hNV.play = True
gl.add(glMultiTexCoord2hNV)

glMultiTexCoord2hvNV = Function('glMultiTexCoord2hvNV')
glMultiTexCoord2hvNV.ret = Return('void')
glMultiTexCoord2hvNV.add( Input( 'target','GLenum' ))
glMultiTexCoord2hvNV.add( Input( 'v','const GLhalfNV *' ,size = 2 ))
glMultiTexCoord2hvNV.version = '1.3'
glMultiTexCoord2hvNV.category = 'GL_NV_half_float'
glMultiTexCoord2hvNV.trace = True
glMultiTexCoord2hvNV.play = True
gl.add(glMultiTexCoord2hvNV)

glMultiTexCoord3hNV = Function('glMultiTexCoord3hNV')
glMultiTexCoord3hNV.ret = Return('void')
glMultiTexCoord3hNV.add( Input( 'target','GLenum' ))
glMultiTexCoord3hNV.add( Input( 's','GLhalfNV' ))
glMultiTexCoord3hNV.add( Input( 't','GLhalfNV' ))
glMultiTexCoord3hNV.add( Input( 'r','GLhalfNV' ))
glMultiTexCoord3hNV.version = '1.3'
glMultiTexCoord3hNV.category = 'GL_NV_half_float'
glMultiTexCoord3hNV.trace = True
glMultiTexCoord3hNV.play = True
gl.add(glMultiTexCoord3hNV)

glMultiTexCoord3hvNV = Function('glMultiTexCoord3hvNV')
glMultiTexCoord3hvNV.ret = Return('void')
glMultiTexCoord3hvNV.add( Input( 'target','GLenum' ))
glMultiTexCoord3hvNV.add( Input( 'v','const GLhalfNV *' ,size = 3 ))
glMultiTexCoord3hvNV.version = '1.3'
glMultiTexCoord3hvNV.category = 'GL_NV_half_float'
glMultiTexCoord3hvNV.trace = True
glMultiTexCoord3hvNV.play = True
gl.add(glMultiTexCoord3hvNV)

glMultiTexCoord4hNV = Function('glMultiTexCoord4hNV')
glMultiTexCoord4hNV.ret = Return('void')
glMultiTexCoord4hNV.add( Input( 'target','GLenum' ))
glMultiTexCoord4hNV.add( Input( 's','GLhalfNV' ))
glMultiTexCoord4hNV.add( Input( 't','GLhalfNV' ))
glMultiTexCoord4hNV.add( Input( 'r','GLhalfNV' ))
glMultiTexCoord4hNV.add( Input( 'q','GLhalfNV' ))
glMultiTexCoord4hNV.version = '1.3'
glMultiTexCoord4hNV.category = 'GL_NV_half_float'
glMultiTexCoord4hNV.trace = True
glMultiTexCoord4hNV.play = True
gl.add(glMultiTexCoord4hNV)

glMultiTexCoord4hvNV = Function('glMultiTexCoord4hvNV')
glMultiTexCoord4hvNV.ret = Return('void')
glMultiTexCoord4hvNV.add( Input( 'target','GLenum' ))
glMultiTexCoord4hvNV.add( Input( 'v','const GLhalfNV *' ,size = 4 ))
glMultiTexCoord4hvNV.version = '1.3'
glMultiTexCoord4hvNV.category = 'GL_NV_half_float'
glMultiTexCoord4hvNV.trace = True
glMultiTexCoord4hvNV.play = True
gl.add(glMultiTexCoord4hvNV)

glNormal3hNV = Function('glNormal3hNV')
glNormal3hNV.ret = Return('void')
glNormal3hNV.add( Input( 'nx','GLhalfNV' ))
glNormal3hNV.add( Input( 'ny','GLhalfNV' ))
glNormal3hNV.add( Input( 'nz','GLhalfNV' ))
glNormal3hNV.version = '1.3'
glNormal3hNV.category = 'GL_NV_half_float'
glNormal3hNV.trace = True
glNormal3hNV.play = True
gl.add(glNormal3hNV)

glNormal3hvNV = Function('glNormal3hvNV')
glNormal3hvNV.ret = Return('void')
glNormal3hvNV.add( Input( 'v','const GLhalfNV *' ,size = 3 ))
glNormal3hvNV.version = '1.3'
glNormal3hvNV.category = 'GL_NV_half_float'
glNormal3hvNV.trace = True
glNormal3hvNV.play = True
gl.add(glNormal3hvNV)

glSecondaryColor3hNV = Function('glSecondaryColor3hNV')
glSecondaryColor3hNV.ret = Return('void')
glSecondaryColor3hNV.add( Input( 'red','GLhalfNV' ))
glSecondaryColor3hNV.add( Input( 'green','GLhalfNV' ))
glSecondaryColor3hNV.add( Input( 'blue','GLhalfNV' ))
glSecondaryColor3hNV.version = '1.3'
glSecondaryColor3hNV.category = 'GL_NV_half_float'
glSecondaryColor3hNV.trace = True
glSecondaryColor3hNV.play = True
gl.add(glSecondaryColor3hNV)

glSecondaryColor3hvNV = Function('glSecondaryColor3hvNV')
glSecondaryColor3hvNV.ret = Return('void')
glSecondaryColor3hvNV.add( Input( 'v','const GLhalfNV *' ,size = 3 ))
glSecondaryColor3hvNV.version = '1.3'
glSecondaryColor3hvNV.category = 'GL_NV_half_float'
glSecondaryColor3hvNV.trace = True
glSecondaryColor3hvNV.play = True
gl.add(glSecondaryColor3hvNV)

glTexCoord1hNV = Function('glTexCoord1hNV')
glTexCoord1hNV.ret = Return('void')
glTexCoord1hNV.add( Input( 's','GLhalfNV' ))
glTexCoord1hNV.version = '1.3'
glTexCoord1hNV.category = 'GL_NV_half_float'
glTexCoord1hNV.trace = True
glTexCoord1hNV.play = True
gl.add(glTexCoord1hNV)

glTexCoord1hvNV = Function('glTexCoord1hvNV')
glTexCoord1hvNV.ret = Return('void')
glTexCoord1hvNV.add( Input( 'v','const GLhalfNV *' ,size = 1 ))
glTexCoord1hvNV.version = '1.3'
glTexCoord1hvNV.category = 'GL_NV_half_float'
glTexCoord1hvNV.trace = True
glTexCoord1hvNV.play = True
gl.add(glTexCoord1hvNV)

glTexCoord2hNV = Function('glTexCoord2hNV')
glTexCoord2hNV.ret = Return('void')
glTexCoord2hNV.add( Input( 's','GLhalfNV' ))
glTexCoord2hNV.add( Input( 't','GLhalfNV' ))
glTexCoord2hNV.version = '1.3'
glTexCoord2hNV.category = 'GL_NV_half_float'
glTexCoord2hNV.trace = True
glTexCoord2hNV.play = True
gl.add(glTexCoord2hNV)

glTexCoord2hvNV = Function('glTexCoord2hvNV')
glTexCoord2hvNV.ret = Return('void')
glTexCoord2hvNV.add( Input( 'v','const GLhalfNV *' ,size = 2 ))
glTexCoord2hvNV.version = '1.3'
glTexCoord2hvNV.category = 'GL_NV_half_float'
glTexCoord2hvNV.trace = True
glTexCoord2hvNV.play = True
gl.add(glTexCoord2hvNV)

glTexCoord3hNV = Function('glTexCoord3hNV')
glTexCoord3hNV.ret = Return('void')
glTexCoord3hNV.add( Input( 's','GLhalfNV' ))
glTexCoord3hNV.add( Input( 't','GLhalfNV' ))
glTexCoord3hNV.add( Input( 'r','GLhalfNV' ))
glTexCoord3hNV.version = '1.3'
glTexCoord3hNV.category = 'GL_NV_half_float'
glTexCoord3hNV.trace = True
glTexCoord3hNV.play = True
gl.add(glTexCoord3hNV)

glTexCoord3hvNV = Function('glTexCoord3hvNV')
glTexCoord3hvNV.ret = Return('void')
glTexCoord3hvNV.add( Input( 'v','const GLhalfNV *' ,size = 3 ))
glTexCoord3hvNV.version = '1.3'
glTexCoord3hvNV.category = 'GL_NV_half_float'
glTexCoord3hvNV.trace = True
glTexCoord3hvNV.play = True
gl.add(glTexCoord3hvNV)

glTexCoord4hNV = Function('glTexCoord4hNV')
glTexCoord4hNV.ret = Return('void')
glTexCoord4hNV.add( Input( 's','GLhalfNV' ))
glTexCoord4hNV.add( Input( 't','GLhalfNV' ))
glTexCoord4hNV.add( Input( 'r','GLhalfNV' ))
glTexCoord4hNV.add( Input( 'q','GLhalfNV' ))
glTexCoord4hNV.version = '1.3'
glTexCoord4hNV.category = 'GL_NV_half_float'
glTexCoord4hNV.trace = True
glTexCoord4hNV.play = True
gl.add(glTexCoord4hNV)

glTexCoord4hvNV = Function('glTexCoord4hvNV')
glTexCoord4hvNV.ret = Return('void')
glTexCoord4hvNV.add( Input( 'v','const GLhalfNV *' ,size = 4 ))
glTexCoord4hvNV.version = '1.3'
glTexCoord4hvNV.category = 'GL_NV_half_float'
glTexCoord4hvNV.trace = True
glTexCoord4hvNV.play = True
gl.add(glTexCoord4hvNV)

glVertex2hNV = Function('glVertex2hNV')
glVertex2hNV.ret = Return('void')
glVertex2hNV.add( Input( 'x','GLhalfNV' ))
glVertex2hNV.add( Input( 'y','GLhalfNV' ))
glVertex2hNV.version = '1.3'
glVertex2hNV.category = 'GL_NV_half_float'
glVertex2hNV.trace = True
glVertex2hNV.play = True
gl.add(glVertex2hNV)

glVertex2hvNV = Function('glVertex2hvNV')
glVertex2hvNV.ret = Return('void')
glVertex2hvNV.add( Input( 'v','const GLhalfNV *' ,size = 2 ))
glVertex2hvNV.version = '1.3'
glVertex2hvNV.category = 'GL_NV_half_float'
glVertex2hvNV.trace = True
glVertex2hvNV.play = True
gl.add(glVertex2hvNV)

glVertex3hNV = Function('glVertex3hNV')
glVertex3hNV.ret = Return('void')
glVertex3hNV.add( Input( 'x','GLhalfNV' ))
glVertex3hNV.add( Input( 'y','GLhalfNV' ))
glVertex3hNV.add( Input( 'z','GLhalfNV' ))
glVertex3hNV.version = '1.3'
glVertex3hNV.category = 'GL_NV_half_float'
glVertex3hNV.trace = True
glVertex3hNV.play = True
gl.add(glVertex3hNV)

glVertex3hvNV = Function('glVertex3hvNV')
glVertex3hvNV.ret = Return('void')
glVertex3hvNV.add( Input( 'v','const GLhalfNV *' ,size = 3 ))
glVertex3hvNV.version = '1.3'
glVertex3hvNV.category = 'GL_NV_half_float'
glVertex3hvNV.trace = True
glVertex3hvNV.play = True
gl.add(glVertex3hvNV)

glVertex4hNV = Function('glVertex4hNV')
glVertex4hNV.ret = Return('void')
glVertex4hNV.add( Input( 'x','GLhalfNV' ))
glVertex4hNV.add( Input( 'y','GLhalfNV' ))
glVertex4hNV.add( Input( 'z','GLhalfNV' ))
glVertex4hNV.add( Input( 'w','GLhalfNV' ))
glVertex4hNV.version = '1.3'
glVertex4hNV.category = 'GL_NV_half_float'
glVertex4hNV.trace = True
glVertex4hNV.play = True
gl.add(glVertex4hNV)

glVertex4hvNV = Function('glVertex4hvNV')
glVertex4hvNV.ret = Return('void')
glVertex4hvNV.add( Input( 'v','const GLhalfNV *' ,size = 4 ))
glVertex4hvNV.version = '1.3'
glVertex4hvNV.category = 'GL_NV_half_float'
glVertex4hvNV.trace = True
glVertex4hvNV.play = True
gl.add(glVertex4hvNV)

glVertexAttrib1hNV = Function('glVertexAttrib1hNV')
glVertexAttrib1hNV.ret = Return('void')
glVertexAttrib1hNV.add( Input( 'index','GLuint' ))
glVertexAttrib1hNV.add( Input( 'x','GLhalfNV' ))
glVertexAttrib1hNV.version = '1.3'
glVertexAttrib1hNV.category = 'GL_NV_half_float'
glVertexAttrib1hNV.trace = True
glVertexAttrib1hNV.play = True
gl.add(glVertexAttrib1hNV)

glVertexAttrib1hvNV = Function('glVertexAttrib1hvNV')
glVertexAttrib1hvNV.ret = Return('void')
glVertexAttrib1hvNV.add( Input( 'index','GLuint' ))
glVertexAttrib1hvNV.add( Input( 'v','const GLhalfNV *' ,size = 1 ))
glVertexAttrib1hvNV.version = '1.3'
glVertexAttrib1hvNV.category = 'GL_NV_half_float'
glVertexAttrib1hvNV.trace = True
glVertexAttrib1hvNV.play = True
gl.add(glVertexAttrib1hvNV)

glVertexAttrib2hNV = Function('glVertexAttrib2hNV')
glVertexAttrib2hNV.ret = Return('void')
glVertexAttrib2hNV.add( Input( 'index','GLuint' ))
glVertexAttrib2hNV.add( Input( 'x','GLhalfNV' ))
glVertexAttrib2hNV.add( Input( 'y','GLhalfNV' ))
glVertexAttrib2hNV.version = '1.3'
glVertexAttrib2hNV.category = 'GL_NV_half_float'
glVertexAttrib2hNV.trace = True
glVertexAttrib2hNV.play = True
gl.add(glVertexAttrib2hNV)

glVertexAttrib2hvNV = Function('glVertexAttrib2hvNV')
glVertexAttrib2hvNV.ret = Return('void')
glVertexAttrib2hvNV.add( Input( 'index','GLuint' ))
glVertexAttrib2hvNV.add( Input( 'v','const GLhalfNV *' ,size = 2 ))
glVertexAttrib2hvNV.version = '1.3'
glVertexAttrib2hvNV.category = 'GL_NV_half_float'
glVertexAttrib2hvNV.trace = True
glVertexAttrib2hvNV.play = True
gl.add(glVertexAttrib2hvNV)

glVertexAttrib3hNV = Function('glVertexAttrib3hNV')
glVertexAttrib3hNV.ret = Return('void')
glVertexAttrib3hNV.add( Input( 'index','GLuint' ))
glVertexAttrib3hNV.add( Input( 'x','GLhalfNV' ))
glVertexAttrib3hNV.add( Input( 'y','GLhalfNV' ))
glVertexAttrib3hNV.add( Input( 'z','GLhalfNV' ))
glVertexAttrib3hNV.version = '1.3'
glVertexAttrib3hNV.category = 'GL_NV_half_float'
glVertexAttrib3hNV.trace = True
glVertexAttrib3hNV.play = True
gl.add(glVertexAttrib3hNV)

glVertexAttrib3hvNV = Function('glVertexAttrib3hvNV')
glVertexAttrib3hvNV.ret = Return('void')
glVertexAttrib3hvNV.add( Input( 'index','GLuint' ))
glVertexAttrib3hvNV.add( Input( 'v','const GLhalfNV *' ,size = 3 ))
glVertexAttrib3hvNV.version = '1.3'
glVertexAttrib3hvNV.category = 'GL_NV_half_float'
glVertexAttrib3hvNV.trace = True
glVertexAttrib3hvNV.play = True
gl.add(glVertexAttrib3hvNV)

glVertexAttrib4hNV = Function('glVertexAttrib4hNV')
glVertexAttrib4hNV.ret = Return('void')
glVertexAttrib4hNV.add( Input( 'index','GLuint' ))
glVertexAttrib4hNV.add( Input( 'x','GLhalfNV' ))
glVertexAttrib4hNV.add( Input( 'y','GLhalfNV' ))
glVertexAttrib4hNV.add( Input( 'z','GLhalfNV' ))
glVertexAttrib4hNV.add( Input( 'w','GLhalfNV' ))
glVertexAttrib4hNV.version = '1.3'
glVertexAttrib4hNV.category = 'GL_NV_half_float'
glVertexAttrib4hNV.trace = True
glVertexAttrib4hNV.play = True
gl.add(glVertexAttrib4hNV)

glVertexAttrib4hvNV = Function('glVertexAttrib4hvNV')
glVertexAttrib4hvNV.ret = Return('void')
glVertexAttrib4hvNV.add( Input( 'index','GLuint' ))
glVertexAttrib4hvNV.add( Input( 'v','const GLhalfNV *' ,size = 4 ))
glVertexAttrib4hvNV.version = '1.3'
glVertexAttrib4hvNV.category = 'GL_NV_half_float'
glVertexAttrib4hvNV.trace = True
glVertexAttrib4hvNV.play = True
gl.add(glVertexAttrib4hvNV)

glVertexAttribs1hvNV = Function('glVertexAttribs1hvNV')
glVertexAttribs1hvNV.ret = Return('void')
glVertexAttribs1hvNV.add( Input( 'index','GLuint' ))
glVertexAttribs1hvNV.add( Input( 'count','GLsizei' ))
glVertexAttribs1hvNV.add( Input( 'v','const GLhalfNV *' ,size = 'count' ))
glVertexAttribs1hvNV.version = '1.3'
glVertexAttribs1hvNV.category = 'GL_NV_half_float'
glVertexAttribs1hvNV.trace = True
glVertexAttribs1hvNV.play = True
gl.add(glVertexAttribs1hvNV)

glVertexAttribs2hvNV = Function('glVertexAttribs2hvNV')
glVertexAttribs2hvNV.ret = Return('void')
glVertexAttribs2hvNV.add( Input( 'index','GLuint' ))
glVertexAttribs2hvNV.add( Input( 'count','GLsizei' ))
glVertexAttribs2hvNV.add( Input( 'v','const GLhalfNV *' ,size = 'count * 2' ))
glVertexAttribs2hvNV.version = '1.3'
glVertexAttribs2hvNV.category = 'GL_NV_half_float'
glVertexAttribs2hvNV.trace = True
glVertexAttribs2hvNV.play = True
gl.add(glVertexAttribs2hvNV)

glVertexAttribs3hvNV = Function('glVertexAttribs3hvNV')
glVertexAttribs3hvNV.ret = Return('void')
glVertexAttribs3hvNV.add( Input( 'index','GLuint' ))
glVertexAttribs3hvNV.add( Input( 'count','GLsizei' ))
glVertexAttribs3hvNV.add( Input( 'v','const GLhalfNV *' ,size = 'count * 3' ))
glVertexAttribs3hvNV.version = '1.3'
glVertexAttribs3hvNV.category = 'GL_NV_half_float'
glVertexAttribs3hvNV.trace = True
glVertexAttribs3hvNV.play = True
gl.add(glVertexAttribs3hvNV)

glVertexAttribs4hvNV = Function('glVertexAttribs4hvNV')
glVertexAttribs4hvNV.ret = Return('void')
glVertexAttribs4hvNV.add( Input( 'index','GLuint' ))
glVertexAttribs4hvNV.add( Input( 'count','GLsizei' ))
glVertexAttribs4hvNV.add( Input( 'v','const GLhalfNV *' ,size = 'count * 4' ))
glVertexAttribs4hvNV.version = '1.3'
glVertexAttribs4hvNV.category = 'GL_NV_half_float'
glVertexAttribs4hvNV.trace = True
glVertexAttribs4hvNV.play = True
gl.add(glVertexAttribs4hvNV)

glVertexWeighthNV = Function('glVertexWeighthNV')
glVertexWeighthNV.ret = Return('void')
glVertexWeighthNV.add( Input( 'weight','GLhalfNV' ))
glVertexWeighthNV.version = '1.3'
glVertexWeighthNV.category = 'GL_NV_half_float'
glVertexWeighthNV.trace = True
glVertexWeighthNV.play = True
gl.add(glVertexWeighthNV)

glVertexWeighthvNV = Function('glVertexWeighthvNV')
glVertexWeighthvNV.ret = Return('void')
glVertexWeighthvNV.add( Input( 'weight','const GLhalfNV *' ,size = 1 ))
glVertexWeighthvNV.version = '1.3'
glVertexWeighthvNV.category = 'GL_NV_half_float'
glVertexWeighthvNV.trace = True
glVertexWeighthvNV.play = True
gl.add(glVertexWeighthvNV)

# GL_NV_non_square_matrices

glUniformMatrix2x3fvNV = Function('glUniformMatrix2x3fvNV')
glUniformMatrix2x3fvNV.ret = Return('void')
glUniformMatrix2x3fvNV.add( Input( 'location','GLint' ))
glUniformMatrix2x3fvNV.add( Input( 'count','GLsizei' ))
glUniformMatrix2x3fvNV.add( Input( 'transpose','GLboolean' ))
glUniformMatrix2x3fvNV.add( Input( 'value','const GLfloat *' ))
glUniformMatrix2x3fvNV.version = ''
glUniformMatrix2x3fvNV.category = 'GL_NV_non_square_matrices'
glUniformMatrix2x3fvNV.trace = True
glUniformMatrix2x3fvNV.play = True
gl.add(glUniformMatrix2x3fvNV)

glUniformMatrix2x4fvNV = Function('glUniformMatrix2x4fvNV')
glUniformMatrix2x4fvNV.ret = Return('void')
glUniformMatrix2x4fvNV.add( Input( 'location','GLint' ))
glUniformMatrix2x4fvNV.add( Input( 'count','GLsizei' ))
glUniformMatrix2x4fvNV.add( Input( 'transpose','GLboolean' ))
glUniformMatrix2x4fvNV.add( Input( 'value','const GLfloat *' ))
glUniformMatrix2x4fvNV.version = ''
glUniformMatrix2x4fvNV.category = 'GL_NV_non_square_matrices'
glUniformMatrix2x4fvNV.trace = True
glUniformMatrix2x4fvNV.play = True
gl.add(glUniformMatrix2x4fvNV)

glUniformMatrix3x2fvNV = Function('glUniformMatrix3x2fvNV')
glUniformMatrix3x2fvNV.ret = Return('void')
glUniformMatrix3x2fvNV.add( Input( 'location','GLint' ))
glUniformMatrix3x2fvNV.add( Input( 'count','GLsizei' ))
glUniformMatrix3x2fvNV.add( Input( 'transpose','GLboolean' ))
glUniformMatrix3x2fvNV.add( Input( 'value','const GLfloat *' ))
glUniformMatrix3x2fvNV.version = ''
glUniformMatrix3x2fvNV.category = 'GL_NV_non_square_matrices'
glUniformMatrix3x2fvNV.trace = True
glUniformMatrix3x2fvNV.play = True
gl.add(glUniformMatrix3x2fvNV)

glUniformMatrix3x4fvNV = Function('glUniformMatrix3x4fvNV')
glUniformMatrix3x4fvNV.ret = Return('void')
glUniformMatrix3x4fvNV.add( Input( 'location','GLint' ))
glUniformMatrix3x4fvNV.add( Input( 'count','GLsizei' ))
glUniformMatrix3x4fvNV.add( Input( 'transpose','GLboolean' ))
glUniformMatrix3x4fvNV.add( Input( 'value','const GLfloat *' ))
glUniformMatrix3x4fvNV.version = ''
glUniformMatrix3x4fvNV.category = 'GL_NV_non_square_matrices'
glUniformMatrix3x4fvNV.trace = True
glUniformMatrix3x4fvNV.play = True
gl.add(glUniformMatrix3x4fvNV)

glUniformMatrix4x2fvNV = Function('glUniformMatrix4x2fvNV')
glUniformMatrix4x2fvNV.ret = Return('void')
glUniformMatrix4x2fvNV.add( Input( 'location','GLint' ))
glUniformMatrix4x2fvNV.add( Input( 'count','GLsizei' ))
glUniformMatrix4x2fvNV.add( Input( 'transpose','GLboolean' ))
glUniformMatrix4x2fvNV.add( Input( 'value','const GLfloat *' ))
glUniformMatrix4x2fvNV.version = ''
glUniformMatrix4x2fvNV.category = 'GL_NV_non_square_matrices'
glUniformMatrix4x2fvNV.trace = True
glUniformMatrix4x2fvNV.play = True
gl.add(glUniformMatrix4x2fvNV)

glUniformMatrix4x3fvNV = Function('glUniformMatrix4x3fvNV')
glUniformMatrix4x3fvNV.ret = Return('void')
glUniformMatrix4x3fvNV.add( Input( 'location','GLint' ))
glUniformMatrix4x3fvNV.add( Input( 'count','GLsizei' ))
glUniformMatrix4x3fvNV.add( Input( 'transpose','GLboolean' ))
glUniformMatrix4x3fvNV.add( Input( 'value','const GLfloat *' ))
glUniformMatrix4x3fvNV.version = ''
glUniformMatrix4x3fvNV.category = 'GL_NV_non_square_matrices'
glUniformMatrix4x3fvNV.trace = True
glUniformMatrix4x3fvNV.play = True
gl.add(glUniformMatrix4x3fvNV)

# GL_NV_occlusion_query

glBeginOcclusionQueryNV = Function('glBeginOcclusionQueryNV')
glBeginOcclusionQueryNV.ret = Return('void')
glBeginOcclusionQueryNV.add( Input( 'id','GLuint' ))
glBeginOcclusionQueryNV.version = '1.2'
glBeginOcclusionQueryNV.category = 'GL_NV_occlusion_query'
glBeginOcclusionQueryNV.trace = True
glBeginOcclusionQueryNV.play = True
gl.add(glBeginOcclusionQueryNV)

glDeleteOcclusionQueriesNV = Function('glDeleteOcclusionQueriesNV')
glDeleteOcclusionQueriesNV.ret = Return('void')
glDeleteOcclusionQueriesNV.add( Input( 'n','GLsizei' ))
glDeleteOcclusionQueriesNV.add( Input( 'ids','const GLuint *' ,size = 'n' ))
glDeleteOcclusionQueriesNV.version = '1.2'
glDeleteOcclusionQueriesNV.category = 'GL_NV_occlusion_query'
glDeleteOcclusionQueriesNV.trace = True
glDeleteOcclusionQueriesNV.play = True
gl.add(glDeleteOcclusionQueriesNV)

glEndOcclusionQueryNV = Function('glEndOcclusionQueryNV')
glEndOcclusionQueryNV.ret = Return('void')
glEndOcclusionQueryNV.version = '1.2'
glEndOcclusionQueryNV.category = 'GL_NV_occlusion_query'
glEndOcclusionQueryNV.trace = True
glEndOcclusionQueryNV.play = True
gl.add(glEndOcclusionQueryNV)

glGenOcclusionQueriesNV = Function('glGenOcclusionQueriesNV')
glGenOcclusionQueriesNV.ret = Return('void')
glGenOcclusionQueriesNV.add( Input( 'n','GLsizei' ))
glGenOcclusionQueriesNV.add( Output( 'ids','GLuint *' ,size = 'n' ))
glGenOcclusionQueriesNV.version = '1.2'
glGenOcclusionQueriesNV.category = 'GL_NV_occlusion_query'
glGenOcclusionQueriesNV.trace = True
glGenOcclusionQueriesNV.play = True
gl.add(glGenOcclusionQueriesNV)

glGetOcclusionQueryivNV = Function('glGetOcclusionQueryivNV')
glGetOcclusionQueryivNV.ret = Return('void')
glGetOcclusionQueryivNV.add( Input( 'id','GLuint' ))
glGetOcclusionQueryivNV.add( Input( 'pname','GLenum' ))
glGetOcclusionQueryivNV.add( Output( 'params','GLint *' ))
glGetOcclusionQueryivNV.version = '1.2'
glGetOcclusionQueryivNV.category = 'GL_NV_occlusion_query'
glGetOcclusionQueryivNV.trace = True
glGetOcclusionQueryivNV.play = True
gl.add(glGetOcclusionQueryivNV)

glGetOcclusionQueryuivNV = Function('glGetOcclusionQueryuivNV')
glGetOcclusionQueryuivNV.ret = Return('void')
glGetOcclusionQueryuivNV.add( Input( 'id','GLuint' ))
glGetOcclusionQueryuivNV.add( Input( 'pname','GLenum' ))
glGetOcclusionQueryuivNV.add( Output( 'params','GLuint *' ))
glGetOcclusionQueryuivNV.version = '1.2'
glGetOcclusionQueryuivNV.category = 'GL_NV_occlusion_query'
glGetOcclusionQueryuivNV.trace = True
glGetOcclusionQueryuivNV.play = True
gl.add(glGetOcclusionQueryuivNV)

glIsOcclusionQueryNV = Function('glIsOcclusionQueryNV')
glIsOcclusionQueryNV.ret = Return('GLboolean')
glIsOcclusionQueryNV.add( Input( 'id','GLuint' ))
glIsOcclusionQueryNV.version = '1.2'
glIsOcclusionQueryNV.category = 'GL_NV_occlusion_query'
glIsOcclusionQueryNV.trace = True
glIsOcclusionQueryNV.play = True
gl.add(glIsOcclusionQueryNV)

# GL_NV_parameter_buffer_object

glProgramBufferParametersIivNV = Function('glProgramBufferParametersIivNV')
glProgramBufferParametersIivNV.ret = Return('void')
glProgramBufferParametersIivNV.add( Input( 'target','GLenum' ))
glProgramBufferParametersIivNV.add( Input( 'buffer','GLuint' ))
glProgramBufferParametersIivNV.add( Input( 'index','GLuint' ))
glProgramBufferParametersIivNV.add( Input( 'count','GLsizei' ))
glProgramBufferParametersIivNV.add( Input( 'params','const GLint *' ,size = 'count' ))
glProgramBufferParametersIivNV.version = '1.2'
glProgramBufferParametersIivNV.category = 'GL_NV_parameter_buffer_object'
glProgramBufferParametersIivNV.trace = True
glProgramBufferParametersIivNV.play = True
gl.add(glProgramBufferParametersIivNV)

glProgramBufferParametersIuivNV = Function('glProgramBufferParametersIuivNV')
glProgramBufferParametersIuivNV.ret = Return('void')
glProgramBufferParametersIuivNV.add( Input( 'target','GLenum' ))
glProgramBufferParametersIuivNV.add( Input( 'buffer','GLuint' ))
glProgramBufferParametersIuivNV.add( Input( 'index','GLuint' ))
glProgramBufferParametersIuivNV.add( Input( 'count','GLsizei' ))
glProgramBufferParametersIuivNV.add( Input( 'params','const GLuint *' ,size = 'count' ))
glProgramBufferParametersIuivNV.version = '1.2'
glProgramBufferParametersIuivNV.category = 'GL_NV_parameter_buffer_object'
glProgramBufferParametersIuivNV.trace = True
glProgramBufferParametersIuivNV.play = True
gl.add(glProgramBufferParametersIuivNV)

glProgramBufferParametersfvNV = Function('glProgramBufferParametersfvNV')
glProgramBufferParametersfvNV.ret = Return('void')
glProgramBufferParametersfvNV.add( Input( 'target','GLenum' ))
glProgramBufferParametersfvNV.add( Input( 'buffer','GLuint' ))
glProgramBufferParametersfvNV.add( Input( 'index','GLuint' ))
glProgramBufferParametersfvNV.add( Input( 'count','GLsizei' ))
glProgramBufferParametersfvNV.add( Input( 'params','const GLfloat *' ,size = 'count' ))
glProgramBufferParametersfvNV.version = '1.2'
glProgramBufferParametersfvNV.category = 'GL_NV_parameter_buffer_object'
glProgramBufferParametersfvNV.trace = True
glProgramBufferParametersfvNV.play = True
gl.add(glProgramBufferParametersfvNV)

# GL_NV_path_rendering

glCopyPathNV = Function('glCopyPathNV')
glCopyPathNV.ret = Return('void')
glCopyPathNV.add( Input( 'resultPath','GLuint' ))
glCopyPathNV.add( Input( 'srcPath','GLuint' ))
glCopyPathNV.version = ''
glCopyPathNV.category = 'GL_NV_path_rendering'
glCopyPathNV.trace = True
glCopyPathNV.play = True
gl.add(glCopyPathNV)

glCoverFillPathInstancedNV = Function('glCoverFillPathInstancedNV')
glCoverFillPathInstancedNV.ret = Return('void')
glCoverFillPathInstancedNV.add( Input( 'numPaths','GLsizei' ))
glCoverFillPathInstancedNV.add( Input( 'pathNameType','GLenum' ))
glCoverFillPathInstancedNV.add( Input( 'paths','const GLvoid *' ))
glCoverFillPathInstancedNV.add( Input( 'pathBase','GLuint' ))
glCoverFillPathInstancedNV.add( Input( 'coverMode','GLenum' ))
glCoverFillPathInstancedNV.add( Input( 'transformType','GLenum' ))
glCoverFillPathInstancedNV.add( Input( 'transformValues','const GLfloat *' ))
glCoverFillPathInstancedNV.version = ''
glCoverFillPathInstancedNV.category = 'GL_NV_path_rendering'
glCoverFillPathInstancedNV.trace = True
glCoverFillPathInstancedNV.play = True
gl.add(glCoverFillPathInstancedNV)

glCoverFillPathNV = Function('glCoverFillPathNV')
glCoverFillPathNV.ret = Return('void')
glCoverFillPathNV.add( Input( 'path','GLuint' ))
glCoverFillPathNV.add( Input( 'coverMode','GLenum' ))
glCoverFillPathNV.version = ''
glCoverFillPathNV.category = 'GL_NV_path_rendering'
glCoverFillPathNV.trace = True
glCoverFillPathNV.play = True
gl.add(glCoverFillPathNV)

glCoverStrokePathInstancedNV = Function('glCoverStrokePathInstancedNV')
glCoverStrokePathInstancedNV.ret = Return('void')
glCoverStrokePathInstancedNV.add( Input( 'numPaths','GLsizei' ))
glCoverStrokePathInstancedNV.add( Input( 'pathNameType','GLenum' ))
glCoverStrokePathInstancedNV.add( Input( 'paths','const GLvoid *' ))
glCoverStrokePathInstancedNV.add( Input( 'pathBase','GLuint' ))
glCoverStrokePathInstancedNV.add( Input( 'coverMode','GLenum' ))
glCoverStrokePathInstancedNV.add( Input( 'transformType','GLenum' ))
glCoverStrokePathInstancedNV.add( Input( 'transformValues','const GLfloat *' ))
glCoverStrokePathInstancedNV.version = ''
glCoverStrokePathInstancedNV.category = 'GL_NV_path_rendering'
glCoverStrokePathInstancedNV.trace = True
glCoverStrokePathInstancedNV.play = True
gl.add(glCoverStrokePathInstancedNV)

glCoverStrokePathNV = Function('glCoverStrokePathNV')
glCoverStrokePathNV.ret = Return('void')
glCoverStrokePathNV.add( Input( 'name','GLuint' ))
glCoverStrokePathNV.add( Input( 'coverMode','GLenum' ))
glCoverStrokePathNV.version = ''
glCoverStrokePathNV.category = 'GL_NV_path_rendering'
glCoverStrokePathNV.trace = True
glCoverStrokePathNV.play = True
gl.add(glCoverStrokePathNV)

glDeletePathsNV = Function('glDeletePathsNV')
glDeletePathsNV.ret = Return('void')
glDeletePathsNV.add( Input( 'path','GLuint' ))
glDeletePathsNV.add( Input( 'range','GLsizei' ))
glDeletePathsNV.version = ''
glDeletePathsNV.category = 'GL_NV_path_rendering'
glDeletePathsNV.trace = True
glDeletePathsNV.play = True
gl.add(glDeletePathsNV)

glGenPathsNV = Function('glGenPathsNV')
glGenPathsNV.ret = Return('GLuint')
glGenPathsNV.add( Input( 'range','GLsizei' ))
glGenPathsNV.version = ''
glGenPathsNV.category = 'GL_NV_path_rendering'
glGenPathsNV.trace = True
glGenPathsNV.play = True
gl.add(glGenPathsNV)

glGetPathColorGenfvNV = Function('glGetPathColorGenfvNV')
glGetPathColorGenfvNV.ret = Return('void')
glGetPathColorGenfvNV.add( Input( 'color','GLenum' ))
glGetPathColorGenfvNV.add( Input( 'pname','GLenum' ))
glGetPathColorGenfvNV.add( Input( 'value','GLfloat *' ))
glGetPathColorGenfvNV.version = ''
glGetPathColorGenfvNV.category = 'GL_NV_path_rendering'
glGetPathColorGenfvNV.trace = True
glGetPathColorGenfvNV.play = False
gl.add(glGetPathColorGenfvNV)

glGetPathColorGenivNV = Function('glGetPathColorGenivNV')
glGetPathColorGenivNV.ret = Return('void')
glGetPathColorGenivNV.add( Input( 'color','GLenum' ))
glGetPathColorGenivNV.add( Input( 'pname','GLenum' ))
glGetPathColorGenivNV.add( Input( 'value','GLint *' ))
glGetPathColorGenivNV.version = ''
glGetPathColorGenivNV.category = 'GL_NV_path_rendering'
glGetPathColorGenivNV.trace = True
glGetPathColorGenivNV.play = False
gl.add(glGetPathColorGenivNV)

glGetPathCommandsNV = Function('glGetPathCommandsNV')
glGetPathCommandsNV.ret = Return('void')
glGetPathCommandsNV.add( Input( 'name','GLuint' ))
glGetPathCommandsNV.add( Output( 'commands','GLubyte *' ))
glGetPathCommandsNV.version = ''
glGetPathCommandsNV.category = 'GL_NV_path_rendering'
glGetPathCommandsNV.trace = True
glGetPathCommandsNV.play = False
gl.add(glGetPathCommandsNV)

glGetPathCoordsNV = Function('glGetPathCoordsNV')
glGetPathCoordsNV.ret = Return('void')
glGetPathCoordsNV.add( Input( 'name','GLuint' ))
glGetPathCoordsNV.add( Input( 'coords','GLfloat *' ))
glGetPathCoordsNV.version = ''
glGetPathCoordsNV.category = 'GL_NV_path_rendering'
glGetPathCoordsNV.trace = True
glGetPathCoordsNV.play = False
gl.add(glGetPathCoordsNV)

glGetPathDashArrayNV = Function('glGetPathDashArrayNV')
glGetPathDashArrayNV.ret = Return('void')
glGetPathDashArrayNV.add( Input( 'name','GLuint' ))
glGetPathDashArrayNV.add( Input( 'dashArray','GLfloat *' ))
glGetPathDashArrayNV.version = ''
glGetPathDashArrayNV.category = 'GL_NV_path_rendering'
glGetPathDashArrayNV.trace = True
glGetPathDashArrayNV.play = False
gl.add(glGetPathDashArrayNV)

glGetPathLengthNV = Function('glGetPathLengthNV')
glGetPathLengthNV.ret = Return('GLfloat')
glGetPathLengthNV.add( Input( 'path','GLuint' ))
glGetPathLengthNV.add( Input( 'startSegment','GLsizei' ))
glGetPathLengthNV.add( Input( 'numSegments','GLsizei' ))
glGetPathLengthNV.version = ''
glGetPathLengthNV.category = 'GL_NV_path_rendering'
glGetPathLengthNV.trace = True
glGetPathLengthNV.play = False
gl.add(glGetPathLengthNV)

glGetPathMetricRangeNV = Function('glGetPathMetricRangeNV')
glGetPathMetricRangeNV.ret = Return('void')
glGetPathMetricRangeNV.add( Input( 'metricQueryMask','GLbitfield' ,regalLog = 'GLgetPathMetricsNVToString(metricQueryMask)' ))
glGetPathMetricRangeNV.add( Input( 'fistPathName','GLuint' ))
glGetPathMetricRangeNV.add( Input( 'numPaths','GLsizei' ))
glGetPathMetricRangeNV.add( Input( 'stride','GLsizei' ))
glGetPathMetricRangeNV.add( Input( 'metrics','GLfloat *' ))
glGetPathMetricRangeNV.version = ''
glGetPathMetricRangeNV.category = 'GL_NV_path_rendering'
glGetPathMetricRangeNV.trace = True
glGetPathMetricRangeNV.play = False
gl.add(glGetPathMetricRangeNV)

glGetPathMetricsNV = Function('glGetPathMetricsNV')
glGetPathMetricsNV.ret = Return('void')
glGetPathMetricsNV.add( Input( 'metricQueryMask','GLbitfield' ,regalLog = 'GLgetPathMetricsNVToString(metricQueryMask)' ))
glGetPathMetricsNV.add( Input( 'numPaths','GLsizei' ))
glGetPathMetricsNV.add( Input( 'pathNameType','GLenum' ))
glGetPathMetricsNV.add( Input( 'paths','const GLvoid *' ))
glGetPathMetricsNV.add( Input( 'pathBase','GLuint' ))
glGetPathMetricsNV.add( Input( 'stride','GLsizei' ))
glGetPathMetricsNV.add( Input( 'metrics','GLfloat *' ))
glGetPathMetricsNV.version = ''
glGetPathMetricsNV.category = 'GL_NV_path_rendering'
glGetPathMetricsNV.trace = True
glGetPathMetricsNV.play = False
gl.add(glGetPathMetricsNV)

glGetPathParameterfvNV = Function('glGetPathParameterfvNV')
glGetPathParameterfvNV.ret = Return('void')
glGetPathParameterfvNV.add( Input( 'name','GLuint' ))
glGetPathParameterfvNV.add( Input( 'param','GLenum' ))
glGetPathParameterfvNV.add( Input( 'value','GLfloat *' ))
glGetPathParameterfvNV.version = ''
glGetPathParameterfvNV.category = 'GL_NV_path_rendering'
glGetPathParameterfvNV.trace = True
glGetPathParameterfvNV.play = False
gl.add(glGetPathParameterfvNV)

glGetPathParameterivNV = Function('glGetPathParameterivNV')
glGetPathParameterivNV.ret = Return('void')
glGetPathParameterivNV.add( Input( 'name','GLuint' ))
glGetPathParameterivNV.add( Input( 'param','GLenum' ))
glGetPathParameterivNV.add( Input( 'value','GLint *' ))
glGetPathParameterivNV.version = ''
glGetPathParameterivNV.category = 'GL_NV_path_rendering'
glGetPathParameterivNV.trace = True
glGetPathParameterivNV.play = False
gl.add(glGetPathParameterivNV)

glGetPathSpacingNV = Function('glGetPathSpacingNV')
glGetPathSpacingNV.ret = Return('void')
glGetPathSpacingNV.add( Input( 'pathListMode','GLenum' ))
glGetPathSpacingNV.add( Input( 'numPaths','GLsizei' ))
glGetPathSpacingNV.add( Input( 'pathNameType','GLenum' ))
glGetPathSpacingNV.add( Input( 'paths','const GLvoid *' ))
glGetPathSpacingNV.add( Input( 'pathBase','GLuint' ))
glGetPathSpacingNV.add( Input( 'advanceScale','GLfloat' ))
glGetPathSpacingNV.add( Input( 'kerningScale','GLfloat' ))
glGetPathSpacingNV.add( Input( 'transformType','GLenum' ))
glGetPathSpacingNV.add( Input( 'returnedSpacing','GLfloat *' ))
glGetPathSpacingNV.version = ''
glGetPathSpacingNV.category = 'GL_NV_path_rendering'
glGetPathSpacingNV.trace = True
glGetPathSpacingNV.play = False
gl.add(glGetPathSpacingNV)

glGetPathTexGenfvNV = Function('glGetPathTexGenfvNV')
glGetPathTexGenfvNV.ret = Return('void')
glGetPathTexGenfvNV.add( Input( 'texCoordSet','GLenum' ))
glGetPathTexGenfvNV.add( Input( 'pname','GLenum' ))
glGetPathTexGenfvNV.add( Input( 'value','GLfloat *' ))
glGetPathTexGenfvNV.version = ''
glGetPathTexGenfvNV.category = 'GL_NV_path_rendering'
glGetPathTexGenfvNV.trace = True
glGetPathTexGenfvNV.play = False
gl.add(glGetPathTexGenfvNV)

glGetPathTexGenivNV = Function('glGetPathTexGenivNV')
glGetPathTexGenivNV.ret = Return('void')
glGetPathTexGenivNV.add( Input( 'texCoordSet','GLenum' ))
glGetPathTexGenivNV.add( Input( 'pname','GLenum' ))
glGetPathTexGenivNV.add( Input( 'value','GLint *' ))
glGetPathTexGenivNV.version = ''
glGetPathTexGenivNV.category = 'GL_NV_path_rendering'
glGetPathTexGenivNV.trace = True
glGetPathTexGenivNV.play = False
gl.add(glGetPathTexGenivNV)

glInterpolatePathsNV = Function('glInterpolatePathsNV')
glInterpolatePathsNV.ret = Return('void')
glInterpolatePathsNV.add( Input( 'resultPath','GLuint' ))
glInterpolatePathsNV.add( Input( 'pathA','GLuint' ))
glInterpolatePathsNV.add( Input( 'pathB','GLuint' ))
glInterpolatePathsNV.add( Input( 'weight','GLfloat' ))
glInterpolatePathsNV.version = ''
glInterpolatePathsNV.category = 'GL_NV_path_rendering'
glInterpolatePathsNV.trace = True
glInterpolatePathsNV.play = True
gl.add(glInterpolatePathsNV)

glIsPathNV = Function('glIsPathNV')
glIsPathNV.ret = Return('GLboolean')
glIsPathNV.add( Input( 'path','GLuint' ))
glIsPathNV.version = ''
glIsPathNV.category = 'GL_NV_path_rendering'
glIsPathNV.trace = True
glIsPathNV.play = False
gl.add(glIsPathNV)

glIsPointInFillPathNV = Function('glIsPointInFillPathNV')
glIsPointInFillPathNV.ret = Return('GLboolean')
glIsPointInFillPathNV.add( Input( 'path','GLuint' ))
glIsPointInFillPathNV.add( Input( 'mask','GLuint' ))
glIsPointInFillPathNV.add( Input( 'x','GLfloat' ))
glIsPointInFillPathNV.add( Input( 'y','GLfloat' ))
glIsPointInFillPathNV.version = ''
glIsPointInFillPathNV.category = 'GL_NV_path_rendering'
glIsPointInFillPathNV.trace = True
glIsPointInFillPathNV.play = False
gl.add(glIsPointInFillPathNV)

glIsPointInStrokePathNV = Function('glIsPointInStrokePathNV')
glIsPointInStrokePathNV.ret = Return('GLboolean')
glIsPointInStrokePathNV.add( Input( 'path','GLuint' ))
glIsPointInStrokePathNV.add( Input( 'x','GLfloat' ))
glIsPointInStrokePathNV.add( Input( 'y','GLfloat' ))
glIsPointInStrokePathNV.version = ''
glIsPointInStrokePathNV.category = 'GL_NV_path_rendering'
glIsPointInStrokePathNV.trace = True
glIsPointInStrokePathNV.play = False
gl.add(glIsPointInStrokePathNV)

glPathColorGenNV = Function('glPathColorGenNV')
glPathColorGenNV.ret = Return('void')
glPathColorGenNV.add( Input( 'color','GLenum' ))
glPathColorGenNV.add( Input( 'genMode','GLenum' ))
glPathColorGenNV.add( Input( 'colorFormat','GLenum' ))
glPathColorGenNV.add( Input( 'coeffs','const GLfloat *' ))
glPathColorGenNV.version = ''
glPathColorGenNV.category = 'GL_NV_path_rendering'
glPathColorGenNV.trace = True
glPathColorGenNV.play = True
gl.add(glPathColorGenNV)

glPathCommandsNV = Function('glPathCommandsNV')
glPathCommandsNV.ret = Return('void')
glPathCommandsNV.add( Input( 'path','GLuint' ))
glPathCommandsNV.add( Input( 'numCommands','GLsizei' ))
glPathCommandsNV.add( Input( 'commands','const GLubyte *' ,regalLog = 'Token::GLpathCommandToString(numCommands,commands)' ))
glPathCommandsNV.add( Input( 'numCoords','GLsizei' ))
glPathCommandsNV.add( Input( 'coordType','GLenum' ,regalLog = 'Token::GLpathCoordToString(coordType)' ))
glPathCommandsNV.add( Input( 'coords','const GLvoid *' ,regalLog = 'Token::GLpathCoordToString(numCoords,coordType,coords)' ))
glPathCommandsNV.version = ''
glPathCommandsNV.category = 'GL_NV_path_rendering'
glPathCommandsNV.trace = True
glPathCommandsNV.play = True
gl.add(glPathCommandsNV)

glPathCoordsNV = Function('glPathCoordsNV')
glPathCoordsNV.ret = Return('void')
glPathCoordsNV.add( Input( 'path','GLuint' ))
glPathCoordsNV.add( Input( 'numCoords','GLsizei' ))
glPathCoordsNV.add( Input( 'coordType','GLenum' ))
glPathCoordsNV.add( Input( 'coords','const GLvoid *' ))
glPathCoordsNV.version = ''
glPathCoordsNV.category = 'GL_NV_path_rendering'
glPathCoordsNV.trace = True
glPathCoordsNV.play = True
gl.add(glPathCoordsNV)

glPathCoverDepthFuncNV = Function('glPathCoverDepthFuncNV')
glPathCoverDepthFuncNV.ret = Return('void')
glPathCoverDepthFuncNV.add( Input( 'zfunc','GLenum' ))
glPathCoverDepthFuncNV.version = ''
glPathCoverDepthFuncNV.category = 'GL_NV_path_rendering'
glPathCoverDepthFuncNV.trace = True
glPathCoverDepthFuncNV.play = True
gl.add(glPathCoverDepthFuncNV)

glPathDashArrayNV = Function('glPathDashArrayNV')
glPathDashArrayNV.ret = Return('void')
glPathDashArrayNV.add( Input( 'path','GLuint' ))
glPathDashArrayNV.add( Input( 'dashCount','GLsizei' ))
glPathDashArrayNV.add( Input( 'dashArray','const GLfloat *' ))
glPathDashArrayNV.version = ''
glPathDashArrayNV.category = 'GL_NV_path_rendering'
glPathDashArrayNV.trace = True
glPathDashArrayNV.play = True
gl.add(glPathDashArrayNV)

glPathFogGenNV = Function('glPathFogGenNV')
glPathFogGenNV.ret = Return('void')
glPathFogGenNV.add( Input( 'genMode','GLenum' ))
glPathFogGenNV.version = ''
glPathFogGenNV.category = 'GL_NV_path_rendering'
glPathFogGenNV.trace = True
glPathFogGenNV.play = True
gl.add(glPathFogGenNV)

glPathGlyphRangeNV = Function('glPathGlyphRangeNV')
glPathGlyphRangeNV.ret = Return('void')
glPathGlyphRangeNV.add( Input( 'firstPathName','GLuint' ))
glPathGlyphRangeNV.add( Input( 'fontTarget','GLenum' ))
glPathGlyphRangeNV.add( Input( 'fontName','const GLvoid *' ,cast = 'const char *' ))
glPathGlyphRangeNV.add( Input( 'fontStyle','GLbitfield' ,regalLog = 'GLpathGlyphsNVToString(fontStyle)' ))
glPathGlyphRangeNV.add( Input( 'firstGlyph','GLuint' ))
glPathGlyphRangeNV.add( Input( 'numGlyphs','GLsizei' ))
glPathGlyphRangeNV.add( Input( 'handleMissingGlyphs','GLenum' ))
glPathGlyphRangeNV.add( Input( 'pathParameterTemplate','GLuint' ))
glPathGlyphRangeNV.add( Input( 'emScale','GLfloat' ))
glPathGlyphRangeNV.version = ''
glPathGlyphRangeNV.category = 'GL_NV_path_rendering'
glPathGlyphRangeNV.trace = True
glPathGlyphRangeNV.play = True
gl.add(glPathGlyphRangeNV)

glPathGlyphsNV = Function('glPathGlyphsNV')
glPathGlyphsNV.ret = Return('void')
glPathGlyphsNV.add( Input( 'firstPathName','GLuint' ))
glPathGlyphsNV.add( Input( 'fontTarget','GLenum' ))
glPathGlyphsNV.add( Input( 'fontName','const GLvoid *' ,cast = 'const char *' ))
glPathGlyphsNV.add( Input( 'fontStyle','GLbitfield' ,regalLog = 'GLpathGlyphsNVToString(fontStyle)' ))
glPathGlyphsNV.add( Input( 'numGlyphs','GLsizei' ))
glPathGlyphsNV.add( Input( 'type','GLenum' ))
glPathGlyphsNV.add( Input( 'charcodes','const GLvoid *' ))
glPathGlyphsNV.add( Input( 'handleMissingGlyphs','GLenum' ))
glPathGlyphsNV.add( Input( 'pathParameterTemplate','GLuint' ))
glPathGlyphsNV.add( Input( 'emScale','GLfloat' ))
glPathGlyphsNV.version = ''
glPathGlyphsNV.category = 'GL_NV_path_rendering'
glPathGlyphsNV.trace = True
glPathGlyphsNV.play = True
gl.add(glPathGlyphsNV)

glPathParameterfNV = Function('glPathParameterfNV')
glPathParameterfNV.ret = Return('void')
glPathParameterfNV.add( Input( 'path','GLuint' ))
glPathParameterfNV.add( Input( 'pname','GLenum' ))
glPathParameterfNV.add( Input( 'value','GLfloat' ))
glPathParameterfNV.version = ''
glPathParameterfNV.category = 'GL_NV_path_rendering'
glPathParameterfNV.trace = True
glPathParameterfNV.play = True
gl.add(glPathParameterfNV)

glPathParameterfvNV = Function('glPathParameterfvNV')
glPathParameterfvNV.ret = Return('void')
glPathParameterfvNV.add( Input( 'path','GLuint' ))
glPathParameterfvNV.add( Input( 'pname','GLenum' ))
glPathParameterfvNV.add( Input( 'value','const GLfloat *' ))
glPathParameterfvNV.version = ''
glPathParameterfvNV.category = 'GL_NV_path_rendering'
glPathParameterfvNV.trace = True
glPathParameterfvNV.play = True
gl.add(glPathParameterfvNV)

glPathParameteriNV = Function('glPathParameteriNV')
glPathParameteriNV.ret = Return('void')
glPathParameteriNV.add( Input( 'path','GLuint' ))
glPathParameteriNV.add( Input( 'pname','GLenum' ))
glPathParameteriNV.add( Input( 'value','GLint' ))
glPathParameteriNV.version = ''
glPathParameteriNV.category = 'GL_NV_path_rendering'
glPathParameteriNV.trace = True
glPathParameteriNV.play = True
gl.add(glPathParameteriNV)

glPathParameterivNV = Function('glPathParameterivNV')
glPathParameterivNV.ret = Return('void')
glPathParameterivNV.add( Input( 'path','GLuint' ))
glPathParameterivNV.add( Input( 'pname','GLenum' ))
glPathParameterivNV.add( Input( 'value','const GLint *' ))
glPathParameterivNV.version = ''
glPathParameterivNV.category = 'GL_NV_path_rendering'
glPathParameterivNV.trace = True
glPathParameterivNV.play = True
gl.add(glPathParameterivNV)

glPathStencilDepthOffsetNV = Function('glPathStencilDepthOffsetNV')
glPathStencilDepthOffsetNV.ret = Return('void')
glPathStencilDepthOffsetNV.add( Input( 'factor','GLfloat' ))
glPathStencilDepthOffsetNV.add( Input( 'units','GLfloat' ))
glPathStencilDepthOffsetNV.version = ''
glPathStencilDepthOffsetNV.category = 'GL_NV_path_rendering'
glPathStencilDepthOffsetNV.trace = True
glPathStencilDepthOffsetNV.play = True
gl.add(glPathStencilDepthOffsetNV)

glPathStencilFuncNV = Function('glPathStencilFuncNV')
glPathStencilFuncNV.ret = Return('void')
glPathStencilFuncNV.add( Input( 'func','GLenum' ))
glPathStencilFuncNV.add( Input( 'ref','GLint' ,regalLog = 'boost::print::hex(ref)' ))
glPathStencilFuncNV.add( Input( 'mask','GLuint' ,regalLog = 'boost::print::hex(mask)' ))
glPathStencilFuncNV.version = ''
glPathStencilFuncNV.category = 'GL_NV_path_rendering'
glPathStencilFuncNV.trace = True
glPathStencilFuncNV.play = True
gl.add(glPathStencilFuncNV)

glPathStringNV = Function('glPathStringNV')
glPathStringNV.ret = Return('void')
glPathStringNV.add( Input( 'path','GLuint' ))
glPathStringNV.add( Input( 'format','GLenum' ))
glPathStringNV.add( Input( 'length','GLsizei' ))
glPathStringNV.add( Input( 'pathString','const GLvoid *' ))
glPathStringNV.version = ''
glPathStringNV.category = 'GL_NV_path_rendering'
glPathStringNV.trace = True
glPathStringNV.play = True
gl.add(glPathStringNV)

glPathSubCommandsNV = Function('glPathSubCommandsNV')
glPathSubCommandsNV.ret = Return('void')
glPathSubCommandsNV.add( Input( 'path','GLuint' ))
glPathSubCommandsNV.add( Input( 'commandStart','GLsizei' ))
glPathSubCommandsNV.add( Input( 'commandsToDelete','GLsizei' ))
glPathSubCommandsNV.add( Input( 'numCommands','GLsizei' ))
glPathSubCommandsNV.add( Input( 'commands','const GLubyte *' ,regalLog = 'Token::GLpathCommandToString(numCommands,commands)' ))
glPathSubCommandsNV.add( Input( 'numCoords','GLsizei' ))
glPathSubCommandsNV.add( Input( 'coordType','GLenum' ,regalLog = 'Token::GLpathCoordToString(coordType)' ))
glPathSubCommandsNV.add( Input( 'coords','const GLvoid *' ,regalLog = 'Token::GLpathCoordToString(numCoords,coordType,coords)' ))
glPathSubCommandsNV.version = ''
glPathSubCommandsNV.category = 'GL_NV_path_rendering'
glPathSubCommandsNV.trace = True
glPathSubCommandsNV.play = True
gl.add(glPathSubCommandsNV)

glPathSubCoordsNV = Function('glPathSubCoordsNV')
glPathSubCoordsNV.ret = Return('void')
glPathSubCoordsNV.add( Input( 'path','GLuint' ))
glPathSubCoordsNV.add( Input( 'coordStart','GLsizei' ))
glPathSubCoordsNV.add( Input( 'numCoords','GLsizei' ))
glPathSubCoordsNV.add( Input( 'coordType','GLenum' ,regalLog = 'Token::GLpathCoordToString(coordType)' ))
glPathSubCoordsNV.add( Input( 'coords','const GLvoid *' ,regalLog = 'Token::GLpathCoordToString(numCoords,coordType,coords)' ))
glPathSubCoordsNV.version = ''
glPathSubCoordsNV.category = 'GL_NV_path_rendering'
glPathSubCoordsNV.trace = True
glPathSubCoordsNV.play = True
gl.add(glPathSubCoordsNV)

glPathTexGenNV = Function('glPathTexGenNV')
glPathTexGenNV.ret = Return('void')
glPathTexGenNV.add( Input( 'texCoordSet','GLenum' ))
glPathTexGenNV.add( Input( 'genMode','GLenum' ))
glPathTexGenNV.add( Input( 'components','GLint' ))
glPathTexGenNV.add( Input( 'coeffs','const GLfloat *' ))
glPathTexGenNV.version = ''
glPathTexGenNV.category = 'GL_NV_path_rendering'
glPathTexGenNV.trace = True
glPathTexGenNV.play = True
gl.add(glPathTexGenNV)

glPointAlongPathNV = Function('glPointAlongPathNV')
glPointAlongPathNV.ret = Return('GLboolean')
glPointAlongPathNV.add( Input( 'path','GLuint' ))
glPointAlongPathNV.add( Input( 'startSegment','GLsizei' ))
glPointAlongPathNV.add( Input( 'numSegments','GLsizei' ))
glPointAlongPathNV.add( Input( 'distance','GLfloat' ))
glPointAlongPathNV.add( Input( 'x','GLfloat *' ))
glPointAlongPathNV.add( Input( 'y','GLfloat *' ))
glPointAlongPathNV.add( Input( 'tangentX','GLfloat *' ))
glPointAlongPathNV.add( Input( 'tangentY','GLfloat *' ))
glPointAlongPathNV.version = ''
glPointAlongPathNV.category = 'GL_NV_path_rendering'
glPointAlongPathNV.trace = True
glPointAlongPathNV.play = True
gl.add(glPointAlongPathNV)

glStencilFillPathInstancedNV = Function('glStencilFillPathInstancedNV')
glStencilFillPathInstancedNV.ret = Return('void')
glStencilFillPathInstancedNV.add( Input( 'numPaths','GLsizei' ))
glStencilFillPathInstancedNV.add( Input( 'pathNameType','GLenum' ))
glStencilFillPathInstancedNV.add( Input( 'paths','const GLvoid *' ))
glStencilFillPathInstancedNV.add( Input( 'pathBase','GLuint' ))
glStencilFillPathInstancedNV.add( Input( 'fillMode','GLenum' ))
glStencilFillPathInstancedNV.add( Input( 'mask','GLuint' ))
glStencilFillPathInstancedNV.add( Input( 'transformType','GLenum' ))
glStencilFillPathInstancedNV.add( Input( 'transformValues','const GLfloat *' ))
glStencilFillPathInstancedNV.version = ''
glStencilFillPathInstancedNV.category = 'GL_NV_path_rendering'
glStencilFillPathInstancedNV.trace = True
glStencilFillPathInstancedNV.play = True
gl.add(glStencilFillPathInstancedNV)

glStencilFillPathNV = Function('glStencilFillPathNV')
glStencilFillPathNV.ret = Return('void')
glStencilFillPathNV.add( Input( 'path','GLuint' ))
glStencilFillPathNV.add( Input( 'fillMode','GLenum' ))
glStencilFillPathNV.add( Input( 'mask','GLuint' ))
glStencilFillPathNV.version = ''
glStencilFillPathNV.category = 'GL_NV_path_rendering'
glStencilFillPathNV.trace = True
glStencilFillPathNV.play = True
gl.add(glStencilFillPathNV)

glStencilStrokePathInstancedNV = Function('glStencilStrokePathInstancedNV')
glStencilStrokePathInstancedNV.ret = Return('void')
glStencilStrokePathInstancedNV.add( Input( 'numPaths','GLsizei' ))
glStencilStrokePathInstancedNV.add( Input( 'pathNameType','GLenum' ))
glStencilStrokePathInstancedNV.add( Input( 'paths','const GLvoid *' ))
glStencilStrokePathInstancedNV.add( Input( 'pathBase','GLuint' ))
glStencilStrokePathInstancedNV.add( Input( 'reference','GLint' ))
glStencilStrokePathInstancedNV.add( Input( 'mask','GLuint' ))
glStencilStrokePathInstancedNV.add( Input( 'transformType','GLenum' ))
glStencilStrokePathInstancedNV.add( Input( 'transformValues','const GLfloat *' ))
glStencilStrokePathInstancedNV.version = ''
glStencilStrokePathInstancedNV.category = 'GL_NV_path_rendering'
glStencilStrokePathInstancedNV.trace = True
glStencilStrokePathInstancedNV.play = True
gl.add(glStencilStrokePathInstancedNV)

glStencilStrokePathNV = Function('glStencilStrokePathNV')
glStencilStrokePathNV.ret = Return('void')
glStencilStrokePathNV.add( Input( 'path','GLuint' ))
glStencilStrokePathNV.add( Input( 'reference','GLint' ))
glStencilStrokePathNV.add( Input( 'mask','GLuint' ))
glStencilStrokePathNV.version = ''
glStencilStrokePathNV.category = 'GL_NV_path_rendering'
glStencilStrokePathNV.trace = True
glStencilStrokePathNV.play = True
gl.add(glStencilStrokePathNV)

glTransformPathNV = Function('glTransformPathNV')
glTransformPathNV.ret = Return('void')
glTransformPathNV.add( Input( 'resultPath','GLuint' ))
glTransformPathNV.add( Input( 'srcPath','GLuint' ))
glTransformPathNV.add( Input( 'transformType','GLenum' ))
glTransformPathNV.add( Input( 'transformValues','const GLfloat *' ))
glTransformPathNV.version = ''
glTransformPathNV.category = 'GL_NV_path_rendering'
glTransformPathNV.trace = True
glTransformPathNV.play = True
gl.add(glTransformPathNV)

glWeightPathsNV = Function('glWeightPathsNV')
glWeightPathsNV.ret = Return('void')
glWeightPathsNV.add( Input( 'resultPath','GLuint' ))
glWeightPathsNV.add( Input( 'numPaths','GLsizei' ))
glWeightPathsNV.add( Input( 'paths','const GLuint *' ))
glWeightPathsNV.add( Input( 'weights','const GLfloat *' ))
glWeightPathsNV.version = ''
glWeightPathsNV.category = 'GL_NV_path_rendering'
glWeightPathsNV.trace = True
glWeightPathsNV.play = True
gl.add(glWeightPathsNV)

# GL_NV_pixel_data_range

glFlushPixelDataRangeNV = Function('glFlushPixelDataRangeNV')
glFlushPixelDataRangeNV.ret = Return('void')
glFlushPixelDataRangeNV.add( Input( 'target','GLenum' ))
glFlushPixelDataRangeNV.version = '1.2'
glFlushPixelDataRangeNV.category = 'GL_NV_pixel_data_range'
glFlushPixelDataRangeNV.trace = True
glFlushPixelDataRangeNV.play = True
gl.add(glFlushPixelDataRangeNV)

glPixelDataRangeNV = Function('glPixelDataRangeNV')
glPixelDataRangeNV.ret = Return('void')
glPixelDataRangeNV.add( Input( 'target','GLenum' ))
glPixelDataRangeNV.add( Input( 'size','GLsizei' ))
glPixelDataRangeNV.add( Input( 'pointer','const GLvoid *' ))
glPixelDataRangeNV.version = '1.2'
glPixelDataRangeNV.category = 'GL_NV_pixel_data_range'
glPixelDataRangeNV.trace = True
glPixelDataRangeNV.play = True
gl.add(glPixelDataRangeNV)

# GL_NV_point_sprite

glPointParameteriNV = Function('glPointParameteriNV')
glPointParameteriNV.ret = Return('void')
glPointParameteriNV.add( Input( 'pname','GLenum' ))
glPointParameteriNV.add( Input( 'param','GLint' ))
glPointParameteriNV.version = '1.2'
glPointParameteriNV.category = 'GL_NV_point_sprite'
glPointParameteriNV.trace = True
glPointParameteriNV.play = True
gl.add(glPointParameteriNV)

glPointParameterivNV = Function('glPointParameterivNV')
glPointParameterivNV.ret = Return('void')
glPointParameterivNV.add( Input( 'pname','GLenum' ))
glPointParameterivNV.add( Input( 'params','const GLint *' ))
glPointParameterivNV.version = '1.2'
glPointParameterivNV.category = 'GL_NV_point_sprite'
glPointParameterivNV.trace = True
glPointParameterivNV.play = True
gl.add(glPointParameterivNV)

# GL_NV_present_video

glGetVideoi64vNV = Function('glGetVideoi64vNV')
glGetVideoi64vNV.ret = Return('void')
glGetVideoi64vNV.add( Input( 'video_slot','GLuint' ))
glGetVideoi64vNV.add( Input( 'pname','GLenum' ))
glGetVideoi64vNV.add( Output( 'params','GLint64EXT *' ))
glGetVideoi64vNV.version = '1.5'
glGetVideoi64vNV.category = 'GL_NV_present_video'
glGetVideoi64vNV.trace = True
glGetVideoi64vNV.play = True
gl.add(glGetVideoi64vNV)

glGetVideoivNV = Function('glGetVideoivNV')
glGetVideoivNV.ret = Return('void')
glGetVideoivNV.add( Input( 'video_slot','GLuint' ))
glGetVideoivNV.add( Input( 'pname','GLenum' ))
glGetVideoivNV.add( Output( 'params','GLint *' ))
glGetVideoivNV.version = '1.5'
glGetVideoivNV.category = 'GL_NV_present_video'
glGetVideoivNV.trace = True
glGetVideoivNV.play = True
gl.add(glGetVideoivNV)

glGetVideoui64vNV = Function('glGetVideoui64vNV')
glGetVideoui64vNV.ret = Return('void')
glGetVideoui64vNV.add( Input( 'video_slot','GLuint' ))
glGetVideoui64vNV.add( Input( 'pname','GLenum' ))
glGetVideoui64vNV.add( Output( 'params','GLuint64EXT *' ))
glGetVideoui64vNV.version = '1.5'
glGetVideoui64vNV.category = 'GL_NV_present_video'
glGetVideoui64vNV.trace = True
glGetVideoui64vNV.play = True
gl.add(glGetVideoui64vNV)

glGetVideouivNV = Function('glGetVideouivNV')
glGetVideouivNV.ret = Return('void')
glGetVideouivNV.add( Input( 'video_slot','GLuint' ))
glGetVideouivNV.add( Input( 'pname','GLenum' ))
glGetVideouivNV.add( Output( 'params','GLuint *' ))
glGetVideouivNV.version = '1.5'
glGetVideouivNV.category = 'GL_NV_present_video'
glGetVideouivNV.trace = True
glGetVideouivNV.play = True
gl.add(glGetVideouivNV)

glPresentFrameDualFillNV = Function('glPresentFrameDualFillNV')
glPresentFrameDualFillNV.ret = Return('void')
glPresentFrameDualFillNV.add( Input( 'video_slot','GLuint' ))
glPresentFrameDualFillNV.add( Input( 'minPresentTime','GLuint64EXT' ))
glPresentFrameDualFillNV.add( Input( 'beginPresentTimeId','GLuint' ))
glPresentFrameDualFillNV.add( Input( 'presentDurationId','GLuint' ))
glPresentFrameDualFillNV.add( Input( 'type','GLenum' ))
glPresentFrameDualFillNV.add( Input( 'target0','GLenum' ))
glPresentFrameDualFillNV.add( Input( 'fill0','GLuint' ))
glPresentFrameDualFillNV.add( Input( 'target1','GLenum' ))
glPresentFrameDualFillNV.add( Input( 'fill1','GLuint' ))
glPresentFrameDualFillNV.add( Input( 'target2','GLenum' ))
glPresentFrameDualFillNV.add( Input( 'fill2','GLuint' ))
glPresentFrameDualFillNV.add( Input( 'target3','GLenum' ))
glPresentFrameDualFillNV.add( Input( 'fill3','GLuint' ))
glPresentFrameDualFillNV.version = '1.5'
glPresentFrameDualFillNV.category = 'GL_NV_present_video'
glPresentFrameDualFillNV.trace = True
glPresentFrameDualFillNV.play = True
gl.add(glPresentFrameDualFillNV)

glPresentFrameKeyedNV = Function('glPresentFrameKeyedNV')
glPresentFrameKeyedNV.ret = Return('void')
glPresentFrameKeyedNV.add( Input( 'video_slot','GLuint' ))
glPresentFrameKeyedNV.add( Input( 'minPresentTime','GLuint64EXT' ))
glPresentFrameKeyedNV.add( Input( 'beginPresentTimeId','GLuint' ))
glPresentFrameKeyedNV.add( Input( 'presentDurationId','GLuint' ))
glPresentFrameKeyedNV.add( Input( 'type','GLenum' ))
glPresentFrameKeyedNV.add( Input( 'target0','GLenum' ))
glPresentFrameKeyedNV.add( Input( 'fill0','GLuint' ))
glPresentFrameKeyedNV.add( Input( 'key0','GLuint' ))
glPresentFrameKeyedNV.add( Input( 'target1','GLenum' ))
glPresentFrameKeyedNV.add( Input( 'fill1','GLuint' ))
glPresentFrameKeyedNV.add( Input( 'key1','GLuint' ))
glPresentFrameKeyedNV.version = '1.5'
glPresentFrameKeyedNV.category = 'GL_NV_present_video'
glPresentFrameKeyedNV.trace = True
glPresentFrameKeyedNV.play = True
gl.add(glPresentFrameKeyedNV)

# GL_NV_primitive_restart

glPrimitiveRestartIndexNV = Function('glPrimitiveRestartIndexNV')
glPrimitiveRestartIndexNV.ret = Return('void')
glPrimitiveRestartIndexNV.add( Input( 'index','GLuint' ))
glPrimitiveRestartIndexNV.version = '1.1'
glPrimitiveRestartIndexNV.category = 'GL_NV_primitive_restart'
glPrimitiveRestartIndexNV.trace = True
glPrimitiveRestartIndexNV.play = True
gl.add(glPrimitiveRestartIndexNV)

glPrimitiveRestartNV = Function('glPrimitiveRestartNV')
glPrimitiveRestartNV.ret = Return('void')
glPrimitiveRestartNV.version = '1.1'
glPrimitiveRestartNV.category = 'GL_NV_primitive_restart'
glPrimitiveRestartNV.trace = True
glPrimitiveRestartNV.play = True
gl.add(glPrimitiveRestartNV)

# GL_NV_read_buffer

glReadBufferNV = Function('glReadBufferNV')
glReadBufferNV.ret = Return('void')
glReadBufferNV.add( Input( 'mode','GLenum' ))
glReadBufferNV.version = ''
glReadBufferNV.category = 'GL_NV_read_buffer'
glReadBufferNV.trace = True
glReadBufferNV.play = True
gl.add(glReadBufferNV)

# GL_NV_register_combiners

glCombinerInputNV = Function('glCombinerInputNV')
glCombinerInputNV.ret = Return('void')
glCombinerInputNV.add( Input( 'stage','GLenum' ))
glCombinerInputNV.add( Input( 'portion','GLenum' ))
glCombinerInputNV.add( Input( 'variable','GLenum' ))
glCombinerInputNV.add( Input( 'input','GLenum' ))
glCombinerInputNV.add( Input( 'mapping','GLenum' ))
glCombinerInputNV.add( Input( 'componentUsage','GLenum' ))
glCombinerInputNV.version = '1.1'
glCombinerInputNV.category = 'GL_NV_register_combiners'
glCombinerInputNV.trace = True
glCombinerInputNV.play = True
gl.add(glCombinerInputNV)

glCombinerOutputNV = Function('glCombinerOutputNV')
glCombinerOutputNV.ret = Return('void')
glCombinerOutputNV.add( Input( 'stage','GLenum' ))
glCombinerOutputNV.add( Input( 'portion','GLenum' ))
glCombinerOutputNV.add( Input( 'abOutput','GLenum' ))
glCombinerOutputNV.add( Input( 'cdOutput','GLenum' ))
glCombinerOutputNV.add( Input( 'sumOutput','GLenum' ))
glCombinerOutputNV.add( Input( 'scale','GLenum' ))
glCombinerOutputNV.add( Input( 'bias','GLenum' ))
glCombinerOutputNV.add( Input( 'abDotProduct','GLboolean' ))
glCombinerOutputNV.add( Input( 'cdDotProduct','GLboolean' ))
glCombinerOutputNV.add( Input( 'muxSum','GLboolean' ))
glCombinerOutputNV.version = '1.1'
glCombinerOutputNV.category = 'GL_NV_register_combiners'
glCombinerOutputNV.trace = True
glCombinerOutputNV.play = True
gl.add(glCombinerOutputNV)

glCombinerParameterfNV = Function('glCombinerParameterfNV')
glCombinerParameterfNV.ret = Return('void')
glCombinerParameterfNV.add( Input( 'pname','GLenum' ))
glCombinerParameterfNV.add( Input( 'param','GLfloat' ))
glCombinerParameterfNV.version = '1.1'
glCombinerParameterfNV.category = 'GL_NV_register_combiners'
glCombinerParameterfNV.trace = True
glCombinerParameterfNV.play = True
gl.add(glCombinerParameterfNV)

glCombinerParameterfvNV = Function('glCombinerParameterfvNV')
glCombinerParameterfvNV.ret = Return('void')
glCombinerParameterfvNV.add( Input( 'pname','GLenum' ))
glCombinerParameterfvNV.add( Input( 'params','const GLfloat *' ))
glCombinerParameterfvNV.version = '1.1'
glCombinerParameterfvNV.category = 'GL_NV_register_combiners'
glCombinerParameterfvNV.trace = True
glCombinerParameterfvNV.play = False
gl.add(glCombinerParameterfvNV)

glCombinerParameteriNV = Function('glCombinerParameteriNV')
glCombinerParameteriNV.ret = Return('void')
glCombinerParameteriNV.add( Input( 'pname','GLenum' ))
glCombinerParameteriNV.add( Input( 'param','GLint' ))
glCombinerParameteriNV.version = '1.1'
glCombinerParameteriNV.category = 'GL_NV_register_combiners'
glCombinerParameteriNV.trace = True
glCombinerParameteriNV.play = True
gl.add(glCombinerParameteriNV)

glCombinerParameterivNV = Function('glCombinerParameterivNV')
glCombinerParameterivNV.ret = Return('void')
glCombinerParameterivNV.add( Input( 'pname','GLenum' ))
glCombinerParameterivNV.add( Input( 'params','const GLint *' ))
glCombinerParameterivNV.version = '1.1'
glCombinerParameterivNV.category = 'GL_NV_register_combiners'
glCombinerParameterivNV.trace = True
glCombinerParameterivNV.play = False
gl.add(glCombinerParameterivNV)

glFinalCombinerInputNV = Function('glFinalCombinerInputNV')
glFinalCombinerInputNV.ret = Return('void')
glFinalCombinerInputNV.add( Input( 'variable','GLenum' ))
glFinalCombinerInputNV.add( Input( 'input','GLenum' ))
glFinalCombinerInputNV.add( Input( 'mapping','GLenum' ))
glFinalCombinerInputNV.add( Input( 'componentUsage','GLenum' ))
glFinalCombinerInputNV.version = '1.1'
glFinalCombinerInputNV.category = 'GL_NV_register_combiners'
glFinalCombinerInputNV.trace = True
glFinalCombinerInputNV.play = True
gl.add(glFinalCombinerInputNV)

glGetCombinerInputParameterfvNV = Function('glGetCombinerInputParameterfvNV')
glGetCombinerInputParameterfvNV.ret = Return('void')
glGetCombinerInputParameterfvNV.add( Input( 'stage','GLenum' ))
glGetCombinerInputParameterfvNV.add( Input( 'portion','GLenum' ))
glGetCombinerInputParameterfvNV.add( Input( 'variable','GLenum' ))
glGetCombinerInputParameterfvNV.add( Input( 'pname','GLenum' ))
glGetCombinerInputParameterfvNV.add( Output( 'params','GLfloat *' ))
glGetCombinerInputParameterfvNV.version = '1.1'
glGetCombinerInputParameterfvNV.category = 'GL_NV_register_combiners'
glGetCombinerInputParameterfvNV.trace = True
glGetCombinerInputParameterfvNV.play = False
gl.add(glGetCombinerInputParameterfvNV)

glGetCombinerInputParameterivNV = Function('glGetCombinerInputParameterivNV')
glGetCombinerInputParameterivNV.ret = Return('void')
glGetCombinerInputParameterivNV.add( Input( 'stage','GLenum' ))
glGetCombinerInputParameterivNV.add( Input( 'portion','GLenum' ))
glGetCombinerInputParameterivNV.add( Input( 'variable','GLenum' ))
glGetCombinerInputParameterivNV.add( Input( 'pname','GLenum' ))
glGetCombinerInputParameterivNV.add( Output( 'params','GLint *' ))
glGetCombinerInputParameterivNV.version = '1.1'
glGetCombinerInputParameterivNV.category = 'GL_NV_register_combiners'
glGetCombinerInputParameterivNV.trace = True
glGetCombinerInputParameterivNV.play = False
gl.add(glGetCombinerInputParameterivNV)

glGetCombinerOutputParameterfvNV = Function('glGetCombinerOutputParameterfvNV')
glGetCombinerOutputParameterfvNV.ret = Return('void')
glGetCombinerOutputParameterfvNV.add( Input( 'stage','GLenum' ))
glGetCombinerOutputParameterfvNV.add( Input( 'portion','GLenum' ))
glGetCombinerOutputParameterfvNV.add( Input( 'pname','GLenum' ))
glGetCombinerOutputParameterfvNV.add( Output( 'params','GLfloat *' ))
glGetCombinerOutputParameterfvNV.version = '1.1'
glGetCombinerOutputParameterfvNV.category = 'GL_NV_register_combiners'
glGetCombinerOutputParameterfvNV.trace = True
glGetCombinerOutputParameterfvNV.play = False
gl.add(glGetCombinerOutputParameterfvNV)

glGetCombinerOutputParameterivNV = Function('glGetCombinerOutputParameterivNV')
glGetCombinerOutputParameterivNV.ret = Return('void')
glGetCombinerOutputParameterivNV.add( Input( 'stage','GLenum' ))
glGetCombinerOutputParameterivNV.add( Input( 'portion','GLenum' ))
glGetCombinerOutputParameterivNV.add( Input( 'pname','GLenum' ))
glGetCombinerOutputParameterivNV.add( Output( 'params','GLint *' ))
glGetCombinerOutputParameterivNV.version = '1.1'
glGetCombinerOutputParameterivNV.category = 'GL_NV_register_combiners'
glGetCombinerOutputParameterivNV.trace = True
glGetCombinerOutputParameterivNV.play = False
gl.add(glGetCombinerOutputParameterivNV)

glGetFinalCombinerInputParameterfvNV = Function('glGetFinalCombinerInputParameterfvNV')
glGetFinalCombinerInputParameterfvNV.ret = Return('void')
glGetFinalCombinerInputParameterfvNV.add( Input( 'variable','GLenum' ))
glGetFinalCombinerInputParameterfvNV.add( Input( 'pname','GLenum' ))
glGetFinalCombinerInputParameterfvNV.add( Output( 'params','GLfloat *' ))
glGetFinalCombinerInputParameterfvNV.version = '1.1'
glGetFinalCombinerInputParameterfvNV.category = 'GL_NV_register_combiners'
glGetFinalCombinerInputParameterfvNV.trace = True
glGetFinalCombinerInputParameterfvNV.play = False
gl.add(glGetFinalCombinerInputParameterfvNV)

glGetFinalCombinerInputParameterivNV = Function('glGetFinalCombinerInputParameterivNV')
glGetFinalCombinerInputParameterivNV.ret = Return('void')
glGetFinalCombinerInputParameterivNV.add( Input( 'variable','GLenum' ))
glGetFinalCombinerInputParameterivNV.add( Input( 'pname','GLenum' ))
glGetFinalCombinerInputParameterivNV.add( Output( 'params','GLint *' ))
glGetFinalCombinerInputParameterivNV.version = '1.1'
glGetFinalCombinerInputParameterivNV.category = 'GL_NV_register_combiners'
glGetFinalCombinerInputParameterivNV.trace = True
glGetFinalCombinerInputParameterivNV.play = False
gl.add(glGetFinalCombinerInputParameterivNV)

# GL_NV_register_combiners2

glCombinerStageParameterfvNV = Function('glCombinerStageParameterfvNV')
glCombinerStageParameterfvNV.ret = Return('void')
glCombinerStageParameterfvNV.add( Input( 'stage','GLenum' ))
glCombinerStageParameterfvNV.add( Input( 'pname','GLenum' ))
glCombinerStageParameterfvNV.add( Input( 'params','const GLfloat *' ))
glCombinerStageParameterfvNV.version = '1.2'
glCombinerStageParameterfvNV.category = 'GL_NV_register_combiners2'
glCombinerStageParameterfvNV.trace = True
glCombinerStageParameterfvNV.play = False
gl.add(glCombinerStageParameterfvNV)

glGetCombinerStageParameterfvNV = Function('glGetCombinerStageParameterfvNV')
glGetCombinerStageParameterfvNV.ret = Return('void')
glGetCombinerStageParameterfvNV.add( Input( 'stage','GLenum' ))
glGetCombinerStageParameterfvNV.add( Input( 'pname','GLenum' ))
glGetCombinerStageParameterfvNV.add( Output( 'params','GLfloat *' ))
glGetCombinerStageParameterfvNV.version = '1.2'
glGetCombinerStageParameterfvNV.category = 'GL_NV_register_combiners2'
glGetCombinerStageParameterfvNV.trace = True
glGetCombinerStageParameterfvNV.play = False
gl.add(glGetCombinerStageParameterfvNV)

# GL_NV_shader_buffer_load

glGetBufferParameterui64vNV = Function('glGetBufferParameterui64vNV')
glGetBufferParameterui64vNV.ret = Return('void')
glGetBufferParameterui64vNV.add( Input( 'target','GLenum' ))
glGetBufferParameterui64vNV.add( Input( 'pname','GLenum' ))
glGetBufferParameterui64vNV.add( Output( 'params','GLuint64EXT *' ))
glGetBufferParameterui64vNV.version = '3.0'
glGetBufferParameterui64vNV.category = 'GL_NV_shader_buffer_load'
glGetBufferParameterui64vNV.trace = True
glGetBufferParameterui64vNV.play = True
gl.add(glGetBufferParameterui64vNV)

glGetIntegerui64vNV = Function('glGetIntegerui64vNV')
glGetIntegerui64vNV.ret = Return('void')
glGetIntegerui64vNV.add( Input( 'target','GLenum' ))
glGetIntegerui64vNV.add( Output( 'data','GLuint64EXT *' ))
glGetIntegerui64vNV.version = '2.0'
glGetIntegerui64vNV.category = 'GL_NV_shader_buffer_load'
glGetIntegerui64vNV.trace = True
glGetIntegerui64vNV.play = False
gl.add(glGetIntegerui64vNV)

glGetNamedBufferParameterui64vNV = Function('glGetNamedBufferParameterui64vNV')
glGetNamedBufferParameterui64vNV.ret = Return('void')
glGetNamedBufferParameterui64vNV.add( Input( 'buffer','GLuint' ))
glGetNamedBufferParameterui64vNV.add( Input( 'pname','GLenum' ))
glGetNamedBufferParameterui64vNV.add( Output( 'params','GLuint64EXT *' ))
glGetNamedBufferParameterui64vNV.version = '3.0'
glGetNamedBufferParameterui64vNV.category = 'GL_NV_shader_buffer_load'
glGetNamedBufferParameterui64vNV.trace = True
glGetNamedBufferParameterui64vNV.play = True
gl.add(glGetNamedBufferParameterui64vNV)

glGetUniformui64vNV = Function('glGetUniformui64vNV')
glGetUniformui64vNV.ret = Return('void')
glGetUniformui64vNV.add( Input( 'program','GLuint' ))
glGetUniformui64vNV.add( Input( 'location','GLint' ))
glGetUniformui64vNV.add( Output( 'params','GLuint64EXT *' ))
glGetUniformui64vNV.version = '2.0'
glGetUniformui64vNV.category = 'GL_NV_shader_buffer_load'
glGetUniformui64vNV.trace = True
glGetUniformui64vNV.play = True
gl.add(glGetUniformui64vNV)

glIsBufferResidentNV = Function('glIsBufferResidentNV')
glIsBufferResidentNV.ret = Return('GLboolean')
glIsBufferResidentNV.add( Input( 'target','GLenum' ))
glIsBufferResidentNV.version = '3.0'
glIsBufferResidentNV.category = 'GL_NV_shader_buffer_load'
glIsBufferResidentNV.trace = True
glIsBufferResidentNV.play = True
gl.add(glIsBufferResidentNV)

glIsNamedBufferResidentNV = Function('glIsNamedBufferResidentNV')
glIsNamedBufferResidentNV.ret = Return('GLboolean')
glIsNamedBufferResidentNV.add( Input( 'buffer','GLuint' ))
glIsNamedBufferResidentNV.version = '3.0'
glIsNamedBufferResidentNV.category = 'GL_NV_shader_buffer_load'
glIsNamedBufferResidentNV.trace = True
glIsNamedBufferResidentNV.play = True
gl.add(glIsNamedBufferResidentNV)

glMakeBufferNonResidentNV = Function('glMakeBufferNonResidentNV')
glMakeBufferNonResidentNV.ret = Return('void')
glMakeBufferNonResidentNV.add( Input( 'target','GLenum' ))
glMakeBufferNonResidentNV.version = '3.0'
glMakeBufferNonResidentNV.category = 'GL_NV_shader_buffer_load'
glMakeBufferNonResidentNV.trace = True
glMakeBufferNonResidentNV.play = True
gl.add(glMakeBufferNonResidentNV)

glMakeBufferResidentNV = Function('glMakeBufferResidentNV')
glMakeBufferResidentNV.ret = Return('void')
glMakeBufferResidentNV.add( Input( 'target','GLenum' ))
glMakeBufferResidentNV.add( Input( 'access','GLenum' ))
glMakeBufferResidentNV.version = '3.0'
glMakeBufferResidentNV.category = 'GL_NV_shader_buffer_load'
glMakeBufferResidentNV.trace = True
glMakeBufferResidentNV.play = True
gl.add(glMakeBufferResidentNV)

glMakeNamedBufferNonResidentNV = Function('glMakeNamedBufferNonResidentNV')
glMakeNamedBufferNonResidentNV.ret = Return('void')
glMakeNamedBufferNonResidentNV.add( Input( 'buffer','GLuint' ))
glMakeNamedBufferNonResidentNV.version = '3.0'
glMakeNamedBufferNonResidentNV.category = 'GL_NV_shader_buffer_load'
glMakeNamedBufferNonResidentNV.trace = True
glMakeNamedBufferNonResidentNV.play = True
gl.add(glMakeNamedBufferNonResidentNV)

glMakeNamedBufferResidentNV = Function('glMakeNamedBufferResidentNV')
glMakeNamedBufferResidentNV.ret = Return('void')
glMakeNamedBufferResidentNV.add( Input( 'buffer','GLuint' ))
glMakeNamedBufferResidentNV.add( Input( 'access','GLenum' ))
glMakeNamedBufferResidentNV.version = '3.0'
glMakeNamedBufferResidentNV.category = 'GL_NV_shader_buffer_load'
glMakeNamedBufferResidentNV.trace = True
glMakeNamedBufferResidentNV.play = True
gl.add(glMakeNamedBufferResidentNV)

glProgramUniformui64NV = Function('glProgramUniformui64NV')
glProgramUniformui64NV.ret = Return('void')
glProgramUniformui64NV.add( Input( 'program','GLuint' ))
glProgramUniformui64NV.add( Input( 'location','GLint' ))
glProgramUniformui64NV.add( Input( 'v0','GLuint64EXT' ))
glProgramUniformui64NV.version = '2.0'
glProgramUniformui64NV.category = 'GL_NV_shader_buffer_load'
glProgramUniformui64NV.trace = True
glProgramUniformui64NV.play = True
gl.add(glProgramUniformui64NV)

glProgramUniformui64vNV = Function('glProgramUniformui64vNV')
glProgramUniformui64vNV.ret = Return('void')
glProgramUniformui64vNV.add( Input( 'program','GLuint' ))
glProgramUniformui64vNV.add( Input( 'location','GLint' ))
glProgramUniformui64vNV.add( Input( 'count','GLsizei' ))
glProgramUniformui64vNV.add( Input( 'value','const GLuint64EXT *' ,size = 'count' ))
glProgramUniformui64vNV.version = '2.0'
glProgramUniformui64vNV.category = 'GL_NV_shader_buffer_load'
glProgramUniformui64vNV.trace = True
glProgramUniformui64vNV.play = True
gl.add(glProgramUniformui64vNV)

glUniformui64NV = Function('glUniformui64NV')
glUniformui64NV.ret = Return('void')
glUniformui64NV.add( Input( 'location','GLint' ))
glUniformui64NV.add( Input( 'v0','GLuint64EXT' ))
glUniformui64NV.version = '2.0'
glUniformui64NV.category = 'GL_NV_shader_buffer_load'
glUniformui64NV.trace = True
glUniformui64NV.play = True
gl.add(glUniformui64NV)

glUniformui64vNV = Function('glUniformui64vNV')
glUniformui64vNV.ret = Return('void')
glUniformui64vNV.add( Input( 'location','GLint' ))
glUniformui64vNV.add( Input( 'count','GLsizei' ))
glUniformui64vNV.add( Input( 'value','const GLuint64EXT *' ,size = 'count' ))
glUniformui64vNV.version = '2.0'
glUniformui64vNV.category = 'GL_NV_shader_buffer_load'
glUniformui64vNV.trace = True
glUniformui64vNV.play = True
gl.add(glUniformui64vNV)

# GL_NV_texture_barrier

glTextureBarrierNV = Function('glTextureBarrierNV')
glTextureBarrierNV.ret = Return('void')
glTextureBarrierNV.version = '1.3'
glTextureBarrierNV.category = 'GL_NV_texture_barrier'
glTextureBarrierNV.trace = True
glTextureBarrierNV.play = True
gl.add(glTextureBarrierNV)

# GL_NV_texture_multisample

glTexImage2DMultisampleCoverageNV = Function('glTexImage2DMultisampleCoverageNV')
glTexImage2DMultisampleCoverageNV.ret = Return('void')
glTexImage2DMultisampleCoverageNV.add( Input( 'target','GLenum' ))
glTexImage2DMultisampleCoverageNV.add( Input( 'coverageSamples','GLsizei' ))
glTexImage2DMultisampleCoverageNV.add( Input( 'colorSamples','GLsizei' ))
glTexImage2DMultisampleCoverageNV.add( Input( 'internalFormat','GLint' ))
glTexImage2DMultisampleCoverageNV.add( Input( 'width','GLsizei' ))
glTexImage2DMultisampleCoverageNV.add( Input( 'height','GLsizei' ))
glTexImage2DMultisampleCoverageNV.add( Input( 'fixedSampleLocations','GLboolean' ))
glTexImage2DMultisampleCoverageNV.version = ''
glTexImage2DMultisampleCoverageNV.category = 'GL_NV_texture_multisample'
glTexImage2DMultisampleCoverageNV.trace = True
glTexImage2DMultisampleCoverageNV.play = True
gl.add(glTexImage2DMultisampleCoverageNV)

glTexImage3DMultisampleCoverageNV = Function('glTexImage3DMultisampleCoverageNV')
glTexImage3DMultisampleCoverageNV.ret = Return('void')
glTexImage3DMultisampleCoverageNV.add( Input( 'target','GLenum' ))
glTexImage3DMultisampleCoverageNV.add( Input( 'coverageSamples','GLsizei' ))
glTexImage3DMultisampleCoverageNV.add( Input( 'colorSamples','GLsizei' ))
glTexImage3DMultisampleCoverageNV.add( Input( 'internalFormat','GLint' ))
glTexImage3DMultisampleCoverageNV.add( Input( 'width','GLsizei' ))
glTexImage3DMultisampleCoverageNV.add( Input( 'height','GLsizei' ))
glTexImage3DMultisampleCoverageNV.add( Input( 'depth','GLsizei' ))
glTexImage3DMultisampleCoverageNV.add( Input( 'fixedSampleLocations','GLboolean' ))
glTexImage3DMultisampleCoverageNV.version = ''
glTexImage3DMultisampleCoverageNV.category = 'GL_NV_texture_multisample'
glTexImage3DMultisampleCoverageNV.trace = True
glTexImage3DMultisampleCoverageNV.play = True
gl.add(glTexImage3DMultisampleCoverageNV)

glTextureImage2DMultisampleCoverageNV = Function('glTextureImage2DMultisampleCoverageNV')
glTextureImage2DMultisampleCoverageNV.ret = Return('void')
glTextureImage2DMultisampleCoverageNV.add( Input( 'texture','GLuint' ))
glTextureImage2DMultisampleCoverageNV.add( Input( 'target','GLenum' ))
glTextureImage2DMultisampleCoverageNV.add( Input( 'coverageSamples','GLsizei' ))
glTextureImage2DMultisampleCoverageNV.add( Input( 'colorSamples','GLsizei' ))
glTextureImage2DMultisampleCoverageNV.add( Input( 'internalFormat','GLint' ))
glTextureImage2DMultisampleCoverageNV.add( Input( 'width','GLsizei' ))
glTextureImage2DMultisampleCoverageNV.add( Input( 'height','GLsizei' ))
glTextureImage2DMultisampleCoverageNV.add( Input( 'fixedSampleLocations','GLboolean' ))
glTextureImage2DMultisampleCoverageNV.version = ''
glTextureImage2DMultisampleCoverageNV.category = 'GL_NV_texture_multisample'
glTextureImage2DMultisampleCoverageNV.trace = True
glTextureImage2DMultisampleCoverageNV.play = True
gl.add(glTextureImage2DMultisampleCoverageNV)

glTextureImage2DMultisampleNV = Function('glTextureImage2DMultisampleNV')
glTextureImage2DMultisampleNV.ret = Return('void')
glTextureImage2DMultisampleNV.add( Input( 'texture','GLuint' ))
glTextureImage2DMultisampleNV.add( Input( 'target','GLenum' ))
glTextureImage2DMultisampleNV.add( Input( 'samples','GLsizei' ))
glTextureImage2DMultisampleNV.add( Input( 'internalFormat','GLint' ))
glTextureImage2DMultisampleNV.add( Input( 'width','GLsizei' ))
glTextureImage2DMultisampleNV.add( Input( 'height','GLsizei' ))
glTextureImage2DMultisampleNV.add( Input( 'fixedSampleLocations','GLboolean' ))
glTextureImage2DMultisampleNV.version = ''
glTextureImage2DMultisampleNV.category = 'GL_NV_texture_multisample'
glTextureImage2DMultisampleNV.trace = True
glTextureImage2DMultisampleNV.play = True
gl.add(glTextureImage2DMultisampleNV)

glTextureImage3DMultisampleCoverageNV = Function('glTextureImage3DMultisampleCoverageNV')
glTextureImage3DMultisampleCoverageNV.ret = Return('void')
glTextureImage3DMultisampleCoverageNV.add( Input( 'texture','GLuint' ))
glTextureImage3DMultisampleCoverageNV.add( Input( 'target','GLenum' ))
glTextureImage3DMultisampleCoverageNV.add( Input( 'coverageSamples','GLsizei' ))
glTextureImage3DMultisampleCoverageNV.add( Input( 'colorSamples','GLsizei' ))
glTextureImage3DMultisampleCoverageNV.add( Input( 'internalFormat','GLint' ))
glTextureImage3DMultisampleCoverageNV.add( Input( 'width','GLsizei' ))
glTextureImage3DMultisampleCoverageNV.add( Input( 'height','GLsizei' ))
glTextureImage3DMultisampleCoverageNV.add( Input( 'depth','GLsizei' ))
glTextureImage3DMultisampleCoverageNV.add( Input( 'fixedSampleLocations','GLboolean' ))
glTextureImage3DMultisampleCoverageNV.version = ''
glTextureImage3DMultisampleCoverageNV.category = 'GL_NV_texture_multisample'
glTextureImage3DMultisampleCoverageNV.trace = True
glTextureImage3DMultisampleCoverageNV.play = True
gl.add(glTextureImage3DMultisampleCoverageNV)

glTextureImage3DMultisampleNV = Function('glTextureImage3DMultisampleNV')
glTextureImage3DMultisampleNV.ret = Return('void')
glTextureImage3DMultisampleNV.add( Input( 'texture','GLuint' ))
glTextureImage3DMultisampleNV.add( Input( 'target','GLenum' ))
glTextureImage3DMultisampleNV.add( Input( 'samples','GLsizei' ))
glTextureImage3DMultisampleNV.add( Input( 'internalFormat','GLint' ))
glTextureImage3DMultisampleNV.add( Input( 'width','GLsizei' ))
glTextureImage3DMultisampleNV.add( Input( 'height','GLsizei' ))
glTextureImage3DMultisampleNV.add( Input( 'depth','GLsizei' ))
glTextureImage3DMultisampleNV.add( Input( 'fixedSampleLocations','GLboolean' ))
glTextureImage3DMultisampleNV.version = ''
glTextureImage3DMultisampleNV.category = 'GL_NV_texture_multisample'
glTextureImage3DMultisampleNV.trace = True
glTextureImage3DMultisampleNV.play = True
gl.add(glTextureImage3DMultisampleNV)

# GL_NV_transform_feedback

glActiveVaryingNV = Function('glActiveVaryingNV')
glActiveVaryingNV.ret = Return('void')
glActiveVaryingNV.add( Input( 'program','GLuint' ))
glActiveVaryingNV.add( Input( 'name','const GLchar *' ))
glActiveVaryingNV.version = '1.5'
glActiveVaryingNV.category = 'GL_NV_transform_feedback'
glActiveVaryingNV.trace = True
glActiveVaryingNV.play = True
gl.add(glActiveVaryingNV)

glBeginTransformFeedbackNV = Function('glBeginTransformFeedbackNV')
glBeginTransformFeedbackNV.ret = Return('void')
glBeginTransformFeedbackNV.add( Input( 'primitiveMode','GLenum' ))
glBeginTransformFeedbackNV.version = '1.5'
glBeginTransformFeedbackNV.category = 'GL_NV_transform_feedback'
glBeginTransformFeedbackNV.trace = True
glBeginTransformFeedbackNV.play = True
gl.add(glBeginTransformFeedbackNV)

glBindBufferBaseNV = Function('glBindBufferBaseNV')
glBindBufferBaseNV.ret = Return('void')
glBindBufferBaseNV.add( Input( 'target','GLenum' ))
glBindBufferBaseNV.add( Input( 'index','GLuint' ))
glBindBufferBaseNV.add( Input( 'buffer','GLuint' ))
glBindBufferBaseNV.version = '1.5'
glBindBufferBaseNV.category = 'GL_NV_transform_feedback'
glBindBufferBaseNV.trace = True
glBindBufferBaseNV.play = True
gl.add(glBindBufferBaseNV)

glBindBufferOffsetNV = Function('glBindBufferOffsetNV')
glBindBufferOffsetNV.ret = Return('void')
glBindBufferOffsetNV.add( Input( 'target','GLenum' ))
glBindBufferOffsetNV.add( Input( 'index','GLuint' ))
glBindBufferOffsetNV.add( Input( 'buffer','GLuint' ))
glBindBufferOffsetNV.add( Input( 'offset','GLintptr' ))
glBindBufferOffsetNV.version = '1.5'
glBindBufferOffsetNV.category = 'GL_NV_transform_feedback'
glBindBufferOffsetNV.trace = True
glBindBufferOffsetNV.play = True
gl.add(glBindBufferOffsetNV)

glBindBufferRangeNV = Function('glBindBufferRangeNV')
glBindBufferRangeNV.ret = Return('void')
glBindBufferRangeNV.add( Input( 'target','GLenum' ))
glBindBufferRangeNV.add( Input( 'index','GLuint' ))
glBindBufferRangeNV.add( Input( 'buffer','GLuint' ))
glBindBufferRangeNV.add( Input( 'offset','GLintptr' ))
glBindBufferRangeNV.add( Input( 'size','GLsizeiptr' ))
glBindBufferRangeNV.version = '1.5'
glBindBufferRangeNV.category = 'GL_NV_transform_feedback'
glBindBufferRangeNV.trace = True
glBindBufferRangeNV.play = True
gl.add(glBindBufferRangeNV)

glEndTransformFeedbackNV = Function('glEndTransformFeedbackNV')
glEndTransformFeedbackNV.ret = Return('void')
glEndTransformFeedbackNV.version = '1.5'
glEndTransformFeedbackNV.category = 'GL_NV_transform_feedback'
glEndTransformFeedbackNV.trace = True
glEndTransformFeedbackNV.play = True
gl.add(glEndTransformFeedbackNV)

glGetActiveVaryingNV = Function('glGetActiveVaryingNV')
glGetActiveVaryingNV.ret = Return('void')
glGetActiveVaryingNV.add( Input( 'program','GLuint' ))
glGetActiveVaryingNV.add( Input( 'index','GLuint' ))
glGetActiveVaryingNV.add( Input( 'bufSize','GLsizei' ))
glGetActiveVaryingNV.add( Output( 'length','GLsizei *' ,size = 1 ))
glGetActiveVaryingNV.add( Output( 'size','GLsizei *' ,size = 1 ))
glGetActiveVaryingNV.add( Output( 'type','GLenum *' ,size = 1 ))
glGetActiveVaryingNV.add( Output( 'name','GLchar *' ,maxSize = 'bufSize' ))
glGetActiveVaryingNV.version = '1.5'
glGetActiveVaryingNV.category = 'GL_NV_transform_feedback'
glGetActiveVaryingNV.trace = True
glGetActiveVaryingNV.play = False
gl.add(glGetActiveVaryingNV)

glGetTransformFeedbackVaryingNV = Function('glGetTransformFeedbackVaryingNV')
glGetTransformFeedbackVaryingNV.ret = Return('void')
glGetTransformFeedbackVaryingNV.add( Input( 'program','GLuint' ))
glGetTransformFeedbackVaryingNV.add( Input( 'index','GLuint' ))
glGetTransformFeedbackVaryingNV.add( Output( 'location','GLint *' ,size = 1 ))
glGetTransformFeedbackVaryingNV.version = '1.5'
glGetTransformFeedbackVaryingNV.category = 'GL_NV_transform_feedback'
glGetTransformFeedbackVaryingNV.trace = True
glGetTransformFeedbackVaryingNV.play = True
gl.add(glGetTransformFeedbackVaryingNV)

glGetVaryingLocationNV = Function('glGetVaryingLocationNV')
glGetVaryingLocationNV.ret = Return('GLint')
glGetVaryingLocationNV.add( Input( 'program','GLuint' ))
glGetVaryingLocationNV.add( Input( 'name','const GLchar *' ))
glGetVaryingLocationNV.version = '1.5'
glGetVaryingLocationNV.category = 'GL_NV_transform_feedback'
glGetVaryingLocationNV.trace = True
glGetVaryingLocationNV.play = True
gl.add(glGetVaryingLocationNV)

glTransformFeedbackAttribsNV = Function('glTransformFeedbackAttribsNV')
glTransformFeedbackAttribsNV.ret = Return('void')
glTransformFeedbackAttribsNV.add( Input( 'count','GLuint' ))
glTransformFeedbackAttribsNV.add( Input( 'attribs','const GLint *' ))
glTransformFeedbackAttribsNV.add( Input( 'bufferMode','GLenum' ))
glTransformFeedbackAttribsNV.version = '1.5'
glTransformFeedbackAttribsNV.category = 'GL_NV_transform_feedback'
glTransformFeedbackAttribsNV.trace = True
glTransformFeedbackAttribsNV.play = True
gl.add(glTransformFeedbackAttribsNV)

glTransformFeedbackVaryingsNV = Function('glTransformFeedbackVaryingsNV')
glTransformFeedbackVaryingsNV.ret = Return('void')
glTransformFeedbackVaryingsNV.add( Input( 'program','GLuint' ))
glTransformFeedbackVaryingsNV.add( Input( 'count','GLsizei' ))
glTransformFeedbackVaryingsNV.add( Input( 'locations','const GLint *' ,size = 'count' ))
glTransformFeedbackVaryingsNV.add( Input( 'bufferMode','GLenum' ))
glTransformFeedbackVaryingsNV.version = '1.5'
glTransformFeedbackVaryingsNV.category = 'GL_NV_transform_feedback'
glTransformFeedbackVaryingsNV.trace = True
glTransformFeedbackVaryingsNV.play = True
gl.add(glTransformFeedbackVaryingsNV)

# GL_NV_transform_feedback2

glBindTransformFeedbackNV = Function('glBindTransformFeedbackNV')
glBindTransformFeedbackNV.ret = Return('void')
glBindTransformFeedbackNV.add( Input( 'target','GLenum' ))
glBindTransformFeedbackNV.add( Input( 'id','GLuint' ))
glBindTransformFeedbackNV.version = '2.0'
glBindTransformFeedbackNV.category = 'GL_NV_transform_feedback2'
glBindTransformFeedbackNV.trace = True
glBindTransformFeedbackNV.play = True
gl.add(glBindTransformFeedbackNV)

glDeleteTransformFeedbacksNV = Function('glDeleteTransformFeedbacksNV')
glDeleteTransformFeedbacksNV.ret = Return('void')
glDeleteTransformFeedbacksNV.add( Input( 'n','GLsizei' ))
glDeleteTransformFeedbacksNV.add( Input( 'ids','const GLuint *' ,size = 'n' ))
glDeleteTransformFeedbacksNV.version = '2.0'
glDeleteTransformFeedbacksNV.category = 'GL_NV_transform_feedback2'
glDeleteTransformFeedbacksNV.trace = True
glDeleteTransformFeedbacksNV.play = True
gl.add(glDeleteTransformFeedbacksNV)

glDrawTransformFeedbackNV = Function('glDrawTransformFeedbackNV')
glDrawTransformFeedbackNV.ret = Return('void')
glDrawTransformFeedbackNV.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glDrawTransformFeedbackNV.add( Input( 'name','GLuint' ))
glDrawTransformFeedbackNV.version = '2.0'
glDrawTransformFeedbackNV.category = 'GL_NV_transform_feedback2'
glDrawTransformFeedbackNV.trace = True
glDrawTransformFeedbackNV.play = True
gl.add(glDrawTransformFeedbackNV)

glGenTransformFeedbacksNV = Function('glGenTransformFeedbacksNV')
glGenTransformFeedbacksNV.ret = Return('void')
glGenTransformFeedbacksNV.add( Input( 'n','GLsizei' ))
glGenTransformFeedbacksNV.add( Output( 'ids','GLuint *' ,size = 'n' ))
glGenTransformFeedbacksNV.version = '2.0'
glGenTransformFeedbacksNV.category = 'GL_NV_transform_feedback2'
glGenTransformFeedbacksNV.trace = True
glGenTransformFeedbacksNV.play = True
gl.add(glGenTransformFeedbacksNV)

glIsTransformFeedbackNV = Function('glIsTransformFeedbackNV')
glIsTransformFeedbackNV.ret = Return('GLboolean')
glIsTransformFeedbackNV.add( Input( 'id','GLuint' ))
glIsTransformFeedbackNV.version = '2.0'
glIsTransformFeedbackNV.category = 'GL_NV_transform_feedback2'
glIsTransformFeedbackNV.trace = True
glIsTransformFeedbackNV.play = True
gl.add(glIsTransformFeedbackNV)

glPauseTransformFeedbackNV = Function('glPauseTransformFeedbackNV')
glPauseTransformFeedbackNV.ret = Return('void')
glPauseTransformFeedbackNV.version = '2.0'
glPauseTransformFeedbackNV.category = 'GL_NV_transform_feedback2'
glPauseTransformFeedbackNV.trace = True
glPauseTransformFeedbackNV.play = True
gl.add(glPauseTransformFeedbackNV)

glResumeTransformFeedbackNV = Function('glResumeTransformFeedbackNV')
glResumeTransformFeedbackNV.ret = Return('void')
glResumeTransformFeedbackNV.version = '2.0'
glResumeTransformFeedbackNV.category = 'GL_NV_transform_feedback2'
glResumeTransformFeedbackNV.trace = True
glResumeTransformFeedbackNV.play = True
gl.add(glResumeTransformFeedbackNV)

# GL_NV_vdpau_interop

glVDPAUFiniNV = Function('glVDPAUFiniNV')
glVDPAUFiniNV.ret = Return('void')
glVDPAUFiniNV.version = '3.2'
glVDPAUFiniNV.category = 'GL_NV_vdpau_interop'
glVDPAUFiniNV.trace = True
glVDPAUFiniNV.play = True
gl.add(glVDPAUFiniNV)

glVDPAUGetSurfaceivNV = Function('glVDPAUGetSurfaceivNV')
glVDPAUGetSurfaceivNV.ret = Return('void')
glVDPAUGetSurfaceivNV.add( Input( 'surface','GLvdpauSurfaceNV' ))
glVDPAUGetSurfaceivNV.add( Input( 'pname','GLenum' ))
glVDPAUGetSurfaceivNV.add( Input( 'bufSize','GLsizei' ))
glVDPAUGetSurfaceivNV.add( Output( 'length','GLsizei *' ,size = 1 ))
glVDPAUGetSurfaceivNV.add( Output( 'values','GLint *' ,size = 'bufSize' ))
glVDPAUGetSurfaceivNV.version = '3.2'
glVDPAUGetSurfaceivNV.category = 'GL_NV_vdpau_interop'
glVDPAUGetSurfaceivNV.trace = True
glVDPAUGetSurfaceivNV.play = True
gl.add(glVDPAUGetSurfaceivNV)

glVDPAUInitNV = Function('glVDPAUInitNV')
glVDPAUInitNV.ret = Return('void')
glVDPAUInitNV.add( Input( 'vdpDevice','const GLvoid *' ))
glVDPAUInitNV.add( Input( 'getProcAddress','const GLvoid *' ))
glVDPAUInitNV.version = '3.2'
glVDPAUInitNV.category = 'GL_NV_vdpau_interop'
glVDPAUInitNV.trace = True
glVDPAUInitNV.play = True
gl.add(glVDPAUInitNV)

glVDPAUIsSurfaceNV = Function('glVDPAUIsSurfaceNV')
glVDPAUIsSurfaceNV.ret = Return('GLboolean')
glVDPAUIsSurfaceNV.add( Input( 'surface','GLvdpauSurfaceNV' ))
glVDPAUIsSurfaceNV.version = '3.2'
glVDPAUIsSurfaceNV.category = 'GL_NV_vdpau_interop'
glVDPAUIsSurfaceNV.trace = True
glVDPAUIsSurfaceNV.play = True
gl.add(glVDPAUIsSurfaceNV)

glVDPAUMapSurfacesNV = Function('glVDPAUMapSurfacesNV')
glVDPAUMapSurfacesNV.ret = Return('void')
glVDPAUMapSurfacesNV.add( Input( 'numSurfaces','GLsizei' ))
glVDPAUMapSurfacesNV.add( Input( 'surfaces','const GLvdpauSurfaceNV *' ,size = 'numSurfaces' ))
glVDPAUMapSurfacesNV.version = '3.2'
glVDPAUMapSurfacesNV.category = 'GL_NV_vdpau_interop'
glVDPAUMapSurfacesNV.trace = True
glVDPAUMapSurfacesNV.play = True
gl.add(glVDPAUMapSurfacesNV)

glVDPAURegisterOutputSurfaceNV = Function('glVDPAURegisterOutputSurfaceNV')
glVDPAURegisterOutputSurfaceNV.ret = Return('GLvdpauSurfaceNV')
glVDPAURegisterOutputSurfaceNV.add( Input( 'vdpSurface','const GLvoid *' ))
glVDPAURegisterOutputSurfaceNV.add( Input( 'target','GLenum' ))
glVDPAURegisterOutputSurfaceNV.add( Input( 'numTextureNames','GLsizei' ))
glVDPAURegisterOutputSurfaceNV.add( Input( 'textureNames','const GLuint *' ,size = 'numTextureNames' ))
glVDPAURegisterOutputSurfaceNV.version = '3.2'
glVDPAURegisterOutputSurfaceNV.category = 'GL_NV_vdpau_interop'
glVDPAURegisterOutputSurfaceNV.trace = True
glVDPAURegisterOutputSurfaceNV.play = True
gl.add(glVDPAURegisterOutputSurfaceNV)

glVDPAURegisterVideoSurfaceNV = Function('glVDPAURegisterVideoSurfaceNV')
glVDPAURegisterVideoSurfaceNV.ret = Return('GLvdpauSurfaceNV')
glVDPAURegisterVideoSurfaceNV.add( Input( 'vdpSurface','const GLvoid *' ))
glVDPAURegisterVideoSurfaceNV.add( Input( 'target','GLenum' ))
glVDPAURegisterVideoSurfaceNV.add( Input( 'numTextureNames','GLsizei' ))
glVDPAURegisterVideoSurfaceNV.add( Input( 'textureNames','const GLuint *' ,size = 'numTextureNames' ))
glVDPAURegisterVideoSurfaceNV.version = '3.2'
glVDPAURegisterVideoSurfaceNV.category = 'GL_NV_vdpau_interop'
glVDPAURegisterVideoSurfaceNV.trace = True
glVDPAURegisterVideoSurfaceNV.play = True
gl.add(glVDPAURegisterVideoSurfaceNV)

glVDPAUSurfaceAccessNV = Function('glVDPAUSurfaceAccessNV')
glVDPAUSurfaceAccessNV.ret = Return('void')
glVDPAUSurfaceAccessNV.add( Input( 'surface','GLvdpauSurfaceNV' ))
glVDPAUSurfaceAccessNV.add( Input( 'access','GLenum' ))
glVDPAUSurfaceAccessNV.version = '3.2'
glVDPAUSurfaceAccessNV.category = 'GL_NV_vdpau_interop'
glVDPAUSurfaceAccessNV.trace = True
glVDPAUSurfaceAccessNV.play = True
gl.add(glVDPAUSurfaceAccessNV)

glVDPAUUnmapSurfacesNV = Function('glVDPAUUnmapSurfacesNV')
glVDPAUUnmapSurfacesNV.ret = Return('void')
glVDPAUUnmapSurfacesNV.add( Input( 'numSurfaces','GLsizei' ))
glVDPAUUnmapSurfacesNV.add( Input( 'surfaces','const GLvdpauSurfaceNV *' ,size = 'numSurfaces' ))
glVDPAUUnmapSurfacesNV.version = '3.2'
glVDPAUUnmapSurfacesNV.category = 'GL_NV_vdpau_interop'
glVDPAUUnmapSurfacesNV.trace = True
glVDPAUUnmapSurfacesNV.play = True
gl.add(glVDPAUUnmapSurfacesNV)

glVDPAUUnregisterSurfaceNV = Function('glVDPAUUnregisterSurfaceNV')
glVDPAUUnregisterSurfaceNV.ret = Return('void')
glVDPAUUnregisterSurfaceNV.add( Input( 'surface','GLvdpauSurfaceNV' ))
glVDPAUUnregisterSurfaceNV.version = '3.2'
glVDPAUUnregisterSurfaceNV.category = 'GL_NV_vdpau_interop'
glVDPAUUnregisterSurfaceNV.trace = True
glVDPAUUnregisterSurfaceNV.play = True
gl.add(glVDPAUUnregisterSurfaceNV)

# GL_NV_vertex_array_range

glFlushVertexArrayRangeNV = Function('glFlushVertexArrayRangeNV')
glFlushVertexArrayRangeNV.ret = Return('void')
glFlushVertexArrayRangeNV.version = '1.1'
glFlushVertexArrayRangeNV.category = 'GL_NV_vertex_array_range'
glFlushVertexArrayRangeNV.trace = True
glFlushVertexArrayRangeNV.play = True
gl.add(glFlushVertexArrayRangeNV)

glVertexArrayRangeNV = Function('glVertexArrayRangeNV')
glVertexArrayRangeNV.ret = Return('void')
glVertexArrayRangeNV.add( Input( 'size','GLsizei' ))
glVertexArrayRangeNV.add( Input( 'pointer','const GLvoid *' ))
glVertexArrayRangeNV.version = '1.1'
glVertexArrayRangeNV.category = 'GL_NV_vertex_array_range'
glVertexArrayRangeNV.trace = True
glVertexArrayRangeNV.play = True
gl.add(glVertexArrayRangeNV)

# GL_NV_vertex_attrib_integer_64bit

glGetVertexAttribLi64vNV = Function('glGetVertexAttribLi64vNV')
glGetVertexAttribLi64vNV.ret = Return('void')
glGetVertexAttribLi64vNV.add( Input( 'index','GLuint' ))
glGetVertexAttribLi64vNV.add( Input( 'pname','GLenum' ))
glGetVertexAttribLi64vNV.add( Output( 'params','GLint64EXT *' ,size = 1 ))
glGetVertexAttribLi64vNV.version = ''
glGetVertexAttribLi64vNV.category = 'GL_NV_vertex_attrib_integer_64bit'
glGetVertexAttribLi64vNV.trace = True
glGetVertexAttribLi64vNV.play = True
gl.add(glGetVertexAttribLi64vNV)

glGetVertexAttribLui64vNV = Function('glGetVertexAttribLui64vNV')
glGetVertexAttribLui64vNV.ret = Return('void')
glGetVertexAttribLui64vNV.add( Input( 'index','GLuint' ))
glGetVertexAttribLui64vNV.add( Input( 'pname','GLenum' ))
glGetVertexAttribLui64vNV.add( Output( 'params','GLuint64EXT *' ,size = 1 ))
glGetVertexAttribLui64vNV.version = ''
glGetVertexAttribLui64vNV.category = 'GL_NV_vertex_attrib_integer_64bit'
glGetVertexAttribLui64vNV.trace = True
glGetVertexAttribLui64vNV.play = True
gl.add(glGetVertexAttribLui64vNV)

glVertexAttribL1i64NV = Function('glVertexAttribL1i64NV')
glVertexAttribL1i64NV.ret = Return('void')
glVertexAttribL1i64NV.add( Input( 'index','GLuint' ))
glVertexAttribL1i64NV.add( Input( 'x','GLint64EXT' ))
glVertexAttribL1i64NV.version = ''
glVertexAttribL1i64NV.category = 'GL_NV_vertex_attrib_integer_64bit'
glVertexAttribL1i64NV.trace = True
glVertexAttribL1i64NV.play = True
gl.add(glVertexAttribL1i64NV)

glVertexAttribL1i64vNV = Function('glVertexAttribL1i64vNV')
glVertexAttribL1i64vNV.ret = Return('void')
glVertexAttribL1i64vNV.add( Input( 'index','GLuint' ))
glVertexAttribL1i64vNV.add( Input( 'v','const GLint64EXT *' ,size = 1 ))
glVertexAttribL1i64vNV.version = ''
glVertexAttribL1i64vNV.category = 'GL_NV_vertex_attrib_integer_64bit'
glVertexAttribL1i64vNV.trace = True
glVertexAttribL1i64vNV.play = True
gl.add(glVertexAttribL1i64vNV)

glVertexAttribL1ui64NV = Function('glVertexAttribL1ui64NV')
glVertexAttribL1ui64NV.ret = Return('void')
glVertexAttribL1ui64NV.add( Input( 'index','GLuint' ))
glVertexAttribL1ui64NV.add( Input( 'x','GLuint64EXT' ))
glVertexAttribL1ui64NV.version = ''
glVertexAttribL1ui64NV.category = 'GL_NV_vertex_attrib_integer_64bit'
glVertexAttribL1ui64NV.trace = True
glVertexAttribL1ui64NV.play = True
gl.add(glVertexAttribL1ui64NV)

glVertexAttribL1ui64vNV = Function('glVertexAttribL1ui64vNV')
glVertexAttribL1ui64vNV.ret = Return('void')
glVertexAttribL1ui64vNV.add( Input( 'index','GLuint' ))
glVertexAttribL1ui64vNV.add( Input( 'v','const GLuint64EXT *' ,size = 1 ))
glVertexAttribL1ui64vNV.version = ''
glVertexAttribL1ui64vNV.category = 'GL_NV_vertex_attrib_integer_64bit'
glVertexAttribL1ui64vNV.trace = True
glVertexAttribL1ui64vNV.play = True
gl.add(glVertexAttribL1ui64vNV)

glVertexAttribL2i64NV = Function('glVertexAttribL2i64NV')
glVertexAttribL2i64NV.ret = Return('void')
glVertexAttribL2i64NV.add( Input( 'index','GLuint' ))
glVertexAttribL2i64NV.add( Input( 'x','GLint64EXT' ))
glVertexAttribL2i64NV.add( Input( 'y','GLint64EXT' ))
glVertexAttribL2i64NV.version = ''
glVertexAttribL2i64NV.category = 'GL_NV_vertex_attrib_integer_64bit'
glVertexAttribL2i64NV.trace = True
glVertexAttribL2i64NV.play = True
gl.add(glVertexAttribL2i64NV)

glVertexAttribL2i64vNV = Function('glVertexAttribL2i64vNV')
glVertexAttribL2i64vNV.ret = Return('void')
glVertexAttribL2i64vNV.add( Input( 'index','GLuint' ))
glVertexAttribL2i64vNV.add( Input( 'v','const GLint64EXT *' ,size = 2 ))
glVertexAttribL2i64vNV.version = ''
glVertexAttribL2i64vNV.category = 'GL_NV_vertex_attrib_integer_64bit'
glVertexAttribL2i64vNV.trace = True
glVertexAttribL2i64vNV.play = True
gl.add(glVertexAttribL2i64vNV)

glVertexAttribL2ui64NV = Function('glVertexAttribL2ui64NV')
glVertexAttribL2ui64NV.ret = Return('void')
glVertexAttribL2ui64NV.add( Input( 'index','GLuint' ))
glVertexAttribL2ui64NV.add( Input( 'x','GLuint64EXT' ))
glVertexAttribL2ui64NV.add( Input( 'y','GLuint64EXT' ))
glVertexAttribL2ui64NV.version = ''
glVertexAttribL2ui64NV.category = 'GL_NV_vertex_attrib_integer_64bit'
glVertexAttribL2ui64NV.trace = True
glVertexAttribL2ui64NV.play = True
gl.add(glVertexAttribL2ui64NV)

glVertexAttribL2ui64vNV = Function('glVertexAttribL2ui64vNV')
glVertexAttribL2ui64vNV.ret = Return('void')
glVertexAttribL2ui64vNV.add( Input( 'index','GLuint' ))
glVertexAttribL2ui64vNV.add( Input( 'v','const GLuint64EXT *' ,size = 2 ))
glVertexAttribL2ui64vNV.version = ''
glVertexAttribL2ui64vNV.category = 'GL_NV_vertex_attrib_integer_64bit'
glVertexAttribL2ui64vNV.trace = True
glVertexAttribL2ui64vNV.play = True
gl.add(glVertexAttribL2ui64vNV)

glVertexAttribL3i64NV = Function('glVertexAttribL3i64NV')
glVertexAttribL3i64NV.ret = Return('void')
glVertexAttribL3i64NV.add( Input( 'index','GLuint' ))
glVertexAttribL3i64NV.add( Input( 'x','GLint64EXT' ))
glVertexAttribL3i64NV.add( Input( 'y','GLint64EXT' ))
glVertexAttribL3i64NV.add( Input( 'z','GLint64EXT' ))
glVertexAttribL3i64NV.version = ''
glVertexAttribL3i64NV.category = 'GL_NV_vertex_attrib_integer_64bit'
glVertexAttribL3i64NV.trace = True
glVertexAttribL3i64NV.play = True
gl.add(glVertexAttribL3i64NV)

glVertexAttribL3i64vNV = Function('glVertexAttribL3i64vNV')
glVertexAttribL3i64vNV.ret = Return('void')
glVertexAttribL3i64vNV.add( Input( 'index','GLuint' ))
glVertexAttribL3i64vNV.add( Input( 'v','const GLint64EXT *' ,size = 3 ))
glVertexAttribL3i64vNV.version = ''
glVertexAttribL3i64vNV.category = 'GL_NV_vertex_attrib_integer_64bit'
glVertexAttribL3i64vNV.trace = True
glVertexAttribL3i64vNV.play = True
gl.add(glVertexAttribL3i64vNV)

glVertexAttribL3ui64NV = Function('glVertexAttribL3ui64NV')
glVertexAttribL3ui64NV.ret = Return('void')
glVertexAttribL3ui64NV.add( Input( 'index','GLuint' ))
glVertexAttribL3ui64NV.add( Input( 'x','GLuint64EXT' ))
glVertexAttribL3ui64NV.add( Input( 'y','GLuint64EXT' ))
glVertexAttribL3ui64NV.add( Input( 'z','GLuint64EXT' ))
glVertexAttribL3ui64NV.version = ''
glVertexAttribL3ui64NV.category = 'GL_NV_vertex_attrib_integer_64bit'
glVertexAttribL3ui64NV.trace = True
glVertexAttribL3ui64NV.play = True
gl.add(glVertexAttribL3ui64NV)

glVertexAttribL3ui64vNV = Function('glVertexAttribL3ui64vNV')
glVertexAttribL3ui64vNV.ret = Return('void')
glVertexAttribL3ui64vNV.add( Input( 'index','GLuint' ))
glVertexAttribL3ui64vNV.add( Input( 'v','const GLuint64EXT *' ,size = 3 ))
glVertexAttribL3ui64vNV.version = ''
glVertexAttribL3ui64vNV.category = 'GL_NV_vertex_attrib_integer_64bit'
glVertexAttribL3ui64vNV.trace = True
glVertexAttribL3ui64vNV.play = True
gl.add(glVertexAttribL3ui64vNV)

glVertexAttribL4i64NV = Function('glVertexAttribL4i64NV')
glVertexAttribL4i64NV.ret = Return('void')
glVertexAttribL4i64NV.add( Input( 'index','GLuint' ))
glVertexAttribL4i64NV.add( Input( 'x','GLint64EXT' ))
glVertexAttribL4i64NV.add( Input( 'y','GLint64EXT' ))
glVertexAttribL4i64NV.add( Input( 'z','GLint64EXT' ))
glVertexAttribL4i64NV.add( Input( 'w','GLint64EXT' ))
glVertexAttribL4i64NV.version = ''
glVertexAttribL4i64NV.category = 'GL_NV_vertex_attrib_integer_64bit'
glVertexAttribL4i64NV.trace = True
glVertexAttribL4i64NV.play = True
gl.add(glVertexAttribL4i64NV)

glVertexAttribL4i64vNV = Function('glVertexAttribL4i64vNV')
glVertexAttribL4i64vNV.ret = Return('void')
glVertexAttribL4i64vNV.add( Input( 'index','GLuint' ))
glVertexAttribL4i64vNV.add( Input( 'v','const GLint64EXT *' ,size = 4 ))
glVertexAttribL4i64vNV.version = ''
glVertexAttribL4i64vNV.category = 'GL_NV_vertex_attrib_integer_64bit'
glVertexAttribL4i64vNV.trace = True
glVertexAttribL4i64vNV.play = True
gl.add(glVertexAttribL4i64vNV)

glVertexAttribL4ui64NV = Function('glVertexAttribL4ui64NV')
glVertexAttribL4ui64NV.ret = Return('void')
glVertexAttribL4ui64NV.add( Input( 'index','GLuint' ))
glVertexAttribL4ui64NV.add( Input( 'x','GLuint64EXT' ))
glVertexAttribL4ui64NV.add( Input( 'y','GLuint64EXT' ))
glVertexAttribL4ui64NV.add( Input( 'z','GLuint64EXT' ))
glVertexAttribL4ui64NV.add( Input( 'w','GLuint64EXT' ))
glVertexAttribL4ui64NV.version = ''
glVertexAttribL4ui64NV.category = 'GL_NV_vertex_attrib_integer_64bit'
glVertexAttribL4ui64NV.trace = True
glVertexAttribL4ui64NV.play = True
gl.add(glVertexAttribL4ui64NV)

glVertexAttribL4ui64vNV = Function('glVertexAttribL4ui64vNV')
glVertexAttribL4ui64vNV.ret = Return('void')
glVertexAttribL4ui64vNV.add( Input( 'index','GLuint' ))
glVertexAttribL4ui64vNV.add( Input( 'v','const GLuint64EXT *' ,size = 4 ))
glVertexAttribL4ui64vNV.version = ''
glVertexAttribL4ui64vNV.category = 'GL_NV_vertex_attrib_integer_64bit'
glVertexAttribL4ui64vNV.trace = True
glVertexAttribL4ui64vNV.play = True
gl.add(glVertexAttribL4ui64vNV)

glVertexAttribLFormatNV = Function('glVertexAttribLFormatNV')
glVertexAttribLFormatNV.ret = Return('void')
glVertexAttribLFormatNV.add( Input( 'index','GLuint' ))
glVertexAttribLFormatNV.add( Input( 'size','GLint' ))
glVertexAttribLFormatNV.add( Input( 'type','GLenum' ))
glVertexAttribLFormatNV.add( Input( 'stride','GLsizei' ))
glVertexAttribLFormatNV.version = '3.0'
glVertexAttribLFormatNV.category = 'GL_NV_vertex_attrib_integer_64bit'
glVertexAttribLFormatNV.trace = True
glVertexAttribLFormatNV.play = True
gl.add(glVertexAttribLFormatNV)

# GL_NV_vertex_buffer_unified_memory

glBufferAddressRangeNV = Function('glBufferAddressRangeNV')
glBufferAddressRangeNV.ret = Return('void')
glBufferAddressRangeNV.add( Input( 'pname','GLenum' ))
glBufferAddressRangeNV.add( Input( 'index','GLuint' ))
glBufferAddressRangeNV.add( Input( 'address','GLuint64EXT' ))
glBufferAddressRangeNV.add( Input( 'length','GLsizeiptr' ))
glBufferAddressRangeNV.version = '3.0'
glBufferAddressRangeNV.category = 'GL_NV_vertex_buffer_unified_memory'
glBufferAddressRangeNV.trace = True
glBufferAddressRangeNV.play = True
gl.add(glBufferAddressRangeNV)

glColorFormatNV = Function('glColorFormatNV')
glColorFormatNV.ret = Return('void')
glColorFormatNV.add( Input( 'size','GLint' ))
glColorFormatNV.add( Input( 'type','GLenum' ))
glColorFormatNV.add( Input( 'stride','GLsizei' ))
glColorFormatNV.version = '3.0'
glColorFormatNV.category = 'GL_NV_vertex_buffer_unified_memory'
glColorFormatNV.trace = True
glColorFormatNV.play = True
gl.add(glColorFormatNV)

glEdgeFlagFormatNV = Function('glEdgeFlagFormatNV')
glEdgeFlagFormatNV.ret = Return('void')
glEdgeFlagFormatNV.add( Input( 'stride','GLsizei' ))
glEdgeFlagFormatNV.version = '3.0'
glEdgeFlagFormatNV.category = 'GL_NV_vertex_buffer_unified_memory'
glEdgeFlagFormatNV.trace = True
glEdgeFlagFormatNV.play = True
gl.add(glEdgeFlagFormatNV)

glFogCoordFormatNV = Function('glFogCoordFormatNV')
glFogCoordFormatNV.ret = Return('void')
glFogCoordFormatNV.add( Input( 'type','GLenum' ))
glFogCoordFormatNV.add( Input( 'stride','GLsizei' ))
glFogCoordFormatNV.version = '3.0'
glFogCoordFormatNV.category = 'GL_NV_vertex_buffer_unified_memory'
glFogCoordFormatNV.trace = True
glFogCoordFormatNV.play = True
gl.add(glFogCoordFormatNV)

glGetIntegerui64i_vNV = Function('glGetIntegerui64i_vNV')
glGetIntegerui64i_vNV.ret = Return('void')
glGetIntegerui64i_vNV.add( Input( 'target','GLenum' ))
glGetIntegerui64i_vNV.add( Input( 'index','GLuint' ))
glGetIntegerui64i_vNV.add( Output( 'data','GLuint64EXT *' ))
glGetIntegerui64i_vNV.version = '2.0'
glGetIntegerui64i_vNV.category = 'GL_NV_vertex_buffer_unified_memory'
glGetIntegerui64i_vNV.trace = True
glGetIntegerui64i_vNV.play = False
gl.add(glGetIntegerui64i_vNV)

glIndexFormatNV = Function('glIndexFormatNV')
glIndexFormatNV.ret = Return('void')
glIndexFormatNV.add( Input( 'type','GLenum' ))
glIndexFormatNV.add( Input( 'stride','GLsizei' ))
glIndexFormatNV.version = '3.0'
glIndexFormatNV.category = 'GL_NV_vertex_buffer_unified_memory'
glIndexFormatNV.trace = True
glIndexFormatNV.play = True
gl.add(glIndexFormatNV)

glNormalFormatNV = Function('glNormalFormatNV')
glNormalFormatNV.ret = Return('void')
glNormalFormatNV.add( Input( 'type','GLenum' ))
glNormalFormatNV.add( Input( 'stride','GLsizei' ))
glNormalFormatNV.version = '3.0'
glNormalFormatNV.category = 'GL_NV_vertex_buffer_unified_memory'
glNormalFormatNV.trace = True
glNormalFormatNV.play = True
gl.add(glNormalFormatNV)

glSecondaryColorFormatNV = Function('glSecondaryColorFormatNV')
glSecondaryColorFormatNV.ret = Return('void')
glSecondaryColorFormatNV.add( Input( 'size','GLint' ))
glSecondaryColorFormatNV.add( Input( 'type','GLenum' ))
glSecondaryColorFormatNV.add( Input( 'stride','GLsizei' ))
glSecondaryColorFormatNV.version = '3.0'
glSecondaryColorFormatNV.category = 'GL_NV_vertex_buffer_unified_memory'
glSecondaryColorFormatNV.trace = True
glSecondaryColorFormatNV.play = True
gl.add(glSecondaryColorFormatNV)

glTexCoordFormatNV = Function('glTexCoordFormatNV')
glTexCoordFormatNV.ret = Return('void')
glTexCoordFormatNV.add( Input( 'size','GLint' ))
glTexCoordFormatNV.add( Input( 'type','GLenum' ))
glTexCoordFormatNV.add( Input( 'stride','GLsizei' ))
glTexCoordFormatNV.version = '3.0'
glTexCoordFormatNV.category = 'GL_NV_vertex_buffer_unified_memory'
glTexCoordFormatNV.trace = True
glTexCoordFormatNV.play = True
gl.add(glTexCoordFormatNV)

glVertexAttribFormatNV = Function('glVertexAttribFormatNV')
glVertexAttribFormatNV.ret = Return('void')
glVertexAttribFormatNV.add( Input( 'index','GLuint' ))
glVertexAttribFormatNV.add( Input( 'size','GLint' ))
glVertexAttribFormatNV.add( Input( 'type','GLenum' ))
glVertexAttribFormatNV.add( Input( 'normalized','GLboolean' ))
glVertexAttribFormatNV.add( Input( 'stride','GLsizei' ))
glVertexAttribFormatNV.version = '3.0'
glVertexAttribFormatNV.category = 'GL_NV_vertex_buffer_unified_memory'
glVertexAttribFormatNV.trace = True
glVertexAttribFormatNV.play = True
gl.add(glVertexAttribFormatNV)

glVertexAttribIFormatNV = Function('glVertexAttribIFormatNV')
glVertexAttribIFormatNV.ret = Return('void')
glVertexAttribIFormatNV.add( Input( 'index','GLuint' ))
glVertexAttribIFormatNV.add( Input( 'size','GLint' ))
glVertexAttribIFormatNV.add( Input( 'type','GLenum' ))
glVertexAttribIFormatNV.add( Input( 'stride','GLsizei' ))
glVertexAttribIFormatNV.version = '3.0'
glVertexAttribIFormatNV.category = 'GL_NV_vertex_buffer_unified_memory'
glVertexAttribIFormatNV.trace = True
glVertexAttribIFormatNV.play = True
gl.add(glVertexAttribIFormatNV)

glVertexFormatNV = Function('glVertexFormatNV')
glVertexFormatNV.ret = Return('void')
glVertexFormatNV.add( Input( 'size','GLint' ))
glVertexFormatNV.add( Input( 'type','GLenum' ))
glVertexFormatNV.add( Input( 'stride','GLsizei' ))
glVertexFormatNV.version = '3.0'
glVertexFormatNV.category = 'GL_NV_vertex_buffer_unified_memory'
glVertexFormatNV.trace = True
glVertexFormatNV.play = True
gl.add(glVertexFormatNV)

# GL_NV_vertex_program

glAreProgramsResidentNV = Function('glAreProgramsResidentNV')
glAreProgramsResidentNV.ret = Return('GLboolean')
glAreProgramsResidentNV.add( Input( 'n','GLsizei' ))
glAreProgramsResidentNV.add( Input( 'programs','const GLuint *' ,size = 'n' ))
glAreProgramsResidentNV.add( Output( 'residences','GLboolean *' ,size = 'n' ))
glAreProgramsResidentNV.version = '1.2'
glAreProgramsResidentNV.category = 'GL_NV_vertex_program'
glAreProgramsResidentNV.trace = True
glAreProgramsResidentNV.play = True
gl.add(glAreProgramsResidentNV)

glBindProgramNV = Function('glBindProgramNV')
glBindProgramNV.ret = Return('void')
glBindProgramNV.add( Input( 'target','GLenum' ))
glBindProgramNV.add( Input( 'id','GLuint' ))
glBindProgramNV.version = '1.2'
glBindProgramNV.category = 'GL_NV_vertex_program'
glBindProgramNV.trace = True
glBindProgramNV.play = True
gl.add(glBindProgramNV)

glDeleteProgramsNV = Function('glDeleteProgramsNV')
glDeleteProgramsNV.ret = Return('void')
glDeleteProgramsNV.add( Input( 'n','GLsizei' ))
glDeleteProgramsNV.add( Input( 'programs','const GLuint *' ,size = 'n' ))
glDeleteProgramsNV.version = '1.2'
glDeleteProgramsNV.category = 'GL_NV_vertex_program'
glDeleteProgramsNV.trace = True
glDeleteProgramsNV.play = True
gl.add(glDeleteProgramsNV)

glExecuteProgramNV = Function('glExecuteProgramNV')
glExecuteProgramNV.ret = Return('void')
glExecuteProgramNV.add( Input( 'target','GLenum' ))
glExecuteProgramNV.add( Input( 'id','GLuint' ))
glExecuteProgramNV.add( Input( 'params','const GLfloat *' ,size = 4 ))
glExecuteProgramNV.version = '1.2'
glExecuteProgramNV.category = 'GL_NV_vertex_program'
glExecuteProgramNV.trace = True
glExecuteProgramNV.play = True
gl.add(glExecuteProgramNV)

glGenProgramsNV = Function('glGenProgramsNV')
glGenProgramsNV.ret = Return('void')
glGenProgramsNV.add( Input( 'n','GLsizei' ))
glGenProgramsNV.add( Output( 'programs','GLuint *' ,size = 'n' ))
glGenProgramsNV.version = '1.2'
glGenProgramsNV.category = 'GL_NV_vertex_program'
glGenProgramsNV.trace = True
glGenProgramsNV.play = True
gl.add(glGenProgramsNV)

glGetProgramParameterdvNV = Function('glGetProgramParameterdvNV')
glGetProgramParameterdvNV.ret = Return('void')
glGetProgramParameterdvNV.add( Input( 'target','GLenum' ))
glGetProgramParameterdvNV.add( Input( 'index','GLuint' ))
glGetProgramParameterdvNV.add( Input( 'pname','GLenum' ))
glGetProgramParameterdvNV.add( Output( 'params','GLdouble *' ,size = 4 ))
glGetProgramParameterdvNV.version = '1.2'
glGetProgramParameterdvNV.category = 'GL_NV_vertex_program'
glGetProgramParameterdvNV.trace = True
glGetProgramParameterdvNV.play = True
gl.add(glGetProgramParameterdvNV)

glGetProgramParameterfvNV = Function('glGetProgramParameterfvNV')
glGetProgramParameterfvNV.ret = Return('void')
glGetProgramParameterfvNV.add( Input( 'target','GLenum' ))
glGetProgramParameterfvNV.add( Input( 'index','GLuint' ))
glGetProgramParameterfvNV.add( Input( 'pname','GLenum' ))
glGetProgramParameterfvNV.add( Output( 'params','GLfloat *' ,size = 4 ))
glGetProgramParameterfvNV.version = '1.2'
glGetProgramParameterfvNV.category = 'GL_NV_vertex_program'
glGetProgramParameterfvNV.trace = True
glGetProgramParameterfvNV.play = True
gl.add(glGetProgramParameterfvNV)

glGetProgramStringNV = Function('glGetProgramStringNV')
glGetProgramStringNV.ret = Return('void')
glGetProgramStringNV.add( Input( 'id','GLuint' ))
glGetProgramStringNV.add( Input( 'pname','GLenum' ))
glGetProgramStringNV.add( Output( 'program','GLubyte *' ))
glGetProgramStringNV.version = '1.2'
glGetProgramStringNV.category = 'GL_NV_vertex_program'
glGetProgramStringNV.trace = True
glGetProgramStringNV.play = False
gl.add(glGetProgramStringNV)

glGetProgramivNV = Function('glGetProgramivNV')
glGetProgramivNV.ret = Return('void')
glGetProgramivNV.add( Input( 'id','GLuint' ))
glGetProgramivNV.add( Input( 'pname','GLenum' ))
glGetProgramivNV.add( Output( 'params','GLint *' ,size = 4 ))
glGetProgramivNV.version = '1.2'
glGetProgramivNV.category = 'GL_NV_vertex_program'
glGetProgramivNV.trace = True
glGetProgramivNV.play = True
gl.add(glGetProgramivNV)

glGetTrackMatrixivNV = Function('glGetTrackMatrixivNV')
glGetTrackMatrixivNV.ret = Return('void')
glGetTrackMatrixivNV.add( Input( 'target','GLenum' ))
glGetTrackMatrixivNV.add( Input( 'address','GLuint' ))
glGetTrackMatrixivNV.add( Input( 'pname','GLenum' ))
glGetTrackMatrixivNV.add( Output( 'params','GLint *' ,size = 1 ))
glGetTrackMatrixivNV.version = '1.2'
glGetTrackMatrixivNV.category = 'GL_NV_vertex_program'
glGetTrackMatrixivNV.trace = True
glGetTrackMatrixivNV.play = True
gl.add(glGetTrackMatrixivNV)

glGetVertexAttribPointervNV = Function('glGetVertexAttribPointervNV')
glGetVertexAttribPointervNV.ret = Return('void')
glGetVertexAttribPointervNV.add( Input( 'index','GLuint' ))
glGetVertexAttribPointervNV.add( Input( 'pname','GLenum' ))
glGetVertexAttribPointervNV.add( Output( 'pointer','GLvoid **' ,size = 1 ))
glGetVertexAttribPointervNV.version = '1.2'
glGetVertexAttribPointervNV.category = 'GL_NV_vertex_program'
glGetVertexAttribPointervNV.trace = True
glGetVertexAttribPointervNV.play = False
gl.add(glGetVertexAttribPointervNV)

glGetVertexAttribdvNV = Function('glGetVertexAttribdvNV')
glGetVertexAttribdvNV.ret = Return('void')
glGetVertexAttribdvNV.add( Input( 'index','GLuint' ))
glGetVertexAttribdvNV.add( Input( 'pname','GLenum' ))
glGetVertexAttribdvNV.add( Output( 'params','GLdouble *' ,size = 1 ))
glGetVertexAttribdvNV.version = '1.2'
glGetVertexAttribdvNV.category = 'GL_NV_vertex_program'
glGetVertexAttribdvNV.trace = True
glGetVertexAttribdvNV.play = True
gl.add(glGetVertexAttribdvNV)

glGetVertexAttribfvNV = Function('glGetVertexAttribfvNV')
glGetVertexAttribfvNV.ret = Return('void')
glGetVertexAttribfvNV.add( Input( 'index','GLuint' ))
glGetVertexAttribfvNV.add( Input( 'pname','GLenum' ))
glGetVertexAttribfvNV.add( Output( 'params','GLfloat *' ,size = 1 ))
glGetVertexAttribfvNV.version = '1.2'
glGetVertexAttribfvNV.category = 'GL_NV_vertex_program'
glGetVertexAttribfvNV.trace = True
glGetVertexAttribfvNV.play = True
gl.add(glGetVertexAttribfvNV)

glGetVertexAttribivNV = Function('glGetVertexAttribivNV')
glGetVertexAttribivNV.ret = Return('void')
glGetVertexAttribivNV.add( Input( 'index','GLuint' ))
glGetVertexAttribivNV.add( Input( 'pname','GLenum' ))
glGetVertexAttribivNV.add( Output( 'params','GLint *' ,size = 1 ))
glGetVertexAttribivNV.version = '1.2'
glGetVertexAttribivNV.category = 'GL_NV_vertex_program'
glGetVertexAttribivNV.trace = True
glGetVertexAttribivNV.play = True
gl.add(glGetVertexAttribivNV)

glIsProgramNV = Function('glIsProgramNV')
glIsProgramNV.ret = Return('GLboolean')
glIsProgramNV.add( Input( 'id','GLuint' ))
glIsProgramNV.version = '1.2'
glIsProgramNV.category = 'GL_NV_vertex_program'
glIsProgramNV.trace = True
glIsProgramNV.play = True
gl.add(glIsProgramNV)

glLoadProgramNV = Function('glLoadProgramNV')
glLoadProgramNV.ret = Return('void')
glLoadProgramNV.add( Input( 'target','GLenum' ))
glLoadProgramNV.add( Input( 'id','GLuint' ))
glLoadProgramNV.add( Input( 'len','GLsizei' ))
glLoadProgramNV.add( Input( 'program','const GLubyte *' ,size = 'len' ))
glLoadProgramNV.version = '1.2'
glLoadProgramNV.category = 'GL_NV_vertex_program'
glLoadProgramNV.trace = True
glLoadProgramNV.play = True
gl.add(glLoadProgramNV)

glProgramParameter4dNV = Function('glProgramParameter4dNV')
glProgramParameter4dNV.ret = Return('void')
glProgramParameter4dNV.add( Input( 'target','GLenum' ))
glProgramParameter4dNV.add( Input( 'index','GLuint' ))
glProgramParameter4dNV.add( Input( 'x','GLdouble' ))
glProgramParameter4dNV.add( Input( 'y','GLdouble' ))
glProgramParameter4dNV.add( Input( 'z','GLdouble' ))
glProgramParameter4dNV.add( Input( 'w','GLdouble' ))
glProgramParameter4dNV.version = '1.2'
glProgramParameter4dNV.category = 'GL_NV_vertex_program'
glProgramParameter4dNV.trace = True
glProgramParameter4dNV.play = True
gl.add(glProgramParameter4dNV)

glProgramParameter4dvNV = Function('glProgramParameter4dvNV')
glProgramParameter4dvNV.ret = Return('void')
glProgramParameter4dvNV.add( Input( 'target','GLenum' ))
glProgramParameter4dvNV.add( Input( 'index','GLuint' ))
glProgramParameter4dvNV.add( Input( 'v','const GLdouble *' ,size = 4 ))
glProgramParameter4dvNV.version = '1.2'
glProgramParameter4dvNV.category = 'GL_NV_vertex_program'
glProgramParameter4dvNV.trace = True
glProgramParameter4dvNV.play = True
gl.add(glProgramParameter4dvNV)

glProgramParameter4fNV = Function('glProgramParameter4fNV')
glProgramParameter4fNV.ret = Return('void')
glProgramParameter4fNV.add( Input( 'target','GLenum' ))
glProgramParameter4fNV.add( Input( 'index','GLuint' ))
glProgramParameter4fNV.add( Input( 'x','GLfloat' ))
glProgramParameter4fNV.add( Input( 'y','GLfloat' ))
glProgramParameter4fNV.add( Input( 'z','GLfloat' ))
glProgramParameter4fNV.add( Input( 'w','GLfloat' ))
glProgramParameter4fNV.version = '1.2'
glProgramParameter4fNV.category = 'GL_NV_vertex_program'
glProgramParameter4fNV.trace = True
glProgramParameter4fNV.play = True
gl.add(glProgramParameter4fNV)

glProgramParameter4fvNV = Function('glProgramParameter4fvNV')
glProgramParameter4fvNV.ret = Return('void')
glProgramParameter4fvNV.add( Input( 'target','GLenum' ))
glProgramParameter4fvNV.add( Input( 'index','GLuint' ))
glProgramParameter4fvNV.add( Input( 'v','const GLfloat *' ,size = 4 ))
glProgramParameter4fvNV.version = '1.2'
glProgramParameter4fvNV.category = 'GL_NV_vertex_program'
glProgramParameter4fvNV.trace = True
glProgramParameter4fvNV.play = True
gl.add(glProgramParameter4fvNV)

glProgramParameters4dvNV = Function('glProgramParameters4dvNV')
glProgramParameters4dvNV.ret = Return('void')
glProgramParameters4dvNV.add( Input( 'target','GLenum' ))
glProgramParameters4dvNV.add( Input( 'index','GLuint' ))
glProgramParameters4dvNV.add( Input( 'count','GLsizei' ))
glProgramParameters4dvNV.add( Input( 'v','const GLdouble *' ,size = 'count * 4' ))
glProgramParameters4dvNV.version = '1.2'
glProgramParameters4dvNV.category = 'GL_NV_vertex_program'
glProgramParameters4dvNV.trace = True
glProgramParameters4dvNV.play = True
gl.add(glProgramParameters4dvNV)

glProgramParameters4fvNV = Function('glProgramParameters4fvNV')
glProgramParameters4fvNV.ret = Return('void')
glProgramParameters4fvNV.add( Input( 'target','GLenum' ))
glProgramParameters4fvNV.add( Input( 'index','GLuint' ))
glProgramParameters4fvNV.add( Input( 'count','GLsizei' ))
glProgramParameters4fvNV.add( Input( 'v','const GLfloat *' ,size = 'count * 4' ))
glProgramParameters4fvNV.version = '1.2'
glProgramParameters4fvNV.category = 'GL_NV_vertex_program'
glProgramParameters4fvNV.trace = True
glProgramParameters4fvNV.play = True
gl.add(glProgramParameters4fvNV)

glRequestResidentProgramsNV = Function('glRequestResidentProgramsNV')
glRequestResidentProgramsNV.ret = Return('void')
glRequestResidentProgramsNV.add( Input( 'n','GLsizei' ))
glRequestResidentProgramsNV.add( Input( 'programs','const GLuint *' ,size = 'n' ))
glRequestResidentProgramsNV.version = '1.2'
glRequestResidentProgramsNV.category = 'GL_NV_vertex_program'
glRequestResidentProgramsNV.trace = True
glRequestResidentProgramsNV.play = True
gl.add(glRequestResidentProgramsNV)

glTrackMatrixNV = Function('glTrackMatrixNV')
glTrackMatrixNV.ret = Return('void')
glTrackMatrixNV.add( Input( 'target','GLenum' ))
glTrackMatrixNV.add( Input( 'address','GLuint' ))
glTrackMatrixNV.add( Input( 'matrix','GLenum' ))
glTrackMatrixNV.add( Input( 'transform','GLenum' ))
glTrackMatrixNV.version = '1.2'
glTrackMatrixNV.category = 'GL_NV_vertex_program'
glTrackMatrixNV.trace = True
glTrackMatrixNV.play = True
gl.add(glTrackMatrixNV)

glVertexAttrib1dNV = Function('glVertexAttrib1dNV')
glVertexAttrib1dNV.ret = Return('void')
glVertexAttrib1dNV.add( Input( 'index','GLuint' ))
glVertexAttrib1dNV.add( Input( 'x','GLdouble' ))
glVertexAttrib1dNV.version = '1.2'
glVertexAttrib1dNV.category = 'GL_NV_vertex_program'
glVertexAttrib1dNV.trace = True
glVertexAttrib1dNV.play = True
gl.add(glVertexAttrib1dNV)

glVertexAttrib1dvNV = Function('glVertexAttrib1dvNV')
glVertexAttrib1dvNV.ret = Return('void')
glVertexAttrib1dvNV.add( Input( 'index','GLuint' ))
glVertexAttrib1dvNV.add( Input( 'v','const GLdouble *' ,size = 1 ))
glVertexAttrib1dvNV.version = '1.2'
glVertexAttrib1dvNV.category = 'GL_NV_vertex_program'
glVertexAttrib1dvNV.trace = True
glVertexAttrib1dvNV.play = True
gl.add(glVertexAttrib1dvNV)

glVertexAttrib1fNV = Function('glVertexAttrib1fNV')
glVertexAttrib1fNV.ret = Return('void')
glVertexAttrib1fNV.add( Input( 'index','GLuint' ))
glVertexAttrib1fNV.add( Input( 'x','GLfloat' ))
glVertexAttrib1fNV.version = '1.2'
glVertexAttrib1fNV.category = 'GL_NV_vertex_program'
glVertexAttrib1fNV.trace = True
glVertexAttrib1fNV.play = True
gl.add(glVertexAttrib1fNV)

glVertexAttrib1fvNV = Function('glVertexAttrib1fvNV')
glVertexAttrib1fvNV.ret = Return('void')
glVertexAttrib1fvNV.add( Input( 'index','GLuint' ))
glVertexAttrib1fvNV.add( Input( 'v','const GLfloat *' ,size = 1 ))
glVertexAttrib1fvNV.version = '1.2'
glVertexAttrib1fvNV.category = 'GL_NV_vertex_program'
glVertexAttrib1fvNV.trace = True
glVertexAttrib1fvNV.play = True
gl.add(glVertexAttrib1fvNV)

glVertexAttrib1sNV = Function('glVertexAttrib1sNV')
glVertexAttrib1sNV.ret = Return('void')
glVertexAttrib1sNV.add( Input( 'index','GLuint' ))
glVertexAttrib1sNV.add( Input( 'x','GLshort' ))
glVertexAttrib1sNV.version = '1.2'
glVertexAttrib1sNV.category = 'GL_NV_vertex_program'
glVertexAttrib1sNV.trace = True
glVertexAttrib1sNV.play = True
gl.add(glVertexAttrib1sNV)

glVertexAttrib1svNV = Function('glVertexAttrib1svNV')
glVertexAttrib1svNV.ret = Return('void')
glVertexAttrib1svNV.add( Input( 'index','GLuint' ))
glVertexAttrib1svNV.add( Input( 'v','const GLshort *' ,size = 1 ))
glVertexAttrib1svNV.version = '1.2'
glVertexAttrib1svNV.category = 'GL_NV_vertex_program'
glVertexAttrib1svNV.trace = True
glVertexAttrib1svNV.play = True
gl.add(glVertexAttrib1svNV)

glVertexAttrib2dNV = Function('glVertexAttrib2dNV')
glVertexAttrib2dNV.ret = Return('void')
glVertexAttrib2dNV.add( Input( 'index','GLuint' ))
glVertexAttrib2dNV.add( Input( 'x','GLdouble' ))
glVertexAttrib2dNV.add( Input( 'y','GLdouble' ))
glVertexAttrib2dNV.version = '1.2'
glVertexAttrib2dNV.category = 'GL_NV_vertex_program'
glVertexAttrib2dNV.trace = True
glVertexAttrib2dNV.play = True
gl.add(glVertexAttrib2dNV)

glVertexAttrib2dvNV = Function('glVertexAttrib2dvNV')
glVertexAttrib2dvNV.ret = Return('void')
glVertexAttrib2dvNV.add( Input( 'index','GLuint' ))
glVertexAttrib2dvNV.add( Input( 'v','const GLdouble *' ,size = 2 ))
glVertexAttrib2dvNV.version = '1.2'
glVertexAttrib2dvNV.category = 'GL_NV_vertex_program'
glVertexAttrib2dvNV.trace = True
glVertexAttrib2dvNV.play = True
gl.add(glVertexAttrib2dvNV)

glVertexAttrib2fNV = Function('glVertexAttrib2fNV')
glVertexAttrib2fNV.ret = Return('void')
glVertexAttrib2fNV.add( Input( 'index','GLuint' ))
glVertexAttrib2fNV.add( Input( 'x','GLfloat' ))
glVertexAttrib2fNV.add( Input( 'y','GLfloat' ))
glVertexAttrib2fNV.version = '1.2'
glVertexAttrib2fNV.category = 'GL_NV_vertex_program'
glVertexAttrib2fNV.trace = True
glVertexAttrib2fNV.play = True
gl.add(glVertexAttrib2fNV)

glVertexAttrib2fvNV = Function('glVertexAttrib2fvNV')
glVertexAttrib2fvNV.ret = Return('void')
glVertexAttrib2fvNV.add( Input( 'index','GLuint' ))
glVertexAttrib2fvNV.add( Input( 'v','const GLfloat *' ,size = 2 ))
glVertexAttrib2fvNV.version = '1.2'
glVertexAttrib2fvNV.category = 'GL_NV_vertex_program'
glVertexAttrib2fvNV.trace = True
glVertexAttrib2fvNV.play = True
gl.add(glVertexAttrib2fvNV)

glVertexAttrib2sNV = Function('glVertexAttrib2sNV')
glVertexAttrib2sNV.ret = Return('void')
glVertexAttrib2sNV.add( Input( 'index','GLuint' ))
glVertexAttrib2sNV.add( Input( 'x','GLshort' ))
glVertexAttrib2sNV.add( Input( 'y','GLshort' ))
glVertexAttrib2sNV.version = '1.2'
glVertexAttrib2sNV.category = 'GL_NV_vertex_program'
glVertexAttrib2sNV.trace = True
glVertexAttrib2sNV.play = True
gl.add(glVertexAttrib2sNV)

glVertexAttrib2svNV = Function('glVertexAttrib2svNV')
glVertexAttrib2svNV.ret = Return('void')
glVertexAttrib2svNV.add( Input( 'index','GLuint' ))
glVertexAttrib2svNV.add( Input( 'v','const GLshort *' ,size = 2 ))
glVertexAttrib2svNV.version = '1.2'
glVertexAttrib2svNV.category = 'GL_NV_vertex_program'
glVertexAttrib2svNV.trace = True
glVertexAttrib2svNV.play = True
gl.add(glVertexAttrib2svNV)

glVertexAttrib3dNV = Function('glVertexAttrib3dNV')
glVertexAttrib3dNV.ret = Return('void')
glVertexAttrib3dNV.add( Input( 'index','GLuint' ))
glVertexAttrib3dNV.add( Input( 'x','GLdouble' ))
glVertexAttrib3dNV.add( Input( 'y','GLdouble' ))
glVertexAttrib3dNV.add( Input( 'z','GLdouble' ))
glVertexAttrib3dNV.version = '1.2'
glVertexAttrib3dNV.category = 'GL_NV_vertex_program'
glVertexAttrib3dNV.trace = True
glVertexAttrib3dNV.play = True
gl.add(glVertexAttrib3dNV)

glVertexAttrib3dvNV = Function('glVertexAttrib3dvNV')
glVertexAttrib3dvNV.ret = Return('void')
glVertexAttrib3dvNV.add( Input( 'index','GLuint' ))
glVertexAttrib3dvNV.add( Input( 'v','const GLdouble *' ,size = 3 ))
glVertexAttrib3dvNV.version = '1.2'
glVertexAttrib3dvNV.category = 'GL_NV_vertex_program'
glVertexAttrib3dvNV.trace = True
glVertexAttrib3dvNV.play = True
gl.add(glVertexAttrib3dvNV)

glVertexAttrib3fNV = Function('glVertexAttrib3fNV')
glVertexAttrib3fNV.ret = Return('void')
glVertexAttrib3fNV.add( Input( 'index','GLuint' ))
glVertexAttrib3fNV.add( Input( 'x','GLfloat' ))
glVertexAttrib3fNV.add( Input( 'y','GLfloat' ))
glVertexAttrib3fNV.add( Input( 'z','GLfloat' ))
glVertexAttrib3fNV.version = '1.2'
glVertexAttrib3fNV.category = 'GL_NV_vertex_program'
glVertexAttrib3fNV.trace = True
glVertexAttrib3fNV.play = True
gl.add(glVertexAttrib3fNV)

glVertexAttrib3fvNV = Function('glVertexAttrib3fvNV')
glVertexAttrib3fvNV.ret = Return('void')
glVertexAttrib3fvNV.add( Input( 'index','GLuint' ))
glVertexAttrib3fvNV.add( Input( 'v','const GLfloat *' ,size = 3 ))
glVertexAttrib3fvNV.version = '1.2'
glVertexAttrib3fvNV.category = 'GL_NV_vertex_program'
glVertexAttrib3fvNV.trace = True
glVertexAttrib3fvNV.play = True
gl.add(glVertexAttrib3fvNV)

glVertexAttrib3sNV = Function('glVertexAttrib3sNV')
glVertexAttrib3sNV.ret = Return('void')
glVertexAttrib3sNV.add( Input( 'index','GLuint' ))
glVertexAttrib3sNV.add( Input( 'x','GLshort' ))
glVertexAttrib3sNV.add( Input( 'y','GLshort' ))
glVertexAttrib3sNV.add( Input( 'z','GLshort' ))
glVertexAttrib3sNV.version = '1.2'
glVertexAttrib3sNV.category = 'GL_NV_vertex_program'
glVertexAttrib3sNV.trace = True
glVertexAttrib3sNV.play = True
gl.add(glVertexAttrib3sNV)

glVertexAttrib3svNV = Function('glVertexAttrib3svNV')
glVertexAttrib3svNV.ret = Return('void')
glVertexAttrib3svNV.add( Input( 'index','GLuint' ))
glVertexAttrib3svNV.add( Input( 'v','const GLshort *' ,size = 3 ))
glVertexAttrib3svNV.version = '1.2'
glVertexAttrib3svNV.category = 'GL_NV_vertex_program'
glVertexAttrib3svNV.trace = True
glVertexAttrib3svNV.play = True
gl.add(glVertexAttrib3svNV)

glVertexAttrib4dNV = Function('glVertexAttrib4dNV')
glVertexAttrib4dNV.ret = Return('void')
glVertexAttrib4dNV.add( Input( 'index','GLuint' ))
glVertexAttrib4dNV.add( Input( 'x','GLdouble' ))
glVertexAttrib4dNV.add( Input( 'y','GLdouble' ))
glVertexAttrib4dNV.add( Input( 'z','GLdouble' ))
glVertexAttrib4dNV.add( Input( 'w','GLdouble' ))
glVertexAttrib4dNV.version = '1.2'
glVertexAttrib4dNV.category = 'GL_NV_vertex_program'
glVertexAttrib4dNV.trace = True
glVertexAttrib4dNV.play = True
gl.add(glVertexAttrib4dNV)

glVertexAttrib4dvNV = Function('glVertexAttrib4dvNV')
glVertexAttrib4dvNV.ret = Return('void')
glVertexAttrib4dvNV.add( Input( 'index','GLuint' ))
glVertexAttrib4dvNV.add( Input( 'v','const GLdouble *' ,size = 4 ))
glVertexAttrib4dvNV.version = '1.2'
glVertexAttrib4dvNV.category = 'GL_NV_vertex_program'
glVertexAttrib4dvNV.trace = True
glVertexAttrib4dvNV.play = True
gl.add(glVertexAttrib4dvNV)

glVertexAttrib4fNV = Function('glVertexAttrib4fNV')
glVertexAttrib4fNV.ret = Return('void')
glVertexAttrib4fNV.add( Input( 'index','GLuint' ))
glVertexAttrib4fNV.add( Input( 'x','GLfloat' ))
glVertexAttrib4fNV.add( Input( 'y','GLfloat' ))
glVertexAttrib4fNV.add( Input( 'z','GLfloat' ))
glVertexAttrib4fNV.add( Input( 'w','GLfloat' ))
glVertexAttrib4fNV.version = '1.2'
glVertexAttrib4fNV.category = 'GL_NV_vertex_program'
glVertexAttrib4fNV.trace = True
glVertexAttrib4fNV.play = True
gl.add(glVertexAttrib4fNV)

glVertexAttrib4fvNV = Function('glVertexAttrib4fvNV')
glVertexAttrib4fvNV.ret = Return('void')
glVertexAttrib4fvNV.add( Input( 'index','GLuint' ))
glVertexAttrib4fvNV.add( Input( 'v','const GLfloat *' ,size = 4 ))
glVertexAttrib4fvNV.version = '1.2'
glVertexAttrib4fvNV.category = 'GL_NV_vertex_program'
glVertexAttrib4fvNV.trace = True
glVertexAttrib4fvNV.play = True
gl.add(glVertexAttrib4fvNV)

glVertexAttrib4sNV = Function('glVertexAttrib4sNV')
glVertexAttrib4sNV.ret = Return('void')
glVertexAttrib4sNV.add( Input( 'index','GLuint' ))
glVertexAttrib4sNV.add( Input( 'x','GLshort' ))
glVertexAttrib4sNV.add( Input( 'y','GLshort' ))
glVertexAttrib4sNV.add( Input( 'z','GLshort' ))
glVertexAttrib4sNV.add( Input( 'w','GLshort' ))
glVertexAttrib4sNV.version = '1.2'
glVertexAttrib4sNV.category = 'GL_NV_vertex_program'
glVertexAttrib4sNV.trace = True
glVertexAttrib4sNV.play = True
gl.add(glVertexAttrib4sNV)

glVertexAttrib4svNV = Function('glVertexAttrib4svNV')
glVertexAttrib4svNV.ret = Return('void')
glVertexAttrib4svNV.add( Input( 'index','GLuint' ))
glVertexAttrib4svNV.add( Input( 'v','const GLshort *' ,size = 4 ))
glVertexAttrib4svNV.version = '1.2'
glVertexAttrib4svNV.category = 'GL_NV_vertex_program'
glVertexAttrib4svNV.trace = True
glVertexAttrib4svNV.play = True
gl.add(glVertexAttrib4svNV)

glVertexAttrib4ubNV = Function('glVertexAttrib4ubNV')
glVertexAttrib4ubNV.ret = Return('void')
glVertexAttrib4ubNV.add( Input( 'index','GLuint' ))
glVertexAttrib4ubNV.add( Input( 'x','GLubyte' ))
glVertexAttrib4ubNV.add( Input( 'y','GLubyte' ))
glVertexAttrib4ubNV.add( Input( 'z','GLubyte' ))
glVertexAttrib4ubNV.add( Input( 'w','GLubyte' ))
glVertexAttrib4ubNV.version = '1.2'
glVertexAttrib4ubNV.category = 'GL_NV_vertex_program'
glVertexAttrib4ubNV.trace = True
glVertexAttrib4ubNV.play = True
gl.add(glVertexAttrib4ubNV)

glVertexAttrib4ubvNV = Function('glVertexAttrib4ubvNV')
glVertexAttrib4ubvNV.ret = Return('void')
glVertexAttrib4ubvNV.add( Input( 'index','GLuint' ))
glVertexAttrib4ubvNV.add( Input( 'v','const GLubyte *' ,size = 4 ))
glVertexAttrib4ubvNV.version = '1.2'
glVertexAttrib4ubvNV.category = 'GL_NV_vertex_program'
glVertexAttrib4ubvNV.trace = True
glVertexAttrib4ubvNV.play = True
gl.add(glVertexAttrib4ubvNV)

glVertexAttribPointerNV = Function('glVertexAttribPointerNV')
glVertexAttribPointerNV.ret = Return('void')
glVertexAttribPointerNV.add( Input( 'index','GLuint' ))
glVertexAttribPointerNV.add( Input( 'fsize','GLint' ))
glVertexAttribPointerNV.add( Input( 'type','GLenum' ))
glVertexAttribPointerNV.add( Input( 'stride','GLsizei' ))
glVertexAttribPointerNV.add( Input( 'pointer','const GLvoid *' ))
glVertexAttribPointerNV.version = '1.2'
glVertexAttribPointerNV.category = 'GL_NV_vertex_program'
glVertexAttribPointerNV.trace = True
glVertexAttribPointerNV.play = True
gl.add(glVertexAttribPointerNV)

glVertexAttribs1dvNV = Function('glVertexAttribs1dvNV')
glVertexAttribs1dvNV.ret = Return('void')
glVertexAttribs1dvNV.add( Input( 'index','GLuint' ))
glVertexAttribs1dvNV.add( Input( 'n','GLsizei' ))
glVertexAttribs1dvNV.add( Input( 'v','const GLdouble *' ,size = 'n' ))
glVertexAttribs1dvNV.version = '1.2'
glVertexAttribs1dvNV.category = 'GL_NV_vertex_program'
glVertexAttribs1dvNV.trace = True
glVertexAttribs1dvNV.play = True
gl.add(glVertexAttribs1dvNV)

glVertexAttribs1fvNV = Function('glVertexAttribs1fvNV')
glVertexAttribs1fvNV.ret = Return('void')
glVertexAttribs1fvNV.add( Input( 'index','GLuint' ))
glVertexAttribs1fvNV.add( Input( 'n','GLsizei' ))
glVertexAttribs1fvNV.add( Input( 'v','const GLfloat *' ,size = 'n' ))
glVertexAttribs1fvNV.version = '1.2'
glVertexAttribs1fvNV.category = 'GL_NV_vertex_program'
glVertexAttribs1fvNV.trace = True
glVertexAttribs1fvNV.play = True
gl.add(glVertexAttribs1fvNV)

glVertexAttribs1svNV = Function('glVertexAttribs1svNV')
glVertexAttribs1svNV.ret = Return('void')
glVertexAttribs1svNV.add( Input( 'index','GLuint' ))
glVertexAttribs1svNV.add( Input( 'n','GLsizei' ))
glVertexAttribs1svNV.add( Input( 'v','const GLshort *' ,size = 'n' ))
glVertexAttribs1svNV.version = '1.2'
glVertexAttribs1svNV.category = 'GL_NV_vertex_program'
glVertexAttribs1svNV.trace = True
glVertexAttribs1svNV.play = True
gl.add(glVertexAttribs1svNV)

glVertexAttribs2dvNV = Function('glVertexAttribs2dvNV')
glVertexAttribs2dvNV.ret = Return('void')
glVertexAttribs2dvNV.add( Input( 'index','GLuint' ))
glVertexAttribs2dvNV.add( Input( 'n','GLsizei' ))
glVertexAttribs2dvNV.add( Input( 'v','const GLdouble *' ,size = 'n * 2' ))
glVertexAttribs2dvNV.version = '1.2'
glVertexAttribs2dvNV.category = 'GL_NV_vertex_program'
glVertexAttribs2dvNV.trace = True
glVertexAttribs2dvNV.play = True
gl.add(glVertexAttribs2dvNV)

glVertexAttribs2fvNV = Function('glVertexAttribs2fvNV')
glVertexAttribs2fvNV.ret = Return('void')
glVertexAttribs2fvNV.add( Input( 'index','GLuint' ))
glVertexAttribs2fvNV.add( Input( 'n','GLsizei' ))
glVertexAttribs2fvNV.add( Input( 'v','const GLfloat *' ,size = 'n * 2' ))
glVertexAttribs2fvNV.version = '1.2'
glVertexAttribs2fvNV.category = 'GL_NV_vertex_program'
glVertexAttribs2fvNV.trace = True
glVertexAttribs2fvNV.play = True
gl.add(glVertexAttribs2fvNV)

glVertexAttribs2svNV = Function('glVertexAttribs2svNV')
glVertexAttribs2svNV.ret = Return('void')
glVertexAttribs2svNV.add( Input( 'index','GLuint' ))
glVertexAttribs2svNV.add( Input( 'n','GLsizei' ))
glVertexAttribs2svNV.add( Input( 'v','const GLshort *' ,size = 'n * 2' ))
glVertexAttribs2svNV.version = '1.2'
glVertexAttribs2svNV.category = 'GL_NV_vertex_program'
glVertexAttribs2svNV.trace = True
glVertexAttribs2svNV.play = True
gl.add(glVertexAttribs2svNV)

glVertexAttribs3dvNV = Function('glVertexAttribs3dvNV')
glVertexAttribs3dvNV.ret = Return('void')
glVertexAttribs3dvNV.add( Input( 'index','GLuint' ))
glVertexAttribs3dvNV.add( Input( 'n','GLsizei' ))
glVertexAttribs3dvNV.add( Input( 'v','const GLdouble *' ,size = 'n * 3' ))
glVertexAttribs3dvNV.version = '1.2'
glVertexAttribs3dvNV.category = 'GL_NV_vertex_program'
glVertexAttribs3dvNV.trace = True
glVertexAttribs3dvNV.play = True
gl.add(glVertexAttribs3dvNV)

glVertexAttribs3fvNV = Function('glVertexAttribs3fvNV')
glVertexAttribs3fvNV.ret = Return('void')
glVertexAttribs3fvNV.add( Input( 'index','GLuint' ))
glVertexAttribs3fvNV.add( Input( 'n','GLsizei' ))
glVertexAttribs3fvNV.add( Input( 'v','const GLfloat *' ,size = 'n * 3' ))
glVertexAttribs3fvNV.version = '1.2'
glVertexAttribs3fvNV.category = 'GL_NV_vertex_program'
glVertexAttribs3fvNV.trace = True
glVertexAttribs3fvNV.play = True
gl.add(glVertexAttribs3fvNV)

glVertexAttribs3svNV = Function('glVertexAttribs3svNV')
glVertexAttribs3svNV.ret = Return('void')
glVertexAttribs3svNV.add( Input( 'index','GLuint' ))
glVertexAttribs3svNV.add( Input( 'n','GLsizei' ))
glVertexAttribs3svNV.add( Input( 'v','const GLshort *' ,size = 'n * 3' ))
glVertexAttribs3svNV.version = '1.2'
glVertexAttribs3svNV.category = 'GL_NV_vertex_program'
glVertexAttribs3svNV.trace = True
glVertexAttribs3svNV.play = True
gl.add(glVertexAttribs3svNV)

glVertexAttribs4dvNV = Function('glVertexAttribs4dvNV')
glVertexAttribs4dvNV.ret = Return('void')
glVertexAttribs4dvNV.add( Input( 'index','GLuint' ))
glVertexAttribs4dvNV.add( Input( 'n','GLsizei' ))
glVertexAttribs4dvNV.add( Input( 'v','const GLdouble *' ,size = 'n * 4' ))
glVertexAttribs4dvNV.version = '1.2'
glVertexAttribs4dvNV.category = 'GL_NV_vertex_program'
glVertexAttribs4dvNV.trace = True
glVertexAttribs4dvNV.play = True
gl.add(glVertexAttribs4dvNV)

glVertexAttribs4fvNV = Function('glVertexAttribs4fvNV')
glVertexAttribs4fvNV.ret = Return('void')
glVertexAttribs4fvNV.add( Input( 'index','GLuint' ))
glVertexAttribs4fvNV.add( Input( 'n','GLsizei' ))
glVertexAttribs4fvNV.add( Input( 'v','const GLfloat *' ,size = 'n * 4' ))
glVertexAttribs4fvNV.version = '1.2'
glVertexAttribs4fvNV.category = 'GL_NV_vertex_program'
glVertexAttribs4fvNV.trace = True
glVertexAttribs4fvNV.play = True
gl.add(glVertexAttribs4fvNV)

glVertexAttribs4svNV = Function('glVertexAttribs4svNV')
glVertexAttribs4svNV.ret = Return('void')
glVertexAttribs4svNV.add( Input( 'index','GLuint' ))
glVertexAttribs4svNV.add( Input( 'n','GLsizei' ))
glVertexAttribs4svNV.add( Input( 'v','const GLshort *' ,size = 'n * 4' ))
glVertexAttribs4svNV.version = '1.2'
glVertexAttribs4svNV.category = 'GL_NV_vertex_program'
glVertexAttribs4svNV.trace = True
glVertexAttribs4svNV.play = True
gl.add(glVertexAttribs4svNV)

glVertexAttribs4ubvNV = Function('glVertexAttribs4ubvNV')
glVertexAttribs4ubvNV.ret = Return('void')
glVertexAttribs4ubvNV.add( Input( 'index','GLuint' ))
glVertexAttribs4ubvNV.add( Input( 'n','GLsizei' ))
glVertexAttribs4ubvNV.add( Input( 'v','const GLubyte *' ,size = 'n * 4' ))
glVertexAttribs4ubvNV.version = '1.2'
glVertexAttribs4ubvNV.category = 'GL_NV_vertex_program'
glVertexAttribs4ubvNV.trace = True
glVertexAttribs4ubvNV.play = True
gl.add(glVertexAttribs4ubvNV)

# GL_NV_video_capture

glBeginVideoCaptureNV = Function('glBeginVideoCaptureNV')
glBeginVideoCaptureNV.ret = Return('void')
glBeginVideoCaptureNV.add( Input( 'video_capture_slot','GLuint' ))
glBeginVideoCaptureNV.version = '1.1'
glBeginVideoCaptureNV.category = 'GL_NV_video_capture'
glBeginVideoCaptureNV.trace = True
glBeginVideoCaptureNV.play = True
gl.add(glBeginVideoCaptureNV)

glBindVideoCaptureStreamBufferNV = Function('glBindVideoCaptureStreamBufferNV')
glBindVideoCaptureStreamBufferNV.ret = Return('void')
glBindVideoCaptureStreamBufferNV.add( Input( 'video_capture_slot','GLuint' ))
glBindVideoCaptureStreamBufferNV.add( Input( 'stream','GLuint' ))
glBindVideoCaptureStreamBufferNV.add( Input( 'frame_region','GLenum' ))
glBindVideoCaptureStreamBufferNV.add( Input( 'offset','GLintptr' ))
glBindVideoCaptureStreamBufferNV.version = '1.1'
glBindVideoCaptureStreamBufferNV.category = 'GL_NV_video_capture'
glBindVideoCaptureStreamBufferNV.trace = True
glBindVideoCaptureStreamBufferNV.play = True
gl.add(glBindVideoCaptureStreamBufferNV)

glBindVideoCaptureStreamTextureNV = Function('glBindVideoCaptureStreamTextureNV')
glBindVideoCaptureStreamTextureNV.ret = Return('void')
glBindVideoCaptureStreamTextureNV.add( Input( 'video_capture_slot','GLuint' ))
glBindVideoCaptureStreamTextureNV.add( Input( 'stream','GLuint' ))
glBindVideoCaptureStreamTextureNV.add( Input( 'frame_region','GLenum' ))
glBindVideoCaptureStreamTextureNV.add( Input( 'target','GLenum' ))
glBindVideoCaptureStreamTextureNV.add( Input( 'texture','GLuint' ))
glBindVideoCaptureStreamTextureNV.version = '1.1'
glBindVideoCaptureStreamTextureNV.category = 'GL_NV_video_capture'
glBindVideoCaptureStreamTextureNV.trace = True
glBindVideoCaptureStreamTextureNV.play = True
gl.add(glBindVideoCaptureStreamTextureNV)

glEndVideoCaptureNV = Function('glEndVideoCaptureNV')
glEndVideoCaptureNV.ret = Return('void')
glEndVideoCaptureNV.add( Input( 'video_capture_slot','GLuint' ))
glEndVideoCaptureNV.version = '1.1'
glEndVideoCaptureNV.category = 'GL_NV_video_capture'
glEndVideoCaptureNV.trace = True
glEndVideoCaptureNV.play = True
gl.add(glEndVideoCaptureNV)

glGetVideoCaptureStreamdvNV = Function('glGetVideoCaptureStreamdvNV')
glGetVideoCaptureStreamdvNV.ret = Return('void')
glGetVideoCaptureStreamdvNV.add( Input( 'video_capture_slot','GLuint' ))
glGetVideoCaptureStreamdvNV.add( Input( 'stream','GLuint' ))
glGetVideoCaptureStreamdvNV.add( Input( 'pname','GLenum' ))
glGetVideoCaptureStreamdvNV.add( Output( 'params','GLdouble *' ))
glGetVideoCaptureStreamdvNV.version = '1.1'
glGetVideoCaptureStreamdvNV.category = 'GL_NV_video_capture'
glGetVideoCaptureStreamdvNV.trace = True
glGetVideoCaptureStreamdvNV.play = True
gl.add(glGetVideoCaptureStreamdvNV)

glGetVideoCaptureStreamfvNV = Function('glGetVideoCaptureStreamfvNV')
glGetVideoCaptureStreamfvNV.ret = Return('void')
glGetVideoCaptureStreamfvNV.add( Input( 'video_capture_slot','GLuint' ))
glGetVideoCaptureStreamfvNV.add( Input( 'stream','GLuint' ))
glGetVideoCaptureStreamfvNV.add( Input( 'pname','GLenum' ))
glGetVideoCaptureStreamfvNV.add( Output( 'params','GLfloat *' ))
glGetVideoCaptureStreamfvNV.version = '1.1'
glGetVideoCaptureStreamfvNV.category = 'GL_NV_video_capture'
glGetVideoCaptureStreamfvNV.trace = True
glGetVideoCaptureStreamfvNV.play = True
gl.add(glGetVideoCaptureStreamfvNV)

glGetVideoCaptureStreamivNV = Function('glGetVideoCaptureStreamivNV')
glGetVideoCaptureStreamivNV.ret = Return('void')
glGetVideoCaptureStreamivNV.add( Input( 'video_capture_slot','GLuint' ))
glGetVideoCaptureStreamivNV.add( Input( 'stream','GLuint' ))
glGetVideoCaptureStreamivNV.add( Input( 'pname','GLenum' ))
glGetVideoCaptureStreamivNV.add( Output( 'params','GLint *' ))
glGetVideoCaptureStreamivNV.version = '1.1'
glGetVideoCaptureStreamivNV.category = 'GL_NV_video_capture'
glGetVideoCaptureStreamivNV.trace = True
glGetVideoCaptureStreamivNV.play = True
gl.add(glGetVideoCaptureStreamivNV)

glGetVideoCaptureivNV = Function('glGetVideoCaptureivNV')
glGetVideoCaptureivNV.ret = Return('void')
glGetVideoCaptureivNV.add( Input( 'video_capture_slot','GLuint' ))
glGetVideoCaptureivNV.add( Input( 'pname','GLenum' ))
glGetVideoCaptureivNV.add( Output( 'params','GLint *' ))
glGetVideoCaptureivNV.version = '1.1'
glGetVideoCaptureivNV.category = 'GL_NV_video_capture'
glGetVideoCaptureivNV.trace = True
glGetVideoCaptureivNV.play = True
gl.add(glGetVideoCaptureivNV)

glVideoCaptureNV = Function('glVideoCaptureNV')
glVideoCaptureNV.ret = Return('GLenum')
glVideoCaptureNV.add( Input( 'video_capture_slot','GLuint' ))
glVideoCaptureNV.add( Output( 'sequence_num','GLuint *' ,size = 1 ))
glVideoCaptureNV.add( Output( 'capture_time','GLuint64EXT *' ,size = 1 ))
glVideoCaptureNV.version = '1.1'
glVideoCaptureNV.category = 'GL_NV_video_capture'
glVideoCaptureNV.trace = True
glVideoCaptureNV.play = True
gl.add(glVideoCaptureNV)

glVideoCaptureStreamParameterdvNV = Function('glVideoCaptureStreamParameterdvNV')
glVideoCaptureStreamParameterdvNV.ret = Return('void')
glVideoCaptureStreamParameterdvNV.add( Input( 'video_capture_slot','GLuint' ))
glVideoCaptureStreamParameterdvNV.add( Input( 'stream','GLuint' ))
glVideoCaptureStreamParameterdvNV.add( Input( 'pname','GLenum' ))
glVideoCaptureStreamParameterdvNV.add( Input( 'params','const GLdouble *' ))
glVideoCaptureStreamParameterdvNV.version = '1.1'
glVideoCaptureStreamParameterdvNV.category = 'GL_NV_video_capture'
glVideoCaptureStreamParameterdvNV.trace = True
glVideoCaptureStreamParameterdvNV.play = True
gl.add(glVideoCaptureStreamParameterdvNV)

glVideoCaptureStreamParameterfvNV = Function('glVideoCaptureStreamParameterfvNV')
glVideoCaptureStreamParameterfvNV.ret = Return('void')
glVideoCaptureStreamParameterfvNV.add( Input( 'video_capture_slot','GLuint' ))
glVideoCaptureStreamParameterfvNV.add( Input( 'stream','GLuint' ))
glVideoCaptureStreamParameterfvNV.add( Input( 'pname','GLenum' ))
glVideoCaptureStreamParameterfvNV.add( Input( 'params','const GLfloat *' ))
glVideoCaptureStreamParameterfvNV.version = '1.1'
glVideoCaptureStreamParameterfvNV.category = 'GL_NV_video_capture'
glVideoCaptureStreamParameterfvNV.trace = True
glVideoCaptureStreamParameterfvNV.play = True
gl.add(glVideoCaptureStreamParameterfvNV)

glVideoCaptureStreamParameterivNV = Function('glVideoCaptureStreamParameterivNV')
glVideoCaptureStreamParameterivNV.ret = Return('void')
glVideoCaptureStreamParameterivNV.add( Input( 'video_capture_slot','GLuint' ))
glVideoCaptureStreamParameterivNV.add( Input( 'stream','GLuint' ))
glVideoCaptureStreamParameterivNV.add( Input( 'pname','GLenum' ))
glVideoCaptureStreamParameterivNV.add( Input( 'params','const GLint *' ))
glVideoCaptureStreamParameterivNV.version = '1.1'
glVideoCaptureStreamParameterivNV.category = 'GL_NV_video_capture'
glVideoCaptureStreamParameterivNV.trace = True
glVideoCaptureStreamParameterivNV.play = True
gl.add(glVideoCaptureStreamParameterivNV)

# GL_OES_blend_equation_separate

glBlendEquationSeparateOES = Function('glBlendEquationSeparateOES')
glBlendEquationSeparateOES.ret = Return('void')
glBlendEquationSeparateOES.add( Input( 'modeRGB','GLenum' ,regalLog = 'GLmodeToString(modeRGB)' ))
glBlendEquationSeparateOES.add( Input( 'modeAlpha','GLenum' ,regalLog = 'GLmodeToString(modeAlpha)' ))
glBlendEquationSeparateOES.version = ''
glBlendEquationSeparateOES.category = 'GL_OES_blend_equation_separate'
glBlendEquationSeparateOES.trace = True
glBlendEquationSeparateOES.play = True
gl.add(glBlendEquationSeparateOES)

# GL_OES_blend_func_separate

glBlendFuncSeparateOES = Function('glBlendFuncSeparateOES')
glBlendFuncSeparateOES.ret = Return('void')
glBlendFuncSeparateOES.add( Input( 'sfactorRGB','GLenum' ))
glBlendFuncSeparateOES.add( Input( 'dfactorRGB','GLenum' ))
glBlendFuncSeparateOES.add( Input( 'sfactorAlpha','GLenum' ))
glBlendFuncSeparateOES.add( Input( 'dfactorAlpha','GLenum' ))
glBlendFuncSeparateOES.version = ''
glBlendFuncSeparateOES.category = 'GL_OES_blend_func_separate'
glBlendFuncSeparateOES.trace = True
glBlendFuncSeparateOES.play = True
gl.add(glBlendFuncSeparateOES)

# GL_OES_blend_subtract

glBlendEquationOES = Function('glBlendEquationOES')
glBlendEquationOES.ret = Return('void')
glBlendEquationOES.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glBlendEquationOES.version = ''
glBlendEquationOES.category = 'GL_OES_blend_subtract'
glBlendEquationOES.trace = True
glBlendEquationOES.play = True
gl.add(glBlendEquationOES)

# GL_OES_framebuffer_object

glBindFramebufferOES = Function('glBindFramebufferOES')
glBindFramebufferOES.ret = Return('void')
glBindFramebufferOES.add( Input( 'target','GLenum' ))
glBindFramebufferOES.add( Input( 'framebuffer','GLuint' ))
glBindFramebufferOES.version = ''
glBindFramebufferOES.category = 'GL_OES_framebuffer_object'
glBindFramebufferOES.trace = True
glBindFramebufferOES.play = True
gl.add(glBindFramebufferOES)

glBindRenderbufferOES = Function('glBindRenderbufferOES')
glBindRenderbufferOES.ret = Return('void')
glBindRenderbufferOES.add( Input( 'target','GLenum' ))
glBindRenderbufferOES.add( Input( 'renderbuffer','GLuint' ))
glBindRenderbufferOES.version = ''
glBindRenderbufferOES.category = 'GL_OES_framebuffer_object'
glBindRenderbufferOES.trace = True
glBindRenderbufferOES.play = True
gl.add(glBindRenderbufferOES)

glCheckFramebufferStatusOES = Function('glCheckFramebufferStatusOES')
glCheckFramebufferStatusOES.ret = Return('GLenum')
glCheckFramebufferStatusOES.add( Input( 'target','GLenum' ))
glCheckFramebufferStatusOES.version = ''
glCheckFramebufferStatusOES.category = 'GL_OES_framebuffer_object'
glCheckFramebufferStatusOES.trace = True
glCheckFramebufferStatusOES.play = True
gl.add(glCheckFramebufferStatusOES)

glDeleteFramebuffersOES = Function('glDeleteFramebuffersOES')
glDeleteFramebuffersOES.ret = Return('void')
glDeleteFramebuffersOES.add( Input( 'n','GLsizei' ))
glDeleteFramebuffersOES.add( Input( 'framebuffers','const GLuint *' ))
glDeleteFramebuffersOES.version = ''
glDeleteFramebuffersOES.category = 'GL_OES_framebuffer_object'
glDeleteFramebuffersOES.trace = True
glDeleteFramebuffersOES.play = True
gl.add(glDeleteFramebuffersOES)

glDeleteRenderbuffersOES = Function('glDeleteRenderbuffersOES')
glDeleteRenderbuffersOES.ret = Return('void')
glDeleteRenderbuffersOES.add( Input( 'n','GLsizei' ))
glDeleteRenderbuffersOES.add( Input( 'renderbuffers','const GLuint *' ))
glDeleteRenderbuffersOES.version = ''
glDeleteRenderbuffersOES.category = 'GL_OES_framebuffer_object'
glDeleteRenderbuffersOES.trace = True
glDeleteRenderbuffersOES.play = True
gl.add(glDeleteRenderbuffersOES)

glFramebufferRenderbufferOES = Function('glFramebufferRenderbufferOES')
glFramebufferRenderbufferOES.ret = Return('void')
glFramebufferRenderbufferOES.add( Input( 'target','GLenum' ))
glFramebufferRenderbufferOES.add( Input( 'attachment','GLenum' ))
glFramebufferRenderbufferOES.add( Input( 'renderbuffertarget','GLenum' ))
glFramebufferRenderbufferOES.add( Input( 'renderbuffer','GLuint' ))
glFramebufferRenderbufferOES.version = ''
glFramebufferRenderbufferOES.category = 'GL_OES_framebuffer_object'
glFramebufferRenderbufferOES.trace = True
glFramebufferRenderbufferOES.play = True
gl.add(glFramebufferRenderbufferOES)

glFramebufferTexture2DOES = Function('glFramebufferTexture2DOES')
glFramebufferTexture2DOES.ret = Return('void')
glFramebufferTexture2DOES.add( Input( 'target','GLenum' ))
glFramebufferTexture2DOES.add( Input( 'attachment','GLenum' ))
glFramebufferTexture2DOES.add( Input( 'textarget','GLenum' ))
glFramebufferTexture2DOES.add( Input( 'texture','GLuint' ))
glFramebufferTexture2DOES.add( Input( 'level','GLint' ))
glFramebufferTexture2DOES.version = ''
glFramebufferTexture2DOES.category = 'GL_OES_framebuffer_object'
glFramebufferTexture2DOES.trace = True
glFramebufferTexture2DOES.play = True
gl.add(glFramebufferTexture2DOES)

glGenFramebuffersOES = Function('glGenFramebuffersOES')
glGenFramebuffersOES.ret = Return('void')
glGenFramebuffersOES.add( Input( 'n','GLsizei' ))
glGenFramebuffersOES.add( Input( 'framebuffers','GLuint *' ))
glGenFramebuffersOES.version = ''
glGenFramebuffersOES.category = 'GL_OES_framebuffer_object'
glGenFramebuffersOES.trace = True
glGenFramebuffersOES.play = True
gl.add(glGenFramebuffersOES)

glGenRenderbuffersOES = Function('glGenRenderbuffersOES')
glGenRenderbuffersOES.ret = Return('void')
glGenRenderbuffersOES.add( Input( 'n','GLsizei' ))
glGenRenderbuffersOES.add( Input( 'renderbuffers','GLuint *' ))
glGenRenderbuffersOES.version = ''
glGenRenderbuffersOES.category = 'GL_OES_framebuffer_object'
glGenRenderbuffersOES.trace = True
glGenRenderbuffersOES.play = True
gl.add(glGenRenderbuffersOES)

glGenerateMipmapOES = Function('glGenerateMipmapOES')
glGenerateMipmapOES.ret = Return('void')
glGenerateMipmapOES.add( Input( 'target','GLenum' ))
glGenerateMipmapOES.version = ''
glGenerateMipmapOES.category = 'GL_OES_framebuffer_object'
glGenerateMipmapOES.trace = True
glGenerateMipmapOES.play = True
gl.add(glGenerateMipmapOES)

glGetFramebufferAttachmentParameterivOES = Function('glGetFramebufferAttachmentParameterivOES')
glGetFramebufferAttachmentParameterivOES.ret = Return('void')
glGetFramebufferAttachmentParameterivOES.add( Input( 'target','GLenum' ))
glGetFramebufferAttachmentParameterivOES.add( Input( 'attachment','GLenum' ))
glGetFramebufferAttachmentParameterivOES.add( Input( 'pname','GLenum' ))
glGetFramebufferAttachmentParameterivOES.add( Input( 'params','GLint *' ))
glGetFramebufferAttachmentParameterivOES.version = ''
glGetFramebufferAttachmentParameterivOES.category = 'GL_OES_framebuffer_object'
glGetFramebufferAttachmentParameterivOES.trace = True
glGetFramebufferAttachmentParameterivOES.play = True
gl.add(glGetFramebufferAttachmentParameterivOES)

glGetRenderbufferParameterivOES = Function('glGetRenderbufferParameterivOES')
glGetRenderbufferParameterivOES.ret = Return('void')
glGetRenderbufferParameterivOES.add( Input( 'target','GLenum' ))
glGetRenderbufferParameterivOES.add( Input( 'pname','GLenum' ))
glGetRenderbufferParameterivOES.add( Input( 'params','GLint *' ))
glGetRenderbufferParameterivOES.version = ''
glGetRenderbufferParameterivOES.category = 'GL_OES_framebuffer_object'
glGetRenderbufferParameterivOES.trace = True
glGetRenderbufferParameterivOES.play = True
gl.add(glGetRenderbufferParameterivOES)

glIsFramebufferOES = Function('glIsFramebufferOES')
glIsFramebufferOES.ret = Return('GLboolean')
glIsFramebufferOES.add( Input( 'framebuffer','GLuint' ))
glIsFramebufferOES.version = ''
glIsFramebufferOES.category = 'GL_OES_framebuffer_object'
glIsFramebufferOES.trace = True
glIsFramebufferOES.play = True
gl.add(glIsFramebufferOES)

glIsRenderbufferOES = Function('glIsRenderbufferOES')
glIsRenderbufferOES.ret = Return('GLboolean')
glIsRenderbufferOES.add( Input( 'renderbuffer','GLuint' ))
glIsRenderbufferOES.version = ''
glIsRenderbufferOES.category = 'GL_OES_framebuffer_object'
glIsRenderbufferOES.trace = True
glIsRenderbufferOES.play = True
gl.add(glIsRenderbufferOES)

glRenderbufferStorageOES = Function('glRenderbufferStorageOES')
glRenderbufferStorageOES.ret = Return('void')
glRenderbufferStorageOES.add( Input( 'target','GLenum' ))
glRenderbufferStorageOES.add( Input( 'internalformat','GLenum' ))
glRenderbufferStorageOES.add( Input( 'width','GLsizei' ))
glRenderbufferStorageOES.add( Input( 'height','GLsizei' ))
glRenderbufferStorageOES.version = ''
glRenderbufferStorageOES.category = 'GL_OES_framebuffer_object'
glRenderbufferStorageOES.trace = True
glRenderbufferStorageOES.play = True
gl.add(glRenderbufferStorageOES)

# GL_OES_get_program_binary

glGetProgramBinaryOES = Function('glGetProgramBinaryOES')
glGetProgramBinaryOES.ret = Return('void')
glGetProgramBinaryOES.add( Input( 'program','GLuint' ))
glGetProgramBinaryOES.add( Input( 'bufSize','GLsizei' ))
glGetProgramBinaryOES.add( Input( 'length','GLsizei *' ))
glGetProgramBinaryOES.add( Input( 'binaryFormat','GLenum *' ))
glGetProgramBinaryOES.add( Input( 'binary','GLvoid *' ))
glGetProgramBinaryOES.version = ''
glGetProgramBinaryOES.category = 'GL_OES_get_program_binary'
glGetProgramBinaryOES.trace = True
glGetProgramBinaryOES.play = True
gl.add(glGetProgramBinaryOES)

glProgramBinaryOES = Function('glProgramBinaryOES')
glProgramBinaryOES.ret = Return('void')
glProgramBinaryOES.add( Input( 'program','GLuint' ))
glProgramBinaryOES.add( Input( 'binaryFormat','GLenum' ))
glProgramBinaryOES.add( Input( 'binary','const GLvoid *' ))
glProgramBinaryOES.add( Input( 'length','GLint' ))
glProgramBinaryOES.version = ''
glProgramBinaryOES.category = 'GL_OES_get_program_binary'
glProgramBinaryOES.trace = True
glProgramBinaryOES.play = True
gl.add(glProgramBinaryOES)

# GL_OES_mapbuffer

glGetBufferPointervOES = Function('glGetBufferPointervOES')
glGetBufferPointervOES.ret = Return('void')
glGetBufferPointervOES.add( Input( 'target','GLenum' ))
glGetBufferPointervOES.add( Input( 'pname','GLenum' ))
glGetBufferPointervOES.add( Input( 'params','GLvoid **' ))
glGetBufferPointervOES.version = ''
glGetBufferPointervOES.category = 'GL_OES_mapbuffer'
glGetBufferPointervOES.trace = True
glGetBufferPointervOES.play = True
gl.add(glGetBufferPointervOES)

glMapBufferOES = Function('glMapBufferOES')
glMapBufferOES.ret = Return('GLvoid *')
glMapBufferOES.add( Input( 'target','GLenum' ))
glMapBufferOES.add( Input( 'access','GLenum' ))
glMapBufferOES.version = ''
glMapBufferOES.category = 'GL_OES_mapbuffer'
glMapBufferOES.trace = True
glMapBufferOES.play = True
gl.add(glMapBufferOES)

glUnmapBufferOES = Function('glUnmapBufferOES')
glUnmapBufferOES.ret = Return('GLboolean')
glUnmapBufferOES.add( Input( 'target','GLenum' ))
glUnmapBufferOES.version = ''
glUnmapBufferOES.category = 'GL_OES_mapbuffer'
glUnmapBufferOES.trace = True
glUnmapBufferOES.play = True
gl.add(glUnmapBufferOES)

# GL_OES_matrix_palette

glCurrentPaletteMatrixOES = Function('glCurrentPaletteMatrixOES')
glCurrentPaletteMatrixOES.ret = Return('void')
glCurrentPaletteMatrixOES.add( Input( 'index','GLuint' ))
glCurrentPaletteMatrixOES.version = ''
glCurrentPaletteMatrixOES.category = 'GL_OES_matrix_palette'
glCurrentPaletteMatrixOES.trace = True
glCurrentPaletteMatrixOES.play = True
gl.add(glCurrentPaletteMatrixOES)

glMatrixIndexPointerOES = Function('glMatrixIndexPointerOES')
glMatrixIndexPointerOES.ret = Return('void')
glMatrixIndexPointerOES.add( Input( 'size','GLint' ))
glMatrixIndexPointerOES.add( Input( 'type','GLenum' ))
glMatrixIndexPointerOES.add( Input( 'stride','GLsizei' ))
glMatrixIndexPointerOES.add( Input( 'pointer','GLvoid *' ))
glMatrixIndexPointerOES.version = ''
glMatrixIndexPointerOES.category = 'GL_OES_matrix_palette'
glMatrixIndexPointerOES.trace = True
glMatrixIndexPointerOES.play = True
gl.add(glMatrixIndexPointerOES)

glWeightPointerOES = Function('glWeightPointerOES')
glWeightPointerOES.ret = Return('void')
glWeightPointerOES.add( Input( 'size','GLint' ))
glWeightPointerOES.add( Input( 'type','GLenum' ))
glWeightPointerOES.add( Input( 'stride','GLsizei' ))
glWeightPointerOES.add( Input( 'pointer','GLvoid *' ))
glWeightPointerOES.version = ''
glWeightPointerOES.category = 'GL_OES_matrix_palette'
glWeightPointerOES.trace = True
glWeightPointerOES.play = True
gl.add(glWeightPointerOES)

# GL_OES_single_precision

glClearDepthfOES = Function('glClearDepthfOES')
glClearDepthfOES.ret = Return('void')
glClearDepthfOES.add( Input( 'depth','GLclampd' ))
glClearDepthfOES.version = ''
glClearDepthfOES.category = 'GL_OES_single_precision'
glClearDepthfOES.trace = True
glClearDepthfOES.play = True
gl.add(glClearDepthfOES)

glClipPlanefOES = Function('glClipPlanefOES')
glClipPlanefOES.ret = Return('void')
glClipPlanefOES.add( Input( 'plane','GLenum' ))
glClipPlanefOES.add( Input( 'equation','const GLfloat *' ))
glClipPlanefOES.version = ''
glClipPlanefOES.category = 'GL_OES_single_precision'
glClipPlanefOES.trace = True
glClipPlanefOES.play = True
gl.add(glClipPlanefOES)

glDepthRangefOES = Function('glDepthRangefOES')
glDepthRangefOES.ret = Return('void')
glDepthRangefOES.add( Input( 'n','GLclampf' ))
glDepthRangefOES.add( Input( 'f','GLclampf' ))
glDepthRangefOES.version = ''
glDepthRangefOES.category = 'GL_OES_single_precision'
glDepthRangefOES.trace = True
glDepthRangefOES.play = True
gl.add(glDepthRangefOES)

glFrustumfOES = Function('glFrustumfOES')
glFrustumfOES.ret = Return('void')
glFrustumfOES.add( Input( 'l','GLfloat' ))
glFrustumfOES.add( Input( 'r','GLfloat' ))
glFrustumfOES.add( Input( 'b','GLfloat' ))
glFrustumfOES.add( Input( 't','GLfloat' ))
glFrustumfOES.add( Input( 'n','GLfloat' ))
glFrustumfOES.add( Input( 'f','GLfloat' ))
glFrustumfOES.version = ''
glFrustumfOES.category = 'GL_OES_single_precision'
glFrustumfOES.trace = True
glFrustumfOES.play = True
gl.add(glFrustumfOES)

glGetClipPlanefOES = Function('glGetClipPlanefOES')
glGetClipPlanefOES.ret = Return('void')
glGetClipPlanefOES.add( Input( 'plane','GLenum' ))
glGetClipPlanefOES.add( Output( 'equation','GLfloat *' ))
glGetClipPlanefOES.version = ''
glGetClipPlanefOES.category = 'GL_OES_single_precision'
glGetClipPlanefOES.trace = True
glGetClipPlanefOES.play = True
gl.add(glGetClipPlanefOES)

glOrthofOES = Function('glOrthofOES')
glOrthofOES.ret = Return('void')
glOrthofOES.add( Input( 'l','GLfloat' ))
glOrthofOES.add( Input( 'r','GLfloat' ))
glOrthofOES.add( Input( 'b','GLfloat' ))
glOrthofOES.add( Input( 't','GLfloat' ))
glOrthofOES.add( Input( 'n','GLfloat' ))
glOrthofOES.add( Input( 'f','GLfloat' ))
glOrthofOES.version = ''
glOrthofOES.category = 'GL_OES_single_precision'
glOrthofOES.trace = True
glOrthofOES.play = True
gl.add(glOrthofOES)

# GL_OES_texture_3D

glCompressedTexImage3DOES = Function('glCompressedTexImage3DOES')
glCompressedTexImage3DOES.ret = Return('void')
glCompressedTexImage3DOES.add( Input( 'target','GLenum' ))
glCompressedTexImage3DOES.add( Input( 'level','GLint' ))
glCompressedTexImage3DOES.add( Input( 'internalformat','GLenum' ))
glCompressedTexImage3DOES.add( Input( 'width','GLsizei' ))
glCompressedTexImage3DOES.add( Input( 'height','GLsizei' ))
glCompressedTexImage3DOES.add( Input( 'depth','GLsizei' ))
glCompressedTexImage3DOES.add( Input( 'border','GLint' ))
glCompressedTexImage3DOES.add( Input( 'imageSize','GLsizei' ))
glCompressedTexImage3DOES.add( Input( 'data','const GLvoid *' ))
glCompressedTexImage3DOES.version = ''
glCompressedTexImage3DOES.category = 'GL_OES_texture_3D'
glCompressedTexImage3DOES.trace = True
glCompressedTexImage3DOES.play = True
gl.add(glCompressedTexImage3DOES)

glCompressedTexSubImage3DOES = Function('glCompressedTexSubImage3DOES')
glCompressedTexSubImage3DOES.ret = Return('void')
glCompressedTexSubImage3DOES.add( Input( 'target','GLenum' ))
glCompressedTexSubImage3DOES.add( Input( 'level','GLint' ))
glCompressedTexSubImage3DOES.add( Input( 'xoffset','GLint' ))
glCompressedTexSubImage3DOES.add( Input( 'yoffset','GLint' ))
glCompressedTexSubImage3DOES.add( Input( 'zoffset','GLint' ))
glCompressedTexSubImage3DOES.add( Input( 'width','GLsizei' ))
glCompressedTexSubImage3DOES.add( Input( 'height','GLsizei' ))
glCompressedTexSubImage3DOES.add( Input( 'depth','GLsizei' ))
glCompressedTexSubImage3DOES.add( Input( 'format','GLenum' ))
glCompressedTexSubImage3DOES.add( Input( 'imageSize','GLsizei' ))
glCompressedTexSubImage3DOES.add( Input( 'data','const GLvoid *' ))
glCompressedTexSubImage3DOES.version = ''
glCompressedTexSubImage3DOES.category = 'GL_OES_texture_3D'
glCompressedTexSubImage3DOES.trace = True
glCompressedTexSubImage3DOES.play = True
gl.add(glCompressedTexSubImage3DOES)

glCopyTexSubImage3DOES = Function('glCopyTexSubImage3DOES')
glCopyTexSubImage3DOES.ret = Return('void')
glCopyTexSubImage3DOES.add( Input( 'target','GLenum' ))
glCopyTexSubImage3DOES.add( Input( 'level','GLint' ))
glCopyTexSubImage3DOES.add( Input( 'xoffset','GLint' ))
glCopyTexSubImage3DOES.add( Input( 'yoffset','GLint' ))
glCopyTexSubImage3DOES.add( Input( 'zoffset','GLint' ))
glCopyTexSubImage3DOES.add( Input( 'x','GLint' ))
glCopyTexSubImage3DOES.add( Input( 'y','GLint' ))
glCopyTexSubImage3DOES.add( Input( 'width','GLsizei' ))
glCopyTexSubImage3DOES.add( Input( 'height','GLsizei' ))
glCopyTexSubImage3DOES.version = ''
glCopyTexSubImage3DOES.category = 'GL_OES_texture_3D'
glCopyTexSubImage3DOES.trace = True
glCopyTexSubImage3DOES.play = True
gl.add(glCopyTexSubImage3DOES)

glFramebufferTexture3DOES = Function('glFramebufferTexture3DOES')
glFramebufferTexture3DOES.ret = Return('void')
glFramebufferTexture3DOES.add( Input( 'target','GLenum' ))
glFramebufferTexture3DOES.add( Input( 'attachment','GLenum' ))
glFramebufferTexture3DOES.add( Input( 'textarget','GLenum' ))
glFramebufferTexture3DOES.add( Input( 'texture','GLuint' ))
glFramebufferTexture3DOES.add( Input( 'level','GLint' ))
glFramebufferTexture3DOES.add( Input( 'zoffset','GLint' ))
glFramebufferTexture3DOES.version = ''
glFramebufferTexture3DOES.category = 'GL_OES_texture_3D'
glFramebufferTexture3DOES.trace = True
glFramebufferTexture3DOES.play = True
gl.add(glFramebufferTexture3DOES)

glTexImage3DOES = Function('glTexImage3DOES')
glTexImage3DOES.ret = Return('void')
glTexImage3DOES.add( Input( 'target','GLenum' ))
glTexImage3DOES.add( Input( 'level','GLint' ))
glTexImage3DOES.add( Input( 'internalFormat','GLenum' ))
glTexImage3DOES.add( Input( 'width','GLsizei' ))
glTexImage3DOES.add( Input( 'height','GLsizei' ))
glTexImage3DOES.add( Input( 'depth','GLsizei' ))
glTexImage3DOES.add( Input( 'border','GLint' ))
glTexImage3DOES.add( Input( 'format','GLenum' ))
glTexImage3DOES.add( Input( 'type','GLenum' ))
glTexImage3DOES.add( Input( 'pixels','const GLvoid *' ))
glTexImage3DOES.version = ''
glTexImage3DOES.category = 'GL_OES_texture_3D'
glTexImage3DOES.trace = True
glTexImage3DOES.play = True
gl.add(glTexImage3DOES)

glTexSubImage3DOES = Function('glTexSubImage3DOES')
glTexSubImage3DOES.ret = Return('void')
glTexSubImage3DOES.add( Input( 'target','GLenum' ))
glTexSubImage3DOES.add( Input( 'level','GLint' ))
glTexSubImage3DOES.add( Input( 'xoffset','GLint' ))
glTexSubImage3DOES.add( Input( 'yoffset','GLint' ))
glTexSubImage3DOES.add( Input( 'zoffset','GLint' ))
glTexSubImage3DOES.add( Input( 'width','GLsizei' ))
glTexSubImage3DOES.add( Input( 'height','GLsizei' ))
glTexSubImage3DOES.add( Input( 'depth','GLsizei' ))
glTexSubImage3DOES.add( Input( 'format','GLenum' ))
glTexSubImage3DOES.add( Input( 'type','GLenum' ))
glTexSubImage3DOES.add( Input( 'pixels','const GLvoid *' ))
glTexSubImage3DOES.version = ''
glTexSubImage3DOES.category = 'GL_OES_texture_3D'
glTexSubImage3DOES.trace = True
glTexSubImage3DOES.play = True
gl.add(glTexSubImage3DOES)

# GL_OES_texture_cube_map

glGetTexGenfvOES = Function('glGetTexGenfvOES')
glGetTexGenfvOES.ret = Return('void')
glGetTexGenfvOES.add( Input( 'coord','GLenum' ))
glGetTexGenfvOES.add( Input( 'pname','GLenum' ))
glGetTexGenfvOES.add( Input( 'params','GLfloat *' ))
glGetTexGenfvOES.version = ''
glGetTexGenfvOES.category = 'GL_OES_texture_cube_map'
glGetTexGenfvOES.trace = True
glGetTexGenfvOES.play = True
gl.add(glGetTexGenfvOES)

glGetTexGenivOES = Function('glGetTexGenivOES')
glGetTexGenivOES.ret = Return('void')
glGetTexGenivOES.add( Input( 'coord','GLenum' ))
glGetTexGenivOES.add( Input( 'pname','GLenum' ))
glGetTexGenivOES.add( Input( 'params','GLint *' ))
glGetTexGenivOES.version = ''
glGetTexGenivOES.category = 'GL_OES_texture_cube_map'
glGetTexGenivOES.trace = True
glGetTexGenivOES.play = True
gl.add(glGetTexGenivOES)

glGetTexGenxvOES = Function('glGetTexGenxvOES')
glGetTexGenxvOES.ret = Return('void')
glGetTexGenxvOES.add( Input( 'coord','GLenum' ))
glGetTexGenxvOES.add( Input( 'pname','GLenum' ))
glGetTexGenxvOES.add( Input( 'params','GLfixed *' ))
glGetTexGenxvOES.version = ''
glGetTexGenxvOES.category = 'GL_OES_texture_cube_map'
glGetTexGenxvOES.trace = True
glGetTexGenxvOES.play = True
gl.add(glGetTexGenxvOES)

glTexGenfOES = Function('glTexGenfOES')
glTexGenfOES.ret = Return('void')
glTexGenfOES.add( Input( 'coord','GLenum' ))
glTexGenfOES.add( Input( 'pname','GLenum' ))
glTexGenfOES.add( Input( 'param','GLfloat' ))
glTexGenfOES.version = ''
glTexGenfOES.category = 'GL_OES_texture_cube_map'
glTexGenfOES.trace = True
glTexGenfOES.play = True
gl.add(glTexGenfOES)

glTexGenfvOES = Function('glTexGenfvOES')
glTexGenfvOES.ret = Return('void')
glTexGenfvOES.add( Input( 'coord','GLenum' ))
glTexGenfvOES.add( Input( 'pname','GLenum' ))
glTexGenfvOES.add( Input( 'params','const GLfloat *' ))
glTexGenfvOES.version = ''
glTexGenfvOES.category = 'GL_OES_texture_cube_map'
glTexGenfvOES.trace = True
glTexGenfvOES.play = True
gl.add(glTexGenfvOES)

glTexGeniOES = Function('glTexGeniOES')
glTexGeniOES.ret = Return('void')
glTexGeniOES.add( Input( 'coord','GLenum' ))
glTexGeniOES.add( Input( 'pname','GLenum' ))
glTexGeniOES.add( Input( 'param','GLint' ))
glTexGeniOES.version = ''
glTexGeniOES.category = 'GL_OES_texture_cube_map'
glTexGeniOES.trace = True
glTexGeniOES.play = True
gl.add(glTexGeniOES)

glTexGenivOES = Function('glTexGenivOES')
glTexGenivOES.ret = Return('void')
glTexGenivOES.add( Input( 'coord','GLenum' ))
glTexGenivOES.add( Input( 'pname','GLenum' ))
glTexGenivOES.add( Input( 'params','const GLint *' ))
glTexGenivOES.version = ''
glTexGenivOES.category = 'GL_OES_texture_cube_map'
glTexGenivOES.trace = True
glTexGenivOES.play = True
gl.add(glTexGenivOES)

glTexGenxOES = Function('glTexGenxOES')
glTexGenxOES.ret = Return('void')
glTexGenxOES.add( Input( 'coord','GLenum' ))
glTexGenxOES.add( Input( 'pname','GLenum' ))
glTexGenxOES.add( Input( 'param','GLfixed' ))
glTexGenxOES.version = ''
glTexGenxOES.category = 'GL_OES_texture_cube_map'
glTexGenxOES.trace = True
glTexGenxOES.play = True
gl.add(glTexGenxOES)

glTexGenxvOES = Function('glTexGenxvOES')
glTexGenxvOES.ret = Return('void')
glTexGenxvOES.add( Input( 'coord','GLenum' ))
glTexGenxvOES.add( Input( 'pname','GLenum' ))
glTexGenxvOES.add( Input( 'params','const GLfixed *' ))
glTexGenxvOES.version = ''
glTexGenxvOES.category = 'GL_OES_texture_cube_map'
glTexGenxvOES.trace = True
glTexGenxvOES.play = True
gl.add(glTexGenxvOES)

# GL_OES_vertex_array_object

glBindVertexArrayOES = Function('glBindVertexArrayOES')
glBindVertexArrayOES.ret = Return('void')
glBindVertexArrayOES.add( Input( 'array','GLuint' ))
glBindVertexArrayOES.version = ''
glBindVertexArrayOES.category = 'GL_OES_vertex_array_object'
glBindVertexArrayOES.trace = True
glBindVertexArrayOES.play = True
gl.add(glBindVertexArrayOES)

glDeleteVertexArraysOES = Function('glDeleteVertexArraysOES')
glDeleteVertexArraysOES.ret = Return('void')
glDeleteVertexArraysOES.add( Input( 'n','GLsizei' ))
glDeleteVertexArraysOES.add( Input( 'arrays','const GLuint *' ))
glDeleteVertexArraysOES.version = ''
glDeleteVertexArraysOES.category = 'GL_OES_vertex_array_object'
glDeleteVertexArraysOES.trace = True
glDeleteVertexArraysOES.play = True
gl.add(glDeleteVertexArraysOES)

glGenVertexArraysOES = Function('glGenVertexArraysOES')
glGenVertexArraysOES.ret = Return('void')
glGenVertexArraysOES.add( Input( 'n','GLsizei' ))
glGenVertexArraysOES.add( Input( 'arrays','GLuint *' ))
glGenVertexArraysOES.version = ''
glGenVertexArraysOES.category = 'GL_OES_vertex_array_object'
glGenVertexArraysOES.trace = True
glGenVertexArraysOES.play = True
gl.add(glGenVertexArraysOES)

glIsVertexArrayOES = Function('glIsVertexArrayOES')
glIsVertexArrayOES.ret = Return('GLboolean')
glIsVertexArrayOES.add( Input( 'array','GLuint' ))
glIsVertexArrayOES.version = ''
glIsVertexArrayOES.category = 'GL_OES_vertex_array_object'
glIsVertexArrayOES.trace = True
glIsVertexArrayOES.play = True
gl.add(glIsVertexArrayOES)

# GL_PGI_misc_hints

glHintPGI = Function('glHintPGI')
glHintPGI.ret = Return('void')
glHintPGI.add( Input( 'target','GLenum' ))
glHintPGI.add( Input( 'mode','GLint' ))
glHintPGI.version = '1.1'
glHintPGI.category = 'GL_PGI_misc_hints'
glHintPGI.trace = True
glHintPGI.play = True
gl.add(glHintPGI)

# GL_QCOM_alpha_test

glAlphaFuncQCOM = Function('glAlphaFuncQCOM')
glAlphaFuncQCOM.ret = Return('void')
glAlphaFuncQCOM.add( Input( 'func','GLenum' ))
glAlphaFuncQCOM.add( Input( 'ref','GLclampf' ))
glAlphaFuncQCOM.version = ''
glAlphaFuncQCOM.category = 'GL_QCOM_alpha_test'
glAlphaFuncQCOM.trace = True
glAlphaFuncQCOM.play = True
gl.add(glAlphaFuncQCOM)

# GL_QCOM_driver_control

glDisableDriverControlQCOM = Function('glDisableDriverControlQCOM')
glDisableDriverControlQCOM.ret = Return('void')
glDisableDriverControlQCOM.add( Input( 'driverControl','GLuint' ))
glDisableDriverControlQCOM.version = ''
glDisableDriverControlQCOM.category = 'GL_QCOM_driver_control'
glDisableDriverControlQCOM.trace = True
glDisableDriverControlQCOM.play = True
gl.add(glDisableDriverControlQCOM)

glEnableDriverControlQCOM = Function('glEnableDriverControlQCOM')
glEnableDriverControlQCOM.ret = Return('void')
glEnableDriverControlQCOM.add( Input( 'driverControl','GLuint' ))
glEnableDriverControlQCOM.version = ''
glEnableDriverControlQCOM.category = 'GL_QCOM_driver_control'
glEnableDriverControlQCOM.trace = True
glEnableDriverControlQCOM.play = True
gl.add(glEnableDriverControlQCOM)

glGetDriverControlStringQCOM = Function('glGetDriverControlStringQCOM')
glGetDriverControlStringQCOM.ret = Return('void')
glGetDriverControlStringQCOM.add( Input( 'driverControl','GLuint' ))
glGetDriverControlStringQCOM.add( Input( 'bufSize','GLsizei' ))
glGetDriverControlStringQCOM.add( Input( 'length','GLsizei *' ))
glGetDriverControlStringQCOM.add( Input( 'driverControlString','GLchar *' ))
glGetDriverControlStringQCOM.version = ''
glGetDriverControlStringQCOM.category = 'GL_QCOM_driver_control'
glGetDriverControlStringQCOM.trace = True
glGetDriverControlStringQCOM.play = True
gl.add(glGetDriverControlStringQCOM)

glGetDriverControlsQCOM = Function('glGetDriverControlsQCOM')
glGetDriverControlsQCOM.ret = Return('void')
glGetDriverControlsQCOM.add( Input( 'num','GLint *' ))
glGetDriverControlsQCOM.add( Input( 'size','GLsizei' ))
glGetDriverControlsQCOM.add( Input( 'driverControls','GLuint *' ))
glGetDriverControlsQCOM.version = ''
glGetDriverControlsQCOM.category = 'GL_QCOM_driver_control'
glGetDriverControlsQCOM.trace = True
glGetDriverControlsQCOM.play = True
gl.add(glGetDriverControlsQCOM)

# GL_QCOM_extended_get

glExtGetBufferPointervQCOM = Function('glExtGetBufferPointervQCOM')
glExtGetBufferPointervQCOM.ret = Return('void')
glExtGetBufferPointervQCOM.add( Input( 'target','GLenum' ))
glExtGetBufferPointervQCOM.add( Input( 'params','GLvoid **' ))
glExtGetBufferPointervQCOM.version = ''
glExtGetBufferPointervQCOM.category = 'GL_QCOM_extended_get'
glExtGetBufferPointervQCOM.trace = True
glExtGetBufferPointervQCOM.play = True
gl.add(glExtGetBufferPointervQCOM)

glExtGetBuffersQCOM = Function('glExtGetBuffersQCOM')
glExtGetBuffersQCOM.ret = Return('void')
glExtGetBuffersQCOM.add( Input( 'buffers','GLuint *' ))
glExtGetBuffersQCOM.add( Input( 'maxBuffers','GLint' ))
glExtGetBuffersQCOM.add( Input( 'numBuffers','GLint *' ))
glExtGetBuffersQCOM.version = ''
glExtGetBuffersQCOM.category = 'GL_QCOM_extended_get'
glExtGetBuffersQCOM.trace = True
glExtGetBuffersQCOM.play = True
gl.add(glExtGetBuffersQCOM)

glExtGetFramebuffersQCOM = Function('glExtGetFramebuffersQCOM')
glExtGetFramebuffersQCOM.ret = Return('void')
glExtGetFramebuffersQCOM.add( Input( 'framebuffers','GLuint *' ))
glExtGetFramebuffersQCOM.add( Input( 'maxFramebuffers','GLint' ))
glExtGetFramebuffersQCOM.add( Input( 'numFramebuffers','GLint *' ))
glExtGetFramebuffersQCOM.version = ''
glExtGetFramebuffersQCOM.category = 'GL_QCOM_extended_get'
glExtGetFramebuffersQCOM.trace = True
glExtGetFramebuffersQCOM.play = True
gl.add(glExtGetFramebuffersQCOM)

glExtGetRenderbuffersQCOM = Function('glExtGetRenderbuffersQCOM')
glExtGetRenderbuffersQCOM.ret = Return('void')
glExtGetRenderbuffersQCOM.add( Input( 'renderbuffers','GLuint *' ))
glExtGetRenderbuffersQCOM.add( Input( 'maxRenderbuffers','GLint' ))
glExtGetRenderbuffersQCOM.add( Input( 'numRenderbuffers','GLint *' ))
glExtGetRenderbuffersQCOM.version = ''
glExtGetRenderbuffersQCOM.category = 'GL_QCOM_extended_get'
glExtGetRenderbuffersQCOM.trace = True
glExtGetRenderbuffersQCOM.play = True
gl.add(glExtGetRenderbuffersQCOM)

glExtGetTexLevelParameterivQCOM = Function('glExtGetTexLevelParameterivQCOM')
glExtGetTexLevelParameterivQCOM.ret = Return('void')
glExtGetTexLevelParameterivQCOM.add( Input( 'texture','GLuint' ))
glExtGetTexLevelParameterivQCOM.add( Input( 'face','GLenum' ))
glExtGetTexLevelParameterivQCOM.add( Input( 'level','GLint' ))
glExtGetTexLevelParameterivQCOM.add( Input( 'pname','GLenum' ))
glExtGetTexLevelParameterivQCOM.add( Input( 'params','GLint *' ))
glExtGetTexLevelParameterivQCOM.version = ''
glExtGetTexLevelParameterivQCOM.category = 'GL_QCOM_extended_get'
glExtGetTexLevelParameterivQCOM.trace = True
glExtGetTexLevelParameterivQCOM.play = True
gl.add(glExtGetTexLevelParameterivQCOM)

glExtGetTexSubImageQCOM = Function('glExtGetTexSubImageQCOM')
glExtGetTexSubImageQCOM.ret = Return('void')
glExtGetTexSubImageQCOM.add( Input( 'target','GLenum' ))
glExtGetTexSubImageQCOM.add( Input( 'level','GLint' ))
glExtGetTexSubImageQCOM.add( Input( 'xoffset','GLint' ))
glExtGetTexSubImageQCOM.add( Input( 'yoffset','GLint' ))
glExtGetTexSubImageQCOM.add( Input( 'zoffset','GLint' ))
glExtGetTexSubImageQCOM.add( Input( 'width','GLsizei' ))
glExtGetTexSubImageQCOM.add( Input( 'height','GLsizei' ))
glExtGetTexSubImageQCOM.add( Input( 'depth','GLsizei' ))
glExtGetTexSubImageQCOM.add( Input( 'format','GLenum' ))
glExtGetTexSubImageQCOM.add( Input( 'type','GLenum' ))
glExtGetTexSubImageQCOM.add( Input( 'texels','GLvoid *' ))
glExtGetTexSubImageQCOM.version = ''
glExtGetTexSubImageQCOM.category = 'GL_QCOM_extended_get'
glExtGetTexSubImageQCOM.trace = True
glExtGetTexSubImageQCOM.play = True
gl.add(glExtGetTexSubImageQCOM)

glExtGetTexturesQCOM = Function('glExtGetTexturesQCOM')
glExtGetTexturesQCOM.ret = Return('void')
glExtGetTexturesQCOM.add( Input( 'textures','GLuint *' ))
glExtGetTexturesQCOM.add( Input( 'maxTextures','GLint' ))
glExtGetTexturesQCOM.add( Input( 'numTextures','GLint *' ))
glExtGetTexturesQCOM.version = ''
glExtGetTexturesQCOM.category = 'GL_QCOM_extended_get'
glExtGetTexturesQCOM.trace = True
glExtGetTexturesQCOM.play = True
gl.add(glExtGetTexturesQCOM)

glExtTexObjectStateOverrideiQCOM = Function('glExtTexObjectStateOverrideiQCOM')
glExtTexObjectStateOverrideiQCOM.ret = Return('void')
glExtTexObjectStateOverrideiQCOM.add( Input( 'target','GLenum' ))
glExtTexObjectStateOverrideiQCOM.add( Input( 'pname','GLenum' ))
glExtTexObjectStateOverrideiQCOM.add( Input( 'param','GLint' ))
glExtTexObjectStateOverrideiQCOM.version = ''
glExtTexObjectStateOverrideiQCOM.category = 'GL_QCOM_extended_get'
glExtTexObjectStateOverrideiQCOM.trace = True
glExtTexObjectStateOverrideiQCOM.play = True
gl.add(glExtTexObjectStateOverrideiQCOM)

# GL_QCOM_extended_get2

glExtGetProgramBinarySourceQCOM = Function('glExtGetProgramBinarySourceQCOM')
glExtGetProgramBinarySourceQCOM.ret = Return('void')
glExtGetProgramBinarySourceQCOM.add( Input( 'program','GLuint' ))
glExtGetProgramBinarySourceQCOM.add( Input( 'shadertype','GLenum' ))
glExtGetProgramBinarySourceQCOM.add( Input( 'source','GLchar *' ))
glExtGetProgramBinarySourceQCOM.add( Input( 'length','GLint *' ))
glExtGetProgramBinarySourceQCOM.version = ''
glExtGetProgramBinarySourceQCOM.category = 'GL_QCOM_extended_get2'
glExtGetProgramBinarySourceQCOM.trace = True
glExtGetProgramBinarySourceQCOM.play = True
gl.add(glExtGetProgramBinarySourceQCOM)

glExtGetProgramsQCOM = Function('glExtGetProgramsQCOM')
glExtGetProgramsQCOM.ret = Return('void')
glExtGetProgramsQCOM.add( Input( 'programs','GLuint *' ))
glExtGetProgramsQCOM.add( Input( 'maxPrograms','GLint' ))
glExtGetProgramsQCOM.add( Input( 'numPrograms','GLint *' ))
glExtGetProgramsQCOM.version = ''
glExtGetProgramsQCOM.category = 'GL_QCOM_extended_get2'
glExtGetProgramsQCOM.trace = True
glExtGetProgramsQCOM.play = True
gl.add(glExtGetProgramsQCOM)

glExtGetShadersQCOM = Function('glExtGetShadersQCOM')
glExtGetShadersQCOM.ret = Return('void')
glExtGetShadersQCOM.add( Input( 'shaders','GLuint *' ))
glExtGetShadersQCOM.add( Input( 'maxShaders','GLint' ))
glExtGetShadersQCOM.add( Input( 'numShaders','GLint *' ))
glExtGetShadersQCOM.version = ''
glExtGetShadersQCOM.category = 'GL_QCOM_extended_get2'
glExtGetShadersQCOM.trace = True
glExtGetShadersQCOM.play = True
gl.add(glExtGetShadersQCOM)

glExtIsProgramBinaryQCOM = Function('glExtIsProgramBinaryQCOM')
glExtIsProgramBinaryQCOM.ret = Return('GLboolean')
glExtIsProgramBinaryQCOM.add( Input( 'program','GLuint' ))
glExtIsProgramBinaryQCOM.version = ''
glExtIsProgramBinaryQCOM.category = 'GL_QCOM_extended_get2'
glExtIsProgramBinaryQCOM.trace = True
glExtIsProgramBinaryQCOM.play = True
gl.add(glExtIsProgramBinaryQCOM)

# GL_QCOM_tiled_rendering

glEndTilingQCOM = Function('glEndTilingQCOM')
glEndTilingQCOM.ret = Return('void')
glEndTilingQCOM.add( Input( 'preserveMask','GLbitfield' ,regalLog = 'GLstartTilingQCOMToString(preserveMask)' ))
glEndTilingQCOM.version = ''
glEndTilingQCOM.category = 'GL_QCOM_tiled_rendering'
glEndTilingQCOM.trace = True
glEndTilingQCOM.play = True
gl.add(glEndTilingQCOM)

glStartTilingQCOM = Function('glStartTilingQCOM')
glStartTilingQCOM.ret = Return('void')
glStartTilingQCOM.add( Input( 'x','GLuint' ))
glStartTilingQCOM.add( Input( 'y','GLuint' ))
glStartTilingQCOM.add( Input( 'width','GLuint' ))
glStartTilingQCOM.add( Input( 'height','GLuint' ))
glStartTilingQCOM.add( Input( 'preserveMask','GLbitfield' ,regalLog = 'GLstartTilingQCOMToString(preserveMask)' ))
glStartTilingQCOM.version = ''
glStartTilingQCOM.category = 'GL_QCOM_tiled_rendering'
glStartTilingQCOM.trace = True
glStartTilingQCOM.play = True
gl.add(glStartTilingQCOM)

# GL_REGAL_ES1_0_compatibility

glAlphaFuncx = Function('glAlphaFuncx')
glAlphaFuncx.ret = Return('void')
glAlphaFuncx.add( Input( 'func','GLenum' ))
glAlphaFuncx.add( Input( 'ref','GLclampx' ))
glAlphaFuncx.version = ''
glAlphaFuncx.category = 'GL_REGAL_ES1_0_compatibility'
glAlphaFuncx.esVersions = [1.0, 1.1]
glAlphaFuncx.regalRemap = 'glAlphaFunc(func, fixedToFloat(ref))'
glAlphaFuncx.trace = True
glAlphaFuncx.play = True
gl.add(glAlphaFuncx)

glClearColorx = Function('glClearColorx')
glClearColorx.ret = Return('void')
glClearColorx.add( Input( 'red','GLclampx' ))
glClearColorx.add( Input( 'green','GLclampx' ))
glClearColorx.add( Input( 'blue','GLclampx' ))
glClearColorx.add( Input( 'alpha','GLclampx' ))
glClearColorx.version = ''
glClearColorx.category = 'GL_REGAL_ES1_0_compatibility'
glClearColorx.esVersions = [1.0, 1.1]
glClearColorx.regalRemap = 'glClearColor(fixedToFloat(red), fixedToFloat(green), fixedToFloat(blue), fixedToFloat(alpha))'
glClearColorx.trace = True
glClearColorx.play = True
gl.add(glClearColorx)

glClearDepthx = Function('glClearDepthx')
glClearDepthx.ret = Return('void')
glClearDepthx.add( Input( 'depth','GLclampx' ))
glClearDepthx.version = ''
glClearDepthx.category = 'GL_REGAL_ES1_0_compatibility'
glClearDepthx.esVersions = [1.0, 1.1]
glClearDepthx.regalRemap = 'glClearDepth(fixedToFloat(depth))'
glClearDepthx.trace = True
glClearDepthx.play = True
gl.add(glClearDepthx)

glColor4x = Function('glColor4x')
glColor4x.ret = Return('void')
glColor4x.add( Input( 'red','GLfixed' ))
glColor4x.add( Input( 'green','GLfixed' ))
glColor4x.add( Input( 'blue','GLfixed' ))
glColor4x.add( Input( 'alpha','GLfixed' ))
glColor4x.version = ''
glColor4x.category = 'GL_REGAL_ES1_0_compatibility'
glColor4x.esVersions = [1.0, 1.1]
glColor4x.regalRemap = 'glColor4f(fixedToFloat(red), fixedToFloat(green), fixedToFloat(blue), fixedToFloat(alpha))'
glColor4x.trace = True
glColor4x.play = True
gl.add(glColor4x)

glDepthRangex = Function('glDepthRangex')
glDepthRangex.ret = Return('void')
glDepthRangex.add( Input( 'zNear','GLclampx' ))
glDepthRangex.add( Input( 'zFar','GLclampx' ))
glDepthRangex.version = ''
glDepthRangex.category = 'GL_REGAL_ES1_0_compatibility'
glDepthRangex.esVersions = [1.0, 1.1]
glDepthRangex.regalRemap = 'glDepthRange(fixedToFloat(zNear), fixedToFloat(zFar))'
glDepthRangex.trace = True
glDepthRangex.play = True
gl.add(glDepthRangex)

glFogx = Function('glFogx')
glFogx.ret = Return('void')
glFogx.add( Input( 'pname','GLenum' ))
glFogx.add( Input( 'param','GLfixed' ))
glFogx.version = ''
glFogx.category = 'GL_REGAL_ES1_0_compatibility'
glFogx.esVersions = [1.0, 1.1]
glFogx.regalRemap = 'glFogf(pname, fixedToFloat(param))'
glFogx.trace = True
glFogx.play = True
gl.add(glFogx)

glFogxv = Function('glFogxv')
glFogxv.ret = Return('void')
glFogxv.add( Input( 'pname','GLenum' ))
glFogxv.add( Input( 'params','const GLfixed *' ))
glFogxv.version = ''
glFogxv.category = 'GL_REGAL_ES1_0_compatibility'
glFogxv.esVersions = [1.0, 1.1]
glFogxv.regalRemap = ['GLfloat tmp[4];', 'fixedToFloat(tmp,params,pname==GL_FOG_COLOR ? 4 : 1);', 'glFogfv(pname,tmp);']
glFogxv.trace = True
glFogxv.play = True
gl.add(glFogxv)

glFrustumf = Function('glFrustumf')
glFrustumf.ret = Return('void')
glFrustumf.add( Input( 'left','GLfloat' ))
glFrustumf.add( Input( 'right','GLfloat' ))
glFrustumf.add( Input( 'bottom','GLfloat' ))
glFrustumf.add( Input( 'top','GLfloat' ))
glFrustumf.add( Input( 'zNear','GLfloat' ))
glFrustumf.add( Input( 'zFar','GLfloat' ))
glFrustumf.version = ''
glFrustumf.category = 'GL_REGAL_ES1_0_compatibility'
glFrustumf.esVersions = [1.0, 1.1]
glFrustumf.regalRemap = 'glFrustum(left,right,bottom,top,zNear,zFar)'
glFrustumf.trace = True
glFrustumf.play = True
gl.add(glFrustumf)

glFrustumx = Function('glFrustumx')
glFrustumx.ret = Return('void')
glFrustumx.add( Input( 'left','GLfixed' ))
glFrustumx.add( Input( 'right','GLfixed' ))
glFrustumx.add( Input( 'bottom','GLfixed' ))
glFrustumx.add( Input( 'top','GLfixed' ))
glFrustumx.add( Input( 'zNear','GLfixed' ))
glFrustumx.add( Input( 'zFar','GLfixed' ))
glFrustumx.version = ''
glFrustumx.category = 'GL_REGAL_ES1_0_compatibility'
glFrustumx.esVersions = [1.0, 1.1]
glFrustumx.regalRemap = 'glFrustumf(fixedToFloat(left), fixedToFloat(right), fixedToFloat(bottom), fixedToFloat(top), fixedToFloat(zNear), fixedToFloat(zFar))'
glFrustumx.trace = True
glFrustumx.play = True
gl.add(glFrustumx)

glLightModelx = Function('glLightModelx')
glLightModelx.ret = Return('void')
glLightModelx.add( Input( 'pname','GLenum' ))
glLightModelx.add( Input( 'param','GLfixed' ))
glLightModelx.version = ''
glLightModelx.category = 'GL_REGAL_ES1_0_compatibility'
glLightModelx.esVersions = [1.0, 1.1]
glLightModelx.regalRemap = 'glLightModelf(pname, fixedToFloat(param))'
glLightModelx.trace = True
glLightModelx.play = True
gl.add(glLightModelx)

glLightModelxv = Function('glLightModelxv')
glLightModelxv.ret = Return('void')
glLightModelxv.add( Input( 'pname','GLenum' ))
glLightModelxv.add( Input( 'params','const GLfixed *' ))
glLightModelxv.version = ''
glLightModelxv.category = 'GL_REGAL_ES1_0_compatibility'
glLightModelxv.esVersions = [1.0, 1.1]
glLightModelxv.regalRemap = ['GLfloat tmp[4];', 'fixedToFloat(tmp,params,pname==GL_LIGHT_MODEL_AMBIENT ? 4 : 1);', 'glLightModelfv(pname,tmp);']
glLightModelxv.trace = True
glLightModelxv.play = True
gl.add(glLightModelxv)

glLightx = Function('glLightx')
glLightx.ret = Return('void')
glLightx.add( Input( 'light','GLenum' ))
glLightx.add( Input( 'pname','GLenum' ))
glLightx.add( Input( 'param','GLfixed' ))
glLightx.version = ''
glLightx.category = 'GL_REGAL_ES1_0_compatibility'
glLightx.esVersions = [1.0, 1.1]
glLightx.regalRemap = 'glLightf(light, pname, fixedToFloat(param))'
glLightx.trace = True
glLightx.play = True
gl.add(glLightx)

glLightxv = Function('glLightxv')
glLightxv.ret = Return('void')
glLightxv.add( Input( 'light','GLenum' ))
glLightxv.add( Input( 'pname','GLenum' ))
glLightxv.add( Input( 'params','const GLfixed *' ))
glLightxv.version = ''
glLightxv.category = 'GL_REGAL_ES1_0_compatibility'
glLightxv.esVersions = [1.0, 1.1]
glLightxv.regalRemap = ['GLfloat tmp[4];', 'fixedToFloat(tmp,params,(pname==GL_AMBIENT || pname==GL_DIFFUSE || pname==GL_SPECULAR || pname==GL_POSITION) ? 4 : (pname==GL_SPOT_DIRECTION ? 3 : 1));', 'glLightfv(light,pname,tmp);']
glLightxv.trace = True
glLightxv.play = True
gl.add(glLightxv)

glLineWidthx = Function('glLineWidthx')
glLineWidthx.ret = Return('void')
glLineWidthx.add( Input( 'width','GLfixed' ))
glLineWidthx.version = ''
glLineWidthx.category = 'GL_REGAL_ES1_0_compatibility'
glLineWidthx.esVersions = [1.0, 1.1]
glLineWidthx.regalRemap = 'glLineWidth(fixedToFloat(width))'
glLineWidthx.trace = True
glLineWidthx.play = True
gl.add(glLineWidthx)

glLoadMatrixx = Function('glLoadMatrixx')
glLoadMatrixx.ret = Return('void')
glLoadMatrixx.add( Input( 'm','const GLfixed *' ))
glLoadMatrixx.version = ''
glLoadMatrixx.category = 'GL_REGAL_ES1_0_compatibility'
glLoadMatrixx.esVersions = [1.0, 1.1]
glLoadMatrixx.regalRemap = ['GLfloat tmp[16];', 'fixedToFloat(tmp,m,16);', 'glLoadMatrixf(tmp);']
glLoadMatrixx.trace = True
glLoadMatrixx.play = True
gl.add(glLoadMatrixx)

glMaterialx = Function('glMaterialx')
glMaterialx.ret = Return('void')
glMaterialx.add( Input( 'face','GLenum' ))
glMaterialx.add( Input( 'pname','GLenum' ))
glMaterialx.add( Input( 'param','GLfixed' ))
glMaterialx.version = ''
glMaterialx.category = 'GL_REGAL_ES1_0_compatibility'
glMaterialx.esVersions = [1.0, 1.1]
glMaterialx.regalRemap = 'glMaterialf(face,pname,fixedToFloat(param))'
glMaterialx.trace = True
glMaterialx.play = True
gl.add(glMaterialx)

glMaterialxv = Function('glMaterialxv')
glMaterialxv.ret = Return('void')
glMaterialxv.add( Input( 'face','GLenum' ))
glMaterialxv.add( Input( 'pname','GLenum' ))
glMaterialxv.add( Input( 'params','const GLfixed *' ))
glMaterialxv.version = ''
glMaterialxv.category = 'GL_REGAL_ES1_0_compatibility'
glMaterialxv.esVersions = [1.0, 1.1]
glMaterialxv.regalRemap = ['GLfloat tmp[16];', 'fixedToFloat(tmp,params,pname==GL_SHININESS ? 1 : 4);', 'glMaterialfv(face,pname,tmp);']
glMaterialxv.trace = True
glMaterialxv.play = True
gl.add(glMaterialxv)

glMultMatrixx = Function('glMultMatrixx')
glMultMatrixx.ret = Return('void')
glMultMatrixx.add( Input( 'm','const GLfixed *' ))
glMultMatrixx.version = ''
glMultMatrixx.category = 'GL_REGAL_ES1_0_compatibility'
glMultMatrixx.esVersions = [1.0, 1.1]
glMultMatrixx.regalRemap = ['GLfloat tmp[16];', 'fixedToFloat(tmp,m,16);', 'glMultMatrixf(tmp);']
glMultMatrixx.trace = True
glMultMatrixx.play = True
gl.add(glMultMatrixx)

glMultiTexCoord4x = Function('glMultiTexCoord4x')
glMultiTexCoord4x.ret = Return('void')
glMultiTexCoord4x.add( Input( 'target','GLenum' ))
glMultiTexCoord4x.add( Input( 's','GLfixed' ))
glMultiTexCoord4x.add( Input( 't','GLfixed' ))
glMultiTexCoord4x.add( Input( 'r','GLfixed' ))
glMultiTexCoord4x.add( Input( 'q','GLfixed' ))
glMultiTexCoord4x.version = ''
glMultiTexCoord4x.category = 'GL_REGAL_ES1_0_compatibility'
glMultiTexCoord4x.esVersions = [1.0, 1.1]
glMultiTexCoord4x.regalRemap = 'glMultiTexCoord4f(target,fixedToFloat(s),fixedToFloat(t),fixedToFloat(r),fixedToFloat(q))'
glMultiTexCoord4x.trace = True
glMultiTexCoord4x.play = True
gl.add(glMultiTexCoord4x)

glNormal3x = Function('glNormal3x')
glNormal3x.ret = Return('void')
glNormal3x.add( Input( 'nx','GLfixed' ))
glNormal3x.add( Input( 'ny','GLfixed' ))
glNormal3x.add( Input( 'nz','GLfixed' ))
glNormal3x.version = ''
glNormal3x.category = 'GL_REGAL_ES1_0_compatibility'
glNormal3x.esVersions = [1.0, 1.1]
glNormal3x.regalRemap = 'glNormal3f(fixedToFloat(nx),fixedToFloat(ny),fixedToFloat(nz))'
glNormal3x.trace = True
glNormal3x.play = True
gl.add(glNormal3x)

glOrthof = Function('glOrthof')
glOrthof.ret = Return('void')
glOrthof.add( Input( 'left','GLfloat' ))
glOrthof.add( Input( 'right','GLfloat' ))
glOrthof.add( Input( 'bottom','GLfloat' ))
glOrthof.add( Input( 'top','GLfloat' ))
glOrthof.add( Input( 'zNear','GLfloat' ))
glOrthof.add( Input( 'zFar','GLfloat' ))
glOrthof.version = ''
glOrthof.category = 'GL_REGAL_ES1_0_compatibility'
glOrthof.esVersions = [1.0, 1.1]
glOrthof.regalRemap = 'glOrtho(left,right,bottom,top,zNear,zFar)'
glOrthof.trace = True
glOrthof.play = True
gl.add(glOrthof)

glOrthox = Function('glOrthox')
glOrthox.ret = Return('void')
glOrthox.add( Input( 'left','GLfixed' ))
glOrthox.add( Input( 'right','GLfixed' ))
glOrthox.add( Input( 'bottom','GLfixed' ))
glOrthox.add( Input( 'top','GLfixed' ))
glOrthox.add( Input( 'zNear','GLfixed' ))
glOrthox.add( Input( 'zFar','GLfixed' ))
glOrthox.version = ''
glOrthox.category = 'GL_REGAL_ES1_0_compatibility'
glOrthox.esVersions = [1.0, 1.1]
glOrthox.regalRemap = 'glOrthof(fixedToFloat(left),fixedToFloat(right),fixedToFloat(bottom),fixedToFloat(top),fixedToFloat(zNear),fixedToFloat(zFar))'
glOrthox.trace = True
glOrthox.play = True
gl.add(glOrthox)

glPointSizex = Function('glPointSizex')
glPointSizex.ret = Return('void')
glPointSizex.add( Input( 'size','GLfixed' ))
glPointSizex.version = ''
glPointSizex.category = 'GL_REGAL_ES1_0_compatibility'
glPointSizex.esVersions = [1.0, 1.1]
glPointSizex.regalRemap = 'glPointSize(fixedToFloat(size))'
glPointSizex.trace = True
glPointSizex.play = True
gl.add(glPointSizex)

glPolygonOffsetx = Function('glPolygonOffsetx')
glPolygonOffsetx.ret = Return('void')
glPolygonOffsetx.add( Input( 'factor','GLfixed' ))
glPolygonOffsetx.add( Input( 'units','GLfixed' ))
glPolygonOffsetx.version = ''
glPolygonOffsetx.category = 'GL_REGAL_ES1_0_compatibility'
glPolygonOffsetx.esVersions = [1.0, 1.1]
glPolygonOffsetx.regalRemap = 'glPolygonOffset(fixedToFloat(factor),fixedToFloat(units))'
glPolygonOffsetx.trace = True
glPolygonOffsetx.play = True
gl.add(glPolygonOffsetx)

glRotatex = Function('glRotatex')
glRotatex.ret = Return('void')
glRotatex.add( Input( 'angle','GLfixed' ))
glRotatex.add( Input( 'x','GLfixed' ))
glRotatex.add( Input( 'y','GLfixed' ))
glRotatex.add( Input( 'z','GLfixed' ))
glRotatex.version = ''
glRotatex.category = 'GL_REGAL_ES1_0_compatibility'
glRotatex.esVersions = [1.0, 1.1]
glRotatex.regalRemap = 'glRotatef(fixedToFloat(angle),fixedToFloat(x),fixedToFloat(y),fixedToFloat(z))'
glRotatex.trace = True
glRotatex.play = True
gl.add(glRotatex)

glSampleCoveragex = Function('glSampleCoveragex')
glSampleCoveragex.ret = Return('void')
glSampleCoveragex.add( Input( 'value','GLclampx' ))
glSampleCoveragex.add( Input( 'invert','GLboolean' ))
glSampleCoveragex.version = ''
glSampleCoveragex.category = 'GL_REGAL_ES1_0_compatibility'
glSampleCoveragex.esVersions = [1.0, 1.1]
glSampleCoveragex.regalRemap = 'glSampleCoverage(fixedToFloat(value),invert)'
glSampleCoveragex.trace = True
glSampleCoveragex.play = True
gl.add(glSampleCoveragex)

glScalex = Function('glScalex')
glScalex.ret = Return('void')
glScalex.add( Input( 'x','GLfixed' ))
glScalex.add( Input( 'y','GLfixed' ))
glScalex.add( Input( 'z','GLfixed' ))
glScalex.version = ''
glScalex.category = 'GL_REGAL_ES1_0_compatibility'
glScalex.esVersions = [1.0, 1.1]
glScalex.regalRemap = 'glScalef(fixedToFloat(x),fixedToFloat(y),fixedToFloat(z))'
glScalex.trace = True
glScalex.play = True
gl.add(glScalex)

glTexEnvx = Function('glTexEnvx')
glTexEnvx.ret = Return('void')
glTexEnvx.add( Input( 'target','GLenum' ))
glTexEnvx.add( Input( 'pname','GLenum' ))
glTexEnvx.add( Input( 'param','GLfixed' ))
glTexEnvx.version = ''
glTexEnvx.category = 'GL_REGAL_ES1_0_compatibility'
glTexEnvx.esVersions = [1.0, 1.1]
glTexEnvx.regalRemap = 'glTexEnvf(target,pname,fixedToFloat(param))'
glTexEnvx.trace = True
glTexEnvx.play = True
gl.add(glTexEnvx)

glTexEnvxv = Function('glTexEnvxv')
glTexEnvxv.ret = Return('void')
glTexEnvxv.add( Input( 'target','GLenum' ))
glTexEnvxv.add( Input( 'pname','GLenum' ))
glTexEnvxv.add( Input( 'params','const GLfixed *' ))
glTexEnvxv.version = ''
glTexEnvxv.category = 'GL_REGAL_ES1_0_compatibility'
glTexEnvxv.esVersions = [1.0, 1.1]
glTexEnvxv.regalRemap = ['GLfloat tmp[16];', 'fixedToFloat(tmp,params,pname==GL_TEXTURE_ENV_COLOR ? 4 : 1);', 'glTexEnvfv(target,pname,tmp);']
glTexEnvxv.trace = True
glTexEnvxv.play = True
gl.add(glTexEnvxv)

glTexParameterx = Function('glTexParameterx')
glTexParameterx.ret = Return('void')
glTexParameterx.add( Input( 'target','GLenum' ))
glTexParameterx.add( Input( 'pname','GLenum' ))
glTexParameterx.add( Input( 'param','GLfixed' ))
glTexParameterx.version = ''
glTexParameterx.category = 'GL_REGAL_ES1_0_compatibility'
glTexParameterx.esVersions = [1.0, 1.1]
glTexParameterx.regalRemap = 'glTexParameterf(target,pname,fixedToFloat(param))'
glTexParameterx.trace = True
glTexParameterx.play = True
gl.add(glTexParameterx)

glTranslatex = Function('glTranslatex')
glTranslatex.ret = Return('void')
glTranslatex.add( Input( 'x','GLfixed' ))
glTranslatex.add( Input( 'y','GLfixed' ))
glTranslatex.add( Input( 'z','GLfixed' ))
glTranslatex.version = ''
glTranslatex.category = 'GL_REGAL_ES1_0_compatibility'
glTranslatex.esVersions = [1.0, 1.1]
glTranslatex.regalRemap = 'glTranslatef(fixedToFloat(x),fixedToFloat(y),fixedToFloat(z))'
glTranslatex.trace = True
glTranslatex.play = True
gl.add(glTranslatex)

# GL_REGAL_ES1_1_compatibility

glClipPlanef = Function('glClipPlanef')
glClipPlanef.ret = Return('void')
glClipPlanef.add( Input( 'plane','GLenum' ))
glClipPlanef.add( Input( 'equation','const GLfloat *' ))
glClipPlanef.version = ''
glClipPlanef.category = 'GL_REGAL_ES1_1_compatibility'
glClipPlanef.esVersions = [1.1]
glClipPlanef.regalRemap = ['GLdouble tmp[4];', 'floatToDouble(tmp,equation,4);', 'glClipPlane(plane,tmp);']
glClipPlanef.trace = True
glClipPlanef.play = True
gl.add(glClipPlanef)

glClipPlanex = Function('glClipPlanex')
glClipPlanex.ret = Return('void')
glClipPlanex.add( Input( 'plane','GLenum' ))
glClipPlanex.add( Input( 'equation','const GLfixed *' ))
glClipPlanex.version = ''
glClipPlanex.category = 'GL_REGAL_ES1_1_compatibility'
glClipPlanex.esVersions = [1.1]
glClipPlanex.regalRemap = ['GLdouble tmp[4];', 'fixedToDouble(tmp,equation,4);', 'glClipPlane(plane,tmp);']
glClipPlanex.trace = True
glClipPlanex.play = True
gl.add(glClipPlanex)

glGetClipPlanef = Function('glGetClipPlanef')
glGetClipPlanef.ret = Return('void')
glGetClipPlanef.add( Input( 'pname','GLenum' ))
glGetClipPlanef.add( Input( 'eqn','GLfloat *' ))
glGetClipPlanef.version = ''
glGetClipPlanef.category = 'GL_REGAL_ES1_1_compatibility'
glGetClipPlanef.esVersions = [1.1]
glGetClipPlanef.regalRemap = ['GLdouble tmp[4];', 'glGetClipPlane(pname,tmp);', 'doubleToFloat(eqn,tmp,4);']
glGetClipPlanef.trace = True
glGetClipPlanef.play = True
gl.add(glGetClipPlanef)

glGetClipPlanex = Function('glGetClipPlanex')
glGetClipPlanex.ret = Return('void')
glGetClipPlanex.add( Input( 'pname','GLenum' ))
glGetClipPlanex.add( Input( 'eqn','GLfixed *' ))
glGetClipPlanex.version = ''
glGetClipPlanex.category = 'GL_REGAL_ES1_1_compatibility'
glGetClipPlanex.esVersions = [1.1]
glGetClipPlanex.regalRemap = ['GLdouble tmp[4];', 'glGetClipPlane(pname,tmp);', 'doubleToFixed(eqn,tmp,4);']
glGetClipPlanex.trace = True
glGetClipPlanex.play = True
gl.add(glGetClipPlanex)

glGetFixedv = Function('glGetFixedv')
glGetFixedv.ret = Return('void')
glGetFixedv.add( Input( 'pname','GLenum' ))
glGetFixedv.add( Input( 'params','GLfixed *' ))
glGetFixedv.version = ''
glGetFixedv.category = 'GL_REGAL_ES1_1_compatibility'
glGetFixedv.esVersions = [1.1]
glGetFixedv.regalRemap = ['GLfloat tmp[4];', 'glGetFloatv(pname,tmp);', 'floatToFixed(params,tmp,helper::size::get(pname));']
glGetFixedv.trace = True
glGetFixedv.play = True
gl.add(glGetFixedv)

glGetLightxv = Function('glGetLightxv')
glGetLightxv.ret = Return('void')
glGetLightxv.add( Input( 'light','GLenum' ))
glGetLightxv.add( Input( 'pname','GLenum' ))
glGetLightxv.add( Input( 'params','GLfixed *' ))
glGetLightxv.version = ''
glGetLightxv.category = 'GL_REGAL_ES1_1_compatibility'
glGetLightxv.esVersions = [1.1]
glGetLightxv.regalRemap = ['GLfloat tmp[4];', 'glGetLightfv(light,pname,tmp);', 'floatToFixed(params,tmp,helper::size::lightv(pname));']
glGetLightxv.trace = True
glGetLightxv.play = True
gl.add(glGetLightxv)

glGetMaterialxv = Function('glGetMaterialxv')
glGetMaterialxv.ret = Return('void')
glGetMaterialxv.add( Input( 'face','GLenum' ))
glGetMaterialxv.add( Input( 'pname','GLenum' ))
glGetMaterialxv.add( Input( 'params','GLfixed *' ))
glGetMaterialxv.version = ''
glGetMaterialxv.category = 'GL_REGAL_ES1_1_compatibility'
glGetMaterialxv.esVersions = [1.1]
glGetMaterialxv.regalRemap = ['GLfloat tmp[4];', 'glGetMaterialfv(face,pname,tmp);', 'floatToFixed(params,tmp,helper::size::materialv(pname));']
glGetMaterialxv.trace = True
glGetMaterialxv.play = True
gl.add(glGetMaterialxv)

glGetTexEnvxv = Function('glGetTexEnvxv')
glGetTexEnvxv.ret = Return('void')
glGetTexEnvxv.add( Input( 'env','GLenum' ))
glGetTexEnvxv.add( Input( 'pname','GLenum' ))
glGetTexEnvxv.add( Input( 'params','GLfixed *' ))
glGetTexEnvxv.version = ''
glGetTexEnvxv.category = 'GL_REGAL_ES1_1_compatibility'
glGetTexEnvxv.esVersions = [1.1]
glGetTexEnvxv.regalRemap = ['GLfloat tmp[4];', 'glGetTexEnvfv(env,pname,tmp);', 'floatToFixed(params,tmp,helper::size::texEnvv(env,pname));']
glGetTexEnvxv.trace = True
glGetTexEnvxv.play = True
gl.add(glGetTexEnvxv)

glGetTexParameterxv = Function('glGetTexParameterxv')
glGetTexParameterxv.ret = Return('void')
glGetTexParameterxv.add( Input( 'target','GLenum' ))
glGetTexParameterxv.add( Input( 'pname','GLenum' ))
glGetTexParameterxv.add( Input( 'params','GLfixed *' ))
glGetTexParameterxv.version = ''
glGetTexParameterxv.category = 'GL_REGAL_ES1_1_compatibility'
glGetTexParameterxv.esVersions = [1.1]
glGetTexParameterxv.regalRemap = ['GLfloat tmp[4];', 'glGetTexParameterfv(target,pname,tmp);', 'floatToFixed(params,tmp,helper::size::texParameterv(pname));']
glGetTexParameterxv.trace = True
glGetTexParameterxv.play = True
gl.add(glGetTexParameterxv)

glPointParameterx = Function('glPointParameterx')
glPointParameterx.ret = Return('void')
glPointParameterx.add( Input( 'pname','GLenum' ))
glPointParameterx.add( Input( 'param','GLfixed' ))
glPointParameterx.version = ''
glPointParameterx.category = 'GL_REGAL_ES1_1_compatibility'
glPointParameterx.esVersions = [1.1]
glPointParameterx.regalRemap = ['glPointParameterf(pname,fixedToFloat(param));']
glPointParameterx.trace = True
glPointParameterx.play = True
gl.add(glPointParameterx)

glPointParameterxv = Function('glPointParameterxv')
glPointParameterxv.ret = Return('void')
glPointParameterxv.add( Input( 'pname','GLenum' ))
glPointParameterxv.add( Input( 'params','const GLfixed *' ))
glPointParameterxv.version = ''
glPointParameterxv.category = 'GL_REGAL_ES1_1_compatibility'
glPointParameterxv.esVersions = [1.1]
glPointParameterxv.regalRemap = ['GLfloat tmp[4];', 'fixedToFloat(tmp,params,pname==GL_POINT_DISTANCE_ATTENUATION ? 3 : 1);', 'glPointParameterfv(pname,tmp);']
glPointParameterxv.trace = True
glPointParameterxv.play = True
gl.add(glPointParameterxv)

glPointSizePointerOES = Function('glPointSizePointerOES')
glPointSizePointerOES.ret = Return('void')
glPointSizePointerOES.add( Input( 'type','GLenum' ))
glPointSizePointerOES.add( Input( 'stride','GLsizei' ))
glPointSizePointerOES.add( Input( 'pointer','const GLvoid *' ))
glPointSizePointerOES.version = ''
glPointSizePointerOES.category = 'GL_REGAL_ES1_1_compatibility'
glPointSizePointerOES.esVersions = [1.1]
glPointSizePointerOES.trace = True
glPointSizePointerOES.play = True
gl.add(glPointSizePointerOES)

glTexParameterxv = Function('glTexParameterxv')
glTexParameterxv.ret = Return('void')
glTexParameterxv.add( Input( 'target','GLenum' ))
glTexParameterxv.add( Input( 'pname','GLenum' ))
glTexParameterxv.add( Input( 'params','const GLfixed *' ))
glTexParameterxv.version = ''
glTexParameterxv.category = 'GL_REGAL_ES1_1_compatibility'
glTexParameterxv.esVersions = [1.1]
glTexParameterxv.regalRemap = ['GLfloat tmp[4];', 'fixedToFloat(tmp,params,helper::size::texParameterv(pname));', 'glTexParameterfv(target,pname,tmp);']
glTexParameterxv.trace = True
glTexParameterxv.play = True
gl.add(glTexParameterxv)

# GL_REGAL_error_string

glErrorStringREGAL = Function('glErrorStringREGAL')
glErrorStringREGAL.ret = Return('const GLchar *')
glErrorStringREGAL.add( Input( 'error','GLenum' ))
glErrorStringREGAL.version = '4.1'
glErrorStringREGAL.category = 'GL_REGAL_error_string'
glErrorStringREGAL.regalOnly = True
glErrorStringREGAL.trace = True
glErrorStringREGAL.play = True
gl.add(glErrorStringREGAL)

# GL_REGAL_extension_query

glGetExtensionREGAL = Function('glGetExtensionREGAL')
glGetExtensionREGAL.ret = Return('GLboolean')
glGetExtensionREGAL.add( Input( 'ext','const GLchar *' ))
glGetExtensionREGAL.version = '4.1'
glGetExtensionREGAL.category = 'GL_REGAL_extension_query'
glGetExtensionREGAL.regalOnly = True
glGetExtensionREGAL.trace = True
glGetExtensionREGAL.play = True
gl.add(glGetExtensionREGAL)

glIsSupportedREGAL = Function('glIsSupportedREGAL')
glIsSupportedREGAL.ret = Return('GLboolean')
glIsSupportedREGAL.add( Input( 'ext','const GLchar *' ))
glIsSupportedREGAL.version = '4.1'
glIsSupportedREGAL.category = 'GL_REGAL_extension_query'
glIsSupportedREGAL.regalOnly = True
glIsSupportedREGAL.trace = True
glIsSupportedREGAL.play = True
gl.add(glIsSupportedREGAL)

# GL_REGAL_log

glLogMessageCallbackREGAL = Function('glLogMessageCallbackREGAL')
glLogMessageCallbackREGAL.ret = Return('void')
glLogMessageCallbackREGAL.add( Input( 'callback','GLLOGPROCREGAL' ))
glLogMessageCallbackREGAL.version = '4.3'
glLogMessageCallbackREGAL.category = 'GL_REGAL_log'
glLogMessageCallbackREGAL.trace = True
glLogMessageCallbackREGAL.play = True
gl.add(glLogMessageCallbackREGAL)

# GL_REGAL_proc_address

glGetProcAddressREGAL = Function('glGetProcAddressREGAL')
glGetProcAddressREGAL.ret = Return('void *')
glGetProcAddressREGAL.add( Input( 'name','const GLchar *' ))
glGetProcAddressREGAL.version = '4.1'
glGetProcAddressREGAL.category = 'GL_REGAL_proc_address'
glGetProcAddressREGAL.regalOnly = True
glGetProcAddressREGAL.trace = True
glGetProcAddressREGAL.play = True
gl.add(glGetProcAddressREGAL)

# GL_SGIS_detail_texture

glDetailTexFuncSGIS = Function('glDetailTexFuncSGIS')
glDetailTexFuncSGIS.ret = Return('void')
glDetailTexFuncSGIS.add( Input( 'target','GLenum' ))
glDetailTexFuncSGIS.add( Input( 'n','GLsizei' ))
glDetailTexFuncSGIS.add( Input( 'points','const GLfloat *' ))
glDetailTexFuncSGIS.version = '1.0'
glDetailTexFuncSGIS.category = 'GL_SGIS_detail_texture'
glDetailTexFuncSGIS.trace = True
glDetailTexFuncSGIS.play = True
gl.add(glDetailTexFuncSGIS)

glGetDetailTexFuncSGIS = Function('glGetDetailTexFuncSGIS')
glGetDetailTexFuncSGIS.ret = Return('void')
glGetDetailTexFuncSGIS.add( Input( 'target','GLenum' ))
glGetDetailTexFuncSGIS.add( Output( 'points','GLfloat *' ))
glGetDetailTexFuncSGIS.version = '1.0'
glGetDetailTexFuncSGIS.category = 'GL_SGIS_detail_texture'
glGetDetailTexFuncSGIS.trace = True
glGetDetailTexFuncSGIS.play = True
gl.add(glGetDetailTexFuncSGIS)

# GL_SGIS_fog_function

glFogFuncSGIS = Function('glFogFuncSGIS')
glFogFuncSGIS.ret = Return('void')
glFogFuncSGIS.add( Input( 'n','GLsizei' ))
glFogFuncSGIS.add( Input( 'points','const GLfloat *' ))
glFogFuncSGIS.version = '1.1'
glFogFuncSGIS.category = 'GL_SGIS_fog_function'
glFogFuncSGIS.trace = True
glFogFuncSGIS.play = True
gl.add(glFogFuncSGIS)

glGetFogFuncSGIS = Function('glGetFogFuncSGIS')
glGetFogFuncSGIS.ret = Return('void')
glGetFogFuncSGIS.add( Output( 'points','GLfloat *' ))
glGetFogFuncSGIS.version = '1.1'
glGetFogFuncSGIS.category = 'GL_SGIS_fog_function'
glGetFogFuncSGIS.trace = True
glGetFogFuncSGIS.play = True
gl.add(glGetFogFuncSGIS)

# GL_SGIS_multisample

glSampleMaskSGIS = Function('glSampleMaskSGIS')
glSampleMaskSGIS.ret = Return('void')
glSampleMaskSGIS.add( Input( 'value','GLclampf' ))
glSampleMaskSGIS.add( Input( 'invert','GLboolean' ))
glSampleMaskSGIS.version = '1.1'
glSampleMaskSGIS.category = 'GL_SGIS_multisample'
glSampleMaskSGIS.trace = True
glSampleMaskSGIS.play = True
gl.add(glSampleMaskSGIS)

glSamplePatternSGIS = Function('glSamplePatternSGIS')
glSamplePatternSGIS.ret = Return('void')
glSamplePatternSGIS.add( Input( 'pattern','GLenum' ))
glSamplePatternSGIS.version = '1.0'
glSamplePatternSGIS.category = 'GL_SGIS_multisample'
glSamplePatternSGIS.trace = True
glSamplePatternSGIS.play = True
gl.add(glSamplePatternSGIS)

# GL_SGIS_pixel_texture

glGetPixelTexGenParameterfvSGIS = Function('glGetPixelTexGenParameterfvSGIS')
glGetPixelTexGenParameterfvSGIS.ret = Return('void')
glGetPixelTexGenParameterfvSGIS.add( Input( 'pname','GLenum' ))
glGetPixelTexGenParameterfvSGIS.add( Output( 'params','GLfloat *' ))
glGetPixelTexGenParameterfvSGIS.version = '1.0'
glGetPixelTexGenParameterfvSGIS.category = 'GL_SGIS_pixel_texture'
glGetPixelTexGenParameterfvSGIS.trace = True
glGetPixelTexGenParameterfvSGIS.play = True
gl.add(glGetPixelTexGenParameterfvSGIS)

glGetPixelTexGenParameterivSGIS = Function('glGetPixelTexGenParameterivSGIS')
glGetPixelTexGenParameterivSGIS.ret = Return('void')
glGetPixelTexGenParameterivSGIS.add( Input( 'pname','GLenum' ))
glGetPixelTexGenParameterivSGIS.add( Output( 'params','GLint *' ))
glGetPixelTexGenParameterivSGIS.version = '1.0'
glGetPixelTexGenParameterivSGIS.category = 'GL_SGIS_pixel_texture'
glGetPixelTexGenParameterivSGIS.trace = True
glGetPixelTexGenParameterivSGIS.play = True
gl.add(glGetPixelTexGenParameterivSGIS)

glPixelTexGenParameterfSGIS = Function('glPixelTexGenParameterfSGIS')
glPixelTexGenParameterfSGIS.ret = Return('void')
glPixelTexGenParameterfSGIS.add( Input( 'pname','GLenum' ))
glPixelTexGenParameterfSGIS.add( Input( 'param','GLfloat' ))
glPixelTexGenParameterfSGIS.version = '1.0'
glPixelTexGenParameterfSGIS.category = 'GL_SGIS_pixel_texture'
glPixelTexGenParameterfSGIS.trace = True
glPixelTexGenParameterfSGIS.play = True
gl.add(glPixelTexGenParameterfSGIS)

glPixelTexGenParameterfvSGIS = Function('glPixelTexGenParameterfvSGIS')
glPixelTexGenParameterfvSGIS.ret = Return('void')
glPixelTexGenParameterfvSGIS.add( Input( 'pname','GLenum' ))
glPixelTexGenParameterfvSGIS.add( Input( 'params','const GLfloat *' ))
glPixelTexGenParameterfvSGIS.version = '1.0'
glPixelTexGenParameterfvSGIS.category = 'GL_SGIS_pixel_texture'
glPixelTexGenParameterfvSGIS.trace = True
glPixelTexGenParameterfvSGIS.play = True
gl.add(glPixelTexGenParameterfvSGIS)

glPixelTexGenParameteriSGIS = Function('glPixelTexGenParameteriSGIS')
glPixelTexGenParameteriSGIS.ret = Return('void')
glPixelTexGenParameteriSGIS.add( Input( 'pname','GLenum' ))
glPixelTexGenParameteriSGIS.add( Input( 'param','GLint' ))
glPixelTexGenParameteriSGIS.version = '1.0'
glPixelTexGenParameteriSGIS.category = 'GL_SGIS_pixel_texture'
glPixelTexGenParameteriSGIS.trace = True
glPixelTexGenParameteriSGIS.play = True
gl.add(glPixelTexGenParameteriSGIS)

glPixelTexGenParameterivSGIS = Function('glPixelTexGenParameterivSGIS')
glPixelTexGenParameterivSGIS.ret = Return('void')
glPixelTexGenParameterivSGIS.add( Input( 'pname','GLenum' ))
glPixelTexGenParameterivSGIS.add( Input( 'params','const GLint *' ))
glPixelTexGenParameterivSGIS.version = '1.0'
glPixelTexGenParameterivSGIS.category = 'GL_SGIS_pixel_texture'
glPixelTexGenParameterivSGIS.trace = True
glPixelTexGenParameterivSGIS.play = True
gl.add(glPixelTexGenParameterivSGIS)

# GL_SGIS_point_parameters

glPointParameterfSGIS = Function('glPointParameterfSGIS')
glPointParameterfSGIS.ret = Return('void')
glPointParameterfSGIS.add( Input( 'pname','GLenum' ))
glPointParameterfSGIS.add( Input( 'param','GLfloat' ))
glPointParameterfSGIS.version = '1.1'
glPointParameterfSGIS.category = 'GL_SGIS_point_parameters'
glPointParameterfSGIS.trace = True
glPointParameterfSGIS.play = True
gl.add(glPointParameterfSGIS)

glPointParameterfvSGIS = Function('glPointParameterfvSGIS')
glPointParameterfvSGIS.ret = Return('void')
glPointParameterfvSGIS.add( Input( 'pname','GLenum' ))
glPointParameterfvSGIS.add( Input( 'params','const GLfloat *' ))
glPointParameterfvSGIS.version = '1.1'
glPointParameterfvSGIS.category = 'GL_SGIS_point_parameters'
glPointParameterfvSGIS.trace = True
glPointParameterfvSGIS.play = True
gl.add(glPointParameterfvSGIS)

# GL_SGIS_sharpen_texture

glGetSharpenTexFuncSGIS = Function('glGetSharpenTexFuncSGIS')
glGetSharpenTexFuncSGIS.ret = Return('void')
glGetSharpenTexFuncSGIS.add( Input( 'target','GLenum' ))
glGetSharpenTexFuncSGIS.add( Output( 'points','GLfloat *' ))
glGetSharpenTexFuncSGIS.version = '1.0'
glGetSharpenTexFuncSGIS.category = 'GL_SGIS_sharpen_texture'
glGetSharpenTexFuncSGIS.trace = True
glGetSharpenTexFuncSGIS.play = True
gl.add(glGetSharpenTexFuncSGIS)

glSharpenTexFuncSGIS = Function('glSharpenTexFuncSGIS')
glSharpenTexFuncSGIS.ret = Return('void')
glSharpenTexFuncSGIS.add( Input( 'target','GLenum' ))
glSharpenTexFuncSGIS.add( Input( 'n','GLsizei' ))
glSharpenTexFuncSGIS.add( Input( 'points','const GLfloat *' ))
glSharpenTexFuncSGIS.version = '1.0'
glSharpenTexFuncSGIS.category = 'GL_SGIS_sharpen_texture'
glSharpenTexFuncSGIS.trace = True
glSharpenTexFuncSGIS.play = True
gl.add(glSharpenTexFuncSGIS)

# GL_SGIS_texture4D

glTexImage4DSGIS = Function('glTexImage4DSGIS')
glTexImage4DSGIS.ret = Return('void')
glTexImage4DSGIS.add( Input( 'target','GLenum' ))
glTexImage4DSGIS.add( Input( 'level','GLint' ))
glTexImage4DSGIS.add( Input( 'internalformat','GLenum' ,regalLog = 'internalFormatToString(internalformat)' ))
glTexImage4DSGIS.add( Input( 'width','GLsizei' ))
glTexImage4DSGIS.add( Input( 'height','GLsizei' ))
glTexImage4DSGIS.add( Input( 'depth','GLsizei' ))
glTexImage4DSGIS.add( Input( 'size4d','GLsizei' ))
glTexImage4DSGIS.add( Input( 'border','GLint' ))
glTexImage4DSGIS.add( Input( 'format','GLenum' ))
glTexImage4DSGIS.add( Input( 'type','GLenum' ))
glTexImage4DSGIS.add( Input( 'pixels','const GLvoid *' ))
glTexImage4DSGIS.version = '1.0'
glTexImage4DSGIS.category = 'GL_SGIS_texture4D'
glTexImage4DSGIS.trace = True
glTexImage4DSGIS.play = True
gl.add(glTexImage4DSGIS)

glTexSubImage4DSGIS = Function('glTexSubImage4DSGIS')
glTexSubImage4DSGIS.ret = Return('void')
glTexSubImage4DSGIS.add( Input( 'target','GLenum' ))
glTexSubImage4DSGIS.add( Input( 'level','GLint' ))
glTexSubImage4DSGIS.add( Input( 'xoffset','GLint' ))
glTexSubImage4DSGIS.add( Input( 'yoffset','GLint' ))
glTexSubImage4DSGIS.add( Input( 'zoffset','GLint' ))
glTexSubImage4DSGIS.add( Input( 'woffset','GLint' ))
glTexSubImage4DSGIS.add( Input( 'width','GLsizei' ))
glTexSubImage4DSGIS.add( Input( 'height','GLsizei' ))
glTexSubImage4DSGIS.add( Input( 'depth','GLsizei' ))
glTexSubImage4DSGIS.add( Input( 'size4d','GLsizei' ))
glTexSubImage4DSGIS.add( Input( 'format','GLenum' ))
glTexSubImage4DSGIS.add( Input( 'type','GLenum' ))
glTexSubImage4DSGIS.add( Input( 'pixels','const GLvoid *' ))
glTexSubImage4DSGIS.version = '1.0'
glTexSubImage4DSGIS.category = 'GL_SGIS_texture4D'
glTexSubImage4DSGIS.trace = True
glTexSubImage4DSGIS.play = True
gl.add(glTexSubImage4DSGIS)

# GL_SGIS_texture_color_mask

glTextureColorMaskSGIS = Function('glTextureColorMaskSGIS')
glTextureColorMaskSGIS.ret = Return('void')
glTextureColorMaskSGIS.add( Input( 'red','GLboolean' ))
glTextureColorMaskSGIS.add( Input( 'green','GLboolean' ))
glTextureColorMaskSGIS.add( Input( 'blue','GLboolean' ))
glTextureColorMaskSGIS.add( Input( 'alpha','GLboolean' ))
glTextureColorMaskSGIS.version = '1.1'
glTextureColorMaskSGIS.category = 'GL_SGIS_texture_color_mask'
glTextureColorMaskSGIS.trace = True
glTextureColorMaskSGIS.play = True
gl.add(glTextureColorMaskSGIS)

# GL_SGIS_texture_filter4

glGetTexFilterFuncSGIS = Function('glGetTexFilterFuncSGIS')
glGetTexFilterFuncSGIS.ret = Return('void')
glGetTexFilterFuncSGIS.add( Input( 'target','GLenum' ))
glGetTexFilterFuncSGIS.add( Input( 'filter','GLenum' ))
glGetTexFilterFuncSGIS.add( Output( 'weights','GLfloat *' ))
glGetTexFilterFuncSGIS.version = '1.0'
glGetTexFilterFuncSGIS.category = 'GL_SGIS_texture_filter4'
glGetTexFilterFuncSGIS.trace = True
glGetTexFilterFuncSGIS.play = True
gl.add(glGetTexFilterFuncSGIS)

glTexFilterFuncSGIS = Function('glTexFilterFuncSGIS')
glTexFilterFuncSGIS.ret = Return('void')
glTexFilterFuncSGIS.add( Input( 'target','GLenum' ))
glTexFilterFuncSGIS.add( Input( 'filter','GLenum' ))
glTexFilterFuncSGIS.add( Input( 'n','GLsizei' ))
glTexFilterFuncSGIS.add( Input( 'weights','const GLfloat *' ))
glTexFilterFuncSGIS.version = '1.0'
glTexFilterFuncSGIS.category = 'GL_SGIS_texture_filter4'
glTexFilterFuncSGIS.trace = True
glTexFilterFuncSGIS.play = True
gl.add(glTexFilterFuncSGIS)

# GL_SGIX_async

glAsyncMarkerSGIX = Function('glAsyncMarkerSGIX')
glAsyncMarkerSGIX.ret = Return('void')
glAsyncMarkerSGIX.add( Input( 'marker','GLuint' ))
glAsyncMarkerSGIX.version = '1.0'
glAsyncMarkerSGIX.category = 'GL_SGIX_async'
glAsyncMarkerSGIX.trace = True
glAsyncMarkerSGIX.play = True
gl.add(glAsyncMarkerSGIX)

glDeleteAsyncMarkersSGIX = Function('glDeleteAsyncMarkersSGIX')
glDeleteAsyncMarkersSGIX.ret = Return('void')
glDeleteAsyncMarkersSGIX.add( Input( 'marker','GLuint' ))
glDeleteAsyncMarkersSGIX.add( Input( 'range','GLsizei' ))
glDeleteAsyncMarkersSGIX.version = '1.0'
glDeleteAsyncMarkersSGIX.category = 'GL_SGIX_async'
glDeleteAsyncMarkersSGIX.trace = True
glDeleteAsyncMarkersSGIX.play = True
gl.add(glDeleteAsyncMarkersSGIX)

glFinishAsyncSGIX = Function('glFinishAsyncSGIX')
glFinishAsyncSGIX.ret = Return('GLint')
glFinishAsyncSGIX.add( Output( 'markerp','GLuint *' ,size = 1 ))
glFinishAsyncSGIX.version = '1.0'
glFinishAsyncSGIX.category = 'GL_SGIX_async'
glFinishAsyncSGIX.trace = True
glFinishAsyncSGIX.play = True
gl.add(glFinishAsyncSGIX)

glGenAsyncMarkersSGIX = Function('glGenAsyncMarkersSGIX')
glGenAsyncMarkersSGIX.ret = Return('GLuint')
glGenAsyncMarkersSGIX.add( Input( 'range','GLsizei' ))
glGenAsyncMarkersSGIX.version = '1.0'
glGenAsyncMarkersSGIX.category = 'GL_SGIX_async'
glGenAsyncMarkersSGIX.trace = True
glGenAsyncMarkersSGIX.play = True
gl.add(glGenAsyncMarkersSGIX)

glIsAsyncMarkerSGIX = Function('glIsAsyncMarkerSGIX')
glIsAsyncMarkerSGIX.ret = Return('GLboolean')
glIsAsyncMarkerSGIX.add( Input( 'marker','GLuint' ))
glIsAsyncMarkerSGIX.version = '1.0'
glIsAsyncMarkerSGIX.category = 'GL_SGIX_async'
glIsAsyncMarkerSGIX.trace = True
glIsAsyncMarkerSGIX.play = True
gl.add(glIsAsyncMarkerSGIX)

glPollAsyncSGIX = Function('glPollAsyncSGIX')
glPollAsyncSGIX.ret = Return('GLint')
glPollAsyncSGIX.add( Output( 'markerp','GLuint *' ,size = 1 ))
glPollAsyncSGIX.version = '1.0'
glPollAsyncSGIX.category = 'GL_SGIX_async'
glPollAsyncSGIX.trace = True
glPollAsyncSGIX.play = True
gl.add(glPollAsyncSGIX)

# GL_SGIX_flush_raster

glFlushRasterSGIX = Function('glFlushRasterSGIX')
glFlushRasterSGIX.ret = Return('void')
glFlushRasterSGIX.version = '1.0'
glFlushRasterSGIX.category = 'GL_SGIX_flush_raster'
glFlushRasterSGIX.trace = True
glFlushRasterSGIX.play = True
gl.add(glFlushRasterSGIX)

# GL_SGIX_fog_texture

glTextureFogSGIX = Function('glTextureFogSGIX')
glTextureFogSGIX.ret = Return('void')
glTextureFogSGIX.add( Input( 'pname','GLenum' ))
glTextureFogSGIX.version = ''
glTextureFogSGIX.category = 'GL_SGIX_fog_texture'
glTextureFogSGIX.trace = True
glTextureFogSGIX.play = True
gl.add(glTextureFogSGIX)

# GL_SGIX_fragment_lighting

glFragmentColorMaterialSGIX = Function('glFragmentColorMaterialSGIX')
glFragmentColorMaterialSGIX.ret = Return('void')
glFragmentColorMaterialSGIX.add( Input( 'face','GLenum' ))
glFragmentColorMaterialSGIX.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glFragmentColorMaterialSGIX.version = '1.0'
glFragmentColorMaterialSGIX.category = 'GL_SGIX_fragment_lighting'
glFragmentColorMaterialSGIX.trace = True
glFragmentColorMaterialSGIX.play = True
gl.add(glFragmentColorMaterialSGIX)

glFragmentLightModelfSGIX = Function('glFragmentLightModelfSGIX')
glFragmentLightModelfSGIX.ret = Return('void')
glFragmentLightModelfSGIX.add( Input( 'pname','GLenum' ))
glFragmentLightModelfSGIX.add( Input( 'param','GLfloat' ))
glFragmentLightModelfSGIX.version = '1.0'
glFragmentLightModelfSGIX.category = 'GL_SGIX_fragment_lighting'
glFragmentLightModelfSGIX.trace = True
glFragmentLightModelfSGIX.play = True
gl.add(glFragmentLightModelfSGIX)

glFragmentLightModelfvSGIX = Function('glFragmentLightModelfvSGIX')
glFragmentLightModelfvSGIX.ret = Return('void')
glFragmentLightModelfvSGIX.add( Input( 'pname','GLenum' ))
glFragmentLightModelfvSGIX.add( Input( 'params','const GLfloat *' ))
glFragmentLightModelfvSGIX.version = '1.0'
glFragmentLightModelfvSGIX.category = 'GL_SGIX_fragment_lighting'
glFragmentLightModelfvSGIX.trace = True
glFragmentLightModelfvSGIX.play = True
gl.add(glFragmentLightModelfvSGIX)

glFragmentLightModeliSGIX = Function('glFragmentLightModeliSGIX')
glFragmentLightModeliSGIX.ret = Return('void')
glFragmentLightModeliSGIX.add( Input( 'pname','GLenum' ))
glFragmentLightModeliSGIX.add( Input( 'param','GLint' ))
glFragmentLightModeliSGIX.version = '1.0'
glFragmentLightModeliSGIX.category = 'GL_SGIX_fragment_lighting'
glFragmentLightModeliSGIX.trace = True
glFragmentLightModeliSGIX.play = True
gl.add(glFragmentLightModeliSGIX)

glFragmentLightModelivSGIX = Function('glFragmentLightModelivSGIX')
glFragmentLightModelivSGIX.ret = Return('void')
glFragmentLightModelivSGIX.add( Input( 'pname','GLenum' ))
glFragmentLightModelivSGIX.add( Input( 'params','const GLint *' ))
glFragmentLightModelivSGIX.version = '1.0'
glFragmentLightModelivSGIX.category = 'GL_SGIX_fragment_lighting'
glFragmentLightModelivSGIX.trace = True
glFragmentLightModelivSGIX.play = True
gl.add(glFragmentLightModelivSGIX)

glFragmentLightfSGIX = Function('glFragmentLightfSGIX')
glFragmentLightfSGIX.ret = Return('void')
glFragmentLightfSGIX.add( Input( 'light','GLenum' ))
glFragmentLightfSGIX.add( Input( 'pname','GLenum' ))
glFragmentLightfSGIX.add( Input( 'param','GLfloat' ))
glFragmentLightfSGIX.version = '1.0'
glFragmentLightfSGIX.category = 'GL_SGIX_fragment_lighting'
glFragmentLightfSGIX.trace = True
glFragmentLightfSGIX.play = True
gl.add(glFragmentLightfSGIX)

glFragmentLightfvSGIX = Function('glFragmentLightfvSGIX')
glFragmentLightfvSGIX.ret = Return('void')
glFragmentLightfvSGIX.add( Input( 'light','GLenum' ))
glFragmentLightfvSGIX.add( Input( 'pname','GLenum' ))
glFragmentLightfvSGIX.add( Input( 'params','const GLfloat *' ))
glFragmentLightfvSGIX.version = '1.0'
glFragmentLightfvSGIX.category = 'GL_SGIX_fragment_lighting'
glFragmentLightfvSGIX.trace = True
glFragmentLightfvSGIX.play = True
gl.add(glFragmentLightfvSGIX)

glFragmentLightiSGIX = Function('glFragmentLightiSGIX')
glFragmentLightiSGIX.ret = Return('void')
glFragmentLightiSGIX.add( Input( 'light','GLenum' ))
glFragmentLightiSGIX.add( Input( 'pname','GLenum' ))
glFragmentLightiSGIX.add( Input( 'param','GLint' ))
glFragmentLightiSGIX.version = '1.0'
glFragmentLightiSGIX.category = 'GL_SGIX_fragment_lighting'
glFragmentLightiSGIX.trace = True
glFragmentLightiSGIX.play = True
gl.add(glFragmentLightiSGIX)

glFragmentLightivSGIX = Function('glFragmentLightivSGIX')
glFragmentLightivSGIX.ret = Return('void')
glFragmentLightivSGIX.add( Input( 'light','GLenum' ))
glFragmentLightivSGIX.add( Input( 'pname','GLenum' ))
glFragmentLightivSGIX.add( Input( 'params','const GLint *' ))
glFragmentLightivSGIX.version = '1.0'
glFragmentLightivSGIX.category = 'GL_SGIX_fragment_lighting'
glFragmentLightivSGIX.trace = True
glFragmentLightivSGIX.play = True
gl.add(glFragmentLightivSGIX)

glFragmentMaterialfSGIX = Function('glFragmentMaterialfSGIX')
glFragmentMaterialfSGIX.ret = Return('void')
glFragmentMaterialfSGIX.add( Input( 'face','GLenum' ))
glFragmentMaterialfSGIX.add( Input( 'pname','GLenum' ))
glFragmentMaterialfSGIX.add( Input( 'param','GLfloat' ))
glFragmentMaterialfSGIX.version = '1.0'
glFragmentMaterialfSGIX.category = 'GL_SGIX_fragment_lighting'
glFragmentMaterialfSGIX.trace = True
glFragmentMaterialfSGIX.play = True
gl.add(glFragmentMaterialfSGIX)

glFragmentMaterialfvSGIX = Function('glFragmentMaterialfvSGIX')
glFragmentMaterialfvSGIX.ret = Return('void')
glFragmentMaterialfvSGIX.add( Input( 'face','GLenum' ))
glFragmentMaterialfvSGIX.add( Input( 'pname','GLenum' ))
glFragmentMaterialfvSGIX.add( Input( 'params','const GLfloat *' ))
glFragmentMaterialfvSGIX.version = '1.0'
glFragmentMaterialfvSGIX.category = 'GL_SGIX_fragment_lighting'
glFragmentMaterialfvSGIX.trace = True
glFragmentMaterialfvSGIX.play = True
gl.add(glFragmentMaterialfvSGIX)

glFragmentMaterialiSGIX = Function('glFragmentMaterialiSGIX')
glFragmentMaterialiSGIX.ret = Return('void')
glFragmentMaterialiSGIX.add( Input( 'face','GLenum' ))
glFragmentMaterialiSGIX.add( Input( 'pname','GLenum' ))
glFragmentMaterialiSGIX.add( Input( 'param','GLint' ))
glFragmentMaterialiSGIX.version = '1.0'
glFragmentMaterialiSGIX.category = 'GL_SGIX_fragment_lighting'
glFragmentMaterialiSGIX.trace = True
glFragmentMaterialiSGIX.play = True
gl.add(glFragmentMaterialiSGIX)

glFragmentMaterialivSGIX = Function('glFragmentMaterialivSGIX')
glFragmentMaterialivSGIX.ret = Return('void')
glFragmentMaterialivSGIX.add( Input( 'face','GLenum' ))
glFragmentMaterialivSGIX.add( Input( 'pname','GLenum' ))
glFragmentMaterialivSGIX.add( Input( 'params','const GLint *' ))
glFragmentMaterialivSGIX.version = '1.0'
glFragmentMaterialivSGIX.category = 'GL_SGIX_fragment_lighting'
glFragmentMaterialivSGIX.trace = True
glFragmentMaterialivSGIX.play = True
gl.add(glFragmentMaterialivSGIX)

glGetFragmentLightfvSGIX = Function('glGetFragmentLightfvSGIX')
glGetFragmentLightfvSGIX.ret = Return('void')
glGetFragmentLightfvSGIX.add( Input( 'light','GLenum' ))
glGetFragmentLightfvSGIX.add( Input( 'pname','GLenum' ))
glGetFragmentLightfvSGIX.add( Output( 'params','GLfloat *' ))
glGetFragmentLightfvSGIX.version = '1.0'
glGetFragmentLightfvSGIX.category = 'GL_SGIX_fragment_lighting'
glGetFragmentLightfvSGIX.trace = True
glGetFragmentLightfvSGIX.play = True
gl.add(glGetFragmentLightfvSGIX)

glGetFragmentLightivSGIX = Function('glGetFragmentLightivSGIX')
glGetFragmentLightivSGIX.ret = Return('void')
glGetFragmentLightivSGIX.add( Input( 'light','GLenum' ))
glGetFragmentLightivSGIX.add( Input( 'pname','GLenum' ))
glGetFragmentLightivSGIX.add( Output( 'params','GLint *' ))
glGetFragmentLightivSGIX.version = '1.0'
glGetFragmentLightivSGIX.category = 'GL_SGIX_fragment_lighting'
glGetFragmentLightivSGIX.trace = True
glGetFragmentLightivSGIX.play = True
gl.add(glGetFragmentLightivSGIX)

glGetFragmentMaterialfvSGIX = Function('glGetFragmentMaterialfvSGIX')
glGetFragmentMaterialfvSGIX.ret = Return('void')
glGetFragmentMaterialfvSGIX.add( Input( 'face','GLenum' ))
glGetFragmentMaterialfvSGIX.add( Input( 'pname','GLenum' ))
glGetFragmentMaterialfvSGIX.add( Output( 'params','GLfloat *' ))
glGetFragmentMaterialfvSGIX.version = '1.0'
glGetFragmentMaterialfvSGIX.category = 'GL_SGIX_fragment_lighting'
glGetFragmentMaterialfvSGIX.trace = True
glGetFragmentMaterialfvSGIX.play = True
gl.add(glGetFragmentMaterialfvSGIX)

glGetFragmentMaterialivSGIX = Function('glGetFragmentMaterialivSGIX')
glGetFragmentMaterialivSGIX.ret = Return('void')
glGetFragmentMaterialivSGIX.add( Input( 'face','GLenum' ))
glGetFragmentMaterialivSGIX.add( Input( 'pname','GLenum' ))
glGetFragmentMaterialivSGIX.add( Output( 'params','GLint *' ))
glGetFragmentMaterialivSGIX.version = '1.0'
glGetFragmentMaterialivSGIX.category = 'GL_SGIX_fragment_lighting'
glGetFragmentMaterialivSGIX.trace = True
glGetFragmentMaterialivSGIX.play = True
gl.add(glGetFragmentMaterialivSGIX)

glLightEnviSGIX = Function('glLightEnviSGIX')
glLightEnviSGIX.ret = Return('void')
glLightEnviSGIX.add( Input( 'pname','GLenum' ))
glLightEnviSGIX.add( Input( 'param','GLint' ))
glLightEnviSGIX.version = '1.0'
glLightEnviSGIX.category = 'GL_SGIX_fragment_lighting'
glLightEnviSGIX.trace = True
glLightEnviSGIX.play = True
gl.add(glLightEnviSGIX)

# GL_SGIX_framezoom

glFrameZoomSGIX = Function('glFrameZoomSGIX')
glFrameZoomSGIX.ret = Return('void')
glFrameZoomSGIX.add( Input( 'factor','GLint' ))
glFrameZoomSGIX.version = '1.0'
glFrameZoomSGIX.category = 'GL_SGIX_framezoom'
glFrameZoomSGIX.trace = True
glFrameZoomSGIX.play = True
gl.add(glFrameZoomSGIX)

# GL_SGIX_igloo_interface

glIglooInterfaceSGIX = Function('glIglooInterfaceSGIX')
glIglooInterfaceSGIX.ret = Return('void')
glIglooInterfaceSGIX.add( Input( 'pname','GLenum' ))
glIglooInterfaceSGIX.add( Input( 'params','const GLvoid *' ))
glIglooInterfaceSGIX.version = '1.0'
glIglooInterfaceSGIX.category = 'GL_SGIX_igloo_interface'
glIglooInterfaceSGIX.trace = True
glIglooInterfaceSGIX.play = True
gl.add(glIglooInterfaceSGIX)

# GL_SGIX_instruments

glGetInstrumentsSGIX = Function('glGetInstrumentsSGIX')
glGetInstrumentsSGIX.ret = Return('GLint')
glGetInstrumentsSGIX.version = '1.0'
glGetInstrumentsSGIX.category = 'GL_SGIX_instruments'
glGetInstrumentsSGIX.trace = True
glGetInstrumentsSGIX.play = True
gl.add(glGetInstrumentsSGIX)

glInstrumentsBufferSGIX = Function('glInstrumentsBufferSGIX')
glInstrumentsBufferSGIX.ret = Return('void')
glInstrumentsBufferSGIX.add( Input( 'size','GLsizei' ))
glInstrumentsBufferSGIX.add( Output( 'buffer','GLint *' ))
glInstrumentsBufferSGIX.version = '1.0'
glInstrumentsBufferSGIX.category = 'GL_SGIX_instruments'
glInstrumentsBufferSGIX.trace = True
glInstrumentsBufferSGIX.play = True
gl.add(glInstrumentsBufferSGIX)

glPollInstrumentsSGIX = Function('glPollInstrumentsSGIX')
glPollInstrumentsSGIX.ret = Return('GLint')
glPollInstrumentsSGIX.add( Output( 'marker_p','GLint *' ,size = 1 ))
glPollInstrumentsSGIX.version = '1.0'
glPollInstrumentsSGIX.category = 'GL_SGIX_instruments'
glPollInstrumentsSGIX.trace = True
glPollInstrumentsSGIX.play = True
gl.add(glPollInstrumentsSGIX)

glReadInstrumentsSGIX = Function('glReadInstrumentsSGIX')
glReadInstrumentsSGIX.ret = Return('void')
glReadInstrumentsSGIX.add( Input( 'marker','GLint' ))
glReadInstrumentsSGIX.version = '1.0'
glReadInstrumentsSGIX.category = 'GL_SGIX_instruments'
glReadInstrumentsSGIX.trace = True
glReadInstrumentsSGIX.play = True
gl.add(glReadInstrumentsSGIX)

glStartInstrumentsSGIX = Function('glStartInstrumentsSGIX')
glStartInstrumentsSGIX.ret = Return('void')
glStartInstrumentsSGIX.version = '1.0'
glStartInstrumentsSGIX.category = 'GL_SGIX_instruments'
glStartInstrumentsSGIX.trace = True
glStartInstrumentsSGIX.play = True
gl.add(glStartInstrumentsSGIX)

glStopInstrumentsSGIX = Function('glStopInstrumentsSGIX')
glStopInstrumentsSGIX.ret = Return('void')
glStopInstrumentsSGIX.add( Input( 'marker','GLint' ))
glStopInstrumentsSGIX.version = '1.0'
glStopInstrumentsSGIX.category = 'GL_SGIX_instruments'
glStopInstrumentsSGIX.trace = True
glStopInstrumentsSGIX.play = True
gl.add(glStopInstrumentsSGIX)

# GL_SGIX_list_priority

glGetListParameterfvSGIX = Function('glGetListParameterfvSGIX')
glGetListParameterfvSGIX.ret = Return('void')
glGetListParameterfvSGIX.add( Input( 'list','GLuint' ))
glGetListParameterfvSGIX.add( Input( 'pname','GLenum' ))
glGetListParameterfvSGIX.add( Output( 'params','GLfloat *' ))
glGetListParameterfvSGIX.version = '1.0'
glGetListParameterfvSGIX.category = 'GL_SGIX_list_priority'
glGetListParameterfvSGIX.trace = True
glGetListParameterfvSGIX.play = True
gl.add(glGetListParameterfvSGIX)

glGetListParameterivSGIX = Function('glGetListParameterivSGIX')
glGetListParameterivSGIX.ret = Return('void')
glGetListParameterivSGIX.add( Input( 'list','GLuint' ))
glGetListParameterivSGIX.add( Input( 'pname','GLenum' ))
glGetListParameterivSGIX.add( Output( 'params','GLint *' ))
glGetListParameterivSGIX.version = '1.0'
glGetListParameterivSGIX.category = 'GL_SGIX_list_priority'
glGetListParameterivSGIX.trace = True
glGetListParameterivSGIX.play = True
gl.add(glGetListParameterivSGIX)

glListParameterfSGIX = Function('glListParameterfSGIX')
glListParameterfSGIX.ret = Return('void')
glListParameterfSGIX.add( Input( 'list','GLuint' ))
glListParameterfSGIX.add( Input( 'pname','GLenum' ))
glListParameterfSGIX.add( Input( 'param','GLfloat' ))
glListParameterfSGIX.version = '1.0'
glListParameterfSGIX.category = 'GL_SGIX_list_priority'
glListParameterfSGIX.trace = True
glListParameterfSGIX.play = True
gl.add(glListParameterfSGIX)

glListParameterfvSGIX = Function('glListParameterfvSGIX')
glListParameterfvSGIX.ret = Return('void')
glListParameterfvSGIX.add( Input( 'list','GLuint' ))
glListParameterfvSGIX.add( Input( 'pname','GLenum' ))
glListParameterfvSGIX.add( Input( 'params','const GLfloat *' ))
glListParameterfvSGIX.version = '1.0'
glListParameterfvSGIX.category = 'GL_SGIX_list_priority'
glListParameterfvSGIX.trace = True
glListParameterfvSGIX.play = True
gl.add(glListParameterfvSGIX)

glListParameteriSGIX = Function('glListParameteriSGIX')
glListParameteriSGIX.ret = Return('void')
glListParameteriSGIX.add( Input( 'list','GLuint' ))
glListParameteriSGIX.add( Input( 'pname','GLenum' ))
glListParameteriSGIX.add( Input( 'param','GLint' ))
glListParameteriSGIX.version = '1.0'
glListParameteriSGIX.category = 'GL_SGIX_list_priority'
glListParameteriSGIX.trace = True
glListParameteriSGIX.play = True
gl.add(glListParameteriSGIX)

glListParameterivSGIX = Function('glListParameterivSGIX')
glListParameterivSGIX.ret = Return('void')
glListParameterivSGIX.add( Input( 'list','GLuint' ))
glListParameterivSGIX.add( Input( 'pname','GLenum' ))
glListParameterivSGIX.add( Input( 'params','const GLint *' ))
glListParameterivSGIX.version = '1.0'
glListParameterivSGIX.category = 'GL_SGIX_list_priority'
glListParameterivSGIX.trace = True
glListParameterivSGIX.play = True
gl.add(glListParameterivSGIX)

# GL_SGIX_pixel_texture

glPixelTexGenSGIX = Function('glPixelTexGenSGIX')
glPixelTexGenSGIX.ret = Return('void')
glPixelTexGenSGIX.add( Input( 'mode','GLenum' ))
glPixelTexGenSGIX.version = '1.0'
glPixelTexGenSGIX.category = 'GL_SGIX_pixel_texture'
glPixelTexGenSGIX.trace = True
glPixelTexGenSGIX.play = True
gl.add(glPixelTexGenSGIX)

# GL_SGIX_polynomial_ffd

glDeformSGIX = Function('glDeformSGIX')
glDeformSGIX.ret = Return('void')
glDeformSGIX.add( Input( 'mask','GLbitfield' ))
glDeformSGIX.version = '1.0'
glDeformSGIX.category = 'GL_SGIX_polynomial_ffd'
glDeformSGIX.trace = True
glDeformSGIX.play = True
gl.add(glDeformSGIX)

glDeformationMap3dSGIX = Function('glDeformationMap3dSGIX')
glDeformationMap3dSGIX.ret = Return('void')
glDeformationMap3dSGIX.add( Input( 'target','GLenum' ))
glDeformationMap3dSGIX.add( Input( 'u1','GLdouble' ))
glDeformationMap3dSGIX.add( Input( 'u2','GLdouble' ))
glDeformationMap3dSGIX.add( Input( 'ustride','GLint' ))
glDeformationMap3dSGIX.add( Input( 'uorder','GLint' ))
glDeformationMap3dSGIX.add( Input( 'v1','GLdouble' ))
glDeformationMap3dSGIX.add( Input( 'v2','GLdouble' ))
glDeformationMap3dSGIX.add( Input( 'vstride','GLint' ))
glDeformationMap3dSGIX.add( Input( 'vorder','GLint' ))
glDeformationMap3dSGIX.add( Input( 'w1','GLdouble' ))
glDeformationMap3dSGIX.add( Input( 'w2','GLdouble' ))
glDeformationMap3dSGIX.add( Input( 'wstride','GLint' ))
glDeformationMap3dSGIX.add( Input( 'worder','GLint' ))
glDeformationMap3dSGIX.add( Input( 'points','const GLdouble *' ))
glDeformationMap3dSGIX.version = '1.0'
glDeformationMap3dSGIX.category = 'GL_SGIX_polynomial_ffd'
glDeformationMap3dSGIX.trace = True
glDeformationMap3dSGIX.play = True
gl.add(glDeformationMap3dSGIX)

glDeformationMap3fSGIX = Function('glDeformationMap3fSGIX')
glDeformationMap3fSGIX.ret = Return('void')
glDeformationMap3fSGIX.add( Input( 'target','GLenum' ))
glDeformationMap3fSGIX.add( Input( 'u1','GLfloat' ))
glDeformationMap3fSGIX.add( Input( 'u2','GLfloat' ))
glDeformationMap3fSGIX.add( Input( 'ustride','GLint' ))
glDeformationMap3fSGIX.add( Input( 'uorder','GLint' ))
glDeformationMap3fSGIX.add( Input( 'v1','GLfloat' ))
glDeformationMap3fSGIX.add( Input( 'v2','GLfloat' ))
glDeformationMap3fSGIX.add( Input( 'vstride','GLint' ))
glDeformationMap3fSGIX.add( Input( 'vorder','GLint' ))
glDeformationMap3fSGIX.add( Input( 'w1','GLfloat' ))
glDeformationMap3fSGIX.add( Input( 'w2','GLfloat' ))
glDeformationMap3fSGIX.add( Input( 'wstride','GLint' ))
glDeformationMap3fSGIX.add( Input( 'worder','GLint' ))
glDeformationMap3fSGIX.add( Input( 'points','const GLfloat *' ))
glDeformationMap3fSGIX.version = '1.0'
glDeformationMap3fSGIX.category = 'GL_SGIX_polynomial_ffd'
glDeformationMap3fSGIX.trace = True
glDeformationMap3fSGIX.play = True
gl.add(glDeformationMap3fSGIX)

glLoadIdentityDeformationMapSGIX = Function('glLoadIdentityDeformationMapSGIX')
glLoadIdentityDeformationMapSGIX.ret = Return('void')
glLoadIdentityDeformationMapSGIX.add( Input( 'mask','GLbitfield' ))
glLoadIdentityDeformationMapSGIX.version = '1.0'
glLoadIdentityDeformationMapSGIX.category = 'GL_SGIX_polynomial_ffd'
glLoadIdentityDeformationMapSGIX.trace = True
glLoadIdentityDeformationMapSGIX.play = True
gl.add(glLoadIdentityDeformationMapSGIX)

# GL_SGIX_reference_plane

glReferencePlaneSGIX = Function('glReferencePlaneSGIX')
glReferencePlaneSGIX.ret = Return('void')
glReferencePlaneSGIX.add( Input( 'equation','const GLdouble *' ,size = 4 ))
glReferencePlaneSGIX.version = '1.0'
glReferencePlaneSGIX.category = 'GL_SGIX_reference_plane'
glReferencePlaneSGIX.trace = True
glReferencePlaneSGIX.play = True
gl.add(glReferencePlaneSGIX)

# GL_SGIX_sprite

glSpriteParameterfSGIX = Function('glSpriteParameterfSGIX')
glSpriteParameterfSGIX.ret = Return('void')
glSpriteParameterfSGIX.add( Input( 'pname','GLenum' ))
glSpriteParameterfSGIX.add( Input( 'param','GLfloat' ))
glSpriteParameterfSGIX.version = '1.0'
glSpriteParameterfSGIX.category = 'GL_SGIX_sprite'
glSpriteParameterfSGIX.trace = True
glSpriteParameterfSGIX.play = True
gl.add(glSpriteParameterfSGIX)

glSpriteParameterfvSGIX = Function('glSpriteParameterfvSGIX')
glSpriteParameterfvSGIX.ret = Return('void')
glSpriteParameterfvSGIX.add( Input( 'pname','GLenum' ))
glSpriteParameterfvSGIX.add( Input( 'params','const GLfloat *' ))
glSpriteParameterfvSGIX.version = '1.0'
glSpriteParameterfvSGIX.category = 'GL_SGIX_sprite'
glSpriteParameterfvSGIX.trace = True
glSpriteParameterfvSGIX.play = True
gl.add(glSpriteParameterfvSGIX)

glSpriteParameteriSGIX = Function('glSpriteParameteriSGIX')
glSpriteParameteriSGIX.ret = Return('void')
glSpriteParameteriSGIX.add( Input( 'pname','GLenum' ))
glSpriteParameteriSGIX.add( Input( 'param','GLint' ))
glSpriteParameteriSGIX.version = '1.0'
glSpriteParameteriSGIX.category = 'GL_SGIX_sprite'
glSpriteParameteriSGIX.trace = True
glSpriteParameteriSGIX.play = True
gl.add(glSpriteParameteriSGIX)

glSpriteParameterivSGIX = Function('glSpriteParameterivSGIX')
glSpriteParameterivSGIX.ret = Return('void')
glSpriteParameterivSGIX.add( Input( 'pname','GLenum' ))
glSpriteParameterivSGIX.add( Input( 'params','const GLint *' ))
glSpriteParameterivSGIX.version = '1.0'
glSpriteParameterivSGIX.category = 'GL_SGIX_sprite'
glSpriteParameterivSGIX.trace = True
glSpriteParameterivSGIX.play = True
gl.add(glSpriteParameterivSGIX)

# GL_SGIX_tag_sample_buffer

glTagSampleBufferSGIX = Function('glTagSampleBufferSGIX')
glTagSampleBufferSGIX.ret = Return('void')
glTagSampleBufferSGIX.version = '1.0'
glTagSampleBufferSGIX.category = 'GL_SGIX_tag_sample_buffer'
glTagSampleBufferSGIX.trace = True
glTagSampleBufferSGIX.play = True
gl.add(glTagSampleBufferSGIX)

# GL_SGI_color_table

glColorTableParameterfvSGI = Function('glColorTableParameterfvSGI')
glColorTableParameterfvSGI.ret = Return('void')
glColorTableParameterfvSGI.add( Input( 'target','GLenum' ))
glColorTableParameterfvSGI.add( Input( 'pname','GLenum' ))
glColorTableParameterfvSGI.add( Input( 'params','const GLfloat *' ))
glColorTableParameterfvSGI.version = '1.0'
glColorTableParameterfvSGI.category = 'GL_SGI_color_table'
glColorTableParameterfvSGI.trace = True
glColorTableParameterfvSGI.play = True
gl.add(glColorTableParameterfvSGI)

glColorTableParameterivSGI = Function('glColorTableParameterivSGI')
glColorTableParameterivSGI.ret = Return('void')
glColorTableParameterivSGI.add( Input( 'target','GLenum' ))
glColorTableParameterivSGI.add( Input( 'pname','GLenum' ))
glColorTableParameterivSGI.add( Input( 'params','const GLint *' ))
glColorTableParameterivSGI.version = '1.0'
glColorTableParameterivSGI.category = 'GL_SGI_color_table'
glColorTableParameterivSGI.trace = True
glColorTableParameterivSGI.play = True
gl.add(glColorTableParameterivSGI)

glColorTableSGI = Function('glColorTableSGI')
glColorTableSGI.ret = Return('void')
glColorTableSGI.add( Input( 'target','GLenum' ))
glColorTableSGI.add( Input( 'internalformat','GLenum' ))
glColorTableSGI.add( Input( 'width','GLsizei' ))
glColorTableSGI.add( Input( 'format','GLenum' ))
glColorTableSGI.add( Input( 'type','GLenum' ))
glColorTableSGI.add( Input( 'table','const GLvoid *' ))
glColorTableSGI.version = '1.0'
glColorTableSGI.category = 'GL_SGI_color_table'
glColorTableSGI.trace = True
glColorTableSGI.play = True
gl.add(glColorTableSGI)

glCopyColorTableSGI = Function('glCopyColorTableSGI')
glCopyColorTableSGI.ret = Return('void')
glCopyColorTableSGI.add( Input( 'target','GLenum' ))
glCopyColorTableSGI.add( Input( 'internalformat','GLenum' ))
glCopyColorTableSGI.add( Input( 'x','GLint' ))
glCopyColorTableSGI.add( Input( 'y','GLint' ))
glCopyColorTableSGI.add( Input( 'width','GLsizei' ))
glCopyColorTableSGI.version = '1.0'
glCopyColorTableSGI.category = 'GL_SGI_color_table'
glCopyColorTableSGI.trace = True
glCopyColorTableSGI.play = True
gl.add(glCopyColorTableSGI)

glGetColorTableParameterfvSGI = Function('glGetColorTableParameterfvSGI')
glGetColorTableParameterfvSGI.ret = Return('void')
glGetColorTableParameterfvSGI.add( Input( 'target','GLenum' ))
glGetColorTableParameterfvSGI.add( Input( 'pname','GLenum' ))
glGetColorTableParameterfvSGI.add( Output( 'params','GLfloat *' ))
glGetColorTableParameterfvSGI.version = '1.0'
glGetColorTableParameterfvSGI.category = 'GL_SGI_color_table'
glGetColorTableParameterfvSGI.trace = True
glGetColorTableParameterfvSGI.play = True
gl.add(glGetColorTableParameterfvSGI)

glGetColorTableParameterivSGI = Function('glGetColorTableParameterivSGI')
glGetColorTableParameterivSGI.ret = Return('void')
glGetColorTableParameterivSGI.add( Input( 'target','GLenum' ))
glGetColorTableParameterivSGI.add( Input( 'pname','GLenum' ))
glGetColorTableParameterivSGI.add( Output( 'params','GLint *' ))
glGetColorTableParameterivSGI.version = '1.0'
glGetColorTableParameterivSGI.category = 'GL_SGI_color_table'
glGetColorTableParameterivSGI.trace = True
glGetColorTableParameterivSGI.play = True
gl.add(glGetColorTableParameterivSGI)

glGetColorTableSGI = Function('glGetColorTableSGI')
glGetColorTableSGI.ret = Return('void')
glGetColorTableSGI.add( Input( 'target','GLenum' ))
glGetColorTableSGI.add( Input( 'format','GLenum' ))
glGetColorTableSGI.add( Input( 'type','GLenum' ))
glGetColorTableSGI.add( Output( 'table','GLvoid *' ))
glGetColorTableSGI.version = '1.0'
glGetColorTableSGI.category = 'GL_SGI_color_table'
glGetColorTableSGI.trace = True
glGetColorTableSGI.play = True
gl.add(glGetColorTableSGI)

# GL_SUNX_constant_data

glFinishTextureSUNX = Function('glFinishTextureSUNX')
glFinishTextureSUNX.ret = Return('void')
glFinishTextureSUNX.version = '1.1'
glFinishTextureSUNX.category = 'GL_SUNX_constant_data'
glFinishTextureSUNX.trace = True
glFinishTextureSUNX.play = True
gl.add(glFinishTextureSUNX)

# GL_SUN_global_alpha

glGlobalAlphaFactorbSUN = Function('glGlobalAlphaFactorbSUN')
glGlobalAlphaFactorbSUN.ret = Return('void')
glGlobalAlphaFactorbSUN.add( Input( 'factor','GLbyte' ))
glGlobalAlphaFactorbSUN.version = '1.1'
glGlobalAlphaFactorbSUN.category = 'GL_SUN_global_alpha'
glGlobalAlphaFactorbSUN.trace = True
glGlobalAlphaFactorbSUN.play = True
gl.add(glGlobalAlphaFactorbSUN)

glGlobalAlphaFactordSUN = Function('glGlobalAlphaFactordSUN')
glGlobalAlphaFactordSUN.ret = Return('void')
glGlobalAlphaFactordSUN.add( Input( 'factor','GLdouble' ))
glGlobalAlphaFactordSUN.version = '1.1'
glGlobalAlphaFactordSUN.category = 'GL_SUN_global_alpha'
glGlobalAlphaFactordSUN.trace = True
glGlobalAlphaFactordSUN.play = True
gl.add(glGlobalAlphaFactordSUN)

glGlobalAlphaFactorfSUN = Function('glGlobalAlphaFactorfSUN')
glGlobalAlphaFactorfSUN.ret = Return('void')
glGlobalAlphaFactorfSUN.add( Input( 'factor','GLfloat' ))
glGlobalAlphaFactorfSUN.version = '1.1'
glGlobalAlphaFactorfSUN.category = 'GL_SUN_global_alpha'
glGlobalAlphaFactorfSUN.trace = True
glGlobalAlphaFactorfSUN.play = True
gl.add(glGlobalAlphaFactorfSUN)

glGlobalAlphaFactoriSUN = Function('glGlobalAlphaFactoriSUN')
glGlobalAlphaFactoriSUN.ret = Return('void')
glGlobalAlphaFactoriSUN.add( Input( 'factor','GLint' ))
glGlobalAlphaFactoriSUN.version = '1.1'
glGlobalAlphaFactoriSUN.category = 'GL_SUN_global_alpha'
glGlobalAlphaFactoriSUN.trace = True
glGlobalAlphaFactoriSUN.play = True
gl.add(glGlobalAlphaFactoriSUN)

glGlobalAlphaFactorsSUN = Function('glGlobalAlphaFactorsSUN')
glGlobalAlphaFactorsSUN.ret = Return('void')
glGlobalAlphaFactorsSUN.add( Input( 'factor','GLshort' ))
glGlobalAlphaFactorsSUN.version = '1.1'
glGlobalAlphaFactorsSUN.category = 'GL_SUN_global_alpha'
glGlobalAlphaFactorsSUN.trace = True
glGlobalAlphaFactorsSUN.play = True
gl.add(glGlobalAlphaFactorsSUN)

glGlobalAlphaFactorubSUN = Function('glGlobalAlphaFactorubSUN')
glGlobalAlphaFactorubSUN.ret = Return('void')
glGlobalAlphaFactorubSUN.add( Input( 'factor','GLubyte' ))
glGlobalAlphaFactorubSUN.version = '1.1'
glGlobalAlphaFactorubSUN.category = 'GL_SUN_global_alpha'
glGlobalAlphaFactorubSUN.trace = True
glGlobalAlphaFactorubSUN.play = True
gl.add(glGlobalAlphaFactorubSUN)

glGlobalAlphaFactoruiSUN = Function('glGlobalAlphaFactoruiSUN')
glGlobalAlphaFactoruiSUN.ret = Return('void')
glGlobalAlphaFactoruiSUN.add( Input( 'factor','GLuint' ))
glGlobalAlphaFactoruiSUN.version = '1.1'
glGlobalAlphaFactoruiSUN.category = 'GL_SUN_global_alpha'
glGlobalAlphaFactoruiSUN.trace = True
glGlobalAlphaFactoruiSUN.play = True
gl.add(glGlobalAlphaFactoruiSUN)

glGlobalAlphaFactorusSUN = Function('glGlobalAlphaFactorusSUN')
glGlobalAlphaFactorusSUN.ret = Return('void')
glGlobalAlphaFactorusSUN.add( Input( 'factor','GLushort' ))
glGlobalAlphaFactorusSUN.version = '1.1'
glGlobalAlphaFactorusSUN.category = 'GL_SUN_global_alpha'
glGlobalAlphaFactorusSUN.trace = True
glGlobalAlphaFactorusSUN.play = True
gl.add(glGlobalAlphaFactorusSUN)

# GL_SUN_mesh_array

glDrawMeshArraysSUN = Function('glDrawMeshArraysSUN')
glDrawMeshArraysSUN.ret = Return('void')
glDrawMeshArraysSUN.add( Input( 'mode','GLenum' ,regalLog = 'GLmodeToString(mode)' ))
glDrawMeshArraysSUN.add( Input( 'first','GLint' ))
glDrawMeshArraysSUN.add( Input( 'count','GLsizei' ))
glDrawMeshArraysSUN.add( Input( 'width','GLsizei' ))
glDrawMeshArraysSUN.version = '1.1'
glDrawMeshArraysSUN.category = 'GL_SUN_mesh_array'
glDrawMeshArraysSUN.trace = True
glDrawMeshArraysSUN.play = True
gl.add(glDrawMeshArraysSUN)

# GL_SUN_read_video_pixels

glReadVideoPixelsSUN = Function('glReadVideoPixelsSUN')
glReadVideoPixelsSUN.ret = Return('void')
glReadVideoPixelsSUN.add( Input( 'x','GLint' ))
glReadVideoPixelsSUN.add( Input( 'y','GLint' ))
glReadVideoPixelsSUN.add( Input( 'width','GLsizei' ))
glReadVideoPixelsSUN.add( Input( 'height','GLsizei' ))
glReadVideoPixelsSUN.add( Input( 'format','GLenum' ))
glReadVideoPixelsSUN.add( Input( 'type','GLenum' ))
glReadVideoPixelsSUN.add( Input( 'pixels','GLvoid *' ))
glReadVideoPixelsSUN.version = ''
glReadVideoPixelsSUN.category = 'GL_SUN_read_video_pixels'
glReadVideoPixelsSUN.trace = True
glReadVideoPixelsSUN.play = True
gl.add(glReadVideoPixelsSUN)

# GL_SUN_triangle_list

glReplacementCodePointerSUN = Function('glReplacementCodePointerSUN')
glReplacementCodePointerSUN.ret = Return('void')
glReplacementCodePointerSUN.add( Input( 'type','GLenum' ))
glReplacementCodePointerSUN.add( Input( 'stride','GLsizei' ))
glReplacementCodePointerSUN.add( Input( 'pointer','const GLvoid **' ))
glReplacementCodePointerSUN.version = '1.1'
glReplacementCodePointerSUN.category = 'GL_SUN_triangle_list'
glReplacementCodePointerSUN.trace = True
glReplacementCodePointerSUN.play = True
gl.add(glReplacementCodePointerSUN)

glReplacementCodeubSUN = Function('glReplacementCodeubSUN')
glReplacementCodeubSUN.ret = Return('void')
glReplacementCodeubSUN.add( Input( 'code','GLubyte' ))
glReplacementCodeubSUN.version = '1.1'
glReplacementCodeubSUN.category = 'GL_SUN_triangle_list'
glReplacementCodeubSUN.trace = True
glReplacementCodeubSUN.play = True
gl.add(glReplacementCodeubSUN)

glReplacementCodeubvSUN = Function('glReplacementCodeubvSUN')
glReplacementCodeubvSUN.ret = Return('void')
glReplacementCodeubvSUN.add( Input( 'code','const GLubyte *' ))
glReplacementCodeubvSUN.version = '1.1'
glReplacementCodeubvSUN.category = 'GL_SUN_triangle_list'
glReplacementCodeubvSUN.trace = True
glReplacementCodeubvSUN.play = True
gl.add(glReplacementCodeubvSUN)

glReplacementCodeuiSUN = Function('glReplacementCodeuiSUN')
glReplacementCodeuiSUN.ret = Return('void')
glReplacementCodeuiSUN.add( Input( 'code','GLuint' ))
glReplacementCodeuiSUN.version = '1.1'
glReplacementCodeuiSUN.category = 'GL_SUN_triangle_list'
glReplacementCodeuiSUN.trace = True
glReplacementCodeuiSUN.play = True
gl.add(glReplacementCodeuiSUN)

glReplacementCodeuivSUN = Function('glReplacementCodeuivSUN')
glReplacementCodeuivSUN.ret = Return('void')
glReplacementCodeuivSUN.add( Input( 'code','const GLuint *' ))
glReplacementCodeuivSUN.version = '1.1'
glReplacementCodeuivSUN.category = 'GL_SUN_triangle_list'
glReplacementCodeuivSUN.trace = True
glReplacementCodeuivSUN.play = True
gl.add(glReplacementCodeuivSUN)

glReplacementCodeusSUN = Function('glReplacementCodeusSUN')
glReplacementCodeusSUN.ret = Return('void')
glReplacementCodeusSUN.add( Input( 'code','GLushort' ))
glReplacementCodeusSUN.version = '1.1'
glReplacementCodeusSUN.category = 'GL_SUN_triangle_list'
glReplacementCodeusSUN.trace = True
glReplacementCodeusSUN.play = True
gl.add(glReplacementCodeusSUN)

glReplacementCodeusvSUN = Function('glReplacementCodeusvSUN')
glReplacementCodeusvSUN.ret = Return('void')
glReplacementCodeusvSUN.add( Input( 'code','const GLushort *' ))
glReplacementCodeusvSUN.version = '1.1'
glReplacementCodeusvSUN.category = 'GL_SUN_triangle_list'
glReplacementCodeusvSUN.trace = True
glReplacementCodeusvSUN.play = True
gl.add(glReplacementCodeusvSUN)

# GL_SUN_vertex

glColor3fVertex3fSUN = Function('glColor3fVertex3fSUN')
glColor3fVertex3fSUN.ret = Return('void')
glColor3fVertex3fSUN.add( Input( 'r','GLfloat' ))
glColor3fVertex3fSUN.add( Input( 'g','GLfloat' ))
glColor3fVertex3fSUN.add( Input( 'b','GLfloat' ))
glColor3fVertex3fSUN.add( Input( 'x','GLfloat' ))
glColor3fVertex3fSUN.add( Input( 'y','GLfloat' ))
glColor3fVertex3fSUN.add( Input( 'z','GLfloat' ))
glColor3fVertex3fSUN.version = '1.1'
glColor3fVertex3fSUN.category = 'GL_SUN_vertex'
glColor3fVertex3fSUN.trace = True
glColor3fVertex3fSUN.play = True
gl.add(glColor3fVertex3fSUN)

glColor3fVertex3fvSUN = Function('glColor3fVertex3fvSUN')
glColor3fVertex3fvSUN.ret = Return('void')
glColor3fVertex3fvSUN.add( Input( 'c','const GLfloat *' ,size = 3 ))
glColor3fVertex3fvSUN.add( Input( 'v','const GLfloat *' ,size = 3 ))
glColor3fVertex3fvSUN.version = '1.1'
glColor3fVertex3fvSUN.category = 'GL_SUN_vertex'
glColor3fVertex3fvSUN.trace = True
glColor3fVertex3fvSUN.play = True
gl.add(glColor3fVertex3fvSUN)

glColor4fNormal3fVertex3fSUN = Function('glColor4fNormal3fVertex3fSUN')
glColor4fNormal3fVertex3fSUN.ret = Return('void')
glColor4fNormal3fVertex3fSUN.add( Input( 'r','GLfloat' ))
glColor4fNormal3fVertex3fSUN.add( Input( 'g','GLfloat' ))
glColor4fNormal3fVertex3fSUN.add( Input( 'b','GLfloat' ))
glColor4fNormal3fVertex3fSUN.add( Input( 'a','GLfloat' ))
glColor4fNormal3fVertex3fSUN.add( Input( 'nx','GLfloat' ))
glColor4fNormal3fVertex3fSUN.add( Input( 'ny','GLfloat' ))
glColor4fNormal3fVertex3fSUN.add( Input( 'nz','GLfloat' ))
glColor4fNormal3fVertex3fSUN.add( Input( 'x','GLfloat' ))
glColor4fNormal3fVertex3fSUN.add( Input( 'y','GLfloat' ))
glColor4fNormal3fVertex3fSUN.add( Input( 'z','GLfloat' ))
glColor4fNormal3fVertex3fSUN.version = '1.1'
glColor4fNormal3fVertex3fSUN.category = 'GL_SUN_vertex'
glColor4fNormal3fVertex3fSUN.trace = True
glColor4fNormal3fVertex3fSUN.play = True
gl.add(glColor4fNormal3fVertex3fSUN)

glColor4fNormal3fVertex3fvSUN = Function('glColor4fNormal3fVertex3fvSUN')
glColor4fNormal3fVertex3fvSUN.ret = Return('void')
glColor4fNormal3fVertex3fvSUN.add( Input( 'c','const GLfloat *' ,size = 4 ))
glColor4fNormal3fVertex3fvSUN.add( Input( 'n','const GLfloat *' ,size = 3 ))
glColor4fNormal3fVertex3fvSUN.add( Input( 'v','const GLfloat *' ,size = 3 ))
glColor4fNormal3fVertex3fvSUN.version = '1.1'
glColor4fNormal3fVertex3fvSUN.category = 'GL_SUN_vertex'
glColor4fNormal3fVertex3fvSUN.trace = True
glColor4fNormal3fVertex3fvSUN.play = True
gl.add(glColor4fNormal3fVertex3fvSUN)

glColor4ubVertex2fSUN = Function('glColor4ubVertex2fSUN')
glColor4ubVertex2fSUN.ret = Return('void')
glColor4ubVertex2fSUN.add( Input( 'r','GLubyte' ))
glColor4ubVertex2fSUN.add( Input( 'g','GLubyte' ))
glColor4ubVertex2fSUN.add( Input( 'b','GLubyte' ))
glColor4ubVertex2fSUN.add( Input( 'a','GLubyte' ))
glColor4ubVertex2fSUN.add( Input( 'x','GLfloat' ))
glColor4ubVertex2fSUN.add( Input( 'y','GLfloat' ))
glColor4ubVertex2fSUN.version = '1.1'
glColor4ubVertex2fSUN.category = 'GL_SUN_vertex'
glColor4ubVertex2fSUN.trace = True
glColor4ubVertex2fSUN.play = True
gl.add(glColor4ubVertex2fSUN)

glColor4ubVertex2fvSUN = Function('glColor4ubVertex2fvSUN')
glColor4ubVertex2fvSUN.ret = Return('void')
glColor4ubVertex2fvSUN.add( Input( 'c','const GLubyte *' ,size = 4 ))
glColor4ubVertex2fvSUN.add( Input( 'v','const GLfloat *' ,size = 2 ))
glColor4ubVertex2fvSUN.version = '1.1'
glColor4ubVertex2fvSUN.category = 'GL_SUN_vertex'
glColor4ubVertex2fvSUN.trace = True
glColor4ubVertex2fvSUN.play = True
gl.add(glColor4ubVertex2fvSUN)

glColor4ubVertex3fSUN = Function('glColor4ubVertex3fSUN')
glColor4ubVertex3fSUN.ret = Return('void')
glColor4ubVertex3fSUN.add( Input( 'r','GLubyte' ))
glColor4ubVertex3fSUN.add( Input( 'g','GLubyte' ))
glColor4ubVertex3fSUN.add( Input( 'b','GLubyte' ))
glColor4ubVertex3fSUN.add( Input( 'a','GLubyte' ))
glColor4ubVertex3fSUN.add( Input( 'x','GLfloat' ))
glColor4ubVertex3fSUN.add( Input( 'y','GLfloat' ))
glColor4ubVertex3fSUN.add( Input( 'z','GLfloat' ))
glColor4ubVertex3fSUN.version = '1.1'
glColor4ubVertex3fSUN.category = 'GL_SUN_vertex'
glColor4ubVertex3fSUN.trace = True
glColor4ubVertex3fSUN.play = True
gl.add(glColor4ubVertex3fSUN)

glColor4ubVertex3fvSUN = Function('glColor4ubVertex3fvSUN')
glColor4ubVertex3fvSUN.ret = Return('void')
glColor4ubVertex3fvSUN.add( Input( 'c','const GLubyte *' ,size = 4 ))
glColor4ubVertex3fvSUN.add( Input( 'v','const GLfloat *' ,size = 3 ))
glColor4ubVertex3fvSUN.version = '1.1'
glColor4ubVertex3fvSUN.category = 'GL_SUN_vertex'
glColor4ubVertex3fvSUN.trace = True
glColor4ubVertex3fvSUN.play = True
gl.add(glColor4ubVertex3fvSUN)

glNormal3fVertex3fSUN = Function('glNormal3fVertex3fSUN')
glNormal3fVertex3fSUN.ret = Return('void')
glNormal3fVertex3fSUN.add( Input( 'nx','GLfloat' ))
glNormal3fVertex3fSUN.add( Input( 'ny','GLfloat' ))
glNormal3fVertex3fSUN.add( Input( 'nz','GLfloat' ))
glNormal3fVertex3fSUN.add( Input( 'x','GLfloat' ))
glNormal3fVertex3fSUN.add( Input( 'y','GLfloat' ))
glNormal3fVertex3fSUN.add( Input( 'z','GLfloat' ))
glNormal3fVertex3fSUN.version = '1.1'
glNormal3fVertex3fSUN.category = 'GL_SUN_vertex'
glNormal3fVertex3fSUN.trace = True
glNormal3fVertex3fSUN.play = True
gl.add(glNormal3fVertex3fSUN)

glNormal3fVertex3fvSUN = Function('glNormal3fVertex3fvSUN')
glNormal3fVertex3fvSUN.ret = Return('void')
glNormal3fVertex3fvSUN.add( Input( 'n','const GLfloat *' ,size = 3 ))
glNormal3fVertex3fvSUN.add( Input( 'v','const GLfloat *' ,size = 3 ))
glNormal3fVertex3fvSUN.version = '1.1'
glNormal3fVertex3fvSUN.category = 'GL_SUN_vertex'
glNormal3fVertex3fvSUN.trace = True
glNormal3fVertex3fvSUN.play = True
gl.add(glNormal3fVertex3fvSUN)

glReplacementCodeuiColor3fVertex3fSUN = Function('glReplacementCodeuiColor3fVertex3fSUN')
glReplacementCodeuiColor3fVertex3fSUN.ret = Return('void')
glReplacementCodeuiColor3fVertex3fSUN.add( Input( 'rc','GLuint' ))
glReplacementCodeuiColor3fVertex3fSUN.add( Input( 'r','GLfloat' ))
glReplacementCodeuiColor3fVertex3fSUN.add( Input( 'g','GLfloat' ))
glReplacementCodeuiColor3fVertex3fSUN.add( Input( 'b','GLfloat' ))
glReplacementCodeuiColor3fVertex3fSUN.add( Input( 'x','GLfloat' ))
glReplacementCodeuiColor3fVertex3fSUN.add( Input( 'y','GLfloat' ))
glReplacementCodeuiColor3fVertex3fSUN.add( Input( 'z','GLfloat' ))
glReplacementCodeuiColor3fVertex3fSUN.version = '1.1'
glReplacementCodeuiColor3fVertex3fSUN.category = 'GL_SUN_vertex'
glReplacementCodeuiColor3fVertex3fSUN.trace = True
glReplacementCodeuiColor3fVertex3fSUN.play = True
gl.add(glReplacementCodeuiColor3fVertex3fSUN)

glReplacementCodeuiColor3fVertex3fvSUN = Function('glReplacementCodeuiColor3fVertex3fvSUN')
glReplacementCodeuiColor3fVertex3fvSUN.ret = Return('void')
glReplacementCodeuiColor3fVertex3fvSUN.add( Input( 'rc','const GLuint *' ,size = 1 ))
glReplacementCodeuiColor3fVertex3fvSUN.add( Input( 'c','const GLfloat *' ,size = 3 ))
glReplacementCodeuiColor3fVertex3fvSUN.add( Input( 'v','const GLfloat *' ,size = 3 ))
glReplacementCodeuiColor3fVertex3fvSUN.version = '1.1'
glReplacementCodeuiColor3fVertex3fvSUN.category = 'GL_SUN_vertex'
glReplacementCodeuiColor3fVertex3fvSUN.trace = True
glReplacementCodeuiColor3fVertex3fvSUN.play = True
gl.add(glReplacementCodeuiColor3fVertex3fvSUN)

glReplacementCodeuiColor4fNormal3fVertex3fSUN = Function('glReplacementCodeuiColor4fNormal3fVertex3fSUN')
glReplacementCodeuiColor4fNormal3fVertex3fSUN.ret = Return('void')
glReplacementCodeuiColor4fNormal3fVertex3fSUN.add( Input( 'rc','GLuint' ))
glReplacementCodeuiColor4fNormal3fVertex3fSUN.add( Input( 'r','GLfloat' ))
glReplacementCodeuiColor4fNormal3fVertex3fSUN.add( Input( 'g','GLfloat' ))
glReplacementCodeuiColor4fNormal3fVertex3fSUN.add( Input( 'b','GLfloat' ))
glReplacementCodeuiColor4fNormal3fVertex3fSUN.add( Input( 'a','GLfloat' ))
glReplacementCodeuiColor4fNormal3fVertex3fSUN.add( Input( 'nx','GLfloat' ))
glReplacementCodeuiColor4fNormal3fVertex3fSUN.add( Input( 'ny','GLfloat' ))
glReplacementCodeuiColor4fNormal3fVertex3fSUN.add( Input( 'nz','GLfloat' ))
glReplacementCodeuiColor4fNormal3fVertex3fSUN.add( Input( 'x','GLfloat' ))
glReplacementCodeuiColor4fNormal3fVertex3fSUN.add( Input( 'y','GLfloat' ))
glReplacementCodeuiColor4fNormal3fVertex3fSUN.add( Input( 'z','GLfloat' ))
glReplacementCodeuiColor4fNormal3fVertex3fSUN.version = '1.1'
glReplacementCodeuiColor4fNormal3fVertex3fSUN.category = 'GL_SUN_vertex'
glReplacementCodeuiColor4fNormal3fVertex3fSUN.trace = True
glReplacementCodeuiColor4fNormal3fVertex3fSUN.play = True
gl.add(glReplacementCodeuiColor4fNormal3fVertex3fSUN)

glReplacementCodeuiColor4fNormal3fVertex3fvSUN = Function('glReplacementCodeuiColor4fNormal3fVertex3fvSUN')
glReplacementCodeuiColor4fNormal3fVertex3fvSUN.ret = Return('void')
glReplacementCodeuiColor4fNormal3fVertex3fvSUN.add( Input( 'rc','const GLuint *' ,size = 1 ))
glReplacementCodeuiColor4fNormal3fVertex3fvSUN.add( Input( 'c','const GLfloat *' ,size = 4 ))
glReplacementCodeuiColor4fNormal3fVertex3fvSUN.add( Input( 'n','const GLfloat *' ,size = 3 ))
glReplacementCodeuiColor4fNormal3fVertex3fvSUN.add( Input( 'v','const GLfloat *' ,size = 3 ))
glReplacementCodeuiColor4fNormal3fVertex3fvSUN.version = '1.1'
glReplacementCodeuiColor4fNormal3fVertex3fvSUN.category = 'GL_SUN_vertex'
glReplacementCodeuiColor4fNormal3fVertex3fvSUN.trace = True
glReplacementCodeuiColor4fNormal3fVertex3fvSUN.play = True
gl.add(glReplacementCodeuiColor4fNormal3fVertex3fvSUN)

glReplacementCodeuiColor4ubVertex3fSUN = Function('glReplacementCodeuiColor4ubVertex3fSUN')
glReplacementCodeuiColor4ubVertex3fSUN.ret = Return('void')
glReplacementCodeuiColor4ubVertex3fSUN.add( Input( 'rc','GLuint' ))
glReplacementCodeuiColor4ubVertex3fSUN.add( Input( 'r','GLubyte' ))
glReplacementCodeuiColor4ubVertex3fSUN.add( Input( 'g','GLubyte' ))
glReplacementCodeuiColor4ubVertex3fSUN.add( Input( 'b','GLubyte' ))
glReplacementCodeuiColor4ubVertex3fSUN.add( Input( 'a','GLubyte' ))
glReplacementCodeuiColor4ubVertex3fSUN.add( Input( 'x','GLfloat' ))
glReplacementCodeuiColor4ubVertex3fSUN.add( Input( 'y','GLfloat' ))
glReplacementCodeuiColor4ubVertex3fSUN.add( Input( 'z','GLfloat' ))
glReplacementCodeuiColor4ubVertex3fSUN.version = '1.1'
glReplacementCodeuiColor4ubVertex3fSUN.category = 'GL_SUN_vertex'
glReplacementCodeuiColor4ubVertex3fSUN.trace = True
glReplacementCodeuiColor4ubVertex3fSUN.play = True
gl.add(glReplacementCodeuiColor4ubVertex3fSUN)

glReplacementCodeuiColor4ubVertex3fvSUN = Function('glReplacementCodeuiColor4ubVertex3fvSUN')
glReplacementCodeuiColor4ubVertex3fvSUN.ret = Return('void')
glReplacementCodeuiColor4ubVertex3fvSUN.add( Input( 'rc','const GLuint *' ,size = 1 ))
glReplacementCodeuiColor4ubVertex3fvSUN.add( Input( 'c','const GLubyte *' ,size = 4 ))
glReplacementCodeuiColor4ubVertex3fvSUN.add( Input( 'v','const GLfloat *' ,size = 3 ))
glReplacementCodeuiColor4ubVertex3fvSUN.version = '1.1'
glReplacementCodeuiColor4ubVertex3fvSUN.category = 'GL_SUN_vertex'
glReplacementCodeuiColor4ubVertex3fvSUN.trace = True
glReplacementCodeuiColor4ubVertex3fvSUN.play = True
gl.add(glReplacementCodeuiColor4ubVertex3fvSUN)

glReplacementCodeuiNormal3fVertex3fSUN = Function('glReplacementCodeuiNormal3fVertex3fSUN')
glReplacementCodeuiNormal3fVertex3fSUN.ret = Return('void')
glReplacementCodeuiNormal3fVertex3fSUN.add( Input( 'rc','GLuint' ))
glReplacementCodeuiNormal3fVertex3fSUN.add( Input( 'nx','GLfloat' ))
glReplacementCodeuiNormal3fVertex3fSUN.add( Input( 'ny','GLfloat' ))
glReplacementCodeuiNormal3fVertex3fSUN.add( Input( 'nz','GLfloat' ))
glReplacementCodeuiNormal3fVertex3fSUN.add( Input( 'x','GLfloat' ))
glReplacementCodeuiNormal3fVertex3fSUN.add( Input( 'y','GLfloat' ))
glReplacementCodeuiNormal3fVertex3fSUN.add( Input( 'z','GLfloat' ))
glReplacementCodeuiNormal3fVertex3fSUN.version = '1.1'
glReplacementCodeuiNormal3fVertex3fSUN.category = 'GL_SUN_vertex'
glReplacementCodeuiNormal3fVertex3fSUN.trace = True
glReplacementCodeuiNormal3fVertex3fSUN.play = True
gl.add(glReplacementCodeuiNormal3fVertex3fSUN)

glReplacementCodeuiNormal3fVertex3fvSUN = Function('glReplacementCodeuiNormal3fVertex3fvSUN')
glReplacementCodeuiNormal3fVertex3fvSUN.ret = Return('void')
glReplacementCodeuiNormal3fVertex3fvSUN.add( Input( 'rc','const GLuint *' ,size = 1 ))
glReplacementCodeuiNormal3fVertex3fvSUN.add( Input( 'n','const GLfloat *' ,size = 3 ))
glReplacementCodeuiNormal3fVertex3fvSUN.add( Input( 'v','const GLfloat *' ,size = 3 ))
glReplacementCodeuiNormal3fVertex3fvSUN.version = '1.1'
glReplacementCodeuiNormal3fVertex3fvSUN.category = 'GL_SUN_vertex'
glReplacementCodeuiNormal3fVertex3fvSUN.trace = True
glReplacementCodeuiNormal3fVertex3fvSUN.play = True
gl.add(glReplacementCodeuiNormal3fVertex3fvSUN)

glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN = Function('glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN')
glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN.ret = Return('void')
glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN.add( Input( 'rc','GLuint' ))
glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN.add( Input( 's','GLfloat' ))
glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN.add( Input( 't','GLfloat' ))
glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN.add( Input( 'r','GLfloat' ))
glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN.add( Input( 'g','GLfloat' ))
glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN.add( Input( 'b','GLfloat' ))
glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN.add( Input( 'a','GLfloat' ))
glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN.add( Input( 'nx','GLfloat' ))
glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN.add( Input( 'ny','GLfloat' ))
glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN.add( Input( 'nz','GLfloat' ))
glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN.add( Input( 'x','GLfloat' ))
glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN.add( Input( 'y','GLfloat' ))
glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN.add( Input( 'z','GLfloat' ))
glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN.version = '1.1'
glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN.category = 'GL_SUN_vertex'
glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN.trace = True
glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN.play = True
gl.add(glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN)

glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN = Function('glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN')
glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN.ret = Return('void')
glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN.add( Input( 'rc','const GLuint *' ,size = 1 ))
glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN.add( Input( 'tc','const GLfloat *' ,size = 2 ))
glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN.add( Input( 'c','const GLfloat *' ,size = 4 ))
glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN.add( Input( 'n','const GLfloat *' ,size = 3 ))
glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN.add( Input( 'v','const GLfloat *' ,size = 3 ))
glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN.version = '1.1'
glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN.category = 'GL_SUN_vertex'
glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN.trace = True
glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN.play = True
gl.add(glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN)

glReplacementCodeuiTexCoord2fNormal3fVertex3fSUN = Function('glReplacementCodeuiTexCoord2fNormal3fVertex3fSUN')
glReplacementCodeuiTexCoord2fNormal3fVertex3fSUN.ret = Return('void')
glReplacementCodeuiTexCoord2fNormal3fVertex3fSUN.add( Input( 'rc','GLuint' ))
glReplacementCodeuiTexCoord2fNormal3fVertex3fSUN.add( Input( 's','GLfloat' ))
glReplacementCodeuiTexCoord2fNormal3fVertex3fSUN.add( Input( 't','GLfloat' ))
glReplacementCodeuiTexCoord2fNormal3fVertex3fSUN.add( Input( 'nx','GLfloat' ))
glReplacementCodeuiTexCoord2fNormal3fVertex3fSUN.add( Input( 'ny','GLfloat' ))
glReplacementCodeuiTexCoord2fNormal3fVertex3fSUN.add( Input( 'nz','GLfloat' ))
glReplacementCodeuiTexCoord2fNormal3fVertex3fSUN.add( Input( 'x','GLfloat' ))
glReplacementCodeuiTexCoord2fNormal3fVertex3fSUN.add( Input( 'y','GLfloat' ))
glReplacementCodeuiTexCoord2fNormal3fVertex3fSUN.add( Input( 'z','GLfloat' ))
glReplacementCodeuiTexCoord2fNormal3fVertex3fSUN.version = '1.1'
glReplacementCodeuiTexCoord2fNormal3fVertex3fSUN.category = 'GL_SUN_vertex'
glReplacementCodeuiTexCoord2fNormal3fVertex3fSUN.trace = True
glReplacementCodeuiTexCoord2fNormal3fVertex3fSUN.play = True
gl.add(glReplacementCodeuiTexCoord2fNormal3fVertex3fSUN)

glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN = Function('glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN')
glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN.ret = Return('void')
glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN.add( Input( 'rc','const GLuint *' ,size = 1 ))
glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN.add( Input( 'tc','const GLfloat *' ,size = 2 ))
glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN.add( Input( 'n','const GLfloat *' ,size = 3 ))
glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN.add( Input( 'v','const GLfloat *' ,size = 3 ))
glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN.version = '1.1'
glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN.category = 'GL_SUN_vertex'
glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN.trace = True
glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN.play = True
gl.add(glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN)

glReplacementCodeuiTexCoord2fVertex3fSUN = Function('glReplacementCodeuiTexCoord2fVertex3fSUN')
glReplacementCodeuiTexCoord2fVertex3fSUN.ret = Return('void')
glReplacementCodeuiTexCoord2fVertex3fSUN.add( Input( 'rc','GLuint' ))
glReplacementCodeuiTexCoord2fVertex3fSUN.add( Input( 's','GLfloat' ))
glReplacementCodeuiTexCoord2fVertex3fSUN.add( Input( 't','GLfloat' ))
glReplacementCodeuiTexCoord2fVertex3fSUN.add( Input( 'x','GLfloat' ))
glReplacementCodeuiTexCoord2fVertex3fSUN.add( Input( 'y','GLfloat' ))
glReplacementCodeuiTexCoord2fVertex3fSUN.add( Input( 'z','GLfloat' ))
glReplacementCodeuiTexCoord2fVertex3fSUN.version = '1.1'
glReplacementCodeuiTexCoord2fVertex3fSUN.category = 'GL_SUN_vertex'
glReplacementCodeuiTexCoord2fVertex3fSUN.trace = True
glReplacementCodeuiTexCoord2fVertex3fSUN.play = True
gl.add(glReplacementCodeuiTexCoord2fVertex3fSUN)

glReplacementCodeuiTexCoord2fVertex3fvSUN = Function('glReplacementCodeuiTexCoord2fVertex3fvSUN')
glReplacementCodeuiTexCoord2fVertex3fvSUN.ret = Return('void')
glReplacementCodeuiTexCoord2fVertex3fvSUN.add( Input( 'rc','const GLuint *' ,size = 1 ))
glReplacementCodeuiTexCoord2fVertex3fvSUN.add( Input( 'tc','const GLfloat *' ,size = 2 ))
glReplacementCodeuiTexCoord2fVertex3fvSUN.add( Input( 'v','const GLfloat *' ,size = 3 ))
glReplacementCodeuiTexCoord2fVertex3fvSUN.version = '1.1'
glReplacementCodeuiTexCoord2fVertex3fvSUN.category = 'GL_SUN_vertex'
glReplacementCodeuiTexCoord2fVertex3fvSUN.trace = True
glReplacementCodeuiTexCoord2fVertex3fvSUN.play = True
gl.add(glReplacementCodeuiTexCoord2fVertex3fvSUN)

glReplacementCodeuiVertex3fSUN = Function('glReplacementCodeuiVertex3fSUN')
glReplacementCodeuiVertex3fSUN.ret = Return('void')
glReplacementCodeuiVertex3fSUN.add( Input( 'rc','GLuint' ))
glReplacementCodeuiVertex3fSUN.add( Input( 'x','GLfloat' ))
glReplacementCodeuiVertex3fSUN.add( Input( 'y','GLfloat' ))
glReplacementCodeuiVertex3fSUN.add( Input( 'z','GLfloat' ))
glReplacementCodeuiVertex3fSUN.version = '1.1'
glReplacementCodeuiVertex3fSUN.category = 'GL_SUN_vertex'
glReplacementCodeuiVertex3fSUN.trace = True
glReplacementCodeuiVertex3fSUN.play = True
gl.add(glReplacementCodeuiVertex3fSUN)

glReplacementCodeuiVertex3fvSUN = Function('glReplacementCodeuiVertex3fvSUN')
glReplacementCodeuiVertex3fvSUN.ret = Return('void')
glReplacementCodeuiVertex3fvSUN.add( Input( 'rc','const GLuint *' ,size = 1 ))
glReplacementCodeuiVertex3fvSUN.add( Input( 'v','const GLfloat *' ,size = 3 ))
glReplacementCodeuiVertex3fvSUN.version = '1.1'
glReplacementCodeuiVertex3fvSUN.category = 'GL_SUN_vertex'
glReplacementCodeuiVertex3fvSUN.trace = True
glReplacementCodeuiVertex3fvSUN.play = True
gl.add(glReplacementCodeuiVertex3fvSUN)

glTexCoord2fColor3fVertex3fSUN = Function('glTexCoord2fColor3fVertex3fSUN')
glTexCoord2fColor3fVertex3fSUN.ret = Return('void')
glTexCoord2fColor3fVertex3fSUN.add( Input( 's','GLfloat' ))
glTexCoord2fColor3fVertex3fSUN.add( Input( 't','GLfloat' ))
glTexCoord2fColor3fVertex3fSUN.add( Input( 'r','GLfloat' ))
glTexCoord2fColor3fVertex3fSUN.add( Input( 'g','GLfloat' ))
glTexCoord2fColor3fVertex3fSUN.add( Input( 'b','GLfloat' ))
glTexCoord2fColor3fVertex3fSUN.add( Input( 'x','GLfloat' ))
glTexCoord2fColor3fVertex3fSUN.add( Input( 'y','GLfloat' ))
glTexCoord2fColor3fVertex3fSUN.add( Input( 'z','GLfloat' ))
glTexCoord2fColor3fVertex3fSUN.version = '1.1'
glTexCoord2fColor3fVertex3fSUN.category = 'GL_SUN_vertex'
glTexCoord2fColor3fVertex3fSUN.trace = True
glTexCoord2fColor3fVertex3fSUN.play = True
gl.add(glTexCoord2fColor3fVertex3fSUN)

glTexCoord2fColor3fVertex3fvSUN = Function('glTexCoord2fColor3fVertex3fvSUN')
glTexCoord2fColor3fVertex3fvSUN.ret = Return('void')
glTexCoord2fColor3fVertex3fvSUN.add( Input( 'tc','const GLfloat *' ,size = 2 ))
glTexCoord2fColor3fVertex3fvSUN.add( Input( 'c','const GLfloat *' ,size = 3 ))
glTexCoord2fColor3fVertex3fvSUN.add( Input( 'v','const GLfloat *' ,size = 3 ))
glTexCoord2fColor3fVertex3fvSUN.version = '1.1'
glTexCoord2fColor3fVertex3fvSUN.category = 'GL_SUN_vertex'
glTexCoord2fColor3fVertex3fvSUN.trace = True
glTexCoord2fColor3fVertex3fvSUN.play = True
gl.add(glTexCoord2fColor3fVertex3fvSUN)

glTexCoord2fColor4fNormal3fVertex3fSUN = Function('glTexCoord2fColor4fNormal3fVertex3fSUN')
glTexCoord2fColor4fNormal3fVertex3fSUN.ret = Return('void')
glTexCoord2fColor4fNormal3fVertex3fSUN.add( Input( 's','GLfloat' ))
glTexCoord2fColor4fNormal3fVertex3fSUN.add( Input( 't','GLfloat' ))
glTexCoord2fColor4fNormal3fVertex3fSUN.add( Input( 'r','GLfloat' ))
glTexCoord2fColor4fNormal3fVertex3fSUN.add( Input( 'g','GLfloat' ))
glTexCoord2fColor4fNormal3fVertex3fSUN.add( Input( 'b','GLfloat' ))
glTexCoord2fColor4fNormal3fVertex3fSUN.add( Input( 'a','GLfloat' ))
glTexCoord2fColor4fNormal3fVertex3fSUN.add( Input( 'nx','GLfloat' ))
glTexCoord2fColor4fNormal3fVertex3fSUN.add( Input( 'ny','GLfloat' ))
glTexCoord2fColor4fNormal3fVertex3fSUN.add( Input( 'nz','GLfloat' ))
glTexCoord2fColor4fNormal3fVertex3fSUN.add( Input( 'x','GLfloat' ))
glTexCoord2fColor4fNormal3fVertex3fSUN.add( Input( 'y','GLfloat' ))
glTexCoord2fColor4fNormal3fVertex3fSUN.add( Input( 'z','GLfloat' ))
glTexCoord2fColor4fNormal3fVertex3fSUN.version = '1.1'
glTexCoord2fColor4fNormal3fVertex3fSUN.category = 'GL_SUN_vertex'
glTexCoord2fColor4fNormal3fVertex3fSUN.trace = True
glTexCoord2fColor4fNormal3fVertex3fSUN.play = True
gl.add(glTexCoord2fColor4fNormal3fVertex3fSUN)

glTexCoord2fColor4fNormal3fVertex3fvSUN = Function('glTexCoord2fColor4fNormal3fVertex3fvSUN')
glTexCoord2fColor4fNormal3fVertex3fvSUN.ret = Return('void')
glTexCoord2fColor4fNormal3fVertex3fvSUN.add( Input( 'tc','const GLfloat *' ,size = 2 ))
glTexCoord2fColor4fNormal3fVertex3fvSUN.add( Input( 'c','const GLfloat *' ,size = 4 ))
glTexCoord2fColor4fNormal3fVertex3fvSUN.add( Input( 'n','const GLfloat *' ,size = 3 ))
glTexCoord2fColor4fNormal3fVertex3fvSUN.add( Input( 'v','const GLfloat *' ,size = 3 ))
glTexCoord2fColor4fNormal3fVertex3fvSUN.version = '1.1'
glTexCoord2fColor4fNormal3fVertex3fvSUN.category = 'GL_SUN_vertex'
glTexCoord2fColor4fNormal3fVertex3fvSUN.trace = True
glTexCoord2fColor4fNormal3fVertex3fvSUN.play = True
gl.add(glTexCoord2fColor4fNormal3fVertex3fvSUN)

glTexCoord2fColor4ubVertex3fSUN = Function('glTexCoord2fColor4ubVertex3fSUN')
glTexCoord2fColor4ubVertex3fSUN.ret = Return('void')
glTexCoord2fColor4ubVertex3fSUN.add( Input( 's','GLfloat' ))
glTexCoord2fColor4ubVertex3fSUN.add( Input( 't','GLfloat' ))
glTexCoord2fColor4ubVertex3fSUN.add( Input( 'r','GLubyte' ))
glTexCoord2fColor4ubVertex3fSUN.add( Input( 'g','GLubyte' ))
glTexCoord2fColor4ubVertex3fSUN.add( Input( 'b','GLubyte' ))
glTexCoord2fColor4ubVertex3fSUN.add( Input( 'a','GLubyte' ))
glTexCoord2fColor4ubVertex3fSUN.add( Input( 'x','GLfloat' ))
glTexCoord2fColor4ubVertex3fSUN.add( Input( 'y','GLfloat' ))
glTexCoord2fColor4ubVertex3fSUN.add( Input( 'z','GLfloat' ))
glTexCoord2fColor4ubVertex3fSUN.version = '1.1'
glTexCoord2fColor4ubVertex3fSUN.category = 'GL_SUN_vertex'
glTexCoord2fColor4ubVertex3fSUN.trace = True
glTexCoord2fColor4ubVertex3fSUN.play = True
gl.add(glTexCoord2fColor4ubVertex3fSUN)

glTexCoord2fColor4ubVertex3fvSUN = Function('glTexCoord2fColor4ubVertex3fvSUN')
glTexCoord2fColor4ubVertex3fvSUN.ret = Return('void')
glTexCoord2fColor4ubVertex3fvSUN.add( Input( 'tc','const GLfloat *' ,size = 2 ))
glTexCoord2fColor4ubVertex3fvSUN.add( Input( 'c','const GLubyte *' ,size = 4 ))
glTexCoord2fColor4ubVertex3fvSUN.add( Input( 'v','const GLfloat *' ,size = 3 ))
glTexCoord2fColor4ubVertex3fvSUN.version = '1.1'
glTexCoord2fColor4ubVertex3fvSUN.category = 'GL_SUN_vertex'
glTexCoord2fColor4ubVertex3fvSUN.trace = True
glTexCoord2fColor4ubVertex3fvSUN.play = True
gl.add(glTexCoord2fColor4ubVertex3fvSUN)

glTexCoord2fNormal3fVertex3fSUN = Function('glTexCoord2fNormal3fVertex3fSUN')
glTexCoord2fNormal3fVertex3fSUN.ret = Return('void')
glTexCoord2fNormal3fVertex3fSUN.add( Input( 's','GLfloat' ))
glTexCoord2fNormal3fVertex3fSUN.add( Input( 't','GLfloat' ))
glTexCoord2fNormal3fVertex3fSUN.add( Input( 'nx','GLfloat' ))
glTexCoord2fNormal3fVertex3fSUN.add( Input( 'ny','GLfloat' ))
glTexCoord2fNormal3fVertex3fSUN.add( Input( 'nz','GLfloat' ))
glTexCoord2fNormal3fVertex3fSUN.add( Input( 'x','GLfloat' ))
glTexCoord2fNormal3fVertex3fSUN.add( Input( 'y','GLfloat' ))
glTexCoord2fNormal3fVertex3fSUN.add( Input( 'z','GLfloat' ))
glTexCoord2fNormal3fVertex3fSUN.version = '1.1'
glTexCoord2fNormal3fVertex3fSUN.category = 'GL_SUN_vertex'
glTexCoord2fNormal3fVertex3fSUN.trace = True
glTexCoord2fNormal3fVertex3fSUN.play = True
gl.add(glTexCoord2fNormal3fVertex3fSUN)

glTexCoord2fNormal3fVertex3fvSUN = Function('glTexCoord2fNormal3fVertex3fvSUN')
glTexCoord2fNormal3fVertex3fvSUN.ret = Return('void')
glTexCoord2fNormal3fVertex3fvSUN.add( Input( 'tc','const GLfloat *' ,size = 2 ))
glTexCoord2fNormal3fVertex3fvSUN.add( Input( 'n','const GLfloat *' ,size = 3 ))
glTexCoord2fNormal3fVertex3fvSUN.add( Input( 'v','const GLfloat *' ,size = 3 ))
glTexCoord2fNormal3fVertex3fvSUN.version = '1.1'
glTexCoord2fNormal3fVertex3fvSUN.category = 'GL_SUN_vertex'
glTexCoord2fNormal3fVertex3fvSUN.trace = True
glTexCoord2fNormal3fVertex3fvSUN.play = True
gl.add(glTexCoord2fNormal3fVertex3fvSUN)

glTexCoord2fVertex3fSUN = Function('glTexCoord2fVertex3fSUN')
glTexCoord2fVertex3fSUN.ret = Return('void')
glTexCoord2fVertex3fSUN.add( Input( 's','GLfloat' ))
glTexCoord2fVertex3fSUN.add( Input( 't','GLfloat' ))
glTexCoord2fVertex3fSUN.add( Input( 'x','GLfloat' ))
glTexCoord2fVertex3fSUN.add( Input( 'y','GLfloat' ))
glTexCoord2fVertex3fSUN.add( Input( 'z','GLfloat' ))
glTexCoord2fVertex3fSUN.version = '1.1'
glTexCoord2fVertex3fSUN.category = 'GL_SUN_vertex'
glTexCoord2fVertex3fSUN.trace = True
glTexCoord2fVertex3fSUN.play = True
gl.add(glTexCoord2fVertex3fSUN)

glTexCoord2fVertex3fvSUN = Function('glTexCoord2fVertex3fvSUN')
glTexCoord2fVertex3fvSUN.ret = Return('void')
glTexCoord2fVertex3fvSUN.add( Input( 'tc','const GLfloat *' ,size = 2 ))
glTexCoord2fVertex3fvSUN.add( Input( 'v','const GLfloat *' ,size = 3 ))
glTexCoord2fVertex3fvSUN.version = '1.1'
glTexCoord2fVertex3fvSUN.category = 'GL_SUN_vertex'
glTexCoord2fVertex3fvSUN.trace = True
glTexCoord2fVertex3fvSUN.play = True
gl.add(glTexCoord2fVertex3fvSUN)

glTexCoord4fColor4fNormal3fVertex4fSUN = Function('glTexCoord4fColor4fNormal3fVertex4fSUN')
glTexCoord4fColor4fNormal3fVertex4fSUN.ret = Return('void')
glTexCoord4fColor4fNormal3fVertex4fSUN.add( Input( 's','GLfloat' ))
glTexCoord4fColor4fNormal3fVertex4fSUN.add( Input( 't','GLfloat' ))
glTexCoord4fColor4fNormal3fVertex4fSUN.add( Input( 'p','GLfloat' ))
glTexCoord4fColor4fNormal3fVertex4fSUN.add( Input( 'q','GLfloat' ))
glTexCoord4fColor4fNormal3fVertex4fSUN.add( Input( 'r','GLfloat' ))
glTexCoord4fColor4fNormal3fVertex4fSUN.add( Input( 'g','GLfloat' ))
glTexCoord4fColor4fNormal3fVertex4fSUN.add( Input( 'b','GLfloat' ))
glTexCoord4fColor4fNormal3fVertex4fSUN.add( Input( 'a','GLfloat' ))
glTexCoord4fColor4fNormal3fVertex4fSUN.add( Input( 'nx','GLfloat' ))
glTexCoord4fColor4fNormal3fVertex4fSUN.add( Input( 'ny','GLfloat' ))
glTexCoord4fColor4fNormal3fVertex4fSUN.add( Input( 'nz','GLfloat' ))
glTexCoord4fColor4fNormal3fVertex4fSUN.add( Input( 'x','GLfloat' ))
glTexCoord4fColor4fNormal3fVertex4fSUN.add( Input( 'y','GLfloat' ))
glTexCoord4fColor4fNormal3fVertex4fSUN.add( Input( 'z','GLfloat' ))
glTexCoord4fColor4fNormal3fVertex4fSUN.add( Input( 'w','GLfloat' ))
glTexCoord4fColor4fNormal3fVertex4fSUN.version = '1.1'
glTexCoord4fColor4fNormal3fVertex4fSUN.category = 'GL_SUN_vertex'
glTexCoord4fColor4fNormal3fVertex4fSUN.trace = True
glTexCoord4fColor4fNormal3fVertex4fSUN.play = True
gl.add(glTexCoord4fColor4fNormal3fVertex4fSUN)

glTexCoord4fColor4fNormal3fVertex4fvSUN = Function('glTexCoord4fColor4fNormal3fVertex4fvSUN')
glTexCoord4fColor4fNormal3fVertex4fvSUN.ret = Return('void')
glTexCoord4fColor4fNormal3fVertex4fvSUN.add( Input( 'tc','const GLfloat *' ,size = 4 ))
glTexCoord4fColor4fNormal3fVertex4fvSUN.add( Input( 'c','const GLfloat *' ,size = 4 ))
glTexCoord4fColor4fNormal3fVertex4fvSUN.add( Input( 'n','const GLfloat *' ,size = 3 ))
glTexCoord4fColor4fNormal3fVertex4fvSUN.add( Input( 'v','const GLfloat *' ,size = 4 ))
glTexCoord4fColor4fNormal3fVertex4fvSUN.version = '1.1'
glTexCoord4fColor4fNormal3fVertex4fvSUN.category = 'GL_SUN_vertex'
glTexCoord4fColor4fNormal3fVertex4fvSUN.trace = True
glTexCoord4fColor4fNormal3fVertex4fvSUN.play = True
gl.add(glTexCoord4fColor4fNormal3fVertex4fvSUN)

glTexCoord4fVertex4fSUN = Function('glTexCoord4fVertex4fSUN')
glTexCoord4fVertex4fSUN.ret = Return('void')
glTexCoord4fVertex4fSUN.add( Input( 's','GLfloat' ))
glTexCoord4fVertex4fSUN.add( Input( 't','GLfloat' ))
glTexCoord4fVertex4fSUN.add( Input( 'p','GLfloat' ))
glTexCoord4fVertex4fSUN.add( Input( 'q','GLfloat' ))
glTexCoord4fVertex4fSUN.add( Input( 'x','GLfloat' ))
glTexCoord4fVertex4fSUN.add( Input( 'y','GLfloat' ))
glTexCoord4fVertex4fSUN.add( Input( 'z','GLfloat' ))
glTexCoord4fVertex4fSUN.add( Input( 'w','GLfloat' ))
glTexCoord4fVertex4fSUN.version = '1.1'
glTexCoord4fVertex4fSUN.category = 'GL_SUN_vertex'
glTexCoord4fVertex4fSUN.trace = True
glTexCoord4fVertex4fSUN.play = True
gl.add(glTexCoord4fVertex4fSUN)

glTexCoord4fVertex4fvSUN = Function('glTexCoord4fVertex4fvSUN')
glTexCoord4fVertex4fvSUN.ret = Return('void')
glTexCoord4fVertex4fvSUN.add( Input( 'tc','const GLfloat *' ,size = 4 ))
glTexCoord4fVertex4fvSUN.add( Input( 'v','const GLfloat *' ,size = 4 ))
glTexCoord4fVertex4fvSUN.version = '1.1'
glTexCoord4fVertex4fvSUN.category = 'GL_SUN_vertex'
glTexCoord4fVertex4fvSUN.trace = True
glTexCoord4fVertex4fvSUN.play = True
gl.add(glTexCoord4fVertex4fvSUN)

# GL_WIN_swap_hint

glAddSwapHintRectWIN = Function('glAddSwapHintRectWIN')
glAddSwapHintRectWIN.ret = Return('void')
glAddSwapHintRectWIN.add( Input( 'x','GLint' ))
glAddSwapHintRectWIN.add( Input( 'y','GLint' ))
glAddSwapHintRectWIN.add( Input( 'width','GLsizei' ))
glAddSwapHintRectWIN.add( Input( 'height','GLsizei' ))
glAddSwapHintRectWIN.version = '1.1'
glAddSwapHintRectWIN.category = 'GL_WIN_swap_hint'
glAddSwapHintRectWIN.trace = True
glAddSwapHintRectWIN.play = True
gl.add(glAddSwapHintRectWIN)

GL_3DFX_multisample = Extension('GL_3DFX_multisample')
GL_3DFX_multisample.url = 'http://www.opengl.org/registry/specs/3DFX/3dfx_multisample.txt'
GL_3DFX_multisample.enumerants = ['GL_MULTISAMPLE_3DFX','GL_MULTISAMPLE_BIT_3DFX','GL_SAMPLES_3DFX','GL_SAMPLE_BUFFERS_3DFX']
gl.add(GL_3DFX_multisample)

GL_3DFX_tbuffer = Extension('GL_3DFX_tbuffer')
GL_3DFX_tbuffer.url = 'http://www.opengl.org/registry/specs/3DFX/tbuffer.txt'
GL_3DFX_tbuffer.functions = ['glTbufferMask3DFX']
gl.add(GL_3DFX_tbuffer)

GL_3DFX_texture_compression_FXT1 = Extension('GL_3DFX_texture_compression_FXT1')
GL_3DFX_texture_compression_FXT1.url = 'http://www.opengl.org/registry/specs/3DFX/texture_compression_FXT1.txt'
GL_3DFX_texture_compression_FXT1.enumerants = ['GL_COMPRESSED_RGBA_FXT1_3DFX','GL_COMPRESSED_RGB_FXT1_3DFX']
gl.add(GL_3DFX_texture_compression_FXT1)

GL_AMD_blend_minmax_factor = Extension('GL_AMD_blend_minmax_factor')
GL_AMD_blend_minmax_factor.url = 'http://www.opengl.org/registry/specs/AMD/blend_minmax_factor.txt'
GL_AMD_blend_minmax_factor.enumerants = ['GL_FACTOR_MAX_AMD','GL_FACTOR_MIN_AMD']
gl.add(GL_AMD_blend_minmax_factor)

GL_AMD_conservative_depth = Extension('GL_AMD_conservative_depth')
GL_AMD_conservative_depth.url = 'http://www.opengl.org/registry/specs/AMD/conservative_depth.txt'
gl.add(GL_AMD_conservative_depth)

GL_AMD_debug_output = Extension('GL_AMD_debug_output')
GL_AMD_debug_output.url = 'http://www.opengl.org/registry/specs/AMD/debug_output.txt'
GL_AMD_debug_output.enumerants = ['GL_DEBUG_CATEGORY_API_ERROR_AMD','GL_DEBUG_CATEGORY_APPLICATION_AMD','GL_DEBUG_CATEGORY_DEPRECATION_AMD','GL_DEBUG_CATEGORY_OTHER_AMD','GL_DEBUG_CATEGORY_PERFORMANCE_AMD','GL_DEBUG_CATEGORY_SHADER_COMPILER_AMD','GL_DEBUG_CATEGORY_UNDEFINED_BEHAVIOR_AMD','GL_DEBUG_CATEGORY_WINDOW_SYSTEM_AMD','GL_DEBUG_LOGGED_MESSAGES_AMD','GL_DEBUG_SEVERITY_HIGH_AMD','GL_DEBUG_SEVERITY_LOW_AMD','GL_DEBUG_SEVERITY_MEDIUM_AMD','GL_MAX_DEBUG_LOGGED_MESSAGES_AMD','GL_MAX_DEBUG_MESSAGE_LENGTH_AMD']
GL_AMD_debug_output.functions = ['glGetDebugMessageLogAMD','glDebugMessageCallbackAMD','glDebugMessageEnableAMD','glDebugMessageInsertAMD']
gl.add(GL_AMD_debug_output)

GL_AMD_depth_clamp_separate = Extension('GL_AMD_depth_clamp_separate')
GL_AMD_depth_clamp_separate.url = 'http://www.opengl.org/registry/specs/AMD/depth_clamp_separate.txt'
GL_AMD_depth_clamp_separate.enumerants = ['GL_DEPTH_CLAMP_FAR_AMD','GL_DEPTH_CLAMP_NEAR_AMD']
gl.add(GL_AMD_depth_clamp_separate)

GL_AMD_draw_buffers_blend = Extension('GL_AMD_draw_buffers_blend')
GL_AMD_draw_buffers_blend.url = 'http://www.opengl.org/registry/specs/AMD/draw_buffers_blend.txt'
GL_AMD_draw_buffers_blend.functions = ['glBlendEquationIndexedAMD','glBlendEquationSeparateIndexedAMD','glBlendFuncIndexedAMD','glBlendFuncSeparateIndexedAMD']
gl.add(GL_AMD_draw_buffers_blend)

GL_AMD_interleaved_elements = Extension('GL_AMD_interleaved_elements')
GL_AMD_interleaved_elements.url = 'http://www.opengl.org/registry/specs/AMD/interleaved_elements.txt'
GL_AMD_interleaved_elements.enumerants = ['GL_VERTEX_ELEMENT_SWIZZLE_AMD','GL_VERTEX_ID_SWIZZLE_AMD']
GL_AMD_interleaved_elements.functions = ['glVertexAttribParameteriAMD']
gl.add(GL_AMD_interleaved_elements)

GL_AMD_multi_draw_indirect = Extension('GL_AMD_multi_draw_indirect')
GL_AMD_multi_draw_indirect.url = 'http://www.opengl.org/registry/specs/AMD/multi_draw_indirect.txt'
GL_AMD_multi_draw_indirect.functions = ['glMultiDrawArraysIndirectAMD','glMultiDrawElementsIndirectAMD']
gl.add(GL_AMD_multi_draw_indirect)

GL_AMD_name_gen_delete = Extension('GL_AMD_name_gen_delete')
GL_AMD_name_gen_delete.url = 'http://www.opengl.org/registry/specs/AMD/name_gen_delete.txt'
GL_AMD_name_gen_delete.enumerants = ['GL_DATA_BUFFER_AMD','GL_PERFORMANCE_MONITOR_AMD','GL_QUERY_OBJECT_AMD','GL_SAMPLER_OBJECT_AMD','GL_VERTEX_ARRAY_OBJECT_AMD']
GL_AMD_name_gen_delete.functions = ['glIsNameAMD','glDeleteNamesAMD','glGenNamesAMD']
gl.add(GL_AMD_name_gen_delete)

GL_AMD_performance_monitor = Extension('GL_AMD_performance_monitor')
GL_AMD_performance_monitor.url = 'http://www.opengl.org/registry/specs/AMD/performance_monitor.txt'
GL_AMD_performance_monitor.enumerants = ['GL_COUNTER_RANGE_AMD','GL_COUNTER_TYPE_AMD','GL_PERCENTAGE_AMD','GL_PERFMON_RESULT_AMD','GL_PERFMON_RESULT_AVAILABLE_AMD','GL_PERFMON_RESULT_SIZE_AMD','GL_UNSIGNED_INT64_AMD']
GL_AMD_performance_monitor.functions = ['glBeginPerfMonitorAMD','glDeletePerfMonitorsAMD','glEndPerfMonitorAMD','glGenPerfMonitorsAMD','glGetPerfMonitorCounterDataAMD','glGetPerfMonitorCounterInfoAMD','glGetPerfMonitorCounterStringAMD','glGetPerfMonitorCountersAMD','glGetPerfMonitorGroupStringAMD','glGetPerfMonitorGroupsAMD','glSelectPerfMonitorCountersAMD']
gl.add(GL_AMD_performance_monitor)

GL_AMD_pinned_memory = Extension('GL_AMD_pinned_memory')
GL_AMD_pinned_memory.url = 'http://www.opengl.org/registry/specs/AMD/pinned_memory.txt'
GL_AMD_pinned_memory.enumerants = ['GL_EXTERNAL_VIRTUAL_MEMORY_BUFFER_AMD']
gl.add(GL_AMD_pinned_memory)

GL_AMD_query_buffer_object = Extension('GL_AMD_query_buffer_object')
GL_AMD_query_buffer_object.url = 'http://www.opengl.org/registry/specs/AMD/query_buffer_object.txt'
GL_AMD_query_buffer_object.enumerants = ['GL_QUERY_BUFFER_AMD','GL_QUERY_BUFFER_BINDING_AMD','GL_QUERY_RESULT_NO_WAIT_AMD']
gl.add(GL_AMD_query_buffer_object)

GL_AMD_sample_positions = Extension('GL_AMD_sample_positions')
GL_AMD_sample_positions.url = 'http://www.opengl.org/registry/specs/AMD/sample_positions.txt'
GL_AMD_sample_positions.enumerants = ['GL_SUBSAMPLE_DISTANCE_AMD']
GL_AMD_sample_positions.functions = ['glSetMultisamplefvAMD']
gl.add(GL_AMD_sample_positions)

GL_AMD_seamless_cubemap_per_texture = Extension('GL_AMD_seamless_cubemap_per_texture')
GL_AMD_seamless_cubemap_per_texture.url = 'http://www.opengl.org/registry/specs/AMD/seamless_cubemap_per_texture.txt'
GL_AMD_seamless_cubemap_per_texture.enumerants = ['GL_TEXTURE_CUBE_MAP_SEAMLESS_ARB']
gl.add(GL_AMD_seamless_cubemap_per_texture)

GL_AMD_seamless_cubemap_per_texture = Extension('GL_AMD_seamless_cubemap_per_texture')
GL_AMD_seamless_cubemap_per_texture.category = 'GL_AMD_seamless_cubemap_per_texture'
gl.add(GL_AMD_seamless_cubemap_per_texture)

GL_AMD_shader_stencil_export = Extension('GL_AMD_shader_stencil_export')
GL_AMD_shader_stencil_export.url = 'http://www.opengl.org/registry/specs/AMD/shader_stencil_export.txt'
gl.add(GL_AMD_shader_stencil_export)

GL_AMD_shader_trinary_minmax = Extension('GL_AMD_shader_trinary_minmax')
GL_AMD_shader_trinary_minmax.url = 'http://www.opengl.org/registry/specs/AMD/shader_trinary_minmax.txt'
gl.add(GL_AMD_shader_trinary_minmax)

GL_AMD_sparse_texture = Extension('GL_AMD_sparse_texture')
GL_AMD_sparse_texture.url = 'http://www.opengl.org/registry/specs/AMD/sparse_texture.txt'
GL_AMD_sparse_texture.enumerants = ['GL_MAX_SPARSE_3D_TEXTURE_SIZE_AMD','GL_MAX_SPARSE_ARRAY_TEXTURE_LAYERS','GL_MAX_SPARSE_ARRAY_TEXTURE_LAYERS','GL_MAX_SPARSE_TEXTURE_SIZE_AMD','GL_MIN_LOD_WARNING_AMD','GL_MIN_SPARSE_LEVEL_AMD','GL_TEXTURE_STORAGE_SPARSE_BIT_AMD','GL_VIRTUAL_PAGE_SIZE_X_AMD','GL_VIRTUAL_PAGE_SIZE_Y_AMD','GL_VIRTUAL_PAGE_SIZE_Z_AMD']
GL_AMD_sparse_texture.functions = ['glTexStorageSparseAMD','glTextureStorageSparseAMD']
gl.add(GL_AMD_sparse_texture)

GL_AMD_stencil_operation_extended = Extension('GL_AMD_stencil_operation_extended')
GL_AMD_stencil_operation_extended.url = 'http://www.opengl.org/registry/specs/AMD/stencil_operation_extended.txt'
GL_AMD_stencil_operation_extended.enumerants = ['GL_REPLACE_VALUE_AMD','GL_SET_AMD','GL_STENCIL_BACK_OP_VALUE_AMD','GL_STENCIL_OP_VALUE_AMD']
GL_AMD_stencil_operation_extended.functions = ['glStencilOpValueAMD']
gl.add(GL_AMD_stencil_operation_extended)

GL_AMD_texture_texture4 = Extension('GL_AMD_texture_texture4')
GL_AMD_texture_texture4.url = 'http://www.opengl.org/registry/specs/AMD/texture_texture4.txt'
gl.add(GL_AMD_texture_texture4)

GL_AMD_transform_feedback3_lines_triangles = Extension('GL_AMD_transform_feedback3_lines_triangles')
GL_AMD_transform_feedback3_lines_triangles.url = 'http://www.opengl.org/registry/specs/AMD/transform_feedback3_lines_triangles.txt'
gl.add(GL_AMD_transform_feedback3_lines_triangles)

GL_AMD_vertex_shader_layer = Extension('GL_AMD_vertex_shader_layer')
GL_AMD_vertex_shader_layer.url = 'http://www.opengl.org/registry/specs/AMD/vertex_shader_layer.txt'
gl.add(GL_AMD_vertex_shader_layer)

GL_AMD_vertex_shader_tessellator = Extension('GL_AMD_vertex_shader_tessellator')
GL_AMD_vertex_shader_tessellator.url = 'http://www.opengl.org/registry/specs/AMD/vertex_shader_tessellator.txt'
GL_AMD_vertex_shader_tessellator.enumerants = ['GL_CONTINUOUS_AMD','GL_DISCRETE_AMD','GL_INT_SAMPLER_BUFFER_AMD','GL_SAMPLER_BUFFER_AMD','GL_TESSELLATION_FACTOR_AMD','GL_TESSELLATION_MODE_AMD','GL_UNSIGNED_INT_SAMPLER_BUFFER_AMD']
GL_AMD_vertex_shader_tessellator.functions = ['glTessellationFactorAMD','glTessellationModeAMD']
gl.add(GL_AMD_vertex_shader_tessellator)

GL_AMD_vertex_shader_viewport_index = Extension('GL_AMD_vertex_shader_viewport_index')
GL_AMD_vertex_shader_viewport_index.url = 'http://www.opengl.org/registry/specs/AMD/vertex_shader_viewport_index.txt'
gl.add(GL_AMD_vertex_shader_viewport_index)

GL_APPLE_aux_depth_stencil = Extension('GL_APPLE_aux_depth_stencil')
GL_APPLE_aux_depth_stencil.url = 'http://www.opengl.org/registry/specs/APPLE/aux_depth_stencil.txt'
GL_APPLE_aux_depth_stencil.enumerants = ['GL_AUX_DEPTH_STENCIL_APPLE']
gl.add(GL_APPLE_aux_depth_stencil)

GL_APPLE_client_storage = Extension('GL_APPLE_client_storage')
GL_APPLE_client_storage.url = 'http://www.opengl.org/registry/specs/APPLE/client_storage.txt'
GL_APPLE_client_storage.enumerants = ['GL_UNPACK_CLIENT_STORAGE_APPLE']
gl.add(GL_APPLE_client_storage)

GL_APPLE_element_array = Extension('GL_APPLE_element_array')
GL_APPLE_element_array.url = 'http://www.opengl.org/registry/specs/APPLE/element_array.txt'
GL_APPLE_element_array.enumerants = ['GL_ELEMENT_ARRAY_APPLE','GL_ELEMENT_ARRAY_POINTER_APPLE','GL_ELEMENT_ARRAY_TYPE_APPLE']
GL_APPLE_element_array.functions = ['glDrawElementArrayAPPLE','glDrawRangeElementArrayAPPLE','glElementPointerAPPLE','glMultiDrawElementArrayAPPLE','glMultiDrawRangeElementArrayAPPLE']
gl.add(GL_APPLE_element_array)

GL_APPLE_fence = Extension('GL_APPLE_fence')
GL_APPLE_fence.url = 'http://www.opengl.org/registry/specs/APPLE/fence.txt'
GL_APPLE_fence.enumerants = ['GL_DRAW_PIXELS_APPLE','GL_FENCE_APPLE']
GL_APPLE_fence.functions = ['glIsFenceAPPLE','glTestFenceAPPLE','glTestObjectAPPLE','glDeleteFencesAPPLE','glFinishFenceAPPLE','glFinishObjectAPPLE','glGenFencesAPPLE','glSetFenceAPPLE']
gl.add(GL_APPLE_fence)

GL_APPLE_float_pixels = Extension('GL_APPLE_float_pixels')
GL_APPLE_float_pixels.url = 'http://www.opengl.org/registry/specs/APPLE/float_pixels.txt'
GL_APPLE_float_pixels.enumerants = ['GL_ALPHA_FLOAT16_APPLE','GL_ALPHA_FLOAT32_APPLE','GL_COLOR_FLOAT_APPLE','GL_HALF_APPLE','GL_INTENSITY_FLOAT16_APPLE','GL_INTENSITY_FLOAT32_APPLE','GL_LUMINANCE_ALPHA_FLOAT16_APPLE','GL_LUMINANCE_ALPHA_FLOAT32_APPLE','GL_LUMINANCE_FLOAT16_APPLE','GL_LUMINANCE_FLOAT32_APPLE','GL_RGBA_FLOAT16_APPLE','GL_RGBA_FLOAT32_APPLE','GL_RGB_FLOAT16_APPLE','GL_RGB_FLOAT32_APPLE']
gl.add(GL_APPLE_float_pixels)

GL_APPLE_flush_buffer_range = Extension('GL_APPLE_flush_buffer_range')
GL_APPLE_flush_buffer_range.url = 'http://www.opengl.org/registry/specs/APPLE/flush_buffer_range.txt'
GL_APPLE_flush_buffer_range.enumerants = ['GL_BUFFER_FLUSHING_UNMAP_APPLE','GL_BUFFER_SERIALIZED_MODIFY_APPLE']
GL_APPLE_flush_buffer_range.functions = ['glBufferParameteriAPPLE','glFlushMappedBufferRangeAPPLE']
gl.add(GL_APPLE_flush_buffer_range)

GL_APPLE_object_purgeable = Extension('GL_APPLE_object_purgeable')
GL_APPLE_object_purgeable.url = 'http://www.opengl.org/registry/specs/APPLE/object_purgeable.txt'
GL_APPLE_object_purgeable.enumerants = ['GL_BUFFER_OBJECT_APPLE','GL_PURGEABLE_APPLE','GL_RELEASED_APPLE','GL_RETAINED_APPLE','GL_UNDEFINED_APPLE','GL_VOLATILE_APPLE']
GL_APPLE_object_purgeable.functions = ['glObjectPurgeableAPPLE','glObjectUnpurgeableAPPLE','glGetObjectParameterivAPPLE']
gl.add(GL_APPLE_object_purgeable)

GL_APPLE_pixel_buffer = Extension('GL_APPLE_pixel_buffer')
GL_APPLE_pixel_buffer.enumerants = ['GL_MIN_PBUFFER_VIEWPORT_DIMS_APPLE']
gl.add(GL_APPLE_pixel_buffer)

GL_APPLE_rgb_422 = Extension('GL_APPLE_rgb_422')
GL_APPLE_rgb_422.url = 'http://www.opengl.org/registry/specs/APPLE/rgb_422.txt'
GL_APPLE_rgb_422.enumerants = ['GL_RGB_422_APPLE','GL_UNSIGNED_SHORT_8_8_APPLE','GL_UNSIGNED_SHORT_8_8_REV_APPLE']
gl.add(GL_APPLE_rgb_422)

GL_APPLE_row_bytes = Extension('GL_APPLE_row_bytes')
GL_APPLE_row_bytes.url = 'http://www.opengl.org/registry/specs/APPLE/row_bytes.txt'
GL_APPLE_row_bytes.enumerants = ['GL_PACK_ROW_BYTES_APPLE','GL_UNPACK_ROW_BYTES_APPLE']
gl.add(GL_APPLE_row_bytes)

GL_APPLE_specular_vector = Extension('GL_APPLE_specular_vector')
GL_APPLE_specular_vector.url = 'http://www.opengl.org/registry/specs/APPLE/specular_vector.txt'
GL_APPLE_specular_vector.enumerants = ['GL_LIGHT_MODEL_SPECULAR_VECTOR_APPLE']
gl.add(GL_APPLE_specular_vector)

GL_APPLE_texture_range = Extension('GL_APPLE_texture_range')
GL_APPLE_texture_range.url = 'http://www.opengl.org/registry/specs/APPLE/texture_range.txt'
GL_APPLE_texture_range.enumerants = ['GL_STORAGE_CACHED_APPLE','GL_STORAGE_PRIVATE_APPLE','GL_STORAGE_SHARED_APPLE','GL_TEXTURE_RANGE_LENGTH_APPLE','GL_TEXTURE_RANGE_POINTER_APPLE','GL_TEXTURE_STORAGE_HINT_APPLE']
GL_APPLE_texture_range.functions = ['glGetTexParameterPointervAPPLE','glTextureRangeAPPLE']
gl.add(GL_APPLE_texture_range)

GL_APPLE_transform_hint = Extension('GL_APPLE_transform_hint')
GL_APPLE_transform_hint.url = 'http://www.opengl.org/registry/specs/APPLE/transform_hint.txt'
GL_APPLE_transform_hint.enumerants = ['GL_TRANSFORM_HINT_APPLE']
gl.add(GL_APPLE_transform_hint)

GL_APPLE_vertex_array_object = Extension('GL_APPLE_vertex_array_object')
GL_APPLE_vertex_array_object.url = 'http://www.opengl.org/registry/specs/APPLE/vertex_array_object.txt'
GL_APPLE_vertex_array_object.enumerants = ['GL_VERTEX_ARRAY_BINDING_APPLE']
GL_APPLE_vertex_array_object.functions = ['glIsVertexArrayAPPLE','glBindVertexArrayAPPLE','glDeleteVertexArraysAPPLE','glGenVertexArraysAPPLE']
gl.add(GL_APPLE_vertex_array_object)

GL_APPLE_vertex_array_range = Extension('GL_APPLE_vertex_array_range')
GL_APPLE_vertex_array_range.url = 'http://www.opengl.org/registry/specs/APPLE/vertex_array_range.txt'
GL_APPLE_vertex_array_range.enumerants = ['GL_MAX_VERTEX_ARRAY_RANGE_ELEMENT_APPLE','GL_STORAGE_CACHED_APPLE','GL_STORAGE_CLIENT_APPLE','GL_STORAGE_SHARED_APPLE','GL_VERTEX_ARRAY_RANGE_APPLE','GL_VERTEX_ARRAY_RANGE_LENGTH_APPLE','GL_VERTEX_ARRAY_RANGE_POINTER_APPLE','GL_VERTEX_ARRAY_STORAGE_HINT_APPLE']
GL_APPLE_vertex_array_range.functions = ['glFlushVertexArrayRangeAPPLE','glVertexArrayParameteriAPPLE','glVertexArrayRangeAPPLE']
gl.add(GL_APPLE_vertex_array_range)

GL_APPLE_vertex_program_evaluators = Extension('GL_APPLE_vertex_program_evaluators')
GL_APPLE_vertex_program_evaluators.url = 'http://www.opengl.org/registry/specs/APPLE/vertex_program_evaluators.txt'
GL_APPLE_vertex_program_evaluators.enumerants = ['GL_VERTEX_ATTRIB_MAP1_APPLE','GL_VERTEX_ATTRIB_MAP1_COEFF_APPLE','GL_VERTEX_ATTRIB_MAP1_DOMAIN_APPLE','GL_VERTEX_ATTRIB_MAP1_ORDER_APPLE','GL_VERTEX_ATTRIB_MAP1_SIZE_APPLE','GL_VERTEX_ATTRIB_MAP2_APPLE','GL_VERTEX_ATTRIB_MAP2_COEFF_APPLE','GL_VERTEX_ATTRIB_MAP2_DOMAIN_APPLE','GL_VERTEX_ATTRIB_MAP2_ORDER_APPLE','GL_VERTEX_ATTRIB_MAP2_SIZE_APPLE']
GL_APPLE_vertex_program_evaluators.functions = ['glIsVertexAttribEnabledAPPLE','glDisableVertexAttribAPPLE','glEnableVertexAttribAPPLE','glMapVertexAttrib1dAPPLE','glMapVertexAttrib1fAPPLE','glMapVertexAttrib2dAPPLE','glMapVertexAttrib2fAPPLE']
gl.add(GL_APPLE_vertex_program_evaluators)

GL_APPLE_ycbcr_422 = Extension('GL_APPLE_ycbcr_422')
GL_APPLE_ycbcr_422.url = 'http://www.opengl.org/registry/specs/APPLE/ycbcr_422.txt'
GL_APPLE_ycbcr_422.enumerants = ['GL_YCBCR_422_APPLE']
gl.add(GL_APPLE_ycbcr_422)

GL_ARB_ES2_compatibility = Extension('GL_ARB_ES2_compatibility')
GL_ARB_ES2_compatibility.url = 'http://www.opengl.org/registry/specs/ARB/ES2_compatibility.txt'
GL_ARB_ES2_compatibility.enumerants = ['GL_FIXED','GL_HIGH_FLOAT','GL_HIGH_INT','GL_IMPLEMENTATION_COLOR_READ_FORMAT','GL_IMPLEMENTATION_COLOR_READ_TYPE','GL_LOW_FLOAT','GL_LOW_INT','GL_MAX_FRAGMENT_UNIFORM_VECTORS','GL_MAX_VARYING_VECTORS','GL_MAX_VERTEX_UNIFORM_VECTORS','GL_MEDIUM_FLOAT','GL_MEDIUM_INT','GL_NUM_SHADER_BINARY_FORMATS','GL_RGB565','GL_SHADER_BINARY_FORMATS','GL_SHADER_COMPILER']
GL_ARB_ES2_compatibility.functions = ['glClearDepthf','glDepthRangef','glGetShaderPrecisionFormat','glReleaseShaderCompiler','glShaderBinary']
gl.add(GL_ARB_ES2_compatibility)

GL_ARB_ES3_compatibility = Extension('GL_ARB_ES3_compatibility')
GL_ARB_ES3_compatibility.url = 'http://www.opengl.org/registry/specs/ARB/ES3_compatibility.txt'
GL_ARB_ES3_compatibility.enumerants = ['GL_ANY_SAMPLES_PASSED_CONSERVATIVE','GL_COMPRESSED_R11_EAC','GL_COMPRESSED_RG11_EAC','GL_COMPRESSED_RGB8_ETC2','GL_COMPRESSED_RGB8_PUNCHTHROUGH_ALPHA1_ETC2','GL_COMPRESSED_RGBA8_ETC2_EAC','GL_COMPRESSED_SIGNED_R11_EAC','GL_COMPRESSED_SIGNED_RG11_EAC','GL_COMPRESSED_SRGB8_ALPHA8_ETC2_EAC','GL_COMPRESSED_SRGB8_ETC2','GL_COMPRESSED_SRGB8_PUNCHTHROUGH_ALPHA1_ETC2','GL_MAX_ELEMENT_INDEX','GL_PRIMITIVE_RESTART_FIXED_INDEX','GL_TEXTURE_IMMUTABLE_LEVELS']
gl.add(GL_ARB_ES3_compatibility)

GL_ARB_arrays_of_arrays = Extension('GL_ARB_arrays_of_arrays')
GL_ARB_arrays_of_arrays.url = 'http://www.opengl.org/registry/specs/ARB/arrays_of_arrays.txt'
gl.add(GL_ARB_arrays_of_arrays)

GL_ARB_base_instance = Extension('GL_ARB_base_instance')
GL_ARB_base_instance.url = 'http://www.opengl.org/registry/specs/ARB/base_instance.txt'
GL_ARB_base_instance.functions = ['glDrawArraysInstancedBaseInstance','glDrawElementsInstancedBaseInstance','glDrawElementsInstancedBaseVertexBaseInstance']
gl.add(GL_ARB_base_instance)

GL_ARB_bindless_texture = Extension('GL_ARB_bindless_texture')
GL_ARB_bindless_texture.url = 'http://www.opengl.org/registry/specs/ARB/bindless_texture.txt'
GL_ARB_bindless_texture.enumerants = ['GL_UNSIGNED_INT64_ARB']
GL_ARB_bindless_texture.functions = ['']
gl.add(GL_ARB_bindless_texture)

GL_ARB_bindless_texture = Extension('GL_ARB_bindless_texture')
GL_ARB_bindless_texture.url = 'http://www.opengl.org/registry/specs/ARB/buffer_storage.txt'
GL_ARB_bindless_texture.enumerants = ['GL_BUFFER_IMMUTABLE_STORAGE','GL_BUFFER_STORAGE_FLAGS','GL_CLIENT_MAPPED_BUFFER_BARRIER_BIT','GL_CLIENT_STORAGE_BIT','GL_DYNAMIC_STORAGE_BIT','GL_MAP_COHERENT_BIT','GL_MAP_PERSISTENT_BIT']
GL_ARB_bindless_texture.functions = ['']
gl.add(GL_ARB_bindless_texture)

GL_ARB_blend_func_extended = Extension('GL_ARB_blend_func_extended')
GL_ARB_blend_func_extended.url = 'http://www.opengl.org/registry/specs/ARB/blend_func_extended.txt'
GL_ARB_blend_func_extended.enumerants = ['GL_MAX_DUAL_SOURCE_DRAW_BUFFERS','GL_ONE_MINUS_SRC1_ALPHA','GL_ONE_MINUS_SRC1_COLOR','GL_SRC1_COLOR']
GL_ARB_blend_func_extended.functions = ['glGetFragDataIndex','glBindFragDataLocationIndexed']
gl.add(GL_ARB_blend_func_extended)

GL_ARB_cl_event = Extension('GL_ARB_cl_event')
GL_ARB_cl_event.url = 'http://www.opengl.org/registry/specs/ARB/cl_event.txt'
GL_ARB_cl_event.enumerants = ['GL_SYNC_CL_EVENT_ARB','GL_SYNC_CL_EVENT_COMPLETE_ARB']
GL_ARB_cl_event.functions = ['glCreateSyncFromCLeventARB']
gl.add(GL_ARB_cl_event)

GL_ARB_clear_buffer_object = Extension('GL_ARB_clear_buffer_object')
GL_ARB_clear_buffer_object.url = 'http://www.opengl.org/registry/specs/ARB/clear_buffer_object.txt'
GL_ARB_clear_buffer_object.functions = ['glClearBufferData','glClearBufferSubData','glClearNamedBufferDataEXT','glClearNamedBufferSubDataEXT']
gl.add(GL_ARB_clear_buffer_object)

GL_ARB_clear_texture = Extension('GL_ARB_clear_texture')
GL_ARB_clear_texture.url = 'http://www.opengl.org/registry/specs/ARB/clear_texture.txt'
GL_ARB_clear_texture.enumerants = ['GL_CLEAR_TEXTURE']
GL_ARB_clear_texture.functions = ['glClearTexImage','glClearTexSubImage']
gl.add(GL_ARB_clear_texture)

GL_ARB_color_buffer_float = Extension('GL_ARB_color_buffer_float')
GL_ARB_color_buffer_float.url = 'http://www.opengl.org/registry/specs/ARB/color_buffer_float.txt'
GL_ARB_color_buffer_float.enumerants = ['GL_CLAMP_FRAGMENT_COLOR_ARB','GL_CLAMP_READ_COLOR_ARB','GL_CLAMP_VERTEX_COLOR_ARB','GL_FIXED_ONLY_ARB','GL_RGBA_FLOAT_MODE_ARB']
GL_ARB_color_buffer_float.functions = ['glClampColorARB']
gl.add(GL_ARB_color_buffer_float)

GL_ARB_compatibility = Extension('GL_ARB_compatibility')
GL_ARB_compatibility.url = 'http://www.opengl.org/registry/specs/ARB/compatibility.txt'
gl.add(GL_ARB_compatibility)

GL_ARB_compressed_texture_pixel_storage = Extension('GL_ARB_compressed_texture_pixel_storage')
GL_ARB_compressed_texture_pixel_storage.url = 'http://www.opengl.org/registry/specs/ARB/compressed_texture_pixel_storage.txt'
GL_ARB_compressed_texture_pixel_storage.enumerants = ['GL_PACK_COMPRESSED_BLOCK_DEPTH','GL_PACK_COMPRESSED_BLOCK_HEIGHT','GL_PACK_COMPRESSED_BLOCK_SIZE','GL_PACK_COMPRESSED_BLOCK_WIDTH','GL_UNPACK_COMPRESSED_BLOCK_DEPTH','GL_UNPACK_COMPRESSED_BLOCK_HEIGHT','GL_UNPACK_COMPRESSED_BLOCK_SIZE','GL_UNPACK_COMPRESSED_BLOCK_WIDTH']
gl.add(GL_ARB_compressed_texture_pixel_storage)

GL_ARB_compute_shader = Extension('GL_ARB_compute_shader')
GL_ARB_compute_shader.url = 'http://www.opengl.org/registry/specs/ARB/compute_shader.txt'
GL_ARB_compute_shader.enumerants = ['GL_ATOMIC_COUNTER_BUFFER_REFERENCED_BY_COMPUTE_SHADER','GL_COMPUTE_SHADER','GL_COMPUTE_SHADER_BIT','GL_COMPUTE_WORK_GROUP_SIZE','GL_DISPATCH_INDIRECT_BUFFER','GL_DISPATCH_INDIRECT_BUFFER_BINDING','GL_MAX_COMBINED_COMPUTE_UNIFORM_COMPONENTS','GL_MAX_COMPUTE_ATOMIC_COUNTERS','GL_MAX_COMPUTE_ATOMIC_COUNTER_BUFFERS','GL_MAX_COMPUTE_IMAGE_UNIFORMS','GL_MAX_COMPUTE_SHARED_MEMORY_SIZE','GL_MAX_COMPUTE_TEXTURE_IMAGE_UNITS','GL_MAX_COMPUTE_UNIFORM_BLOCKS','GL_MAX_COMPUTE_UNIFORM_COMPONENTS','GL_MAX_COMPUTE_WORK_GROUP_COUNT','GL_MAX_COMPUTE_WORK_GROUP_INVOCATIONS','GL_MAX_COMPUTE_WORK_GROUP_SIZE','GL_UNIFORM_BLOCK_REFERENCED_BY_COMPUTE_SHADER']
GL_ARB_compute_shader.functions = ['glDispatchCompute','glDispatchComputeIndirect']
gl.add(GL_ARB_compute_shader)

GL_ARB_compute_variable_group_size = Extension('GL_ARB_compute_variable_group_size')
GL_ARB_compute_variable_group_size.url = 'http://www.opengl.org/registry/specs/ARB/compute_variable_group_size.txt'
GL_ARB_compute_variable_group_size.enumerants = ['GL_MAX_COMPUTE_FIXED_GROUP_INVOCATIONS_ARB','GL_MAX_COMPUTE_FIXED_GROUP_SIZE_ARB','GL_MAX_COMPUTE_VARIABLE_GROUP_INVOCATIONS_ARB','GL_MAX_COMPUTE_VARIABLE_GROUP_SIZE_ARB']
GL_ARB_compute_variable_group_size.functions = ['']
gl.add(GL_ARB_compute_variable_group_size)

GL_ARB_conservative_depth = Extension('GL_ARB_conservative_depth')
GL_ARB_conservative_depth.url = 'http://www.opengl.org/registry/specs/ARB/conservative_depth.txt'
gl.add(GL_ARB_conservative_depth)

GL_ARB_copy_buffer = Extension('GL_ARB_copy_buffer')
GL_ARB_copy_buffer.url = 'http://www.opengl.org/registry/specs/ARB/copy_buffer.txt'
GL_ARB_copy_buffer.enumerants = ['GL_COPY_READ_BUFFER','GL_COPY_WRITE_BUFFER']
GL_ARB_copy_buffer.functions = ['glCopyBufferSubData']
gl.add(GL_ARB_copy_buffer)

GL_ARB_copy_image = Extension('GL_ARB_copy_image')
GL_ARB_copy_image.url = 'http://www.opengl.org/registry/specs/ARB/copy_image.txt'
GL_ARB_copy_image.functions = ['glCopyImageSubData']
gl.add(GL_ARB_copy_image)

GL_ARB_debug_output = Extension('GL_ARB_debug_output')
GL_ARB_debug_output.url = 'http://www.opengl.org/registry/specs/ARB/debug_output.txt'
GL_ARB_debug_output.enumerants = ['GL_DEBUG_CALLBACK_FUNCTION_ARB','GL_DEBUG_CALLBACK_USER_PARAM_ARB','GL_DEBUG_LOGGED_MESSAGES_ARB','GL_DEBUG_NEXT_LOGGED_MESSAGE_LENGTH_ARB','GL_DEBUG_OUTPUT_SYNCHRONOUS_ARB','GL_DEBUG_SEVERITY_HIGH_ARB','GL_DEBUG_SEVERITY_LOW_ARB','GL_DEBUG_SEVERITY_MEDIUM_ARB','GL_DEBUG_SOURCE_API_ARB','GL_DEBUG_SOURCE_APPLICATION_ARB','GL_DEBUG_SOURCE_OTHER_ARB','GL_DEBUG_SOURCE_SHADER_COMPILER_ARB','GL_DEBUG_SOURCE_THIRD_PARTY_ARB','GL_DEBUG_SOURCE_WINDOW_SYSTEM_ARB','GL_DEBUG_TYPE_DEPRECATED_BEHAVIOR_ARB','GL_DEBUG_TYPE_ERROR_ARB','GL_DEBUG_TYPE_OTHER_ARB','GL_DEBUG_TYPE_PERFORMANCE_ARB','GL_DEBUG_TYPE_PORTABILITY_ARB','GL_DEBUG_TYPE_UNDEFINED_BEHAVIOR_ARB','GL_MAX_DEBUG_LOGGED_MESSAGES_ARB','GL_MAX_DEBUG_MESSAGE_LENGTH_ARB']
GL_ARB_debug_output.functions = ['glGetDebugMessageLogARB','glDebugMessageCallbackARB','glDebugMessageControlARB','glDebugMessageInsertARB']
gl.add(GL_ARB_debug_output)

GL_ARB_depth_buffer_float = Extension('GL_ARB_depth_buffer_float')
GL_ARB_depth_buffer_float.url = 'http://www.opengl.org/registry/specs/ARB/depth_buffer_float.txt'
GL_ARB_depth_buffer_float.enumerants = ['GL_DEPTH32F_STENCIL8','GL_DEPTH_COMPONENT32F','GL_FLOAT_32_UNSIGNED_INT_24_8_REV']
gl.add(GL_ARB_depth_buffer_float)

GL_ARB_depth_clamp = Extension('GL_ARB_depth_clamp')
GL_ARB_depth_clamp.url = 'http://www.opengl.org/registry/specs/ARB/depth_clamp.txt'
GL_ARB_depth_clamp.enumerants = ['GL_DEPTH_CLAMP']
gl.add(GL_ARB_depth_clamp)

GL_ARB_depth_texture = Extension('GL_ARB_depth_texture')
GL_ARB_depth_texture.url = 'http://www.opengl.org/registry/specs/ARB/depth_texture.txt'
GL_ARB_depth_texture.enumerants = ['GL_DEPTH_COMPONENT16_ARB','GL_DEPTH_COMPONENT24_ARB','GL_DEPTH_COMPONENT32_ARB','GL_DEPTH_TEXTURE_MODE_ARB','GL_TEXTURE_DEPTH_SIZE_ARB']
gl.add(GL_ARB_depth_texture)

GL_ARB_draw_buffers = Extension('GL_ARB_draw_buffers')
GL_ARB_draw_buffers.url = 'http://www.opengl.org/registry/specs/ARB/draw_buffers.txt'
GL_ARB_draw_buffers.enumerants = ['GL_DRAW_BUFFER0_ARB','GL_DRAW_BUFFER10_ARB','GL_DRAW_BUFFER11_ARB','GL_DRAW_BUFFER12_ARB','GL_DRAW_BUFFER13_ARB','GL_DRAW_BUFFER14_ARB','GL_DRAW_BUFFER15_ARB','GL_DRAW_BUFFER1_ARB','GL_DRAW_BUFFER2_ARB','GL_DRAW_BUFFER3_ARB','GL_DRAW_BUFFER4_ARB','GL_DRAW_BUFFER5_ARB','GL_DRAW_BUFFER6_ARB','GL_DRAW_BUFFER7_ARB','GL_DRAW_BUFFER8_ARB','GL_DRAW_BUFFER9_ARB','GL_MAX_DRAW_BUFFERS_ARB']
GL_ARB_draw_buffers.functions = ['glDrawBuffersARB']
gl.add(GL_ARB_draw_buffers)

GL_ARB_draw_buffers_blend = Extension('GL_ARB_draw_buffers_blend')
GL_ARB_draw_buffers_blend.url = 'http://www.opengl.org/registry/specs/ARB/draw_buffers_blend.txt'
GL_ARB_draw_buffers_blend.functions = ['glBlendEquationSeparateiARB','glBlendEquationiARB','glBlendFuncSeparateiARB','glBlendFunciARB']
gl.add(GL_ARB_draw_buffers_blend)

GL_ARB_draw_elements_base_vertex = Extension('GL_ARB_draw_elements_base_vertex')
GL_ARB_draw_elements_base_vertex.url = 'http://www.opengl.org/registry/specs/ARB/draw_elements_base_vertex.txt'
GL_ARB_draw_elements_base_vertex.functions = ['glDrawElementsBaseVertex','glDrawElementsInstancedBaseVertex','glDrawRangeElementsBaseVertex','glMultiDrawElementsBaseVertex']
gl.add(GL_ARB_draw_elements_base_vertex)

GL_ARB_draw_indirect = Extension('GL_ARB_draw_indirect')
GL_ARB_draw_indirect.url = 'http://www.opengl.org/registry/specs/ARB/draw_indirect.txt'
GL_ARB_draw_indirect.enumerants = ['GL_DRAW_INDIRECT_BUFFER','GL_DRAW_INDIRECT_BUFFER_BINDING']
GL_ARB_draw_indirect.functions = ['glDrawArraysIndirect','glDrawElementsIndirect']
gl.add(GL_ARB_draw_indirect)

GL_ARB_draw_instanced = Extension('GL_ARB_draw_instanced')
GL_ARB_draw_instanced.url = 'http://www.opengl.org/registry/specs/ARB/draw_instanced.txt'
gl.add(GL_ARB_draw_instanced)

GL_ARB_enhanced_layouts = Extension('GL_ARB_enhanced_layouts')
GL_ARB_enhanced_layouts.url = 'http://www.opengl.org/registry/specs/ARB/enhanced_layouts.txt'
GL_ARB_enhanced_layouts.enumerants = ['GL_LOCATION_COMPONENT','GL_TRANSFORM_FEEDBACK_BUFFER_INDEX','GL_TRANSFORM_FEEDBACK_BUFFER_STRIDE']
GL_ARB_enhanced_layouts.functions = ['']
gl.add(GL_ARB_enhanced_layouts)

GL_ARB_explicit_attrib_location = Extension('GL_ARB_explicit_attrib_location')
GL_ARB_explicit_attrib_location.url = 'http://www.opengl.org/registry/specs/ARB/explicit_attrib_location.txt'
gl.add(GL_ARB_explicit_attrib_location)

GL_ARB_explicit_uniform_location = Extension('GL_ARB_explicit_uniform_location')
GL_ARB_explicit_uniform_location.url = 'http://www.opengl.org/registry/specs/ARB/explicit_uniform_location.txt'
GL_ARB_explicit_uniform_location.enumerants = ['GL_MAX_UNIFORM_LOCATIONS']
gl.add(GL_ARB_explicit_uniform_location)

GL_ARB_fragment_coord_conventions = Extension('GL_ARB_fragment_coord_conventions')
GL_ARB_fragment_coord_conventions.url = 'http://www.opengl.org/registry/specs/ARB/fragment_coord_conventions.txt'
gl.add(GL_ARB_fragment_coord_conventions)

GL_ARB_fragment_layer_viewport = Extension('GL_ARB_fragment_layer_viewport')
GL_ARB_fragment_layer_viewport.url = 'http://www.opengl.org/registry/specs/ARB/fragment_layer_viewport.txt'
gl.add(GL_ARB_fragment_layer_viewport)

GL_ARB_fragment_program = Extension('GL_ARB_fragment_program')
GL_ARB_fragment_program.url = 'http://www.opengl.org/registry/specs/ARB/fragment_program.txt'
GL_ARB_fragment_program.enumerants = ['GL_FRAGMENT_PROGRAM_ARB','GL_MAX_PROGRAM_ALU_INSTRUCTIONS_ARB','GL_MAX_PROGRAM_NATIVE_ALU_INSTRUCTIONS_ARB','GL_MAX_PROGRAM_NATIVE_TEX_INDIRECTIONS_ARB','GL_MAX_PROGRAM_NATIVE_TEX_INSTRUCTIONS_ARB','GL_MAX_PROGRAM_TEX_INDIRECTIONS_ARB','GL_MAX_PROGRAM_TEX_INSTRUCTIONS_ARB','GL_MAX_TEXTURE_COORDS_ARB','GL_MAX_TEXTURE_IMAGE_UNITS_ARB','GL_PROGRAM_ALU_INSTRUCTIONS_ARB','GL_PROGRAM_NATIVE_ALU_INSTRUCTIONS_ARB','GL_PROGRAM_NATIVE_TEX_INDIRECTIONS_ARB','GL_PROGRAM_NATIVE_TEX_INSTRUCTIONS_ARB','GL_PROGRAM_TEX_INDIRECTIONS_ARB','GL_PROGRAM_TEX_INSTRUCTIONS_ARB']
gl.add(GL_ARB_fragment_program)

GL_ARB_fragment_program_shadow = Extension('GL_ARB_fragment_program_shadow')
GL_ARB_fragment_program_shadow.url = 'http://www.opengl.org/registry/specs/ARB/fragment_program_shadow.txt'
gl.add(GL_ARB_fragment_program_shadow)

GL_ARB_fragment_shader = Extension('GL_ARB_fragment_shader')
GL_ARB_fragment_shader.url = 'http://www.opengl.org/registry/specs/ARB/fragment_shader.txt'
GL_ARB_fragment_shader.enumerants = ['GL_FRAGMENT_SHADER_ARB','GL_FRAGMENT_SHADER_DERIVATIVE_HINT_ARB','GL_MAX_FRAGMENT_UNIFORM_COMPONENTS_ARB']
gl.add(GL_ARB_fragment_shader)

GL_ARB_framebuffer_no_attachments = Extension('GL_ARB_framebuffer_no_attachments')
GL_ARB_framebuffer_no_attachments.url = 'http://www.opengl.org/registry/specs/ARB/framebuffer_no_attachments.txt'
GL_ARB_framebuffer_no_attachments.enumerants = ['GL_FRAMEBUFFER_DEFAULT_FIXED_SAMPLE_LOCATIONS','GL_FRAMEBUFFER_DEFAULT_HEIGHT','GL_FRAMEBUFFER_DEFAULT_LAYERS','GL_FRAMEBUFFER_DEFAULT_SAMPLES','GL_FRAMEBUFFER_DEFAULT_WIDTH','GL_MAX_FRAMEBUFFER_HEIGHT','GL_MAX_FRAMEBUFFER_LAYERS','GL_MAX_FRAMEBUFFER_SAMPLES','GL_MAX_FRAMEBUFFER_WIDTH']
GL_ARB_framebuffer_no_attachments.functions = ['glFramebufferParameteri','glGetFramebufferParameteriv','glGetNamedFramebufferParameterivEXT','glNamedFramebufferParameteriEXT']
gl.add(GL_ARB_framebuffer_no_attachments)

GL_ARB_framebuffer_object = Extension('GL_ARB_framebuffer_object')
GL_ARB_framebuffer_object.url = 'http://www.opengl.org/registry/specs/ARB/framebuffer_object.txt'
GL_ARB_framebuffer_object.enumerants = ['GL_COLOR_ATTACHMENT0','GL_COLOR_ATTACHMENT1','GL_COLOR_ATTACHMENT10','GL_COLOR_ATTACHMENT11','GL_COLOR_ATTACHMENT12','GL_COLOR_ATTACHMENT13','GL_COLOR_ATTACHMENT14','GL_COLOR_ATTACHMENT15','GL_COLOR_ATTACHMENT2','GL_COLOR_ATTACHMENT3','GL_COLOR_ATTACHMENT4','GL_COLOR_ATTACHMENT5','GL_COLOR_ATTACHMENT6','GL_COLOR_ATTACHMENT7','GL_COLOR_ATTACHMENT8','GL_COLOR_ATTACHMENT9','GL_DEPTH24_STENCIL8','GL_DEPTH_ATTACHMENT','GL_DEPTH_STENCIL','GL_DEPTH_STENCIL_ATTACHMENT','GL_DRAW_FRAMEBUFFER','GL_DRAW_FRAMEBUFFER_BINDING','GL_FRAMEBUFFER','GL_FRAMEBUFFER_ATTACHMENT_ALPHA_SIZE','GL_FRAMEBUFFER_ATTACHMENT_BLUE_SIZE','GL_FRAMEBUFFER_ATTACHMENT_COLOR_ENCODING','GL_FRAMEBUFFER_ATTACHMENT_COMPONENT_TYPE','GL_FRAMEBUFFER_ATTACHMENT_DEPTH_SIZE','GL_FRAMEBUFFER_ATTACHMENT_GREEN_SIZE','GL_FRAMEBUFFER_ATTACHMENT_OBJECT_NAME','GL_FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE','GL_FRAMEBUFFER_ATTACHMENT_RED_SIZE','GL_FRAMEBUFFER_ATTACHMENT_STENCIL_SIZE','GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE','GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_LAYER','GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL','GL_FRAMEBUFFER_BINDING','GL_FRAMEBUFFER_COMPLETE','GL_FRAMEBUFFER_DEFAULT','GL_FRAMEBUFFER_INCOMPLETE_ATTACHMENT','GL_FRAMEBUFFER_INCOMPLETE_DRAW_BUFFER','GL_FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT','GL_FRAMEBUFFER_INCOMPLETE_MULTISAMPLE','GL_FRAMEBUFFER_INCOMPLETE_READ_BUFFER','GL_FRAMEBUFFER_UNDEFINED','GL_FRAMEBUFFER_UNSUPPORTED','GL_INDEX','GL_INVALID_FRAMEBUFFER_OPERATION','GL_MAX_COLOR_ATTACHMENTS','GL_MAX_RENDERBUFFER_SIZE','GL_MAX_SAMPLES','GL_READ_FRAMEBUFFER','GL_READ_FRAMEBUFFER_BINDING','GL_RENDERBUFFER','GL_RENDERBUFFER_ALPHA_SIZE','GL_RENDERBUFFER_BINDING','GL_RENDERBUFFER_BLUE_SIZE','GL_RENDERBUFFER_DEPTH_SIZE','GL_RENDERBUFFER_GREEN_SIZE','GL_RENDERBUFFER_HEIGHT','GL_RENDERBUFFER_INTERNAL_FORMAT','GL_RENDERBUFFER_RED_SIZE','GL_RENDERBUFFER_SAMPLES','GL_RENDERBUFFER_STENCIL_SIZE','GL_RENDERBUFFER_WIDTH','GL_SRGB','GL_STENCIL_ATTACHMENT','GL_STENCIL_INDEX1','GL_STENCIL_INDEX16','GL_STENCIL_INDEX4','GL_STENCIL_INDEX8','GL_TEXTURE_STENCIL_SIZE','GL_UNSIGNED_INT_24_8','GL_UNSIGNED_NORMALIZED']
GL_ARB_framebuffer_object.functions = ['glIsFramebuffer','glIsRenderbuffer','glCheckFramebufferStatus','glBindFramebuffer','glBindRenderbuffer','glBlitFramebuffer','glDeleteFramebuffers','glDeleteRenderbuffers','glFramebufferRenderbuffer','glFramebufferTexture1D','glFramebufferTexture2D','glFramebufferTexture3D','glFramebufferTextureLayer','glGenFramebuffers','glGenRenderbuffers','glGenerateMipmap','glGetFramebufferAttachmentParameteriv','glGetRenderbufferParameteriv','glRenderbufferStorage','glRenderbufferStorageMultisample']
gl.add(GL_ARB_framebuffer_object)

GL_ARB_framebuffer_sRGB = Extension('GL_ARB_framebuffer_sRGB')
GL_ARB_framebuffer_sRGB.url = 'http://www.opengl.org/registry/specs/ARB/framebuffer_sRGB.txt'
GL_ARB_framebuffer_sRGB.enumerants = ['GL_FRAMEBUFFER_SRGB']
gl.add(GL_ARB_framebuffer_sRGB)

GL_ARB_geometry_shader4 = Extension('GL_ARB_geometry_shader4')
GL_ARB_geometry_shader4.url = 'http://www.opengl.org/registry/specs/ARB/geometry_shader4.txt'
GL_ARB_geometry_shader4.enumerants = ['GL_FRAMEBUFFER_ATTACHMENT_LAYERED_ARB','GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_LAYER','GL_FRAMEBUFFER_INCOMPLETE_LAYER_COUNT_ARB','GL_FRAMEBUFFER_INCOMPLETE_LAYER_TARGETS_ARB','GL_GEOMETRY_INPUT_TYPE_ARB','GL_GEOMETRY_OUTPUT_TYPE_ARB','GL_GEOMETRY_SHADER_ARB','GL_GEOMETRY_VERTICES_OUT_ARB','GL_LINES_ADJACENCY_ARB','GL_LINE_STRIP_ADJACENCY_ARB','GL_MAX_GEOMETRY_OUTPUT_VERTICES_ARB','GL_MAX_GEOMETRY_TEXTURE_IMAGE_UNITS_ARB','GL_MAX_GEOMETRY_TOTAL_OUTPUT_COMPONENTS_ARB','GL_MAX_GEOMETRY_UNIFORM_COMPONENTS_ARB','GL_MAX_GEOMETRY_VARYING_COMPONENTS_ARB','GL_MAX_VERTEX_VARYING_COMPONENTS_ARB','GL_PROGRAM_POINT_SIZE_ARB','GL_TRIANGLES_ADJACENCY_ARB','GL_TRIANGLE_STRIP_ADJACENCY_ARB']
GL_ARB_geometry_shader4.functions = ['glFramebufferTextureARB','glFramebufferTextureFaceARB','glFramebufferTextureLayerARB','glProgramParameteriARB']
gl.add(GL_ARB_geometry_shader4)

GL_ARB_get_program_binary = Extension('GL_ARB_get_program_binary')
GL_ARB_get_program_binary.url = 'http://www.opengl.org/registry/specs/ARB/get_program_binary.txt'
GL_ARB_get_program_binary.enumerants = ['GL_NUM_PROGRAM_BINARY_FORMATS','GL_PROGRAM_BINARY_FORMATS','GL_PROGRAM_BINARY_LENGTH','GL_PROGRAM_BINARY_RETRIEVABLE_HINT']
GL_ARB_get_program_binary.functions = ['glGetProgramBinary','glProgramBinary','glProgramParameteri']
gl.add(GL_ARB_get_program_binary)

GL_ARB_gpu_shader5 = Extension('GL_ARB_gpu_shader5')
GL_ARB_gpu_shader5.url = 'http://www.opengl.org/registry/specs/ARB/gpu_shader5.txt'
GL_ARB_gpu_shader5.enumerants = ['GL_FRAGMENT_INTERPOLATION_OFFSET_BITS','GL_GEOMETRY_SHADER_INVOCATIONS','GL_MAX_FRAGMENT_INTERPOLATION_OFFSET','GL_MAX_GEOMETRY_SHADER_INVOCATIONS','GL_MAX_VERTEX_STREAMS','GL_MIN_FRAGMENT_INTERPOLATION_OFFSET']
gl.add(GL_ARB_gpu_shader5)

GL_ARB_gpu_shader_fp64 = Extension('GL_ARB_gpu_shader_fp64')
GL_ARB_gpu_shader_fp64.url = 'http://www.opengl.org/registry/specs/ARB/gpu_shader_fp64.txt'
GL_ARB_gpu_shader_fp64.enumerants = ['GL_DOUBLE_MAT2','GL_DOUBLE_MAT2x3','GL_DOUBLE_MAT2x4','GL_DOUBLE_MAT3','GL_DOUBLE_MAT3x2','GL_DOUBLE_MAT3x4','GL_DOUBLE_MAT4','GL_DOUBLE_MAT4x2','GL_DOUBLE_MAT4x3','GL_DOUBLE_VEC2','GL_DOUBLE_VEC3','GL_DOUBLE_VEC4']
GL_ARB_gpu_shader_fp64.functions = ['glGetUniformdv','glUniform1d','glUniform1dv','glUniform2d','glUniform2dv','glUniform3d','glUniform3dv','glUniform4d','glUniform4dv','glUniformMatrix2dv','glUniformMatrix2x3dv','glUniformMatrix2x4dv','glUniformMatrix3dv','glUniformMatrix3x2dv','glUniformMatrix3x4dv','glUniformMatrix4dv','glUniformMatrix4x2dv','glUniformMatrix4x3dv']
gl.add(GL_ARB_gpu_shader_fp64)

GL_ARB_half_float_pixel = Extension('GL_ARB_half_float_pixel')
GL_ARB_half_float_pixel.url = 'http://www.opengl.org/registry/specs/ARB/half_float_pixel.txt'
GL_ARB_half_float_pixel.enumerants = ['GL_HALF_FLOAT_ARB']
gl.add(GL_ARB_half_float_pixel)

GL_ARB_half_float_vertex = Extension('GL_ARB_half_float_vertex')
GL_ARB_half_float_vertex.url = 'http://www.opengl.org/registry/specs/ARB/half_float_vertex.txt'
GL_ARB_half_float_vertex.enumerants = ['GL_HALF_FLOAT']
gl.add(GL_ARB_half_float_vertex)

GL_ARB_imaging = Extension('GL_ARB_imaging')
GL_ARB_imaging.enumerants = ['GL_BLEND_COLOR','GL_BLEND_EQUATION','GL_COLOR_MATRIX','GL_COLOR_MATRIX_STACK_DEPTH','GL_COLOR_TABLE','GL_COLOR_TABLE_ALPHA_SIZE','GL_COLOR_TABLE_BIAS','GL_COLOR_TABLE_BLUE_SIZE','GL_COLOR_TABLE_FORMAT','GL_COLOR_TABLE_GREEN_SIZE','GL_COLOR_TABLE_INTENSITY_SIZE','GL_COLOR_TABLE_LUMINANCE_SIZE','GL_COLOR_TABLE_RED_SIZE','GL_COLOR_TABLE_SCALE','GL_COLOR_TABLE_WIDTH','GL_CONSTANT_ALPHA','GL_CONSTANT_BORDER','GL_CONSTANT_COLOR','GL_CONVOLUTION_1D','GL_CONVOLUTION_2D','GL_CONVOLUTION_BORDER_COLOR','GL_CONVOLUTION_BORDER_MODE','GL_CONVOLUTION_FILTER_BIAS','GL_CONVOLUTION_FILTER_SCALE','GL_CONVOLUTION_FORMAT','GL_CONVOLUTION_HEIGHT','GL_CONVOLUTION_WIDTH','GL_FUNC_ADD','GL_FUNC_REVERSE_SUBTRACT','GL_FUNC_SUBTRACT','GL_HISTOGRAM','GL_HISTOGRAM_ALPHA_SIZE','GL_HISTOGRAM_BLUE_SIZE','GL_HISTOGRAM_FORMAT','GL_HISTOGRAM_GREEN_SIZE','GL_HISTOGRAM_LUMINANCE_SIZE','GL_HISTOGRAM_RED_SIZE','GL_HISTOGRAM_SINK','GL_HISTOGRAM_WIDTH','GL_IGNORE_BORDER','GL_MAX','GL_MAX_COLOR_MATRIX_STACK_DEPTH','GL_MAX_CONVOLUTION_HEIGHT','GL_MAX_CONVOLUTION_WIDTH','GL_MIN','GL_MINMAX','GL_MINMAX_FORMAT','GL_MINMAX_SINK','GL_ONE_MINUS_CONSTANT_ALPHA','GL_ONE_MINUS_CONSTANT_COLOR','GL_POST_COLOR_MATRIX_ALPHA_BIAS','GL_POST_COLOR_MATRIX_ALPHA_SCALE','GL_POST_COLOR_MATRIX_BLUE_BIAS','GL_POST_COLOR_MATRIX_BLUE_SCALE','GL_POST_COLOR_MATRIX_COLOR_TABLE','GL_POST_COLOR_MATRIX_GREEN_BIAS','GL_POST_COLOR_MATRIX_GREEN_SCALE','GL_POST_COLOR_MATRIX_RED_BIAS','GL_POST_COLOR_MATRIX_RED_SCALE','GL_POST_CONVOLUTION_ALPHA_BIAS','GL_POST_CONVOLUTION_ALPHA_SCALE','GL_POST_CONVOLUTION_BLUE_BIAS','GL_POST_CONVOLUTION_BLUE_SCALE','GL_POST_CONVOLUTION_COLOR_TABLE','GL_POST_CONVOLUTION_GREEN_BIAS','GL_POST_CONVOLUTION_GREEN_SCALE','GL_POST_CONVOLUTION_RED_BIAS','GL_POST_CONVOLUTION_RED_SCALE','GL_PROXY_COLOR_TABLE','GL_PROXY_HISTOGRAM','GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE','GL_PROXY_POST_CONVOLUTION_COLOR_TABLE','GL_REDUCE','GL_REPLICATE_BORDER','GL_SEPARABLE_2D','GL_TABLE_TOO_LARGE','GL_WRAP_BORDER']
GL_ARB_imaging.functions = ['glColorSubTable','glColorTable','glColorTableParameterfv','glColorTableParameteriv','glConvolutionFilter1D','glConvolutionFilter2D','glConvolutionParameterf','glConvolutionParameterfv','glConvolutionParameteri','glConvolutionParameteriv','glCopyColorSubTable','glCopyColorTable','glCopyConvolutionFilter1D','glCopyConvolutionFilter2D','glGetColorTable','glGetColorTableParameterfv','glGetColorTableParameteriv','glGetConvolutionFilter','glGetConvolutionParameterfv','glGetConvolutionParameteriv','glGetHistogram','glGetHistogramParameterfv','glGetHistogramParameteriv','glGetMinmax','glGetMinmaxParameterfv','glGetMinmaxParameteriv','glGetSeparableFilter','glHistogram','glMinmax','glResetHistogram','glResetMinmax','glSeparableFilter2D']
gl.add(GL_ARB_imaging)

GL_ARB_indirect_parameters = Extension('GL_ARB_indirect_parameters')
GL_ARB_indirect_parameters.url = 'http://www.opengl.org/registry/specs/ARB/indirect_parameters.txt'
GL_ARB_indirect_parameters.enumerants = ['GL_PARAMETER_BUFFER_ARB','GL_PARAMETER_BUFFER_BINDING_ARB']
GL_ARB_indirect_parameters.functions = ['glMultiDrawArraysIndirectCountARB','glMultiDrawElementsIndirectCountARB']
gl.add(GL_ARB_indirect_parameters)

GL_ARB_instanced_arrays = Extension('GL_ARB_instanced_arrays')
GL_ARB_instanced_arrays.url = 'http://www.opengl.org/registry/specs/ARB/instanced_arrays.txt'
GL_ARB_instanced_arrays.enumerants = ['GL_VERTEX_ATTRIB_ARRAY_DIVISOR_ARB']
GL_ARB_instanced_arrays.functions = ['glDrawArraysInstancedARB','glDrawElementsInstancedARB','glVertexAttribDivisorARB']
gl.add(GL_ARB_instanced_arrays)

GL_ARB_internalformat_query = Extension('GL_ARB_internalformat_query')
GL_ARB_internalformat_query.url = 'http://www.opengl.org/registry/specs/ARB/internalformat_query.txt'
GL_ARB_internalformat_query.enumerants = ['GL_NUM_SAMPLE_COUNTS']
GL_ARB_internalformat_query.functions = ['glGetInternalformativ']
gl.add(GL_ARB_internalformat_query)

GL_ARB_internalformat_query2 = Extension('GL_ARB_internalformat_query2')
GL_ARB_internalformat_query2.url = 'http://www.opengl.org/registry/specs/ARB/internalformat_query2.txt'
GL_ARB_internalformat_query2.enumerants = ['GL_AUTO_GENERATE_MIPMAP','GL_CAVEAT_SUPPORT','GL_CLEAR_BUFFER','GL_COLOR_COMPONENTS','GL_COLOR_ENCODING','GL_COLOR_RENDERABLE','GL_COMPUTE_TEXTURE','GL_DEPTH_COMPONENTS','GL_DEPTH_RENDERABLE','GL_FILTER','GL_FRAGMENT_TEXTURE','GL_FRAMEBUFFER_BLEND','GL_FRAMEBUFFER_RENDERABLE','GL_FRAMEBUFFER_RENDERABLE_LAYERED','GL_FULL_SUPPORT','GL_GEOMETRY_TEXTURE','GL_GET_TEXTURE_IMAGE_FORMAT','GL_GET_TEXTURE_IMAGE_TYPE','GL_IMAGE_CLASS_10_10_10_2','GL_IMAGE_CLASS_11_11_10','GL_IMAGE_CLASS_1_X_16','GL_IMAGE_CLASS_1_X_32','GL_IMAGE_CLASS_1_X_8','GL_IMAGE_CLASS_2_X_16','GL_IMAGE_CLASS_2_X_32','GL_IMAGE_CLASS_2_X_8','GL_IMAGE_CLASS_4_X_16','GL_IMAGE_CLASS_4_X_32','GL_IMAGE_CLASS_4_X_8','GL_IMAGE_COMPATIBILITY_CLASS','GL_IMAGE_PIXEL_FORMAT','GL_IMAGE_PIXEL_TYPE','GL_IMAGE_TEXEL_SIZE','GL_INTERNALFORMAT_ALPHA_SIZE','GL_INTERNALFORMAT_ALPHA_TYPE','GL_INTERNALFORMAT_BLUE_SIZE','GL_INTERNALFORMAT_BLUE_TYPE','GL_INTERNALFORMAT_DEPTH_SIZE','GL_INTERNALFORMAT_DEPTH_TYPE','GL_INTERNALFORMAT_GREEN_SIZE','GL_INTERNALFORMAT_GREEN_TYPE','GL_INTERNALFORMAT_PREFERRED','GL_INTERNALFORMAT_RED_SIZE','GL_INTERNALFORMAT_RED_TYPE','GL_INTERNALFORMAT_SHARED_SIZE','GL_INTERNALFORMAT_STENCIL_SIZE','GL_INTERNALFORMAT_STENCIL_TYPE','GL_INTERNALFORMAT_SUPPORTED','GL_MANUAL_GENERATE_MIPMAP','GL_MAX_COMBINED_DIMENSIONS','GL_MAX_DEPTH','GL_MAX_HEIGHT','GL_MAX_LAYERS','GL_MAX_WIDTH','GL_MIPMAP','GL_READ_PIXELS','GL_READ_PIXELS_FORMAT','GL_READ_PIXELS_TYPE','GL_SHADER_IMAGE_ATOMIC','GL_SHADER_IMAGE_LOAD','GL_SHADER_IMAGE_STORE','GL_SIMULTANEOUS_TEXTURE_AND_DEPTH_TEST','GL_SIMULTANEOUS_TEXTURE_AND_DEPTH_WRITE','GL_SIMULTANEOUS_TEXTURE_AND_STENCIL_TEST','GL_SIMULTANEOUS_TEXTURE_AND_STENCIL_WRITE','GL_SRGB_DECODE_ARB','GL_SRGB_READ','GL_SRGB_WRITE','GL_STENCIL_COMPONENTS','GL_STENCIL_RENDERABLE','GL_TESS_CONTROL_TEXTURE','GL_TESS_EVALUATION_TEXTURE','GL_TEXTURE_COMPRESSED_BLOCK_HEIGHT','GL_TEXTURE_COMPRESSED_BLOCK_SIZE','GL_TEXTURE_COMPRESSED_BLOCK_WIDTH','GL_TEXTURE_GATHER','GL_TEXTURE_GATHER_SHADOW','GL_TEXTURE_IMAGE_FORMAT','GL_TEXTURE_IMAGE_TYPE','GL_TEXTURE_SHADOW','GL_TEXTURE_VIEW','GL_VERTEX_TEXTURE','GL_VIEW_CLASS_128_BITS','GL_VIEW_CLASS_16_BITS','GL_VIEW_CLASS_24_BITS','GL_VIEW_CLASS_32_BITS','GL_VIEW_CLASS_48_BITS','GL_VIEW_CLASS_64_BITS','GL_VIEW_CLASS_8_BITS','GL_VIEW_CLASS_96_BITS','GL_VIEW_CLASS_BPTC_FLOAT','GL_VIEW_CLASS_BPTC_UNORM','GL_VIEW_CLASS_RGTC1_RED','GL_VIEW_CLASS_RGTC2_RG','GL_VIEW_CLASS_S3TC_DXT1_RGB','GL_VIEW_CLASS_S3TC_DXT1_RGBA','GL_VIEW_CLASS_S3TC_DXT3_RGBA','GL_VIEW_CLASS_S3TC_DXT5_RGBA','GL_VIEW_COMPATIBILITY_CLASS']
GL_ARB_internalformat_query2.functions = ['glGetInternalformati64v']
gl.add(GL_ARB_internalformat_query2)

GL_ARB_invalidate_subdata = Extension('GL_ARB_invalidate_subdata')
GL_ARB_invalidate_subdata.url = 'http://www.opengl.org/registry/specs/ARB/invalidate_subdata.txt'
GL_ARB_invalidate_subdata.functions = ['glInvalidateBufferData','glInvalidateBufferSubData','glInvalidateFramebuffer','glInvalidateSubFramebuffer','glInvalidateTexImage','glInvalidateTexSubImage']
gl.add(GL_ARB_invalidate_subdata)

GL_ARB_map_buffer_alignment = Extension('GL_ARB_map_buffer_alignment')
GL_ARB_map_buffer_alignment.url = 'http://www.opengl.org/registry/specs/ARB/map_buffer_alignment.txt'
GL_ARB_map_buffer_alignment.enumerants = ['GL_MIN_MAP_BUFFER_ALIGNMENT']
gl.add(GL_ARB_map_buffer_alignment)

GL_ARB_map_buffer_range = Extension('GL_ARB_map_buffer_range')
GL_ARB_map_buffer_range.url = 'http://www.opengl.org/registry/specs/ARB/map_buffer_range.txt'
GL_ARB_map_buffer_range.enumerants = ['GL_MAP_FLUSH_EXPLICIT_BIT','GL_MAP_INVALIDATE_BUFFER_BIT','GL_MAP_INVALIDATE_RANGE_BIT','GL_MAP_READ_BIT','GL_MAP_UNSYNCHRONIZED_BIT','GL_MAP_WRITE_BIT']
GL_ARB_map_buffer_range.functions = ['*','glFlushMappedBufferRange']
gl.add(GL_ARB_map_buffer_range)

GL_ARB_matrix_palette = Extension('GL_ARB_matrix_palette')
GL_ARB_matrix_palette.url = 'http://oss.sgi.com/projects/ogl-sample/registry/ARB/matrix_palette.txt'
GL_ARB_matrix_palette.enumerants = ['GL_CURRENT_MATRIX_INDEX_ARB','GL_CURRENT_PALETTE_MATRIX_ARB','GL_MATRIX_INDEX_ARRAY_ARB','GL_MATRIX_INDEX_ARRAY_POINTER_ARB','GL_MATRIX_INDEX_ARRAY_SIZE_ARB','GL_MATRIX_INDEX_ARRAY_STRIDE_ARB','GL_MATRIX_INDEX_ARRAY_TYPE_ARB','GL_MATRIX_PALETTE_ARB','GL_MAX_MATRIX_PALETTE_STACK_DEPTH_ARB','GL_MAX_PALETTE_MATRICES_ARB']
GL_ARB_matrix_palette.functions = ['glCurrentPaletteMatrixARB','glMatrixIndexPointerARB','glMatrixIndexubvARB','glMatrixIndexuivARB','glMatrixIndexusvARB']
gl.add(GL_ARB_matrix_palette)

GL_ARB_multi_bind = Extension('GL_ARB_multi_bind')
GL_ARB_multi_bind.url = 'http://www.opengl.org/registry/specs/gl/ARB/multi_bind.txt'
GL_ARB_multi_bind.functions = ['glBindBuffersBase','glBindBuffersRange','glBindImageTextures','glBindSamplers','glBindTextures','glBindVertexBuffers']
gl.add(GL_ARB_multi_bind)

GL_ARB_multi_draw_indirect = Extension('GL_ARB_multi_draw_indirect')
GL_ARB_multi_draw_indirect.url = 'http://www.opengl.org/registry/specs/ARB/multi_draw_indirect.txt'
GL_ARB_multi_draw_indirect.functions = ['glMultiDrawArraysIndirect','glMultiDrawElementsIndirect']
gl.add(GL_ARB_multi_draw_indirect)

GL_ARB_multisample = Extension('GL_ARB_multisample')
GL_ARB_multisample.url = 'http://www.opengl.org/registry/specs/ARB/multisample.txt'
GL_ARB_multisample.enumerants = ['GL_MULTISAMPLE_ARB','GL_MULTISAMPLE_BIT_ARB','GL_SAMPLES_ARB','GL_SAMPLE_ALPHA_TO_COVERAGE_ARB','GL_SAMPLE_ALPHA_TO_ONE_ARB','GL_SAMPLE_BUFFERS_ARB','GL_SAMPLE_COVERAGE_ARB','GL_SAMPLE_COVERAGE_INVERT_ARB','GL_SAMPLE_COVERAGE_VALUE_ARB']
GL_ARB_multisample.functions = ['glSampleCoverageARB']
gl.add(GL_ARB_multisample)

GL_ARB_multitexture = Extension('GL_ARB_multitexture')
GL_ARB_multitexture.url = 'http://oss.sgi.com/projects/ogl-sample/registry/ARB/multitexture.txt'
GL_ARB_multitexture.enumerants = ['GL_ACTIVE_TEXTURE_ARB','GL_CLIENT_ACTIVE_TEXTURE_ARB','GL_MAX_TEXTURE_UNITS_ARB','GL_TEXTURE0_ARB','GL_TEXTURE10_ARB','GL_TEXTURE11_ARB','GL_TEXTURE12_ARB','GL_TEXTURE13_ARB','GL_TEXTURE14_ARB','GL_TEXTURE15_ARB','GL_TEXTURE16_ARB','GL_TEXTURE17_ARB','GL_TEXTURE18_ARB','GL_TEXTURE19_ARB','GL_TEXTURE1_ARB','GL_TEXTURE20_ARB','GL_TEXTURE21_ARB','GL_TEXTURE22_ARB','GL_TEXTURE23_ARB','GL_TEXTURE24_ARB','GL_TEXTURE25_ARB','GL_TEXTURE26_ARB','GL_TEXTURE27_ARB','GL_TEXTURE28_ARB','GL_TEXTURE29_ARB','GL_TEXTURE2_ARB','GL_TEXTURE30_ARB','GL_TEXTURE31_ARB','GL_TEXTURE3_ARB','GL_TEXTURE4_ARB','GL_TEXTURE5_ARB','GL_TEXTURE6_ARB','GL_TEXTURE7_ARB','GL_TEXTURE8_ARB','GL_TEXTURE9_ARB']
GL_ARB_multitexture.functions = ['glActiveTextureARB','glClientActiveTextureARB','glMultiTexCoord1dARB','glMultiTexCoord1dvARB','glMultiTexCoord1fARB','glMultiTexCoord1fvARB','glMultiTexCoord1iARB','glMultiTexCoord1ivARB','glMultiTexCoord1sARB','glMultiTexCoord1svARB','glMultiTexCoord2dARB','glMultiTexCoord2dvARB','glMultiTexCoord2fARB','glMultiTexCoord2fvARB','glMultiTexCoord2iARB','glMultiTexCoord2ivARB','glMultiTexCoord2sARB','glMultiTexCoord2svARB','glMultiTexCoord3dARB','glMultiTexCoord3dvARB','glMultiTexCoord3fARB','glMultiTexCoord3fvARB','glMultiTexCoord3iARB','glMultiTexCoord3ivARB','glMultiTexCoord3sARB','glMultiTexCoord3svARB','glMultiTexCoord4dARB','glMultiTexCoord4dvARB','glMultiTexCoord4fARB','glMultiTexCoord4fvARB','glMultiTexCoord4iARB','glMultiTexCoord4ivARB','glMultiTexCoord4sARB','glMultiTexCoord4svARB']
gl.add(GL_ARB_multitexture)

GL_ARB_occlusion_query = Extension('GL_ARB_occlusion_query')
GL_ARB_occlusion_query.url = 'http://www.opengl.org/registry/specs/ARB/occlusion_query.txt'
GL_ARB_occlusion_query.enumerants = ['GL_CURRENT_QUERY_ARB','GL_QUERY_COUNTER_BITS_ARB','GL_QUERY_RESULT_ARB','GL_QUERY_RESULT_AVAILABLE_ARB','GL_SAMPLES_PASSED_ARB']
GL_ARB_occlusion_query.functions = ['glIsQueryARB','glBeginQueryARB','glDeleteQueriesARB','glEndQueryARB','glGenQueriesARB','glGetQueryObjectivARB','glGetQueryObjectuivARB','glGetQueryivARB']
gl.add(GL_ARB_occlusion_query)

GL_ARB_occlusion_query2 = Extension('GL_ARB_occlusion_query2')
GL_ARB_occlusion_query2.url = 'http://www.opengl.org/registry/specs/ARB/occlusion_query2.txt'
GL_ARB_occlusion_query2.enumerants = ['GL_ANY_SAMPLES_PASSED']
gl.add(GL_ARB_occlusion_query2)

GL_ARB_pixel_buffer_object = Extension('GL_ARB_pixel_buffer_object')
GL_ARB_pixel_buffer_object.url = 'http://www.opengl.org/registry/specs/ARB/pixel_buffer_object.txt'
GL_ARB_pixel_buffer_object.enumerants = ['GL_PIXEL_PACK_BUFFER_ARB','GL_PIXEL_PACK_BUFFER_BINDING_ARB','GL_PIXEL_UNPACK_BUFFER_ARB','GL_PIXEL_UNPACK_BUFFER_BINDING_ARB']
gl.add(GL_ARB_pixel_buffer_object)

GL_ARB_point_parameters = Extension('GL_ARB_point_parameters')
GL_ARB_point_parameters.url = 'http://www.opengl.org/registry/specs/ARB/point_parameters.txt'
GL_ARB_point_parameters.enumerants = ['GL_POINT_DISTANCE_ATTENUATION_ARB','GL_POINT_FADE_THRESHOLD_SIZE_ARB','GL_POINT_SIZE_MAX_ARB','GL_POINT_SIZE_MIN_ARB']
GL_ARB_point_parameters.functions = ['glPointParameterfARB','glPointParameterfvARB']
gl.add(GL_ARB_point_parameters)

GL_ARB_point_sprite = Extension('GL_ARB_point_sprite')
GL_ARB_point_sprite.url = 'http://www.opengl.org/registry/specs/ARB/point_sprite.txt'
GL_ARB_point_sprite.enumerants = ['GL_COORD_REPLACE_ARB','GL_POINT_SPRITE_ARB']
gl.add(GL_ARB_point_sprite)

GL_ARB_program_interface_query = Extension('GL_ARB_program_interface_query')
GL_ARB_program_interface_query.url = 'http://www.opengl.org/registry/specs/ARB/program_interface_query.txt'
GL_ARB_program_interface_query.enumerants = ['GL_ACTIVE_RESOURCES','GL_ACTIVE_VARIABLES','GL_ARRAY_SIZE','GL_ARRAY_STRIDE','GL_ATOMIC_COUNTER_BUFFER_INDEX','GL_BLOCK_INDEX','GL_BUFFER_BINDING','GL_BUFFER_DATA_SIZE','GL_BUFFER_VARIABLE','GL_COMPUTE_SUBROUTINE','GL_COMPUTE_SUBROUTINE_UNIFORM','GL_FRAGMENT_SUBROUTINE','GL_FRAGMENT_SUBROUTINE_UNIFORM','GL_GEOMETRY_SUBROUTINE','GL_GEOMETRY_SUBROUTINE_UNIFORM','GL_IS_PER_PATCH','GL_IS_ROW_MAJOR','GL_LOCATION','GL_LOCATION_INDEX','GL_MATRIX_STRIDE','GL_MAX_NAME_LENGTH','GL_MAX_NUM_ACTIVE_VARIABLES','GL_MAX_NUM_COMPATIBLE_SUBROUTINES','GL_NAME_LENGTH','GL_NUM_ACTIVE_VARIABLES','GL_OFFSET','GL_PROGRAM_INPUT','GL_PROGRAM_OUTPUT','GL_REFERENCED_BY_COMPUTE_SHADER','GL_REFERENCED_BY_FRAGMENT_SHADER','GL_REFERENCED_BY_GEOMETRY_SHADER','GL_REFERENCED_BY_TESS_CONTROL_SHADER','GL_REFERENCED_BY_TESS_EVALUATION_SHADER','GL_REFERENCED_BY_VERTEX_SHADER','GL_SHADER_STORAGE_BLOCK','GL_TESS_CONTROL_SUBROUTINE','GL_TESS_CONTROL_SUBROUTINE_UNIFORM','GL_TESS_EVALUATION_SUBROUTINE','GL_TESS_EVALUATION_SUBROUTINE_UNIFORM','GL_TOP_LEVEL_ARRAY_SIZE','GL_TOP_LEVEL_ARRAY_STRIDE','GL_TRANSFORM_FEEDBACK_VARYING','GL_TYPE','GL_UNIFORM','GL_UNIFORM_BLOCK','GL_VERTEX_SUBROUTINE','GL_VERTEX_SUBROUTINE_UNIFORM']
GL_ARB_program_interface_query.functions = ['glGetProgramResourceLocation','glGetProgramResourceLocationIndex','glGetProgramResourceIndex','glGetProgramInterfaceiv','glGetProgramResourceName','glGetProgramResourceiv']
gl.add(GL_ARB_program_interface_query)

GL_ARB_provoking_vertex = Extension('GL_ARB_provoking_vertex')
GL_ARB_provoking_vertex.url = 'http://www.opengl.org/registry/specs/ARB/provoking_vertex.txt'
GL_ARB_provoking_vertex.enumerants = ['GL_FIRST_VERTEX_CONVENTION','GL_LAST_VERTEX_CONVENTION','GL_PROVOKING_VERTEX','GL_QUADS_FOLLOW_PROVOKING_VERTEX_CONVENTION']
GL_ARB_provoking_vertex.functions = ['glProvokingVertex']
gl.add(GL_ARB_provoking_vertex)

GL_ARB_query_buffer_object = Extension('GL_ARB_query_buffer_object')
GL_ARB_query_buffer_object.url = 'http://www.opengl.org/registry/specs/ARB/query_buffer_object.txt'
GL_ARB_query_buffer_object.enumerants = ['GL_QUERY_BUFFER','GL_QUERY_BUFFER_BARRIER_BIT','GL_QUERY_BUFFER_BINDING','GL_QUERY_RESULT_NO_WAIT']
GL_ARB_query_buffer_object.functions = ['']
gl.add(GL_ARB_query_buffer_object)

GL_ARB_robust_buffer_access_behavior = Extension('GL_ARB_robust_buffer_access_behavior')
GL_ARB_robust_buffer_access_behavior.url = 'http://www.opengl.org/registry/specs/ARB/robust_buffer_access_behavior.txt'
gl.add(GL_ARB_robust_buffer_access_behavior)

GL_ARB_robustness = Extension('GL_ARB_robustness')
GL_ARB_robustness.url = 'http://www.opengl.org/registry/specs/ARB/robustness.txt'
GL_ARB_robustness.enumerants = ['GL_CONTEXT_FLAG_ROBUST_ACCESS_BIT_ARB','GL_GUILTY_CONTEXT_RESET_ARB','GL_INNOCENT_CONTEXT_RESET_ARB','GL_LOSE_CONTEXT_ON_RESET_ARB','GL_NO_RESET_NOTIFICATION_ARB','GL_RESET_NOTIFICATION_STRATEGY_ARB','GL_UNKNOWN_CONTEXT_RESET_ARB']
GL_ARB_robustness.functions = ['glGetGraphicsResetStatusARB','glGetnColorTableARB','glGetnCompressedTexImageARB','glGetnConvolutionFilterARB','glGetnHistogramARB','glGetnMapdvARB','glGetnMapfvARB','glGetnMapivARB','glGetnMinmaxARB','glGetnPixelMapfvARB','glGetnPixelMapuivARB','glGetnPixelMapusvARB','glGetnPolygonStippleARB','glGetnSeparableFilterARB','glGetnTexImageARB','glGetnUniformdvARB','glGetnUniformfvARB','glGetnUniformivARB','glGetnUniformuivARB','glReadnPixelsARB']
gl.add(GL_ARB_robustness)

GL_ARB_robustness_application_isolation = Extension('GL_ARB_robustness_application_isolation')
GL_ARB_robustness_application_isolation.url = 'http://www.opengl.org/registry/specs/ARB/robustness_isolation.txt'
gl.add(GL_ARB_robustness_application_isolation)

GL_ARB_robustness_share_group_isolation = Extension('GL_ARB_robustness_share_group_isolation')
GL_ARB_robustness_share_group_isolation.url = 'http://www.opengl.org/registry/specs/ARB/robustness_isolation.txt'
gl.add(GL_ARB_robustness_share_group_isolation)

GL_ARB_sample_shading = Extension('GL_ARB_sample_shading')
GL_ARB_sample_shading.url = 'http://www.opengl.org/registry/specs/ARB/sample_shading.txt'
GL_ARB_sample_shading.enumerants = ['GL_MIN_SAMPLE_SHADING_VALUE_ARB','GL_SAMPLE_SHADING_ARB']
GL_ARB_sample_shading.functions = ['glMinSampleShadingARB']
gl.add(GL_ARB_sample_shading)

GL_ARB_sampler_objects = Extension('GL_ARB_sampler_objects')
GL_ARB_sampler_objects.url = 'http://www.opengl.org/registry/specs/ARB/sampler_objects.txt'
GL_ARB_sampler_objects.enumerants = ['GL_SAMPLER_BINDING']
GL_ARB_sampler_objects.functions = ['glIsSampler','glBindSampler','glDeleteSamplers','glGenSamplers','glGetSamplerParameterIiv','glGetSamplerParameterIuiv','glGetSamplerParameterfv','glGetSamplerParameteriv','glSamplerParameterIiv','glSamplerParameterIuiv','glSamplerParameterf','glSamplerParameterfv','glSamplerParameteri','glSamplerParameteriv']
gl.add(GL_ARB_sampler_objects)

GL_ARB_seamless_cube_map = Extension('GL_ARB_seamless_cube_map')
GL_ARB_seamless_cube_map.url = 'http://www.opengl.org/registry/specs/ARB/seamless_cube_map.txt'
GL_ARB_seamless_cube_map.enumerants = ['GL_TEXTURE_CUBE_MAP_SEAMLESS']
gl.add(GL_ARB_seamless_cube_map)

GL_ARB_separate_shader_objects = Extension('GL_ARB_separate_shader_objects')
GL_ARB_separate_shader_objects.url = 'http://www.opengl.org/registry/specs/ARB/separate_shader_objects.txt'
GL_ARB_separate_shader_objects.enumerants = ['GL_ACTIVE_PROGRAM','GL_ALL_SHADER_BITS','GL_FRAGMENT_SHADER_BIT','GL_GEOMETRY_SHADER_BIT','GL_PROGRAM_PIPELINE_BINDING','GL_PROGRAM_SEPARABLE','GL_TESS_CONTROL_SHADER_BIT','GL_TESS_EVALUATION_SHADER_BIT','GL_VERTEX_SHADER_BIT']
GL_ARB_separate_shader_objects.functions = ['glIsProgramPipeline','glCreateShaderProgramv','glActiveShaderProgram','glBindProgramPipeline','glDeleteProgramPipelines','glGenProgramPipelines','glGetProgramPipelineInfoLog','glGetProgramPipelineiv','glProgramUniform1d','glProgramUniform1dv','glProgramUniform1f','glProgramUniform1fv','glProgramUniform1i','glProgramUniform1iv','glProgramUniform1ui','glProgramUniform1uiv','glProgramUniform2d','glProgramUniform2dv','glProgramUniform2f','glProgramUniform2fv','glProgramUniform2i','glProgramUniform2iv','glProgramUniform2ui','glProgramUniform2uiv','glProgramUniform3d','glProgramUniform3dv','glProgramUniform3f','glProgramUniform3fv','glProgramUniform3i','glProgramUniform3iv','glProgramUniform3ui','glProgramUniform3uiv','glProgramUniform4d','glProgramUniform4dv','glProgramUniform4f','glProgramUniform4fv','glProgramUniform4i','glProgramUniform4iv','glProgramUniform4ui','glProgramUniform4uiv','glProgramUniformMatrix2dv','glProgramUniformMatrix2fv','glProgramUniformMatrix2x3dv','glProgramUniformMatrix2x3fv','glProgramUniformMatrix2x4dv','glProgramUniformMatrix2x4fv','glProgramUniformMatrix3dv','glProgramUniformMatrix3fv','glProgramUniformMatrix3x2dv','glProgramUniformMatrix3x2fv','glProgramUniformMatrix3x4dv','glProgramUniformMatrix3x4fv','glProgramUniformMatrix4dv','glProgramUniformMatrix4fv','glProgramUniformMatrix4x2dv','glProgramUniformMatrix4x2fv','glProgramUniformMatrix4x3dv','glProgramUniformMatrix4x3fv','glUseProgramStages','glValidateProgramPipeline']
gl.add(GL_ARB_separate_shader_objects)

GL_ARB_shader_atomic_counters = Extension('GL_ARB_shader_atomic_counters')
GL_ARB_shader_atomic_counters.url = 'http://www.opengl.org/registry/specs/ARB/shader_atomic_counters.txt'
GL_ARB_shader_atomic_counters.enumerants = ['GL_ACTIVE_ATOMIC_COUNTER_BUFFERS','GL_ATOMIC_COUNTER_BUFFER','GL_ATOMIC_COUNTER_BUFFER_ACTIVE_ATOMIC_COUNTERS','GL_ATOMIC_COUNTER_BUFFER_ACTIVE_ATOMIC_COUNTER_INDICES','GL_ATOMIC_COUNTER_BUFFER_BINDING','GL_ATOMIC_COUNTER_BUFFER_DATA_SIZE','GL_ATOMIC_COUNTER_BUFFER_REFERENCED_BY_FRAGMENT_SHADER','GL_ATOMIC_COUNTER_BUFFER_REFERENCED_BY_GEOMETRY_SHADER','GL_ATOMIC_COUNTER_BUFFER_REFERENCED_BY_TESS_CONTROL_SHADER','GL_ATOMIC_COUNTER_BUFFER_REFERENCED_BY_TESS_EVALUATION_SHADER','GL_ATOMIC_COUNTER_BUFFER_REFERENCED_BY_VERTEX_SHADER','GL_ATOMIC_COUNTER_BUFFER_SIZE','GL_ATOMIC_COUNTER_BUFFER_START','GL_MAX_ATOMIC_COUNTER_BUFFER_BINDINGS','GL_MAX_ATOMIC_COUNTER_BUFFER_SIZE','GL_MAX_COMBINED_ATOMIC_COUNTERS','GL_MAX_COMBINED_ATOMIC_COUNTER_BUFFERS','GL_MAX_FRAGMENT_ATOMIC_COUNTERS','GL_MAX_FRAGMENT_ATOMIC_COUNTER_BUFFERS','GL_MAX_GEOMETRY_ATOMIC_COUNTERS','GL_MAX_GEOMETRY_ATOMIC_COUNTER_BUFFERS','GL_MAX_TESS_CONTROL_ATOMIC_COUNTERS','GL_MAX_TESS_CONTROL_ATOMIC_COUNTER_BUFFERS','GL_MAX_TESS_EVALUATION_ATOMIC_COUNTERS','GL_MAX_TESS_EVALUATION_ATOMIC_COUNTER_BUFFERS','GL_MAX_VERTEX_ATOMIC_COUNTERS','GL_MAX_VERTEX_ATOMIC_COUNTER_BUFFERS','GL_UNIFORM_ATOMIC_COUNTER_BUFFER_INDEX','GL_UNSIGNED_INT_ATOMIC_COUNTER']
GL_ARB_shader_atomic_counters.functions = ['glGetActiveAtomicCounterBufferiv']
gl.add(GL_ARB_shader_atomic_counters)

GL_ARB_shader_bit_encoding = Extension('GL_ARB_shader_bit_encoding')
GL_ARB_shader_bit_encoding.url = 'http://www.opengl.org/registry/specs/ARB/shader_bit_encoding.txt'
gl.add(GL_ARB_shader_bit_encoding)

GL_ARB_shader_image_load_store = Extension('GL_ARB_shader_image_load_store')
GL_ARB_shader_image_load_store.url = 'http://www.opengl.org/registry/specs/ARB/shader_image_load_store.txt'
GL_ARB_shader_image_load_store.enumerants = ['GL_ALL_BARRIER_BITS','GL_ATOMIC_COUNTER_BARRIER_BIT','GL_BUFFER_UPDATE_BARRIER_BIT','GL_COMMAND_BARRIER_BIT','GL_ELEMENT_ARRAY_BARRIER_BIT','GL_FRAMEBUFFER_BARRIER_BIT','GL_IMAGE_1D','GL_IMAGE_1D_ARRAY','GL_IMAGE_2D','GL_IMAGE_2D_ARRAY','GL_IMAGE_2D_MULTISAMPLE','GL_IMAGE_2D_MULTISAMPLE_ARRAY','GL_IMAGE_2D_RECT','GL_IMAGE_3D','GL_IMAGE_BINDING_ACCESS','GL_IMAGE_BINDING_FORMAT','GL_IMAGE_BINDING_LAYER','GL_IMAGE_BINDING_LAYERED','GL_IMAGE_BINDING_LEVEL','GL_IMAGE_BINDING_NAME','GL_IMAGE_BUFFER','GL_IMAGE_CUBE','GL_IMAGE_CUBE_MAP_ARRAY','GL_IMAGE_FORMAT_COMPATIBILITY_BY_CLASS','GL_IMAGE_FORMAT_COMPATIBILITY_BY_SIZE','GL_IMAGE_FORMAT_COMPATIBILITY_TYPE','GL_INT_IMAGE_1D','GL_INT_IMAGE_1D_ARRAY','GL_INT_IMAGE_2D','GL_INT_IMAGE_2D_ARRAY','GL_INT_IMAGE_2D_MULTISAMPLE','GL_INT_IMAGE_2D_MULTISAMPLE_ARRAY','GL_INT_IMAGE_2D_RECT','GL_INT_IMAGE_3D','GL_INT_IMAGE_BUFFER','GL_INT_IMAGE_CUBE','GL_INT_IMAGE_CUBE_MAP_ARRAY','GL_MAX_COMBINED_IMAGE_UNIFORMS','GL_MAX_COMBINED_IMAGE_UNITS_AND_FRAGMENT_OUTPUTS','GL_MAX_FRAGMENT_IMAGE_UNIFORMS','GL_MAX_GEOMETRY_IMAGE_UNIFORMS','GL_MAX_IMAGE_SAMPLES','GL_MAX_IMAGE_UNITS','GL_MAX_TESS_CONTROL_IMAGE_UNIFORMS','GL_MAX_TESS_EVALUATION_IMAGE_UNIFORMS','GL_MAX_VERTEX_IMAGE_UNIFORMS','GL_PIXEL_BUFFER_BARRIER_BIT','GL_SHADER_IMAGE_ACCESS_BARRIER_BIT','GL_TEXTURE_FETCH_BARRIER_BIT','GL_TEXTURE_UPDATE_BARRIER_BIT','GL_TRANSFORM_FEEDBACK_BARRIER_BIT','GL_UNIFORM_BARRIER_BIT','GL_UNSIGNED_INT_IMAGE_1D','GL_UNSIGNED_INT_IMAGE_1D_ARRAY','GL_UNSIGNED_INT_IMAGE_2D','GL_UNSIGNED_INT_IMAGE_2D_ARRAY','GL_UNSIGNED_INT_IMAGE_2D_MULTISAMPLE','GL_UNSIGNED_INT_IMAGE_2D_MULTISAMPLE_ARRAY','GL_UNSIGNED_INT_IMAGE_2D_RECT','GL_UNSIGNED_INT_IMAGE_3D','GL_UNSIGNED_INT_IMAGE_BUFFER','GL_UNSIGNED_INT_IMAGE_CUBE','GL_UNSIGNED_INT_IMAGE_CUBE_MAP_ARRAY','GL_VERTEX_ATTRIB_ARRAY_BARRIER_BIT']
GL_ARB_shader_image_load_store.functions = ['glBindImageTexture','glMemoryBarrier']
gl.add(GL_ARB_shader_image_load_store)

GL_ARB_shader_image_size = Extension('GL_ARB_shader_image_size')
GL_ARB_shader_image_size.url = 'http://www.opengl.org/registry/specs/ARB/shader_image_size.txt'
gl.add(GL_ARB_shader_image_size)

GL_ARB_shader_objects = Extension('GL_ARB_shader_objects')
GL_ARB_shader_objects.url = 'http://www.opengl.org/registry/specs/ARB/shader_objects.txt'
GL_ARB_shader_objects.enumerants = ['GL_BOOL_ARB','GL_BOOL_VEC2_ARB','GL_BOOL_VEC3_ARB','GL_BOOL_VEC4_ARB','GL_FLOAT_MAT2_ARB','GL_FLOAT_MAT3_ARB','GL_FLOAT_MAT4_ARB','GL_FLOAT_VEC2_ARB','GL_FLOAT_VEC3_ARB','GL_FLOAT_VEC4_ARB','GL_INT_VEC2_ARB','GL_INT_VEC3_ARB','GL_INT_VEC4_ARB','GL_OBJECT_ACTIVE_UNIFORMS_ARB','GL_OBJECT_ACTIVE_UNIFORM_MAX_LENGTH_ARB','GL_OBJECT_ATTACHED_OBJECTS_ARB','GL_OBJECT_COMPILE_STATUS_ARB','GL_OBJECT_DELETE_STATUS_ARB','GL_OBJECT_INFO_LOG_LENGTH_ARB','GL_OBJECT_LINK_STATUS_ARB','GL_OBJECT_SHADER_SOURCE_LENGTH_ARB','GL_OBJECT_SUBTYPE_ARB','GL_OBJECT_TYPE_ARB','GL_OBJECT_VALIDATE_STATUS_ARB','GL_PROGRAM_OBJECT_ARB','GL_SAMPLER_1D_ARB','GL_SAMPLER_1D_SHADOW_ARB','GL_SAMPLER_2D_ARB','GL_SAMPLER_2D_RECT_ARB','GL_SAMPLER_2D_RECT_SHADOW_ARB','GL_SAMPLER_2D_SHADOW_ARB','GL_SAMPLER_3D_ARB','GL_SAMPLER_CUBE_ARB','GL_SHADER_OBJECT_ARB']
GL_ARB_shader_objects.functions = ['glCreateProgramObjectARB','glCreateShaderObjectARB','glGetHandleARB','glGetUniformLocationARB','glAttachObjectARB','glCompileShaderARB','glDeleteObjectARB','glDetachObjectARB','glGetActiveUniformARB','glGetAttachedObjectsARB','glGetInfoLogARB','glGetObjectParameterfvARB','glGetObjectParameterivARB','glGetShaderSourceARB','glGetUniformfvARB','glGetUniformivARB','glLinkProgramARB','glShaderSourceARB','glUniform1fARB','glUniform1fvARB','glUniform1iARB','glUniform1ivARB','glUniform2fARB','glUniform2fvARB','glUniform2iARB','glUniform2ivARB','glUniform3fARB','glUniform3fvARB','glUniform3iARB','glUniform3ivARB','glUniform4fARB','glUniform4fvARB','glUniform4iARB','glUniform4ivARB','glUniformMatrix2fvARB','glUniformMatrix3fvARB','glUniformMatrix4fvARB','glUseProgramObjectARB','glValidateProgramARB']
gl.add(GL_ARB_shader_objects)

GL_ARB_shader_precision = Extension('GL_ARB_shader_precision')
GL_ARB_shader_precision.url = 'http://www.opengl.org/registry/specs/ARB/shader_precision.txt'
gl.add(GL_ARB_shader_precision)

GL_ARB_shader_stencil_export = Extension('GL_ARB_shader_stencil_export')
GL_ARB_shader_stencil_export.url = 'http://www.opengl.org/registry/specs/ARB/shader_stencil_export.txt'
gl.add(GL_ARB_shader_stencil_export)

GL_ARB_shader_storage_buffer_object = Extension('GL_ARB_shader_storage_buffer_object')
GL_ARB_shader_storage_buffer_object.url = 'http://www.opengl.org/registry/specs/ARB/shader_storage_buffer_object.txt'
GL_ARB_shader_storage_buffer_object.enumerants = ['GL_MAX_COMBINED_SHADER_OUTPUT_RESOURCES','GL_MAX_COMBINED_SHADER_STORAGE_BLOCKS','GL_MAX_COMPUTE_SHADER_STORAGE_BLOCKS','GL_MAX_FRAGMENT_SHADER_STORAGE_BLOCKS','GL_MAX_GEOMETRY_SHADER_STORAGE_BLOCKS','GL_MAX_SHADER_STORAGE_BLOCK_SIZE','GL_MAX_SHADER_STORAGE_BUFFER_BINDINGS','GL_MAX_TESS_CONTROL_SHADER_STORAGE_BLOCKS','GL_MAX_TESS_EVALUATION_SHADER_STORAGE_BLOCKS','GL_MAX_VERTEX_SHADER_STORAGE_BLOCKS','GL_SHADER_STORAGE_BARRIER_BIT','GL_SHADER_STORAGE_BUFFER','GL_SHADER_STORAGE_BUFFER_BINDING','GL_SHADER_STORAGE_BUFFER_OFFSET_ALIGNMENT','GL_SHADER_STORAGE_BUFFER_SIZE','GL_SHADER_STORAGE_BUFFER_START']
GL_ARB_shader_storage_buffer_object.functions = ['glShaderStorageBlockBinding']
gl.add(GL_ARB_shader_storage_buffer_object)

GL_ARB_shader_subroutine = Extension('GL_ARB_shader_subroutine')
GL_ARB_shader_subroutine.url = 'http://www.opengl.org/registry/specs/ARB/shader_subroutine.txt'
GL_ARB_shader_subroutine.enumerants = ['GL_ACTIVE_SUBROUTINES','GL_ACTIVE_SUBROUTINE_MAX_LENGTH','GL_ACTIVE_SUBROUTINE_UNIFORMS','GL_ACTIVE_SUBROUTINE_UNIFORM_LOCATIONS','GL_ACTIVE_SUBROUTINE_UNIFORM_MAX_LENGTH','GL_COMPATIBLE_SUBROUTINES','GL_MAX_SUBROUTINES','GL_MAX_SUBROUTINE_UNIFORM_LOCATIONS','GL_NUM_COMPATIBLE_SUBROUTINES']
GL_ARB_shader_subroutine.functions = ['glGetSubroutineUniformLocation','glGetSubroutineIndex','glGetActiveSubroutineName','glGetActiveSubroutineUniformName','glGetActiveSubroutineUniformiv','glGetProgramStageiv','glGetUniformSubroutineuiv','glUniformSubroutinesuiv']
gl.add(GL_ARB_shader_subroutine)

GL_ARB_shader_texture_lod = Extension('GL_ARB_shader_texture_lod')
GL_ARB_shader_texture_lod.url = 'http://www.opengl.org/registry/specs/ARB/shader_texture_lod.txt'
gl.add(GL_ARB_shader_texture_lod)

GL_ARB_shading_language_100 = Extension('GL_ARB_shading_language_100')
GL_ARB_shading_language_100.url = 'http://www.opengl.org/registry/specs/ARB/shading_language_100.txt'
GL_ARB_shading_language_100.enumerants = ['GL_SHADING_LANGUAGE_VERSION_ARB']
gl.add(GL_ARB_shading_language_100)

GL_ARB_shading_language_420pack = Extension('GL_ARB_shading_language_420pack')
GL_ARB_shading_language_420pack.url = 'http://www.opengl.org/registry/specs/ARB/shading_language_420pack.txt'
gl.add(GL_ARB_shading_language_420pack)

GL_ARB_shading_language_include = Extension('GL_ARB_shading_language_include')
GL_ARB_shading_language_include.url = 'http://www.opengl.org/registry/specs/ARB/shading_language_include.txt'
GL_ARB_shading_language_include.enumerants = ['GL_NAMED_STRING_LENGTH_ARB','GL_NAMED_STRING_TYPE_ARB','GL_SHADER_INCLUDE_ARB']
GL_ARB_shading_language_include.functions = ['glIsNamedStringARB','glCompileShaderIncludeARB','glDeleteNamedStringARB','glGetNamedStringARB','glGetNamedStringivARB','glNamedStringARB']
gl.add(GL_ARB_shading_language_include)

GL_ARB_shading_language_packing = Extension('GL_ARB_shading_language_packing')
GL_ARB_shading_language_packing.url = 'http://www.opengl.org/registry/specs/ARB/shading_language_packing.txt'
gl.add(GL_ARB_shading_language_packing)

GL_ARB_shadow = Extension('GL_ARB_shadow')
GL_ARB_shadow.url = 'http://www.opengl.org/registry/specs/ARB/shadow.txt'
GL_ARB_shadow.enumerants = ['GL_COMPARE_R_TO_TEXTURE_ARB','GL_TEXTURE_COMPARE_FUNC_ARB','GL_TEXTURE_COMPARE_MODE_ARB']
gl.add(GL_ARB_shadow)

GL_ARB_shadow_ambient = Extension('GL_ARB_shadow_ambient')
GL_ARB_shadow_ambient.url = 'http://www.opengl.org/registry/specs/ARB/shadow_ambient.txt'
GL_ARB_shadow_ambient.enumerants = ['GL_TEXTURE_COMPARE_FAIL_VALUE_ARB']
gl.add(GL_ARB_shadow_ambient)

GL_ARB_sparse_texture = Extension('GL_ARB_sparse_texture')
GL_ARB_sparse_texture.url = 'http://www.opengl.org/registry/specs/ARB/sparse_texture.txt'
GL_ARB_sparse_texture.enumerants = ['GL_MAX_SPARSE_3D_TEXTURE_SIZE_ARB','GL_MAX_SPARSE_ARRAY_TEXTURE_LAYERS_ARB','GL_MAX_SPARSE_TEXTURE_SIZE_ARB','GL_NUM_SPARSE_LEVELS_ARB','GL_NUM_VIRTUAL_PAGE_SIZES_ARB','GL_SPARSE_TEXTURE_FULL_ARRAY_CUBE_MIPMAPS_ARB','GL_TEXTURE_SPARSE_ARB','GL_VIRTUAL_PAGE_SIZE_INDEX_ARB','GL_VIRTUAL_PAGE_SIZE_X_ARB','GL_VIRTUAL_PAGE_SIZE_Y_ARB','GL_VIRTUAL_PAGE_SIZE_Z_ARB']
GL_ARB_sparse_texture.functions = ['glTexPageCommitmentARB','glTexturePageCommitmentEXT']
gl.add(GL_ARB_sparse_texture)

GL_ARB_stencil_texturing = Extension('GL_ARB_stencil_texturing')
GL_ARB_stencil_texturing.url = 'http://www.opengl.org/registry/specs/ARB/stencil_texturing.txt'
GL_ARB_stencil_texturing.enumerants = ['GL_DEPTH_STENCIL_TEXTURE_MODE']
gl.add(GL_ARB_stencil_texturing)

GL_ARB_sync = Extension('GL_ARB_sync')
GL_ARB_sync.url = 'http://www.opengl.org/registry/specs/ARB/sync.txt'
GL_ARB_sync.enumerants = ['GL_ALREADY_SIGNALED','GL_CONDITION_SATISFIED','GL_MAX_SERVER_WAIT_TIMEOUT','GL_OBJECT_TYPE','GL_SIGNALED','GL_SYNC_CONDITION','GL_SYNC_FENCE','GL_SYNC_FLAGS','GL_SYNC_FLUSH_COMMANDS_BIT','GL_SYNC_GPU_COMMANDS_COMPLETE','GL_SYNC_STATUS','GL_TIMEOUT_EXPIRED','GL_TIMEOUT_IGNORED','GL_UNSIGNALED','GL_WAIT_FAILED']
GL_ARB_sync.functions = ['glIsSync','glClientWaitSync','glFenceSync','glDeleteSync','glGetInteger64v','glGetSynciv','glWaitSync']
gl.add(GL_ARB_sync)

GL_ARB_tessellation_shader = Extension('GL_ARB_tessellation_shader')
GL_ARB_tessellation_shader.url = 'http://www.opengl.org/registry/specs/ARB/tessellation_shader.txt'
GL_ARB_tessellation_shader.enumerants = ['GL_FRACTIONAL_EVEN','GL_FRACTIONAL_ODD','GL_ISOLINES','GL_MAX_COMBINED_TESS_CONTROL_UNIFORM_COMPONENTS','GL_MAX_COMBINED_TESS_EVALUATION_UNIFORM_COMPONENTS','GL_MAX_PATCH_VERTICES','GL_MAX_TESS_CONTROL_INPUT_COMPONENTS','GL_MAX_TESS_CONTROL_OUTPUT_COMPONENTS','GL_MAX_TESS_CONTROL_TEXTURE_IMAGE_UNITS','GL_MAX_TESS_CONTROL_TOTAL_OUTPUT_COMPONENTS','GL_MAX_TESS_CONTROL_UNIFORM_BLOCKS','GL_MAX_TESS_CONTROL_UNIFORM_COMPONENTS','GL_MAX_TESS_EVALUATION_INPUT_COMPONENTS','GL_MAX_TESS_EVALUATION_OUTPUT_COMPONENTS','GL_MAX_TESS_EVALUATION_TEXTURE_IMAGE_UNITS','GL_MAX_TESS_EVALUATION_UNIFORM_BLOCKS','GL_MAX_TESS_EVALUATION_UNIFORM_COMPONENTS','GL_MAX_TESS_GEN_LEVEL','GL_MAX_TESS_PATCH_COMPONENTS','GL_PATCHES','GL_PATCH_DEFAULT_INNER_LEVEL','GL_PATCH_DEFAULT_OUTER_LEVEL','GL_PATCH_VERTICES','GL_TESS_CONTROL_OUTPUT_VERTICES','GL_TESS_CONTROL_SHADER','GL_TESS_EVALUATION_SHADER','GL_TESS_GEN_MODE','GL_TESS_GEN_POINT_MODE','GL_TESS_GEN_SPACING','GL_TESS_GEN_VERTEX_ORDER','GL_UNIFORM_BLOCK_REFERENCED_BY_TESS_CONTROL_SHADER','GL_UNIFORM_BLOCK_REFERENCED_BY_TESS_EVALUATION_SHADER']
GL_ARB_tessellation_shader.functions = ['glPatchParameterfv','glPatchParameteri']
gl.add(GL_ARB_tessellation_shader)

GL_ARB_texture_border_clamp = Extension('GL_ARB_texture_border_clamp')
GL_ARB_texture_border_clamp.url = 'http://www.opengl.org/registry/specs/ARB/texture_border_clamp.txt'
GL_ARB_texture_border_clamp.enumerants = ['GL_CLAMP_TO_BORDER_ARB']
gl.add(GL_ARB_texture_border_clamp)

GL_ARB_texture_buffer_object = Extension('GL_ARB_texture_buffer_object')
GL_ARB_texture_buffer_object.url = 'http://www.opengl.org/registry/specs/ARB/texture_buffer_object.txt'
GL_ARB_texture_buffer_object.enumerants = ['GL_MAX_TEXTURE_BUFFER_SIZE_ARB','GL_TEXTURE_BINDING_BUFFER_ARB','GL_TEXTURE_BUFFER_ARB','GL_TEXTURE_BUFFER_DATA_STORE_BINDING_ARB','GL_TEXTURE_BUFFER_FORMAT_ARB']
GL_ARB_texture_buffer_object.functions = ['glTexBufferARB']
gl.add(GL_ARB_texture_buffer_object)

GL_ARB_texture_buffer_object_rgb32 = Extension('GL_ARB_texture_buffer_object_rgb32')
GL_ARB_texture_buffer_object_rgb32.url = 'http://www.opengl.org/registry/specs/ARB/texture_buffer_object_rgb32.txt'
gl.add(GL_ARB_texture_buffer_object_rgb32)

GL_ARB_texture_buffer_range = Extension('GL_ARB_texture_buffer_range')
GL_ARB_texture_buffer_range.url = 'http://www.opengl.org/registry/specs/ARB/texture_buffer_range.txt'
GL_ARB_texture_buffer_range.enumerants = ['GL_TEXTURE_BUFFER_OFFSET','GL_TEXTURE_BUFFER_OFFSET_ALIGNMENT','GL_TEXTURE_BUFFER_SIZE']
GL_ARB_texture_buffer_range.functions = ['glTexBufferRange','glTextureBufferRangeEXT']
gl.add(GL_ARB_texture_buffer_range)

GL_ARB_texture_compression = Extension('GL_ARB_texture_compression')
GL_ARB_texture_compression.url = 'http://www.opengl.org/registry/specs/ARB/texture_compression.txt'
GL_ARB_texture_compression.enumerants = ['GL_COMPRESSED_ALPHA_ARB','GL_COMPRESSED_INTENSITY_ARB','GL_COMPRESSED_LUMINANCE_ALPHA_ARB','GL_COMPRESSED_LUMINANCE_ARB','GL_COMPRESSED_RGBA_ARB','GL_COMPRESSED_RGB_ARB','GL_COMPRESSED_TEXTURE_FORMATS_ARB','GL_NUM_COMPRESSED_TEXTURE_FORMATS_ARB','GL_TEXTURE_COMPRESSED_ARB','GL_TEXTURE_COMPRESSED_IMAGE_SIZE_ARB','GL_TEXTURE_COMPRESSION_HINT_ARB']
GL_ARB_texture_compression.functions = ['glCompressedTexImage1DARB','glCompressedTexImage2DARB','glCompressedTexImage3DARB','glCompressedTexSubImage1DARB','glCompressedTexSubImage2DARB','glCompressedTexSubImage3DARB','glGetCompressedTexImageARB']
gl.add(GL_ARB_texture_compression)

GL_ARB_texture_compression_bptc = Extension('GL_ARB_texture_compression_bptc')
GL_ARB_texture_compression_bptc.url = 'http://www.opengl.org/registry/specs/ARB/texture_compression_bptc.txt'
GL_ARB_texture_compression_bptc.enumerants = ['GL_COMPRESSED_RGBA_BPTC_UNORM_ARB','GL_COMPRESSED_RGB_BPTC_SIGNED_FLOAT_ARB','GL_COMPRESSED_RGB_BPTC_UNSIGNED_FLOAT_ARB','GL_COMPRESSED_SRGB_ALPHA_BPTC_UNORM_ARB']
gl.add(GL_ARB_texture_compression_bptc)

GL_ARB_texture_compression_rgtc = Extension('GL_ARB_texture_compression_rgtc')
GL_ARB_texture_compression_rgtc.url = 'http://www.opengl.org/registry/specs/ARB/texture_compression_rgtc.txt'
GL_ARB_texture_compression_rgtc.enumerants = ['GL_COMPRESSED_RED_RGTC1','GL_COMPRESSED_RG_RGTC2','GL_COMPRESSED_SIGNED_RED_RGTC1','GL_COMPRESSED_SIGNED_RG_RGTC2']
gl.add(GL_ARB_texture_compression_rgtc)

GL_ARB_texture_cube_map = Extension('GL_ARB_texture_cube_map')
GL_ARB_texture_cube_map.url = 'http://www.opengl.org/registry/specs/ARB/texture_cube_map.txt'
GL_ARB_texture_cube_map.enumerants = ['GL_MAX_CUBE_MAP_TEXTURE_SIZE_ARB','GL_NORMAL_MAP_ARB','GL_PROXY_TEXTURE_CUBE_MAP_ARB','GL_REFLECTION_MAP_ARB','GL_TEXTURE_BINDING_CUBE_MAP_ARB','GL_TEXTURE_CUBE_MAP_ARB','GL_TEXTURE_CUBE_MAP_NEGATIVE_X_ARB','GL_TEXTURE_CUBE_MAP_NEGATIVE_Y_ARB','GL_TEXTURE_CUBE_MAP_NEGATIVE_Z_ARB','GL_TEXTURE_CUBE_MAP_POSITIVE_X_ARB','GL_TEXTURE_CUBE_MAP_POSITIVE_Y_ARB','GL_TEXTURE_CUBE_MAP_POSITIVE_Z_ARB']
gl.add(GL_ARB_texture_cube_map)

GL_ARB_texture_cube_map_array = Extension('GL_ARB_texture_cube_map_array')
GL_ARB_texture_cube_map_array.url = 'http://www.opengl.org/registry/specs/ARB/texture_cube_map_array.txt'
GL_ARB_texture_cube_map_array.enumerants = ['GL_INT_SAMPLER_CUBE_MAP_ARRAY_ARB','GL_PROXY_TEXTURE_CUBE_MAP_ARRAY_ARB','GL_SAMPLER_CUBE_MAP_ARRAY_ARB','GL_SAMPLER_CUBE_MAP_ARRAY_SHADOW_ARB','GL_TEXTURE_BINDING_CUBE_MAP_ARRAY_ARB','GL_TEXTURE_CUBE_MAP_ARRAY_ARB','GL_UNSIGNED_INT_SAMPLER_CUBE_MAP_ARRAY_ARB']
gl.add(GL_ARB_texture_cube_map_array)

GL_ARB_texture_env_add = Extension('GL_ARB_texture_env_add')
GL_ARB_texture_env_add.url = 'http://www.opengl.org/registry/specs/ARB/texture_env_add.txt'
gl.add(GL_ARB_texture_env_add)

GL_ARB_texture_env_combine = Extension('GL_ARB_texture_env_combine')
GL_ARB_texture_env_combine.url = 'http://www.opengl.org/registry/specs/ARB/texture_env_combine.txt'
GL_ARB_texture_env_combine.enumerants = ['GL_ADD_SIGNED_ARB','GL_COMBINE_ALPHA_ARB','GL_COMBINE_ARB','GL_COMBINE_RGB_ARB','GL_CONSTANT_ARB','GL_INTERPOLATE_ARB','GL_OPERAND0_ALPHA_ARB','GL_OPERAND0_RGB_ARB','GL_OPERAND1_ALPHA_ARB','GL_OPERAND1_RGB_ARB','GL_OPERAND2_ALPHA_ARB','GL_OPERAND2_RGB_ARB','GL_PREVIOUS_ARB','GL_PRIMARY_COLOR_ARB','GL_RGB_SCALE_ARB','GL_SOURCE0_ALPHA_ARB','GL_SOURCE0_RGB_ARB','GL_SOURCE1_ALPHA_ARB','GL_SOURCE1_RGB_ARB','GL_SOURCE2_ALPHA_ARB','GL_SOURCE2_RGB_ARB','GL_SUBTRACT_ARB']
gl.add(GL_ARB_texture_env_combine)

GL_ARB_texture_env_crossbar = Extension('GL_ARB_texture_env_crossbar')
GL_ARB_texture_env_crossbar.url = 'http://www.opengl.org/registry/specs/ARB/texture_env_crossbar.txt'
gl.add(GL_ARB_texture_env_crossbar)

GL_ARB_texture_env_dot3 = Extension('GL_ARB_texture_env_dot3')
GL_ARB_texture_env_dot3.url = 'http://www.opengl.org/registry/specs/ARB/texture_env_dot3.txt'
GL_ARB_texture_env_dot3.enumerants = ['GL_DOT3_RGBA_ARB','GL_DOT3_RGB_ARB']
gl.add(GL_ARB_texture_env_dot3)

GL_ARB_texture_float = Extension('GL_ARB_texture_float')
GL_ARB_texture_float.url = 'http://www.opengl.org/registry/specs/ARB/texture_float.txt'
GL_ARB_texture_float.enumerants = ['GL_ALPHA16F_ARB','GL_ALPHA32F_ARB','GL_INTENSITY16F_ARB','GL_INTENSITY32F_ARB','GL_LUMINANCE16F_ARB','GL_LUMINANCE32F_ARB','GL_LUMINANCE_ALPHA16F_ARB','GL_LUMINANCE_ALPHA32F_ARB','GL_RGB16F_ARB','GL_RGB32F_ARB','GL_RGBA16F_ARB','GL_RGBA32F_ARB','GL_TEXTURE_ALPHA_TYPE_ARB','GL_TEXTURE_BLUE_TYPE_ARB','GL_TEXTURE_DEPTH_TYPE_ARB','GL_TEXTURE_GREEN_TYPE_ARB','GL_TEXTURE_INTENSITY_TYPE_ARB','GL_TEXTURE_LUMINANCE_TYPE_ARB','GL_TEXTURE_RED_TYPE_ARB','GL_UNSIGNED_NORMALIZED_ARB']
gl.add(GL_ARB_texture_float)

GL_ARB_texture_gather = Extension('GL_ARB_texture_gather')
GL_ARB_texture_gather.url = 'http://www.opengl.org/registry/specs/ARB/texture_gather.txt'
GL_ARB_texture_gather.enumerants = ['GL_MAX_PROGRAM_TEXTURE_GATHER_COMPONENTS_ARB','GL_MAX_PROGRAM_TEXTURE_GATHER_OFFSET_ARB','GL_MIN_PROGRAM_TEXTURE_GATHER_OFFSET_ARB']
gl.add(GL_ARB_texture_gather)

GL_ARB_texture_mirror_clamp_to_edge = Extension('GL_ARB_texture_mirror_clamp_to_edge')
GL_ARB_texture_mirror_clamp_to_edge.url = 'http://www.opengl.org/registry/specs/ARB/texture_mirror_clamp_to_edge.txt'
GL_ARB_texture_mirror_clamp_to_edge.enumerants = ['GL_MIRROR_CLAMP_TO_EDGE']
GL_ARB_texture_mirror_clamp_to_edge.functions = ['']
gl.add(GL_ARB_texture_mirror_clamp_to_edge)

GL_ARB_texture_mirrored_repeat = Extension('GL_ARB_texture_mirrored_repeat')
GL_ARB_texture_mirrored_repeat.url = 'http://www.opengl.org/registry/specs/ARB/texture_mirrored_repeat.txt'
GL_ARB_texture_mirrored_repeat.enumerants = ['GL_MIRRORED_REPEAT_ARB']
gl.add(GL_ARB_texture_mirrored_repeat)

GL_ARB_texture_multisample = Extension('GL_ARB_texture_multisample')
GL_ARB_texture_multisample.url = 'http://www.opengl.org/registry/specs/ARB/texture_multisample.txt'
GL_ARB_texture_multisample.enumerants = ['GL_INT_SAMPLER_2D_MULTISAMPLE','GL_INT_SAMPLER_2D_MULTISAMPLE_ARRAY','GL_MAX_COLOR_TEXTURE_SAMPLES','GL_MAX_DEPTH_TEXTURE_SAMPLES','GL_MAX_INTEGER_SAMPLES','GL_MAX_SAMPLE_MASK_WORDS','GL_PROXY_TEXTURE_2D_MULTISAMPLE','GL_PROXY_TEXTURE_2D_MULTISAMPLE_ARRAY','GL_SAMPLER_2D_MULTISAMPLE','GL_SAMPLER_2D_MULTISAMPLE_ARRAY','GL_SAMPLE_MASK','GL_SAMPLE_MASK_VALUE','GL_SAMPLE_POSITION','GL_TEXTURE_2D_MULTISAMPLE','GL_TEXTURE_2D_MULTISAMPLE_ARRAY','GL_TEXTURE_BINDING_2D_MULTISAMPLE','GL_TEXTURE_BINDING_2D_MULTISAMPLE_ARRAY','GL_TEXTURE_FIXED_SAMPLE_LOCATIONS','GL_TEXTURE_SAMPLES','GL_UNSIGNED_INT_SAMPLER_2D_MULTISAMPLE','GL_UNSIGNED_INT_SAMPLER_2D_MULTISAMPLE_ARRAY']
GL_ARB_texture_multisample.functions = ['glGetMultisamplefv','glSampleMaski','glTexImage2DMultisample','glTexImage3DMultisample']
gl.add(GL_ARB_texture_multisample)

GL_ARB_texture_non_power_of_two = Extension('GL_ARB_texture_non_power_of_two')
GL_ARB_texture_non_power_of_two.url = 'http://www.opengl.org/registry/specs/ARB/texture_non_power_of_two.txt'
gl.add(GL_ARB_texture_non_power_of_two)

GL_ARB_texture_query_levels = Extension('GL_ARB_texture_query_levels')
GL_ARB_texture_query_levels.url = 'http://www.opengl.org/registry/specs/ARB/texture_query_levels.txt'
gl.add(GL_ARB_texture_query_levels)

GL_ARB_texture_query_lod = Extension('GL_ARB_texture_query_lod')
GL_ARB_texture_query_lod.url = 'http://www.opengl.org/registry/specs/ARB/texture_query_lod.txt'
gl.add(GL_ARB_texture_query_lod)

GL_ARB_texture_rectangle = Extension('GL_ARB_texture_rectangle')
GL_ARB_texture_rectangle.url = 'http://www.opengl.org/registry/specs/ARB/texture_rectangle.txt'
GL_ARB_texture_rectangle.enumerants = ['GL_MAX_RECTANGLE_TEXTURE_SIZE_ARB','GL_PROXY_TEXTURE_RECTANGLE_ARB','GL_TEXTURE_BINDING_RECTANGLE_ARB','GL_TEXTURE_RECTANGLE_ARB']
gl.add(GL_ARB_texture_rectangle)

GL_ARB_texture_rg = Extension('GL_ARB_texture_rg')
GL_ARB_texture_rg.url = 'http://www.opengl.org/registry/specs/ARB/texture_rg.txt'
GL_ARB_texture_rg.enumerants = ['GL_COMPRESSED_RED','GL_COMPRESSED_RG','GL_R16','GL_R16F','GL_R16I','GL_R16UI','GL_R32F','GL_R32I','GL_R32UI','GL_R8','GL_R8I','GL_R8UI','GL_RG','GL_RG16','GL_RG16F','GL_RG16I','GL_RG16UI','GL_RG32F','GL_RG32I','GL_RG32UI','GL_RG8','GL_RG8I','GL_RG8UI','GL_RG_INTEGER']
gl.add(GL_ARB_texture_rg)

GL_ARB_texture_rgb10_a2ui = Extension('GL_ARB_texture_rgb10_a2ui')
GL_ARB_texture_rgb10_a2ui.url = 'http://www.opengl.org/registry/specs/ARB/texture_rgb10_a2ui.txt'
GL_ARB_texture_rgb10_a2ui.enumerants = ['GL_RGB10_A2UI']
gl.add(GL_ARB_texture_rgb10_a2ui)

GL_ARB_texture_stencil8 = Extension('GL_ARB_texture_stencil8')
GL_ARB_texture_stencil8.url = 'http://www.opengl.org/registry/specs/ARB/texture_stencil8.txt'
GL_ARB_texture_stencil8.enumerants = ['GL_STENCIL_INDEX8']
GL_ARB_texture_stencil8.functions = ['']
gl.add(GL_ARB_texture_stencil8)

GL_ARB_texture_storage = Extension('GL_ARB_texture_storage')
GL_ARB_texture_storage.url = 'http://www.opengl.org/registry/specs/ARB/texture_storage.txt'
GL_ARB_texture_storage.enumerants = ['GL_TEXTURE_IMMUTABLE_FORMAT']
GL_ARB_texture_storage.functions = ['glTexStorage1D','glTexStorage2D','glTexStorage3D','glTextureStorage1DEXT','glTextureStorage2DEXT','glTextureStorage3DEXT']
gl.add(GL_ARB_texture_storage)

GL_ARB_texture_storage_multisample = Extension('GL_ARB_texture_storage_multisample')
GL_ARB_texture_storage_multisample.url = 'http://www.opengl.org/registry/specs/ARB/texture_storage_multisample.txt'
GL_ARB_texture_storage_multisample.functions = ['glTexStorage2DMultisample','glTexStorage3DMultisample','glTextureStorage2DMultisampleEXT','glTextureStorage3DMultisampleEXT']
gl.add(GL_ARB_texture_storage_multisample)

GL_ARB_texture_swizzle = Extension('GL_ARB_texture_swizzle')
GL_ARB_texture_swizzle.url = 'http://www.opengl.org/registry/specs/ARB/texture_swizzle.txt'
GL_ARB_texture_swizzle.enumerants = ['GL_TEXTURE_SWIZZLE_A','GL_TEXTURE_SWIZZLE_B','GL_TEXTURE_SWIZZLE_G','GL_TEXTURE_SWIZZLE_R','GL_TEXTURE_SWIZZLE_RGBA']
gl.add(GL_ARB_texture_swizzle)

GL_ARB_texture_view = Extension('GL_ARB_texture_view')
GL_ARB_texture_view.url = 'http://www.opengl.org/registry/specs/ARB/texture_view.txt'
GL_ARB_texture_view.enumerants = ['GL_TEXTURE_IMMUTABLE_LEVELS','GL_TEXTURE_VIEW_MIN_LAYER','GL_TEXTURE_VIEW_MIN_LEVEL','GL_TEXTURE_VIEW_NUM_LAYERS','GL_TEXTURE_VIEW_NUM_LEVELS']
GL_ARB_texture_view.functions = ['glTextureView']
gl.add(GL_ARB_texture_view)

GL_ARB_timer_query = Extension('GL_ARB_timer_query')
GL_ARB_timer_query.url = 'http://www.opengl.org/registry/specs/ARB/timer_query.txt'
GL_ARB_timer_query.enumerants = ['GL_TIMESTAMP','GL_TIME_ELAPSED']
GL_ARB_timer_query.functions = ['glGetQueryObjecti64v','glGetQueryObjectui64v','glQueryCounter']
gl.add(GL_ARB_timer_query)

GL_ARB_transform_feedback2 = Extension('GL_ARB_transform_feedback2')
GL_ARB_transform_feedback2.url = 'http://www.opengl.org/registry/specs/ARB/transform_feedback2.txt'
GL_ARB_transform_feedback2.enumerants = ['GL_TRANSFORM_FEEDBACK','GL_TRANSFORM_FEEDBACK_BINDING','GL_TRANSFORM_FEEDBACK_BUFFER_ACTIVE','GL_TRANSFORM_FEEDBACK_BUFFER_PAUSED']
GL_ARB_transform_feedback2.functions = ['glIsTransformFeedback','glBindTransformFeedback','glDeleteTransformFeedbacks','glDrawTransformFeedback','glGenTransformFeedbacks','glPauseTransformFeedback','glResumeTransformFeedback']
gl.add(GL_ARB_transform_feedback2)

GL_ARB_transform_feedback3 = Extension('GL_ARB_transform_feedback3')
GL_ARB_transform_feedback3.url = 'http://www.opengl.org/registry/specs/ARB/transform_feedback3.txt'
GL_ARB_transform_feedback3.enumerants = ['GL_MAX_TRANSFORM_FEEDBACK_BUFFERS','GL_MAX_VERTEX_STREAMS']
GL_ARB_transform_feedback3.functions = ['glBeginQueryIndexed','glDrawTransformFeedbackStream','glEndQueryIndexed','glGetQueryIndexediv']
gl.add(GL_ARB_transform_feedback3)

GL_ARB_transform_feedback_instanced = Extension('GL_ARB_transform_feedback_instanced')
GL_ARB_transform_feedback_instanced.url = 'http://www.opengl.org/registry/specs/ARB/transform_feedback_instanced.txt'
GL_ARB_transform_feedback_instanced.functions = ['glDrawTransformFeedbackInstanced','glDrawTransformFeedbackStreamInstanced']
gl.add(GL_ARB_transform_feedback_instanced)

GL_ARB_transpose_matrix = Extension('GL_ARB_transpose_matrix')
GL_ARB_transpose_matrix.url = 'http://www.opengl.org/registry/specs/ARB/transpose_matrix.txt'
GL_ARB_transpose_matrix.enumerants = ['GL_TRANSPOSE_COLOR_MATRIX_ARB','GL_TRANSPOSE_MODELVIEW_MATRIX_ARB','GL_TRANSPOSE_PROJECTION_MATRIX_ARB','GL_TRANSPOSE_TEXTURE_MATRIX_ARB']
GL_ARB_transpose_matrix.functions = ['glLoadTransposeMatrixdARB','glLoadTransposeMatrixfARB','glMultTransposeMatrixdARB','glMultTransposeMatrixfARB']
gl.add(GL_ARB_transpose_matrix)

GL_ARB_uniform_buffer_object = Extension('GL_ARB_uniform_buffer_object')
GL_ARB_uniform_buffer_object.url = 'http://www.opengl.org/registry/specs/ARB/uniform_buffer_object.txt'
GL_ARB_uniform_buffer_object.enumerants = ['GL_ACTIVE_UNIFORM_BLOCKS','GL_ACTIVE_UNIFORM_BLOCK_MAX_NAME_LENGTH','GL_INVALID_INDEX','GL_MAX_COMBINED_FRAGMENT_UNIFORM_COMPONENTS','GL_MAX_COMBINED_GEOMETRY_UNIFORM_COMPONENTS','GL_MAX_COMBINED_UNIFORM_BLOCKS','GL_MAX_COMBINED_VERTEX_UNIFORM_COMPONENTS','GL_MAX_FRAGMENT_UNIFORM_BLOCKS','GL_MAX_GEOMETRY_UNIFORM_BLOCKS','GL_MAX_UNIFORM_BLOCK_SIZE','GL_MAX_UNIFORM_BUFFER_BINDINGS','GL_MAX_VERTEX_UNIFORM_BLOCKS','GL_UNIFORM_ARRAY_STRIDE','GL_UNIFORM_BLOCK_ACTIVE_UNIFORMS','GL_UNIFORM_BLOCK_ACTIVE_UNIFORM_INDICES','GL_UNIFORM_BLOCK_BINDING','GL_UNIFORM_BLOCK_DATA_SIZE','GL_UNIFORM_BLOCK_INDEX','GL_UNIFORM_BLOCK_NAME_LENGTH','GL_UNIFORM_BLOCK_REFERENCED_BY_FRAGMENT_SHADER','GL_UNIFORM_BLOCK_REFERENCED_BY_GEOMETRY_SHADER','GL_UNIFORM_BLOCK_REFERENCED_BY_VERTEX_SHADER','GL_UNIFORM_BUFFER','GL_UNIFORM_BUFFER_BINDING','GL_UNIFORM_BUFFER_OFFSET_ALIGNMENT','GL_UNIFORM_BUFFER_SIZE','GL_UNIFORM_BUFFER_START','GL_UNIFORM_IS_ROW_MAJOR','GL_UNIFORM_MATRIX_STRIDE','GL_UNIFORM_NAME_LENGTH','GL_UNIFORM_OFFSET','GL_UNIFORM_SIZE','GL_UNIFORM_TYPE']
GL_ARB_uniform_buffer_object.functions = ['glGetUniformBlockIndex','glBindBufferBase','glBindBufferRange','glGetActiveUniformBlockName','glGetActiveUniformBlockiv','glGetActiveUniformName','glGetActiveUniformsiv','glGetIntegeri_v','glGetUniformIndices','glUniformBlockBinding']
gl.add(GL_ARB_uniform_buffer_object)

GL_ARB_vertex_array_bgra = Extension('GL_ARB_vertex_array_bgra')
GL_ARB_vertex_array_bgra.url = 'http://www.opengl.org/registry/specs/ARB/vertex_array_bgra.txt'
GL_ARB_vertex_array_bgra.enumerants = ['GL_BGRA']
gl.add(GL_ARB_vertex_array_bgra)

GL_ARB_vertex_array_object = Extension('GL_ARB_vertex_array_object')
GL_ARB_vertex_array_object.url = 'http://www.opengl.org/registry/specs/ARB/vertex_array_object.txt'
GL_ARB_vertex_array_object.enumerants = ['GL_VERTEX_ARRAY_BINDING']
GL_ARB_vertex_array_object.functions = ['glIsVertexArray','glBindVertexArray','glDeleteVertexArrays','glGenVertexArrays']
gl.add(GL_ARB_vertex_array_object)

GL_ARB_vertex_attrib_64bit = Extension('GL_ARB_vertex_attrib_64bit')
GL_ARB_vertex_attrib_64bit.url = 'http://www.opengl.org/registry/specs/ARB/vertex_attrib_64bit.txt'
GL_ARB_vertex_attrib_64bit.functions = ['glGetVertexAttribLdv','glVertexAttribL1d','glVertexAttribL1dv','glVertexAttribL2d','glVertexAttribL2dv','glVertexAttribL3d','glVertexAttribL3dv','glVertexAttribL4d','glVertexAttribL4dv','glVertexAttribLPointer']
gl.add(GL_ARB_vertex_attrib_64bit)

GL_ARB_vertex_attrib_binding = Extension('GL_ARB_vertex_attrib_binding')
GL_ARB_vertex_attrib_binding.url = 'http://www.opengl.org/registry/specs/ARB/vertex_attrib_binding.txt'
GL_ARB_vertex_attrib_binding.enumerants = ['GL_MAX_VERTEX_ATTRIB_BINDINGS','GL_MAX_VERTEX_ATTRIB_RELATIVE_OFFSET','GL_VERTEX_ATTRIB_BINDING','GL_VERTEX_ATTRIB_RELATIVE_OFFSET','GL_VERTEX_BINDING_DIVISOR','GL_VERTEX_BINDING_OFFSET','GL_VERTEX_BINDING_STRIDE']
GL_ARB_vertex_attrib_binding.functions = ['glBindVertexBuffer','glVertexAttribBinding','glVertexAttribFormat','glVertexAttribIFormat','glVertexAttribLFormat','glVertexBindingDivisor']
gl.add(GL_ARB_vertex_attrib_binding)

GL_ARB_vertex_blend = Extension('GL_ARB_vertex_blend')
GL_ARB_vertex_blend.url = 'http://oss.sgi.com/projects/ogl-sample/registry/ARB/vertex_blend.txt'
GL_ARB_vertex_blend.enumerants = ['GL_ACTIVE_VERTEX_UNITS_ARB','GL_CURRENT_WEIGHT_ARB','GL_MAX_VERTEX_UNITS_ARB','GL_MODELVIEW0_ARB','GL_MODELVIEW10_ARB','GL_MODELVIEW11_ARB','GL_MODELVIEW12_ARB','GL_MODELVIEW13_ARB','GL_MODELVIEW14_ARB','GL_MODELVIEW15_ARB','GL_MODELVIEW16_ARB','GL_MODELVIEW17_ARB','GL_MODELVIEW18_ARB','GL_MODELVIEW19_ARB','GL_MODELVIEW1_ARB','GL_MODELVIEW20_ARB','GL_MODELVIEW21_ARB','GL_MODELVIEW22_ARB','GL_MODELVIEW23_ARB','GL_MODELVIEW24_ARB','GL_MODELVIEW25_ARB','GL_MODELVIEW26_ARB','GL_MODELVIEW27_ARB','GL_MODELVIEW28_ARB','GL_MODELVIEW29_ARB','GL_MODELVIEW2_ARB','GL_MODELVIEW30_ARB','GL_MODELVIEW31_ARB','GL_MODELVIEW3_ARB','GL_MODELVIEW4_ARB','GL_MODELVIEW5_ARB','GL_MODELVIEW6_ARB','GL_MODELVIEW7_ARB','GL_MODELVIEW8_ARB','GL_MODELVIEW9_ARB','GL_VERTEX_BLEND_ARB','GL_WEIGHT_ARRAY_ARB','GL_WEIGHT_ARRAY_POINTER_ARB','GL_WEIGHT_ARRAY_SIZE_ARB','GL_WEIGHT_ARRAY_STRIDE_ARB','GL_WEIGHT_ARRAY_TYPE_ARB','GL_WEIGHT_SUM_UNITY_ARB']
GL_ARB_vertex_blend.functions = ['glVertexBlendARB','glWeightPointerARB','glWeightbvARB','glWeightdvARB','glWeightfvARB','glWeightivARB','glWeightsvARB','glWeightubvARB','glWeightuivARB','glWeightusvARB']
gl.add(GL_ARB_vertex_blend)

GL_ARB_vertex_buffer_object = Extension('GL_ARB_vertex_buffer_object')
GL_ARB_vertex_buffer_object.url = 'http://www.opengl.org/registry/specs/ARB/vertex_buffer_object.txt'
GL_ARB_vertex_buffer_object.enumerants = ['GL_ARRAY_BUFFER_ARB','GL_ARRAY_BUFFER_BINDING_ARB','GL_BUFFER_ACCESS_ARB','GL_BUFFER_MAPPED_ARB','GL_BUFFER_MAP_POINTER_ARB','GL_BUFFER_SIZE_ARB','GL_BUFFER_USAGE_ARB','GL_COLOR_ARRAY_BUFFER_BINDING_ARB','GL_DYNAMIC_COPY_ARB','GL_DYNAMIC_DRAW_ARB','GL_DYNAMIC_READ_ARB','GL_EDGE_FLAG_ARRAY_BUFFER_BINDING_ARB','GL_ELEMENT_ARRAY_BUFFER_ARB','GL_ELEMENT_ARRAY_BUFFER_BINDING_ARB','GL_FOG_COORDINATE_ARRAY_BUFFER_BINDING_ARB','GL_INDEX_ARRAY_BUFFER_BINDING_ARB','GL_NORMAL_ARRAY_BUFFER_BINDING_ARB','GL_READ_ONLY_ARB','GL_READ_WRITE_ARB','GL_SECONDARY_COLOR_ARRAY_BUFFER_BINDING_ARB','GL_STATIC_COPY_ARB','GL_STATIC_DRAW_ARB','GL_STATIC_READ_ARB','GL_STREAM_COPY_ARB','GL_STREAM_DRAW_ARB','GL_STREAM_READ_ARB','GL_TEXTURE_COORD_ARRAY_BUFFER_BINDING_ARB','GL_VERTEX_ARRAY_BUFFER_BINDING_ARB','GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING_ARB','GL_WEIGHT_ARRAY_BUFFER_BINDING_ARB','GL_WRITE_ONLY_ARB']
GL_ARB_vertex_buffer_object.functions = ['glIsBufferARB','glUnmapBufferARB','*','glBindBufferARB','glBufferDataARB','glBufferSubDataARB','glDeleteBuffersARB','glGenBuffersARB','glGetBufferParameterivARB','glGetBufferPointervARB','glGetBufferSubDataARB']
gl.add(GL_ARB_vertex_buffer_object)

GL_ARB_vertex_program = Extension('GL_ARB_vertex_program')
GL_ARB_vertex_program.url = 'http://www.opengl.org/registry/specs/ARB/vertex_program.txt'
GL_ARB_vertex_program.enumerants = ['GL_COLOR_SUM_ARB','GL_CURRENT_MATRIX_ARB','GL_CURRENT_MATRIX_STACK_DEPTH_ARB','GL_CURRENT_VERTEX_ATTRIB_ARB','GL_MATRIX0_ARB','GL_MATRIX10_ARB','GL_MATRIX11_ARB','GL_MATRIX12_ARB','GL_MATRIX13_ARB','GL_MATRIX14_ARB','GL_MATRIX15_ARB','GL_MATRIX16_ARB','GL_MATRIX17_ARB','GL_MATRIX18_ARB','GL_MATRIX19_ARB','GL_MATRIX1_ARB','GL_MATRIX20_ARB','GL_MATRIX21_ARB','GL_MATRIX22_ARB','GL_MATRIX23_ARB','GL_MATRIX24_ARB','GL_MATRIX25_ARB','GL_MATRIX26_ARB','GL_MATRIX27_ARB','GL_MATRIX28_ARB','GL_MATRIX29_ARB','GL_MATRIX2_ARB','GL_MATRIX30_ARB','GL_MATRIX31_ARB','GL_MATRIX3_ARB','GL_MATRIX4_ARB','GL_MATRIX5_ARB','GL_MATRIX6_ARB','GL_MATRIX7_ARB','GL_MATRIX8_ARB','GL_MATRIX9_ARB','GL_MAX_PROGRAM_ADDRESS_REGISTERS_ARB','GL_MAX_PROGRAM_ATTRIBS_ARB','GL_MAX_PROGRAM_ENV_PARAMETERS_ARB','GL_MAX_PROGRAM_INSTRUCTIONS_ARB','GL_MAX_PROGRAM_LOCAL_PARAMETERS_ARB','GL_MAX_PROGRAM_MATRICES_ARB','GL_MAX_PROGRAM_MATRIX_STACK_DEPTH_ARB','GL_MAX_PROGRAM_NATIVE_ADDRESS_REGISTERS_ARB','GL_MAX_PROGRAM_NATIVE_ATTRIBS_ARB','GL_MAX_PROGRAM_NATIVE_INSTRUCTIONS_ARB','GL_MAX_PROGRAM_NATIVE_PARAMETERS_ARB','GL_MAX_PROGRAM_NATIVE_TEMPORARIES_ARB','GL_MAX_PROGRAM_PARAMETERS_ARB','GL_MAX_PROGRAM_TEMPORARIES_ARB','GL_MAX_VERTEX_ATTRIBS_ARB','GL_PROGRAM_ADDRESS_REGISTERS_ARB','GL_PROGRAM_ATTRIBS_ARB','GL_PROGRAM_BINDING_ARB','GL_PROGRAM_ERROR_POSITION_ARB','GL_PROGRAM_ERROR_STRING_ARB','GL_PROGRAM_FORMAT_ARB','GL_PROGRAM_FORMAT_ASCII_ARB','GL_PROGRAM_INSTRUCTIONS_ARB','GL_PROGRAM_LENGTH_ARB','GL_PROGRAM_NATIVE_ADDRESS_REGISTERS_ARB','GL_PROGRAM_NATIVE_ATTRIBS_ARB','GL_PROGRAM_NATIVE_INSTRUCTIONS_ARB','GL_PROGRAM_NATIVE_PARAMETERS_ARB','GL_PROGRAM_NATIVE_TEMPORARIES_ARB','GL_PROGRAM_PARAMETERS_ARB','GL_PROGRAM_STRING_ARB','GL_PROGRAM_TEMPORARIES_ARB','GL_PROGRAM_UNDER_NATIVE_LIMITS_ARB','GL_TRANSPOSE_CURRENT_MATRIX_ARB','GL_VERTEX_ATTRIB_ARRAY_ENABLED_ARB','GL_VERTEX_ATTRIB_ARRAY_NORMALIZED_ARB','GL_VERTEX_ATTRIB_ARRAY_POINTER_ARB','GL_VERTEX_ATTRIB_ARRAY_SIZE_ARB','GL_VERTEX_ATTRIB_ARRAY_STRIDE_ARB','GL_VERTEX_ATTRIB_ARRAY_TYPE_ARB','GL_VERTEX_PROGRAM_ARB','GL_VERTEX_PROGRAM_POINT_SIZE_ARB','GL_VERTEX_PROGRAM_TWO_SIDE_ARB']
GL_ARB_vertex_program.functions = ['glIsProgramARB','glBindProgramARB','glDeleteProgramsARB','glDisableVertexAttribArrayARB','glEnableVertexAttribArrayARB','glGenProgramsARB','glGetProgramEnvParameterdvARB','glGetProgramEnvParameterfvARB','glGetProgramLocalParameterdvARB','glGetProgramLocalParameterfvARB','glGetProgramStringARB','glGetProgramivARB','glGetVertexAttribPointervARB','glGetVertexAttribdvARB','glGetVertexAttribfvARB','glGetVertexAttribivARB','glProgramEnvParameter4dARB','glProgramEnvParameter4dvARB','glProgramEnvParameter4fARB','glProgramEnvParameter4fvARB','glProgramLocalParameter4dARB','glProgramLocalParameter4dvARB','glProgramLocalParameter4fARB','glProgramLocalParameter4fvARB','glProgramStringARB','glVertexAttrib1dARB','glVertexAttrib1dvARB','glVertexAttrib1fARB','glVertexAttrib1fvARB','glVertexAttrib1sARB','glVertexAttrib1svARB','glVertexAttrib2dARB','glVertexAttrib2dvARB','glVertexAttrib2fARB','glVertexAttrib2fvARB','glVertexAttrib2sARB','glVertexAttrib2svARB','glVertexAttrib3dARB','glVertexAttrib3dvARB','glVertexAttrib3fARB','glVertexAttrib3fvARB','glVertexAttrib3sARB','glVertexAttrib3svARB','glVertexAttrib4NbvARB','glVertexAttrib4NivARB','glVertexAttrib4NsvARB','glVertexAttrib4NubARB','glVertexAttrib4NubvARB','glVertexAttrib4NuivARB','glVertexAttrib4NusvARB','glVertexAttrib4bvARB','glVertexAttrib4dARB','glVertexAttrib4dvARB','glVertexAttrib4fARB','glVertexAttrib4fvARB','glVertexAttrib4ivARB','glVertexAttrib4sARB','glVertexAttrib4svARB','glVertexAttrib4ubvARB','glVertexAttrib4uivARB','glVertexAttrib4usvARB','glVertexAttribPointerARB']
gl.add(GL_ARB_vertex_program)

GL_ARB_vertex_shader = Extension('GL_ARB_vertex_shader')
GL_ARB_vertex_shader.url = 'http://www.opengl.org/registry/specs/ARB/vertex_shader.txt'
GL_ARB_vertex_shader.enumerants = ['GL_MAX_COMBINED_TEXTURE_IMAGE_UNITS_ARB','GL_MAX_VARYING_FLOATS_ARB','GL_MAX_VERTEX_TEXTURE_IMAGE_UNITS_ARB','GL_MAX_VERTEX_UNIFORM_COMPONENTS_ARB','GL_OBJECT_ACTIVE_ATTRIBUTES_ARB','GL_OBJECT_ACTIVE_ATTRIBUTE_MAX_LENGTH_ARB','GL_VERTEX_SHADER_ARB']
GL_ARB_vertex_shader.functions = ['glGetAttribLocationARB','glBindAttribLocationARB','glGetActiveAttribARB']
gl.add(GL_ARB_vertex_shader)

GL_ARB_vertex_type_10f_11f_11f_rev = Extension('GL_ARB_vertex_type_10f_11f_11f_rev')
GL_ARB_vertex_type_10f_11f_11f_rev.url = 'http://www.opengl.org/registry/specs/ARB/vertex_type_10f_11f_11f_rev.txt'
GL_ARB_vertex_type_10f_11f_11f_rev.enumerants = ['']
GL_ARB_vertex_type_10f_11f_11f_rev.functions = ['']
gl.add(GL_ARB_vertex_type_10f_11f_11f_rev)

GL_ARB_vertex_type_2_10_10_10_rev = Extension('GL_ARB_vertex_type_2_10_10_10_rev')
GL_ARB_vertex_type_2_10_10_10_rev.url = 'http://www.opengl.org/registry/specs/ARB/vertex_type_2_10_10_10_rev.txt'
GL_ARB_vertex_type_2_10_10_10_rev.enumerants = ['GL_INT_2_10_10_10_REV']
GL_ARB_vertex_type_2_10_10_10_rev.functions = ['glColorP3ui','glColorP3uiv','glColorP4ui','glColorP4uiv','glMultiTexCoordP1ui','glMultiTexCoordP1uiv','glMultiTexCoordP2ui','glMultiTexCoordP2uiv','glMultiTexCoordP3ui','glMultiTexCoordP3uiv','glMultiTexCoordP4ui','glMultiTexCoordP4uiv','glNormalP3ui','glNormalP3uiv','glSecondaryColorP3ui','glSecondaryColorP3uiv','glTexCoordP1ui','glTexCoordP1uiv','glTexCoordP2ui','glTexCoordP2uiv','glTexCoordP3ui','glTexCoordP3uiv','glTexCoordP4ui','glTexCoordP4uiv','glVertexAttribP1ui','glVertexAttribP1uiv','glVertexAttribP2ui','glVertexAttribP2uiv','glVertexAttribP3ui','glVertexAttribP3uiv','glVertexAttribP4ui','glVertexAttribP4uiv','glVertexP2ui','glVertexP2uiv','glVertexP3ui','glVertexP3uiv','glVertexP4ui','glVertexP4uiv']
gl.add(GL_ARB_vertex_type_2_10_10_10_rev)

GL_ARB_viewport_array = Extension('GL_ARB_viewport_array')
GL_ARB_viewport_array.url = 'http://www.opengl.org/registry/specs/ARB/viewport_array.txt'
GL_ARB_viewport_array.enumerants = ['GL_DEPTH_RANGE','GL_FIRST_VERTEX_CONVENTION','GL_LAST_VERTEX_CONVENTION','GL_LAYER_PROVOKING_VERTEX','GL_MAX_VIEWPORTS','GL_PROVOKING_VERTEX','GL_SCISSOR_BOX','GL_SCISSOR_TEST','GL_UNDEFINED_VERTEX','GL_VIEWPORT','GL_VIEWPORT_BOUNDS_RANGE','GL_VIEWPORT_INDEX_PROVOKING_VERTEX','GL_VIEWPORT_SUBPIXEL_BITS']
GL_ARB_viewport_array.functions = ['glDepthRangeArrayv','glDepthRangeIndexed','glGetDoublei_v','glGetFloati_v','glScissorArrayv','glScissorIndexed','glScissorIndexedv','glViewportArrayv','glViewportIndexedf','glViewportIndexedfv']
gl.add(GL_ARB_viewport_array)

GL_ARB_window_pos = Extension('GL_ARB_window_pos')
GL_ARB_window_pos.url = 'http://www.opengl.org/registry/specs/ARB/window_pos.txt'
GL_ARB_window_pos.functions = ['glWindowPos2dARB','glWindowPos2dvARB','glWindowPos2fARB','glWindowPos2fvARB','glWindowPos2iARB','glWindowPos2ivARB','glWindowPos2sARB','glWindowPos2svARB','glWindowPos3dARB','glWindowPos3dvARB','glWindowPos3fARB','glWindowPos3fvARB','glWindowPos3iARB','glWindowPos3ivARB','glWindowPos3sARB','glWindowPos3svARB']
gl.add(GL_ARB_window_pos)

GL_ATIX_point_sprites = Extension('GL_ATIX_point_sprites')
GL_ATIX_point_sprites.url = 'http://www.ati.com/developer/atiopengl.pdf'
GL_ATIX_point_sprites.enumerants = ['GL_POINT_SPRITE_CULL_CENTER_ATIX','GL_POINT_SPRITE_CULL_CLIP_ATIX','GL_POINT_SPRITE_CULL_MODE_ATIX','GL_TEXTURE_POINT_MODE_ATIX','GL_TEXTURE_POINT_ONE_COORD_ATIX','GL_TEXTURE_POINT_SPRITE_ATIX']
gl.add(GL_ATIX_point_sprites)

GL_ATIX_texture_env_combine3 = Extension('GL_ATIX_texture_env_combine3')
GL_ATIX_texture_env_combine3.url = 'http://www.ati.com/developer/atiopengl.pdf'
GL_ATIX_texture_env_combine3.enumerants = ['GL_MODULATE_ADD_ATIX','GL_MODULATE_SIGNED_ADD_ATIX','GL_MODULATE_SUBTRACT_ATIX']
gl.add(GL_ATIX_texture_env_combine3)

GL_ATIX_texture_env_route = Extension('GL_ATIX_texture_env_route')
GL_ATIX_texture_env_route.url = 'http://www.ati.com/developer/sdk/RadeonSDK/Html/Info/ATIX_texture_env_route.txt'
GL_ATIX_texture_env_route.enumerants = ['GL_SECONDARY_COLOR_ATIX','GL_TEXTURE_OUTPUT_ALPHA_ATIX','GL_TEXTURE_OUTPUT_RGB_ATIX']
gl.add(GL_ATIX_texture_env_route)

GL_ATIX_vertex_shader_output_point_size = Extension('GL_ATIX_vertex_shader_output_point_size')
GL_ATIX_vertex_shader_output_point_size.url = 'http://www.ati.com/developer/atiopengl.pdf'
GL_ATIX_vertex_shader_output_point_size.enumerants = ['GL_OUTPUT_POINT_SIZE_ATIX']
gl.add(GL_ATIX_vertex_shader_output_point_size)

GL_ATI_draw_buffers = Extension('GL_ATI_draw_buffers')
GL_ATI_draw_buffers.url = 'http://www.opengl.org/registry/specs/ATI/draw_buffers.txt'
GL_ATI_draw_buffers.enumerants = ['GL_DRAW_BUFFER0_ATI','GL_DRAW_BUFFER10_ATI','GL_DRAW_BUFFER11_ATI','GL_DRAW_BUFFER12_ATI','GL_DRAW_BUFFER13_ATI','GL_DRAW_BUFFER14_ATI','GL_DRAW_BUFFER15_ATI','GL_DRAW_BUFFER1_ATI','GL_DRAW_BUFFER2_ATI','GL_DRAW_BUFFER3_ATI','GL_DRAW_BUFFER4_ATI','GL_DRAW_BUFFER5_ATI','GL_DRAW_BUFFER6_ATI','GL_DRAW_BUFFER7_ATI','GL_DRAW_BUFFER8_ATI','GL_DRAW_BUFFER9_ATI','GL_MAX_DRAW_BUFFERS_ATI']
GL_ATI_draw_buffers.functions = ['glDrawBuffersATI']
gl.add(GL_ATI_draw_buffers)

GL_ATI_element_array = Extension('GL_ATI_element_array')
GL_ATI_element_array.url = 'http://www.opengl.org/registry/specs/ATI/element_array.txt'
GL_ATI_element_array.enumerants = ['GL_ELEMENT_ARRAY_ATI','GL_ELEMENT_ARRAY_POINTER_ATI','GL_ELEMENT_ARRAY_TYPE_ATI']
GL_ATI_element_array.functions = ['glDrawElementArrayATI','glDrawRangeElementArrayATI','glElementPointerATI']
gl.add(GL_ATI_element_array)

GL_ATI_envmap_bumpmap = Extension('GL_ATI_envmap_bumpmap')
GL_ATI_envmap_bumpmap.url = 'http://oss.sgi.com/projects/ogl-sample/registry/ATI/envmap_bumpmap.txt'
GL_ATI_envmap_bumpmap.enumerants = ['GL_BUMP_ENVMAP_ATI','GL_BUMP_NUM_TEX_UNITS_ATI','GL_BUMP_ROT_MATRIX_ATI','GL_BUMP_ROT_MATRIX_SIZE_ATI','GL_BUMP_TARGET_ATI','GL_BUMP_TEX_UNITS_ATI','GL_DU8DV8_ATI','GL_DUDV_ATI']
GL_ATI_envmap_bumpmap.functions = ['glGetTexBumpParameterfvATI','glGetTexBumpParameterivATI','glTexBumpParameterfvATI','glTexBumpParameterivATI']
gl.add(GL_ATI_envmap_bumpmap)

GL_ATI_fragment_shader = Extension('GL_ATI_fragment_shader')
GL_ATI_fragment_shader.url = 'http://www.opengl.org/registry/specs/ATI/fragment_shader.txt'
GL_ATI_fragment_shader.enumerants = ['GL_2X_BIT_ATI','GL_4X_BIT_ATI','GL_8X_BIT_ATI','GL_ADD_ATI','GL_BIAS_BIT_ATI','GL_BLUE_BIT_ATI','GL_CND0_ATI','GL_CND_ATI','GL_COLOR_ALPHA_PAIRING_ATI','GL_COMP_BIT_ATI','GL_CON_0_ATI','GL_CON_1_ATI','GL_CON_2_ATI','GL_CON_3_ATI','GL_CON_4_ATI','GL_CON_5_ATI','GL_CON_6_ATI','GL_CON_7_ATI','GL_DOT2_ADD_ATI','GL_DOT3_ATI','GL_DOT4_ATI','GL_EIGHTH_BIT_ATI','GL_FRAGMENT_SHADER_ATI','GL_GREEN_BIT_ATI','GL_HALF_BIT_ATI','GL_LERP_ATI','GL_MAD_ATI','GL_MOV_ATI','GL_MUL_ATI','GL_NEGATE_BIT_ATI','GL_NUM_FRAGMENT_CONSTANTS_ATI','GL_NUM_FRAGMENT_REGISTERS_ATI','GL_NUM_INPUT_INTERPOLATOR_COMPONENTS_ATI','GL_NUM_INSTRUCTIONS_PER_PASS_ATI','GL_NUM_INSTRUCTIONS_TOTAL_ATI','GL_NUM_LOOPBACK_COMPONENTS_ATI','GL_NUM_PASSES_ATI','GL_QUARTER_BIT_ATI','GL_RED_BIT_ATI','GL_REG_0_ATI','GL_REG_1_ATI','GL_REG_2_ATI','GL_REG_3_ATI','GL_REG_4_ATI','GL_REG_5_ATI','GL_SATURATE_BIT_ATI','GL_SECONDARY_INTERPOLATOR_ATI','GL_SUB_ATI','GL_SWIZZLE_STQ_ATI','GL_SWIZZLE_STQ_DQ_ATI','GL_SWIZZLE_STRQ_ATI','GL_SWIZZLE_STRQ_DQ_ATI','GL_SWIZZLE_STR_ATI','GL_SWIZZLE_STR_DR_ATI']
GL_ATI_fragment_shader.functions = ['glGenFragmentShadersATI','glAlphaFragmentOp1ATI','glAlphaFragmentOp2ATI','glAlphaFragmentOp3ATI','glBeginFragmentShaderATI','glBindFragmentShaderATI','glColorFragmentOp1ATI','glColorFragmentOp2ATI','glColorFragmentOp3ATI','glDeleteFragmentShaderATI','glEndFragmentShaderATI','glPassTexCoordATI','glSampleMapATI','glSetFragmentShaderConstantATI']
gl.add(GL_ATI_fragment_shader)

GL_ATI_map_object_buffer = Extension('GL_ATI_map_object_buffer')
GL_ATI_map_object_buffer.url = 'http://www.opengl.org/registry/specs/ATI/map_object_buffer.txt'
GL_ATI_map_object_buffer.functions = ['*','glUnmapObjectBufferATI']
gl.add(GL_ATI_map_object_buffer)

GL_ATI_meminfo = Extension('GL_ATI_meminfo')
GL_ATI_meminfo.url = 'http://www.opengl.org/registry/specs/ATI/meminfo.txt'
GL_ATI_meminfo.enumerants = ['GL_RENDERBUFFER_FREE_MEMORY_ATI','GL_TEXTURE_FREE_MEMORY_ATI','GL_VBO_FREE_MEMORY_ATI']
gl.add(GL_ATI_meminfo)

GL_ATI_pn_triangles = Extension('GL_ATI_pn_triangles')
GL_ATI_pn_triangles.url = 'http://www.opengl.org/registry/specs/ATI/pn_triangles.txt'
GL_ATI_pn_triangles.enumerants = ['GL_MAX_PN_TRIANGLES_TESSELATION_LEVEL_ATI','GL_PN_TRIANGLES_ATI','GL_PN_TRIANGLES_NORMAL_MODE_ATI','GL_PN_TRIANGLES_NORMAL_MODE_LINEAR_ATI','GL_PN_TRIANGLES_NORMAL_MODE_QUADRATIC_ATI','GL_PN_TRIANGLES_POINT_MODE_ATI','GL_PN_TRIANGLES_POINT_MODE_CUBIC_ATI','GL_PN_TRIANGLES_POINT_MODE_LINEAR_ATI','GL_PN_TRIANGLES_TESSELATION_LEVEL_ATI']
GL_ATI_pn_triangles.functions = ['glPNTrianglesfATI','glPNTrianglesiATI']
gl.add(GL_ATI_pn_triangles)

GL_ATI_separate_stencil = Extension('GL_ATI_separate_stencil')
GL_ATI_separate_stencil.url = 'http://www.opengl.org/registry/specs/ATI/separate_stencil.txt'
GL_ATI_separate_stencil.enumerants = ['GL_STENCIL_BACK_FAIL_ATI','GL_STENCIL_BACK_FUNC_ATI','GL_STENCIL_BACK_PASS_DEPTH_FAIL_ATI','GL_STENCIL_BACK_PASS_DEPTH_PASS_ATI']
GL_ATI_separate_stencil.functions = ['glStencilFuncSeparateATI','glStencilOpSeparateATI']
gl.add(GL_ATI_separate_stencil)

GL_ATI_shader_texture_lod = Extension('GL_ATI_shader_texture_lod')
gl.add(GL_ATI_shader_texture_lod)

GL_ATI_text_fragment_shader = Extension('GL_ATI_text_fragment_shader')
GL_ATI_text_fragment_shader.url = 'http://www.opengl.org/registry/specs/ATI/text_fragment_shader.txt'
GL_ATI_text_fragment_shader.enumerants = ['GL_TEXT_FRAGMENT_SHADER_ATI']
gl.add(GL_ATI_text_fragment_shader)

GL_ATI_texture_compression_3dc = Extension('GL_ATI_texture_compression_3dc')
GL_ATI_texture_compression_3dc.enumerants = ['GL_COMPRESSED_LUMINANCE_ALPHA_3DC_ATI']
gl.add(GL_ATI_texture_compression_3dc)

GL_ATI_texture_env_combine3 = Extension('GL_ATI_texture_env_combine3')
GL_ATI_texture_env_combine3.url = 'http://www.opengl.org/registry/specs/ATI/texture_env_combine3.txt'
GL_ATI_texture_env_combine3.enumerants = ['GL_MODULATE_ADD_ATI','GL_MODULATE_SIGNED_ADD_ATI','GL_MODULATE_SUBTRACT_ATI']
gl.add(GL_ATI_texture_env_combine3)

GL_ATI_texture_float = Extension('GL_ATI_texture_float')
GL_ATI_texture_float.url = 'http://www.opengl.org/registry/specs/ATI/texture_float.txt'
GL_ATI_texture_float.enumerants = ['GL_ALPHA_FLOAT16_ATI','GL_ALPHA_FLOAT32_ATI','GL_INTENSITY_FLOAT16_ATI','GL_INTENSITY_FLOAT32_ATI','GL_LUMINANCE_ALPHA_FLOAT16_ATI','GL_LUMINANCE_ALPHA_FLOAT32_ATI','GL_LUMINANCE_FLOAT16_ATI','GL_LUMINANCE_FLOAT32_ATI','GL_RGBA_FLOAT16_ATI','GL_RGBA_FLOAT32_ATI','GL_RGB_FLOAT16_ATI','GL_RGB_FLOAT32_ATI']
gl.add(GL_ATI_texture_float)

GL_ATI_texture_mirror_once = Extension('GL_ATI_texture_mirror_once')
GL_ATI_texture_mirror_once.url = 'http://www.opengl.org/registry/specs/ATI/texture_mirror_once.txt'
GL_ATI_texture_mirror_once.enumerants = ['GL_MIRROR_CLAMP_ATI','GL_MIRROR_CLAMP_TO_EDGE_ATI']
gl.add(GL_ATI_texture_mirror_once)

GL_ATI_vertex_array_object = Extension('GL_ATI_vertex_array_object')
GL_ATI_vertex_array_object.url = 'http://www.opengl.org/registry/specs/ATI/vertex_array_object.txt'
GL_ATI_vertex_array_object.enumerants = ['GL_ARRAY_OBJECT_BUFFER_ATI','GL_ARRAY_OBJECT_OFFSET_ATI','GL_DISCARD_ATI','GL_DYNAMIC_ATI','GL_OBJECT_BUFFER_SIZE_ATI','GL_OBJECT_BUFFER_USAGE_ATI','GL_PRESERVE_ATI','GL_STATIC_ATI']
GL_ATI_vertex_array_object.functions = ['glIsObjectBufferATI','glNewObjectBufferATI','glArrayObjectATI','glFreeObjectBufferATI','glGetArrayObjectfvATI','glGetArrayObjectivATI','glGetObjectBufferfvATI','glGetObjectBufferivATI','glGetVariantArrayObjectfvATI','glGetVariantArrayObjectivATI','glUpdateObjectBufferATI','glVariantArrayObjectATI']
gl.add(GL_ATI_vertex_array_object)

GL_ATI_vertex_attrib_array_object = Extension('GL_ATI_vertex_attrib_array_object')
GL_ATI_vertex_attrib_array_object.url = 'http://www.opengl.org/registry/specs/ATI/vertex_attrib_array_object.txt'
GL_ATI_vertex_attrib_array_object.functions = ['glGetVertexAttribArrayObjectfvATI','glGetVertexAttribArrayObjectivATI','glVertexAttribArrayObjectATI']
gl.add(GL_ATI_vertex_attrib_array_object)

GL_ATI_vertex_streams = Extension('GL_ATI_vertex_streams')
GL_ATI_vertex_streams.url = 'http://www.opengl.org/registry/specs/ATI/vertex_streams.txt'
GL_ATI_vertex_streams.enumerants = ['GL_MAX_VERTEX_STREAMS_ATI','GL_VERTEX_SOURCE_ATI','GL_VERTEX_STREAM0_ATI','GL_VERTEX_STREAM1_ATI','GL_VERTEX_STREAM2_ATI','GL_VERTEX_STREAM3_ATI','GL_VERTEX_STREAM4_ATI','GL_VERTEX_STREAM5_ATI','GL_VERTEX_STREAM6_ATI','GL_VERTEX_STREAM7_ATI']
GL_ATI_vertex_streams.functions = ['glClientActiveVertexStreamATI','glNormalStream3bATI','glNormalStream3bvATI','glNormalStream3dATI','glNormalStream3dvATI','glNormalStream3fATI','glNormalStream3fvATI','glNormalStream3iATI','glNormalStream3ivATI','glNormalStream3sATI','glNormalStream3svATI','glVertexBlendEnvfATI','glVertexBlendEnviATI','glVertexStream1dATI','glVertexStream1dvATI','glVertexStream1fATI','glVertexStream1fvATI','glVertexStream1iATI','glVertexStream1ivATI','glVertexStream1sATI','glVertexStream1svATI','glVertexStream2dATI','glVertexStream2dvATI','glVertexStream2fATI','glVertexStream2fvATI','glVertexStream2iATI','glVertexStream2ivATI','glVertexStream2sATI','glVertexStream2svATI','glVertexStream3dATI','glVertexStream3dvATI','glVertexStream3fATI','glVertexStream3fvATI','glVertexStream3iATI','glVertexStream3ivATI','glVertexStream3sATI','glVertexStream3svATI','glVertexStream4dATI','glVertexStream4dvATI','glVertexStream4fATI','glVertexStream4fvATI','glVertexStream4iATI','glVertexStream4ivATI','glVertexStream4sATI','glVertexStream4svATI']
gl.add(GL_ATI_vertex_streams)

GL_EXT_422_pixels = Extension('GL_EXT_422_pixels')
GL_EXT_422_pixels.url = 'http://www.opengl.org/registry/specs/EXT/422_pixels.txt'
GL_EXT_422_pixels.enumerants = ['GL_422_AVERAGE_EXT','GL_422_EXT','GL_422_REV_AVERAGE_EXT','GL_422_REV_EXT']
gl.add(GL_EXT_422_pixels)

GL_EXT_Cg_shader = Extension('GL_EXT_Cg_shader')
GL_EXT_Cg_shader.url = 'http://download.nvidia.com/developer/GLSL/GLSL%20Release%20Notes%20for%20Release%2060.pdf'
GL_EXT_Cg_shader.enumerants = ['GL_CG_FRAGMENT_SHADER_EXT','GL_CG_VERTEX_SHADER_EXT']
gl.add(GL_EXT_Cg_shader)

GL_EXT_abgr = Extension('GL_EXT_abgr')
GL_EXT_abgr.url = 'http://www.opengl.org/registry/specs/EXT/abgr.txt'
GL_EXT_abgr.enumerants = ['GL_ABGR_EXT']
gl.add(GL_EXT_abgr)

GL_EXT_bgra = Extension('GL_EXT_bgra')
GL_EXT_bgra.url = 'http://www.opengl.org/registry/specs/EXT/bgra.txt'
GL_EXT_bgra.enumerants = ['GL_BGRA_EXT','GL_BGR_EXT']
gl.add(GL_EXT_bgra)

GL_EXT_bindable_uniform = Extension('GL_EXT_bindable_uniform')
GL_EXT_bindable_uniform.url = 'http://developer.download.nvidia.com/opengl/specs/GL_EXT_bindable_uniform.txt'
GL_EXT_bindable_uniform.enumerants = ['GL_MAX_BINDABLE_UNIFORM_SIZE_EXT','GL_MAX_FRAGMENT_BINDABLE_UNIFORMS_EXT','GL_MAX_GEOMETRY_BINDABLE_UNIFORMS_EXT','GL_MAX_VERTEX_BINDABLE_UNIFORMS_EXT','GL_UNIFORM_BUFFER_BINDING_EXT','GL_UNIFORM_BUFFER_EXT']
GL_EXT_bindable_uniform.functions = ['glGetUniformBufferSizeEXT','glGetUniformOffsetEXT','glUniformBufferEXT']
gl.add(GL_EXT_bindable_uniform)

GL_EXT_blend_color = Extension('GL_EXT_blend_color')
GL_EXT_blend_color.url = 'http://www.opengl.org/registry/specs/EXT/blend_color.txt'
GL_EXT_blend_color.enumerants = ['GL_BLEND_COLOR_EXT','GL_CONSTANT_ALPHA_EXT','GL_CONSTANT_COLOR_EXT','GL_ONE_MINUS_CONSTANT_ALPHA_EXT','GL_ONE_MINUS_CONSTANT_COLOR_EXT']
GL_EXT_blend_color.functions = ['glBlendColorEXT']
gl.add(GL_EXT_blend_color)

GL_EXT_blend_equation_separate = Extension('GL_EXT_blend_equation_separate')
GL_EXT_blend_equation_separate.url = 'http://www.opengl.org/registry/specs/EXT/blend_equation_separate.txt'
GL_EXT_blend_equation_separate.enumerants = ['GL_BLEND_EQUATION_ALPHA_EXT','GL_BLEND_EQUATION_RGB_EXT']
GL_EXT_blend_equation_separate.functions = ['glBlendEquationSeparateEXT']
gl.add(GL_EXT_blend_equation_separate)

GL_EXT_blend_func_separate = Extension('GL_EXT_blend_func_separate')
GL_EXT_blend_func_separate.url = 'http://www.opengl.org/registry/specs/EXT/blend_func_separate.txt'
GL_EXT_blend_func_separate.enumerants = ['GL_BLEND_DST_ALPHA_EXT','GL_BLEND_DST_RGB_EXT','GL_BLEND_SRC_ALPHA_EXT','GL_BLEND_SRC_RGB_EXT']
GL_EXT_blend_func_separate.functions = ['glBlendFuncSeparateEXT']
gl.add(GL_EXT_blend_func_separate)

GL_EXT_blend_logic_op = Extension('GL_EXT_blend_logic_op')
GL_EXT_blend_logic_op.url = 'http://www.opengl.org/registry/specs/EXT/blend_logic_op.txt'
gl.add(GL_EXT_blend_logic_op)

GL_EXT_blend_minmax = Extension('GL_EXT_blend_minmax')
GL_EXT_blend_minmax.url = 'http://www.opengl.org/registry/specs/EXT/blend_minmax.txt'
GL_EXT_blend_minmax.enumerants = ['GL_BLEND_EQUATION_EXT','GL_FUNC_ADD_EXT','GL_MAX_EXT','GL_MIN_EXT']
GL_EXT_blend_minmax.functions = ['glBlendEquationEXT']
gl.add(GL_EXT_blend_minmax)

GL_EXT_blend_subtract = Extension('GL_EXT_blend_subtract')
GL_EXT_blend_subtract.url = 'http://www.opengl.org/registry/specs/EXT/blend_subtract.txt'
GL_EXT_blend_subtract.enumerants = ['GL_FUNC_REVERSE_SUBTRACT_EXT','GL_FUNC_SUBTRACT_EXT']
gl.add(GL_EXT_blend_subtract)

GL_EXT_clip_volume_hint = Extension('GL_EXT_clip_volume_hint')
GL_EXT_clip_volume_hint.url = 'http://www.opengl.org/registry/specs/EXT/clip_volume_hint.txt'
GL_EXT_clip_volume_hint.enumerants = ['GL_CLIP_VOLUME_CLIPPING_HINT_EXT']
gl.add(GL_EXT_clip_volume_hint)

GL_EXT_cmyka = Extension('GL_EXT_cmyka')
GL_EXT_cmyka.url = 'http://www.opengl.org/registry/specs/EXT/cmyka.txt'
GL_EXT_cmyka.enumerants = ['GL_CMYKA_EXT','GL_CMYK_EXT','GL_PACK_CMYK_HINT_EXT','GL_UNPACK_CMYK_HINT_EXT']
gl.add(GL_EXT_cmyka)

GL_EXT_color_subtable = Extension('GL_EXT_color_subtable')
GL_EXT_color_subtable.url = 'http://www.opengl.org/registry/specs/EXT/color_subtable.txt'
GL_EXT_color_subtable.functions = ['glColorSubTableEXT','glCopyColorSubTableEXT']
gl.add(GL_EXT_color_subtable)

GL_EXT_compiled_vertex_array = Extension('GL_EXT_compiled_vertex_array')
GL_EXT_compiled_vertex_array.url = 'http://www.opengl.org/registry/specs/EXT/compiled_vertex_array.txt'
GL_EXT_compiled_vertex_array.enumerants = ['GL_ARRAY_ELEMENT_LOCK_COUNT_EXT','GL_ARRAY_ELEMENT_LOCK_FIRST_EXT']
GL_EXT_compiled_vertex_array.functions = ['glLockArraysEXT','glUnlockArraysEXT']
gl.add(GL_EXT_compiled_vertex_array)

GL_EXT_convolution = Extension('GL_EXT_convolution')
GL_EXT_convolution.url = 'http://www.opengl.org/registry/specs/EXT/convolution.txt'
GL_EXT_convolution.enumerants = ['GL_CONVOLUTION_1D_EXT','GL_CONVOLUTION_2D_EXT','GL_CONVOLUTION_BORDER_MODE_EXT','GL_CONVOLUTION_FILTER_BIAS_EXT','GL_CONVOLUTION_FILTER_SCALE_EXT','GL_CONVOLUTION_FORMAT_EXT','GL_CONVOLUTION_HEIGHT_EXT','GL_CONVOLUTION_WIDTH_EXT','GL_MAX_CONVOLUTION_HEIGHT_EXT','GL_MAX_CONVOLUTION_WIDTH_EXT','GL_POST_CONVOLUTION_ALPHA_BIAS_EXT','GL_POST_CONVOLUTION_ALPHA_SCALE_EXT','GL_POST_CONVOLUTION_BLUE_BIAS_EXT','GL_POST_CONVOLUTION_BLUE_SCALE_EXT','GL_POST_CONVOLUTION_GREEN_BIAS_EXT','GL_POST_CONVOLUTION_GREEN_SCALE_EXT','GL_POST_CONVOLUTION_RED_BIAS_EXT','GL_POST_CONVOLUTION_RED_SCALE_EXT','GL_REDUCE_EXT','GL_SEPARABLE_2D_EXT']
GL_EXT_convolution.functions = ['glConvolutionFilter1DEXT','glConvolutionFilter2DEXT','glConvolutionParameterfEXT','glConvolutionParameterfvEXT','glConvolutionParameteriEXT','glConvolutionParameterivEXT','glCopyConvolutionFilter1DEXT','glCopyConvolutionFilter2DEXT','glGetConvolutionFilterEXT','glGetConvolutionParameterfvEXT','glGetConvolutionParameterivEXT','glGetSeparableFilterEXT','glSeparableFilter2DEXT']
gl.add(GL_EXT_convolution)

GL_EXT_coordinate_frame = Extension('GL_EXT_coordinate_frame')
GL_EXT_coordinate_frame.url = 'http://www.opengl.org/registry/specs/EXT/coordinate_frame.txt'
GL_EXT_coordinate_frame.enumerants = ['GL_BINORMAL_ARRAY_EXT','GL_BINORMAL_ARRAY_POINTER_EXT','GL_BINORMAL_ARRAY_STRIDE_EXT','GL_BINORMAL_ARRAY_TYPE_EXT','GL_CURRENT_BINORMAL_EXT','GL_CURRENT_TANGENT_EXT','GL_MAP1_BINORMAL_EXT','GL_MAP1_TANGENT_EXT','GL_MAP2_BINORMAL_EXT','GL_MAP2_TANGENT_EXT','GL_TANGENT_ARRAY_EXT','GL_TANGENT_ARRAY_POINTER_EXT','GL_TANGENT_ARRAY_STRIDE_EXT','GL_TANGENT_ARRAY_TYPE_EXT']
GL_EXT_coordinate_frame.functions = ['glBinormalPointerEXT','glTangentPointerEXT']
gl.add(GL_EXT_coordinate_frame)

GL_EXT_copy_texture = Extension('GL_EXT_copy_texture')
GL_EXT_copy_texture.url = 'http://www.opengl.org/registry/specs/EXT/copy_texture.txt'
GL_EXT_copy_texture.functions = ['glCopyTexImage1DEXT','glCopyTexImage2DEXT','glCopyTexSubImage1DEXT','glCopyTexSubImage2DEXT','glCopyTexSubImage3DEXT']
gl.add(GL_EXT_copy_texture)

GL_EXT_cull_vertex = Extension('GL_EXT_cull_vertex')
GL_EXT_cull_vertex.url = 'http://www.opengl.org/registry/specs/EXT/cull_vertex.txt'
GL_EXT_cull_vertex.enumerants = ['GL_CULL_VERTEX_EXT','GL_CULL_VERTEX_EYE_POSITION_EXT','GL_CULL_VERTEX_OBJECT_POSITION_EXT']
GL_EXT_cull_vertex.functions = ['glCullParameterdvEXT','glCullParameterfvEXT']
gl.add(GL_EXT_cull_vertex)

GL_EXT_debug_marker = Extension('GL_EXT_debug_marker')
GL_EXT_debug_marker.url = 'http://www.khronos.org/registry/gles/extensions/EXT/EXT_debug_marker.txt'
GL_EXT_debug_marker.functions = ['glInsertEventMarkerEXT','glPopGroupMarkerEXT','glPushGroupMarkerEXT']
gl.add(GL_EXT_debug_marker)

GL_EXT_depth_bounds_test = Extension('GL_EXT_depth_bounds_test')
GL_EXT_depth_bounds_test.url = 'http://www.nvidia.com/dev_content/nvopenglspecs/GL_EXT_depth_bounds_test.txt'
GL_EXT_depth_bounds_test.enumerants = ['GL_DEPTH_BOUNDS_EXT','GL_DEPTH_BOUNDS_TEST_EXT']
GL_EXT_depth_bounds_test.functions = ['glDepthBoundsEXT']
gl.add(GL_EXT_depth_bounds_test)

GL_EXT_direct_state_access = Extension('GL_EXT_direct_state_access')
GL_EXT_direct_state_access.url = 'http://www.opengl.org/registry/specs/EXT/direct_state_access.txt'
GL_EXT_direct_state_access.enumerants = ['GL_PROGRAM_MATRIX_EXT','GL_PROGRAM_MATRIX_STACK_DEPTH_EXT','GL_TRANSPOSE_PROGRAM_MATRIX_EXT']
GL_EXT_direct_state_access.functions = ['glUnmapNamedBufferEXT','glCheckNamedFramebufferStatusEXT','*','*','glBindMultiTextureEXT','glClientAttribDefaultEXT','glCompressedMultiTexImage1DEXT','glCompressedMultiTexImage2DEXT','glCompressedMultiTexImage3DEXT','glCompressedMultiTexSubImage1DEXT','glCompressedMultiTexSubImage2DEXT','glCompressedMultiTexSubImage3DEXT','glCompressedTextureImage1DEXT','glCompressedTextureImage2DEXT','glCompressedTextureImage3DEXT','glCompressedTextureSubImage1DEXT','glCompressedTextureSubImage2DEXT','glCompressedTextureSubImage3DEXT','glCopyMultiTexImage1DEXT','glCopyMultiTexImage2DEXT','glCopyMultiTexSubImage1DEXT','glCopyMultiTexSubImage2DEXT','glCopyMultiTexSubImage3DEXT','glCopyTextureImage1DEXT','glCopyTextureImage2DEXT','glCopyTextureSubImage1DEXT','glCopyTextureSubImage2DEXT','glCopyTextureSubImage3DEXT','glDisableClientStateIndexedEXT','glDisableClientStateiEXT','glDisableVertexArrayAttribEXT','glDisableVertexArrayEXT','glEnableClientStateIndexedEXT','glEnableClientStateiEXT','glEnableVertexArrayAttribEXT','glEnableVertexArrayEXT','glFlushMappedNamedBufferRangeEXT','glFramebufferDrawBufferEXT','glFramebufferDrawBuffersEXT','glFramebufferReadBufferEXT','glGenerateMultiTexMipmapEXT','glGenerateTextureMipmapEXT','glGetCompressedMultiTexImageEXT','glGetCompressedTextureImageEXT','glGetDoubleIndexedvEXT','glGetDoublei_vEXT','glGetFloatIndexedvEXT','glGetFloati_vEXT','glGetFramebufferParameterivEXT','glGetMultiTexEnvfvEXT','glGetMultiTexEnvivEXT','glGetMultiTexGendvEXT','glGetMultiTexGenfvEXT','glGetMultiTexGenivEXT','glGetMultiTexImageEXT','glGetMultiTexLevelParameterfvEXT','glGetMultiTexLevelParameterivEXT','glGetMultiTexParameterIivEXT','glGetMultiTexParameterIuivEXT','glGetMultiTexParameterfvEXT','glGetMultiTexParameterivEXT','glGetNamedBufferParameterivEXT','glGetNamedBufferPointervEXT','glGetNamedBufferSubDataEXT','glGetNamedFramebufferAttachmentParameterivEXT','glGetNamedProgramLocalParameterIivEXT','glGetNamedProgramLocalParameterIuivEXT','glGetNamedProgramLocalParameterdvEXT','glGetNamedProgramLocalParameterfvEXT','glGetNamedProgramStringEXT','glGetNamedProgramivEXT','glGetNamedRenderbufferParameterivEXT','glGetPointerIndexedvEXT','glGetPointeri_vEXT','glGetTextureImageEXT','glGetTextureLevelParameterfvEXT','glGetTextureLevelParameterivEXT','glGetTextureParameterIivEXT','glGetTextureParameterIuivEXT','glGetTextureParameterfvEXT','glGetTextureParameterivEXT','glGetVertexArrayIntegeri_vEXT','glGetVertexArrayIntegervEXT','glGetVertexArrayPointeri_vEXT','glGetVertexArrayPointervEXT','glMatrixFrustumEXT','glMatrixLoadIdentityEXT','glMatrixLoadTransposedEXT','glMatrixLoadTransposefEXT','glMatrixLoaddEXT','glMatrixLoadfEXT','glMatrixMultTransposedEXT','glMatrixMultTransposefEXT','glMatrixMultdEXT','glMatrixMultfEXT','glMatrixOrthoEXT','glMatrixPopEXT','glMatrixPushEXT','glMatrixRotatedEXT','glMatrixRotatefEXT','glMatrixScaledEXT','glMatrixScalefEXT','glMatrixTranslatedEXT','glMatrixTranslatefEXT','glMultiTexBufferEXT','glMultiTexCoordPointerEXT','glMultiTexEnvfEXT','glMultiTexEnvfvEXT','glMultiTexEnviEXT','glMultiTexEnvivEXT','glMultiTexGendEXT','glMultiTexGendvEXT','glMultiTexGenfEXT','glMultiTexGenfvEXT','glMultiTexGeniEXT','glMultiTexGenivEXT','glMultiTexImage1DEXT','glMultiTexImage2DEXT','glMultiTexImage3DEXT','glMultiTexParameterIivEXT','glMultiTexParameterIuivEXT','glMultiTexParameterfEXT','glMultiTexParameterfvEXT','glMultiTexParameteriEXT','glMultiTexParameterivEXT','glMultiTexRenderbufferEXT','glMultiTexSubImage1DEXT','glMultiTexSubImage2DEXT','glMultiTexSubImage3DEXT','glNamedBufferDataEXT','glNamedBufferSubDataEXT','glNamedCopyBufferSubDataEXT','glNamedFramebufferRenderbufferEXT','glNamedFramebufferTexture1DEXT','glNamedFramebufferTexture2DEXT','glNamedFramebufferTexture3DEXT','glNamedFramebufferTextureEXT','glNamedFramebufferTextureFaceEXT','glNamedFramebufferTextureLayerEXT','glNamedProgramLocalParameter4dEXT','glNamedProgramLocalParameter4dvEXT','glNamedProgramLocalParameter4fEXT','glNamedProgramLocalParameter4fvEXT','glNamedProgramLocalParameterI4iEXT','glNamedProgramLocalParameterI4ivEXT','glNamedProgramLocalParameterI4uiEXT','glNamedProgramLocalParameterI4uivEXT','glNamedProgramLocalParameters4fvEXT','glNamedProgramLocalParametersI4ivEXT','glNamedProgramLocalParametersI4uivEXT','glNamedProgramStringEXT','glNamedRenderbufferStorageEXT','glNamedRenderbufferStorageMultisampleCoverageEXT','glNamedRenderbufferStorageMultisampleEXT','glProgramUniform1dEXT','glProgramUniform1dvEXT','glProgramUniform1fEXT','glProgramUniform1fvEXT','glProgramUniform1iEXT','glProgramUniform1ivEXT','glProgramUniform1uiEXT','glProgramUniform1uivEXT','glProgramUniform2dEXT','glProgramUniform2dvEXT','glProgramUniform2fEXT','glProgramUniform2fvEXT','glProgramUniform2iEXT','glProgramUniform2ivEXT','glProgramUniform2uiEXT','glProgramUniform2uivEXT','glProgramUniform3dEXT','glProgramUniform3dvEXT','glProgramUniform3fEXT','glProgramUniform3fvEXT','glProgramUniform3iEXT','glProgramUniform3ivEXT','glProgramUniform3uiEXT','glProgramUniform3uivEXT','glProgramUniform4dEXT','glProgramUniform4dvEXT','glProgramUniform4fEXT','glProgramUniform4fvEXT','glProgramUniform4iEXT','glProgramUniform4ivEXT','glProgramUniform4uiEXT','glProgramUniform4uivEXT','glProgramUniformMatrix2dvEXT','glProgramUniformMatrix2fvEXT','glProgramUniformMatrix2x3dvEXT','glProgramUniformMatrix2x3fvEXT','glProgramUniformMatrix2x4dvEXT','glProgramUniformMatrix2x4fvEXT','glProgramUniformMatrix3dvEXT','glProgramUniformMatrix3fvEXT','glProgramUniformMatrix3x2dvEXT','glProgramUniformMatrix3x2fvEXT','glProgramUniformMatrix3x4dvEXT','glProgramUniformMatrix3x4fvEXT','glProgramUniformMatrix4dvEXT','glProgramUniformMatrix4fvEXT','glProgramUniformMatrix4x2dvEXT','glProgramUniformMatrix4x2fvEXT','glProgramUniformMatrix4x3dvEXT','glProgramUniformMatrix4x3fvEXT','glPushClientAttribDefaultEXT','glTextureBufferEXT','glTextureImage1DEXT','glTextureImage2DEXT','glTextureImage3DEXT','glTextureParameterIivEXT','glTextureParameterIuivEXT','glTextureParameterfEXT','glTextureParameterfvEXT','glTextureParameteriEXT','glTextureParameterivEXT','glTextureRenderbufferEXT','glTextureSubImage1DEXT','glTextureSubImage2DEXT','glTextureSubImage3DEXT','glVertexArrayColorOffsetEXT','glVertexArrayEdgeFlagOffsetEXT','glVertexArrayFogCoordOffsetEXT','glVertexArrayIndexOffsetEXT','glVertexArrayMultiTexCoordOffsetEXT','glVertexArrayNormalOffsetEXT','glVertexArraySecondaryColorOffsetEXT','glVertexArrayTexCoordOffsetEXT','glVertexArrayVertexAttribIOffsetEXT','glVertexArrayVertexAttribOffsetEXT','glVertexArrayVertexOffsetEXT']
gl.add(GL_EXT_direct_state_access)

GL_EXT_draw_buffers2 = Extension('GL_EXT_draw_buffers2')
GL_EXT_draw_buffers2.url = 'http://www.opengl.org/registry/specs/EXT/draw_buffers2.txt'
GL_EXT_draw_buffers2.functions = ['glIsEnabledIndexedEXT','glColorMaskIndexedEXT','glDisableIndexedEXT','glEnableIndexedEXT','glGetBooleanIndexedvEXT','glGetIntegerIndexedvEXT']
gl.add(GL_EXT_draw_buffers2)

GL_EXT_draw_instanced = Extension('GL_EXT_draw_instanced')
GL_EXT_draw_instanced.url = 'http://developer.download.nvidia.com/opengl/specs/GL_EXT_draw_instanced.txt'
GL_EXT_draw_instanced.functions = ['glDrawArraysInstancedEXT','glDrawElementsInstancedEXT']
gl.add(GL_EXT_draw_instanced)

GL_EXT_draw_range_elements = Extension('GL_EXT_draw_range_elements')
GL_EXT_draw_range_elements.url = 'http://oss.sgi.com/projects/ogl-sample/registry/EXT/draw_range_elements.txt'
GL_EXT_draw_range_elements.enumerants = ['GL_MAX_ELEMENTS_INDICES_EXT','GL_MAX_ELEMENTS_VERTICES_EXT']
GL_EXT_draw_range_elements.functions = ['glDrawRangeElementsEXT']
gl.add(GL_EXT_draw_range_elements)

GL_EXT_fog_coord = Extension('GL_EXT_fog_coord')
GL_EXT_fog_coord.url = 'http://oss.sgi.com/projects/ogl-sample/registry/EXT/fog_coord.txt'
GL_EXT_fog_coord.enumerants = ['GL_CURRENT_FOG_COORDINATE_EXT','GL_FOG_COORDINATE_ARRAY_EXT','GL_FOG_COORDINATE_ARRAY_POINTER_EXT','GL_FOG_COORDINATE_ARRAY_STRIDE_EXT','GL_FOG_COORDINATE_ARRAY_TYPE_EXT','GL_FOG_COORDINATE_EXT','GL_FOG_COORDINATE_SOURCE_EXT','GL_FRAGMENT_DEPTH_EXT']
GL_EXT_fog_coord.functions = ['glFogCoordPointerEXT','glFogCoorddEXT','glFogCoorddvEXT','glFogCoordfEXT','glFogCoordfvEXT']
gl.add(GL_EXT_fog_coord)

GL_EXT_fragment_lighting = Extension('GL_EXT_fragment_lighting')
GL_EXT_fragment_lighting.url = 'http://www.opengl.org/registry/specs/EXT/fragment_lighting.txt'
GL_EXT_fragment_lighting.enumerants = ['GL_CURRENT_RASTER_NORMAL_EXT','GL_FRAGMENT_COLOR_MATERIAL_EXT','GL_FRAGMENT_COLOR_MATERIAL_FACE_EXT','GL_FRAGMENT_COLOR_MATERIAL_PARAMETER_EXT','GL_FRAGMENT_LIGHT0_EXT','GL_FRAGMENT_LIGHT7_EXT','GL_FRAGMENT_LIGHTING_EXT','GL_FRAGMENT_LIGHT_MODEL_AMBIENT_EXT','GL_FRAGMENT_LIGHT_MODEL_LOCAL_VIEWER_EXT','GL_FRAGMENT_LIGHT_MODEL_NORMAL_INTERPOLATION_EXT','GL_FRAGMENT_LIGHT_MODEL_TWO_SIDE_EXT','GL_LIGHT_ENV_MODE_EXT','GL_MAX_ACTIVE_LIGHTS_EXT','GL_MAX_FRAGMENT_LIGHTS_EXT']
GL_EXT_fragment_lighting.functions = ['glFragmentColorMaterialEXT','glFragmentLightModelfEXT','glFragmentLightModelfvEXT','glFragmentLightModeliEXT','glFragmentLightModelivEXT','glFragmentLightfEXT','glFragmentLightfvEXT','glFragmentLightiEXT','glFragmentLightivEXT','glFragmentMaterialfEXT','glFragmentMaterialfvEXT','glFragmentMaterialiEXT','glFragmentMaterialivEXT','glGetFragmentLightfvEXT','glGetFragmentLightivEXT','glGetFragmentMaterialfvEXT','glGetFragmentMaterialivEXT','glLightEnviEXT']
gl.add(GL_EXT_fragment_lighting)

GL_EXT_framebuffer_blit = Extension('GL_EXT_framebuffer_blit')
GL_EXT_framebuffer_blit.url = 'http://www.opengl.org/registry/specs/EXT/framebuffer_blit.txt'
GL_EXT_framebuffer_blit.enumerants = ['GL_DRAW_FRAMEBUFFER_BINDING_EXT','GL_DRAW_FRAMEBUFFER_EXT','GL_READ_FRAMEBUFFER_BINDING_EXT','GL_READ_FRAMEBUFFER_EXT']
GL_EXT_framebuffer_blit.functions = ['glBlitFramebufferEXT']
gl.add(GL_EXT_framebuffer_blit)

GL_EXT_framebuffer_multisample = Extension('GL_EXT_framebuffer_multisample')
GL_EXT_framebuffer_multisample.url = 'http://www.opengl.org/registry/specs/EXT/framebuffer_multisample.txt'
GL_EXT_framebuffer_multisample.enumerants = ['GL_FRAMEBUFFER_INCOMPLETE_MULTISAMPLE_EXT','GL_MAX_SAMPLES_EXT','GL_RENDERBUFFER_SAMPLES_EXT']
GL_EXT_framebuffer_multisample.functions = ['glRenderbufferStorageMultisampleEXT']
gl.add(GL_EXT_framebuffer_multisample)

GL_EXT_framebuffer_multisample_blit_scaled = Extension('GL_EXT_framebuffer_multisample_blit_scaled')
GL_EXT_framebuffer_multisample_blit_scaled.url = 'http://www.opengl.org/registry/specs/EXT/framebuffer_multisample_blit_scaled.txt'
GL_EXT_framebuffer_multisample_blit_scaled.enumerants = ['GL_SCALED_RESOLVE_FASTEST_EXT','GL_SCALED_RESOLVE_NICEST_EXT']
gl.add(GL_EXT_framebuffer_multisample_blit_scaled)

GL_EXT_framebuffer_object = Extension('GL_EXT_framebuffer_object')
GL_EXT_framebuffer_object.url = 'http://www.opengl.org/registry/specs/EXT/framebuffer_object.txt'
GL_EXT_framebuffer_object.enumerants = ['GL_COLOR_ATTACHMENT0_EXT','GL_COLOR_ATTACHMENT10_EXT','GL_COLOR_ATTACHMENT11_EXT','GL_COLOR_ATTACHMENT12_EXT','GL_COLOR_ATTACHMENT13_EXT','GL_COLOR_ATTACHMENT14_EXT','GL_COLOR_ATTACHMENT15_EXT','GL_COLOR_ATTACHMENT1_EXT','GL_COLOR_ATTACHMENT2_EXT','GL_COLOR_ATTACHMENT3_EXT','GL_COLOR_ATTACHMENT4_EXT','GL_COLOR_ATTACHMENT5_EXT','GL_COLOR_ATTACHMENT6_EXT','GL_COLOR_ATTACHMENT7_EXT','GL_COLOR_ATTACHMENT8_EXT','GL_COLOR_ATTACHMENT9_EXT','GL_DEPTH_ATTACHMENT_EXT','GL_FRAMEBUFFER_ATTACHMENT_OBJECT_NAME_EXT','GL_FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE_EXT','GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_3D_ZOFFSET_EXT','GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE_EXT','GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL_EXT','GL_FRAMEBUFFER_BINDING_EXT','GL_FRAMEBUFFER_COMPLETE_EXT','GL_FRAMEBUFFER_EXT','GL_FRAMEBUFFER_INCOMPLETE_ATTACHMENT_EXT','GL_FRAMEBUFFER_INCOMPLETE_DIMENSIONS_EXT','GL_FRAMEBUFFER_INCOMPLETE_DRAW_BUFFER_EXT','GL_FRAMEBUFFER_INCOMPLETE_FORMATS_EXT','GL_FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT_EXT','GL_FRAMEBUFFER_INCOMPLETE_READ_BUFFER_EXT','GL_FRAMEBUFFER_UNSUPPORTED_EXT','GL_INVALID_FRAMEBUFFER_OPERATION_EXT','GL_MAX_COLOR_ATTACHMENTS_EXT','GL_MAX_RENDERBUFFER_SIZE_EXT','GL_RENDERBUFFER_ALPHA_SIZE_EXT','GL_RENDERBUFFER_BINDING_EXT','GL_RENDERBUFFER_BLUE_SIZE_EXT','GL_RENDERBUFFER_DEPTH_SIZE_EXT','GL_RENDERBUFFER_EXT','GL_RENDERBUFFER_GREEN_SIZE_EXT','GL_RENDERBUFFER_HEIGHT_EXT','GL_RENDERBUFFER_INTERNAL_FORMAT_EXT','GL_RENDERBUFFER_RED_SIZE_EXT','GL_RENDERBUFFER_STENCIL_SIZE_EXT','GL_RENDERBUFFER_WIDTH_EXT','GL_STENCIL_ATTACHMENT_EXT','GL_STENCIL_INDEX16_EXT','GL_STENCIL_INDEX1_EXT','GL_STENCIL_INDEX4_EXT','GL_STENCIL_INDEX8_EXT']
GL_EXT_framebuffer_object.functions = ['glIsFramebufferEXT','glIsRenderbufferEXT','glCheckFramebufferStatusEXT','glBindFramebufferEXT','glBindRenderbufferEXT','glDeleteFramebuffersEXT','glDeleteRenderbuffersEXT','glFramebufferRenderbufferEXT','glFramebufferTexture1DEXT','glFramebufferTexture2DEXT','glFramebufferTexture3DEXT','glGenFramebuffersEXT','glGenRenderbuffersEXT','glGenerateMipmapEXT','glGetFramebufferAttachmentParameterivEXT','glGetRenderbufferParameterivEXT','glRenderbufferStorageEXT']
gl.add(GL_EXT_framebuffer_object)

GL_EXT_framebuffer_sRGB = Extension('GL_EXT_framebuffer_sRGB')
GL_EXT_framebuffer_sRGB.url = 'http://developer.download.nvidia.com/opengl/specs/GL_EXT_framebuffer_sRGB.txt'
GL_EXT_framebuffer_sRGB.enumerants = ['GL_FRAMEBUFFER_SRGB_CAPABLE_EXT','GL_FRAMEBUFFER_SRGB_EXT']
gl.add(GL_EXT_framebuffer_sRGB)

GL_EXT_geometry_shader4 = Extension('GL_EXT_geometry_shader4')
GL_EXT_geometry_shader4.url = 'http://developer.download.nvidia.com/opengl/specs/GL_EXT_geometry_shader4.txt'
GL_EXT_geometry_shader4.enumerants = ['GL_FRAMEBUFFER_ATTACHMENT_LAYERED_EXT','GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_LAYER_EXT','GL_FRAMEBUFFER_INCOMPLETE_LAYER_COUNT_EXT','GL_FRAMEBUFFER_INCOMPLETE_LAYER_TARGETS_EXT','GL_GEOMETRY_INPUT_TYPE_EXT','GL_GEOMETRY_OUTPUT_TYPE_EXT','GL_GEOMETRY_SHADER_EXT','GL_GEOMETRY_VERTICES_OUT_EXT','GL_LINES_ADJACENCY_EXT','GL_LINE_STRIP_ADJACENCY_EXT','GL_MAX_GEOMETRY_OUTPUT_VERTICES_EXT','GL_MAX_GEOMETRY_TEXTURE_IMAGE_UNITS_EXT','GL_MAX_GEOMETRY_TOTAL_OUTPUT_COMPONENTS_EXT','GL_MAX_GEOMETRY_UNIFORM_COMPONENTS_EXT','GL_MAX_GEOMETRY_VARYING_COMPONENTS_EXT','GL_MAX_VARYING_COMPONENTS_EXT','GL_MAX_VERTEX_VARYING_COMPONENTS_EXT','GL_PROGRAM_POINT_SIZE_EXT','GL_TRIANGLES_ADJACENCY_EXT','GL_TRIANGLE_STRIP_ADJACENCY_EXT']
GL_EXT_geometry_shader4.functions = ['glFramebufferTextureEXT','glFramebufferTextureFaceEXT','glProgramParameteriEXT']
gl.add(GL_EXT_geometry_shader4)

GL_EXT_gpu_program_parameters = Extension('GL_EXT_gpu_program_parameters')
GL_EXT_gpu_program_parameters.url = 'http://developer.download.nvidia.com/opengl/specs/GL_EXT_gpu_program_parameters.txt'
GL_EXT_gpu_program_parameters.functions = ['glProgramEnvParameters4fvEXT','glProgramLocalParameters4fvEXT']
gl.add(GL_EXT_gpu_program_parameters)

GL_EXT_gpu_shader4 = Extension('GL_EXT_gpu_shader4')
GL_EXT_gpu_shader4.url = 'http://developer.download.nvidia.com/opengl/specs/GL_EXT_gpu_shader4.txt'
GL_EXT_gpu_shader4.enumerants = ['GL_INT_SAMPLER_1D_ARRAY_EXT','GL_INT_SAMPLER_1D_EXT','GL_INT_SAMPLER_2D_ARRAY_EXT','GL_INT_SAMPLER_2D_EXT','GL_INT_SAMPLER_2D_RECT_EXT','GL_INT_SAMPLER_3D_EXT','GL_INT_SAMPLER_BUFFER_EXT','GL_INT_SAMPLER_CUBE_EXT','GL_SAMPLER_1D_ARRAY_EXT','GL_SAMPLER_1D_ARRAY_SHADOW_EXT','GL_SAMPLER_2D_ARRAY_EXT','GL_SAMPLER_2D_ARRAY_SHADOW_EXT','GL_SAMPLER_BUFFER_EXT','GL_SAMPLER_CUBE_SHADOW_EXT','GL_UNSIGNED_INT_SAMPLER_1D_ARRAY_EXT','GL_UNSIGNED_INT_SAMPLER_1D_EXT','GL_UNSIGNED_INT_SAMPLER_2D_ARRAY_EXT','GL_UNSIGNED_INT_SAMPLER_2D_EXT','GL_UNSIGNED_INT_SAMPLER_2D_RECT_EXT','GL_UNSIGNED_INT_SAMPLER_3D_EXT','GL_UNSIGNED_INT_SAMPLER_BUFFER_EXT','GL_UNSIGNED_INT_SAMPLER_CUBE_EXT','GL_UNSIGNED_INT_VEC2_EXT','GL_UNSIGNED_INT_VEC3_EXT','GL_UNSIGNED_INT_VEC4_EXT','GL_VERTEX_ATTRIB_ARRAY_INTEGER_EXT']
GL_EXT_gpu_shader4.functions = ['glGetFragDataLocationEXT','glBindFragDataLocationEXT','glGetUniformuivEXT','glGetVertexAttribIivEXT','glGetVertexAttribIuivEXT','glUniform1uiEXT','glUniform1uivEXT','glUniform2uiEXT','glUniform2uivEXT','glUniform3uiEXT','glUniform3uivEXT','glUniform4uiEXT','glUniform4uivEXT','glVertexAttribI1iEXT','glVertexAttribI1ivEXT','glVertexAttribI1uiEXT','glVertexAttribI1uivEXT','glVertexAttribI2iEXT','glVertexAttribI2ivEXT','glVertexAttribI2uiEXT','glVertexAttribI2uivEXT','glVertexAttribI3iEXT','glVertexAttribI3ivEXT','glVertexAttribI3uiEXT','glVertexAttribI3uivEXT','glVertexAttribI4bvEXT','glVertexAttribI4iEXT','glVertexAttribI4ivEXT','glVertexAttribI4svEXT','glVertexAttribI4ubvEXT','glVertexAttribI4uiEXT','glVertexAttribI4uivEXT','glVertexAttribI4usvEXT','glVertexAttribIPointerEXT']
gl.add(GL_EXT_gpu_shader4)

GL_EXT_histogram = Extension('GL_EXT_histogram')
GL_EXT_histogram.url = 'http://www.opengl.org/registry/specs/EXT/histogram.txt'
GL_EXT_histogram.enumerants = ['GL_HISTOGRAM_ALPHA_SIZE_EXT','GL_HISTOGRAM_BLUE_SIZE_EXT','GL_HISTOGRAM_EXT','GL_HISTOGRAM_FORMAT_EXT','GL_HISTOGRAM_GREEN_SIZE_EXT','GL_HISTOGRAM_LUMINANCE_SIZE_EXT','GL_HISTOGRAM_RED_SIZE_EXT','GL_HISTOGRAM_SINK_EXT','GL_HISTOGRAM_WIDTH_EXT','GL_MINMAX_EXT','GL_MINMAX_FORMAT_EXT','GL_MINMAX_SINK_EXT','GL_PROXY_HISTOGRAM_EXT']
GL_EXT_histogram.functions = ['glGetHistogramEXT','glGetHistogramParameterfvEXT','glGetHistogramParameterivEXT','glGetMinmaxEXT','glGetMinmaxParameterfvEXT','glGetMinmaxParameterivEXT','glHistogramEXT','glMinmaxEXT','glResetHistogramEXT','glResetMinmaxEXT']
gl.add(GL_EXT_histogram)

GL_EXT_index_array_formats = Extension('GL_EXT_index_array_formats')
GL_EXT_index_array_formats.url = 'http://www.opengl.org/registry/specs/EXT/index_array_formats.txt'
gl.add(GL_EXT_index_array_formats)

GL_EXT_index_func = Extension('GL_EXT_index_func')
GL_EXT_index_func.url = 'http://www.opengl.org/registry/specs/EXT/index_func.txt'
GL_EXT_index_func.functions = ['glIndexFuncEXT']
gl.add(GL_EXT_index_func)

GL_EXT_index_material = Extension('GL_EXT_index_material')
GL_EXT_index_material.url = 'http://www.opengl.org/registry/specs/EXT/index_material.txt'
GL_EXT_index_material.functions = ['glIndexMaterialEXT']
gl.add(GL_EXT_index_material)

GL_EXT_index_texture = Extension('GL_EXT_index_texture')
GL_EXT_index_texture.url = 'http://www.opengl.org/registry/specs/EXT/index_texture.txt'
gl.add(GL_EXT_index_texture)

GL_EXT_light_texture = Extension('GL_EXT_light_texture')
GL_EXT_light_texture.url = 'http://www.opengl.org/registry/specs/EXT/light_texture.txt'
GL_EXT_light_texture.enumerants = ['GL_ATTENUATION_EXT','GL_FRAGMENT_COLOR_EXT','GL_FRAGMENT_MATERIAL_EXT','GL_FRAGMENT_NORMAL_EXT','GL_SHADOW_ATTENUATION_EXT','GL_TEXTURE_APPLICATION_MODE_EXT','GL_TEXTURE_LIGHT_EXT','GL_TEXTURE_MATERIAL_FACE_EXT','GL_TEXTURE_MATERIAL_PARAMETER_EXT']
GL_EXT_light_texture.functions = ['glApplyTextureEXT','glTextureLightEXT','glTextureMaterialEXT']
gl.add(GL_EXT_light_texture)

GL_EXT_misc_attribute = Extension('GL_EXT_misc_attribute')
GL_EXT_misc_attribute.url = 'http://www.opengl.org/registry/specs/EXT/misc_attribute.txt'
gl.add(GL_EXT_misc_attribute)

GL_EXT_multi_draw_arrays = Extension('GL_EXT_multi_draw_arrays')
GL_EXT_multi_draw_arrays.url = 'http://www.opengl.org/registry/specs/EXT/multi_draw_arrays.txt'
GL_EXT_multi_draw_arrays.functions = ['glMultiDrawArraysEXT','glMultiDrawElementsEXT']
gl.add(GL_EXT_multi_draw_arrays)

GL_EXT_multisample = Extension('GL_EXT_multisample')
GL_EXT_multisample.url = 'http://www.opengl.org/registry/specs/EXT/wgl_multisample.txt'
GL_EXT_multisample.enumerants = ['GL_1PASS_EXT','GL_2PASS_0_EXT','GL_2PASS_1_EXT','GL_4PASS_0_EXT','GL_4PASS_1_EXT','GL_4PASS_2_EXT','GL_4PASS_3_EXT','GL_MULTISAMPLE_BIT_EXT','GL_MULTISAMPLE_EXT','GL_SAMPLES_EXT','GL_SAMPLE_ALPHA_TO_MASK_EXT','GL_SAMPLE_ALPHA_TO_ONE_EXT','GL_SAMPLE_BUFFERS_EXT','GL_SAMPLE_MASK_EXT','GL_SAMPLE_MASK_INVERT_EXT','GL_SAMPLE_MASK_VALUE_EXT','GL_SAMPLE_PATTERN_EXT']
GL_EXT_multisample.functions = ['glSampleMaskEXT','glSamplePatternEXT']
gl.add(GL_EXT_multisample)

GL_EXT_packed_depth_stencil = Extension('GL_EXT_packed_depth_stencil')
GL_EXT_packed_depth_stencil.url = 'http://www.opengl.org/registry/specs/EXT/packed_depth_stencil.txt'
GL_EXT_packed_depth_stencil.enumerants = ['GL_DEPTH24_STENCIL8_EXT','GL_DEPTH_STENCIL_EXT','GL_TEXTURE_STENCIL_SIZE_EXT','GL_UNSIGNED_INT_24_8_EXT']
gl.add(GL_EXT_packed_depth_stencil)

GL_EXT_packed_float = Extension('GL_EXT_packed_float')
GL_EXT_packed_float.url = 'http://developer.download.nvidia.com/opengl/specs/GL_EXT_packed_float.txt'
GL_EXT_packed_float.enumerants = ['GL_R11F_G11F_B10F_EXT','GL_RGBA_SIGNED_COMPONENTS_EXT','GL_UNSIGNED_INT_10F_11F_11F_REV_EXT']
gl.add(GL_EXT_packed_float)

GL_EXT_packed_pixels = Extension('GL_EXT_packed_pixels')
GL_EXT_packed_pixels.url = 'http://www.opengl.org/registry/specs/EXT/packed_pixels.txt'
GL_EXT_packed_pixels.enumerants = ['GL_UNSIGNED_BYTE_3_3_2_EXT','GL_UNSIGNED_INT_10_10_10_2_EXT','GL_UNSIGNED_INT_8_8_8_8_EXT','GL_UNSIGNED_SHORT_4_4_4_4_EXT','GL_UNSIGNED_SHORT_5_5_5_1_EXT']
gl.add(GL_EXT_packed_pixels)

GL_EXT_paletted_texture = Extension('GL_EXT_paletted_texture')
GL_EXT_paletted_texture.url = 'http://www.opengl.org/registry/specs/EXT/paletted_texture.txt'
GL_EXT_paletted_texture.enumerants = ['GL_COLOR_INDEX12_EXT','GL_COLOR_INDEX16_EXT','GL_COLOR_INDEX1_EXT','GL_COLOR_INDEX2_EXT','GL_COLOR_INDEX4_EXT','GL_COLOR_INDEX8_EXT','GL_COLOR_TABLE_ALPHA_SIZE_EXT','GL_COLOR_TABLE_BLUE_SIZE_EXT','GL_COLOR_TABLE_FORMAT_EXT','GL_COLOR_TABLE_GREEN_SIZE_EXT','GL_COLOR_TABLE_INTENSITY_SIZE_EXT','GL_COLOR_TABLE_LUMINANCE_SIZE_EXT','GL_COLOR_TABLE_RED_SIZE_EXT','GL_COLOR_TABLE_WIDTH_EXT','GL_PROXY_TEXTURE_1D','GL_PROXY_TEXTURE_2D','GL_TEXTURE_1D','GL_TEXTURE_2D','GL_TEXTURE_INDEX_SIZE_EXT']
GL_EXT_paletted_texture.functions = ['glColorTableEXT','glGetColorTableEXT','glGetColorTableParameterfvEXT','glGetColorTableParameterivEXT']
gl.add(GL_EXT_paletted_texture)

GL_EXT_pixel_buffer_object = Extension('GL_EXT_pixel_buffer_object')
GL_EXT_pixel_buffer_object.url = 'http://www.nvidia.com/dev_content/nvopenglspecs/GL_EXT_pixel_buffer_object.txt'
GL_EXT_pixel_buffer_object.enumerants = ['GL_PIXEL_PACK_BUFFER_BINDING_EXT','GL_PIXEL_PACK_BUFFER_EXT','GL_PIXEL_UNPACK_BUFFER_BINDING_EXT','GL_PIXEL_UNPACK_BUFFER_EXT']
gl.add(GL_EXT_pixel_buffer_object)

GL_EXT_pixel_transform = Extension('GL_EXT_pixel_transform')
GL_EXT_pixel_transform.url = 'http://www.opengl.org/registry/specs/EXT/pixel_transform.txt'
GL_EXT_pixel_transform.enumerants = ['GL_AVERAGE_EXT','GL_CUBIC_EXT','GL_MAX_PIXEL_TRANSFORM_2D_STACK_DEPTH_EXT','GL_PIXEL_CUBIC_WEIGHT_EXT','GL_PIXEL_MAG_FILTER_EXT','GL_PIXEL_MIN_FILTER_EXT','GL_PIXEL_TRANSFORM_2D_EXT','GL_PIXEL_TRANSFORM_2D_MATRIX_EXT','GL_PIXEL_TRANSFORM_2D_STACK_DEPTH_EXT']
GL_EXT_pixel_transform.functions = ['glGetPixelTransformParameterfvEXT','glGetPixelTransformParameterivEXT','glPixelTransformParameterfEXT','glPixelTransformParameterfvEXT','glPixelTransformParameteriEXT','glPixelTransformParameterivEXT']
gl.add(GL_EXT_pixel_transform)

GL_EXT_pixel_transform_color_table = Extension('GL_EXT_pixel_transform_color_table')
GL_EXT_pixel_transform_color_table.url = 'http://www.opengl.org/registry/specs/EXT/pixel_transform_color_table.txt'
gl.add(GL_EXT_pixel_transform_color_table)

GL_EXT_point_parameters = Extension('GL_EXT_point_parameters')
GL_EXT_point_parameters.url = 'http://www.opengl.org/registry/specs/EXT/point_parameters.txt'
GL_EXT_point_parameters.enumerants = ['GL_DISTANCE_ATTENUATION_EXT','GL_POINT_FADE_THRESHOLD_SIZE_EXT','GL_POINT_SIZE_MAX_EXT','GL_POINT_SIZE_MIN_EXT']
GL_EXT_point_parameters.functions = ['glPointParameterfEXT','glPointParameterfvEXT']
gl.add(GL_EXT_point_parameters)

GL_EXT_polygon_offset = Extension('GL_EXT_polygon_offset')
GL_EXT_polygon_offset.url = 'http://www.opengl.org/registry/specs/EXT/polygon_offset.txt'
GL_EXT_polygon_offset.enumerants = ['GL_POLYGON_OFFSET_BIAS_EXT','GL_POLYGON_OFFSET_EXT','GL_POLYGON_OFFSET_FACTOR_EXT']
GL_EXT_polygon_offset.functions = ['glPolygonOffsetEXT']
gl.add(GL_EXT_polygon_offset)

GL_EXT_provoking_vertex = Extension('GL_EXT_provoking_vertex')
GL_EXT_provoking_vertex.url = 'http://www.opengl.org/registry/specs/EXT/provoking_vertex.txt'
GL_EXT_provoking_vertex.enumerants = ['GL_FIRST_VERTEX_CONVENTION_EXT','GL_LAST_VERTEX_CONVENTION_EXT','GL_PROVOKING_VERTEX_EXT','GL_QUADS_FOLLOW_PROVOKING_VERTEX_CONVENTION_EXT']
GL_EXT_provoking_vertex.functions = ['glProvokingVertexEXT']
gl.add(GL_EXT_provoking_vertex)

GL_EXT_rescale_normal = Extension('GL_EXT_rescale_normal')
GL_EXT_rescale_normal.url = 'http://www.opengl.org/registry/specs/EXT/rescale_normal.txt'
GL_EXT_rescale_normal.enumerants = ['GL_RESCALE_NORMAL_EXT']
gl.add(GL_EXT_rescale_normal)

GL_EXT_scene_marker = Extension('GL_EXT_scene_marker')
GL_EXT_scene_marker.url = 'http://www.opengl.org/registry/specs/EXT/scene_marker.txt'
GL_EXT_scene_marker.functions = ['glBeginSceneEXT','glEndSceneEXT']
gl.add(GL_EXT_scene_marker)

GL_EXT_secondary_color = Extension('GL_EXT_secondary_color')
GL_EXT_secondary_color.url = 'http://oss.sgi.com/projects/ogl-sample/registry/EXT/secondary_color.txt'
GL_EXT_secondary_color.enumerants = ['GL_COLOR_SUM_EXT','GL_CURRENT_SECONDARY_COLOR_EXT','GL_SECONDARY_COLOR_ARRAY_EXT','GL_SECONDARY_COLOR_ARRAY_POINTER_EXT','GL_SECONDARY_COLOR_ARRAY_SIZE_EXT','GL_SECONDARY_COLOR_ARRAY_STRIDE_EXT','GL_SECONDARY_COLOR_ARRAY_TYPE_EXT']
GL_EXT_secondary_color.functions = ['glSecondaryColor3bEXT','glSecondaryColor3bvEXT','glSecondaryColor3dEXT','glSecondaryColor3dvEXT','glSecondaryColor3fEXT','glSecondaryColor3fvEXT','glSecondaryColor3iEXT','glSecondaryColor3ivEXT','glSecondaryColor3sEXT','glSecondaryColor3svEXT','glSecondaryColor3ubEXT','glSecondaryColor3ubvEXT','glSecondaryColor3uiEXT','glSecondaryColor3uivEXT','glSecondaryColor3usEXT','glSecondaryColor3usvEXT','glSecondaryColorPointerEXT']
gl.add(GL_EXT_secondary_color)

GL_EXT_separate_shader_objects = Extension('GL_EXT_separate_shader_objects')
GL_EXT_separate_shader_objects.url = 'http://www.opengl.org/registry/specs/EXT/separate_shader_objects.txt'
GL_EXT_separate_shader_objects.enumerants = ['GL_ACTIVE_PROGRAM_EXT']
GL_EXT_separate_shader_objects.functions = ['glCreateShaderProgramEXT','glActiveProgramEXT','glUseShaderProgramEXT']
gl.add(GL_EXT_separate_shader_objects)

GL_EXT_separate_specular_color = Extension('GL_EXT_separate_specular_color')
GL_EXT_separate_specular_color.url = 'http://www.opengl.org/registry/specs/EXT/separate_specular_color.txt'
GL_EXT_separate_specular_color.enumerants = ['GL_LIGHT_MODEL_COLOR_CONTROL_EXT','GL_SEPARATE_SPECULAR_COLOR_EXT','GL_SINGLE_COLOR_EXT']
gl.add(GL_EXT_separate_specular_color)

GL_EXT_shader_image_load_store = Extension('GL_EXT_shader_image_load_store')
GL_EXT_shader_image_load_store.url = 'http://www.opengl.org/registry/specs/EXT/shader_image_load_store.txt'
GL_EXT_shader_image_load_store.enumerants = ['GL_ALL_BARRIER_BITS_EXT','GL_ATOMIC_COUNTER_BARRIER_BIT_EXT','GL_BUFFER_UPDATE_BARRIER_BIT_EXT','GL_COMMAND_BARRIER_BIT_EXT','GL_ELEMENT_ARRAY_BARRIER_BIT_EXT','GL_FRAMEBUFFER_BARRIER_BIT_EXT','GL_IMAGE_1D_ARRAY_EXT','GL_IMAGE_1D_EXT','GL_IMAGE_2D_ARRAY_EXT','GL_IMAGE_2D_EXT','GL_IMAGE_2D_MULTISAMPLE_ARRAY_EXT','GL_IMAGE_2D_MULTISAMPLE_EXT','GL_IMAGE_2D_RECT_EXT','GL_IMAGE_3D_EXT','GL_IMAGE_BINDING_ACCESS_EXT','GL_IMAGE_BINDING_FORMAT_EXT','GL_IMAGE_BINDING_LAYERED_EXT','GL_IMAGE_BINDING_LAYER_EXT','GL_IMAGE_BINDING_LEVEL_EXT','GL_IMAGE_BINDING_NAME_EXT','GL_IMAGE_BUFFER_EXT','GL_IMAGE_CUBE_EXT','GL_IMAGE_CUBE_MAP_ARRAY_EXT','GL_INT_IMAGE_1D_ARRAY_EXT','GL_INT_IMAGE_1D_EXT','GL_INT_IMAGE_2D_ARRAY_EXT','GL_INT_IMAGE_2D_EXT','GL_INT_IMAGE_2D_MULTISAMPLE_ARRAY_EXT','GL_INT_IMAGE_2D_MULTISAMPLE_EXT','GL_INT_IMAGE_2D_RECT_EXT','GL_INT_IMAGE_3D_EXT','GL_INT_IMAGE_BUFFER_EXT','GL_INT_IMAGE_CUBE_EXT','GL_INT_IMAGE_CUBE_MAP_ARRAY_EXT','GL_MAX_COMBINED_IMAGE_UNITS_AND_FRAGMENT_OUTPUTS_EXT','GL_MAX_IMAGE_SAMPLES_EXT','GL_MAX_IMAGE_UNITS_EXT','GL_PIXEL_BUFFER_BARRIER_BIT_EXT','GL_SHADER_IMAGE_ACCESS_BARRIER_BIT_EXT','GL_TEXTURE_FETCH_BARRIER_BIT_EXT','GL_TEXTURE_UPDATE_BARRIER_BIT_EXT','GL_TRANSFORM_FEEDBACK_BARRIER_BIT_EXT','GL_UNIFORM_BARRIER_BIT_EXT','GL_UNSIGNED_INT_IMAGE_1D_ARRAY_EXT','GL_UNSIGNED_INT_IMAGE_1D_EXT','GL_UNSIGNED_INT_IMAGE_2D_ARRAY_EXT','GL_UNSIGNED_INT_IMAGE_2D_EXT','GL_UNSIGNED_INT_IMAGE_2D_MULTISAMPLE_ARRAY_EXT','GL_UNSIGNED_INT_IMAGE_2D_MULTISAMPLE_EXT','GL_UNSIGNED_INT_IMAGE_2D_RECT_EXT','GL_UNSIGNED_INT_IMAGE_3D_EXT','GL_UNSIGNED_INT_IMAGE_BUFFER_EXT','GL_UNSIGNED_INT_IMAGE_CUBE_EXT','GL_UNSIGNED_INT_IMAGE_CUBE_MAP_ARRAY_EXT','GL_VERTEX_ATTRIB_ARRAY_BARRIER_BIT_EXT']
GL_EXT_shader_image_load_store.functions = ['glBindImageTextureEXT','glMemoryBarrierEXT']
gl.add(GL_EXT_shader_image_load_store)

GL_EXT_shadow_funcs = Extension('GL_EXT_shadow_funcs')
GL_EXT_shadow_funcs.url = 'http://www.opengl.org/registry/specs/EXT/shadow_funcs.txt'
gl.add(GL_EXT_shadow_funcs)

GL_EXT_shared_texture_palette = Extension('GL_EXT_shared_texture_palette')
GL_EXT_shared_texture_palette.url = 'http://www.opengl.org/registry/specs/EXT/shared_texture_palette.txt'
GL_EXT_shared_texture_palette.enumerants = ['GL_SHARED_TEXTURE_PALETTE_EXT']
gl.add(GL_EXT_shared_texture_palette)

GL_EXT_stencil_clear_tag = Extension('GL_EXT_stencil_clear_tag')
GL_EXT_stencil_clear_tag.url = 'http://www.opengl.org/registry/specs/EXT/stencil_clear_tag.txt'
GL_EXT_stencil_clear_tag.enumerants = ['GL_STENCIL_CLEAR_TAG_VALUE_EXT','GL_STENCIL_TAG_BITS_EXT']
gl.add(GL_EXT_stencil_clear_tag)

GL_EXT_stencil_two_side = Extension('GL_EXT_stencil_two_side')
GL_EXT_stencil_two_side.url = 'http://www.opengl.org/registry/specs/EXT/stencil_two_side.txt'
GL_EXT_stencil_two_side.enumerants = ['GL_ACTIVE_STENCIL_FACE_EXT','GL_STENCIL_TEST_TWO_SIDE_EXT']
GL_EXT_stencil_two_side.functions = ['glActiveStencilFaceEXT']
gl.add(GL_EXT_stencil_two_side)

GL_EXT_stencil_wrap = Extension('GL_EXT_stencil_wrap')
GL_EXT_stencil_wrap.url = 'http://www.opengl.org/registry/specs/EXT/stencil_wrap.txt'
GL_EXT_stencil_wrap.enumerants = ['GL_DECR_WRAP_EXT','GL_INCR_WRAP_EXT']
gl.add(GL_EXT_stencil_wrap)

GL_EXT_subtexture = Extension('GL_EXT_subtexture')
GL_EXT_subtexture.url = 'http://www.opengl.org/registry/specs/EXT/subtexture.txt'
GL_EXT_subtexture.functions = ['glTexSubImage1DEXT','glTexSubImage2DEXT','glTexSubImage3DEXT']
gl.add(GL_EXT_subtexture)

GL_EXT_texture = Extension('GL_EXT_texture')
GL_EXT_texture.url = 'http://www.opengl.org/registry/specs/EXT/texture.txt'
GL_EXT_texture.enumerants = ['GL_ALPHA12_EXT','GL_ALPHA16_EXT','GL_ALPHA4_EXT','GL_ALPHA8_EXT','GL_INTENSITY12_EXT','GL_INTENSITY16_EXT','GL_INTENSITY4_EXT','GL_INTENSITY8_EXT','GL_INTENSITY_EXT','GL_LUMINANCE12_ALPHA12_EXT','GL_LUMINANCE12_ALPHA4_EXT','GL_LUMINANCE12_EXT','GL_LUMINANCE16_ALPHA16_EXT','GL_LUMINANCE16_EXT','GL_LUMINANCE4_ALPHA4_EXT','GL_LUMINANCE4_EXT','GL_LUMINANCE6_ALPHA2_EXT','GL_LUMINANCE8_ALPHA8_EXT','GL_LUMINANCE8_EXT','GL_PROXY_TEXTURE_1D_EXT','GL_PROXY_TEXTURE_2D_EXT','GL_REPLACE_EXT','GL_RGB10_A2_EXT','GL_RGB10_EXT','GL_RGB12_EXT','GL_RGB16_EXT','GL_RGB2_EXT','GL_RGB4_EXT','GL_RGB5_A1_EXT','GL_RGB5_EXT','GL_RGB8_EXT','GL_RGBA12_EXT','GL_RGBA16_EXT','GL_RGBA2_EXT','GL_RGBA4_EXT','GL_RGBA8_EXT','GL_TEXTURE_ALPHA_SIZE_EXT','GL_TEXTURE_BLUE_SIZE_EXT','GL_TEXTURE_GREEN_SIZE_EXT','GL_TEXTURE_INTENSITY_SIZE_EXT','GL_TEXTURE_LUMINANCE_SIZE_EXT','GL_TEXTURE_RED_SIZE_EXT']
gl.add(GL_EXT_texture)

GL_EXT_texture3D = Extension('GL_EXT_texture3D')
GL_EXT_texture3D.url = 'http://www.opengl.org/registry/specs/EXT/texture3D.txt'
GL_EXT_texture3D.enumerants = ['GL_MAX_3D_TEXTURE_SIZE_EXT','GL_PACK_IMAGE_HEIGHT_EXT','GL_PACK_SKIP_IMAGES_EXT','GL_PROXY_TEXTURE_3D_EXT','GL_TEXTURE_3D_EXT','GL_TEXTURE_DEPTH_EXT','GL_TEXTURE_WRAP_R_EXT','GL_UNPACK_IMAGE_HEIGHT_EXT','GL_UNPACK_SKIP_IMAGES_EXT']
GL_EXT_texture3D.functions = ['glTexImage3DEXT']
gl.add(GL_EXT_texture3D)

GL_EXT_texture_array = Extension('GL_EXT_texture_array')
GL_EXT_texture_array.url = 'http://developer.download.nvidia.com/opengl/specs/GL_EXT_texture_array.txt'
GL_EXT_texture_array.enumerants = ['GL_COMPARE_REF_DEPTH_TO_TEXTURE_EXT','GL_MAX_ARRAY_TEXTURE_LAYERS_EXT','GL_PROXY_TEXTURE_1D_ARRAY_EXT','GL_PROXY_TEXTURE_2D_ARRAY_EXT','GL_TEXTURE_1D_ARRAY_EXT','GL_TEXTURE_2D_ARRAY_EXT','GL_TEXTURE_BINDING_1D_ARRAY_EXT','GL_TEXTURE_BINDING_2D_ARRAY_EXT']
GL_EXT_texture_array.functions = ['glFramebufferTextureLayerEXT']
gl.add(GL_EXT_texture_array)

GL_EXT_texture_buffer_object = Extension('GL_EXT_texture_buffer_object')
GL_EXT_texture_buffer_object.url = 'http://developer.download.nvidia.com/opengl/specs/GL_EXT_texture_buffer_object.txt'
GL_EXT_texture_buffer_object.enumerants = ['GL_MAX_TEXTURE_BUFFER_SIZE_EXT','GL_TEXTURE_BINDING_BUFFER_EXT','GL_TEXTURE_BUFFER_DATA_STORE_BINDING_EXT','GL_TEXTURE_BUFFER_EXT','GL_TEXTURE_BUFFER_FORMAT_EXT']
GL_EXT_texture_buffer_object.functions = ['glTexBufferEXT']
gl.add(GL_EXT_texture_buffer_object)

GL_EXT_texture_compression_dxt1 = Extension('GL_EXT_texture_compression_dxt1')
GL_EXT_texture_compression_dxt1.url = 'http://www.opengl.org/registry/specs/EXT/texture_compression_dxt1.txt'
gl.add(GL_EXT_texture_compression_dxt1)

GL_EXT_texture_compression_latc = Extension('GL_EXT_texture_compression_latc')
GL_EXT_texture_compression_latc.url = 'http://developer.download.nvidia.com/opengl/specs/GL_EXT_texture_compression_latc.txt'
GL_EXT_texture_compression_latc.enumerants = ['GL_COMPRESSED_LUMINANCE_ALPHA_LATC2_EXT','GL_COMPRESSED_LUMINANCE_LATC1_EXT','GL_COMPRESSED_SIGNED_LUMINANCE_ALPHA_LATC2_EXT','GL_COMPRESSED_SIGNED_LUMINANCE_LATC1_EXT']
gl.add(GL_EXT_texture_compression_latc)

GL_EXT_texture_compression_rgtc = Extension('GL_EXT_texture_compression_rgtc')
GL_EXT_texture_compression_rgtc.url = 'http://developer.download.nvidia.com/opengl/specs/GL_EXT_texture_compression_rgtc.txt'
GL_EXT_texture_compression_rgtc.enumerants = ['GL_COMPRESSED_RED_GREEN_RGTC2_EXT','GL_COMPRESSED_RED_RGTC1_EXT','GL_COMPRESSED_SIGNED_RED_GREEN_RGTC2_EXT','GL_COMPRESSED_SIGNED_RED_RGTC1_EXT']
gl.add(GL_EXT_texture_compression_rgtc)

GL_EXT_texture_compression_s3tc = Extension('GL_EXT_texture_compression_s3tc')
GL_EXT_texture_compression_s3tc.url = 'http://www.opengl.org/registry/specs/EXT/texture_compression_s3tc.txt'
GL_EXT_texture_compression_s3tc.enumerants = ['GL_COMPRESSED_RGBA_S3TC_DXT1_EXT','GL_COMPRESSED_RGBA_S3TC_DXT3_EXT','GL_COMPRESSED_RGBA_S3TC_DXT5_EXT','GL_COMPRESSED_RGB_S3TC_DXT1_EXT']
gl.add(GL_EXT_texture_compression_s3tc)

GL_EXT_texture_cube_map = Extension('GL_EXT_texture_cube_map')
GL_EXT_texture_cube_map.url = 'http://www.nvidia.com/dev_content/nvopenglspecs/GL_EXT_texture_cube_map.txt'
GL_EXT_texture_cube_map.enumerants = ['GL_MAX_CUBE_MAP_TEXTURE_SIZE_EXT','GL_NORMAL_MAP_EXT','GL_PROXY_TEXTURE_CUBE_MAP_EXT','GL_REFLECTION_MAP_EXT','GL_TEXTURE_BINDING_CUBE_MAP_EXT','GL_TEXTURE_CUBE_MAP_EXT','GL_TEXTURE_CUBE_MAP_NEGATIVE_X_EXT','GL_TEXTURE_CUBE_MAP_NEGATIVE_Y_EXT','GL_TEXTURE_CUBE_MAP_NEGATIVE_Z_EXT','GL_TEXTURE_CUBE_MAP_POSITIVE_X_EXT','GL_TEXTURE_CUBE_MAP_POSITIVE_Y_EXT','GL_TEXTURE_CUBE_MAP_POSITIVE_Z_EXT']
gl.add(GL_EXT_texture_cube_map)

GL_EXT_texture_edge_clamp = Extension('GL_EXT_texture_edge_clamp')
GL_EXT_texture_edge_clamp.url = 'http://www.opengl.org/developers/documentation/Version1.2/1.2specs/texture_edge_clamp.txt'
GL_EXT_texture_edge_clamp.enumerants = ['GL_CLAMP_TO_EDGE_EXT']
gl.add(GL_EXT_texture_edge_clamp)

GL_EXT_texture_env = Extension('GL_EXT_texture_env')
GL_EXT_texture_env.url = 'http://www.opengl.org/registry/specs/EXT/texture_env.txt'
gl.add(GL_EXT_texture_env)

GL_EXT_texture_env_add = Extension('GL_EXT_texture_env_add')
GL_EXT_texture_env_add.url = 'http://www.opengl.org/registry/specs/EXT/texture_env_add.txt'
gl.add(GL_EXT_texture_env_add)

GL_EXT_texture_env_combine = Extension('GL_EXT_texture_env_combine')
GL_EXT_texture_env_combine.url = 'http://www.opengl.org/registry/specs/EXT/texture_env_combine.txt'
GL_EXT_texture_env_combine.enumerants = ['GL_ADD_SIGNED_EXT','GL_COMBINE_ALPHA_EXT','GL_COMBINE_EXT','GL_COMBINE_RGB_EXT','GL_CONSTANT_EXT','GL_INTERPOLATE_EXT','GL_OPERAND0_ALPHA_EXT','GL_OPERAND0_RGB_EXT','GL_OPERAND1_ALPHA_EXT','GL_OPERAND1_RGB_EXT','GL_OPERAND2_ALPHA_EXT','GL_OPERAND2_RGB_EXT','GL_PREVIOUS_EXT','GL_PRIMARY_COLOR_EXT','GL_RGB_SCALE_EXT','GL_SOURCE0_ALPHA_EXT','GL_SOURCE0_RGB_EXT','GL_SOURCE1_ALPHA_EXT','GL_SOURCE1_RGB_EXT','GL_SOURCE2_ALPHA_EXT','GL_SOURCE2_RGB_EXT']
gl.add(GL_EXT_texture_env_combine)

GL_EXT_texture_env_dot3 = Extension('GL_EXT_texture_env_dot3')
GL_EXT_texture_env_dot3.url = 'http://www.opengl.org/registry/specs/EXT/texture_env_dot3.txt'
GL_EXT_texture_env_dot3.enumerants = ['GL_DOT3_RGBA_EXT','GL_DOT3_RGB_EXT']
gl.add(GL_EXT_texture_env_dot3)

GL_EXT_texture_filter_anisotropic = Extension('GL_EXT_texture_filter_anisotropic')
GL_EXT_texture_filter_anisotropic.url = 'http://www.opengl.org/registry/specs/EXT/texture_filter_anisotropic.txt'
GL_EXT_texture_filter_anisotropic.enumerants = ['GL_MAX_TEXTURE_MAX_ANISOTROPY_EXT','GL_TEXTURE_MAX_ANISOTROPY_EXT']
gl.add(GL_EXT_texture_filter_anisotropic)

GL_EXT_texture_format_BGRA8888 = Extension('GL_EXT_texture_format_BGRA8888')
GL_EXT_texture_format_BGRA8888.category = 'GL_EXT_texture_format_BGRA8888'
gl.add(GL_EXT_texture_format_BGRA8888)

GL_EXT_texture_integer = Extension('GL_EXT_texture_integer')
GL_EXT_texture_integer.url = 'http://developer.download.nvidia.com/opengl/specs/GL_EXT_texture_integer.txt'
GL_EXT_texture_integer.enumerants = ['GL_ALPHA16I_EXT','GL_ALPHA16UI_EXT','GL_ALPHA32I_EXT','GL_ALPHA32UI_EXT','GL_ALPHA8I_EXT','GL_ALPHA8UI_EXT','GL_ALPHA_INTEGER_EXT','GL_BGRA_INTEGER_EXT','GL_BGR_INTEGER_EXT','GL_BLUE_INTEGER_EXT','GL_GREEN_INTEGER_EXT','GL_INTENSITY16I_EXT','GL_INTENSITY16UI_EXT','GL_INTENSITY32I_EXT','GL_INTENSITY32UI_EXT','GL_INTENSITY8I_EXT','GL_INTENSITY8UI_EXT','GL_LUMINANCE16I_EXT','GL_LUMINANCE16UI_EXT','GL_LUMINANCE32I_EXT','GL_LUMINANCE32UI_EXT','GL_LUMINANCE8I_EXT','GL_LUMINANCE8UI_EXT','GL_LUMINANCE_ALPHA16I_EXT','GL_LUMINANCE_ALPHA16UI_EXT','GL_LUMINANCE_ALPHA32I_EXT','GL_LUMINANCE_ALPHA32UI_EXT','GL_LUMINANCE_ALPHA8I_EXT','GL_LUMINANCE_ALPHA8UI_EXT','GL_LUMINANCE_ALPHA_INTEGER_EXT','GL_LUMINANCE_INTEGER_EXT','GL_RED_INTEGER_EXT','GL_RGB16I_EXT','GL_RGB16UI_EXT','GL_RGB32I_EXT','GL_RGB32UI_EXT','GL_RGB8I_EXT','GL_RGB8UI_EXT','GL_RGBA16I_EXT','GL_RGBA16UI_EXT','GL_RGBA32I_EXT','GL_RGBA32UI_EXT','GL_RGBA8I_EXT','GL_RGBA8UI_EXT','GL_RGBA_INTEGER_EXT','GL_RGBA_INTEGER_MODE_EXT','GL_RGB_INTEGER_EXT']
GL_EXT_texture_integer.functions = ['glClearColorIiEXT','glClearColorIuiEXT','glGetTexParameterIivEXT','glGetTexParameterIuivEXT','glTexParameterIivEXT','glTexParameterIuivEXT']
gl.add(GL_EXT_texture_integer)

GL_EXT_texture_lod_bias = Extension('GL_EXT_texture_lod_bias')
GL_EXT_texture_lod_bias.url = 'http://www.opengl.org/registry/specs/EXT/texture_lod_bias.txt'
GL_EXT_texture_lod_bias.enumerants = ['GL_MAX_TEXTURE_LOD_BIAS_EXT','GL_TEXTURE_FILTER_CONTROL_EXT','GL_TEXTURE_LOD_BIAS_EXT']
gl.add(GL_EXT_texture_lod_bias)

GL_EXT_texture_mirror_clamp = Extension('GL_EXT_texture_mirror_clamp')
GL_EXT_texture_mirror_clamp.url = 'http://www.opengl.org/registry/specs/EXT/texture_mirror_clamp.txt'
GL_EXT_texture_mirror_clamp.enumerants = ['GL_MIRROR_CLAMP_EXT','GL_MIRROR_CLAMP_TO_BORDER_EXT','GL_MIRROR_CLAMP_TO_EDGE_EXT']
gl.add(GL_EXT_texture_mirror_clamp)

GL_EXT_texture_object = Extension('GL_EXT_texture_object')
GL_EXT_texture_object.url = 'http://www.opengl.org/registry/specs/EXT/texture_object.txt'
GL_EXT_texture_object.enumerants = ['GL_TEXTURE_1D_BINDING_EXT','GL_TEXTURE_2D_BINDING_EXT','GL_TEXTURE_3D_BINDING_EXT','GL_TEXTURE_PRIORITY_EXT','GL_TEXTURE_RESIDENT_EXT']
GL_EXT_texture_object.functions = ['glAreTexturesResidentEXT','glIsTextureEXT','glBindTextureEXT','glDeleteTexturesEXT','glGenTexturesEXT','glPrioritizeTexturesEXT']
gl.add(GL_EXT_texture_object)

GL_EXT_texture_perturb_normal = Extension('GL_EXT_texture_perturb_normal')
GL_EXT_texture_perturb_normal.url = 'http://www.opengl.org/registry/specs/EXT/texture_perturb_normal.txt'
GL_EXT_texture_perturb_normal.enumerants = ['GL_PERTURB_EXT','GL_TEXTURE_NORMAL_EXT']
GL_EXT_texture_perturb_normal.functions = ['glTextureNormalEXT']
gl.add(GL_EXT_texture_perturb_normal)

GL_EXT_texture_rectangle = Extension('GL_EXT_texture_rectangle')
GL_EXT_texture_rectangle.url = 'http://developer.apple.com/opengl/extensions/ext_texture_rectangle.html'
GL_EXT_texture_rectangle.enumerants = ['GL_MAX_RECTANGLE_TEXTURE_SIZE_EXT','GL_PROXY_TEXTURE_RECTANGLE_EXT','GL_TEXTURE_BINDING_RECTANGLE_EXT','GL_TEXTURE_RECTANGLE_EXT']
gl.add(GL_EXT_texture_rectangle)

GL_EXT_texture_sRGB = Extension('GL_EXT_texture_sRGB')
GL_EXT_texture_sRGB.url = 'http://www.opengl.org/registry/specs/EXT/texture_sRGB.txt'
GL_EXT_texture_sRGB.enumerants = ['GL_COMPRESSED_SLUMINANCE_ALPHA_EXT','GL_COMPRESSED_SLUMINANCE_EXT','GL_COMPRESSED_SRGB_ALPHA_EXT','GL_COMPRESSED_SRGB_ALPHA_S3TC_DXT1_EXT','GL_COMPRESSED_SRGB_ALPHA_S3TC_DXT3_EXT','GL_COMPRESSED_SRGB_ALPHA_S3TC_DXT5_EXT','GL_COMPRESSED_SRGB_EXT','GL_COMPRESSED_SRGB_S3TC_DXT1_EXT','GL_SLUMINANCE8_ALPHA8_EXT','GL_SLUMINANCE8_EXT','GL_SLUMINANCE_ALPHA_EXT','GL_SLUMINANCE_EXT','GL_SRGB8_ALPHA8_EXT','GL_SRGB8_EXT','GL_SRGB_ALPHA_EXT','GL_SRGB_EXT']
gl.add(GL_EXT_texture_sRGB)

GL_EXT_texture_sRGB_decode = Extension('GL_EXT_texture_sRGB_decode')
GL_EXT_texture_sRGB_decode.url = 'http://www.opengl.org/registry/specs/EXT/texture_sRGB_decode.txt'
GL_EXT_texture_sRGB_decode.enumerants = ['GL_DECODE_EXT','GL_SKIP_DECODE_EXT','GL_TEXTURE_SRGB_DECODE_EXT']
gl.add(GL_EXT_texture_sRGB_decode)

GL_EXT_texture_shared_exponent = Extension('GL_EXT_texture_shared_exponent')
GL_EXT_texture_shared_exponent.url = 'http://developer.download.nvidia.com/opengl/specs/GL_EXT_texture_shared_exponent.txt'
GL_EXT_texture_shared_exponent.enumerants = ['GL_RGB9_E5_EXT','GL_TEXTURE_SHARED_SIZE_EXT','GL_UNSIGNED_INT_5_9_9_9_REV_EXT']
gl.add(GL_EXT_texture_shared_exponent)

GL_EXT_texture_snorm = Extension('GL_EXT_texture_snorm')
GL_EXT_texture_snorm.url = 'http://www.opengl.org/registry/specs/EXT/texture_snorm.txt'
GL_EXT_texture_snorm.enumerants = ['GL_ALPHA16_SNORM','GL_ALPHA8_SNORM','GL_ALPHA_SNORM','GL_INTENSITY16_SNORM','GL_INTENSITY8_SNORM','GL_INTENSITY_SNORM','GL_LUMINANCE16_ALPHA16_SNORM','GL_LUMINANCE16_SNORM','GL_LUMINANCE8_ALPHA8_SNORM','GL_LUMINANCE8_SNORM','GL_LUMINANCE_ALPHA_SNORM','GL_LUMINANCE_SNORM','GL_R16_SNORM','GL_R8_SNORM','GL_RED_SNORM','GL_RG16_SNORM','GL_RG8_SNORM','GL_RGB16_SNORM','GL_RGB8_SNORM','GL_RGBA16_SNORM','GL_RGBA8_SNORM','GL_RGBA_SNORM','GL_RGB_SNORM','GL_RG_SNORM','GL_SIGNED_NORMALIZED']
gl.add(GL_EXT_texture_snorm)

GL_EXT_texture_swizzle = Extension('GL_EXT_texture_swizzle')
GL_EXT_texture_swizzle.url = 'http://www.opengl.org/registry/specs/EXT/texture_swizzle.txt'
GL_EXT_texture_swizzle.enumerants = ['GL_TEXTURE_SWIZZLE_A_EXT','GL_TEXTURE_SWIZZLE_B_EXT','GL_TEXTURE_SWIZZLE_G_EXT','GL_TEXTURE_SWIZZLE_RGBA_EXT','GL_TEXTURE_SWIZZLE_R_EXT']
gl.add(GL_EXT_texture_swizzle)

GL_EXT_timer_query = Extension('GL_EXT_timer_query')
GL_EXT_timer_query.url = 'http://www.nvidia.com/dev_content/nvopenglspecs/GL_EXT_timer_query.txt'
GL_EXT_timer_query.enumerants = ['GL_TIME_ELAPSED_EXT']
GL_EXT_timer_query.functions = ['glGetQueryObjecti64vEXT','glGetQueryObjectui64vEXT']
gl.add(GL_EXT_timer_query)

GL_EXT_transform_feedback = Extension('GL_EXT_transform_feedback')
GL_EXT_transform_feedback.url = 'http://www.opengl.org/registry/specs/EXT/transform_feedback.txt'
GL_EXT_transform_feedback.enumerants = ['GL_INTERLEAVED_ATTRIBS_EXT','GL_MAX_TRANSFORM_FEEDBACK_INTERLEAVED_COMPONENTS_EXT','GL_MAX_TRANSFORM_FEEDBACK_SEPARATE_ATTRIBS_EXT','GL_MAX_TRANSFORM_FEEDBACK_SEPARATE_COMPONENTS_EXT','GL_PRIMITIVES_GENERATED_EXT','GL_RASTERIZER_DISCARD_EXT','GL_SEPARATE_ATTRIBS_EXT','GL_TRANSFORM_FEEDBACK_BUFFER_BINDING_EXT','GL_TRANSFORM_FEEDBACK_BUFFER_EXT','GL_TRANSFORM_FEEDBACK_BUFFER_MODE_EXT','GL_TRANSFORM_FEEDBACK_BUFFER_SIZE_EXT','GL_TRANSFORM_FEEDBACK_BUFFER_START_EXT','GL_TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN_EXT','GL_TRANSFORM_FEEDBACK_VARYINGS_EXT','GL_TRANSFORM_FEEDBACK_VARYING_MAX_LENGTH_EXT']
GL_EXT_transform_feedback.functions = ['glBeginTransformFeedbackEXT','glBindBufferBaseEXT','glBindBufferOffsetEXT','glBindBufferRangeEXT','glEndTransformFeedbackEXT','glGetTransformFeedbackVaryingEXT','glTransformFeedbackVaryingsEXT']
gl.add(GL_EXT_transform_feedback)

GL_EXT_vertex_array = Extension('GL_EXT_vertex_array')
GL_EXT_vertex_array.url = 'http://www.opengl.org/registry/specs/EXT/vertex_array.txt'
GL_EXT_vertex_array.enumerants = ['GL_COLOR_ARRAY_COUNT_EXT','GL_COLOR_ARRAY_EXT','GL_COLOR_ARRAY_POINTER_EXT','GL_COLOR_ARRAY_SIZE_EXT','GL_COLOR_ARRAY_STRIDE_EXT','GL_COLOR_ARRAY_TYPE_EXT','GL_DOUBLE_EXT','GL_EDGE_FLAG_ARRAY_COUNT_EXT','GL_EDGE_FLAG_ARRAY_EXT','GL_EDGE_FLAG_ARRAY_POINTER_EXT','GL_EDGE_FLAG_ARRAY_STRIDE_EXT','GL_INDEX_ARRAY_COUNT_EXT','GL_INDEX_ARRAY_EXT','GL_INDEX_ARRAY_POINTER_EXT','GL_INDEX_ARRAY_STRIDE_EXT','GL_INDEX_ARRAY_TYPE_EXT','GL_NORMAL_ARRAY_COUNT_EXT','GL_NORMAL_ARRAY_EXT','GL_NORMAL_ARRAY_POINTER_EXT','GL_NORMAL_ARRAY_STRIDE_EXT','GL_NORMAL_ARRAY_TYPE_EXT','GL_TEXTURE_COORD_ARRAY_COUNT_EXT','GL_TEXTURE_COORD_ARRAY_EXT','GL_TEXTURE_COORD_ARRAY_POINTER_EXT','GL_TEXTURE_COORD_ARRAY_SIZE_EXT','GL_TEXTURE_COORD_ARRAY_STRIDE_EXT','GL_TEXTURE_COORD_ARRAY_TYPE_EXT','GL_VERTEX_ARRAY_COUNT_EXT','GL_VERTEX_ARRAY_EXT','GL_VERTEX_ARRAY_POINTER_EXT','GL_VERTEX_ARRAY_SIZE_EXT','GL_VERTEX_ARRAY_STRIDE_EXT','GL_VERTEX_ARRAY_TYPE_EXT']
GL_EXT_vertex_array.functions = ['glArrayElementEXT','glColorPointerEXT','glDrawArraysEXT','glEdgeFlagPointerEXT','glIndexPointerEXT','glNormalPointerEXT','glTexCoordPointerEXT','glVertexPointerEXT']
gl.add(GL_EXT_vertex_array)

GL_EXT_vertex_array_bgra = Extension('GL_EXT_vertex_array_bgra')
GL_EXT_vertex_array_bgra.url = 'http://www.opengl.org/registry/specs/EXT/vertex_array_bgra.txt'
GL_EXT_vertex_array_bgra.enumerants = ['GL_BGRA']
gl.add(GL_EXT_vertex_array_bgra)

GL_EXT_vertex_attrib_64bit = Extension('GL_EXT_vertex_attrib_64bit')
GL_EXT_vertex_attrib_64bit.url = 'http://www.opengl.org/registry/specs/EXT/vertex_attrib_64bit.txt'
GL_EXT_vertex_attrib_64bit.enumerants = ['GL_DOUBLE_MAT2_EXT','GL_DOUBLE_MAT2x3_EXT','GL_DOUBLE_MAT2x4_EXT','GL_DOUBLE_MAT3_EXT','GL_DOUBLE_MAT3x2_EXT','GL_DOUBLE_MAT3x4_EXT','GL_DOUBLE_MAT4_EXT','GL_DOUBLE_MAT4x2_EXT','GL_DOUBLE_MAT4x3_EXT','GL_DOUBLE_VEC2_EXT','GL_DOUBLE_VEC3_EXT','GL_DOUBLE_VEC4_EXT']
GL_EXT_vertex_attrib_64bit.functions = ['glGetVertexAttribLdvEXT','glVertexArrayVertexAttribLOffsetEXT','glVertexAttribL1dEXT','glVertexAttribL1dvEXT','glVertexAttribL2dEXT','glVertexAttribL2dvEXT','glVertexAttribL3dEXT','glVertexAttribL3dvEXT','glVertexAttribL4dEXT','glVertexAttribL4dvEXT','glVertexAttribLPointerEXT']
gl.add(GL_EXT_vertex_attrib_64bit)

GL_EXT_vertex_shader = Extension('GL_EXT_vertex_shader')
GL_EXT_vertex_shader.url = 'http://oss.sgi.com/projects/ogl-sample/registry/EXT/vertex_shader.txt'
GL_EXT_vertex_shader.enumerants = ['GL_CURRENT_VERTEX_EXT','GL_FULL_RANGE_EXT','GL_INVARIANT_DATATYPE_EXT','GL_INVARIANT_EXT','GL_INVARIANT_VALUE_EXT','GL_LOCAL_CONSTANT_DATATYPE_EXT','GL_LOCAL_CONSTANT_EXT','GL_LOCAL_CONSTANT_VALUE_EXT','GL_LOCAL_EXT','GL_MATRIX_EXT','GL_MAX_OPTIMIZED_VERTEX_SHADER_INSTRUCTIONS_EXT','GL_MAX_OPTIMIZED_VERTEX_SHADER_INVARIANTS_EXT','GL_MAX_OPTIMIZED_VERTEX_SHADER_LOCALS_EXT','GL_MAX_OPTIMIZED_VERTEX_SHADER_LOCAL_CONSTANTS_EXT','GL_MAX_OPTIMIZED_VERTEX_SHADER_VARIANTS_EXT','GL_MAX_VERTEX_SHADER_INSTRUCTIONS_EXT','GL_MAX_VERTEX_SHADER_INVARIANTS_EXT','GL_MAX_VERTEX_SHADER_LOCALS_EXT','GL_MAX_VERTEX_SHADER_LOCAL_CONSTANTS_EXT','GL_MAX_VERTEX_SHADER_VARIANTS_EXT','GL_MVP_MATRIX_EXT','GL_NEGATIVE_ONE_EXT','GL_NEGATIVE_W_EXT','GL_NEGATIVE_X_EXT','GL_NEGATIVE_Y_EXT','GL_NEGATIVE_Z_EXT','GL_NORMALIZED_RANGE_EXT','GL_ONE_EXT','GL_OP_ADD_EXT','GL_OP_CLAMP_EXT','GL_OP_CROSS_PRODUCT_EXT','GL_OP_DOT3_EXT','GL_OP_DOT4_EXT','GL_OP_EXP_BASE_2_EXT','GL_OP_FLOOR_EXT','GL_OP_FRAC_EXT','GL_OP_INDEX_EXT','GL_OP_LOG_BASE_2_EXT','GL_OP_MADD_EXT','GL_OP_MAX_EXT','GL_OP_MIN_EXT','GL_OP_MOV_EXT','GL_OP_MULTIPLY_MATRIX_EXT','GL_OP_MUL_EXT','GL_OP_NEGATE_EXT','GL_OP_POWER_EXT','GL_OP_RECIP_EXT','GL_OP_RECIP_SQRT_EXT','GL_OP_ROUND_EXT','GL_OP_SET_GE_EXT','GL_OP_SET_LT_EXT','GL_OP_SUB_EXT','GL_OUTPUT_COLOR0_EXT','GL_OUTPUT_COLOR1_EXT','GL_OUTPUT_FOG_EXT','GL_OUTPUT_TEXTURE_COORD0_EXT','GL_OUTPUT_TEXTURE_COORD10_EXT','GL_OUTPUT_TEXTURE_COORD11_EXT','GL_OUTPUT_TEXTURE_COORD12_EXT','GL_OUTPUT_TEXTURE_COORD13_EXT','GL_OUTPUT_TEXTURE_COORD14_EXT','GL_OUTPUT_TEXTURE_COORD15_EXT','GL_OUTPUT_TEXTURE_COORD16_EXT','GL_OUTPUT_TEXTURE_COORD17_EXT','GL_OUTPUT_TEXTURE_COORD18_EXT','GL_OUTPUT_TEXTURE_COORD19_EXT','GL_OUTPUT_TEXTURE_COORD1_EXT','GL_OUTPUT_TEXTURE_COORD20_EXT','GL_OUTPUT_TEXTURE_COORD21_EXT','GL_OUTPUT_TEXTURE_COORD22_EXT','GL_OUTPUT_TEXTURE_COORD23_EXT','GL_OUTPUT_TEXTURE_COORD24_EXT','GL_OUTPUT_TEXTURE_COORD25_EXT','GL_OUTPUT_TEXTURE_COORD26_EXT','GL_OUTPUT_TEXTURE_COORD27_EXT','GL_OUTPUT_TEXTURE_COORD28_EXT','GL_OUTPUT_TEXTURE_COORD29_EXT','GL_OUTPUT_TEXTURE_COORD2_EXT','GL_OUTPUT_TEXTURE_COORD30_EXT','GL_OUTPUT_TEXTURE_COORD31_EXT','GL_OUTPUT_TEXTURE_COORD3_EXT','GL_OUTPUT_TEXTURE_COORD4_EXT','GL_OUTPUT_TEXTURE_COORD5_EXT','GL_OUTPUT_TEXTURE_COORD6_EXT','GL_OUTPUT_TEXTURE_COORD7_EXT','GL_OUTPUT_TEXTURE_COORD8_EXT','GL_OUTPUT_TEXTURE_COORD9_EXT','GL_OUTPUT_VERTEX_EXT','GL_SCALAR_EXT','GL_VARIANT_ARRAY_EXT','GL_VARIANT_ARRAY_POINTER_EXT','GL_VARIANT_ARRAY_STRIDE_EXT','GL_VARIANT_ARRAY_TYPE_EXT','GL_VARIANT_DATATYPE_EXT','GL_VARIANT_EXT','GL_VARIANT_VALUE_EXT','GL_VECTOR_EXT','GL_VERTEX_SHADER_BINDING_EXT','GL_VERTEX_SHADER_EXT','GL_VERTEX_SHADER_INSTRUCTIONS_EXT','GL_VERTEX_SHADER_INVARIANTS_EXT','GL_VERTEX_SHADER_LOCALS_EXT','GL_VERTEX_SHADER_LOCAL_CONSTANTS_EXT','GL_VERTEX_SHADER_OPTIMIZED_EXT','GL_VERTEX_SHADER_VARIANTS_EXT','GL_W_EXT','GL_X_EXT','GL_Y_EXT','GL_ZERO_EXT','GL_Z_EXT']
GL_EXT_vertex_shader.functions = ['glIsVariantEnabledEXT','glBindLightParameterEXT','glBindMaterialParameterEXT','glBindParameterEXT','glBindTexGenParameterEXT','glBindTextureUnitParameterEXT','glGenSymbolsEXT','glGenVertexShadersEXT','glBeginVertexShaderEXT','glBindVertexShaderEXT','glDeleteVertexShaderEXT','glDisableVariantClientStateEXT','glEnableVariantClientStateEXT','glEndVertexShaderEXT','glExtractComponentEXT','glGetInvariantBooleanvEXT','glGetInvariantFloatvEXT','glGetInvariantIntegervEXT','glGetLocalConstantBooleanvEXT','glGetLocalConstantFloatvEXT','glGetLocalConstantIntegervEXT','glGetVariantBooleanvEXT','glGetVariantFloatvEXT','glGetVariantIntegervEXT','glGetVariantPointervEXT','glInsertComponentEXT','glSetInvariantEXT','glSetLocalConstantEXT','glShaderOp1EXT','glShaderOp2EXT','glShaderOp3EXT','glSwizzleEXT','glVariantPointerEXT','glVariantbvEXT','glVariantdvEXT','glVariantfvEXT','glVariantivEXT','glVariantsvEXT','glVariantubvEXT','glVariantuivEXT','glVariantusvEXT','glWriteMaskEXT']
gl.add(GL_EXT_vertex_shader)

GL_EXT_vertex_weighting = Extension('GL_EXT_vertex_weighting')
GL_EXT_vertex_weighting.url = 'http://www.opengl.org/registry/specs/EXT/vertex_weighting.txt'
GL_EXT_vertex_weighting.enumerants = ['GL_CURRENT_VERTEX_WEIGHT_EXT','GL_MODELVIEW0_EXT','GL_MODELVIEW0_MATRIX_EXT','GL_MODELVIEW0_STACK_DEPTH_EXT','GL_MODELVIEW1_EXT','GL_MODELVIEW1_MATRIX_EXT','GL_MODELVIEW1_STACK_DEPTH_EXT','GL_VERTEX_WEIGHTING_EXT','GL_VERTEX_WEIGHT_ARRAY_EXT','GL_VERTEX_WEIGHT_ARRAY_POINTER_EXT','GL_VERTEX_WEIGHT_ARRAY_SIZE_EXT','GL_VERTEX_WEIGHT_ARRAY_STRIDE_EXT','GL_VERTEX_WEIGHT_ARRAY_TYPE_EXT']
GL_EXT_vertex_weighting.functions = ['glVertexWeightPointerEXT','glVertexWeightfEXT','glVertexWeightfvEXT']
gl.add(GL_EXT_vertex_weighting)

GL_EXT_x11_sync_object = Extension('GL_EXT_x11_sync_object')
GL_EXT_x11_sync_object.url = 'http://www.opengl.org/registry/specs/EXT/x11_sync_object.txt'
GL_EXT_x11_sync_object.enumerants = ['GL_SYNC_X11_FENCE_EXT']
GL_EXT_x11_sync_object.functions = ['glImportSyncEXT']
gl.add(GL_EXT_x11_sync_object)

GL_GREMEDY_frame_terminator = Extension('GL_GREMEDY_frame_terminator')
GL_GREMEDY_frame_terminator.url = 'http://www.opengl.org/registry/specs/GREMEDY/frame_terminator.txt'
GL_GREMEDY_frame_terminator.functions = ['glFrameTerminatorGREMEDY']
gl.add(GL_GREMEDY_frame_terminator)

GL_GREMEDY_string_marker = Extension('GL_GREMEDY_string_marker')
GL_GREMEDY_string_marker.url = 'http://www.opengl.org/registry/specs/GREMEDY/string_marker.txt'
GL_GREMEDY_string_marker.functions = ['glStringMarkerGREMEDY']
gl.add(GL_GREMEDY_string_marker)

GL_HP_convolution_border_modes = Extension('GL_HP_convolution_border_modes')
GL_HP_convolution_border_modes.url = 'http://www.opengl.org/registry/specs/HP/convolution_border_modes.txt'
gl.add(GL_HP_convolution_border_modes)

GL_HP_image_transform = Extension('GL_HP_image_transform')
GL_HP_image_transform.url = 'http://www.opengl.org/registry/specs/HP/image_transform.txt'
GL_HP_image_transform.functions = ['glGetImageTransformParameterfvHP','glGetImageTransformParameterivHP','glImageTransformParameterfHP','glImageTransformParameterfvHP','glImageTransformParameteriHP','glImageTransformParameterivHP']
gl.add(GL_HP_image_transform)

GL_HP_occlusion_test = Extension('GL_HP_occlusion_test')
GL_HP_occlusion_test.url = 'http://www.opengl.org/registry/specs/HP/occlusion_test.txt'
gl.add(GL_HP_occlusion_test)

GL_HP_texture_lighting = Extension('GL_HP_texture_lighting')
GL_HP_texture_lighting.url = 'http://www.opengl.org/registry/specs/HP/texture_lighting.txt'
gl.add(GL_HP_texture_lighting)

GL_IBM_cull_vertex = Extension('GL_IBM_cull_vertex')
GL_IBM_cull_vertex.url = 'http://www.opengl.org/registry/specs/IBM/cull_vertex.txt'
GL_IBM_cull_vertex.enumerants = ['GL_CULL_VERTEX_IBM']
gl.add(GL_IBM_cull_vertex)

GL_IBM_multimode_draw_arrays = Extension('GL_IBM_multimode_draw_arrays')
GL_IBM_multimode_draw_arrays.url = 'http://www.opengl.org/registry/specs/IBM/multimode_draw_arrays.txt'
GL_IBM_multimode_draw_arrays.functions = ['glMultiModeDrawArraysIBM','glMultiModeDrawElementsIBM']
gl.add(GL_IBM_multimode_draw_arrays)

GL_IBM_rasterpos_clip = Extension('GL_IBM_rasterpos_clip')
GL_IBM_rasterpos_clip.url = 'http://www.opengl.org/registry/specs/IBM/rasterpos_clip.txt'
GL_IBM_rasterpos_clip.enumerants = ['GL_RASTER_POSITION_UNCLIPPED_IBM']
gl.add(GL_IBM_rasterpos_clip)

GL_IBM_static_data = Extension('GL_IBM_static_data')
GL_IBM_static_data.url = 'http://www.opengl.org/registry/specs/IBM/static_data.txt'
GL_IBM_static_data.enumerants = ['GL_ALL_STATIC_DATA_IBM','GL_STATIC_VERTEX_ARRAY_IBM']
gl.add(GL_IBM_static_data)

GL_IBM_texture_mirrored_repeat = Extension('GL_IBM_texture_mirrored_repeat')
GL_IBM_texture_mirrored_repeat.url = 'http://www.opengl.org/registry/specs/IBM/texture_mirrored_repeat.txt'
GL_IBM_texture_mirrored_repeat.enumerants = ['GL_MIRRORED_REPEAT_IBM']
gl.add(GL_IBM_texture_mirrored_repeat)

GL_IBM_vertex_array_lists = Extension('GL_IBM_vertex_array_lists')
GL_IBM_vertex_array_lists.url = 'http://www.opengl.org/registry/specs/IBM/vertex_array_lists.txt'
GL_IBM_vertex_array_lists.enumerants = ['GL_COLOR_ARRAY_LIST_IBM','GL_COLOR_ARRAY_LIST_STRIDE_IBM','GL_EDGE_FLAG_ARRAY_LIST_IBM','GL_EDGE_FLAG_ARRAY_LIST_STRIDE_IBM','GL_FOG_COORDINATE_ARRAY_LIST_IBM','GL_FOG_COORDINATE_ARRAY_LIST_STRIDE_IBM','GL_INDEX_ARRAY_LIST_IBM','GL_INDEX_ARRAY_LIST_STRIDE_IBM','GL_NORMAL_ARRAY_LIST_IBM','GL_NORMAL_ARRAY_LIST_STRIDE_IBM','GL_SECONDARY_COLOR_ARRAY_LIST_IBM','GL_SECONDARY_COLOR_ARRAY_LIST_STRIDE_IBM','GL_TEXTURE_COORD_ARRAY_LIST_IBM','GL_TEXTURE_COORD_ARRAY_LIST_STRIDE_IBM','GL_VERTEX_ARRAY_LIST_IBM','GL_VERTEX_ARRAY_LIST_STRIDE_IBM']
GL_IBM_vertex_array_lists.functions = ['glColorPointerListIBM','glEdgeFlagPointerListIBM','glFogCoordPointerListIBM','glIndexPointerListIBM','glNormalPointerListIBM','glSecondaryColorPointerListIBM','glTexCoordPointerListIBM','glVertexPointerListIBM']
gl.add(GL_IBM_vertex_array_lists)

GL_INGR_color_clamp = Extension('GL_INGR_color_clamp')
GL_INGR_color_clamp.url = 'http://www.opengl.org/registry/specs/INGR/color_clamp.txt'
GL_INGR_color_clamp.enumerants = ['GL_ALPHA_MAX_CLAMP_INGR','GL_ALPHA_MIN_CLAMP_INGR','GL_BLUE_MAX_CLAMP_INGR','GL_BLUE_MIN_CLAMP_INGR','GL_GREEN_MAX_CLAMP_INGR','GL_GREEN_MIN_CLAMP_INGR','GL_RED_MAX_CLAMP_INGR','GL_RED_MIN_CLAMP_INGR']
gl.add(GL_INGR_color_clamp)

GL_INGR_interlace_read = Extension('GL_INGR_interlace_read')
GL_INGR_interlace_read.url = 'http://www.opengl.org/registry/specs/INGR/interlace_read.txt'
GL_INGR_interlace_read.enumerants = ['GL_INTERLACE_READ_INGR']
gl.add(GL_INGR_interlace_read)

GL_INTEL_map_texture = Extension('GL_INTEL_map_texture')
GL_INTEL_map_texture.url = 'http://www.opengl.org/registry/specs/INTEL/map_texture.txt'
GL_INTEL_map_texture.enumerants = ['GL_LAYOUT_DEFAULT_INTEL','GL_LAYOUT_LINEAR_CPU_CACHED_INTEL','GL_LAYOUT_LINEAR_INTEL','GL_TEXTURE_MEMORY_LAYOUT_INTEL']
GL_INTEL_map_texture.functions = ['*','glSyncTextureINTEL','glUnmapTexture2DINTEL']
gl.add(GL_INTEL_map_texture)

GL_INTEL_map_texture = Extension('GL_INTEL_map_texture')
GL_INTEL_map_texture.url = 'http://www.opengl.org/registry/specs/INTEL/map_texture.txt'
GL_INTEL_map_texture.enumerants = ['GL_LAYOUT_DEFAULT_INTEL','GL_LAYOUT_LINEAR_CPU_CACHED_INTEL','GL_LAYOUT_LINEAR_INTEL','GL_TEXTURE_MEMORY_LAYOUT_INTEL']
GL_INTEL_map_texture.functions = ['glMapTexture2DINTEL','glSyncTextureINTEL','glUnmapTexture2DINTEL']
gl.add(GL_INTEL_map_texture)

GL_INTEL_parallel_arrays = Extension('GL_INTEL_parallel_arrays')
GL_INTEL_parallel_arrays.url = 'http://www.opengl.org/registry/specs/INTEL/parallel_arrays.txt'
GL_INTEL_parallel_arrays.enumerants = ['GL_COLOR_ARRAY_PARALLEL_POINTERS_INTEL','GL_NORMAL_ARRAY_PARALLEL_POINTERS_INTEL','GL_PARALLEL_ARRAYS_INTEL','GL_TEXTURE_COORD_ARRAY_PARALLEL_POINTERS_INTEL','GL_VERTEX_ARRAY_PARALLEL_POINTERS_INTEL']
GL_INTEL_parallel_arrays.functions = ['glColorPointervINTEL','glNormalPointervINTEL','glTexCoordPointervINTEL','glVertexPointervINTEL']
gl.add(GL_INTEL_parallel_arrays)

GL_INTEL_texture_scissor = Extension('GL_INTEL_texture_scissor')
GL_INTEL_texture_scissor.url = 'http://www.opengl.org/registry/specs/INTEL/texture_scissor.txt'
GL_INTEL_texture_scissor.functions = ['glTexScissorFuncINTEL','glTexScissorINTEL']
gl.add(GL_INTEL_texture_scissor)

GL_KHR_debug = Extension('GL_KHR_debug')
GL_KHR_debug.url = 'http://www.opengl.org/registry/specs/KHR/debug.txt'
GL_KHR_debug.enumerants = ['GL_BUFFER','GL_CONTEXT_FLAG_DEBUG_BIT','GL_DEBUG_CALLBACK_FUNCTION','GL_DEBUG_CALLBACK_USER_PARAM','GL_DEBUG_GROUP_STACK_DEPTH','GL_DEBUG_LOGGED_MESSAGES','GL_DEBUG_NEXT_LOGGED_MESSAGE_LENGTH','GL_DEBUG_OUTPUT','GL_DEBUG_OUTPUT_SYNCHRONOUS','GL_DEBUG_SEVERITY_HIGH','GL_DEBUG_SEVERITY_LOW','GL_DEBUG_SEVERITY_MEDIUM','GL_DEBUG_SEVERITY_NOTIFICATION','GL_DEBUG_SOURCE_API','GL_DEBUG_SOURCE_APPLICATION','GL_DEBUG_SOURCE_OTHER','GL_DEBUG_SOURCE_SHADER_COMPILER','GL_DEBUG_SOURCE_THIRD_PARTY','GL_DEBUG_SOURCE_WINDOW_SYSTEM','GL_DEBUG_TYPE_DEPRECATED_BEHAVIOR','GL_DEBUG_TYPE_ERROR','GL_DEBUG_TYPE_MARKER','GL_DEBUG_TYPE_OTHER','GL_DEBUG_TYPE_PERFORMANCE','GL_DEBUG_TYPE_POP_GROUP','GL_DEBUG_TYPE_PORTABILITY','GL_DEBUG_TYPE_PUSH_GROUP','GL_DEBUG_TYPE_UNDEFINED_BEHAVIOR','GL_DISPLAY_LIST','GL_MAX_DEBUG_GROUP_STACK_DEPTH','GL_MAX_DEBUG_LOGGED_MESSAGES','GL_MAX_DEBUG_MESSAGE_LENGTH','GL_MAX_LABEL_LENGTH','GL_PROGRAM','GL_PROGRAM_PIPELINE','GL_QUERY','GL_SAMPLER','GL_SHADER']
GL_KHR_debug.functions = ['glGetDebugMessageLog','glDebugMessageCallback','glDebugMessageControl','glDebugMessageInsert','glGetObjectLabel','glGetObjectPtrLabel','glObjectLabel','glObjectPtrLabel','glPopDebugGroup','glPushDebugGroup']
gl.add(GL_KHR_debug)

GL_KHR_texture_compression_astc_ldr = Extension('GL_KHR_texture_compression_astc_ldr')
GL_KHR_texture_compression_astc_ldr.url = 'http://www.opengl.org/registry/specs/KHR/texture_compression_astc_ldr.txt'
GL_KHR_texture_compression_astc_ldr.enumerants = ['GL_COMPRESSED_RGBA_ASTC_10x10_KHR','GL_COMPRESSED_RGBA_ASTC_10x5_KHR','GL_COMPRESSED_RGBA_ASTC_10x6_KHR','GL_COMPRESSED_RGBA_ASTC_10x8_KHR','GL_COMPRESSED_RGBA_ASTC_12x10_KHR','GL_COMPRESSED_RGBA_ASTC_12x12_KHR','GL_COMPRESSED_RGBA_ASTC_4x4_KHR','GL_COMPRESSED_RGBA_ASTC_5x4_KHR','GL_COMPRESSED_RGBA_ASTC_5x5_KHR','GL_COMPRESSED_RGBA_ASTC_6x5_KHR','GL_COMPRESSED_RGBA_ASTC_6x6_KHR','GL_COMPRESSED_RGBA_ASTC_8x5_KHR','GL_COMPRESSED_RGBA_ASTC_8x6_KHR','GL_COMPRESSED_RGBA_ASTC_8x8_KHR','GL_COMPRESSED_SRGB8_ALPHA8_ASTC_10x10_KHR','GL_COMPRESSED_SRGB8_ALPHA8_ASTC_10x5_KHR','GL_COMPRESSED_SRGB8_ALPHA8_ASTC_10x6_KHR','GL_COMPRESSED_SRGB8_ALPHA8_ASTC_10x8_KHR','GL_COMPRESSED_SRGB8_ALPHA8_ASTC_12x10_KHR','GL_COMPRESSED_SRGB8_ALPHA8_ASTC_12x12_KHR','GL_COMPRESSED_SRGB8_ALPHA8_ASTC_4x4_KHR','GL_COMPRESSED_SRGB8_ALPHA8_ASTC_5x4_KHR','GL_COMPRESSED_SRGB8_ALPHA8_ASTC_5x5_KHR','GL_COMPRESSED_SRGB8_ALPHA8_ASTC_6x5_KHR','GL_COMPRESSED_SRGB8_ALPHA8_ASTC_6x6_KHR','GL_COMPRESSED_SRGB8_ALPHA8_ASTC_8x5_KHR','GL_COMPRESSED_SRGB8_ALPHA8_ASTC_8x6_KHR','GL_COMPRESSED_SRGB8_ALPHA8_ASTC_8x8_KHR']
gl.add(GL_KHR_texture_compression_astc_ldr)

GL_KTX_buffer_region = Extension('GL_KTX_buffer_region')
GL_KTX_buffer_region.enumerants = ['GL_KTX_BACK_REGION','GL_KTX_FRONT_REGION','GL_KTX_STENCIL_REGION','GL_KTX_Z_REGION']
GL_KTX_buffer_region.functions = ['glBufferRegionEnabled','glNewBufferRegion','glDeleteBufferRegion','glDrawBufferRegion','glReadBufferRegion']
gl.add(GL_KTX_buffer_region)

GL_MESAX_texture_stack = Extension('GL_MESAX_texture_stack')
GL_MESAX_texture_stack.url = 'http://www.opengl.org/registry/specs/MESAX/texture_stack.txt'
GL_MESAX_texture_stack.enumerants = ['GL_PROXY_TEXTURE_1D_STACK_MESAX','GL_PROXY_TEXTURE_2D_STACK_MESAX','GL_TEXTURE_1D_STACK_BINDING_MESAX','GL_TEXTURE_1D_STACK_MESAX','GL_TEXTURE_2D_STACK_BINDING_MESAX','GL_TEXTURE_2D_STACK_MESAX']
gl.add(GL_MESAX_texture_stack)

GL_MESA_pack_invert = Extension('GL_MESA_pack_invert')
GL_MESA_pack_invert.url = 'http://www.opengl.org/registry/specs/MESA/pack_invert.txt'
GL_MESA_pack_invert.enumerants = ['GL_PACK_INVERT_MESA']
gl.add(GL_MESA_pack_invert)

GL_MESA_resize_buffers = Extension('GL_MESA_resize_buffers')
GL_MESA_resize_buffers.url = 'http://www.opengl.org/registry/specs/MESA/resize_buffers.txt'
GL_MESA_resize_buffers.functions = ['glResizeBuffersMESA']
gl.add(GL_MESA_resize_buffers)

GL_MESA_window_pos = Extension('GL_MESA_window_pos')
GL_MESA_window_pos.url = 'http://www.opengl.org/registry/specs/MESA/window_pos.txt'
GL_MESA_window_pos.functions = ['glWindowPos2dMESA','glWindowPos2dvMESA','glWindowPos2fMESA','glWindowPos2fvMESA','glWindowPos2iMESA','glWindowPos2ivMESA','glWindowPos2sMESA','glWindowPos2svMESA','glWindowPos3dMESA','glWindowPos3dvMESA','glWindowPos3fMESA','glWindowPos3fvMESA','glWindowPos3iMESA','glWindowPos3ivMESA','glWindowPos3sMESA','glWindowPos3svMESA','glWindowPos4dMESA','glWindowPos4dvMESA','glWindowPos4fMESA','glWindowPos4fvMESA','glWindowPos4iMESA','glWindowPos4ivMESA','glWindowPos4sMESA','glWindowPos4svMESA']
gl.add(GL_MESA_window_pos)

GL_MESA_ycbcr_texture = Extension('GL_MESA_ycbcr_texture')
GL_MESA_ycbcr_texture.url = 'http://www.opengl.org/registry/specs/MESA/ycbcr_texture.txt'
GL_MESA_ycbcr_texture.enumerants = ['GL_UNSIGNED_SHORT_8_8_MESA','GL_UNSIGNED_SHORT_8_8_REV_MESA','GL_YCBCR_MESA']
gl.add(GL_MESA_ycbcr_texture)

GL_NVX_conditional_render = Extension('GL_NVX_conditional_render')
GL_NVX_conditional_render.url = 'http://www.opengl.org/registry/specs/NV/nvx_conditional_render.txt'
GL_NVX_conditional_render.functions = ['glBeginConditionalRenderNVX','glEndConditionalRenderNVX']
gl.add(GL_NVX_conditional_render)

GL_NVX_gpu_memory_info = Extension('GL_NVX_gpu_memory_info')
GL_NVX_gpu_memory_info.url = 'http://developer.download.nvidia.com/opengl/specs/GL_NVX_gpu_memory_info.txt'
GL_NVX_gpu_memory_info.enumerants = ['GL_GPU_MEMORY_INFO_CURRENT_AVAILABLE_VIDMEM_NVX','GL_GPU_MEMORY_INFO_DEDICATED_VIDMEM_NVX','GL_GPU_MEMORY_INFO_EVICTED_MEMORY_NVX','GL_GPU_MEMORY_INFO_EVICTION_COUNT_NVX','GL_GPU_MEMORY_INFO_TOTAL_AVAILABLE_MEMORY_NVX']
gl.add(GL_NVX_gpu_memory_info)

GL_NV_bindless_texture = Extension('GL_NV_bindless_texture')
GL_NV_bindless_texture.url = 'http://www.opengl.org/registry/specs/NV/bindless_texture.txt'
GL_NV_bindless_texture.functions = ['glIsImageHandleResidentNV','glIsTextureHandleResidentNV','glGetImageHandleNV','glGetTextureHandleNV','glGetTextureSamplerHandleNV','glMakeImageHandleNonResidentNV','glMakeImageHandleResidentNV','glMakeTextureHandleNonResidentNV','glMakeTextureHandleResidentNV','glProgramUniformHandleui64NV','glProgramUniformHandleui64vNV','glUniformHandleui64NV','glUniformHandleui64vNV']
gl.add(GL_NV_bindless_texture)

GL_NV_blend_equation_advanced = Extension('GL_NV_blend_equation_advanced')
GL_NV_blend_equation_advanced.url = 'http://www.opengl.org/registry/specs/gl/NV/blend_equation_advanced.txt'
GL_NV_blend_equation_advanced.enumerants = ['GL_BLEND_ADVANCED_COHERENT_NV','GL_BLEND_OVERLAP_NV','GL_BLEND_PREMULTIPLIED_SRC_NV','GL_COLORBURN_NV','GL_COLORDODGE_NV','GL_CONJOINT_NV','GL_CONTRAST_NV','GL_DARKEN_NV','GL_DIFFERENCE_NV','GL_DISJOINT_NV','GL_DST_ATOP_NV','GL_DST_IN_NV','GL_DST_NV','GL_DST_OUT_NV','GL_DST_OVER_NV','GL_EXCLUSION_NV','GL_HARDLIGHT_NV','GL_HARDMIX_NV','GL_HSL_COLOR_NV','GL_HSL_HUE_NV','GL_HSL_LUMINOSITY_NV','GL_HSL_SATURATION_NV','GL_INVERT_OVG_NV','GL_INVERT_RGB_NV','GL_LIGHTEN_NV','GL_LINEARBURN_NV','GL_LINEARDODGE_NV','GL_LINEARLIGHT_NV','GL_MINUS_CLAMPED_NV','GL_MINUS_NV','GL_MULTIPLY_NV','GL_OVERLAY_NV','GL_PINLIGHT_NV','GL_PLUS_CLAMPED_ALPHA_NV','GL_PLUS_CLAMPED_NV','GL_PLUS_DARKER_NV','GL_PLUS_NV','GL_SCREEN_NV','GL_SOFTLIGHT_NV','GL_SRC_ATOP_NV','GL_SRC_IN_NV','GL_SRC_NV','GL_SRC_OUT_NV','GL_SRC_OVER_NV','GL_UNCORRELATED_NV','GL_VIVIDLIGHT_NV']
GL_NV_blend_equation_advanced.functions = ['glBlendBarrierNV','glBlendParameteriNV']
gl.add(GL_NV_blend_equation_advanced)

GL_NV_blend_equation_advanced_coherent = Extension('GL_NV_blend_equation_advanced_coherent')
GL_NV_blend_equation_advanced_coherent.url = 'http://www.opengl.org/registry/specs/gl/NV/blend_equation_advanced.txt'
gl.add(GL_NV_blend_equation_advanced_coherent)

GL_NV_blend_square = Extension('GL_NV_blend_square')
GL_NV_blend_square.url = 'http://www.opengl.org/registry/specs/NV/blend_square.txt'
GL_NV_blend_square.category = 'GL_NV_blend_square'
gl.add(GL_NV_blend_square)

GL_NV_compute_program5 = Extension('GL_NV_compute_program5')
GL_NV_compute_program5.url = 'http://www.opengl.org/registry/specs/NV/compute_program5.txt'
GL_NV_compute_program5.enumerants = ['GL_COMPUTE_PROGRAM_NV','GL_COMPUTE_PROGRAM_PARAMETER_BUFFER_NV']
gl.add(GL_NV_compute_program5)

GL_NV_conditional_render = Extension('GL_NV_conditional_render')
GL_NV_conditional_render.url = 'http://www.opengl.org/registry/specs/NV/conditional_render.txt'
GL_NV_conditional_render.enumerants = ['GL_QUERY_BY_REGION_NO_WAIT_NV','GL_QUERY_BY_REGION_WAIT_NV','GL_QUERY_NO_WAIT_NV','GL_QUERY_WAIT_NV']
GL_NV_conditional_render.functions = ['glBeginConditionalRenderNV','glEndConditionalRenderNV']
gl.add(GL_NV_conditional_render)

GL_NV_copy_buffer = Extension('GL_NV_copy_buffer')
GL_NV_copy_buffer.url = 'http://www.khronos.org/registry/gles/extensions/NV/NV_copy_buffer.txt'
GL_NV_copy_buffer.enumerants = ['GL_COPY_READ_BUFFER_NV','GL_COPY_WRITE_BUFFER_NV']
GL_NV_copy_buffer.functions = ['glCopyBufferSubDataNV']
gl.add(GL_NV_copy_buffer)

GL_NV_copy_depth_to_color = Extension('GL_NV_copy_depth_to_color')
GL_NV_copy_depth_to_color.url = 'http://www.opengl.org/registry/specs/NV/copy_depth_to_color.txt'
GL_NV_copy_depth_to_color.enumerants = ['GL_DEPTH_STENCIL_TO_BGRA_NV','GL_DEPTH_STENCIL_TO_RGBA_NV']
gl.add(GL_NV_copy_depth_to_color)

GL_NV_copy_image = Extension('GL_NV_copy_image')
GL_NV_copy_image.url = 'http://www.opengl.org/registry/specs/NV/copy_image.txt'
GL_NV_copy_image.functions = ['glCopyImageSubDataNV']
gl.add(GL_NV_copy_image)

GL_NV_deep_texture3D = Extension('GL_NV_deep_texture3D')
GL_NV_deep_texture3D.url = 'http://www.opengl.org/registry/specs/NV/deep_texture3D.txt'
GL_NV_deep_texture3D.enumerants = ['GL_MAX_DEEP_3D_TEXTURE_DEPTH_NV','GL_MAX_DEEP_3D_TEXTURE_WIDTH_HEIGHT_NV']
gl.add(GL_NV_deep_texture3D)

GL_NV_depth_buffer_float = Extension('GL_NV_depth_buffer_float')
GL_NV_depth_buffer_float.url = 'http://developer.download.nvidia.com/opengl/specs/GL_NV_depth_buffer_float.txt'
GL_NV_depth_buffer_float.enumerants = ['GL_DEPTH32F_STENCIL8_NV','GL_DEPTH_BUFFER_FLOAT_MODE_NV','GL_DEPTH_COMPONENT32F_NV','GL_FLOAT_32_UNSIGNED_INT_24_8_REV_NV']
GL_NV_depth_buffer_float.functions = ['glClearDepthdNV','glDepthBoundsdNV','glDepthRangedNV']
gl.add(GL_NV_depth_buffer_float)

GL_NV_depth_clamp = Extension('GL_NV_depth_clamp')
GL_NV_depth_clamp.url = 'http://www.opengl.org/registry/specs/NV/depth_clamp.txt'
GL_NV_depth_clamp.enumerants = ['GL_DEPTH_CLAMP_NV']
gl.add(GL_NV_depth_clamp)

GL_NV_depth_range_unclamped = Extension('GL_NV_depth_range_unclamped')
GL_NV_depth_range_unclamped.enumerants = ['GL_CURRENT_SAMPLE_COUNT_QUERY_NV','GL_QUERY_RESULT_AVAILABLE_NV','GL_QUERY_RESULT_NV','GL_SAMPLE_COUNT_BITS_NV','GL_SAMPLE_COUNT_NV']
gl.add(GL_NV_depth_range_unclamped)

GL_NV_draw_texture = Extension('GL_NV_draw_texture')
GL_NV_draw_texture.url = 'http://www.opengl.org/registry/specs/NV/draw_texture.txt'
GL_NV_draw_texture.functions = ['glDrawTextureNV']
gl.add(GL_NV_draw_texture)

GL_NV_evaluators = Extension('GL_NV_evaluators')
GL_NV_evaluators.url = 'http://www.opengl.org/registry/specs/NV/evaluators.txt'
GL_NV_evaluators.enumerants = ['GL_EVAL_2D_NV','GL_EVAL_FRACTIONAL_TESSELLATION_NV','GL_EVAL_TRIANGULAR_2D_NV','GL_EVAL_VERTEX_ATTRIB0_NV','GL_EVAL_VERTEX_ATTRIB10_NV','GL_EVAL_VERTEX_ATTRIB11_NV','GL_EVAL_VERTEX_ATTRIB12_NV','GL_EVAL_VERTEX_ATTRIB13_NV','GL_EVAL_VERTEX_ATTRIB14_NV','GL_EVAL_VERTEX_ATTRIB15_NV','GL_EVAL_VERTEX_ATTRIB1_NV','GL_EVAL_VERTEX_ATTRIB2_NV','GL_EVAL_VERTEX_ATTRIB3_NV','GL_EVAL_VERTEX_ATTRIB4_NV','GL_EVAL_VERTEX_ATTRIB5_NV','GL_EVAL_VERTEX_ATTRIB6_NV','GL_EVAL_VERTEX_ATTRIB7_NV','GL_EVAL_VERTEX_ATTRIB8_NV','GL_EVAL_VERTEX_ATTRIB9_NV','GL_MAP_ATTRIB_U_ORDER_NV','GL_MAP_ATTRIB_V_ORDER_NV','GL_MAP_TESSELLATION_NV','GL_MAX_MAP_TESSELLATION_NV','GL_MAX_RATIONAL_EVAL_ORDER_NV']
GL_NV_evaluators.functions = ['glEvalMapsNV','glGetMapAttribParameterfvNV','glGetMapAttribParameterivNV','glGetMapControlPointsNV','glGetMapParameterfvNV','glGetMapParameterivNV','glMapControlPointsNV','glMapParameterfvNV','glMapParameterivNV']
gl.add(GL_NV_evaluators)

GL_NV_explicit_multisample = Extension('GL_NV_explicit_multisample')
GL_NV_explicit_multisample.url = 'http://www.opengl.org/registry/specs/NV/explicit_multisample.txt'
GL_NV_explicit_multisample.enumerants = ['GL_INT_SAMPLER_RENDERBUFFER_NV','GL_MAX_SAMPLE_MASK_WORDS_NV','GL_SAMPLER_RENDERBUFFER_NV','GL_SAMPLE_MASK_NV','GL_SAMPLE_MASK_VALUE_NV','GL_SAMPLE_POSITION_NV','GL_TEXTURE_BINDING_RENDERBUFFER_NV','GL_TEXTURE_RENDERBUFFER_DATA_STORE_BINDING_NV','GL_TEXTURE_RENDERBUFFER_NV','GL_UNSIGNED_INT_SAMPLER_RENDERBUFFER_NV']
GL_NV_explicit_multisample.functions = ['glGetMultisamplefvNV','glSampleMaskIndexedNV','glTexRenderbufferNV']
gl.add(GL_NV_explicit_multisample)

GL_NV_fence = Extension('GL_NV_fence')
GL_NV_fence.url = 'http://www.opengl.org/registry/specs/NV/fence.txt'
GL_NV_fence.enumerants = ['GL_ALL_COMPLETED_NV','GL_FENCE_CONDITION_NV','GL_FENCE_STATUS_NV']
GL_NV_fence.functions = ['glIsFenceNV','glTestFenceNV','glDeleteFencesNV','glFinishFenceNV','glGenFencesNV','glGetFenceivNV','glSetFenceNV']
gl.add(GL_NV_fence)

GL_NV_float_buffer = Extension('GL_NV_float_buffer')
GL_NV_float_buffer.url = 'http://www.opengl.org/registry/specs/NV/float_buffer.txt'
GL_NV_float_buffer.enumerants = ['GL_FLOAT_CLEAR_COLOR_VALUE_NV','GL_FLOAT_R16_NV','GL_FLOAT_R32_NV','GL_FLOAT_RG16_NV','GL_FLOAT_RG32_NV','GL_FLOAT_RGB16_NV','GL_FLOAT_RGB32_NV','GL_FLOAT_RGBA16_NV','GL_FLOAT_RGBA32_NV','GL_FLOAT_RGBA_MODE_NV','GL_FLOAT_RGBA_NV','GL_FLOAT_RGB_NV','GL_FLOAT_RG_NV','GL_FLOAT_R_NV','GL_TEXTURE_FLOAT_COMPONENTS_NV']
gl.add(GL_NV_float_buffer)

GL_NV_fog_distance = Extension('GL_NV_fog_distance')
GL_NV_fog_distance.url = 'http://www.opengl.org/registry/specs/NV/fog_distance.txt'
GL_NV_fog_distance.enumerants = ['GL_EYE_PLANE_ABSOLUTE_NV','GL_EYE_RADIAL_NV','GL_FOG_DISTANCE_MODE_NV']
gl.add(GL_NV_fog_distance)

GL_NV_fragment_program = Extension('GL_NV_fragment_program')
GL_NV_fragment_program.url = 'http://www.opengl.org/registry/specs/NV/fragment_program.txt'
GL_NV_fragment_program.enumerants = ['GL_FRAGMENT_PROGRAM_BINDING_NV','GL_FRAGMENT_PROGRAM_NV','GL_MAX_FRAGMENT_PROGRAM_LOCAL_PARAMETERS_NV','GL_MAX_TEXTURE_COORDS_NV','GL_MAX_TEXTURE_IMAGE_UNITS_NV','GL_PROGRAM_ERROR_STRING_NV']
GL_NV_fragment_program.functions = ['glGetProgramNamedParameterdvNV','glGetProgramNamedParameterfvNV','glProgramNamedParameter4dNV','glProgramNamedParameter4dvNV','glProgramNamedParameter4fNV','glProgramNamedParameter4fvNV']
gl.add(GL_NV_fragment_program)

GL_NV_fragment_program2 = Extension('GL_NV_fragment_program2')
GL_NV_fragment_program2.url = 'http://www.nvidia.com/dev_content/nvopenglspecs/GL_NV_fragment_program2.txt'
GL_NV_fragment_program2.enumerants = ['GL_MAX_PROGRAM_CALL_DEPTH_NV','GL_MAX_PROGRAM_EXEC_INSTRUCTIONS_NV','GL_MAX_PROGRAM_IF_DEPTH_NV','GL_MAX_PROGRAM_LOOP_COUNT_NV','GL_MAX_PROGRAM_LOOP_DEPTH_NV']
gl.add(GL_NV_fragment_program2)

GL_NV_fragment_program4 = Extension('GL_NV_fragment_program4')
GL_NV_fragment_program4.url = 'http://developer.download.nvidia.com/opengl/specs/GL_NV_fragment_program4.txt'
gl.add(GL_NV_fragment_program4)

GL_NV_fragment_program_option = Extension('GL_NV_fragment_program_option')
GL_NV_fragment_program_option.url = 'http://www.nvidia.com/dev_content/nvopenglspecs/GL_NV_fragment_program_option.txt'
gl.add(GL_NV_fragment_program_option)

GL_NV_framebuffer_multisample_coverage = Extension('GL_NV_framebuffer_multisample_coverage')
GL_NV_framebuffer_multisample_coverage.url = 'http://developer.download.nvidia.com/opengl/specs/GL_NV_framebuffer_multisample_coverage.txt'
GL_NV_framebuffer_multisample_coverage.enumerants = ['GL_MAX_MULTISAMPLE_COVERAGE_MODES_NV','GL_MULTISAMPLE_COVERAGE_MODES_NV','GL_RENDERBUFFER_COLOR_SAMPLES_NV','GL_RENDERBUFFER_COVERAGE_SAMPLES_NV']
GL_NV_framebuffer_multisample_coverage.functions = ['glRenderbufferStorageMultisampleCoverageNV']
gl.add(GL_NV_framebuffer_multisample_coverage)

GL_NV_geometry_program4 = Extension('GL_NV_geometry_program4')
GL_NV_geometry_program4.url = 'http://developer.download.nvidia.com/opengl/specs/GL_NV_geometry_program4.txt'
GL_NV_geometry_program4.enumerants = ['GL_GEOMETRY_PROGRAM_NV','GL_MAX_PROGRAM_OUTPUT_VERTICES_NV','GL_MAX_PROGRAM_TOTAL_OUTPUT_COMPONENTS_NV']
GL_NV_geometry_program4.functions = ['glProgramVertexLimitNV']
gl.add(GL_NV_geometry_program4)

GL_NV_geometry_shader4 = Extension('GL_NV_geometry_shader4')
GL_NV_geometry_shader4.url = 'http://developer.download.nvidia.com/opengl/specs/GL_NV_geometry_shader4.txt'
gl.add(GL_NV_geometry_shader4)

GL_NV_gpu_program4 = Extension('GL_NV_gpu_program4')
GL_NV_gpu_program4.url = 'http://developer.download.nvidia.com/opengl/specs/GL_NV_gpu_program4.txt'
GL_NV_gpu_program4.enumerants = ['GL_MAX_PROGRAM_ATTRIB_COMPONENTS_NV','GL_MAX_PROGRAM_GENERIC_ATTRIBS_NV','GL_MAX_PROGRAM_GENERIC_RESULTS_NV','GL_MAX_PROGRAM_RESULT_COMPONENTS_NV','GL_MAX_PROGRAM_TEXEL_OFFSET_NV','GL_MIN_PROGRAM_TEXEL_OFFSET_NV','GL_PROGRAM_ATTRIB_COMPONENTS_NV','GL_PROGRAM_RESULT_COMPONENTS_NV']
GL_NV_gpu_program4.functions = ['glProgramEnvParameterI4iNV','glProgramEnvParameterI4ivNV','glProgramEnvParameterI4uiNV','glProgramEnvParameterI4uivNV','glProgramEnvParametersI4ivNV','glProgramEnvParametersI4uivNV','glProgramLocalParameterI4iNV','glProgramLocalParameterI4ivNV','glProgramLocalParameterI4uiNV','glProgramLocalParameterI4uivNV','glProgramLocalParametersI4ivNV','glProgramLocalParametersI4uivNV']
gl.add(GL_NV_gpu_program4)

GL_NV_gpu_program5 = Extension('GL_NV_gpu_program5')
GL_NV_gpu_program5.url = 'http://www.opengl.org/registry/specs/NV/gpu_program5.txt'
GL_NV_gpu_program5.enumerants = ['GL_FRAGMENT_PROGRAM_INTERPOLATION_OFFSET_BITS_NV','GL_MAX_FRAGMENT_INTERPOLATION_OFFSET_NV','GL_MAX_GEOMETRY_PROGRAM_INVOCATIONS_NV','GL_MAX_PROGRAM_TEXTURE_GATHER_OFFSET_NV','GL_MIN_FRAGMENT_INTERPOLATION_OFFSET_NV','GL_MIN_PROGRAM_TEXTURE_GATHER_OFFSET_NV']
gl.add(GL_NV_gpu_program5)

GL_NV_gpu_program_fp64 = Extension('GL_NV_gpu_program_fp64')
GL_NV_gpu_program_fp64.url = 'http://www.opengl.org/registry/specs/NV/gpu_program5.txt'
gl.add(GL_NV_gpu_program_fp64)

GL_NV_gpu_shader5 = Extension('GL_NV_gpu_shader5')
GL_NV_gpu_shader5.url = 'http://www.opengl.org/registry/specs/NV/gpu_shader5.txt'
GL_NV_gpu_shader5.enumerants = ['GL_FLOAT16_NV','GL_FLOAT16_VEC2_NV','GL_FLOAT16_VEC3_NV','GL_FLOAT16_VEC4_NV','GL_INT16_NV','GL_INT16_VEC2_NV','GL_INT16_VEC3_NV','GL_INT16_VEC4_NV','GL_INT64_NV','GL_INT64_VEC2_NV','GL_INT64_VEC3_NV','GL_INT64_VEC4_NV','GL_INT8_NV','GL_INT8_VEC2_NV','GL_INT8_VEC3_NV','GL_INT8_VEC4_NV','GL_UNSIGNED_INT16_NV','GL_UNSIGNED_INT16_VEC2_NV','GL_UNSIGNED_INT16_VEC3_NV','GL_UNSIGNED_INT16_VEC4_NV','GL_UNSIGNED_INT64_NV','GL_UNSIGNED_INT64_VEC2_NV','GL_UNSIGNED_INT64_VEC3_NV','GL_UNSIGNED_INT64_VEC4_NV','GL_UNSIGNED_INT8_NV','GL_UNSIGNED_INT8_VEC2_NV','GL_UNSIGNED_INT8_VEC3_NV','GL_UNSIGNED_INT8_VEC4_NV']
GL_NV_gpu_shader5.functions = ['glGetUniformi64vNV','glGetUniformui64vNV','glProgramUniform1i64NV','glProgramUniform1i64vNV','glProgramUniform1ui64NV','glProgramUniform1ui64vNV','glProgramUniform2i64NV','glProgramUniform2i64vNV','glProgramUniform2ui64NV','glProgramUniform2ui64vNV','glProgramUniform3i64NV','glProgramUniform3i64vNV','glProgramUniform3ui64NV','glProgramUniform3ui64vNV','glProgramUniform4i64NV','glProgramUniform4i64vNV','glProgramUniform4ui64NV','glProgramUniform4ui64vNV','glUniform1i64NV','glUniform1i64vNV','glUniform1ui64NV','glUniform1ui64vNV','glUniform2i64NV','glUniform2i64vNV','glUniform2ui64NV','glUniform2ui64vNV','glUniform3i64NV','glUniform3i64vNV','glUniform3ui64NV','glUniform3ui64vNV','glUniform4i64NV','glUniform4i64vNV','glUniform4ui64NV','glUniform4ui64vNV']
gl.add(GL_NV_gpu_shader5)

GL_NV_half_float = Extension('GL_NV_half_float')
GL_NV_half_float.url = 'http://www.opengl.org/registry/specs/NV/half_float.txt'
GL_NV_half_float.enumerants = ['GL_HALF_FLOAT_NV']
GL_NV_half_float.functions = ['glColor3hNV','glColor3hvNV','glColor4hNV','glColor4hvNV','glFogCoordhNV','glFogCoordhvNV','glMultiTexCoord1hNV','glMultiTexCoord1hvNV','glMultiTexCoord2hNV','glMultiTexCoord2hvNV','glMultiTexCoord3hNV','glMultiTexCoord3hvNV','glMultiTexCoord4hNV','glMultiTexCoord4hvNV','glNormal3hNV','glNormal3hvNV','glSecondaryColor3hNV','glSecondaryColor3hvNV','glTexCoord1hNV','glTexCoord1hvNV','glTexCoord2hNV','glTexCoord2hvNV','glTexCoord3hNV','glTexCoord3hvNV','glTexCoord4hNV','glTexCoord4hvNV','glVertex2hNV','glVertex2hvNV','glVertex3hNV','glVertex3hvNV','glVertex4hNV','glVertex4hvNV','glVertexAttrib1hNV','glVertexAttrib1hvNV','glVertexAttrib2hNV','glVertexAttrib2hvNV','glVertexAttrib3hNV','glVertexAttrib3hvNV','glVertexAttrib4hNV','glVertexAttrib4hvNV','glVertexAttribs1hvNV','glVertexAttribs2hvNV','glVertexAttribs3hvNV','glVertexAttribs4hvNV','glVertexWeighthNV','glVertexWeighthvNV']
gl.add(GL_NV_half_float)

GL_NV_light_max_exponent = Extension('GL_NV_light_max_exponent')
GL_NV_light_max_exponent.url = 'http://www.opengl.org/registry/specs/NV/light_max_exponent.txt'
GL_NV_light_max_exponent.enumerants = ['GL_MAX_SHININESS_NV','GL_MAX_SPOT_EXPONENT_NV']
gl.add(GL_NV_light_max_exponent)

GL_NV_multisample_coverage = Extension('GL_NV_multisample_coverage')
GL_NV_multisample_coverage.url = 'http://www.opengl.org/registry/specs/NV/multisample_coverage.txt'
GL_NV_multisample_coverage.enumerants = ['GL_COLOR_SAMPLES_NV','GL_COVERAGE_SAMPLES_NV']
gl.add(GL_NV_multisample_coverage)

GL_NV_multisample_filter_hint = Extension('GL_NV_multisample_filter_hint')
GL_NV_multisample_filter_hint.url = 'http://www.opengl.org/registry/specs/NV/multisample_filter_hint.txt'
GL_NV_multisample_filter_hint.enumerants = ['GL_MULTISAMPLE_FILTER_HINT_NV']
gl.add(GL_NV_multisample_filter_hint)

GL_NV_non_square_matrices = Extension('GL_NV_non_square_matrices')
GL_NV_non_square_matrices.url = 'http://www.khronos.org/registry/gles/extensions/NV/NV_non_square_matrices.txt'
GL_NV_non_square_matrices.enumerants = ['GL_FLOAT_MAT2x3_NV','GL_FLOAT_MAT2x4_NV','GL_FLOAT_MAT3x2_NV','GL_FLOAT_MAT3x4_NV','GL_FLOAT_MAT4x2_NV','GL_FLOAT_MAT4x3_NV']
GL_NV_non_square_matrices.functions = ['glUniformMatrix2x3fvNV','glUniformMatrix2x4fvNV','glUniformMatrix3x2fvNV','glUniformMatrix3x4fvNV','glUniformMatrix4x2fvNV','glUniformMatrix4x3fvNV']
gl.add(GL_NV_non_square_matrices)

GL_NV_occlusion_query = Extension('GL_NV_occlusion_query')
GL_NV_occlusion_query.url = 'http://www.opengl.org/registry/specs/NV/occlusion_query.txt'
GL_NV_occlusion_query.enumerants = ['GL_CURRENT_OCCLUSION_QUERY_ID_NV','GL_PIXEL_COUNTER_BITS_NV','GL_PIXEL_COUNT_AVAILABLE_NV','GL_PIXEL_COUNT_NV']
GL_NV_occlusion_query.functions = ['glIsOcclusionQueryNV','glBeginOcclusionQueryNV','glDeleteOcclusionQueriesNV','glEndOcclusionQueryNV','glGenOcclusionQueriesNV','glGetOcclusionQueryivNV','glGetOcclusionQueryuivNV']
gl.add(GL_NV_occlusion_query)

GL_NV_packed_depth_stencil = Extension('GL_NV_packed_depth_stencil')
GL_NV_packed_depth_stencil.url = 'http://www.opengl.org/registry/specs/NV/packed_depth_stencil.txt'
GL_NV_packed_depth_stencil.enumerants = ['GL_DEPTH_STENCIL_NV','GL_UNSIGNED_INT_24_8_NV']
gl.add(GL_NV_packed_depth_stencil)

GL_NV_parameter_buffer_object = Extension('GL_NV_parameter_buffer_object')
GL_NV_parameter_buffer_object.url = 'http://developer.download.nvidia.com/opengl/specs/GL_NV_parameter_buffer_object.txt'
GL_NV_parameter_buffer_object.enumerants = ['GL_FRAGMENT_PROGRAM_PARAMETER_BUFFER_NV','GL_GEOMETRY_PROGRAM_PARAMETER_BUFFER_NV','GL_MAX_PROGRAM_PARAMETER_BUFFER_BINDINGS_NV','GL_MAX_PROGRAM_PARAMETER_BUFFER_SIZE_NV','GL_VERTEX_PROGRAM_PARAMETER_BUFFER_NV']
GL_NV_parameter_buffer_object.functions = ['glProgramBufferParametersIivNV','glProgramBufferParametersIuivNV','glProgramBufferParametersfvNV']
gl.add(GL_NV_parameter_buffer_object)

GL_NV_parameter_buffer_object2 = Extension('GL_NV_parameter_buffer_object2')
GL_NV_parameter_buffer_object2.url = 'http://www.opengl.org/registry/specs/NV/parameter_buffer_object2.txt'
gl.add(GL_NV_parameter_buffer_object2)

GL_NV_path_rendering = Extension('GL_NV_path_rendering')
GL_NV_path_rendering.url = 'http://www.opengl.org/registry/specs/NV/path_rendering.txt'
GL_NV_path_rendering.enumerants = ['GL_ACCUM_ADJACENT_PAIRS_NV','GL_ADJACENT_PAIRS_NV','GL_AFFINE_2D_NV','GL_AFFINE_3D_NV','GL_ARC_TO_NV','GL_BEVEL_NV','GL_BOLD_BIT_NV','GL_BOUNDING_BOX_NV','GL_BOUNDING_BOX_OF_BOUNDING_BOXES_NV','GL_CIRCULAR_CCW_ARC_TO_NV','GL_CIRCULAR_CW_ARC_TO_NV','GL_CIRCULAR_TANGENT_ARC_TO_NV','GL_CLOSE_PATH_NV','GL_CONVEX_HULL_NV','GL_COUNT_DOWN_NV','GL_COUNT_UP_NV','GL_CUBIC_CURVE_TO_NV','GL_DUP_FIRST_CUBIC_CURVE_TO_NV','GL_DUP_LAST_CUBIC_CURVE_TO_NV','GL_FILE_NAME_NV','GL_FIRST_TO_REST_NV','GL_FONT_ASCENDER_BIT_NV','GL_FONT_DESCENDER_BIT_NV','GL_FONT_HAS_KERNING_BIT_NV','GL_FONT_HEIGHT_BIT_NV','GL_FONT_MAX_ADVANCE_HEIGHT_BIT_NV','GL_FONT_MAX_ADVANCE_WIDTH_BIT_NV','GL_FONT_UNDERLINE_POSITION_BIT_NV','GL_FONT_UNDERLINE_THICKNESS_BIT_NV','GL_FONT_UNITS_PER_EM_BIT_NV','GL_FONT_X_MAX_BOUNDS_BIT_NV','GL_FONT_X_MIN_BOUNDS_BIT_NV','GL_FONT_Y_MAX_BOUNDS_BIT_NV','GL_FONT_Y_MIN_BOUNDS_BIT_NV','GL_GLYPH_HAS_KERNING_BIT_NV','GL_GLYPH_HEIGHT_BIT_NV','GL_GLYPH_HORIZONTAL_BEARING_ADVANCE_BIT_NV','GL_GLYPH_HORIZONTAL_BEARING_X_BIT_NV','GL_GLYPH_HORIZONTAL_BEARING_Y_BIT_NV','GL_GLYPH_VERTICAL_BEARING_ADVANCE_BIT_NV','GL_GLYPH_VERTICAL_BEARING_X_BIT_NV','GL_GLYPH_VERTICAL_BEARING_Y_BIT_NV','GL_GLYPH_WIDTH_BIT_NV','GL_HORIZONTAL_LINE_TO_NV','GL_ITALIC_BIT_NV','GL_LARGE_CCW_ARC_TO_NV','GL_LARGE_CW_ARC_TO_NV','GL_LINE_TO_NV','GL_MITER_REVERT_NV','GL_MITER_TRUNCATE_NV','GL_MOVE_TO_CONTINUES_NV','GL_MOVE_TO_NV','GL_MOVE_TO_RESETS_NV','GL_PATH_CLIENT_LENGTH_NV','GL_PATH_COMMAND_COUNT_NV','GL_PATH_COMPUTED_LENGTH_NV','GL_PATH_COORD_COUNT_NV','GL_PATH_COVER_DEPTH_FUNC_NV','GL_PATH_DASH_ARRAY_COUNT_NV','GL_PATH_DASH_CAPS_NV','GL_PATH_DASH_OFFSET_NV','GL_PATH_DASH_OFFSET_RESET_NV','GL_PATH_END_CAPS_NV','GL_PATH_ERROR_POSITION_NV','GL_PATH_FILL_BOUNDING_BOX_NV','GL_PATH_FILL_COVER_MODE_NV','GL_PATH_FILL_MASK_NV','GL_PATH_FILL_MODE_NV','GL_PATH_FOG_GEN_MODE_NV','GL_PATH_FORMAT_PS_NV','GL_PATH_FORMAT_SVG_NV','GL_PATH_GEN_COEFF_NV','GL_PATH_GEN_COLOR_FORMAT_NV','GL_PATH_GEN_COMPONENTS_NV','GL_PATH_GEN_MODE_NV','GL_PATH_INITIAL_DASH_CAP_NV','GL_PATH_INITIAL_END_CAP_NV','GL_PATH_JOIN_STYLE_NV','GL_PATH_MITER_LIMIT_NV','GL_PATH_OBJECT_BOUNDING_BOX_NV','GL_PATH_STENCIL_DEPTH_OFFSET_FACTOR_NV','GL_PATH_STENCIL_DEPTH_OFFSET_UNITS_NV','GL_PATH_STENCIL_FUNC_NV','GL_PATH_STENCIL_REF_NV','GL_PATH_STENCIL_VALUE_MASK_NV','GL_PATH_STROKE_BOUNDING_BOX_NV','GL_PATH_STROKE_COVER_MODE_NV','GL_PATH_STROKE_MASK_NV','GL_PATH_STROKE_WIDTH_NV','GL_PATH_TERMINAL_DASH_CAP_NV','GL_PATH_TERMINAL_END_CAP_NV','GL_PRIMARY_COLOR','GL_QUADRATIC_CURVE_TO_NV','GL_RECT_NV','GL_RELATIVE_ARC_TO_NV','GL_RELATIVE_CUBIC_CURVE_TO_NV','GL_RELATIVE_HORIZONTAL_LINE_TO_NV','GL_RELATIVE_LARGE_CCW_ARC_TO_NV','GL_RELATIVE_LARGE_CW_ARC_TO_NV','GL_RELATIVE_LINE_TO_NV','GL_RELATIVE_MOVE_TO_NV','GL_RELATIVE_QUADRATIC_CURVE_TO_NV','GL_RELATIVE_SMALL_CCW_ARC_TO_NV','GL_RELATIVE_SMALL_CW_ARC_TO_NV','GL_RELATIVE_SMOOTH_CUBIC_CURVE_TO_NV','GL_RELATIVE_SMOOTH_QUADRATIC_CURVE_TO_NV','GL_RELATIVE_VERTICAL_LINE_TO_NV','GL_RESTART_PATH_NV','GL_ROUND_NV','GL_SKIP_MISSING_GLYPH_NV','GL_SMALL_CCW_ARC_TO_NV','GL_SMALL_CW_ARC_TO_NV','GL_SMOOTH_CUBIC_CURVE_TO_NV','GL_SMOOTH_QUADRATIC_CURVE_TO_NV','GL_SQUARE_NV','GL_STANDARD_FONT_NAME_NV','GL_SYSTEM_FONT_NAME_NV','GL_TRANSLATE_2D_NV','GL_TRANSLATE_3D_NV','GL_TRANSLATE_X_NV','GL_TRANSLATE_Y_NV','GL_TRANSPOSE_AFFINE_2D_NV','GL_TRANSPOSE_AFFINE_3D_NV','GL_TRIANGULAR_NV','GL_USE_MISSING_GLYPH_NV','GL_UTF16_NV','GL_UTF8_NV','GL_VERTICAL_LINE_TO_NV']
GL_NV_path_rendering.functions = ['glIsPathNV','glIsPointInFillPathNV','glIsPointInStrokePathNV','glPointAlongPathNV','glGetPathLengthNV','glGenPathsNV','glCopyPathNV','glCoverFillPathInstancedNV','glCoverFillPathNV','glCoverStrokePathInstancedNV','glCoverStrokePathNV','glDeletePathsNV','glGetPathColorGenfvNV','glGetPathColorGenivNV','glGetPathCommandsNV','glGetPathCoordsNV','glGetPathDashArrayNV','glGetPathMetricRangeNV','glGetPathMetricsNV','glGetPathParameterfvNV','glGetPathParameterivNV','glGetPathSpacingNV','glGetPathTexGenfvNV','glGetPathTexGenivNV','glInterpolatePathsNV','glPathColorGenNV','glPathCommandsNV','glPathCoordsNV','glPathCoverDepthFuncNV','glPathDashArrayNV','glPathFogGenNV','glPathGlyphRangeNV','glPathGlyphsNV','glPathParameterfNV','glPathParameterfvNV','glPathParameteriNV','glPathParameterivNV','glPathStencilDepthOffsetNV','glPathStencilFuncNV','glPathStringNV','glPathSubCommandsNV','glPathSubCoordsNV','glPathTexGenNV','glStencilFillPathInstancedNV','glStencilFillPathNV','glStencilStrokePathInstancedNV','glStencilStrokePathNV','glTransformPathNV','glWeightPathsNV']
gl.add(GL_NV_path_rendering)

GL_NV_pixel_data_range = Extension('GL_NV_pixel_data_range')
GL_NV_pixel_data_range.url = 'http://www.opengl.org/registry/specs/NV/pixel_data_range.txt'
GL_NV_pixel_data_range.enumerants = ['GL_READ_PIXEL_DATA_RANGE_LENGTH_NV','GL_READ_PIXEL_DATA_RANGE_NV','GL_READ_PIXEL_DATA_RANGE_POINTER_NV','GL_WRITE_PIXEL_DATA_RANGE_LENGTH_NV','GL_WRITE_PIXEL_DATA_RANGE_NV','GL_WRITE_PIXEL_DATA_RANGE_POINTER_NV']
GL_NV_pixel_data_range.functions = ['glFlushPixelDataRangeNV','glPixelDataRangeNV']
gl.add(GL_NV_pixel_data_range)

GL_NV_point_sprite = Extension('GL_NV_point_sprite')
GL_NV_point_sprite.url = 'http://www.opengl.org/registry/specs/NV/point_sprite.txt'
GL_NV_point_sprite.enumerants = ['GL_COORD_REPLACE_NV','GL_POINT_SPRITE_NV','GL_POINT_SPRITE_R_MODE_NV']
GL_NV_point_sprite.functions = ['glPointParameteriNV','glPointParameterivNV']
gl.add(GL_NV_point_sprite)

GL_NV_present_video = Extension('GL_NV_present_video')
GL_NV_present_video.url = 'http://www.opengl.org/registry/specs/NV/present_video.txt'
GL_NV_present_video.enumerants = ['GL_CURRENT_TIME_NV','GL_FIELDS_NV','GL_FRAME_NV','GL_NUM_FILL_STREAMS_NV','GL_PRESENT_DURATION_NV','GL_PRESENT_TIME_NV']
GL_NV_present_video.functions = ['glGetVideoi64vNV','glGetVideoivNV','glGetVideoui64vNV','glGetVideouivNV','glPresentFrameDualFillNV','glPresentFrameKeyedNV']
gl.add(GL_NV_present_video)

GL_NV_primitive_restart = Extension('GL_NV_primitive_restart')
GL_NV_primitive_restart.url = 'http://www.opengl.org/registry/specs/NV/primitive_restart.txt'
GL_NV_primitive_restart.enumerants = ['GL_PRIMITIVE_RESTART_INDEX_NV','GL_PRIMITIVE_RESTART_NV']
GL_NV_primitive_restart.functions = ['glPrimitiveRestartIndexNV','glPrimitiveRestartNV']
gl.add(GL_NV_primitive_restart)

GL_NV_register_combiners = Extension('GL_NV_register_combiners')
GL_NV_register_combiners.url = 'http://www.opengl.org/registry/specs/NV/register_combiners.txt'
GL_NV_register_combiners.enumerants = ['GL_BIAS_BY_NEGATIVE_ONE_HALF_NV','GL_COLOR_SUM_CLAMP_NV','GL_COMBINER0_NV','GL_COMBINER1_NV','GL_COMBINER2_NV','GL_COMBINER3_NV','GL_COMBINER4_NV','GL_COMBINER5_NV','GL_COMBINER6_NV','GL_COMBINER7_NV','GL_COMBINER_AB_DOT_PRODUCT_NV','GL_COMBINER_AB_OUTPUT_NV','GL_COMBINER_BIAS_NV','GL_COMBINER_CD_DOT_PRODUCT_NV','GL_COMBINER_CD_OUTPUT_NV','GL_COMBINER_COMPONENT_USAGE_NV','GL_COMBINER_INPUT_NV','GL_COMBINER_MAPPING_NV','GL_COMBINER_MUX_SUM_NV','GL_COMBINER_SCALE_NV','GL_COMBINER_SUM_OUTPUT_NV','GL_CONSTANT_COLOR0_NV','GL_CONSTANT_COLOR1_NV','GL_DISCARD_NV','GL_EXPAND_NEGATE_NV','GL_EXPAND_NORMAL_NV','GL_E_TIMES_F_NV','GL_HALF_BIAS_NEGATE_NV','GL_HALF_BIAS_NORMAL_NV','GL_MAX_GENERAL_COMBINERS_NV','GL_NUM_GENERAL_COMBINERS_NV','GL_PRIMARY_COLOR_NV','GL_REGISTER_COMBINERS_NV','GL_SCALE_BY_FOUR_NV','GL_SCALE_BY_ONE_HALF_NV','GL_SCALE_BY_TWO_NV','GL_SECONDARY_COLOR_NV','GL_SIGNED_IDENTITY_NV','GL_SIGNED_NEGATE_NV','GL_SPARE0_NV','GL_SPARE0_PLUS_SECONDARY_COLOR_NV','GL_SPARE1_NV','GL_UNSIGNED_IDENTITY_NV','GL_UNSIGNED_INVERT_NV','GL_VARIABLE_A_NV','GL_VARIABLE_B_NV','GL_VARIABLE_C_NV','GL_VARIABLE_D_NV','GL_VARIABLE_E_NV','GL_VARIABLE_F_NV','GL_VARIABLE_G_NV']
GL_NV_register_combiners.functions = ['glCombinerInputNV','glCombinerOutputNV','glCombinerParameterfNV','glCombinerParameterfvNV','glCombinerParameteriNV','glCombinerParameterivNV','glFinalCombinerInputNV','glGetCombinerInputParameterfvNV','glGetCombinerInputParameterivNV','glGetCombinerOutputParameterfvNV','glGetCombinerOutputParameterivNV','glGetFinalCombinerInputParameterfvNV','glGetFinalCombinerInputParameterivNV']
gl.add(GL_NV_register_combiners)

GL_NV_register_combiners2 = Extension('GL_NV_register_combiners2')
GL_NV_register_combiners2.url = 'http://www.opengl.org/registry/specs/NV/register_combiners2.txt'
GL_NV_register_combiners2.enumerants = ['GL_PER_STAGE_CONSTANTS_NV']
GL_NV_register_combiners2.functions = ['glCombinerStageParameterfvNV','glGetCombinerStageParameterfvNV']
gl.add(GL_NV_register_combiners2)

GL_NV_shader_atomic_counters = Extension('GL_NV_shader_atomic_counters')
GL_NV_shader_atomic_counters.url = 'http://www.opengl.org/registry/specs/NV/shader_atomic_counters.txt'
gl.add(GL_NV_shader_atomic_counters)

GL_NV_shader_atomic_float = Extension('GL_NV_shader_atomic_float')
GL_NV_shader_atomic_float.url = 'http://www.opengl.org/registry/specs/NV/shader_atomic_float.txt'
gl.add(GL_NV_shader_atomic_float)

GL_NV_shader_buffer_load = Extension('GL_NV_shader_buffer_load')
GL_NV_shader_buffer_load.url = 'http://www.opengl.org/registry/specs/NV/shader_buffer_load.txt'
GL_NV_shader_buffer_load.enumerants = ['GL_BUFFER_GPU_ADDRESS_NV','GL_GPU_ADDRESS_NV','GL_MAX_SHADER_BUFFER_ADDRESS_NV']
GL_NV_shader_buffer_load.functions = ['glIsBufferResidentNV','glIsNamedBufferResidentNV','glGetBufferParameterui64vNV','glGetIntegerui64vNV','glGetNamedBufferParameterui64vNV','glMakeBufferNonResidentNV','glMakeBufferResidentNV','glMakeNamedBufferNonResidentNV','glMakeNamedBufferResidentNV','glProgramUniformui64NV','glProgramUniformui64vNV','glUniformui64NV','glUniformui64vNV']
gl.add(GL_NV_shader_buffer_load)

GL_NV_shader_storage_buffer_object = Extension('GL_NV_shader_storage_buffer_object')
GL_NV_shader_storage_buffer_object.url = 'http://www.opengl.org/registry/specs/NV/shader_storage_buffer_object.txt'
gl.add(GL_NV_shader_storage_buffer_object)

GL_NV_tessellation_program5 = Extension('GL_NV_tessellation_program5')
GL_NV_tessellation_program5.url = 'http://www.opengl.org/registry/specs/NV/tessellation_program5.txt'
GL_NV_tessellation_program5.enumerants = ['GL_MAX_PROGRAM_PATCH_ATTRIBS_NV','GL_TESS_CONTROL_PROGRAM_NV','GL_TESS_CONTROL_PROGRAM_PARAMETER_BUFFER_NV','GL_TESS_EVALUATION_PROGRAM_NV','GL_TESS_EVALUATION_PROGRAM_PARAMETER_BUFFER_NV']
gl.add(GL_NV_tessellation_program5)

GL_NV_texgen_emboss = Extension('GL_NV_texgen_emboss')
GL_NV_texgen_emboss.url = 'http://www.opengl.org/registry/specs/NV/texgen_emboss.txt'
GL_NV_texgen_emboss.enumerants = ['GL_EMBOSS_CONSTANT_NV','GL_EMBOSS_LIGHT_NV','GL_EMBOSS_MAP_NV']
gl.add(GL_NV_texgen_emboss)

GL_NV_texgen_reflection = Extension('GL_NV_texgen_reflection')
GL_NV_texgen_reflection.url = 'http://www.opengl.org/registry/specs/NV/texgen_reflection.txt'
GL_NV_texgen_reflection.enumerants = ['GL_NORMAL_MAP_NV','GL_REFLECTION_MAP_NV']
gl.add(GL_NV_texgen_reflection)

GL_NV_texture_barrier = Extension('GL_NV_texture_barrier')
GL_NV_texture_barrier.url = 'http://www.opengl.org/registry/specs/NV/texture_barrier.txt'
GL_NV_texture_barrier.functions = ['glTextureBarrierNV']
gl.add(GL_NV_texture_barrier)

GL_NV_texture_compression_vtc = Extension('GL_NV_texture_compression_vtc')
GL_NV_texture_compression_vtc.url = 'http://www.opengl.org/registry/specs/NV/texture_compression_vtc.txt'
gl.add(GL_NV_texture_compression_vtc)

GL_NV_texture_env_combine4 = Extension('GL_NV_texture_env_combine4')
GL_NV_texture_env_combine4.url = 'http://www.opengl.org/registry/specs/NV/texture_env_combine4.txt'
GL_NV_texture_env_combine4.enumerants = ['GL_COMBINE4_NV','GL_OPERAND3_ALPHA_NV','GL_OPERAND3_RGB_NV','GL_SOURCE3_ALPHA_NV','GL_SOURCE3_RGB_NV']
gl.add(GL_NV_texture_env_combine4)

GL_NV_texture_expand_normal = Extension('GL_NV_texture_expand_normal')
GL_NV_texture_expand_normal.url = 'http://www.opengl.org/registry/specs/NV/texture_expand_normal.txt'
GL_NV_texture_expand_normal.enumerants = ['GL_TEXTURE_UNSIGNED_REMAP_MODE_NV']
gl.add(GL_NV_texture_expand_normal)

GL_NV_texture_multisample = Extension('GL_NV_texture_multisample')
GL_NV_texture_multisample.url = 'http://www.opengl.org/registry/specs/NV/texture_multisample.txt'
GL_NV_texture_multisample.enumerants = ['GL_TEXTURE_COLOR_SAMPLES_NV','GL_TEXTURE_COVERAGE_SAMPLES_NV']
GL_NV_texture_multisample.functions = ['glTexImage2DMultisampleCoverageNV','glTexImage3DMultisampleCoverageNV','glTextureImage2DMultisampleCoverageNV','glTextureImage2DMultisampleNV','glTextureImage3DMultisampleCoverageNV','glTextureImage3DMultisampleNV']
gl.add(GL_NV_texture_multisample)

GL_NV_texture_rectangle = Extension('GL_NV_texture_rectangle')
GL_NV_texture_rectangle.url = 'http://www.opengl.org/registry/specs/NV/texture_rectangle.txt'
GL_NV_texture_rectangle.enumerants = ['GL_MAX_RECTANGLE_TEXTURE_SIZE_NV','GL_PROXY_TEXTURE_RECTANGLE_NV','GL_TEXTURE_BINDING_RECTANGLE_NV','GL_TEXTURE_RECTANGLE_NV']
gl.add(GL_NV_texture_rectangle)

GL_NV_texture_shader = Extension('GL_NV_texture_shader')
GL_NV_texture_shader.url = 'http://www.opengl.org/registry/specs/NV/texture_shader.txt'
GL_NV_texture_shader.enumerants = ['GL_CONST_EYE_NV','GL_CULL_FRAGMENT_NV','GL_CULL_MODES_NV','GL_DEPENDENT_AR_TEXTURE_2D_NV','GL_DEPENDENT_GB_TEXTURE_2D_NV','GL_DOT_PRODUCT_CONST_EYE_REFLECT_CUBE_MAP_NV','GL_DOT_PRODUCT_DEPTH_REPLACE_NV','GL_DOT_PRODUCT_DIFFUSE_CUBE_MAP_NV','GL_DOT_PRODUCT_NV','GL_DOT_PRODUCT_REFLECT_CUBE_MAP_NV','GL_DOT_PRODUCT_TEXTURE_2D_NV','GL_DOT_PRODUCT_TEXTURE_CUBE_MAP_NV','GL_DOT_PRODUCT_TEXTURE_RECTANGLE_NV','GL_DSDT8_MAG8_INTENSITY8_NV','GL_DSDT8_MAG8_NV','GL_DSDT8_NV','GL_DSDT_MAG_INTENSITY_NV','GL_DSDT_MAG_NV','GL_DSDT_MAG_VIB_NV','GL_DSDT_NV','GL_DS_BIAS_NV','GL_DS_SCALE_NV','GL_DT_BIAS_NV','GL_DT_SCALE_NV','GL_HILO16_NV','GL_HILO_NV','GL_HI_BIAS_NV','GL_HI_SCALE_NV','GL_LO_BIAS_NV','GL_LO_SCALE_NV','GL_MAGNITUDE_BIAS_NV','GL_MAGNITUDE_SCALE_NV','GL_OFFSET_TEXTURE_2D_BIAS_NV','GL_OFFSET_TEXTURE_2D_MATRIX_NV','GL_OFFSET_TEXTURE_2D_NV','GL_OFFSET_TEXTURE_2D_SCALE_NV','GL_OFFSET_TEXTURE_BIAS_NV','GL_OFFSET_TEXTURE_MATRIX_NV','GL_OFFSET_TEXTURE_RECTANGLE_NV','GL_OFFSET_TEXTURE_RECTANGLE_SCALE_NV','GL_OFFSET_TEXTURE_SCALE_NV','GL_PASS_THROUGH_NV','GL_PREVIOUS_TEXTURE_INPUT_NV','GL_RGBA_UNSIGNED_DOT_PRODUCT_MAPPING_NV','GL_SHADER_CONSISTENT_NV','GL_SHADER_OPERATION_NV','GL_SIGNED_ALPHA8_NV','GL_SIGNED_ALPHA_NV','GL_SIGNED_HILO16_NV','GL_SIGNED_HILO_NV','GL_SIGNED_INTENSITY8_NV','GL_SIGNED_INTENSITY_NV','GL_SIGNED_LUMINANCE8_ALPHA8_NV','GL_SIGNED_LUMINANCE8_NV','GL_SIGNED_LUMINANCE_ALPHA_NV','GL_SIGNED_LUMINANCE_NV','GL_SIGNED_RGB8_NV','GL_SIGNED_RGB8_UNSIGNED_ALPHA8_NV','GL_SIGNED_RGBA8_NV','GL_SIGNED_RGBA_NV','GL_SIGNED_RGB_NV','GL_SIGNED_RGB_UNSIGNED_ALPHA_NV','GL_TEXTURE_BORDER_VALUES_NV','GL_TEXTURE_DS_SIZE_NV','GL_TEXTURE_DT_SIZE_NV','GL_TEXTURE_HI_SIZE_NV','GL_TEXTURE_LO_SIZE_NV','GL_TEXTURE_MAG_SIZE_NV','GL_TEXTURE_SHADER_NV','GL_UNSIGNED_INT_8_8_S8_S8_REV_NV','GL_UNSIGNED_INT_S8_S8_8_8_NV','GL_VIBRANCE_BIAS_NV','GL_VIBRANCE_SCALE_NV']
gl.add(GL_NV_texture_shader)

GL_NV_texture_shader2 = Extension('GL_NV_texture_shader2')
GL_NV_texture_shader2.url = 'http://www.opengl.org/registry/specs/NV/texture_shader2.txt'
GL_NV_texture_shader2.enumerants = ['GL_DOT_PRODUCT_TEXTURE_3D_NV','GL_DSDT8_MAG8_INTENSITY8_NV','GL_DSDT8_MAG8_NV','GL_DSDT8_NV','GL_DSDT_MAG_INTENSITY_NV','GL_DSDT_MAG_NV','GL_DSDT_MAG_VIB_NV','GL_DSDT_NV','GL_HILO16_NV','GL_HILO_NV','GL_SIGNED_ALPHA8_NV','GL_SIGNED_ALPHA_NV','GL_SIGNED_HILO16_NV','GL_SIGNED_HILO_NV','GL_SIGNED_INTENSITY8_NV','GL_SIGNED_INTENSITY_NV','GL_SIGNED_LUMINANCE8_ALPHA8_NV','GL_SIGNED_LUMINANCE8_NV','GL_SIGNED_LUMINANCE_ALPHA_NV','GL_SIGNED_LUMINANCE_NV','GL_SIGNED_RGB8_NV','GL_SIGNED_RGB8_UNSIGNED_ALPHA8_NV','GL_SIGNED_RGBA8_NV','GL_SIGNED_RGBA_NV','GL_SIGNED_RGB_NV','GL_SIGNED_RGB_UNSIGNED_ALPHA_NV','GL_UNSIGNED_INT_8_8_S8_S8_REV_NV','GL_UNSIGNED_INT_S8_S8_8_8_NV']
gl.add(GL_NV_texture_shader2)

GL_NV_texture_shader3 = Extension('GL_NV_texture_shader3')
GL_NV_texture_shader3.url = 'http://www.opengl.org/registry/specs/NV/texture_shader3.txt'
GL_NV_texture_shader3.enumerants = ['GL_DEPENDENT_HILO_TEXTURE_2D_NV','GL_DEPENDENT_RGB_TEXTURE_3D_NV','GL_DEPENDENT_RGB_TEXTURE_CUBE_MAP_NV','GL_DOT_PRODUCT_AFFINE_DEPTH_REPLACE_NV','GL_DOT_PRODUCT_PASS_THROUGH_NV','GL_DOT_PRODUCT_TEXTURE_1D_NV','GL_FORCE_BLUE_TO_ONE_NV','GL_HILO8_NV','GL_OFFSET_HILO_PROJECTIVE_TEXTURE_2D_NV','GL_OFFSET_HILO_PROJECTIVE_TEXTURE_RECTANGLE_NV','GL_OFFSET_HILO_TEXTURE_2D_NV','GL_OFFSET_HILO_TEXTURE_RECTANGLE_NV','GL_OFFSET_PROJECTIVE_TEXTURE_2D_NV','GL_OFFSET_PROJECTIVE_TEXTURE_2D_SCALE_NV','GL_OFFSET_PROJECTIVE_TEXTURE_RECTANGLE_NV','GL_OFFSET_PROJECTIVE_TEXTURE_RECTANGLE_SCALE_NV','GL_SIGNED_HILO8_NV']
gl.add(GL_NV_texture_shader3)

GL_NV_transform_feedback = Extension('GL_NV_transform_feedback')
GL_NV_transform_feedback.url = 'http://developer.download.nvidia.com/opengl/specs/GL_NV_transform_feedback.txt'
GL_NV_transform_feedback.enumerants = ['GL_ACTIVE_VARYINGS_NV','GL_ACTIVE_VARYING_MAX_LENGTH_NV','GL_BACK_PRIMARY_COLOR_NV','GL_BACK_SECONDARY_COLOR_NV','GL_CLIP_DISTANCE_NV','GL_GENERIC_ATTRIB_NV','GL_INTERLEAVED_ATTRIBS_NV','GL_MAX_TRANSFORM_FEEDBACK_INTERLEAVED_COMPONENTS_NV','GL_MAX_TRANSFORM_FEEDBACK_SEPARATE_ATTRIBS_NV','GL_MAX_TRANSFORM_FEEDBACK_SEPARATE_COMPONENTS_NV','GL_PRIMITIVES_GENERATED_NV','GL_PRIMITIVE_ID_NV','GL_RASTERIZER_DISCARD_NV','GL_SEPARATE_ATTRIBS_NV','GL_TEXTURE_COORD_NV','GL_TRANSFORM_FEEDBACK_ATTRIBS_NV','GL_TRANSFORM_FEEDBACK_BUFFER_BINDING_NV','GL_TRANSFORM_FEEDBACK_BUFFER_MODE_NV','GL_TRANSFORM_FEEDBACK_BUFFER_NV','GL_TRANSFORM_FEEDBACK_BUFFER_SIZE_NV','GL_TRANSFORM_FEEDBACK_BUFFER_START_NV','GL_TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN_NV','GL_TRANSFORM_FEEDBACK_RECORD_NV','GL_TRANSFORM_FEEDBACK_VARYINGS_NV','GL_VERTEX_ID_NV']
GL_NV_transform_feedback.functions = ['glGetVaryingLocationNV','glActiveVaryingNV','glBeginTransformFeedbackNV','glBindBufferBaseNV','glBindBufferOffsetNV','glBindBufferRangeNV','glEndTransformFeedbackNV','glGetActiveVaryingNV','glGetTransformFeedbackVaryingNV','glTransformFeedbackAttribsNV','glTransformFeedbackVaryingsNV']
gl.add(GL_NV_transform_feedback)

GL_NV_transform_feedback2 = Extension('GL_NV_transform_feedback2')
GL_NV_transform_feedback2.url = 'http://www.opengl.org/registry/specs/NV/transform_feedback2.txt'
GL_NV_transform_feedback2.enumerants = ['GL_TRANSFORM_FEEDBACK_BINDING_NV','GL_TRANSFORM_FEEDBACK_BUFFER_ACTIVE_NV','GL_TRANSFORM_FEEDBACK_BUFFER_PAUSED_NV','GL_TRANSFORM_FEEDBACK_NV']
GL_NV_transform_feedback2.functions = ['glIsTransformFeedbackNV','glBindTransformFeedbackNV','glDeleteTransformFeedbacksNV','glDrawTransformFeedbackNV','glGenTransformFeedbacksNV','glPauseTransformFeedbackNV','glResumeTransformFeedbackNV']
gl.add(GL_NV_transform_feedback2)

GL_NV_vdpau_interop = Extension('GL_NV_vdpau_interop')
GL_NV_vdpau_interop.url = 'http://www.opengl.org/registry/specs/NV/vdpau_interop.txt'
GL_NV_vdpau_interop.enumerants = ['GL_SURFACE_MAPPED_NV','GL_SURFACE_REGISTERED_NV','GL_SURFACE_STATE_NV','GL_WRITE_DISCARD_NV']
GL_NV_vdpau_interop.functions = ['glVDPAURegisterOutputSurfaceNV','glVDPAURegisterVideoSurfaceNV','glVDPAUFiniNV','glVDPAUGetSurfaceivNV','glVDPAUInitNV','glVDPAUIsSurfaceNV','glVDPAUMapSurfacesNV','glVDPAUSurfaceAccessNV','glVDPAUUnmapSurfacesNV','glVDPAUUnregisterSurfaceNV']
gl.add(GL_NV_vdpau_interop)

GL_NV_vertex_array_range = Extension('GL_NV_vertex_array_range')
GL_NV_vertex_array_range.url = 'http://www.opengl.org/registry/specs/NV/vertex_array_range.txt'
GL_NV_vertex_array_range.enumerants = ['GL_MAX_VERTEX_ARRAY_RANGE_ELEMENT_NV','GL_VERTEX_ARRAY_RANGE_LENGTH_NV','GL_VERTEX_ARRAY_RANGE_NV','GL_VERTEX_ARRAY_RANGE_POINTER_NV','GL_VERTEX_ARRAY_RANGE_VALID_NV']
GL_NV_vertex_array_range.functions = ['glFlushVertexArrayRangeNV','glVertexArrayRangeNV']
gl.add(GL_NV_vertex_array_range)

GL_NV_vertex_array_range2 = Extension('GL_NV_vertex_array_range2')
GL_NV_vertex_array_range2.url = 'http://www.opengl.org/registry/specs/NV/vertex_array_range2.txt'
GL_NV_vertex_array_range2.enumerants = ['GL_VERTEX_ARRAY_RANGE_WITHOUT_FLUSH_NV']
gl.add(GL_NV_vertex_array_range2)

GL_NV_vertex_attrib_integer_64bit = Extension('GL_NV_vertex_attrib_integer_64bit')
GL_NV_vertex_attrib_integer_64bit.url = 'http://www.opengl.org/registry/specs/NV/vertex_attrib_integer_64bit.txt'
GL_NV_vertex_attrib_integer_64bit.enumerants = ['GL_INT64_NV','GL_UNSIGNED_INT64_NV']
GL_NV_vertex_attrib_integer_64bit.functions = ['glGetVertexAttribLi64vNV','glGetVertexAttribLui64vNV','glVertexAttribL1i64NV','glVertexAttribL1i64vNV','glVertexAttribL1ui64NV','glVertexAttribL1ui64vNV','glVertexAttribL2i64NV','glVertexAttribL2i64vNV','glVertexAttribL2ui64NV','glVertexAttribL2ui64vNV','glVertexAttribL3i64NV','glVertexAttribL3i64vNV','glVertexAttribL3ui64NV','glVertexAttribL3ui64vNV','glVertexAttribL4i64NV','glVertexAttribL4i64vNV','glVertexAttribL4ui64NV','glVertexAttribL4ui64vNV','glVertexAttribLFormatNV']
gl.add(GL_NV_vertex_attrib_integer_64bit)

GL_NV_vertex_buffer_unified_memory = Extension('GL_NV_vertex_buffer_unified_memory')
GL_NV_vertex_buffer_unified_memory.url = 'http://www.opengl.org/registry/specs/NV/vertex_buffer_unified_memory.txt'
GL_NV_vertex_buffer_unified_memory.enumerants = ['GL_COLOR_ARRAY_ADDRESS_NV','GL_COLOR_ARRAY_LENGTH_NV','GL_DRAW_INDIRECT_ADDRESS_NV','GL_DRAW_INDIRECT_LENGTH_NV','GL_DRAW_INDIRECT_UNIFIED_NV','GL_EDGE_FLAG_ARRAY_ADDRESS_NV','GL_EDGE_FLAG_ARRAY_LENGTH_NV','GL_ELEMENT_ARRAY_ADDRESS_NV','GL_ELEMENT_ARRAY_LENGTH_NV','GL_ELEMENT_ARRAY_UNIFIED_NV','GL_FOG_COORD_ARRAY_ADDRESS_NV','GL_FOG_COORD_ARRAY_LENGTH_NV','GL_INDEX_ARRAY_ADDRESS_NV','GL_INDEX_ARRAY_LENGTH_NV','GL_NORMAL_ARRAY_ADDRESS_NV','GL_NORMAL_ARRAY_LENGTH_NV','GL_SECONDARY_COLOR_ARRAY_ADDRESS_NV','GL_SECONDARY_COLOR_ARRAY_LENGTH_NV','GL_TEXTURE_COORD_ARRAY_ADDRESS_NV','GL_TEXTURE_COORD_ARRAY_LENGTH_NV','GL_VERTEX_ARRAY_ADDRESS_NV','GL_VERTEX_ARRAY_LENGTH_NV','GL_VERTEX_ATTRIB_ARRAY_ADDRESS_NV','GL_VERTEX_ATTRIB_ARRAY_LENGTH_NV','GL_VERTEX_ATTRIB_ARRAY_UNIFIED_NV']
GL_NV_vertex_buffer_unified_memory.functions = ['glBufferAddressRangeNV','glColorFormatNV','glEdgeFlagFormatNV','glFogCoordFormatNV','glGetIntegerui64i_vNV','glIndexFormatNV','glNormalFormatNV','glSecondaryColorFormatNV','glTexCoordFormatNV','glVertexAttribFormatNV','glVertexAttribIFormatNV','glVertexFormatNV']
gl.add(GL_NV_vertex_buffer_unified_memory)

GL_NV_vertex_program = Extension('GL_NV_vertex_program')
GL_NV_vertex_program.url = 'http://www.opengl.org/registry/specs/NV/vertex_program.txt'
GL_NV_vertex_program.enumerants = ['GL_ATTRIB_ARRAY_POINTER_NV','GL_ATTRIB_ARRAY_SIZE_NV','GL_ATTRIB_ARRAY_STRIDE_NV','GL_ATTRIB_ARRAY_TYPE_NV','GL_CURRENT_ATTRIB_NV','GL_CURRENT_MATRIX_NV','GL_CURRENT_MATRIX_STACK_DEPTH_NV','GL_IDENTITY_NV','GL_INVERSE_NV','GL_INVERSE_TRANSPOSE_NV','GL_MAP1_VERTEX_ATTRIB0_4_NV','GL_MAP1_VERTEX_ATTRIB10_4_NV','GL_MAP1_VERTEX_ATTRIB11_4_NV','GL_MAP1_VERTEX_ATTRIB12_4_NV','GL_MAP1_VERTEX_ATTRIB13_4_NV','GL_MAP1_VERTEX_ATTRIB14_4_NV','GL_MAP1_VERTEX_ATTRIB15_4_NV','GL_MAP1_VERTEX_ATTRIB1_4_NV','GL_MAP1_VERTEX_ATTRIB2_4_NV','GL_MAP1_VERTEX_ATTRIB3_4_NV','GL_MAP1_VERTEX_ATTRIB4_4_NV','GL_MAP1_VERTEX_ATTRIB5_4_NV','GL_MAP1_VERTEX_ATTRIB6_4_NV','GL_MAP1_VERTEX_ATTRIB7_4_NV','GL_MAP1_VERTEX_ATTRIB8_4_NV','GL_MAP1_VERTEX_ATTRIB9_4_NV','GL_MAP2_VERTEX_ATTRIB0_4_NV','GL_MAP2_VERTEX_ATTRIB10_4_NV','GL_MAP2_VERTEX_ATTRIB11_4_NV','GL_MAP2_VERTEX_ATTRIB12_4_NV','GL_MAP2_VERTEX_ATTRIB13_4_NV','GL_MAP2_VERTEX_ATTRIB14_4_NV','GL_MAP2_VERTEX_ATTRIB15_4_NV','GL_MAP2_VERTEX_ATTRIB1_4_NV','GL_MAP2_VERTEX_ATTRIB2_4_NV','GL_MAP2_VERTEX_ATTRIB3_4_NV','GL_MAP2_VERTEX_ATTRIB4_4_NV','GL_MAP2_VERTEX_ATTRIB5_4_NV','GL_MAP2_VERTEX_ATTRIB6_4_NV','GL_MAP2_VERTEX_ATTRIB7_4_NV','GL_MAP2_VERTEX_ATTRIB8_4_NV','GL_MAP2_VERTEX_ATTRIB9_4_NV','GL_MATRIX0_NV','GL_MATRIX1_NV','GL_MATRIX2_NV','GL_MATRIX3_NV','GL_MATRIX4_NV','GL_MATRIX5_NV','GL_MATRIX6_NV','GL_MATRIX7_NV','GL_MAX_TRACK_MATRICES_NV','GL_MAX_TRACK_MATRIX_STACK_DEPTH_NV','GL_MODELVIEW_PROJECTION_NV','GL_PROGRAM_ERROR_POSITION_NV','GL_PROGRAM_LENGTH_NV','GL_PROGRAM_PARAMETER_NV','GL_PROGRAM_RESIDENT_NV','GL_PROGRAM_STRING_NV','GL_PROGRAM_TARGET_NV','GL_TRACK_MATRIX_NV','GL_TRACK_MATRIX_TRANSFORM_NV','GL_TRANSPOSE_NV','GL_VERTEX_ATTRIB_ARRAY0_NV','GL_VERTEX_ATTRIB_ARRAY10_NV','GL_VERTEX_ATTRIB_ARRAY11_NV','GL_VERTEX_ATTRIB_ARRAY12_NV','GL_VERTEX_ATTRIB_ARRAY13_NV','GL_VERTEX_ATTRIB_ARRAY14_NV','GL_VERTEX_ATTRIB_ARRAY15_NV','GL_VERTEX_ATTRIB_ARRAY1_NV','GL_VERTEX_ATTRIB_ARRAY2_NV','GL_VERTEX_ATTRIB_ARRAY3_NV','GL_VERTEX_ATTRIB_ARRAY4_NV','GL_VERTEX_ATTRIB_ARRAY5_NV','GL_VERTEX_ATTRIB_ARRAY6_NV','GL_VERTEX_ATTRIB_ARRAY7_NV','GL_VERTEX_ATTRIB_ARRAY8_NV','GL_VERTEX_ATTRIB_ARRAY9_NV','GL_VERTEX_PROGRAM_BINDING_NV','GL_VERTEX_PROGRAM_NV','GL_VERTEX_PROGRAM_POINT_SIZE_NV','GL_VERTEX_PROGRAM_TWO_SIDE_NV','GL_VERTEX_STATE_PROGRAM_NV']
GL_NV_vertex_program.functions = ['glAreProgramsResidentNV','glIsProgramNV','glBindProgramNV','glDeleteProgramsNV','glExecuteProgramNV','glGenProgramsNV','glGetProgramParameterdvNV','glGetProgramParameterfvNV','glGetProgramStringNV','glGetProgramivNV','glGetTrackMatrixivNV','glGetVertexAttribPointervNV','glGetVertexAttribdvNV','glGetVertexAttribfvNV','glGetVertexAttribivNV','glLoadProgramNV','glProgramParameter4dNV','glProgramParameter4dvNV','glProgramParameter4fNV','glProgramParameter4fvNV','glProgramParameters4dvNV','glProgramParameters4fvNV','glRequestResidentProgramsNV','glTrackMatrixNV','glVertexAttrib1dNV','glVertexAttrib1dvNV','glVertexAttrib1fNV','glVertexAttrib1fvNV','glVertexAttrib1sNV','glVertexAttrib1svNV','glVertexAttrib2dNV','glVertexAttrib2dvNV','glVertexAttrib2fNV','glVertexAttrib2fvNV','glVertexAttrib2sNV','glVertexAttrib2svNV','glVertexAttrib3dNV','glVertexAttrib3dvNV','glVertexAttrib3fNV','glVertexAttrib3fvNV','glVertexAttrib3sNV','glVertexAttrib3svNV','glVertexAttrib4dNV','glVertexAttrib4dvNV','glVertexAttrib4fNV','glVertexAttrib4fvNV','glVertexAttrib4sNV','glVertexAttrib4svNV','glVertexAttrib4ubNV','glVertexAttrib4ubvNV','glVertexAttribPointerNV','glVertexAttribs1dvNV','glVertexAttribs1fvNV','glVertexAttribs1svNV','glVertexAttribs2dvNV','glVertexAttribs2fvNV','glVertexAttribs2svNV','glVertexAttribs3dvNV','glVertexAttribs3fvNV','glVertexAttribs3svNV','glVertexAttribs4dvNV','glVertexAttribs4fvNV','glVertexAttribs4svNV','glVertexAttribs4ubvNV']
gl.add(GL_NV_vertex_program)

GL_NV_vertex_program1_1 = Extension('GL_NV_vertex_program1_1')
GL_NV_vertex_program1_1.url = 'http://www.opengl.org/registry/specs/NV/vertex_program1_1.txt'
gl.add(GL_NV_vertex_program1_1)

GL_NV_vertex_program2 = Extension('GL_NV_vertex_program2')
GL_NV_vertex_program2.url = 'http://www.opengl.org/registry/specs/NV/vertex_program2.txt'
gl.add(GL_NV_vertex_program2)

GL_NV_vertex_program2_option = Extension('GL_NV_vertex_program2_option')
GL_NV_vertex_program2_option.url = 'http://www.nvidia.com/dev_content/nvopenglspecs/GL_NV_vertex_program2_option.txt'
GL_NV_vertex_program2_option.enumerants = ['GL_MAX_PROGRAM_CALL_DEPTH_NV','GL_MAX_PROGRAM_EXEC_INSTRUCTIONS_NV']
gl.add(GL_NV_vertex_program2_option)

GL_NV_vertex_program3 = Extension('GL_NV_vertex_program3')
GL_NV_vertex_program3.url = 'http://www.nvidia.com/dev_content/nvopenglspecs/GL_NV_vertex_program3.txt'
GL_NV_vertex_program3.enumerants = ['MAX_VERTEX_TEXTURE_IMAGE_UNITS_ARB']
gl.add(GL_NV_vertex_program3)

GL_NV_vertex_program4 = Extension('GL_NV_vertex_program4')
GL_NV_vertex_program4.url = 'http://developer.download.nvidia.com/opengl/specs/GL_NV_vertex_program4.txt'
GL_NV_vertex_program4.enumerants = ['GL_VERTEX_ATTRIB_ARRAY_INTEGER_NV']
gl.add(GL_NV_vertex_program4)

GL_NV_video_capture = Extension('GL_NV_video_capture')
GL_NV_video_capture.url = 'http://www.opengl.org/registry/specs/NV/video_capture.txt'
GL_NV_video_capture.enumerants = ['GL_FAILURE_NV','GL_FIELD_LOWER_NV','GL_FIELD_UPPER_NV','GL_LAST_VIDEO_CAPTURE_STATUS_NV','GL_NEXT_VIDEO_CAPTURE_BUFFER_STATUS_NV','GL_NUM_VIDEO_CAPTURE_STREAMS_NV','GL_PARTIAL_SUCCESS_NV','GL_SUCCESS_NV','GL_VIDEO_BUFFER_BINDING_NV','GL_VIDEO_BUFFER_INTERNAL_FORMAT_NV','GL_VIDEO_BUFFER_NV','GL_VIDEO_BUFFER_PITCH_NV','GL_VIDEO_CAPTURE_FIELD_LOWER_HEIGHT_NV','GL_VIDEO_CAPTURE_FIELD_UPPER_HEIGHT_NV','GL_VIDEO_CAPTURE_FRAME_HEIGHT_NV','GL_VIDEO_CAPTURE_FRAME_WIDTH_NV','GL_VIDEO_CAPTURE_SURFACE_ORIGIN_NV','GL_VIDEO_CAPTURE_TO_422_SUPPORTED_NV','GL_VIDEO_COLOR_CONVERSION_MATRIX_NV','GL_VIDEO_COLOR_CONVERSION_MAX_NV','GL_VIDEO_COLOR_CONVERSION_MIN_NV','GL_VIDEO_COLOR_CONVERSION_OFFSET_NV','GL_YCBAYCR8A_4224_NV','GL_YCBYCR8_422_NV','GL_Z4Y12Z4CB12Z4A12Z4Y12Z4CR12Z4A12_4224_NV','GL_Z4Y12Z4CB12Z4CR12_444_NV','GL_Z4Y12Z4CB12Z4Y12Z4CR12_422_NV','GL_Z6Y10Z6CB10Z6A10Z6Y10Z6CR10Z6A10_4224_NV','GL_Z6Y10Z6CB10Z6Y10Z6CR10_422_NV']
GL_NV_video_capture.functions = ['glVideoCaptureNV','glBeginVideoCaptureNV','glBindVideoCaptureStreamBufferNV','glBindVideoCaptureStreamTextureNV','glEndVideoCaptureNV','glGetVideoCaptureStreamdvNV','glGetVideoCaptureStreamfvNV','glGetVideoCaptureStreamivNV','glGetVideoCaptureivNV','glVideoCaptureStreamParameterdvNV','glVideoCaptureStreamParameterfvNV','glVideoCaptureStreamParameterivNV']
gl.add(GL_NV_video_capture)

GL_OES_EGL_image_external = Extension('GL_OES_EGL_image_external')
GL_OES_EGL_image_external.url = 'http://www.khronos.org/registry/gles/extensions/OES/OES_EGL_image_external.txt'
GL_OES_EGL_image_external.enumerants = ['GL_REQUIRED_TEXTURE_IMAGE_UNITS_OES','GL_SAMPLER_EXTERNAL_OES','GL_TEXTURE_BINDING_EXTERNAL_OES','GL_TEXTURE_EXTERNAL_OES']
GL_OES_EGL_image_external.functions = ['glEGLImageTargetTexture2DOES']
gl.add(GL_OES_EGL_image_external)

GL_OES_byte_coordinates = Extension('GL_OES_byte_coordinates')
GL_OES_byte_coordinates.url = 'http://www.opengl.org/registry/specs/OES/OES_byte_coordinates.txt'
gl.add(GL_OES_byte_coordinates)

GL_OES_compressed_paletted_texture = Extension('GL_OES_compressed_paletted_texture')
GL_OES_compressed_paletted_texture.url = 'http://www.opengl.org/registry/specs/OES/OES_compressed_paletted_texture.txt'
GL_OES_compressed_paletted_texture.enumerants = ['GL_PALETTE4_R5_G6_B5_OES','GL_PALETTE4_RGB5_A1_OES','GL_PALETTE4_RGB8_OES','GL_PALETTE4_RGBA4_OES','GL_PALETTE4_RGBA8_OES','GL_PALETTE8_R5_G6_B5_OES','GL_PALETTE8_RGB5_A1_OES','GL_PALETTE8_RGB8_OES','GL_PALETTE8_RGBA4_OES','GL_PALETTE8_RGBA8_OES']
gl.add(GL_OES_compressed_paletted_texture)

GL_OES_depth_texture = Extension('GL_OES_depth_texture')
GL_OES_depth_texture.category = 'GL_OES_depth_texture'
gl.add(GL_OES_depth_texture)

GL_OES_element_index_uint = Extension('GL_OES_element_index_uint')
GL_OES_element_index_uint.category = 'GL_OES_element_index_uint'
gl.add(GL_OES_element_index_uint)

GL_OES_fbo_render_mipmap = Extension('GL_OES_fbo_render_mipmap')
GL_OES_fbo_render_mipmap.url = 'http://www.khronos.org/registry/gles/extensions/OES/OES_fbo_render_mipmap.txt'
GL_OES_fbo_render_mipmap.category = 'GL_OES_fbo_render_mipmap'
gl.add(GL_OES_fbo_render_mipmap)

GL_OES_read_format = Extension('GL_OES_read_format')
GL_OES_read_format.url = 'http://www.opengl.org/registry/specs/OES/OES_read_format.txt'
GL_OES_read_format.enumerants = ['GL_IMPLEMENTATION_COLOR_READ_FORMAT_OES','GL_IMPLEMENTATION_COLOR_READ_TYPE_OES']
gl.add(GL_OES_read_format)

GL_OES_single_precision = Extension('GL_OES_single_precision')
GL_OES_single_precision.url = 'http://www.opengl.org/registry/specs/OES/OES_single_precision.txt'
GL_OES_single_precision.functions = ['glClearDepthfOES','glClipPlanefOES','glDepthRangefOES','glFrustumfOES','glGetClipPlanefOES','glOrthofOES']
gl.add(GL_OES_single_precision)

GL_OES_texture_mirrored_repeat = Extension('GL_OES_texture_mirrored_repeat')
GL_OES_texture_mirrored_repeat.category = 'GL_OES_texture_mirrored_repeat'
gl.add(GL_OES_texture_mirrored_repeat)

GL_OES_texture_mirrored_repeat = Extension('GL_OES_texture_mirrored_repeat')
GL_OES_texture_mirrored_repeat.category = 'GL_OES_texture_mirrored_repeat'
gl.add(GL_OES_texture_mirrored_repeat)

GL_OML_interlace = Extension('GL_OML_interlace')
GL_OML_interlace.url = 'http://www.opengl.org/registry/specs/OML/interlace.txt'
GL_OML_interlace.enumerants = ['GL_INTERLACE_OML','GL_INTERLACE_READ_OML']
gl.add(GL_OML_interlace)

GL_OML_resample = Extension('GL_OML_resample')
GL_OML_resample.url = 'http://www.opengl.org/registry/specs/OML/resample.txt'
GL_OML_resample.enumerants = ['GL_PACK_RESAMPLE_OML','GL_RESAMPLE_AVERAGE_OML','GL_RESAMPLE_DECIMATE_OML','GL_RESAMPLE_REPLICATE_OML','GL_RESAMPLE_ZERO_FILL_OML','GL_UNPACK_RESAMPLE_OML']
gl.add(GL_OML_resample)

GL_OML_subsample = Extension('GL_OML_subsample')
GL_OML_subsample.url = 'http://www.opengl.org/registry/specs/OML/subsample.txt'
GL_OML_subsample.enumerants = ['GL_FORMAT_SUBSAMPLE_244_244_OML','GL_FORMAT_SUBSAMPLE_24_24_OML']
gl.add(GL_OML_subsample)

GL_PGI_misc_hints = Extension('GL_PGI_misc_hints')
GL_PGI_misc_hints.url = 'http://www.opengl.org/registry/specs/PGI/misc_hints.txt'
GL_PGI_misc_hints.enumerants = ['GL_ALLOW_DRAW_FRG_HINT_PGI','GL_ALLOW_DRAW_MEM_HINT_PGI','GL_ALLOW_DRAW_OBJ_HINT_PGI','GL_ALLOW_DRAW_WIN_HINT_PGI','GL_ALWAYS_FAST_HINT_PGI','GL_ALWAYS_SOFT_HINT_PGI','GL_BACK_NORMALS_HINT_PGI','GL_CLIP_FAR_HINT_PGI','GL_CLIP_NEAR_HINT_PGI','GL_CONSERVE_MEMORY_HINT_PGI','GL_FULL_STIPPLE_HINT_PGI','GL_NATIVE_GRAPHICS_BEGIN_HINT_PGI','GL_NATIVE_GRAPHICS_END_HINT_PGI','GL_NATIVE_GRAPHICS_HANDLE_PGI','GL_PREFER_DOUBLEBUFFER_HINT_PGI','GL_RECLAIM_MEMORY_HINT_PGI','GL_STRICT_DEPTHFUNC_HINT_PGI','GL_STRICT_LIGHTING_HINT_PGI','GL_STRICT_SCISSOR_HINT_PGI','GL_WIDE_LINE_HINT_PGI']
gl.add(GL_PGI_misc_hints)

GL_PGI_vertex_hints = Extension('GL_PGI_vertex_hints')
GL_PGI_vertex_hints.url = 'http://www.opengl.org/registry/specs/PGI/vertex_hints.txt'
GL_PGI_vertex_hints.enumerants = ['GL_COLOR3_BIT_PGI','GL_COLOR4_BIT_PGI','GL_EDGEFLAG_BIT_PGI','GL_INDEX_BIT_PGI','GL_MATERIAL_SIDE_HINT_PGI','GL_MAT_AMBIENT_AND_DIFFUSE_BIT_PGI','GL_MAT_AMBIENT_BIT_PGI','GL_MAT_COLOR_INDEXES_BIT_PGI','GL_MAT_DIFFUSE_BIT_PGI','GL_MAT_EMISSION_BIT_PGI','GL_MAT_SHININESS_BIT_PGI','GL_MAT_SPECULAR_BIT_PGI','GL_MAX_VERTEX_HINT_PGI','GL_NORMAL_BIT_PGI','GL_TEXCOORD1_BIT_PGI','GL_TEXCOORD2_BIT_PGI','GL_TEXCOORD3_BIT_PGI','GL_TEXCOORD4_BIT_PGI','GL_VERTEX23_BIT_PGI','GL_VERTEX4_BIT_PGI','GL_VERTEX_CONSISTENT_HINT_PGI','GL_VERTEX_DATA_HINT_PGI']
gl.add(GL_PGI_vertex_hints)

GL_REGAL_ES1_0_compatibility = Extension('GL_REGAL_ES1_0_compatibility')
GL_REGAL_ES1_0_compatibility.url = 'https://github.com/p3/regal/blob/master/doc/extensions/GL_REGAL_ES1_0_compatibility.txt'
GL_REGAL_ES1_0_compatibility.functions = ['glAlphaFuncx','glClearColorx','glClearDepthx','glColor4x','glDepthRangex','glFogx','glFogxv','glFrustumf','glFrustumx','glLightModelx','glLightModelxv','glLightx','glLightxv','glLineWidthx','glLoadMatrixx','glMaterialx','glMaterialxv','glMultMatrixx','glMultiTexCoord4x','glNormal3x','glOrthof','glOrthox','glPointSizex','glPolygonOffsetx','glRotatex','glSampleCoveragex','glScalex','glTexEnvx','glTexEnvxv','glTexParameterx','glTranslatex']
gl.add(GL_REGAL_ES1_0_compatibility)

GL_REGAL_ES1_1_compatibility = Extension('GL_REGAL_ES1_1_compatibility')
GL_REGAL_ES1_1_compatibility.url = 'https://github.com/p3/regal/blob/master/doc/extensions/GL_REGAL_ES1_1_compatibility.txt'
GL_REGAL_ES1_1_compatibility.functions = ['glClipPlanef','glClipPlanex','glGetClipPlanef','glGetClipPlanex','glGetFixedv','glGetLightxv','glGetMaterialxv','glGetTexEnvxv','glGetTexParameterxv','glPointParameterx','glPointParameterxv','glPointSizePointerOES','glTexParameterxv']
gl.add(GL_REGAL_ES1_1_compatibility)

GL_REGAL_enable = Extension('GL_REGAL_enable')
GL_REGAL_enable.url = 'https://github.com/p3/regal/blob/master/doc/extensions/GL_REGAL_enable.txt'
GL_REGAL_enable.enumerants = ['GL_DEBUG_REGAL','GL_DRIVER_REGAL','GL_EMULATION_REGAL','GL_ERROR_REGAL','GL_LOG_REGAL']
gl.add(GL_REGAL_enable)

GL_REGAL_error_string = Extension('GL_REGAL_error_string')
GL_REGAL_error_string.url = 'https://github.com/p3/regal/blob/master/doc/extensions/GL_REGAL_error_string.txt'
GL_REGAL_error_string.functions = ['GLchar*']
gl.add(GL_REGAL_error_string)

GL_REGAL_extension_query = Extension('GL_REGAL_extension_query')
GL_REGAL_extension_query.url = 'https://github.com/p3/regal/blob/master/doc/extensions/GL_REGAL_extension_query.txt'
GL_REGAL_extension_query.functions = ['glGetExtensionREGAL','glIsSupportedREGAL']
gl.add(GL_REGAL_extension_query)

GL_REGAL_log = Extension('GL_REGAL_log')
GL_REGAL_log.url = 'https://github.com/p3/regal/blob/master/doc/extensions/GL_REGAL_log.txt'
GL_REGAL_log.enumerants = ['GL_LOG_APP_REGAL','GL_LOG_DEBUG_REGAL','GL_LOG_DRIVER_REGAL','GL_LOG_ERROR_REGAL','GL_LOG_HTTP_REGAL','GL_LOG_INFO_REGAL','GL_LOG_INTERNAL_REGAL','GL_LOG_STATUS_REGAL','GL_LOG_WARNING_REGAL']
GL_REGAL_log.functions = ['glLogMessageCallbackREGAL']
gl.add(GL_REGAL_log)

GL_REND_screen_coordinates = Extension('GL_REND_screen_coordinates')
GL_REND_screen_coordinates.url = 'http://www.opengl.org/registry/specs/REND/screen_coordinates.txt'
GL_REND_screen_coordinates.enumerants = ['GL_INVERTED_SCREEN_W_REND','GL_SCREEN_COORDINATES_REND']
gl.add(GL_REND_screen_coordinates)

GL_S3_s3tc = Extension('GL_S3_s3tc')
GL_S3_s3tc.url = 'http://www.opengl.org/registry/specs/S3/s3tc.txt'
GL_S3_s3tc.enumerants = ['GL_RGB4_S3TC','GL_RGBA4_DXT5_S3TC','GL_RGBA4_S3TC','GL_RGBA_DXT5_S3TC','GL_RGBA_S3TC','GL_RGB_S3TC']
gl.add(GL_S3_s3tc)

GL_SGIS_color_range = Extension('GL_SGIS_color_range')
GL_SGIS_color_range.url = 'http://www.opengl.org/registry/specs/SGIS/color_range.txt'
GL_SGIS_color_range.enumerants = ['GL_EXTENDED_RANGE_SGIS','GL_MAX_ALPHA_SGIS','GL_MAX_BLUE_SGIS','GL_MAX_GREEN_SGIS','GL_MAX_RED_SGIS','GL_MIN_ALPHA_SGIS','GL_MIN_BLUE_SGIS','GL_MIN_GREEN_SGIS','GL_MIN_RED_SGIS']
gl.add(GL_SGIS_color_range)

GL_SGIS_detail_texture = Extension('GL_SGIS_detail_texture')
GL_SGIS_detail_texture.url = 'http://www.opengl.org/registry/specs/SGIS/detail_texture.txt'
GL_SGIS_detail_texture.functions = ['glDetailTexFuncSGIS','glGetDetailTexFuncSGIS']
gl.add(GL_SGIS_detail_texture)

GL_SGIS_fog_function = Extension('GL_SGIS_fog_function')
GL_SGIS_fog_function.url = 'http://www.opengl.org/registry/specs/SGIS/fog_func.txt'
GL_SGIS_fog_function.functions = ['glFogFuncSGIS','glGetFogFuncSGIS']
gl.add(GL_SGIS_fog_function)

GL_SGIS_generate_mipmap = Extension('GL_SGIS_generate_mipmap')
GL_SGIS_generate_mipmap.url = 'http://www.opengl.org/registry/specs/SGIS/generate_mipmap.txt'
GL_SGIS_generate_mipmap.enumerants = ['GL_GENERATE_MIPMAP_HINT_SGIS','GL_GENERATE_MIPMAP_SGIS']
gl.add(GL_SGIS_generate_mipmap)

GL_SGIS_multisample = Extension('GL_SGIS_multisample')
GL_SGIS_multisample.url = 'http://www.opengl.org/registry/specs/SGIS/multisample.txt'
GL_SGIS_multisample.enumerants = ['GL_1PASS_SGIS','GL_2PASS_0_SGIS','GL_2PASS_1_SGIS','GL_4PASS_0_SGIS','GL_4PASS_1_SGIS','GL_4PASS_2_SGIS','GL_4PASS_3_SGIS','GL_MULTISAMPLE_SGIS','GL_SAMPLES_SGIS','GL_SAMPLE_ALPHA_TO_MASK_SGIS','GL_SAMPLE_ALPHA_TO_ONE_SGIS','GL_SAMPLE_BUFFERS_SGIS','GL_SAMPLE_MASK_INVERT_SGIS','GL_SAMPLE_MASK_SGIS','GL_SAMPLE_MASK_VALUE_SGIS','GL_SAMPLE_PATTERN_SGIS']
GL_SGIS_multisample.functions = ['glSampleMaskSGIS','glSamplePatternSGIS']
gl.add(GL_SGIS_multisample)

GL_SGIS_pixel_texture = Extension('GL_SGIS_pixel_texture')
GL_SGIS_pixel_texture.url = 'http://www.opengl.org/registry/specs/SGIS/pixel_texture.txt'
gl.add(GL_SGIS_pixel_texture)

GL_SGIS_point_line_texgen = Extension('GL_SGIS_point_line_texgen')
GL_SGIS_point_line_texgen.url = 'http://www.opengl.org/registry/specs/SGIS/point_line_texgen.txt'
GL_SGIS_point_line_texgen.enumerants = ['GL_EYE_DISTANCE_TO_LINE_SGIS','GL_EYE_DISTANCE_TO_POINT_SGIS','GL_EYE_LINE_SGIS','GL_EYE_POINT_SGIS','GL_OBJECT_DISTANCE_TO_LINE_SGIS','GL_OBJECT_DISTANCE_TO_POINT_SGIS','GL_OBJECT_LINE_SGIS','GL_OBJECT_POINT_SGIS']
gl.add(GL_SGIS_point_line_texgen)

GL_SGIS_sharpen_texture = Extension('GL_SGIS_sharpen_texture')
GL_SGIS_sharpen_texture.url = 'http://www.opengl.org/registry/specs/SGIS/sharpen_texture.txt'
GL_SGIS_sharpen_texture.functions = ['glGetSharpenTexFuncSGIS','glSharpenTexFuncSGIS']
gl.add(GL_SGIS_sharpen_texture)

GL_SGIS_texture4D = Extension('GL_SGIS_texture4D')
GL_SGIS_texture4D.url = 'http://www.opengl.org/registry/specs/SGIS/texture4D.txt'
GL_SGIS_texture4D.functions = ['glTexImage4DSGIS','glTexSubImage4DSGIS']
gl.add(GL_SGIS_texture4D)

GL_SGIS_texture_border_clamp = Extension('GL_SGIS_texture_border_clamp')
GL_SGIS_texture_border_clamp.url = 'http://www.opengl.org/registry/specs/SGIS/texture_border_clamp.txt'
GL_SGIS_texture_border_clamp.enumerants = ['GL_CLAMP_TO_BORDER_SGIS']
gl.add(GL_SGIS_texture_border_clamp)

GL_SGIS_texture_edge_clamp = Extension('GL_SGIS_texture_edge_clamp')
GL_SGIS_texture_edge_clamp.url = 'http://www.opengl.org/registry/specs/SGIS/texture_edge_clamp.txt'
GL_SGIS_texture_edge_clamp.enumerants = ['GL_CLAMP_TO_EDGE_SGIS']
gl.add(GL_SGIS_texture_edge_clamp)

GL_SGIS_texture_filter4 = Extension('GL_SGIS_texture_filter4')
GL_SGIS_texture_filter4.url = 'http://www.opengl.org/registry/specs/SGIS/texture_filter4.txt'
GL_SGIS_texture_filter4.functions = ['glGetTexFilterFuncSGIS','glTexFilterFuncSGIS']
gl.add(GL_SGIS_texture_filter4)

GL_SGIS_texture_lod = Extension('GL_SGIS_texture_lod')
GL_SGIS_texture_lod.url = 'http://www.opengl.org/registry/specs/SGIS/texture_lod.txt'
GL_SGIS_texture_lod.enumerants = ['GL_TEXTURE_BASE_LEVEL_SGIS','GL_TEXTURE_MAX_LEVEL_SGIS','GL_TEXTURE_MAX_LOD_SGIS','GL_TEXTURE_MIN_LOD_SGIS']
gl.add(GL_SGIS_texture_lod)

GL_SGIS_texture_select = Extension('GL_SGIS_texture_select')
GL_SGIS_texture_select.url = 'http://www.opengl.org/registry/specs/SGIS/texture_select.txt'
gl.add(GL_SGIS_texture_select)

GL_SGIX_async = Extension('GL_SGIX_async')
GL_SGIX_async.url = 'http://www.opengl.org/registry/specs/SGIX/async.txt'
GL_SGIX_async.enumerants = ['GL_ASYNC_MARKER_SGIX']
GL_SGIX_async.functions = ['glIsAsyncMarkerSGIX','glFinishAsyncSGIX','glPollAsyncSGIX','glGenAsyncMarkersSGIX','glAsyncMarkerSGIX','glDeleteAsyncMarkersSGIX']
gl.add(GL_SGIX_async)

GL_SGIX_async_histogram = Extension('GL_SGIX_async_histogram')
GL_SGIX_async_histogram.url = 'http://www.opengl.org/registry/specs/SGIX/async_histogram.txt'
GL_SGIX_async_histogram.enumerants = ['GL_ASYNC_HISTOGRAM_SGIX','GL_MAX_ASYNC_HISTOGRAM_SGIX']
gl.add(GL_SGIX_async_histogram)

GL_SGIX_async_pixel = Extension('GL_SGIX_async_pixel')
GL_SGIX_async_pixel.url = 'http://www.opengl.org/registry/specs/SGIX/async_pixel.txt'
GL_SGIX_async_pixel.enumerants = ['GL_ASYNC_DRAW_PIXELS_SGIX','GL_ASYNC_READ_PIXELS_SGIX','GL_ASYNC_TEX_IMAGE_SGIX','GL_MAX_ASYNC_DRAW_PIXELS_SGIX','GL_MAX_ASYNC_READ_PIXELS_SGIX','GL_MAX_ASYNC_TEX_IMAGE_SGIX']
gl.add(GL_SGIX_async_pixel)

GL_SGIX_blend_alpha_minmax = Extension('GL_SGIX_blend_alpha_minmax')
GL_SGIX_blend_alpha_minmax.url = 'http://www.opengl.org/registry/specs/SGIX/blend_alpha_minmax.txt'
GL_SGIX_blend_alpha_minmax.enumerants = ['GL_ALPHA_MAX_SGIX','GL_ALPHA_MIN_SGIX']
gl.add(GL_SGIX_blend_alpha_minmax)

GL_SGIX_clipmap = Extension('GL_SGIX_clipmap')
GL_SGIX_clipmap.url = 'http://www.opengl.org/registry/specs/SGIX/clipmap.txt'
gl.add(GL_SGIX_clipmap)

GL_SGIX_convolution_accuracy = Extension('GL_SGIX_convolution_accuracy')
GL_SGIX_convolution_accuracy.url = 'http://www.opengl.org/registry/specs/SGIX/convolution_accuracy.txt'
GL_SGIX_convolution_accuracy.enumerants = ['GL_CONVOLUTION_HINT_SGIX']
gl.add(GL_SGIX_convolution_accuracy)

GL_SGIX_depth_texture = Extension('GL_SGIX_depth_texture')
GL_SGIX_depth_texture.url = 'http://www.opengl.org/registry/specs/SGIX/depth_texture.txt'
GL_SGIX_depth_texture.enumerants = ['GL_DEPTH_COMPONENT16_SGIX','GL_DEPTH_COMPONENT24_SGIX','GL_DEPTH_COMPONENT32_SGIX']
gl.add(GL_SGIX_depth_texture)

GL_SGIX_flush_raster = Extension('GL_SGIX_flush_raster')
GL_SGIX_flush_raster.url = 'http://www.opengl.org/registry/specs/SGIX/flush_raster.txt'
GL_SGIX_flush_raster.functions = ['glFlushRasterSGIX']
gl.add(GL_SGIX_flush_raster)

GL_SGIX_fog_offset = Extension('GL_SGIX_fog_offset')
GL_SGIX_fog_offset.url = 'http://www.opengl.org/registry/specs/SGIX/fog_offset.txt'
GL_SGIX_fog_offset.enumerants = ['GL_FOG_OFFSET_SGIX','GL_FOG_OFFSET_VALUE_SGIX']
gl.add(GL_SGIX_fog_offset)

GL_SGIX_fog_texture = Extension('GL_SGIX_fog_texture')
GL_SGIX_fog_texture.url = 'http://www.opengl.org/registry/specs/SGIX/fog_texture.txt'
GL_SGIX_fog_texture.enumerants = ['GL_FOG_PATCHY_FACTOR_SGIX','GL_FRAGMENT_FOG_SGIX','GL_TEXTURE_FOG_SGIX']
GL_SGIX_fog_texture.functions = ['glTextureFogSGIX']
gl.add(GL_SGIX_fog_texture)

GL_SGIX_fragment_specular_lighting = Extension('GL_SGIX_fragment_specular_lighting')
GL_SGIX_fragment_specular_lighting.url = 'http://www.opengl.org/registry/specs/SGIX/fragment_specular_lighting.txt'
GL_SGIX_fragment_specular_lighting.functions = ['glFragmentColorMaterialSGIX','glFragmentLightModelfSGIX','glFragmentLightModelfvSGIX','glFragmentLightModeliSGIX','glFragmentLightModelivSGIX','glFragmentLightfSGIX','glFragmentLightfvSGIX','glFragmentLightiSGIX','glFragmentLightivSGIX','glFragmentMaterialfSGIX','glFragmentMaterialfvSGIX','glFragmentMaterialiSGIX','glFragmentMaterialivSGIX','glGetFragmentLightfvSGIX','glGetFragmentLightivSGIX','glGetFragmentMaterialfvSGIX','glGetFragmentMaterialivSGIX']
gl.add(GL_SGIX_fragment_specular_lighting)

GL_SGIX_framezoom = Extension('GL_SGIX_framezoom')
GL_SGIX_framezoom.url = 'http://www.opengl.org/registry/specs/SGIX/framezoom.txt'
GL_SGIX_framezoom.functions = ['glFrameZoomSGIX']
gl.add(GL_SGIX_framezoom)

GL_SGIX_interlace = Extension('GL_SGIX_interlace')
GL_SGIX_interlace.url = 'http://www.opengl.org/registry/specs/SGIX/interlace.txt'
GL_SGIX_interlace.enumerants = ['GL_INTERLACE_SGIX']
gl.add(GL_SGIX_interlace)

GL_SGIX_ir_instrument1 = Extension('GL_SGIX_ir_instrument1')
GL_SGIX_ir_instrument1.url = 'http://www.opengl.org/registry/specs/SGIX/ir_instrument1.txt'
gl.add(GL_SGIX_ir_instrument1)

GL_SGIX_list_priority = Extension('GL_SGIX_list_priority')
GL_SGIX_list_priority.url = 'http://www.opengl.org/registry/specs/SGIX/list_priority.txt'
gl.add(GL_SGIX_list_priority)

GL_SGIX_pixel_texture = Extension('GL_SGIX_pixel_texture')
GL_SGIX_pixel_texture.url = 'http://www.opengl.org/registry/specs/SGIX/sgix_pixel_texture.txt'
GL_SGIX_pixel_texture.functions = ['glPixelTexGenSGIX']
gl.add(GL_SGIX_pixel_texture)

GL_SGIX_pixel_texture_bits = Extension('GL_SGIX_pixel_texture_bits')
GL_SGIX_pixel_texture_bits.url = 'http://www.opengl.org/registry/specs/SGIX/pixel_texture_bits.txt'
gl.add(GL_SGIX_pixel_texture_bits)

GL_SGIX_reference_plane = Extension('GL_SGIX_reference_plane')
GL_SGIX_reference_plane.url = 'http://www.opengl.org/registry/specs/SGIX/reference_plane.txt'
GL_SGIX_reference_plane.functions = ['glReferencePlaneSGIX']
gl.add(GL_SGIX_reference_plane)

GL_SGIX_resample = Extension('GL_SGIX_resample')
GL_SGIX_resample.url = 'http://www.opengl.org/registry/specs/SGIX/resample.txt'
GL_SGIX_resample.enumerants = ['GL_PACK_RESAMPLE_SGIX','GL_RESAMPLE_DECIMATE_SGIX','GL_RESAMPLE_REPLICATE_SGIX','GL_RESAMPLE_ZERO_FILL_SGIX','GL_UNPACK_RESAMPLE_SGIX']
gl.add(GL_SGIX_resample)

GL_SGIX_shadow = Extension('GL_SGIX_shadow')
GL_SGIX_shadow.url = 'http://oss.sgi.com/projects/ogl-sample/registry/SGIX/shadow.txt'
GL_SGIX_shadow.enumerants = ['GL_TEXTURE_COMPARE_OPERATOR_SGIX','GL_TEXTURE_COMPARE_SGIX','GL_TEXTURE_GEQUAL_R_SGIX','GL_TEXTURE_LEQUAL_R_SGIX']
gl.add(GL_SGIX_shadow)

GL_SGIX_shadow_ambient = Extension('GL_SGIX_shadow_ambient')
GL_SGIX_shadow_ambient.url = 'http://www.opengl.org/registry/specs/SGIX/shadow_ambient.txt'
GL_SGIX_shadow_ambient.enumerants = ['GL_SHADOW_AMBIENT_SGIX']
gl.add(GL_SGIX_shadow_ambient)

GL_SGIX_sprite = Extension('GL_SGIX_sprite')
GL_SGIX_sprite.url = 'http://www.opengl.org/registry/specs/SGIX/sprite.txt'
GL_SGIX_sprite.functions = ['glSpriteParameterfSGIX','glSpriteParameterfvSGIX','glSpriteParameteriSGIX','glSpriteParameterivSGIX']
gl.add(GL_SGIX_sprite)

GL_SGIX_tag_sample_buffer = Extension('GL_SGIX_tag_sample_buffer')
GL_SGIX_tag_sample_buffer.url = 'http://www.opengl.org/registry/specs/SGIX/tag_sample_buffer.txt'
GL_SGIX_tag_sample_buffer.functions = ['glTagSampleBufferSGIX']
gl.add(GL_SGIX_tag_sample_buffer)

GL_SGIX_texture_add_env = Extension('GL_SGIX_texture_add_env')
GL_SGIX_texture_add_env.url = 'http://www.opengl.org/registry/specs/SGIX/texture_env_add.txt'
gl.add(GL_SGIX_texture_add_env)

GL_SGIX_texture_coordinate_clamp = Extension('GL_SGIX_texture_coordinate_clamp')
GL_SGIX_texture_coordinate_clamp.url = 'http://www.opengl.org/registry/specs/SGIX/texture_coordinate_clamp.txt'
GL_SGIX_texture_coordinate_clamp.enumerants = ['GL_TEXTURE_MAX_CLAMP_R_SGIX','GL_TEXTURE_MAX_CLAMP_S_SGIX','GL_TEXTURE_MAX_CLAMP_T_SGIX']
gl.add(GL_SGIX_texture_coordinate_clamp)

GL_SGIX_texture_lod_bias = Extension('GL_SGIX_texture_lod_bias')
GL_SGIX_texture_lod_bias.url = 'http://www.opengl.org/registry/specs/SGIX/texture_lod_bias.txt'
gl.add(GL_SGIX_texture_lod_bias)

GL_SGIX_texture_multi_buffer = Extension('GL_SGIX_texture_multi_buffer')
GL_SGIX_texture_multi_buffer.url = 'http://www.opengl.org/registry/specs/SGIX/texture_multi_buffer.txt'
GL_SGIX_texture_multi_buffer.enumerants = ['GL_TEXTURE_MULTI_BUFFER_HINT_SGIX']
gl.add(GL_SGIX_texture_multi_buffer)

GL_SGIX_texture_range = Extension('GL_SGIX_texture_range')
GL_SGIX_texture_range.url = 'http://www.opengl.org/registry/specs/SGIX/texture_range.txt'
GL_SGIX_texture_range.enumerants = ['GL_ALPHA16_EXTENDED_RANGE_SGIX','GL_ALPHA16_SIGNED_SGIX','GL_ALPHA_EXTENDED_RANGE_SGIX','GL_ALPHA_SIGNED_SGIX','GL_INTENSITY16_EXTENDED_RANGE_SGIX','GL_INTENSITY16_SIGNED_SGIX','GL_INTENSITY_EXTENDED_RANGE_SGIX','GL_INTENSITY_SIGNED_SGIX','GL_LUMINANCE16_ALPHA16_EXTENDED_RANGE_SGIX','GL_LUMINANCE16_ALPHA16_SIGNED_SGIX','GL_LUMINANCE16_EXTENDED_RANGE_SGIX','GL_LUMINANCE16_SIGNED_SGIX','GL_LUMINANCE_ALPHA_EXTENDED_RANGE_SGIX','GL_LUMINANCE_ALPHA_SIGNED_SGIX','GL_LUMINANCE_EXTENDED_RANGE_SGIX','GL_LUMINANCE_SIGNED_SGIX','GL_MAX_INTENSITY_SGIS','GL_MAX_LUMINANCE_SGIS','GL_MIN_INTENSITY_SGIS','GL_MIN_LUMINANCE_SGIS','GL_RGB16_EXTENDED_RANGE_SGIX','GL_RGB16_SIGNED_SGIX','GL_RGBA16_EXTENDED_RANGE_SGIX','GL_RGBA16_SIGNED_SGIX','GL_RGBA_EXTENDED_RANGE_SGIX','GL_RGBA_SIGNED_SGIX','GL_RGB_EXTENDED_RANGE_SGIX','GL_RGB_SIGNED_SGIX']
gl.add(GL_SGIX_texture_range)

GL_SGIX_texture_scale_bias = Extension('GL_SGIX_texture_scale_bias')
GL_SGIX_texture_scale_bias.url = 'http://www.opengl.org/registry/specs/SGIX/texture_scale_bias.txt'
GL_SGIX_texture_scale_bias.enumerants = ['GL_POST_TEXTURE_FILTER_BIAS_RANGE_SGIX','GL_POST_TEXTURE_FILTER_BIAS_SGIX','GL_POST_TEXTURE_FILTER_SCALE_RANGE_SGIX','GL_POST_TEXTURE_FILTER_SCALE_SGIX']
gl.add(GL_SGIX_texture_scale_bias)

GL_SGIX_vertex_preclip = Extension('GL_SGIX_vertex_preclip')
GL_SGIX_vertex_preclip.url = 'http://www.opengl.org/registry/specs/SGIX/vertex_preclip.txt'
GL_SGIX_vertex_preclip.enumerants = ['GL_VERTEX_PRECLIP_HINT_SGIX','GL_VERTEX_PRECLIP_SGIX']
gl.add(GL_SGIX_vertex_preclip)

GL_SGIX_vertex_preclip_hint = Extension('GL_SGIX_vertex_preclip_hint')
GL_SGIX_vertex_preclip_hint.url = 'http://www.opengl.org/registry/specs/SGIX/vertex_preclip.txt'
GL_SGIX_vertex_preclip_hint.enumerants = ['GL_VERTEX_PRECLIP_HINT_SGIX','GL_VERTEX_PRECLIP_SGIX']
gl.add(GL_SGIX_vertex_preclip_hint)

GL_SGIX_ycrcb = Extension('GL_SGIX_ycrcb')
GL_SGIX_ycrcb.url = 'http://www.opengl.org/registry/specs/SGIX/ycrcb.txt'
gl.add(GL_SGIX_ycrcb)

GL_SGI_color_matrix = Extension('GL_SGI_color_matrix')
GL_SGI_color_matrix.url = 'http://www.opengl.org/registry/specs/SGI/color_matrix.txt'
GL_SGI_color_matrix.enumerants = ['GL_COLOR_MATRIX_SGI','GL_COLOR_MATRIX_STACK_DEPTH_SGI','GL_MAX_COLOR_MATRIX_STACK_DEPTH_SGI','GL_POST_COLOR_MATRIX_ALPHA_BIAS_SGI','GL_POST_COLOR_MATRIX_ALPHA_SCALE_SGI','GL_POST_COLOR_MATRIX_BLUE_BIAS_SGI','GL_POST_COLOR_MATRIX_BLUE_SCALE_SGI','GL_POST_COLOR_MATRIX_GREEN_BIAS_SGI','GL_POST_COLOR_MATRIX_GREEN_SCALE_SGI','GL_POST_COLOR_MATRIX_RED_BIAS_SGI','GL_POST_COLOR_MATRIX_RED_SCALE_SGI']
gl.add(GL_SGI_color_matrix)

GL_SGI_color_table = Extension('GL_SGI_color_table')
GL_SGI_color_table.url = 'http://www.opengl.org/registry/specs/SGI/color_table.txt'
GL_SGI_color_table.enumerants = ['GL_COLOR_TABLE_ALPHA_SIZE_SGI','GL_COLOR_TABLE_BIAS_SGI','GL_COLOR_TABLE_BLUE_SIZE_SGI','GL_COLOR_TABLE_FORMAT_SGI','GL_COLOR_TABLE_GREEN_SIZE_SGI','GL_COLOR_TABLE_INTENSITY_SIZE_SGI','GL_COLOR_TABLE_LUMINANCE_SIZE_SGI','GL_COLOR_TABLE_RED_SIZE_SGI','GL_COLOR_TABLE_SCALE_SGI','GL_COLOR_TABLE_SGI','GL_COLOR_TABLE_WIDTH_SGI','GL_POST_COLOR_MATRIX_COLOR_TABLE_SGI','GL_POST_CONVOLUTION_COLOR_TABLE_SGI','GL_PROXY_COLOR_TABLE_SGI','GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE_SGI','GL_PROXY_POST_CONVOLUTION_COLOR_TABLE_SGI']
GL_SGI_color_table.functions = ['glColorTableParameterfvSGI','glColorTableParameterivSGI','glColorTableSGI','glCopyColorTableSGI','glGetColorTableParameterfvSGI','glGetColorTableParameterivSGI','glGetColorTableSGI']
gl.add(GL_SGI_color_table)

GL_SGI_texture_color_table = Extension('GL_SGI_texture_color_table')
GL_SGI_texture_color_table.url = 'http://www.opengl.org/registry/specs/SGI/texture_color_table.txt'
GL_SGI_texture_color_table.enumerants = ['GL_PROXY_TEXTURE_COLOR_TABLE_SGI','GL_TEXTURE_COLOR_TABLE_SGI']
gl.add(GL_SGI_texture_color_table)

GL_SUNX_constant_data = Extension('GL_SUNX_constant_data')
GL_SUNX_constant_data.url = 'http://www.opengl.org/registry/specs/SUNX/constant_data.txt'
GL_SUNX_constant_data.enumerants = ['GL_TEXTURE_CONSTANT_DATA_SUNX','GL_UNPACK_CONSTANT_DATA_SUNX']
GL_SUNX_constant_data.functions = ['glFinishTextureSUNX']
gl.add(GL_SUNX_constant_data)

GL_SUN_convolution_border_modes = Extension('GL_SUN_convolution_border_modes')
GL_SUN_convolution_border_modes.url = 'http://www.opengl.org/registry/specs/SUN/convolution_border_modes.txt'
GL_SUN_convolution_border_modes.enumerants = ['GL_WRAP_BORDER_SUN']
gl.add(GL_SUN_convolution_border_modes)

GL_SUN_global_alpha = Extension('GL_SUN_global_alpha')
GL_SUN_global_alpha.url = 'http://www.opengl.org/registry/specs/SUN/global_alpha.txt'
GL_SUN_global_alpha.enumerants = ['GL_GLOBAL_ALPHA_FACTOR_SUN','GL_GLOBAL_ALPHA_SUN']
GL_SUN_global_alpha.functions = ['glGlobalAlphaFactorbSUN','glGlobalAlphaFactordSUN','glGlobalAlphaFactorfSUN','glGlobalAlphaFactoriSUN','glGlobalAlphaFactorsSUN','glGlobalAlphaFactorubSUN','glGlobalAlphaFactoruiSUN','glGlobalAlphaFactorusSUN']
gl.add(GL_SUN_global_alpha)

GL_SUN_mesh_array = Extension('GL_SUN_mesh_array')
GL_SUN_mesh_array.url = 'http://www.opengl.org/registry/specs/SUN/mesh_array.txt'
GL_SUN_mesh_array.enumerants = ['GL_QUAD_MESH_SUN','GL_TRIANGLE_MESH_SUN']
gl.add(GL_SUN_mesh_array)

GL_SUN_read_video_pixels = Extension('GL_SUN_read_video_pixels')
GL_SUN_read_video_pixels.url = 'http://wwws.sun.com/software/graphics/opengl/extensions/gl_sun_read_video_pixels.txt'
GL_SUN_read_video_pixels.functions = ['glReadVideoPixelsSUN']
gl.add(GL_SUN_read_video_pixels)

GL_SUN_slice_accum = Extension('GL_SUN_slice_accum')
GL_SUN_slice_accum.url = 'http://www.opengl.org/registry/specs/SUN/slice_accum.txt'
GL_SUN_slice_accum.enumerants = ['GL_SLICE_ACCUM_SUN']
gl.add(GL_SUN_slice_accum)

GL_SUN_triangle_list = Extension('GL_SUN_triangle_list')
GL_SUN_triangle_list.url = 'http://www.opengl.org/registry/specs/SUN/triangle_list.txt'
GL_SUN_triangle_list.enumerants = ['GL_R1UI_C3F_V3F_SUN','GL_R1UI_C4F_N3F_V3F_SUN','GL_R1UI_C4UB_V3F_SUN','GL_R1UI_N3F_V3F_SUN','GL_R1UI_T2F_C4F_N3F_V3F_SUN','GL_R1UI_T2F_N3F_V3F_SUN','GL_R1UI_T2F_V3F_SUN','GL_R1UI_V3F_SUN','GL_REPLACEMENT_CODE_ARRAY_POINTER_SUN','GL_REPLACEMENT_CODE_ARRAY_STRIDE_SUN','GL_REPLACEMENT_CODE_ARRAY_SUN','GL_REPLACEMENT_CODE_ARRAY_TYPE_SUN','GL_REPLACEMENT_CODE_SUN','GL_REPLACE_MIDDLE_SUN','GL_REPLACE_OLDEST_SUN','GL_RESTART_SUN','GL_TRIANGLE_LIST_SUN']
GL_SUN_triangle_list.functions = ['glReplacementCodePointerSUN','glReplacementCodeubSUN','glReplacementCodeubvSUN','glReplacementCodeuiSUN','glReplacementCodeuivSUN','glReplacementCodeusSUN','glReplacementCodeusvSUN']
gl.add(GL_SUN_triangle_list)

GL_SUN_vertex = Extension('GL_SUN_vertex')
GL_SUN_vertex.url = 'http://www.opengl.org/registry/specs/SUN/vertex.txt'
GL_SUN_vertex.functions = ['glColor3fVertex3fSUN','glColor3fVertex3fvSUN','glColor4fNormal3fVertex3fSUN','glColor4fNormal3fVertex3fvSUN','glColor4ubVertex2fSUN','glColor4ubVertex2fvSUN','glColor4ubVertex3fSUN','glColor4ubVertex3fvSUN','glNormal3fVertex3fSUN','glNormal3fVertex3fvSUN','glReplacementCodeuiColor3fVertex3fSUN','glReplacementCodeuiColor3fVertex3fvSUN','glReplacementCodeuiColor4fNormal3fVertex3fSUN','glReplacementCodeuiColor4fNormal3fVertex3fvSUN','glReplacementCodeuiColor4ubVertex3fSUN','glReplacementCodeuiColor4ubVertex3fvSUN','glReplacementCodeuiNormal3fVertex3fSUN','glReplacementCodeuiNormal3fVertex3fvSUN','glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN','glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN','glReplacementCodeuiTexCoord2fNormal3fVertex3fSUN','glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN','glReplacementCodeuiTexCoord2fVertex3fSUN','glReplacementCodeuiTexCoord2fVertex3fvSUN','glReplacementCodeuiVertex3fSUN','glReplacementCodeuiVertex3fvSUN','glTexCoord2fColor3fVertex3fSUN','glTexCoord2fColor3fVertex3fvSUN','glTexCoord2fColor4fNormal3fVertex3fSUN','glTexCoord2fColor4fNormal3fVertex3fvSUN','glTexCoord2fColor4ubVertex3fSUN','glTexCoord2fColor4ubVertex3fvSUN','glTexCoord2fNormal3fVertex3fSUN','glTexCoord2fNormal3fVertex3fvSUN','glTexCoord2fVertex3fSUN','glTexCoord2fVertex3fvSUN','glTexCoord4fColor4fNormal3fVertex4fSUN','glTexCoord4fColor4fNormal3fVertex4fvSUN','glTexCoord4fVertex4fSUN','glTexCoord4fVertex4fvSUN']
gl.add(GL_SUN_vertex)

GL_WIN_phong_shading = Extension('GL_WIN_phong_shading')
GL_WIN_phong_shading.url = 'http://www.opengl.org/registry/specs/WIN/phong_shading.txt'
GL_WIN_phong_shading.enumerants = ['GL_PHONG_HINT_WIN','GL_PHONG_WIN']
gl.add(GL_WIN_phong_shading)

GL_WIN_specular_fog = Extension('GL_WIN_specular_fog')
GL_WIN_specular_fog.url = 'http://www.opengl.org/registry/specs/WIN/specular_fog.txt'
GL_WIN_specular_fog.enumerants = ['GL_FOG_SPECULAR_TEXTURE_WIN']
gl.add(GL_WIN_specular_fog)

GL_WIN_swap_hint = Extension('GL_WIN_swap_hint')
GL_WIN_swap_hint.url = 'http://msdn.microsoft.com/library/default.asp?url=/library/en-us/opengl/glfunc01_16zy.asp'
GL_WIN_swap_hint.functions = ['glAddSwapHintRectWIN']
gl.add(GL_WIN_swap_hint)

# state types

B = StateType('B', 'B', 'Boolean')
BMU = StateType('BMU', 'BMU', 'Basic machine units')
C = StateType('C', 'C', 'Color (floating-point R, G, B, and A values)')
E = StateType('E', 'E', 'Enumerated value (as described in spec body)')
CI = StateType('CI', 'CI', 'Color index (floating-point index value)')
T = StateType('T', 'T', 'Texture coordinates (floating-point (s, t, r, q) values)')
N = StateType('N', 'N', 'Normal coordinates (floating-point (x, y, z) values)')
V = StateType('V', 'V', 'Vertex, including associated data')
Z = StateType('Z', 'Z', 'Integer')
Zplus = StateType('Zplus', 'Z+', 'Non-negative integer or enumerated value')
Zk = StateType('Zk', 'Zk', 'k-valued integer')
Zkstar = StateType('Zkstar', 'Zk*', 'k-valued integer (k is minimum)')
R = StateType('R', 'R', 'Floating-point number')
Rplus = StateType('Rplus', 'R+', 'Non-negative floating-point number')
Rab = StateType('Rab', 'R[a,b]', 'Floating-point number in the range [a,b]')
Rk = StateType('Rk', 'Rk', 'k-tuple of floating-point numbers')
P = StateType('P', 'P', 'Position ((x, y, z, w) floating-point coordinates)')
D = StateType('D', 'D', 'Direction ((x, y, z) floating-point coordinates)')
M4 = StateType('M4', 'M4', '4 x 4 floating-point matrix')
S = StateType('S', 'S', 'null-terminated string')
I = StateType('I', 'I', 'Image')
A = StateType('A', 'A', 'Attribute stack entry, including mask')
Y = StateType('Y', 'Y', 'Pointer (data type unspecified)')
nbytype = StateType('nbytype', 'n x type', 'n copies of type type')
nstarbytype = StateType('nstarbytype', 'n* x type', 'n copies of type type where n is minimum)')

gl.add(B)
gl.add(BMU)
gl.add(C)
gl.add(E)
gl.add(CI)
gl.add(T)
gl.add(N)
gl.add(V)
gl.add(Z)
gl.add(Zplus)
gl.add(Zk)
gl.add(Zkstar)
gl.add(R)
gl.add(Rplus)
gl.add(Rab)
gl.add(Rk)
gl.add(P)
gl.add(D)
gl.add(M4)
gl.add(S)
gl.add(I)
gl.add(A)
gl.add(Y)
gl.add(nbytype)
gl.add(nstarbytype)

# states

MAX_ATTRIB_STACK_DEPTH = State('MAX_ATTRIB_STACK_DEPTH', 'Zplus', 'glGetIntegerv', '16', 'Max depth of the server attribute stack', '21.6', '-')
MAX_CLIENT_ATTRIB_STACK_DEPTH = State('MAX_CLIENT_ATTRIB_STACK_DEPTH', 'Zplus', 'glGetIntegerv', '16', 'Max depth of the client attribute stack', '21.6', '-')
MAX_VERTEX_ATTRIB_BINDINGS = State('MAX_VERTEX_ATTRIB_BINDINGS', 'Zkstar', 'glGetIntegerv', '16', 'Max no. of vertex buffers', '10.3', '-')
MAX_VERTEX_ATTRIBS = State('MAX_VERTEX_ATTRIBS', 'Zplus', 'glGetIntegerv', '16', 'Max no. of active vertex attributes', '10.2', '-')
MAX_TEXTURE_UNITS = State('MAX_TEXTURE_UNITS', 'Zplus', 'glGetIntegerv', '2', 'No. of fixed-function texture units', '10', '-')
MAX_TEXTURE_COORDS = State('MAX_TEXTURE_COORDS', 'Zplus', 'glGetIntegerv', '8', 'No. of texture coordinate sets', '10.2.2', '-')
MAX_COMBINED_TEXTURE_IMAGE_UNITS = State('MAX_COMBINED_TEXTURE_IMAGE_UNITS', 'Zplus', 'glGetIntegerv', '96', 'Total no. of texture units accessible by the GL', '11.1.3.5', '-')
MAX_DRAW_BUFFERS = State('MAX_DRAW_BUFFERS', 'Zplus', 'glGetIntegerv', '8', 'Max no. of active draw buffers', '17.4.1', '-')
MAX_VIEWPORTS = State('MAX_VIEWPORTS', 'Zplus', 'glGetIntegerv', '16', 'Max no. of active viewports', '13.6.1', '-')
MAX_DEBUG_MESSAGE_LENGTH = State('MAX_DEBUG_MESSAGE_LENGTH', 'Zplus', 'glGetIntegerv', '1024', 'Maximum length of a debug output message', '5.5.1', '-')

gl.add(MAX_ATTRIB_STACK_DEPTH)
gl.add(MAX_CLIENT_ATTRIB_STACK_DEPTH)
gl.add(MAX_VERTEX_ATTRIB_BINDINGS)
gl.add(MAX_VERTEX_ATTRIBS)
gl.add(MAX_TEXTURE_UNITS)
gl.add(MAX_TEXTURE_COORDS)
gl.add(MAX_COMBINED_TEXTURE_IMAGE_UNITS)
gl.add(MAX_DRAW_BUFFERS)
gl.add(MAX_VIEWPORTS)
gl.add(MAX_DEBUG_MESSAGE_LENGTH)
